/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var f1=["require","exports","vs/base/common/errors","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/arraysFind","vs/base/common/charCode","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/cache","vs/base/common/types","vs/base/common/objects","vs/base/common/uint","vs/base/common/strings","vs/nls!vs/base/common/platform","vs/base/common/platform","vs/nls","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker"],h1=function(a1){for(var t=[],A=0,e=a1.length;A<e;A++)t[A]=f1[a1[A]];return t};define(f1[6],h1([0,1]),function(a1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=A,t.findLastIdx=e,t.findLastMonotonous=q,t.findLastIdxMonotonous=L,t.findFirstMonotonous=X,t.findFirstIdxMonotonousOrArrLen=H,t.findFirstIdxMonotonous=p,t.findFirstMax=P,t.findLastMax=K,t.findFirstMin=Y,t.findMaxIdx=o1,t.mapFindFirst=c1;function A(F,j){const M=e(F,j);if(M!==-1)return F[M]}function e(F,j,M=F.length-1){for(let d=M;d>=0;d--){const m=F[d];if(j(m))return d}return-1}function q(F,j){const M=L(F,j);return M===-1?void 0:F[M]}function L(F,j,M=0,d=F.length){let m=M,O=d;for(;m<O;){const s=Math.floor((m+O)/2);j(F[s])?m=s+1:O=s}return m-1}function X(F,j){const M=H(F,j);return M===F.length?void 0:F[M]}function H(F,j,M=0,d=F.length){let m=M,O=d;for(;m<O;){const s=Math.floor((m+O)/2);j(F[s])?O=s:m=s+1}return m}function p(F,j,M=0,d=F.length){const m=H(F,j,M,d);return m===F.length?-1:m}class D{static{this.assertInvariants=!1}constructor(j){this._array=j,this._findLastMonotonousLastIdx=0}findLastMonotonous(j){if(D.assertInvariants){if(this._prevFindLastPredicate){for(const d of this._array)if(this._prevFindLastPredicate(d)&&!j(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=j}const M=L(this._array,j,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=M+1,M===-1?void 0:this._array[M]}}t.MonotonousArray=D;function P(F,j){if(F.length===0)return;let M=F[0];for(let d=1;d<F.length;d++){const m=F[d];j(m,M)>0&&(M=m)}return M}function K(F,j){if(F.length===0)return;let M=F[0];for(let d=1;d<F.length;d++){const m=F[d];j(m,M)>=0&&(M=m)}return M}function Y(F,j){return P(F,(M,d)=>-j(M,d))}function o1(F,j){if(F.length===0)return-1;let M=0;for(let d=1;d<F.length;d++){const m=F[d];j(m,F[M])>0&&(M=d)}return M}function c1(F,j){for(const M of F){const d=j(M);if(d!==void 0)return d}}}),define(f1[7],h1([0,1]),function(a1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var A;(function(e){e[e.Null=0]="Null",e[e.Backspace=8]="Backspace",e[e.Tab=9]="Tab",e[e.LineFeed=10]="LineFeed",e[e.CarriageReturn=13]="CarriageReturn",e[e.Space=32]="Space",e[e.ExclamationMark=33]="ExclamationMark",e[e.DoubleQuote=34]="DoubleQuote",e[e.Hash=35]="Hash",e[e.DollarSign=36]="DollarSign",e[e.PercentSign=37]="PercentSign",e[e.Ampersand=38]="Ampersand",e[e.SingleQuote=39]="SingleQuote",e[e.OpenParen=40]="OpenParen",e[e.CloseParen=41]="CloseParen",e[e.Asterisk=42]="Asterisk",e[e.Plus=43]="Plus",e[e.Comma=44]="Comma",e[e.Dash=45]="Dash",e[e.Period=46]="Period",e[e.Slash=47]="Slash",e[e.Digit0=48]="Digit0",e[e.Digit1=49]="Digit1",e[e.Digit2=50]="Digit2",e[e.Digit3=51]="Digit3",e[e.Digit4=52]="Digit4",e[e.Digit5=53]="Digit5",e[e.Digit6=54]="Digit6",e[e.Digit7=55]="Digit7",e[e.Digit8=56]="Digit8",e[e.Digit9=57]="Digit9",e[e.Colon=58]="Colon",e[e.Semicolon=59]="Semicolon",e[e.LessThan=60]="LessThan",e[e.Equals=61]="Equals",e[e.GreaterThan=62]="GreaterThan",e[e.QuestionMark=63]="QuestionMark",e[e.AtSign=64]="AtSign",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.OpenSquareBracket=91]="OpenSquareBracket",e[e.Backslash=92]="Backslash",e[e.CloseSquareBracket=93]="CloseSquareBracket",e[e.Caret=94]="Caret",e[e.Underline=95]="Underline",e[e.BackTick=96]="BackTick",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.OpenCurlyBrace=123]="OpenCurlyBrace",e[e.Pipe=124]="Pipe",e[e.CloseCurlyBrace=125]="CloseCurlyBrace",e[e.Tilde=126]="Tilde",e[e.NoBreakSpace=160]="NoBreakSpace",e[e.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",e[e.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",e[e.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",e[e.U_Combining_Tilde=771]="U_Combining_Tilde",e[e.U_Combining_Macron=772]="U_Combining_Macron",e[e.U_Combining_Overline=773]="U_Combining_Overline",e[e.U_Combining_Breve=774]="U_Combining_Breve",e[e.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",e[e.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",e[e.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",e[e.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",e[e.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",e[e.U_Combining_Caron=780]="U_Combining_Caron",e[e.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",e[e.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",e[e.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",e[e.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",e[e.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",e[e.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",e[e.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",e[e.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",e[e.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",e[e.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",e[e.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",e[e.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",e[e.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",e[e.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",e[e.U_Combining_Horn=795]="U_Combining_Horn",e[e.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",e[e.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",e[e.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",e[e.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",e[e.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",e[e.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",e[e.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",e[e.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",e[e.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",e[e.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",e[e.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",e[e.U_Combining_Cedilla=807]="U_Combining_Cedilla",e[e.U_Combining_Ogonek=808]="U_Combining_Ogonek",e[e.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",e[e.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",e[e.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",e[e.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",e[e.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",e[e.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",e[e.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",e[e.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",e[e.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",e[e.U_Combining_Low_Line=818]="U_Combining_Low_Line",e[e.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",e[e.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",e[e.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",e[e.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",e[e.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",e[e.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",e[e.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",e[e.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",e[e.U_Combining_Square_Below=827]="U_Combining_Square_Below",e[e.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",e[e.U_Combining_X_Above=829]="U_Combining_X_Above",e[e.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",e[e.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",e[e.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",e[e.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",e[e.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",e[e.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",e[e.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",e[e.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",e[e.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",e[e.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",e[e.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",e[e.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",e[e.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",e[e.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",e[e.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",e[e.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",e[e.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",e[e.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",e[e.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",e[e.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",e[e.U_Combining_Fermata=850]="U_Combining_Fermata",e[e.U_Combining_X_Below=851]="U_Combining_X_Below",e[e.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",e[e.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",e[e.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",e[e.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",e[e.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",e[e.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",e[e.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",e[e.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",e[e.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",e[e.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",e[e.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",e[e.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",e[e.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",e[e.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",e[e.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",e[e.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",e[e.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",e[e.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",e[e.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",e[e.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",e[e.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",e[e.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",e[e.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",e[e.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",e[e.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",e[e.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",e[e.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",e[e.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",e[e.LINE_SEPARATOR=8232]="LINE_SEPARATOR",e[e.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",e[e.NEXT_LINE=133]="NEXT_LINE",e[e.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",e[e.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",e[e.U_DIAERESIS=168]="U_DIAERESIS",e[e.U_MACRON=175]="U_MACRON",e[e.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",e[e.U_CEDILLA=184]="U_CEDILLA",e[e.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",e[e.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",e[e.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",e[e.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",e[e.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",e[e.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",e[e.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",e[e.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",e[e.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",e[e.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",e[e.U_BREVE=728]="U_BREVE",e[e.U_DOT_ABOVE=729]="U_DOT_ABOVE",e[e.U_RING_ABOVE=730]="U_RING_ABOVE",e[e.U_OGONEK=731]="U_OGONEK",e[e.U_SMALL_TILDE=732]="U_SMALL_TILDE",e[e.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",e[e.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",e[e.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",e[e.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",e[e.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",e[e.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",e[e.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",e[e.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",e[e.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",e[e.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",e[e.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",e[e.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",e[e.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",e[e.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",e[e.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",e[e.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",e[e.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",e[e.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",e[e.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",e[e.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",e[e.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",e[e.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",e[e.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",e[e.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",e[e.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",e[e.U_GREEK_TONOS=900]="U_GREEK_TONOS",e[e.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",e[e.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",e[e.U_GREEK_PSILI=8127]="U_GREEK_PSILI",e[e.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",e[e.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",e[e.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",e[e.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",e[e.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",e[e.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",e[e.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",e[e.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",e[e.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",e[e.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",e[e.U_GREEK_VARIA=8175]="U_GREEK_VARIA",e[e.U_GREEK_OXIA=8189]="U_GREEK_OXIA",e[e.U_GREEK_DASIA=8190]="U_GREEK_DASIA",e[e.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",e[e.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",e[e.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",e[e.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",e[e.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",e[e.U_OVERLINE=8254]="U_OVERLINE",e[e.UTF8_BOM=65279]="UTF8_BOM",e[e.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",e[e.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(A||(t.CharCode=A={}))}),define(f1[8],h1([0,1]),function(a1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.groupBy=A,t.diffSets=e,t.diffMaps=q,t.intersection=L;function A(X,H){const p=Object.create(null);for(const D of X){const P=H(D);let K=p[P];K||(K=p[P]=[]),K.push(D)}return p}function e(X,H){const p=[],D=[];for(const P of X)H.has(P)||p.push(P);for(const P of H)X.has(P)||D.push(P);return{removed:p,added:D}}function q(X,H){const p=[],D=[];for(const[P,K]of X)H.has(P)||p.push(K);for(const[P,K]of H)X.has(P)||D.push(K);return{removed:p,added:D}}function L(X,H){const p=new Set;for(const D of H)X.has(D)&&p.add(D);return p}}),define(f1[2],h1([0,1]),function(a1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=e,t.isSigPipeError=q,t.onUnexpectedError=L,t.onUnexpectedExternalError=X,t.transformErrorForSerialization=H,t.isCancellationError=D,t.canceled=K,t.illegalArgument=Y,t.illegalState=o1,t.getErrorMessage=F;class A{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?m.isErrorNoTelemetry(n)?new m(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}t.ErrorHandler=A,t.errorHandler=new A;function e(s){t.errorHandler.setUnexpectedErrorHandler(s)}function q(s){if(!s||typeof s!="object")return!1;const n=s;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function L(s){D(s)||t.errorHandler.onUnexpectedError(s)}function X(s){D(s)||t.errorHandler.onUnexpectedExternalError(s)}function H(s){if(s instanceof Error){const{name:n,message:o}=s,_=s.stacktrace||s.stack;return{$isError:!0,name:n,message:o,stack:_,noTelemetry:m.isErrorNoTelemetry(s)}}return s}const p="Canceled";function D(s){return s instanceof P?!0:s instanceof Error&&s.name===p&&s.message===p}class P extends Error{constructor(){super(p),this.name=this.message}}t.CancellationError=P;function K(){const s=new Error(p);return s.name=s.message,s}function Y(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function o1(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class c1 extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=c1;function F(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class j extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.NotImplementedError=j;class M extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.NotSupportedError=M;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=d;class m extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof m)return n;const o=new m;return o.message=n.message,o.stack=n.stack,o}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.ErrorNoTelemetry=m;class O extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,O.prototype)}}t.BugIndicatingError=O}),define(f1[9],h1([0,1,2,6]),function(a1,t,A,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=q,t.tail2=L,t.equals=X,t.removeFastWithoutKeepingOrder=H,t.binarySearch=p,t.binarySearch2=D,t.quickSelect=P,t.groupBy=K,t.groupAdjacentBy=Y,t.forEachAdjacent=o1,t.forEachWithNeighbors=c1,t.sortedDiff=F,t.delta=j,t.top=M,t.topAsync=d,t.coalesce=O,t.coalesceInPlace=s,t.move=n,t.isFalsyOrEmpty=o,t.isNonEmptyArray=_,t.distinct=a,t.uniqueFilter=I,t.firstOrDefault=T,t.lastOrDefault=Z,t.commonPrefixLength=d1,t.range=_1,t.index=z,t.insert=S,t.remove=f,t.arrayInsert=w,t.shuffle=W,t.pushToStart=v,t.pushToEnd=g,t.pushMany=N,t.mapArrayOrNot=x,t.asArray=$,t.getRandomElement=C,t.insertInto=t1,t.splice=Q,t.compareBy=U1,t.tieBreakComparators=R1,t.reverseOrder=G1;function q(u,c=0){return u[u.length-(1+c)]}function L(u){if(u.length===0)throw new Error("Invalid tail call");return[u.slice(0,u.length-1),u[u.length-1]]}function X(u,c,l=(E,U)=>E===U){if(u===c)return!0;if(!u||!c||u.length!==c.length)return!1;for(let E=0,U=u.length;E<U;E++)if(!l(u[E],c[E]))return!1;return!0}function H(u,c){const l=u.length-1;c<l&&(u[c]=u[l]),u.pop()}function p(u,c,l){return D(u.length,E=>l(u[E],c))}function D(u,c){let l=0,E=u-1;for(;l<=E;){const U=(l+E)/2|0,J=c(U);if(J<0)l=U+1;else if(J>0)E=U-1;else return U}return-(l+1)}function P(u,c,l){if(u=u|0,u>=c.length)throw new TypeError("invalid index");const E=c[Math.floor(c.length*Math.random())],U=[],J=[],r1=[];for(const g1 of c){const E1=l(g1,E);E1<0?U.push(g1):E1>0?J.push(g1):r1.push(g1)}return u<U.length?P(u,U,l):u<U.length+r1.length?r1[0]:P(u-(U.length+r1.length),J,l)}function K(u,c){const l=[];let E;for(const U of u.slice(0).sort(c))!E||c(E[0],U)!==0?(E=[U],l.push(E)):E.push(U);return l}function*Y(u,c){let l,E;for(const U of u)E!==void 0&&c(E,U)?l.push(U):(l&&(yield l),l=[U]),E=U;l&&(yield l)}function o1(u,c){for(let l=0;l<=u.length;l++)c(l===0?void 0:u[l-1],l===u.length?void 0:u[l])}function c1(u,c){for(let l=0;l<u.length;l++)c(l===0?void 0:u[l-1],u[l],l+1===u.length?void 0:u[l+1])}function F(u,c,l){const E=[];function U(g1,E1,A1){if(E1===0&&A1.length===0)return;const y=E[E.length-1];y&&y.start+y.deleteCount===g1?(y.deleteCount+=E1,y.toInsert.push(...A1)):E.push({start:g1,deleteCount:E1,toInsert:A1})}let J=0,r1=0;for(;;){if(J===u.length){U(J,0,c.slice(r1));break}if(r1===c.length){U(J,u.length-J,[]);break}const g1=u[J],E1=c[r1],A1=l(g1,E1);A1===0?(J+=1,r1+=1):A1<0?(U(J,1,[]),J+=1):A1>0&&(U(J,0,[E1]),r1+=1)}return E}function j(u,c,l){const E=F(u,c,l),U=[],J=[];for(const r1 of E)U.push(...u.slice(r1.start,r1.start+r1.deleteCount)),J.push(...r1.toInsert);return{removed:U,added:J}}function M(u,c,l){if(l===0)return[];const E=u.slice(0,l).sort(c);return m(u,c,E,l,u.length),E}function d(u,c,l,E,U){return l===0?Promise.resolve([]):new Promise((J,r1)=>{(async()=>{const g1=u.length,E1=u.slice(0,l).sort(c);for(let A1=l,y=Math.min(l+E,g1);A1<g1;A1=y,y=Math.min(y+E,g1)){if(A1>l&&await new Promise(R=>setTimeout(R)),U&&U.isCancellationRequested)throw new A.CancellationError;m(u,c,E1,A1,y)}return E1})().then(J,r1)})}function m(u,c,l,E,U){for(const J=l.length;E<U;E++){const r1=u[E];if(c(r1,l[J-1])<0){l.pop();const g1=(0,e.findFirstIdxMonotonousOrArrLen)(l,E1=>c(r1,E1)<0);l.splice(g1,0,r1)}}}function O(u){return u.filter(c=>!!c)}function s(u){let c=0;for(let l=0;l<u.length;l++)u[l]&&(u[c]=u[l],c+=1);u.length=c}function n(u,c,l){u.splice(l,0,u.splice(c,1)[0])}function o(u){return!Array.isArray(u)||u.length===0}function _(u){return Array.isArray(u)&&u.length>0}function a(u,c=l=>l){const l=new Set;return u.filter(E=>{const U=c(E);return l.has(U)?!1:(l.add(U),!0)})}function I(u){const c=new Set;return l=>{const E=u(l);return c.has(E)?!1:(c.add(E),!0)}}function T(u,c){return u.length>0?u[0]:c}function Z(u,c){return u.length>0?u[u.length-1]:c}function d1(u,c,l=(E,U)=>E===U){let E=0;for(let U=0,J=Math.min(u.length,c.length);U<J&&l(u[U],c[U]);U++)E++;return E}function _1(u,c){let l=typeof c=="number"?u:0;typeof c=="number"?l=u:(l=0,c=u);const E=[];if(l<=c)for(let U=l;U<c;U++)E.push(U);else for(let U=l;U>c;U--)E.push(U);return E}function z(u,c,l){return u.reduce((E,U)=>(E[c(U)]=l?l(U):U,E),Object.create(null))}function S(u,c){return u.push(c),()=>f(u,c)}function f(u,c){const l=u.indexOf(c);if(l>-1)return u.splice(l,1),c}function w(u,c,l){const E=u.slice(0,c),U=u.slice(c);return E.concat(l,U)}function W(u,c){let l;if(typeof c=="number"){let E=c;l=()=>{const U=Math.sin(E++)*179426549;return U-Math.floor(U)}}else l=Math.random;for(let E=u.length-1;E>0;E-=1){const U=Math.floor(l()*(E+1)),J=u[E];u[E]=u[U],u[U]=J}}function v(u,c){const l=u.indexOf(c);l>-1&&(u.splice(l,1),u.unshift(c))}function g(u,c){const l=u.indexOf(c);l>-1&&(u.splice(l,1),u.push(c))}function N(u,c){for(const l of c)u.push(l)}function x(u,c){return Array.isArray(u)?u.map(c):c(u)}function $(u){return Array.isArray(u)?u:[u]}function C(u){return u[Math.floor(Math.random()*u.length)]}function t1(u,c,l){const E=n1(u,c),U=u.length,J=l.length;u.length=U+J;for(let r1=U-1;r1>=E;r1--)u[r1+J]=u[r1];for(let r1=0;r1<J;r1++)u[r1+E]=l[r1]}function Q(u,c,l,E){const U=n1(u,c);let J=u.splice(U,l);return J===void 0&&(J=[]),t1(u,U,E),J}function n1(u,c){return c<0?Math.max(c+u.length,0):Math.min(c,u.length)}var l1;(function(u){function c(J){return J<0}u.isLessThan=c;function l(J){return J<=0}u.isLessThanOrEqual=l;function E(J){return J>0}u.isGreaterThan=E;function U(J){return J===0}u.isNeitherLessOrGreaterThan=U,u.greaterThan=1,u.lessThan=-1,u.neitherLessOrGreaterThan=0})(l1||(t.CompareResult=l1={}));function U1(u,c){return(l,E)=>c(u(l),u(E))}function R1(...u){return(c,l)=>{for(const E of u){const U=E(c,l);if(!l1.isNeitherLessOrGreaterThan(U))return U}return l1.neitherLessOrGreaterThan}}const v1=(u,c)=>u-c;t.numberComparator=v1;const y1=(u,c)=>(0,t.numberComparator)(u?1:0,c?1:0);t.booleanComparator=y1;function G1(u){return(c,l)=>-u(c,l)}class q1{constructor(c){this.items=c,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(c){let l=this.firstIdx;for(;l<this.items.length&&c(this.items[l]);)l++;const E=l===this.firstIdx?null:this.items.slice(this.firstIdx,l);return this.firstIdx=l,E}takeFromEndWhile(c){let l=this.lastIdx;for(;l>=0&&c(this.items[l]);)l--;const E=l===this.lastIdx?null:this.items.slice(l+1,this.lastIdx+1);return this.lastIdx=l,E}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const c=this.items[this.firstIdx];return this.firstIdx++,c}removeLast(){const c=this.items[this.lastIdx];return this.lastIdx--,c}takeCount(c){const l=this.items.slice(this.firstIdx,this.firstIdx+c);return this.firstIdx+=c,l}}t.ArrayQueue=q1;class I1{static{this.empty=new I1(c=>{})}constructor(c){this.iterate=c}forEach(c){this.iterate(l=>(c(l),!0))}toArray(){const c=[];return this.iterate(l=>(c.push(l),!0)),c}filter(c){return new I1(l=>this.iterate(E=>c(E)?l(E):!0))}map(c){return new I1(l=>this.iterate(E=>l(c(E))))}some(c){let l=!1;return this.iterate(E=>(l=c(E),!l)),l}findFirst(c){let l;return this.iterate(E=>c(E)?(l=E,!1):!0),l}findLast(c){let l;return this.iterate(E=>(c(E)&&(l=E),!0)),l}findLastMaxBy(c){let l,E=!0;return this.iterate(U=>((E||l1.isGreaterThan(c(U,l)))&&(E=!1,l=U),!0)),l}}t.CallbackIterable=I1;class N1{constructor(c){this._indexMap=c}static createSortPermutation(c,l){const E=Array.from(c.keys()).sort((U,J)=>l(c[U],c[J]));return new N1(E)}apply(c){return c.map((l,E)=>c[this._indexMap[E]])}inverse(){const c=this._indexMap.slice();for(let l=0;l<this._indexMap.length;l++)c[this._indexMap[l]]=l;return new N1(c)}}t.Permutation=N1}),define(f1[3],h1([0,1]),function(a1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=A;function A(e,q){const L=this;let X=!1,H;return function(){if(X)return H;if(X=!0,q)try{H=e.apply(L,arguments)}finally{q()}else H=e.apply(L,arguments);return H}}}),define(f1[10],h1([0,1]),function(a1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var A;(function(e){function q(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}e.is=q;const L=Object.freeze([]);function X(){return L}e.empty=X;function*H(n){yield n}e.single=H;function p(n){return q(n)?n:H(n)}e.wrap=p;function D(n){return n||L}e.from=D;function*P(n){for(let o=n.length-1;o>=0;o--)yield n[o]}e.reverse=P;function K(n){return!n||n[Symbol.iterator]().next().done===!0}e.isEmpty=K;function Y(n){return n[Symbol.iterator]().next().value}e.first=Y;function o1(n,o){for(const _ of n)if(o(_))return!0;return!1}e.some=o1;function c1(n,o){for(const _ of n)if(o(_))return _}e.find=c1;function*F(n,o){for(const _ of n)o(_)&&(yield _)}e.filter=F;function*j(n,o){let _=0;for(const a of n)yield o(a,_++)}e.map=j;function*M(...n){for(const o of n)yield*o}e.concat=M;function d(n,o,_){let a=_;for(const I of n)a=o(a,I);return a}e.reduce=d;function*m(n,o,_=n.length){for(o<0&&(o+=n.length),_<0?_+=n.length:_>n.length&&(_=n.length);o<_;o++)yield n[o]}e.slice=m;function O(n,o=Number.POSITIVE_INFINITY){const _=[];if(o===0)return[_,n];const a=n[Symbol.iterator]();for(let I=0;I<o;I++){const T=a.next();if(T.done)return[_,e.empty()];_.push(T.value)}return[_,{[Symbol.iterator](){return a}}]}e.consume=O;async function s(n){const o=[];for await(const _ of n)o.push(_);return Promise.resolve(o)}e.asyncToArray=s})(A||(t.Iterable=A={}))}),define(f1[11],h1([0,1]),function(a1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class A{constructor(q){this.executor=q,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(q){this._error=q}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=A}),define(f1[12],h1([0,1]),function(a1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class A{static{this.Undefined=new A(void 0)}constructor(L){this.element=L,this.next=A.Undefined,this.prev=A.Undefined}}class e{constructor(){this._first=A.Undefined,this._last=A.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===A.Undefined}clear(){let L=this._first;for(;L!==A.Undefined;){const X=L.next;L.prev=A.Undefined,L.next=A.Undefined,L=X}this._first=A.Undefined,this._last=A.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,X){const H=new A(L);if(this._first===A.Undefined)this._first=H,this._last=H;else if(X){const D=this._last;this._last=H,H.prev=D,D.next=H}else{const D=this._first;this._first=H,H.next=D,D.prev=H}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(H))}}shift(){if(this._first!==A.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==A.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==A.Undefined&&L.next!==A.Undefined){const X=L.prev;X.next=L.next,L.next.prev=X}else L.prev===A.Undefined&&L.next===A.Undefined?(this._first=A.Undefined,this._last=A.Undefined):L.next===A.Undefined?(this._last=this._last.prev,this._last.next=A.Undefined):L.prev===A.Undefined&&(this._first=this._first.next,this._first.prev=A.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==A.Undefined;)yield L.element,L=L.next}}t.LinkedList=e}),define(f1[13],h1([0,1]),function(a1,t){"use strict";var A,e,q;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.MRUCache=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=L,t.mapToString=X,t.setToString=H,t.mapsStrictEqualIgnoreOrder=O;function L(s,n,o){let _=s.get(n);return _===void 0&&(_=o,s.set(n,_)),_}function X(s){const n=[];return s.forEach((o,_)=>{n.push(`${_} => ${o}`)}),`Map(${s.size}) {${n.join(", ")}}`}function H(s){const n=[];return s.forEach(o=>{n.push(o)}),`Set(${s.size}) {${n.join(", ")}}`}class p{constructor(n,o){this.uri=n,this.value=o}}function D(s){return Array.isArray(s)}class P{static{this.defaultToKey=n=>n.toString()}constructor(n,o){if(this[A]="ResourceMap",n instanceof P)this.map=new Map(n.map),this.toKey=o??P.defaultToKey;else if(D(n)){this.map=new Map,this.toKey=o??P.defaultToKey;for(const[_,a]of n)this.set(_,a)}else this.map=new Map,this.toKey=n??P.defaultToKey}set(n,o){return this.map.set(this.toKey(n),new p(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[_,a]of this.map)n(a.value,a.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}t.ResourceMap=P;class K{constructor(n,o){this[e]="ResourceSet",!n||typeof n=="function"?this._map=new P(n):(this._map=new P(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((_,a)=>n.call(o,a,a,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(e=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=K;var Y;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(Y||(t.Touch=Y={}));class o1{constructor(){this[q]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=Y.None){const _=this._map.get(n);if(_)return o!==Y.None&&this.touch(_,o),_.value}set(n,o,_=Y.None){let a=this._map.get(n);if(a)a.value=o,_!==Y.None&&this.touch(a,_);else{switch(a={key:n,value:o,next:void 0,previous:void 0},_){case Y.None:this.addItemLast(a);break;case Y.AsOld:this.addItemFirst(a);break;case Y.AsNew:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(n,a),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const _=this._state;let a=this._head;for(;a;){if(o?n.bind(o)(a.value,a.key,this):n(a.value,a.key,this),this._state!==_)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,o=this._state;let _=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(_){const I={value:_.key,done:!1};return _=_.next,I}else return{value:void 0,done:!0}}};return a}values(){const n=this,o=this._state;let _=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(_){const I={value:_.value,done:!1};return _=_.next,I}else return{value:void 0,done:!0}}};return a}entries(){const n=this,o=this._state;let _=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(_){const I={value:[_.key,_.value],done:!1};return _=_.next,I}else return{value:void 0,done:!0}}};return a}[(q=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,_=this.size;for(;o&&_>n;)this._map.delete(o.key),o=o.next,_--;this._head=o,this._size=_,o&&(o.previous=void 0),this._state++}trimNew(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._tail,_=this.size;for(;o&&_>n;)this._map.delete(o.key),o=o.previous,_--;this._tail=o,this._size=_,o&&(o.next=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,_=n.previous;if(!o||!_)throw new Error("Invalid list");o.previous=_,_.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==Y.AsOld&&o!==Y.AsNew)){if(o===Y.AsOld){if(n===this._head)return;const _=n.next,a=n.previous;n===this._tail?(a.next=void 0,this._tail=a):(_.previous=a,a.next=_),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===Y.AsNew){if(n===this._tail)return;const _=n.next,a=n.previous;n===this._head?(_.previous=void 0,this._head=_):(_.previous=a,a.next=_),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,_)=>{n.push([_,o])}),n}fromJSON(n){this.clear();for(const[o,_]of n)this.set(o,_)}}t.LinkedMap=o1;class c1 extends o1{constructor(n,o=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=Y.AsNew){return super.get(n,o)}peek(n){return super.get(n,Y.None)}set(n,o){return super.set(n,o,Y.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class F extends c1{constructor(n,o=1){super(n,o)}trim(n){this.trimOld(n)}set(n,o){return super.set(n,o),this.checkTrim(),this}}t.LRUCache=F;class j extends c1{constructor(n,o=1){super(n,o)}trim(n){this.trimNew(n)}set(n,o){return this._limit<=this.size&&!this.has(n)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(n,o),this}}t.MRUCache=j;class M{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let o=this.map.get(n)||0;return o===0?!1:(o--,o===0?this.map.delete(n):this.map.set(n,o),!0)}has(n){return this.map.has(n)}}t.CounterSet=M;class d{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[o,_]of n)this.set(o,_)}clear(){this._m1.clear(),this._m2.clear()}set(n,o){this._m1.set(n,o),this._m2.set(o,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const o=this._m1.get(n);return o===void 0?!1:(this._m1.delete(n),this._m2.delete(o),!0)}forEach(n,o){this._m1.forEach((_,a)=>{n.call(o,_,a,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=d;class m{constructor(){this.map=new Map}add(n,o){let _=this.map.get(n);_||(_=new Set,this.map.set(n,_)),_.add(o)}delete(n,o){const _=this.map.get(n);_&&(_.delete(o),_.size===0&&this.map.delete(n))}forEach(n,o){const _=this.map.get(n);_&&_.forEach(o)}get(n){const o=this.map.get(n);return o||new Set}}t.SetMap=m;function O(s,n){if(s===n)return!0;if(s.size!==n.size)return!1;for(const[o,_]of s)if(!n.has(o)||n.get(o)!==_)return!1;for(const[o]of n)if(!s.has(o))return!1;return!0}}),define(f1[4],h1([0,1,9,8,13,3,10]),function(a1,t,A,e,q,L,X){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=P,t.trackDisposable=K,t.markAsDisposed=Y,t.markAsSingleton=F,t.isDisposable=j,t.dispose=M,t.disposeIfDisposable=d,t.combinedDisposable=m,t.toDisposable=O,t.disposeOnReturn=_1;const H=!1;let p=null;class D{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(f){let w=this.livingDisposables.get(f);return w||(w={parent:null,source:null,isSingleton:!1,value:f,idx:D.idx++},this.livingDisposables.set(f,w)),w}trackDisposable(f){const w=this.getDisposableData(f);w.source||(w.source=new Error().stack)}setParent(f,w){const W=this.getDisposableData(f);W.parent=w}markAsDisposed(f){this.livingDisposables.delete(f)}markAsSingleton(f){this.getDisposableData(f).isSingleton=!0}getRootParent(f,w){const W=w.get(f);if(W)return W;const v=f.parent?this.getRootParent(this.getDisposableData(f.parent),w):f;return w.set(f,v),v}getTrackedDisposables(){const f=new Map;return[...this.livingDisposables.entries()].filter(([,W])=>W.source!==null&&!this.getRootParent(W,f).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(f=10,w){let W;if(w)W=w;else{const $=new Map,C=[...this.livingDisposables.values()].filter(Q=>Q.source!==null&&!this.getRootParent(Q,$).isSingleton);if(C.length===0)return;const t1=new Set(C.map(Q=>Q.value));if(W=C.filter(Q=>!(Q.parent&&t1.has(Q.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function v($){function C(Q,n1){for(;Q.length>0&&n1.some(l1=>typeof l1=="string"?l1===Q[0]:Q[0].match(l1));)Q.shift()}const t1=$.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return C(t1,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),t1.reverse()}const g=new q.SetMap;for(const $ of W){const C=v($);for(let t1=0;t1<=C.length;t1++)g.add(C.slice(0,t1).join(`
`),$)}W.sort((0,A.compareBy)($=>$.idx,A.numberComparator));let N="",x=0;for(const $ of W.slice(0,f)){x++;const C=v($),t1=[];for(let Q=0;Q<C.length;Q++){let n1=C[Q];n1=`(shared with ${g.get(C.slice(0,Q+1).join(`
`)).size}/${W.length} leaks) at ${n1}`;const U1=g.get(C.slice(0,Q).join(`
`)),R1=(0,e.groupBy)([...U1].map(v1=>v(v1)[Q]),v1=>v1);delete R1[C[Q]];for(const[v1,y1]of Object.entries(R1))t1.unshift(`    - stacktraces of ${y1.length} other leaks continue with ${v1}`);t1.unshift(n1)}N+=`


==================== Leaking disposable ${x}/${W.length}: ${$.value.constructor.name} ====================
${t1.join(`
`)}
============================================================

`}return W.length>f&&(N+=`


... and ${W.length-f} more leaking disposables

`),{leaks:W,details:N}}}t.DisposableTracker=D;function P(S){p=S}if(H){const S="__is_disposable_tracked__";P(new class{trackDisposable(f){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[S]||console.log(w)},3e3)}setParent(f,w){if(f&&f!==n.None)try{f[S]=!0}catch{}}markAsDisposed(f){if(f&&f!==n.None)try{f[S]=!0}catch{}}markAsSingleton(f){}})}function K(S){return p?.trackDisposable(S),S}function Y(S){p?.markAsDisposed(S)}function o1(S,f){p?.setParent(S,f)}function c1(S,f){if(p)for(const w of S)p.setParent(w,f)}function F(S){return p?.markAsSingleton(S),S}function j(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function M(S){if(X.Iterable.is(S)){const f=[];for(const w of S)if(w)try{w.dispose()}catch(W){f.push(W)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function d(S){for(const f of S)j(f)&&f.dispose();return[]}function m(...S){const f=O(()=>M(S));return c1(S,f),f}function O(S){const f=K({dispose:(0,L.createSingleCallFunction)(()=>{Y(f),S()})});return f}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,K(this)}dispose(){this._isDisposed||(Y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{M(this._toDispose)}finally{this._toDispose.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return o1(f,this),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(f),f}delete(f){if(f){if(f===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(f),f.dispose()}}deleteAndLeak(f){f&&this._toDispose.has(f)&&(this._toDispose.delete(f),o1(f,null))}}t.DisposableStore=s;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new s,K(this),o1(this._store,this)}dispose(){Y(this),this._store.dispose()}_register(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(f)}}t.Disposable=n;class o{constructor(){this._isDisposed=!1,K(this)}get value(){return this._isDisposed?void 0:this._value}set value(f){this._isDisposed||f===this._value||(this._value?.dispose(),f&&o1(f,this),this._value=f)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,Y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const f=this._value;return this._value=void 0,f&&o1(f,null),f}}t.MutableDisposable=o;class _{constructor(f){this._disposable=new o,this._isDisposed=!1,this._disposable.value=f}get value(){return this._disposable.value}set value(f){this._isDisposed||f===this._disposable.value||(this._disposable.value=f)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=_;class a{constructor(f){this._disposable=f,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=a;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,K(this)}set(f){let w=f;return this.unset=()=>w=void 0,this.isset=()=>w!==void 0,this.dispose=()=>{w&&(w(),w=void 0,Y(this))},this}}t.SafeDisposable=I;class T{constructor(){this.references=new Map}acquire(f,...w){let W=this.references.get(f);W||(W={counter:0,object:this.createReferencedObject(f,...w)},this.references.set(f,W));const{object:v}=W,g=(0,L.createSingleCallFunction)(()=>{--W.counter===0&&(this.destroyReferencedObject(f,W.object),this.references.delete(f))});return W.counter++,{object:v,dispose:g}}}t.ReferenceCollection=T;class Z{constructor(f){this.referenceCollection=f}async acquire(f,...w){const W=this.referenceCollection.acquire(f,...w);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(v){throw W.dispose(),v}}}t.AsyncReferenceCollection=Z;class d1{constructor(f){this.object=f}dispose(){}}t.ImmortalReference=d1;function _1(S){const f=new s;try{S(f)}finally{f.dispose()}}class z{constructor(){this._store=new Map,this._isDisposed=!1,K(this)}dispose(){Y(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{M(this._store.values())}finally{this._store.clear()}}has(f){return this._store.has(f)}get size(){return this._store.size}get(f){return this._store.get(f)}set(f,w,W=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this._store.get(f)?.dispose(),this._store.set(f,w)}deleteAndDispose(f){this._store.get(f)?.dispose(),this._store.delete(f)}deleteAndLeak(f){const w=this._store.get(f);return this._store.delete(f),w}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=z}),define(f1[14],h1([0,1]),function(a1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class e{static create(L){return new e(L)}constructor(L){this._now=A&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=e}),define(f1[5],h1([0,1,2,3,4,12,14]),function(a1,t,A,e,q,L,X){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEvent=t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.ListenerRefusalError=t.ListenerLeakError=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=o1;const H=!1,p=!1,D=!1;var P;(function(v){v.None=()=>q.Disposable.None;function g(y){if(D){const{onDidAddListener:R}=y,G=F.create();let k=0;y.onDidAddListener=()=>{++k===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),R?.()}}}function N(y,R){return v1(y,()=>{},0,void 0,!0,void 0,R)}v.defer=N;function x(y){return(R,G=null,k)=>{let V=!1,i1;return i1=y(u1=>{if(!V)return i1?i1.dispose():V=!0,R.call(G,u1)},null,k),V&&i1.dispose(),i1}}v.once=x;function $(y,R,G){return U1((k,V=null,i1)=>y(u1=>k.call(V,R(u1)),null,i1),G)}v.map=$;function C(y,R,G){return U1((k,V=null,i1)=>y(u1=>{R(u1),k.call(V,u1)},null,i1),G)}v.forEach=C;function t1(y,R,G){return U1((k,V=null,i1)=>y(u1=>R(u1)&&k.call(V,u1),null,i1),G)}v.filter=t1;function Q(y){return y}v.signal=Q;function n1(...y){return(R,G=null,k)=>{const V=(0,q.combinedDisposable)(...y.map(i1=>i1(u1=>R.call(G,u1))));return R1(V,k)}}v.any=n1;function l1(y,R,G,k){let V=G;return $(y,i1=>(V=R(V,i1),V),k)}v.reduce=l1;function U1(y,R){let G;const k={onWillAddFirstListener(){G=y(V.fire,V)},onDidRemoveLastListener(){G?.dispose()}};R||g(k);const V=new o(k);return R?.add(V),V.event}function R1(y,R){return R instanceof Array?R.push(y):R&&R.add(y),y}function v1(y,R,G=100,k=!1,V=!1,i1,u1){let m1,L1,F1,k1=0,e1;const D1={leakWarningThreshold:i1,onWillAddFirstListener(){m1=y(z1=>{k1++,L1=R(L1,z1),k&&!F1&&(P1.fire(L1),L1=void 0),e1=()=>{const j1=L1;L1=void 0,F1=void 0,(!k||k1>1)&&P1.fire(j1),k1=0},typeof G=="number"?(clearTimeout(F1),F1=setTimeout(e1,G)):F1===void 0&&(F1=0,queueMicrotask(e1))})},onWillRemoveListener(){V&&k1>0&&e1?.()},onDidRemoveLastListener(){e1=void 0,m1.dispose()}};u1||g(D1);const P1=new o(D1);return u1?.add(P1),P1.event}v.debounce=v1;function y1(y,R=0,G){return v.debounce(y,(k,V)=>k?(k.push(V),k):[V],R,void 0,!0,void 0,G)}v.accumulate=y1;function G1(y,R=(k,V)=>k===V,G){let k=!0,V;return t1(y,i1=>{const u1=k||!R(i1,V);return k=!1,V=i1,u1},G)}v.latch=G1;function q1(y,R,G){return[v.filter(y,R,G),v.filter(y,k=>!R(k),G)]}v.split=q1;function I1(y,R=!1,G=[],k){let V=G.slice(),i1=y(L1=>{V?V.push(L1):m1.fire(L1)});k&&k.add(i1);const u1=()=>{V?.forEach(L1=>m1.fire(L1)),V=null},m1=new o({onWillAddFirstListener(){i1||(i1=y(L1=>m1.fire(L1)),k&&k.add(i1))},onDidAddFirstListener(){V&&(R?setTimeout(u1):u1())},onDidRemoveLastListener(){i1&&i1.dispose(),i1=null}});return k&&k.add(m1),m1.event}v.buffer=I1;function N1(y,R){return(k,V,i1)=>{const u1=R(new c);return y(function(m1){const L1=u1.evaluate(m1);L1!==u&&k.call(V,L1)},void 0,i1)}}v.chain=N1;const u=Symbol("HaltChainable");class c{constructor(){this.steps=[]}map(R){return this.steps.push(R),this}forEach(R){return this.steps.push(G=>(R(G),G)),this}filter(R){return this.steps.push(G=>R(G)?G:u),this}reduce(R,G){let k=G;return this.steps.push(V=>(k=R(k,V),k)),this}latch(R=(G,k)=>G===k){let G=!0,k;return this.steps.push(V=>{const i1=G||!R(V,k);return G=!1,k=V,i1?V:u}),this}evaluate(R){for(const G of this.steps)if(R=G(R),R===u)break;return R}}function l(y,R,G=k=>k){const k=(...m1)=>u1.fire(G(...m1)),V=()=>y.on(R,k),i1=()=>y.removeListener(R,k),u1=new o({onWillAddFirstListener:V,onDidRemoveLastListener:i1});return u1.event}v.fromNodeEventEmitter=l;function E(y,R,G=k=>k){const k=(...m1)=>u1.fire(G(...m1)),V=()=>y.addEventListener(R,k),i1=()=>y.removeEventListener(R,k),u1=new o({onWillAddFirstListener:V,onDidRemoveLastListener:i1});return u1.event}v.fromDOMEventEmitter=E;function U(y){return new Promise(R=>x(y)(R))}v.toPromise=U;function J(y){const R=new o;return y.then(G=>{R.fire(G)},()=>{R.fire(void 0)}).finally(()=>{R.dispose()}),R.event}v.fromPromise=J;function r1(y,R,G){return R(G),y(k=>R(k))}v.runAndSubscribe=r1;class g1{constructor(R,G){this._observable=R,this._counter=0,this._hasChanged=!1;const k={onWillAddFirstListener:()=>{R.addObserver(this)},onDidRemoveLastListener:()=>{R.removeObserver(this)}};G||g(k),this.emitter=new o(k),G&&G.add(this.emitter)}beginUpdate(R){this._counter++}handlePossibleChange(R){}handleChange(R,G){this._hasChanged=!0}endUpdate(R){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function E1(y,R){return new g1(y,R).emitter.event}v.fromObservable=E1;function A1(y){return(R,G,k)=>{let V=0,i1=!1;const u1={beginUpdate(){V++},endUpdate(){V--,V===0&&(y.reportChanges(),i1&&(i1=!1,R.call(G)))},handlePossibleChange(){},handleChange(){i1=!0}};y.addObserver(u1),y.reportChanges();const m1={dispose(){y.removeObserver(u1)}};return k instanceof q.DisposableStore?k.add(m1):Array.isArray(k)&&k.push(m1),m1}}v.fromObservableLight=A1})(P||(t.Event=P={}));class K{static{this.all=new Set}static{this._idPool=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${K._idPool++}`,K.all.add(this)}start(g){this._stopWatch=new X.StopWatch,this.listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=K;let Y=-1;function o1(v){const g=Y;return Y=v,{dispose(){Y=g}}}class c1{constructor(g,N,x=Math.random().toString(18).slice(2,5)){this._errorHandler=g,this.threshold=N,this.name=x,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(g,N){const x=this.threshold;if(x<=0||N<x)return;this._stacks||(this._stacks=new Map);const $=this._stacks.get(g.value)||0;if(this._stacks.set(g.value,$+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=x*.5;const[C,t1]=this.getMostFrequentStack(),Q=`[${this.name}] potential listener LEAK detected, having ${N} listeners already. MOST frequent listener (${t1}):`;console.warn(Q),console.warn(C);const n1=new j(Q,C);this._errorHandler(n1)}return()=>{const C=this._stacks.get(g.value)||0;this._stacks.set(g.value,C-1)}}getMostFrequentStack(){if(!this._stacks)return;let g,N=0;for(const[x,$]of this._stacks)(!g||N<$)&&(g=[x,$],N=$);return g}}class F{static create(){const g=new Error;return new F(g.stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class j extends Error{constructor(g,N){super(g),this.name="ListenerLeakError",this.stack=N}}t.ListenerLeakError=j;class M extends Error{constructor(g,N){super(g),this.name="ListenerRefusalError",this.stack=N}}t.ListenerRefusalError=M;let d=0;class m{constructor(g){this.value=g,this.id=d++}}const O=2,s=(v,g)=>{if(v instanceof m)g(v);else for(let N=0;N<v.length;N++){const x=v[N];x&&g(x)}},n=H?new FinalizationRegistry(v=>{typeof v=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(v))}):void 0;class o{constructor(g){this._size=0,this._options=g,this._leakageMon=Y>0||this._options?.leakWarningThreshold?new c1(g?.onListenerError??A.onUnexpectedError,this._options?.leakWarningThreshold??Y):void 0,this._perfMon=this._options?._profName?new K(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(p){const g=this._listeners;queueMicrotask(()=>{s(g,N=>N.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(g,N,x)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const n1=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(n1);const l1=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],U1=new M(`${n1}. HINT: Stack shows most frequent listener (${l1[1]}-times)`,l1[0]);return(this._options?.onListenerError||A.onUnexpectedError)(U1),q.Disposable.None}if(this._disposed)return q.Disposable.None;N&&(g=g.bind(N));const $=new m(g);let C,t1;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&($.stack=F.create(),C=this._leakageMon.check($.stack,this._size+1)),p&&($.stack=t1??F.create()),this._listeners?this._listeners instanceof m?(this._deliveryQueue??=new a,this._listeners=[this._listeners,$]):this._listeners.push($):(this._options?.onWillAddFirstListener?.(this),this._listeners=$,this._options?.onDidAddFirstListener?.(this)),this._size++;const Q=(0,q.toDisposable)(()=>{n?.unregister(Q),C?.(),this._removeListener($)});if(x instanceof q.DisposableStore?x.add(Q):Array.isArray(x)&&x.push(Q),n){const n1=new Error().stack.split(`
`).slice(2).join(`
`).trim();n.register(Q,n1,Q)}return Q},this._event}_removeListener(g){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const N=this._listeners,x=N.indexOf(g);if(x===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,N[x]=void 0;const $=this._deliveryQueue.current===this;if(this._size*O<=N.length){let C=0;for(let t1=0;t1<N.length;t1++)N[t1]?N[C++]=N[t1]:$&&(this._deliveryQueue.end--,C<this._deliveryQueue.i&&this._deliveryQueue.i--);N.length=C}}_deliver(g,N){if(!g)return;const x=this._options?.onListenerError||A.onUnexpectedError;if(!x){g.value(N);return}try{g.value(N)}catch($){x($)}}_deliverQueue(g){const N=g.current._listeners;for(;g.i<g.end;)this._deliver(N[g.i++],g.value);g.reset()}fire(g){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof m)this._deliver(this._listeners,g);else{const N=this._deliveryQueue;N.enqueue(this,g,this._listeners.length),this._deliverQueue(N)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=o;const _=()=>new a;t.createEventDeliveryQueue=_;class a{constructor(){this.i=-1,this.end=0}enqueue(g,N,x){this.i=0,this.end=x,this.current=g,this.value=N}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class I extends o{async fireAsync(g,N,x){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList),s(this._listeners,$=>this._asyncDeliveryQueue.push([$.value,g]));this._asyncDeliveryQueue.size>0&&!N.isCancellationRequested;){const[$,C]=this._asyncDeliveryQueue.shift(),t1=[],Q={...C,token:N,waitUntil:n1=>{if(Object.isFrozen(t1))throw new Error("waitUntil can NOT be called asynchronous");x&&(n1=x(n1,$)),t1.push(n1)}};try{$(Q)}catch(n1){(0,A.onUnexpectedError)(n1);continue}Object.freeze(t1),await Promise.allSettled(t1).then(n1=>{for(const l1 of n1)l1.status==="rejected"&&(0,A.onUnexpectedError)(l1.reason)})}}}t.AsyncEmitter=I;class T extends o{get isPaused(){return this._isPaused!==0}constructor(g){super(g),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._size&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}t.PauseableEmitter=T;class Z extends T{constructor(g){super(g),this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}t.DebounceEmitter=Z;class d1 extends o{constructor(g){super(g),this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this.hasListeners()&&(this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(N=>super.fire(N)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=d1;class _1{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const N={event:g,listener:null};this.events.push(N),this.hasListeners&&this.hook(N);const x=()=>{this.hasListeners&&this.unhook(N);const $=this.events.indexOf(N);this.events.splice($,1)};return(0,q.toDisposable)((0,e.createSingleCallFunction)(x))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(N=>this.emitter.fire(N))}unhook(g){g.listener?.dispose(),g.listener=null}dispose(){this.emitter.dispose();for(const g of this.events)g.listener?.dispose();this.events=[]}}t.EventMultiplexer=_1;class z{constructor(g,N,x,$){this._store=new q.DisposableStore;const C=this._store.add(new _1),t1=this._store.add(new q.DisposableMap);function Q(n1){t1.set(n1,C.add($(n1)))}for(const n1 of g)Q(n1);this._store.add(N(n1=>{Q(n1)})),this._store.add(x(n1=>{t1.deleteAndDispose(n1)})),this.event=C.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=z;class S{constructor(){this.data=[]}wrapEvent(g,N,x){return($,C,t1)=>g(Q=>{const n1=this.data[this.data.length-1];if(!N){n1?n1.buffers.push(()=>$.call(C,Q)):$.call(C,Q);return}const l1=n1;if(!l1){$.call(C,N(x,Q));return}l1.items??=[],l1.items.push(Q),l1.buffers.length===0&&n1.buffers.push(()=>{l1.reducedResult??=x?l1.items.reduce(N,x):l1.items.reduce(N),$.call(C,l1.reducedResult)})},void 0,t1)}bufferEvents(g){const N={buffers:new Array};this.data.push(N);const x=g();return this.data.pop(),N.buffers.forEach($=>$()),x}}t.EventBufferer=S;class f{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=q.Disposable.None,this.emitter=new o({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=f;class w{static const(g){return new W(g)}constructor(g){this._value=g,this._onDidChange=new o,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(g){g!==this._value&&(this._value=g,this._onDidChange.fire(void 0))}}t.ValueWithChangeEvent=w;class W{constructor(g){this.value=g,this.onDidChange=P.None}}}),define(f1[15],h1([0,1,5]),function(a1,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0,t.cancelOnDispose=H;const e=Object.freeze(function(p,D){const P=setTimeout(p.bind(D),0);return{dispose(){clearTimeout(P)}}});var q;(function(p){function D(P){return P===p.None||P===p.Cancelled||P instanceof L?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}p.isCancellationToken=D,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:e})})(q||(t.CancellationToken=q={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?e:(this._emitter||(this._emitter=new A.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class X{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=q.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=q.None}}t.CancellationTokenSource=X;function H(p){const D=new X;return p.add({dispose(){D.cancel()}}),D.token}}),define(f1[16],h1([0,1,15]),function(a1,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0,t.identity=q;class e{constructor(p){this.task=p,this.result=null}get(){if(this.result)return this.result;const p=new A.CancellationTokenSource,D=this.task(p.token);return this.result={promise:D,dispose:()=>{this.result=null,p.cancel(),p.dispose()}},this.result}}t.Cache=e;function q(H){return H}class L{constructor(p,D){this.lastCache=void 0,this.lastArgKey=void 0,typeof p=="function"?(this._fn=p,this._computeKey=q):(this._fn=D,this._computeKey=p.getCacheKey)}get(p){const D=this._computeKey(p);return this.lastArgKey!==D&&(this.lastArgKey=D,this.lastCache=this._fn(p)),this.lastCache}}t.LRUCachedFunction=L;class X{get cachedValues(){return this._map}constructor(p,D){this._map=new Map,this._map2=new Map,typeof p=="function"?(this._fn=p,this._computeKey=q):(this._fn=D,this._computeKey=p.getCacheKey)}get(p){const D=this._computeKey(p);if(this._map2.has(D))return this._map2.get(D);const P=this._fn(p);return this._map.set(p,P),this._map2.set(D,P),P}}t.CachedFunction=X}),define(f1[17],h1([0,1]),function(a1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isString=A,t.isStringArray=e,t.isObject=q,t.isTypedArray=L,t.isNumber=X,t.isIterable=H,t.isBoolean=p,t.isUndefined=D,t.isDefined=P,t.isUndefinedOrNull=K,t.assertType=Y,t.assertIsDefined=o1,t.assertAllDefined=c1,t.isEmptyObject=j,t.isFunction=M,t.areFunctions=d,t.validateConstraints=m,t.validateConstraint=O;function A(s){return typeof s=="string"}function e(s){return Array.isArray(s)&&s.every(n=>A(n))}function q(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function L(s){const n=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof n}function X(s){return typeof s=="number"&&!isNaN(s)}function H(s){return!!s&&typeof s[Symbol.iterator]=="function"}function p(s){return s===!0||s===!1}function D(s){return typeof s>"u"}function P(s){return!K(s)}function K(s){return D(s)||s===null}function Y(s,n){if(!s)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function o1(s){if(K(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function c1(...s){const n=[];for(let o=0;o<s.length;o++){const _=s[o];if(K(_))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);n.push(_)}return n}const F=Object.prototype.hasOwnProperty;function j(s){if(!q(s))return!1;for(const n in s)if(F.call(s,n))return!1;return!0}function M(s){return typeof s=="function"}function d(...s){return s.length>0&&s.every(M)}function m(s,n){const o=Math.min(s.length,n.length);for(let _=0;_<o;_++)O(s[_],n[_])}function O(s,n){if(A(n)){if(typeof s!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(M(n)){try{if(s instanceof n)return}catch{}if(!K(s)&&s.constructor===n||n.length===1&&n.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(f1[18],h1([0,1,17]),function(a1,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=e,t.deepFreeze=q,t.cloneAndChange=X,t.mixin=p,t.equals=D,t.safeStringify=P,t.distinct=K,t.getCaseInsensitive=Y,t.filter=o1,t.getAllPropertyNames=c1,t.getAllMethodNames=F,t.createProxyObject=j,t.mapValues=M;function e(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const m=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([O,s])=>{m[O]=s&&typeof s=="object"?e(s):s}),m}function q(d){if(!d||typeof d!="object")return d;const m=[d];for(;m.length>0;){const O=m.shift();Object.freeze(O);for(const s in O)if(L.call(O,s)){const n=O[s];typeof n=="object"&&!Object.isFrozen(n)&&!(0,A.isTypedArray)(n)&&m.push(n)}}return d}const L=Object.prototype.hasOwnProperty;function X(d,m){return H(d,m,new Set)}function H(d,m,O){if((0,A.isUndefinedOrNull)(d))return d;const s=m(d);if(typeof s<"u")return s;if(Array.isArray(d)){const n=[];for(const o of d)n.push(H(o,m,O));return n}if((0,A.isObject)(d)){if(O.has(d))throw new Error("Cannot clone recursive data-structure");O.add(d);const n={};for(const o in d)L.call(d,o)&&(n[o]=H(d[o],m,O));return O.delete(d),n}return d}function p(d,m,O=!0){return(0,A.isObject)(d)?((0,A.isObject)(m)&&Object.keys(m).forEach(s=>{s in d?O&&((0,A.isObject)(d[s])&&(0,A.isObject)(m[s])?p(d[s],m[s],O):d[s]=m[s]):d[s]=m[s]}),d):m}function D(d,m){if(d===m)return!0;if(d==null||m===null||m===void 0||typeof d!=typeof m||typeof d!="object"||Array.isArray(d)!==Array.isArray(m))return!1;let O,s;if(Array.isArray(d)){if(d.length!==m.length)return!1;for(O=0;O<d.length;O++)if(!D(d[O],m[O]))return!1}else{const n=[];for(s in d)n.push(s);n.sort();const o=[];for(s in m)o.push(s);if(o.sort(),!D(n,o))return!1;for(O=0;O<n.length;O++)if(!D(d[n[O]],m[n[O]]))return!1}return!0}function P(d){const m=new Set;return JSON.stringify(d,(O,s)=>{if((0,A.isObject)(s)||Array.isArray(s)){if(m.has(s))return"[Circular]";m.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function K(d,m){const O=Object.create(null);return!d||!m||Object.keys(m).forEach(n=>{const o=d[n],_=m[n];D(o,_)||(O[n]=_)}),O}function Y(d,m){const O=m.toLowerCase(),s=Object.keys(d).find(n=>n.toLowerCase()===O);return s?d[s]:d[m]}function o1(d,m){const O=Object.create(null);for(const[s,n]of Object.entries(d))m(s,n)&&(O[s]=n);return O}function c1(d){let m=[];for(;Object.prototype!==d;)m=m.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return m}function F(d){const m=[];for(const O of c1(d))typeof d[O]=="function"&&m.push(O);return m}function j(d,m){const O=n=>function(){const o=Array.prototype.slice.call(arguments,0);return m(n,o)},s={};for(const n of d)s[n]=O(n);return s}function M(d,m){const O={};for(const[s,n]of Object.entries(d))O[s]=m(n,s);return O}}),define(f1[19],h1([0,1]),function(a1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.toUint8=e,t.toUint32=q;var A;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(A||(t.Constants=A={}));function e(L){return L<0?0:L>A.MAX_UINT_8?A.MAX_UINT_8:L|0}function q(L){return L<0?0:L>A.MAX_UINT_32?A.MAX_UINT_32:L|0}}),define(f1[20],h1([0,1,16,7,11,19]),function(a1,t,A,e,q,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=X,t.format=p,t.format2=P,t.htmlAttributeEncodeValue=K,t.escape=Y,t.escapeRegExpCharacters=o1,t.count=c1,t.truncate=F,t.truncateMiddle=j,t.trim=M,t.ltrim=d,t.rtrim=m,t.convertSimple2RegExpPattern=O,t.stripWildcards=s,t.createRegExp=n,t.regExpLeadsToEndlessLoop=o,t.splitLines=_,t.splitLinesIncludeSeparators=a,t.firstNonWhitespaceIndex=I,t.getLeadingWhitespace=T,t.lastNonWhitespaceIndex=Z,t.replaceAsync=d1,t.compare=_1,t.compareSubstring=z,t.compareIgnoreCase=S,t.compareSubstringIgnoreCase=f,t.isAsciiDigit=w,t.isLowerAsciiLetter=W,t.isUpperAsciiLetter=v,t.equalsIgnoreCase=g,t.startsWithIgnoreCase=N,t.commonPrefixLength=x,t.commonSuffixLength=$,t.isHighSurrogate=C,t.isLowSurrogate=t1,t.computeCodePoint=Q,t.getNextCodePoint=n1,t.nextCharLength=v1,t.prevCharLength=y1,t.getCharContainingOffset=G1,t.charCount=q1,t.containsRTL=u,t.isBasicASCII=l,t.containsUnusualLineTerminators=E,t.isFullWidthCharacter=U,t.isEmojiImprecise=J,t.lcut=r1,t.forAnsiStringParts=E1,t.removeAnsiEscapeCodes=A1,t.removeAnsiEscapeCodesFromPrompt=R,t.startsWithUTF8BOM=G,t.stripUTF8BOM=k,t.fuzzyContains=V,t.containsUppercaseCharacter=i1,t.uppercaseFirstLetter=u1,t.getNLines=m1,t.singleLetterHash=L1,t.getGraphemeBreakType=F1,t.getLeftDeleteOffset=z1;function X(i){return!i||typeof i!="string"?!0:i.trim().length===0}const H=/{(\d+)}/g;function p(i,...r){return r.length===0?i:i.replace(H,function(h,b){const B=parseInt(b,10);return isNaN(B)||B<0||B>=r.length?h:r[B]})}const D=/{([^}]+)}/g;function P(i,r){return Object.keys(r).length===0?i:i.replace(D,(h,b)=>r[b]??h)}function K(i){return i.replace(/[<>"'&]/g,r=>{switch(r){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return r})}function Y(i){return i.replace(/[<>&]/g,function(r){switch(r){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return r}})}function o1(i){return i.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c1(i,r){let h=0,b=i.indexOf(r);for(;b!==-1;)h++,b=i.indexOf(r,b+r.length);return h}function F(i,r,h="\u2026"){return i.length<=r?i:`${i.substr(0,r)}${h}`}function j(i,r,h="\u2026"){if(i.length<=r)return i;const b=Math.ceil(r/2)-h.length/2,B=Math.floor(r/2)-h.length/2;return`${i.substr(0,b)}${h}${i.substr(i.length-B)}`}function M(i,r=" "){const h=d(i,r);return m(h,r)}function d(i,r){if(!i||!r)return i;const h=r.length;if(h===0||i.length===0)return i;let b=0;for(;i.indexOf(r,b)===b;)b=b+h;return i.substring(b)}function m(i,r){if(!i||!r)return i;const h=r.length,b=i.length;if(h===0||b===0)return i;let B=b,s1=-1;for(;s1=i.lastIndexOf(r,B-1),!(s1===-1||s1+h!==B);){if(s1===0)return"";B=s1}return i.substring(0,B)}function O(i){return i.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function s(i){return i.replace(/\*/g,"")}function n(i,r,h={}){if(!i)throw new Error("Cannot create regex from empty string");r||(i=o1(i)),h.wholeWord&&(/\B/.test(i.charAt(0))||(i="\\b"+i),/\B/.test(i.charAt(i.length-1))||(i=i+"\\b"));let b="";return h.global&&(b+="g"),h.matchCase||(b+="i"),h.multiline&&(b+="m"),h.unicode&&(b+="u"),new RegExp(i,b)}function o(i){return i.source==="^"||i.source==="^$"||i.source==="$"||i.source==="^\\s*$"?!1:!!(i.exec("")&&i.lastIndex===0)}function _(i){return i.split(/\r\n|\r|\n/)}function a(i){const r=[],h=i.split(/(\r\n|\r|\n)/);for(let b=0;b<Math.ceil(h.length/2);b++)r.push(h[2*b]+(h[2*b+1]??""));return r}function I(i){for(let r=0,h=i.length;r<h;r++){const b=i.charCodeAt(r);if(b!==e.CharCode.Space&&b!==e.CharCode.Tab)return r}return-1}function T(i,r=0,h=i.length){for(let b=r;b<h;b++){const B=i.charCodeAt(b);if(B!==e.CharCode.Space&&B!==e.CharCode.Tab)return i.substring(r,b)}return i.substring(r,h)}function Z(i,r=i.length-1){for(let h=r;h>=0;h--){const b=i.charCodeAt(h);if(b!==e.CharCode.Space&&b!==e.CharCode.Tab)return h}return-1}function d1(i,r,h){const b=[];let B=0;for(const s1 of i.matchAll(r)){if(b.push(i.slice(B,s1.index)),s1.index===void 0)throw new Error("match.index should be defined");B=s1.index+s1[0].length,b.push(h(s1[0],...s1.slice(1),s1.index,i,s1.groups))}return b.push(i.slice(B)),Promise.all(b).then(s1=>s1.join(""))}function _1(i,r){return i<r?-1:i>r?1:0}function z(i,r,h=0,b=i.length,B=0,s1=r.length){for(;h<b&&B<s1;h++,B++){const w1=i.charCodeAt(h),O1=r.charCodeAt(B);if(w1<O1)return-1;if(w1>O1)return 1}const b1=b-h,M1=s1-B;return b1<M1?-1:b1>M1?1:0}function S(i,r){return f(i,r,0,i.length,0,r.length)}function f(i,r,h=0,b=i.length,B=0,s1=r.length){for(;h<b&&B<s1;h++,B++){let w1=i.charCodeAt(h),O1=r.charCodeAt(B);if(w1===O1)continue;if(w1>=128||O1>=128)return z(i.toLowerCase(),r.toLowerCase(),h,b,B,s1);W(w1)&&(w1-=32),W(O1)&&(O1-=32);const p1=w1-O1;if(p1!==0)return p1}const b1=b-h,M1=s1-B;return b1<M1?-1:b1>M1?1:0}function w(i){return i>=e.CharCode.Digit0&&i<=e.CharCode.Digit9}function W(i){return i>=e.CharCode.a&&i<=e.CharCode.z}function v(i){return i>=e.CharCode.A&&i<=e.CharCode.Z}function g(i,r){return i.length===r.length&&f(i,r)===0}function N(i,r){const h=r.length;return r.length>i.length?!1:f(i,r,0,h)===0}function x(i,r){const h=Math.min(i.length,r.length);let b;for(b=0;b<h;b++)if(i.charCodeAt(b)!==r.charCodeAt(b))return b;return h}function $(i,r){const h=Math.min(i.length,r.length);let b;const B=i.length-1,s1=r.length-1;for(b=0;b<h;b++)if(i.charCodeAt(B-b)!==r.charCodeAt(s1-b))return b;return h}function C(i){return 55296<=i&&i<=56319}function t1(i){return 56320<=i&&i<=57343}function Q(i,r){return(i-55296<<10)+(r-56320)+65536}function n1(i,r,h){const b=i.charCodeAt(h);if(C(b)&&h+1<r){const B=i.charCodeAt(h+1);if(t1(B))return Q(b,B)}return b}function l1(i,r){const h=i.charCodeAt(r-1);if(t1(h)&&r>1){const b=i.charCodeAt(r-2);if(C(b))return Q(b,h)}return h}class U1{get offset(){return this._offset}constructor(r,h=0){this._str=r,this._len=r.length,this._offset=h}setOffset(r){this._offset=r}prevCodePoint(){const r=l1(this._str,this._offset);return this._offset-=r>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,r}nextCodePoint(){const r=n1(this._str,this._len,this._offset);return this._offset+=r>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,r}eol(){return this._offset>=this._len}}t.CodePointIterator=U1;class R1{get offset(){return this._iterator.offset}constructor(r,h=0){this._iterator=new U1(r,h)}nextGraphemeLength(){const r=D1.getInstance(),h=this._iterator,b=h.offset;let B=r.getGraphemeBreakType(h.nextCodePoint());for(;!h.eol();){const s1=h.offset,b1=r.getGraphemeBreakType(h.nextCodePoint());if(k1(B,b1)){h.setOffset(s1);break}B=b1}return h.offset-b}prevGraphemeLength(){const r=D1.getInstance(),h=this._iterator,b=h.offset;let B=r.getGraphemeBreakType(h.prevCodePoint());for(;h.offset>0;){const s1=h.offset,b1=r.getGraphemeBreakType(h.prevCodePoint());if(k1(b1,B)){h.setOffset(s1);break}B=b1}return b-h.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=R1;function v1(i,r){return new R1(i,r).nextGraphemeLength()}function y1(i,r){return new R1(i,r).prevGraphemeLength()}function G1(i,r){r>0&&t1(i.charCodeAt(r))&&r--;const h=r+v1(i,r);return[h-y1(i,h),h]}function q1(i){const r=new R1(i);let h=0;for(;!r.eol();)h++,r.nextGraphemeLength();return h}let I1;function N1(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function u(i){return I1||(I1=N1()),I1.test(i)}const c=/^[\t\n\r\x20-\x7E]*$/;function l(i){return c.test(i)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function E(i){return t.UNUSUAL_LINE_TERMINATORS.test(i)}function U(i){return i>=11904&&i<=55215||i>=63744&&i<=64255||i>=65281&&i<=65374}function J(i){return i>=127462&&i<=127487||i===8986||i===8987||i===9200||i===9203||i>=9728&&i<=10175||i===11088||i===11093||i>=127744&&i<=128591||i>=128640&&i<=128764||i>=128992&&i<=129008||i>=129280&&i<=129535||i>=129648&&i<=129782}function r1(i,r,h=""){const b=i.trimStart();if(b.length<r)return b;const B=/\b/g;let s1=0;for(;B.test(b)&&!(b.length-B.lastIndex<r);)s1=B.lastIndex,B.lastIndex+=1;return s1===0?b:h+b.substring(s1).trimStart()}const g1=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*E1(i){let r=0;for(const h of i.matchAll(g1))r!==h.index&&(yield{isCode:!1,str:i.substring(r,h.index)}),yield{isCode:!0,str:h[0]},r=h.index+h[0].length;r!==i.length&&(yield{isCode:!1,str:i.substring(r)})}function A1(i){return i&&(i=i.replace(g1,"")),i}const y=/\\\[.*?\\\]/g;function R(i){return A1(i).replace(y,"")}t.UTF8_BOM_CHARACTER=String.fromCharCode(e.CharCode.UTF8_BOM);function G(i){return!!(i&&i.length>0&&i.charCodeAt(0)===e.CharCode.UTF8_BOM)}function k(i){return G(i)?i.substr(1):i}function V(i,r){if(!i||!r||i.length<r.length)return!1;const h=r.length,b=i.toLowerCase();let B=0,s1=-1;for(;B<h;){const b1=b.indexOf(r[B],s1+1);if(b1<0)return!1;s1=b1,B++}return!0}function i1(i,r=!1){return i?(r&&(i=i.replace(/\\./g,"")),i.toLowerCase()!==i):!1}function u1(i){return i.charAt(0).toUpperCase()+i.slice(1)}function m1(i,r=1){if(r===0)return"";let h=-1;do h=i.indexOf(`
`,h+1),r--;while(r>0&&h>=0);return h===-1?i:(i[h-1]==="\r"&&h--,i.substr(0,h))}function L1(i){const r=e.CharCode.Z-e.CharCode.A+1;return i=i%(2*r),i<r?String.fromCharCode(e.CharCode.a+i):String.fromCharCode(e.CharCode.A+i-r)}function F1(i){return D1.getInstance().getGraphemeBreakType(i)}function k1(i,r){return i===e1.Other?r!==e1.Extend&&r!==e1.SpacingMark:i===e1.CR&&r===e1.LF?!1:i===e1.Control||i===e1.CR||i===e1.LF||r===e1.Control||r===e1.CR||r===e1.LF?!0:!(i===e1.L&&(r===e1.L||r===e1.V||r===e1.LV||r===e1.LVT)||(i===e1.LV||i===e1.V)&&(r===e1.V||r===e1.T)||(i===e1.LVT||i===e1.T)&&r===e1.T||r===e1.Extend||r===e1.ZWJ||r===e1.SpacingMark||i===e1.Prepend||i===e1.ZWJ&&r===e1.Extended_Pictographic||i===e1.Regional_Indicator&&r===e1.Regional_Indicator)}var e1;(function(i){i[i.Other=0]="Other",i[i.Prepend=1]="Prepend",i[i.CR=2]="CR",i[i.LF=3]="LF",i[i.Control=4]="Control",i[i.Extend=5]="Extend",i[i.Regional_Indicator=6]="Regional_Indicator",i[i.SpacingMark=7]="SpacingMark",i[i.L=8]="L",i[i.V=9]="V",i[i.T=10]="T",i[i.LV=11]="LV",i[i.LVT=12]="LVT",i[i.ZWJ=13]="ZWJ",i[i.Extended_Pictographic=14]="Extended_Pictographic"})(e1||(t.GraphemeBreakType=e1={}));class D1{static{this._INSTANCE=null}static getInstance(){return D1._INSTANCE||(D1._INSTANCE=new D1),D1._INSTANCE}constructor(){this._data=P1()}getGraphemeBreakType(r){if(r<32)return r===e.CharCode.LineFeed?e1.LF:r===e.CharCode.CarriageReturn?e1.CR:e1.Control;if(r<127)return e1.Other;const h=this._data,b=h.length/3;let B=1;for(;B<=b;)if(r<h[3*B])B=2*B;else if(r>h[3*B+1])B=2*B+1;else return h[3*B+2];return e1.Other}}function P1(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function z1(i,r){if(i===0)return 0;const h=j1(i,r);if(h!==void 0)return h;const b=new U1(r,i);return b.prevCodePoint(),b.offset}function j1(i,r){const h=new U1(r,i);let b=h.prevCodePoint();for(;$1(b)||b===H1.emojiVariantSelector||b===H1.enclosingKeyCap;){if(h.offset===0)return;b=h.prevCodePoint()}if(!J(b))return;let B=h.offset;return B>0&&h.prevCodePoint()===H1.zwj&&(B=h.offset),B}function $1(i){return 127995<=i&&i<=127999}var H1;(function(i){i[i.zwj=8205]="zwj",i[i.emojiVariantSelector=65039]="emojiVariantSelector",i[i.enclosingKeyCap=8419]="enclosingKeyCap"})(H1||(H1={})),t.noBreakWhitespace="\xA0";class B1{static{this.ambiguousCharacterData=new q.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new A.LRUCachedFunction({getCacheKey:JSON.stringify},r=>{function h(p1){const S1=new Map;for(let T1=0;T1<p1.length;T1+=2)S1.set(p1[T1],p1[T1+1]);return S1}function b(p1,S1){const T1=new Map(p1);for(const[K1,V1]of S1)T1.set(K1,V1);return T1}function B(p1,S1){if(!p1)return S1;const T1=new Map;for(const[K1,V1]of p1)S1.has(K1)&&T1.set(K1,V1);return T1}const s1=this.ambiguousCharacterData.value;let b1=r.filter(p1=>!p1.startsWith("_")&&p1 in s1);b1.length===0&&(b1=["_default"]);let M1;for(const p1 of b1){const S1=h(s1[p1]);M1=B(M1,S1)}const w1=h(s1._common),O1=b(w1,M1);return new B1(O1)})}static getInstance(r){return B1.cache.get(Array.from(r))}static{this._locales=new q.Lazy(()=>Object.keys(B1.ambiguousCharacterData.value).filter(r=>!r.startsWith("_")))}static getLocales(){return B1._locales.value}constructor(r){this.confusableDictionary=r}isAmbiguous(r){return this.confusableDictionary.has(r)}containsAmbiguousCharacter(r){for(let h=0;h<r.length;h++){const b=r.codePointAt(h);if(typeof b=="number"&&this.isAmbiguous(b))return!0}return!1}getPrimaryConfusable(r){return this.confusableDictionary.get(r)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=B1;class W1{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(W1.getRawData())),this._data}static isInvisibleCharacter(r){return W1.getData().has(r)}static containsInvisibleCharacter(r){for(let h=0;h<r.length;h++){const b=r.codePointAt(h);if(typeof b=="number"&&W1.isInvisibleCharacter(b))return!0}return!1}static get codePoints(){return W1.getData()}}t.InvisibleCharacters=W1}),define(f1[21],h1([23,24]),function(a1,t){return a1.create("vs/base/common/platform",t)}),define(f1[22],h1([0,1,21]),function(a1,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=o,t.isLittleEndian=d1,t.isBigSurOrNewer=_1,t.LANGUAGE_DEFAULT="en";let e=!1,q=!1,L=!1,X=!1,H=!1,p=!1,D=!1,P=!1,K=!1,Y=!1,o1,c1=t.LANGUAGE_DEFAULT,F=t.LANGUAGE_DEFAULT,j,M;const d=globalThis;let m;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?m=d.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(m=process);const O=typeof m?.versions?.electron=="string",s=O&&m?.type==="renderer";if(typeof m=="object"){e=m.platform==="win32",q=m.platform==="darwin",L=m.platform==="linux",X=L&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,D=O,K=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,o1=t.LANGUAGE_DEFAULT,c1=t.LANGUAGE_DEFAULT;const z=m.env.VSCODE_NLS_CONFIG;if(z)try{const S=JSON.parse(z),f=S.availableLanguages["*"];o1=S.locale,F=S.osLocale,c1=f||t.LANGUAGE_DEFAULT,j=S._translationsConfigFile}catch{}H=!0}else typeof navigator=="object"&&!s?(M=navigator.userAgent,e=M.indexOf("Windows")>=0,q=M.indexOf("Macintosh")>=0,P=(M.indexOf("Macintosh")>=0||M.indexOf("iPad")>=0||M.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=M.indexOf("Linux")>=0,Y=M?.indexOf("Mobi")>=0,p=!0,o1=A.getConfiguredDefaultLocale(A.localize(0,null))||t.LANGUAGE_DEFAULT,c1=o1,F=navigator.language):console.error("Unable to resolve platform.");var n;(function(z){z[z.Web=0]="Web",z[z.Mac=1]="Mac",z[z.Linux=2]="Linux",z[z.Windows=3]="Windows"})(n||(t.Platform=n={}));function o(z){switch(z){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let _=n.Web;q?_=n.Mac:e?_=n.Windows:L&&(_=n.Linux),t.isWindows=e,t.isMacintosh=q,t.isLinux=L,t.isLinuxSnap=X,t.isNative=H,t.isElectron=D,t.isWeb=p,t.isWebWorker=p&&typeof d.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?d.origin:void 0,t.isIOS=P,t.isMobile=Y,t.isCI=K,t.platform=_,t.userAgent=M,t.language=c1;var a;(function(z){function S(){return t.language}z.value=S;function f(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}z.isDefaultVariant=f;function w(){return t.language==="en"}z.isDefault=w})(a||(t.Language=a={})),t.locale=o1,t.platformLocale=F,t.translationsConfigFile=j,t.setTimeout0IsFaster=typeof d.postMessage=="function"&&!d.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const z=[];d.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let w=0,W=z.length;w<W;w++){const v=z[w];if(v.id===f.data.vscodeScheduleAsyncWork){z.splice(w,1),v.callback();return}}});let S=0;return f=>{const w=++S;z.push({id:w,callback:f}),d.postMessage({vscodeScheduleAsyncWork:w},"*")}}return z=>setTimeout(z)})();var I;(function(z){z[z.Windows=1]="Windows",z[z.Macintosh=2]="Macintosh",z[z.Linux=3]="Linux"})(I||(t.OperatingSystem=I={})),t.OS=q||P?I.Macintosh:e?I.Windows:I.Linux;let T=!0,Z=!1;function d1(){if(!Z){Z=!0;const z=new Uint8Array(2);z[0]=1,z[1]=2,T=new Uint16Array(z.buffer)[0]===513}return T}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function _1(z){return parseFloat(z)>=20}}),define(f1[25],h1([0,1,2,5,4,18,22,20]),function(a1,t,A,e,q,L,X,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=P,t.create=o;const p="$initialize";let D=!1;function P(_){X.isWeb&&(D||(D=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(_.message))}var K;(function(_){_[_.Request=0]="Request",_[_.Reply=1]="Reply",_[_.SubscribeEvent=2]="SubscribeEvent",_[_.Event=3]="Event",_[_.UnsubscribeEvent=4]="UnsubscribeEvent"})(K||(K={}));class Y{constructor(a,I,T,Z){this.vsWorker=a,this.req=I,this.method=T,this.args=Z,this.type=K.Request}}class o1{constructor(a,I,T,Z){this.vsWorker=a,this.seq=I,this.res=T,this.err=Z,this.type=K.Reply}}class c1{constructor(a,I,T,Z){this.vsWorker=a,this.req=I,this.eventName=T,this.arg=Z,this.type=K.SubscribeEvent}}class F{constructor(a,I,T){this.vsWorker=a,this.req=I,this.event=T,this.type=K.Event}}class j{constructor(a,I){this.vsWorker=a,this.req=I,this.type=K.UnsubscribeEvent}}class M{constructor(a){this._workerId=-1,this._handler=a,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(a){this._workerId=a}sendMessage(a,I){const T=String(++this._lastSentReq);return new Promise((Z,d1)=>{this._pendingReplies[T]={resolve:Z,reject:d1},this._send(new Y(this._workerId,T,a,I))})}listen(a,I){let T=null;const Z=new e.Emitter({onWillAddFirstListener:()=>{T=String(++this._lastSentReq),this._pendingEmitters.set(T,Z),this._send(new c1(this._workerId,T,a,I))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(T),this._send(new j(this._workerId,T)),T=null}});return Z.event}handleMessage(a){!a||!a.vsWorker||this._workerId!==-1&&a.vsWorker!==this._workerId||this._handleMessage(a)}_handleMessage(a){switch(a.type){case K.Reply:return this._handleReplyMessage(a);case K.Request:return this._handleRequestMessage(a);case K.SubscribeEvent:return this._handleSubscribeEventMessage(a);case K.Event:return this._handleEventMessage(a);case K.UnsubscribeEvent:return this._handleUnsubscribeEventMessage(a)}}_handleReplyMessage(a){if(!this._pendingReplies[a.seq]){console.warn("Got reply to unknown seq");return}const I=this._pendingReplies[a.seq];if(delete this._pendingReplies[a.seq],a.err){let T=a.err;a.err.$isError&&(T=new Error,T.name=a.err.name,T.message=a.err.message,T.stack=a.err.stack),I.reject(T);return}I.resolve(a.res)}_handleRequestMessage(a){const I=a.req;this._handler.handleMessage(a.method,a.args).then(Z=>{this._send(new o1(this._workerId,I,Z,void 0))},Z=>{Z.detail instanceof Error&&(Z.detail=(0,A.transformErrorForSerialization)(Z.detail)),this._send(new o1(this._workerId,I,void 0,(0,A.transformErrorForSerialization)(Z)))})}_handleSubscribeEventMessage(a){const I=a.req,T=this._handler.handleEvent(a.eventName,a.arg)(Z=>{this._send(new F(this._workerId,I,Z))});this._pendingEvents.set(I,T)}_handleEventMessage(a){if(!this._pendingEmitters.has(a.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(a.req).fire(a.event)}_handleUnsubscribeEventMessage(a){if(!this._pendingEvents.has(a.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(a.req).dispose(),this._pendingEvents.delete(a.req)}_send(a){const I=[];if(a.type===K.Request)for(let T=0;T<a.args.length;T++)a.args[T]instanceof ArrayBuffer&&I.push(a.args[T]);else a.type===K.Reply&&a.res instanceof ArrayBuffer&&I.push(a.res);this._handler.sendMessage(a,I)}}class d extends q.Disposable{constructor(a,I,T){super();let Z=null;this._worker=this._register(a.create("vs/base/common/worker/simpleWorker",w=>{this._protocol.handleMessage(w)},w=>{Z?.(w)})),this._protocol=new M({sendMessage:(w,W)=>{this._worker.postMessage(w,W)},handleMessage:(w,W)=>{if(typeof T[w]!="function")return Promise.reject(new Error("Missing method "+w+" on main thread host."));try{return Promise.resolve(T[w].apply(T,W))}catch(v){return Promise.reject(v)}},handleEvent:(w,W)=>{if(O(w)){const v=T[w].call(T,W);if(typeof v!="function")throw new Error(`Missing dynamic event ${w} on main thread host.`);return v}if(m(w)){const v=T[w];if(typeof v!="function")throw new Error(`Missing event ${w} on main thread host.`);return v}throw new Error(`Malformed event name ${w}`)}}),this._protocol.setWorkerId(this._worker.getId());let d1=null;const _1=globalThis.require;typeof _1<"u"&&typeof _1.getConfig=="function"?d1=_1.getConfig():typeof globalThis.requirejs<"u"&&(d1=globalThis.requirejs.s.contexts._.config);const z=(0,L.getAllMethodNames)(T);this._onModuleLoaded=this._protocol.sendMessage(p,[this._worker.getId(),JSON.parse(JSON.stringify(d1)),I,z]);const S=(w,W)=>this._request(w,W),f=(w,W)=>this._protocol.listen(w,W);this._lazyProxy=new Promise((w,W)=>{Z=W,this._onModuleLoaded.then(v=>{w(s(v,S,f))},v=>{W(v),this._onError("Worker failed to load "+I,v)})})}getProxyObject(){return this._lazyProxy}_request(a,I){return new Promise((T,Z)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(a,I).then(T,Z)},Z)})}_onError(a,I){console.error(a),console.info(I)}}t.SimpleWorkerClient=d;function m(_){return _[0]==="o"&&_[1]==="n"&&H.isUpperAsciiLetter(_.charCodeAt(2))}function O(_){return/^onDynamic/.test(_)&&H.isUpperAsciiLetter(_.charCodeAt(9))}function s(_,a,I){const T=_1=>function(){const z=Array.prototype.slice.call(arguments,0);return a(_1,z)},Z=_1=>function(z){return I(_1,z)},d1={};for(const _1 of _){if(O(_1)){d1[_1]=Z(_1);continue}if(m(_1)){d1[_1]=I(_1,void 0);continue}d1[_1]=T(_1)}return d1}class n{constructor(a,I){this._requestHandlerFactory=I,this._requestHandler=null,this._protocol=new M({sendMessage:(T,Z)=>{a(T,Z)},handleMessage:(T,Z)=>this._handleMessage(T,Z),handleEvent:(T,Z)=>this._handleEvent(T,Z)})}onmessage(a){this._protocol.handleMessage(a)}_handleMessage(a,I){if(a===p)return this.initialize(I[0],I[1],I[2],I[3]);if(!this._requestHandler||typeof this._requestHandler[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._requestHandler[a].apply(this._requestHandler,I))}catch(T){return Promise.reject(T)}}_handleEvent(a,I){if(!this._requestHandler)throw new Error("Missing requestHandler");if(O(a)){const T=this._requestHandler[a].call(this._requestHandler,I);if(typeof T!="function")throw new Error(`Missing dynamic event ${a} on request handler.`);return T}if(m(a)){const T=this._requestHandler[a];if(typeof T!="function")throw new Error(`Missing event ${a} on request handler.`);return T}throw new Error(`Malformed event name ${a}`)}initialize(a,I,T,Z){this._protocol.setWorkerId(a);const z=s(Z,(S,f)=>this._protocol.sendMessage(S,f),(S,f)=>this._protocol.listen(S,f));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(z),Promise.resolve((0,L.getAllMethodNames)(this._requestHandler))):(I&&(typeof I.baseUrl<"u"&&delete I.baseUrl,typeof I.paths<"u"&&typeof I.paths.vs<"u"&&delete I.paths.vs,typeof I.trustedTypesPolicy<"u"&&delete I.trustedTypesPolicy,I.catchError=!0,globalThis.require.config(I)),new Promise((S,f)=>{(globalThis.require||a1)([T],W=>{if(this._requestHandler=W.create(z),!this._requestHandler){f(new Error("No RequestHandler!"));return}S((0,L.getAllMethodNames)(this._requestHandler))},f)}))}}t.SimpleWorkerServer=n;function o(_){return new n(_,null)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d98c6de73fb939f1eb4b8a500c569b858b2d297/core/vs/base/common/worker/simpleWorker.js.map
