/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/charCode","vs/base/common/errors","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/base/common/arrays","vs/base/common/strings","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uint","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/diff/diff","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/marshallingIds","vs/base/common/cache","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/hash","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(V){for(var i=[],t=0,n=V.length;t<n;t++)i[t]=ie[V[t]];return i};const Xe=this,Ye=typeof global=="object"?global:{};var Ee;(function(V){V.global=Xe;class i{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=i._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof V.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}V.Environment=i})(Ee||(Ee={}));var Ee;(function(V){class i{constructor(g,E,b){this.type=g,this.detail=E,this.timestamp=b}}V.LoaderEvent=i;class t{constructor(g){this._events=[new i(1,"",g)]}record(g,E){this._events.push(new i(g,E,V.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}V.LoaderEventRecorder=t;class n{record(g,E){}getEvents(){return[]}}n.INSTANCE=new n,V.NullLoaderEventRecorder=n})(Ee||(Ee={}));var Ee;(function(V){class i{static fileUriToFilePath(n,M){if(M=decodeURI(M).replace(/%23/g,"#"),n){if(/^file:\/\/\//.test(M))return M.substr(8);if(/^file:\/\//.test(M))return M.substr(5)}else if(/^file:\/\//.test(M))return M.substr(7);return M}static startsWith(n,M){return n.length>=M.length&&n.substr(0,M.length)===M}static endsWith(n,M){return n.length>=M.length&&n.substr(n.length-M.length)===M}static containsQueryString(n){return/^[^\#]*\?/gi.test(n)}static isAbsolutePath(n){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(n)}static forEachProperty(n,M){if(n){let g;for(g in n)n.hasOwnProperty(g)&&M(g,n[g])}}static isEmpty(n){let M=!0;return i.forEachProperty(n,()=>{M=!1}),M}static recursiveClone(n){if(!n||typeof n!="object"||n instanceof RegExp||!Array.isArray(n)&&Object.getPrototypeOf(n)!==Object.prototype)return n;let M=Array.isArray(n)?[]:{};return i.forEachProperty(n,(g,E)=>{E&&typeof E=="object"?M[g]=i.recursiveClone(E):M[g]=E}),M}static generateAnonymousModule(){return"===anonymous"+i.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(n){return i.startsWith(n,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=V.global.performance&&typeof V.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?V.global.performance.now():Date.now()}}i.NEXT_ANONYMOUS_ID=1,i.PERFORMANCE_NOW_PROBED=!1,i.HAS_PERFORMANCE_NOW=!1,V.Utilities=i})(Ee||(Ee={}));var Ee;(function(V){function i(M){if(M instanceof Error)return M;const g=new Error(M.message||String(M)||"Unknown Error");return M.stack&&(g.stack=M.stack),g}V.ensureError=i;class t{static validateConfigurationOptions(g){function E(b){if(b.phase==="loading"){console.error('Loading "'+b.moduleId+'" failed'),console.error(b),console.error("Here are the modules that depend on it:"),console.error(b.neededBy);return}if(b.phase==="factory"){console.error('The factory function of "'+b.moduleId+'" has thrown an exception'),console.error(b),console.error("Here are the modules that depend on it:"),console.error(b.neededBy);return}}if(g=g||{},typeof g.baseUrl!="string"&&(g.baseUrl=""),typeof g.isBuild!="boolean"&&(g.isBuild=!1),typeof g.paths!="object"&&(g.paths={}),typeof g.config!="object"&&(g.config={}),typeof g.catchError>"u"&&(g.catchError=!1),typeof g.recordStats>"u"&&(g.recordStats=!1),typeof g.urlArgs!="string"&&(g.urlArgs=""),typeof g.onError!="function"&&(g.onError=E),Array.isArray(g.ignoreDuplicateModules)||(g.ignoreDuplicateModules=[]),g.baseUrl.length>0&&(V.Utilities.endsWith(g.baseUrl,"/")||(g.baseUrl+="/")),typeof g.cspNonce!="string"&&(g.cspNonce=""),typeof g.preferScriptTags>"u"&&(g.preferScriptTags=!1),g.nodeCachedData&&typeof g.nodeCachedData=="object"&&(typeof g.nodeCachedData.seed!="string"&&(g.nodeCachedData.seed="seed"),(typeof g.nodeCachedData.writeDelay!="number"||g.nodeCachedData.writeDelay<0)&&(g.nodeCachedData.writeDelay=1e3*7),!g.nodeCachedData.path||typeof g.nodeCachedData.path!="string")){const b=i(new Error("INVALID cached data configuration, 'path' MUST be set"));b.phase="configuration",g.onError(b),g.nodeCachedData=void 0}return g}static mergeConfigurationOptions(g=null,E=null){let b=V.Utilities.recursiveClone(E||{});return V.Utilities.forEachProperty(g,(l,u)=>{l==="ignoreDuplicateModules"&&typeof b.ignoreDuplicateModules<"u"?b.ignoreDuplicateModules=b.ignoreDuplicateModules.concat(u):l==="paths"&&typeof b.paths<"u"?V.Utilities.forEachProperty(u,(f,_)=>b.paths[f]=_):l==="config"&&typeof b.config<"u"?V.Utilities.forEachProperty(u,(f,_)=>b.config[f]=_):b[l]=V.Utilities.recursiveClone(u)}),t.validateConfigurationOptions(b)}}V.ConfigurationOptionsUtil=t;class n{constructor(g,E){if(this._env=g,this.options=t.mergeConfigurationOptions(E),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let b=this.options.nodeRequire.main.filename,l=Math.max(b.lastIndexOf("/"),b.lastIndexOf("\\"));this.options.baseUrl=b.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let g=0;g<this.options.ignoreDuplicateModules.length;g++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[g]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],V.Utilities.forEachProperty(this.options.paths,(g,E)=>{Array.isArray(E)?this.sortedPathsRules.push({from:g,to:E}):this.sortedPathsRules.push({from:g,to:[E]})}),this.sortedPathsRules.sort((g,E)=>E.from.length-g.from.length)}cloneAndMerge(g){return new n(this._env,t.mergeConfigurationOptions(g,this.options))}getOptionsLiteral(){return this.options}_applyPaths(g){let E;for(let b=0,l=this.sortedPathsRules.length;b<l;b++)if(E=this.sortedPathsRules[b],V.Utilities.startsWith(g,E.from)){let u=[];for(let f=0,_=E.to.length;f<_;f++)u.push(E.to[f]+g.substr(E.from.length));return u}return[g]}_addUrlArgsToUrl(g){return V.Utilities.containsQueryString(g)?g+"&"+this.options.urlArgs:g+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(g){return this.options.urlArgs?this._addUrlArgsToUrl(g):g}_addUrlArgsIfNecessaryToUrls(g){if(this.options.urlArgs)for(let E=0,b=g.length;E<b;E++)g[E]=this._addUrlArgsToUrl(g[E]);return g}moduleIdToPaths(g){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(g))return this.isBuild()?["empty:"]:["node|"+g];let E=g,b;if(!V.Utilities.endsWith(E,".js")&&!V.Utilities.isAbsolutePath(E)){b=this._applyPaths(E);for(let l=0,u=b.length;l<u;l++)this.isBuild()&&b[l]==="empty:"||(V.Utilities.isAbsolutePath(b[l])||(b[l]=this.options.baseUrl+b[l]),!V.Utilities.endsWith(b[l],".js")&&!V.Utilities.containsQueryString(b[l])&&(b[l]=b[l]+".js"))}else!V.Utilities.endsWith(E,".js")&&!V.Utilities.containsQueryString(E)&&(E=E+".js"),b=[E];return this._addUrlArgsIfNecessaryToUrls(b)}requireToUrl(g){let E=g;return V.Utilities.isAbsolutePath(E)||(E=this._applyPaths(E)[0],V.Utilities.isAbsolutePath(E)||(E=this.options.baseUrl+E)),this._addUrlArgsIfNecessaryToUrl(E)}isBuild(){return this.options.isBuild}shouldInvokeFactory(g){return!!(!this.options.isBuild||V.Utilities.isAnonymousModule(g)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[g])}isDuplicateMessageIgnoredFor(g){return this.ignoreDuplicateModulesMap.hasOwnProperty(g)}getConfigForModule(g){if(this.options.config)return this.options.config[g]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(g){this.options.onError(g)}}V.Configuration=n})(Ee||(Ee={}));var Ee;(function(V){class i{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,f,_,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new M;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new t:this._scriptLoader=new g(this._env)}else this._env.isNode?this._scriptLoader=new g(this._env):this._scriptLoader=new t;let p={callback:_,errorback:d};if(this._callbackMap.hasOwnProperty(f)){this._callbackMap[f].push(p);return}this._callbackMap[f]=[p],this._scriptLoader.load(u,f,()=>this.triggerCallback(f),e=>this.triggerErrorback(f,e))}triggerCallback(u){let f=this._callbackMap[u];delete this._callbackMap[u];for(let _=0;_<f.length;_++)f[_].callback()}triggerErrorback(u,f){let _=this._callbackMap[u];delete this._callbackMap[u];for(let d=0;d<_.length;d++)_[d].errorback(f)}}class t{attachListeners(u,f,_){let d=()=>{u.removeEventListener("load",p),u.removeEventListener("error",e)},p=m=>{d(),f()},e=m=>{d(),_(m)};u.addEventListener("load",p),u.addEventListener("error",e)}load(u,f,_,d){if(/^node\|/.test(f)){let p=u.getConfig().getOptionsLiteral(),e=E(u.getRecorder(),p.nodeRequire||V.global.nodeRequire),m=f.split("|"),v=null;try{v=e(m[1])}catch(A){d(A);return}u.enqueueDefineAnonymousModule([],()=>v),_()}else{let p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript"),this.attachListeners(p,_,d);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(f=e.createScriptURL(f)),p.setAttribute("src",f);const{cspNonce:m}=u.getConfig().getOptionsLiteral();m&&p.setAttribute("nonce",m),document.getElementsByTagName("head")[0].appendChild(p)}}}function n(l){const{trustedTypesPolicy:u}=l.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class M{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=n(u)),this._cachedCanUseEval}load(u,f,_,d){if(/^node\|/.test(f)){const p=u.getConfig().getOptionsLiteral(),e=E(u.getRecorder(),p.nodeRequire||V.global.nodeRequire),m=f.split("|");let v=null;try{v=e(m[1])}catch(A){d(A);return}u.enqueueDefineAnonymousModule([],function(){return v}),_()}else{const{trustedTypesPolicy:p}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(f).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${f}`,(p?self.eval(p.createScript("",m)):new Function(m)).call(self),_()}).then(void 0,d);return}try{p&&(f=p.createScriptURL(f)),importScripts(f),_()}catch(m){d(m)}}}}class g{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,f){const{nodeCachedData:_}=f.getConfig().getOptionsLiteral();if(!_||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,p=u("module");function e(m){const v=m.constructor;let A=function(L){try{return m.require(L)}finally{}};return A.resolve=function(L,w){return v._resolveFilename(L,m,!1,w)},A.resolve.paths=function(L){return v._resolveLookupPaths(L,m)},A.main=process.mainModule,A.extensions=v._extensions,A.cache=v._cache,A}p.prototype._compile=function(m,v){const A=p.wrap(m.replace(/^#!.*/,"")),N=f.getRecorder(),L=d._getCachedDataPath(_,v),w={filename:v};let c;try{const S=d._fs.readFileSync(L);c=S.slice(0,16),w.cachedData=S.slice(16),N.record(60,L)}catch{N.record(61,L)}const a=new d._vm.Script(A,w),s=a.runInThisContext(w),o=d._path.dirname(v),h=e(this),D=[this.exports,h,this,v,o,process,Ye,Buffer],R=s.apply(this.exports,D);return d._handleCachedData(a,A,L,!w.cachedData,f),d._verifyCachedData(a,A,L,c,f),R}}load(u,f,_,d){const p=u.getConfig().getOptionsLiteral(),e=E(u.getRecorder(),p.nodeRequire||V.global.nodeRequire),m=p.nodeInstrumenter||function(A){return A};this._init(e),this._initNodeRequire(e,u);let v=u.getRecorder();if(/^node\|/.test(f)){let A=f.split("|"),N=null;try{N=e(A[1])}catch(L){d(L);return}u.enqueueDefineAnonymousModule([],()=>N),_()}else{f=V.Utilities.fileUriToFilePath(this._env.isWindows,f);const A=this._path.normalize(f),N=this._getElectronRendererScriptPathOrUri(A),L=!!p.nodeCachedData,w=L?this._getCachedDataPath(p.nodeCachedData,f):void 0;this._readSourceAndCachedData(A,w,v,(c,a,s,o)=>{if(c){d(c);return}let h;a.charCodeAt(0)===g._BOM?h=g._PREFIX+a.substring(1)+g._SUFFIX:h=g._PREFIX+a+g._SUFFIX,h=m(h,A);const D={filename:N,cachedData:s},R=this._createAndEvalScript(u,h,D,_,d);this._handleCachedData(R,h,w,L&&!s,u),this._verifyCachedData(R,h,w,o,u)})}}_createAndEvalScript(u,f,_,d,p){const e=u.getRecorder();e.record(31,_.filename);const m=new this._vm.Script(f,_),v=m.runInThisContext(_),A=u.getGlobalAMDDefineFunc();let N=!1;const L=function(){return N=!0,A.apply(null,arguments)};return L.amd=A.amd,v.call(V.global,u.getGlobalAMDRequireFunc(),L,_.filename,this._path.dirname(_.filename)),e.record(32,_.filename),N?d():p(new Error(`Didn't receive define call in ${_.filename}!`)),m}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let f=u.match(/^([a-z])\:(.*)/i);return f?`file:///${(f[1].toUpperCase()+":"+f[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,f){const _=this._crypto.createHash("md5").update(f,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(f).replace(/\.js$/,"");return this._path.join(u.path,`${d}-${_}.code`)}_handleCachedData(u,f,_,d,p){u.cachedDataRejected?this._fs.unlink(_,e=>{p.getRecorder().record(62,_),this._createAndWriteCachedData(u,f,_,p),e&&p.getConfig().onError(e)}):d&&this._createAndWriteCachedData(u,f,_,p)}_createAndWriteCachedData(u,f,_,d){let p=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,m=0,v;const A=()=>{setTimeout(()=>{v||(v=this._crypto.createHash("md5").update(f,"utf8").digest());const N=u.createCachedData();if(!(N.length===0||N.length===e||m>=5)){if(N.length<e){A();return}e=N.length,this._fs.writeFile(_,Buffer.concat([v,N]),L=>{L&&d.getConfig().onError(L),d.getRecorder().record(63,_),A()})}},p*Math.pow(4,m++))};A()}_readSourceAndCachedData(u,f,_,d){if(!f)this._fs.readFile(u,{encoding:"utf8"},d);else{let p,e,m,v=2;const A=N=>{N?d(N):--v===0&&d(void 0,p,e,m)};this._fs.readFile(u,{encoding:"utf8"},(N,L)=>{p=L,A(N)}),this._fs.readFile(f,(N,L)=>{!N&&L&&L.length>0?(m=L.slice(0,16),e=L.slice(16),_.record(60,f)):_.record(61,f),A()})}}_verifyCachedData(u,f,_,d,p){d&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(f,"utf8").digest();d.equals(e)||(p.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${_}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(_,m=>{m&&p.getConfig().onError(m)}))},Math.ceil(5e3*(1+Math.random()))))}}g._BOM=65279,g._PREFIX="(function (require, define, __filename, __dirname) { ",g._SUFFIX=`
});`;function E(l,u){if(u.__$__isRecorded)return u;const f=function(d){l.record(33,d);try{return u(d)}finally{l.record(34,d)}};return f.__$__isRecorded=!0,f}V.ensureRecordedNodeRequire=E;function b(l){return new i(l)}V.createScriptLoader=b})(Ee||(Ee={}));var Ee;(function(V){class i{constructor(l){let u=l.lastIndexOf("/");u!==-1?this.fromModulePath=l.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(l){let u=l,f;for(f=/\/\.\//;f.test(u);)u=u.replace(f,"/");for(u=u.replace(/^\.\//g,""),f=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;f.test(u);)u=u.replace(f,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(l){let u=l;return V.Utilities.isAbsolutePath(u)||(V.Utilities.startsWith(u,"./")||V.Utilities.startsWith(u,"../"))&&(u=i._normalizeModuleId(this.fromModulePath+u)),u}}i.ROOT=new i(""),V.ModuleIdResolver=i;class t{constructor(l,u,f,_,d,p){this.id=l,this.strId=u,this.dependencies=f,this._callback=_,this._errorback=d,this.moduleIdResolver=p,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,u){try{return{returnedValue:l.apply(V.global,u),producedError:null}}catch(f){return{returnedValue:null,producedError:f}}}static _invokeFactory(l,u,f,_){return l.shouldInvokeFactory(u)?l.shouldCatchError()?this._safeInvokeFunction(f,_):{returnedValue:f.apply(V.global,_),producedError:null}:{returnedValue:null,producedError:null}}complete(l,u,f,_){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let p=t._invokeFactory(u,this.strId,this._callback,f);d=p.producedError,l.record(22,this.strId),!d&&typeof p.returnedValue<"u"&&(!this.exportsPassedIn||V.Utilities.isEmpty(this.exports))&&(this.exports=p.returnedValue)}else this.exports=this._callback;if(d){let p=V.ensureError(d);p.phase="factory",p.moduleId=this.strId,p.neededBy=_(this.id),this.error=p,u.onError(p)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}V.Module=t;class n{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let u=this._strModuleIdToIntModuleId.get(l);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(l,u),this._intModuleIdToStrModuleId[u]=l),u}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class M{constructor(l){this.id=l}}M.EXPORTS=new M(0),M.MODULE=new M(1),M.REQUIRE=new M(2),V.RegularDependency=M;class g{constructor(l,u,f){this.id=l,this.pluginId=u,this.pluginParam=f}}V.PluginDependency=g;class E{constructor(l,u,f,_,d=0){this._env=l,this._scriptLoader=u,this._loaderAvailableTimestamp=d,this._defineFunc=f,this._requireFunc=_,this._moduleIdProvider=new n,this._config=new V.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new E(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,u){let f=p=>p.replace(/\\/g,"/"),_=f(l),d=u.split(/\n/);for(let p=0;p<d.length;p++){let e=d[p].match(/(.*):(\d+):(\d+)\)?$/);if(e){let m=e[1],v=e[2],A=e[3],N=Math.max(m.lastIndexOf(" ")+1,m.lastIndexOf("(")+1);if(m=m.substr(N),m=f(m),m===_){let L={line:parseInt(v,10),col:parseInt(A,10)};return L.line===1&&(L.col-=53),L}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],u=0;for(let f=0,_=this._modules2.length;f<_;f++){let d=this._modules2[f];if(!d)continue;let p=this._buildInfoPath[d.id]||null,e=this._buildInfoDefineStack[d.id]||null,m=this._buildInfoDependencies[d.id];l[u++]={id:d.strId,path:p,defineLocation:p&&e?E._findRelevantLocationInStack(p,e):null,dependencies:m,shim:null,exports:d.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new V.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=V.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let f=null;this._config.isBuild()&&(f=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:f,dependencies:l,callback:u}}defineModule(l,u,f,_,d,p=new i(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let m=new t(e,l,this._normalizeDependencies(u,p),f,_,p);this._modules2[e]=m,this._config.isBuild()&&(this._buildInfoDefineStack[e]=d,this._buildInfoDependencies[e]=(m.dependencies||[]).map(v=>this._moduleIdProvider.getStrModuleId(v.id))),this._resolve(m)}_normalizeDependency(l,u){if(l==="exports")return M.EXPORTS;if(l==="module")return M.MODULE;if(l==="require")return M.REQUIRE;let f=l.indexOf("!");if(f>=0){let _=u.resolveModule(l.substr(0,f)),d=u.resolveModule(l.substr(f+1)),p=this._moduleIdProvider.getModuleId(_+"!"+d),e=this._moduleIdProvider.getModuleId(_);return new g(p,e,d)}return new M(this._moduleIdProvider.getModuleId(u.resolveModule(l)))}_normalizeDependencies(l,u){let f=[],_=0;for(let d=0,p=l.length;d<p;d++)f[_++]=this._normalizeDependency(l[d],u);return f}_relativeRequire(l,u,f,_){if(typeof u=="string")return this.synchronousRequire(u,l);this.defineModule(V.Utilities.generateAnonymousModule(),u,f,_,null,l)}synchronousRequire(l,u=new i(l)){let f=this._normalizeDependency(l,u),_=this._modules2[f.id];if(!_)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!_.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(_.error)throw _.error;return _.exports}configure(l,u){let f=this._config.shouldRecordStats();u?this._config=new V.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!f&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),u.dependencies,u.callback,null,u.stack)}}_createLoadError(l,u){let f=this._moduleIdProvider.getStrModuleId(l),_=(this._inverseDependencies2[l]||[]).map(p=>this._moduleIdProvider.getStrModuleId(p));const d=V.ensureError(u);return d.phase="loading",d.moduleId=f,d.neededBy=_,d}_onLoadError(l,u){const f=this._createLoadError(l,u);this._modules2[l]||(this._modules2[l]=new t(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let _=[];for(let e=0,m=this._moduleIdProvider.getMaxModuleId();e<m;e++)_[e]=!1;let d=!1,p=[];for(p.push(l),_[l]=!0;p.length>0;){let e=p.shift(),m=this._modules2[e];m&&(d=m.onDependencyError(f)||d);let v=this._inverseDependencies2[e];if(v)for(let A=0,N=v.length;A<N;A++){let L=v[A];_[L]||(p.push(L),_[L]=!0)}}d||this._config.onError(f)}_hasDependencyPath(l,u){let f=this._modules2[l];if(!f)return!1;let _=[];for(let p=0,e=this._moduleIdProvider.getMaxModuleId();p<e;p++)_[p]=!1;let d=[];for(d.push(f),_[l]=!0;d.length>0;){let e=d.shift().dependencies;if(e)for(let m=0,v=e.length;m<v;m++){let A=e[m];if(A.id===u)return!0;let N=this._modules2[A.id];N&&!_[A.id]&&(_[A.id]=!0,d.push(N))}}return!1}_findCyclePath(l,u,f){if(l===u||f===50)return[l];let _=this._modules2[l];if(!_)return null;let d=_.dependencies;if(d)for(let p=0,e=d.length;p<e;p++){let m=this._findCyclePath(d[p].id,u,f+1);if(m!==null)return m.push(l),m}return null}_createRequire(l){let u=(f,_,d)=>this._relativeRequire(l,f,_,d);return u.toUrl=f=>this._config.requireToUrl(l.resolveModule(f)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(f,_=!1)=>{this.configure(f,_)},u.__$__nodeRequire=V.global.nodeRequire,u}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let u=this._moduleIdProvider.getStrModuleId(l),f=this._config.moduleIdToPaths(u),_=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||_.test(u))&&f.push("node|"+u);let d=-1,p=e=>{if(d++,d>=f.length)this._onLoadError(l,e);else{let m=f[d],v=this.getRecorder();if(this._config.isBuild()&&m==="empty:"){this._buildInfoPath[l]=m,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}v.record(10,m),this._scriptLoader.load(this,m,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=m),v.record(11,m),this._onLoad(l)},A=>{v.record(12,m),p(A)})}};p(null)}_loadPluginDependency(l,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let f=_=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],_,null,null)};f.error=_=>{this._config.onError(this._createLoadError(u.id,_))},l.load(u.pluginParam,this._createRequire(i.ROOT),f,this._config.getOptionsLiteral())}_resolve(l){let u=l.dependencies;if(u)for(let f=0,_=u.length;f<_;f++){let d=u[f];if(d===M.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(d===M.MODULE){l.unresolvedDependenciesCount--;continue}if(d===M.REQUIRE){l.unresolvedDependenciesCount--;continue}let p=this._modules2[d.id];if(p&&p.isComplete()){if(p.error){l.onDependencyError(p.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(d.id,l.id,0)||[];e.reverse(),e.push(d.id),console.warn(e.map(m=>this._moduleIdProvider.getStrModuleId(m)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(l.id),d instanceof g){let e=this._modules2[d.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,d);continue}let m=this._inversePluginDependencies2.get(d.pluginId);m||(m=[],this._inversePluginDependencies2.set(d.pluginId,m)),m.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let u=this.getRecorder();if(l.isComplete())return;let f=l.dependencies,_=[];if(f)for(let m=0,v=f.length;m<v;m++){let A=f[m];if(A===M.EXPORTS){_[m]=l.exports;continue}if(A===M.MODULE){_[m]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(A===M.REQUIRE){_[m]=this._createRequire(l.moduleIdResolver);continue}let N=this._modules2[A.id];if(N){_[m]=N.exports;continue}_[m]=null}const d=m=>(this._inverseDependencies2[m]||[]).map(v=>this._moduleIdProvider.getStrModuleId(v));l.complete(u,this._config,_,d);let p=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,p)for(let m=0,v=p.length;m<v;m++){let A=p[m],N=this._modules2[A];N.unresolvedDependenciesCount--,N.unresolvedDependenciesCount===0&&this._onModuleComplete(N)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let m=0,v=e.length;m<v;m++)this._loadPluginDependency(l.exports,e[m])}}}V.ModuleManager=E})(Ee||(Ee={}));var ne,Ee;(function(V){const i=new V.Environment;let t=null;const n=function(b,l,u){typeof b!="string"&&(u=l,l=b,b=null),(typeof l!="object"||!Array.isArray(l))&&(u=l,l=null),l||(l=["require","exports","module"]),b?t.defineModule(b,l,u,null,null):t.enqueueDefineAnonymousModule(l,u)};n.amd={jQuery:!0};const M=function(b,l=!1){t.configure(b,l)},g=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){M(arguments[0]);return}if(typeof arguments[0]=="string")return t.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){t.defineModule(V.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};g.config=M,g.getConfig=function(){return t.getConfig().getOptionsLiteral()},g.reset=function(){t=t.reset()},g.getBuildInfo=function(){return t.getBuildInfo()},g.getStats=function(){return t.getLoaderEvents()},g.define=n;function E(){if(typeof V.global.require<"u"||typeof require<"u"){const b=V.global.require||require;if(typeof b=="function"&&typeof b.resolve=="function"){const l=V.ensureRecordedNodeRequire(t.getRecorder(),b);V.global.nodeRequire=l,g.nodeRequire=l,g.__$__nodeRequire=l}}i.isNode&&!i.isElectronRenderer&&!i.isElectronNodeIntegrationWebWorker?module.exports=g:(i.isElectronRenderer||(V.global.define=n),V.global.require=g)}V.init=E,(typeof V.global.define!="function"||!V.global.define.amd)&&(t=new V.ModuleManager(i,V.createScriptLoader(i),n,g,V.Utilities.getHighPerformanceTimestamp()),typeof V.global.require<"u"&&typeof V.global.require!="function"&&g.config(V.global.require),ne=function(){return n.apply(null,arguments)},ne.amd=n.amd,typeof doNotInitLoader>"u"&&E())})(Ee||(Ee={})),ne(ie[78],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.load=t;function t(b,l,u,f){if(f=f||{},(f["vs/css"]||{}).disabled){u({});return}const d=l.toUrl(b+".css");n(b,d,()=>{u({})},p=>{typeof u.error=="function"&&u.error("Could not find "+d+".")})}function n(b,l,u,f){if(M(b,l)){u();return}g(b,l,u,f)}function M(b,l){const u=window.document.getElementsByTagName("link");for(let f=0,_=u.length;f<_;f++){const d=u[f].getAttribute("data-name"),p=u[f].getAttribute("href");if(d===b||p===l)return!0}return!1}function g(b,l,u,f){const _=document.createElement("link");_.setAttribute("rel","stylesheet"),_.setAttribute("type","text/css"),_.setAttribute("data-name",b),E(b,_,u,f),_.setAttribute("href",l),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(_)}function E(b,l,u,f){const _=()=>{l.removeEventListener("load",d),l.removeEventListener("error",p)},d=e=>{_(),u()},p=e=>{_(),f(e)};l.addEventListener("load",d),l.addEventListener("error",p)}}),ne("vs/nls",["require","exports"],function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localize=f,i.localize2=_,i.getConfiguredDefaultLocale=d,i.setPseudoTranslation=p,i.create=e,i.load=m;let t=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const n="i-default";function M(v,A){let N;return A.length===0?N=v:N=v.replace(/\{(\d+)\}/g,(L,w)=>{const c=w[0],a=A[c];let s=L;return typeof a=="string"?s=a:(typeof a=="number"||typeof a=="boolean"||a===void 0||a===null)&&(s=String(a)),s}),t&&(N="\uFF3B"+N.replace(/[aouei]/g,"$&$&")+"\uFF3D"),N}function g(v,A){let N=v[A];return N||(N=v["*"],N)?N:null}function E(v){return v.charAt(v.length-1)==="/"?v:v+"/"}async function b(v,A,N){const L=E(v)+E(A)+"vscode/"+E(N),w=await fetch(L);if(w.ok)return await w.json();throw new Error(`${w.status} - ${w.statusText}`)}function l(v){return function(A,N){const L=Array.prototype.slice.call(arguments,2);return M(v[A],L)}}function u(v){return(A,N,...L)=>({value:M(v[A],L),original:M(N,L)})}function f(v,A,...N){return M(A,N)}function _(v,A,...N){const L=M(A,N);return{value:L,original:L}}function d(v){}function p(v){t=v}function e(v,A){return{localize:l(A[v]),localize2:u(A[v]),getConfiguredDefaultLocale:A.getConfiguredDefaultLocale??(N=>{})}}function m(v,A,N,L){const w=L["vs/nls"]??{};if(!v||v.length===0)return N({localize:f,localize2:_,getConfiguredDefaultLocale:()=>w.availableLanguages?.["*"]});const c=w.availableLanguages?g(w.availableLanguages,v):null,a=c===null||c===n;let s=".nls";a||(s=s+"."+c);const o=h=>{Array.isArray(h)?(h.localize=l(h),h.localize2=u(h)):(h.localize=l(h[v]),h.localize2=u(h[v])),h.getConfiguredDefaultLocale=()=>w.availableLanguages?.["*"],N(h)};typeof w.loadBundle=="function"?w.loadBundle(v,c,(h,D)=>{h?A([v+".nls"],o):o(D)}):w.translationServiceUrl&&!a?(async()=>{try{const h=await b(w.translationServiceUrl,c,v);return o(h)}catch(h){if(!c.includes("-"))return console.error(h),A([v+".nls"],o);try{const D=c.split("-")[0],R=await b(w.translationServiceUrl,D,v);return w.availableLanguages??={},w.availableLanguages["*"]=D,o(R)}catch(D){return console.error(D),A([v+".nls"],o)}}})():A([v+s],o,h=>{if(s===".nls"){console.error("Failed trying to load default language strings",h);return}console.error(`Failed to load message bundle for language ${c}. Falling back to the default language:`,h),A([v+".nls"],o)})}}),function(){const V=globalThis.MonacoEnvironment,i=V&&V.baseUrl?V.baseUrl:"../../../";function t(f,_){if(V?.createTrustedTypesPolicy)try{return V.createTrustedTypesPolicy(f,_)}catch(d){console.warn(d);return}try{return self.trustedTypes?.createPolicy(f,_)}catch(d){console.warn(d);return}}const n=t("amdLoader",{createScriptURL:f=>f,createScript:(f,..._)=>{const d=_.slice(0,-1).join(","),p=_.pop().toString();return`(function anonymous(${d}) { ${p}
})`}});function M(){try{return(n?globalThis.eval(n.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function g(){return new Promise((f,_)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return f();const d=i+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,globalThis.origin.length)!==globalThis.origin)&&M()){fetch(d).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${d}`,(n?globalThis.eval(n.createScript("",e)):new Function(e)).call(globalThis),f()}).then(void 0,_);return}n?importScripts(n.createScriptURL(d)):importScripts(d),f()})}function E(){require.config({baseUrl:i,catchError:!0,trustedTypesPolicy:n,amdModulesPattern:/^vs\//})}function b(f){g().then(()=>{E(),require([f],function(_){setTimeout(function(){const d=_.create((p,e)=>{globalThis.postMessage(p,e)},null);for(globalThis.onmessage=p=>d.onmessage(p.data,p.ports);u.length>0;){const p=u.shift();d.onmessage(p.data,p.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&E();let l=!0;const u=[];globalThis.onmessage=f=>{if(!l){u.push(f);return}l=!1,b(f.data)}}(),ne(ie[9],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MonotonousArray=void 0,i.findLast=t,i.findLastIdx=n,i.findLastMonotonous=M,i.findLastIdxMonotonous=g,i.findFirstMonotonous=E,i.findFirstIdxMonotonousOrArrLen=b,i.findFirstIdxMonotonous=l,i.findFirstMax=f,i.findLastMax=_,i.findFirstMin=d,i.findMaxIdx=p,i.mapFindFirst=e;function t(m,v){const A=n(m,v);if(A!==-1)return m[A]}function n(m,v,A=m.length-1){for(let N=A;N>=0;N--){const L=m[N];if(v(L))return N}return-1}function M(m,v){const A=g(m,v);return A===-1?void 0:m[A]}function g(m,v,A=0,N=m.length){let L=A,w=N;for(;L<w;){const c=Math.floor((L+w)/2);v(m[c])?L=c+1:w=c}return L-1}function E(m,v){const A=b(m,v);return A===m.length?void 0:m[A]}function b(m,v,A=0,N=m.length){let L=A,w=N;for(;L<w;){const c=Math.floor((L+w)/2);v(m[c])?w=c:L=c+1}return L}function l(m,v,A=0,N=m.length){const L=b(m,v,A,N);return L===m.length?-1:L}class u{static{this.assertInvariants=!1}constructor(v){this._array=v,this._findLastMonotonousLastIdx=0}findLastMonotonous(v){if(u.assertInvariants){if(this._prevFindLastPredicate){for(const N of this._array)if(this._prevFindLastPredicate(N)&&!v(N))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=v}const A=g(this._array,v,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=A+1,A===-1?void 0:this._array[A]}}i.MonotonousArray=u;function f(m,v){if(m.length===0)return;let A=m[0];for(let N=1;N<m.length;N++){const L=m[N];v(L,A)>0&&(A=L)}return A}function _(m,v){if(m.length===0)return;let A=m[0];for(let N=1;N<m.length;N++){const L=m[N];v(L,A)>=0&&(A=L)}return A}function d(m,v){return f(m,(A,N)=>-v(A,N))}function p(m,v){if(m.length===0)return-1;let A=0;for(let N=1;N<m.length;N++){const L=m[N];v(L,m[A])>0&&(A=N)}return A}function e(m,v){for(const A of m){const N=v(A);if(N!==void 0)return N}}}),ne(ie[3],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharCode=void 0;var t;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(i.CharCode=t={}))}),ne(ie[37],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.groupBy=t,i.diffSets=n,i.diffMaps=M,i.intersection=g;function t(E,b){const l=Object.create(null);for(const u of E){const f=b(u);let _=l[f];_||(_=l[f]=[]),_.push(u)}return l}function n(E,b){const l=[],u=[];for(const f of E)b.has(f)||l.push(f);for(const f of b)E.has(f)||u.push(f);return{removed:l,added:u}}function M(E,b){const l=[],u=[];for(const[f,_]of E)b.has(f)||l.push(_);for(const[f,_]of b)E.has(f)||u.push(_);return{removed:l,added:u}}function g(E,b){const l=new Set;for(const u of b)E.has(u)&&l.add(u);return l}}),ne(ie[38],re([0,1,3]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Color=i.HSVA=i.HSLA=i.RGBA=void 0;function n(l,u){const f=Math.pow(10,u);return Math.round(l*f)/f}class M{constructor(u,f,_,d=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,_))|0,this.a=n(Math.max(Math.min(1,d),0),3)}static equals(u,f){return u.r===f.r&&u.g===f.g&&u.b===f.b&&u.a===f.a}}i.RGBA=M;class g{constructor(u,f,_,d){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,f),0),3),this.l=n(Math.max(Math.min(1,_),0),3),this.a=n(Math.max(Math.min(1,d),0),3)}static equals(u,f){return u.h===f.h&&u.s===f.s&&u.l===f.l&&u.a===f.a}static fromRGBA(u){const f=u.r/255,_=u.g/255,d=u.b/255,p=u.a,e=Math.max(f,_,d),m=Math.min(f,_,d);let v=0,A=0;const N=(m+e)/2,L=e-m;if(L>0){switch(A=Math.min(N<=.5?L/(2*N):L/(2-2*N),1),e){case f:v=(_-d)/L+(_<d?6:0);break;case _:v=(d-f)/L+2;break;case d:v=(f-_)/L+4;break}v*=60,v=Math.round(v)}return new g(v,A,N,p)}static _hue2rgb(u,f,_){return _<0&&(_+=1),_>1&&(_-=1),_<1/6?u+(f-u)*6*_:_<1/2?f:_<2/3?u+(f-u)*(2/3-_)*6:u}static toRGBA(u){const f=u.h/360,{s:_,l:d,a:p}=u;let e,m,v;if(_===0)e=m=v=d;else{const A=d<.5?d*(1+_):d+_-d*_,N=2*d-A;e=g._hue2rgb(N,A,f+1/3),m=g._hue2rgb(N,A,f),v=g._hue2rgb(N,A,f-1/3)}return new M(Math.round(e*255),Math.round(m*255),Math.round(v*255),p)}}i.HSLA=g;class E{constructor(u,f,_,d){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,f),0),3),this.v=n(Math.max(Math.min(1,_),0),3),this.a=n(Math.max(Math.min(1,d),0),3)}static equals(u,f){return u.h===f.h&&u.s===f.s&&u.v===f.v&&u.a===f.a}static fromRGBA(u){const f=u.r/255,_=u.g/255,d=u.b/255,p=Math.max(f,_,d),e=Math.min(f,_,d),m=p-e,v=p===0?0:m/p;let A;return m===0?A=0:p===f?A=((_-d)/m%6+6)%6:p===_?A=(d-f)/m+2:A=(f-_)/m+4,new E(Math.round(A*60),v,p,u.a)}static toRGBA(u){const{h:f,s:_,v:d,a:p}=u,e=d*_,m=e*(1-Math.abs(f/60%2-1)),v=d-e;let[A,N,L]=[0,0,0];return f<60?(A=e,N=m):f<120?(A=m,N=e):f<180?(N=e,L=m):f<240?(N=m,L=e):f<300?(A=m,L=e):f<=360&&(A=e,L=m),A=Math.round((A+v)*255),N=Math.round((N+v)*255),L=Math.round((L+v)*255),new M(A,N,L,p)}}i.HSVA=E;class b{static fromHex(u){return b.Format.CSS.parseHex(u)||b.red}static equals(u,f){return!u&&!f?!0:!u||!f?!1:u.equals(f)}get hsla(){return this._hsla?this._hsla:g.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:E.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof M)this.rgba=u;else if(u instanceof g)this._hsla=u,this.rgba=g.toRGBA(u);else if(u instanceof E)this._hsva=u,this.rgba=E.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&M.equals(this.rgba,u.rgba)&&g.equals(this.hsla,u.hsla)&&E.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=b._relativeLuminanceForComponent(this.rgba.r),f=b._relativeLuminanceForComponent(this.rgba.g),_=b._relativeLuminanceForComponent(this.rgba.b),d=.2126*u+.7152*f+.0722*_;return n(d,4)}static _relativeLuminanceForComponent(u){const f=u/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(u){const f=this.getRelativeLuminance(),_=u.getRelativeLuminance();return f>_?(f+.05)/(_+.05):(_+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const f=this.getRelativeLuminance(),_=u.getRelativeLuminance();return f>_}isDarkerThan(u){const f=this.getRelativeLuminance(),_=u.getRelativeLuminance();return f<_}lighten(u){return new b(new g(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new b(new g(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:f,g:_,b:d,a:p}=this.rgba;return new b(new M(f,_,d,p*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new b(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const f=u.rgba,_=this.rgba.a,d=f.a,p=_+d*(1-_);if(p<1e-6)return b.transparent;const e=this.rgba.r*_/p+f.r*d*(1-_)/p,m=this.rgba.g*_/p+f.g*d*(1-_)/p,v=this.rgba.b*_/p+f.b*d*(1-_)/p;return new b(new M(e,m,v,p))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:f,g:_,b:d,a:p}=this.rgba;return new b(new M(u.rgba.r-p*(u.rgba.r-f),u.rgba.g-p*(u.rgba.g-_),u.rgba.b-p*(u.rgba.b-d),1))}flatten(...u){const f=u.reduceRight((_,d)=>b._flatten(d,_));return b._flatten(this,f)}static _flatten(u,f){const _=1-u.rgba.a;return new b(new M(_*f.rgba.r+u.rgba.a*u.rgba.r,_*f.rgba.g+u.rgba.a*u.rgba.g,_*f.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=b.Format.CSS.format(this)),this._toString}static getLighterColor(u,f,_){if(u.isLighterThan(f))return u;_=_||.5;const d=u.getRelativeLuminance(),p=f.getRelativeLuminance();return _=_*(p-d)/p,u.lighten(_)}static getDarkerColor(u,f,_){if(u.isDarkerThan(f))return u;_=_||.5;const d=u.getRelativeLuminance(),p=f.getRelativeLuminance();return _=_*(d-p)/d,u.darken(_)}static{this.white=new b(new M(255,255,255,1))}static{this.black=new b(new M(0,0,0,1))}static{this.red=new b(new M(255,0,0,1))}static{this.blue=new b(new M(0,0,255,1))}static{this.green=new b(new M(0,255,0,1))}static{this.cyan=new b(new M(0,255,255,1))}static{this.lightgrey=new b(new M(211,211,211,1))}static{this.transparent=new b(new M(0,0,0,0))}}i.Color=b,function(l){let u;(function(f){let _;(function(d){function p(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:l.Format.CSS.formatRGBA(s)}d.formatRGB=p;function e(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}d.formatRGBA=e;function m(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:l.Format.CSS.formatHSLA(s)}d.formatHSL=m;function v(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}d.formatHSLA=v;function A(s){const o=s.toString(16);return o.length!==2?"0"+o:o}function N(s){return`#${A(s.rgba.r)}${A(s.rgba.g)}${A(s.rgba.b)}`}d.formatHex=N;function L(s,o=!1){return o&&s.rgba.a===1?l.Format.CSS.formatHex(s):`#${A(s.rgba.r)}${A(s.rgba.g)}${A(s.rgba.b)}${A(Math.round(s.rgba.a*255))}`}d.formatHexA=L;function w(s){return s.isOpaque()?l.Format.CSS.formatHex(s):l.Format.CSS.formatRGBA(s)}d.format=w;function c(s){const o=s.length;if(o===0||s.charCodeAt(0)!==t.CharCode.Hash)return null;if(o===7){const h=16*a(s.charCodeAt(1))+a(s.charCodeAt(2)),D=16*a(s.charCodeAt(3))+a(s.charCodeAt(4)),R=16*a(s.charCodeAt(5))+a(s.charCodeAt(6));return new l(new M(h,D,R,1))}if(o===9){const h=16*a(s.charCodeAt(1))+a(s.charCodeAt(2)),D=16*a(s.charCodeAt(3))+a(s.charCodeAt(4)),R=16*a(s.charCodeAt(5))+a(s.charCodeAt(6)),S=16*a(s.charCodeAt(7))+a(s.charCodeAt(8));return new l(new M(h,D,R,S/255))}if(o===4){const h=a(s.charCodeAt(1)),D=a(s.charCodeAt(2)),R=a(s.charCodeAt(3));return new l(new M(16*h+h,16*D+D,16*R+R))}if(o===5){const h=a(s.charCodeAt(1)),D=a(s.charCodeAt(2)),R=a(s.charCodeAt(3)),S=a(s.charCodeAt(4));return new l(new M(16*h+h,16*D+D,16*R+R,(16*S+S)/255))}return null}d.parseHex=c;function a(s){switch(s){case t.CharCode.Digit0:return 0;case t.CharCode.Digit1:return 1;case t.CharCode.Digit2:return 2;case t.CharCode.Digit3:return 3;case t.CharCode.Digit4:return 4;case t.CharCode.Digit5:return 5;case t.CharCode.Digit6:return 6;case t.CharCode.Digit7:return 7;case t.CharCode.Digit8:return 8;case t.CharCode.Digit9:return 9;case t.CharCode.a:return 10;case t.CharCode.A:return 10;case t.CharCode.b:return 11;case t.CharCode.B:return 11;case t.CharCode.c:return 12;case t.CharCode.C:return 12;case t.CharCode.d:return 13;case t.CharCode.D:return 13;case t.CharCode.e:return 14;case t.CharCode.E:return 14;case t.CharCode.f:return 15;case t.CharCode.F:return 15}return 0}})(_=f.CSS||(f.CSS={}))})(u=l.Format||(l.Format={}))}(b||(i.Color=b={}))}),ne(ie[39],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiffChange=void 0;class t{constructor(M,g,E,b){this.originalStart=M,this.originalLength=g,this.modifiedStart=E,this.modifiedLength=b}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}i.DiffChange=t}),ne(ie[4],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.BugIndicatingError=i.ErrorNoTelemetry=i.ExpectedError=i.NotSupportedError=i.NotImplementedError=i.ReadonlyError=i.CancellationError=i.errorHandler=i.ErrorHandler=void 0,i.setUnexpectedErrorHandler=n,i.isSigPipeError=M,i.onUnexpectedError=g,i.onUnexpectedExternalError=E,i.transformErrorForSerialization=b,i.isCancellationError=u,i.canceled=_,i.illegalArgument=d,i.illegalState=p,i.getErrorMessage=m;class t{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?L.isErrorNoTelemetry(a)?new L(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(s=>{s(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}i.ErrorHandler=t,i.errorHandler=new t;function n(c){i.errorHandler.setUnexpectedErrorHandler(c)}function M(c){if(!c||typeof c!="object")return!1;const a=c;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}function g(c){u(c)||i.errorHandler.onUnexpectedError(c)}function E(c){u(c)||i.errorHandler.onUnexpectedExternalError(c)}function b(c){if(c instanceof Error){const{name:a,message:s}=c,o=c.stacktrace||c.stack;return{$isError:!0,name:a,message:s,stack:o,noTelemetry:L.isErrorNoTelemetry(c)}}return c}const l="Canceled";function u(c){return c instanceof f?!0:c instanceof Error&&c.name===l&&c.message===l}class f extends Error{constructor(){super(l),this.name=this.message}}i.CancellationError=f;function _(){const c=new Error(l);return c.name=c.message,c}function d(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}function p(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}class e extends TypeError{constructor(a){super(a?`${a} is read-only and cannot be changed`:"Cannot change read-only property")}}i.ReadonlyError=e;function m(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}class v extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}i.NotImplementedError=v;class A extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}i.NotSupportedError=A;class N extends Error{constructor(){super(...arguments),this.isExpected=!0}}i.ExpectedError=N;class L extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof L)return a;const s=new L;return s.message=a.message,s.stack=a.stack,s}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}i.ErrorNoTelemetry=L;class w extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}i.BugIndicatingError=w}),ne(ie[7],re([0,1,4,9]),function(V,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Permutation=i.CallbackIterable=i.ArrayQueue=i.booleanComparator=i.numberComparator=i.CompareResult=void 0,i.tail=M,i.tail2=g,i.equals=E,i.removeFastWithoutKeepingOrder=b,i.binarySearch=l,i.binarySearch2=u,i.quickSelect=f,i.groupBy=_,i.groupAdjacentBy=d,i.forEachAdjacent=p,i.forEachWithNeighbors=e,i.sortedDiff=m,i.delta=v,i.top=A,i.topAsync=N,i.coalesce=w,i.coalesceInPlace=c,i.move=a,i.isFalsyOrEmpty=s,i.isNonEmptyArray=o,i.distinct=h,i.uniqueFilter=D,i.firstOrDefault=R,i.lastOrDefault=S,i.commonPrefixLength=T,i.range=y,i.index=k,i.insert=O,i.remove=I,i.arrayInsert=U,i.shuffle=$,i.pushToStart=q,i.pushToEnd=x,i.pushMany=X,i.mapArrayOrNot=Y,i.asArray=G,i.getRandomElement=Q,i.insertInto=K,i.splice=F,i.compareBy=oe,i.tieBreakComparators=Le,i.reverseOrder=ke;function M(W,z=0){return W[W.length-(1+z)]}function g(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}function E(W,z,H=(Z,ee)=>Z===ee){if(W===z)return!0;if(!W||!z||W.length!==z.length)return!1;for(let Z=0,ee=W.length;Z<ee;Z++)if(!H(W[Z],z[Z]))return!1;return!0}function b(W,z){const H=W.length-1;z<H&&(W[z]=W[H]),W.pop()}function l(W,z,H){return u(W.length,Z=>H(W[Z],z))}function u(W,z){let H=0,Z=W-1;for(;H<=Z;){const ee=(H+Z)/2|0,he=z(ee);if(he<0)H=ee+1;else if(he>0)Z=ee-1;else return ee}return-(H+1)}function f(W,z,H){if(W=W|0,W>=z.length)throw new TypeError("invalid index");const Z=z[Math.floor(z.length*Math.random())],ee=[],he=[],be=[];for(const pe of z){const we=H(pe,Z);we<0?ee.push(pe):we>0?he.push(pe):be.push(pe)}return W<ee.length?f(W,ee,H):W<ee.length+be.length?be[0]:f(W-(ee.length+be.length),he,H)}function _(W,z){const H=[];let Z;for(const ee of W.slice(0).sort(z))!Z||z(Z[0],ee)!==0?(Z=[ee],H.push(Z)):Z.push(ee);return H}function*d(W,z){let H,Z;for(const ee of W)Z!==void 0&&z(Z,ee)?H.push(ee):(H&&(yield H),H=[ee]),Z=ee;H&&(yield H)}function p(W,z){for(let H=0;H<=W.length;H++)z(H===0?void 0:W[H-1],H===W.length?void 0:W[H])}function e(W,z){for(let H=0;H<W.length;H++)z(H===0?void 0:W[H-1],W[H],H+1===W.length?void 0:W[H+1])}function m(W,z,H){const Z=[];function ee(pe,we,Re){if(we===0&&Re.length===0)return;const se=Z[Z.length-1];se&&se.start+se.deleteCount===pe?(se.deleteCount+=we,se.toInsert.push(...Re)):Z.push({start:pe,deleteCount:we,toInsert:Re})}let he=0,be=0;for(;;){if(he===W.length){ee(he,0,z.slice(be));break}if(be===z.length){ee(he,W.length-he,[]);break}const pe=W[he],we=z[be],Re=H(pe,we);Re===0?(he+=1,be+=1):Re<0?(ee(he,1,[]),he+=1):Re>0&&(ee(he,0,[we]),be+=1)}return Z}function v(W,z,H){const Z=m(W,z,H),ee=[],he=[];for(const be of Z)ee.push(...W.slice(be.start,be.start+be.deleteCount)),he.push(...be.toInsert);return{removed:ee,added:he}}function A(W,z,H){if(H===0)return[];const Z=W.slice(0,H).sort(z);return L(W,z,Z,H,W.length),Z}function N(W,z,H,Z,ee){return H===0?Promise.resolve([]):new Promise((he,be)=>{(async()=>{const pe=W.length,we=W.slice(0,H).sort(z);for(let Re=H,se=Math.min(H+Z,pe);Re<pe;Re=se,se=Math.min(se+Z,pe)){if(Re>H&&await new Promise(te=>setTimeout(te)),ee&&ee.isCancellationRequested)throw new t.CancellationError;L(W,z,we,Re,se)}return we})().then(he,be)})}function L(W,z,H,Z,ee){for(const he=H.length;Z<ee;Z++){const be=W[Z];if(z(be,H[he-1])<0){H.pop();const pe=(0,n.findFirstIdxMonotonousOrArrLen)(H,we=>z(be,we)<0);H.splice(pe,0,be)}}}function w(W){return W.filter(z=>!!z)}function c(W){let z=0;for(let H=0;H<W.length;H++)W[H]&&(W[z]=W[H],z+=1);W.length=z}function a(W,z,H){W.splice(H,0,W.splice(z,1)[0])}function s(W){return!Array.isArray(W)||W.length===0}function o(W){return Array.isArray(W)&&W.length>0}function h(W,z=H=>H){const H=new Set;return W.filter(Z=>{const ee=z(Z);return H.has(ee)?!1:(H.add(ee),!0)})}function D(W){const z=new Set;return H=>{const Z=W(H);return z.has(Z)?!1:(z.add(Z),!0)}}function R(W,z){return W.length>0?W[0]:z}function S(W,z){return W.length>0?W[W.length-1]:z}function T(W,z,H=(Z,ee)=>Z===ee){let Z=0;for(let ee=0,he=Math.min(W.length,z.length);ee<he&&H(W[ee],z[ee]);ee++)Z++;return Z}function y(W,z){let H=typeof z=="number"?W:0;typeof z=="number"?H=W:(H=0,z=W);const Z=[];if(H<=z)for(let ee=H;ee<z;ee++)Z.push(ee);else for(let ee=H;ee>z;ee--)Z.push(ee);return Z}function k(W,z,H){return W.reduce((Z,ee)=>(Z[z(ee)]=H?H(ee):ee,Z),Object.create(null))}function O(W,z){return W.push(z),()=>I(W,z)}function I(W,z){const H=W.indexOf(z);if(H>-1)return W.splice(H,1),z}function U(W,z,H){const Z=W.slice(0,z),ee=W.slice(z);return Z.concat(H,ee)}function $(W,z){let H;if(typeof z=="number"){let Z=z;H=()=>{const ee=Math.sin(Z++)*179426549;return ee-Math.floor(ee)}}else H=Math.random;for(let Z=W.length-1;Z>0;Z-=1){const ee=Math.floor(H()*(Z+1)),he=W[Z];W[Z]=W[ee],W[ee]=he}}function q(W,z){const H=W.indexOf(z);H>-1&&(W.splice(H,1),W.unshift(z))}function x(W,z){const H=W.indexOf(z);H>-1&&(W.splice(H,1),W.push(z))}function X(W,z){for(const H of z)W.push(H)}function Y(W,z){return Array.isArray(W)?W.map(z):z(W)}function G(W){return Array.isArray(W)?W:[W]}function Q(W){return W[Math.floor(Math.random()*W.length)]}function K(W,z,H){const Z=j(W,z),ee=W.length,he=H.length;W.length=ee+he;for(let be=ee-1;be>=Z;be--)W[be+he]=W[be];for(let be=0;be<he;be++)W[be+Z]=H[be]}function F(W,z,H,Z){const ee=j(W,z);let he=W.splice(ee,H);return he===void 0&&(he=[]),K(W,ee,Z),he}function j(W,z){return z<0?Math.max(z+W.length,0):Math.min(z,W.length)}var fe;(function(W){function z(he){return he<0}W.isLessThan=z;function H(he){return he<=0}W.isLessThanOrEqual=H;function Z(he){return he>0}W.isGreaterThan=Z;function ee(he){return he===0}W.isNeitherLessOrGreaterThan=ee,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(fe||(i.CompareResult=fe={}));function oe(W,z){return(H,Z)=>z(W(H),W(Z))}function Le(...W){return(z,H)=>{for(const Z of W){const ee=Z(z,H);if(!fe.isNeitherLessOrGreaterThan(ee))return ee}return fe.neitherLessOrGreaterThan}}const r=(W,z)=>W-z;i.numberComparator=r;const De=(W,z)=>(0,i.numberComparator)(W?1:0,z?1:0);i.booleanComparator=De;function ke(W){return(z,H)=>-W(z,H)}class He{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let H=this.firstIdx;for(;H<this.items.length&&z(this.items[H]);)H++;const Z=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,Z}takeFromEndWhile(z){let H=this.lastIdx;for(;H>=0&&z(this.items[H]);)H--;const Z=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}removeLast(){const z=this.items[this.lastIdx];return this.lastIdx--,z}takeCount(z){const H=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,H}}i.ArrayQueue=He;class Se{static{this.empty=new Se(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(H=>(z(H),!0))}toArray(){const z=[];return this.iterate(H=>(z.push(H),!0)),z}filter(z){return new Se(H=>this.iterate(Z=>z(Z)?H(Z):!0))}map(z){return new Se(H=>this.iterate(Z=>H(z(Z))))}some(z){let H=!1;return this.iterate(Z=>(H=z(Z),!H)),H}findFirst(z){let H;return this.iterate(Z=>z(Z)?(H=Z,!1):!0),H}findLast(z){let H;return this.iterate(Z=>(z(Z)&&(H=Z),!0)),H}findLastMaxBy(z){let H,Z=!0;return this.iterate(ee=>((Z||fe.isGreaterThan(z(ee,H)))&&(Z=!1,H=ee),!0)),H}}i.CallbackIterable=Se;class xe{constructor(z){this._indexMap=z}static createSortPermutation(z,H){const Z=Array.from(z.keys()).sort((ee,he)=>H(z[ee],z[he]));return new xe(Z)}apply(z){return z.map((H,Z)=>z[this._indexMap[Z]])}inverse(){const z=this._indexMap.slice();for(let H=0;H<this._indexMap.length;H++)z[this._indexMap[H]]=H;return new xe(z)}}i.Permutation=xe}),ne(ie[11],re([0,1,4]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=n,i.assertNever=M,i.assert=g,i.softAssert=E,i.assertFn=b,i.checkAdjacentItems=l;function n(u,f){if(!u)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function M(u,f="Unreachable"){throw new Error(f)}function g(u,f="unexpected state"){if(!u)throw new t.BugIndicatingError(`Assertion Failed: ${f}`)}function E(u){u||(0,t.onUnexpectedError)(new t.BugIndicatingError("Soft Assertion Failed"))}function b(u){if(!u()){debugger;u(),(0,t.onUnexpectedError)(new t.BugIndicatingError("Assertion Failed"))}}function l(u,f){let _=0;for(;_<u.length-1;){const d=u[_],p=u[_+1];if(!f(d,p))return!1;_++}return!0}}),ne(ie[22],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createSingleCallFunction=t;function t(n,M){const g=this;let E=!1,b;return function(){if(E)return b;if(E=!0,M)try{b=n.apply(g,arguments)}finally{M()}else b=n.apply(g,arguments);return b}}}),ne(ie[23],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Iterable=void 0;var t;(function(n){function M(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}n.is=M;const g=Object.freeze([]);function E(){return g}n.empty=E;function*b(a){yield a}n.single=b;function l(a){return M(a)?a:b(a)}n.wrap=l;function u(a){return a||g}n.from=u;function*f(a){for(let s=a.length-1;s>=0;s--)yield a[s]}n.reverse=f;function _(a){return!a||a[Symbol.iterator]().next().done===!0}n.isEmpty=_;function d(a){return a[Symbol.iterator]().next().value}n.first=d;function p(a,s){for(const o of a)if(s(o))return!0;return!1}n.some=p;function e(a,s){for(const o of a)if(s(o))return o}n.find=e;function*m(a,s){for(const o of a)s(o)&&(yield o)}n.filter=m;function*v(a,s){let o=0;for(const h of a)yield s(h,o++)}n.map=v;function*A(...a){for(const s of a)yield*s}n.concat=A;function N(a,s,o){let h=o;for(const D of a)h=s(h,D);return h}n.reduce=N;function*L(a,s,o=a.length){for(s<0&&(s+=a.length),o<0?o+=a.length:o>a.length&&(o=a.length);s<o;s++)yield a[s]}n.slice=L;function w(a,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,a];const h=a[Symbol.iterator]();for(let D=0;D<s;D++){const R=h.next();if(R.done)return[o,n.empty()];o.push(R.value)}return[o,{[Symbol.iterator](){return h}}]}n.consume=w;async function c(a){const s=[];for await(const o of a)s.push(o);return Promise.resolve(s)}n.asyncToArray=c})(t||(i.Iterable=t={}))}),ne(ie[40],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyMod=i.KeyCodeUtils=i.IMMUTABLE_KEY_CODE_TO_CODE=i.IMMUTABLE_CODE_TO_KEY_CODE=i.ScanCodeUtils=i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=i.EVENT_KEY_CODE_MAP=i.ScanCode=i.KeyCode=void 0,i.KeyChord=p;var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(t||(i.KeyCode=t={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(i.ScanCode=n={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,v){this._keyCodeToStr[m]=v,this._strToKeyCode[v.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||t.Unknown}}const g=new M,E=new M,b=new M;i.EVENT_KEY_CODE_MAP=new Array(230),i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const l=[],u=Object.create(null),f=Object.create(null);i.ScanCodeUtils={lowerCaseToEnum:e=>f[e]||n.None,toEnum:e=>u[e]||n.None,toString:e=>l[e]||"None"},i.IMMUTABLE_CODE_TO_KEY_CODE=[],i.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=n.MAX_VALUE;e++)i.IMMUTABLE_CODE_TO_KEY_CODE[e]=t.DependsOnKbLayout;for(let e=0;e<=t.MAX_VALUE;e++)i.IMMUTABLE_KEY_CODE_TO_CODE[e]=n.DependsOnKbLayout;(function(){const e="",m=[[1,n.None,"None",t.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",t.Unknown,e,0,e,e,e],[1,n.Super,"Super",t.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",t.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",t.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",t.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",t.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",t.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",t.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",t.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",t.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",t.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",t.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",t.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",t.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",t.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",t.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",t.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",t.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",t.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",t.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",t.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",t.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",t.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",t.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",t.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",t.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",t.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",t.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",t.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",t.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",t.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",t.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",t.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",t.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",t.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",t.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",t.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",t.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",t.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",t.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",t.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",t.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",t.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",t.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",t.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",t.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",t.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",t.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",t.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",t.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",t.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",t.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",t.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",t.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",t.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",t.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",t.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",t.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",t.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",t.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",t.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",t.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",t.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",t.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",t.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",t.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",t.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",t.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",t.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",t.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",t.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",t.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",t.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",t.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",t.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",t.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",t.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",t.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",t.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",t.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",t.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",t.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",t.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",t.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",t.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",t.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",t.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",t.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",t.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",t.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",t.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",t.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",t.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",t.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",t.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",t.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",t.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",t.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",t.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",t.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",t.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",t.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",t.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",t.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",t.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",t.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",t.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",t.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",t.Unknown,e,0,e,e,e],[1,n.F13,"F13",t.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",t.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",t.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",t.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",t.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",t.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",t.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",t.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",t.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",t.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",t.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",t.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",t.Unknown,e,0,e,e,e],[1,n.Help,"Help",t.Unknown,e,0,e,e,e],[1,n.Select,"Select",t.Unknown,e,0,e,e,e],[1,n.Again,"Again",t.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",t.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",t.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",t.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",t.Unknown,e,0,e,e,e],[1,n.Find,"Find",t.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",t.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",t.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",t.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",t.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",t.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",t.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",t.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",t.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",t.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",t.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",t.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",t.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",t.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",t.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",t.Unknown,e,0,e,e,e],[1,n.Props,"Props",t.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",t.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",t.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",t.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",t.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",t.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",t.Unknown,e,0,e,e,e],[1,n.None,e,t.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,t.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,t.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,t.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",t.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",t.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",t.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",t.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",t.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",t.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",t.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",t.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",t.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",t.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",t.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",t.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",t.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",t.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",t.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",t.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",t.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",t.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",t.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",t.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",t.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",t.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",t.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",t.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",t.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",t.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",t.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",t.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",t.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",t.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",t.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",t.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",t.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",t.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",t.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",t.Unknown,e,0,e,e,e],[1,n.None,e,t.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,t.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,t.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,t.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,t.Unknown,e,0,"VK_OEM_CLEAR",e,e]],v=[],A=[];for(const N of m){const[L,w,c,a,s,o,h,D,R]=N;if(A[w]||(A[w]=!0,l[w]=c,u[c]=w,f[c.toLowerCase()]=w,L&&(i.IMMUTABLE_CODE_TO_KEY_CODE[w]=a,a!==t.Unknown&&a!==t.Enter&&a!==t.Ctrl&&a!==t.Shift&&a!==t.Alt&&a!==t.Meta&&(i.IMMUTABLE_KEY_CODE_TO_CODE[a]=w))),!v[a]){if(v[a]=!0,!s)throw new Error(`String representation missing for key code ${a} around scan code ${c}`);g.define(a,s),E.define(a,D||s),b.define(a,R||D||s)}o&&(i.EVENT_KEY_CODE_MAP[o]=a),h&&(i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[h]=a)}i.IMMUTABLE_KEY_CODE_TO_CODE[t.Enter]=n.Enter})();var _;(function(e){function m(c){return g.keyCodeToStr(c)}e.toString=m;function v(c){return g.strToKeyCode(c)}e.fromString=v;function A(c){return E.keyCodeToStr(c)}e.toUserSettingsUS=A;function N(c){return b.keyCodeToStr(c)}e.toUserSettingsGeneral=N;function L(c){return E.strToKeyCode(c)||b.strToKeyCode(c)}e.fromUserSettings=L;function w(c){if(c>=t.Numpad0&&c<=t.NumpadDivide)return null;switch(c){case t.UpArrow:return"Up";case t.DownArrow:return"Down";case t.LeftArrow:return"Left";case t.RightArrow:return"Right"}return g.keyCodeToStr(c)}e.toElectronAccelerator=w})(_||(i.KeyCodeUtils=_={}));var d;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(d||(i.KeyMod=d={}));function p(e,m){const v=(m&65535)<<16>>>0;return(e|v)>>>0}}),ne(ie[41],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Lazy=void 0;class t{constructor(M){this.executor=M,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(M){this._error=M}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}i.Lazy=t}),ne(ie[24],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LinkedList=void 0;class t{static{this.Undefined=new t(void 0)}constructor(g){this.element=g,this.next=t.Undefined,this.prev=t.Undefined}}class n{constructor(){this._first=t.Undefined,this._last=t.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===t.Undefined}clear(){let g=this._first;for(;g!==t.Undefined;){const E=g.next;g.prev=t.Undefined,g.next=t.Undefined,g=E}this._first=t.Undefined,this._last=t.Undefined,this._size=0}unshift(g){return this._insert(g,!1)}push(g){return this._insert(g,!0)}_insert(g,E){const b=new t(g);if(this._first===t.Undefined)this._first=b,this._last=b;else if(E){const u=this._last;this._last=b,b.prev=u,u.next=b}else{const u=this._first;this._first=b,b.next=u,u.prev=b}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(b))}}shift(){if(this._first!==t.Undefined){const g=this._first.element;return this._remove(this._first),g}}pop(){if(this._last!==t.Undefined){const g=this._last.element;return this._remove(this._last),g}}_remove(g){if(g.prev!==t.Undefined&&g.next!==t.Undefined){const E=g.prev;E.next=g.next,g.next.prev=E}else g.prev===t.Undefined&&g.next===t.Undefined?(this._first=t.Undefined,this._last=t.Undefined):g.next===t.Undefined?(this._last=this._last.prev,this._last.next=t.Undefined):g.prev===t.Undefined&&(this._first=this._first.next,this._first.prev=t.Undefined);this._size-=1}*[Symbol.iterator](){let g=this._first;for(;g!==t.Undefined;)yield g.element,g=g.next}}i.LinkedList=n}),ne(ie[16],re([0,1]),function(V,i){"use strict";var t,n,M;Object.defineProperty(i,"__esModule",{value:!0}),i.SetMap=i.BidirectionalMap=i.CounterSet=i.MRUCache=i.LRUCache=i.LinkedMap=i.Touch=i.ResourceSet=i.ResourceMap=void 0,i.getOrSet=g,i.mapToString=E,i.setToString=b,i.mapsStrictEqualIgnoreOrder=w;function g(c,a,s){let o=c.get(a);return o===void 0&&(o=s,c.set(a,o)),o}function E(c){const a=[];return c.forEach((s,o)=>{a.push(`${o} => ${s}`)}),`Map(${c.size}) {${a.join(", ")}}`}function b(c){const a=[];return c.forEach(s=>{a.push(s)}),`Set(${c.size}) {${a.join(", ")}}`}class l{constructor(a,s){this.uri=a,this.value=s}}function u(c){return Array.isArray(c)}class f{static{this.defaultToKey=a=>a.toString()}constructor(a,s){if(this[t]="ResourceMap",a instanceof f)this.map=new Map(a.map),this.toKey=s??f.defaultToKey;else if(u(a)){this.map=new Map,this.toKey=s??f.defaultToKey;for(const[o,h]of a)this.set(o,h)}else this.map=new Map,this.toKey=a??f.defaultToKey}set(a,s){return this.map.set(this.toKey(a),new l(a,s)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,s){typeof s<"u"&&(a=a.bind(s));for(const[o,h]of this.map)a(h.value,h.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}i.ResourceMap=f;class _{constructor(a,s){this[n]="ResourceSet",!a||typeof a=="function"?this._map=new f(a):(this._map=new f(s),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,s){this._map.forEach((o,h)=>a.call(s,h,h,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}i.ResourceSet=_;var d;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(d||(i.Touch=d={}));class p{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,s=d.None){const o=this._map.get(a);if(o)return s!==d.None&&this.touch(o,s),o.value}set(a,s,o=d.None){let h=this._map.get(a);if(h)h.value=s,o!==d.None&&this.touch(h,o);else{switch(h={key:a,value:s,next:void 0,previous:void 0},o){case d.None:this.addItemLast(h);break;case d.AsOld:this.addItemFirst(h);break;case d.AsNew:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(a,h),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const s=this._map.get(a);if(s)return this._map.delete(a),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,s){const o=this._state;let h=this._head;for(;h;){if(s?a.bind(s)(h.value,h.key,this):a(h.value,h.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const a=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(a._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const D={value:o.key,done:!1};return o=o.next,D}else return{value:void 0,done:!0}}};return h}values(){const a=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(a._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const D={value:o.value,done:!1};return o=o.next,D}else return{value:void 0,done:!0}}};return h}entries(){const a=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(a._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const D={value:[o.key,o.value],done:!1};return o=o.next,D}else return{value:void 0,done:!0}}};return h}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>a;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}trimNew(a){if(a>=this.size)return;if(a===0){this.clear();return}let s=this._tail,o=this.size;for(;s&&o>a;)this._map.delete(s.key),s=s.previous,o--;this._tail=s,this._size=o,s&&(s.next=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const s=a.next,o=a.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}a.next=void 0,a.previous=void 0,this._state++}touch(a,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==d.AsOld&&s!==d.AsNew)){if(s===d.AsOld){if(a===this._head)return;const o=a.next,h=a.previous;a===this._tail?(h.next=void 0,this._tail=h):(o.previous=h,h.next=o),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(s===d.AsNew){if(a===this._tail)return;const o=a.next,h=a.previous;a===this._head?(o.previous=void 0,this._head=o):(o.previous=h,h.next=o),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((s,o)=>{a.push([o,s])}),a}fromJSON(a){this.clear();for(const[s,o]of a)this.set(s,o)}}i.LinkedMap=p;class e extends p{constructor(a,s=1){super(),this._limit=a,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,s=d.AsNew){return super.get(a,s)}peek(a){return super.get(a,d.None)}set(a,s){return super.set(a,s,d.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class m extends e{constructor(a,s=1){super(a,s)}trim(a){this.trimOld(a)}set(a,s){return super.set(a,s),this.checkTrim(),this}}i.LRUCache=m;class v extends e{constructor(a,s=1){super(a,s)}trim(a){this.trimNew(a)}set(a,s){return this._limit<=this.size&&!this.has(a)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(a,s),this}}i.MRUCache=v;class A{constructor(){this.map=new Map}add(a){return this.map.set(a,(this.map.get(a)||0)+1),this}delete(a){let s=this.map.get(a)||0;return s===0?!1:(s--,s===0?this.map.delete(a):this.map.set(a,s),!0)}has(a){return this.map.has(a)}}i.CounterSet=A;class N{constructor(a){if(this._m1=new Map,this._m2=new Map,a)for(const[s,o]of a)this.set(s,o)}clear(){this._m1.clear(),this._m2.clear()}set(a,s){this._m1.set(a,s),this._m2.set(s,a)}get(a){return this._m1.get(a)}getKey(a){return this._m2.get(a)}delete(a){const s=this._m1.get(a);return s===void 0?!1:(this._m1.delete(a),this._m2.delete(s),!0)}forEach(a,s){this._m1.forEach((o,h)=>{a.call(s,o,h,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}i.BidirectionalMap=N;class L{constructor(){this.map=new Map}add(a,s){let o=this.map.get(a);o||(o=new Set,this.map.set(a,o)),o.add(s)}delete(a,s){const o=this.map.get(a);o&&(o.delete(s),o.size===0&&this.map.delete(a))}forEach(a,s){const o=this.map.get(a);o&&o.forEach(s)}get(a){const s=this.map.get(a);return s||new Set}}i.SetMap=L;function w(c,a){if(c===a)return!0;if(c.size!==a.size)return!1;for(const[s,o]of c)if(!a.has(s)||a.get(s)!==o)return!1;for(const[s]of a)if(!c.has(s))return!1;return!0}}),ne(ie[12],re([0,1,7,37,16,22,23]),function(V,i,t,n,M,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DisposableMap=i.ImmortalReference=i.AsyncReferenceCollection=i.ReferenceCollection=i.SafeDisposable=i.RefCountedDisposable=i.MandatoryMutableDisposable=i.MutableDisposable=i.Disposable=i.DisposableStore=i.DisposableTracker=void 0,i.setDisposableTracker=f,i.trackDisposable=_,i.markAsDisposed=d,i.markAsSingleton=m,i.isDisposable=v,i.dispose=A,i.disposeIfDisposable=N,i.combinedDisposable=L,i.toDisposable=w,i.disposeOnReturn=y;const b=!1;let l=null;class u{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(I){let U=this.livingDisposables.get(I);return U||(U={parent:null,source:null,isSingleton:!1,value:I,idx:u.idx++},this.livingDisposables.set(I,U)),U}trackDisposable(I){const U=this.getDisposableData(I);U.source||(U.source=new Error().stack)}setParent(I,U){const $=this.getDisposableData(I);$.parent=U}markAsDisposed(I){this.livingDisposables.delete(I)}markAsSingleton(I){this.getDisposableData(I).isSingleton=!0}getRootParent(I,U){const $=U.get(I);if($)return $;const q=I.parent?this.getRootParent(this.getDisposableData(I.parent),U):I;return U.set(I,q),q}getTrackedDisposables(){const I=new Map;return[...this.livingDisposables.entries()].filter(([,$])=>$.source!==null&&!this.getRootParent($,I).isSingleton).flatMap(([$])=>$)}computeLeakingDisposables(I=10,U){let $;if(U)$=U;else{const G=new Map,Q=[...this.livingDisposables.values()].filter(F=>F.source!==null&&!this.getRootParent(F,G).isSingleton);if(Q.length===0)return;const K=new Set(Q.map(F=>F.value));if($=Q.filter(F=>!(F.parent&&K.has(F.parent))),$.length===0)throw new Error("There are cyclic diposable chains!")}if(!$)return;function q(G){function Q(F,j){for(;F.length>0&&j.some(fe=>typeof fe=="string"?fe===F[0]:F[0].match(fe));)F.shift()}const K=G.source.split(`
`).map(F=>F.trim().replace("at ","")).filter(F=>F!=="");return Q(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const x=new M.SetMap;for(const G of $){const Q=q(G);for(let K=0;K<=Q.length;K++)x.add(Q.slice(0,K).join(`
`),G)}$.sort((0,t.compareBy)(G=>G.idx,t.numberComparator));let X="",Y=0;for(const G of $.slice(0,I)){Y++;const Q=q(G),K=[];for(let F=0;F<Q.length;F++){let j=Q[F];j=`(shared with ${x.get(Q.slice(0,F+1).join(`
`)).size}/${$.length} leaks) at ${j}`;const oe=x.get(Q.slice(0,F).join(`
`)),Le=(0,n.groupBy)([...oe].map(r=>q(r)[F]),r=>r);delete Le[Q[F]];for(const[r,De]of Object.entries(Le))K.unshift(`    - stacktraces of ${De.length} other leaks continue with ${r}`);K.unshift(j)}X+=`


==================== Leaking disposable ${Y}/${$.length}: ${G.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return $.length>I&&(X+=`


... and ${$.length-I} more leaking disposables

`),{leaks:$,details:X}}}i.DisposableTracker=u;function f(O){l=O}if(b){const O="__is_disposable_tracked__";f(new class{trackDisposable(I){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[O]||console.log(U)},3e3)}setParent(I,U){if(I&&I!==a.None)try{I[O]=!0}catch{}}markAsDisposed(I){if(I&&I!==a.None)try{I[O]=!0}catch{}}markAsSingleton(I){}})}function _(O){return l?.trackDisposable(O),O}function d(O){l?.markAsDisposed(O)}function p(O,I){l?.setParent(O,I)}function e(O,I){if(l)for(const U of O)l.setParent(U,I)}function m(O){return l?.markAsSingleton(O),O}function v(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function A(O){if(E.Iterable.is(O)){const I=[];for(const U of O)if(U)try{U.dispose()}catch($){I.push($)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function N(O){for(const I of O)v(I)&&I.dispose();return[]}function L(...O){const I=w(()=>A(O));return e(O,I),I}function w(O){const I=_({dispose:(0,g.createSingleCallFunction)(()=>{d(I),O()})});return I}class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{A(this._toDispose)}finally{this._toDispose.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return p(I,this),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(I),I.dispose()}}deleteAndLeak(I){I&&this._toDispose.has(I)&&(this._toDispose.delete(I),p(I,null))}}i.DisposableStore=c;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new c,_(this),p(this._store,this)}dispose(){d(this),this._store.dispose()}_register(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(I)}}i.Disposable=a;class s{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(I){this._isDisposed||I===this._value||(this._value?.dispose(),I&&p(I,this),this._value=I)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const I=this._value;return this._value=void 0,I&&p(I,null),I}}i.MutableDisposable=s;class o{constructor(I){this._disposable=new s,this._isDisposed=!1,this._disposable.value=I}get value(){return this._disposable.value}set value(I){this._isDisposed||I===this._disposable.value||(this._disposable.value=I)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}i.MandatoryMutableDisposable=o;class h{constructor(I){this._disposable=I,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}i.RefCountedDisposable=h;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(I){let U=I;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,d(this))},this}}i.SafeDisposable=D;class R{constructor(){this.references=new Map}acquire(I,...U){let $=this.references.get(I);$||($={counter:0,object:this.createReferencedObject(I,...U)},this.references.set(I,$));const{object:q}=$,x=(0,g.createSingleCallFunction)(()=>{--$.counter===0&&(this.destroyReferencedObject(I,$.object),this.references.delete(I))});return $.counter++,{object:q,dispose:x}}}i.ReferenceCollection=R;class S{constructor(I){this.referenceCollection=I}async acquire(I,...U){const $=this.referenceCollection.acquire(I,...U);try{return{object:await $.object,dispose:()=>$.dispose()}}catch(q){throw $.dispose(),q}}}i.AsyncReferenceCollection=S;class T{constructor(I){this.object=I}dispose(){}}i.ImmortalReference=T;function y(O){const I=new c;try{O(I)}finally{I.dispose()}}class k{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){d(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{A(this._store.values())}finally{this._store.clear()}}has(I){return this._store.has(I)}get size(){return this._store.size}get(I){return this._store.get(I)}set(I,U,$=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),$||this._store.get(I)?.dispose(),this._store.set(I,U)}deleteAndDispose(I){this._store.get(I)?.dispose(),this._store.delete(I)}deleteAndLeak(I){const U=this._store.get(I);return this._store.delete(I),U}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}i.DisposableMap=k}),ne(ie[42],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MarshalledId=void 0;var t;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(i.MarshalledId=t={}))}),ne(ie[25],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StopWatch=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(g){return new n(g)}constructor(g){this._now=t&&g===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}i.StopWatch=n}),ne(ie[13],re([0,1,4,22,12,24,25]),function(V,i,t,n,M,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ValueWithChangeEvent=i.Relay=i.EventBufferer=i.DynamicListEventMultiplexer=i.EventMultiplexer=i.MicrotaskEmitter=i.DebounceEmitter=i.PauseableEmitter=i.AsyncEmitter=i.createEventDeliveryQueue=i.Emitter=i.ListenerRefusalError=i.ListenerLeakError=i.EventProfiling=i.Event=void 0,i.setGlobalLeakWarningThreshold=p;const b=!1,l=!1,u=!1;var f;(function(q){q.None=()=>M.Disposable.None;function x(se){if(u){const{onDidAddListener:te}=se,le=m.create();let ae=0;se.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),te?.()}}}function X(se,te){return r(se,()=>{},0,void 0,!0,void 0,te)}q.defer=X;function Y(se){return(te,le=null,ae)=>{let ce=!1,me;return me=se(_e=>{if(!ce)return me?me.dispose():ce=!0,te.call(le,_e)},null,ae),ce&&me.dispose(),me}}q.once=Y;function G(se,te,le){return oe((ae,ce=null,me)=>se(_e=>ae.call(ce,te(_e)),null,me),le)}q.map=G;function Q(se,te,le){return oe((ae,ce=null,me)=>se(_e=>{te(_e),ae.call(ce,_e)},null,me),le)}q.forEach=Q;function K(se,te,le){return oe((ae,ce=null,me)=>se(_e=>te(_e)&&ae.call(ce,_e),null,me),le)}q.filter=K;function F(se){return se}q.signal=F;function j(...se){return(te,le=null,ae)=>{const ce=(0,M.combinedDisposable)(...se.map(me=>me(_e=>te.call(le,_e))));return Le(ce,ae)}}q.any=j;function fe(se,te,le,ae){let ce=le;return G(se,me=>(ce=te(ce,me),ce),ae)}q.reduce=fe;function oe(se,te){let le;const ae={onWillAddFirstListener(){le=se(ce.fire,ce)},onDidRemoveLastListener(){le?.dispose()}};te||x(ae);const ce=new s(ae);return te?.add(ce),ce.event}function Le(se,te){return te instanceof Array?te.push(se):te&&te.add(se),se}function r(se,te,le=100,ae=!1,ce=!1,me,_e){let ve,Ne,Be,qe=0,ge;const Te={leakWarningThreshold:me,onWillAddFirstListener(){ve=se(Ce=>{qe++,Ne=te(Ne,Ce),ae&&!Be&&(Ue.fire(Ne),Ne=void 0),ge=()=>{const je=Ne;Ne=void 0,Be=void 0,(!ae||qe>1)&&Ue.fire(je),qe=0},typeof le=="number"?(clearTimeout(Be),Be=setTimeout(ge,le)):Be===void 0&&(Be=0,queueMicrotask(ge))})},onWillRemoveListener(){ce&&qe>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,ve.dispose()}};_e||x(Te);const Ue=new s(Te);return _e?.add(Ue),Ue.event}q.debounce=r;function De(se,te=0,le){return q.debounce(se,(ae,ce)=>ae?(ae.push(ce),ae):[ce],te,void 0,!0,void 0,le)}q.accumulate=De;function ke(se,te=(ae,ce)=>ae===ce,le){let ae=!0,ce;return K(se,me=>{const _e=ae||!te(me,ce);return ae=!1,ce=me,_e},le)}q.latch=ke;function He(se,te,le){return[q.filter(se,te,le),q.filter(se,ae=>!te(ae),le)]}q.split=He;function Se(se,te=!1,le=[],ae){let ce=le.slice(),me=se(Ne=>{ce?ce.push(Ne):ve.fire(Ne)});ae&&ae.add(me);const _e=()=>{ce?.forEach(Ne=>ve.fire(Ne)),ce=null},ve=new s({onWillAddFirstListener(){me||(me=se(Ne=>ve.fire(Ne)),ae&&ae.add(me))},onDidAddFirstListener(){ce&&(te?setTimeout(_e):_e())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return ae&&ae.add(ve),ve.event}q.buffer=Se;function xe(se,te){return(ae,ce,me)=>{const _e=te(new z);return se(function(ve){const Ne=_e.evaluate(ve);Ne!==W&&ae.call(ce,Ne)},void 0,me)}}q.chain=xe;const W=Symbol("HaltChainable");class z{constructor(){this.steps=[]}map(te){return this.steps.push(te),this}forEach(te){return this.steps.push(le=>(te(le),le)),this}filter(te){return this.steps.push(le=>te(le)?le:W),this}reduce(te,le){let ae=le;return this.steps.push(ce=>(ae=te(ae,ce),ae)),this}latch(te=(le,ae)=>le===ae){let le=!0,ae;return this.steps.push(ce=>{const me=le||!te(ce,ae);return le=!1,ae=ce,me?ce:W}),this}evaluate(te){for(const le of this.steps)if(te=le(te),te===W)break;return te}}function H(se,te,le=ae=>ae){const ae=(...ve)=>_e.fire(le(...ve)),ce=()=>se.on(te,ae),me=()=>se.removeListener(te,ae),_e=new s({onWillAddFirstListener:ce,onDidRemoveLastListener:me});return _e.event}q.fromNodeEventEmitter=H;function Z(se,te,le=ae=>ae){const ae=(...ve)=>_e.fire(le(...ve)),ce=()=>se.addEventListener(te,ae),me=()=>se.removeEventListener(te,ae),_e=new s({onWillAddFirstListener:ce,onDidRemoveLastListener:me});return _e.event}q.fromDOMEventEmitter=Z;function ee(se){return new Promise(te=>Y(se)(te))}q.toPromise=ee;function he(se){const te=new s;return se.then(le=>{te.fire(le)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}q.fromPromise=he;function be(se,te,le){return te(le),se(ae=>te(ae))}q.runAndSubscribe=be;class pe{constructor(te,le){this._observable=te,this._counter=0,this._hasChanged=!1;const ae={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};le||x(ae),this.emitter=new s(ae),le&&le.add(this.emitter)}beginUpdate(te){this._counter++}handlePossibleChange(te){}handleChange(te,le){this._hasChanged=!0}endUpdate(te){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function we(se,te){return new pe(se,te).emitter.event}q.fromObservable=we;function Re(se){return(te,le,ae)=>{let ce=0,me=!1;const _e={beginUpdate(){ce++},endUpdate(){ce--,ce===0&&(se.reportChanges(),me&&(me=!1,te.call(le)))},handlePossibleChange(){},handleChange(){me=!0}};se.addObserver(_e),se.reportChanges();const ve={dispose(){se.removeObserver(_e)}};return ae instanceof M.DisposableStore?ae.add(ve):Array.isArray(ae)&&ae.push(ve),ve}}q.fromObservableLight=Re})(f||(i.Event=f={}));class _{static{this.all=new Set}static{this._idPool=0}constructor(x){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${x}_${_._idPool++}`,_.all.add(this)}start(x){this._stopWatch=new E.StopWatch,this.listenerCount=x}stop(){if(this._stopWatch){const x=this._stopWatch.elapsed();this.durations.push(x),this.elapsedOverall+=x,this.invocationCount+=1,this._stopWatch=void 0}}}i.EventProfiling=_;let d=-1;function p(q){const x=d;return d=q,{dispose(){d=x}}}class e{constructor(x,X,Y=Math.random().toString(18).slice(2,5)){this._errorHandler=x,this.threshold=X,this.name=Y,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(x,X){const Y=this.threshold;if(Y<=0||X<Y)return;this._stacks||(this._stacks=new Map);const G=this._stacks.get(x.value)||0;if(this._stacks.set(x.value,G+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=Y*.5;const[Q,K]=this.getMostFrequentStack(),F=`[${this.name}] potential listener LEAK detected, having ${X} listeners already. MOST frequent listener (${K}):`;console.warn(F),console.warn(Q);const j=new v(F,Q);this._errorHandler(j)}return()=>{const Q=this._stacks.get(x.value)||0;this._stacks.set(x.value,Q-1)}}getMostFrequentStack(){if(!this._stacks)return;let x,X=0;for(const[Y,G]of this._stacks)(!x||X<G)&&(x=[Y,G],X=G);return x}}class m{static create(){const x=new Error;return new m(x.stack??"")}constructor(x){this.value=x}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(x,X){super(x),this.name="ListenerLeakError",this.stack=X}}i.ListenerLeakError=v;class A extends Error{constructor(x,X){super(x),this.name="ListenerRefusalError",this.stack=X}}i.ListenerRefusalError=A;let N=0;class L{constructor(x){this.value=x,this.id=N++}}const w=2,c=(q,x)=>{if(q instanceof L)x(q);else for(let X=0;X<q.length;X++){const Y=q[X];Y&&x(Y)}},a=b?new FinalizationRegistry(q=>{typeof q=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(q))}):void 0;class s{constructor(x){this._size=0,this._options=x,this._leakageMon=d>0||this._options?.leakWarningThreshold?new e(x?.onListenerError??t.onUnexpectedError,this._options?.leakWarningThreshold??d):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(l){const x=this._listeners;queueMicrotask(()=>{c(x,X=>X.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(x,X,Y)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const j=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(j);const fe=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],oe=new A(`${j}. HINT: Stack shows most frequent listener (${fe[1]}-times)`,fe[0]);return(this._options?.onListenerError||t.onUnexpectedError)(oe),M.Disposable.None}if(this._disposed)return M.Disposable.None;X&&(x=x.bind(X));const G=new L(x);let Q,K;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(G.stack=m.create(),Q=this._leakageMon.check(G.stack,this._size+1)),l&&(G.stack=K??m.create()),this._listeners?this._listeners instanceof L?(this._deliveryQueue??=new h,this._listeners=[this._listeners,G]):this._listeners.push(G):(this._options?.onWillAddFirstListener?.(this),this._listeners=G,this._options?.onDidAddFirstListener?.(this)),this._size++;const F=(0,M.toDisposable)(()=>{a?.unregister(F),Q?.(),this._removeListener(G)});if(Y instanceof M.DisposableStore?Y.add(F):Array.isArray(Y)&&Y.push(F),a){const j=new Error().stack.split(`
`).slice(2).join(`
`).trim();a.register(F,j,F)}return F},this._event}_removeListener(x){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const X=this._listeners,Y=X.indexOf(x);if(Y===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,X[Y]=void 0;const G=this._deliveryQueue.current===this;if(this._size*w<=X.length){let Q=0;for(let K=0;K<X.length;K++)X[K]?X[Q++]=X[K]:G&&(this._deliveryQueue.end--,Q<this._deliveryQueue.i&&this._deliveryQueue.i--);X.length=Q}}_deliver(x,X){if(!x)return;const Y=this._options?.onListenerError||t.onUnexpectedError;if(!Y){x.value(X);return}try{x.value(X)}catch(G){Y(G)}}_deliverQueue(x){const X=x.current._listeners;for(;x.i<x.end;)this._deliver(X[x.i++],x.value);x.reset()}fire(x){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof L)this._deliver(this._listeners,x);else{const X=this._deliveryQueue;X.enqueue(this,x,this._listeners.length),this._deliverQueue(X)}this._perfMon?.stop()}hasListeners(){return this._size>0}}i.Emitter=s;const o=()=>new h;i.createEventDeliveryQueue=o;class h{constructor(){this.i=-1,this.end=0}enqueue(x,X,Y){this.i=0,this.end=Y,this.current=x,this.value=X}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class D extends s{async fireAsync(x,X,Y){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new g.LinkedList),c(this._listeners,G=>this._asyncDeliveryQueue.push([G.value,x]));this._asyncDeliveryQueue.size>0&&!X.isCancellationRequested;){const[G,Q]=this._asyncDeliveryQueue.shift(),K=[],F={...Q,token:X,waitUntil:j=>{if(Object.isFrozen(K))throw new Error("waitUntil can NOT be called asynchronous");Y&&(j=Y(j,G)),K.push(j)}};try{G(F)}catch(j){(0,t.onUnexpectedError)(j);continue}Object.freeze(K),await Promise.allSettled(K).then(j=>{for(const fe of j)fe.status==="rejected"&&(0,t.onUnexpectedError)(fe.reason)})}}}i.AsyncEmitter=D;class R extends s{get isPaused(){return this._isPaused!==0}constructor(x){super(x),this._isPaused=0,this._eventQueue=new g.LinkedList,this._mergeFn=x?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const x=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(x))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(x){this._size&&(this._isPaused!==0?this._eventQueue.push(x):super.fire(x))}}i.PauseableEmitter=R;class S extends R{constructor(x){super(x),this._delay=x.delay??100}fire(x){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(x)}}i.DebounceEmitter=S;class T extends s{constructor(x){super(x),this._queuedEvents=[],this._mergeFn=x?.merge}fire(x){this.hasListeners()&&(this._queuedEvents.push(x),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(X=>super.fire(X)),this._queuedEvents=[]}))}}i.MicrotaskEmitter=T;class y{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new s({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(x){const X={event:x,listener:null};this.events.push(X),this.hasListeners&&this.hook(X);const Y=()=>{this.hasListeners&&this.unhook(X);const G=this.events.indexOf(X);this.events.splice(G,1)};return(0,M.toDisposable)((0,n.createSingleCallFunction)(Y))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(x=>this.hook(x))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(x=>this.unhook(x))}hook(x){x.listener=x.event(X=>this.emitter.fire(X))}unhook(x){x.listener?.dispose(),x.listener=null}dispose(){this.emitter.dispose();for(const x of this.events)x.listener?.dispose();this.events=[]}}i.EventMultiplexer=y;class k{constructor(x,X,Y,G){this._store=new M.DisposableStore;const Q=this._store.add(new y),K=this._store.add(new M.DisposableMap);function F(j){K.set(j,Q.add(G(j)))}for(const j of x)F(j);this._store.add(X(j=>{F(j)})),this._store.add(Y(j=>{K.deleteAndDispose(j)})),this.event=Q.event}dispose(){this._store.dispose()}}i.DynamicListEventMultiplexer=k;class O{constructor(){this.data=[]}wrapEvent(x,X,Y){return(G,Q,K)=>x(F=>{const j=this.data[this.data.length-1];if(!X){j?j.buffers.push(()=>G.call(Q,F)):G.call(Q,F);return}const fe=j;if(!fe){G.call(Q,X(Y,F));return}fe.items??=[],fe.items.push(F),fe.buffers.length===0&&j.buffers.push(()=>{fe.reducedResult??=Y?fe.items.reduce(X,Y):fe.items.reduce(X),G.call(Q,fe.reducedResult)})},void 0,K)}bufferEvents(x){const X={buffers:new Array};this.data.push(X);const Y=x();return this.data.pop(),X.buffers.forEach(G=>G()),Y}}i.EventBufferer=O;class I{constructor(){this.listening=!1,this.inputEvent=f.None,this.inputEventListener=M.Disposable.None,this.emitter=new s({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(x){this.inputEvent=x,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=x(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}i.Relay=I;class U{static const(x){return new $(x)}constructor(x){this._value=x,this._onDidChange=new s,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(x){x!==this._value&&(this._value=x,this._onDidChange.fire(void 0))}}i.ValueWithChangeEvent=U;class ${constructor(x){this.value=x,this.onDidChange=f.None}}}),ne(ie[26],re([0,1,13]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CancellationTokenSource=i.CancellationToken=void 0,i.cancelOnDispose=b;const n=Object.freeze(function(l,u){const f=setTimeout(l.bind(u),0);return{dispose(){clearTimeout(f)}}});var M;(function(l){function u(f){return f===l.None||f===l.Cancelled||f instanceof g?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}l.isCancellationToken=u,l.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),l.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(M||(i.CancellationToken=M={}));class g{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new t.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new g),this._token}cancel(){this._token?this._token instanceof g&&this._token.cancel():this._token=M.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof g&&this._token.dispose():this._token=M.None}}i.CancellationTokenSource=E;function b(l){const u=new E;return l.add({dispose(){u.cancel()}}),u.token}}),ne(ie[43],re([0,1,26]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CachedFunction=i.LRUCachedFunction=i.Cache=void 0,i.identity=M;class n{constructor(l){this.task=l,this.result=null}get(){if(this.result)return this.result;const l=new t.CancellationTokenSource,u=this.task(l.token);return this.result={promise:u,dispose:()=>{this.result=null,l.cancel(),l.dispose()}},this.result}}i.Cache=n;function M(b){return b}class g{constructor(l,u){this.lastCache=void 0,this.lastArgKey=void 0,typeof l=="function"?(this._fn=l,this._computeKey=M):(this._fn=u,this._computeKey=l.getCacheKey)}get(l){const u=this._computeKey(l);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this._fn(l)),this.lastCache}}i.LRUCachedFunction=g;class E{get cachedValues(){return this._map}constructor(l,u){this._map=new Map,this._map2=new Map,typeof l=="function"?(this._fn=l,this._computeKey=M):(this._fn=u,this._computeKey=l.getCacheKey)}get(l){const u=this._computeKey(l);if(this._map2.has(u))return this._map2.get(u);const f=this._fn(l);return this._map.set(l,f),this._map2.set(u,f),f}}i.CachedFunction=E}),ne(ie[27],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isString=t,i.isStringArray=n,i.isObject=M,i.isTypedArray=g,i.isNumber=E,i.isIterable=b,i.isBoolean=l,i.isUndefined=u,i.isDefined=f,i.isUndefinedOrNull=_,i.assertType=d,i.assertIsDefined=p,i.assertAllDefined=e,i.isEmptyObject=v,i.isFunction=A,i.areFunctions=N,i.validateConstraints=L,i.validateConstraint=w;function t(c){return typeof c=="string"}function n(c){return Array.isArray(c)&&c.every(a=>t(a))}function M(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}function g(c){const a=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof a}function E(c){return typeof c=="number"&&!isNaN(c)}function b(c){return!!c&&typeof c[Symbol.iterator]=="function"}function l(c){return c===!0||c===!1}function u(c){return typeof c>"u"}function f(c){return!_(c)}function _(c){return u(c)||c===null}function d(c,a){if(!c)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}function p(c){if(_(c))throw new Error("Assertion Failed: argument is undefined or null");return c}function e(...c){const a=[];for(let s=0;s<c.length;s++){const o=c[s];if(_(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);a.push(o)}return a}const m=Object.prototype.hasOwnProperty;function v(c){if(!M(c))return!1;for(const a in c)if(m.call(c,a))return!1;return!0}function A(c){return typeof c=="function"}function N(...c){return c.length>0&&c.every(A)}function L(c,a){const s=Math.min(c.length,a.length);for(let o=0;o<s;o++)w(c[o],a[o])}function w(c,a){if(t(a)){if(typeof c!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(A(a)){try{if(c instanceof a)return}catch{}if(!_(c)&&c.constructor===a||a.length===1&&a.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ne(ie[28],re([0,1,27]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.register=M,i.getCodiconFontCharacters=g;const n=Object.create(null);function M(E,b){if((0,t.isString)(b)){const l=n[b];if(l===void 0)throw new Error(`${E} references an unknown codicon: ${b}`);b=l}return n[E]=b,{id:E}}function g(){return n}}),ne(ie[44],re([0,1,28]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.codiconsLibrary=void 0,i.codiconsLibrary={add:(0,t.register)("add",6e4),plus:(0,t.register)("plus",6e4),gistNew:(0,t.register)("gist-new",6e4),repoCreate:(0,t.register)("repo-create",6e4),lightbulb:(0,t.register)("lightbulb",60001),lightBulb:(0,t.register)("light-bulb",60001),repo:(0,t.register)("repo",60002),repoDelete:(0,t.register)("repo-delete",60002),gistFork:(0,t.register)("gist-fork",60003),repoForked:(0,t.register)("repo-forked",60003),gitPullRequest:(0,t.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.register)("git-pull-request-abandoned",60004),recordKeys:(0,t.register)("record-keys",60005),keyboard:(0,t.register)("keyboard",60005),tag:(0,t.register)("tag",60006),gitPullRequestLabel:(0,t.register)("git-pull-request-label",60006),tagAdd:(0,t.register)("tag-add",60006),tagRemove:(0,t.register)("tag-remove",60006),person:(0,t.register)("person",60007),personFollow:(0,t.register)("person-follow",60007),personOutline:(0,t.register)("person-outline",60007),personFilled:(0,t.register)("person-filled",60007),gitBranch:(0,t.register)("git-branch",60008),gitBranchCreate:(0,t.register)("git-branch-create",60008),gitBranchDelete:(0,t.register)("git-branch-delete",60008),sourceControl:(0,t.register)("source-control",60008),mirror:(0,t.register)("mirror",60009),mirrorPublic:(0,t.register)("mirror-public",60009),star:(0,t.register)("star",60010),starAdd:(0,t.register)("star-add",60010),starDelete:(0,t.register)("star-delete",60010),starEmpty:(0,t.register)("star-empty",60010),comment:(0,t.register)("comment",60011),commentAdd:(0,t.register)("comment-add",60011),alert:(0,t.register)("alert",60012),warning:(0,t.register)("warning",60012),search:(0,t.register)("search",60013),searchSave:(0,t.register)("search-save",60013),logOut:(0,t.register)("log-out",60014),signOut:(0,t.register)("sign-out",60014),logIn:(0,t.register)("log-in",60015),signIn:(0,t.register)("sign-in",60015),eye:(0,t.register)("eye",60016),eyeUnwatch:(0,t.register)("eye-unwatch",60016),eyeWatch:(0,t.register)("eye-watch",60016),circleFilled:(0,t.register)("circle-filled",60017),primitiveDot:(0,t.register)("primitive-dot",60017),closeDirty:(0,t.register)("close-dirty",60017),debugBreakpoint:(0,t.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.register)("debug-breakpoint-disabled",60017),debugHint:(0,t.register)("debug-hint",60017),terminalDecorationSuccess:(0,t.register)("terminal-decoration-success",60017),primitiveSquare:(0,t.register)("primitive-square",60018),edit:(0,t.register)("edit",60019),pencil:(0,t.register)("pencil",60019),info:(0,t.register)("info",60020),issueOpened:(0,t.register)("issue-opened",60020),gistPrivate:(0,t.register)("gist-private",60021),gitForkPrivate:(0,t.register)("git-fork-private",60021),lock:(0,t.register)("lock",60021),mirrorPrivate:(0,t.register)("mirror-private",60021),close:(0,t.register)("close",60022),removeClose:(0,t.register)("remove-close",60022),x:(0,t.register)("x",60022),repoSync:(0,t.register)("repo-sync",60023),sync:(0,t.register)("sync",60023),clone:(0,t.register)("clone",60024),desktopDownload:(0,t.register)("desktop-download",60024),beaker:(0,t.register)("beaker",60025),microscope:(0,t.register)("microscope",60025),vm:(0,t.register)("vm",60026),deviceDesktop:(0,t.register)("device-desktop",60026),file:(0,t.register)("file",60027),fileText:(0,t.register)("file-text",60027),more:(0,t.register)("more",60028),ellipsis:(0,t.register)("ellipsis",60028),kebabHorizontal:(0,t.register)("kebab-horizontal",60028),mailReply:(0,t.register)("mail-reply",60029),reply:(0,t.register)("reply",60029),organization:(0,t.register)("organization",60030),organizationFilled:(0,t.register)("organization-filled",60030),organizationOutline:(0,t.register)("organization-outline",60030),newFile:(0,t.register)("new-file",60031),fileAdd:(0,t.register)("file-add",60031),newFolder:(0,t.register)("new-folder",60032),fileDirectoryCreate:(0,t.register)("file-directory-create",60032),trash:(0,t.register)("trash",60033),trashcan:(0,t.register)("trashcan",60033),history:(0,t.register)("history",60034),clock:(0,t.register)("clock",60034),folder:(0,t.register)("folder",60035),fileDirectory:(0,t.register)("file-directory",60035),symbolFolder:(0,t.register)("symbol-folder",60035),logoGithub:(0,t.register)("logo-github",60036),markGithub:(0,t.register)("mark-github",60036),github:(0,t.register)("github",60036),terminal:(0,t.register)("terminal",60037),console:(0,t.register)("console",60037),repl:(0,t.register)("repl",60037),zap:(0,t.register)("zap",60038),symbolEvent:(0,t.register)("symbol-event",60038),error:(0,t.register)("error",60039),stop:(0,t.register)("stop",60039),variable:(0,t.register)("variable",60040),symbolVariable:(0,t.register)("symbol-variable",60040),array:(0,t.register)("array",60042),symbolArray:(0,t.register)("symbol-array",60042),symbolModule:(0,t.register)("symbol-module",60043),symbolPackage:(0,t.register)("symbol-package",60043),symbolNamespace:(0,t.register)("symbol-namespace",60043),symbolObject:(0,t.register)("symbol-object",60043),symbolMethod:(0,t.register)("symbol-method",60044),symbolFunction:(0,t.register)("symbol-function",60044),symbolConstructor:(0,t.register)("symbol-constructor",60044),symbolBoolean:(0,t.register)("symbol-boolean",60047),symbolNull:(0,t.register)("symbol-null",60047),symbolNumeric:(0,t.register)("symbol-numeric",60048),symbolNumber:(0,t.register)("symbol-number",60048),symbolStructure:(0,t.register)("symbol-structure",60049),symbolStruct:(0,t.register)("symbol-struct",60049),symbolParameter:(0,t.register)("symbol-parameter",60050),symbolTypeParameter:(0,t.register)("symbol-type-parameter",60050),symbolKey:(0,t.register)("symbol-key",60051),symbolText:(0,t.register)("symbol-text",60051),symbolReference:(0,t.register)("symbol-reference",60052),goToFile:(0,t.register)("go-to-file",60052),symbolEnum:(0,t.register)("symbol-enum",60053),symbolValue:(0,t.register)("symbol-value",60053),symbolRuler:(0,t.register)("symbol-ruler",60054),symbolUnit:(0,t.register)("symbol-unit",60054),activateBreakpoints:(0,t.register)("activate-breakpoints",60055),archive:(0,t.register)("archive",60056),arrowBoth:(0,t.register)("arrow-both",60057),arrowDown:(0,t.register)("arrow-down",60058),arrowLeft:(0,t.register)("arrow-left",60059),arrowRight:(0,t.register)("arrow-right",60060),arrowSmallDown:(0,t.register)("arrow-small-down",60061),arrowSmallLeft:(0,t.register)("arrow-small-left",60062),arrowSmallRight:(0,t.register)("arrow-small-right",60063),arrowSmallUp:(0,t.register)("arrow-small-up",60064),arrowUp:(0,t.register)("arrow-up",60065),bell:(0,t.register)("bell",60066),bold:(0,t.register)("bold",60067),book:(0,t.register)("book",60068),bookmark:(0,t.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.register)("briefcase",60076),broadcast:(0,t.register)("broadcast",60077),browser:(0,t.register)("browser",60078),bug:(0,t.register)("bug",60079),calendar:(0,t.register)("calendar",60080),caseSensitive:(0,t.register)("case-sensitive",60081),check:(0,t.register)("check",60082),checklist:(0,t.register)("checklist",60083),chevronDown:(0,t.register)("chevron-down",60084),chevronLeft:(0,t.register)("chevron-left",60085),chevronRight:(0,t.register)("chevron-right",60086),chevronUp:(0,t.register)("chevron-up",60087),chromeClose:(0,t.register)("chrome-close",60088),chromeMaximize:(0,t.register)("chrome-maximize",60089),chromeMinimize:(0,t.register)("chrome-minimize",60090),chromeRestore:(0,t.register)("chrome-restore",60091),circleOutline:(0,t.register)("circle-outline",60092),circle:(0,t.register)("circle",60092),debugBreakpointUnverified:(0,t.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.register)("terminal-decoration-incomplete",60092),circleSlash:(0,t.register)("circle-slash",60093),circuitBoard:(0,t.register)("circuit-board",60094),clearAll:(0,t.register)("clear-all",60095),clippy:(0,t.register)("clippy",60096),closeAll:(0,t.register)("close-all",60097),cloudDownload:(0,t.register)("cloud-download",60098),cloudUpload:(0,t.register)("cloud-upload",60099),code:(0,t.register)("code",60100),collapseAll:(0,t.register)("collapse-all",60101),colorMode:(0,t.register)("color-mode",60102),commentDiscussion:(0,t.register)("comment-discussion",60103),creditCard:(0,t.register)("credit-card",60105),dash:(0,t.register)("dash",60108),dashboard:(0,t.register)("dashboard",60109),database:(0,t.register)("database",60110),debugContinue:(0,t.register)("debug-continue",60111),debugDisconnect:(0,t.register)("debug-disconnect",60112),debugPause:(0,t.register)("debug-pause",60113),debugRestart:(0,t.register)("debug-restart",60114),debugStart:(0,t.register)("debug-start",60115),debugStepInto:(0,t.register)("debug-step-into",60116),debugStepOut:(0,t.register)("debug-step-out",60117),debugStepOver:(0,t.register)("debug-step-over",60118),debugStop:(0,t.register)("debug-stop",60119),debug:(0,t.register)("debug",60120),deviceCameraVideo:(0,t.register)("device-camera-video",60121),deviceCamera:(0,t.register)("device-camera",60122),deviceMobile:(0,t.register)("device-mobile",60123),diffAdded:(0,t.register)("diff-added",60124),diffIgnored:(0,t.register)("diff-ignored",60125),diffModified:(0,t.register)("diff-modified",60126),diffRemoved:(0,t.register)("diff-removed",60127),diffRenamed:(0,t.register)("diff-renamed",60128),diff:(0,t.register)("diff",60129),diffSidebyside:(0,t.register)("diff-sidebyside",60129),discard:(0,t.register)("discard",60130),editorLayout:(0,t.register)("editor-layout",60131),emptyWindow:(0,t.register)("empty-window",60132),exclude:(0,t.register)("exclude",60133),extensions:(0,t.register)("extensions",60134),eyeClosed:(0,t.register)("eye-closed",60135),fileBinary:(0,t.register)("file-binary",60136),fileCode:(0,t.register)("file-code",60137),fileMedia:(0,t.register)("file-media",60138),filePdf:(0,t.register)("file-pdf",60139),fileSubmodule:(0,t.register)("file-submodule",60140),fileSymlinkDirectory:(0,t.register)("file-symlink-directory",60141),fileSymlinkFile:(0,t.register)("file-symlink-file",60142),fileZip:(0,t.register)("file-zip",60143),files:(0,t.register)("files",60144),filter:(0,t.register)("filter",60145),flame:(0,t.register)("flame",60146),foldDown:(0,t.register)("fold-down",60147),foldUp:(0,t.register)("fold-up",60148),fold:(0,t.register)("fold",60149),folderActive:(0,t.register)("folder-active",60150),folderOpened:(0,t.register)("folder-opened",60151),gear:(0,t.register)("gear",60152),gift:(0,t.register)("gift",60153),gistSecret:(0,t.register)("gist-secret",60154),gist:(0,t.register)("gist",60155),gitCommit:(0,t.register)("git-commit",60156),gitCompare:(0,t.register)("git-compare",60157),compareChanges:(0,t.register)("compare-changes",60157),gitMerge:(0,t.register)("git-merge",60158),githubAction:(0,t.register)("github-action",60159),githubAlt:(0,t.register)("github-alt",60160),globe:(0,t.register)("globe",60161),grabber:(0,t.register)("grabber",60162),graph:(0,t.register)("graph",60163),gripper:(0,t.register)("gripper",60164),heart:(0,t.register)("heart",60165),home:(0,t.register)("home",60166),horizontalRule:(0,t.register)("horizontal-rule",60167),hubot:(0,t.register)("hubot",60168),inbox:(0,t.register)("inbox",60169),issueReopened:(0,t.register)("issue-reopened",60171),issues:(0,t.register)("issues",60172),italic:(0,t.register)("italic",60173),jersey:(0,t.register)("jersey",60174),json:(0,t.register)("json",60175),kebabVertical:(0,t.register)("kebab-vertical",60176),key:(0,t.register)("key",60177),law:(0,t.register)("law",60178),lightbulbAutofix:(0,t.register)("lightbulb-autofix",60179),linkExternal:(0,t.register)("link-external",60180),link:(0,t.register)("link",60181),listOrdered:(0,t.register)("list-ordered",60182),listUnordered:(0,t.register)("list-unordered",60183),liveShare:(0,t.register)("live-share",60184),loading:(0,t.register)("loading",60185),location:(0,t.register)("location",60186),mailRead:(0,t.register)("mail-read",60187),mail:(0,t.register)("mail",60188),markdown:(0,t.register)("markdown",60189),megaphone:(0,t.register)("megaphone",60190),mention:(0,t.register)("mention",60191),milestone:(0,t.register)("milestone",60192),gitPullRequestMilestone:(0,t.register)("git-pull-request-milestone",60192),mortarBoard:(0,t.register)("mortar-board",60193),move:(0,t.register)("move",60194),multipleWindows:(0,t.register)("multiple-windows",60195),mute:(0,t.register)("mute",60196),noNewline:(0,t.register)("no-newline",60197),note:(0,t.register)("note",60198),octoface:(0,t.register)("octoface",60199),openPreview:(0,t.register)("open-preview",60200),package:(0,t.register)("package",60201),paintcan:(0,t.register)("paintcan",60202),pin:(0,t.register)("pin",60203),play:(0,t.register)("play",60204),run:(0,t.register)("run",60204),plug:(0,t.register)("plug",60205),preserveCase:(0,t.register)("preserve-case",60206),preview:(0,t.register)("preview",60207),project:(0,t.register)("project",60208),pulse:(0,t.register)("pulse",60209),question:(0,t.register)("question",60210),quote:(0,t.register)("quote",60211),radioTower:(0,t.register)("radio-tower",60212),reactions:(0,t.register)("reactions",60213),references:(0,t.register)("references",60214),refresh:(0,t.register)("refresh",60215),regex:(0,t.register)("regex",60216),remoteExplorer:(0,t.register)("remote-explorer",60217),remote:(0,t.register)("remote",60218),remove:(0,t.register)("remove",60219),replaceAll:(0,t.register)("replace-all",60220),replace:(0,t.register)("replace",60221),repoClone:(0,t.register)("repo-clone",60222),repoForcePush:(0,t.register)("repo-force-push",60223),repoPull:(0,t.register)("repo-pull",60224),repoPush:(0,t.register)("repo-push",60225),report:(0,t.register)("report",60226),requestChanges:(0,t.register)("request-changes",60227),rocket:(0,t.register)("rocket",60228),rootFolderOpened:(0,t.register)("root-folder-opened",60229),rootFolder:(0,t.register)("root-folder",60230),rss:(0,t.register)("rss",60231),ruby:(0,t.register)("ruby",60232),saveAll:(0,t.register)("save-all",60233),saveAs:(0,t.register)("save-as",60234),save:(0,t.register)("save",60235),screenFull:(0,t.register)("screen-full",60236),screenNormal:(0,t.register)("screen-normal",60237),searchStop:(0,t.register)("search-stop",60238),server:(0,t.register)("server",60240),settingsGear:(0,t.register)("settings-gear",60241),settings:(0,t.register)("settings",60242),shield:(0,t.register)("shield",60243),smiley:(0,t.register)("smiley",60244),sortPrecedence:(0,t.register)("sort-precedence",60245),splitHorizontal:(0,t.register)("split-horizontal",60246),splitVertical:(0,t.register)("split-vertical",60247),squirrel:(0,t.register)("squirrel",60248),starFull:(0,t.register)("star-full",60249),starHalf:(0,t.register)("star-half",60250),symbolClass:(0,t.register)("symbol-class",60251),symbolColor:(0,t.register)("symbol-color",60252),symbolConstant:(0,t.register)("symbol-constant",60253),symbolEnumMember:(0,t.register)("symbol-enum-member",60254),symbolField:(0,t.register)("symbol-field",60255),symbolFile:(0,t.register)("symbol-file",60256),symbolInterface:(0,t.register)("symbol-interface",60257),symbolKeyword:(0,t.register)("symbol-keyword",60258),symbolMisc:(0,t.register)("symbol-misc",60259),symbolOperator:(0,t.register)("symbol-operator",60260),symbolProperty:(0,t.register)("symbol-property",60261),wrench:(0,t.register)("wrench",60261),wrenchSubaction:(0,t.register)("wrench-subaction",60261),symbolSnippet:(0,t.register)("symbol-snippet",60262),tasklist:(0,t.register)("tasklist",60263),telescope:(0,t.register)("telescope",60264),textSize:(0,t.register)("text-size",60265),threeBars:(0,t.register)("three-bars",60266),thumbsdown:(0,t.register)("thumbsdown",60267),thumbsup:(0,t.register)("thumbsup",60268),tools:(0,t.register)("tools",60269),triangleDown:(0,t.register)("triangle-down",60270),triangleLeft:(0,t.register)("triangle-left",60271),triangleRight:(0,t.register)("triangle-right",60272),triangleUp:(0,t.register)("triangle-up",60273),twitter:(0,t.register)("twitter",60274),unfold:(0,t.register)("unfold",60275),unlock:(0,t.register)("unlock",60276),unmute:(0,t.register)("unmute",60277),unverified:(0,t.register)("unverified",60278),verified:(0,t.register)("verified",60279),versions:(0,t.register)("versions",60280),vmActive:(0,t.register)("vm-active",60281),vmOutline:(0,t.register)("vm-outline",60282),vmRunning:(0,t.register)("vm-running",60283),watch:(0,t.register)("watch",60284),whitespace:(0,t.register)("whitespace",60285),wholeWord:(0,t.register)("whole-word",60286),window:(0,t.register)("window",60287),wordWrap:(0,t.register)("word-wrap",60288),zoomIn:(0,t.register)("zoom-in",60289),zoomOut:(0,t.register)("zoom-out",60290),listFilter:(0,t.register)("list-filter",60291),listFlat:(0,t.register)("list-flat",60292),listSelection:(0,t.register)("list-selection",60293),selection:(0,t.register)("selection",60293),listTree:(0,t.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.register)("debug-stackframe-active",60297),circleSmallFilled:(0,t.register)("circle-small-filled",60298),debugStackframeDot:(0,t.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.register)("terminal-decoration-mark",60298),debugStackframe:(0,t.register)("debug-stackframe",60299),debugStackframeFocused:(0,t.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.register)("debug-breakpoint-unsupported",60300),symbolString:(0,t.register)("symbol-string",60301),debugReverseContinue:(0,t.register)("debug-reverse-continue",60302),debugStepBack:(0,t.register)("debug-step-back",60303),debugRestartFrame:(0,t.register)("debug-restart-frame",60304),debugAlt:(0,t.register)("debug-alt",60305),callIncoming:(0,t.register)("call-incoming",60306),callOutgoing:(0,t.register)("call-outgoing",60307),menu:(0,t.register)("menu",60308),expandAll:(0,t.register)("expand-all",60309),feedback:(0,t.register)("feedback",60310),gitPullRequestReviewer:(0,t.register)("git-pull-request-reviewer",60310),groupByRefType:(0,t.register)("group-by-ref-type",60311),ungroupByRefType:(0,t.register)("ungroup-by-ref-type",60312),account:(0,t.register)("account",60313),gitPullRequestAssignee:(0,t.register)("git-pull-request-assignee",60313),bellDot:(0,t.register)("bell-dot",60314),debugConsole:(0,t.register)("debug-console",60315),library:(0,t.register)("library",60316),output:(0,t.register)("output",60317),runAll:(0,t.register)("run-all",60318),syncIgnored:(0,t.register)("sync-ignored",60319),pinned:(0,t.register)("pinned",60320),githubInverted:(0,t.register)("github-inverted",60321),serverProcess:(0,t.register)("server-process",60322),serverEnvironment:(0,t.register)("server-environment",60323),pass:(0,t.register)("pass",60324),issueClosed:(0,t.register)("issue-closed",60324),stopCircle:(0,t.register)("stop-circle",60325),playCircle:(0,t.register)("play-circle",60326),record:(0,t.register)("record",60327),debugAltSmall:(0,t.register)("debug-alt-small",60328),vmConnect:(0,t.register)("vm-connect",60329),cloud:(0,t.register)("cloud",60330),merge:(0,t.register)("merge",60331),export:(0,t.register)("export",60332),graphLeft:(0,t.register)("graph-left",60333),magnet:(0,t.register)("magnet",60334),notebook:(0,t.register)("notebook",60335),redo:(0,t.register)("redo",60336),checkAll:(0,t.register)("check-all",60337),pinnedDirty:(0,t.register)("pinned-dirty",60338),passFilled:(0,t.register)("pass-filled",60339),circleLargeFilled:(0,t.register)("circle-large-filled",60340),circleLarge:(0,t.register)("circle-large",60341),circleLargeOutline:(0,t.register)("circle-large-outline",60341),combine:(0,t.register)("combine",60342),gather:(0,t.register)("gather",60342),table:(0,t.register)("table",60343),variableGroup:(0,t.register)("variable-group",60344),typeHierarchy:(0,t.register)("type-hierarchy",60345),typeHierarchySub:(0,t.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.register)("git-pull-request-create",60348),runAbove:(0,t.register)("run-above",60349),runBelow:(0,t.register)("run-below",60350),notebookTemplate:(0,t.register)("notebook-template",60351),debugRerun:(0,t.register)("debug-rerun",60352),workspaceTrusted:(0,t.register)("workspace-trusted",60353),workspaceUntrusted:(0,t.register)("workspace-untrusted",60354),workspaceUnknown:(0,t.register)("workspace-unknown",60355),terminalCmd:(0,t.register)("terminal-cmd",60356),terminalDebian:(0,t.register)("terminal-debian",60357),terminalLinux:(0,t.register)("terminal-linux",60358),terminalPowershell:(0,t.register)("terminal-powershell",60359),terminalTmux:(0,t.register)("terminal-tmux",60360),terminalUbuntu:(0,t.register)("terminal-ubuntu",60361),terminalBash:(0,t.register)("terminal-bash",60362),arrowSwap:(0,t.register)("arrow-swap",60363),copy:(0,t.register)("copy",60364),personAdd:(0,t.register)("person-add",60365),filterFilled:(0,t.register)("filter-filled",60366),wand:(0,t.register)("wand",60367),debugLineByLine:(0,t.register)("debug-line-by-line",60368),inspect:(0,t.register)("inspect",60369),layers:(0,t.register)("layers",60370),layersDot:(0,t.register)("layers-dot",60371),layersActive:(0,t.register)("layers-active",60372),compass:(0,t.register)("compass",60373),compassDot:(0,t.register)("compass-dot",60374),compassActive:(0,t.register)("compass-active",60375),azure:(0,t.register)("azure",60376),issueDraft:(0,t.register)("issue-draft",60377),gitPullRequestClosed:(0,t.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.register)("git-pull-request-draft",60379),debugAll:(0,t.register)("debug-all",60380),debugCoverage:(0,t.register)("debug-coverage",60381),runErrors:(0,t.register)("run-errors",60382),folderLibrary:(0,t.register)("folder-library",60383),debugContinueSmall:(0,t.register)("debug-continue-small",60384),beakerStop:(0,t.register)("beaker-stop",60385),graphLine:(0,t.register)("graph-line",60386),graphScatter:(0,t.register)("graph-scatter",60387),pieChart:(0,t.register)("pie-chart",60388),bracket:(0,t.register)("bracket",60175),bracketDot:(0,t.register)("bracket-dot",60389),bracketError:(0,t.register)("bracket-error",60390),lockSmall:(0,t.register)("lock-small",60391),azureDevops:(0,t.register)("azure-devops",60392),verifiedFilled:(0,t.register)("verified-filled",60393),newline:(0,t.register)("newline",60394),layout:(0,t.register)("layout",60395),layoutActivitybarLeft:(0,t.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.register)("layout-panel-left",60398),layoutPanelCenter:(0,t.register)("layout-panel-center",60399),layoutPanelJustify:(0,t.register)("layout-panel-justify",60400),layoutPanelRight:(0,t.register)("layout-panel-right",60401),layoutPanel:(0,t.register)("layout-panel",60402),layoutSidebarLeft:(0,t.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.register)("layout-sidebar-right",60404),layoutStatusbar:(0,t.register)("layout-statusbar",60405),layoutMenubar:(0,t.register)("layout-menubar",60406),layoutCentered:(0,t.register)("layout-centered",60407),target:(0,t.register)("target",60408),indent:(0,t.register)("indent",60409),recordSmall:(0,t.register)("record-small",60410),errorSmall:(0,t.register)("error-small",60411),terminalDecorationError:(0,t.register)("terminal-decoration-error",60411),arrowCircleDown:(0,t.register)("arrow-circle-down",60412),arrowCircleLeft:(0,t.register)("arrow-circle-left",60413),arrowCircleRight:(0,t.register)("arrow-circle-right",60414),arrowCircleUp:(0,t.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.register)("layout-sidebar-left-off",60418),blank:(0,t.register)("blank",60419),heartFilled:(0,t.register)("heart-filled",60420),map:(0,t.register)("map",60421),mapHorizontal:(0,t.register)("map-horizontal",60421),foldHorizontal:(0,t.register)("fold-horizontal",60421),mapFilled:(0,t.register)("map-filled",60422),mapHorizontalFilled:(0,t.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.register)("fold-horizontal-filled",60422),circleSmall:(0,t.register)("circle-small",60423),bellSlash:(0,t.register)("bell-slash",60424),bellSlashDot:(0,t.register)("bell-slash-dot",60425),commentUnresolved:(0,t.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.register)("search-fuzzy",60429),commentDraft:(0,t.register)("comment-draft",60430),send:(0,t.register)("send",60431),sparkle:(0,t.register)("sparkle",60432),insert:(0,t.register)("insert",60433),mic:(0,t.register)("mic",60434),thumbsdownFilled:(0,t.register)("thumbsdown-filled",60435),thumbsupFilled:(0,t.register)("thumbsup-filled",60436),coffee:(0,t.register)("coffee",60437),snake:(0,t.register)("snake",60438),game:(0,t.register)("game",60439),vr:(0,t.register)("vr",60440),chip:(0,t.register)("chip",60441),piano:(0,t.register)("piano",60442),music:(0,t.register)("music",60443),micFilled:(0,t.register)("mic-filled",60444),repoFetch:(0,t.register)("repo-fetch",60445),copilot:(0,t.register)("copilot",60446),lightbulbSparkle:(0,t.register)("lightbulb-sparkle",60447),robot:(0,t.register)("robot",60448),sparkleFilled:(0,t.register)("sparkle-filled",60449),diffSingle:(0,t.register)("diff-single",60450),diffMultiple:(0,t.register)("diff-multiple",60451),surroundWith:(0,t.register)("surround-with",60452),share:(0,t.register)("share",60453),gitStash:(0,t.register)("git-stash",60454),gitStashApply:(0,t.register)("git-stash-apply",60455),gitStashPop:(0,t.register)("git-stash-pop",60456),vscode:(0,t.register)("vscode",60457),vscodeInsiders:(0,t.register)("vscode-insiders",60458),codeOss:(0,t.register)("code-oss",60459),runCoverage:(0,t.register)("run-coverage",60460),runAllCoverage:(0,t.register)("run-all-coverage",60461),coverage:(0,t.register)("coverage",60462),githubProject:(0,t.register)("github-project",60463),mapVertical:(0,t.register)("map-vertical",60464),foldVertical:(0,t.register)("fold-vertical",60464),mapVerticalFilled:(0,t.register)("map-vertical-filled",60465),foldVerticalFilled:(0,t.register)("fold-vertical-filled",60465),goToSearch:(0,t.register)("go-to-search",60466),percentage:(0,t.register)("percentage",60467),sortPercentage:(0,t.register)("sort-percentage",60467),attach:(0,t.register)("attach",60468)}}),ne(ie[45],re([0,1,28,44]),function(V,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Codicon=i.codiconsDerived=void 0,i.getAllCodicons=M;function M(){return Object.values(i.Codicon)}i.codiconsDerived={dialogError:(0,t.register)("dialog-error","error"),dialogWarning:(0,t.register)("dialog-warning","warning"),dialogInfo:(0,t.register)("dialog-info","info"),dialogClose:(0,t.register)("dialog-close","close"),treeItemExpanded:(0,t.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.register)("tree-filter-clear","close"),treeItemLoading:(0,t.register)("tree-item-loading","loading"),menuSelection:(0,t.register)("menu-selection","check"),menuSubmenu:(0,t.register)("menu-submenu","chevron-right"),menuBarMore:(0,t.register)("menubar-more","more"),scrollbarButtonLeft:(0,t.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.register)("toolbar-more","more"),quickInputBack:(0,t.register)("quick-input-back","arrow-left"),dropDownButton:(0,t.register)("drop-down-button",60084),symbolCustomColor:(0,t.register)("symbol-customcolor",60252),exportIcon:(0,t.register)("export",60332),workspaceUnspecified:(0,t.register)("workspace-unspecified",60355),newLine:(0,t.register)("newline",60394),thumbsDownFilled:(0,t.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.register)("thumbsup-filled",60436),gitFetch:(0,t.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.register)("debug-breakpoint-pending",60377)},i.Codicon={...n.codiconsLibrary,...i.codiconsDerived}}),ne(ie[17],re([0,1,27]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.deepClone=n,i.deepFreeze=M,i.cloneAndChange=E,i.mixin=l,i.equals=u,i.safeStringify=f,i.distinct=_,i.getCaseInsensitive=d,i.filter=p,i.getAllPropertyNames=e,i.getAllMethodNames=m,i.createProxyObject=v,i.mapValues=A;function n(N){if(!N||typeof N!="object"||N instanceof RegExp)return N;const L=Array.isArray(N)?[]:{};return Object.entries(N).forEach(([w,c])=>{L[w]=c&&typeof c=="object"?n(c):c}),L}function M(N){if(!N||typeof N!="object")return N;const L=[N];for(;L.length>0;){const w=L.shift();Object.freeze(w);for(const c in w)if(g.call(w,c)){const a=w[c];typeof a=="object"&&!Object.isFrozen(a)&&!(0,t.isTypedArray)(a)&&L.push(a)}}return N}const g=Object.prototype.hasOwnProperty;function E(N,L){return b(N,L,new Set)}function b(N,L,w){if((0,t.isUndefinedOrNull)(N))return N;const c=L(N);if(typeof c<"u")return c;if(Array.isArray(N)){const a=[];for(const s of N)a.push(b(s,L,w));return a}if((0,t.isObject)(N)){if(w.has(N))throw new Error("Cannot clone recursive data-structure");w.add(N);const a={};for(const s in N)g.call(N,s)&&(a[s]=b(N[s],L,w));return w.delete(N),a}return N}function l(N,L,w=!0){return(0,t.isObject)(N)?((0,t.isObject)(L)&&Object.keys(L).forEach(c=>{c in N?w&&((0,t.isObject)(N[c])&&(0,t.isObject)(L[c])?l(N[c],L[c],w):N[c]=L[c]):N[c]=L[c]}),N):L}function u(N,L){if(N===L)return!0;if(N==null||L===null||L===void 0||typeof N!=typeof L||typeof N!="object"||Array.isArray(N)!==Array.isArray(L))return!1;let w,c;if(Array.isArray(N)){if(N.length!==L.length)return!1;for(w=0;w<N.length;w++)if(!u(N[w],L[w]))return!1}else{const a=[];for(c in N)a.push(c);a.sort();const s=[];for(c in L)s.push(c);if(s.sort(),!u(a,s))return!1;for(w=0;w<a.length;w++)if(!u(N[a[w]],L[a[w]]))return!1}return!0}function f(N){const L=new Set;return JSON.stringify(N,(w,c)=>{if((0,t.isObject)(c)||Array.isArray(c)){if(L.has(c))return"[Circular]";L.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function _(N,L){const w=Object.create(null);return!N||!L||Object.keys(L).forEach(a=>{const s=N[a],o=L[a];u(s,o)||(w[a]=o)}),w}function d(N,L){const w=L.toLowerCase(),c=Object.keys(N).find(a=>a.toLowerCase()===w);return c?N[c]:N[L]}function p(N,L){const w=Object.create(null);for(const[c,a]of Object.entries(N))L(c,a)&&(w[c]=a);return w}function e(N){let L=[];for(;Object.prototype!==N;)L=L.concat(Object.getOwnPropertyNames(N)),N=Object.getPrototypeOf(N);return L}function m(N){const L=[];for(const w of e(N))typeof N[w]=="function"&&L.push(w);return L}function v(N,L){const w=a=>function(){const s=Array.prototype.slice.call(arguments,0);return L(a,s)},c={};for(const a of N)c[a]=w(a);return c}function A(N,L){const w={};for(const[c,a]of Object.entries(N))w[c]=L(a,c);return w}}),ne(ie[14],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Constants=void 0,i.toUint8=n,i.toUint32=M;var t;(function(g){g[g.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",g[g.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",g[g.MAX_UINT_8=255]="MAX_UINT_8",g[g.MAX_UINT_16=65535]="MAX_UINT_16",g[g.MAX_UINT_32=4294967295]="MAX_UINT_32",g[g.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(i.Constants=t={}));function n(g){return g<0?0:g>t.MAX_UINT_8?t.MAX_UINT_8:g|0}function M(g){return g<0?0:g>t.MAX_UINT_32?t.MAX_UINT_32:g|0}}),ne(ie[8],re([0,1,43,3,41,14]),function(V,i,t,n,M,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InvisibleCharacters=i.AmbiguousCharacters=i.noBreakWhitespace=i.GraphemeBreakType=i.UTF8_BOM_CHARACTER=i.UNUSUAL_LINE_TERMINATORS=i.GraphemeIterator=i.CodePointIterator=void 0,i.isFalsyOrWhitespace=E,i.format=l,i.format2=f,i.htmlAttributeEncodeValue=_,i.escape=d,i.escapeRegExpCharacters=p,i.count=e,i.truncate=m,i.truncateMiddle=v,i.trim=A,i.ltrim=N,i.rtrim=L,i.convertSimple2RegExpPattern=w,i.stripWildcards=c,i.createRegExp=a,i.regExpLeadsToEndlessLoop=s,i.splitLines=o,i.splitLinesIncludeSeparators=h,i.firstNonWhitespaceIndex=D,i.getLeadingWhitespace=R,i.lastNonWhitespaceIndex=S,i.replaceAsync=T,i.compare=y,i.compareSubstring=k,i.compareIgnoreCase=O,i.compareSubstringIgnoreCase=I,i.isAsciiDigit=U,i.isLowerAsciiLetter=$,i.isUpperAsciiLetter=q,i.equalsIgnoreCase=x,i.startsWithIgnoreCase=X,i.commonPrefixLength=Y,i.commonSuffixLength=G,i.isHighSurrogate=Q,i.isLowSurrogate=K,i.computeCodePoint=F,i.getNextCodePoint=j,i.nextCharLength=r,i.prevCharLength=De,i.getCharContainingOffset=ke,i.charCount=He,i.containsRTL=W,i.isBasicASCII=H,i.containsUnusualLineTerminators=Z,i.isFullWidthCharacter=ee,i.isEmojiImprecise=he,i.lcut=be,i.forAnsiStringParts=we,i.removeAnsiEscapeCodes=Re,i.removeAnsiEscapeCodesFromPrompt=te,i.startsWithUTF8BOM=le,i.stripUTF8BOM=ae,i.fuzzyContains=ce,i.containsUppercaseCharacter=me,i.uppercaseFirstLetter=_e,i.getNLines=ve,i.singleLetterHash=Ne,i.getGraphemeBreakType=Be,i.getLeftDeleteOffset=Ce;function E(P){return!P||typeof P!="string"?!0:P.trim().length===0}const b=/{(\d+)}/g;function l(P,...B){return B.length===0?P:P.replace(b,function(C,J){const ue=parseInt(J,10);return isNaN(ue)||ue<0||ue>=B.length?C:B[ue]})}const u=/{([^}]+)}/g;function f(P,B){return Object.keys(B).length===0?P:P.replace(u,(C,J)=>B[J]??C)}function _(P){return P.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}function d(P){return P.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}function p(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(P,B){let C=0,J=P.indexOf(B);for(;J!==-1;)C++,J=P.indexOf(B,J+B.length);return C}function m(P,B,C="\u2026"){return P.length<=B?P:`${P.substr(0,B)}${C}`}function v(P,B,C="\u2026"){if(P.length<=B)return P;const J=Math.ceil(B/2)-C.length/2,ue=Math.floor(B/2)-C.length/2;return`${P.substr(0,J)}${C}${P.substr(P.length-ue)}`}function A(P,B=" "){const C=N(P,B);return L(C,B)}function N(P,B){if(!P||!B)return P;const C=B.length;if(C===0||P.length===0)return P;let J=0;for(;P.indexOf(B,J)===J;)J=J+C;return P.substring(J)}function L(P,B){if(!P||!B)return P;const C=B.length,J=P.length;if(C===0||J===0)return P;let ue=J,de=-1;for(;de=P.lastIndexOf(B,ue-1),!(de===-1||de+C!==ue);){if(de===0)return"";ue=de}return P.substring(0,ue)}function w(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function c(P){return P.replace(/\*/g,"")}function a(P,B,C={}){if(!P)throw new Error("Cannot create regex from empty string");B||(P=p(P)),C.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let J="";return C.global&&(J+="g"),C.matchCase||(J+="i"),C.multiline&&(J+="m"),C.unicode&&(J+="u"),new RegExp(P,J)}function s(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}function o(P){return P.split(/\r\n|\r|\n/)}function h(P){const B=[],C=P.split(/(\r\n|\r|\n)/);for(let J=0;J<Math.ceil(C.length/2);J++)B.push(C[2*J]+(C[2*J+1]??""));return B}function D(P){for(let B=0,C=P.length;B<C;B++){const J=P.charCodeAt(B);if(J!==n.CharCode.Space&&J!==n.CharCode.Tab)return B}return-1}function R(P,B=0,C=P.length){for(let J=B;J<C;J++){const ue=P.charCodeAt(J);if(ue!==n.CharCode.Space&&ue!==n.CharCode.Tab)return P.substring(B,J)}return P.substring(B,C)}function S(P,B=P.length-1){for(let C=B;C>=0;C--){const J=P.charCodeAt(C);if(J!==n.CharCode.Space&&J!==n.CharCode.Tab)return C}return-1}function T(P,B,C){const J=[];let ue=0;for(const de of P.matchAll(B)){if(J.push(P.slice(ue,de.index)),de.index===void 0)throw new Error("match.index should be defined");ue=de.index+de[0].length,J.push(C(de[0],...de.slice(1),de.index,P,de.groups))}return J.push(P.slice(ue)),Promise.all(J).then(de=>de.join(""))}function y(P,B){return P<B?-1:P>B?1:0}function k(P,B,C=0,J=P.length,ue=0,de=B.length){for(;C<J&&ue<de;C++,ue++){const Ie=P.charCodeAt(C),ye=B.charCodeAt(ue);if(Ie<ye)return-1;if(Ie>ye)return 1}const Ae=J-C,Pe=de-ue;return Ae<Pe?-1:Ae>Pe?1:0}function O(P,B){return I(P,B,0,P.length,0,B.length)}function I(P,B,C=0,J=P.length,ue=0,de=B.length){for(;C<J&&ue<de;C++,ue++){let Ie=P.charCodeAt(C),ye=B.charCodeAt(ue);if(Ie===ye)continue;if(Ie>=128||ye>=128)return k(P.toLowerCase(),B.toLowerCase(),C,J,ue,de);$(Ie)&&(Ie-=32),$(ye)&&(ye-=32);const Me=Ie-ye;if(Me!==0)return Me}const Ae=J-C,Pe=de-ue;return Ae<Pe?-1:Ae>Pe?1:0}function U(P){return P>=n.CharCode.Digit0&&P<=n.CharCode.Digit9}function $(P){return P>=n.CharCode.a&&P<=n.CharCode.z}function q(P){return P>=n.CharCode.A&&P<=n.CharCode.Z}function x(P,B){return P.length===B.length&&I(P,B)===0}function X(P,B){const C=B.length;return B.length>P.length?!1:I(P,B,0,C)===0}function Y(P,B){const C=Math.min(P.length,B.length);let J;for(J=0;J<C;J++)if(P.charCodeAt(J)!==B.charCodeAt(J))return J;return C}function G(P,B){const C=Math.min(P.length,B.length);let J;const ue=P.length-1,de=B.length-1;for(J=0;J<C;J++)if(P.charCodeAt(ue-J)!==B.charCodeAt(de-J))return J;return C}function Q(P){return 55296<=P&&P<=56319}function K(P){return 56320<=P&&P<=57343}function F(P,B){return(P-55296<<10)+(B-56320)+65536}function j(P,B,C){const J=P.charCodeAt(C);if(Q(J)&&C+1<B){const ue=P.charCodeAt(C+1);if(K(ue))return F(J,ue)}return J}function fe(P,B){const C=P.charCodeAt(B-1);if(K(C)&&B>1){const J=P.charCodeAt(B-2);if(Q(J))return F(J,C)}return C}class oe{get offset(){return this._offset}constructor(B,C=0){this._str=B,this._len=B.length,this._offset=C}setOffset(B){this._offset=B}prevCodePoint(){const B=fe(this._str,this._offset);return this._offset-=B>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,B}nextCodePoint(){const B=j(this._str,this._len,this._offset);return this._offset+=B>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,B}eol(){return this._offset>=this._len}}i.CodePointIterator=oe;class Le{get offset(){return this._iterator.offset}constructor(B,C=0){this._iterator=new oe(B,C)}nextGraphemeLength(){const B=Te.getInstance(),C=this._iterator,J=C.offset;let ue=B.getGraphemeBreakType(C.nextCodePoint());for(;!C.eol();){const de=C.offset,Ae=B.getGraphemeBreakType(C.nextCodePoint());if(qe(ue,Ae)){C.setOffset(de);break}ue=Ae}return C.offset-J}prevGraphemeLength(){const B=Te.getInstance(),C=this._iterator,J=C.offset;let ue=B.getGraphemeBreakType(C.prevCodePoint());for(;C.offset>0;){const de=C.offset,Ae=B.getGraphemeBreakType(C.prevCodePoint());if(qe(Ae,ue)){C.setOffset(de);break}ue=Ae}return J-C.offset}eol(){return this._iterator.eol()}}i.GraphemeIterator=Le;function r(P,B){return new Le(P,B).nextGraphemeLength()}function De(P,B){return new Le(P,B).prevGraphemeLength()}function ke(P,B){B>0&&K(P.charCodeAt(B))&&B--;const C=B+r(P,B);return[C-De(P,C),C]}function He(P){const B=new Le(P);let C=0;for(;!B.eol();)C++,B.nextGraphemeLength();return C}let Se;function xe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(P){return Se||(Se=xe()),Se.test(P)}const z=/^[\t\n\r\x20-\x7E]*$/;function H(P){return z.test(P)}i.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(P){return i.UNUSUAL_LINE_TERMINATORS.test(P)}function ee(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}function he(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}function be(P,B,C=""){const J=P.trimStart();if(J.length<B)return J;const ue=/\b/g;let de=0;for(;ue.test(J)&&!(J.length-ue.lastIndex<B);)de=ue.lastIndex,ue.lastIndex+=1;return de===0?J:C+J.substring(de).trimStart()}const pe=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(P){let B=0;for(const C of P.matchAll(pe))B!==C.index&&(yield{isCode:!1,str:P.substring(B,C.index)}),yield{isCode:!0,str:C[0]},B=C.index+C[0].length;B!==P.length&&(yield{isCode:!1,str:P.substring(B)})}function Re(P){return P&&(P=P.replace(pe,"")),P}const se=/\\\[.*?\\\]/g;function te(P){return Re(P).replace(se,"")}i.UTF8_BOM_CHARACTER=String.fromCharCode(n.CharCode.UTF8_BOM);function le(P){return!!(P&&P.length>0&&P.charCodeAt(0)===n.CharCode.UTF8_BOM)}function ae(P){return le(P)?P.substr(1):P}function ce(P,B){if(!P||!B||P.length<B.length)return!1;const C=B.length,J=P.toLowerCase();let ue=0,de=-1;for(;ue<C;){const Ae=J.indexOf(B[ue],de+1);if(Ae<0)return!1;de=Ae,ue++}return!0}function me(P,B=!1){return P?(B&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}function _e(P){return P.charAt(0).toUpperCase()+P.slice(1)}function ve(P,B=1){if(B===0)return"";let C=-1;do C=P.indexOf(`
`,C+1),B--;while(B>0&&C>=0);return C===-1?P:(P[C-1]==="\r"&&C--,P.substr(0,C))}function Ne(P){const B=n.CharCode.Z-n.CharCode.A+1;return P=P%(2*B),P<B?String.fromCharCode(n.CharCode.a+P):String.fromCharCode(n.CharCode.A+P-B)}function Be(P){return Te.getInstance().getGraphemeBreakType(P)}function qe(P,B){return P===ge.Other?B!==ge.Extend&&B!==ge.SpacingMark:P===ge.CR&&B===ge.LF?!1:P===ge.Control||P===ge.CR||P===ge.LF||B===ge.Control||B===ge.CR||B===ge.LF?!0:!(P===ge.L&&(B===ge.L||B===ge.V||B===ge.LV||B===ge.LVT)||(P===ge.LV||P===ge.V)&&(B===ge.V||B===ge.T)||(P===ge.LVT||P===ge.T)&&B===ge.T||B===ge.Extend||B===ge.ZWJ||B===ge.SpacingMark||P===ge.Prepend||P===ge.ZWJ&&B===ge.Extended_Pictographic||P===ge.Regional_Indicator&&B===ge.Regional_Indicator)}var ge;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(i.GraphemeBreakType=ge={}));class Te{static{this._INSTANCE=null}static getInstance(){return Te._INSTANCE||(Te._INSTANCE=new Te),Te._INSTANCE}constructor(){this._data=Ue()}getGraphemeBreakType(B){if(B<32)return B===n.CharCode.LineFeed?ge.LF:B===n.CharCode.CarriageReturn?ge.CR:ge.Control;if(B<127)return ge.Other;const C=this._data,J=C.length/3;let ue=1;for(;ue<=J;)if(B<C[3*ue])ue=2*ue;else if(B>C[3*ue+1])ue=2*ue+1;else return C[3*ue+2];return ge.Other}}function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(P,B){if(P===0)return 0;const C=je(P,B);if(C!==void 0)return C;const J=new oe(B,P);return J.prevCodePoint(),J.offset}function je(P,B){const C=new oe(B,P);let J=C.prevCodePoint();for(;Qe(J)||J===ze.emojiVariantSelector||J===ze.enclosingKeyCap;){if(C.offset===0)return;J=C.prevCodePoint()}if(!he(J))return;let ue=C.offset;return ue>0&&C.prevCodePoint()===ze.zwj&&(ue=C.offset),ue}function Qe(P){return 127995<=P&&P<=127999}var ze;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),i.noBreakWhitespace="\xA0";class We{static{this.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new t.LRUCachedFunction({getCacheKey:JSON.stringify},B=>{function C(Me){const Oe=new Map;for(let Fe=0;Fe<Me.length;Fe+=2)Oe.set(Me[Fe],Me[Fe+1]);return Oe}function J(Me,Oe){const Fe=new Map(Me);for(const[Ge,$e]of Oe)Fe.set(Ge,$e);return Fe}function ue(Me,Oe){if(!Me)return Oe;const Fe=new Map;for(const[Ge,$e]of Me)Oe.has(Ge)&&Fe.set(Ge,$e);return Fe}const de=this.ambiguousCharacterData.value;let Ae=B.filter(Me=>!Me.startsWith("_")&&Me in de);Ae.length===0&&(Ae=["_default"]);let Pe;for(const Me of Ae){const Oe=C(de[Me]);Pe=ue(Pe,Oe)}const Ie=C(de._common),ye=J(Ie,Pe);return new We(ye)})}static getInstance(B){return We.cache.get(Array.from(B))}static{this._locales=new M.Lazy(()=>Object.keys(We.ambiguousCharacterData.value).filter(B=>!B.startsWith("_")))}static getLocales(){return We._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}containsAmbiguousCharacter(B){for(let C=0;C<B.length;C++){const J=B.codePointAt(C);if(typeof J=="number"&&this.isAmbiguous(J))return!0}return!1}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}i.AmbiguousCharacters=We;class Ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ve.getRawData())),this._data}static isInvisibleCharacter(B){return Ve.getData().has(B)}static containsInvisibleCharacter(B){for(let C=0;C<B.length;C++){const J=B.codePointAt(C);if(typeof J=="number"&&Ve.isInvisibleCharacter(J))return!0}return!1}static get codePoints(){return Ve.getData()}}i.InvisibleCharacters=Ve}),ne(ie[46],re([0,1,8]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.Hasher=void 0,i.hash=n,i.doHash=M,i.numberHash=g,i.stringHash=b,i.toHexString=m;function n(A){return M(A,0)}function M(A,N){switch(typeof A){case"object":return A===null?g(349,N):Array.isArray(A)?l(A,N):u(A,N);case"string":return b(A,N);case"boolean":return E(A,N);case"number":return g(A,N);case"undefined":return g(937,N);default:return g(617,N)}}function g(A,N){return(N<<5)-N+A|0}function E(A,N){return g(A?433:863,N)}function b(A,N){N=g(149417,N);for(let L=0,w=A.length;L<w;L++)N=g(A.charCodeAt(L),N);return N}function l(A,N){return N=g(104579,N),A.reduce((L,w)=>M(w,L),N)}function u(A,N){return N=g(181387,N),Object.keys(A).sort().reduce((L,w)=>(L=b(w,L),M(A[w],L)),N)}class f{constructor(){this._value=0}get value(){return this._value}hash(N){return this._value=M(N,this._value),this._value}}i.Hasher=f;var _;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(_||(_={}));function d(A,N,L=32){const w=L-N,c=~((1<<w)-1);return(A<<N|(c&A)>>>w)>>>0}function p(A,N=0,L=A.byteLength,w=0){for(let c=0;c<L;c++)A[N+c]=w}function e(A,N,L="0"){for(;A.length<N;)A=L+A;return A}function m(A,N=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(L=>L.toString(16).padStart(2,"0")).join(""):e((A>>>0).toString(16),N/4)}class v{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(_.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(N){const L=N.length;if(L===0)return;const w=this._buff;let c=this._buffLen,a=this._leftoverHighSurrogate,s,o;for(a!==0?(s=a,o=-1,a=0):(s=N.charCodeAt(0),o=0);;){let h=s;if(t.isHighSurrogate(s))if(o+1<L){const D=N.charCodeAt(o+1);t.isLowSurrogate(D)?(o++,h=t.computeCodePoint(s,D)):h=_.UNICODE_REPLACEMENT}else{a=s;break}else t.isLowSurrogate(s)&&(h=_.UNICODE_REPLACEMENT);if(c=this._push(w,c,h),o++,o<L)s=N.charCodeAt(o);else break}this._buffLen=c,this._leftoverHighSurrogate=a}_push(N,L,w){return w<128?N[L++]=w:w<2048?(N[L++]=192|(w&1984)>>>6,N[L++]=128|(w&63)>>>0):w<65536?(N[L++]=224|(w&61440)>>>12,N[L++]=128|(w&4032)>>>6,N[L++]=128|(w&63)>>>0):(N[L++]=240|(w&1835008)>>>18,N[L++]=128|(w&258048)>>>12,N[L++]=128|(w&4032)>>>6,N[L++]=128|(w&63)>>>0),L>=_.BLOCK_SIZE&&(this._step(),L-=_.BLOCK_SIZE,this._totalLen+=_.BLOCK_SIZE,N[0]=N[_.BLOCK_SIZE+0],N[1]=N[_.BLOCK_SIZE+1],N[2]=N[_.BLOCK_SIZE+2]),L}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,_.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const N=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(N/4294967296),!1),this._buffDV.setUint32(60,N%4294967296,!1),this._step()}_step(){const N=v._bigBlock32,L=this._buffDV;for(let S=0;S<64;S+=4)N.setUint32(S,L.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)N.setUint32(S,d(N.getUint32(S-12,!1)^N.getUint32(S-32,!1)^N.getUint32(S-56,!1)^N.getUint32(S-64,!1),1),!1);let w=this._h0,c=this._h1,a=this._h2,s=this._h3,o=this._h4,h,D,R;for(let S=0;S<80;S++)S<20?(h=c&a|~c&s,D=1518500249):S<40?(h=c^a^s,D=1859775393):S<60?(h=c&a|c&s|a&s,D=2400959708):(h=c^a^s,D=3395469782),R=d(w,5)+h+o+D+N.getUint32(S*4,!1)&4294967295,o=s,s=a,a=d(c,30),c=w,w=R;this._h0=this._h0+w&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+o&4294967295}}i.StringSHA1=v}),ne(ie[29],re([0,1,39,46,14]),function(V,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LcsDiff=i.StringDiffSequence=void 0,i.stringDiff=E;class g{constructor(p){this.source=p}getElements(){const p=this.source,e=new Int32Array(p.length);for(let m=0,v=p.length;m<v;m++)e[m]=p.charCodeAt(m);return e}}i.StringDiffSequence=g;function E(d,p,e){return new _(new g(d),new g(p)).ComputeDiff(e).changes}class b{static Assert(p,e){if(!p)throw new Error(e)}}class l{static Copy(p,e,m,v,A){for(let N=0;N<A;N++)m[v+N]=p[e+N]}static Copy2(p,e,m,v,A){for(let N=0;N<A;N++)m[v+N]=p[e+N]}}var u;(function(d){d[d.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class f{constructor(){this.m_changes=[],this.m_originalStart=M.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=M.Constants.MAX_SAFE_SMALL_INTEGER,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new t.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=M.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=M.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(p,e){this.m_originalStart=Math.min(this.m_originalStart,p),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_originalCount++}AddModifiedElement(p,e){this.m_originalStart=Math.min(this.m_originalStart,p),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class _{constructor(p,e,m=null){this.ContinueProcessingPredicate=m,this._originalSequence=p,this._modifiedSequence=e;const[v,A,N]=_._getElements(p),[L,w,c]=_._getElements(e);this._hasStrings=N&&c,this._originalStringElements=v,this._originalElementsOrHash=A,this._modifiedStringElements=L,this._modifiedElementsOrHash=w,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(p){return p.length>0&&typeof p[0]=="string"}static _getElements(p){const e=p.getElements();if(_._isStringArray(e)){const m=new Int32Array(e.length);for(let v=0,A=e.length;v<A;v++)m[v]=(0,n.stringHash)(e[v],0);return[e,m,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}ElementsAreEqual(p,e){return this._originalElementsOrHash[p]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[p]===this._modifiedStringElements[e]:!0}ElementsAreStrictEqual(p,e){if(!this.ElementsAreEqual(p,e))return!1;const m=_._getStrictElement(this._originalSequence,p),v=_._getStrictElement(this._modifiedSequence,e);return m===v}static _getStrictElement(p,e){return typeof p.getStrictElement=="function"?p.getStrictElement(e):null}OriginalElementsAreEqual(p,e){return this._originalElementsOrHash[p]!==this._originalElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[p]===this._originalStringElements[e]:!0}ModifiedElementsAreEqual(p,e){return this._modifiedElementsOrHash[p]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._modifiedStringElements[p]===this._modifiedStringElements[e]:!0}ComputeDiff(p){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,p)}_ComputeDiff(p,e,m,v,A){const N=[!1];let L=this.ComputeDiffRecursive(p,e,m,v,N);return A&&(L=this.PrettifyChanges(L)),{quitEarly:N[0],changes:L}}ComputeDiffRecursive(p,e,m,v,A){for(A[0]=!1;p<=e&&m<=v&&this.ElementsAreEqual(p,m);)p++,m++;for(;e>=p&&v>=m&&this.ElementsAreEqual(e,v);)e--,v--;if(p>e||m>v){let s;return m<=v?(b.Assert(p===e+1,"originalStart should only be one more than originalEnd"),s=[new t.DiffChange(p,0,m,v-m+1)]):p<=e?(b.Assert(m===v+1,"modifiedStart should only be one more than modifiedEnd"),s=[new t.DiffChange(p,e-p+1,m,0)]):(b.Assert(p===e+1,"originalStart should only be one more than originalEnd"),b.Assert(m===v+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const N=[0],L=[0],w=this.ComputeRecursionPoint(p,e,m,v,N,L,A),c=N[0],a=L[0];if(w!==null)return w;if(!A[0]){const s=this.ComputeDiffRecursive(p,c,m,a,A);let o=[];return A[0]?o=[new t.DiffChange(c+1,e-(c+1)+1,a+1,v-(a+1)+1)]:o=this.ComputeDiffRecursive(c+1,e,a+1,v,A),this.ConcatenateChanges(s,o)}return[new t.DiffChange(p,e-p+1,m,v-m+1)]}WALKTRACE(p,e,m,v,A,N,L,w,c,a,s,o,h,D,R,S,T,y){let k=null,O=null,I=new f,U=e,$=m,q=h[0]-S[0]-v,x=M.Constants.MIN_SAFE_SMALL_INTEGER,X=this.m_forwardHistory.length-1;do{const Y=q+p;Y===U||Y<$&&c[Y-1]<c[Y+1]?(s=c[Y+1],D=s-q-v,s<x&&I.MarkNextChange(),x=s,I.AddModifiedElement(s+1,D),q=Y+1-p):(s=c[Y-1]+1,D=s-q-v,s<x&&I.MarkNextChange(),x=s-1,I.AddOriginalElement(s,D+1),q=Y-1-p),X>=0&&(c=this.m_forwardHistory[X],p=c[0],U=1,$=c.length-1)}while(--X>=-1);if(k=I.getReverseChanges(),y[0]){let Y=h[0]+1,G=S[0]+1;if(k!==null&&k.length>0){const Q=k[k.length-1];Y=Math.max(Y,Q.getOriginalEnd()),G=Math.max(G,Q.getModifiedEnd())}O=[new t.DiffChange(Y,o-Y+1,G,R-G+1)]}else{I=new f,U=N,$=L,q=h[0]-S[0]-w,x=M.Constants.MAX_SAFE_SMALL_INTEGER,X=T?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const Y=q+A;Y===U||Y<$&&a[Y-1]>=a[Y+1]?(s=a[Y+1]-1,D=s-q-w,s>x&&I.MarkNextChange(),x=s+1,I.AddOriginalElement(s+1,D+1),q=Y+1-A):(s=a[Y-1],D=s-q-w,s>x&&I.MarkNextChange(),x=s,I.AddModifiedElement(s+1,D+1),q=Y-1-A),X>=0&&(a=this.m_reverseHistory[X],A=a[0],U=1,$=a.length-1)}while(--X>=-1);O=I.getChanges()}return this.ConcatenateChanges(k,O)}ComputeRecursionPoint(p,e,m,v,A,N,L){let w=0,c=0,a=0,s=0,o=0,h=0;p--,m--,A[0]=0,N[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const D=e-p+(v-m),R=D+1,S=new Int32Array(R),T=new Int32Array(R),y=v-m,k=e-p,O=p-m,I=e-v,$=(k-y)%2===0;S[y]=p,T[k]=e,L[0]=!1;for(let q=1;q<=D/2+1;q++){let x=0,X=0;a=this.ClipDiagonalBound(y-q,q,y,R),s=this.ClipDiagonalBound(y+q,q,y,R);for(let G=a;G<=s;G+=2){G===a||G<s&&S[G-1]<S[G+1]?w=S[G+1]:w=S[G-1]+1,c=w-(G-y)-O;const Q=w;for(;w<e&&c<v&&this.ElementsAreEqual(w+1,c+1);)w++,c++;if(S[G]=w,w+c>x+X&&(x=w,X=c),!$&&Math.abs(G-k)<=q-1&&w>=T[G])return A[0]=w,N[0]=c,Q<=T[G]&&u.MaxDifferencesHistory>0&&q<=u.MaxDifferencesHistory+1?this.WALKTRACE(y,a,s,O,k,o,h,I,S,T,w,e,A,c,v,N,$,L):null}const Y=(x-p+(X-m)-q)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(x,Y))return L[0]=!0,A[0]=x,N[0]=X,Y>0&&u.MaxDifferencesHistory>0&&q<=u.MaxDifferencesHistory+1?this.WALKTRACE(y,a,s,O,k,o,h,I,S,T,w,e,A,c,v,N,$,L):(p++,m++,[new t.DiffChange(p,e-p+1,m,v-m+1)]);o=this.ClipDiagonalBound(k-q,q,k,R),h=this.ClipDiagonalBound(k+q,q,k,R);for(let G=o;G<=h;G+=2){G===o||G<h&&T[G-1]>=T[G+1]?w=T[G+1]-1:w=T[G-1],c=w-(G-k)-I;const Q=w;for(;w>p&&c>m&&this.ElementsAreEqual(w,c);)w--,c--;if(T[G]=w,$&&Math.abs(G-y)<=q&&w<=S[G])return A[0]=w,N[0]=c,Q>=S[G]&&u.MaxDifferencesHistory>0&&q<=u.MaxDifferencesHistory+1?this.WALKTRACE(y,a,s,O,k,o,h,I,S,T,w,e,A,c,v,N,$,L):null}if(q<=u.MaxDifferencesHistory){let G=new Int32Array(s-a+2);G[0]=y-a+1,l.Copy2(S,a,G,1,s-a+1),this.m_forwardHistory.push(G),G=new Int32Array(h-o+2),G[0]=k-o+1,l.Copy2(T,o,G,1,h-o+1),this.m_reverseHistory.push(G)}}return this.WALKTRACE(y,a,s,O,k,o,h,I,S,T,w,e,A,c,v,N,$,L)}PrettifyChanges(p){for(let e=0;e<p.length;e++){const m=p[e],v=e<p.length-1?p[e+1].originalStart:this._originalElementsOrHash.length,A=e<p.length-1?p[e+1].modifiedStart:this._modifiedElementsOrHash.length,N=m.originalLength>0,L=m.modifiedLength>0;for(;m.originalStart+m.originalLength<v&&m.modifiedStart+m.modifiedLength<A&&(!N||this.OriginalElementsAreEqual(m.originalStart,m.originalStart+m.originalLength))&&(!L||this.ModifiedElementsAreEqual(m.modifiedStart,m.modifiedStart+m.modifiedLength));){const c=this.ElementsAreStrictEqual(m.originalStart,m.modifiedStart);if(this.ElementsAreStrictEqual(m.originalStart+m.originalLength,m.modifiedStart+m.modifiedLength)&&!c)break;m.originalStart++,m.modifiedStart++}const w=[null];if(e<p.length-1&&this.ChangesOverlap(p[e],p[e+1],w)){p[e]=w[0],p.splice(e+1,1),e--;continue}}for(let e=p.length-1;e>=0;e--){const m=p[e];let v=0,A=0;if(e>0){const s=p[e-1];v=s.originalStart+s.originalLength,A=s.modifiedStart+s.modifiedLength}const N=m.originalLength>0,L=m.modifiedLength>0;let w=0,c=this._boundaryScore(m.originalStart,m.originalLength,m.modifiedStart,m.modifiedLength);for(let s=1;;s++){const o=m.originalStart-s,h=m.modifiedStart-s;if(o<v||h<A||N&&!this.OriginalElementsAreEqual(o,o+m.originalLength)||L&&!this.ModifiedElementsAreEqual(h,h+m.modifiedLength))break;const R=(o===v&&h===A?5:0)+this._boundaryScore(o,m.originalLength,h,m.modifiedLength);R>c&&(c=R,w=s)}m.originalStart-=w,m.modifiedStart-=w;const a=[null];if(e>0&&this.ChangesOverlap(p[e-1],p[e],a)){p[e-1]=a[0],p.splice(e,1),e++;continue}}if(this._hasStrings)for(let e=1,m=p.length;e<m;e++){const v=p[e-1],A=p[e],N=A.originalStart-v.originalStart-v.originalLength,L=v.originalStart,w=A.originalStart+A.originalLength,c=w-L,a=v.modifiedStart,s=A.modifiedStart+A.modifiedLength,o=s-a;if(N<5&&c<20&&o<20){const h=this._findBetterContiguousSequence(L,c,a,o,N);if(h){const[D,R]=h;(D!==v.originalStart+v.originalLength||R!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=D-v.originalStart,v.modifiedLength=R-v.modifiedStart,A.originalStart=D+N,A.modifiedStart=R+N,A.originalLength=w-A.originalStart,A.modifiedLength=s-A.modifiedStart)}}}return p}_findBetterContiguousSequence(p,e,m,v,A){if(e<A||v<A)return null;const N=p+e-A+1,L=m+v-A+1;let w=0,c=0,a=0;for(let s=p;s<N;s++)for(let o=m;o<L;o++){const h=this._contiguousSequenceScore(s,o,A);h>0&&h>w&&(w=h,c=s,a=o)}return w>0?[c,a]:null}_contiguousSequenceScore(p,e,m){let v=0;for(let A=0;A<m;A++){if(!this.ElementsAreEqual(p+A,e+A))return 0;v+=this._originalStringElements[p+A].length}return v}_OriginalIsBoundary(p){return p<=0||p>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[p])}_OriginalRegionIsBoundary(p,e){if(this._OriginalIsBoundary(p)||this._OriginalIsBoundary(p-1))return!0;if(e>0){const m=p+e;if(this._OriginalIsBoundary(m-1)||this._OriginalIsBoundary(m))return!0}return!1}_ModifiedIsBoundary(p){return p<=0||p>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[p])}_ModifiedRegionIsBoundary(p,e){if(this._ModifiedIsBoundary(p)||this._ModifiedIsBoundary(p-1))return!0;if(e>0){const m=p+e;if(this._ModifiedIsBoundary(m-1)||this._ModifiedIsBoundary(m))return!0}return!1}_boundaryScore(p,e,m,v){const A=this._OriginalRegionIsBoundary(p,e)?1:0,N=this._ModifiedRegionIsBoundary(m,v)?1:0;return A+N}ConcatenateChanges(p,e){const m=[];if(p.length===0||e.length===0)return e.length>0?e:p;if(this.ChangesOverlap(p[p.length-1],e[0],m)){const v=new Array(p.length+e.length-1);return l.Copy(p,0,v,0,p.length-1),v[p.length-1]=m[0],l.Copy(e,1,v,p.length,e.length-1),v}else{const v=new Array(p.length+e.length);return l.Copy(p,0,v,0,p.length),l.Copy(e,0,v,p.length,e.length),v}}ChangesOverlap(p,e,m){if(b.Assert(p.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),b.Assert(p.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),p.originalStart+p.originalLength>=e.originalStart||p.modifiedStart+p.modifiedLength>=e.modifiedStart){const v=p.originalStart;let A=p.originalLength;const N=p.modifiedStart;let L=p.modifiedLength;return p.originalStart+p.originalLength>=e.originalStart&&(A=e.originalStart+e.originalLength-p.originalStart),p.modifiedStart+p.modifiedLength>=e.modifiedStart&&(L=e.modifiedStart+e.modifiedLength-p.modifiedStart),m[0]=new t.DiffChange(v,A,N,L),!0}else return m[0]=null,!1}ClipDiagonalBound(p,e,m,v){if(p>=0&&p<v)return p;const A=m,N=v-m-1,L=e%2===0;if(p<0){const w=A%2===0;return L===w?0:1}else{const w=N%2===0;return L===w?v-1:v-2}}}i.LcsDiff=_}),ne(ie[30],re([0,1,14]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharacterSet=i.CharacterClassifier=void 0;class n{constructor(b){const l=(0,t.toUint8)(b);this._defaultValue=l,this._asciiMap=n._createAsciiMap(l),this._map=new Map}static _createAsciiMap(b){const l=new Uint8Array(256);return l.fill(b),l}set(b,l){const u=(0,t.toUint8)(l);b>=0&&b<256?this._asciiMap[b]=u:this._map.set(b,u)}get(b){return b>=0&&b<256?this._asciiMap[b]:this._map.get(b)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}i.CharacterClassifier=n;var M;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(M||(M={}));class g{constructor(){this._actual=new n(M.False)}add(b){this._actual.set(b,M.True)}has(b){return this._actual.get(b)===M.True}clear(){return this._actual.clear()}}i.CharacterSet=g}),ne(ie[6],re([0,1,4]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.OffsetRangeSet=i.OffsetRange=void 0;class n{static addRange(E,b){let l=0;for(;l<b.length&&b[l].endExclusive<E.start;)l++;let u=l;for(;u<b.length&&b[u].start<=E.endExclusive;)u++;if(l===u)b.splice(l,0,E);else{const f=Math.min(E.start,b[l].start),_=Math.max(E.endExclusive,b[u-1].endExclusive);b.splice(l,u-l,new n(f,_))}}static tryCreate(E,b){if(!(E>b))return new n(E,b)}static ofLength(E){return new n(0,E)}static ofStartAndLength(E,b){return new n(E,E+b)}constructor(E,b){if(this.start=E,this.endExclusive=b,E>b)throw new t.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(E){return new n(this.start+E,this.endExclusive+E)}deltaStart(E){return new n(this.start+E,this.endExclusive)}deltaEnd(E){return new n(this.start,this.endExclusive+E)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(E){return this.start===E.start&&this.endExclusive===E.endExclusive}containsRange(E){return this.start<=E.start&&E.endExclusive<=this.endExclusive}contains(E){return this.start<=E&&E<this.endExclusive}join(E){return new n(Math.min(this.start,E.start),Math.max(this.endExclusive,E.endExclusive))}intersect(E){const b=Math.max(this.start,E.start),l=Math.min(this.endExclusive,E.endExclusive);if(b<=l)return new n(b,l)}intersects(E){const b=Math.max(this.start,E.start),l=Math.min(this.endExclusive,E.endExclusive);return b<l}intersectsOrTouches(E){const b=Math.max(this.start,E.start),l=Math.min(this.endExclusive,E.endExclusive);return b<=l}isBefore(E){return this.endExclusive<=E.start}isAfter(E){return this.start>=E.endExclusive}slice(E){return E.slice(this.start,this.endExclusive)}substring(E){return E.substring(this.start,this.endExclusive)}clip(E){if(this.isEmpty)throw new t.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,E))}clipCyclic(E){if(this.isEmpty)throw new t.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return E<this.start?this.endExclusive-(this.start-E)%this.length:E>=this.endExclusive?this.start+(E-this.start)%this.length:E}map(E){const b=[];for(let l=this.start;l<this.endExclusive;l++)b.push(E(l));return b}forEach(E){for(let b=this.start;b<this.endExclusive;b++)E(b)}}i.OffsetRange=n;class M{constructor(){this._sortedRanges=[]}addRange(E){let b=0;for(;b<this._sortedRanges.length&&this._sortedRanges[b].endExclusive<E.start;)b++;let l=b;for(;l<this._sortedRanges.length&&this._sortedRanges[l].start<=E.endExclusive;)l++;if(b===l)this._sortedRanges.splice(b,0,E);else{const u=Math.min(E.start,this._sortedRanges[b].start),f=Math.max(E.endExclusive,this._sortedRanges[l-1].endExclusive);this._sortedRanges.splice(b,l-b,new n(u,f))}}toString(){return this._sortedRanges.map(E=>E.toString()).join(", ")}intersectsStrict(E){let b=0;for(;b<this._sortedRanges.length&&this._sortedRanges[b].endExclusive<=E.start;)b++;return b<this._sortedRanges.length&&this._sortedRanges[b].start<E.endExclusive}intersectWithRange(E){const b=new M;for(const l of this._sortedRanges){const u=l.intersect(E);u&&b.addRange(u)}return b}intersectWithRangeLength(E){return this.intersectWithRange(E).length}get length(){return this._sortedRanges.reduce((E,b)=>E+b.length,0)}}i.OffsetRangeSet=M}),ne(ie[5],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Position=void 0;class t{constructor(M,g){this.lineNumber=M,this.column=g}with(M=this.lineNumber,g=this.column){return M===this.lineNumber&&g===this.column?this:new t(M,g)}delta(M=0,g=0){return this.with(this.lineNumber+M,this.column+g)}equals(M){return t.equals(this,M)}static equals(M,g){return!M&&!g?!0:!!M&&!!g&&M.lineNumber===g.lineNumber&&M.column===g.column}isBefore(M){return t.isBefore(this,M)}static isBefore(M,g){return M.lineNumber<g.lineNumber?!0:g.lineNumber<M.lineNumber?!1:M.column<g.column}isBeforeOrEqual(M){return t.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,g){return M.lineNumber<g.lineNumber?!0:g.lineNumber<M.lineNumber?!1:M.column<=g.column}static compare(M,g){const E=M.lineNumber|0,b=g.lineNumber|0;if(E===b){const l=M.column|0,u=g.column|0;return l-u}return E-b}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new t(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}i.Position=t}),ne(ie[2],re([0,1,5]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Range=void 0;class n{constructor(g,E,b,l){g>b||g===b&&E>l?(this.startLineNumber=b,this.startColumn=l,this.endLineNumber=g,this.endColumn=E):(this.startLineNumber=g,this.startColumn=E,this.endLineNumber=b,this.endColumn=l)}isEmpty(){return n.isEmpty(this)}static isEmpty(g){return g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn}containsPosition(g){return n.containsPosition(this,g)}static containsPosition(g,E){return!(E.lineNumber<g.startLineNumber||E.lineNumber>g.endLineNumber||E.lineNumber===g.startLineNumber&&E.column<g.startColumn||E.lineNumber===g.endLineNumber&&E.column>g.endColumn)}static strictContainsPosition(g,E){return!(E.lineNumber<g.startLineNumber||E.lineNumber>g.endLineNumber||E.lineNumber===g.startLineNumber&&E.column<=g.startColumn||E.lineNumber===g.endLineNumber&&E.column>=g.endColumn)}containsRange(g){return n.containsRange(this,g)}static containsRange(g,E){return!(E.startLineNumber<g.startLineNumber||E.endLineNumber<g.startLineNumber||E.startLineNumber>g.endLineNumber||E.endLineNumber>g.endLineNumber||E.startLineNumber===g.startLineNumber&&E.startColumn<g.startColumn||E.endLineNumber===g.endLineNumber&&E.endColumn>g.endColumn)}strictContainsRange(g){return n.strictContainsRange(this,g)}static strictContainsRange(g,E){return!(E.startLineNumber<g.startLineNumber||E.endLineNumber<g.startLineNumber||E.startLineNumber>g.endLineNumber||E.endLineNumber>g.endLineNumber||E.startLineNumber===g.startLineNumber&&E.startColumn<=g.startColumn||E.endLineNumber===g.endLineNumber&&E.endColumn>=g.endColumn)}plusRange(g){return n.plusRange(this,g)}static plusRange(g,E){let b,l,u,f;return E.startLineNumber<g.startLineNumber?(b=E.startLineNumber,l=E.startColumn):E.startLineNumber===g.startLineNumber?(b=E.startLineNumber,l=Math.min(E.startColumn,g.startColumn)):(b=g.startLineNumber,l=g.startColumn),E.endLineNumber>g.endLineNumber?(u=E.endLineNumber,f=E.endColumn):E.endLineNumber===g.endLineNumber?(u=E.endLineNumber,f=Math.max(E.endColumn,g.endColumn)):(u=g.endLineNumber,f=g.endColumn),new n(b,l,u,f)}intersectRanges(g){return n.intersectRanges(this,g)}static intersectRanges(g,E){let b=g.startLineNumber,l=g.startColumn,u=g.endLineNumber,f=g.endColumn;const _=E.startLineNumber,d=E.startColumn,p=E.endLineNumber,e=E.endColumn;return b<_?(b=_,l=d):b===_&&(l=Math.max(l,d)),u>p?(u=p,f=e):u===p&&(f=Math.min(f,e)),b>u||b===u&&l>f?null:new n(b,l,u,f)}equalsRange(g){return n.equalsRange(this,g)}static equalsRange(g,E){return!g&&!E?!0:!!g&&!!E&&g.startLineNumber===E.startLineNumber&&g.startColumn===E.startColumn&&g.endLineNumber===E.endLineNumber&&g.endColumn===E.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(g){return new t.Position(g.endLineNumber,g.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(g){return new t.Position(g.startLineNumber,g.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(g,E){return new n(this.startLineNumber,this.startColumn,g,E)}setStartPosition(g,E){return new n(g,E,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(g){return new n(g.startLineNumber,g.startColumn,g.startLineNumber,g.startColumn)}collapseToEnd(){return n.collapseToEnd(this)}static collapseToEnd(g){return new n(g.endLineNumber,g.endColumn,g.endLineNumber,g.endColumn)}delta(g){return new n(this.startLineNumber+g,this.startColumn,this.endLineNumber+g,this.endColumn)}static fromPositions(g,E=g){return new n(g.lineNumber,g.column,E.lineNumber,E.column)}static lift(g){return g?new n(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):null}static isIRange(g){return g&&typeof g.startLineNumber=="number"&&typeof g.startColumn=="number"&&typeof g.endLineNumber=="number"&&typeof g.endColumn=="number"}static areIntersectingOrTouching(g,E){return!(g.endLineNumber<E.startLineNumber||g.endLineNumber===E.startLineNumber&&g.endColumn<E.startColumn||E.endLineNumber<g.startLineNumber||E.endLineNumber===g.startLineNumber&&E.endColumn<g.startColumn)}static areIntersecting(g,E){return!(g.endLineNumber<E.startLineNumber||g.endLineNumber===E.startLineNumber&&g.endColumn<=E.startColumn||E.endLineNumber<g.startLineNumber||E.endLineNumber===g.startLineNumber&&E.endColumn<=g.startColumn)}static compareRangesUsingStarts(g,E){if(g&&E){const u=g.startLineNumber|0,f=E.startLineNumber|0;if(u===f){const _=g.startColumn|0,d=E.startColumn|0;if(_===d){const p=g.endLineNumber|0,e=E.endLineNumber|0;if(p===e){const m=g.endColumn|0,v=E.endColumn|0;return m-v}return p-e}return _-d}return u-f}return(g?1:0)-(E?1:0)}static compareRangesUsingEnds(g,E){return g.endLineNumber===E.endLineNumber?g.endColumn===E.endColumn?g.startLineNumber===E.startLineNumber?g.startColumn-E.startColumn:g.startLineNumber-E.startLineNumber:g.endColumn-E.endColumn:g.endLineNumber-E.endLineNumber}static spansMultipleLines(g){return g.endLineNumber>g.startLineNumber}toJSON(){return this}}i.Range=n}),ne(ie[47],re([0,1,2]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.EditOperation=void 0;class n{static insert(g,E){return{range:new t.Range(g.lineNumber,g.column,g.lineNumber,g.column),text:E,forceMoveMarkers:!0}}static delete(g){return{range:g,text:null}}static replace(g,E){return{range:g,text:E}}static replaceMove(g,E){return{range:g,text:E,forceMoveMarkers:!0}}}i.EditOperation=n}),ne(ie[15],re([0,1,4,6,2,9]),function(V,i,t,n,M,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineRangeSet=i.LineRange=void 0;class E{static fromRange(u){return new E(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new E(u.startLineNumber,u.endLineNumber+1)}static subtract(u,f){return f?u.startLineNumber<f.startLineNumber&&f.endLineNumberExclusive<u.endLineNumberExclusive?[new E(u.startLineNumber,f.startLineNumber),new E(f.endLineNumberExclusive,u.endLineNumberExclusive)]:f.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=f.endLineNumberExclusive?[]:f.endLineNumberExclusive<u.endLineNumberExclusive?[new E(Math.max(f.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new E(u.startLineNumber,Math.min(f.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let f=new b(u[0].slice());for(let _=1;_<u.length;_++)f=f.getUnion(new b(u[_].slice()));return f.ranges}static join(u){if(u.length===0)throw new t.BugIndicatingError("lineRanges cannot be empty");let f=u[0].startLineNumber,_=u[0].endLineNumberExclusive;for(let d=1;d<u.length;d++)f=Math.min(f,u[d].startLineNumber),_=Math.max(_,u[d].endLineNumberExclusive);return new E(f,_)}static ofLength(u,f){return new E(u,u+f)}static deserialize(u){return new E(u[0],u[1])}constructor(u,f){if(u>f)throw new t.BugIndicatingError(`startLineNumber ${u} cannot be after endLineNumberExclusive ${f}`);this.startLineNumber=u,this.endLineNumberExclusive=f}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new E(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new E(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new E(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const f=Math.max(this.startLineNumber,u.startLineNumber),_=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(f<=_)return new E(f,_)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new M.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new M.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const f=[];for(let _=this.startLineNumber;_<this.endLineNumberExclusive;_++)f.push(u(_));return f}forEach(u){for(let f=this.startLineNumber;f<this.endLineNumberExclusive;f++)u(f)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new n.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}i.LineRange=E;class b{constructor(u=[]){this._normalizedRanges=u}get ranges(){return this._normalizedRanges}addRange(u){if(u.length===0)return;const f=(0,g.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,d=>d.endLineNumberExclusive>=u.startLineNumber),_=(0,g.findLastIdxMonotonous)(this._normalizedRanges,d=>d.startLineNumber<=u.endLineNumberExclusive)+1;if(f===_)this._normalizedRanges.splice(f,0,u);else if(f===_-1){const d=this._normalizedRanges[f];this._normalizedRanges[f]=d.join(u)}else{const d=this._normalizedRanges[f].join(this._normalizedRanges[_-1]).join(u);this._normalizedRanges.splice(f,_-f,d)}}contains(u){const f=(0,g.findLastMonotonous)(this._normalizedRanges,_=>_.startLineNumber<=u);return!!f&&f.endLineNumberExclusive>u}intersects(u){const f=(0,g.findLastMonotonous)(this._normalizedRanges,_=>_.startLineNumber<u.endLineNumberExclusive);return!!f&&f.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this._normalizedRanges.length===0)return u;if(u._normalizedRanges.length===0)return this;const f=[];let _=0,d=0,p=null;for(;_<this._normalizedRanges.length||d<u._normalizedRanges.length;){let e=null;if(_<this._normalizedRanges.length&&d<u._normalizedRanges.length){const m=this._normalizedRanges[_],v=u._normalizedRanges[d];m.startLineNumber<v.startLineNumber?(e=m,_++):(e=v,d++)}else _<this._normalizedRanges.length?(e=this._normalizedRanges[_],_++):(e=u._normalizedRanges[d],d++);p===null?p=e:p.endLineNumberExclusive>=e.startLineNumber?p=new E(p.startLineNumber,Math.max(p.endLineNumberExclusive,e.endLineNumberExclusive)):(f.push(p),p=e)}return p!==null&&f.push(p),new b(f)}subtractFrom(u){const f=(0,g.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,e=>e.endLineNumberExclusive>=u.startLineNumber),_=(0,g.findLastIdxMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(f===_)return new b([u]);const d=[];let p=u.startLineNumber;for(let e=f;e<_;e++){const m=this._normalizedRanges[e];m.startLineNumber>p&&d.push(new E(p,m.startLineNumber)),p=m.endLineNumberExclusive}return p<u.endLineNumberExclusive&&d.push(new E(p,u.endLineNumberExclusive)),new b(d)}toString(){return this._normalizedRanges.map(u=>u.toString()).join(", ")}getIntersection(u){const f=[];let _=0,d=0;for(;_<this._normalizedRanges.length&&d<u._normalizedRanges.length;){const p=this._normalizedRanges[_],e=u._normalizedRanges[d],m=p.intersect(e);m&&!m.isEmpty&&f.push(m),p.endLineNumberExclusive<e.endLineNumberExclusive?_++:d++}return new b(f)}getWithDelta(u){return new b(this._normalizedRanges.map(f=>f.delta(u)))}}i.LineRangeSet=b}),ne(ie[48],re([0,1,5,2]),function(V,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Selection=i.SelectionDirection=void 0;var M;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(M||(i.SelectionDirection=M={}));class g extends n.Range{constructor(b,l,u,f){super(b,l,u,f),this.selectionStartLineNumber=b,this.selectionStartColumn=l,this.positionLineNumber=u,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return g.selectionsEqual(this,b)}static selectionsEqual(b,l){return b.selectionStartLineNumber===l.selectionStartLineNumber&&b.selectionStartColumn===l.selectionStartColumn&&b.positionLineNumber===l.positionLineNumber&&b.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?M.LTR:M.RTL}setEndPosition(b,l){return this.getDirection()===M.LTR?new g(this.startLineNumber,this.startColumn,b,l):new g(b,l,this.startLineNumber,this.startColumn)}getPosition(){return new t.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new t.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,l){return this.getDirection()===M.LTR?new g(b,l,this.endLineNumber,this.endColumn):new g(this.endLineNumber,this.endColumn,b,l)}static fromPositions(b,l=b){return new g(b.lineNumber,b.column,l.lineNumber,l.column)}static fromRange(b,l){return l===M.LTR?new g(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new g(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new g(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,l){if(b&&!l||!b&&l)return!1;if(!b&&!l)return!0;if(b.length!==l.length)return!1;for(let u=0,f=b.length;u<f;u++)if(!this.selectionsEqual(b[u],l[u]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,l,u,f,_){return _===M.LTR?new g(b,l,u,f):new g(u,f,b,l)}}i.Selection=g}),ne(ie[31],re([0,1,5,2]),function(V,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TextLength=void 0;class M{static{this.zero=new M(0,0)}static lengthDiffNonNegative(E,b){return b.isLessThan(E)?M.zero:E.lineCount===b.lineCount?new M(0,b.columnCount-E.columnCount):new M(b.lineCount-E.lineCount,b.columnCount)}static betweenPositions(E,b){return E.lineNumber===b.lineNumber?new M(0,b.column-E.column):new M(b.lineNumber-E.lineNumber,b.column-1)}static ofRange(E){return M.betweenPositions(E.getStartPosition(),E.getEndPosition())}static ofText(E){let b=0,l=0;for(const u of E)u===`
`?(b++,l=0):l++;return new M(b,l)}constructor(E,b){this.lineCount=E,this.columnCount=b}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(E){return this.lineCount!==E.lineCount?this.lineCount<E.lineCount:this.columnCount<E.columnCount}isGreaterThan(E){return this.lineCount!==E.lineCount?this.lineCount>E.lineCount:this.columnCount>E.columnCount}isGreaterThanOrEqualTo(E){return this.lineCount!==E.lineCount?this.lineCount>E.lineCount:this.columnCount>=E.columnCount}equals(E){return this.lineCount===E.lineCount&&this.columnCount===E.columnCount}compare(E){return this.lineCount!==E.lineCount?this.lineCount-E.lineCount:this.columnCount-E.columnCount}add(E){return E.lineCount===0?new M(this.lineCount,this.columnCount+E.columnCount):new M(this.lineCount+E.lineCount,E.columnCount)}createRange(E){return this.lineCount===0?new n.Range(E.lineNumber,E.column,E.lineNumber,E.column+this.columnCount):new n.Range(E.lineNumber,E.column,E.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new n.Range(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(E){return this.lineCount===0?new t.Position(E.lineNumber,E.column+this.columnCount):new t.Position(E.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}i.TextLength=M}),ne(ie[49],re([0,1,9,6,5,2,31]),function(V,i,t,n,M,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PositionOffsetTransformer=void 0;class b{constructor(u){this.text=u,this.lineStartOffsetByLineIdx=[],this.lineStartOffsetByLineIdx.push(0);for(let f=0;f<u.length;f++)u.charAt(f)===`
`&&this.lineStartOffsetByLineIdx.push(f+1)}getOffset(u){return this.lineStartOffsetByLineIdx[u.lineNumber-1]+u.column-1}getOffsetRange(u){return new n.OffsetRange(this.getOffset(u.getStartPosition()),this.getOffset(u.getEndPosition()))}getPosition(u){const f=(0,t.findLastIdxMonotonous)(this.lineStartOffsetByLineIdx,p=>p<=u),_=f+1,d=u-this.lineStartOffsetByLineIdx[f]+1;return new M.Position(_,d)}getRange(u){return g.Range.fromPositions(this.getPosition(u.start),this.getPosition(u.endExclusive))}getTextLength(u){return E.TextLength.ofRange(this.getRange(u))}get textLength(){const u=this.lineStartOffsetByLineIdx.length-1;return new E.TextLength(u,this.text.length-this.lineStartOffsetByLineIdx[u])}}i.PositionOffsetTransformer=b}),ne(ie[50],re([0,1,11,4,5,49,2,31]),function(V,i,t,n,M,g,E,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringText=i.LineBasedText=i.AbstractText=i.SingleTextEdit=i.TextEdit=void 0;class l{static single(m,v){return new l([new u(m,v)])}constructor(m){this.edits=m,(0,t.assertFn)(()=>(0,t.checkAdjacentItems)(m,(v,A)=>v.range.getEndPosition().isBeforeOrEqual(A.range.getStartPosition())))}normalize(){const m=[];for(const v of this.edits)if(m.length>0&&m[m.length-1].range.getEndPosition().equals(v.range.getStartPosition())){const A=m[m.length-1];m[m.length-1]=new u(A.range.plusRange(v.range),A.text+v.text)}else v.isEmpty||m.push(v);return new l(m)}mapPosition(m){let v=0,A=0,N=0;for(const L of this.edits){const w=L.range.getStartPosition(),c=L.range.getEndPosition();if(m.isBeforeOrEqual(w))break;const a=b.TextLength.ofText(L.text);if(m.isBefore(c)){const s=new M.Position(w.lineNumber+v,w.column+(w.lineNumber+v===A?N:0)),o=a.addToPosition(s);return f(s,o)}v+=a.lineCount-(L.range.endLineNumber-L.range.startLineNumber),a.lineCount===0?c.lineNumber!==w.lineNumber?N+=a.columnCount-(c.column-1):N+=a.columnCount-(c.column-w.column):N=a.columnCount,A=c.lineNumber+v}return new M.Position(m.lineNumber+v,m.column+(m.lineNumber+v===A?N:0))}mapRange(m){function v(w){return w instanceof M.Position?w:w.getStartPosition()}function A(w){return w instanceof M.Position?w:w.getEndPosition()}const N=v(this.mapPosition(m.getStartPosition())),L=A(this.mapPosition(m.getEndPosition()));return f(N,L)}inverseMapPosition(m,v){return this.inverse(v).mapPosition(m)}inverseMapRange(m,v){return this.inverse(v).mapRange(m)}apply(m){let v="",A=new M.Position(1,1);for(const L of this.edits){const w=L.range,c=w.getStartPosition(),a=w.getEndPosition(),s=f(A,c);s.isEmpty()||(v+=m.getValueOfRange(s)),v+=L.text,A=a}const N=f(A,m.endPositionExclusive);return N.isEmpty()||(v+=m.getValueOfRange(N)),v}applyToString(m){const v=new p(m);return this.apply(v)}inverse(m){const v=this.getNewRanges();return new l(this.edits.map((A,N)=>new u(v[N],m.getValueOfRange(A.range))))}getNewRanges(){const m=[];let v=0,A=0,N=0;for(const L of this.edits){const w=b.TextLength.ofText(L.text),c=M.Position.lift({lineNumber:L.range.startLineNumber+A,column:L.range.startColumn+(L.range.startLineNumber===v?N:0)}),a=w.createRange(c);m.push(a),A=a.endLineNumber-L.range.endLineNumber,N=a.endColumn-L.range.endColumn,v=L.range.endLineNumber}return m}}i.TextEdit=l;class u{constructor(m,v){this.range=m,this.text=v}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(m,v){return m.range.equalsRange(v.range)&&m.text===v.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}i.SingleTextEdit=u;function f(e,m){if(e.lineNumber===m.lineNumber&&e.column===Number.MAX_SAFE_INTEGER)return E.Range.fromPositions(m,m);if(!e.isBeforeOrEqual(m))throw new n.BugIndicatingError("start must be before end");return new E.Range(e.lineNumber,e.column,m.lineNumber,m.column)}class _{get endPositionExclusive(){return this.length.addToPosition(new M.Position(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}i.AbstractText=_;class d extends _{constructor(m,v){(0,t.assert)(v>=1),super(),this._getLineContent=m,this._lineCount=v}getValueOfRange(m){if(m.startLineNumber===m.endLineNumber)return this._getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);let v=this._getLineContent(m.startLineNumber).substring(m.startColumn-1);for(let A=m.startLineNumber+1;A<m.endLineNumber;A++)v+=`
`+this._getLineContent(A);return v+=`
`+this._getLineContent(m.endLineNumber).substring(0,m.endColumn-1),v}get length(){const m=this._getLineContent(this._lineCount);return new b.TextLength(this._lineCount-1,m.length)}}i.LineBasedText=d;class p extends _{constructor(m){super(),this.value=m,this._t=new g.PositionOffsetTransformer(this.value)}getValueOfRange(m){return this._t.getOffsetRange(m).substring(this.value)}get length(){return this._t.textLength}}i.StringText=p}),ne(ie[51],re([0,1,3,16,30]),function(V,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WordCharacterClassifier=i.WordCharacterClass=void 0,i.getMapForWordSeparators=l;var g;(function(u){u[u.Regular=0]="Regular",u[u.Whitespace=1]="Whitespace",u[u.WordSeparator=2]="WordSeparator"})(g||(i.WordCharacterClass=g={}));class E extends M.CharacterClassifier{constructor(f,_){super(g.Regular),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=_,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let d=0,p=f.length;d<p;d++)this.set(f.charCodeAt(d),g.WordSeparator);this.set(t.CharCode.Space,g.Whitespace),this.set(t.CharCode.Tab,g.Whitespace)}findPrevIntlWordBeforeOrAtOffset(f,_){let d=null;for(const p of this._getIntlSegmenterWordsOnLine(f)){if(p.index>_)break;d=p}return d}findNextIntlWordAtOrAfterOffset(f,_){for(const d of this._getIntlSegmenterWordsOnLine(f))if(!(d.index<_))return d;return null}_getIntlSegmenterWordsOnLine(f){return this._segmenter?this._cachedLine===f?this._cachedSegments:(this._cachedLine=f,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(f)),this._cachedSegments):[]}_filterWordSegments(f){const _=[];for(const d of f)this._isWordLike(d)&&_.push(d);return _}_isWordLike(f){return!!f.isWordLike}}i.WordCharacterClassifier=E;const b=new n.LRUCache(10);function l(u,f){const _=`${u}/${f.join(",")}`;let d=b.get(_);return d||(d=new E(u,f),b.set(_,d)),d}}),ne(ie[32],re([0,1,23,12,24]),function(V,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DEFAULT_WORD_REGEXP=i.USUAL_WORD_SEPARATORS=void 0,i.ensureValidWordDefinition=E,i.setDefaultGetWordAtTextConfig=l,i.getWordAtText=u,i.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(_=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const p of i.USUAL_WORD_SEPARATORS)_.indexOf(p)>=0||(d+="\\"+p);return d+="\\s]+)",new RegExp(d,"g")}i.DEFAULT_WORD_REGEXP=g();function E(_){let d=i.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)d=_;else{let p="g";_.ignoreCase&&(p+="i"),_.multiline&&(p+="m"),_.unicode&&(p+="u"),d=new RegExp(_.source,p)}return d.lastIndex=0,d}const b=new M.LinkedList;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(_){const d=b.unshift(_);return(0,n.toDisposable)(d)}function u(_,d,p,e,m){if(d=E(d),m||(m=t.Iterable.first(b)),p.length>m.maxLen){let w=_-m.maxLen/2;return w<0?w=0:e+=w,p=p.substring(w,_+m.maxLen/2),u(_,d,p,e,m)}const v=Date.now(),A=_-1-e;let N=-1,L=null;for(let w=1;!(Date.now()-v>=m.timeBudget);w++){const c=A-m.windowSize*w;d.lastIndex=Math.max(0,c);const a=f(d,p,A,N);if(!a&&L||(L=a,c<=0))break;N=c}if(L){const w={word:L[0],startColumn:e+1+L.index,endColumn:e+1+L.index+L[0].length};return d.lastIndex=0,w}return null}function f(_,d,p,e){let m;for(;m=_.exec(d);){const v=m.index||0;if(v<=p&&_.lastIndex>=p)return m;if(e>0&&v>e)return null}return null}}),ne(ie[10],re([0,1,7,4,6]),function(V,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DateTimeout=i.InfiniteTimeout=i.OffsetPair=i.SequenceDiff=i.DiffAlgorithmResult=void 0;class g{static trivial(_,d){return new g([new E(M.OffsetRange.ofLength(_.length),M.OffsetRange.ofLength(d.length))],!1)}static trivialTimedOut(_,d){return new g([new E(M.OffsetRange.ofLength(_.length),M.OffsetRange.ofLength(d.length))],!0)}constructor(_,d){this.diffs=_,this.hitTimeout=d}}i.DiffAlgorithmResult=g;class E{static invert(_,d){const p=[];return(0,t.forEachAdjacent)(_,(e,m)=>{p.push(E.fromOffsetPairs(e?e.getEndExclusives():b.zero,m?m.getStarts():new b(d,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+d)))}),p}static fromOffsetPairs(_,d){return new E(new M.OffsetRange(_.offset1,d.offset1),new M.OffsetRange(_.offset2,d.offset2))}constructor(_,d){this.seq1Range=_,this.seq2Range=d}swap(){return new E(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(_){return new E(this.seq1Range.join(_.seq1Range),this.seq2Range.join(_.seq2Range))}delta(_){return _===0?this:new E(this.seq1Range.delta(_),this.seq2Range.delta(_))}deltaStart(_){return _===0?this:new E(this.seq1Range.deltaStart(_),this.seq2Range.deltaStart(_))}deltaEnd(_){return _===0?this:new E(this.seq1Range.deltaEnd(_),this.seq2Range.deltaEnd(_))}intersectsOrTouches(_){return this.seq1Range.intersectsOrTouches(_.seq1Range)||this.seq2Range.intersectsOrTouches(_.seq2Range)}intersect(_){const d=this.seq1Range.intersect(_.seq1Range),p=this.seq2Range.intersect(_.seq2Range);if(!(!d||!p))return new E(d,p)}getStarts(){return new b(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new b(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}i.SequenceDiff=E;class b{static{this.zero=new b(0,0)}static{this.max=new b(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(_,d){this.offset1=_,this.offset2=d}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(_){return _===0?this:new b(this.offset1+_,this.offset2+_)}equals(_){return this.offset1===_.offset1&&this.offset2===_.offset2}}i.OffsetPair=b;class l{static{this.instance=new l}isValid(){return!0}}i.InfiniteTimeout=l;class u{constructor(_){if(this.timeout=_,this.startTime=Date.now(),this.valid=!0,_<=0)throw new n.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}i.DateTimeout=u}),ne(ie[33],re([0,1,6,10]),function(V,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MyersDiffAlgorithm=void 0;class M{compute(u,f,_=n.InfiniteTimeout.instance){if(u.length===0||f.length===0)return n.DiffAlgorithmResult.trivial(u,f);const d=u,p=f;function e(s,o){for(;s<d.length&&o<p.length&&d.getElement(s)===p.getElement(o);)s++,o++;return s}let m=0;const v=new E;v.set(0,e(0,0));const A=new b;A.set(0,v.get(0)===0?null:new g(null,0,0,v.get(0)));let N=0;e:for(;;){if(m++,!_.isValid())return n.DiffAlgorithmResult.trivialTimedOut(d,p);const s=-Math.min(m,p.length+m%2),o=Math.min(m,d.length+m%2);for(N=s;N<=o;N+=2){let h=0;const D=N===o?-1:v.get(N+1),R=N===s?-1:v.get(N-1)+1;h++;const S=Math.min(Math.max(D,R),d.length),T=S-N;if(h++,S>d.length||T>p.length)continue;const y=e(S,T);v.set(N,y);const k=S===D?A.get(N+1):A.get(N-1);if(A.set(N,y!==S?new g(k,S,T,y-S):k),v.get(N)===d.length&&v.get(N)-N===p.length)break e}}let L=A.get(N);const w=[];let c=d.length,a=p.length;for(;;){const s=L?L.x+L.length:0,o=L?L.y+L.length:0;if((s!==c||o!==a)&&w.push(new n.SequenceDiff(new t.OffsetRange(s,c),new t.OffsetRange(o,a))),!L)break;c=L.x,a=L.y,L=L.prev}return w.reverse(),new n.DiffAlgorithmResult(w,!1)}}i.MyersDiffAlgorithm=M;class g{constructor(u,f,_,d){this.prev=u,this.x=f,this.y=_,this.length=d}}class E{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.negativeArr[u]):this.positiveArr[u]}set(u,f){if(u<0){if(u=-u-1,u>=this.negativeArr.length){const _=this.negativeArr;this.negativeArr=new Int32Array(_.length*2),this.negativeArr.set(_)}this.negativeArr[u]=f}else{if(u>=this.positiveArr.length){const _=this.positiveArr;this.positiveArr=new Int32Array(_.length*2),this.positiveArr.set(_)}this.positiveArr[u]=f}}}class b{constructor(){this.positiveArr=[],this.negativeArr=[]}get(u){return u<0?(u=-u-1,this.negativeArr[u]):this.positiveArr[u]}set(u,f){u<0?(u=-u-1,this.negativeArr[u]=f):this.positiveArr[u]=f}}}),ne(ie[52],re([0,1,7,6,10]),function(V,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.optimizeSequenceDiffs=g,i.removeShortMatches=u,i.extendDiffsToEntireWordIfAppropriate=f,i.removeVeryShortMatchingLinesBetweenDiffs=d,i.removeVeryShortMatchingTextBetweenLongDiffs=p;function g(e,m,v){let A=v;return A=E(e,m,A),A=E(e,m,A),A=b(e,m,A),A}function E(e,m,v){if(v.length===0)return v;const A=[];A.push(v[0]);for(let L=1;L<v.length;L++){const w=A[A.length-1];let c=v[L];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const a=c.seq1Range.start-w.seq1Range.endExclusive;let s;for(s=1;s<=a&&!(e.getElement(c.seq1Range.start-s)!==e.getElement(c.seq1Range.endExclusive-s)||m.getElement(c.seq2Range.start-s)!==m.getElement(c.seq2Range.endExclusive-s));s++);if(s--,s===a){A[A.length-1]=new M.SequenceDiff(new n.OffsetRange(w.seq1Range.start,c.seq1Range.endExclusive-a),new n.OffsetRange(w.seq2Range.start,c.seq2Range.endExclusive-a));continue}c=c.delta(-s)}A.push(c)}const N=[];for(let L=0;L<A.length-1;L++){const w=A[L+1];let c=A[L];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const a=w.seq1Range.start-c.seq1Range.endExclusive;let s;for(s=0;s<a&&!(!e.isStronglyEqual(c.seq1Range.start+s,c.seq1Range.endExclusive+s)||!m.isStronglyEqual(c.seq2Range.start+s,c.seq2Range.endExclusive+s));s++);if(s===a){A[L+1]=new M.SequenceDiff(new n.OffsetRange(c.seq1Range.start+a,w.seq1Range.endExclusive),new n.OffsetRange(c.seq2Range.start+a,w.seq2Range.endExclusive));continue}s>0&&(c=c.delta(s))}N.push(c)}return A.length>0&&N.push(A[A.length-1]),N}function b(e,m,v){if(!e.getBoundaryScore||!m.getBoundaryScore)return v;for(let A=0;A<v.length;A++){const N=A>0?v[A-1]:void 0,L=v[A],w=A+1<v.length?v[A+1]:void 0,c=new n.OffsetRange(N?N.seq1Range.endExclusive+1:0,w?w.seq1Range.start-1:e.length),a=new n.OffsetRange(N?N.seq2Range.endExclusive+1:0,w?w.seq2Range.start-1:m.length);L.seq1Range.isEmpty?v[A]=l(L,e,m,c,a):L.seq2Range.isEmpty&&(v[A]=l(L.swap(),m,e,a,c).swap())}return v}function l(e,m,v,A,N){let w=1;for(;e.seq1Range.start-w>=A.start&&e.seq2Range.start-w>=N.start&&v.isStronglyEqual(e.seq2Range.start-w,e.seq2Range.endExclusive-w)&&w<100;)w++;w--;let c=0;for(;e.seq1Range.start+c<A.endExclusive&&e.seq2Range.endExclusive+c<N.endExclusive&&v.isStronglyEqual(e.seq2Range.start+c,e.seq2Range.endExclusive+c)&&c<100;)c++;if(w===0&&c===0)return e;let a=0,s=-1;for(let o=-w;o<=c;o++){const h=e.seq2Range.start+o,D=e.seq2Range.endExclusive+o,R=e.seq1Range.start+o,S=m.getBoundaryScore(R)+v.getBoundaryScore(h)+v.getBoundaryScore(D);S>s&&(s=S,a=o)}return e.delta(a)}function u(e,m,v){const A=[];for(const N of v){const L=A[A.length-1];if(!L){A.push(N);continue}N.seq1Range.start-L.seq1Range.endExclusive<=2||N.seq2Range.start-L.seq2Range.endExclusive<=2?A[A.length-1]=new M.SequenceDiff(L.seq1Range.join(N.seq1Range),L.seq2Range.join(N.seq2Range)):A.push(N)}return A}function f(e,m,v){const A=M.SequenceDiff.invert(v,e.length),N=[];let L=new M.OffsetPair(0,0);function w(a,s){if(a.offset1<L.offset1||a.offset2<L.offset2)return;const o=e.findWordContaining(a.offset1),h=m.findWordContaining(a.offset2);if(!o||!h)return;let D=new M.SequenceDiff(o,h);const R=D.intersect(s);let S=R.seq1Range.length,T=R.seq2Range.length;for(;A.length>0;){const y=A[0];if(!(y.seq1Range.intersects(D.seq1Range)||y.seq2Range.intersects(D.seq2Range)))break;const O=e.findWordContaining(y.seq1Range.start),I=m.findWordContaining(y.seq2Range.start),U=new M.SequenceDiff(O,I),$=U.intersect(y);if(S+=$.seq1Range.length,T+=$.seq2Range.length,D=D.join(U),D.seq1Range.endExclusive>=y.seq1Range.endExclusive)A.shift();else break}S+T<(D.seq1Range.length+D.seq2Range.length)*2/3&&N.push(D),L=D.getEndExclusives()}for(;A.length>0;){const a=A.shift();a.seq1Range.isEmpty||(w(a.getStarts(),a),w(a.getEndExclusives().delta(-1),a))}return _(v,N)}function _(e,m){const v=[];for(;e.length>0||m.length>0;){const A=e[0],N=m[0];let L;A&&(!N||A.seq1Range.start<N.seq1Range.start)?L=e.shift():L=m.shift(),v.length>0&&v[v.length-1].seq1Range.endExclusive>=L.seq1Range.start?v[v.length-1]=v[v.length-1].join(L):v.push(L)}return v}function d(e,m,v){let A=v;if(A.length===0)return A;let N=0,L;do{L=!1;const w=[A[0]];for(let c=1;c<A.length;c++){let o=function(D,R){const S=new n.OffsetRange(s.seq1Range.endExclusive,a.seq1Range.start);return e.getText(S).replace(/\s/g,"").length<=4&&(D.seq1Range.length+D.seq2Range.length>5||R.seq1Range.length+R.seq2Range.length>5)};const a=A[c],s=w[w.length-1];o(s,a)?(L=!0,w[w.length-1]=w[w.length-1].join(a)):w.push(a)}A=w}while(N++<10&&L);return A}function p(e,m,v){let A=v;if(A.length===0)return A;let N=0,L;do{L=!1;const c=[A[0]];for(let a=1;a<A.length;a++){let h=function(R,S){const T=new n.OffsetRange(o.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(T)>5||T.length>500)return!1;const k=e.getText(T).trim();if(k.length>20||k.split(/\r\n|\r|\n/).length>1)return!1;const O=e.countLinesIn(R.seq1Range),I=R.seq1Range.length,U=m.countLinesIn(R.seq2Range),$=R.seq2Range.length,q=e.countLinesIn(S.seq1Range),x=S.seq1Range.length,X=m.countLinesIn(S.seq2Range),Y=S.seq2Range.length,G=2*40+50;function Q(K){return Math.min(K,G)}return Math.pow(Math.pow(Q(O*40+I),1.5)+Math.pow(Q(U*40+$),1.5),1.5)+Math.pow(Math.pow(Q(q*40+x),1.5)+Math.pow(Q(X*40+Y),1.5),1.5)>(G**1.5)**1.5*1.3};const s=A[a],o=c[c.length-1];h(o,s)?(L=!0,c[c.length-1]=c[c.length-1].join(s)):c.push(s)}A=c}while(N++<10&&L);const w=[];return(0,t.forEachWithNeighbors)(A,(c,a,s)=>{let o=a;function h(k){return k.length>0&&k.trim().length<=3&&a.seq1Range.length+a.seq2Range.length>100}const D=e.extendToFullLines(a.seq1Range),R=e.getText(new n.OffsetRange(D.start,a.seq1Range.start));h(R)&&(o=o.deltaStart(-R.length));const S=e.getText(new n.OffsetRange(a.seq1Range.endExclusive,D.endExclusive));h(S)&&(o=o.deltaEnd(S.length));const T=M.SequenceDiff.fromOffsetPairs(c?c.getEndExclusives():M.OffsetPair.zero,s?s.getStarts():M.OffsetPair.max),y=o.intersect(T);w.length>0&&y.getStarts().equals(w[w.length-1].getEndExclusives())?w[w.length-1]=w[w.length-1].join(y):w.push(y)}),w}}),ne(ie[53],re([0,1,3]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineSequence=void 0;class n{constructor(E,b){this.trimmedHash=E,this.lines=b}getElement(E){return this.trimmedHash[E]}get length(){return this.trimmedHash.length}getBoundaryScore(E){const b=E===0?0:M(this.lines[E-1]),l=E===this.lines.length?0:M(this.lines[E]);return 1e3-(b+l)}getText(E){return this.lines.slice(E.start,E.endExclusive).join(`
`)}isStronglyEqual(E,b){return this.lines[E]===this.lines[b]}}i.LineSequence=n;function M(g){let E=0;for(;E<g.length&&(g.charCodeAt(E)===t.CharCode.Space||g.charCodeAt(E)===t.CharCode.Tab);)E++;return E}}),ne(ie[18],re([0,1,3]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineRangeFragment=i.Array2D=void 0,i.isSpace=M;class n{constructor(b,l){this.width=b,this.height=l,this.array=[],this.array=new Array(b*l)}get(b,l){return this.array[b+l*this.width]}set(b,l,u){this.array[b+l*this.width]=u}}i.Array2D=n;function M(E){return E===t.CharCode.Space||E===t.CharCode.Tab}class g{static{this.chrKeys=new Map}static getKey(b){let l=this.chrKeys.get(b);return l===void 0&&(l=this.chrKeys.size,this.chrKeys.set(b,l)),l}constructor(b,l,u){this.range=b,this.lines=l,this.source=u,this.histogram=[];let f=0;for(let _=b.startLineNumber-1;_<b.endLineNumberExclusive-1;_++){const d=l[_];for(let e=0;e<d.length;e++){f++;const m=d[e],v=g.getKey(m);this.histogram[v]=(this.histogram[v]||0)+1}f++;const p=g.getKey(`
`);this.histogram[p]=(this.histogram[p]||0)+1}this.totalCount=f}computeSimilarity(b){let l=0;const u=Math.max(this.histogram.length,b.histogram.length);for(let f=0;f<u;f++)l+=Math.abs((this.histogram[f]??0)-(b.histogram[f]??0));return 1-l/(this.totalCount+b.totalCount)}}i.LineRangeFragment=g}),ne(ie[54],re([0,1,6,10,18]),function(V,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DynamicProgrammingDiffing=void 0;class g{compute(b,l,u=n.InfiniteTimeout.instance,f){if(b.length===0||l.length===0)return n.DiffAlgorithmResult.trivial(b,l);const _=new M.Array2D(b.length,l.length),d=new M.Array2D(b.length,l.length),p=new M.Array2D(b.length,l.length);for(let w=0;w<b.length;w++)for(let c=0;c<l.length;c++){if(!u.isValid())return n.DiffAlgorithmResult.trivialTimedOut(b,l);const a=w===0?0:_.get(w-1,c),s=c===0?0:_.get(w,c-1);let o;b.getElement(w)===l.getElement(c)?(w===0||c===0?o=0:o=_.get(w-1,c-1),w>0&&c>0&&d.get(w-1,c-1)===3&&(o+=p.get(w-1,c-1)),o+=f?f(w,c):1):o=-1;const h=Math.max(a,s,o);if(h===o){const D=w>0&&c>0?p.get(w-1,c-1):0;p.set(w,c,D+1),d.set(w,c,3)}else h===a?(p.set(w,c,0),d.set(w,c,1)):h===s&&(p.set(w,c,0),d.set(w,c,2));_.set(w,c,h)}const e=[];let m=b.length,v=l.length;function A(w,c){(w+1!==m||c+1!==v)&&e.push(new n.SequenceDiff(new t.OffsetRange(w+1,m),new t.OffsetRange(c+1,v))),m=w,v=c}let N=b.length-1,L=l.length-1;for(;N>=0&&L>=0;)d.get(N,L)===3?(A(N,L),N--,L--):d.get(N,L)===1?N--:L--;return A(-1,-1),e.reverse(),new n.DiffAlgorithmResult(e,!1)}}i.DynamicProgrammingDiffing=g}),ne(ie[34],re([0,1,9,3,6,5,2,18]),function(V,i,t,n,M,g,E,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LinesSliceCharSequence=void 0;class l{constructor(m,v,A){this.lines=m,this.considerWhitespaceChanges=A,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let N=!1;v.start>0&&v.endExclusive>=m.length&&(v=new M.OffsetRange(v.start-1,v.endExclusive),N=!0),this.lineRange=v,this.firstCharOffsetByLine[0]=0;for(let L=this.lineRange.start;L<this.lineRange.endExclusive;L++){let w=m[L],c=0;if(N)c=w.length,w="",N=!1;else if(!A){const a=w.trimStart();c=w.length-a.length,w=a.trimEnd()}this.additionalOffsetByLine.push(c);for(let a=0;a<w.length;a++)this.elements.push(w.charCodeAt(a));L<m.length-1&&(this.elements.push(10),this.firstCharOffsetByLine[L-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new M.OffsetRange(0,this.length))}getText(m){return this.elements.slice(m.start,m.endExclusive).map(v=>String.fromCharCode(v)).join("")}getElement(m){return this.elements[m]}get length(){return this.elements.length}getBoundaryScore(m){const v=p(m>0?this.elements[m-1]:-1),A=p(m<this.elements.length?this.elements[m]:-1);if(v===f.LineBreakCR&&A===f.LineBreakLF)return 0;if(v===f.LineBreakLF)return 150;let N=0;return v!==A&&(N+=10,v===f.WordLower&&A===f.WordUpper&&(N+=1)),N+=d(v),N+=d(A),N}translateOffset(m){if(this.lineRange.isEmpty)return new g.Position(this.lineRange.start+1,1);const v=(0,t.findLastIdxMonotonous)(this.firstCharOffsetByLine,A=>A<=m);return new g.Position(this.lineRange.start+v+1,m-this.firstCharOffsetByLine[v]+this.additionalOffsetByLine[v]+1)}translateRange(m){return E.Range.fromPositions(this.translateOffset(m.start),this.translateOffset(m.endExclusive))}findWordContaining(m){if(m<0||m>=this.elements.length||!u(this.elements[m]))return;let v=m;for(;v>0&&u(this.elements[v-1]);)v--;let A=m;for(;A<this.elements.length&&u(this.elements[A]);)A++;return new M.OffsetRange(v,A)}countLinesIn(m){return this.translateOffset(m.endExclusive).lineNumber-this.translateOffset(m.start).lineNumber}isStronglyEqual(m,v){return this.elements[m]===this.elements[v]}extendToFullLines(m){const v=(0,t.findLastMonotonous)(this.firstCharOffsetByLine,N=>N<=m.start)??0,A=(0,t.findFirstMonotonous)(this.firstCharOffsetByLine,N=>m.endExclusive<=N)??this.elements.length;return new M.OffsetRange(v,A)}}i.LinesSliceCharSequence=l;function u(e){return e>=n.CharCode.a&&e<=n.CharCode.z||e>=n.CharCode.A&&e<=n.CharCode.Z||e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9}var f;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(f||(f={}));const _={[f.WordLower]:0,[f.WordUpper]:0,[f.WordNumber]:0,[f.End]:10,[f.Other]:2,[f.Separator]:30,[f.Space]:3,[f.LineBreakCR]:10,[f.LineBreakLF]:10};function d(e){return _[e]}function p(e){return e===n.CharCode.LineFeed?f.LineBreakLF:e===n.CharCode.CarriageReturn?f.LineBreakCR:(0,b.isSpace)(e)?f.Space:e>=n.CharCode.a&&e<=n.CharCode.z?f.WordLower:e>=n.CharCode.A&&e<=n.CharCode.Z?f.WordUpper:e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9?f.WordNumber:e===-1?f.End:e===n.CharCode.Comma||e===n.CharCode.Semicolon?f.Separator:f.Other}}),ne(ie[35],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MovedText=i.LinesDiff=void 0;class t{constructor(g,E,b){this.changes=g,this.moves=E,this.hitTimeout=b}}i.LinesDiff=t;class n{constructor(g,E){this.lineRangeMapping=g,this.changes=E}flip(){return new n(this.lineRangeMapping.flip(),this.changes.map(g=>g.flip()))}}i.MovedText=n}),ne(ie[19],re([0,1,4,15,2,50]),function(V,i,t,n,M,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RangeMapping=i.DetailedLineRangeMapping=i.LineRangeMapping=void 0;class E{static inverse(f,_,d){const p=[];let e=1,m=1;for(const A of f){const N=new E(new n.LineRange(e,A.original.startLineNumber),new n.LineRange(m,A.modified.startLineNumber));N.modified.isEmpty||p.push(N),e=A.original.endLineNumberExclusive,m=A.modified.endLineNumberExclusive}const v=new E(new n.LineRange(e,_+1),new n.LineRange(m,d+1));return v.modified.isEmpty||p.push(v),p}static clip(f,_,d){const p=[];for(const e of f){const m=e.original.intersect(_),v=e.modified.intersect(d);m&&!m.isEmpty&&v&&!v.isEmpty&&p.push(new E(m,v))}return p}constructor(f,_){this.original=f,this.modified=_}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new E(this.modified,this.original)}join(f){return new E(this.original.join(f.original),this.modified.join(f.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const f=this.original.toInclusiveRange(),_=this.modified.toInclusiveRange();if(f&&_)return new l(f,_);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new t.BugIndicatingError("not a valid diff");return new l(new M.Range(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new M.Range(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new l(new M.Range(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new M.Range(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}}i.LineRangeMapping=E;class b extends E{static fromRangeMappings(f){const _=n.LineRange.join(f.map(p=>n.LineRange.fromRangeInclusive(p.originalRange))),d=n.LineRange.join(f.map(p=>n.LineRange.fromRangeInclusive(p.modifiedRange)));return new b(_,d,f)}constructor(f,_,d){super(f,_),this.innerChanges=d}flip(){return new b(this.modified,this.original,this.innerChanges?.map(f=>f.flip()))}withInnerChangesFromLineRanges(){return new b(this.original,this.modified,[this.toRangeMapping()])}}i.DetailedLineRangeMapping=b;class l{constructor(f,_){this.originalRange=f,this.modifiedRange=_}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new l(this.modifiedRange,this.originalRange)}toTextEdit(f){const _=f.getValueOfRange(this.modifiedRange);return new g.SingleTextEdit(this.originalRange,_)}}i.RangeMapping=l}),ne(ie[55],re([0,1,10,19,7,9,16,15,6,34,18,33]),function(V,i,t,n,M,g,E,b,l,u,f,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeMovedLines=d;function d(L,w,c,a,s,o){let{moves:h,excludedChanges:D}=e(L,w,c,o);if(!o.isValid())return[];const R=L.filter(T=>!D.has(T)),S=m(R,a,s,w,c,o);return(0,M.pushMany)(h,S),h=A(h),h=h.filter(T=>{const y=T.original.toOffsetRange().slice(w).map(O=>O.trim());return y.join(`
`).length>=15&&p(y,O=>O.length>=2)>=2}),h=N(L,h),h}function p(L,w){let c=0;for(const a of L)w(a)&&c++;return c}function e(L,w,c,a){const s=[],o=L.filter(R=>R.modified.isEmpty&&R.original.length>=3).map(R=>new f.LineRangeFragment(R.original,w,R)),h=new Set(L.filter(R=>R.original.isEmpty&&R.modified.length>=3).map(R=>new f.LineRangeFragment(R.modified,c,R))),D=new Set;for(const R of o){let S=-1,T;for(const y of h){const k=R.computeSimilarity(y);k>S&&(S=k,T=y)}if(S>.9&&T&&(h.delete(T),s.push(new n.LineRangeMapping(R.range,T.range)),D.add(R.source),D.add(T.source)),!a.isValid())return{moves:s,excludedChanges:D}}return{moves:s,excludedChanges:D}}function m(L,w,c,a,s,o){const h=[],D=new E.SetMap;for(const k of L)for(let O=k.original.startLineNumber;O<k.original.endLineNumberExclusive-2;O++){const I=`${w[O-1]}:${w[O+1-1]}:${w[O+2-1]}`;D.add(I,{range:new b.LineRange(O,O+3)})}const R=[];L.sort((0,M.compareBy)(k=>k.modified.startLineNumber,M.numberComparator));for(const k of L){let O=[];for(let I=k.modified.startLineNumber;I<k.modified.endLineNumberExclusive-2;I++){const U=`${c[I-1]}:${c[I+1-1]}:${c[I+2-1]}`,$=new b.LineRange(I,I+3),q=[];D.forEach(U,({range:x})=>{for(const Y of O)if(Y.originalLineRange.endLineNumberExclusive+1===x.endLineNumberExclusive&&Y.modifiedLineRange.endLineNumberExclusive+1===$.endLineNumberExclusive){Y.originalLineRange=new b.LineRange(Y.originalLineRange.startLineNumber,x.endLineNumberExclusive),Y.modifiedLineRange=new b.LineRange(Y.modifiedLineRange.startLineNumber,$.endLineNumberExclusive),q.push(Y);return}const X={modifiedLineRange:$,originalLineRange:x};R.push(X),q.push(X)}),O=q}if(!o.isValid())return[]}R.sort((0,M.reverseOrder)((0,M.compareBy)(k=>k.modifiedLineRange.length,M.numberComparator)));const S=new b.LineRangeSet,T=new b.LineRangeSet;for(const k of R){const O=k.modifiedLineRange.startLineNumber-k.originalLineRange.startLineNumber,I=S.subtractFrom(k.modifiedLineRange),U=T.subtractFrom(k.originalLineRange).getWithDelta(O),$=I.getIntersection(U);for(const q of $.ranges){if(q.length<3)continue;const x=q,X=q.delta(-O);h.push(new n.LineRangeMapping(X,x)),S.addRange(x),T.addRange(X)}}h.sort((0,M.compareBy)(k=>k.original.startLineNumber,M.numberComparator));const y=new g.MonotonousArray(L);for(let k=0;k<h.length;k++){const O=h[k],I=y.findLastMonotonous(Q=>Q.original.startLineNumber<=O.original.startLineNumber),U=(0,g.findLastMonotonous)(L,Q=>Q.modified.startLineNumber<=O.modified.startLineNumber),$=Math.max(O.original.startLineNumber-I.original.startLineNumber,O.modified.startLineNumber-U.modified.startLineNumber),q=y.findLastMonotonous(Q=>Q.original.startLineNumber<O.original.endLineNumberExclusive),x=(0,g.findLastMonotonous)(L,Q=>Q.modified.startLineNumber<O.modified.endLineNumberExclusive),X=Math.max(q.original.endLineNumberExclusive-O.original.endLineNumberExclusive,x.modified.endLineNumberExclusive-O.modified.endLineNumberExclusive);let Y;for(Y=0;Y<$;Y++){const Q=O.original.startLineNumber-Y-1,K=O.modified.startLineNumber-Y-1;if(Q>a.length||K>s.length||S.contains(K)||T.contains(Q)||!v(a[Q-1],s[K-1],o))break}Y>0&&(T.addRange(new b.LineRange(O.original.startLineNumber-Y,O.original.startLineNumber)),S.addRange(new b.LineRange(O.modified.startLineNumber-Y,O.modified.startLineNumber)));let G;for(G=0;G<X;G++){const Q=O.original.endLineNumberExclusive+G,K=O.modified.endLineNumberExclusive+G;if(Q>a.length||K>s.length||S.contains(K)||T.contains(Q)||!v(a[Q-1],s[K-1],o))break}G>0&&(T.addRange(new b.LineRange(O.original.endLineNumberExclusive,O.original.endLineNumberExclusive+G)),S.addRange(new b.LineRange(O.modified.endLineNumberExclusive,O.modified.endLineNumberExclusive+G))),(Y>0||G>0)&&(h[k]=new n.LineRangeMapping(new b.LineRange(O.original.startLineNumber-Y,O.original.endLineNumberExclusive+G),new b.LineRange(O.modified.startLineNumber-Y,O.modified.endLineNumberExclusive+G)))}return h}function v(L,w,c){if(L.trim()===w.trim())return!0;if(L.length>300&&w.length>300)return!1;const s=new _.MyersDiffAlgorithm().compute(new u.LinesSliceCharSequence([L],new l.OffsetRange(0,1),!1),new u.LinesSliceCharSequence([w],new l.OffsetRange(0,1),!1),c);let o=0;const h=t.SequenceDiff.invert(s.diffs,L.length);for(const T of h)T.seq1Range.forEach(y=>{(0,f.isSpace)(L.charCodeAt(y))||o++});function D(T){let y=0;for(let k=0;k<L.length;k++)(0,f.isSpace)(T.charCodeAt(k))||y++;return y}const R=D(L.length>w.length?L:w);return o/R>.6&&R>10}function A(L){if(L.length===0)return L;L.sort((0,M.compareBy)(c=>c.original.startLineNumber,M.numberComparator));const w=[L[0]];for(let c=1;c<L.length;c++){const a=w[w.length-1],s=L[c],o=s.original.startLineNumber-a.original.endLineNumberExclusive,h=s.modified.startLineNumber-a.modified.endLineNumberExclusive;if(o>=0&&h>=0&&o+h<=2){w[w.length-1]=a.join(s);continue}w.push(s)}return w}function N(L,w){const c=new g.MonotonousArray(L);return w=w.filter(a=>{const s=c.findLastMonotonous(D=>D.original.startLineNumber<a.original.endLineNumberExclusive)||new n.LineRangeMapping(new b.LineRange(1,1),new b.LineRange(1,1)),o=(0,g.findLastMonotonous)(L,D=>D.modified.startLineNumber<a.modified.endLineNumberExclusive);return s!==o}),w}}),ne(ie[56],re([0,1,7,11,15,6,2,10,54,33,55,52,53,34,35,19]),function(V,i,t,n,M,g,E,b,l,u,f,_,d,p,e,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DefaultLinesDiffComputer=void 0,i.lineRangeMappingFromRangeMappings=A,i.getLineRangeMapping=N;class v{constructor(){this.dynamicProgrammingDiffing=new l.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new u.MyersDiffAlgorithm}computeDiff(w,c,a){if(w.length<=1&&(0,t.equals)(w,c,(G,Q)=>G===Q))return new e.LinesDiff([],[],!1);if(w.length===1&&w[0].length===0||c.length===1&&c[0].length===0)return new e.LinesDiff([new m.DetailedLineRangeMapping(new M.LineRange(1,w.length+1),new M.LineRange(1,c.length+1),[new m.RangeMapping(new E.Range(1,1,w.length,w[w.length-1].length+1),new E.Range(1,1,c.length,c[c.length-1].length+1))])],[],!1);const s=a.maxComputationTimeMs===0?b.InfiniteTimeout.instance:new b.DateTimeout(a.maxComputationTimeMs),o=!a.ignoreTrimWhitespace,h=new Map;function D(G){let Q=h.get(G);return Q===void 0&&(Q=h.size,h.set(G,Q)),Q}const R=w.map(G=>D(G.trim())),S=c.map(G=>D(G.trim())),T=new d.LineSequence(R,w),y=new d.LineSequence(S,c),k=T.length+y.length<1700?this.dynamicProgrammingDiffing.compute(T,y,s,(G,Q)=>w[G]===c[Q]?c[Q].length===0?.1:1+Math.log(1+c[Q].length):.99):this.myersDiffingAlgorithm.compute(T,y,s);let O=k.diffs,I=k.hitTimeout;O=(0,_.optimizeSequenceDiffs)(T,y,O),O=(0,_.removeVeryShortMatchingLinesBetweenDiffs)(T,y,O);const U=[],$=G=>{if(o)for(let Q=0;Q<G;Q++){const K=q+Q,F=x+Q;if(w[K]!==c[F]){const j=this.refineDiff(w,c,new b.SequenceDiff(new g.OffsetRange(K,K+1),new g.OffsetRange(F,F+1)),s,o);for(const fe of j.mappings)U.push(fe);j.hitTimeout&&(I=!0)}}};let q=0,x=0;for(const G of O){(0,n.assertFn)(()=>G.seq1Range.start-q===G.seq2Range.start-x);const Q=G.seq1Range.start-q;$(Q),q=G.seq1Range.endExclusive,x=G.seq2Range.endExclusive;const K=this.refineDiff(w,c,G,s,o);K.hitTimeout&&(I=!0);for(const F of K.mappings)U.push(F)}$(w.length-q);const X=A(U,w,c);let Y=[];return a.computeMoves&&(Y=this.computeMoves(X,w,c,R,S,s,o)),(0,n.assertFn)(()=>{function G(K,F){if(K.lineNumber<1||K.lineNumber>F.length)return!1;const j=F[K.lineNumber-1];return!(K.column<1||K.column>j.length+1)}function Q(K,F){return!(K.startLineNumber<1||K.startLineNumber>F.length+1||K.endLineNumberExclusive<1||K.endLineNumberExclusive>F.length+1)}for(const K of X){if(!K.innerChanges)return!1;for(const F of K.innerChanges)if(!(G(F.modifiedRange.getStartPosition(),c)&&G(F.modifiedRange.getEndPosition(),c)&&G(F.originalRange.getStartPosition(),w)&&G(F.originalRange.getEndPosition(),w)))return!1;if(!Q(K.modified,c)||!Q(K.original,w))return!1}return!0}),new e.LinesDiff(X,Y,I)}computeMoves(w,c,a,s,o,h,D){return(0,f.computeMovedLines)(w,c,a,s,o,h).map(T=>{const y=this.refineDiff(c,a,new b.SequenceDiff(T.original.toOffsetRange(),T.modified.toOffsetRange()),h,D),k=A(y.mappings,c,a,!0);return new e.MovedText(T,k)})}refineDiff(w,c,a,s,o){const h=new p.LinesSliceCharSequence(w,a.seq1Range,o),D=new p.LinesSliceCharSequence(c,a.seq2Range,o),R=h.length+D.length<500?this.dynamicProgrammingDiffing.compute(h,D,s):this.myersDiffingAlgorithm.compute(h,D,s);let S=R.diffs;return S=(0,_.optimizeSequenceDiffs)(h,D,S),S=(0,_.extendDiffsToEntireWordIfAppropriate)(h,D,S),S=(0,_.removeShortMatches)(h,D,S),S=(0,_.removeVeryShortMatchingTextBetweenLongDiffs)(h,D,S),{mappings:S.map(y=>new m.RangeMapping(h.translateRange(y.seq1Range),D.translateRange(y.seq2Range))),hitTimeout:R.hitTimeout}}}i.DefaultLinesDiffComputer=v;function A(L,w,c,a=!1){const s=[];for(const o of(0,t.groupAdjacentBy)(L.map(h=>N(h,w,c)),(h,D)=>h.original.overlapOrTouch(D.original)||h.modified.overlapOrTouch(D.modified))){const h=o[0],D=o[o.length-1];s.push(new m.DetailedLineRangeMapping(h.original.join(D.original),h.modified.join(D.modified),o.map(R=>R.innerChanges[0])))}return(0,n.assertFn)(()=>!a&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||c.length-s[s.length-1].modified.endLineNumberExclusive!==w.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,n.checkAdjacentItems)(s,(o,h)=>h.original.startLineNumber-o.original.endLineNumberExclusive===h.modified.startLineNumber-o.modified.endLineNumberExclusive&&o.original.endLineNumberExclusive<h.original.startLineNumber&&o.modified.endLineNumberExclusive<h.modified.startLineNumber)),s}function N(L,w,c){let a=0,s=0;L.modifiedRange.endColumn===1&&L.originalRange.endColumn===1&&L.originalRange.startLineNumber+a<=L.originalRange.endLineNumber&&L.modifiedRange.startLineNumber+a<=L.modifiedRange.endLineNumber&&(s=-1),L.modifiedRange.startColumn-1>=c[L.modifiedRange.startLineNumber-1].length&&L.originalRange.startColumn-1>=w[L.originalRange.startLineNumber-1].length&&L.originalRange.startLineNumber<=L.originalRange.endLineNumber+s&&L.modifiedRange.startLineNumber<=L.modifiedRange.endLineNumber+s&&(a=1);const o=new M.LineRange(L.originalRange.startLineNumber+a,L.originalRange.endLineNumber+1+s),h=new M.LineRange(L.modifiedRange.startLineNumber+a,L.modifiedRange.endLineNumber+1+s);return new m.DetailedLineRangeMapping(o,h,[L])}}),ne(ie[36],re([0,1,3,29,35,19,8,2,11,15]),function(V,i,t,n,M,g,E,b,l,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiffComputer=i.LegacyLinesDiffComputer=void 0;const f=3;class _{computeDiff(s,o,h){const R=new N(s,o,{maxComputationTime:h.maxComputationTimeMs,shouldIgnoreTrimWhitespace:h.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),S=[];let T=null;for(const y of R.changes){let k;y.originalEndLineNumber===0?k=new u.LineRange(y.originalStartLineNumber+1,y.originalStartLineNumber+1):k=new u.LineRange(y.originalStartLineNumber,y.originalEndLineNumber+1);let O;y.modifiedEndLineNumber===0?O=new u.LineRange(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):O=new u.LineRange(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let I=new g.DetailedLineRangeMapping(k,O,y.charChanges?.map(U=>new g.RangeMapping(new b.Range(U.originalStartLineNumber,U.originalStartColumn,U.originalEndLineNumber,U.originalEndColumn),new b.Range(U.modifiedStartLineNumber,U.modifiedStartColumn,U.modifiedEndLineNumber,U.modifiedEndColumn))));T&&(T.modified.endLineNumberExclusive===I.modified.startLineNumber||T.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new g.DetailedLineRangeMapping(T.original.join(I.original),T.modified.join(I.modified),T.innerChanges&&I.innerChanges?T.innerChanges.concat(I.innerChanges):void 0),S.pop()),S.push(I),T=I}return(0,l.assertFn)(()=>(0,l.checkAdjacentItems)(S,(y,k)=>k.original.startLineNumber-y.original.endLineNumberExclusive===k.modified.startLineNumber-y.modified.endLineNumberExclusive&&y.original.endLineNumberExclusive<k.original.startLineNumber&&y.modified.endLineNumberExclusive<k.modified.startLineNumber)),new M.LinesDiff(S,[],R.quitEarly)}}i.LegacyLinesDiffComputer=_;function d(a,s,o,h){return new n.LcsDiff(a,s,o).ComputeDiff(h)}class p{constructor(s){const o=[],h=[];for(let D=0,R=s.length;D<R;D++)o[D]=L(s[D],1),h[D]=w(s[D],1);this.lines=s,this._startColumns=o,this._endColumns=h}getElements(){const s=[];for(let o=0,h=this.lines.length;o<h;o++)s[o]=this.lines[o].substring(this._startColumns[o]-1,this._endColumns[o]-1);return s}getStrictElement(s){return this.lines[s]}getStartLineNumber(s){return s+1}getEndLineNumber(s){return s+1}createCharSequence(s,o,h){const D=[],R=[],S=[];let T=0;for(let y=o;y<=h;y++){const k=this.lines[y],O=s?this._startColumns[y]:1,I=s?this._endColumns[y]:k.length+1;for(let U=O;U<I;U++)D[T]=k.charCodeAt(U-1),R[T]=y+1,S[T]=U,T++;!s&&y<h&&(D[T]=t.CharCode.LineFeed,R[T]=y+1,S[T]=k.length+1,T++)}return new e(D,R,S)}}class e{constructor(s,o,h){this._charCodes=s,this._lineNumbers=o,this._columns=h}toString(){return"["+this._charCodes.map((s,o)=>(s===t.CharCode.LineFeed?"\\n":String.fromCharCode(s))+`-(${this._lineNumbers[o]},${this._columns[o]})`).join(", ")+"]"}_assertIndex(s,o){if(s<0||s>=o.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(s){return s>0&&s===this._lineNumbers.length?this.getEndLineNumber(s-1):(this._assertIndex(s,this._lineNumbers),this._lineNumbers[s])}getEndLineNumber(s){return s===-1?this.getStartLineNumber(s+1):(this._assertIndex(s,this._lineNumbers),this._charCodes[s]===t.CharCode.LineFeed?this._lineNumbers[s]+1:this._lineNumbers[s])}getStartColumn(s){return s>0&&s===this._columns.length?this.getEndColumn(s-1):(this._assertIndex(s,this._columns),this._columns[s])}getEndColumn(s){return s===-1?this.getStartColumn(s+1):(this._assertIndex(s,this._columns),this._charCodes[s]===t.CharCode.LineFeed?1:this._columns[s]+1)}}class m{constructor(s,o,h,D,R,S,T,y){this.originalStartLineNumber=s,this.originalStartColumn=o,this.originalEndLineNumber=h,this.originalEndColumn=D,this.modifiedStartLineNumber=R,this.modifiedStartColumn=S,this.modifiedEndLineNumber=T,this.modifiedEndColumn=y}static createFromDiffChange(s,o,h){const D=o.getStartLineNumber(s.originalStart),R=o.getStartColumn(s.originalStart),S=o.getEndLineNumber(s.originalStart+s.originalLength-1),T=o.getEndColumn(s.originalStart+s.originalLength-1),y=h.getStartLineNumber(s.modifiedStart),k=h.getStartColumn(s.modifiedStart),O=h.getEndLineNumber(s.modifiedStart+s.modifiedLength-1),I=h.getEndColumn(s.modifiedStart+s.modifiedLength-1);return new m(D,R,S,T,y,k,O,I)}}function v(a){if(a.length<=1)return a;const s=[a[0]];let o=s[0];for(let h=1,D=a.length;h<D;h++){const R=a[h],S=R.originalStart-(o.originalStart+o.originalLength),T=R.modifiedStart-(o.modifiedStart+o.modifiedLength);Math.min(S,T)<f?(o.originalLength=R.originalStart+R.originalLength-o.originalStart,o.modifiedLength=R.modifiedStart+R.modifiedLength-o.modifiedStart):(s.push(R),o=R)}return s}class A{constructor(s,o,h,D,R){this.originalStartLineNumber=s,this.originalEndLineNumber=o,this.modifiedStartLineNumber=h,this.modifiedEndLineNumber=D,this.charChanges=R}static createFromDiffResult(s,o,h,D,R,S,T){let y,k,O,I,U;if(o.originalLength===0?(y=h.getStartLineNumber(o.originalStart)-1,k=0):(y=h.getStartLineNumber(o.originalStart),k=h.getEndLineNumber(o.originalStart+o.originalLength-1)),o.modifiedLength===0?(O=D.getStartLineNumber(o.modifiedStart)-1,I=0):(O=D.getStartLineNumber(o.modifiedStart),I=D.getEndLineNumber(o.modifiedStart+o.modifiedLength-1)),S&&o.originalLength>0&&o.originalLength<20&&o.modifiedLength>0&&o.modifiedLength<20&&R()){const $=h.createCharSequence(s,o.originalStart,o.originalStart+o.originalLength-1),q=D.createCharSequence(s,o.modifiedStart,o.modifiedStart+o.modifiedLength-1);if($.getElements().length>0&&q.getElements().length>0){let x=d($,q,R,!0).changes;T&&(x=v(x)),U=[];for(let X=0,Y=x.length;X<Y;X++)U.push(m.createFromDiffChange(x[X],$,q))}}return new A(y,k,O,I,U)}}class N{constructor(s,o,h){this.shouldComputeCharChanges=h.shouldComputeCharChanges,this.shouldPostProcessCharChanges=h.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=h.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=h.shouldMakePrettyDiff,this.originalLines=s,this.modifiedLines=o,this.original=new p(s),this.modified=new p(o),this.continueLineDiff=c(h.maxComputationTime),this.continueCharDiff=c(h.maxComputationTime===0?0:Math.min(h.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const s=d(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),o=s.changes,h=s.quitEarly;if(this.shouldIgnoreTrimWhitespace){const T=[];for(let y=0,k=o.length;y<k;y++)T.push(A.createFromDiffResult(this.shouldIgnoreTrimWhitespace,o[y],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:h,changes:T}}const D=[];let R=0,S=0;for(let T=-1,y=o.length;T<y;T++){const k=T+1<y?o[T+1]:null,O=k?k.originalStart:this.originalLines.length,I=k?k.modifiedStart:this.modifiedLines.length;for(;R<O&&S<I;){const U=this.originalLines[R],$=this.modifiedLines[S];if(U!==$){{let q=L(U,1),x=L($,1);for(;q>1&&x>1;){const X=U.charCodeAt(q-2),Y=$.charCodeAt(x-2);if(X!==Y)break;q--,x--}(q>1||x>1)&&this._pushTrimWhitespaceCharChange(D,R+1,1,q,S+1,1,x)}{let q=w(U,1),x=w($,1);const X=U.length+1,Y=$.length+1;for(;q<X&&x<Y;){const G=U.charCodeAt(q-1),Q=U.charCodeAt(x-1);if(G!==Q)break;q++,x++}(q<X||x<Y)&&this._pushTrimWhitespaceCharChange(D,R+1,q,X,S+1,x,Y)}}R++,S++}k&&(D.push(A.createFromDiffResult(this.shouldIgnoreTrimWhitespace,k,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),R+=k.originalLength,S+=k.modifiedLength)}return{quitEarly:h,changes:D}}_pushTrimWhitespaceCharChange(s,o,h,D,R,S,T){if(this._mergeTrimWhitespaceCharChange(s,o,h,D,R,S,T))return;let y;this.shouldComputeCharChanges&&(y=[new m(o,h,o,D,R,S,R,T)]),s.push(new A(o,o,R,R,y))}_mergeTrimWhitespaceCharChange(s,o,h,D,R,S,T){const y=s.length;if(y===0)return!1;const k=s[y-1];return k.originalEndLineNumber===0||k.modifiedEndLineNumber===0?!1:k.originalEndLineNumber===o&&k.modifiedEndLineNumber===R?(this.shouldComputeCharChanges&&k.charChanges&&k.charChanges.push(new m(o,h,o,D,R,S,R,T)),!0):k.originalEndLineNumber+1===o&&k.modifiedEndLineNumber+1===R?(k.originalEndLineNumber=o,k.modifiedEndLineNumber=R,this.shouldComputeCharChanges&&k.charChanges&&k.charChanges.push(new m(o,h,o,D,R,S,R,T)),!0):!1}}i.DiffComputer=N;function L(a,s){const o=E.firstNonWhitespaceIndex(a);return o===-1?s:o+1}function w(a,s){const o=E.lastNonWhitespaceIndex(a);return o===-1?s:o+2}function c(a){if(a===0)return()=>!0;const s=Date.now();return()=>Date.now()-s<a}}),ne(ie[57],re([0,1,36,56]),function(V,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.linesDiffComputers=void 0,i.linesDiffComputers={getLegacy:()=>new t.LegacyLinesDiffComputer,getDefault:()=>new n.DefaultLinesDiffComputer}}),ne(ie[58],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TokenMetadata=i.MetadataConsts=i.StandardTokenType=i.ColorId=i.FontStyle=i.LanguageId=void 0;var t;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(t||(i.LanguageId=t={}));var n;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline",l[l.Strikethrough=8]="Strikethrough"})(n||(i.FontStyle=n={}));var M;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(M||(i.ColorId=M={}));var g;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=3]="RegEx"})(g||(i.StandardTokenType=g={}));var E;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",l[l.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",l[l.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",l[l.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(E||(i.MetadataConsts=E={}));class b{static getLanguageId(u){return(u&E.LANGUAGEID_MASK)>>>E.LANGUAGEID_OFFSET}static getTokenType(u){return(u&E.TOKEN_TYPE_MASK)>>>E.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(u){return(u&E.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(u){return(u&E.FONT_STYLE_MASK)>>>E.FONT_STYLE_OFFSET}static getForeground(u){return(u&E.FOREGROUND_MASK)>>>E.FOREGROUND_OFFSET}static getBackground(u){return(u&E.BACKGROUND_MASK)>>>E.BACKGROUND_OFFSET}static getClassNameFromMetadata(u){let _="mtk"+this.getForeground(u);const d=this.getFontStyle(u);return d&n.Italic&&(_+=" mtki"),d&n.Bold&&(_+=" mtkb"),d&n.Underline&&(_+=" mtku"),d&n.Strikethrough&&(_+=" mtks"),_}static getInlineStyleFromMetadata(u,f){const _=this.getForeground(u),d=this.getFontStyle(u);let p=`color: ${f[_]};`;d&n.Italic&&(p+="font-style: italic;"),d&n.Bold&&(p+="font-weight: bold;");let e="";return d&n.Underline&&(e+=" underline"),d&n.Strikethrough&&(e+=" line-through"),e&&(p+=`text-decoration:${e};`),p}static getPresentationFromMetadata(u){const f=this.getForeground(u),_=this.getFontStyle(u);return{foreground:f,italic:!!(_&n.Italic),bold:!!(_&n.Bold),underline:!!(_&n.Underline),strikethrough:!!(_&n.Strikethrough)}}}i.TokenMetadata=b}),ne(ie[59],re([0,1,38]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeDefaultDocumentColors=_;function n(d){const p=[];for(const e of d){const m=Number(e);(m||m===0&&e.replace(/\s/g,"")!=="")&&p.push(m)}return p}function M(d,p,e,m){return{red:d/255,blue:e/255,green:p/255,alpha:m}}function g(d,p){const e=p.index,m=p[0].length;if(!e)return;const v=d.positionAt(e);return{startLineNumber:v.lineNumber,startColumn:v.column,endLineNumber:v.lineNumber,endColumn:v.column+m}}function E(d,p){if(!d)return;const e=t.Color.Format.CSS.parseHex(p);if(e)return{range:d,color:M(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function b(d,p,e){if(!d||p.length!==1)return;const v=p[0].values(),A=n(v);return{range:d,color:M(A[0],A[1],A[2],e?A[3]:1)}}function l(d,p,e){if(!d||p.length!==1)return;const v=p[0].values(),A=n(v),N=new t.Color(new t.HSLA(A[0],A[1]/100,A[2]/100,e?A[3]:1));return{range:d,color:M(N.rgba.r,N.rgba.g,N.rgba.b,N.rgba.a)}}function u(d,p){return typeof d=="string"?[...d.matchAll(p)]:d.findMatches(p)}function f(d){const p=[],m=u(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(m.length>0)for(const v of m){const A=v.filter(c=>c!==void 0),N=A[1],L=A[2];if(!L)continue;let w;if(N==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;w=b(g(d,v),u(L,c),!1)}else if(N==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;w=b(g(d,v),u(L,c),!0)}else if(N==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;w=l(g(d,v),u(L,c),!1)}else if(N==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;w=l(g(d,v),u(L,c),!0)}else N==="#"&&(w=E(g(d,v),N+L));w&&p.push(w)}return p}function _(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:f(d)}}),ne(ie[60],re([0,1,3,30]),function(V,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LinkComputer=i.StateMachine=i.State=void 0,i.computeLinks=p;var M;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(M||(i.State=M={}));class g{constructor(m,v,A){const N=new Uint8Array(m*v);for(let L=0,w=m*v;L<w;L++)N[L]=A;this._data=N,this.rows=m,this.cols=v}get(m,v){return this._data[m*this.cols+v]}set(m,v,A){this._data[m*this.cols+v]=A}}class E{constructor(m){let v=0,A=M.Invalid;for(let L=0,w=m.length;L<w;L++){const[c,a,s]=m[L];a>v&&(v=a),c>A&&(A=c),s>A&&(A=s)}v++,A++;const N=new g(A,v,M.Invalid);for(let L=0,w=m.length;L<w;L++){const[c,a,s]=m[L];N.set(c,a,s)}this._states=N,this._maxCharCode=v}nextState(m,v){return v<0||v>=this._maxCharCode?M.Invalid:this._states.get(m,v)}}i.StateMachine=E;let b=null;function l(){return b===null&&(b=new E([[M.Start,t.CharCode.h,M.H],[M.Start,t.CharCode.H,M.H],[M.Start,t.CharCode.f,M.F],[M.Start,t.CharCode.F,M.F],[M.H,t.CharCode.t,M.HT],[M.H,t.CharCode.T,M.HT],[M.HT,t.CharCode.t,M.HTT],[M.HT,t.CharCode.T,M.HTT],[M.HTT,t.CharCode.p,M.HTTP],[M.HTT,t.CharCode.P,M.HTTP],[M.HTTP,t.CharCode.s,M.BeforeColon],[M.HTTP,t.CharCode.S,M.BeforeColon],[M.HTTP,t.CharCode.Colon,M.AfterColon],[M.F,t.CharCode.i,M.FI],[M.F,t.CharCode.I,M.FI],[M.FI,t.CharCode.l,M.FIL],[M.FI,t.CharCode.L,M.FIL],[M.FIL,t.CharCode.e,M.BeforeColon],[M.FIL,t.CharCode.E,M.BeforeColon],[M.BeforeColon,t.CharCode.Colon,M.AfterColon],[M.AfterColon,t.CharCode.Slash,M.AlmostThere],[M.AlmostThere,t.CharCode.Slash,M.End]])),b}var u;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let f=null;function _(){if(f===null){f=new n.CharacterClassifier(u.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<e.length;v++)f.set(e.charCodeAt(v),u.ForceTermination);const m=".,;:";for(let v=0;v<m.length;v++)f.set(m.charCodeAt(v),u.CannotEndIn)}return f}class d{static _createLink(m,v,A,N,L){let w=L-1;do{const c=v.charCodeAt(w);if(m.get(c)!==u.CannotEndIn)break;w--}while(w>N);if(N>0){const c=v.charCodeAt(N-1),a=v.charCodeAt(w);(c===t.CharCode.OpenParen&&a===t.CharCode.CloseParen||c===t.CharCode.OpenSquareBracket&&a===t.CharCode.CloseSquareBracket||c===t.CharCode.OpenCurlyBrace&&a===t.CharCode.CloseCurlyBrace)&&w--}return{range:{startLineNumber:A,startColumn:N+1,endLineNumber:A,endColumn:w+2},url:v.substring(N,w+1)}}static computeLinks(m,v=l()){const A=_(),N=[];for(let L=1,w=m.getLineCount();L<=w;L++){const c=m.getLineContent(L),a=c.length;let s=0,o=0,h=0,D=M.Start,R=!1,S=!1,T=!1,y=!1;for(;s<a;){let k=!1;const O=c.charCodeAt(s);if(D===M.Accept){let I;switch(O){case t.CharCode.OpenParen:R=!0,I=u.None;break;case t.CharCode.CloseParen:I=R?u.None:u.ForceTermination;break;case t.CharCode.OpenSquareBracket:T=!0,S=!0,I=u.None;break;case t.CharCode.CloseSquareBracket:T=!1,I=S?u.None:u.ForceTermination;break;case t.CharCode.OpenCurlyBrace:y=!0,I=u.None;break;case t.CharCode.CloseCurlyBrace:I=y?u.None:u.ForceTermination;break;case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.BackTick:h===O?I=u.ForceTermination:h===t.CharCode.SingleQuote||h===t.CharCode.DoubleQuote||h===t.CharCode.BackTick?I=u.None:I=u.ForceTermination;break;case t.CharCode.Asterisk:I=h===t.CharCode.Asterisk?u.ForceTermination:u.None;break;case t.CharCode.Pipe:I=h===t.CharCode.Pipe?u.ForceTermination:u.None;break;case t.CharCode.Space:I=T?u.None:u.ForceTermination;break;default:I=A.get(O)}I===u.ForceTermination&&(N.push(d._createLink(A,c,L,o,s)),k=!0)}else if(D===M.End){let I;O===t.CharCode.OpenSquareBracket?(S=!0,I=u.None):I=A.get(O),I===u.ForceTermination?k=!0:D=M.Accept}else D=v.nextState(D,O),D===M.Invalid&&(k=!0);k&&(D=M.Start,R=!1,S=!1,y=!1,o=s+1,h=O),s++}D===M.Accept&&N.push(d._createLink(A,c,L,o,a))}return N}}i.LinkComputer=d;function p(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:d.computeLinks(e)}}),ne(ie[61],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.BasicInplaceReplace=void 0;class t{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new t}navigateValueSet(M,g,E,b,l){if(M&&g){const u=this.doNavigateValueSet(g,l);if(u)return{range:M,value:u}}if(E&&b){const u=this.doNavigateValueSet(b,l);if(u)return{range:E,value:u}}return null}doNavigateValueSet(M,g){const E=this.numberReplace(M,g);return E!==null?E:this.textReplace(M,g)}numberReplace(M,g){const E=Math.pow(10,M.length-(M.lastIndexOf(".")+1));let b=Number(M);const l=parseFloat(M);return!isNaN(b)&&!isNaN(l)&&b===l?b===0&&!g?null:(b=Math.floor(b*E),b+=g?E:-E,String(b/E)):null}textReplace(M,g){return this.valueSetsReplace(this._defaultValueSet,M,g)}valueSetsReplace(M,g,E){let b=null;for(let l=0,u=M.length;b===null&&l<u;l++)b=this.valueSetReplace(M[l],g,E);return b}valueSetReplace(M,g,E){let b=M.indexOf(g);return b>=0?(b+=E?1:-1,b<0?b=M.length-1:b%=M.length,M[b]):null}}i.BasicInplaceReplace=t}),ne(ie[62],re([0,1,17]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ApplyEditsResult=i.SearchData=i.ValidAnnotatedEditOperation=i.ModelConstants=i.PositionAffinity=i.TrackedRangeStickiness=i.FindMatch=i.TextModelResolvedOptions=i.EndOfLineSequence=i.DefaultEndOfLine=i.EndOfLinePreference=i.InjectedTextCursorStops=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.GlyphMarginLane=i.OverviewRulerLane=void 0,i.isITextSnapshot=e,i.shouldSynchronizeModel=w;var n;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(n||(i.OverviewRulerLane=n={}));var M;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=3]="Right"})(M||(i.GlyphMarginLane=M={}));var g;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(g||(i.MinimapPosition=g={}));var E;(function(c){c[c.Normal=1]="Normal",c[c.Underlined=2]="Underlined"})(E||(i.MinimapSectionHeaderStyle=E={}));var b;(function(c){c[c.Both=0]="Both",c[c.Right=1]="Right",c[c.Left=2]="Left",c[c.None=3]="None"})(b||(i.InjectedTextCursorStops=b={}));var l;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(l||(i.EndOfLinePreference=l={}));var u;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(u||(i.DefaultEndOfLine=u={}));var f;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(f||(i.EndOfLineSequence=f={}));class _{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,a.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this._indentSizeIsTabSize===a._indentSizeIsTabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,t.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}i.TextModelResolvedOptions=_;class d{constructor(a,s){this._findMatchBrand=void 0,this.range=a,this.matches=s}}i.FindMatch=d;var p;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(i.TrackedRangeStickiness=p={}));function e(c){return c&&typeof c.read=="function"}var m;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right",c[c.None=2]="None",c[c.LeftOfInjectedText=3]="LeftOfInjectedText",c[c.RightOfInjectedText=4]="RightOfInjectedText"})(m||(i.PositionAffinity=m={}));var v;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(i.ModelConstants=v={}));class A{constructor(a,s,o,h,D,R){this.identifier=a,this.range=s,this.text=o,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=D,this._isTracked=R}}i.ValidAnnotatedEditOperation=A;class N{constructor(a,s,o){this.regex=a,this.wordSeparators=s,this.simpleSearch=o}}i.SearchData=N;class L{constructor(a,s,o){this.reverseEdits=a,this.changes=s,this.trimAutoWhitespaceLineNumbers=o}}i.ApplyEditsResult=L;function w(c){return!c.isTooLargeForSyncing()&&!c.isForSimpleWidget}}),ne(ie[63],re([0,1,7,14]),function(V,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PrefixSumIndexOfResult=i.ConstantTimePrefixSumComputer=i.PrefixSumComputer=void 0;class M{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(l,u){l=(0,n.toUint32)(l);const f=this.values,_=this.prefixSum,d=u.length;return d===0?!1:(this.values=new Uint32Array(f.length+d),this.values.set(f.subarray(0,l),0),this.values.set(f.subarray(l),l+d),this.values.set(u,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(_.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,u){return l=(0,n.toUint32)(l),u=(0,n.toUint32)(u),this.values[l]===u?!1:(this.values[l]=u,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,u){l=(0,n.toUint32)(l),u=(0,n.toUint32)(u);const f=this.values,_=this.prefixSum;if(l>=f.length)return!1;const d=f.length-l;return u>=d&&(u=d),u===0?!1:(this.values=new Uint32Array(f.length-u),this.values.set(f.subarray(0,l),0),this.values.set(f.subarray(l+u),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(_.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,n.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let u=this.prefixSumValidIndex[0]+1;u===0&&(this.prefixSum[0]=this.values[0],u++),l>=this.values.length&&(l=this.values.length-1);for(let f=u;f<=l;f++)this.prefixSum[f]=this.prefixSum[f-1]+this.values[f];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let u=0,f=this.values.length-1,_=0,d=0,p=0;for(;u<=f;)if(_=u+(f-u)/2|0,d=this.prefixSum[_],p=d-this.values[_],l<p)f=_-1;else if(l>=d)u=_+1;else break;return new E(_,l-p)}}i.PrefixSumComputer=M;class g{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const u=this._indexBySum[l],f=u>0?this._prefixSum[u-1]:0;return new E(u,l-f)}removeValues(l,u){this._values.splice(l,u),this._invalidate(l)}insertValues(l,u){this._values=(0,t.arrayInsert)(this._values,l,u),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,u=this._values.length;l<u;l++){const f=this._values[l],_=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=_+f;for(let d=0;d<f;d++)this._indexBySum[_+d]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,u){this._values[l]!==u&&(this._values[l]=u,this._invalidate(l))}}i.ConstantTimePrefixSumComputer=g;class E{constructor(l,u){this.index=l,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=u}}i.PrefixSumIndexOfResult=E}),ne(ie[64],re([0,1,8,5,63]),function(V,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MirrorTextModel=void 0;class g{constructor(b,l,u,f){this._uri=b,this._lines=l,this._eol=u,this._versionId=f,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(b){b.eol&&b.eol!==this._eol&&(this._eol=b.eol,this._lineStarts=null);const l=b.changes;for(const u of l)this._acceptDeleteRange(u.range),this._acceptInsertText(new n.Position(u.range.startLineNumber,u.range.startColumn),u.text);this._versionId=b.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const b=this._eol.length,l=this._lines.length,u=new Uint32Array(l);for(let f=0;f<l;f++)u[f]=this._lines[f].length+b;this._lineStarts=new M.PrefixSumComputer(u)}}_setLineText(b,l){this._lines[b]=l,this._lineStarts&&this._lineStarts.setValue(b,this._lines[b].length+this._eol.length)}_acceptDeleteRange(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.startLineNumber-1].substring(b.endColumn-1));return}this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.endLineNumber-1].substring(b.endColumn-1)),this._lines.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}_acceptInsertText(b,l){if(l.length===0)return;const u=(0,t.splitLines)(l);if(u.length===1){this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+u[0]+this._lines[b.lineNumber-1].substring(b.column-1));return}u[u.length-1]+=this._lines[b.lineNumber-1].substring(b.column-1),this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+u[0]);const f=new Uint32Array(u.length-1);for(let _=1;_<u.length;_++)this._lines.splice(b.lineNumber+_-1,0,u[_]),f[_-1]=u[_].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(b.lineNumber,f)}}i.MirrorTextModel=g}),ne(ie[65],re([0,1,3,8,51,5,2,62]),function(V,i,t,n,M,g,E,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Searcher=i.TextModelSearch=i.SearchParams=void 0,i.isMultilineRegexSource=f,i.createFindMatch=_,i.isValidMatch=v;const l=999;class u{constructor(L,w,c,a){this.searchString=L,this.isRegex=w,this.matchCase=c,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let L;this.isRegex?L=f(this.searchString):L=this.searchString.indexOf(`
`)>=0;let w=null;try{w=n.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:L,global:!0,unicode:!0})}catch{return null}if(!w)return null;let c=!this.isRegex&&!L;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new b.SearchData(w,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators,[]):null,c?this.searchString:null)}}i.SearchParams=u;function f(N){if(!N||N.length===0)return!1;for(let L=0,w=N.length;L<w;L++){const c=N.charCodeAt(L);if(c===t.CharCode.LineFeed)return!0;if(c===t.CharCode.Backslash){if(L++,L>=w)break;const a=N.charCodeAt(L);if(a===t.CharCode.n||a===t.CharCode.r||a===t.CharCode.W)return!0}}return!1}function _(N,L,w){if(!w)return new b.FindMatch(N,null);const c=[];for(let a=0,s=L.length;a<s;a++)c[a]=L[a];return new b.FindMatch(N,c)}class d{constructor(L){const w=[];let c=0;for(let a=0,s=L.length;a<s;a++)L.charCodeAt(a)===t.CharCode.LineFeed&&(w[c++]=a);this._lineFeedsOffsets=w}findLineFeedCountBeforeOffset(L){const w=this._lineFeedsOffsets;let c=0,a=w.length-1;if(a===-1||L<=w[0])return 0;for(;c<a;){const s=c+((a-c)/2>>0);w[s]>=L?a=s-1:w[s+1]>=L?(c=s,a=s):c=s+1}return c+1}}class p{static findMatches(L,w,c,a,s){const o=w.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(L,c,new A(o.wordSeparators,o.regex),a,s):this._doFindMatchesLineByLine(L,c,o,a,s):[]}static _getMultilineMatchRange(L,w,c,a,s,o){let h,D=0;a?(D=a.findLineFeedCountBeforeOffset(s),h=w+s+D):h=w+s;let R;if(a){const k=a.findLineFeedCountBeforeOffset(s+o.length)-D;R=h+o.length+k}else R=h+o.length;const S=L.getPositionAt(h),T=L.getPositionAt(R);return new E.Range(S.lineNumber,S.column,T.lineNumber,T.column)}static _doFindMatchesMultiline(L,w,c,a,s){const o=L.getOffsetAt(w.getStartPosition()),h=L.getValueInRange(w,b.EndOfLinePreference.LF),D=L.getEOL()===`\r
`?new d(h):null,R=[];let S=0,T;for(c.reset(0);T=c.next(h);)if(R[S++]=_(this._getMultilineMatchRange(L,o,h,D,T.index,T[0]),T,a),S>=s)return R;return R}static _doFindMatchesLineByLine(L,w,c,a,s){const o=[];let h=0;if(w.startLineNumber===w.endLineNumber){const R=L.getLineContent(w.startLineNumber).substring(w.startColumn-1,w.endColumn-1);return h=this._findMatchesInLine(c,R,w.startLineNumber,w.startColumn-1,h,o,a,s),o}const D=L.getLineContent(w.startLineNumber).substring(w.startColumn-1);h=this._findMatchesInLine(c,D,w.startLineNumber,w.startColumn-1,h,o,a,s);for(let R=w.startLineNumber+1;R<w.endLineNumber&&h<s;R++)h=this._findMatchesInLine(c,L.getLineContent(R),R,0,h,o,a,s);if(h<s){const R=L.getLineContent(w.endLineNumber).substring(0,w.endColumn-1);h=this._findMatchesInLine(c,R,w.endLineNumber,0,h,o,a,s)}return o}static _findMatchesInLine(L,w,c,a,s,o,h,D){const R=L.wordSeparators;if(!h&&L.simpleSearch){const y=L.simpleSearch,k=y.length,O=w.length;let I=-k;for(;(I=w.indexOf(y,I+k))!==-1;)if((!R||v(R,w,O,I,k))&&(o[s++]=new b.FindMatch(new E.Range(c,I+1+a,c,I+1+k+a),null),s>=D))return s;return s}const S=new A(L.wordSeparators,L.regex);let T;S.reset(0);do if(T=S.next(w),T&&(o[s++]=_(new E.Range(c,T.index+1+a,c,T.index+1+T[0].length+a),T,h),s>=D))return s;while(T);return s}static findNextMatch(L,w,c,a){const s=w.parseSearchRequest();if(!s)return null;const o=new A(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(L,c,o,a):this._doFindNextMatchLineByLine(L,c,o,a)}static _doFindNextMatchMultiline(L,w,c,a){const s=new g.Position(w.lineNumber,1),o=L.getOffsetAt(s),h=L.getLineCount(),D=L.getValueInRange(new E.Range(s.lineNumber,s.column,h,L.getLineMaxColumn(h)),b.EndOfLinePreference.LF),R=L.getEOL()===`\r
`?new d(D):null;c.reset(w.column-1);const S=c.next(D);return S?_(this._getMultilineMatchRange(L,o,D,R,S.index,S[0]),S,a):w.lineNumber!==1||w.column!==1?this._doFindNextMatchMultiline(L,new g.Position(1,1),c,a):null}static _doFindNextMatchLineByLine(L,w,c,a){const s=L.getLineCount(),o=w.lineNumber,h=L.getLineContent(o),D=this._findFirstMatchInLine(c,h,o,w.column,a);if(D)return D;for(let R=1;R<=s;R++){const S=(o+R-1)%s,T=L.getLineContent(S+1),y=this._findFirstMatchInLine(c,T,S+1,1,a);if(y)return y}return null}static _findFirstMatchInLine(L,w,c,a,s){L.reset(a-1);const o=L.next(w);return o?_(new E.Range(c,o.index+1,c,o.index+1+o[0].length),o,s):null}static findPreviousMatch(L,w,c,a){const s=w.parseSearchRequest();if(!s)return null;const o=new A(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(L,c,o,a):this._doFindPreviousMatchLineByLine(L,c,o,a)}static _doFindPreviousMatchMultiline(L,w,c,a){const s=this._doFindMatchesMultiline(L,new E.Range(1,1,w.lineNumber,w.column),c,a,10*l);if(s.length>0)return s[s.length-1];const o=L.getLineCount();return w.lineNumber!==o||w.column!==L.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(L,new g.Position(o,L.getLineMaxColumn(o)),c,a):null}static _doFindPreviousMatchLineByLine(L,w,c,a){const s=L.getLineCount(),o=w.lineNumber,h=L.getLineContent(o).substring(0,w.column-1),D=this._findLastMatchInLine(c,h,o,a);if(D)return D;for(let R=1;R<=s;R++){const S=(s+o-R-1)%s,T=L.getLineContent(S+1),y=this._findLastMatchInLine(c,T,S+1,a);if(y)return y}return null}static _findLastMatchInLine(L,w,c,a){let s=null,o;for(L.reset(0);o=L.next(w);)s=_(new E.Range(c,o.index+1,c,o.index+1+o[0].length),o,a);return s}}i.TextModelSearch=p;function e(N,L,w,c,a){if(c===0)return!0;const s=L.charCodeAt(c-1);if(N.get(s)!==M.WordCharacterClass.Regular||s===t.CharCode.CarriageReturn||s===t.CharCode.LineFeed)return!0;if(a>0){const o=L.charCodeAt(c);if(N.get(o)!==M.WordCharacterClass.Regular)return!0}return!1}function m(N,L,w,c,a){if(c+a===w)return!0;const s=L.charCodeAt(c+a);if(N.get(s)!==M.WordCharacterClass.Regular||s===t.CharCode.CarriageReturn||s===t.CharCode.LineFeed)return!0;if(a>0){const o=L.charCodeAt(c+a-1);if(N.get(o)!==M.WordCharacterClass.Regular)return!0}return!1}function v(N,L,w,c,a){return e(N,L,w,c,a)&&m(N,L,w,c,a)}class A{constructor(L,w){this._wordSeparators=L,this._searchRegex=w,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(L){this._searchRegex.lastIndex=L,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(L){const w=L.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===w||(c=this._searchRegex.exec(L),!c))return null;const a=c.index,s=c[0].length;if(a===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){n.getNextCodePoint(L,w,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=s,!this._wordSeparators||v(this._wordSeparators,L,w,a,s))return c}while(c);return null}}i.Searcher=A}),ne(ie[66],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.findSectionHeaders=M;const t=new RegExp("\\bMARK:\\s*(.*)$","d"),n=/^-+|-+$/g;function M(u,f){let _=[];if(f.findRegionSectionHeaders&&f.foldingRules?.markers){const d=g(u,f);_=_.concat(d)}if(f.findMarkSectionHeaders){const d=E(u);_=_.concat(d)}return _}function g(u,f){const _=[],d=u.getLineCount();for(let p=1;p<=d;p++){const e=u.getLineContent(p),m=e.match(f.foldingRules.markers.start);if(m){const v={startLineNumber:p,startColumn:m[0].length+1,endLineNumber:p,endColumn:e.length+1};if(v.endColumn>v.startColumn){const A={range:v,...l(e.substring(m[0].length)),shouldBeInComments:!1};(A.text||A.hasSeparatorLine)&&_.push(A)}}}return _}function E(u){const f=[],_=u.getLineCount();for(let d=1;d<=_;d++){const p=u.getLineContent(d);b(p,d,f)}return f}function b(u,f,_){t.lastIndex=0;const d=t.exec(u);if(d){const p=d.indices[1][0]+1,e=d.indices[1][1]+1,m={startLineNumber:f,startColumn:p,endLineNumber:f,endColumn:e};if(m.endColumn>m.startColumn){const v={range:m,...l(d[1]),shouldBeInComments:!0};(v.text||v.hasSeparatorLine)&&_.push(v)}}}function l(u){u=u.trim();const f=u.startsWith("-");return u=u.replace(n,""),{text:u,hasSeparatorLine:f}}}),ne(ie[67],re([0,1,2,65,8,11,32]),function(V,i,t,n,M,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UnicodeHighlighterReasonKind=i.UnicodeTextModelHighlighter=void 0;class b{static computeUnicodeHighlights(e,m,v){const A=v?v.startLineNumber:1,N=v?v.endLineNumber:e.getLineCount(),L=new f(m),w=L.getCandidateCodePoints();let c;w==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${l(Array.from(w))}`,"g");const a=new n.Searcher(null,c),s=[];let o=!1,h,D=0,R=0,S=0;e:for(let T=A,y=N;T<=y;T++){const k=e.getLineContent(T),O=k.length;a.reset(0);do if(h=a.next(k),h){let I=h.index,U=h.index+h[0].length;if(I>0){const X=k.charCodeAt(I-1);M.isHighSurrogate(X)&&I--}if(U+1<O){const X=k.charCodeAt(U-1);M.isHighSurrogate(X)&&U++}const $=k.substring(I,U);let q=(0,E.getWordAtText)(I+1,E.DEFAULT_WORD_REGEXP,k,0);q&&q.endColumn<=I+1&&(q=null);const x=L.shouldHighlightNonBasicASCII($,q?q.word:null);if(x!==d.None){if(x===d.Ambiguous?D++:x===d.Invisible?R++:x===d.NonBasicASCII?S++:(0,g.assertNever)(x),s.length>=1e3){o=!0;break e}s.push(new t.Range(T,I+1,T,U+1))}}while(h)}return{ranges:s,hasMore:o,ambiguousCharacterCount:D,invisibleCharacterCount:R,nonBasicAsciiCharacterCount:S}}static computeUnicodeHighlightReason(e,m){const v=new f(m);switch(v.shouldHighlightNonBasicASCII(e,null)){case d.None:return null;case d.Invisible:return{kind:u.Invisible};case d.Ambiguous:{const N=e.codePointAt(0),L=v.ambiguousCharacters.getPrimaryConfusable(N),w=M.AmbiguousCharacters.getLocales().filter(c=>!M.AmbiguousCharacters.getInstance(new Set([...m.allowedLocales,c])).isAmbiguous(N));return{kind:u.Ambiguous,confusableWith:String.fromCodePoint(L),notAmbiguousInLocales:w}}case d.NonBasicASCII:return{kind:u.NonBasicAscii}}}}i.UnicodeTextModelHighlighter=b;function l(p,e){return`[${M.escapeRegExpCharacters(p.map(v=>String.fromCodePoint(v)).join(""))}]`}var u;(function(p){p[p.Ambiguous=0]="Ambiguous",p[p.Invisible=1]="Invisible",p[p.NonBasicAscii=2]="NonBasicAscii"})(u||(i.UnicodeHighlighterReasonKind=u={}));class f{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=M.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const m of M.InvisibleCharacters.codePoints)_(String.fromCodePoint(m))||e.add(m);if(this.options.ambiguousCharacters)for(const m of this.ambiguousCharacters.getConfusableCodePoints())e.add(m);for(const m of this.allowedCodePoints)e.delete(m);return e}shouldHighlightNonBasicASCII(e,m){const v=e.codePointAt(0);if(this.allowedCodePoints.has(v))return d.None;if(this.options.nonBasicASCII)return d.NonBasicASCII;let A=!1,N=!1;if(m)for(const L of m){const w=L.codePointAt(0),c=M.isBasicASCII(L);A=A||c,!c&&!this.ambiguousCharacters.isAmbiguous(w)&&!M.InvisibleCharacters.isInvisibleCharacter(w)&&(N=!0)}return!A&&N?d.None:this.options.invisibleCharacters&&!_(e)&&M.InvisibleCharacters.isInvisibleCharacter(v)?d.Invisible:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(v)?d.Ambiguous:d.None}}function _(p){return p===" "||p===`
`||p==="	"}var d;(function(p){p[p.None=0]="None",p[p.NonBasicASCII=1]="NonBasicASCII",p[p.Invisible=2]="Invisible",p[p.Ambiguous=3]="Ambiguous"})(d||(d={}))}),ne(ie[68],re([0,1]),function(V,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WrappingIndent=i.TrackedRangeStickiness=i.TextEditorCursorStyle=i.TextEditorCursorBlinkingStyle=i.SymbolTag=i.SymbolKind=i.SignatureHelpTriggerKind=i.ShowLightbulbIconMode=i.SelectionDirection=i.ScrollbarVisibility=i.ScrollType=i.RenderMinimap=i.RenderLineNumbersType=i.PositionAffinity=i.PartialAcceptTriggerKind=i.OverviewRulerLane=i.OverlayWidgetPositionPreference=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.MouseTargetType=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.MarkerTag=i.MarkerSeverity=i.KeyCode=i.InlineEditTriggerKind=i.InlineCompletionTriggerKind=i.InlayHintKind=i.InjectedTextCursorStops=i.IndentAction=i.HoverVerbosityAction=i.GlyphMarginLane=i.EndOfLineSequence=i.EndOfLinePreference=i.EditorOption=i.EditorAutoIndentStrategy=i.DocumentHighlightKind=i.DefaultEndOfLine=i.CursorChangeReason=i.ContentWidgetPositionPreference=i.CompletionTriggerKind=i.CompletionItemTag=i.CompletionItemKind=i.CompletionItemInsertTextRule=i.CodeActionTriggerType=i.AccessibilitySupport=void 0;var t;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(t||(i.AccessibilitySupport=t={}));var n;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(n||(i.CodeActionTriggerType=n={}));var M;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(M||(i.CompletionItemInsertTextRule=M={}));var g;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(g||(i.CompletionItemKind=g={}));var E;(function(r){r[r.Deprecated=1]="Deprecated"})(E||(i.CompletionItemTag=E={}));var b;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b||(i.CompletionTriggerKind=b={}));var l;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(l||(i.ContentWidgetPositionPreference=l={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(i.CursorChangeReason=u={}));var f;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(f||(i.DefaultEndOfLine=f={}));var _;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(_||(i.DocumentHighlightKind=_={}));var d;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(d||(i.EditorAutoIndentStrategy=d={}));var p;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSegmenterLocales=130]="wordSegmenterLocales",r[r.wordSeparators=131]="wordSeparators",r[r.wordWrap=132]="wordWrap",r[r.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=135]="wordWrapColumn",r[r.wordWrapOverride1=136]="wordWrapOverride1",r[r.wordWrapOverride2=137]="wordWrapOverride2",r[r.wrappingIndent=138]="wrappingIndent",r[r.wrappingStrategy=139]="wrappingStrategy",r[r.showDeprecated=140]="showDeprecated",r[r.inlayHints=141]="inlayHints",r[r.editorClassName=142]="editorClassName",r[r.pixelRatio=143]="pixelRatio",r[r.tabFocusMode=144]="tabFocusMode",r[r.layoutInfo=145]="layoutInfo",r[r.wrappingInfo=146]="wrappingInfo",r[r.defaultColorDecorators=147]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(p||(i.EditorOption=p={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(i.EndOfLinePreference=e={}));var m;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(m||(i.EndOfLineSequence=m={}));var v;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(v||(i.GlyphMarginLane=v={}));var A;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(A||(i.HoverVerbosityAction=A={}));var N;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(N||(i.IndentAction=N={}));var L;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(L||(i.InjectedTextCursorStops=L={}));var w;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(w||(i.InlayHintKind=w={}));var c;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(c||(i.InlineCompletionTriggerKind=c={}));var a;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(a||(i.InlineEditTriggerKind=a={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(i.KeyCode=s={}));var o;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(o||(i.MarkerSeverity=o={}));var h;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(h||(i.MarkerTag=h={}));var D;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(D||(i.MinimapPosition=D={}));var R;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(R||(i.MinimapSectionHeaderStyle=R={}));var S;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(S||(i.MouseTargetType=S={}));var T;(function(r){r[r.AIGenerated=1]="AIGenerated"})(T||(i.NewSymbolNameTag=T={}));var y;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(y||(i.NewSymbolNameTriggerKind=y={}));var k;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(k||(i.OverlayWidgetPositionPreference=k={}));var O;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(O||(i.OverviewRulerLane=O={}));var I;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(I||(i.PartialAcceptTriggerKind=I={}));var U;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(U||(i.PositionAffinity=U={}));var $;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})($||(i.RenderLineNumbersType=$={}));var q;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(q||(i.RenderMinimap=q={}));var x;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(x||(i.ScrollType=x={}));var X;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(X||(i.ScrollbarVisibility=X={}));var Y;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(Y||(i.SelectionDirection=Y={}));var G;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(G||(i.ShowLightbulbIconMode=G={}));var Q;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(Q||(i.SignatureHelpTriggerKind=Q={}));var K;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(K||(i.SymbolKind=K={}));var F;(function(r){r[r.Deprecated=1]="Deprecated"})(F||(i.SymbolTag=F={}));var j;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(j||(i.TextEditorCursorBlinkingStyle=j={}));var fe;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(fe||(i.TextEditorCursorStyle=fe={}));var oe;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(oe||(i.TrackedRangeStickiness=oe={}));var Le;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(Le||(i.WrappingIndent=Le={}))}),ne(ie[69],re([0,1,13,12,58]),function(V,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TokenizationRegistry=void 0;class g{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(l){this._onDidChange.fire({changedLanguages:l,changedColorMap:!1})}register(l,u){return this._tokenizationSupports.set(l,u),this.handleChange([l]),(0,n.toDisposable)(()=>{this._tokenizationSupports.get(l)===u&&(this._tokenizationSupports.delete(l),this.handleChange([l]))})}get(l){return this._tokenizationSupports.get(l)||null}registerFactory(l,u){this._factories.get(l)?.dispose();const f=new E(this,l,u);return this._factories.set(l,f),(0,n.toDisposable)(()=>{const _=this._factories.get(l);!_||_!==f||(this._factories.delete(l),_.dispose())})}async getOrCreate(l){const u=this.get(l);if(u)return u;const f=this._factories.get(l);return!f||f.isResolved?null:(await f.resolve(),this.get(l))}isResolved(l){if(this.get(l))return!0;const f=this._factories.get(l);return!!(!f||f.isResolved)}setColorMap(l){this._colorMap=l,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>M.ColorId.DefaultBackground?this._colorMap[M.ColorId.DefaultBackground]:null}}i.TokenizationRegistry=g;class E extends n.Disposable{get isResolved(){return this._isResolved}constructor(l,u,f){super(),this._registry=l,this._languageId=u,this._factory=f,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const l=await this._factory.tokenizationSupport;this._isResolved=!0,l&&!this._isDisposed&&this._register(this._registry.register(this._languageId,l))}}}),ne(ie[70],re([71,72]),function(V,i){return V.create("vs/base/common/platform",i)}),ne(ie[20],re([0,1,70]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isAndroid=i.isEdge=i.isSafari=i.isFirefox=i.isChrome=i.OS=i.OperatingSystem=i.setTimeout0=i.setTimeout0IsFaster=i.translationsConfigFile=i.platformLocale=i.locale=i.Language=i.language=i.userAgent=i.platform=i.isCI=i.isMobile=i.isIOS=i.webWorkerOrigin=i.isWebWorker=i.isWeb=i.isElectron=i.isNative=i.isLinuxSnap=i.isLinux=i.isMacintosh=i.isWindows=i.Platform=i.LANGUAGE_DEFAULT=void 0,i.PlatformToString=s,i.isLittleEndian=T,i.isBigSurOrNewer=y,i.LANGUAGE_DEFAULT="en";let n=!1,M=!1,g=!1,E=!1,b=!1,l=!1,u=!1,f=!1,_=!1,d=!1,p,e=i.LANGUAGE_DEFAULT,m=i.LANGUAGE_DEFAULT,v,A;const N=globalThis;let L;typeof N.vscode<"u"&&typeof N.vscode.process<"u"?L=N.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(L=process);const w=typeof L?.versions?.electron=="string",c=w&&L?.type==="renderer";if(typeof L=="object"){n=L.platform==="win32",M=L.platform==="darwin",g=L.platform==="linux",E=g&&!!L.env.SNAP&&!!L.env.SNAP_REVISION,u=w,_=!!L.env.CI||!!L.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=i.LANGUAGE_DEFAULT,e=i.LANGUAGE_DEFAULT;const k=L.env.VSCODE_NLS_CONFIG;if(k)try{const O=JSON.parse(k),I=O.availableLanguages["*"];p=O.locale,m=O.osLocale,e=I||i.LANGUAGE_DEFAULT,v=O._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!c?(A=navigator.userAgent,n=A.indexOf("Windows")>=0,M=A.indexOf("Macintosh")>=0,f=(A.indexOf("Macintosh")>=0||A.indexOf("iPad")>=0||A.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,g=A.indexOf("Linux")>=0,d=A?.indexOf("Mobi")>=0,l=!0,p=t.getConfiguredDefaultLocale(t.localize(0,null))||i.LANGUAGE_DEFAULT,e=p,m=navigator.language):console.error("Unable to resolve platform.");var a;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(a||(i.Platform=a={}));function s(k){switch(k){case a.Web:return"Web";case a.Mac:return"Mac";case a.Linux:return"Linux";case a.Windows:return"Windows"}}let o=a.Web;M?o=a.Mac:n?o=a.Windows:g&&(o=a.Linux),i.isWindows=n,i.isMacintosh=M,i.isLinux=g,i.isLinuxSnap=E,i.isNative=b,i.isElectron=u,i.isWeb=l,i.isWebWorker=l&&typeof N.importScripts=="function",i.webWorkerOrigin=i.isWebWorker?N.origin:void 0,i.isIOS=f,i.isMobile=d,i.isCI=_,i.platform=o,i.userAgent=A,i.language=e;var h;(function(k){function O(){return i.language}k.value=O;function I(){return i.language.length===2?i.language==="en":i.language.length>=3?i.language[0]==="e"&&i.language[1]==="n"&&i.language[2]==="-":!1}k.isDefaultVariant=I;function U(){return i.language==="en"}k.isDefault=U})(h||(i.Language=h={})),i.locale=p,i.platformLocale=m,i.translationsConfigFile=v,i.setTimeout0IsFaster=typeof N.postMessage=="function"&&!N.importScripts,i.setTimeout0=(()=>{if(i.setTimeout0IsFaster){const k=[];N.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let U=0,$=k.length;U<$;U++){const q=k[U];if(q.id===I.data.vscodeScheduleAsyncWork){k.splice(U,1),q.callback();return}}});let O=0;return I=>{const U=++O;k.push({id:U,callback:I}),N.postMessage({vscodeScheduleAsyncWork:U},"*")}}return k=>setTimeout(k)})();var D;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(D||(i.OperatingSystem=D={})),i.OS=M||f?D.Macintosh:n?D.Windows:D.Linux;let R=!0,S=!1;function T(){if(!S){S=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,R=new Uint16Array(k.buffer)[0]===513}return R}i.isChrome=!!(i.userAgent&&i.userAgent.indexOf("Chrome")>=0),i.isFirefox=!!(i.userAgent&&i.userAgent.indexOf("Firefox")>=0),i.isSafari=!!(!i.isChrome&&i.userAgent&&i.userAgent.indexOf("Safari")>=0),i.isEdge=!!(i.userAgent&&i.userAgent.indexOf("Edg/")>=0),i.isAndroid=!!(i.userAgent&&i.userAgent.indexOf("Android")>=0);function y(k){return parseFloat(k)>=20}}),ne(ie[73],re([0,1,20]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.arch=i.platform=i.env=i.cwd=void 0;let n;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const g=M.process;n={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return t.isWindows?"win32":t.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};i.cwd=n.cwd,i.env=n.env,i.platform=n.platform,i.arch=n.arch}),ne(ie[74],re([0,1,73]),function(V,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.delimiter=i.sep=i.toNamespacedPath=i.parse=i.format=i.extname=i.basename=i.dirname=i.relative=i.resolve=i.join=i.isAbsolute=i.normalize=i.posix=i.win32=void 0;const n=65,M=97,g=90,E=122,b=46,l=47,u=92,f=58,_=63;class d extends Error{constructor(s,o,h){let D;typeof o=="string"&&o.indexOf("not ")===0?(D="must not be",o=o.replace(/^not /,"")):D="must be";const R=s.indexOf(".")!==-1?"property":"argument";let S=`The "${s}" ${R} ${D} of type ${o}`;S+=`. Received type ${typeof h}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function p(a,s){if(a===null||typeof a!="object")throw new d(s,"Object",a)}function e(a,s){if(typeof a!="string")throw new d(s,"string",a)}const m=t.platform==="win32";function v(a){return a===l||a===u}function A(a){return a===l}function N(a){return a>=n&&a<=g||a>=M&&a<=E}function L(a,s,o,h){let D="",R=0,S=-1,T=0,y=0;for(let k=0;k<=a.length;++k){if(k<a.length)y=a.charCodeAt(k);else{if(h(y))break;y=l}if(h(y)){if(!(S===k-1||T===1))if(T===2){if(D.length<2||R!==2||D.charCodeAt(D.length-1)!==b||D.charCodeAt(D.length-2)!==b){if(D.length>2){const O=D.lastIndexOf(o);O===-1?(D="",R=0):(D=D.slice(0,O),R=D.length-1-D.lastIndexOf(o)),S=k,T=0;continue}else if(D.length!==0){D="",R=0,S=k,T=0;continue}}s&&(D+=D.length>0?`${o}..`:"..",R=2)}else D.length>0?D+=`${o}${a.slice(S+1,k)}`:D=a.slice(S+1,k),R=k-S-1;S=k,T=0}else y===b&&T!==-1?++T:T=-1}return D}function w(a,s){p(s,"pathObject");const o=s.dir||s.root,h=s.base||`${s.name||""}${s.ext||""}`;return o?o===s.root?`${o}${h}`:`${o}${a}${h}`:h}i.win32={resolve(...a){let s="",o="",h=!1;for(let D=a.length-1;D>=-1;D--){let R;if(D>=0){if(R=a[D],e(R,"path"),R.length===0)continue}else s.length===0?R=t.cwd():(R=t.env[`=${s}`]||t.cwd(),(R===void 0||R.slice(0,2).toLowerCase()!==s.toLowerCase()&&R.charCodeAt(2)===u)&&(R=`${s}\\`));const S=R.length;let T=0,y="",k=!1;const O=R.charCodeAt(0);if(S===1)v(O)&&(T=1,k=!0);else if(v(O))if(k=!0,v(R.charCodeAt(1))){let I=2,U=I;for(;I<S&&!v(R.charCodeAt(I));)I++;if(I<S&&I!==U){const $=R.slice(U,I);for(U=I;I<S&&v(R.charCodeAt(I));)I++;if(I<S&&I!==U){for(U=I;I<S&&!v(R.charCodeAt(I));)I++;(I===S||I!==U)&&(y=`\\\\${$}\\${R.slice(U,I)}`,T=I)}}}else T=1;else N(O)&&R.charCodeAt(1)===f&&(y=R.slice(0,2),T=2,S>2&&v(R.charCodeAt(2))&&(k=!0,T=3));if(y.length>0)if(s.length>0){if(y.toLowerCase()!==s.toLowerCase())continue}else s=y;if(h){if(s.length>0)break}else if(o=`${R.slice(T)}\\${o}`,h=k,k&&s.length>0)break}return o=L(o,!h,"\\",v),h?`${s}\\${o}`:`${s}${o}`||"."},normalize(a){e(a,"path");const s=a.length;if(s===0)return".";let o=0,h,D=!1;const R=a.charCodeAt(0);if(s===1)return A(R)?"\\":a;if(v(R))if(D=!0,v(a.charCodeAt(1))){let T=2,y=T;for(;T<s&&!v(a.charCodeAt(T));)T++;if(T<s&&T!==y){const k=a.slice(y,T);for(y=T;T<s&&v(a.charCodeAt(T));)T++;if(T<s&&T!==y){for(y=T;T<s&&!v(a.charCodeAt(T));)T++;if(T===s)return`\\\\${k}\\${a.slice(y)}\\`;T!==y&&(h=`\\\\${k}\\${a.slice(y,T)}`,o=T)}}}else o=1;else N(R)&&a.charCodeAt(1)===f&&(h=a.slice(0,2),o=2,s>2&&v(a.charCodeAt(2))&&(D=!0,o=3));let S=o<s?L(a.slice(o),!D,"\\",v):"";return S.length===0&&!D&&(S="."),S.length>0&&v(a.charCodeAt(s-1))&&(S+="\\"),h===void 0?D?`\\${S}`:S:D?`${h}\\${S}`:`${h}${S}`},isAbsolute(a){e(a,"path");const s=a.length;if(s===0)return!1;const o=a.charCodeAt(0);return v(o)||s>2&&N(o)&&a.charCodeAt(1)===f&&v(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let s,o;for(let R=0;R<a.length;++R){const S=a[R];e(S,"path"),S.length>0&&(s===void 0?s=o=S:s+=`\\${S}`)}if(s===void 0)return".";let h=!0,D=0;if(typeof o=="string"&&v(o.charCodeAt(0))){++D;const R=o.length;R>1&&v(o.charCodeAt(1))&&(++D,R>2&&(v(o.charCodeAt(2))?++D:h=!1))}if(h){for(;D<s.length&&v(s.charCodeAt(D));)D++;D>=2&&(s=`\\${s.slice(D)}`)}return i.win32.normalize(s)},relative(a,s){if(e(a,"from"),e(s,"to"),a===s)return"";const o=i.win32.resolve(a),h=i.win32.resolve(s);if(o===h||(a=o.toLowerCase(),s=h.toLowerCase(),a===s))return"";let D=0;for(;D<a.length&&a.charCodeAt(D)===u;)D++;let R=a.length;for(;R-1>D&&a.charCodeAt(R-1)===u;)R--;const S=R-D;let T=0;for(;T<s.length&&s.charCodeAt(T)===u;)T++;let y=s.length;for(;y-1>T&&s.charCodeAt(y-1)===u;)y--;const k=y-T,O=S<k?S:k;let I=-1,U=0;for(;U<O;U++){const q=a.charCodeAt(D+U);if(q!==s.charCodeAt(T+U))break;q===u&&(I=U)}if(U!==O){if(I===-1)return h}else{if(k>O){if(s.charCodeAt(T+U)===u)return h.slice(T+U+1);if(U===2)return h.slice(T+U)}S>O&&(a.charCodeAt(D+U)===u?I=U:U===2&&(I=3)),I===-1&&(I=0)}let $="";for(U=D+I+1;U<=R;++U)(U===R||a.charCodeAt(U)===u)&&($+=$.length===0?"..":"\\..");return T+=I,$.length>0?`${$}${h.slice(T,y)}`:(h.charCodeAt(T)===u&&++T,h.slice(T,y))},toNamespacedPath(a){if(typeof a!="string"||a.length===0)return a;const s=i.win32.resolve(a);if(s.length<=2)return a;if(s.charCodeAt(0)===u){if(s.charCodeAt(1)===u){const o=s.charCodeAt(2);if(o!==_&&o!==b)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(N(s.charCodeAt(0))&&s.charCodeAt(1)===f&&s.charCodeAt(2)===u)return`\\\\?\\${s}`;return a},dirname(a){e(a,"path");const s=a.length;if(s===0)return".";let o=-1,h=0;const D=a.charCodeAt(0);if(s===1)return v(D)?a:".";if(v(D)){if(o=h=1,v(a.charCodeAt(1))){let T=2,y=T;for(;T<s&&!v(a.charCodeAt(T));)T++;if(T<s&&T!==y){for(y=T;T<s&&v(a.charCodeAt(T));)T++;if(T<s&&T!==y){for(y=T;T<s&&!v(a.charCodeAt(T));)T++;if(T===s)return a;T!==y&&(o=h=T+1)}}}}else N(D)&&a.charCodeAt(1)===f&&(o=s>2&&v(a.charCodeAt(2))?3:2,h=o);let R=-1,S=!0;for(let T=s-1;T>=h;--T)if(v(a.charCodeAt(T))){if(!S){R=T;break}}else S=!1;if(R===-1){if(o===-1)return".";R=o}return a.slice(0,R)},basename(a,s){s!==void 0&&e(s,"ext"),e(a,"path");let o=0,h=-1,D=!0,R;if(a.length>=2&&N(a.charCodeAt(0))&&a.charCodeAt(1)===f&&(o=2),s!==void 0&&s.length>0&&s.length<=a.length){if(s===a)return"";let S=s.length-1,T=-1;for(R=a.length-1;R>=o;--R){const y=a.charCodeAt(R);if(v(y)){if(!D){o=R+1;break}}else T===-1&&(D=!1,T=R+1),S>=0&&(y===s.charCodeAt(S)?--S===-1&&(h=R):(S=-1,h=T))}return o===h?h=T:h===-1&&(h=a.length),a.slice(o,h)}for(R=a.length-1;R>=o;--R)if(v(a.charCodeAt(R))){if(!D){o=R+1;break}}else h===-1&&(D=!1,h=R+1);return h===-1?"":a.slice(o,h)},extname(a){e(a,"path");let s=0,o=-1,h=0,D=-1,R=!0,S=0;a.length>=2&&a.charCodeAt(1)===f&&N(a.charCodeAt(0))&&(s=h=2);for(let T=a.length-1;T>=s;--T){const y=a.charCodeAt(T);if(v(y)){if(!R){h=T+1;break}continue}D===-1&&(R=!1,D=T+1),y===b?o===-1?o=T:S!==1&&(S=1):o!==-1&&(S=-1)}return o===-1||D===-1||S===0||S===1&&o===D-1&&o===h+1?"":a.slice(o,D)},format:w.bind(null,"\\"),parse(a){e(a,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return s;const o=a.length;let h=0,D=a.charCodeAt(0);if(o===1)return v(D)?(s.root=s.dir=a,s):(s.base=s.name=a,s);if(v(D)){if(h=1,v(a.charCodeAt(1))){let I=2,U=I;for(;I<o&&!v(a.charCodeAt(I));)I++;if(I<o&&I!==U){for(U=I;I<o&&v(a.charCodeAt(I));)I++;if(I<o&&I!==U){for(U=I;I<o&&!v(a.charCodeAt(I));)I++;I===o?h=I:I!==U&&(h=I+1)}}}}else if(N(D)&&a.charCodeAt(1)===f){if(o<=2)return s.root=s.dir=a,s;if(h=2,v(a.charCodeAt(2))){if(o===3)return s.root=s.dir=a,s;h=3}}h>0&&(s.root=a.slice(0,h));let R=-1,S=h,T=-1,y=!0,k=a.length-1,O=0;for(;k>=h;--k){if(D=a.charCodeAt(k),v(D)){if(!y){S=k+1;break}continue}T===-1&&(y=!1,T=k+1),D===b?R===-1?R=k:O!==1&&(O=1):R!==-1&&(O=-1)}return T!==-1&&(R===-1||O===0||O===1&&R===T-1&&R===S+1?s.base=s.name=a.slice(S,T):(s.name=a.slice(S,R),s.base=a.slice(S,T),s.ext=a.slice(R,T))),S>0&&S!==h?s.dir=a.slice(0,S-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(m){const a=/\\/g;return()=>{const s=t.cwd().replace(a,"/");return s.slice(s.indexOf("/"))}}return()=>t.cwd()})();i.posix={resolve(...a){let s="",o=!1;for(let h=a.length-1;h>=-1&&!o;h--){const D=h>=0?a[h]:c();e(D,"path"),D.length!==0&&(s=`${D}/${s}`,o=D.charCodeAt(0)===l)}return s=L(s,!o,"/",A),o?`/${s}`:s.length>0?s:"."},normalize(a){if(e(a,"path"),a.length===0)return".";const s=a.charCodeAt(0)===l,o=a.charCodeAt(a.length-1)===l;return a=L(a,!s,"/",A),a.length===0?s?"/":o?"./":".":(o&&(a+="/"),s?`/${a}`:a)},isAbsolute(a){return e(a,"path"),a.length>0&&a.charCodeAt(0)===l},join(...a){if(a.length===0)return".";let s;for(let o=0;o<a.length;++o){const h=a[o];e(h,"path"),h.length>0&&(s===void 0?s=h:s+=`/${h}`)}return s===void 0?".":i.posix.normalize(s)},relative(a,s){if(e(a,"from"),e(s,"to"),a===s||(a=i.posix.resolve(a),s=i.posix.resolve(s),a===s))return"";const o=1,h=a.length,D=h-o,R=1,S=s.length-R,T=D<S?D:S;let y=-1,k=0;for(;k<T;k++){const I=a.charCodeAt(o+k);if(I!==s.charCodeAt(R+k))break;I===l&&(y=k)}if(k===T)if(S>T){if(s.charCodeAt(R+k)===l)return s.slice(R+k+1);if(k===0)return s.slice(R+k)}else D>T&&(a.charCodeAt(o+k)===l?y=k:k===0&&(y=0));let O="";for(k=o+y+1;k<=h;++k)(k===h||a.charCodeAt(k)===l)&&(O+=O.length===0?"..":"/..");return`${O}${s.slice(R+y)}`},toNamespacedPath(a){return a},dirname(a){if(e(a,"path"),a.length===0)return".";const s=a.charCodeAt(0)===l;let o=-1,h=!0;for(let D=a.length-1;D>=1;--D)if(a.charCodeAt(D)===l){if(!h){o=D;break}}else h=!1;return o===-1?s?"/":".":s&&o===1?"//":a.slice(0,o)},basename(a,s){s!==void 0&&e(s,"ext"),e(a,"path");let o=0,h=-1,D=!0,R;if(s!==void 0&&s.length>0&&s.length<=a.length){if(s===a)return"";let S=s.length-1,T=-1;for(R=a.length-1;R>=0;--R){const y=a.charCodeAt(R);if(y===l){if(!D){o=R+1;break}}else T===-1&&(D=!1,T=R+1),S>=0&&(y===s.charCodeAt(S)?--S===-1&&(h=R):(S=-1,h=T))}return o===h?h=T:h===-1&&(h=a.length),a.slice(o,h)}for(R=a.length-1;R>=0;--R)if(a.charCodeAt(R)===l){if(!D){o=R+1;break}}else h===-1&&(D=!1,h=R+1);return h===-1?"":a.slice(o,h)},extname(a){e(a,"path");let s=-1,o=0,h=-1,D=!0,R=0;for(let S=a.length-1;S>=0;--S){const T=a.charCodeAt(S);if(T===l){if(!D){o=S+1;break}continue}h===-1&&(D=!1,h=S+1),T===b?s===-1?s=S:R!==1&&(R=1):s!==-1&&(R=-1)}return s===-1||h===-1||R===0||R===1&&s===h-1&&s===o+1?"":a.slice(s,h)},format:w.bind(null,"/"),parse(a){e(a,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return s;const o=a.charCodeAt(0)===l;let h;o?(s.root="/",h=1):h=0;let D=-1,R=0,S=-1,T=!0,y=a.length-1,k=0;for(;y>=h;--y){const O=a.charCodeAt(y);if(O===l){if(!T){R=y+1;break}continue}S===-1&&(T=!1,S=y+1),O===b?D===-1?D=y:k!==1&&(k=1):D!==-1&&(k=-1)}if(S!==-1){const O=R===0&&o?1:R;D===-1||k===0||k===1&&D===S-1&&D===R+1?s.base=s.name=a.slice(O,S):(s.name=a.slice(O,D),s.base=a.slice(O,S),s.ext=a.slice(D,S))}return R>0?s.dir=a.slice(0,R-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},i.posix.win32=i.win32.win32=i.win32,i.posix.posix=i.win32.posix=i.posix,i.normalize=m?i.win32.normalize:i.posix.normalize,i.isAbsolute=m?i.win32.isAbsolute:i.posix.isAbsolute,i.join=m?i.win32.join:i.posix.join,i.resolve=m?i.win32.resolve:i.posix.resolve,i.relative=m?i.win32.relative:i.posix.relative,i.dirname=m?i.win32.dirname:i.posix.dirname,i.basename=m?i.win32.basename:i.posix.basename,i.extname=m?i.win32.extname:i.posix.extname,i.format=m?i.win32.format:i.posix.format,i.parse=m?i.win32.parse:i.posix.parse,i.toNamespacedPath=m?i.win32.toNamespacedPath:i.posix.toNamespacedPath,i.sep=m?i.win32.sep:i.posix.sep,i.delimiter=m?i.win32.delimiter:i.posix.delimiter}),ne(ie[21],re([0,1,3,42,74,20]),function(V,i,t,n,M,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.URI=void 0,i.isUriComponents=v,i.uriToFsPath=a;const E=/^\w[\w\d+.-]*$/,b=/^\//,l=/^\/\//;function u(R,S){if(!R.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!E.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!b.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(l.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(R,S){return!R&&!S?"file":R}function _(R,S){switch(R){case"https":case"http":case"file":S?S[0]!==p&&(S=p+S):S=p;break}return S}const d="",p="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(S){return S instanceof m?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,T,y,k,O,I=!1){typeof S=="object"?(this.scheme=S.scheme||d,this.authority=S.authority||d,this.path=S.path||d,this.query=S.query||d,this.fragment=S.fragment||d):(this.scheme=f(S,I),this.authority=T||d,this.path=_(this.scheme,y||d),this.query=k||d,this.fragment=O||d,u(this,I))}get fsPath(){return a(this,!1)}with(S){if(!S)return this;let{scheme:T,authority:y,path:k,query:O,fragment:I}=S;return T===void 0?T=this.scheme:T===null&&(T=d),y===void 0?y=this.authority:y===null&&(y=d),k===void 0?k=this.path:k===null&&(k=d),O===void 0?O=this.query:O===null&&(O=d),I===void 0?I=this.fragment:I===null&&(I=d),T===this.scheme&&y===this.authority&&k===this.path&&O===this.query&&I===this.fragment?this:new N(T,y,k,O,I)}static parse(S,T=!1){const y=e.exec(S);return y?new N(y[2]||d,D(y[4]||d),D(y[5]||d),D(y[7]||d),D(y[9]||d),T):new N(d,d,d,d,d)}static file(S){let T=d;if(g.isWindows&&(S=S.replace(/\\/g,p)),S[0]===p&&S[1]===p){const y=S.indexOf(p,2);y===-1?(T=S.substring(2),S=p):(T=S.substring(2,y),S=S.substring(y)||p)}return new N("file",T,S,d,d)}static from(S,T){return new N(S.scheme,S.authority,S.path,S.query,S.fragment,T)}static joinPath(S,...T){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return g.isWindows&&S.scheme==="file"?y=m.file(M.win32.join(a(S,!0),...T)).path:y=M.posix.join(S.path,...T),S.with({path:y})}toString(S=!1){return s(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof m)return S;{const T=new N(S);return T._formatted=S.external??null,T._fsPath=S._sep===A?S.fsPath??null:null,T}}else return S}}i.URI=m;function v(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}const A=g.isWindows?1:void 0;class N extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(S=!1){return S?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const S={$mid:n.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=A),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const L={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function w(R,S,T){let y,k=-1;for(let O=0;O<R.length;O++){const I=R.charCodeAt(O);if(I>=t.CharCode.a&&I<=t.CharCode.z||I>=t.CharCode.A&&I<=t.CharCode.Z||I>=t.CharCode.Digit0&&I<=t.CharCode.Digit9||I===t.CharCode.Dash||I===t.CharCode.Period||I===t.CharCode.Underline||I===t.CharCode.Tilde||S&&I===t.CharCode.Slash||T&&I===t.CharCode.OpenSquareBracket||T&&I===t.CharCode.CloseSquareBracket||T&&I===t.CharCode.Colon)k!==-1&&(y+=encodeURIComponent(R.substring(k,O)),k=-1),y!==void 0&&(y+=R.charAt(O));else{y===void 0&&(y=R.substr(0,O));const U=L[I];U!==void 0?(k!==-1&&(y+=encodeURIComponent(R.substring(k,O)),k=-1),y+=U):k===-1&&(k=O)}}return k!==-1&&(y+=encodeURIComponent(R.substring(k))),y!==void 0?y:R}function c(R){let S;for(let T=0;T<R.length;T++){const y=R.charCodeAt(T);y===t.CharCode.Hash||y===t.CharCode.QuestionMark?(S===void 0&&(S=R.substr(0,T)),S+=L[y]):S!==void 0&&(S+=R[T])}return S!==void 0?S:R}function a(R,S){let T;return R.authority&&R.path.length>1&&R.scheme==="file"?T=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===t.CharCode.Slash&&(R.path.charCodeAt(1)>=t.CharCode.A&&R.path.charCodeAt(1)<=t.CharCode.Z||R.path.charCodeAt(1)>=t.CharCode.a&&R.path.charCodeAt(1)<=t.CharCode.z)&&R.path.charCodeAt(2)===t.CharCode.Colon?S?T=R.path.substr(1):T=R.path[1].toLowerCase()+R.path.substr(2):T=R.path,g.isWindows&&(T=T.replace(/\//g,"\\")),T}function s(R,S){const T=S?c:w;let y="",{scheme:k,authority:O,path:I,query:U,fragment:$}=R;if(k&&(y+=k,y+=":"),(O||k==="file")&&(y+=p,y+=p),O){let q=O.indexOf("@");if(q!==-1){const x=O.substr(0,q);O=O.substr(q+1),q=x.lastIndexOf(":"),q===-1?y+=T(x,!1,!1):(y+=T(x.substr(0,q),!1,!1),y+=":",y+=T(x.substr(q+1),!1,!0)),y+="@"}O=O.toLowerCase(),q=O.lastIndexOf(":"),q===-1?y+=T(O,!1,!0):(y+=T(O.substr(0,q),!1,!0),y+=O.substr(q))}if(I){if(I.length>=3&&I.charCodeAt(0)===t.CharCode.Slash&&I.charCodeAt(2)===t.CharCode.Colon){const q=I.charCodeAt(1);q>=t.CharCode.A&&q<=t.CharCode.Z&&(I=`/${String.fromCharCode(q+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===t.CharCode.Colon){const q=I.charCodeAt(0);q>=t.CharCode.A&&q<=t.CharCode.Z&&(I=`${String.fromCharCode(q+32)}:${I.substr(2)}`)}y+=T(I,!0,!1)}return U&&(y+="?",y+=T(U,!1,!1)),$&&(y+="#",y+=S?$:w($,!1,!1)),y}function o(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+o(R.substr(3)):R}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function D(R){return R.match(h)?R.replace(h,S=>o(S)):R}}),ne(ie[79],re([0,1,4,13,12,17,20,8]),function(V,i,t,n,M,g,E,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SimpleWorkerServer=i.SimpleWorkerClient=void 0,i.logOnceWebWorkerWarning=f,i.create=s;const l="$initialize";let u=!1;function f(o){E.isWeb&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}var _;(function(o){o[o.Request=0]="Request",o[o.Reply=1]="Reply",o[o.SubscribeEvent=2]="SubscribeEvent",o[o.Event=3]="Event",o[o.UnsubscribeEvent=4]="UnsubscribeEvent"})(_||(_={}));class d{constructor(h,D,R,S){this.vsWorker=h,this.req=D,this.method=R,this.args=S,this.type=_.Request}}class p{constructor(h,D,R,S){this.vsWorker=h,this.seq=D,this.res=R,this.err=S,this.type=_.Reply}}class e{constructor(h,D,R,S){this.vsWorker=h,this.req=D,this.eventName=R,this.arg=S,this.type=_.SubscribeEvent}}class m{constructor(h,D,R){this.vsWorker=h,this.req=D,this.event=R,this.type=_.Event}}class v{constructor(h,D){this.vsWorker=h,this.req=D,this.type=_.UnsubscribeEvent}}class A{constructor(h){this._workerId=-1,this._handler=h,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(h){this._workerId=h}sendMessage(h,D){const R=String(++this._lastSentReq);return new Promise((S,T)=>{this._pendingReplies[R]={resolve:S,reject:T},this._send(new d(this._workerId,R,h,D))})}listen(h,D){let R=null;const S=new n.Emitter({onWillAddFirstListener:()=>{R=String(++this._lastSentReq),this._pendingEmitters.set(R,S),this._send(new e(this._workerId,R,h,D))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(R),this._send(new v(this._workerId,R)),R=null}});return S.event}handleMessage(h){!h||!h.vsWorker||this._workerId!==-1&&h.vsWorker!==this._workerId||this._handleMessage(h)}_handleMessage(h){switch(h.type){case _.Reply:return this._handleReplyMessage(h);case _.Request:return this._handleRequestMessage(h);case _.SubscribeEvent:return this._handleSubscribeEventMessage(h);case _.Event:return this._handleEventMessage(h);case _.UnsubscribeEvent:return this._handleUnsubscribeEventMessage(h)}}_handleReplyMessage(h){if(!this._pendingReplies[h.seq]){console.warn("Got reply to unknown seq");return}const D=this._pendingReplies[h.seq];if(delete this._pendingReplies[h.seq],h.err){let R=h.err;h.err.$isError&&(R=new Error,R.name=h.err.name,R.message=h.err.message,R.stack=h.err.stack),D.reject(R);return}D.resolve(h.res)}_handleRequestMessage(h){const D=h.req;this._handler.handleMessage(h.method,h.args).then(S=>{this._send(new p(this._workerId,D,S,void 0))},S=>{S.detail instanceof Error&&(S.detail=(0,t.transformErrorForSerialization)(S.detail)),this._send(new p(this._workerId,D,void 0,(0,t.transformErrorForSerialization)(S)))})}_handleSubscribeEventMessage(h){const D=h.req,R=this._handler.handleEvent(h.eventName,h.arg)(S=>{this._send(new m(this._workerId,D,S))});this._pendingEvents.set(D,R)}_handleEventMessage(h){if(!this._pendingEmitters.has(h.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(h.req).fire(h.event)}_handleUnsubscribeEventMessage(h){if(!this._pendingEvents.has(h.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(h.req).dispose(),this._pendingEvents.delete(h.req)}_send(h){const D=[];if(h.type===_.Request)for(let R=0;R<h.args.length;R++)h.args[R]instanceof ArrayBuffer&&D.push(h.args[R]);else h.type===_.Reply&&h.res instanceof ArrayBuffer&&D.push(h.res);this._handler.sendMessage(h,D)}}class N extends M.Disposable{constructor(h,D,R){super();let S=null;this._worker=this._register(h.create("vs/base/common/worker/simpleWorker",U=>{this._protocol.handleMessage(U)},U=>{S?.(U)})),this._protocol=new A({sendMessage:(U,$)=>{this._worker.postMessage(U,$)},handleMessage:(U,$)=>{if(typeof R[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(R[U].apply(R,$))}catch(q){return Promise.reject(q)}},handleEvent:(U,$)=>{if(w(U)){const q=R[U].call(R,$);if(typeof q!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return q}if(L(U)){const q=R[U];if(typeof q!="function")throw new Error(`Missing event ${U} on main thread host.`);return q}throw new Error(`Malformed event name ${U}`)}}),this._protocol.setWorkerId(this._worker.getId());let T=null;const y=globalThis.require;typeof y<"u"&&typeof y.getConfig=="function"?T=y.getConfig():typeof globalThis.requirejs<"u"&&(T=globalThis.requirejs.s.contexts._.config);const k=(0,g.getAllMethodNames)(R);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(T)),D,k]);const O=(U,$)=>this._request(U,$),I=(U,$)=>this._protocol.listen(U,$);this._lazyProxy=new Promise((U,$)=>{S=$,this._onModuleLoaded.then(q=>{U(c(q,O,I))},q=>{$(q),this._onError("Worker failed to load "+D,q)})})}getProxyObject(){return this._lazyProxy}_request(h,D){return new Promise((R,S)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(h,D).then(R,S)},S)})}_onError(h,D){console.error(h),console.info(D)}}i.SimpleWorkerClient=N;function L(o){return o[0]==="o"&&o[1]==="n"&&b.isUpperAsciiLetter(o.charCodeAt(2))}function w(o){return/^onDynamic/.test(o)&&b.isUpperAsciiLetter(o.charCodeAt(9))}function c(o,h,D){const R=y=>function(){const k=Array.prototype.slice.call(arguments,0);return h(y,k)},S=y=>function(k){return D(y,k)},T={};for(const y of o){if(w(y)){T[y]=S(y);continue}if(L(y)){T[y]=D(y,void 0);continue}T[y]=R(y)}return T}class a{constructor(h,D){this._requestHandlerFactory=D,this._requestHandler=null,this._protocol=new A({sendMessage:(R,S)=>{h(R,S)},handleMessage:(R,S)=>this._handleMessage(R,S),handleEvent:(R,S)=>this._handleEvent(R,S)})}onmessage(h){this._protocol.handleMessage(h)}_handleMessage(h,D){if(h===l)return this.initialize(D[0],D[1],D[2],D[3]);if(!this._requestHandler||typeof this._requestHandler[h]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+h));try{return Promise.resolve(this._requestHandler[h].apply(this._requestHandler,D))}catch(R){return Promise.reject(R)}}_handleEvent(h,D){if(!this._requestHandler)throw new Error("Missing requestHandler");if(w(h)){const R=this._requestHandler[h].call(this._requestHandler,D);if(typeof R!="function")throw new Error(`Missing dynamic event ${h} on request handler.`);return R}if(L(h)){const R=this._requestHandler[h];if(typeof R!="function")throw new Error(`Missing event ${h} on request handler.`);return R}throw new Error(`Malformed event name ${h}`)}initialize(h,D,R,S){this._protocol.setWorkerId(h);const k=c(S,(O,I)=>this._protocol.sendMessage(O,I),(O,I)=>this._protocol.listen(O,I));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(k),Promise.resolve((0,g.getAllMethodNames)(this._requestHandler))):(D&&(typeof D.baseUrl<"u"&&delete D.baseUrl,typeof D.paths<"u"&&typeof D.paths.vs<"u"&&delete D.paths.vs,typeof D.trustedTypesPolicy<"u"&&delete D.trustedTypesPolicy,D.catchError=!0,globalThis.require.config(D)),new Promise((O,I)=>{(globalThis.require||V)([R],$=>{if(this._requestHandler=$.create(k),!this._requestHandler){I(new Error("No RequestHandler!"));return}O((0,g.getAllMethodNames)(this._requestHandler))},I)}))}}i.SimpleWorkerServer=a;function s(o){return new a(o,null)}}),ne(ie[75],re([71,72]),function(V,i){return V.create("vs/editor/common/languages",i)}),ne(ie[76],re([0,1,45,21,47,2,69,75]),function(V,i,t,n,M,g,E,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InlineEditTriggerKind=i.ExternalUriOpenerPriority=i.TokenizationRegistry=i.LazyTokenizationSupport=i.InlayHintKind=i.CommentState=i.CommentMode=i.CommentThreadApplicability=i.CommentThreadState=i.CommentThreadCollapsibleState=i.Command=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.FoldingRangeKind=i.TextEdit=i.SymbolKinds=i.SymbolTag=i.symbolKindNames=i.SymbolKind=i.DocumentHighlightKind=i.SignatureHelpTriggerKind=i.DocumentPasteTriggerKind=i.CodeActionTriggerType=i.SelectedSuggestionInfo=i.InlineCompletionTriggerKind=i.CompletionTriggerKind=i.PartialAcceptTriggerKind=i.CompletionItemInsertTextRule=i.CompletionItemTag=i.CompletionItemKinds=i.CompletionItemKind=i.HoverVerbosityAction=i.EncodedTokenizationResult=i.TokenizationResult=i.Token=void 0,i.isLocationLink=o,i.getAriaLabelForSymbol=D;class l{constructor(j,fe,oe){this.offset=j,this.type=fe,this.language=oe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}i.Token=l;class u{constructor(j,fe){this.tokens=j,this.endState=fe,this._tokenizationResultBrand=void 0}}i.TokenizationResult=u;class f{constructor(j,fe){this.tokens=j,this.endState=fe,this._encodedTokenizationResultBrand=void 0}}i.EncodedTokenizationResult=f;var _;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})(_||(i.HoverVerbosityAction=_={}));var d;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(d||(i.CompletionItemKind=d={}));var p;(function(F){const j=new Map;j.set(d.Method,t.Codicon.symbolMethod),j.set(d.Function,t.Codicon.symbolFunction),j.set(d.Constructor,t.Codicon.symbolConstructor),j.set(d.Field,t.Codicon.symbolField),j.set(d.Variable,t.Codicon.symbolVariable),j.set(d.Class,t.Codicon.symbolClass),j.set(d.Struct,t.Codicon.symbolStruct),j.set(d.Interface,t.Codicon.symbolInterface),j.set(d.Module,t.Codicon.symbolModule),j.set(d.Property,t.Codicon.symbolProperty),j.set(d.Event,t.Codicon.symbolEvent),j.set(d.Operator,t.Codicon.symbolOperator),j.set(d.Unit,t.Codicon.symbolUnit),j.set(d.Value,t.Codicon.symbolValue),j.set(d.Enum,t.Codicon.symbolEnum),j.set(d.Constant,t.Codicon.symbolConstant),j.set(d.Enum,t.Codicon.symbolEnum),j.set(d.EnumMember,t.Codicon.symbolEnumMember),j.set(d.Keyword,t.Codicon.symbolKeyword),j.set(d.Snippet,t.Codicon.symbolSnippet),j.set(d.Text,t.Codicon.symbolText),j.set(d.Color,t.Codicon.symbolColor),j.set(d.File,t.Codicon.symbolFile),j.set(d.Reference,t.Codicon.symbolReference),j.set(d.Customcolor,t.Codicon.symbolCustomColor),j.set(d.Folder,t.Codicon.symbolFolder),j.set(d.TypeParameter,t.Codicon.symbolTypeParameter),j.set(d.User,t.Codicon.account),j.set(d.Issue,t.Codicon.issues);function fe(r){let De=j.get(r);return De||(console.info("No codicon found for CompletionItemKind "+r),De=t.Codicon.symbolProperty),De}F.toIcon=fe;const oe=new Map;oe.set("method",d.Method),oe.set("function",d.Function),oe.set("constructor",d.Constructor),oe.set("field",d.Field),oe.set("variable",d.Variable),oe.set("class",d.Class),oe.set("struct",d.Struct),oe.set("interface",d.Interface),oe.set("module",d.Module),oe.set("property",d.Property),oe.set("event",d.Event),oe.set("operator",d.Operator),oe.set("unit",d.Unit),oe.set("value",d.Value),oe.set("constant",d.Constant),oe.set("enum",d.Enum),oe.set("enum-member",d.EnumMember),oe.set("enumMember",d.EnumMember),oe.set("keyword",d.Keyword),oe.set("snippet",d.Snippet),oe.set("text",d.Text),oe.set("color",d.Color),oe.set("file",d.File),oe.set("reference",d.Reference),oe.set("customcolor",d.Customcolor),oe.set("folder",d.Folder),oe.set("type-parameter",d.TypeParameter),oe.set("typeParameter",d.TypeParameter),oe.set("account",d.User),oe.set("issue",d.Issue);function Le(r,De){let ke=oe.get(r);return typeof ke>"u"&&!De&&(ke=d.Property),ke}F.fromString=Le})(p||(i.CompletionItemKinds=p={}));var e;(function(F){F[F.Deprecated=1]="Deprecated"})(e||(i.CompletionItemTag=e={}));var m;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(m||(i.CompletionItemInsertTextRule=m={}));var v;(function(F){F[F.Word=0]="Word",F[F.Line=1]="Line",F[F.Suggest=2]="Suggest"})(v||(i.PartialAcceptTriggerKind=v={}));var A;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A||(i.CompletionTriggerKind=A={}));var N;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(N||(i.InlineCompletionTriggerKind=N={}));class L{constructor(j,fe,oe,Le){this.range=j,this.text=fe,this.completionKind=oe,this.isSnippetText=Le}equals(j){return g.Range.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}i.SelectedSuggestionInfo=L;var w;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(w||(i.CodeActionTriggerType=w={}));var c;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(c||(i.DocumentPasteTriggerKind=c={}));var a;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(a||(i.SignatureHelpTriggerKind=a={}));var s;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(s||(i.DocumentHighlightKind=s={}));function o(F){return F&&n.URI.isUri(F.uri)&&g.Range.isIRange(F.range)&&(g.Range.isIRange(F.originSelectionRange)||g.Range.isIRange(F.targetSelectionRange))}var h;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(h||(i.SymbolKind=h={})),i.symbolKindNames={[h.Array]:(0,b.localize)(0,null),[h.Boolean]:(0,b.localize)(1,null),[h.Class]:(0,b.localize)(2,null),[h.Constant]:(0,b.localize)(3,null),[h.Constructor]:(0,b.localize)(4,null),[h.Enum]:(0,b.localize)(5,null),[h.EnumMember]:(0,b.localize)(6,null),[h.Event]:(0,b.localize)(7,null),[h.Field]:(0,b.localize)(8,null),[h.File]:(0,b.localize)(9,null),[h.Function]:(0,b.localize)(10,null),[h.Interface]:(0,b.localize)(11,null),[h.Key]:(0,b.localize)(12,null),[h.Method]:(0,b.localize)(13,null),[h.Module]:(0,b.localize)(14,null),[h.Namespace]:(0,b.localize)(15,null),[h.Null]:(0,b.localize)(16,null),[h.Number]:(0,b.localize)(17,null),[h.Object]:(0,b.localize)(18,null),[h.Operator]:(0,b.localize)(19,null),[h.Package]:(0,b.localize)(20,null),[h.Property]:(0,b.localize)(21,null),[h.String]:(0,b.localize)(22,null),[h.Struct]:(0,b.localize)(23,null),[h.TypeParameter]:(0,b.localize)(24,null),[h.Variable]:(0,b.localize)(25,null)};function D(F,j){return(0,b.localize)(26,null,F,i.symbolKindNames[j])}var R;(function(F){F[F.Deprecated=1]="Deprecated"})(R||(i.SymbolTag=R={}));var S;(function(F){const j=new Map;j.set(h.File,t.Codicon.symbolFile),j.set(h.Module,t.Codicon.symbolModule),j.set(h.Namespace,t.Codicon.symbolNamespace),j.set(h.Package,t.Codicon.symbolPackage),j.set(h.Class,t.Codicon.symbolClass),j.set(h.Method,t.Codicon.symbolMethod),j.set(h.Property,t.Codicon.symbolProperty),j.set(h.Field,t.Codicon.symbolField),j.set(h.Constructor,t.Codicon.symbolConstructor),j.set(h.Enum,t.Codicon.symbolEnum),j.set(h.Interface,t.Codicon.symbolInterface),j.set(h.Function,t.Codicon.symbolFunction),j.set(h.Variable,t.Codicon.symbolVariable),j.set(h.Constant,t.Codicon.symbolConstant),j.set(h.String,t.Codicon.symbolString),j.set(h.Number,t.Codicon.symbolNumber),j.set(h.Boolean,t.Codicon.symbolBoolean),j.set(h.Array,t.Codicon.symbolArray),j.set(h.Object,t.Codicon.symbolObject),j.set(h.Key,t.Codicon.symbolKey),j.set(h.Null,t.Codicon.symbolNull),j.set(h.EnumMember,t.Codicon.symbolEnumMember),j.set(h.Struct,t.Codicon.symbolStruct),j.set(h.Event,t.Codicon.symbolEvent),j.set(h.Operator,t.Codicon.symbolOperator),j.set(h.TypeParameter,t.Codicon.symbolTypeParameter);function fe(oe){let Le=j.get(oe);return Le||(console.info("No codicon found for SymbolKind "+oe),Le=t.Codicon.symbolProperty),Le}F.toIcon=fe})(S||(i.SymbolKinds=S={}));class T{static asEditOperation(j){return M.EditOperation.replace(g.Range.lift(j.range),j.text)}}i.TextEdit=T;class y{static{this.Comment=new y("comment")}static{this.Imports=new y("imports")}static{this.Region=new y("region")}static fromValue(j){switch(j){case"comment":return y.Comment;case"imports":return y.Imports;case"region":return y.Region}return new y(j)}constructor(j){this.value=j}}i.FoldingRangeKind=y;var k;(function(F){F[F.AIGenerated=1]="AIGenerated"})(k||(i.NewSymbolNameTag=k={}));var O;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(O||(i.NewSymbolNameTriggerKind=O={}));var I;(function(F){function j(fe){return!fe||typeof fe!="object"?!1:typeof fe.id=="string"&&typeof fe.title=="string"}F.is=j})(I||(i.Command=I={}));var U;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(U||(i.CommentThreadCollapsibleState=U={}));var $;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})($||(i.CommentThreadState=$={}));var q;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(q||(i.CommentThreadApplicability=q={}));var x;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(x||(i.CommentMode=x={}));var X;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(X||(i.CommentState=X={}));var Y;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(Y||(i.InlayHintKind=Y={}));class G{constructor(j){this.createSupport=j,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}i.LazyTokenizationSupport=G,i.TokenizationRegistry=new E.TokenizationRegistry;var Q;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(Q||(i.ExternalUriOpenerPriority=Q={}));var K;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(K||(i.InlineEditTriggerKind=K={}))}),ne(ie[77],re([0,1,26,13,40,21,5,2,48,76,68]),function(V,i,t,n,M,g,E,b,l,u,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyMod=void 0,i.createMonacoBaseAPI=d;class _{static{this.CtrlCmd=M.KeyMod.CtrlCmd}static{this.Shift=M.KeyMod.Shift}static{this.Alt=M.KeyMod.Alt}static{this.WinCtrl=M.KeyMod.WinCtrl}static chord(e,m){return(0,M.KeyChord)(e,m)}}i.KeyMod=_;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.CancellationTokenSource,Emitter:n.Emitter,KeyCode:f.KeyCode,KeyMod:_,Position:E.Position,Range:b.Range,Selection:l.Selection,SelectionDirection:f.SelectionDirection,MarkerSeverity:f.MarkerSeverity,MarkerTag:f.MarkerTag,Uri:g.URI,Token:u.Token}}}),ne(ie[80],re([0,1,29,21,5,2,64,32,60,61,77,25,67,36,57,17,4,59,66]),function(V,i,t,n,M,g,E,b,l,u,f,_,d,p,e,m,v,A,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.EditorSimpleWorker=void 0,i.create=c;class L extends E.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(s){const o=[];for(let h=0;h<this._lines.length;h++){const D=this._lines[h],R=this.offsetAt(new M.Position(h+1,1)),S=D.matchAll(s);for(const T of S)(T.index||T.index===0)&&(T.index=T.index+R),o.push(T)}return o}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(s){return this._lines[s-1]}getWordAtPosition(s,o){const h=(0,b.getWordAtText)(s.column,(0,b.ensureValidWordDefinition)(o),this._lines[s.lineNumber-1],0);return h?new g.Range(s.lineNumber,h.startColumn,s.lineNumber,h.endColumn):null}getWordUntilPosition(s,o){const h=this.getWordAtPosition(s,o);return h?{word:this._lines[s.lineNumber-1].substring(h.startColumn-1,s.column-1),startColumn:h.startColumn,endColumn:s.column}:{word:"",startColumn:s.column,endColumn:s.column}}words(s){const o=this._lines,h=this._wordenize.bind(this);let D=0,R="",S=0,T=[];return{*[Symbol.iterator](){for(;;)if(S<T.length){const y=R.substring(T[S].start,T[S].end);S+=1,yield y}else if(D<o.length)R=o[D],T=h(R,s),S=0,D+=1;else break}}}getLineWords(s,o){const h=this._lines[s-1],D=this._wordenize(h,o),R=[];for(const S of D)R.push({word:h.substring(S.start,S.end),startColumn:S.start+1,endColumn:S.end+1});return R}_wordenize(s,o){const h=[];let D;for(o.lastIndex=0;(D=o.exec(s))&&D[0].length!==0;)h.push({start:D.index,end:D.index+D[0].length});return h}getValueInRange(s){if(s=this._validateRange(s),s.startLineNumber===s.endLineNumber)return this._lines[s.startLineNumber-1].substring(s.startColumn-1,s.endColumn-1);const o=this._eol,h=s.startLineNumber-1,D=s.endLineNumber-1,R=[];R.push(this._lines[h].substring(s.startColumn-1));for(let S=h+1;S<D;S++)R.push(this._lines[S]);return R.push(this._lines[D].substring(0,s.endColumn-1)),R.join(o)}offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getPrefixSum(s.lineNumber-2)+(s.column-1)}positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(s),h=this._lines[o.index].length;return{lineNumber:1+o.index,column:1+Math.min(o.remainder,h)}}_validateRange(s){const o=this._validatePosition({lineNumber:s.startLineNumber,column:s.startColumn}),h=this._validatePosition({lineNumber:s.endLineNumber,column:s.endColumn});return o.lineNumber!==s.startLineNumber||o.column!==s.startColumn||h.lineNumber!==s.endLineNumber||h.column!==s.endColumn?{startLineNumber:o.lineNumber,startColumn:o.column,endLineNumber:h.lineNumber,endColumn:h.column}:s}_validatePosition(s){if(!M.Position.isIPosition(s))throw new Error("bad position");let{lineNumber:o,column:h}=s,D=!1;if(o<1)o=1,h=1,D=!0;else if(o>this._lines.length)o=this._lines.length,h=this._lines[o-1].length+1,D=!0;else{const R=this._lines[o-1].length+1;h<1?(h=1,D=!0):h>R&&(h=R,D=!0)}return D?{lineNumber:o,column:h}:s}}class w{constructor(s,o){this._host=s,this._models=Object.create(null),this._foreignModuleFactory=o,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(s){return this._models[s]}_getModels(){const s=[];return Object.keys(this._models).forEach(o=>s.push(this._models[o])),s}acceptNewModel(s){this._models[s.url]=new L(n.URI.parse(s.url),s.lines,s.EOL,s.versionId)}acceptModelChanged(s,o){if(!this._models[s])return;this._models[s].onEvents(o)}acceptRemovedModel(s){this._models[s]&&delete this._models[s]}async computeUnicodeHighlights(s,o,h){const D=this._getModel(s);return D?d.UnicodeTextModelHighlighter.computeUnicodeHighlights(D,o,h):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(s,o){const h=this._getModel(s);return h?(0,N.findSectionHeaders)(h,o):[]}async computeDiff(s,o,h,D){const R=this._getModel(s),S=this._getModel(o);return!R||!S?null:w.computeDiff(R,S,h,D)}static computeDiff(s,o,h,D){const R=D==="advanced"?e.linesDiffComputers.getDefault():e.linesDiffComputers.getLegacy(),S=s.getLinesContent(),T=o.getLinesContent(),y=R.computeDiff(S,T,h),k=y.changes.length>0?!1:this._modelsAreIdentical(s,o);function O(I){return I.map(U=>[U.original.startLineNumber,U.original.endLineNumberExclusive,U.modified.startLineNumber,U.modified.endLineNumberExclusive,U.innerChanges?.map($=>[$.originalRange.startLineNumber,$.originalRange.startColumn,$.originalRange.endLineNumber,$.originalRange.endColumn,$.modifiedRange.startLineNumber,$.modifiedRange.startColumn,$.modifiedRange.endLineNumber,$.modifiedRange.endColumn])])}return{identical:k,quitEarly:y.hitTimeout,changes:O(y.changes),moves:y.moves.map(I=>[I.lineRangeMapping.original.startLineNumber,I.lineRangeMapping.original.endLineNumberExclusive,I.lineRangeMapping.modified.startLineNumber,I.lineRangeMapping.modified.endLineNumberExclusive,O(I.changes)])}}static _modelsAreIdentical(s,o){const h=s.getLineCount(),D=o.getLineCount();if(h!==D)return!1;for(let R=1;R<=h;R++){const S=s.getLineContent(R),T=o.getLineContent(R);if(S!==T)return!1}return!0}async computeDirtyDiff(s,o,h){const D=this._getModel(s),R=this._getModel(o);if(!D||!R)return null;const S=D.getLinesContent(),T=R.getLinesContent();return new p.DiffComputer(S,T,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:h,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this._diffLimit=1e5}async computeMoreMinimalEdits(s,o,h){const D=this._getModel(s);if(!D)return o;const R=[];let S;o=o.slice(0).sort((y,k)=>{if(y.range&&k.range)return g.Range.compareRangesUsingStarts(y.range,k.range);const O=y.range?0:1,I=k.range?0:1;return O-I});let T=0;for(let y=1;y<o.length;y++)g.Range.getEndPosition(o[T].range).equals(g.Range.getStartPosition(o[y].range))?(o[T].range=g.Range.fromPositions(g.Range.getStartPosition(o[T].range),g.Range.getEndPosition(o[y].range)),o[T].text+=o[y].text):(T++,o[T]=o[y]);o.length=T+1;for(let{range:y,text:k,eol:O}of o){if(typeof O=="number"&&(S=O),g.Range.isEmpty(y)&&!k)continue;const I=D.getValueInRange(y);if(k=k.replace(/\r\n|\n|\r/g,D.eol),I===k)continue;if(Math.max(k.length,I.length)>w._diffLimit){R.push({range:y,text:k});continue}const U=(0,t.stringDiff)(I,k,h),$=D.offsetAt(g.Range.lift(y).getStartPosition());for(const q of U){const x=D.positionAt($+q.originalStart),X=D.positionAt($+q.originalStart+q.originalLength),Y={text:k.substr(q.modifiedStart,q.modifiedLength),range:{startLineNumber:x.lineNumber,startColumn:x.column,endLineNumber:X.lineNumber,endColumn:X.column}};D.getValueInRange(Y.range)!==Y.text&&R.push(Y)}}return typeof S=="number"&&R.push({eol:S,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),R}computeHumanReadableDiff(s,o,h){const D=this._getModel(s);if(!D)return o;const R=[];let S;o=o.slice(0).sort((T,y)=>{if(T.range&&y.range)return g.Range.compareRangesUsingStarts(T.range,y.range);const k=T.range?0:1,O=y.range?0:1;return k-O});for(let{range:T,text:y,eol:k}of o){let x=function(Y,G){return new M.Position(Y.lineNumber+G.lineNumber-1,G.lineNumber===1?Y.column+G.column-1:G.column)},X=function(Y,G){const Q=[];for(let K=G.startLineNumber;K<=G.endLineNumber;K++){const F=Y[K-1];K===G.startLineNumber&&K===G.endLineNumber?Q.push(F.substring(G.startColumn-1,G.endColumn-1)):K===G.startLineNumber?Q.push(F.substring(G.startColumn-1)):K===G.endLineNumber?Q.push(F.substring(0,G.endColumn-1)):Q.push(F)}return Q};if(typeof k=="number"&&(S=k),g.Range.isEmpty(T)&&!y)continue;const O=D.getValueInRange(T);if(y=y.replace(/\r\n|\n|\r/g,D.eol),O===y)continue;if(Math.max(y.length,O.length)>w._diffLimit){R.push({range:T,text:y});continue}const I=O.split(/\r\n|\n|\r/),U=y.split(/\r\n|\n|\r/),$=e.linesDiffComputers.getDefault().computeDiff(I,U,h),q=g.Range.lift(T).getStartPosition();for(const Y of $.changes)if(Y.innerChanges)for(const G of Y.innerChanges)R.push({range:g.Range.fromPositions(x(q,G.originalRange.getStartPosition()),x(q,G.originalRange.getEndPosition())),text:X(U,G.modifiedRange).join(D.eol)});else throw new v.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof S=="number"&&R.push({eol:S,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),R}async computeLinks(s){const o=this._getModel(s);return o?(0,l.computeLinks)(o):null}async computeDefaultDocumentColors(s){const o=this._getModel(s);return o?(0,A.computeDefaultDocumentColors)(o):null}static{this._suggestionsLimit=1e4}async textualSuggest(s,o,h,D){const R=new _.StopWatch,S=new RegExp(h,D),T=new Set;e:for(const y of s){const k=this._getModel(y);if(k){for(const O of k.words(S))if(!(O===o||!isNaN(Number(O)))&&(T.add(O),T.size>w._suggestionsLimit))break e}}return{words:Array.from(T),duration:R.elapsed()}}async computeWordRanges(s,o,h,D){const R=this._getModel(s);if(!R)return Object.create(null);const S=new RegExp(h,D),T=Object.create(null);for(let y=o.startLineNumber;y<o.endLineNumber;y++){const k=R.getLineWords(y,S);for(const O of k){if(!isNaN(Number(O.word)))continue;let I=T[O.word];I||(I=[],T[O.word]=I),I.push({startLineNumber:y,startColumn:O.startColumn,endLineNumber:y,endColumn:O.endColumn})}}return T}async navigateValueSet(s,o,h,D,R){const S=this._getModel(s);if(!S)return null;const T=new RegExp(D,R);o.startColumn===o.endColumn&&(o={startLineNumber:o.startLineNumber,startColumn:o.startColumn,endLineNumber:o.endLineNumber,endColumn:o.endColumn+1});const y=S.getValueInRange(o),k=S.getWordAtPosition({lineNumber:o.startLineNumber,column:o.startColumn},T);if(!k)return null;const O=S.getValueInRange(k);return u.BasicInplaceReplace.INSTANCE.navigateValueSet(o,y,k,O,h)}loadForeignModule(s,o,h){const D=(T,y)=>this._host.fhr(T,y),S={host:(0,m.createProxyObject)(h,D),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(S,o),Promise.resolve((0,m.getAllMethodNames)(this._foreignModule))):new Promise((T,y)=>{V([s],k=>{this._foreignModule=k.create(S,o),T((0,m.getAllMethodNames)(this._foreignModule))},y)})}fmr(s,o){if(!this._foreignModule||typeof this._foreignModule[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this._foreignModule[s].apply(this._foreignModule,o))}catch(h){return Promise.reject(h)}}}i.EditorSimpleWorker=w;function c(a){return new w(a,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,f.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d98c6de73fb939f1eb4b8a500c569b858b2d297/core/vs/base/worker/workerMain.js.map
