/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/charCode","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/platform/window/electron-main/window","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ce=function(K){for(var e=[],i=0,s=K.length;i<s;i++)e[i]=le[K[i]];return e};define(le[138],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=i,e.findLastIdx=s,e.findLastMonotonous=P,e.findLastIdxMonotonous=k,e.findFirstMonotonous=A,e.findFirstIdxMonotonousOrArrLen=R,e.findFirstIdxMonotonous=b,e.findFirstMax=d,e.findLastMax=f,e.findFirstMin=g,e.findMaxIdx=y,e.mapFindFirst=h;function i(m,p){const v=s(m,p);if(v!==-1)return m[v]}function s(m,p,v=m.length-1){for(let w=v;w>=0;w--){const E=m[w];if(p(E))return w}return-1}function P(m,p){const v=k(m,p);return v===-1?void 0:m[v]}function k(m,p,v=0,w=m.length){let E=v,I=w;for(;E<I;){const o=Math.floor((E+I)/2);p(m[o])?E=o+1:I=o}return E-1}function A(m,p){const v=R(m,p);return v===m.length?void 0:m[v]}function R(m,p,v=0,w=m.length){let E=v,I=w;for(;E<I;){const o=Math.floor((E+I)/2);p(m[o])?I=o:E=o+1}return E}function b(m,p,v=0,w=m.length){const E=R(m,p,v,w);return E===m.length?-1:E}class l{static{this.assertInvariants=!1}constructor(p){this._array=p,this._findLastMonotonousLastIdx=0}findLastMonotonous(p){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const w of this._array)if(this._prevFindLastPredicate(w)&&!p(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=p}const v=k(this._array,p,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=v+1,v===-1?void 0:this._array[v]}}e.MonotonousArray=l;function d(m,p){if(m.length===0)return;let v=m[0];for(let w=1;w<m.length;w++){const E=m[w];p(E,v)>0&&(v=E)}return v}function f(m,p){if(m.length===0)return;let v=m[0];for(let w=1;w<m.length;w++){const E=m[w];p(E,v)>=0&&(v=E)}return v}function g(m,p){return d(m,(v,w)=>-p(v,w))}function y(m,p){if(m.length===0)return-1;let v=0;for(let w=1;w<m.length;w++){const E=m[w];p(E,m[v])>0&&(v=w)}return v}function h(m,p){for(const v of m){const w=p(v);if(w!==void 0)return w}}}),define(le[39],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var i;(function(s){s[s.Null=0]="Null",s[s.Backspace=8]="Backspace",s[s.Tab=9]="Tab",s[s.LineFeed=10]="LineFeed",s[s.CarriageReturn=13]="CarriageReturn",s[s.Space=32]="Space",s[s.ExclamationMark=33]="ExclamationMark",s[s.DoubleQuote=34]="DoubleQuote",s[s.Hash=35]="Hash",s[s.DollarSign=36]="DollarSign",s[s.PercentSign=37]="PercentSign",s[s.Ampersand=38]="Ampersand",s[s.SingleQuote=39]="SingleQuote",s[s.OpenParen=40]="OpenParen",s[s.CloseParen=41]="CloseParen",s[s.Asterisk=42]="Asterisk",s[s.Plus=43]="Plus",s[s.Comma=44]="Comma",s[s.Dash=45]="Dash",s[s.Period=46]="Period",s[s.Slash=47]="Slash",s[s.Digit0=48]="Digit0",s[s.Digit1=49]="Digit1",s[s.Digit2=50]="Digit2",s[s.Digit3=51]="Digit3",s[s.Digit4=52]="Digit4",s[s.Digit5=53]="Digit5",s[s.Digit6=54]="Digit6",s[s.Digit7=55]="Digit7",s[s.Digit8=56]="Digit8",s[s.Digit9=57]="Digit9",s[s.Colon=58]="Colon",s[s.Semicolon=59]="Semicolon",s[s.LessThan=60]="LessThan",s[s.Equals=61]="Equals",s[s.GreaterThan=62]="GreaterThan",s[s.QuestionMark=63]="QuestionMark",s[s.AtSign=64]="AtSign",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.OpenSquareBracket=91]="OpenSquareBracket",s[s.Backslash=92]="Backslash",s[s.CloseSquareBracket=93]="CloseSquareBracket",s[s.Caret=94]="Caret",s[s.Underline=95]="Underline",s[s.BackTick=96]="BackTick",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.OpenCurlyBrace=123]="OpenCurlyBrace",s[s.Pipe=124]="Pipe",s[s.CloseCurlyBrace=125]="CloseCurlyBrace",s[s.Tilde=126]="Tilde",s[s.NoBreakSpace=160]="NoBreakSpace",s[s.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",s[s.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",s[s.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",s[s.U_Combining_Tilde=771]="U_Combining_Tilde",s[s.U_Combining_Macron=772]="U_Combining_Macron",s[s.U_Combining_Overline=773]="U_Combining_Overline",s[s.U_Combining_Breve=774]="U_Combining_Breve",s[s.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",s[s.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",s[s.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",s[s.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",s[s.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",s[s.U_Combining_Caron=780]="U_Combining_Caron",s[s.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",s[s.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",s[s.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",s[s.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",s[s.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",s[s.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",s[s.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",s[s.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",s[s.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",s[s.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",s[s.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",s[s.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",s[s.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",s[s.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",s[s.U_Combining_Horn=795]="U_Combining_Horn",s[s.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",s[s.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",s[s.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",s[s.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",s[s.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",s[s.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",s[s.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",s[s.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",s[s.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",s[s.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",s[s.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",s[s.U_Combining_Cedilla=807]="U_Combining_Cedilla",s[s.U_Combining_Ogonek=808]="U_Combining_Ogonek",s[s.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",s[s.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",s[s.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",s[s.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",s[s.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",s[s.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",s[s.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",s[s.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",s[s.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",s[s.U_Combining_Low_Line=818]="U_Combining_Low_Line",s[s.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",s[s.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",s[s.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",s[s.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",s[s.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",s[s.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",s[s.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",s[s.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",s[s.U_Combining_Square_Below=827]="U_Combining_Square_Below",s[s.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",s[s.U_Combining_X_Above=829]="U_Combining_X_Above",s[s.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",s[s.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",s[s.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",s[s.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",s[s.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",s[s.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",s[s.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",s[s.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",s[s.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",s[s.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",s[s.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",s[s.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",s[s.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",s[s.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",s[s.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",s[s.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",s[s.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",s[s.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",s[s.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",s[s.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",s[s.U_Combining_Fermata=850]="U_Combining_Fermata",s[s.U_Combining_X_Below=851]="U_Combining_X_Below",s[s.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",s[s.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",s[s.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",s[s.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",s[s.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",s[s.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",s[s.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",s[s.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",s[s.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",s[s.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",s[s.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",s[s.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",s[s.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",s[s.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",s[s.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",s[s.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",s[s.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",s[s.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",s[s.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",s[s.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",s[s.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",s[s.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",s[s.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",s[s.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",s[s.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",s[s.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",s[s.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",s[s.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",s[s.LINE_SEPARATOR=8232]="LINE_SEPARATOR",s[s.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",s[s.NEXT_LINE=133]="NEXT_LINE",s[s.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",s[s.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",s[s.U_DIAERESIS=168]="U_DIAERESIS",s[s.U_MACRON=175]="U_MACRON",s[s.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",s[s.U_CEDILLA=184]="U_CEDILLA",s[s.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",s[s.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",s[s.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",s[s.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",s[s.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",s[s.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",s[s.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",s[s.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",s[s.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",s[s.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",s[s.U_BREVE=728]="U_BREVE",s[s.U_DOT_ABOVE=729]="U_DOT_ABOVE",s[s.U_RING_ABOVE=730]="U_RING_ABOVE",s[s.U_OGONEK=731]="U_OGONEK",s[s.U_SMALL_TILDE=732]="U_SMALL_TILDE",s[s.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",s[s.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",s[s.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",s[s.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",s[s.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",s[s.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",s[s.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",s[s.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",s[s.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",s[s.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",s[s.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",s[s.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",s[s.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",s[s.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",s[s.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",s[s.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",s[s.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",s[s.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",s[s.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",s[s.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",s[s.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",s[s.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",s[s.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",s[s.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",s[s.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",s[s.U_GREEK_TONOS=900]="U_GREEK_TONOS",s[s.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",s[s.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",s[s.U_GREEK_PSILI=8127]="U_GREEK_PSILI",s[s.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",s[s.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",s[s.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",s[s.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",s[s.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",s[s.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",s[s.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",s[s.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",s[s.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",s[s.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",s[s.U_GREEK_VARIA=8175]="U_GREEK_VARIA",s[s.U_GREEK_OXIA=8189]="U_GREEK_OXIA",s[s.U_GREEK_DASIA=8190]="U_GREEK_DASIA",s[s.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",s[s.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",s[s.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",s[s.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",s[s.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",s[s.U_OVERLINE=8254]="U_OVERLINE",s[s.UTF8_BOM=65279]="UTF8_BOM",s[s.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",s[s.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(e.CharCode=i={}))}),define(le[139],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=i,e.diffSets=s,e.diffMaps=P,e.intersection=k;function i(A,R){const b=Object.create(null);for(const l of A){const d=R(l);let f=b[d];f||(f=b[d]=[]),f.push(l)}return b}function s(A,R){const b=[],l=[];for(const d of A)R.has(d)||b.push(d);for(const d of R)A.has(d)||l.push(d);return{removed:b,added:l}}function P(A,R){const b=[],l=[];for(const[d,f]of A)R.has(d)||b.push(f);for(const[d,f]of R)A.has(d)||l.push(f);return{removed:b,added:l}}function k(A,R){const b=new Set;for(const l of R)A.has(l)&&b.add(l);return b}}),define(le[140],ce([0,1,39]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function s(b,l){const d=Math.pow(10,l);return Math.round(b*d)/d}class P{constructor(l,d,f,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,d))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=s(Math.max(Math.min(1,g),0),3)}static equals(l,d){return l.r===d.r&&l.g===d.g&&l.b===d.b&&l.a===d.a}}e.RGBA=P;class k{constructor(l,d,f,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=s(Math.max(Math.min(1,d),0),3),this.l=s(Math.max(Math.min(1,f),0),3),this.a=s(Math.max(Math.min(1,g),0),3)}static equals(l,d){return l.h===d.h&&l.s===d.s&&l.l===d.l&&l.a===d.a}static fromRGBA(l){const d=l.r/255,f=l.g/255,g=l.b/255,y=l.a,h=Math.max(d,f,g),m=Math.min(d,f,g);let p=0,v=0;const w=(m+h)/2,E=h-m;if(E>0){switch(v=Math.min(w<=.5?E/(2*w):E/(2-2*w),1),h){case d:p=(f-g)/E+(f<g?6:0);break;case f:p=(g-d)/E+2;break;case g:p=(d-f)/E+4;break}p*=60,p=Math.round(p)}return new k(p,v,w,y)}static _hue2rgb(l,d,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?l+(d-l)*6*f:f<1/2?d:f<2/3?l+(d-l)*(2/3-f)*6:l}static toRGBA(l){const d=l.h/360,{s:f,l:g,a:y}=l;let h,m,p;if(f===0)h=m=p=g;else{const v=g<.5?g*(1+f):g+f-g*f,w=2*g-v;h=k._hue2rgb(w,v,d+1/3),m=k._hue2rgb(w,v,d),p=k._hue2rgb(w,v,d-1/3)}return new P(Math.round(h*255),Math.round(m*255),Math.round(p*255),y)}}e.HSLA=k;class A{constructor(l,d,f,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=s(Math.max(Math.min(1,d),0),3),this.v=s(Math.max(Math.min(1,f),0),3),this.a=s(Math.max(Math.min(1,g),0),3)}static equals(l,d){return l.h===d.h&&l.s===d.s&&l.v===d.v&&l.a===d.a}static fromRGBA(l){const d=l.r/255,f=l.g/255,g=l.b/255,y=Math.max(d,f,g),h=Math.min(d,f,g),m=y-h,p=y===0?0:m/y;let v;return m===0?v=0:y===d?v=((f-g)/m%6+6)%6:y===f?v=(g-d)/m+2:v=(d-f)/m+4,new A(Math.round(v*60),p,y,l.a)}static toRGBA(l){const{h:d,s:f,v:g,a:y}=l,h=g*f,m=h*(1-Math.abs(d/60%2-1)),p=g-h;let[v,w,E]=[0,0,0];return d<60?(v=h,w=m):d<120?(v=m,w=h):d<180?(w=h,E=m):d<240?(w=m,E=h):d<300?(v=m,E=h):d<=360&&(v=h,E=m),v=Math.round((v+p)*255),w=Math.round((w+p)*255),E=Math.round((E+p)*255),new P(v,w,E,y)}}e.HSVA=A;class R{static fromHex(l){return R.Format.CSS.parseHex(l)||R.red}static equals(l,d){return!l&&!d?!0:!l||!d?!1:l.equals(d)}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:A.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof P)this.rgba=l;else if(l instanceof k)this._hsla=l,this.rgba=k.toRGBA(l);else if(l instanceof A)this._hsva=l,this.rgba=A.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&P.equals(this.rgba,l.rgba)&&k.equals(this.hsla,l.hsla)&&A.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=R._relativeLuminanceForComponent(this.rgba.r),d=R._relativeLuminanceForComponent(this.rgba.g),f=R._relativeLuminanceForComponent(this.rgba.b),g=.2126*l+.7152*d+.0722*f;return s(g,4)}static _relativeLuminanceForComponent(l){const d=l/255;return d<=.03928?d/12.92:Math.pow((d+.055)/1.055,2.4)}getContrastRatio(l){const d=this.getRelativeLuminance(),f=l.getRelativeLuminance();return d>f?(d+.05)/(f+.05):(f+.05)/(d+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const d=this.getRelativeLuminance(),f=l.getRelativeLuminance();return d>f}isDarkerThan(l){const d=this.getRelativeLuminance(),f=l.getRelativeLuminance();return d<f}lighten(l){return new R(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new R(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:d,g:f,b:g,a:y}=this.rgba;return new R(new P(d,f,g,y*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const d=l.rgba,f=this.rgba.a,g=d.a,y=f+g*(1-f);if(y<1e-6)return R.transparent;const h=this.rgba.r*f/y+d.r*g*(1-f)/y,m=this.rgba.g*f/y+d.g*g*(1-f)/y,p=this.rgba.b*f/y+d.b*g*(1-f)/y;return new R(new P(h,m,p,y))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:d,g:f,b:g,a:y}=this.rgba;return new R(new P(l.rgba.r-y*(l.rgba.r-d),l.rgba.g-y*(l.rgba.g-f),l.rgba.b-y*(l.rgba.b-g),1))}flatten(...l){const d=l.reduceRight((f,g)=>R._flatten(g,f));return R._flatten(this,d)}static _flatten(l,d){const f=1-l.rgba.a;return new R(new P(f*d.rgba.r+l.rgba.a*l.rgba.r,f*d.rgba.g+l.rgba.a*l.rgba.g,f*d.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this._toString||(this._toString=R.Format.CSS.format(this)),this._toString}static getLighterColor(l,d,f){if(l.isLighterThan(d))return l;f=f||.5;const g=l.getRelativeLuminance(),y=d.getRelativeLuminance();return f=f*(y-g)/y,l.lighten(f)}static getDarkerColor(l,d,f){if(l.isDarkerThan(d))return l;f=f||.5;const g=l.getRelativeLuminance(),y=d.getRelativeLuminance();return f=f*(g-y)/g,l.darken(f)}static{this.white=new R(new P(255,255,255,1))}static{this.black=new R(new P(0,0,0,1))}static{this.red=new R(new P(255,0,0,1))}static{this.blue=new R(new P(0,0,255,1))}static{this.green=new R(new P(0,255,0,1))}static{this.cyan=new R(new P(0,255,255,1))}static{this.lightgrey=new R(new P(211,211,211,1))}static{this.transparent=new R(new P(0,0,0,0))}}e.Color=R,function(b){let l;(function(d){let f;(function(g){function y(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:b.Format.CSS.formatRGBA(r)}g.formatRGB=y;function h(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}g.formatRGBA=h;function m(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(r)}g.formatHSL=m;function p(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}g.formatHSLA=p;function v(r){const a=r.toString(16);return a.length!==2?"0"+a:a}function w(r){return`#${v(r.rgba.r)}${v(r.rgba.g)}${v(r.rgba.b)}`}g.formatHex=w;function E(r,a=!1){return a&&r.rgba.a===1?b.Format.CSS.formatHex(r):`#${v(r.rgba.r)}${v(r.rgba.g)}${v(r.rgba.b)}${v(Math.round(r.rgba.a*255))}`}g.formatHexA=E;function I(r){return r.isOpaque()?b.Format.CSS.formatHex(r):b.Format.CSS.formatRGBA(r)}g.format=I;function o(r){const a=r.length;if(a===0||r.charCodeAt(0)!==i.CharCode.Hash)return null;if(a===7){const n=16*t(r.charCodeAt(1))+t(r.charCodeAt(2)),c=16*t(r.charCodeAt(3))+t(r.charCodeAt(4)),u=16*t(r.charCodeAt(5))+t(r.charCodeAt(6));return new b(new P(n,c,u,1))}if(a===9){const n=16*t(r.charCodeAt(1))+t(r.charCodeAt(2)),c=16*t(r.charCodeAt(3))+t(r.charCodeAt(4)),u=16*t(r.charCodeAt(5))+t(r.charCodeAt(6)),S=16*t(r.charCodeAt(7))+t(r.charCodeAt(8));return new b(new P(n,c,u,S/255))}if(a===4){const n=t(r.charCodeAt(1)),c=t(r.charCodeAt(2)),u=t(r.charCodeAt(3));return new b(new P(16*n+n,16*c+c,16*u+u))}if(a===5){const n=t(r.charCodeAt(1)),c=t(r.charCodeAt(2)),u=t(r.charCodeAt(3)),S=t(r.charCodeAt(4));return new b(new P(16*n+n,16*c+c,16*u+u,(16*S+S)/255))}return null}g.parseHex=o;function t(r){switch(r){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(f=d.CSS||(d.CSS={}))})(l=b.Format||(b.Format={}))}(R||(e.Color=R={}))}),define(le[53],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=s,e.debounce=P,e.throttle=k;function i(A){return(R,b,l)=>{let d=null,f=null;if(typeof l.value=="function"?(d="value",f=l.value):typeof l.get=="function"&&(d="get",f=l.get),!f)throw new Error("not supported");l[d]=A(f,b)}}function s(A,R,b){let l=null,d=null;if(typeof b.value=="function"?(l="value",d=b.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(l="get",d=b.get),!d)throw new Error("not supported");const f=`$memoize$${R}`;b[l]=function(...g){return this.hasOwnProperty(f)||Object.defineProperty(this,f,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,g)}),this[f]}}function P(A,R,b){return i((l,d)=>{const f=`$debounce$${d}`,g=`$debounce$result$${d}`;return function(...y){this[g]||(this[g]=b?b():void 0),clearTimeout(this[f]),R&&(this[g]=R(this[g],...y),y=[this[g]]),this[f]=setTimeout(()=>{l.apply(this,y),this[g]=b?b():void 0},A)}})}function k(A,R,b){return i((l,d)=>{const f=`$throttle$timer$${d}`,g=`$throttle$result$${d}`,y=`$throttle$lastRun$${d}`,h=`$throttle$pending$${d}`;return function(...m){if(this[g]||(this[g]=b?b():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),R&&(this[g]=R(this[g],...m)),this[h])return;const p=this[y]+A;p<=Date.now()?(this[y]=Date.now(),l.apply(this,[this[g]]),this[g]=b?b():void 0):(this[h]=!0,this[f]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),l.apply(this,[this[g]]),this[g]=b?b():void 0},p-Date.now()))}})}}),define(le[16],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=s,e.isSigPipeError=P,e.onUnexpectedError=k,e.onUnexpectedExternalError=A,e.transformErrorForSerialization=R,e.isCancellationError=l,e.canceled=f,e.illegalArgument=g,e.illegalState=y,e.getErrorMessage=m;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?E.isErrorNoTelemetry(t)?new E(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=i,e.errorHandler=new i;function s(o){e.errorHandler.setUnexpectedErrorHandler(o)}function P(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function k(o){l(o)||e.errorHandler.onUnexpectedError(o)}function A(o){l(o)||e.errorHandler.onUnexpectedExternalError(o)}function R(o){if(o instanceof Error){const{name:t,message:r}=o,a=o.stacktrace||o.stack;return{$isError:!0,name:t,message:r,stack:a,noTelemetry:E.isErrorNoTelemetry(o)}}return o}const b="Canceled";function l(o){return o instanceof d?!0:o instanceof Error&&o.name===b&&o.message===b}class d extends Error{constructor(){super(b),this.name=this.message}}e.CancellationError=d;function f(){const o=new Error(b);return o.name=o.message,o}function g(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function y(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class h extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=h;function m(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class p extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=p;class v extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=v;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class E extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof E)return t;const r=new E;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=E;class I extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,I.prototype)}}e.BugIndicatingError=I}),define(le[22],ce([0,1,16,138]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=P,e.tail2=k,e.equals=A,e.removeFastWithoutKeepingOrder=R,e.binarySearch=b,e.binarySearch2=l,e.quickSelect=d,e.groupBy=f,e.groupAdjacentBy=g,e.forEachAdjacent=y,e.forEachWithNeighbors=h,e.sortedDiff=m,e.delta=p,e.top=v,e.topAsync=w,e.coalesce=I,e.coalesceInPlace=o,e.move=t,e.isFalsyOrEmpty=r,e.isNonEmptyArray=a,e.distinct=n,e.uniqueFilter=c,e.firstOrDefault=u,e.lastOrDefault=S,e.commonPrefixLength=D,e.range=L,e.index=M,e.insert=T,e.remove=C,e.arrayInsert=F,e.shuffle=x,e.pushToStart=U,e.pushToEnd=z,e.pushMany=re,e.mapArrayOrNot=ie,e.asArray=oe,e.getRandomElement=G,e.insertInto=te,e.splice=q,e.compareBy=V,e.tieBreakComparators=ae,e.reverseOrder=ne;function P(N,H=0){return N[N.length-(1+H)]}function k(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function A(N,H,X=(Q,$)=>Q===$){if(N===H)return!0;if(!N||!H||N.length!==H.length)return!1;for(let Q=0,$=N.length;Q<$;Q++)if(!X(N[Q],H[Q]))return!1;return!0}function R(N,H){const X=N.length-1;H<X&&(N[H]=N[X]),N.pop()}function b(N,H,X){return l(N.length,Q=>X(N[Q],H))}function l(N,H){let X=0,Q=N-1;for(;X<=Q;){const $=(X+Q)/2|0,ee=H($);if(ee<0)X=$+1;else if(ee>0)Q=$-1;else return $}return-(X+1)}function d(N,H,X){if(N=N|0,N>=H.length)throw new TypeError("invalid index");const Q=H[Math.floor(H.length*Math.random())],$=[],ee=[],fe=[];for(const me of H){const we=X(me,Q);we<0?$.push(me):we>0?ee.push(me):fe.push(me)}return N<$.length?d(N,$,X):N<$.length+fe.length?fe[0]:d(N-($.length+fe.length),ee,X)}function f(N,H){const X=[];let Q;for(const $ of N.slice(0).sort(H))!Q||H(Q[0],$)!==0?(Q=[$],X.push(Q)):Q.push($);return X}function*g(N,H){let X,Q;for(const $ of N)Q!==void 0&&H(Q,$)?X.push($):(X&&(yield X),X=[$]),Q=$;X&&(yield X)}function y(N,H){for(let X=0;X<=N.length;X++)H(X===0?void 0:N[X-1],X===N.length?void 0:N[X])}function h(N,H){for(let X=0;X<N.length;X++)H(X===0?void 0:N[X-1],N[X],X+1===N.length?void 0:N[X+1])}function m(N,H,X){const Q=[];function $(me,we,Re){if(we===0&&Re.length===0)return;const Pe=Q[Q.length-1];Pe&&Pe.start+Pe.deleteCount===me?(Pe.deleteCount+=we,Pe.toInsert.push(...Re)):Q.push({start:me,deleteCount:we,toInsert:Re})}let ee=0,fe=0;for(;;){if(ee===N.length){$(ee,0,H.slice(fe));break}if(fe===H.length){$(ee,N.length-ee,[]);break}const me=N[ee],we=H[fe],Re=X(me,we);Re===0?(ee+=1,fe+=1):Re<0?($(ee,1,[]),ee+=1):Re>0&&($(ee,0,[we]),fe+=1)}return Q}function p(N,H,X){const Q=m(N,H,X),$=[],ee=[];for(const fe of Q)$.push(...N.slice(fe.start,fe.start+fe.deleteCount)),ee.push(...fe.toInsert);return{removed:$,added:ee}}function v(N,H,X){if(X===0)return[];const Q=N.slice(0,X).sort(H);return E(N,H,Q,X,N.length),Q}function w(N,H,X,Q,$){return X===0?Promise.resolve([]):new Promise((ee,fe)=>{(async()=>{const me=N.length,we=N.slice(0,X).sort(H);for(let Re=X,Pe=Math.min(X+Q,me);Re<me;Re=Pe,Pe=Math.min(Pe+Q,me)){if(Re>X&&await new Promise(De=>setTimeout(De)),$&&$.isCancellationRequested)throw new i.CancellationError;E(N,H,we,Re,Pe)}return we})().then(ee,fe)})}function E(N,H,X,Q,$){for(const ee=X.length;Q<$;Q++){const fe=N[Q];if(H(fe,X[ee-1])<0){X.pop();const me=(0,s.findFirstIdxMonotonousOrArrLen)(X,we=>H(fe,we)<0);X.splice(me,0,fe)}}}function I(N){return N.filter(H=>!!H)}function o(N){let H=0;for(let X=0;X<N.length;X++)N[X]&&(N[H]=N[X],H+=1);N.length=H}function t(N,H,X){N.splice(X,0,N.splice(H,1)[0])}function r(N){return!Array.isArray(N)||N.length===0}function a(N){return Array.isArray(N)&&N.length>0}function n(N,H=X=>X){const X=new Set;return N.filter(Q=>{const $=H(Q);return X.has($)?!1:(X.add($),!0)})}function c(N){const H=new Set;return X=>{const Q=N(X);return H.has(Q)?!1:(H.add(Q),!0)}}function u(N,H){return N.length>0?N[0]:H}function S(N,H){return N.length>0?N[N.length-1]:H}function D(N,H,X=(Q,$)=>Q===$){let Q=0;for(let $=0,ee=Math.min(N.length,H.length);$<ee&&X(N[$],H[$]);$++)Q++;return Q}function L(N,H){let X=typeof H=="number"?N:0;typeof H=="number"?X=N:(X=0,H=N);const Q=[];if(X<=H)for(let $=X;$<H;$++)Q.push($);else for(let $=X;$>H;$--)Q.push($);return Q}function M(N,H,X){return N.reduce((Q,$)=>(Q[H($)]=X?X($):$,Q),Object.create(null))}function T(N,H){return N.push(H),()=>C(N,H)}function C(N,H){const X=N.indexOf(H);if(X>-1)return N.splice(X,1),H}function F(N,H,X){const Q=N.slice(0,H),$=N.slice(H);return Q.concat(X,$)}function x(N,H){let X;if(typeof H=="number"){let Q=H;X=()=>{const $=Math.sin(Q++)*179426549;return $-Math.floor($)}}else X=Math.random;for(let Q=N.length-1;Q>0;Q-=1){const $=Math.floor(X()*(Q+1)),ee=N[Q];N[Q]=N[$],N[$]=ee}}function U(N,H){const X=N.indexOf(H);X>-1&&(N.splice(X,1),N.unshift(H))}function z(N,H){const X=N.indexOf(H);X>-1&&(N.splice(X,1),N.push(H))}function re(N,H){for(const X of H)N.push(X)}function ie(N,H){return Array.isArray(N)?N.map(H):H(N)}function oe(N){return Array.isArray(N)?N:[N]}function G(N){return N[Math.floor(Math.random()*N.length)]}function te(N,H,X){const Q=O(N,H),$=N.length,ee=X.length;N.length=$+ee;for(let fe=$-1;fe>=Q;fe--)N[fe+ee]=N[fe];for(let fe=0;fe<ee;fe++)N[fe+Q]=X[fe]}function q(N,H,X,Q){const $=O(N,H);let ee=N.splice($,X);return ee===void 0&&(ee=[]),te(N,$,Q),ee}function O(N,H){return H<0?Math.max(H+N.length,0):Math.min(H,N.length)}var B;(function(N){function H(ee){return ee<0}N.isLessThan=H;function X(ee){return ee<=0}N.isLessThanOrEqual=X;function Q(ee){return ee>0}N.isGreaterThan=Q;function $(ee){return ee===0}N.isNeitherLessOrGreaterThan=$,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(B||(e.CompareResult=B={}));function V(N,H){return(X,Q)=>H(N(X),N(Q))}function ae(...N){return(H,X)=>{for(const Q of N){const $=Q(H,X);if(!B.isNeitherLessOrGreaterThan($))return $}return B.neitherLessOrGreaterThan}}const j=(N,H)=>N-H;e.numberComparator=j;const he=(N,H)=>(0,e.numberComparator)(N?1:0,H?1:0);e.booleanComparator=he;function ne(N){return(H,X)=>-N(H,X)}class J{constructor(H){this.items=H,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(H){let X=this.firstIdx;for(;X<this.items.length&&H(this.items[X]);)X++;const Q=X===this.firstIdx?null:this.items.slice(this.firstIdx,X);return this.firstIdx=X,Q}takeFromEndWhile(H){let X=this.lastIdx;for(;X>=0&&H(this.items[X]);)X--;const Q=X===this.lastIdx?null:this.items.slice(X+1,this.lastIdx+1);return this.lastIdx=X,Q}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const H=this.items[this.firstIdx];return this.firstIdx++,H}removeLast(){const H=this.items[this.lastIdx];return this.lastIdx--,H}takeCount(H){const X=this.items.slice(this.firstIdx,this.firstIdx+H);return this.firstIdx+=H,X}}e.ArrayQueue=J;class _{static{this.empty=new _(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(X=>(H(X),!0))}toArray(){const H=[];return this.iterate(X=>(H.push(X),!0)),H}filter(H){return new _(X=>this.iterate(Q=>H(Q)?X(Q):!0))}map(H){return new _(X=>this.iterate(Q=>X(H(Q))))}some(H){let X=!1;return this.iterate(Q=>(X=H(Q),!X)),X}findFirst(H){let X;return this.iterate(Q=>H(Q)?(X=Q,!1):!0),X}findLast(H){let X;return this.iterate(Q=>(H(Q)&&(X=Q),!0)),X}findLastMaxBy(H){let X,Q=!0;return this.iterate($=>((Q||B.isGreaterThan(H($,X)))&&(Q=!1,X=$),!0)),X}}e.CallbackIterable=_;class W{constructor(H){this._indexMap=H}static createSortPermutation(H,X){const Q=Array.from(H.keys()).sort(($,ee)=>X(H[$],H[ee]));return new W(Q)}apply(H){return H.map((X,Q)=>H[this._indexMap[Q]])}inverse(){const H=this._indexMap.slice();for(let X=0;X<this._indexMap.length;X++)H[this._indexMap[X]]=X;return new W(H)}}e.Permutation=W}),define(le[141],ce([0,1,16]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=s,e.assertNever=P,e.assert=k,e.softAssert=A,e.assertFn=R,e.checkAdjacentItems=b;function s(l,d){if(!l)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}function P(l,d="Unreachable"){throw new Error(d)}function k(l,d="unexpected state"){if(!l)throw new i.BugIndicatingError(`Assertion Failed: ${d}`)}function A(l){l||(0,i.onUnexpectedError)(new i.BugIndicatingError("Soft Assertion Failed"))}function R(l){if(!l()){debugger;l(),(0,i.onUnexpectedError)(new i.BugIndicatingError("Assertion Failed"))}}function b(l,d){let f=0;for(;f<l.length-1;){const g=l[f],y=l[f+1];if(!d(g,y))return!1;f++}return!0}}),define(le[89],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=i;function i(s,P){const k=this;let A=!1,R;return function(){if(A)return R;if(A=!0,P)try{R=s.apply(k,arguments)}finally{P()}else R=s.apply(k,arguments);return R}}}),define(le[75],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(s){function P(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}s.is=P;const k=Object.freeze([]);function A(){return k}s.empty=A;function*R(t){yield t}s.single=R;function b(t){return P(t)?t:R(t)}s.wrap=b;function l(t){return t||k}s.from=l;function*d(t){for(let r=t.length-1;r>=0;r--)yield t[r]}s.reverse=d;function f(t){return!t||t[Symbol.iterator]().next().done===!0}s.isEmpty=f;function g(t){return t[Symbol.iterator]().next().value}s.first=g;function y(t,r){for(const a of t)if(r(a))return!0;return!1}s.some=y;function h(t,r){for(const a of t)if(r(a))return a}s.find=h;function*m(t,r){for(const a of t)r(a)&&(yield a)}s.filter=m;function*p(t,r){let a=0;for(const n of t)yield r(n,a++)}s.map=p;function*v(...t){for(const r of t)yield*r}s.concat=v;function w(t,r,a){let n=a;for(const c of t)n=r(n,c);return n}s.reduce=w;function*E(t,r,a=t.length){for(r<0&&(r+=t.length),a<0?a+=t.length:a>t.length&&(a=t.length);r<a;r++)yield t[r]}s.slice=E;function I(t,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,t];const n=t[Symbol.iterator]();for(let c=0;c<r;c++){const u=n.next();if(u.done)return[a,s.empty()];a.push(u.value)}return[a,{[Symbol.iterator](){return n}}]}s.consume=I;async function o(t){const r=[];for await(const a of t)r.push(a);return Promise.resolve(r)}s.asyncToArray=o})(i||(e.Iterable=i={}))}),define(le[40],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=A,e.getLocation=f,e.parse=g,e.parseTree=y,e.findNodeAtLocation=h,e.getNodePath=m,e.getNodeValue=p,e.contains=v,e.findNodeAtOffset=w,e.visit=E,e.stripComments=I,e.getNodeType=o;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var s;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(s||(e.SyntaxKind=s={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function A(t,r=!1){let a=0;const n=t.length;let c="",u=0,S=s.Unknown,D=i.None;function L(z){let re=0,ie=0;for(;re<z;){const oe=t.charCodeAt(a);if(oe>=d._0&&oe<=d._9)ie=ie*16+oe-d._0;else if(oe>=d.A&&oe<=d.F)ie=ie*16+oe-d.A+10;else if(oe>=d.a&&oe<=d.f)ie=ie*16+oe-d.a+10;else break;a++,re++}return re<z&&(ie=-1),ie}function M(z){a=z,c="",u=0,S=s.Unknown,D=i.None}function T(){const z=a;if(t.charCodeAt(a)===d._0)a++;else for(a++;a<t.length&&l(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===d.dot)if(a++,a<t.length&&l(t.charCodeAt(a)))for(a++;a<t.length&&l(t.charCodeAt(a));)a++;else return D=i.UnexpectedEndOfNumber,t.substring(z,a);let re=a;if(a<t.length&&(t.charCodeAt(a)===d.E||t.charCodeAt(a)===d.e))if(a++,(a<t.length&&t.charCodeAt(a)===d.plus||t.charCodeAt(a)===d.minus)&&a++,a<t.length&&l(t.charCodeAt(a))){for(a++;a<t.length&&l(t.charCodeAt(a));)a++;re=a}else D=i.UnexpectedEndOfNumber;return t.substring(z,re)}function C(){let z="",re=a;for(;;){if(a>=n){z+=t.substring(re,a),D=i.UnexpectedEndOfString;break}const ie=t.charCodeAt(a);if(ie===d.doubleQuote){z+=t.substring(re,a),a++;break}if(ie===d.backslash){if(z+=t.substring(re,a),a++,a>=n){D=i.UnexpectedEndOfString;break}switch(t.charCodeAt(a++)){case d.doubleQuote:z+='"';break;case d.backslash:z+="\\";break;case d.slash:z+="/";break;case d.b:z+="\b";break;case d.f:z+="\f";break;case d.n:z+=`
`;break;case d.r:z+="\r";break;case d.t:z+="	";break;case d.u:{const G=L(4);G>=0?z+=String.fromCharCode(G):D=i.InvalidUnicode;break}default:D=i.InvalidEscapeCharacter}re=a;continue}if(ie>=0&&ie<=31)if(b(ie)){z+=t.substring(re,a),D=i.UnexpectedEndOfString;break}else D=i.InvalidCharacter;a++}return z}function F(){if(c="",D=i.None,u=a,a>=n)return u=n,S=s.EOF;let z=t.charCodeAt(a);if(R(z)){do a++,c+=String.fromCharCode(z),z=t.charCodeAt(a);while(R(z));return S=s.Trivia}if(b(z))return a++,c+=String.fromCharCode(z),z===d.carriageReturn&&t.charCodeAt(a)===d.lineFeed&&(a++,c+=`
`),S=s.LineBreakTrivia;switch(z){case d.openBrace:return a++,S=s.OpenBraceToken;case d.closeBrace:return a++,S=s.CloseBraceToken;case d.openBracket:return a++,S=s.OpenBracketToken;case d.closeBracket:return a++,S=s.CloseBracketToken;case d.colon:return a++,S=s.ColonToken;case d.comma:return a++,S=s.CommaToken;case d.doubleQuote:return a++,c=C(),S=s.StringLiteral;case d.slash:{const re=a-1;if(t.charCodeAt(a+1)===d.slash){for(a+=2;a<n&&!b(t.charCodeAt(a));)a++;return c=t.substring(re,a),S=s.LineCommentTrivia}if(t.charCodeAt(a+1)===d.asterisk){a+=2;const ie=n-1;let oe=!1;for(;a<ie;){if(t.charCodeAt(a)===d.asterisk&&t.charCodeAt(a+1)===d.slash){a+=2,oe=!0;break}a++}return oe||(a++,D=i.UnexpectedEndOfComment),c=t.substring(re,a),S=s.BlockCommentTrivia}return c+=String.fromCharCode(z),a++,S=s.Unknown}case d.minus:if(c+=String.fromCharCode(z),a++,a===n||!l(t.charCodeAt(a)))return S=s.Unknown;case d._0:case d._1:case d._2:case d._3:case d._4:case d._5:case d._6:case d._7:case d._8:case d._9:return c+=T(),S=s.NumericLiteral;default:for(;a<n&&x(z);)a++,z=t.charCodeAt(a);if(u!==a){switch(c=t.substring(u,a),c){case"true":return S=s.TrueKeyword;case"false":return S=s.FalseKeyword;case"null":return S=s.NullKeyword}return S=s.Unknown}return c+=String.fromCharCode(z),a++,S=s.Unknown}}function x(z){if(R(z)||b(z))return!1;switch(z){case d.closeBrace:case d.closeBracket:case d.openBrace:case d.openBracket:case d.doubleQuote:case d.colon:case d.comma:case d.slash:return!1}return!0}function U(){let z;do z=F();while(z>=s.LineCommentTrivia&&z<=s.Trivia);return z}return{setPosition:M,getPosition:()=>a,scan:r?U:F,getToken:()=>S,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>a-u,getTokenError:()=>D}}function R(t){return t===d.space||t===d.tab||t===d.verticalTab||t===d.formFeed||t===d.nonBreakingSpace||t===d.ogham||t>=d.enQuad&&t<=d.zeroWidthSpace||t===d.narrowNoBreakSpace||t===d.mathematicalSpace||t===d.ideographicSpace||t===d.byteOrderMark}function b(t){return t===d.lineFeed||t===d.carriageReturn||t===d.lineSeparator||t===d.paragraphSeparator}function l(t){return t>=d._0&&t<=d._9}var d;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(d||(d={}));function f(t,r){const a=[],n=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(L,M,T,C){u.value=L,u.offset=M,u.length=T,u.type=C,u.colonOffset=void 0,c=u}try{E(t,{onObjectBegin:(L,M)=>{if(r<=L)throw n;c=void 0,S=r>L,a.push("")},onObjectProperty:(L,M,T)=>{if(r<M||(D(L,M,T,"property"),a[a.length-1]=L,r<=M+T))throw n},onObjectEnd:(L,M)=>{if(r<=L)throw n;c=void 0,a.pop()},onArrayBegin:(L,M)=>{if(r<=L)throw n;c=void 0,a.push(0)},onArrayEnd:(L,M)=>{if(r<=L)throw n;c=void 0,a.pop()},onLiteralValue:(L,M,T)=>{if(r<M||(D(L,M,T,o(L)),r<=M+T))throw n},onSeparator:(L,M,T)=>{if(r<=M)throw n;if(L===":"&&c&&c.type==="property")c.colonOffset=M,S=!1,c=void 0;else if(L===","){const C=a[a.length-1];typeof C=="number"?a[a.length-1]=C+1:(S=!0,a[a.length-1]=""),c=void 0}}})}catch(L){if(L!==n)throw L}return{path:a,previousNode:c,isAtPropertyKey:S,matches:L=>{let M=0;for(let T=0;M<L.length&&T<a.length;T++)if(L[M]===a[T]||L[M]==="*")M++;else if(L[M]!=="**")return!1;return M===L.length}}}function g(t,r=[],a=k.DEFAULT){let n=null,c=[];const u=[];function S(L){Array.isArray(c)?c.push(L):n!==null&&(c[n]=L)}return E(t,{onObjectBegin:()=>{const L={};S(L),u.push(c),c=L,n=null},onObjectProperty:L=>{n=L},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const L=[];S(L),u.push(c),c=L,n=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:S,onError:(L,M,T)=>{r.push({error:L,offset:M,length:T})}},a),c[0]}function y(t,r=[],a=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(L){n.type==="property"&&(n.length=L-n.offset,n=n.parent)}function u(L){return n.children.push(L),L}E(t,{onObjectBegin:L=>{n=u({type:"object",offset:L,length:-1,parent:n,children:[]})},onObjectProperty:(L,M,T)=>{n=u({type:"property",offset:M,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:L,offset:M,length:T,parent:n})},onObjectEnd:(L,M)=>{n.length=L+M-n.offset,n=n.parent,c(L+M)},onArrayBegin:(L,M)=>{n=u({type:"array",offset:L,length:-1,parent:n,children:[]})},onArrayEnd:(L,M)=>{n.length=L+M-n.offset,n=n.parent,c(L+M)},onLiteralValue:(L,M,T)=>{u({type:o(L),offset:M,length:T,parent:n,value:L}),c(M+T)},onSeparator:(L,M,T)=>{n.type==="property"&&(L===":"?n.colonOffset=M:L===","&&c(M))},onError:(L,M,T)=>{r.push({error:L,offset:M,length:T})}},a);const D=n.children[0];return D&&delete D.parent,D}function h(t,r){if(!t)return;let a=t;for(const n of r)if(typeof n=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const u of a.children)if(Array.isArray(u.children)&&u.children[0].value===n){a=u.children[1],c=!0;break}if(!c)return}else{const c=n;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;r.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&r.push(a)}return r}function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const r=Object.create(null);for(const a of t.children){const n=a.children[1];n&&(r[a.children[0].value]=p(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function v(t,r,a=!1){return r>=t.offset&&r<t.offset+t.length||a&&r===t.offset+t.length}function w(t,r,a=!1){if(v(t,r,a)){const n=t.children;if(Array.isArray(n))for(let c=0;c<n.length&&n[c].offset<=r;c++){const u=w(n[c],r,a);if(u)return u}return t}}function E(t,r,a=k.DEFAULT){const n=A(t,!1);function c(ae){return ae?()=>ae(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(ae){return ae?j=>ae(j,n.getTokenOffset(),n.getTokenLength()):()=>!0}const S=c(r.onObjectBegin),D=u(r.onObjectProperty),L=c(r.onObjectEnd),M=c(r.onArrayBegin),T=c(r.onArrayEnd),C=u(r.onLiteralValue),F=u(r.onSeparator),x=c(r.onComment),U=u(r.onError),z=a&&a.disallowComments,re=a&&a.allowTrailingComma;function ie(){for(;;){const ae=n.scan();switch(n.getTokenError()){case i.InvalidUnicode:oe(P.InvalidUnicode);break;case i.InvalidEscapeCharacter:oe(P.InvalidEscapeCharacter);break;case i.UnexpectedEndOfNumber:oe(P.UnexpectedEndOfNumber);break;case i.UnexpectedEndOfComment:z||oe(P.UnexpectedEndOfComment);break;case i.UnexpectedEndOfString:oe(P.UnexpectedEndOfString);break;case i.InvalidCharacter:oe(P.InvalidCharacter);break}switch(ae){case s.LineCommentTrivia:case s.BlockCommentTrivia:z?oe(P.InvalidCommentToken):x();break;case s.Unknown:oe(P.InvalidSymbol);break;case s.Trivia:case s.LineBreakTrivia:break;default:return ae}}}function oe(ae,j=[],he=[]){if(U(ae),j.length+he.length>0){let ne=n.getToken();for(;ne!==s.EOF;){if(j.indexOf(ne)!==-1){ie();break}else if(he.indexOf(ne)!==-1)break;ne=ie()}}}function G(ae){const j=n.getTokenValue();return ae?C(j):D(j),ie(),!0}function te(){switch(n.getToken()){case s.NumericLiteral:{let ae=0;try{ae=JSON.parse(n.getTokenValue()),typeof ae!="number"&&(oe(P.InvalidNumberFormat),ae=0)}catch{oe(P.InvalidNumberFormat)}C(ae);break}case s.NullKeyword:C(null);break;case s.TrueKeyword:C(!0);break;case s.FalseKeyword:C(!1);break;default:return!1}return ie(),!0}function q(){return n.getToken()!==s.StringLiteral?(oe(P.PropertyNameExpected,[],[s.CloseBraceToken,s.CommaToken]),!1):(G(!1),n.getToken()===s.ColonToken?(F(":"),ie(),V()||oe(P.ValueExpected,[],[s.CloseBraceToken,s.CommaToken])):oe(P.ColonExpected,[],[s.CloseBraceToken,s.CommaToken]),!0)}function O(){S(),ie();let ae=!1;for(;n.getToken()!==s.CloseBraceToken&&n.getToken()!==s.EOF;){if(n.getToken()===s.CommaToken){if(ae||oe(P.ValueExpected,[],[]),F(","),ie(),n.getToken()===s.CloseBraceToken&&re)break}else ae&&oe(P.CommaExpected,[],[]);q()||oe(P.ValueExpected,[],[s.CloseBraceToken,s.CommaToken]),ae=!0}return L(),n.getToken()!==s.CloseBraceToken?oe(P.CloseBraceExpected,[s.CloseBraceToken],[]):ie(),!0}function B(){M(),ie();let ae=!1;for(;n.getToken()!==s.CloseBracketToken&&n.getToken()!==s.EOF;){if(n.getToken()===s.CommaToken){if(ae||oe(P.ValueExpected,[],[]),F(","),ie(),n.getToken()===s.CloseBracketToken&&re)break}else ae&&oe(P.CommaExpected,[],[]);V()||oe(P.ValueExpected,[],[s.CloseBracketToken,s.CommaToken]),ae=!0}return T(),n.getToken()!==s.CloseBracketToken?oe(P.CloseBracketExpected,[s.CloseBracketToken],[]):ie(),!0}function V(){switch(n.getToken()){case s.OpenBracketToken:return B();case s.OpenBraceToken:return O();case s.StringLiteral:return G(!0);default:return te()}}return ie(),n.getToken()===s.EOF?a.allowEmptyContent?!0:(oe(P.ValueExpected,[],[]),!1):V()?(n.getToken()!==s.EOF&&oe(P.EndOfFileExpected,[],[]),!0):(oe(P.ValueExpected,[],[]),!1)}function I(t,r){const a=A(t),n=[];let c,u=0,S;do switch(S=a.getPosition(),c=a.scan(),c){case s.LineCommentTrivia:case s.BlockCommentTrivia:case s.EOF:u!==S&&n.push(t.substring(u,S)),r!==void 0&&n.push(a.getTokenValue().replace(/[^\r\n]/g,r)),u=a.getPosition();break}while(c!==s.EOF);return n.join("")}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[142],ce([0,1,40]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=s,e.toFormattedString=P,e.getEOL=R,e.isEOL=b;function s(l,d,f){let g,y,h,m,p;if(d){for(m=d.offset,p=m+d.length,h=m;h>0&&!b(l,h-1);)h--;let S=p;for(;S<l.length&&!b(l,S);)S++;y=l.substring(h,S),g=A(y,f)}else y=l,g=0,h=0,m=0,p=l.length;const v=R(f,l);let w=!1,E=0,I;f.insertSpaces?I=k(" ",f.tabSize||4):I="	";const o=(0,i.createScanner)(y,!1);let t=!1;function r(){return v+k(I,g+E)}function a(){let S=o.scan();for(w=!1;S===i.SyntaxKind.Trivia||S===i.SyntaxKind.LineBreakTrivia;)w=w||S===i.SyntaxKind.LineBreakTrivia,S=o.scan();return t=S===i.SyntaxKind.Unknown||o.getTokenError()!==i.ScanError.None,S}const n=[];function c(S,D,L){!t&&D<p&&L>m&&l.substring(D,L)!==S&&n.push({offset:D,length:L-D,content:S})}let u=a();if(u!==i.SyntaxKind.EOF){const S=o.getTokenOffset()+h,D=k(I,g);c(D,h,S)}for(;u!==i.SyntaxKind.EOF;){let S=o.getTokenOffset()+o.getTokenLength()+h,D=a(),L="";for(;!w&&(D===i.SyntaxKind.LineCommentTrivia||D===i.SyntaxKind.BlockCommentTrivia);){const T=o.getTokenOffset()+h;c(" ",S,T),S=o.getTokenOffset()+o.getTokenLength()+h,L=D===i.SyntaxKind.LineCommentTrivia?r():"",D=a()}if(D===i.SyntaxKind.CloseBraceToken)u!==i.SyntaxKind.OpenBraceToken&&(E--,L=r());else if(D===i.SyntaxKind.CloseBracketToken)u!==i.SyntaxKind.OpenBracketToken&&(E--,L=r());else{switch(u){case i.SyntaxKind.OpenBracketToken:case i.SyntaxKind.OpenBraceToken:E++,L=r();break;case i.SyntaxKind.CommaToken:case i.SyntaxKind.LineCommentTrivia:L=r();break;case i.SyntaxKind.BlockCommentTrivia:w?L=r():L=" ";break;case i.SyntaxKind.ColonToken:L=" ";break;case i.SyntaxKind.StringLiteral:if(D===i.SyntaxKind.ColonToken){L="";break}case i.SyntaxKind.NullKeyword:case i.SyntaxKind.TrueKeyword:case i.SyntaxKind.FalseKeyword:case i.SyntaxKind.NumericLiteral:case i.SyntaxKind.CloseBraceToken:case i.SyntaxKind.CloseBracketToken:D===i.SyntaxKind.LineCommentTrivia||D===i.SyntaxKind.BlockCommentTrivia?L=" ":D!==i.SyntaxKind.CommaToken&&D!==i.SyntaxKind.EOF&&(t=!0);break;case i.SyntaxKind.Unknown:t=!0;break}w&&(D===i.SyntaxKind.LineCommentTrivia||D===i.SyntaxKind.BlockCommentTrivia)&&(L=r())}const M=o.getTokenOffset()+h;c(L,S,M),u=D}return n}function P(l,d){const f=JSON.stringify(l,void 0,d.insertSpaces?d.tabSize||4:"	");return d.eol!==void 0?f.replace(/\r\n|\r|\n/g,d.eol):f}function k(l,d){let f="";for(let g=0;g<d;g++)f+=l;return f}function A(l,d){let f=0,g=0;const y=d.tabSize||4;for(;f<l.length;){const h=l.charAt(f);if(h===" ")g++;else if(h==="	")g+=y;else break;f++}return Math.floor(g/y)}function R(l,d){for(let f=0;f<d.length;f++){const g=d.charAt(f);if(g==="\r")return f+1<d.length&&d.charAt(f+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return l&&l.eol||`
`}function b(l,d){return`\r
`.indexOf(l.charAt(d))!==-1}}),define(le[108],ce([0,1,40,142]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=P,e.setProperty=k,e.withFormatting=A,e.applyEdit=R,e.applyEdits=b;function P(l,d,f){return k(l,d,void 0,f)}function k(l,d,f,g,y){const h=d.slice(),m=[],p=(0,i.parseTree)(l,m);let v,w;for(;h.length>0&&(w=h.pop(),v=(0,i.findNodeAtLocation)(p,h),v===void 0&&f!==void 0);)typeof w=="string"?f={[w]:f}:f=[f];if(v)if(v.type==="object"&&typeof w=="string"&&Array.isArray(v.children)){const E=(0,i.findNodeAtLocation)(v,[w]);if(E!==void 0)if(f===void 0){if(!E.parent)throw new Error("Malformed AST");const I=v.children.indexOf(E.parent);let o,t=E.parent.offset+E.parent.length;if(I>0){const r=v.children[I-1];o=r.offset+r.length}else o=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return A(l,{offset:o,length:t-o,content:""},g)}else return A(l,{offset:E.offset,length:E.length,content:JSON.stringify(f)},g);else{if(f===void 0)return[];const I=`${JSON.stringify(w)}: ${JSON.stringify(f)}`,o=y?y(v.children.map(r=>r.children[0].value)):v.children.length;let t;if(o>0){const r=v.children[o-1];t={offset:r.offset+r.length,length:0,content:","+I}}else v.children.length===0?t={offset:v.offset+1,length:0,content:I}:t={offset:v.offset+1,length:0,content:I+","};return A(l,t,g)}}else if(v.type==="array"&&typeof w=="number"&&Array.isArray(v.children))if(f!==void 0){const E=`${JSON.stringify(f)}`;let I;if(v.children.length===0||w===0)I={offset:v.offset+1,length:0,content:v.children.length===0?E:E+","};else{const o=w===-1||w>v.children.length?v.children.length:w,t=v.children[o-1];I={offset:t.offset+t.length,length:0,content:","+E}}return A(l,I,g)}else{const E=w,I=v.children[E];let o;if(v.children.length===1)o={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===E){const t=v.children[E-1],r=t.offset+t.length,a=v.offset+v.length;o={offset:r,length:a-2-r,content:""}}else o={offset:I.offset,length:v.children[E+1].offset-I.offset,content:""};return A(l,o,g)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${v.type}`);else return f===void 0?[]:A(l,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(f)},g)}function A(l,d,f){let g=R(l,d),y=d.offset,h=d.offset+d.content.length;if(d.length===0||d.content.length===0){for(;y>0&&!(0,s.isEOL)(g,y-1);)y--;for(;h<g.length&&!(0,s.isEOL)(g,h);)h++}const m=(0,s.format)(g,{offset:y,length:h-y},f);for(let v=m.length-1;v>=0;v--){const w=m[v];g=R(g,w),y=Math.min(y,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const p=l.length-(g.length-h)-y;return[{offset:y,length:p,content:g.substring(y,h)}]}function R(l,d){return l.substring(0,d.offset)+d.content+l.substring(d.offset+d.length)}function b(l,d){const f=d.slice(0).sort((y,h)=>{const m=y.offset-h.offset;return m===0?y.length-h.length:m});let g=l.length;for(let y=f.length-1;y>=0;y--){const h=f[y];if(h.offset+h.length<=g)l=R(l,h);else throw new Error("Overlapping edit");g=h.offset}return l}}),define(le[65],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class i{constructor(P){this.executor=P,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=i}),define(le[109],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class i{static{this.Undefined=new i(void 0)}constructor(k){this.element=k,this.next=i.Undefined,this.prev=i.Undefined}}class s{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){let k=this._first;for(;k!==i.Undefined;){const A=k.next;k.prev=i.Undefined,k.next=i.Undefined,k=A}this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const R=new i(k);if(this._first===i.Undefined)this._first=R,this._last=R;else if(A){const l=this._last;this._last=R,R.prev=l,l.next=R}else{const l=this._first;this._first=R,R.next=l,l.prev=R}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(R))}}shift(){if(this._first!==i.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==i.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==i.Undefined&&k.next!==i.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===i.Undefined&&k.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):k.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):k.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==i.Undefined;)yield k.element,k=k.next}}e.LinkedList=s}),define(le[32],ce([0,1]),function(K,e){"use strict";var i,s,P;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=k,e.mapToString=A,e.setToString=R,e.mapsStrictEqualIgnoreOrder=I;function k(o,t,r){let a=o.get(t);return a===void 0&&(a=r,o.set(t,a)),a}function A(o){const t=[];return o.forEach((r,a)=>{t.push(`${a} => ${r}`)}),`Map(${o.size}) {${t.join(", ")}}`}function R(o){const t=[];return o.forEach(r=>{t.push(r)}),`Set(${o.size}) {${t.join(", ")}}`}class b{constructor(t,r){this.uri=t,this.value=r}}function l(o){return Array.isArray(o)}class d{static{this.defaultToKey=t=>t.toString()}constructor(t,r){if(this[i]="ResourceMap",t instanceof d)this.map=new Map(t.map),this.toKey=r??d.defaultToKey;else if(l(t)){this.map=new Map,this.toKey=r??d.defaultToKey;for(const[a,n]of t)this.set(a,n)}else this.map=new Map,this.toKey=t??d.defaultToKey}set(t,r){return this.map.set(this.toKey(t),new b(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[a,n]of this.map)t(n.value,n.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=d;class f{constructor(t,r){this[s]="ResourceSet",!t||typeof t=="function"?this._map=new d(t):(this._map=new d(r),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,r){this._map.forEach((a,n)=>t.call(r,n,n,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var g;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class y{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=g.None){const a=this._map.get(t);if(a)return r!==g.None&&this.touch(a,r),a.value}set(t,r,a=g.None){let n=this._map.get(t);if(n)n.value=r,a!==g.None&&this.touch(n,a);else{switch(n={key:t,value:r,next:void 0,previous:void 0},a){case g.None:this.addItemLast(n);break;case g.AsOld:this.addItemFirst(n);break;case g.AsNew:this.addItemLast(n);break;default:this.addItemLast(n);break}this._map.set(t,n),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const a=this._state;let n=this._head;for(;n;){if(r?t.bind(r)(n.value,n.key,this):t(n.value,n.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const t=this,r=this._state;let a=this._head;const n={[Symbol.iterator](){return n},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:a.key,done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return n}values(){const t=this,r=this._state;let a=this._head;const n={[Symbol.iterator](){return n},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:a.value,done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return n}entries(){const t=this,r=this._state;let a=this._head;const n={[Symbol.iterator](){return n},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:[a.key,a.value],done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return n}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>t;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}trimNew(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._tail,a=this.size;for(;r&&a>t;)this._map.delete(r.key),r=r.previous,a--;this._tail=r,this._size=a,r&&(r.next=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,a=t.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==g.AsOld&&r!==g.AsNew)){if(r===g.AsOld){if(t===this._head)return;const a=t.next,n=t.previous;t===this._tail?(n.next=void 0,this._tail=n):(a.previous=n,n.next=a),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===g.AsNew){if(t===this._tail)return;const a=t.next,n=t.previous;t===this._head?(a.previous=void 0,this._head=a):(a.previous=n,n.next=a),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,a)=>{t.push([a,r])}),t}fromJSON(t){this.clear();for(const[r,a]of t)this.set(r,a)}}e.LinkedMap=y;class h extends y{constructor(t,r=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=g.AsNew){return super.get(t,r)}peek(t){return super.get(t,g.None)}set(t,r){return super.set(t,r,g.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class m extends h{constructor(t,r=1){super(t,r)}trim(t){this.trimOld(t)}set(t,r){return super.set(t,r),this.checkTrim(),this}}e.LRUCache=m;class p extends h{constructor(t,r=1){super(t,r)}trim(t){this.trimNew(t)}set(t,r){return this._limit<=this.size&&!this.has(t)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(t,r),this}}e.MRUCache=p;class v{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let r=this.map.get(t)||0;return r===0?!1:(r--,r===0?this.map.delete(t):this.map.set(t,r),!0)}has(t){return this.map.has(t)}}e.CounterSet=v;class w{constructor(t){if(this._m1=new Map,this._m2=new Map,t)for(const[r,a]of t)this.set(r,a)}clear(){this._m1.clear(),this._m2.clear()}set(t,r){this._m1.set(t,r),this._m2.set(r,t)}get(t){return this._m1.get(t)}getKey(t){return this._m2.get(t)}delete(t){const r=this._m1.get(t);return r===void 0?!1:(this._m1.delete(t),this._m2.delete(r),!0)}forEach(t,r){this._m1.forEach((a,n)=>{t.call(r,a,n,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=w;class E{constructor(){this.map=new Map}add(t,r){let a=this.map.get(t);a||(a=new Set,this.map.set(t,a)),a.add(r)}delete(t,r){const a=this.map.get(t);a&&(a.delete(r),a.size===0&&this.map.delete(t))}forEach(t,r){const a=this.map.get(t);a&&a.forEach(r)}get(t){const r=this.map.get(t);return r||new Set}}e.SetMap=E;function I(o,t){if(o===t)return!0;if(o.size!==t.size)return!1;for(const[r,a]of o)if(!t.has(r)||t.get(r)!==a)return!1;for(const[r]of t)if(!o.has(r))return!1;return!0}}),define(le[2],ce([0,1,22,139,32,89,75]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=d,e.trackDisposable=f,e.markAsDisposed=g,e.markAsSingleton=m,e.isDisposable=p,e.dispose=v,e.disposeIfDisposable=w,e.combinedDisposable=E,e.toDisposable=I,e.disposeOnReturn=L;const R=!1;let b=null;class l{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(C){let F=this.livingDisposables.get(C);return F||(F={parent:null,source:null,isSingleton:!1,value:C,idx:l.idx++},this.livingDisposables.set(C,F)),F}trackDisposable(C){const F=this.getDisposableData(C);F.source||(F.source=new Error().stack)}setParent(C,F){const x=this.getDisposableData(C);x.parent=F}markAsDisposed(C){this.livingDisposables.delete(C)}markAsSingleton(C){this.getDisposableData(C).isSingleton=!0}getRootParent(C,F){const x=F.get(C);if(x)return x;const U=C.parent?this.getRootParent(this.getDisposableData(C.parent),F):C;return F.set(C,U),U}getTrackedDisposables(){const C=new Map;return[...this.livingDisposables.entries()].filter(([,x])=>x.source!==null&&!this.getRootParent(x,C).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(C=10,F){let x;if(F)x=F;else{const oe=new Map,G=[...this.livingDisposables.values()].filter(q=>q.source!==null&&!this.getRootParent(q,oe).isSingleton);if(G.length===0)return;const te=new Set(G.map(q=>q.value));if(x=G.filter(q=>!(q.parent&&te.has(q.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function U(oe){function G(q,O){for(;q.length>0&&O.some(B=>typeof B=="string"?B===q[0]:q[0].match(B));)q.shift()}const te=oe.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return G(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const z=new P.SetMap;for(const oe of x){const G=U(oe);for(let te=0;te<=G.length;te++)z.add(G.slice(0,te).join(`
`),oe)}x.sort((0,i.compareBy)(oe=>oe.idx,i.numberComparator));let re="",ie=0;for(const oe of x.slice(0,C)){ie++;const G=U(oe),te=[];for(let q=0;q<G.length;q++){let O=G[q];O=`(shared with ${z.get(G.slice(0,q+1).join(`
`)).size}/${x.length} leaks) at ${O}`;const V=z.get(G.slice(0,q).join(`
`)),ae=(0,s.groupBy)([...V].map(j=>U(j)[q]),j=>j);delete ae[G[q]];for(const[j,he]of Object.entries(ae))te.unshift(`    - stacktraces of ${he.length} other leaks continue with ${j}`);te.unshift(O)}re+=`


==================== Leaking disposable ${ie}/${x.length}: ${oe.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return x.length>C&&(re+=`


... and ${x.length-C} more leaking disposables

`),{leaks:x,details:re}}}e.DisposableTracker=l;function d(T){b=T}if(R){const T="__is_disposable_tracked__";d(new class{trackDisposable(C){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[T]||console.log(F)},3e3)}setParent(C,F){if(C&&C!==t.None)try{C[T]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[T]=!0}catch{}}markAsSingleton(C){}})}function f(T){return b?.trackDisposable(T),T}function g(T){b?.markAsDisposed(T)}function y(T,C){b?.setParent(T,C)}function h(T,C){if(b)for(const F of T)b.setParent(F,C)}function m(T){return b?.markAsSingleton(T),T}function p(T){return typeof T=="object"&&T!==null&&typeof T.dispose=="function"&&T.dispose.length===0}function v(T){if(A.Iterable.is(T)){const C=[];for(const F of T)if(F)try{F.dispose()}catch(x){C.push(x)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(T)?[]:T}else if(T)return T.dispose(),T}function w(T){for(const C of T)p(C)&&C.dispose();return[]}function E(...T){const C=I(()=>v(T));return h(T,C),C}function I(T){const C=f({dispose:(0,k.createSingleCallFunction)(()=>{g(C),T()})});return C}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,f(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{v(this._toDispose)}finally{this._toDispose.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return y(C,this),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(C),C.dispose()}}deleteAndLeak(C){C&&this._toDispose.has(C)&&(this._toDispose.delete(C),y(C,null))}}e.DisposableStore=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new o,f(this),y(this._store,this)}dispose(){g(this),this._store.dispose()}_register(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(C)}}e.Disposable=t;class r{constructor(){this._isDisposed=!1,f(this)}get value(){return this._isDisposed?void 0:this._value}set value(C){this._isDisposed||C===this._value||(this._value?.dispose(),C&&y(C,this),this._value=C)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const C=this._value;return this._value=void 0,C&&y(C,null),C}}e.MutableDisposable=r;class a{constructor(C){this._disposable=new r,this._isDisposed=!1,this._disposable.value=C}get value(){return this._disposable.value}set value(C){this._isDisposed||C===this._disposable.value||(this._disposable.value=C)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=a;class n{constructor(C){this._disposable=C,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=n;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,f(this)}set(C){let F=C;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,g(this))},this}}e.SafeDisposable=c;class u{constructor(){this.references=new Map}acquire(C,...F){let x=this.references.get(C);x||(x={counter:0,object:this.createReferencedObject(C,...F)},this.references.set(C,x));const{object:U}=x,z=(0,k.createSingleCallFunction)(()=>{--x.counter===0&&(this.destroyReferencedObject(C,x.object),this.references.delete(C))});return x.counter++,{object:U,dispose:z}}}e.ReferenceCollection=u;class S{constructor(C){this.referenceCollection=C}async acquire(C,...F){const x=this.referenceCollection.acquire(C,...F);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(U){throw x.dispose(),U}}}e.AsyncReferenceCollection=S;class D{constructor(C){this.object=C}dispose(){}}e.ImmortalReference=D;function L(T){const C=new o;try{T(C)}finally{C.dispose()}}class M{constructor(){this._store=new Map,this._isDisposed=!1,f(this)}dispose(){g(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{v(this._store.values())}finally{this._store.clear()}}has(C){return this._store.has(C)}get size(){return this._store.size}get(C){return this._store.get(C)}set(C,F,x=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this._store.get(C)?.dispose(),this._store.set(C,F)}deleteAndDispose(C){this._store.get(C)?.dispose(),this._store.delete(C)}deleteAndLeak(C){const F=this._store.get(C);return this._store.delete(C),F}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=M}),define(le[90],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var i;(function(s){s[s.Uri=1]="Uri",s[s.Regexp=2]="Regexp",s[s.ScmResource=3]="ScmResource",s[s.ScmResourceGroup=4]="ScmResourceGroup",s[s.ScmProvider=5]="ScmProvider",s[s.CommentController=6]="CommentController",s[s.CommentThread=7]="CommentThread",s[s.CommentThreadInstance=8]="CommentThreadInstance",s[s.CommentThreadReply=9]="CommentThreadReply",s[s.CommentNode=10]="CommentNode",s[s.CommentThreadNode=11]="CommentThreadNode",s[s.TimelineActionContext=12]="TimelineActionContext",s[s.NotebookCellActionContext=13]="NotebookCellActionContext",s[s.NotebookActionContext=14]="NotebookActionContext",s[s.TerminalContext=15]="TerminalContext",s[s.TestItemContext=16]="TestItemContext",s[s.Date=17]="Date",s[s.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(e.MarshalledId=i={}))}),define(le[76],ce([0,1,32]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=P,e.normalizeNFD=A;const s=new i.LRUCache(1e4);function P(l){return b(l,"NFC",s)}const k=new i.LRUCache(1e4);function A(l){return b(l,"NFD",k)}const R=/[^\u0000-\u0080]/;function b(l,d,f){if(!l)return l;const g=f.get(l);if(g)return g;let y;return R.test(l)?y=l.normalize(d):y=l,f.set(l,y),y}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(d){return A(d).replace(l,"")}}()}),define(le[143],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=i,e.rot=s;function i(R,b,l){return Math.min(Math.max(R,b),l)}function s(R,b){return(b+R%b)%b}class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class k{constructor(){this._n=1,this._val=0}update(b){return this._val=this._val+(b-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=k;class A{constructor(b){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(b),this._values.fill(0,0,b)}update(b){const l=this._values[this._index];return this._values[this._index]=b,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=b,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function K(P){const k=[];typeof P=="number"&&k.push("code/timeOrigin",P);function A(b){k.push(b,Date.now())}function R(){const b=[];for(let l=0;l<k.length;l+=2)b.push({name:k[l],startTime:k[l+1]});return b}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(P+A.startTime)});return k}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function i(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var s;typeof global=="object"?s=global:typeof self=="object"?s=self:s={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(s)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(s):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),s.perf=i(s))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var s in i)(typeof exports=="object"?exports:K)[s]=i[s]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function i(s){if(e[s])return e[s].exports;var P=e[s]={i:s,l:!1,exports:{}};return K[s].call(P.exports,P,P.exports,i),P.l=!0,P.exports}return i.m=K,i.c=e,i.d=function(s,P,k){i.o(s,P)||Object.defineProperty(s,P,{enumerable:!0,get:k})},i.r=function(s){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(s,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(s,"__esModule",{value:!0})},i.t=function(s,P){if(1&P&&(s=i(s)),8&P||4&P&&typeof s=="object"&&s&&s.__esModule)return s;var k=Object.create(null);if(i.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:s}),2&P&&typeof s!="string")for(var A in s)i.d(k,A,function(R){return s[R]}.bind(null,A));return k},i.n=function(s){var P=s&&s.__esModule?function(){return s.default}:function(){return s};return i.d(P,"a",P),P},i.o=function(s,P){return Object.prototype.hasOwnProperty.call(s,P)},i.p="",i(i.s=0)}([function(K,e,i){(function(s){var P;e=K.exports=he,P=typeof s=="object"&&s.env&&s.env.NODE_DEBUG&&/\bsemver\b/i.test(s.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],l=0,d=l++;b[d]="0|[1-9]\\d*";var f=l++;b[f]="[0-9]+";var g=l++;b[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=l++;b[y]="("+b[d]+")\\.("+b[d]+")\\.("+b[d]+")";var h=l++;b[h]="("+b[f]+")\\.("+b[f]+")\\.("+b[f]+")";var m=l++;b[m]="(?:"+b[d]+"|"+b[g]+")";var p=l++;b[p]="(?:"+b[f]+"|"+b[g]+")";var v=l++;b[v]="(?:-("+b[m]+"(?:\\."+b[m]+")*))";var w=l++;b[w]="(?:-?("+b[p]+"(?:\\."+b[p]+")*))";var E=l++;b[E]="[0-9A-Za-z-]+";var I=l++;b[I]="(?:\\+("+b[E]+"(?:\\."+b[E]+")*))";var o=l++,t="v?"+b[y]+b[v]+"?"+b[I]+"?";b[o]="^"+t+"$";var r="[v=\\s]*"+b[h]+b[w]+"?"+b[I]+"?",a=l++;b[a]="^"+r+"$";var n=l++;b[n]="((?:<|>)?=?)";var c=l++;b[c]=b[f]+"|x|X|\\*";var u=l++;b[u]=b[d]+"|x|X|\\*";var S=l++;b[S]="[v=\\s]*("+b[u]+")(?:\\.("+b[u]+")(?:\\.("+b[u]+")(?:"+b[v]+")?"+b[I]+"?)?)?";var D=l++;b[D]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[w]+")?"+b[I]+"?)?)?";var L=l++;b[L]="^"+b[n]+"\\s*"+b[S]+"$";var M=l++;b[M]="^"+b[n]+"\\s*"+b[D]+"$";var T=l++;b[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=l++;b[C]="(?:~>?)";var F=l++;b[F]="(\\s*)"+b[C]+"\\s+",R[F]=new RegExp(b[F],"g");var x=l++;b[x]="^"+b[C]+b[S]+"$";var U=l++;b[U]="^"+b[C]+b[D]+"$";var z=l++;b[z]="(?:\\^)";var re=l++;b[re]="(\\s*)"+b[z]+"\\s+",R[re]=new RegExp(b[re],"g");var ie=l++;b[ie]="^"+b[z]+b[S]+"$";var oe=l++;b[oe]="^"+b[z]+b[D]+"$";var G=l++;b[G]="^"+b[n]+"\\s*("+r+")$|^$";var te=l++;b[te]="^"+b[n]+"\\s*("+t+")$|^$";var q=l++;b[q]="(\\s*)"+b[n]+"\\s*("+r+"|"+b[S]+")",R[q]=new RegExp(b[q],"g");var O=l++;b[O]="^\\s*("+b[S]+")\\s+-\\s+("+b[S]+")\\s*$";var B=l++;b[B]="^\\s*("+b[D]+")\\s+-\\s+("+b[D]+")\\s*$";var V=l++;b[V]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)P(ae,b[ae]),R[ae]||(R[ae]=new RegExp(b[ae]));function j(Y,ue){if(Y instanceof he)return Y;if(typeof Y!="string"||Y.length>k||!(ue?R[a]:R[o]).test(Y))return null;try{return new he(Y,ue)}catch{return null}}function he(Y,ue){if(Y instanceof he){if(Y.loose===ue)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof he))return new he(Y,ue);P("SemVer",Y,ue),this.loose=ue;var de=Y.trim().match(ue?R[a]:R[o]);if(!de)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Me=+Se;if(Me>=0&&Me<A)return Me}return Se}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=j,e.valid=function(Y,ue){var de=j(Y,ue);return de?de.version:null},e.clean=function(Y,ue){var de=j(Y.trim().replace(/^[=v]+/,""),ue);return de?de.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(Y){return P("SemVer.compare",this.version,this.loose,Y),Y instanceof he||(Y=new he(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},he.prototype.compareMain=function(Y){return Y instanceof he||(Y=new he(Y,this.loose)),J(this.major,Y.major)||J(this.minor,Y.minor)||J(this.patch,Y.patch)},he.prototype.comparePre=function(Y){if(Y instanceof he||(Y=new he(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ue=0;do{var de=this.prerelease[ue],Se=Y.prerelease[ue];if(P("prerelease compare",ue,de,Se),de===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(de===void 0)return-1;if(de!==Se)return J(de,Se)}while(++ue)},he.prototype.inc=function(Y,ue){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ue,de,Se){typeof de=="string"&&(Se=de,de=void 0);try{return new he(Y,de).inc(ue,Se).version}catch{return null}},e.diff=function(Y,ue){if(H(Y,ue))return null;var de=j(Y),Se=j(ue);if(de.prerelease.length||Se.prerelease.length){for(var Me in de)if((Me==="major"||Me==="minor"||Me==="patch")&&de[Me]!==Se[Me])return"pre"+Me;return"prerelease"}for(var Me in de)if((Me==="major"||Me==="minor"||Me==="patch")&&de[Me]!==Se[Me])return Me},e.compareIdentifiers=J;var ne=/^[0-9]+$/;function J(Y,ue){var de=ne.test(Y),Se=ne.test(ue);return de&&Se&&(Y=+Y,ue=+ue),de&&!Se?-1:Se&&!de?1:Y<ue?-1:Y>ue?1:0}function _(Y,ue,de){return new he(Y,de).compare(new he(ue,de))}function W(Y,ue,de){return _(Y,ue,de)>0}function N(Y,ue,de){return _(Y,ue,de)<0}function H(Y,ue,de){return _(Y,ue,de)===0}function X(Y,ue,de){return _(Y,ue,de)!==0}function Q(Y,ue,de){return _(Y,ue,de)>=0}function $(Y,ue,de){return _(Y,ue,de)<=0}function ee(Y,ue,de,Se){var Me;switch(ue){case"===":typeof Y=="object"&&(Y=Y.version),typeof de=="object"&&(de=de.version),Me=Y===de;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof de=="object"&&(de=de.version),Me=Y!==de;break;case"":case"=":case"==":Me=H(Y,de,Se);break;case"!=":Me=X(Y,de,Se);break;case">":Me=W(Y,de,Se);break;case">=":Me=Q(Y,de,Se);break;case"<":Me=N(Y,de,Se);break;case"<=":Me=$(Y,de,Se);break;default:throw new TypeError("Invalid operator: "+ue)}return Me}function fe(Y,ue){if(Y instanceof fe){if(Y.loose===ue)return Y;Y=Y.value}if(!(this instanceof fe))return new fe(Y,ue);P("comparator",Y,ue),this.loose=ue,this.parse(Y),this.semver===me?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(Y,ue){return J(ue,Y)},e.major=function(Y,ue){return new he(Y,ue).major},e.minor=function(Y,ue){return new he(Y,ue).minor},e.patch=function(Y,ue){return new he(Y,ue).patch},e.compare=_,e.compareLoose=function(Y,ue){return _(Y,ue,!0)},e.rcompare=function(Y,ue,de){return _(ue,Y,de)},e.sort=function(Y,ue){return Y.sort(function(de,Se){return e.compare(de,Se,ue)})},e.rsort=function(Y,ue){return Y.sort(function(de,Se){return e.rcompare(de,Se,ue)})},e.gt=W,e.lt=N,e.eq=H,e.neq=X,e.gte=Q,e.lte=$,e.cmp=ee,e.Comparator=fe;var me={};function we(Y,ue){if(Y instanceof we)return Y.loose===ue?Y:new we(Y.raw,ue);if(Y instanceof fe)return new we(Y.value,ue);if(!(this instanceof we))return new we(Y,ue);if(this.loose=ue,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Re(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function Pe(Y,ue,de,Se,Me,Ne,_e,Le,Ue,Ve,Xe,ze,Qe){return((ue=Re(de)?"":Re(Se)?">="+de+".0.0":Re(Me)?">="+de+"."+Se+".0":">="+ue)+" "+(Le=Re(Ue)?"":Re(Ve)?"<"+(+Ue+1)+".0.0":Re(Xe)?"<"+Ue+"."+(+Ve+1)+".0":ze?"<="+Ue+"."+Ve+"."+Xe+"-"+ze:"<="+Le)).trim()}function De(Y,ue){for(var de=0;de<Y.length;de++)if(!Y[de].test(ue))return!1;if(ue.prerelease.length){for(de=0;de<Y.length;de++)if(P(Y[de].semver),Y[de].semver!==me&&Y[de].semver.prerelease.length>0){var Se=Y[de].semver;if(Se.major===ue.major&&Se.minor===ue.minor&&Se.patch===ue.patch)return!0}return!1}return!0}function ke(Y,ue,de){try{ue=new we(ue,de)}catch{return!1}return ue.test(Y)}function pe(Y,ue,de,Se){var Me,Ne,_e,Le,Ue;switch(Y=new he(Y,Se),ue=new we(ue,Se),de){case">":Me=W,Ne=$,_e=N,Le=">",Ue=">=";break;case"<":Me=N,Ne=Q,_e=W,Le="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(Y,ue,Se))return!1;for(var Ve=0;Ve<ue.set.length;++Ve){var Xe=ue.set[Ve],ze=null,Qe=null;if(Xe.forEach(function(Ke){Ke.semver===me&&(Ke=new fe(">=0.0.0")),ze=ze||Ke,Qe=Qe||Ke,Me(Ke.semver,ze.semver,Se)?ze=Ke:_e(Ke.semver,Qe.semver,Se)&&(Qe=Ke)}),ze.operator===Le||ze.operator===Ue||(!Qe.operator||Qe.operator===Le)&&Ne(Y,Qe.semver)||Qe.operator===Ue&&_e(Y,Qe.semver))return!1}return!0}fe.prototype.parse=function(Y){var ue=this.loose?R[G]:R[te],de=Y.match(ue);if(!de)throw new TypeError("Invalid comparator: "+Y);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new he(de[2],this.loose):this.semver=me},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(Y){return P("Comparator.test",Y,this.loose),this.semver===me||(typeof Y=="string"&&(Y=new he(Y,this.loose)),ee(Y,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(Y,ue){if(!(Y instanceof fe))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new we(Y.value,ue),ke(this.value,de,ue);if(Y.operator==="")return de=new we(this.value,ue),ke(Y.semver,de,ue);var Se=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ne=this.semver.version===Y.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Le=ee(this.semver,"<",Y.semver,ue)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Ue=ee(this.semver,">",Y.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Se||Me||Ne&&_e||Le||Ue},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(Y){var ue=this.loose;Y=Y.trim(),P("range",Y,ue);var de=ue?R[B]:R[O];Y=Y.replace(de,Pe),P("hyphen replace",Y),Y=Y.replace(R[q],"$1$2$3"),P("comparator trim",Y,R[q]),Y=(Y=(Y=Y.replace(R[F],"$1~")).replace(R[re],"$1^")).split(/\s+/).join(" ");var Se=ue?R[G]:R[te],Me=Y.split(" ").map(function(Ne){return function(_e,Le){return P("comp",_e),_e=function(Ue,Ve){return Ue.trim().split(/\s+/).map(function(Xe){return function(ze,Qe){P("caret",ze,Qe);var Ke=Qe?R[oe]:R[ie];return ze.replace(Ke,function(Ge,Fe,Z,ge,ve){var ye;return P("caret",ze,Ge,Fe,Z,ge,ve),Re(Fe)?ye="":Re(Z)?ye=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":Re(ge)?ye=Fe==="0"?">="+Fe+"."+Z+".0 <"+Fe+"."+(+Z+1)+".0":">="+Fe+"."+Z+".0 <"+(+Fe+1)+".0.0":ve?(P("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ye=Fe==="0"?Z==="0"?">="+Fe+"."+Z+"."+ge+ve+" <"+Fe+"."+Z+"."+(+ge+1):">="+Fe+"."+Z+"."+ge+ve+" <"+Fe+"."+(+Z+1)+".0":">="+Fe+"."+Z+"."+ge+ve+" <"+(+Fe+1)+".0.0"):(P("no pr"),ye=Fe==="0"?Z==="0"?">="+Fe+"."+Z+"."+ge+" <"+Fe+"."+Z+"."+(+ge+1):">="+Fe+"."+Z+"."+ge+" <"+Fe+"."+(+Z+1)+".0":">="+Fe+"."+Z+"."+ge+" <"+(+Fe+1)+".0.0"),P("caret return",ye),ye})}(Xe,Ve)}).join(" ")}(_e,Le),P("caret",_e),_e=function(Ue,Ve){return Ue.trim().split(/\s+/).map(function(Xe){return function(ze,Qe){var Ke=Qe?R[U]:R[x];return ze.replace(Ke,function(Ge,Fe,Z,ge,ve){var ye;return P("tilde",ze,Ge,Fe,Z,ge,ve),Re(Fe)?ye="":Re(Z)?ye=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":Re(ge)?ye=">="+Fe+"."+Z+".0 <"+Fe+"."+(+Z+1)+".0":ve?(P("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ye=">="+Fe+"."+Z+"."+ge+ve+" <"+Fe+"."+(+Z+1)+".0"):ye=">="+Fe+"."+Z+"."+ge+" <"+Fe+"."+(+Z+1)+".0",P("tilde return",ye),ye})}(Xe,Ve)}).join(" ")}(_e,Le),P("tildes",_e),_e=function(Ue,Ve){return P("replaceXRanges",Ue,Ve),Ue.split(/\s+/).map(function(Xe){return function(ze,Qe){ze=ze.trim();var Ke=Qe?R[M]:R[L];return ze.replace(Ke,function(Ge,Fe,Z,ge,ve,ye){P("xRange",ze,Ge,Fe,Z,ge,ve,ye);var Oe=Re(Z),xe=Oe||Re(ge),Ye=xe||Re(ve);return Fe==="="&&Ye&&(Fe=""),Oe?Ge=Fe===">"||Fe==="<"?"<0.0.0":"*":Fe&&Ye?(xe&&(ge=0),Ye&&(ve=0),Fe===">"?(Fe=">=",xe?(Z=+Z+1,ge=0,ve=0):Ye&&(ge=+ge+1,ve=0)):Fe==="<="&&(Fe="<",xe?Z=+Z+1:ge=+ge+1),Ge=Fe+Z+"."+ge+"."+ve):xe?Ge=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ye&&(Ge=">="+Z+"."+ge+".0 <"+Z+"."+(+ge+1)+".0"),P("xRange return",Ge),Ge})}(Xe,Ve)}).join(" ")}(_e,Le),P("xrange",_e),_e=function(Ue,Ve){return P("replaceStars",Ue,Ve),Ue.trim().replace(R[V],"")}(_e,Le),P("stars",_e),_e}(Ne,ue)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Ne){return!!Ne.match(Se)})),Me=Me.map(function(Ne){return new fe(Ne,ue)})},we.prototype.intersects=function(Y,ue){if(!(Y instanceof we))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Se){return Y.set.some(function(Me){return Me.every(function(Ne){return Se.intersects(Ne,ue)})})})})},e.toComparators=function(Y,ue){return new we(Y,ue).set.map(function(de){return de.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},we.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new he(Y,this.loose));for(var ue=0;ue<this.set.length;ue++)if(De(this.set[ue],Y))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(Y,ue,de){var Se=null,Me=null;try{var Ne=new we(ue,de)}catch{return null}return Y.forEach(function(_e){Ne.test(_e)&&(Se&&Me.compare(_e)!==-1||(Me=new he(Se=_e,de)))}),Se},e.minSatisfying=function(Y,ue,de){var Se=null,Me=null;try{var Ne=new we(ue,de)}catch{return null}return Y.forEach(function(_e){Ne.test(_e)&&(Se&&Me.compare(_e)!==1||(Me=new he(Se=_e,de)))}),Se},e.validRange=function(Y,ue){try{return new we(Y,ue).range||"*"}catch{return null}},e.ltr=function(Y,ue,de){return pe(Y,ue,"<",de)},e.gtr=function(Y,ue,de){return pe(Y,ue,">",de)},e.outside=pe,e.prerelease=function(Y,ue){var de=j(Y,ue);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(Y,ue,de){return Y=new we(Y,de),ue=new we(ue,de),Y.intersects(ue)},e.coerce=function(Y){if(Y instanceof he)return Y;if(typeof Y!="string")return null;var ue=Y.match(R[T]);return ue==null?null:j((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,i(1))},function(K,e){var i,s,P=K.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(p){if(i===setTimeout)return setTimeout(p,0);if((i===k||!i)&&setTimeout)return i=setTimeout,setTimeout(p,0);try{return i(p,0)}catch{try{return i.call(null,p,0)}catch{return i.call(this,p,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:k}catch{i=k}try{s=typeof clearTimeout=="function"?clearTimeout:A}catch{s=A}})();var b,l=[],d=!1,f=-1;function g(){d&&b&&(d=!1,b.length?l=b.concat(l):f=-1,l.length&&y())}function y(){if(!d){var p=R(g);d=!0;for(var v=l.length;v;){for(b=l,l=[];++f<v;)b&&b[f].run();f=-1,v=l.length}b=null,d=!1,function(w){if(s===clearTimeout)return clearTimeout(w);if((s===A||!s)&&clearTimeout)return s=clearTimeout,clearTimeout(w);try{s(w)}catch{try{return s.call(null,w)}catch{return s.call(this,w)}}}(p)}}function h(p,v){this.fun=p,this.array=v}function m(){}P.nextTick=function(p){var v=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)v[w-1]=arguments[w];l.push(new h(p,v)),l.length!==1||d||R(y)},h.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=m,P.addListener=m,P.once=m,P.off=m,P.removeListener=m,P.removeAllListeners=m,P.emit=m,P.prependListener=m,P.prependOnceListener=m,P.listeners=function(p){return[]},P.binding=function(p){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(p){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(le[144],ce([0,1]),function(K,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class s{constructor(R,b,l){this.level=R,this.key=b,this.value=l,this.forward=[]}}const P=void 0;class k{constructor(R,b=2**16){this.comparator=R,this[i]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new s(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new s(this._maxLevel,P,P),this._size=0}has(R){return!!k._search(this,R,this.comparator)}get(R){return k._search(this,R,this.comparator)?.value}set(R,b){return k._insert(this,R,b,this.comparator)&&(this._size+=1),this}delete(R){const b=k._delete(this,R,this.comparator);return b&&(this._size-=1),b}forEach(R,b){let l=this._header.forward[0];for(;l;)R.call(b,l.value,l.key,this),l=l.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this._header.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static _search(R,b,l){let d=R._header;for(let f=R._level-1;f>=0;f--)for(;d.forward[f]&&l(d.forward[f].key,b)<0;)d=d.forward[f];if(d=d.forward[0],d&&l(d.key,b)===0)return d}static _insert(R,b,l,d){const f=[];let g=R._header;for(let y=R._level-1;y>=0;y--){for(;g.forward[y]&&d(g.forward[y].key,b)<0;)g=g.forward[y];f[y]=g}if(g=g.forward[0],g&&d(g.key,b)===0)return g.value=l,!1;{const y=k._randomLevel(R);if(y>R._level){for(let h=R._level;h<y;h++)f[h]=R._header;R._level=y}g=new s(y,b,l);for(let h=0;h<y;h++)g.forward[h]=f[h].forward[h],f[h].forward[h]=g;return!0}}static _randomLevel(R,b=.5){let l=1;for(;Math.random()<b&&l<R._maxLevel;)l+=1;return l}static _delete(R,b,l){const d=[];let f=R._header;for(let g=R._level-1;g>=0;g--){for(;f.forward[g]&&l(f.forward[g].key,b)<0;)f=f.forward[g];d[g]=f}if(f=f.forward[0],!f||l(f.key,b)!==0)return!1;for(let g=0;g<R._level&&d[g].forward[g]===f;g++)d[g].forward[g]=f.forward[g];for(;R._level>0&&R._header.forward[R._level-1]===P;)R._level-=1;return!0}}e.SkipList=k}),define(le[77],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class s{static create(k){return new s(k)}constructor(k){this._now=i&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=s}),define(le[3],ce([0,1,16,89,2,109,77]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=y;const R=!1,b=!1,l=!1;var d;(function(U){U.None=()=>P.Disposable.None;function z(Pe){if(l){const{onDidAddListener:De}=Pe,ke=m.create();let pe=0;Pe.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),De?.()}}}function re(Pe,De){return j(Pe,()=>{},0,void 0,!0,void 0,De)}U.defer=re;function ie(Pe){return(De,ke=null,pe)=>{let Y=!1,ue;return ue=Pe(de=>{if(!Y)return ue?ue.dispose():Y=!0,De.call(ke,de)},null,pe),Y&&ue.dispose(),ue}}U.once=ie;function oe(Pe,De,ke){return V((pe,Y=null,ue)=>Pe(de=>pe.call(Y,De(de)),null,ue),ke)}U.map=oe;function G(Pe,De,ke){return V((pe,Y=null,ue)=>Pe(de=>{De(de),pe.call(Y,de)},null,ue),ke)}U.forEach=G;function te(Pe,De,ke){return V((pe,Y=null,ue)=>Pe(de=>De(de)&&pe.call(Y,de),null,ue),ke)}U.filter=te;function q(Pe){return Pe}U.signal=q;function O(...Pe){return(De,ke=null,pe)=>{const Y=(0,P.combinedDisposable)(...Pe.map(ue=>ue(de=>De.call(ke,de))));return ae(Y,pe)}}U.any=O;function B(Pe,De,ke,pe){let Y=ke;return oe(Pe,ue=>(Y=De(Y,ue),Y),pe)}U.reduce=B;function V(Pe,De){let ke;const pe={onWillAddFirstListener(){ke=Pe(Y.fire,Y)},onDidRemoveLastListener(){ke?.dispose()}};De||z(pe);const Y=new r(pe);return De?.add(Y),Y.event}function ae(Pe,De){return De instanceof Array?De.push(Pe):De&&De.add(Pe),Pe}function j(Pe,De,ke=100,pe=!1,Y=!1,ue,de){let Se,Me,Ne,_e=0,Le;const Ue={leakWarningThreshold:ue,onWillAddFirstListener(){Se=Pe(Xe=>{_e++,Me=De(Me,Xe),pe&&!Ne&&(Ve.fire(Me),Me=void 0),Le=()=>{const ze=Me;Me=void 0,Ne=void 0,(!pe||_e>1)&&Ve.fire(ze),_e=0},typeof ke=="number"?(clearTimeout(Ne),Ne=setTimeout(Le,ke)):Ne===void 0&&(Ne=0,queueMicrotask(Le))})},onWillRemoveListener(){Y&&_e>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,Se.dispose()}};de||z(Ue);const Ve=new r(Ue);return de?.add(Ve),Ve.event}U.debounce=j;function he(Pe,De=0,ke){return U.debounce(Pe,(pe,Y)=>pe?(pe.push(Y),pe):[Y],De,void 0,!0,void 0,ke)}U.accumulate=he;function ne(Pe,De=(pe,Y)=>pe===Y,ke){let pe=!0,Y;return te(Pe,ue=>{const de=pe||!De(ue,Y);return pe=!1,Y=ue,de},ke)}U.latch=ne;function J(Pe,De,ke){return[U.filter(Pe,De,ke),U.filter(Pe,pe=>!De(pe),ke)]}U.split=J;function _(Pe,De=!1,ke=[],pe){let Y=ke.slice(),ue=Pe(Me=>{Y?Y.push(Me):Se.fire(Me)});pe&&pe.add(ue);const de=()=>{Y?.forEach(Me=>Se.fire(Me)),Y=null},Se=new r({onWillAddFirstListener(){ue||(ue=Pe(Me=>Se.fire(Me)),pe&&pe.add(ue))},onDidAddFirstListener(){Y&&(De?setTimeout(de):de())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return pe&&pe.add(Se),Se.event}U.buffer=_;function W(Pe,De){return(pe,Y,ue)=>{const de=De(new H);return Pe(function(Se){const Me=de.evaluate(Se);Me!==N&&pe.call(Y,Me)},void 0,ue)}}U.chain=W;const N=Symbol("HaltChainable");class H{constructor(){this.steps=[]}map(De){return this.steps.push(De),this}forEach(De){return this.steps.push(ke=>(De(ke),ke)),this}filter(De){return this.steps.push(ke=>De(ke)?ke:N),this}reduce(De,ke){let pe=ke;return this.steps.push(Y=>(pe=De(pe,Y),pe)),this}latch(De=(ke,pe)=>ke===pe){let ke=!0,pe;return this.steps.push(Y=>{const ue=ke||!De(Y,pe);return ke=!1,pe=Y,ue?Y:N}),this}evaluate(De){for(const ke of this.steps)if(De=ke(De),De===N)break;return De}}function X(Pe,De,ke=pe=>pe){const pe=(...Se)=>de.fire(ke(...Se)),Y=()=>Pe.on(De,pe),ue=()=>Pe.removeListener(De,pe),de=new r({onWillAddFirstListener:Y,onDidRemoveLastListener:ue});return de.event}U.fromNodeEventEmitter=X;function Q(Pe,De,ke=pe=>pe){const pe=(...Se)=>de.fire(ke(...Se)),Y=()=>Pe.addEventListener(De,pe),ue=()=>Pe.removeEventListener(De,pe),de=new r({onWillAddFirstListener:Y,onDidRemoveLastListener:ue});return de.event}U.fromDOMEventEmitter=Q;function $(Pe){return new Promise(De=>ie(Pe)(De))}U.toPromise=$;function ee(Pe){const De=new r;return Pe.then(ke=>{De.fire(ke)},()=>{De.fire(void 0)}).finally(()=>{De.dispose()}),De.event}U.fromPromise=ee;function fe(Pe,De,ke){return De(ke),Pe(pe=>De(pe))}U.runAndSubscribe=fe;class me{constructor(De,ke){this._observable=De,this._counter=0,this._hasChanged=!1;const pe={onWillAddFirstListener:()=>{De.addObserver(this)},onDidRemoveLastListener:()=>{De.removeObserver(this)}};ke||z(pe),this.emitter=new r(pe),ke&&ke.add(this.emitter)}beginUpdate(De){this._counter++}handlePossibleChange(De){}handleChange(De,ke){this._hasChanged=!0}endUpdate(De){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function we(Pe,De){return new me(Pe,De).emitter.event}U.fromObservable=we;function Re(Pe){return(De,ke,pe)=>{let Y=0,ue=!1;const de={beginUpdate(){Y++},endUpdate(){Y--,Y===0&&(Pe.reportChanges(),ue&&(ue=!1,De.call(ke)))},handlePossibleChange(){},handleChange(){ue=!0}};Pe.addObserver(de),Pe.reportChanges();const Se={dispose(){Pe.removeObserver(de)}};return pe instanceof P.DisposableStore?pe.add(Se):Array.isArray(pe)&&pe.push(Se),Se}}U.fromObservableLight=Re})(d||(e.Event=d={}));class f{static{this.all=new Set}static{this._idPool=0}constructor(z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${z}_${f._idPool++}`,f.all.add(this)}start(z){this._stopWatch=new A.StopWatch,this.listenerCount=z}stop(){if(this._stopWatch){const z=this._stopWatch.elapsed();this.durations.push(z),this.elapsedOverall+=z,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=f;let g=-1;function y(U){const z=g;return g=U,{dispose(){g=z}}}class h{constructor(z,re,ie=Math.random().toString(18).slice(2,5)){this._errorHandler=z,this.threshold=re,this.name=ie,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(z,re){const ie=this.threshold;if(ie<=0||re<ie)return;this._stacks||(this._stacks=new Map);const oe=this._stacks.get(z.value)||0;if(this._stacks.set(z.value,oe+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=ie*.5;const[G,te]=this.getMostFrequentStack(),q=`[${this.name}] potential listener LEAK detected, having ${re} listeners already. MOST frequent listener (${te}):`;console.warn(q),console.warn(G);const O=new p(q,G);this._errorHandler(O)}return()=>{const G=this._stacks.get(z.value)||0;this._stacks.set(z.value,G-1)}}getMostFrequentStack(){if(!this._stacks)return;let z,re=0;for(const[ie,oe]of this._stacks)(!z||re<oe)&&(z=[ie,oe],re=oe);return z}}class m{static create(){const z=new Error;return new m(z.stack??"")}constructor(z){this.value=z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p extends Error{constructor(z,re){super(z),this.name="ListenerLeakError",this.stack=re}}e.ListenerLeakError=p;class v extends Error{constructor(z,re){super(z),this.name="ListenerRefusalError",this.stack=re}}e.ListenerRefusalError=v;let w=0;class E{constructor(z){this.value=z,this.id=w++}}const I=2,o=(U,z)=>{if(U instanceof E)z(U);else for(let re=0;re<U.length;re++){const ie=U[re];ie&&z(ie)}},t=R?new FinalizationRegistry(U=>{typeof U=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(U))}):void 0;class r{constructor(z){this._size=0,this._options=z,this._leakageMon=g>0||this._options?.leakWarningThreshold?new h(z?.onListenerError??i.onUnexpectedError,this._options?.leakWarningThreshold??g):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(b){const z=this._listeners;queueMicrotask(()=>{o(z,re=>re.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(z,re,ie)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const O=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(O);const B=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],V=new v(`${O}. HINT: Stack shows most frequent listener (${B[1]}-times)`,B[0]);return(this._options?.onListenerError||i.onUnexpectedError)(V),P.Disposable.None}if(this._disposed)return P.Disposable.None;re&&(z=z.bind(re));const oe=new E(z);let G,te;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(oe.stack=m.create(),G=this._leakageMon.check(oe.stack,this._size+1)),b&&(oe.stack=te??m.create()),this._listeners?this._listeners instanceof E?(this._deliveryQueue??=new n,this._listeners=[this._listeners,oe]):this._listeners.push(oe):(this._options?.onWillAddFirstListener?.(this),this._listeners=oe,this._options?.onDidAddFirstListener?.(this)),this._size++;const q=(0,P.toDisposable)(()=>{t?.unregister(q),G?.(),this._removeListener(oe)});if(ie instanceof P.DisposableStore?ie.add(q):Array.isArray(ie)&&ie.push(q),t){const O=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(q,O,q)}return q},this._event}_removeListener(z){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const re=this._listeners,ie=re.indexOf(z);if(ie===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,re[ie]=void 0;const oe=this._deliveryQueue.current===this;if(this._size*I<=re.length){let G=0;for(let te=0;te<re.length;te++)re[te]?re[G++]=re[te]:oe&&(this._deliveryQueue.end--,G<this._deliveryQueue.i&&this._deliveryQueue.i--);re.length=G}}_deliver(z,re){if(!z)return;const ie=this._options?.onListenerError||i.onUnexpectedError;if(!ie){z.value(re);return}try{z.value(re)}catch(oe){ie(oe)}}_deliverQueue(z){const re=z.current._listeners;for(;z.i<z.end;)this._deliver(re[z.i++],z.value);z.reset()}fire(z){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof E)this._deliver(this._listeners,z);else{const re=this._deliveryQueue;re.enqueue(this,z,this._listeners.length),this._deliverQueue(re)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=r;const a=()=>new n;e.createEventDeliveryQueue=a;class n{constructor(){this.i=-1,this.end=0}enqueue(z,re,ie){this.i=0,this.end=ie,this.current=z,this.value=re}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends r{async fireAsync(z,re,ie){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList),o(this._listeners,oe=>this._asyncDeliveryQueue.push([oe.value,z]));this._asyncDeliveryQueue.size>0&&!re.isCancellationRequested;){const[oe,G]=this._asyncDeliveryQueue.shift(),te=[],q={...G,token:re,waitUntil:O=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");ie&&(O=ie(O,oe)),te.push(O)}};try{oe(q)}catch(O){(0,i.onUnexpectedError)(O);continue}Object.freeze(te),await Promise.allSettled(te).then(O=>{for(const B of O)B.status==="rejected"&&(0,i.onUnexpectedError)(B.reason)})}}}e.AsyncEmitter=c;class u extends r{get isPaused(){return this._isPaused!==0}constructor(z){super(z),this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=z?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const z=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(z))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(z){this._size&&(this._isPaused!==0?this._eventQueue.push(z):super.fire(z))}}e.PauseableEmitter=u;class S extends u{constructor(z){super(z),this._delay=z.delay??100}fire(z){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(z)}}e.DebounceEmitter=S;class D extends r{constructor(z){super(z),this._queuedEvents=[],this._mergeFn=z?.merge}fire(z){this.hasListeners()&&(this._queuedEvents.push(z),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(re=>super.fire(re)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=D;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new r({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(z){const re={event:z,listener:null};this.events.push(re),this.hasListeners&&this.hook(re);const ie=()=>{this.hasListeners&&this.unhook(re);const oe=this.events.indexOf(re);this.events.splice(oe,1)};return(0,P.toDisposable)((0,s.createSingleCallFunction)(ie))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(z=>this.hook(z))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(z=>this.unhook(z))}hook(z){z.listener=z.event(re=>this.emitter.fire(re))}unhook(z){z.listener?.dispose(),z.listener=null}dispose(){this.emitter.dispose();for(const z of this.events)z.listener?.dispose();this.events=[]}}e.EventMultiplexer=L;class M{constructor(z,re,ie,oe){this._store=new P.DisposableStore;const G=this._store.add(new L),te=this._store.add(new P.DisposableMap);function q(O){te.set(O,G.add(oe(O)))}for(const O of z)q(O);this._store.add(re(O=>{q(O)})),this._store.add(ie(O=>{te.deleteAndDispose(O)})),this.event=G.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=M;class T{constructor(){this.data=[]}wrapEvent(z,re,ie){return(oe,G,te)=>z(q=>{const O=this.data[this.data.length-1];if(!re){O?O.buffers.push(()=>oe.call(G,q)):oe.call(G,q);return}const B=O;if(!B){oe.call(G,re(ie,q));return}B.items??=[],B.items.push(q),B.buffers.length===0&&O.buffers.push(()=>{B.reducedResult??=ie?B.items.reduce(re,ie):B.items.reduce(re),oe.call(G,B.reducedResult)})},void 0,te)}bufferEvents(z){const re={buffers:new Array};this.data.push(re);const ie=z();return this.data.pop(),re.buffers.forEach(oe=>oe()),ie}}e.EventBufferer=T;class C{constructor(){this.listening=!1,this.inputEvent=d.None,this.inputEventListener=P.Disposable.None,this.emitter=new r({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(z){this.inputEvent=z,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=z(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C;class F{static const(z){return new x(z)}constructor(z){this._value=z,this._onDidChange=new r,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(z){z!==this._value&&(this._value=z,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=F;class x{constructor(z){this.value=z,this.onDidChange=d.None}}}),define(le[23],ce([0,1,3]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=R;const s=Object.freeze(function(b,l){const d=setTimeout(b.bind(l),0);return{dispose(){clearTimeout(d)}}});var P;(function(b){function l(d){return d===b.None||d===b.Cancelled||d instanceof k?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}b.isCancellationToken=l,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:s})})(P||(e.CancellationToken=P={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?s:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=P.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=A;function R(b){const l=new A;return b.add({dispose(){l.cancel()}}),l.token}}),define(le[145],ce([0,1,23]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=P;class s{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new i.CancellationTokenSource,l=this.task(b.token);return this.result={promise:l,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=s;function P(R){return R}class k{constructor(b,l){this.lastCache=void 0,this.lastArgKey=void 0,typeof b=="function"?(this._fn=b,this._computeKey=P):(this._fn=l,this._computeKey=b.getCacheKey)}get(b){const l=this._computeKey(b);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this._fn(b)),this.lastCache}}e.LRUCachedFunction=k;class A{get cachedValues(){return this._map}constructor(b,l){this._map=new Map,this._map2=new Map,typeof b=="function"?(this._fn=b,this._computeKey=P):(this._fn=l,this._computeKey=b.getCacheKey)}get(b){const l=this._computeKey(b);if(this._map2.has(l))return this._map2.get(l);const d=this._fn(b);return this._map.set(b,d),this._map2.set(l,d),d}}e.CachedFunction=A}),define(le[66],ce([0,1,16,2]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=P,e.isReadableStream=k,e.isReadableBufferedStream=A,e.newWriteableStream=R,e.consumeReadable=l,e.peekReadable=d,e.consumeStream=f,e.listenStream=g,e.peekStream=y,e.toStream=h,e.emptyStream=m,e.toReadable=p,e.transform=v,e.prefixedReadable=w,e.prefixedStream=E;function P(I){const o=I;return o?typeof o.read=="function":!1}function k(I){const o=I;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function A(I){const o=I;return o?k(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function R(I,o){return new b(I,o)}class b{constructor(o,t){this.reducer=o,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o<"u"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(t=>t(o))}emitError(o){this.listeners.error.length===0?(0,i.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(t=>t(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,t){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(o,t){if(this.state.destroyed)return;let r;switch(o){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(t);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(I,o){const t=[];let r;for(;(r=I.read())!==null;)t.push(r);return o(t)}function d(I,o,t){const r=[];let a;for(;(a=I.read())!==null&&r.length<t;)r.push(a);return a===null&&r.length>0?o(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a<"u"){const n=a;return a=void 0,n}return I.read()}}}function f(I,o){return new Promise((t,r)=>{const a=[];g(I,{onData:n=>{o&&a.push(n)},onError:n=>{o?r(n):t(void 0)},onEnd:()=>{t(o?o(a):void 0)}})})}function g(I,o,t){I.on("error",r=>{t?.isCancellationRequested||o.onError(r)}),I.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),I.on("data",r=>{t?.isCancellationRequested||o.onData(r)})}function y(I,o){return new Promise((t,r)=>{const a=new s.DisposableStore,n=[],c=D=>{if(n.push(D),n.length>o)return a.dispose(),I.pause(),t({stream:I,buffer:n,ended:!1})},u=D=>(a.dispose(),r(D)),S=()=>(a.dispose(),t({stream:I,buffer:n,ended:!0}));a.add((0,s.toDisposable)(()=>I.removeListener("error",u))),I.on("error",u),a.add((0,s.toDisposable)(()=>I.removeListener("end",S))),I.on("end",S),a.add((0,s.toDisposable)(()=>I.removeListener("data",c))),I.on("data",c)})}function h(I,o){const t=R(o);return t.end(I),t}function m(){const I=R(()=>{throw new Error("not supported")});return I.end(),I}function p(I){let o=!1;return{read:()=>o?null:(o=!0,I)}}function v(I,o,t){const r=R(t);return g(I,{onData:a=>r.write(o.data(a)),onError:a=>r.error(o.error?o.error(a):a),onEnd:()=>r.end()}),r}function w(I,o,t){let r=!1;return{read:()=>{const a=o.read();return r?a:(r=!0,a!==null?t([I,a]):I)}}}function E(I,o,t){let r=!1;const a=R(t);return g(o,{onData:n=>r?a.write(n):(r=!0,a.write(t([I,n]))),onError:n=>a.error(n),onEnd:()=>{r||(r=!0,a.write(I)),a.end()}}),a}}),define(le[17],ce([0,1,65,66]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=l,e.readUInt16LE=d,e.writeUInt16LE=f,e.readUInt32BE=g,e.writeUInt32BE=y,e.readUInt32LE=h,e.writeUInt32LE=m,e.readUInt8=p,e.writeUInt8=v,e.readableToBuffer=w,e.bufferToReadable=E,e.streamToBuffer=I,e.bufferedStreamToBuffer=o,e.bufferToStream=t,e.streamToBufferReadableStream=r,e.newWriteableBufferStream=a,e.prefixedBufferReadable=n,e.prefixedBufferStream=c,e.decodeBase64=u,e.encodeBase64=L;const P=typeof Buffer<"u",k=new i.Lazy(()=>new Uint8Array(256));let A,R;class b{static alloc(T){return P?new b(Buffer.allocUnsafe(T)):new b(new Uint8Array(T))}static wrap(T){return P&&!Buffer.isBuffer(T)&&(T=Buffer.from(T.buffer,T.byteOffset,T.byteLength)),new b(T)}static fromString(T,C){return!(C?.dontUseNodeBuffer||!1)&&P?new b(Buffer.from(T)):(A||(A=new TextEncoder),new b(A.encode(T)))}static fromByteArray(T){const C=b.alloc(T.length);for(let F=0,x=T.length;F<x;F++)C.buffer[F]=T[F];return C}static concat(T,C){if(typeof C>"u"){C=0;for(let U=0,z=T.length;U<z;U++)C+=T[U].byteLength}const F=b.alloc(C);let x=0;for(let U=0,z=T.length;U<z;U++){const re=T[U];F.set(re,x),x+=re.byteLength}return F}constructor(T){this.buffer=T,this.byteLength=this.buffer.byteLength}clone(){const T=b.alloc(this.byteLength);return T.set(this),T}toString(){return P?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(T,C){return new b(this.buffer.subarray(T,C))}set(T,C){if(T instanceof b)this.buffer.set(T.buffer,C);else if(T instanceof Uint8Array)this.buffer.set(T,C);else if(T instanceof ArrayBuffer)this.buffer.set(new Uint8Array(T),C);else if(ArrayBuffer.isView(T))this.buffer.set(new Uint8Array(T.buffer,T.byteOffset,T.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(T){return g(this.buffer,T)}writeUInt32BE(T,C){y(this.buffer,T,C)}readUInt32LE(T){return h(this.buffer,T)}writeUInt32LE(T,C){m(this.buffer,T,C)}readUInt8(T){return p(this.buffer,T)}writeUInt8(T,C){v(this.buffer,T,C)}indexOf(T,C=0){return l(this.buffer,T instanceof b?T.buffer:T,C)}}e.VSBuffer=b;function l(M,T,C=0){const F=T.byteLength,x=M.byteLength;if(F===0)return 0;if(F===1)return M.indexOf(T[0]);if(F>x-C)return-1;const U=k.value;U.fill(T.length);for(let oe=0;oe<T.length;oe++)U[T[oe]]=T.length-oe-1;let z=C+T.length-1,re=z,ie=-1;for(;z<x;)if(M[z]===T[re]){if(re===0){ie=z;break}z--,re--}else z+=Math.max(T.length-re,U[M[z]]),re=T.length-1;return ie}function d(M,T){return M[T+0]<<0>>>0|M[T+1]<<8>>>0}function f(M,T,C){M[C+0]=T&255,T=T>>>8,M[C+1]=T&255}function g(M,T){return M[T]*2**24+M[T+1]*2**16+M[T+2]*2**8+M[T+3]}function y(M,T,C){M[C+3]=T,T=T>>>8,M[C+2]=T,T=T>>>8,M[C+1]=T,T=T>>>8,M[C]=T}function h(M,T){return M[T+0]<<0>>>0|M[T+1]<<8>>>0|M[T+2]<<16>>>0|M[T+3]<<24>>>0}function m(M,T,C){M[C+0]=T&255,T=T>>>8,M[C+1]=T&255,T=T>>>8,M[C+2]=T&255,T=T>>>8,M[C+3]=T&255}function p(M,T){return M[T]}function v(M,T,C){M[C]=T}function w(M){return s.consumeReadable(M,T=>b.concat(T))}function E(M){return s.toReadable(M)}function I(M){return s.consumeStream(M,T=>b.concat(T))}async function o(M){return M.ended?b.concat(M.buffer):b.concat([...M.buffer,await I(M.stream)])}function t(M){return s.toStream(M,T=>b.concat(T))}function r(M){return s.transform(M,{data:T=>typeof T=="string"?b.fromString(T):b.wrap(T)},T=>b.concat(T))}function a(M){return s.newWriteableStream(T=>b.concat(T),M)}function n(M,T){return s.prefixedReadable(M,T,C=>b.concat(C))}function c(M,T){return s.prefixedStream(M,T,C=>b.concat(C))}function u(M){let T=0,C=0,F=0;const x=new Uint8Array(Math.floor(M.length/4*3)),U=re=>{switch(C){case 3:x[F++]=T|re,C=0;break;case 2:x[F++]=T|re>>>2,T=re<<6,C=3;break;case 1:x[F++]=T|re>>>4,T=re<<4,C=2;break;default:T=re<<2,C=1}};for(let re=0;re<M.length;re++){const ie=M.charCodeAt(re);if(ie>=65&&ie<=90)U(ie-65);else if(ie>=97&&ie<=122)U(ie-97+26);else if(ie>=48&&ie<=57)U(ie-48+52);else if(ie===43||ie===45)U(62);else if(ie===47||ie===95)U(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${M[re]}`)}}const z=F;for(;C>0;)U(0);return b.wrap(x).slice(0,z)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function L({buffer:M},T=!0,C=!1){const F=C?D:S;let x="";const U=M.byteLength%3;let z=0;for(;z<M.byteLength-U;z+=3){const re=M[z+0],ie=M[z+1],oe=M[z+2];x+=F[re>>>2],x+=F[(re<<4|ie>>>4)&63],x+=F[(ie<<2|oe>>>6)&63],x+=F[oe&63]}if(U===1){const re=M[z+0];x+=F[re>>>2],x+=F[re<<4&63],T&&(x+="==")}else if(U===2){const re=M[z+0],ie=M[z+1];x+=F[re>>>2],x+=F[(re<<4|ie>>>4)&63],x+=F[ie<<2&63],T&&(x+="=")}return x}}),define(le[146],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(le[12],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=i,e.isStringArray=s,e.isObject=P,e.isTypedArray=k,e.isNumber=A,e.isIterable=R,e.isBoolean=b,e.isUndefined=l,e.isDefined=d,e.isUndefinedOrNull=f,e.assertType=g,e.assertIsDefined=y,e.assertAllDefined=h,e.isEmptyObject=p,e.isFunction=v,e.areFunctions=w,e.validateConstraints=E,e.validateConstraint=I;function i(o){return typeof o=="string"}function s(o){return Array.isArray(o)&&o.every(t=>i(t))}function P(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function k(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function A(o){return typeof o=="number"&&!isNaN(o)}function R(o){return!!o&&typeof o[Symbol.iterator]=="function"}function b(o){return o===!0||o===!1}function l(o){return typeof o>"u"}function d(o){return!f(o)}function f(o){return l(o)||o===null}function g(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function y(o){if(f(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function h(...o){const t=[];for(let r=0;r<o.length;r++){const a=o[r];if(f(a))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(a)}return t}const m=Object.prototype.hasOwnProperty;function p(o){if(!P(o))return!1;for(const t in o)if(m.call(o,t))return!1;return!0}function v(o){return typeof o=="function"}function w(...o){return o.length>0&&o.every(v)}function E(o,t){const r=Math.min(o.length,t.length);for(let a=0;a<r;a++)I(o[a],t[a])}function I(o,t){if(i(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(v(t)){try{if(o instanceof t)return}catch{}if(!f(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[110],ce([0,1,12]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=P,e.getCodiconFontCharacters=k;const s=Object.create(null);function P(A,R){if((0,i.isString)(R)){const b=s[R];if(b===void 0)throw new Error(`${A} references an unknown codicon: ${R}`);R=b}return s[A]=R,{id:A}}function k(){return s}}),define(le[147],ce([0,1,110]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,i.register)("add",6e4),plus:(0,i.register)("plus",6e4),gistNew:(0,i.register)("gist-new",6e4),repoCreate:(0,i.register)("repo-create",6e4),lightbulb:(0,i.register)("lightbulb",60001),lightBulb:(0,i.register)("light-bulb",60001),repo:(0,i.register)("repo",60002),repoDelete:(0,i.register)("repo-delete",60002),gistFork:(0,i.register)("gist-fork",60003),repoForked:(0,i.register)("repo-forked",60003),gitPullRequest:(0,i.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.register)("git-pull-request-abandoned",60004),recordKeys:(0,i.register)("record-keys",60005),keyboard:(0,i.register)("keyboard",60005),tag:(0,i.register)("tag",60006),gitPullRequestLabel:(0,i.register)("git-pull-request-label",60006),tagAdd:(0,i.register)("tag-add",60006),tagRemove:(0,i.register)("tag-remove",60006),person:(0,i.register)("person",60007),personFollow:(0,i.register)("person-follow",60007),personOutline:(0,i.register)("person-outline",60007),personFilled:(0,i.register)("person-filled",60007),gitBranch:(0,i.register)("git-branch",60008),gitBranchCreate:(0,i.register)("git-branch-create",60008),gitBranchDelete:(0,i.register)("git-branch-delete",60008),sourceControl:(0,i.register)("source-control",60008),mirror:(0,i.register)("mirror",60009),mirrorPublic:(0,i.register)("mirror-public",60009),star:(0,i.register)("star",60010),starAdd:(0,i.register)("star-add",60010),starDelete:(0,i.register)("star-delete",60010),starEmpty:(0,i.register)("star-empty",60010),comment:(0,i.register)("comment",60011),commentAdd:(0,i.register)("comment-add",60011),alert:(0,i.register)("alert",60012),warning:(0,i.register)("warning",60012),search:(0,i.register)("search",60013),searchSave:(0,i.register)("search-save",60013),logOut:(0,i.register)("log-out",60014),signOut:(0,i.register)("sign-out",60014),logIn:(0,i.register)("log-in",60015),signIn:(0,i.register)("sign-in",60015),eye:(0,i.register)("eye",60016),eyeUnwatch:(0,i.register)("eye-unwatch",60016),eyeWatch:(0,i.register)("eye-watch",60016),circleFilled:(0,i.register)("circle-filled",60017),primitiveDot:(0,i.register)("primitive-dot",60017),closeDirty:(0,i.register)("close-dirty",60017),debugBreakpoint:(0,i.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.register)("debug-breakpoint-disabled",60017),debugHint:(0,i.register)("debug-hint",60017),terminalDecorationSuccess:(0,i.register)("terminal-decoration-success",60017),primitiveSquare:(0,i.register)("primitive-square",60018),edit:(0,i.register)("edit",60019),pencil:(0,i.register)("pencil",60019),info:(0,i.register)("info",60020),issueOpened:(0,i.register)("issue-opened",60020),gistPrivate:(0,i.register)("gist-private",60021),gitForkPrivate:(0,i.register)("git-fork-private",60021),lock:(0,i.register)("lock",60021),mirrorPrivate:(0,i.register)("mirror-private",60021),close:(0,i.register)("close",60022),removeClose:(0,i.register)("remove-close",60022),x:(0,i.register)("x",60022),repoSync:(0,i.register)("repo-sync",60023),sync:(0,i.register)("sync",60023),clone:(0,i.register)("clone",60024),desktopDownload:(0,i.register)("desktop-download",60024),beaker:(0,i.register)("beaker",60025),microscope:(0,i.register)("microscope",60025),vm:(0,i.register)("vm",60026),deviceDesktop:(0,i.register)("device-desktop",60026),file:(0,i.register)("file",60027),fileText:(0,i.register)("file-text",60027),more:(0,i.register)("more",60028),ellipsis:(0,i.register)("ellipsis",60028),kebabHorizontal:(0,i.register)("kebab-horizontal",60028),mailReply:(0,i.register)("mail-reply",60029),reply:(0,i.register)("reply",60029),organization:(0,i.register)("organization",60030),organizationFilled:(0,i.register)("organization-filled",60030),organizationOutline:(0,i.register)("organization-outline",60030),newFile:(0,i.register)("new-file",60031),fileAdd:(0,i.register)("file-add",60031),newFolder:(0,i.register)("new-folder",60032),fileDirectoryCreate:(0,i.register)("file-directory-create",60032),trash:(0,i.register)("trash",60033),trashcan:(0,i.register)("trashcan",60033),history:(0,i.register)("history",60034),clock:(0,i.register)("clock",60034),folder:(0,i.register)("folder",60035),fileDirectory:(0,i.register)("file-directory",60035),symbolFolder:(0,i.register)("symbol-folder",60035),logoGithub:(0,i.register)("logo-github",60036),markGithub:(0,i.register)("mark-github",60036),github:(0,i.register)("github",60036),terminal:(0,i.register)("terminal",60037),console:(0,i.register)("console",60037),repl:(0,i.register)("repl",60037),zap:(0,i.register)("zap",60038),symbolEvent:(0,i.register)("symbol-event",60038),error:(0,i.register)("error",60039),stop:(0,i.register)("stop",60039),variable:(0,i.register)("variable",60040),symbolVariable:(0,i.register)("symbol-variable",60040),array:(0,i.register)("array",60042),symbolArray:(0,i.register)("symbol-array",60042),symbolModule:(0,i.register)("symbol-module",60043),symbolPackage:(0,i.register)("symbol-package",60043),symbolNamespace:(0,i.register)("symbol-namespace",60043),symbolObject:(0,i.register)("symbol-object",60043),symbolMethod:(0,i.register)("symbol-method",60044),symbolFunction:(0,i.register)("symbol-function",60044),symbolConstructor:(0,i.register)("symbol-constructor",60044),symbolBoolean:(0,i.register)("symbol-boolean",60047),symbolNull:(0,i.register)("symbol-null",60047),symbolNumeric:(0,i.register)("symbol-numeric",60048),symbolNumber:(0,i.register)("symbol-number",60048),symbolStructure:(0,i.register)("symbol-structure",60049),symbolStruct:(0,i.register)("symbol-struct",60049),symbolParameter:(0,i.register)("symbol-parameter",60050),symbolTypeParameter:(0,i.register)("symbol-type-parameter",60050),symbolKey:(0,i.register)("symbol-key",60051),symbolText:(0,i.register)("symbol-text",60051),symbolReference:(0,i.register)("symbol-reference",60052),goToFile:(0,i.register)("go-to-file",60052),symbolEnum:(0,i.register)("symbol-enum",60053),symbolValue:(0,i.register)("symbol-value",60053),symbolRuler:(0,i.register)("symbol-ruler",60054),symbolUnit:(0,i.register)("symbol-unit",60054),activateBreakpoints:(0,i.register)("activate-breakpoints",60055),archive:(0,i.register)("archive",60056),arrowBoth:(0,i.register)("arrow-both",60057),arrowDown:(0,i.register)("arrow-down",60058),arrowLeft:(0,i.register)("arrow-left",60059),arrowRight:(0,i.register)("arrow-right",60060),arrowSmallDown:(0,i.register)("arrow-small-down",60061),arrowSmallLeft:(0,i.register)("arrow-small-left",60062),arrowSmallRight:(0,i.register)("arrow-small-right",60063),arrowSmallUp:(0,i.register)("arrow-small-up",60064),arrowUp:(0,i.register)("arrow-up",60065),bell:(0,i.register)("bell",60066),bold:(0,i.register)("bold",60067),book:(0,i.register)("book",60068),bookmark:(0,i.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.register)("briefcase",60076),broadcast:(0,i.register)("broadcast",60077),browser:(0,i.register)("browser",60078),bug:(0,i.register)("bug",60079),calendar:(0,i.register)("calendar",60080),caseSensitive:(0,i.register)("case-sensitive",60081),check:(0,i.register)("check",60082),checklist:(0,i.register)("checklist",60083),chevronDown:(0,i.register)("chevron-down",60084),chevronLeft:(0,i.register)("chevron-left",60085),chevronRight:(0,i.register)("chevron-right",60086),chevronUp:(0,i.register)("chevron-up",60087),chromeClose:(0,i.register)("chrome-close",60088),chromeMaximize:(0,i.register)("chrome-maximize",60089),chromeMinimize:(0,i.register)("chrome-minimize",60090),chromeRestore:(0,i.register)("chrome-restore",60091),circleOutline:(0,i.register)("circle-outline",60092),circle:(0,i.register)("circle",60092),debugBreakpointUnverified:(0,i.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.register)("terminal-decoration-incomplete",60092),circleSlash:(0,i.register)("circle-slash",60093),circuitBoard:(0,i.register)("circuit-board",60094),clearAll:(0,i.register)("clear-all",60095),clippy:(0,i.register)("clippy",60096),closeAll:(0,i.register)("close-all",60097),cloudDownload:(0,i.register)("cloud-download",60098),cloudUpload:(0,i.register)("cloud-upload",60099),code:(0,i.register)("code",60100),collapseAll:(0,i.register)("collapse-all",60101),colorMode:(0,i.register)("color-mode",60102),commentDiscussion:(0,i.register)("comment-discussion",60103),creditCard:(0,i.register)("credit-card",60105),dash:(0,i.register)("dash",60108),dashboard:(0,i.register)("dashboard",60109),database:(0,i.register)("database",60110),debugContinue:(0,i.register)("debug-continue",60111),debugDisconnect:(0,i.register)("debug-disconnect",60112),debugPause:(0,i.register)("debug-pause",60113),debugRestart:(0,i.register)("debug-restart",60114),debugStart:(0,i.register)("debug-start",60115),debugStepInto:(0,i.register)("debug-step-into",60116),debugStepOut:(0,i.register)("debug-step-out",60117),debugStepOver:(0,i.register)("debug-step-over",60118),debugStop:(0,i.register)("debug-stop",60119),debug:(0,i.register)("debug",60120),deviceCameraVideo:(0,i.register)("device-camera-video",60121),deviceCamera:(0,i.register)("device-camera",60122),deviceMobile:(0,i.register)("device-mobile",60123),diffAdded:(0,i.register)("diff-added",60124),diffIgnored:(0,i.register)("diff-ignored",60125),diffModified:(0,i.register)("diff-modified",60126),diffRemoved:(0,i.register)("diff-removed",60127),diffRenamed:(0,i.register)("diff-renamed",60128),diff:(0,i.register)("diff",60129),diffSidebyside:(0,i.register)("diff-sidebyside",60129),discard:(0,i.register)("discard",60130),editorLayout:(0,i.register)("editor-layout",60131),emptyWindow:(0,i.register)("empty-window",60132),exclude:(0,i.register)("exclude",60133),extensions:(0,i.register)("extensions",60134),eyeClosed:(0,i.register)("eye-closed",60135),fileBinary:(0,i.register)("file-binary",60136),fileCode:(0,i.register)("file-code",60137),fileMedia:(0,i.register)("file-media",60138),filePdf:(0,i.register)("file-pdf",60139),fileSubmodule:(0,i.register)("file-submodule",60140),fileSymlinkDirectory:(0,i.register)("file-symlink-directory",60141),fileSymlinkFile:(0,i.register)("file-symlink-file",60142),fileZip:(0,i.register)("file-zip",60143),files:(0,i.register)("files",60144),filter:(0,i.register)("filter",60145),flame:(0,i.register)("flame",60146),foldDown:(0,i.register)("fold-down",60147),foldUp:(0,i.register)("fold-up",60148),fold:(0,i.register)("fold",60149),folderActive:(0,i.register)("folder-active",60150),folderOpened:(0,i.register)("folder-opened",60151),gear:(0,i.register)("gear",60152),gift:(0,i.register)("gift",60153),gistSecret:(0,i.register)("gist-secret",60154),gist:(0,i.register)("gist",60155),gitCommit:(0,i.register)("git-commit",60156),gitCompare:(0,i.register)("git-compare",60157),compareChanges:(0,i.register)("compare-changes",60157),gitMerge:(0,i.register)("git-merge",60158),githubAction:(0,i.register)("github-action",60159),githubAlt:(0,i.register)("github-alt",60160),globe:(0,i.register)("globe",60161),grabber:(0,i.register)("grabber",60162),graph:(0,i.register)("graph",60163),gripper:(0,i.register)("gripper",60164),heart:(0,i.register)("heart",60165),home:(0,i.register)("home",60166),horizontalRule:(0,i.register)("horizontal-rule",60167),hubot:(0,i.register)("hubot",60168),inbox:(0,i.register)("inbox",60169),issueReopened:(0,i.register)("issue-reopened",60171),issues:(0,i.register)("issues",60172),italic:(0,i.register)("italic",60173),jersey:(0,i.register)("jersey",60174),json:(0,i.register)("json",60175),kebabVertical:(0,i.register)("kebab-vertical",60176),key:(0,i.register)("key",60177),law:(0,i.register)("law",60178),lightbulbAutofix:(0,i.register)("lightbulb-autofix",60179),linkExternal:(0,i.register)("link-external",60180),link:(0,i.register)("link",60181),listOrdered:(0,i.register)("list-ordered",60182),listUnordered:(0,i.register)("list-unordered",60183),liveShare:(0,i.register)("live-share",60184),loading:(0,i.register)("loading",60185),location:(0,i.register)("location",60186),mailRead:(0,i.register)("mail-read",60187),mail:(0,i.register)("mail",60188),markdown:(0,i.register)("markdown",60189),megaphone:(0,i.register)("megaphone",60190),mention:(0,i.register)("mention",60191),milestone:(0,i.register)("milestone",60192),gitPullRequestMilestone:(0,i.register)("git-pull-request-milestone",60192),mortarBoard:(0,i.register)("mortar-board",60193),move:(0,i.register)("move",60194),multipleWindows:(0,i.register)("multiple-windows",60195),mute:(0,i.register)("mute",60196),noNewline:(0,i.register)("no-newline",60197),note:(0,i.register)("note",60198),octoface:(0,i.register)("octoface",60199),openPreview:(0,i.register)("open-preview",60200),package:(0,i.register)("package",60201),paintcan:(0,i.register)("paintcan",60202),pin:(0,i.register)("pin",60203),play:(0,i.register)("play",60204),run:(0,i.register)("run",60204),plug:(0,i.register)("plug",60205),preserveCase:(0,i.register)("preserve-case",60206),preview:(0,i.register)("preview",60207),project:(0,i.register)("project",60208),pulse:(0,i.register)("pulse",60209),question:(0,i.register)("question",60210),quote:(0,i.register)("quote",60211),radioTower:(0,i.register)("radio-tower",60212),reactions:(0,i.register)("reactions",60213),references:(0,i.register)("references",60214),refresh:(0,i.register)("refresh",60215),regex:(0,i.register)("regex",60216),remoteExplorer:(0,i.register)("remote-explorer",60217),remote:(0,i.register)("remote",60218),remove:(0,i.register)("remove",60219),replaceAll:(0,i.register)("replace-all",60220),replace:(0,i.register)("replace",60221),repoClone:(0,i.register)("repo-clone",60222),repoForcePush:(0,i.register)("repo-force-push",60223),repoPull:(0,i.register)("repo-pull",60224),repoPush:(0,i.register)("repo-push",60225),report:(0,i.register)("report",60226),requestChanges:(0,i.register)("request-changes",60227),rocket:(0,i.register)("rocket",60228),rootFolderOpened:(0,i.register)("root-folder-opened",60229),rootFolder:(0,i.register)("root-folder",60230),rss:(0,i.register)("rss",60231),ruby:(0,i.register)("ruby",60232),saveAll:(0,i.register)("save-all",60233),saveAs:(0,i.register)("save-as",60234),save:(0,i.register)("save",60235),screenFull:(0,i.register)("screen-full",60236),screenNormal:(0,i.register)("screen-normal",60237),searchStop:(0,i.register)("search-stop",60238),server:(0,i.register)("server",60240),settingsGear:(0,i.register)("settings-gear",60241),settings:(0,i.register)("settings",60242),shield:(0,i.register)("shield",60243),smiley:(0,i.register)("smiley",60244),sortPrecedence:(0,i.register)("sort-precedence",60245),splitHorizontal:(0,i.register)("split-horizontal",60246),splitVertical:(0,i.register)("split-vertical",60247),squirrel:(0,i.register)("squirrel",60248),starFull:(0,i.register)("star-full",60249),starHalf:(0,i.register)("star-half",60250),symbolClass:(0,i.register)("symbol-class",60251),symbolColor:(0,i.register)("symbol-color",60252),symbolConstant:(0,i.register)("symbol-constant",60253),symbolEnumMember:(0,i.register)("symbol-enum-member",60254),symbolField:(0,i.register)("symbol-field",60255),symbolFile:(0,i.register)("symbol-file",60256),symbolInterface:(0,i.register)("symbol-interface",60257),symbolKeyword:(0,i.register)("symbol-keyword",60258),symbolMisc:(0,i.register)("symbol-misc",60259),symbolOperator:(0,i.register)("symbol-operator",60260),symbolProperty:(0,i.register)("symbol-property",60261),wrench:(0,i.register)("wrench",60261),wrenchSubaction:(0,i.register)("wrench-subaction",60261),symbolSnippet:(0,i.register)("symbol-snippet",60262),tasklist:(0,i.register)("tasklist",60263),telescope:(0,i.register)("telescope",60264),textSize:(0,i.register)("text-size",60265),threeBars:(0,i.register)("three-bars",60266),thumbsdown:(0,i.register)("thumbsdown",60267),thumbsup:(0,i.register)("thumbsup",60268),tools:(0,i.register)("tools",60269),triangleDown:(0,i.register)("triangle-down",60270),triangleLeft:(0,i.register)("triangle-left",60271),triangleRight:(0,i.register)("triangle-right",60272),triangleUp:(0,i.register)("triangle-up",60273),twitter:(0,i.register)("twitter",60274),unfold:(0,i.register)("unfold",60275),unlock:(0,i.register)("unlock",60276),unmute:(0,i.register)("unmute",60277),unverified:(0,i.register)("unverified",60278),verified:(0,i.register)("verified",60279),versions:(0,i.register)("versions",60280),vmActive:(0,i.register)("vm-active",60281),vmOutline:(0,i.register)("vm-outline",60282),vmRunning:(0,i.register)("vm-running",60283),watch:(0,i.register)("watch",60284),whitespace:(0,i.register)("whitespace",60285),wholeWord:(0,i.register)("whole-word",60286),window:(0,i.register)("window",60287),wordWrap:(0,i.register)("word-wrap",60288),zoomIn:(0,i.register)("zoom-in",60289),zoomOut:(0,i.register)("zoom-out",60290),listFilter:(0,i.register)("list-filter",60291),listFlat:(0,i.register)("list-flat",60292),listSelection:(0,i.register)("list-selection",60293),selection:(0,i.register)("selection",60293),listTree:(0,i.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.register)("debug-stackframe-active",60297),circleSmallFilled:(0,i.register)("circle-small-filled",60298),debugStackframeDot:(0,i.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.register)("terminal-decoration-mark",60298),debugStackframe:(0,i.register)("debug-stackframe",60299),debugStackframeFocused:(0,i.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.register)("debug-breakpoint-unsupported",60300),symbolString:(0,i.register)("symbol-string",60301),debugReverseContinue:(0,i.register)("debug-reverse-continue",60302),debugStepBack:(0,i.register)("debug-step-back",60303),debugRestartFrame:(0,i.register)("debug-restart-frame",60304),debugAlt:(0,i.register)("debug-alt",60305),callIncoming:(0,i.register)("call-incoming",60306),callOutgoing:(0,i.register)("call-outgoing",60307),menu:(0,i.register)("menu",60308),expandAll:(0,i.register)("expand-all",60309),feedback:(0,i.register)("feedback",60310),gitPullRequestReviewer:(0,i.register)("git-pull-request-reviewer",60310),groupByRefType:(0,i.register)("group-by-ref-type",60311),ungroupByRefType:(0,i.register)("ungroup-by-ref-type",60312),account:(0,i.register)("account",60313),gitPullRequestAssignee:(0,i.register)("git-pull-request-assignee",60313),bellDot:(0,i.register)("bell-dot",60314),debugConsole:(0,i.register)("debug-console",60315),library:(0,i.register)("library",60316),output:(0,i.register)("output",60317),runAll:(0,i.register)("run-all",60318),syncIgnored:(0,i.register)("sync-ignored",60319),pinned:(0,i.register)("pinned",60320),githubInverted:(0,i.register)("github-inverted",60321),serverProcess:(0,i.register)("server-process",60322),serverEnvironment:(0,i.register)("server-environment",60323),pass:(0,i.register)("pass",60324),issueClosed:(0,i.register)("issue-closed",60324),stopCircle:(0,i.register)("stop-circle",60325),playCircle:(0,i.register)("play-circle",60326),record:(0,i.register)("record",60327),debugAltSmall:(0,i.register)("debug-alt-small",60328),vmConnect:(0,i.register)("vm-connect",60329),cloud:(0,i.register)("cloud",60330),merge:(0,i.register)("merge",60331),export:(0,i.register)("export",60332),graphLeft:(0,i.register)("graph-left",60333),magnet:(0,i.register)("magnet",60334),notebook:(0,i.register)("notebook",60335),redo:(0,i.register)("redo",60336),checkAll:(0,i.register)("check-all",60337),pinnedDirty:(0,i.register)("pinned-dirty",60338),passFilled:(0,i.register)("pass-filled",60339),circleLargeFilled:(0,i.register)("circle-large-filled",60340),circleLarge:(0,i.register)("circle-large",60341),circleLargeOutline:(0,i.register)("circle-large-outline",60341),combine:(0,i.register)("combine",60342),gather:(0,i.register)("gather",60342),table:(0,i.register)("table",60343),variableGroup:(0,i.register)("variable-group",60344),typeHierarchy:(0,i.register)("type-hierarchy",60345),typeHierarchySub:(0,i.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.register)("git-pull-request-create",60348),runAbove:(0,i.register)("run-above",60349),runBelow:(0,i.register)("run-below",60350),notebookTemplate:(0,i.register)("notebook-template",60351),debugRerun:(0,i.register)("debug-rerun",60352),workspaceTrusted:(0,i.register)("workspace-trusted",60353),workspaceUntrusted:(0,i.register)("workspace-untrusted",60354),workspaceUnknown:(0,i.register)("workspace-unknown",60355),terminalCmd:(0,i.register)("terminal-cmd",60356),terminalDebian:(0,i.register)("terminal-debian",60357),terminalLinux:(0,i.register)("terminal-linux",60358),terminalPowershell:(0,i.register)("terminal-powershell",60359),terminalTmux:(0,i.register)("terminal-tmux",60360),terminalUbuntu:(0,i.register)("terminal-ubuntu",60361),terminalBash:(0,i.register)("terminal-bash",60362),arrowSwap:(0,i.register)("arrow-swap",60363),copy:(0,i.register)("copy",60364),personAdd:(0,i.register)("person-add",60365),filterFilled:(0,i.register)("filter-filled",60366),wand:(0,i.register)("wand",60367),debugLineByLine:(0,i.register)("debug-line-by-line",60368),inspect:(0,i.register)("inspect",60369),layers:(0,i.register)("layers",60370),layersDot:(0,i.register)("layers-dot",60371),layersActive:(0,i.register)("layers-active",60372),compass:(0,i.register)("compass",60373),compassDot:(0,i.register)("compass-dot",60374),compassActive:(0,i.register)("compass-active",60375),azure:(0,i.register)("azure",60376),issueDraft:(0,i.register)("issue-draft",60377),gitPullRequestClosed:(0,i.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.register)("git-pull-request-draft",60379),debugAll:(0,i.register)("debug-all",60380),debugCoverage:(0,i.register)("debug-coverage",60381),runErrors:(0,i.register)("run-errors",60382),folderLibrary:(0,i.register)("folder-library",60383),debugContinueSmall:(0,i.register)("debug-continue-small",60384),beakerStop:(0,i.register)("beaker-stop",60385),graphLine:(0,i.register)("graph-line",60386),graphScatter:(0,i.register)("graph-scatter",60387),pieChart:(0,i.register)("pie-chart",60388),bracket:(0,i.register)("bracket",60175),bracketDot:(0,i.register)("bracket-dot",60389),bracketError:(0,i.register)("bracket-error",60390),lockSmall:(0,i.register)("lock-small",60391),azureDevops:(0,i.register)("azure-devops",60392),verifiedFilled:(0,i.register)("verified-filled",60393),newline:(0,i.register)("newline",60394),layout:(0,i.register)("layout",60395),layoutActivitybarLeft:(0,i.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.register)("layout-panel-left",60398),layoutPanelCenter:(0,i.register)("layout-panel-center",60399),layoutPanelJustify:(0,i.register)("layout-panel-justify",60400),layoutPanelRight:(0,i.register)("layout-panel-right",60401),layoutPanel:(0,i.register)("layout-panel",60402),layoutSidebarLeft:(0,i.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.register)("layout-sidebar-right",60404),layoutStatusbar:(0,i.register)("layout-statusbar",60405),layoutMenubar:(0,i.register)("layout-menubar",60406),layoutCentered:(0,i.register)("layout-centered",60407),target:(0,i.register)("target",60408),indent:(0,i.register)("indent",60409),recordSmall:(0,i.register)("record-small",60410),errorSmall:(0,i.register)("error-small",60411),terminalDecorationError:(0,i.register)("terminal-decoration-error",60411),arrowCircleDown:(0,i.register)("arrow-circle-down",60412),arrowCircleLeft:(0,i.register)("arrow-circle-left",60413),arrowCircleRight:(0,i.register)("arrow-circle-right",60414),arrowCircleUp:(0,i.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.register)("layout-sidebar-left-off",60418),blank:(0,i.register)("blank",60419),heartFilled:(0,i.register)("heart-filled",60420),map:(0,i.register)("map",60421),mapHorizontal:(0,i.register)("map-horizontal",60421),foldHorizontal:(0,i.register)("fold-horizontal",60421),mapFilled:(0,i.register)("map-filled",60422),mapHorizontalFilled:(0,i.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.register)("fold-horizontal-filled",60422),circleSmall:(0,i.register)("circle-small",60423),bellSlash:(0,i.register)("bell-slash",60424),bellSlashDot:(0,i.register)("bell-slash-dot",60425),commentUnresolved:(0,i.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.register)("search-fuzzy",60429),commentDraft:(0,i.register)("comment-draft",60430),send:(0,i.register)("send",60431),sparkle:(0,i.register)("sparkle",60432),insert:(0,i.register)("insert",60433),mic:(0,i.register)("mic",60434),thumbsdownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsupFilled:(0,i.register)("thumbsup-filled",60436),coffee:(0,i.register)("coffee",60437),snake:(0,i.register)("snake",60438),game:(0,i.register)("game",60439),vr:(0,i.register)("vr",60440),chip:(0,i.register)("chip",60441),piano:(0,i.register)("piano",60442),music:(0,i.register)("music",60443),micFilled:(0,i.register)("mic-filled",60444),repoFetch:(0,i.register)("repo-fetch",60445),copilot:(0,i.register)("copilot",60446),lightbulbSparkle:(0,i.register)("lightbulb-sparkle",60447),robot:(0,i.register)("robot",60448),sparkleFilled:(0,i.register)("sparkle-filled",60449),diffSingle:(0,i.register)("diff-single",60450),diffMultiple:(0,i.register)("diff-multiple",60451),surroundWith:(0,i.register)("surround-with",60452),share:(0,i.register)("share",60453),gitStash:(0,i.register)("git-stash",60454),gitStashApply:(0,i.register)("git-stash-apply",60455),gitStashPop:(0,i.register)("git-stash-pop",60456),vscode:(0,i.register)("vscode",60457),vscodeInsiders:(0,i.register)("vscode-insiders",60458),codeOss:(0,i.register)("code-oss",60459),runCoverage:(0,i.register)("run-coverage",60460),runAllCoverage:(0,i.register)("run-all-coverage",60461),coverage:(0,i.register)("coverage",60462),githubProject:(0,i.register)("github-project",60463),mapVertical:(0,i.register)("map-vertical",60464),foldVertical:(0,i.register)("fold-vertical",60464),mapVerticalFilled:(0,i.register)("map-vertical-filled",60465),foldVerticalFilled:(0,i.register)("fold-vertical-filled",60465),goToSearch:(0,i.register)("go-to-search",60466),percentage:(0,i.register)("percentage",60467),sortPercentage:(0,i.register)("sort-percentage",60467),attach:(0,i.register)("attach",60468)}}),define(le[78],ce([0,1,110,147]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=P;function P(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,i.register)("dialog-error","error"),dialogWarning:(0,i.register)("dialog-warning","warning"),dialogInfo:(0,i.register)("dialog-info","info"),dialogClose:(0,i.register)("dialog-close","close"),treeItemExpanded:(0,i.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.register)("tree-filter-clear","close"),treeItemLoading:(0,i.register)("tree-item-loading","loading"),menuSelection:(0,i.register)("menu-selection","check"),menuSubmenu:(0,i.register)("menu-submenu","chevron-right"),menuBarMore:(0,i.register)("menubar-more","more"),scrollbarButtonLeft:(0,i.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.register)("toolbar-more","more"),quickInputBack:(0,i.register)("quick-input-back","arrow-left"),dropDownButton:(0,i.register)("drop-down-button",60084),symbolCustomColor:(0,i.register)("symbol-customcolor",60252),exportIcon:(0,i.register)("export",60332),workspaceUnspecified:(0,i.register)("workspace-unspecified",60355),newLine:(0,i.register)("newline",60394),thumbsDownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.register)("thumbsup-filled",60436),gitFetch:(0,i.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.register)("debug-breakpoint-pending",60377)},e.Codicon={...s.codiconsLibrary,...e.codiconsDerived}}),define(le[35],ce([0,1,12]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=s,e.deepFreeze=P,e.cloneAndChange=A,e.mixin=b,e.equals=l,e.safeStringify=d,e.distinct=f,e.getCaseInsensitive=g,e.filter=y,e.getAllPropertyNames=h,e.getAllMethodNames=m,e.createProxyObject=p,e.mapValues=v;function s(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const E=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([I,o])=>{E[I]=o&&typeof o=="object"?s(o):o}),E}function P(w){if(!w||typeof w!="object")return w;const E=[w];for(;E.length>0;){const I=E.shift();Object.freeze(I);for(const o in I)if(k.call(I,o)){const t=I[o];typeof t=="object"&&!Object.isFrozen(t)&&!(0,i.isTypedArray)(t)&&E.push(t)}}return w}const k=Object.prototype.hasOwnProperty;function A(w,E){return R(w,E,new Set)}function R(w,E,I){if((0,i.isUndefinedOrNull)(w))return w;const o=E(w);if(typeof o<"u")return o;if(Array.isArray(w)){const t=[];for(const r of w)t.push(R(r,E,I));return t}if((0,i.isObject)(w)){if(I.has(w))throw new Error("Cannot clone recursive data-structure");I.add(w);const t={};for(const r in w)k.call(w,r)&&(t[r]=R(w[r],E,I));return I.delete(w),t}return w}function b(w,E,I=!0){return(0,i.isObject)(w)?((0,i.isObject)(E)&&Object.keys(E).forEach(o=>{o in w?I&&((0,i.isObject)(w[o])&&(0,i.isObject)(E[o])?b(w[o],E[o],I):w[o]=E[o]):w[o]=E[o]}),w):E}function l(w,E){if(w===E)return!0;if(w==null||E===null||E===void 0||typeof w!=typeof E||typeof w!="object"||Array.isArray(w)!==Array.isArray(E))return!1;let I,o;if(Array.isArray(w)){if(w.length!==E.length)return!1;for(I=0;I<w.length;I++)if(!l(w[I],E[I]))return!1}else{const t=[];for(o in w)t.push(o);t.sort();const r=[];for(o in E)r.push(o);if(r.sort(),!l(t,r))return!1;for(I=0;I<t.length;I++)if(!l(w[t[I]],E[t[I]]))return!1}return!0}function d(w){const E=new Set;return JSON.stringify(w,(I,o)=>{if((0,i.isObject)(o)||Array.isArray(o)){if(E.has(o))return"[Circular]";E.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function f(w,E){const I=Object.create(null);return!w||!E||Object.keys(E).forEach(t=>{const r=w[t],a=E[t];l(r,a)||(I[t]=a)}),I}function g(w,E){const I=E.toLowerCase(),o=Object.keys(w).find(t=>t.toLowerCase()===I);return o?w[o]:w[E]}function y(w,E){const I=Object.create(null);for(const[o,t]of Object.entries(w))E(o,t)&&(I[o]=t);return I}function h(w){let E=[];for(;Object.prototype!==w;)E=E.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return E}function m(w){const E=[];for(const I of h(w))typeof w[I]=="function"&&E.push(I);return E}function p(w,E){const I=t=>function(){const r=Array.prototype.slice.call(arguments,0);return E(t,r)},o={};for(const t of w)o[t]=I(t);return o}function v(w,E){const I={};for(const[o,t]of Object.entries(w))I[o]=E(t,o);return I}}),define(le[111],ce([0,1,78]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=P;var s;(function(A){function R(b){return b&&typeof b=="object"&&typeof b.id=="string"}A.isThemeColor=R})(s||(e.ThemeColor=s={}));function P(A){return{id:A}}var k;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(w){const E=R.exec(w.id);if(!E)return b(i.Codicon.error);const[,I,o]=E,t=["codicon","codicon-"+I];return o&&t.push("codicon-modifier-"+o.substring(1)),t}A.asClassNameArray=b;function l(w){return b(w).join(" ")}A.asClassName=l;function d(w){return"."+b(w).join(".")}A.asCSSSelector=d;function f(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(typeof w.color>"u"||s.isThemeColor(w.color))}A.isThemeIcon=f;const g=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function y(w){const E=g.exec(w);if(!E)return;const[,I]=E;return{id:I}}A.fromString=y;function h(w){return{id:w}}A.fromId=h;function m(w,E){let I=w.id;const o=I.lastIndexOf("~");return o!==-1&&(I=I.substring(0,o)),E&&(I=`${I}~${E}`),{id:I}}A.modify=m;function p(w){const E=w.id.lastIndexOf("~");if(E!==-1)return w.id.substring(E+1)}A.getModifier=p;function v(w,E){return w.id===E.id&&w.color?.id===E.color?.id}A.isEqual=v})(k||(e.ThemeIcon=k={}))}),define(le[148],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=s,e.toUint32=P;var i;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(e.Constants=i={}));function s(k){return k<0?0:k>i.MAX_UINT_8?i.MAX_UINT_8:k|0}function P(k){return k<0?0:k>i.MAX_UINT_32?i.MAX_UINT_32:k|0}}),define(le[26],ce([0,1,145,39,65,148]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=A,e.format=b,e.format2=d,e.htmlAttributeEncodeValue=f,e.escape=g,e.escapeRegExpCharacters=y,e.count=h,e.truncate=m,e.truncateMiddle=p,e.trim=v,e.ltrim=w,e.rtrim=E,e.convertSimple2RegExpPattern=I,e.stripWildcards=o,e.createRegExp=t,e.regExpLeadsToEndlessLoop=r,e.splitLines=a,e.splitLinesIncludeSeparators=n,e.firstNonWhitespaceIndex=c,e.getLeadingWhitespace=u,e.lastNonWhitespaceIndex=S,e.replaceAsync=D,e.compare=L,e.compareSubstring=M,e.compareIgnoreCase=T,e.compareSubstringIgnoreCase=C,e.isAsciiDigit=F,e.isLowerAsciiLetter=x,e.isUpperAsciiLetter=U,e.equalsIgnoreCase=z,e.startsWithIgnoreCase=re,e.commonPrefixLength=ie,e.commonSuffixLength=oe,e.isHighSurrogate=G,e.isLowSurrogate=te,e.computeCodePoint=q,e.getNextCodePoint=O,e.nextCharLength=j,e.prevCharLength=he,e.getCharContainingOffset=ne,e.charCount=J,e.containsRTL=N,e.isBasicASCII=X,e.containsUnusualLineTerminators=Q,e.isFullWidthCharacter=$,e.isEmojiImprecise=ee,e.lcut=fe,e.forAnsiStringParts=we,e.removeAnsiEscapeCodes=Re,e.removeAnsiEscapeCodesFromPrompt=De,e.startsWithUTF8BOM=ke,e.stripUTF8BOM=pe,e.fuzzyContains=Y,e.containsUppercaseCharacter=ue,e.uppercaseFirstLetter=de,e.getNLines=Se,e.singleLetterHash=Me,e.getGraphemeBreakType=Ne,e.getLeftDeleteOffset=Xe;function A(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}const R=/{(\d+)}/g;function b(Z,...ge){return ge.length===0?Z:Z.replace(R,function(ve,ye){const Oe=parseInt(ye,10);return isNaN(Oe)||Oe<0||Oe>=ge.length?ve:ge[Oe]})}const l=/{([^}]+)}/g;function d(Z,ge){return Object.keys(ge).length===0?Z:Z.replace(l,(ve,ye)=>ge[ye]??ve)}function f(Z){return Z.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function g(Z){return Z.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function y(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function h(Z,ge){let ve=0,ye=Z.indexOf(ge);for(;ye!==-1;)ve++,ye=Z.indexOf(ge,ye+ge.length);return ve}function m(Z,ge,ve="\u2026"){return Z.length<=ge?Z:`${Z.substr(0,ge)}${ve}`}function p(Z,ge,ve="\u2026"){if(Z.length<=ge)return Z;const ye=Math.ceil(ge/2)-ve.length/2,Oe=Math.floor(ge/2)-ve.length/2;return`${Z.substr(0,ye)}${ve}${Z.substr(Z.length-Oe)}`}function v(Z,ge=" "){const ve=w(Z,ge);return E(ve,ge)}function w(Z,ge){if(!Z||!ge)return Z;const ve=ge.length;if(ve===0||Z.length===0)return Z;let ye=0;for(;Z.indexOf(ge,ye)===ye;)ye=ye+ve;return Z.substring(ye)}function E(Z,ge){if(!Z||!ge)return Z;const ve=ge.length,ye=Z.length;if(ve===0||ye===0)return Z;let Oe=ye,xe=-1;for(;xe=Z.lastIndexOf(ge,Oe-1),!(xe===-1||xe+ve!==Oe);){if(xe===0)return"";Oe=xe}return Z.substring(0,Oe)}function I(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function o(Z){return Z.replace(/\*/g,"")}function t(Z,ge,ve={}){if(!Z)throw new Error("Cannot create regex from empty string");ge||(Z=y(Z)),ve.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let ye="";return ve.global&&(ye+="g"),ve.matchCase||(ye+="i"),ve.multiline&&(ye+="m"),ve.unicode&&(ye+="u"),new RegExp(Z,ye)}function r(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}function a(Z){return Z.split(/\r\n|\r|\n/)}function n(Z){const ge=[],ve=Z.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(ve.length/2);ye++)ge.push(ve[2*ye]+(ve[2*ye+1]??""));return ge}function c(Z){for(let ge=0,ve=Z.length;ge<ve;ge++){const ye=Z.charCodeAt(ge);if(ye!==s.CharCode.Space&&ye!==s.CharCode.Tab)return ge}return-1}function u(Z,ge=0,ve=Z.length){for(let ye=ge;ye<ve;ye++){const Oe=Z.charCodeAt(ye);if(Oe!==s.CharCode.Space&&Oe!==s.CharCode.Tab)return Z.substring(ge,ye)}return Z.substring(ge,ve)}function S(Z,ge=Z.length-1){for(let ve=ge;ve>=0;ve--){const ye=Z.charCodeAt(ve);if(ye!==s.CharCode.Space&&ye!==s.CharCode.Tab)return ve}return-1}function D(Z,ge,ve){const ye=[];let Oe=0;for(const xe of Z.matchAll(ge)){if(ye.push(Z.slice(Oe,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Oe=xe.index+xe[0].length,ye.push(ve(xe[0],...xe.slice(1),xe.index,Z,xe.groups))}return ye.push(Z.slice(Oe)),Promise.all(ye).then(xe=>xe.join(""))}function L(Z,ge){return Z<ge?-1:Z>ge?1:0}function M(Z,ge,ve=0,ye=Z.length,Oe=0,xe=ge.length){for(;ve<ye&&Oe<xe;ve++,Oe++){const nt=Z.charCodeAt(ve),st=ge.charCodeAt(Oe);if(nt<st)return-1;if(nt>st)return 1}const Ye=ye-ve,at=xe-Oe;return Ye<at?-1:Ye>at?1:0}function T(Z,ge){return C(Z,ge,0,Z.length,0,ge.length)}function C(Z,ge,ve=0,ye=Z.length,Oe=0,xe=ge.length){for(;ve<ye&&Oe<xe;ve++,Oe++){let nt=Z.charCodeAt(ve),st=ge.charCodeAt(Oe);if(nt===st)continue;if(nt>=128||st>=128)return M(Z.toLowerCase(),ge.toLowerCase(),ve,ye,Oe,xe);x(nt)&&(nt-=32),x(st)&&(st-=32);const Ze=nt-st;if(Ze!==0)return Ze}const Ye=ye-ve,at=xe-Oe;return Ye<at?-1:Ye>at?1:0}function F(Z){return Z>=s.CharCode.Digit0&&Z<=s.CharCode.Digit9}function x(Z){return Z>=s.CharCode.a&&Z<=s.CharCode.z}function U(Z){return Z>=s.CharCode.A&&Z<=s.CharCode.Z}function z(Z,ge){return Z.length===ge.length&&C(Z,ge)===0}function re(Z,ge){const ve=ge.length;return ge.length>Z.length?!1:C(Z,ge,0,ve)===0}function ie(Z,ge){const ve=Math.min(Z.length,ge.length);let ye;for(ye=0;ye<ve;ye++)if(Z.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return ve}function oe(Z,ge){const ve=Math.min(Z.length,ge.length);let ye;const Oe=Z.length-1,xe=ge.length-1;for(ye=0;ye<ve;ye++)if(Z.charCodeAt(Oe-ye)!==ge.charCodeAt(xe-ye))return ye;return ve}function G(Z){return 55296<=Z&&Z<=56319}function te(Z){return 56320<=Z&&Z<=57343}function q(Z,ge){return(Z-55296<<10)+(ge-56320)+65536}function O(Z,ge,ve){const ye=Z.charCodeAt(ve);if(G(ye)&&ve+1<ge){const Oe=Z.charCodeAt(ve+1);if(te(Oe))return q(ye,Oe)}return ye}function B(Z,ge){const ve=Z.charCodeAt(ge-1);if(te(ve)&&ge>1){const ye=Z.charCodeAt(ge-2);if(G(ye))return q(ye,ve)}return ve}class V{get offset(){return this._offset}constructor(ge,ve=0){this._str=ge,this._len=ge.length,this._offset=ve}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=B(this._str,this._offset);return this._offset-=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=O(this._str,this._len,this._offset);return this._offset+=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=V;class ae{get offset(){return this._iterator.offset}constructor(ge,ve=0){this._iterator=new V(ge,ve)}nextGraphemeLength(){const ge=Ue.getInstance(),ve=this._iterator,ye=ve.offset;let Oe=ge.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const xe=ve.offset,Ye=ge.getGraphemeBreakType(ve.nextCodePoint());if(_e(Oe,Ye)){ve.setOffset(xe);break}Oe=Ye}return ve.offset-ye}prevGraphemeLength(){const ge=Ue.getInstance(),ve=this._iterator,ye=ve.offset;let Oe=ge.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const xe=ve.offset,Ye=ge.getGraphemeBreakType(ve.prevCodePoint());if(_e(Ye,Oe)){ve.setOffset(xe);break}Oe=Ye}return ye-ve.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ae;function j(Z,ge){return new ae(Z,ge).nextGraphemeLength()}function he(Z,ge){return new ae(Z,ge).prevGraphemeLength()}function ne(Z,ge){ge>0&&te(Z.charCodeAt(ge))&&ge--;const ve=ge+j(Z,ge);return[ve-he(Z,ve),ve]}function J(Z){const ge=new ae(Z);let ve=0;for(;!ge.eol();)ve++,ge.nextGraphemeLength();return ve}let _;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(Z){return _||(_=W()),_.test(Z)}const H=/^[\t\n\r\x20-\x7E]*$/;function X(Z){return H.test(Z)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Q(Z){return e.UNUSUAL_LINE_TERMINATORS.test(Z)}function $(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}function ee(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}function fe(Z,ge,ve=""){const ye=Z.trimStart();if(ye.length<ge)return ye;const Oe=/\b/g;let xe=0;for(;Oe.test(ye)&&!(ye.length-Oe.lastIndex<ge);)xe=Oe.lastIndex,Oe.lastIndex+=1;return xe===0?ye:ve+ye.substring(xe).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(Z){let ge=0;for(const ve of Z.matchAll(me))ge!==ve.index&&(yield{isCode:!1,str:Z.substring(ge,ve.index)}),yield{isCode:!0,str:ve[0]},ge=ve.index+ve[0].length;ge!==Z.length&&(yield{isCode:!1,str:Z.substring(ge)})}function Re(Z){return Z&&(Z=Z.replace(me,"")),Z}const Pe=/\\\[.*?\\\]/g;function De(Z){return Re(Z).replace(Pe,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(s.CharCode.UTF8_BOM);function ke(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===s.CharCode.UTF8_BOM)}function pe(Z){return ke(Z)?Z.substr(1):Z}function Y(Z,ge){if(!Z||!ge||Z.length<ge.length)return!1;const ve=ge.length,ye=Z.toLowerCase();let Oe=0,xe=-1;for(;Oe<ve;){const Ye=ye.indexOf(ge[Oe],xe+1);if(Ye<0)return!1;xe=Ye,Oe++}return!0}function ue(Z,ge=!1){return Z?(ge&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}function de(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}function Se(Z,ge=1){if(ge===0)return"";let ve=-1;do ve=Z.indexOf(`
`,ve+1),ge--;while(ge>0&&ve>=0);return ve===-1?Z:(Z[ve-1]==="\r"&&ve--,Z.substr(0,ve))}function Me(Z){const ge=s.CharCode.Z-s.CharCode.A+1;return Z=Z%(2*ge),Z<ge?String.fromCharCode(s.CharCode.a+Z):String.fromCharCode(s.CharCode.A+Z-ge)}function Ne(Z){return Ue.getInstance().getGraphemeBreakType(Z)}function _e(Z,ge){return Z===Le.Other?ge!==Le.Extend&&ge!==Le.SpacingMark:Z===Le.CR&&ge===Le.LF?!1:Z===Le.Control||Z===Le.CR||Z===Le.LF||ge===Le.Control||ge===Le.CR||ge===Le.LF?!0:!(Z===Le.L&&(ge===Le.L||ge===Le.V||ge===Le.LV||ge===Le.LVT)||(Z===Le.LV||Z===Le.V)&&(ge===Le.V||ge===Le.T)||(Z===Le.LVT||Z===Le.T)&&ge===Le.T||ge===Le.Extend||ge===Le.ZWJ||ge===Le.SpacingMark||Z===Le.Prepend||Z===Le.ZWJ&&ge===Le.Extended_Pictographic||Z===Le.Regional_Indicator&&ge===Le.Regional_Indicator)}var Le;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Ue{static{this._INSTANCE=null}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}constructor(){this._data=Ve()}getGraphemeBreakType(ge){if(ge<32)return ge===s.CharCode.LineFeed?Le.LF:ge===s.CharCode.CarriageReturn?Le.CR:Le.Control;if(ge<127)return Le.Other;const ve=this._data,ye=ve.length/3;let Oe=1;for(;Oe<=ye;)if(ge<ve[3*Oe])Oe=2*Oe;else if(ge>ve[3*Oe+1])Oe=2*Oe+1;else return ve[3*Oe+2];return Le.Other}}function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Xe(Z,ge){if(Z===0)return 0;const ve=ze(Z,ge);if(ve!==void 0)return ve;const ye=new V(ge,Z);return ye.prevCodePoint(),ye.offset}function ze(Z,ge){const ve=new V(ge,Z);let ye=ve.prevCodePoint();for(;Qe(ye)||ye===Ke.emojiVariantSelector||ye===Ke.enclosingKeyCap;){if(ve.offset===0)return;ye=ve.prevCodePoint()}if(!ee(ye))return;let Oe=ve.offset;return Oe>0&&ve.prevCodePoint()===Ke.zwj&&(Oe=ve.offset),Oe}function Qe(Z){return 127995<=Z&&Z<=127999}var Ke;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Ke||(Ke={})),e.noBreakWhitespace="\xA0";class Ge{static{this.ambiguousCharacterData=new P.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new i.LRUCachedFunction({getCacheKey:JSON.stringify},ge=>{function ve(Ze){const lt=new Map;for(let ot=0;ot<Ze.length;ot+=2)lt.set(Ze[ot],Ze[ot+1]);return lt}function ye(Ze,lt){const ot=new Map(Ze);for(const[ut,dt]of lt)ot.set(ut,dt);return ot}function Oe(Ze,lt){if(!Ze)return lt;const ot=new Map;for(const[ut,dt]of Ze)lt.has(ut)&&ot.set(ut,dt);return ot}const xe=this.ambiguousCharacterData.value;let Ye=ge.filter(Ze=>!Ze.startsWith("_")&&Ze in xe);Ye.length===0&&(Ye=["_default"]);let at;for(const Ze of Ye){const lt=ve(xe[Ze]);at=Oe(at,lt)}const nt=ve(xe._common),st=ye(nt,at);return new Ge(st)})}static getInstance(ge){return Ge.cache.get(Array.from(ge))}static{this._locales=new P.Lazy(()=>Object.keys(Ge.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ge._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}containsAmbiguousCharacter(ge){for(let ve=0;ve<ge.length;ve++){const ye=ge.codePointAt(ve);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ge;class Fe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Fe.getRawData())),this._data}static isInvisibleCharacter(ge){return Fe.getData().has(ge)}static containsInvisibleCharacter(ge){for(let ve=0;ve<ge.length;ve++){const ye=ge.codePointAt(ve);if(typeof ye=="number"&&Fe.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Fe.getData()}}e.InvisibleCharacters=Fe}),define(le[47],ce([0,1,26]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=s,e.doHash=P,e.numberHash=k,e.stringHash=R,e.toHexString=m;function s(v){return P(v,0)}function P(v,w){switch(typeof v){case"object":return v===null?k(349,w):Array.isArray(v)?b(v,w):l(v,w);case"string":return R(v,w);case"boolean":return A(v,w);case"number":return k(v,w);case"undefined":return k(937,w);default:return k(617,w)}}function k(v,w){return(w<<5)-w+v|0}function A(v,w){return k(v?433:863,w)}function R(v,w){w=k(149417,w);for(let E=0,I=v.length;E<I;E++)w=k(v.charCodeAt(E),w);return w}function b(v,w){return w=k(104579,w),v.reduce((E,I)=>P(I,E),w)}function l(v,w){return w=k(181387,w),Object.keys(v).sort().reduce((E,I)=>(E=R(I,E),P(v[I],E)),w)}class d{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=P(w,this._value),this._value}}e.Hasher=d;var f;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(f||(f={}));function g(v,w,E=32){const I=E-w,o=~((1<<I)-1);return(v<<w|(o&v)>>>I)>>>0}function y(v,w=0,E=v.byteLength,I=0){for(let o=0;o<E;o++)v[w+o]=I}function h(v,w,E="0"){for(;v.length<w;)v=E+v;return v}function m(v,w=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(E=>E.toString(16).padStart(2,"0")).join(""):h((v>>>0).toString(16),w/4)}class p{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(f.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const E=w.length;if(E===0)return;const I=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,r,a;for(t!==0?(r=t,a=-1,t=0):(r=w.charCodeAt(0),a=0);;){let n=r;if(i.isHighSurrogate(r))if(a+1<E){const c=w.charCodeAt(a+1);i.isLowSurrogate(c)?(a++,n=i.computeCodePoint(r,c)):n=f.UNICODE_REPLACEMENT}else{t=r;break}else i.isLowSurrogate(r)&&(n=f.UNICODE_REPLACEMENT);if(o=this._push(I,o,n),a++,a<E)r=w.charCodeAt(a);else break}this._buffLen=o,this._leftoverHighSurrogate=t}_push(w,E,I){return I<128?w[E++]=I:I<2048?(w[E++]=192|(I&1984)>>>6,w[E++]=128|(I&63)>>>0):I<65536?(w[E++]=224|(I&61440)>>>12,w[E++]=128|(I&4032)>>>6,w[E++]=128|(I&63)>>>0):(w[E++]=240|(I&1835008)>>>18,w[E++]=128|(I&258048)>>>12,w[E++]=128|(I&4032)>>>6,w[E++]=128|(I&63)>>>0),E>=f.BLOCK_SIZE&&(this._step(),E-=f.BLOCK_SIZE,this._totalLen+=f.BLOCK_SIZE,w[0]=w[f.BLOCK_SIZE+0],w[1]=w[f.BLOCK_SIZE+1],w[2]=w[f.BLOCK_SIZE+2]),E}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,f.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=p._bigBlock32,E=this._buffDV;for(let S=0;S<64;S+=4)w.setUint32(S,E.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)w.setUint32(S,g(w.getUint32(S-12,!1)^w.getUint32(S-32,!1)^w.getUint32(S-56,!1)^w.getUint32(S-64,!1),1),!1);let I=this._h0,o=this._h1,t=this._h2,r=this._h3,a=this._h4,n,c,u;for(let S=0;S<80;S++)S<20?(n=o&t|~o&r,c=1518500249):S<40?(n=o^t^r,c=1859775393):S<60?(n=o&t|o&r|t&r,c=2400959708):(n=o^t^r,c=3395469782),u=g(I,5)+n+a+c+w.getUint32(S*4,!1)&4294967295,a=r,r=t,t=g(o,30),o=I,I=u;this._h0=this._h0+I&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=p}),define(le[79],ce([0,1,26]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var s;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(s||(s={})),function(P){const k="error",A="warning",R="warn",b="info",l="ignore";function d(g){return g?i.equalsIgnoreCase(k,g)?P.Error:i.equalsIgnoreCase(A,g)||i.equalsIgnoreCase(R,g)?P.Warning:i.equalsIgnoreCase(b,g)?P.Info:P.Ignore:P.Ignore}P.fromValue=d;function f(g){switch(g){case P.Error:return k;case P.Warning:return A;case P.Info:return b;default:return l}}P.toString=f}(s||(s={})),e.default=s}),define(le[61],ce([0,1,22,39,26]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this._value="",this._pos=0}reset(h){return this._value=h,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(h){const m=h.charCodeAt(0),p=this._value.charCodeAt(this._pos);return m-p}value(){return this._value[this._pos]}}e.StringIterator=k;class A{constructor(h=!0){this._caseSensitive=h}reset(h){return this._value=h,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let h=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===s.CharCode.Period)if(h)this._from++;else break;else h=!1;return this}cmp(h){return this._caseSensitive?(0,P.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class R{constructor(h=!0,m=!0){this._splitOnBackslash=h,this._caseSensitive=m}reset(h){this._from=0,this._to=0,this._value=h,this._valueLen=h.length;for(let m=h.length-1;m>=0;m--,this._valueLen--){const p=this._value.charCodeAt(m);if(!(p===s.CharCode.Slash||this._splitOnBackslash&&p===s.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let h=!0;for(;this._to<this._valueLen;this._to++){const m=this._value.charCodeAt(this._to);if(m===s.CharCode.Slash||this._splitOnBackslash&&m===s.CharCode.Backslash)if(h)this._from++;else break;else h=!1}return this}cmp(h){return this._caseSensitive?(0,P.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var b;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(b||(b={}));class l{constructor(h,m){this._ignorePathCasing=h,this._ignoreQueryAndFragment=m,this._states=[],this._stateIdx=0}reset(h){return this._value=h,this._states=[],this._value.scheme&&this._states.push(b.Scheme),this._value.authority&&this._states.push(b.Authority),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(h)),this._pathIterator.reset(h.path),this._pathIterator.value()&&this._states.push(b.Path)),this._ignoreQueryAndFragment(h)||(this._value.query&&this._states.push(b.Query),this._value.fragment&&this._states.push(b.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===b.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===b.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(h){if(this._states[this._stateIdx]===b.Scheme)return(0,P.compareIgnoreCase)(h,this._value.scheme);if(this._states[this._stateIdx]===b.Authority)return(0,P.compareIgnoreCase)(h,this._value.authority);if(this._states[this._stateIdx]===b.Path)return this._pathIterator.cmp(h);if(this._states[this._stateIdx]===b.Query)return(0,P.compare)(h,this._value.query);if(this._states[this._stateIdx]===b.Fragment)return(0,P.compare)(h,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===b.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===b.Authority)return this._value.authority;if(this._states[this._stateIdx]===b.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===b.Query)return this._value.query;if(this._states[this._stateIdx]===b.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=l;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(f||(f={}));class g{static forUris(h=()=>!1,m=()=>!1){return new g(new l(h,m))}static forPaths(h=!1){return new g(new R(void 0,!h))}static forStrings(){return new g(new k)}static forConfigKeys(){return new g(new A)}constructor(h){this._iter=h}clear(){this._root=void 0}fill(h,m){if(m){const p=m.slice(0);(0,i.shuffle)(p);for(const v of p)this.set(v,h)}else{const p=h.slice(0);(0,i.shuffle)(p);for(const v of p)this.set(v[0],v[1])}}set(h,m){const p=this._iter.reset(h);let v;this._root||(this._root=new d,this._root.segment=p.value());const w=[];for(v=this._root;;){const I=p.cmp(v.segment);if(I>0)v.left||(v.left=new d,v.left.segment=p.value()),w.push([f.Left,v]),v=v.left;else if(I<0)v.right||(v.right=new d,v.right.segment=p.value()),w.push([f.Right,v]),v=v.right;else if(p.hasNext())p.next(),v.mid||(v.mid=new d,v.mid.segment=p.value()),w.push([f.Mid,v]),v=v.mid;else break}const E=v.value;v.value=m,v.key=h;for(let I=w.length-1;I>=0;I--){const o=w[I][1];o.updateHeight();const t=o.balanceFactor();if(t<-1||t>1){const r=w[I][0],a=w[I+1][0];if(r===f.Right&&a===f.Right)w[I][1]=o.rotateLeft();else if(r===f.Left&&a===f.Left)w[I][1]=o.rotateRight();else if(r===f.Right&&a===f.Left)o.right=w[I+1][1]=w[I+1][1].rotateRight(),w[I][1]=o.rotateLeft();else if(r===f.Left&&a===f.Right)o.left=w[I+1][1]=w[I+1][1].rotateLeft(),w[I][1]=o.rotateRight();else throw new Error;if(I>0)switch(w[I-1][0]){case f.Left:w[I-1][1].left=w[I][1];break;case f.Right:w[I-1][1].right=w[I][1];break;case f.Mid:w[I-1][1].mid=w[I][1];break}else this._root=w[0][1]}}return E}get(h){return this._getNode(h)?.value}_getNode(h){const m=this._iter.reset(h);let p=this._root;for(;p;){const v=m.cmp(p.segment);if(v>0)p=p.left;else if(v<0)p=p.right;else if(m.hasNext())m.next(),p=p.mid;else break}return p}has(h){const m=this._getNode(h);return!(m?.value===void 0&&m?.mid===void 0)}delete(h){return this._delete(h,!1)}deleteSuperstr(h){return this._delete(h,!0)}_delete(h,m){const p=this._iter.reset(h),v=[];let w=this._root;for(;w;){const E=p.cmp(w.segment);if(E>0)v.push([f.Left,w]),w=w.left;else if(E<0)v.push([f.Right,w]),w=w.right;else if(p.hasNext())p.next(),v.push([f.Mid,w]),w=w.mid;else break}if(w){if(m?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const E=this._min(w.right);if(E.key){const{key:I,value:o,segment:t}=E;this._delete(E.key,!1),w.key=I,w.value=o,w.segment=t}}else{const E=w.left??w.right;if(v.length>0){const[I,o]=v[v.length-1];switch(I){case f.Left:o.left=E;break;case f.Mid:o.mid=E;break;case f.Right:o.right=E;break}}else this._root=E}for(let E=v.length-1;E>=0;E--){const I=v[E][1];I.updateHeight();const o=I.balanceFactor();if(o>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),v[E][1]=I.rotateLeft()):o<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),v[E][1]=I.rotateRight()),E>0)switch(v[E-1][0]){case f.Left:v[E-1][1].left=v[E][1];break;case f.Right:v[E-1][1].right=v[E][1];break;case f.Mid:v[E-1][1].mid=v[E][1];break}else this._root=v[0][1]}}}_min(h){for(;h.left;)h=h.left;return h}findSubstr(h){const m=this._iter.reset(h);let p=this._root,v;for(;p;){const w=m.cmp(p.segment);if(w>0)p=p.left;else if(w<0)p=p.right;else if(m.hasNext())m.next(),v=p.value||v,p=p.mid;else break}return p&&p.value||v}findSuperstr(h){return this._findSuperstrOrElement(h,!1)}_findSuperstrOrElement(h,m){const p=this._iter.reset(h);let v=this._root;for(;v;){const w=p.cmp(v.segment);if(w>0)v=v.left;else if(w<0)v=v.right;else if(p.hasNext())p.next(),v=v.mid;else return v.mid?this._entries(v.mid):m?v.value:void 0}}hasElementOrSubtree(h){return this._findSuperstrOrElement(h,!0)!==void 0}forEach(h){for(const[m,p]of this)h(p,m)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(h){const m=[];return this._dfsEntries(h,m),m[Symbol.iterator]()}_dfsEntries(h,m){h&&(h.left&&this._dfsEntries(h.left,m),h.value&&m.push([h.key,h.value]),h.mid&&this._dfsEntries(h.mid,m),h.right&&this._dfsEntries(h.right,m))}_isBalanced(){const h=m=>{if(!m)return!0;const p=m.balanceFactor();return p<-1||p>1?!1:h(m.left)&&h(m.right)};return h(this._root)}}e.TernarySearchTree=g}),define(le[33],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=s;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function s(P){return i.test(P)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(R){for(let b=0;b<R.length;b++)R[b]=Math.floor(Math.random()*256);return R};const k=new Uint8Array(16),A=[];for(let R=0;R<256;R++)A.push(R.toString(16).padStart(2,"0"));return function(){P(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let b=0,l="";return l+=A[k[b++]],l+=A[k[b++]],l+=A[k[b++]],l+=A[k[b++]],l+="-",l+=A[k[b++]],l+=A[k[b++]],l+="-",l+=A[k[b++]],l+=A[k[b++]],l+="-",l+=A[k[b++]],l+=A[k[b++]],l+="-",l+=A[k[b++]],l+=A[k[b++]],l+=A[k[b++]],l+=A[k[b++]],l+=A[k[b++]],l+=A[k[b++]],l}}()}),define(le[149],ce([0,1,91,44,89]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=k;async function k(A,R){if(await new Promise((d,f)=>{const g=s.createReadStream(A),y=i.createHash("sha256");g.pipe(y);const h=(0,P.createSingleCallFunction)((m,p)=>{g.removeAllListeners(),y.removeAllListeners(),m?f(m):d(p)});g.once("error",h),g.once("end",h),y.once("error",h),y.once("data",m=>h(void 0,m.toString("hex")))})!==R)throw new Error("Hash mismatch")}}),define(le[150],ce([0,1,27]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=k;const s=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(A){const R=A.replace(/\-/g,":").toLowerCase();return!s.has(R)}function k(){const A=(0,i.networkInterfaces)();for(const R in A){const b=A[R];if(b){for(const{mac:l}of b)if(P(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[112],ce([0,1,92]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=s,e.findFreePortFaster=k;function s(R,b,l,d=1){let f=!1;return new Promise(g=>{const y=setTimeout(()=>{if(!f)return f=!0,g(0)},l);P(R,b,d,h=>{if(!f)return f=!0,clearTimeout(y),g(h)})})}function P(R,b,l,d){if(b===0)return d(0);const f=new i.Socket;f.once("connect",()=>(A(f),P(R+l,b-1,l,d))),f.once("data",()=>{}),f.once("error",g=>(A(f),g.code!=="ECONNREFUSED"?P(R+l,b-1,l,d):d(R))),f.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(R,b,l,d="127.0.0.1"){let f=!1,g,y=1;const h=i.createServer({pauseOnConnect:!0});function m(p,v){f||(f=!0,h.removeAllListeners(),h.close(),g&&clearTimeout(g),v(p))}return new Promise(p=>{g=setTimeout(()=>{m(0,p)},l),h.on("listening",()=>{m(R,p)}),h.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&y<b?(R++,y++,h.listen(R,d)):m(0,p)}),h.on("close",()=>{m(0,p)}),h.listen(R,d)})}function A(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),function(){function K(){function e(){return process.uncHostAllowlist}function i(b){const l=new Set;if(Array.isArray(b))for(const d of b)typeof d=="string"&&l.add(d);return Array.from(l)}function s(){const b=e();return b?Array.from(b):[]}function P(b){if(process.platform!=="win32")return;const l=e();if(l)if(typeof b=="string")l.add(b.toLowerCase());else for(const d of i(b))P(d)}function k(b){if(typeof b!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let d;for(const f of l){if(b.indexOf(f)!==0)continue;const y=b.indexOf("\\",f.length);if(y===-1)continue;const h=b.substring(f.length,y);if(h){d=h;break}}return d}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function R(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:s,addUNCHostToAllowlist:P,getUNCHost:k,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:R}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[151],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(le[152],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class i{constructor(P,k){this.sender=P,this.onMessage=k}send(P){try{this.sender.send("vscode:message",P.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=i}),define(le[153],ce([11,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(le[154],ce([0,1,153]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=l,e.getDurationString=d,e.toLocalISOString=f;const s=60,P=s*60,k=P*24,A=k*7,R=k*30,b=k*365;function l(g,y,h,m){typeof g!="number"&&(g=g.getTime());const p=Math.round((new Date().getTime()-g)/1e3);if(p<-30)return(0,i.localize)(0,null,l(new Date().getTime()+p*1e3,!1));if(!m&&p<30)return(0,i.localize)(1,null);let v;return p<s?(v=p,y?v===1?h?(0,i.localize)(2,null,v):(0,i.localize)(3,null,v):h?(0,i.localize)(4,null,v):(0,i.localize)(5,null,v):v===1?h?(0,i.localize)(6,null,v):(0,i.localize)(7,null,v):h?(0,i.localize)(8,null,v):(0,i.localize)(9,null,v)):p<P?(v=Math.floor(p/s),y?v===1?h?(0,i.localize)(10,null,v):(0,i.localize)(11,null,v):h?(0,i.localize)(12,null,v):(0,i.localize)(13,null,v):v===1?h?(0,i.localize)(14,null,v):(0,i.localize)(15,null,v):h?(0,i.localize)(16,null,v):(0,i.localize)(17,null,v)):p<k?(v=Math.floor(p/P),y?v===1?h?(0,i.localize)(18,null,v):(0,i.localize)(19,null,v):h?(0,i.localize)(20,null,v):(0,i.localize)(21,null,v):v===1?h?(0,i.localize)(22,null,v):(0,i.localize)(23,null,v):h?(0,i.localize)(24,null,v):(0,i.localize)(25,null,v)):p<A?(v=Math.floor(p/k),y?v===1?(0,i.localize)(26,null,v):(0,i.localize)(27,null,v):v===1?(0,i.localize)(28,null,v):(0,i.localize)(29,null,v)):p<R?(v=Math.floor(p/A),y?v===1?h?(0,i.localize)(30,null,v):(0,i.localize)(31,null,v):h?(0,i.localize)(32,null,v):(0,i.localize)(33,null,v):v===1?h?(0,i.localize)(34,null,v):(0,i.localize)(35,null,v):h?(0,i.localize)(36,null,v):(0,i.localize)(37,null,v)):p<b?(v=Math.floor(p/R),y?v===1?h?(0,i.localize)(38,null,v):(0,i.localize)(39,null,v):h?(0,i.localize)(40,null,v):(0,i.localize)(41,null,v):v===1?h?(0,i.localize)(42,null,v):(0,i.localize)(43,null,v):h?(0,i.localize)(44,null,v):(0,i.localize)(45,null,v)):(v=Math.floor(p/b),y?v===1?h?(0,i.localize)(46,null,v):(0,i.localize)(47,null,v):h?(0,i.localize)(48,null,v):(0,i.localize)(49,null,v):v===1?h?(0,i.localize)(50,null,v):(0,i.localize)(51,null,v):h?(0,i.localize)(52,null,v):(0,i.localize)(53,null,v))}function d(g,y){const h=Math.abs(g/1e3);return h<1?y?(0,i.localize)(54,null,g):(0,i.localize)(55,null,g):h<s?y?(0,i.localize)(56,null,Math.round(g)/1e3):(0,i.localize)(57,null,Math.round(g)/1e3):h<P?y?(0,i.localize)(58,null,Math.round(g/(1e3*s))):(0,i.localize)(59,null,Math.round(g/(1e3*s))):h<k?y?(0,i.localize)(60,null,Math.round(g/(1e3*P))):(0,i.localize)(61,null,Math.round(g/(1e3*P))):(0,i.localize)(62,null,Math.round(g/(1e3*k)))}function f(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[155],ce([11,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(le[48],ce([0,1,22,12,155]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=b,e.isErrorWithActions=l,e.createErrorWithActions=d;function k(f,g){return g&&(f.stack||f.stacktrace)?P.localize(0,null,R(f),A(f.stack)||A(f.stacktrace)):R(f)}function A(f){return Array.isArray(f)?f.join(`
`):f}function R(f){return f.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${f.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?P.localize(1,null,f.message):f.message||P.localize(2,null)}function b(f=null,g=!1){if(!f)return P.localize(3,null);if(Array.isArray(f)){const y=i.coalesce(f),h=b(y[0],g);return y.length>1?P.localize(4,null,h,y.length):h}if(s.isString(f))return f;if(f.detail){const y=f.detail;if(y.error)return k(y.error,g);if(y.exception)return k(y.exception,g)}return f.stack?k(f,g):f.message?f.message:P.localize(5,null)}function l(f){const g=f;return g instanceof Error&&Array.isArray(g.actions)}function d(f,g){let y;return typeof f=="string"?y=new Error(f):y=f,y.actions=g,y}}),define(le[156],ce([11,10]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(le[157],ce([0,1,156,40]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=P;function P(k){switch(k){case s.ParseErrorCode.InvalidSymbol:return(0,i.localize)(0,null);case s.ParseErrorCode.InvalidNumberFormat:return(0,i.localize)(1,null);case s.ParseErrorCode.PropertyNameExpected:return(0,i.localize)(2,null);case s.ParseErrorCode.ValueExpected:return(0,i.localize)(3,null);case s.ParseErrorCode.ColonExpected:return(0,i.localize)(4,null);case s.ParseErrorCode.CommaExpected:return(0,i.localize)(5,null);case s.ParseErrorCode.CloseBraceExpected:return(0,i.localize)(6,null);case s.ParseErrorCode.CloseBracketExpected:return(0,i.localize)(7,null);case s.ParseErrorCode.EndOfFileExpected:return(0,i.localize)(8,null);default:return""}}}),define(le[158],ce([11,10]),function(K,e){return K.create("vs/base/common/platform",e)}),define(le[4],ce([0,1,158]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=r,e.isLittleEndian=D,e.isBigSurOrNewer=L,e.LANGUAGE_DEFAULT="en";let s=!1,P=!1,k=!1,A=!1,R=!1,b=!1,l=!1,d=!1,f=!1,g=!1,y,h=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT,p,v;const w=globalThis;let E;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?E=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(E=process);const I=typeof E?.versions?.electron=="string",o=I&&E?.type==="renderer";if(typeof E=="object"){s=E.platform==="win32",P=E.platform==="darwin",k=E.platform==="linux",A=k&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,l=I,f=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const M=E.env.VSCODE_NLS_CONFIG;if(M)try{const T=JSON.parse(M),C=T.availableLanguages["*"];y=T.locale,m=T.osLocale,h=C||e.LANGUAGE_DEFAULT,p=T._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!o?(v=navigator.userAgent,s=v.indexOf("Windows")>=0,P=v.indexOf("Macintosh")>=0,d=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=v.indexOf("Linux")>=0,g=v?.indexOf("Mobi")>=0,b=!0,y=i.getConfiguredDefaultLocale(i.localize(0,null))||e.LANGUAGE_DEFAULT,h=y,m=navigator.language):console.error("Unable to resolve platform.");var t;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(M){switch(M){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let a=t.Web;P?a=t.Mac:s?a=t.Windows:k&&(a=t.Linux),e.isWindows=s,e.isMacintosh=P,e.isLinux=k,e.isLinuxSnap=A,e.isNative=R,e.isElectron=l,e.isWeb=b,e.isWebWorker=b&&typeof w.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?w.origin:void 0,e.isIOS=d,e.isMobile=g,e.isCI=f,e.platform=a,e.userAgent=v,e.language=h;var n;(function(M){function T(){return e.language}M.value=T;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}M.isDefaultVariant=C;function F(){return e.language==="en"}M.isDefault=F})(n||(e.Language=n={})),e.locale=y,e.platformLocale=m,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof w.postMessage=="function"&&!w.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const M=[];w.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let F=0,x=M.length;F<x;F++){const U=M[F];if(U.id===C.data.vscodeScheduleAsyncWork){M.splice(F,1),U.callback();return}}});let T=0;return C=>{const F=++T;M.push({id:F,callback:C}),w.postMessage({vscodeScheduleAsyncWork:F},"*")}}return M=>setTimeout(M)})();var c;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=P||d?c.Macintosh:s?c.Windows:c.Linux;let u=!0,S=!1;function D(){if(!S){S=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,u=new Uint16Array(M.buffer)[0]===513}return u}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function L(M){return parseFloat(M)>=20}}),define(le[36],ce([0,1,4]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let s;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const k=P.process;s={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?s={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:s={get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=s.cwd,e.env=s.env,e.platform=s.platform,e.arch=s.arch}),define(le[9],ce([0,1,36]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const s=65,P=97,k=90,A=122,R=46,b=47,l=92,d=58,f=63;class g extends Error{constructor(r,a,n){let c;typeof a=="string"&&a.indexOf("not ")===0?(c="must not be",a=a.replace(/^not /,"")):c="must be";const u=r.indexOf(".")!==-1?"property":"argument";let S=`The "${r}" ${u} ${c} of type ${a}`;S+=`. Received type ${typeof n}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,r){if(t===null||typeof t!="object")throw new g(r,"Object",t)}function h(t,r){if(typeof t!="string")throw new g(r,"string",t)}const m=i.platform==="win32";function p(t){return t===b||t===l}function v(t){return t===b}function w(t){return t>=s&&t<=k||t>=P&&t<=A}function E(t,r,a,n){let c="",u=0,S=-1,D=0,L=0;for(let M=0;M<=t.length;++M){if(M<t.length)L=t.charCodeAt(M);else{if(n(L))break;L=b}if(n(L)){if(!(S===M-1||D===1))if(D===2){if(c.length<2||u!==2||c.charCodeAt(c.length-1)!==R||c.charCodeAt(c.length-2)!==R){if(c.length>2){const T=c.lastIndexOf(a);T===-1?(c="",u=0):(c=c.slice(0,T),u=c.length-1-c.lastIndexOf(a)),S=M,D=0;continue}else if(c.length!==0){c="",u=0,S=M,D=0;continue}}r&&(c+=c.length>0?`${a}..`:"..",u=2)}else c.length>0?c+=`${a}${t.slice(S+1,M)}`:c=t.slice(S+1,M),u=M-S-1;S=M,D=0}else L===R&&D!==-1?++D:D=-1}return c}function I(t,r){y(r,"pathObject");const a=r.dir||r.root,n=r.base||`${r.name||""}${r.ext||""}`;return a?a===r.root?`${a}${n}`:`${a}${t}${n}`:n}e.win32={resolve(...t){let r="",a="",n=!1;for(let c=t.length-1;c>=-1;c--){let u;if(c>=0){if(u=t[c],h(u,"path"),u.length===0)continue}else r.length===0?u=i.cwd():(u=i.env[`=${r}`]||i.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==r.toLowerCase()&&u.charCodeAt(2)===l)&&(u=`${r}\\`));const S=u.length;let D=0,L="",M=!1;const T=u.charCodeAt(0);if(S===1)p(T)&&(D=1,M=!0);else if(p(T))if(M=!0,p(u.charCodeAt(1))){let C=2,F=C;for(;C<S&&!p(u.charCodeAt(C));)C++;if(C<S&&C!==F){const x=u.slice(F,C);for(F=C;C<S&&p(u.charCodeAt(C));)C++;if(C<S&&C!==F){for(F=C;C<S&&!p(u.charCodeAt(C));)C++;(C===S||C!==F)&&(L=`\\\\${x}\\${u.slice(F,C)}`,D=C)}}}else D=1;else w(T)&&u.charCodeAt(1)===d&&(L=u.slice(0,2),D=2,S>2&&p(u.charCodeAt(2))&&(M=!0,D=3));if(L.length>0)if(r.length>0){if(L.toLowerCase()!==r.toLowerCase())continue}else r=L;if(n){if(r.length>0)break}else if(a=`${u.slice(D)}\\${a}`,n=M,M&&r.length>0)break}return a=E(a,!n,"\\",p),n?`${r}\\${a}`:`${r}${a}`||"."},normalize(t){h(t,"path");const r=t.length;if(r===0)return".";let a=0,n,c=!1;const u=t.charCodeAt(0);if(r===1)return v(u)?"\\":t;if(p(u))if(c=!0,p(t.charCodeAt(1))){let D=2,L=D;for(;D<r&&!p(t.charCodeAt(D));)D++;if(D<r&&D!==L){const M=t.slice(L,D);for(L=D;D<r&&p(t.charCodeAt(D));)D++;if(D<r&&D!==L){for(L=D;D<r&&!p(t.charCodeAt(D));)D++;if(D===r)return`\\\\${M}\\${t.slice(L)}\\`;D!==L&&(n=`\\\\${M}\\${t.slice(L,D)}`,a=D)}}}else a=1;else w(u)&&t.charCodeAt(1)===d&&(n=t.slice(0,2),a=2,r>2&&p(t.charCodeAt(2))&&(c=!0,a=3));let S=a<r?E(t.slice(a),!c,"\\",p):"";return S.length===0&&!c&&(S="."),S.length>0&&p(t.charCodeAt(r-1))&&(S+="\\"),n===void 0?c?`\\${S}`:S:c?`${n}\\${S}`:`${n}${S}`},isAbsolute(t){h(t,"path");const r=t.length;if(r===0)return!1;const a=t.charCodeAt(0);return p(a)||r>2&&w(a)&&t.charCodeAt(1)===d&&p(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,a;for(let u=0;u<t.length;++u){const S=t[u];h(S,"path"),S.length>0&&(r===void 0?r=a=S:r+=`\\${S}`)}if(r===void 0)return".";let n=!0,c=0;if(typeof a=="string"&&p(a.charCodeAt(0))){++c;const u=a.length;u>1&&p(a.charCodeAt(1))&&(++c,u>2&&(p(a.charCodeAt(2))?++c:n=!1))}if(n){for(;c<r.length&&p(r.charCodeAt(c));)c++;c>=2&&(r=`\\${r.slice(c)}`)}return e.win32.normalize(r)},relative(t,r){if(h(t,"from"),h(r,"to"),t===r)return"";const a=e.win32.resolve(t),n=e.win32.resolve(r);if(a===n||(t=a.toLowerCase(),r=n.toLowerCase(),t===r))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===l;)c++;let u=t.length;for(;u-1>c&&t.charCodeAt(u-1)===l;)u--;const S=u-c;let D=0;for(;D<r.length&&r.charCodeAt(D)===l;)D++;let L=r.length;for(;L-1>D&&r.charCodeAt(L-1)===l;)L--;const M=L-D,T=S<M?S:M;let C=-1,F=0;for(;F<T;F++){const U=t.charCodeAt(c+F);if(U!==r.charCodeAt(D+F))break;U===l&&(C=F)}if(F!==T){if(C===-1)return n}else{if(M>T){if(r.charCodeAt(D+F)===l)return n.slice(D+F+1);if(F===2)return n.slice(D+F)}S>T&&(t.charCodeAt(c+F)===l?C=F:F===2&&(C=3)),C===-1&&(C=0)}let x="";for(F=c+C+1;F<=u;++F)(F===u||t.charCodeAt(F)===l)&&(x+=x.length===0?"..":"\\..");return D+=C,x.length>0?`${x}${n.slice(D,L)}`:(n.charCodeAt(D)===l&&++D,n.slice(D,L))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.win32.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===l){if(r.charCodeAt(1)===l){const a=r.charCodeAt(2);if(a!==f&&a!==R)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(w(r.charCodeAt(0))&&r.charCodeAt(1)===d&&r.charCodeAt(2)===l)return`\\\\?\\${r}`;return t},dirname(t){h(t,"path");const r=t.length;if(r===0)return".";let a=-1,n=0;const c=t.charCodeAt(0);if(r===1)return p(c)?t:".";if(p(c)){if(a=n=1,p(t.charCodeAt(1))){let D=2,L=D;for(;D<r&&!p(t.charCodeAt(D));)D++;if(D<r&&D!==L){for(L=D;D<r&&p(t.charCodeAt(D));)D++;if(D<r&&D!==L){for(L=D;D<r&&!p(t.charCodeAt(D));)D++;if(D===r)return t;D!==L&&(a=n=D+1)}}}}else w(c)&&t.charCodeAt(1)===d&&(a=r>2&&p(t.charCodeAt(2))?3:2,n=a);let u=-1,S=!0;for(let D=r-1;D>=n;--D)if(p(t.charCodeAt(D))){if(!S){u=D;break}}else S=!1;if(u===-1){if(a===-1)return".";u=a}return t.slice(0,u)},basename(t,r){r!==void 0&&h(r,"ext"),h(t,"path");let a=0,n=-1,c=!0,u;if(t.length>=2&&w(t.charCodeAt(0))&&t.charCodeAt(1)===d&&(a=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let S=r.length-1,D=-1;for(u=t.length-1;u>=a;--u){const L=t.charCodeAt(u);if(p(L)){if(!c){a=u+1;break}}else D===-1&&(c=!1,D=u+1),S>=0&&(L===r.charCodeAt(S)?--S===-1&&(n=u):(S=-1,n=D))}return a===n?n=D:n===-1&&(n=t.length),t.slice(a,n)}for(u=t.length-1;u>=a;--u)if(p(t.charCodeAt(u))){if(!c){a=u+1;break}}else n===-1&&(c=!1,n=u+1);return n===-1?"":t.slice(a,n)},extname(t){h(t,"path");let r=0,a=-1,n=0,c=-1,u=!0,S=0;t.length>=2&&t.charCodeAt(1)===d&&w(t.charCodeAt(0))&&(r=n=2);for(let D=t.length-1;D>=r;--D){const L=t.charCodeAt(D);if(p(L)){if(!u){n=D+1;break}continue}c===-1&&(u=!1,c=D+1),L===R?a===-1?a=D:S!==1&&(S=1):a!==-1&&(S=-1)}return a===-1||c===-1||S===0||S===1&&a===c-1&&a===n+1?"":t.slice(a,c)},format:I.bind(null,"\\"),parse(t){h(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const a=t.length;let n=0,c=t.charCodeAt(0);if(a===1)return p(c)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(p(c)){if(n=1,p(t.charCodeAt(1))){let C=2,F=C;for(;C<a&&!p(t.charCodeAt(C));)C++;if(C<a&&C!==F){for(F=C;C<a&&p(t.charCodeAt(C));)C++;if(C<a&&C!==F){for(F=C;C<a&&!p(t.charCodeAt(C));)C++;C===a?n=C:C!==F&&(n=C+1)}}}}else if(w(c)&&t.charCodeAt(1)===d){if(a<=2)return r.root=r.dir=t,r;if(n=2,p(t.charCodeAt(2))){if(a===3)return r.root=r.dir=t,r;n=3}}n>0&&(r.root=t.slice(0,n));let u=-1,S=n,D=-1,L=!0,M=t.length-1,T=0;for(;M>=n;--M){if(c=t.charCodeAt(M),p(c)){if(!L){S=M+1;break}continue}D===-1&&(L=!1,D=M+1),c===R?u===-1?u=M:T!==1&&(T=1):u!==-1&&(T=-1)}return D!==-1&&(u===-1||T===0||T===1&&u===D-1&&u===S+1?r.base=r.name=t.slice(S,D):(r.name=t.slice(S,u),r.base=t.slice(S,D),r.ext=t.slice(u,D))),S>0&&S!==n?r.dir=t.slice(0,S-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(m){const t=/\\/g;return()=>{const r=i.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>i.cwd()})();e.posix={resolve(...t){let r="",a=!1;for(let n=t.length-1;n>=-1&&!a;n--){const c=n>=0?t[n]:o();h(c,"path"),c.length!==0&&(r=`${c}/${r}`,a=c.charCodeAt(0)===b)}return r=E(r,!a,"/",v),a?`/${r}`:r.length>0?r:"."},normalize(t){if(h(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===b,a=t.charCodeAt(t.length-1)===b;return t=E(t,!r,"/",v),t.length===0?r?"/":a?"./":".":(a&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return h(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let r;for(let a=0;a<t.length;++a){const n=t[a];h(n,"path"),n.length>0&&(r===void 0?r=n:r+=`/${n}`)}return r===void 0?".":e.posix.normalize(r)},relative(t,r){if(h(t,"from"),h(r,"to"),t===r||(t=e.posix.resolve(t),r=e.posix.resolve(r),t===r))return"";const a=1,n=t.length,c=n-a,u=1,S=r.length-u,D=c<S?c:S;let L=-1,M=0;for(;M<D;M++){const C=t.charCodeAt(a+M);if(C!==r.charCodeAt(u+M))break;C===b&&(L=M)}if(M===D)if(S>D){if(r.charCodeAt(u+M)===b)return r.slice(u+M+1);if(M===0)return r.slice(u+M)}else c>D&&(t.charCodeAt(a+M)===b?L=M:M===0&&(L=0));let T="";for(M=a+L+1;M<=n;++M)(M===n||t.charCodeAt(M)===b)&&(T+=T.length===0?"..":"/..");return`${T}${r.slice(u+L)}`},toNamespacedPath(t){return t},dirname(t){if(h(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===b;let a=-1,n=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===b){if(!n){a=c;break}}else n=!1;return a===-1?r?"/":".":r&&a===1?"//":t.slice(0,a)},basename(t,r){r!==void 0&&h(r,"ext"),h(t,"path");let a=0,n=-1,c=!0,u;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let S=r.length-1,D=-1;for(u=t.length-1;u>=0;--u){const L=t.charCodeAt(u);if(L===b){if(!c){a=u+1;break}}else D===-1&&(c=!1,D=u+1),S>=0&&(L===r.charCodeAt(S)?--S===-1&&(n=u):(S=-1,n=D))}return a===n?n=D:n===-1&&(n=t.length),t.slice(a,n)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===b){if(!c){a=u+1;break}}else n===-1&&(c=!1,n=u+1);return n===-1?"":t.slice(a,n)},extname(t){h(t,"path");let r=-1,a=0,n=-1,c=!0,u=0;for(let S=t.length-1;S>=0;--S){const D=t.charCodeAt(S);if(D===b){if(!c){a=S+1;break}continue}n===-1&&(c=!1,n=S+1),D===R?r===-1?r=S:u!==1&&(u=1):r!==-1&&(u=-1)}return r===-1||n===-1||u===0||u===1&&r===n-1&&r===a+1?"":t.slice(r,n)},format:I.bind(null,"/"),parse(t){h(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const a=t.charCodeAt(0)===b;let n;a?(r.root="/",n=1):n=0;let c=-1,u=0,S=-1,D=!0,L=t.length-1,M=0;for(;L>=n;--L){const T=t.charCodeAt(L);if(T===b){if(!D){u=L+1;break}continue}S===-1&&(D=!1,S=L+1),T===R?c===-1?c=L:M!==1&&(M=1):c!==-1&&(M=-1)}if(S!==-1){const T=u===0&&a?1:u;c===-1||M===0||M===1&&c===S-1&&c===u+1?r.base=r.name=t.slice(T,S):(r.name=t.slice(T,c),r.base=t.slice(T,S),r.ext=t.slice(c,S))}return u>0?r.dir=t.slice(0,u-1):a&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m?e.win32.normalize:e.posix.normalize,e.isAbsolute=m?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m?e.win32.join:e.posix.join,e.resolve=m?e.win32.resolve:e.posix.resolve,e.relative=m?e.win32.relative:e.posix.relative,e.dirname=m?e.win32.dirname:e.posix.dirname,e.basename=m?e.win32.basename:e.posix.basename,e.extname=m?e.win32.extname:e.posix.extname,e.format=m?e.win32.format:e.posix.format,e.parse=m?e.win32.parse:e.posix.parse,e.toNamespacedPath=m?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m?e.win32.sep:e.posix.sep,e.delimiter=m?e.win32.delimiter:e.posix.delimiter}),define(le[31],ce([0,1,39,9,4,26,12]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=b,e.toPosixPath=l,e.getRoot=d,e.isUNC=f,e.isValidBasename=m,e.isEqual=p,e.isEqualOrParent=v,e.isWindowsDriveLetter=w,e.sanitizeFilePath=E,e.removeTrailingPathSeparator=I,e.isRootOrDriveLetter=o,e.hasDriveLetter=t,e.getDriveLetter=r,e.indexOfPath=a,e.parseLineAndColumnAware=n,e.randomPath=S;function R(D){return D===i.CharCode.Slash||D===i.CharCode.Backslash}function b(D){return D.replace(/[\\/]/g,s.posix.sep)}function l(D){return D.indexOf("/")===-1&&(D=b(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}function d(D,L=s.posix.sep){if(!D)return"";const M=D.length,T=D.charCodeAt(0);if(R(T)){if(R(D.charCodeAt(1))&&!R(D.charCodeAt(2))){let F=3;const x=F;for(;F<M&&!R(D.charCodeAt(F));F++);if(x!==F&&!R(D.charCodeAt(F+1))){for(F+=1;F<M;F++)if(R(D.charCodeAt(F)))return D.slice(0,F+1).replace(/[\\/]/g,L)}}return L}else if(w(T)&&D.charCodeAt(1)===i.CharCode.Colon)return R(D.charCodeAt(2))?D.slice(0,2)+L:D.slice(0,2);let C=D.indexOf("://");if(C!==-1){for(C+=3;C<M;C++)if(R(D.charCodeAt(C)))return D.slice(0,C+1)}return""}function f(D){if(!P.isWindows||!D||D.length<5)return!1;let L=D.charCodeAt(0);if(L!==i.CharCode.Backslash||(L=D.charCodeAt(1),L!==i.CharCode.Backslash))return!1;let M=2;const T=M;for(;M<D.length&&(L=D.charCodeAt(M),L!==i.CharCode.Backslash);M++);return!(T===M||(L=D.charCodeAt(M+1),isNaN(L)||L===i.CharCode.Backslash))}const g=/[\\/:\*\?"<>\|]/g,y=/[/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(D,L=P.isWindows){const M=L?g:y;return!(!D||D.length===0||/^\s+$/.test(D)||(M.lastIndex=0,M.test(D))||L&&h.test(D)||D==="."||D===".."||L&&D[D.length-1]==="."||L&&D.length!==D.trim().length||D.length>255)}function p(D,L,M){const T=D===L;return!M||T?T:!D||!L?!1:(0,k.equalsIgnoreCase)(D,L)}function v(D,L,M,T=s.sep){if(D===L)return!0;if(!D||!L||L.length>D.length)return!1;if(M){if(!(0,k.startsWithIgnoreCase)(D,L))return!1;if(L.length===D.length)return!0;let F=L.length;return L.charAt(L.length-1)===T&&F--,D.charAt(F)===T}return L.charAt(L.length-1)!==T&&(L+=T),D.indexOf(L)===0}function w(D){return D>=i.CharCode.A&&D<=i.CharCode.Z||D>=i.CharCode.a&&D<=i.CharCode.z}function E(D,L){return P.isWindows&&D.endsWith(":")&&(D+=s.sep),(0,s.isAbsolute)(D)||(D=(0,s.join)(L,D)),D=(0,s.normalize)(D),I(D)}function I(D){return P.isWindows?(D=(0,k.rtrim)(D,s.sep),D.endsWith(":")&&(D+=s.sep)):(D=(0,k.rtrim)(D,s.sep),D||(D=s.sep)),D}function o(D){const L=(0,s.normalize)(D);return P.isWindows?D.length>3?!1:t(L)&&(D.length===2||L.charCodeAt(2)===i.CharCode.Backslash):L===s.posix.sep}function t(D,L=P.isWindows){return L?w(D.charCodeAt(0))&&D.charCodeAt(1)===i.CharCode.Colon:!1}function r(D,L=P.isWindows){return t(D,L)?D[0]:void 0}function a(D,L,M){return L.length>D.length?-1:D===L?0:(M&&(D=D.toLowerCase(),L=L.toLowerCase()),D.indexOf(L))}function n(D){const L=D.split(":");let M,T,C;for(const F of L){const x=Number(F);(0,A.isNumber)(x)?T===void 0?T=x:C===void 0&&(C=x):M=M?[M,F].join(":"):F}if(!M)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:M,line:T!==void 0?T:void 0,column:C!==void 0?C:T!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(D,L,M=8){let T="";for(let F=0;F<M;F++){let x;F===0&&P.isWindows&&!L&&(M===3||M===4)?x=u:x=c,T+=x.charAt(Math.floor(Math.random()*x.length))}let C;return L?C=`${L}-${T}`:C=T,D?(0,s.join)(D,C):C}}),define(le[80],ce([0,1,4]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=k,e.removeDangerousEnvVariables=A;var s;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(s||(e.Source=s={}));var P;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function k(R,...b){const l=b.reduce((g,y)=>(g[y]=!0,g),{}),d=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(g=>!l[g]).forEach(g=>{for(let y=0;y<d.length;y++)if(g.search(d[y])!==-1){delete R[g];break}})}function A(R){R&&(delete R.DEBUG,i.isMacintosh&&delete R.DYLD_LIBRARY_PATH,i.isLinux&&delete R.LD_PRELOAD)}}),define(le[7],ce([0,1,39,90,9,4]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=p,e.uriToFsPath=t;const A=/^\w[\w\d+.-]*$/,R=/^\//,b=/^\/\//;function l(u,S){if(!u.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!A.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!R.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(u,S){return!u&&!S?"file":u}function f(u,S){switch(u){case"https":case"http":case"file":S?S[0]!==y&&(S=y+S):S=y;break}return S}const g="",y="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(S){return S instanceof m?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,D,L,M,T,C=!1){typeof S=="object"?(this.scheme=S.scheme||g,this.authority=S.authority||g,this.path=S.path||g,this.query=S.query||g,this.fragment=S.fragment||g):(this.scheme=d(S,C),this.authority=D||g,this.path=f(this.scheme,L||g),this.query=M||g,this.fragment=T||g,l(this,C))}get fsPath(){return t(this,!1)}with(S){if(!S)return this;let{scheme:D,authority:L,path:M,query:T,fragment:C}=S;return D===void 0?D=this.scheme:D===null&&(D=g),L===void 0?L=this.authority:L===null&&(L=g),M===void 0?M=this.path:M===null&&(M=g),T===void 0?T=this.query:T===null&&(T=g),C===void 0?C=this.fragment:C===null&&(C=g),D===this.scheme&&L===this.authority&&M===this.path&&T===this.query&&C===this.fragment?this:new w(D,L,M,T,C)}static parse(S,D=!1){const L=h.exec(S);return L?new w(L[2]||g,c(L[4]||g),c(L[5]||g),c(L[7]||g),c(L[9]||g),D):new w(g,g,g,g,g)}static file(S){let D=g;if(k.isWindows&&(S=S.replace(/\\/g,y)),S[0]===y&&S[1]===y){const L=S.indexOf(y,2);L===-1?(D=S.substring(2),S=y):(D=S.substring(2,L),S=S.substring(L)||y)}return new w("file",D,S,g,g)}static from(S,D){return new w(S.scheme,S.authority,S.path,S.query,S.fragment,D)}static joinPath(S,...D){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let L;return k.isWindows&&S.scheme==="file"?L=m.file(P.win32.join(t(S,!0),...D)).path:L=P.posix.join(S.path,...D),S.with({path:L})}toString(S=!1){return r(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof m)return S;{const D=new w(S);return D._formatted=S.external??null,D._fsPath=S._sep===v?S.fsPath??null:null,D}}else return S}}e.URI=m;function p(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}const v=k.isWindows?1:void 0;class w extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(S=!1){return S?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const S={$mid:s.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=v),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const E={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function I(u,S,D){let L,M=-1;for(let T=0;T<u.length;T++){const C=u.charCodeAt(T);if(C>=i.CharCode.a&&C<=i.CharCode.z||C>=i.CharCode.A&&C<=i.CharCode.Z||C>=i.CharCode.Digit0&&C<=i.CharCode.Digit9||C===i.CharCode.Dash||C===i.CharCode.Period||C===i.CharCode.Underline||C===i.CharCode.Tilde||S&&C===i.CharCode.Slash||D&&C===i.CharCode.OpenSquareBracket||D&&C===i.CharCode.CloseSquareBracket||D&&C===i.CharCode.Colon)M!==-1&&(L+=encodeURIComponent(u.substring(M,T)),M=-1),L!==void 0&&(L+=u.charAt(T));else{L===void 0&&(L=u.substr(0,T));const F=E[C];F!==void 0?(M!==-1&&(L+=encodeURIComponent(u.substring(M,T)),M=-1),L+=F):M===-1&&(M=T)}}return M!==-1&&(L+=encodeURIComponent(u.substring(M))),L!==void 0?L:u}function o(u){let S;for(let D=0;D<u.length;D++){const L=u.charCodeAt(D);L===i.CharCode.Hash||L===i.CharCode.QuestionMark?(S===void 0&&(S=u.substr(0,D)),S+=E[L]):S!==void 0&&(S+=u[D])}return S!==void 0?S:u}function t(u,S){let D;return u.authority&&u.path.length>1&&u.scheme==="file"?D=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===i.CharCode.Slash&&(u.path.charCodeAt(1)>=i.CharCode.A&&u.path.charCodeAt(1)<=i.CharCode.Z||u.path.charCodeAt(1)>=i.CharCode.a&&u.path.charCodeAt(1)<=i.CharCode.z)&&u.path.charCodeAt(2)===i.CharCode.Colon?S?D=u.path.substr(1):D=u.path[1].toLowerCase()+u.path.substr(2):D=u.path,k.isWindows&&(D=D.replace(/\//g,"\\")),D}function r(u,S){const D=S?o:I;let L="",{scheme:M,authority:T,path:C,query:F,fragment:x}=u;if(M&&(L+=M,L+=":"),(T||M==="file")&&(L+=y,L+=y),T){let U=T.indexOf("@");if(U!==-1){const z=T.substr(0,U);T=T.substr(U+1),U=z.lastIndexOf(":"),U===-1?L+=D(z,!1,!1):(L+=D(z.substr(0,U),!1,!1),L+=":",L+=D(z.substr(U+1),!1,!0)),L+="@"}T=T.toLowerCase(),U=T.lastIndexOf(":"),U===-1?L+=D(T,!1,!0):(L+=D(T.substr(0,U),!1,!0),L+=T.substr(U))}if(C){if(C.length>=3&&C.charCodeAt(0)===i.CharCode.Slash&&C.charCodeAt(2)===i.CharCode.Colon){const U=C.charCodeAt(1);U>=i.CharCode.A&&U<=i.CharCode.Z&&(C=`/${String.fromCharCode(U+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===i.CharCode.Colon){const U=C.charCodeAt(0);U>=i.CharCode.A&&U<=i.CharCode.Z&&(C=`${String.fromCharCode(U+32)}:${C.substr(2)}`)}L+=D(C,!0,!1)}return F&&(L+="?",L+=D(F,!1,!1)),x&&(L+="#",L+=S?x:I(x,!1,!1)),L}function a(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+a(u.substr(3)):u}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(u){return u.match(n)?u.replace(n,S=>a(S)):u}}),define(le[159],ce([0,1,7]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=s,e.parse=P,e.getFirstFrame=k,e.log=R;function s(l){const d=l;return d&&typeof d.type=="string"&&typeof d.severity=="string"}function P(l){const d=[];let f;try{const g=JSON.parse(l.arguments),y=g[g.length-1];y&&y.__$stack&&(g.pop(),f=y.__$stack),d.push(...g)}catch{d.push("Unable to log remote console arguments",l.arguments)}return{args:d,stack:f}}function k(l){if(typeof l!="string")return k(P(l).stack);const d=l;if(d){const f=A(d),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(g&&g.length===4)return{uri:i.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}function A(l){if(!l)return l;const d=l.indexOf(`
`);return d===-1?l:l.substring(0,d)}function R(l,d){const{args:f,stack:g}=P(l),y=typeof f[0]=="string"&&f.length===1;let h=A(g);h&&(h=`(${h.trim()})`);let m=[];if(typeof f[0]=="string"?h&&y?m=[`%c[${d}] %c${f[0]} %c${h}`,b("blue"),b(""),b("grey")]:m=[`%c[${d}] %c${f[0]}`,b("blue"),b(""),...f.slice(1)]:m=[`%c[${d}]%`,b("blue"),...f],h&&!y&&m.push(h),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,m)}function b(l){return`color: ${l}`}}),define(le[81],ce([0,1,17,7,90]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=k,e.parse=A,e.revive=b;function k(l){return JSON.stringify(l,R)}function A(l){let d=JSON.parse(l);return d=b(d),d}function R(l,d){return d instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:d.source,flags:d.flags}:d}function b(l,d=0){if(!l||d>200)return l;if(typeof l=="object"){switch(l.$mid){case P.MarshalledId.Uri:return s.URI.revive(l);case P.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case P.MarshalledId.Date:return new Date(l.source)}if(l instanceof i.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let f=0;f<l.length;++f)l[f]=b(l[f],d+1);else for(const f in l)Object.hasOwnProperty.call(l,f)&&(l[f]=b(l[f],d+1))}return l}}),define(le[13],ce([0,1,16,4,26,7,9]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=b,e.matchesSomeScheme=l,e.getServerRootPath=f;var R;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",h.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.commentsInput="comment",h.codeSetting="code-setting"})(R||(e.Schemas=R={}));function b(h,m){return k.URI.isUri(h)?(0,P.equalsIgnoreCase)(h.scheme,m):(0,P.startsWithIgnoreCase)(h,m+":")}function l(h,...m){return m.some(p=>b(h,p))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class d{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m,p){this._serverRootPath=f(m,p)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return A.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(m,p,v){this._hosts[m]=p,this._ports[m]=v}setConnectionToken(m,p){this._connectionTokens[m]=p}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)try{return this._delegate(m)}catch(o){return i.onUnexpectedError(o),m}const p=m.authority;let v=this._hosts[p];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const w=this._ports[p],E=this._connectionTokens[p];let I=`path=${encodeURIComponent(m.path)}`;return typeof E=="string"&&(I+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),k.URI.from({scheme:s.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${v}:${w}`,path:this._remoteResourcesPath,query:I})}}e.RemoteAuthorities=new d;function f(h,m){return A.posix.join(m??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class g{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(m){const p=this.toUri(m,K);return this.uriToBrowserUri(p)}uriToBrowserUri(m){return m.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(m):m.scheme===R.file&&(s.isNative||s.webWorkerOrigin===`${R.vscodeFileResource}://${g.FALLBACK_AUTHORITY}`)?m.with({scheme:R.vscodeFileResource,authority:m.authority||g.FALLBACK_AUTHORITY,query:null,fragment:null}):m}asFileUri(m){const p=this.toUri(m,K);return this.uriToFileUri(p)}uriToFileUri(m){return m.scheme===R.vscodeFileResource?m.with({scheme:R.file,authority:m.authority!==g.FALLBACK_AUTHORITY?m.authority:null,query:null,fragment:null}):m}toUri(m,p){return k.URI.isUri(m)?m:k.URI.parse(p.toUrl(m))}}e.FileAccess=new g;var y;(function(h){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(m.get("3"));const p="vscode-coi";function v(E){let I;typeof E=="string"?I=new URL(E).searchParams:E instanceof URL?I=E.searchParams:k.URI.isUri(E)&&(I=new URL(E.toString(!0)).searchParams);const o=I?.get(p);if(o)return m.get(o)}h.getHeadersFromQuery=v;function w(E,I,o){if(!globalThis.crossOriginIsolated)return;const t=I&&o?"3":o?"2":"1";E instanceof URLSearchParams?E.set(p,t):E[p]=t}h.addSearchParam=w})(y||(e.COI=y={}))}),define(le[19],ce([0,1,39,31,13,9,4,26,7]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=l,e.distinctParents=f,e.toLocalResource=y;function l(h){return(0,b.uriToFsPath)(h,!0)}class d{constructor(m){this._ignorePathCasing=m}compare(m,p,v=!1){return m===p?0:(0,R.compare)(this.getComparisonKey(m,v),this.getComparisonKey(p,v))}isEqual(m,p,v=!1){return m===p?!0:!m||!p?!1:this.getComparisonKey(m,v)===this.getComparisonKey(p,v)}getComparisonKey(m,p=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,p,v=!1){if(m.scheme===p.scheme){if(m.scheme===P.Schemas.file)return s.isEqualOrParent(l(m),l(p),this._ignorePathCasing(m))&&m.query===p.query&&(v||m.fragment===p.fragment);if((0,e.isEqualAuthority)(m.authority,p.authority))return s.isEqualOrParent(m.path,p.path,this._ignorePathCasing(m),"/")&&m.query===p.query&&(v||m.fragment===p.fragment)}return!1}joinPath(m,...p){return b.URI.joinPath(m,...p)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return k.posix.basename(m.path)}extname(m){return k.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let p;return m.scheme===P.Schemas.file?p=b.URI.file(k.dirname(l(m))).path:(p=k.posix.dirname(m.path),m.authority&&p.length&&p.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${m.toString})) resulted in a relative path`),p="/")),m.with({path:p})}normalizePath(m){if(!m.path.length)return m;let p;return m.scheme===P.Schemas.file?p=b.URI.file(k.normalize(l(m))).path:p=k.posix.normalize(m.path),m.with({path:p})}relativePath(m,p){if(m.scheme!==p.scheme||!(0,e.isEqualAuthority)(m.authority,p.authority))return;if(m.scheme===P.Schemas.file){const E=k.relative(l(m),l(p));return A.isWindows?s.toSlashes(E):E}let v=m.path||"/";const w=p.path||"/";if(this._ignorePathCasing(m)){let E=0;for(const I=Math.min(v.length,w.length);E<I&&!(v.charCodeAt(E)!==w.charCodeAt(E)&&v.charAt(E).toLowerCase()!==w.charAt(E).toLowerCase());E++);v=w.substr(0,E)+v.substr(E)}return k.posix.relative(v,w)}resolvePath(m,p){if(m.scheme===P.Schemas.file){const v=b.URI.file(k.resolve(l(m),p));return m.with({authority:v.authority,path:v.path})}return p=s.toPosixPath(p),m.with({path:k.posix.resolve(m.path,p)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,p){return m===p||m!==void 0&&p!==void 0&&(0,R.equalsIgnoreCase)(m,p)}hasTrailingPathSeparator(m,p=k.sep){if(m.scheme===P.Schemas.file){const v=l(m);return v.length>s.getRoot(v).length&&v[v.length-1]===p}else{const v=m.path;return v.length>1&&v.charCodeAt(v.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,p=k.sep){return(0,e.hasTrailingPathSeparator)(m,p)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,p=k.sep){let v=!1;if(m.scheme===P.Schemas.file){const w=l(m);v=w!==void 0&&w.length===s.getRoot(w).length&&w[w.length-1]===p}else{p="/";const w=m.path;v=w.length===1&&w.charCodeAt(w.length-1)===i.CharCode.Slash}return!v&&!(0,e.hasTrailingPathSeparator)(m,p)?m.with({path:m.path+"/"}):m}}e.ExtUri=d,e.extUri=new d(()=>!1),e.extUriBiasedIgnorePathCase=new d(h=>h.scheme===P.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new d(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function f(h,m){const p=[];for(let v=0;v<h.length;v++){const w=m(h[v]);h.some((E,I)=>I===v?!1:(0,e.isEqualOrParent)(w,m(E)))||p.push(h[v])}return p}var g;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function m(p){const v=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(I=>{const[o,t]=I.split(":");o&&t&&v.set(o,t)});const E=p.path.substring(0,p.path.indexOf(";"));return E&&v.set(h.META_DATA_MIME,E),v}h.parseMetaData=m})(g||(e.DataUri=g={}));function y(h,m,p){if(m){let v=h.path;return v&&v[0]!==k.posix.sep&&(v=k.posix.sep+v),h.with({scheme:p,authority:m,path:v})}return h.with({scheme:p})}}),define(le[8],ce([0,1,23,16,3,2,19,4,146,65]),function(K,e,i,s,P,k,A,R,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=d,e.createCancelablePromise=f,e.raceCancellation=g,e.raceCancellationError=y,e.raceCancellablePromises=h,e.raceTimeout=m,e.asPromise=p,e.promiseWithResolvers=v,e.timeout=u,e.disposableTimeout=S,e.sequence=D,e.first=L,e.firstParallel=M,e.retry=O,e.createCancelableAsyncIterable=H;function d(Q){return!!Q&&typeof Q.then=="function"}function f(Q){const $=new i.CancellationTokenSource,ee=Q($.token),fe=new Promise((me,we)=>{const Re=$.token.onCancellationRequested(()=>{Re.dispose(),we(new s.CancellationError)});Promise.resolve(ee).then(Pe=>{Re.dispose(),$.dispose(),me(Pe)},Pe=>{Re.dispose(),$.dispose(),we(Pe)})});return new class{cancel(){$.cancel(),$.dispose()}then(me,we){return fe.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return fe.finally(me)}}}function g(Q,$,ee){return new Promise((fe,me)=>{const we=$.onCancellationRequested(()=>{we.dispose(),fe(ee)});Q.then(fe,me).finally(()=>we.dispose())})}function y(Q,$){return new Promise((ee,fe)=>{const me=$.onCancellationRequested(()=>{me.dispose(),fe(new s.CancellationError)});Q.then(ee,fe).finally(()=>me.dispose())})}async function h(Q){let $=-1;const ee=Q.map((fe,me)=>fe.then(we=>($=me,we)));try{return await Promise.race(ee)}finally{Q.forEach((fe,me)=>{me!==$&&fe.cancel()})}}function m(Q,$,ee){let fe;const me=setTimeout(()=>{fe?.(void 0),ee?.()},$);return Promise.race([Q.finally(()=>clearTimeout(me)),new Promise(we=>fe=we)])}function p(Q){return new Promise(($,ee)=>{const fe=Q();d(fe)?fe.then($,ee):$(fe)})}function v(){let Q,$;return{promise:new Promise((fe,me)=>{Q=fe,$=me}),resolve:Q,reject:$}}class w{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const ee=()=>{if(this.queuedPromise=null,this.isDisposed)return;const fe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,fe};this.queuedPromise=new Promise(fe=>{this.activePromise.then(ee,ee).then(fe)})}return new Promise((ee,fe)=>{this.queuedPromise.then(ee,fe)})}return this.activePromise=$(),new Promise((ee,fe)=>{this.activePromise.then(me=>{this.activePromise=null,ee(me)},me=>{this.activePromise=null,fe(me)})})}dispose(){this.isDisposed=!0}}e.Throttler=w;class E{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=E;class I{constructor(){this.promiseMap=new Map}queue($,ee){const me=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.promiseMap.get($)===me&&this.promiseMap.delete($)});return this.promiseMap.set($,me),me}}e.SequencerByKey=I;const o=(Q,$)=>{let ee=!0;const fe=setTimeout(()=>{ee=!1,$()},Q);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(fe),ee=!1}}},t=Q=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,Q())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class r{constructor($){this.defaultDelay=$,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,ee=this.defaultDelay){this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((me,we)=>{this.doResolve=me,this.doReject=we}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const me=this.task;return this.task=null,me()}}));const fe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ee===b.MicrotaskDelay?t(fe):o(ee,fe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new s.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=r;class a{constructor($){this.delayer=new r($),this.throttler=new w}trigger($,ee){return this.delayer.trigger(()=>this.throttler.queue($),ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=a;class n{constructor(){this._isOpen=!1,this._promise=new Promise(($,ee)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class c extends n{constructor($){super(),this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function u(Q,$){return $?new Promise((ee,fe)=>{const me=setTimeout(()=>{we.dispose(),ee()},Q),we=$.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),fe(new s.CancellationError)})}):f(ee=>u(Q,ee))}function S(Q,$=0,ee){const fe=setTimeout(()=>{Q(),ee&&me.dispose()},$),me=(0,k.toDisposable)(()=>{clearTimeout(fe),ee?.deleteAndLeak(me)});return ee?.add(me),me}function D(Q){const $=[];let ee=0;const fe=Q.length;function me(){return ee<fe?Q[ee++]():null}function we(Re){Re!=null&&$.push(Re);const Pe=me();return Pe?Pe.then(we):Promise.resolve($)}return Promise.resolve(null).then(we)}function L(Q,$=fe=>!!fe,ee=null){let fe=0;const me=Q.length,we=()=>{if(fe>=me)return Promise.resolve(ee);const Re=Q[fe++];return Promise.resolve(Re()).then(De=>$(De)?Promise.resolve(De):we())};return we()}function M(Q,$=fe=>!!fe,ee=null){if(Q.length===0)return Promise.resolve(ee);let fe=Q.length;const me=()=>{fe=-1;for(const we of Q)we.cancel?.()};return new Promise((we,Re)=>{for(const Pe of Q)Pe.then(De=>{--fe>=0&&$(De)?(me(),we(De)):fe===0&&we(ee)}).catch(De=>{--fe>=0&&(me(),Re(De))})})}class T{constructor($){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new P.Emitter}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue($){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((ee,fe)=>{this.outstandingPromises.push({factory:$,c:ee,e:fe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const ee=$.factory();ee.then($.c,$.e),ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=T;class C extends T{constructor(){super(1)}}e.Queue=C;class F{constructor(){this.sequentializer=new B,this.tasks=0}queue($){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,$())):this.sequentializer.run(this.tasks++,$())}}e.LimitedQueue=F;class x{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const $=new j;return this.drainers.add($),$.p}isDrained(){for(const[,$]of this.queues)if($.size>0)return!1;return!0}queueSize($,ee=A.extUri){const fe=ee.getComparisonKey($);return this.queues.get(fe)?.size??0}queueFor($,ee,fe=A.extUri){const me=fe.getComparisonKey($);let we=this.queues.get(me);if(!we){we=new C;const Re=this.drainListenerCount++,Pe=P.Event.once(we.onDrained)(()=>{we?.dispose(),this.queues.delete(me),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Re),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new k.DisposableMap),this.drainListeners.set(Re,Pe),this.queues.set(me,we)}return we.queue(ee)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const $ of this.drainers)$.complete();this.drainers.clear()}dispose(){for(const[,$]of this.queues)$.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=x;class U{constructor($,ee){this._isDisposed=!1,this._token=-1,typeof $=="function"&&typeof ee=="number"&&this.setIfNotSet($,ee)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,ee){if(this._isDisposed)throw new s.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},ee)}setIfNotSet($,ee){if(this._isDisposed)throw new s.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},ee))}}e.TimeoutTimer=U;class z{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet($,ee,fe=globalThis){if(this.isDisposed)throw new s.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=fe.setInterval(()=>{$()},ee);this.disposable=(0,k.toDisposable)(()=>{fe.clearInterval(me),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=z;class re{constructor($,ee){this.timeoutToken=-1,this.runner=$,this.timeout=ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=re;class ie{constructor($,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ie;class oe extends re{constructor($,ee){super($,ee),this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner?.($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=oe;class G extends k.Disposable{constructor($,ee){super(),this.options=$,this.handler=ee,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.options.maxBufferedWork)return!1}else if(this.pending+$.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ee of $)this.pendingWork.push(ee);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new re(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(Q,$)=>{(0,R.setTimeout0)(()=>{if(ee)return;const fe=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e._runWhenIdle=(Q,$,ee)=>{const fe=Q.requestIdleCallback($,typeof ee=="number"?{timeout:ee}:void 0);let me=!1;return{dispose(){me||(me=!0,Q.cancelIdleCallback(fe))}}},e.runWhenGlobalIdle=Q=>(0,e._runWhenIdle)(globalThis,Q)}();class te{constructor($,ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(fe){this._error=fe}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)($,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=te;class q extends te{constructor($){super(globalThis,$)}}e.GlobalIdleValue=q;async function O(Q,$,ee){let fe;for(let me=0;me<ee;me++)try{return await Q()}catch(we){fe=we,await u($)}throw fe}class B{isRunning($){return typeof $=="number"?this._running?.taskId===$:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run($,ee,fe){return this._running={taskId:$,cancel:()=>fe?.(),promise:ee},ee.then(()=>this.doneRunning($),()=>this.doneRunning($)),ee}doneRunning($){this._running&&$===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const $=this._queued;this._queued=void 0,$.run().then($.promiseResolve,$.promiseReject)}}queue($){if(this._queued)this._queued.run=$;else{const{promise:ee,resolve:fe,reject:me}=v();this._queued={run:$,promise:ee,promiseResolve:fe,promiseReject:me}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=B;class V{constructor($,ee=()=>Date.now()){this.interval=$,this.nowFn=ee,this.lastIncrementTime=0,this.value=0}increment(){const $=this.nowFn();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=V;var ae;(function(Q){Q[Q.Resolved=0]="Resolved",Q[Q.Rejected=1]="Rejected"})(ae||(ae={}));class j{get isRejected(){return this.outcome?.outcome===ae.Rejected}get isResolved(){return this.outcome?.outcome===ae.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ae.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise(($,ee)=>{this.completeCallback=$,this.errorCallback=ee})}complete($){return new Promise(ee=>{this.completeCallback($),this.outcome={outcome:ae.Resolved,value:$},ee()})}error($){return new Promise(ee=>{this.errorCallback($),this.outcome={outcome:ae.Rejected,value:$},ee()})}cancel(){return this.error(new s.CancellationError)}}e.DeferredPromise=j;var he;(function(Q){async function $(fe){let me;const we=await Promise.all(fe.map(Re=>Re.then(Pe=>Pe,Pe=>{me||(me=Pe)})));if(typeof me<"u")throw me;return we}Q.settled=$;function ee(fe){return new Promise(async(me,we)=>{try{await fe(me,we)}catch(Re){we(Re)}})}Q.withAsyncBody=ee})(he||(e.Promises=he={}));class ne{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor($){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=$.then(ee=>(this._value=ee,this._isResolved=!0,ee),ee=>{throw this._error=ee,this._isResolved=!0,ee})}requireValue(){if(!this._isResolved)throw new s.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=ne;class J{constructor($){this._compute=$,this._promise=new l.Lazy(()=>new ne(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=J;var _;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(_||(_={}));class W{static fromArray($){return new W(ee=>{ee.emitMany($)})}static fromPromise($){return new W(async ee=>{ee.emitMany(await $)})}static fromPromises($){return new W(async ee=>{await Promise.all($.map(async fe=>ee.emitOne(await fe)))})}static merge($){return new W(async ee=>{await Promise.all($.map(async fe=>{for await(const me of fe)ee.emitOne(me)}))})}static{this.EMPTY=W.fromArray([])}constructor($,ee){this._state=_.Initial,this._results=[],this._error=null,this._onReturn=ee,this._onStateChanged=new P.Emitter,queueMicrotask(async()=>{const fe={emitOne:me=>this.emitOne(me),emitMany:me=>this.emitMany(me),reject:me=>this.reject(me)};try{await Promise.resolve($(fe)),this.resolve()}catch(me){this.reject(me)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this._state===_.DoneError)throw this._error;if($<this._results.length)return{done:!1,value:this._results[$++]};if(this._state===_.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map($,ee){return new W(async fe=>{for await(const me of $)fe.emitOne(ee(me))})}map($){return W.map(this,$)}static filter($,ee){return new W(async fe=>{for await(const me of $)ee(me)&&fe.emitOne(me)})}filter($){return W.filter(this,$)}static coalesce($){return W.filter($,ee=>!!ee)}coalesce(){return W.coalesce(this)}static async toPromise($){const ee=[];for await(const fe of $)ee.push(fe);return ee}toPromise(){return W.toPromise(this)}emitOne($){this._state===_.Initial&&(this._results.push($),this._onStateChanged.fire())}emitMany($){this._state===_.Initial&&(this._results=this._results.concat($),this._onStateChanged.fire())}resolve(){this._state===_.Initial&&(this._state=_.DoneOK,this._onStateChanged.fire())}reject($){this._state===_.Initial&&(this._state=_.DoneError,this._error=$,this._onStateChanged.fire())}}e.AsyncIterableObject=W;class N extends W{constructor($,ee){super(ee),this._source=$}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=N;function H(Q){const $=new i.CancellationTokenSource,ee=Q($.token);return new N($,async fe=>{const me=$.token.onCancellationRequested(()=>{me.dispose(),$.dispose(),fe.reject(new s.CancellationError)});try{for await(const we of ee){if($.token.isCancellationRequested)return;fe.emitOne(we)}me.dispose(),$.dispose()}catch(we){me.dispose(),$.dispose(),fe.reject(we)}})}class X{constructor($){this._deferred=new j,this._asyncIterable=new W(me=>{if(ee){me.reject(ee);return}return fe&&me.emitMany(fe),this._errorFn=we=>me.reject(we),this._emitFn=we=>me.emitOne(we),this._deferred.p},$);let ee,fe;this._emitFn=me=>{fe||(fe=[]),fe.push(me)},this._errorFn=me=>{ee||(ee=me)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject($){this._errorFn($),this._deferred.complete()}emitOne($){this._emitFn($)}}e.AsyncIterableSource=X}),define(le[113],ce([0,1,22,8,39,31,32,9,4,26]),function(K,e,i,s,P,k,A,R,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=d,e.splitGlobAware=m,e.match=F,e.parse=x,e.isRelativePattern=U,e.getBasenameTerms=z,e.getPathTerms=re,e.patternsEquals=te;function d(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const f="[/\\\\]",g="[^/\\\\]",y=/\//g;function h(q,O){switch(q){case 0:return"";case 1:return`${g}*?`;default:return`(?:${f}|${g}+${f}${O?`|${f}${g}+`:""})*?`}}function m(q,O){if(!q)return[];const B=[];let V=!1,ae=!1,j="";for(const he of q){switch(he){case O:if(!V&&!ae){B.push(j),j="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}j+=he}return j&&B.push(j),B}function p(q){if(!q)return"";let O="";const B=m(q,e.GLOB_SPLIT);if(B.every(V=>V===e.GLOBSTAR))O=".*";else{let V=!1;B.forEach((ae,j)=>{if(ae===e.GLOBSTAR){if(V)return;O+=h(2,j===B.length-1)}else{let he=!1,ne="",J=!1,_="";for(const W of ae){if(W!=="}"&&he){ne+=W;continue}if(J&&(W!=="]"||!_)){let N;W==="-"?N=W:(W==="^"||W==="!")&&!_?N="^":W===e.GLOB_SPLIT?N="":N=(0,l.escapeRegExpCharacters)(W),_+=N;continue}switch(W){case"{":he=!0;continue;case"[":J=!0;continue;case"}":{const H=`(?:${m(ne,",").map(X=>p(X)).join("|")})`;O+=H,he=!1,ne="";break}case"]":{O+="["+_+"]",J=!1,_="";break}case"?":O+=g;continue;case"*":O+=h(1);continue;default:O+=(0,l.escapeRegExpCharacters)(W)}}j<B.length-1&&(B[j+1]!==e.GLOBSTAR||j+2<B.length)&&(O+=f)}V=ae===e.GLOBSTAR})}return O}const v=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,I=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new A.LRUCache(1e4),a=function(){return!1},n=function(){return null};function c(q,O){if(!q)return n;let B;typeof q!="string"?B=q.pattern:B=q,B=B.trim();const V=`${B}_${!!O.trimForExclusions}`;let ae=r.get(V);if(ae)return u(ae,q);let j;return v.test(B)?ae=D(B.substr(4),B):(j=w.exec(S(B,O)))?ae=L(j[1],B):(O.trimForExclusions?I:E).test(B)?ae=M(B,O):(j=o.exec(S(B,O)))?ae=T(j[1].substr(1),B,!0):(j=t.exec(S(B,O)))?ae=T(j[1],B,!1):ae=C(B),r.set(V,ae),u(ae,q)}function u(q,O){if(typeof O=="string")return q;const B=function(V,ae){return(0,k.isEqualOrParent)(V,O.base,!b.isLinux)?q((0,l.ltrim)(V.substr(O.base.length),R.sep),ae):null};return B.allBasenames=q.allBasenames,B.allPaths=q.allPaths,B.basenames=q.basenames,B.patterns=q.patterns,B}function S(q,O){return O.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function D(q,O){return function(B,V){return typeof B=="string"&&B.endsWith(q)?O:null}}function L(q,O){const B=`/${q}`,V=`\\${q}`,ae=function(he,ne){return typeof he!="string"?null:ne?ne===q?O:null:he===q||he.endsWith(B)||he.endsWith(V)?O:null},j=[q];return ae.basenames=j,ae.patterns=[O],ae.allBasenames=j,ae}function M(q,O){const B=G(q.slice(1,-1).split(",").map(ne=>c(ne,O)).filter(ne=>ne!==n),q),V=B.length;if(!V)return n;if(V===1)return B[0];const ae=function(ne,J){for(let _=0,W=B.length;_<W;_++)if(B[_](ne,J))return q;return null},j=B.find(ne=>!!ne.allBasenames);j&&(ae.allBasenames=j.allBasenames);const he=B.reduce((ne,J)=>J.allPaths?ne.concat(J.allPaths):ne,[]);return he.length&&(ae.allPaths=he),ae}function T(q,O,B){const V=R.sep===R.posix.sep,ae=V?q:q.replace(y,R.sep),j=R.sep+ae,he=R.posix.sep+q;let ne;return B?ne=function(J,_){return typeof J=="string"&&(J===ae||J.endsWith(j)||!V&&(J===q||J.endsWith(he)))?O:null}:ne=function(J,_){return typeof J=="string"&&(J===ae||!V&&J===q)?O:null},ne.allPaths=[(B?"*/":"./")+q],ne}function C(q){try{const O=new RegExp(`^${p(q)}$`);return function(B){return O.lastIndex=0,typeof B=="string"&&O.test(B)?q:null}}catch{return n}}function F(q,O,B){return!q||typeof O!="string"?!1:x(q)(O,void 0,B)}function x(q,O={}){if(!q)return a;if(typeof q=="string"||U(q)){const B=c(q,O);if(B===n)return a;const V=function(ae,j){return!!B(ae,j)};return B.allBasenames&&(V.allBasenames=B.allBasenames),B.allPaths&&(V.allPaths=B.allPaths),V}return ie(q,O)}function U(q){const O=q;return O?typeof O.base=="string"&&typeof O.pattern=="string":!1}function z(q){return q.allBasenames||[]}function re(q){return q.allPaths||[]}function ie(q,O){const B=G(Object.getOwnPropertyNames(q).map(ne=>oe(ne,q[ne],O)).filter(ne=>ne!==n)),V=B.length;if(!V)return n;if(!B.some(ne=>!!ne.requiresSiblings)){if(V===1)return B[0];const ne=function(W,N){let H;for(let X=0,Q=B.length;X<Q;X++){const $=B[X](W,N);if(typeof $=="string")return $;(0,s.isThenable)($)&&(H||(H=[]),H.push($))}return H?(async()=>{for(const X of H){const Q=await X;if(typeof Q=="string")return Q}return null})():null},J=B.find(W=>!!W.allBasenames);J&&(ne.allBasenames=J.allBasenames);const _=B.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return _.length&&(ne.allPaths=_),ne}const ae=function(ne,J,_){let W,N;for(let H=0,X=B.length;H<X;H++){const Q=B[H];Q.requiresSiblings&&_&&(J||(J=(0,R.basename)(ne)),W||(W=J.substr(0,J.length-(0,R.extname)(ne).length)));const $=Q(ne,J,W,_);if(typeof $=="string")return $;(0,s.isThenable)($)&&(N||(N=[]),N.push($))}return N?(async()=>{for(const H of N){const X=await H;if(typeof X=="string")return X}return null})():null},j=B.find(ne=>!!ne.allBasenames);j&&(ae.allBasenames=j.allBasenames);const he=B.reduce((ne,J)=>J.allPaths?ne.concat(J.allPaths):ne,[]);return he.length&&(ae.allPaths=he),ae}function oe(q,O,B){if(O===!1)return n;const V=c(q,B);if(V===n)return n;if(typeof O=="boolean")return V;if(O){const ae=O.when;if(typeof ae=="string"){const j=(he,ne,J,_)=>{if(!_||!V(he,ne))return null;const W=ae.replace("$(basename)",()=>J),N=_(W);return(0,s.isThenable)(N)?N.then(H=>H?q:null):N?q:null};return j.requiresSiblings=!0,j}}return V}function G(q,O){const B=q.filter(ne=>!!ne.basenames);if(B.length<2)return q;const V=B.reduce((ne,J)=>{const _=J.basenames;return _?ne.concat(_):ne},[]);let ae;if(O){ae=[];for(let ne=0,J=V.length;ne<J;ne++)ae.push(O)}else ae=B.reduce((ne,J)=>{const _=J.patterns;return _?ne.concat(_):ne},[]);const j=function(ne,J){if(typeof ne!="string")return null;if(!J){let W;for(W=ne.length;W>0;W--){const N=ne.charCodeAt(W-1);if(N===P.CharCode.Slash||N===P.CharCode.Backslash)break}J=ne.substr(W)}const _=V.indexOf(J);return _!==-1?ae[_]:null};j.basenames=V,j.patterns=ae,j.allBasenames=V;const he=q.filter(ne=>!ne.basenames);return he.push(j),he}function te(q,O){return(0,i.equals)(q,O,(B,V)=>typeof B=="string"&&typeof V=="string"?B===V:typeof B!="string"&&typeof V!="string"?B.base===V.base&&B.pattern===V.pattern:!1)}}),define(le[49],ce([0,1,22,31,9,4,19,26]),function(K,e,i,s,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=b,e.normalizeDriveLetter=d,e.tildify=g,e.untildify=y,e.shorten=v,e.template=E,e.mnemonicMenuLabel=I,e.mnemonicButtonLabel=o,e.unmnemonicLabel=t,e.splitRecentLabel=r;function b(n,c){const{os:u,tildify:S,relative:D}=c;if(D){const T=l(n,D,u);if(typeof T=="string")return T}let L=n.fsPath;if(u===k.OperatingSystem.Windows&&!k.isWindows?L=L.replace(/\//g,"\\"):u!==k.OperatingSystem.Windows&&k.isWindows&&(L=L.replace(/\\/g,"/")),u!==k.OperatingSystem.Windows&&S?.userHome){const T=S.userHome.fsPath;let C;n.scheme!==S.userHome.scheme&&n.path[0]===P.posix.sep&&n.path[1]!==P.posix.sep?C=S.userHome.with({path:n.path}).fsPath:C=L,L=g(C,T,u)}return(u===k.OperatingSystem.Windows?P.win32:P.posix).normalize(d(L,u===k.OperatingSystem.Windows))}function l(n,c,u){const S=u===k.OperatingSystem.Windows?P.win32:P.posix,D=u===k.OperatingSystem.Linux?A.extUri:A.extUriIgnorePathCase,L=c.getWorkspace(),M=(0,i.firstOrDefault)(L.folders);if(!M)return;n.scheme!==M.uri.scheme&&n.path[0]===P.posix.sep&&n.path[1]!==P.posix.sep&&(n=M.uri.with({path:n.path}));const T=c.getWorkspaceFolder(n);if(!T)return;let C;if(D.isEqual(T.uri,n)?C="":C=D.relativePath(T.uri,n)??"",C&&(C=S.normalize(C)),L.folders.length>1&&!c.noPrefix){const F=T.name?T.name:D.basenameOrAuthority(T.uri);C=C?`${F} \u2022 ${C}`:F}return C}function d(n,c=k.isWindows){return(0,s.hasDriveLetter)(n,c)?n.charAt(0).toUpperCase()+n.slice(1):n}let f=Object.create(null);function g(n,c,u=k.OS){if(u===k.OperatingSystem.Windows||!n||!c)return n;let S=f.original===c?f.normalized:void 0;S||(S=c,k.isWindows&&(S=(0,s.toSlashes)(S)),S=`${(0,R.rtrim)(S,P.posix.sep)}${P.posix.sep}`,f={original:c,normalized:S});let D=n;return k.isWindows&&(D=(0,s.toSlashes)(D)),(u===k.OperatingSystem.Linux?D.startsWith(S):(0,R.startsWithIgnoreCase)(D,S))?`~/${D.substr(S.length)}`:n}function y(n,c){return n.replace(/^~($|\/|\\)/,`${c}$1`)}const h="\u2026",m="\\\\",p="~";function v(n,c=P.sep){const u=new Array(n.length);let S=!1;for(let D=0;D<n.length;D++){const L=n[D];if(L===""){u[D]=`.${c}`;continue}if(!L){u[D]=L;continue}S=!0;let M="",T=L;T.indexOf(m)===0?(M=T.substr(0,T.indexOf(m)+m.length),T=T.substr(T.indexOf(m)+m.length)):T.indexOf(c)===0?(M=T.substr(0,T.indexOf(c)+c.length),T=T.substr(T.indexOf(c)+c.length)):T.indexOf(p)===0&&(M=T.substr(0,T.indexOf(p)+p.length),T=T.substr(T.indexOf(p)+p.length));const C=T.split(c);for(let F=1;S&&F<=C.length;F++)for(let x=C.length-F;S&&x>=0;x--){S=!1;let U=C.slice(x,x+F).join(c);for(let z=0;!S&&z<n.length;z++)if(z!==D&&n[z]&&n[z].indexOf(U)>-1){const re=x+F===C.length,ie=x>0&&n[z].indexOf(c)>-1?c+U:U,oe=n[z].endsWith(ie);S=!re||oe}if(!S){let z="";(C[0].endsWith(":")||M!=="")&&(x===1&&(x=0,F++,U=C[0]+c+U),x>0&&(z=C[0]+c),z=M+z),x>0&&(z=z+h+c),z=z+U,x+F<C.length&&(z=z+c+h),u[D]=z}}S&&(u[D]=L)}return u}var w;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function E(n,c=Object.create(null)){const u=[];let S=!1,D="";for(const L of n)if(L==="$"||S&&L==="{")D&&u.push({value:D,type:w.TEXT}),D="",S=!0;else if(L==="}"&&S){const M=c[D];if(typeof M=="string")M.length&&u.push({value:M,type:w.VARIABLE});else if(M){const T=u[u.length-1];(!T||T.type!==w.SEPARATOR)&&u.push({value:M.label,type:w.SEPARATOR})}D="",S=!1}else D+=L;return D&&!S&&u.push({value:D,type:w.TEXT}),u.filter((L,M)=>{if(L.type===w.SEPARATOR){const T=u[M-1],C=u[M+1];return[T,C].every(F=>F&&(F.type===w.VARIABLE||F.type===w.TEXT)&&F.value.length>0)}return!0}).map(L=>L.value).join("")}function I(n,c){return k.isMacintosh||c?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):n.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function o(n,c){return k.isMacintosh||c?n.replace(/\(&&\w\)|&&/g,""):k.isWindows?n.replace(/&&|&/g,u=>u==="&"?"&&":"&"):n.replace(/&&/g,"_")}function t(n){return n.replace(/&/g,"&&")}function r(n){if(n.endsWith("]")){const c=n.lastIndexOf(" [",n.length-2);if(c!==-1){const u=a(n.substring(0,c)),S=n.substring(c);return{name:u.name+S,parentPath:u.parentPath}}}return a(n)}function a(n){const c=n.indexOf("/")!==-1?P.posix:P.win32,u=c.basename(n),S=c.dirname(n);return u.length?{name:u,parentPath:S}:{name:S,parentPath:""}}}),define(le[160],ce([0,1,17,90,7]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=b,e.transformIncomingURIs=d,e.transformAndReviveIncomingURIs=f;function k(g){return g.toJSON()}class A{constructor(y){this._uriTransformer=y}transformIncoming(y){const h=this._uriTransformer.transformIncoming(y);return h===y?y:k(P.URI.from(h))}transformOutgoing(y){const h=this._uriTransformer.transformOutgoing(y);return h===y?y:k(P.URI.from(h))}transformOutgoingURI(y){const h=this._uriTransformer.transformOutgoing(y);return h===y?y:P.URI.from(h)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function R(g,y,h){if(!g||h>200)return null;if(typeof g=="object"){if(g instanceof P.URI)return y.transformOutgoing(g);for(const m in g)if(Object.hasOwnProperty.call(g,m)){const p=R(g[m],y,h+1);p!==null&&(g[m]=p)}}return null}function b(g,y){const h=R(g,y,0);return h===null?g:h}function l(g,y,h,m){if(!g||m>200)return null;if(typeof g=="object"){if(g.$mid===s.MarshalledId.Uri)return h?P.URI.revive(y.transformIncoming(g)):y.transformIncoming(g);if(g instanceof i.VSBuffer)return null;for(const p in g)if(Object.hasOwnProperty.call(g,p)){const v=l(g[p],y,h,m+1);v!==null&&(g[p]=v)}}return null}function d(g,y){const h=l(g,y,!1,0);return h===null?g:h}function f(g,y){const h=l(g,y,!0,0);return h===null?g:h}}),define(le[93],ce([0,1,27,61,33,150,4]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=b,e.getSqmMachineId=f,e.getdevDeviceId=g,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=s.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,h=0;const m=(0,i.networkInterfaces)();for(const p in m){const v=m[p];if(v)for(const{mac:w,internal:E}of v)E||(h+=1,this._isVirtualMachineMacAddress(w.toUpperCase())&&(y+=1))}this._value=h>0?y/h:0}return this._value}};let R;async function b(y){return R||(R=(async()=>await l(y)||P.generateUuid())()),R}async function l(y){try{const h=await new Promise((p,v)=>{K(["crypto"],p,v)}),m=(0,k.getMac)();return h.createHash("sha256").update(m,"utf8").digest("hex")}catch(h){y(h);return}}const d="Software\\Microsoft\\SQMClient";async function f(y){if(A.isWindows){const h=await new Promise((m,p)=>{K(["@vscode/windows-registry"],m,p)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",d,"MachineId")||""}catch(m){return y(m),""}}return""}async function g(y){try{return await(await new Promise((p,v)=>{K(["@vscode/deviceid"],p,v)})).getDeviceId()}catch(h){return y(h),""}}}),define(le[21],ce([0,1,44,27,161,8,31,76,9,4,19,7]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=p,e.readdirSync=E,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=D;var g;(function(ie){ie[ie.UNLINK=0]="UNLINK",ie[ie.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function y(ie,oe=g.UNLINK,G){if((0,A.isRootOrDriveLetter)(ie))throw new Error("rimraf - will refuse to recursively delete root");return oe===g.UNLINK?m(ie):h(ie,G)}async function h(ie,oe=(0,A.randomPath)((0,s.tmpdir)())){try{try{await i.promises.rename(ie,oe)}catch(G){return G.code==="ENOENT"?void 0:m(ie)}m(oe).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function m(ie){return(0,P.promisify)(i.rm)(ie,{recursive:!0,force:!0,maxRetries:3})}function p(ie){if((0,A.isRootOrDriveLetter)(ie))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(ie,{recursive:!0,force:!0,maxRetries:3})}async function v(ie,oe){return I(await(oe?w(ie):(0,P.promisify)(i.readdir)(ie)))}async function w(ie){try{return await(0,P.promisify)(i.readdir)(ie,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const oe=[],G=await v(ie);for(const te of G){let q=!1,O=!1,B=!1;try{const V=await e.Promises.lstat((0,b.join)(ie,te));q=V.isFile(),O=V.isDirectory(),B=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}oe.push({name:te,isFile:()=>q,isDirectory:()=>O,isSymbolicLink:()=>B})}return oe}function E(ie){return I(i.readdirSync(ie))}function I(ie){return ie.map(oe=>typeof oe=="string"?l.isMacintosh?(0,R.normalizeNFC)(oe):oe:(oe.name=l.isMacintosh?(0,R.normalizeNFC)(oe.name):oe.name,oe))}async function o(ie){const oe=await v(ie),G=[];for(const te of oe)await r.existsDirectory((0,b.join)(ie,te))&&G.push(te);return G}function t(ie,oe=1e3){return new Promise(G=>{let te=!1;const q=setInterval(()=>{te||(te=!0,i.access(ie,O=>{te=!1,O&&(clearInterval(q),G(void 0))}))},oe)})}var r;(function(ie){async function oe(q){let O;try{if(O=await e.Promises.lstat(q),!O.isSymbolicLink())return{stat:O}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(l.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw V}throw B}}ie.stat=oe;async function G(q){try{const{stat:O,symbolicLink:B}=await ie.stat(q);return O.isFile()&&B?.dangling!==!0}catch{}return!1}ie.existsFile=G;async function te(q){try{const{stat:O,symbolicLink:B}=await ie.stat(q);return O.isDirectory()&&B?.dangling!==!0}catch{}return!1}ie.existsDirectory=te})(r||(e.SymlinkSupport=r={}));const a=new k.ResourceQueue;function n(ie,oe,G){return a.queueFor(f.URI.file(ie),()=>{const te=L(G);return new Promise((q,O)=>S(ie,oe,te,B=>B?O(B):q()))},d.extUriBiasedIgnorePathCase)}let c=!0;function u(ie){c=ie}function S(ie,oe,G,te){if(!c)return i.writeFile(ie,oe,{mode:G.mode,flag:G.flag},te);i.open(ie,G.flag,G.mode,(q,O)=>{if(q)return te(q);i.writeFile(O,oe,B=>{if(B)return i.close(O,()=>te(B));i.fdatasync(O,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),u(!1)),i.close(O,ae=>te(ae))))})})}function D(ie,oe,G){const te=L(G);if(!c)return i.writeFileSync(ie,oe,{mode:te.mode,flag:te.flag});const q=i.openSync(ie,te.flag,te.mode);try{i.writeFileSync(q,oe);try{i.fdatasyncSync(q)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),u(!1)}}finally{i.closeSync(q)}}function L(ie){return ie?{mode:typeof ie.mode=="number"?ie.mode:438,flag:typeof ie.flag=="string"?ie.flag:"w"}:{mode:438,flag:"w"}}async function M(ie,oe,G=6e4){if(ie!==oe)try{l.isWindows&&typeof G=="number"?await T(ie,oe,Date.now(),G):await(0,P.promisify)(i.rename)(ie,oe)}catch(te){if(ie.toLowerCase()!==oe.toLowerCase()&&te.code==="EXDEV"||ie.endsWith("."))await C(ie,oe,{preserveSymlinks:!1}),await y(ie,g.MOVE);else throw te}}async function T(ie,oe,G,te,q=0){try{return await(0,P.promisify)(i.rename)(ie,oe)}catch(O){if(O.code!=="EACCES"&&O.code!=="EPERM"&&O.code!=="EBUSY")throw O;if(Date.now()-G>=te)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${O}`),O;if(q===0){let B=!1;try{const{stat:V}=await r.stat(oe);V.isFile()||(B=!0)}catch{}if(B)throw O}return await(0,k.timeout)(Math.min(100,q*10)),T(ie,oe,G,te,q+1)}}async function C(ie,oe,G){return x(ie,oe,{root:{source:ie,target:oe},options:G,handledSourcePaths:new Set})}const F=511;async function x(ie,oe,G){if(G.handledSourcePaths.has(ie))return;G.handledSourcePaths.add(ie);const{stat:te,symbolicLink:q}=await r.stat(ie);if(q){if(G.options.preserveSymlinks)try{return await re(ie,oe,G)}catch{}if(q.dangling)return}return te.isDirectory()?U(ie,oe,te.mode&F,G):z(ie,oe,te.mode&F)}async function U(ie,oe,G,te){await e.Promises.mkdir(oe,{recursive:!0,mode:G});const q=await v(ie);for(const O of q)await x((0,b.join)(ie,O),(0,b.join)(oe,O),te)}async function z(ie,oe,G){await e.Promises.copyFile(ie,oe),await e.Promises.chmod(oe,G)}async function re(ie,oe,G){let te=await e.Promises.readlink(ie);(0,A.isEqualOrParent)(te,G.root.source,!l.isLinux)&&(te=(0,b.join)(G.root.target,te.substr(G.root.source.length+1))),await e.Promises.symlink(te,oe)}e.Promises=new class{get access(){return(0,P.promisify)(i.access)}get stat(){return(0,P.promisify)(i.stat)}get lstat(){return(0,P.promisify)(i.lstat)}get utimes(){return(0,P.promisify)(i.utimes)}get read(){return(ie,oe,G,te,q)=>new Promise((O,B)=>{i.read(ie,oe,G,te,q,(V,ae,j)=>V?B(V):O({bytesRead:ae,buffer:j}))})}get readFile(){return(0,P.promisify)(i.readFile)}get write(){return(ie,oe,G,te,q)=>new Promise((O,B)=>{i.write(ie,oe,G,te,q,(V,ae,j)=>V?B(V):O({bytesWritten:ae,buffer:j}))})}get appendFile(){return(0,P.promisify)(i.appendFile)}get fdatasync(){return(0,P.promisify)(i.fdatasync)}get truncate(){return(0,P.promisify)(i.truncate)}get copyFile(){return(0,P.promisify)(i.copyFile)}get open(){return(0,P.promisify)(i.open)}get close(){return(0,P.promisify)(i.close)}get symlink(){return(0,P.promisify)(i.symlink)}get readlink(){return(0,P.promisify)(i.readlink)}get chmod(){return(0,P.promisify)(i.chmod)}get mkdir(){return(0,P.promisify)(i.mkdir)}get unlink(){return(0,P.promisify)(i.unlink)}get rmdir(){return(0,P.promisify)(i.rmdir)}get realpath(){return(0,P.promisify)(i.realpath)}async exists(ie){try{return await e.Promises.access(ie),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return o}get writeFile(){return n}get rm(){return y}get rename(){return M}get copy(){return C}}}),define(le[114],ce([0,1,44,9,4,26,21]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=R,e.realcase=b,e.realpath=l,e.realpathSync=d;function R(g){if(P.isLinux)return g;const y=(0,s.dirname)(g);if(g===y)return g;const h=((0,s.basename)(g)||g).toLowerCase();try{const p=(0,A.readdirSync)(y).filter(v=>v.toLowerCase()===h);if(p.length===1){const v=R(y);if(v)return(0,s.join)(v,p[0])}else if(p.length>1){const v=p.indexOf(h);if(v>=0){const w=R(y);if(w)return(0,s.join)(w,p[v])}}}catch{}return null}async function b(g,y){if(P.isLinux)return g;const h=(0,s.dirname)(g);if(g===h)return g;const m=((0,s.basename)(g)||g).toLowerCase();try{if(y?.isCancellationRequested)return null;const v=(await A.Promises.readdir(h)).filter(w=>w.toLowerCase()===m);if(v.length===1){const w=await b(h,y);if(w)return(0,s.join)(w,v[0])}else if(v.length>1){const w=v.indexOf(m);if(w>=0){const E=await b(h,y);if(E)return(0,s.join)(E,v[w])}}}catch{}return null}async function l(g){try{return await A.Promises.realpath(g)}catch{const h=f(g);return await A.Promises.access(h,i.constants.R_OK),h}}function d(g){try{return i.realpathSync(g)}catch{const h=f(g);return i.accessSync(h,i.constants.R_OK),h}}function f(g){return(0,k.rtrim)((0,s.normalize)(g),s.sep)}}),define(le[115],ce([0,1,27,9,21]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=w,e.getFirstAvailablePowerShellInstallation=E;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(I){I[I.x64=0]="x64",I[I.x86=1]="x86",I[I.ARM=2]="ARM"})(b||(b={}));let l;switch(process.arch){case"ia32":l=b.x86;break;case"arm":case"arm64":l=b.ARM;break;default:l=b.x64;break}let d;process.env.PROCESSOR_ARCHITEW6432?d=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?b.ARM:b.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?d=b.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?d=b.x86:d=b.x64;class f{constructor(o,t,r){this.exePath=o,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:I=!1}={}){return I?l===b.x64?process.env["ProgramFiles(x86)"]||null:d===b.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:I=!1,findPreview:o=!1}={}){const t=g({useAlternateBitness:I});if(!t)return null;const r=s.join(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(r))return null;let a=-1,n=null;for(const S of await P.Promises.readdir(r)){let D=-1;if(o){const M=S.indexOf("-");if(M<0)continue;const T=S.substring(0,M);if(!k.test(T)||S.substring(M+1)!=="preview")continue;D=parseInt(T,10)}else{if(!k.test(S))continue;D=parseInt(S,10)}if(D<=a)continue;const L=s.join(r,S,"pwsh.exe");await P.SymlinkSupport.existsFile(L)&&(n=L,a=D)}if(!n)return null;const c=t.includes("x86")?" (x86)":"",u=o?" Preview":"";return new f(n,`PowerShell${u}${c}`,!0)}async function h({findPreview:I}={}){if(!process.env.LOCALAPPDATA)return null;const o=s.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=I?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const a of await P.Promises.readdir(o))if(t.test(a)){const n=s.join(o,a,"pwsh.exe");return new f(n,r)}return null}function m(){const I=s.join(i.homedir(),".dotnet","tools","pwsh.exe");return new f(I,".NET Core PowerShell Global Tool")}function p(){const I=s.join(process.env.windir,l===b.x86&&d!==b.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new f(I,"Windows PowerShell",!0)}async function*v(){let I=await y();I&&(yield I),I=await y({useAlternateBitness:!0}),I&&(yield I),I=await h(),I&&(yield I),I=m(),I&&(yield I),I=await y({findPreview:!0}),I&&(yield I),I=await h({findPreview:!0}),I&&(yield I),I=await y({useAlternateBitness:!0,findPreview:!0}),I&&(yield I),I=p(),I&&(yield I)}async function*w(){for await(const I of v())await I.exists()&&(yield I)}async function E(){for await(const I of w())return I;return null}}),define(le[94],ce([0,1,9,4,36,80,12,21]),function(K,e,i,s,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=b,e.createQueuedSender=l,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function b(f=P.env){return f.comspec||"cmd.exe"}function l(f){let g=[],y=!1;const h=function(m){if(y){g.push(m);return}(!f.send(m,v=>{if(v&&console.error(v),y=!1,g.length>0){const w=g.slice(0);g=[],w.forEach(E=>h(E))}})||s.isWindows)&&(y=!0)};return{send:h}}var d;(function(f){async function g(y,h,m){if(i.isAbsolute(y))return y;if(h===void 0&&(h=P.cwd()),i.dirname(y)!=="."||(m===void 0&&A.isString(P.env.PATH)&&(m=P.env.PATH.split(i.delimiter)),m===void 0||m.length===0))return i.join(h,y);async function v(w){if(await R.Promises.exists(w)){let E;try{E=await R.Promises.stat(w)}catch(I){I.message.startsWith("EACCES")&&(E=await R.Promises.lstat(w))}return E?!E.isDirectory():!1}return!1}for(const w of m){let E;if(i.isAbsolute(w)?E=i.join(w,y):E=i.join(h,w,y),await v(E))return E;let I=E+".com";if(await v(I)||(I=E+".exe",await v(I)))return I}return i.join(h,y)}f.findExecutable=g})(d||(e.win32=d={}))}),define(le[116],ce([0,1,50,13]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=P;function P(A){return new Promise((R,b)=>{let l;const d=new Map;function f(y,h,m,p,v){const w=d.get(h);if(y===A||w){const E={name:g(m),cmd:m,pid:y,ppid:h,load:p,mem:v};d.set(y,E),y===A&&(l=E),w&&(w.children||(w.children=[]),w.children.push(E),w.children.length>1&&(w.children=w.children.sort((I,o)=>I.pid-o.pid)))}}function g(y){const h=/--utility-sub-type=network/i,m=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,v=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(m.exec(y))return"electron-crash-reporter";if(p.exec(y))return"winpty-agent";if(v.exec(y))return"conpty-agent";let E=w.exec(y);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?h.exec(y)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const I=/[a-zA-Z-]+\.js/g;let o="";do E=I.exec(y),E&&(o+=E+" ");while(E);return o&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron-nodejs (${o})`:y}if(process.platform==="win32"){const y=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substring(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substring(5):h;new Promise((h,m)=>{K(["@vscode/windows-process-tree"],h,m)}).then(h=>{h.getProcessList(A,m=>{if(!m){b(new Error(`Root process ${A} not found`));return}h.getProcessCpuUsage(m,p=>{const v=new Map;p.forEach(w=>{const E=y(w.commandLine||"");v.set(w.pid,{name:g(E),cmd:E,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),l=v.get(A),l?(v.forEach(w=>{const E=v.get(w.ppid);E&&(E.children||(E.children=[]),E.children.push(w))}),v.forEach(w=>{w.children&&(w.children=w.children.sort((E,I)=>E.pid-I.pid))}),R(l)):b(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let y=function(){let h=[l];const m=[];for(;h.length;){const v=h.shift();v&&(m.push(v.pid),v.children&&(h=h.concat(v.children)))}let p=JSON.stringify(s.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+m.join(" "),(0,i.exec)(p,{},(v,w,E)=>{if(v||E)b(v||new Error(E.toString()));else{const I=w.toString().split(`
`);for(let o=0;o<m.length;o++){const t=d.get(m[o]);t.load=parseFloat(I[o])}if(!l){b(new Error(`Root process ${A} not found`));return}R(l)}})};(0,i.exec)("which ps",{},(h,m,p)=>{if(h||p)if(process.platform!=="linux")b(h||new Error(p.toString()));else{const v=JSON.stringify(s.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)(v,{},(w,E,I)=>{w||I?b(w||new Error(I.toString())):(k(E,f),y())})}else{const v=m.toString().trim();(0,i.exec)(`${v} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(E,I,o)=>{E||o&&!o.includes("screen size is bogus")?b(E||new Error(o.toString())):(k(I,f),process.platform==="linux"?y():l?R(l):b(new Error(`Root process ${A} not found`)))})}})}})}function k(A,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=A.toString().split(`
`);for(const d of l){const f=b.exec(d.trim());f&&f.length===6&&R(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(le[117],ce([0,1,27,4,115,94]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=A;async function A(f,g){return f===s.OperatingSystem.Windows?s.isWindows?d():k.getWindowsShell(g):b(f,g)}let R=null;function b(f,g){if(s.isLinux&&f===s.OperatingSystem.Macintosh||s.isMacintosh&&f===s.OperatingSystem.Linux)return"/bin/bash";if(!R){let y;if(s.isWindows)y="/bin/bash";else{if(y=g.SHELL,!y)try{y=(0,i.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}R=y}return R}let l=null;async function d(){return l||(l=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),l}});var Ie=this&&this.__decorate||function(K,e,i,s){var P=arguments.length,k=P<3?e:s===null?s=Object.getOwnPropertyDescriptor(e,i):s,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(K,e,i,s);else for(var R=K.length-1;R>=0;R--)(A=K[R])&&(k=(P<3?A(k):P>3?A(e,i,k):A(e,i))||k);return P>3&&k&&Object.defineProperty(e,i,k),k};define(le[45],ce([0,1,22,8,17,23,53,16,3,2,81,26,12]),function(K,e,i,s,P,k,A,R,b,l,d,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=u,e.deserialize=S,e.getDelayedChannel=F,e.getNextTickChannel=x;var y;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(y||(y={}));function h(q){switch(q){case y.Promise:return"req";case y.PromiseCancel:return"cancel";case y.EventListen:return"subscribe";case y.EventDispose:return"unsubscribe"}}var m;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(m||(m={}));function p(q){switch(q){case m.Initialize:return"init";case m.PromiseSuccess:return"reply:";case m.PromiseError:case m.PromiseErrorObj:return"replyErr:";case m.EventFire:return"event:"}}var v;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(v||(v={}));function w(q){let O=0;for(let B=0;;B+=7){const V=q.read(1);if(O|=(V.buffer[0]&127)<<B,!(V.buffer[0]&128))return O}}const E=a(0);function I(q,O){if(O===0){q.write(E);return}let B=0;for(let ae=O;ae!==0;ae=ae>>>7)B++;const V=P.VSBuffer.alloc(B);for(let ae=0;O!==0;ae++)V.buffer[ae]=O&127,O=O>>>7,O>0&&(V.buffer[ae]|=128);q.write(V)}class o{constructor(O){this.buffer=O,this.pos=0}read(O){const B=this.buffer.slice(this.pos,this.pos+O);return this.pos+=B.byteLength,B}}e.BufferReader=o;class t{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}e.BufferWriter=t;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function a(q){const O=P.VSBuffer.alloc(1);return O.writeUInt8(q,0),O}const n={Undefined:a(r.Undefined),String:a(r.String),Buffer:a(r.Buffer),VSBuffer:a(r.VSBuffer),Array:a(r.Array),Object:a(r.Object),Uint:a(r.Int)},c=typeof Buffer<"u";function u(q,O){if(typeof O>"u")q.write(n.Undefined);else if(typeof O=="string"){const B=P.VSBuffer.fromString(O);q.write(n.String),I(q,B.byteLength),q.write(B)}else if(c&&Buffer.isBuffer(O)){const B=P.VSBuffer.wrap(O);q.write(n.Buffer),I(q,B.byteLength),q.write(B)}else if(O instanceof P.VSBuffer)q.write(n.VSBuffer),I(q,O.byteLength),q.write(O);else if(Array.isArray(O)){q.write(n.Array),I(q,O.length);for(const B of O)u(q,B)}else if(typeof O=="number"&&(O|0)===O)q.write(n.Uint),I(q,O);else{const B=P.VSBuffer.fromString(JSON.stringify(O));q.write(n.Object),I(q,B.byteLength),q.write(B)}}function S(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(w(q)).toString();case r.Buffer:return q.read(w(q)).buffer;case r.VSBuffer:return q.read(w(q));case r.Array:{const B=w(q),V=[];for(let ae=0;ae<B;ae++)V.push(S(q));return V}case r.Object:return JSON.parse(q.read(w(q)).toString());case r.Int:return w(q)}}class D{constructor(O,B,V=null,ae=1e3){this.protocol=O,this.ctx=B,this.logger=V,this.timeoutDelay=ae,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(j=>this.onRawMessage(j)),this.sendResponse({type:m.Initialize})}registerChannel(O,B){this.channels.set(O,B),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case m.Initialize:{const B=this.send([O.type]);this.logger?.logOutgoing(B,0,L.OtherSide,p(O.type));return}case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:{const B=this.send([O.type,O.id],O.data);this.logger?.logOutgoing(B,O.id,L.OtherSide,p(O.type),O.data);return}}}send(O,B=void 0){const V=new t;return u(V,O),u(V,B),this.sendBuffer(V.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onRawMessage(O){const B=new o(O),V=S(B),ae=S(B),j=V[0];switch(j){case y.Promise:return this.logger?.logIncoming(O.byteLength,V[1],L.OtherSide,`${h(j)}: ${V[2]}.${V[3]}`,ae),this.onPromise({type:j,id:V[1],channelName:V[2],name:V[3],arg:ae});case y.EventListen:return this.logger?.logIncoming(O.byteLength,V[1],L.OtherSide,`${h(j)}: ${V[2]}.${V[3]}`,ae),this.onEventListen({type:j,id:V[1],channelName:V[2],name:V[3],arg:ae});case y.PromiseCancel:return this.logger?.logIncoming(O.byteLength,V[1],L.OtherSide,`${h(j)}`),this.disposeActiveRequest({type:j,id:V[1]});case y.EventDispose:return this.logger?.logIncoming(O.byteLength,V[1],L.OtherSide,`${h(j)}`),this.disposeActiveRequest({type:j,id:V[1]})}}onPromise(O){const B=this.channels.get(O.channelName);if(!B){this.collectPendingRequest(O);return}const V=new k.CancellationTokenSource;let ae;try{ae=B.call(this.ctx,O.name,O.arg,V.token)}catch(ne){ae=Promise.reject(ne)}const j=O.id;ae.then(ne=>{this.sendResponse({id:j,data:ne,type:m.PromiseSuccess})},ne=>{ne instanceof Error?this.sendResponse({id:j,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:m.PromiseError}):this.sendResponse({id:j,data:ne,type:m.PromiseErrorObj})}).finally(()=>{he.dispose(),this.activeRequests.delete(O.id)});const he=(0,l.toDisposable)(()=>V.cancel());this.activeRequests.set(O.id,he)}onEventListen(O){const B=this.channels.get(O.channelName);if(!B){this.collectPendingRequest(O);return}const V=O.id,j=B.listen(this.ctx,O.name,O.arg)(he=>this.sendResponse({id:V,data:he,type:m.EventFire}));this.activeRequests.set(O.id,j)}disposeActiveRequest(O){const B=this.activeRequests.get(O.id);B&&(B.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let B=this.pendingRequests.get(O.channelName);B||(B=[],this.pendingRequests.set(O.channelName,B));const V=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===y.Promise&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:m.PromiseError})},this.timeoutDelay);B.push({request:O,timeoutTimer:V})}flushPendingRequests(O){const B=this.pendingRequests.get(O);if(B){for(const V of B)switch(clearTimeout(V.timeoutTimer),V.request.type){case y.Promise:this.onPromise(V.request);break;case y.EventListen:this.onEventListen(V.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var L;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(L||(e.RequestInitiator=L={}));class M{constructor(O,B=null){this.protocol=O,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=B}getChannel(O){const B=this;return{call(V,ae,j){return B.isDisposed?Promise.reject(new R.CancellationError):B.requestPromise(O,V,ae,j)},listen(V,ae){return B.isDisposed?b.Event.None:B.requestEvent(O,V,ae)}}}requestPromise(O,B,V,ae=k.CancellationToken.None){const j=this.lastRequestId++,he=y.Promise,ne={id:j,type:he,channelName:O,name:B,arg:V};if(ae.isCancellationRequested)return Promise.reject(new R.CancellationError);let J;return new Promise((W,N)=>{if(ae.isCancellationRequested)return N(new R.CancellationError);const H=()=>{const ee=fe=>{switch(fe.type){case m.PromiseSuccess:this.handlers.delete(j),W(fe.data);break;case m.PromiseError:{this.handlers.delete(j);const me=new Error(fe.data.message);me.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,me.name=fe.data.name,N(me);break}case m.PromiseErrorObj:this.handlers.delete(j),N(fe.data);break}};this.handlers.set(j,ee),this.sendRequest(ne)};let X=null;this.state===v.Idle?H():(X=(0,s.createCancelablePromise)(ee=>this.whenInitialized()),X.then(()=>{X=null,H()}));const Q=()=>{X?(X.cancel(),X=null):this.sendRequest({id:j,type:y.PromiseCancel}),N(new R.CancellationError)},$=ae.onCancellationRequested(Q);J=(0,l.combinedDisposable)((0,l.toDisposable)(Q),$),this.activeRequests.add(J)}).finally(()=>{J.dispose(),this.activeRequests.delete(J)})}requestEvent(O,B,V){const ae=this.lastRequestId++,j=y.EventListen,he={id:ae,type:j,channelName:O,name:B,arg:V};let ne=null;const J=new b.Emitter({onWillAddFirstListener:()=>{ne=(0,s.createCancelablePromise)(W=>this.whenInitialized()),ne.then(()=>{ne=null,this.activeRequests.add(J),this.sendRequest(he)})},onDidRemoveLastListener:()=>{ne?(ne.cancel(),ne=null):(this.activeRequests.delete(J),this.sendRequest({id:ae,type:y.EventDispose}))}}),_=W=>J.fire(W.data);return this.handlers.set(ae,_),J.event}sendRequest(O){switch(O.type){case y.Promise:case y.EventListen:{const B=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger?.logOutgoing(B,O.id,L.LocalSide,`${h(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case y.PromiseCancel:case y.EventDispose:{const B=this.send([O.type,O.id]);this.logger?.logOutgoing(B,O.id,L.LocalSide,h(O.type));return}}}send(O,B=void 0){const V=new t;return u(V,O),u(V,B),this.sendBuffer(V.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onBuffer(O){const B=new o(O),V=S(B),ae=S(B),j=V[0];switch(j){case m.Initialize:return this.logger?.logIncoming(O.byteLength,0,L.LocalSide,p(j)),this.onResponse({type:V[0]});case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:return this.logger?.logIncoming(O.byteLength,V[1],L.LocalSide,p(j),ae),this.onResponse({type:V[0],id:V[1],data:ae})}}onResponse(O){if(O.type===m.Initialize){this.state=v.Idle,this._onDidInitialize.fire();return}this.handlers.get(O.id)?.(O)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=M,Ie([A.memoize],M.prototype,"onDidInitializePromise",null);class T{get connections(){const O=[];return this._connections.forEach(B=>O.push(B)),O}constructor(O,B,V){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add(O(({protocol:ae,onDidClientDisconnect:j})=>{const he=b.Event.once(ae.onMessage);this.disposables.add(he(ne=>{const J=new o(ne),_=S(J),W=new D(ae,_,B,V),N=new M(ae,B);this.channels.forEach((X,Q)=>W.registerChannel(Q,X));const H={channelServer:W,channelClient:N,ctx:_};this._connections.add(H),this._onDidAddConnection.fire(H),this.disposables.add(j(()=>{W.dispose(),N.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)}))}))}))}getChannel(O,B){const V=this;return{call(ae,j,he){let ne;if((0,g.isFunction)(B)){const _=(0,i.getRandomElement)(V.connections.filter(B));ne=_?Promise.resolve(_):b.Event.toPromise(b.Event.filter(V.onDidAddConnection,B))}else ne=B.routeCall(V,ae,j);const J=ne.then(_=>_.channelClient.getChannel(O));return F(J).call(ae,j,he)},listen(ae,j){if((0,g.isFunction)(B))return V.getMulticastEvent(O,B,ae,j);const he=B.routeEvent(V,ae,j).then(ne=>ne.channelClient.getChannel(O));return F(he).listen(ae,j)}}}getMulticastEvent(O,B,V,ae){const j=this;let he;const ne=new b.Emitter({onWillAddFirstListener:()=>{he=new l.DisposableStore;const J=new b.EventMultiplexer,_=new Map,W=H=>{const Q=H.channelClient.getChannel(O).listen(V,ae),$=J.add(Q);_.set(H,$)},N=H=>{const X=_.get(H);X&&(X.dispose(),_.delete(H))};j.connections.filter(B).forEach(W),b.Event.filter(j.onDidAddConnection,B)(W,void 0,he),j.onDidRemoveConnection(N,void 0,he),J.event(ne.fire,ne,he),he.add(J)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return ne.event}registerChannel(O,B){this.channels.set(O,B);for(const V of this._connections)V.channelServer.registerChannel(O,B)}dispose(){this.disposables.dispose();for(const O of this._connections)O.channelClient.dispose(),O.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class C{constructor(O,B,V=null){const ae=new t;u(ae,B),O.send(ae.buffer),this.channelClient=new M(O,V),this.channelServer=new D(O,B,V)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,B){this.channelServer.registerChannel(O,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function F(q){return{call(O,B,V){return q.then(ae=>ae.call(O,B,V))},listen(O,B){const V=new b.Relay;return q.then(ae=>V.input=ae.listen(O,B)),V.event}}}function x(q){let O=!1;return{call(B,V,ae){return O?q.call(B,V,ae):(0,s.timeout)(0).then(()=>O=!0).then(()=>q.call(B,V,ae))},listen(B,V){if(O)return q.listen(B,V);const ae=new b.Relay;return(0,s.timeout)(0).then(()=>O=!0).then(()=>ae.input=q.listen(B,V)),ae.event}}}class U{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const B of O.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await b.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=U;var z;(function(q){function O(j,he,ne){const J=j,_=ne&&ne.disableMarshalling,W=new Map;for(const N in J)V(N)&&W.set(N,b.Event.buffer(J[N],!0,void 0,he));return new class{listen(N,H,X){const Q=W.get(H);if(Q)return Q;const $=J[H];if(typeof $=="function"){if(ae(H))return $.call(J,X);if(V(H))return W.set(H,b.Event.buffer(J[H],!0,void 0,he)),W.get(H)}throw new R.ErrorNoTelemetry(`Event not found: ${H}`)}call(N,H,X){const Q=J[H];if(typeof Q=="function"){if(!_&&Array.isArray(X))for(let ee=0;ee<X.length;ee++)X[ee]=(0,d.revive)(X[ee]);let $=Q.apply(J,X);return $ instanceof Promise||($=Promise.resolve($)),$}throw new R.ErrorNoTelemetry(`Method not found: ${H}`)}}}q.fromService=O;function B(j,he){const ne=he&&he.disableMarshalling;return new Proxy({},{get(J,_){if(typeof _=="string")return he?.properties?.has(_)?he.properties.get(_):ae(_)?function(W){return j.listen(_,W)}:V(_)?j.listen(_):async function(...W){let N;he&&!(0,g.isUndefinedOrNull)(he.context)?N=[he.context,...W]:N=W;const H=await j.call(_,N);return ne?H:(0,d.revive)(H)};throw new R.ErrorNoTelemetry(`Property not found: ${String(_)}`)}})}q.toService=B;function V(j){return j[0]==="o"&&j[1]==="n"&&f.isUpperAsciiLetter(j.charCodeAt(2))}function ae(j){return/^onDynamic/.test(j)&&f.isUpperAsciiLetter(j.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ie(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const O=q.toString();if(O!=="[object Object]")return O}return q}function oe(q){return Array.isArray(q)?q.map(ie):ie(q)}function G(q,O,B,V,ae,j,he){he=oe(he);const ne=re[ae],J=ne[V%ne.length];let _=[`%c[${q}]%c[${String(O).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${J}`];/\($/.test(j)?(_=_.concat(he),_.push(")")):_.push(he),console.log.apply(console,_)}class te{constructor(O,B){this._outgoingPrefix=O,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,B,V,ae,j){this._totalOutgoing+=O,G(this._outgoingPrefix,this._totalOutgoing,O,B,V,ae,j)}logIncoming(O,B,V,ae,j){this._totalIncoming+=O,G(this._incomingPrefix,this._totalIncoming,O,B,V,ae,j)}}e.IPCLogger=te}),define(le[162],ce([0,1,17,3,45]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(b){this.port=b,this.onMessage=s.Event.fromDOMEventEmitter(this.port,"message",l=>l.data?i.VSBuffer.wrap(l.data):i.VSBuffer.alloc(0)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends P.IPCClient{constructor(b,l){const d=new k(b);super(d,l),this.protocol=d}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=A}),define(le[118],ce([0,1,17,3,2,45]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const c=new WeakMap;let u=0;function S(L,M){if(!c.has(L)){const T=String(++u);c.set(L,T)}return c.get(L)}function D(L,M,T,C){if(!n.enableDiagnostics)return;const F=S(L,M);if(C instanceof i.VSBuffer||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const x=i.VSBuffer.alloc(C.byteLength);x.set(C),n.records.push({timestamp:Date.now(),id:F,label:M,type:T,buff:x})}else n.records.push({timestamp:Date.now(),id:F,label:M,type:T,data:C})}n.traceSocketEvent=D})(R||(e.SocketDiagnostics=R={}));var b;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let l=null;function d(){return l||(l=i.VSBuffer.alloc(0)),l}class f{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(c){this._chunks.push(c),this._totalLength+=c.byteLength}read(c){return this._read(c,!0)}peek(c){return this._read(c,!1)}_read(c,u){if(c===0)return d();if(c>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===c){const M=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=c),M}if(this._chunks[0].byteLength>c){const M=this._chunks[0].slice(0,c);return u&&(this._chunks[0]=this._chunks[0].slice(c),this._totalLength-=c),M}const S=i.VSBuffer.alloc(c);let D=0,L=0;for(;c>0;){const M=this._chunks[L];if(M.byteLength>c){const T=M.slice(0,c);S.set(T,D),D+=c,u&&(this._chunks[L]=M.slice(c),this._totalLength-=c),c-=c}else S.set(M,D),D+=M.byteLength,u?(this._chunks.shift(),this._totalLength-=M.byteLength):L++,c-=M.byteLength}return S}}e.ChunkStream=f;var g;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(g||(g={}));function y(n){switch(n){case g.None:return"None";case g.Regular:return"Regular";case g.Control:return"Control";case g.Ack:return"Ack";case g.Disconnect:return"Disconnect";case g.ReplayRequest:return"ReplayRequest";case g.Pause:return"PauseWriting";case g.Resume:return"ResumeWriting";case g.KeepAlive:return"KeepAlive"}}var h;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(h||(e.ProtocolConstants=h={}));class m{constructor(c,u,S,D){this.type=c,this.id=u,this.ack=S,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends P.Disposable{constructor(c){super(),this._onMessage=this._register(new s.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:h.HeaderLength,messageType:g.None,id:0,ack:0},this._socket=c,this._isDisposed=!1,this._incomingData=new f,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent(A.ProtocolHeaderRead,{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const S=this._state.messageType,D=this._state.id,L=this._state.ack;if(this._state.readHead=!0,this._state.readLen=h.HeaderLength,this._state.messageType=g.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(A.ProtocolMessageRead,u),this._onMessage.fire(new m(S,D,L,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(c){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=c,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(c){if(this._isDisposed)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=i.VSBuffer.alloc(h.HeaderLength);u.writeUInt8(c.type,0),u.writeUInt32BE(c.id,1),u.writeUInt32BE(c.ack,5),u.writeUInt32BE(c.data.byteLength,9),this._socket.traceSocketEvent(A.ProtocolHeaderWrite,{messageType:y(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this._socket.traceSocketEvent(A.ProtocolMessageWrite,c.data),this._writeSoon(u,c.data)}_bufferAdd(c,u){const S=this._totalLength===0;return this._data.push(c,u),this._totalLength+=c.byteLength+u.byteLength,S}_bufferTake(){const c=i.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,c}_writeSoon(c,u){this._bufferAdd(c,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const c=this._bufferTake();this._socket.traceSocketEvent(A.ProtocolWrite,{byteLength:c.byteLength}),this._socket.write(c)}}class w extends P.Disposable{constructor(c){super(),this._onMessage=new s.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new s.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=c,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===g.Regular&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(c){this._socketWriter.write(new m(g.Regular,0,0,c))}}e.Protocol=w;class E extends k.IPCClient{static fromSocket(c,u){return new E(new w(c),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(c,u,S=null){super(c,u,S),this.protocol=c}dispose(){super.dispose();const c=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),c.end()}}e.Client=E;class I{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new s.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(c){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(c):this._emitter.fire(c):this._bufferedMessages.push(c)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=I;class o{constructor(c){this.data=c,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let c=0,u=this._first;for(;u;)u=u.next,c++;return c}peek(){return this._first?this._first.data:null}toArray(){const c=[];let u=0,S=this._first;for(;S;)c[u++]=S.data,S=S.next;return c}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(c){const u=new o(c);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class r{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const c=Date.now();for(let u=0;u<r._HISTORY_LENGTH;u++)this.lastRuns[u]=c-1e3*u;setInterval(()=>{for(let u=r._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const c=Date.now(),u=(1+r._HISTORY_LENGTH)*1e3;let S=0;for(let D=0;D<r._HISTORY_LENGTH;D++)c-this.lastRuns[D]<=u&&S++;return 1-S/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class a{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(c){this._onControlMessage=new I,this.onControlMessage=this._onControlMessage.event,this._onMessage=new I,this.onMessage=this._onMessage.event,this._onDidDispose=new I,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new I,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new I,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c.loadEstimator??r.getInstance(),this._shouldSendKeepAlive=c.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new P.DisposableStore,this._socket=c.socket,this._socketWriter=this._socketDisposables.add(new v(this._socket)),this._socketReader=this._socketDisposables.add(new p(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.add(this._socket.onClose(u=>this._onSocketClose.fire(u))),c.initialChunk&&this._socketReader.acceptChunk(c.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},h.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const c=new m(g.Disconnect,0,0,d());this._socketWriter.write(c),this._socketWriter.flush()}sendPause(){const c=new m(g.Pause,0,0,d());this._socketWriter.write(c)}sendResume(){const c=new m(g.Resume,0,0,d());this._socketWriter.write(c)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(c,u){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new P.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=c,this._socketWriter=this._socketDisposables.add(new v(this._socket)),this._socketReader=this._socketDisposables.add(new p(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.add(this._socket.onClose(S=>this._onSocketClose.fire(S))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const c=new m(g.Ack,0,this._incomingAckId,d());this._socketWriter.write(c);const u=this._outgoingUnackMsg.toArray();for(let S=0,D=u.length;S<D;S++)this._socketWriter.write(u[S]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(c){if(c.ack>this._outgoingAckId){this._outgoingAckId=c.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=c.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(c.type){case g.None:break;case g.Regular:{if(c.id>this._incomingMsgId)if(c.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new m(g.ReplayRequest,0,0,d())))}else this._incomingMsgId=c.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(c.data);break}case g.Control:{this._onControlMessage.fire(c.data);break}case g.Ack:break;case g.Disconnect:{this._onDidDispose.fire();break}case g.ReplayRequest:{const u=this._outgoingUnackMsg.toArray();for(let S=0,D=u.length;S<D;S++)this._socketWriter.write(u[S]);this._recvAckCheck();break}case g.Pause:{this._socketWriter.pause();break}case g.Resume:{this._socketWriter.resume();break}case g.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(c){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const S=new m(g.Regular,u,this._incomingAckId,c);this._outgoingUnackMsg.push(S),this._isReconnecting||(this._socketWriter.write(S),this._recvAckCheck())}sendControl(c){const u=new m(g.Control,0,0,c);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const c=Date.now()-this._incomingMsgLastTime;if(c>=h.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},h.AcknowledgeTime-c+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const c=this._outgoingUnackMsg.peek(),u=Date.now()-c.writtenTime,S=Date.now()-this._socketReader.lastReadTime,D=Date.now()-this._lastSocketTimeoutTime;if(u>=h.TimeoutTime&&S>=h.TimeoutTime&&D>=h.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:S});return}const L=Math.max(h.TimeoutTime-u,h.TimeoutTime-S,h.TimeoutTime-D,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},L)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const c=new m(g.Ack,0,this._incomingAckId,d());this._socketWriter.write(c)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const c=new m(g.KeepAlive,0,this._incomingAckId,d());this._socketWriter.write(c)}}e.PersistentProtocol=a}),define(le[37],ce([0,1,14,16,13]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(R,b){const l=(d,...f)=>{this.validateEvent(R,d)&&b(d,...f)};return this.mapListenerToWrapper.set(b,l),i.ipcMain.on(R,l),this}once(R,b){return i.ipcMain.once(R,(l,...d)=>{this.validateEvent(R,l)&&b(l,...d)}),this}handle(R,b){return i.ipcMain.handle(R,(l,...d)=>this.validateEvent(R,l)?b(l,...d):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return i.ipcMain.removeHandler(R),this}removeListener(R,b){const l=this.mapListenerToWrapper.get(b);return l&&(i.ipcMain.removeListener(R,l),this.mapListenerToWrapper.delete(b)),this}validateEvent(R,b){if(!R||!R.startsWith("vscode:"))return(0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const l=b.senderFrame,d=l.url;if(!d||d==="about:blank")return!0;let f="unknown";try{f=new URL(d).host}catch{return(0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${d}'.`),!1}return f!==P.VSCODE_AUTHORITY?((0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${f}'.`),!1):l.parent!==null?((0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${f}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(le[163],ce([0,1,14,37,151]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=k;function k(){s.validatedIpcMain.on(P.CONTEXT_MENU_CHANNEL,(R,b,l,d,f)=>{const g=A(R,d,l);g.popup({x:f?f.x:void 0,y:f?f.y:void 0,positioningItem:f?f.positioningItem:void 0,callback:()=>{g&&R.sender.send(P.CONTEXT_MENU_CLOSE_CHANNEL,b)}})})}function A(R,b,l){const d=new i.Menu;return l.forEach(f=>{let g;f.type==="separator"?g=new i.MenuItem({type:f.type}):Array.isArray(f.submenu)?g=new i.MenuItem({submenu:A(R,b,f.submenu),label:f.label}):g=new i.MenuItem({label:f.label,type:f.type,accelerator:f.accelerator,checked:f.checked,enabled:f.enabled,visible:f.visible,click:(y,h,m)=>R.sender.send(b,f.id,m)}),d.append(g)}),d}}),define(le[164],ce([0,1,37,17,3,2,45,152]),function(K,e,i,s,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function b(d,f){const g=P.Event.fromNodeEventEmitter(i.validatedIpcMain,f,(h,m)=>({event:h,message:m})),y=P.Event.filter(g,({event:h})=>h.sender.id===d);return P.Event.map(y,({message:h})=>h&&s.VSBuffer.wrap(h))}class l extends A.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const f=P.Event.fromNodeEventEmitter(i.validatedIpcMain,"vscode:hello",({sender:g})=>g);return P.Event.map(f,g=>{const y=g.id;l.Clients.get(y)?.dispose();const m=new P.Emitter;l.Clients.set(y,(0,k.toDisposable)(()=>m.fire()));const p=b(y,"vscode:message"),v=P.Event.any(P.Event.signal(b(y,"vscode:disconnect")),m.event);return{protocol:new R.Protocol(g,p),onDidClientDisconnect:v}})}constructor(){super(l.getOnDidClientConnect())}}e.Server=l}),define(le[119],ce([0,1,37,3,33,162]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=void 0,e.connect=R;class A extends k.Client{constructor(l,d){super({addEventListener:(f,g)=>l.addListener(f,g),removeEventListener:(f,g)=>l.removeListener(f,g),postMessage:f=>l.postMessage(f),start:()=>l.start(),close:()=>l.close()},d)}}e.Client=A;async function R(b){if(b.isDestroyed()||b.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,P.generateUuid)();b.webContents.send("vscode:createMessageChannel",l);const d=s.Event.fromNodeEventEmitter(i.validatedIpcMain,"vscode:createMessageChannelResult",(g,y)=>({nonce:y,port:g.ports[0]})),{port:f}=await s.Event.toPromise(s.Event.once(s.Event.filter(d,g=>g.nonce===l)));return f}}),define(le[165],ce([0,1,50,8,17,23,159,16,3,2,35,94,80,45]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends y.ChannelServer{constructor(v){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",w=>P.VSBuffer.wrap(Buffer.from(w,"base64")))},v),process.once("disconnect",()=>this.dispose())}}e.Server=h;class m{constructor(v,w){this.modulePath=v,this.options=w,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=w&&w.timeout?w.timeout:6e4;this.disposeDelayer=new s.Delayer(E),this.child=null,this._client=null}getChannel(v){const w=this;return{call(E,I,o){return w.requestPromise(v,E,I,o)},listen(E,I){return w.requestEvent(v,E,I)}}}requestPromise(v,w,E,I=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(I.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(v),t=(0,s.createCancelablePromise)(n=>o.call(w,E,n)),r=I.onCancellationRequested(()=>t.cancel()),a=(0,l.toDisposable)(()=>t.cancel());return this.activeRequests.add(a),t.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(v,w,E){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let I;const o=new b.Emitter({onWillAddFirstListener:()=>{I=this.getCachedChannel(v).listen(w,E)(o.fire,o),this.activeRequests.add(I)},onDidRemoveLastListener:()=>{this.activeRequests.delete(I),I.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],w=Object.create(null);w.env={...(0,d.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(w.env={...w.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(w.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,g.removeDangerousEnvVariables)(w.env),this.child=(0,i.fork)(this.modulePath,v,w);const E=new b.Emitter,o=b.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,A.isRemoteConsoleLog)(u)){(0,A.log)(u,`IPC Library: ${this.options.serverName}`);return}E.fire(P.VSBuffer.wrap(Buffer.from(u,"base64")))}),t=this.options.useQueue?(0,f.createQueuedSender)(this.child):this.child,r=u=>this.child&&this.child.connected&&t.send(u.buffer.toString("base64")),a=E.event,n={send:r,onMessage:a};this._client=new y.ChannelClient(n);const c=()=>this.disposeClient();process.once("exit",c),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,S)=>{process.removeListener("exit",c),o.dispose(),this.activeRequests.forEach(D=>(0,l.dispose)(D)),this.activeRequests.clear(),u!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+S),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:S})})}return this._client}getCachedChannel(v){let w=this.channels.get(v);return w||(w=this.client.getChannel(v),this.channels.set(v,w)),w}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(le[120],ce([0,1,8,3,2,81,12]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=b;var R;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function b(g){const y=g;return y?.changed instanceof Map||y?.deleted instanceof Set}var l;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(l||(e.StorageState=l={}));class d extends P.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(y,h=Object.create(null)){super(),this.database=y,this.options=h,this._onDidChangeStorage=this._register(new s.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new i.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){this._onDidChangeStorage.pause();try{y.changed?.forEach((h,m)=>this.acceptExternal(m,h)),y.deleted?.forEach(h=>this.acceptExternal(h,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(y,h){if(this.state===l.Closed)return;let m=!1;(0,A.isUndefinedOrNull)(h)?m=this.cache.delete(y):this.cache.get(y)!==h&&(this.cache.set(y,h),m=!0),m&&this._onDidChangeStorage.fire({key:y,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,h){const m=this.cache.get(y);return(0,A.isUndefinedOrNull)(m)?h:m}getBoolean(y,h){const m=this.get(y);return(0,A.isUndefinedOrNull)(m)?h:m==="true"}getNumber(y,h){const m=this.get(y);return(0,A.isUndefinedOrNull)(m)?h:parseInt(m,10)}getObject(y,h){const m=this.get(y);return(0,A.isUndefinedOrNull)(m)?h:(0,k.parse)(m)}async set(y,h,m=!1){if(this.state===l.Closed)return;if((0,A.isUndefinedOrNull)(h))return this.delete(y,m);const p=(0,A.isObject)(h)||Array.isArray(h)?(0,k.stringify)(h):String(h);if(this.cache.get(y)!==p)return this.cache.set(y,p),this.pendingInserts.set(y,p),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire({key:y,external:m}),this.doFlush()}async delete(y,h=!1){if(!(this.state===l.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire({key:y,external:h}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(!(this.state===l.Closed||this.pendingClose))return this.doFlush(y)}async doFlush(y){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=d;class f{constructor(){this.onDidChangeItemsExternal=s.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert?.forEach((h,m)=>this.items.set(m,h)),y.delete?.forEach(h=>this.items.delete(h))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=f}),define(le[166],ce([0,1,8,3,32,9,21]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class R{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return s.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(d,f=Object.create(null)){this.path=d,this.options=f,this.name=(0,k.basename)(this.path),this.logger=new b(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const d=await this.whenConnected,f=new Map;return(await this.all(d,"SELECT * FROM ItemTable")).forEach(y=>f.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${f.size} rows`),f}async updateItems(d){const f=await this.whenConnected;return this.doUpdateItems(f,d)}doUpdateItems(d,f){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${f.insert?(0,P.mapToString)(f.insert):"0"}), delete(${f.delete?(0,P.setToString)(f.delete):"0"})`),this.transaction(d,()=>{const g=f.insert,y=f.delete;if(g&&g.size>0){const h=[];h.push([]);let m=0;g.forEach((p,v)=>{let w=h[m];w.length>R.MAX_HOST_PARAMETERS&&(m++,w=[],h.push(w)),w.push(v,p)}),h.forEach(p=>{this.prepare(d,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,v=>v.run(p),()=>{const v=[];let w=0;return g.forEach((E,I)=>{v.push(I),w+=E.length}),`Keys: ${v.join(", ")} Length: ${w}`})})}if(y&&y.size){const h=[];h.push([]);let m=0;y.forEach(p=>{let v=h[m];v.length>R.MAX_HOST_PARAMETERS&&(m++,v=[],h.push(v)),v.push(p)}),h.forEach(p=>{this.prepare(d,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,v=>v.run(p),()=>{const v=[];return y.forEach(w=>{v.push(w)}),`Keys: ${v.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const d=await this.whenConnected;return this.exec(d,"VACUUM")}async close(d){this.logger.trace(`[storage ${this.name}] close()`);const f=await this.whenConnected;return this.doClose(f,d)}doClose(d,f){return new Promise((g,y)=>{d.db.close(h=>(h&&this.handleSQLiteError(d,`[storage ${this.name}] close(): ${h}`),this.path===R.IN_MEMORY_PATH?g():!d.isErroneous&&!d.isInMemory?this.backup().then(g,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),g())):typeof f=="function"?A.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const p=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:f()}).then(()=>p(),v=>(p(),Promise.reject(v)))})).then(g,y):y(h||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const d=this.toBackupPath(this.path);return A.Promises.copy(this.path,d,{preserveSymlinks:!1})}toBackupPath(d){return`${d}.backup`}async checkIntegrity(d){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${d})`);const f=await this.whenConnected,g=await this.get(f,d?"PRAGMA integrity_check":"PRAGMA quick_check"),y=d?g.integrity_check:g.quick_check;return f.isErroneous?`${y} (last error: ${f.lastError})`:f.isInMemory?`${y} (in-memory!)`:y}async connect(d,f=!0){this.logger.trace(`[storage ${this.name}] open(${d}, retryOnBusy: ${f})`);try{return await this.doConnect(d)}catch(g){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${g}`),g.code==="SQLITE_BUSY"&&f)return await(0,i.timeout)(R.BUSY_OPEN_TIMEOUT),this.connect(d,!1);try{await A.Promises.unlink(d);try{await A.Promises.rename(this.toBackupPath(d),d,!1)}catch{}return await this.doConnect(d)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(R.IN_MEMORY_PATH)}}}handleSQLiteError(d,f){d.isErroneous=!0,d.lastError=f,this.logger.error(f)}doConnect(d){return new Promise((f,g)=>{new Promise((y,h)=>{K(["@vscode/sqlite3"],y,h)}).then(y=>{const h={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(d,m=>m?h.db&&m.code!=="SQLITE_CANTOPEN"?h.db.close(()=>g(m)):g(m):this.exec(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>f(h),p=>h.db.close(()=>g(p)))),isInMemory:d===R.IN_MEMORY_PATH};h.db.on("error",m=>this.handleSQLiteError(h,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&h.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},g)})}exec(d,f){return new Promise((g,y)=>{d.db.exec(f,h=>h?(this.handleSQLiteError(d,`[storage ${this.name}] exec(): ${h}`),y(h)):g())})}get(d,f){return new Promise((g,y)=>{d.db.get(f,(h,m)=>h?(this.handleSQLiteError(d,`[storage ${this.name}] get(): ${h}`),y(h)):g(m))})}all(d,f){return new Promise((g,y)=>{d.db.all(f,(h,m)=>h?(this.handleSQLiteError(d,`[storage ${this.name}] all(): ${h}`),y(h)):g(m))})}transaction(d,f){return new Promise((g,y)=>{d.db.serialize(()=>{d.db.run("BEGIN TRANSACTION"),f(),d.db.run("END TRANSACTION",h=>h?(this.handleSQLiteError(d,`[storage ${this.name}] transaction(): ${h}`),y(h)):g())})})}prepare(d,f,g,y){const h=d.db.prepare(f),m=p=>{this.handleSQLiteError(d,`[storage ${this.name}] prepare(): ${p} (${f}). Details: ${y()}`)};h.on("error",m),g(h),h.finalize(p=>{p&&m(p),h.removeListener("error",m)})}}e.SQLiteStorageDatabase=R;class b{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(d){d&&typeof d.logTrace=="function"&&process.env[b.VSCODE_TRACE_STORAGE]&&(this.logTrace=d.logTrace),d&&typeof d.logError=="function"&&(this.logError=d.logError)}get isTracing(){return!!this.logTrace}trace(d){this.logTrace?.(d)}error(d){this.logError?.(d)}}}),define(le[167],ce([11,10]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(le[168],ce([11,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[169],ce([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(le[170],ce([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(le[171],ce([11,10]),function(K,e){return K.create("vs/platform/dialogs/common/dialogs",e)}),define(le[172],ce([11,10]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(le[173],ce([11,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(le[174],ce([11,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(le[175],ce([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[176],ce([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[177],ce([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[178],ce([11,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[179],ce([11,10]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(le[180],ce([11,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(le[181],ce([11,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(le[182],ce([11,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(le[183],ce([11,10]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(le[184],ce([11,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[185],ce([11,10]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(le[186],ce([11,10]),function(K,e){return K.create("vs/platform/log/common/log",e)}),define(le[187],ce([11,10]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(le[188],ce([11,10]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(le[189],ce([11,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(le[190],ce([11,10]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(le[191],ce([11,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[192],ce([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(le[193],ce([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalProfiles",e)}),define(le[194],ce([11,10]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(le[195],ce([11,10]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[196],ce([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowImpl",e)}),define(le[197],ce([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(le[198],ce([11,10]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(le[199],ce([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(le[200],ce([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(le[201],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isFolderBackupInfo=i,e.isWorkspaceBackupInfo=s;function i(P){return P&&P.hasOwnProperty("folderUri")}function s(P){return P&&P.hasOwnProperty("workspace")}}),define(le[202],ce([0,1,7]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=s,e.deserializeWorkspaceInfos=P,e.deserializeFolderInfos=k;function s(A){return typeof A?.backupFolder=="string"}function P(A){let R=[];try{Array.isArray(A.workspaces)&&(R=A.workspaces.map(b=>({workspace:{id:b.id,configPath:i.URI.parse(b.configURIPath)},remoteAuthority:b.remoteAuthority})))}catch{}return R}function k(A){let R=[];try{Array.isArray(A.folders)&&(R=A.folders.map(b=>({folderUri:i.URI.parse(b.folderUri),remoteAuthority:b.remoteAuthority})))}catch{}return R}}),define(le[203],ce([0,1,39,16,170]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...d){switch(d.length){case 1:return(0,P.localize)(0,null,d[0]);case 2:return(0,P.localize)(1,null,d[0],d[1]);case 3:return(0,P.localize)(2,null,d[0],d[1],d[2]);default:return}}const R=(0,P.localize)(3,null),b=(0,P.localize)(4,null);class l{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(f){switch(f.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return f.isTripleEq?"===":"==";case k.NotEq:return f.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return f.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return f.lexeme;case k.QuotedStr:return f.lexeme;case k.Error:return f.lexeme;case k.EOF:return"EOF";default:throw(0,s.illegalState)(`unhandled token type: ${JSON.stringify(f)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(f=>f.charCodeAt(0)))}static{this._keywords=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this._errors}reset(f){return this._input=f,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case i.CharCode.OpenParen:this._addToken(k.LParen);break;case i.CharCode.CloseParen:this._addToken(k.RParen);break;case i.CharCode.ExclamationMark:if(this._match(i.CharCode.Equals)){const g=this._match(i.CharCode.Equals);this._tokens.push({type:k.NotEq,offset:this._start,isTripleEq:g})}else this._addToken(k.Neg);break;case i.CharCode.SingleQuote:this._quotedString();break;case i.CharCode.Slash:this._regex();break;case i.CharCode.Equals:if(this._match(i.CharCode.Equals)){const g=this._match(i.CharCode.Equals);this._tokens.push({type:k.Eq,offset:this._start,isTripleEq:g})}else this._match(i.CharCode.Tilde)?this._addToken(k.RegexOp):this._error(A("==","=~"));break;case i.CharCode.LessThan:this._addToken(this._match(i.CharCode.Equals)?k.LtEq:k.Lt);break;case i.CharCode.GreaterThan:this._addToken(this._match(i.CharCode.Equals)?k.GtEq:k.Gt);break;case i.CharCode.Ampersand:this._match(i.CharCode.Ampersand)?this._addToken(k.And):this._error(A("&&"));break;case i.CharCode.Pipe:this._match(i.CharCode.Pipe)?this._addToken(k.Or):this._error(A("||"));break;case i.CharCode.Space:case i.CharCode.CarriageReturn:case i.CharCode.Tab:case i.CharCode.LineFeed:case i.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(k.EOF),Array.from(this._tokens)}_match(f){return this._isAtEnd()||this._input.charCodeAt(this._current)!==f?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?i.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(f){this._tokens.push({type:f,offset:this._start})}_error(f){const g=this._start,y=this._input.substring(this._start,this._current),h={type:k.Error,offset:this._start,lexeme:y};this._errors.push({offset:g,lexeme:y,additionalInfo:f}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const f=this.stringRe.exec(this._input);if(f){this._current=this._start+f[0].length;const g=this._input.substring(this._start,this._current),y=l._keywords.get(g);y?this._addToken(y):this._tokens.push({type:k.Str,lexeme:g,offset:this._start})}}_quotedString(){for(;this._peek()!==i.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:k.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let f=this._current,g=!1,y=!1;for(;;){if(f>=this._input.length){this._current=f,this._error(b);return}const m=this._input.charCodeAt(f);if(g)g=!1;else if(m===i.CharCode.Slash&&!y){f++;break}else m===i.CharCode.OpenSquareBracket?y=!0:m===i.CharCode.Backslash?g=!0:m===i.CharCode.CloseSquareBracket&&(y=!1);f++}for(;f<this._input.length&&l._regexFlags.has(this._input.charCodeAt(f));)f++;this._current=f;const h=this._input.substring(this._start,this._current);this._tokens.push({type:k.RegexStr,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=l}),define(le[204],ce([0,1,3,2]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class P{constructor(){this._onCloseEmitter=new i.Emitter,this._onReloadEmitter=new i.Emitter,this._onTerminateEmitter=new i.Emitter,this._onAttachEmitter=new i.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(R,b,l){switch(b){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(R,b,l){switch(b){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=P;class k extends s.Disposable{constructor(R){super(),this.channel=R}reload(R){this.channel.call("reload",[R])}get onReload(){return this.channel.listen("reload")}close(R){this.channel.call("close",[R])}get onClose(){return this.channel.listen("close")}attachSession(R,b,l){this.channel.call("attach",[R,b,l])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(R,b){this.channel.call("terminate",[R,b])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(R,b){return this.channel.call("openExtensionDevelopmentHostWindow",[R,b])}}e.ExtensionHostDebugChannelClient=k}),define(le[205],ce([0,1,154,53,13,9,36,19,7]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=d,e.parseDebugParams=f,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,k.dirname)(P.FileAccess.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const y=(0,i.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",y)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=A.env.VSCODE_PORTABLE;return y?b.URI.file((0,k.join)(y,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,k.resolve)(y):(0,k.normalize)((0,k.join)(P.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const y=this.args["extensions-download-dir"];return y?b.URI.file((0,k.resolve)(y)):b.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,k.resolve)(y);const h=A.env.VSCODE_EXTENSIONS;if(h)return h;const m=A.env.VSCODE_PORTABLE;return m?(0,k.join)(m,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(h=>/^[^:/?#]+?:\/\//.test(h)?b.URI.parse(h):b.URI.file((0,k.normalize)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?b.URI.parse(y):b.URI.file((0,k.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return d(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(y=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(y))}get extensionLogLevel(){const y=[];for(const h of this.args.log||[]){const m=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(h);m&&m[1]&&m[2]&&y.push([m[1],m[2]])}return y.length?y:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=A.env.VSCODE_PORTABLE;return y?b.URI.file((0,k.join)(y,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(y){this.args.continueOn=y}get args(){return this._args}constructor(y,h,m){this._args=y,this.paths=h,this.productService=m,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,Ie([s.memoize],l.prototype,"appRoot",null),Ie([s.memoize],l.prototype,"userHome",null),Ie([s.memoize],l.prototype,"userDataPath",null),Ie([s.memoize],l.prototype,"appSettingsHome",null),Ie([s.memoize],l.prototype,"tmpDir",null),Ie([s.memoize],l.prototype,"cacheHome",null),Ie([s.memoize],l.prototype,"stateResource",null),Ie([s.memoize],l.prototype,"userRoamingDataHome",null),Ie([s.memoize],l.prototype,"userDataSyncHome",null),Ie([s.memoize],l.prototype,"sync",null),Ie([s.memoize],l.prototype,"machineSettingsResource",null),Ie([s.memoize],l.prototype,"workspaceStorageHome",null),Ie([s.memoize],l.prototype,"localHistoryHome",null),Ie([s.memoize],l.prototype,"keyboardLayoutResource",null),Ie([s.memoize],l.prototype,"argvResource",null),Ie([s.memoize],l.prototype,"isExtensionDevelopment",null),Ie([s.memoize],l.prototype,"untitledWorkspacesHome",null),Ie([s.memoize],l.prototype,"builtinExtensionsPath",null),Ie([s.memoize],l.prototype,"extensionsPath",null),Ie([s.memoize],l.prototype,"extensionDevelopmentLocationURI",null),Ie([s.memoize],l.prototype,"extensionDevelopmentKind",null),Ie([s.memoize],l.prototype,"extensionTestsLocationURI",null),Ie([s.memoize],l.prototype,"debugExtensionHost",null),Ie([s.memoize],l.prototype,"logLevel",null),Ie([s.memoize],l.prototype,"extensionLogLevel",null),Ie([s.memoize],l.prototype,"serviceMachineIdResource",null),Ie([s.memoize],l.prototype,"disableTelemetry",null),Ie([s.memoize],l.prototype,"disableWorkspaceTrust",null),Ie([s.memoize],l.prototype,"useInMemorySecretStorage",null),Ie([s.memoize],l.prototype,"policyFile",null);function d(g,y){return f(g["inspect-extensions"],g["inspect-brk-extensions"],5870,y,g.debugId,g.extensionEnvironment)}function f(g,y,h,m,p,v){const E=Number(y||g)||(m?null:h),I=E?!!y:!1;let o;if(v)try{o=JSON.parse(v)}catch{}return{port:E,break:I,debugId:p,env:o}}}),define(le[121],ce([0,1,316,4,173]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=R,e.formatOptions=l,e.buildHelpMessage=y,e.buildVersionMessage=h;const k={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,P.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,P.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},"use-gl":{type:"string"},"use-angle":{type:"string"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(m,p,v=A){const w=m.find(u=>u.length>0&&u[0]!=="-"),E={},I=["_"],o=[],t={};let r;for(const u in p){const S=p[u];S.type==="subcommand"?u===w&&(r=S):(S.alias&&(E[u]=S.alias),S.type==="string"||S.type==="string[]"?(I.push(u),S.deprecates&&I.push(...S.deprecates)):S.type==="boolean"&&(o.push(u),S.deprecates&&o.push(...S.deprecates)),S.global&&(t[u]=S))}if(r&&w){const u=t;for(const M in r.options)u[M]=r.options[M];const S=m.filter(M=>M!==w),D=v.getSubcommandReporter?v.getSubcommandReporter(w):void 0,L=R(S,u,D);return{[w]:L,_:[]}}const a=i(m,{string:I,boolean:o,alias:E}),n={},c=a;n._=a._.map(u=>String(u)).filter(u=>u.length>0),delete c._;for(const u in p){const S=p[u];if(S.type==="subcommand")continue;S.alias&&delete c[S.alias];let D=c[u];if(S.deprecates)for(const L of S.deprecates)c.hasOwnProperty(L)&&(D||(D=c[L],D&&v.onDeprecatedOption(L,S.deprecationMessage||(0,P.localize)(39,null,u))),delete c[L]);if(typeof D<"u"){if(S.type==="string[]"){if(Array.isArray(D)||(D=[D]),!S.allowEmptyValue){const L=D.filter(M=>M.length>0);L.length!==D.length&&(v.onEmptyValue(u),D=L.length>0?L:void 0)}}else S.type==="string"&&(Array.isArray(D)?(D=D.pop(),v.onMultipleValues(u,D)):!D&&!S.allowEmptyValue&&(v.onEmptyValue(u),D=void 0));n[u]=D,S.deprecationMessage&&v.onDeprecatedOption(u,S.deprecationMessage)}delete c[u]}for(const u in c)v.onUnknownOption(u);return n}function b(m,p){let v="";return p.args&&(Array.isArray(p.args)?v=` <${p.args.join("> <")}>`:v=` <${p.args}>`),p.alias?`-${p.alias} --${m}${v}`:`--${m}${v}`}function l(m,p){const v=[];for(const w in m){const E=m[w],I=b(w,E);v.push([I,E.description])}return d(v,p)}function d(m,p){const w=m.reduce((o,t)=>Math.max(o,t[0].length),12)+2+1;if(p-w<25)return m.reduce((o,t)=>o.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const E=p-w-1,I=[];for(const o of m){const t=o[0],r=g(o[1],E),a=f(w-t.length-2);I.push("  "+t+a+r[0]);for(let n=1;n<r.length;n++)I.push(f(w)+r[n])}return I}function f(m){return" ".repeat(m)}function g(m,p){const v=[];for(;m.length;){const w=m.length<p?m.length:m.lastIndexOf(" ",p),E=m.slice(0,w).trim();m=m.slice(w),v.push(E)}return v}function y(m,p,v,w,E){const I=process.stdout.isTTY&&process.stdout.columns||80,o=E?.noInputFiles!==!0?`[${(0,P.localize)(40,null)}...]`:"",t=[`${m} ${v}`];t.push(""),t.push(`${(0,P.localize)(41,null)}: ${p} [${(0,P.localize)(42,null)}]${o}`),t.push(""),E?.noPipe!==!0&&(s.isWindows?t.push((0,P.localize)(43,null,p)):t.push((0,P.localize)(44,null,p)),t.push(""));const r={},a=[];for(const n in w){const c=w[n];if(c.type==="subcommand")c.description&&a.push({command:n,description:c.description});else if(c.description&&c.cat){let u=r[c.cat];u||(r[c.cat]=u={}),u[n]=c}}for(const n in r){const c=n,u=r[c];u&&(t.push(k[c]),t.push(...l(u,I)),t.push(""))}return a.length&&(t.push((0,P.localize)(45,null)),t.push(...d(a.map(n=>[n.command,n.description]),I)),t.push("")),t.join(`
`)}function h(m,p){return`${m||(0,P.localize)(46,null)}
${p||(0,P.localize)(47,null)}
${process.arch}`}}),define(le[67],ce([0,1,317,174,121]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseMainProcessArgv=R,e.parseCLIProcessArgv=b,e.addArg=l,e.isLaunchedFromCli=d;function k(f,g){const y=(E,I)=>{console.warn((0,s.localize)(0,null,E,I))},h=E=>{console.warn((0,s.localize)(1,null,E))},m=(E,I)=>{console.warn((0,s.localize)(2,null,E,I))},p=E=>({onUnknownOption:I=>{P.NATIVE_CLI_COMMANDS.includes(E)||console.warn((0,s.localize)(3,null,I,E))},onMultipleValues:y,onEmptyValue:h,onDeprecatedOption:m,getSubcommandReporter:P.NATIVE_CLI_COMMANDS.includes(E)?p:void 0}),v={onUnknownOption:E=>{console.warn((0,s.localize)(4,null,E))},onMultipleValues:y,onEmptyValue:h,onDeprecatedOption:m,getSubcommandReporter:p},w=(0,P.parseArgs)(f,P.OPTIONS,g?v:void 0);return w.goto&&w._.forEach(E=>i(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(E),(0,s.localize)(5,null))),w}function A(f){const g=f.findIndex(y=>!/^-/.test(y));if(g>-1)return[...f.slice(0,g),...f.slice(g+1)]}function R(f){let[,...g]=f;process.env.VSCODE_DEV&&(g=A(g)||[]);const y=!d(process.env);return k(g,y)}function b(f){let[,,...g]=f;return process.env.VSCODE_DEV&&(g=A(g)||[]),k(g,!0)}function l(f,...g){const y=f.indexOf("--");return y===-1?f.push(...g):f.splice(y,0,...g),f}function d(f){return f.VSCODE_CLI==="1"}}),function(){"use strict";function K(e,i,s){function P(A,R){const b=k(A,R),l=[b];return e.isAbsolute(b)||l.unshift(s),e.resolve(...l)}function k(A,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,R);const d=A["user-data-dir"];if(d)return d;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(f,"AppData","Roaming")}break;case"darwin":l=e.join(i.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,R)}return{getUserDataPath:P}}if(typeof define=="function")define(le[206],ce([122,27,36]),function(e,i,s){return K(e,i,s.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=K(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[95],ce([0,1,27,205,206]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=A,e.parseSharedProcessDebugPort=R;class k extends s.AbstractNativeEnvironmentService{constructor(l,d){super(l,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,P.getUserDataPath)(l,d.nameShort)},d)}}e.NativeEnvironmentService=k;function A(b,l){return(0,s.parseDebugParams)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,l,b.extensionEnvironment)}function R(b,l){return(0,s.parseDebugParams)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,l,b.extensionEnvironment)}}),define(le[207],ce([0,1,44,27,31]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=k;function k(A){const R=(0,P.randomPath)((0,s.tmpdir)());try{return(0,i.writeFileSync)(R,""),A&&console.log(`Marker file for --wait created: ${R}`),R}catch(b){A&&console.error(`Failed to create marker file for --wait: ${b}`);return}}}),define(le[208],ce([0,1,12,176]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=P;function P(A,R,b,l){try{k(A,R,b,l)}catch(d){A.error(d?.message??d)}return R}function k(A,R,b,l){const d=(f,g,y)=>{const h=f[g];if((0,i.isString)(h)){const m=h,p=m.length;if(p>1&&m[0]==="%"&&m[p-1]==="%"){const v=m.substr(1,p-2);let w=b[v];w===void 0&&l&&(w=l[v]);const E=typeof w=="string"?w:w?.message,I=l?.[v],o=typeof I=="string"?I:I?.message;if(!E){o||A.warn(`[${R.name}]: ${(0,s.localize)(0,null,v)}`);return}if(y&&(g==="title"||g==="category")&&o&&o!==E){const t={value:E,original:o};f[g]=t}else f[g]=E}}else if((0,i.isObject)(h))for(const m in h)h.hasOwnProperty(m)&&(m==="commands"?d(h,m,!0):d(h,m,y));else if(Array.isArray(h))for(let m=0;m<h.length;m++)d(h,m,y)};for(const f in R)R.hasOwnProperty(f)&&d(R,f)}}),define(le[209],ce([0,1,19,79,178,210]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=b,e.parseVersion=l,e.normalizeVersion=d,e.isValidVersion=f,e.validateExtensionManifest=g,e.isValidExtensionVersion=y,e.isEngineValid=h;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function b(v){return v=v.trim(),v==="*"||A.test(v)}function l(v){if(!b(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=v.match(A);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}function d(v){if(!v)return null;const w=v.majorBase,E=v.majorMustEqual,I=v.minorBase;let o=v.minorMustEqual;const t=v.patchBase;let r=v.patchMustEqual;v.hasCaret&&(w===0||(o=!1),r=!1);let a=0;if(v.preRelease){const n=R.exec(v.preRelease);if(n){const[,c,u,S]=n;a=Date.UTC(Number(c),Number(u)-1,Number(S))}}return{majorBase:w,majorMustEqual:E,minorBase:I,minorMustEqual:o,patchBase:t,patchMustEqual:r,isMinimum:v.hasGreaterEquals,notBefore:a}}function f(v,w,E){let I;typeof v=="string"?I=d(l(v)):I=v;let o;w instanceof Date?o=w.getTime():typeof w=="string"&&(o=new Date(w).getTime());let t;if(typeof E=="string"?t=d(l(E)):t=E,!I||!t)return!1;const r=I.majorBase,a=I.minorBase,n=I.patchBase;let c=t.majorBase,u=t.minorBase,S=t.patchBase;const D=t.notBefore;let L=t.majorMustEqual,M=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:a>u?!0:a<u||o&&o<D?!1:n>=S:(r===1&&c===0&&(!L||!M||!T)&&(c=1,u=0,S=0,L=!0,M=!1,T=!1),r<c?!1:r>c?!L:a<u?!1:a>u?!M:n<S?!1:n>S?!T:!(o&&o<D))}function g(v,w,E,I,o){const t=[];if(typeof I.publisher<"u"&&typeof I.publisher!="string")return t.push([s.default.Error,P.localize(0,null)]),t;if(typeof I.name!="string")return t.push([s.default.Error,P.localize(1,null,"name")]),t;if(typeof I.version!="string")return t.push([s.default.Error,P.localize(2,null,"version")]),t;if(!I.engines)return t.push([s.default.Error,P.localize(3,null,"engines")]),t;if(typeof I.engines.vscode!="string")return t.push([s.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof I.extensionDependencies<"u"&&!p(I.extensionDependencies))return t.push([s.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof I.activationEvents<"u"){if(!p(I.activationEvents))return t.push([s.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof I.main>"u"&&typeof I.browser>"u")return t.push([s.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof I.extensionKind<"u"&&typeof I.main>"u"&&t.push([s.default.Warning,P.localize(8,null,"extensionKind")]),typeof I.main<"u"){if(typeof I.main!="string")return t.push([s.default.Error,P.localize(9,null,"main")]),t;{const n=(0,i.joinPath)(E,I.main);(0,i.isEqualOrParent)(n,E)||t.push([s.default.Warning,P.localize(10,null,n.path,E.path)])}}if(typeof I.browser<"u"){if(typeof I.browser!="string")return t.push([s.default.Error,P.localize(11,null,"browser")]),t;{const n=(0,i.joinPath)(E,I.browser);(0,i.isEqualOrParent)(n,E)||t.push([s.default.Warning,P.localize(12,null,n.path,E.path)])}}if(!k.valid(I.version))return t.push([s.default.Error,P.localize(13,null)]),t;const r=[];if(!y(v,w,I,o,r))for(const n of r)t.push([s.default.Error,n]);return t}function y(v,w,E,I,o){return I||typeof E.main>"u"&&typeof E.browser>"u"?!0:m(v,w,E.engines.vscode,o)}function h(v,w,E){return v==="*"||m(w,E,v)}function m(v,w,E,I=[]){const o=d(l(E));if(!o)return I.push(P.localize(14,null,E)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return I.push(P.localize(15,null,E)),!1}else if(!o.majorMustEqual)return I.push(P.localize(16,null,E)),!1;return f(v,w,o)?!0:(I.push(P.localize(17,null,v,E)),!1)}function p(v){if(!Array.isArray(v))return!1;for(let w=0,E=v.length;w<E;w++)if(typeof v[w]!="string")return!1;return!0}}),define(le[82],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(P,k=[],A=!1){this.ctor=P,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=i}),define(le[211],ce([0,1,82]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=k,e.getSingletonServiceDescriptors=A;const s=[];var P;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function k(R,b,l){b instanceof i.SyncDescriptor||(b=new i.SyncDescriptor(b,[],!!l)),s.push([R,b])}function A(){return s}}),define(le[212],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(k,A){this.key=k,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class s{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const R=this.lookupOrInsertNode(k),b=this.lookupOrInsertNode(A);R.outgoing.set(b.key,b),b.incoming.set(R.key,R)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(const R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let R=this._nodes.get(A);return R||(R=new i(A,k),this._nodes.set(A,R)),R}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[A,R]of this._nodes)k.push(`${A}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,A]of this._nodes){const R=new Set([k]),b=this._findCycle(A,R);if(b)return b}}_findCycle(k,A){for(const[R,b]of k.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const l=this._findCycle(b,A);if(l)return l;A.delete(R)}}}e.Graph=s}),define(le[6],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=P,e.refineServiceDecorator=k;var i;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(i||(e._util=i={})),e.IInstantiationService=P("instantiationService");function s(A,R,b){R[i.DI_TARGET]===R?R[i.DI_DEPENDENCIES].push({id:A,index:b}):(R[i.DI_DEPENDENCIES]=[{id:A,index:b}],R[i.DI_TARGET]=R)}function P(A){if(i.serviceIds.has(A))return i.serviceIds.get(A);const R=function(b,l,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");s(R,b,d)};return R.toString=()=>A,i.serviceIds.set(A,R),R}function k(A){return A}}),define(le[83],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuxiliaryWindowsMainService=void 0,e.IAuxiliaryWindowsMainService=(0,i.createDecorator)("auxiliaryWindowsMainService")}),define(le[68],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,i.createDecorator)("backupMainService")}),define(le[18],ce([0,1,12,7,6]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=k,e.isConfigurationUpdateOverrides=A,e.ConfigurationTargetToString=b,e.isConfigured=l,e.toValuesTree=d,e.addToValueTree=f,e.removeFromValueTree=g,e.getConfigurationValue=h,e.merge=m,e.getLanguageTagSettingPlainKey=p,e.IConfigurationService=(0,P.createDecorator)("configurationService");function k(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof s.URI)}function A(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||Array.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof s.URI)}var R;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.USER=2]="USER",v[v.USER_LOCAL=3]="USER_LOCAL",v[v.USER_REMOTE=4]="USER_REMOTE",v[v.WORKSPACE=5]="WORKSPACE",v[v.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",v[v.DEFAULT=7]="DEFAULT",v[v.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function b(v){switch(v){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function l(v){return v.applicationValue!==void 0||v.userValue!==void 0||v.userLocalValue!==void 0||v.userRemoteValue!==void 0||v.workspaceValue!==void 0||v.workspaceFolderValue!==void 0}function d(v,w){const E=Object.create(null);for(const I in v)f(E,I,v[I],w);return E}function f(v,w,E,I){const o=w.split("."),t=o.pop();let r=v;for(let a=0;a<o.length;a++){const n=o[a];let c=r[n];switch(typeof c){case"undefined":c=r[n]=Object.create(null);break;case"object":if(c===null){I(`Ignoring ${w} as ${o.slice(0,a+1).join(".")} is null`);return}break;default:I(`Ignoring ${w} as ${o.slice(0,a+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=E}catch{I(`Ignoring ${w} as ${o.join(".")} is ${JSON.stringify(r)}`)}else I(`Ignoring ${w} as ${o.join(".")} is ${JSON.stringify(r)}`)}function g(v,w){const E=w.split(".");y(v,E)}function y(v,w){const E=w.shift();if(w.length===0){delete v[E];return}if(Object.keys(v).indexOf(E)!==-1){const I=v[E];typeof I=="object"&&!Array.isArray(I)&&(y(I,w),Object.keys(I).length===0&&delete v[E])}}function h(v,w,E){function I(r,a){let n=r;for(const c of a){if(typeof n!="object"||n===null)return;n=n[c]}return n}const o=w.split("."),t=I(v,o);return typeof t>"u"?E:t}function m(v,w,E){Object.keys(w).forEach(I=>{I!=="__proto__"&&(I in v?i.isObject(v[I])&&i.isObject(w[I])?m(v[I],w[I],E):E&&(v[I]=w[I]):v[I]=w[I])})}function p(v){return v.replace(/[\[\]]/g,"")}}),define(le[123],ce([0,1,39,4,26,203,6,169,16]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=d,e.validateWhenClauses=a,e.expressionsAreEqualWithConstantSubstitution=n,e.implies=j;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",s.isMacintosh),l.set("isLinux",s.isLinux),l.set("isWindows",s.isWindows),l.set("isWeb",s.isWeb),l.set("isMacNative",s.isMacintosh&&!s.isWeb),l.set("isEdge",s.isEdge),l.set("isFirefox",s.isFirefox),l.set("isChrome",s.isChrome),l.set("isSafari",s.isSafari);function d(J,_){if(l.get(J)!==void 0)throw(0,b.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(J,_)}const f=Object.prototype.hasOwnProperty;var g;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const y={regexParsingWithErrorRecovery:!0},h=(0,R.localize)(0,null),m=(0,R.localize)(1,null),p=(0,R.localize)(2,null),v=(0,R.localize)(3,null),w=(0,R.localize)(4,null),E=(0,R.localize)(5,null),I=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class t{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(_=y){this._config=_,this._scanner=new k.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(_){if(_===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:m});return}this._tokens=this._scanner.reset(_).scan(),this._current=0,this._parsingErrors=[];try{const W=this._expr();if(!this._isAtEnd()){const N=this._peek(),H=N.type===k.TokenType.Str?E:void 0;throw this._parsingErrors.push({message:w,offset:N.offset,lexeme:k.Scanner.getLexeme(N),additionalInfo:H}),t._parseError}return W}catch(W){if(W!==t._parseError)throw W;return}}_expr(){return this._or()}_or(){const _=[this._and()];for(;this._matchOne(k.TokenType.Or);){const W=this._and();_.push(W)}return _.length===1?_[0]:r.or(..._)}_and(){const _=[this._term()];for(;this._matchOne(k.TokenType.And);){const W=this._term();_.push(W)}return _.length===1?_[0]:r.and(..._)}_term(){if(this._matchOne(k.TokenType.Neg)){const _=this._peek();switch(_.type){case k.TokenType.True:return this._advance(),u.INSTANCE;case k.TokenType.False:return this._advance(),S.INSTANCE;case k.TokenType.LParen:{this._advance();const W=this._expr();return this._consume(k.TokenType.RParen,v),W?.negate()}case k.TokenType.Str:return this._advance(),F.create(_.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",_)}}return this._primary()}_primary(){const _=this._peek();switch(_.type){case k.TokenType.True:return this._advance(),r.true();case k.TokenType.False:return this._advance(),r.false();case k.TokenType.LParen:{this._advance();const W=this._expr();return this._consume(k.TokenType.RParen,v),W}case k.TokenType.Str:{const W=_.lexeme;if(this._advance(),this._matchOne(k.TokenType.RegexOp)){const H=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),H.type!==k.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",H);const X=H.lexeme,Q=X.lastIndexOf("/"),$=Q===X.length-1?void 0:this._removeFlagsGY(X.substring(Q+1));let ee;try{ee=new RegExp(X.substring(1,Q),$)}catch{throw this._errExpectedButGot("REGEX",H)}return oe.create(W,ee)}switch(H.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const X=[H.lexeme];this._advance();let Q=this._peek(),$=0;for(let Re=0;Re<H.lexeme.length;Re++)H.lexeme.charCodeAt(Re)===i.CharCode.OpenParen?$++:H.lexeme.charCodeAt(Re)===i.CharCode.CloseParen&&$--;for(;!this._isAtEnd()&&Q.type!==k.TokenType.And&&Q.type!==k.TokenType.Or;){switch(Q.type){case k.TokenType.LParen:$++;break;case k.TokenType.RParen:$--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let Re=0;Re<Q.lexeme.length;Re++)Q.lexeme.charCodeAt(Re)===i.CharCode.OpenParen?$++:H.lexeme.charCodeAt(Re)===i.CharCode.CloseParen&&$--}if($<0)break;X.push(k.Scanner.getLexeme(Q)),this._advance(),Q=this._peek()}const ee=X.join(""),fe=ee.lastIndexOf("/"),me=fe===ee.length-1?void 0:this._removeFlagsGY(ee.substring(fe+1));let we;try{we=new RegExp(ee.substring(1,fe),me)}catch{throw this._errExpectedButGot("REGEX",H)}return r.regex(W,we)}case k.TokenType.QuotedStr:{const X=H.lexeme;this._advance();let Q=null;if(!(0,P.isFalsyOrWhitespace)(X)){const $=X.indexOf("/"),ee=X.lastIndexOf("/");if($!==ee&&$>=0){const fe=X.slice($+1,ee),me=X[ee+1]==="i"?"i":"";try{Q=new RegExp(fe,me)}catch{throw this._errExpectedButGot("REGEX",H)}}}if(Q===null)throw this._errExpectedButGot("REGEX",H);return oe.create(W,Q)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(k.TokenType.Not)){this._consume(k.TokenType.In,p);const H=this._value();return r.notIn(W,H)}switch(this._peek().type){case k.TokenType.Eq:{this._advance();const H=this._value();if(this._previous().type===k.TokenType.QuotedStr)return r.equals(W,H);switch(H){case"true":return r.has(W);case"false":return r.not(W);default:return r.equals(W,H)}}case k.TokenType.NotEq:{this._advance();const H=this._value();if(this._previous().type===k.TokenType.QuotedStr)return r.notEquals(W,H);switch(H){case"true":return r.not(W);case"false":return r.has(W);default:return r.notEquals(W,H)}}case k.TokenType.Lt:return this._advance(),re.create(W,this._value());case k.TokenType.LtEq:return this._advance(),ie.create(W,this._value());case k.TokenType.Gt:return this._advance(),U.create(W,this._value());case k.TokenType.GtEq:return this._advance(),z.create(W,this._value());case k.TokenType.In:return this._advance(),r.in(W,this._value());default:return r.has(W)}}case k.TokenType.EOF:throw this._parsingErrors.push({message:I,offset:_.offset,lexeme:"",additionalInfo:o}),t._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const _=this._peek();switch(_.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this._advance(),_.lexeme;case k.TokenType.True:return this._advance(),"true";case k.TokenType.False:return this._advance(),"false";case k.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(_){return _.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(_){return this._check(_)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(_,W){if(this._check(_))return this._advance();throw this._errExpectedButGot(W,this._peek())}_errExpectedButGot(_,W,N){const H=(0,R.localize)(8,null,_,k.Scanner.getLexeme(W)),X=W.offset,Q=k.Scanner.getLexeme(W);return this._parsingErrors.push({message:H,offset:X,lexeme:Q,additionalInfo:N}),t._parseError}_check(_){return this._peek().type===_}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===k.TokenType.EOF}}e.Parser=t;class r{static false(){return u.INSTANCE}static true(){return S.INSTANCE}static has(_){return D.create(_)}static equals(_,W){return L.create(_,W)}static notEquals(_,W){return C.create(_,W)}static regex(_,W){return oe.create(_,W)}static in(_,W){return M.create(_,W)}static notIn(_,W){return T.create(_,W)}static not(_){return F.create(_)}static and(..._){return q.create(_,null,!0)}static or(..._){return O.create(_,null,!0)}static greater(_,W){return U.create(_,W)}static greaterEquals(_,W){return z.create(_,W)}static smaller(_,W){return re.create(_,W)}static smallerEquals(_,W){return ie.create(_,W)}static{this._parser=new t({regexParsingWithErrorRecovery:!1})}static deserialize(_){return _==null?void 0:this._parser.parse(_)}}e.ContextKeyExpr=r;function a(J){const _=new t({regexParsingWithErrorRecovery:!1});return J.map(W=>(_.parse(W),_.lexingErrors.length>0?_.lexingErrors.map(N=>({errorMessage:N.additionalInfo?(0,R.localize)(9,null,N.additionalInfo):(0,R.localize)(10,null),offset:N.offset,length:N.lexeme.length})):_.parsingErrors.length>0?_.parsingErrors.map(N=>({errorMessage:N.additionalInfo?`${N.message}. ${N.additionalInfo}`:N.message,offset:N.offset,length:N.lexeme.length})):[]))}function n(J,_){const W=J?J.substituteConstants():void 0,N=_?_.substituteConstants():void 0;return!W&&!N?!0:!W||!N?!1:W.equals(N)}function c(J,_){return J.cmp(_)}class u{static{this.INSTANCE=new u}constructor(){this.type=g.False}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=u;class S{static{this.INSTANCE=new S}constructor(){this.type=g.True}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return u.INSTANCE}}e.ContextKeyTrueExpr=S;class D{static create(_,W=null){const N=l.get(_);return typeof N=="boolean"?N?S.INSTANCE:u.INSTANCE:new D(_,W)}constructor(_,W){this.key=_,this.negated=W,this.type=g.Defined}cmp(_){return _.type!==this.type?this.type-_.type:V(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=l.get(this.key);return typeof _=="boolean"?_?S.INSTANCE:u.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=F.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=D;class L{static create(_,W,N=null){if(typeof W=="boolean")return W?D.create(_,N):F.create(_,N);const H=l.get(_);return typeof H=="boolean"?W===(H?"true":"false")?S.INSTANCE:u.INSTANCE:new L(_,W,N)}constructor(_,W,N){this.key=_,this.value=W,this.negated=N,this.type=g.Equals}cmp(_){return _.type!==this.type?this.type-_.type:ae(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=l.get(this.key);if(typeof _=="boolean"){const W=_?"true":"false";return this.value===W?S.INSTANCE:u.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=L;class M{static create(_,W){return new M(_,W)}constructor(_,W){this.key=_,this.valueKey=W,this.type=g.In,this.negated=null}cmp(_){return _.type!==this.type?this.type-_.type:ae(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const W=_.getValue(this.valueKey),N=_.getValue(this.key);return Array.isArray(W)?W.includes(N):typeof N=="string"&&typeof W=="object"&&W!==null?f.call(W,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=T.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=M;class T{static create(_,W){return new T(_,W)}constructor(_,W){this.key=_,this.valueKey=W,this.type=g.NotIn,this._negated=M.create(_,W)}cmp(_){return _.type!==this.type?this.type-_.type:this._negated.cmp(_._negated)}equals(_){return _.type===this.type?this._negated.equals(_._negated):!1}substituteConstants(){return this}evaluate(_){return!this._negated.evaluate(_)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(_){return _.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=T;class C{static create(_,W,N=null){if(typeof W=="boolean")return W?F.create(_,N):D.create(_,N);const H=l.get(_);return typeof H=="boolean"?W===(H?"true":"false")?u.INSTANCE:S.INSTANCE:new C(_,W,N)}constructor(_,W,N){this.key=_,this.value=W,this.negated=N,this.type=g.NotEquals}cmp(_){return _.type!==this.type?this.type-_.type:ae(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=l.get(this.key);if(typeof _=="boolean"){const W=_?"true":"false";return this.value===W?u.INSTANCE:S.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=C;class F{static create(_,W=null){const N=l.get(_);return typeof N=="boolean"?N?u.INSTANCE:S.INSTANCE:new F(_,W)}constructor(_,W){this.key=_,this.negated=W,this.type=g.Not}cmp(_){return _.type!==this.type?this.type-_.type:V(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=l.get(this.key);return typeof _=="boolean"?_?u.INSTANCE:S.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=D.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=F;function x(J,_){if(typeof J=="string"){const W=parseFloat(J);isNaN(W)||(J=W)}return typeof J=="string"||typeof J=="number"?_(J):u.INSTANCE}class U{static create(_,W,N=null){return x(W,H=>new U(_,H,N))}constructor(_,W,N){this.key=_,this.value=W,this.negated=N,this.type=g.Greater}cmp(_){return _.type!==this.type?this.type-_.type:ae(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ie.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=U;class z{static create(_,W,N=null){return x(W,H=>new z(_,H,N))}constructor(_,W,N){this.key=_,this.value=W,this.negated=N,this.type=g.GreaterEquals}cmp(_){return _.type!==this.type?this.type-_.type:ae(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=z;class re{static create(_,W,N=null){return x(W,H=>new re(_,H,N))}constructor(_,W,N){this.key=_,this.value=W,this.negated=N,this.type=g.Smaller}cmp(_){return _.type!==this.type?this.type-_.type:ae(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=re;class ie{static create(_,W,N=null){return x(W,H=>new ie(_,H,N))}constructor(_,W,N){this.key=_,this.value=W,this.negated=N,this.type=g.SmallerEquals}cmp(_){return _.type!==this.type?this.type-_.type:ae(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ie;class oe{static create(_,W){return new oe(_,W)}constructor(_,W){this.key=_,this.regexp=W,this.type=g.Regex,this.negated=null}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const W=this.regexp?this.regexp.source:"",N=_.regexp?_.regexp.source:"";return W<N?-1:W>N?1:0}equals(_){if(_.type===this.type){const W=this.regexp?this.regexp.source:"",N=_.regexp?_.regexp.source:"";return this.key===_.key&&W===N}return!1}substituteConstants(){return this}evaluate(_){const W=_.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=G.create(this)),this.negated}}e.ContextKeyRegexExpr=oe;class G{static create(_){return new G(_)}constructor(_){this._actual=_,this.type=g.NotRegex}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(_){return new G(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=G;function te(J){let _=null;for(let W=0,N=J.length;W<N;W++){const H=J[W].substituteConstants();if(J[W]!==H&&_===null){_=[];for(let X=0;X<W;X++)_[X]=J[X]}_!==null&&(_[W]=H)}return _===null?J:_}class q{static create(_,W,N){return q._normalizeArr(_,W,N)}constructor(_,W){this.expr=_,this.negated=W,this.type=g.And}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let W=0,N=this.expr.length;W<N;W++){const H=c(this.expr[W],_.expr[W]);if(H!==0)return H}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let W=0,N=this.expr.length;W<N;W++)if(!this.expr[W].equals(_.expr[W]))return!1;return!0}return!1}substituteConstants(){const _=te(this.expr);return _===this.expr?this:q.create(_,this.negated,!1)}evaluate(_){for(let W=0,N=this.expr.length;W<N;W++)if(!this.expr[W].evaluate(_))return!1;return!0}static _normalizeArr(_,W,N){const H=[];let X=!1;for(const Q of _)if(Q){if(Q.type===g.True){X=!0;continue}if(Q.type===g.False)return u.INSTANCE;if(Q.type===g.And){H.push(...Q.expr);continue}H.push(Q)}if(H.length===0&&X)return S.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(c);for(let Q=1;Q<H.length;Q++)H[Q-1].equals(H[Q])&&(H.splice(Q,1),Q--);if(H.length===1)return H[0];for(;H.length>1;){const Q=H[H.length-1];if(Q.type!==g.Or)break;H.pop();const $=H.pop(),ee=H.length===0,fe=O.create(Q.expr.map(me=>q.create([me,$],null,N)),null,ee);fe&&(H.push(fe),H.sort(c))}if(H.length===1)return H[0];if(N){for(let Q=0;Q<H.length;Q++)for(let $=Q+1;$<H.length;$++)if(H[Q].negate().equals(H[$]))return u.INSTANCE;if(H.length===1)return H[0]}return new q(H,W)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(const W of this.expr)_.push(...W.keys());return _}map(_){return new q(this.expr.map(W=>W.map(_)),null)}negate(){if(!this.negated){const _=[];for(const W of this.expr)_.push(W.negate());this.negated=O.create(_,this,!0)}return this.negated}}e.ContextKeyAndExpr=q;class O{static create(_,W,N){return O._normalizeArr(_,W,N)}constructor(_,W){this.expr=_,this.negated=W,this.type=g.Or}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let W=0,N=this.expr.length;W<N;W++){const H=c(this.expr[W],_.expr[W]);if(H!==0)return H}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let W=0,N=this.expr.length;W<N;W++)if(!this.expr[W].equals(_.expr[W]))return!1;return!0}return!1}substituteConstants(){const _=te(this.expr);return _===this.expr?this:O.create(_,this.negated,!1)}evaluate(_){for(let W=0,N=this.expr.length;W<N;W++)if(this.expr[W].evaluate(_))return!0;return!1}static _normalizeArr(_,W,N){let H=[],X=!1;if(_){for(let Q=0,$=_.length;Q<$;Q++){const ee=_[Q];if(ee){if(ee.type===g.False){X=!0;continue}if(ee.type===g.True)return S.INSTANCE;if(ee.type===g.Or){H=H.concat(ee.expr);continue}H.push(ee)}}if(H.length===0&&X)return u.INSTANCE;H.sort(c)}if(H.length!==0){if(H.length===1)return H[0];for(let Q=1;Q<H.length;Q++)H[Q-1].equals(H[Q])&&(H.splice(Q,1),Q--);if(H.length===1)return H[0];if(N){for(let Q=0;Q<H.length;Q++)for(let $=Q+1;$<H.length;$++)if(H[Q].negate().equals(H[$]))return S.INSTANCE;if(H.length===1)return H[0]}return new O(H,W)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(const W of this.expr)_.push(...W.keys());return _}map(_){return new O(this.expr.map(W=>W.map(_)),null)}negate(){if(!this.negated){const _=[];for(const W of this.expr)_.push(W.negate());for(;_.length>1;){const W=_.shift(),N=_.shift(),H=[];for(const X of ne(W))for(const Q of ne(N))H.push(q.create([X,Q],null,!1));_.unshift(O.create(H,null,!1))}this.negated=O.create(_,this,!0)}return this.negated}}e.ContextKeyOrExpr=O;class B extends D{static{this._info=[]}static all(){return B._info.values()}constructor(_,W,N){super(_,null),this._defaultValue=W,typeof N=="object"?B._info.push({...N,key:_}):N!==!0&&B._info.push({key:_,description:N,type:W!=null?typeof W:void 0})}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return L.create(this.key,_)}notEqualsTo(_){return C.create(this.key,_)}}e.RawContextKey=B,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function V(J,_){return J<_?-1:J>_?1:0}function ae(J,_,W,N){return J<W?-1:J>W?1:_<N?-1:_>N?1:0}function j(J,_){if(J.type===g.False||_.type===g.True)return!0;if(J.type===g.Or)return _.type===g.Or?he(J.expr,_.expr):!1;if(_.type===g.Or){for(const W of _.expr)if(j(J,W))return!0;return!1}if(J.type===g.And){if(_.type===g.And)return he(_.expr,J.expr);for(const W of J.expr)if(j(W,_))return!0;return!1}return J.equals(_)}function he(J,_){let W=0,N=0;for(;W<J.length&&N<_.length;){const H=J[W].cmp(_[N]);if(H<0)return!1;H===0&&W++,N++}return W===J.length}function ne(J){return J.type===g.Or?J.expr:[J]}}),define(le[96],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=s,e.ID="diagnosticsService",e.IDiagnosticsService=(0,i.createDecorator)(e.ID);function s(k){return!!k.hostName&&!!k.errorMessage}class P{async getPerformanceInfo(A,R){return{}}async getSystemInfo(A,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,R){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=P}),define(le[124],ce([0,1,19,79,171,6,49,4,35]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=y,e.massageMessageBoxOptions=h,e.IDialogService=(0,k.createDecorator)("dialogService");var l;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(l||(l={}));class d{getConfirmationButtons(p){return this.getButtons(p,l.Confirmation)}getPromptButtons(p){return this.getButtons(p,l.Prompt)}getInputButtons(p){return this.getButtons(p,l.Input)}getButtons(p,v){const w=[];switch(v){case l.Confirmation:{const E=p;E.primaryButton?w.push(E.primaryButton):w.push((0,P.localize)(0,null)),E.cancelButton?w.push(E.cancelButton):w.push((0,P.localize)(1,null));break}case l.Prompt:{const E=p;Array.isArray(E.buttons)&&E.buttons.length>0&&w.push(...E.buttons.map(I=>I.label)),E.cancelButton&&(E.cancelButton===!0?w.push((0,P.localize)(2,null)):typeof E.cancelButton=="string"?w.push(E.cancelButton):E.cancelButton.label?w.push(E.cancelButton.label):w.push((0,P.localize)(3,null))),w.length===0&&w.push((0,P.localize)(4,null));break}case l.Input:{const E=p;E.primaryButton?w.push(E.primaryButton):w.push((0,P.localize)(5,null)),E.cancelButton?w.push(E.cancelButton):w.push((0,P.localize)(6,null));break}}return w}getDialogType(p){if(typeof p=="string")return p;if(typeof p=="number")return p===s.default.Info?"info":p===s.default.Error?"error":p===s.default.Warning?"warning":"none"}getPromptResult(p,v,w){const E=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&E.push(p.cancelButton);let I=E[v]?.run({checkboxChecked:w});return I instanceof Promise||(I=Promise.resolve(I)),{result:I,checkboxChecked:w}}}e.AbstractDialogHandler=d,e.IFileDialogService=(0,k.createDecorator)("fileDialogService");var f;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(f||(e.ConfirmResult=f={}));const g=10;function y(m){const p=[];return p.push(...m.slice(0,g).map(v=>typeof v=="string"?v:(0,i.basename)(v))),m.length>g&&(m.length-g===1?p.push((0,P.localize)(7,null)):p.push((0,P.localize)(8,null,m.length-g))),p.push(""),p.join(`
`)}function h(m,p){const v=(0,b.deepClone)(m);let w=(v.buttons??[]).map(t=>(0,A.mnemonicButtonLabel)(t)),E=(m.buttons||[]).map((t,r)=>r),I=0,o=v.cancelId??w.length-1;if(w.length>1){const t=typeof o=="number"?w[o]:void 0;if(R.isLinux||R.isMacintosh){if(typeof t=="string"&&w.length>1&&o!==1){w.splice(o,1),w.splice(1,0,t);const r=E[o];E.splice(o,1),E.splice(1,0,r),o=1}R.isLinux&&w.length>1&&(w=w.reverse(),E=E.reverse(),I=w.length-1,typeof t=="string"&&(o=I-1))}else if(R.isWindows&&typeof t=="string"&&w.length>1&&o!==w.length-1){w.splice(o,1),w.push(t);const r=E[o];E.splice(o,1),E.push(r),o=w.length-1}}return v.buttons=w,v.defaultId=I,v.cancelId=o,v.noLink=!0,v.title=v.title||p.nameLong,{options:v,buttonIndeces:E}}}),define(le[97],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.isKwallet=k,e.isGnome=A,e.IEncryptionService=(0,i.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,i.createDecorator)("encryptionMainService");var s;(function(R){R.kwallet="kwallet",R.kwallet5="kwallet5",R.gnomeLibsecret="gnome-libsecret",R.basic="basic"})(s||(e.PasswordStoreCLIOption=s={}));var P;(function(R){R.unknown="unknown",R.basicText="basic_text",R.gnomeAny="gnome_any",R.gnomeLibsecret="gnome_libsecret",R.gnomeKeyring="gnome_keyring",R.kwallet="kwallet",R.kwallet5="kwallet5",R.kwallet6="kwallet6",R.dplib="dpapi",R.keychainAccess="keychain_access"})(P||(e.KnownStorageProvider=P={}));function k(R){return R===P.kwallet||R===P.kwallet5||R===P.kwallet6}function A(R){return R===P.gnomeAny||R===P.gnomeLibsecret||R===P.gnomeKeyring}}),define(le[38],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(le[213],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,i.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(le[214],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,i.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(le[215],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,i.createDecorator)("externalTerminal")}),define(le[216],ce([0,1,50,53,13,9,4,80,21,94,179,214]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const g=d.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends y{static{this.CMD="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(i,o,l.getWindowsShell(),t)}spawnTerminal(o,t,r,a){const n=t.windowsExec||h.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const c=k.basename(n,".exe").toLowerCase();if(c==="cmder")return o.spawn(n,a?[a]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return n.indexOf(" ")>=0&&u.push('""'),u.push(n),c==="wt"&&u.push("-d ."),new Promise((S,D)=>{const L=v(process),M=o.spawn(r,u,{cwd:a,env:L,detached:!0});M.on("error",D),M.on("exit",()=>S())})}async runInTerminal(o,t,r,a,n){const c="windowsExec"in n&&n.windowsExec?n.windowsExec:h.getDefaultTerminalWindows(),u=await h.getWtExePath();return new Promise((S,D)=>{const L=`"${t} - ${g}"`,M=`"${r.join('" "')}" & pause`,T=Object.assign({},v(process),a);Object.keys(T).filter(z=>T[z]===null).forEach(z=>delete T[z]);const C={cwd:t,env:T,windowsVerbatimArguments:!0};let F,x;k.basename(c,".exe")==="wt"?(F=c,x=["-d",".",h.CMD,"/c",M]):u?(F=u,x=["-d",".",c,"/c",M]):(F=h.CMD,x=["/c","start",L,"/wait",c,"/c",`"${M}"`]),i.spawn(F,x,C).on("error",z=>{D(w(z))}),S(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const o=await l.win32.findExecutable("wt");return await b.Promises.exists(o)?o:void 0}catch{return}}}e.WindowsExternalTerminalService=h,Ie([s.memoize],h,"getWtExePath",null);class m extends y{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(i,o,t)}runInTerminal(o,t,r,a,n){const c=n.osxExec||f.DEFAULT_TERMINAL_OSX;return new Promise((u,S)=>{if(c===f.DEFAULT_TERMINAL_OSX||c==="iTerm.app"){const D=c===f.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[P.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",o||g,"-w",t];for(const F of r)M.push("-a"),M.push(F);if(a){const F=Object.assign({},v(process),a);for(const x in F){const U=F[x];U===null?(M.push("-u"),M.push(x)):(M.push("-e"),M.push(`${x}=${U}`))}}let T="";const C=i.spawn(m.OSASCRIPT,M);C.on("error",F=>{S(w(F))}),C.stderr.on("data",F=>{T+=F.toString()}),C.on("exit",F=>{if(F===0)u(void 0);else if(T){const x=T.split(`
`,1);S(new Error(x[0]))}else S(new Error(d.localize(1,null,D,F)))})}else S(new Error(d.localize(2,null,c)))})}spawnTerminal(o,t,r){const a=t.osxExec||f.DEFAULT_TERMINAL_OSX;return new Promise((n,c)=>{const u=["-a",a];r&&u.push(r);const S=v(process),D=o.spawn("/usr/bin/open",u,{cwd:r,env:S});D.on("error",c),D.on("exit",()=>n())})}}e.MacExternalTerminalService=m;class p extends y{static{this.WAIT_MESSAGE=d.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(i,o,t)}runInTerminal(o,t,r,a,n){const c=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((u,S)=>{const D=[];c.then(L=>{L.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const M=`${E(r)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;D.push(`''${M}''`);const T=Object.assign({},v(process),a);Object.keys(T).filter(U=>T[U]===null).forEach(U=>delete T[U]);const C={cwd:t,env:T};let F="";const x=i.spawn(L,D,C);x.on("error",U=>{S(w(U))}),x.stderr.on("data",U=>{F+=U.toString()}),x.on("exit",U=>{if(U===0)u(void 0);else if(F){const z=F.split(`
`,1);S(new Error(z[0]))}else S(new Error(d.localize(4,null,L,U)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await b.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,t,r){const a=t.linuxExec?Promise.resolve(t.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,c)=>{a.then(u=>{const S=v(process),D=o.spawn(u,[],{cwd:r,env:S});D.on("error",c),D.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=p;function v(I){const o={...I.env};return(0,R.sanitizeProcessEnvironment)(o),o}function w(I){return"errno"in I&&I.errno==="ENOENT"&&"path"in I&&typeof I.path=="string"?new Error(d.localize(5,null,I.path)):I}function E(I){let o="";for(const t of I)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(le[15],ce([0,1,61,9,26,12,7,181,6,4,13,65]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=g,e.isFileSystemWatcher=p,e.hasReadWriteCapability=w,e.hasFileFolderCopyCapability=E,e.hasFileCloneCapability=I,e.hasOpenReadWriteCloseCapability=o,e.hasFileReadStreamCapability=t,e.hasFileAtomicReadCapability=r,e.hasFileAtomicWriteCapability=a,e.hasFileAtomicDeleteCapability=n,e.hasReadonlyCapability=c,e.createFileSystemProviderError=D,e.ensureFileSystemProviderError=L,e.markAsFileSystemProviderError=M,e.toFileSystemProviderErrorCode=T,e.toFileOperationResult=C,e.isParent=re,e.etag=O,e.whenProviderRegistered=B,e.getLargeFileConfirmationLimit=ae,e.IFileService=(0,b.createDecorator)("fileService");function g(j){return j.create===!0}var y;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var h;(function(j){j[j.Readonly=1]="Readonly",j[j.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var m;(function(j){j[j.UPDATED=2]="UPDATED",j[j.ADDED=4]="ADDED",j[j.DELETED=8]="DELETED"})(m||(e.FileChangeFilter=m={}));function p(j){const he=j;return!!he&&typeof he.onDidChange=="function"}var v;(function(j){j[j.None=0]="None",j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileAtomicWrite=32768]="FileAtomicWrite",j[j.FileAtomicDelete=65536]="FileAtomicDelete",j[j.FileClone=131072]="FileClone"})(v||(e.FileSystemProviderCapabilities=v={}));function w(j){return!!(j.capabilities&v.FileReadWrite)}function E(j){return!!(j.capabilities&v.FileFolderCopy)}function I(j){return!!(j.capabilities&v.FileClone)}function o(j){return!!(j.capabilities&v.FileOpenReadWriteClose)}function t(j){return!!(j.capabilities&v.FileReadStream)}function r(j){return w(j)?!!(j.capabilities&v.FileAtomicRead):!1}function a(j){return w(j)?!!(j.capabilities&v.FileAtomicWrite):!1}function n(j){return!!(j.capabilities&v.FileAtomicDelete)}function c(j){return!!(j.capabilities&v.Readonly)}var u;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsStorageQuota="EntryExceedsStorageQuota",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class S extends Error{static create(he,ne){const J=new S(he.toString(),ne);return M(J,ne),J}constructor(he,ne){super(he),this.code=ne}}e.FileSystemProviderError=S;function D(j,he){return S.create(j,he)}function L(j){return j||D((0,R.localize)(0,null),u.Unknown)}function M(j,he){return j.name=he?`${he} (FileSystemError)`:"FileSystemError",j}function T(j){if(!j)return u.Unknown;if(j instanceof S)return j.code;const he=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!he)return u.Unknown;switch(he[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function C(j){if(j instanceof ie)return j.fileOperationResult;switch(T(j)){case u.FileNotFound:return te.FILE_NOT_FOUND;case u.FileIsADirectory:return te.FILE_IS_DIRECTORY;case u.FileNotADirectory:return te.FILE_NOT_DIRECTORY;case u.FileWriteLocked:return te.FILE_WRITE_LOCKED;case u.NoPermissions:return te.FILE_PERMISSION_DENIED;case u.FileExists:return te.FILE_MOVE_CONFLICT;case u.FileTooLarge:return te.FILE_TOO_LARGE;default:return te.FILE_OTHER_ERROR}}var F;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class x{constructor(he,ne,J){this.resource=he,this.operation=ne,this.target=J}isOperation(he){return this.operation===he}}e.FileOperationEvent=x;var U;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class z{static{this.MIXED_CORRELATION=null}constructor(he,ne){this.ignorePathCasing=ne,this.correlationId=void 0,this.added=new f.Lazy(()=>{const J=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return J.fill(this.rawAdded.map(_=>[_,!0])),J}),this.updated=new f.Lazy(()=>{const J=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return J.fill(this.rawUpdated.map(_=>[_,!0])),J}),this.deleted=new f.Lazy(()=>{const J=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return J.fill(this.rawDeleted.map(_=>[_,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of he){switch(J.type){case U.ADDED:this.rawAdded.push(J.resource);break;case U.UPDATED:this.rawUpdated.push(J.resource);break;case U.DELETED:this.rawDeleted.push(J.resource);break}this.correlationId!==z.MIXED_CORRELATION&&(typeof J.cId=="number"?this.correlationId===void 0?this.correlationId=J.cId:this.correlationId!==J.cId&&(this.correlationId=z.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=z.MIXED_CORRELATION))}}contains(he,...ne){return this.doContains(he,{includeChildren:!1},...ne)}affects(he,...ne){return this.doContains(he,{includeChildren:!0},...ne)}doContains(he,ne,...J){if(!he)return!1;const _=J.length>0;return!!((!_||J.includes(U.ADDED))&&(this.added.value.get(he)||ne.includeChildren&&this.added.value.findSuperstr(he))||(!_||J.includes(U.UPDATED))&&(this.updated.value.get(he)||ne.includeChildren&&this.updated.value.findSuperstr(he))||(!_||J.includes(U.DELETED))&&(this.deleted.value.findSubstr(he)||ne.includeChildren&&this.deleted.value.findSuperstr(he)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(he){return this.correlationId===he}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=z;function re(j,he,ne){return!j||!he||j===he||he.length>j.length?!1:(he.charAt(he.length-1)!==s.sep&&(he+=s.sep),ne?(0,P.startsWithIgnoreCase)(j,he):j.indexOf(he)===0)}class ie extends Error{constructor(he,ne,J){super(he),this.fileOperationResult=ne,this.options=J}}e.FileOperationError=ie;class oe extends ie{constructor(he,ne,J,_){super(he,ne,_),this.fileOperationResult=ne,this.size=J}}e.TooLargeFileOperationError=oe;class G extends ie{constructor(he,ne,J){super(he,te.FILE_NOT_MODIFIED_SINCE,J),this.stat=ne}}e.NotModifiedSinceFileOperationError=G;var te;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var q;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.ETAG_DISABLED="";function O(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}async function B(j,he){if(!he.hasProvider(A.URI.from({scheme:j.scheme})))return new Promise(ne=>{const J=he.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===j.scheme&&_.added&&(J.dispose(),ne())})})}class V{static{this.KB=1024}static{this.MB=V.KB*V.KB}static{this.GB=V.MB*V.KB}static{this.TB=V.GB*V.KB}static formatSize(he){return(0,k.isNumber)(he)||(he=0),he<V.KB?(0,R.localize)(1,null,he.toFixed(0)):he<V.MB?(0,R.localize)(2,null,(he/V.KB).toFixed(2)):he<V.GB?(0,R.localize)(3,null,(he/V.MB).toFixed(2)):he<V.TB?(0,R.localize)(4,null,(he/V.GB).toFixed(2)):(0,R.localize)(5,null,(he/V.TB).toFixed(2))}}e.ByteSize=V;function ae(j){const he=typeof j=="string"||j?.scheme===d.Schemas.vscodeRemote;return typeof j!="string"&&j?.scheme===d.Schemas.file?1024*V.MB:he?10*V.MB:l.isWeb?50*V.MB:1024*V.MB}}),define(le[125],ce([0,1,17,16,182,15]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=A;async function A(d,f,g,y,h,m){let p;try{await R(d,f,g,y,h,m)}catch(v){p=v}finally{p&&h.errorTransformer&&(p=h.errorTransformer(p)),typeof p<"u"&&g.error(p),g.end()}}async function R(d,f,g,y,h,m){b(m);const p=await d.open(f,{create:!1});try{b(m);let v=0,w=0,E=h&&typeof h.length=="number"?h.length:void 0,I=i.VSBuffer.alloc(Math.min(h.bufferSize,typeof E=="number"?E:h.bufferSize)),o=h&&typeof h.position=="number"?h.position:0,t=0;do w=await d.read(p,o,I.buffer,t,I.byteLength-t),o+=w,t+=w,v+=w,typeof E=="number"&&(E-=w),t===I.byteLength&&(await g.write(y(I)),I=i.VSBuffer.alloc(Math.min(h.bufferSize,typeof E=="number"?E:h.bufferSize)),t=0);while(w>0&&(typeof E!="number"||E>0)&&b(m)&&l(v,h));if(t>0){let r=t;typeof E=="number"&&(r=Math.min(t,E)),g.write(y(I.slice(0,r)))}}catch(v){throw(0,k.ensureFileSystemProviderError)(v)}finally{await d.close(p)}}function b(d){if(d.isCancellationRequested)throw(0,s.canceled)();return!0}function l(d,f){if(typeof f?.limits?.size=="number"&&d>f.limits.size)throw(0,k.createFileSystemProviderError)((0,P.localize)(0,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[62],ce([0,1,113,2,9,4,7,15]),function(K,e,i,s,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=b,e.isRecursiveWatchRequest=l,e.reviveFileChanges=y,e.coalesceEvents=h,e.normalizeWatcherPattern=m,e.parseWatcherPatterns=p,e.isFiltered=w,e.requestFilterToString=E;function b(I){return typeof I.correlationId=="number"}function l(I){return I.recursive===!0}class d extends s.Disposable{static{this.MAX_RESTARTS_PER_REQUEST_ERROR=3}static{this.MAX_RESTARTS_PER_UNKNOWN_ERROR=10}constructor(o,t,r,a){super(),this.onFileChanges=o,this.onLogMessage=t,this.verboseLogging=r,this.options=a,this.watcherDisposables=this._register(new s.MutableDisposable),this.requests=void 0,this.restartsPerRequestError=new Map,this.restartsPerUnknownError=0}init(){const o=new s.DisposableStore;this.watcherDisposables.value=o,this.watcher=this.createWatcher(o),this.watcher.setVerboseLogging(this.verboseLogging),o.add(this.watcher.onDidChangeFile(t=>this.onFileChanges(t))),o.add(this.watcher.onDidLogMessage(t=>this.onLogMessage(t))),o.add(this.watcher.onDidError(t=>this.onError(t.error,t.request)))}onError(o,t){if(this.options.restartOnError&&this.requests?.length)if(t){const r=this.restartsPerRequestError.get(t.path)??0;r<d.MAX_RESTARTS_PER_REQUEST_ERROR?(this.error(`restarting watcher from error in watch request (retrying request): ${o} (${JSON.stringify(t)})`),this.restartsPerRequestError.set(t.path,r+1),this.restart(this.requests)):(this.error(`restarting watcher from error in watch request (skipping request): ${o} (${JSON.stringify(t)})`),this.restart(this.requests.filter(a=>a.path!==t.path)))}else this.restartsPerUnknownError<d.MAX_RESTARTS_PER_UNKNOWN_ERROR?(this.error(`restarting watcher after unknown global error: ${o}`),this.restartsPerUnknownError++,this.restart(this.requests)):this.error(`giving up attempting to restart watcher after error: ${o}`);else this.error(o)}restart(o){this.init(),this.watch(o)}async watch(o){this.requests=o,await this.watcher?.watch(o)}async setVerboseLogging(o){this.verboseLogging=o,await this.watcher?.setVerboseLogging(o)}error(o){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${o}`})}trace(o){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${o}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=d;class f extends d{constructor(o,t,r){super(o,t,r,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=f;class g extends d{constructor(o,t,r){super(o,t,r,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=g;function y(I){return I.map(o=>({type:o.type,resource:A.URI.revive(o.resource),cId:o.cId}))}function h(I){const o=new v;for(const t of I)o.processEvent(t);return o.coalesce()}function m(I,o){return typeof o=="string"&&!o.startsWith(i.GLOBSTAR)&&!(0,P.isAbsolute)(o)?{base:I,pattern:o}:o}function p(I,o){const t=[];for(const r of o)t.push((0,i.parse)(m(I,r)));return t}class v{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(o){return k.isLinux?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const t=this.mapPathToChange.get(this.toKey(o));let r=!1;if(t){const a=t.type,n=o.type;t.resource.fsPath!==o.resource.fsPath&&(o.type===R.FileChangeType.DELETED||o.type===R.FileChangeType.ADDED)?r=!0:a===R.FileChangeType.ADDED&&n===R.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(o)),this.coalesced.delete(t)):a===R.FileChangeType.DELETED&&n===R.FileChangeType.ADDED?t.type=R.FileChangeType.UPDATED:a===R.FileChangeType.ADDED&&n===R.FileChangeType.UPDATED||(t.type=n)}else r=!0;r&&(this.coalesced.add(o),this.mapPathToChange.set(this.toKey(o),o))}coalesce(){const o=[],t=[];return Array.from(this.coalesced).filter(r=>r.type!==R.FileChangeType.DELETED?(o.push(r),!1):!0).sort((r,a)=>r.resource.fsPath.length-a.resource.fsPath.length).filter(r=>t.some(a=>(0,R.isParent)(r.resource.fsPath,a,!k.isLinux))?!1:(t.push(r.resource.fsPath),!0)).concat(o)}}function w(I,o){if(typeof o=="number")switch(I.type){case R.FileChangeType.ADDED:return(o&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(o&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(o&R.FileChangeFilter.UPDATED)===0}return!1}function E(I){if(typeof I=="number"){const o=[];return I&R.FileChangeFilter.ADDED&&o.push("Added"),I&R.FileChangeFilter.DELETED&&o.push("Deleted"),I&R.FileChangeFilter.UPDATED&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(le[217],ce([0,1,17,48,16,3,2,66,33,15,62]),function(K,e,i,s,P,k,A,R,b,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class f extends A.Disposable{constructor(y,h){super(),this.channel=y,this.extraCapabilities=h,this.onDidChangeCapabilities=k.Event.None,this._onDidChange=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=l.FileSystemProviderCapabilities.FileReadWrite|l.FileSystemProviderCapabilities.FileOpenReadWriteClose|l.FileSystemProviderCapabilities.FileReadStream|l.FileSystemProviderCapabilities.FileFolderCopy|l.FileSystemProviderCapabilities.FileWriteUnlock|l.FileSystemProviderCapabilities.FileAtomicRead|l.FileSystemProviderCapabilities.FileAtomicWrite|l.FileSystemProviderCapabilities.FileAtomicDelete|l.FileSystemProviderCapabilities.FileClone,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=l.FileSystemProviderCapabilities.PathCaseSensitive),this.extraCapabilities.trash&&(this._capabilities|=l.FileSystemProviderCapabilities.Trash)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,h){const{buffer:m}=await this.channel.call("readFile",[y,h]);return m}readFileStream(y,h,m){const p=(0,R.newWriteableStream)(w=>i.VSBuffer.concat(w.map(E=>i.VSBuffer.wrap(E))).buffer),v=new A.DisposableStore;return v.add(this.channel.listen("readFileStream",[y,h])(w=>{if(w instanceof i.VSBuffer)p.write(w.buffer);else{if(w==="end")p.end();else{let E;if(w instanceof Error)E=w;else{const I=w;E=(0,l.createFileSystemProviderError)(I.message??(0,s.toErrorMessage)(I),I.code??l.FileSystemProviderErrorCode.Unknown)}p.error(E),p.end()}v.dispose()}})),v.add(m.onCancellationRequested(()=>{p.error((0,P.canceled)()),p.end(),v.dispose()})),p}writeFile(y,h,m){return this.channel.call("writeFile",[y,i.VSBuffer.wrap(h),m])}open(y,h){return this.channel.call("open",[y,h])}close(y){return this.channel.call("close",[y])}async read(y,h,m,p,v){const[w,E]=await this.channel.call("read",[y,h,v]);return m.set(w.buffer.slice(0,E),p),E}write(y,h,m,p,v){return this.channel.call("write",[y,h,i.VSBuffer.wrap(m),p,v])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,h){return this.channel.call("delete",[y,h])}rename(y,h,m){return this.channel.call("rename",[y,h,m])}copy(y,h,m){return this.channel.call("copy",[y,h,m])}cloneFile(y,h){return this.channel.call("cloneFile",[y,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const h=y;this._onDidChange.fire((0,d.reviveFileChanges)(h))}else{const h=y;this._onDidWatchError.fire(h)}}))}watch(y,h){const m=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,m,y,h]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,m]))}}e.DiskFileSystemProviderClient=f}),define(le[218],ce([0,1,44,2,62,3,15,7,8]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class l extends s.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new k.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new s.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new b.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(f=>this.handleDidWatchFail(f)))}handleDidWatchFail(f){this.isCorrelated(f)&&this.suspendWatchRequest(f)}isCorrelated(f){return(0,P.isWatchRequestWithCorrelation)(f)}async watch(f){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new b.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const g of f)this.isCorrelated(g)?this.allCorrelatedWatchRequests.set(g.correlationId,g):this.allNonCorrelatedWatchRequests.add(g);for(const[g]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(g)||(this.suspendedWatchRequests.deleteAndDispose(g),this.suspendedWatchRequestsWithPolling.delete(g));return await this.updateWatchers()}finally{this.joinWatch.complete()}}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(f=>!this.suspendedWatchRequests.has(f.correlationId))])}isSuspended(f){return typeof f.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(f.correlationId)?"polling":this.suspendedWatchRequests.has(f.correlationId)}async suspendWatchRequest(f){if(this.suspendedWatchRequests.has(f.correlationId))return;const g=new s.DisposableStore;this.suspendedWatchRequests.set(f.correlationId,g),await this.joinWatch.p,!g.isDisposed&&(this.monitorSuspendedWatchRequest(f,g),this.updateWatchers())}resumeWatchRequest(f){this.suspendedWatchRequests.deleteAndDispose(f.correlationId),this.suspendedWatchRequestsWithPolling.delete(f.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(f,g){this.doMonitorWithExistingWatcher(f,g)?(this.trace(`reusing an existing recursive watcher to monitor ${f.path}`),this.suspendedWatchRequestsWithPolling.delete(f.correlationId)):(this.doMonitorWithNodeJS(f,g),this.suspendedWatchRequestsWithPolling.add(f.correlationId))}doMonitorWithExistingWatcher(f,g){const y=this.recursiveWatcher?.subscribe(f.path,(h,m)=>{g.isDisposed||(h?this.monitorSuspendedWatchRequest(f,g):m?.type===A.FileChangeType.ADDED&&this.onMonitoredPathAdded(f))});return y?(g.add(y),!0):!1}doMonitorWithNodeJS(f,g){let y=!1;const h=(m,p)=>{if(g.isDisposed)return;const v=this.isPathNotFound(m),w=this.isPathNotFound(p),E=y;y=v,!v&&(w||E)&&this.onMonitoredPathAdded(f)};this.trace(`starting fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,i.watchFile)(f.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},h)}catch(m){this.warn(`fs.watchFile() failed with error ${m} on path ${f.path} (correlationId: ${f.correlationId})`)}g.add((0,s.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,i.unwatchFile)(f.path,h)}catch(m){this.warn(`fs.unwatchFile() failed with error ${m} on path ${f.path} (correlationId: ${f.correlationId})`)}}))}onMonitoredPathAdded(f){this.trace(`detected ${f.path} exists again, resuming watcher (correlationId: ${f.correlationId})`);const g={resource:R.URI.file(f.path),type:A.FileChangeType.ADDED,cId:f.correlationId};this._onDidChangeFile.fire([g]),this.traceEvent(g,f),this.resumeWatchRequest(f)}isPathNotFound(f){return f.ctimeMs===0&&f.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(f,g){if(this.verboseLogging){const y=` >> normalized ${f.type===A.FileChangeType.ADDED?"[ADDED]":f.type===A.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`;this.traceWithCorrelation(y,g)}}traceWithCorrelation(f,g){this.verboseLogging&&this.trace(`${f}${typeof g.correlationId=="number"?` <${g.correlationId}> `:""}`)}requestToString(f){return`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, filter: ${(0,P.requestFilterToString)(f.filter)}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`}async setVerboseLogging(f){this.verboseLogging=f}}e.BaseWatcher=l}),define(le[219],ce([0,1,44,8,23,31,2,76,9,4,19,7,114,21,15,62]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=v;class p extends A.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(E,I,o,t,r,a){super(),this.request=E,this.recursiveWatcher=I,this.onDidFilesChange=o,this.onDidWatchFail=t,this.onLogMessage=r,this.verboseLogging=a,this.throttledFileChangesEmitter=this._register(new s.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.onDidFilesChange(n))),this.fileChangesAggregator=this._register(new s.RunOnceWorker(n=>this.handleFileChanges(n),p.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,m.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,m.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,m.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new P.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const E=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const I=await y.Promises.stat(E);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(E,I.isDirectory()))}catch(E){E.code!=="ENOENT"?this.error(E):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${E})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(E){let I=E.path;try{I=await y.Promises.realpath(E.path),E.path===I&&(I=await(0,g.realcase)(E.path,this.cts.token)??E.path),E.path!==I&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${E.path}, real: ${I})`)}catch{}return I}async doWatch(E,I){const o=new A.DisposableStore;return this.doWatchWithExistingWatcher(E,I,o)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(E,I,o)),o}doWatchWithExistingWatcher(E,I,o){if(I)return!1;const t=f.URI.file(this.request.path),r=this.recursiveWatcher?.subscribe(this.request.path,async(a,n)=>{if(!o.isDisposed)if(a){const c=await this.doWatch(E,I);o.isDisposed?c.dispose():o.add(c)}else n&&(typeof n.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:t,type:n.type,cId:this.request.correlationId},!0)});return r?(o.add(r),!0):!1}async doWatchWithNodeJS(E,I,o){if(l.isMacintosh&&(0,k.isEqualOrParent)(E,"/Volumes/",!0)){this.error(`Refusing to watch ${E} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new P.CancellationTokenSource(this.cts.token);o.add((0,A.toDisposable)(()=>t.dispose(!0)));const r=new A.DisposableStore;o.add(r);try{const a=f.URI.file(this.request.path),n=(0,b.basename)(E),c=(0,i.watch)(E);r.add((0,A.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${E}'`);const u=new Set;if(I)try{for(const D of await y.Promises.readdir(E))u.add(D)}catch(D){this.error(D)}if(t.token.isCancellationRequested)return;const S=new Map;r.add((0,A.toDisposable)(()=>{for(const[,D]of S)D.dispose();S.clear()})),c.on("error",(D,L)=>{t.token.isCancellationRequested||(this.error(`Failed to watch ${E} for changes using fs.watch() (${D}, ${L})`),this.notifyWatchFailed())}),c.on("change",(D,L)=>{if(t.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${D}"] ${L}`);let M="";if(L&&(M=L.toString(),l.isMacintosh&&(M=(0,R.normalizeNFC)(M))),!(!M||D!=="change"&&D!=="rename"))if(I)if(D==="rename"){S.get(M)?.dispose();const T=setTimeout(async()=>{if(S.delete(M),M===n&&!await y.Promises.exists(E)){this.onWatchedPathDeleted(a);return}if(t.token.isCancellationRequested)return;const C=await this.existsChildStrictCase((0,b.join)(E,M));if(t.token.isCancellationRequested)return;let F;C?u.has(M)?F=h.FileChangeType.UPDATED:(F=h.FileChangeType.ADDED,u.add(M)):(u.delete(M),F=h.FileChangeType.DELETED),this.onFileChange({resource:(0,d.joinPath)(a,M),type:F,cId:this.request.correlationId})},p.FILE_DELETE_HANDLER_DELAY);S.set(M,(0,A.toDisposable)(()=>clearTimeout(T)))}else{let T;u.has(M)?T=h.FileChangeType.UPDATED:(T=h.FileChangeType.ADDED,u.add(M)),this.onFileChange({resource:(0,d.joinPath)(a,M),type:T,cId:this.request.correlationId})}else if(D==="rename"||M!==n){const T=setTimeout(async()=>{const C=await y.Promises.exists(E);t.token.isCancellationRequested||(C?(this.onFileChange({resource:a,type:h.FileChangeType.UPDATED,cId:this.request.correlationId},!0),r.add(await this.doWatch(E,!1))):this.onWatchedPathDeleted(a))},p.FILE_DELETE_HANDLER_DELAY);r.clear(),r.add((0,A.toDisposable)(()=>clearTimeout(T)))}else this.onFileChange({resource:a,type:h.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(a){t.token.isCancellationRequested||this.error(`Failed to watch ${E} for changes using fs.watch() (${a.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(E){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:E,type:h.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(E,I=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${E.type===h.FileChangeType.ADDED?"[ADDED]":E.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`),!I&&this.excludes.some(o=>o(E.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${E.resource.fsPath}`):!I&&this.includes&&this.includes.length>0&&!this.includes.some(o=>o(E.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${E.resource.fsPath}`):this.fileChangesAggregator.work(E))}handleFileChanges(E){const I=(0,m.coalesceEvents)(E),o=[];for(const r of I){if((0,m.isFiltered)(r,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${r.resource.fsPath}`);continue}o.push(r)}if(o.length===0)return;if(this.verboseLogging)for(const r of o)this.traceWithCorrelation(` >> normalized ${r.type===h.FileChangeType.ADDED?"[ADDED]":r.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${r.resource.fsPath}`);this.throttledFileChangesEmitter.work(o)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(E){if(l.isLinux)return y.Promises.exists(E);try{const I=(0,b.basename)(E);return(await y.Promises.readdir((0,b.dirname)(E))).some(t=>t===I)}catch(I){return this.trace(I),!1}}setVerboseLogging(E){this.verboseLogging=E}error(E){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${E}`})}warn(E){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${E}`})}trace(E){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${E}`})}traceWithCorrelation(E){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${E}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p;async function v(w,E,I,o,t=512){const r=await y.Promises.open(w,"r"),a=Buffer.allocUnsafe(t),n=new P.CancellationTokenSource(o);let c,u=!1;const S={path:w,excludes:[],recursive:!1},D=new p(S,void 0,L=>{(async()=>{for(const{type:M}of L)if(M===h.FileChangeType.UPDATED){if(u)return;u=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:T}=await y.Promises.read(r,a,0,t,null);if(!T||n.token.isCancellationRequested)break;E(a.slice(0,T))}}catch(T){c=new Error(T),n.dispose(!0)}finally{u=!1}}})()});return await D.ready,I(),new Promise((L,M)=>{n.token.onCancellationRequested(async()=>{D.dispose();try{await y.Promises.close(r)}catch(T){c=new Error(T)}c?M(c):L()})})}}),define(le[220],ce([0,1,3,113,218,4,219,31]),function(K,e,i,s,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends P.BaseWatcher{constructor(d){super(),this.recursiveWatcher=d,this.onDidError=i.Event.None,this.watchers=new Set}async doWatch(d){d=this.removeDuplicateRequests(d);const f=[],g=new Set(Array.from(this.watchers));for(const y of d){const h=this.findWatcher(y);h&&(0,s.patternsEquals)(h.request.excludes,y.excludes)&&(0,s.patternsEquals)(h.request.includes,y.includes)?g.delete(h):f.push(y)}f.length&&this.trace(`Request to start watching: ${f.map(y=>this.requestToString(y)).join(",")}`),g.size&&this.trace(`Request to stop watching: ${Array.from(g).map(y=>this.requestToString(y.request)).join(",")}`);for(const y of g)this.stopWatching(y);for(const y of f)this.startWatching(y)}findWatcher(d){for(const f of this.watchers)if(typeof d.correlationId=="number"||typeof f.request.correlationId=="number"){if(f.request.correlationId===d.correlationId)return f}else if((0,R.isEqual)(f.request.path,d.path,!k.isLinux))return f}startWatching(d){const f=new A.NodeJSFileWatcherLibrary(d,this.recursiveWatcher,y=>this._onDidChangeFile.fire(y),()=>this._onDidWatchFail.fire(d),y=>this._onDidLogMessage.fire(y),this.verboseLogging),g={request:d,instance:f};this.watchers.add(g)}async stop(){await super.stop();for(const d of this.watchers)this.stopWatching(d)}stopWatching(d){this.trace("stopping file watcher",d),this.watchers.delete(d),d.instance.dispose()}removeDuplicateRequests(d){const f=new Map;for(const g of d){const y=k.isLinux?g.path:g.path.toLowerCase();let h=f.get(g.correlationId);h||(h=new Map,f.set(g.correlationId,h)),h.has(y)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(g)}`),h.set(y,g)}return Array.from(f.values()).map(g=>Array.from(g.values())).flat()}async setVerboseLogging(d){super.setVerboseLogging(d);for(const f of this.watchers)f.instance.setVerboseLogging(d)}trace(d,f){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d,f)})}warn(d){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(d)})}toMessage(d,f){return f?`[File Watcher (node.js)] ${d} (${this.requestToString(f.request)})`:`[File Watcher (node.js)] ${d}`}}e.NodeJSWatcher=b}),define(le[221],ce([0,1,62,220]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class P extends i.AbstractNonRecursiveWatcherClient{constructor(A,R,b){super(A,R,b),this.init()}createWatcher(A){return A.add(new s.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=P}),define(le[222],ce([0,1,13,45,165,62]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends k.AbstractUniversalWatcherClient{constructor(b,l,d){super(b,l,d),this.init()}createWatcher(b){const l=b.add(new P.Client(i.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(l.onDidProcessExit(({code:d,signal:f})=>this.onError(`terminated by itself with code ${d}, signal: ${f} (ETERM)`))),s.ProxyChannel.toService((0,s.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(le[98],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...P){this._entries=new Map;for(const[k,A]of P)this.set(k,A)}set(P,k){const A=this._entries.get(P);return this._entries.set(P,k),A}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=i}),define(le[223],ce([0,1,8,16,2,82,212,6,98,109]),function(K,e,i,s,P,k,A,R,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const d=!1;class f extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class g{constructor(p=new b.ServiceCollection,v=!1,w,E=d){this._services=p,this._strict=v,this._parent=w,this._enableTracing=E,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=E?w?._globalGraph??new A.Graph(I=>I):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,P.dispose)(this._children),this._children.clear();for(const p of this._servicesToMaybeDispose)(0,P.isDisposable)(p)&&p.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(p,v){this._throwIfDisposed();const w=this,E=new class extends g{dispose(){w._children.delete(E),super.dispose()}}(p,this._strict,this,this._enableTracing);return this._children.add(E),v?.add(E),E}invokeFunction(p,...v){this._throwIfDisposed();const w=h.traceInvocation(this._enableTracing,p);let E=!1;try{return p({get:o=>{if(E)throw(0,s.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(o,w);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...v)}finally{E=!0,w.stop()}}createInstance(p,...v){this._throwIfDisposed();let w,E;return p instanceof k.SyncDescriptor?(w=h.traceCreation(this._enableTracing,p.ctor),E=this._createInstance(p.ctor,p.staticArguments.concat(v),w)):(w=h.traceCreation(this._enableTracing,p),E=this._createInstance(p,v,w)),w.stop(),E}_createInstance(p,v=[],w){const E=R._util.getServiceDependencies(p).sort((t,r)=>t.index-r.index),I=[];for(const t of E){const r=this._getOrCreateServiceInstance(t.id,w);r||this._throwIfStrict(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),I.push(r)}const o=E.length>0?E[0].index:v.length;if(v.length!==o){console.trace(`[createInstance] First service dependency of ${p.name} at position ${o+1} conflicts with ${v.length} static arguments`);const t=o-v.length;t>0?v=v.concat(new Array(t)):v=v.slice(0,o)}return Reflect.construct(p,v.concat(I))}_setCreatedServiceInstance(p,v){if(this._services.get(p)instanceof k.SyncDescriptor)this._services.set(p,v);else if(this._parent)this._parent._setCreatedServiceInstance(p,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){const v=this._services.get(p);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):v}_getOrCreateServiceInstance(p,v){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(p));const w=this._getServiceInstanceOrDescriptor(p);return w instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,w,v.branch(p,!0)):(v.branch(p,!1),w)}_safeCreateAndCacheServiceInstance(p,v,w){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,v,w)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,v,w){const E=new A.Graph(t=>t.id.toString());let I=0;const o=[{id:p,desc:v,_trace:w}];for(;o.length;){const t=o.pop();if(E.lookupOrInsertNode(t),I++>1e3)throw new f(E);for(const r of R._util.getServiceDependencies(t.desc.ctor)){const a=this._getServiceInstanceOrDescriptor(r.id);if(a||this._throwIfStrict(`[createInstance] ${p} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),a instanceof k.SyncDescriptor){const n={id:r.id,desc:a,_trace:t._trace.branch(r.id,!0)};E.insertEdge(t,n),o.push(n)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new f(E);break}for(const{data:r}of t){if(this._getServiceInstanceOrDescriptor(r.id)instanceof k.SyncDescriptor){const n=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setCreatedServiceInstance(r.id,n)}E.removeNode(r)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,v,w=[],E,I){if(this._services.get(p)instanceof k.SyncDescriptor)return this._createServiceInstance(p,v,w,E,I,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,v,w,E,I);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(p,v,w=[],E,I,o){if(E){const t=new g(void 0,this._strict,this,this._enableTracing);t._globalGraphImplicitDependency=String(p);const r=new Map,a=new i.GlobalIdleValue(()=>{const n=t._createInstance(v,w,I);for(const[c,u]of r){const S=n[c];if(typeof S=="function")for(const D of u)D.disposable=S.apply(n,D.listener)}return r.clear(),o.add(n),n});return new Proxy(Object.create(null),{get(n,c){if(!a.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let D=r.get(c);return D||(D=new l.LinkedList,r.set(c,D)),(M,T,C)=>{if(a.isInitialized)return a.value[c](M,T,C);{const F={listener:[M,T,C],disposable:void 0},x=D.push(F);return(0,P.toDisposable)(()=>{x(),F.disposable?.dispose()})}}}if(c in n)return n[c];const u=a.value;let S=u[c];return typeof S!="function"||(S=S.bind(u),n[c]=S),S},set(n,c,u){return a.value[c]=u,!0},getPrototypeOf(n){return v.prototype}})}else{const t=this._createInstance(v,w,I);return o.add(t),t}}_throwIfStrict(p,v){if(v&&console.warn(p),this._strict)throw new Error(p)}}e.InstantiationService=g;var y;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(y||(y={}));class h{static{this.all=new Set}static{this._None=new class extends h{constructor(){super(y.None,null)}stop(){}branch(){return this}}}static traceInvocation(p,v){return p?new h(y.Invocation,v.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h._None}static traceCreation(p,v){return p?new h(y.Creation,v.name):h._None}static{this._totals=0}constructor(p,v){this.type=p,this.name=v,this._start=Date.now(),this._dep=[]}branch(p,v){const w=new h(y.Branch,p.toString());return this._dep.push([p,v,w]),w}stop(){const p=Date.now()-this._start;h._totals+=p;let v=!1;function w(I,o){const t=[],r=new Array(I+1).join("	");for(const[a,n,c]of o._dep)if(n&&c){v=!0,t.push(`${r}CREATES -> ${a}`);const u=w(I+1,c);u&&t.push(u)}else t.push(`${r}uses -> ${a}`);return t.join(`
`)}const E=[`${this.type===y.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(p>2||v)&&h.all.add(E.join(`
`))}}e.Trace=h}),define(le[224],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueSource=e.IssueType=void 0;var s;(function(k){k[k.Bug=0]="Bug",k[k.PerformanceIssue=1]="PerformanceIssue",k[k.FeatureRequest=2]="FeatureRequest"})(s||(e.IssueType=s={}));var P;(function(k){k.VSCode="vscode",k.Extension="extension",k.Marketplace="marketplace"})(P||(e.IssueSource=P={})),e.IIssueMainService=(0,i.createDecorator)("issueService")}),define(le[5],ce([0,1,186,48,3,47,2,32,4,19,12,7,123,6]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=m,e.log=v,e.getLogLevel=S,e.LogLevelToString=D,e.LogLevelToLocalizedString=L,e.parseLogLevel=M,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function h(){return new Date().toISOString()}function m(T){return(0,d.isNumber)(T)}var p;(function(T){T[T.Off=0]="Off",T[T.Trace=1]="Trace",T[T.Debug=2]="Debug",T[T.Info=3]="Info",T[T.Warning=4]="Warning",T[T.Error=5]="Error"})(p||(e.LogLevel=p={})),e.DEFAULT_LOG_LEVEL=p.Info;function v(T,C,F){switch(C){case p.Trace:T.trace(F);break;case p.Debug:T.debug(F);break;case p.Info:T.info(F);break;case p.Warning:T.warn(F);break;case p.Error:T.error(F);break;case p.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function w(T,C=!1){let F="";for(let x=0;x<T.length;x++){let U=T[x];if(U instanceof Error&&(U=(0,s.toErrorMessage)(U,C)),typeof U=="object")try{U=JSON.stringify(U)}catch{}F+=(x>0?" ":"")+U}return F}class E extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(C){this.level!==C&&(this.level=C,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(C){return this.level!==p.Off&&this.level<=C}}e.AbstractLogger=E;class I extends E{constructor(C){super(),this.logAlways=C}checkLogLevel(C){return this.logAlways||super.checkLogLevel(C)}trace(C,...F){this.checkLogLevel(p.Trace)&&this.log(p.Trace,w([C,...F],!0))}debug(C,...F){this.checkLogLevel(p.Debug)&&this.log(p.Debug,w([C,...F]))}info(C,...F){this.checkLogLevel(p.Info)&&this.log(p.Info,w([C,...F]))}warn(C,...F){this.checkLogLevel(p.Warning)&&this.log(p.Warning,w([C,...F]))}error(C,...F){if(this.checkLogLevel(p.Error))if(C instanceof Error){const x=Array.prototype.slice.call(arguments);x[0]=C.stack,this.log(p.Error,w(x))}else this.log(p.Error,w([C,...F]))}flush(){}}e.AbstractMessageLogger=I;class o extends E{constructor(C=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(C),this.useColors=!b.isWindows}trace(C,...F){this.checkLogLevel(p.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,C,...F):console.log(`[main ${h()}]`,C,...F))}debug(C,...F){this.checkLogLevel(p.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,C,...F):console.log(`[main ${h()}]`,C,...F))}info(C,...F){this.checkLogLevel(p.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,C,...F):console.log(`[main ${h()}]`,C,...F))}warn(C,...F){this.checkLogLevel(p.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,C,...F):console.warn(`[main ${h()}]`,C,...F))}error(C,...F){this.checkLogLevel(p.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,C,...F):console.error(`[main ${h()}]`,C,...F))}flush(){}}e.ConsoleMainLogger=o;class t extends E{constructor(C=e.DEFAULT_LOG_LEVEL,F=!0){super(),this.useColors=F,this.setLevel(C)}trace(C,...F){this.checkLogLevel(p.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",C,...F):console.log(C,...F))}debug(C,...F){this.checkLogLevel(p.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",C,...F):console.log(C,...F))}info(C,...F){this.checkLogLevel(p.Info)&&(this.useColors?console.log("%c INFO","color: #33f",C,...F):console.log(C,...F))}warn(C,...F){this.checkLogLevel(p.Warning)&&(this.useColors?console.log("%c WARN","color: #993",C,...F):console.log(C,...F))}error(C,...F){this.checkLogLevel(p.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",C,...F):console.error(C,...F))}flush(){}}e.ConsoleLogger=t;class r extends E{constructor(C,F=e.DEFAULT_LOG_LEVEL){super(),this.adapter=C,this.setLevel(F)}trace(C,...F){this.checkLogLevel(p.Trace)&&this.adapter.log(p.Trace,[this.extractMessage(C),...F])}debug(C,...F){this.checkLogLevel(p.Debug)&&this.adapter.log(p.Debug,[this.extractMessage(C),...F])}info(C,...F){this.checkLogLevel(p.Info)&&this.adapter.log(p.Info,[this.extractMessage(C),...F])}warn(C,...F){this.checkLogLevel(p.Warning)&&this.adapter.log(p.Warning,[this.extractMessage(C),...F])}error(C,...F){this.checkLogLevel(p.Error)&&this.adapter.log(p.Error,[this.extractMessage(C),...F])}extractMessage(C){return typeof C=="string"?C:(0,s.toErrorMessage)(C,this.checkLogLevel(p.Trace))}flush(){}}e.AdapterLogger=r;class a extends E{constructor(C){super(),this.loggers=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const F of this.loggers)F.setLevel(C);super.setLevel(C)}trace(C,...F){for(const x of this.loggers)x.trace(C,...F)}debug(C,...F){for(const x of this.loggers)x.debug(C,...F)}info(C,...F){for(const x of this.loggers)x.info(C,...F)}warn(C,...F){for(const x of this.loggers)x.warn(C,...F)}error(C,...F){for(const x of this.loggers)x.error(C,...F)}flush(){for(const C of this.loggers)C.flush()}dispose(){for(const C of this.loggers)C.dispose();super.dispose()}}e.MultiplexLogger=a;class n extends A.Disposable{constructor(C,F,x){if(super(),this.logLevel=C,this.logsHome=F,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new P.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,x)for(const U of x)this._loggers.set(U.resource,{logger:void 0,info:U})}getLoggerEntry(C){return(0,d.isString)(C)?[...this._loggers.values()].find(F=>F.info.id===C):this._loggers.get(C)}getLogger(C){return this.getLoggerEntry(C)?.logger}createLogger(C,F){const x=this.toResource(C),U=(0,d.isString)(C)?C:F?.id??(0,k.hash)(x.toString()).toString(16);let z=this._loggers.get(x)?.logger;const re=F?.logLevel==="always"?p.Trace:F?.logLevel;z||(z=this.doCreateLogger(x,re??this.getLogLevel(x)??this.logLevel,{...F,id:U}));const ie={logger:z,info:{resource:x,id:U,logLevel:re,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(ie.info),this._loggers.set(x,ie),z}toResource(C){return(0,d.isString)(C)?(0,l.joinPath)(this.logsHome,`${C}.log`):C}setLogLevel(C,F){if(f.URI.isUri(C)){const x=C,U=F,z=this._loggers.get(x);z&&U!==z.info.logLevel&&(z.info.logLevel=U===this.logLevel?void 0:U,z.logger?.setLevel(U),this._loggers.set(z.info.resource,z),this._onDidChangeLogLevel.fire([x,U]))}else{this.logLevel=C;for(const[x,U]of this._loggers.entries())this._loggers.get(x)?.info.logLevel===void 0&&U.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(C,F){const x=this.getLoggerEntry(C);x&&F!==!x.info.hidden&&(x.info.hidden=!F,this._loggers.set(x.info.resource,x),this._onDidChangeVisibility.fire([x.info.resource,F]))}getLogLevel(C){let F;return C&&(F=this._loggers.get(C)?.info.logLevel),F??this.logLevel}registerLogger(C){const F=this._loggers.get(C.resource);F?F.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this._loggers.set(C.resource,{info:C,logger:void 0}),this._onDidChangeLoggers.fire({added:[C],removed:[]}))}deregisterLogger(C){const F=this._loggers.get(C);F&&(F.logger&&F.logger.dispose(),this._loggers.delete(C),this._onDidChangeLoggers.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const C of this._loggers.values())yield C.info}getRegisteredLogger(C){return this._loggers.get(C)?.info}dispose(){this._loggers.forEach(C=>C.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class c{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(C){}getLevel(){return p.Info}trace(C,...F){}debug(C,...F){}info(C,...F){}warn(C,...F){}error(C,...F){}critical(C,...F){}dispose(){}flush(){}}e.NullLogger=c;class u extends c{}e.NullLogService=u;function S(T){if(T.verbose)return p.Trace;if(typeof T.logLevel=="string"){const C=M(T.logLevel.toLowerCase());if(C!==void 0)return C}return e.DEFAULT_LOG_LEVEL}function D(T){switch(T){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function L(T){switch(T){case p.Trace:return{original:"Trace",value:i.localize(0,null)};case p.Debug:return{original:"Debug",value:i.localize(1,null)};case p.Info:return{original:"Info",value:i.localize(2,null)};case p.Warning:return{original:"Warning",value:i.localize(3,null)};case p.Error:return{original:"Error",value:i.localize(4,null)};case p.Off:return{original:"Off",value:i.localize(5,null)}}}function M(T){switch(T){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.CONTEXT_LOG_LEVEL=new g.RawContextKey("logLevel",D(p.Info))});var se=this&&this.__param||function(K,e){return function(i,s){e(i,s,K)}};define(le[225],ce([0,1,14,4,97,5]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const A=i.safeStorage;let R=class{constructor(l){this.logService=l,i.app.commandLine.getSwitchValue("password-store")===P.PasswordStoreCLIOption.basic&&A.setUsePlainTextEncryption?.(!0)}async encrypt(l){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const d=JSON.stringify(A.encryptString(l));return this.logService.trace("[EncryptionMainService] Encrypted value."),d}catch(d){throw this.logService.error(d),d}}async decrypt(l){let d;try{if(d=JSON.parse(l),!d.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${l}`);const f=Buffer.from(d.data);this.logService.trace("[EncryptionMainService] Decrypting value.");const g=A.decryptString(f);return this.logService.trace("[EncryptionMainService] Decrypted value."),g}catch(f){throw this.logService.error(f),f}}isEncryptionAvailable(){return Promise.resolve(A.isEncryptionAvailable())}getKeyStorageProvider(){if(s.isWindows)return Promise.resolve(P.KnownStorageProvider.dplib);if(s.isMacintosh)return Promise.resolve(P.KnownStorageProvider.keychainAccess);if(A.getSelectedStorageBackend)try{const l=A.getSelectedStorageBackend();return Promise.resolve(l)}catch(l){this.logService.error(l)}return Promise.resolve(P.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(s.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(s.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!A.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");A.setUsePlainTextEncryption(!0)}};e.EncryptionMainService=R,e.EncryptionMainService=R=Ie([se(0,k.ILogService)],R)}),define(le[226],ce([0,1,22,8,16,3,31,2,9,62,5]),function(K,e,i,s,P,k,A,R,b,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class f extends R.Disposable{constructor(y,h){super(),this.logService=y,this.options=h,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new s.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new s.ThrottledDelayer(0))}watch(y,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(y,h):this.watchNonRecursive(y,h)}watchUniversal(y,h){const m={path:this.toWatchPath(y),excludes:h.excludes,includes:h.includes,recursive:h.recursive,filter:h.filter,correlationId:h.correlationId},p=(0,i.insert)(this.universalWatchRequests,m);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(y=>(0,P.onUnexpectedError)(y))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const y=this.options?.watcher?.recursive?.usePolling;if(y===!0)for(const h of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const h of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(h)&&y.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(y,h){const m={path:this.toWatchPath(y),excludes:h.excludes,includes:h.includes,recursive:!1,filter:h.filter,correlationId:h.correlationId},p=(0,i.insert)(this.nonRecursiveWatchRequests,m);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(y=>(0,P.onUnexpectedError)(y))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(y=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(y){y.type==="error"&&this._onDidWatchError.fire(y.message),this.logWatcherMessage(y)}logWatcherMessage(y){this.logService[y.type](y.message)}toFilePath(y){return(0,b.normalize)(y.fsPath)}toWatchPath(y){const h=this.toFilePath(y);return(0,A.removeTrailingPathSeparator)(h)}}e.AbstractDiskFileSystemProvider=f}),define(le[227],ce([0,1,22,8,17,23,3,47,75,2,61,13,69,19,66,180,15,125,5,16]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let o=class extends l.Disposable{static{I=this}constructor(r){super(),this.logService=r,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new A.Emitter),this._onDidUncorrelatedFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new s.ResourceQueue)}registerProvider(r,a){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${r}`);const n=new l.DisposableStore;return this.provider.set(r,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:a}),n.add(a.onDidChangeFile(c=>{const u=new p.FileChangesEvent(c,!this.isPathCaseSensitive(a));this.internalOnDidFilesChange.fire(u),u.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(u)})),typeof a.onDidWatchError=="function"&&n.add(a.onDidWatchError(c=>this._onDidWatchError.fire(new Error(c)))),n.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:r}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:a}),this.provider.delete(r),(0,l.dispose)(n)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(n){a.push(n)}}),!this.provider.has(r)&&await s.Promises.settled(a)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.provider.has(r.scheme)}hasCapability(r,a){const n=this.provider.get(r.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return b.Iterable.map(this.provider,([r,a])=>({scheme:r,capabilities:a.capabilities}))}async withProvider(r){if(!(0,y.isAbsolutePath)(r))throw new p.FileOperationError((0,m.localize)(0,null,this.resourceForError(r)),p.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(r.scheme);const a=this.provider.get(r.scheme);if(!a){const n=new E.ErrorNoTelemetry;throw n.message=(0,m.localize)(1,null,r.toString()),n}return a}async withReadProvider(r){const a=await this.withProvider(r);if((0,p.hasOpenReadWriteCloseCapability)(a)||(0,p.hasReadWriteCapability)(a)||(0,p.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const a=await this.withProvider(r);if((0,p.hasOpenReadWriteCloseCapability)(a)||(0,p.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,a){try{return await this.doResolveFile(r,a)}catch(n){throw(0,p.toFileSystemProviderErrorCode)(n)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,m.localize)(2,null,this.resourceForError(r)),p.FileOperationResult.FILE_NOT_FOUND):(0,p.ensureFileSystemProviderError)(n)}}async doResolveFile(r,a){const n=await this.withProvider(r),c=this.isPathCaseSensitive(n),u=a?.resolveTo,S=a?.resolveSingleChildDescendants,D=a?.resolveMetadata,L=await n.stat(r);let M;return this.toFileStat(n,r,L,void 0,!!D,(T,C)=>(M||(M=d.TernarySearchTree.forUris(()=>!c),M.set(r,!0),u&&M.fill(!0,u)),M.get(T.resource)||M.findSuperstr(T.resource.with({query:null,fragment:null}))?!0:T.isDirectory&&S?C===1:!1))}async toFileStat(r,a,n,c,u,S){const{providerExtUri:D}=this.getExtUri(r),L={resource:a,name:D.basename(a),isFile:(n.type&p.FileType.File)!==0,isDirectory:(n.type&p.FileType.Directory)!==0,isSymbolicLink:(n.type&p.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&p.FilePermission.Readonly)||!!(r.capabilities&p.FileSystemProviderCapabilities.Readonly),locked:!!((n.permissions??0)&p.FilePermission.Locked),etag:(0,p.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(L.isDirectory&&S(L,c)){try{const M=await r.readdir(a),T=await s.Promises.settled(M.map(async([C,F])=>{try{const x=D.joinPath(a,C),U=u?await r.stat(x):{type:F};return await this.toFileStat(r,x,U,M.length,u,S)}catch(x){return this.logService.trace(x),null}}));L.children=(0,i.coalesce)(T)}catch(M){this.logService.trace(M),L.children=[]}return L}return L}async resolveAll(r){return s.Promises.settled(r.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const a=await this.withProvider(r),n=await a.stat(r);return this.toFileStat(a,r,n,void 0,!0,()=>!1)}async exists(r){const a=await this.withProvider(r);try{return!!await a.stat(r)}catch{return!1}}async canCreateFile(r,a){try{await this.doValidateCreateFile(r,a)}catch(n){return n}return!0}async doValidateCreateFile(r,a){if(!a?.overwrite&&await this.exists(r))throw new p.FileOperationError((0,m.localize)(3,null,this.resourceForError(r)),p.FileOperationResult.FILE_MODIFIED_SINCE,a)}async createFile(r,a=P.VSBuffer.fromString(""),n){await this.doValidateCreateFile(r,n);const c=await this.writeFile(r,a);return this._onDidRunOperation.fire(new p.FileOperationEvent(r,p.FileOperation.CREATE,c)),c}async writeFile(r,a,n){const c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:u}=this.getExtUri(c);let S=n;if((0,p.hasFileAtomicWriteCapability)(c)&&!S?.atomic){const D=c.enforceAtomicWriteFile?.(r);D&&(S={...n,atomic:D})}try{await this.validateWriteFile(c,r,S)||await this.mkdirp(c,u.dirname(r));let L;if((0,p.hasReadWriteCapability)(c)&&!(a instanceof P.VSBuffer))if((0,h.isReadableStream)(a)){const M=await(0,h.peekStream)(a,3);M.ended?L=P.VSBuffer.concat(M.buffer):L=M}else L=(0,h.peekReadable)(a,M=>P.VSBuffer.concat(M),3);else L=a;!(0,p.hasOpenReadWriteCloseCapability)(c)||(0,p.hasReadWriteCapability)(c)&&L instanceof P.VSBuffer||(0,p.hasReadWriteCapability)(c)&&(0,p.hasFileAtomicWriteCapability)(c)&&S?.atomic?await this.doWriteUnbuffered(c,r,S,L):await this.doWriteBuffered(c,r,S,L instanceof P.VSBuffer?(0,P.bufferToReadable)(L):L),this._onDidRunOperation.fire(new p.FileOperationEvent(r,p.FileOperation.WRITE))}catch(D){throw new p.FileOperationError((0,m.localize)(4,null,this.resourceForError(r),(0,p.ensureFileSystemProviderError)(D).toString()),(0,p.toFileOperationResult)(D),S)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,a,n){const c=!!n?.unlock;if(c&&!(r.capabilities&p.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,m.localize)(5,null,this.resourceForError(a)));if(!!n?.atomic){if(!(r.capabilities&p.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,m.localize)(6,null,this.resourceForError(a)));if(!(r.capabilities&p.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,m.localize)(7,null,this.resourceForError(a)));if(c)throw new Error((0,m.localize)(8,null,this.resourceForError(a)))}let S;try{S=await r.stat(a)}catch{return}if(S.type&p.FileType.Directory)throw new p.FileOperationError((0,m.localize)(9,null,this.resourceForError(a)),p.FileOperationResult.FILE_IS_DIRECTORY,n);if(this.throwIfFileIsReadonly(a,S),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==p.ETAG_DISABLED&&typeof S.mtime=="number"&&typeof S.size=="number"&&n.mtime<S.mtime&&n.etag!==(0,p.etag)({mtime:n.mtime,size:S.size}))throw new p.FileOperationError((0,m.localize)(10,null),p.FileOperationResult.FILE_MODIFIED_SINCE,n);return S}async readFile(r,a,n){const c=await this.withReadProvider(r);return a?.atomic?this.doReadFileAtomic(c,r,a,n):this.doReadFile(c,r,a,n)}async doReadFileAtomic(r,a,n,c){return new Promise((u,S)=>{this.writeQueue.queueFor(a,async()=>{try{const D=await this.doReadFile(r,a,n,c);u(D)}catch(D){S(D)}},this.getExtUri(r).providerExtUri)})}async doReadFile(r,a,n,c){const u=await this.doReadFileStream(r,a,{...n,preferUnbuffered:!0},c);return{...u,value:await(0,P.streamToBuffer)(u.value)}}async readFileStream(r,a,n){const c=await this.withReadProvider(r);return this.doReadFileStream(c,r,a,n)}async doReadFileStream(r,a,n,c){const u=new k.CancellationTokenSource(c);let S=n;(0,p.hasFileAtomicReadCapability)(r)&&r.enforceAtomicReadFile?.(a)&&(S={...n,atomic:!0});const D=this.validateReadFile(a,S).then(M=>M,M=>{throw u.dispose(!0),M});let L;try{return typeof S?.etag=="string"&&S.etag!==p.ETAG_DISABLED&&await D,S?.atomic&&(0,p.hasFileAtomicReadCapability)(r)||!((0,p.hasOpenReadWriteCloseCapability)(r)||(0,p.hasFileReadStreamCapability)(r))||(0,p.hasReadWriteCapability)(r)&&S?.preferUnbuffered?L=this.readFileUnbuffered(r,a,S):(0,p.hasFileReadStreamCapability)(r)?L=this.readFileStreamed(r,a,u.token,S):L=this.readFileBuffered(r,a,u.token,S),L.on("end",()=>u.dispose()),L.on("error",()=>u.dispose()),{...await D,value:L}}catch(M){throw L&&await(0,h.consumeStream)(L),this.restoreReadError(M,a,S)}}restoreReadError(r,a,n){const c=(0,m.localize)(11,null,this.resourceForError(a),(0,p.ensureFileSystemProviderError)(r).toString());return r instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(c,r.stat,n):r instanceof p.TooLargeFileOperationError?new p.TooLargeFileOperationError(c,r.fileOperationResult,r.size,r.options):new p.FileOperationError(c,(0,p.toFileOperationResult)(r),n)}readFileStreamed(r,a,n,c=Object.create(null)){const u=r.readFileStream(a,c,n);return(0,h.transform)(u,{data:S=>S instanceof P.VSBuffer?S:P.VSBuffer.wrap(S),error:S=>this.restoreReadError(S,a,c)},S=>P.VSBuffer.concat(S))}readFileBuffered(r,a,n,c=Object.create(null)){const u=(0,P.newWriteableBufferStream)();return(0,v.readFileIntoStream)(r,a,u,S=>S,{...c,bufferSize:this.BUFFER_SIZE,errorTransformer:S=>this.restoreReadError(S,a,c)},n),u}readFileUnbuffered(r,a,n){const c=(0,h.newWriteableStream)(u=>P.VSBuffer.concat(u));return(async()=>{try{let u;n?.atomic&&(0,p.hasFileAtomicReadCapability)(r)?u=await r.readFile(a,{atomic:!0}):u=await r.readFile(a),typeof n?.position=="number"&&(u=u.slice(n.position)),typeof n?.length=="number"&&(u=u.slice(0,n.length)),this.validateReadFileLimits(a,u.byteLength,n),c.end(P.VSBuffer.wrap(u))}catch(u){c.error(u),c.end()}})(),c}async validateReadFile(r,a){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new p.FileOperationError((0,m.localize)(12,null,this.resourceForError(r)),p.FileOperationResult.FILE_IS_DIRECTORY,a);if(typeof a?.etag=="string"&&a.etag!==p.ETAG_DISABLED&&a.etag===n.etag)throw new p.NotModifiedSinceFileOperationError((0,m.localize)(13,null),n,a);return this.validateReadFileLimits(r,n.size,a),n}validateReadFileLimits(r,a,n){if(typeof n?.limits?.size=="number"&&a>n.limits.size)throw new p.TooLargeFileOperationError((0,m.localize)(14,null,this.resourceForError(r)),p.FileOperationResult.FILE_TOO_LARGE,a,n)}async canMove(r,a,n){return this.doCanMoveCopy(r,a,"move",n)}async canCopy(r,a,n){return this.doCanMoveCopy(r,a,"copy",n)}async doCanMoveCopy(r,a,n,c){if(r.toString()!==a.toString())try{const u=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),S=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(u,r,S,a,n,c)}catch(u){return u}return!0}async move(r,a,n){const c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),S=await this.doMoveCopy(c,r,u,a,"move",!!n),D=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(r,S==="move"?p.FileOperation.MOVE:p.FileOperation.COPY,D)),D}async copy(r,a,n){const c=await this.withReadProvider(r),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),S=await this.doMoveCopy(c,r,u,a,"copy",!!n),D=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(r,S==="copy"?p.FileOperation.COPY:p.FileOperation.MOVE,D)),D}async doMoveCopy(r,a,n,c,u,S){if(a.toString()===c.toString())return u;const{exists:D,isSameResourceWithDifferentPathCase:L}=await this.doValidateMoveCopy(r,a,n,c,u,S);if(D&&!L&&S&&await this.del(c,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(c)),u==="copy"){if(r===n&&(0,p.hasFileFolderCopyCapability)(r))await r.copy(a,c,{overwrite:S});else{const M=await this.resolve(a);M.isDirectory?await this.doCopyFolder(r,M,n,c):await this.doCopyFile(r,a,n,c)}return u}else return r===n?(await r.rename(a,c,{overwrite:S}),u):(await this.doMoveCopy(r,a,n,c,"copy",S),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(r,a,n,c){if((0,p.hasOpenReadWriteCloseCapability)(r)&&(0,p.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(r,a,n,c);if((0,p.hasOpenReadWriteCloseCapability)(r)&&(0,p.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(r,a,n,c);if((0,p.hasReadWriteCapability)(r)&&(0,p.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(r,a,n,c);if((0,p.hasReadWriteCapability)(r)&&(0,p.hasReadWriteCapability)(n))return this.doPipeUnbuffered(r,a,n,c)}async doCopyFolder(r,a,n,c){await n.mkdir(c),Array.isArray(a.children)&&await s.Promises.settled(a.children.map(async u=>{const S=this.getExtUri(n).providerExtUri.joinPath(c,u.name);return u.isDirectory?this.doCopyFolder(r,await this.resolve(u.resource),n,S):this.doCopyFile(r,u.resource,n,S)}))}async doValidateMoveCopy(r,a,n,c,u,S){let D=!1;if(r===n){const{providerExtUri:M,isPathCaseSensitive:T}=this.getExtUri(r);if(T||(D=M.isEqual(a,c)),D&&u==="copy")throw new Error((0,m.localize)(15,null,this.resourceForError(a),this.resourceForError(c)));if(!D&&M.isEqualOrParent(c,a))throw new Error((0,m.localize)(16,null,this.resourceForError(a),this.resourceForError(c)))}const L=await this.exists(c);if(L&&!D){if(!S)throw new p.FileOperationError((0,m.localize)(17,null,this.resourceForError(a),this.resourceForError(c)),p.FileOperationResult.FILE_MOVE_CONFLICT);if(r===n){const{providerExtUri:M}=this.getExtUri(r);if(M.isEqualOrParent(a,c))throw new Error((0,m.localize)(18,null,this.resourceForError(a),this.resourceForError(c)))}}return{exists:L,isSameResourceWithDifferentPathCase:D}}getExtUri(r){const a=this.isPathCaseSensitive(r);return{providerExtUri:a?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(r){return!!(r.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(r){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(a,r);const n=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(r,p.FileOperation.CREATE,n)),n}async mkdirp(r,a){const n=[],{providerExtUri:c}=this.getExtUri(r);for(;!c.isEqual(a,c.dirname(a));)try{if(!((await r.stat(a)).type&p.FileType.Directory))throw new Error((0,m.localize)(19,null,this.resourceForError(a)));break}catch(u){if((0,p.toFileSystemProviderErrorCode)(u)!==p.FileSystemProviderErrorCode.FileNotFound)throw u;n.push(c.basename(a)),a=c.dirname(a)}for(let u=n.length-1;u>=0;u--){a=c.joinPath(a,n[u]);try{await r.mkdir(a)}catch(S){if((0,p.toFileSystemProviderErrorCode)(S)!==p.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(r,a){try{await this.doValidateDelete(r,a)}catch(n){return n}return!0}async doValidateDelete(r,a){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r),c=!!a?.useTrash;if(c&&!(n.capabilities&p.FileSystemProviderCapabilities.Trash))throw new Error((0,m.localize)(20,null,this.resourceForError(r)));const u=a?.atomic;if(u&&!(n.capabilities&p.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,m.localize)(21,null,this.resourceForError(r)));if(c&&u)throw new Error((0,m.localize)(22,null,this.resourceForError(r)));let S;try{S=await n.stat(r)}catch{}if(S)this.throwIfFileIsReadonly(r,S);else throw new p.FileOperationError((0,m.localize)(23,null,this.resourceForError(r)),p.FileOperationResult.FILE_NOT_FOUND);if(!!!a?.recursive){const L=await this.resolve(r);if(L.isDirectory&&Array.isArray(L.children)&&L.children.length>0)throw new Error((0,m.localize)(24,null,this.resourceForError(r)))}return n}async del(r,a){const n=await this.doValidateDelete(r,a);let c=a;if((0,p.hasFileAtomicDeleteCapability)(n)&&!c?.atomic){const L=n.enforceAtomicDelete?.(r);L&&(c={...a,atomic:L})}const u=!!c?.useTrash,S=!!c?.recursive,D=c?.atomic??!1;await n.delete(r,{recursive:S,useTrash:u,atomic:D}),this._onDidRunOperation.fire(new p.FileOperationEvent(r,p.FileOperation.DELETE))}async cloneFile(r,a){const n=await this.withProvider(r),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);if(!(n===c&&this.getExtUri(n).providerExtUri.isEqual(r,a)))return n===c&&(0,p.hasFileCloneCapability)(n)?n.cloneFile(r,a):(await this.mkdirp(c,this.getExtUri(c).providerExtUri.dirname(a)),n===c&&(0,p.hasFileFolderCopyCapability)(n)?this.writeQueue.queueFor(r,()=>n.copy(r,a,{overwrite:!0}),this.getExtUri(n).providerExtUri):this.writeQueue.queueFor(r,()=>this.doCopyFile(n,r,c,a),this.getExtUri(n).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(r,a){return this.watch(r,{...a,correlationId:I.WATCHER_CORRELATION_IDS++})}watch(r,a={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let c=!1,u=()=>{c=!0};n.add((0,l.toDisposable)(()=>u())),(async()=>{try{const D=await this.doWatch(r,a);c?(0,l.dispose)(D):u=()=>(0,l.dispose)(D)}catch(D){this.logService.error(D)}})();const S=a.correlationId;if(typeof S=="number"){const D=n.add(new A.Emitter);return n.add(this.internalOnDidFilesChange.event(M=>{M.correlates(S)&&D.fire(M)})),{onDidChange:D.event,dispose:()=>n.dispose()}}return n}async doWatch(r,a){const n=await this.withProvider(r),c=(0,R.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(r),a]);let u=this.activeWatchers.get(c);return u||(u={count:0,disposable:n.watch(r,a)},this.activeWatchers.set(c,u)),u.count+=1,(0,l.toDisposable)(()=>{u&&(u.count--,u.count===0&&((0,l.dispose)(u.disposable),this.activeWatchers.delete(c)))})}dispose(){super.dispose();for(const[,r]of this.activeWatchers)(0,l.dispose)(r.disposable);this.activeWatchers.clear()}async doWriteBuffered(r,a,n,c){return this.writeQueue.queueFor(a,async()=>{const u=await r.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,h.isReadableStream)(c)||(0,h.isReadableBufferedStream)(c)?await this.doWriteStreamBufferedQueued(r,u,c):await this.doWriteReadableBufferedQueued(r,u,c)}catch(S){throw(0,p.ensureFileSystemProviderError)(S)}finally{await r.close(u)}},this.getExtUri(r).providerExtUri)}async doWriteStreamBufferedQueued(r,a,n){let c=0,u;if((0,h.isReadableBufferedStream)(n)){if(n.buffer.length>0){const S=P.VSBuffer.concat(n.buffer);await this.doWriteBuffer(r,a,S,S.byteLength,c,0),c+=S.byteLength}if(n.ended)return;u=n.stream}else u=n;return new Promise((S,D)=>{(0,h.listenStream)(u,{onData:async L=>{u.pause();try{await this.doWriteBuffer(r,a,L,L.byteLength,c,0)}catch(M){return D(M)}c+=L.byteLength,setTimeout(()=>u.resume())},onError:L=>D(L),onEnd:()=>S()})})}async doWriteReadableBufferedQueued(r,a,n){let c=0,u;for(;(u=n.read())!==null;)await this.doWriteBuffer(r,a,u,u.byteLength,c,0),c+=u.byteLength}async doWriteBuffer(r,a,n,c,u,S){let D=0;for(;D<c;){const L=await r.write(a,u+D,n.buffer,S+D,c-D);D+=L}}async doWriteUnbuffered(r,a,n,c){return this.writeQueue.queueFor(a,()=>this.doWriteUnbufferedQueued(r,a,n,c),this.getExtUri(r).providerExtUri)}async doWriteUnbufferedQueued(r,a,n,c){let u;c instanceof P.VSBuffer?u=c:(0,h.isReadableStream)(c)?u=await(0,P.streamToBuffer)(c):(0,h.isReadableBufferedStream)(c)?u=await(0,P.bufferedStreamToBuffer)(c):u=(0,P.readableToBuffer)(c),await r.writeFile(a,u.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async doPipeBuffered(r,a,n,c){return this.writeQueue.queueFor(c,()=>this.doPipeBufferedQueued(r,a,n,c),this.getExtUri(n).providerExtUri)}async doPipeBufferedQueued(r,a,n,c){let u,S;try{u=await r.open(a,{create:!1}),S=await n.open(c,{create:!0,unlock:!1});const D=P.VSBuffer.alloc(this.BUFFER_SIZE);let L=0,M=0,T=0;do T=await r.read(u,L,D.buffer,M,D.byteLength-M),await this.doWriteBuffer(n,S,D,T,L,M),L+=T,M+=T,M===D.byteLength&&(M=0);while(T>0)}catch(D){throw(0,p.ensureFileSystemProviderError)(D)}finally{await s.Promises.settled([typeof u=="number"?r.close(u):Promise.resolve(),typeof S=="number"?n.close(S):Promise.resolve()])}}async doPipeUnbuffered(r,a,n,c){return this.writeQueue.queueFor(c,()=>this.doPipeUnbufferedQueued(r,a,n,c),this.getExtUri(n).providerExtUri)}async doPipeUnbufferedQueued(r,a,n,c){return n.writeFile(c,await r.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(r,a,n,c){return this.writeQueue.queueFor(c,()=>this.doPipeUnbufferedToBufferedQueued(r,a,n,c),this.getExtUri(n).providerExtUri)}async doPipeUnbufferedToBufferedQueued(r,a,n,c){const u=await n.open(c,{create:!0,unlock:!1});try{const S=await r.readFile(a);await this.doWriteBuffer(n,u,P.VSBuffer.wrap(S),S.byteLength,0,0)}catch(S){throw(0,p.ensureFileSystemProviderError)(S)}finally{await n.close(u)}}async doPipeBufferedToUnbuffered(r,a,n,c){const u=await(0,P.streamToBuffer)(this.readFileBuffered(r,a,k.CancellationToken.None));await this.doWriteUnbuffered(n,c,void 0,u)}throwIfFileSystemIsReadonly(r,a){if(r.capabilities&p.FileSystemProviderCapabilities.Readonly)throw new p.FileOperationError((0,m.localize)(25,null,this.resourceForError(a)),p.FileOperationResult.FILE_PERMISSION_DENIED);return r}throwIfFileIsReadonly(r,a){if((a.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,m.localize)(26,null,this.resourceForError(r)),p.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(r){return r.scheme===f.Schemas.file?r.fsPath:r.toString(!0)}};e.FileService=o,e.FileService=o=I=Ie([se(0,w.ILogService)],o)}),define(le[99],ce([0,1,44,318,8,32,17,3,31,2,9,4,19,66,21,184,15,125,226,48,222,221]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,s.gracefulify)(i)}catch(r){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(r)}`)}})();class t extends w.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(a,n){super(a,n),this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new k.ResourceMap(c=>g.extUriBiasedIgnorePathCase.getComparisonKey(c)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=p.FileSystemProviderCapabilities.FileReadWrite|p.FileSystemProviderCapabilities.FileOpenReadWriteClose|p.FileSystemProviderCapabilities.FileReadStream|p.FileSystemProviderCapabilities.FileFolderCopy|p.FileSystemProviderCapabilities.FileWriteUnlock|p.FileSystemProviderCapabilities.FileAtomicRead|p.FileSystemProviderCapabilities.FileAtomicWrite|p.FileSystemProviderCapabilities.FileAtomicDelete|p.FileSystemProviderCapabilities.FileClone,f.isLinux&&(this._capabilities|=p.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(a){try{const{stat:n,symbolicLink:c}=await h.SymlinkSupport.stat(this.toFilePath(a));return{type:this.toType(n,c),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:p.FilePermission.Locked}}catch(n){throw this.toFileSystemProviderError(n)}}async statIgnoreError(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const n=await h.Promises.readdir(this.toFilePath(a),{withFileTypes:!0}),c=[];return await Promise.all(n.map(async u=>{try{let S;u.isSymbolicLink()?S=(await this.stat((0,g.joinPath)(a,u.name))).type:S=this.toType(u),c.push([u.name,S])}catch(S){this.logService.trace(S)}})),c}catch(n){throw this.toFileSystemProviderError(n)}}toType(a,n){let c;return n?.dangling?c=p.FileType.Unknown:a.isFile()?c=p.FileType.File:a.isDirectory()?c=p.FileType.Directory:c=p.FileType.Unknown,n&&(c|=p.FileType.SymbolicLink),c}async createResourceLock(a){const n=this.toFilePath(a);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let c;for(;c=this.resourceLocks.get(a);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await c.wait();const u=new P.Barrier;return this.resourceLocks.set(a,u),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(a)===u&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(a)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),u.open()})}async readFile(a,n){let c;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(a)})`),c=await this.createResourceLock(a));const u=this.toFilePath(a);return await h.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{c?.dispose()}}traceLock(a){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(a)}readFileStream(a,n,c){const u=(0,y.newWriteableStream)(S=>A.VSBuffer.concat(S.map(D=>A.VSBuffer.wrap(D))).buffer);return(0,v.readFileIntoStream)(this,a,u,S=>S.buffer,{...n,bufferSize:256*1024},c),u}async writeFile(a,n,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.canWriteFileAtomic(a)?this.doWriteFileAtomic(a,(0,g.joinPath)((0,g.dirname)(a),`${(0,g.basename)(a)}${c.atomic.postfix}`),n,c):this.doWriteFile(a,n,c)}async canWriteFileAtomic(a){try{const n=this.toFilePath(a),{symbolicLink:c}=await h.SymlinkSupport.stat(n);if(c)return!1}catch{}return!0}async doWriteFileAtomic(a,n,c,u){const S=new l.DisposableStore;try{S.add(await this.createResourceLock(a)),S.add(await this.createResourceLock(n)),await this.doWriteFile(n,c,u,!0);try{await this.rename(n,a,{overwrite:!0})}catch(D){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{S.dispose()}}async doWriteFile(a,n,c,u){let S;try{const D=this.toFilePath(a);if(!c.create||!c.overwrite){if(await h.Promises.exists(D)){if(!c.overwrite)throw(0,p.createFileSystemProviderError)((0,m.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,p.createFileSystemProviderError)((0,m.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(a,{create:!0,unlock:c.unlock},u),await this.write(S,0,n,0,n.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(a,D)}finally{typeof S=="number"&&await this.close(S)}}static{this.canFlush=!0}static configureFlushOnWrite(a){t.canFlush=a}async open(a,n,c){const u=this.toFilePath(a);let S;(0,p.isFileOpenForWriteOptions)(n)&&!c&&(S=await this.createResourceLock(a));let D;try{if((0,p.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:M}=await h.SymlinkSupport.stat(u);M.mode&128||await h.Promises.chmod(u,M.mode|128)}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}let L;if((0,p.isFileOpenForWriteOptions)(n)){if(f.isWindows)try{await h.Promises.truncate(u,0),L="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}L||(L="w")}else L="r";D=await h.Promises.open(u,L)}catch(L){throw S?.dispose(),(0,p.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(a,L):this.toFileSystemProviderError(L)}if(this.mapHandleToPos.set(D,0),(0,p.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(D,a),S){const L=this.mapHandleToLock.get(D);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${u})`),this.mapHandleToLock.set(D,S),L&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${u})`),L.dispose())}return D}async close(a){const n=this.mapHandleToLock.get(a);try{if(this.mapHandleToPos.delete(a),this.writeHandles.delete(a)&&t.canFlush)try{await h.Promises.fdatasync(a)}catch(c){t.configureFlushOnWrite(!1),this.logService.error(c)}return await h.Promises.close(a)}catch(c){throw this.toFileSystemProviderError(c)}finally{n&&(this.mapHandleToLock.get(a)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.mapHandleToLock.delete(a)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),n.dispose())}}async read(a,n,c,u,S){const D=this.normalizePos(a,n);let L=null;try{L=(await h.Promises.read(a,c,u,S,D)).bytesRead}catch(M){throw this.toFileSystemProviderError(M)}finally{this.updatePos(a,D,L)}return L}normalizePos(a,n){return n===this.mapHandleToPos.get(a)?null:n}updatePos(a,n,c){const u=this.mapHandleToPos.get(a);typeof u=="number"&&(typeof n=="number"||(typeof c=="number"?this.mapHandleToPos.set(a,u+c):this.mapHandleToPos.delete(a)))}async write(a,n,c,u,S){return(0,P.retry)(()=>this.doWrite(a,n,c,u,S),100,3)}async doWrite(a,n,c,u,S){const D=this.normalizePos(a,n);let L=null;try{L=(await h.Promises.write(a,c,u,S,D)).bytesWritten}catch(M){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(a),M)}finally{this.updatePos(a,D,L)}return L}async mkdir(a){try{await h.Promises.mkdir(this.toFilePath(a))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(a,n){try{const c=this.toFilePath(a);if(n.recursive){let u;n?.atomic!==!1&&n.atomic.postfix&&(u=(0,d.join)((0,d.dirname)(c),`${(0,d.basename)(c)}${n.atomic.postfix}`)),await h.Promises.rm(c,h.RimRafMode.MOVE,u)}else try{await h.Promises.unlink(c)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let S=!1;try{const{stat:D,symbolicLink:L}=await h.SymlinkSupport.stat(c);S=D.isDirectory()&&!L}catch{}if(S)await h.Promises.rmdir(c);else throw u}else throw u}}catch(c){throw this.toFileSystemProviderError(c)}}async rename(a,n,c){const u=this.toFilePath(a),S=this.toFilePath(n);if(u!==S)try{await this.validateMoveCopy(a,n,"move",c.overwrite),await h.Promises.rename(u,S)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,m.localize)(2,null,(0,d.basename)(u),(0,d.basename)((0,d.dirname)(S)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(a,n,c){const u=this.toFilePath(a),S=this.toFilePath(n);if(u!==S)try{await this.validateMoveCopy(a,n,"copy",c.overwrite),await h.Promises.copy(u,S,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,m.localize)(3,null,(0,d.basename)(u),(0,d.basename)((0,d.dirname)(S)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(a,n,c,u){const S=this.toFilePath(a),D=this.toFilePath(n);let L=!1;if(!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)||(L=(0,b.isEqual)(S,D,!0)),L){if(c==="copy")throw(0,p.createFileSystemProviderError)((0,m.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const T=await this.statIgnoreError(a);if(!T)throw(0,p.createFileSystemProviderError)((0,m.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const C=await this.statIgnoreError(n);if(C){if(!u)throw(0,p.createFileSystemProviderError)((0,m.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);T.type&p.FileType.File&&C.type&p.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,n){return this.doCloneFile(a,n,!1)}async doCloneFile(a,n,c){const u=this.toFilePath(a),S=this.toFilePath(n),D=!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive);if((0,b.isEqual)(u,S,!D))return;const L=new l.DisposableStore;try{L.add(await this.createResourceLock(a)),L.add(await this.createResourceLock(n)),c&&await h.Promises.mkdir((0,d.dirname)(S),{recursive:!0}),await h.Promises.copyFile(u,S)}catch(M){if(M.code==="ENOENT"&&!c)return this.doCloneFile(a,n,!0);throw this.toFileSystemProviderError(M)}finally{L.dispose()}}createUniversalWatcher(a,n,c){return new I.UniversalWatcherClient(u=>a(u),u=>n(u),c)}createNonRecursiveWatcher(a,n,c){return new o.NodeJSWatcherClient(u=>a(u),u=>n(u),c)}toFileSystemProviderError(a){if(a instanceof p.FileSystemProviderError)return a;let n=a,c;switch(a.code){case"ENOENT":c=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=p.FileSystemProviderErrorCode.Unknown;break;default:c=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(n,c)}async toFileSystemProviderWriteError(a,n){let c=this.toFileSystemProviderError(n);if(a&&c.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await h.SymlinkSupport.stat(this.toFilePath(a));u.mode&128||(c=(0,p.createFileSystemProviderError)(n,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return c}}e.DiskFileSystemProvider=t}),define(le[228],ce([0,1,3,99,2,17,66,23]),function(K,e,i,s,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class b extends P.Disposable{constructor(f,g){super(),this.provider=f,this.logService=g,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,g,y){const h=this.getUriTransformer(f);switch(g){case"stat":return this.stat(h,y[0]);case"readdir":return this.readdir(h,y[0]);case"open":return this.open(h,y[0],y[1]);case"close":return this.close(y[0]);case"read":return this.read(y[0],y[1],y[2]);case"readFile":return this.readFile(h,y[0],y[1]);case"write":return this.write(y[0],y[1],y[2],y[3],y[4]);case"writeFile":return this.writeFile(h,y[0],y[1],y[2]);case"rename":return this.rename(h,y[0],y[1],y[2]);case"copy":return this.copy(h,y[0],y[1],y[2]);case"cloneFile":return this.cloneFile(h,y[0],y[1]);case"mkdir":return this.mkdir(h,y[0]);case"delete":return this.delete(h,y[0],y[1]);case"watch":return this.watch(h,y[0],y[1],y[2],y[3]);case"unwatch":return this.unwatch(y[0],y[1])}throw new Error(`IPC Command ${g} not found`)}listen(f,g,y){const h=this.getUriTransformer(f);switch(g){case"fileChange":return this.onFileChange(h,y[0]);case"readFileStream":return this.onReadFileStream(h,y[0],y[1])}throw new Error(`Unknown event ${g}`)}stat(f,g){const y=this.transformIncoming(f,g,!0);return this.provider.stat(y)}readdir(f,g){const y=this.transformIncoming(f,g);return this.provider.readdir(y)}async readFile(f,g,y){const h=this.transformIncoming(f,g,!0),m=await this.provider.readFile(h,y);return k.VSBuffer.wrap(m)}onReadFileStream(f,g,y){const h=this.transformIncoming(f,g,!0),m=new R.CancellationTokenSource,p=new i.Emitter({onDidRemoveLastListener:()=>{m.cancel()}}),v=this.provider.readFileStream(h,y,m.token);return(0,A.listenStream)(v,{onData:w=>p.fire(k.VSBuffer.wrap(w)),onError:w=>p.fire(w),onEnd:()=>{p.fire("end"),p.dispose(),m.dispose()}}),p.event}writeFile(f,g,y,h){const m=this.transformIncoming(f,g);return this.provider.writeFile(m,y.buffer,h)}open(f,g,y){const h=this.transformIncoming(f,g,!0);return this.provider.open(h,y)}close(f){return this.provider.close(f)}async read(f,g,y){const h=k.VSBuffer.alloc(y),p=await this.provider.read(f,g,h.buffer,0,y);return[h,p]}write(f,g,y,h,m){return this.provider.write(f,g,y.buffer,h,m)}mkdir(f,g){const y=this.transformIncoming(f,g);return this.provider.mkdir(y)}delete(f,g,y){const h=this.transformIncoming(f,g);return this.provider.delete(h,y)}rename(f,g,y,h){const m=this.transformIncoming(f,g),p=this.transformIncoming(f,y);return this.provider.rename(m,p,h)}copy(f,g,y,h){const m=this.transformIncoming(f,g),p=this.transformIncoming(f,y);return this.provider.copy(m,p,h)}cloneFile(f,g,y){const h=this.transformIncoming(f,g),m=this.transformIncoming(f,y);return this.provider.cloneFile(h,m)}onFileChange(f,g){const y=new i.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(g,this.createSessionFileWatcher(f,y))},onDidRemoveLastListener:()=>{(0,P.dispose)(this.sessionToWatcher.get(g)),this.sessionToWatcher.delete(g)}});return y.event}async watch(f,g,y,h,m){const p=this.sessionToWatcher.get(g);if(p){const v=this.transformIncoming(f,h),w=p.watch(y,v,m);this.watchRequests.set(g+y,w)}}async unwatch(f,g){const y=f+g,h=this.watchRequests.get(y);h&&((0,P.dispose)(h),this.watchRequests.delete(y))}dispose(){super.dispose();for(const[,f]of this.watchRequests)f.dispose();this.watchRequests.clear();for(const[,f]of this.sessionToWatcher)f.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=b;class l extends P.Disposable{constructor(f,g,y,h){super(),this.uriTransformer=f,this.logService=y,this.environmentService=h,this.watcherRequests=new Map,this.fileWatcher=this._register(new s.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(g)}registerListeners(f){const g=this._register(new i.Emitter);this._register(g.event(y=>{f.fire(y.map(h=>({resource:this.uriTransformer.transformOutgoingURI(h.resource),type:h.type,cId:h.cId})))})),this._register(this.fileWatcher.onDidChangeFile(y=>g.fire(y))),this._register(this.fileWatcher.onDidWatchError(y=>f.fire(y)))}getRecursiveWatcherOptions(f){}getExtraExcludes(f){}watch(f,g,y){const h=this.getExtraExcludes(this.environmentService);return Array.isArray(h)&&(y.excludes=[...y.excludes,...h]),this.watcherRequests.set(f,this.fileWatcher.watch(g,y)),(0,P.toDisposable)(()=>{(0,P.dispose)(this.watcherRequests.get(f)),this.watcherRequests.delete(f)})}dispose(){for(const[,f]of this.watcherRequests)f.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=l}),define(le[229],ce([0,1,14,183,4,7,15,9,228,160,48]),function(K,e,i,s,P,k,A,R,b,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class f extends b.AbstractDiskFileSystemProviderChannel{constructor(h,m,p){super(h,m),this.environmentService=p}getUriTransformer(h){return l.DefaultURITransformer}transformIncoming(h,m){return k.URI.revive(m)}async delete(h,m,p){if(!p.useTrash)return super.delete(h,m,p);const v=this.transformIncoming(h,m),w=(0,R.normalize)(v.fsPath);try{await i.shell.trashItem(w)}catch(E){throw(0,A.createFileSystemProviderError)(P.isWindows?(0,s.localize)(0,null,(0,R.basename)(w),(0,d.toErrorMessage)(E)):(0,s.localize)(1,null,(0,R.basename)(w),(0,d.toErrorMessage)(E)),A.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(h,m){return new g(h,m,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=f;class g extends b.AbstractSessionFileWatcher{watch(h,m,p){if(p.recursive)throw(0,A.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(h,m,p)}}}),define(le[230],ce([0,1,5]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class s extends i.AbstractMessageLogger{constructor(k=i.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(A=>{this._logger?.setLevel(A)}))}set logger(k){this._logger=k;for(const{level:A,message:R}of this.buffer)(0,i.log)(k,A,R);this.buffer=[]}log(k,A){this._logger?(0,i.log)(this._logger,k,A):this.getLevel()<=k&&this.buffer.push({level:k,message:A})}dispose(){this._logger?.dispose(),super.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=s}),define(le[231],ce([0,1,7,3,5,2]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class A extends P.AbstractLoggerService{constructor(f,g,y,h,m){super(g,y,h),this.windowId=f,this.channel=m,this._register(m.listen("onDidChangeLogLevel",f)(p=>{(0,P.isLogLevel)(p)?super.setLogLevel(p):super.setLogLevel(i.URI.revive(p[0]),p[1])})),this._register(m.listen("onDidChangeVisibility",f)(([p,v])=>super.setVisibility(i.URI.revive(p),v))),this._register(m.listen("onDidChangeLoggers",f)(({added:p,removed:v})=>{for(const w of p)super.registerLogger({...w,resource:i.URI.revive(w.resource)});for(const w of v)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new P.AdapterLogger({log:(f,g)=>{this.channel.call("consoleLog",[f,g])}})}registerLogger(f){super.registerLogger(f),this.channel.call("registerLogger",[f,this.windowId])}deregisterLogger(f){super.deregisterLogger(f),this.channel.call("deregisterLogger",[f,this.windowId])}setLogLevel(f,g){super.setLogLevel(f,g),this.channel.call("setLogLevel",[f,g])}setVisibility(f,g){super.setVisibility(f,g),this.channel.call("setVisibility",[this.toResource(f),g])}doCreateLogger(f,g,y){return new R(this.channel,f,g,y,this.windowId)}static setLogLevel(f,g,y){return f.call("setLogLevel",[g,y])}}e.LoggerChannelClient=A;class R extends P.AbstractMessageLogger{constructor(f,g,y,h,m){super(h?.logLevel==="always"),this.channel=f,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(y),this.channel.call("createLogger",[g,h,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,g){const y=[[f,g]];this.isLoggerCreated?this.doLog(y):this.buffer.push(...y)}doLog(f){this.channel.call("log",[this.file,f])}}class b{constructor(f,g){this.loggerService=f,this.getUriTransformer=g}listen(f,g){const y=this.getUriTransformer(f);switch(g){case"onDidChangeLoggers":return s.Event.map(this.loggerService.onDidChangeLoggers,h=>({added:[...h.added].map(m=>this.transformLogger(m,y)),removed:[...h.removed].map(m=>this.transformLogger(m,y))}));case"onDidChangeVisibility":return s.Event.map(this.loggerService.onDidChangeVisibility,h=>[y.transformOutgoingURI(h[0]),h[1]]);case"onDidChangeLogLevel":return s.Event.map(this.loggerService.onDidChangeLogLevel,h=>(0,P.isLogLevel)(h)?h:[y.transformOutgoingURI(h[0]),h[1]])}throw new Error(`Event not found: ${g}`)}async call(f,g,y){const h=this.getUriTransformer(f);switch(g){case"setLogLevel":return(0,P.isLogLevel)(y[0])?this.loggerService.setLogLevel(y[0]):this.loggerService.setLogLevel(i.URI.revive(h.transformIncoming(y[0][0])),y[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(m=>this.transformLogger(m,h)))}throw new Error(`Call not found: ${g}`)}transformLogger(f,g){return{...f,resource:g.transformOutgoingURI(f.resource)}}}e.LoggerChannel=b;class l extends k.Disposable{constructor(f,g){super(),g.call("setLogLevel",[f.getLogLevel()]),this._register(f.onDidChangeLogLevel(y=>g.call("setLogLevel",[y]))),g.call("getRegisteredLoggers").then(y=>{for(const h of y)f.registerLogger({...h,resource:i.URI.revive(h.resource)})}),this._register(g.listen("onDidChangeVisibility")(([y,h])=>f.setVisibility(i.URI.revive(y),h))),this._register(g.listen("onDidChangeLoggers")(({added:y,removed:h})=>{for(const m of y)f.registerLogger({...m,resource:i.URI.revive(m.resource)});for(const m of h)f.deregisterLogger(m.resource)}))}}e.RemoteLoggerChannelClient=l}),define(le[232],ce([0,1,2,5]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class P extends i.Disposable{constructor(A,R=[]){super(),this.logger=new s.MultiplexLogger([A,...R]),this._register(A.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}flush(){this.logger.flush()}}e.LogService=P}),define(le[233],ce([0,1,32,7,5]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class k{constructor(R){this.loggerService=R,this.loggers=new i.ResourceMap}listen(R,b,l){switch(b){case"onDidChangeLoggers":return l?this.loggerService.getOnDidChangeLoggersEvent(l):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.loggerService.getOnDidChangeLogLevelEvent(l):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.loggerService.getOnDidChangeVisibilityEvent(l):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${b}`)}async call(R,b,l){switch(b){case"createLogger":this.createLogger(s.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.log(s.URI.revive(l[0]),l[1]);case"consoleLog":return this.consoleLog(l[0],l[1]);case"setLogLevel":return(0,P.isLogLevel)(l[0])?this.loggerService.setLogLevel(l[0]):this.loggerService.setLogLevel(s.URI.revive(l[0]),l[1]);case"setVisibility":return this.loggerService.setVisibility(s.URI.revive(l[0]),l[1]);case"registerLogger":return this.loggerService.registerLogger({...l[0],resource:s.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(s.URI.revive(l[0]))}throw new Error(`Call not found: ${b}`)}createLogger(R,b,l){this.loggers.set(R,this.loggerService.createLogger(R,b,l))}consoleLog(R,b){let l=console.log;switch(R){case P.LogLevel.Error:l=console.error;break;case P.LogLevel.Warning:l=console.warn;break;case P.LogLevel.Info:l=console.info;break}l.call(console,...b)}log(R,b){const l=this.loggers.get(R);if(!l)throw new Error("Create the logger before logging");for(const[d,f]of b)(0,P.log)(l,d,f)}}e.LoggerChannel=k}),define(le[234],ce([0,1,15,5]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var P;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(P||(P={}));async function k(l,d,f,g,y){try{const h=await new Promise((p,v)=>{K(["@vscode/spdlog"],p,v)});h.setFlushOn(P.Trace);const m=await h.createAsyncRotatingLogger(l,d,f,g);return y?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(h){console.error(h)}return null}function A(l,d,f){switch(d){case s.LogLevel.Trace:l.trace(f);break;case s.LogLevel.Debug:l.debug(f);break;case s.LogLevel.Info:l.info(f);break;case s.LogLevel.Warning:l.warn(f);break;case s.LogLevel.Error:l.error(f);break;case s.LogLevel.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function R(l,d){switch(d){case s.LogLevel.Trace:l.setLevel(P.Trace);break;case s.LogLevel.Debug:l.setLevel(P.Debug);break;case s.LogLevel.Info:l.setLevel(P.Info);break;case s.LogLevel.Warning:l.setLevel(P.Warning);break;case s.LogLevel.Error:l.setLevel(P.Error);break;case s.LogLevel.Off:l.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${d}`)}}class b extends s.AbstractMessageLogger{constructor(d,f,g,y,h){super(),this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(d,f,g,y),this._register(this.onDidChangeLogLevel(m=>{this._logger&&R(this._logger,m)}))}async _createSpdLogLogger(d,f,g,y){const h=g?6:1,m=30/h*i.ByteSize.MB,p=await k(d,f,m,h,y);if(p){this._logger=p,R(this._logger,this.getLevel());for(const{level:v,message:w}of this.buffer)A(this._logger,v,w);this.buffer=[]}}log(d,f){this._logger?A(this._logger,d,f):this.getLevel()<=d&&this.buffer.push({level:d,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=b}),define(le[235],ce([0,1,33,5,234]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class k extends s.AbstractLoggerService{doCreateLogger(R,b,l){return new P.SpdLogLogger((0,i.generateUuid)(),R.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,b)}}e.LoggerService=k}),define(le[70],ce([0,1,32,3,6,5,235]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,P.refineServiceDecorator)(k.ILoggerService);class R extends A.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new i.ResourceMap}createLogger(l,d,f){f!==void 0&&this.loggerResourcesByWindow.set(this.toResource(l),f);try{return super.createLogger(l,d)}catch(g){throw this.loggerResourcesByWindow.delete(this.toResource(l)),g}}registerLogger(l,d){d!==void 0&&this.loggerResourcesByWindow.set(l.resource,d),super.registerLogger(l)}deregisterLogger(l){this.loggerResourcesByWindow.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const d=[];for(const f of super.getRegisteredLoggers())l===this.loggerResourcesByWindow.get(f.resource)&&d.push(f);return d}getOnDidChangeLogLevelEvent(l){return s.Event.filter(this.onDidChangeLogLevel,d=>(0,k.isLogLevel)(d)||this.isInterestedLoggerResource(d[0],l))}getOnDidChangeVisibilityEvent(l){return s.Event.filter(this.onDidChangeVisibility,([d])=>this.isInterestedLoggerResource(d,l))}getOnDidChangeLoggersEvent(l){return s.Event.filter(s.Event.map(this.onDidChangeLoggers,d=>({added:[...d.added].filter(g=>this.isInterestedLoggerResource(g.resource,l)),removed:[...d.removed].filter(g=>this.isInterestedLoggerResource(g.resource,l))})),d=>d.added.length>0||d.removed.length>0)}deregisterLoggers(l){for(const[d,f]of this.loggerResourcesByWindow)f===l&&this.deregisterLogger(d)}isInterestedLoggerResource(l,d){const f=this.loggerResourcesByWindow.get(l);return f===void 0||f===d}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=R}),define(le[236],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemSubmenu=i,e.isMenubarMenuItemSeparator=s,e.isMenubarMenuItemRecentAction=P,e.isMenubarMenuItemAction=k;function i(A){return A.submenu!==void 0}function s(A){return A.id==="vscode.menubar.separator"}function P(A){return A.uri!==void 0}function k(A){return!i(A)&&!s(A)&&!P(A)}}),define(le[41],ce([0,1,3,75,2,6]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class A extends P.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const d=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},d!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),s.Iterable.reduce(this.policies.entries(),(f,[g,y])=>({...f,[g]:y}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return s.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[d,f])=>({...l,[d]:{definition:f,value:this.policies.get(d)}}),{})}}e.AbstractPolicyService=A;class R{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(le[237],ce([0,1,8,3,75,12,15,5,41]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(f,g){const y=[];for(const h of new Set(P.Iterable.concat(f.keys(),g.keys())))f.get(h)!==g.get(h)&&y.push(h);return y}let d=class extends b.AbstractPolicyService{constructor(g,y,h){super(),this.file=g,this.fileService=y,this.logService=h,this.throttledDelayer=this._register(new i.ThrottledDelayer(500));const m=s.Event.filter(y.onDidFilesChange,p=>p.affects(g));this._register(y.watch(g)),this._register(m(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const g=new Map;try{const y=await this.fileService.readFile(this.file),h=JSON.parse(y.value.toString());if(!(0,k.isObject)(h))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(h))this.policyDefinitions[m]&&g.set(m,h[m])}catch(y){y.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.logService.error("[FilePolicyService] Failed to read policies",y)}return g}async refresh(){const g=await this.read(),y=l(this.policies,g);this.policies=g,y.length>0&&this._onDidChange.fire(y)}};e.FilePolicyService=d,e.FilePolicyService=d=Ie([se(1,A.IFileService),se(2,R.ILogService)],d)}),define(le[238],ce([0,1,3,2,41]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class k{constructor(b){this.service=b,this.disposables=new s.DisposableStore}listen(b,l){switch(l){case"onDidChange":return i.Event.map(this.service.onDidChange,d=>d.reduce((f,g)=>({...f,[g]:this.service.getPolicyValue(g)??null}),{}),this.disposables)}throw new Error(`Event not found: ${l}`)}call(b,l,d){switch(l){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(d)}throw new Error(`Call not found: ${l}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=k;class A extends P.AbstractPolicyService{constructor(b,l){super(),this.channel=l;for(const d in b){const{definition:f,value:g}=b[d];this.policyDefinitions[d]=f,g!==void 0&&this.policies.set(d,g)}this.channel.listen("onDidChange")(d=>{for(const f in d){const g=d[f];g===null?this.policies.delete(f):this.policies.set(f,g)}this._onDidChange.fire(Object.keys(d))})}async _updatePolicyDefinitions(b){const l=await this.channel.call("updatePolicyDefinitions",b);for(const d in l)this.policies.set(d,l[d])}}e.PolicyChannelClient=A}),define(le[239],ce([0,1,41,8,2,5]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let A=class extends i.AbstractPolicyService{constructor(b,l){super(),this.logService=b,this.productName=l,this.throttler=new s.Throttler,this.watcher=this._register(new P.MutableDisposable)}async _updatePolicyDefinitions(b){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(b).length} policy definitions`);const{createWatcher:l}=await new Promise((d,f)=>{K(["@vscode/policy-watcher"],d,f)});await this.throttler.queue(()=>new Promise((d,f)=>{try{this.watcher.value=l(this.productName,b,g=>{this._onDidPolicyChange(g),d()})}catch(g){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),f(g)}}))}_onDidPolicyChange(b){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(b)}`);for(const l in b){const d=b[l];d===void 0?this.policies.delete(l):this.policies.set(l,d)}this._onDidChange.fire(Object.keys(b))}};e.NativePolicyService=A,e.NativePolicyService=A=Ie([se(0,k.ILogService)],A)}),define(le[84],ce([0,1,36]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const k=P.context.configuration();if(k)s=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){s=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:k,searchUrl:A,itemUrl:R,controlUrl:b}=s.extensionsGallery||{};Object.assign(s,{extensionsGallery:{serviceUrl:i.env.VSCODE_GALLERY_SERVICE_URL||k,searchUrl:i.env.VSCODE_GALLERY_SEARCH_URL||A,itemUrl:i.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:i.env.VSCODE_GALLERY_CONTROL_URL||b}});try{const l=(...f)=>f.reduce((g,y)=>(Object.keys(y).forEach(h=>{Array.isArray(g[h])&&Array.isArray(y[h])?g[h]=y[h]:typeof g[h]=="object"&&typeof y[h]=="object"?g[h]=l(g[h],y[h]):g[h]=y[h]}),g),{}),d=globalThis._VSCODE_USER_PRODUCT_JSON||{};s=l(s,d)}catch{}if(i.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const l=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:l.version,release:l.release})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(le[28],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(le[240],ce([0,1,8,5]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let P=class{constructor(A,R,b){this._window=A,this._sessionId=R,this._logService=b}async inspect(A){await this._connect();const R=this._window.webContents.debugger;await R.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,i.timeout)(A);const b=await R.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),b.profile}async _connect(){const A=this._window.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async _disconnect(){const A=this._window.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};e.WindowProfiler=P,e.WindowProfiler=P=Ie([se(2,s.ILogService)],P)}),define(le[85],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,i.createDecorator)("protocolMainService")}),define(le[46],ce([0,1,141,12]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(A,R){i.ok(s.isString(A)),i.ok(s.isObject(R)),i.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new P}),define(le[241],ce([0,1,3,46]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class k{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,l){this.schemasById[P(b)]=l,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;s.Registry.add(e.Extensions.JSONContribution,A)}),define(le[54],ce([0,1,22,3,12,168,18,241,46]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=m,e.keyFromOverrideIdentifiers=p,e.getDefaultValue=v,e.validateProperty=E,e.getScopes=I;var l;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var d;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d||(e.ConfigurationScope=d={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const f=b.Registry.as(R.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new s.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new s.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const a=new Set;this.doRegisterConfigurations(t,r,a),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(t){const r=new Set;this.doDeregisterConfigurations(t,r),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:t,remove:r}){const a=new Set;this.doDeregisterConfigurations(r,a),this.doRegisterConfigurations(t,!1,a),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}registerDefaultConfigurations(t){const r=new Set;this.doRegisterDefaultConfigurations(t,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,r){const a=[];for(const{overrides:n,source:c}of t)for(const u in n)if(r.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const S=this.configurationDefaultsOverrides.get(u),D=S?.valuesSources??new Map;if(c)for(const C of Object.keys(n[u]))D.set(C,c);const L={...S?.value||{},...n[u]};this.configurationDefaultsOverrides.set(u,{source:c,value:L,valuesSources:D});const M=(0,A.getLanguageTagSettingPlainKey)(u),T={type:"object",default:L,description:k.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:L,source:P.isString(c)?void 0:c,defaultValueSource:c};a.push(...m(u)),this.configurationProperties[u]=T,this.defaultLanguageConfigurationOverridesNode.properties[u]=T}else{this.configurationDefaultsOverrides.set(u,{value:n[u],source:c});const S=this.configurationProperties[u];S&&(this.updatePropertyDefaultValue(u,S),this.updateSchema(u,S))}this.doRegisterOverrideIdentifiers(a)}deregisterDefaultConfigurations(t){const r=new Set;this.doDeregisterDefaultConfigurations(t,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,r){for(const{overrides:a,source:n}of t)for(const c in a){const u=this.configurationDefaultsOverrides.get(c),S=P.isString(n)?n:n?.id,D=P.isString(u?.source)?u?.source:u?.source?.id;if(S===D)if(r.add(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const L=this.configurationProperties[c];L&&(this.updatePropertyDefaultValue(c,L),this.updateSchema(c,L))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let r=!1;const a=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,a),r=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,a),r=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,a),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const r of t)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,r,a){t.forEach(n=>{this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties,void 0,a),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(t,r){const a=n=>{if(n.properties)for(const c in n.properties){r.add(c);const u=this.configurationProperties[c];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,n.properties[c])}n.allOf?.forEach(c=>a(c))};for(const n of t){a(n);const c=this.configurationContributors.indexOf(n);c!==-1&&this.configurationContributors.splice(c,1)}}validateAndRegisterProperties(t,r=!0,a,n,c=d.WINDOW,u){c=P.isUndefinedOrNull(t.scope)?c:t.scope;const S=t.properties;if(S)for(const L in S){const M=S[L];if(r&&E(L,M)){delete S[L];continue}if(M.source=a,M.defaultDefaultValue=S[L].default,this.updatePropertyDefaultValue(L,M),e.OVERRIDE_PROPERTY_REGEX.test(L)?M.scope=void 0:(M.scope=P.isUndefinedOrNull(M.scope)?c:M.scope,M.restricted=P.isUndefinedOrNull(M.restricted)?!!n?.includes(L):M.restricted),S[L].hasOwnProperty("included")&&!S[L].included){this.excludedConfigurationProperties[L]=S[L],delete S[L];continue}else this.configurationProperties[L]=S[L],S[L].policy?.name&&this.policyConfigurations.set(S[L].policy.name,L);!S[L].deprecationMessage&&S[L].markdownDeprecationMessage&&(S[L].deprecationMessage=S[L].markdownDeprecationMessage),u.add(L)}const D=t.allOf;if(D)for(const L of D)this.validateAndRegisterProperties(L,r,a,n,c,u)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const r=a=>{const n=a.properties;if(n)for(const u in n)this.updateSchema(u,n[u]);a.allOf?.forEach(r)};r(t)}updateSchema(t,r){switch(e.allSettings.properties[t]=r,r.scope){case d.APPLICATION:e.applicationSettings.properties[t]=r;break;case d.MACHINE:e.machineSettings.properties[t]=r;break;case d.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[t]=r;break;case d.WINDOW:e.windowSettings.properties[t]=r;break;case d.RESOURCE:e.resourceSettings.properties[t]=r;break;case d.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[t]=r,this.resourceLanguageSettingsSchema.properties[t]=r;break}}removeFromSchema(t,r){switch(delete e.allSettings.properties[t],r.scope){case d.APPLICATION:delete e.applicationSettings.properties[t];break;case d.MACHINE:delete e.machineSettings.properties[t];break;case d.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[t];break;case d.WINDOW:delete e.windowSettings.properties[t];break;case d.RESOURCE:case d.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const r=`[${t}]`,a={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}}registerOverridePropertyPatternKey(){const t={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,r){const a=this.configurationDefaultsOverrides.get(t);let n=a?.value,c=a?.source;P.isUndefined(n)&&(n=r.defaultDefaultValue,c=void 0),P.isUndefined(n)&&(n=v(r.type)),r.default=n,r.defaultValueSource=c}}const y="\\[([^\\]]+)\\]",h=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(o){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(o)){let r=h.exec(o);for(;r?.length;){const a=r[1].trim();a&&t.push(a),r=h.exec(o)}}return(0,i.distinct)(t)}function p(o){return o.reduce((t,r)=>`${t}[${r}]`,"")}function v(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new g;b.Registry.add(e.Extensions.Configuration,w);function E(o,t){return o.trim()?e.OVERRIDE_PROPERTY_REGEX.test(o)?k.localize(7,null,o):w.getConfigurationProperties()[o]!==void 0?k.localize(8,null,o):t.policy?.name&&w.getPolicyConfigurations().get(t.policy?.name)!==void 0?k.localize(9,null,o,t.policy?.name,w.getPolicyConfigurations().get(t.policy?.name)):null:k.localize(6,null)}function I(){const o=[],t=w.getConfigurationProperties();for(const r of Object.keys(t))o.push([r,t[r].scope]);return o.push(["launch",d.RESOURCE]),o.push(["task",d.RESOURCE]),o}}),define(le[126],ce([0,1,22,3,40,2,32,35,12,7,18,54,15,46]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=I;function h(a){return Object.isFrozen(a)?a:R.deepFreeze(a)}class m{static createEmptyModel(n){return new m({},[],[],void 0,n)}constructor(n,c,u,S,D){this._contents=n,this._keys=c,this._overrides=u,this.raw=S,this.logService=D,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(c=>{if(c instanceof m)return c;const u=new p("",this.logService);return u.parseRaw(c),u.configurationModel});this._rawConfiguration=n.reduce((c,u)=>u===c?u:c.merge(u),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,d.getConfigurationValue)(this.contents,n):this.contents}inspect(n,c){const u=this;return{get value(){return h(u.rawConfiguration.getValue(n))},get override(){return c?h(u.rawConfiguration.getOverrideValue(n,c)):void 0},get merged(){return h(c?u.rawConfiguration.override(c).getValue(n):u.rawConfiguration.getValue(n))},get overrides(){const S=[];for(const{contents:D,identifiers:L,keys:M}of u.rawConfiguration.overrides){const T=new m(D,M,[],void 0,u.logService).getValue(n);T!==void 0&&S.push({identifiers:L,value:T})}return S.length?h(S):void 0}}}getOverrideValue(n,c){const u=this.getContentsForOverrideIdentifer(c);return u?n?(0,d.getConfigurationValue)(u,n):u:void 0}getKeysForOverrideIdentifier(n){const c=[];for(const u of this.overrides)u.identifiers.includes(n)&&c.push(...u.keys);return i.distinct(c)}getAllOverrideIdentifiers(){const n=[];for(const c of this.overrides)n.push(...c.identifiers);return i.distinct(n)}override(n){let c=this.overrideConfigurations.get(n);return c||(c=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,c)),c}merge(...n){const c=R.deepClone(this.contents),u=R.deepClone(this.overrides),S=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const L of n)if(D.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.mergeContents(c,L.contents);for(const M of L.overrides){const[T]=u.filter(C=>i.equals(C.identifiers,M.identifiers));T?(this.mergeContents(T.contents,M.contents),T.keys.push(...M.keys),T.keys=i.distinct(T.keys)):u.push(R.deepClone(M))}for(const M of L.keys)S.indexOf(M)===-1&&S.push(M)}return new m(c,S,u,D.every(L=>L instanceof m)?void 0:D,this.logService)}createOverrideConfigurationModel(n){const c=this.getContentsForOverrideIdentifer(n);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const u={};for(const S of i.distinct([...Object.keys(this.contents),...Object.keys(c)])){let D=this.contents[S];const L=c[S];L&&(typeof D=="object"&&typeof L=="object"?(D=R.deepClone(D),this.mergeContents(D,L)):D=L),u[S]=D}return new m(u,this.keys,this.overrides,void 0,this.logService)}mergeContents(n,c){for(const u of Object.keys(c)){if(u in n&&b.isObject(n[u])&&b.isObject(c[u])){this.mergeContents(n[u],c[u]);continue}n[u]=R.deepClone(c[u])}}getContentsForOverrideIdentifer(n){let c=null,u=null;const S=D=>{D&&(u?this.mergeContents(u,D):u=R.deepClone(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===n?c=D.contents:D.identifiers.includes(n)&&S(D.contents);return S(c),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,c){this.updateValue(n,c,!0)}setValue(n,c){this.updateValue(n,c,!1)}removeValue(n){const c=this.keys.indexOf(n);c!==-1&&(this.keys.splice(c,1),(0,d.removeFromValueTree)(this.contents,n),f.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(u=>i.equals(u.identifiers,(0,f.overrideIdentifiersFromKey)(n))),1))}updateValue(n,c,u){(0,d.addToValueTree)(this.contents,n,c,S=>this.logService.error(S)),u=u||this.keys.indexOf(n)===-1,u&&this.keys.push(n),f.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,f.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,d.toValuesTree)(this.contents[n],S=>this.logService.error(S))})}}e.ConfigurationModel=m;class p{constructor(n,c){this._name=n,this.logService=c,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||m.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,c){if(!b.isUndefinedOrNull(n)){const u=this.doParseContent(n);this.parseRaw(u,c)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,c){this._raw=n;const{contents:u,keys:S,overrides:D,restricted:L,hasExcludedProperties:M}=this.doParseRaw(n,c);this._configurationModel=new m(u,S,D,M?[n]:void 0,this.logService),this._restrictedConfigurations=L||[]}doParseContent(n){let c={},u=null,S=[];const D=[],L=[];function M(C){Array.isArray(S)?S.push(C):u!==null&&(S[u]=C)}const T={onObjectBegin:()=>{const C={};M(C),D.push(S),S=C,u=null},onObjectProperty:C=>{u=C},onObjectEnd:()=>{S=D.pop()},onArrayBegin:()=>{const C=[];M(C),D.push(S),S=C,u=null},onArrayEnd:()=>{S=D.pop()},onLiteralValue:M,onError:(C,F,x)=>{L.push({error:C,offset:F,length:x})}};if(n)try{P.visit(n,T),c=S[0]||{}}catch(C){this.logService.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return c}doParseRaw(n,c){const u=y.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),S=this.filter(n,u,!0,c);n=S.raw;const D=(0,d.toValuesTree)(n,T=>this.logService.error(`Conflict in settings file ${this._name}: ${T}`)),L=Object.keys(n),M=this.toOverrides(n,T=>this.logService.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:D,keys:L,overrides:M,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}filter(n,c,u,S){let D=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:D};const L={},M=[];for(const T in n)if(f.OVERRIDE_PROPERTY_REGEX.test(T)&&u){const C=this.filter(n[T],c,!1,S);L[T]=C.raw,D=D||C.hasExcludedProperties,M.push(...C.restricted)}else{const C=c[T],F=C?typeof C.scope<"u"?C.scope:f.ConfigurationScope.WINDOW:void 0;C?.restricted&&M.push(T),!S.exclude?.includes(T)&&(S.include?.includes(T)||(F===void 0||S.scopes===void 0||S.scopes.includes(F))&&!(S.skipRestricted&&C?.restricted))?L[T]=n[T]:D=!0}return{raw:L,restricted:M,hasExcludedProperties:D}}toOverrides(n,c){const u=[];for(const S of Object.keys(n))if(f.OVERRIDE_PROPERTY_REGEX.test(S)){const D={};for(const L in n[S])D[L]=n[S][L];u.push({identifiers:(0,f.overrideIdentifiersFromKey)(S),keys:Object.keys(D),contents:(0,d.toValuesTree)(D,c)})}return u}}e.ConfigurationModelParser=p;class v extends k.Disposable{constructor(n,c,u,S,D){super(),this.userSettingsResource=n,this.parseOptions=c,this.fileService=S,this.logService=D,this._onDidChange=this._register(new s.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString(),D),this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(s.Event.any(s.Event.filter(this.fileService.onDidFilesChange,L=>L.contains(this.userSettingsResource)),s.Event.filter(this.fileService.onDidRunOperation,L=>(L.isOperation(g.FileOperation.CREATE)||L.isOperation(g.FileOperation.COPY)||L.isOperation(g.FileOperation.DELETE)||L.isOperation(g.FileOperation.WRITE))&&u.isEqual(L.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return m.createEmptyModel(this.logService)}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class w{constructor(n,c,u,S,D,L,M,T,C,F,x,U,z){this.key=n,this.overrides=c,this._value=u,this.overrideIdentifiers=S,this.defaultConfiguration=D,this.policyConfiguration=L,this.applicationConfiguration=M,this.userConfiguration=T,this.localUserConfiguration=C,this.remoteUserConfiguration=F,this.workspaceConfiguration=x,this.folderConfigurationModel=U,this.memoryConfigurationModel=z}get value(){return h(this._value)}toInspectValue(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class E{constructor(n,c,u,S,D,L,M,T,C,F){this._defaultConfiguration=n,this._policyConfiguration=c,this._applicationConfiguration=u,this._localUserConfiguration=S,this._remoteUserConfiguration=D,this._workspaceConfiguration=L,this._folderConfigurations=M,this._memoryConfiguration=T,this._memoryConfigurationByResource=C,this.logService=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(n,c,u){return this.getConsolidatedConfigurationModel(n,c,u).getValue(n)}updateValue(n,c,u={}){let S;u.resource?(S=this._memoryConfigurationByResource.get(u.resource),S||(S=m.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(u.resource,S))):S=this._memoryConfiguration,c===void 0?S.removeValue(n):S.setValue(n,c),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,c,u){const S=this.getConsolidatedConfigurationModel(n,c,u),D=this.getFolderConfigurationModelForResource(c.resource,u),L=c.resource?this._memoryConfigurationByResource.get(c.resource)||this._memoryConfiguration:this._memoryConfiguration,M=new Set;for(const T of S.overrides)for(const C of T.identifiers)S.getOverrideValue(n,C)!==void 0&&M.add(C);return new w(n,c,S.getValue(n),M.size?[...M]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this._workspaceConfiguration:void 0,D||void 0,L)}keys(n){const c=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,c){this._folderConfigurations.set(n,c),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,c){const u=[];if(!c){const{added:S,updated:D,removed:L}=t(this._defaultConfiguration,n);c=[...S,...D,...L]}for(const S of c)for(const D of(0,f.overrideIdentifiersFromKey)(S)){const L=this._defaultConfiguration.getKeysForOverrideIdentifier(D),M=n.getKeysForOverrideIdentifier(D),T=[...M.filter(C=>L.indexOf(C)===-1),...L.filter(C=>M.indexOf(C)===-1),...L.filter(C=>!R.equals(this._defaultConfiguration.override(D).getValue(C),n.override(D).getValue(C)))];u.push([D,T])}return this.updateDefaultConfiguration(n),{keys:c,overrides:u}}compareAndUpdatePolicyConfiguration(n){const{added:c,updated:u,removed:S}=t(this._policyConfiguration,n),D=[...c,...u,...S];return D.length&&this.updatePolicyConfiguration(n),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:c,updated:u,removed:S,overrides:D}=t(this.applicationConfiguration,n),L=[...c,...u,...S];return L.length&&this.updateApplicationConfiguration(n),{keys:L,overrides:D}}compareAndUpdateLocalUserConfiguration(n){const{added:c,updated:u,removed:S,overrides:D}=t(this.localUserConfiguration,n),L=[...c,...u,...S];return L.length&&this.updateLocalUserConfiguration(n),{keys:L,overrides:D}}compareAndUpdateRemoteUserConfiguration(n){const{added:c,updated:u,removed:S,overrides:D}=t(this.remoteUserConfiguration,n),L=[...c,...u,...S];return L.length&&this.updateRemoteUserConfiguration(n),{keys:L,overrides:D}}compareAndUpdateWorkspaceConfiguration(n){const{added:c,updated:u,removed:S,overrides:D}=t(this.workspaceConfiguration,n),L=[...c,...u,...S];return L.length&&this.updateWorkspaceConfiguration(n),{keys:L,overrides:D}}compareAndUpdateFolderConfiguration(n,c){const u=this.folderConfigurations.get(n),{added:S,updated:D,removed:L,overrides:M}=t(u,c),T=[...S,...D,...L];return(T.length||!u)&&this.updateFolderConfiguration(n,c),{keys:T,overrides:M}}compareAndDeleteFolderConfiguration(n){const c=this.folderConfigurations.get(n);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:u,updated:S,removed:D,overrides:L}=t(c,void 0);return{keys:[...u,...S,...D],overrides:L}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,c,u){let S=this.getConsolidatedConfigurationModelForResource(c,u);return c.overrideIdentifier&&(S=S.override(c.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(S=S.merge(this._policyConfiguration)),S}getConsolidatedConfigurationModelForResource({resource:n},c){let u=this.getWorkspaceConsolidatedConfiguration();if(c&&n){const S=c.getFolder(n);S&&(u=this.getFolderConsolidatedConfiguration(S.uri)||u);const D=this._memoryConfigurationByResource.get(n);D&&(u=u.merge(D))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let c=this._foldersConsolidatedConfigurations.get(n);if(!c){const u=this.getWorkspaceConsolidatedConfiguration(),S=this._folderConfigurations.get(n);S?(c=u.merge(S),this._foldersConsolidatedConfigurations.set(n,c)):c=u}return c}getFolderConfigurationModelForResource(n,c){if(c&&n){const u=c.getFolder(n);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,c)=>{const{contents:u,overrides:S,keys:D}=this._folderConfigurations.get(c);return n.push([c,{contents:u,overrides:S,keys:D}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(c=>n.add(c)),this.userConfiguration.keys.forEach(c=>n.add(c)),this._workspaceConfiguration.keys.forEach(c=>n.add(c)),this._folderConfigurations.forEach(c=>c.keys.forEach(u=>n.add(u))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this._folderConfigurations.forEach(c=>c.getAllOverrideIdentifiers().forEach(u=>n.add(u))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const c=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(u=>c.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(u=>c.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(u=>c.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(n).forEach(S=>c.add(S))),[...c.values()]}static parse(n,c){const u=this.parseConfigurationModel(n.defaults,c),S=this.parseConfigurationModel(n.policy,c),D=this.parseConfigurationModel(n.application,c),L=this.parseConfigurationModel(n.user,c),M=this.parseConfigurationModel(n.workspace,c),T=n.folders.reduce((C,F)=>(C.set(l.URI.revive(F[0]),this.parseConfigurationModel(F[1],c)),C),new A.ResourceMap);return new E(u,S,D,L,m.createEmptyModel(c),M,T,m.createEmptyModel(c),new A.ResourceMap,c)}static parseConfigurationModel(n,c){return new m(n.contents,n.keys,n.overrides,void 0,c)}}e.Configuration=E;function I(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,c=new Map;for(const S of a)S.keys.forEach(D=>n.add(D)),S.overrides.forEach(([D,L])=>{const M=(0,A.getOrSet)(c,D,new Set);L.forEach(T=>M.add(T))});const u=[];return c.forEach((S,D)=>u.push([D,[...S.values()]])),{keys:[...n.values()],overrides:u}}class o{constructor(n,c,u,S,D){this.change=n,this.previous=c,this.currentConfiguraiton=u,this.currentWorkspace=S,this.logService=D,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const L of n.keys)this.affectedKeys.add(L);for(const[,L]of n.overrides)for(const M of L)this.affectedKeys.add(M);this._affectsConfigStr=this._marker;for(const L of this.affectedKeys)this._affectsConfigStr+=L+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(n,c){const u=this._marker+n,S=this._affectsConfigStr.indexOf(u);if(S<0)return!1;const D=S+u.length;if(D>=this._affectsConfigStr.length)return!1;const L=this._affectsConfigStr.charCodeAt(D);if(L!==this._markerCode1&&L!==this._markerCode2)return!1;if(c){const M=this.previousConfiguration?this.previousConfiguration.getValue(n,c,this.previous?.workspace):void 0,T=this.currentConfiguraiton.getValue(n,c,this.currentWorkspace);return!R.equals(M,T)}return!0}}e.ConfigurationChangeEvent=o;function t(a,n){const{added:c,removed:u,updated:S}=r(n?.rawConfiguration,a?.rawConfiguration),D=[],L=a?.getAllOverrideIdentifiers()||[],M=n?.getAllOverrideIdentifiers()||[];if(n){const T=M.filter(C=>!L.includes(C));for(const C of T)D.push([C,n.getKeysForOverrideIdentifier(C)])}if(a){const T=L.filter(C=>!M.includes(C));for(const C of T)D.push([C,a.getKeysForOverrideIdentifier(C)])}if(n&&a){for(const T of L)if(M.includes(T)){const C=r({contents:a.getOverrideValue(void 0,T)||{},keys:a.getKeysForOverrideIdentifier(T)},{contents:n.getOverrideValue(void 0,T)||{},keys:n.getKeysForOverrideIdentifier(T)});D.push([T,[...C.added,...C.removed,...C.updated]])}}return{added:c,removed:u,updated:S,overrides:D}}function r(a,n){const c=a?n?a.keys.filter(D=>n.keys.indexOf(D)===-1):[...a.keys]:[],u=n?a?n.keys.filter(D=>a.keys.indexOf(D)===-1):[...n.keys]:[],S=[];if(a&&n){for(const D of n.keys)if(a.keys.indexOf(D)!==-1){const L=(0,d.getConfigurationValue)(n.contents,D),M=(0,d.getConfigurationValue)(a.contents,D);R.equals(L,M)||S.push(D)}}return{added:c,removed:u,updated:S}}}),define(le[242],ce([0,1,22,3,2,35,12,126,54,5,41,46]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends P.Disposable{get configurationModel(){return this._configurationModel}constructor(p){super(),this.logService=p,this._onDidChangeConfiguration=this._register(new s.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(f.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:v})=>this.onDidUpdateConfiguration(Array.from(p),v))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(p,v){this.updateConfigurationModel(p,f.Registry.as(b.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService);const p=f.Registry.as(b.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(p),p)}updateConfigurationModel(p,v){const w=this.getConfigurationDefaultOverrides();for(const E of p){const I=w[E],o=v[E];I!==void 0?this._configurationModel.addValue(E,I):o?this._configurationModel.addValue(E,o.default):this._configurationModel.removeValue(E)}}}e.DefaultConfiguration=g;class y{constructor(){this.onDidChangeConfiguration=s.Event.None,this.configurationModel=R.ConfigurationModel.createEmptyModel(new l.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let h=class extends P.Disposable{get configurationModel(){return this._configurationModel}constructor(p,v,w){super(),this.defaultConfiguration=p,this.policyService=v,this.logService=w,this._onDidChangeConfiguration=this._register(new s.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.updatePolicyDefinitions(p),!0))),this._configurationModel}async updatePolicyDefinitions(p){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",p);const v={},w=[],E=f.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const I of p){const o=E[I];if(!o){w.push(I);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}w.push(I),v[o.policy.name]={type:o.type}}}return(0,A.isEmptyObject)(v)||await this.policyService.updatePolicyDefinitions(v),w}onDidChangePolicies(p){this.logService.trace("PolicyConfiguration#onDidChangePolicies",p);const v=f.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),w=(0,i.coalesce)(p.map(E=>v.get(E)));this.update(w,!0)}update(p,v){this.logService.trace("PolicyConfiguration#update",p);const w=f.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),E=[],I=this._configurationModel.isEmpty();for(const o of p){const t=w[o]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(I?r!==void 0:!(0,k.equals)(this._configurationModel.getValue(o),r))&&E.push([o,r])}else this._configurationModel.getValue(o)!==void 0&&E.push([o,void 0])}if(E.length){this.logService.trace("PolicyConfiguration#changed",E);const o=this._configurationModel;this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService);for(const t of o.keys)this._configurationModel.setValue(t,o.getValue(t));for(const[t,r]of E)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);v&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=h,e.PolicyConfiguration=h=Ie([se(1,d.IPolicyService),se(2,l.ILogService)],h)}),define(le[243],ce([0,1,22,8,17,3,40,108,2,32,35,4,19,18,126,54,242,15,41]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends b.Disposable{constructor(t,r,a,n){super(),this.settingsResource=t,this.logService=n,this._onDidChangeConfiguration=this._register(new k.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new p.DefaultConfiguration(n)),this.policyConfiguration=a instanceof w.NullPolicyService?new p.NullPolicyConfiguration:this._register(new p.PolicyConfiguration(this.defaultConfiguration,a,n)),this.userConfiguration=this._register(new h.UserSettings(this.settingsResource,{},g.extUriBiasedIgnorePathCase,r,n)),this.configuration=new h.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,h.ConfigurationModel.createEmptyModel(n),h.ConfigurationModel.createEmptyModel(n),h.ConfigurationModel.createEmptyModel(n),h.ConfigurationModel.createEmptyModel(n),new l.ResourceMap,h.ConfigurationModel.createEmptyModel(n),new l.ResourceMap,n),this.configurationEditing=new I(t,r,this),this.reloadConfigurationScheduler=this._register(new s.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:c,properties:u})=>this.onDidDefaultConfigurationChange(c,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(c=>this.onDidPolicyConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[t,r,a]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new h.Configuration(t,r,h.ConfigurationModel.createEmptyModel(this.logService),a,h.ConfigurationModel.createEmptyModel(this.logService),h.ConfigurationModel.createEmptyModel(this.logService),new l.ResourceMap,h.ConfigurationModel.createEmptyModel(this.logService),new l.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(t,r){const a=typeof t=="string"?t:void 0,n=(0,y.isConfigurationOverrides)(t)?t:(0,y.isConfigurationOverrides)(r)?r:{};return this.configuration.getValue(a,n,void 0)}async updateValue(t,r,a,n,c){const u=(0,y.isConfigurationUpdateOverrides)(a)?a:(0,y.isConfigurationOverrides)(a)?{resource:a.resource,overrideIdentifiers:a.overrideIdentifier?[a.overrideIdentifier]:void 0}:void 0,S=u?n:a;if(S!==void 0&&S!==y.ConfigurationTarget.USER_LOCAL&&S!==y.ConfigurationTarget.USER)throw new Error(`Unable to write ${t} to target ${S}.`);u?.overrideIdentifiers&&(u.overrideIdentifiers=(0,i.distinct)(u.overrideIdentifiers),u.overrideIdentifiers=u.overrideIdentifiers.length?u.overrideIdentifiers:void 0);const D=this.inspect(t,{resource:u?.resource,overrideIdentifier:u?.overrideIdentifiers?u.overrideIdentifiers[0]:void 0});if(D.policyValue!==void 0)throw new Error(`Unable to write ${t} because it is configured in system policy.`);if((0,d.equals)(r,D.defaultValue)&&(r=void 0),u?.overrideIdentifiers?.length&&u.overrideIdentifiers.length>1){const M=u.overrideIdentifiers.sort(),T=this.configuration.localUserConfiguration.overrides.find(C=>(0,i.equals)([...C.identifiers].sort(),M));T&&(u.overrideIdentifiers=T.identifiers)}const L=u?.overrideIdentifiers?.length?[(0,m.keyFromOverrideIdentifiers)(u.overrideIdentifiers),t]:[t];await this.configurationEditing.write(L,r),await this.reloadConfiguration()}inspect(t,r={}){return this.configuration.inspect(t,r,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const t=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(t)}onDidChangeUserConfiguration(t){const r=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(t);this.trigger(a,r,y.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(t,r){const a=this.configuration.toData(),n=this.configuration.compareAndUpdateDefaultConfiguration(t,r);this.trigger(n,a,y.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(t){const r=this.configuration.toData(),a=this.configuration.compareAndUpdatePolicyConfiguration(t);this.trigger(a,r,y.ConfigurationTarget.DEFAULT)}trigger(t,r,a){const n=new h.ConfigurationChangeEvent(t,{data:r},this.configuration,void 0,this.logService);n.source=a,this._onDidChangeConfiguration.fire(n)}}e.ConfigurationService=E;class I{constructor(t,r,a){this.settingsResource=t,this.fileService=r,this.configurationService=a,this.queue=new s.Queue}write(t,r){return this.queue.queue(()=>this.doWriteConfiguration(t,r))}async doWriteConfiguration(t,r){let a;try{a=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(u){if(u.fileOperationResult===v.FileOperationResult.FILE_NOT_FOUND)a="{}";else throw u}const n=[];if((0,A.parse)(a,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const c=this.getEdits(a,t,r);a=(0,R.applyEdits)(a,c),await this.fileService.writeFile(this.settingsResource,P.VSBuffer.fromString(a))}getEdits(t,r,a){const{tabSize:n,insertSpaces:c,eol:u}=this.formattingOptions;if(!r.length){const S=JSON.stringify(a,null,c?" ".repeat(n):"	");return[{content:S,length:S.length,offset:0}]}return(0,R.setProperty)(t,r,a,{tabSize:n,insertSpaces:c,eol:u})}get formattingOptions(){if(!this._formattingOptions){let t=f.OS===f.OperatingSystem.Linux||f.OS===f.OperatingSystem.Macintosh?`
`:`\r
`;const r=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});r&&typeof r=="string"&&r!=="auto"&&(t=r),this._formattingOptions={eol:t,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(le[244],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class i{async routeCall(P,k,A){if(k!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${k}`);const R=A[0];if(R?.authority){const b=P.connections.find(l=>l.ctx===R.authority);if(b)return b}throw new Error("Caller not found")}routeEvent(P,k){throw new Error(`Event not found: ${k}`)}}e.NodeRemoteResourceRouter=i}),define(le[245],ce([0,1,16,6]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=l,e.IRemoteAuthorityResolverService=(0,s.createDecorator)("remoteAuthorityResolverService");var P;(function(d){d[d.WebSocket=0]="WebSocket",d[d.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class k{constructor(f){this.id=f,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=k;class A{constructor(f,g){this.host=f,this.port=g,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=A;var R;(function(d){d.Unknown="Unknown",d.NotAvailable="NotAvailable",d.TemporarilyNotAvailable="TemporarilyNotAvailable",d.NoResolverFound="NoResolverFound",d.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class b extends i.ErrorNoTelemetry{static isNotAvailable(f){return f instanceof b&&f._code===R.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof b&&f._code===R.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof b&&f._code===R.NoResolverFound}static isInvalidAuthority(f){return f instanceof b&&f._code===R.InvalidAuthority}static isHandled(f){return f instanceof b&&f.isHandled}constructor(f,g=R.Unknown,y){super(f),this._message=f,this._code=g,this._detail=y,this.isHandled=g===R.NotAvailable&&y===!0,Object.setPrototypeOf(this,b.prototype)}}e.RemoteAuthorityResolverError=b;function l(d){const f=d.indexOf("+");return f===-1?d:d.substring(0,f)}}),define(le[246],ce([0,1,8,17,23,16,3,2,13,69,77,33,118,245]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=D,e.connectRemoteAgentExtensionHost=L,e.connectRemoteAgentTunnel=T;const h=30*1e3;var m;(function(ne){ne[ne.Management=1]="Management",ne[ne.ExtensionHost=2]="ExtensionHost",ne[ne.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function p(ne){switch(ne){case m.Management:return"Management";case m.ExtensionHost:return"ExtensionHost";case m.Tunnel:return"Tunnel"}}function v(ne){const J=new P.CancellationTokenSource;return setTimeout(()=>J.cancel(),ne),J.token}function w(ne,J){if(ne.isCancellationRequested||J.isCancellationRequested)return P.CancellationToken.Cancelled;const _=new P.CancellationTokenSource;return ne.onCancellationRequested(()=>_.cancel()),J.onCancellationRequested(()=>_.cancel()),_.token}class E{get didTimeout(){return this._state==="timedout"}constructor(J){this._state="pending",this._disposables=new R.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,i.promiseWithResolvers)(),J.isCancellationRequested?this._timeout():this._disposables.add(J.onCancellationRequested(()=>this._timeout()))}registerDisposable(J){this._state==="pending"?this._disposables.add(J):J.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(J))}reject(J){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(J))}}function I(ne,J){const _=new E(J);return _.registerDisposable(ne.onControlMessage(W=>{const N=JSON.parse(W.toString()),H=O(N);H?_.reject(H):_.resolve(N)})),_.promise}function o(ne,J,_,W,N,H,X,Q){const $=new E(Q),ee=d.StopWatch.create(!1);return ne.info(`Creating a socket (${X})...`),l.mark(`code/willCreateSocket/${H}`),J.connect(_,W,N,X).then(fe=>{$.didTimeout?(l.mark(`code/didCreateSocketError/${H}`),ne.info(`Creating a socket (${X}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(l.mark(`code/didCreateSocketOK/${H}`),ne.info(`Creating a socket (${X}) was successful after ${ee.elapsed()} ms.`),$.resolve(fe))},fe=>{l.mark(`code/didCreateSocketError/${H}`),ne.info(`Creating a socket (${X}) returned an error after ${ee.elapsed()} ms.`),ne.error(fe),$.reject(fe)}),$.promise}function t(ne,J){const _=new E(J);return ne.then(W=>{_.didTimeout||_.resolve(W)},W=>{_.didTimeout||_.reject(W)}),_.promise}async function r(ne,J,_,W){const N=j(ne,J);ne.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let H;try{H=await o(ne.logService,ne.remoteSocketFactoryService,ne.connectTo,b.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${ne.reconnectionToken}&reconnection=${ne.reconnectionProtocol?"true":"false"}`,p(J),`renderer-${p(J)}-${ne.reconnectionToken}`,W)}catch(fe){throw ne.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),ne.logService.error(fe),fe}ne.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let X,Q;ne.reconnectionProtocol?(ne.reconnectionProtocol.beginAcceptReconnection(H,null),X=ne.reconnectionProtocol,Q=!1):(X=new g.PersistentProtocol({socket:H}),Q=!0),ne.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const $=await t(ne.signService.createNewMessage((0,f.generateUuid)()),W),ee={type:"auth",auth:ne.connectionToken||"00000000000000000000",data:$.data};X.sendControl(s.VSBuffer.fromString(JSON.stringify(ee)));try{const fe=await I(X,w(W,v(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(ne.logService.trace(`${N} 4/6. received SignRequest control message.`),!await t(ne.signService.validate($,fe.signedData),W)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const we=await t(ne.signService.sign(fe.data),W),Re={type:"connectionType",commit:ne.commit,signedData:we,desiredConnectionType:J};return _&&(Re.args=_),ne.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(s.VSBuffer.fromString(JSON.stringify(Re))),{protocol:X,ownsProtocol:Q}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(ne.logService.error(`${N} the handshake timed out. Error:`),ne.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(ne.logService.error(`${N} received error control message when negotiating connection. Error:`),ne.logService.error(fe)),Q&&q(X),fe}}async function a(ne,J,_,W){const N=Date.now(),H=j(ne,J),{protocol:X,ownsProtocol:Q}=await r(ne,J,_,W),$=new E(W);return $.registerDisposable(X.onControlMessage(ee=>{const fe=JSON.parse(ee.toString()),me=O(fe);me?(ne.logService.error(`${H} received error control message when negotiating connection. Error:`),ne.logService.error(me),Q&&q(X),$.reject(me)):(ne.reconnectionProtocol?.endAcceptReconnection(),ne.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${he(N)}!`),$.resolve({protocol:X,firstMessage:fe}))})),$.promise}async function n(ne,J){const{protocol:_}=await a(ne,m.Management,void 0,J);return{protocol:_}}async function c(ne,J,_){const{protocol:W,firstMessage:N}=await a(ne,m.ExtensionHost,J,_),H=N&&N.debugPort;return{protocol:W,debugPort:H}}async function u(ne,J,_){const W=Date.now(),N=j(ne,m.Tunnel),{protocol:H}=await r(ne,m.Tunnel,J,_);return ne.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${he(W)}!`),H}async function S(ne,J,_){const{connectTo:W,connectionToken:N}=await ne.addressProvider.getAddress();return{commit:ne.commit,quality:ne.quality,connectTo:W,connectionToken:N,reconnectionToken:J,reconnectionProtocol:_,remoteSocketFactoryService:ne.remoteSocketFactoryService,signService:ne.signService,logService:ne.logService}}async function D(ne,J,_){return M(ne,async W=>{const{protocol:N}=await n(W,P.CancellationToken.None);return new G(ne,J,_,W.reconnectionToken,N)})}async function L(ne,J){return M(ne,async _=>{const{protocol:W,debugPort:N}=await c(_,J,P.CancellationToken.None);return new te(ne,J,_.reconnectionToken,W,N)})}async function M(ne,J){for(let W=1;;W++)try{const N=(0,f.generateUuid)(),H=await S(ne,N,null);return await J(H)}catch(N){if(W<5)ne.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),ne.logService.error(N);else throw ne.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ne.logService.error(N),oe.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(N)),N}}async function T(ne,J,_){const W=await S(ne,(0,f.generateUuid)(),null);return await u(W,{host:J,port:_},P.CancellationToken.None)}function C(ne){return(0,i.createCancelablePromise)(J=>new Promise((_,W)=>{const N=setTimeout(_,ne*1e3);J.onCancellationRequested(()=>{clearTimeout(N),_()})}))}var F;(function(ne){ne[ne.ConnectionLost=0]="ConnectionLost",ne[ne.ReconnectionWait=1]="ReconnectionWait",ne[ne.ReconnectionRunning=2]="ReconnectionRunning",ne[ne.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ne[ne.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class x{constructor(J,_){this.reconnectionToken=J,this.millisSinceLastIncomingData=_,this.type=F.ConnectionLost}}e.ConnectionLostEvent=x;class U{constructor(J,_,W,N){this.reconnectionToken=J,this.millisSinceLastIncomingData=_,this.durationSeconds=W,this.cancellableTimer=N,this.type=F.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=U;class z{constructor(J,_,W){this.reconnectionToken=J,this.millisSinceLastIncomingData=_,this.attempt=W,this.type=F.ReconnectionRunning}}e.ReconnectionRunningEvent=z;class re{constructor(J,_,W){this.reconnectionToken=J,this.millisSinceLastIncomingData=_,this.attempt=W,this.type=F.ConnectionGain}}e.ConnectionGainEvent=re;class ie{constructor(J,_,W,N){this.reconnectionToken=J,this.millisSinceLastIncomingData=_,this.attempt=W,this.handled=N,this.type=F.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=ie;class oe extends R.Disposable{static triggerPermanentFailure(J,_,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=J,this._permanentFailureAttempt=_,this._permanentFailureHandled=W,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(J=>J._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(J=>J._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||oe._permanentFailure}constructor(J,_,W,N,H){super(),this._connectionType=J,this._options=_,this.reconnectionToken=W,this.protocol=N,this._reconnectionFailureIsFatal=H,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new re(this.reconnectionToken,0,0)),this._register(N.onSocketClose(X=>{const Q=ae(this._connectionType,this.reconnectionToken,!0);X?X.type===g.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${Q} received socket close event (hadError: ${X.hadError}).`),X.error&&this._options.logService.error(X.error)):(this._options.logService.info(`${Q} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this._options.logService.error(X.event)):this._options.logService.info(`${Q} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(X=>{const Q=ae(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Q} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),oe._instances.push(this),this._register((0,R.toDisposable)(()=>{const X=oe._instances.indexOf(this);X>=0&&oe._instances.splice(X,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(oe._permanentFailureMillisSinceLastIncomingData,oe._permanentFailureAttempt,oe._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const J=ae(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const N=W<_.length?_[W]:_[_.length-1];try{if(N>0){const X=C(N);this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,X)),this._options.logService.info(`${J} waiting for ${N} seconds before reconnecting...`);try{await X}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${J} resolving connection...`);const H=await S(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${J} connecting to ${H.connectTo}...`),await this._reconnect(H,v(h)),this._options.logService.info(`${J} reconnected!`),this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(H)){this._options.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this._options.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((0,k.isCancellationError)(H)){this._options.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(H instanceof y.RemoteAuthorityResolverError){this._options.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,y.RemoteAuthorityResolverError.isHandled(H));break}this._options.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(J,_,W){this._reconnectionFailureIsFatal?oe.triggerPermanentFailure(J,_,W):this._gotoPermanentFailure(J,_,W)}_gotoPermanentFailure(J,_,W){this._onDidStateChange.fire(new ie(this.reconnectionToken,J,_,W)),q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=oe;class G extends oe{constructor(J,_,W,N,H){super(m.Management,J,N,H,!0),this.client=this._register(new g.Client(H,{remoteAuthority:_,clientId:W},J.ipcLogger))}async _reconnect(J,_){await n(J,_)}}e.ManagementPersistentConnection=G;class te extends oe{constructor(J,_,W,N,H){super(m.ExtensionHost,J,W,N,!1),this._startArguments=_,this.debugPort=H}async _reconnect(J,_){await c(J,this._startArguments,_)}}e.ExtensionHostPersistentConnection=te;function q(ne){try{ne.acceptDisconnect();const J=ne.getSocket();ne.dispose(),J.dispose()}catch(J){(0,k.onUnexpectedError)(J)}}function O(ne){if(ne&&ne.type==="error"){const J=new Error(`Connection error: ${ne.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function B(ne,J){for(;ne.length<J;)ne+=" ";return ne}function V(ne,J){return`[remote-connection][${B(p(ne),13)}][${J.substr(0,5)}\u2026]`}function ae(ne,J,_){return`${V(ne,J)}[${_?"reconnect":"initial"}]`}function j(ne,J){return`${ae(J,ne.reconnectionToken,!!ne.reconnectionProtocol)}[${ne.connectTo}]`}function he(ne){return`${Date.now()-ne} ms`}}),define(le[71],ce([0,1,13]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=s,e.getRemoteName=P,e.parseAuthorityWithPort=k,e.parseAuthorityWithOptionalPort=A;function s(b){return b.scheme===i.Schemas.vscodeRemote?b.authority:void 0}function P(b){if(!b)return;const l=b.indexOf("+");return l<0?b:b.substr(0,l)}function k(b){const{host:l,port:d}=R(b);if(typeof d>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:d}}function A(b,l){let{host:d,port:f}=R(b);return typeof f>"u"&&(f=l),{host:d,port:f}}function R(b){const l=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const d=b.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const f=b.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:b,port:void 0}}}),define(le[100],ce([0,1,26,6,71]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=k,e.isApplicationScopedExtension=f,e.isLanguagePackExtension=g,e.isAuthenticationProviderExtension=y,e.isResolverExtension=h,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(A||(e.ExtensionType=A={}));var R;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.LINUX_PPC64LE="linux-ppc64le",m.LINUX_RISCV64="linux-riscv64",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class b{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,v){if(typeof p>"u"||p===null)return typeof v>"u"||v===null;if(typeof v>"u"||v===null)return!1;if(typeof p=="string"||typeof v=="string"){const w=typeof p=="string"?p:p.value,E=typeof v=="string"?v:v.value;return i.equalsIgnoreCase(w,E)}return p._lower===v._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=b;class l{get size(){return this._set.size}constructor(p){if(this._set=new Set,p)for(const v of p)this.add(v)}add(p){this._set.add(b.toKey(p))}delete(p){return this._set.delete(b.toKey(p))}has(p){return this._set.has(b.toKey(p))}}e.ExtensionIdentifierSet=l;class d{constructor(){this._map=new Map}clear(){this._map.clear()}delete(p){this._map.delete(b.toKey(p))}get(p){return this._map.get(b.toKey(p))}has(p){return this._map.has(b.toKey(p))}set(p,v){this._map.set(b.toKey(p),v)}values(){return this._map.values()}forEach(p){this._map.forEach(p)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=d;function f(m){return g(m)}function g(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}function y(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}function h(m,p){if(p){const v=`onResolveRemoteAuthority:${(0,P.getRemoteName)(p)}`;return!!m.activationEvents?.includes(v)}return!1}e.IBuiltinExtensionsScannerService=(0,s.createDecorator)("IBuiltinExtensionsScannerService")}),define(le[127],ce([0,1,4,175,100,6]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=R,e.toTargetPlatform=b,e.getTargetPlatform=l,e.isNotWebExtensionInWebTargetPlatform=d,e.isTargetPlatformCompatible=f,e.isIExtensionIdentifier=g,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var A;(function(o){o.COMMAND="command",o.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function R(o){switch(o){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case P.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function b(o){switch(o){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.LINUX_PPC64LE:return P.TargetPlatform.LINUX_PPC64LE;case P.TargetPlatform.LINUX_RISCV64:return P.TargetPlatform.LINUX_RISCV64;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function l(o,t){switch(o){case i.Platform.Windows:return t==="x64"?P.TargetPlatform.WIN32_X64:t==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case i.Platform.Linux:return t==="x64"?P.TargetPlatform.LINUX_X64:t==="arm64"?P.TargetPlatform.LINUX_ARM64:t==="arm"?P.TargetPlatform.LINUX_ARMHF:t==="ppc64le"?P.TargetPlatform.LINUX_PPC64LE:t==="riscv64"?P.TargetPlatform.LINUX_RISCV64:P.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?P.TargetPlatform.ALPINE_X64:t==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case i.Platform.Mac:return t==="x64"?P.TargetPlatform.DARWIN_X64:t==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case i.Platform.Web:return P.TargetPlatform.WEB}}function d(o,t){return t===P.TargetPlatform.WEB&&!o.includes(P.TargetPlatform.WEB)}function f(o,t,r){return d(t,r)?!1:o===P.TargetPlatform.UNDEFINED||o===P.TargetPlatform.UNIVERSAL?!0:o===P.TargetPlatform.UNKNOWN?!1:o===r}function g(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}var y;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var h;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var m;(function(o){o.Install="install",o.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var p;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var v;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed",o.DownloadFailedWriting="DownloadFailedWriting"})(v||(e.ExtensionGalleryErrorCode=v={}));class w extends Error{constructor(t,r){super(t),this.code=r,this.name=r}}e.ExtensionGalleryError=w;var E;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.DownloadFailedWriting="DownloadFailedWriting",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.ScanningExtension="ScanningExtension",o.ReadUninstalled="ReadUninstalled",o.UnsetUninstalled="UnsetUninstalled",o.Delete="Delete",o.Rename="Rename",o.IntializeDefaultProfile="IntializeDefaultProfile",o.AddToProfile="AddToProfile",o.InstalledExtensionNotFound="InstalledExtensionNotFound",o.PostInstall="PostInstall",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Cancelled="Cancelled",o.Unknown="Unknown",o.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));class I extends Error{constructor(t,r){super(t),this.code=r,this.name=r}}e.ExtensionManagementError=I,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,s.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,s.localize2)(1,"Preferences")}),define(le[247],ce([0,1,2,6]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,s.createDecorator)("remoteSocketFactoryService");class P{constructor(){this.factories={}}register(A,R){return this.factories[A]??=[],this.factories[A].push(R),(0,i.toDisposable)(()=>{const b=this.factories[A]?.indexOf(R);typeof b=="number"&&b>=0&&this.factories[A]?.splice(b,1)})}getSocketFactory(A){return(this.factories[A.type]||[]).find(b=>b.supports(A))}connect(A,R,b,l){const d=this.getSocketFactory(A);if(!d)throw new Error(`No socket factory found for ${A}`);return d.connect(A,R,b,l)}}e.RemoteSocketFactoryService=P}),define(le[248],ce([0,1,27,50,21,122]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=R;let A;async function R(y=!1){return(A===void 0||y)&&(A=b()),A}async function b(){const y=l();if(y===void 0)return!1;if(y>=22e3){const h=f();if(h)return new Promise(m=>{s.execFile(h,["--status"],p=>m(!p))})}else{const h=g();if(h)try{if((await P.Promises.stat(h)).isFile())return!0}catch{}}return!1}function l(){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());if(y)return parseInt(y[3])}function d(y){const h=process.env.SystemRoot;if(h){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return k.join(h,m?"Sysnative":"System32",y)}}function f(){return d("wsl.exe")}function g(){return d("lxss\\LxssManager.dll")}}),define(le[55],ce([0,1,17,16,2,189,54,6,5,46]),function(K,e,i,s,P,k,A,R,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=g,e.hasNoContent=y,e.asText=h,e.asTextOrError=m,e.asJson=p,e.updateProxyConfigurationsScope=v,e.IRequestService=(0,R.createDecorator)("requestService");class d{constructor(o){this.original=o}toJSON(){if(!this.headers){const o=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?o[t]="*****":o[t]=this.original[t];this.headers=o}return this.headers}}class f extends P.Disposable{constructor(o){super(),this.counter=0,this.logger=o.createLogger("network",{name:(0,k.localize)(0,null),when:b.CONTEXT_LOG_LEVEL.isEqualTo((0,b.LogLevelToString)(b.LogLevel.Trace)).serialize()})}async logAndRequest(o,t,r){const a=`${o} #${++this.counter}: ${t.url}`;this.logger.trace(`${a} - begin`,t.type,new d(t.headers??{}));try{const n=await r();return this.logger.trace(`${a} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.logger.error(`${a} - error`,t.type,(0,s.getErrorMessage)(n)),n}}}e.AbstractRequestService=f;function g(I){return I.res.statusCode&&I.res.statusCode>=200&&I.res.statusCode<300||I.res.statusCode===1223}function y(I){return I.res.statusCode===204}async function h(I){return y(I)?null:(await(0,i.streamToBuffer)(I.stream)).toString()}async function m(I){if(!g(I))throw new Error("Server returned "+I.res.statusCode);return h(I)}async function p(I){if(!g(I))throw new Error("Server returned "+I.res.statusCode);if(y(I))return null;const t=(await(0,i.streamToBuffer)(I.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function v(I){E(I)}let w;function E(I){const o=l.Registry.as(A.Extensions.Configuration),t=w;w={id:"http",order:15,title:(0,k.localize)(1,null),type:"object",scope:I,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(6,null),(0,k.localize)(7,null),(0,k.localize)(8,null),(0,k.localize)(9,null)],default:"override",description:(0,k.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(12,null),restricted:!0}}},o.updateConfigurations({add:[w],remove:t?[t]:[]})}E(A.ConfigurationScope.APPLICATION)}),define(le[249],ce([0,1,17,23]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class P{constructor(R){this.service=R}listen(R,b){throw new Error("Invalid listen")}call(R,b,l,d=s.CancellationToken.None){switch(b){case"request":return this.service.request(l[0],d).then(async({res:f,stream:g})=>{const y=await(0,i.streamToBuffer)(g);return[{statusCode:f.statusCode,headers:f.headers},y]});case"resolveProxy":return this.service.resolveProxy(l[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=P;class k{constructor(R){this.channel=R}async request(R,b){const[l,d]=await this.channel.call("request",[R],b);return{res:l,stream:(0,i.bufferToStream)(d)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=k}),define(le[250],ce([0,1,251,12]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=k;function P(A,R){return A.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:A.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function k(A,R,b={}){const l=(0,i.parse)(A),d=b.proxyUrl||P(l,R);if(!d)return null;const f=(0,i.parse)(d);if(!/^https?:$/.test(f.protocol||""))return null;const g={host:f.hostname||"",port:(f.port?+f.port:0)||(f.protocol==="https"?443:80),auth:f.auth,rejectUnauthorized:(0,s.isBoolean)(b.strictSSL)?b.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((y,h)=>{K(["http-proxy-agent"],y,h)})).HttpProxyAgent(d,g):new(await new Promise((y,h)=>{K(["https-proxy-agent"],y,h)})).HttpsProxyAgent(d,g)}}),define(le[252],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[101],ce([0,1,50,9,190,23,48,16,4,33,117,67,8,143]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=m;let h;async function m(v,w,E,I){return E["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,f.isLaunchedFromCli)(I)&&!E["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,f.isLaunchedFromCli)(I)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=g.Promises.withAsyncBody(async(o,t)=>{const r=new k.CancellationTokenSource;let a=1e4;const n=v.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(a=(0,y.clamp)(n,1,120)*1e3);const c=setTimeout(()=>{r.dispose(!0),t(new Error((0,P.localize)(0,null)))},a);try{o(await p(w,r.token))}catch(u){!(0,R.isCancellationError)(u)&&!r.token.isCancellationRequested?t(new Error((0,P.localize)(1,null,(0,A.toErrorMessage)(u)))):o({})}finally{clearTimeout(c),r.dispose()}})),h)}async function p(v,w){const E=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",E);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",I);const o=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(o+"({.*})"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};v.trace("getUnixShellEnvironment#env",r);const a=await(0,d.getSystemShell)(b.OS,r);return v.trace("getUnixShellEnvironment#shell",a),new Promise((n,c)=>{if(w.isCancellationRequested)return c(new R.CancellationError);const u=(0,s.basename)(a);let S,D;const L="";/^pwsh(-preview)?$/.test(u)?(S=`& '${process.execPath}' ${L} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,D=["-Login","-Command"]):u==="nu"?(S=`^'${process.execPath}' ${L} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,D=["-i","-l","-c"]):u==="xonsh"?(S=`import os, json; print("${o}", json.dumps(dict(os.environ)), "${o}")`,D=["-i","-l","-c"]):(S=`'${process.execPath}' ${L} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,u==="tcsh"||u==="csh"?D=["-ic"]:D=["-i","-l","-c"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),S);const M=(0,i.spawn)(a,[...D,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});w.onCancellationRequested(()=>(M.kill(),c(new R.CancellationError))),M.on("error",F=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(F)),c(F)});const T=[];M.stdout.on("data",F=>T.push(F));const C=[];M.stderr.on("data",F=>C.push(F)),M.on("close",(F,x)=>{const U=Buffer.concat(T).toString("utf8");v.trace("getUnixShellEnvironment#raw",U);const z=Buffer.concat(C).toString("utf8");if(z.trim()&&v.trace("getUnixShellEnvironment#stderr",z),F||x)return c(new Error((0,P.localize)(2,null,F,x)));const re=t.exec(U),ie=re?re[1]:"{}";try{const oe=JSON.parse(ie);E?oe.ELECTRON_RUN_AS_NODE=E:delete oe.ELECTRON_RUN_AS_NODE,I?oe.ELECTRON_NO_ATTACH_CONSOLE=I:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",oe),n(oe)}catch(oe){v.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(oe)),c(oe)}})})}}),define(le[253],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class i{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(P){try{const k=await this.getValidator();if(k){const A=String(i._nextId++);return this.validators.set(A,k),{id:A,data:k.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,k){if(!P.id)return!0;const A=this.validators.get(P.id);if(!A)return!1;this.validators.delete(P.id);try{return A.validate(k)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(P){try{return await this.signValue(P)}catch{}return P}}e.AbstractSignService=i}),define(le[102],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,i.createDecorator)(e.SIGN_SERVICE_ID)}),define(le[254],ce([0,1,253]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class s extends i.AbstractSignService{getValidator(){return this.vsda().then(k=>new k.validator)}signValue(k){return this.vsda().then(A=>new A.signer().sign(k))}vsda(){return new Promise((k,A)=>K(["vsda"],k,A))}}e.SignService=s}),define(le[34],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,i.createDecorator)("stateReadService"),e.IStateService=(0,i.createDecorator)("stateService")}),define(le[128],ce([0,1,8,17,2,12,38,15,5]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var l;(function(y){y[y.IMMEDIATE=0]="IMMEDIATE",y[y.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class d extends P.Disposable{constructor(h,m,p,v){super(),this.storagePath=h,this.saveStrategy=m,this.logService=p,this.fileService=v,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new i.ThrottledDelayer(this.saveStrategy===l.IMMEDIATE?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(h){h.fileOperationResult!==R.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(h)}}getItem(h,m){const p=this.storage[h];return(0,k.isUndefinedOrNull)(p)?m:p}setItem(h,m){this.setItems([{key:h,data:m}])}setItems(h){let m=!1;for(const{key:p,data:v}of h)this.storage[p]!==v&&((0,k.isUndefinedOrNull)(v)?(0,k.isUndefined)(this.storage[p])||(this.storage[p]=void 0,m=!0):(this.storage[p]=v,m=!0));m&&this.save()}removeItem(h){(0,k.isUndefined)(this.storage[h])||(this.storage[h]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const h=JSON.stringify(this.storage,null,4);if(h!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,s.VSBuffer.fromString(h),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=h}catch(m){this.logService.error(m)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=d;let f=class extends P.Disposable{constructor(h,m,p,v){super(),this.fileStorage=this._register(new d(m.stateResource,h,p,v))}async init(){await this.fileStorage.init()}getItem(h,m){return this.fileStorage.getItem(h,m)}};e.StateReadonlyService=f,e.StateReadonlyService=f=Ie([se(1,A.IEnvironmentService),se(2,b.ILogService),se(3,R.IFileService)],f);class g extends f{setItem(h,m){this.fileStorage.setItem(h,m)}setItems(h){this.fileStorage.setItems(h)}removeItem(h){this.fileStorage.removeItem(h)}close(){return this.fileStorage.close()}}e.StateService=g}),define(le[129],ce([0,1,4,36,33]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=A,e.verifyMicrosoftInternalDomain=R;function k(b){if(i.platform===i.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function A(b,l,d,f,g,y,h,m,p,v){const w=Object.create(null);w["common.machineId"]=y,w["common.sqmId"]=h,w["common.devDeviceId"]=m,w.sessionID=(0,P.generateUuid)()+Date.now(),w.commitHash=f,w.version=g,w["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,i.PlatformToString)(i.platform),w["common.nodePlatform"]=s.platform,w["common.nodeArch"]=d,w["common.product"]=v||"desktop",p&&(w["common.msftInternal"]=p);let E=0;const I=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-I,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),i.isLinuxSnap&&(w["common.snap"]="true");const o=k(l);return o&&(w["common.platformDetail"]=o),w}function R(b){const l=s.env.USERDNSDOMAIN;if(!l)return!1;const d=l.toLowerCase();return b.some(f=>d===f)}}),define(le[24],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var s;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(s||(e.TelemetryLevel=s={}));var P;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(le[255],ce([0,1,27,8,40,13,9,4,7,93,21,116,96,15,28,24]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=v,e.getMachineInfo=E,e.collectLaunchConfigs=I;const p=new Map;async function v(t,r){const a=`${t}::${r.join(":")}`,n=p.get(a);if(n)return n;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,S=new Map,D=2e4;function L(T,C,F,x){const U=C.substring(T.length+1);return s.Promises.withAsyncBody(async z=>{let re;try{re=await d.Promises.readdir(C,{withFileTypes:!0})}catch{z();return}if(x.count>=D){x.count+=re.length,x.maxReached=!0,z();return}let ie=re.length;if(ie===0){z();return}let oe=re;x.count+re.length>D&&(x.maxReached=!0,ie=D-x.count,oe=re.slice(0,ie)),x.count+=re.length;for(const G of oe)if(G.isDirectory()){if(F.includes(G.name)||await L(T,(0,A.join)(C,G.name),F,x),--ie===0){z();return}}else{const te=G.name.lastIndexOf(".");if(te>=0){const q=G.name.substring(te+1);q&&u.set(q,(u.get(q)??0)+1)}for(const q of c)q.relativePathPattern?.test(U)!==!1&&q.filePattern.test(G.name)&&S.set(q.tag,(S.get(q.tag)??0)+1);if(--ie===0){z();return}}})}const M=s.Promises.withAsyncBody(async T=>{const C={count:0,maxReached:!1};await L(t,t,r,C);const F=await I(t);T({configFiles:w(S),fileTypes:w(u),fileCount:C.count,maxFilesReached:C.maxReached,launchConfigFiles:F})});return p.set(a,M),M}function w(t){return Array.from(t.entries(),([r,a])=>({name:r,count:a})).sort((r,a)=>a.count-r.count)}function E(){const t={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(i.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.virtualMachineHint.value()*100)}%`},r=i.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function I(t){try{const r=new Map,a=(0,A.join)(t,".vscode","launch.json"),n=await d.Promises.readFile(a),c=[],u=(0,P.parse)(n.toString(),c);if(c.length)return console.log(`Unable to parse ${a}`),[];if((0,P.getNodeType)(u)==="object"&&u.configurations)for(const S of u.configurations){const D=S.type;D&&(r.has(D)?r.set(D,r.get(D)+1):r.set(D,1))}return w(r)}catch{return[]}}let o=class{constructor(r,a){this.telemetryService=r,this.productService=a}formatMachineInfo(r){const a=[];return a.push(`OS Version:       ${r.os}`),a.push(`CPUs:             ${r.cpus}`),a.push(`Memory (System):  ${r.memory}`),a.push(`VM:               ${r.vmHint}`),a.join(`
`)}formatEnvironment(r){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const n=i.cpus();return n&&n.length>0&&a.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),a.push(`Memory (System):  ${(i.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(i.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||a.push(`Load (avg):       ${i.loadavg().map(c=>Math.round(c)).join(", ")}`),a.push(`VM:               ${Math.round(l.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${r.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(r,a){return Promise.all([(0,f.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async n=>{let[c,u]=n,S=this.formatProcessList(r,c);return a.forEach(D=>{if((0,g.isRemoteDiagnosticError)(D))S+=`
${D.errorMessage}`,u+=`
${D.errorMessage}`;else if(S+=`

Remote: ${D.hostName}`,D.processes&&(S+=`
${this.formatProcessList(r,D.processes)}`),D.workspaceMetadata){u+=`
|  Remote: ${D.hostName}`;for(const L of Object.keys(D.workspaceMetadata)){const M=D.workspaceMetadata[L];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),u+=`|    Folder (${L}): ${T}`,u+=this.formatWorkspaceStats(M)}}}),{processInfo:S,workspaceInfo:u}})}async getSystemInfo(r,a){const{memory:n,vmHint:c,os:u,cpus:S}=E(),D={os:u,memory:n,cpus:S,vmHint:c,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:a};return R.isWindows||(D.load=`${i.loadavg().map(L=>Math.round(L)).join(", ")}`),R.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(r,a){const n=[];return(0,f.listProcesses)(r.mainPID).then(async c=>(n.push(""),n.push(this.formatEnvironment(r)),n.push(""),n.push(this.formatProcessList(r,c)),r.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(r))),a.forEach(u=>{if((0,g.isRemoteDiagnosticError)(u))n.push(`
${u.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${u.hostName}`),n.push(this.formatMachineInfo(u.machineInfo)),u.processes&&n.push(this.formatProcessList(r,u.processes)),u.workspaceMetadata)for(const S of Object.keys(u.workspaceMetadata)){const D=u.workspaceMetadata[S];let L=`${D.fileCount} files`;D.maxFilesReached&&(L=`more than ${L}`),n.push(`Folder (${S}): ${L}`),n.push(this.formatWorkspaceStats(D))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(r){const a=[];let c=0;const u=(M,T)=>{const C=` ${M}(${T})`;c+C.length>60?(a.push(S),S="|                 ",c=S.length):c+=C.length,S+=C};let S="|      File types:";const D=10,L=r.fileTypes.length>D?D:r.fileTypes.length;for(let M=0;M<L;M++){const T=r.fileTypes[M];u(T.name,T.count)}if(a.push(S),r.configFiles.length>=0&&(S="|      Conf files:",c=0,r.configFiles.forEach(M=>{u(M.name,M.count)}),a.push(S)),r.launchConfigFiles.length>0){let M="|      Launch Configs:";r.launchConfigFiles.forEach(T=>{const C=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`;M+=C}),a.push(M)}return a.join(`
`)}expandGPUFeatures(r){const a=Math.max(...Object.keys(r).map(n=>n.length));return Object.keys(r).map(n=>`${n}:  ${" ".repeat(a-n.length)}  ${r[n]}`).join(`
                  `)}formatWorkspaceMetadata(r){const a=[],n=[];return r.windows.forEach(c=>{c.folderURIs.length===0||c.remoteAuthority||(a.push(`|  Window (${c.title})`),c.folderURIs.forEach(u=>{const S=b.URI.revive(u);if(S.scheme===k.Schemas.file){const D=S.fsPath;n.push(v(D,["node_modules",".git"]).then(L=>{let M=`${L.fileCount} files`;L.maxFilesReached&&(M=`more than ${M}`),a.push(`|    Folder (${(0,A.basename)(D)}): ${M}`),a.push(this.formatWorkspaceStats(L))}).catch(L=>{a.push(`|      Error: Unable to collect workspace stats for folder ${D} (${L.toString()})`)}))}else a.push(`|    Folder (${S.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(c=>a.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(r,a){const n=new Map;r.windows.forEach(u=>n.set(u.pid,`window [${u.id}] (${u.title})`)),r.pidToNames.forEach(({pid:u,name:S})=>n.set(u,S));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(r.mainPID,n,c,a,0),c.join(`
`)}formatProcessItem(r,a,n,c,u){const S=u===0;let D;S?D=c.pid===r?`${this.productService.applicationName} main`:"remote agent":a.has(c.pid)?D=a.get(c.pid):D=`${"  ".repeat(u)} ${c.name}`;const L=process.platform==="win32"?c.mem:i.totalmem()*(c.mem/100);n.push(`${c.load.toFixed(0).padStart(5," ")}	${(L/y.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(c.children)&&c.children.forEach(M=>this.formatProcessItem(r,a,n,M,u+1))}async getWorkspaceFileExtensions(r){const a=new Set;for(const{uri:n}of r.folders){const c=b.URI.revive(n);if(c.scheme!==k.Schemas.file)continue;const u=c.fsPath;try{(await v(u,["node_modules",".git"])).fileTypes.forEach(D=>a.add(D.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(r){for(const{uri:a}of r.folders){const n=b.URI.revive(a);if(n.scheme!==k.Schemas.file)continue;const c=n.fsPath;try{const u=await v(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),u.fileTypes.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:S.name,count:S.count})}),u.launchConfigFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:S.name,count:S.count})}),u.configFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:S.name,count:S.count})})}catch{}}}};e.DiagnosticsService=o,e.DiagnosticsService=o=Ie([se(0,m.ITelemetryService),se(1,h.IProductService)],o)}),define(le[256],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class i{constructor(k){this.appenders=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:R,data:b}){return this.appenders.forEach(l=>l.log(R,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=i;class s{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=s}),define(le[56],ce([0,1,35,12,71,129,24]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=d,e.isLoggingOnly=f,e.getTelemetryLevel=g,e.validateTelemetryData=y,e.cleanRemoteAuthority=m,e.isInternalTelemetry=v,e.getPiiPathsFromEnvironment=w,e.cleanData=o;class R{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class b{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class l{async publicLog(r,a,n){}async publicLogError(r,a,n){}}e.NullEndpointTelemetryService=l,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function f(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function g(t){const r=t.getValue(A.TELEMETRY_SETTING_ID),a=t.getValue(A.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return A.TelemetryLevel.NONE;switch(r??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function y(t){const r={},a={},n={};p(t,n);for(let c in n){c=c.length>150?c.substr(c.length-149):c;const u=n[c];typeof u=="number"?a[c]=u:typeof u=="boolean"?a[c]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${u.length}`),r[c]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(r[c]=u)}return{properties:r,measurements:a}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(t){if(!t)return"none";const r=(0,P.getRemoteName)(t);return h.has(r)?r:"other"}function p(t,r,a=0,n){if(t)for(const c of Object.getOwnPropertyNames(t)){const u=t[c],S=n?n+c:c;Array.isArray(u)?r[S]=(0,i.safeStringify)(u):u instanceof Date?r[S]=u.toISOString():(0,s.isObject)(u)?a<2?p(u,r,a+1,S+"."):r[S]=(0,i.safeStringify)(u):r[S]=u}}function v(t,r){const a=t.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(a)||n}function w(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function E(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const n=[];for(const D of r)for(;;){const L=D.exec(t);if(!L)break;n.push([L.index,D.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(a="";;){const D=u.exec(t);if(!D)break;const L=n.some(([M,T])=>D.index<T&&M<u.lastIndex);!c.test(D[0])&&!L&&(a+=t.substring(S,D.index)+"<REDACTED: user-file-path>",S=u.lastIndex)}return S<t.length&&(a+=t.substr(S)),a}function I(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of r)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function o(t,r){return(0,i.cloneAndChange)(t,a=>{if(a instanceof R||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let n=a.replaceAll("%20"," ");n=E(n,r);for(const c of r)n=n.replace(c,"");return n=I(n),n}})}}),define(le[130],ce([0,1,26,127,100,4,7,16,36,56]),function(K,e,i,s,P,k,A,R,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=d,e.getIdAndVersion=h,e.getExtensionId=m,e.adoptToGalleryExtensionId=p,e.getGalleryExtensionId=v,e.groupByExtension=w,e.getLocalExtensionTelemetryData=E,e.getGalleryExtensionTelemetryData=I,e.getExtensionDependencies=o,e.computeTargetPlatform=r;function d(a,n){return a.uuid&&n.uuid?a.uuid===n.uuid:a.id===n.id?!0:(0,i.compareIgnoreCase)(a.id,n.id)===0}const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const c=n.manifest?n.manifest.version:n.version,u=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,c,u)}static parse(n){const c=f.exec(n);return c&&c[1]&&c[2]?new g({id:c[1]},c[2],c[4]||void 0):null}constructor(n,c,u=P.TargetPlatform.UNDEFINED){this.identifier=n,this.version=c,this.targetPlatform=u,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?d(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=g;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(a){const n=y.exec(a);return n&&n[1]?[p(n[1]),n[2]]:[p(a),void 0]}function m(a,n){return`${a}.${n}`}function p(a){return a.toLowerCase()}function v(a,n){return p(m(a??P.UNDEFINED_PUBLISHER,n))}function w(a,n){const c=[],u=S=>{for(const D of c)if(D.some(L=>d(n(L),n(S))))return D;return null};for(const S of a){const D=u(S);D?D.push(S):c.push([S])}return c}function E(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function I(a){return{id:new l.TelemetryTrustedValue(a.identifier.id),name:new l.TelemetryTrustedValue(a.name),version:a.version,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function o(a,n){const c=[],u=n.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const S=u.shift();if(S&&c.every(D=>!d(D.identifier,{id:S}))){const D=a.filter(L=>d(L.identifier,{id:S}));D.length===1&&(c.push(D[0]),u.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function t(a,n){if(!k.isLinux)return!1;let c;try{c=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){n.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(S))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(a,n){const c=await t(a,n),u=(0,s.getTargetPlatform)(c?"alpine":k.platform,b.arch);return n.debug("ComputeTargetPlatform:",u),u}}),define(le[257],ce([0,1,2,35,4,26,191,18,54,84,28,46,24,56]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(v,w,E){this._configurationService=w,this._productService=E,this._experimentProperties={},this._disposables=new i.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=v.piiPaths||[],this._telemetryLevel=g.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(I),"gi")),I.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(I.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(I=>{(I.affectsConfiguration(g.TELEMETRY_SETTING_ID)||I.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||I.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(v,w){this._experimentProperties[v]=w}_updateTelemetryLevel(){let v=(0,y.getTelemetryLevel)(this._configurationService);const w=this._productService.enabledTelemetryLevels;if(w){this._sendErrorTelemetry=this.sendErrorTelemetry?w.error:!1;const E=w.usage?g.TelemetryLevel.USAGE:w.error?g.TelemetryLevel.ERROR:g.TelemetryLevel.NONE;v=Math.min(v,E)}this._telemetryLevel=v}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(v,w,E){this._telemetryLevel<w||(E=(0,s.mixin)(E,this._experimentProperties),E=(0,y.cleanData)(E,this._cleanupPatterns),E=(0,s.mixin)(E,this._commonProperties),this._appenders.forEach(I=>I.log(v,E)))}publicLog(v,w){this._log(v,g.TelemetryLevel.USAGE,w)}publicLog2(v,w){this.publicLog(v,w)}publicLogError(v,w){this._sendErrorTelemetry&&this._log(v,g.TelemetryLevel.ERROR,w)}publicLogError2(v,w){this.publicLogError(v,w)}};e.TelemetryService=h,e.TelemetryService=h=Ie([se(1,R.IConfigurationService),se(2,d.IProductService)],h);function m(){const p=(0,A.localize)(0,null,l.default.nameLong),v=l.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=P.isWeb?"":(0,A.localize)(3,null),E=(0,A.localize)(4,null),I=(0,A.localize)(5,null),o=(0,A.localize)(6,null),t=(0,A.localize)(7,null),r=`
|       | ${E} | ${I} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,A.localize)(8,null);return`
${p} ${v} ${w}

&nbsp;

${t}
${r}

&nbsp;

${a}
`}f.Registry.as(b.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:[g.TelemetryConfiguration.ON,g.TelemetryConfiguration.ERROR,g.TelemetryConfiguration.CRASH,g.TelemetryConfiguration.OFF],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:m(),default:g.TelemetryConfiguration.OFF,restricted:!0,scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),f.Registry.as(b.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,A.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,A.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[258],ce([0,1,4,93,24]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=k,e.resolveSqmId=A,e.resolvedevDeviceId=R;async function k(b,l){let d=b.getItem(P.machineIdKey);return(typeof d!="string"||i.isMacintosh&&d==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(d=await(0,s.getMachineId)(l.error.bind(l))),d}async function A(b,l){let d=b.getItem(P.sqmIdKey);return typeof d!="string"&&(d=await(0,s.getSqmMachineId)(l.error.bind(l))),d}async function R(b,l){let d=b.getItem(P.devDeviceIdKey);return typeof d!="string"&&(d=await(0,s.getdevDeviceId)(l.error.bind(l))),d}}),define(le[259],ce([0,1,24,258]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=P,e.resolveSqmId=k,e.resolvedevDeviceId=A;async function P(R,b){const l=await(0,s.resolveMachineId)(R,b);return R.setItem(i.machineIdKey,l),l}async function k(R,b){const l=await(0,s.resolveSqmId)(R,b);return R.setItem(i.sqmIdKey,l),l}async function A(R,b){const l=await(0,s.resolvedevDeviceId)(R,b);return R.setItem(i.devDeviceIdKey,l),l}}),define(le[131],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(s){s[s.Replace=1]="Replace",s[s.Append=2]="Append",s[s.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(le[260],ce([0,1,4,131]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const P=new Map([[s.EnvironmentVariableMutatorType.Append,"APPEND"],[s.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[s.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class k{constructor(d){this.collections=d,this.map=new Map,this.descriptionMap=new Map,d.forEach((f,g)=>{this.populateDescriptionMap(f,g);const y=f.map.entries();let h=y.next();for(;!h.done;){const m=h.value[1],p=h.value[0];let v=this.map.get(p);if(v||(v=[],this.map.set(p,v)),v.length>0&&v[0].type===s.EnvironmentVariableMutatorType.Replace){h=y.next();continue}const w={extensionIdentifier:g,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};w.scope||delete w.scope,v.unshift(w),h=y.next()}})}async applyToProcessEnvironment(d,f,g){let y;i.isWindows&&(y={},Object.keys(d).forEach(h=>y[h.toLowerCase()]=h));for(const[h,m]of this.getVariableMap(f)){const p=i.isWindows&&y[h.toLowerCase()]||h;for(const v of m){const w=g?await g(v.value):v.value;if(v.options?.applyAtProcessCreation??!0)switch(v.type){case s.EnvironmentVariableMutatorType.Append:d[p]=(d[p]||"")+w;break;case s.EnvironmentVariableMutatorType.Prepend:d[p]=w+(d[p]||"");break;case s.EnvironmentVariableMutatorType.Replace:d[p]=w;break}if(v.options?.applyAtShellIntegration??!1){const E=`VSCODE_ENV_${P.get(v.type)}`;d[E]=(d[E]?d[E]+":":"")+h+"="+this._encodeColons(w)}}}}_encodeColons(d){return d.replaceAll(":","\\x3a")}diff(d,f){const g=new Map,y=new Map,h=new Map;if(d.getVariableMap(f).forEach((m,p)=>{const v=this.getVariableMap(f).get(p),w=R(m,v);w&&g.set(p,w)}),this.getVariableMap(f).forEach((m,p)=>{const v=d.getVariableMap(f).get(p),w=R(m,v);w&&h.set(p,w)}),this.getVariableMap(f).forEach((m,p)=>{const v=d.getVariableMap(f).get(p),w=b(m,v);w&&y.set(p,w)}),!(g.size===0&&y.size===0&&h.size===0))return{added:g,changed:y,removed:h}}getVariableMap(d){const f=new Map;for(const g of this.map.values()){const y=g.filter(h=>A(h,d));y.length>0&&f.set(y[0].variable,y)}return f}getDescriptionMap(d){const f=new Map;for(const g of this.descriptionMap.values()){const y=g.filter(h=>A(h,d,!0));for(const h of y)f.set(h.extensionIdentifier,h.description)}return f}populateDescriptionMap(d,f){if(!d.descriptionMap)return;const g=d.descriptionMap.entries();let y=g.next();for(;!y.done;){const h=y.value[1],m=y.value[0];let p=this.descriptionMap.get(m);p||(p=[],this.descriptionMap.set(m,p));const v={extensionIdentifier:f,scope:h.scope,description:h.description};v.scope||delete v.scope,p.push(v),y=g.next()}}}e.MergedEnvironmentVariableCollection=k;function A(l,d,f=!1){return l.scope?!!(l.scope.workspaceFolder&&d?.workspaceFolder&&l.scope.workspaceFolder.index===d.workspaceFolder.index):f?d===l.scope:!0}function R(l,d){if(!d)return l;const f=new Set;d.forEach(y=>f.add(y.extensionIdentifier));const g=[];return l.forEach(y=>{f.has(y.extensionIdentifier)||g.push(y)}),g.length===0?void 0:g}function b(l,d){if(!d)return;const f=new Map;d.forEach(y=>f.set(y.extensionIdentifier,y));const g=[];return l.forEach(y=>{const h=f.get(y.extensionIdentifier);h&&(y.type!==h.type||y.value!==h.value||y.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index)&&g.push(h)}),g.length===0?void 0:g}}),define(le[261],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=i,e.serializeEnvironmentDescriptionMap=s,e.deserializeEnvironmentVariableCollection=P,e.deserializeEnvironmentDescriptionMap=k,e.serializeEnvironmentVariableCollections=A,e.deserializeEnvironmentVariableCollections=R;function i(b){return[...b.entries()]}function s(b){return b?[...b.entries()]:[]}function P(b){return new Map(b)}function k(b){return new Map(b??[])}function A(b){return Array.from(b.entries()).map(l=>[l[0],i(l[1].map),s(l[1].descriptionMap)])}function R(b){return new Map(b.map(l=>[l[0],{map:P(l[1]),descriptionMap:k(l[2])}]))}}),define(le[262],ce([0,1,8,23,3,2,5]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends k.Disposable{constructor(l,d){super(),this._logService=d,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new P.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=l===void 0?15e3:l,this._register((0,k.toDisposable)(()=>{for(const f of this._pendingRequestDisposables.values())(0,k.dispose)(f)}))}createRequest(l){return new Promise((d,f)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,d),this._onCreateRequest.fire({requestId:g,...l});const y=new s.CancellationTokenSource;(0,i.timeout)(this._timeout,y.token).then(()=>f(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,k.toDisposable)(()=>y.cancel())])})}acceptReply(l,d){const f=this._pendingRequests.get(l);f?(this._pendingRequests.delete(l),(0,k.dispose)(this._pendingRequestDisposables.get(l)||[]),this._pendingRequestDisposables.delete(l),f(d)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.RequestStore=R,e.RequestStore=R=Ie([se(1,A.ILogService)],R)}),define(le[72],ce([0,1,6,123,46]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new s.RawContextKey("terminalTabFocusMode",!1,!0);var k;(function(o){o.AutomationProfile="terminal.integrated.automationProfile.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(k||(e.TerminalSettingPrefix=k={}));var A;(function(o){o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationProfileLinux="terminal.integrated.automationProfile.linux",o.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",o.AutomationProfileWindows="terminal.integrated.automationProfile.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsDefaultColor="terminal.integrated.tabs.defaultColor",o.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.TabStopWidth="terminal.integrated.tabStopWidth",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorStyleInactive="terminal.integrated.cursorStyleInactive",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.TerminalTitleSeparator="terminal.integrated.tabs.separator",o.TerminalTitle="terminal.integrated.tabs.title",o.TerminalDescription="terminal.integrated.tabs.description",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.MiddleClickBehavior="terminal.integrated.middleClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.EnableVisualBell="terminal.integrated.enableVisualBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.TabFocusMode="terminal.integrated.tabFocusMode",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",o.HideOnStartup="terminal.integrated.hideOnStartup",o.CustomGlyphs="terminal.integrated.customGlyphs",o.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover",o.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",o.AutoReplies="terminal.integrated.autoReplies",o.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",o.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",o.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",o.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",o.EnableImages="terminal.integrated.enableImages",o.SmoothScrolling="terminal.integrated.smoothScrolling",o.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",o.FocusAfterRun="terminal.integrated.focusAfterRun",o.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",o.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",o.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var R;(function(o){o.PowerShell="pwsh",o.Bash="bash",o.Fish="fish",o.Sh="sh",o.Csh="csh",o.Ksh="ksh",o.Zsh="zsh",o.Python="python"})(R||(e.PosixShellType=R={}));var b;(function(o){o.CommandPrompt="cmd",o.PowerShell="pwsh",o.Wsl="wsl",o.GitBash="gitbash",o.Python="python"})(b||(e.WindowsShellType=b={}));var l;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence",o[o.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var d;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.PtyHostWindow="ptyHostWindow",o.Logger="logger",o.Heartbeat="heartbeat"})(d||(e.TerminalIpcChannels=d={}));var f;(function(o){o.Cwd="cwd",o.InitialCwd="initialCwd",o.FixedDimensions="fixedDimensions",o.Title="title",o.ShellType="shellType",o.HasChildProcesses="hasChildProcesses",o.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",o.OverrideDimensions="overrideDimensions",o.FailedShellIntegrationActivation="failedShellIntegrationActivation",o.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(f||(e.ProcessPropertyType=f={})),e.IPtyService=(0,i.createDecorator)("ptyService");var g;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(g||(e.HeartbeatConstants=g={}));var y;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(y||(e.TerminalLocation=y={}));var h;(function(o){o.TerminalView="view",o.Editor="editor"})(h||(e.TerminalLocationString=h={}));var m;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var p;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var v;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(v||(e.ProfileSource=v={}));var w;(function(o){o[o.Off=0]="Off",o[o.FinalTerm=1]="FinalTerm",o[o.VSCode=2]="VSCode"})(w||(e.ShellIntegrationStatus=w={}));var E;(function(o){o[o.Unknown=0]="Unknown",o[o.Shutdown=1]="Shutdown",o[o.Process=2]="Process",o[o.User=3]="User",o[o.Extension=4]="Extension"})(E||(e.TerminalExitReason=E={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class I{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const r=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(r))throw new Error(`A terminal backend with remote authority '${r}' was already registered.`);this._backends.set(r,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}P.Registry.add(e.TerminalExtensions.Backend,new I),e.ILocalPtyService=(0,i.createDecorator)("localPtyService"),e.ITerminalLogService=(0,i.createDecorator)("terminalLogService")}),define(le[263],ce([0,1,78,7,193,111]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=A,e.terminalProfileArgsMatch=l,e.terminalIconsEqual=d,e.isUriComponents=f;function A(g,y){const h=[{name:null,description:(0,P.localize)(0,null)}];return h.push(...g.map(m=>({name:m.profileName,description:R(m)}))),y&&h.push(...y.map(m=>({name:m.title,description:b(m)}))),{values:h.map(m=>m.name),markdownDescriptions:h.map(m=>m.description)}}function R(g){let y=`$(${k.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:i.Codicon.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?y+=`
- args: "${g.args}"`:y+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(y+=`
- overrideName: ${g.overrideName}`),g.color&&(y+=`
- color: ${g.color}`),g.env&&(y+=`
- env: ${JSON.stringify(g.env)}`),y}function b(g){return`$(${k.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:i.Codicon.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function l(g,y){if(!g&&!y)return!0;if(typeof g=="string"&&typeof y=="string")return g===y;if(Array.isArray(g)&&Array.isArray(y)){if(g.length!==y.length)return!1;for(let h=0;h<g.length;h++)if(g[h]!==y[h])return!1;return!0}return!1}function d(g,y){if(!g&&!y)return!0;if(!g||!y)return!1;if(k.ThemeIcon.isThemeIcon(g)&&k.ThemeIcon.isThemeIcon(y))return g.id===y.id&&g.color===y.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof y=="object"&&"light"in y&&"dark"in y){const h=g,m=y;if((s.URI.isUri(h.light)||f(h.light))&&(s.URI.isUri(h.dark)||f(h.dark))&&(s.URI.isUri(m.light)||f(m.light))&&(s.URI.isUri(m.dark)||f(m.dark)))return h.light.path===m.light.path&&h.dark.path===m.dark.path}if(s.URI.isUri(g)&&s.URI.isUri(y)||f(g)||f(y)){const h=g,m=y;return h.path===m.path&&h.scheme===m.scheme}return!1}function f(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}}),define(le[264],ce([0,1,78,4,192,54,46,72,263]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalIconSchema=e.terminalColorSchema=void 0,e.registerTerminalPlatformConfiguration=h,e.registerTerminalDefaultProfileConfiguration=p,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,i.getAllCodicons)(),v=>v.id),markdownEnumDescriptions:Array.from((0,i.getAllCodicons)(),v=>`$(${v.id})`)};const l={args:{description:(0,P.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(1,null),type:"boolean"},icon:{description:(0,P.localize)(2,null),...e.terminalIconSchema},color:{description:(0,P.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,P.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},d={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(5,null),type:["string","array"],items:{type:"string"}},...l}},f={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(6,null),type:["string"],items:{type:"string"}},...l}};function g(v){const w=v===s.Platform.Linux?"linux":v===s.Platform.Mac?"osx":"windows";return(0,P.localize)(7,null,(0,s.PlatformToString)(v),'```json\n"terminal.integrated.profile.'+w+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,P.localize)(8,null),type:"object",properties:{[R.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,P.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,P.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,P.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:g(s.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(12,null),enum:["PowerShell","Git Bash"]},...l}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(13,null),type:"string"},id:{description:(0,P.localize)(14,null),type:"string"},title:{description:(0,P.localize)(15,null),type:"string"},...l}},{type:"null"},d]}},[R.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:g(s.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(16,null),type:"string"},id:{description:(0,P.localize)(17,null),type:"string"},title:{description:(0,P.localize)(18,null),type:"string"},...l}},{type:"null"},d]}},[R.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:g(s.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(19,null),type:"string"},id:{description:(0,P.localize)(20,null),type:"string"},title:{description:(0,P.localize)(21,null),type:"string"},...l}},{type:"null"},d]}},[R.TerminalSettingId.UseWslProfiles]:{description:(0,P.localize)(22,null),type:"boolean",default:!0},[R.TerminalSettingId.InheritEnv]:{scope:k.ConfigurationScope.APPLICATION,description:(0,P.localize)(23,null),type:"boolean",default:!0},[R.TerminalSettingId.PersistentSessionScrollback]:{scope:k.ConfigurationScope.APPLICATION,markdownDescription:(0,P.localize)(24,null),type:"number",default:100},[R.TerminalSettingId.ShowLinkHover]:{scope:k.ConfigurationScope.APPLICATION,description:(0,P.localize)(25,null),type:"boolean",default:!0},[R.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,P.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){A.Registry.as(k.Extensions.Configuration).registerConfiguration(y),p()}let m;function p(v,w){const E=A.Registry.as(k.Extensions.Configuration);let I;v&&(I=(0,b.createProfileSchemaEnums)(v?.profiles,w));const o=m;m={id:"terminal",order:100,title:(0,P.localize)(27,null),type:"object",properties:{[R.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,P.localize)(28,null),type:["string","null"],default:null,enum:v?.os===s.OperatingSystem.Linux?I?.values:void 0,markdownEnumDescriptions:v?.os===s.OperatingSystem.Linux?I?.markdownDescriptions:void 0},[R.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,P.localize)(29,null),type:["string","null"],default:null,enum:v?.os===s.OperatingSystem.Macintosh?I?.values:void 0,markdownEnumDescriptions:v?.os===s.OperatingSystem.Macintosh?I?.markdownDescriptions:void 0},[R.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,P.localize)(30,null),type:["string","null"],default:null,enum:v?.os===s.OperatingSystem.Windows?I?.values:void 0,markdownEnumDescriptions:v?.os===s.OperatingSystem.Windows?I?.markdownDescriptions:void 0}}},E.updateConfigurations({add:[m],remove:o?[o]:[]})}}),define(le[265],ce([0,1,27,13,35,9,4,36,26,12,21,131,261,260]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=h,e.findExecutable=m,e.getShellIntegrationInjection=p;function h(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let S=0;return u&&u.length===4&&(S=parseInt(u[3])),S}async function m(u,S,D,L=R.env,M=d.Promises.exists){if(k.isAbsolute(u))return await M(u)?u:void 0;if(S===void 0&&(S=R.cwd()),k.dirname(u)!=="."){const x=k.join(S,u);return await M(x)?x:void 0}const C=(0,P.getCaseInsensitive)(L,"PATH");if(D===void 0&&(0,l.isString)(C)&&(D=C.split(k.delimiter)),D===void 0||D.length===0){const x=k.join(S,u);return await M(x)?x:void 0}for(const x of D){let U;if(k.isAbsolute(x)?U=k.join(x,u):U=k.join(S,x,u),await M(U))return U;if(A.isWindows){let z=U+".com";if(await M(z)||(z=U+".exe",await M(z)))return z}}const F=k.join(S,u);return await M(F)?F:void 0}function p(u,S,D,L,M){const T=A.isWindows&&(!S.windowsEnableConpty||h()<18309);if(!S.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||T)return;const C=u.args,F=R.platform==="win32"?k.basename(u.executable).toLowerCase():k.basename(u.executable),x=k.dirname(s.FileAccess.asFileUri("").fsPath);let U;const z={VSCODE_INJECTION:"1"};if(S.shellIntegration.nonce&&(z.VSCODE_NONCE=S.shellIntegration.nonce),A.isWindows){if(F==="pwsh.exe"||F==="powershell.exe")return!C||n(C)?U=E.get(w.WindowsPwsh):a(C)&&(U=E.get(w.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,b.format)(U[U.length-1],x,""),S.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),{newArgs:U,envMixin:z}):void 0;if(F==="bash.exe")return!C||C.length===0?U=E.get(w.Bash):c(C)&&(z.VSCODE_SHELL_LOGIN="1",v(S,z),U=E.get(w.Bash)),U?(U=[...U],U[U.length-1]=(0,b.format)(U[U.length-1],x),{newArgs:U,envMixin:z}):void 0;L.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(F){case"bash":return!C||C.length===0?U=E.get(w.Bash):c(C)&&(z.VSCODE_SHELL_LOGIN="1",v(S,z),U=E.get(w.Bash)),U?(U=[...U],U[U.length-1]=(0,b.format)(U[U.length-1],x),{newArgs:U,envMixin:z}):void 0;case"fish":{const re=D?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ie=k.join(x,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${re}:${ie}`,v(S,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!C||n(C)?U=E.get(w.Pwsh):a(C)&&(U=E.get(w.PwshLogin)),U?(S.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),U=[...U],U[U.length-1]=(0,b.format)(U[U.length-1],x,""),{newArgs:U,envMixin:z}):void 0;case"zsh":{if(!C||C.length===0?U=E.get(w.Zsh):c(C)?(U=E.get(w.ZshLogin),v(S,z)):(C===E.get(w.Zsh)||C===E.get(w.ZshLogin))&&(U=C),!U)return;U=[...U],U[U.length-1]=(0,b.format)(U[U.length-1],x);let re;try{re=i.userInfo().username}catch{re="unknown"}const ie=k.join(i.tmpdir(),`${re}-${M.applicationName}-zsh`);z.ZDOTDIR=ie;const oe=D?.ZDOTDIR??i.homedir()??"~";z.USER_ZDOTDIR=oe;const G=[];return G.push({source:k.join(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.join(ie,".zshrc")}),G.push({source:k.join(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.join(ie,".zprofile")}),G.push({source:k.join(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.join(ie,".zshenv")}),G.push({source:k.join(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.join(ie,".zlogin")}),{newArgs:U,envMixin:z,filesToCopy:G}}}L.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function v(u,S){if(A.isMacintosh&&u.environmentVariableCollections){const D=(0,g.deserializeEnvironmentVariableCollections)(u.environmentVariableCollections),M=new y.MergedEnvironmentVariableCollection(D).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),T=[];if(M)for(const C of M)C.type===f.EnvironmentVariableMutatorType.Prepend&&T.push(C.value);T.length>0&&(S.VSCODE_PATH_PREFIX=T.join(""))}}var w;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(w||(w={}));const E=new Map;E.set(w.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),E.set(w.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),E.set(w.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),E.set(w.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),E.set(w.Zsh,["-i"]),E.set(w.ZshLogin,["-il"]),E.set(w.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const I=["-login","-l"],o=["--login","-l"],t=["-i","--interactive"],r=["-nol","-nologo"];function a(u){return typeof u=="string"?I.includes(u.toLowerCase()):u.length===1&&I.includes(u[0].toLowerCase())||u.length===2&&(I.includes(u[0].toLowerCase())||I.includes(u[1].toLowerCase()))&&(r.includes(u[0].toLowerCase())||r.includes(u[1].toLowerCase()))}function n(u){return typeof u=="string"?r.includes(u.toLowerCase()):u.length===0||u?.length===1&&r.includes(u[0].toLowerCase())}function c(u){return typeof u!="string"&&(u=u.filter(S=>!t.includes(S.toLowerCase()))),u==="string"&&o.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&o.includes(u[0].toLowerCase())}}),define(le[266],ce([0,1,50,78,9,4,12,21,115,72,265,122]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=m;var g;(function(S){S.UnixShellsPath="/etc/shells"})(g||(g={}));let y,h=!0;function m(S,D,L,M,T=process.env,C,F,x,U){return C=C||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},k.isWindows?p(L,C,T,F,M.getValue(l.TerminalSettingId.UseWslProfiles)!==!1,S&&typeof S=="object"?{...S}:M.getValue(l.TerminalSettingId.ProfilesWindows),typeof D=="string"?D:M.getValue(l.TerminalSettingId.DefaultProfileWindows),U,x):n(C,F,L,S&&typeof S=="object"?{...S}:M.getValue(k.isLinux?l.TerminalSettingId.ProfilesLinux:l.TerminalSettingId.ProfilesMacOs),typeof D=="string"?D:M.getValue(k.isLinux?l.TerminalSettingId.DefaultProfileLinux:l.TerminalSettingId.DefaultProfileMacOs),U,x,T)}async function p(S,D,L,M,T,C,F,x,U){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let ie=!1;(0,d.getWindowsBuildNumber)()>=16299&&(ie=!0),await I(x);const oe=new Map;if(S){oe.set("PowerShell",{source:l.ProfileSource.Pwsh,icon:s.Codicon.terminalPowershell,isAutoDetected:!0}),oe.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:s.Codicon.terminalPowershell,isAutoDetected:!0}),oe.set("Git Bash",{source:l.ProfileSource.GitBash,isAutoDetected:!0}),oe.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:s.Codicon.terminalCmd,isAutoDetected:!0}),oe.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),oe.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:s.Codicon.terminalBash,isAutoDetected:!0});const te=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;oe.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",te],requiresPath:process.env.CMDER_ROOT?te:{path:te,isUnsafe:!0},isAutoDetected:!0})}c(C,oe);const G=await v(oe.entries(),F,D,L,M,U);if(S&&T)try{const te=await r(`${re}\\${ie?"wsl":"bash"}.exe`,F);for(const q of te)(!C||!(q.profileName in C))&&G.push(q)}catch{h&&(M?.trace("WSL is not installed, so could not detect WSL profiles"),h=!1)}return G}async function v(S,D,L,M=process.env,T,C){const F=[];for(const[x,U]of S)F.push(w(x,U,D,L,M,T,C));return(await Promise.all(F)).filter(x=>!!x)}async function w(S,D,L,M,T=process.env,C,F){if(D===null)return;let x,U,z;if("source"in D&&!("path"in D)){const G=y?.get(D.source);if(!G)return;x=G.paths,U=D.args||G.args,D.icon?z=E(D.icon):G.icon&&(z=G.icon)}else x=Array.isArray(D.path)?D.path:[D.path],U=k.isWindows||Array.isArray(D.args)?D.args:void 0,z=E(D.icon);let re;if(F){const G=x.map(q=>typeof q=="string"?q:q.path),te=await F(G);re=new Array(x.length);for(let q=0;q<x.length;q++)typeof x[q]=="string"?re[q]=te[q]:re[q]={path:te[q],isUnsafe:!0}}else re=x.slice();let ie;if(D.requiresPath){let G;if((0,A.isString)(D.requiresPath)?G=D.requiresPath:(G=D.requiresPath.path,D.requiresPath.isUnsafe&&(ie=G)),!await M.existsFile(G))return}const oe=await u(S,L,re,M,T,U,D.env,D.overrideName,D.isAutoDetected,ie);if(!oe){C?.debug("Terminal profile not validated",S,x);return}return oe.isAutoDetected=D.isAutoDetected,oe.icon=z,oe.color=D.color,oe}function E(S){return typeof S=="string"?{id:S}:S}async function I(S){if(y&&!S)return;const[D,L]=await Promise.all([o(),S||t()]);y=new Map,y.set(l.ProfileSource.GitBash,{profileName:"Git Bash",paths:D,args:["--login","-i"]}),y.set(l.ProfileSource.Pwsh,{profileName:"PowerShell",paths:L,icon:s.Codicon.terminalPowershell})}async function o(){const S=new Set,D=await(0,d.findExecutable)("git.exe");if(D){const T=(0,f.dirname)(D);S.add((0,f.resolve)(T,"../.."))}function L(T,C){C&&T.add(C)}L(S,process.env.ProgramW6432),L(S,process.env.ProgramFiles),L(S,process.env["ProgramFiles(X86)"]),L(S,`${process.env.LocalAppData}\\Program`);const M=[];for(const T of S)M.push(`${T}\\Git\\bin\\bash.exe`,`${T}\\Git\\usr\\bin\\bash.exe`,`${T}\\usr\\bin\\bash.exe`);return M.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),M.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),M}async function t(){const S=[];for await(const D of(0,b.enumeratePowerShellInstallations)())S.push(D.exePath);return S}async function r(S,D){const L=[],M=await new Promise((F,x)=>{i.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,z)=>{if(U)return x("Problem occurred when getting wsl distros");F(z)})});if(!M)return[];const T=new RegExp(/[\r?\n]/),C=M.split(T).filter(F=>F.trim().length>0&&F!=="");for(const F of C){if(F===""||F.startsWith("docker-desktop"))continue;const x=`${F} (WSL)`,U={profileName:x,path:S,args:["-d",`${F}`],isDefault:x===D,icon:a(F),isAutoDetected:!1};L.push(U)}return L}function a(S){return S.includes("Ubuntu")?s.Codicon.terminalUbuntu:S.includes("Debian")?s.Codicon.terminalDebian:s.Codicon.terminalLinux}async function n(S,D,L,M,T,C,F,x){const U=new Map;if(L&&await S.existsFile(g.UnixShellsPath)){const z=(await S.readFile(g.UnixShellsPath)).toString(),re=(C||z.split(`
`)).map(oe=>{const G=oe.indexOf("#");return G===-1?oe:oe.substring(0,G)}).filter(oe=>oe.trim().length>0),ie=new Map;for(const oe of re){let G=(0,P.basename)(oe),te=ie.get(G)||0;te++,te>1&&(G=`${G} (${te})`),ie.set(G,te),U.set(G,{path:oe,isAutoDetected:!0})}}return c(M,U),await v(U.entries(),T,S,x,D,F)}function c(S,D){if(S)for(const[L,M]of Object.entries(S))M===null||typeof M!="object"||!("path"in M)&&!("source"in M)?D.delete(L):(M.icon=M.icon||D.get(L)?.icon,D.set(L,M))}async function u(S,D,L,M,T,C,F,x,U,z){if(L.length===0)return Promise.resolve(void 0);const re=L.shift();if(re==="")return u(S,D,L,M,T,C,F,x,U);const ie=typeof re!="string"&&re.isUnsafe,oe=typeof re=="string"?re:re.path,G={profileName:S,path:oe,args:C,env:F,overrideName:x,isAutoDetected:U,isDefault:S===D,isUnsafePath:ie,requiresUnsafePath:z};if((0,P.basename)(oe)===oe){const q=T.PATH?T.PATH.split(P.delimiter):void 0,O=await(0,d.findExecutable)(oe,void 0,q,void 0,M.existsFile);return O?(G.path=O,G.isFromPath=!0,G):u(S,D,L,M,T,C)}return await M.existsFile((0,P.normalize)(oe))?G:u(S,D,L,M,T,C,F,x,U)}}),define(le[267],ce([0,1,3,2,4,45,18,5,231,101,262,72,264,266,117,77]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var p;(function(w){w[w.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let v=class extends s.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(E,I,o,t){super(),this._ptyHostStarter=E,this._configurationService=I,this._logService=o,this._loggerService=t,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new i.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new i.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new i.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new i.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new i.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new i.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new i.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new i.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new i.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new i.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new i.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new i.Emitter),this.onProcessExit=this._onProcessExit.event,(0,g.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,s.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onRequestConnection&&i.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost()),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue(f.TerminalSettingId.IgnoreProcessNames)}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(P.isWindows)return process.env;try{return await(0,l.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(E){return this._logService.error("ptyHost was unable to resolve shell environment",E),{}}}_startPtyHost(){const E=this._ptyHostStarter.start(),I=E.client;this._logService.getLevel()===R.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),k.ProxyChannel.toService(I.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(E.onDidProcessExit(r=>{this._onPtyHostExit.fire(r.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=p.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const t=k.ProxyChannel.toService(I.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onDidChangeProperty(r=>this._onDidChangeProperty.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),this._register(t.onDidRequestDetach(r=>this._onDidRequestDetach.fire(r))),this._register(new b.RemoteLoggerChannelClient(this._loggerService,I.getChannel(f.TerminalIpcChannels.Logger))),this.__connection=E,this.__proxy=t,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async r=>{r.affectsConfiguration(f.TerminalSettingId.IgnoreProcessNames)&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[E,t]}async createProcess(E,I,o,t,r,a,n,c,u,S,D){const L=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),M=await this._proxy.createProcess(E,I,o,t,r,a,n,c,u,S,D);return clearTimeout(L),M}updateTitle(E,I,o){return this._proxy.updateTitle(E,I,o)}updateIcon(E,I,o,t){return this._proxy.updateIcon(E,I,o,t)}attachToProcess(E){return this._proxy.attachToProcess(E)}detachFromProcess(E,I){return this._proxy.detachFromProcess(E,I)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(E){return this._proxy.start(E)}shutdown(E,I){return this._proxy.shutdown(E,I)}input(E,I){return this._proxy.input(E,I)}processBinary(E,I){return this._proxy.processBinary(E,I)}resize(E,I,o){return this._proxy.resize(E,I,o)}clearBuffer(E){return this._proxy.clearBuffer(E)}acknowledgeDataEvent(E,I){return this._proxy.acknowledgeDataEvent(E,I)}setUnicodeVersion(E,I){return this._proxy.setUnicodeVersion(E,I)}getInitialCwd(E){return this._proxy.getInitialCwd(E)}getCwd(E){return this._proxy.getCwd(E)}async getLatency(){const E=new m.StopWatch,I=await this._proxy.getLatency();return E.stop(),[{label:"ptyhostservice<->ptyhost",latency:E.elapsed()},...I]}orphanQuestionReply(E){return this._proxy.orphanQuestionReply(E)}installAutoReply(E,I){return this._proxy.installAutoReply(E,I)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(E){return this._proxy.uninstallAutoReply(E)}getDefaultSystemShell(E){return this._optionalProxy?.getDefaultSystemShell(E)??(0,h.getSystemShell)(E??P.OS,process.env)}async getProfiles(E,I,o,t=!1){const r=await this._resolveShellEnv();return(0,y.detectAvailableProfiles)(I,o,t,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,E))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(E,I){return this._proxy.getWslPath(E,I)}getRevivedPtyNewId(E,I){return this._proxy.getRevivedPtyNewId(E,I)}setTerminalLayoutInfo(E){return this._proxy.setTerminalLayoutInfo(E)}async getTerminalLayoutInfo(E){return this._optionalProxy?.getTerminalLayoutInfo(E)}async requestDetachInstance(E,I){return this._proxy.requestDetachInstance(E,I)}async acceptDetachInstanceReply(E,I){return this._proxy.acceptDetachInstanceReply(E,I)}async freePortKillProcess(E){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(E)}async serializeTerminalState(E){return this._proxy.serializeTerminalState(E)}async reviveTerminalProcesses(E,I,o){return this._proxy.reviveTerminalProcesses(E,I,o)}async refreshProperty(E,I){return this._proxy.refreshProperty(E,I)}async updateProperty(E,I,o){return this._proxy.updateProperty(E,I,o)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(E){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),E?f.HeartbeatConstants.ConnectingBeatInterval:f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(E,I){return this._resolveVariablesRequestStore.createRequest({workspaceId:E,originalText:I})}async acceptPtyHostResolvedVariables(E,I){this._resolveVariablesRequestStore.acceptReply(E,I)}};e.PtyHostService=v,e.PtyHostService=v=Ie([se(1,A.IConfigurationService),se(2,R.ILogService),se(3,R.ILoggerService)],v)}),define(le[73],ce([0,1,14,3,2,4,18,6,34]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const l="#FFFFFF",d="#1E1E1E",f="#000000",g="#FFFFFF",y="theme",h="themeBackground",m="windowSplash";var p;(function(w){w.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",w.SYSTEM_COLOR_THEME="window.systemColorTheme"})(p||(p={})),e.IThemeMainService=(0,R.createDecorator)("themeMainService");let v=class extends P.Disposable{constructor(E,I){super(),this.stateService=E,this.configurationService=I,this._onDidChangeColorScheme=this._register(new s.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,k.isLinux||this._register(this.configurationService.onDidChangeConfiguration(o=>{(o.affectsConfiguration(p.SYSTEM_COLOR_THEME)||o.affectsConfiguration(p.DETECT_COLOR_SCHEME))&&this.updateSystemColorTheme()})),this.updateSystemColorTheme(),this._register(s.Event.fromNodeEventEmitter(i.nativeTheme,"updated")(()=>this._onDidChangeColorScheme.fire(this.getColorScheme())))}updateSystemColorTheme(){if(k.isLinux||this.configurationService.getValue(p.DETECT_COLOR_SCHEME))i.nativeTheme.themeSource="system";else switch(this.configurationService.getValue(p.SYSTEM_COLOR_THEME)){case"dark":i.nativeTheme.themeSource="dark";break;case"light":i.nativeTheme.themeSource="light";break;case"auto":switch(this.getBaseTheme()){case"vs":i.nativeTheme.themeSource="light";break;case"vs-dark":i.nativeTheme.themeSource="dark";break;default:i.nativeTheme.themeSource="system"}break;default:i.nativeTheme.themeSource="system";break}}getColorScheme(){if(k.isWindows){if(i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(k.isMacintosh){if(i.nativeTheme.shouldUseInvertedColorScheme||i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(k.isLinux&&i.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const E=this.getColorScheme();if(E.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return E.dark?f:g;let I=this.stateService.getItem(h,null);if(!I)switch(this.getBaseTheme()){case"vs":I=l;break;case"hc-black":I=f;break;case"hc-light":I=g;break;default:I=d}return k.isMacintosh&&I.toUpperCase()===d&&(I="#171717"),I}getBaseTheme(){switch(this.stateService.getItem(y,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(E,I){this.stateService.setItems([{key:y,data:I.baseTheme},{key:h,data:I.colorInfo.background},{key:m,data:I}]),typeof E=="number"&&this.updateBackgroundColor(E,I),this.updateSystemColorTheme()}updateBackgroundColor(E,I){for(const o of i.BrowserWindow.getAllWindows())if(o.id===E){o.setBackgroundColor(I.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(m)}};e.ThemeMainService=v,e.ThemeMainService=v=Ie([se(0,b.IStateService),se(1,A.IConfigurationService)],v)}),define(le[132],ce([0,1,3,4,7,18,6,5]),function(K,e,i,s,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=d,e.extractLocalHostUriMetaDataForPortMapping=g,e.extractQueryLocalHostUriMetaDataForPortMapping=y,e.isLocalhost=h,e.isAllInterfaces=m,e.isPortPrivileged=p,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var b;(function(E){E.Http="http",E.Https="https"})(b||(e.TunnelProtocol=b={}));var l;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(l||(e.TunnelPrivacyId=l={}));function d(E){return!!E.forwardPort}var f;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function g(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const I=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(I)return{address:I[1],port:+I[2]}}function y(E){if(E.scheme!=="http"&&E.scheme!=="https"||!E.query)return;const I=E.query.split("&");for(const o of I){const t=o.split("=")[1];if(/^https?:/.exec(t)){const r=g(P.URI.parse(t));if(r)return r}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function h(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}function p(E,I,o,t){if(o===s.OperatingSystem.Windows)return!1;if(o===s.OperatingSystem.Macintosh&&m(I)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(r?.length===4&&parseInt(r[1])>=18)return!1}return E<1024}class v{constructor(I,o,t){this.remoteAddress=I,this.localAddress=o,this._dispose=t,this._onDispose=new i.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let w=class{constructor(I,o){this.logService=I,this.configurationService=o,this._onTunnelOpened=new i.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new i.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new i.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const I=this.configurationService.getValue("remote.localPortHost");return!I||I==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(I){return this._tunnelProvider=I,I?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(I){this._canElevate=I.elevation,this._privacyOptions=I.privacyOptions,this._canChangeProtocol=I.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const I=[],o=Array.from(this._tunnels.values());for(const t of o){const r=Array.from(t.values());for(const a of r){const n=await a.value;n&&typeof n!="string"&&I.push(n)}}return I}async dispose(){for(const I of this._tunnels.values()){for(const{value:o}of I.values())await o.then(t=>typeof t!="string"?t?.dispose():void 0);I.clear()}this._tunnels.clear()}setEnvironmentTunnel(I,o,t,r,a){this.addTunnelToMap(I,o,Promise.resolve({tunnelRemoteHost:I,tunnelRemotePort:o,localAddress:t,privacy:r,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(I,o){(m(I)||h(I))&&(I=e.LOCALHOST_ADDRESSES[0]);const t=this.getTunnelFromMap(I,o);if(t)return++t.refcount,t.value}openTunnel(I,o,t,r,a,n=!1,c,u){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${t} on local port ${a}.`);const S=this._tunnelProvider??I;if(!S)return;if(o||(o="localhost"),r||(r=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(t)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const D=this.retainOrCreateTunnel(S,o,t,r,a,n,c,u);return D?D.then(L=>{if(L){if(typeof L=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(o,t),L}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(o,t);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const M=this.makeTunnel(L);return(L.tunnelRemoteHost!==o||L.tunnelRemotePort!==t)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&L.privacy!==c&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(M),M}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),D)}makeTunnel(I){return{tunnelRemotePort:I.tunnelRemotePort,tunnelRemoteHost:I.tunnelRemoteHost,tunnelLocalPort:I.tunnelLocalPort,localAddress:I.localAddress,privacy:I.privacy,protocol:I.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${I.tunnelRemoteHost}:${I.tunnelRemotePort} `);const o=this._tunnels.get(I.tunnelRemoteHost);if(o){const t=o.get(I.tunnelRemotePort);t&&(t.refcount--,await this.tryDisposeTunnel(I.tunnelRemoteHost,I.tunnelRemotePort,t))}}}}async tryDisposeTunnel(I,o,t){if(t.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${I}:${o}.`);const r=t.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(I)&&this._tunnels.get(I).delete(o),r}}async closeTunnel(I,o){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${I}:${o} `);const t=this._tunnels.get(I);if(t&&t.has(o)){const r=t.get(o);r.refcount=0,await this.tryDisposeTunnel(I,o,r)}}addTunnelToMap(I,o,t){this._tunnels.has(I)||this._tunnels.set(I,new Map),this._tunnels.get(I).set(o,{refcount:1,value:t})}async removeEmptyOrErrorTunnelFromMap(I,o){const t=this._tunnels.get(I);if(t){const r=t.get(o),a=r?await r.value:void 0;(!a||typeof a=="string")&&t.delete(o),t.size===0&&this._tunnels.delete(I)}}getTunnelFromMap(I,o){const t=[I];h(I)?(t.push(...e.LOCALHOST_ADDRESSES),t.push(...e.ALL_INTERFACES_ADDRESSES)):m(I)&&t.push(...e.ALL_INTERFACES_ADDRESSES);const r=t.map(a=>this._tunnels.get(a));for(const a of r){const n=a?.get(o);if(n)return n}}canTunnel(I){return!!g(I)}createWithProvider(I,o,t,r,a,n,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${t} on local port ${r}.`);const u=t;this._factoryInProgress.add(u);const S=r===void 0?t:r,D={elevationRequired:a?this.isPortPrivileged(S):!1},L={remoteAddress:{host:o,port:t},localAddressPort:r,privacy:n,public:n?n!==l.Private:void 0,protocol:c},M=I.forwardPort(L,D);return M?(this.addTunnelToMap(o,t,M),M.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),M}};e.AbstractTunnelService=w,e.AbstractTunnelService=w=Ie([se(0,R.ILogService),se(1,k.IConfigurationService)],w)}),define(le[51],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var s;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.Disabled="disabled",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(s||(e.StateType=s={}));var P;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap",A[A.WindowsInstaller=3]="WindowsInstaller"})(P||(e.UpdateType=P={}));var k;(function(A){A[A.NotBuilt=0]="NotBuilt",A[A.DisabledByEnvironment=1]="DisabledByEnvironment",A[A.ManuallyDisabled=2]="ManuallyDisabled",A[A.MissingConfiguration=3]="MissingConfiguration",A[A.InvalidConfiguration=4]="InvalidConfiguration",A[A.RunningAsAdmin=5]="RunningAsAdmin"})(k||(e.DisablementReason=k={})),e.State={Uninitialized:{type:s.Uninitialized},Disabled:A=>({type:s.Disabled,reason:A}),Idle:(A,R)=>({type:s.Idle,updateType:A,error:R}),CheckingForUpdates:A=>({type:s.CheckingForUpdates,explicit:A}),AvailableForDownload:A=>({type:s.AvailableForDownload,update:A}),Downloading:{type:s.Downloading},Downloaded:A=>({type:s.Downloaded,update:A}),Updating:A=>({type:s.Updating,update:A}),Ready:A=>({type:s.Ready,update:A})},e.IUpdateService=(0,i.createDecorator)("updateService")}),define(le[268],ce([0,1,4,194,54,46]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),k.Registry.as(P.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,s.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:P.ConfigurationScope.APPLICATION,description:(0,s.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,s.localize)(2,null),(0,s.localize)(3,null),(0,s.localize)(4,null),(0,s.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:P.ConfigurationScope.APPLICATION,description:(0,s.localize)(6,null),deprecationMessage:(0,s.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:P.ConfigurationScope.APPLICATION,title:(0,s.localize)(8,null),description:(0,s.localize)(9,null),included:i.isWindows&&!i.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:P.ConfigurationScope.APPLICATION,description:(0,s.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(le[269],ce([0,1,3,51]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class P{constructor(R){this.service=R}listen(R,b){switch(b){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${b}`)}call(R,b,l){switch(b){case"checkForUpdates":return this.service.checkForUpdates(l);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(l)}throw new Error(`Call not found: ${b}`)}}e.UpdateChannel=P;class k{get state(){return this._state}set state(R){this._state=R,this._onStateChange.fire(R)}constructor(R){this.channel=R,this._onStateChange=new i.Emitter,this.onStateChange=this._onStateChange.event,this._state=s.State.Uninitialized,this.channel.listen("onStateChange")(b=>this.state=b),this.channel.call("_getInitialState").then(b=>this.state=b)}checkForUpdates(R){return this.channel.call("checkForUpdates",R)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(R){return this.channel.call("_applySpecificUpdate",R)}}e.UpdateChannelClient=k}),define(le[42],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,i.createDecorator)("IUriIdentityService")}),define(le[270],ce([0,1,42,211,15,19,144,3,2]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{static{this._clock=0}constructor(g){this.uri=g,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let d=class{constructor(g){this._fileService=g,this._dispooables=new b.DisposableStore,this._limit=2**16;const y=new Map,h=m=>{let p=y.get(m.scheme);return p===void 0&&(p=g.hasProvider(m)&&!this._fileService.hasCapability(m,P.FileSystemProviderCapabilities.PathCaseSensitive),y.set(m.scheme,p)),p};this._dispooables.add(R.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(m=>{y.delete(m.scheme)})),this.extUri=new k.ExtUri(h),this._canonicalUris=new A.SkipList((m,p)=>this.extUri.compare(m,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,k.normalizePath)(g));const y=this._canonicalUris.get(g);return y?y.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new l(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((h,m)=>h[1].time<m[1].time?1:h[1].time>m[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let h=0;h<y;h++)this._canonicalUris.set(g[h][0],g[h][1].touch())}};e.UriIdentityService=d,e.UriIdentityService=d=Ie([se(0,P.IFileService)],d),(0,s.registerSingleton)(i.IUriIdentityService,d,s.InstantiationType.Delayed)}),define(le[133],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,i.createDecorator)("urlService")}),define(le[271],ce([0,1,7]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class s{constructor(R){this.handler=R}listen(R,b){throw new Error(`Event not found: ${b}`)}call(R,b,l){switch(b){case"handleURL":return this.handler.handleURL(i.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${b}`)}}e.URLHandlerChannel=s;class P{constructor(R){this.channel=R}handleURL(R,b){return this.channel.call("handleURL",[R.toJSON(),b])}}e.URLHandlerChannelClient=P;class k{constructor(R,b){this.next=R,this.logService=b}async routeCall(R,b,l,d){if(b!=="handleURL")throw new Error(`Call not found: ${b}`);if(Array.isArray(l)&&l.length>0){const f=i.URI.revive(l[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",f.toString(!0)),f.query){const g=/\bwindowId=(\d+)/.exec(f.query);if(g){const y=g[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${y}"`,f.toString(!0));const h=new RegExp(`window:${y}`),m=R.connections.find(p=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),h.test(p.ctx)));if(m)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",f.toString(!0)),m;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",f.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",f.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(R,b,l,d)}routeEvent(R,b){throw new Error(`Event not found: ${b}`)}}e.URLHandlerRouter=k}),define(le[272],ce([0,1,8,2,7,28]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class A extends s.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(l,d){const f=[...this.handlers.values()];return(0,i.first)(f.map(g=>()=>g.handleURL(l,d)),void 0,!1).then(g=>g||!1)}registerHandler(l){return this.handlers.add(l),(0,s.toDisposable)(()=>this.handlers.delete(l))}}e.AbstractURLService=A;let R=class extends A{constructor(l){super(),this.productService=l}create(l){let{authority:d,path:f,query:g,fragment:y}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return d&&f&&f.indexOf("/")!==0&&(f=`/${f}`),P.URI.from({scheme:this.productService.urlProtocol,authority:d,path:f,query:g,fragment:y})}};e.NativeURLService=R,e.NativeURLService=R=Ie([se(0,k.IProductService)],R)}),define(le[273],ce([0,1,14,8,3,2,4,7]),function(K,e,i,s,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class b extends k.Disposable{constructor(d,f,g,y,h,m){if(super(),this.urlService=f,this.logService=m,this.uris=[],this.retryCount=0,d&&(m.trace("ElectronURLListener initialUrisToHandle:",d.map(w=>w.originalUrl)),this.uris=d),A.isWindows){const w=y.isBuilt?[]:[`"${y.appRoot}"`];w.push("--open-url","--"),i.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,w)}const p=P.Event.map(P.Event.fromNodeEventEmitter(i.app,"open-url",(w,E)=>({event:w,url:E})),({event:w,url:E})=>(w.preventDefault(),E));this._register(p(w=>{const E=this.uriFromRawUrl(w);E&&this.urlService.open(E,{originalUrl:w})})),g.getWindows().filter(w=>w.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(P.Event.once(g.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(d){try{return R.URI.parse(d)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const d=[];for(const f of this.uris)await this.urlService.open(f.uri,{originalUrl:f.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",f.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",f.originalUrl),d.push(f));d.length!==0&&(this.uris=d,(0,s.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=b}),define(le[274],ce([0,1,3,2,15,61,32]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends s.Disposable{constructor(l,d,f,g,y,h){super(),this.fileSystemScheme=l,this.fileSystemProvider=d,this.userDataScheme=f,this.userDataProfilesService=g,this.uriIdentityService=y,this.logService=h,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new i.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=k.TernarySearchTree.forUris(()=>!(this.capabilities&P.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new A.ResourceSet(m=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(m))),this.updateAtomicReadWritesResources(),this._register(g.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(m=>this.handleFileChanges(m)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const l of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(l.settingsResource),this.atomicReadWriteResources.add(l.keybindingsResource),this.atomicReadWriteResources.add(l.tasksResource),this.atomicReadWriteResources.add(l.extensionsResource)}open(l,d){return this.fileSystemProvider.open(this.toFileSystemResource(l),d)}close(l){return this.fileSystemProvider.close(l)}read(l,d,f,g,y){return this.fileSystemProvider.read(l,d,f,g,y)}write(l,d,f,g,y){return this.fileSystemProvider.write(l,d,f,g,y)}watch(l,d){this.watchResources.set(l,l);const f=this.fileSystemProvider.watch(this.toFileSystemResource(l),d);return(0,s.toDisposable)(()=>{this.watchResources.delete(l),f.dispose()})}stat(l){return this.fileSystemProvider.stat(this.toFileSystemResource(l))}mkdir(l){return this.fileSystemProvider.mkdir(this.toFileSystemResource(l))}rename(l,d,f){return this.fileSystemProvider.rename(this.toFileSystemResource(l),this.toFileSystemResource(d),f)}readFile(l,d){return this.fileSystemProvider.readFile(this.toFileSystemResource(l),d)}readFileStream(l,d,f){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(l),d,f)}readdir(l){return this.fileSystemProvider.readdir(this.toFileSystemResource(l))}enforceAtomicReadFile(l){return this.atomicReadWriteResources.has(l)}writeFile(l,d,f){return this.fileSystemProvider.writeFile(this.toFileSystemResource(l),d,f)}enforceAtomicWriteFile(l){return this.atomicReadWriteResources.has(l)?{postfix:".vsctmp"}:!1}delete(l,d){return this.fileSystemProvider.delete(this.toFileSystemResource(l),d)}copy(l,d,f){if((0,P.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(l),this.toFileSystemResource(d),f);throw new Error("copy not supported")}cloneFile(l,d){if((0,P.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(l),this.toFileSystemResource(d));throw new Error("clone not supported")}handleFileChanges(l){const d=[];for(const f of l){if(f.resource.scheme!==this.fileSystemScheme)continue;const g=this.toUserDataResource(f.resource);this.watchResources.findSubstr(g)&&d.push({resource:g,type:f.type,cId:f.cId})}d.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(d))}toFileSystemResource(l){return l.with({scheme:this.fileSystemScheme})}toUserDataResource(l){return l.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(le[275],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(le[276],ce([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,i.createDecorator)("webviewManagerService")}),define(le[277],ce([0,1,14,2,13,7]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class A extends s.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const b=this.handleWebviewRequest.bind(this);i.protocol.registerFileProtocol(P.Schemas.vscodeWebview,b)}handleWebviewRequest(b,l){try{const d=k.URI.parse(b.url),f=A.validWebviewFilePaths.get(d.path);if(typeof f=="string"){const g=`vs/workbench/contrib/webview/browser/pre/${f}`,y=P.FileAccess.asFileUri(g);return l({path:y.fsPath,headers:{...P.COI.getHeadersFromQuery(b.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.WebviewProtocolProvider=A}),define(le[57],ce([0,1,4]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.WindowMinimumSize=void 0,e.isOpenedAuxiliaryWindow=s,e.isWorkspaceToOpen=P,e.isFolderToOpen=k,e.isFileToOpen=A,e.getMenuBarVisibility=R,e.hasCustomTitlebar=f,e.hasNativeTitlebar=g,e.getTitleBarStyle=y,e.useWindowControlsOverlay=h,e.useNativeFullScreen=m,e.zoomLevelToZoomFactor=p,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function s(v){return typeof v.parentId=="number"}function P(v){return!!v.workspaceUri}function k(v){return!!v.folderUri}function A(v){return!!v.fileUri}function R(v){const w=g(v),E=v.getValue("window.menuBarVisibility");return E==="default"||w&&E==="compact"||i.isMacintosh&&i.isNative?"classic":E}var b;(function(v){v.TITLE_BAR_STYLE="window.titleBarStyle",v.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(b||(e.TitleBarSetting=b={}));var l;(function(v){v.NATIVE="native",v.CUSTOM="custom"})(l||(e.TitlebarStyle=l={}));var d;(function(v){v.AUTO="auto",v.WINDOWED="windowed",v.NEVER="never"})(d||(e.CustomTitleBarVisibility=d={}));function f(v,w){return!0}function g(v,w){return w||(w=y(v)),w===l.NATIVE}function y(v){if(i.isWeb)return l.CUSTOM;const w=v.getValue("window");if(w){if(i.isMacintosh&&w.nativeTabs===!0||i.isMacintosh&&w.nativeFullScreen===!1)return l.NATIVE;const o=w.titleBarStyle;if(o===l.NATIVE||o===l.CUSTOM)return o}return i.isLinux?l.NATIVE:l.CUSTOM}e.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=35;function h(v){return!(!i.isWindows||i.isWeb||g(v))}function m(v){const w=v.getValue("window");return!w||typeof w.nativeFullScreen!="boolean"||w.nativeTabs?!0:w.nativeFullScreen!==!1}function p(v=0){return Math.pow(1.2,v)}}),define(le[52],ce([0,1,14]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultAuxWindowState=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var s;(function(l){l[l.INITIAL=1]="INITIAL",l[l.LOAD=2]="LOAD",l[l.RELOAD=3]="RELOAD"})(s||(e.LoadReason=s={}));var P;(function(l){l[l.CLOSE=1]="CLOSE",l[l.QUIT=2]="QUIT",l[l.RELOAD=3]="RELOAD",l[l.LOAD=4]="LOAD"})(P||(e.UnloadReason=P={}));const k=function(l=R.Normal){return{width:1024,height:768,mode:l}};e.defaultWindowState=k;const A=function(){const f=i.screen.getPrimaryDisplay().workArea,g=Math.max(f.x+f.width/2-800/2,0),y=Math.max(f.y+f.height/2-600/2,0);return{x:g,y,width:800,height:600,mode:R.Normal}};e.defaultAuxWindowState=A;var R;(function(l){l[l.Maximized=0]="Maximized",l[l.Normal=1]="Normal",l[l.Minimized=2]="Minimized",l[l.Fullscreen=3]="Fullscreen"})(R||(e.WindowMode=R={}));var b;(function(l){l[l.UNRESPONSIVE=1]="UNRESPONSIVE",l[l.PROCESS_GONE=2]="PROCESS_GONE",l[l.LOAD=3]="LOAD"})(b||(e.WindowError=b={}))}),define(le[278],ce([0,1,8,3,2]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends P.Disposable{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:b,getActiveWindowId:l}){super(),this.disposables=this._register(new P.DisposableStore),s.Event.latch(s.Event.any(R,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,i.createCancelablePromise)(()=>l()),(async()=>{try{const f=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:f}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(le[30],ce([0,1,198,9,61,19,7,6,13]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=l,e.isEmptyWorkspaceIdentifier=d,e.toWorkspaceIdentifier=f,e.isWorkspaceIdentifier=g,e.reviveIdentifier=y,e.isWorkspace=m,e.isWorkspaceFolder=p,e.toWorkspaceFolder=E,e.isUntitledWorkspace=I,e.isTemporaryWorkspace=o,e.isStandaloneEditorWorkspace=t,e.isSavedWorkspace=r,e.hasWorkspaceFileExtension=a,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function l(n){const c=n;return typeof c?.id=="string"&&A.URI.isUri(c.uri)}function d(n){return typeof n?.id=="string"&&!l(n)&&!g(n)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function f(n,c){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,s.basename)(n)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const u=n;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function g(n){const c=n;return typeof c?.id=="string"&&A.URI.isUri(c.configPath)}function y(n){const c=n;if(c?.uri)return{id:c.id,uri:A.URI.revive(c.uri)};const u=n;if(u?.configPath)return{id:u.id,configPath:A.URI.revive(u.configPath)};if(n?.id)return{id:n.id}}var h;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function m(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function p(n){const c=n;return!!(c&&typeof c=="object"&&A.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class v{constructor(c,u,S,D,L){this._id=c,this._transient=S,this._configuration=D,this._ignorePathCasing=L,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=u}update(c){this._id=c.id,this._configuration=c.configuration,this._transient=c.transient,this._ignorePathCasing=c._ignorePathCasing,this.folders=c.folders}get folders(){return this._folders}set folders(c){this._folders=c,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(c){this._configuration=c}getFolder(c){return c&&this._foldersMap.findSubstr(c)||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const c of this.folders)this._foldersMap.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class w{constructor(c,u){this.raw=u,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,k.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=w;function E(n){return new w({uri:n,index:0,name:(0,k.basenameOrAuthority)(n)},{uri:n.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(n,c){return k.extUriBiasedIgnorePathCase.isEqualOrParent(n,c.untitledWorkspacesHome)}function o(n){let c;return A.URI.isUri(n)?c=n:c=n.configuration,c?.scheme===b.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function r(n,c){return!I(n,c)&&!o(n)}function a(n){return(typeof n=="string"?(0,s.extname)(n):(0,k.extname)(n))===e.WORKSPACE_SUFFIX}}),define(le[58],ce([0,1,14,8,47,49,2,76,4,21,172,124,6,5,28,30]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,g.createDecorator)("dialogMainService");let p=class{constructor(w,E){this.logService=w,this.productService=E,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new s.Queue}pickFileFolder(w,E){return this.doPick({...w,pickFolders:!0,pickFiles:!0,title:(0,d.localize)(0,null)},E)}pickFolder(w,E){return this.doPick({...w,pickFolders:!0,title:(0,d.localize)(1,null)},E)}pickFile(w,E){return this.doPick({...w,pickFiles:!0,title:(0,d.localize)(2,null)},E)}pickWorkspace(w,E){const I=(0,d.localize)(3,null),o=(0,k.mnemonicButtonLabel)((0,d.localize)(4,null)),t=m.WORKSPACE_FILTER;return this.doPick({...w,pickFiles:!0,title:I,filters:t,buttonLabel:o},E)}async doPick(w,E){const I={title:w.title,buttonLabel:w.buttonLabel,filters:w.filters,defaultPath:w.defaultPath};(typeof w.pickFiles=="boolean"||typeof w.pickFolders=="boolean")&&(I.properties=void 0,w.pickFiles&&w.pickFolders&&(I.properties=["multiSelections","openDirectory","openFile","createDirectory"])),I.properties||(I.properties=["multiSelections",w.pickFolders?"openDirectory":"openFile","createDirectory"]),b.isMacintosh&&I.properties.push("treatPackageAsDirectory");const o=await this.showOpenDialog(I,(E||i.BrowserWindow.getFocusedWindow())??void 0);if(o&&o.filePaths&&o.filePaths.length>0)return o.filePaths}getWindowDialogQueue(w){if(w){let E=this.windowDialogQueues.get(w.id);return E||(E=new s.Queue,this.windowDialogQueues.set(w.id,E)),E}else return this.noWindowDialogueQueue}showMessageBox(w,E){return this.getWindowDialogQueue(E).queue(async()=>{const{options:I,buttonIndeces:o}=(0,f.massageMessageBoxOptions)(w,this.productService);let t;return E?t=await i.dialog.showMessageBox(E,I):t=await i.dialog.showMessageBox(I),{response:o[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(w,E){const I=this.acquireFileDialogLock(w,E);if(!I)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.getWindowDialogQueue(E).queue(async()=>{let o;return E?o=await i.dialog.showSaveDialog(E,w):o=await i.dialog.showSaveDialog(w),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,A.dispose)(I)}}normalizePath(w){return w&&b.isMacintosh&&(w=(0,R.normalizeNFC)(w)),w}normalizePaths(w){return w.map(E=>this.normalizePath(E))}async showOpenDialog(w,E){w.defaultPath&&(await l.Promises.exists(w.defaultPath)||(w.defaultPath=void 0));const I=this.acquireFileDialogLock(w,E);if(!I)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(E).queue(async()=>{let o;return E?o=await i.dialog.showOpenDialog(E,w):o=await i.dialog.showOpenDialog(w),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,A.dispose)(I)}}acquireFileDialogLock(w,E){if(!E)return A.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",w);let I=this.windowFileDialogLocks.get(E.id);I||(I=new Set,this.windowFileDialogLocks.set(E.id,I));const o=(0,P.hash)(w);if(!I.has(o))return this.logService.trace("[DialogMainService]: new file dialog lock created",w),I.add(o),(0,A.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",w),I?.delete(o),I?.size===0&&this.windowFileDialogLocks.delete(E.id)})}};e.DialogMainService=p,e.DialogMainService=p=Ie([se(0,y.ILogService),se(1,h.IProductService)],p)}),define(le[279],ce([0,1,3,2,81,30]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class A extends s.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(b,l){super(),this.logService=b,this.storageMainService=l,this.onDidChangeApplicationStorageEmitter=this._register(new i.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(l.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(b,l){this._register(i.Event.debounce(b.onDidChangeStorage,(d,f)=>(d?d.push(f):d=[f],d),A.STORAGE_CHANGE_DEBOUNCE_TIME)(d=>{d.length&&l.fire(this.serializeStorageChangeEvents(d,b))}))}serializeStorageChangeEvents(b,l){const d=new Map,f=new Set;return b.forEach(g=>{const y=l.get(g.key);typeof y=="string"?d.set(g.key,y):f.add(g.key)}),{changed:Array.from(d.entries()),deleted:Array.from(f.values())}}listen(b,l,d){switch(l){case"onDidChangeStorage":{const f=d.profile?(0,P.revive)(d.profile):void 0;if(!f)return this.onDidChangeApplicationStorageEmitter.event;let g=this.mapProfileToOnDidChangeProfileStorageEmitter.get(f.id);return g||(g=this._register(new i.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(f),g),this.mapProfileToOnDidChangeProfileStorageEmitter.set(f.id,g)),g.event}}throw new Error(`Event not found: ${l}`)}async call(b,l,d){const f=d.profile?(0,P.revive)(d.profile):void 0,g=(0,k.reviveIdentifier)(d.workspace),y=await this.withStorageInitialized(f,g);switch(l){case"getItems":return Array.from(y.items.entries());case"updateItems":{const h=d;if(h.insert)for(const[m,p]of h.insert)y.set(m,p);h.delete?.forEach(m=>y.delete(m));break}case"optimize":return y.optimize();case"isUsed":{const h=d.payload;if(typeof h=="string")return this.storageMainService.isUsed(h)}default:throw new Error(`Call not found: ${l}`)}}async withStorageInitialized(b,l){let d;l?d=this.storageMainService.workspaceStorage(l):b?d=this.storageMainService.profileStorage(b):d=this.storageMainService.applicationStorage;try{await d.init()}catch(f){this.logService.error(`StorageIPC#init: Unable to init ${l?"workspace":b?"profile":"application"} storage due to ${f}`)}return d}}e.StorageDatabaseChannel=A}),define(le[43],ce([0,1,47,3,2,19,7,195,38,15,6,5,30,32,42,8,33,26,12]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=I,e.reviveProfile=o,e.toUserDataProfile=t;var E;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(E||(e.ProfileResourceType=E={}));function I(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&A.URI.isUri(c.location)&&A.URI.isUri(c.globalStorageHome)&&A.URI.isUri(c.settingsResource)&&A.URI.isUri(c.keybindingsResource)&&A.URI.isUri(c.tasksResource)&&A.URI.isUri(c.snippetsHome)&&A.URI.isUri(c.extensionsResource))}e.IUserDataProfilesService=(0,d.createDecorator)("IUserDataProfilesService");function o(n,c){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:A.URI.revive(n.location).with({scheme:c}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:c}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:c}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:c}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:c}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:c}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:c}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:c}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function t(n,c,u,S,D,L){return{id:n,name:c,location:u,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:L&&D?.useDefaultFlags?.globalState?L.globalStorageHome:(0,k.joinPath)(u,"globalStorage"),settingsResource:L&&D?.useDefaultFlags?.settings?L.settingsResource:(0,k.joinPath)(u,"settings.json"),keybindingsResource:L&&D?.useDefaultFlags?.keybindings?L.keybindingsResource:(0,k.joinPath)(u,"keybindings.json"),tasksResource:L&&D?.useDefaultFlags?.tasks?L.tasksResource:(0,k.joinPath)(u,"tasks.json"),snippetsHome:L&&D?.useDefaultFlags?.snippets?L.snippetsHome:(0,k.joinPath)(u,"snippets"),extensionsResource:L&&D?.useDefaultFlags?.extensions?L.extensionsResource:(0,k.joinPath)(u,"extensions.json"),cacheHome:(0,k.joinPath)(S,n),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let r=class extends P.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(c,u,S,D){super(),this.environmentService=c,this.fileService=u,this.uriIdentityService=S,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new s.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new s.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new s.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new s.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new y.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,k.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(c){this.enabled!==c&&(this._profilesObject=void 0,this.enabled=c)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const c=this.createDefaultProfile(),u=[c];if(this.enabled)try{for(const L of this.getStoredProfiles()){if(!L.name||!(0,w.isString)(L.name)||!L.location){this.logService.warn("Skipping the invalid stored profile",L.location||L.name);continue}u.push(t((0,k.basename)(L.location),L.name,L.location,this.profilesCacheHome,{shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags},c))}}catch(L){this.logService.error(L)}const S=new y.ResourceMap,D=new Map;if(u.length)try{const L=this.getStoredProfileAssociations();if(L.workspaces)for(const[M,T]of Object.entries(L.workspaces)){const C=A.URI.parse(M),F=u.find(x=>x.id===T);F&&S.set(C,F)}if(L.emptyWindows)for(const[M,T]of Object.entries(L.emptyWindows)){const C=u.find(F=>F.id===T);C&&D.set(M,C)}}catch(L){this.logService.error(L)}this._profilesObject={profiles:u,workspaces:S,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const c=t("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...c,extensionsResource:this.getDefaultProfileExtensionsLocation()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const u="Temp",S=new RegExp(`${(0,v.escapeRegExpCharacters)(u)}\\s(\\d+)`);let D=0;for(const M of this.profiles){const T=S.exec(M.name),C=T?parseInt(T[1]):0;D=C>D?C:D}const L=`${u} ${D+1}`;return this.createProfile((0,i.hash)((0,p.generateUuid)()).toString(16),L,{transient:!0},c)}async createNamedProfile(c,u,S){return this.createProfile((0,i.hash)((0,p.generateUuid)()).toString(16),c,u,S)}async createProfile(c,u,S,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const L=await this.doCreateProfile(c,u,S);return D&&await this.setProfileForWorkspace(D,L),L}async doCreateProfile(c,u,S){if(!(0,w.isString)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(u);return D||(D=(async()=>{try{if(this.profiles.find(C=>C.name===u||C.id===c))throw new Error(`Profile with ${u} name already exists`);const M=t(c,u,(0,k.joinPath)(this.profilesHome,c),this.profilesCacheHome,S,this.defaultProfile);await this.fileService.createFolder(M.location);const T=[];return this._onWillCreateProfile.fire({profile:M,join(C){T.push(C)}}),await m.Promises.settled(T),this.updateProfiles([M],[],[]),M}finally{this.profileCreationPromises.delete(u)}})(),this.profileCreationPromises.set(u,D)),D}async updateProfile(c,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(D=>D.id===c.id);if(!S)throw new Error(`Profile '${c.name}' does not exist`);return S=t(S.id,u.name??S.name,S.location,this.profilesCacheHome,{shortName:u.shortName??S.shortName,icon:u.icon===null?void 0:u.icon??S.icon,transient:u.transient??S.isTransient,useDefaultFlags:u.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[S]),S}async removeProfile(c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(D=>D.id===c.id);if(!u)throw new Error(`Profile '${c.name}' does not exist`);const S=[];this._onWillRemoveProfile.fire({profile:u,join(D){S.push(D)}});try{await Promise.allSettled(S)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])u.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])u.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[u],[]);try{await this.fileService.del(u.cacheHome,{recursive:!0})}catch(D){(0,l.toFileOperationResult)(D)!==l.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(D)}}async setProfileForWorkspace(c,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(D=>D.id===u.id);if(!S)throw new Error(`Profile '${u.name}' does not exist`);this.updateWorkspaceAssociation(c,S)}unsetWorkspace(c,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(c,void 0,u)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const c=await this.fileService.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(u=>u.isDirectory&&this.profiles.every(S=>!this.uriIdentityService.extUri.isEqual(S.location,u.resource))).map(u=>this.fileService.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const c=this.transientProfilesObject.profiles.filter(u=>!this.isProfileAssociatedToWorkspace(u));await Promise.allSettled(c.map(u=>this.removeProfile(u)))}getProfileForWorkspace(c){const u=this.getWorkspace(c);return A.URI.isUri(u)?this.transientProfilesObject.workspaces.get(u)??this.profilesObject.workspaces.get(u):this.transientProfilesObject.emptyWindows.get(u)??this.profilesObject.emptyWindows.get(u)}getWorkspace(c){return(0,g.isSingleFolderWorkspaceIdentifier)(c)?c.uri:(0,g.isWorkspaceIdentifier)(c)?c.configPath:c.id}isProfileAssociatedToWorkspace(c){return!!([...this.transientProfilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,c.location))||[...this.transientProfilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,c.location))||[...this.profilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,c.location))||[...this.profilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,c.location)))}updateProfiles(c,u,S){const D=[...this.profiles,...c],L=[];this.transientProfilesObject.profiles=[];for(let M of D)M.isDefault||u.some(T=>M.id===T.id)||(M=S.find(T=>M.id===T.id)??M,M.isTransient?this.transientProfilesObject.profiles.push(M):L.push({location:M.location,name:M.name,shortName:M.shortName,icon:M.icon,useDefaultFlags:M.useDefaultFlags}));this.saveStoredProfiles(L),this._profilesObject=void 0,this.triggerProfilesChanges(c,u,S)}triggerProfilesChanges(c,u,S){this._onDidChangeProfiles.fire({added:c,removed:u,updated:S,all:this.profiles})}updateWorkspaceAssociation(c,u,S){S=u?.isTransient?!0:S,S||this.updateWorkspaceAssociation(c,void 0,!0);const D=this.getWorkspace(c),L=S?this.transientProfilesObject:this.profilesObject;A.URI.isUri(D)?(L.workspaces.delete(D),u&&L.workspaces.set(D,u)):(L.emptyWindows.delete(D),u&&L.emptyWindows.set(D,u)),S||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const c={};for(const[S,D]of this.profilesObject.workspaces.entries())c[S.toString()]=D.id;const u={};for(const[S,D]of this.profilesObject.emptyWindows.entries())u[S.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:c,emptyWindows:u}),this._profilesObject=void 0}migrateStoredProfileAssociations(c){const u={},S=this.createDefaultProfile();if(c.workspaces)for(const[L,M]of Object.entries(c.workspaces)){const T=A.URI.parse(M);u[L]=this.uriIdentityService.extUri.isEqual(T,S.location)?S.id:this.uriIdentityService.extUri.basename(T)}const D={};if(c.emptyWindows)for(const[L,M]of Object.entries(c.emptyWindows)){const T=A.URI.parse(M);D[L]=this.uriIdentityService.extUri.isEqual(T,S.location)?S.id:this.uriIdentityService.extUri.basename(T)}return{workspaces:u,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(c){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(c){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=r,e.UserDataProfilesService=r=Ie([se(0,b.IEnvironmentService),se(1,l.IFileService),se(2,h.IUriIdentityService),se(3,f.ILogService)],r);class a extends r{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(c){this.storedProfiles=c}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(c){this.storedProfileAssociations=c}}e.InMemoryUserDataProfilesService=a}),define(le[86],ce([0,1,8,17,2,3,32,7,127,130,15,6,5,43,42,12,16,24]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class E extends Error{constructor(a,n){super(a),this.code=n}}e.ExtensionsProfileScanningError=E,e.IExtensionsProfileScannerService=(0,f.createDecorator)("IExtensionsProfileScannerService");let I=class extends P.Disposable{constructor(a,n,c,u,S,D){super(),this.extensionsLocation=a,this.fileService=n,this.userDataProfilesService=c,this.uriIdentityService=u,this.telemetryService=S,this.logService=D,this._onAddExtensions=this._register(new k.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new k.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new k.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new k.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new A.ResourceMap}scanProfileExtensions(a,n){return this.withProfileExtensions(a,void 0,n)}async addExtensionsToProfile(a,n,c){const u=[],S=[];try{return await this.withProfileExtensions(n,D=>{const L=[];if(c)L.push(...D);else for(const M of D)a.some(([T])=>(0,l.areSameExtensions)(T.identifier,M.identifier)&&T.manifest.version!==M.version)?u.push(M):L.push(M);for(const[M,T]of a){const C=L.findIndex(x=>(0,l.areSameExtensions)(x.identifier,M.identifier)&&x.version===M.manifest.version),F={identifier:M.identifier,version:M.manifest.version,location:M.location,metadata:T};C===-1?(S.push(F),L.push(F)):L.splice(C,1,F)}return S.length&&this._onAddExtensions.fire({extensions:S,profileLocation:n}),u.length&&this._onRemoveExtensions.fire({extensions:u,profileLocation:n}),L}),S.length&&this._onDidAddExtensions.fire({extensions:S,profileLocation:n}),u.length&&this._onDidRemoveExtensions.fire({extensions:u,profileLocation:n}),S}catch(D){throw S.length&&this._onDidAddExtensions.fire({extensions:S,error:D,profileLocation:n}),u.length&&this._onDidRemoveExtensions.fire({extensions:u,error:D,profileLocation:n}),D}}async updateMetadata(a,n){const c=[];return await this.withProfileExtensions(n,u=>{const S=[];for(const D of u){const L=a.find(([M])=>(0,l.areSameExtensions)(M.identifier,D.identifier)&&M.manifest.version===D.version);L&&(D.metadata={...D.metadata,...L[1]},c.push(D)),S.push(D)}return S}),c}async removeExtensionFromProfile(a,n){const c=[];try{await this.withProfileExtensions(n,u=>{const S=[];for(const D of u)(0,l.areSameExtensions)(D.identifier,a.identifier)?c.push(D):S.push(D);return c.length&&this._onRemoveExtensions.fire({extensions:c,profileLocation:n}),S}),c.length&&this._onDidRemoveExtensions.fire({extensions:c,profileLocation:n})}catch(u){throw c.length&&this._onDidRemoveExtensions.fire({extensions:c,error:u,profileLocation:n}),u}}async withProfileExtensions(a,n,c){return this.getResourceAccessQueue(a).queue(async()=>{let u=[],S;try{const D=await this.fileService.readFile(a);S=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,d.toFileOperationResult)(D)!==d.FileOperationResult.FILE_NOT_FOUND)throw D;if(this.uriIdentityService.extUri.isEqual(a,this.userDataProfilesService.defaultProfile.extensionsResource)&&(S=await this.migrateFromOldDefaultProfileExtensionsLocation()),!S&&c?.bailOutWhenFileNotFound)throw new E((0,p.getErrorMessage)(D),w.ERROR_PROFILE_NOT_FOUND)}if(S){Array.isArray(S)||this.reportAndThrowInvalidConentError(a);let D=!1;for(const L of S){o(L)||this.reportAndThrowInvalidConentError(a);let M;if((0,m.isString)(L.relativeLocation)&&L.relativeLocation)M=this.resolveExtensionLocation(L.relativeLocation);else if((0,m.isString)(L.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${L.location}`);continue}else{M=R.URI.revive(L.location);const T=this.toRelativePath(M);T&&(D=!0,L.relativeLocation=T)}(0,m.isUndefined)(L.metadata?.hasPreReleaseVersion)&&L.metadata?.preRelease&&(D=!0,L.metadata.hasPreReleaseVersion=!0),u.push({identifier:L.identifier,location:M,version:L.version,metadata:L.metadata})}D&&await this.fileService.writeFile(a,s.VSBuffer.fromString(JSON.stringify(S)))}if(n){u=n(u);const D=u.map(L=>({identifier:L.identifier,version:L.version,location:L.location.toJSON(),relativeLocation:this.toRelativePath(L.location),metadata:L.metadata}));await this.fileService.writeFile(a,s.VSBuffer.fromString(JSON.stringify(D)))}return u})}reportAndThrowInvalidConentError(a){const n=new E(`Invalid extensions content in ${a.toString()}`,w.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(a){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(a),this.extensionsLocation)?this.uriIdentityService.extUri.basename(a):void 0}resolveExtensionLocation(a){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,a)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const a=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let c;try{c=(await this.fileService.readFile(a)).value.toString()}catch(S){if((0,d.toFileOperationResult)(S)===d.FileOperationResult.FILE_NOT_FOUND)return;throw S}this.logService.info("Migrating extensions from old default profile location",a.toString());let u;try{const S=JSON.parse(c);Array.isArray(S)&&S.every(D=>o(D))?u=S:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.logService.error(S)}if(u)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,s.VSBuffer.fromString(JSON.stringify(u)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",a.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(S){if((0,d.toFileOperationResult)(S)===d.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",a.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw S}try{await this.fileService.del(a)}catch(S){(0,d.toFileOperationResult)(S)!==d.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(S)}try{await this.fileService.del(n)}catch(S){(0,d.toFileOperationResult)(S)!==d.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(S)}return u})()),this._migrationPromise}getResourceAccessQueue(a){let n=this.resourcesAccessQueueMap.get(a);return n||(n=new i.Queue,this.resourcesAccessQueueMap.set(a,n)),n}};e.AbstractExtensionsProfileScannerService=I,e.AbstractExtensionsProfileScannerService=I=Ie([se(1,d.IFileService),se(2,y.IUserDataProfilesService),se(3,h.IUriIdentityService),se(4,v.ITelemetryService),se(5,g.ILogService)],I);function o(r){return(0,m.isObject)(r)&&(0,b.isIExtensionIdentifier)(r.identifier)&&(t(r.location)||(0,m.isString)(r.location)&&r.location)&&((0,m.isUndefined)(r.relativeLocation)||(0,m.isString)(r.relativeLocation))&&r.version&&(0,m.isString)(r.version)}function t(r){return r?(0,m.isString)(r.path)&&(0,m.isString)(r.scheme):!1}}),define(le[134],ce([0,1,22,8,35,17,16,40,157,2,13,9,4,19,210,79,12,7,177,38,130,100,209,15,6,5,28,3,81,86,43,42,208]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I,o,t,r,a,n,c,u,S,D,L,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=re;var C;(function(oe){function G(te,q){if(te===q)return!0;const O=Object.keys(te),B=new Set;for(const V of Object.keys(q))B.add(V);if(O.length!==B.size)return!1;for(const V of O){if(te[V]!==q[V])return!1;B.delete(V)}return B.size===0}oe.equals=G})(C||(e.Translations=C={})),e.IExtensionsScannerService=(0,a.createDecorator)("IExtensionsScannerService");let F=class extends l.Disposable{constructor(G,te,q,O,B,V,ae,j,he,ne,J,_){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=te,this.extensionsControlLocation=q,this.currentProfile=O,this.userDataProfilesService=B,this.extensionsProfileScannerService=V,this.fileService=ae,this.logService=j,this.environmentService=he,this.productService=ne,this.uriIdentityService=J,this.instantiationService=_,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(U,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(o.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(o.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,I.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,te,q){const[O,B]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(te)]),V=q?await this.scanExtensionsUnderDevelopment(G,[...O,...B]):[];return this.dedupExtensions(O,B,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const te=[];te.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),te.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[q,O]=await Promise.all(te);return this.applyScanOptions([...q,...O],o.ExtensionType.System,G,!1)}async scanUserExtensions(G){const te=G.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",te);const q=this.uriIdentityService.extUri.isEqual(G.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,O=await this.createExtensionScannerInput(te,!!G.profileLocation,o.ExtensionType.User,!G.includeUninstalled,G.language,!0,q,G.productVersion??this.getProductVersion()),B=G.useCache&&!O.devMode&&O.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let V;try{V=await B.scanExtensions(O)}catch(ae){if(ae instanceof D.ExtensionsProfileScanningError&&ae.code===D.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),V=await B.scanExtensions(O);else throw ae}return V=await this.applyScanOptions(V,o.ExtensionType.User,G,!0),this.logService.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(G,te){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const q=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(O=>O.scheme===d.Schemas.file).map(async O=>{const B=await this.createExtensionScannerInput(O,!1,o.ExtensionType.User,!0,G.language,!1,void 0,G.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(B)).map(ae=>(ae.type=te.find(j=>(0,I.areSameExtensions)(j.identifier,ae.identifier))?.type??ae.type,this.extensionsScanner.validate(ae,B)))}))).flat();return this.applyScanOptions(q,"development",G,!0)}return[]}async scanExistingExtension(G,te,q){const O=await this.createExtensionScannerInput(G,!1,te,!0,q.language,!0,void 0,q.productVersion??this.getProductVersion()),B=await this.extensionsScanner.scanExtension(O);return!B||!q.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(G,te,q){const O=await this.createExtensionScannerInput(G,!1,te,!0,q.language,!0,void 0,q.productVersion??this.getProductVersion()),B=await this.extensionsScanner.scanOneOrMultipleExtensions(O);return this.applyScanOptions(B,te,q,!0)}async scanMultipleExtensions(G,te,q){const O=[];return await Promise.all(G.map(async B=>{const V=await this.scanOneOrMultipleExtensions(B,te,q);O.push(...V)})),this.applyScanOptions(O,te,q,!0)}async scanMetadata(G){const te=(0,y.joinPath)(G,"package.json"),q=(await this.fileService.readFile(te)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(G,te){const q=(0,y.joinPath)(G,"package.json"),O=(await this.fileService.readFile(q)).value.toString(),B=JSON.parse(O);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,B.__metadata={...B.__metadata,...te},await this.fileService.writeFile((0,y.joinPath)(G,"package.json"),k.VSBuffer.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof D.ExtensionsProfileScanningError&&G.code===D.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw G}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.extensionsProfileScannerService.addExtensionsToProfile(G.map(te=>[te,te.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,k.VSBuffer.fromString(JSON.stringify([])))}catch(te){(0,r.toFileOperationResult)(te)!==r.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)(te))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.logService.error(G)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(G,te,q,O){return q.includeAllVersions||(G=this.dedupExtensions(te===o.ExtensionType.System?G:void 0,te===o.ExtensionType.User?G:void 0,te==="development"?G:void 0,await this.getTargetPlatform(),O)),q.includeInvalid||(G=G.filter(B=>B.isValid)),G.sort((B,V)=>{const ae=f.basename(B.location.fsPath),j=f.basename(V.location.fsPath);return ae<j?-1:ae>j?1:0})}dedupExtensions(G,te,q,O,B){const V=(j,he,ne)=>{if(j.isValid&&!he.isValid)return!1;if(j.isValid===he.isValid){if(B&&h.gt(j.manifest.version,he.manifest.version))return this.logService.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${j.location.path} with version ${j.manifest.version}`),!1;if(h.eq(j.manifest.version,he.manifest.version)){if(j.type===o.ExtensionType.System)return this.logService.debug(`Skipping extension ${he.location.path} in favour of system extension ${j.location.path} with same version`),!1;if(j.targetPlatform===O)return this.logService.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return ne?this.logService.warn(`Overwriting user extension ${j.location.path} with ${he.location.path}.`):this.logService.debug(`Overwriting user extension ${j.location.path} with ${he.location.path}.`),!0},ae=new o.ExtensionIdentifierMap;return G?.forEach(j=>{const he=ae.get(j.identifier.id);(!he||V(he,j,!1))&&ae.set(j.identifier.id,j)}),te?.forEach(j=>{const he=ae.get(j.identifier.id);if(!he&&G&&j.type===o.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${j.location.path}.`);return}(!he||V(he,j,!1))&&ae.set(j.identifier.id,j)}),q?.forEach(j=>{const he=ae.get(j.identifier.id);(!he||V(he,j,!0))&&ae.set(j.identifier.id,j),ae.set(j.identifier.id,j)}),[...ae.values()]}async scanDefaultSystemExtensions(G,te){this.logService.trace("Started scanning system extensions");const q=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,o.ExtensionType.System,!0,te,!0,void 0,this.getProductVersion()),B=await(G&&!q.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(q);return this.logService.trace("Scanned system extensions:",B.length),B}async scanDevSystemExtensions(G,te){const q=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!q?.length)return[];this.logService.trace("Started scanning dev system extensions");const O=te?await this.getBuiltInExtensionControl():{},B=[],V=v.URI.file(f.normalize(f.join(d.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const j of q){const he=O[j.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":B.push((0,y.joinPath)(V,j.name));break;default:B.push(v.URI.file(he));break}}const ae=await Promise.all(B.map(async j=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(j,!1,o.ExtensionType.System,!0,G,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",ae.length),(0,i.coalesce)(ae)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,te,q,O,B,V,ae,j){const he=await this.getTranslations(B??g.language),ne=await this.getMtime(G),J=te&&!this.uriIdentityService.extUri.isEqual(G,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,_=J?await this.getMtime(J):void 0;return new x(G,ne,J,_,te,ae,q,O,V,j.version,j.date,this.productService.commit,!this.environmentService.isBuilt,B,he)}async getMtime(G){try{const te=await this.fileService.stat(G);if(typeof te.mtime=="number")return te.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=F,e.AbstractExtensionsScannerService=F=Ie([se(4,L.IUserDataProfilesService),se(5,D.IExtensionsProfileScannerService),se(6,r.IFileService),se(7,n.ILogService),se(8,E.IEnvironmentService),se(9,c.IProductService),se(10,M.IUriIdentityService),se(11,a.IInstantiationService)],F);class x{constructor(G,te,q,O,B,V,ae,j,he,ne,J,_,W,N,H){this.location=G,this.mtime=te,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=O,this.profile=B,this.profileScanOptions=V,this.type=ae,this.excludeObsolete=j,this.validate=he,this.productVersion=ne,this.productDate=J,this.productCommit=_,this.devMode=W,this.language=N,this.translations=H}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,te){return(0,y.isEqual)(G.location,te.location)&&G.mtime===te.mtime&&(0,y.isEqual)(G.applicationExtensionslocation,te.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&G.profile===te.profile&&P.equals(G.profileScanOptions,te.profileScanOptions)&&G.type===te.type&&G.excludeObsolete===te.excludeObsolete&&G.validate===te.validate&&G.productVersion===te.productVersion&&G.productDate===te.productDate&&G.productCommit===te.productCommit&&G.devMode===te.devMode&&G.language===te.language&&C.equals(G.translations,te.translations)}}e.ExtensionScannerInput=x;let U=class extends l.Disposable{constructor(G,te,q,O,B){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=te,this.uriIdentityService=q,this.fileService=O,this.logService=B}async scanExtensions(G){const te=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let q={};if(G.excludeObsolete&&G.type===o.ExtensionType.User)try{const O=(await this.fileService.readFile(this.obsoleteFile)).value.toString();q=JSON.parse(O)}catch{}return(0,p.isEmptyObject)(q)?te:te.filter(O=>!q[I.ExtensionKey.create(O).toString()])}async scanExtensionsFromLocation(G){const te=await this.fileService.resolve(G.location);if(!te.children?.length)return[];const q=await Promise.all(te.children.map(async O=>{if(!O.isDirectory||G.type===o.ExtensionType.User&&(0,y.basename)(O.resource).indexOf(".")===0)return null;const B=new x(O.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(B)}));return(0,i.coalesce)(q).sort((O,B)=>O.location.path<B.location.path?-1:1)}async scanExtensionsFromProfile(G){let te=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){te=te.filter(O=>!O.metadata?.isApplicationScoped);const q=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,O=>!!O.metadata?.isBuiltin||!!O.metadata?.isApplicationScoped,G);te.push(...q)}return te}async scanExtensionsFromProfileResource(G,te,q){const O=await this.extensionsProfileScannerService.scanProfileExtensions(G,q.profileScanOptions);if(!O.length)return[];const B=await Promise.all(O.map(async V=>{if(te(V)){const ae=new x(V.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(ae,V.metadata)}return null}));return(0,i.coalesce)(B)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,y.joinPath)(G.location,"package.json"))){const te=await this.scanExtension(G);return te?[te]:[]}else return await this.scanExtensions(G)}catch(te){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,A.getErrorMessage)(te)),[]}}async scanExtension(G,te){try{let q=await this.scanExtensionManifest(G.location);if(q){q.publisher||(q.publisher=o.UNDEFINED_PUBLISHER),te=te??q.__metadata,delete q.__metadata;const O=(0,I.getGalleryExtensionId)(q.publisher,q.name),B=te?.id?{id:O,uuid:te.id}:{id:O},V=te?.isSystem?o.ExtensionType.System:G.type,ae=V===o.ExtensionType.System||!!te?.isBuiltin;q=await this.translateManifest(G.location,q,x.createNlsConfiguration(G));const j={type:V,identifier:B,manifest:q,location:G.location,isBuiltin:ae,targetPlatform:te?.targetPlatform??o.TargetPlatform.UNDEFINED,publisherDisplayName:te?.publisherDisplayName,metadata:te,isValid:!0,validations:[]};return G.validate?this.validate(j,G):j}}catch(q){G.type!==o.ExtensionType.System&&this.logService.error(q)}return null}validate(G,te){let q=!0;const O=(0,t.validateExtensionManifest)(te.productVersion,te.productDate,te.location,G.manifest,G.isBuiltin);for(const[B,V]of O)B===m.default.Error&&(q=!1,this.logService.error(this.formatMessage(te.location,V)));return G.isValid=q,G.validations=O,G}async scanExtensionManifest(G){const te=(0,y.joinPath)(G,"package.json");let q;try{q=(await this.fileService.readFile(te)).value.toString()}catch(B){return(0,r.toFileOperationResult)(B)!==r.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(G,(0,w.localize)(0,null,te.path,B.message))),null}let O;try{O=JSON.parse(q)}catch{const V=[];(0,R.parse)(q,V);for(const ae of V)this.logService.error(this.formatMessage(G,(0,w.localize)(1,null,te.path,ae.offset,ae.length,(0,b.getParseErrorMessage)(ae.error))));return null}return(0,R.getNodeType)(O)!=="object"?(this.logService.error(this.formatMessage(G,(0,w.localize)(2,null,te.path))),null):O}async translateManifest(G,te,q){const O=await this.getLocalizedMessages(G,te,q);if(O)try{const B=[],V=await this.resolveOriginalMessageBundle(O.default,B);if(B.length>0)return B.forEach(j=>{this.logService.error(this.formatMessage(G,(0,w.localize)(3,null,O.default?.path,(0,b.getParseErrorMessage)(j.error))))}),te;if((0,R.getNodeType)(O)!=="object")return this.logService.error(this.formatMessage(G,(0,w.localize)(4,null,O.default?.path))),te;const ae=O.values||Object.create(null);return(0,T.localizeManifest)(this.logService,te,ae,V)}catch{}return te}async getLocalizedMessages(G,te,q){const O=(0,y.joinPath)(G,"package.nls.json"),B=(he,ne)=>{ne.forEach(J=>{this.logService.error(this.formatMessage(G,(0,w.localize)(5,null,he?.path,(0,b.getParseErrorMessage)(J.error))))})},V=he=>{this.logService.error(this.formatMessage(G,(0,w.localize)(6,null,he?.path)))},ae=`${te.publisher}.${te.name}`,j=q.translations[ae];if(j)try{const he=v.URI.file(j),ne=(await this.fileService.readFile(he)).value.toString(),J=[],_=(0,R.parse)(ne,J);return J.length>0?(B(he,J),{values:void 0,default:O}):(0,R.getNodeType)(_)!=="object"?(V(he),{values:void 0,default:O}):{values:_.contents?_.contents.package:void 0,default:O}}catch{return{values:void 0,default:O}}else{if(!await this.fileService.exists(O))return;let ne;try{ne=await this.findMessageBundles(G,q)}catch{return}if(!ne.localized)return{values:void 0,default:ne.original};try{const J=(await this.fileService.readFile(ne.localized)).value.toString(),_=[],W=(0,R.parse)(J,_);return _.length>0?(B(ne.localized,_),{values:void 0,default:ne.original}):(0,R.getNodeType)(W)!=="object"?(V(ne.localized),{values:void 0,default:ne.original}):{values:W,default:ne.original}}catch{return{values:void 0,default:ne.original}}}}async resolveOriginalMessageBundle(G,te){if(G)try{const q=(await this.fileService.readFile(G)).value.toString();return(0,R.parse)(q,te)}catch{}}findMessageBundles(G,te){return new Promise((q,O)=>{const B=V=>{const ae=(0,y.joinPath)(G,`package.nls.${V}.json`);this.fileService.exists(ae).then(j=>{j&&q({localized:ae,original:(0,y.joinPath)(G,"package.nls.json")});const he=V.lastIndexOf("-");he===-1?q({localized:(0,y.joinPath)(G,"package.nls.json"),original:null}):(V=V.substring(0,he),B(V))})};if(te.devMode||te.pseudo||!te.language)return q({localized:(0,y.joinPath)(G,"package.nls.json"),original:null});B(te.language)})}formatMessage(G,te){return`[${G.path}]: ${te}`}};U=Ie([se(1,D.IExtensionsProfileScannerService),se(2,M.IUriIdentityService),se(3,r.IFileService),se(4,n.ILogService)],U);let z=class extends U{constructor(G,te,q,O,B,V,ae){super(te,O,B,V,ae),this.currentProfile=G,this.userDataProfilesService=q,this.cacheValidatorThrottler=this._register(new s.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const te=this.getCacheFile(G),q=await this.readExtensionCache(te);if(this.input=G,q&&q.input&&x.equals(q.input,this.input))return this.logService.debug("Using cached extensions scan result",G.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),q.result.map(B=>(B.location=v.URI.revive(B.location),B));const O=await super.scanExtensions(G);return await this.writeExtensionCache(te,{input:G,result:O}),O}async readExtensionCache(G){try{const te=await this.fileService.readFile(G),q=JSON.parse(te.value.toString());return{result:q.result,input:(0,S.revive)(q.input)}}catch(te){this.logService.debug("Error while reading the extension cache file:",G.path,(0,A.getErrorMessage)(te))}return null}async writeExtensionCache(G,te){try{await this.fileService.writeFile(G,k.VSBuffer.fromString(JSON.stringify(te)))}catch(q){this.logService.debug("Error while writing the extension cache file:",G.path,(0,A.getErrorMessage)(q))}}async validateCache(){if(!this.input)return;const G=this.getCacheFile(this.input),te=await this.readExtensionCache(G);if(!te)return;const q=te.result,O=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!P.equals(O,q))try{this.logService.info("Invalidating Cache",q,O),await this.fileService.del(G),this._onDidChangeCache.fire()}catch(B){this.logService.error(B)}}getCacheFile(G){const te=this.getProfile(G);return this.uriIdentityService.extUri.joinPath(te.cacheHome,G.type===o.ExtensionType.System?o.BUILTIN_MANIFEST_CACHE_FILE:o.USER_MANIFEST_CACHE_FILE)}getProfile(G){return G.type===o.ExtensionType.System?this.userDataProfilesService.defaultProfile:G.profile?this.uriIdentityService.extUri.isEqual(G.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(te=>this.uriIdentityService.extUri.isEqual(G.location,te.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};z=Ie([se(2,L.IUserDataProfilesService),se(3,D.IExtensionsProfileScannerService),se(4,M.IUriIdentityService),se(5,r.IFileService),se(6,n.ILogService)],z);function re(oe,G){const te=(0,I.getExtensionId)(oe.manifest.publisher,oe.manifest.name);return{id:te,identifier:new o.ExtensionIdentifier(te),isBuiltin:oe.type===o.ExtensionType.System,isUserBuiltin:oe.type===o.ExtensionType.User&&oe.isBuiltin,isUnderDevelopment:G,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,publisherDisplayName:oe.publisherDisplayName,...oe.manifest}}class ie extends F{constructor(G,te,q,O,B,V,ae,j,he,ne,J,_){super(G,te,(0,y.joinPath)(q,".vscode-oss-dev","extensions","control.json"),O,B,V,ae,j,he,ne,J,_),this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const W=await this.fileService.readFile(v.URI.file(g.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=ie}),define(le[280],ce([0,1,5,43,42,24,86,15,38,7]),function(K,e,i,s,P,k,A,R,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let d=class extends A.AbstractExtensionsProfileScannerService{constructor(g,y,h,m,p,v){super(l.URI.file(g.extensionsPath),y,h,m,p,v)}};e.ExtensionsProfileScannerService=d,e.ExtensionsProfileScannerService=d=Ie([se(0,b.INativeEnvironmentService),se(1,R.IFileService),se(2,s.IUserDataProfilesService),se(3,P.IUriIdentityService),se(4,k.ITelemetryService),se(5,i.ILogService)],d)}),define(le[281],ce([0,1,7,38,86,134,15,6,5,28,42,43]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends k.NativeExtensionsScannerService{constructor(h,m,p,v,w,E,I,o){super(i.URI.file(w.builtinExtensionsPath),i.URI.file(w.extensionsPath),w.userHome,h.defaultProfile,h,m,p,v,w,E,I,o)}};e.ExtensionsScannerService=g,e.ExtensionsScannerService=g=Ie([se(0,f.IUserDataProfilesService),se(1,P.IExtensionsProfileScannerService),se(2,A.IFileService),se(3,b.ILogService),se(4,s.INativeEnvironmentService),se(5,l.IProductService),se(6,d.IUriIdentityService),se(7,R.IInstantiationService)],g)}),define(le[282],ce([0,1,14,2,13,9,4,61,7,33,37,38,5,43]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let h=class extends s.Disposable{constructor(p,v,w){super(),this.environmentService=p,this.logService=w,this.validRoots=R.TernarySearchTree.forPaths(!A.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot(v.defaultProfile.globalStorageHome.with({scheme:P.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:p}=i.session;p.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,(v,w)=>this.handleResourceRequest(v,w)),p.protocol.interceptFileProtocol(P.Schemas.file,(v,w)=>this.handleFileRequest(v,w)),this._register((0,s.toDisposable)(()=>{p.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(p){const v=(0,k.normalize)(p);return this.validRoots.get(v)?s.Disposable.None:(this.validRoots.set(v,!0),(0,s.toDisposable)(()=>this.validRoots.delete(v)))}handleFileRequest(p,v){const w=b.URI.parse(p.url);return this.logService.error(`Refused to load resource ${w.fsPath} from ${P.Schemas.file}: protocol (original URL: ${p.url})`),v({error:-3})}handleResourceRequest(p,v){const w=this.requestToNormalizedFilePath(p);let E;return this.environmentService.crossOriginIsolated&&((0,k.basename)(w)==="workbench.html"||(0,k.basename)(w)==="workbench-dev.html"?E=P.COI.CoopAndCoep:E=P.COI.getHeadersFromQuery(p.url)),this.validRoots.findSubstr(w)?v({path:w,headers:E}):this.validExtensions.has((0,k.extname)(w).toLowerCase())?v({path:w}):(this.logService.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${w} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),v({error:-3}))}requestToNormalizedFilePath(p){const v=b.URI.parse(p.url),w=P.FileAccess.uriToFileUri(v);return(0,k.normalize)(w.fsPath)}createIPCObjectUrl(){let p;const v=b.URI.from({scheme:"vscode",path:(0,l.generateUuid)()}),w=v.toString(),E=async()=>p;return d.validatedIpcMain.handle(w,E),this.logService.trace(`IPC Object URL: Registered new channel ${w}.`),{resource:v,update:I=>p=I,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${w}.`),d.validatedIpcMain.removeHandler(w)}}}};e.ProtocolMainService=h,e.ProtocolMainService=h=Ie([se(0,f.INativeEnvironmentService),se(1,y.IUserDataProfilesService),se(2,g.ILogService)],h)}),define(le[63],ce([0,1,8,3,2,69,12,120,6,43]),function(K,e,i,s,P,k,A,R,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=y,e.isProfileUsingDefaultStorage=m,e.logStorage=v,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,b.createDecorator)("storageService");var d;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(d||(e.WillSaveStateReason=d={}));var f;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(f||(e.StorageScope=f={}));var g;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function y(w){const E=w.get(e.TARGET_KEY);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}class h extends P.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(E={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=E,this._onDidChangeValue=this._register(new s.PauseableEmitter),this._onDidChangeTarget=this._register(new s.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new s.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new i.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(E,I,o){return s.Event.filter(this._onDidChangeValue.event,t=>t.scope===E&&(I===void 0||t.key===I),o)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,i.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(E,I){const{key:o,external:t}=I;if(o===e.TARGET_KEY){switch(E){case f.APPLICATION:this._applicationKeyTargets=void 0;break;case f.PROFILE:this._profileKeyTargets=void 0;break;case f.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:E})}else this._onDidChangeValue.fire({scope:E,key:o,target:this.getKeyTargets(E)[o],external:t})}emitWillSaveState(E){this._onWillSaveState.fire({reason:E})}get(E,I,o){return this.getStorage(I)?.get(E,o)}getBoolean(E,I,o){return this.getStorage(I)?.getBoolean(E,o)}getNumber(E,I,o){return this.getStorage(I)?.getNumber(E,o)}getObject(E,I,o){return this.getStorage(I)?.getObject(E,o)}storeAll(E,I){this.withPausedEmitters(()=>{for(const o of E)this.store(o.key,o.value,o.scope,o.target,I)})}store(E,I,o,t,r=!1){if((0,A.isUndefinedOrNull)(I)){this.remove(E,o,r);return}this.withPausedEmitters(()=>{this.updateKeyTarget(E,o,t),this.getStorage(o)?.set(E,I,r)})}remove(E,I,o=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(E,I,void 0),this.getStorage(I)?.delete(E,o)})}withPausedEmitters(E){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{E()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(E,I){const o=[],t=this.getKeyTargets(E);for(const r of Object.keys(t))t[r]===I&&o.push(r);return o}updateKeyTarget(E,I,o,t=!1){const r=this.getKeyTargets(I);typeof o=="number"?r[E]!==o&&(r[E]=o,this.getStorage(I)?.set(e.TARGET_KEY,JSON.stringify(r),t)):typeof r[E]=="number"&&(delete r[E],this.getStorage(I)?.set(e.TARGET_KEY,JSON.stringify(r),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(f.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(f.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(f.APPLICATION)),this._applicationKeyTargets}getKeyTargets(E){switch(E){case f.APPLICATION:return this.applicationKeyTargets;case f.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(E){const I=this.getStorage(E);return I?y(I):Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(E=d.NONE){this._onWillSaveState.fire({reason:E});const I=this.getStorage(f.APPLICATION),o=this.getStorage(f.PROFILE),t=this.getStorage(f.WORKSPACE);switch(E){case d.NONE:await i.Promises.settled([I?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case d.SHUTDOWN:await i.Promises.settled([I?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.getStorage(f.APPLICATION)?.items??new Map,I=this.getStorage(f.PROFILE)?.items??new Map,o=this.getStorage(f.WORKSPACE)?.items??new Map;return v(E,I,o,this.getLogDetails(f.APPLICATION)??"",this.getLogDetails(f.PROFILE)??"",this.getLogDetails(f.WORKSPACE)??"")}async optimize(E){return await this.flush(),this.getStorage(E)?.optimize()}async switch(E,I){return this.emitWillSaveState(d.NONE),(0,l.isUserDataProfile)(E)?this.switchToProfile(E,I):this.switchToWorkspace(E,I)}canSwitchProfile(E,I){return!(E.id===I.id||m(I)&&m(E))}switchData(E,I,o){this.withPausedEmitters(()=>{const t=new Set;for(const[r,a]of E)t.add(r),I.get(r)!==a&&this.emitDidChangeValue(o,{key:r,external:!0});for(const[r]of I.items)t.has(r)||this.emitDidChangeValue(o,{key:r,external:!0})})}}e.AbstractStorageService=h;function m(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class p extends h{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(E=>this.emitDidChangeValue(f.WORKSPACE,E))),this._register(this.profileStorage.onDidChangeStorage(E=>this.emitDidChangeValue(f.PROFILE,E))),this._register(this.applicationStorage.onDidChangeStorage(E=>this.emitDidChangeValue(f.APPLICATION,E)))}getStorage(E){switch(E){case f.APPLICATION:return this.applicationStorage;case f.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(E){switch(E){case f.APPLICATION:return"inMemory (application)";case f.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(E){return!1}}e.InMemoryStorageService=p;async function v(w,E,I,o,t,r){const a=C=>{try{return JSON.parse(C)}catch{return C}},n=new Map,c=new Map;w.forEach((C,F)=>{n.set(F,C),c.set(F,a(C))});const u=new Map,S=new Map;E.forEach((C,F)=>{u.set(F,C),S.set(F,a(C))});const D=new Map,L=new Map;I.forEach((C,F)=>{D.set(F,C),L.set(F,a(C))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const M=[];if(n.forEach((C,F)=>{M.push({key:F,value:C})}),console.table(M),console.groupEnd(),console.log(c),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];u.forEach((F,x)=>{C.push({key:x,value:F})}),console.table(C),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${r})`);const T=[];D.forEach((C,F)=>{T.push({key:F,value:C})}),console.table(T),console.groupEnd(),console.log(L)}}),define(le[283],ce([0,1,17,33,63]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=k;async function k(A,R,b){let l=b&&b.get("storage.serviceMachineId",P.StorageScope.APPLICATION)||null;if(l)return l;try{const f=(await R.readFile(A.serviceMachineIdResource)).value.toString();l=(0,s.isUUID)(f)?f:null}catch{l=null}if(!l){l=(0,s.generateUuid)();try{await R.writeFile(A.serviceMachineIdResource,i.VSBuffer.fromString(l))}catch{}}return b?.store("storage.serviceMachineId",l,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),l}}),define(le[284],ce([0,1,283,24,56]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=k;async function k(A,R,b,l,d,f,g){const y={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${R.nameShort})`};if((0,P.supportsTelemetry)(R,b)&&(0,P.getTelemetryLevel)(l)===s.TelemetryLevel.USAGE){const h=await(0,i.getServiceMachineId)(b,d,f);y["X-Market-User-Id"]=h,y["VSCode-SessionId"]=g.machineId||h}return y}}),define(le[285],ce([0,1,22,8,3,2,9,77,7,21,120,166,5,63,24,30,13]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class v extends k.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(a,n){super(),this.logService=a,this.fileService=n,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new P.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new d.Storage(new d.InMemoryStorageDatabase,{hint:d.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new s.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=d.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===d.StorageState.None)try{const a=this._register(await this.doCreate());this._storage.dispose(),this._storage=a,this._register(a.onDidChangeStorage(c=>this._onDidChangeStorage.fire(c))),await this.doInit(a);const n=a.getBoolean(y.IS_NEW_KEY);n===void 0?a.set(y.IS_NEW_KEY,!0):n&&a.set(y.IS_NEW_KEY,!1)}catch(a){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.state=d.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===g.LogLevel.Trace?a=>this.logService.trace(a):void 0,logError:a=>this.logService.error(a)}}doInit(a){return a.init()}get items(){return this._storage.items}get(a,n){return this._storage.get(a,n)}set(a,n){return this._storage.set(a,n)}delete(a){return this._storage.delete(a)}optimize(){return this._storage.optimize()}async close(){const a=new R.StopWatch(!1);await this.doClose(),a.stop(),a.elapsed()>v.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(a),this._onDidCloseStorage.fire()}async logSlowClose(a){if(this.path)try{const n=(0,i.top)(Array.from(this._storage.items.entries()).map(([u,S])=>({key:u,length:S.length})),(u,S)=>S.length-u.length,5).map(u=>`${u.key}:${u.length}`).join(", "),c=(await this.fileService.stat(b.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${c}b, Large Keys: ${n}`)}catch(n){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=d.StorageState.Closed,await this._storage.close()}}class w extends v{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,A.join)(this.profile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,w.STORAGE_NAME)}constructor(a,n,c,u){super(c,u),this.profile=a,this.options=n}async doCreate(){return new d.Storage(new f.SQLiteStorageDatabase(this.path??f.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:d.StorageHint.STORAGE_IN_MEMORY})}}class E extends w{constructor(a,n,c,u){super(a,n,c,u)}}e.ProfileStorageMain=E;class I extends w{constructor(a,n,c,u){super(n.defaultProfile,a,c,u)}async doInit(a){await super.doInit(a),this.updateTelemetryState(a)}updateTelemetryState(a){a.get(h.firstSessionDateStorageKey,void 0)===void 0&&a.set(h.firstSessionDateStorageKey,new Date().toUTCString());const c=a.get(h.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();a.set(h.lastSessionDateStorageKey,typeof c>"u"?null:c),a.set(h.currentSessionDateStorageKey,u)}}e.ApplicationStorageMain=I;class o extends v{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,A.join)(this.environmentService.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.workspace.id,o.WORKSPACE_STORAGE_NAME)}constructor(a,n,c,u,S){super(c,S),this.workspace=a,this.options=n,this.environmentService=u}async doCreate(){const{storageFilePath:a,wasCreated:n}=await this.prepareWorkspaceStorageFolder();return new d.Storage(new f.SQLiteStorageDatabase(a,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?d.StorageHint.STORAGE_IN_MEMORY:n?d.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,A.join)(this.environmentService.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.workspace.id),n=(0,A.join)(a,o.WORKSPACE_STORAGE_NAME);return await l.Promises.exists(a)?{storageFilePath:n,wasCreated:!1}:(await l.Promises.mkdir(a,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(a),{storageFilePath:n,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(a){let n;if((0,m.isSingleFolderWorkspaceIdentifier)(this.workspace)?n={folder:this.workspace.uri.toString()}:(0,m.isWorkspaceIdentifier)(this.workspace)&&(n={workspace:this.workspace.configPath.toString()}),n)try{const c=(0,A.join)(a,o.WORKSPACE_META_NAME);await l.Promises.exists(c)||await l.Promises.writeFile(c,JSON.stringify(n,void 0,2))}catch(c){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${c}`)}}}e.WorkspaceStorageMain=o;class t extends v{get path(){}async doCreate(){return new d.Storage(new d.InMemoryStorageDatabase,{hint:d.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=t}),define(le[286],ce([0,1,3,2,63]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class k extends s.Disposable{constructor(R,b,l){super(),this.storageMainService=R,this.userDataProfilesService=b,this.logService=l;const d=this._register(new s.MutableDisposable);this._onDidChange=this._register(new i.Emitter({onWillAddFirstListener:()=>d.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>d.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const R=new s.DisposableStore;return R.add(i.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(b,l)=>(b?b.push(l.key):b=[l.key],b),100)(b=>this.onDidChangeApplicationStorage(b))),R.add(i.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(b,l)=>{b||(b=new Map);let d=b.get(l.profile.id);return d||b.set(l.profile.id,d={profile:l.profile,keys:[],storage:l.storage}),d.keys.push(l.key),b},100)(b=>this.onDidChangeProfileStorage(b))),R}onDidChangeApplicationStorage(R){const b=R.includes(P.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],l=[];if(R=R.filter(d=>d!==P.TARGET_KEY),R.length){const d=(0,P.loadKeyTargets)(this.storageMainService.applicationStorage.storage);l.push({profile:this.userDataProfilesService.defaultProfile,changes:R.map(f=>({key:f,scope:P.StorageScope.PROFILE,target:d[f]}))})}this.triggerEvents(b,l)}onDidChangeProfileStorage(R){const b=[],l=new Map;for(const[d,f]of R.entries()){f.keys.includes(P.TARGET_KEY)&&b.push(f.profile);const g=f.keys.filter(y=>y!==P.TARGET_KEY);if(g.length){const y=(0,P.loadKeyTargets)(f.storage.storage);l.set(d,{profile:f.profile,changes:g.map(h=>({key:h,scope:P.StorageScope.PROFILE,target:y[h]}))})}}this.triggerEvents(b,[...l.values()])}triggerEvents(R,b){(R.length||b.length)&&this._onDidChange.fire({valueChanges:b,targetChanges:R})}listen(R,b,l){switch(b){case"onDidChange":return this._onDidChange.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${b}`)}async call(R,b){throw new Error(`Call not found: ${b}`)}}e.ProfileStorageChangesListenerChannel=k}),define(le[287],ce([0,1,7,38,15,5,34,42,43,12,128]),function(K,e,i,s,P,k,A,R,b,l,d){"use strict";var f,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let y=class extends b.UserDataProfilesService{static{f=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(v,w,E,I,o){super(E,I,w,o),this.stateReadonlyService=v,this.nativeEnvironmentService=E}getStoredProfiles(){return this.stateReadonlyService.getItem(f.PROFILES_KEY,[]).map(w=>({...w,location:(0,l.isString)(w.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,w.location):i.URI.revive(w.location)}))}getStoredProfileAssociations(){const v=this.stateReadonlyService.getItem(f.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(f.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?v:this.migrateStoredProfileAssociations(v)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(i.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=y,e.UserDataProfilesReadonlyService=y=f=Ie([se(0,A.IStateReadService),se(1,R.IUriIdentityService),se(2,s.INativeEnvironmentService),se(3,P.IFileService),se(4,k.ILogService)],y);let h=g=class extends y{constructor(v,w,E,I,o){super(v,w,E,I,o),this.stateService=v}saveStoredProfiles(v){v.length?this.stateService.setItem(g.PROFILES_KEY,v.map(w=>({...w,location:this.uriIdentityService.extUri.basename(w.location)}))):this.stateService.removeItem(g.PROFILES_KEY)}getStoredProfiles(){const v=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(v),this.stateService.setItem("userDataProfilesMigration",!0)),v}saveStoredProfileAssociations(v){v.emptyWindows||v.workspaces?this.stateService.setItem(g.PROFILE_ASSOCIATIONS_KEY,v):this.stateService.removeItem(g.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const v="workspaceAndProfileInfo",w=this.stateService.getItem(v,void 0);if(w){this.stateService.removeItem(v);const I=w.reduce((o,{workspace:t,profile:r})=>(o[i.URI.revive(t).toString()]=i.URI.revive(r).toString(),o),{});this.stateService.setItem(g.PROFILE_ASSOCIATIONS_KEY,{workspaces:I})}const E=super.getStoredProfileAssociations();return this.stateService.getItem(g.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(E),this.stateService.setItem(g.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),E}};e.UserDataProfilesService=h,e.UserDataProfilesService=h=g=Ie([se(0,A.IStateService),se(1,R.IUriIdentityService),se(2,s.INativeEnvironmentService),se(3,P.IFileService),se(4,k.ILogService)],h);let m=class extends h{constructor(v,w,E,I){super(new d.StateService(d.SaveStrategy.IMMEDIATE,w,I,E),v,w,E,I)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=m,e.ServerUserDataProfilesService=m=Ie([se(0,R.IUriIdentityService),se(1,s.INativeEnvironmentService),se(2,P.IFileService),se(3,k.ILogService)],m)}),define(le[59],ce([0,1,38,15,6,5,42,43,287,34]),function(K,e,i,s,P,k,A,R,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,P.refineServiceDecorator)(R.IUserDataProfilesService);let d=class extends b.UserDataProfilesService{constructor(g,y,h,m,p){super(g,y,h,m,p)}getAssociatedEmptyWindows(){const g=[];for(const y of this.profilesObject.emptyWindows.keys())g.push({id:y});return g}};e.UserDataProfilesMainService=d,e.UserDataProfilesMainService=d=Ie([se(0,l.IStateService),se(1,A.IUriIdentityService),se(2,i.INativeEnvironmentService),se(3,s.IFileService),se(4,k.ILogService)],d)}),define(le[135],ce([0,1,19,7,30]),function(K,e,i,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnFile=k,e.findWindowOnWorkspaceOrFolder=A,e.findWindowOnExtensionDevelopmentPath=R;async function k(b,l,d){for(const g of b){const y=g.openedWorkspace;if((0,P.isWorkspaceIdentifier)(y)){const h=await d(y);if(h){if(h.folders.some(m=>i.extUriBiasedIgnorePathCase.isEqualOrParent(l,m.uri)))return g}else if(i.extUriBiasedIgnorePathCase.isEqualOrParent(l,y.configPath))return g}}const f=b.filter(g=>(0,P.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&i.extUriBiasedIgnorePathCase.isEqualOrParent(l,g.openedWorkspace.uri));if(f.length)return f.sort((g,y)=>-(g.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}function A(b,l){for(const d of b)if((0,P.isWorkspaceIdentifier)(d.openedWorkspace)&&i.extUriBiasedIgnorePathCase.isEqual(d.openedWorkspace.configPath,l)||(0,P.isSingleFolderWorkspaceIdentifier)(d.openedWorkspace)&&i.extUriBiasedIgnorePathCase.isEqual(d.openedWorkspace.uri,l))return d}function R(b,l){const d=f=>l.some(g=>i.extUriBiasedIgnorePathCase.isEqual(s.URI.file(g),s.URI.file(f)));for(const f of b)if(f.config?.extensionDevelopmentPath?.some(g=>d(g)))return f}}),define(le[103],ce([0,1,31,40,108,49,13,9,4,19,7,6,71,30]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkspacesService=void 0,e.isRecentWorkspace=h,e.isRecentFolder=m,e.isRecentFile=p,e.isStoredWorkspaceFolder=v,e.getStoredWorkspaceFolder=I,e.toWorkspaceFolders=t,e.rewriteWorkspaceFileForNewLocation=r,e.restoreRecentlyOpened=S,e.toStoreData=D,e.IWorkspacesService=(0,f.createDecorator)("workspacesService");function h(L){return L.hasOwnProperty("workspace")}function m(L){return L.hasOwnProperty("folderUri")}function p(L){return L.hasOwnProperty("fileUri")}function v(L){return w(L)||E(L)}function w(L){const M=L;return typeof M?.path=="string"&&(!M.name||typeof M.name=="string")}function E(L){const M=L;return typeof M?.uri=="string"&&(!M.name||typeof M.name=="string")}function I(L,M,T,C,F){if(L.scheme!==C.scheme)return{name:T,uri:L.toString(!0)};let x=M?void 0:F.relativePath(C,L);if(x!==void 0)x.length===0?x=".":b.isWindows&&(x=o(x));else if(L.scheme===A.Schemas.file)x=L.fsPath,b.isWindows&&(x=o(x));else if(F.isEqualAuthority(L.authority,C.authority))x=L.path;else return{name:T,uri:L.toString(!0)};return{name:T,path:x}}function o(L){return L=(0,k.normalizeDriveLetter)(L),(0,i.isUNC)(L)||(L=(0,i.toSlashes)(L)),L}function t(L,M,T){const C=[],F=new Set,x=T.dirname(M);for(const U of L){let z;if(w(U))U.path&&(z=T.resolvePath(x,U.path));else if(E(U))try{z=d.URI.parse(U.uri),z.path[0]!==R.posix.sep&&(z=z.with({path:R.posix.sep+z.path}))}catch(re){console.warn(re)}if(z){const re=T.getComparisonKey(z);if(!F.has(re)){F.add(re);const ie=U.name||T.basenameOrAuthority(z);C.push(new y.WorkspaceFolder({uri:z,name:ie,index:C.length},U))}}}return C}function r(L,M,T,C,F){const x=a(M,L),U=F.dirname(M),z=F.dirname(C),re=[];for(const te of x.folders){const q=w(te)?F.resolvePath(U,te.path):d.URI.parse(te.uri);let O;T?O=!1:O=!w(te)||(0,R.isAbsolute)(te.path),re.push(I(q,O,te.name,z,F))}const ie={insertSpaces:!1,tabSize:4,eol:b.isLinux||b.isMacintosh?`
`:`\r
`},oe=P.setProperty(L,["folders"],re,ie);let G=P.applyEdits(L,oe);return(0,l.isEqualAuthority)(x.remoteAuthority,(0,g.getRemoteAuthority)(C))&&(G=P.applyEdits(G,P.removeProperty(G,["remoteAuthority"],ie))),G}function a(L,M){const T=s.parse(M);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(C=>v(C));else throw new Error(`${L} looks like an invalid workspace file.`);return T}function n(L){return L.workspace&&typeof L.workspace=="object"&&typeof L.workspace.id=="string"&&typeof L.workspace.configPath=="string"}function c(L){return typeof L.folderUri=="string"}function u(L){return typeof L.fileUri=="string"}function S(L,M){const T={workspaces:[],files:[]};if(L){const C=function(x,U){for(let z=0;z<x.length;z++)try{U(x[z],z)}catch(re){M.warn(`Error restoring recent entry ${JSON.stringify(x[z])}: ${re.toString()}. Skip entry.`)}},F=L;Array.isArray(F.entries)&&C(F.entries,x=>{const U=x.label,z=x.remoteAuthority;n(x)?T.workspaces.push({label:U,remoteAuthority:z,workspace:{id:x.workspace.id,configPath:d.URI.parse(x.workspace.configPath)}}):c(x)?T.workspaces.push({label:U,remoteAuthority:z,folderUri:d.URI.parse(x.folderUri)}):u(x)&&T.files.push({label:U,remoteAuthority:z,fileUri:d.URI.parse(x.fileUri)})})}return T}function D(L){const M={entries:[]};for(const T of L.workspaces)m(T)?M.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):M.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of L.files)M.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return M}}),define(le[104],ce([0,1,91,13,4,19]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=A,e.getSingleFolderWorkspaceIdentifier=R,e.createEmptyWorkspaceIdentifier=b,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(l){function d(){let f=l.scheme===s.Schemas.file?(0,k.originalFSPath)(l):l.toString();return P.isLinux||(f=f.toLowerCase()),(0,i.createHash)("md5").update(f).digest("hex")}return{id:d(),configPath:l}}function R(l,d){function f(){if(l.scheme!==s.Schemas.file)return(0,i.createHash)("md5").update(l.toString()).digest("hex");if(!d)return;let y;return P.isLinux?y=d.ino:P.isMacintosh?y=d.birthtime.getTime():P.isWindows&&(typeof d.birthtimeMs=="number"?y=Math.floor(d.birthtimeMs):y=d.birthtime.getTime()),(0,i.createHash)("md5").update(l.fsPath).update(y?String(y):"").digest("hex")}const g=f();if(typeof g=="string")return{id:g,uri:l}}function b(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[105],ce([0,1,91,92,27,288,17,16,3,2,9,4,33,45,118]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=a,e.createStaticIPCHandle=n,e.serve=S,e.connect=D;class m{traceSocketEvent(M,T){h.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,M,T)}constructor(M,T=""){this._canWrite=!0,this.debugLabel=T,this.socket=M,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=C=>{if(this.traceSocketEvent(h.SocketDiagnosticsEventType.Error,{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,R.onUnexpectedError)(C)}},this.socket.on("error",this._errorListener),this._closeListener=C=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Close,{hadError:C}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(M){const T=C=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Read,C),M(A.VSBuffer.wrap(C))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(M){const T=C=>{M({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:C,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(M){const T=()=>{M()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(M){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(h.SocketDiagnosticsEventType.Write,M),this.socket.write(M.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,R.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,R.onUnexpectedError)(T)}}end(){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((M,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),M();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),M()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.NodeSocket=m;var p;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var v;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(v||(v={}));class w extends l.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(M,T){this.socket.traceSocketEvent(M,T)}constructor(M,T,C,F){super(),this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:v.PeekHeader,readLen:p.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=M,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:C?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new E(this,T,C,F,this._onData,(x,U)=>this._write(x,U))),this._register(this._flowManager.onError(x=>{console.error(x),(0,R.onUnexpectedError)(x),this._onClose.fire({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:x})})),this._incomingData=new h.ChunkStream,this._register(this.socket.onData(x=>this._acceptChunk(x))),this._register(this.socket.onClose(async x=>{this._flowManager.isProcessingReadQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(x)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(M){return this._onData.event(M)}onClose(M){return this._onClose.event(M)}onEnd(M){return this.socket.onEnd(M)}write(M){let T=0;for(;T<M.byteLength;)this._flowManager.writeMessage(M.slice(T,Math.min(T+p.MaxWebSocketMessageLength,M.byteLength)),{compressed:!0,opcode:2}),T+=p.MaxWebSocketMessageLength}_write(M,{compressed:T,opcode:C}){if(this._isEnded)return;this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,M);let F=p.MinHeaderByteSize;M.byteLength<126?F+=0:M.byteLength<2**16?F+=2:F+=8;const x=A.VSBuffer.alloc(F),U=T?64:0,z=C&15;if(x.writeUInt8(128|U|z,0),M.byteLength<126)x.writeUInt8(M.byteLength,1);else if(M.byteLength<2**16){x.writeUInt8(126,1);let re=1;x.writeUInt8(M.byteLength>>>8&255,++re),x.writeUInt8(M.byteLength>>>0&255,++re)}else{x.writeUInt8(127,1);let re=1;x.writeUInt8(0,++re),x.writeUInt8(0,++re),x.writeUInt8(0,++re),x.writeUInt8(0,++re),x.writeUInt8(M.byteLength>>>24&255,++re),x.writeUInt8(M.byteLength>>>16&255,++re),x.writeUInt8(M.byteLength>>>8&255,++re),x.writeUInt8(M.byteLength>>>0&255,++re)}this.socket.write(A.VSBuffer.concat([x,M]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(M){if(M.byteLength!==0){for(this._incomingData.acceptChunk(M);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===v.PeekHeader){const T=this._incomingData.peek(this._state.readLen),C=T.readUInt8(0),F=(C&128)>>>7,x=(C&64)>>>6,U=C&15,z=T.readUInt8(1),re=(z&128)>>>7,ie=z&127;this._state.state=v.ReadHeader,this._state.readLen=p.MinHeaderByteSize+(re?4:0)+(ie===126?2:0)+(ie===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!x),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this._state.opcode=U,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===v.ReadHeader){const T=this._incomingData.read(this._state.readLen),C=T.readUInt8(1),F=(C&128)>>>7;let x=C&127,U=1;x===126?x=T.readUInt8(++U)*2**8+T.readUInt8(++U):x===127&&(x=T.readUInt8(++U)*0+T.readUInt8(++U)*0+T.readUInt8(++U)*0+T.readUInt8(++U)*0+T.readUInt8(++U)*2**24+T.readUInt8(++U)*2**16+T.readUInt8(++U)*2**8+T.readUInt8(++U));let z=0;F&&(z=T.readUInt8(++U)*2**24+T.readUInt8(++U)*2**16+T.readUInt8(++U)*2**8+T.readUInt8(++U)),this._state.state=v.ReadBody,this._state.readLen=x,this._state.mask=z,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===v.ReadBody){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,T),t(T,this._state.mask),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,T),this._state.state=v.PeekHeader,this._state.readLen=p.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(T,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=w;class E extends l.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}constructor(M,T,C,F,x,U){super(),this._tracer=M,this._onData=x,this._writeFn=U,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new b.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new b.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new I(this._tracer,F,C,{windowBits:15})),this._zlibDeflateStream=this._register(new o(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(z=>this._onError.fire(z))),this._register(this._zlibDeflateStream.onError(z=>this._onError.fire(z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(M,T){this._writeQueue.push({data:M,options:T}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:M,options:T}=this._writeQueue.shift();if(this._zlibDeflateStream&&T.compressed){const C=await this._deflateMessage(this._zlibDeflateStream,M);this._writeFn(C,T)}else this._writeFn(M,{...T,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(M,T){return new Promise((C,F)=>{M.write(T),M.flush(x=>C(x))})}acceptFrame(M,T,C){this._readQueue.push({data:M,isCompressed:T,isLastFrameOfMessage:C}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const M=this._readQueue.shift();if(this._zlibInflateStream&&M.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,M.data,M.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(M.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(M,T,C){return new Promise((F,x)=>{M.write(T),C&&M.write(A.VSBuffer.fromByteArray([0,0,255,255])),M.flush(U=>F(U))})}}class I extends l.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}constructor(M,T,C,F){super(),this._tracer=M,this._recordInflateBytes=T,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,k.createInflateRaw)(F),this._zlibInflate.on("error",x=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateError,{message:x?.message,code:x?.code}),this._onError.fire(x)}),this._zlibInflate.on("data",x=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateData,x),this._pendingInflateData.push(A.VSBuffer.wrap(x))}),C&&(this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialWrite,C.buffer),this._zlibInflate.write(C.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(M){this._recordInflateBytes&&this._recordedInflateBytes.push(M.clone()),this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateWrite,M),this._zlibInflate.write(M.buffer)}flush(M){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateFlushFired);const T=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,M(T)})}}class o extends l.Disposable{constructor(M,T){super(),this._tracer=M,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,k.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",C=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateError,{message:C?.message,code:C?.code}),this._onError.fire(C)}),this._zlibDeflate.on("data",C=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateData,C),this._pendingDeflateData.push(A.VSBuffer.wrap(C))})}write(M){this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateWrite,M.buffer),this._zlibDeflate.write(M.buffer)}flush(M){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateFlushFired);let T=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),M(T)})}}function t(L,M){if(M===0)return;const T=L.byteLength>>>2;for(let re=0;re<T;re++){const ie=L.readUInt32BE(re*4);L.writeUInt32BE(ie^M,re*4)}const C=T*4,F=L.byteLength-C,x=M>>>24&255,U=M>>>16&255,z=M>>>8&255;F>=1&&L.writeUInt8(L.readUInt8(C)^x,C),F>=2&&L.writeUInt8(L.readUInt8(C+1)^U,C+1),F>=3&&L.writeUInt8(L.readUInt8(C+2)^z,C+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[f.Platform.Linux]:107,[f.Platform.Mac]:103};function a(){const L=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const M=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,P.tmpdir)(),T=(0,d.join)(M,`vscode-ipc-${L}.sock`);return c(T),T}function n(L,M,T){const F=(0,i.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${T}-${M}-sock`;const x=T.substr(0,4),U=M.substr(0,6);let z;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?z=(0,d.join)(e.XDG_RUNTIME_DIR,`vscode-${F}-${x}-${U}.sock`):z=(0,d.join)(L,`${x}-${U}.sock`),c(z),z}function c(L){const M=r[f.platform];typeof M=="number"&&L.length>=M&&console.warn(`WARNING: IPC handle "${L}" is longer than ${M} chars, try a shorter --user-data-dir`)}class u extends y.IPCServer{static toClientConnectionEvent(M){const T=b.Event.fromNodeEventEmitter(M,"connection");return b.Event.map(T,C=>({protocol:new h.Protocol(new m(C,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(C,"close"))}))}constructor(M){super(u.toClientConnectionEvent(M)),this.server=M}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function S(L){return new Promise((M,T)=>{const C=(0,s.createServer)();C.on("error",T),C.listen(L,()=>{C.removeListener("error",T),M(new u(C))})})}function D(L,M){return new Promise((T,C)=>{const F=(0,s.createConnection)(L,()=>{F.removeListener("error",C),T(h.Client.fromSocket(new m(F,`ipc-client${M}`),M))});F.once("error",C)})}}),define(le[25],ce([0,1,53,9,4,105,38,95,6]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,b.refineServiceDecorator)(A.IEnvironmentService);class l extends R.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,s.join)(this.userDataPath,"clp")}get backupHome(){return(0,s.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,s.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(P.isLinux){for(const f in process.env)if(f.endsWith("_VSCODE_SNAP_ORIG")){const g=f.slice(0,-17);if(this._snapEnv[g])continue;process.env[g]&&(this._snapEnv[g]=process.env[g]),process.env[f]?process.env[g]=process.env[f]:delete process.env[g]}}}restoreSnapExportedVariables(){if(P.isLinux)for(const f in this._snapEnv)process.env[f]=this._snapEnv[f],delete this._snapEnv[f]}}e.EnvironmentMainService=l,Ie([i.memoize],l.prototype,"cachedLanguagesPath",null),Ie([i.memoize],l.prototype,"backupHome",null),Ie([i.memoize],l.prototype,"mainIPCHandle",null),Ie([i.memoize],l.prototype,"mainLockfile",null),Ie([i.memoize],l.prototype,"disableUpdates",null),Ie([i.memoize],l.prototype,"crossOriginIsolated",null),Ie([i.memoize],l.prototype,"codeCachePath",null),Ie([i.memoize],l.prototype,"useCodeCache",null)}),define(le[289],ce([0,1,91,31,13,9,4,19,21,202,18,25,34,15,5,201,30,104]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let E=class{static{w=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(o,t,r,a){this.environmentMainService=o,this.configurationService=t,this.logService=r,this.stateService=a,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=R.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,c)=>(0,s.isEqual)(n,c,!A.isLinux)}}async initialize(){const o=this.stateService.getItem(w.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(o.emptyWindows),this.workspaces=await this.validateWorkspaces((0,l.deserializeWorkspaceInfos)(o)),this.folders=await this.validateFolders((0,l.deserializeFolderInfos)(o)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==y.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===y.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||y.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(o,t){this.workspaces.some(a=>o.workspace.id===a.workspace.id)||(this.workspaces.push(o),this.storeWorkspacesMetadata());const r=(0,k.join)(this.backupHome,o.workspace.id);return t?this.moveBackupFolder(r,t).then(()=>r):r}async moveBackupFolder(o,t){if(await b.Promises.exists(o)&&await this.convertToEmptyWindowBackup(o),await b.Promises.exists(t))try{await b.Promises.rename(t,o,!1)}catch(r){this.logService.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}registerFolderBackup(o){return this.folders.some(t=>this.backupUriComparer.isEqual(o.folderUri,t.folderUri))||(this.folders.push(o),this.storeWorkspacesMetadata()),(0,k.join)(this.backupHome,this.getFolderHash(o))}registerEmptyWindowBackup(o){return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o.backupFolder))||(this.emptyWindows.push(o),this.storeWorkspacesMetadata()),(0,k.join)(this.backupHome,o.backupFolder)}async validateWorkspaces(o){if(!Array.isArray(o))return[];const t=new Set,r=[];for(const a of o){const n=a.workspace;if(!(0,p.isWorkspaceIdentifier)(n))return[];if(!t.has(n.id)){t.add(n.id);const c=(0,k.join)(this.backupHome,n.id);await this.doHasBackups(c)?n.configPath.scheme!==P.Schemas.file||await b.Promises.exists(n.configPath.fsPath)?r.push(a):await this.convertToEmptyWindowBackup(c):await this.deleteStaleBackup(c)}}return r}async validateFolders(o){if(!Array.isArray(o))return[];const t=[],r=new Set;for(const a of o){const n=a.folderUri,c=this.backupUriComparer.getComparisonKey(n);if(!r.has(c)){r.add(c);const u=(0,k.join)(this.backupHome,this.getFolderHash(a));await this.doHasBackups(u)?n.scheme!==P.Schemas.file||await b.Promises.exists(n.fsPath)?t.push(a):await this.convertToEmptyWindowBackup(u):await this.deleteStaleBackup(u)}}return t}async validateEmptyWorkspaces(o){if(!Array.isArray(o))return[];const t=[],r=new Set;for(const a of o){const n=a.backupFolder;if(typeof n!="string")return[];if(!r.has(n)){r.add(n);const c=(0,k.join)(this.backupHome,n);await this.doHasBackups(c)?t.push(a):await this.deleteStaleBackup(c)}}return t}async deleteStaleBackup(o){try{await b.Promises.rm(o,b.RimRafMode.MOVE)}catch(t){this.logService.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}prepareNewEmptyWindowBackup(){let o=(0,v.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o.id));)o=(0,v.createEmptyWorkspaceIdentifier)();return{backupFolder:o.id}}async convertToEmptyWindowBackup(o){const t=this.prepareNewEmptyWindowBackup(),r=(0,k.join)(this.backupHome,t.backupFolder);try{await b.Promises.rename(o,r,!1)}catch(a){return this.logService.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.emptyWindows.push(t),!0}async getDirtyWorkspaces(){const o=[];for(const t of this.workspaces)await this.hasBackups(t)&&o.push(t);for(const t of this.folders)await this.hasBackups(t)&&o.push(t);return o}hasBackups(o){let t;return(0,l.isEmptyWindowBackupInfo)(o)?t=(0,k.join)(this.backupHome,o.backupFolder):(0,m.isFolderBackupInfo)(o)?t=(0,k.join)(this.backupHome,this.getFolderHash(o)):t=(0,k.join)(this.backupHome,o.workspace.id),this.doHasBackups(t)}async doHasBackups(o){try{const t=await b.Promises.readdir(o);for(const r of t)try{if((await b.Promises.readdir((0,k.join)(o,r))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const o={workspaces:this.workspaces.map(({workspace:t,remoteAuthority:r})=>{const a={id:t.id,configURIPath:t.configPath.toString()};return r&&(a.remoteAuthority=r),a}),folders:this.folders.map(({folderUri:t,remoteAuthority:r})=>{const a={folderUri:t.toString()};return r&&(a.remoteAuthority=r),a}),emptyWindows:this.emptyWindows.map(({backupFolder:t,remoteAuthority:r})=>{const a={backupFolder:t};return r&&(a.remoteAuthority=r),a})};this.stateService.setItem(w.backupWorkspacesMetadataStorageKey,o)}getFolderHash(o){const t=o.folderUri;let r;return t.scheme===P.Schemas.file?r=A.isLinux?t.fsPath:t.fsPath.toLowerCase():r=t.toString().toLowerCase(),(0,i.createHash)("md5").update(r).digest("hex")}};e.BackupMainService=E,e.BackupMainService=E=w=Ie([se(0,f.IEnvironmentMainService),se(1,d.IConfigurationService),se(2,h.ILogService),se(3,g.IStateService)],E)}),define(le[20],ce([0,1,14,37,8,3,2,4,36,12,6,5,34,52,25]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,d.createDecorator)("lifecycleMainService");var p;(function(E){E[E.QUIT=1]="QUIT",E[E.KILL=2]="KILL"})(p||(e.ShutdownReason=p={}));var v;(function(E){E[E.Starting=1]="Starting",E[E.Ready=2]="Ready",E[E.AfterWindowOpen=3]="AfterWindowOpen",E[E.Eventually=4]="Eventually"})(v||(e.LifecycleMainPhase=v={}));let w=class extends A.Disposable{static{m=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(I,o,t){super(),this.logService=I,this.stateService=o,this.environmentMainService=t,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=v.Starting,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(v.Ready).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(m.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(m.QUIT_AND_RESTART_KEY)}registerListeners(){const I=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),R.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(p.QUIT))};i.app.addListener("before-quit",I);const o=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!R.isMacintosh)&&i.app.quit()};i.app.addListener("window-all-closed",o),i.app.once("will-quit",t=>{this.trace("Lifecycle#app.on(will-quit) - begin"),t.preventDefault(),this.fireOnWillShutdown(p.QUIT).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),i.app.removeListener("before-quit",I),i.app.removeListener("window-all-closed",o),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),i.app.quit()})})}fireOnWillShutdown(I){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const o=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const t=[];return this._onWillShutdown.fire({reason:I,join(r,a){o.trace(`Lifecycle#onWillShutdown - begin '${r}'`),t.push(a.finally(()=>{o.trace(`Lifecycle#onWillShutdown - end '${r}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await P.Promises.settled(t)}catch(r){this.logService.error(r)}try{await this.stateService.close()}catch(r){this.logService.error(r)}})(),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===I)return;this.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const o=this.phaseWhen.get(this._phase);o&&(o.open(),this.phaseWhen.delete(this._phase))}async when(I){if(I<=this._phase)return;let o=this.phaseWhen.get(I);o||(o=new P.Barrier,this.phaseWhen.set(I,o)),await o.wait()}registerWindow(I){const o=new A.DisposableStore;this.windowCounter++,o.add(I.onWillLoad(r=>this._onWillLoadWindow.fire({window:I,workspace:r.workspace,reason:r.reason})));const t=(0,l.assertIsDefined)(I.win);o.add(k.Event.fromNodeEventEmitter(t,"close")(r=>{const a=I.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),r.preventDefault(),this.unload(I,y.UnloadReason.CLOSE).then(n=>{if(n){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(I),I.close()})})),o.add(k.Event.fromNodeEventEmitter(t,"closed")(()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,o.dispose(),this.windowCounter===0&&(!R.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(p.QUIT)}))}registerAuxWindow(I){const o=(0,l.assertIsDefined)(I.win),t=new A.DisposableStore;t.add(k.Event.fromNodeEventEmitter(o,"close")(r=>{this.trace(`Lifecycle#auxWindow.on('close') - window ID ${I.id}`),this._quitRequested&&(this.trace("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),r.preventDefault())})),t.add(k.Event.fromNodeEventEmitter(o,"closed")(()=>{this.trace(`Lifecycle#auxWindow.on('closed') - window ID ${I.id}`),t.dispose()}))}async reload(I,o){await this.unload(I,y.UnloadReason.RELOAD)||I.reload(o)}unload(I,o){const t=this.mapWindowIdToPendingUnload.get(I.id);if(t)return t;const r=this.doUnload(I,o).finally(()=>{this.mapWindowIdToPendingUnload.delete(I.id)});return this.mapWindowIdToPendingUnload.set(I.id,r),r}async doUnload(I,o){if(!I.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${I.id}`);const t=this._quitRequested?y.UnloadReason.QUIT:o,r=await this.onBeforeUnloadWindowInRenderer(I,t);return r?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(r)):(await this.onWillUnloadWindowInRenderer(I,t),!1)}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(I,o){return new Promise(t=>{const r=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${r}`,n=`vscode:cancel${r}`;s.validatedIpcMain.once(a,()=>{t(!1)}),s.validatedIpcMain.once(n,()=>{t(!0)}),I.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:n,reason:o})})}onWillUnloadWindowInRenderer(I,o){return new Promise(t=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;s.validatedIpcMain.once(a,()=>t()),I.send("vscode:onWillUnload",{replyChannel:a,reason:o})})}quit(I){return this.doQuit(I).then(o=>{if(!o&&I)try{if(R.isWindows){const t=(0,b.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.logService.error(t)}return o})}doQuit(I){return this.trace(`Lifecycle#quit() - begin (willRestart: ${I})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(I&&this.stateService.setItem(m.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(o=>{this.pendingQuitPromiseResolve=o,this.trace("Lifecycle#quit() - calling app.quit()"),i.app.quit()}),this.pendingQuitPromise)}trace(I){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(I):this.logService.trace(I)}setRelaunchHandler(I){this.relaunchHandler=I}async relaunch(I){this.trace("Lifecycle#relaunch()");const o=process.argv.slice(1);if(I?.addArgs&&o.push(...I.addArgs),I?.removeArgs)for(const a of I.removeArgs){const n=o.indexOf(a);n>=0&&o.splice(n,1)}const t=()=>{this.relaunchHandler?.handleRelaunch(I)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),i.app.relaunch({args:o}))};i.app.once("quit",t),await this.quit(!0)&&i.app.removeListener("quit",t)}async kill(I){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(p.KILL),await Promise.race([(0,P.timeout)(1e3),(async()=>{for(const o of i.BrowserWindow.getAllWindows())if(o&&!o.isDestroyed()){let t;o.webContents&&!o.webContents.isDestroyed()?t=new Promise(r=>o.once("closed",r)):t=Promise.resolve(),o.destroy(),await t}})()]),i.app.exit(I)}};e.LifecycleMainService=w,e.LifecycleMainService=w=m=Ie([se(0,f.ILogService),se(1,g.IStateService),se(2,h.IEnvironmentMainService)],w)}),define(le[290],ce([0,1,4,3,2,6,20]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let R=class extends P.Disposable{constructor(d){super(),this._onDidChangeKeyboardLayout=this._register(new s.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,d.when(A.LifecycleMainPhase.AfterWindowOpen).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const d=await new Promise((f,g)=>{K(["native-keymap"],f,g)});this._keyboardLayoutData=b(d),i.isCI||d.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=b(d),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=R,e.KeyboardLayoutMainService=R=Ie([se(0,A.ILifecycleMainService)],R);function b(l){const d=l.getKeyMap(),f=l.getCurrentKeyboardLayout();return{keyboardMapping:d,keyboardLayoutInfo:f}}}),define(le[291],ce([0,1,251,8,17,16,12,18,38,101,5,55,250,288]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0,e.nodeRequest=p;let h=class extends f.AbstractRequestService{constructor(w,E,I,o){super(o),this.configurationService=w,this.environmentService=E,this.logService=I,this.configure(),this._register(w.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const w=this.configurationService.getValue("http");this.proxyUrl=w?.proxy,this.strictSSL=!!w?.proxyStrictSSL,this.authorization=w?.proxyAuthorization}async request(w,E){const{proxyUrl:I,strictSSL:o}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,k.getErrorMessage)(n)))}const r={...process.env,...t},a=w.agent?w.agent:await(0,g.getProxyAgent)(w.url||"",r,{proxyUrl:I,strictSSL:o});return w.agent=a,w.strictSSL=o,this.authorization&&(w.headers={...w.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(w.isChromiumNetwork?"electron":"node",w,()=>p(w,E))}async resolveProxy(w){}async loadCertificates(){return(await new Promise((E,I)=>{K(["@vscode/proxy-agent"],E,I)})).loadSystemCertificates({log:this.logService})}};e.RequestService=h,e.RequestService=h=Ie([se(0,R.IConfigurationService),se(1,b.INativeEnvironmentService),se(2,d.ILogService),se(3,d.ILoggerService)],h);async function m(v){return((0,i.parse)(v.url).protocol==="https:"?await new Promise((I,o)=>{K(["https"],I,o)}):await new Promise((I,o)=>{K(["http"],I,o)})).request}async function p(v,w){return s.Promises.withAsyncBody(async(E,I)=>{const o=(0,i.parse)(v.url),t=v.getRawRequest?v.getRawRequest(v):await m(v),r={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,A.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(r.auth=v.user+":"+v.password);const a=t(r,n=>{const c=(0,A.isNumber)(v.followRedirects)?v.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&c>0&&n.headers.location)p({...v,url:n.headers.location,followRedirects:c-1},w).then(E,I);else{let u=n;!v.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(u=n.pipe((0,y.createGunzip)())),E({res:n,stream:(0,P.streamToBufferReadableStream)(u)})}});a.on("error",I),v.timeout&&a.setTimeout(v.timeout),v.isChromiumNetwork&&a.removeHeader("Content-Length"),v.data&&typeof v.data=="string"&&a.write(v.data),a.end(),w.onCancellationRequested(()=>{a.abort(),I(new k.CancellationError)})})}}),define(le[292],ce([0,1,14,291]),function(K,e,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function P(A){return i.net.request}class k extends s.RequestService{request(R,b){return super.request({...R||{},getRawRequest:P,isChromiumNetwork:!0},b)}}e.RequestMainService=k}),define(le[87],ce([0,1,7,3,2,38,15,6,20,5,63,285,43,59,42,13]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,R.createDecorator)("storageMainService");let p=class extends P.Disposable{constructor(E,I,o,t,r,a){super(),this.logService=E,this.environmentService=I,this.userDataProfilesService=o,this.lifecycleMainService=t,this.fileService=r,this.uriIdentityService=a,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new s.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(b.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(E=>{E.window.profile&&this.profileStorage(E.window.profile).init(),E.workspace&&this.workspaceStorage(E.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(E=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=E.reason,E.join("applicationStorage",this.applicationStorage.close());for(const[,I]of this.mapProfileToStorage)E.join("profileStorage",I.close());for(const[,I]of this.mapWorkspaceToStorage)E.join("workspaceStorage",I.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(E=>{E.join((async()=>{await this.fileService.exists(E.profile.globalStorageHome)||await this.fileService.createFolder(E.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(E=>{const I=this.mapProfileToStorage.get(E.profile.id);I&&E.join(I.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const E=new f.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(s.Event.once(E.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),E}profileStorage(E){if((0,d.isProfileUsingDefaultStorage)(E))return this.applicationStorage;let I=this.mapProfileToStorage.get(E.id);if(!I){this.logService.trace(`StorageMainService: creating profile storage (${E.name})`),I=this._register(this.createProfileStorage(E)),this.mapProfileToStorage.set(E.id,I);const o=this._register(I.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:I,profile:E})));this._register(s.Event.once(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${E.name})`),this.mapProfileToStorage.delete(E.id),o.dispose()}))}return I}createProfileStorage(E){return this.shutdownReason===b.ShutdownReason.KILL?new f.InMemoryStorageMain(this.logService,this.fileService):new f.ProfileStorageMain(E,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(E){let I=this.mapWorkspaceToStorage.get(E.id);return I||(this.logService.trace(`StorageMainService: creating workspace storage (${E.id})`),I=this._register(this.createWorkspaceStorage(E)),this.mapWorkspaceToStorage.set(E.id,I),this._register(s.Event.once(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${E.id})`),this.mapWorkspaceToStorage.delete(E.id)}))),I}createWorkspaceStorage(E){return this.shutdownReason===b.ShutdownReason.KILL?new f.InMemoryStorageMain(this.logService,this.fileService):new f.WorkspaceStorageMain(E,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(E){const I=i.URI.file(E);for(const o of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(o.path&&this.uriIdentityService.extUri.isEqualOrParent(i.URI.file(o.path),I))return!0;return!1}};e.StorageMainService=p,e.StorageMainService=p=Ie([se(0,l.ILogService),se(1,k.IEnvironmentService),se(2,y.IUserDataProfilesMainService),se(3,b.ILifecycleMainService),se(4,A.IFileService),se(5,h.IUriIdentityService)],p),e.IApplicationStorageMainService=(0,R.createDecorator)("applicationStorageMainService");let v=class extends d.AbstractStorageService{constructor(E,I){super(),this.userDataProfilesService=E,this.storageMainService=I,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(E){if(E===d.StorageScope.APPLICATION)return this.storageMainService.applicationStorage.storage}getLogDetails(E){if(E===d.StorageScope.APPLICATION)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=v,e.ApplicationStorageMainService=v=Ie([se(0,g.IUserDataProfilesService),se(1,e.IStorageMainService)],v)}),define(le[293],ce([0,1,92,27,112,105,8,2,4,18,5,28,246,247,102,132,17]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function v(t,r,a,n,c){let u;for(let S=3;S&&(u?.dispose(),u=await new w(t,r,a,n,c).waitForReady(),!(c&&P.BROWSER_RESTRICTED_PORTS[c]||!P.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));S--);return u}class w extends R.Disposable{constructor(r,a,n,c,u){super(),this.defaultTunnelHost=a,this.suggestedLocalPort=u,this.privacy=m.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=r,this._server=i.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=S=>this._onConnection(S),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){const r=this.suggestedLocalPort??this.tunnelRemotePort,a=(0,m.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let n=await(0,P.findFreePortFaster)(r,2,1e3,a),c=null;return this._server.listen(n,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(n=0,this._server.listen(n,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(r){r.pause();const a=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,g.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),c=n.getSocket(),u=n.readEntireBuffer();n.dispose(),u.byteLength>0&&r.write(u.buffer),r.on("end",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),c.end()}),r.on("close",()=>c.end()),r.on("error",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),c instanceof k.NodeSocket?c.socket.destroy():c.end()}),c instanceof k.NodeSocket?this._mirrorNodeSocket(r,c):this._mirrorGenericSocket(r,c),r.localAddress&&this._socketsDispose.set(r.localAddress,()=>{r.end(),c.end()})}_mirrorGenericSocket(r,a){a.onClose(()=>r.destroy()),a.onEnd(()=>r.end()),a.onData(n=>r.write(n.buffer)),r.on("data",n=>a.write(p.VSBuffer.wrap(n))),r.resume()}_mirrorNodeSocket(r,a){const n=a.socket;n.on("end",()=>r.end()),n.on("close",()=>r.end()),n.on("error",()=>{r.destroy()}),n.pipe(r),r.pipe(n)}}e.NodeRemoteTunnel=w;let E=class extends m.AbstractTunnelService{constructor(r,a,n,c,u){super(a,u),this.remoteSocketFactoryService=r,this.signService=n,this.productService=c}isPortPrivileged(r){return(0,m.isPortPrivileged)(r,this.defaultTunnelHost,b.OS,s.release())}retainOrCreateTunnel(r,a,n,c,u,S,D,L){const M=this.getTunnelFromMap(a,n);if(M)return++M.refcount,M.value;if((0,m.isTunnelProvider)(r))return this.createWithProvider(r,a,n,u,S,D,L);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${n} on local port ${u}.`);const T={commit:this.productService.commit,quality:this.productService.quality,addressProvider:r,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},C=v(T,c,a,n,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,n,C),C}}};e.BaseTunnelService=E,e.BaseTunnelService=E=Ie([se(0,y.IRemoteSocketFactoryService),se(1,d.ILogService),se(2,h.ISignService),se(3,f.IProductService),se(4,l.IConfigurationService)],E);let I=class extends E{constructor(r,a,n,c,u){super(r,a,n,c,u)}};e.TunnelService=I,e.TunnelService=I=Ie([se(0,y.IRemoteSocketFactoryService),se(1,d.ILogService),se(2,h.ISignService),se(3,f.IProductService),se(4,l.IConfigurationService)],I);let o=class extends R.Disposable{constructor(r,a,n,c,u){super(),this.remoteSocketFactoryService=r,this.logService=a,this.productService=n,this.signService=c,this.configurationService=u,this._tunnelServices=new Map}async openTunnel(r,a,n,c,u,S,D,L,M){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${c} on local port ${S}.`),!this._tunnelServices.has(r)){const T=new I(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(T),this._tunnelServices.set(r,T),T.onTunnelClosed(async()=>{(await T.tunnels).length===0&&(T.dispose(),this._tunnelServices.delete(r))})}return this._tunnelServices.get(r).openTunnel(a,n,c,u,S,D,L,M)}};e.SharedTunnelsService=o,e.SharedTunnelsService=o=Ie([se(0,y.IRemoteSocketFactoryService),se(1,d.ILogService),se(2,f.IProductService),se(3,h.ISignService),se(4,l.IConfigurationService)],o)}),define(le[106],ce([0,1,8,23,3,18,25,20,5,28,55,51]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=void 0,e.createUpdateURL=g;function g(h,m,p){return`${p.updateUrl}/api/update/${h}/${m}/${p.commit}`}let y=class{get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}constructor(m,p,v,w,E,I){this.lifecycleMainService=m,this.configurationService=p,this.environmentMainService=v,this.requestService=w,this.logService=E,this.productService=I,this._state=f.State.Uninitialized,this._onStateChange=new P.Emitter,this.onStateChange=this._onStateChange.event,m.when(R.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(f.State.Disabled(f.DisablementReason.NotBuilt));return}if(this.environmentMainService.disableUpdates){this.setState(f.State.Disabled(f.DisablementReason.DisabledByEnvironment)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(f.State.Disabled(f.DisablementReason.MissingConfiguration)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.configurationService.getValue("update.mode"),p=this.getProductQuality(m);if(!p){this.setState(f.State.Disabled(f.DisablementReason.ManuallyDisabled)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(p),!this.url){this.setState(f.State.Disabled(f.DisablementReason.InvalidConfiguration)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.configurationService.getValue("_update.prss")){const v=new URL(this.url);v.searchParams.set("prss","true"),this.url=v.toString()}if(this.setState(f.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,i.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===f.StateType.Idle&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===f.StateType.AvailableForDownload&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type===f.StateType.Downloaded&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==f.StateType.Ready||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},s.CancellationToken.None)).res.statusCode===204}catch(p){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(p);return}}async _applySpecificUpdate(m){}getUpdateType(){return f.UpdateType.Archive}doQuitAndInstall(){}};e.AbstractUpdateService=y,e.AbstractUpdateService=y=Ie([se(0,R.ILifecycleMainService),se(1,k.IConfigurationService),se(2,A.IEnvironmentMainService),se(3,d.IRequestService),se(4,b.ILogService),se(5,l.IProductService)],y)}),define(le[294],ce([0,1,14,53,3,47,2,18,25,20,5,28,55,24,51,106]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let p=class extends m.AbstractUpdateService{get onRawError(){return P.Event.fromNodeEventEmitter(i.autoUpdater,"error",(w,E)=>E)}get onRawUpdateNotAvailable(){return P.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return P.Event.fromNodeEventEmitter(i.autoUpdater,"update-available")}get onRawUpdateDownloaded(){return P.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",(w,E,I,o)=>({version:I,productVersion:I,timestamp:o}))}constructor(w,E,I,o,t,r,a){super(w,E,o,t,r,a),this.telemetryService=I,this.disposables=new A.DisposableStore,w.setRelaunchHandler(this)}handleRelaunch(w){return w?.addArgs||w?.removeArgs||this.state.type!==h.StateType.Ready?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(w){this.telemetryService.publicLog2("update:error",{messageHash:String((0,k.hash)(String(w)))}),this.logService.error("UpdateService error:",w);const E=this.state.type===h.StateType.CheckingForUpdates&&this.state.explicit?w:void 0;this.setState(h.State.Idle(h.UpdateType.Archive,E))}buildUpdateFeedUrl(w){let E;this.productService.darwinUniversalAssetId?E=this.productService.darwinUniversalAssetId:E=process.arch==="x64"?"darwin":"darwin-arm64";const I=(0,m.createUpdateURL)(E,w,this.productService);try{i.autoUpdater.setFeedURL({url:I})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return I}doCheckForUpdates(w){this.setState(h.State.CheckingForUpdates(w)),i.autoUpdater.checkForUpdates()}onUpdateAvailable(){this.state.type===h.StateType.CheckingForUpdates&&this.setState(h.State.Downloading)}onUpdateDownloaded(w){this.state.type===h.StateType.Downloading&&(this.setState(h.State.Downloaded(w)),this.telemetryService.publicLog2("update:downloaded",{version:w.version}),this.setState(h.State.Ready(w)))}onUpdateNotAvailable(){this.state.type===h.StateType.CheckingForUpdates&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(h.State.Idle(h.UpdateType.Archive)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=p,Ie([s.memoize],p.prototype,"onRawError",null),Ie([s.memoize],p.prototype,"onRawUpdateNotAvailable",null),Ie([s.memoize],p.prototype,"onRawUpdateAvailable",null),Ie([s.memoize],p.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=p=Ie([se(0,l.ILifecycleMainService),se(1,R.IConfigurationService),se(2,y.ITelemetryService),se(3,b.IEnvironmentMainService),se(4,g.IRequestService),se(5,d.ILogService),se(6,f.IProductService)],p)}),define(le[295],ce([0,1,50,44,8,3,9,25,20,5,24,51]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let g=class{get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}constructor(m,p,v){if(this.lifecycleMainService=m,this.logService=v,this._state=f.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event,p.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(f.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,w=>this.logService.error(w))}scheduleCheckForUpdates(m=60*60*1e3){return(0,P.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===f.StateType.Idle&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===f.StateType.AvailableForDownload&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type===f.StateType.Downloaded&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==f.StateType.Ready||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return f.UpdateType.Snap}doQuitAndInstall(){}async _applySpecificUpdate(m){}};g=Ie([se(0,b.ILifecycleMainService),se(1,R.IEnvironmentMainService),se(2,l.ILogService)],g);let y=class extends g{constructor(m,p,v,w,E,I){super(v,w,E),this.snap=m,this.snapRevision=p,this.telemetryService=I;const o=(0,s.watch)(A.dirname(this.snap)),t=k.Event.fromNodeEventEmitter(o,"change",(c,u)=>u),r=k.Event.filter(t,c=>c==="current"),n=k.Event.debounce(r,(c,u)=>u,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{n.dispose(),o.close()})}doCheckForUpdates(){this.setState(f.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(f.State.Ready({version:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(f.State.Idle(f.UpdateType.Snap)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(f.State.Idle(f.UpdateType.Snap,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+A.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((v,w)=>(0,s.realpath)(`${A.dirname(this.snap)}/current`,(E,I)=>E?w(E):v(I))),p=A.basename(m);return this.snapRevision!==p}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=y,e.SnapUpdateService=y=Ie([se(2,b.ILifecycleMainService),se(3,R.IEnvironmentMainService),se(4,l.ILogService),se(5,d.ITelemetryService)],y)}),define(le[29],ce([0,1,14,4,6,52,57,73,28,18,25,9,140]),function(K,e,i,s,P,k,A,R,b,l,d,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.IWindowsMainService=void 0,e.defaultBrowserWindowOptions=h,e.getLastFocused=m,e.IWindowsMainService=(0,P.createDecorator)("windowsMainService");var y;(function(v){v[v.CLI=0]="CLI",v[v.DOCK=1]="DOCK",v[v.MENU=2]="MENU",v[v.DIALOG=3]="DIALOG",v[v.DESKTOP=4]="DESKTOP",v[v.API=5]="API"})(y||(e.OpenContext=y={}));function h(v,w,E){const I=v.get(R.IThemeMainService),o=v.get(b.IProductService),t=v.get(l.IConfigurationService),r=v.get(d.IEnvironmentMainService),a=t.getValue("window"),n={backgroundColor:I.getBackgroundColor(),minWidth:A.WindowMinimumSize.WIDTH,minHeight:A.WindowMinimumSize.HEIGHT,title:o.nameLong,show:w.mode!==k.WindowMode.Maximized&&w.mode!==k.WindowMode.Fullscreen,x:w.x,y:w.y,width:w.width,height:w.height,webPreferences:{...E,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,A.zoomLevelToZoomFactor)(w.zoomLevel??a?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(s.isLinux?n.icon=(0,f.join)(r.appRoot,"resources/linux/code.png"):s.isWindows&&!r.isBuilt&&(n.icon=(0,f.join)(r.appRoot,"resources/win32/code_150x150.png")),s.isMacintosh&&(n.acceptFirstMouse=!0,a?.clickThroughInactive===!1&&(n.acceptFirstMouse=!1)),s.isMacintosh&&!(0,A.useNativeFullScreen)(t)&&(n.fullscreenable=!1),s.isMacintosh&&a?.nativeTabs===!0&&(n.tabbingIdentifier=o.nameShort),!(0,A.hasNativeTitlebar)(t)&&(n.titleBarStyle="hidden",s.isMacintosh||(n.frame=!1),(0,A.useWindowControlsOverlay)(t))){const S=I.getWindowSplash()?.colorInfo.titleBarBackground??I.getBackgroundColor(),D=g.Color.fromHex(S).isDarker()?"#FFFFFF":"#000000";n.titleBarOverlay={height:29,color:S,symbolColor:D}}return n}function m(v){let w,E=Number.MIN_VALUE;for(const I of v)I.lastFocusTime>E&&(E=I.lastFocusTime,w=I);return w}var p;(function(v){function w(I,o,t=i.screen.getAllDisplays()){if(I.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,o),typeof o.x!="number"||typeof o.y!="number"||typeof o.width!="number"||typeof o.height!="number"){I.trace("window#validateWindowState: unexpected type of state values");return}if(o.width<=0||o.height<=0){I.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const n=E(t[0]);if(I.trace("window#validateWindowState: single monitor working area",n),n){let c=function(){!o||typeof o.x!="number"||typeof o.y!="number"||!n||(o.x<n.x&&(o.x=n.x),o.y<n.y&&(o.y=n.y))};c(),o.width>n.width&&(o.width=n.width),o.height>n.height&&(o.height=n.height),o.x>n.x+n.width-128&&(o.x=n.x+n.width-o.width),o.y>n.y+n.height-128&&(o.y=n.y+n.height-o.height),c()}return o}if(o.display&&o.mode===k.WindowMode.Fullscreen){const n=t.find(c=>c.id===o.display);if(n&&typeof n.bounds?.x=="number"&&typeof n.bounds?.y=="number"){I.trace("window#validateWindowState: restoring fullscreen to previous display");const c=(0,k.defaultWindowState)(k.WindowMode.Fullscreen);return c.x=n.bounds.x,c.y=n.bounds.y,c}}let r,a;try{r=i.screen.getDisplayMatching({x:o.x,y:o.y,width:o.width,height:o.height}),a=E(r),I.trace("window#validateWindowState: multi-monitor working area",a)}catch(n){I.error("window#validateWindowState: error finding display for window state",n)}if(r&&a&&o.x+o.width>a.x&&o.y+o.height>a.y&&o.x<a.x+a.width&&o.y<a.y+a.height)return o;I.trace("window#validateWindowState: state is outside of the multi-monitor working area")}v.validateWindowState=w;function E(I){if(I.workArea.width>0&&I.workArea.height>0)return I.workArea;if(I.bounds.width>0&&I.bounds.height>0)return I.bounds}})(p||(e.WindowStateValidator=p={}))}),define(le[296],ce([0,1,14,23,3,47,2,33,97,5,63,87,29]),function(K,e,i,s,P,k,A,R,b,l,d,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let h=class extends A.Disposable{constructor(p,v,w,E){super(),this.logService=p,this.windowsMainService=v,this.encryptionMainService=w,this.applicationStorageMainService=E,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const p=P.Event.fromNodeEventEmitter(i.app,"login",(v,w,E,I,o)=>({event:v,webContents:w,req:E,authInfo:I,callback:o}));this._register(p(this.onLogin,this))}async onLogin({event:p,authInfo:v,req:w,callback:E}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&w.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let I;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),I=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{I=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}E(I?.username,I?.password)}async resolveProxyCredentials(p){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(p);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(p){this.logService.trace("auth#doResolveProxyCredentials - enter",p);const v=String((0,k.hash)({scheme:p.scheme,host:p.host,port:p.port}));let w,E;try{const r=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+v,d.StorageScope.APPLICATION);if(r){const a=JSON.parse(await this.encryptionMainService.decrypt(r));w=a.username,E=a.password}}catch(r){this.logService.error(r)}if(this.state!==y.StoredCredentialsUsed&&typeof w=="string"&&typeof E=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:w,password:E};const I=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!I){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${I.id} to handle proxy login`);const o={authInfo:p,username:this.sessionCredentials?.username??w,password:this.sessionCredentials?.password??E,replyChannel:`vscode:proxyAuthResponse:${(0,R.generateUuid)()}`};I.sendWhenReady("vscode:openProxyAuthenticationDialog",s.CancellationToken.None,o),this.state=y.LoginDialogShown;const t=await new Promise(r=>{const a=async(n,c,u)=>{if(c===o.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${I.id}`),I.win?.webContents.off("ipc-message",a),u){const S={username:u.username,password:u.password};try{if(u.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(S));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+v,D,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+v,d.StorageScope.APPLICATION)}catch(D){this.logService.error(D)}r({username:S.username,password:S.password})}else r(void 0)};I.win?.webContents.on("ipc-message",a)});return this.sessionCredentials=t,t}};e.ProxyAuthHandler=h,e.ProxyAuthHandler=h=Ie([se(0,l.ILogService),se(1,g.IWindowsMainService),se(2,b.IEncryptionMainService),se(3,f.IApplicationStorageMainService)],h)}),define(le[297],ce([0,1,92,204,121,29]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class A extends s.ExtensionHostDebugBroadcastChannel{constructor(b){super(),this.windowsMainService=b}call(b,l,d){return l==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(d[0],d[1]):super.call(b,l,d)}async openExtensionDevelopmentHostWindow(b,l){const d=(0,P.parseArgs)(b,P.OPTIONS);d.debugRenderer=l;const f=d.extensionDevelopmentPath;if(!f)return{success:!1};const[g]=await this.windowsMainService.openExtensionDevelopmentHostWindow(f,{context:k.OpenContext.API,cli:d,forceProfile:d.profile,forceTempProfile:d["profile-temp"]});if(!l)return{success:!0};const y=g.win;if(!y)return{success:!0};const h=y.webContents.debugger;let m=h.isAttached()?1/0:0;const p=(0,i.createServer)(v=>{m++===0&&h.attach();let w=!1;const E=t=>{w||v.write(JSON.stringify(t)+"\0")},I=(t,r,a,n)=>E({method:r,params:a,sessionId:n});y.on("close",()=>{h.removeListener("message",I),v.end(),w=!0}),h.addListener("message",I);let o=Buffer.alloc(0);v.on("data",t=>{o=Buffer.concat([o,t]);for(let r=o.indexOf(0);r!==-1;r=o.indexOf(0)){let a;try{const n=o.slice(0,r).toString("utf8");o=o.slice(r+1),a=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}h.sendCommand(a.method,a.params,a.sessionId).then(n=>E({id:a.id,sessionId:a.sessionId,result:n})).catch(n=>E({id:a.id,sessionId:a.sessionId,error:{code:0,message:n.message}}))}}),v.on("error",t=>{console.error("error on cdp pipe:",t)}),v.on("close",()=>{w=!0,--m===0&&h.detach()})});return await new Promise(v=>p.listen(0,v)),y.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=A}),define(le[298],ce([0,1,14,22,4,7,21,18,67,6,5,133,29]),function(K,e,i,s,P,k,A,R,b,l,d,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,l.createDecorator)(e.ID);let y=class{constructor(m,p,v,w){this.logService=m,this.windowsMainService=p,this.urlService=v,this.configurationService=w}async start(m,p){this.logService.trace("Received data from other instance: ",m,p),P.isMacintosh&&i.app.focus({steal:!0});const v=this.parseOpenUrl(m);if(v.length){let w=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const E=(0,s.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:g.OpenContext.DESKTOP}));E&&(w=E.ready())}w.then(()=>{for(const{uri:E,originalUrl:I}of v)this.urlService.open(E,{originalUrl:I})})}else return this.startOpenWindow(m,p)}parseOpenUrl(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,s.coalesce)(m._urls.map(p=>{try{return{uri:k.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async startOpenWindow(m,p){const v=(0,b.isLaunchedFromCli)(p)?g.OpenContext.CLI:g.OpenContext.DESKTOP;let w=[];const E=m.wait&&m.waitMarkerFilePath?k.URI.file(m.waitMarkerFilePath):void 0,I=m.remote||void 0,o={context:v,cli:m,userEnv:m["preserve-env"]||v===g.OpenContext.CLI?p:void 0,waitMarkerFileURI:E,remoteAuthority:I,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,o);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let t=!1;if(m["new-window"]||o.forceProfile||o.forceTempProfile)t=!0;else if(m["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!P.isMacintosh}if(t)w=await this.windowsMainService.open({...o,forceNewWindow:!0,forceEmpty:!0});else{const r=this.windowsMainService.getLastActiveWindow();r?(this.windowsMainService.openExistingWindow(r,o),w=[r]):w=await this.windowsMainService.open({...o,forceEmpty:!0})}}else w=await this.windowsMainService.open({...o,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(E&&w.length===1&&w[0])return Promise.race([w[0].whenClosedOrLoaded,(0,A.whenDeleted)(E.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=y,e.LaunchMainService=y=Ie([se(0,d.ILogService),se(1,g.IWindowsMainService),se(2,f.IURLService),se(3,R.IConfigurationService)],y)}),define(le[299],ce([0,1,2,20,52,59,30,8,29]),function(K,e,i,s,P,k,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let l=class extends i.Disposable{constructor(f,g,y){super(),this.userDataProfilesService=g,this.windowsMainService=y,this._register(f.onWillLoadWindow(h=>{h.reason===P.LoadReason.LOAD&&this.unsetProfileForWorkspace(h.window)})),this._register(f.onBeforeCloseWindow(h=>this.unsetProfileForWorkspace(h))),this._register(new R.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(f){const g=this.getWorkspace(f),y=this.userDataProfilesService.getProfileForWorkspace(g);y?.isTransient&&(this.userDataProfilesService.unsetWorkspace(g,y.isTransient),y.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(f){return f.openedWorkspace??(0,A.toWorkspaceIdentifier)(f.backupPath,f.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const f=this.userDataProfilesService.getAssociatedEmptyWindows();if(f.length===0)return;const g=this.windowsMainService.getWindows().map(y=>this.getWorkspace(y));for(const y of f)g.some(h=>h.id===y.id)||this.userDataProfilesService.unsetWorkspace(y,!1)}};e.UserDataProfilesHandler=l,e.UserDataProfilesHandler=l=Ie([se(0,s.ILifecycleMainService),se(1,k.IUserDataProfilesMainService),se(2,b.IWindowsMainService)],l)}),define(le[64],ce([0,1,14,2,3,5,319,8,13,29,79,24,20,80,35,4,107]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function w(o){return typeof o.responseWindowId=="number"}let E=class extends s.Disposable{static{v=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(v.all.values())}constructor(t,r,a){super(),this.logService=t,this.telemetryService=r,this.lifecycleMainService=a,this.id=String(++v.ID_COUNTER),this._onStdout=this._register(new P.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new P.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new P.Emitter),this.onMessage=this._onMessage.event,this._onSpawn=this._register(new P.Emitter),this.onSpawn=this._onSpawn.event,this._onExit=this._register(new P.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new P.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0,this.killed=!1}log(t,r){let a;switch(this.configuration?.correlationId?a=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`:a=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`,r){case d.default.Error:this.logService.error(a);break;case d.default.Warning:this.logService.warn(a);break;case d.default.Info:this.logService.trace(a);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",d.default.Error),!1):!0}start(t){const r=this.doStart(t);return r&&t.payload&&this.postMessage(t.payload)&&this.log("payload sent via postMessage()",d.default.Info),r}doStart(t){if(!this.validateCanStart())return!1;this.configuration=t;const r=`${this.configuration.type}-${this.id}`,a=b.FileAccess.asFileUri("bootstrap-fork.js").fsPath,n=this.configuration.args??[],c=this.configuration.execArgv??[],u=this.configuration.allowLoadingUnsignedLibraries,S=this.configuration.forceAllocationsToV8Sandbox,D="pipe",L=this.createEnv(t);return this.log("creating new...",d.default.Info),this.process=i.utilityProcess.fork(a,n,{serviceName:r,env:L,execArgv:c,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:S,stdio:D}),this.registerListeners(this.process,this.configuration,r),!0}createEnv(t){const r=t.env?{...t.env}:{...(0,h.deepClone)(process.env)};r.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(r.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),r.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,m.isWindows&&((0,p.isUNCAccessRestrictionsDisabled)()?r.NODE_DISABLE_UNC_ACCESS_CHECKS="1":r.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,y.removeDangerousEnvVariables)(r);for(const a of Object.keys(r))r[a]=String(r[a]);return r}registerListeners(t,r,a){if(t.stdout){const n=new A.StringDecoder("utf-8");this._register(P.Event.fromNodeEventEmitter(t.stdout,"data")(c=>this._onStdout.fire(typeof c=="string"?c:n.write(c))))}if(t.stderr){const n=new A.StringDecoder("utf-8");this._register(P.Event.fromNodeEventEmitter(t.stderr,"data")(c=>this._onStderr.fire(typeof c=="string"?c:n.write(c))))}this._register(P.Event.fromNodeEventEmitter(t,"message")(n=>this._onMessage.fire(n))),this._register(P.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.processPid=t.pid,typeof t.pid=="number"&&v.all.set(t.pid,{pid:t.pid,name:w(r)?`${r.type} [${r.responseWindowId}]`:r.type}),this.log("successfully created",d.default.Info),this._onSpawn.fire(t.pid)})),this._register(P.Event.fromNodeEventEmitter(t,"exit")(n=>{const c=this.isNormalExit(n)?0:n;this.log(`received exit event with code ${c}`,d.default.Info),this._onExit.fire({pid:this.processPid,code:c,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(P.Event.fromNodeEventEmitter(i.app,"child-process-gone",(n,c)=>({event:n,details:c}))(({details:n})=>{n.type==="Utility"&&n.name===a&&!this.isNormalExit(n.exitCode)&&(this.log(`crashed with code ${n.exitCode} and reason '${n.reason}'`,d.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:r.type,reason:n.reason,code:n.exitCode}),this._onCrash.fire({pid:this.processPid,code:n.exitCode,reason:n.reason}),this.onDidExitOrCrashOrKill())}))}once(t,r){const a=this._register(this._onMessage.event(n=>{n===t&&(a.dispose(),r())}))}postMessage(t,r){return this.process?(this.process.postMessage(t,r),!0):!1}connect(t){const{port1:r,port2:a}=new i.MessageChannelMain;return this.postMessage(t,[a]),r}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",d.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",d.default.Info),this.process.kill()?(this.log("successfully killed the process",d.default.Info),this.killed=!0,this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",d.default.Warning)}isNormalExit(t){return t===0?!0:this.killed&&t===15}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&v.all.delete(this.processPid),this.process=void 0}async waitForExit(t){this.process&&(this.log("waiting to exit...",d.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,R.timeout)(t)]),this.process&&(this.log(`did not exit within ${t}ms, will kill it now...`,d.default.Info),this.kill()))}};e.UtilityProcess=E,e.UtilityProcess=E=v=Ie([se(0,k.ILogService),se(1,f.ITelemetryService),se(2,g.ILifecycleMainService)],E);let I=class extends E{constructor(t,r,a,n){super(t,a,n),this.windowsMainService=r}start(t){const r=this.windowsMainService.getWindowById(t.responseWindowId);if(!r?.win||r.win.isDestroyed()||r.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",d.default.Error),!0;if(!super.doStart(t))return!1;this.registerWindowListeners(r.win,t);const n=this.connect(t.payload);return r.win.webContents.postMessage(t.responseChannel,t.responseNonce,[n]),!0}registerWindowListeners(t,r){r.windowLifecycleBound&&(this._register(P.Event.filter(this.lifecycleMainService.onWillLoadWindow,a=>a.window.win===t)(()=>this.kill())),this._register(P.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=I,e.WindowUtilityProcess=I=Ie([se(0,k.ILogService),se(1,l.IWindowsMainService),se(2,f.ITelemetryService),se(3,g.ILifecycleMainService)],I)}),define(le[300],ce([0,1,16,3,5,20,8,64,29,24]),function(K,e,i,s,P,k,A,R,b,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let f=class{static{d=this}static{this._lastId=0}constructor(y,h,m,p){this._logService=y,this._lifecycleMainService=h,this._windowsMainService=m,this._telemetryService=p,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(v=>{this._shutdown=!0,v.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(y){const h=this._extHosts.get(y);if(!h)throw new Error("Unknown extension host!");return h}onDynamicStdout(y){return this._getExtHost(y).onStdout}onDynamicStderr(y){return this._getExtHost(y).onStderr}onDynamicMessage(y){return this._getExtHost(y).onMessage}onDynamicExit(y){return this._getExtHost(y).onExit}async createExtensionHost(){if(this._shutdown)throw(0,i.canceled)();const y=String(++d._lastId),h=new R.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(y,h),h.onExit(({pid:m,code:p,signal:v})=>{this._logService.info(`Extension host with pid ${m} exited with code: ${p}, signal: ${v}.`),setTimeout(()=>{h.dispose(),this._extHosts.delete(y)}),setTimeout(()=>{try{process.kill(m,0),this._logService.error(`Extension host with pid ${m} still exists, forcefully killing it...`),process.kill(m)}catch{}},1e3)}),{id:y}}async start(y,h){if(this._shutdown)throw(0,i.canceled)();const m=this._getExtHost(y);return m.start({...h,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:h.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y}),{pid:await s.Event.toPromise(m.onSpawn)}}async enableInspectPort(y){if(this._shutdown)throw(0,i.canceled)();const h=this._extHosts.get(y);return h?h.enableInspectPort():!1}async kill(y){if(this._shutdown)throw(0,i.canceled)();const h=this._extHosts.get(y);h&&h.kill()}async _killAllNow(){for(const[,y]of this._extHosts)y.kill()}async _waitForAllExit(y){const h=[];for(const[,m]of this._extHosts)h.push(m.waitForExit(y));return A.Promises.settled(h).then(()=>{})}};e.ExtensionHostStarter=f,e.ExtensionHostStarter=f=d=Ie([se(0,P.ILogService),se(1,k.ILifecycleMainService),se(2,b.IWindowsMainService),se(3,l.ITelemetryService)],f)}),define(le[301],ce([0,1,37,8,2,25,20,5,43,41,70,64,56,95,12,252,3]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let v=class extends P.Disposable{constructor(E,I,o,t,r,a,n,c,u){super(),this.machineId=E,this.sqmId=I,this.devDeviceId=o,this.environmentMainService=t,this.userDataProfilesService=r,this.lifecycleMainService=a,this.logService=n,this.loggerMainService=c,this.policyService=u,this.firstWindowConnectionBarrier=new s.Barrier,this.utilityProcess=void 0,this.utilityProcessLogListener=void 0,this._onDidCrash=this._register(new p.Emitter),this.onDidCrash=this._onDidCrash.event,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){i.validatedIpcMain.on(m.SharedProcessChannelConnection.request,(E,I)=>this.onWindowConnection(E,I,m.SharedProcessChannelConnection.response)),i.validatedIpcMain.on(m.SharedProcessRawConnection.request,(E,I)=>this.onWindowConnection(E,I,m.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(E,I,o){this.logService.trace(`[SharedProcess] onWindowConnection for: ${o}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const t=await this.connect(o);if(E.sender.isDestroyed())return t.close();E.sender.postMessage(o,I,[t])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(m.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const E=new s.DeferredPromise;this.utilityProcess?.once(m.SharedProcessLifecycle.initDone,()=>E.complete()),await E.p,this.utilityProcessLogListener?.dispose(),this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const E=new s.DeferredPromise;this.utilityProcess?.once(m.SharedProcessLifecycle.ipcReady,()=>E.complete()),await E.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new f.UtilityProcess(this.logService,g.NullTelemetryService,this.lifecycleMainService)),this.utilityProcessLogListener=this.utilityProcess.onMessage(o=>{typeof o.warning=="string"?this.logService.warn(o.warning):typeof o.error=="string"&&this.logService.error(o.error)});const E=(0,y.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let I;E.port&&(I=["--nolazy"],E.break?I.push(`--inspect-brk=${E.port}`):I.push(`--inspect=${E.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:I}),this._register(this.utilityProcess.onCrash(()=>this._onDidCrash.fire()))}createSharedProcessConfiguration(){return{machineId:this.machineId,sqmId:this.sqmId,devDeviceId:this.devDeviceId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(E){return await this.whenIpcReady,(0,h.assertIsDefined)(this.utilityProcess).connect(E)}};e.SharedProcess=v,e.SharedProcess=v=Ie([se(3,k.IEnvironmentMainService),se(4,b.IUserDataProfilesService),se(5,A.ILifecycleMainService),se(6,R.ILogService),se(7,d.ILoggerMainService),se(8,l.IPolicyService)],v)}),define(le[302],ce([0,1,25,95,20,5,56,72,64,119,37,2,3,35,18,13]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let p=class extends f.Disposable{constructor(w,E,I,o,t){super(),this._reconnectConstants=w,this._configurationService=E,this._environmentMainService=I,this._lifecycleMainService=o,this._logService=t,this.utilityProcess=void 0,this._onRequestConnection=new g.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new g.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),d.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(r,a)=>this._onWindowConnection(r,a)),this._register((0,f.toDisposable)(()=>{d.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new b.UtilityProcess(this._logService,A.NullTelemetryService,this._lifecycleMainService);const w=(0,s.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),E=w.port?["--nolazy",`--inspect${w.break?"-brk":""}=${w.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:E,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const I=this.utilityProcess.connect(),o=new l.Client(I,"ptyHost"),t=new f.DisposableStore;return t.add(o),t.add((0,f.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:o,store:t,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const w={...(0,y.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},E=this._configurationService.getValue(R.TerminalSettingId.DeveloperPtyHostLatency);E&&typeof E=="number"&&(w.VSCODE_LATENCY=String(E));const I=this._configurationService.getValue(R.TerminalSettingId.DeveloperPtyHostStartupDelay);return I&&typeof I=="number"&&(w.VSCODE_STARTUP_DELAY=String(I)),this._environmentMainService.restoreSnapExportedVariables(),w}_onWindowConnection(w,E){this._onRequestConnection.fire();const I=this.utilityProcess.connect();if(w.sender.isDestroyed()){I.close();return}w.sender.postMessage("vscode:createPtyHostMessageChannelResult",E,[I])}};e.ElectronPtyHostStarter=p,e.ElectronPtyHostStarter=p=Ie([se(1,h.IConfigurationService),se(2,i.IEnvironmentMainService),se(3,P.ILifecycleMainService),se(4,k.ILogService)],p)}),define(le[303],ce([0,1,2,6,5,29,64,24,47,3,8,20]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,s.createDecorator)("utilityProcessWorker");let g=class extends i.Disposable{constructor(m,p,v,w){super(),this.logService=m,this.windowsMainService=p,this.telemetryService=v,this.lifecycleMainService=w,this.workers=new Map}async createWorker(m){const p=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${p})`);const v=this.hash(m);this.workers.has(v)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(m));const w=new y(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,m);if(!w.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(v,w);const E=new d.DeferredPromise;return l.Event.once(w.onDidTerminate)(I=>{I.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${I.code}, signal: ${I.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${I.code}, signal: ${I.signal}`),this.workers.delete(v),E.complete({reason:I})}),E.p}hash(m){return(0,b.hash)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const p=this.hash(m),v=this.workers.get(p);v&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),v.kill(),v.dispose(),this.workers.delete(p))}};e.UtilityProcessWorkerMainService=g,e.UtilityProcessWorkerMainService=g=Ie([se(0,P.ILogService),se(1,k.IWindowsMainService),se(2,R.ITelemetryService),se(3,f.ILifecycleMainService)],g);let y=class extends i.Disposable{constructor(m,p,v,w,E){super(),this.logService=m,this.windowsMainService=p,this.telemetryService=v,this.lifecycleMainService=w,this.configuration=E,this._onDidTerminate=this._register(new l.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=this._register(new A.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService)),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(m=>this._onDidTerminate.fire({code:m.code,signal:m.signal}))),this._register(this.utilityProcess.onCrash(m=>this._onDidTerminate.fire({code:m.code,signal:"ECRASH"})))}spawn(){const p=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};y=Ie([se(0,P.ILogService),se(1,k.IWindowsMainService),se(2,R.ITelemetryService),se(3,f.ILifecycleMainService)],y)}),define(le[304],ce([0,1,14,3,2,277,29]),function(K,e,i,s,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let R=class extends P.Disposable{constructor(l){super(),this.windowsMainService=l,this._onFoundInFrame=this._register(new s.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new k.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(l,d){let f;if(typeof l.windowId=="number"){const{windowId:g}=l,y=this.windowsMainService.getWindowById(g);if(!y?.win)throw new Error(`Invalid windowId: ${g}`);f=y.win.webContents}else{const{webContentsId:g}=l;if(f=i.webContents.fromId(g),!f)throw new Error(`Invalid webContentsId: ${g}`)}f.isDestroyed()||f.setIgnoreMenuShortcuts(d)}async findInFrame(l,d,f,g){const h=this.getFrameByName(l,d);if(typeof h.findInFrame=="function"){h.findInFrame(f,{findNext:g.findNext,forward:g.forward});const m=(p,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),h.removeListener("found-in-frame",m))};h.on("found-in-frame",m)}}async stopFindInFrame(l,d,f){const y=this.getFrameByName(l,d);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(f.keepSelection?"keepSelection":"clearSelection")}getFrameByName(l,d){const f=this.windowsMainService.getWindowById(l.windowId);if(!f?.win)throw new Error(`Invalid windowId: ${l}`);const g=f.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===d);if(!g)throw new Error(`Unknown frame: ${d}`);return g}};e.WebviewMainService=R,e.WebviewMainService=R=Ie([se(0,A.IWindowsMainService)],R)}),define(le[305],ce([0,1,14,2,4,19,7,18,20,5,34,29,52,30]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsStateHandler=void 0,e.restoreWindowsState=p,e.getWindowsStateStoreData=w;let m=class extends s.Disposable{static{h=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(o,t,r,a,n){super(),this.windowsMainService=o,this.stateService=t,this.lifecycleMainService=r,this.logService=a,this.configurationService=n,this._state=p(this.stateService.getItem(h.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){i.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(o=>this.onBeforeCloseWindow(o)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(o=>{o.newCount-o.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(o=>this.onBeforeCloseWindow(o))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const o=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!t.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(c=>!c.isExtensionDevelopmentHost)),n&&(t.lastActiveWindow=this.toWindowState(n),t.lastActiveWindow.uiState.mode===g.WindowMode.Fullscreen&&o.add(t.lastActiveWindow.uiState.display))}const r=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);r&&(t.lastPluginDevelopmentHostWindow=this.toWindowState(r),t.lastPluginDevelopmentHostWindow.uiState.mode===g.WindowMode.Fullscreen&&(o.has(t.lastPluginDevelopmentHostWindow.uiState.display)?P.isMacintosh&&!r.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=g.WindowMode.Normal):o.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(t.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const c=this.toWindowState(n);return c.uiState.mode===g.WindowMode.Fullscreen&&(o.has(c.uiState.display)?P.isMacintosh&&c.windowId!==t.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(c.uiState.mode=g.WindowMode.Normal):o.add(c.uiState.display)),c}));const a=w(t);this.stateService.setItem(h.windowsStateStorageKey,a),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",a)}onBeforeCloseWindow(o){if(this.lifecycleMainService.quitRequested)return;const t=this.toWindowState(o);o.isExtensionDevelopmentHost&&!o.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=t:!o.isExtensionDevelopmentHost&&o.openedWorkspace&&this._state.openedWindows.forEach(r=>{const a=(0,y.isWorkspaceIdentifier)(o.openedWorkspace)&&r.workspace?.id===o.openedWorkspace.id,n=(0,y.isSingleFolderWorkspaceIdentifier)(o.openedWorkspace)&&r.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(r.folderUri,o.openedWorkspace.uri);(a||n)&&(r.uiState=t.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=t)}toWindowState(o){return{windowId:o.id,workspace:(0,y.isWorkspaceIdentifier)(o.openedWorkspace)?o.openedWorkspace:void 0,folderUri:(0,y.isSingleFolderWorkspaceIdentifier)(o.openedWorkspace)?o.openedWorkspace.uri:void 0,backupPath:o.backupPath,remoteAuthority:o.remoteAuthority,uiState:o.serializeWindowState()}}getNewWindowState(o){const t=this.doGetNewWindowState(o),r=this.configurationService.getValue("window");if(t.mode===g.WindowMode.Fullscreen){let a;t.hasDefaultState?a=!!(r?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(r.newWindowDimensions)>=0):a=!!(this.lifecycleMainService.wasRestarted||r?.restoreFullscreen),a||(t.mode=g.WindowMode.Normal)}return t}doGetNewWindowState(o){const t=this.windowsMainService.getLastActiveWindow();if(!o.extensionTestsPath){if(o.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const S=o.workspace;if((0,y.isWorkspaceIdentifier)(S)){const L=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===S.id).map(M=>M.uiState);if(L.length)return L[0]}if((0,y.isSingleFolderWorkspaceIdentifier)(S)){const L=this.state.openedWindows.filter(M=>M.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(M.folderUri,S.uri)).map(M=>M.uiState);if(L.length)return L[0]}else if(o.backupPath){const L=this.state.openedWindows.filter(M=>M.backupPath===o.backupPath).map(M=>M.uiState);if(L.length)return L[0]}const D=this.lastClosedState||this.state.lastActiveWindow;if(!t&&D)return D.uiState}let r;const a=i.screen.getAllDisplays();if(a.length===1)r=a[0];else{if(P.isMacintosh){const S=i.screen.getCursorScreenPoint();r=i.screen.getDisplayNearestPoint(S)}!r&&t&&(r=i.screen.getDisplayMatching(t.getBounds())),r||(r=i.screen.getPrimaryDisplay()||a[0])}let n=(0,g.defaultWindowState)();n.x=Math.round(r.bounds.x+r.bounds.width/2-n.width/2),n.y=Math.round(r.bounds.y+r.bounds.height/2-n.height/2);const c=this.configurationService.getValue("window");let u=!0;if(c?.newWindowDimensions){if(c.newWindowDimensions==="maximized")n.mode=g.WindowMode.Maximized,u=!1;else if(c.newWindowDimensions==="fullscreen")n.mode=g.WindowMode.Fullscreen,u=!1;else if((c.newWindowDimensions==="inherit"||c.newWindowDimensions==="offset")&&t){const S=t.serializeWindowState();S.mode===g.WindowMode.Fullscreen?n.mode=g.WindowMode.Fullscreen:n={...S,zoomLevel:void 0},u=n.mode!==g.WindowMode.Fullscreen&&c.newWindowDimensions==="offset"}}return u&&(n=this.ensureNoOverlap(n)),n.hasDefaultState=!0,n}ensureNoOverlap(o){if(this.windowsMainService.getWindows().length===0)return o;o.x=typeof o.x=="number"?o.x:0,o.y=typeof o.y=="number"?o.y:0;const t=this.windowsMainService.getWindows().map(r=>r.getBounds());for(;t.some(r=>r.x===o.x||r.y===o.y);)o.x+=30,o.y+=30;return o}};e.WindowsStateHandler=m,e.WindowsStateHandler=m=h=Ie([se(0,f.IWindowsMainService),se(1,d.IStateService),se(2,b.ILifecycleMainService),se(3,l.ILogService),se(4,R.IConfigurationService)],m);function p(I){const o={openedWindows:[]},t=I||{openedWindows:[]};return t.lastActiveWindow&&(o.lastActiveWindow=v(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(o.lastPluginDevelopmentHostWindow=v(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(o.openedWindows=t.openedWindows.map(r=>v(r))),o}function v(I){const o={uiState:I.uiState};return I.backupPath&&(o.backupPath=I.backupPath),I.remoteAuthority&&(o.remoteAuthority=I.remoteAuthority),I.folder&&(o.folderUri=A.URI.parse(I.folder)),I.workspaceIdentifier&&(o.workspace={id:I.workspaceIdentifier.id,configPath:A.URI.parse(I.workspaceIdentifier.configURIPath)}),o}function w(I){return{lastActiveWindow:I.lastActiveWindow&&E(I.lastActiveWindow),lastPluginDevelopmentHostWindow:I.lastPluginDevelopmentHostWindow&&E(I.lastPluginDevelopmentHostWindow),openedWindows:I.openedWindows.map(o=>E(o))}}function E(I){return{workspaceIdentifier:I.workspace&&{id:I.workspace.id,configURIPath:I.workspace.configPath.toString()},folder:I.folderUri&&I.folderUri.toString(),backupPath:I.backupPath,remoteAuthority:I.remoteAuthority,uiState:I.uiState}}}),define(le[60],ce([0,1,14,3,40,2,13,9,19,21,200,68,58,25,6,5,59,135,30,103,104]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,h.createDecorator)("workspacesManagementMainService");let o=class extends k.Disposable{constructor(r,a,n,c,u){super(),this.environmentMainService=r,this.logService=a,this.userDataProfilesMainService=n,this.backupMainService=c,this.dialogMainService=u,this._onDidDeleteUntitledWorkspace=this._register(new s.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new s.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const r=(await l.Promises.readdir(this.untitledWorkspacesHome.with({scheme:A.Schemas.file}).fsPath)).map(a=>(0,b.joinPath)(this.untitledWorkspacesHome,a,w.UNTITLED_WORKSPACE_NAME));for(const a of r){const n=(0,I.getWorkspaceIdentifier)(a),c=await this.resolveLocalWorkspace(a);c?this.untitledWorkspaces.push({workspace:n,remoteAuthority:c.remoteAuthority}):await this.deleteUntitledWorkspace(n)}}catch(r){r.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${r}).`)}}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,a=>l.Promises.readFile(a,"utf8"))}doResolveLocalWorkspace(r,a){if(this.isWorkspacePath(r)&&r.scheme===A.Schemas.file)try{const n=a(r.fsPath);return n instanceof Promise?n.then(c=>this.doResolveWorkspace(r,c),c=>{}):this.doResolveWorkspace(r,n)}catch{return}}isWorkspacePath(r){return(0,w.isUntitledWorkspace)(r,this.environmentMainService)||(0,w.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,a){try{const n=this.doParseStoredWorkspace(r,a),c=(0,I.getWorkspaceIdentifier)(r);return{id:c.id,configPath:c.configPath,folders:(0,E.toWorkspaceFolders)(n.folders,c.configPath,b.extUriBiasedIgnorePathCase),remoteAuthority:n.remoteAuthority,transient:n.transient}}catch(n){this.logService.warn(n.toString())}}doParseStoredWorkspace(r,a){const n=(0,P.parse)(a);if(n&&Array.isArray(n.folders))n.folders=n.folders.filter(c=>(0,E.isStoredWorkspaceFolder)(c));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return n}async createUntitledWorkspace(r,a){const{workspace:n,storedWorkspace:c}=this.newUntitledWorkspace(r,a),u=n.configPath.fsPath;return await l.Promises.mkdir((0,R.dirname)(u),{recursive:!0}),await l.Promises.writeFile(u,JSON.stringify(c,null,"	")),this.untitledWorkspaces.push({workspace:n,remoteAuthority:a}),n}newUntitledWorkspace(r=[],a){const n=(Date.now()+Math.round(Math.random()*1e3)).toString(),c=(0,b.joinPath)(this.untitledWorkspacesHome,n),u=(0,b.joinPath)(c,w.UNTITLED_WORKSPACE_NAME),S=[];for(const D of r)S.push((0,E.getStoredWorkspaceFolder)(D.uri,!0,D.name,c,b.extUriBiasedIgnorePathCase));return{workspace:(0,I.getWorkspaceIdentifier)(u),storedWorkspace:{folders:S,remoteAuthority:a}}}async getWorkspaceIdentifier(r){return(0,I.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,w.isUntitledWorkspace)(r.configPath,this.environmentMainService)}async deleteUntitledWorkspace(r){this.isUntitledWorkspace(r)&&(await this.doDeleteUntitledWorkspace(r),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(r),this._onDidDeleteUntitledWorkspace.fire(r))}async doDeleteUntitledWorkspace(r){const a=(0,b.originalFSPath)(r.configPath);try{await l.Promises.rm((0,R.dirname)(a));const n=(0,R.join)(this.environmentMainService.workspaceStorageHome.with({scheme:A.Schemas.file}).fsPath,r.id);await l.Promises.exists(n)&&await l.Promises.writeFile((0,R.join)(n,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(c=>c.workspace.id!==r.id)}catch(n){this.logService.warn(`Unable to delete untitled workspace ${a} (${n}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(r,a,n){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,a,n))return;const u=await this.doEnterWorkspace(r,(0,I.getWorkspaceIdentifier)(n));if(u)return this._onDidEnterWorkspace.fire({window:r,workspace:u.workspace}),u}async isValidTargetWorkspacePath(r,a,n){return n?(0,w.isWorkspaceIdentifier)(r.openedWorkspace)&&b.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,n)?!1:(0,v.findWindowOnWorkspaceOrFolder)(a,n)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:(0,d.localize)(1,null,(0,b.basename)(n)),detail:(0,d.localize)(2,null)},i.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(r,a){if(!r.config)return;r.focus();let n;return r.config.extensionDevelopmentPath||(r.config.backupPath?n=await this.backupMainService.registerWorkspaceBackup({workspace:a,remoteAuthority:r.remoteAuthority},r.config.backupPath):n=this.backupMainService.registerWorkspaceBackup({workspace:a,remoteAuthority:r.remoteAuthority})),(0,w.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=a,r.config.backupPath=n,{workspace:a,backupPath:n}}};e.WorkspacesManagementMainService=o,e.WorkspacesManagementMainService=o=Ie([se(0,y.IEnvironmentMainService),se(1,m.ILogService),se(2,p.IUserDataProfilesMainService),se(3,f.IBackupMainService),se(4,g.IDialogMainService)],o)}),define(le[136],ce([0,1,14,37,23,6,29,30,60,12,5,64]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,k.createDecorator)(e.ID);let g=class{constructor(h,m,p){this.windowsMainService=h,this.workspacesManagementMainService=m,this.logService=p}async getRemoteDiagnostics(h){const m=this.windowsMainService.getWindows();return(await Promise.all(m.map(async v=>{const w=v.remoteAuthority;if(!w)return;const E=`vscode:getDiagnosticInfoResponse${v.id}`,I={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.getFolderURIs(v):void 0};return new Promise(o=>{v.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:E,args:I}),s.validatedIpcMain.once(E,(t,r)=>{r||o({hostName:w,errorMessage:`Unable to resolve connection to '${w}'.`}),o(r)}),setTimeout(()=>{o({hostName:w,errorMessage:`Connection to '${w}' could not be established`})},5e3)})}))).filter(v=>!!v)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const h=[];for(const p of i.BrowserWindow.getAllWindows()){const v=this.windowsMainService.getWindowById(p.id);v?h.push(await this.codeWindowToInfo(v)):h.push(this.browserWindowToInfo(p))}const m=[];for(const{pid:p,name:v}of f.UtilityProcess.getAll())m.push({pid:p,name:v});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,pidToNames:m,screenReader:!!i.app.accessibilitySupportEnabled,gpuFeatureStatus:i.app.getGPUFeatureStatus()}}async codeWindowToInfo(h){const m=await this.getFolderURIs(h),p=(0,l.assertIsDefined)(h.win);return this.browserWindowToInfo(p,m,h.remoteAuthority)}browserWindowToInfo(h,m=[],p){return{id:h.id,pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:m,remoteAuthority:p}}async getFolderURIs(h){const m=[],p=h.openedWorkspace;if((0,R.isSingleFolderWorkspaceIdentifier)(p))m.push(p.uri);else if((0,R.isWorkspaceIdentifier)(p)){const v=await this.workspacesManagementMainService.resolveLocalWorkspace(p.configPath);v&&v.folders.forEach(E=>{m.push(E.uri)})}return m}};e.DiagnosticsMainService=g,e.DiagnosticsMainService=g=Ie([se(0,A.IWindowsMainService),se(1,b.IWorkspacesManagementMainService),se(2,d.ILogService)],g)}),define(le[74],ce([0,1,50,14,27,161,53,3,2,13,9,4,7,114,93,21,112,188,58,25,6,20,5,28,73,29,30,60,17,248,240,83,16]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I,o,t,r,a,n,c,u,S,D,L,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,I.createDecorator)("nativeHostMainService");let C=class extends b.Disposable{constructor(x,U,z,re,ie,oe,G,te,q){super(),this.windowsMainService=x,this.auxiliaryWindowsMainService=U,this.dialogMainService=z,this.lifecycleMainService=re,this.environmentMainService=ie,this.logService=oe,this.productService=G,this.themeMainService=te,this.workspacesManagementMainService=q,this.onDidOpenMainWindow=R.Event.map(this.windowsMainService.onDidOpenWindow,O=>O.id),this.onDidTriggerWindowSystemContextMenu=R.Event.any(R.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:O,x:B,y:V})=>({windowId:O.id,x:B,y:V})),R.Event.map(this.auxiliaryWindowsMainService.onDidTriggerSystemContextMenu,({window:O,x:B,y:V})=>({windowId:O.id,x:B,y:V}))),this.onDidMaximizeWindow=R.Event.any(R.Event.map(this.windowsMainService.onDidMaximizeWindow,O=>O.id),R.Event.map(this.auxiliaryWindowsMainService.onDidMaximizeWindow,O=>O.id)),this.onDidUnmaximizeWindow=R.Event.any(R.Event.map(this.windowsMainService.onDidUnmaximizeWindow,O=>O.id),R.Event.map(this.auxiliaryWindowsMainService.onDidUnmaximizeWindow,O=>O.id)),this.onDidChangeWindowFullScreen=R.Event.any(R.Event.map(this.windowsMainService.onDidChangeFullScreen,O=>({windowId:O.window.id,fullscreen:O.fullscreen})),R.Event.map(this.auxiliaryWindowsMainService.onDidChangeFullScreen,O=>({windowId:O.window.id,fullscreen:O.fullscreen}))),this.onDidBlurMainWindow=R.Event.filter(R.Event.fromNodeEventEmitter(s.app,"browser-window-blur",(O,B)=>B.id),O=>!!this.windowsMainService.getWindowById(O)),this.onDidFocusMainWindow=R.Event.any(R.Event.map(R.Event.filter(R.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),O=>!!O),O=>O.id),R.Event.filter(R.Event.fromNodeEventEmitter(s.app,"browser-window-focus",(O,B)=>B.id),O=>!!this.windowsMainService.getWindowById(O))),this.onDidBlurMainOrAuxiliaryWindow=R.Event.any(this.onDidBlurMainWindow,R.Event.map(R.Event.filter(R.Event.fromNodeEventEmitter(s.app,"browser-window-blur",(O,B)=>this.auxiliaryWindowsMainService.getWindowByWebContents(B.webContents)),O=>!!O),O=>O.id)),this.onDidFocusMainOrAuxiliaryWindow=R.Event.any(this.onDidFocusMainWindow,R.Event.map(R.Event.filter(R.Event.fromNodeEventEmitter(s.app,"browser-window-focus",(O,B)=>this.auxiliaryWindowsMainService.getWindowByWebContents(B.webContents)),O=>!!O),O=>O.id)),this.onDidResumeOS=R.Event.fromNodeEventEmitter(s.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new R.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=R.Event.debounce(R.Event.any(R.Event.filter(R.Event.fromNodeEventEmitter(s.screen,"display-metrics-changed",(O,B,V)=>V),O=>!(Array.isArray(O)&&O.length===1&&O[0]==="workArea")),R.Event.fromNodeEventEmitter(s.screen,"display-added"),R.Event.fromNodeEventEmitter(s.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(x,U){const z=this.windowsMainService.getWindows().map(ie=>({id:ie.id,workspace:ie.openedWorkspace??(0,c.toWorkspaceIdentifier)(ie.backupPath,ie.isExtensionDevelopmentHost),title:ie.win?.getTitle()??"",filename:ie.getRepresentedFilename(),dirty:ie.isDocumentEdited()})),re=[];return U.includeAuxiliaryWindows&&re.push(...this.auxiliaryWindowsMainService.getWindows().map(ie=>({id:ie.id,parentId:ie.parentId,title:ie.win?.getTitle()??"",filename:ie.getRepresentedFilename()}))),[...z,...re]}async getWindowCount(x){return this.windowsMainService.getWindowCount()}async getActiveWindowId(x){const U=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(x,U,z){return Array.isArray(U)?this.doOpenWindow(x,U,z):this.doOpenEmptyWindow(x,U)}async doOpenWindow(x,U,z=Object.create(null)){U.length>0&&await this.windowsMainService.open({context:n.OpenContext.API,contextWindowId:x,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async doOpenEmptyWindow(x,U){await this.windowsMainService.openEmptyWindow({context:n.OpenContext.API,contextWindowId:x},U)}async isFullScreen(x,U){return this.windowById(U?.targetWindowId,x)?.isFullScreen??!1}async toggleFullScreen(x,U){this.windowById(U?.targetWindowId,x)?.toggleFullScreen()}async handleTitleDoubleClick(x,U){this.windowById(U?.targetWindowId,x)?.handleTitleDoubleClick()}async getCursorScreenPoint(x){const U=s.screen.getCursorScreenPoint(),z=s.screen.getDisplayNearestPoint(U);return{point:U,display:z.bounds}}async isMaximized(x,U){return this.windowById(U?.targetWindowId,x)?.win?.isMaximized()??!1}async maximizeWindow(x,U){this.windowById(U?.targetWindowId,x)?.win?.maximize()}async unmaximizeWindow(x,U){this.windowById(U?.targetWindowId,x)?.win?.unmaximize()}async minimizeWindow(x,U){this.windowById(U?.targetWindowId,x)?.win?.minimize()}async moveWindowTop(x,U){this.windowById(U?.targetWindowId,x)?.win?.moveTop()}async positionWindow(x,U,z){const re=this.windowById(z?.targetWindowId,x);if(re?.win){if(re.win.isFullScreen()){const ie=R.Event.toPromise(R.Event.once(R.Event.fromNodeEventEmitter(re.win,"leave-full-screen")));re.win.setFullScreen(!1),await ie}re.win.setBounds(U)}}async updateWindowControls(x,U){this.windowById(U?.targetWindowId,x)?.updateWindowControls(U)}async focusWindow(x,U){this.windowById(U?.targetWindowId,x)?.focus({force:U?.force??!1})}async setMinimumSize(x,U,z){const re=this.codeWindowById(x);if(re?.win){const[ie,oe]=re.win.getSize(),[G,te]=re.win.getMinimumSize(),[q,O]=[U??G,z??te],[B,V]=[Math.max(ie,q),Math.max(oe,O)];(G!==q||te!==O)&&re.win.setMinimumSize(q,O),(ie!==B||oe!==V)&&re.win.setSize(B,V)}}async saveWindowSplash(x,U){this.themeMainService.saveWindowSplash(x,U)}async installShellCommand(x){const{source:U,target:z}=await this.getShellCommandLink();try{const{symbolicLink:re}=await m.SymlinkSupport.stat(U);if(re&&!re.dangling){const ie=await(0,y.realpath)(U);if(z===ie)return}await m.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await m.Promises.symlink(z,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:ie}=await this.showMessageBox(x,{type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,v.localize)(1,null),(0,v.localize)(2,null)]});if(ie===1)throw new T.CancellationError;try{const oe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${U}'\\" with administrator privileges"`;await(0,k.promisify)(i.exec)(oe)}catch{throw new Error((0,v.localize)(3,null,U))}}}async uninstallShellCommand(x){const{source:U}=await this.getShellCommandLink();try{await m.Promises.unlink(U)}catch(z){switch(z.code){case"EACCES":{const{response:re}=await this.showMessageBox(x,{type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,v.localize)(5,null),(0,v.localize)(6,null)]});if(re===1)throw new T.CancellationError;try{const ie=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,k.promisify)(i.exec)(ie)}catch{throw new Error((0,v.localize)(7,null,U))}break}case"ENOENT":break;default:throw z}}}async getShellCommandLink(){const x=(0,d.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await m.Promises.exists(x))throw new Error((0,v.localize)(8,null,x));return{source:U,target:x}}async showMessageBox(x,U){const z=this.windowById(U?.targetWindowId,x);return this.dialogMainService.showMessageBox(U,z?.win??void 0)}async showSaveDialog(x,U){const z=this.windowById(U?.targetWindowId,x);return this.dialogMainService.showSaveDialog(U,z?.win??void 0)}async showOpenDialog(x,U){const z=this.windowById(U?.targetWindowId,x);return this.dialogMainService.showOpenDialog(U,z?.win??void 0)}async pickFileFolderAndOpen(x,U){const z=await this.dialogMainService.pickFileFolder(U);z&&await this.doOpenPicked(await Promise.all(z.map(async re=>await m.SymlinkSupport.existsDirectory(re)?{folderUri:g.URI.file(re)}:{fileUri:g.URI.file(re)})),U,x)}async pickFolderAndOpen(x,U){const z=await this.dialogMainService.pickFolder(U);z&&await this.doOpenPicked(z.map(re=>({folderUri:g.URI.file(re)})),U,x)}async pickFileAndOpen(x,U){const z=await this.dialogMainService.pickFile(U);z&&await this.doOpenPicked(z.map(re=>({fileUri:g.URI.file(re)})),U,x)}async pickWorkspaceAndOpen(x,U){const z=await this.dialogMainService.pickWorkspace(U);z&&await this.doOpenPicked(z.map(re=>({workspaceUri:g.URI.file(re)})),U,x)}async doOpenPicked(x,U,z){await this.windowsMainService.open({context:n.OpenContext.DIALOG,contextWindowId:z,cli:this.environmentMainService.args,urisToOpen:x,forceNewWindow:U.forceNewWindow})}async showItemInFolder(x,U){s.shell.showItemInFolder(U)}async setRepresentedFilename(x,U,z){this.windowById(z?.targetWindowId,x)?.setRepresentedFilename(U)}async setDocumentEdited(x,U,z){this.windowById(z?.targetWindowId,x)?.setDocumentEdited(U)}async openExternal(x,U){return this.environmentMainService.unsetSnapExportedVariables(),s.shell.openExternal(U),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(x,U){return s.shell.trashItem(U)}async isAdmin(){let x;return f.isWindows?x=(await new Promise((U,z)=>{K(["native-is-elevated"],U,z)}))():x=process.getuid?.()===0,x}async writeElevated(x,U,z,re){const ie=await new Promise((oe,G)=>{K(["@vscode/sudo-prompt"],oe,G)});return new Promise((oe,G)=>{const te=[`"${this.cliPath}"`];re?.unlock&&te.push("--file-chmod"),te.push("--file-write",`"${U.fsPath}"`,`"${z.fsPath}"`);const q={name:this.productService.nameLong.replace("-",""),icns:f.isMacintosh&&this.environmentMainService.isBuilt?(0,d.join)((0,d.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ie.exec(te.join(" "),q,(O,B,V)=>{B&&this.logService.trace(`[sudo-prompt] received stdout: ${B}`),V&&this.logService.trace(`[sudo-prompt] received stderr: ${V}`),O?G(O):oe(void 0)})})}async isRunningUnderARM64Translation(){return f.isLinux||f.isWindows?!1:s.app.runningUnderARM64Translation}get cliPath(){return f.isWindows?this.environmentMainService.isBuilt?(0,d.join)((0,d.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,d.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):f.isLinux?this.environmentMainService.isBuilt?(0,d.join)((0,d.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,d.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,d.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,d.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,P.totalmem)(),freemem:(0,P.freemem)(),loadavg:(0,P.loadavg)()}}async getOSProperties(){return{arch:(0,P.arch)(),platform:(0,P.platform)(),release:(0,P.release)(),type:(0,P.type)(),cpus:(0,P.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return f.isWindows&&(0,D.hasWSLFeatureInstalled)()}async getProcessId(x){return this.windowById(void 0,x)?.win?.webContents.getOSProcessId()}async killProcess(x,U,z){process.kill(U,z)}async readClipboardText(x,U){return s.clipboard.readText(U)}async writeClipboardText(x,U,z){return s.clipboard.writeText(U,z)}async readClipboardFindText(x){return s.clipboard.readFindText()}async writeClipboardFindText(x,U){return s.clipboard.writeFindText(U)}async writeClipboardBuffer(x,U,z,re){return s.clipboard.writeBuffer(U,Buffer.from(z.buffer),re)}async readClipboardBuffer(x,U){return S.VSBuffer.wrap(s.clipboard.readBuffer(U))}async hasClipboard(x,U,z){return s.clipboard.has(U,z)}async newWindowTab(){await this.windowsMainService.open({context:n.OpenContext.API,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){s.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){s.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){s.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){s.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){s.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(x,U){this.codeWindowById(x)?.updateTouchBar(U)}async notifyReady(x){this.codeWindowById(x)?.setReady()}async relaunch(x,U){return this.lifecycleMainService.relaunch(U)}async reload(x,U){const z=this.codeWindowById(x);if(z){if((0,c.isWorkspaceIdentifier)(z.openedWorkspace)){const re=z.openedWorkspace.configPath;if(re.scheme===l.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(re))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(z,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(x,U){return this.windowById(U?.targetWindowId,x)?.win?.close()}async quit(x){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(x,U){await this.lifecycleMainService.kill(U)}async resolveProxy(x,U){return this.codeWindowById(x)?.win?.webContents?.session?.resolveProxy(U)}async loadCertificates(x){return(await new Promise((z,re)=>{K(["@vscode/proxy-agent"],z,re)})).loadSystemCertificates({log:this.logService})}findFreePort(x,U,z,re,ie=1){return(0,p.findFreePort)(U,z,re,ie)}async openDevTools(x,U){this.windowById(U?.targetWindowId,x)?.win?.webContents.openDevTools(U?.mode?{mode:U.mode,activate:U.activate}:void 0)}async toggleDevTools(x,U){this.windowById(U?.targetWindowId,x)?.win?.webContents.toggleDevTools()}async profileRenderer(x,U,z){const re=this.codeWindowById(x);if(!re||!re.win)throw new Error;return await new L.WindowProfiler(re.win,U,this.logService).inspect(z)}async windowsGetStringRegKey(x,U,z,re){if(!f.isWindows)return;const ie=await new Promise((oe,G)=>{K(["@vscode/windows-registry"],oe,G)});try{return ie.GetStringRegKey(U,z,re)}catch{return}}windowById(x,U){return this.codeWindowById(x)??this.auxiliaryWindowById(x)??this.codeWindowById(U)}codeWindowById(x){if(typeof x=="number")return this.windowsMainService.getWindowById(x)}auxiliaryWindowById(x){if(typeof x!="number")return;const U=s.webContents.fromId(x);if(U)return this.auxiliaryWindowsMainService.getWindowByWebContents(U)}};e.NativeHostMainService=C,Ie([A.memoize],C.prototype,"cliPath",null),e.NativeHostMainService=C=Ie([se(0,n.IWindowsMainService),se(1,M.IAuxiliaryWindowsMainService),se(2,w.IDialogMainService),se(3,o.ILifecycleMainService),se(4,E.IEnvironmentMainService),se(5,t.ILogService),se(6,r.IProductService),se(7,a.IThemeMainService),se(8,u.IWorkspacesManagementMainService)],C)}),define(le[306],ce([0,1,14,27,8,23,31,2,13,4,116,37,185,96,136,58,25,5,74,84,28,85,34,64,57,29]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I,o,t,r,a,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const u="issue.processExplorerWindowState";let S=class{static{c=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(M,T,C,F,x,U,z,re,ie,oe,G){this.userEnv=M,this.environmentMainService=T,this.logService=C,this.diagnosticsService=F,this.diagnosticsMainService=x,this.dialogMainService=U,this.nativeHostMainService=z,this.protocolMainService=re,this.productService=ie,this.stateService=oe,this.windowsMainService=G,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){f.validatedIpcMain.on("vscode:listProcesses",async M=>{const T=[];try{T.push({name:(0,g.localize)(0,null),rootProcess:await(0,d.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(F=>{(0,y.isRemoteDiagnosticError)(F)?T.push({name:F.hostName,rootProcess:F}):F.processes&&T.push({name:F.hostName,rootProcess:F.processes})})}catch(C){this.logService.error(`Listing processes failed: ${C}`)}this.safeSend(M,"vscode:listProcessesResponse",T)}),f.validatedIpcMain.on("vscode:workbenchCommand",(M,T)=>{const{id:C,from:F,args:x}=T;let U;switch(F){case"processExplorer":U=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${F}`)}U?.webContents.send("vscode:runAction",{id:C,from:F,args:x})}),f.validatedIpcMain.on("vscode:closeProcessExplorer",M=>{this.processExplorerWindow?.close()}),f.validatedIpcMain.on("vscode:pidToNameRequest",async M=>{const T=await this.diagnosticsMainService.getMainDiagnostics(),C=[];for(const F of T.windows)C.push([F.pid,`window [${F.id}] (${F.title})`]);for(const{pid:F,name:x}of r.UtilityProcess.getAll())C.push([F,x]);this.safeSend(M,"vscode:pidToNameResponse",C)})}async openReporter(M){if(this.issueReporterWindow)this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow);else if(this.issueReporterParentWindow=i.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow){const T=new R.DisposableStore,C=T.add(this.protocolMainService.createIPCObjectUrl()),F=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(F,C,{backgroundColor:M.styles.backgroundColor,title:(0,g.localize)(1,null),zoomLevel:M.zoomLevel,alwaysOnTop:!1},"issue-reporter"),C.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:M,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:E.default}),this.issueReporterWindow.loadURL(b.FileAccess.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,T.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,T.dispose())})}}async openProcessExplorer(M){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=i.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const T=new R.DisposableStore,C=T.add(this.protocolMainService.createIPCObjectUrl()),F=this.stateService.getItem(u,void 0),x=D(F)?F:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(x,C,{backgroundColor:M.styles.backgroundColor,title:(0,g.localize)(2,null),zoomLevel:M.zoomLevel,alwaysOnTop:!0},"process-explorer"),C.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:M,product:E.default}),this.processExplorerWindow.loadURL(b.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,T.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,T.dispose())});const U=()=>{if(!this.processExplorerWindow)return;const z=this.processExplorerWindow.getSize(),re=this.processExplorerWindow.getPosition();if(!z||!re)return;const ie={width:z[0],height:z[1],x:re[0],y:re[1]};this.stateService.setItem(u,ie)};this.processExplorerWindow.on("moved",U),this.processExplorerWindow.on("resized",U)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const M=await i.contentTracing.stopRecording(`${(0,A.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null,M),buttons:[(0,g.localize)(5,null)]},i.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,M)}async getSystemStatus(){const[M,T]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(M,T)}async $getSystemInfo(){const[M,T]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(M,T)}async $getPerformanceInfo(){try{const[M,T]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(M,T)}catch(M){throw this.logService.warn("issueService#getPerformanceInfo ",M.message),M}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(M){this.logService.error(M)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:M}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,g.localize)(6,null),buttons:[(0,g.localize)(7,null),(0,g.localize)(8,null)]},this.issueReporterWindow);M===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:M}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,g.localize)(9,null),buttons:[(0,g.localize)(10,null),(0,g.localize)(11,null)]},this.issueReporterWindow);return M===0}return!1}issueReporterWindowCheck(){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const M=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!M)throw new Error("Window not found");return M}async $sendReporterMenu(M,T){const C=this.issueReporterWindowCheck(),F="vscode:triggerReporterMenu",x=new k.CancellationTokenSource;return C.sendWhenReady(F,x.token,{replyChannel:F,extensionId:M,extensionName:T}),await(0,P.raceTimeout)(new Promise(z=>f.validatedIpcMain.once(`vscode:triggerReporterMenuResponse:${M}`,(re,ie)=>z(ie))),5e3,()=>{this.logService.error(`Error: Extension ${M} timed out waiting for menu response`),x.cancel()})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(M){M.isMinimized()&&M.restore(),M.focus()}safeSend(M,T,...C){M.sender.isDestroyed()||M.sender.send(T,...C)}createBrowserWindow(M,T,C,F){const x=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:M.width,height:M.height,minWidth:300,minHeight:200,x:M.x,y:M.y,title:C.title,backgroundColor:C.backgroundColor||c.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${T.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,a.zoomLevelToZoomFactor)(C.zoomLevel),sandbox:!0},alwaysOnTop:C.alwaysOnTop,experimentalDarkMode:!0});return x.setMenuBarVisibility(!1),x}getWindowPosition(M,T,C){let F;const x=i.screen.getAllDisplays();if(x.length===1)F=x[0];else{if(l.isMacintosh){const re=i.screen.getCursorScreenPoint();F=i.screen.getDisplayNearestPoint(re)}!F&&M&&(F=i.screen.getDisplayMatching(M.getBounds())),F||(F=i.screen.getPrimaryDisplay()||x[0])}const U=F.bounds,z={width:T,height:C,x:U.x+U.width/2-T/2,y:U.y+U.height/2-C/2};return U.width>0&&U.height>0&&(z.x<U.x&&(z.x=U.x),z.y<U.y&&(z.y=U.y),z.x>U.x+U.width&&(z.x=U.x),z.y>U.y+U.height&&(z.y=U.y),z.width>U.width&&(z.width=U.width),z.height>U.height&&(z.height=U.height)),z}};e.IssueMainService=S,e.IssueMainService=S=c=Ie([se(1,p.IEnvironmentMainService),se(2,v.ILogService),se(3,y.IDiagnosticsService),se(4,h.IDiagnosticsMainService),se(5,m.IDialogMainService),se(6,w.INativeHostMainService),se(7,o.IProtocolMainService),se(8,I.IProductService),se(9,t.IStateService),se(10,n.IWindowsMainService)],S);function D(L){return typeof L!="object"||L===null?!1:"x"in L&&"y"in L&&"width"in L&&"height"in L}}),define(le[307],ce([0,1,23,18,25,20,5,74,28,55,24,51,106]),function(K,e,i,s,P,k,A,R,b,l,d,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends g.AbstractUpdateService{constructor(m,p,v,w,E,I,o,t){super(m,p,w,E,I,t),this.telemetryService=v,this.nativeHostMainService=o}buildUpdateFeedUrl(m){return(0,g.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){this.url&&(this.setState(f.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},i.CancellationToken.None).then(l.asJson).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(f.State.Idle(f.UpdateType.Archive))):this.setState(f.State.AvailableForDownload(p))}).then(void 0,p=>{this.logService.error(p);const v=m?p.message||p:void 0;this.setState(f.State.Idle(f.UpdateType.Archive,v))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(f.State.Idle(f.UpdateType.Archive))}};e.LinuxUpdateService=y,e.LinuxUpdateService=y=Ie([se(0,k.ILifecycleMainService),se(1,s.IConfigurationService),se(2,d.ITelemetryService),se(3,P.IEnvironmentMainService),se(4,l.IRequestService),se(5,A.ILogService),se(6,R.INativeHostMainService),se(7,b.IProductService)],y)}),define(le[308],ce([0,1,50,44,27,8,23,53,47,9,7,149,21,18,25,15,20,5,74,28,55,24,51,106]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I,o,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(S,D=1e3){for(;!S();)await(0,k.timeout)(D)}let n;function c(){return typeof n>"u"&&(s.existsSync(l.join(l.dirname(process.execPath),"unins000.exe"))?n=t.UpdateType.Setup:l.basename(l.normalize(l.join(process.execPath,"..","..")))==="Program Files"?n=t.UpdateType.WindowsInstaller:n=t.UpdateType.Archive),n}let u=class extends r.AbstractUpdateService{get cachePath(){const D=l.join((0,P.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return g.Promises.mkdir(D,{recursive:!0}).then(()=>D)}constructor(D,L,M,T,C,F,x,U,z){super(D,L,T,C,F,z),this.telemetryService=M,this.fileService=x,this.nativeHostMainService=U,D.setRelaunchHandler(this)}handleRelaunch(D){return D?.addArgs||D?.removeArgs||this.state.type!==t.StateType.Ready||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(t.State.Disabled(t.DisablementReason.RunningAsAdmin)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(D){let L=`win32-${process.arch}`;switch(c()){case t.UpdateType.Archive:L+="-archive";break;case t.UpdateType.WindowsInstaller:L+="-msi";break;default:this.productService.target==="user"?L+="-user":L+="-system"}return(0,r.createUpdateURL)(L,D,this.productService)}doCheckForUpdates(D){this.url&&(this.setState(t.State.CheckingForUpdates(D)),this.requestService.request({url:this.url},A.CancellationToken.None).then(I.asJson).then(L=>{const M=c();return!L||!L.url||!L.version||!L.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!D}),this.setState(t.State.Idle(M)),Promise.resolve(null)):M===t.UpdateType.Archive?(this.setState(t.State.AvailableForDownload(L)),Promise.resolve(null)):(this.setState(t.State.Downloading),this.cleanup(L.version).then(()=>this.getUpdatePackagePath(L.version).then(T=>g.Promises.exists(T).then(C=>{if(C)return Promise.resolve(T);const F=`${T}.tmp`;return this.requestService.request({url:L.url},A.CancellationToken.None).then(x=>this.fileService.writeFile(d.URI.file(F),x.stream)).then(L.sha256hash?()=>(0,f.checksum)(F,L.sha256hash):()=>{}).then(()=>g.Promises.rename(F,T,!1)).then(()=>T)})).then(T=>{this.availableUpdate={packagePath:T},this.setState(t.State.Downloaded(L)),this.configurationService.getValue("update.enableWindowsBackgroundUpdates")?this.productService.target==="user"&&this.doApplyUpdate():this.setState(t.State.Ready(L))})))}).then(void 0,L=>{this.telemetryService.publicLog2("update:error",{messageHash:String((0,b.hash)(String(L)))}),this.logService.error(L);const M=D?L.message||L:void 0;this.setState(t.State.Idle(c(),M))}))}async doDownloadUpdate(D){D.update.url&&this.nativeHostMainService.openExternal(void 0,D.update.url),this.setState(t.State.Idle(c()))}async getUpdatePackagePath(D){const L=await this.cachePath;return l.join(L,`CodeSetup-${this.productService.quality}-${D}.exe`)}async cleanup(D=null){const L=D?F=>!new RegExp(`${this.productService.quality}-${D}\\.exe$`).test(F):()=>!0,M=await this.cachePath,C=(await g.Promises.readdir(M)).filter(L).map(async F=>{try{await g.Promises.unlink(l.join(M,F))}catch{}});await Promise.all(C)}async doApplyUpdate(){if(this.state.type!==t.StateType.Downloaded||!this.availableUpdate)return Promise.resolve(void 0);const D=this.state.update;this.setState(t.State.Updating(D));const L=await this.cachePath;this.availableUpdate.updateFilePath=l.join(L,`CodeSetup-${this.productService.quality}-${D.version}.flag`),await g.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,i.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(t.State.Idle(c()))});const T=`${this.productService.win32MutexName}-ready`,C=await new Promise((F,x)=>{K(["@vscode/windows-mutex"],F,x)});a(()=>C.isActive(T)).then(()=>this.setState(t.State.Ready(D)))}doQuitAndInstall(){this.state.type!==t.StateType.Ready||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?s.unlinkSync(this.availableUpdate.updateFilePath):c()==t.UpdateType.WindowsInstaller?(0,i.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,i.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return c()}async _applySpecificUpdate(D){if(this.state.type!==t.StateType.Idle)return;const L=c()==t.UpdateType.Setup&&this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown"};this.setState(t.State.Downloading),this.availableUpdate={packagePath:D},this.setState(t.State.Downloaded(M)),L?this.productService.target==="user"&&this.doApplyUpdate():this.setState(t.State.Ready(M))}};e.Win32UpdateService=u,Ie([R.memoize],u.prototype,"cachePath",null),e.Win32UpdateService=u=Ie([se(0,p.ILifecycleMainService),se(1,y.IConfigurationService),se(2,o.ITelemetryService),se(3,h.IEnvironmentMainService),se(4,I.IRequestService),se(5,v.ILogService),se(6,m.IFileService),se(7,w.INativeHostMainService),se(8,E.IProductService)],u)}),define(le[137],ce([0,1,14,8,23,48,3,2,13,69,4,7,196,27,68,18,58,25,67,15,20,5,28,85,284,87,24,111,73,57,29,30,60,52,41,34,59,70,22,6]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I,o,t,r,a,n,c,u,S,D,L,M,T,C,F,x,U,z,re,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=e.BaseWindow=void 0;var oe;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(oe||(oe={}));class G extends R.Disposable{get lastFocusTime(){return this._lastFocusTime}get win(){return this._win}setWin(O){this._win=O,this._register(A.Event.fromNodeEventEmitter(O,"maximize")(()=>this._onDidMaximize.fire())),this._register(A.Event.fromNodeEventEmitter(O,"unmaximize")(()=>this._onDidUnmaximize.fire())),this._register(A.Event.fromNodeEventEmitter(O,"closed")(()=>{this._onDidClose.fire(),this.dispose()})),this._register(A.Event.fromNodeEventEmitter(O,"focus")(()=>{this._lastFocusTime=Date.now()})),this._register(A.Event.fromNodeEventEmitter(this._win,"enter-full-screen")(()=>this._onDidEnterFullScreen.fire())),this._register(A.Event.fromNodeEventEmitter(this._win,"leave-full-screen")(()=>this._onDidLeaveFullScreen.fire()));const B=!(0,D.hasNativeTitlebar)(this.configurationService);if(d.isMacintosh&&B&&O.setSheetOffset((0,d.isBigSurOrNewer)((0,y.release)())?28:22),B&&(d.isWindows&&(0,D.useWindowControlsOverlay)(this.configurationService)||d.isMacintosh)){const V=this.stateService.getItem(G.windowControlHeightStateStorageKey);V?this.updateWindowControls({height:V}):this.updateWindowControls({height:D.DEFAULT_CUSTOM_TITLEBAR_HEIGHT})}d.isWindows&&B&&O.hookWindowMessage(278,()=>{const[ae,j]=O.getPosition(),he=i.screen.getCursorScreenPoint(),ne=he.x-ae,J=he.y-j;return!(ne>30&&J>=0&&J<=Math.max(O.getBounds().height*.15,35))||(O.setEnabled(!1),O.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:ne,y:J})),0}),this.environmentMainService.args["open-devtools"]===!0&&O.webContents.openDevTools(),d.isMacintosh&&(this._register(this.onDidEnterFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})),this._register(this.onDidLeaveFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})))}constructor(O,B,V,ae){super(),this.configurationService=O,this.stateService=B,this.environmentMainService=V,this.logService=ae,this._onDidClose=this._register(new A.Emitter),this.onDidClose=this._onDidClose.event,this._onDidMaximize=this._register(new A.Emitter),this.onDidMaximize=this._onDidMaximize.event,this._onDidUnmaximize=this._register(new A.Emitter),this.onDidUnmaximize=this._onDidUnmaximize.event,this._onDidTriggerSystemContextMenu=this._register(new A.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidEnterFullScreen=this._register(new A.Emitter),this.onDidEnterFullScreen=this._onDidEnterFullScreen.event,this._onDidLeaveFullScreen=this._register(new A.Emitter),this.onDidLeaveFullScreen=this._onDidLeaveFullScreen.event,this._lastFocusTime=Date.now(),this._win=null,this.hasWindowControlOverlay=(0,D.useWindowControlsOverlay)(this.configurationService),this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0}applyState(O,B=i.screen.getAllDisplays().length>0){const V=this.configurationService.getValue("window"),ae=d.isMacintosh&&V?.nativeTabs===!0;(d.isMacintosh||d.isWindows)&&B&&(!ae||i.BrowserWindow.getAllWindows().length===1)&&[O.width,O.height,O.x,O.y].every(j=>typeof j=="number")&&this._win?.setBounds({width:O.width,height:O.height,x:O.x,y:O.y}),(O.mode===C.WindowMode.Maximized||O.mode===C.WindowMode.Fullscreen)&&(this._win?.maximize(),O.mode===C.WindowMode.Fullscreen&&this.setFullScreen(!0,!0),this._win?.show())}setRepresentedFilename(O){d.isMacintosh?this.win?.setRepresentedFilename(O):this.representedFilename=O}getRepresentedFilename(){return d.isMacintosh?this.win?.getRepresentedFilename():this.representedFilename}setDocumentEdited(O){d.isMacintosh&&this.win?.setDocumentEdited(O),this.documentEdited=O}isDocumentEdited(){return d.isMacintosh?!!this.win?.isDocumentEdited():!!this.documentEdited}focus(O){d.isMacintosh&&O?.force&&i.app.focus({steal:!0});const B=this.win;B&&(B.isMinimized()&&B.restore(),B.focus())}handleTitleDoubleClick(){const O=this.win;if(O)if(d.isMacintosh)switch(i.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":O.minimize();break;case"None":break;case"Maximize":default:O.isMaximized()?O.unmaximize():O.maximize()}else O.isMaximized()?O.unmaximize():O.maximize()}static{this.windowControlHeightStateStorageKey="windowControlHeight"}updateWindowControls(O){const B=this.win;if(B){if(O.height&&this.stateService.setItem(te.windowControlHeightStateStorageKey,O.height),d.isWindows&&this.hasWindowControlOverlay)B.setTitleBarOverlay({color:O.backgroundColor?.trim()===""?void 0:O.backgroundColor,symbolColor:O.foregroundColor?.trim()===""?void 0:O.foregroundColor,height:O.height?O.height-1:void 0});else if(d.isMacintosh&&O.height!==void 0){const V=(O.height-15)/2;V?B.setWindowButtonPosition({x:V,y:V}):B.setWindowButtonPosition(null)}}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen,!1)}setFullScreen(O,B){(0,D.useNativeFullScreen)(this.configurationService)?this.setNativeFullScreen(O,B):this.setSimpleFullScreen(O)}get isFullScreen(){if(d.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean")return this.transientIsNativeFullScreen;const O=this.win,B=O?.isFullScreen(),V=O?.isSimpleFullScreen();return!!(B||V)}setNativeFullScreen(O,B){const V=this.win;V?.isSimpleFullScreen()&&V?.setSimpleFullScreen(!1),this.doSetNativeFullScreen(O,B)}doSetNativeFullScreen(O,B){if(d.isMacintosh){this.transientIsNativeFullScreen=O;const ae=this.joinNativeFullScreenTransition=new s.DeferredPromise;(async()=>{const j=await Promise.race([ae.p,(0,s.timeout)(1e4).then(()=>!1)]);this.joinNativeFullScreenTransition===ae&&(this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,!j&&O&&B&&this.win&&!this.win.isFullScreen()&&(this.logService.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this._onDidLeaveFullScreen.fire()))})()}this.win?.setFullScreen(O)}setSimpleFullScreen(O){const B=this.win;B?.isFullScreen()&&this.doSetNativeFullScreen(!1,!1),B?.setSimpleFullScreen(O),B?.webContents.focus()}dispose(){super.dispose(),this._win=null}}e.BaseWindow=G;let te=class extends G{get id(){return this._id}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const O=this.userDataProfilesService.profiles.find(B=>B.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&O?O:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,M.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(O,B,V,ae,j,he,ne,J,_,W,N,H,X,Q,$,ee,fe,me,we,Re,Pe){super(W,Re,ae,B),this.loggerMainService=V,this.policyService=j,this.userDataProfilesService=he,this.fileService=ne,this.applicationStorageMainService=J,this.storageMainService=_,this.themeMainService=N,this.workspacesManagementMainService=H,this.backupMainService=X,this.telemetryService=Q,this.dialogMainService=$,this.lifecycleMainService=ee,this.productService=fe,this.protocolMainService=me,this.windowsMainService=we,this._onWillLoad=this._register(new A.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new A.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidDestroy=this._register(new A.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.customZoomLevel=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=oe.NONE;{const[De,ke]=this.restoreWindowState(O.state);this.windowState=De,this.logService.trace("window#ctor: using window state",De);const pe=Pe.invokeFunction(L.defaultBrowserWindowOptions,this.windowState,{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none"});(0,l.mark)("code/willCreateCodeBrowserWindow"),this._win=new i.BrowserWindow(pe),(0,l.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.setWin(this._win),this.applyState(this.windowState,ke),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=oe.READY;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.whenReadyCallbacks.push(O)})}get isReady(){return this.readyState===oe.READY}get whenClosedOrLoaded(){return new Promise(O=>{function B(){V.dispose(),ae.dispose(),O()}const V=this.onDidClose(()=>B()),ae=this.onWillLoad(()=>B())})}registerListeners(){this._register(A.Event.fromNodeEventEmitter(this._win,"unresponsive")(()=>this.onWindowError(C.WindowError.UNRESPONSIVE))),this._register(A.Event.fromNodeEventEmitter(this._win.webContents,"render-process-gone",(B,V)=>V)(B=>this.onWindowError(C.WindowError.PROCESS_GONE,{...B}))),this._register(A.Event.fromNodeEventEmitter(this._win.webContents,"did-fail-load",(B,V,ae)=>({exitCode:V,reason:ae}))(({exitCode:B,reason:V})=>this.onWindowError(C.WindowError.LOAD,{reason:V,exitCode:B}))),this._register(A.Event.fromNodeEventEmitter(this._win.webContents,"will-prevent-unload")(B=>B.preventDefault())),this._register(A.Event.fromNodeEventEmitter(this._win.webContents,"did-finish-load")(()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)})),this._register(this.onDidMaximize(()=>{this._config&&(this._config.maximized=!0)})),this._register(this.onDidUnmaximize(()=>{this._config&&(this._config.maximized=!1)})),this._register(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None)})),this._register(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None)})),this._register(this.configurationService.onDidChangeConfiguration(B=>this.onConfigurationUpdated(B))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(B=>this.onDidDeleteUntitledWorkspace(B)));const O=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:O},async(B,V)=>{const ae=await this.getMarketplaceHeaders();V({cancel:!1,requestHeaders:Object.assign(B.requestHeaders,ae)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(O,B){switch(O){case C.WindowError.PROCESS_GONE:this.logService.error(`CodeWindow: renderer process gone (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break;case C.WindowError.UNRESPONSIVE:this.logService.error("CodeWindow: detected unresponsive");break;case C.WindowError.LOAD:this.logService.error(`CodeWindow: failed to load (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:O,reason:B?.reason,code:B?.exitCode}),O){case C.WindowError.UNRESPONSIVE:case C.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(O===C.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:ae}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null),(0,g.localize)(2,null)],message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null),checkboxLabel:this._config?.workspace?(0,g.localize)(5,null):void 0},this._win);if(V!==2){const j=V===0;await this.destroyWindow(j,ae)}}else if(O===C.WindowError.PROCESS_GONE){let V;B?V=(0,g.localize)(7,null,B.reason,B.exitCode??"<unknown>"):V=(0,g.localize)(6,null);const{response:ae,checkboxChecked:j}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,g.localize)(8,null):(0,g.localize)(9,null),(0,g.localize)(10,null)],message:V,detail:this._config?.workspace?(0,g.localize)(11,null):(0,g.localize)(12,null),checkboxLabel:this._config?.workspace?(0,g.localize)(13,null):void 0},this._win),he=ae===0;await this.destroyWindow(he,j)}break}}async destroyWindow(O,B){const V=this._config?.workspace;if(B&&V)try{const ae=this.storageMainService.workspaceStorage(V);await ae.init(),ae.delete("memento/workbench.parts.editor"),await ae.close()}catch(ae){this.logService.error(ae)}this._onDidDestroy.fire();try{if(O&&this._config){let ae,j;(0,M.isSingleFolderWorkspaceIdentifier)(V)?ae={folderUri:V.uri}:(0,M.isWorkspaceIdentifier)(V)?ae={workspaceUri:V.configPath}:j=!0,(0,re.firstOrDefault)(await this.windowsMainService.open({context:L.OpenContext.API,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:ae?[ae]:void 0,forceEmpty:j,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this._win?.destroy()}}onDidDeleteUntitledWorkspace(O){this._config?.workspace?.id===O.id&&(this._config.workspace=void 0)}onConfigurationUpdated(O){if(!O||O.affectsConfiguration("window.menuBarVisibility")){const B=this.getMenuBarVisibility();B!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=B,this.setMenuBarVisibility(B))}if(!O||O.affectsConfiguration("http.proxy")){let B=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;B?.endsWith("/")&&(B=B.substr(0,B.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.currentHttpProxy||V!==this.currentNoProxy)){this.currentHttpProxy=B,this.currentNoProxy=V;const ae=B||"",j=V?`${V},<local>`:"<local>";this.logService.trace(`Setting proxy to '${ae}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:ae,proxyBypassRules:j,pacScript:""}),typeof i.app.setProxy=="function"&&i.app.setProxy({proxyRules:ae,proxyBypassRules:j,pacScript:""})}}}addTabbedWindow(O){d.isMacintosh&&O.win&&this._win.addTabbedWindow(O.win)}load(O,B=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!B.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),B.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(O,B),this.readyState===oe.NONE?this._config=O:this.pendingLoadConfig=O,this.readyState=oe.NAVIGATING,this._win.loadURL(b.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new s.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:O.workspace,reason:B.isReload?C.LoadReason.RELOAD:V?C.LoadReason.LOAD:C.LoadReason.INITIAL})}updateConfiguration(O,B){const V=(this._config??this.pendingLoadConfig)?.userEnv;if(V){const ae=(0,w.isLaunchedFromCli)(V)&&!(0,w.isLaunchedFromCli)(O.userEnv),j=this.isExtensionDevelopmentHost;(ae||j)&&(O.userEnv={...V,...O.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),B.disableExtensions!==void 0&&(O["disable-extensions"]=B.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this._win.isMaximized(),O.partsSplash=this.themeMainService.getWindowSplash(),O.zoomLevel=this.getZoomLevel(),O.isCustomZoomLevel=typeof this.customZoomLevel=="number",O.isCustomZoomLevel&&O.partsSplash&&(O.partsSplash.zoomLevel=O.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),O.perfMarks=(0,l.getMarks)(),this.configObjectUrl.update(O)}async reload(O){const B=Object.assign({},this._config);B.workspace=await this.validateWorkspaceBeforeReload(B),delete B.filesToOpenOrCreate,delete B.filesToDiff,delete B.filesToMerge,delete B.filesToWait,this.isExtensionDevelopmentHost&&O&&(B.verbose=O.verbose,B.debugId=O.debugId,B.extensionEnvironment=O.extensionEnvironment,B["inspect-extensions"]=O["inspect-extensions"],B["inspect-brk-extensions"]=O["inspect-brk-extensions"],B["extensions-dir"]=O["extensions-dir"]),B.accessibilitySupport=i.app.isAccessibilitySupportEnabled(),B.isInitialStartup=!1,B.policiesData=this.policyService.serialize(),B.continueOn=this.environmentMainService.continueOn,B.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},B.logLevel=this.loggerMainService.getLogLevel(),B.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(B,{isReload:!0,disableExtensions:O?.["disable-extensions"]})}async validateWorkspaceBeforeReload(O){if((0,M.isWorkspaceIdentifier)(O.workspace)){const B=O.workspace.configPath;if(B.scheme===b.Schemas.file&&!await this.fileService.exists(B))return}else if((0,M.isSingleFolderWorkspaceIdentifier)(O.workspace)){const B=O.workspace.uri;if(B.scheme===b.Schemas.file&&!await this.fileService.exists(B))return}return O.workspace}serializeWindowState(){if(!this._win)return(0,C.defaultWindowState)();if(this.isFullScreen){let V;try{V=i.screen.getDisplayMatching(this.getBounds())}catch{}const ae=(0,C.defaultWindowState)();return{mode:C.WindowMode.Fullscreen,display:V?V.id:void 0,width:this.windowState.width||ae.width,height:this.windowState.height||ae.height,x:this.windowState.x||0,y:this.windowState.y||0,zoomLevel:this.customZoomLevel}}const O=Object.create(null);let B;if(!d.isMacintosh&&this._win.isMaximized()?B=C.WindowMode.Maximized:B=C.WindowMode.Normal,B===C.WindowMode.Maximized?O.mode=C.WindowMode.Maximized:O.mode=C.WindowMode.Normal,B===C.WindowMode.Normal||B===C.WindowMode.Maximized){let V;B===C.WindowMode.Normal?V=this.getBounds():V=this._win.getNormalBounds(),O.x=V.x,O.y=V.y,O.width=V.width,O.height=V.height}return O.zoomLevel=this.customZoomLevel,O}restoreWindowState(O){(0,l.mark)("code/willRestoreCodeWindowState");let B=!1;if(O){this.customZoomLevel=O.zoomLevel;try{const V=i.screen.getAllDisplays();B=V.length>1,O=L.WindowStateValidator.validateWindowState(this.logService,O,V)}catch(V){this.logService.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[O||(0,C.defaultWindowState)(),B]}getBounds(){const[O,B]=this._win.getPosition(),[V,ae]=this._win.getSize();return{x:O,y:B,width:V,height:ae}}setFullScreen(O,B){super.setFullScreen(O,B),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}getMenuBarVisibility(){let O=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}setMenuBarVisibility(O,B=!0){d.isMacintosh||(O==="toggle"&&B&&this.send("vscode:showInfoMessage",(0,g.localize)(14,null)),O==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(O)}):this.doSetMenuBarVisibility(O))}doSetMenuBarVisibility(O){const B=this.isFullScreen;switch(O){case"classic":this._win.setMenuBarVisibility(!B),this._win.autoHideMenuBar=B;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}notifyZoomLevel(O){this.customZoomLevel=O}getZoomLevel(){return typeof this.customZoomLevel=="number"?this.customZoomLevel:this.configurationService.getValue("window")?.zoomLevel}close(){this._win?.close()}sendWhenReady(O,B,...V){this.isReady?this.send(O,...V):this.ready().then(()=>{B.isCancellationRequested||this.send(O,...V)})}send(O,...B){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${O}' for window that is destroyed`);return}try{this._win.webContents.send(O,...B)}catch(V){this.logService.warn(`Error sending IPC message to channel '${O}' of window ${this._id}: ${(0,k.toErrorMessage)(V)}`)}}}updateTouchBar(O){d.isMacintosh&&this.touchBarGroups.forEach((B,V)=>{const ae=O[V];B.segments=this.createTouchBarGroupSegments(ae)})}createTouchBar(){if(d.isMacintosh){for(let O=0;O<10;O++){const B=this.createTouchBarGroup();this.touchBarGroups.push(B)}this._win.setTouchBar(new i.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(O=[]){const B=this.createTouchBarGroupSegments(O),V=new i.TouchBar.TouchBarSegmentedControl({segments:B,mode:"buttons",segmentStyle:"automatic",change:ae=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:V.segments[ae].id,from:"touchbar"})}});return V}createTouchBarGroupSegments(O=[]){return O.map(V=>{let ae;V.icon&&!u.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===b.Schemas.file&&(ae=i.nativeImage.createFromPath(f.URI.revive(V.icon.dark).fsPath),ae.isEmpty()&&(ae=void 0));let j;return typeof V.title=="string"?j=V.title:j=V.title.value,{id:V.id,label:ae?void 0:j,icon:ae}})}matches(O){return this._win?.webContents.id===O.id}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id)}};e.CodeWindow=te,e.CodeWindow=te=Ie([se(1,o.ILogService),se(2,z.ILoggerMainService),se(3,v.IEnvironmentMainService),se(4,F.IPolicyService),se(5,U.IUserDataProfilesMainService),se(6,E.IFileService),se(7,n.IApplicationStorageMainService),se(8,n.IStorageMainService),se(9,m.IConfigurationService),se(10,S.IThemeMainService),se(11,T.IWorkspacesManagementMainService),se(12,h.IBackupMainService),se(13,c.ITelemetryService),se(14,p.IDialogMainService),se(15,I.ILifecycleMainService),se(16,t.IProductService),se(17,r.IProtocolMainService),se(18,L.IWindowsMainService),se(19,x.IStateService),se(20,ie.IInstantiationService)],te)}),define(le[309],ce([0,1,14,4,18,25,20,5,34,57,52,137]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindow=void 0;let g=class extends f.BaseWindow{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(h,m,p,v,w,E){super(v,w,m,p),this.webContents=h,this.lifecycleMainService=E,this.id=this.webContents.id,this.parentId=-1,this.stateApplied=!1,this.tryClaimWindow()}tryClaimWindow(h){this._store.isDisposed||this.webContents.isDestroyed()||(this.doTryClaimWindow(),h&&!this.stateApplied&&(this.stateApplied=!0,this.applyState({x:h.x,y:h.y,width:h.width,height:h.height,mode:h.show===!1?d.WindowMode.Maximized:d.WindowMode.Normal})))}doTryClaimWindow(){if(this._win)return;const h=i.BrowserWindow.fromWebContents(this.webContents);h&&(this.logService.trace("[aux window] Claimed browser window instance"),this.setWin(h),h.setMenu(null),(s.isWindows||s.isLinux)&&(0,l.hasNativeTitlebar)(this.configurationService)&&h.setAutoHideMenuBar(!0),this.lifecycleMainService.registerAuxWindow(this))}matches(h){return this.webContents.id===h.id}};e.AuxiliaryWindow=g,e.AuxiliaryWindow=g=Ie([se(1,k.IEnvironmentMainService),se(2,R.ILogService),se(3,P.IConfigurationService),se(4,b.IStateService),se(5,A.ILifecycleMainService)],g)}),define(le[310],ce([0,1,14,3,2,13,37,309,6,5,52,29]),function(K,e,i,s,P,k,A,R,b,l,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindowsMainService=void 0;let g=class extends P.Disposable{constructor(h,m){super(),this.instantiationService=h,this.logService=m,this._onDidMaximizeWindow=this._register(new s.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new s.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new s.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new s.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.registerListeners()}registerListeners(){i.app.on("browser-window-created",(h,m)=>{const p=this.getWindowByWebContents(m.webContents);if(p)this.logService.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow();else{const v=new P.DisposableStore;v.add(s.Event.fromNodeEventEmitter(m.webContents,"did-create-window",(w,E)=>({browserWindow:w,details:E}))(({browserWindow:w,details:E})=>{const I=this.getWindowByWebContents(w.webContents);I&&(this.logService.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),I.tryClaimWindow(E.options))})),v.add(s.Event.fromNodeEventEmitter(m,"closed")(()=>v.dispose()))}}),A.validatedIpcMain.handle("vscode:registerAuxiliaryWindow",async(h,m)=>{const p=this.getWindowByWebContents(h.sender);return p&&(this.logService.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=m),h.sender.id})}createWindow(h){return this.instantiationService.invokeFunction(f.defaultBrowserWindowOptions,this.validateWindowState(h),{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}validateWindowState(h){const m={},p=h.features.split(",");for(const w of p){const[E,I]=w.split("=");switch(E){case"width":m.width=parseInt(I,10);break;case"height":m.height=parseInt(I,10);break;case"left":m.x=parseInt(I,10);break;case"top":m.y=parseInt(I,10);break;case"window-maximized":m.mode=d.WindowMode.Maximized;break;case"window-fullscreen":m.mode=d.WindowMode.Fullscreen;break}}const v=f.WindowStateValidator.validateWindowState(this.logService,m)??(0,d.defaultAuxWindowState)();return this.logService.trace("[aux window] using window state",v),v}registerWindow(h){const m=new P.DisposableStore,p=this.instantiationService.createInstance(R.AuxiliaryWindow,h);this.windows.set(p.id,p),m.add((0,P.toDisposable)(()=>this.windows.delete(p.id))),m.add(p.onDidMaximize(()=>this._onDidMaximizeWindow.fire(p))),m.add(p.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(p))),m.add(p.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:p,fullscreen:!0}))),m.add(p.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:p,fullscreen:!1}))),m.add(p.onDidTriggerSystemContextMenu(({x:v,y:w})=>this._onDidTriggerSystemContextMenu.fire({window:p,x:v,y:w}))),s.Event.once(p.onDidClose)(()=>m.dispose())}getWindowByWebContents(h){const m=this.windows.get(h.id);return m?.matches(h)?m:void 0}getFocusedWindow(){const h=i.BrowserWindow.getFocusedWindow();if(h)return this.getWindowByWebContents(h.webContents)}getLastActiveWindow(){return(0,f.getLastFocused)(Array.from(this.windows.values()))}getWindows(){return Array.from(this.windows.values())}};e.AuxiliaryWindowsMainService=g,e.AuxiliaryWindowsMainService=g=Ie([se(0,b.IInstantiationService),se(1,l.ILogService)],g)}),define(le[88],ce([0,1,14,22,8,3,49,2,13,4,19,7,21,199,6,20,5,63,87,103,30,60,32,58]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I,o,t,r){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,h.createDecorator)("workspacesHistoryMainService");let n=class extends R.Disposable{static{a=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(u,S,D,L,M){super(),this.logService=u,this.workspacesManagementMainService=S,this.lifecycleMainService=D,this.applicationStorageMainService=L,this.dialogMainService=M,this._onDidChangeRecentlyOpened=this._register(new k.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new P.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(m.LifecycleMainPhase.Eventually).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(u=>this.addRecentlyOpened([{workspace:u.workspace,remoteAuthority:u.window.remoteAuthority}])))}async addRecentlyOpened(u){let S=[],D=[];for(const M of u)if((0,E.isRecentWorkspace)(M))!this.workspacesManagementMainService.isUntitledWorkspace(M.workspace)&&!this.containsWorkspace(S,M.workspace)&&S.push(M);else if((0,E.isRecentFolder)(M))this.containsFolder(S,M.folderUri)||S.push(M);else{const T=this.containsFile(D,M.fileUri),C=M.fileUri.scheme===b.Schemas.file&&a.COMMON_FILES_FILTER.indexOf((0,d.basename)(M.fileUri))>=0;!T&&!C&&(D.push(M),l.isWindows&&M.fileUri.scheme===b.Schemas.file&&i.app.addRecentDocument(M.fileUri.fsPath))}const L=await this.mergeEntriesFromStorage({workspaces:S,files:D});S=L.workspaces,D=L.files,S.length>a.MAX_TOTAL_RECENT_ENTRIES&&(S.length=a.MAX_TOTAL_RECENT_ENTRIES),D.length>a.MAX_TOTAL_RECENT_ENTRIES&&(D.length=a.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:S,files:D}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(u){const S=T=>{const C=this.location(T);for(const F of u)if(d.extUriBiasedIgnorePathCase.isEqual(F,C))return!1;return!0},D=await this.getRecentlyOpened(),L=D.workspaces.filter(S),M=D.files.filter(S);(L.length!==D.workspaces.length||M.length!==D.files.length)&&(await this.saveRecentlyOpened({files:M,workspaces:L}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(u){if(u?.confirm){const{response:S}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null)],message:(0,y.localize)(2,null),detail:(0,y.localize)(3,null),cancelId:1});if(S!==0)return}await this.saveRecentlyOpened({workspaces:[],files:[]}),i.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(u){const S=new t.ResourceMap(M=>d.extUriBiasedIgnorePathCase.getComparisonKey(M));if(u?.workspaces)for(const M of u.workspaces)S.set(this.location(M),M);const D=new t.ResourceMap(M=>d.extUriBiasedIgnorePathCase.getComparisonKey(M));if(u?.files)for(const M of u.files)D.set(this.location(M),M);const L=await this.getRecentlyOpenedFromStorage();for(const M of L.workspaces){const T=S.get(this.location(M));T?T.label=T.label??M.label:S.set(this.location(M),M)}for(const M of L.files){const T=D.get(this.location(M));T?T.label=T.label??M.label:D.set(this.location(M),M)}return{workspaces:[...S.values()],files:[...D.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let u;const S=this.applicationStorageMainService.get(a.RECENTLY_OPENED_STORAGE_KEY,v.StorageScope.APPLICATION);if(typeof S=="string")try{u=JSON.parse(S)}catch(D){this.logService.error("Unexpected error parsing opened paths list",D)}return(0,E.restoreRecentlyOpened)(u,this.logService)}async saveRecentlyOpened(u){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(a.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,E.toStoreData)(u)),v.StorageScope.APPLICATION,v.StorageTarget.MACHINE)}location(u){return(0,E.isRecentFolder)(u)?u.folderUri:(0,E.isRecentFile)(u)?u.fileUri:u.workspace.configPath}containsWorkspace(u,S){return!!u.find(D=>(0,E.isRecentWorkspace)(D)&&D.workspace.id===S.id)}containsFolder(u,S){return!!u.find(D=>(0,E.isRecentFolder)(D)&&d.extUriBiasedIgnorePathCase.isEqual(D.folderUri,S))}containsFile(u,S){return!!u.find(D=>d.extUriBiasedIgnorePathCase.isEqual(D.fileUri,S))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async handleWindowsJumpList(){l.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!l.isWindows)return;const u=[];if(u.push({type:"tasks",items:[{type:"task",title:(0,y.localize)(4,null),description:(0,y.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const S=[];for(const M of i.app.getJumpListSettings().removedItems){const T=M.args;if(T){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(T);C&&S.push(f.URI.parse(C[2]))}}await this.removeRecentlyOpened(S);let D=!1;const L=(0,s.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,a.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(M=>{const T=(0,E.isRecentWorkspace)(M)?M.workspace:M.folderUri,{title:C,description:F}=this.getWindowsJumpListLabel(T,M.label);let x;return f.URI.isUri(T)?x=`--folder-uri "${T.toString()}"`:(D=!0,x=`--file-uri "${T.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:F.substr(0,255),program:process.execPath,args:x,iconPath:"explorer.exe",iconIndex:0}}));L.length>0&&u.push({type:"custom",name:D?(0,y.localize)(6,null):(0,y.localize)(7,null),items:L})}u.push({type:"recent"});try{const S=i.app.setJumpList(u);S&&S!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${S}`)}catch(S){this.logService.warn("updateWindowsJumpList#setJumpList",S)}}getWindowsJumpListLabel(u,S){if(S)return{title:(0,A.splitRecentLabel)(S).name,description:S};if(f.URI.isUri(u))return{title:(0,d.basename)(u),description:this.renderJumpListPathDescription(u)};if(this.workspacesManagementMainService.isUntitledWorkspace(u))return{title:(0,y.localize)(8,null),description:""};let D=(0,d.basename)(u.configPath);return D.endsWith(I.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-I.WORKSPACE_EXTENSION.length-1)),{title:(0,y.localize)(9,null,D),description:this.renderJumpListPathDescription(u.configPath)}}renderJumpListPathDescription(u){return u.scheme==="file"?(0,A.normalizeDriveLetter)(u.fsPath):u.toString()}async updateMacOSRecentDocuments(){if(!l.isMacintosh)return;i.app.clearRecentDocuments();const u=await this.getRecentlyOpened(),S=[];let D=0;for(let M=0;M<u.workspaces.length&&D<a.MAX_MACOS_DOCK_RECENT_WORKSPACES;M++){const T=this.location(u.workspaces[M]);if(T.scheme===b.Schemas.file){const C=(0,d.originalFSPath)(T);await g.Promises.exists(C)&&(S.push(C),D++)}}const L=[];for(let M=0;M<u.files.length&&D<a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;M++){const T=this.location(u.files[M]);if(T.scheme===b.Schemas.file){const C=(0,d.originalFSPath)(T);if(a.COMMON_FILES_FILTER.includes((0,d.basename)(T))||S.includes(C))continue;await g.Promises.exists(C)&&(L.push(C),D++)}}L.reverse().forEach(M=>i.app.addRecentDocument(M)),S.reverse().forEach(M=>i.app.addRecentDocument(M))}};e.WorkspacesHistoryMainService=n,e.WorkspacesHistoryMainService=n=a=Ie([se(0,p.ILogService),se(1,o.IWorkspacesManagementMainService),se(2,m.ILifecycleMainService),se(3,w.IApplicationStorageMainService),se(4,r.IDialogMainService)],n)}),define(le[311],ce([0,1,14,8,23,49,4,7,187,83,18,25,20,5,236,74,28,34,24,51,57,29,88]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I,o,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const a="menu";let n=class{static{r=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(S,D,L,M,T,C,F,x,U,z,re,ie){this.updateService=S,this.configurationService=D,this.windowsMainService=L,this.environmentMainService=M,this.telemetryService=T,this.workspacesHistoryMainService=C,this.stateService=F,this.lifecycleMainService=x,this.logService=U,this.nativeHostMainService=z,this.productService=re,this.auxiliaryWindowsMainService=ie,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new s.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new s.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(A.isMacintosh||(0,I.hasNativeTitlebar)(D))&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveMainWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const S=this.stateService.getItem(r.lastKnownMenubarStorageKey);S&&(S.menus&&(this.menubarMenus=S.menus),S.keybindings&&(this.keybindings=S.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(C,F,x)=>{this.runActionInRenderer({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.windowsMainService.openEmptyWindow({context:o.OpenContext.MENU,contextWindowId:F?.id})},this.fallbackMenuHandlers["workbench.action.newWindow"]=(C,F,x)=>this.windowsMainService.openEmptyWindow({context:o.OpenContext.MENU,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(C,F,x)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(x),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(C,F,x)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(x),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(C,F,x)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(x),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened({confirm:!0});const S=this.productService.youTubeUrl;S&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(S,"openYouTubeUrl"));const D=this.productService.requestFeatureUrl;D&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(D,"openUserVoiceUrl"));const L=this.productService.reportIssueUrl;L&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(L,"openReportIssues"));const M=this.productService.licenseUrl;M&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(A.language){const C=M.indexOf("?")>0?"&":"?";this.openUrl(`${M}${C}lang=${A.language}`,"openLicenseUrl")}else this.openUrl(M,"openLicenseUrl")});const T=this.productService.privacyStatementUrl;T&&M&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(S=>this.onDidChangeWindowsCount(S)),this.nativeHostMainService.onDidBlurMainWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusMainWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const S=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof S!="boolean"?!0:S}get currentEnableNativeTabs(){if(!A.isMacintosh)return!1;const S=this.configurationService.getValue("window.nativeTabs");return typeof S!="boolean"?!1:S}updateMenu(S,D){this.menubarMenus=S.menus,this.keybindings=S.keybindings,this.stateService.setItem(r.lastKnownMenubarStorageKey,S),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(S){A.isMacintosh&&(S.oldCount===0&&S.newCount>0||S.oldCount>0&&S.newCount===0)&&(this.closedLastWindow=S.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){if(!A.isMacintosh)return;const S=i.BrowserWindow.getFocusedWindow();this.noActiveMainWindow=!S||!!this.auxiliaryWindowsMainService.getWindowByWebContents(S.webContents),this.scheduleUpdateMenu()}install(){const S=i.Menu.getApplicationMenu();if(S&&this.oldMenus.push(S),Object.keys(this.menubarMenus).length===0){this.doSetApplicationMenu(A.isMacintosh?new i.Menu:null);return}const D=new i.Menu;let L;if(A.isMacintosh){const T=new i.Menu;L=new i.MenuItem({label:this.productService.nameShort,submenu:T}),this.setMacApplicationMenu(T),D.append(L)}if(A.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const T=new i.Menu;T.append(new i.MenuItem({label:this.mnemonicLabel(b.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:o.OpenContext.DOCK})})),i.app.dock.setMenu(T)}if(this.shouldDrawMenu("File")){const T=new i.Menu,C=new i.MenuItem({label:this.mnemonicLabel(b.localize(1,null)),submenu:T});this.setMenuById(T,"File"),D.append(C)}if(this.shouldDrawMenu("Edit")){const T=new i.Menu,C=new i.MenuItem({label:this.mnemonicLabel(b.localize(2,null)),submenu:T});this.setMenuById(T,"Edit"),D.append(C)}if(this.shouldDrawMenu("Selection")){const T=new i.Menu,C=new i.MenuItem({label:this.mnemonicLabel(b.localize(3,null)),submenu:T});this.setMenuById(T,"Selection"),D.append(C)}if(this.shouldDrawMenu("View")){const T=new i.Menu,C=new i.MenuItem({label:this.mnemonicLabel(b.localize(4,null)),submenu:T});this.setMenuById(T,"View"),D.append(C)}if(this.shouldDrawMenu("Go")){const T=new i.Menu,C=new i.MenuItem({label:this.mnemonicLabel(b.localize(5,null)),submenu:T});this.setMenuById(T,"Go"),D.append(C)}if(this.shouldDrawMenu("Run")){const T=new i.Menu,C=new i.MenuItem({label:this.mnemonicLabel(b.localize(6,null)),submenu:T});this.setMenuById(T,"Run"),D.append(C)}if(this.shouldDrawMenu("Terminal")){const T=new i.Menu,C=new i.MenuItem({label:this.mnemonicLabel(b.localize(7,null)),submenu:T});this.setMenuById(T,"Terminal"),D.append(C)}let M;if(this.shouldDrawMenu("Window")){const T=new i.Menu;M=new i.MenuItem({label:this.mnemonicLabel(b.localize(8,null)),submenu:T,role:"window"}),this.setMacWindowMenu(T)}if(M&&D.append(M),this.shouldDrawMenu("Help")){const T=new i.Menu,C=new i.MenuItem({label:this.mnemonicLabel(b.localize(9,null)),submenu:T,role:"help"});this.setMenuById(T,"Help"),D.append(C)}D.items&&D.items.length>0?this.doSetApplicationMenu(D):this.doSetApplicationMenu(null),this.menuGC.schedule()}doSetApplicationMenu(S){if(i.Menu.setApplicationMenu(S),S)for(const D of this.auxiliaryWindowsMainService.getWindows())D.win?.setMenu(null)}setMacApplicationMenu(S){const D=this.createMenuItem(b.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),L=this.getUpdateMenuItems();let M;if(this.shouldDrawMenu("Preferences")){const ie=new i.Menu;this.setMenuById(ie,"Preferences"),M=new i.MenuItem({label:this.mnemonicLabel(b.localize(11,null)),submenu:ie})}const T=new i.Menu,C=new i.MenuItem({label:b.localize(12,null),role:"services",submenu:T}),F=new i.MenuItem({label:b.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),x=new i.MenuItem({label:b.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),U=new i.MenuItem({label:b.localize(15,null),role:"unhide"}),z=new i.MenuItem(this.likeAction("workbench.action.quit",{label:b.localize(16,null,this.productService.nameLong),click:async(ie,oe,G)=>{const te=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||i.BrowserWindow.getFocusedWindow()||te?.win?.isMinimized())&&await this.confirmBeforeQuit(G)&&this.nativeHostMainService.quit(void 0)}})),re=[D];re.push(...L),M&&re.push(c(),M),re.push(c(),C,c(),F,x,U,c(),z),re.forEach(ie=>S.append(ie))}async confirmBeforeQuit(S){if(this.windowsMainService.getWindowCount()===0)return!0;const D=this.configurationService.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.isKeyboardEvent(S)){const{response:L}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[b.localize(17,null),b.localize(18,null)],message:b.localize(19,null)});return L===0}return!0}shouldDrawMenu(S){if(!A.isMacintosh&&!(0,I.hasNativeTitlebar)(this.configurationService))return!1;switch(S){case"File":case"Help":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus&&!!this.menubarMenus[S];case"Window":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[S]}}setMenu(S,D){D.forEach(L=>{if((0,h.isMenubarMenuItemSeparator)(L))S.append(c());else if((0,h.isMenubarMenuItemSubmenu)(L)){const M=new i.Menu,T=new i.MenuItem({label:this.mnemonicLabel(L.label),submenu:M});this.setMenu(M,L.submenu.items),S.append(T)}else(0,h.isMenubarMenuItemRecentAction)(L)?S.append(this.createOpenRecentMenuItem(L)):(0,h.isMenubarMenuItemAction)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(S),A.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow?this.fallbackMenuHandlers[L.id]?S.append(new i.MenuItem(this.likeAction(L.id,{label:this.mnemonicLabel(L.label),click:this.fallbackMenuHandlers[L.id]}))):S.append(this.createMenuItem(L.label,L.id,!1,L.checked)):S.append(this.createMenuItem(L.label,L.id,L.enabled!==!1,!!L.checked)):S.append(this.createMenuItem(L.label,L.id,L.enabled!==!1,!!L.checked)))})}setMenuById(S,D){this.menubarMenus&&this.menubarMenus[D]&&this.setMenu(S,this.menubarMenus[D].items)}insertCheckForUpdatesItems(S){const D=this.getUpdateMenuItems();D.length&&(D.forEach(L=>S.append(L)),S.append(c()))}createOpenRecentMenuItem(S){const D=R.URI.revive(S.uri),L=S.id,M=L==="openRecentFile"?{fileUri:D}:L==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new i.MenuItem(this.likeAction(L,{label:S.label,click:async(T,C,F)=>{const x=this.isOptionClick(F);(await this.windowsMainService.open({context:o.OpenContext.MENU,cli:this.environmentMainService.args,urisToOpen:[M],forceNewWindow:x,gotoLineMode:!1,remoteAuthority:S.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([D])}},!1))}isOptionClick(S){return!!(S&&(!A.isMacintosh&&(S.ctrlKey||S.shiftKey)||A.isMacintosh&&(S.metaKey||S.altKey)))}isKeyboardEvent(S){return!!(S.triggeredByAccelerator||S.altKey||S.ctrlKey||S.metaKey||S.shiftKey)}createRoleMenuItem(S,D,L){const M={label:this.mnemonicLabel(S),role:L,enabled:!0};return new i.MenuItem(this.withKeybinding(D,M))}setMacWindowMenu(S){const D=new i.MenuItem({label:b.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),L=new i.MenuItem({label:b.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),M=new i.MenuItem({label:b.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(b.localize(23,null),"workbench.action.switchWindow"),C=[];this.currentEnableNativeTabs&&(C.push(c()),C.push(this.createMenuItem(b.localize(24,null),"workbench.action.newWindowTab")),C.push(this.createRoleMenuItem(b.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.createRoleMenuItem(b.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.createRoleMenuItem(b.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.createRoleMenuItem(b.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,L,c(),T,...C,c(),M].forEach(F=>S.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case E.StateType.Idle:return[new i.MenuItem({label:this.mnemonicLabel(b.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case E.StateType.CheckingForUpdates:return[new i.MenuItem({label:b.localize(30,null),enabled:!1})];case E.StateType.AvailableForDownload:return[new i.MenuItem({label:this.mnemonicLabel(b.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case E.StateType.Downloading:return[new i.MenuItem({label:b.localize(32,null),enabled:!1})];case E.StateType.Downloaded:return A.isMacintosh?[]:[new i.MenuItem({label:this.mnemonicLabel(b.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case E.StateType.Updating:return[new i.MenuItem({label:b.localize(34,null),enabled:!1})];case E.StateType.Ready:return[new i.MenuItem({label:this.mnemonicLabel(b.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(S,D,L,M){const T=this.mnemonicLabel(S),C=typeof D=="function"?D:(re,ie,oe)=>{const G=re?re.userSettingsLabel:null;let te=D;Array.isArray(D)&&(te=this.isOptionClick(oe)?D[1]:D[0]),G&&oe.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:G}):this.runActionInRenderer({type:"commandId",commandId:te})},F=typeof L=="boolean"?L:this.windowsMainService.getWindowCount()>0,x=typeof M=="boolean"?M:!1,U={label:T,click:C,enabled:F};x&&(U.type="checkbox",U.checked=x);let z;return typeof D=="string"?z=D:Array.isArray(D)&&(z=D[0]),A.isMacintosh&&(z==="editor.action.clipboardCutAction"?U.role="cut":z==="editor.action.clipboardCopyAction"?U.role="copy":z==="editor.action.clipboardPasteAction"&&(U.role="paste"),z==="undo"?U.click=this.makeContextAwareClickHandler(C,{inDevTools:re=>re.undo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("undo:")}):z==="redo"?U.click=this.makeContextAwareClickHandler(C,{inDevTools:re=>re.redo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("redo:")}):z==="editor.action.selectAll"&&(U.click=this.makeContextAwareClickHandler(C,{inDevTools:re=>re.selectAll(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("selectAll:")}))),new i.MenuItem(this.withKeybinding(z,U))}makeContextAwareClickHandler(S,D){return(L,M,T)=>{const C=i.BrowserWindow.getFocusedWindow();if(!C)return D.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return D.inDevTools(C.webContents.devToolsWebContents);S(L,M||C,T)}}runActionInRenderer(S){let D=i.BrowserWindow.getFocusedWindow();if(D){const M=this.auxiliaryWindowsMainService.getWindowByWebContents(D.webContents);M&&(D=this.windowsMainService.getWindowById(M.parentId)?.win??null)}if(!D){const M=this.windowsMainService.getLastActiveWindow();M?.win?.isMinimized()&&(D=M.win)}const L=D?this.windowsMainService.getWindowById(D.id):void 0;if(L){if(this.logService.trace("menubar#runActionInRenderer",S),A.isMacintosh&&!this.environmentMainService.isBuilt&&!L.isReady&&(S.type==="commandId"&&S.commandId==="workbench.action.toggleDevTools"||S.type!=="commandId"&&S.userSettingsLabel==="alt+cmd+i"))return!1;if(S.type==="commandId"){const M={id:S.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",P.CancellationToken.None,M)}else{const M={userSettingsLabel:S.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,M)}return!0}else return this.logService.trace("menubar#runActionInRenderer: no active window found",S),!1}withKeybinding(S,D){const L=typeof S=="string"?this.keybindings[S]:void 0;if(L?.label){if(L.isNative!==!1)D.accelerator=L.label,D.userSettingsLabel=L.userSettingsLabel;else if(typeof D.label=="string"){const M=D.label.indexOf("[");M>=0?D.label=`${D.label.substr(0,M)} [${L.label}]`:D.label=`${D.label} [${L.label}]`}}else D.accelerator=void 0;return D}likeAction(S,D,L=!D.accelerator){L&&(D=this.withKeybinding(S,D));const M=D.click;return D.click=(T,C,F)=>{this.reportMenuActionTelemetry(S),M?.(T,C,F)},D}openUrl(S,D){this.nativeHostMainService.openExternal(void 0,S),this.reportMenuActionTelemetry(D)}reportMenuActionTelemetry(S){this.telemetryService.publicLog2("workbenchActionExecuted",{id:S,from:a})}mnemonicLabel(S){return(0,k.mnemonicMenuLabel)(S,!this.currentEnableMenuBarMnemonics)}};e.Menubar=n,e.Menubar=n=r=Ie([se(0,E.IUpdateService),se(1,d.IConfigurationService),se(2,o.IWindowsMainService),se(3,f.IEnvironmentMainService),se(4,w.ITelemetryService),se(5,t.IWorkspacesHistoryMainService),se(6,v.IStateService),se(7,g.ILifecycleMainService),se(8,y.ILogService),se(9,m.INativeHostMainService),se(10,p.IProductService),se(11,l.IAuxiliaryWindowsMainService)],n);function c(){return new i.MenuItem({type:"separator"})}}),define(le[312],ce([0,1,6,20,5,311]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,i.createDecorator)("menubarMainService");let A=class{constructor(b,l,d){this.instantiationService=b,this.lifecycleMainService=l,this.logService=d,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(s.LifecycleMainPhase.AfterWindowOpen),this.instantiationService.createInstance(k.Menubar)}async updateMenubar(b,l){this.logService.trace("menubarService#updateMenubar",b),(await this.menubar).updateMenu(l,b)}};e.MenubarMainService=A,e.MenubarMainService=A=Ie([se(0,i.IInstantiationService),se(1,s.ILifecycleMainService),se(2,P.ILogService)],A)}),define(le[313],ce([0,1,14,21,107,27,22,23,39,3,31,49,2,13,9,69,4,36,19,12,7,197,68,18,58,25,15,6,20,5,84,85,71,34,57,137,29,135,305,30,104,88,60,52,73,41,59,70,83]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I,o,t,r,a,n,c,u,S,D,L,M,T,C,F,x,U,z,re,ie,oe,G,te,q,O,B,V,ae,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function he(_){return(0,ie.isWorkspaceIdentifier)(_?.workspace)}function ne(_){return(0,ie.isSingleFolderWorkspaceIdentifier)(_?.workspace)}let J=class extends g.Disposable{constructor(W,N,H,X,Q,$,ee,fe,me,we,Re,Pe,De,ke,pe,Y,ue,de,Se,Me,Ne){super(),this.machineId=W,this.sqmId=N,this.devDeviceId=H,this.initialUserEnv=X,this.logService=Q,this.loggerService=$,this.stateService=ee,this.policyService=fe,this.environmentMainService=me,this.userDataProfilesMainService=we,this.lifecycleMainService=Re,this.backupMainService=Pe,this.configurationService=De,this.workspacesHistoryMainService=ke,this.workspacesManagementMainService=pe,this.instantiationService=Y,this.dialogMainService=ue,this.fileService=de,this.protocolMainService=Se,this.themeMainService=Me,this.auxiliaryWindowsMainService=Ne,this._onDidOpenWindow=this._register(new l.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new l.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new l.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new l.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidMaximizeWindow=this._register(new l.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new l.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new l.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new l.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.windowsStateHandler=this._register(new re.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(W=>this._onDidSignalReadyWindow.fire(W.window))),this._register(this.onDidSignalReadyWindow(W=>{if(W.config?.extensionDevelopmentPath||W.config?.extensionTestsPath){const N=new g.DisposableStore;if(N.add(l.Event.any(W.onDidClose,W.onDidDestroy)(()=>N.dispose())),W.config.extensionDevelopmentPath)for(const H of W.config.extensionDevelopmentPath)N.add(this.protocolMainService.addValidFileRoot(H));W.config.extensionTestsPath&&N.add(this.protocolMainService.addValidFileRoot(W.config.extensionTestsPath))}}))}openEmptyWindow(W,N){const H=this.environmentMainService.args,X=N?.remoteAuthority||void 0,Q=!0,$=N?.forceReuseWindow,ee=!$;return this.open({...W,cli:H,forceEmpty:Q,forceNewWindow:ee,forceReuseWindow:$,remoteAuthority:X})}openExistingWindow(W,N){W.focus(),this.handleWaitMarkerFile(N,[W])}async open(W){this.logService.trace("windowsManager#open"),W.addMode&&(W.initialStartup||!this.getLastActiveWindow())&&(W.addMode=!1);const N=[],H=[],X=[],Q=[],$=[];let ee,fe=0;const me=await this.getPathsToOpen(W);this.logService.trace("windowsManager#open pathsToOpen",me);for(const ke of me)ne(ke)?W.addMode?N.push(ke):H.push(ke):he(ke)?X.push(ke):ke.fileUri?(ee||(ee={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),ee.filesToOpenOrCreate.push(ke)):ke.backupPath?$.push({backupFolder:(0,h.basename)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):fe++;W.diffMode&&ee&&ee.filesToOpenOrCreate.length>=2&&(ee.filesToDiff=ee.filesToOpenOrCreate.slice(0,2),ee.filesToOpenOrCreate=[]),W.mergeMode&&ee&&ee.filesToOpenOrCreate.length===4&&(ee.filesToMerge=ee.filesToOpenOrCreate.slice(0,4),ee.filesToOpenOrCreate=[],ee.filesToDiff=[]),ee&&W.waitMarkerFileURI&&(ee.filesToWait={paths:(0,A.coalesce)([...ee.filesToDiff,ee.filesToMerge[3],...ee.filesToOpenOrCreate]),waitMarkerFileUri:W.waitMarkerFileURI}),W.initialStartup?(Q.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),X.push(...Q),$.push(...this.backupMainService.getEmptyWindowBackups())):$.length=0;const{windows:we,filesOpenedInWindow:Re}=await this.doOpen(W,X,H,$,fe,ee,N);if(this.logService.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${X.length}, foldersToOpen: ${H.length}, emptyToRestore: ${$.length}, emptyToOpen: ${fe})`),we.length>1)if(Re)Re.focus();else{const ke=this.windowsStateHandler.state.lastActiveWindow&&!W.forceEmpty&&!W.cli._.length&&!W.cli["file-uri"]&&!W.cli["folder-uri"]&&!(W.urisToOpen&&W.urisToOpen.length);let pe=!0,Y=!0;if(ke){const ue=we.filter(de=>this.windowsStateHandler.state.lastActiveWindow&&de.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),pe=!1,Y=!1)}if(pe)for(let ue=we.length-1;ue>=0;ue--){const de=we[ue];if(!(de.openedWorkspace&&Q.some(Se=>de.openedWorkspace&&Se.workspace.id===de.openedWorkspace.id)||de.backupPath&&$.some(Se=>de.backupPath&&Se.backupFolder===(0,h.basename)(de.backupPath)))){de.focus(),Y=!1;break}}Y&&we[we.length-1].focus()}const Pe=ee&&ee.filesToDiff.length>0,De=ee&&ee.filesToMerge.length>0;if(!we.some(ke=>ke.isExtensionDevelopmentHost)&&!Pe&&!De&&!W.noRecentEntry){const ke=[];for(const pe of me)he(pe)&&!pe.transient?ke.push({label:pe.label,workspace:pe.workspace,remoteAuthority:pe.remoteAuthority}):ne(pe)?ke.push({label:pe.label,folderUri:pe.workspace.uri,remoteAuthority:pe.remoteAuthority}):pe.fileUri&&ke.push({label:pe.label,fileUri:pe.fileUri,remoteAuthority:pe.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ke)}return this.handleWaitMarkerFile(W,we),we}handleWaitMarkerFile(W,N){const H=W.waitMarkerFileURI;W.context===U.OpenContext.CLI&&H&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.fileService.del(H)}catch{}})()}async doOpen(W,N,H,X,Q,$,ee){const fe=[];let me;function we(ue,de){fe.push(ue),de&&(me=ue,$=void 0)}let{openFolderInNewWindow:Re,openFilesInNewWindow:Pe}=this.shouldOpenNewWindow(W);if(!W.initialStartup&&ee.length>0){const ue=ee[0].remoteAuthority,de=this.getLastActiveWindowForAuthority(ue);de&&we(this.doAddFoldersToExistingWindow(de,ee.map(Se=>Se.workspace.uri)))}const De=H.length+N.length+X.length;if($&&De===0){const ue=$.filesToOpenOrCreate[0]||$.filesToDiff[0]||$.filesToMerge[3],de=this.getWindows().filter(Me=>$&&(0,w.isEqualAuthority)(Me.remoteAuthority,$.remoteAuthority));let Se;ue?.fileUri&&!Pe&&((W.context===U.OpenContext.DESKTOP||W.context===U.OpenContext.CLI||W.context===U.OpenContext.DOCK)&&(Se=await(0,z.findWindowOnFile)(de,ue.fileUri,async Me=>Me.configPath.scheme===y.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(Me.configPath):void 0)),Se||(Se=this.doGetLastActiveWindow(de))),Se?(0,ie.isWorkspaceIdentifier)(Se.openedWorkspace)?N.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):(0,ie.isSingleFolderWorkspaceIdentifier)(Se.openedWorkspace)?H.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):we(this.doOpenFilesInExistingWindow(W,Se,$),!0):we(await this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,filesToOpen:$,forceNewWindow:!0,remoteAuthority:$.remoteAuthority,forceNewTabbedWindow:W.forceNewTabbedWindow,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile}),!0)}const ke=(0,A.distinct)(N,ue=>ue.workspace.id);if(ke.length>0){const ue=(0,A.coalesce)(ke.map(de=>(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),de.workspace.configPath)));if(ue.length>0){const de=ue[0],Se=(0,w.isEqualAuthority)($?.remoteAuthority,de.remoteAuthority)?$:void 0;we(this.doOpenFilesInExistingWindow(W,de,Se),!!Se),Re=!0}for(const de of ke){if(ue.some(Ne=>Ne.openedWorkspace&&Ne.openedWorkspace.id===de.workspace.id))continue;const Se=de.remoteAuthority,Me=(0,w.isEqualAuthority)($?.remoteAuthority,Se)?$:void 0;we(await this.doOpenFolderOrWorkspace(W,de,Re,Me),!!Me),Re=!0}}const pe=(0,A.distinct)(H,ue=>w.extUriBiasedIgnorePathCase.getComparisonKey(ue.workspace.uri));if(pe.length>0){const ue=(0,A.coalesce)(pe.map(de=>(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),de.workspace.uri)));if(ue.length>0){const de=ue[0],Se=(0,w.isEqualAuthority)($?.remoteAuthority,de.remoteAuthority)?$:void 0;we(this.doOpenFilesInExistingWindow(W,de,Se),!!Se),Re=!0}for(const de of pe){if(ue.some(Ne=>(0,ie.isSingleFolderWorkspaceIdentifier)(Ne.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(Ne.openedWorkspace.uri,de.workspace.uri)))continue;const Se=de.remoteAuthority,Me=(0,w.isEqualAuthority)($?.remoteAuthority,Se)?$:void 0;we(await this.doOpenFolderOrWorkspace(W,de,Re,Me),!!Me),Re=!0}}const Y=(0,A.distinct)(X,ue=>ue.backupFolder);if(Y.length>0)for(const ue of Y){const de=ue.remoteAuthority,Se=(0,w.isEqualAuthority)($?.remoteAuthority,de)?$:void 0;we(await this.doOpenEmpty(W,!0,de,Se,ue),!!Se),Re=!0}if(fe.length===0||$){$&&!Q&&Q++;const ue=$?$.remoteAuthority:W.remoteAuthority;for(let de=0;de<Q;de++)we(await this.doOpenEmpty(W,Re,ue,$),!!$),Re=!0}return{windows:(0,A.distinct)(fe),filesOpenedInWindow:me}}doOpenFilesInExistingWindow(W,N,H){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:H}),this.focusMainOrChildWindow(N);const X={filesToOpenOrCreate:H?.filesToOpenOrCreate,filesToDiff:H?.filesToDiff,filesToMerge:H?.filesToMerge,filesToWait:H?.filesToWait,termProgram:W?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",R.CancellationToken.None,X),N}focusMainOrChildWindow(W){let N=W;const H=i.BrowserWindow.getFocusedWindow();if(H&&H.id!==W.id){const X=this.auxiliaryWindowsMainService.getWindowByWebContents(H.webContents);X&&X.parentId===W.id&&(N=X)}N.focus()}doAddFoldersToExistingWindow(W,N){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),W.focus();const H={foldersToAdd:N};return W.sendWhenReady("vscode:addFolders",R.CancellationToken.None,H),W}doOpenEmpty(W,N,H,X,Q){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:H,filesToOpen:X,forceNewWindow:N});let $;return!N&&typeof W.contextWindowId=="number"&&($=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:H,forceNewWindow:N,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:X,windowToUse:$,emptyWindowBackupInfo:Q,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile})}doOpenFolderOrWorkspace(W,N,H,X,Q){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:X}),!H&&!Q&&typeof W.contextWindowId=="number"&&(Q=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({workspace:N.workspace,userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:H,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:X,windowToUse:Q,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile})}async getPathsToOpen(W){let N,H=!1,X=!1;if(W.urisToOpen&&W.urisToOpen.length>0?(N=await this.doExtractPathsFromAPI(W),H=!0):W.forceEmpty?N=[Object.create(null)]:W.cli._.length||W.cli["folder-uri"]||W.cli["file-uri"]?(N=await this.doExtractPathsFromCLI(W.cli),N.length===0&&N.push(Object.create(null)),H=!0):(N=await this.doGetPathsFromLastSession(),N.length===0&&N.push(Object.create(null)),X=!0),!W.addMode&&H){const Q=N.filter($=>ne($));if(Q.length>1){const $=Q[0].remoteAuthority;if(Q.every(ee=>(0,w.isEqualAuthority)(ee.remoteAuthority,$))){const ee=await this.workspacesManagementMainService.createUntitledWorkspace(Q.map(fe=>({uri:fe.workspace.uri})));N.push({workspace:ee,remoteAuthority:$}),N=N.filter(fe=>!ne(fe))}}}if(W.initialStartup&&!X&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const Q=await this.doGetPathsFromLastSession();N.unshift(...Q.filter($=>he($)||ne($)||$.backupPath))}return N}async doExtractPathsFromAPI(W){const N={gotoLineMode:W.gotoLineMode,remoteAuthority:W.remoteAuthority},H=await Promise.all((0,A.coalesce)(W.urisToOpen||[]).map(async X=>{const Q=await this.resolveOpenable(X,N);if(Q)return Q.label=X.label,Q;const $=this.resourceFromOpenable(X);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,o.localize)(0,null)],message:$.scheme===y.Schemas.file?(0,o.localize)(1,null):(0,o.localize)(2,null),detail:$.scheme===y.Schemas.file?(0,o.localize)(3,null,(0,f.getPathLabel)($,{os:p.OS,tildify:this.environmentMainService})):(0,o.localize)(4,null,$.toString(!0))},i.BrowserWindow.getFocusedWindow()??void 0)}));return(0,A.coalesce)(H)}async doExtractPathsFromCLI(W){const N=[],H={ignoreFileNotFound:!0,gotoLineMode:W.goto,remoteAuthority:W.remote||void 0,forceOpenWorkspaceAsFile:W.diff&&W._.length===2||W.merge&&W._.length===4},X=W["folder-uri"];if(X){const ee=await Promise.all(X.map(fe=>{const me=this.cliArgToUri(fe);if(me)return this.resolveOpenable({folderUri:me},H)}));N.push(...(0,A.coalesce)(ee))}const Q=W["file-uri"];if(Q){const ee=await Promise.all(Q.map(fe=>{const me=this.cliArgToUri(fe);if(me)return this.resolveOpenable((0,ie.hasWorkspaceFileExtension)(fe)?{workspaceUri:me}:{fileUri:me},H)}));N.push(...(0,A.coalesce)(ee))}const $=await Promise.all(W._.map(ee=>H.remoteAuthority?this.doResolveRemotePath(ee,H):this.doResolveFilePath(ee,H)));return N.push(...(0,A.coalesce)($)),N}cliArgToUri(W){try{const N=I.URI.parse(W);if(!N.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${W}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.logService.error(`Invalid URI input string: ${W}, ${N.message}`)}}async doGetPathsFromLastSession(){const W=this.getRestoreWindowsSetting();switch(W){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];W!=="one"&&N.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&N.push(this.windowsStateHandler.state.lastActiveWindow);const H=await Promise.all(N.map(async X=>{if(X.workspace){const Q=await this.resolveOpenable({workspaceUri:X.workspace.configPath},{remoteAuthority:X.remoteAuthority,rejectTransientWorkspaces:!0});if(he(Q))return Q}else if(X.folderUri){const Q=await this.resolveOpenable({folderUri:X.folderUri},{remoteAuthority:X.remoteAuthority});if(ne(Q))return Q}else if(W!=="folders"&&X.backupPath)return{backupPath:X.backupPath,remoteAuthority:X.remoteAuthority}}));return(0,A.coalesce)(H)}}}getRestoreWindowsSetting(){let W;return this.lifecycleMainService.wasRestarted?W="all":(W=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(W)||(W="all")),W}async resolveOpenable(W,N=Object.create(null)){const H=this.resourceFromOpenable(W);return H.scheme===y.Schemas.file?((0,F.isFileToOpen)(W)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(H.fsPath,N)):this.doResolveRemoteOpenable(W,N)}doResolveRemoteOpenable(W,N){let H=this.resourceFromOpenable(W);const X=(0,T.getRemoteAuthority)(H)||N.remoteAuthority;if(H=(0,w.removeTrailingPathSeparator)((0,w.normalizePath)(H)),(0,F.isFileToOpen)(W)){if(N.gotoLineMode){const{path:Q,line:$,column:ee}=(0,d.parseLineAndColumnAware)(H.path);return{fileUri:H.with({path:Q}),options:{selection:$?{startLineNumber:$,startColumn:ee||1}:void 0},remoteAuthority:X}}return{fileUri:H,remoteAuthority:X}}else if((0,F.isWorkspaceToOpen)(W))return{workspace:(0,oe.getWorkspaceIdentifier)(H),remoteAuthority:X};return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(H),remoteAuthority:X}}resourceFromOpenable(W){return(0,F.isWorkspaceToOpen)(W)?W.workspaceUri:(0,F.isFolderToOpen)(W)?W.folderUri:W.fileUri}async doResolveFilePath(W,N,H){let X,Q;N.gotoLineMode&&({path:W,line:X,column:Q}=(0,d.parseLineAndColumnAware)(W)),W=(0,d.sanitizeFilePath)((0,h.normalize)(W),(0,v.cwd)());try{const $=await s.Promises.stat(W);if($.isFile()){if(!N.forceOpenWorkspaceAsFile){const ee=await this.workspacesManagementMainService.resolveLocalWorkspace(I.URI.file(W));if(ee)return ee.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:ee.id,configPath:ee.configPath},type:c.FileType.File,exists:!0,remoteAuthority:ee.remoteAuthority,transient:ee.transient}}return{fileUri:I.URI.file(W),type:c.FileType.File,exists:!0,options:{selection:X?{startLineNumber:X,startColumn:Q||1}:void 0}}}else{if($.isDirectory())return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(I.URI.file(W),$),type:c.FileType.Directory,exists:!0};if(!p.isWindows&&W==="/dev/null")return{fileUri:I.URI.file(W),type:c.FileType.File,exists:!0}}}catch($){if($.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!H)return this.onUNCHostNotAllowed(W,N);const ee=I.URI.file(W);if(this.workspacesHistoryMainService.removeRecentlyOpened([ee]),N.ignoreFileNotFound)return{fileUri:ee,type:c.FileType.File,exists:!1}}}async onUNCHostNotAllowed(W,N){const H=I.URI.file(W),{response:X,checkboxChecked:Q}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,o.localize)(5,null),(0,o.localize)(6,null),(0,o.localize)(7,null)],message:(0,o.localize)(8,null,H.authority),detail:(0,o.localize)(9,null,(0,f.getPathLabel)(H,{os:p.OS,tildify:this.environmentMainService})),checkboxLabel:(0,o.localize)(10,null,H.authority),cancelId:1});if(X===0){if((0,P.addUNCHostToAllowlist)(H.authority),Q){const $={channel:"vscode:configureAllowedUNCHost",args:H.authority};this.sendToFocused($.channel,$.args),this.sendToOpeningWindow($.channel,$.args)}return this.doResolveFilePath(W,N,!0)}if(X===2)return i.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(W,N)}doResolveRemotePath(W,N){const H=W.charCodeAt(0),X=N.remoteAuthority;let Q,$;N.gotoLineMode&&({path:W,line:Q,column:$}=(0,d.parseLineAndColumnAware)(W)),H!==b.CharCode.Slash&&((0,d.isWindowsDriveLetter)(H)&&W.charCodeAt(W.charCodeAt(1))===b.CharCode.Colon&&(W=(0,d.toSlashes)(W)),W=`/${W}`);const ee=I.URI.from({scheme:y.Schemas.vscodeRemote,authority:X,path:W});if(W.charCodeAt(W.length-1)!==b.CharCode.Slash){if((0,ie.hasWorkspaceFileExtension)(W))return N.forceOpenWorkspaceAsFile?{fileUri:ee,options:{selection:Q?{startLineNumber:Q,startColumn:$||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,oe.getWorkspaceIdentifier)(ee),remoteAuthority:X};if(N.gotoLineMode||h.posix.basename(W).indexOf(".")!==-1)return{fileUri:ee,options:{selection:Q?{startLineNumber:Q,startColumn:$||1}:void 0},remoteAuthority:X}}return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(ee),remoteAuthority:X}}shouldOpenNewWindow(W){const N=this.configurationService.getValue("window"),H=N?.openFoldersInNewWindow||"default",X=N?.openFilesInNewWindow||"off";let Q=(W.preferNewWindow||W.forceNewWindow)&&!W.forceReuseWindow;!W.forceNewWindow&&!W.forceReuseWindow&&(H==="on"||H==="off")&&(Q=H==="on");let $=!1;return W.forceNewWindow||W.forceReuseWindow?$=!!W.forceNewWindow&&!W.forceReuseWindow:(p.isMacintosh?W.context===U.OpenContext.DOCK&&($=!0):W.context!==U.OpenContext.DIALOG&&W.context!==U.OpenContext.MENU&&!(W.userEnv&&W.userEnv.TERM_PROGRAM==="vscode")&&($=!0),!W.cli.extensionDevelopmentPath&&(X==="on"||X==="off")&&($=X==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:$}}async openExtensionDevelopmentHostWindow(W,N){const H=(0,z.findWindowOnExtensionDevelopmentPath)(this.getWindows(),W);if(H)return this.lifecycleMainService.reload(H,N.cli),H.focus(),[H];let X=N.cli["folder-uri"]||[],Q=N.cli["file-uri"]||[],$=N.cli._;if(!$.length&&!X.length&&!Q.length&&!N.cli.extensionTestsPath){const me=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(I.URI.isUri(we)?we.scheme===y.Schemas.file?$=[we.fsPath]:X=[we.toString()]:we.configPath.scheme===y.Schemas.file?$=[(0,w.originalFSPath)(we.configPath)]:Q=[we.configPath.toString()])}let ee=N.remoteAuthority;for(const me of W)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=I.URI.parse(me),Re=(0,T.getRemoteAuthority)(we);Re&&(ee?(0,w.isEqualAuthority)(Re,ee)||this.logService.error("more than one extension development path authority"):ee=Re)}$=$.filter(me=>{const we=I.URI.file(me);return(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),we)?!1:(0,w.isEqualAuthority)((0,T.getRemoteAuthority)(we),ee)}),X=X.filter(me=>{const we=this.cliArgToUri(me);return we&&(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),we)?!1:we?(0,w.isEqualAuthority)((0,T.getRemoteAuthority)(we),ee):!1}),Q=Q.filter(me=>{const we=this.cliArgToUri(me);return we&&(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),we)?!1:we?(0,w.isEqualAuthority)((0,T.getRemoteAuthority)(we),ee):!1}),N.cli._=$,N.cli["folder-uri"]=X,N.cli["file-uri"]=Q;const fe={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!$.length&&!X.length&&!Q.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:ee,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(fe)}async openInBrowserWindow(W){const N=this.configurationService.getValue("window"),H=this.getLastActiveWindow(),Q=(N?.newWindowProfile?this.userDataProfilesMainService.profiles.find(fe=>fe.name===N.newWindowProfile):void 0)??H?.profile??this.userDataProfilesMainService.defaultProfile;let $;!W.forceNewWindow&&!W.forceNewTabbedWindow&&($=W.windowToUse||H,$&&$.focus());const ee={...this.environmentMainService.args,...W.cli,machineId:this.machineId,sqmId:this.sqmId,devDeviceId:this.devDeviceId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:W.emptyWindowBackupInfo?(0,h.join)(this.environmentMainService.backupHome,W.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:Q},homeDir:this.environmentMainService.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:W.remoteAuthority,workspace:W.workspace,userEnv:{...this.initialUserEnv,...W.userEnv},filesToOpenOrCreate:W.filesToOpen?.filesToOpenOrCreate,filesToDiff:W.filesToOpen?.filesToDiff,filesToMerge:W.filesToOpen?.filesToMerge,filesToWait:W.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:y.Schemas.file}).fsPath,product:L.default,isInitialStartup:W.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)(),arch:(0,k.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:i.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if($){const fe=$.config;!ee.extensionDevelopmentPath&&fe?.extensionDevelopmentPath&&(ee.extensionDevelopmentPath=fe.extensionDevelopmentPath,ee.extensionDevelopmentKind=fe.extensionDevelopmentKind,ee["enable-proposed-api"]=fe["enable-proposed-api"],ee.verbose=fe.verbose,ee["inspect-extensions"]=fe["inspect-extensions"],ee["inspect-brk-extensions"]=fe["inspect-brk-extensions"],ee.debugId=fe.debugId,ee.extensionEnvironment=fe.extensionEnvironment,ee["extensions-dir"]=fe["extensions-dir"],ee["disable-extensions"]=fe["disable-extensions"]),ee.loggers={global:ee.loggers.global,window:fe?.loggers.window??ee.loggers.window}}else{const fe=this.windowsStateHandler.getNewWindowState(ee);(0,m.mark)("code/willCreateCodeWindow");const me=$=this.instantiationService.createInstance(x.CodeWindow,{state:fe,extensionDevelopmentPath:ee.extensionDevelopmentPath,isExtensionTestHost:!!ee.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),W.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.windows.set(me.id,me),this._onDidOpenWindow.fire(me),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new g.DisposableStore;we.add(me.onDidSignalReady(()=>this._onDidSignalReadyWindow.fire(me))),we.add(l.Event.once(me.onDidClose)(()=>this.onWindowClosed(me,we))),we.add(l.Event.once(me.onDidDestroy)(()=>this.onWindowDestroyed(me))),we.add(me.onDidMaximize(()=>this._onDidMaximizeWindow.fire(me))),we.add(me.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(me))),we.add(me.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:Pe,y:De})=>this._onDidTriggerSystemContextMenu.fire({window:me,x:Pe,y:De})));const Re=(0,E.assertIsDefined)(me.win?.webContents);Re.removeAllListeners("devtools-reload-page"),we.add(l.Event.fromNodeEventEmitter(Re,"devtools-reload-page")(()=>this.lifecycleMainService.reload(me))),this.lifecycleMainService.registerWindow(me)}return ee.windowId=$.id,$.isReady?this.lifecycleMainService.unload($,q.UnloadReason.LOAD).then(async fe=>{fe||await this.doOpenInBrowserWindow($,ee,W,Q)}):await this.doOpenInBrowserWindow($,ee,W,Q),$}async doOpenInBrowserWindow(W,N,H,X){if(N.extensionDevelopmentPath||((0,ie.isWorkspaceIdentifier)(N.workspace)?N.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,ie.isSingleFolderWorkspaceIdentifier)(N.workspace)?N.backupPath=this.backupMainService.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:H.emptyWindowBackupInfo?.backupFolder??(0,oe.createEmptyWorkspaceIdentifier)().id,remoteAuthority:N.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const Q=N.workspace??(0,ie.toWorkspaceIdentifier)(N.backupPath,!1),$=this.resolveProfileForBrowserWindow(H,Q,X),ee=$ instanceof Promise?await $:$;N.profiles.profile=ee,N.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(Q,ee)}W.load(N)}resolveProfileForBrowserWindow(W,N,H){return W.forceProfile?this.userDataProfilesMainService.profiles.find(X=>X.name===W.forceProfile)??this.userDataProfilesMainService.createNamedProfile(W.forceProfile):W.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(N)??H}onWindowClosed(W,N){this.windows.delete(W.id),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}onWindowDestroyed(W){this.windows.delete(W.id),this._onDidDestroyWindow.fire(W)}getFocusedWindow(){const W=i.BrowserWindow.getFocusedWindow();if(W)return this.getWindowById(W.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(W){return this.doGetLastActiveWindow(this.getWindows().filter(N=>(0,w.isEqualAuthority)(N.remoteAuthority,W)))}doGetLastActiveWindow(W){return(0,U.getLastFocused)(W)}sendToFocused(W,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(W,R.CancellationToken.None,...N)}sendToOpeningWindow(W,...N){this._register(l.Event.once(this.onDidSignalReadyWindow)(H=>{H.sendWhenReady(W,R.CancellationToken.None,...N)}))}sendToAll(W,N,H){for(const X of this.getWindows())H&&H.indexOf(X.id)>=0||X.sendWhenReady(W,R.CancellationToken.None,N)}getWindows(){return Array.from(this.windows.values())}getWindowCount(){return this.windows.size}getWindowById(W){return this.windows.get(W)}getWindowByWebContents(W){const N=i.BrowserWindow.fromWebContents(W);if(!N)return;const H=this.getWindowById(N.id);return H?.matches(W)?H:void 0}};e.WindowsMainService=J,e.WindowsMainService=J=Ie([se(4,D.ILogService),se(5,ae.ILoggerMainService),se(6,C.IStateService),se(7,B.IPolicyService),se(8,n.IEnvironmentMainService),se(9,V.IUserDataProfilesMainService),se(10,S.ILifecycleMainService),se(11,t.IBackupMainService),se(12,r.IConfigurationService),se(13,G.IWorkspacesHistoryMainService),se(14,te.IWorkspacesManagementMainService),se(15,u.IInstantiationService),se(16,a.IDialogMainService),se(17,c.IFileService),se(18,M.IProtocolMainService),se(19,O.IThemeMainService),se(20,j.IAuxiliaryWindowsMainService)],J)}),define(le[314],ce([0,1,68,29,88,60]),function(K,e,i,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let A=class{constructor(b,l,d,f){this.workspacesManagementMainService=b,this.windowsMainService=l,this.workspacesHistoryMainService=d,this.backupMainService=f,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(b,l){const d=this.windowsMainService.getWindowById(b);if(d)return this.workspacesManagementMainService.enterWorkspace(d,this.windowsMainService.getWindows(),l)}createUntitledWorkspace(b,l,d){return this.workspacesManagementMainService.createUntitledWorkspace(l,d)}deleteUntitledWorkspace(b,l){return this.workspacesManagementMainService.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(b,l){return this.workspacesManagementMainService.getWorkspaceIdentifier(l)}getRecentlyOpened(b){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(b,l){return this.workspacesHistoryMainService.addRecentlyOpened(l)}removeRecentlyOpened(b,l){return this.workspacesHistoryMainService.removeRecentlyOpened(l)}clearRecentlyOpened(b){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=A,e.WorkspacesMainService=A=Ie([se(0,k.IWorkspacesManagementMainService),se(1,s.IWindowsMainService),se(2,P.IWorkspacesHistoryMainService),se(3,i.IBackupMainService)],A)}),define(le[315],ce([0,1,14,107,37,27,17,48,16,31,3,40,49,2,13,9,4,12,7,33,163,45,164,119,296,167,68,289,18,297,96,136,58,97,225,25,67,101,213,300,215,216,217,15,229,99,82,6,98,224,306,290,298,20,5,312,74,28,71,301,102,34,279,87,129,24,256,257,56,51,269,294,307,295,308,133,271,272,273,276,304,57,29,313,278,30,103,88,314,60,41,238,59,249,55,86,134,281,299,286,8,259,280,233,70,303,275,22,72,302,267,244,65,83,310,76]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I,o,t,r,a,n,c,u,S,D,L,M,T,C,F,x,U,z,re,ie,oe,G,te,q,O,B,V,ae,j,he,ne,J,_,W,N,H,X,Q,$,ee,fe,me,we,Re,Pe,De,ke,pe,Y,ue,de,Se,Me,Ne,_e,Le,Ue,Ve,Xe,ze,Qe,Ke,Ge,Fe,Z,ge,ve,ye,Oe,xe,Ye,at,nt,st,Ze,lt,ot,ut,dt,Dt,gt,mt,Rt,kt,Mt,pt,Lt,yt,ht,At,Ct,vt,Tt,Et,Ot,bt){"use strict";var wt;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let St=class extends y.Disposable{static{wt=this}static{this.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY={[h.Schemas.file]:"security.promptForLocalFileProtocolHandling",[h.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ae,Ce,Te,Ee,be,qe,$e,je,We,He,Be,Je){super(),this.mainProcessNodeIpcServer=Ae,this.userEnv=Ce,this.mainInstantiationService=Te,this.logService=Ee,this.loggerService=be,this.environmentMainService=qe,this.lifecycleMainService=$e,this.configurationService=je,this.stateService=We,this.fileService=He,this.productService=Be,this.userDataProfilesMainService=Je,this.configureSession(),this.registerListeners()}configureSession(){const Ae=We=>We?.startsWith(`${h.Schemas.vscodeWebview}://`),Ce=new Set(["clipboard-read","clipboard-sanitized-write"]);i.session.defaultSession.setPermissionRequestHandler((We,He,Be,Je)=>Ae(Je.requestingUrl)?Be(Ce.has(He)):Be(!1)),i.session.defaultSession.setPermissionCheckHandler((We,He,Be,Je)=>Ae(Je.requestingUrl)?Ce.has(He):!1);const Te=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,h.Schemas.vscodeManagedRemoteResource,"devtools"]),Ee=We=>{for(let He=We;He;He=He.parent)if(He.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},be=We=>We.resourceType==="xhr"||Ee(We.frame),qe=We=>{const He=We.frame;if(!He||!this.windowsMainService)return!1;const Be=i.BrowserWindow.getAllWindows();for(const Je of Be)if(He.processId===Je.webContents.mainFrame.processId)return!0;return!1},$e=(We,He)=>{if(We.path!=="/index.html")return!0;const Be=He.frame;if(!Be||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&Be.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};i.session.defaultSession.webRequest.onBeforeRequest((We,He)=>{const Be=w.URI.parse(We.url);return Be.scheme===h.Schemas.vscodeWebview&&!$e(Be,We)?(this.logService.error("Blocked vscode-webview request",We.url),He({cancel:!0})):Be.scheme===h.Schemas.vscodeFileResource&&!qe(We)?(this.logService.error("Blocked vscode-file request",We.url),He({cancel:!0})):Be.path.endsWith(".svg")&&!Te.has(Be.scheme)?He({cancel:!be(We)}):He({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((We,He)=>{const Be=We.responseHeaders,Je=Be["content-type"]||Be["Content-Type"];if(Je&&Array.isArray(Je)){const et=w.URI.parse(We.url);if(et.path.endsWith(".svg")&&Te.has(et.scheme))return Be["Content-Type"]=["image/svg+xml"],He({cancel:!1,responseHeaders:Be});if(!et.path.endsWith(h.Schemas.vscodeRemoteResource)&&Je.some(rt=>rt.toLowerCase().includes("image/svg")))return He({cancel:!be(We)})}return He({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((We,He)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Be=We.responseHeaders??Object.create(null);if(Be["Access-Control-Allow-Origin"]===void 0)return Be["Access-Control-Allow-Origin"]=["*"],He({cancel:!1,responseHeaders:Be})}return He({cancel:!1})});const je=i.session.defaultSession;typeof je.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&je.setCodeCachePath((0,m.join)(this.environmentMainService.codeCachePath,"chrome")),p.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,s.disableUNCAccessRestrictions)():(0,s.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,b.setUnexpectedErrorHandler)(Te=>this.onUnexpectedError(Te)),process.on("uncaughtException",Te=>{(0,b.isSigPipeError)(Te)||(0,b.onUnexpectedError)(Te)}),process.on("unhandledRejection",Te=>(0,b.onUnexpectedError)(Te)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,I.registerContextMenuListener)(),i.app.on("accessibility-support-changed",(Te,Ee)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ee)}),i.app.on("activate",async(Te,Ee)=>{this.logService.trace("app#activate"),Ee||await this.windowsMainService?.openEmptyWindow({context:Ge.OpenContext.DOCK})}),i.app.on("web-contents-created",(Te,Ee)=>{Ee?.opener?.url.startsWith(`${h.Schemas.vscodeFileResource}://${h.VSCODE_AUTHORITY}/`)&&(this.logService.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.auxiliaryWindowsMainService?.registerWindow(Ee)),Ee.on("will-navigate",be=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),be.preventDefault()}),Ee.setWindowOpenHandler(be=>be.url==="about:blank"?(this.logService.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.auxiliaryWindowsMainService?.createWindow(be)}):(this.logService.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${be.url}}`),this.nativeHostMainService?.openExternal(void 0,be.url),{action:"deny"}))});let Ae=[],Ce;i.app.on("open-file",(Te,Ee)=>{Ee=(0,bt.normalizeNFC)(Ee),this.logService.trace("app#open-file: ",Ee),Te.preventDefault(),Ae.push((0,ge.hasWorkspaceFileExtension)(Ee)?{workspaceUri:w.URI.file(Ee)}:{fileUri:w.URI.file(Ee)}),Ce!==void 0&&(clearTimeout(Ce),Ce=void 0),Ce=setTimeout(async()=>{await this.windowsMainService?.open({context:Ge.OpenContext.DOCK,cli:this.environmentMainService.args,urisToOpen:Ae,gotoLineMode:!1,preferNewWindow:!0}),Ae=[],Ce=void 0},100)}),i.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:Ge.OpenContext.DESKTOP})}),P.validatedIpcMain.handle("vscode:fetchShellEnv",Te=>{const Ee=this.windowsMainService?.getWindowByWebContents(Te.sender);let be,qe;return Ee?.config?(be=Ee.config,qe={...process.env,...Ee.config.userEnv}):(be=this.environmentMainService.args,qe=process.env),this.resolveShellEnvironment(be,qe,!1)}),P.validatedIpcMain.handle("vscode:writeNlsFile",(Te,Ee,be)=>{const qe=this.validateNlsPath([Ee]);if(!qe||typeof be!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(qe,A.VSBuffer.fromString(be))}),P.validatedIpcMain.handle("vscode:readNlsFile",async(Te,...Ee)=>{const be=this.validateNlsPath(Ee);if(!be)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(be)).value.toString()}),P.validatedIpcMain.on("vscode:toggleDevTools",Te=>Te.sender.toggleDevTools()),P.validatedIpcMain.on("vscode:openDevTools",Te=>Te.sender.openDevTools()),P.validatedIpcMain.on("vscode:reloadWindow",Te=>Te.sender.reload()),P.validatedIpcMain.handle("vscode:notifyZoomLevel",async(Te,Ee)=>{const be=this.windowsMainService?.getWindowByWebContents(Te.sender);be&&be.notifyZoomLevel(Ee)})}validateNlsPath(Ae){let Ce;for(const Te of Ae)typeof Te=="string"&&(typeof Ce!="string"?Ce=Te:Ce=(0,m.join)(Ce,Te));if(!(typeof Ce!="string"||!(0,m.isAbsolute)(Ce)||!(0,l.isEqualOrParent)(Ce,this.environmentMainService.cachedLanguagesPath,!p.isLinux)))return w.URI.file(Ce)}onUnexpectedError(Ae){if(Ae){const Ce={message:`[uncaught exception in main]: ${Ae.message}`,stack:Ae.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Ce))}this.logService.error(`[uncaught exception in main]: ${Ae}`),Ae.stack&&this.logService.error(Ae.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ae=this.productService.win32AppUserModelId;p.isWindows&&Ae&&i.app.setAppUserModelId(Ae);try{p.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Be){this.logService.error(Be)}const Ce=new t.Server;this.lifecycleMainService.onWillShutdown(Be=>{Be.reason===W.ShutdownReason.KILL&&Ce.dispose()}),this.logService.trace("Resolving machine identifier...");const[Te,Ee,be]=await Promise.all([(0,mt.resolveMachineId)(this.stateService,this.logService),(0,mt.resolveSqmId)(this.stateService,this.logService),(0,mt.resolvedevDeviceId)(this.stateService,this.logService)]);this.logService.trace(`Resolved machine identifier: ${Te}`);const{sharedProcessReady:qe,sharedProcessClient:$e}=this.setupSharedProcess(Te,Ee,be),je=await this.initServices(Te,Ee,be,qe);this._register(je.createInstance(a.ProxyAuthHandler)),this._register(je.createInstance(dt.UserDataProfilesHandler)),je.invokeFunction(Be=>this.initChannels(Be,Ce,$e));const We=await je.invokeFunction(Be=>this.setupProtocolUrlHandlers(Be,Ce));this.setupManagedRemoteResourceUrlHandler(Ce),this.lifecycleMainService.phase=W.LifecycleMainPhase.Ready,await je.invokeFunction(Be=>this.openFirstWindow(Be,We)),this.lifecycleMainService.phase=W.LifecycleMainPhase.AfterWindowOpen,this.afterWindowOpen(),this._register(new gt.RunOnceScheduler(()=>{this._register((0,gt.runWhenGlobalIdle)(()=>this.lifecycleMainService.phase=W.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async setupProtocolUrlHandlers(Ae,Ce){const Te=this.windowsMainService=Ae.get(Ge.IWindowsMainService),Ee=Ae.get(Le.IURLService),be=this.nativeHostMainService=Ae.get(X.INativeHostMainService),qe=Ae.get(T.IDialogMainService),$e=this;Ee.registerHandler({async handleURL(et,rt){return $e.handleProtocolUrl(Te,qe,Ee,et,rt)}});const je=this._register(new Z.ActiveWindowManager({onDidOpenMainWindow:be.onDidOpenMainWindow,onDidFocusMainWindow:be.onDidFocusMainWindow,getActiveWindowId:()=>be.getActiveWindowId(-1)})),We=new o.StaticRouter(et=>je.getActiveClientId().then(rt=>et===rt)),He=new Ue.URLHandlerRouter(We,this.logService),Be=Ce.getChannel("urlHandler",He);Ee.registerHandler(new Ue.URLHandlerChannelClient(Be));const Je=await this.resolveInitialProtocolUrls(Te,qe);return this._register(new Xe.ElectronURLListener(Je?.urls,Ee,Te,this.environmentMainService,this.productService,this.logService)),Je}setupManagedRemoteResourceUrlHandler(Ae){const Ce=()=>({statusCode:404,data:"Not found"}),Te=new Tt.Lazy(()=>Ae.getChannel(vt.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new vt.NodeRemoteResourceRouter));i.protocol.registerBufferProtocol(h.Schemas.vscodeManagedRemoteResource,(Ee,be)=>{const qe=w.URI.parse(Ee.url);if(!qe.authority.startsWith("window:"))return be(Ce());Te.value.call(vt.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[qe]).then($e=>be({...$e,data:Buffer.from($e.body,"base64")}),$e=>{this.logService.warn("error dispatching remote resource call",$e),be({statusCode:500,data:String($e)})})})}async resolveInitialProtocolUrls(Ae,Ce){const Te=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Te.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Te);const Ee=global.getOpenUrls()||[];if(Ee.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ee),Te.length+Ee.length===0)return;const be=[...Te,...Ee].map(je=>{try{return{uri:w.URI.parse(je),originalUrl:je}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",je);return}}),qe=[],$e=[];for(const je of be){if(!je)continue;const We=this.getWindowOpenableFromProtocolUrl(je.uri);if(We)if(await this.shouldBlockOpenable(We,Ae,Ce)){this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",je.uri.toString(!0));continue}else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",je.uri.toString(!0),We),qe.push(We);else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",je.uri.toString(!0)),$e.push(je)}return{urls:$e,openables:qe}}async shouldBlockOpenable(Ae,Ce,Te){let Ee,be;if((0,Ke.isWorkspaceToOpen)(Ae)?(Ee=Ae.workspaceUri,be=(0,n.localize)(0,null,Ee.scheme===h.Schemas.file?(0,g.getPathLabel)(Ee,{os:p.OS,tildify:this.environmentMainService}):Ee.toString(!0),this.productService.nameShort)):(0,Ke.isFolderToOpen)(Ae)?(Ee=Ae.folderUri,be=(0,n.localize)(1,null,Ee.scheme===h.Schemas.file?(0,g.getPathLabel)(Ee,{os:p.OS,tildify:this.environmentMainService}):Ee.toString(!0),this.productService.nameShort)):(Ee=Ae.fileUri,be=(0,n.localize)(2,null,Ee.scheme===h.Schemas.file?(0,g.getPathLabel)(Ee,{os:p.OS,tildify:this.environmentMainService}):Ee.toString(!0),this.productService.nameShort)),Ee.scheme!==h.Schemas.file&&Ee.scheme!==h.Schemas.vscodeRemote||this.configurationService.getValue(wt.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY[Ee.scheme])===!1)return!1;const{response:$e,checkboxChecked:je}=await Te.showMessageBox({type:"warning",buttons:[(0,n.localize)(3,null),(0,n.localize)(4,null)],message:be,detail:(0,n.localize)(5,null),checkboxLabel:Ee.scheme===h.Schemas.file?(0,n.localize)(6,null):(0,n.localize)(7,null),cancelId:1});if($e!==0)return!0;if(je){const We={channel:"vscode:disablePromptForProtocolHandling",args:Ee.scheme===h.Schemas.file?"local":"remote"};Ce.sendToFocused(We.channel,We.args),Ce.sendToOpeningWindow(We.channel,We.args)}return!1}getWindowOpenableFromProtocolUrl(Ae){if(Ae.path){if(Ae.authority===h.Schemas.file){const Ce=w.URI.file(Ae.fsPath);return(0,ge.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Ce}:{fileUri:Ce}}else if(Ae.authority===h.Schemas.vscodeRemote){const Ce=Ae.path.indexOf(m.posix.sep,1);if(Ce!==-1){const Te=Ae.path.substring(1,Ce),Ee=Ae.path.substring(Ce);let be=Ae.query;const qe=new URLSearchParams(Ae.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),be=qe.toString());const $e=w.URI.from({scheme:h.Schemas.vscodeRemote,authority:Te,path:Ee,query:be,fragment:Ae.fragment});return(0,ge.hasWorkspaceFileExtension)(Ee)?{workspaceUri:$e}:/:[\d]+$/.test(Ee)?{fileUri:$e}:{folderUri:$e}}}}}async handleProtocolUrl(Ae,Ce,Te,Ee,be){this.logService.trace("app#handleProtocolUrl():",Ee.toString(!0),be),Ee.scheme===this.productService.urlProtocol&&Ee.path==="workspace"&&(Ee=Ee.with({authority:"file",path:w.URI.parse(Ee.query).path,query:""}));let qe=!1;const $e=new URLSearchParams(Ee.query);$e.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),$e.delete("windowId"),Ee=Ee.with({query:$e.toString()}),qe=!0):p.isMacintosh&&Ae.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),qe=!0);const je=$e.get("continueOn");je!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Ee.toString(!0)),$e.delete("continueOn"),Ee=Ee.with({query:$e.toString()}),this.environmentMainService.continueOn=je??void 0);const We=this.getWindowOpenableFromProtocolUrl(Ee);return We?await this.shouldBlockOpenable(We,Ae,Ce)?(this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",Ee.toString(!0)),!0):(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",We,Ee.toString(!0)),(0,yt.firstOrDefault)(await Ae.open({context:Ge.OpenContext.API,cli:{...this.environmentMainService.args},urisToOpen:[We],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Ee.toString(!0)),await(0,yt.firstOrDefault)(await Ae.open({context:Ge.OpenContext.API,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,$.getRemoteAuthority)(Ee)}))?.ready(),Te.open(Ee,be)):(this.logService.trace("app#handleProtocolUrl(): not handled",Ee.toString(!0),be),!1)}setupSharedProcess(Ae,Ce,Te){const Ee=this._register(this.mainInstantiationService.createInstance(ee.SharedProcess,Ae,Ce,Te));this._register(Ee.onDidCrash(()=>this.windowsMainService?.sendToFocused("vscode:reportSharedProcessCrash")));const be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const $e=await Ee.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new r.Client($e,"main")})();return{sharedProcessReady:(async()=>(await Ee.whenReady(),be))(),sharedProcessClient:be}}async initServices(Ae,Ce,Te,Ee){const be=new j.ServiceCollection;switch(process.platform){case"win32":be.set(ue.IUpdateService,new V.SyncDescriptor(_e.Win32UpdateService));break;case"linux":p.isLinuxSnap?be.set(ue.IUpdateService,new V.SyncDescriptor(Ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(ue.IUpdateService,new V.SyncDescriptor(Me.LinuxUpdateService));break;case"darwin":be.set(ue.IUpdateService,new V.SyncDescriptor(Se.DarwinUpdateService));break}be.set(Ge.IWindowsMainService,new V.SyncDescriptor(Fe.WindowsMainService,[Ae,Ce,Te,this.userEnv],!1)),be.set(Et.IAuxiliaryWindowsMainService,new V.SyncDescriptor(Ot.AuxiliaryWindowsMainService,void 0,!1));const qe=new T.DialogMainService(this.logService,this.productService);be.set(T.IDialogMainService,qe),be.set(_.ILaunchMainService,new V.SyncDescriptor(_.LaunchMainService,void 0,!1)),be.set(M.IDiagnosticsMainService,new V.SyncDescriptor(M.DiagnosticsMainService,void 0,!1)),be.set(L.IDiagnosticsService,o.ProxyChannel.toService((0,o.getDelayedChannel)(Ee.then(Be=>Be.getChannel("diagnostics"))))),be.set(he.IIssueMainService,new V.SyncDescriptor(ne.IssueMainService,[this.userEnv])),be.set(C.IEncryptionMainService,new V.SyncDescriptor(F.EncryptionMainService)),be.set(J.IKeyboardLayoutMainService,new V.SyncDescriptor(J.KeyboardLayoutMainService)),be.set(X.INativeHostMainService,new V.SyncDescriptor(X.NativeHostMainService,void 0,!1)),be.set(ze.IWebviewManagerService,new V.SyncDescriptor(Qe.WebviewMainService)),be.set(H.IMenubarMainService,new V.SyncDescriptor(H.MenubarMainService)),be.set(re.IExtensionHostStarter,new V.SyncDescriptor(ie.ExtensionHostStarter)),be.set(Re.IStorageMainService,new V.SyncDescriptor(Re.StorageMainService)),be.set(Re.IApplicationStorageMainService,new V.SyncDescriptor(Re.ApplicationStorageMainService));const $e=new At.ElectronPtyHostStarter({graceTime:ht.LocalReconnectConstants.GraceTime,shortGraceTime:ht.LocalReconnectConstants.ShortGraceTime,scrollback:this.configurationService.getValue(ht.TerminalSettingId.PersistentSessionScrollback)??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),je=new Ct.PtyHostService($e,this.configurationService,this.logService,this.loggerService);be.set(ht.ILocalPtyService,je),p.isWindows?be.set(oe.IExternalTerminalMainService,new V.SyncDescriptor(G.WindowsExternalTerminalService)):p.isMacintosh?be.set(oe.IExternalTerminalMainService,new V.SyncDescriptor(G.MacExternalTerminalService)):p.isLinux&&be.set(oe.IExternalTerminalMainService,new V.SyncDescriptor(G.LinuxExternalTerminalService));const We=new u.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);be.set(c.IBackupMainService,We);const He=new xe.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,We,qe);if(be.set(xe.IWorkspacesManagementMainService,He),be.set(ve.IWorkspacesService,new V.SyncDescriptor(Oe.WorkspacesMainService,void 0,!1)),be.set(ye.IWorkspacesHistoryMainService,new V.SyncDescriptor(ye.WorkspacesHistoryMainService,void 0,!1)),be.set(Le.IURLService,new V.SyncDescriptor(Ve.NativeURLService,void 0,!1)),(0,Y.supportsTelemetry)(this.productService,this.environmentMainService)){const Be=(0,Y.isInternalTelemetry)(this.productService,this.configurationService),Je=(0,o.getDelayedChannel)(Ee.then(ft=>ft.getChannel("telemetryAppender"))),et=new ke.TelemetryAppenderClient(Je),rt=(0,Pe.resolveCommonProperties)((0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,Ae,Ce,Te,Be),tt=(0,Y.getPiiPathsFromEnvironment)(this.environmentMainService),ct={appenders:[et],commonProperties:rt,piiPaths:tt,sendErrorTelemetry:!0};be.set(De.ITelemetryService,new V.SyncDescriptor(pe.TelemetryService,[ct],!1))}else be.set(De.ITelemetryService,Y.NullTelemetryService);return be.set(lt.IExtensionsProfileScannerService,new V.SyncDescriptor(Rt.ExtensionsProfileScannerService,void 0,!0)),be.set(ot.IExtensionsScannerService,new V.SyncDescriptor(ut.ExtensionsScannerService,void 0,!0)),be.set(pt.IUtilityProcessWorkerMainService,new V.SyncDescriptor(pt.UtilityProcessWorkerMainService,void 0,!0)),await gt.Promises.settled([We.initialize(),He.initialize()]),this.mainInstantiationService.createChild(be)}initChannels(Ae,Ce,Te){const Ee=this._register(new y.DisposableStore),be=o.ProxyChannel.fromService(Ae.get(_.ILaunchMainService),Ee,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",be);const qe=o.ProxyChannel.fromService(Ae.get(M.IDiagnosticsMainService),Ee,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",qe);const $e=Ee.add(new at.PolicyChannel(Ae.get(Ye.IPolicyService)));Ce.registerChannel("policy",$e),Te.then(it=>it.registerChannel("policy",$e));const je=this.fileService.getProvider(h.Schemas.file);(0,v.assertType)(je instanceof B.DiskFileSystemProvider);const We=Ee.add(new O.DiskFileSystemProviderChannel(je,this.logService,this.environmentMainService));Ce.registerChannel(te.LOCAL_FILE_SYSTEM_CHANNEL_NAME,We),Te.then(it=>it.registerChannel(te.LOCAL_FILE_SYSTEM_CHANNEL_NAME,We));const He=o.ProxyChannel.fromService(Ae.get(nt.IUserDataProfilesMainService),Ee);Ce.registerChannel("userDataProfiles",He),Te.then(it=>it.registerChannel("userDataProfiles",He));const Be=new st.RequestChannel(Ae.get(Ze.IRequestService));Te.then(it=>it.registerChannel("request",Be));const Je=new de.UpdateChannel(Ae.get(ue.IUpdateService));Ce.registerChannel("update",Je);const et=o.ProxyChannel.fromService(Ae.get(he.IIssueMainService),Ee);Ce.registerChannel("issue",et);const rt=o.ProxyChannel.fromService(Ae.get(C.IEncryptionMainService),Ee);Ce.registerChannel("encryption",rt);const tt=o.ProxyChannel.fromService(Ae.get(fe.ISignService),Ee);Ce.registerChannel("sign",tt);const ct=o.ProxyChannel.fromService(Ae.get(J.IKeyboardLayoutMainService),Ee);Ce.registerChannel("keyboardLayout",ct),this.nativeHostMainService=Ae.get(X.INativeHostMainService);const ft=o.ProxyChannel.fromService(this.nativeHostMainService,Ee);Ce.registerChannel("nativeHost",ft),Te.then(it=>it.registerChannel("nativeHost",ft));const _t=o.ProxyChannel.fromService(Ae.get(ve.IWorkspacesService),Ee);Ce.registerChannel("workspaces",_t);const Wt=o.ProxyChannel.fromService(Ae.get(H.IMenubarMainService),Ee);Ce.registerChannel("menubar",Wt);const Ft=o.ProxyChannel.fromService(Ae.get(Le.IURLService),Ee);Ce.registerChannel("url",Ft);const Nt=o.ProxyChannel.fromService(Ae.get(ze.IWebviewManagerService),Ee);Ce.registerChannel("webview",Nt);const It=Ee.add(new we.StorageDatabaseChannel(this.logService,Ae.get(Re.IStorageMainService)));Ce.registerChannel("storage",It),Te.then(it=>it.registerChannel("storage",It));const Ut=Ee.add(new Dt.ProfileStorageChangesListenerChannel(Ae.get(Re.IStorageMainService),Ae.get(nt.IUserDataProfilesMainService),this.logService));Te.then(it=>it.registerChannel("profileStorageListener",Ut));const xt=o.ProxyChannel.fromService(Ae.get(ht.ILocalPtyService),Ee);Ce.registerChannel(ht.TerminalIpcChannels.LocalPty,xt);const Bt=o.ProxyChannel.fromService(Ae.get(oe.IExternalTerminalMainService),Ee);Ce.registerChannel("externalTerminal",Bt);const Pt=new kt.LoggerChannel(Ae.get(Mt.ILoggerMainService));Ce.registerChannel("logger",Pt),Te.then(it=>it.registerChannel("logger",Pt));const zt=new D.ElectronExtensionHostDebugBroadcastChannel(Ae.get(Ge.IWindowsMainService));Ce.registerChannel("extensionhostdebugservice",zt);const qt=o.ProxyChannel.fromService(Ae.get(re.IExtensionHostStarter),Ee);Ce.registerChannel(re.ipcExtensionHostStarterChannelName,qt);const Ht=o.ProxyChannel.fromService(Ae.get(pt.IUtilityProcessWorkerMainService),Ee);Ce.registerChannel(Lt.ipcUtilityProcessWorkerChannelName,Ht)}async openFirstWindow(Ae,Ce){const Te=this.windowsMainService=Ae.get(Ge.IWindowsMainService);this.auxiliaryWindowsMainService=Ae.get(Et.IAuxiliaryWindowsMainService);const Ee=(0,U.isLaunchedFromCli)(process.env)?Ge.OpenContext.CLI:Ge.OpenContext.DESKTOP,be=this.environmentMainService.args;if(Ce){if(Ce.openables.length>0)return Te.open({context:Ee,cli:be,urisToOpen:Ce.openables,gotoLineMode:!0,initialStartup:!0});if(Ce.urls.length>0)for(const tt of Ce.urls){const ct=new URLSearchParams(tt.uri.query);if(ct.get("windowId")==="_blank")return ct.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:ct.toString()}),Te.open({context:Ee,cli:be,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,$e=be._.length,je=!!be["folder-uri"],We=!!be["file-uri"],He=be["skip-add-to-recently-opened"]===!0,Be=be.wait&&be.waitMarkerFilePath?w.URI.file(be.waitMarkerFilePath):void 0,Je=be.remote||void 0,et=be.profile,rt=be["profile-temp"];if(!$e&&!je&&!We){if(be["new-window"]||et||rt)return Te.open({context:Ee,cli:be,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:Be,initialStartup:!0,remoteAuthority:Je,forceProfile:et,forceTempProfile:rt});if(qe.length)return Te.open({context:Ge.OpenContext.DOCK,cli:be,urisToOpen:qe.map(tt=>(tt=(0,bt.normalizeNFC)(tt),(0,ge.hasWorkspaceFileExtension)(tt)?{workspaceUri:w.URI.file(tt)}:{fileUri:w.URI.file(tt)})),noRecentEntry:He,waitMarkerFileURI:Be,initialStartup:!0})}return Te.open({context:Ee,cli:be,forceNewWindow:be["new-window"],diffMode:be.diff,mergeMode:be.merge,noRecentEntry:He,waitMarkerFileURI:Be,gotoLineMode:be.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:et,forceTempProfile:rt})}afterWindowOpen(){this.installMutex(),i.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Ae,Ce)=>{Ce({url:Ae.url.replace(/^vscode-remote-resource:/,"http:"),method:Ae.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),p.isMacintosh&&i.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const Ae=this.productService.win32MutexName;if(p.isWindows&&Ae)try{const Ce=await new Promise((Ee,be)=>{K(["@vscode/windows-mutex"],Ee,be)}),Te=new Ce.Mutex(Ae);d.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Te.release())}catch(Ce){this.logService.error(Ce)}}async resolveShellEnvironment(Ae,Ce,Te){try{return await(0,z.getResolvedShellEnv)(this.configurationService,this.logService,Ae,Ce)}catch(Ee){const be=(0,R.toErrorMessage)(Ee);Te?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",be):this.logService.error(be)}return{}}async updateCrashReporterEnablement(){try{const Ce=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Te=JSON.parse((0,f.stripComments)(Ce)),be=(0,Y.getTelemetryLevel)(this.configurationService)>=De.TelemetryLevel.CRASH;if(Te["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${be},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,E.generateUuid)()}"`,"}"],$e=Ce.substring(0,Ce.length-2).concat(`,
`,qe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,A.VSBuffer.fromString($e))}else{const qe=Ce.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${be},`);qe!==Ce&&await this.fileService.writeFile(this.environmentMainService.argvResource,A.VSBuffer.fromString(qe))}}catch(Ae){this.logService.error(Ae)}}};e.CodeApplication=St,e.CodeApplication=St=wt=Ie([se(2,ae.IInstantiationService),se(3,N.ILogService),se(4,N.ILoggerService),se(5,x.IEnvironmentMainService),se(6,W.ILifecycleMainService),se(7,S.IConfigurationService),se(8,me.IStateService),se(9,q.IFileService),se(10,Q.IProductService),se(11,nt.IUserDataProfilesMainService)],St)}),define(le[320],ce([0,1,14,44,7,22,8,48,16,31,3,49,13,9,69,4,36,26,21,45,105,315,10,18,243,255,25,67,207,15,227,99,82,223,98,20,230,5,84,28,85,282,132,293,55,292,102,254,34,56,73,59,41,239,237,2,42,270,70,232,124,128,274,107,268]),function(K,e,i,s,P,k,A,R,b,l,d,f,g,y,h,m,p,v,w,E,I,o,t,r,a,n,c,u,S,D,L,M,T,C,F,x,U,z,re,ie,oe,G,te,q,O,B,V,ae,j,he,ne,J,_,W,N,H,X,Q,$,ee,fe,me,we,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Pe{main(){try{this.startup()}catch(pe){console.error(pe.message),i.app.exit(1)}}async startup(){(0,b.setUnexpectedErrorHandler)(Le=>console.error(Le));const[pe,Y,ue,de,Se,Me,Ne,_e]=this.createServices();try{try{await this.initServices(ue,_e,de,Se,Ne)}catch(Le){throw this.handleStartupDataDirError(ue,Ne,Le),Le}await pe.invokeFunction(async Le=>{const Ue=Le.get(z.ILogService),Ve=Le.get(x.ILifecycleMainService),Xe=Le.get(D.IFileService),ze=Le.get(z.ILoggerService),Qe=await this.claimInstance(Ue,ue,Ve,pe,Ne,!0);return w.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Ke=>{Ue.warn(`app#startup(): Error writing main lockfile: ${Ke.stack}`)}),Me.logger=ze.createLogger("main",{name:(0,t.localize)(0,null)}),d.Event.once(Ve.onWillShutdown)(Ke=>{Xe.dispose(),de.dispose(),Ke.join("instanceLockfile",w.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),pe.createInstance(o.CodeApplication,Qe,Y).startup()})}catch(Le){pe.invokeFunction(this.quit,Le)}}createServices(){const pe=new F.ServiceCollection,Y=new H.DisposableStore;process.once("exit",()=>Y.dispose());const ue={_serviceBrand:void 0,...re.default};pe.set(ie.IProductService,ue);const de=new c.EnvironmentMainService(this.resolveArgs(),ue),Se=this.patchEnvironment(de);pe.set(c.IEnvironmentMainService,de);const Me=new $.LoggerMainService((0,z.getLogLevel)(de),de.logsHome);pe.set($.ILoggerMainService,Me);const Ne=new U.BufferLogger(Me.getLogLevel()),_e=Y.add(new ee.LogService(Ne,[new z.ConsoleMainLogger(Me.getLogLevel())]));pe.set(z.ILogService,_e);const Le=new L.FileService(_e);pe.set(D.IFileService,Le);const Ue=new M.DiskFileSystemProvider(_e);Le.registerProvider(g.Schemas.file,Ue);const Ve=new Q.UriIdentityService(Le);pe.set(X.IUriIdentityService,Ve);const Xe=new me.StateService(me.SaveStrategy.DELAYED,de,_e,Le);pe.set(j.IStateReadService,Xe),pe.set(j.IStateService,Xe);const ze=new J.UserDataProfilesMainService(Xe,Ve,de,Le,_e);pe.set(J.IUserDataProfilesMainService,ze),Le.registerProvider(g.Schemas.vscodeUserData,new we.FileUserDataProvider(g.Schemas.file,Ue,g.Schemas.vscodeUserData,ze,Ve,_e));const Qe=m.isWindows&&ue.win32RegValueName?Y.add(new W.NativePolicyService(_e,ue.win32RegValueName)):de.policyFile?Y.add(new N.FilePolicyService(de.policyFile,Le,_e)):new _.NullPolicyService;pe.set(_.IPolicyService,Qe);const Ke=new a.ConfigurationService(ze.defaultProfile.settingsResource,Le,Qe,_e);return pe.set(r.IConfigurationService,Ke),pe.set(x.ILifecycleMainService,new T.SyncDescriptor(x.LifecycleMainService,void 0,!1)),pe.set(O.IRequestService,new T.SyncDescriptor(B.RequestMainService,void 0,!0)),pe.set(ne.IThemeMainService,new T.SyncDescriptor(ne.ThemeMainService)),pe.set(V.ISignService,new T.SyncDescriptor(ae.SignService,void 0,!1)),pe.set(te.ITunnelService,new T.SyncDescriptor(q.TunnelService)),pe.set(oe.IProtocolMainService,new G.ProtocolMainService(de,ze,_e)),[new C.InstantiationService(pe,!0),Se,de,Ke,Xe,Ne,ue,ze]}patchEnvironment(pe){const Y={VSCODE_IPC_HOOK:pe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const de=process.env[ue];typeof de=="string"&&(Y[ue]=de)}),Object.assign(process.env,Y),Y}async initServices(pe,Y,ue,de,Se){await A.Promises.settled([Promise.all([this.allowWindowsUNCPath(pe.extensionsPath),pe.codeCachePath,pe.logsHome.with({scheme:g.Schemas.file}).fsPath,Y.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,pe.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,pe.localHistoryHome.with({scheme:g.Schemas.file}).fsPath,pe.backupHome].map(Me=>Me?w.Promises.mkdir(Me,{recursive:!0}):void 0)),de.init(),ue.initialize()]),Y.init()}allowWindowsUNCPath(pe){if(m.isWindows){const Y=(0,Re.getUNCHost)(pe);Y&&(0,Re.addUNCHostToAllowlist)(Y)}return pe}async claimInstance(pe,Y,ue,de,Se,Me){let Ne;try{(0,h.mark)("code/willStartMainServer"),Ne=await(0,I.serve)(Y.mainIPCHandle),(0,h.mark)("code/didStartMainServer"),d.Event.once(ue.onWillShutdown)(()=>Ne.dispose())}catch(_e){if(_e.code!=="EADDRINUSE")throw this.handleStartupDataDirError(Y,Se,_e),_e;let Le;try{Le=await(0,I.connect)(Y.mainIPCHandle,"main")}catch(ze){if(!Me||m.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,Se.nameShort),(0,t.localize)(2,null),Se),ze;try{(0,s.unlinkSync)(Y.mainIPCHandle)}catch(Qe){throw pe.warn("Could not delete obsolete instance handle",Qe),Qe}return this.claimInstance(pe,Y,ue,de,Se,!1)}if(Y.extensionTestsLocationURI&&!Y.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${Se.nameShort} is running.`;throw pe.error(ze),Le.dispose(),new Error(ze)}let Ue;!Y.args.wait&&!Y.args.status&&(Ue=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,Se.nameShort),(0,t.localize)(4,null),Se)},1e4));const Ve=E.ProxyChannel.toService(Le.getChannel("launch"),{disableMarshalling:!0}),Xe=E.ProxyChannel.toService(Le.getChannel("diagnostics"),{disableMarshalling:!0});if(Y.args.status)return de.invokeFunction(async()=>{const ze=new n.DiagnosticsService(he.NullTelemetryService,Se),Qe=await Xe.getMainDiagnostics(),Ke=await Xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ge=await ze.getDiagnostics(Qe,Ke);throw console.log(Ge),new b.ExpectedError});throw m.isWindows&&await this.windowsAllowSetForegroundWindow(Ve,pe),pe.trace("Sending env to running instance..."),await Ve.start(Y.args,process.env),Le.dispose(),Ue&&clearTimeout(Ue),new b.ExpectedError("Sent env to running instance. Terminating...")}if(Y.args.status)throw console.log((0,t.localize)(5,null,Se.nameShort)),new b.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ne}handleStartupDataDirError(pe,Y,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const de=(0,k.coalesce)([pe.userDataPath,pe.extensionsPath,I.XDG_RUNTIME_DIR]).map(Se=>(0,f.getPathLabel)(P.URI.file(Se),{os:m.OS,tildify:pe}));this.showStartupWarningDialog((0,t.localize)(6,null),(0,t.localize)(7,null,(0,R.toErrorMessage)(ue),de.join(`
`)),Y)}}showStartupWarningDialog(pe,Y,ue){i.dialog.showMessageBoxSync((0,fe.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:pe,detail:Y},ue).options)}async windowsAllowSetForegroundWindow(pe,Y){if(m.isWindows){const ue=await pe.getMainProcessId();Y.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((de,Se)=>{K(["windows-foreground-love"],de,Se)})).allowSetForegroundWindow(ue)}catch(de){Y.error(de)}}}quit(pe,Y){const ue=pe.get(z.ILogService),de=pe.get(x.ILifecycleMainService);let Se=0;Y&&(Y.isExpected?Y.message&&ue.trace(Y.message):(Se=1,Y.stack?ue.error(Y.stack):ue.error(`Startup error: ${Y.toString()}`))),de.kill(Se)}resolveArgs(){const pe=this.validatePaths((0,u.parseMainProcessArgv)(process.argv));if(pe.wait&&!pe.waitMarkerFilePath){const Y=(0,S.createWaitMarkerFileSync)(pe.verbose);Y&&((0,u.addArg)(process.argv,"--waitMarkerFilePath",Y),pe.waitMarkerFilePath=Y)}return pe}validatePaths(pe){if(pe["open-url"]&&(pe._urls=pe._,pe._=[]),!pe.remote){const Y=this.doValidatePaths(pe._,pe.goto);pe._=Y}return pe}doValidatePaths(pe,Y){const ue=(0,p.cwd)(),de=pe.map(Ne=>{let _e=String(Ne),Le;Y&&(Le=(0,l.parseLineAndColumnAware)(_e),_e=Le.path),_e&&(_e=this.preparePath(ue,_e));const Ue=(0,l.sanitizeFilePath)(_e,ue),Ve=(0,y.basename)(Ue);return Ve&&!(0,l.isValidBasename)(Ve)?null:Y&&Le?(Le.path=Ue,this.toPath(Le)):Ue}),Se=m.isWindows||m.isMacintosh,Me=(0,k.distinct)(de,Ne=>Ne&&Se?Ne.toLowerCase():Ne||"");return(0,k.coalesce)(Me)}preparePath(pe,Y){return m.isWindows&&(Y=(0,v.rtrim)(Y,'"')),Y=(0,v.trim)((0,v.trim)(Y," "),"	"),m.isWindows&&(Y=(0,y.resolve)(pe,Y),Y=(0,v.rtrim)(Y,".")),Y}toPath(pe){const Y=[pe.path];return typeof pe.line=="number"&&Y.push(String(pe.line)),typeof pe.column=="number"&&Y.push(String(pe.column)),Y.join(":")}}new Pe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d98c6de73fb939f1eb4b8a500c569b858b2d297/core/vs/code/electron-main/main.js.map
