/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/keyCodes","vs/base/common/arrays","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/charCode","vs/base/browser/browser","vs/base/common/scrollable","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/list/list","vs/base/common/assert","vs/base/common/equals","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/range","vs/base/common/buffer","vs/base/common/codiconsUtil","vs/base/common/filters","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/observable","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/hash","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/browser/canIUse","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/contextview/contextview","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/codiconsLibrary","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/contextview/contextview","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/keybindings","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],De=function(oe){for(var t=[],i=0,n=oe.length;i<n;i++)t[i]=ve[oe[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Wt,setPrototypeOf:Ht,isFrozen:oi,getPrototypeOf:ai,getOwnPropertyDescriptor:li}=Object;let{freeze:at,seal:pt,create:ui}=Object,{apply:Rt,construct:Ct}=typeof Reflect<"u"&&Reflect;Rt||(Rt=function(t,i,n){return t.apply(i,n)}),at||(at=function(t){return t}),pt||(pt=function(t){return t}),Ct||(Ct=function(t,i){return new t(...i)});const ci=gt(Array.prototype.forEach),zt=gt(Array.prototype.pop),yt=gt(Array.prototype.push),Tt=gt(String.prototype.toLowerCase),Ot=gt(String.prototype.toString),hi=gt(String.prototype.match),bt=gt(String.prototype.replace),di=gt(String.prototype.indexOf),fi=gt(String.prototype.trim),ft=gt(RegExp.prototype.test),_t=gi(TypeError);function gt(oe){return function(t){for(var i=arguments.length,n=new Array(i>1?i-1:0),P=1;P<i;P++)n[P-1]=arguments[P];return Rt(oe,t,n)}}function gi(oe){return function(){for(var t=arguments.length,i=new Array(t),n=0;n<t;n++)i[n]=arguments[n];return Ct(oe,i)}}function Ve(oe,t,i){var n;i=(n=i)!==null&&n!==void 0?n:Tt,Ht&&Ht(oe,null);let P=t.length;for(;P--;){let O=t[P];if(typeof O=="string"){const T=i(O);T!==O&&(oi(t)||(t[P]=T),O=T)}oe[O]=!0}return oe}function Dt(oe){const t=ui(null);for(const[i,n]of Wt(oe))t[i]=n;return t}function Lt(oe,t){for(;oe!==null;){const n=li(oe,t);if(n){if(n.get)return gt(n.get);if(typeof n.value=="function")return gt(n.value)}oe=ai(oe)}function i(n){return console.warn("fallback value for",n),null}return i}const Ut=at(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),kt=at(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Mt=at(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),mi=at(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Pt=at(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),pi=at(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Vt=at(["#text"]),Kt=at(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Bt=at(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),$t=at(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),It=at(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),bi=pt(/\{\{[\w\W]*|[\w\W]*\}\}/gm),vi=pt(/<%[\w\W]*|[\w\W]*%>/gm),Di=pt(/\${[\w\W]*}/gm),wi=pt(/^data-[\-\w.\u00B7-\uFFFF]/),Ei=pt(/^aria-[\-\w]+$/),qt=pt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),yi=pt(/^(?:\w+script|data):/i),_i=pt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Gt=pt(/^html$/i);var jt=Object.freeze({__proto__:null,MUSTACHE_EXPR:bi,ERB_EXPR:vi,TMPLIT_EXPR:Di,DATA_ATTR:wi,ARIA_ATTR:Ei,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:yi,ATTR_WHITESPACE:_i,DOCTYPE_NAME:Gt});const Si=()=>typeof window>"u"?null:window,Ai=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let n=null;const P="data-tt-policy-suffix";i&&i.hasAttribute(P)&&(n=i.getAttribute(P));const O="dompurify"+(n?"#"+n:"");try{return t.createPolicy(O,{createHTML(T){return T},createScriptURL(T){return T}})}catch{return console.warn("TrustedTypes policy "+O+" could not be created."),null}};function Yt(){let oe=arguments.length>0&&arguments[0]!==void 0?arguments[0]:Si();const t=We=>Yt(We);if(t.version="3.0.5",t.removed=[],!oe||!oe.document||oe.document.nodeType!==9)return t.isSupported=!1,t;const i=oe.document,n=i.currentScript;let{document:P}=oe;const{DocumentFragment:O,HTMLTemplateElement:T,Node:w,Element:_,NodeFilter:d,NamedNodeMap:D=oe.NamedNodeMap||oe.MozNamedAttrMap,HTMLFormElement:S,DOMParser:b,trustedTypes:m}=oe,e=_.prototype,s=Lt(e,"cloneNode"),o=Lt(e,"nextSibling"),c=Lt(e,"childNodes"),h=Lt(e,"parentNode");if(typeof T=="function"){const We=P.createElement("template");We.content&&We.content.ownerDocument&&(P=We.content.ownerDocument)}let p,L="";const{implementation:y,createNodeIterator:r,createDocumentFragment:f,getElementsByTagName:E}=P,{importNode:I}=i;let H={};t.isSupported=typeof Wt=="function"&&typeof h=="function"&&y&&y.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:z,ERB_EXPR:U,TMPLIT_EXPR:v,DATA_ATTR:k,ARIA_ATTR:x,IS_SCRIPT_OR_DATA:N,ATTR_WHITESPACE:M}=jt;let{IS_ALLOWED_URI:$}=jt,ne=null;const Z=Ve({},[...Ut,...kt,...Mt,...Pt,...Vt]);let Y=null;const te=Ve({},[...Kt,...Bt,...$t,...It]);let fe=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Ee=null,Fe=null,Ae=!0,ue=!0,J=!1,de=!0,ae=!1,Le=!1,Q=!1,me=!1,_e=!1,Oe=!1,Ce=!1,Be=!0,ie=!1;const q="user-content-";let W=!0,l=!1,a={},g=null;const C=Ve({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let R=null;const u=Ve({},["audio","video","img","source","image","track"]);let F=null;const A=Ve({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),B="http://www.w3.org/1998/Math/MathML",V="http://www.w3.org/2000/svg",G="http://www.w3.org/1999/xhtml";let ee=G,re=!1,he=null;const ye=Ve({},[B,V,G],Ot);let we;const Ie=["application/xhtml+xml","text/html"],Te="text/html";let ce,Re=null;const Ue=P.createElement("form"),Ye=function(ge){return ge instanceof RegExp||ge instanceof Function},et=function(ge){if(!(Re&&Re===ge)){if((!ge||typeof ge!="object")&&(ge={}),ge=Dt(ge),we=Ie.indexOf(ge.PARSER_MEDIA_TYPE)===-1?we=Te:we=ge.PARSER_MEDIA_TYPE,ce=we==="application/xhtml+xml"?Ot:Tt,ne="ALLOWED_TAGS"in ge?Ve({},ge.ALLOWED_TAGS,ce):Z,Y="ALLOWED_ATTR"in ge?Ve({},ge.ALLOWED_ATTR,ce):te,he="ALLOWED_NAMESPACES"in ge?Ve({},ge.ALLOWED_NAMESPACES,Ot):ye,F="ADD_URI_SAFE_ATTR"in ge?Ve(Dt(A),ge.ADD_URI_SAFE_ATTR,ce):A,R="ADD_DATA_URI_TAGS"in ge?Ve(Dt(u),ge.ADD_DATA_URI_TAGS,ce):u,g="FORBID_CONTENTS"in ge?Ve({},ge.FORBID_CONTENTS,ce):C,Ee="FORBID_TAGS"in ge?Ve({},ge.FORBID_TAGS,ce):{},Fe="FORBID_ATTR"in ge?Ve({},ge.FORBID_ATTR,ce):{},a="USE_PROFILES"in ge?ge.USE_PROFILES:!1,Ae=ge.ALLOW_ARIA_ATTR!==!1,ue=ge.ALLOW_DATA_ATTR!==!1,J=ge.ALLOW_UNKNOWN_PROTOCOLS||!1,de=ge.ALLOW_SELF_CLOSE_IN_ATTR!==!1,ae=ge.SAFE_FOR_TEMPLATES||!1,Le=ge.WHOLE_DOCUMENT||!1,_e=ge.RETURN_DOM||!1,Oe=ge.RETURN_DOM_FRAGMENT||!1,Ce=ge.RETURN_TRUSTED_TYPE||!1,me=ge.FORCE_BODY||!1,Be=ge.SANITIZE_DOM!==!1,ie=ge.SANITIZE_NAMED_PROPS||!1,W=ge.KEEP_CONTENT!==!1,l=ge.IN_PLACE||!1,$=ge.ALLOWED_URI_REGEXP||qt,ee=ge.NAMESPACE||G,fe=ge.CUSTOM_ELEMENT_HANDLING||{},ge.CUSTOM_ELEMENT_HANDLING&&Ye(ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(fe.tagNameCheck=ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&Ye(ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(fe.attributeNameCheck=ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&typeof ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(fe.allowCustomizedBuiltInElements=ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),ae&&(ue=!1),Oe&&(_e=!0),a&&(ne=Ve({},[...Vt]),Y=[],a.html===!0&&(Ve(ne,Ut),Ve(Y,Kt)),a.svg===!0&&(Ve(ne,kt),Ve(Y,Bt),Ve(Y,It)),a.svgFilters===!0&&(Ve(ne,Mt),Ve(Y,Bt),Ve(Y,It)),a.mathMl===!0&&(Ve(ne,Pt),Ve(Y,$t),Ve(Y,It))),ge.ADD_TAGS&&(ne===Z&&(ne=Dt(ne)),Ve(ne,ge.ADD_TAGS,ce)),ge.ADD_ATTR&&(Y===te&&(Y=Dt(Y)),Ve(Y,ge.ADD_ATTR,ce)),ge.ADD_URI_SAFE_ATTR&&Ve(F,ge.ADD_URI_SAFE_ATTR,ce),ge.FORBID_CONTENTS&&(g===C&&(g=Dt(g)),Ve(g,ge.FORBID_CONTENTS,ce)),W&&(ne["#text"]=!0),Le&&Ve(ne,["html","head","body"]),ne.table&&(Ve(ne,["tbody"]),delete Ee.tbody),ge.TRUSTED_TYPES_POLICY){if(typeof ge.TRUSTED_TYPES_POLICY.createHTML!="function")throw _t('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ge.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw _t('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');p=ge.TRUSTED_TYPES_POLICY,L=p.createHTML("")}else p===void 0&&(p=Ai(m,n)),p!==null&&typeof L=="string"&&(L=p.createHTML(""));at&&at(ge),Re=ge}},ot=Ve({},["mi","mo","mn","ms","mtext"]),it=Ve({},["foreignobject","desc","title","annotation-xml"]),$e=Ve({},["title","style","font","a","script"]),Ze=Ve({},kt);Ve(Ze,Mt),Ve(Ze,mi);const X=Ve({},Pt);Ve(X,pi);const le=function(ge){let ke=h(ge);(!ke||!ke.tagName)&&(ke={namespaceURI:ee,tagName:"template"});const Pe=Tt(ge.tagName),qe=Tt(ke.tagName);return he[ge.namespaceURI]?ge.namespaceURI===V?ke.namespaceURI===G?Pe==="svg":ke.namespaceURI===B?Pe==="svg"&&(qe==="annotation-xml"||ot[qe]):!!Ze[Pe]:ge.namespaceURI===B?ke.namespaceURI===G?Pe==="math":ke.namespaceURI===V?Pe==="math"&&it[qe]:!!X[Pe]:ge.namespaceURI===G?ke.namespaceURI===V&&!it[qe]||ke.namespaceURI===B&&!ot[qe]?!1:!X[Pe]&&($e[Pe]||!Ze[Pe]):!!(we==="application/xhtml+xml"&&he[ge.namespaceURI]):!1},be=function(ge){yt(t.removed,{element:ge});try{ge.parentNode.removeChild(ge)}catch{ge.remove()}},Se=function(ge,ke){try{yt(t.removed,{attribute:ke.getAttributeNode(ge),from:ke})}catch{yt(t.removed,{attribute:null,from:ke})}if(ke.removeAttribute(ge),ge==="is"&&!Y[ge])if(_e||Oe)try{be(ke)}catch{}else try{ke.setAttribute(ge,"")}catch{}},Me=function(ge){let ke,Pe;if(me)ge="<remove></remove>"+ge;else{const dt=hi(ge,/^[\r\n\t ]+/);Pe=dt&&dt[0]}we==="application/xhtml+xml"&&ee===G&&(ge='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ge+"</body></html>");const qe=p?p.createHTML(ge):ge;if(ee===G)try{ke=new b().parseFromString(qe,we)}catch{}if(!ke||!ke.documentElement){ke=y.createDocument(ee,"template",null);try{ke.documentElement.innerHTML=re?L:qe}catch{}}const rt=ke.body||ke.documentElement;return ge&&Pe&&rt.insertBefore(P.createTextNode(Pe),rt.childNodes[0]||null),ee===G?E.call(ke,Le?"html":"body")[0]:Le?ke.documentElement:rt},ze=function(ge){return r.call(ge.ownerDocument||ge,ge,d.SHOW_ELEMENT|d.SHOW_COMMENT|d.SHOW_TEXT,null,!1)},Qe=function(ge){return ge instanceof S&&(typeof ge.nodeName!="string"||typeof ge.textContent!="string"||typeof ge.removeChild!="function"||!(ge.attributes instanceof D)||typeof ge.removeAttribute!="function"||typeof ge.setAttribute!="function"||typeof ge.namespaceURI!="string"||typeof ge.insertBefore!="function"||typeof ge.hasChildNodes!="function")},st=function(ge){return typeof w=="object"?ge instanceof w:ge&&typeof ge=="object"&&typeof ge.nodeType=="number"&&typeof ge.nodeName=="string"},tt=function(ge,ke,Pe){H[ge]&&ci(H[ge],qe=>{qe.call(t,ke,Pe,Re)})},lt=function(ge){let ke;if(tt("beforeSanitizeElements",ge,null),Qe(ge))return be(ge),!0;const Pe=ce(ge.nodeName);if(tt("uponSanitizeElement",ge,{tagName:Pe,allowedTags:ne}),ge.hasChildNodes()&&!st(ge.firstElementChild)&&(!st(ge.content)||!st(ge.content.firstElementChild))&&ft(/<[/\w]/g,ge.innerHTML)&&ft(/<[/\w]/g,ge.textContent))return be(ge),!0;if(!ne[Pe]||Ee[Pe]){if(!Ee[Pe]&&ht(Pe)&&(fe.tagNameCheck instanceof RegExp&&ft(fe.tagNameCheck,Pe)||fe.tagNameCheck instanceof Function&&fe.tagNameCheck(Pe)))return!1;if(W&&!g[Pe]){const qe=h(ge)||ge.parentNode,rt=c(ge)||ge.childNodes;if(rt&&qe){const dt=rt.length;for(let Xe=dt-1;Xe>=0;--Xe)qe.insertBefore(s(rt[Xe],!0),o(ge))}}return be(ge),!0}return ge instanceof _&&!le(ge)||(Pe==="noscript"||Pe==="noembed"||Pe==="noframes")&&ft(/<\/no(script|embed|frames)/i,ge.innerHTML)?(be(ge),!0):(ae&&ge.nodeType===3&&(ke=ge.textContent,ke=bt(ke,z," "),ke=bt(ke,U," "),ke=bt(ke,v," "),ge.textContent!==ke&&(yt(t.removed,{element:ge.cloneNode()}),ge.textContent=ke)),tt("afterSanitizeElements",ge,null),!1)},nt=function(ge,ke,Pe){if(Be&&(ke==="id"||ke==="name")&&(Pe in P||Pe in Ue))return!1;if(!(ue&&!Fe[ke]&&ft(k,ke))){if(!(Ae&&ft(x,ke))){if(!Y[ke]||Fe[ke]){if(!(ht(ge)&&(fe.tagNameCheck instanceof RegExp&&ft(fe.tagNameCheck,ge)||fe.tagNameCheck instanceof Function&&fe.tagNameCheck(ge))&&(fe.attributeNameCheck instanceof RegExp&&ft(fe.attributeNameCheck,ke)||fe.attributeNameCheck instanceof Function&&fe.attributeNameCheck(ke))||ke==="is"&&fe.allowCustomizedBuiltInElements&&(fe.tagNameCheck instanceof RegExp&&ft(fe.tagNameCheck,Pe)||fe.tagNameCheck instanceof Function&&fe.tagNameCheck(Pe))))return!1}else if(!F[ke]){if(!ft($,bt(Pe,M,""))){if(!((ke==="src"||ke==="xlink:href"||ke==="href")&&ge!=="script"&&di(Pe,"data:")===0&&R[ge])){if(!(J&&!ft(N,bt(Pe,M,"")))){if(Pe)return!1}}}}}}return!0},ht=function(ge){return ge.indexOf("-")>0},ut=function(ge){let ke,Pe,qe,rt;tt("beforeSanitizeAttributes",ge,null);const{attributes:dt}=ge;if(!dt)return;const Xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:Y};for(rt=dt.length;rt--;){ke=dt[rt];const{name:mt,namespaceURI:St}=ke;if(Pe=mt==="value"?ke.value:fi(ke.value),qe=ce(mt),Xe.attrName=qe,Xe.attrValue=Pe,Xe.keepAttr=!0,Xe.forceKeepAttr=void 0,tt("uponSanitizeAttribute",ge,Xe),Pe=Xe.attrValue,Xe.forceKeepAttr||(Se(mt,ge),!Xe.keepAttr))continue;if(!de&&ft(/\/>/i,Pe)){Se(mt,ge);continue}ae&&(Pe=bt(Pe,z," "),Pe=bt(Pe,U," "),Pe=bt(Pe,v," "));const Nt=ce(ge.nodeName);if(nt(Nt,qe,Pe)){if(ie&&(qe==="id"||qe==="name")&&(Se(mt,ge),Pe=q+Pe),p&&typeof m=="object"&&typeof m.getAttributeType=="function"&&!St)switch(m.getAttributeType(Nt,qe)){case"TrustedHTML":{Pe=p.createHTML(Pe);break}case"TrustedScriptURL":{Pe=p.createScriptURL(Pe);break}}try{St?ge.setAttributeNS(St,mt,Pe):ge.setAttribute(mt,Pe),zt(t.removed)}catch{}}}tt("afterSanitizeAttributes",ge,null)},vt=function We(ge){let ke;const Pe=ze(ge);for(tt("beforeSanitizeShadowDOM",ge,null);ke=Pe.nextNode();)tt("uponSanitizeShadowNode",ke,null),!lt(ke)&&(ke.content instanceof O&&We(ke.content),ut(ke));tt("afterSanitizeShadowDOM",ge,null)};return t.sanitize=function(We){let ge=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ke,Pe,qe,rt;if(re=!We,re&&(We="<!-->"),typeof We!="string"&&!st(We))if(typeof We.toString=="function"){if(We=We.toString(),typeof We!="string")throw _t("dirty is not a string, aborting")}else throw _t("toString is not a function");if(!t.isSupported)return We;if(Q||et(ge),t.removed=[],typeof We=="string"&&(l=!1),l){if(We.nodeName){const mt=ce(We.nodeName);if(!ne[mt]||Ee[mt])throw _t("root node is forbidden and cannot be sanitized in-place")}}else if(We instanceof w)ke=Me("<!---->"),Pe=ke.ownerDocument.importNode(We,!0),Pe.nodeType===1&&Pe.nodeName==="BODY"||Pe.nodeName==="HTML"?ke=Pe:ke.appendChild(Pe);else{if(!_e&&!ae&&!Le&&We.indexOf("<")===-1)return p&&Ce?p.createHTML(We):We;if(ke=Me(We),!ke)return _e?null:Ce?L:""}ke&&me&&be(ke.firstChild);const dt=ze(l?We:ke);for(;qe=dt.nextNode();)lt(qe)||(qe.content instanceof O&&vt(qe.content),ut(qe));if(l)return We;if(_e){if(Oe)for(rt=f.call(ke.ownerDocument);ke.firstChild;)rt.appendChild(ke.firstChild);else rt=ke;return(Y.shadowroot||Y.shadowrootmode)&&(rt=I.call(i,rt,!0)),rt}let Xe=Le?ke.outerHTML:ke.innerHTML;return Le&&ne["!doctype"]&&ke.ownerDocument&&ke.ownerDocument.doctype&&ke.ownerDocument.doctype.name&&ft(Gt,ke.ownerDocument.doctype.name)&&(Xe="<!DOCTYPE "+ke.ownerDocument.doctype.name+`>
`+Xe),ae&&(Xe=bt(Xe,z," "),Xe=bt(Xe,U," "),Xe=bt(Xe,v," ")),p&&Ce?p.createHTML(Xe):Xe},t.setConfig=function(We){et(We),Q=!0},t.clearConfig=function(){Re=null,Q=!1},t.isValidAttribute=function(We,ge,ke){Re||et({});const Pe=ce(We),qe=ce(ge);return nt(Pe,qe,ke)},t.addHook=function(We,ge){typeof ge=="function"&&(H[We]=H[We]||[],yt(H[We],ge))},t.removeHook=function(We){if(H[We])return zt(H[We])},t.removeHooks=function(We){H[We]&&(H[We]=[])},t.removeAllHooks=function(){H={}},t}var Ti=Yt();define("vs/base/browser/dompurify/dompurify",function(){return Ti}),define(ve[56],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FastDomNode=void 0,t.createFastDomNode=P;class i{constructor(T){this.domNode=T,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._paddingTop="",this._paddingLeft="",this._paddingBottom="",this._paddingRight="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._fontVariationSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(T){const w=n(T);this._maxWidth!==w&&(this._maxWidth=w,this.domNode.style.maxWidth=this._maxWidth)}setWidth(T){const w=n(T);this._width!==w&&(this._width=w,this.domNode.style.width=this._width)}setHeight(T){const w=n(T);this._height!==w&&(this._height=w,this.domNode.style.height=this._height)}setTop(T){const w=n(T);this._top!==w&&(this._top=w,this.domNode.style.top=this._top)}setLeft(T){const w=n(T);this._left!==w&&(this._left=w,this.domNode.style.left=this._left)}setBottom(T){const w=n(T);this._bottom!==w&&(this._bottom=w,this.domNode.style.bottom=this._bottom)}setRight(T){const w=n(T);this._right!==w&&(this._right=w,this.domNode.style.right=this._right)}setPaddingTop(T){const w=n(T);this._paddingTop!==w&&(this._paddingTop=w,this.domNode.style.paddingTop=this._paddingTop)}setPaddingLeft(T){const w=n(T);this._paddingLeft!==w&&(this._paddingLeft=w,this.domNode.style.paddingLeft=this._paddingLeft)}setPaddingBottom(T){const w=n(T);this._paddingBottom!==w&&(this._paddingBottom=w,this.domNode.style.paddingBottom=this._paddingBottom)}setPaddingRight(T){const w=n(T);this._paddingRight!==w&&(this._paddingRight=w,this.domNode.style.paddingRight=this._paddingRight)}setFontFamily(T){this._fontFamily!==T&&(this._fontFamily=T,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(T){this._fontWeight!==T&&(this._fontWeight=T,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(T){const w=n(T);this._fontSize!==w&&(this._fontSize=w,this.domNode.style.fontSize=this._fontSize)}setFontStyle(T){this._fontStyle!==T&&(this._fontStyle=T,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(T){this._fontFeatureSettings!==T&&(this._fontFeatureSettings=T,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setFontVariationSettings(T){this._fontVariationSettings!==T&&(this._fontVariationSettings=T,this.domNode.style.fontVariationSettings=this._fontVariationSettings)}setTextDecoration(T){this._textDecoration!==T&&(this._textDecoration=T,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(T){const w=n(T);this._lineHeight!==w&&(this._lineHeight=w,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(T){const w=n(T);this._letterSpacing!==w&&(this._letterSpacing=w,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(T){this._className!==T&&(this._className=T,this.domNode.className=this._className)}toggleClassName(T,w){this.domNode.classList.toggle(T,w),this._className=this.domNode.className}setDisplay(T){this._display!==T&&(this._display=T,this.domNode.style.display=this._display)}setPosition(T){this._position!==T&&(this._position=T,this.domNode.style.position=this._position)}setVisibility(T){this._visibility!==T&&(this._visibility=T,this.domNode.style.visibility=this._visibility)}setColor(T){this._color!==T&&(this._color=T,this.domNode.style.color=this._color)}setBackgroundColor(T){this._backgroundColor!==T&&(this._backgroundColor=T,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(T){this._layerHint!==T&&(this._layerHint=T,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(T){this._boxShadow!==T&&(this._boxShadow=T,this.domNode.style.boxShadow=T)}setContain(T){this._contain!==T&&(this._contain=T,this.domNode.style.contain=this._contain)}setAttribute(T,w){this.domNode.setAttribute(T,w)}removeAttribute(T){this.domNode.removeAttribute(T)}appendChild(T){this.domNode.appendChild(T.domNode)}removeChild(T){this.domNode.removeChild(T.domNode)}}t.FastDomNode=i;function n(O){return typeof O=="number"?`${O}px`:O}function P(O){return new i(O)}}),define(ve[85],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0,t.parentOriginHash=O;const i=new WeakMap;function n(w){if(!w.parent||w.parent===w)return null;try{const _=w.location,d=w.parent.location;if(_.origin!=="null"&&d.origin!=="null"&&_.origin!==d.origin)return null}catch{return null}return w.parent}class P{static getSameOriginWindowChain(_){let d=i.get(_);if(!d){d=[],i.set(_,d);let D=_,S;do S=n(D),S?d.push({window:new WeakRef(D),iframeElement:D.frameElement||null}):d.push({window:new WeakRef(D),iframeElement:null}),D=S;while(D)}return d.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(_,d){if(!d||_===d)return{top:0,left:0};let D=0,S=0;const b=this.getSameOriginWindowChain(_);for(const m of b){const e=m.window.deref();if(D+=e?.scrollY??0,S+=e?.scrollX??0,e===d||!m.iframeElement)break;const s=m.iframeElement.getBoundingClientRect();D+=s.top,S+=s.left}return{top:D,left:S}}}t.IframeUtils=P;async function O(w,_){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const d=JSON.stringify({parentOrigin:w,salt:_}),S=new TextEncoder().encode(d),b=await crypto.subtle.digest("sha-256",S);return T(b)}function T(w){const d=Array.from(new Uint8Array(w)).map(D=>D.toString(16).padStart(2,"0")).join("");return BigInt(`0x${d}`).toString(32).padStart(52,"0")}}),define(ve[32],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setBaseLayerHoverDelegate=n,t.getBaseLayerHoverDelegate=P;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupUpdatableHover:()=>null,triggerUpdatableHover:()=>{}};function n(O){i=O}function P(){return i}}),define(ve[40],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(T){T[T.Copy=0]="Copy",T[T.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var n;(function(T){T.Over="drop-target",T.Before="drop-target-before",T.After="drop-target-after"})(n||(t.ListDragOverEffectPosition=n={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class P extends Error{constructor(w,_){super(`ListError [${w}] ${_}`)}}t.ListError=P;class O{constructor(){this.cache=new WeakMap}getHeight(w){return this.cache.get(w)??this.estimateHeight(w)}setDynamicHeight(w,_){_>0&&this.cache.set(w,_)}}t.CachedListVirtualDelegate=O}),define(ve[86],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class i{constructor(P){this.spliceables=P}splice(P,O,T){this.spliceables.forEach(w=>w.splice(P,O,T))}}t.CombinedSpliceable=i}),define(ve[57],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const i=20;class n{constructor(O,T,w,_,d,D){this._scrollbarSize=Math.round(T),this._oppositeScrollbarSize=Math.round(w),this._arrowSize=Math.round(O),this._visibleSize=_,this._scrollSize=d,this._scrollPosition=D,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new n(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(O){const T=Math.round(O);return this._visibleSize!==T?(this._visibleSize=T,this._refreshComputedValues(),!0):!1}setScrollSize(O){const T=Math.round(O);return this._scrollSize!==T?(this._scrollSize=T,this._refreshComputedValues(),!0):!1}setScrollPosition(O){const T=Math.round(O);return this._scrollPosition!==T?(this._scrollPosition=T,this._refreshComputedValues(),!0):!1}setScrollbarSize(O){this._scrollbarSize=Math.round(O)}setOppositeScrollbarSize(O){this._oppositeScrollbarSize=Math.round(O)}static _computeValues(O,T,w,_,d){const D=Math.max(0,w-O),S=Math.max(0,D-2*T),b=_>0&&_>w;if(!b)return{computedAvailableSize:Math.round(D),computedIsNeeded:b,computedSliderSize:Math.round(S),computedSliderRatio:0,computedSliderPosition:0};const m=Math.round(Math.max(i,Math.floor(w*S/_))),e=(S-m)/(_-w),s=d*e;return{computedAvailableSize:Math.round(D),computedIsNeeded:b,computedSliderSize:Math.round(m),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}_refreshComputedValues(){const O=n._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=O.computedAvailableSize,this._computedIsNeeded=O.computedIsNeeded,this._computedSliderSize=O.computedSliderSize,this._computedSliderRatio=O.computedSliderRatio,this._computedSliderPosition=O.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(O){if(!this._computedIsNeeded)return 0;const T=O-this._arrowSize-this._computedSliderSize/2;return Math.round(T/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(O){if(!this._computedIsNeeded)return 0;const T=O-this._arrowSize;let w=this._scrollPosition;return T<this._computedSliderPosition?w-=this._visibleSize:w+=this._visibleSize,w}getDesiredScrollPositionFromDelta(O){if(!this._computedIsNeeded)return 0;const T=this._computedSliderPosition+O;return Math.round(T/this._computedSliderRatio)}}t.ScrollbarState=n}),define(ve[33],De([1,0,40]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(d){d[d.Hidden=0]="Hidden",d[d.Visible=1]="Visible",d[d.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var P;(function(d){d[d.Expanded=0]="Expanded",d[d.Collapsed=1]="Collapsed",d[d.PreserveOrExpanded=2]="PreserveOrExpanded",d[d.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(P||(t.ObjectTreeElementCollapseState=P={}));var O;(function(d){d[d.Unknown=0]="Unknown",d[d.Twistie=1]="Twistie",d[d.Element=2]="Element",d[d.Filter=3]="Filter"})(O||(t.TreeMouseEventTarget=O={}));var T;(function(d){d[d.Down=0]="Down",d[d.Up=1]="Up"})(T||(t.TreeDragOverBubble=T={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:T.Up}},acceptBubbleDown(d=!1){return{accept:!0,bubble:T.Down,autoExpand:d}},acceptCopyBubbleUp(){return{accept:!0,bubble:T.Up,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over}}},acceptCopyBubbleDown(d=!1){return{accept:!0,bubble:T.Down,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over},autoExpand:d}}};class w extends Error{constructor(D,S){super(`TreeError [${D}] ${S}`)}}t.TreeError=w;class _{constructor(D){this.fn=D,this._map=new WeakMap}map(D){let S=this._map.get(D);return S||(S=this.fn(D),this._map.set(D,S)),S}}t.WeakMapper=_}),define(ve[25],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mainWindow=void 0,t.ensureCodeWindow=i,t.isAuxiliaryWindow=n;function i(P,O){const T=P;typeof T.vscodeWindowId!="number"&&Object.defineProperty(T,"vscodeWindowId",{get:()=>O})}t.mainWindow=window;function n(P){return P===t.mainWindow?!1:typeof P?.vscodeWindowId=="number"}}),define(ve[87],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=i,t.findLastIdx=n,t.findLastMonotonous=P,t.findLastIdxMonotonous=O,t.findFirstMonotonous=T,t.findFirstIdxMonotonousOrArrLen=w,t.findFirstIdxMonotonous=_,t.findFirstMax=D,t.findLastMax=S,t.findFirstMin=b,t.findMaxIdx=m,t.mapFindFirst=e;function i(s,o){const c=n(s,o);if(c!==-1)return s[c]}function n(s,o,c=s.length-1){for(let h=c;h>=0;h--){const p=s[h];if(o(p))return h}return-1}function P(s,o){const c=O(s,o);return c===-1?void 0:s[c]}function O(s,o,c=0,h=s.length){let p=c,L=h;for(;p<L;){const y=Math.floor((p+L)/2);o(s[y])?p=y+1:L=y}return p-1}function T(s,o){const c=w(s,o);return c===s.length?void 0:s[c]}function w(s,o,c=0,h=s.length){let p=c,L=h;for(;p<L;){const y=Math.floor((p+L)/2);o(s[y])?L=y:p=y+1}return p}function _(s,o,c=0,h=s.length){const p=w(s,o,c,h);return p===s.length?-1:p}class d{static{this.assertInvariants=!1}constructor(o){this._array=o,this._findLastMonotonousLastIdx=0}findLastMonotonous(o){if(d.assertInvariants){if(this._prevFindLastPredicate){for(const h of this._array)if(this._prevFindLastPredicate(h)&&!o(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=o}const c=O(this._array,o,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=c+1,c===-1?void 0:this._array[c]}}t.MonotonousArray=d;function D(s,o){if(s.length===0)return;let c=s[0];for(let h=1;h<s.length;h++){const p=s[h];o(p,c)>0&&(c=p)}return c}function S(s,o){if(s.length===0)return;let c=s[0];for(let h=1;h<s.length;h++){const p=s[h];o(p,c)>=0&&(c=p)}return c}function b(s,o){return D(s,(c,h)=>-o(c,h))}function m(s,o){if(s.length===0)return-1;let c=0;for(let h=1;h<s.length;h++){const p=s[h];o(p,s[c])>0&&(c=h)}return c}function e(s,o){for(const c of s){const h=o(c);if(h!==void 0)return h}}}),define(ve[18],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var i;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(t.CharCode=i={}))}),define(ve[88],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.groupBy=i,t.diffSets=n,t.diffMaps=P,t.intersection=O;function i(T,w){const _=Object.create(null);for(const d of T){const D=w(d);let S=_[D];S||(S=_[D]=[]),S.push(d)}return _}function n(T,w){const _=[],d=[];for(const D of T)w.has(D)||_.push(D);for(const D of w)T.has(D)||d.push(D);return{removed:_,added:d}}function P(T,w){const _=[],d=[];for(const[D,S]of T)w.has(D)||_.push(S);for(const[D,S]of w)T.has(D)||d.push(S);return{removed:_,added:d}}function O(T,w){const _=new Set;for(const d of w)T.has(d)&&_.add(d);return _}}),define(ve[89],De([1,0,18]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function n(_,d){const D=Math.pow(10,d);return Math.round(_*D)/D}class P{constructor(d,D,S,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,D))|0,this.b=Math.min(255,Math.max(0,S))|0,this.a=n(Math.max(Math.min(1,b),0),3)}static equals(d,D){return d.r===D.r&&d.g===D.g&&d.b===D.b&&d.a===D.a}}t.RGBA=P;class O{constructor(d,D,S,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,D),0),3),this.l=n(Math.max(Math.min(1,S),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(d,D){return d.h===D.h&&d.s===D.s&&d.l===D.l&&d.a===D.a}static fromRGBA(d){const D=d.r/255,S=d.g/255,b=d.b/255,m=d.a,e=Math.max(D,S,b),s=Math.min(D,S,b);let o=0,c=0;const h=(s+e)/2,p=e-s;if(p>0){switch(c=Math.min(h<=.5?p/(2*h):p/(2-2*h),1),e){case D:o=(S-b)/p+(S<b?6:0);break;case S:o=(b-D)/p+2;break;case b:o=(D-S)/p+4;break}o*=60,o=Math.round(o)}return new O(o,c,h,m)}static _hue2rgb(d,D,S){return S<0&&(S+=1),S>1&&(S-=1),S<1/6?d+(D-d)*6*S:S<1/2?D:S<2/3?d+(D-d)*(2/3-S)*6:d}static toRGBA(d){const D=d.h/360,{s:S,l:b,a:m}=d;let e,s,o;if(S===0)e=s=o=b;else{const c=b<.5?b*(1+S):b+S-b*S,h=2*b-c;e=O._hue2rgb(h,c,D+1/3),s=O._hue2rgb(h,c,D),o=O._hue2rgb(h,c,D-1/3)}return new P(Math.round(e*255),Math.round(s*255),Math.round(o*255),m)}}t.HSLA=O;class T{constructor(d,D,S,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,D),0),3),this.v=n(Math.max(Math.min(1,S),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(d,D){return d.h===D.h&&d.s===D.s&&d.v===D.v&&d.a===D.a}static fromRGBA(d){const D=d.r/255,S=d.g/255,b=d.b/255,m=Math.max(D,S,b),e=Math.min(D,S,b),s=m-e,o=m===0?0:s/m;let c;return s===0?c=0:m===D?c=((S-b)/s%6+6)%6:m===S?c=(b-D)/s+2:c=(D-S)/s+4,new T(Math.round(c*60),o,m,d.a)}static toRGBA(d){const{h:D,s:S,v:b,a:m}=d,e=b*S,s=e*(1-Math.abs(D/60%2-1)),o=b-e;let[c,h,p]=[0,0,0];return D<60?(c=e,h=s):D<120?(c=s,h=e):D<180?(h=e,p=s):D<240?(h=s,p=e):D<300?(c=s,p=e):D<=360&&(c=e,p=s),c=Math.round((c+o)*255),h=Math.round((h+o)*255),p=Math.round((p+o)*255),new P(c,h,p,m)}}t.HSVA=T;class w{static fromHex(d){return w.Format.CSS.parseHex(d)||w.red}static equals(d,D){return!d&&!D?!0:!d||!D?!1:d.equals(D)}get hsla(){return this._hsla?this._hsla:O.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:T.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof P)this.rgba=d;else if(d instanceof O)this._hsla=d,this.rgba=O.toRGBA(d);else if(d instanceof T)this._hsva=d,this.rgba=T.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&P.equals(this.rgba,d.rgba)&&O.equals(this.hsla,d.hsla)&&T.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=w._relativeLuminanceForComponent(this.rgba.r),D=w._relativeLuminanceForComponent(this.rgba.g),S=w._relativeLuminanceForComponent(this.rgba.b),b=.2126*d+.7152*D+.0722*S;return n(b,4)}static _relativeLuminanceForComponent(d){const D=d/255;return D<=.03928?D/12.92:Math.pow((D+.055)/1.055,2.4)}getContrastRatio(d){const D=this.getRelativeLuminance(),S=d.getRelativeLuminance();return D>S?(D+.05)/(S+.05):(S+.05)/(D+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const D=this.getRelativeLuminance(),S=d.getRelativeLuminance();return D>S}isDarkerThan(d){const D=this.getRelativeLuminance(),S=d.getRelativeLuminance();return D<S}lighten(d){return new w(new O(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new w(new O(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:D,g:S,b,a:m}=this.rgba;return new w(new P(D,S,b,m*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const D=d.rgba,S=this.rgba.a,b=D.a,m=S+b*(1-S);if(m<1e-6)return w.transparent;const e=this.rgba.r*S/m+D.r*b*(1-S)/m,s=this.rgba.g*S/m+D.g*b*(1-S)/m,o=this.rgba.b*S/m+D.b*b*(1-S)/m;return new w(new P(e,s,o,m))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:D,g:S,b,a:m}=this.rgba;return new w(new P(d.rgba.r-m*(d.rgba.r-D),d.rgba.g-m*(d.rgba.g-S),d.rgba.b-m*(d.rgba.b-b),1))}flatten(...d){const D=d.reduceRight((S,b)=>w._flatten(b,S));return w._flatten(this,D)}static _flatten(d,D){const S=1-d.rgba.a;return new w(new P(S*D.rgba.r+d.rgba.a*d.rgba.r,S*D.rgba.g+d.rgba.a*d.rgba.g,S*D.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this._toString||(this._toString=w.Format.CSS.format(this)),this._toString}static getLighterColor(d,D,S){if(d.isLighterThan(D))return d;S=S||.5;const b=d.getRelativeLuminance(),m=D.getRelativeLuminance();return S=S*(m-b)/m,d.lighten(S)}static getDarkerColor(d,D,S){if(d.isDarkerThan(D))return d;S=S||.5;const b=d.getRelativeLuminance(),m=D.getRelativeLuminance();return S=S*(b-m)/b,d.darken(S)}static{this.white=new w(new P(255,255,255,1))}static{this.black=new w(new P(0,0,0,1))}static{this.red=new w(new P(255,0,0,1))}static{this.blue=new w(new P(0,0,255,1))}static{this.green=new w(new P(0,255,0,1))}static{this.cyan=new w(new P(0,255,255,1))}static{this.lightgrey=new w(new P(211,211,211,1))}static{this.transparent=new w(new P(0,0,0,0))}}t.Color=w,function(_){let d;(function(D){let S;(function(b){function m(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:_.Format.CSS.formatRGBA(f)}b.formatRGB=m;function e(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}b.formatRGBA=e;function s(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:_.Format.CSS.formatHSLA(f)}b.formatHSL=s;function o(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}b.formatHSLA=o;function c(f){const E=f.toString(16);return E.length!==2?"0"+E:E}function h(f){return`#${c(f.rgba.r)}${c(f.rgba.g)}${c(f.rgba.b)}`}b.formatHex=h;function p(f,E=!1){return E&&f.rgba.a===1?_.Format.CSS.formatHex(f):`#${c(f.rgba.r)}${c(f.rgba.g)}${c(f.rgba.b)}${c(Math.round(f.rgba.a*255))}`}b.formatHexA=p;function L(f){return f.isOpaque()?_.Format.CSS.formatHex(f):_.Format.CSS.formatRGBA(f)}b.format=L;function y(f){const E=f.length;if(E===0||f.charCodeAt(0)!==i.CharCode.Hash)return null;if(E===7){const I=16*r(f.charCodeAt(1))+r(f.charCodeAt(2)),H=16*r(f.charCodeAt(3))+r(f.charCodeAt(4)),z=16*r(f.charCodeAt(5))+r(f.charCodeAt(6));return new _(new P(I,H,z,1))}if(E===9){const I=16*r(f.charCodeAt(1))+r(f.charCodeAt(2)),H=16*r(f.charCodeAt(3))+r(f.charCodeAt(4)),z=16*r(f.charCodeAt(5))+r(f.charCodeAt(6)),U=16*r(f.charCodeAt(7))+r(f.charCodeAt(8));return new _(new P(I,H,z,U/255))}if(E===4){const I=r(f.charCodeAt(1)),H=r(f.charCodeAt(2)),z=r(f.charCodeAt(3));return new _(new P(16*I+I,16*H+H,16*z+z))}if(E===5){const I=r(f.charCodeAt(1)),H=r(f.charCodeAt(2)),z=r(f.charCodeAt(3)),U=r(f.charCodeAt(4));return new _(new P(16*I+I,16*H+H,16*z+z,(16*U+U)/255))}return null}b.parseHex=y;function r(f){switch(f){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(S=D.CSS||(D.CSS={}))})(d=_.Format||(_.Format={}))}(w||(t.Color=w={}))}),define(ve[34],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.memoize=n,t.debounce=P,t.throttle=O;function i(T){return(w,_,d)=>{let D=null,S=null;if(typeof d.value=="function"?(D="value",S=d.value):typeof d.get=="function"&&(D="get",S=d.get),!S)throw new Error("not supported");d[D]=T(S,_)}}function n(T,w,_){let d=null,D=null;if(typeof _.value=="function"?(d="value",D=_.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(d="get",D=_.get),!D)throw new Error("not supported");const S=`$memoize$${w}`;_[d]=function(...b){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,b)}),this[S]}}function P(T,w,_){return i((d,D)=>{const S=`$debounce$${D}`,b=`$debounce$result$${D}`;return function(...m){this[b]||(this[b]=_?_():void 0),clearTimeout(this[S]),w&&(this[b]=w(this[b],...m),m=[this[b]]),this[S]=setTimeout(()=>{d.apply(this,m),this[b]=_?_():void 0},T)}})}function O(T,w,_){return i((d,D)=>{const S=`$throttle$timer$${D}`,b=`$throttle$result$${D}`,m=`$throttle$lastRun$${D}`,e=`$throttle$pending$${D}`;return function(...s){if(this[b]||(this[b]=_?_():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),w&&(this[b]=w(this[b],...s)),this[e])return;const o=this[m]+T;o<=Date.now()?(this[m]=Date.now(),d.apply(this,[this[b]]),this[b]=_?_():void 0):(this[e]=!0,this[S]=setTimeout(()=>{this[e]=!1,this[m]=Date.now(),d.apply(this,[this[b]]),this[b]=_?_():void 0},o-Date.now()))}})}}),define(ve[90],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class i{constructor(P,O,T,w){this.originalStart=P,this.originalLength=O,this.modifiedStart=T,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=i}),define(ve[6],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=n,t.isSigPipeError=P,t.onUnexpectedError=O,t.onUnexpectedExternalError=T,t.transformErrorForSerialization=w,t.isCancellationError=d,t.canceled=S,t.illegalArgument=b,t.illegalState=m,t.getErrorMessage=s;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?p.isErrorNoTelemetry(r)?new p(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(f=>{f(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}t.ErrorHandler=i,t.errorHandler=new i;function n(y){t.errorHandler.setUnexpectedErrorHandler(y)}function P(y){if(!y||typeof y!="object")return!1;const r=y;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function O(y){d(y)||t.errorHandler.onUnexpectedError(y)}function T(y){d(y)||t.errorHandler.onUnexpectedExternalError(y)}function w(y){if(y instanceof Error){const{name:r,message:f}=y,E=y.stacktrace||y.stack;return{$isError:!0,name:r,message:f,stack:E,noTelemetry:p.isErrorNoTelemetry(y)}}return y}const _="Canceled";function d(y){return y instanceof D?!0:y instanceof Error&&y.name===_&&y.message===_}class D extends Error{constructor(){super(_),this.name=this.message}}t.CancellationError=D;function S(){const y=new Error(_);return y.name=y.message,y}function b(y){return y?new Error(`Illegal argument: ${y}`):new Error("Illegal argument")}function m(y){return y?new Error(`Illegal state: ${y}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=e;function s(y){return y?y.message?y.message:y.stack?y.stack.split(`
`)[0]:String(y):"Error"}class o extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.NotImplementedError=o;class c extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.NotSupportedError=c;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=h;class p extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof p)return r;const f=new p;return f.message=r.message,f.stack=r.stack,f}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.ErrorNoTelemetry=p;class L extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype)}}t.BugIndicatingError=L}),define(ve[9],De([1,0,6,87]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=P,t.tail2=O,t.equals=T,t.removeFastWithoutKeepingOrder=w,t.binarySearch=_,t.binarySearch2=d,t.quickSelect=D,t.groupBy=S,t.groupAdjacentBy=b,t.forEachAdjacent=m,t.forEachWithNeighbors=e,t.sortedDiff=s,t.delta=o,t.top=c,t.topAsync=h,t.coalesce=L,t.coalesceInPlace=y,t.move=r,t.isFalsyOrEmpty=f,t.isNonEmptyArray=E,t.distinct=I,t.uniqueFilter=H,t.firstOrDefault=z,t.lastOrDefault=U,t.commonPrefixLength=v,t.range=k,t.index=x,t.insert=N,t.remove=M,t.arrayInsert=$,t.shuffle=ne,t.pushToStart=Z,t.pushToEnd=Y,t.pushMany=te,t.mapArrayOrNot=fe,t.asArray=Ee,t.getRandomElement=Fe,t.insertInto=Ae,t.splice=ue,t.compareBy=ae,t.tieBreakComparators=Le,t.reverseOrder=_e;function P(ie,q=0){return ie[ie.length-(1+q)]}function O(ie){if(ie.length===0)throw new Error("Invalid tail call");return[ie.slice(0,ie.length-1),ie[ie.length-1]]}function T(ie,q,W=(l,a)=>l===a){if(ie===q)return!0;if(!ie||!q||ie.length!==q.length)return!1;for(let l=0,a=ie.length;l<a;l++)if(!W(ie[l],q[l]))return!1;return!0}function w(ie,q){const W=ie.length-1;q<W&&(ie[q]=ie[W]),ie.pop()}function _(ie,q,W){return d(ie.length,l=>W(ie[l],q))}function d(ie,q){let W=0,l=ie-1;for(;W<=l;){const a=(W+l)/2|0,g=q(a);if(g<0)W=a+1;else if(g>0)l=a-1;else return a}return-(W+1)}function D(ie,q,W){if(ie=ie|0,ie>=q.length)throw new TypeError("invalid index");const l=q[Math.floor(q.length*Math.random())],a=[],g=[],C=[];for(const R of q){const u=W(R,l);u<0?a.push(R):u>0?g.push(R):C.push(R)}return ie<a.length?D(ie,a,W):ie<a.length+C.length?C[0]:D(ie-(a.length+C.length),g,W)}function S(ie,q){const W=[];let l;for(const a of ie.slice(0).sort(q))!l||q(l[0],a)!==0?(l=[a],W.push(l)):l.push(a);return W}function*b(ie,q){let W,l;for(const a of ie)l!==void 0&&q(l,a)?W.push(a):(W&&(yield W),W=[a]),l=a;W&&(yield W)}function m(ie,q){for(let W=0;W<=ie.length;W++)q(W===0?void 0:ie[W-1],W===ie.length?void 0:ie[W])}function e(ie,q){for(let W=0;W<ie.length;W++)q(W===0?void 0:ie[W-1],ie[W],W+1===ie.length?void 0:ie[W+1])}function s(ie,q,W){const l=[];function a(R,u,F){if(u===0&&F.length===0)return;const A=l[l.length-1];A&&A.start+A.deleteCount===R?(A.deleteCount+=u,A.toInsert.push(...F)):l.push({start:R,deleteCount:u,toInsert:F})}let g=0,C=0;for(;;){if(g===ie.length){a(g,0,q.slice(C));break}if(C===q.length){a(g,ie.length-g,[]);break}const R=ie[g],u=q[C],F=W(R,u);F===0?(g+=1,C+=1):F<0?(a(g,1,[]),g+=1):F>0&&(a(g,0,[u]),C+=1)}return l}function o(ie,q,W){const l=s(ie,q,W),a=[],g=[];for(const C of l)a.push(...ie.slice(C.start,C.start+C.deleteCount)),g.push(...C.toInsert);return{removed:a,added:g}}function c(ie,q,W){if(W===0)return[];const l=ie.slice(0,W).sort(q);return p(ie,q,l,W,ie.length),l}function h(ie,q,W,l,a){return W===0?Promise.resolve([]):new Promise((g,C)=>{(async()=>{const R=ie.length,u=ie.slice(0,W).sort(q);for(let F=W,A=Math.min(W+l,R);F<R;F=A,A=Math.min(A+l,R)){if(F>W&&await new Promise(B=>setTimeout(B)),a&&a.isCancellationRequested)throw new i.CancellationError;p(ie,q,u,F,A)}return u})().then(g,C)})}function p(ie,q,W,l,a){for(const g=W.length;l<a;l++){const C=ie[l];if(q(C,W[g-1])<0){W.pop();const R=(0,n.findFirstIdxMonotonousOrArrLen)(W,u=>q(C,u)<0);W.splice(R,0,C)}}}function L(ie){return ie.filter(q=>!!q)}function y(ie){let q=0;for(let W=0;W<ie.length;W++)ie[W]&&(ie[q]=ie[W],q+=1);ie.length=q}function r(ie,q,W){ie.splice(W,0,ie.splice(q,1)[0])}function f(ie){return!Array.isArray(ie)||ie.length===0}function E(ie){return Array.isArray(ie)&&ie.length>0}function I(ie,q=W=>W){const W=new Set;return ie.filter(l=>{const a=q(l);return W.has(a)?!1:(W.add(a),!0)})}function H(ie){const q=new Set;return W=>{const l=ie(W);return q.has(l)?!1:(q.add(l),!0)}}function z(ie,q){return ie.length>0?ie[0]:q}function U(ie,q){return ie.length>0?ie[ie.length-1]:q}function v(ie,q,W=(l,a)=>l===a){let l=0;for(let a=0,g=Math.min(ie.length,q.length);a<g&&W(ie[a],q[a]);a++)l++;return l}function k(ie,q){let W=typeof q=="number"?ie:0;typeof q=="number"?W=ie:(W=0,q=ie);const l=[];if(W<=q)for(let a=W;a<q;a++)l.push(a);else for(let a=W;a>q;a--)l.push(a);return l}function x(ie,q,W){return ie.reduce((l,a)=>(l[q(a)]=W?W(a):a,l),Object.create(null))}function N(ie,q){return ie.push(q),()=>M(ie,q)}function M(ie,q){const W=ie.indexOf(q);if(W>-1)return ie.splice(W,1),q}function $(ie,q,W){const l=ie.slice(0,q),a=ie.slice(q);return l.concat(W,a)}function ne(ie,q){let W;if(typeof q=="number"){let l=q;W=()=>{const a=Math.sin(l++)*179426549;return a-Math.floor(a)}}else W=Math.random;for(let l=ie.length-1;l>0;l-=1){const a=Math.floor(W()*(l+1)),g=ie[l];ie[l]=ie[a],ie[a]=g}}function Z(ie,q){const W=ie.indexOf(q);W>-1&&(ie.splice(W,1),ie.unshift(q))}function Y(ie,q){const W=ie.indexOf(q);W>-1&&(ie.splice(W,1),ie.push(q))}function te(ie,q){for(const W of q)ie.push(W)}function fe(ie,q){return Array.isArray(ie)?ie.map(q):q(ie)}function Ee(ie){return Array.isArray(ie)?ie:[ie]}function Fe(ie){return ie[Math.floor(Math.random()*ie.length)]}function Ae(ie,q,W){const l=J(ie,q),a=ie.length,g=W.length;ie.length=a+g;for(let C=a-1;C>=l;C--)ie[C+g]=ie[C];for(let C=0;C<g;C++)ie[C+l]=W[C]}function ue(ie,q,W,l){const a=J(ie,q);let g=ie.splice(a,W);return g===void 0&&(g=[]),Ae(ie,a,l),g}function J(ie,q){return q<0?Math.max(q+ie.length,0):Math.min(q,ie.length)}var de;(function(ie){function q(g){return g<0}ie.isLessThan=q;function W(g){return g<=0}ie.isLessThanOrEqual=W;function l(g){return g>0}ie.isGreaterThan=l;function a(g){return g===0}ie.isNeitherLessOrGreaterThan=a,ie.greaterThan=1,ie.lessThan=-1,ie.neitherLessOrGreaterThan=0})(de||(t.CompareResult=de={}));function ae(ie,q){return(W,l)=>q(ie(W),ie(l))}function Le(...ie){return(q,W)=>{for(const l of ie){const a=l(q,W);if(!de.isNeitherLessOrGreaterThan(a))return a}return de.neitherLessOrGreaterThan}}const Q=(ie,q)=>ie-q;t.numberComparator=Q;const me=(ie,q)=>(0,t.numberComparator)(ie?1:0,q?1:0);t.booleanComparator=me;function _e(ie){return(q,W)=>-ie(q,W)}class Oe{constructor(q){this.items=q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(q){let W=this.firstIdx;for(;W<this.items.length&&q(this.items[W]);)W++;const l=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,l}takeFromEndWhile(q){let W=this.lastIdx;for(;W>=0&&q(this.items[W]);)W--;const l=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,l}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const q=this.items[this.firstIdx];return this.firstIdx++,q}removeLast(){const q=this.items[this.lastIdx];return this.lastIdx--,q}takeCount(q){const W=this.items.slice(this.firstIdx,this.firstIdx+q);return this.firstIdx+=q,W}}t.ArrayQueue=Oe;class Ce{static{this.empty=new Ce(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(W=>(q(W),!0))}toArray(){const q=[];return this.iterate(W=>(q.push(W),!0)),q}filter(q){return new Ce(W=>this.iterate(l=>q(l)?W(l):!0))}map(q){return new Ce(W=>this.iterate(l=>W(q(l))))}some(q){let W=!1;return this.iterate(l=>(W=q(l),!W)),W}findFirst(q){let W;return this.iterate(l=>q(l)?(W=l,!1):!0),W}findLast(q){let W;return this.iterate(l=>(q(l)&&(W=l),!0)),W}findLastMaxBy(q){let W,l=!0;return this.iterate(a=>((l||de.isGreaterThan(q(a,W)))&&(l=!1,W=a),!0)),W}}t.CallbackIterable=Ce;class Be{constructor(q){this._indexMap=q}static createSortPermutation(q,W){const l=Array.from(q.keys()).sort((a,g)=>W(q[a],q[g]));return new Be(l)}apply(q){return q.map((W,l)=>q[this._indexMap[l]])}inverse(){const q=this._indexMap.slice();for(let W=0;W<this._indexMap.length;W++)q[this._indexMap[W]]=W;return new Be(q)}}t.Permutation=Be}),define(ve[41],De([1,0,6]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=n,t.assertNever=P,t.assert=O,t.softAssert=T,t.assertFn=w,t.checkAdjacentItems=_;function n(d,D){if(!d)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}function P(d,D="Unreachable"){throw new Error(D)}function O(d,D="unexpected state"){if(!d)throw new i.BugIndicatingError(`Assertion Failed: ${D}`)}function T(d){d||(0,i.onUnexpectedError)(new i.BugIndicatingError("Soft Assertion Failed"))}function w(d){if(!d()){debugger;d(),(0,i.onUnexpectedError)(new i.BugIndicatingError("Assertion Failed"))}}function _(d,D){let S=0;for(;S<d.length-1;){const b=d[S],m=d[S+1];if(!D(b,m))return!1;S++}return!0}}),define(ve[42],De([1,0,9]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.strictEquals=void 0,t.itemsEquals=P,t.jsonStringifyEquals=O,t.itemEquals=T,t.equalsIfDefined=w,t.structuralEquals=_,t.getStructuralKey=d;const n=(m,e)=>m===e;t.strictEquals=n;function P(m=t.strictEquals){return(e,s)=>i.equals(e,s,m)}function O(){return(m,e)=>JSON.stringify(m)===JSON.stringify(e)}function T(){return(m,e)=>m.equals(e)}function w(m,e,s){return!m||!e?m===e:s(m,e)}function _(m,e){if(m===e)return!0;if(Array.isArray(m)&&Array.isArray(e)){if(m.length!==e.length)return!1;for(let s=0;s<m.length;s++)if(!_(m[s],e[s]))return!1;return!0}if(m&&typeof m=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(m)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const s=m,o=e,c=Object.keys(s),h=Object.keys(o),p=new Set(h);if(c.length!==h.length)return!1;for(const L of c)if(!p.has(L)||!_(s[L],o[L]))return!1;return!0}return!1}function d(m){return JSON.stringify(b(m))}let D=0;const S=new WeakMap;function b(m){if(Array.isArray(m))return m.map(b);if(m&&typeof m=="object")if(Object.getPrototypeOf(m)===Object.prototype){const e=m,s=Object.create(null);for(const o of Object.keys(e).sort())s[o]=b(e[o]);return s}else{let e=S.get(m);return e===void 0&&(e=D++,S.set(m,e)),e+"----2b76a038c20c4bcc"}return m}}),define(ve[58],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=i;function i(n,P){const O=this;let T=!1,w;return function(){if(T)return w;if(T=!0,P)try{w=n.apply(O,arguments)}finally{P()}else w=n.apply(O,arguments);return w}}}),define(ve[91],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class i{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=i,t.defaultGenerator=new i("id#")}),define(ve[35],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(n){function P(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}n.is=P;const O=Object.freeze([]);function T(){return O}n.empty=T;function*w(r){yield r}n.single=w;function _(r){return P(r)?r:w(r)}n.wrap=_;function d(r){return r||O}n.from=d;function*D(r){for(let f=r.length-1;f>=0;f--)yield r[f]}n.reverse=D;function S(r){return!r||r[Symbol.iterator]().next().done===!0}n.isEmpty=S;function b(r){return r[Symbol.iterator]().next().value}n.first=b;function m(r,f){for(const E of r)if(f(E))return!0;return!1}n.some=m;function e(r,f){for(const E of r)if(f(E))return E}n.find=e;function*s(r,f){for(const E of r)f(E)&&(yield E)}n.filter=s;function*o(r,f){let E=0;for(const I of r)yield f(I,E++)}n.map=o;function*c(...r){for(const f of r)yield*f}n.concat=c;function h(r,f,E){let I=E;for(const H of r)I=f(I,H);return I}n.reduce=h;function*p(r,f,E=r.length){for(f<0&&(f+=r.length),E<0?E+=r.length:E>r.length&&(E=r.length);f<E;f++)yield r[f]}n.slice=p;function L(r,f=Number.POSITIVE_INFINITY){const E=[];if(f===0)return[E,r];const I=r[Symbol.iterator]();for(let H=0;H<f;H++){const z=I.next();if(z.done)return[E,n.empty()];E.push(z.value)}return[E,{[Symbol.iterator](){return I}}]}n.consume=L;async function y(r){const f=[];for await(const E of r)f.push(E);return Promise.resolve(f)}n.asyncToArray=y})(i||(t.Iterable=i={}))}),define(ve[8],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0,t.KeyChord=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(t.ScanCode=n={}));class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,o){this._keyCodeToStr[s]=o,this._strToKeyCode[o.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||i.Unknown}}const O=new P,T=new P,w=new P;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const _=[],d=Object.create(null),D=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>D[e]||n.None,toEnum:e=>d[e]||n.None,toString:e=>_[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=n.MAX_VALUE;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=i.DependsOnKbLayout;for(let e=0;e<=i.MAX_VALUE;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=n.DependsOnKbLayout;(function(){const e="",s=[[1,n.None,"None",i.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",i.Unknown,e,0,e,e,e],[1,n.Super,"Super",i.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",i.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",i.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",i.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",i.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",i.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",i.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",i.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",i.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",i.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",i.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",i.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",i.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",i.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",i.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",i.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",i.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",i.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",i.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",i.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",i.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",i.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",i.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",i.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",i.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",i.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",i.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",i.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",i.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",i.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",i.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",i.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",i.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",i.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",i.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",i.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",i.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",i.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",i.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",i.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",i.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",i.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",i.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",i.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",i.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",i.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",i.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",i.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",i.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",i.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",i.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",i.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",i.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",i.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",i.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",i.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",i.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",i.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",i.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",i.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",i.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",i.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",i.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",i.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",i.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",i.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",i.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",i.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",i.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",i.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",i.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",i.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",i.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",i.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",i.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",i.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",i.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",i.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",i.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",i.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",i.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",i.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",i.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",i.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",i.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",i.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",i.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",i.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",i.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",i.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",i.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",i.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",i.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",i.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",i.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",i.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",i.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",i.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",i.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",i.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",i.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",i.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",i.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",i.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",i.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",i.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",i.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",i.Unknown,e,0,e,e,e],[1,n.F13,"F13",i.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",i.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",i.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",i.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",i.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",i.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",i.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",i.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",i.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",i.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",i.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",i.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",i.Unknown,e,0,e,e,e],[1,n.Help,"Help",i.Unknown,e,0,e,e,e],[1,n.Select,"Select",i.Unknown,e,0,e,e,e],[1,n.Again,"Again",i.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",i.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",i.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",i.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",i.Unknown,e,0,e,e,e],[1,n.Find,"Find",i.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",i.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",i.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",i.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",i.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",i.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",i.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",i.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",i.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",i.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",i.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",i.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",i.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",i.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",i.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",i.Unknown,e,0,e,e,e],[1,n.Props,"Props",i.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",i.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",i.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",i.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",i.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",i.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",i.Unknown,e,0,e,e,e],[1,n.None,e,i.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,i.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,i.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,i.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",i.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",i.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",i.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",i.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",i.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",i.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",i.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",i.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",i.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",i.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",i.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",i.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",i.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",i.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",i.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",i.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",i.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",i.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",i.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",i.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",i.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",i.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",i.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",i.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",i.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",i.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",i.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",i.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",i.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",i.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",i.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",i.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",i.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",i.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",i.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",i.Unknown,e,0,e,e,e],[1,n.None,e,i.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,i.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,i.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,i.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,i.Unknown,e,0,"VK_OEM_CLEAR",e,e]],o=[],c=[];for(const h of s){const[p,L,y,r,f,E,I,H,z]=h;if(c[L]||(c[L]=!0,_[L]=y,d[y]=L,D[y.toLowerCase()]=L,p&&(t.IMMUTABLE_CODE_TO_KEY_CODE[L]=r,r!==i.Unknown&&r!==i.Enter&&r!==i.Ctrl&&r!==i.Shift&&r!==i.Alt&&r!==i.Meta&&(t.IMMUTABLE_KEY_CODE_TO_CODE[r]=L))),!o[r]){if(o[r]=!0,!f)throw new Error(`String representation missing for key code ${r} around scan code ${y}`);O.define(r,f),T.define(r,H||f),w.define(r,z||H||f)}E&&(t.EVENT_KEY_CODE_MAP[E]=r),I&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[I]=r)}t.IMMUTABLE_KEY_CODE_TO_CODE[i.Enter]=n.Enter})();var S;(function(e){function s(y){return O.keyCodeToStr(y)}e.toString=s;function o(y){return O.strToKeyCode(y)}e.fromString=o;function c(y){return T.keyCodeToStr(y)}e.toUserSettingsUS=c;function h(y){return w.keyCodeToStr(y)}e.toUserSettingsGeneral=h;function p(y){return T.strToKeyCode(y)||w.strToKeyCode(y)}e.fromUserSettings=p;function L(y){if(y>=i.Numpad0&&y<=i.NumpadDivide)return null;switch(y){case i.UpArrow:return"Up";case i.DownArrow:return"Down";case i.LeftArrow:return"Left";case i.RightArrow:return"Right"}return O.keyCodeToStr(y)}e.toElectronAccelerator=L})(S||(t.KeyCodeUtils=S={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function m(e,s){const o=(s&65535)<<16>>>0;return(e|o)>>>0}}),define(ve[26],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class i{constructor(P){this.executor=P,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=i}),define(ve[15],De([1,0,26]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setHoverDelegateFactory=w,t.getDefaultHoverDelegate=_,t.createInstantHoverDelegate=d;let P=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const O=new i.Lazy(()=>P("mouse",!1)),T=new i.Lazy(()=>P("element",!1));function w(D){P=D}function _(D){return D==="element"?T.value:O.value}function d(){return P("element",!0)}}),define(ve[59],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class i{static{this.Undefined=new i(void 0)}constructor(O){this.element=O,this.next=i.Undefined,this.prev=i.Undefined}}class n{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){let O=this._first;for(;O!==i.Undefined;){const T=O.next;O.prev=i.Undefined,O.next=i.Undefined,O=T}this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(O){return this._insert(O,!1)}push(O){return this._insert(O,!0)}_insert(O,T){const w=new i(O);if(this._first===i.Undefined)this._first=w,this._last=w;else if(T){const d=this._last;this._last=w,w.prev=d,d.next=w}else{const d=this._first;this._first=w,w.next=d,d.prev=w}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(w))}}shift(){if(this._first!==i.Undefined){const O=this._first.element;return this._remove(this._first),O}}pop(){if(this._last!==i.Undefined){const O=this._last.element;return this._remove(this._last),O}}_remove(O){if(O.prev!==i.Undefined&&O.next!==i.Undefined){const T=O.prev;T.next=O.next,O.next.prev=T}else O.prev===i.Undefined&&O.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):O.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):O.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let O=this._first;for(;O!==i.Undefined;)yield O.element,O=O.next}}t.LinkedList=n}),define(ve[43],De([1,0]),function(oe,t){"use strict";var i,n,P;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.MRUCache=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=O,t.mapToString=T,t.setToString=w,t.mapsStrictEqualIgnoreOrder=L;function O(y,r,f){let E=y.get(r);return E===void 0&&(E=f,y.set(r,E)),E}function T(y){const r=[];return y.forEach((f,E)=>{r.push(`${E} => ${f}`)}),`Map(${y.size}) {${r.join(", ")}}`}function w(y){const r=[];return y.forEach(f=>{r.push(f)}),`Set(${y.size}) {${r.join(", ")}}`}class _{constructor(r,f){this.uri=r,this.value=f}}function d(y){return Array.isArray(y)}class D{static{this.defaultToKey=r=>r.toString()}constructor(r,f){if(this[i]="ResourceMap",r instanceof D)this.map=new Map(r.map),this.toKey=f??D.defaultToKey;else if(d(r)){this.map=new Map,this.toKey=f??D.defaultToKey;for(const[E,I]of r)this.set(E,I)}else this.map=new Map,this.toKey=r??D.defaultToKey}set(r,f){return this.map.set(this.toKey(r),new _(r,f)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,f){typeof f<"u"&&(r=r.bind(f));for(const[E,I]of this.map)r(I.value,I.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}t.ResourceMap=D;class S{constructor(r,f){this[n]="ResourceSet",!r||typeof r=="function"?this._map=new D(r):(this._map=new D(f),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,f){this._map.forEach((E,I)=>r.call(f,I,I,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=S;var b;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class m{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,f=b.None){const E=this._map.get(r);if(E)return f!==b.None&&this.touch(E,f),E.value}set(r,f,E=b.None){let I=this._map.get(r);if(I)I.value=f,E!==b.None&&this.touch(I,E);else{switch(I={key:r,value:f,next:void 0,previous:void 0},E){case b.None:this.addItemLast(I);break;case b.AsOld:this.addItemFirst(I);break;case b.AsNew:this.addItemLast(I);break;default:this.addItemLast(I);break}this._map.set(r,I),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const f=this._map.get(r);if(f)return this._map.delete(r),this.removeItem(f),this._size--,f.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,f){const E=this._state;let I=this._head;for(;I;){if(f?r.bind(f)(I.value,I.key,this):r(I.value,I.key,this),this._state!==E)throw new Error("LinkedMap got modified during iteration.");I=I.next}}keys(){const r=this,f=this._state;let E=this._head;const I={[Symbol.iterator](){return I},next(){if(r._state!==f)throw new Error("LinkedMap got modified during iteration.");if(E){const H={value:E.key,done:!1};return E=E.next,H}else return{value:void 0,done:!0}}};return I}values(){const r=this,f=this._state;let E=this._head;const I={[Symbol.iterator](){return I},next(){if(r._state!==f)throw new Error("LinkedMap got modified during iteration.");if(E){const H={value:E.value,done:!1};return E=E.next,H}else return{value:void 0,done:!0}}};return I}entries(){const r=this,f=this._state;let E=this._head;const I={[Symbol.iterator](){return I},next(){if(r._state!==f)throw new Error("LinkedMap got modified during iteration.");if(E){const H={value:[E.key,E.value],done:!1};return E=E.next,H}else return{value:void 0,done:!0}}};return I}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let f=this._head,E=this.size;for(;f&&E>r;)this._map.delete(f.key),f=f.next,E--;this._head=f,this._size=E,f&&(f.previous=void 0),this._state++}trimNew(r){if(r>=this.size)return;if(r===0){this.clear();return}let f=this._tail,E=this.size;for(;f&&E>r;)this._map.delete(f.key),f=f.previous,E--;this._tail=f,this._size=E,f&&(f.next=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const f=r.next,E=r.previous;if(!f||!E)throw new Error("Invalid list");f.previous=E,E.next=f}r.next=void 0,r.previous=void 0,this._state++}touch(r,f){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(f!==b.AsOld&&f!==b.AsNew)){if(f===b.AsOld){if(r===this._head)return;const E=r.next,I=r.previous;r===this._tail?(I.next=void 0,this._tail=I):(E.previous=I,I.next=E),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(f===b.AsNew){if(r===this._tail)return;const E=r.next,I=r.previous;r===this._head?(E.previous=void 0,this._head=E):(E.previous=I,I.next=E),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((f,E)=>{r.push([E,f])}),r}fromJSON(r){this.clear();for(const[f,E]of r)this.set(f,E)}}t.LinkedMap=m;class e extends m{constructor(r,f=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,f),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,f=b.AsNew){return super.get(r,f)}peek(r){return super.get(r,b.None)}set(r,f){return super.set(r,f,b.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class s extends e{constructor(r,f=1){super(r,f)}trim(r){this.trimOld(r)}set(r,f){return super.set(r,f),this.checkTrim(),this}}t.LRUCache=s;class o extends e{constructor(r,f=1){super(r,f)}trim(r){this.trimNew(r)}set(r,f){return this._limit<=this.size&&!this.has(r)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(r,f),this}}t.MRUCache=o;class c{constructor(){this.map=new Map}add(r){return this.map.set(r,(this.map.get(r)||0)+1),this}delete(r){let f=this.map.get(r)||0;return f===0?!1:(f--,f===0?this.map.delete(r):this.map.set(r,f),!0)}has(r){return this.map.has(r)}}t.CounterSet=c;class h{constructor(r){if(this._m1=new Map,this._m2=new Map,r)for(const[f,E]of r)this.set(f,E)}clear(){this._m1.clear(),this._m2.clear()}set(r,f){this._m1.set(r,f),this._m2.set(f,r)}get(r){return this._m1.get(r)}getKey(r){return this._m2.get(r)}delete(r){const f=this._m1.get(r);return f===void 0?!1:(this._m1.delete(r),this._m2.delete(f),!0)}forEach(r,f){this._m1.forEach((E,I)=>{r.call(f,E,I,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=h;class p{constructor(){this.map=new Map}add(r,f){let E=this.map.get(r);E||(E=new Set,this.map.set(r,E)),E.add(f)}delete(r,f){const E=this.map.get(r);E&&(E.delete(f),E.size===0&&this.map.delete(r))}forEach(r,f){const E=this.map.get(r);E&&E.forEach(f)}get(r){const f=this.map.get(r);return f||new Set}}t.SetMap=p;function L(y,r){if(y===r)return!0;if(y.size!==r.size)return!1;for(const[f,E]of y)if(!r.has(f)||r.get(f)!==E)return!1;for(const[f]of r)if(!y.has(f))return!1;return!0}}),define(ve[2],De([1,0,9,88,43,58,35]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=D,t.trackDisposable=S,t.markAsDisposed=b,t.markAsSingleton=s,t.isDisposable=o,t.dispose=c,t.disposeIfDisposable=h,t.combinedDisposable=p,t.toDisposable=L,t.disposeOnReturn=k;const w=!1;let _=null;class d{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(M){let $=this.livingDisposables.get(M);return $||($={parent:null,source:null,isSingleton:!1,value:M,idx:d.idx++},this.livingDisposables.set(M,$)),$}trackDisposable(M){const $=this.getDisposableData(M);$.source||($.source=new Error().stack)}setParent(M,$){const ne=this.getDisposableData(M);ne.parent=$}markAsDisposed(M){this.livingDisposables.delete(M)}markAsSingleton(M){this.getDisposableData(M).isSingleton=!0}getRootParent(M,$){const ne=$.get(M);if(ne)return ne;const Z=M.parent?this.getRootParent(this.getDisposableData(M.parent),$):M;return $.set(M,Z),Z}getTrackedDisposables(){const M=new Map;return[...this.livingDisposables.entries()].filter(([,ne])=>ne.source!==null&&!this.getRootParent(ne,M).isSingleton).flatMap(([ne])=>ne)}computeLeakingDisposables(M=10,$){let ne;if($)ne=$;else{const Ee=new Map,Fe=[...this.livingDisposables.values()].filter(ue=>ue.source!==null&&!this.getRootParent(ue,Ee).isSingleton);if(Fe.length===0)return;const Ae=new Set(Fe.map(ue=>ue.value));if(ne=Fe.filter(ue=>!(ue.parent&&Ae.has(ue.parent))),ne.length===0)throw new Error("There are cyclic diposable chains!")}if(!ne)return;function Z(Ee){function Fe(ue,J){for(;ue.length>0&&J.some(de=>typeof de=="string"?de===ue[0]:ue[0].match(de));)ue.shift()}const Ae=Ee.source.split(`
`).map(ue=>ue.trim().replace("at ","")).filter(ue=>ue!=="");return Fe(Ae,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Ae.reverse()}const Y=new P.SetMap;for(const Ee of ne){const Fe=Z(Ee);for(let Ae=0;Ae<=Fe.length;Ae++)Y.add(Fe.slice(0,Ae).join(`
`),Ee)}ne.sort((0,i.compareBy)(Ee=>Ee.idx,i.numberComparator));let te="",fe=0;for(const Ee of ne.slice(0,M)){fe++;const Fe=Z(Ee),Ae=[];for(let ue=0;ue<Fe.length;ue++){let J=Fe[ue];J=`(shared with ${Y.get(Fe.slice(0,ue+1).join(`
`)).size}/${ne.length} leaks) at ${J}`;const ae=Y.get(Fe.slice(0,ue).join(`
`)),Le=(0,n.groupBy)([...ae].map(Q=>Z(Q)[ue]),Q=>Q);delete Le[Fe[ue]];for(const[Q,me]of Object.entries(Le))Ae.unshift(`    - stacktraces of ${me.length} other leaks continue with ${Q}`);Ae.unshift(J)}te+=`


==================== Leaking disposable ${fe}/${ne.length}: ${Ee.value.constructor.name} ====================
${Ae.join(`
`)}
============================================================

`}return ne.length>M&&(te+=`


... and ${ne.length-M} more leaking disposables

`),{leaks:ne,details:te}}}t.DisposableTracker=d;function D(N){_=N}if(w){const N="__is_disposable_tracked__";D(new class{trackDisposable(M){const $=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[N]||console.log($)},3e3)}setParent(M,$){if(M&&M!==r.None)try{M[N]=!0}catch{}}markAsDisposed(M){if(M&&M!==r.None)try{M[N]=!0}catch{}}markAsSingleton(M){}})}function S(N){return _?.trackDisposable(N),N}function b(N){_?.markAsDisposed(N)}function m(N,M){_?.setParent(N,M)}function e(N,M){if(_)for(const $ of N)_.setParent($,M)}function s(N){return _?.markAsSingleton(N),N}function o(N){return typeof N=="object"&&N!==null&&typeof N.dispose=="function"&&N.dispose.length===0}function c(N){if(T.Iterable.is(N)){const M=[];for(const $ of N)if($)try{$.dispose()}catch(ne){M.push(ne)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(N)?[]:N}else if(N)return N.dispose(),N}function h(N){for(const M of N)o(M)&&M.dispose();return[]}function p(...N){const M=L(()=>c(N));return e(N,M),M}function L(N){const M=S({dispose:(0,O.createSingleCallFunction)(()=>{b(M),N()})});return M}class y{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{c(this._toDispose)}finally{this._toDispose.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return m(M,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(M),M.dispose()}}deleteAndLeak(M){M&&this._toDispose.has(M)&&(this._toDispose.delete(M),m(M,null))}}t.DisposableStore=y;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new y,S(this),m(this._store,this)}dispose(){b(this),this._store.dispose()}_register(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(M)}}t.Disposable=r;class f{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(M){this._isDisposed||M===this._value||(this._value?.dispose(),M&&m(M,this),this._value=M)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const M=this._value;return this._value=void 0,M&&m(M,null),M}}t.MutableDisposable=f;class E{constructor(M){this._disposable=new f,this._isDisposed=!1,this._disposable.value=M}get value(){return this._disposable.value}set value(M){this._isDisposed||M===this._disposable.value||(this._disposable.value=M)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=E;class I{constructor(M){this._disposable=M,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=I;class H{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(M){let $=M;return this.unset=()=>$=void 0,this.isset=()=>$!==void 0,this.dispose=()=>{$&&($(),$=void 0,b(this))},this}}t.SafeDisposable=H;class z{constructor(){this.references=new Map}acquire(M,...$){let ne=this.references.get(M);ne||(ne={counter:0,object:this.createReferencedObject(M,...$)},this.references.set(M,ne));const{object:Z}=ne,Y=(0,O.createSingleCallFunction)(()=>{--ne.counter===0&&(this.destroyReferencedObject(M,ne.object),this.references.delete(M))});return ne.counter++,{object:Z,dispose:Y}}}t.ReferenceCollection=z;class U{constructor(M){this.referenceCollection=M}async acquire(M,...$){const ne=this.referenceCollection.acquire(M,...$);try{return{object:await ne.object,dispose:()=>ne.dispose()}}catch(Z){throw ne.dispose(),Z}}}t.AsyncReferenceCollection=U;class v{constructor(M){this.object=M}dispose(){}}t.ImmortalReference=v;function k(N){const M=new y;try{N(M)}finally{M.dispose()}}class x{constructor(){this._store=new Map,this._isDisposed=!1,S(this)}dispose(){b(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{c(this._store.values())}finally{this._store.clear()}}has(M){return this._store.has(M)}get size(){return this._store.size}get(M){return this._store.get(M)}set(M,$,ne=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ne||this._store.get(M)?.dispose(),this._store.set(M,$)}deleteAndDispose(M){this._store.get(M)?.dispose(),this._store.delete(M)}deleteAndLeak(M){const $=this._store.get(M);return this._store.delete(M),$}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=x}),function(oe,t){typeof define=="function"&&define.amd?define(ve[92],De([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,t(oe.marked={}))}(this,function(oe){"use strict";function t(q,W){for(var l=0;l<W.length;l++){var a=W[l];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(q,a.key,a)}}function i(q,W,l){return W&&t(q.prototype,W),l&&t(q,l),Object.defineProperty(q,"prototype",{writable:!1}),q}function n(q,W){if(q){if(typeof q=="string")return P(q,W);var l=Object.prototype.toString.call(q).slice(8,-1);if(l==="Object"&&q.constructor&&(l=q.constructor.name),l==="Map"||l==="Set")return Array.from(q);if(l==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(l))return P(q,W)}}function P(q,W){(W==null||W>q.length)&&(W=q.length);for(var l=0,a=new Array(W);l<W;l++)a[l]=q[l];return a}function O(q,W){var l=typeof Symbol<"u"&&q[Symbol.iterator]||q["@@iterator"];if(l)return(l=l.call(q)).next.bind(l);if(Array.isArray(q)||(l=n(q))||W&&q&&typeof q.length=="number"){l&&(q=l);var a=0;return function(){return a>=q.length?{done:!0}:{done:!1,value:q[a++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=T();function w(q){oe.defaults=q}var _=/[&<>"']/,d=/[&<>"']/g,D=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(W){return b[W]};function e(q,W){if(W){if(_.test(q))return q.replace(d,m)}else if(D.test(q))return q.replace(S,m);return q}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(q){return q.replace(s,function(W,l){return l=l.toLowerCase(),l==="colon"?":":l.charAt(0)==="#"?l.charAt(1)==="x"?String.fromCharCode(parseInt(l.substring(2),16)):String.fromCharCode(+l.substring(1)):""})}var c=/(^|[^\[])\^/g;function h(q,W){q=typeof q=="string"?q:q.source,W=W||"";var l={replace:function(g,C){return C=C.source||C,C=C.replace(c,"$1"),q=q.replace(g,C),l},getRegex:function(){return new RegExp(q,W)}};return l}var p=/[^\w:]/g,L=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(q,W,l){if(q){var a;try{a=decodeURIComponent(o(l)).replace(p,"").toLowerCase()}catch{return null}if(a.indexOf("javascript:")===0||a.indexOf("vbscript:")===0||a.indexOf("data:")===0)return null}W&&!L.test(l)&&(l=H(W,l));try{l=encodeURI(l).replace(/%25/g,"%")}catch{return null}return l}var r={},f=/^[^:]+:\/*[^/]*$/,E=/^([^:]+:)[\s\S]*$/,I=/^([^:]+:\/*[^/]*)[\s\S]*$/;function H(q,W){r[" "+q]||(f.test(q)?r[" "+q]=q+"/":r[" "+q]=k(q,"/",!0)),q=r[" "+q];var l=q.indexOf(":")===-1;return W.substring(0,2)==="//"?l?W:q.replace(E,"$1")+W:W.charAt(0)==="/"?l?W:q.replace(I,"$1")+W:q+W}var z={exec:function(){}};function U(q){for(var W=1,l,a;W<arguments.length;W++){l=arguments[W];for(a in l)Object.prototype.hasOwnProperty.call(l,a)&&(q[a]=l[a])}return q}function v(q,W){var l=q.replace(/\|/g,function(C,R,u){for(var F=!1,A=R;--A>=0&&u[A]==="\\";)F=!F;return F?"|":" |"}),a=l.split(/ \|/),g=0;if(a[0].trim()||a.shift(),a.length>0&&!a[a.length-1].trim()&&a.pop(),a.length>W)a.splice(W);else for(;a.length<W;)a.push("");for(;g<a.length;g++)a[g]=a[g].trim().replace(/\\\|/g,"|");return a}function k(q,W,l){var a=q.length;if(a===0)return"";for(var g=0;g<a;){var C=q.charAt(a-g-1);if(C===W&&!l)g++;else if(C!==W&&l)g++;else break}return q.slice(0,a-g)}function x(q,W){if(q.indexOf(W[1])===-1)return-1;for(var l=q.length,a=0,g=0;g<l;g++)if(q[g]==="\\")g++;else if(q[g]===W[0])a++;else if(q[g]===W[1]&&(a--,a<0))return g;return-1}function N(q){q&&q.sanitize&&!q.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(q,W){if(W<1)return"";for(var l="";W>1;)W&1&&(l+=q),W>>=1,q+=q;return l+q}function $(q,W,l,a){var g=W.href,C=W.title?e(W.title):null,R=q[1].replace(/\\([\[\]])/g,"$1");if(q[0].charAt(0)!=="!"){a.state.inLink=!0;var u={type:"link",raw:l,href:g,title:C,text:R,tokens:a.inlineTokens(R)};return a.state.inLink=!1,u}return{type:"image",raw:l,href:g,title:C,text:e(R)}}function ne(q,W){var l=q.match(/^(\s+)(?:```)/);if(l===null)return W;var a=l[1];return W.split(`
`).map(function(g){var C=g.match(/^\s+/);if(C===null)return g;var R=C[0];return R.length>=a.length?g.slice(a.length):g}).join(`
`)}var Z=function(){function q(l){this.options=l||oe.defaults}var W=q.prototype;return W.space=function(a){var g=this.rules.block.newline.exec(a);if(g&&g[0].length>0)return{type:"space",raw:g[0]}},W.code=function(a){var g=this.rules.block.code.exec(a);if(g){var C=g[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:g[0],codeBlockStyle:"indented",text:this.options.pedantic?C:k(C,`
`)}}},W.fences=function(a){var g=this.rules.block.fences.exec(a);if(g){var C=g[0],R=ne(C,g[3]||"");return{type:"code",raw:C,lang:g[2]?g[2].trim():g[2],text:R}}},W.heading=function(a){var g=this.rules.block.heading.exec(a);if(g){var C=g[2].trim();if(/#$/.test(C)){var R=k(C,"#");(this.options.pedantic||!R||/ $/.test(R))&&(C=R.trim())}return{type:"heading",raw:g[0],depth:g[1].length,text:C,tokens:this.lexer.inline(C)}}},W.hr=function(a){var g=this.rules.block.hr.exec(a);if(g)return{type:"hr",raw:g[0]}},W.blockquote=function(a){var g=this.rules.block.blockquote.exec(a);if(g){var C=g[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:g[0],tokens:this.lexer.blockTokens(C,[]),text:C}}},W.list=function(a){var g=this.rules.block.list.exec(a);if(g){var C,R,u,F,A,B,V,G,ee,re,he,ye,we=g[1].trim(),Ie=we.length>1,Te={type:"list",raw:"",ordered:Ie,start:Ie?+we.slice(0,-1):"",loose:!1,items:[]};we=Ie?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Ie?we:"[*+-]");for(var ce=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");a&&(ye=!1,!(!(g=ce.exec(a))||this.rules.block.hr.test(a)));){if(C=g[0],a=a.substring(C.length),G=g[2].split(`
`,1)[0],ee=a.split(`
`,1)[0],this.options.pedantic?(F=2,he=G.trimLeft()):(F=g[2].search(/[^ ]/),F=F>4?1:F,he=G.slice(F),F+=g[1].length),B=!1,!G&&/^ *$/.test(ee)&&(C+=ee+`
`,a=a.substring(ee.length+1),ye=!0),!ye)for(var Re=new RegExp("^ {0,"+Math.min(3,F-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ue=new RegExp("^ {0,"+Math.min(3,F-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ye=new RegExp("^ {0,"+Math.min(3,F-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,F-1)+"}#");a&&(re=a.split(`
`,1)[0],G=re,this.options.pedantic&&(G=G.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ye.test(G)||et.test(G)||Re.test(G)||Ue.test(a)));){if(G.search(/[^ ]/)>=F||!G.trim())he+=`
`+G.slice(F);else if(!B)he+=`
`+G;else break;!B&&!G.trim()&&(B=!0),C+=re+`
`,a=a.substring(re.length+1)}Te.loose||(V?Te.loose=!0:/\n *\n *$/.test(C)&&(V=!0)),this.options.gfm&&(R=/^\[[ xX]\] /.exec(he),R&&(u=R[0]!=="[ ] ",he=he.replace(/^\[[ xX]\] +/,""))),Te.items.push({type:"list_item",raw:C,task:!!R,checked:u,loose:!1,text:he}),Te.raw+=C}Te.items[Te.items.length-1].raw=C.trimRight(),Te.items[Te.items.length-1].text=he.trimRight(),Te.raw=Te.raw.trimRight();var ot=Te.items.length;for(A=0;A<ot;A++){this.lexer.state.top=!1,Te.items[A].tokens=this.lexer.blockTokens(Te.items[A].text,[]);var it=Te.items[A].tokens.filter(function(Ze){return Ze.type==="space"}),$e=it.every(function(Ze){for(var X=Ze.raw.split(""),le=0,be=O(X),Se;!(Se=be()).done;){var Me=Se.value;if(Me===`
`&&(le+=1),le>1)return!0}return!1});!Te.loose&&it.length&&$e&&(Te.loose=!0,Te.items[A].loose=!0)}return Te}},W.html=function(a){var g=this.rules.block.html.exec(a);if(g){var C={type:"html",raw:g[0],pre:!this.options.sanitizer&&(g[1]==="pre"||g[1]==="script"||g[1]==="style"),text:g[0]};if(this.options.sanitize){var R=this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]);C.type="paragraph",C.text=R,C.tokens=this.lexer.inline(R)}return C}},W.def=function(a){var g=this.rules.block.def.exec(a);if(g){g[3]&&(g[3]=g[3].substring(1,g[3].length-1));var C=g[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:C,raw:g[0],href:g[2],title:g[3]}}},W.table=function(a){var g=this.rules.block.table.exec(a);if(g){var C={type:"table",header:v(g[1]).map(function(V){return{text:V}}),align:g[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:g[3]&&g[3].trim()?g[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(C.header.length===C.align.length){C.raw=g[0];var R=C.align.length,u,F,A,B;for(u=0;u<R;u++)/^ *-+: *$/.test(C.align[u])?C.align[u]="right":/^ *:-+: *$/.test(C.align[u])?C.align[u]="center":/^ *:-+ *$/.test(C.align[u])?C.align[u]="left":C.align[u]=null;for(R=C.rows.length,u=0;u<R;u++)C.rows[u]=v(C.rows[u],C.header.length).map(function(V){return{text:V}});for(R=C.header.length,F=0;F<R;F++)C.header[F].tokens=this.lexer.inline(C.header[F].text);for(R=C.rows.length,F=0;F<R;F++)for(B=C.rows[F],A=0;A<B.length;A++)B[A].tokens=this.lexer.inline(B[A].text);return C}}},W.lheading=function(a){var g=this.rules.block.lheading.exec(a);if(g)return{type:"heading",raw:g[0],depth:g[2].charAt(0)==="="?1:2,text:g[1],tokens:this.lexer.inline(g[1])}},W.paragraph=function(a){var g=this.rules.block.paragraph.exec(a);if(g){var C=g[1].charAt(g[1].length-1)===`
`?g[1].slice(0,-1):g[1];return{type:"paragraph",raw:g[0],text:C,tokens:this.lexer.inline(C)}}},W.text=function(a){var g=this.rules.block.text.exec(a);if(g)return{type:"text",raw:g[0],text:g[0],tokens:this.lexer.inline(g[0])}},W.escape=function(a){var g=this.rules.inline.escape.exec(a);if(g)return{type:"escape",raw:g[0],text:e(g[1])}},W.tag=function(a){var g=this.rules.inline.tag.exec(a);if(g)return!this.lexer.state.inLink&&/^<a /i.test(g[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(g[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(g[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(g[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:g[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]):g[0]}},W.link=function(a){var g=this.rules.inline.link.exec(a);if(g){var C=g[2].trim();if(!this.options.pedantic&&/^</.test(C)){if(!/>$/.test(C))return;var R=k(C.slice(0,-1),"\\");if((C.length-R.length)%2===0)return}else{var u=x(g[2],"()");if(u>-1){var F=g[0].indexOf("!")===0?5:4,A=F+g[1].length+u;g[2]=g[2].substring(0,u),g[0]=g[0].substring(0,A).trim(),g[3]=""}}var B=g[2],V="";if(this.options.pedantic){var G=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);G&&(B=G[1],V=G[3])}else V=g[3]?g[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(C)?B=B.slice(1):B=B.slice(1,-1)),$(g,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:V&&V.replace(this.rules.inline._escapes,"$1")},g[0],this.lexer)}},W.reflink=function(a,g){var C;if((C=this.rules.inline.reflink.exec(a))||(C=this.rules.inline.nolink.exec(a))){var R=(C[2]||C[1]).replace(/\s+/g," ");if(R=g[R.toLowerCase()],!R||!R.href){var u=C[0].charAt(0);return{type:"text",raw:u,text:u}}return $(C,R,C[0],this.lexer)}},W.emStrong=function(a,g,C){C===void 0&&(C="");var R=this.rules.inline.emStrong.lDelim.exec(a);if(R&&!(R[3]&&C.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var u=R[1]||R[2]||"";if(!u||u&&(C===""||this.rules.inline.punctuation.exec(C))){var F=R[0].length-1,A,B,V=F,G=0,ee=R[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ee.lastIndex=0,g=g.slice(-1*a.length+F);(R=ee.exec(g))!=null;)if(A=R[1]||R[2]||R[3]||R[4]||R[5]||R[6],!!A){if(B=A.length,R[3]||R[4]){V+=B;continue}else if((R[5]||R[6])&&F%3&&!((F+B)%3)){G+=B;continue}if(V-=B,!(V>0)){if(B=Math.min(B,B+V+G),Math.min(F,B)%2){var re=a.slice(1,F+R.index+B);return{type:"em",raw:a.slice(0,F+R.index+B+1),text:re,tokens:this.lexer.inlineTokens(re)}}var he=a.slice(2,F+R.index+B-1);return{type:"strong",raw:a.slice(0,F+R.index+B+1),text:he,tokens:this.lexer.inlineTokens(he)}}}}}},W.codespan=function(a){var g=this.rules.inline.code.exec(a);if(g){var C=g[2].replace(/\n/g," "),R=/[^ ]/.test(C),u=/^ /.test(C)&&/ $/.test(C);return R&&u&&(C=C.substring(1,C.length-1)),C=e(C,!0),{type:"codespan",raw:g[0],text:C}}},W.br=function(a){var g=this.rules.inline.br.exec(a);if(g)return{type:"br",raw:g[0]}},W.del=function(a){var g=this.rules.inline.del.exec(a);if(g)return{type:"del",raw:g[0],text:g[2],tokens:this.lexer.inlineTokens(g[2])}},W.autolink=function(a,g){var C=this.rules.inline.autolink.exec(a);if(C){var R,u;return C[2]==="@"?(R=e(this.options.mangle?g(C[1]):C[1]),u="mailto:"+R):(R=e(C[1]),u=R),{type:"link",raw:C[0],text:R,href:u,tokens:[{type:"text",raw:R,text:R}]}}},W.url=function(a,g){var C;if(C=this.rules.inline.url.exec(a)){var R,u;if(C[2]==="@")R=e(this.options.mangle?g(C[0]):C[0]),u="mailto:"+R;else{var F;do F=C[0],C[0]=this.rules.inline._backpedal.exec(C[0])[0];while(F!==C[0]);R=e(C[0]),C[1]==="www."?u="http://"+R:u=R}return{type:"link",raw:C[0],text:R,href:u,tokens:[{type:"text",raw:R,text:R}]}}},W.inlineText=function(a,g){var C=this.rules.inline.text.exec(a);if(C){var R;return this.lexer.state.inRawBlock?R=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(C[0]):e(C[0]):C[0]:R=e(this.options.smartypants?g(C[0]):C[0]),{type:"text",raw:C[0],text:R}}},q}(),Y={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:z,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};Y._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,Y._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Y.def=h(Y.def).replace("label",Y._label).replace("title",Y._title).getRegex(),Y.bullet=/(?:[*+-]|\d{1,9}[.)])/,Y.listItemStart=h(/^( *)(bull) */).replace("bull",Y.bullet).getRegex(),Y.list=h(Y.list).replace(/bull/g,Y.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Y.def.source+")").getRegex(),Y._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Y._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Y.html=h(Y.html,"i").replace("comment",Y._comment).replace("tag",Y._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Y.paragraph=h(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.blockquote=h(Y.blockquote).replace("paragraph",Y.paragraph).getRegex(),Y.normal=U({},Y),Y.gfm=U({},Y.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Y.gfm.table=h(Y.gfm.table).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.gfm.paragraph=h(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",Y.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.pedantic=U({},Y.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Y._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:z,paragraph:h(Y.normal._paragraph).replace("hr",Y.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Y.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:z,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:z,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=h(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=h(Y._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=h(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=h(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=h(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=h(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=h(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=h(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=h(te.reflink).replace("label",te._label).replace("ref",Y._label).getRegex(),te.nolink=h(te.nolink).replace("ref",Y._label).getRegex(),te.reflinkSearch=h(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=U({},te),te.pedantic=U({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=U({},te.normal,{escape:h(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=h(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=U({},te.gfm,{br:h(te.br).replace("{2,}","*").getRegex(),text:h(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function fe(q){return q.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ee(q){var W="",l,a,g=q.length;for(l=0;l<g;l++)a=q.charCodeAt(l),Math.random()>.5&&(a="x"+a.toString(16)),W+="&#"+a+";";return W}var Fe=function(){function q(l){this.tokens=[],this.tokens.links=Object.create(null),this.options=l||oe.defaults,this.options.tokenizer=this.options.tokenizer||new Z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var a={block:Y.normal,inline:te.normal};this.options.pedantic?(a.block=Y.pedantic,a.inline=te.pedantic):this.options.gfm&&(a.block=Y.gfm,this.options.breaks?a.inline=te.breaks:a.inline=te.gfm),this.tokenizer.rules=a}q.lex=function(a,g){var C=new q(g);return C.lex(a)},q.lexInline=function(a,g){var C=new q(g);return C.inlineTokens(a)};var W=q.prototype;return W.lex=function(a){a=a.replace(/\r\n|\r/g,`
`),this.blockTokens(a,this.tokens);for(var g;g=this.inlineQueue.shift();)this.inlineTokens(g.src,g.tokens);return this.tokens},W.blockTokens=function(a,g){var C=this;g===void 0&&(g=[]),this.options.pedantic?a=a.replace(/\t/g,"    ").replace(/^ +$/gm,""):a=a.replace(/^( *)(\t+)/gm,function(V,G,ee){return G+"    ".repeat(ee.length)});for(var R,u,F,A;a;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(V){return(R=V.call({lexer:C},a,g))?(a=a.substring(R.raw.length),g.push(R),!0):!1}))){if(R=this.tokenizer.space(a)){a=a.substring(R.raw.length),R.raw.length===1&&g.length>0?g[g.length-1].raw+=`
`:g.push(R);continue}if(R=this.tokenizer.code(a)){a=a.substring(R.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+R.raw,u.text+=`
`+R.text,this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(R);continue}if(R=this.tokenizer.fences(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.heading(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.hr(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.blockquote(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.list(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.html(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.def(a)){a=a.substring(R.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+R.raw,u.text+=`
`+R.raw,this.inlineQueue[this.inlineQueue.length-1].src=u.text):this.tokens.links[R.tag]||(this.tokens.links[R.tag]={href:R.href,title:R.title});continue}if(R=this.tokenizer.table(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.lheading(a)){a=a.substring(R.raw.length),g.push(R);continue}if(F=a,this.options.extensions&&this.options.extensions.startBlock&&function(){var V=1/0,G=a.slice(1),ee=void 0;C.options.extensions.startBlock.forEach(function(re){ee=re.call({lexer:this},G),typeof ee=="number"&&ee>=0&&(V=Math.min(V,ee))}),V<1/0&&V>=0&&(F=a.substring(0,V+1))}(),this.state.top&&(R=this.tokenizer.paragraph(F))){u=g[g.length-1],A&&u.type==="paragraph"?(u.raw+=`
`+R.raw,u.text+=`
`+R.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(R),A=F.length!==a.length,a=a.substring(R.raw.length);continue}if(R=this.tokenizer.text(a)){a=a.substring(R.raw.length),u=g[g.length-1],u&&u.type==="text"?(u.raw+=`
`+R.raw,u.text+=`
`+R.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(R);continue}if(a){var B="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,g},W.inline=function(a,g){return g===void 0&&(g=[]),this.inlineQueue.push({src:a,tokens:g}),g},W.inlineTokens=function(a,g){var C=this;g===void 0&&(g=[]);var R,u,F,A=a,B,V,G;if(this.tokens.links){var ee=Object.keys(this.tokens.links);if(ee.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(A))!=null;)ee.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(A=A.slice(0,B.index)+"["+M("a",B[0].length-2)+"]"+A.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(A))!=null;)A=A.slice(0,B.index)+"["+M("a",B[0].length-2)+"]"+A.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(A))!=null;)A=A.slice(0,B.index)+"++"+A.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;a;)if(V||(G=""),V=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(he){return(R=he.call({lexer:C},a,g))?(a=a.substring(R.raw.length),g.push(R),!0):!1}))){if(R=this.tokenizer.escape(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.tag(a)){a=a.substring(R.raw.length),u=g[g.length-1],u&&R.type==="text"&&u.type==="text"?(u.raw+=R.raw,u.text+=R.text):g.push(R);continue}if(R=this.tokenizer.link(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.reflink(a,this.tokens.links)){a=a.substring(R.raw.length),u=g[g.length-1],u&&R.type==="text"&&u.type==="text"?(u.raw+=R.raw,u.text+=R.text):g.push(R);continue}if(R=this.tokenizer.emStrong(a,A,G)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.codespan(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.br(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.del(a)){a=a.substring(R.raw.length),g.push(R);continue}if(R=this.tokenizer.autolink(a,Ee)){a=a.substring(R.raw.length),g.push(R);continue}if(!this.state.inLink&&(R=this.tokenizer.url(a,Ee))){a=a.substring(R.raw.length),g.push(R);continue}if(F=a,this.options.extensions&&this.options.extensions.startInline&&function(){var he=1/0,ye=a.slice(1),we=void 0;C.options.extensions.startInline.forEach(function(Ie){we=Ie.call({lexer:this},ye),typeof we=="number"&&we>=0&&(he=Math.min(he,we))}),he<1/0&&he>=0&&(F=a.substring(0,he+1))}(),R=this.tokenizer.inlineText(F,fe)){a=a.substring(R.raw.length),R.raw.slice(-1)!=="_"&&(G=R.raw.slice(-1)),V=!0,u=g[g.length-1],u&&u.type==="text"?(u.raw+=R.raw,u.text+=R.text):g.push(R);continue}if(a){var re="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return g},i(q,null,[{key:"rules",get:function(){return{block:Y,inline:te}}}]),q}(),Ae=function(){function q(l){this.options=l||oe.defaults}var W=q.prototype;return W.code=function(a,g,C){var R=(g||"").match(/\S*/)[0];if(this.options.highlight){var u=this.options.highlight(a,R);u!=null&&u!==a&&(C=!0,a=u)}return a=a.replace(/\n$/,"")+`
`,R?'<pre><code class="'+this.options.langPrefix+e(R,!0)+'">'+(C?a:e(a,!0))+`</code></pre>
`:"<pre><code>"+(C?a:e(a,!0))+`</code></pre>
`},W.blockquote=function(a){return`<blockquote>
`+a+`</blockquote>
`},W.html=function(a){return a},W.heading=function(a,g,C,R){if(this.options.headerIds){var u=this.options.headerPrefix+R.slug(C);return"<h"+g+' id="'+u+'">'+a+"</h"+g+`>
`}return"<h"+g+">"+a+"</h"+g+`>
`},W.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},W.list=function(a,g,C){var R=g?"ol":"ul",u=g&&C!==1?' start="'+C+'"':"";return"<"+R+u+`>
`+a+"</"+R+`>
`},W.listitem=function(a){return"<li>"+a+`</li>
`},W.checkbox=function(a){return"<input "+(a?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},W.paragraph=function(a){return"<p>"+a+`</p>
`},W.table=function(a,g){return g&&(g="<tbody>"+g+"</tbody>"),`<table>
<thead>
`+a+`</thead>
`+g+`</table>
`},W.tablerow=function(a){return`<tr>
`+a+`</tr>
`},W.tablecell=function(a,g){var C=g.header?"th":"td",R=g.align?"<"+C+' align="'+g.align+'">':"<"+C+">";return R+a+("</"+C+`>
`)},W.strong=function(a){return"<strong>"+a+"</strong>"},W.em=function(a){return"<em>"+a+"</em>"},W.codespan=function(a){return"<code>"+a+"</code>"},W.br=function(){return this.options.xhtml?"<br/>":"<br>"},W.del=function(a){return"<del>"+a+"</del>"},W.link=function(a,g,C){if(a=y(this.options.sanitize,this.options.baseUrl,a),a===null)return C;var R='<a href="'+e(a)+'"';return g&&(R+=' title="'+g+'"'),R+=">"+C+"</a>",R},W.image=function(a,g,C){if(a=y(this.options.sanitize,this.options.baseUrl,a),a===null)return C;var R='<img src="'+a+'" alt="'+C+'"';return g&&(R+=' title="'+g+'"'),R+=this.options.xhtml?"/>":">",R},W.text=function(a){return a},q}(),ue=function(){function q(){}var W=q.prototype;return W.strong=function(a){return a},W.em=function(a){return a},W.codespan=function(a){return a},W.del=function(a){return a},W.html=function(a){return a},W.text=function(a){return a},W.link=function(a,g,C){return""+C},W.image=function(a,g,C){return""+C},W.br=function(){return""},q}(),J=function(){function q(){this.seen={}}var W=q.prototype;return W.serialize=function(a){return a.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},W.getNextSafeSlug=function(a,g){var C=a,R=0;if(this.seen.hasOwnProperty(C)){R=this.seen[a];do R++,C=a+"-"+R;while(this.seen.hasOwnProperty(C))}return g||(this.seen[a]=R,this.seen[C]=0),C},W.slug=function(a,g){g===void 0&&(g={});var C=this.serialize(a);return this.getNextSafeSlug(C,g.dryrun)},q}(),de=function(){function q(l){this.options=l||oe.defaults,this.options.renderer=this.options.renderer||new Ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ue,this.slugger=new J}q.parse=function(a,g){var C=new q(g);return C.parse(a)},q.parseInline=function(a,g){var C=new q(g);return C.parseInline(a)};var W=q.prototype;return W.parse=function(a,g){g===void 0&&(g=!0);var C="",R,u,F,A,B,V,G,ee,re,he,ye,we,Ie,Te,ce,Re,Ue,Ye,et,ot=a.length;for(R=0;R<ot;R++){if(he=a[R],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(et=this.options.extensions.renderers[he.type].call({parser:this},he),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(he.type))){C+=et||"";continue}switch(he.type){case"space":continue;case"hr":{C+=this.renderer.hr();continue}case"heading":{C+=this.renderer.heading(this.parseInline(he.tokens),he.depth,o(this.parseInline(he.tokens,this.textRenderer)),this.slugger);continue}case"code":{C+=this.renderer.code(he.text,he.lang,he.escaped);continue}case"table":{for(ee="",G="",A=he.header.length,u=0;u<A;u++)G+=this.renderer.tablecell(this.parseInline(he.header[u].tokens),{header:!0,align:he.align[u]});for(ee+=this.renderer.tablerow(G),re="",A=he.rows.length,u=0;u<A;u++){for(V=he.rows[u],G="",B=V.length,F=0;F<B;F++)G+=this.renderer.tablecell(this.parseInline(V[F].tokens),{header:!1,align:he.align[F]});re+=this.renderer.tablerow(G)}C+=this.renderer.table(ee,re);continue}case"blockquote":{re=this.parse(he.tokens),C+=this.renderer.blockquote(re);continue}case"list":{for(ye=he.ordered,we=he.start,Ie=he.loose,A=he.items.length,re="",u=0;u<A;u++)ce=he.items[u],Re=ce.checked,Ue=ce.task,Te="",ce.task&&(Ye=this.renderer.checkbox(Re),Ie?ce.tokens.length>0&&ce.tokens[0].type==="paragraph"?(ce.tokens[0].text=Ye+" "+ce.tokens[0].text,ce.tokens[0].tokens&&ce.tokens[0].tokens.length>0&&ce.tokens[0].tokens[0].type==="text"&&(ce.tokens[0].tokens[0].text=Ye+" "+ce.tokens[0].tokens[0].text)):ce.tokens.unshift({type:"text",text:Ye}):Te+=Ye),Te+=this.parse(ce.tokens,Ie),re+=this.renderer.listitem(Te,Ue,Re);C+=this.renderer.list(re,ye,we);continue}case"html":{C+=this.renderer.html(he.text);continue}case"paragraph":{C+=this.renderer.paragraph(this.parseInline(he.tokens));continue}case"text":{for(re=he.tokens?this.parseInline(he.tokens):he.text;R+1<ot&&a[R+1].type==="text";)he=a[++R],re+=`
`+(he.tokens?this.parseInline(he.tokens):he.text);C+=g?this.renderer.paragraph(re):re;continue}default:{var it='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(it);return}else throw new Error(it)}}}return C},W.parseInline=function(a,g){g=g||this.renderer;var C="",R,u,F,A=a.length;for(R=0;R<A;R++){if(u=a[R],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[u.type]&&(F=this.options.extensions.renderers[u.type].call({parser:this},u),F!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(u.type))){C+=F||"";continue}switch(u.type){case"escape":{C+=g.text(u.text);break}case"html":{C+=g.html(u.text);break}case"link":{C+=g.link(u.href,u.title,this.parseInline(u.tokens,g));break}case"image":{C+=g.image(u.href,u.title,u.text);break}case"strong":{C+=g.strong(this.parseInline(u.tokens,g));break}case"em":{C+=g.em(this.parseInline(u.tokens,g));break}case"codespan":{C+=g.codespan(u.text);break}case"br":{C+=g.br();break}case"del":{C+=g.del(this.parseInline(u.tokens,g));break}case"text":{C+=g.text(u.text);break}default:{var B='Token with "'+u.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return C},q}();function ae(q,W,l){if(typeof q>"u"||q===null)throw new Error("marked(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");if(typeof W=="function"&&(l=W,W=null),W=U({},ae.defaults,W||{}),N(W),l){var a=W.highlight,g;try{g=Fe.lex(q,W)}catch(A){return l(A)}var C=function(B){var V;if(!B)try{W.walkTokens&&ae.walkTokens(g,W.walkTokens),V=de.parse(g,W)}catch(G){B=G}return W.highlight=a,B?l(B):l(null,V)};if(!a||a.length<3||(delete W.highlight,!g.length))return C();var R=0;ae.walkTokens(g,function(A){A.type==="code"&&(R++,setTimeout(function(){a(A.text,A.lang,function(B,V){if(B)return C(B);V!=null&&V!==A.text&&(A.text=V,A.escaped=!0),R--,R===0&&C()})},0))}),R===0&&C();return}function u(A){if(A.message+=`
Please report this to https://github.com/markedjs/marked.`,W.silent)return"<p>An error occurred:</p><pre>"+e(A.message+"",!0)+"</pre>";throw A}try{var F=Fe.lex(q,W);if(W.walkTokens){if(W.async)return Promise.all(ae.walkTokens(F,W.walkTokens)).then(function(){return de.parse(F,W)}).catch(u);ae.walkTokens(F,W.walkTokens)}return de.parse(F,W)}catch(A){u(A)}}ae.options=ae.setOptions=function(q){return U(ae.defaults,q),w(ae.defaults),ae},ae.getDefaults=T,ae.defaults=oe.defaults,ae.use=function(){for(var q=arguments.length,W=new Array(q),l=0;l<q;l++)W[l]=arguments[l];var a=U.apply(void 0,[{}].concat(W)),g=ae.defaults.extensions||{renderers:{},childTokens:{}},C;W.forEach(function(R){if(R.extensions&&(C=!0,R.extensions.forEach(function(F){if(!F.name)throw new Error("extension name required");if(F.renderer){var A=g.renderers?g.renderers[F.name]:null;A?g.renderers[F.name]=function(){for(var B=arguments.length,V=new Array(B),G=0;G<B;G++)V[G]=arguments[G];var ee=F.renderer.apply(this,V);return ee===!1&&(ee=A.apply(this,V)),ee}:g.renderers[F.name]=F.renderer}if(F.tokenizer){if(!F.level||F.level!=="block"&&F.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");g[F.level]?g[F.level].unshift(F.tokenizer):g[F.level]=[F.tokenizer],F.start&&(F.level==="block"?g.startBlock?g.startBlock.push(F.start):g.startBlock=[F.start]:F.level==="inline"&&(g.startInline?g.startInline.push(F.start):g.startInline=[F.start]))}F.childTokens&&(g.childTokens[F.name]=F.childTokens)})),R.renderer&&function(){var F=ae.defaults.renderer||new Ae,A=function(G){var ee=F[G];F[G]=function(){for(var re=arguments.length,he=new Array(re),ye=0;ye<re;ye++)he[ye]=arguments[ye];var we=R.renderer[G].apply(F,he);return we===!1&&(we=ee.apply(F,he)),we}};for(var B in R.renderer)A(B);a.renderer=F}(),R.tokenizer&&function(){var F=ae.defaults.tokenizer||new Z,A=function(G){var ee=F[G];F[G]=function(){for(var re=arguments.length,he=new Array(re),ye=0;ye<re;ye++)he[ye]=arguments[ye];var we=R.tokenizer[G].apply(F,he);return we===!1&&(we=ee.apply(F,he)),we}};for(var B in R.tokenizer)A(B);a.tokenizer=F}(),R.walkTokens){var u=ae.defaults.walkTokens;a.walkTokens=function(F){var A=[];return A.push(R.walkTokens.call(this,F)),u&&(A=A.concat(u.call(this,F))),A}}C&&(a.extensions=g),ae.setOptions(a)})},ae.walkTokens=function(q,W){for(var l=[],a=function(){var u=C.value;switch(l=l.concat(W.call(ae,u)),u.type){case"table":{for(var F=O(u.header),A;!(A=F()).done;){var B=A.value;l=l.concat(ae.walkTokens(B.tokens,W))}for(var V=O(u.rows),G;!(G=V()).done;)for(var ee=G.value,re=O(ee),he;!(he=re()).done;){var ye=he.value;l=l.concat(ae.walkTokens(ye.tokens,W))}break}case"list":{l=l.concat(ae.walkTokens(u.items,W));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[u.type]?ae.defaults.extensions.childTokens[u.type].forEach(function(we){l=l.concat(ae.walkTokens(u[we],W))}):u.tokens&&(l=l.concat(ae.walkTokens(u.tokens,W)))}},g=O(q),C;!(C=g()).done;)a();return l},ae.parseInline=function(q,W){if(typeof q>"u"||q===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");W=U({},ae.defaults,W||{}),N(W);try{var l=Fe.lexInline(q,W);return W.walkTokens&&ae.walkTokens(l,W.walkTokens),de.parseInline(l,W)}catch(a){if(a.message+=`
Please report this to https://github.com/markedjs/marked.`,W.silent)return"<p>An error occurred:</p><pre>"+e(a.message+"",!0)+"</pre>";throw a}},ae.Parser=de,ae.parser=de.parse,ae.Renderer=Ae,ae.TextRenderer=ue,ae.Lexer=Fe,ae.lexer=Fe.lex,ae.Tokenizer=Z,ae.Slugger=J,ae.parse=ae;var Le=ae.options,Q=ae.setOptions,me=ae.use,_e=ae.walkTokens,Oe=ae.parseInline,Ce=ae,Be=de.parse,ie=Fe.lex;oe.Lexer=Fe,oe.Parser=de,oe.Renderer=Ae,oe.Slugger=J,oe.TextRenderer=ue,oe.Tokenizer=Z,oe.getDefaults=T,oe.lexer=ie,oe.marked=ae,oe.options=Le,oe.parse=Ce,oe.parseInline=Oe,oe.parser=Be,oe.setOptions=Q,oe.use=me,oe.walkTokens=_e,Object.defineProperty(oe,"__esModule",{value:!0})}),define(ve[60],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var i;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(t.MarshalledId=i={}))}),define(ve[93],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getKoreanAltChars=i;function i(s){const o=O(s);if(o&&o.length>0)return new Uint32Array(o)}let n=0;const P=new Uint32Array(10);function O(s){if(n=0,T(s,S,_.InitialConsonant),n>0||(T(s,b,_.Vowel),n>0)||(T(s,m,_.FinalConsonant),n>0)||(T(s,e,_.CompatibilityJamo),n))return P.subarray(0,n);if(s>=44032&&s<=55203){const o=s-44032,c=o%588,h=Math.floor(o/588),p=Math.floor(c/28),L=c%28-1;if(h<S.length?T(h,S,0):_.InitialConsonant+h-_.CompatibilityJamo<e.length&&T(_.InitialConsonant+h,e,_.CompatibilityJamo),p<b.length?T(p,b,0):_.Vowel+p-_.CompatibilityJamo<e.length&&T(_.Vowel+p-_.CompatibilityJamo,e,_.CompatibilityJamo),L>=0&&(L<m.length?T(L,m,0):_.FinalConsonant+L-_.CompatibilityJamo<e.length&&T(_.FinalConsonant+L-_.CompatibilityJamo,e,_.CompatibilityJamo)),n>0)return P.subarray(0,n)}}function T(s,o,c){s>=c&&s<c+o.length&&w(o[s-c])}function w(s){s!==d.NUL&&(P[n++]=s&255,s>>8&&(P[n++]=s>>8&255),s>>16&&(P[n++]=s>>16&255))}var _;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(_||(_={}));var d;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(d||(d={}));var D;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(D||(D={}));const S=new Uint8Array([d.r,d.R,d.s,d.e,d.E,d.f,d.a,d.q,d.Q,d.t,d.T,d.d,d.w,d.W,d.c,d.z,d.x,d.v,d.g]),b=new Uint16Array([d.k,d.o,d.i,d.O,d.j,d.p,d.u,d.P,d.h,D.hk,D.ho,D.hl,d.y,d.n,D.nj,D.np,D.nl,d.b,d.m,D.ml,d.l]),m=new Uint16Array([d.r,d.R,D.rt,d.s,D.sw,D.sg,d.e,d.f,D.fr,D.fa,D.fq,D.ft,D.fx,D.fv,D.fg,d.a,d.q,D.qt,d.t,d.T,d.d,d.w,d.c,d.z,d.x,d.v,d.g]),e=new Uint16Array([d.r,d.R,D.rt,d.s,D.sw,D.sg,d.e,d.E,d.f,D.fr,D.fa,D.fq,D.ft,D.fx,D.fv,D.fg,d.a,d.q,d.Q,D.qt,d.t,d.T,d.d,d.w,d.W,d.c,d.z,d.x,d.v,d.g,d.k,d.o,d.i,d.O,d.j,d.p,d.u,d.P,d.h,D.hk,D.ho,D.hl,d.y,d.n,D.nj,D.np,D.nl,d.b,d.m,D.ml,d.l])}),define(ve[94],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class i{constructor(P,O=0,T=P.length,w=O-1){this.items=P,this.start=O,this.end=T,this.index=w}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=i}),define(ve[95],De([1,0,94]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class n{constructor(T=[],w=10){this._initialize(T),this._limit=w,this._onChange()}getHistory(){return this._elements}add(T){this._history.delete(T),this._history.add(T),this._onChange()}next(){return this._navigator.next()}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}isFirst(){return this._currentPosition()===0}isLast(){return this._currentPosition()>=this._elements.length-1}isNowhere(){return this._navigator.current()===null}has(T){return this._history.has(T)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const T=this._elements;this._navigator=new i.ArrayNavigator(T,0,T.length,T.length)}_reduceToLimit(){const T=this._elements;T.length>this._limit&&this._initialize(T.slice(T.length-this._limit))}_currentPosition(){const T=this._navigator.current();return T?this._elements.indexOf(T):-1}_initialize(T){this._history=new Set;for(const w of T)this._history.add(w)}get _elements(){const T=[];return this._history.forEach(w=>T.push(w)),T}}t.HistoryNavigator=n;class P{get size(){return this._size}constructor(T,w=10){if(this.capacity=w,T.length<1)throw new Error("not supported");this._size=1,this.head=this.tail=this.cursor={value:T[0],previous:void 0,next:void 0},this.valueSet=new Set([T[0]]);for(let _=1;_<T.length;_++)this.add(T[_])}add(T){const w={value:T,previous:this.tail,next:void 0};for(this.tail.next=w,this.tail=w,this.cursor=this.tail,this._size++,this.valueSet.has(T)?this._deleteFromList(T):this.valueSet.add(T);this._size>this.capacity;)this.valueSet.delete(this.head.value),this.head=this.head.next,this.head.previous=void 0,this._size--}replaceLast(T){if(this.tail.value===T)return T;const w=this.tail.value;return this.valueSet.delete(w),this.tail.value=T,this.valueSet.has(T)?this._deleteFromList(T):this.valueSet.add(T),w}prepend(T){if(this._size===this.capacity||this.valueSet.has(T))return;const w={value:T,previous:void 0,next:this.head};this.head.previous=w,this.head=w,this._size++,this.valueSet.add(T)}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(T){return this.valueSet.has(T)}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let T=this.head;for(;T;)yield T.value,T=T.next}_deleteFromList(T){let w=this.head;for(;w!==this.tail;)w.value===T&&(w===this.head?(this.head=this.head.next,this.head.previous=void 0):(w.previous.next=w.next,w.next.previous=w.previous),this._size--),w=w.next}}t.HistoryNavigator2=P}),define(ve[44],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=void 0,t.clamp=i,t.rot=n;function i(w,_,d){return Math.min(Math.max(w,_),d)}function n(w,_){return(_+w%_)%_}class P{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=P;class O{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=O;class T{constructor(_){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(_),this._values.fill(0,0,_)}update(_){const d=this._values[this._index];return this._values[this._index]=_,this._index=(this._index+1)%this._values.length,this._sum-=d,this._sum+=_,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=T}),define(ve[29],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DebugNameData=void 0,t.getDebugName=O,t.getFunctionName=b;class i{constructor(e,s,o){this.owner=e,this.debugNameSource=s,this.referenceFn=o}getDebugName(e){return O(e,this)}}t.DebugNameData=i;const n=new Map,P=new WeakMap;function O(m,e){const s=P.get(m);if(s)return s;const o=T(m,e);if(o){let c=n.get(o)??0;c++,n.set(o,c);const h=c===1?o:`${o}#${c}`;return P.set(m,h),h}}function T(m,e){const s=P.get(m);if(s)return s;const o=e.owner?D(e.owner)+".":"";let c;const h=e.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(c=h(),c!==void 0)return o+c}else return o+h;const p=e.referenceFn;if(p!==void 0&&(c=b(p),c!==void 0))return o+c;if(e.owner!==void 0){const L=w(e.owner,m);if(L!==void 0)return o+L}}function w(m,e){for(const s in m)if(m[s]===e)return s}const _=new Map,d=new WeakMap;function D(m){const e=d.get(m);if(e)return e;const s=S(m);let o=_.get(s)??0;o++,_.set(s,o);const c=o===1?s:`${s}#${o}`;return d.set(m,c),c}function S(m){const e=m.constructor;return e?e.name:"Object"}function b(m){const e=m.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(o?o[1]:void 0)?.trim()}}),define(ve[30],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConsoleObservableLogger=void 0,t.setLogger=n,t.getLogger=P;let i;function n(s){i=s}function P(){return i}class O{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(o){return T([w(m("|  ",this.indentation)),o])}formatInfo(o){return o.hadValue?o.didChange?[w(" "),d(D(o.oldValue,70),{color:"red",strikeThrough:!0}),w(" "),d(D(o.newValue,60),{color:"green"})]:[w(" (unchanged)")]:[w(" "),d(D(o.newValue,60),{color:"green"}),w(" (initial)")]}handleObservableChanged(o,c){console.log(...this.textToConsoleArgs([_("observable value changed"),d(o.debugName,{color:"BlueViolet"}),...this.formatInfo(c)]))}formatChanges(o){if(o.size!==0)return d(" (changed deps: "+[...o].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const c=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(h,p)=>(this.changedObservablesSets.get(o).add(h),c.apply(o,[h,p]))}handleDerivedRecomputed(o,c){const h=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([_("derived recomputed"),d(o.debugName,{color:"BlueViolet"}),...this.formatInfo(c),this.formatChanges(h),{data:[{fn:o._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(o,c){console.log(...this.textToConsoleArgs([_("observable from event triggered"),d(o.debugName,{color:"BlueViolet"}),...this.formatInfo(c),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const c=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(h,p)=>(this.changedObservablesSets.get(o).add(h),c.apply(o,[h,p]))}handleAutorunTriggered(o){const c=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([_("autorun"),d(o.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:o._runFn}]}])),c.clear(),this.indentation++}handleAutorunFinished(o){this.indentation--}handleBeginTransaction(o){let c=o.getDebugName();c===void 0&&(c=""),console.log(...this.textToConsoleArgs([_("transaction"),d(c,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}t.ConsoleObservableLogger=O;function T(s){const o=new Array,c=[];let h="";function p(y){if("length"in y)for(const r of y)r&&p(r);else"text"in y?(h+=`%c${y.text}`,o.push(y.style),y.data&&c.push(...y.data)):"data"in y&&c.push(...y.data)}p(s);const L=[h,...o];return L.push(...c),L}function w(s){return d(s,{color:"black"})}function _(s){return d(e(`${s}: `,10),{color:"black",bold:!0})}function d(s,o={color:"black"}){function c(p){return Object.entries(p).reduce((L,[y,r])=>`${L}${y}:${r};`,"")}const h={color:o.color};return o.strikeThrough&&(h["text-decoration"]="line-through"),o.bold&&(h["font-weight"]="bold"),{text:s,style:c(h)}}function D(s,o){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=o?`"${s}"`:`"${s.substr(0,o-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?S(s,o):b(s,o);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function S(s,o){let c="[ ",h=!0;for(const p of s){if(h||(c+=", "),c.length-5>o){c+="...";break}h=!1,c+=`${D(p,o-c.length)}`}return c+=" ]",c}function b(s,o){let c="{ ",h=!0;for(const[p,L]of Object.entries(s)){if(h||(c+=", "),c.length-5>o){c+="...";break}h=!1,c+=`${p}: ${D(L,o-c.length)}`}return c+=" }",c}function m(s,o){let c="";for(let h=1;h<=o;h++)c+=s;return c}function e(s,o){for(;s.length<o;)s+=" ";return s}}),define(ve[45],De([1,0,41,2,29,30]),function(oe,t,i,n,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AutorunObserver=void 0,t.autorun=T,t.autorunOpts=w,t.autorunHandleChanges=_,t.autorunWithStoreHandleChanges=d,t.autorunWithStore=D,t.autorunDelta=S;function T(e){return new m(new P.DebugNameData(void 0,void 0,e),e,void 0,void 0)}function w(e,s){return new m(new P.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??s),s,void 0,void 0)}function _(e,s){return new m(new P.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??s),s,e.createEmptyChangeSummary,e.handleChange)}function d(e,s){const o=new n.DisposableStore,c=_({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(h,p)=>{o.clear(),s(h,p,o)});return(0,n.toDisposable)(()=>{c.dispose(),o.dispose()})}function D(e){const s=new n.DisposableStore,o=w({owner:void 0,debugName:void 0,debugReferenceFn:e},c=>{s.clear(),e(c,s)});return(0,n.toDisposable)(()=>{o.dispose(),s.dispose()})}function S(e,s){let o;return w({debugReferenceFn:s},c=>{const h=e.read(c),p=o;o=h,s({lastValue:p,newValue:h})})}var b;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(b||(b={}));class m{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(s,o,c,h){this._debugNameData=s,this._runFn=o,this.createChangeSummary=c,this._handleChange=h,this.state=b.stale,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,O.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,n.trackDisposable)(this)}dispose(){this.disposed=!0;for(const s of this.dependencies)s.removeObserver(this);this.dependencies.clear(),(0,n.markAsDisposed)(this)}_runIfNeeded(){if(this.state===b.upToDate)return;const s=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=s,this.state=b.upToDate;const o=this.disposed;try{if(!o){(0,O.getLogger)()?.handleAutorunTriggered(this);const c=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,c)}}finally{o||(0,O.getLogger)()?.handleAutorunFinished(this);for(const c of this.dependenciesToBeRemoved)c.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===b.upToDate&&(this.state=b.dependenciesMightHaveChanged),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===b.dependenciesMightHaveChanged){this.state=b.upToDate;for(const s of this.dependencies)if(s.reportChanges(),this.state===b.stale)break}this._runIfNeeded()}while(this.state!==b.upToDate);this.updateCount--,(0,i.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(s){this.state===b.upToDate&&this.dependencies.has(s)&&!this.dependenciesToBeRemoved.has(s)&&(this.state=b.dependenciesMightHaveChanged)}handleChange(s,o){this.dependencies.has(s)&&!this.dependenciesToBeRemoved.has(s)&&(!this._handleChange||this._handleChange({changedObservable:s,change:o,didChange:h=>h===s},this.changeSummary))&&(this.state=b.stale)}readObservable(s){if(this.disposed)return s.get();s.addObserver(this);const o=s.get();return this.dependencies.add(s),this.dependenciesToBeRemoved.delete(s),o}}t.AutorunObserver=m,function(e){e.Observer=m}(T||(t.autorun=T={}))}),define(ve[36],De([1,0,42,29,30]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableObservableValue=t.ObservableValue=t.TransactionImpl=t.BaseObservable=t.ConvenientObservable=void 0,t._setRecomputeInitiallyAndOnChange=T,t._setKeepObserved=_,t._setDerivedOpts=D,t.transaction=m,t.globalTransaction=s,t.asyncTransaction=o,t.subtransaction=c,t.observableValue=p,t.observableValueOpts=L,t.disposableObservableValue=r;let O;function T(E){O=E}let w;function _(E){w=E}let d;function D(E){d=E}class S{get TChange(){return null}reportChanges(){this.get()}read(I){return I?I.readObservable(this):this.get()}map(I,H){const z=H===void 0?void 0:I,U=H===void 0?I:H;return d({owner:z,debugName:()=>{const v=(0,n.getFunctionName)(U);if(v!==void 0)return v;const x=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(U.toString());if(x)return`${this.debugName}.${x[2]}`;if(!z)return`${this.debugName} (mapped)`},debugReferenceFn:U},v=>U(this.read(v),v))}recomputeInitiallyAndOnChange(I,H){return I.add(O(this,H)),this}keepObserved(I){return I.add(w(this)),this}get debugValue(){return this.get()}}t.ConvenientObservable=S;class b extends S{constructor(){super(...arguments),this.observers=new Set}addObserver(I){const H=this.observers.size;this.observers.add(I),H===0&&this.onFirstObserverAdded()}removeObserver(I){this.observers.delete(I)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}t.BaseObservable=b;function m(E,I){const H=new h(E,I);try{E(H)}finally{H.finish()}}let e;function s(E){if(e)E(e);else{const I=new h(E,void 0);e=I;try{E(I)}finally{I.finish(),e=void 0}}}async function o(E,I){const H=new h(E,I);try{await E(H)}finally{H.finish()}}function c(E,I,H){E?I(E):m(I,H)}class h{constructor(I,H){this._fn=I,this._getDebugName=H,this.updatingObservers=[],(0,P.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,n.getFunctionName)(this._fn)}updateObserver(I,H){this.updatingObservers.push({observer:I,observable:H}),I.beginUpdate(H)}finish(){const I=this.updatingObservers;for(let H=0;H<I.length;H++){const{observer:z,observable:U}=I[H];z.endUpdate(U)}this.updatingObservers=null,(0,P.getLogger)()?.handleEndTransaction()}}t.TransactionImpl=h;function p(E,I){let H;return typeof E=="string"?H=new n.DebugNameData(void 0,E,void 0):H=new n.DebugNameData(E,void 0,void 0),new y(H,I,i.strictEquals)}function L(E,I){return new y(new n.DebugNameData(E.owner,E.debugName,void 0),I,E.equalsFn??i.strictEquals)}class y extends b{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(I,H,z){super(),this._debugNameData=I,this._equalityComparator=z,this._value=H}get(){return this._value}set(I,H,z){if(z===void 0&&this._equalityComparator(this._value,I))return;let U;H||(H=U=new h(()=>{},()=>`Setting ${this.debugName}`));try{const v=this._value;this._setValue(I),(0,P.getLogger)()?.handleObservableChanged(this,{oldValue:v,newValue:I,change:z,didChange:!0,hadValue:!0});for(const k of this.observers)H.updateObserver(k,this),k.handleChange(this,z)}finally{U&&U.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(I){this._value=I}}t.ObservableValue=y;function r(E,I){let H;return typeof E=="string"?H=new n.DebugNameData(void 0,E,void 0):H=new n.DebugNameData(E,void 0,void 0),new f(H,I,i.strictEquals)}class f extends y{_setValue(I){this._value!==I&&(this._value&&this._value.dispose(),this._value=I)}dispose(){this._value?.dispose()}}t.DisposableObservableValue=f}),define(ve[46],De([1,0,41,42,2,36,29,30]),function(oe,t,i,n,P,O,T,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DerivedWithSetter=t.Derived=void 0,t.derived=_,t.derivedWithSetter=d,t.derivedOpts=D,t.derivedHandleChanges=S,t.derivedWithStore=b,t.derivedDisposable=m;function _(c,h){return h!==void 0?new s(new T.DebugNameData(c,void 0,h),h,void 0,void 0,void 0,n.strictEquals):new s(new T.DebugNameData(void 0,void 0,c),c,void 0,void 0,void 0,n.strictEquals)}function d(c,h,p){return new o(new T.DebugNameData(c,void 0,h),h,void 0,void 0,void 0,n.strictEquals,p)}function D(c,h){return new s(new T.DebugNameData(c.owner,c.debugName,c.debugReferenceFn),h,void 0,void 0,c.onLastObserverRemoved,c.equalsFn??n.strictEquals)}(0,O._setDerivedOpts)(D);function S(c,h){return new s(new T.DebugNameData(c.owner,c.debugName,void 0),h,c.createEmptyChangeSummary,c.handleChange,void 0,c.equalityComparer??n.strictEquals)}function b(c,h){let p,L;h===void 0?(p=c,L=void 0):(L=c,p=h);const y=new P.DisposableStore;return new s(new T.DebugNameData(L,void 0,p),r=>(y.clear(),p(r,y)),void 0,void 0,()=>y.dispose(),n.strictEquals)}function m(c,h){let p,L;h===void 0?(p=c,L=void 0):(L=c,p=h);const y=new P.DisposableStore;return new s(new T.DebugNameData(L,void 0,p),r=>{y.clear();const f=p(r);return f&&y.add(f),f},void 0,void 0,()=>y.dispose(),n.strictEquals)}var e;(function(c){c[c.initial=0]="initial",c[c.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",c[c.stale=2]="stale",c[c.upToDate=3]="upToDate"})(e||(e={}));class s extends O.BaseObservable{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(h,p,L,y,r=void 0,f){super(),this._debugNameData=h,this._computeFn=p,this.createChangeSummary=L,this._handleChange=y,this._handleLastObserverRemoved=r,this._equalityComparator=f,this.state=e.initial,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,w.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=e.initial,this.value=void 0;for(const h of this.dependencies)h.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const h=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),h}else{do{if(this.state===e.dependenciesMightHaveChanged){for(const h of this.dependencies)if(h.reportChanges(),this.state===e.stale)break}this.state===e.dependenciesMightHaveChanged&&(this.state=e.upToDate),this._recomputeIfNeeded()}while(this.state!==e.upToDate);return this.value}}_recomputeIfNeeded(){if(this.state===e.upToDate)return;const h=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=h;const p=this.state!==e.initial,L=this.value;this.state=e.upToDate;const y=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,y)}finally{for(const f of this.dependenciesToBeRemoved)f.removeObserver(this);this.dependenciesToBeRemoved.clear()}const r=p&&!this._equalityComparator(L,this.value);if((0,w.getLogger)()?.handleDerivedRecomputed(this,{oldValue:L,newValue:this.value,change:void 0,didChange:r,hadValue:p}),r)for(const f of this.observers)f.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(h){this.updateCount++;const p=this.updateCount===1;if(this.state===e.upToDate&&(this.state=e.dependenciesMightHaveChanged,!p))for(const L of this.observers)L.handlePossibleChange(this);if(p)for(const L of this.observers)L.beginUpdate(this)}endUpdate(h){if(this.updateCount--,this.updateCount===0){const p=[...this.observers];for(const L of p)L.endUpdate(this)}(0,i.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(h){if(this.state===e.upToDate&&this.dependencies.has(h)&&!this.dependenciesToBeRemoved.has(h)){this.state=e.dependenciesMightHaveChanged;for(const p of this.observers)p.handlePossibleChange(this)}}handleChange(h,p){if(this.dependencies.has(h)&&!this.dependenciesToBeRemoved.has(h)){const L=this._handleChange?this._handleChange({changedObservable:h,change:p,didChange:r=>r===h},this.changeSummary):!0,y=this.state===e.upToDate;if(L&&(this.state===e.dependenciesMightHaveChanged||y)&&(this.state=e.stale,y))for(const r of this.observers)r.handlePossibleChange(this)}}readObservable(h){h.addObserver(this);const p=h.get();return this.dependencies.add(h),this.dependenciesToBeRemoved.delete(h),p}addObserver(h){const p=!this.observers.has(h)&&this.updateCount>0;super.addObserver(h),p&&h.beginUpdate(this)}removeObserver(h){const p=this.observers.has(h)&&this.updateCount>0;super.removeObserver(h),p&&h.endUpdate(this)}}t.Derived=s;class o extends s{constructor(h,p,L,y,r=void 0,f,E){super(h,p,L,y,r,f),this.set=E}}t.DerivedWithSetter=o}),define(ve[47],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(n){function P(_,d){if(_.start>=d.end||d.start>=_.end)return{start:0,end:0};const D=Math.max(_.start,d.start),S=Math.min(_.end,d.end);return S-D<=0?{start:0,end:0}:{start:D,end:S}}n.intersect=P;function O(_){return _.end-_.start<=0}n.isEmpty=O;function T(_,d){return!O(P(_,d))}n.intersects=T;function w(_,d){const D=[],S={start:_.start,end:Math.min(d.start,_.end)},b={start:Math.max(d.end,_.start),end:_.end};return O(S)||D.push(S),O(b)||D.push(b),D}n.relativeComplement=w})(i||(t.Range=i={}))}),define(ve[96],De([1,0,47]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=void 0,t.groupIntersect=n,t.shift=P,t.consolidate=O;function n(_,d){const D=[];for(const S of d){if(_.start>=S.range.end)continue;if(_.end<S.range.start)break;const b=i.Range.intersect(_,S.range);i.Range.isEmpty(b)||D.push({range:b,size:S.size})}return D}function P({start:_,end:d},D){return{start:_+D,end:d+D}}function O(_){const d=[];let D=null;for(const S of _){const b=S.range.start,m=S.range.end,e=S.size;if(D&&e===D.size){D.range.end=m;continue}D={range:{start:b,end:m},size:e},d.push(D)}return d}function T(..._){return O(_.reduce((d,D)=>d.concat(D),[]))}class w{get paddingTop(){return this._paddingTop}set paddingTop(d){this._size=this._size+d-this._paddingTop,this._paddingTop=d}constructor(d){this.groups=[],this._size=0,this._paddingTop=0,this._paddingTop=d??0,this._size=this._paddingTop}splice(d,D,S=[]){const b=S.length-D,m=n({start:0,end:d},this.groups),e=n({start:d+D,end:Number.POSITIVE_INFINITY},this.groups).map(o=>({range:P(o.range,b),size:o.size})),s=S.map((o,c)=>({range:{start:d+c,end:d+c+1},size:o.size}));this.groups=T(m,s,e),this._size=this._paddingTop+this.groups.reduce((o,c)=>o+c.size*(c.range.end-c.range.start),0)}get count(){const d=this.groups.length;return d?this.groups[d-1].range.end:0}get size(){return this._size}indexAt(d){if(d<0)return-1;if(d<this._paddingTop)return 0;let D=0,S=this._paddingTop;for(const b of this.groups){const m=b.range.end-b.range.start,e=S+m*b.size;if(d<e)return D+Math.floor((d-S)/b.size);D+=m,S=e}return D}indexAfter(d){return Math.min(this.indexAt(d)+1,this.count)}positionAt(d){if(d<0)return-1;let D=0,S=0;for(const b of this.groups){const m=b.range.end-b.range.start,e=S+m;if(d<e)return this._paddingTop+D+(d-S)*b.size;D+=m*b.size,S=e}return-1}}t.RangeMap=w}),define(ve[97],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(O){return new n(O)}constructor(O){this._now=i&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=n}),define(ve[3],De([1,0,6,58,2,59,97]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEvent=t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.ListenerRefusalError=t.ListenerLeakError=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=m;const w=!1,_=!1,d=!1;var D;(function(Z){Z.None=()=>P.Disposable.None;function Y(A){if(d){const{onDidAddListener:B}=A,V=s.create();let G=0;A.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),B?.()}}}function te(A,B){return Q(A,()=>{},0,void 0,!0,void 0,B)}Z.defer=te;function fe(A){return(B,V=null,G)=>{let ee=!1,re;return re=A(he=>{if(!ee)return re?re.dispose():ee=!0,B.call(V,he)},null,G),ee&&re.dispose(),re}}Z.once=fe;function Ee(A,B,V){return ae((G,ee=null,re)=>A(he=>G.call(ee,B(he)),null,re),V)}Z.map=Ee;function Fe(A,B,V){return ae((G,ee=null,re)=>A(he=>{B(he),G.call(ee,he)},null,re),V)}Z.forEach=Fe;function Ae(A,B,V){return ae((G,ee=null,re)=>A(he=>B(he)&&G.call(ee,he),null,re),V)}Z.filter=Ae;function ue(A){return A}Z.signal=ue;function J(...A){return(B,V=null,G)=>{const ee=(0,P.combinedDisposable)(...A.map(re=>re(he=>B.call(V,he))));return Le(ee,G)}}Z.any=J;function de(A,B,V,G){let ee=V;return Ee(A,re=>(ee=B(ee,re),ee),G)}Z.reduce=de;function ae(A,B){let V;const G={onWillAddFirstListener(){V=A(ee.fire,ee)},onDidRemoveLastListener(){V?.dispose()}};B||Y(G);const ee=new f(G);return B?.add(ee),ee.event}function Le(A,B){return B instanceof Array?B.push(A):B&&B.add(A),A}function Q(A,B,V=100,G=!1,ee=!1,re,he){let ye,we,Ie,Te=0,ce;const Re={leakWarningThreshold:re,onWillAddFirstListener(){ye=A(Ye=>{Te++,we=B(we,Ye),G&&!Ie&&(Ue.fire(we),we=void 0),ce=()=>{const et=we;we=void 0,Ie=void 0,(!G||Te>1)&&Ue.fire(et),Te=0},typeof V=="number"?(clearTimeout(Ie),Ie=setTimeout(ce,V)):Ie===void 0&&(Ie=0,queueMicrotask(ce))})},onWillRemoveListener(){ee&&Te>0&&ce?.()},onDidRemoveLastListener(){ce=void 0,ye.dispose()}};he||Y(Re);const Ue=new f(Re);return he?.add(Ue),Ue.event}Z.debounce=Q;function me(A,B=0,V){return Z.debounce(A,(G,ee)=>G?(G.push(ee),G):[ee],B,void 0,!0,void 0,V)}Z.accumulate=me;function _e(A,B=(G,ee)=>G===ee,V){let G=!0,ee;return Ae(A,re=>{const he=G||!B(re,ee);return G=!1,ee=re,he},V)}Z.latch=_e;function Oe(A,B,V){return[Z.filter(A,B,V),Z.filter(A,G=>!B(G),V)]}Z.split=Oe;function Ce(A,B=!1,V=[],G){let ee=V.slice(),re=A(we=>{ee?ee.push(we):ye.fire(we)});G&&G.add(re);const he=()=>{ee?.forEach(we=>ye.fire(we)),ee=null},ye=new f({onWillAddFirstListener(){re||(re=A(we=>ye.fire(we)),G&&G.add(re))},onDidAddFirstListener(){ee&&(B?setTimeout(he):he())},onDidRemoveLastListener(){re&&re.dispose(),re=null}});return G&&G.add(ye),ye.event}Z.buffer=Ce;function Be(A,B){return(G,ee,re)=>{const he=B(new q);return A(function(ye){const we=he.evaluate(ye);we!==ie&&G.call(ee,we)},void 0,re)}}Z.chain=Be;const ie=Symbol("HaltChainable");class q{constructor(){this.steps=[]}map(B){return this.steps.push(B),this}forEach(B){return this.steps.push(V=>(B(V),V)),this}filter(B){return this.steps.push(V=>B(V)?V:ie),this}reduce(B,V){let G=V;return this.steps.push(ee=>(G=B(G,ee),G)),this}latch(B=(V,G)=>V===G){let V=!0,G;return this.steps.push(ee=>{const re=V||!B(ee,G);return V=!1,G=ee,re?ee:ie}),this}evaluate(B){for(const V of this.steps)if(B=V(B),B===ie)break;return B}}function W(A,B,V=G=>G){const G=(...ye)=>he.fire(V(...ye)),ee=()=>A.on(B,G),re=()=>A.removeListener(B,G),he=new f({onWillAddFirstListener:ee,onDidRemoveLastListener:re});return he.event}Z.fromNodeEventEmitter=W;function l(A,B,V=G=>G){const G=(...ye)=>he.fire(V(...ye)),ee=()=>A.addEventListener(B,G),re=()=>A.removeEventListener(B,G),he=new f({onWillAddFirstListener:ee,onDidRemoveLastListener:re});return he.event}Z.fromDOMEventEmitter=l;function a(A){return new Promise(B=>fe(A)(B))}Z.toPromise=a;function g(A){const B=new f;return A.then(V=>{B.fire(V)},()=>{B.fire(void 0)}).finally(()=>{B.dispose()}),B.event}Z.fromPromise=g;function C(A,B,V){return B(V),A(G=>B(G))}Z.runAndSubscribe=C;class R{constructor(B,V){this._observable=B,this._counter=0,this._hasChanged=!1;const G={onWillAddFirstListener:()=>{B.addObserver(this)},onDidRemoveLastListener:()=>{B.removeObserver(this)}};V||Y(G),this.emitter=new f(G),V&&V.add(this.emitter)}beginUpdate(B){this._counter++}handlePossibleChange(B){}handleChange(B,V){this._hasChanged=!0}endUpdate(B){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function u(A,B){return new R(A,B).emitter.event}Z.fromObservable=u;function F(A){return(B,V,G)=>{let ee=0,re=!1;const he={beginUpdate(){ee++},endUpdate(){ee--,ee===0&&(A.reportChanges(),re&&(re=!1,B.call(V)))},handlePossibleChange(){},handleChange(){re=!0}};A.addObserver(he),A.reportChanges();const ye={dispose(){A.removeObserver(he)}};return G instanceof P.DisposableStore?G.add(ye):Array.isArray(G)&&G.push(ye),ye}}Z.fromObservableLight=F})(D||(t.Event=D={}));class S{static{this.all=new Set}static{this._idPool=0}constructor(Y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${Y}_${S._idPool++}`,S.all.add(this)}start(Y){this._stopWatch=new T.StopWatch,this.listenerCount=Y}stop(){if(this._stopWatch){const Y=this._stopWatch.elapsed();this.durations.push(Y),this.elapsedOverall+=Y,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=S;let b=-1;function m(Z){const Y=b;return b=Z,{dispose(){b=Y}}}class e{constructor(Y,te,fe=Math.random().toString(18).slice(2,5)){this._errorHandler=Y,this.threshold=te,this.name=fe,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(Y,te){const fe=this.threshold;if(fe<=0||te<fe)return;this._stacks||(this._stacks=new Map);const Ee=this._stacks.get(Y.value)||0;if(this._stacks.set(Y.value,Ee+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=fe*.5;const[Fe,Ae]=this.getMostFrequentStack(),ue=`[${this.name}] potential listener LEAK detected, having ${te} listeners already. MOST frequent listener (${Ae}):`;console.warn(ue),console.warn(Fe);const J=new o(ue,Fe);this._errorHandler(J)}return()=>{const Fe=this._stacks.get(Y.value)||0;this._stacks.set(Y.value,Fe-1)}}getMostFrequentStack(){if(!this._stacks)return;let Y,te=0;for(const[fe,Ee]of this._stacks)(!Y||te<Ee)&&(Y=[fe,Ee],te=Ee);return Y}}class s{static create(){const Y=new Error;return new s(Y.stack??"")}constructor(Y){this.value=Y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class o extends Error{constructor(Y,te){super(Y),this.name="ListenerLeakError",this.stack=te}}t.ListenerLeakError=o;class c extends Error{constructor(Y,te){super(Y),this.name="ListenerRefusalError",this.stack=te}}t.ListenerRefusalError=c;let h=0;class p{constructor(Y){this.value=Y,this.id=h++}}const L=2,y=(Z,Y)=>{if(Z instanceof p)Y(Z);else for(let te=0;te<Z.length;te++){const fe=Z[te];fe&&Y(fe)}},r=w?new FinalizationRegistry(Z=>{typeof Z=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(Z))}):void 0;class f{constructor(Y){this._size=0,this._options=Y,this._leakageMon=b>0||this._options?.leakWarningThreshold?new e(Y?.onListenerError??i.onUnexpectedError,this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(_){const Y=this._listeners;queueMicrotask(()=>{y(Y,te=>te.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(Y,te,fe)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const J=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(J);const de=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ae=new c(`${J}. HINT: Stack shows most frequent listener (${de[1]}-times)`,de[0]);return(this._options?.onListenerError||i.onUnexpectedError)(ae),P.Disposable.None}if(this._disposed)return P.Disposable.None;te&&(Y=Y.bind(te));const Ee=new p(Y);let Fe,Ae;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(Ee.stack=s.create(),Fe=this._leakageMon.check(Ee.stack,this._size+1)),_&&(Ee.stack=Ae??s.create()),this._listeners?this._listeners instanceof p?(this._deliveryQueue??=new I,this._listeners=[this._listeners,Ee]):this._listeners.push(Ee):(this._options?.onWillAddFirstListener?.(this),this._listeners=Ee,this._options?.onDidAddFirstListener?.(this)),this._size++;const ue=(0,P.toDisposable)(()=>{r?.unregister(ue),Fe?.(),this._removeListener(Ee)});if(fe instanceof P.DisposableStore?fe.add(ue):Array.isArray(fe)&&fe.push(ue),r){const J=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(ue,J,ue)}return ue},this._event}_removeListener(Y){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const te=this._listeners,fe=te.indexOf(Y);if(fe===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,te[fe]=void 0;const Ee=this._deliveryQueue.current===this;if(this._size*L<=te.length){let Fe=0;for(let Ae=0;Ae<te.length;Ae++)te[Ae]?te[Fe++]=te[Ae]:Ee&&(this._deliveryQueue.end--,Fe<this._deliveryQueue.i&&this._deliveryQueue.i--);te.length=Fe}}_deliver(Y,te){if(!Y)return;const fe=this._options?.onListenerError||i.onUnexpectedError;if(!fe){Y.value(te);return}try{Y.value(te)}catch(Ee){fe(Ee)}}_deliverQueue(Y){const te=Y.current._listeners;for(;Y.i<Y.end;)this._deliver(te[Y.i++],Y.value);Y.reset()}fire(Y){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof p)this._deliver(this._listeners,Y);else{const te=this._deliveryQueue;te.enqueue(this,Y,this._listeners.length),this._deliverQueue(te)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=f;const E=()=>new I;t.createEventDeliveryQueue=E;class I{constructor(){this.i=-1,this.end=0}enqueue(Y,te,fe){this.i=0,this.end=fe,this.current=Y,this.value=te}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class H extends f{async fireAsync(Y,te,fe){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList),y(this._listeners,Ee=>this._asyncDeliveryQueue.push([Ee.value,Y]));this._asyncDeliveryQueue.size>0&&!te.isCancellationRequested;){const[Ee,Fe]=this._asyncDeliveryQueue.shift(),Ae=[],ue={...Fe,token:te,waitUntil:J=>{if(Object.isFrozen(Ae))throw new Error("waitUntil can NOT be called asynchronous");fe&&(J=fe(J,Ee)),Ae.push(J)}};try{Ee(ue)}catch(J){(0,i.onUnexpectedError)(J);continue}Object.freeze(Ae),await Promise.allSettled(Ae).then(J=>{for(const de of J)de.status==="rejected"&&(0,i.onUnexpectedError)(de.reason)})}}}t.AsyncEmitter=H;class z extends f{get isPaused(){return this._isPaused!==0}constructor(Y){super(Y),this._isPaused=0,this._eventQueue=new O.LinkedList,this._mergeFn=Y?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const Y=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(Y))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(Y){this._size&&(this._isPaused!==0?this._eventQueue.push(Y):super.fire(Y))}}t.PauseableEmitter=z;class U extends z{constructor(Y){super(Y),this._delay=Y.delay??100}fire(Y){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(Y)}}t.DebounceEmitter=U;class v extends f{constructor(Y){super(Y),this._queuedEvents=[],this._mergeFn=Y?.merge}fire(Y){this.hasListeners()&&(this._queuedEvents.push(Y),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(te=>super.fire(te)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=v;class k{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(Y){const te={event:Y,listener:null};this.events.push(te),this.hasListeners&&this.hook(te);const fe=()=>{this.hasListeners&&this.unhook(te);const Ee=this.events.indexOf(te);this.events.splice(Ee,1)};return(0,P.toDisposable)((0,n.createSingleCallFunction)(fe))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(Y=>this.hook(Y))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(Y=>this.unhook(Y))}hook(Y){Y.listener=Y.event(te=>this.emitter.fire(te))}unhook(Y){Y.listener?.dispose(),Y.listener=null}dispose(){this.emitter.dispose();for(const Y of this.events)Y.listener?.dispose();this.events=[]}}t.EventMultiplexer=k;class x{constructor(Y,te,fe,Ee){this._store=new P.DisposableStore;const Fe=this._store.add(new k),Ae=this._store.add(new P.DisposableMap);function ue(J){Ae.set(J,Fe.add(Ee(J)))}for(const J of Y)ue(J);this._store.add(te(J=>{ue(J)})),this._store.add(fe(J=>{Ae.deleteAndDispose(J)})),this.event=Fe.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=x;class N{constructor(){this.data=[]}wrapEvent(Y,te,fe){return(Ee,Fe,Ae)=>Y(ue=>{const J=this.data[this.data.length-1];if(!te){J?J.buffers.push(()=>Ee.call(Fe,ue)):Ee.call(Fe,ue);return}const de=J;if(!de){Ee.call(Fe,te(fe,ue));return}de.items??=[],de.items.push(ue),de.buffers.length===0&&J.buffers.push(()=>{de.reducedResult??=fe?de.items.reduce(te,fe):de.items.reduce(te),Ee.call(Fe,de.reducedResult)})},void 0,Ae)}bufferEvents(Y){const te={buffers:new Array};this.data.push(te);const fe=Y();return this.data.pop(),te.buffers.forEach(Ee=>Ee()),fe}}t.EventBufferer=N;class M{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=P.Disposable.None,this.emitter=new f({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(Y){this.inputEvent=Y,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=Y(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=M;class ${static const(Y){return new ne(Y)}constructor(Y){this._value=Y,this._onDidChange=new f,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(Y){Y!==this._value&&(this._value=Y,this._onDidChange.fire(void 0))}}t.ValueWithChangeEvent=$;class ne{constructor(Y){this.value=Y,this.onDidChange=D.None}}}),define(ve[19],De([1,0,25,3]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.onDidChangeZoomLevel=void 0,t.addMatchMediaChangeListener=O,t.setZoomLevel=T,t.getZoomLevel=w,t.getZoomFactor=_,t.setZoomFactor=d,t.setFullscreen=D,t.isFullscreen=S,t.isStandalone=e,t.isWCOEnabled=s;class P{constructor(){this.mapWindowIdToZoomLevel=new Map,this._onDidChangeZoomLevel=new n.Emitter,this.onDidChangeZoomLevel=this._onDidChangeZoomLevel.event,this.mapWindowIdToZoomFactor=new Map,this._onDidChangeFullscreen=new n.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event,this.mapWindowIdToFullScreen=new Map}static{this.INSTANCE=new P}getZoomLevel(c){return this.mapWindowIdToZoomLevel.get(this.getWindowId(c))??0}setZoomLevel(c,h){if(this.getZoomLevel(h)===c)return;const p=this.getWindowId(h);this.mapWindowIdToZoomLevel.set(p,c),this._onDidChangeZoomLevel.fire(p)}getZoomFactor(c){return this.mapWindowIdToZoomFactor.get(this.getWindowId(c))??1}setZoomFactor(c,h){this.mapWindowIdToZoomFactor.set(this.getWindowId(h),c)}setFullscreen(c,h){if(this.isFullscreen(h)===c)return;const p=this.getWindowId(h);this.mapWindowIdToFullScreen.set(p,c),this._onDidChangeFullscreen.fire(p)}isFullscreen(c){return!!this.mapWindowIdToFullScreen.get(this.getWindowId(c))}getWindowId(c){return c.vscodeWindowId}}function O(o,c,h){typeof c=="string"&&(c=o.matchMedia(c)),c.addEventListener("change",h)}function T(o,c){P.INSTANCE.setZoomLevel(o,c)}function w(o){return P.INSTANCE.getZoomLevel(o)}t.onDidChangeZoomLevel=P.INSTANCE.onDidChangeZoomLevel;function _(o){return P.INSTANCE.getZoomFactor(o)}function d(o,c){P.INSTANCE.setZoomFactor(o,c)}function D(o,c){P.INSTANCE.setFullscreen(o,c)}function S(o){return P.INSTANCE.isFullscreen(o)}t.onDidChangeFullscreen=P.INSTANCE.onDidChangeFullscreen;const b=navigator.userAgent;t.isFirefox=b.indexOf("Firefox")>=0,t.isWebKit=b.indexOf("AppleWebKit")>=0,t.isChrome=b.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&b.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=b.indexOf("Electron/")>=0,t.isAndroid=b.indexOf("Android")>=0;let m=!1;if(typeof i.mainWindow.matchMedia=="function"){const o=i.mainWindow.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),c=i.mainWindow.matchMedia("(display-mode: fullscreen)");m=o.matches,O(i.mainWindow,o,({matches:h})=>{m&&c.matches||(m=h)})}function e(){return m}function s(){return navigator?.windowControlsOverlay?.visible}}),define(ve[27],De([1,0,3]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class n{get event(){return this.emitter.event}constructor(O,T,w){const _=d=>this.emitter.fire(d);this.emitter=new i.Emitter({onWillAddFirstListener:()=>O.addEventListener(T,_,w),onDidRemoveLastListener:()=>O.removeEventListener(T,_,w)})}dispose(){this.emitter.dispose()}}t.DomEmitter=n}),define(ve[37],De([1,0,3]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0,t.cancelOnDispose=w;const n=Object.freeze(function(_,d){const D=setTimeout(_.bind(d),0);return{dispose(){clearTimeout(D)}}});var P;(function(_){function d(D){return D===_.None||D===_.Cancelled||D instanceof O?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}_.isCancellationToken=d,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(P||(t.CancellationToken=P={}));class O{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new O),this._token}cancel(){this._token?this._token instanceof O&&this._token.cancel():this._token=P.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof O&&this._token.dispose():this._token=P.None}}t.CancellationTokenSource=T;function w(_){const d=new T;return _.add({dispose(){d.cancel()}}),d.token}}),define(ve[98],De([1,0,37]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0,t.identity=P;class n{constructor(_){this.task=_,this.result=null}get(){if(this.result)return this.result;const _=new i.CancellationTokenSource,d=this.task(_.token);return this.result={promise:d,dispose:()=>{this.result=null,_.cancel(),_.dispose()}},this.result}}t.Cache=n;function P(w){return w}class O{constructor(_,d){this.lastCache=void 0,this.lastArgKey=void 0,typeof _=="function"?(this._fn=_,this._computeKey=P):(this._fn=d,this._computeKey=_.getCacheKey)}get(_){const d=this._computeKey(_);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this._fn(_)),this.lastCache}}t.LRUCachedFunction=O;class T{get cachedValues(){return this._map}constructor(_,d){this._map=new Map,this._map2=new Map,typeof _=="function"?(this._fn=_,this._computeKey=P):(this._fn=d,this._computeKey=_.getCacheKey)}get(_){const d=this._computeKey(_);if(this._map2.has(d))return this._map2.get(d);const D=this._fn(_);return this._map.set(_,D),this._map2.set(d,D),D}}t.CachedFunction=T}),define(ve[99],De([1,0,45,36,46,37,29,42,6]),function(oe,t,i,n,P,O,T,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObservableLazyPromise=t.PromiseResult=t.ObservablePromise=t.ObservableLazy=void 0,t.waitForState=m,t.derivedWithCancellationToken=e;class d{get cachedValue(){return this._value}constructor(o){this._computeValue=o,this._value=(0,n.observableValue)(this,void 0)}getValue(){let o=this._value.get();return o||(o=this._computeValue(),this._value.set(o,void 0)),o}}t.ObservableLazy=d;class D{constructor(o){this._value=(0,n.observableValue)(this,void 0),this.promiseResult=this._value,this.promise=o.then(c=>((0,n.transaction)(h=>{this._value.set(new S(c,void 0),h)}),c),c=>{throw(0,n.transaction)(h=>{this._value.set(new S(void 0,c),h)}),c})}}t.ObservablePromise=D;class S{constructor(o,c){this.data=o,this.error=c}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.PromiseResult=S;class b{constructor(o){this._computePromise=o,this._lazyValue=new d(()=>new D(this._computePromise())),this.cachedPromiseResult=(0,P.derived)(this,c=>this._lazyValue.cachedValue.read(c)?.promiseResult.read(c))}getPromise(){return this._lazyValue.getValue().promise}}t.ObservableLazyPromise=b;function m(s,o,c,h){return o||(o=p=>p!=null),new Promise((p,L)=>{let y=!0,r=!1;const f=s.map(I=>({isFinished:o(I),error:c?c(I):!1,state:I})),E=(0,i.autorun)(I=>{const{isFinished:H,error:z,state:U}=f.read(I);(H||z)&&(y?r=!0:E.dispose(),z?L(z===!0?U:z):p(U))});if(h){const I=h.onCancellationRequested(()=>{E.dispose(),I.dispose(),L(new _.CancellationError)});if(h.isCancellationRequested){E.dispose(),I.dispose(),L(new _.CancellationError);return}}y=!1,r&&E.dispose()})}function e(s,o){let c,h;o===void 0?(c=s,h=void 0):(h=s,c=o);let p;return new P.Derived(new T.DebugNameData(h,void 0,c),L=>(p&&p.dispose(!0),p=new O.CancellationTokenSource,c(L,p.token)),void 0,void 0,()=>p?.dispose(),w.strictEquals)}}),define(ve[100],De([1,0,3,2,45,36,29,46,30]),function(oe,t,i,n,P,O,T,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEventFromObservable=t.KeepAliveObserver=t.FromEventObservable=void 0,t.constObservable=d,t.observableFromPromise=S,t.observableFromEvent=b,t.observableSignalFromEvent=e,t.observableSignal=o,t.debouncedObservable=h,t.debouncedObservable2=p,t.wasEventTriggeredRecently=L,t.keepObserved=y,t.recomputeInitiallyAndOnChange=r,t.derivedObservableWithCache=E,t.derivedObservableWithWritableCache=I,t.mapObservableArrayCached=H,t.observableFromValueWithChangeEvent=v;function d(k){return new D(k)}class D extends O.ConvenientObservable{constructor(x){super(),this.value=x}get debugName(){return this.toString()}get(){return this.value}addObserver(x){}removeObserver(x){}toString(){return`Const: ${this.value}`}}function S(k){const x=(0,O.observableValue)("promiseValue",{});return k.then(N=>{x.set({value:N},void 0)}),x}function b(k,x){return new m(k,x)}class m extends O.BaseObservable{constructor(x,N){super(),this.event=x,this._getValue=N,this.hasValue=!1,this.handleEvent=M=>{const $=this._getValue(M),ne=this.value,Z=!this.hasValue||ne!==$;let Y=!1;Z&&(this.value=$,this.hasValue&&(Y=!0,(0,O.subtransaction)(m.globalTransaction,te=>{(0,_.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:ne,newValue:$,change:void 0,didChange:Z,hadValue:this.hasValue});for(const fe of this.observers)te.updateObserver(fe,this),fe.handleChange(this,void 0)},()=>{const te=this.getDebugName();return"Event fired"+(te?`: ${te}`:"")})),this.hasValue=!0),Y||(0,_.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:ne,newValue:$,change:void 0,didChange:Z,hadValue:this.hasValue})}}getDebugName(){return(0,T.getFunctionName)(this._getValue)}get debugName(){const x=this.getDebugName();return"From Event"+(x?`: ${x}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}t.FromEventObservable=m,function(k){k.Observer=m;function x(N,M){let $=!1;m.globalTransaction===void 0&&(m.globalTransaction=N,$=!0);try{M()}finally{$&&(m.globalTransaction=void 0)}}k.batchEventsGlobally=x}(b||(t.observableFromEvent=b={}));function e(k,x){return new s(k,x)}class s extends O.BaseObservable{constructor(x,N){super(),this.debugName=x,this.event=N,this.handleEvent=()=>{(0,O.transaction)(M=>{for(const $ of this.observers)M.updateObserver($,this),$.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function o(k){return typeof k=="string"?new c(k):new c(void 0,k)}class c extends O.BaseObservable{get debugName(){return new T.DebugNameData(this._owner,this._debugName,void 0).getDebugName(this)??"Observable Signal"}constructor(x,N){super(),this._debugName=x,this._owner=N}trigger(x,N){if(!x){(0,O.transaction)(M=>{this.trigger(M,N)},()=>`Trigger signal ${this.debugName}`);return}for(const M of this.observers)x.updateObserver(M,this),M.handleChange(this,N)}get(){}}function h(k,x,N){const M=(0,O.observableValue)("debounced",void 0);let $;return N.add((0,P.autorun)(ne=>{const Z=k.read(ne);$&&clearTimeout($),$=setTimeout(()=>{(0,O.transaction)(Y=>{M.set(Z,Y)})},x)})),M}function p(k,x){let N=!1,M,$;return b(ne=>{const Z=(0,P.autorun)(Y=>{const te=k.read(Y);N?($&&clearTimeout($),$=setTimeout(()=>{M=te,ne()},x)):(N=!0,M=te)});return{dispose(){Z.dispose(),N=!1,M=void 0}}},()=>N?M:k.get())}function L(k,x,N){const M=(0,O.observableValue)("triggeredRecently",!1);let $;return N.add(k(()=>{M.set(!0,void 0),$&&clearTimeout($),$=setTimeout(()=>{M.set(!1,void 0)},x)})),M}function y(k){const x=new f(!1,void 0);return k.addObserver(x),(0,n.toDisposable)(()=>{k.removeObserver(x)})}(0,O._setKeepObserved)(y);function r(k,x){const N=new f(!0,x);return k.addObserver(N),x?x(k.get()):k.reportChanges(),(0,n.toDisposable)(()=>{k.removeObserver(N)})}(0,O._setRecomputeInitiallyAndOnChange)(r);class f{constructor(x,N){this._forceRecompute=x,this._handleValue=N,this._counter=0}beginUpdate(x){this._counter++}endUpdate(x){this._counter--,this._counter===0&&this._forceRecompute&&(this._handleValue?this._handleValue(x.get()):x.reportChanges())}handlePossibleChange(x){}handleChange(x,N){}}t.KeepAliveObserver=f;function E(k,x){let N;return(0,w.derived)(k,$=>(N=x($,N),N))}function I(k,x){let N;const M=o("derivedObservableWithWritableCache"),$=(0,w.derived)(k,ne=>(M.read(ne),N=x(ne,N),N));return Object.assign($,{clearCache:ne=>{N=void 0,M.trigger(ne)},setCache:(ne,Z)=>{N=ne,M.trigger(Z)}})}function H(k,x,N,M){let $=new z(N,M);return(0,w.derivedOpts)({debugReferenceFn:N,owner:k,onLastObserverRemoved:()=>{$.dispose(),$=new z(N)}},Z=>($.setItems(x.read(Z)),$.getItems()))}class z{constructor(x,N){this._map=x,this._keySelector=N,this._cache=new Map,this._items=[]}dispose(){this._cache.forEach(x=>x.store.dispose()),this._cache.clear()}setItems(x){const N=[],M=new Set(this._cache.keys());for(const $ of x){const ne=this._keySelector?this._keySelector($):$;let Z=this._cache.get(ne);if(Z)M.delete(ne);else{const Y=new n.DisposableStore;Z={out:this._map($,Y),store:Y},this._cache.set(ne,Z)}N.push(Z.out)}for(const $ of M)this._cache.get($).store.dispose(),this._cache.delete($);this._items=N}getItems(){return this._items}}class U{constructor(x){this.observable=x}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.ValueWithChangeEventFromObservable=U;function v(k,x){return x instanceof U?x.observable:b(x.onDidChange,()=>x.value)}}),define(ve[61],De([1,0,36,46,45,100,99,30]),function(oe,t,i,n,P,O,T,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.observableValue}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.disposableObservableValue}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.transaction}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.subtransaction}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return n.derived}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return n.derivedOpts}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return n.derivedHandleChanges}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return n.derivedWithStore}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return P.autorun}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return P.autorunDelta}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return P.autorunHandleChanges}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return P.autorunWithStore}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return P.autorunOpts}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return P.autorunWithStoreHandleChanges}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return O.constObservable}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return O.debouncedObservable}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.derivedObservableWithCache}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.derivedObservableWithWritableCache}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return O.keepObserved}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return O.recomputeInitiallyAndOnChange}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return O.observableFromEvent}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return O.observableFromPromise}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return O.observableSignal}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.observableSignalFromEvent}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.wasEventTriggeredRecently}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return T.ObservableLazy}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return T.ObservableLazyPromise}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return T.ObservablePromise}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return T.PromiseResult}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return T.waitForState}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return T.derivedWithCancellationToken}}),!1&&(0,w.setLogger)(new w.ConsoleObservableLogger)}),define(ve[20],De([1,0,3,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var P;(function(m){m[m.Auto=1]="Auto",m[m.Hidden=2]="Hidden",m[m.Visible=3]="Visible"})(P||(t.ScrollbarVisibility=P={}));class O{constructor(e,s,o,c,h,p,L){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(s=s|0,o=o|0,c=c|0,h=h|0,p=p|0,L=L|0),this.rawScrollLeft=c,this.rawScrollTop=L,s<0&&(s=0),c+s>o&&(c=o-s),c<0&&(c=0),h<0&&(h=0),L+h>p&&(L=p-h),L<0&&(L=0),this.width=s,this.scrollWidth=o,this.scrollLeft=c,this.height=h,this.scrollHeight=p,this.scrollTop=L}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new O(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new O(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const o=this.width!==e.width,c=this.scrollWidth!==e.scrollWidth,h=this.scrollLeft!==e.scrollLeft,p=this.height!==e.height,L=this.scrollHeight!==e.scrollHeight,y=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:c,scrollLeftChanged:h,heightChanged:p,scrollHeightChanged:L,scrollTopChanged:y}}}t.ScrollState=O;class T extends n.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new i.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new O(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,s){const o=this._state.withScrollDimensions(e,s);this._setState(o,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const s=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(s,!1)}setScrollPositionSmooth(e,s){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const o=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===o.scrollLeft&&this._smoothScrolling.to.scrollTop===o.scrollTop)return;let c;s?c=new D(this._smoothScrolling.from,o,this._smoothScrolling.startTime,this._smoothScrolling.duration):c=this._smoothScrolling.combine(this._state,o,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=c}else{const o=this._state.withScrollPosition(e);this._smoothScrolling=D.start(this._state,o,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),s=this._state.withScrollPosition(e);if(this._setState(s,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,s){const o=this._state;o.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(o,s)))}}t.Scrollable=T;class w{constructor(e,s,o){this.scrollLeft=e,this.scrollTop=s,this.isDone=o}}t.SmoothScrollingUpdate=w;function _(m,e){const s=e-m;return function(o){return m+s*b(o)}}function d(m,e,s){return function(o){return o<s?m(o/s):e((o-s)/(1-s))}}class D{constructor(e,s,o,c){this.from=e,this.to=s,this.duration=c,this.startTime=o,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,s,o){if(Math.abs(e-s)>2.5*o){let h,p;return e<s?(h=e+.75*o,p=s-.75*o):(h=e-.75*o,p=s+.75*o),d(_(e,h),_(p,s),.33)}return _(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const s=(e-this.startTime)/this.duration;if(s<1){const o=this.scrollLeft(s),c=this.scrollTop(s);return new w(o,c,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,o){return D.start(e,s,o)}static start(e,s,o){o=o+10;const c=Date.now()-10;return new D(e,s,c,o)}}t.SmoothScrollingOperation=D;function S(m){return Math.pow(m,3)}function b(m){return 1-S(1-m)}}),define(ve[101],De([1,0,6,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isReadable=P,t.isReadableStream=O,t.isReadableBufferedStream=T,t.newWriteableStream=w,t.consumeReadable=d,t.peekReadable=D,t.consumeStream=S,t.listenStream=b,t.peekStream=m,t.toStream=e,t.emptyStream=s,t.toReadable=o,t.transform=c,t.prefixedReadable=h,t.prefixedStream=p;function P(L){const y=L;return y?typeof y.read=="function":!1}function O(L){const y=L;return y?[y.on,y.pause,y.resume,y.destroy].every(r=>typeof r=="function"):!1}function T(L){const y=L;return y?O(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}function w(L,y){return new _(L,y)}class _{constructor(y,r){this.reducer=y,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(y){if(!this.state.destroyed){if(this.state.flowing)this.emitData(y);else if(this.buffer.data.push(y),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(y){this.state.destroyed||(this.state.flowing?this.emitError(y):this.buffer.error.push(y))}end(y){this.state.destroyed||(typeof y<"u"&&this.write(y),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(y){this.listeners.data.slice(0).forEach(r=>r(y))}emitError(y){this.listeners.error.length===0?(0,i.onUnexpectedError)(y):this.listeners.error.slice(0).forEach(r=>r(y))}emitEnd(){this.listeners.end.slice(0).forEach(y=>y())}on(y,r){if(!this.state.destroyed)switch(y){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(y,r){if(this.state.destroyed)return;let f;switch(y){case"data":f=this.listeners.data;break;case"end":f=this.listeners.end;break;case"error":f=this.listeners.error;break}if(f){const E=f.indexOf(r);E>=0&&f.splice(E,1)}}flowData(){if(this.buffer.data.length>0){const y=this.reducer(this.buffer.data);this.emitData(y),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(f=>f())}}flowErrors(){if(this.listeners.error.length>0){for(const y of this.buffer.error)this.emitError(y);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(L,y){const r=[];let f;for(;(f=L.read())!==null;)r.push(f);return y(r)}function D(L,y,r){const f=[];let E;for(;(E=L.read())!==null&&f.length<r;)f.push(E);return E===null&&f.length>0?y(f):{read:()=>{if(f.length>0)return f.shift();if(typeof E<"u"){const I=E;return E=void 0,I}return L.read()}}}function S(L,y){return new Promise((r,f)=>{const E=[];b(L,{onData:I=>{y&&E.push(I)},onError:I=>{y?f(I):r(void 0)},onEnd:()=>{r(y?y(E):void 0)}})})}function b(L,y,r){L.on("error",f=>{r?.isCancellationRequested||y.onError(f)}),L.on("end",()=>{r?.isCancellationRequested||y.onEnd()}),L.on("data",f=>{r?.isCancellationRequested||y.onData(f)})}function m(L,y){return new Promise((r,f)=>{const E=new n.DisposableStore,I=[],H=v=>{if(I.push(v),I.length>y)return E.dispose(),L.pause(),r({stream:L,buffer:I,ended:!1})},z=v=>(E.dispose(),f(v)),U=()=>(E.dispose(),r({stream:L,buffer:I,ended:!0}));E.add((0,n.toDisposable)(()=>L.removeListener("error",z))),L.on("error",z),E.add((0,n.toDisposable)(()=>L.removeListener("end",U))),L.on("end",U),E.add((0,n.toDisposable)(()=>L.removeListener("data",H))),L.on("data",H)})}function e(L,y){const r=w(y);return r.end(L),r}function s(){const L=w(()=>{throw new Error("not supported")});return L.end(),L}function o(L){let y=!1;return{read:()=>y?null:(y=!0,L)}}function c(L,y,r){const f=w(r);return b(L,{onData:E=>f.write(y.data(E)),onError:E=>f.error(y.error?y.error(E):E),onEnd:()=>f.end()}),f}function h(L,y,r){let f=!1;return{read:()=>{const E=y.read();return f?E:(f=!0,E!==null?r([L,E]):L)}}}function p(L,y,r){let f=!1;const E=w(r);return b(y,{onData:I=>f?E.write(I):(f=!0,E.write(r([L,I]))),onError:I=>E.error(I),onEnd:()=>{f||(f=!0,E.write(L)),E.end()}}),E}}),define(ve[48],De([1,0,26,101]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VSBuffer=void 0,t.binaryIndexOf=d,t.readUInt16LE=D,t.writeUInt16LE=S,t.readUInt32BE=b,t.writeUInt32BE=m,t.readUInt32LE=e,t.writeUInt32LE=s,t.readUInt8=o,t.writeUInt8=c,t.readableToBuffer=h,t.bufferToReadable=p,t.streamToBuffer=L,t.bufferedStreamToBuffer=y,t.bufferToStream=r,t.streamToBufferReadableStream=f,t.newWriteableBufferStream=E,t.prefixedBufferReadable=I,t.prefixedBufferStream=H,t.decodeBase64=z,t.encodeBase64=k;const P=typeof Buffer<"u",O=new i.Lazy(()=>new Uint8Array(256));let T,w;class _{static alloc(N){return P?new _(Buffer.allocUnsafe(N)):new _(new Uint8Array(N))}static wrap(N){return P&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new _(N)}static fromString(N,M){return!(M?.dontUseNodeBuffer||!1)&&P?new _(Buffer.from(N)):(T||(T=new TextEncoder),new _(T.encode(N)))}static fromByteArray(N){const M=_.alloc(N.length);for(let $=0,ne=N.length;$<ne;$++)M.buffer[$]=N[$];return M}static concat(N,M){if(typeof M>"u"){M=0;for(let Z=0,Y=N.length;Z<Y;Z++)M+=N[Z].byteLength}const $=_.alloc(M);let ne=0;for(let Z=0,Y=N.length;Z<Y;Z++){const te=N[Z];$.set(te,ne),ne+=te.byteLength}return $}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=_.alloc(this.byteLength);return N.set(this),N}toString(){return P?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(N,M){return new _(this.buffer.subarray(N,M))}set(N,M){if(N instanceof _)this.buffer.set(N.buffer,M);else if(N instanceof Uint8Array)this.buffer.set(N,M);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),M);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return b(this.buffer,N)}writeUInt32BE(N,M){m(this.buffer,N,M)}readUInt32LE(N){return e(this.buffer,N)}writeUInt32LE(N,M){s(this.buffer,N,M)}readUInt8(N){return o(this.buffer,N)}writeUInt8(N,M){c(this.buffer,N,M)}indexOf(N,M=0){return d(this.buffer,N instanceof _?N.buffer:N,M)}}t.VSBuffer=_;function d(x,N,M=0){const $=N.byteLength,ne=x.byteLength;if($===0)return 0;if($===1)return x.indexOf(N[0]);if($>ne-M)return-1;const Z=O.value;Z.fill(N.length);for(let Ee=0;Ee<N.length;Ee++)Z[N[Ee]]=N.length-Ee-1;let Y=M+N.length-1,te=Y,fe=-1;for(;Y<ne;)if(x[Y]===N[te]){if(te===0){fe=Y;break}Y--,te--}else Y+=Math.max(N.length-te,Z[x[Y]]),te=N.length-1;return fe}function D(x,N){return x[N+0]<<0>>>0|x[N+1]<<8>>>0}function S(x,N,M){x[M+0]=N&255,N=N>>>8,x[M+1]=N&255}function b(x,N){return x[N]*2**24+x[N+1]*2**16+x[N+2]*2**8+x[N+3]}function m(x,N,M){x[M+3]=N,N=N>>>8,x[M+2]=N,N=N>>>8,x[M+1]=N,N=N>>>8,x[M]=N}function e(x,N){return x[N+0]<<0>>>0|x[N+1]<<8>>>0|x[N+2]<<16>>>0|x[N+3]<<24>>>0}function s(x,N,M){x[M+0]=N&255,N=N>>>8,x[M+1]=N&255,N=N>>>8,x[M+2]=N&255,N=N>>>8,x[M+3]=N&255}function o(x,N){return x[N]}function c(x,N,M){x[M]=N}function h(x){return n.consumeReadable(x,N=>_.concat(N))}function p(x){return n.toReadable(x)}function L(x){return n.consumeStream(x,N=>_.concat(N))}async function y(x){return x.ended?_.concat(x.buffer):_.concat([...x.buffer,await L(x.stream)])}function r(x){return n.toStream(x,N=>_.concat(N))}function f(x){return n.transform(x,{data:N=>typeof N=="string"?_.fromString(N):_.wrap(N)},N=>_.concat(N))}function E(x){return n.newWriteableStream(N=>_.concat(N),x)}function I(x,N){return n.prefixedReadable(x,N,M=>_.concat(M))}function H(x,N){return n.prefixedStream(x,N,M=>_.concat(M))}function z(x){let N=0,M=0,$=0;const ne=new Uint8Array(Math.floor(x.length/4*3)),Z=te=>{switch(M){case 3:ne[$++]=N|te,M=0;break;case 2:ne[$++]=N|te>>>2,N=te<<6,M=3;break;case 1:ne[$++]=N|te>>>4,N=te<<4,M=2;break;default:N=te<<2,M=1}};for(let te=0;te<x.length;te++){const fe=x.charCodeAt(te);if(fe>=65&&fe<=90)Z(fe-65);else if(fe>=97&&fe<=122)Z(fe-97+26);else if(fe>=48&&fe<=57)Z(fe-48+52);else if(fe===43||fe===45)Z(62);else if(fe===47||fe===95)Z(63);else{if(fe===61)break;throw new SyntaxError(`Unexpected base64 character ${x[te]}`)}}const Y=$;for(;M>0;)Z(0);return _.wrap(ne).slice(0,Y)}const U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:x},N=!0,M=!1){const $=M?v:U;let ne="";const Z=x.byteLength%3;let Y=0;for(;Y<x.byteLength-Z;Y+=3){const te=x[Y+0],fe=x[Y+1],Ee=x[Y+2];ne+=$[te>>>2],ne+=$[(te<<4|fe>>>4)&63],ne+=$[(fe<<2|Ee>>>6)&63],ne+=$[Ee&63]}if(Z===1){const te=x[Y+0];ne+=$[te>>>2],ne+=$[te<<4&63],N&&(ne+="==")}else if(Z===2){const te=x[Y+0],fe=x[Y+1];ne+=$[te>>>2],ne+=$[(te<<4|fe>>>4)&63],ne+=$[fe<<2&63],N&&(ne+="=")}return ne}}),define(ve[62],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ve[10],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isString=i,t.isStringArray=n,t.isObject=P,t.isTypedArray=O,t.isNumber=T,t.isIterable=w,t.isBoolean=_,t.isUndefined=d,t.isDefined=D,t.isUndefinedOrNull=S,t.assertType=b,t.assertIsDefined=m,t.assertAllDefined=e,t.isEmptyObject=o,t.isFunction=c,t.areFunctions=h,t.validateConstraints=p,t.validateConstraint=L;function i(y){return typeof y=="string"}function n(y){return Array.isArray(y)&&y.every(r=>i(r))}function P(y){return typeof y=="object"&&y!==null&&!Array.isArray(y)&&!(y instanceof RegExp)&&!(y instanceof Date)}function O(y){const r=Object.getPrototypeOf(Uint8Array);return typeof y=="object"&&y instanceof r}function T(y){return typeof y=="number"&&!isNaN(y)}function w(y){return!!y&&typeof y[Symbol.iterator]=="function"}function _(y){return y===!0||y===!1}function d(y){return typeof y>"u"}function D(y){return!S(y)}function S(y){return d(y)||y===null}function b(y,r){if(!y)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function m(y){if(S(y))throw new Error("Assertion Failed: argument is undefined or null");return y}function e(...y){const r=[];for(let f=0;f<y.length;f++){const E=y[f];if(S(E))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);r.push(E)}return r}const s=Object.prototype.hasOwnProperty;function o(y){if(!P(y))return!1;for(const r in y)if(s.call(y,r))return!1;return!0}function c(y){return typeof y=="function"}function h(...y){return y.length>0&&y.every(c)}function p(y,r){const f=Math.min(y.length,r.length);for(let E=0;E<f;E++)L(y[E],r[E])}function L(y,r){if(i(r)){if(typeof y!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(c(r)){try{if(y instanceof r)return}catch{}if(!S(y)&&y.constructor===r||r.length===1&&r.call(void 0,y)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ve[49],De([1,0,10]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.register=P,t.getCodiconFontCharacters=O;const n=Object.create(null);function P(T,w){if((0,i.isString)(w)){const _=n[w];if(_===void 0)throw new Error(`${T} references an unknown codicon: ${w}`);w=_}return n[T]=w,{id:T}}function O(){return n}}),define(ve[102],De([1,0,49]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.codiconsLibrary=void 0,t.codiconsLibrary={add:(0,i.register)("add",6e4),plus:(0,i.register)("plus",6e4),gistNew:(0,i.register)("gist-new",6e4),repoCreate:(0,i.register)("repo-create",6e4),lightbulb:(0,i.register)("lightbulb",60001),lightBulb:(0,i.register)("light-bulb",60001),repo:(0,i.register)("repo",60002),repoDelete:(0,i.register)("repo-delete",60002),gistFork:(0,i.register)("gist-fork",60003),repoForked:(0,i.register)("repo-forked",60003),gitPullRequest:(0,i.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.register)("git-pull-request-abandoned",60004),recordKeys:(0,i.register)("record-keys",60005),keyboard:(0,i.register)("keyboard",60005),tag:(0,i.register)("tag",60006),gitPullRequestLabel:(0,i.register)("git-pull-request-label",60006),tagAdd:(0,i.register)("tag-add",60006),tagRemove:(0,i.register)("tag-remove",60006),person:(0,i.register)("person",60007),personFollow:(0,i.register)("person-follow",60007),personOutline:(0,i.register)("person-outline",60007),personFilled:(0,i.register)("person-filled",60007),gitBranch:(0,i.register)("git-branch",60008),gitBranchCreate:(0,i.register)("git-branch-create",60008),gitBranchDelete:(0,i.register)("git-branch-delete",60008),sourceControl:(0,i.register)("source-control",60008),mirror:(0,i.register)("mirror",60009),mirrorPublic:(0,i.register)("mirror-public",60009),star:(0,i.register)("star",60010),starAdd:(0,i.register)("star-add",60010),starDelete:(0,i.register)("star-delete",60010),starEmpty:(0,i.register)("star-empty",60010),comment:(0,i.register)("comment",60011),commentAdd:(0,i.register)("comment-add",60011),alert:(0,i.register)("alert",60012),warning:(0,i.register)("warning",60012),search:(0,i.register)("search",60013),searchSave:(0,i.register)("search-save",60013),logOut:(0,i.register)("log-out",60014),signOut:(0,i.register)("sign-out",60014),logIn:(0,i.register)("log-in",60015),signIn:(0,i.register)("sign-in",60015),eye:(0,i.register)("eye",60016),eyeUnwatch:(0,i.register)("eye-unwatch",60016),eyeWatch:(0,i.register)("eye-watch",60016),circleFilled:(0,i.register)("circle-filled",60017),primitiveDot:(0,i.register)("primitive-dot",60017),closeDirty:(0,i.register)("close-dirty",60017),debugBreakpoint:(0,i.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.register)("debug-breakpoint-disabled",60017),debugHint:(0,i.register)("debug-hint",60017),terminalDecorationSuccess:(0,i.register)("terminal-decoration-success",60017),primitiveSquare:(0,i.register)("primitive-square",60018),edit:(0,i.register)("edit",60019),pencil:(0,i.register)("pencil",60019),info:(0,i.register)("info",60020),issueOpened:(0,i.register)("issue-opened",60020),gistPrivate:(0,i.register)("gist-private",60021),gitForkPrivate:(0,i.register)("git-fork-private",60021),lock:(0,i.register)("lock",60021),mirrorPrivate:(0,i.register)("mirror-private",60021),close:(0,i.register)("close",60022),removeClose:(0,i.register)("remove-close",60022),x:(0,i.register)("x",60022),repoSync:(0,i.register)("repo-sync",60023),sync:(0,i.register)("sync",60023),clone:(0,i.register)("clone",60024),desktopDownload:(0,i.register)("desktop-download",60024),beaker:(0,i.register)("beaker",60025),microscope:(0,i.register)("microscope",60025),vm:(0,i.register)("vm",60026),deviceDesktop:(0,i.register)("device-desktop",60026),file:(0,i.register)("file",60027),fileText:(0,i.register)("file-text",60027),more:(0,i.register)("more",60028),ellipsis:(0,i.register)("ellipsis",60028),kebabHorizontal:(0,i.register)("kebab-horizontal",60028),mailReply:(0,i.register)("mail-reply",60029),reply:(0,i.register)("reply",60029),organization:(0,i.register)("organization",60030),organizationFilled:(0,i.register)("organization-filled",60030),organizationOutline:(0,i.register)("organization-outline",60030),newFile:(0,i.register)("new-file",60031),fileAdd:(0,i.register)("file-add",60031),newFolder:(0,i.register)("new-folder",60032),fileDirectoryCreate:(0,i.register)("file-directory-create",60032),trash:(0,i.register)("trash",60033),trashcan:(0,i.register)("trashcan",60033),history:(0,i.register)("history",60034),clock:(0,i.register)("clock",60034),folder:(0,i.register)("folder",60035),fileDirectory:(0,i.register)("file-directory",60035),symbolFolder:(0,i.register)("symbol-folder",60035),logoGithub:(0,i.register)("logo-github",60036),markGithub:(0,i.register)("mark-github",60036),github:(0,i.register)("github",60036),terminal:(0,i.register)("terminal",60037),console:(0,i.register)("console",60037),repl:(0,i.register)("repl",60037),zap:(0,i.register)("zap",60038),symbolEvent:(0,i.register)("symbol-event",60038),error:(0,i.register)("error",60039),stop:(0,i.register)("stop",60039),variable:(0,i.register)("variable",60040),symbolVariable:(0,i.register)("symbol-variable",60040),array:(0,i.register)("array",60042),symbolArray:(0,i.register)("symbol-array",60042),symbolModule:(0,i.register)("symbol-module",60043),symbolPackage:(0,i.register)("symbol-package",60043),symbolNamespace:(0,i.register)("symbol-namespace",60043),symbolObject:(0,i.register)("symbol-object",60043),symbolMethod:(0,i.register)("symbol-method",60044),symbolFunction:(0,i.register)("symbol-function",60044),symbolConstructor:(0,i.register)("symbol-constructor",60044),symbolBoolean:(0,i.register)("symbol-boolean",60047),symbolNull:(0,i.register)("symbol-null",60047),symbolNumeric:(0,i.register)("symbol-numeric",60048),symbolNumber:(0,i.register)("symbol-number",60048),symbolStructure:(0,i.register)("symbol-structure",60049),symbolStruct:(0,i.register)("symbol-struct",60049),symbolParameter:(0,i.register)("symbol-parameter",60050),symbolTypeParameter:(0,i.register)("symbol-type-parameter",60050),symbolKey:(0,i.register)("symbol-key",60051),symbolText:(0,i.register)("symbol-text",60051),symbolReference:(0,i.register)("symbol-reference",60052),goToFile:(0,i.register)("go-to-file",60052),symbolEnum:(0,i.register)("symbol-enum",60053),symbolValue:(0,i.register)("symbol-value",60053),symbolRuler:(0,i.register)("symbol-ruler",60054),symbolUnit:(0,i.register)("symbol-unit",60054),activateBreakpoints:(0,i.register)("activate-breakpoints",60055),archive:(0,i.register)("archive",60056),arrowBoth:(0,i.register)("arrow-both",60057),arrowDown:(0,i.register)("arrow-down",60058),arrowLeft:(0,i.register)("arrow-left",60059),arrowRight:(0,i.register)("arrow-right",60060),arrowSmallDown:(0,i.register)("arrow-small-down",60061),arrowSmallLeft:(0,i.register)("arrow-small-left",60062),arrowSmallRight:(0,i.register)("arrow-small-right",60063),arrowSmallUp:(0,i.register)("arrow-small-up",60064),arrowUp:(0,i.register)("arrow-up",60065),bell:(0,i.register)("bell",60066),bold:(0,i.register)("bold",60067),book:(0,i.register)("book",60068),bookmark:(0,i.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.register)("briefcase",60076),broadcast:(0,i.register)("broadcast",60077),browser:(0,i.register)("browser",60078),bug:(0,i.register)("bug",60079),calendar:(0,i.register)("calendar",60080),caseSensitive:(0,i.register)("case-sensitive",60081),check:(0,i.register)("check",60082),checklist:(0,i.register)("checklist",60083),chevronDown:(0,i.register)("chevron-down",60084),chevronLeft:(0,i.register)("chevron-left",60085),chevronRight:(0,i.register)("chevron-right",60086),chevronUp:(0,i.register)("chevron-up",60087),chromeClose:(0,i.register)("chrome-close",60088),chromeMaximize:(0,i.register)("chrome-maximize",60089),chromeMinimize:(0,i.register)("chrome-minimize",60090),chromeRestore:(0,i.register)("chrome-restore",60091),circleOutline:(0,i.register)("circle-outline",60092),circle:(0,i.register)("circle",60092),debugBreakpointUnverified:(0,i.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.register)("terminal-decoration-incomplete",60092),circleSlash:(0,i.register)("circle-slash",60093),circuitBoard:(0,i.register)("circuit-board",60094),clearAll:(0,i.register)("clear-all",60095),clippy:(0,i.register)("clippy",60096),closeAll:(0,i.register)("close-all",60097),cloudDownload:(0,i.register)("cloud-download",60098),cloudUpload:(0,i.register)("cloud-upload",60099),code:(0,i.register)("code",60100),collapseAll:(0,i.register)("collapse-all",60101),colorMode:(0,i.register)("color-mode",60102),commentDiscussion:(0,i.register)("comment-discussion",60103),creditCard:(0,i.register)("credit-card",60105),dash:(0,i.register)("dash",60108),dashboard:(0,i.register)("dashboard",60109),database:(0,i.register)("database",60110),debugContinue:(0,i.register)("debug-continue",60111),debugDisconnect:(0,i.register)("debug-disconnect",60112),debugPause:(0,i.register)("debug-pause",60113),debugRestart:(0,i.register)("debug-restart",60114),debugStart:(0,i.register)("debug-start",60115),debugStepInto:(0,i.register)("debug-step-into",60116),debugStepOut:(0,i.register)("debug-step-out",60117),debugStepOver:(0,i.register)("debug-step-over",60118),debugStop:(0,i.register)("debug-stop",60119),debug:(0,i.register)("debug",60120),deviceCameraVideo:(0,i.register)("device-camera-video",60121),deviceCamera:(0,i.register)("device-camera",60122),deviceMobile:(0,i.register)("device-mobile",60123),diffAdded:(0,i.register)("diff-added",60124),diffIgnored:(0,i.register)("diff-ignored",60125),diffModified:(0,i.register)("diff-modified",60126),diffRemoved:(0,i.register)("diff-removed",60127),diffRenamed:(0,i.register)("diff-renamed",60128),diff:(0,i.register)("diff",60129),diffSidebyside:(0,i.register)("diff-sidebyside",60129),discard:(0,i.register)("discard",60130),editorLayout:(0,i.register)("editor-layout",60131),emptyWindow:(0,i.register)("empty-window",60132),exclude:(0,i.register)("exclude",60133),extensions:(0,i.register)("extensions",60134),eyeClosed:(0,i.register)("eye-closed",60135),fileBinary:(0,i.register)("file-binary",60136),fileCode:(0,i.register)("file-code",60137),fileMedia:(0,i.register)("file-media",60138),filePdf:(0,i.register)("file-pdf",60139),fileSubmodule:(0,i.register)("file-submodule",60140),fileSymlinkDirectory:(0,i.register)("file-symlink-directory",60141),fileSymlinkFile:(0,i.register)("file-symlink-file",60142),fileZip:(0,i.register)("file-zip",60143),files:(0,i.register)("files",60144),filter:(0,i.register)("filter",60145),flame:(0,i.register)("flame",60146),foldDown:(0,i.register)("fold-down",60147),foldUp:(0,i.register)("fold-up",60148),fold:(0,i.register)("fold",60149),folderActive:(0,i.register)("folder-active",60150),folderOpened:(0,i.register)("folder-opened",60151),gear:(0,i.register)("gear",60152),gift:(0,i.register)("gift",60153),gistSecret:(0,i.register)("gist-secret",60154),gist:(0,i.register)("gist",60155),gitCommit:(0,i.register)("git-commit",60156),gitCompare:(0,i.register)("git-compare",60157),compareChanges:(0,i.register)("compare-changes",60157),gitMerge:(0,i.register)("git-merge",60158),githubAction:(0,i.register)("github-action",60159),githubAlt:(0,i.register)("github-alt",60160),globe:(0,i.register)("globe",60161),grabber:(0,i.register)("grabber",60162),graph:(0,i.register)("graph",60163),gripper:(0,i.register)("gripper",60164),heart:(0,i.register)("heart",60165),home:(0,i.register)("home",60166),horizontalRule:(0,i.register)("horizontal-rule",60167),hubot:(0,i.register)("hubot",60168),inbox:(0,i.register)("inbox",60169),issueReopened:(0,i.register)("issue-reopened",60171),issues:(0,i.register)("issues",60172),italic:(0,i.register)("italic",60173),jersey:(0,i.register)("jersey",60174),json:(0,i.register)("json",60175),kebabVertical:(0,i.register)("kebab-vertical",60176),key:(0,i.register)("key",60177),law:(0,i.register)("law",60178),lightbulbAutofix:(0,i.register)("lightbulb-autofix",60179),linkExternal:(0,i.register)("link-external",60180),link:(0,i.register)("link",60181),listOrdered:(0,i.register)("list-ordered",60182),listUnordered:(0,i.register)("list-unordered",60183),liveShare:(0,i.register)("live-share",60184),loading:(0,i.register)("loading",60185),location:(0,i.register)("location",60186),mailRead:(0,i.register)("mail-read",60187),mail:(0,i.register)("mail",60188),markdown:(0,i.register)("markdown",60189),megaphone:(0,i.register)("megaphone",60190),mention:(0,i.register)("mention",60191),milestone:(0,i.register)("milestone",60192),gitPullRequestMilestone:(0,i.register)("git-pull-request-milestone",60192),mortarBoard:(0,i.register)("mortar-board",60193),move:(0,i.register)("move",60194),multipleWindows:(0,i.register)("multiple-windows",60195),mute:(0,i.register)("mute",60196),noNewline:(0,i.register)("no-newline",60197),note:(0,i.register)("note",60198),octoface:(0,i.register)("octoface",60199),openPreview:(0,i.register)("open-preview",60200),package:(0,i.register)("package",60201),paintcan:(0,i.register)("paintcan",60202),pin:(0,i.register)("pin",60203),play:(0,i.register)("play",60204),run:(0,i.register)("run",60204),plug:(0,i.register)("plug",60205),preserveCase:(0,i.register)("preserve-case",60206),preview:(0,i.register)("preview",60207),project:(0,i.register)("project",60208),pulse:(0,i.register)("pulse",60209),question:(0,i.register)("question",60210),quote:(0,i.register)("quote",60211),radioTower:(0,i.register)("radio-tower",60212),reactions:(0,i.register)("reactions",60213),references:(0,i.register)("references",60214),refresh:(0,i.register)("refresh",60215),regex:(0,i.register)("regex",60216),remoteExplorer:(0,i.register)("remote-explorer",60217),remote:(0,i.register)("remote",60218),remove:(0,i.register)("remove",60219),replaceAll:(0,i.register)("replace-all",60220),replace:(0,i.register)("replace",60221),repoClone:(0,i.register)("repo-clone",60222),repoForcePush:(0,i.register)("repo-force-push",60223),repoPull:(0,i.register)("repo-pull",60224),repoPush:(0,i.register)("repo-push",60225),report:(0,i.register)("report",60226),requestChanges:(0,i.register)("request-changes",60227),rocket:(0,i.register)("rocket",60228),rootFolderOpened:(0,i.register)("root-folder-opened",60229),rootFolder:(0,i.register)("root-folder",60230),rss:(0,i.register)("rss",60231),ruby:(0,i.register)("ruby",60232),saveAll:(0,i.register)("save-all",60233),saveAs:(0,i.register)("save-as",60234),save:(0,i.register)("save",60235),screenFull:(0,i.register)("screen-full",60236),screenNormal:(0,i.register)("screen-normal",60237),searchStop:(0,i.register)("search-stop",60238),server:(0,i.register)("server",60240),settingsGear:(0,i.register)("settings-gear",60241),settings:(0,i.register)("settings",60242),shield:(0,i.register)("shield",60243),smiley:(0,i.register)("smiley",60244),sortPrecedence:(0,i.register)("sort-precedence",60245),splitHorizontal:(0,i.register)("split-horizontal",60246),splitVertical:(0,i.register)("split-vertical",60247),squirrel:(0,i.register)("squirrel",60248),starFull:(0,i.register)("star-full",60249),starHalf:(0,i.register)("star-half",60250),symbolClass:(0,i.register)("symbol-class",60251),symbolColor:(0,i.register)("symbol-color",60252),symbolConstant:(0,i.register)("symbol-constant",60253),symbolEnumMember:(0,i.register)("symbol-enum-member",60254),symbolField:(0,i.register)("symbol-field",60255),symbolFile:(0,i.register)("symbol-file",60256),symbolInterface:(0,i.register)("symbol-interface",60257),symbolKeyword:(0,i.register)("symbol-keyword",60258),symbolMisc:(0,i.register)("symbol-misc",60259),symbolOperator:(0,i.register)("symbol-operator",60260),symbolProperty:(0,i.register)("symbol-property",60261),wrench:(0,i.register)("wrench",60261),wrenchSubaction:(0,i.register)("wrench-subaction",60261),symbolSnippet:(0,i.register)("symbol-snippet",60262),tasklist:(0,i.register)("tasklist",60263),telescope:(0,i.register)("telescope",60264),textSize:(0,i.register)("text-size",60265),threeBars:(0,i.register)("three-bars",60266),thumbsdown:(0,i.register)("thumbsdown",60267),thumbsup:(0,i.register)("thumbsup",60268),tools:(0,i.register)("tools",60269),triangleDown:(0,i.register)("triangle-down",60270),triangleLeft:(0,i.register)("triangle-left",60271),triangleRight:(0,i.register)("triangle-right",60272),triangleUp:(0,i.register)("triangle-up",60273),twitter:(0,i.register)("twitter",60274),unfold:(0,i.register)("unfold",60275),unlock:(0,i.register)("unlock",60276),unmute:(0,i.register)("unmute",60277),unverified:(0,i.register)("unverified",60278),verified:(0,i.register)("verified",60279),versions:(0,i.register)("versions",60280),vmActive:(0,i.register)("vm-active",60281),vmOutline:(0,i.register)("vm-outline",60282),vmRunning:(0,i.register)("vm-running",60283),watch:(0,i.register)("watch",60284),whitespace:(0,i.register)("whitespace",60285),wholeWord:(0,i.register)("whole-word",60286),window:(0,i.register)("window",60287),wordWrap:(0,i.register)("word-wrap",60288),zoomIn:(0,i.register)("zoom-in",60289),zoomOut:(0,i.register)("zoom-out",60290),listFilter:(0,i.register)("list-filter",60291),listFlat:(0,i.register)("list-flat",60292),listSelection:(0,i.register)("list-selection",60293),selection:(0,i.register)("selection",60293),listTree:(0,i.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.register)("debug-stackframe-active",60297),circleSmallFilled:(0,i.register)("circle-small-filled",60298),debugStackframeDot:(0,i.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.register)("terminal-decoration-mark",60298),debugStackframe:(0,i.register)("debug-stackframe",60299),debugStackframeFocused:(0,i.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.register)("debug-breakpoint-unsupported",60300),symbolString:(0,i.register)("symbol-string",60301),debugReverseContinue:(0,i.register)("debug-reverse-continue",60302),debugStepBack:(0,i.register)("debug-step-back",60303),debugRestartFrame:(0,i.register)("debug-restart-frame",60304),debugAlt:(0,i.register)("debug-alt",60305),callIncoming:(0,i.register)("call-incoming",60306),callOutgoing:(0,i.register)("call-outgoing",60307),menu:(0,i.register)("menu",60308),expandAll:(0,i.register)("expand-all",60309),feedback:(0,i.register)("feedback",60310),gitPullRequestReviewer:(0,i.register)("git-pull-request-reviewer",60310),groupByRefType:(0,i.register)("group-by-ref-type",60311),ungroupByRefType:(0,i.register)("ungroup-by-ref-type",60312),account:(0,i.register)("account",60313),gitPullRequestAssignee:(0,i.register)("git-pull-request-assignee",60313),bellDot:(0,i.register)("bell-dot",60314),debugConsole:(0,i.register)("debug-console",60315),library:(0,i.register)("library",60316),output:(0,i.register)("output",60317),runAll:(0,i.register)("run-all",60318),syncIgnored:(0,i.register)("sync-ignored",60319),pinned:(0,i.register)("pinned",60320),githubInverted:(0,i.register)("github-inverted",60321),serverProcess:(0,i.register)("server-process",60322),serverEnvironment:(0,i.register)("server-environment",60323),pass:(0,i.register)("pass",60324),issueClosed:(0,i.register)("issue-closed",60324),stopCircle:(0,i.register)("stop-circle",60325),playCircle:(0,i.register)("play-circle",60326),record:(0,i.register)("record",60327),debugAltSmall:(0,i.register)("debug-alt-small",60328),vmConnect:(0,i.register)("vm-connect",60329),cloud:(0,i.register)("cloud",60330),merge:(0,i.register)("merge",60331),export:(0,i.register)("export",60332),graphLeft:(0,i.register)("graph-left",60333),magnet:(0,i.register)("magnet",60334),notebook:(0,i.register)("notebook",60335),redo:(0,i.register)("redo",60336),checkAll:(0,i.register)("check-all",60337),pinnedDirty:(0,i.register)("pinned-dirty",60338),passFilled:(0,i.register)("pass-filled",60339),circleLargeFilled:(0,i.register)("circle-large-filled",60340),circleLarge:(0,i.register)("circle-large",60341),circleLargeOutline:(0,i.register)("circle-large-outline",60341),combine:(0,i.register)("combine",60342),gather:(0,i.register)("gather",60342),table:(0,i.register)("table",60343),variableGroup:(0,i.register)("variable-group",60344),typeHierarchy:(0,i.register)("type-hierarchy",60345),typeHierarchySub:(0,i.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.register)("git-pull-request-create",60348),runAbove:(0,i.register)("run-above",60349),runBelow:(0,i.register)("run-below",60350),notebookTemplate:(0,i.register)("notebook-template",60351),debugRerun:(0,i.register)("debug-rerun",60352),workspaceTrusted:(0,i.register)("workspace-trusted",60353),workspaceUntrusted:(0,i.register)("workspace-untrusted",60354),workspaceUnknown:(0,i.register)("workspace-unknown",60355),terminalCmd:(0,i.register)("terminal-cmd",60356),terminalDebian:(0,i.register)("terminal-debian",60357),terminalLinux:(0,i.register)("terminal-linux",60358),terminalPowershell:(0,i.register)("terminal-powershell",60359),terminalTmux:(0,i.register)("terminal-tmux",60360),terminalUbuntu:(0,i.register)("terminal-ubuntu",60361),terminalBash:(0,i.register)("terminal-bash",60362),arrowSwap:(0,i.register)("arrow-swap",60363),copy:(0,i.register)("copy",60364),personAdd:(0,i.register)("person-add",60365),filterFilled:(0,i.register)("filter-filled",60366),wand:(0,i.register)("wand",60367),debugLineByLine:(0,i.register)("debug-line-by-line",60368),inspect:(0,i.register)("inspect",60369),layers:(0,i.register)("layers",60370),layersDot:(0,i.register)("layers-dot",60371),layersActive:(0,i.register)("layers-active",60372),compass:(0,i.register)("compass",60373),compassDot:(0,i.register)("compass-dot",60374),compassActive:(0,i.register)("compass-active",60375),azure:(0,i.register)("azure",60376),issueDraft:(0,i.register)("issue-draft",60377),gitPullRequestClosed:(0,i.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.register)("git-pull-request-draft",60379),debugAll:(0,i.register)("debug-all",60380),debugCoverage:(0,i.register)("debug-coverage",60381),runErrors:(0,i.register)("run-errors",60382),folderLibrary:(0,i.register)("folder-library",60383),debugContinueSmall:(0,i.register)("debug-continue-small",60384),beakerStop:(0,i.register)("beaker-stop",60385),graphLine:(0,i.register)("graph-line",60386),graphScatter:(0,i.register)("graph-scatter",60387),pieChart:(0,i.register)("pie-chart",60388),bracket:(0,i.register)("bracket",60175),bracketDot:(0,i.register)("bracket-dot",60389),bracketError:(0,i.register)("bracket-error",60390),lockSmall:(0,i.register)("lock-small",60391),azureDevops:(0,i.register)("azure-devops",60392),verifiedFilled:(0,i.register)("verified-filled",60393),newline:(0,i.register)("newline",60394),layout:(0,i.register)("layout",60395),layoutActivitybarLeft:(0,i.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.register)("layout-panel-left",60398),layoutPanelCenter:(0,i.register)("layout-panel-center",60399),layoutPanelJustify:(0,i.register)("layout-panel-justify",60400),layoutPanelRight:(0,i.register)("layout-panel-right",60401),layoutPanel:(0,i.register)("layout-panel",60402),layoutSidebarLeft:(0,i.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.register)("layout-sidebar-right",60404),layoutStatusbar:(0,i.register)("layout-statusbar",60405),layoutMenubar:(0,i.register)("layout-menubar",60406),layoutCentered:(0,i.register)("layout-centered",60407),target:(0,i.register)("target",60408),indent:(0,i.register)("indent",60409),recordSmall:(0,i.register)("record-small",60410),errorSmall:(0,i.register)("error-small",60411),terminalDecorationError:(0,i.register)("terminal-decoration-error",60411),arrowCircleDown:(0,i.register)("arrow-circle-down",60412),arrowCircleLeft:(0,i.register)("arrow-circle-left",60413),arrowCircleRight:(0,i.register)("arrow-circle-right",60414),arrowCircleUp:(0,i.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.register)("layout-sidebar-left-off",60418),blank:(0,i.register)("blank",60419),heartFilled:(0,i.register)("heart-filled",60420),map:(0,i.register)("map",60421),mapHorizontal:(0,i.register)("map-horizontal",60421),foldHorizontal:(0,i.register)("fold-horizontal",60421),mapFilled:(0,i.register)("map-filled",60422),mapHorizontalFilled:(0,i.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.register)("fold-horizontal-filled",60422),circleSmall:(0,i.register)("circle-small",60423),bellSlash:(0,i.register)("bell-slash",60424),bellSlashDot:(0,i.register)("bell-slash-dot",60425),commentUnresolved:(0,i.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.register)("search-fuzzy",60429),commentDraft:(0,i.register)("comment-draft",60430),send:(0,i.register)("send",60431),sparkle:(0,i.register)("sparkle",60432),insert:(0,i.register)("insert",60433),mic:(0,i.register)("mic",60434),thumbsdownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsupFilled:(0,i.register)("thumbsup-filled",60436),coffee:(0,i.register)("coffee",60437),snake:(0,i.register)("snake",60438),game:(0,i.register)("game",60439),vr:(0,i.register)("vr",60440),chip:(0,i.register)("chip",60441),piano:(0,i.register)("piano",60442),music:(0,i.register)("music",60443),micFilled:(0,i.register)("mic-filled",60444),repoFetch:(0,i.register)("repo-fetch",60445),copilot:(0,i.register)("copilot",60446),lightbulbSparkle:(0,i.register)("lightbulb-sparkle",60447),robot:(0,i.register)("robot",60448),sparkleFilled:(0,i.register)("sparkle-filled",60449),diffSingle:(0,i.register)("diff-single",60450),diffMultiple:(0,i.register)("diff-multiple",60451),surroundWith:(0,i.register)("surround-with",60452),share:(0,i.register)("share",60453),gitStash:(0,i.register)("git-stash",60454),gitStashApply:(0,i.register)("git-stash-apply",60455),gitStashPop:(0,i.register)("git-stash-pop",60456),vscode:(0,i.register)("vscode",60457),vscodeInsiders:(0,i.register)("vscode-insiders",60458),codeOss:(0,i.register)("code-oss",60459),runCoverage:(0,i.register)("run-coverage",60460),runAllCoverage:(0,i.register)("run-all-coverage",60461),coverage:(0,i.register)("coverage",60462),githubProject:(0,i.register)("github-project",60463),mapVertical:(0,i.register)("map-vertical",60464),foldVertical:(0,i.register)("fold-vertical",60464),mapVerticalFilled:(0,i.register)("map-vertical-filled",60465),foldVerticalFilled:(0,i.register)("fold-vertical-filled",60465),goToSearch:(0,i.register)("go-to-search",60466),percentage:(0,i.register)("percentage",60467),sortPercentage:(0,i.register)("sort-percentage",60467),attach:(0,i.register)("attach",60468)}}),define(ve[21],De([1,0,49,102]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.codiconsDerived=void 0,t.getAllCodicons=P;function P(){return Object.values(t.Codicon)}t.codiconsDerived={dialogError:(0,i.register)("dialog-error","error"),dialogWarning:(0,i.register)("dialog-warning","warning"),dialogInfo:(0,i.register)("dialog-info","info"),dialogClose:(0,i.register)("dialog-close","close"),treeItemExpanded:(0,i.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.register)("tree-filter-clear","close"),treeItemLoading:(0,i.register)("tree-item-loading","loading"),menuSelection:(0,i.register)("menu-selection","check"),menuSubmenu:(0,i.register)("menu-submenu","chevron-right"),menuBarMore:(0,i.register)("menubar-more","more"),scrollbarButtonLeft:(0,i.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.register)("toolbar-more","more"),quickInputBack:(0,i.register)("quick-input-back","arrow-left"),dropDownButton:(0,i.register)("drop-down-button",60084),symbolCustomColor:(0,i.register)("symbol-customcolor",60252),exportIcon:(0,i.register)("export",60332),workspaceUnspecified:(0,i.register)("workspace-unspecified",60355),newLine:(0,i.register)("newline",60394),thumbsDownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.register)("thumbsup-filled",60436),gitFetch:(0,i.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.register)("debug-breakpoint-pending",60377)},t.Codicon={...n.codiconsLibrary,...t.codiconsDerived}}),define(ve[63],De([1,0,10]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=n,t.deepFreeze=P,t.cloneAndChange=T,t.mixin=_,t.equals=d,t.safeStringify=D,t.distinct=S,t.getCaseInsensitive=b,t.filter=m,t.getAllPropertyNames=e,t.getAllMethodNames=s,t.createProxyObject=o,t.mapValues=c;function n(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const p=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([L,y])=>{p[L]=y&&typeof y=="object"?n(y):y}),p}function P(h){if(!h||typeof h!="object")return h;const p=[h];for(;p.length>0;){const L=p.shift();Object.freeze(L);for(const y in L)if(O.call(L,y)){const r=L[y];typeof r=="object"&&!Object.isFrozen(r)&&!(0,i.isTypedArray)(r)&&p.push(r)}}return h}const O=Object.prototype.hasOwnProperty;function T(h,p){return w(h,p,new Set)}function w(h,p,L){if((0,i.isUndefinedOrNull)(h))return h;const y=p(h);if(typeof y<"u")return y;if(Array.isArray(h)){const r=[];for(const f of h)r.push(w(f,p,L));return r}if((0,i.isObject)(h)){if(L.has(h))throw new Error("Cannot clone recursive data-structure");L.add(h);const r={};for(const f in h)O.call(h,f)&&(r[f]=w(h[f],p,L));return L.delete(h),r}return h}function _(h,p,L=!0){return(0,i.isObject)(h)?((0,i.isObject)(p)&&Object.keys(p).forEach(y=>{y in h?L&&((0,i.isObject)(h[y])&&(0,i.isObject)(p[y])?_(h[y],p[y],L):h[y]=p[y]):h[y]=p[y]}),h):p}function d(h,p){if(h===p)return!0;if(h==null||p===null||p===void 0||typeof h!=typeof p||typeof h!="object"||Array.isArray(h)!==Array.isArray(p))return!1;let L,y;if(Array.isArray(h)){if(h.length!==p.length)return!1;for(L=0;L<h.length;L++)if(!d(h[L],p[L]))return!1}else{const r=[];for(y in h)r.push(y);r.sort();const f=[];for(y in p)f.push(y);if(f.sort(),!d(r,f))return!1;for(L=0;L<r.length;L++)if(!d(h[r[L]],p[r[L]]))return!1}return!0}function D(h){const p=new Set;return JSON.stringify(h,(L,y)=>{if((0,i.isObject)(y)||Array.isArray(y)){if(p.has(y))return"[Circular]";p.add(y)}return typeof y=="bigint"?`[BigInt ${y.toString()}]`:y})}function S(h,p){const L=Object.create(null);return!h||!p||Object.keys(p).forEach(r=>{const f=h[r],E=p[r];d(f,E)||(L[r]=E)}),L}function b(h,p){const L=p.toLowerCase(),y=Object.keys(h).find(r=>r.toLowerCase()===L);return y?h[y]:h[p]}function m(h,p){const L=Object.create(null);for(const[y,r]of Object.entries(h))p(y,r)&&(L[y]=r);return L}function e(h){let p=[];for(;Object.prototype!==h;)p=p.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return p}function s(h){const p=[];for(const L of e(h))typeof h[L]=="function"&&p.push(L);return p}function o(h,p){const L=r=>function(){const f=Array.prototype.slice.call(arguments,0);return p(r,f)},y={};for(const r of h)y[r]=L(r);return y}function c(h,p){const L={};for(const[y,r]of Object.entries(h))L[y]=p(r,y);return L}}),define(ve[22],De([1,0,21]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.themeColorFromId=P;var n;(function(T){function w(_){return _&&typeof _=="object"&&typeof _.id=="string"}T.isThemeColor=w})(n||(t.ThemeColor=n={}));function P(T){return{id:T}}var O;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function _(h){const p=w.exec(h.id);if(!p)return _(i.Codicon.error);const[,L,y]=p,r=["codicon","codicon-"+L];return y&&r.push("codicon-modifier-"+y.substring(1)),r}T.asClassNameArray=_;function d(h){return _(h).join(" ")}T.asClassName=d;function D(h){return"."+_(h).join(".")}T.asCSSSelector=D;function S(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||n.isThemeColor(h.color))}T.isThemeIcon=S;const b=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function m(h){const p=b.exec(h);if(!p)return;const[,L]=p;return{id:L}}T.fromString=m;function e(h){return{id:h}}T.fromId=e;function s(h,p){let L=h.id;const y=L.lastIndexOf("~");return y!==-1&&(L=L.substring(0,y)),p&&(L=`${L}~${p}`),{id:L}}T.modify=s;function o(h){const p=h.id.lastIndexOf("~");if(p!==-1)return h.id.substring(p+1)}T.getModifier=o;function c(h,p){return h.id===p.id&&h.color?.id===p.color?.id}T.isEqual=c})(O||(t.ThemeIcon=O={}))}),define(ve[64],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.toUint8=n,t.toUint32=P;var i;(function(O){O[O.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",O[O.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",O[O.MAX_UINT_8=255]="MAX_UINT_8",O[O.MAX_UINT_16=65535]="MAX_UINT_16",O[O.MAX_UINT_32=4294967295]="MAX_UINT_32",O[O.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function n(O){return O<0?0:O>i.MAX_UINT_8?i.MAX_UINT_8:O|0}function P(O){return O<0?0:O>i.MAX_UINT_32?i.MAX_UINT_32:O|0}}),define(ve[11],De([1,0,98,18,26,64]),function(oe,t,i,n,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=T,t.format=_,t.format2=D,t.htmlAttributeEncodeValue=S,t.escape=b,t.escapeRegExpCharacters=m,t.count=e,t.truncate=s,t.truncateMiddle=o,t.trim=c,t.ltrim=h,t.rtrim=p,t.convertSimple2RegExpPattern=L,t.stripWildcards=y,t.createRegExp=r,t.regExpLeadsToEndlessLoop=f,t.splitLines=E,t.splitLinesIncludeSeparators=I,t.firstNonWhitespaceIndex=H,t.getLeadingWhitespace=z,t.lastNonWhitespaceIndex=U,t.replaceAsync=v,t.compare=k,t.compareSubstring=x,t.compareIgnoreCase=N,t.compareSubstringIgnoreCase=M,t.isAsciiDigit=$,t.isLowerAsciiLetter=ne,t.isUpperAsciiLetter=Z,t.equalsIgnoreCase=Y,t.startsWithIgnoreCase=te,t.commonPrefixLength=fe,t.commonSuffixLength=Ee,t.isHighSurrogate=Fe,t.isLowSurrogate=Ae,t.computeCodePoint=ue,t.getNextCodePoint=J,t.nextCharLength=Q,t.prevCharLength=me,t.getCharContainingOffset=_e,t.charCount=Oe,t.containsRTL=ie,t.isBasicASCII=W,t.containsUnusualLineTerminators=l,t.isFullWidthCharacter=a,t.isEmojiImprecise=g,t.lcut=C,t.forAnsiStringParts=u,t.removeAnsiEscapeCodes=F,t.removeAnsiEscapeCodesFromPrompt=B,t.startsWithUTF8BOM=V,t.stripUTF8BOM=G,t.fuzzyContains=ee,t.containsUppercaseCharacter=re,t.uppercaseFirstLetter=he,t.getNLines=ye,t.singleLetterHash=we,t.getGraphemeBreakType=Ie,t.getLeftDeleteOffset=Ye;function T(X){return!X||typeof X!="string"?!0:X.trim().length===0}const w=/{(\d+)}/g;function _(X,...le){return le.length===0?X:X.replace(w,function(be,Se){const Me=parseInt(Se,10);return isNaN(Me)||Me<0||Me>=le.length?be:le[Me]})}const d=/{([^}]+)}/g;function D(X,le){return Object.keys(le).length===0?X:X.replace(d,(be,Se)=>le[Se]??be)}function S(X){return X.replace(/[<>"'&]/g,le=>{switch(le){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return le})}function b(X){return X.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}function m(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(X,le){let be=0,Se=X.indexOf(le);for(;Se!==-1;)be++,Se=X.indexOf(le,Se+le.length);return be}function s(X,le,be="\u2026"){return X.length<=le?X:`${X.substr(0,le)}${be}`}function o(X,le,be="\u2026"){if(X.length<=le)return X;const Se=Math.ceil(le/2)-be.length/2,Me=Math.floor(le/2)-be.length/2;return`${X.substr(0,Se)}${be}${X.substr(X.length-Me)}`}function c(X,le=" "){const be=h(X,le);return p(be,le)}function h(X,le){if(!X||!le)return X;const be=le.length;if(be===0||X.length===0)return X;let Se=0;for(;X.indexOf(le,Se)===Se;)Se=Se+be;return X.substring(Se)}function p(X,le){if(!X||!le)return X;const be=le.length,Se=X.length;if(be===0||Se===0)return X;let Me=Se,ze=-1;for(;ze=X.lastIndexOf(le,Me-1),!(ze===-1||ze+be!==Me);){if(ze===0)return"";Me=ze}return X.substring(0,Me)}function L(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function y(X){return X.replace(/\*/g,"")}function r(X,le,be={}){if(!X)throw new Error("Cannot create regex from empty string");le||(X=m(X)),be.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let Se="";return be.global&&(Se+="g"),be.matchCase||(Se+="i"),be.multiline&&(Se+="m"),be.unicode&&(Se+="u"),new RegExp(X,Se)}function f(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}function E(X){return X.split(/\r\n|\r|\n/)}function I(X){const le=[],be=X.split(/(\r\n|\r|\n)/);for(let Se=0;Se<Math.ceil(be.length/2);Se++)le.push(be[2*Se]+(be[2*Se+1]??""));return le}function H(X){for(let le=0,be=X.length;le<be;le++){const Se=X.charCodeAt(le);if(Se!==n.CharCode.Space&&Se!==n.CharCode.Tab)return le}return-1}function z(X,le=0,be=X.length){for(let Se=le;Se<be;Se++){const Me=X.charCodeAt(Se);if(Me!==n.CharCode.Space&&Me!==n.CharCode.Tab)return X.substring(le,Se)}return X.substring(le,be)}function U(X,le=X.length-1){for(let be=le;be>=0;be--){const Se=X.charCodeAt(be);if(Se!==n.CharCode.Space&&Se!==n.CharCode.Tab)return be}return-1}function v(X,le,be){const Se=[];let Me=0;for(const ze of X.matchAll(le)){if(Se.push(X.slice(Me,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Me=ze.index+ze[0].length,Se.push(be(ze[0],...ze.slice(1),ze.index,X,ze.groups))}return Se.push(X.slice(Me)),Promise.all(Se).then(ze=>ze.join(""))}function k(X,le){return X<le?-1:X>le?1:0}function x(X,le,be=0,Se=X.length,Me=0,ze=le.length){for(;be<Se&&Me<ze;be++,Me++){const tt=X.charCodeAt(be),lt=le.charCodeAt(Me);if(tt<lt)return-1;if(tt>lt)return 1}const Qe=Se-be,st=ze-Me;return Qe<st?-1:Qe>st?1:0}function N(X,le){return M(X,le,0,X.length,0,le.length)}function M(X,le,be=0,Se=X.length,Me=0,ze=le.length){for(;be<Se&&Me<ze;be++,Me++){let tt=X.charCodeAt(be),lt=le.charCodeAt(Me);if(tt===lt)continue;if(tt>=128||lt>=128)return x(X.toLowerCase(),le.toLowerCase(),be,Se,Me,ze);ne(tt)&&(tt-=32),ne(lt)&&(lt-=32);const nt=tt-lt;if(nt!==0)return nt}const Qe=Se-be,st=ze-Me;return Qe<st?-1:Qe>st?1:0}function $(X){return X>=n.CharCode.Digit0&&X<=n.CharCode.Digit9}function ne(X){return X>=n.CharCode.a&&X<=n.CharCode.z}function Z(X){return X>=n.CharCode.A&&X<=n.CharCode.Z}function Y(X,le){return X.length===le.length&&M(X,le)===0}function te(X,le){const be=le.length;return le.length>X.length?!1:M(X,le,0,be)===0}function fe(X,le){const be=Math.min(X.length,le.length);let Se;for(Se=0;Se<be;Se++)if(X.charCodeAt(Se)!==le.charCodeAt(Se))return Se;return be}function Ee(X,le){const be=Math.min(X.length,le.length);let Se;const Me=X.length-1,ze=le.length-1;for(Se=0;Se<be;Se++)if(X.charCodeAt(Me-Se)!==le.charCodeAt(ze-Se))return Se;return be}function Fe(X){return 55296<=X&&X<=56319}function Ae(X){return 56320<=X&&X<=57343}function ue(X,le){return(X-55296<<10)+(le-56320)+65536}function J(X,le,be){const Se=X.charCodeAt(be);if(Fe(Se)&&be+1<le){const Me=X.charCodeAt(be+1);if(Ae(Me))return ue(Se,Me)}return Se}function de(X,le){const be=X.charCodeAt(le-1);if(Ae(be)&&le>1){const Se=X.charCodeAt(le-2);if(Fe(Se))return ue(Se,be)}return be}class ae{get offset(){return this._offset}constructor(le,be=0){this._str=le,this._len=le.length,this._offset=be}setOffset(le){this._offset=le}prevCodePoint(){const le=de(this._str,this._offset);return this._offset-=le>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,le}nextCodePoint(){const le=J(this._str,this._len,this._offset);return this._offset+=le>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,le}eol(){return this._offset>=this._len}}t.CodePointIterator=ae;class Le{get offset(){return this._iterator.offset}constructor(le,be=0){this._iterator=new ae(le,be)}nextGraphemeLength(){const le=Re.getInstance(),be=this._iterator,Se=be.offset;let Me=le.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const ze=be.offset,Qe=le.getGraphemeBreakType(be.nextCodePoint());if(Te(Me,Qe)){be.setOffset(ze);break}Me=Qe}return be.offset-Se}prevGraphemeLength(){const le=Re.getInstance(),be=this._iterator,Se=be.offset;let Me=le.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const ze=be.offset,Qe=le.getGraphemeBreakType(be.prevCodePoint());if(Te(Qe,Me)){be.setOffset(ze);break}Me=Qe}return Se-be.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=Le;function Q(X,le){return new Le(X,le).nextGraphemeLength()}function me(X,le){return new Le(X,le).prevGraphemeLength()}function _e(X,le){le>0&&Ae(X.charCodeAt(le))&&le--;const be=le+Q(X,le);return[be-me(X,be),be]}function Oe(X){const le=new Le(X);let be=0;for(;!le.eol();)be++,le.nextGraphemeLength();return be}let Ce;function Be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(X){return Ce||(Ce=Be()),Ce.test(X)}const q=/^[\t\n\r\x20-\x7E]*$/;function W(X){return q.test(X)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function l(X){return t.UNUSUAL_LINE_TERMINATORS.test(X)}function a(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}function g(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}function C(X,le,be=""){const Se=X.trimStart();if(Se.length<le)return Se;const Me=/\b/g;let ze=0;for(;Me.test(Se)&&!(Se.length-Me.lastIndex<le);)ze=Me.lastIndex,Me.lastIndex+=1;return ze===0?Se:be+Se.substring(ze).trimStart()}const R=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*u(X){let le=0;for(const be of X.matchAll(R))le!==be.index&&(yield{isCode:!1,str:X.substring(le,be.index)}),yield{isCode:!0,str:be[0]},le=be.index+be[0].length;le!==X.length&&(yield{isCode:!1,str:X.substring(le)})}function F(X){return X&&(X=X.replace(R,"")),X}const A=/\\\[.*?\\\]/g;function B(X){return F(X).replace(A,"")}t.UTF8_BOM_CHARACTER=String.fromCharCode(n.CharCode.UTF8_BOM);function V(X){return!!(X&&X.length>0&&X.charCodeAt(0)===n.CharCode.UTF8_BOM)}function G(X){return V(X)?X.substr(1):X}function ee(X,le){if(!X||!le||X.length<le.length)return!1;const be=le.length,Se=X.toLowerCase();let Me=0,ze=-1;for(;Me<be;){const Qe=Se.indexOf(le[Me],ze+1);if(Qe<0)return!1;ze=Qe,Me++}return!0}function re(X,le=!1){return X?(le&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}function he(X){return X.charAt(0).toUpperCase()+X.slice(1)}function ye(X,le=1){if(le===0)return"";let be=-1;do be=X.indexOf(`
`,be+1),le--;while(le>0&&be>=0);return be===-1?X:(X[be-1]==="\r"&&be--,X.substr(0,be))}function we(X){const le=n.CharCode.Z-n.CharCode.A+1;return X=X%(2*le),X<le?String.fromCharCode(n.CharCode.a+X):String.fromCharCode(n.CharCode.A+X-le)}function Ie(X){return Re.getInstance().getGraphemeBreakType(X)}function Te(X,le){return X===ce.Other?le!==ce.Extend&&le!==ce.SpacingMark:X===ce.CR&&le===ce.LF?!1:X===ce.Control||X===ce.CR||X===ce.LF||le===ce.Control||le===ce.CR||le===ce.LF?!0:!(X===ce.L&&(le===ce.L||le===ce.V||le===ce.LV||le===ce.LVT)||(X===ce.LV||X===ce.V)&&(le===ce.V||le===ce.T)||(X===ce.LVT||X===ce.T)&&le===ce.T||le===ce.Extend||le===ce.ZWJ||le===ce.SpacingMark||X===ce.Prepend||X===ce.ZWJ&&le===ce.Extended_Pictographic||X===ce.Regional_Indicator&&le===ce.Regional_Indicator)}var ce;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(ce||(t.GraphemeBreakType=ce={}));class Re{static{this._INSTANCE=null}static getInstance(){return Re._INSTANCE||(Re._INSTANCE=new Re),Re._INSTANCE}constructor(){this._data=Ue()}getGraphemeBreakType(le){if(le<32)return le===n.CharCode.LineFeed?ce.LF:le===n.CharCode.CarriageReturn?ce.CR:ce.Control;if(le<127)return ce.Other;const be=this._data,Se=be.length/3;let Me=1;for(;Me<=Se;)if(le<be[3*Me])Me=2*Me;else if(le>be[3*Me+1])Me=2*Me+1;else return be[3*Me+2];return ce.Other}}function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ye(X,le){if(X===0)return 0;const be=et(X,le);if(be!==void 0)return be;const Se=new ae(le,X);return Se.prevCodePoint(),Se.offset}function et(X,le){const be=new ae(le,X);let Se=be.prevCodePoint();for(;ot(Se)||Se===it.emojiVariantSelector||Se===it.enclosingKeyCap;){if(be.offset===0)return;Se=be.prevCodePoint()}if(!g(Se))return;let Me=be.offset;return Me>0&&be.prevCodePoint()===it.zwj&&(Me=be.offset),Me}function ot(X){return 127995<=X&&X<=127999}var it;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),t.noBreakWhitespace="\xA0";class $e{static{this.ambiguousCharacterData=new P.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new i.LRUCachedFunction({getCacheKey:JSON.stringify},le=>{function be(nt){const ht=new Map;for(let ut=0;ut<nt.length;ut+=2)ht.set(nt[ut],nt[ut+1]);return ht}function Se(nt,ht){const ut=new Map(nt);for(const[vt,We]of ht)ut.set(vt,We);return ut}function Me(nt,ht){if(!nt)return ht;const ut=new Map;for(const[vt,We]of nt)ht.has(vt)&&ut.set(vt,We);return ut}const ze=this.ambiguousCharacterData.value;let Qe=le.filter(nt=>!nt.startsWith("_")&&nt in ze);Qe.length===0&&(Qe=["_default"]);let st;for(const nt of Qe){const ht=be(ze[nt]);st=Me(st,ht)}const tt=be(ze._common),lt=Se(tt,st);return new $e(lt)})}static getInstance(le){return $e.cache.get(Array.from(le))}static{this._locales=new P.Lazy(()=>Object.keys($e.ambiguousCharacterData.value).filter(le=>!le.startsWith("_")))}static getLocales(){return $e._locales.value}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}containsAmbiguousCharacter(le){for(let be=0;be<le.length;be++){const Se=le.codePointAt(be);if(typeof Se=="number"&&this.isAmbiguous(Se))return!0}return!1}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=$e;class Ze{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ze.getRawData())),this._data}static isInvisibleCharacter(le){return Ze.getData().has(le)}static containsInvisibleCharacter(le){for(let be=0;be<le.length;be++){const Se=le.codePointAt(be);if(typeof Se=="number"&&Ze.isInvisibleCharacter(Se))return!0}return!1}static get codePoints(){return Ze.getData()}}t.InvisibleCharacters=Ze}),define(ve[50],De([1,0,18,43,93,11]),function(oe,t,i,n,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FuzzyScoreOptions=t.FuzzyScore=t.matchesPrefix=t.matchesStrictPrefix=void 0,t.or=T,t.matchesContiguousSubString=_,t.matchesSubString=d,t.isUpper=b,t.matchesCamelCase=U,t.matchesWords=v,t.matchesFuzzy=ne,t.matchesFuzzy2=Z,t.anyScore=Y,t.createMatches=te,t.isPatternInWord=Be,t.fuzzyScore=l,t.fuzzyScoreGracefulAggressive=C,t.fuzzyScoreGraceful=R;function T(...A){return function(B,V){for(let G=0,ee=A.length;G<ee;G++){const re=A[G](B,V);if(re)return re}return null}}t.matchesStrictPrefix=w.bind(void 0,!1),t.matchesPrefix=w.bind(void 0,!0);function w(A,B,V){if(!V||V.length<B.length)return null;let G;return A?G=O.startsWithIgnoreCase(V,B):G=V.indexOf(B)===0,G?B.length>0?[{start:0,end:B.length}]:[]:null}function _(A,B){const V=B.toLowerCase().indexOf(A.toLowerCase());return V===-1?null:[{start:V,end:V+A.length}]}function d(A,B){return D(A.toLowerCase(),B.toLowerCase(),0,0)}function D(A,B,V,G){if(V===A.length)return[];if(G===B.length)return null;if(A[V]===B[G]){let ee=null;return(ee=D(A,B,V+1,G+1))?y({start:G,end:G+1},ee):null}return D(A,B,V,G+1)}function S(A){return i.CharCode.a<=A&&A<=i.CharCode.z}function b(A){return i.CharCode.A<=A&&A<=i.CharCode.Z}function m(A){return i.CharCode.Digit0<=A&&A<=i.CharCode.Digit9}function e(A){return A===i.CharCode.Space||A===i.CharCode.Tab||A===i.CharCode.LineFeed||A===i.CharCode.CarriageReturn}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(A=>s.add(A.charCodeAt(0)));function o(A){return e(A)||s.has(A)}function c(A,B){return A===B||o(A)&&o(B)}const h=new Map;function p(A){if(h.has(A))return h.get(A);let B;const V=(0,P.getKoreanAltChars)(A);return V&&(B=V),h.set(A,B),B}function L(A){return S(A)||b(A)||m(A)}function y(A,B){return B.length===0?B=[A]:A.end===B[0].start?B[0].start=A.start:B.unshift(A),B}function r(A,B){for(let V=B;V<A.length;V++){const G=A.charCodeAt(V);if(b(G)||m(G)||V>0&&!L(A.charCodeAt(V-1)))return V}return A.length}function f(A,B,V,G){if(V===A.length)return[];if(G===B.length)return null;if(A[V]!==B[G].toLowerCase())return null;{let ee=null,re=G+1;for(ee=f(A,B,V+1,G+1);!ee&&(re=r(B,re))<B.length;)ee=f(A,B,V+1,re),re++;return ee===null?null:y({start:G,end:G+1},ee)}}function E(A){let B=0,V=0,G=0,ee=0,re=0;for(let Te=0;Te<A.length;Te++)re=A.charCodeAt(Te),b(re)&&B++,S(re)&&V++,L(re)&&G++,m(re)&&ee++;const he=B/A.length,ye=V/A.length,we=G/A.length,Ie=ee/A.length;return{upperPercent:he,lowerPercent:ye,alphaPercent:we,numericPercent:Ie}}function I(A){const{upperPercent:B,lowerPercent:V}=A;return V===0&&B>.6}function H(A){const{upperPercent:B,lowerPercent:V,alphaPercent:G,numericPercent:ee}=A;return V>.2&&B<.8&&G>.6&&ee<.2}function z(A){let B=0,V=0,G=0,ee=0;for(let re=0;re<A.length;re++)G=A.charCodeAt(re),b(G)&&B++,S(G)&&V++,e(G)&&ee++;return(B===0||V===0)&&ee===0?A.length<=30:B<=5}function U(A,B){if(!B||(B=B.trim(),B.length===0)||!z(A))return null;B.length>60&&(B=B.substring(0,60));const V=E(B);if(!H(V)){if(!I(V))return null;B=B.toLowerCase()}let G=null,ee=0;for(A=A.toLowerCase();ee<B.length&&(G=f(A,B,0,ee))===null;)ee=r(B,ee+1);return G}function v(A,B,V=!1){if(!B||B.length===0)return null;let G=null,ee=0;for(A=A.toLowerCase(),B=B.toLowerCase();ee<B.length&&(G=k(A,B,0,ee,V),G===null);)ee=x(B,ee+1);return G}function k(A,B,V,G,ee){let re=0;if(V===A.length)return[];if(G===B.length)return null;if(!c(A.charCodeAt(V),B.charCodeAt(G))){const we=p(A.charCodeAt(V));if(!we)return null;for(let Ie=0;Ie<we.length;Ie++)if(!c(we[Ie],B.charCodeAt(G+Ie)))return null;re+=we.length-1}let he=null,ye=G+re+1;if(he=k(A,B,V+1,ye,ee),!ee)for(;!he&&(ye=x(B,ye))<B.length;)he=k(A,B,V+1,ye,ee),ye++;if(!he)return null;if(A.charCodeAt(V)!==B.charCodeAt(G)){const we=p(A.charCodeAt(V));if(!we)return he;for(let Ie=0;Ie<we.length;Ie++)if(we[Ie]!==B.charCodeAt(G+Ie))return he}return y({start:G,end:G+re+1},he)}function x(A,B){for(let V=B;V<A.length;V++)if(o(A.charCodeAt(V))||V>0&&o(A.charCodeAt(V-1)))return V;return A.length}const N=T(t.matchesPrefix,U,_),M=T(t.matchesPrefix,U,d),$=new n.LRUCache(1e4);function ne(A,B,V=!1){if(typeof A!="string"||typeof B!="string")return null;let G=$.get(A);G||(G=new RegExp(O.convertSimple2RegExpPattern(A),"i"),$.set(A,G));const ee=G.exec(B);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:V?M(A,B):N(A,B)}function Z(A,B){const V=l(A,A.toLowerCase(),0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?te(V):null}function Y(A,B,V,G,ee,re){const he=Math.min(13,A.length);for(;V<he;V++){const ye=l(A,B,V,G,ee,re,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,re]}function te(A){if(typeof A>"u")return[];const B=[],V=A[1];for(let G=A.length-1;G>1;G--){const ee=A[G]+V,re=B[B.length-1];re&&re.end===ee?re.end=ee+1:B.push({start:ee,end:ee+1})}return B}const fe=128;function Ee(){const A=[],B=[];for(let V=0;V<=fe;V++)B[V]=0;for(let V=0;V<=fe;V++)A.push(B.slice(0));return A}function Fe(A){const B=[];for(let V=0;V<=A;V++)B[V]=0;return B}const Ae=Fe(2*fe),ue=Fe(2*fe),J=Ee(),de=Ee(),ae=Ee(),Le=!1;function Q(A,B,V,G,ee){function re(ye,we,Ie=" "){for(;ye.length<we;)ye=Ie+ye;return ye}let he=` |   |${G.split("").map(ye=>re(ye,3)).join("|")}
`;for(let ye=0;ye<=V;ye++)ye===0?he+=" |":he+=`${B[ye-1]}|`,he+=A[ye].slice(0,ee+1).map(we=>re(we.toString(),3)).join("|")+`
`;return he}function me(A,B,V,G){A=A.substr(B),V=V.substr(G),console.log(Q(de,A,A.length,V,V.length)),console.log(Q(ae,A,A.length,V,V.length)),console.log(Q(J,A,A.length,V,V.length))}function _e(A,B){if(B<0||B>=A.length)return!1;const V=A.codePointAt(B);switch(V){case i.CharCode.Underline:case i.CharCode.Dash:case i.CharCode.Period:case i.CharCode.Space:case i.CharCode.Slash:case i.CharCode.Backslash:case i.CharCode.SingleQuote:case i.CharCode.DoubleQuote:case i.CharCode.Colon:case i.CharCode.DollarSign:case i.CharCode.LessThan:case i.CharCode.GreaterThan:case i.CharCode.OpenParen:case i.CharCode.CloseParen:case i.CharCode.OpenSquareBracket:case i.CharCode.CloseSquareBracket:case i.CharCode.OpenCurlyBrace:case i.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.isEmojiImprecise(V)}}function Oe(A,B){if(B<0||B>=A.length)return!1;switch(A.charCodeAt(B)){case i.CharCode.Space:case i.CharCode.Tab:return!0;default:return!1}}function Ce(A,B,V){return B[A]!==V[A]}function Be(A,B,V,G,ee,re,he=!1){for(;B<V&&ee<re;)A[B]===G[ee]&&(he&&(Ae[B]=ee),B+=1),ee+=1;return B===V}var ie;(function(A){A[A.Diag=1]="Diag",A[A.Left=2]="Left",A[A.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var q;(function(A){A.Default=[-100,0];function B(V){return!V||V.length===2&&V[0]===-100&&V[1]===0}A.isDefault=B})(q||(t.FuzzyScore=q={}));class W{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(B,V){this.firstMatchCanBeWeak=B,this.boostFullMatch=V}}t.FuzzyScoreOptions=W;function l(A,B,V,G,ee,re,he=W.default){const ye=A.length>fe?fe:A.length,we=G.length>fe?fe:G.length;if(V>=ye||re>=we||ye-V>we-re||!Be(B,V,ye,ee,re,we,!0))return;a(ye,we,V,re,B,ee);let Ie=1,Te=1,ce=V,Re=re;const Ue=[!1];for(Ie=1,ce=V;ce<ye;Ie++,ce++){const $e=Ae[ce],Ze=ue[ce],X=ce+1<ye?ue[ce+1]:we;for(Te=$e-re+1,Re=$e;Re<X;Te++,Re++){let le=Number.MIN_SAFE_INTEGER,be=!1;Re<=Ze&&(le=g(A,B,ce,V,G,ee,Re,we,re,J[Ie-1][Te-1]===0,Ue));let Se=0;le!==Number.MAX_SAFE_INTEGER&&(be=!0,Se=le+de[Ie-1][Te-1]);const Me=Re>$e,ze=Me?de[Ie][Te-1]+(J[Ie][Te-1]>0?-5:0):0,Qe=Re>$e+1&&J[Ie][Te-1]>0,st=Qe?de[Ie][Te-2]+(J[Ie][Te-2]>0?-5:0):0;if(Qe&&(!Me||st>=ze)&&(!be||st>=Se))de[Ie][Te]=st,ae[Ie][Te]=ie.LeftLeft,J[Ie][Te]=0;else if(Me&&(!be||ze>=Se))de[Ie][Te]=ze,ae[Ie][Te]=ie.Left,J[Ie][Te]=0;else if(be)de[Ie][Te]=Se,ae[Ie][Te]=ie.Diag,J[Ie][Te]=J[Ie-1][Te-1]+1;else throw new Error("not possible")}}if(Le&&me(A,V,G,re),!Ue[0]&&!he.firstMatchCanBeWeak)return;Ie--,Te--;const Ye=[de[Ie][Te],re];let et=0,ot=0;for(;Ie>=1;){let $e=Te;do{const Ze=ae[Ie][$e];if(Ze===ie.LeftLeft)$e=$e-2;else if(Ze===ie.Left)$e=$e-1;else break}while($e>=1);et>1&&B[V+Ie-1]===ee[re+Te-1]&&!Ce($e+re-1,G,ee)&&et+1>J[Ie][$e]&&($e=Te),$e===Te?et++:et=1,ot||(ot=$e),Ie--,Te=$e-1,Ye.push(Te)}we-re===ye&&he.boostFullMatch&&(Ye[0]+=2);const it=ot-ye;return Ye[0]-=it,Ye}function a(A,B,V,G,ee,re){let he=A-1,ye=B-1;for(;he>=V&&ye>=G;)ee[he]===re[ye]&&(ue[he]=ye,he--),ye--}function g(A,B,V,G,ee,re,he,ye,we,Ie,Te){if(B[V]!==re[he])return Number.MIN_SAFE_INTEGER;let ce=1,Re=!1;return he===V-G?ce=A[V]===ee[he]?7:5:Ce(he,ee,re)&&(he===0||!Ce(he-1,ee,re))?(ce=A[V]===ee[he]?7:5,Re=!0):_e(re,he)&&(he===0||!_e(re,he-1))?ce=5:(_e(re,he-1)||Oe(re,he-1))&&(ce=5,Re=!0),ce>1&&V===G&&(Te[0]=!0),Re||(Re=Ce(he,ee,re)||_e(re,he-1)||Oe(re,he-1)),V===G?he>we&&(ce-=Re?3:5):Ie?ce+=Re?2:0:ce+=Re?0:1,he+1===ye&&(ce-=Re?3:5),ce}function C(A,B,V,G,ee,re,he){return u(A,B,V,G,ee,re,!0,he)}function R(A,B,V,G,ee,re,he){return u(A,B,V,G,ee,re,!1,he)}function u(A,B,V,G,ee,re,he,ye){let we=l(A,B,V,G,ee,re,ye);if(we&&!he)return we;if(A.length>=3){const Ie=Math.min(7,A.length-1);for(let Te=V+1;Te<Ie;Te++){const ce=F(A,Te);if(ce){const Re=l(ce,ce.toLowerCase(),V,G,ee,re,ye);Re&&(Re[0]-=3,(!we||Re[0]>we[0])&&(we=Re))}}}return we}function F(A,B){if(B+1>=A.length)return;const V=A[B],G=A[B+1];if(V!==G)return A.slice(0,B)+G+V+A.slice(B+2)}}),define(ve[65],De([1,0,11]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=void 0,t.hash=n,t.doHash=P,t.numberHash=O,t.stringHash=w,t.toHexString=s;function n(c){return P(c,0)}function P(c,h){switch(typeof c){case"object":return c===null?O(349,h):Array.isArray(c)?_(c,h):d(c,h);case"string":return w(c,h);case"boolean":return T(c,h);case"number":return O(c,h);case"undefined":return O(937,h);default:return O(617,h)}}function O(c,h){return(h<<5)-h+c|0}function T(c,h){return O(c?433:863,h)}function w(c,h){h=O(149417,h);for(let p=0,L=c.length;p<L;p++)h=O(c.charCodeAt(p),h);return h}function _(c,h){return h=O(104579,h),c.reduce((p,L)=>P(L,p),h)}function d(c,h){return h=O(181387,h),Object.keys(c).sort().reduce((p,L)=>(p=w(L,p),P(c[L],p)),h)}class D{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=P(h,this._value),this._value}}t.Hasher=D;var S;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function b(c,h,p=32){const L=p-h,y=~((1<<L)-1);return(c<<h|(y&c)>>>L)>>>0}function m(c,h=0,p=c.byteLength,L=0){for(let y=0;y<p;y++)c[h+y]=L}function e(c,h,p="0"){for(;c.length<h;)c=p+c;return c}function s(c,h=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(p=>p.toString(16).padStart(2,"0")).join(""):e((c>>>0).toString(16),h/4)}class o{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(S.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const p=h.length;if(p===0)return;const L=this._buff;let y=this._buffLen,r=this._leftoverHighSurrogate,f,E;for(r!==0?(f=r,E=-1,r=0):(f=h.charCodeAt(0),E=0);;){let I=f;if(i.isHighSurrogate(f))if(E+1<p){const H=h.charCodeAt(E+1);i.isLowSurrogate(H)?(E++,I=i.computeCodePoint(f,H)):I=S.UNICODE_REPLACEMENT}else{r=f;break}else i.isLowSurrogate(f)&&(I=S.UNICODE_REPLACEMENT);if(y=this._push(L,y,I),E++,E<p)f=h.charCodeAt(E);else break}this._buffLen=y,this._leftoverHighSurrogate=r}_push(h,p,L){return L<128?h[p++]=L:L<2048?(h[p++]=192|(L&1984)>>>6,h[p++]=128|(L&63)>>>0):L<65536?(h[p++]=224|(L&61440)>>>12,h[p++]=128|(L&4032)>>>6,h[p++]=128|(L&63)>>>0):(h[p++]=240|(L&1835008)>>>18,h[p++]=128|(L&258048)>>>12,h[p++]=128|(L&4032)>>>6,h[p++]=128|(L&63)>>>0),p>=S.BLOCK_SIZE&&(this._step(),p-=S.BLOCK_SIZE,this._totalLen+=S.BLOCK_SIZE,h[0]=h[S.BLOCK_SIZE+0],h[1]=h[S.BLOCK_SIZE+1],h[2]=h[S.BLOCK_SIZE+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,S.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=o._bigBlock32,p=this._buffDV;for(let U=0;U<64;U+=4)h.setUint32(U,p.getUint32(U,!1),!1);for(let U=64;U<320;U+=4)h.setUint32(U,b(h.getUint32(U-12,!1)^h.getUint32(U-32,!1)^h.getUint32(U-56,!1)^h.getUint32(U-64,!1),1),!1);let L=this._h0,y=this._h1,r=this._h2,f=this._h3,E=this._h4,I,H,z;for(let U=0;U<80;U++)U<20?(I=y&r|~y&f,H=1518500249):U<40?(I=y^r^f,H=1859775393):U<60?(I=y&r|y&f|r&f,H=2400959708):(I=y^r^f,H=3395469782),z=b(L,5)+I+E+H+h.getUint32(U*4,!1)&4294967295,E=f,f=r,r=b(y,30),y=L,L=z;this._h0=this._h0+L&4294967295,this._h1=this._h1+y&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+f&4294967295,this._h4=this._h4+E&4294967295}}t.StringSHA1=o}),define(ve[103],De([1,0,90,65,64]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.StringDiffSequence=void 0,t.stringDiff=T;class O{constructor(m){this.source=m}getElements(){const m=this.source,e=new Int32Array(m.length);for(let s=0,o=m.length;s<o;s++)e[s]=m.charCodeAt(s);return e}}t.StringDiffSequence=O;function T(b,m,e){return new S(new O(b),new O(m)).ComputeDiff(e).changes}class w{static Assert(m,e){if(!m)throw new Error(e)}}class _{static Copy(m,e,s,o,c){for(let h=0;h<c;h++)s[o+h]=m[e+h]}static Copy2(m,e,s,o,c){for(let h=0;h<c;h++)s[o+h]=m[e+h]}}var d;(function(b){b[b.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(d||(d={}));class D{constructor(){this.m_changes=[],this.m_originalStart=P.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=P.Constants.MAX_SAFE_SMALL_INTEGER,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new i.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=P.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=P.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(m,e){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_originalCount++}AddModifiedElement(m,e){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class S{constructor(m,e,s=null){this.ContinueProcessingPredicate=s,this._originalSequence=m,this._modifiedSequence=e;const[o,c,h]=S._getElements(m),[p,L,y]=S._getElements(e);this._hasStrings=h&&y,this._originalStringElements=o,this._originalElementsOrHash=c,this._modifiedStringElements=p,this._modifiedElementsOrHash=L,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(m){return m.length>0&&typeof m[0]=="string"}static _getElements(m){const e=m.getElements();if(S._isStringArray(e)){const s=new Int32Array(e.length);for(let o=0,c=e.length;o<c;o++)s[o]=(0,n.stringHash)(e[o],0);return[e,s,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}ElementsAreEqual(m,e){return this._originalElementsOrHash[m]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[m]===this._modifiedStringElements[e]:!0}ElementsAreStrictEqual(m,e){if(!this.ElementsAreEqual(m,e))return!1;const s=S._getStrictElement(this._originalSequence,m),o=S._getStrictElement(this._modifiedSequence,e);return s===o}static _getStrictElement(m,e){return typeof m.getStrictElement=="function"?m.getStrictElement(e):null}OriginalElementsAreEqual(m,e){return this._originalElementsOrHash[m]!==this._originalElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[m]===this._originalStringElements[e]:!0}ModifiedElementsAreEqual(m,e){return this._modifiedElementsOrHash[m]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._modifiedStringElements[m]===this._modifiedStringElements[e]:!0}ComputeDiff(m){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,m)}_ComputeDiff(m,e,s,o,c){const h=[!1];let p=this.ComputeDiffRecursive(m,e,s,o,h);return c&&(p=this.PrettifyChanges(p)),{quitEarly:h[0],changes:p}}ComputeDiffRecursive(m,e,s,o,c){for(c[0]=!1;m<=e&&s<=o&&this.ElementsAreEqual(m,s);)m++,s++;for(;e>=m&&o>=s&&this.ElementsAreEqual(e,o);)e--,o--;if(m>e||s>o){let f;return s<=o?(w.Assert(m===e+1,"originalStart should only be one more than originalEnd"),f=[new i.DiffChange(m,0,s,o-s+1)]):m<=e?(w.Assert(s===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[new i.DiffChange(m,e-m+1,s,0)]):(w.Assert(m===e+1,"originalStart should only be one more than originalEnd"),w.Assert(s===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const h=[0],p=[0],L=this.ComputeRecursionPoint(m,e,s,o,h,p,c),y=h[0],r=p[0];if(L!==null)return L;if(!c[0]){const f=this.ComputeDiffRecursive(m,y,s,r,c);let E=[];return c[0]?E=[new i.DiffChange(y+1,e-(y+1)+1,r+1,o-(r+1)+1)]:E=this.ComputeDiffRecursive(y+1,e,r+1,o,c),this.ConcatenateChanges(f,E)}return[new i.DiffChange(m,e-m+1,s,o-s+1)]}WALKTRACE(m,e,s,o,c,h,p,L,y,r,f,E,I,H,z,U,v,k){let x=null,N=null,M=new D,$=e,ne=s,Z=I[0]-U[0]-o,Y=P.Constants.MIN_SAFE_SMALL_INTEGER,te=this.m_forwardHistory.length-1;do{const fe=Z+m;fe===$||fe<ne&&y[fe-1]<y[fe+1]?(f=y[fe+1],H=f-Z-o,f<Y&&M.MarkNextChange(),Y=f,M.AddModifiedElement(f+1,H),Z=fe+1-m):(f=y[fe-1]+1,H=f-Z-o,f<Y&&M.MarkNextChange(),Y=f-1,M.AddOriginalElement(f,H+1),Z=fe-1-m),te>=0&&(y=this.m_forwardHistory[te],m=y[0],$=1,ne=y.length-1)}while(--te>=-1);if(x=M.getReverseChanges(),k[0]){let fe=I[0]+1,Ee=U[0]+1;if(x!==null&&x.length>0){const Fe=x[x.length-1];fe=Math.max(fe,Fe.getOriginalEnd()),Ee=Math.max(Ee,Fe.getModifiedEnd())}N=[new i.DiffChange(fe,E-fe+1,Ee,z-Ee+1)]}else{M=new D,$=h,ne=p,Z=I[0]-U[0]-L,Y=P.Constants.MAX_SAFE_SMALL_INTEGER,te=v?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const fe=Z+c;fe===$||fe<ne&&r[fe-1]>=r[fe+1]?(f=r[fe+1]-1,H=f-Z-L,f>Y&&M.MarkNextChange(),Y=f+1,M.AddOriginalElement(f+1,H+1),Z=fe+1-c):(f=r[fe-1],H=f-Z-L,f>Y&&M.MarkNextChange(),Y=f,M.AddModifiedElement(f+1,H+1),Z=fe-1-c),te>=0&&(r=this.m_reverseHistory[te],c=r[0],$=1,ne=r.length-1)}while(--te>=-1);N=M.getChanges()}return this.ConcatenateChanges(x,N)}ComputeRecursionPoint(m,e,s,o,c,h,p){let L=0,y=0,r=0,f=0,E=0,I=0;m--,s--,c[0]=0,h[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const H=e-m+(o-s),z=H+1,U=new Int32Array(z),v=new Int32Array(z),k=o-s,x=e-m,N=m-s,M=e-o,ne=(x-k)%2===0;U[k]=m,v[x]=e,p[0]=!1;for(let Z=1;Z<=H/2+1;Z++){let Y=0,te=0;r=this.ClipDiagonalBound(k-Z,Z,k,z),f=this.ClipDiagonalBound(k+Z,Z,k,z);for(let Ee=r;Ee<=f;Ee+=2){Ee===r||Ee<f&&U[Ee-1]<U[Ee+1]?L=U[Ee+1]:L=U[Ee-1]+1,y=L-(Ee-k)-N;const Fe=L;for(;L<e&&y<o&&this.ElementsAreEqual(L+1,y+1);)L++,y++;if(U[Ee]=L,L+y>Y+te&&(Y=L,te=y),!ne&&Math.abs(Ee-x)<=Z-1&&L>=v[Ee])return c[0]=L,h[0]=y,Fe<=v[Ee]&&d.MaxDifferencesHistory>0&&Z<=d.MaxDifferencesHistory+1?this.WALKTRACE(k,r,f,N,x,E,I,M,U,v,L,e,c,y,o,h,ne,p):null}const fe=(Y-m+(te-s)-Z)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(Y,fe))return p[0]=!0,c[0]=Y,h[0]=te,fe>0&&d.MaxDifferencesHistory>0&&Z<=d.MaxDifferencesHistory+1?this.WALKTRACE(k,r,f,N,x,E,I,M,U,v,L,e,c,y,o,h,ne,p):(m++,s++,[new i.DiffChange(m,e-m+1,s,o-s+1)]);E=this.ClipDiagonalBound(x-Z,Z,x,z),I=this.ClipDiagonalBound(x+Z,Z,x,z);for(let Ee=E;Ee<=I;Ee+=2){Ee===E||Ee<I&&v[Ee-1]>=v[Ee+1]?L=v[Ee+1]-1:L=v[Ee-1],y=L-(Ee-x)-M;const Fe=L;for(;L>m&&y>s&&this.ElementsAreEqual(L,y);)L--,y--;if(v[Ee]=L,ne&&Math.abs(Ee-k)<=Z&&L<=U[Ee])return c[0]=L,h[0]=y,Fe>=U[Ee]&&d.MaxDifferencesHistory>0&&Z<=d.MaxDifferencesHistory+1?this.WALKTRACE(k,r,f,N,x,E,I,M,U,v,L,e,c,y,o,h,ne,p):null}if(Z<=d.MaxDifferencesHistory){let Ee=new Int32Array(f-r+2);Ee[0]=k-r+1,_.Copy2(U,r,Ee,1,f-r+1),this.m_forwardHistory.push(Ee),Ee=new Int32Array(I-E+2),Ee[0]=x-E+1,_.Copy2(v,E,Ee,1,I-E+1),this.m_reverseHistory.push(Ee)}}return this.WALKTRACE(k,r,f,N,x,E,I,M,U,v,L,e,c,y,o,h,ne,p)}PrettifyChanges(m){for(let e=0;e<m.length;e++){const s=m[e],o=e<m.length-1?m[e+1].originalStart:this._originalElementsOrHash.length,c=e<m.length-1?m[e+1].modifiedStart:this._modifiedElementsOrHash.length,h=s.originalLength>0,p=s.modifiedLength>0;for(;s.originalStart+s.originalLength<o&&s.modifiedStart+s.modifiedLength<c&&(!h||this.OriginalElementsAreEqual(s.originalStart,s.originalStart+s.originalLength))&&(!p||this.ModifiedElementsAreEqual(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const y=this.ElementsAreStrictEqual(s.originalStart,s.modifiedStart);if(this.ElementsAreStrictEqual(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!y)break;s.originalStart++,s.modifiedStart++}const L=[null];if(e<m.length-1&&this.ChangesOverlap(m[e],m[e+1],L)){m[e]=L[0],m.splice(e+1,1),e--;continue}}for(let e=m.length-1;e>=0;e--){const s=m[e];let o=0,c=0;if(e>0){const f=m[e-1];o=f.originalStart+f.originalLength,c=f.modifiedStart+f.modifiedLength}const h=s.originalLength>0,p=s.modifiedLength>0;let L=0,y=this._boundaryScore(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let f=1;;f++){const E=s.originalStart-f,I=s.modifiedStart-f;if(E<o||I<c||h&&!this.OriginalElementsAreEqual(E,E+s.originalLength)||p&&!this.ModifiedElementsAreEqual(I,I+s.modifiedLength))break;const z=(E===o&&I===c?5:0)+this._boundaryScore(E,s.originalLength,I,s.modifiedLength);z>y&&(y=z,L=f)}s.originalStart-=L,s.modifiedStart-=L;const r=[null];if(e>0&&this.ChangesOverlap(m[e-1],m[e],r)){m[e-1]=r[0],m.splice(e,1),e++;continue}}if(this._hasStrings)for(let e=1,s=m.length;e<s;e++){const o=m[e-1],c=m[e],h=c.originalStart-o.originalStart-o.originalLength,p=o.originalStart,L=c.originalStart+c.originalLength,y=L-p,r=o.modifiedStart,f=c.modifiedStart+c.modifiedLength,E=f-r;if(h<5&&y<20&&E<20){const I=this._findBetterContiguousSequence(p,y,r,E,h);if(I){const[H,z]=I;(H!==o.originalStart+o.originalLength||z!==o.modifiedStart+o.modifiedLength)&&(o.originalLength=H-o.originalStart,o.modifiedLength=z-o.modifiedStart,c.originalStart=H+h,c.modifiedStart=z+h,c.originalLength=L-c.originalStart,c.modifiedLength=f-c.modifiedStart)}}}return m}_findBetterContiguousSequence(m,e,s,o,c){if(e<c||o<c)return null;const h=m+e-c+1,p=s+o-c+1;let L=0,y=0,r=0;for(let f=m;f<h;f++)for(let E=s;E<p;E++){const I=this._contiguousSequenceScore(f,E,c);I>0&&I>L&&(L=I,y=f,r=E)}return L>0?[y,r]:null}_contiguousSequenceScore(m,e,s){let o=0;for(let c=0;c<s;c++){if(!this.ElementsAreEqual(m+c,e+c))return 0;o+=this._originalStringElements[m+c].length}return o}_OriginalIsBoundary(m){return m<=0||m>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[m])}_OriginalRegionIsBoundary(m,e){if(this._OriginalIsBoundary(m)||this._OriginalIsBoundary(m-1))return!0;if(e>0){const s=m+e;if(this._OriginalIsBoundary(s-1)||this._OriginalIsBoundary(s))return!0}return!1}_ModifiedIsBoundary(m){return m<=0||m>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[m])}_ModifiedRegionIsBoundary(m,e){if(this._ModifiedIsBoundary(m)||this._ModifiedIsBoundary(m-1))return!0;if(e>0){const s=m+e;if(this._ModifiedIsBoundary(s-1)||this._ModifiedIsBoundary(s))return!0}return!1}_boundaryScore(m,e,s,o){const c=this._OriginalRegionIsBoundary(m,e)?1:0,h=this._ModifiedRegionIsBoundary(s,o)?1:0;return c+h}ConcatenateChanges(m,e){const s=[];if(m.length===0||e.length===0)return e.length>0?e:m;if(this.ChangesOverlap(m[m.length-1],e[0],s)){const o=new Array(m.length+e.length-1);return _.Copy(m,0,o,0,m.length-1),o[m.length-1]=s[0],_.Copy(e,1,o,m.length,e.length-1),o}else{const o=new Array(m.length+e.length);return _.Copy(m,0,o,0,m.length),_.Copy(e,0,o,m.length,e.length),o}}ChangesOverlap(m,e,s){if(w.Assert(m.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),w.Assert(m.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=e.originalStart||m.modifiedStart+m.modifiedLength>=e.modifiedStart){const o=m.originalStart;let c=m.originalLength;const h=m.modifiedStart;let p=m.modifiedLength;return m.originalStart+m.originalLength>=e.originalStart&&(c=e.originalStart+e.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=e.modifiedStart&&(p=e.modifiedStart+e.modifiedLength-m.modifiedStart),s[0]=new i.DiffChange(o,c,h,p),!0}else return s[0]=null,!1}ClipDiagonalBound(m,e,s,o){if(m>=0&&m<o)return m;const c=s,h=o-s-1,p=e%2===0;if(m<0){const L=c%2===0;return p===L?0:1}else{const L=h%2===0;return p===L?o-1:o-2}}}t.LcsDiff=S}),define(ve[66],De([1,0,50,11,22]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.escapeIcons=_,t.markdownEscapeEscapedIcons=D,t.stripIcons=b,t.getCodiconAriaLabel=m,t.parseLabelWithIcons=s,t.matchesFuzzyIconAware=o;const O="$(",T=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${T.source}`,"g");function _(c){return c.replace(w,(h,p)=>p?h:`\\${h}`)}const d=new RegExp(`\\\\${T.source}`,"g");function D(c){return c.replace(d,h=>`\\${h}`)}const S=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function b(c){return c.indexOf(O)===-1?c:c.replace(S,(h,p,L,y)=>L?h:p||y||"")}function m(c){return c?c.replace(/\$\((.*?)\)/g,(h,p)=>` ${p} `).trim():""}const e=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(c){e.lastIndex=0;let h="";const p=[];let L=0;for(;;){const y=e.lastIndex,r=e.exec(c),f=c.substring(y,r?.index);if(f.length>0){h+=f;for(let E=0;E<f.length;E++)p.push(L)}if(!r)break;L+=r[0].length}return{text:h,iconOffsets:p}}function o(c,h,p=!1){const{text:L,iconOffsets:y}=h;if(!y||y.length===0)return(0,i.matchesFuzzy)(c,L,p);const r=(0,n.ltrim)(L," "),f=L.length-r.length,E=(0,i.matchesFuzzy)(c,r,p);if(E)for(const I of E){const H=y[I.start+f]+f;I.start+=H,I.end+=H}return E}}),define(ve[104],De([1,0,9,18,11]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class O{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){const s=e.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}t.StringIterator=O;class T{constructor(e=!0){this._caseSensitive=e}reset(e){return this._value=e,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===n.CharCode.Period)if(e)this._from++;else break;else e=!1;return this}cmp(e){return this._caseSensitive?(0,P.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=T;class w{constructor(e=!0,s=!0){this._splitOnBackslash=e,this._caseSensitive=s}reset(e){this._from=0,this._to=0,this._value=e,this._valueLen=e.length;for(let s=e.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===n.CharCode.Slash||this._splitOnBackslash&&o===n.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let e=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===n.CharCode.Slash||this._splitOnBackslash&&s===n.CharCode.Backslash)if(e)this._from++;else break;else e=!1}return this}cmp(e){return this._caseSensitive?(0,P.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=w;var _;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(_||(_={}));class d{constructor(e,s){this._ignorePathCasing=e,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(e){return this._value=e,this._states=[],this._value.scheme&&this._states.push(_.Scheme),this._value.authority&&this._states.push(_.Authority),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(e)),this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(_.Path)),this._ignoreQueryAndFragment(e)||(this._value.query&&this._states.push(_.Query),this._value.fragment&&this._states.push(_.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===_.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===_.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(this._states[this._stateIdx]===_.Scheme)return(0,P.compareIgnoreCase)(e,this._value.scheme);if(this._states[this._stateIdx]===_.Authority)return(0,P.compareIgnoreCase)(e,this._value.authority);if(this._states[this._stateIdx]===_.Path)return this._pathIterator.cmp(e);if(this._states[this._stateIdx]===_.Query)return(0,P.compare)(e,this._value.query);if(this._states[this._stateIdx]===_.Fragment)return(0,P.compare)(e,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===_.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===_.Authority)return this._value.authority;if(this._states[this._stateIdx]===_.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===_.Query)return this._value.query;if(this._states[this._stateIdx]===_.Fragment)return this._value.fragment;throw new Error}}t.UriIterator=d;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(S||(S={}));class b{static forUris(e=()=>!1,s=()=>!1){return new b(new d(e,s))}static forPaths(e=!1){return new b(new w(void 0,!e))}static forStrings(){return new b(new O)}static forConfigKeys(){return new b(new T)}constructor(e){this._iter=e}clear(){this._root=void 0}fill(e,s){if(s){const o=s.slice(0);(0,i.shuffle)(o);for(const c of o)this.set(c,e)}else{const o=e.slice(0);(0,i.shuffle)(o);for(const c of o)this.set(c[0],c[1])}}set(e,s){const o=this._iter.reset(e);let c;this._root||(this._root=new D,this._root.segment=o.value());const h=[];for(c=this._root;;){const L=o.cmp(c.segment);if(L>0)c.left||(c.left=new D,c.left.segment=o.value()),h.push([S.Left,c]),c=c.left;else if(L<0)c.right||(c.right=new D,c.right.segment=o.value()),h.push([S.Right,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new D,c.mid.segment=o.value()),h.push([S.Mid,c]),c=c.mid;else break}const p=c.value;c.value=s,c.key=e;for(let L=h.length-1;L>=0;L--){const y=h[L][1];y.updateHeight();const r=y.balanceFactor();if(r<-1||r>1){const f=h[L][0],E=h[L+1][0];if(f===S.Right&&E===S.Right)h[L][1]=y.rotateLeft();else if(f===S.Left&&E===S.Left)h[L][1]=y.rotateRight();else if(f===S.Right&&E===S.Left)y.right=h[L+1][1]=h[L+1][1].rotateRight(),h[L][1]=y.rotateLeft();else if(f===S.Left&&E===S.Right)y.left=h[L+1][1]=h[L+1][1].rotateLeft(),h[L][1]=y.rotateRight();else throw new Error;if(L>0)switch(h[L-1][0]){case S.Left:h[L-1][1].left=h[L][1];break;case S.Right:h[L-1][1].right=h[L][1];break;case S.Mid:h[L-1][1].mid=h[L][1];break}else this._root=h[0][1]}}return p}get(e){return this._getNode(e)?.value}_getNode(e){const s=this._iter.reset(e);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(e){const s=this._getNode(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this._delete(e,!1)}deleteSuperstr(e){return this._delete(e,!0)}_delete(e,s){const o=this._iter.reset(e),c=[];let h=this._root;for(;h;){const p=o.cmp(h.segment);if(p>0)c.push([S.Left,h]),h=h.left;else if(p<0)c.push([S.Right,h]),h=h.right;else if(o.hasNext())o.next(),c.push([S.Mid,h]),h=h.mid;else break}if(h){if(s?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const p=this._min(h.right);if(p.key){const{key:L,value:y,segment:r}=p;this._delete(p.key,!1),h.key=L,h.value=y,h.segment=r}}else{const p=h.left??h.right;if(c.length>0){const[L,y]=c[c.length-1];switch(L){case S.Left:y.left=p;break;case S.Mid:y.mid=p;break;case S.Right:y.right=p;break}}else this._root=p}for(let p=c.length-1;p>=0;p--){const L=c[p][1];L.updateHeight();const y=L.balanceFactor();if(y>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),c[p][1]=L.rotateLeft()):y<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),c[p][1]=L.rotateRight()),p>0)switch(c[p-1][0]){case S.Left:c[p-1][1].left=c[p][1];break;case S.Right:c[p-1][1].right=c[p][1];break;case S.Mid:c[p-1][1].mid=c[p][1];break}else this._root=c[0][1]}}}_min(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this._iter.reset(e);let o=this._root,c;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(e){return this._findSuperstrOrElement(e,!1)}_findSuperstrOrElement(e,s){const o=this._iter.reset(e);let c=this._root;for(;c;){const h=o.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else return c.mid?this._entries(c.mid):s?c.value:void 0}}hasElementOrSubtree(e){return this._findSuperstrOrElement(e,!0)!==void 0}forEach(e){for(const[s,o]of this)e(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(e){const s=[];return this._dfsEntries(e,s),s[Symbol.iterator]()}_dfsEntries(e,s){e&&(e.left&&this._dfsEntries(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this._dfsEntries(e.mid,s),e.right&&this._dfsEntries(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:e(s.left)&&e(s.right)};return e(this._root)}}t.TernarySearchTree=b}),define(ve[105],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ve[106],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class i{constructor(P,O){this.sender=P,this.onMessage=O}send(P){try{this.sender.send("vscode:message",P.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=i}),define(ve[38],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0;const i=globalThis.vscode;t.ipcRenderer=i.ipcRenderer,t.ipcMessagePort=i.ipcMessagePort,t.webFrame=i.webFrame,t.process=i.process,t.context=i.context}),define(ve[107],De([1,0,105,38]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=O;let P=0;function O(w,_,d){const D=[],S=P++,b=`vscode:onContextMenu${S}`,m=(e,s,o)=>{D[s].click?.(o)};n.ipcRenderer.once(b,m),n.ipcRenderer.once(i.CONTEXT_MENU_CLOSE_CHANNEL,(e,s)=>{s===S&&(n.ipcRenderer.removeListener(b,m),d?.())}),n.ipcRenderer.send(i.CONTEXT_MENU_CHANNEL,S,w.map(e=>T(e,D)),b,_)}function T(w,_){const d={id:_.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return _.push(w),Array.isArray(w.submenu)&&(d.submenu=w.submenu.map(D=>T(D,_))),d}}),define(ve[67],De([7]),{}),define(ve[108],De([7]),{}),define(ve[109],De([7]),{}),define(ve[110],De([7]),{}),define(ve[111],De([1,0,109,110]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ve[112],De([7]),{}),define(ve[113],De([7]),{}),define(ve[114],De([7]),{}),define(ve[115],De([7]),{}),define(ve[116],De([7]),{}),define(ve[117],De([7]),{}),define(ve[118],De([7]),{}),define(ve[119],De([7]),{}),define(ve[120],De([7]),{}),define(ve[121],De([7]),{}),define(ve[122],De([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ve[123],De([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/findinput/findInput",t)}),define(ve[124],De([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ve[125],De([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ve[126],De([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ve[127],De([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ve[128],De([14,13]),function(oe,t){return oe.create("vs/base/common/actions",t)}),define(ve[51],De([1,0,3,2,128]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0,t.toAction=D;class O extends n.Disposable{constructor(b,m="",e="",s=!0,o){super(),this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=b,this._label=m,this._cssClass=e,this._enabled=s,this._actionCallback=o}get id(){return this._id}get label(){return this._label}set label(b){this._setLabel(b)}_setLabel(b){this._label!==b&&(this._label=b,this._onDidChange.fire({label:b}))}get tooltip(){return this._tooltip||""}set tooltip(b){this._setTooltip(b)}_setTooltip(b){this._tooltip!==b&&(this._tooltip=b,this._onDidChange.fire({tooltip:b}))}get class(){return this._cssClass}set class(b){this._setClass(b)}_setClass(b){this._cssClass!==b&&(this._cssClass=b,this._onDidChange.fire({class:b}))}get enabled(){return this._enabled}set enabled(b){this._setEnabled(b)}_setEnabled(b){this._enabled!==b&&(this._enabled=b,this._onDidChange.fire({enabled:b}))}get checked(){return this._checked}set checked(b){this._setChecked(b)}_setChecked(b){this._checked!==b&&(this._checked=b,this._onDidChange.fire({checked:b}))}async run(b,m){this._actionCallback&&await this._actionCallback(b)}}t.Action=O;class T extends n.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new i.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new i.Emitter),this.onDidRun=this._onDidRun.event}async run(b,m){if(!b.enabled)return;this._onWillRun.fire({action:b});let e;try{await this.runAction(b,m)}catch(s){e=s}this._onDidRun.fire({action:b,error:e})}async runAction(b,m){await b.run(m)}}t.ActionRunner=T;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let m=[];for(const e of b)e.length&&(m.length?m=[...m,new w,...e]:m=e);return m}static{this.ID="vs.actions.separator"}async run(){}}t.Separator=w;class _{get actions(){return this._actions}constructor(b,m,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=m,this.class=s,this._actions=e}async run(){}}t.SubmenuAction=_;class d extends O{static{this.ID="vs.actions.empty"}constructor(){super(d.ID,P.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=d;function D(S){return{id:S.id,label:S.label,tooltip:S.tooltip??S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...b)=>S.run(...b)}}}),define(ve[129],De([14,13]),function(oe,t){return oe.create("vs/base/common/platform",t)}),define(ve[5],De([1,0,129]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=f,t.isLittleEndian=v,t.isBigSurOrNewer=k,t.LANGUAGE_DEFAULT="en";let n=!1,P=!1,O=!1,T=!1,w=!1,_=!1,d=!1,D=!1,S=!1,b=!1,m,e=t.LANGUAGE_DEFAULT,s=t.LANGUAGE_DEFAULT,o,c;const h=globalThis;let p;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?p=h.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(p=process);const L=typeof p?.versions?.electron=="string",y=L&&p?.type==="renderer";if(typeof p=="object"){n=p.platform==="win32",P=p.platform==="darwin",O=p.platform==="linux",T=O&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,d=L,S=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const x=p.env.VSCODE_NLS_CONFIG;if(x)try{const N=JSON.parse(x),M=N.availableLanguages["*"];m=N.locale,s=N.osLocale,e=M||t.LANGUAGE_DEFAULT,o=N._translationsConfigFile}catch{}w=!0}else typeof navigator=="object"&&!y?(c=navigator.userAgent,n=c.indexOf("Windows")>=0,P=c.indexOf("Macintosh")>=0,D=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=c.indexOf("Linux")>=0,b=c?.indexOf("Mobi")>=0,_=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.LANGUAGE_DEFAULT,e=m,s=navigator.language):console.error("Unable to resolve platform.");var r;(function(x){x[x.Web=0]="Web",x[x.Mac=1]="Mac",x[x.Linux=2]="Linux",x[x.Windows=3]="Windows"})(r||(t.Platform=r={}));function f(x){switch(x){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let E=r.Web;P?E=r.Mac:n?E=r.Windows:O&&(E=r.Linux),t.isWindows=n,t.isMacintosh=P,t.isLinux=O,t.isLinuxSnap=T,t.isNative=w,t.isElectron=d,t.isWeb=_,t.isWebWorker=_&&typeof h.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?h.origin:void 0,t.isIOS=D,t.isMobile=b,t.isCI=S,t.platform=E,t.userAgent=c,t.language=e;var I;(function(x){function N(){return t.language}x.value=N;function M(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}x.isDefaultVariant=M;function $(){return t.language==="en"}x.isDefault=$})(I||(t.Language=I={})),t.locale=m,t.platformLocale=s,t.translationsConfigFile=o,t.setTimeout0IsFaster=typeof h.postMessage=="function"&&!h.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const x=[];h.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let $=0,ne=x.length;$<ne;$++){const Z=x[$];if(Z.id===M.data.vscodeScheduleAsyncWork){x.splice($,1),Z.callback();return}}});let N=0;return M=>{const $=++N;x.push({id:$,callback:M}),h.postMessage({vscodeScheduleAsyncWork:$},"*")}}return x=>setTimeout(x)})();var H;(function(x){x[x.Windows=1]="Windows",x[x.Macintosh=2]="Macintosh",x[x.Linux=3]="Linux"})(H||(t.OperatingSystem=H={})),t.OS=P||D?H.Macintosh:n?H.Windows:H.Linux;let z=!0,U=!1;function v(){if(!U){U=!0;const x=new Uint8Array(2);x[0]=1,x[1]=2,z=new Uint16Array(x.buffer)[0]===513}return z}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function k(x){return parseFloat(x)>=20}}),define(ve[68],De([1,0,19,25,5]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var O;(function(T){T[T.Always=0]="Always",T[T.FullScreen=1]="FullScreen",T[T.None=2]="None"})(O||(t.KeyboardSupport=O={})),t.BrowserFeatures={clipboard:{writeText:P.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:P.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:P.isNative||i.isStandalone()?O.Always:navigator.keyboard||i.isSafari?O.FullScreen:O.None,touch:"ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0,pointerEvents:n.mainWindow.PointerEvent&&("ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0)}}),define(ve[23],De([1,0,19,85,5]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class O{constructor(d,D){this.timestamp=Date.now(),this.browserEvent=D,this.leftButton=D.button===0,this.middleButton=D.button===1,this.rightButton=D.button===2,this.buttons=D.buttons,this.target=D.target,this.detail=D.detail||1,D.type==="dblclick"&&(this.detail=2),this.ctrlKey=D.ctrlKey,this.shiftKey=D.shiftKey,this.altKey=D.altKey,this.metaKey=D.metaKey,typeof D.pageX=="number"?(this.posx=D.pageX,this.posy=D.pageY):(this.posx=D.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=D.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const S=n.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(d,D.view);this.posx-=S.left,this.posy-=S.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=O;class T extends O{constructor(d,D){super(d,D),this.dataTransfer=D.dataTransfer}}t.DragMouseEvent=T;class w{constructor(d,D=0,S=0){this.browserEvent=d||null,this.target=d?d.target||d.targetNode||d.srcElement:null,this.deltaY=S,this.deltaX=D;let b=!1;if(i.isChrome){const m=navigator.userAgent.match(/Chrome\/(\d+)/);b=(m?parseInt(m[1]):123)<=122}if(d){const m=d,e=d,s=d.view?.devicePixelRatio||1;if(typeof m.wheelDeltaY<"u")b?this.deltaY=m.wheelDeltaY/(120*s):this.deltaY=m.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(d.type==="wheel"){const o=d;o.deltaMode===o.DOM_DELTA_LINE?i.isFirefox&&!P.isMacintosh?this.deltaY=-d.deltaY/3:this.deltaY=-d.deltaY:this.deltaY=-d.deltaY/40}if(typeof m.wheelDeltaX<"u")i.isSafari&&P.isWindows?this.deltaX=-(m.wheelDeltaX/120):b?this.deltaX=m.wheelDeltaX/(120*s):this.deltaX=m.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-d.detail/3;else if(d.type==="wheel"){const o=d;o.deltaMode===o.DOM_DELTA_LINE?i.isFirefox&&!P.isMacintosh?this.deltaX=-d.deltaX/3:this.deltaX=-d.deltaX:this.deltaX=-d.deltaX/40}this.deltaY===0&&this.deltaX===0&&d.wheelDelta&&(b?this.deltaY=d.wheelDelta/(120*s):this.deltaY=d.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=w}),define(ve[130],De([1,0,6,8,5]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=void 0,t.decodeKeybinding=T,t.createSimpleKeybinding=w;var O;(function(m){m[m.CtrlCmd=2048]="CtrlCmd",m[m.Shift=1024]="Shift",m[m.Alt=512]="Alt",m[m.WinCtrl=256]="WinCtrl",m[m.KeyCode=255]="KeyCode"})(O||(O={}));function T(m,e){if(typeof m=="number"){if(m===0)return null;const s=(m&65535)>>>0,o=(m&4294901760)>>>16;return o!==0?new D([w(s,e),w(o,e)]):new D([w(s,e)])}else{const s=[];for(let o=0;o<m.length;o++)s.push(w(m[o],e));return new D(s)}}function w(m,e){const s=!!(m&O.CtrlCmd),o=!!(m&O.WinCtrl),c=e===P.OperatingSystem.Macintosh?o:s,h=!!(m&O.Shift),p=!!(m&O.Alt),L=e===P.OperatingSystem.Macintosh?s:o,y=m&O.KeyCode;return new _(c,h,p,L,y)}class _{constructor(e,s,o,c,h){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=c,this.keyCode=h}equals(e){return e instanceof _&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",o=this.altKey?"1":"0",c=this.metaKey?"1":"0";return`K${e}${s}${o}${c}${this.keyCode}`}isModifierKey(){return this.keyCode===n.KeyCode.Unknown||this.keyCode===n.KeyCode.Ctrl||this.keyCode===n.KeyCode.Meta||this.keyCode===n.KeyCode.Alt||this.keyCode===n.KeyCode.Shift}toKeybinding(){return new D([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===n.KeyCode.Ctrl||this.shiftKey&&this.keyCode===n.KeyCode.Shift||this.altKey&&this.keyCode===n.KeyCode.Alt||this.metaKey&&this.keyCode===n.KeyCode.Meta}}t.KeyCodeChord=_;class d{constructor(e,s,o,c,h){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=c,this.scanCode=h}equals(e){return e instanceof d&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.scanCode===e.scanCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",o=this.altKey?"1":"0",c=this.metaKey?"1":"0";return`S${e}${s}${o}${c}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===n.ScanCode.ControlLeft||this.scanCode===n.ScanCode.ControlRight)||this.shiftKey&&(this.scanCode===n.ScanCode.ShiftLeft||this.scanCode===n.ScanCode.ShiftRight)||this.altKey&&(this.scanCode===n.ScanCode.AltLeft||this.scanCode===n.ScanCode.AltRight)||this.metaKey&&(this.scanCode===n.ScanCode.MetaLeft||this.scanCode===n.ScanCode.MetaRight)}}t.ScanCodeChord=d;class D{constructor(e){if(e.length===0)throw(0,i.illegalArgument)("chords");this.chords=e}getHashCode(){let e="";for(let s=0,o=this.chords.length;s<o;s++)s!==0&&(e+=";"),e+=this.chords[s].getHashCode();return e}equals(e){if(e===null||this.chords.length!==e.chords.length)return!1;for(let s=0;s<this.chords.length;s++)if(!this.chords[s].equals(e.chords[s]))return!1;return!0}}t.Keybinding=D;class S{constructor(e,s,o,c,h,p){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=c,this.keyLabel=h,this.keyAriaLabel=p}}t.ResolvedChord=S;class b{}t.ResolvedKeybinding=b}),define(ve[16],De([1,0,19,8,130,5]),function(oe,t,i,n,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=void 0,t.printKeyboardEvent=S,t.printStandardKeyboardEvent=b;function T(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return n.KeyCodeUtils.fromString(o)}const s=e.keyCode;if(s===3)return n.KeyCode.PauseBreak;if(i.isFirefox)switch(s){case 59:return n.KeyCode.Semicolon;case 60:if(O.isLinux)return n.KeyCode.IntlBackslash;break;case 61:return n.KeyCode.Equal;case 107:return n.KeyCode.NumpadAdd;case 109:return n.KeyCode.NumpadSubtract;case 173:return n.KeyCode.Minus;case 224:if(O.isMacintosh)return n.KeyCode.Meta;break}else if(i.isWebKit){if(O.isMacintosh&&s===93)return n.KeyCode.Meta;if(!O.isMacintosh&&s===92)return n.KeyCode.Meta}return n.EVENT_KEY_CODE_MAP[s]||n.KeyCode.Unknown}const w=O.isMacintosh?n.KeyMod.WinCtrl:n.KeyMod.CtrlCmd,_=n.KeyMod.Alt,d=n.KeyMod.Shift,D=O.isMacintosh?n.KeyMod.CtrlCmd:n.KeyMod.WinCtrl;function S(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function b(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${n.KeyCodeUtils.toString(e.keyCode)}')`}class m{constructor(s){this._standardKeyboardEventBrand=!0;const o=s;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState?.("AltGraph"),this.keyCode=T(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===n.KeyCode.Ctrl,this.altKey=this.altKey||this.keyCode===n.KeyCode.Alt,this.shiftKey=this.shiftKey||this.keyCode===n.KeyCode.Shift,this.metaKey=this.metaKey||this.keyCode===n.KeyCode.Meta,this._asKeybinding=this._computeKeybinding(),this._asKeyCodeChord=this._computeKeyCodeChord()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this._asKeyCodeChord}equals(s){return this._asKeybinding===s}_computeKeybinding(){let s=n.KeyCode.Unknown;this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode);let o=0;return this.ctrlKey&&(o|=w),this.altKey&&(o|=_),this.shiftKey&&(o|=d),this.metaKey&&(o|=D),o|=s,o}_computeKeyCodeChord(){let s=n.KeyCode.Unknown;return this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode),new P.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.StandardKeyboardEvent=m}),define(ve[131],De([1,0,5]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let n;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const O=P.process;n={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=n.cwd,t.env=n.env,t.platform=n.platform,t.arch=n.arch}),define(ve[28],De([1,0,131]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const n=65,P=97,O=90,T=122,w=46,_=47,d=92,D=58,S=63;class b extends Error{constructor(f,E,I){let H;typeof E=="string"&&E.indexOf("not ")===0?(H="must not be",E=E.replace(/^not /,"")):H="must be";const z=f.indexOf(".")!==-1?"property":"argument";let U=`The "${f}" ${z} ${H} of type ${E}`;U+=`. Received type ${typeof I}`,super(U),this.code="ERR_INVALID_ARG_TYPE"}}function m(r,f){if(r===null||typeof r!="object")throw new b(f,"Object",r)}function e(r,f){if(typeof r!="string")throw new b(f,"string",r)}const s=i.platform==="win32";function o(r){return r===_||r===d}function c(r){return r===_}function h(r){return r>=n&&r<=O||r>=P&&r<=T}function p(r,f,E,I){let H="",z=0,U=-1,v=0,k=0;for(let x=0;x<=r.length;++x){if(x<r.length)k=r.charCodeAt(x);else{if(I(k))break;k=_}if(I(k)){if(!(U===x-1||v===1))if(v===2){if(H.length<2||z!==2||H.charCodeAt(H.length-1)!==w||H.charCodeAt(H.length-2)!==w){if(H.length>2){const N=H.lastIndexOf(E);N===-1?(H="",z=0):(H=H.slice(0,N),z=H.length-1-H.lastIndexOf(E)),U=x,v=0;continue}else if(H.length!==0){H="",z=0,U=x,v=0;continue}}f&&(H+=H.length>0?`${E}..`:"..",z=2)}else H.length>0?H+=`${E}${r.slice(U+1,x)}`:H=r.slice(U+1,x),z=x-U-1;U=x,v=0}else k===w&&v!==-1?++v:v=-1}return H}function L(r,f){m(f,"pathObject");const E=f.dir||f.root,I=f.base||`${f.name||""}${f.ext||""}`;return E?E===f.root?`${E}${I}`:`${E}${r}${I}`:I}t.win32={resolve(...r){let f="",E="",I=!1;for(let H=r.length-1;H>=-1;H--){let z;if(H>=0){if(z=r[H],e(z,"path"),z.length===0)continue}else f.length===0?z=i.cwd():(z=i.env[`=${f}`]||i.cwd(),(z===void 0||z.slice(0,2).toLowerCase()!==f.toLowerCase()&&z.charCodeAt(2)===d)&&(z=`${f}\\`));const U=z.length;let v=0,k="",x=!1;const N=z.charCodeAt(0);if(U===1)o(N)&&(v=1,x=!0);else if(o(N))if(x=!0,o(z.charCodeAt(1))){let M=2,$=M;for(;M<U&&!o(z.charCodeAt(M));)M++;if(M<U&&M!==$){const ne=z.slice($,M);for($=M;M<U&&o(z.charCodeAt(M));)M++;if(M<U&&M!==$){for($=M;M<U&&!o(z.charCodeAt(M));)M++;(M===U||M!==$)&&(k=`\\\\${ne}\\${z.slice($,M)}`,v=M)}}}else v=1;else h(N)&&z.charCodeAt(1)===D&&(k=z.slice(0,2),v=2,U>2&&o(z.charCodeAt(2))&&(x=!0,v=3));if(k.length>0)if(f.length>0){if(k.toLowerCase()!==f.toLowerCase())continue}else f=k;if(I){if(f.length>0)break}else if(E=`${z.slice(v)}\\${E}`,I=x,x&&f.length>0)break}return E=p(E,!I,"\\",o),I?`${f}\\${E}`:`${f}${E}`||"."},normalize(r){e(r,"path");const f=r.length;if(f===0)return".";let E=0,I,H=!1;const z=r.charCodeAt(0);if(f===1)return c(z)?"\\":r;if(o(z))if(H=!0,o(r.charCodeAt(1))){let v=2,k=v;for(;v<f&&!o(r.charCodeAt(v));)v++;if(v<f&&v!==k){const x=r.slice(k,v);for(k=v;v<f&&o(r.charCodeAt(v));)v++;if(v<f&&v!==k){for(k=v;v<f&&!o(r.charCodeAt(v));)v++;if(v===f)return`\\\\${x}\\${r.slice(k)}\\`;v!==k&&(I=`\\\\${x}\\${r.slice(k,v)}`,E=v)}}}else E=1;else h(z)&&r.charCodeAt(1)===D&&(I=r.slice(0,2),E=2,f>2&&o(r.charCodeAt(2))&&(H=!0,E=3));let U=E<f?p(r.slice(E),!H,"\\",o):"";return U.length===0&&!H&&(U="."),U.length>0&&o(r.charCodeAt(f-1))&&(U+="\\"),I===void 0?H?`\\${U}`:U:H?`${I}\\${U}`:`${I}${U}`},isAbsolute(r){e(r,"path");const f=r.length;if(f===0)return!1;const E=r.charCodeAt(0);return o(E)||f>2&&h(E)&&r.charCodeAt(1)===D&&o(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let f,E;for(let z=0;z<r.length;++z){const U=r[z];e(U,"path"),U.length>0&&(f===void 0?f=E=U:f+=`\\${U}`)}if(f===void 0)return".";let I=!0,H=0;if(typeof E=="string"&&o(E.charCodeAt(0))){++H;const z=E.length;z>1&&o(E.charCodeAt(1))&&(++H,z>2&&(o(E.charCodeAt(2))?++H:I=!1))}if(I){for(;H<f.length&&o(f.charCodeAt(H));)H++;H>=2&&(f=`\\${f.slice(H)}`)}return t.win32.normalize(f)},relative(r,f){if(e(r,"from"),e(f,"to"),r===f)return"";const E=t.win32.resolve(r),I=t.win32.resolve(f);if(E===I||(r=E.toLowerCase(),f=I.toLowerCase(),r===f))return"";let H=0;for(;H<r.length&&r.charCodeAt(H)===d;)H++;let z=r.length;for(;z-1>H&&r.charCodeAt(z-1)===d;)z--;const U=z-H;let v=0;for(;v<f.length&&f.charCodeAt(v)===d;)v++;let k=f.length;for(;k-1>v&&f.charCodeAt(k-1)===d;)k--;const x=k-v,N=U<x?U:x;let M=-1,$=0;for(;$<N;$++){const Z=r.charCodeAt(H+$);if(Z!==f.charCodeAt(v+$))break;Z===d&&(M=$)}if($!==N){if(M===-1)return I}else{if(x>N){if(f.charCodeAt(v+$)===d)return I.slice(v+$+1);if($===2)return I.slice(v+$)}U>N&&(r.charCodeAt(H+$)===d?M=$:$===2&&(M=3)),M===-1&&(M=0)}let ne="";for($=H+M+1;$<=z;++$)($===z||r.charCodeAt($)===d)&&(ne+=ne.length===0?"..":"\\..");return v+=M,ne.length>0?`${ne}${I.slice(v,k)}`:(I.charCodeAt(v)===d&&++v,I.slice(v,k))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const f=t.win32.resolve(r);if(f.length<=2)return r;if(f.charCodeAt(0)===d){if(f.charCodeAt(1)===d){const E=f.charCodeAt(2);if(E!==S&&E!==w)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(h(f.charCodeAt(0))&&f.charCodeAt(1)===D&&f.charCodeAt(2)===d)return`\\\\?\\${f}`;return r},dirname(r){e(r,"path");const f=r.length;if(f===0)return".";let E=-1,I=0;const H=r.charCodeAt(0);if(f===1)return o(H)?r:".";if(o(H)){if(E=I=1,o(r.charCodeAt(1))){let v=2,k=v;for(;v<f&&!o(r.charCodeAt(v));)v++;if(v<f&&v!==k){for(k=v;v<f&&o(r.charCodeAt(v));)v++;if(v<f&&v!==k){for(k=v;v<f&&!o(r.charCodeAt(v));)v++;if(v===f)return r;v!==k&&(E=I=v+1)}}}}else h(H)&&r.charCodeAt(1)===D&&(E=f>2&&o(r.charCodeAt(2))?3:2,I=E);let z=-1,U=!0;for(let v=f-1;v>=I;--v)if(o(r.charCodeAt(v))){if(!U){z=v;break}}else U=!1;if(z===-1){if(E===-1)return".";z=E}return r.slice(0,z)},basename(r,f){f!==void 0&&e(f,"ext"),e(r,"path");let E=0,I=-1,H=!0,z;if(r.length>=2&&h(r.charCodeAt(0))&&r.charCodeAt(1)===D&&(E=2),f!==void 0&&f.length>0&&f.length<=r.length){if(f===r)return"";let U=f.length-1,v=-1;for(z=r.length-1;z>=E;--z){const k=r.charCodeAt(z);if(o(k)){if(!H){E=z+1;break}}else v===-1&&(H=!1,v=z+1),U>=0&&(k===f.charCodeAt(U)?--U===-1&&(I=z):(U=-1,I=v))}return E===I?I=v:I===-1&&(I=r.length),r.slice(E,I)}for(z=r.length-1;z>=E;--z)if(o(r.charCodeAt(z))){if(!H){E=z+1;break}}else I===-1&&(H=!1,I=z+1);return I===-1?"":r.slice(E,I)},extname(r){e(r,"path");let f=0,E=-1,I=0,H=-1,z=!0,U=0;r.length>=2&&r.charCodeAt(1)===D&&h(r.charCodeAt(0))&&(f=I=2);for(let v=r.length-1;v>=f;--v){const k=r.charCodeAt(v);if(o(k)){if(!z){I=v+1;break}continue}H===-1&&(z=!1,H=v+1),k===w?E===-1?E=v:U!==1&&(U=1):E!==-1&&(U=-1)}return E===-1||H===-1||U===0||U===1&&E===H-1&&E===I+1?"":r.slice(E,H)},format:L.bind(null,"\\"),parse(r){e(r,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return f;const E=r.length;let I=0,H=r.charCodeAt(0);if(E===1)return o(H)?(f.root=f.dir=r,f):(f.base=f.name=r,f);if(o(H)){if(I=1,o(r.charCodeAt(1))){let M=2,$=M;for(;M<E&&!o(r.charCodeAt(M));)M++;if(M<E&&M!==$){for($=M;M<E&&o(r.charCodeAt(M));)M++;if(M<E&&M!==$){for($=M;M<E&&!o(r.charCodeAt(M));)M++;M===E?I=M:M!==$&&(I=M+1)}}}}else if(h(H)&&r.charCodeAt(1)===D){if(E<=2)return f.root=f.dir=r,f;if(I=2,o(r.charCodeAt(2))){if(E===3)return f.root=f.dir=r,f;I=3}}I>0&&(f.root=r.slice(0,I));let z=-1,U=I,v=-1,k=!0,x=r.length-1,N=0;for(;x>=I;--x){if(H=r.charCodeAt(x),o(H)){if(!k){U=x+1;break}continue}v===-1&&(k=!1,v=x+1),H===w?z===-1?z=x:N!==1&&(N=1):z!==-1&&(N=-1)}return v!==-1&&(z===-1||N===0||N===1&&z===v-1&&z===U+1?f.base=f.name=r.slice(U,v):(f.name=r.slice(U,z),f.base=r.slice(U,v),f.ext=r.slice(z,v))),U>0&&U!==I?f.dir=r.slice(0,U-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const y=(()=>{if(s){const r=/\\/g;return()=>{const f=i.cwd().replace(r,"/");return f.slice(f.indexOf("/"))}}return()=>i.cwd()})();t.posix={resolve(...r){let f="",E=!1;for(let I=r.length-1;I>=-1&&!E;I--){const H=I>=0?r[I]:y();e(H,"path"),H.length!==0&&(f=`${H}/${f}`,E=H.charCodeAt(0)===_)}return f=p(f,!E,"/",c),E?`/${f}`:f.length>0?f:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const f=r.charCodeAt(0)===_,E=r.charCodeAt(r.length-1)===_;return r=p(r,!f,"/",c),r.length===0?f?"/":E?"./":".":(E&&(r+="/"),f?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===_},join(...r){if(r.length===0)return".";let f;for(let E=0;E<r.length;++E){const I=r[E];e(I,"path"),I.length>0&&(f===void 0?f=I:f+=`/${I}`)}return f===void 0?".":t.posix.normalize(f)},relative(r,f){if(e(r,"from"),e(f,"to"),r===f||(r=t.posix.resolve(r),f=t.posix.resolve(f),r===f))return"";const E=1,I=r.length,H=I-E,z=1,U=f.length-z,v=H<U?H:U;let k=-1,x=0;for(;x<v;x++){const M=r.charCodeAt(E+x);if(M!==f.charCodeAt(z+x))break;M===_&&(k=x)}if(x===v)if(U>v){if(f.charCodeAt(z+x)===_)return f.slice(z+x+1);if(x===0)return f.slice(z+x)}else H>v&&(r.charCodeAt(E+x)===_?k=x:x===0&&(k=0));let N="";for(x=E+k+1;x<=I;++x)(x===I||r.charCodeAt(x)===_)&&(N+=N.length===0?"..":"/..");return`${N}${f.slice(z+k)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const f=r.charCodeAt(0)===_;let E=-1,I=!0;for(let H=r.length-1;H>=1;--H)if(r.charCodeAt(H)===_){if(!I){E=H;break}}else I=!1;return E===-1?f?"/":".":f&&E===1?"//":r.slice(0,E)},basename(r,f){f!==void 0&&e(f,"ext"),e(r,"path");let E=0,I=-1,H=!0,z;if(f!==void 0&&f.length>0&&f.length<=r.length){if(f===r)return"";let U=f.length-1,v=-1;for(z=r.length-1;z>=0;--z){const k=r.charCodeAt(z);if(k===_){if(!H){E=z+1;break}}else v===-1&&(H=!1,v=z+1),U>=0&&(k===f.charCodeAt(U)?--U===-1&&(I=z):(U=-1,I=v))}return E===I?I=v:I===-1&&(I=r.length),r.slice(E,I)}for(z=r.length-1;z>=0;--z)if(r.charCodeAt(z)===_){if(!H){E=z+1;break}}else I===-1&&(H=!1,I=z+1);return I===-1?"":r.slice(E,I)},extname(r){e(r,"path");let f=-1,E=0,I=-1,H=!0,z=0;for(let U=r.length-1;U>=0;--U){const v=r.charCodeAt(U);if(v===_){if(!H){E=U+1;break}continue}I===-1&&(H=!1,I=U+1),v===w?f===-1?f=U:z!==1&&(z=1):f!==-1&&(z=-1)}return f===-1||I===-1||z===0||z===1&&f===I-1&&f===E+1?"":r.slice(f,I)},format:L.bind(null,"/"),parse(r){e(r,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return f;const E=r.charCodeAt(0)===_;let I;E?(f.root="/",I=1):I=0;let H=-1,z=0,U=-1,v=!0,k=r.length-1,x=0;for(;k>=I;--k){const N=r.charCodeAt(k);if(N===_){if(!v){z=k+1;break}continue}U===-1&&(v=!1,U=k+1),N===w?H===-1?H=k:x!==1&&(x=1):H!==-1&&(x=-1)}if(U!==-1){const N=z===0&&E?1:z;H===-1||x===0||x===1&&H===U-1&&H===z+1?f.base=f.name=r.slice(N,U):(f.name=r.slice(N,H),f.base=r.slice(N,U),f.ext=r.slice(H,U))}return z>0?f.dir=r.slice(0,z-1):E&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=s?t.win32.normalize:t.posix.normalize,t.isAbsolute=s?t.win32.isAbsolute:t.posix.isAbsolute,t.join=s?t.win32.join:t.posix.join,t.resolve=s?t.win32.resolve:t.posix.resolve,t.relative=s?t.win32.relative:t.posix.relative,t.dirname=s?t.win32.dirname:t.posix.dirname,t.basename=s?t.win32.basename:t.posix.basename,t.extname=s?t.win32.extname:t.posix.extname,t.format=s?t.win32.format:t.posix.format,t.parse=s?t.win32.parse:t.posix.parse,t.toNamespacedPath=s?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=s?t.win32.sep:t.posix.sep,t.delimiter=s?t.win32.delimiter:t.posix.delimiter}),define(ve[132],De([1,0,18,28,5,11,10]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPathSeparator=w,t.toSlashes=_,t.toPosixPath=d,t.getRoot=D,t.isUNC=S,t.isValidBasename=s,t.isEqual=o,t.isEqualOrParent=c,t.isWindowsDriveLetter=h,t.sanitizeFilePath=p,t.removeTrailingPathSeparator=L,t.isRootOrDriveLetter=y,t.hasDriveLetter=r,t.getDriveLetter=f,t.indexOfPath=E,t.parseLineAndColumnAware=I,t.randomPath=U;function w(v){return v===i.CharCode.Slash||v===i.CharCode.Backslash}function _(v){return v.replace(/[\\/]/g,n.posix.sep)}function d(v){return v.indexOf("/")===-1&&(v=_(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function D(v,k=n.posix.sep){if(!v)return"";const x=v.length,N=v.charCodeAt(0);if(w(N)){if(w(v.charCodeAt(1))&&!w(v.charCodeAt(2))){let $=3;const ne=$;for(;$<x&&!w(v.charCodeAt($));$++);if(ne!==$&&!w(v.charCodeAt($+1))){for($+=1;$<x;$++)if(w(v.charCodeAt($)))return v.slice(0,$+1).replace(/[\\/]/g,k)}}return k}else if(h(N)&&v.charCodeAt(1)===i.CharCode.Colon)return w(v.charCodeAt(2))?v.slice(0,2)+k:v.slice(0,2);let M=v.indexOf("://");if(M!==-1){for(M+=3;M<x;M++)if(w(v.charCodeAt(M)))return v.slice(0,M+1)}return""}function S(v){if(!P.isWindows||!v||v.length<5)return!1;let k=v.charCodeAt(0);if(k!==i.CharCode.Backslash||(k=v.charCodeAt(1),k!==i.CharCode.Backslash))return!1;let x=2;const N=x;for(;x<v.length&&(k=v.charCodeAt(x),k!==i.CharCode.Backslash);x++);return!(N===x||(k=v.charCodeAt(x+1),isNaN(k)||k===i.CharCode.Backslash))}const b=/[\\/:\*\?"<>\|]/g,m=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(v,k=P.isWindows){const x=k?b:m;return!(!v||v.length===0||/^\s+$/.test(v)||(x.lastIndex=0,x.test(v))||k&&e.test(v)||v==="."||v===".."||k&&v[v.length-1]==="."||k&&v.length!==v.trim().length||v.length>255)}function o(v,k,x){const N=v===k;return!x||N?N:!v||!k?!1:(0,O.equalsIgnoreCase)(v,k)}function c(v,k,x,N=n.sep){if(v===k)return!0;if(!v||!k||k.length>v.length)return!1;if(x){if(!(0,O.startsWithIgnoreCase)(v,k))return!1;if(k.length===v.length)return!0;let $=k.length;return k.charAt(k.length-1)===N&&$--,v.charAt($)===N}return k.charAt(k.length-1)!==N&&(k+=N),v.indexOf(k)===0}function h(v){return v>=i.CharCode.A&&v<=i.CharCode.Z||v>=i.CharCode.a&&v<=i.CharCode.z}function p(v,k){return P.isWindows&&v.endsWith(":")&&(v+=n.sep),(0,n.isAbsolute)(v)||(v=(0,n.join)(k,v)),v=(0,n.normalize)(v),L(v)}function L(v){return P.isWindows?(v=(0,O.rtrim)(v,n.sep),v.endsWith(":")&&(v+=n.sep)):(v=(0,O.rtrim)(v,n.sep),v||(v=n.sep)),v}function y(v){const k=(0,n.normalize)(v);return P.isWindows?v.length>3?!1:r(k)&&(v.length===2||k.charCodeAt(2)===i.CharCode.Backslash):k===n.posix.sep}function r(v,k=P.isWindows){return k?h(v.charCodeAt(0))&&v.charCodeAt(1)===i.CharCode.Colon:!1}function f(v,k=P.isWindows){return r(v,k)?v[0]:void 0}function E(v,k,x){return k.length>v.length?-1:v===k?0:(x&&(v=v.toLowerCase(),k=k.toLowerCase()),v.indexOf(k))}function I(v){const k=v.split(":");let x,N,M;for(const $ of k){const ne=Number($);(0,T.isNumber)(ne)?N===void 0?N=ne:M===void 0&&(M=ne):x=x?[x,$].join(":"):$}if(!x)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:x,line:N!==void 0?N:void 0,column:M!==void 0?M:N!==void 0?1:void 0}}const H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",z="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function U(v,k,x=8){let N="";for(let $=0;$<x;$++){let ne;$===0&&P.isWindows&&!k&&(x===3||x===4)?ne=z:ne=H,N+=ne.charAt(Math.floor(Math.random()*ne.length))}let M;return k?M=`${k}-${N}`:M=N,v?(0,n.join)(v,M):M}}),define(ve[133],De([1,0,28]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Mimes=void 0,t.getMediaOrTextMime=O,t.getMediaMime=T,t.getExtensionForMimeType=w,t.normalizeMimeType=d,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(D){const S=(0,i.extname)(D),b=n[S.toLowerCase()];return b!==void 0?b:T(D)}function T(D){const S=(0,i.extname)(D);return P[S.toLowerCase()]}function w(D){for(const S in P)if(P[S]===D)return S}const _=/^(.+)\/(.+?)(;.+)?$/;function d(D,S){const b=_.exec(D);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:S?void 0:D}}),define(ve[17],De([1,0,18,60,28,5]),function(oe,t,i,n,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.isUriComponents=o,t.uriToFsPath=r;const T=/^\w[\w\d+.-]*$/,w=/^\//,_=/^\/\//;function d(z,U){if(!z.scheme&&U)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${z.authority}", path: "${z.path}", query: "${z.query}", fragment: "${z.fragment}"}`);if(z.scheme&&!T.test(z.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(z.path){if(z.authority){if(!w.test(z.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(z.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(z,U){return!z&&!U?"file":z}function S(z,U){switch(z){case"https":case"http":case"file":U?U[0]!==m&&(U=m+U):U=m;break}return U}const b="",m="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(U){return U instanceof s?!0:U?typeof U.authority=="string"&&typeof U.fragment=="string"&&typeof U.path=="string"&&typeof U.query=="string"&&typeof U.scheme=="string"&&typeof U.fsPath=="string"&&typeof U.with=="function"&&typeof U.toString=="function":!1}constructor(U,v,k,x,N,M=!1){typeof U=="object"?(this.scheme=U.scheme||b,this.authority=U.authority||b,this.path=U.path||b,this.query=U.query||b,this.fragment=U.fragment||b):(this.scheme=D(U,M),this.authority=v||b,this.path=S(this.scheme,k||b),this.query=x||b,this.fragment=N||b,d(this,M))}get fsPath(){return r(this,!1)}with(U){if(!U)return this;let{scheme:v,authority:k,path:x,query:N,fragment:M}=U;return v===void 0?v=this.scheme:v===null&&(v=b),k===void 0?k=this.authority:k===null&&(k=b),x===void 0?x=this.path:x===null&&(x=b),N===void 0?N=this.query:N===null&&(N=b),M===void 0?M=this.fragment:M===null&&(M=b),v===this.scheme&&k===this.authority&&x===this.path&&N===this.query&&M===this.fragment?this:new h(v,k,x,N,M)}static parse(U,v=!1){const k=e.exec(U);return k?new h(k[2]||b,H(k[4]||b),H(k[5]||b),H(k[7]||b),H(k[9]||b),v):new h(b,b,b,b,b)}static file(U){let v=b;if(O.isWindows&&(U=U.replace(/\\/g,m)),U[0]===m&&U[1]===m){const k=U.indexOf(m,2);k===-1?(v=U.substring(2),U=m):(v=U.substring(2,k),U=U.substring(k)||m)}return new h("file",v,U,b,b)}static from(U,v){return new h(U.scheme,U.authority,U.path,U.query,U.fragment,v)}static joinPath(U,...v){if(!U.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return O.isWindows&&U.scheme==="file"?k=s.file(P.win32.join(r(U,!0),...v)).path:k=P.posix.join(U.path,...v),U.with({path:k})}toString(U=!1){return f(this,U)}toJSON(){return this}static revive(U){if(U){if(U instanceof s)return U;{const v=new h(U);return v._formatted=U.external??null,v._fsPath=U._sep===c?U.fsPath??null:null,v}}else return U}}t.URI=s;function o(z){return!z||typeof z!="object"?!1:typeof z.scheme=="string"&&(typeof z.authority=="string"||typeof z.authority>"u")&&(typeof z.path=="string"||typeof z.path>"u")&&(typeof z.query=="string"||typeof z.query>"u")&&(typeof z.fragment=="string"||typeof z.fragment>"u")}const c=O.isWindows?1:void 0;class h extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(U=!1){return U?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const U={$mid:n.MarshalledId.Uri};return this._fsPath&&(U.fsPath=this._fsPath,U._sep=c),this._formatted&&(U.external=this._formatted),this.path&&(U.path=this.path),this.scheme&&(U.scheme=this.scheme),this.authority&&(U.authority=this.authority),this.query&&(U.query=this.query),this.fragment&&(U.fragment=this.fragment),U}}const p={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function L(z,U,v){let k,x=-1;for(let N=0;N<z.length;N++){const M=z.charCodeAt(N);if(M>=i.CharCode.a&&M<=i.CharCode.z||M>=i.CharCode.A&&M<=i.CharCode.Z||M>=i.CharCode.Digit0&&M<=i.CharCode.Digit9||M===i.CharCode.Dash||M===i.CharCode.Period||M===i.CharCode.Underline||M===i.CharCode.Tilde||U&&M===i.CharCode.Slash||v&&M===i.CharCode.OpenSquareBracket||v&&M===i.CharCode.CloseSquareBracket||v&&M===i.CharCode.Colon)x!==-1&&(k+=encodeURIComponent(z.substring(x,N)),x=-1),k!==void 0&&(k+=z.charAt(N));else{k===void 0&&(k=z.substr(0,N));const $=p[M];$!==void 0?(x!==-1&&(k+=encodeURIComponent(z.substring(x,N)),x=-1),k+=$):x===-1&&(x=N)}}return x!==-1&&(k+=encodeURIComponent(z.substring(x))),k!==void 0?k:z}function y(z){let U;for(let v=0;v<z.length;v++){const k=z.charCodeAt(v);k===i.CharCode.Hash||k===i.CharCode.QuestionMark?(U===void 0&&(U=z.substr(0,v)),U+=p[k]):U!==void 0&&(U+=z[v])}return U!==void 0?U:z}function r(z,U){let v;return z.authority&&z.path.length>1&&z.scheme==="file"?v=`//${z.authority}${z.path}`:z.path.charCodeAt(0)===i.CharCode.Slash&&(z.path.charCodeAt(1)>=i.CharCode.A&&z.path.charCodeAt(1)<=i.CharCode.Z||z.path.charCodeAt(1)>=i.CharCode.a&&z.path.charCodeAt(1)<=i.CharCode.z)&&z.path.charCodeAt(2)===i.CharCode.Colon?U?v=z.path.substr(1):v=z.path[1].toLowerCase()+z.path.substr(2):v=z.path,O.isWindows&&(v=v.replace(/\//g,"\\")),v}function f(z,U){const v=U?y:L;let k="",{scheme:x,authority:N,path:M,query:$,fragment:ne}=z;if(x&&(k+=x,k+=":"),(N||x==="file")&&(k+=m,k+=m),N){let Z=N.indexOf("@");if(Z!==-1){const Y=N.substr(0,Z);N=N.substr(Z+1),Z=Y.lastIndexOf(":"),Z===-1?k+=v(Y,!1,!1):(k+=v(Y.substr(0,Z),!1,!1),k+=":",k+=v(Y.substr(Z+1),!1,!0)),k+="@"}N=N.toLowerCase(),Z=N.lastIndexOf(":"),Z===-1?k+=v(N,!1,!0):(k+=v(N.substr(0,Z),!1,!0),k+=N.substr(Z))}if(M){if(M.length>=3&&M.charCodeAt(0)===i.CharCode.Slash&&M.charCodeAt(2)===i.CharCode.Colon){const Z=M.charCodeAt(1);Z>=i.CharCode.A&&Z<=i.CharCode.Z&&(M=`/${String.fromCharCode(Z+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===i.CharCode.Colon){const Z=M.charCodeAt(0);Z>=i.CharCode.A&&Z<=i.CharCode.Z&&(M=`${String.fromCharCode(Z+32)}:${M.substr(2)}`)}k+=v(M,!0,!1)}return $&&(k+="?",k+=v($,!1,!1)),ne&&(k+="#",k+=U?ne:L(ne,!1,!1)),k}function E(z){try{return decodeURIComponent(z)}catch{return z.length>3?z.substr(0,3)+E(z.substr(3)):z}}const I=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function H(z){return z.match(I)?z.replace(I,U=>E(U)):z}}),define(ve[69],De([1,0,48,17,60]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stringify=O,t.parse=T,t.revive=_;function O(d){return JSON.stringify(d,w)}function T(d){let D=JSON.parse(d);return D=_(D),D}function w(d,D){return D instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:D.source,flags:D.flags}:D}function _(d,D=0){if(!d||D>200)return d;if(typeof d=="object"){switch(d.$mid){case P.MarshalledId.Uri:return n.URI.revive(d);case P.MarshalledId.Regexp:return new RegExp(d.source,d.flags);case P.MarshalledId.Date:return new Date(d.source)}if(d instanceof i.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let S=0;S<d.length;++S)d[S]=_(d[S],D+1);else for(const S in d)Object.hasOwnProperty.call(d,S)&&(d[S]=_(d[S],D+1))}return d}}),define(ve[39],De([1,0,6,5,11,17,28]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.VSCODE_AUTHORITY=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0,t.matchesScheme=_,t.matchesSomeScheme=d,t.getServerRootPath=S;var w;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(w||(t.Schemas=w={}));function _(e,s){return O.URI.isUri(e)?(0,P.equalsIgnoreCase)(e.scheme,s):(0,P.startsWithIgnoreCase)(e,s+":")}function d(e,...s){return s.some(o=>_(e,o))}t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(s){this._preferredWebSchema=s}setDelegate(s){this._delegate=s}setServerRootPath(s,o){this._serverRootPath=S(s,o)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return T.posix.join(this._serverRootPath,w.vscodeRemoteResource)}set(s,o,c){this._hosts[s]=o,this._ports[s]=c}setConnectionToken(s,o){this._connectionTokens[s]=o}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(s){if(this._delegate)try{return this._delegate(s)}catch(y){return i.onUnexpectedError(y),s}const o=s.authority;let c=this._hosts[o];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const h=this._ports[o],p=this._connectionTokens[o];let L=`path=${encodeURIComponent(s.path)}`;return typeof p=="string"&&(L+=`&${t.connectionTokenQueryName}=${encodeURIComponent(p)}`),O.URI.from({scheme:n.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${c}:${h}`,path:this._remoteResourcesPath,query:L})}}t.RemoteAuthorities=new D;function S(e,s){return T.posix.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",t.VSCODE_AUTHORITY="vscode-app";class b{static{this.FALLBACK_AUTHORITY=t.VSCODE_AUTHORITY}asBrowserUri(s){const o=this.toUri(s,oe);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===w.vscodeRemote?t.RemoteAuthorities.rewrite(s):s.scheme===w.file&&(n.isNative||n.webWorkerOrigin===`${w.vscodeFileResource}://${b.FALLBACK_AUTHORITY}`)?s.with({scheme:w.vscodeFileResource,authority:s.authority||b.FALLBACK_AUTHORITY,query:null,fragment:null}):s}asFileUri(s){const o=this.toUri(s,oe);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===w.vscodeFileResource?s.with({scheme:w.file,authority:s.authority!==b.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(s,o){return O.URI.isUri(s)?s:O.URI.parse(o.toUrl(s))}}t.FileAccess=new b;var m;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function c(p){let L;typeof p=="string"?L=new URL(p).searchParams:p instanceof URL?L=p.searchParams:O.URI.isUri(p)&&(L=new URL(p.toString(!0)).searchParams);const y=L?.get(o);if(y)return s.get(y)}e.getHeadersFromQuery=c;function h(p,L,y){if(!globalThis.crossOriginIsolated)return;const r=L&&y?"3":y?"2":"1";p instanceof URLSearchParams?p.set(o,r):p[o]=r}e.addSearchParam=h})(m||(t.COI=m={}))}),define(ve[52],De([1,0,18,132,39,28,5,11,17]),function(oe,t,i,n,P,O,T,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=void 0,t.originalFSPath=d,t.distinctParents=S,t.toLocalResource=m;function d(e){return(0,_.uriToFsPath)(e,!0)}class D{constructor(s){this._ignorePathCasing=s}compare(s,o,c=!1){return s===o?0:(0,w.compare)(this.getComparisonKey(s,c),this.getComparisonKey(o,c))}isEqual(s,o,c=!1){return s===o?!0:!s||!o?!1:this.getComparisonKey(s,c)===this.getComparisonKey(o,c)}getComparisonKey(s,o=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,o,c=!1){if(s.scheme===o.scheme){if(s.scheme===P.Schemas.file)return n.isEqualOrParent(d(s),d(o),this._ignorePathCasing(s))&&s.query===o.query&&(c||s.fragment===o.fragment);if((0,t.isEqualAuthority)(s.authority,o.authority))return n.isEqualOrParent(s.path,o.path,this._ignorePathCasing(s),"/")&&s.query===o.query&&(c||s.fragment===o.fragment)}return!1}joinPath(s,...o){return _.URI.joinPath(s,...o)}basenameOrAuthority(s){return(0,t.basename)(s)||s.authority}basename(s){return O.posix.basename(s.path)}extname(s){return O.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let o;return s.scheme===P.Schemas.file?o=_.URI.file(O.dirname(d(s))).path:(o=O.posix.dirname(s.path),s.authority&&o.length&&o.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),o="/")),s.with({path:o})}normalizePath(s){if(!s.path.length)return s;let o;return s.scheme===P.Schemas.file?o=_.URI.file(O.normalize(d(s))).path:o=O.posix.normalize(s.path),s.with({path:o})}relativePath(s,o){if(s.scheme!==o.scheme||!(0,t.isEqualAuthority)(s.authority,o.authority))return;if(s.scheme===P.Schemas.file){const p=O.relative(d(s),d(o));return T.isWindows?n.toSlashes(p):p}let c=s.path||"/";const h=o.path||"/";if(this._ignorePathCasing(s)){let p=0;for(const L=Math.min(c.length,h.length);p<L&&!(c.charCodeAt(p)!==h.charCodeAt(p)&&c.charAt(p).toLowerCase()!==h.charAt(p).toLowerCase());p++);c=h.substr(0,p)+c.substr(p)}return O.posix.relative(c,h)}resolvePath(s,o){if(s.scheme===P.Schemas.file){const c=_.URI.file(O.resolve(d(s),o));return s.with({authority:c.authority,path:c.path})}return o=n.toPosixPath(o),s.with({path:O.posix.resolve(s.path,o)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,o){return s===o||s!==void 0&&o!==void 0&&(0,w.equalsIgnoreCase)(s,o)}hasTrailingPathSeparator(s,o=O.sep){if(s.scheme===P.Schemas.file){const c=d(s);return c.length>n.getRoot(c).length&&c[c.length-1]===o}else{const c=s.path;return c.length>1&&c.charCodeAt(c.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,o=O.sep){return(0,t.hasTrailingPathSeparator)(s,o)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,o=O.sep){let c=!1;if(s.scheme===P.Schemas.file){const h=d(s);c=h!==void 0&&h.length===n.getRoot(h).length&&h[h.length-1]===o}else{o="/";const h=s.path;c=h.length===1&&h.charCodeAt(h.length-1)===i.CharCode.Slash}return!c&&!(0,t.hasTrailingPathSeparator)(s,o)?s.with({path:s.path+"/"}):s}}t.ExtUri=D,t.extUri=new D(()=>!1),t.extUriBiasedIgnorePathCase=new D(e=>e.scheme===P.Schemas.file?!T.isLinux:!0),t.extUriIgnorePathCase=new D(e=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function S(e,s){const o=[];for(let c=0;c<e.length;c++){const h=s(e[c]);e.some((p,L)=>L===c?!1:(0,t.isEqualOrParent)(h,s(p)))||o.push(e[c])}return o}var b;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function s(o){const c=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(L=>{const[y,r]=L.split(":");y&&r&&c.set(y,r)});const p=o.path.substring(0,o.path.indexOf(";"));return p&&c.set(e.META_DATA_MIME,p),c}e.parseMetaData=s})(b||(t.DataUri=b={}));function m(e,s,o){if(s){let c=e.path;return c&&c[0]!==O.posix.sep&&(c=O.posix.sep+c),e.with({scheme:o,authority:s,path:c})}return e.with({scheme:o})}}),define(ve[12],De([1,0,37,6,3,2,52,5,62,26]),function(oe,t,i,n,P,O,T,w,_,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AsyncIterableSource=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.LazyStatefulPromise=t.StatefulPromise=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.GlobalIdleValue=t.AbstractIdleValue=t._runWhenIdle=t.runWhenGlobalIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.LimitedQueue=t.Queue=t.Limiter=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=void 0,t.isThenable=D,t.createCancelablePromise=S,t.raceCancellation=b,t.raceCancellationError=m,t.raceCancellablePromises=e,t.raceTimeout=s,t.asPromise=o,t.promiseWithResolvers=c,t.timeout=z,t.disposableTimeout=U,t.sequence=v,t.first=k,t.firstParallel=x,t.retry=J,t.createCancelableAsyncIterable=q;function D(l){return!!l&&typeof l.then=="function"}function S(l){const a=new i.CancellationTokenSource,g=l(a.token),C=new Promise((R,u)=>{const F=a.token.onCancellationRequested(()=>{F.dispose(),u(new n.CancellationError)});Promise.resolve(g).then(A=>{F.dispose(),a.dispose(),R(A)},A=>{F.dispose(),a.dispose(),u(A)})});return new class{cancel(){a.cancel(),a.dispose()}then(R,u){return C.then(R,u)}catch(R){return this.then(void 0,R)}finally(R){return C.finally(R)}}}function b(l,a,g){return new Promise((C,R)=>{const u=a.onCancellationRequested(()=>{u.dispose(),C(g)});l.then(C,R).finally(()=>u.dispose())})}function m(l,a){return new Promise((g,C)=>{const R=a.onCancellationRequested(()=>{R.dispose(),C(new n.CancellationError)});l.then(g,C).finally(()=>R.dispose())})}async function e(l){let a=-1;const g=l.map((C,R)=>C.then(u=>(a=R,u)));try{return await Promise.race(g)}finally{l.forEach((C,R)=>{R!==a&&C.cancel()})}}function s(l,a,g){let C;const R=setTimeout(()=>{C?.(void 0),g?.()},a);return Promise.race([l.finally(()=>clearTimeout(R)),new Promise(u=>C=u)])}function o(l){return new Promise((a,g)=>{const C=l();D(C)?C.then(a,g):a(C)})}function c(){let l,a;return{promise:new Promise((C,R)=>{l=C,a=R}),resolve:l,reject:a}}class h{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(a){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=a,!this.queuedPromise){const g=()=>{if(this.queuedPromise=null,this.isDisposed)return;const C=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,C};this.queuedPromise=new Promise(C=>{this.activePromise.then(g,g).then(C)})}return new Promise((g,C)=>{this.queuedPromise.then(g,C)})}return this.activePromise=a(),new Promise((g,C)=>{this.activePromise.then(R=>{this.activePromise=null,g(R)},R=>{this.activePromise=null,C(R)})})}dispose(){this.isDisposed=!0}}t.Throttler=h;class p{constructor(){this.current=Promise.resolve(null)}queue(a){return this.current=this.current.then(()=>a(),()=>a())}}t.Sequencer=p;class L{constructor(){this.promiseMap=new Map}queue(a,g){const R=(this.promiseMap.get(a)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.promiseMap.get(a)===R&&this.promiseMap.delete(a)});return this.promiseMap.set(a,R),R}}t.SequencerByKey=L;const y=(l,a)=>{let g=!0;const C=setTimeout(()=>{g=!1,a()},l);return{isTriggered:()=>g,dispose:()=>{clearTimeout(C),g=!1}}},r=l=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,l())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class f{constructor(a){this.defaultDelay=a,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(a,g=this.defaultDelay){this.task=a,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((R,u)=>{this.doResolve=R,this.doReject=u}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const R=this.task;return this.task=null,R()}}));const C=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=g===_.MicrotaskDelay?r(C):y(g,C),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=f;class E{constructor(a){this.delayer=new f(a),this.throttler=new h}trigger(a,g){return this.delayer.trigger(()=>this.throttler.queue(a),g)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}t.ThrottledDelayer=E;class I{constructor(){this._isOpen=!1,this._promise=new Promise((a,g)=>{this._completePromise=a})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=I;class H extends I{constructor(a){super(),this._timeout=setTimeout(()=>this.open(),a)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=H;function z(l,a){return a?new Promise((g,C)=>{const R=setTimeout(()=>{u.dispose(),g()},l),u=a.onCancellationRequested(()=>{clearTimeout(R),u.dispose(),C(new n.CancellationError)})}):S(g=>z(l,g))}function U(l,a=0,g){const C=setTimeout(()=>{l(),g&&R.dispose()},a),R=(0,O.toDisposable)(()=>{clearTimeout(C),g?.deleteAndLeak(R)});return g?.add(R),R}function v(l){const a=[];let g=0;const C=l.length;function R(){return g<C?l[g++]():null}function u(F){F!=null&&a.push(F);const A=R();return A?A.then(u):Promise.resolve(a)}return Promise.resolve(null).then(u)}function k(l,a=C=>!!C,g=null){let C=0;const R=l.length,u=()=>{if(C>=R)return Promise.resolve(g);const F=l[C++];return Promise.resolve(F()).then(B=>a(B)?Promise.resolve(B):u())};return u()}function x(l,a=C=>!!C,g=null){if(l.length===0)return Promise.resolve(g);let C=l.length;const R=()=>{C=-1;for(const u of l)u.cancel?.()};return new Promise((u,F)=>{for(const A of l)A.then(B=>{--C>=0&&a(B)?(R(),u(B)):C===0&&u(g)}).catch(B=>{--C>=0&&(R(),F(B))})})}class N{constructor(a){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=a,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new P.Emitter}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(a){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((g,C)=>{this.outstandingPromises.push({factory:a,c:g,e:C}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const a=this.outstandingPromises.shift();this.runningPromises++;const g=a.factory();g.then(a.c,a.e),g.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}t.Limiter=N;class M extends N{constructor(){super(1)}}t.Queue=M;class ${constructor(){this.sequentializer=new de,this.tasks=0}queue(a){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,a())):this.sequentializer.run(this.tasks++,a())}}t.LimitedQueue=$;class ne{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const a=new Q;return this.drainers.add(a),a.p}isDrained(){for(const[,a]of this.queues)if(a.size>0)return!1;return!0}queueSize(a,g=T.extUri){const C=g.getComparisonKey(a);return this.queues.get(C)?.size??0}queueFor(a,g,C=T.extUri){const R=C.getComparisonKey(a);let u=this.queues.get(R);if(!u){u=new M;const F=this.drainListenerCount++,A=P.Event.once(u.onDrained)(()=>{u?.dispose(),this.queues.delete(R),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(F),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(F,A),this.queues.set(R,u)}return u.queue(g)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const a of this.drainers)a.complete();this.drainers.clear()}dispose(){for(const[,a]of this.queues)a.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}t.ResourceQueue=ne;class Z{constructor(a,g){this._isDisposed=!1,this._token=-1,typeof a=="function"&&typeof g=="number"&&this.setIfNotSet(a,g)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(a,g){if(this._isDisposed)throw new n.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,a()},g)}setIfNotSet(a,g){if(this._isDisposed)throw new n.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,a()},g))}}t.TimeoutTimer=Z;class Y{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(a,g,C=globalThis){if(this.isDisposed)throw new n.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const R=C.setInterval(()=>{a()},g);this.disposable=(0,O.toDisposable)(()=>{C.clearInterval(R),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}t.IntervalTimer=Y;class te{constructor(a,g){this.timeoutToken=-1,this.runner=a,this.timeout=g,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(a=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,a)}get delay(){return this.timeout}set delay(a){this.timeout=a}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=te;class fe{constructor(a,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.runner=a,this.timeout=g,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(a=this.timeout){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(a/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=fe;class Ee extends te{constructor(a,g){super(a,g),this.units=[]}work(a){this.units.push(a),this.isScheduled()||this.schedule()}doRun(){const a=this.units;this.units=[],this.runner?.(a)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=Ee;class Fe extends O.Disposable{constructor(a,g){super(),this.options=a,this.handler=g,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(a){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+a.length>this.options.maxBufferedWork)return!1}else if(this.pending+a.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const g of a)this.pendingWork.push(g);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new te(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=Fe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t._runWhenIdle=(l,a)=>{(0,w.setTimeout0)(()=>{if(g)return;const C=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let g=!1;return{dispose(){g||(g=!0)}}}:t._runWhenIdle=(l,a,g)=>{const C=l.requestIdleCallback(a,typeof g=="number"?{timeout:g}:void 0);let R=!1;return{dispose(){R||(R=!0,l.cancelIdleCallback(C))}}},t.runWhenGlobalIdle=l=>(0,t._runWhenIdle)(globalThis,l)}();class Ae{constructor(a,g){this._didRun=!1,this._executor=()=>{try{this._value=g()}catch(C){this._error=C}finally{this._didRun=!0}},this._handle=(0,t._runWhenIdle)(a,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.AbstractIdleValue=Ae;class ue extends Ae{constructor(a){super(globalThis,a)}}t.GlobalIdleValue=ue;async function J(l,a,g){let C;for(let R=0;R<g;R++)try{return await l()}catch(u){C=u,await z(a)}throw C}class de{isRunning(a){return typeof a=="number"?this._running?.taskId===a:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(a,g,C){return this._running={taskId:a,cancel:()=>C?.(),promise:g},g.then(()=>this.doneRunning(a),()=>this.doneRunning(a)),g}doneRunning(a){this._running&&a===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const a=this._queued;this._queued=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this._queued)this._queued.run=a;else{const{promise:g,resolve:C,reject:R}=c();this._queued={run:a,promise:g,promiseResolve:C,promiseReject:R}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}t.TaskSequentializer=de;class ae{constructor(a,g=()=>Date.now()){this.interval=a,this.nowFn=g,this.lastIncrementTime=0,this.value=0}increment(){const a=this.nowFn();return a-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=a,this.value=0),this.value++,this.value}}t.IntervalCounter=ae;var Le;(function(l){l[l.Resolved=0]="Resolved",l[l.Rejected=1]="Rejected"})(Le||(Le={}));class Q{get isRejected(){return this.outcome?.outcome===Le.Rejected}get isResolved(){return this.outcome?.outcome===Le.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===Le.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((a,g)=>{this.completeCallback=a,this.errorCallback=g})}complete(a){return new Promise(g=>{this.completeCallback(a),this.outcome={outcome:Le.Resolved,value:a},g()})}error(a){return new Promise(g=>{this.errorCallback(a),this.outcome={outcome:Le.Rejected,value:a},g()})}cancel(){return this.error(new n.CancellationError)}}t.DeferredPromise=Q;var me;(function(l){async function a(C){let R;const u=await Promise.all(C.map(F=>F.then(A=>A,A=>{R||(R=A)})));if(typeof R<"u")throw R;return u}l.settled=a;function g(C){return new Promise(async(R,u)=>{try{await C(R,u)}catch(F){u(F)}})}l.withAsyncBody=g})(me||(t.Promises=me={}));class _e{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(a){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=a.then(g=>(this._value=g,this._isResolved=!0,g),g=>{throw this._error=g,this._isResolved=!0,g})}requireValue(){if(!this._isResolved)throw new n.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}t.StatefulPromise=_e;class Oe{constructor(a){this._compute=a,this._promise=new d.Lazy(()=>new _e(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}t.LazyStatefulPromise=Oe;var Ce;(function(l){l[l.Initial=0]="Initial",l[l.DoneOK=1]="DoneOK",l[l.DoneError=2]="DoneError"})(Ce||(Ce={}));class Be{static fromArray(a){return new Be(g=>{g.emitMany(a)})}static fromPromise(a){return new Be(async g=>{g.emitMany(await a)})}static fromPromises(a){return new Be(async g=>{await Promise.all(a.map(async C=>g.emitOne(await C)))})}static merge(a){return new Be(async g=>{await Promise.all(a.map(async C=>{for await(const R of C)g.emitOne(R)}))})}static{this.EMPTY=Be.fromArray([])}constructor(a,g){this._state=Ce.Initial,this._results=[],this._error=null,this._onReturn=g,this._onStateChanged=new P.Emitter,queueMicrotask(async()=>{const C={emitOne:R=>this.emitOne(R),emitMany:R=>this.emitMany(R),reject:R=>this.reject(R)};try{await Promise.resolve(a(C)),this.resolve()}catch(R){this.reject(R)}finally{C.emitOne=void 0,C.emitMany=void 0,C.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this._state===Ce.DoneError)throw this._error;if(a<this._results.length)return{done:!1,value:this._results[a++]};if(this._state===Ce.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(a,g){return new Be(async C=>{for await(const R of a)C.emitOne(g(R))})}map(a){return Be.map(this,a)}static filter(a,g){return new Be(async C=>{for await(const R of a)g(R)&&C.emitOne(R)})}filter(a){return Be.filter(this,a)}static coalesce(a){return Be.filter(a,g=>!!g)}coalesce(){return Be.coalesce(this)}static async toPromise(a){const g=[];for await(const C of a)g.push(C);return g}toPromise(){return Be.toPromise(this)}emitOne(a){this._state===Ce.Initial&&(this._results.push(a),this._onStateChanged.fire())}emitMany(a){this._state===Ce.Initial&&(this._results=this._results.concat(a),this._onStateChanged.fire())}resolve(){this._state===Ce.Initial&&(this._state=Ce.DoneOK,this._onStateChanged.fire())}reject(a){this._state===Ce.Initial&&(this._state=Ce.DoneError,this._error=a,this._onStateChanged.fire())}}t.AsyncIterableObject=Be;class ie extends Be{constructor(a,g){super(g),this._source=a}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=ie;function q(l){const a=new i.CancellationTokenSource,g=l(a.token);return new ie(a,async C=>{const R=a.token.onCancellationRequested(()=>{R.dispose(),a.dispose(),C.reject(new n.CancellationError)});try{for await(const u of g){if(a.token.isCancellationRequested)return;C.emitOne(u)}R.dispose(),a.dispose()}catch(u){R.dispose(),a.dispose(),C.reject(u)}})}class W{constructor(a){this._deferred=new Q,this._asyncIterable=new Be(R=>{if(g){R.reject(g);return}return C&&R.emitMany(C),this._errorFn=u=>R.reject(u),this._emitFn=u=>R.emitOne(u),this._deferred.p},a);let g,C;this._emitFn=R=>{C||(C=[]),C.push(R)},this._errorFn=R=>{g||(g=R)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(a){this._errorFn(a),this._deferred.complete()}emitOne(a){this._emitFn(a)}}t.AsyncIterableSource=W}),define(ve[4],De([1,0,19,68,16,23,12,6,3,134,8,2,39,5,17,65,25]),function(oe,t,i,n,P,O,T,w,_,d,D,S,b,m,e,s,o){"use strict";var c;Object.defineProperty(t,"__esModule",{value:!0}),t.DragAndDropObserver=t.ModifierKeyEmitter=t.basicMarkupHtmlTags=t.DetectedFullscreenMode=t.Namespace=t.EventHelper=t.EventType=t.sharedMutationObserver=t.Dimension=t.WindowIntervalTimer=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.WindowIdleValue=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.clearNode=h,t.addDisposableListener=L,t.addDisposableGenericMouseDownListener=H,t.addDisposableGenericMouseMoveListener=z,t.addDisposableGenericMouseUpListener=U,t.runWhenWindowIdle=v,t.disposableWindowInterval=x,t.measure=$,t.modify=ne,t.addDisposableThrottledListener=fe,t.getComputedStyle=Ee,t.getClientArea=Fe,t.getTopLeftOffset=J,t.size=de,t.position=ae,t.getDomNodePagePosition=Le,t.getDomNodeZoomLevel=Q,t.getTotalWidth=me,t.getContentWidth=_e,t.getTotalScrollWidth=Oe,t.getContentHeight=Ce,t.getTotalHeight=Be,t.getLargestChildWidth=q,t.isAncestor=W,t.setParentFlowTo=a,t.isAncestorUsingFlowTo=C,t.findParentWithClass=R,t.hasParentWithClass=u,t.isShadowRoot=F,t.isInShadowDOM=A,t.getShadowRoot=B,t.getActiveElement=V,t.isActiveElement=G,t.isAncestorOfActiveElement=ee,t.isActiveDocument=re,t.getActiveDocument=he,t.getActiveWindow=ye,t.isGlobalStylesheet=Ie,t.createStyleSheet2=Te,t.createStyleSheet=Re,t.cloneGlobalStylesheets=Ue,t.createMetaElement=et,t.createLinkElement=ot,t.createCSSRule=le,t.removeCSSRulesContainingSelector=be,t.isHTMLElement=Me,t.isHTMLAnchorElement=ze,t.isHTMLSpanElement=Qe,t.isHTMLTextAreaElement=st,t.isHTMLInputElement=tt,t.isHTMLButtonElement=lt,t.isHTMLDivElement=nt,t.isMouseEvent=ht,t.isKeyboardEvent=ut,t.isPointerEvent=vt,t.isDragEvent=We,t.isEventLike=ge,t.saveParentsScrollTop=ke,t.restoreParentsScrollTop=Pe,t.trackFocus=rt,t.after=dt,t.append=Xe,t.prepend=mt,t.reset=St,t.$=Zt,t.join=Ii,t.setVisibility=Ni,t.show=Qt,t.hide=Jt,t.removeTabIndexAndUpdateFocus=Ri,t.finalHandler=Ci,t.domContentLoaded=Oi,t.computeScreenAwareSize=ki,t.windowOpenNoOpener=Mi,t.windowOpenPopup=Pi,t.windowOpenWithSuccess=Bi,t.animate=xi,t.asCSSUrl=Wi,t.asCSSPropertyValue=Hi,t.asCssValueWithDefault=ii,t.triggerDownload=zi,t.triggerUpload=Ui,t.detectFullscreen=Vi,t.hookDomPurifyHrefAndSrcSanitizer=ni,t.safeInnerHtml=qi,t.multibyteAwareBtoa=ji,t.getCookieValue=Yi,t.h=Qi,t.copyAttributes=ri,t.trackAttributes=en,c=function(){const K=new Map;(0,o.ensureCodeWindow)(o.mainWindow,1);const j={window:o.mainWindow,disposables:new S.DisposableStore};K.set(o.mainWindow.vscodeWindowId,j);const se=new _.Emitter,pe=new _.Emitter,Ne=new _.Emitter;function He(xe,Ke){return(typeof xe=="number"?K.get(xe):void 0)??(Ke?j:void 0)}return{onDidRegisterWindow:se.event,onWillUnregisterWindow:Ne.event,onDidUnregisterWindow:pe.event,registerWindow(xe){if(K.has(xe.vscodeWindowId))return S.Disposable.None;const Ke=new S.DisposableStore,Ge={window:xe,disposables:Ke.add(new S.DisposableStore)};return K.set(xe.vscodeWindowId,Ge),Ke.add((0,S.toDisposable)(()=>{K.delete(xe.vscodeWindowId),pe.fire(xe)})),Ke.add(L(xe,t.EventType.BEFORE_UNLOAD,()=>{Ne.fire(xe)})),se.fire(Ge),Ke},getWindows(){return K.values()},getWindowsCount(){return K.size},getWindowId(xe){return xe.vscodeWindowId},hasWindow(xe){return K.has(xe)},getWindowById:He,getWindow(xe){const Ke=xe;if(Ke?.ownerDocument?.defaultView)return Ke.ownerDocument.defaultView.window;const Ge=xe;return Ge?.view?Ge.view.window:o.mainWindow},getDocument(xe){const Ke=xe;return(0,t.getWindow)(Ke).document}}}(),t.registerWindow=c.registerWindow,t.getWindow=c.getWindow,t.getDocument=c.getDocument,t.getWindows=c.getWindows,t.getWindowsCount=c.getWindowsCount,t.getWindowId=c.getWindowId,t.getWindowById=c.getWindowById,t.hasWindow=c.hasWindow,t.onDidRegisterWindow=c.onDidRegisterWindow,t.onWillUnregisterWindow=c.onWillUnregisterWindow,t.onDidUnregisterWindow=c.onDidUnregisterWindow;function h(K){for(;K.firstChild;)K.firstChild.remove()}class p{constructor(j,se,pe,Ne){this._node=j,this._type=se,this._handler=pe,this._options=Ne||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){this._handler&&(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function L(K,j,se,pe){return new p(K,j,se,pe)}function y(K,j){return function(se){return j(new O.StandardMouseEvent(K,se))}}function r(K){return function(j){return K(new P.StandardKeyboardEvent(j))}}const f=function(j,se,pe,Ne){let He=pe;return se==="click"||se==="mousedown"||se==="contextmenu"?He=y((0,t.getWindow)(j),pe):(se==="keydown"||se==="keypress"||se==="keyup")&&(He=r(pe)),L(j,se,He,Ne)};t.addStandardDisposableListener=f;const E=function(j,se,pe){const Ne=y((0,t.getWindow)(j),se);return H(j,Ne,pe)};t.addStandardDisposableGenericMouseDownListener=E;const I=function(j,se,pe){const Ne=y((0,t.getWindow)(j),se);return U(j,Ne,pe)};t.addStandardDisposableGenericMouseUpListener=I;function H(K,j,se){return L(K,m.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,j,se)}function z(K,j,se){return L(K,m.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,j,se)}function U(K,j,se){return L(K,m.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,j,se)}function v(K,j,se){return(0,T._runWhenIdle)(K,j,se)}class k extends T.AbstractIdleValue{constructor(j,se){super(j,se)}}t.WindowIdleValue=k;function x(K,j,se,pe){let Ne=0;const He=K.setInterval(()=>{Ne++,(typeof pe=="number"&&Ne>=pe||j()===!0)&&xe.dispose()},se),xe=(0,S.toDisposable)(()=>{K.clearInterval(He)});return xe}class N extends T.IntervalTimer{constructor(j){super(),this.defaultTarget=j&&(0,t.getWindow)(j)}cancelAndSet(j,se,pe){return super.cancelAndSet(j,se,pe??this.defaultTarget)}}t.WindowIntervalTimer=N;class M{constructor(j,se=0){this._runner=j,this.priority=se,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(j){(0,w.onUnexpectedError)(j)}}static sort(j,se){return se.priority-j.priority}}(function(){const K=new Map,j=new Map,se=new Map,pe=new Map,Ne=He=>{se.set(He,!1);const xe=K.get(He)??[];for(j.set(He,xe),K.set(He,[]),pe.set(He,!0);xe.length>0;)xe.sort(M.sort),xe.shift().execute();pe.set(He,!1)};t.scheduleAtNextAnimationFrame=(He,xe,Ke=0)=>{const Ge=(0,t.getWindowId)(He),je=new M(xe,Ke);let ct=K.get(Ge);return ct||(ct=[],K.set(Ge,ct)),ct.push(je),se.get(Ge)||(se.set(Ge,!0),He.requestAnimationFrame(()=>Ne(Ge))),je},t.runAtThisOrScheduleAtNextAnimationFrame=(He,xe,Ke)=>{const Ge=(0,t.getWindowId)(He);if(pe.get(Ge)){const je=new M(xe,Ke);let ct=j.get(Ge);return ct||(ct=[],j.set(Ge,ct)),ct.push(je),je}else return(0,t.scheduleAtNextAnimationFrame)(He,xe,Ke)}})();function $(K,j){return(0,t.scheduleAtNextAnimationFrame)(K,j,1e4)}function ne(K,j){return(0,t.scheduleAtNextAnimationFrame)(K,j,-1e4)}const Z=8,Y=function(K,j){return j};class te extends S.Disposable{constructor(j,se,pe,Ne=Y,He=Z){super();let xe=null,Ke=0;const Ge=this._register(new T.TimeoutTimer),je=()=>{Ke=new Date().getTime(),pe(xe),xe=null};this._register(L(j,se,ct=>{xe=Ne(xe,ct);const Ft=new Date().getTime()-Ke;Ft>=He?(Ge.cancel(),je()):Ge.setIfNotSet(je,He-Ft)}))}}function fe(K,j,se,pe,Ne){return new te(K,j,se,pe,Ne)}function Ee(K){return(0,t.getWindow)(K).getComputedStyle(K,null)}function Fe(K,j){const se=(0,t.getWindow)(K),pe=se.document;if(K!==pe.body)return new ue(K.clientWidth,K.clientHeight);if(m.isIOS&&se?.visualViewport)return new ue(se.visualViewport.width,se.visualViewport.height);if(se?.innerWidth&&se.innerHeight)return new ue(se.innerWidth,se.innerHeight);if(pe.body&&pe.body.clientWidth&&pe.body.clientHeight)return new ue(pe.body.clientWidth,pe.body.clientHeight);if(pe.documentElement&&pe.documentElement.clientWidth&&pe.documentElement.clientHeight)return new ue(pe.documentElement.clientWidth,pe.documentElement.clientHeight);if(j)return Fe(j);throw new Error("Unable to figure out browser width and height")}class Ae{static convertToPixels(j,se){return parseFloat(se)||0}static getDimension(j,se,pe){const Ne=Ee(j),He=Ne?Ne.getPropertyValue(se):"0";return Ae.convertToPixels(j,He)}static getBorderLeftWidth(j){return Ae.getDimension(j,"border-left-width","borderLeftWidth")}static getBorderRightWidth(j){return Ae.getDimension(j,"border-right-width","borderRightWidth")}static getBorderTopWidth(j){return Ae.getDimension(j,"border-top-width","borderTopWidth")}static getBorderBottomWidth(j){return Ae.getDimension(j,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(j){return Ae.getDimension(j,"padding-left","paddingLeft")}static getPaddingRight(j){return Ae.getDimension(j,"padding-right","paddingRight")}static getPaddingTop(j){return Ae.getDimension(j,"padding-top","paddingTop")}static getPaddingBottom(j){return Ae.getDimension(j,"padding-bottom","paddingBottom")}static getMarginLeft(j){return Ae.getDimension(j,"margin-left","marginLeft")}static getMarginTop(j){return Ae.getDimension(j,"margin-top","marginTop")}static getMarginRight(j){return Ae.getDimension(j,"margin-right","marginRight")}static getMarginBottom(j){return Ae.getDimension(j,"margin-bottom","marginBottom")}}class ue{static{this.None=new ue(0,0)}constructor(j,se){this.width=j,this.height=se}with(j=this.width,se=this.height){return j!==this.width||se!==this.height?new ue(j,se):this}static is(j){return typeof j=="object"&&typeof j.height=="number"&&typeof j.width=="number"}static lift(j){return j instanceof ue?j:new ue(j.width,j.height)}static equals(j,se){return j===se?!0:!j||!se?!1:j.width===se.width&&j.height===se.height}}t.Dimension=ue;function J(K){let j=K.offsetParent,se=K.offsetTop,pe=K.offsetLeft;for(;(K=K.parentNode)!==null&&K!==K.ownerDocument.body&&K!==K.ownerDocument.documentElement;){se-=K.scrollTop;const Ne=F(K)?null:Ee(K);Ne&&(pe-=Ne.direction!=="rtl"?K.scrollLeft:-K.scrollLeft),K===j&&(pe+=Ae.getBorderLeftWidth(K),se+=Ae.getBorderTopWidth(K),se+=K.offsetTop,pe+=K.offsetLeft,j=K.offsetParent)}return{left:pe,top:se}}function de(K,j,se){typeof j=="number"&&(K.style.width=`${j}px`),typeof se=="number"&&(K.style.height=`${se}px`)}function ae(K,j,se,pe,Ne,He="absolute"){typeof j=="number"&&(K.style.top=`${j}px`),typeof se=="number"&&(K.style.right=`${se}px`),typeof pe=="number"&&(K.style.bottom=`${pe}px`),typeof Ne=="number"&&(K.style.left=`${Ne}px`),K.style.position=He}function Le(K){const j=K.getBoundingClientRect(),se=(0,t.getWindow)(K);return{left:j.left+se.scrollX,top:j.top+se.scrollY,width:j.width,height:j.height}}function Q(K){let j=K,se=1;do{const pe=Ee(j).zoom;pe!=null&&pe!=="1"&&(se*=pe),j=j.parentElement}while(j!==null&&j!==j.ownerDocument.documentElement);return se}function me(K){const j=Ae.getMarginLeft(K)+Ae.getMarginRight(K);return K.offsetWidth+j}function _e(K){const j=Ae.getBorderLeftWidth(K)+Ae.getBorderRightWidth(K),se=Ae.getPaddingLeft(K)+Ae.getPaddingRight(K);return K.offsetWidth-j-se}function Oe(K){const j=Ae.getMarginLeft(K)+Ae.getMarginRight(K);return K.scrollWidth+j}function Ce(K){const j=Ae.getBorderTopWidth(K)+Ae.getBorderBottomWidth(K),se=Ae.getPaddingTop(K)+Ae.getPaddingBottom(K);return K.offsetHeight-j-se}function Be(K){const j=Ae.getMarginTop(K)+Ae.getMarginBottom(K);return K.offsetHeight+j}function ie(K,j){if(K===null)return 0;const se=J(K),pe=J(j);return se.left-pe.left}function q(K,j){const se=j.map(Ne=>Math.max(Oe(Ne),me(Ne))+ie(Ne,K)||0);return Math.max(...se)}function W(K,j){return!!j?.contains(K)}const l="parentFlowToElementId";function a(K,j){K.dataset[l]=j.id}function g(K){const j=K.dataset[l];return typeof j=="string"?K.ownerDocument.getElementById(j):null}function C(K,j){let se=K;for(;se;){if(se===j)return!0;if(Me(se)){const pe=g(se);if(pe){se=pe;continue}}se=se.parentNode}return!1}function R(K,j,se){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K.classList.contains(j))return K;if(se){if(typeof se=="string"){if(K.classList.contains(se))return null}else if(K===se)return null}K=K.parentNode}return null}function u(K,j,se){return!!R(K,j,se)}function F(K){return K&&!!K.host&&!!K.mode}function A(K){return!!B(K)}function B(K){for(;K.parentNode;){if(K===K.ownerDocument?.body)return null;K=K.parentNode}return F(K)?K:null}function V(){let K=he().activeElement;for(;K?.shadowRoot;)K=K.shadowRoot.activeElement;return K}function G(K){return V()===K}function ee(K){return W(V(),K)}function re(K){return K.ownerDocument===he()}function he(){return(0,t.getWindowsCount)()<=1?o.mainWindow.document:Array.from((0,t.getWindows)()).map(({window:j})=>j.document).find(j=>j.hasFocus())??o.mainWindow.document}function ye(){return he().defaultView?.window??o.mainWindow}const we=new Map;function Ie(K){return we.has(K)}function Te(){return new ce}class ce{constructor(){this._currentCssStyle="",this._styleSheet=void 0}setStyle(j){j!==this._currentCssStyle&&(this._currentCssStyle=j,this._styleSheet?this._styleSheet.innerText=j:this._styleSheet=Re(o.mainWindow.document.head,se=>se.innerText=j))}dispose(){this._styleSheet&&(this._styleSheet.remove(),this._styleSheet=void 0)}}function Re(K=o.mainWindow.document.head,j,se){const pe=document.createElement("style");if(pe.type="text/css",pe.media="screen",j?.(pe),K.appendChild(pe),se&&se.add((0,S.toDisposable)(()=>K.removeChild(pe))),K===o.mainWindow.document.head){const Ne=new Set;we.set(pe,Ne);for(const{window:He,disposables:xe}of(0,t.getWindows)()){if(He===o.mainWindow)continue;const Ke=xe.add(Ye(pe,Ne,He));se?.add(Ke)}}return pe}function Ue(K){const j=new S.DisposableStore;for(const[se,pe]of we)j.add(Ye(se,pe,K));return j}function Ye(K,j,se){const pe=new S.DisposableStore,Ne=K.cloneNode(!0);se.document.head.appendChild(Ne),pe.add((0,S.toDisposable)(()=>se.document.head.removeChild(Ne)));for(const He of X(K))Ne.sheet?.insertRule(He.cssText,Ne.sheet?.cssRules.length);return pe.add(t.sharedMutationObserver.observe(K,pe,{childList:!0})(()=>{Ne.textContent=K.textContent})),j.add(Ne),pe.add((0,S.toDisposable)(()=>j.delete(Ne))),pe}t.sharedMutationObserver=new class{constructor(){this.mutationObservers=new Map}observe(K,j,se){let pe=this.mutationObservers.get(K);pe||(pe=new Map,this.mutationObservers.set(K,pe));const Ne=(0,s.hash)(se);let He=pe.get(Ne);if(He)He.users+=1;else{const xe=new _.Emitter,Ke=new MutationObserver(je=>xe.fire(je));Ke.observe(K,se);const Ge=He={users:1,observer:Ke,onDidMutate:xe.event};j.add((0,S.toDisposable)(()=>{Ge.users-=1,Ge.users===0&&(xe.dispose(),Ke.disconnect(),pe?.delete(Ne),pe?.size===0&&this.mutationObservers.delete(K))})),pe.set(Ne,He)}return He.onDidMutate}};function et(K=o.mainWindow.document.head){return it("meta",K)}function ot(K=o.mainWindow.document.head){return it("link",K)}function it(K,j=o.mainWindow.document.head){const se=document.createElement(K);return j.appendChild(se),se}let $e=null;function Ze(){return $e||($e=Re()),$e}function X(K){return K?.sheet?.rules?K.sheet.rules:K?.sheet?.cssRules?K.sheet.cssRules:[]}function le(K,j,se=Ze()){if(!(!se||!j)){se.sheet?.insertRule(`${K} {${j}}`,0);for(const pe of we.get(se)??[])le(K,j,pe)}}function be(K,j=Ze()){if(!j)return;const se=X(j),pe=[];for(let Ne=0;Ne<se.length;Ne++){const He=se[Ne];Se(He)&&He.selectorText.indexOf(K)!==-1&&pe.push(Ne)}for(let Ne=pe.length-1;Ne>=0;Ne--)j.sheet?.deleteRule(pe[Ne]);for(const Ne of we.get(j)??[])be(K,Ne)}function Se(K){return typeof K.selectorText=="string"}function Me(K){return K instanceof HTMLElement||K instanceof(0,t.getWindow)(K).HTMLElement}function ze(K){return K instanceof HTMLAnchorElement||K instanceof(0,t.getWindow)(K).HTMLAnchorElement}function Qe(K){return K instanceof HTMLSpanElement||K instanceof(0,t.getWindow)(K).HTMLSpanElement}function st(K){return K instanceof HTMLTextAreaElement||K instanceof(0,t.getWindow)(K).HTMLTextAreaElement}function tt(K){return K instanceof HTMLInputElement||K instanceof(0,t.getWindow)(K).HTMLInputElement}function lt(K){return K instanceof HTMLButtonElement||K instanceof(0,t.getWindow)(K).HTMLButtonElement}function nt(K){return K instanceof HTMLDivElement||K instanceof(0,t.getWindow)(K).HTMLDivElement}function ht(K){return K instanceof MouseEvent||K instanceof(0,t.getWindow)(K).MouseEvent}function ut(K){return K instanceof KeyboardEvent||K instanceof(0,t.getWindow)(K).KeyboardEvent}function vt(K){return K instanceof PointerEvent||K instanceof(0,t.getWindow)(K).PointerEvent}function We(K){return K instanceof DragEvent||K instanceof(0,t.getWindow)(K).DragEvent}t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:i.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.isWebKit?"webkitAnimationIteration":"animationiteration"};function ge(K){const j=K;return!!(j&&typeof j.preventDefault=="function"&&typeof j.stopPropagation=="function")}t.EventHelper={stop:(K,j)=>(K.preventDefault(),j&&K.stopPropagation(),K)};function ke(K){const j=[];for(let se=0;K&&K.nodeType===K.ELEMENT_NODE;se++)j[se]=K.scrollTop,K=K.parentNode;return j}function Pe(K,j){for(let se=0;K&&K.nodeType===K.ELEMENT_NODE;se++)K.scrollTop!==j[se]&&(K.scrollTop=j[se]),K=K.parentNode}class qe extends S.Disposable{static hasFocusWithin(j){if(Me(j)){const se=B(j),pe=se?se.activeElement:j.ownerDocument.activeElement;return W(pe,j)}else{const se=j;return W(se.document.activeElement,se.document)}}constructor(j){super(),this._onDidFocus=this._register(new _.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new _.Emitter),this.onDidBlur=this._onDidBlur.event;let se=qe.hasFocusWithin(j),pe=!1;const Ne=()=>{pe=!1,se||(se=!0,this._onDidFocus.fire())},He=()=>{se&&(pe=!0,(Me(j)?(0,t.getWindow)(j):j).setTimeout(()=>{pe&&(pe=!1,se=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{qe.hasFocusWithin(j)!==se&&(se?He():Ne())},this._register(L(j,t.EventType.FOCUS,Ne,!0)),this._register(L(j,t.EventType.BLUR,He,!0)),Me(j)&&(this._register(L(j,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(L(j,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler())))}refreshState(){this._refreshStateHandler()}}function rt(K){return new qe(K)}function dt(K,j){return K.after(j),j}function Xe(K,...j){if(K.append(...j),j.length===1&&typeof j[0]!="string")return j[0]}function mt(K,j){return K.insertBefore(j,K.firstChild),j}function St(K,...j){K.innerText="",Xe(K,...j)}const Nt=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var wt;(function(K){K.HTML="http://www.w3.org/1999/xhtml",K.SVG="http://www.w3.org/2000/svg"})(wt||(t.Namespace=wt={}));function Xt(K,j,se,...pe){const Ne=Nt.exec(j);if(!Ne)throw new Error("Bad use of emmet");const He=Ne[1]||"div";let xe;return K!==wt.HTML?xe=document.createElementNS(K,He):xe=document.createElement(He),Ne[3]&&(xe.id=Ne[3]),Ne[4]&&(xe.className=Ne[4].replace(/\./g," ").trim()),se&&Object.entries(se).forEach(([Ke,Ge])=>{typeof Ge>"u"||(/^on\w+$/.test(Ke)?xe[Ke]=Ge:Ke==="selected"?Ge&&xe.setAttribute(Ke,"true"):xe.setAttribute(Ke,Ge))}),xe.append(...pe),xe}function Zt(K,j,...se){return Xt(wt.HTML,K,j,...se)}Zt.SVG=function(K,j,...se){return Xt(wt.SVG,K,j,...se)};function Ii(K,j){const se=[];return K.forEach((pe,Ne)=>{Ne>0&&(j instanceof Node?se.push(j.cloneNode()):se.push(document.createTextNode(j))),se.push(pe)}),se}function Ni(K,...j){K?Qt(...j):Jt(...j)}function Qt(...K){for(const j of K)j.style.display="",j.removeAttribute("aria-hidden")}function Jt(...K){for(const j of K)j.style.display="none",j.setAttribute("aria-hidden","true")}function Fi(K,j){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(Me(K)&&K.hasAttribute(j))return K;K=K.parentNode}return null}function Ri(K){!K||!K.hasAttribute("tabIndex")||(K.ownerDocument.activeElement===K&&Fi(K.parentElement,"tabIndex")?.focus(),K.removeAttribute("tabindex"))}function Ci(K){return j=>{j.preventDefault(),j.stopPropagation(),K(j)}}function Oi(K){return new Promise(j=>{if(K.document.readyState==="complete"||K.document&&K.document.body!==null)j(void 0);else{const pe=()=>{K.window.removeEventListener("DOMContentLoaded",pe,!1),j()};K.window.addEventListener("DOMContentLoaded",pe,!1)}})}function ki(K,j){const se=K.devicePixelRatio*j;return Math.max(1,Math.floor(se))/K.devicePixelRatio}function Mi(K){o.mainWindow.open(K,"_blank","noopener")}const ei=780,ti=640;function Pi(K){const j=Math.floor(o.mainWindow.screenLeft+o.mainWindow.innerWidth/2-ei/2),se=Math.floor(o.mainWindow.screenTop+o.mainWindow.innerHeight/2-ti/2);o.mainWindow.open(K,"_blank",`width=${ei},height=${ti},top=${se},left=${j}`)}function Bi(K,j=!0){const se=o.mainWindow.open();return se?(j&&(se.opener=null),se.location.href=K,!0):!1}function xi(K,j){const se=()=>{j(),pe=(0,t.scheduleAtNextAnimationFrame)(K,se)};let pe=(0,t.scheduleAtNextAnimationFrame)(K,se);return(0,S.toDisposable)(()=>pe.dispose())}b.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(o.mainWindow.location.href)?"https":"http");function Wi(K){return K?`url('${b.FileAccess.uriToBrowserUri(K).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Hi(K){return`'${K.replace(/'/g,"%27")}'`}function ii(K,j){if(K!==void 0){const se=K.match(/^\s*var\((.+)\)$/);if(se){const pe=se[1].split(",",2);return pe.length===2&&(j=ii(pe[1].trim(),j)),`var(${pe[0]}, ${j})`}return K}return j}function zi(K,j){let se;if(e.URI.isUri(K))se=K.toString(!0);else{const He=new Blob([K]);se=URL.createObjectURL(He),setTimeout(()=>URL.revokeObjectURL(se))}const pe=ye(),Ne=document.createElement("a");pe.document.body.appendChild(Ne),Ne.download=j,Ne.href=se,Ne.click(),setTimeout(()=>pe.document.body.removeChild(Ne))}function Ui(){return new Promise(K=>{const j=ye(),se=document.createElement("input");j.document.body.appendChild(se),se.type="file",se.multiple=!0,_.Event.once(_.Event.fromDOMEventEmitter(se,"input"))(()=>{K(se.files??void 0)}),se.click(),setTimeout(()=>j.document.body.removeChild(se))})}var At;(function(K){K[K.DOCUMENT=1]="DOCUMENT",K[K.BROWSER=2]="BROWSER"})(At||(t.DetectedFullscreenMode=At={}));function Vi(K){return K.document.fullscreenElement||K.document.webkitFullscreenElement||K.document.webkitIsFullScreen?{mode:At.DOCUMENT,guess:!1}:K.innerHeight===K.screen.height?{mode:At.BROWSER,guess:!1}:(m.isMacintosh||m.isLinux)&&K.outerHeight===K.screen.height&&K.outerWidth===K.screen.width?{mode:At.BROWSER,guess:!0}:null}function ni(K,j=!1){const se=document.createElement("a");return d.addHook("afterSanitizeAttributes",pe=>{for(const Ne of["href","src"])if(pe.hasAttribute(Ne)){const He=pe.getAttribute(Ne);if(Ne==="href"&&He.startsWith("#"))continue;if(se.href=He,!K.includes(se.protocol.replace(/:$/,""))){if(j&&Ne==="src"&&se.href.startsWith("data:"))continue;pe.removeAttribute(Ne)}}}),(0,S.toDisposable)(()=>{d.removeHook("afterSanitizeAttributes")})}const Ki=[b.Schemas.http,b.Schemas.https,b.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const $i=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function qi(K,j){const se=ni(Ki);try{const pe=d.sanitize(j,$i);K.innerHTML=pe}finally{se.dispose()}}function Gi(K){const j=new Uint16Array(K.length);for(let Ne=0;Ne<j.length;Ne++)j[Ne]=K.charCodeAt(Ne);let se="";const pe=new Uint8Array(j.buffer);for(let Ne=0;Ne<pe.length;Ne++)se+=String.fromCharCode(pe[Ne]);return se}function ji(K){return btoa(Gi(K))}class Et extends _.Emitter{constructor(){super(),this._subscriptions=new S.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(_.Event.runAndSubscribe(t.onDidRegisterWindow,({window:j,disposables:se})=>this.registerListeners(j,se),{window:o.mainWindow,disposables:this._subscriptions}))}registerListeners(j,se){se.add(L(j,"keydown",pe=>{if(pe.defaultPrevented)return;const Ne=new P.StandardKeyboardEvent(pe);if(!(Ne.keyCode===D.KeyCode.Alt&&pe.repeat)){if(pe.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(pe.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(pe.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(pe.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(Ne.keyCode!==D.KeyCode.Alt)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=pe.altKey,this._keyStatus.ctrlKey=pe.ctrlKey,this._keyStatus.metaKey=pe.metaKey,this._keyStatus.shiftKey=pe.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=pe,this.fire(this._keyStatus))}},!0)),se.add(L(j,"keyup",pe=>{pe.defaultPrevented||(!pe.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!pe.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!pe.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!pe.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=pe.altKey,this._keyStatus.ctrlKey=pe.ctrlKey,this._keyStatus.metaKey=pe.metaKey,this._keyStatus.shiftKey=pe.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=pe,this.fire(this._keyStatus)))},!0)),se.add(L(j.document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),se.add(L(j.document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),se.add(L(j.document.body,"mousemove",pe=>{pe.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),se.add(L(j,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return Et.instance||(Et.instance=new Et),Et.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=Et;function Yi(K){const j=document.cookie.match("(^|[^;]+)\\s*"+K+"\\s*=\\s*([^;]+)");return j?j.pop():void 0}class Xi extends S.Disposable{constructor(j,se){super(),this.element=j,this.callbacks=se,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this.callbacks.onDragStart&&this._register(L(this.element,t.EventType.DRAG_START,j=>{this.callbacks.onDragStart?.(j)})),this.callbacks.onDrag&&this._register(L(this.element,t.EventType.DRAG,j=>{this.callbacks.onDrag?.(j)})),this._register(L(this.element,t.EventType.DRAG_ENTER,j=>{this.counter++,this.dragStartTime=j.timeStamp,this.callbacks.onDragEnter?.(j)})),this._register(L(this.element,t.EventType.DRAG_OVER,j=>{j.preventDefault(),this.callbacks.onDragOver?.(j,j.timeStamp-this.dragStartTime)})),this._register(L(this.element,t.EventType.DRAG_LEAVE,j=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave?.(j))})),this._register(L(this.element,t.EventType.DRAG_END,j=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd?.(j)})),this._register(L(this.element,t.EventType.DROP,j=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop?.(j)}))}}t.DragAndDropObserver=Xi;const Zi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Qi(K,...j){let se,pe;Array.isArray(j[0])?(se={},pe=j[0]):(se=j[0]||{},pe=j[1]);const Ne=Zi.exec(K);if(!Ne||!Ne.groups)throw new Error("Bad use of h");const He=Ne.groups.tag||"div",xe=document.createElement(He);Ne.groups.id&&(xe.id=Ne.groups.id);const Ke=[];if(Ne.groups.class)for(const je of Ne.groups.class.split("."))je!==""&&Ke.push(je);if(se.className!==void 0)for(const je of se.className.split("."))je!==""&&Ke.push(je);Ke.length>0&&(xe.className=Ke.join(" "));const Ge={};if(Ne.groups.name&&(Ge[Ne.groups.name]=xe),pe)for(const je of pe)Me(je)?xe.appendChild(je):typeof je=="string"?xe.append(je):"root"in je&&(Object.assign(Ge,je),xe.appendChild(je.root));for(const[je,ct]of Object.entries(se))if(je!=="className")if(je==="style")for(const[Ft,xt]of Object.entries(ct))xe.style.setProperty(si(Ft),typeof xt=="number"?xt+"px":""+xt);else je==="tabIndex"?xe.tabIndex=ct:xe.setAttribute(si(je),ct.toString());return Ge.root=xe,Ge}function si(K){return K.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ri(K,j,se){for(const{name:pe,value:Ne}of K.attributes)(!se||se.includes(pe))&&j.setAttribute(pe,Ne)}function Ji(K,j,se){const pe=K.getAttribute(se);pe?j.setAttribute(se,pe):j.removeAttribute(se)}function en(K,j,se){ri(K,j,se);const pe=new S.DisposableStore;return pe.add(t.sharedMutationObserver.observe(K,pe,{attributes:!0,attributeFilter:se})(Ne=>{for(const He of Ne)He.type==="attributes"&&He.attributeName&&Ji(K,j,He.attributeName)})),pe}}),define(ve[70],De([1,0,4,2,133]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTransfers=t.DelayedDragHandler=void 0,t.applyDragImage=T;class O extends n.Disposable{constructor(_,d){super(),this._register((0,i.addDisposableListener)(_,"dragover",D=>{D.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{d(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(D=>{this._register((0,i.addDisposableListener)(_,D,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=O,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:P.Mimes.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function T(w,_,d,D,S){const b=document.createElement("div");if(b.className=d,b.textContent=_,S&&(b.style.color=S),D&&(b.style.background=D),w.dataTransfer){const m=(0,i.getWindow)(w).document;m.body.appendChild(b),w.dataTransfer.setDragImage(b,-10,-10),setTimeout(()=>m.body.removeChild(b),0)}}}),define(ve[71],De([1,0,4]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderText=n,t.renderFormattedText=P,t.createElement=O;function n(b,m={}){const e=O(m);return e.textContent=b,e}function P(b,m={}){const e=O(m);return _(e,d(b,!!m.renderCodeSegments),m.actionHandler,m.renderCodeSegments),e}function O(b){const m=b.inline?"span":"div",e=document.createElement(m);return b.className&&(e.className=b.className),e}class T{constructor(m){this.source=m,this.index=0}eos(){return this.index>=this.source.length}next(){const m=this.peek();return this.advance(),m}peek(){return this.source[this.index]}advance(){this.index++}}var w;(function(b){b[b.Invalid=0]="Invalid",b[b.Root=1]="Root",b[b.Text=2]="Text",b[b.Bold=3]="Bold",b[b.Italics=4]="Italics",b[b.Action=5]="Action",b[b.ActionClose=6]="ActionClose",b[b.Code=7]="Code",b[b.NewLine=8]="NewLine"})(w||(w={}));function _(b,m,e,s){let o;if(m.type===w.Text)o=document.createTextNode(m.content||"");else if(m.type===w.Bold)o=document.createElement("b");else if(m.type===w.Italics)o=document.createElement("i");else if(m.type===w.Code&&s)o=document.createElement("code");else if(m.type===w.Action&&e){const c=document.createElement("a");e.disposables.add(i.addStandardDisposableListener(c,"click",h=>{e.callback(String(m.index),h)})),o=c}else m.type===w.NewLine?o=document.createElement("br"):m.type===w.Root&&(o=b);o&&b!==o&&b.appendChild(o),o&&Array.isArray(m.children)&&m.children.forEach(c=>{_(o,c,e,s)})}function d(b,m){const e={type:w.Root,children:[]};let s=0,o=e;const c=[],h=new T(b);for(;!h.eos();){let p=h.next();const L=p==="\\"&&S(h.peek(),m)!==w.Invalid;if(L&&(p=h.next()),!L&&D(p,m)&&p===h.peek()){h.advance(),o.type===w.Text&&(o=c.pop());const y=S(p,m);if(o.type===y||o.type===w.Action&&y===w.ActionClose)o=c.pop();else{const r={type:y,children:[]};y===w.Action&&(r.index=s,s++),o.children.push(r),c.push(o),o=r}}else if(p===`
`)o.type===w.Text&&(o=c.pop()),o.children.push({type:w.NewLine});else if(o.type!==w.Text){const y={type:w.Text,content:p};o.children.push(y),c.push(o),o=y}else o.content+=p}return o.type===w.Text&&(o=c.pop()),c.length,e}function D(b,m){return S(b,m)!==w.Invalid}function S(b,m){switch(b){case"*":return w.Bold;case"_":return w.Italics;case"[":return w.Action;case"]":return w.ActionClose;case"`":return m?w.Code:w.Invalid;default:return w.Invalid}}}),define(ve[72],De([1,0,4,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class P{constructor(){this._hooks=new n.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(T,w){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const _=this._onStopCallback;this._onStopCallback=null,T&&_&&_(w)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(T,w,_,d,D){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=d,this._onStopCallback=D;let S=T;try{T.setPointerCapture(w),this._hooks.add((0,n.toDisposable)(()=>{try{T.releasePointerCapture(w)}catch{}}))}catch{S=i.getWindow(T)}this._hooks.add(i.addDisposableListener(S,i.EventType.POINTER_MOVE,b=>{if(b.buttons!==_){this.stopMonitoring(!0);return}b.preventDefault(),this._pointerMoveCallback(b)})),this._hooks.add(i.addDisposableListener(S,i.EventType.POINTER_UP,b=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=P});var Je=this&&this.__decorate||function(oe,t,i,n){var P=arguments.length,O=P<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,i):n,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(oe,t,i,n);else for(var w=oe.length-1;w>=0;w--)(T=oe[w])&&(O=(P<3?T(O):P>3?T(t,i,O):T(t,i))||O);return P>3&&O&&Object.defineProperty(t,i,O),O};define(ve[31],De([1,0,4,25,9,34,3,2,59]),function(oe,t,i,n,P,O,T,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var d;(function(S){S.Tap="-monaco-gesturetap",S.Change="-monaco-gesturechange",S.Start="-monaco-gesturestart",S.End="-monaco-gesturesend",S.Contextmenu="-monaco-gesturecontextmenu"})(d||(t.EventType=d={}));class D extends w.Disposable{static{this.SCROLL_FRICTION=-.005}static{this.HOLD_DELAY=700}static{this.CLEAR_TAP_COUNT_TIME=400}constructor(){super(),this.dispatched=!1,this.targets=new _.LinkedList,this.ignoreTargets=new _.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(T.Event.runAndSubscribe(i.onDidRegisterWindow,({window:b,disposables:m})=>{m.add(i.addDisposableListener(b.document,"touchstart",e=>this.onTouchStart(e),{passive:!1})),m.add(i.addDisposableListener(b.document,"touchend",e=>this.onTouchEnd(b,e))),m.add(i.addDisposableListener(b.document,"touchmove",e=>this.onTouchMove(e),{passive:!1}))},{window:n.mainWindow,disposables:this._store}))}static addTarget(b){if(!D.isTouchDevice())return w.Disposable.None;D.INSTANCE||(D.INSTANCE=(0,w.markAsSingleton)(new D));const m=D.INSTANCE.targets.push(b);return(0,w.toDisposable)(m)}static ignoreTarget(b){if(!D.isTouchDevice())return w.Disposable.None;D.INSTANCE||(D.INSTANCE=(0,w.markAsSingleton)(new D));const m=D.INSTANCE.ignoreTargets.push(b);return(0,w.toDisposable)(m)}static isTouchDevice(){return"ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(b){const m=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let e=0,s=b.targetTouches.length;e<s;e++){const o=b.targetTouches.item(e);this.activeTouches[o.identifier]={id:o.identifier,initialTarget:o.target,initialTimeStamp:m,initialPageX:o.pageX,initialPageY:o.pageY,rollingTimestamps:[m],rollingPageX:[o.pageX],rollingPageY:[o.pageY]};const c=this.newGestureEvent(d.Start,o.target);c.pageX=o.pageX,c.pageY=o.pageY,this.dispatchEvent(c)}this.dispatched&&(b.preventDefault(),b.stopPropagation(),this.dispatched=!1)}onTouchEnd(b,m){const e=Date.now(),s=Object.keys(this.activeTouches).length;for(let o=0,c=m.changedTouches.length;o<c;o++){const h=m.changedTouches.item(o);if(!this.activeTouches.hasOwnProperty(String(h.identifier))){console.warn("move of an UNKNOWN touch",h);continue}const p=this.activeTouches[h.identifier],L=Date.now()-p.initialTimeStamp;if(L<D.HOLD_DELAY&&Math.abs(p.initialPageX-P.tail(p.rollingPageX))<30&&Math.abs(p.initialPageY-P.tail(p.rollingPageY))<30){const y=this.newGestureEvent(d.Tap,p.initialTarget);y.pageX=P.tail(p.rollingPageX),y.pageY=P.tail(p.rollingPageY),this.dispatchEvent(y)}else if(L>=D.HOLD_DELAY&&Math.abs(p.initialPageX-P.tail(p.rollingPageX))<30&&Math.abs(p.initialPageY-P.tail(p.rollingPageY))<30){const y=this.newGestureEvent(d.Contextmenu,p.initialTarget);y.pageX=P.tail(p.rollingPageX),y.pageY=P.tail(p.rollingPageY),this.dispatchEvent(y)}else if(s===1){const y=P.tail(p.rollingPageX),r=P.tail(p.rollingPageY),f=P.tail(p.rollingTimestamps)-p.rollingTimestamps[0],E=y-p.rollingPageX[0],I=r-p.rollingPageY[0],H=[...this.targets].filter(z=>p.initialTarget instanceof Node&&z.contains(p.initialTarget));this.inertia(b,H,e,Math.abs(E)/f,E>0?1:-1,y,Math.abs(I)/f,I>0?1:-1,r)}this.dispatchEvent(this.newGestureEvent(d.End,p.initialTarget)),delete this.activeTouches[h.identifier]}this.dispatched&&(m.preventDefault(),m.stopPropagation(),this.dispatched=!1)}newGestureEvent(b,m){const e=document.createEvent("CustomEvent");return e.initEvent(b,!1,!0),e.initialTarget=m,e.tapCount=0,e}dispatchEvent(b){if(b.type===d.Tap){const m=new Date().getTime();let e=0;m-this._lastSetTapCountTime>D.CLEAR_TAP_COUNT_TIME?e=1:e=2,this._lastSetTapCountTime=m,b.tapCount=e}else(b.type===d.Change||b.type===d.Contextmenu)&&(this._lastSetTapCountTime=0);if(b.initialTarget instanceof Node){for(const e of this.ignoreTargets)if(e.contains(b.initialTarget))return;const m=[];for(const e of this.targets)if(e.contains(b.initialTarget)){let s=0,o=b.initialTarget;for(;o&&o!==e;)s++,o=o.parentElement;m.push([s,e])}m.sort((e,s)=>e[0]-s[0]);for(const[e,s]of m)s.dispatchEvent(b),this.dispatched=!0}}inertia(b,m,e,s,o,c,h,p,L){this.handle=i.scheduleAtNextAnimationFrame(b,()=>{const y=Date.now(),r=y-e;let f=0,E=0,I=!0;s+=D.SCROLL_FRICTION*r,h+=D.SCROLL_FRICTION*r,s>0&&(I=!1,f=o*s*r),h>0&&(I=!1,E=p*h*r);const H=this.newGestureEvent(d.Change);H.translationX=f,H.translationY=E,m.forEach(z=>z.dispatchEvent(H)),I||this.inertia(b,m,y,s,o,c+f,h,p,L+E)})}onTouchMove(b){const m=Date.now();for(let e=0,s=b.changedTouches.length;e<s;e++){const o=b.changedTouches.item(e);if(!this.activeTouches.hasOwnProperty(String(o.identifier))){console.warn("end of an UNKNOWN touch",o);continue}const c=this.activeTouches[o.identifier],h=this.newGestureEvent(d.Change,c.initialTarget);h.translationX=o.pageX-P.tail(c.rollingPageX),h.translationY=o.pageY-P.tail(c.rollingPageY),h.pageX=o.pageX,h.pageY=o.pageY,this.dispatchEvent(h),c.rollingPageX.length>3&&(c.rollingPageX.shift(),c.rollingPageY.shift(),c.rollingTimestamps.shift()),c.rollingPageX.push(o.pageX),c.rollingPageY.push(o.pageY),c.rollingTimestamps.push(m)}this.dispatched&&(b.preventDefault(),b.stopPropagation(),this.dispatched=!1)}}t.Gesture=D,Je([O.memoize],D,"isTouchDevice",null)}),define(ve[73],De([1,0,4,108]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setARIAContainer=d,t.alert=D,t.status=S;const n=2e4;let P,O,T,w,_;function d(m){P=document.createElement("div"),P.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),P.appendChild(o),o};O=e(),T=e();const s=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),P.appendChild(o),o};w=s(),_=s(),m.appendChild(P)}function D(m){P&&(O.textContent!==m?(i.clearNode(T),b(O,m)):(i.clearNode(O),b(T,m)))}function S(m){P&&(w.textContent!==m?(i.clearNode(_),b(w,m)):(i.clearNode(w),b(_,m)))}function b(m,e){i.clearNode(m),e.length>n&&(e=e.substr(0,n)),m.textContent=e,m.style.visibility="hidden",m.style.visibility="visible"}}),define(ve[74],De([1,0,68,4,2,5,47,112]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ContextView=t.LayoutAnchorMode=t.LayoutAnchorPosition=t.AnchorAxisAlignment=t.AnchorPosition=t.AnchorAlignment=t.ContextViewDOMPosition=void 0,t.isAnchor=_,t.layout=e;var w;(function(c){c[c.ABSOLUTE=1]="ABSOLUTE",c[c.FIXED=2]="FIXED",c[c.FIXED_SHADOW=3]="FIXED_SHADOW"})(w||(t.ContextViewDOMPosition=w={}));function _(c){const h=c;return!!h&&typeof h.x=="number"&&typeof h.y=="number"}var d;(function(c){c[c.LEFT=0]="LEFT",c[c.RIGHT=1]="RIGHT"})(d||(t.AnchorAlignment=d={}));var D;(function(c){c[c.BELOW=0]="BELOW",c[c.ABOVE=1]="ABOVE"})(D||(t.AnchorPosition=D={}));var S;(function(c){c[c.VERTICAL=0]="VERTICAL",c[c.HORIZONTAL=1]="HORIZONTAL"})(S||(t.AnchorAxisAlignment=S={}));var b;(function(c){c[c.Before=0]="Before",c[c.After=1]="After"})(b||(t.LayoutAnchorPosition=b={}));var m;(function(c){c[c.AVOID=0]="AVOID",c[c.ALIGN=1]="ALIGN"})(m||(t.LayoutAnchorMode=m={}));function e(c,h,p){const L=p.mode===m.ALIGN?p.offset:p.offset+p.size,y=p.mode===m.ALIGN?p.offset+p.size:p.offset;return p.position===b.Before?h<=c-L?L:h<=y?y-h:Math.max(c-h,0):h<=y?y-h:h<=c-L?L:0}class s extends P.Disposable{static{this.BUBBLE_UP_EVENTS=["click","keydown","focus","blur"]}static{this.BUBBLE_DOWN_EVENTS=["click"]}constructor(h,p){super(),this.container=null,this.useFixedPosition=!1,this.useShadowDOM=!1,this.delegate=null,this.toDisposeOnClean=P.Disposable.None,this.toDisposeOnSetContainer=P.Disposable.None,this.shadowRoot=null,this.shadowRootHostElement=null,this.view=n.$(".context-view"),n.hide(this.view),this.setContainer(h,p),this._register((0,P.toDisposable)(()=>this.setContainer(null,w.ABSOLUTE)))}setContainer(h,p){this.useFixedPosition=p!==w.ABSOLUTE;const L=this.useShadowDOM;if(this.useShadowDOM=p===w.FIXED_SHADOW,!(h===this.container&&L===this.useShadowDOM)&&(this.container&&(this.toDisposeOnSetContainer.dispose(),this.shadowRoot?(this.shadowRoot.removeChild(this.view),this.shadowRoot=null,this.shadowRootHostElement?.remove(),this.shadowRootHostElement=null):this.container.removeChild(this.view),this.container=null),h)){if(this.container=h,this.useShadowDOM){this.shadowRootHostElement=n.$(".shadow-root-host"),this.container.appendChild(this.shadowRootHostElement),this.shadowRoot=this.shadowRootHostElement.attachShadow({mode:"open"});const r=document.createElement("style");r.textContent=o,this.shadowRoot.appendChild(r),this.shadowRoot.appendChild(this.view),this.shadowRoot.appendChild(n.$("slot"))}else this.container.appendChild(this.view);const y=new P.DisposableStore;s.BUBBLE_UP_EVENTS.forEach(r=>{y.add(n.addStandardDisposableListener(this.container,r,f=>{this.onDOMEvent(f,!1)}))}),s.BUBBLE_DOWN_EVENTS.forEach(r=>{y.add(n.addStandardDisposableListener(this.container,r,f=>{this.onDOMEvent(f,!0)},!0))}),this.toDisposeOnSetContainer=y}}show(h){this.isVisible()&&this.hide(),n.clearNode(this.view),this.view.className="context-view monaco-component",this.view.style.top="0px",this.view.style.left="0px",this.view.style.zIndex=`${2575+(h.layer??0)}`,this.view.style.position=this.useFixedPosition?"fixed":"absolute",n.show(this.view),this.toDisposeOnClean=h.render(this.view)||P.Disposable.None,this.delegate=h,this.doLayout(),this.delegate.focus?.()}getViewElement(){return this.view}layout(){if(this.isVisible()){if(this.delegate.canRelayout===!1&&!(O.isIOS&&i.BrowserFeatures.pointerEvents)){this.hide();return}this.delegate?.layout?.(),this.doLayout()}}doLayout(){if(!this.isVisible())return;const h=this.delegate.getAnchor();let p;if(n.isHTMLElement(h)){const v=n.getDomNodePagePosition(h),k=n.getDomNodeZoomLevel(h);p={top:v.top*k,left:v.left*k,width:v.width*k,height:v.height*k}}else _(h)?p={top:h.y,left:h.x,width:h.width||1,height:h.height||2}:p={top:h.posy,left:h.posx,width:2,height:2};const L=n.getTotalWidth(this.view),y=n.getTotalHeight(this.view),r=this.delegate.anchorPosition||D.BELOW,f=this.delegate.anchorAlignment||d.LEFT,E=this.delegate.anchorAxisAlignment||S.VERTICAL;let I,H;const z=n.getActiveWindow();if(E===S.VERTICAL){const v={offset:p.top-z.pageYOffset,size:p.height,position:r===D.BELOW?b.Before:b.After},k={offset:p.left,size:p.width,position:f===d.LEFT?b.Before:b.After,mode:m.ALIGN};I=e(z.innerHeight,y,v)+z.pageYOffset,T.Range.intersects({start:I,end:I+y},{start:v.offset,end:v.offset+v.size})&&(k.mode=m.AVOID),H=e(z.innerWidth,L,k)}else{const v={offset:p.left,size:p.width,position:f===d.LEFT?b.Before:b.After},k={offset:p.top,size:p.height,position:r===D.BELOW?b.Before:b.After,mode:m.ALIGN};H=e(z.innerWidth,L,v),T.Range.intersects({start:H,end:H+L},{start:v.offset,end:v.offset+v.size})&&(k.mode=m.AVOID),I=e(z.innerHeight,y,k)+z.pageYOffset}this.view.classList.remove("top","bottom","left","right"),this.view.classList.add(r===D.BELOW?"bottom":"top"),this.view.classList.add(f===d.LEFT?"left":"right"),this.view.classList.toggle("fixed",this.useFixedPosition);const U=n.getDomNodePagePosition(this.container);this.view.style.top=`${I-(this.useFixedPosition?n.getDomNodePagePosition(this.view).top:U.top)}px`,this.view.style.left=`${H-(this.useFixedPosition?n.getDomNodePagePosition(this.view).left:U.left)}px`,this.view.style.width="initial"}hide(h){const p=this.delegate;this.delegate=null,p?.onHide&&p.onHide(h),this.toDisposeOnClean.dispose(),n.hide(this.view)}isVisible(){return!!this.delegate}onDOMEvent(h,p){this.delegate&&(this.delegate.onDOMEvent?this.delegate.onDOMEvent(h,n.getWindow(h).document.activeElement):p&&!n.isAncestor(h.target,this.container)&&this.hide())}dispose(){this.hide(),super.dispose()}}t.ContextView=s;const o=`
	:host {
		all: initial; /* 1st rule so subsequent properties are reset. */
	}

	.codicon[class*='codicon-'] {
		font: normal normal normal 16px/1 codicon;
		display: inline-block;
		text-decoration: none;
		text-rendering: auto;
		text-align: center;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		user-select: none;
		-webkit-user-select: none;
		-ms-user-select: none;
	}

	:host {
		font-family: -apple-system, BlinkMacSystemFont, "Segoe WPC", "Segoe UI", "HelveticaNeue-Light", system-ui, "Ubuntu", "Droid Sans", sans-serif;
	}

	:host-context(.mac) { font-family: -apple-system, BlinkMacSystemFont, sans-serif; }
	:host-context(.mac:lang(zh-Hans)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang SC", "Hiragino Sans GB", sans-serif; }
	:host-context(.mac:lang(zh-Hant)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang TC", sans-serif; }
	:host-context(.mac:lang(ja)) { font-family: -apple-system, BlinkMacSystemFont, "Hiragino Kaku Gothic Pro", sans-serif; }
	:host-context(.mac:lang(ko)) { font-family: -apple-system, BlinkMacSystemFont, "Nanum Gothic", "Apple SD Gothic Neo", "AppleGothic", sans-serif; }

	:host-context(.windows) { font-family: "Segoe WPC", "Segoe UI", sans-serif; }
	:host-context(.windows:lang(zh-Hans)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft YaHei", sans-serif; }
	:host-context(.windows:lang(zh-Hant)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft Jhenghei", sans-serif; }
	:host-context(.windows:lang(ja)) { font-family: "Segoe WPC", "Segoe UI", "Yu Gothic UI", "Meiryo UI", sans-serif; }
	:host-context(.windows:lang(ko)) { font-family: "Segoe WPC", "Segoe UI", "Malgun Gothic", "Dotom", sans-serif; }

	:host-context(.linux) { font-family: system-ui, "Ubuntu", "Droid Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hans)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans SC", "Source Han Sans CN", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hant)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans TC", "Source Han Sans TW", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ja)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans J", "Source Han Sans JP", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ko)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans K", "Source Han Sans JR", "Source Han Sans", "UnDotum", "FBaekmuk Gulim", sans-serif; }
`}),define(ve[135],De([1,0,4,22]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderLabelWithIcons=O,t.renderIcon=T;const P=new RegExp(`(\\\\)?\\$\\((${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?)\\)`,"g");function O(w){const _=new Array;let d,D=0,S=0;for(;(d=P.exec(w))!==null;){S=d.index||0,D<S&&_.push(w.substring(D,S)),D=(d.index||0)+d[0].length;const[,b,m]=d;_.push(b?`$(${m})`:T({id:m}))}return D<w.length&&_.push(w.substring(D)),_}function T(w){const _=i.$("span");return _.classList.add(...n.ThemeIcon.asClassNameArray(w)),_}}),define(ve[136],De([1,0,4]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function n(O){try{O.parentElement?.removeChild(O)}catch{}}class P{constructor(T){this.renderers=T,this.cache=new Map,this.transactionNodesPendingRemoval=new Set,this.inTransaction=!1}alloc(T){let w=this.getTemplateCache(T).pop(),_=!1;if(w)_=this.transactionNodesPendingRemoval.has(w.domNode),_&&this.transactionNodesPendingRemoval.delete(w.domNode);else{const d=(0,i.$)(".monaco-list-row"),S=this.getRenderer(T).renderTemplate(d);w={domNode:d,templateId:T,templateData:S}}return{row:w,isReusingConnectedDomNode:_}}release(T){T&&this.releaseRow(T)}transact(T){if(this.inTransaction)throw new Error("Already in transaction");this.inTransaction=!0;try{T()}finally{for(const w of this.transactionNodesPendingRemoval)this.doRemoveNode(w);this.transactionNodesPendingRemoval.clear(),this.inTransaction=!1}}releaseRow(T){const{domNode:w,templateId:_}=T;w&&(this.inTransaction?this.transactionNodesPendingRemoval.add(w):this.doRemoveNode(w)),this.getTemplateCache(_).push(T)}doRemoveNode(T){T.classList.remove("scrolling"),n(T)}getTemplateCache(T){let w=this.cache.get(T);return w||(w=[],this.cache.set(T,w)),w}dispose(){this.cache.forEach((T,w)=>{for(const _ of T)this.getRenderer(w).disposeTemplate(_.templateData),_.templateData=null}),this.cache.clear(),this.transactionNodesPendingRemoval.clear()}getRenderer(T){const w=this.renderers.get(T);if(!w)throw new Error(`No renderer found for ${T}`);return w}}t.RowCache=P}),define(ve[137],De([1,0,12,2,20]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class O extends n.Disposable{constructor(w,_,d){super(),this._visibility=w,this._visibleClassName=_,this._invisibleClassName=d,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new i.TimeoutTimer)}setVisibility(w){this._visibility!==w&&(this._visibility=w,this._updateShouldBeVisible())}setShouldBeVisible(w){this._rawShouldBeVisible=w,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===P.ScrollbarVisibility.Hidden?!1:this._visibility===P.ScrollbarVisibility.Visible?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const w=this._applyVisibilitySetting();this._shouldBeVisible!==w&&(this._shouldBeVisible=w,this.ensureVisibility())}setIsNeeded(w){this._isNeeded!==w&&(this._isNeeded=w,this.ensureVisibility())}setDomNode(w){this._domNode=w,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(w){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(w?" fade":"")))}}t.ScrollbarVisibilityController=O}),define(ve[138],De([1,0,4,31,9,3,8,2,5]),function(oe,t,i,n,P,O,T,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class d extends w.Disposable{constructor(S,b,m,e){super(),this.selected=0,this.selectBoxOptions=e||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new O.Emitter),this.styles=m,this.registerListeners(),this.setOptions(S,b)}registerListeners(){this._register(n.Gesture.addTarget(this.selectElement)),[n.EventType.Tap].forEach(S=>{this._register(i.addDisposableListener(this.selectElement,S,b=>{this.selectElement.focus()}))}),this._register(i.addStandardDisposableListener(this.selectElement,"click",S=>{i.EventHelper.stop(S,!0)})),this._register(i.addStandardDisposableListener(this.selectElement,"change",S=>{this.selectElement.title=S.target.value,this._onDidSelect.fire({index:S.target.selectedIndex,selected:S.target.value})})),this._register(i.addStandardDisposableListener(this.selectElement,"keydown",S=>{let b=!1;_.isMacintosh?(S.keyCode===T.KeyCode.DownArrow||S.keyCode===T.KeyCode.UpArrow||S.keyCode===T.KeyCode.Space)&&(b=!0):(S.keyCode===T.KeyCode.DownArrow&&S.altKey||S.keyCode===T.KeyCode.Space||S.keyCode===T.KeyCode.Enter)&&(b=!0),b&&S.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(S,b){(!this.options||!P.equals(this.options,S))&&(this.options=S,this.selectElement.options.length=0,this.options.forEach((m,e)=>{this.selectElement.add(this.createOption(m.text,e,m.isDisabled))})),b!==void 0&&this.select(b)}select(S){this.options.length===0?this.selected=0:S>=0&&S<this.options.length?this.selected=S:S>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(S){this.selectBoxOptions.ariaLabel=S,this.selectElement.setAttribute("aria-label",S)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setEnabled(S){this.selectElement.disabled=!S}setFocusable(S){this.selectElement.tabIndex=S?0:-1}render(S){S.classList.add("select-container"),S.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(S){this.styles=S,this.applyStyles()}applyStyles(){this.selectElement&&(this.selectElement.style.backgroundColor=this.styles.selectBackground??"",this.selectElement.style.color=this.styles.selectForeground??"",this.selectElement.style.borderColor=this.styles.selectBorder??"")}createOption(S,b,m){const e=document.createElement("option");return e.value=S,e.text=S,e.disabled=!!m,e}}t.SelectBoxNative=d}),define(ve[75],De([1,0,33,9,12,62,103,3,35]),function(oe,t,i,n,P,O,T,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=void 0,t.isFilterResult=d,t.getVisibleState=D;function d(m){return typeof m=="object"&&"visibility"in m&&"data"in m}function D(m){switch(m){case!0:return i.TreeVisibility.Visible;case!1:return i.TreeVisibility.Hidden;default:return m}}function S(m){return typeof m.collapsible=="boolean"}class b{constructor(e,s,o,c={}){this.user=e,this.list=s,this.rootRef=[],this.eventBufferer=new w.EventBufferer,this._onDidChangeCollapseState=new w.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new w.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new w.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new P.Delayer(O.MicrotaskDelay),this.collapseByDefault=typeof c.collapseByDefault>"u"?!1:c.collapseByDefault,this.allowNonCollapsibleParents=c.allowNonCollapsibleParents??!1,this.filter=c.filter,this.autoExpandSingleChildren=typeof c.autoExpandSingleChildren>"u"?!1:c.autoExpandSingleChildren,this.root={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0}}splice(e,s,o=_.Iterable.empty(),c={}){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");c.diffIdentityProvider?this.spliceSmart(c.diffIdentityProvider,e,s,o,c):this.spliceSimple(e,s,o,c)}spliceSmart(e,s,o,c=_.Iterable.empty(),h,p=h.diffDepth??0){const{parentNode:L}=this.getParentNodeWithListIndex(s);if(!L.lastDiffIds)return this.spliceSimple(s,o,c,h);const y=[...c],r=s[s.length-1],f=new T.LcsDiff({getElements:()=>L.lastDiffIds},{getElements:()=>[...L.children.slice(0,r),...y,...L.children.slice(r+o)].map(U=>e.getId(U.element).toString())}).ComputeDiff(!1);if(f.quitEarly)return L.lastDiffIds=void 0,this.spliceSimple(s,o,y,h);const E=s.slice(0,-1),I=(U,v,k)=>{if(p>0)for(let x=0;x<k;x++)U--,v--,this.spliceSmart(e,[...E,U,0],Number.MAX_SAFE_INTEGER,y[v].children,h,p-1)};let H=Math.min(L.children.length,r+o),z=y.length;for(const U of f.changes.sort((v,k)=>k.originalStart-v.originalStart))I(H,z,H-(U.originalStart+U.originalLength)),H=U.originalStart,z=U.modifiedStart-r,this.spliceSimple([...E,H],U.originalLength,_.Iterable.slice(y,z,z+U.modifiedLength),h);I(H,z,H)}spliceSimple(e,s,o=_.Iterable.empty(),{onDidCreateNode:c,onDidDeleteNode:h,diffIdentityProvider:p}){const{parentNode:L,listIndex:y,revealed:r,visible:f}=this.getParentNodeWithListIndex(e),E=[],I=_.Iterable.map(o,$=>this.createTreeNode($,L,L.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,r,E,c)),H=e[e.length-1];let z=0;for(let $=H;$>=0&&$<L.children.length;$--){const ne=L.children[$];if(ne.visible){z=ne.visibleChildIndex;break}}const U=[];let v=0,k=0;for(const $ of I)U.push($),k+=$.renderNodeCount,$.visible&&($.visibleChildIndex=z+v++);const x=(0,n.splice)(L.children,H,s,U);p?L.lastDiffIds?(0,n.splice)(L.lastDiffIds,H,s,U.map($=>p.getId($.element).toString())):L.lastDiffIds=L.children.map($=>p.getId($.element).toString()):L.lastDiffIds=void 0;let N=0;for(const $ of x)$.visible&&N++;if(N!==0)for(let $=H+U.length;$<L.children.length;$++){const ne=L.children[$];ne.visible&&(ne.visibleChildIndex-=N)}if(L.visibleChildrenCount+=v-N,r&&f){const $=x.reduce((ne,Z)=>ne+(Z.visible?Z.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(L,k-$),this.list.splice(y,$,E)}if(x.length>0&&h){const $=ne=>{h(ne),ne.children.forEach($)};x.forEach($)}this._onDidSplice.fire({insertedNodes:U,deletedNodes:x});let M=L;for(;M;){if(M.visibility===i.TreeVisibility.Recurse){this.refilterDelayer.trigger(()=>this.refilter());break}M=M.parent}}rerender(e){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");const{node:s,listIndex:o,revealed:c}=this.getTreeNodeWithListIndex(e);s.visible&&c&&this.list.splice(o,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");const{listIndex:o}=this.getTreeNodeWithListIndex(e);this.list.updateElementHeight(o,s)}has(e){return this.hasTreeNode(e)}getListIndex(e){const{listIndex:s,visible:o,revealed:c}=this.getTreeNodeWithListIndex(e);return o&&c?s:-1}getListRenderCount(e){return this.getTreeNode(e).renderNodeCount}isCollapsible(e){return this.getTreeNode(e).collapsible}setCollapsible(e,s){const o=this.getTreeNode(e);typeof s>"u"&&(s=!o.collapsible);const c={collapsible:s};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,c))}isCollapsed(e){return this.getTreeNode(e).collapsed}setCollapsed(e,s,o){const c=this.getTreeNode(e);typeof s>"u"&&(s=!c.collapsed);const h={collapsed:s,recursive:o||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,h))}_setCollapseState(e,s){const{node:o,listIndex:c,revealed:h}=this.getTreeNodeWithListIndex(e),p=this._setListNodeCollapseState(o,c,h,s);if(o!==this.root&&this.autoExpandSingleChildren&&p&&!S(s)&&o.collapsible&&!o.collapsed&&!s.recursive){let L=-1;for(let y=0;y<o.children.length;y++)if(o.children[y].visible)if(L>-1){L=-1;break}else L=y;L>-1&&this._setCollapseState([...e,L],s)}return p}_setListNodeCollapseState(e,s,o,c){const h=this._setNodeCollapseState(e,c,!1);if(!o||!e.visible||!h)return h;const p=e.renderNodeCount,L=this.updateNodeAfterCollapseChange(e),y=p-(s===-1?0:1);return this.list.splice(s+1,y,L.slice(1)),h}_setNodeCollapseState(e,s,o){let c;if(e===this.root?c=!1:(S(s)?(c=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(c=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):c=!1,c&&this._onDidChangeCollapseState.fire({node:e,deep:o})),!S(s)&&s.recursive)for(const h of e.children)c=this._setNodeCollapseState(h,s,!0)||c;return c}expandTo(e){this.eventBufferer.bufferEvents(()=>{let s=this.getTreeNode(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this._setCollapseState(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.root.renderNodeCount,s=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,s),this.refilterDelayer.cancel()}createTreeNode(e,s,o,c,h,p){const L={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.collapseByDefault:e.collapsed,renderNodeCount:1,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0},y=this._filterNode(L,o);L.visibility=y,c&&h.push(L);const r=e.children||_.Iterable.empty(),f=c&&y!==i.TreeVisibility.Hidden&&!L.collapsed;let E=0,I=1;for(const H of r){const z=this.createTreeNode(H,L,y,f,h,p);L.children.push(z),I+=z.renderNodeCount,z.visible&&(z.visibleChildIndex=E++)}return this.allowNonCollapsibleParents||(L.collapsible=L.collapsible||L.children.length>0),L.visibleChildrenCount=E,L.visible=y===i.TreeVisibility.Recurse?E>0:y===i.TreeVisibility.Visible,L.visible?L.collapsed||(L.renderNodeCount=I):(L.renderNodeCount=0,c&&h.pop()),p?.(L),L}updateNodeAfterCollapseChange(e){const s=e.renderNodeCount,o=[];return this._updateNodeAfterCollapseChange(e,o),this._updateAncestorsRenderNodeCount(e.parent,o.length-s),o}_updateNodeAfterCollapseChange(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this._updateNodeAfterCollapseChange(o,s);return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount}updateNodeAfterFilterChange(e){const s=e.renderNodeCount,o=[];return this._updateNodeAfterFilterChange(e,e.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,o),this._updateAncestorsRenderNodeCount(e.parent,o.length-s),o}_updateNodeAfterFilterChange(e,s,o,c=!0){let h;if(e!==this.root){if(h=this._filterNode(e,s),h===i.TreeVisibility.Hidden)return e.visible=!1,e.renderNodeCount=0,!1;c&&o.push(e)}const p=o.length;e.renderNodeCount=e===this.root?0:1;let L=!1;if(!e.collapsed||h!==i.TreeVisibility.Hidden){let y=0;for(const r of e.children)L=this._updateNodeAfterFilterChange(r,h,o,c&&!e.collapsed)||L,r.visible&&(r.visibleChildIndex=y++);e.visibleChildrenCount=y}else e.visibleChildrenCount=0;return e!==this.root&&(e.visible=h===i.TreeVisibility.Recurse?L:h===i.TreeVisibility.Visible,e.visibility=h),e.visible?e.collapsed||(e.renderNodeCount+=o.length-p):(e.renderNodeCount=0,c&&o.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible}_updateAncestorsRenderNodeCount(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this._onDidChangeRenderNodeCount.fire(e),e=e.parent}_filterNode(e,s){const o=this.filter?this.filter.filter(e.element,s):i.TreeVisibility.Visible;return typeof o=="boolean"?(e.filterData=void 0,o?i.TreeVisibility.Visible:i.TreeVisibility.Hidden):d(o)?(e.filterData=o.data,D(o.visibility)):(e.filterData=void 0,D(o))}hasTreeNode(e,s=this.root){if(!e||e.length===0)return!0;const[o,...c]=e;return o<0||o>s.children.length?!1:this.hasTreeNode(c,s.children[o])}getTreeNode(e,s=this.root){if(!e||e.length===0)return s;const[o,...c]=e;if(o<0||o>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");return this.getTreeNode(c,s.children[o])}getTreeNodeWithListIndex(e){if(e.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:o,revealed:c,visible:h}=this.getParentNodeWithListIndex(e),p=e[e.length-1];if(p<0||p>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");const L=s.children[p];return{node:L,listIndex:o,revealed:c,visible:h&&L.visible}}getParentNodeWithListIndex(e,s=this.root,o=0,c=!0,h=!0){const[p,...L]=e;if(p<0||p>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");for(let y=0;y<p;y++)o+=s.children[y].renderNodeCount;return c=c&&!s.collapsed,h=h&&s.visible,L.length===0?{parentNode:s,listIndex:o,revealed:c,visible:h}:this.getParentNodeWithListIndex(L,s.children[p],o+1,c,h)}getNode(e=[]){return this.getTreeNode(e)}getNodeLocation(e){const s=[];let o=e;for(;o.parent;)s.push(o.parent.children.indexOf(o)),o=o.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,n.tail2)(e)[0]}getFirstElementChild(e){const s=this.getTreeNode(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.getTreeNode(e);if(s.children.length!==0)return this._getLastElementAncestor(s)}_getLastElementAncestor(e){return e.children.length===0?e.element:this._getLastElementAncestor(e.children[e.children.length-1])}}t.IndexTreeModel=b}),define(ve[139],De([1,0,75,33,35]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class O{get size(){return this.nodes.size}constructor(w,_,d={}){this.user=w,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new i.IndexTreeModel(w,_,null,d),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,d.sorter&&(this.sorter={compare(D,S){return d.sorter.compare(D.element,S.element)}}),this.identityProvider=d.identityProvider}setChildren(w,_=P.Iterable.empty(),d={}){const D=this.getElementLocation(w);this._setChildren(D,this.preserveCollapseState(_),d)}_setChildren(w,_=P.Iterable.empty(),d){const D=new Set,S=new Set,b=e=>{if(e.element===null)return;const s=e;if(D.add(s.element),this.nodes.set(s.element,s),this.identityProvider){const o=this.identityProvider.getId(s.element).toString();S.add(o),this.nodesByIdentity.set(o,s)}d.onDidCreateNode?.(s)},m=e=>{if(e.element===null)return;const s=e;if(D.has(s.element)||this.nodes.delete(s.element),this.identityProvider){const o=this.identityProvider.getId(s.element).toString();S.has(o)||this.nodesByIdentity.delete(o)}d.onDidDeleteNode?.(s)};this.model.splice([...w,0],Number.MAX_VALUE,_,{...d,onDidCreateNode:b,onDidDeleteNode:m})}preserveCollapseState(w=P.Iterable.empty()){return this.sorter&&(w=[...w].sort(this.sorter.compare.bind(this.sorter))),P.Iterable.map(w,_=>{let d=this.nodes.get(_.element);if(!d&&this.identityProvider){const b=this.identityProvider.getId(_.element).toString();d=this.nodesByIdentity.get(b)}if(!d){let b;return typeof _.collapsed>"u"?b=void 0:_.collapsed===n.ObjectTreeElementCollapseState.Collapsed||_.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed?b=!0:_.collapsed===n.ObjectTreeElementCollapseState.Expanded||_.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?b=!1:b=!!_.collapsed,{..._,children:this.preserveCollapseState(_.children),collapsed:b}}const D=typeof _.collapsible=="boolean"?_.collapsible:d.collapsible;let S;return typeof _.collapsed>"u"||_.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed||_.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?S=d.collapsed:_.collapsed===n.ObjectTreeElementCollapseState.Collapsed?S=!0:_.collapsed===n.ObjectTreeElementCollapseState.Expanded?S=!1:S=!!_.collapsed,{..._,collapsible:D,collapsed:S,children:this.preserveCollapseState(_.children)}})}rerender(w){const _=this.getElementLocation(w);this.model.rerender(_)}updateElementHeight(w,_){const d=this.getElementLocation(w);this.model.updateElementHeight(d,_)}resort(w=null,_=!0){if(!this.sorter)return;const d=this.getElementLocation(w),D=this.model.getNode(d);this._setChildren(d,this.resortChildren(D,_),{})}resortChildren(w,_,d=!0){let D=[...w.children];return(_||d)&&(D=D.sort(this.sorter.compare.bind(this.sorter))),P.Iterable.map(D,S=>({element:S.element,collapsible:S.collapsible,collapsed:S.collapsed,children:this.resortChildren(S,_,!1)}))}getFirstElementChild(w=null){const _=this.getElementLocation(w);return this.model.getFirstElementChild(_)}getLastElementAncestor(w=null){const _=this.getElementLocation(w);return this.model.getLastElementAncestor(_)}has(w){return this.nodes.has(w)}getListIndex(w){const _=this.getElementLocation(w);return this.model.getListIndex(_)}getListRenderCount(w){const _=this.getElementLocation(w);return this.model.getListRenderCount(_)}isCollapsible(w){const _=this.getElementLocation(w);return this.model.isCollapsible(_)}setCollapsible(w,_){const d=this.getElementLocation(w);return this.model.setCollapsible(d,_)}isCollapsed(w){const _=this.getElementLocation(w);return this.model.isCollapsed(_)}setCollapsed(w,_,d){const D=this.getElementLocation(w);return this.model.setCollapsed(D,_,d)}expandTo(w){const _=this.getElementLocation(w);this.model.expandTo(_)}refilter(){this.model.refilter()}getNode(w=null){if(w===null)return this.model.getNode(this.model.rootRef);const _=this.nodes.get(w);if(!_)throw new n.TreeError(this.user,`Tree element not found: ${w}`);return _}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new n.TreeError(this.user,"Invalid getParentNodeLocation call");const _=this.nodes.get(w);if(!_)throw new n.TreeError(this.user,`Tree element not found: ${w}`);const d=this.model.getNodeLocation(_),D=this.model.getParentNodeLocation(d);return this.model.getNode(D).element}getElementLocation(w){if(w===null)return[];const _=this.nodes.get(w);if(!_)throw new n.TreeError(this.user,`Tree element not found: ${w}`);return this.model.getNodeLocation(_)}}t.ObjectTreeModel=O}),define(ve[24],De([1,0,4,16,23,31,2]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class w extends T.Disposable{onclick(d,D){this._register(i.addDisposableListener(d,i.EventType.CLICK,S=>D(new P.StandardMouseEvent(i.getWindow(d),S))))}onmousedown(d,D){this._register(i.addDisposableListener(d,i.EventType.MOUSE_DOWN,S=>D(new P.StandardMouseEvent(i.getWindow(d),S))))}onmouseover(d,D){this._register(i.addDisposableListener(d,i.EventType.MOUSE_OVER,S=>D(new P.StandardMouseEvent(i.getWindow(d),S))))}onmouseleave(d,D){this._register(i.addDisposableListener(d,i.EventType.MOUSE_LEAVE,S=>D(new P.StandardMouseEvent(i.getWindow(d),S))))}onkeydown(d,D){this._register(i.addDisposableListener(d,i.EventType.KEY_DOWN,S=>D(new n.StandardKeyboardEvent(S))))}onkeyup(d,D){this._register(i.addDisposableListener(d,i.EventType.KEY_UP,S=>D(new n.StandardKeyboardEvent(S))))}oninput(d,D){this._register(i.addDisposableListener(d,i.EventType.INPUT,D))}onblur(d,D){this._register(i.addDisposableListener(d,i.EventType.BLUR,D))}onfocus(d,D){this._register(i.addDisposableListener(d,i.EventType.FOCUS,D))}onchange(d,D){this._register(i.addDisposableListener(d,i.EventType.CHANGE,D))}ignoreGesture(d){return O.Gesture.ignoreTarget(d)}}t.Widget=w}),define(ve[53],De([1,0,72,24,12,22,4]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class w extends n.Widget{constructor(d){super(),this._onActivate=d.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=d.bgWidth+"px",this.bgDomNode.style.height=d.bgHeight+"px",typeof d.top<"u"&&(this.bgDomNode.style.top="0px"),typeof d.left<"u"&&(this.bgDomNode.style.left="0px"),typeof d.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof d.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=d.className,this.domNode.classList.add(...O.ThemeIcon.asClassNameArray(d.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof d.top<"u"&&(this.domNode.style.top=d.top+"px"),typeof d.left<"u"&&(this.domNode.style.left=d.left+"px"),typeof d.bottom<"u"&&(this.domNode.style.bottom=d.bottom+"px"),typeof d.right<"u"&&(this.domNode.style.right=d.right+"px"),this._pointerMoveMonitor=this._register(new i.GlobalPointerMoveMonitor),this._register(T.addStandardDisposableListener(this.bgDomNode,T.EventType.POINTER_DOWN,D=>this._arrowPointerDown(D))),this._register(T.addStandardDisposableListener(this.domNode,T.EventType.POINTER_DOWN,D=>this._arrowPointerDown(D))),this._pointerdownRepeatTimer=this._register(new T.WindowIntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new P.TimeoutTimer)}_arrowPointerDown(d){if(!d.target||!(d.target instanceof Element))return;const D=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24,T.getWindow(d))};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(D,200),this._pointerMoveMonitor.startMonitoring(d.target,d.pointerId,d.buttons,S=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),d.preventDefault()}}t.ScrollbarArrow=w}),define(ve[76],De([1,0,4,56,72,53,137,24,5]),function(oe,t,i,n,P,O,T,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const d=140;class D extends w.Widget{constructor(b){super(),this._lazyRender=b.lazyRender,this._host=b.host,this._scrollable=b.scrollable,this._scrollByPage=b.scrollByPage,this._scrollbarState=b.scrollbarState,this._visibilityController=this._register(new T.ScrollbarVisibilityController(b.visibility,"visible scrollbar "+b.extraScrollbarClassName,"invisible scrollbar "+b.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new P.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,n.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(i.addDisposableListener(this.domNode.domNode,i.EventType.POINTER_DOWN,m=>this._domNodePointerDown(m)))}_createArrow(b){const m=this._register(new O.ScrollbarArrow(b));this.domNode.domNode.appendChild(m.bgDomNode),this.domNode.domNode.appendChild(m.domNode)}_createSlider(b,m,e,s){this.slider=(0,n.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(b),this.slider.setLeft(m),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(i.addDisposableListener(this.slider.domNode,i.EventType.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this._sliderPointerDown(o))})),this.onclick(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}_onElementSize(b){return this._scrollbarState.setVisibleSize(b)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(b){return this._scrollbarState.setScrollSize(b)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(b){return this._scrollbarState.setScrollPosition(b)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(b){b.target===this.domNode.domNode&&this._onPointerDown(b)}delegatePointerDown(b){const m=this.domNode.domNode.getClientRects()[0].top,e=m+this._scrollbarState.getSliderPosition(),s=m+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),o=this._sliderPointerPosition(b);e<=o&&o<=s?b.button===0&&(b.preventDefault(),this._sliderPointerDown(b)):this._onPointerDown(b)}_onPointerDown(b){let m,e;if(b.target===this.domNode.domNode&&typeof b.offsetX=="number"&&typeof b.offsetY=="number")m=b.offsetX,e=b.offsetY;else{const o=i.getDomNodePagePosition(this.domNode.domNode);m=b.pageX-o.left,e=b.pageY-o.top}const s=this._pointerDownRelativePosition(m,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(s):this._scrollbarState.getDesiredScrollPositionFromOffset(s)),b.button===0&&(b.preventDefault(),this._sliderPointerDown(b))}_sliderPointerDown(b){if(!b.target||!(b.target instanceof Element))return;const m=this._sliderPointerPosition(b),e=this._sliderOrthogonalPointerPosition(b),s=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(b.target,b.pointerId,b.buttons,o=>{const c=this._sliderOrthogonalPointerPosition(o),h=Math.abs(c-e);if(_.isWindows&&h>d){this._setDesiredScrollPositionNow(s.getScrollPosition());return}const L=this._sliderPointerPosition(o)-m;this._setDesiredScrollPositionNow(s.getDesiredScrollPositionFromDelta(L))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(b){const m={};this.writeScrollPosition(m,b),this._scrollable.setScrollPositionNow(m)}updateScrollbarSize(b){this._updateScrollbarSize(b),this._scrollbarState.setScrollbarSize(b),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=D}),define(ve[140],De([1,0,23,76,53,57,21,20]),function(oe,t,i,n,P,O,T,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class _ extends n.AbstractScrollbar{constructor(D,S,b){const m=D.getScrollDimensions(),e=D.getCurrentScrollPosition();if(super({lazyRender:S.lazyRender,host:b,scrollbarState:new O.ScrollbarState(S.horizontalHasArrows?S.arrowSize:0,S.horizontal===w.ScrollbarVisibility.Hidden?0:S.horizontalScrollbarSize,S.vertical===w.ScrollbarVisibility.Hidden?0:S.verticalScrollbarSize,m.width,m.scrollWidth,e.scrollLeft),visibility:S.horizontal,extraScrollbarClassName:"horizontal",scrollable:D,scrollByPage:S.scrollByPage}),S.horizontalHasArrows){const s=(S.arrowSize-P.ARROW_IMG_SIZE)/2,o=(S.horizontalScrollbarSize-P.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:T.Codicon.scrollbarButtonLeft,top:o,left:s,bottom:void 0,right:void 0,bgWidth:S.arrowSize,bgHeight:S.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:T.Codicon.scrollbarButtonRight,top:o,left:void 0,bottom:void 0,right:s,bgWidth:S.arrowSize,bgHeight:S.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((S.horizontalScrollbarSize-S.horizontalSliderSize)/2),0,void 0,S.horizontalSliderSize)}_updateSlider(D,S){this.slider.setWidth(D),this.slider.setLeft(S)}_renderDomNode(D,S){this.domNode.setWidth(D),this.domNode.setHeight(S),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(D){return this._shouldRender=this._onElementScrollSize(D.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(D.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(D.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(D,S){return D}_sliderPointerPosition(D){return D.pageX}_sliderOrthogonalPointerPosition(D){return D.pageY}_updateScrollbarSize(D){this.slider.setHeight(D)}writeScrollPosition(D,S){D.scrollLeft=S}updateOptions(D){this.updateScrollbarSize(D.horizontal===w.ScrollbarVisibility.Hidden?0:D.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(D.vertical===w.ScrollbarVisibility.Hidden?0:D.verticalScrollbarSize),this._visibilityController.setVisibility(D.horizontal),this._scrollByPage=D.scrollByPage}}t.HorizontalScrollbar=_}),define(ve[141],De([1,0,23,76,53,57,21,20]),function(oe,t,i,n,P,O,T,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class _ extends n.AbstractScrollbar{constructor(D,S,b){const m=D.getScrollDimensions(),e=D.getCurrentScrollPosition();if(super({lazyRender:S.lazyRender,host:b,scrollbarState:new O.ScrollbarState(S.verticalHasArrows?S.arrowSize:0,S.vertical===w.ScrollbarVisibility.Hidden?0:S.verticalScrollbarSize,0,m.height,m.scrollHeight,e.scrollTop),visibility:S.vertical,extraScrollbarClassName:"vertical",scrollable:D,scrollByPage:S.scrollByPage}),S.verticalHasArrows){const s=(S.arrowSize-P.ARROW_IMG_SIZE)/2,o=(S.verticalScrollbarSize-P.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:T.Codicon.scrollbarButtonUp,top:s,left:o,bottom:void 0,right:void 0,bgWidth:S.verticalScrollbarSize,bgHeight:S.arrowSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:T.Codicon.scrollbarButtonDown,top:void 0,left:o,bottom:s,right:void 0,bgWidth:S.verticalScrollbarSize,bgHeight:S.arrowSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((S.verticalScrollbarSize-S.verticalSliderSize)/2),S.verticalSliderSize,void 0)}_updateSlider(D,S){this.slider.setHeight(D),this.slider.setTop(S)}_renderDomNode(D,S){this.domNode.setWidth(S),this.domNode.setHeight(D),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(D){return this._shouldRender=this._onElementScrollSize(D.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(D.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(D.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(D,S){return S}_sliderPointerPosition(D){return D.pageY}_sliderOrthogonalPointerPosition(D){return D.pageX}_updateScrollbarSize(D){this.slider.setWidth(D)}writeScrollPosition(D,S){D.scrollTop=S}updateOptions(D){this.updateScrollbarSize(D.vertical===w.ScrollbarVisibility.Hidden?0:D.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(D.vertical),this._scrollByPage=D.scrollByPage}}t.VerticalScrollbar=_}),define(ve[77],De([1,0,19,4,56,23,140,141,24,12,3,2,5,20,116]),function(oe,t,i,n,P,O,T,w,_,d,D,S,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,s=50,o=!0;class c{constructor(I,H,z){this.timestamp=I,this.deltaX=H,this.deltaY=z,this.score=0}}class h{static{this.INSTANCE=new h}constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let I=1,H=0,z=1,U=this._rear;do{const v=U===this._front?I:Math.pow(2,-z);if(I-=v,H+=this._memory[U].score*v,U===this._front)break;U=(this._capacity+U-1)%this._capacity,z++}while(!0);return H<=.5}acceptStandardWheelEvent(I){if(i.isChrome){const H=n.getWindow(I.browserEvent),z=(0,i.getZoomFactor)(H);this.accept(Date.now(),I.deltaX*z,I.deltaY*z)}else this.accept(Date.now(),I.deltaX,I.deltaY)}accept(I,H,z){let U=null;const v=new c(I,H,z);this._front===-1&&this._rear===-1?(this._memory[0]=v,this._front=0,this._rear=0):(U=this._memory[this._rear],this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=v),v.score=this._computeScore(v,U)}_computeScore(I,H){if(Math.abs(I.deltaX)>0&&Math.abs(I.deltaY)>0)return 1;let z=.5;if((!this._isAlmostInt(I.deltaX)||!this._isAlmostInt(I.deltaY))&&(z+=.25),H){const U=Math.abs(I.deltaX),v=Math.abs(I.deltaY),k=Math.abs(H.deltaX),x=Math.abs(H.deltaY),N=Math.max(Math.min(U,k),1),M=Math.max(Math.min(v,x),1),$=Math.max(U,k),ne=Math.max(v,x);$%N===0&&ne%M===0&&(z-=.5)}return Math.min(Math.max(z,0),1)}_isAlmostInt(I){return Math.abs(Math.round(I)-I)<.01}}t.MouseWheelClassifier=h;class p extends _.Widget{get options(){return this._options}constructor(I,H,z){super(),this._onScroll=this._register(new D.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new D.Emitter),this.onWillScroll=this._onWillScroll.event,I.style.overflow="hidden",this._options=f(H),this._scrollable=z,this._register(this._scrollable.onScroll(v=>{this._onWillScroll.fire(v),this._onDidScroll(v),this._onScroll.fire(v)}));const U={onMouseWheel:v=>this._onMouseWheel(v),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new w.VerticalScrollbar(this._scrollable,this._options,U)),this._horizontalScrollbar=this._register(new T.HorizontalScrollbar(this._scrollable,this._options,U)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(I),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,v=>this._onMouseOver(v)),this.onmouseleave(this._listenOnDomNode,v=>this._onMouseLeave(v)),this._hideTimeout=this._register(new d.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,S.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(I){this._verticalScrollbar.delegatePointerDown(I)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(I){this._scrollable.setScrollDimensions(I,!1)}updateClassName(I){this._options.className=I,b.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(I){typeof I.handleMouseWheel<"u"&&(this._options.handleMouseWheel=I.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof I.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=I.mouseWheelScrollSensitivity),typeof I.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=I.fastScrollSensitivity),typeof I.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=I.scrollPredominantAxis),typeof I.horizontal<"u"&&(this._options.horizontal=I.horizontal),typeof I.vertical<"u"&&(this._options.vertical=I.vertical),typeof I.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=I.horizontalScrollbarSize),typeof I.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=I.verticalScrollbarSize),typeof I.scrollByPage<"u"&&(this._options.scrollByPage=I.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(I){this._revealOnScroll=I}delegateScrollFromMouseWheelEvent(I){this._onMouseWheel(new O.StandardWheelEvent(I))}_setListeningToMouseWheel(I){if(this._mouseWheelToDispose.length>0!==I&&(this._mouseWheelToDispose=(0,S.dispose)(this._mouseWheelToDispose),I)){const z=U=>{this._onMouseWheel(new O.StandardWheelEvent(U))};this._mouseWheelToDispose.push(n.addDisposableListener(this._listenOnDomNode,n.EventType.MOUSE_WHEEL,z,{passive:!1}))}}_onMouseWheel(I){if(I.browserEvent?.defaultPrevented)return;const H=h.INSTANCE;o&&H.acceptStandardWheelEvent(I);let z=!1;if(I.deltaY||I.deltaX){let v=I.deltaY*this._options.mouseWheelScrollSensitivity,k=I.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(this._options.scrollYToX&&k+v===0?k=v=0:Math.abs(v)>=Math.abs(k)?k=0:v=0),this._options.flipAxes&&([v,k]=[k,v]);const x=!b.isMacintosh&&I.browserEvent&&I.browserEvent.shiftKey;(this._options.scrollYToX||x)&&!k&&(k=v,v=0),I.browserEvent&&I.browserEvent.altKey&&(k=k*this._options.fastScrollSensitivity,v=v*this._options.fastScrollSensitivity);const N=this._scrollable.getFutureScrollPosition();let M={};if(v){const $=s*v,ne=N.scrollTop-($<0?Math.floor($):Math.ceil($));this._verticalScrollbar.writeScrollPosition(M,ne)}if(k){const $=s*k,ne=N.scrollLeft-($<0?Math.floor($):Math.ceil($));this._horizontalScrollbar.writeScrollPosition(M,ne)}M=this._scrollable.validateScrollPosition(M),(N.scrollLeft!==M.scrollLeft||N.scrollTop!==M.scrollTop)&&(o&&this._options.mouseWheelSmoothScroll&&H.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(M):this._scrollable.setScrollPositionNow(M),z=!0)}let U=z;!U&&this._options.alwaysConsumeMouseWheel&&(U=!0),!U&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(U=!0),U&&(I.preventDefault(),I.stopPropagation())}_onDidScroll(I){this._shouldRender=this._horizontalScrollbar.onDidScroll(I)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(I)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const I=this._scrollable.getCurrentScrollPosition(),H=I.scrollTop>0,z=I.scrollLeft>0,U=z?" left":"",v=H?" top":"",k=z||H?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${U}`),this._topShadowDomNode.setClassName(`shadow${v}`),this._topLeftShadowDomNode.setClassName(`shadow${k}${v}${U}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(I){this._mouseIsOver=!1,this._hide()}_onMouseOver(I){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=p;class L extends p{constructor(I,H){H=H||{},H.mouseWheelSmoothScroll=!1;const z=new m.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:U=>n.scheduleAtNextAnimationFrame(n.getWindow(I),U)});super(I,H,z),this._register(z)}setScrollPosition(I){this._scrollable.setScrollPositionNow(I)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=L;class y extends p{constructor(I,H,z){super(I,H,z)}setScrollPosition(I){I.reuseAnimation?this._scrollable.setScrollPositionSmooth(I,I.reuseAnimation):this._scrollable.setScrollPositionNow(I)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=y;class r extends p{constructor(I,H){H=H||{},H.mouseWheelSmoothScroll=!1;const z=new m.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:U=>n.scheduleAtNextAnimationFrame(n.getWindow(I),U)});super(I,H,z),this._register(z),this._element=I,this._register(this.onScroll(U=>{U.scrollTopChanged&&(this._element.scrollTop=U.scrollTop),U.scrollLeftChanged&&(this._element.scrollLeft=U.scrollLeft)})),this.scanDomNode()}setScrollPosition(I){this._scrollable.setScrollPositionNow(I)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=r;function f(E){const I={lazyRender:typeof E.lazyRender<"u"?E.lazyRender:!1,className:typeof E.className<"u"?E.className:"",useShadows:typeof E.useShadows<"u"?E.useShadows:!0,handleMouseWheel:typeof E.handleMouseWheel<"u"?E.handleMouseWheel:!0,flipAxes:typeof E.flipAxes<"u"?E.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof E.consumeMouseWheelIfScrollbarIsNeeded<"u"?E.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof E.alwaysConsumeMouseWheel<"u"?E.alwaysConsumeMouseWheel:!1,scrollYToX:typeof E.scrollYToX<"u"?E.scrollYToX:!1,mouseWheelScrollSensitivity:typeof E.mouseWheelScrollSensitivity<"u"?E.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof E.fastScrollSensitivity<"u"?E.fastScrollSensitivity:5,scrollPredominantAxis:typeof E.scrollPredominantAxis<"u"?E.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof E.mouseWheelSmoothScroll<"u"?E.mouseWheelSmoothScroll:!0,arrowSize:typeof E.arrowSize<"u"?E.arrowSize:11,listenOnDomNode:typeof E.listenOnDomNode<"u"?E.listenOnDomNode:null,horizontal:typeof E.horizontal<"u"?E.horizontal:m.ScrollbarVisibility.Auto,horizontalScrollbarSize:typeof E.horizontalScrollbarSize<"u"?E.horizontalScrollbarSize:10,horizontalSliderSize:typeof E.horizontalSliderSize<"u"?E.horizontalSliderSize:0,horizontalHasArrows:typeof E.horizontalHasArrows<"u"?E.horizontalHasArrows:!1,vertical:typeof E.vertical<"u"?E.vertical:m.ScrollbarVisibility.Auto,verticalScrollbarSize:typeof E.verticalScrollbarSize<"u"?E.verticalScrollbarSize:10,verticalHasArrows:typeof E.verticalHasArrows<"u"?E.verticalHasArrows:!1,verticalSliderSize:typeof E.verticalSliderSize<"u"?E.verticalSliderSize:0,scrollByPage:typeof E.scrollByPage<"u"?E.scrollByPage:!1};return I.horizontalSliderSize=typeof E.horizontalSliderSize<"u"?E.horizontalSliderSize:I.horizontalScrollbarSize,I.verticalSliderSize=typeof E.verticalSliderSize<"u"?E.verticalSliderSize:I.verticalScrollbarSize,b.isMacintosh&&(I.className+=" mac"),I}}),define(ve[78],De([1,0,70,4,27,31,77,9,12,34,3,2,47,20,40,96,136,6,44]),function(oe,t,i,n,P,O,T,w,_,d,D,S,b,m,e,s,o,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=t.ListViewTargetSector=void 0;const p={CurrentDragAndDropData:void 0};var L;(function(U){U[U.TOP=0]="TOP",U[U.CENTER_TOP=1]="CENTER_TOP",U[U.CENTER_BOTTOM=2]="CENTER_BOTTOM",U[U.BOTTOM=3]="BOTTOM"})(L||(t.ListViewTargetSector=L={}));const y={useShadows:!0,verticalScrollMode:m.ScrollbarVisibility.Auto,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(U){return[U]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this._context}set context(v){this._context=v}constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=r;class f{constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=f;class E{constructor(){this.types=[],this.files=[]}update(v){if(v.types&&this.types.splice(0,this.types.length,...v.types),v.files){this.files.splice(0,this.files.length);for(let k=0;k<v.files.length;k++){const x=v.files.item(k);x&&(x.size||x.type)&&this.files.push(x)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=E;function I(U,v){return Array.isArray(U)&&Array.isArray(v)?(0,w.equals)(U,v):U===v}class H{constructor(v){v?.getSetSize?this.getSetSize=v.getSetSize.bind(v):this.getSetSize=(k,x,N)=>N,v?.getPosInSet?this.getPosInSet=v.getPosInSet.bind(v):this.getPosInSet=(k,x)=>x+1,v?.getRole?this.getRole=v.getRole.bind(v):this.getRole=k=>"listitem",v?.isChecked?this.isChecked=v.isChecked.bind(v):this.isChecked=k=>{}}}class z{static{this.InstanceCount=0}get contentHeight(){return this.rangeMap.size}get contentWidth(){return this.scrollWidth??0}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(v){if(v!==this._horizontalScrolling){if(v&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=v,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const k of this.items)this.measureItemWidth(k);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,n.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(v,k,x,N=y){if(this.virtualDelegate=k,this.domId=`list_id_${++z.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new _.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=S.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=S.Disposable.None,this.onDragLeaveTimeout=S.Disposable.None,this.disposables=new S.DisposableStore,this._onDidChangeContentHeight=new D.Emitter,this._onDidChangeContentWidth=new D.Emitter,this.onDidChangeContentHeight=D.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this.onDidChangeContentWidth=D.Event.latch(this._onDidChangeContentWidth.event,void 0,this.disposables),this._horizontalScrolling=!1,N.horizontalScrolling&&N.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=this.createRangeMap(N.paddingTop??0);for(const $ of x)this.renderers.set($.templateId,$);this.cache=this.disposables.add(new o.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof N.mouseSupport=="boolean"?N.mouseSupport:!0),this._horizontalScrolling=N.horizontalScrolling??y.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.paddingBottom=typeof N.paddingBottom>"u"?0:N.paddingBottom,this.accessibilityProvider=new H(N.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(N.transformOptimization??y.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(O.Gesture.addTarget(this.rowsContainer)),this.scrollable=this.disposables.add(new m.Scrollable({forceIntegerValues:!0,smoothScrollDuration:N.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:$=>(0,n.scheduleAtNextAnimationFrame)((0,n.getWindow)(this.domNode),$)})),this.scrollableElement=this.disposables.add(new T.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:N.alwaysConsumeMouseWheel??y.alwaysConsumeMouseWheel,horizontal:m.ScrollbarVisibility.Auto,vertical:N.verticalScrollMode??y.verticalScrollMode,useShadows:N.useShadows??y.useShadows,mouseWheelScrollSensitivity:N.mouseWheelScrollSensitivity,fastScrollSensitivity:N.fastScrollSensitivity,scrollByPage:N.scrollByPage},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),v.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,n.addDisposableListener)(this.rowsContainer,O.EventType.Change,$=>this.onTouchChange($))),this.disposables.add((0,n.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",$=>$.target.scrollTop=0)),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragover",$=>this.onDragOver(this.toDragEvent($)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"drop",$=>this.onDrop(this.toDragEvent($)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragleave",$=>this.onDragLeave(this.toDragEvent($)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragend",$=>this.onDragEnd($))),this.setRowLineHeight=N.setRowLineHeight??y.setRowLineHeight,this.setRowHeight=N.setRowHeight??y.setRowHeight,this.supportDynamicHeights=N.supportDynamicHeights??y.supportDynamicHeights,this.dnd=N.dnd??this.disposables.add(y.dnd),this.layout(N.initialSize?.height,N.initialSize?.width)}updateOptions(v){v.paddingBottom!==void 0&&(this.paddingBottom=v.paddingBottom,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),v.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(v.smoothScrolling?125:0),v.horizontalScrolling!==void 0&&(this.horizontalScrolling=v.horizontalScrolling);let k;if(v.scrollByPage!==void 0&&(k={...k??{},scrollByPage:v.scrollByPage}),v.mouseWheelScrollSensitivity!==void 0&&(k={...k??{},mouseWheelScrollSensitivity:v.mouseWheelScrollSensitivity}),v.fastScrollSensitivity!==void 0&&(k={...k??{},fastScrollSensitivity:v.fastScrollSensitivity}),k&&this.scrollableElement.updateOptions(k),v.paddingTop!==void 0&&v.paddingTop!==this.rangeMap.paddingTop){const x=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),N=v.paddingTop-this.rangeMap.paddingTop;this.rangeMap.paddingTop=v.paddingTop,this.render(x,Math.max(0,this.lastRenderTop+N),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}}delegateScrollFromMouseWheelEvent(v){this.scrollableElement.delegateScrollFromMouseWheelEvent(v)}delegateVerticalScrollbarPointerDown(v){this.scrollableElement.delegateVerticalScrollbarPointerDown(v)}updateElementHeight(v,k,x){if(v<0||v>=this.items.length)return;const N=this.items[v].size;if(typeof k>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[v].lastDynamicHeightWidth=void 0,k=N+this.probeDynamicHeight(v)}if(N===k)return;const M=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let $=0;v<M.start||x!==null&&x>v&&x<M.end?$=k-N:$=0,this.rangeMap.splice(v,1,[{size:k}]),this.items[v].size=k,this.render(M,Math.max(0,this.lastRenderTop+$),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}createRangeMap(v){return new s.RangeMap(v)}splice(v,k,x=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(v,k,x)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(v,k,x=[]){const N=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),M={start:v,end:v+k},$=b.Range.intersect(N,M),ne=new Map;for(let me=$.end-1;me>=$.start;me--){const _e=this.items[me];if(_e.dragStartDisposable.dispose(),_e.checkedDisposable.dispose(),_e.row){let Oe=ne.get(_e.templateId);Oe||(Oe=[],ne.set(_e.templateId,Oe));const Ce=this.renderers.get(_e.templateId);Ce&&Ce.disposeElement&&Ce.disposeElement(_e.element,me,_e.row.templateData,_e.size),Oe.unshift(_e.row)}_e.row=null,_e.stale=!0}const Z={start:v+k,end:this.items.length},Y=b.Range.intersect(Z,N),te=b.Range.relativeComplement(Z,N),fe=x.map(me=>({id:String(this.itemId++),element:me,templateId:this.virtualDelegate.getTemplateId(me),size:this.virtualDelegate.getHeight(me),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(me),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:S.Disposable.None,checkedDisposable:S.Disposable.None,stale:!1}));let Ee;v===0&&k>=this.items.length?(this.rangeMap=this.createRangeMap(this.rangeMap.paddingTop),this.rangeMap.splice(0,0,fe),Ee=this.items,this.items=fe):(this.rangeMap.splice(v,k,fe),Ee=this.items.splice(v,k,...fe));const Fe=x.length-k,Ae=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),ue=(0,s.shift)(Y,Fe),J=b.Range.intersect(Ae,ue);for(let me=J.start;me<J.end;me++)this.updateItemInDOM(this.items[me],me);const de=b.Range.relativeComplement(ue,Ae);for(const me of de)for(let _e=me.start;_e<me.end;_e++)this.removeItemFromDOM(_e);const ae=te.map(me=>(0,s.shift)(me,Fe)),Q=[{start:v,end:v+x.length},...ae].map(me=>b.Range.intersect(Ae,me)).reverse();for(const me of Q)for(let _e=me.end-1;_e>=me.start;_e--){const Oe=this.items[_e],Be=ne.get(Oe.templateId)?.pop();this.insertItemInDOM(_e,Be)}for(const me of ne.values())for(const _e of me)this.cache.release(_e);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),Ee.map(me=>me.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,n.scheduleAtNextAnimationFrame)((0,n.getWindow)(this.domNode),()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let v=0;for(const k of this.items)typeof k.width<"u"&&(v=Math.max(v,k.width));this.scrollWidth=v,this.scrollableElement.setScrollDimensions({scrollWidth:v===0?0:v+10}),this._onDidChangeContentWidth.fire(this.scrollWidth)}updateWidth(v){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const k=this.items[v];this.measureItemWidth(k),typeof k.width<"u"&&k.width>this.scrollWidth&&(this.scrollWidth=k.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}),this._onDidChangeContentWidth.fire(this.scrollWidth))}rerender(){if(this.supportDynamicHeights){for(const v of this.items)v.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).start}get firstMostlyVisibleIndex(){const v=this.firstVisibleIndex,k=this.rangeMap.positionAt(v),x=this.rangeMap.positionAt(v+1);return x!==-1&&(x-k)/2+k<this.scrollTop?v+1:v}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(v){return this.items[v].element}indexOf(v){return this.items.findIndex(k=>k.element===v)}domElement(v){const k=this.items[v].row;return k&&k.domNode}elementHeight(v){return this.items[v].size}elementTop(v){return this.rangeMap.positionAt(v)}indexAt(v){return this.rangeMap.indexAt(v)}indexAfter(v){return this.rangeMap.indexAfter(v)}layout(v,k){const x={height:typeof v=="number"?v:(0,n.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,x.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(x),typeof k<"u"&&(this.renderWidth=k,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof k=="number"?k:(0,n.getContentWidth)(this.domNode)})}render(v,k,x,N,M,$=!1){const ne=this.getRenderRange(k,x),Z=b.Range.relativeComplement(ne,v).reverse(),Y=b.Range.relativeComplement(v,ne);if($){const te=b.Range.intersect(v,ne);for(let fe=te.start;fe<te.end;fe++)this.updateItemInDOM(this.items[fe],fe)}this.cache.transact(()=>{for(const te of Y)for(let fe=te.start;fe<te.end;fe++)this.removeItemFromDOM(fe);for(const te of Z)for(let fe=te.end-1;fe>=te.start;fe--)this.insertItemInDOM(fe)}),N!==void 0&&(this.rowsContainer.style.left=`-${N}px`),this.rowsContainer.style.top=`-${k}px`,this.horizontalScrolling&&M!==void 0&&(this.rowsContainer.style.width=`${Math.max(M,this.renderWidth)}px`),this.lastRenderTop=k,this.lastRenderHeight=x}insertItemInDOM(v,k){const x=this.items[v];if(!x.row)if(k)x.row=k,x.stale=!0;else{const Z=this.cache.alloc(x.templateId);x.row=Z.row,x.stale||=Z.isReusingConnectedDomNode}const N=this.accessibilityProvider.getRole(x.element)||"listitem";x.row.domNode.setAttribute("role",N);const M=this.accessibilityProvider.isChecked(x.element);if(typeof M=="boolean")x.row.domNode.setAttribute("aria-checked",String(!!M));else if(M){const Z=Y=>x.row.domNode.setAttribute("aria-checked",String(!!Y));Z(M.value),x.checkedDisposable=M.onDidChange(()=>Z(M.value))}if(x.stale||!x.row.domNode.parentElement){const Z=this.items.at(v+1)?.row?.domNode??null;(x.row.domNode.parentElement!==this.rowsContainer||x.row.domNode.nextElementSibling!==Z)&&this.rowsContainer.insertBefore(x.row.domNode,Z),x.stale=!1}this.updateItemInDOM(x,v);const $=this.renderers.get(x.templateId);if(!$)throw new Error(`No renderer found for template id ${x.templateId}`);$?.renderElement(x.element,v,x.row.templateData,x.size);const ne=this.dnd.getDragURI(x.element);x.dragStartDisposable.dispose(),x.row.domNode.draggable=!!ne,ne&&(x.dragStartDisposable=(0,n.addDisposableListener)(x.row.domNode,"dragstart",Z=>this.onDragStart(x.element,ne,Z))),this.horizontalScrolling&&(this.measureItemWidth(x),this.eventuallyUpdateScrollWidth())}measureItemWidth(v){if(!v.row||!v.row.domNode)return;v.row.domNode.style.width="fit-content",v.width=(0,n.getContentWidth)(v.row.domNode);const k=(0,n.getWindow)(v.row.domNode).getComputedStyle(v.row.domNode);k.paddingLeft&&(v.width+=parseFloat(k.paddingLeft)),k.paddingRight&&(v.width+=parseFloat(k.paddingRight)),v.row.domNode.style.width=""}updateItemInDOM(v,k){v.row.domNode.style.top=`${this.elementTop(k)}px`,this.setRowHeight&&(v.row.domNode.style.height=`${v.size}px`),this.setRowLineHeight&&(v.row.domNode.style.lineHeight=`${v.size}px`),v.row.domNode.setAttribute("data-index",`${k}`),v.row.domNode.setAttribute("data-last-element",k===this.length-1?"true":"false"),v.row.domNode.setAttribute("data-parity",k%2===0?"even":"odd"),v.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(v.element,k,this.length))),v.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(v.element,k))),v.row.domNode.setAttribute("id",this.getElementDomId(k)),v.row.domNode.classList.toggle("drop-target",v.dropTarget)}removeItemFromDOM(v){const k=this.items[v];if(k.dragStartDisposable.dispose(),k.checkedDisposable.dispose(),k.row){const x=this.renderers.get(k.templateId);x&&x.disposeElement&&x.disposeElement(k.element,v,k.row.templateData,k.size),this.cache.release(k.row),k.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(v,k){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:v,reuseAnimation:k})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(v){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:v})}get scrollTop(){return this.getScrollTop()}set scrollTop(v){this.setScrollTop(v)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.paddingBottom}get onMouseClick(){return D.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"click")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseDblClick(){return D.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"dblclick")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseMiddleClick(){return D.Event.filter(D.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"auxclick")).event,v=>this.toMouseEvent(v),this.disposables),v=>v.browserEvent.button===1,this.disposables)}get onMouseUp(){return D.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"mouseup")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseDown(){return D.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"mousedown")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseOver(){return D.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"mouseover")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseMove(){return D.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"mousemove")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseOut(){return D.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"mouseout")).event,v=>this.toMouseEvent(v),this.disposables)}get onContextMenu(){return D.Event.any(D.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"contextmenu")).event,v=>this.toMouseEvent(v),this.disposables),D.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,O.EventType.Contextmenu)).event,v=>this.toGestureEvent(v),this.disposables))}get onTouchStart(){return D.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"touchstart")).event,v=>this.toTouchEvent(v),this.disposables)}get onTap(){return D.Event.map(this.disposables.add(new P.DomEmitter(this.rowsContainer,O.EventType.Tap)).event,v=>this.toGestureEvent(v),this.disposables)}toMouseEvent(v){const k=this.getItemIndexFromEventTarget(v.target||null),x=typeof k>"u"?void 0:this.items[k],N=x&&x.element;return{browserEvent:v,index:k,element:N}}toTouchEvent(v){const k=this.getItemIndexFromEventTarget(v.target||null),x=typeof k>"u"?void 0:this.items[k],N=x&&x.element;return{browserEvent:v,index:k,element:N}}toGestureEvent(v){const k=this.getItemIndexFromEventTarget(v.initialTarget||null),x=typeof k>"u"?void 0:this.items[k],N=x&&x.element;return{browserEvent:v,index:k,element:N}}toDragEvent(v){const k=this.getItemIndexFromEventTarget(v.target||null),x=typeof k>"u"?void 0:this.items[k],N=x&&x.element,M=this.getTargetSector(v,k);return{browserEvent:v,index:k,element:N,sector:M}}onScroll(v){try{const k=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(k,v.scrollTop,v.height,v.scrollLeft,v.scrollWidth),this.supportDynamicHeights&&this._rerender(v.scrollTop,v.height,v.inSmoothScrolling)}catch(k){throw console.error("Got bad scroll event:",v),k}}onTouchChange(v){v.preventDefault(),v.stopPropagation(),this.scrollTop-=v.translationY}onDragStart(v,k,x){if(!x.dataTransfer)return;const N=this.dnd.getDragElements(v);if(x.dataTransfer.effectAllowed="copyMove",x.dataTransfer.setData(i.DataTransfers.TEXT,k),x.dataTransfer.setDragImage){let M;this.dnd.getDragLabel&&(M=this.dnd.getDragLabel(N,x)),typeof M>"u"&&(M=String(N.length));const $=(0,n.$)(".monaco-drag-image");$.textContent=M;const Z=(Y=>{for(;Y&&!Y.classList.contains("monaco-workbench");)Y=Y.parentElement;return Y||this.domNode.ownerDocument})(this.domNode);Z.appendChild($),x.dataTransfer.setDragImage($,-10,-10),setTimeout(()=>Z.removeChild($),0)}this.domNode.classList.add("dragging"),this.currentDragData=new r(N),p.CurrentDragAndDropData=new f(N),this.dnd.onDragStart?.(this.currentDragData,x)}onDragOver(v){if(v.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),p.CurrentDragAndDropData&&p.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(v.browserEvent),!v.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(p.CurrentDragAndDropData)this.currentDragData=p.CurrentDragAndDropData;else{if(!v.browserEvent.dataTransfer.types)return!1;this.currentDragData=new E}const k=this.dnd.onDragOver(this.currentDragData,v.element,v.index,v.sector,v.browserEvent);if(this.canDrop=typeof k=="boolean"?k:k.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;v.browserEvent.dataTransfer.dropEffect=typeof k!="boolean"&&k.effect?.type===e.ListDragOverEffectType.Copy?"copy":"move";let x;typeof k!="boolean"&&k.feedback?x=k.feedback:typeof v.index>"u"?x=[-1]:x=[v.index],x=(0,w.distinct)(x).filter(M=>M>=-1&&M<this.length).sort((M,$)=>M-$),x=x[0]===-1?[-1]:x;let N=typeof k!="boolean"&&k.effect&&k.effect.position?k.effect.position:e.ListDragOverEffectPosition.Over;if(I(this.currentDragFeedback,x)&&this.currentDragFeedbackPosition===N)return!0;if(this.currentDragFeedback=x,this.currentDragFeedbackPosition=N,this.currentDragFeedbackDisposable.dispose(),x[0]===-1)this.domNode.classList.add(N),this.rowsContainer.classList.add(N),this.currentDragFeedbackDisposable=(0,S.toDisposable)(()=>{this.domNode.classList.remove(N),this.rowsContainer.classList.remove(N)});else{if(x.length>1&&N!==e.ListDragOverEffectPosition.Over)throw new Error("Can't use multiple feedbacks with position different than 'over'");N===e.ListDragOverEffectPosition.After&&x[0]<this.length-1&&(x[0]+=1,N=e.ListDragOverEffectPosition.Before);for(const M of x){const $=this.items[M];$.dropTarget=!0,$.row?.domNode.classList.add(N)}this.currentDragFeedbackDisposable=(0,S.toDisposable)(()=>{for(const M of x){const $=this.items[M];$.dropTarget=!1,$.row?.domNode.classList.remove(N)}})}return!0}onDragLeave(v){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,_.disposableTimeout)(()=>this.clearDragOverFeedback(),100,this.disposables),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,v.element,v.index,v.browserEvent)}onDrop(v){if(!this.canDrop)return;const k=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,p.CurrentDragAndDropData=void 0,!(!k||!v.browserEvent.dataTransfer)&&(v.browserEvent.preventDefault(),k.update(v.browserEvent.dataTransfer),this.dnd.drop(k,v.element,v.index,v.sector,v.browserEvent))}onDragEnd(v){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,p.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(v)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackPosition=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=S.Disposable.None}setupDragAndDropScrollTopAnimation(v){if(!this.dragOverAnimationDisposable){const k=(0,n.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,n.animate)((0,n.getWindow)(this.domNode),this.animateDragAndDropScrollTop.bind(this,k))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,_.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3,this.disposables),this.dragOverMouseY=v.pageY}animateDragAndDropScrollTop(v){if(this.dragOverMouseY===void 0)return;const k=this.dragOverMouseY-v,x=this.renderHeight-35;k<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(k-35))):k>x&&(this.scrollTop+=Math.min(14,Math.floor(.3*(k-x))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getTargetSector(v,k){if(k===void 0)return;const x=v.offsetY/this.items[k].size,N=Math.floor(x/.25);return(0,h.clamp)(N,0,3)}getItemIndexFromEventTarget(v){const k=this.scrollableElement.getDomNode();let x=v;for(;(0,n.isHTMLElement)(x)&&x!==this.rowsContainer&&k.contains(x);){const N=x.getAttribute("data-index");if(N){const M=Number(N);if(!isNaN(M))return M}x=x.parentElement}}getRenderRange(v,k){return{start:this.rangeMap.indexAt(v),end:this.rangeMap.indexAfter(v+k-1)}}_rerender(v,k,x){const N=this.getRenderRange(v,k);let M,$;v===this.elementTop(N.start)?(M=N.start,$=0):N.end-N.start>1&&(M=N.start+1,$=this.elementTop(M)-v);let ne=0;for(;;){const Z=this.getRenderRange(v,k);let Y=!1;for(let te=Z.start;te<Z.end;te++){const fe=this.probeDynamicHeight(te);fe!==0&&this.rangeMap.splice(te,1,[this.items[te]]),ne+=fe,Y=Y||fe!==0}if(!Y){ne!==0&&this.eventuallyUpdateScrollDimensions();const te=b.Range.relativeComplement(N,Z);for(const Ee of te)for(let Fe=Ee.start;Fe<Ee.end;Fe++)this.items[Fe].row&&this.removeItemFromDOM(Fe);const fe=b.Range.relativeComplement(Z,N).reverse();for(const Ee of fe)for(let Fe=Ee.end-1;Fe>=Ee.start;Fe--)this.insertItemInDOM(Fe);for(let Ee=Z.start;Ee<Z.end;Ee++)this.items[Ee].row&&this.updateItemInDOM(this.items[Ee],Ee);if(typeof M=="number"){const Ee=this.scrollable.getFutureScrollPosition().scrollTop-v,Fe=this.elementTop(M)-$+Ee;this.setScrollTop(Fe,x)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(v){const k=this.items[v];if(this.virtualDelegate.getDynamicHeight){const $=this.virtualDelegate.getDynamicHeight(k.element);if($!==null){const ne=k.size;return k.size=$,k.lastDynamicHeightWidth=this.renderWidth,$-ne}}if(!k.hasDynamicHeight||k.lastDynamicHeightWidth===this.renderWidth||this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(k.element))return 0;const x=k.size;if(k.row)return k.row.domNode.style.height="",k.size=k.row.domNode.offsetHeight,k.size===0&&!(0,n.isAncestor)(k.row.domNode,(0,n.getWindow)(k.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),k.lastDynamicHeightWidth=this.renderWidth,k.size-x;const{row:N}=this.cache.alloc(k.templateId);N.domNode.style.height="",this.rowsContainer.appendChild(N.domNode);const M=this.renderers.get(k.templateId);if(!M)throw new c.BugIndicatingError("Missing renderer for templateId: "+k.templateId);return M.renderElement(k.element,v,N.templateData,void 0),k.size=N.domNode.offsetHeight,M.disposeElement?.(k.element,v,N.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(k.element,k.size),k.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(N.domNode),this.cache.release(N),k.size-x}getElementDomId(v){return`${this.domId}_${v}`}dispose(){for(const v of this.items)if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const k=this.renderers.get(v.row.templateId);k&&(k.disposeElement?.(v.element,-1,v.row.templateData,void 0),k.disposeTemplate(v.row.templateData))}this.items=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.dragOverAnimationDisposable?.dispose(),this.disposables.dispose()}}t.ListView=z,Je([d.memoize],z.prototype,"onMouseClick",null),Je([d.memoize],z.prototype,"onMouseDblClick",null),Je([d.memoize],z.prototype,"onMouseMiddleClick",null),Je([d.memoize],z.prototype,"onMouseUp",null),Je([d.memoize],z.prototype,"onMouseDown",null),Je([d.memoize],z.prototype,"onMouseOver",null),Je([d.memoize],z.prototype,"onMouseMove",null),Je([d.memoize],z.prototype,"onMouseOut",null),Je([d.memoize],z.prototype,"onContextMenu",null),Je([d.memoize],z.prototype,"onTouchStart",null),Je([d.memoize],z.prototype,"onTap",null)}),define(ve[54],De([1,0,4,27,16,31,73,86,9,12,89,34,3,50,8,2,44,5,10,40,78,23,61,115]),function(oe,t,i,n,P,O,T,w,_,d,D,S,b,m,e,s,o,c,h,p,L,y,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=void 0,t.isInputElement=z,t.isMonacoEditor=v,t.isMonacoCustomToggle=k,t.isActionItem=x,t.isMonacoTwistie=N,t.isStickyScrollElement=M,t.isStickyScrollContainer=$,t.isButton=ne,t.isSelectionSingleChangeEvent=Fe,t.isSelectionRangeChangeEvent=Ae;class f{constructor(l){this.trait=l,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(l){return l}renderElement(l,a,g){const C=this.renderedElements.findIndex(R=>R.templateData===g);if(C>=0){const R=this.renderedElements[C];this.trait.unrender(g),R.index=a}else{const R={index:a,templateData:g};this.renderedElements.push(R)}this.trait.renderIndex(a,g)}splice(l,a,g){const C=[];for(const R of this.renderedElements)R.index<l?C.push(R):R.index>=l+a&&C.push({index:R.index+g-a,templateData:R.templateData});this.renderedElements=C}renderIndexes(l){for(const{index:a,templateData:g}of this.renderedElements)l.indexOf(a)>-1&&this.trait.renderIndex(a,g)}disposeTemplate(l){const a=this.renderedElements.findIndex(g=>g.templateData===l);a<0||this.renderedElements.splice(a,1)}}class E{get name(){return this._trait}get renderer(){return new f(this)}constructor(l){this._trait=l,this.indexes=[],this.sortedIndexes=[],this._onChange=new b.Emitter,this.onChange=this._onChange.event}splice(l,a,g){const C=g.length-a,R=l+a,u=[];let F=0;for(;F<this.sortedIndexes.length&&this.sortedIndexes[F]<l;)u.push(this.sortedIndexes[F++]);for(let A=0;A<g.length;A++)g[A]&&u.push(A+l);for(;F<this.sortedIndexes.length&&this.sortedIndexes[F]>=R;)u.push(this.sortedIndexes[F++]+C);this.renderer.splice(l,a,g.length),this._set(u,u)}renderIndex(l,a){a.classList.toggle(this._trait,this.contains(l))}unrender(l){l.classList.remove(this._trait)}set(l,a){return this._set(l,[...l].sort(Oe),a)}_set(l,a,g){const C=this.indexes,R=this.sortedIndexes;this.indexes=l,this.sortedIndexes=a;const u=me(R,l);return this.renderer.renderIndexes(u),this._onChange.fire({indexes:l,browserEvent:g}),C}get(){return this.indexes}contains(l){return(0,_.binarySearch)(this.sortedIndexes,l,Oe)>=0}dispose(){(0,s.dispose)(this._onChange)}}Je([S.memoize],E.prototype,"renderer",null);class I extends E{constructor(l){super("selected"),this.setAriaSelected=l}renderIndex(l,a){super.renderIndex(l,a),this.setAriaSelected&&(this.contains(l)?a.setAttribute("aria-selected","true"):a.setAttribute("aria-selected","false"))}}class H{constructor(l,a,g){this.trait=l,this.view=a,this.identityProvider=g}splice(l,a,g){if(!this.identityProvider)return this.trait.splice(l,a,new Array(g.length).fill(!1));const C=this.trait.get().map(F=>this.identityProvider.getId(this.view.element(F)).toString());if(C.length===0)return this.trait.splice(l,a,new Array(g.length).fill(!1));const R=new Set(C),u=g.map(F=>R.has(this.identityProvider.getId(F).toString()));this.trait.splice(l,a,u)}}function z(W){return W.tagName==="INPUT"||W.tagName==="TEXTAREA"}function U(W,l){return W.classList.contains(l)?!0:W.classList.contains("monaco-list")||!W.parentElement?!1:U(W.parentElement,l)}function v(W){return U(W,"monaco-editor")}function k(W){return U(W,"monaco-custom-toggle")}function x(W){return U(W,"action-item")}function N(W){return U(W,"monaco-tl-twistie")}function M(W){return U(W,"monaco-tree-sticky-row")}function $(W){return W.classList.contains("monaco-tree-sticky-container")}function ne(W){return W.tagName==="A"&&W.classList.contains("monaco-button")||W.tagName==="DIV"&&W.classList.contains("monaco-button-dropdown")?!0:W.classList.contains("monaco-list")||!W.parentElement?!1:ne(W.parentElement)}class Z{get onKeyDown(){return b.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,l=>l.filter(a=>!z(a.target)).map(a=>new P.StandardKeyboardEvent(a)))}constructor(l,a,g){this.list=l,this.view=a,this.disposables=new s.DisposableStore,this.multipleSelectionDisposables=new s.DisposableStore,this.multipleSelectionSupport=g.multipleSelectionSupport,this.disposables.add(this.onKeyDown(C=>{switch(C.keyCode){case e.KeyCode.Enter:return this.onEnter(C);case e.KeyCode.UpArrow:return this.onUpArrow(C);case e.KeyCode.DownArrow:return this.onDownArrow(C);case e.KeyCode.PageUp:return this.onPageUpArrow(C);case e.KeyCode.PageDown:return this.onPageDownArrow(C);case e.KeyCode.Escape:return this.onEscape(C);case e.KeyCode.KeyA:this.multipleSelectionSupport&&(c.isMacintosh?C.metaKey:C.ctrlKey)&&this.onCtrlA(C)}}))}updateOptions(l){l.multipleSelectionSupport!==void 0&&(this.multipleSelectionSupport=l.multipleSelectionSupport)}onEnter(l){l.preventDefault(),l.stopPropagation(),this.list.setSelection(this.list.getFocus(),l.browserEvent)}onUpArrow(l){l.preventDefault(),l.stopPropagation(),this.list.focusPrevious(1,!1,l.browserEvent);const a=this.list.getFocus()[0];this.list.setAnchor(a),this.list.reveal(a),this.view.domNode.focus()}onDownArrow(l){l.preventDefault(),l.stopPropagation(),this.list.focusNext(1,!1,l.browserEvent);const a=this.list.getFocus()[0];this.list.setAnchor(a),this.list.reveal(a),this.view.domNode.focus()}onPageUpArrow(l){l.preventDefault(),l.stopPropagation(),this.list.focusPreviousPage(l.browserEvent);const a=this.list.getFocus()[0];this.list.setAnchor(a),this.list.reveal(a),this.view.domNode.focus()}onPageDownArrow(l){l.preventDefault(),l.stopPropagation(),this.list.focusNextPage(l.browserEvent);const a=this.list.getFocus()[0];this.list.setAnchor(a),this.list.reveal(a),this.view.domNode.focus()}onCtrlA(l){l.preventDefault(),l.stopPropagation(),this.list.setSelection((0,_.range)(this.list.length),l.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(l){this.list.getSelection().length&&(l.preventDefault(),l.stopPropagation(),this.list.setSelection([],l.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}Je([S.memoize],Z.prototype,"onKeyDown",null);var Y;(function(W){W[W.Automatic=0]="Automatic",W[W.Trigger=1]="Trigger"})(Y||(t.TypeNavigationMode=Y={}));var te;(function(W){W[W.Idle=0]="Idle",W[W.Typing=1]="Typing"})(te||(te={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(W){return W.ctrlKey||W.metaKey||W.altKey?!1:W.keyCode>=e.KeyCode.KeyA&&W.keyCode<=e.KeyCode.KeyZ||W.keyCode>=e.KeyCode.Digit0&&W.keyCode<=e.KeyCode.Digit9||W.keyCode>=e.KeyCode.Numpad0&&W.keyCode<=e.KeyCode.Numpad9||W.keyCode>=e.KeyCode.Semicolon&&W.keyCode<=e.KeyCode.Quote}};class fe{constructor(l,a,g,C,R){this.list=l,this.view=a,this.keyboardNavigationLabelProvider=g,this.keyboardNavigationEventFilter=C,this.delegate=R,this.enabled=!1,this.state=te.Idle,this.mode=Y.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new s.DisposableStore,this.disposables=new s.DisposableStore,this.updateOptions(l.options)}updateOptions(l){l.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=l.typeNavigationMode??Y.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let l=!1;const a=b.Event.chain(this.enabledDisposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,R=>R.filter(u=>!z(u.target)).filter(()=>this.mode===Y.Automatic||this.triggered).map(u=>new P.StandardKeyboardEvent(u)).filter(u=>l||this.keyboardNavigationEventFilter(u)).filter(u=>this.delegate.mightProducePrintableCharacter(u)).forEach(u=>i.EventHelper.stop(u,!0)).map(u=>u.browserEvent.key)),g=b.Event.debounce(a,()=>null,800,void 0,void 0,void 0,this.enabledDisposables);b.Event.reduce(b.Event.any(a,g),(R,u)=>u===null?null:(R||"")+u,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),g(this.onClear,this,this.enabledDisposables),a(()=>l=!0,void 0,this.enabledDisposables),g(()=>l=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){this.enabled&&(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const l=this.list.getFocus();if(l.length>0&&l[0]===this.previouslyFocused){const a=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(l[0]));typeof a=="string"?(0,T.alert)(a):a&&(0,T.alert)(a.get())}this.previouslyFocused=-1}onInput(l){if(!l){this.state=te.Idle,this.triggered=!1;return}const a=this.list.getFocus(),g=a.length>0?a[0]:0,C=this.state===te.Idle?1:0;this.state=te.Typing;for(let R=0;R<this.list.length;R++){const u=(g+R+C)%this.list.length,F=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(u)),A=F&&F.toString();if(this.list.options.typeNavigationEnabled){if(typeof A<"u"){if((0,m.matchesPrefix)(l,A)){this.previouslyFocused=g,this.list.setFocus([u]),this.list.reveal(u);return}const B=(0,m.matchesFuzzy2)(l,A);if(B&&B[0].end-B[0].start>1&&B.length===1){this.previouslyFocused=g,this.list.setFocus([u]),this.list.reveal(u);return}}}else if(typeof A>"u"||(0,m.matchesPrefix)(l,A)){this.previouslyFocused=g,this.list.setFocus([u]),this.list.reveal(u);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class Ee{constructor(l,a){this.list=l,this.view=a,this.disposables=new s.DisposableStore;const g=b.Event.chain(this.disposables.add(new n.DomEmitter(a.domNode,"keydown")).event,R=>R.filter(u=>!z(u.target)).map(u=>new P.StandardKeyboardEvent(u)));b.Event.chain(g,R=>R.filter(u=>u.keyCode===e.KeyCode.Tab&&!u.ctrlKey&&!u.metaKey&&!u.shiftKey&&!u.altKey))(this.onTab,this,this.disposables)}onTab(l){if(l.target!==this.view.domNode)return;const a=this.list.getFocus();if(a.length===0)return;const g=this.view.domElement(a[0]);if(!g)return;const C=g.querySelector("[tabIndex]");if(!C||!(0,i.isHTMLElement)(C)||C.tabIndex===-1)return;const R=(0,i.getWindow)(C).getComputedStyle(C);R.visibility==="hidden"||R.display==="none"||(l.preventDefault(),l.stopPropagation(),C.focus())}dispose(){this.disposables.dispose()}}function Fe(W){return c.isMacintosh?W.browserEvent.metaKey:W.browserEvent.ctrlKey}function Ae(W){return W.browserEvent.shiftKey}function ue(W){return(0,i.isMouseEvent)(W)&&W.button===2}const J={isSelectionSingleChangeEvent:Fe,isSelectionRangeChangeEvent:Ae};class de{constructor(l){this.list=l,this.disposables=new s.DisposableStore,this._onPointer=new b.Emitter,this.onPointer=this._onPointer.event,l.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||J),this.mouseSupport=typeof l.options.mouseSupport>"u"||!!l.options.mouseSupport,this.mouseSupport&&(l.onMouseDown(this.onMouseDown,this,this.disposables),l.onContextMenu(this.onContextMenu,this,this.disposables),l.onMouseDblClick(this.onDoubleClick,this,this.disposables),l.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(O.Gesture.addTarget(l.getHTMLElement()))),b.Event.any(l.onMouseClick,l.onMouseMiddleClick,l.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(l){l.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,l.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||J))}isSelectionSingleChangeEvent(l){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(l):!1}isSelectionRangeChangeEvent(l){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(l):!1}isSelectionChangeEvent(l){return this.isSelectionSingleChangeEvent(l)||this.isSelectionRangeChangeEvent(l)}onMouseDown(l){v(l.browserEvent.target)||(0,i.getActiveElement)()!==l.browserEvent.target&&this.list.domFocus()}onContextMenu(l){if(z(l.browserEvent.target)||v(l.browserEvent.target))return;const a=typeof l.index>"u"?[]:[l.index];this.list.setFocus(a,l.browserEvent)}onViewPointer(l){if(!this.mouseSupport||z(l.browserEvent.target)||v(l.browserEvent.target)||l.browserEvent.isHandledByList)return;l.browserEvent.isHandledByList=!0;const a=l.index;if(typeof a>"u"){this.list.setFocus([],l.browserEvent),this.list.setSelection([],l.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionChangeEvent(l))return this.changeSelection(l);this.list.setFocus([a],l.browserEvent),this.list.setAnchor(a),ue(l.browserEvent)||this.list.setSelection([a],l.browserEvent),this._onPointer.fire(l)}onDoubleClick(l){if(z(l.browserEvent.target)||v(l.browserEvent.target)||this.isSelectionChangeEvent(l)||l.browserEvent.isHandledByList)return;l.browserEvent.isHandledByList=!0;const a=this.list.getFocus();this.list.setSelection(a,l.browserEvent)}changeSelection(l){const a=l.index;let g=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(l)){typeof g>"u"&&(g=this.list.getFocus()[0]??a,this.list.setAnchor(g));const C=Math.min(g,a),R=Math.max(g,a),u=(0,_.range)(C,R+1),F=this.list.getSelection(),A=Q(me(F,[g]),g);if(A.length===0)return;const B=me(u,_e(F,A));this.list.setSelection(B,l.browserEvent),this.list.setFocus([a],l.browserEvent)}else if(this.isSelectionSingleChangeEvent(l)){const C=this.list.getSelection(),R=C.filter(u=>u!==a);this.list.setFocus([a]),this.list.setAnchor(a),C.length===R.length?this.list.setSelection([...R,a],l.browserEvent):this.list.setSelection(R,l.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=de;class ae{constructor(l,a){this.styleElement=l,this.selectorSuffix=a}style(l){const a=this.selectorSuffix&&`.${this.selectorSuffix}`,g=[];l.listBackground&&g.push(`.monaco-list${a} .monaco-list-rows { background: ${l.listBackground}; }`),l.listFocusBackground&&(g.push(`.monaco-list${a}:focus .monaco-list-row.focused { background-color: ${l.listFocusBackground}; }`),g.push(`.monaco-list${a}:focus .monaco-list-row.focused:hover { background-color: ${l.listFocusBackground}; }`)),l.listFocusForeground&&g.push(`.monaco-list${a}:focus .monaco-list-row.focused { color: ${l.listFocusForeground}; }`),l.listActiveSelectionBackground&&(g.push(`.monaco-list${a}:focus .monaco-list-row.selected { background-color: ${l.listActiveSelectionBackground}; }`),g.push(`.monaco-list${a}:focus .monaco-list-row.selected:hover { background-color: ${l.listActiveSelectionBackground}; }`)),l.listActiveSelectionForeground&&g.push(`.monaco-list${a}:focus .monaco-list-row.selected { color: ${l.listActiveSelectionForeground}; }`),l.listActiveSelectionIconForeground&&g.push(`.monaco-list${a}:focus .monaco-list-row.selected .codicon { color: ${l.listActiveSelectionIconForeground}; }`),l.listFocusAndSelectionBackground&&g.push(`
				.monaco-drag-image,
				.monaco-list${a}:focus .monaco-list-row.selected.focused { background-color: ${l.listFocusAndSelectionBackground}; }
			`),l.listFocusAndSelectionForeground&&g.push(`
				.monaco-drag-image,
				.monaco-list${a}:focus .monaco-list-row.selected.focused { color: ${l.listFocusAndSelectionForeground}; }
			`),l.listInactiveFocusForeground&&(g.push(`.monaco-list${a} .monaco-list-row.focused { color:  ${l.listInactiveFocusForeground}; }`),g.push(`.monaco-list${a} .monaco-list-row.focused:hover { color:  ${l.listInactiveFocusForeground}; }`)),l.listInactiveSelectionIconForeground&&g.push(`.monaco-list${a} .monaco-list-row.focused .codicon { color:  ${l.listInactiveSelectionIconForeground}; }`),l.listInactiveFocusBackground&&(g.push(`.monaco-list${a} .monaco-list-row.focused { background-color:  ${l.listInactiveFocusBackground}; }`),g.push(`.monaco-list${a} .monaco-list-row.focused:hover { background-color:  ${l.listInactiveFocusBackground}; }`)),l.listInactiveSelectionBackground&&(g.push(`.monaco-list${a} .monaco-list-row.selected { background-color:  ${l.listInactiveSelectionBackground}; }`),g.push(`.monaco-list${a} .monaco-list-row.selected:hover { background-color:  ${l.listInactiveSelectionBackground}; }`)),l.listInactiveSelectionForeground&&g.push(`.monaco-list${a} .monaco-list-row.selected { color: ${l.listInactiveSelectionForeground}; }`),l.listHoverBackground&&g.push(`.monaco-list${a}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${l.listHoverBackground}; }`),l.listHoverForeground&&g.push(`.monaco-list${a}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${l.listHoverForeground}; }`);const C=(0,i.asCssValueWithDefault)(l.listFocusAndSelectionOutline,(0,i.asCssValueWithDefault)(l.listSelectionOutline,l.listFocusOutline??""));C&&g.push(`.monaco-list${a}:focus .monaco-list-row.focused.selected { outline: 1px solid ${C}; outline-offset: -1px;}`),l.listFocusOutline&&g.push(`
				.monaco-drag-image,
				.monaco-list${a}:focus .monaco-list-row.focused { outline: 1px solid ${l.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${a}.last-focused .monaco-list-row.focused { outline: 1px solid ${l.listFocusOutline}; outline-offset: -1px; }
			`);const R=(0,i.asCssValueWithDefault)(l.listSelectionOutline,l.listInactiveFocusOutline??"");R&&g.push(`.monaco-list${a} .monaco-list-row.focused.selected { outline: 1px dotted ${R}; outline-offset: -1px; }`),l.listSelectionOutline&&g.push(`.monaco-list${a} .monaco-list-row.selected { outline: 1px dotted ${l.listSelectionOutline}; outline-offset: -1px; }`),l.listInactiveFocusOutline&&g.push(`.monaco-list${a} .monaco-list-row.focused { outline: 1px dotted ${l.listInactiveFocusOutline}; outline-offset: -1px; }`),l.listHoverOutline&&g.push(`.monaco-list${a} .monaco-list-row:hover { outline: 1px dashed ${l.listHoverOutline}; outline-offset: -1px; }`),l.listDropOverBackground&&g.push(`
				.monaco-list${a}.drop-target,
				.monaco-list${a} .monaco-list-rows.drop-target,
				.monaco-list${a} .monaco-list-row.drop-target { background-color: ${l.listDropOverBackground} !important; color: inherit !important; }
			`),l.listDropBetweenBackground&&(g.push(`
			.monaco-list${a} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${a} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${l.listDropBetweenBackground};
			}`),g.push(`
			.monaco-list${a} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${a} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${l.listDropBetweenBackground};
			}`)),l.tableColumnsBorder&&g.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${l.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),l.tableOddRowsBackgroundColor&&g.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${l.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=g.join(`
`)}}t.DefaultStyleController=ae,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:D.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:D.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:D.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const Le={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Q(W,l){const a=W.indexOf(l);if(a===-1)return[];const g=[];let C=a-1;for(;C>=0&&W[C]===l-(a-C);)g.push(W[C--]);for(g.reverse(),C=a;C<W.length&&W[C]===l+(C-a);)g.push(W[C++]);return g}function me(W,l){const a=[];let g=0,C=0;for(;g<W.length||C<l.length;)if(g>=W.length)a.push(l[C++]);else if(C>=l.length)a.push(W[g++]);else if(W[g]===l[C]){a.push(W[g]),g++,C++;continue}else W[g]<l[C]?a.push(W[g++]):a.push(l[C++]);return a}function _e(W,l){const a=[];let g=0,C=0;for(;g<W.length||C<l.length;)if(g>=W.length)a.push(l[C++]);else if(C>=l.length)a.push(W[g++]);else if(W[g]===l[C]){g++,C++;continue}else W[g]<l[C]?a.push(W[g++]):C++;return a}const Oe=(W,l)=>W-l;class Ce{constructor(l,a){this._templateId=l,this.renderers=a}get templateId(){return this._templateId}renderTemplate(l){return this.renderers.map(a=>a.renderTemplate(l))}renderElement(l,a,g,C){let R=0;for(const u of this.renderers)u.renderElement(l,a,g[R++],C)}disposeElement(l,a,g,C){let R=0;for(const u of this.renderers)u.disposeElement?.(l,a,g[R],C),R+=1}disposeTemplate(l){let a=0;for(const g of this.renderers)g.disposeTemplate(l[a++])}}class Be{constructor(l){this.accessibilityProvider=l,this.templateId="a18n"}renderTemplate(l){return{container:l,disposables:new s.DisposableStore}}renderElement(l,a,g){const C=this.accessibilityProvider.getAriaLabel(l),R=C&&typeof C!="string"?C:(0,r.constObservable)(C);g.disposables.add((0,r.autorun)(F=>{this.setAriaLabel(F.readObservable(R),g.container)}));const u=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(l);typeof u=="number"?g.container.setAttribute("aria-level",`${u}`):g.container.removeAttribute("aria-level")}setAriaLabel(l,a){l?a.setAttribute("aria-label",l):a.removeAttribute("aria-label")}disposeElement(l,a,g,C){g.disposables.clear()}disposeTemplate(l){l.disposables.dispose()}}class ie{constructor(l,a){this.list=l,this.dnd=a}getDragElements(l){const a=this.list.getSelectedElements();return a.indexOf(l)>-1?a:[l]}getDragURI(l){return this.dnd.getDragURI(l)}getDragLabel(l,a){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(l,a)}onDragStart(l,a){this.dnd.onDragStart?.(l,a)}onDragOver(l,a,g,C,R){return this.dnd.onDragOver(l,a,g,C,R)}onDragLeave(l,a,g,C){this.dnd.onDragLeave?.(l,a,g,C)}onDragEnd(l){this.dnd.onDragEnd?.(l)}drop(l,a,g,C,R){this.dnd.drop(l,a,g,C,R)}dispose(){this.dnd.dispose()}}class q{get onDidChangeFocus(){return b.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),l=>this.toListEvent(l),this.disposables)}get onDidChangeSelection(){return b.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),l=>this.toListEvent(l),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let l=!1;const a=b.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,R=>R.map(u=>new P.StandardKeyboardEvent(u)).filter(u=>l=u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.EventHelper.stop(u,!0)).filter(()=>!1)),g=b.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keyup")).event,R=>R.forEach(()=>l=!1).map(u=>new P.StandardKeyboardEvent(u)).filter(u=>u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.EventHelper.stop(u,!0)).map(({browserEvent:u})=>{const F=this.getFocus(),A=F.length?F[0]:void 0,B=typeof A<"u"?this.view.element(A):void 0,V=typeof A<"u"?this.view.domElement(A):this.view.domNode;return{index:A,element:B,anchor:V,browserEvent:u}})),C=b.Event.chain(this.view.onContextMenu,R=>R.filter(u=>!l).map(({element:u,index:F,browserEvent:A})=>({element:u,index:F,anchor:new y.StandardMouseEvent((0,i.getWindow)(this.view.domNode),A),browserEvent:A})));return b.Event.any(a,g,C)}get onKeyDown(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return b.Event.signal(this.disposables.add(new n.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return b.Event.signal(this.disposables.add(new n.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(l,a,g,C,R=Le){this.user=l,this._options=R,this.focus=new E("focused"),this.anchor=new E("anchor"),this.eventBufferer=new b.EventBufferer,this._ariaLabel="",this.disposables=new s.DisposableStore,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event;const u=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new I(u!=="listbox");const F=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=R.accessibilityProvider,this.accessibilityProvider&&(F.push(new Be(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),C=C.map(B=>new Ce(B.templateId,[...F,B]));const A={...R,dnd:R.dnd&&new ie(this,R.dnd)};if(this.view=this.createListView(a,g,C,A),this.view.domNode.setAttribute("role",u),R.styleController)this.styleController=R.styleController(this.view.domId);else{const B=(0,i.createStyleSheet)(this.view.domNode);this.styleController=new ae(B,this.view.domId)}if(this.spliceable=new w.CombinedSpliceable([new H(this.focus,this.view,R.identityProvider),new H(this.selection,this.view,R.identityProvider),new H(this.anchor,this.view,R.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new Ee(this,this.view)),(typeof R.keyboardSupport!="boolean"||R.keyboardSupport)&&(this.keyboardController=new Z(this,this.view,R),this.disposables.add(this.keyboardController)),R.keyboardNavigationLabelProvider){const B=R.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new fe(this,this.view,R.keyboardNavigationLabelProvider,R.keyboardNavigationEventFilter??(()=>!0),B),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(R),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createListView(l,a,g,C){return new L.ListView(l,a,g,C)}createMouseController(l){return new de(this)}updateOptions(l={}){this._options={...this._options,...l},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(l),this.keyboardController?.updateOptions(l),this.view.updateOptions(l)}get options(){return this._options}splice(l,a,g=[]){if(l<0||l>this.view.length)throw new p.ListError(this.user,`Invalid start index: ${l}`);if(a<0)throw new p.ListError(this.user,`Invalid delete count: ${a}`);a===0&&g.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(l,a,g))}updateWidth(l){this.view.updateWidth(l)}updateElementHeight(l,a){this.view.updateElementHeight(l,a,null)}rerender(){this.view.rerender()}element(l){return this.view.element(l)}indexOf(l){return this.view.indexOf(l)}indexAt(l){return this.view.indexAt(l)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.getScrollTop()}set scrollTop(l){this.view.setScrollTop(l)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(l){this.view.setScrollLeft(l)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.view.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(l){this._ariaLabel=l,this.view.domNode.setAttribute("aria-label",l)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(l,a){this.view.layout(l,a)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(l,a){for(const g of l)if(g<0||g>=this.length)throw new p.ListError(this.user,`Invalid index ${g}`);this.selection.set(l,a)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(l=>this.view.element(l))}setAnchor(l){if(typeof l>"u"){this.anchor.set([]);return}if(l<0||l>=this.length)throw new p.ListError(this.user,`Invalid index ${l}`);this.anchor.set([l])}getAnchor(){return(0,_.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const l=this.getAnchor();return typeof l>"u"?void 0:this.element(l)}setFocus(l,a){for(const g of l)if(g<0||g>=this.length)throw new p.ListError(this.user,`Invalid index ${g}`);this.focus.set(l,a)}focusNext(l=1,a=!1,g,C){if(this.length===0)return;const R=this.focus.get(),u=this.findNextIndex(R.length>0?R[0]+l:0,a,C);u>-1&&this.setFocus([u],g)}focusPrevious(l=1,a=!1,g,C){if(this.length===0)return;const R=this.focus.get(),u=this.findPreviousIndex(R.length>0?R[0]-l:0,a,C);u>-1&&this.setFocus([u],g)}async focusNextPage(l,a){let g=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);g=g===0?0:g-1;const C=this.getFocus()[0];if(C!==g&&(C===void 0||g>C)){const R=this.findPreviousIndex(g,!1,a);R>-1&&C!==R?this.setFocus([R],l):this.setFocus([g],l)}else{const R=this.view.getScrollTop();let u=R+this.view.renderHeight;g>C&&(u-=this.view.elementHeight(g)),this.view.setScrollTop(u),this.view.getScrollTop()!==R&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusNextPage(l,a))}}async focusPreviousPage(l,a,g=()=>0){let C;const R=g(),u=this.view.getScrollTop()+R;u===0?C=this.view.indexAt(u):C=this.view.indexAfter(u-1);const F=this.getFocus()[0];if(F!==C&&(F===void 0||F>=C)){const A=this.findNextIndex(C,!1,a);A>-1&&F!==A?this.setFocus([A],l):this.setFocus([C],l)}else{const A=u;this.view.setScrollTop(u-this.view.renderHeight-R),this.view.getScrollTop()+g()!==A&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusPreviousPage(l,a,g))}}focusLast(l,a){if(this.length===0)return;const g=this.findPreviousIndex(this.length-1,!1,a);g>-1&&this.setFocus([g],l)}focusFirst(l,a){this.focusNth(0,l,a)}focusNth(l,a,g){if(this.length===0)return;const C=this.findNextIndex(l,!1,g);C>-1&&this.setFocus([C],a)}findNextIndex(l,a=!1,g){for(let C=0;C<this.length;C++){if(l>=this.length&&!a)return-1;if(l=l%this.length,!g||g(this.element(l)))return l;l++}return-1}findPreviousIndex(l,a=!1,g){for(let C=0;C<this.length;C++){if(l<0&&!a)return-1;if(l=(this.length+l%this.length)%this.length,!g||g(this.element(l)))return l;l--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(l=>this.view.element(l))}reveal(l,a,g=0){if(l<0||l>=this.length)throw new p.ListError(this.user,`Invalid index ${l}`);const C=this.view.getScrollTop(),R=this.view.elementTop(l),u=this.view.elementHeight(l);if((0,h.isNumber)(a)){const F=u-this.view.renderHeight+g;this.view.setScrollTop(F*(0,o.clamp)(a,0,1)+R-g)}else{const F=R+u,A=C+this.view.renderHeight;R<C+g&&F>=A||(R<C+g||F>=A&&u>=this.view.renderHeight?this.view.setScrollTop(R-g):F>=A&&this.view.setScrollTop(F-this.view.renderHeight))}}getRelativeTop(l,a=0){if(l<0||l>=this.length)throw new p.ListError(this.user,`Invalid index ${l}`);const g=this.view.getScrollTop(),C=this.view.elementTop(l),R=this.view.elementHeight(l);if(C<g+a||C+R>g+this.view.renderHeight)return null;const u=R-this.view.renderHeight+a;return Math.abs((g+a-C)/u)}isDOMFocused(){return(0,i.isActiveElement)(this.view.domNode)}getHTMLElement(){return this.view.domNode}getScrollableElement(){return this.view.scrollableElementDomNode}getElementID(l){return this.view.getElementDomId(l)}getElementTop(l){return this.view.elementTop(l)}style(l){this.styleController.style(l)}toListEvent({indexes:l,browserEvent:a}){return{indexes:l,elements:l.map(g=>this.view.element(g)),browserEvent:a}}_onFocusChange(){const l=this.focus.get();this.view.domNode.classList.toggle("element-focused",l.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const l=this.focus.get();if(l.length>0){let a;this.accessibilityProvider?.getActiveDescendantId&&(a=this.accessibilityProvider.getActiveDescendantId(this.view.element(l[0]))),this.view.domNode.setAttribute("aria-activedescendant",a||this.view.getElementDomId(l[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const l=this.selection.get();this.view.domNode.classList.toggle("selection-none",l.length===0),this.view.domNode.classList.toggle("selection-single",l.length===1),this.view.domNode.classList.toggle("selection-multiple",l.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}t.List=q,Je([S.memoize],q.prototype,"onDidChangeFocus",null),Je([S.memoize],q.prototype,"onDidChangeSelection",null),Je([S.memoize],q.prototype,"onContextMenu",null),Je([S.memoize],q.prototype,"onKeyDown",null),Je([S.memoize],q.prototype,"onKeyUp",null),Je([S.memoize],q.prototype,"onKeyPress",null),Je([S.memoize],q.prototype,"onDidFocus",null),Je([S.memoize],q.prototype,"onDidBlur",null)}),define(ve[142],De([1,0,6,66,52,11,17]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0,t.isEmptyMarkdownString=d,t.isMarkdownString=D,t.markdownStringEqual=S,t.escapeMarkdownSyntaxTokens=b,t.appendEscapedMarkdownCodeBlockFence=m,t.escapeDoubleQuotes=e,t.removeMarkdownEscapes=s,t.parseHrefAndDimensions=o;var w;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(w||(t.MarkdownStringTextNewlineStyle=w={}));class _{constructor(h="",p=!1){if(this.value=h,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(h,p=w.Paragraph){return this.value+=b(this.supportThemeIcons?(0,n.escapeIcons)(h):h).replace(/([ \t]+)/g,(L,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===w.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,p){return this.value+=`
${m(p,h)}
`,this}appendLink(h,p,L){return this.value+="[",this.value+=this._escape(p,"]"),this.value+="](",this.value+=this._escape(String(h),")"),L&&(this.value+=` "${this._escape(this._escape(L,'"'),")")}"`),this.value+=")",this}_escape(h,p){const L=new RegExp((0,O.escapeRegExpCharacters)(p),"g");return h.replace(L,(y,r)=>h.charAt(r-1)!=="\\"?`\\${y}`:y)}}t.MarkdownString=_;function d(c){return D(c)?!c.value:Array.isArray(c)?c.every(d):!0}function D(c){return c instanceof _?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function S(c,h){return c===h?!0:!c||!h?!1:c.value===h.value&&c.isTrusted===h.isTrusted&&c.supportThemeIcons===h.supportThemeIcons&&c.supportHtml===h.supportHtml&&(c.baseUri===h.baseUri||!!c.baseUri&&!!h.baseUri&&(0,P.isEqual)(T.URI.from(c.baseUri),T.URI.from(h.baseUri)))}function b(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function m(c,h){const p=c.match(/^`+/gm)?.reduce((y,r)=>y.length>r.length?y:r).length??0,L=p>=3?p+1:3;return[`${"`".repeat(L)}${h}`,c,`${"`".repeat(L)}`].join(`
`)}function e(c){return c.replace(/"/g,"&quot;")}function s(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(c){const h=[],p=c.split("|").map(y=>y.trim());c=p[0];const L=p[1];if(L){const y=/height=(\d+)/.exec(L),r=/width=(\d+)/.exec(L),f=y?y[1]:"",E=r?r[1]:"",I=isFinite(parseInt(E)),H=isFinite(parseInt(f));I&&h.push(`width="${E}"`),H&&h.push(`height="${f}"`)}return{href:c,dimensions:h}}}),define(ve[143],De([1,0,4,134,27,71,16,23,135,6,3,142,66,91,8,26,2,92,69,39,63,52,11,17]),function(oe,t,i,n,P,O,T,w,_,d,D,S,b,m,e,s,o,c,h,p,L,y,r,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.allowedMarkdownAttr=void 0,t.renderMarkdown=I,t.renderStringAsPlaintext=x,t.renderMarkdownAsPlaintext=N,t.fillInIncompleteTokens=ue;const E=Object.freeze({image:(l,a,g)=>{let C=[],R=[];return l&&({href:l,dimensions:C}=(0,S.parseHrefAndDimensions)(l),R.push(`src="${(0,S.escapeDoubleQuotes)(l)}"`)),g&&R.push(`alt="${(0,S.escapeDoubleQuotes)(g)}"`),a&&R.push(`title="${(0,S.escapeDoubleQuotes)(a)}"`),C.length&&(R=R.concat(C)),"<img "+R.join(" ")+">"},paragraph:l=>`<p>${l}</p>`,link:(l,a,g)=>typeof l!="string"?"":(l===g&&(g=(0,S.removeMarkdownEscapes)(g)),a=typeof a=="string"?(0,S.escapeDoubleQuotes)((0,S.removeMarkdownEscapes)(a)):"",l=(0,S.removeMarkdownEscapes)(l),l=l.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${l}" title="${a||l}" draggable="false">${g}</a>`)});function I(l,a={},g={}){const C=new o.DisposableStore;let R=!1;const u=(0,O.createElement)(a),F=function(we){let Ie;try{Ie=(0,h.parse)(decodeURIComponent(we))}catch{}return Ie?(Ie=(0,L.cloneAndChange)(Ie,Te=>{if(l.uris&&l.uris[Te])return f.URI.revive(l.uris[Te])}),encodeURIComponent(JSON.stringify(Ie))):we},A=function(we,Ie){const Te=l.uris&&l.uris[we];let ce=f.URI.revive(Te);return Ie?we.startsWith(p.Schemas.data+":")?we:(ce||(ce=f.URI.parse(we)),p.FileAccess.uriToBrowserUri(ce).toString(!0)):!ce||f.URI.parse(we).toString()===ce.toString()?we:(ce.query&&(ce=ce.with({query:F(ce.query)})),ce.toString())},B=new c.marked.Renderer;B.image=E.image,B.link=E.link,B.paragraph=E.paragraph;const V=[],G=[];if(a.codeBlockRendererSync?B.code=(we,Ie)=>{const Te=m.defaultGenerator.nextId(),ce=a.codeBlockRendererSync(H(Ie),we);return G.push([Te,ce]),`<div class="code" data-code="${Te}">${(0,r.escape)(we)}</div>`}:a.codeBlockRenderer&&(B.code=(we,Ie)=>{const Te=m.defaultGenerator.nextId(),ce=a.codeBlockRenderer(H(Ie),we);return V.push(ce.then(Re=>[Te,Re])),`<div class="code" data-code="${Te}">${(0,r.escape)(we)}</div>`}),a.actionHandler){const we=function(ce){let Re=ce.target;if(!(Re.tagName!=="A"&&(Re=Re.parentElement,!Re||Re.tagName!=="A")))try{let Ue=Re.dataset.href;Ue&&(l.baseUri&&(Ue=z(f.URI.from(l.baseUri),Ue)),a.actionHandler.callback(Ue,ce))}catch(Ue){(0,d.onUnexpectedError)(Ue)}finally{ce.preventDefault()}},Ie=a.actionHandler.disposables.add(new P.DomEmitter(u,"click")),Te=a.actionHandler.disposables.add(new P.DomEmitter(u,"auxclick"));a.actionHandler.disposables.add(D.Event.any(Ie.event,Te.event)(ce=>{const Re=new w.StandardMouseEvent(i.getWindow(u),ce);!Re.leftButton&&!Re.middleButton||we(Re)})),a.actionHandler.disposables.add(i.addDisposableListener(u,"keydown",ce=>{const Re=new T.StandardKeyboardEvent(ce);!Re.equals(e.KeyCode.Space)&&!Re.equals(e.KeyCode.Enter)||we(Re)}))}l.supportHtml||(g.sanitizer=we=>a.sanitizerOptions?.replaceWithPlaintext?(0,r.escape)(we):(l.isTrusted?we.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?we:"",g.sanitize=!0,g.silent=!0),g.renderer=B;let ee=l.value??"";ee.length>1e5&&(ee=`${ee.substr(0,1e5)}\u2026`),l.supportThemeIcons&&(ee=(0,b.markdownEscapeEscapedIcons)(ee));let re;if(a.fillInIncompleteTokens){const we={...c.marked.defaults,...g},Ie=c.marked.lexer(ee,we),Te=ue(Ie);re=c.marked.parser(Te,we)}else re=c.marked.parse(ee,g);l.supportThemeIcons&&(re=(0,_.renderLabelWithIcons)(re).map(Ie=>typeof Ie=="string"?Ie:Ie.outerHTML).join(""));const ye=new DOMParser().parseFromString(v({isTrusted:l.isTrusted,...a.sanitizerOptions},re),"text/html");if(ye.body.querySelectorAll("img, audio, video, source").forEach(we=>{const Ie=we.getAttribute("src");if(Ie){let Te=Ie;try{l.baseUri&&(Te=z(f.URI.from(l.baseUri),Te))}catch{}if(we.setAttribute("src",A(Te,!0)),a.remoteImageIsAllowed){const ce=f.URI.parse(Te);ce.scheme!==p.Schemas.file&&ce.scheme!==p.Schemas.data&&!a.remoteImageIsAllowed(ce)&&we.replaceWith(i.$("",void 0,we.outerHTML))}}}),ye.body.querySelectorAll("a").forEach(we=>{const Ie=we.getAttribute("href");if(we.setAttribute("href",""),!Ie||/^data:|javascript:/i.test(Ie)||/^command:/i.test(Ie)&&!l.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(Ie))we.replaceWith(...we.childNodes);else{let Te=A(Ie,!1);l.baseUri&&(Te=z(f.URI.from(l.baseUri),Ie)),we.dataset.href=Te}}),u.innerHTML=v({isTrusted:l.isTrusted,...a.sanitizerOptions},ye.body.innerHTML),V.length>0)Promise.all(V).then(we=>{if(R)return;const Ie=new Map(we),Te=u.querySelectorAll("div[data-code]");for(const ce of Te){const Re=Ie.get(ce.dataset.code??"");Re&&i.reset(ce,Re)}a.asyncRenderCallback?.()});else if(G.length>0){const we=new Map(G),Ie=u.querySelectorAll("div[data-code]");for(const Te of Ie){const ce=we.get(Te.dataset.code??"");ce&&i.reset(Te,ce)}}if(a.asyncRenderCallback)for(const we of u.getElementsByTagName("img")){const Ie=C.add(i.addDisposableListener(we,"load",()=>{Ie.dispose(),a.asyncRenderCallback()}))}return{element:u,dispose:()=>{R=!0,C.dispose()}}}function H(l){if(!l)return"";const a=l.split(/[\s+|:|,|\{|\?]/,1);return a.length?a[0]:l}function z(l,a){return/^\w[\w\d+.-]*:/.test(a)?a:l.path.endsWith("/")?(0,y.resolvePath)(l,a).toString():(0,y.resolvePath)((0,y.dirname)(l),a).toString()}const U=["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"];function v(l,a){const{config:g,allowedSchemes:C}=k(l),R=new o.DisposableStore;R.add(W("uponSanitizeAttribute",(u,F)=>{if(F.attrName==="style"||F.attrName==="class"){if(u.tagName==="SPAN"){if(F.attrName==="style"){F.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(F.attrValue);return}else if(F.attrName==="class"){F.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(F.attrValue);return}}F.keepAttr=!1;return}else if(u.tagName==="INPUT"&&u.attributes.getNamedItem("type")?.value==="checkbox"){if(F.attrName==="type"&&F.attrValue==="checkbox"||F.attrName==="disabled"||F.attrName==="checked"){F.keepAttr=!0;return}F.keepAttr=!1}})),R.add(W("uponSanitizeElement",(u,F)=>{if(F.tagName==="input"&&(u.attributes.getNamedItem("type")?.value==="checkbox"?u.setAttribute("disabled",""):l.replaceWithPlaintext||u.parentElement?.removeChild(u)),l.replaceWithPlaintext&&!F.allowedTags[F.tagName]&&F.tagName!=="body"&&u.parentElement){let A,B;if(F.tagName==="#comment")A=`<!--${u.textContent}-->`;else{const re=U.includes(F.tagName),he=u.attributes.length?" "+Array.from(u.attributes).map(ye=>`${ye.name}="${ye.value}"`).join(" "):"";A=`<${F.tagName}${he}>`,re||(B=`</${F.tagName}>`)}const V=document.createDocumentFragment(),G=u.parentElement.ownerDocument.createTextNode(A);V.appendChild(G);const ee=B?u.parentElement.ownerDocument.createTextNode(B):void 0;for(;u.firstChild;)V.appendChild(u.firstChild);ee&&V.appendChild(ee),u.parentElement.replaceChild(V,u)}})),R.add(i.hookDomPurifyHrefAndSrcSanitizer(C));try{return n.sanitize(a,{...g,RETURN_TRUSTED_TYPE:!0})}finally{R.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function k(l){const a=[p.Schemas.http,p.Schemas.https,p.Schemas.mailto,p.Schemas.data,p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemote,p.Schemas.vscodeRemoteResource];return l.isTrusted&&a.push(p.Schemas.command),{config:{ALLOWED_TAGS:l.allowedTags??[...i.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:a}}function x(l){return typeof l=="string"?l:N(l)}function N(l,a){let g=l.value??"";g.length>1e5&&(g=`${g.substr(0,1e5)}\u2026`);const C=c.marked.parse(g,{renderer:a?Z.value:ne.value}).replace(/&(#\d+|[a-zA-Z]+);/g,R=>M.get(R)??R);return v({isTrusted:!1},C).toString()}const M=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]);function $(){const l=new c.marked.Renderer;return l.code=a=>a,l.blockquote=a=>a,l.html=a=>"",l.heading=(a,g,C)=>a+`
`,l.hr=()=>"",l.list=(a,g)=>a,l.listitem=a=>a+`
`,l.paragraph=a=>a+`
`,l.table=(a,g)=>a+g+`
`,l.tablerow=a=>a,l.tablecell=(a,g)=>a+" ",l.strong=a=>a,l.em=a=>a,l.codespan=a=>a,l.br=()=>`
`,l.del=a=>a,l.image=(a,g,C)=>"",l.text=a=>a,l.link=(a,g,C)=>C,l}const ne=new s.Lazy(l=>$()),Z=new s.Lazy(()=>{const l=$();return l.code=a=>"\n```"+a+"```\n",l});function Y(l){let a="";return l.forEach(g=>{a+=g.raw}),a}function te(l){if(l.tokens)for(let a=l.tokens.length-1;a>=0;a--){const g=l.tokens[a];if(g.type==="text"){const C=g.raw.split(`
`),R=C[C.length-1];if(R.includes("`"))return ae(l);if(R.includes("**"))return Ce(l);if(R.match(/\*\w/))return Le(l);if(R.match(/(^|\s)__\w/))return Be(l);if(R.match(/(^|\s)_\w/))return Q(l);if(fe(R)||Ee(R)&&l.tokens.slice(0,a).some(u=>u.type==="text"&&u.raw.match(/\[[^\]]*$/))){const u=l.tokens.slice(a+1);return u[0]?.type==="link"&&u[1]?.type==="text"&&u[1].raw.match(/^ *"[^"]*$/)||R.match(/^[^"]* +"[^"]*$/)?_e(l):me(l)}else if(R.match(/(^|\s)\[\w*/))return Oe(l)}}}function fe(l){return!!l.match(/(^|\s)\[.*\]\(\w*/)}function Ee(l){return!!l.match(/^[^\[]*\]\([^\)]*$/)}function Fe(l){const a=l.items[l.items.length-1],g=a.tokens?a.tokens[a.tokens.length-1]:void 0;let C;if(g?.type==="text"&&!("inRawBlock"in a)&&(C=te(g)),!C||C.type!=="paragraph")return;const R=Y(l.items.slice(0,-1)),u=a.raw.match(/^(\s*(-|\d+\.) +)/)?.[0];if(!u)return;const F=u+Y(a.tokens.slice(0,-1))+C.raw,A=c.marked.lexer(R+F)[0];if(A.type==="list")return A}const Ae=3;function ue(l){for(let a=0;a<Ae;a++){const g=J(l);if(g)l=g;else break}return l}function J(l){let a,g;for(a=0;a<l.length;a++){const C=l[a];let R;if(C.type==="paragraph"&&(R=C.raw.match(/(\n|^)(````*)/))){const u=R[2];g=de(l.slice(a),u);break}if(C.type==="paragraph"&&C.raw.match(/(\n|^)\|/)){g=q(l.slice(a));break}if(a===l.length-1&&C.type==="list"){const u=Fe(C);if(u){g=[u];break}}if(a===l.length-1&&C.type==="paragraph"){const u=te(C);if(u){g=[u];break}}}if(g){const C=[...l.slice(0,a),...g];return C.links=l.links,C}return null}function de(l,a){const g=Y(l);return c.marked.lexer(g+`
${a}`)}function ae(l){return ie(l,"`")}function Le(l){return ie(l,"*")}function Q(l){return ie(l,"_")}function me(l){return ie(l,")")}function _e(l){return ie(l,'")')}function Oe(l){return ie(l,"](https://microsoft.com)")}function Ce(l){return ie(l,"**")}function Be(l){return ie(l,"__")}function ie(l,a){const g=Y(Array.isArray(l)?l:[l]);return c.marked.lexer(g+a)[0]}function q(l){const a=Y(l),g=a.split(`
`);let C,R=!1;for(let u=0;u<g.length;u++){const F=g[u].trim();if(typeof C>"u"&&F.match(/^\s*\|/)){const A=F.match(/(\|[^\|]+)(?=\||$)/g);A&&(C=A.length)}else if(typeof C=="number")if(F.match(/^\s*\|/)){if(u!==g.length-1)return;R=!0}else return}if(typeof C=="number"&&C>0){const u=R?g.slice(0,-1).join(`
`):a,F=!!u.match(/\|\s*$/),A=u+(F?"":"|")+`
|${" --- |".repeat(C)}`;return c.marked.lexer(A)}}function W(l,a){return n.addHook(l,a),(0,o.toDisposable)(()=>n.removeHook(l))}}),define(ve[144],De([1,0,4,27,16,143,74,32,15,54,9,3,8,2,5,20,126,118]),function(oe,t,i,n,P,O,T,w,_,d,D,S,b,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const c=i.$,h="selectOption.entry.template";class p{get templateId(){return h}renderTemplate(r){const f=Object.create(null);return f.root=r,f.text=i.append(r,c(".option-text")),f.detail=i.append(r,c(".option-detail")),f.decoratorRight=i.append(r,c(".option-decorator-right")),f}renderElement(r,f,E){const I=E,H=r.text,z=r.detail,U=r.decoratorRight,v=r.isDisabled;I.text.textContent=H,I.detail.textContent=z||"",I.decoratorRight.innerText=U||"",v?I.root.classList.add("option-disabled"):I.root.classList.remove("option-disabled")}disposeTemplate(r){}}class L extends m.Disposable{static{this.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32}static{this.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2}static{this.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}constructor(r,f,E,I,H){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.styles=I,this.selectBoxOptions=H||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=L.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new S.Emitter,this._register(this._onDidSelect),this.registerListeners(),this.constructSelectDropDown(E),this.selected=f||0,r&&this.setOptions(r,f),this.initStyleSheet()}setTitle(r){!this._hover&&r?this._hover=this._register((0,w.getBaseLayerHoverDelegate)().setupUpdatableHover((0,_.getDefaultHoverDelegate)("mouse"),this.selectElement,r)):this._hover&&this._hover.update(r)}getHeight(){return 22}getTemplateId(){return h}constructSelectDropDown(r){this.contextViewProvider=r,this.selectDropDownContainer=i.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=i.append(this.selectDropDownContainer,c(".select-box-details-pane"));const f=i.append(this.selectDropDownContainer,c(".select-box-dropdown-container-width-control")),E=i.append(f,c(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",i.append(E,this.widthControlElement),this._dropDownPosition=T.AnchorPosition.BELOW,this.styleElement=i.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(i.addDisposableListener(this.selectDropDownContainer,i.EventType.DRAG_START,I=>{i.EventHelper.stop(I,!0)}))}registerListeners(){this._register(i.addStandardDisposableListener(this.selectElement,"change",f=>{this.selected=f.target.selectedIndex,this._onDidSelect.fire({index:f.target.selectedIndex,selected:f.target.value}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)})),this._register(i.addDisposableListener(this.selectElement,i.EventType.CLICK,f=>{i.EventHelper.stop(f),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(i.addDisposableListener(this.selectElement,i.EventType.MOUSE_DOWN,f=>{i.EventHelper.stop(f)}));let r;this._register(i.addDisposableListener(this.selectElement,"touchstart",f=>{r=this._isVisible})),this._register(i.addDisposableListener(this.selectElement,"touchend",f=>{i.EventHelper.stop(f),r?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(i.addDisposableListener(this.selectElement,i.EventType.KEY_DOWN,f=>{const E=new P.StandardKeyboardEvent(f);let I=!1;e.isMacintosh?(E.keyCode===b.KeyCode.DownArrow||E.keyCode===b.KeyCode.UpArrow||E.keyCode===b.KeyCode.Space||E.keyCode===b.KeyCode.Enter)&&(I=!0):(E.keyCode===b.KeyCode.DownArrow&&E.altKey||E.keyCode===b.KeyCode.UpArrow&&E.altKey||E.keyCode===b.KeyCode.Space||E.keyCode===b.KeyCode.Enter)&&(I=!0),I&&(this.showSelectDropDown(),i.EventHelper.stop(f,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(r,f){D.equals(this.options,r)||(this.options=r,this.selectElement.options.length=0,this._hasDetails=!1,this._cachedMaxDetailsHeight=void 0,this.options.forEach((E,I)=>{this.selectElement.add(this.createOption(E.text,I,E.isDisabled)),typeof E.description=="string"&&(this._hasDetails=!0)})),f!==void 0&&(this.select(f),this._currentSelection=this.selected)}setEnabled(r){this.selectElement.disabled=!r}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(r){r>=0&&r<this.options.length?this.selected=r:r>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)}setAriaLabel(r){this.selectBoxOptions.ariaLabel=r,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(r){this.selectElement.tabIndex=r?0:-1}render(r){this.container=r,r.classList.add("select-container"),r.appendChild(this.selectElement),this.styleSelectElement()}initStyleSheet(){const r=[];this.styles.listFocusBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&this.styles.selectBorder!==this.styles.selectBackground?(r.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=r.join(`
`)}styleSelectElement(){const r=this.styles.selectBackground??"",f=this.styles.selectForeground??"",E=this.styles.selectBorder??"";this.selectElement.style.backgroundColor=r,this.selectElement.style.color=f,this.selectElement.style.borderColor=E}styleList(){const r=this.styles.selectBackground??"",f=i.asCssValueWithDefault(this.styles.selectListBackground,r);this.selectDropDownListContainer.style.backgroundColor=f,this.selectionDetailsPane.style.backgroundColor=f;const E=this.styles.focusBorder??"";this.selectDropDownContainer.style.outlineColor=E,this.selectDropDownContainer.style.outlineOffset="-1px",this.selectList.style(this.styles)}createOption(r,f,E){const I=document.createElement("option");return I.value=r,I.text=r,I.disabled=!!E,I}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:r=>this.renderSelectDropDown(r,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:r=>this.renderSelectDropDown(r),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(r){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),r&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(r,f){return r.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(f),{dispose:()=>{try{r.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let r=0;return this.options.forEach((f,E)=>{this.updateDetail(E),this.selectionDetailsPane.offsetHeight>r&&(r=this.selectionDetailsPane.offsetHeight)}),r}layoutSelectDropDown(r){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const f=i.getWindow(this.selectElement),E=i.getDomNodePagePosition(this.selectElement),I=i.getWindow(this.selectElement).getComputedStyle(this.selectElement),H=parseFloat(I.getPropertyValue("--dropdown-padding-top"))+parseFloat(I.getPropertyValue("--dropdown-padding-bottom")),z=f.innerHeight-E.top-E.height-(this.selectBoxOptions.minBottomMargin||0),U=E.top-L.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,v=this.selectElement.offsetWidth,k=this.setWidthControlElement(this.widthControlElement),x=Math.max(k,Math.round(v)).toString()+"px";this.selectDropDownContainer.style.width=x,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let N=this.selectList.contentHeight;this._hasDetails&&this._cachedMaxDetailsHeight===void 0&&(this._cachedMaxDetailsHeight=this.measureMaxDetailsHeight());const M=this._hasDetails?this._cachedMaxDetailsHeight:0,$=N+H+M,ne=Math.floor((z-H-M)/this.getHeight()),Z=Math.floor((U-H-M)/this.getHeight());if(r)return E.top+E.height>f.innerHeight-22||E.top<L.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||ne<1&&Z<1?!1:(ne<L.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&Z>ne&&this.options.length>ne?(this._dropDownPosition=T.AnchorPosition.ABOVE,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=T.AnchorPosition.BELOW,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(E.top+E.height>f.innerHeight-22||E.top<L.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===T.AnchorPosition.BELOW&&ne<1||this._dropDownPosition===T.AnchorPosition.ABOVE&&Z<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===T.AnchorPosition.BELOW){if(this._isVisible&&ne+Z<1)return this.hideSelectDropDown(!0),!1;$>z&&(N=ne*this.getHeight())}else $>U&&(N=Z*this.getHeight());return this.selectList.layout(N),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=N+H+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=N+H+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=x,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(r){let f=0;if(r){let E=0,I=0;this.options.forEach((H,z)=>{const U=H.detail?H.detail.length:0,v=H.decoratorRight?H.decoratorRight.length:0,k=H.text.length+U+v;k>I&&(E=z,I=k)}),r.textContent=this.options[E].text+(this.options[E].decoratorRight?this.options[E].decoratorRight+" ":""),f=i.getTotalWidth(r)}return f}createSelectList(r){if(this.selectList)return;this.selectDropDownListContainer=i.append(r,c(".select-box-dropdown-list-container")),this.listRenderer=new p,this.selectList=new d.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:s.ScrollbarVisibility.Visible,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:I=>{let H=I.text;return I.detail&&(H+=`. ${I.detail}`),I.decoratorRight&&(H+=`. ${I.decoratorRight}`),I.description&&(H+=`. ${I.description}`),H},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>e.isMacintosh?"":"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const f=this._register(new n.DomEmitter(this.selectDropDownListContainer,"keydown")),E=S.Event.chain(f.event,I=>I.filter(()=>this.selectList.length>0).map(H=>new P.StandardKeyboardEvent(H)));this._register(S.Event.chain(E,I=>I.filter(H=>H.keyCode===b.KeyCode.Enter))(this.onEnter,this)),this._register(S.Event.chain(E,I=>I.filter(H=>H.keyCode===b.KeyCode.Tab))(this.onEnter,this)),this._register(S.Event.chain(E,I=>I.filter(H=>H.keyCode===b.KeyCode.Escape))(this.onEscape,this)),this._register(S.Event.chain(E,I=>I.filter(H=>H.keyCode===b.KeyCode.UpArrow))(this.onUpArrow,this)),this._register(S.Event.chain(E,I=>I.filter(H=>H.keyCode===b.KeyCode.DownArrow))(this.onDownArrow,this)),this._register(S.Event.chain(E,I=>I.filter(H=>H.keyCode===b.KeyCode.PageDown))(this.onPageDown,this)),this._register(S.Event.chain(E,I=>I.filter(H=>H.keyCode===b.KeyCode.PageUp))(this.onPageUp,this)),this._register(S.Event.chain(E,I=>I.filter(H=>H.keyCode===b.KeyCode.Home))(this.onHome,this)),this._register(S.Event.chain(E,I=>I.filter(H=>H.keyCode===b.KeyCode.End))(this.onEnd,this)),this._register(S.Event.chain(E,I=>I.filter(H=>H.keyCode>=b.KeyCode.Digit0&&H.keyCode<=b.KeyCode.KeyZ||H.keyCode>=b.KeyCode.Semicolon&&H.keyCode<=b.KeyCode.NumpadDivide))(this.onCharacter,this)),this._register(i.addDisposableListener(this.selectList.getHTMLElement(),i.EventType.POINTER_UP,I=>this.onPointerUp(I))),this._register(this.selectList.onMouseOver(I=>typeof I.index<"u"&&this.selectList.setFocus([I.index]))),this._register(this.selectList.onDidChangeFocus(I=>this.onListFocus(I))),this._register(i.addDisposableListener(this.selectDropDownContainer,i.EventType.FOCUS_OUT,I=>{!this._isVisible||i.isAncestor(I.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(r){if(!this.selectList.length)return;i.EventHelper.stop(r);const f=r.target;if(!f||f.classList.contains("slider"))return;const E=f.closest(".monaco-list-row");if(!E)return;const I=Number(E.getAttribute("data-index")),H=E.classList.contains("option-disabled");I>=0&&I<this.options.length&&!H&&(this.selected=I,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(r,f){const E=H=>{for(let z=0;z<H.childNodes.length;z++){const U=H.childNodes.item(z);(U.tagName&&U.tagName.toLowerCase())==="img"?H.removeChild(U):E(U)}},I=(0,O.renderMarkdown)({value:r,supportThemeIcons:!0},{actionHandler:f});return I.element.classList.add("select-box-description-markdown"),E(I.element),I.element}onListFocus(r){!this._isVisible||!this._hasDetails||this.updateDetail(r.indexes[0])}updateDetail(r){this.selectionDetailsPane.innerText="";const f=this.options[r],E=f?.description??"",I=f?.descriptionIsMarkdown??!1;if(E){if(I){const H=f.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(E,H))}else this.selectionDetailsPane.innerText=E;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(r){i.EventHelper.stop(r),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(r){i.EventHelper.stop(r),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(r){if(this.selected<this.options.length-1){i.EventHelper.stop(r,!0);const f=this.options[this.selected+1].isDisabled;if(f&&this.options.length>this.selected+2)this.selected+=2;else{if(f)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(r){this.selected>0&&(i.EventHelper.stop(r,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(r){i.EventHelper.stop(r),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(r){i.EventHelper.stop(r),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(r){i.EventHelper.stop(r),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(r){i.EventHelper.stop(r),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(r){const f=b.KeyCodeUtils.toString(r.keyCode);let E=-1;for(let I=0;I<this.options.length-1;I++)if(E=(I+this.selected+1)%this.options.length,this.options[E].text.charAt(0).toUpperCase()===f&&!this.options[E].isDisabled){this.select(E),this.selectList.setFocus([E]),this.selectList.reveal(this.selectList.getFocus()[0]),i.EventHelper.stop(r);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=L}),define(ve[145],De([1,0,54,144,138,24,5,117]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...i.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class w extends O.Widget{constructor(d,D,S,b,m){super(),T.isMacintosh&&!m?.useCustomDrawn?this.selectBoxDelegate=new P.SelectBoxNative(d,D,b,m):this.selectBoxDelegate=new n.SelectBoxList(d,D,S,b,m),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(d,D){this.selectBoxDelegate.setOptions(d,D)}select(d){this.selectBoxDelegate.select(d)}setAriaLabel(d){this.selectBoxDelegate.setAriaLabel(d)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(d){this.selectBoxDelegate.setFocusable(d)}setEnabled(d){this.selectBoxDelegate.setEnabled(d)}render(d){this.selectBoxDelegate.render(d)}}t.SelectBox=w}),define(ve[79],De([1,0,19,70,4,31,15,145,51,2,5,10,122,32,67]),function(oe,t,i,n,P,O,T,w,_,d,D,S,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class e extends d.Disposable{get action(){return this._action}constructor(h,p,L={}){super(),this.options=L,this._context=h||this,this._action=p,p instanceof _.Action&&this._register(p.onDidChange(y=>{this.element&&this.handleActionChangeEvent(y)}))}handleActionChangeEvent(h){h.enabled!==void 0&&this.updateEnabled(),h.checked!==void 0&&this.updateChecked(),h.class!==void 0&&this.updateClass(),h.label!==void 0&&(this.updateLabel(),this.updateTooltip()),h.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new _.ActionRunner)),this._actionRunner}set actionRunner(h){this._actionRunner=h}isEnabled(){return this._action.enabled}setActionContext(h){this._context=h}render(h){const p=this.element=h;this._register(O.Gesture.addTarget(h));const L=this.options&&this.options.draggable;L&&(h.draggable=!0,i.isFirefox&&this._register((0,P.addDisposableListener)(h,P.EventType.DRAG_START,y=>y.dataTransfer?.setData(n.DataTransfers.TEXT,this._action.label)))),this._register((0,P.addDisposableListener)(p,O.EventType.Tap,y=>this.onClick(y,!0))),this._register((0,P.addDisposableListener)(p,P.EventType.MOUSE_DOWN,y=>{L||P.EventHelper.stop(y,!0),this._action.enabled&&y.button===0&&p.classList.add("active")})),D.isMacintosh&&this._register((0,P.addDisposableListener)(p,P.EventType.CONTEXT_MENU,y=>{y.button===0&&y.ctrlKey===!0&&this.onClick(y)})),this._register((0,P.addDisposableListener)(p,P.EventType.CLICK,y=>{P.EventHelper.stop(y,!0),this.options&&this.options.isMenu||this.onClick(y)})),this._register((0,P.addDisposableListener)(p,P.EventType.DBLCLICK,y=>{P.EventHelper.stop(y,!0)})),[P.EventType.MOUSE_UP,P.EventType.MOUSE_OUT].forEach(y=>{this._register((0,P.addDisposableListener)(p,y,r=>{P.EventHelper.stop(r),p.classList.remove("active")}))})}onClick(h,p=!1){P.EventHelper.stop(h,!0);const L=S.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?h:{preserveFocus:p}:this._context;this.actionRunner.run(this._action,L)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(h){this.element&&(this.element.tabIndex=h?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getClass(){return this.action.class}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const h=this.getTooltip()??"";if(this.updateAriaLabel(),this.options.hoverDelegate?.showNativeHover)this.element.title=h;else if(!this.customHover&&h!==""){const p=this.options.hoverDelegate??(0,T.getDefaultHoverDelegate)("element");this.customHover=this._store.add((0,m.getBaseLayerHoverDelegate)().setupUpdatableHover(p,this.element,h))}else this.customHover&&this.customHover.update(h)}updateAriaLabel(){if(this.element){const h=this.getTooltip()??"";this.element.setAttribute("aria-label",h)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=e;class s extends e{constructor(h,p,L){super(h,p,L),this.options=L,this.options.icon=L.icon!==void 0?L.icon:!1,this.options.label=L.label!==void 0?L.label:!0,this.cssClass=""}render(h){super.render(h),S.assertType(this.element);const p=document.createElement("a");if(p.classList.add("action-label"),p.setAttribute("role",this.getDefaultAriaRole()),this.label=p,this.element.appendChild(p),this.options.label&&this.options.keybinding){const L=document.createElement("span");L.classList.add("keybinding"),L.textContent=this.options.keybinding,this.element.appendChild(L)}this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}getDefaultAriaRole(){return this._action.id===_.Separator.ID?"presentation":this.options.isMenu?"menuitem":"button"}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(h){this.label&&(this.label.tabIndex=h?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let h=null;return this.action.tooltip?h=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(h=this.action.label,this.options.keybinding&&(h=b.localize(0,null,h,this.options.keybinding))),h??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.getClass(),this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const h=this.getTooltip()??"";this.label.setAttribute("aria-label",h)}}updateChecked(){this.label&&(this.action.checked!==void 0?(this.label.classList.toggle("checked",this.action.checked),this.label.setAttribute("aria-checked",this.action.checked?"true":"false"),this.label.setAttribute("role","checkbox")):(this.label.classList.remove("checked"),this.label.removeAttribute("aria-checked"),this.label.setAttribute("role",this.getDefaultAriaRole())))}}t.ActionViewItem=s;class o extends e{constructor(h,p,L,y,r,f,E){super(h,p),this.selectBox=new w.SelectBox(L,y,r,f,E),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(h,p){this.selectBox.setOptions(h,p)}select(h){this.selectBox.select(h)}registerListeners(){this._register(this.selectBox.onDidSelect(h=>this.runAction(h.selected,h.index)))}runAction(h,p){this.actionRunner.run(this._action,this.getActionContext(h,p))}getActionContext(h,p){return h}setFocusable(h){this.selectBox.setFocusable(h)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(h){this.selectBox.render(h)}}t.SelectActionViewItem=o}),define(ve[80],De([1,0,4,16,79,15,51,3,8,2,10,67]),function(oe,t,i,n,P,O,T,w,_,d,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ActionBar=t.ActionsOrientation=void 0,t.prepareActions=m;var S;(function(e){e[e.HORIZONTAL=0]="HORIZONTAL",e[e.VERTICAL=1]="VERTICAL"})(S||(t.ActionsOrientation=S={}));class b extends d.Disposable{constructor(s,o={}){super(),this._actionRunnerDisposables=this._register(new d.DisposableStore),this.viewItemDisposables=this._register(new d.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new w.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new w.Emitter({onWillAddFirstListener:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new w.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new w.Emitter),this.onWillRun=this._onWillRun.event,this.options=o,this._context=o.context??null,this._orientation=this.options.orientation??S.HORIZONTAL,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[_.KeyCode.Enter,_.KeyCode.Space]},this._hoverDelegate=o.hoverDelegate??this._register((0,O.createInstantHoverDelegate)()),this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new T.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(p=>this._onDidRun.fire(p))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(p=>this._onWillRun.fire(p))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let c,h;switch(this._orientation){case S.HORIZONTAL:c=[_.KeyCode.LeftArrow],h=[_.KeyCode.RightArrow];break;case S.VERTICAL:c=[_.KeyCode.UpArrow],h=[_.KeyCode.DownArrow],this.domNode.className+=" vertical";break}this._register(i.addDisposableListener(this.domNode,i.EventType.KEY_DOWN,p=>{const L=new n.StandardKeyboardEvent(p);let y=!0;const r=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;c&&(L.equals(c[0])||L.equals(c[1]))?y=this.focusPrevious():h&&(L.equals(h[0])||L.equals(h[1]))?y=this.focusNext():L.equals(_.KeyCode.Escape)&&this.cancelHasListener?this._onDidCancel.fire():L.equals(_.KeyCode.Home)?y=this.focusFirst():L.equals(_.KeyCode.End)?y=this.focusLast():L.equals(_.KeyCode.Tab)&&r instanceof P.BaseActionViewItem&&r.trapsArrowNavigation?y=this.focusNext():this.isTriggerKeyEvent(L)?this._triggerKeys.keyDown?this.doTrigger(L):this.triggerKeyDown=!0:y=!1,y&&(L.preventDefault(),L.stopPropagation())})),this._register(i.addDisposableListener(this.domNode,i.EventType.KEY_UP,p=>{const L=new n.StandardKeyboardEvent(p);this.isTriggerKeyEvent(L)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(L)),L.preventDefault(),L.stopPropagation()):(L.equals(_.KeyCode.Tab)||L.equals(_.KeyMod.Shift|_.KeyCode.Tab)||L.equals(_.KeyCode.UpArrow)||L.equals(_.KeyCode.DownArrow)||L.equals(_.KeyCode.LeftArrow)||L.equals(_.KeyCode.RightArrow))&&this.updateFocusedItem()})),this.focusTracker=this._register(i.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(i.getActiveElement()===this.domNode||!i.isAncestor(i.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.previouslyFocusedItem=this.focusedItem,this.focusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.options.highlightToggledItems&&this.actionsList.classList.add("highlight-toggled"),this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),s.appendChild(this.domNode)}refreshRole(){this.length()>=1?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(s){s?this.actionsList.setAttribute("aria-label",s):this.actionsList.removeAttribute("aria-label")}setFocusable(s){if(this.focusable=s,this.focusable){const o=this.viewItems.find(c=>c instanceof P.BaseActionViewItem&&c.isEnabled());o instanceof P.BaseActionViewItem&&o.setFocusable(!0)}else this.viewItems.forEach(o=>{o instanceof P.BaseActionViewItem&&o.setFocusable(!1)})}isTriggerKeyEvent(s){let o=!1;return this._triggerKeys.keys.forEach(c=>{o=o||s.equals(c)}),o}updateFocusedItem(){for(let s=0;s<this.actionsList.children.length;s++){const o=this.actionsList.children[s];if(i.isAncestor(i.getActiveElement(),o)){this.focusedItem=s,this.viewItems[this.focusedItem]?.showHover?.();break}}}get context(){return this._context}set context(s){this._context=s,this.viewItems.forEach(o=>o.setActionContext(s))}get actionRunner(){return this._actionRunner}set actionRunner(s){this._actionRunner=s,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(o=>this._onDidRun.fire(o))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(o=>this._onWillRun.fire(o))),this.viewItems.forEach(o=>o.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(o=>o.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(i.isHTMLElement(s)){for(;s.parentElement!==this.actionsList;){if(!s.parentElement)return;s=s.parentElement}for(let o=0;o<this.actionsList.childNodes.length;o++)if(this.actionsList.childNodes[o]===s)return this.viewItems[o].action}}push(s,o={}){const c=Array.isArray(s)?s:[s];let h=D.isNumber(o.index)?o.index:null;c.forEach(p=>{const L=document.createElement("li");L.className="action-item",L.setAttribute("role","presentation");let y;const r={hoverDelegate:this._hoverDelegate,...o};this.options.actionViewItemProvider&&(y=this.options.actionViewItemProvider(p,r)),y||(y=new P.ActionViewItem(this.context,p,r)),this.options.allowContextMenu||this.viewItemDisposables.set(y,i.addDisposableListener(L,i.EventType.CONTEXT_MENU,f=>{i.EventHelper.stop(f,!0)})),y.actionRunner=this._actionRunner,y.setActionContext(this.context),y.render(L),this.focusable&&y instanceof P.BaseActionViewItem&&this.viewItems.length===0&&y.setFocusable(!0),h===null||h<0||h>=this.actionsList.children.length?(this.actionsList.appendChild(L),this.viewItems.push(y)):(this.actionsList.insertBefore(L,this.actionsList.children[h]),this.viewItems.splice(h,0,y),h++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(s){if(s>=0&&s<this.actionsList.children.length){const o=this.actionsList.children.item(s);if(o)return o.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.actionsList.children.length){const o=this.actionsList.children.item(s);if(o)return o.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[s]),this.viewItemDisposables.deleteAndDispose(this.viewItems[s]),(0,d.dispose)(this.viewItems.splice(s,1)),this.refreshRole())}clear(){this.isEmpty()||(this.viewItems=(0,d.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),i.clearNode(this.actionsList),this.refreshRole())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let o=!1,c;if(s===void 0?o=!0:typeof s=="number"?c=s:typeof s=="boolean"&&(o=s),o&&typeof this.focusedItem>"u"){const h=this.viewItems.findIndex(p=>p.isEnabled());this.focusedItem=h===-1?void 0:h,this.updateFocus(void 0,void 0,!0)}else c!==void 0&&(this.focusedItem=c),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(s){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const o=this.focusedItem;let c;do{if(!s&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=o,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,c=this.viewItems[this.focusedItem]}while(this.focusedItem!==o&&(this.options.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===T.Separator.ID));return this.updateFocus(),!0}focusPrevious(s){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const o=this.focusedItem;let c;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!s&&this.options.preventLoopNavigation)return this.focusedItem=o,!1;this.focusedItem=this.viewItems.length-1}c=this.viewItems[this.focusedItem]}while(this.focusedItem!==o&&(this.options.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===T.Separator.ID));return this.updateFocus(!0),!0}updateFocus(s,o,c=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:o}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const h=this.focusedItem!==void 0?this.viewItems[this.focusedItem]:void 0;if(h){let p=!0;D.isFunction(h.focus)||(p=!1),this.options.focusOnlyEnabledItems&&D.isFunction(h.isEnabled)&&!h.isEnabled()&&(p=!1),h.action.id===T.Separator.ID&&(p=!1),p?(c||this.previouslyFocusedItem!==this.focusedItem)&&(h.focus(s),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:o}),this.previouslyFocusedItem=void 0),p&&h.showHover?.()}}doTrigger(s){if(typeof this.focusedItem>"u")return;const o=this.viewItems[this.focusedItem];if(o instanceof P.BaseActionViewItem){const c=o._context===null||o._context===void 0?s:o._context;this.run(o._action,c)}}async run(s,o){await this._actionRunner.run(s,o)}dispose(){this._context=void 0,this.viewItems=(0,d.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=b;function m(e){if(!e.length)return e;let s=-1;for(let c=0;c<e.length;c++)if(e[c].id!==T.Separator.ID){s=c;break}if(s===-1)return[];e=e.slice(s);for(let c=e.length-1;c>=0&&e[c].id===T.Separator.ID;c--)e.splice(c,1);let o=!1;for(let c=e.length-1;c>=0;c--){const h=e[c].id===T.Separator.ID;h&&!o?e.splice(c,1):h?h&&(o=!1):o=!0}return e}}),define(ve[81],De([1,0,4,27,71,80,73,74,32,15,77,24,3,95,63,20,125,114]),function(oe,t,i,n,P,O,T,w,_,d,D,S,b,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const c=i.$;var h;(function(y){y[y.INFO=1]="INFO",y[y.WARNING=2]="WARNING",y[y.ERROR=3]="ERROR"})(h||(t.MessageType=h={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class p extends S.Widget{constructor(r,f,E){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new b.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=f,this.options=E,this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=i.append(r,c(".monaco-inputbox.idle"));const I=this.options.flexibleHeight?"textarea":"input",H=i.append(this.element,c(".ibwrapper"));if(this.input=i.append(H,c(I+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=i.append(H,c("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new D.ScrollableElement(this.element,{vertical:s.ScrollbarVisibility.Auto}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),i.append(r,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(v=>this.input.scrollTop=v.scrollTop));const z=this._register(new n.DomEmitter(r.ownerDocument,"selectionchange")),U=b.Event.filter(z.event,()=>r.ownerDocument.getSelection()?.anchorNode===H);this._register(U(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new O.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(r){this.placeholder=r,this.input.setAttribute("placeholder",r)}setTooltip(r){this.tooltip=r,this.hover?this.hover.update(r):this.hover=this._register((0,_.getBaseLayerHoverDelegate)().setupUpdatableHover((0,d.getDefaultHoverDelegate)("mouse"),this.input,r))}setAriaLabel(r){this.ariaLabel=r,r?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(r){this.input.value!==r&&(this.input.value=r,this.onValueChange())}get step(){return this.input.step}set step(r){this.input.step=r}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:i.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return i.isActiveElement(this.input)}select(r=null){this.input.select(),r&&(this.input.setSelectionRange(r.start,r.end),r.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}getSelection(){const r=this.input.selectionStart;if(r===null)return null;const f=this.input.selectionEnd??r;return{start:r,end:f}}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(r){r?this.enable():this.disable()}get width(){return i.getTotalWidth(this.input)}set width(r){if(this.options.flexibleHeight&&this.options.flexibleWidth){let f=0;if(this.mirror){const E=parseFloat(this.mirror.style.paddingLeft||"")||0,I=parseFloat(this.mirror.style.paddingRight||"")||0;f=E+I}this.input.style.width=r-f+"px"}else this.input.style.width=r+"px";this.mirror&&(this.mirror.style.width=r+"px")}set paddingRight(r){this.input.style.width=`calc(100% - ${r}px)`,this.mirror&&(this.mirror.style.paddingRight=r+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const r=this.cachedContentHeight,f=this.cachedHeight,E=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:r,height:f}),this.scrollableElement.setScrollPosition({scrollTop:E})}showMessage(r,f){if(this.state==="open"&&(0,e.equals)(this.message,r))return;this.message=r,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(r.type));const E=this.stylesForType(this.message.type);this.element.style.border=`1px solid ${i.asCssValueWithDefault(E.border,"transparent")}`,this.message.content&&(this.hasFocus()||f)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let r=null;return this.validation&&(r=this.validation(this.value),r?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(r)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),r?.type}stylesForType(r){const f=this.options.inputBoxStyles;switch(r){case h.INFO:return{border:f.inputValidationInfoBorder,background:f.inputValidationInfoBackground,foreground:f.inputValidationInfoForeground};case h.WARNING:return{border:f.inputValidationWarningBorder,background:f.inputValidationWarningBackground,foreground:f.inputValidationWarningForeground};default:return{border:f.inputValidationErrorBorder,background:f.inputValidationErrorBackground,foreground:f.inputValidationErrorForeground}}}classForType(r){switch(r){case h.INFO:return"info";case h.WARNING:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let r;const f=()=>r.style.width=i.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:w.AnchorAlignment.RIGHT,render:I=>{if(!this.message)return null;r=i.append(I,c(".monaco-inputbox-container")),f();const H={inline:!0,className:"monaco-inputbox-message"},z=this.message.formatContent?(0,P.renderFormattedText)(this.message.content,H):(0,P.renderText)(this.message.content,H);z.classList.add(this.classForType(this.message.type));const U=this.stylesForType(this.message.type);return z.style.backgroundColor=U.background??"",z.style.color=U.foreground??"",z.style.border=U.border?`1px solid ${U.border}`:"",i.append(r,z),null},onHide:()=>{this.state="closed"},layout:f});let E;this.message.type===h.ERROR?E=o.localize(0,null,this.message.content):this.message.type===h.WARNING?E=o.localize(1,null,this.message.content):E=o.localize(2,null,this.message.content),T.alert(E),this.state="open"}_hideMessage(){this.contextViewProvider&&(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const r=this.value,E=r.charCodeAt(r.length-1)===10?" ":"";(r+E).replace(/\u000c/g,"")?this.mirror.textContent=r+E:this.mirror.innerText="\xA0",this.layout()}applyStyles(){const r=this.options.inputBoxStyles,f=r.inputBackground??"",E=r.inputForeground??"",I=r.inputBorder??"";this.element.style.backgroundColor=f,this.element.style.color=E,this.input.style.backgroundColor="inherit",this.input.style.color=E,this.element.style.border=`1px solid ${i.asCssValueWithDefault(I,"transparent")}`}layout(){if(!this.mirror)return;const r=this.cachedContentHeight;this.cachedContentHeight=i.getTotalHeight(this.mirror),r!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(r){const f=this.inputElement,E=f.selectionStart,I=f.selectionEnd,H=f.value;E!==null&&I!==null&&(this.value=H.substr(0,E)+r+H.substr(I),f.setSelectionRange(E+1,E+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=p;class L extends p{constructor(r,f,E){const I=o.localize(3,null,"\u21C5"),H=o.localize(4,null,"\u21C5");super(r,f,E),this._onDidFocus=this._register(new b.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new b.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new m.HistoryNavigator(E.history,100);const z=()=>{if(E.showHistoryHint&&E.showHistoryHint()&&!this.placeholder.endsWith(I)&&!this.placeholder.endsWith(H)&&this.history.getHistory().length){const U=this.placeholder.endsWith(")")?I:H,v=this.placeholder+U;E.showPlaceholderOnFocus&&!i.isActiveElement(this.input)?this.placeholder=v:this.setPlaceHolder(v)}};this.observer=new MutationObserver((U,v)=>{U.forEach(k=>{k.target.textContent||z()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>z()),this.onblur(this.input,()=>{const U=v=>{if(this.placeholder.endsWith(v)){const k=this.placeholder.slice(0,this.placeholder.length-v.length);return E.showPlaceholderOnFocus?this.placeholder=k:this.setPlaceHolder(k),!0}else return!1};U(H)||U(I)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(r){this.value&&(r||this.value!==this.getCurrentValue())&&this.history.add(this.value)}prependHistory(r){const f=this.getHistory();this.clearHistory(),r.forEach(E=>{this.history.add(E)}),f.forEach(E=>{this.history.add(E)})}getHistory(){return this.history.getHistory()}isAtFirstInHistory(){return this.history.isFirst()}isAtLastInHistory(){return this.history.isLast()}isNowhereInHistory(){return this.history.isNowhere()}showNextValue(){this.history.has(this.value)||this.addToHistory();let r=this.getNextValue();r&&(r=r===this.value?this.getNextValue():r),this.value=r??"",T.status(this.value?this.value:o.localize(5,null))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let r=this.getPreviousValue();r&&(r=r===this.value?this.getPreviousValue():r),r&&(this.value=r,T.status(this.value))}clearHistory(){this.history.clear()}setPlaceHolder(r){super.setPlaceHolder(r),this.setTooltip(r)}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let r=this.history.current();return r||(r=this.history.last(),this.history.next()),r}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()}}t.HistoryInputBox=L}),define(ve[82],De([1,0,79,24,21,22,3,8,4,15,32,119]),function(oe,t,i,n,P,O,T,w,_,d,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CheckboxActionViewItem=t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class S extends i.BaseActionViewItem{constructor(o,c,h){super(o,c,h),this.toggle=this._register(new b({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:h.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:h.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:h.toggleStyles?.inputActiveOptionForeground,hoverDelegate:h.hoverDelegate})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(o){this.element=o,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(o){this.toggle.domNode.tabIndex=o?0:-1}}t.ToggleActionViewItem=S;class b extends n.Widget{constructor(o){super(),this._onChange=this._register(new T.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new T.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts=o,this._checked=this._opts.isChecked;const c=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,c.push(...O.ThemeIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&c.push(...this._opts.actionClassName.split(" ")),this._checked&&c.push("checked"),this.domNode=document.createElement("div"),this._hover=this._register((0,D.getBaseLayerHoverDelegate)().setupUpdatableHover(o.hoverDelegate??(0,d.getDefaultHoverDelegate)("mouse"),this.domNode,this._opts.title)),this.domNode.classList.add(...c),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,h=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),h.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,h=>{if(h.keyCode===w.KeyCode.Space||h.keyCode===w.KeyCode.Enter){this.checked=!this._checked,this._onChange.fire(!0),h.preventDefault(),h.stopPropagation();return}this._onKeyDown.fire(h)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(o){this._checked=o,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(o){this._icon&&this.domNode.classList.remove(...O.ThemeIcon.asClassNameArray(this._icon)),this._icon=o,this._icon&&this.domNode.classList.add(...O.ThemeIcon.asClassNameArray(this._icon))}width(){return 22}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder||"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(o){this._hover.update(o),this.domNode.setAttribute("aria-label",o)}set visible(o){this.domNode.style.display=o?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.Toggle=b;class m extends n.Widget{static{this.CLASS_NAME="monaco-checkbox"}constructor(o,c,h){super(),this.title=o,this.isChecked=c,this._onChange=this._register(new T.Emitter),this.onChange=this._onChange.event,this.checkbox=this._register(new b({title:this.title,isChecked:this.isChecked,icon:P.Codicon.check,actionClassName:m.CLASS_NAME,...t.unthemedToggleStyles})),this.domNode=this.checkbox.domNode,this.styles=h,this.applyStyles(),this._register(this.checkbox.onChange(p=>{this.applyStyles(),this._onChange.fire(p)}))}get checked(){return this.checkbox.checked}set checked(o){this.checkbox.checked=o,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return(0,_.isActiveElement)(this.domNode)}enable(){this.checkbox.enable()}disable(){this.checkbox.disable()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground||"",this.domNode.style.backgroundColor=this.styles.checkboxBackground||"",this.domNode.style.borderColor=this.styles.checkboxBorder||""}}t.Checkbox=m;class e extends i.BaseActionViewItem{constructor(o,c,h){super(o,c,h),this.toggle=this._register(new m(this._action.label,!!this._action.checked,h.checkboxStyles)),this._register(this.toggle.onChange(()=>this.onChange()))}render(o){if(this.element=o,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.toggle.domNode),this.options.label&&this._action.label){const c=this.element.appendChild((0,_.$)("span.checkbox-label",void 0,this._action.label));this._register((0,_.addDisposableListener)(c,_.EventType.CLICK,h=>{this.toggle.checked=!this.toggle.checked,h.stopPropagation(),h.preventDefault(),this.onChange()}))}this.updateEnabled(),this.updateClass(),this.updateChecked()}onChange(){this._action.checked=!!this.toggle&&this.toggle.checked,this.actionRunner.run(this._action,this._context)}updateEnabled(){this.isEnabled()?this.toggle.enable():this.toggle.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}updateChecked(){this.toggle.checked=!!this._action.checked}updateClass(){this.cssClass&&this.toggle.domNode.classList.remove(...this.cssClass.split(" ")),this.cssClass=this.getClass(),this.cssClass&&this.toggle.domNode.classList.add(...this.cssClass.split(" "))}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(o){this.toggle.domNode.tabIndex=o?0:-1}}t.CheckboxActionViewItem=e}),define(ve[146],De([1,0,15,82,21,124]),function(oe,t,i,n,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const T=O.localize(0,null),w=O.localize(1,null),_=O.localize(2,null);class d extends n.Toggle{constructor(m){super({icon:P.Codicon.caseSensitive,title:T+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.CaseSensitiveToggle=d;class D extends n.Toggle{constructor(m){super({icon:P.Codicon.wholeWord,title:w+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.WholeWordsToggle=D;class S extends n.Toggle{constructor(m){super({icon:P.Codicon.regex,title:_+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.RegexToggle=S}),define(ve[147],De([1,0,4,146,81,24,3,8,123,2,15,113]),function(oe,t,i,n,P,O,T,w,_,d,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const S=_.localize(0,null);class b extends O.Widget{static{this.OPTION_CHANGE="optionChange"}constructor(e,s,o){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=this._register(new d.MutableDisposable),this.additionalToggles=[],this._onDidOptionChange=this._register(new T.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new T.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new T.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new T.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new T.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new T.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new T.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=o.placeholder||"",this.validation=o.validation,this.label=o.label||S,this.showCommonFindToggles=!!o.showCommonFindToggles;const c=o.appendCaseSensitiveLabel||"",h=o.appendWholeWordsLabel||"",p=o.appendRegexLabel||"",L=o.history||[],y=!!o.flexibleHeight,r=!!o.flexibleWidth,f=o.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new P.HistoryInputBox(this.domNode,s,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},history:L,showHistoryHint:o.showHistoryHint,flexibleHeight:y,flexibleWidth:r,flexibleMaxHeight:f,inputBoxStyles:o.inputBoxStyles}));const E=this._register((0,D.createInstantHoverDelegate)());if(this.showCommonFindToggles){this.regex=this._register(new n.RegexToggle({appendTitle:p,isChecked:!1,hoverDelegate:E,...o.toggleStyles})),this._register(this.regex.onChange(H=>{this._onDidOptionChange.fire(H),!H&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(H=>{this._onRegexKeyDown.fire(H)})),this.wholeWords=this._register(new n.WholeWordsToggle({appendTitle:h,isChecked:!1,hoverDelegate:E,...o.toggleStyles})),this._register(this.wholeWords.onChange(H=>{this._onDidOptionChange.fire(H),!H&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new n.CaseSensitiveToggle({appendTitle:c,isChecked:!1,hoverDelegate:E,...o.toggleStyles})),this._register(this.caseSensitive.onChange(H=>{this._onDidOptionChange.fire(H),!H&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(H=>{this._onCaseSensitiveKeyDown.fire(H)}));const I=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,H=>{if(H.equals(w.KeyCode.LeftArrow)||H.equals(w.KeyCode.RightArrow)||H.equals(w.KeyCode.Escape)){const z=I.indexOf(this.domNode.ownerDocument.activeElement);if(z>=0){let U=-1;H.equals(w.KeyCode.RightArrow)?U=(z+1)%I.length:H.equals(w.KeyCode.LeftArrow)&&(z===0?U=I.length-1:U=z-1),H.equals(w.KeyCode.Escape)?(I[z].blur(),this.inputBox.focus()):U>=0&&I[U].focus(),i.EventHelper.stop(H,!0)}}})}this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"":"none",this.caseSensitive&&this.controls.append(this.caseSensitive.domNode),this.wholeWords&&this.controls.appendChild(this.wholeWords.domNode),this.regex&&this.controls.appendChild(this.regex.domNode),this.setAdditionalToggles(o?.additionalToggles),this.controls&&this.domNode.appendChild(this.controls),e?.appendChild(this.domNode),this._register(i.addDisposableListener(this.inputBox.inputElement,"compositionstart",I=>{this.imeSessionInProgress=!0})),this._register(i.addDisposableListener(this.inputBox.inputElement,"compositionend",I=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,I=>this._onKeyDown.fire(I)),this.onkeyup(this.inputBox.inputElement,I=>this._onKeyUp.fire(I)),this.oninput(this.inputBox.inputElement,I=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,I=>this._onMouseDown.fire(I))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}layout(e){this.inputBox.layout(),this.updateInputBoxPadding(e.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex?.enable(),this.wholeWords?.enable(),this.caseSensitive?.enable();for(const e of this.additionalToggles)e.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex?.disable(),this.wholeWords?.disable(),this.caseSensitive?.disable();for(const e of this.additionalToggles)e.disable()}setFocusInputOnOptionClick(e){this.fixFocusOnOptionClickEnabled=e}setEnabled(e){e?this.enable():this.disable()}setAdditionalToggles(e){for(const s of this.additionalToggles)s.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.value=new d.DisposableStore;for(const s of e??[])this.additionalTogglesDisposables.value.add(s),this.controls.appendChild(s.domNode),this.additionalTogglesDisposables.value.add(s.onChange(o=>{this._onDidOptionChange.fire(o),!o&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(s);this.additionalToggles.length>0&&(this.controls.style.display=""),this.updateInputBoxPadding()}updateInputBoxPadding(e=!1){e?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.caseSensitive?.width()??0)+(this.wholeWords?.width()??0)+(this.regex?.width()??0)+this.additionalToggles.reduce((s,o)=>s+o.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(e){this.inputBox.value!==e&&(this.inputBox.value=e)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive?.checked??!1}setCaseSensitive(e){this.caseSensitive&&(this.caseSensitive.checked=e)}getWholeWords(){return this.wholeWords?.checked??!1}setWholeWords(e){this.wholeWords&&(this.wholeWords.checked=e)}getRegex(){return this.regex?.checked??!1}setRegex(e){this.regex&&(this.regex.checked=e,this.validate())}focusOnCaseSensitive(){this.caseSensitive?.focus()}focusOnRegex(){this.regex?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(e){this.inputBox.showMessage(e)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=b}),define(ve[148],De([1,0,4,27,16,80,147,81,78,54,82,75,33,51,9,12,21,22,43,3,50,8,2,44,10,127,15,61,120]),function(oe,t,i,n,P,O,T,w,_,d,D,S,b,m,e,s,o,c,h,p,L,y,r,f,E,I,H,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.TreeRenderer=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class U extends _.ElementsDragAndDropData{set context(u){this.data.context=u}get context(){return this.data.context}constructor(u){super(u.elements.map(F=>F.element)),this.data=u}}function v(R){return R instanceof _.ElementsDragAndDropData?new U(R):R}class k{constructor(u,F){this.modelProvider=u,this.dnd=F,this.autoExpandDisposable=r.Disposable.None,this.disposables=new r.DisposableStore}getDragURI(u){return this.dnd.getDragURI(u.element)}getDragLabel(u,F){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(u.map(A=>A.element),F)}onDragStart(u,F){this.dnd.onDragStart?.(v(u),F)}onDragOver(u,F,A,B,V,G=!0){const ee=this.dnd.onDragOver(v(u),F&&F.element,A,B,V),re=this.autoExpandNode!==F;if(re&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=F),typeof F>"u")return ee;if(re&&typeof ee!="boolean"&&ee.autoExpand&&(this.autoExpandDisposable=(0,s.disposableTimeout)(()=>{const Te=this.modelProvider(),ce=Te.getNodeLocation(F);Te.isCollapsed(ce)&&Te.setCollapsed(ce,!1),this.autoExpandNode=void 0},500,this.disposables)),typeof ee=="boolean"||!ee.accept||typeof ee.bubble>"u"||ee.feedback){if(!G){const Te=typeof ee=="boolean"?ee:ee.accept,ce=typeof ee=="boolean"?void 0:ee.effect;return{accept:Te,effect:ce,feedback:[A]}}return ee}if(ee.bubble===b.TreeDragOverBubble.Up){const Te=this.modelProvider(),ce=Te.getNodeLocation(F),Re=Te.getParentNodeLocation(ce),Ue=Te.getNode(Re),Ye=Re&&Te.getListIndex(Re);return this.onDragOver(u,Ue,Ye,B,V,!1)}const he=this.modelProvider(),ye=he.getNodeLocation(F),we=he.getListIndex(ye),Ie=he.getListRenderCount(ye);return{...ee,feedback:(0,e.range)(we,we+Ie)}}drop(u,F,A,B,V){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(v(u),F&&F.element,A,B,V)}onDragEnd(u){this.dnd.onDragEnd?.(u)}dispose(){this.disposables.dispose(),this.dnd.dispose()}}function x(R,u){return u&&{...u,identityProvider:u.identityProvider&&{getId(F){return u.identityProvider.getId(F.element)}},dnd:u.dnd&&new k(R,u.dnd),multipleSelectionController:u.multipleSelectionController&&{isSelectionSingleChangeEvent(F){return u.multipleSelectionController.isSelectionSingleChangeEvent({...F,element:F.element})},isSelectionRangeChangeEvent(F){return u.multipleSelectionController.isSelectionRangeChangeEvent({...F,element:F.element})}},accessibilityProvider:u.accessibilityProvider&&{...u.accessibilityProvider,getSetSize(F){const A=R(),B=A.getNodeLocation(F),V=A.getParentNodeLocation(B);return A.getNode(V).visibleChildrenCount},getPosInSet(F){return F.visibleChildIndex+1},isChecked:u.accessibilityProvider&&u.accessibilityProvider.isChecked?F=>u.accessibilityProvider.isChecked(F.element):void 0,getRole:u.accessibilityProvider&&u.accessibilityProvider.getRole?F=>u.accessibilityProvider.getRole(F.element):()=>"treeitem",getAriaLabel(F){return u.accessibilityProvider.getAriaLabel(F.element)},getWidgetAriaLabel(){return u.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:u.accessibilityProvider&&u.accessibilityProvider.getWidgetRole?()=>u.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:u.accessibilityProvider&&u.accessibilityProvider.getAriaLevel?F=>u.accessibilityProvider.getAriaLevel(F.element):F=>F.depth,getActiveDescendantId:u.accessibilityProvider.getActiveDescendantId&&(F=>u.accessibilityProvider.getActiveDescendantId(F.element))},keyboardNavigationLabelProvider:u.keyboardNavigationLabelProvider&&{...u.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(F){return u.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(F.element)}}}}class N{constructor(u){this.delegate=u}getHeight(u){return this.delegate.getHeight(u.element)}getTemplateId(u){return this.delegate.getTemplateId(u.element)}hasDynamicHeight(u){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(u.element)}setDynamicHeight(u,F){this.delegate.setDynamicHeight?.(u.element,F)}}t.ComposedTreeDelegate=N;class M{static lift(u){return u instanceof M?u:new M(u)}static empty(u=0){return new M({focus:[],selection:[],expanded:Object.create(null),scrollTop:u})}constructor(u){if(this.focus=new Set(u.focus),this.selection=new Set(u.selection),u.expanded instanceof Array){this.expanded=Object.create(null);for(const F of u.expanded)this.expanded[F]=1}else this.expanded=u.expanded;this.expanded=u.expanded,this.scrollTop=u.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=M;var $;(function(R){R.None="none",R.OnHover="onHover",R.Always="always"})($||(t.RenderIndentGuides=$={}));class ne{get elements(){return this._elements}constructor(u,F=[]){this._elements=F,this.disposables=new r.DisposableStore,this.onDidChange=p.Event.forEach(u,A=>this._elements=A,this.disposables)}dispose(){this.disposables.dispose()}}class Z{static{this.DefaultIndent=8}constructor(u,F,A,B,V,G={}){this.renderer=u,this.modelProvider=F,this.activeNodes=B,this.renderedIndentGuides=V,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=Z.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=r.Disposable.None,this.disposables=new r.DisposableStore,this.templateId=u.templateId,this.updateOptions(G),p.Event.map(A,ee=>ee.node)(this.onDidChangeNodeTwistieState,this,this.disposables),u.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(u={}){if(typeof u.indent<"u"){const F=(0,f.clamp)(u.indent,0,40);if(F!==this.indent){this.indent=F;for(const[A,B]of this.renderedNodes)this.renderTreeElement(A,B)}}if(typeof u.renderIndentGuides<"u"){const F=u.renderIndentGuides!==$.None;if(F!==this.shouldRenderIndentGuides){this.shouldRenderIndentGuides=F;for(const[A,B]of this.renderedNodes)this._renderIndentGuides(A,B);if(this.indentGuidesDisposable.dispose(),F){const A=new r.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,A),this.indentGuidesDisposable=A,this._onDidChangeActiveNodes(this.activeNodes.elements)}}}typeof u.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=u.hideTwistiesOfChildlessElements)}renderTemplate(u){const F=(0,i.append)(u,(0,i.$)(".monaco-tl-row")),A=(0,i.append)(F,(0,i.$)(".monaco-tl-indent")),B=(0,i.append)(F,(0,i.$)(".monaco-tl-twistie")),V=(0,i.append)(F,(0,i.$)(".monaco-tl-contents")),G=this.renderer.renderTemplate(V);return{container:u,indent:A,twistie:B,indentGuidesDisposable:r.Disposable.None,templateData:G}}renderElement(u,F,A,B){this.renderedNodes.set(u,A),this.renderedElements.set(u.element,u),this.renderTreeElement(u,A),this.renderer.renderElement(u,F,A.templateData,B)}disposeElement(u,F,A,B){A.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(u,F,A.templateData,B),typeof B=="number"&&(this.renderedNodes.delete(u),this.renderedElements.delete(u.element))}disposeTemplate(u){this.renderer.disposeTemplate(u.templateData)}onDidChangeTwistieState(u){const F=this.renderedElements.get(u);F&&this.onDidChangeNodeTwistieState(F)}onDidChangeNodeTwistieState(u){const F=this.renderedNodes.get(u);F&&(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(u,F))}renderTreeElement(u,F){const A=Z.DefaultIndent+(u.depth-1)*this.indent;F.twistie.style.paddingLeft=`${A}px`,F.indent.style.width=`${A+this.indent-16}px`,u.collapsible?F.container.setAttribute("aria-expanded",String(!u.collapsed)):F.container.removeAttribute("aria-expanded"),F.twistie.classList.remove(...c.ThemeIcon.asClassNameArray(o.Codicon.treeItemExpanded));let B=!1;this.renderer.renderTwistie&&(B=this.renderer.renderTwistie(u.element,F.twistie)),u.collapsible&&(!this.hideTwistiesOfChildlessElements||u.visibleChildrenCount>0)?(B||F.twistie.classList.add(...c.ThemeIcon.asClassNameArray(o.Codicon.treeItemExpanded)),F.twistie.classList.add("collapsible"),F.twistie.classList.toggle("collapsed",u.collapsed)):F.twistie.classList.remove("collapsible","collapsed"),this._renderIndentGuides(u,F)}_renderIndentGuides(u,F){if((0,i.clearNode)(F.indent),F.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const A=new r.DisposableStore,B=this.modelProvider();for(;;){const V=B.getNodeLocation(u),G=B.getParentNodeLocation(V);if(!G)break;const ee=B.getNode(G),re=(0,i.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(ee)&&re.classList.add("active"),F.indent.childElementCount===0?F.indent.appendChild(re):F.indent.insertBefore(re,F.indent.firstElementChild),this.renderedIndentGuides.add(ee,re),A.add((0,r.toDisposable)(()=>this.renderedIndentGuides.delete(ee,re))),u=ee}F.indentGuidesDisposable=A}_onDidChangeActiveNodes(u){if(!this.shouldRenderIndentGuides)return;const F=new Set,A=this.modelProvider();u.forEach(B=>{const V=A.getNodeLocation(B);try{const G=A.getParentNodeLocation(V);B.collapsible&&B.children.length>0&&!B.collapsed?F.add(B):G&&F.add(A.getNode(G))}catch{}}),this.activeIndentNodes.forEach(B=>{F.has(B)||this.renderedIndentGuides.forEach(B,V=>V.classList.remove("active"))}),F.forEach(B=>{this.activeIndentNodes.has(B)||this.renderedIndentGuides.forEach(B,V=>V.classList.add("active"))}),this.activeIndentNodes=F}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,r.dispose)(this.disposables)}}t.TreeRenderer=Z;class Y{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(u){this._pattern=u,this._lowercasePattern=u.toLowerCase()}constructor(u,F,A){this.tree=u,this.keyboardNavigationLabelProvider=F,this._filter=A,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new r.DisposableStore,u.onWillRefilter(this.reset,this,this.disposables)}filter(u,F){let A=b.TreeVisibility.Visible;if(this._filter){const G=this._filter.filter(u,F);if(typeof G=="boolean"?A=G?b.TreeVisibility.Visible:b.TreeVisibility.Hidden:(0,S.isFilterResult)(G)?A=(0,S.getVisibleState)(G.visibility):A=G,A===b.TreeVisibility.Hidden)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:L.FuzzyScore.Default,visibility:A};const B=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(u),V=Array.isArray(B)?B:[B];for(const G of V){const ee=G&&G.toString();if(typeof ee>"u")return{data:L.FuzzyScore.Default,visibility:A};let re;if(this.tree.findMatchType===Ae.Contiguous){const he=ee.toLowerCase().indexOf(this._lowercasePattern);if(he>-1){re=[Number.MAX_SAFE_INTEGER,0];for(let ye=this._lowercasePattern.length;ye>0;ye--)re.push(he+ye-1)}}else re=(0,L.fuzzyScore)(this._pattern,this._lowercasePattern,0,ee,ee.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return this._matchCount++,V.length===1?{data:re,visibility:A}:{data:{label:ee,score:re},visibility:A}}return this.tree.findMode===Fe.Filter?typeof this.tree.options.defaultFindVisibility=="number"?this.tree.options.defaultFindVisibility:this.tree.options.defaultFindVisibility?this.tree.options.defaultFindVisibility(u):b.TreeVisibility.Recurse:{data:L.FuzzyScore.Default,visibility:A}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,r.dispose)(this.disposables)}}class te extends D.Toggle{constructor(u){super({icon:o.Codicon.listFilter,title:(0,I.localize)(0,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,H.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.ModeToggle=te;class fe extends D.Toggle{constructor(u){super({icon:o.Codicon.searchFuzzy,title:(0,I.localize)(1,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,H.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.FuzzyToggle=fe;const Ee={inputBoxStyles:w.unthemedInboxStyles,toggleStyles:D.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var Fe;(function(R){R[R.Highlight=0]="Highlight",R[R.Filter=1]="Filter"})(Fe||(t.TreeFindMode=Fe={}));var Ae;(function(R){R[R.Fuzzy=0]="Fuzzy",R[R.Contiguous=1]="Contiguous"})(Ae||(t.TreeFindMatchType=Ae={}));class ue extends r.Disposable{set mode(u){this.modeToggle.checked=u===Fe.Filter,this.findInput.inputBox.setPlaceHolder(u===Fe.Filter?(0,I.localize)(2,null):(0,I.localize)(3,null))}set matchType(u){this.matchTypeToggle.checked=u===Ae.Fuzzy}get value(){return this.findInput.inputBox.value}set value(u){this.findInput.inputBox.value=u}constructor(u,F,A,B,V,G){super(),this.tree=F,this.elements=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new p.Emitter,this.onDidDisable=this._onDidDisable.event,u.appendChild(this.elements.root),this._register((0,r.toDisposable)(()=>u.removeChild(this.elements.root)));const ee=G?.styles??Ee;ee.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=ee.listFilterWidgetBackground),ee.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${ee.listFilterWidgetShadow}`);const re=this._register((0,H.createInstantHoverDelegate)());this.modeToggle=this._register(new te({...ee.toggleStyles,isChecked:B===Fe.Filter,hoverDelegate:re})),this.matchTypeToggle=this._register(new fe({...ee.toggleStyles,isChecked:V===Ae.Fuzzy,hoverDelegate:re})),this.onDidChangeMode=p.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?Fe.Filter:Fe.Highlight,this._store),this.onDidChangeMatchType=p.Event.map(this.matchTypeToggle.onChange,()=>this.matchTypeToggle.checked?Ae.Fuzzy:Ae.Contiguous,this._store),this.findInput=this._register(new T.FindInput(this.elements.findInput,A,{label:(0,I.localize)(4,null),additionalToggles:[this.modeToggle,this.matchTypeToggle],showCommonFindToggles:!1,inputBoxStyles:ee.inputBoxStyles,toggleStyles:ee.toggleStyles,history:G?.history})),this.actionbar=this._register(new O.ActionBar(this.elements.actionbar)),this.mode=B;const he=this._register(new n.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),ye=p.Event.chain(he.event,ce=>ce.map(Re=>new P.StandardKeyboardEvent(Re)));this._register(ye(ce=>{if(ce.equals(y.KeyCode.Enter)){ce.preventDefault(),ce.stopPropagation(),this.findInput.inputBox.addToHistory(),this.tree.domFocus();return}if(ce.equals(y.KeyCode.DownArrow)){ce.preventDefault(),ce.stopPropagation(),this.findInput.inputBox.isAtLastInHistory()||this.findInput.inputBox.isNowhereInHistory()?(this.findInput.inputBox.addToHistory(),this.tree.domFocus()):this.findInput.inputBox.showNextValue();return}if(ce.equals(y.KeyCode.UpArrow)){ce.preventDefault(),ce.stopPropagation(),this.findInput.inputBox.showPreviousValue();return}}));const we=this._register(new m.Action("close",(0,I.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(we,{icon:!0,label:!1});const Ie=this._register(new n.DomEmitter(this.elements.grab,"mousedown"));this._register(Ie.event(ce=>{const Re=new r.DisposableStore,Ue=Re.add(new n.DomEmitter((0,i.getWindow)(ce),"mousemove")),Ye=Re.add(new n.DomEmitter((0,i.getWindow)(ce),"mouseup")),et=this.right,ot=ce.pageX,it=this.top,$e=ce.pageY;this.elements.grab.classList.add("grabbing");const Ze=this.elements.root.style.transition;this.elements.root.style.transition="unset";const X=le=>{const be=le.pageX-ot;this.right=et-be;const Se=le.pageY-$e;this.top=it+Se,this.layout()};Re.add(Ue.event(X)),Re.add(Ye.event(le=>{X(le),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=Ze,Re.dispose()}))}));const Te=p.Event.chain(this._register(new n.DomEmitter(this.elements.grab,"keydown")).event,ce=>ce.map(Re=>new P.StandardKeyboardEvent(Re)));this._register(Te(ce=>{let Re,Ue;if(ce.keyCode===y.KeyCode.LeftArrow?Re=Number.POSITIVE_INFINITY:ce.keyCode===y.KeyCode.RightArrow?Re=0:ce.keyCode===y.KeyCode.Space&&(Re=this.right===0?Number.POSITIVE_INFINITY:0),ce.keyCode===y.KeyCode.UpArrow?Ue=0:ce.keyCode===y.KeyCode.DownArrow&&(Ue=Number.POSITIVE_INFINITY),Re!==void 0&&(ce.preventDefault(),ce.stopPropagation(),this.right=Re,this.layout()),Ue!==void 0){ce.preventDefault(),ce.stopPropagation(),this.top=Ue;const Ye=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=Ye},0)}})),this.onDidChangeValue=this.findInput.onDidChange}getHistory(){return this.findInput.inputBox.getHistory()}focus(){this.findInput.focus()}select(){this.findInput.select(),this.findInput.inputBox.addToHistory(!0)}layout(u=this.width){this.width=u,this.right=(0,f.clamp)(this.right,0,Math.max(0,u-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,f.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(u){this.findInput.showMessage(u)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,s.timeout)(300),super.dispose()}}class J{get pattern(){return this._pattern}get mode(){return this._mode}set mode(u){u!==this._mode&&(this._mode=u,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(u))}get matchType(){return this._matchType}set matchType(u){u!==this._matchType&&(this._matchType=u,this.widget&&(this.widget.matchType=this._matchType),this.tree.refilter(),this.render(),this._onDidChangeMatchType.fire(u))}constructor(u,F,A,B,V,G={}){this.tree=u,this.view=A,this.filter=B,this.contextViewProvider=V,this.options=G,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new p.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangeMatchType=new p.Emitter,this.onDidChangeMatchType=this._onDidChangeMatchType.event,this._onDidChangePattern=new p.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new p.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new r.DisposableStore,this.disposables=new r.DisposableStore,this._mode=u.options.defaultFindMode??Fe.Highlight,this._matchType=u.options.defaultFindMatchType??Ae.Fuzzy,F.onDidSplice(this.onDidSpliceModel,this,this.disposables)}updateOptions(u={}){u.defaultFindMode!==void 0&&(this.mode=u.defaultFindMode),u.defaultFindMatchType!==void 0&&(this.matchType=u.defaultFindMatchType)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new ue(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.matchType,{...this.options,history:this._history}),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(u=>this.mode=u,void 0,this.enabledDisposables),this.widget.onDidChangeMatchType(u=>this.matchType=u,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){this.widget&&(this._history=this.widget.getHistory(),this.widget=void 0,this.enabledDisposables.clear(),this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(u){this._pattern=u,this._onDidChangePattern.fire(u),this.filter.pattern=u,this.tree.refilter(),u&&this.tree.focusNext(0,!0,void 0,A=>!L.FuzzyScore.isDefault(A.filterData));const F=this.tree.getFocus();if(F.length>0){const A=F[0];this.tree.getRelativeTop(A)===null&&this.tree.reveal(A,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const u=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&u?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:w.MessageType.WARNING,content:(0,I.localize)(6,null)}):this.widget?.showMessage({type:w.MessageType.WARNING}):this.widget?.clearMessage()}shouldAllowFocus(u){return!this.widget||!this.pattern||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!L.FuzzyScore.isDefault(u.filterData)}layout(u){this.width=u,this.widget?.layout(u)}dispose(){this._history=void 0,this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function de(R,u){return R.position===u.position&&ae(R,u)}function ae(R,u){return R.node.element===u.node.element&&R.startIndex===u.startIndex&&R.height===u.height&&R.endIndex===u.endIndex}class Le{constructor(u=[]){this.stickyNodes=u}get count(){return this.stickyNodes.length}equal(u){return(0,e.equals)(this.stickyNodes,u.stickyNodes,de)}lastNodePartiallyVisible(){if(this.count===0)return!1;const u=this.stickyNodes[this.count-1];if(this.count===1)return u.position!==0;const F=this.stickyNodes[this.count-2];return F.position+F.height!==u.position}animationStateChanged(u){if(!(0,e.equals)(this.stickyNodes,u.stickyNodes,ae)||this.count===0)return!1;const F=this.stickyNodes[this.count-1],A=u.stickyNodes[u.count-1];return F.position!==A.position}}class Q{constrainStickyScrollNodes(u,F,A){for(let B=0;B<u.length;B++){const V=u[B];if(V.position+V.height>A||B>=F)return u.slice(0,B)}return u}}class me extends r.Disposable{constructor(u,F,A,B,V,G={}){super(),this.tree=u,this.model=F,this.view=A,this.treeDelegate=V,this.maxWidgetViewRatio=.4;const ee=this.validateStickySettings(G);this.stickyScrollMaxItemCount=ee.stickyScrollMaxItemCount,this.stickyScrollDelegate=G.stickyScrollDelegate??new Q,this._widget=this._register(new _e(A.getScrollableElement(),A,u,B,V,G.accessibilityProvider)),this.onDidChangeHasFocus=this._widget.onDidChangeHasFocus,this.onContextMenu=this._widget.onContextMenu,this._register(A.onDidScroll(()=>this.update())),this._register(A.onDidChangeContentHeight(()=>this.update())),this._register(u.onDidChangeCollapseState(()=>this.update())),this.update()}get height(){return this._widget.height}get count(){return this._widget.count}getNode(u){return this._widget.getNode(u)}getNodeAtHeight(u){let F;if(u===0?F=this.view.firstVisibleIndex:F=this.view.indexAt(u+this.view.scrollTop),!(F<0||F>=this.view.length))return this.view.element(F)}update(){const u=this.getNodeAtHeight(0);if(!u||this.tree.scrollTop===0){this._widget.setState(void 0);return}const F=this.findStickyState(u);this._widget.setState(F)}findStickyState(u){const F=[];let A=u,B=0,V=this.getNextStickyNode(A,void 0,B);for(;V&&(F.push(V),B+=V.height,!(F.length<=this.stickyScrollMaxItemCount&&(A=this.getNextVisibleNode(V),!A)));)V=this.getNextStickyNode(A,V.node,B);const G=this.constrainStickyNodes(F);return G.length?new Le(G):void 0}getNextVisibleNode(u){return this.getNodeAtHeight(u.position+u.height)}getNextStickyNode(u,F,A){const B=this.getAncestorUnderPrevious(u,F);if(B&&!(B===u&&(!this.nodeIsUncollapsedParent(u)||this.nodeTopAlignsWithStickyNodesBottom(u,A))))return this.createStickyScrollNode(B,A)}nodeTopAlignsWithStickyNodesBottom(u,F){const A=this.getNodeIndex(u),B=this.view.getElementTop(A),V=F;return this.view.scrollTop===B-V}createStickyScrollNode(u,F){const A=this.treeDelegate.getHeight(u),{startIndex:B,endIndex:V}=this.getNodeRange(u),G=this.calculateStickyNodePosition(V,F,A);return{node:u,position:G,height:A,startIndex:B,endIndex:V}}getAncestorUnderPrevious(u,F=void 0){let A=u,B=this.getParentNode(A);for(;B;){if(B===F)return A;A=B,B=this.getParentNode(A)}if(F===void 0)return A}calculateStickyNodePosition(u,F,A){let B=this.view.getRelativeTop(u);if(B===null&&this.view.firstVisibleIndex===u&&u+1<this.view.length){const he=this.treeDelegate.getHeight(this.view.element(u)),ye=this.view.getRelativeTop(u+1);B=ye?ye-he/this.view.renderHeight:null}if(B===null)return F;const V=this.view.element(u),G=this.treeDelegate.getHeight(V),re=B*this.view.renderHeight+G;return F+A>re&&F<=re?re-A:F}constrainStickyNodes(u){if(u.length===0)return[];const F=this.view.renderHeight*this.maxWidgetViewRatio,A=u[u.length-1];if(u.length<=this.stickyScrollMaxItemCount&&A.position+A.height<=F)return u;const B=this.stickyScrollDelegate.constrainStickyScrollNodes(u,this.stickyScrollMaxItemCount,F);if(!B.length)return[];const V=B[B.length-1];if(B.length>this.stickyScrollMaxItemCount||V.position+V.height>F)throw new Error("stickyScrollDelegate violates constraints");return B}getParentNode(u){const F=this.model.getNodeLocation(u),A=this.model.getParentNodeLocation(F);return A?this.model.getNode(A):void 0}nodeIsUncollapsedParent(u){const F=this.model.getNodeLocation(u);return this.model.getListRenderCount(F)>1}getNodeIndex(u){const F=this.model.getNodeLocation(u);return this.model.getListIndex(F)}getNodeRange(u){const F=this.model.getNodeLocation(u),A=this.model.getListIndex(F);if(A<0)throw new Error("Node not found in tree");const B=this.model.getListRenderCount(F),V=A+B-1;return{startIndex:A,endIndex:V}}nodePositionTopBelowWidget(u){const F=[];let A=this.getParentNode(u);for(;A;)F.push(A),A=this.getParentNode(A);let B=0;for(let V=0;V<F.length&&V<this.stickyScrollMaxItemCount;V++)B+=this.treeDelegate.getHeight(F[V]);return B}getFocus(){return this._widget.getFocus()}domFocus(){this._widget.domFocus()}focusedLast(){return this._widget.focusedLast()}updateOptions(u={}){if(!u.stickyScrollMaxItemCount)return;const F=this.validateStickySettings(u);this.stickyScrollMaxItemCount!==F.stickyScrollMaxItemCount&&(this.stickyScrollMaxItemCount=F.stickyScrollMaxItemCount,this.update())}validateStickySettings(u){let F=7;return typeof u.stickyScrollMaxItemCount=="number"&&(F=Math.max(u.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:F}}}class _e{constructor(u,F,A,B,V,G){this.view=F,this.tree=A,this.treeRenderers=B,this.treeDelegate=V,this.accessibilityProvider=G,this._previousElements=[],this._previousStateDisposables=new r.DisposableStore,this._rootDomNode=(0,i.$)(".monaco-tree-sticky-container.empty"),u.appendChild(this._rootDomNode);const ee=(0,i.$)(".monaco-tree-sticky-container-shadow");this._rootDomNode.appendChild(ee),this.stickyScrollFocus=new Oe(this._rootDomNode,F),this.onDidChangeHasFocus=this.stickyScrollFocus.onDidChangeHasFocus,this.onContextMenu=this.stickyScrollFocus.onContextMenu}get height(){if(!this._previousState)return 0;const u=this._previousState.stickyNodes[this._previousState.count-1];return u.position+u.height}get count(){return this._previousState?.count??0}getNode(u){return this._previousState?.stickyNodes.find(F=>F.node===u)}setState(u){const F=!!this._previousState&&this._previousState.count>0,A=!!u&&u.count>0;if(!F&&!A||F&&A&&this._previousState.equal(u))return;if(F!==A&&this.setVisible(A),!A){this._previousState=void 0,this._previousElements=[],this._previousStateDisposables.clear();return}const B=u.stickyNodes[u.count-1];if(this._previousState&&u.animationStateChanged(this._previousState))this._previousElements[this._previousState.count-1].style.top=`${B.position}px`;else{this._previousStateDisposables.clear();const V=Array(u.count);for(let G=u.count-1;G>=0;G--){const ee=u.stickyNodes[G],{element:re,disposable:he}=this.createElement(ee,G,u.count);V[G]=re,this._rootDomNode.appendChild(re),this._previousStateDisposables.add(he)}this.stickyScrollFocus.updateElements(V,u),this._previousElements=V}this._previousState=u,this._rootDomNode.style.height=`${B.position+B.height}px`}createElement(u,F,A){const B=u.startIndex,V=document.createElement("div");V.style.top=`${u.position}px`,this.tree.options.setRowHeight!==!1&&(V.style.height=`${u.height}px`),this.tree.options.setRowLineHeight!==!1&&(V.style.lineHeight=`${u.height}px`),V.classList.add("monaco-tree-sticky-row"),V.classList.add("monaco-list-row"),V.setAttribute("data-index",`${B}`),V.setAttribute("data-parity",B%2===0?"even":"odd"),V.setAttribute("id",this.view.getElementID(B));const G=this.setAccessibilityAttributes(V,u.node.element,F,A),ee=this.treeDelegate.getTemplateId(u.node),re=this.treeRenderers.find(Ie=>Ie.templateId===ee);if(!re)throw new Error(`No renderer found for template id ${ee}`);let he=u.node;he===this.tree.getNode(this.tree.getNodeLocation(u.node))&&(he=new Proxy(u.node,{}));const ye=re.renderTemplate(V);re.renderElement(he,u.startIndex,ye,u.height);const we=(0,r.toDisposable)(()=>{G.dispose(),re.disposeElement(he,u.startIndex,ye,u.height),re.disposeTemplate(ye),V.remove()});return{element:V,disposable:we}}setAccessibilityAttributes(u,F,A,B){if(!this.accessibilityProvider)return r.Disposable.None;this.accessibilityProvider.getSetSize&&u.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(F,A,B))),this.accessibilityProvider.getPosInSet&&u.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(F,A))),this.accessibilityProvider.getRole&&u.setAttribute("role",this.accessibilityProvider.getRole(F)??"treeitem");const V=this.accessibilityProvider.getAriaLabel(F),G=V&&typeof V!="string"?V:(0,z.constObservable)(V),ee=(0,z.autorun)(he=>{const ye=he.readObservable(G);ye?u.setAttribute("aria-label",ye):u.removeAttribute("aria-label")});typeof V=="string"||V&&u.setAttribute("aria-label",V.get());const re=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(F);return typeof re=="number"&&u.setAttribute("aria-level",`${re}`),u.setAttribute("aria-selected",String(!1)),ee}setVisible(u){this._rootDomNode.classList.toggle("empty",!u),u||this.stickyScrollFocus.updateElements([],void 0)}getFocus(){return this.stickyScrollFocus.getFocus()}domFocus(){this.stickyScrollFocus.domFocus()}focusedLast(){return this.stickyScrollFocus.focusedLast()}dispose(){this.stickyScrollFocus.dispose(),this._previousStateDisposables.dispose(),this._rootDomNode.remove()}}class Oe extends r.Disposable{get domHasFocus(){return this._domHasFocus}set domHasFocus(u){u!==this._domHasFocus&&(this._onDidChangeHasFocus.fire(u),this._domHasFocus=u)}constructor(u,F){super(),this.container=u,this.view=F,this.focusedIndex=-1,this.elements=[],this._onDidChangeHasFocus=new p.Emitter,this.onDidChangeHasFocus=this._onDidChangeHasFocus.event,this._onContextMenu=new p.Emitter,this.onContextMenu=this._onContextMenu.event,this._domHasFocus=!1,this.container.addEventListener("focus",()=>this.onFocus()),this.container.addEventListener("blur",()=>this.onBlur()),this._register(this.view.onDidFocus(()=>this.toggleStickyScrollFocused(!1))),this._register(this.view.onKeyDown(A=>this.onKeyDown(A))),this._register(this.view.onMouseDown(A=>this.onMouseDown(A))),this._register(this.view.onContextMenu(A=>this.handleContextMenu(A)))}handleContextMenu(u){const F=u.browserEvent.target;if(!(0,d.isStickyScrollContainer)(F)&&!(0,d.isStickyScrollElement)(F)){this.focusedLast()&&this.view.domFocus();return}if(!(0,i.isKeyboardEvent)(u.browserEvent)){if(!this.state)throw new Error("Context menu should not be triggered when state is undefined");const G=this.state.stickyNodes.findIndex(ee=>ee.node.element===u.element?.element);if(G===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.container.focus(),this.setFocus(G);return}if(!this.state||this.focusedIndex<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const B=this.state.stickyNodes[this.focusedIndex].node.element,V=this.elements[this.focusedIndex];this._onContextMenu.fire({element:B,anchor:V,browserEvent:u.browserEvent,isStickyScroll:!0})}onKeyDown(u){if(this.domHasFocus&&this.state){if(u.key==="ArrowUp")this.setFocusedElement(Math.max(0,this.focusedIndex-1)),u.preventDefault(),u.stopPropagation();else if(u.key==="ArrowDown"||u.key==="ArrowRight"){if(this.focusedIndex>=this.state.count-1){const F=this.state.stickyNodes[this.state.count-1].startIndex+1;this.view.domFocus(),this.view.setFocus([F]),this.scrollNodeUnderWidget(F,this.state)}else this.setFocusedElement(this.focusedIndex+1);u.preventDefault(),u.stopPropagation()}}}onMouseDown(u){const F=u.browserEvent.target;!(0,d.isStickyScrollContainer)(F)&&!(0,d.isStickyScrollElement)(F)||(u.browserEvent.preventDefault(),u.browserEvent.stopPropagation())}updateElements(u,F){if(F&&F.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(F&&F.count!==u.length)throw new Error("Sticky scroll focus received illigel state");const A=this.focusedIndex;if(this.removeFocus(),this.elements=u,this.state=F,F){const B=(0,f.clamp)(A,0,F.count-1);this.setFocus(B)}else this.domHasFocus&&this.view.domFocus();this.container.tabIndex=F?0:-1}setFocusedElement(u){const F=this.state;if(!F)throw new Error("Cannot set focus when state is undefined");if(this.setFocus(u),!(u<F.count-1)&&F.lastNodePartiallyVisible()){const A=F.stickyNodes[u];this.scrollNodeUnderWidget(A.endIndex+1,F)}}scrollNodeUnderWidget(u,F){const A=F.stickyNodes[F.count-1],B=F.count>1?F.stickyNodes[F.count-2]:void 0,V=this.view.getElementTop(u),G=B?B.position+B.height+A.height:A.height;this.view.scrollTop=V-G}getFocus(){if(!(!this.state||this.focusedIndex===-1))return this.state.stickyNodes[this.focusedIndex].node.element}domFocus(){if(!this.state)throw new Error("Cannot focus when state is undefined");this.container.focus()}focusedLast(){return this.state?this.view.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}removeFocus(){this.focusedIndex!==-1&&(this.toggleElementFocus(this.elements[this.focusedIndex],!1),this.focusedIndex=-1)}setFocus(u){if(0>u)throw new Error("addFocus() can not remove focus");if(!this.state&&u>=0)throw new Error("Cannot set focus index when state is undefined");if(this.state&&u>=this.state.count)throw new Error("Cannot set focus index to an index that does not exist");const F=this.focusedIndex;F>=0&&this.toggleElementFocus(this.elements[F],!1),u>=0&&this.toggleElementFocus(this.elements[u],!0),this.focusedIndex=u}toggleElementFocus(u,F){this.toggleElementActiveFocus(u,F&&this.domHasFocus),this.toggleElementPassiveFocus(u,F)}toggleCurrentElementActiveFocus(u){this.focusedIndex!==-1&&this.toggleElementActiveFocus(this.elements[this.focusedIndex],u)}toggleElementActiveFocus(u,F){u.classList.toggle("focused",F)}toggleElementPassiveFocus(u,F){u.classList.toggle("passive-focused",F)}toggleStickyScrollFocused(u){this.view.getHTMLElement().classList.toggle("sticky-scroll-focused",u)}onFocus(){if(!this.state||this.elements.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.domHasFocus=!0,this.toggleStickyScrollFocused(!0),this.toggleCurrentElementActiveFocus(!0),this.focusedIndex===-1&&this.setFocus(0)}onBlur(){this.domHasFocus=!1,this.toggleCurrentElementActiveFocus(!1)}dispose(){this.toggleStickyScrollFocused(!1),this._onDidChangeHasFocus.fire(!1),super.dispose()}}function Ce(R){let u=b.TreeMouseEventTarget.Unknown;return(0,i.hasParentWithClass)(R.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?u=b.TreeMouseEventTarget.Twistie:(0,i.hasParentWithClass)(R.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?u=b.TreeMouseEventTarget.Element:(0,i.hasParentWithClass)(R.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(u=b.TreeMouseEventTarget.Filter),{browserEvent:R.browserEvent,element:R.element?R.element.element:null,target:u}}function Be(R){const u=(0,d.isStickyScrollContainer)(R.browserEvent.target);return{element:R.element?R.element.element:null,browserEvent:R.browserEvent,anchor:R.anchor,isStickyScroll:u}}function ie(R,u){u(R),R.children.forEach(F=>ie(F,u))}class q{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(u,F){this.getFirstViewElementWithTrait=u,this.identityProvider=F,this.nodes=[],this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event}set(u,F){!F?.__forceEvent&&(0,e.equals)(this.nodes,u)||this._set(u,!1,F)}_set(u,F,A){if(this.nodes=[...u],this.elements=void 0,this._nodeSet=void 0,!F){const B=this;this._onDidChange.fire({get elements(){return B.get()},browserEvent:A})}}get(){return this.elements||(this.elements=this.nodes.map(u=>u.element)),[...this.elements]}getNodes(){return this.nodes}has(u){return this.nodeSet.has(u)}onDidModelSplice({insertedNodes:u,deletedNodes:F}){if(!this.identityProvider){const re=this.createNodeSet(),he=ye=>re.delete(ye);F.forEach(ye=>ie(ye,he)),this.set([...re.values()]);return}const A=new Set,B=re=>A.add(this.identityProvider.getId(re.element).toString());F.forEach(re=>ie(re,B));const V=new Map,G=re=>V.set(this.identityProvider.getId(re.element).toString(),re);u.forEach(re=>ie(re,G));const ee=[];for(const re of this.nodes){const he=this.identityProvider.getId(re.element).toString();if(!A.has(he))ee.push(re);else{const we=V.get(he);we&&we.visible&&ee.push(we)}}if(this.nodes.length>0&&ee.length===0){const re=this.getFirstViewElementWithTrait();re&&ee.push(re)}this._set(ee,!0)}createNodeSet(){const u=new Set;for(const F of this.nodes)u.add(F);return u}}class W extends d.MouseController{constructor(u,F,A){super(u),this.tree=F,this.stickyScrollProvider=A}onViewPointer(u){if((0,d.isButton)(u.browserEvent.target)||(0,d.isInputElement)(u.browserEvent.target)||(0,d.isMonacoEditor)(u.browserEvent.target)||u.browserEvent.isHandledByList)return;const F=u.element;if(!F)return super.onViewPointer(u);if(this.isSelectionRangeChangeEvent(u)||this.isSelectionSingleChangeEvent(u))return super.onViewPointer(u);const A=u.browserEvent.target,B=A.classList.contains("monaco-tl-twistie")||A.classList.contains("monaco-icon-label")&&A.classList.contains("folder-icon")&&u.browserEvent.offsetX<16,V=(0,d.isStickyScrollElement)(u.browserEvent.target);let G=!1;if(V?G=!0:typeof this.tree.expandOnlyOnTwistieClick=="function"?G=this.tree.expandOnlyOnTwistieClick(F.element):G=!!this.tree.expandOnlyOnTwistieClick,V)this.handleStickyScrollMouseEvent(u,F);else{if(G&&!B&&u.browserEvent.detail!==2)return super.onViewPointer(u);if(!this.tree.expandOnDoubleClick&&u.browserEvent.detail===2)return super.onViewPointer(u)}if(F.collapsible&&(!V||B)){const ee=this.tree.getNodeLocation(F),re=u.browserEvent.altKey;if(this.tree.setFocus([ee]),this.tree.toggleCollapsed(ee,re),B){u.browserEvent.isHandledByList=!0;return}}V||super.onViewPointer(u)}handleStickyScrollMouseEvent(u,F){if((0,d.isMonacoCustomToggle)(u.browserEvent.target)||(0,d.isActionItem)(u.browserEvent.target))return;const A=this.stickyScrollProvider();if(!A)throw new Error("Sticky scroll controller not found");const B=this.list.indexOf(F),V=this.list.getElementTop(B),G=A.nodePositionTopBelowWidget(F);this.tree.scrollTop=V-G,this.list.domFocus(),this.list.setFocus([B]),this.list.setSelection([B])}onDoubleClick(u){u.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||u.browserEvent.isHandledByList||super.onDoubleClick(u)}onMouseDown(u){const F=u.browserEvent.target;if(!(0,d.isStickyScrollContainer)(F)&&!(0,d.isStickyScrollElement)(F)){super.onMouseDown(u);return}}onContextMenu(u){const F=u.browserEvent.target;if(!(0,d.isStickyScrollContainer)(F)&&!(0,d.isStickyScrollElement)(F)){super.onContextMenu(u);return}}}class l extends d.List{constructor(u,F,A,B,V,G,ee,re){super(u,F,A,B,re),this.focusTrait=V,this.selectionTrait=G,this.anchorTrait=ee}createMouseController(u){return new W(this,u.tree,u.stickyScrollProvider)}splice(u,F,A=[]){if(super.splice(u,F,A),A.length===0)return;const B=[],V=[];let G;A.forEach((ee,re)=>{this.focusTrait.has(ee)&&B.push(u+re),this.selectionTrait.has(ee)&&V.push(u+re),this.anchorTrait.has(ee)&&(G=u+re)}),B.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...B])),V.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...V])),typeof G=="number"&&super.setAnchor(G)}setFocus(u,F,A=!1){super.setFocus(u,F),A||this.focusTrait.set(u.map(B=>this.element(B)),F)}setSelection(u,F,A=!1){super.setSelection(u,F),A||this.selectionTrait.set(u.map(B=>this.element(B)),F)}setAnchor(u,F=!1){super.setAnchor(u),F||(typeof u>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(u)]))}}var a;(function(R){R[R.Tree=0]="Tree",R[R.StickyScroll=1]="StickyScroll"})(a||(t.AbstractTreePart=a={}));class g{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return p.Event.map(this.view.onMouseClick,Ce)}get onMouseDblClick(){return p.Event.filter(p.Event.map(this.view.onMouseDblClick,Ce),u=>u.target!==b.TreeMouseEventTarget.Filter)}get onMouseOver(){return p.Event.map(this.view.onMouseOver,Ce)}get onMouseOut(){return p.Event.map(this.view.onMouseOut,Ce)}get onContextMenu(){return p.Event.any(p.Event.filter(p.Event.map(this.view.onContextMenu,Be),u=>!u.isStickyScroll),this.stickyScrollController?.onContextMenu??p.Event.None)}get onTap(){return p.Event.map(this.view.onTap,Ce)}get onPointer(){return p.Event.map(this.view.onPointer,Ce)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return p.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??Fe.Highlight}set findMode(u){this.findController&&(this.findController.mode=u)}get findMatchType(){return this.findController?.matchType??Ae.Fuzzy}set findMatchType(u){this.findController&&(this.findController.matchType=u)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:p.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(u,F,A,B,V={}){this._user=u,this._options=V,this.eventBufferer=new p.EventBufferer,this.onDidChangeFindOpenState=p.Event.None,this.onDidChangeStickyScrollFocused=p.Event.None,this.disposables=new r.DisposableStore,this._onWillRefilter=new p.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new p.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event,this.treeDelegate=new N(A);const G=new p.Relay,ee=new p.Relay,re=this.disposables.add(new ne(ee.event)),he=new h.SetMap;this.renderers=B.map(ce=>new Z(ce,()=>this.model,G.event,re,he,V));for(const ce of this.renderers)this.disposables.add(ce);let ye;V.keyboardNavigationLabelProvider&&(ye=new Y(this,V.keyboardNavigationLabelProvider,V.filter),V={...V,filter:ye},this.disposables.add(ye)),this.focus=new q(()=>this.view.getFocusedElements()[0],V.identityProvider),this.selection=new q(()=>this.view.getSelectedElements()[0],V.identityProvider),this.anchor=new q(()=>this.view.getAnchorElement(),V.identityProvider),this.view=new l(u,F,this.treeDelegate,this.renderers,this.focus,this.selection,this.anchor,{...x(()=>this.model,V),tree:this,stickyScrollProvider:()=>this.stickyScrollController}),this.model=this.createModel(u,this.view,V),G.input=this.model.onDidChangeCollapseState;const we=p.Event.forEach(this.model.onDidSplice,ce=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(ce),this.selection.onDidModelSplice(ce)})},this.disposables);we(()=>null,null,this.disposables);const Ie=this.disposables.add(new p.Emitter),Te=this.disposables.add(new s.Delayer(0));if(this.disposables.add(p.Event.any(we,this.focus.onDidChange,this.selection.onDidChange)(()=>{Te.trigger(()=>{const ce=new Set;for(const Re of this.focus.getNodes())ce.add(Re);for(const Re of this.selection.getNodes())ce.add(Re);Ie.fire([...ce.values()])})})),ee.input=Ie.event,V.keyboardSupport!==!1){const ce=p.Event.chain(this.view.onKeyDown,Re=>Re.filter(Ue=>!(0,d.isInputElement)(Ue.target)).map(Ue=>new P.StandardKeyboardEvent(Ue)));p.Event.chain(ce,Re=>Re.filter(Ue=>Ue.keyCode===y.KeyCode.LeftArrow))(this.onLeftArrow,this,this.disposables),p.Event.chain(ce,Re=>Re.filter(Ue=>Ue.keyCode===y.KeyCode.RightArrow))(this.onRightArrow,this,this.disposables),p.Event.chain(ce,Re=>Re.filter(Ue=>Ue.keyCode===y.KeyCode.Space))(this.onSpace,this,this.disposables)}if((V.findWidgetEnabled??!0)&&V.keyboardNavigationLabelProvider&&V.contextViewProvider){const ce=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.findController=new J(this,this.model,this.view,ye,V.contextViewProvider,ce),this.focusNavigationFilter=Re=>this.findController.shouldAllowFocus(Re),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode,this.onDidChangeFindMatchType=this.findController.onDidChangeMatchType}else this.onDidChangeFindMode=p.Event.None,this.onDidChangeFindMatchType=p.Event.None;V.enableStickyScroll&&(this.stickyScrollController=new me(this,this.model,this.view,this.renderers,this.treeDelegate,V),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus),this.styleElement=(0,i.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===$.Always)}updateOptions(u={}){this._options={...this._options,...u};for(const F of this.renderers)F.updateOptions(u);this.view.updateOptions(this._options),this.findController?.updateOptions(u),this.updateStickyScroll(u),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===$.Always)}get options(){return this._options}updateStickyScroll(u){!this.stickyScrollController&&this._options.enableStickyScroll?(this.stickyScrollController=new me(this,this.model,this.view,this.renderers,this.treeDelegate,this._options),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus):this.stickyScrollController&&!this._options.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=p.Event.None,this.stickyScrollController.dispose(),this.stickyScrollController=void 0),this.stickyScrollController?.updateOptions(u)}updateWidth(u){const F=this.model.getListIndex(u);F!==-1&&this.view.updateWidth(F)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.scrollTop}set scrollTop(u){this.view.scrollTop=u}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(u){this.view.scrollLeft=u}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){let u=this.view.firstVisibleIndex;return this.stickyScrollController&&(u+=this.stickyScrollController.count),u<0||u>=this.view.length?void 0:this.view.element(u).element}get lastVisibleElement(){const u=this.view.lastVisibleIndex;return this.view.element(u).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(u){this.view.ariaLabel=u}get selectionSize(){return this.selection.getNodes().length}domFocus(){this.stickyScrollController?.focusedLast()?this.stickyScrollController.domFocus():this.view.domFocus()}isDOMFocused(){return(0,i.isActiveElement)(this.getHTMLElement())}layout(u,F){this.view.layout(u,F),(0,E.isNumber)(F)&&this.findController?.layout(F)}style(u){const F=`.${this.view.domId}`,A=[];u.treeIndentGuidesStroke&&(A.push(`.monaco-list${F}:hover .monaco-tl-indent > .indent-guide, .monaco-list${F}.always .monaco-tl-indent > .indent-guide  { border-color: ${u.treeInactiveIndentGuidesStroke}; }`),A.push(`.monaco-list${F} .monaco-tl-indent > .indent-guide.active { border-color: ${u.treeIndentGuidesStroke}; }`));const B=u.treeStickyScrollBackground??u.listBackground;B&&(A.push(`.monaco-list${F} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${B}; }`),A.push(`.monaco-list${F} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${B}; }`)),u.treeStickyScrollBorder&&A.push(`.monaco-list${F} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${u.treeStickyScrollBorder}; }`),u.treeStickyScrollShadow&&A.push(`.monaco-list${F} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${u.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),u.listFocusForeground&&(A.push(`.monaco-list${F}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),A.push(`.monaco-list${F}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const V=(0,i.asCssValueWithDefault)(u.listFocusAndSelectionOutline,(0,i.asCssValueWithDefault)(u.listSelectionOutline,u.listFocusOutline??""));V&&(A.push(`.monaco-list${F}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${V}; outline-offset: -1px;}`),A.push(`.monaco-list${F}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),u.listFocusOutline&&(A.push(`.monaco-list${F}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),A.push(`.monaco-list${F}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),A.push(`.monaco-workbench.context-menu-visible .monaco-list${F}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),A.push(`.monaco-workbench.context-menu-visible .monaco-list${F}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),A.push(`.monaco-workbench.context-menu-visible .monaco-list${F}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.styleElement.textContent=A.join(`
`),this.view.style(u)}getParentElement(u){const F=this.model.getParentNodeLocation(u);return this.model.getNode(F).element}getFirstElementChild(u){return this.model.getFirstElementChild(u)}getNode(u){return this.model.getNode(u)}getNodeLocation(u){return this.model.getNodeLocation(u)}collapse(u,F=!1){return this.model.setCollapsed(u,!0,F)}expand(u,F=!1){return this.model.setCollapsed(u,!1,F)}toggleCollapsed(u,F=!1){return this.model.setCollapsed(u,void 0,F)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(u){return this.model.isCollapsible(u)}setCollapsible(u,F){return this.model.setCollapsible(u,F)}isCollapsed(u){return this.model.isCollapsed(u)}expandTo(u){this.model.expandTo(u)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(u){if(typeof u>"u")return this.view.setAnchor(void 0);this.eventBufferer.bufferEvents(()=>{const F=this.model.getNode(u);this.anchor.set([F]);const A=this.model.getListIndex(u);A>-1&&this.view.setAnchor(A,!0)})}getAnchor(){return(0,e.firstOrDefault)(this.anchor.get(),void 0)}setSelection(u,F){this.eventBufferer.bufferEvents(()=>{const A=u.map(V=>this.model.getNode(V));this.selection.set(A,F);const B=u.map(V=>this.model.getListIndex(V)).filter(V=>V>-1);this.view.setSelection(B,F,!0)})}getSelection(){return this.selection.get()}setFocus(u,F){this.eventBufferer.bufferEvents(()=>{const A=u.map(V=>this.model.getNode(V));this.focus.set(A,F);const B=u.map(V=>this.model.getListIndex(V)).filter(V=>V>-1);this.view.setFocus(B,F,!0)})}focusNext(u=1,F=!1,A,B=(0,i.isKeyboardEvent)(A)&&A.altKey?void 0:this.focusNavigationFilter){this.view.focusNext(u,F,A,B)}focusPrevious(u=1,F=!1,A,B=(0,i.isKeyboardEvent)(A)&&A.altKey?void 0:this.focusNavigationFilter){this.view.focusPrevious(u,F,A,B)}focusNextPage(u,F=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){return this.view.focusNextPage(u,F)}focusPreviousPage(u,F=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){return this.view.focusPreviousPage(u,F,()=>this.stickyScrollController?.height??0)}focusLast(u,F=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){this.view.focusLast(u,F)}focusFirst(u,F=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){this.view.focusFirst(u,F)}getFocus(){return this.focus.get()}getStickyScrollFocus(){const u=this.stickyScrollController?.getFocus();return u!==void 0?[u]:[]}getFocusedPart(){return this.stickyScrollController?.focusedLast()?a.StickyScroll:a.Tree}reveal(u,F){this.model.expandTo(u);const A=this.model.getListIndex(u);if(A!==-1)if(!this.stickyScrollController)this.view.reveal(A,F);else{const B=this.stickyScrollController.nodePositionTopBelowWidget(this.getNode(u));this.view.reveal(A,F,B)}}getRelativeTop(u){const F=this.model.getListIndex(u);if(F===-1)return null;const A=this.stickyScrollController?.getNode(this.getNode(u));return this.view.getRelativeTop(F,A?.position??this.stickyScrollController?.height)}getViewState(u=this.options.identityProvider){if(!u)throw new b.TreeError(this._user,"Can't get tree view state without an identity provider");const F=G=>u.getId(G).toString(),A=M.empty(this.scrollTop);for(const G of this.getFocus())A.focus.add(F(G));for(const G of this.getSelection())A.selection.add(F(G));const B=this.model.getNode(),V=[B];for(;V.length>0;){const G=V.shift();G!==B&&G.collapsible&&(A.expanded[F(G.element)]=G.collapsed?0:1),V.push(...G.children)}return A}onLeftArrow(u){u.preventDefault(),u.stopPropagation();const F=this.view.getFocusedElements();if(F.length===0)return;const A=F[0],B=this.model.getNodeLocation(A);if(!this.model.setCollapsed(B,!0)){const G=this.model.getParentNodeLocation(B);if(!G)return;const ee=this.model.getListIndex(G);this.view.reveal(ee),this.view.setFocus([ee])}}onRightArrow(u){u.preventDefault(),u.stopPropagation();const F=this.view.getFocusedElements();if(F.length===0)return;const A=F[0],B=this.model.getNodeLocation(A);if(!this.model.setCollapsed(B,!1)){if(!A.children.some(re=>re.visible))return;const[G]=this.view.getFocus(),ee=G+1;this.view.reveal(ee),this.view.setFocus([ee])}}onSpace(u){u.preventDefault(),u.stopPropagation();const F=this.view.getFocusedElements();if(F.length===0)return;const A=F[0],B=this.model.getNodeLocation(A),V=u.browserEvent.altKey;this.model.setCollapsed(B,void 0,V)}navigate(u){return new C(this.view,this.model,u)}dispose(){(0,r.dispose)(this.disposables),this.stickyScrollController?.dispose(),this.view.dispose()}}t.AbstractTree=g;class C{constructor(u,F,A){this.view=u,this.model=F,A?this.index=this.model.getListIndex(A):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(ve[149],De([1,0,148,139,33,35]),function(oe,t,i,n,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class T extends i.AbstractTree{constructor(_,d,D,S,b,m={}){super(_,d,D,S,m),this.user=_,this.dataSource=b,this.nodesByIdentity=new Map,this.identityProvider=m.identityProvider}getInput(){return this.input}setInput(_,d){if(d&&!this.identityProvider)throw new P.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=_,!_){this.nodesByIdentity.clear(),this.model.setChildren(null,O.Iterable.empty());return}if(!d){this._refresh(_);return}const D=[],S=[],b=e=>{const s=this.identityProvider.getId(e).toString();return!d.expanded[s]},m=e=>{const s=this.identityProvider.getId(e.element).toString();d.focus.has(s)&&D.push(e.element),d.selection.has(s)&&S.push(e.element)};this._refresh(_,b,m),this.setFocus(D),this.setSelection(S),d&&typeof d.scrollTop=="number"&&(this.scrollTop=d.scrollTop)}updateChildren(_=this.input){if(typeof this.input>"u")throw new P.TreeError(this.user,"Tree input not set");let d;this.identityProvider&&(d=D=>{const S=this.identityProvider.getId(D).toString(),b=this.nodesByIdentity.get(S);if(b)return b.collapsed}),this._refresh(_,d)}resort(_=this.input,d=!0){this.model.resort(_===this.input?null:_,d)}refresh(_){if(_===void 0){this.view.rerender();return}this.model.rerender(_)}_refresh(_,d,D){let S;if(this.identityProvider){const b=new Set,m=D;D=e=>{const s=this.identityProvider.getId(e.element).toString();b.add(s),this.nodesByIdentity.set(s,e),m?.(e)},S=e=>{const s=this.identityProvider.getId(e.element).toString();b.has(s)||this.nodesByIdentity.delete(s)}}this.model.setChildren(_===this.input?null:_,this.iterate(_,d).elements,{onDidCreateNode:D,onDidDeleteNode:S})}iterate(_,d){const D=[...this.dataSource.getChildren(_)];return{elements:O.Iterable.map(D,b=>{const{elements:m,size:e}=this.iterate(b,d),s=this.dataSource.hasChildren?this.dataSource.hasChildren(b):void 0,o=e===0?void 0:d&&d(b);return{element:b,children:m,collapsible:s,collapsed:o}}),size:D.length}}createModel(_,d,D){return new n.ObjectTreeModel(_,d,D)}}t.DataTree=T}),define(ve[83],De([1,0,9,12,48,37,34,6,3,2,69,11,10]),function(oe,t,i,n,P,O,T,w,_,d,D,S,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.BufferWriter=t.BufferReader=void 0,t.serialize=z,t.deserialize=U,t.getDelayedChannel=$,t.getNextTickChannel=ne;var m;(function(ue){ue[ue.Promise=100]="Promise",ue[ue.PromiseCancel=101]="PromiseCancel",ue[ue.EventListen=102]="EventListen",ue[ue.EventDispose=103]="EventDispose"})(m||(m={}));function e(ue){switch(ue){case m.Promise:return"req";case m.PromiseCancel:return"cancel";case m.EventListen:return"subscribe";case m.EventDispose:return"unsubscribe"}}var s;(function(ue){ue[ue.Initialize=200]="Initialize",ue[ue.PromiseSuccess=201]="PromiseSuccess",ue[ue.PromiseError=202]="PromiseError",ue[ue.PromiseErrorObj=203]="PromiseErrorObj",ue[ue.EventFire=204]="EventFire"})(s||(s={}));function o(ue){switch(ue){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var c;(function(ue){ue[ue.Uninitialized=0]="Uninitialized",ue[ue.Idle=1]="Idle"})(c||(c={}));function h(ue){let J=0;for(let de=0;;de+=7){const ae=ue.read(1);if(J|=(ae.buffer[0]&127)<<de,!(ae.buffer[0]&128))return J}}const p=E(0);function L(ue,J){if(J===0){ue.write(p);return}let de=0;for(let Le=J;Le!==0;Le=Le>>>7)de++;const ae=P.VSBuffer.alloc(de);for(let Le=0;J!==0;Le++)ae.buffer[Le]=J&127,J=J>>>7,J>0&&(ae.buffer[Le]|=128);ue.write(ae)}class y{constructor(J){this.buffer=J,this.pos=0}read(J){const de=this.buffer.slice(this.pos,this.pos+J);return this.pos+=de.byteLength,de}}t.BufferReader=y;class r{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(J){this.buffers.push(J)}}t.BufferWriter=r;var f;(function(ue){ue[ue.Undefined=0]="Undefined",ue[ue.String=1]="String",ue[ue.Buffer=2]="Buffer",ue[ue.VSBuffer=3]="VSBuffer",ue[ue.Array=4]="Array",ue[ue.Object=5]="Object",ue[ue.Int=6]="Int"})(f||(f={}));function E(ue){const J=P.VSBuffer.alloc(1);return J.writeUInt8(ue,0),J}const I={Undefined:E(f.Undefined),String:E(f.String),Buffer:E(f.Buffer),VSBuffer:E(f.VSBuffer),Array:E(f.Array),Object:E(f.Object),Uint:E(f.Int)},H=typeof Buffer<"u";function z(ue,J){if(typeof J>"u")ue.write(I.Undefined);else if(typeof J=="string"){const de=P.VSBuffer.fromString(J);ue.write(I.String),L(ue,de.byteLength),ue.write(de)}else if(H&&Buffer.isBuffer(J)){const de=P.VSBuffer.wrap(J);ue.write(I.Buffer),L(ue,de.byteLength),ue.write(de)}else if(J instanceof P.VSBuffer)ue.write(I.VSBuffer),L(ue,J.byteLength),ue.write(J);else if(Array.isArray(J)){ue.write(I.Array),L(ue,J.length);for(const de of J)z(ue,de)}else if(typeof J=="number"&&(J|0)===J)ue.write(I.Uint),L(ue,J);else{const de=P.VSBuffer.fromString(JSON.stringify(J));ue.write(I.Object),L(ue,de.byteLength),ue.write(de)}}function U(ue){switch(ue.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return ue.read(h(ue)).toString();case f.Buffer:return ue.read(h(ue)).buffer;case f.VSBuffer:return ue.read(h(ue));case f.Array:{const de=h(ue),ae=[];for(let Le=0;Le<de;Le++)ae.push(U(ue));return ae}case f.Object:return JSON.parse(ue.read(h(ue)).toString());case f.Int:return h(ue)}}class v{constructor(J,de,ae=null,Le=1e3){this.protocol=J,this.ctx=de,this.logger=ae,this.timeoutDelay=Le,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:s.Initialize})}registerChannel(J,de){this.channels.set(J,de),setTimeout(()=>this.flushPendingRequests(J),0)}sendResponse(J){switch(J.type){case s.Initialize:{const de=this.send([J.type]);this.logger?.logOutgoing(de,0,k.OtherSide,o(J.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const de=this.send([J.type,J.id],J.data);this.logger?.logOutgoing(de,J.id,k.OtherSide,o(J.type),J.data);return}}}send(J,de=void 0){const ae=new r;return z(ae,J),z(ae,de),this.sendBuffer(ae.buffer)}sendBuffer(J){try{return this.protocol.send(J),J.byteLength}catch{return 0}}onRawMessage(J){const de=new y(J),ae=U(de),Le=U(de),Q=ae[0];switch(Q){case m.Promise:return this.logger?.logIncoming(J.byteLength,ae[1],k.OtherSide,`${e(Q)}: ${ae[2]}.${ae[3]}`,Le),this.onPromise({type:Q,id:ae[1],channelName:ae[2],name:ae[3],arg:Le});case m.EventListen:return this.logger?.logIncoming(J.byteLength,ae[1],k.OtherSide,`${e(Q)}: ${ae[2]}.${ae[3]}`,Le),this.onEventListen({type:Q,id:ae[1],channelName:ae[2],name:ae[3],arg:Le});case m.PromiseCancel:return this.logger?.logIncoming(J.byteLength,ae[1],k.OtherSide,`${e(Q)}`),this.disposeActiveRequest({type:Q,id:ae[1]});case m.EventDispose:return this.logger?.logIncoming(J.byteLength,ae[1],k.OtherSide,`${e(Q)}`),this.disposeActiveRequest({type:Q,id:ae[1]})}}onPromise(J){const de=this.channels.get(J.channelName);if(!de){this.collectPendingRequest(J);return}const ae=new O.CancellationTokenSource;let Le;try{Le=de.call(this.ctx,J.name,J.arg,ae.token)}catch(_e){Le=Promise.reject(_e)}const Q=J.id;Le.then(_e=>{this.sendResponse({id:Q,data:_e,type:s.PromiseSuccess})},_e=>{_e instanceof Error?this.sendResponse({id:Q,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:s.PromiseError}):this.sendResponse({id:Q,data:_e,type:s.PromiseErrorObj})}).finally(()=>{me.dispose(),this.activeRequests.delete(J.id)});const me=(0,d.toDisposable)(()=>ae.cancel());this.activeRequests.set(J.id,me)}onEventListen(J){const de=this.channels.get(J.channelName);if(!de){this.collectPendingRequest(J);return}const ae=J.id,Q=de.listen(this.ctx,J.name,J.arg)(me=>this.sendResponse({id:ae,data:me,type:s.EventFire}));this.activeRequests.set(J.id,Q)}disposeActiveRequest(J){const de=this.activeRequests.get(J.id);de&&(de.dispose(),this.activeRequests.delete(J.id))}collectPendingRequest(J){let de=this.pendingRequests.get(J.channelName);de||(de=[],this.pendingRequests.set(J.channelName,de));const ae=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===m.Promise&&this.sendResponse({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:s.PromiseError})},this.timeoutDelay);de.push({request:J,timeoutTimer:ae})}flushPendingRequests(J){const de=this.pendingRequests.get(J);if(de){for(const ae of de)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case m.Promise:this.onPromise(ae.request);break;case m.EventListen:this.onEventListen(ae.request);break}this.pendingRequests.delete(J)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=v;var k;(function(ue){ue[ue.LocalSide=0]="LocalSide",ue[ue.OtherSide=1]="OtherSide"})(k||(t.RequestInitiator=k={}));class x{constructor(J,de=null){this.protocol=J,this.isDisposed=!1,this.state=c.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ae=>this.onBuffer(ae)),this.logger=de}getChannel(J){const de=this;return{call(ae,Le,Q){return de.isDisposed?Promise.reject(new w.CancellationError):de.requestPromise(J,ae,Le,Q)},listen(ae,Le){return de.isDisposed?_.Event.None:de.requestEvent(J,ae,Le)}}}requestPromise(J,de,ae,Le=O.CancellationToken.None){const Q=this.lastRequestId++,me=m.Promise,_e={id:Q,type:me,channelName:J,name:de,arg:ae};if(Le.isCancellationRequested)return Promise.reject(new w.CancellationError);let Oe;return new Promise((Be,ie)=>{if(Le.isCancellationRequested)return ie(new w.CancellationError);const q=()=>{const g=C=>{switch(C.type){case s.PromiseSuccess:this.handlers.delete(Q),Be(C.data);break;case s.PromiseError:{this.handlers.delete(Q);const R=new Error(C.data.message);R.stack=Array.isArray(C.data.stack)?C.data.stack.join(`
`):C.data.stack,R.name=C.data.name,ie(R);break}case s.PromiseErrorObj:this.handlers.delete(Q),ie(C.data);break}};this.handlers.set(Q,g),this.sendRequest(_e)};let W=null;this.state===c.Idle?q():(W=(0,n.createCancelablePromise)(g=>this.whenInitialized()),W.then(()=>{W=null,q()}));const l=()=>{W?(W.cancel(),W=null):this.sendRequest({id:Q,type:m.PromiseCancel}),ie(new w.CancellationError)},a=Le.onCancellationRequested(l);Oe=(0,d.combinedDisposable)((0,d.toDisposable)(l),a),this.activeRequests.add(Oe)}).finally(()=>{Oe.dispose(),this.activeRequests.delete(Oe)})}requestEvent(J,de,ae){const Le=this.lastRequestId++,Q=m.EventListen,me={id:Le,type:Q,channelName:J,name:de,arg:ae};let _e=null;const Oe=new _.Emitter({onWillAddFirstListener:()=>{_e=(0,n.createCancelablePromise)(Be=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Oe),this.sendRequest(me)})},onDidRemoveLastListener:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Oe),this.sendRequest({id:Le,type:m.EventDispose}))}}),Ce=Be=>Oe.fire(Be.data);return this.handlers.set(Le,Ce),Oe.event}sendRequest(J){switch(J.type){case m.Promise:case m.EventListen:{const de=this.send([J.type,J.id,J.channelName,J.name],J.arg);this.logger?.logOutgoing(de,J.id,k.LocalSide,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case m.PromiseCancel:case m.EventDispose:{const de=this.send([J.type,J.id]);this.logger?.logOutgoing(de,J.id,k.LocalSide,e(J.type));return}}}send(J,de=void 0){const ae=new r;return z(ae,J),z(ae,de),this.sendBuffer(ae.buffer)}sendBuffer(J){try{return this.protocol.send(J),J.byteLength}catch{return 0}}onBuffer(J){const de=new y(J),ae=U(de),Le=U(de),Q=ae[0];switch(Q){case s.Initialize:return this.logger?.logIncoming(J.byteLength,0,k.LocalSide,o(Q)),this.onResponse({type:ae[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.logger?.logIncoming(J.byteLength,ae[1],k.LocalSide,o(Q),Le),this.onResponse({type:ae[0],id:ae[1],data:Le})}}onResponse(J){if(J.type===s.Initialize){this.state=c.Idle,this._onDidInitialize.fire();return}this.handlers.get(J.id)?.(J)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelClient=x,Je([T.memoize],x.prototype,"onDidInitializePromise",null);class N{get connections(){const J=[];return this._connections.forEach(de=>J.push(de)),J}constructor(J,de,ae){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new d.DisposableStore,this.disposables.add(J(({protocol:Le,onDidClientDisconnect:Q})=>{const me=_.Event.once(Le.onMessage);this.disposables.add(me(_e=>{const Oe=new y(_e),Ce=U(Oe),Be=new v(Le,Ce,de,ae),ie=new x(Le,de);this.channels.forEach((W,l)=>Be.registerChannel(l,W));const q={channelServer:Be,channelClient:ie,ctx:Ce};this._connections.add(q),this._onDidAddConnection.fire(q),this.disposables.add(Q(()=>{Be.dispose(),ie.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)}))}))}))}getChannel(J,de){const ae=this;return{call(Le,Q,me){let _e;if((0,b.isFunction)(de)){const Ce=(0,i.getRandomElement)(ae.connections.filter(de));_e=Ce?Promise.resolve(Ce):_.Event.toPromise(_.Event.filter(ae.onDidAddConnection,de))}else _e=de.routeCall(ae,Le,Q);const Oe=_e.then(Ce=>Ce.channelClient.getChannel(J));return $(Oe).call(Le,Q,me)},listen(Le,Q){if((0,b.isFunction)(de))return ae.getMulticastEvent(J,de,Le,Q);const me=de.routeEvent(ae,Le,Q).then(_e=>_e.channelClient.getChannel(J));return $(me).listen(Le,Q)}}}getMulticastEvent(J,de,ae,Le){const Q=this;let me;const _e=new _.Emitter({onWillAddFirstListener:()=>{me=new d.DisposableStore;const Oe=new _.EventMultiplexer,Ce=new Map,Be=q=>{const l=q.channelClient.getChannel(J).listen(ae,Le),a=Oe.add(l);Ce.set(q,a)},ie=q=>{const W=Ce.get(q);W&&(W.dispose(),Ce.delete(q))};Q.connections.filter(de).forEach(Be),_.Event.filter(Q.onDidAddConnection,de)(Be,void 0,me),Q.onDidRemoveConnection(ie,void 0,me),Oe.event(_e.fire,_e,me),me.add(Oe)},onDidRemoveLastListener:()=>{me?.dispose(),me=void 0}});return _e.event}registerChannel(J,de){this.channels.set(J,de);for(const ae of this._connections)ae.channelServer.registerChannel(J,de)}dispose(){this.disposables.dispose();for(const J of this._connections)J.channelClient.dispose(),J.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=N;class M{constructor(J,de,ae=null){const Le=new r;z(Le,de),J.send(Le.buffer),this.channelClient=new x(J,ae),this.channelServer=new v(J,de,ae)}getChannel(J){return this.channelClient.getChannel(J)}registerChannel(J,de){this.channelServer.registerChannel(J,de)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=M;function $(ue){return{call(J,de,ae){return ue.then(Le=>Le.call(J,de,ae))},listen(J,de){const ae=new _.Relay;return ue.then(Le=>ae.input=Le.listen(J,de)),ae.event}}}function ne(ue){let J=!1;return{call(de,ae,Le){return J?ue.call(de,ae,Le):(0,n.timeout)(0).then(()=>J=!0).then(()=>ue.call(de,ae,Le))},listen(de,ae){if(J)return ue.listen(de,ae);const Le=new _.Relay;return(0,n.timeout)(0).then(()=>J=!0).then(()=>Le.input=ue.listen(de,ae)),Le.event}}}class Z{constructor(J){this.fn=J}routeCall(J){return this.route(J)}routeEvent(J){return this.route(J)}async route(J){for(const de of J.connections)if(await Promise.resolve(this.fn(de.ctx)))return Promise.resolve(de);return await _.Event.toPromise(J.onDidAddConnection),await this.route(J)}}t.StaticRouter=Z;var Y;(function(ue){function J(Q,me,_e){const Oe=Q,Ce=_e&&_e.disableMarshalling,Be=new Map;for(const ie in Oe)ae(ie)&&Be.set(ie,_.Event.buffer(Oe[ie],!0,void 0,me));return new class{listen(ie,q,W){const l=Be.get(q);if(l)return l;const a=Oe[q];if(typeof a=="function"){if(Le(q))return a.call(Oe,W);if(ae(q))return Be.set(q,_.Event.buffer(Oe[q],!0,void 0,me)),Be.get(q)}throw new w.ErrorNoTelemetry(`Event not found: ${q}`)}call(ie,q,W){const l=Oe[q];if(typeof l=="function"){if(!Ce&&Array.isArray(W))for(let g=0;g<W.length;g++)W[g]=(0,D.revive)(W[g]);let a=l.apply(Oe,W);return a instanceof Promise||(a=Promise.resolve(a)),a}throw new w.ErrorNoTelemetry(`Method not found: ${q}`)}}}ue.fromService=J;function de(Q,me){const _e=me&&me.disableMarshalling;return new Proxy({},{get(Oe,Ce){if(typeof Ce=="string")return me?.properties?.has(Ce)?me.properties.get(Ce):Le(Ce)?function(Be){return Q.listen(Ce,Be)}:ae(Ce)?Q.listen(Ce):async function(...Be){let ie;me&&!(0,b.isUndefinedOrNull)(me.context)?ie=[me.context,...Be]:ie=Be;const q=await Q.call(Ce,ie);return _e?q:(0,D.revive)(q)};throw new w.ErrorNoTelemetry(`Property not found: ${String(Ce)}`)}})}ue.toService=de;function ae(Q){return Q[0]==="o"&&Q[1]==="n"&&S.isUpperAsciiLetter(Q.charCodeAt(2))}function Le(Q){return/^onDynamic/.test(Q)&&S.isUpperAsciiLetter(Q.charCodeAt(9))}})(Y||(t.ProxyChannel=Y={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(ue){if(Array.isArray(ue))return ue;if(ue&&typeof ue=="object"&&typeof ue.toString=="function"){const J=ue.toString();if(J!=="[object Object]")return J}return ue}function Ee(ue){return Array.isArray(ue)?ue.map(fe):fe(ue)}function Fe(ue,J,de,ae,Le,Q,me){me=Ee(me);const _e=te[Le],Oe=_e[ae%_e.length];let Ce=[`%c[${ue}]%c[${String(J).padStart(7," ")}]%c[len: ${String(de).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Oe}`];/\($/.test(Q)?(Ce=Ce.concat(me),Ce.push(")")):Ce.push(me),console.log.apply(console,Ce)}class Ae{constructor(J,de){this._outgoingPrefix=J,this._incomingPrefix=de,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(J,de,ae,Le,Q){this._totalOutgoing+=J,Fe(this._outgoingPrefix,this._totalOutgoing,J,de,ae,Le,Q)}logIncoming(J,de,ae,Le,Q){this._totalIncoming+=J,Fe(this._incomingPrefix,this._totalIncoming,J,de,ae,Le,Q)}}t.IPCLogger=Ae}),define(ve[150],De([1,0,48,3,83,106,38]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends P.IPCClient{static createProtocol(){const d=n.Event.fromNodeEventEmitter(T.ipcRenderer,"vscode:message",(D,S)=>i.VSBuffer.wrap(S));return T.ipcRenderer.send("vscode:hello"),new O.Protocol(T.ipcRenderer,d)}constructor(d){const D=w.createProtocol();super(D,d),this.protocol=D}dispose(){this.protocol.disconnect(),super.dispose()}}t.Client=w}),define(ve[151],De([14,13]),function(oe,t){return oe.create("vs/platform/files/common/files",t)}),define(ve[152],De([14,13]),function(oe,t){return oe.create("vs/platform/theme/common/iconRegistry",t)}),define(ve[55],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IInstantiationService=t._util=void 0,t.createDecorator=P,t.refineServiceDecorator=O;var i;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function w(_){return _[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=w})(i||(t._util=i={})),t.IInstantiationService=P("instantiationService");function n(T,w,_){w[i.DI_TARGET]===w?w[i.DI_DEPENDENCIES].push({id:T,index:_}):(w[i.DI_DEPENDENCIES]=[{id:T,index:_}],w[i.DI_TARGET]=w)}function P(T){if(i.serviceIds.has(T))return i.serviceIds.get(T);const w=function(_,d,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(w,_,D)};return w.toString=()=>T,i.serviceIds.set(T,w),w}function O(T){return T}}),define(ve[153],De([1,0,55]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.IDiagnosticsService=t.ID=void 0,t.isRemoteDiagnosticError=n,t.ID="diagnosticsService",t.IDiagnosticsService=(0,i.createDecorator)(t.ID);function n(O){return!!O.hostName&&!!O.errorMessage}class P{async getPerformanceInfo(T,w){return{}}async getSystemInfo(T,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,w){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}t.NullDiagnosticsService=P}),define(ve[154],De([1,0,104,28,11,10,17,151,55,5,39,26]),function(oe,t,i,n,P,O,T,w,_,d,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ByteSize=t.ETAG_DISABLED=t.FileKind=t.FILES_READONLY_FROM_PERMISSIONS_CONFIG=t.FILES_READONLY_EXCLUDE_CONFIG=t.FILES_READONLY_INCLUDE_CONFIG=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.IFileService=void 0,t.isFileOpenForWriteOptions=b,t.isFileSystemWatcher=o,t.hasReadWriteCapability=h,t.hasFileFolderCopyCapability=p,t.hasFileCloneCapability=L,t.hasOpenReadWriteCloseCapability=y,t.hasFileReadStreamCapability=r,t.hasFileAtomicReadCapability=f,t.hasFileAtomicWriteCapability=E,t.hasFileAtomicDeleteCapability=I,t.hasReadonlyCapability=H,t.createFileSystemProviderError=v,t.ensureFileSystemProviderError=k,t.markAsFileSystemProviderError=x,t.toFileSystemProviderErrorCode=N,t.toFileOperationResult=M,t.isParent=te,t.etag=J,t.whenProviderRegistered=de,t.getLargeFileConfirmationLimit=Le,t.IFileService=(0,_.createDecorator)("fileService");function b(Q){return Q.create===!0}var m;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.File=1]="File",Q[Q.Directory=2]="Directory",Q[Q.SymbolicLink=64]="SymbolicLink"})(m||(t.FileType=m={}));var e;(function(Q){Q[Q.Readonly=1]="Readonly",Q[Q.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var s;(function(Q){Q[Q.UPDATED=2]="UPDATED",Q[Q.ADDED=4]="ADDED",Q[Q.DELETED=8]="DELETED"})(s||(t.FileChangeFilter=s={}));function o(Q){const me=Q;return!!me&&typeof me.onDidChange=="function"}var c;(function(Q){Q[Q.None=0]="None",Q[Q.FileReadWrite=2]="FileReadWrite",Q[Q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Q[Q.FileReadStream=16]="FileReadStream",Q[Q.FileFolderCopy=8]="FileFolderCopy",Q[Q.PathCaseSensitive=1024]="PathCaseSensitive",Q[Q.Readonly=2048]="Readonly",Q[Q.Trash=4096]="Trash",Q[Q.FileWriteUnlock=8192]="FileWriteUnlock",Q[Q.FileAtomicRead=16384]="FileAtomicRead",Q[Q.FileAtomicWrite=32768]="FileAtomicWrite",Q[Q.FileAtomicDelete=65536]="FileAtomicDelete",Q[Q.FileClone=131072]="FileClone"})(c||(t.FileSystemProviderCapabilities=c={}));function h(Q){return!!(Q.capabilities&c.FileReadWrite)}function p(Q){return!!(Q.capabilities&c.FileFolderCopy)}function L(Q){return!!(Q.capabilities&c.FileClone)}function y(Q){return!!(Q.capabilities&c.FileOpenReadWriteClose)}function r(Q){return!!(Q.capabilities&c.FileReadStream)}function f(Q){return h(Q)?!!(Q.capabilities&c.FileAtomicRead):!1}function E(Q){return h(Q)?!!(Q.capabilities&c.FileAtomicWrite):!1}function I(Q){return!!(Q.capabilities&c.FileAtomicDelete)}function H(Q){return!!(Q.capabilities&c.Readonly)}var z;(function(Q){Q.FileExists="EntryExists",Q.FileNotFound="EntryNotFound",Q.FileNotADirectory="EntryNotADirectory",Q.FileIsADirectory="EntryIsADirectory",Q.FileExceedsStorageQuota="EntryExceedsStorageQuota",Q.FileTooLarge="EntryTooLarge",Q.FileWriteLocked="EntryWriteLocked",Q.NoPermissions="NoPermissions",Q.Unavailable="Unavailable",Q.Unknown="Unknown"})(z||(t.FileSystemProviderErrorCode=z={}));class U extends Error{static create(me,_e){const Oe=new U(me.toString(),_e);return x(Oe,_e),Oe}constructor(me,_e){super(me),this.code=_e}}t.FileSystemProviderError=U;function v(Q,me){return U.create(Q,me)}function k(Q){return Q||v((0,w.localize)(0,null),z.Unknown)}function x(Q,me){return Q.name=me?`${me} (FileSystemError)`:"FileSystemError",Q}function N(Q){if(!Q)return z.Unknown;if(Q instanceof U)return Q.code;const me=/^(.+) \(FileSystemError\)$/.exec(Q.name);if(!me)return z.Unknown;switch(me[1]){case z.FileExists:return z.FileExists;case z.FileIsADirectory:return z.FileIsADirectory;case z.FileNotADirectory:return z.FileNotADirectory;case z.FileNotFound:return z.FileNotFound;case z.FileTooLarge:return z.FileTooLarge;case z.FileWriteLocked:return z.FileWriteLocked;case z.NoPermissions:return z.NoPermissions;case z.Unavailable:return z.Unavailable}return z.Unknown}function M(Q){if(Q instanceof fe)return Q.fileOperationResult;switch(N(Q)){case z.FileNotFound:return Ae.FILE_NOT_FOUND;case z.FileIsADirectory:return Ae.FILE_IS_DIRECTORY;case z.FileNotADirectory:return Ae.FILE_NOT_DIRECTORY;case z.FileWriteLocked:return Ae.FILE_WRITE_LOCKED;case z.NoPermissions:return Ae.FILE_PERMISSION_DENIED;case z.FileExists:return Ae.FILE_MOVE_CONFLICT;case z.FileTooLarge:return Ae.FILE_TOO_LARGE;default:return Ae.FILE_OTHER_ERROR}}var $;(function(Q){Q[Q.CREATE=0]="CREATE",Q[Q.DELETE=1]="DELETE",Q[Q.MOVE=2]="MOVE",Q[Q.COPY=3]="COPY",Q[Q.WRITE=4]="WRITE"})($||(t.FileOperation=$={}));class ne{constructor(me,_e,Oe){this.resource=me,this.operation=_e,this.target=Oe}isOperation(me){return this.operation===me}}t.FileOperationEvent=ne;var Z;(function(Q){Q[Q.UPDATED=0]="UPDATED",Q[Q.ADDED=1]="ADDED",Q[Q.DELETED=2]="DELETED"})(Z||(t.FileChangeType=Z={}));class Y{static{this.MIXED_CORRELATION=null}constructor(me,_e){this.ignorePathCasing=_e,this.correlationId=void 0,this.added=new S.Lazy(()=>{const Oe=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Oe.fill(this.rawAdded.map(Ce=>[Ce,!0])),Oe}),this.updated=new S.Lazy(()=>{const Oe=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Oe.fill(this.rawUpdated.map(Ce=>[Ce,!0])),Oe}),this.deleted=new S.Lazy(()=>{const Oe=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Oe.fill(this.rawDeleted.map(Ce=>[Ce,!0])),Oe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Oe of me){switch(Oe.type){case Z.ADDED:this.rawAdded.push(Oe.resource);break;case Z.UPDATED:this.rawUpdated.push(Oe.resource);break;case Z.DELETED:this.rawDeleted.push(Oe.resource);break}this.correlationId!==Y.MIXED_CORRELATION&&(typeof Oe.cId=="number"?this.correlationId===void 0?this.correlationId=Oe.cId:this.correlationId!==Oe.cId&&(this.correlationId=Y.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=Y.MIXED_CORRELATION))}}contains(me,..._e){return this.doContains(me,{includeChildren:!1},..._e)}affects(me,..._e){return this.doContains(me,{includeChildren:!0},..._e)}doContains(me,_e,...Oe){if(!me)return!1;const Ce=Oe.length>0;return!!((!Ce||Oe.includes(Z.ADDED))&&(this.added.value.get(me)||_e.includeChildren&&this.added.value.findSuperstr(me))||(!Ce||Oe.includes(Z.UPDATED))&&(this.updated.value.get(me)||_e.includeChildren&&this.updated.value.findSuperstr(me))||(!Ce||Oe.includes(Z.DELETED))&&(this.deleted.value.findSubstr(me)||_e.includeChildren&&this.deleted.value.findSuperstr(me)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(me){return this.correlationId===me}hasCorrelation(){return typeof this.correlationId=="number"}}t.FileChangesEvent=Y;function te(Q,me,_e){return!Q||!me||Q===me||me.length>Q.length?!1:(me.charAt(me.length-1)!==n.sep&&(me+=n.sep),_e?(0,P.startsWithIgnoreCase)(Q,me):Q.indexOf(me)===0)}class fe extends Error{constructor(me,_e,Oe){super(me),this.fileOperationResult=_e,this.options=Oe}}t.FileOperationError=fe;class Ee extends fe{constructor(me,_e,Oe,Ce){super(me,_e,Ce),this.fileOperationResult=_e,this.size=Oe}}t.TooLargeFileOperationError=Ee;class Fe extends fe{constructor(me,_e,Oe){super(me,Ae.FILE_NOT_MODIFIED_SINCE,Oe),this.stat=_e}}t.NotModifiedSinceFileOperationError=Fe;var Ae;(function(Q){Q[Q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Q[Q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Q[Q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Q[Q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Q[Q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Q[Q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Q[Q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Q[Q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Q[Q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Q[Q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Q[Q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ae||(t.FileOperationResult=Ae={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",t.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",t.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",t.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ue;(function(Q){Q[Q.FILE=0]="FILE",Q[Q.FOLDER=1]="FOLDER",Q[Q.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(t.FileKind=ue={})),t.ETAG_DISABLED="";function J(Q){if(!(typeof Q.size!="number"||typeof Q.mtime!="number"))return Q.mtime.toString(29)+Q.size.toString(31)}async function de(Q,me){if(!me.hasProvider(T.URI.from({scheme:Q.scheme})))return new Promise(_e=>{const Oe=me.onDidChangeFileSystemProviderRegistrations(Ce=>{Ce.scheme===Q.scheme&&Ce.added&&(Oe.dispose(),_e())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(me){return(0,O.isNumber)(me)||(me=0),me<ae.KB?(0,w.localize)(1,null,me.toFixed(0)):me<ae.MB?(0,w.localize)(2,null,(me/ae.KB).toFixed(2)):me<ae.GB?(0,w.localize)(3,null,(me/ae.MB).toFixed(2)):me<ae.TB?(0,w.localize)(4,null,(me/ae.GB).toFixed(2)):(0,w.localize)(5,null,(me/ae.TB).toFixed(2))}}t.ByteSize=ae;function Le(Q){const me=typeof Q=="string"||Q?.scheme===D.Schemas.vscodeRemote;return typeof Q!="string"&&Q?.scheme===D.Schemas.file?1024*ae.MB:me?10*ae.MB:d.isWeb?50*ae.MB:1024*ae.MB}}),define(ve[155],De([1,0,55]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,i.createDecorator)("mainProcessService");class n{constructor(O,T){this.server=O,this.router=T}getChannel(O){return this.server.getChannel(O,this.router)}registerChannel(O,T){this.server.registerChannel(O,T)}}t.MainProcessService=n}),define(ve[156],De([1,0,2,150]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class P extends i.Disposable{constructor(T){super(),this.mainProcessConnection=this._register(new n.Client(`window:${T}`))}getChannel(T){return this.mainProcessConnection.getChannel(T)}registerChannel(T,w){this.mainProcessConnection.registerChannel(T,w)}}t.ElectronIPCMainProcessService=P});var Li=this&&this.__param||function(oe,t){return function(i,n){t(i,n,oe)}};define(ve[157],De([1,0,83,155]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let P=class{constructor(T,w){return this.windowId=T,i.ProxyChannel.toService(w.getChannel("nativeHost"),{context:T,properties:(()=>{const _=new Map;return _.set("windowId",T),_})()})}};t.NativeHostService=P,t.NativeHostService=P=Je([Li(1,n.IMainProcessService)],P)}),define(ve[84],De([1,0,41,10]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class P{constructor(){this.data=new Map}add(T,w){i.ok(n.isString(T)),i.ok(n.isObject(w)),i.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,w)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new P}),define(ve[158],De([1,0,3,84]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function P(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class O{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,d){this.schemasById[P(_)]=d,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new O;n.Registry.add(t.Extensions.JSONContribution,T)}),define(ve[159],De([1,0,12,21,49,22,3,10,17,152,158,84]),function(oe,t,i,n,P,O,T,w,_,d,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.registerIcon=o,t.getIconRegistry=c,t.Extensions={IconContribution:"base.contributions.icons"};var b;(function(y){function r(f,E){let I=f.defaults;for(;O.ThemeIcon.isThemeIcon(I);){const H=s.getIcon(I.id);if(!H)return;I=H.defaults}return I}y.getDefinition=r})(b||(t.IconContribution=b={}));var m;(function(y){function r(E){return{weight:E.weight,style:E.style,src:E.src.map(I=>({format:I.format,location:I.location.toString()}))}}y.toJSONObject=r;function f(E){const I=H=>(0,w.isString)(H)?H:void 0;if(E&&Array.isArray(E.src)&&E.src.every(H=>(0,w.isString)(H.format)&&(0,w.isString)(H.location)))return{weight:I(E.weight),style:I(E.style),src:E.src.map(H=>({format:H.format,location:_.URI.parse(H.location)}))}}y.fromJSONObject=f})(m||(t.IconFontDefinition=m={}));class e{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,d.localize)(0,null)},fontCharacter:{type:"string",description:(0,d.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(r,f,E,I){const H=this.iconsById[r];if(H){if(E&&!H.description){H.description=E,this.iconSchema.properties[r].markdownDescription=`${E} $(${r})`;const v=this.iconReferenceSchema.enum.indexOf(r);v!==-1&&(this.iconReferenceSchema.enumDescriptions[v]=E),this._onDidChange.fire()}return H}const z={id:r,description:E,defaults:f,deprecationMessage:I};this.iconsById[r]=z;const U={$ref:"#/definitions/icons"};return I&&(U.deprecationMessage=I),E&&(U.markdownDescription=`${E}: $(${r})`),this.iconSchema.properties[r]=U,this.iconReferenceSchema.enum.push(r),this.iconReferenceSchema.enumDescriptions.push(E||""),this._onDidChange.fire(),{id:r}}deregisterIcon(r){delete this.iconsById[r],delete this.iconSchema.properties[r];const f=this.iconReferenceSchema.enum.indexOf(r);f!==-1&&(this.iconReferenceSchema.enum.splice(f,1),this.iconReferenceSchema.enumDescriptions.splice(f,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(r=>this.iconsById[r])}getIcon(r){return this.iconsById[r]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(r,f){const E=this.iconFontsById[r];return E||(this.iconFontsById[r]=f,this._onDidChange.fire(),f)}deregisterIconFont(r){delete this.iconFontsById[r]}getIconFont(r){return this.iconFontsById[r]}toString(){const r=(H,z)=>H.id.localeCompare(z.id),f=H=>{for(;O.ThemeIcon.isThemeIcon(H.defaults);)H=this.iconsById[H.defaults.id];return`codicon codicon-${H?H.id:""}`},E=[];E.push("| preview     | identifier                        | default codicon ID                | description"),E.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const I=Object.keys(this.iconsById).map(H=>this.iconsById[H]);for(const H of I.filter(z=>!!z.description).sort(r))E.push(`|<i class="${f(H)}"></i>|${H.id}|${O.ThemeIcon.isThemeIcon(H.defaults)?H.defaults.id:H.id}|${H.description||""}|`);E.push("| preview     | identifier                        "),E.push("| ----------- | --------------------------------- |");for(const H of I.filter(z=>!O.ThemeIcon.isThemeIcon(z.defaults)).sort(r))E.push(`|<i class="${f(H)}"></i>|${H.id}|`);return E.join(`
`)}}const s=new e;S.Registry.add(t.Extensions.IconContribution,s);function o(y,r,f,E){return s.registerIcon(y,r,f,E)}function c(){return s}function h(){const y=(0,P.getCodiconFontCharacters)();for(const r in y){const f="\\"+y[r].toString(16);s.registerIcon(r,{fontCharacter:f})}}h(),t.iconsSchemaId="vscode://schemas/icons";const p=S.Registry.as(D.Extensions.JSONContribution);p.registerSchema(t.iconsSchemaId,s.getIconSchema());const L=new i.RunOnceScheduler(()=>p.notifySchemaChanged(t.iconsSchemaId),200);s.onDidChange(()=>{L.isScheduled()||L.schedule()}),t.widgetClose=o("widget-close",n.Codicon.close,(0,d.localize)(2,null)),t.gotoPreviousLocation=o("goto-previous-location",n.Codicon.arrowUp,(0,d.localize)(3,null)),t.gotoNextLocation=o("goto-next-location",n.Codicon.arrowDown,(0,d.localize)(4,null)),t.syncing=O.ThemeIcon.modify(n.Codicon.sync,"spin"),t.spinningLoading=O.ThemeIcon.modify(n.Codicon.loading,"spin")}),define(ve[160],De([1,0,4,3,2,22,159]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=void 0,t.getIconsStyleSheet=w;function w(d){const D=new P.DisposableStore,S=D.add(new n.Emitter),b=(0,T.getIconRegistry)();return D.add(b.onDidChange(()=>S.fire())),d&&D.add(d.onDidProductIconThemeChange(()=>S.fire())),{dispose:()=>D.dispose(),onDidChange:S.event,getCSS(){const m=d?d.getProductIconTheme():new _,e={},s=[],o=[];for(const c of b.getIcons()){const h=m.getIcon(c);if(!h)continue;const p=h.font,L=`--vscode-icon-${c.id}-font-family`,y=`--vscode-icon-${c.id}-content`;p?(e[p.id]=p.definition,o.push(`${L}: ${(0,i.asCSSPropertyValue)(p.id)};`,`${y}: '${h.fontCharacter}';`),s.push(`.codicon-${c.id}:before { content: '${h.fontCharacter}'; font-family: ${(0,i.asCSSPropertyValue)(p.id)}; }`)):(o.push(`${y}: '${h.fontCharacter}'; ${L}: 'codicon';`),s.push(`.codicon-${c.id}:before { content: '${h.fontCharacter}'; }`))}for(const c in e){const h=e[c],p=h.weight?`font-weight: ${h.weight};`:"",L=h.style?`font-style: ${h.style};`:"",y=h.src.map(r=>`${(0,i.asCSSUrl)(r.location)} format('${r.format}')`).join(", ");s.push(`@font-face { src: ${y}; font-family: ${(0,i.asCSSPropertyValue)(c)};${p}${L} font-display: block; }`)}return s.push(`:root { ${o.join(" ")} }`),s.join(`
`)}}}class _{getIcon(D){const S=(0,T.getIconRegistry)();let b=D.defaults;for(;O.ThemeIcon.isThemeIcon(b);){const m=S.getIcon(b.id);if(!m)return;b=m.defaults}return b}}t.UnthemedProductIconTheme=_}),define(ve[161],De([1,0,5]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.WindowMinimumSize=void 0,t.isOpenedAuxiliaryWindow=n,t.isWorkspaceToOpen=P,t.isFolderToOpen=O,t.isFileToOpen=T,t.getMenuBarVisibility=w,t.hasCustomTitlebar=S,t.hasNativeTitlebar=b,t.getTitleBarStyle=m,t.useWindowControlsOverlay=e,t.useNativeFullScreen=s,t.zoomLevelToZoomFactor=o,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(c){return typeof c.parentId=="number"}function P(c){return!!c.workspaceUri}function O(c){return!!c.folderUri}function T(c){return!!c.fileUri}function w(c){const h=b(c),p=c.getValue("window.menuBarVisibility");return p==="default"||h&&p==="compact"||i.isMacintosh&&i.isNative?"classic":p}var _;(function(c){c.TITLE_BAR_STYLE="window.titleBarStyle",c.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(_||(t.TitleBarSetting=_={}));var d;(function(c){c.NATIVE="native",c.CUSTOM="custom"})(d||(t.TitlebarStyle=d={}));var D;(function(c){c.AUTO="auto",c.WINDOWED="windowed",c.NEVER="never"})(D||(t.CustomTitleBarVisibility=D={}));function S(c,h){return!0}function b(c,h){return h||(h=m(c)),h===d.NATIVE}function m(c){if(i.isWeb)return d.CUSTOM;const h=c.getValue("window");if(h){if(i.isMacintosh&&h.nativeTabs===!0||i.isMacintosh&&h.nativeFullScreen===!1)return d.NATIVE;const y=h.titleBarStyle;if(y===d.NATIVE||y===d.CUSTOM)return y}return i.isLinux?d.NATIVE:d.CUSTOM}t.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=35;function e(c){return!(!i.isWindows||i.isWeb||b(c))}function s(c){const h=c.getValue("window");return!h||typeof h.nativeFullScreen!="boolean"||h.nativeTabs?!0:h.nativeFullScreen!==!1}function o(c=0){return Math.pow(1.2,c)}}),define(ve[162],De([1,0,19,4,25,38,161]),function(oe,t,i,n,P,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MIN_ZOOM_LEVEL=t.MAX_ZOOM_LEVEL=t.ApplyZoomTarget=void 0,t.applyZoom=_,t.zoomIn=D,t.zoomOut=S;var w;(function(b){b[b.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",b[b.ALL_WINDOWS=2]="ALL_WINDOWS"})(w||(t.ApplyZoomTarget=w={})),t.MAX_ZOOM_LEVEL=8,t.MIN_ZOOM_LEVEL=-8;function _(b,m){b=Math.min(Math.max(b,t.MIN_ZOOM_LEVEL),t.MAX_ZOOM_LEVEL);const e=[];m===w.ACTIVE_WINDOW?e.push((0,n.getActiveWindow)()):m===w.ALL_WINDOWS?e.push(...Array.from((0,n.getWindows)()).map(({window:s})=>s)):e.push(m);for(const s of e)d(s)?.webFrame?.setZoomLevel(b),(0,i.setZoomFactor)((0,T.zoomLevelToZoomFactor)(b),s),(0,i.setZoomLevel)(b,s)}function d(b){if(b===P.mainWindow)return{ipcRenderer:O.ipcRenderer,webFrame:O.webFrame};{const m=b;if(m?.vscode?.ipcRenderer&&m?.vscode?.webFrame)return m.vscode}}function D(b){_((0,i.getZoomLevel)(typeof b=="number"?(0,n.getActiveWindow)():b)+1,b)}function S(b){_((0,i.getZoomLevel)(typeof b=="number"?(0,n.getActiveWindow)():b)-1,b)}}),define(ve[163],De([1,0,13,4,149,12,107,38,153,154,156,157,160,162,16,8,25,121,111]),function(oe,t,i,n,P,O,T,w,_,d,D,S,b,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=k;const c=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,h=/\s--inspect-port=(?<port>\d+)/;class p{getHeight(N){return 22}getTemplateId(N){return z(N)?"process":I(N)?"machine":(0,_.isRemoteDiagnosticError)(N)?"error":H(N)?"header":""}}class L{hasChildren(N){return(0,_.isRemoteDiagnosticError)(N)?!1:z(N)?!!N.children?.length:!0}getChildren(N){return z(N)?N.children?N.children:[]:(0,_.isRemoteDiagnosticError)(N)?[]:H(N)?N.processRoots.length>1?N.processRoots:[N.processRoots[0].rootProcess]:I(N)?[N.rootProcess]:[N.processes]}}class y{constructor(){this.templateId="header"}renderTemplate(N){const M=(0,n.append)(N,(0,n.$)(".row")),$=(0,n.append)(M,(0,n.$)(".nameLabel")),ne=(0,n.append)(M,(0,n.$)(".cpu")),Z=(0,n.append)(M,(0,n.$)(".memory")),Y=(0,n.append)(M,(0,n.$)(".pid"));return{name:$,CPU:ne,memory:Z,PID:Y}}renderElement(N,M,$,ne){$.name.textContent=(0,i.localize)(0,null),$.CPU.textContent=(0,i.localize)(1,null),$.PID.textContent=(0,i.localize)(2,null),$.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(N){}}class r{constructor(){this.templateId="machine"}renderTemplate(N){const M=Object.create(null),$=(0,n.append)(N,(0,n.$)(".row"));return M.name=(0,n.append)($,(0,n.$)(".nameLabel")),M}renderElement(N,M,$,ne){$.name.textContent=N.element.name}disposeTemplate(N){}}class f{constructor(){this.templateId="error"}renderTemplate(N){const M=Object.create(null),$=(0,n.append)(N,(0,n.$)(".row"));return M.name=(0,n.append)($,(0,n.$)(".nameLabel")),M}renderElement(N,M,$,ne){$.name.textContent=N.element.errorMessage}disposeTemplate(N){}}class E{constructor(N,M,$){this.platform=N,this.totalMem=M,this.mapPidToName=$,this.templateId="process"}renderTemplate(N){const M=(0,n.append)(N,(0,n.$)(".row")),$=(0,n.append)(M,(0,n.$)(".nameLabel")),ne=(0,n.append)(M,(0,n.$)(".cpu")),Z=(0,n.append)(M,(0,n.$)(".memory")),Y=(0,n.append)(M,(0,n.$)(".pid"));return{name:$,CPU:ne,PID:Y,memory:Z}}renderElement(N,M,$,ne){const{element:Z}=N,Y=Z.pid.toFixed(0);let te=Z.name;this.mapPidToName.has(Z.pid)&&(te=this.mapPidToName.get(Z.pid)),$.name.textContent=te,$.name.title=Z.cmd,$.CPU.textContent=Z.load.toFixed(0),$.PID.textContent=Y,$.PID.parentElement.id=`pid-${Y}`;const fe=this.platform==="win32"?Z.mem:this.totalMem*(Z.mem/100);$.memory.textContent=(fe/d.ByteSize.MB).toFixed(0)}disposeTemplate(N){}}function I(x){return!!x.name&&!!x.rootProcess}function H(x){return!!x.processRoots}function z(x){return!!x.pid}class U{constructor(N,M){this.data=M,this.mapPidToName=new Map;const $=new D.ElectronIPCMainProcessService(N);this.nativeHostService=new S.NativeHostService(N,$),this.applyStyles(M.styles),this.setEventHandlers(M),w.ipcRenderer.on("vscode:pidToNameResponse",(ne,Z)=>{this.mapPidToName.clear();for(const[Y,te]of Z)this.mapPidToName.set(Y,te)}),w.ipcRenderer.on("vscode:listProcessesResponse",async(ne,Z)=>{Z.forEach((Y,te)=>{z(Y.rootProcess)&&(Y.rootProcess.name=te===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:Z}}),this.tree.layout(o.mainWindow.innerHeight,o.mainWindow.innerWidth)):await this.createProcessTree(Z),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),w.ipcRenderer.send("vscode:pidToNameRequest"),w.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(N){o.mainWindow.document.onkeydown=M=>{const $=N.platform==="darwin"?M.metaKey:M.ctrlKey;$&&M.keyCode===87&&(M.stopPropagation(),M.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),$&&M.keyCode===187&&(0,m.zoomIn)(o.mainWindow),$&&M.keyCode===189&&(0,m.zoomOut)(o.mainWindow)}}async createProcessTree(N){const M=o.mainWindow.document.getElementById("process-list");if(!M)return;const{totalmem:$}=await this.nativeHostService.getOSStatistics(),ne=[new E(this.data.platform,$,this.mapPidToName),new y,new r,new f];this.tree=new P.DataTree("processExplorer",M,new p,ne,new L,{identityProvider:{getId:Z=>z(Z)?Z.pid.toString():(0,_.isRemoteDiagnosticError)(Z)?Z.hostName:H(Z)?"processes":I(Z)?Z.name:"header"}}),this.tree.setInput({processes:{processRoots:N}}),this.tree.layout(o.mainWindow.innerHeight,o.mainWindow.innerWidth),this.tree.onKeyDown(Z=>{const Y=new e.StandardKeyboardEvent(Z);if(Y.keyCode===s.KeyCode.KeyE&&Y.altKey){const te=this.getSelectedPids();Promise.all(te.map(fe=>this.nativeHostService.killProcess(fe,"SIGTERM"))).then(()=>this.tree?.refresh())}}),this.tree.onContextMenu(Z=>{z(Z.element)&&this.showContextMenu(Z.element,!0)}),M.style.height=`${o.mainWindow.innerHeight}px`,o.mainWindow.addEventListener("resize",()=>{M.style.height=`${o.mainWindow.innerHeight}px`,this.tree?.layout(o.mainWindow.innerHeight,o.mainWindow.innerWidth)})}isDebuggable(N){const M=c.exec(N);return M&&M.groups.port!=="0"||N.indexOf("node ")>=0||N.indexOf("node.exe")>=0}attachTo(N){const M={type:"node",request:"attach",name:`process ${N.pid}`};let $=c.exec(N.cmd);$?M.port=Number($.groups.port):M.processId=String(N.pid),$=h.exec(N.cmd),$&&(M.port=Number($.groups.port)),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[M]})}applyStyles(N){const M=(0,n.createStyleSheet)(),$=[];N.listFocusBackground&&($.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${N.listFocusBackground}; }`),$.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${N.listFocusBackground}; }`)),N.listFocusForeground&&$.push(`.monaco-list:focus .monaco-list-row.focused { color: ${N.listFocusForeground}; }`),N.listActiveSelectionBackground&&($.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${N.listActiveSelectionBackground}; }`),$.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${N.listActiveSelectionBackground}; }`)),N.listActiveSelectionForeground&&$.push(`.monaco-list:focus .monaco-list-row.selected { color: ${N.listActiveSelectionForeground}; }`),N.listHoverBackground&&$.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${N.listHoverBackground}; }`),N.listHoverForeground&&$.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${N.listHoverForeground}; }`),N.listFocusOutline&&$.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${N.listFocusOutline}; outline-offset: -1px; }`),N.listHoverOutline&&$.push(`.monaco-list-row:hover { outline: 1px dashed ${N.listHoverOutline}; outline-offset: -1px; }`),N.scrollbarShadowColor&&$.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${N.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),N.scrollbarSliderBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${N.scrollbarSliderBackgroundColor};
				}
			`),N.scrollbarSliderHoverBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${N.scrollbarSliderHoverBackgroundColor};
				}
			`),N.scrollbarSliderActiveBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${N.scrollbarSliderActiveBackgroundColor};
				}
			`),M.textContent=$.join(`
`),N.color&&(o.mainWindow.document.body.style.color=N.color)}showContextMenu(N,M){const $=[],ne=Number(N.pid);M&&($.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.nativeHostService.killProcess(ne,"SIGTERM")}}),$.push({label:(0,i.localize)(5,null),click:()=>{this.nativeHostService.killProcess(ne,"SIGKILL")}}),$.push({type:"separator"})),$.push({label:(0,i.localize)(6,null),click:()=>{const Z=this.getSelectedPids();Z?.includes(ne)||(Z.length=0,Z.push(ne));const Y=Z?.map(te=>o.mainWindow.document.getElementById(`pid-${te}`)).filter(te=>!!te);if(Y){const te=Y.map(fe=>fe.innerText).filter(fe=>!!fe);this.nativeHostService.writeClipboardText(te.join(`
`))}}}),$.push({label:(0,i.localize)(7,null),click:()=>{const Z=o.mainWindow.document.getElementById("process-list");Z&&this.nativeHostService.writeClipboardText(Z.innerText)}}),N&&M&&this.isDebuggable(N.cmd)&&($.push({type:"separator"}),$.push({label:(0,i.localize)(8,null),click:()=>{this.attachTo(N)}})),(0,T.popup)($)}requestProcessList(N){setTimeout(()=>{const M=Date.now(),$=N+M-this.lastRequestTime;this.lastRequestTime=M,$>1e3?(w.ipcRenderer.send("vscode:pidToNameRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList($)},200)}getSelectedPids(){return this.tree?.getSelection()?.map(N=>{if(!(!N||!("pid"in N)))return N.pid}).filter(N=>!!N)}}function v(){const x=(0,n.createStyleSheet)();x.id="codiconStyles";const N=(0,b.getIconsStyleSheet)(void 0);function M(){x.textContent=N.getCSS()}const $=new O.RunOnceScheduler(M,0);N.onDidChange(()=>$.schedule()),$.schedule()}function k(x){const N=x.data.platform==="win32"?"windows":x.data.platform==="linux"?"linux":"mac";o.mainWindow.document.body.classList.add(N),v(),(0,m.applyZoom)(x.data.zoomLevel,o.mainWindow),new U(x.windowId,x.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d98c6de73fb939f1eb4b8a500c569b858b2d297/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
