/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],oe=function(H){for(var t=[],b=0,D=H.length;b<D;b++)t[b]=se[H[b]];return t};define(se[75],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LoaderStats=t.LoaderEventType=t.isESM=void 0,t.isESM=!1;var b;(function(y){y[y.LoaderAvailable=1]="LoaderAvailable",y[y.BeginLoadingScript=10]="BeginLoadingScript",y[y.EndLoadingScriptOK=11]="EndLoadingScriptOK",y[y.EndLoadingScriptError=12]="EndLoadingScriptError",y[y.BeginInvokeFactory=21]="BeginInvokeFactory",y[y.EndInvokeFactory=22]="EndInvokeFactory",y[y.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",y[y.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",y[y.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",y[y.NodeEndNativeRequire=34]="NodeEndNativeRequire",y[y.CachedDataFound=60]="CachedDataFound",y[y.CachedDataMissed=61]="CachedDataMissed",y[y.CachedDataRejected=62]="CachedDataRejected",y[y.CachedDataCreated=63]="CachedDataCreated"})(b||(t.LoaderEventType=b={}));class D{static get(){const R=new Map,L=new Map,C=new Map,p=new Map;function l(S,T){S.has(T.detail)||S.set(T.detail,-T.timestamp)}function a(S,T){const g=S.get(T.detail);g&&(g>=0||S.set(T.detail,g+T.timestamp))}let c=[];typeof H=="function"&&typeof H.getStats=="function"&&(c=H.getStats().slice(0).sort((S,T)=>S.timestamp-T.timestamp));for(const S of c)switch(S.type){case b.BeginLoadingScript:l(R,S);break;case b.EndLoadingScriptOK:case b.EndLoadingScriptError:a(R,S);break;case b.BeginInvokeFactory:l(L,S);break;case b.EndInvokeFactory:a(L,S);break;case b.NodeBeginNativeRequire:l(C,S);break;case b.NodeEndNativeRequire:a(C,S);break;case b.NodeBeginEvaluatingScript:l(p,S);break;case b.NodeEndEvaluatingScript:a(p,S);break}let h=0;C.forEach(S=>h+=S);function m(S){const T=[];return S.forEach((g,d)=>T.push([d,g])),T}return{amdLoad:m(R),amdInvoke:m(L),nodeRequire:m(C),nodeEval:m(p),nodeRequireTotal:h}}static toMarkdownTable(R,L){let C="";const p=[];return R.forEach((l,a)=>{p[a]=l.length}),L.forEach(l=>{l.forEach((a,c)=>{typeof a>"u"&&(a=l[c]="-");const h=a.toString().length;p[c]=Math.max(h,p[c])})}),R.forEach((l,a)=>{C+=`| ${l+" ".repeat(p[a]-l.toString().length)} `}),C+=`|
`,R.forEach((l,a)=>{C+=`| ${"-".repeat(p[a])} `}),C+=`|
`,L.forEach(l=>{l.forEach((a,c)=>{typeof a<"u"&&(C+=`| ${a+" ".repeat(p[c]-a.toString().length)} `)}),C+=`|
`}),C}}t.LoaderStats=D}),define(se[55],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.memoize=D,t.debounce=y,t.throttle=R;function b(L){return(C,p,l)=>{let a=null,c=null;if(typeof l.value=="function"?(a="value",c=l.value):typeof l.get=="function"&&(a="get",c=l.get),!c)throw new Error("not supported");l[a]=L(c,p)}}function D(L,C,p){let l=null,a=null;if(typeof p.value=="function"?(l="value",a=p.value,a.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(l="get",a=p.get),!a)throw new Error("not supported");const c=`$memoize$${C}`;p[l]=function(...h){return this.hasOwnProperty(c)||Object.defineProperty(this,c,{configurable:!1,enumerable:!1,writable:!1,value:a.apply(this,h)}),this[c]}}function y(L,C,p){return b((l,a)=>{const c=`$debounce$${a}`,h=`$debounce$result$${a}`;return function(...m){this[h]||(this[h]=p?p():void 0),clearTimeout(this[c]),C&&(this[h]=C(this[h],...m),m=[this[h]]),this[c]=setTimeout(()=>{l.apply(this,m),this[h]=p?p():void 0},L)}})}function R(L,C,p){return b((l,a)=>{const c=`$throttle$timer$${a}`,h=`$throttle$result$${a}`,m=`$throttle$lastRun$${a}`,S=`$throttle$pending$${a}`;return function(...T){if(this[h]||(this[h]=p?p():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),C&&(this[h]=C(this[h],...T)),this[S])return;const g=this[m]+L;g<=Date.now()?(this[m]=Date.now(),l.apply(this,[this[h]]),this[h]=p?p():void 0):(this[S]=!0,this[c]=setTimeout(()=>{this[S]=!1,this[m]=Date.now(),l.apply(this,[this[h]]),this[h]=p?p():void 0},g-Date.now()))}})}}),define(se[76],oe([0,1,9]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=D,t.assertNever=y,t.assert=R,t.softAssert=L,t.assertFn=C,t.checkAdjacentItems=p;function D(l,a){if(!l)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}function y(l,a="Unreachable"){throw new Error(a)}function R(l,a="unexpected state"){if(!l)throw new b.BugIndicatingError(`Assertion Failed: ${a}`)}function L(l){l||(0,b.onUnexpectedError)(new b.BugIndicatingError("Soft Assertion Failed"))}function C(l){if(!l()){debugger;l(),(0,b.onUnexpectedError)(new b.BugIndicatingError("Assertion Failed"))}}function p(l,a){let c=0;for(;c<l.length-1;){const h=l[c],m=l[c+1];if(!a(h,m))return!1;c++}return!0}}),define(se[34],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,t.createScanner=L,t.getLocation=c,t.parse=h,t.parseTree=m,t.findNodeAtLocation=S,t.getNodePath=T,t.getNodeValue=g,t.contains=d,t.findNodeAtOffset=v,t.visit=P,t.stripComments=E,t.getNodeType=u;var b;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(b||(t.ScanError=b={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D||(t.SyntaxKind=D={}));var y;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(y||(t.ParseErrorCode=y={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R||(t.ParseOptions=R={}));function L(i,o=!1){let r=0;const e=i.length;let n="",s=0,f=D.Unknown,I=b.None;function O(ie){let ce=0,ue=0;for(;ce<ie;){const le=i.charCodeAt(r);if(le>=a._0&&le<=a._9)ue=ue*16+le-a._0;else if(le>=a.A&&le<=a.F)ue=ue*16+le-a.A+10;else if(le>=a.a&&le<=a.f)ue=ue*16+le-a.a+10;else break;r++,ce++}return ce<ie&&(ue=-1),ue}function N(ie){r=ie,n="",s=0,f=D.Unknown,I=b.None}function k(){const ie=r;if(i.charCodeAt(r)===a._0)r++;else for(r++;r<i.length&&l(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===a.dot)if(r++,r<i.length&&l(i.charCodeAt(r)))for(r++;r<i.length&&l(i.charCodeAt(r));)r++;else return I=b.UnexpectedEndOfNumber,i.substring(ie,r);let ce=r;if(r<i.length&&(i.charCodeAt(r)===a.E||i.charCodeAt(r)===a.e))if(r++,(r<i.length&&i.charCodeAt(r)===a.plus||i.charCodeAt(r)===a.minus)&&r++,r<i.length&&l(i.charCodeAt(r))){for(r++;r<i.length&&l(i.charCodeAt(r));)r++;ce=r}else I=b.UnexpectedEndOfNumber;return i.substring(ie,ce)}function F(){let ie="",ce=r;for(;;){if(r>=e){ie+=i.substring(ce,r),I=b.UnexpectedEndOfString;break}const ue=i.charCodeAt(r);if(ue===a.doubleQuote){ie+=i.substring(ce,r),r++;break}if(ue===a.backslash){if(ie+=i.substring(ce,r),r++,r>=e){I=b.UnexpectedEndOfString;break}switch(i.charCodeAt(r++)){case a.doubleQuote:ie+='"';break;case a.backslash:ie+="\\";break;case a.slash:ie+="/";break;case a.b:ie+="\b";break;case a.f:ie+="\f";break;case a.n:ie+=`
`;break;case a.r:ie+="\r";break;case a.t:ie+="	";break;case a.u:{const B=O(4);B>=0?ie+=String.fromCharCode(B):I=b.InvalidUnicode;break}default:I=b.InvalidEscapeCharacter}ce=r;continue}if(ue>=0&&ue<=31)if(p(ue)){ie+=i.substring(ce,r),I=b.UnexpectedEndOfString;break}else I=b.InvalidCharacter;r++}return ie}function _(){if(n="",I=b.None,s=r,r>=e)return s=e,f=D.EOF;let ie=i.charCodeAt(r);if(C(ie)){do r++,n+=String.fromCharCode(ie),ie=i.charCodeAt(r);while(C(ie));return f=D.Trivia}if(p(ie))return r++,n+=String.fromCharCode(ie),ie===a.carriageReturn&&i.charCodeAt(r)===a.lineFeed&&(r++,n+=`
`),f=D.LineBreakTrivia;switch(ie){case a.openBrace:return r++,f=D.OpenBraceToken;case a.closeBrace:return r++,f=D.CloseBraceToken;case a.openBracket:return r++,f=D.OpenBracketToken;case a.closeBracket:return r++,f=D.CloseBracketToken;case a.colon:return r++,f=D.ColonToken;case a.comma:return r++,f=D.CommaToken;case a.doubleQuote:return r++,n=F(),f=D.StringLiteral;case a.slash:{const ce=r-1;if(i.charCodeAt(r+1)===a.slash){for(r+=2;r<e&&!p(i.charCodeAt(r));)r++;return n=i.substring(ce,r),f=D.LineCommentTrivia}if(i.charCodeAt(r+1)===a.asterisk){r+=2;const ue=e-1;let le=!1;for(;r<ue;){if(i.charCodeAt(r)===a.asterisk&&i.charCodeAt(r+1)===a.slash){r+=2,le=!0;break}r++}return le||(r++,I=b.UnexpectedEndOfComment),n=i.substring(ce,r),f=D.BlockCommentTrivia}return n+=String.fromCharCode(ie),r++,f=D.Unknown}case a.minus:if(n+=String.fromCharCode(ie),r++,r===e||!l(i.charCodeAt(r)))return f=D.Unknown;case a._0:case a._1:case a._2:case a._3:case a._4:case a._5:case a._6:case a._7:case a._8:case a._9:return n+=k(),f=D.NumericLiteral;default:for(;r<e&&K(ie);)r++,ie=i.charCodeAt(r);if(s!==r){switch(n=i.substring(s,r),n){case"true":return f=D.TrueKeyword;case"false":return f=D.FalseKeyword;case"null":return f=D.NullKeyword}return f=D.Unknown}return n+=String.fromCharCode(ie),r++,f=D.Unknown}}function K(ie){if(C(ie)||p(ie))return!1;switch(ie){case a.closeBrace:case a.closeBracket:case a.openBrace:case a.openBracket:case a.doubleQuote:case a.colon:case a.comma:case a.slash:return!1}return!0}function ae(){let ie;do ie=_();while(ie>=D.LineCommentTrivia&&ie<=D.Trivia);return ie}return{setPosition:N,getPosition:()=>r,scan:o?ae:_,getToken:()=>f,getTokenValue:()=>n,getTokenOffset:()=>s,getTokenLength:()=>r-s,getTokenError:()=>I}}function C(i){return i===a.space||i===a.tab||i===a.verticalTab||i===a.formFeed||i===a.nonBreakingSpace||i===a.ogham||i>=a.enQuad&&i<=a.zeroWidthSpace||i===a.narrowNoBreakSpace||i===a.mathematicalSpace||i===a.ideographicSpace||i===a.byteOrderMark}function p(i){return i===a.lineFeed||i===a.carriageReturn||i===a.lineSeparator||i===a.paragraphSeparator}function l(i){return i>=a._0&&i<=a._9}var a;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(a||(a={}));function c(i,o){const r=[],e=new Object;let n;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function I(O,N,k,F){s.value=O,s.offset=N,s.length=k,s.type=F,s.colonOffset=void 0,n=s}try{P(i,{onObjectBegin:(O,N)=>{if(o<=O)throw e;n=void 0,f=o>O,r.push("")},onObjectProperty:(O,N,k)=>{if(o<N||(I(O,N,k,"property"),r[r.length-1]=O,o<=N+k))throw e},onObjectEnd:(O,N)=>{if(o<=O)throw e;n=void 0,r.pop()},onArrayBegin:(O,N)=>{if(o<=O)throw e;n=void 0,r.push(0)},onArrayEnd:(O,N)=>{if(o<=O)throw e;n=void 0,r.pop()},onLiteralValue:(O,N,k)=>{if(o<N||(I(O,N,k,u(O)),o<=N+k))throw e},onSeparator:(O,N,k)=>{if(o<=N)throw e;if(O===":"&&n&&n.type==="property")n.colonOffset=N,f=!1,n=void 0;else if(O===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(f=!0,r[r.length-1]=""),n=void 0}}})}catch(O){if(O!==e)throw O}return{path:r,previousNode:n,isAtPropertyKey:f,matches:O=>{let N=0;for(let k=0;N<O.length&&k<r.length;k++)if(O[N]===r[k]||O[N]==="*")N++;else if(O[N]!=="**")return!1;return N===O.length}}}function h(i,o=[],r=R.DEFAULT){let e=null,n=[];const s=[];function f(O){Array.isArray(n)?n.push(O):e!==null&&(n[e]=O)}return P(i,{onObjectBegin:()=>{const O={};f(O),s.push(n),n=O,e=null},onObjectProperty:O=>{e=O},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const O=[];f(O),s.push(n),n=O,e=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:f,onError:(O,N,k)=>{o.push({error:O,offset:N,length:k})}},r),n[0]}function m(i,o=[],r=R.DEFAULT){let e={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(O){e.type==="property"&&(e.length=O-e.offset,e=e.parent)}function s(O){return e.children.push(O),O}P(i,{onObjectBegin:O=>{e=s({type:"object",offset:O,length:-1,parent:e,children:[]})},onObjectProperty:(O,N,k)=>{e=s({type:"property",offset:N,length:-1,parent:e,children:[]}),e.children.push({type:"string",value:O,offset:N,length:k,parent:e})},onObjectEnd:(O,N)=>{e.length=O+N-e.offset,e=e.parent,n(O+N)},onArrayBegin:(O,N)=>{e=s({type:"array",offset:O,length:-1,parent:e,children:[]})},onArrayEnd:(O,N)=>{e.length=O+N-e.offset,e=e.parent,n(O+N)},onLiteralValue:(O,N,k)=>{s({type:u(O),offset:N,length:k,parent:e,value:O}),n(N+k)},onSeparator:(O,N,k)=>{e.type==="property"&&(O===":"?e.colonOffset=N:O===","&&n(N))},onError:(O,N,k)=>{o.push({error:O,offset:N,length:k})}},r);const I=e.children[0];return I&&delete I.parent,I}function S(i,o){if(!i)return;let r=i;for(const e of o)if(typeof e=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const s of r.children)if(Array.isArray(s.children)&&s.children[0].value===e){r=s.children[1],n=!0;break}if(!n)return}else{const n=e;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}function T(i){if(!i.parent||!i.parent.children)return[];const o=T(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;o.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&o.push(r)}return o}function g(i){switch(i.type){case"array":return i.children.map(g);case"object":{const o=Object.create(null);for(const r of i.children){const e=r.children[1];e&&(o[r.children[0].value]=g(e))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function d(i,o,r=!1){return o>=i.offset&&o<i.offset+i.length||r&&o===i.offset+i.length}function v(i,o,r=!1){if(d(i,o,r)){const e=i.children;if(Array.isArray(e))for(let n=0;n<e.length&&e[n].offset<=o;n++){const s=v(e[n],o,r);if(s)return s}return i}}function P(i,o,r=R.DEFAULT){const e=L(i,!1);function n(Q){return Q?()=>Q(e.getTokenOffset(),e.getTokenLength()):()=>!0}function s(Q){return Q?U=>Q(U,e.getTokenOffset(),e.getTokenLength()):()=>!0}const f=n(o.onObjectBegin),I=s(o.onObjectProperty),O=n(o.onObjectEnd),N=n(o.onArrayBegin),k=n(o.onArrayEnd),F=s(o.onLiteralValue),_=s(o.onSeparator),K=n(o.onComment),ae=s(o.onError),ie=r&&r.disallowComments,ce=r&&r.allowTrailingComma;function ue(){for(;;){const Q=e.scan();switch(e.getTokenError()){case b.InvalidUnicode:le(y.InvalidUnicode);break;case b.InvalidEscapeCharacter:le(y.InvalidEscapeCharacter);break;case b.UnexpectedEndOfNumber:le(y.UnexpectedEndOfNumber);break;case b.UnexpectedEndOfComment:ie||le(y.UnexpectedEndOfComment);break;case b.UnexpectedEndOfString:le(y.UnexpectedEndOfString);break;case b.InvalidCharacter:le(y.InvalidCharacter);break}switch(Q){case D.LineCommentTrivia:case D.BlockCommentTrivia:ie?le(y.InvalidCommentToken):K();break;case D.Unknown:le(y.InvalidSymbol);break;case D.Trivia:case D.LineBreakTrivia:break;default:return Q}}}function le(Q,U=[],W=[]){if(ae(Q),U.length+W.length>0){let q=e.getToken();for(;q!==D.EOF;){if(U.indexOf(q)!==-1){ue();break}else if(W.indexOf(q)!==-1)break;q=ue()}}}function B(Q){const U=e.getTokenValue();return Q?F(U):I(U),ue(),!0}function Z(){switch(e.getToken()){case D.NumericLiteral:{let Q=0;try{Q=JSON.parse(e.getTokenValue()),typeof Q!="number"&&(le(y.InvalidNumberFormat),Q=0)}catch{le(y.InvalidNumberFormat)}F(Q);break}case D.NullKeyword:F(null);break;case D.TrueKeyword:F(!0);break;case D.FalseKeyword:F(!1);break;default:return!1}return ue(),!0}function z(){return e.getToken()!==D.StringLiteral?(le(y.PropertyNameExpected,[],[D.CloseBraceToken,D.CommaToken]),!1):(B(!1),e.getToken()===D.ColonToken?(_(":"),ue(),J()||le(y.ValueExpected,[],[D.CloseBraceToken,D.CommaToken])):le(y.ColonExpected,[],[D.CloseBraceToken,D.CommaToken]),!0)}function M(){f(),ue();let Q=!1;for(;e.getToken()!==D.CloseBraceToken&&e.getToken()!==D.EOF;){if(e.getToken()===D.CommaToken){if(Q||le(y.ValueExpected,[],[]),_(","),ue(),e.getToken()===D.CloseBraceToken&&ce)break}else Q&&le(y.CommaExpected,[],[]);z()||le(y.ValueExpected,[],[D.CloseBraceToken,D.CommaToken]),Q=!0}return O(),e.getToken()!==D.CloseBraceToken?le(y.CloseBraceExpected,[D.CloseBraceToken],[]):ue(),!0}function G(){N(),ue();let Q=!1;for(;e.getToken()!==D.CloseBracketToken&&e.getToken()!==D.EOF;){if(e.getToken()===D.CommaToken){if(Q||le(y.ValueExpected,[],[]),_(","),ue(),e.getToken()===D.CloseBracketToken&&ce)break}else Q&&le(y.CommaExpected,[],[]);J()||le(y.ValueExpected,[],[D.CloseBracketToken,D.CommaToken]),Q=!0}return k(),e.getToken()!==D.CloseBracketToken?le(y.CloseBracketExpected,[D.CloseBracketToken],[]):ue(),!0}function J(){switch(e.getToken()){case D.OpenBracketToken:return G();case D.OpenBraceToken:return M();case D.StringLiteral:return B(!0);default:return Z()}}return ue(),e.getToken()===D.EOF?r.allowEmptyContent?!0:(le(y.ValueExpected,[],[]),!1):J()?(e.getToken()!==D.EOF&&le(y.EndOfFileExpected,[],[]),!0):(le(y.ValueExpected,[],[]),!1)}function E(i,o){const r=L(i),e=[];let n,s=0,f;do switch(f=r.getPosition(),n=r.scan(),n){case D.LineCommentTrivia:case D.BlockCommentTrivia:case D.EOF:s!==f&&e.push(i.substring(s,f)),o!==void 0&&e.push(r.getTokenValue().replace(/[^\r\n]/g,o)),s=r.getPosition();break}while(n!==D.EOF);return e.join("")}function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[77],oe([0,1,34]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.format=D,t.toFormattedString=y,t.getEOL=C,t.isEOL=p;function D(l,a,c){let h,m,S,T,g;if(a){for(T=a.offset,g=T+a.length,S=T;S>0&&!p(l,S-1);)S--;let f=g;for(;f<l.length&&!p(l,f);)f++;m=l.substring(S,f),h=L(m,c)}else m=l,h=0,S=0,T=0,g=l.length;const d=C(c,l);let v=!1,P=0,E;c.insertSpaces?E=R(" ",c.tabSize||4):E="	";const u=(0,b.createScanner)(m,!1);let i=!1;function o(){return d+R(E,h+P)}function r(){let f=u.scan();for(v=!1;f===b.SyntaxKind.Trivia||f===b.SyntaxKind.LineBreakTrivia;)v=v||f===b.SyntaxKind.LineBreakTrivia,f=u.scan();return i=f===b.SyntaxKind.Unknown||u.getTokenError()!==b.ScanError.None,f}const e=[];function n(f,I,O){!i&&I<g&&O>T&&l.substring(I,O)!==f&&e.push({offset:I,length:O-I,content:f})}let s=r();if(s!==b.SyntaxKind.EOF){const f=u.getTokenOffset()+S,I=R(E,h);n(I,S,f)}for(;s!==b.SyntaxKind.EOF;){let f=u.getTokenOffset()+u.getTokenLength()+S,I=r(),O="";for(;!v&&(I===b.SyntaxKind.LineCommentTrivia||I===b.SyntaxKind.BlockCommentTrivia);){const k=u.getTokenOffset()+S;n(" ",f,k),f=u.getTokenOffset()+u.getTokenLength()+S,O=I===b.SyntaxKind.LineCommentTrivia?o():"",I=r()}if(I===b.SyntaxKind.CloseBraceToken)s!==b.SyntaxKind.OpenBraceToken&&(P--,O=o());else if(I===b.SyntaxKind.CloseBracketToken)s!==b.SyntaxKind.OpenBracketToken&&(P--,O=o());else{switch(s){case b.SyntaxKind.OpenBracketToken:case b.SyntaxKind.OpenBraceToken:P++,O=o();break;case b.SyntaxKind.CommaToken:case b.SyntaxKind.LineCommentTrivia:O=o();break;case b.SyntaxKind.BlockCommentTrivia:v?O=o():O=" ";break;case b.SyntaxKind.ColonToken:O=" ";break;case b.SyntaxKind.StringLiteral:if(I===b.SyntaxKind.ColonToken){O="";break}case b.SyntaxKind.NullKeyword:case b.SyntaxKind.TrueKeyword:case b.SyntaxKind.FalseKeyword:case b.SyntaxKind.NumericLiteral:case b.SyntaxKind.CloseBraceToken:case b.SyntaxKind.CloseBracketToken:I===b.SyntaxKind.LineCommentTrivia||I===b.SyntaxKind.BlockCommentTrivia?O=" ":I!==b.SyntaxKind.CommaToken&&I!==b.SyntaxKind.EOF&&(i=!0);break;case b.SyntaxKind.Unknown:i=!0;break}v&&(I===b.SyntaxKind.LineCommentTrivia||I===b.SyntaxKind.BlockCommentTrivia)&&(O=o())}const N=u.getTokenOffset()+S;n(O,f,N),s=I}return e}function y(l,a){const c=JSON.stringify(l,void 0,a.insertSpaces?a.tabSize||4:"	");return a.eol!==void 0?c.replace(/\r\n|\r|\n/g,a.eol):c}function R(l,a){let c="";for(let h=0;h<a;h++)c+=l;return c}function L(l,a){let c=0,h=0;const m=a.tabSize||4;for(;c<l.length;){const S=l.charAt(c);if(S===" ")h++;else if(S==="	")h+=m;else break;c++}return Math.floor(h/m)}function C(l,a){for(let c=0;c<a.length;c++){const h=a.charAt(c);if(h==="\r")return c+1<a.length&&a.charAt(c+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return l&&l.eol||`
`}function p(l,a){return`\r
`.indexOf(l.charAt(a))!==-1}}),define(se[78],oe([0,1,34,77]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeProperty=y,t.setProperty=R,t.withFormatting=L,t.applyEdit=C,t.applyEdits=p;function y(l,a,c){return R(l,a,void 0,c)}function R(l,a,c,h,m){const S=a.slice(),T=[],g=(0,b.parseTree)(l,T);let d,v;for(;S.length>0&&(v=S.pop(),d=(0,b.findNodeAtLocation)(g,S),d===void 0&&c!==void 0);)typeof v=="string"?c={[v]:c}:c=[c];if(d)if(d.type==="object"&&typeof v=="string"&&Array.isArray(d.children)){const P=(0,b.findNodeAtLocation)(d,[v]);if(P!==void 0)if(c===void 0){if(!P.parent)throw new Error("Malformed AST");const E=d.children.indexOf(P.parent);let u,i=P.parent.offset+P.parent.length;if(E>0){const o=d.children[E-1];u=o.offset+o.length}else u=d.offset+1,d.children.length>1&&(i=d.children[1].offset);return L(l,{offset:u,length:i-u,content:""},h)}else return L(l,{offset:P.offset,length:P.length,content:JSON.stringify(c)},h);else{if(c===void 0)return[];const E=`${JSON.stringify(v)}: ${JSON.stringify(c)}`,u=m?m(d.children.map(o=>o.children[0].value)):d.children.length;let i;if(u>0){const o=d.children[u-1];i={offset:o.offset+o.length,length:0,content:","+E}}else d.children.length===0?i={offset:d.offset+1,length:0,content:E}:i={offset:d.offset+1,length:0,content:E+","};return L(l,i,h)}}else if(d.type==="array"&&typeof v=="number"&&Array.isArray(d.children))if(c!==void 0){const P=`${JSON.stringify(c)}`;let E;if(d.children.length===0||v===0)E={offset:d.offset+1,length:0,content:d.children.length===0?P:P+","};else{const u=v===-1||v>d.children.length?d.children.length:v,i=d.children[u-1];E={offset:i.offset+i.length,length:0,content:","+P}}return L(l,E,h)}else{const P=v,E=d.children[P];let u;if(d.children.length===1)u={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===P){const i=d.children[P-1],o=i.offset+i.length,r=d.offset+d.length;u={offset:o,length:r-2-o,content:""}}else u={offset:E.offset,length:d.children[P+1].offset-E.offset,content:""};return L(l,u,h)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${d.type}`);else return c===void 0?[]:L(l,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(c)},h)}function L(l,a,c){let h=C(l,a),m=a.offset,S=a.offset+a.content.length;if(a.length===0||a.content.length===0){for(;m>0&&!(0,D.isEOL)(h,m-1);)m--;for(;S<h.length&&!(0,D.isEOL)(h,S);)S++}const T=(0,D.format)(h,{offset:m,length:S-m},c);for(let d=T.length-1;d>=0;d--){const v=T[d];h=C(h,v),m=Math.min(m,v.offset),S=Math.max(S,v.offset+v.length),S+=v.content.length-v.length}const g=l.length-(h.length-S)-m;return[{offset:m,length:g,content:h.substring(m,S)}]}function C(l,a){return l.substring(0,a.offset)+a.content+l.substring(a.offset+a.length)}function p(l,a){const c=a.slice(0).sort((m,S)=>{const T=m.offset-S.offset;return T===0?m.length-S.length:T});let h=l.length;for(let m=c.length-1;m>=0;m--){const S=c[m];if(S.offset+S.length<=h)l=C(l,S);else throw new Error("Overlapping edit");h=S.offset}return l}}),define(se[79],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=void 0,t.clamp=b,t.rot=D;function b(C,p,l){return Math.min(Math.max(C,p),l)}function D(C,p){return(p+C%p)%p}class y{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=y;class R{constructor(){this._n=1,this._val=0}update(p){return this._val=this._val+(p-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=R;class L{constructor(p){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(p),this._values.fill(0,0,p)}update(p){const l=this._values[this._index];return this._values[this._index]=p,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=p,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=L}),function(){function H(y){const R=[];typeof y=="number"&&R.push("code/timeOrigin",y);function L(p){R.push(p,Date.now())}function C(){const p=[];for(let l=0;l<R.length;l+=2)p.push({name:R[l],startTime:R[l+1]});return p}return{mark:L,getMarks:C}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(y+L.startTime)});return R}};if(typeof process=="object"){const y=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function b(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=t()),y.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=b(D))}(),function(H,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var b=t();for(var D in b)(typeof exports=="object"?exports:H)[D]=b[D]}}(typeof self<"u"?self:this,function(){return function(H){var t={};function b(D){if(t[D])return t[D].exports;var y=t[D]={i:D,l:!1,exports:{}};return H[D].call(y.exports,y,y.exports,b),y.l=!0,y.exports}return b.m=H,b.c=t,b.d=function(D,y,R){b.o(D,y)||Object.defineProperty(D,y,{enumerable:!0,get:R})},b.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},b.t=function(D,y){if(1&y&&(D=b(D)),8&y||4&y&&typeof D=="object"&&D&&D.__esModule)return D;var R=Object.create(null);if(b.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:D}),2&y&&typeof D!="string")for(var L in D)b.d(R,L,function(C){return D[C]}.bind(null,L));return R},b.n=function(D){var y=D&&D.__esModule?function(){return D.default}:function(){return D};return b.d(y,"a",y),y},b.o=function(D,y){return Object.prototype.hasOwnProperty.call(D,y)},b.p="",b(b.s=0)}([function(H,t,b){(function(D){var y;t=H.exports=W,y=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,C=t.re=[],p=t.src=[],l=0,a=l++;p[a]="0|[1-9]\\d*";var c=l++;p[c]="[0-9]+";var h=l++;p[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=l++;p[m]="("+p[a]+")\\.("+p[a]+")\\.("+p[a]+")";var S=l++;p[S]="("+p[c]+")\\.("+p[c]+")\\.("+p[c]+")";var T=l++;p[T]="(?:"+p[a]+"|"+p[h]+")";var g=l++;p[g]="(?:"+p[c]+"|"+p[h]+")";var d=l++;p[d]="(?:-("+p[T]+"(?:\\."+p[T]+")*))";var v=l++;p[v]="(?:-?("+p[g]+"(?:\\."+p[g]+")*))";var P=l++;p[P]="[0-9A-Za-z-]+";var E=l++;p[E]="(?:\\+("+p[P]+"(?:\\."+p[P]+")*))";var u=l++,i="v?"+p[m]+p[d]+"?"+p[E]+"?";p[u]="^"+i+"$";var o="[v=\\s]*"+p[S]+p[v]+"?"+p[E]+"?",r=l++;p[r]="^"+o+"$";var e=l++;p[e]="((?:<|>)?=?)";var n=l++;p[n]=p[c]+"|x|X|\\*";var s=l++;p[s]=p[a]+"|x|X|\\*";var f=l++;p[f]="[v=\\s]*("+p[s]+")(?:\\.("+p[s]+")(?:\\.("+p[s]+")(?:"+p[d]+")?"+p[E]+"?)?)?";var I=l++;p[I]="[v=\\s]*("+p[n]+")(?:\\.("+p[n]+")(?:\\.("+p[n]+")(?:"+p[v]+")?"+p[E]+"?)?)?";var O=l++;p[O]="^"+p[e]+"\\s*"+p[f]+"$";var N=l++;p[N]="^"+p[e]+"\\s*"+p[I]+"$";var k=l++;p[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=l++;p[F]="(?:~>?)";var _=l++;p[_]="(\\s*)"+p[F]+"\\s+",C[_]=new RegExp(p[_],"g");var K=l++;p[K]="^"+p[F]+p[f]+"$";var ae=l++;p[ae]="^"+p[F]+p[I]+"$";var ie=l++;p[ie]="(?:\\^)";var ce=l++;p[ce]="(\\s*)"+p[ie]+"\\s+",C[ce]=new RegExp(p[ce],"g");var ue=l++;p[ue]="^"+p[ie]+p[f]+"$";var le=l++;p[le]="^"+p[ie]+p[I]+"$";var B=l++;p[B]="^"+p[e]+"\\s*("+o+")$|^$";var Z=l++;p[Z]="^"+p[e]+"\\s*("+i+")$|^$";var z=l++;p[z]="(\\s*)"+p[e]+"\\s*("+o+"|"+p[f]+")",C[z]=new RegExp(p[z],"g");var M=l++;p[M]="^\\s*("+p[f]+")\\s+-\\s+("+p[f]+")\\s*$";var G=l++;p[G]="^\\s*("+p[I]+")\\s+-\\s+("+p[I]+")\\s*$";var J=l++;p[J]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)y(Q,p[Q]),C[Q]||(C[Q]=new RegExp(p[Q]));function U(j,ee){if(j instanceof W)return j;if(typeof j!="string"||j.length>R||!(ee?C[r]:C[u]).test(j))return null;try{return new W(j,ee)}catch{return null}}function W(j,ee){if(j instanceof W){if(j.loose===ee)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof W))return new W(j,ee);y("SemVer",j,ee),this.loose=ee;var te=j.trim().match(ee?C[r]:C[u]);if(!te)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var we=+pe;if(we>=0&&we<L)return we}return pe}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}t.parse=U,t.valid=function(j,ee){var te=U(j,ee);return te?te.version:null},t.clean=function(j,ee){var te=U(j.trim().replace(/^[=v]+/,""),ee);return te?te.version:null},t.SemVer=W,W.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},W.prototype.toString=function(){return this.version},W.prototype.compare=function(j){return y("SemVer.compare",this.version,this.loose,j),j instanceof W||(j=new W(j,this.loose)),this.compareMain(j)||this.comparePre(j)},W.prototype.compareMain=function(j){return j instanceof W||(j=new W(j,this.loose)),$(this.major,j.major)||$(this.minor,j.minor)||$(this.patch,j.patch)},W.prototype.comparePre=function(j){if(j instanceof W||(j=new W(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var ee=0;do{var te=this.prerelease[ee],pe=j.prerelease[ee];if(y("prerelease compare",ee,te,pe),te===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(te===void 0)return-1;if(te!==pe)return $(te,pe)}while(++ee)},W.prototype.inc=function(j,ee){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},t.inc=function(j,ee,te,pe){typeof te=="string"&&(pe=te,te=void 0);try{return new W(j,te).inc(ee,pe).version}catch{return null}},t.diff=function(j,ee){if(V(j,ee))return null;var te=U(j),pe=U(ee);if(te.prerelease.length||pe.prerelease.length){for(var we in te)if((we==="major"||we==="minor"||we==="patch")&&te[we]!==pe[we])return"pre"+we;return"prerelease"}for(var we in te)if((we==="major"||we==="minor"||we==="patch")&&te[we]!==pe[we])return we},t.compareIdentifiers=$;var q=/^[0-9]+$/;function $(j,ee){var te=q.test(j),pe=q.test(ee);return te&&pe&&(j=+j,ee=+ee),te&&!pe?-1:pe&&!te?1:j<ee?-1:j>ee?1:0}function w(j,ee,te){return new W(j,te).compare(new W(ee,te))}function A(j,ee,te){return w(j,ee,te)>0}function x(j,ee,te){return w(j,ee,te)<0}function V(j,ee,te){return w(j,ee,te)===0}function Y(j,ee,te){return w(j,ee,te)!==0}function X(j,ee,te){return w(j,ee,te)>=0}function ne(j,ee,te){return w(j,ee,te)<=0}function he(j,ee,te,pe){var we;switch(ee){case"===":typeof j=="object"&&(j=j.version),typeof te=="object"&&(te=te.version),we=j===te;break;case"!==":typeof j=="object"&&(j=j.version),typeof te=="object"&&(te=te.version),we=j!==te;break;case"":case"=":case"==":we=V(j,te,pe);break;case"!=":we=Y(j,te,pe);break;case">":we=A(j,te,pe);break;case">=":we=X(j,te,pe);break;case"<":we=x(j,te,pe);break;case"<=":we=ne(j,te,pe);break;default:throw new TypeError("Invalid operator: "+ee)}return we}function fe(j,ee){if(j instanceof fe){if(j.loose===ee)return j;j=j.value}if(!(this instanceof fe))return new fe(j,ee);y("comparator",j,ee),this.loose=ee,this.parse(j),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}t.rcompareIdentifiers=function(j,ee){return $(ee,j)},t.major=function(j,ee){return new W(j,ee).major},t.minor=function(j,ee){return new W(j,ee).minor},t.patch=function(j,ee){return new W(j,ee).patch},t.compare=w,t.compareLoose=function(j,ee){return w(j,ee,!0)},t.rcompare=function(j,ee,te){return w(ee,j,te)},t.sort=function(j,ee){return j.sort(function(te,pe){return t.compare(te,pe,ee)})},t.rsort=function(j,ee){return j.sort(function(te,pe){return t.rcompare(te,pe,ee)})},t.gt=A,t.lt=x,t.eq=V,t.neq=Y,t.gte=X,t.lte=ne,t.cmp=he,t.Comparator=fe;var ye={};function me(j,ee){if(j instanceof me)return j.loose===ee?j:new me(j.raw,ee);if(j instanceof fe)return new me(j.value,ee);if(!(this instanceof me))return new me(j,ee);if(this.loose=ee,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function ge(j){return!j||j.toLowerCase()==="x"||j==="*"}function de(j,ee,te,pe,we,Le,be,Ne,De,ke,Me,Te,Ae){return((ee=ge(te)?"":ge(pe)?">="+te+".0.0":ge(we)?">="+te+"."+pe+".0":">="+ee)+" "+(Ne=ge(De)?"":ge(ke)?"<"+(+De+1)+".0.0":ge(Me)?"<"+De+"."+(+ke+1)+".0":Te?"<="+De+"."+ke+"."+Me+"-"+Te:"<="+Ne)).trim()}function ve(j,ee){for(var te=0;te<j.length;te++)if(!j[te].test(ee))return!1;if(ee.prerelease.length){for(te=0;te<j.length;te++)if(y(j[te].semver),j[te].semver!==ye&&j[te].semver.prerelease.length>0){var pe=j[te].semver;if(pe.major===ee.major&&pe.minor===ee.minor&&pe.patch===ee.patch)return!0}return!1}return!0}function Ee(j,ee,te){try{ee=new me(ee,te)}catch{return!1}return ee.test(j)}function Ce(j,ee,te,pe){var we,Le,be,Ne,De;switch(j=new W(j,pe),ee=new me(ee,pe),te){case">":we=A,Le=ne,be=x,Ne=">",De=">=";break;case"<":we=x,Le=X,be=A,Ne="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(j,ee,pe))return!1;for(var ke=0;ke<ee.set.length;++ke){var Me=ee.set[ke],Te=null,Ae=null;if(Me.forEach(function(Fe){Fe.semver===ye&&(Fe=new fe(">=0.0.0")),Te=Te||Fe,Ae=Ae||Fe,we(Fe.semver,Te.semver,pe)?Te=Fe:be(Fe.semver,Ae.semver,pe)&&(Ae=Fe)}),Te.operator===Ne||Te.operator===De||(!Ae.operator||Ae.operator===Ne)&&Le(j,Ae.semver)||Ae.operator===De&&be(j,Ae.semver))return!1}return!0}fe.prototype.parse=function(j){var ee=this.loose?C[B]:C[Z],te=j.match(ee);if(!te)throw new TypeError("Invalid comparator: "+j);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new W(te[2],this.loose):this.semver=ye},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(j){return y("Comparator.test",j,this.loose),this.semver===ye||(typeof j=="string"&&(j=new W(j,this.loose)),he(j,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(j,ee){if(!(j instanceof fe))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new me(j.value,ee),Ee(this.value,te,ee);if(j.operator==="")return te=new me(this.value,ee),Ee(j.semver,te,ee);var pe=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Le=this.semver.version===j.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ne=he(this.semver,"<",j.semver,ee)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),De=he(this.semver,">",j.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return pe||we||Le&&be||Ne||De},t.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(j){var ee=this.loose;j=j.trim(),y("range",j,ee);var te=ee?C[G]:C[M];j=j.replace(te,de),y("hyphen replace",j),j=j.replace(C[z],"$1$2$3"),y("comparator trim",j,C[z]),j=(j=(j=j.replace(C[_],"$1~")).replace(C[ce],"$1^")).split(/\s+/).join(" ");var pe=ee?C[B]:C[Z],we=j.split(" ").map(function(Le){return function(be,Ne){return y("comp",be),be=function(De,ke){return De.trim().split(/\s+/).map(function(Me){return function(Te,Ae){y("caret",Te,Ae);var Fe=Ae?C[le]:C[ue];return Te.replace(Fe,function(Ue,Ie,Pe,Re,Oe){var xe;return y("caret",Te,Ue,Ie,Pe,Re,Oe),ge(Ie)?xe="":ge(Pe)?xe=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":ge(Re)?xe=Ie==="0"?">="+Ie+"."+Pe+".0 <"+Ie+"."+(+Pe+1)+".0":">="+Ie+"."+Pe+".0 <"+(+Ie+1)+".0.0":Oe?(y("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),xe=Ie==="0"?Pe==="0"?">="+Ie+"."+Pe+"."+Re+Oe+" <"+Ie+"."+Pe+"."+(+Re+1):">="+Ie+"."+Pe+"."+Re+Oe+" <"+Ie+"."+(+Pe+1)+".0":">="+Ie+"."+Pe+"."+Re+Oe+" <"+(+Ie+1)+".0.0"):(y("no pr"),xe=Ie==="0"?Pe==="0"?">="+Ie+"."+Pe+"."+Re+" <"+Ie+"."+Pe+"."+(+Re+1):">="+Ie+"."+Pe+"."+Re+" <"+Ie+"."+(+Pe+1)+".0":">="+Ie+"."+Pe+"."+Re+" <"+(+Ie+1)+".0.0"),y("caret return",xe),xe})}(Me,ke)}).join(" ")}(be,Ne),y("caret",be),be=function(De,ke){return De.trim().split(/\s+/).map(function(Me){return function(Te,Ae){var Fe=Ae?C[ae]:C[K];return Te.replace(Fe,function(Ue,Ie,Pe,Re,Oe){var xe;return y("tilde",Te,Ue,Ie,Pe,Re,Oe),ge(Ie)?xe="":ge(Pe)?xe=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":ge(Re)?xe=">="+Ie+"."+Pe+".0 <"+Ie+"."+(+Pe+1)+".0":Oe?(y("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),xe=">="+Ie+"."+Pe+"."+Re+Oe+" <"+Ie+"."+(+Pe+1)+".0"):xe=">="+Ie+"."+Pe+"."+Re+" <"+Ie+"."+(+Pe+1)+".0",y("tilde return",xe),xe})}(Me,ke)}).join(" ")}(be,Ne),y("tildes",be),be=function(De,ke){return y("replaceXRanges",De,ke),De.split(/\s+/).map(function(Me){return function(Te,Ae){Te=Te.trim();var Fe=Ae?C[N]:C[O];return Te.replace(Fe,function(Ue,Ie,Pe,Re,Oe,xe){y("xRange",Te,Ue,Ie,Pe,Re,Oe,xe);var _e=ge(Pe),We=_e||ge(Re),Ve=We||ge(Oe);return Ie==="="&&Ve&&(Ie=""),_e?Ue=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&Ve?(We&&(Re=0),Ve&&(Oe=0),Ie===">"?(Ie=">=",We?(Pe=+Pe+1,Re=0,Oe=0):Ve&&(Re=+Re+1,Oe=0)):Ie==="<="&&(Ie="<",We?Pe=+Pe+1:Re=+Re+1),Ue=Ie+Pe+"."+Re+"."+Oe):We?Ue=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ve&&(Ue=">="+Pe+"."+Re+".0 <"+Pe+"."+(+Re+1)+".0"),y("xRange return",Ue),Ue})}(Me,ke)}).join(" ")}(be,Ne),y("xrange",be),be=function(De,ke){return y("replaceStars",De,ke),De.trim().replace(C[J],"")}(be,Ne),y("stars",be),be}(Le,ee)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Le){return!!Le.match(pe)})),we=we.map(function(Le){return new fe(Le,ee)})},me.prototype.intersects=function(j,ee){if(!(j instanceof me))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function(pe){return j.set.some(function(we){return we.every(function(Le){return pe.intersects(Le,ee)})})})})},t.toComparators=function(j,ee){return new me(j,ee).set.map(function(te){return te.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new W(j,this.loose));for(var ee=0;ee<this.set.length;ee++)if(ve(this.set[ee],j))return!0;return!1},t.satisfies=Ee,t.maxSatisfying=function(j,ee,te){var pe=null,we=null;try{var Le=new me(ee,te)}catch{return null}return j.forEach(function(be){Le.test(be)&&(pe&&we.compare(be)!==-1||(we=new W(pe=be,te)))}),pe},t.minSatisfying=function(j,ee,te){var pe=null,we=null;try{var Le=new me(ee,te)}catch{return null}return j.forEach(function(be){Le.test(be)&&(pe&&we.compare(be)!==1||(we=new W(pe=be,te)))}),pe},t.validRange=function(j,ee){try{return new me(j,ee).range||"*"}catch{return null}},t.ltr=function(j,ee,te){return Ce(j,ee,"<",te)},t.gtr=function(j,ee,te){return Ce(j,ee,">",te)},t.outside=Ce,t.prerelease=function(j,ee){var te=U(j,ee);return te&&te.prerelease.length?te.prerelease:null},t.intersects=function(j,ee,te){return j=new me(j,te),ee=new me(ee,te),j.intersects(ee)},t.coerce=function(j){if(j instanceof W)return j;if(typeof j!="string")return null;var ee=j.match(C[k]);return ee==null?null:U((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,b(1))},function(H,t){var b,D,y=H.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function C(g){if(b===setTimeout)return setTimeout(g,0);if((b===R||!b)&&setTimeout)return b=setTimeout,setTimeout(g,0);try{return b(g,0)}catch{try{return b.call(null,g,0)}catch{return b.call(this,g,0)}}}(function(){try{b=typeof setTimeout=="function"?setTimeout:R}catch{b=R}try{D=typeof clearTimeout=="function"?clearTimeout:L}catch{D=L}})();var p,l=[],a=!1,c=-1;function h(){a&&p&&(a=!1,p.length?l=p.concat(l):c=-1,l.length&&m())}function m(){if(!a){var g=C(h);a=!0;for(var d=l.length;d;){for(p=l,l=[];++c<d;)p&&p[c].run();c=-1,d=l.length}p=null,a=!1,function(v){if(D===clearTimeout)return clearTimeout(v);if((D===L||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(v);try{D(v)}catch{try{return D.call(null,v)}catch{return D.call(this,v)}}}(g)}}function S(g,d){this.fun=g,this.array=d}function T(){}y.nextTick=function(g){var d=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)d[v-1]=arguments[v];l.push(new S(g,d)),l.length!==1||a||C(m)},S.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=T,y.addListener=T,y.once=T,y.off=T,y.removeListener=T,y.removeAllListeners=T,y.emit=T,y.prependListener=T,y.prependOnceListener=T,y.listeners=function(g){return[]},y.binding=function(g){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(g){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(se[80],oe([0,1]),function(H,t){"use strict";var b;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class D{constructor(C,p,l){this.level=C,this.key=p,this.value=l,this.forward=[]}}const y=void 0;class R{constructor(C,p=2**16){this.comparator=C,this[b]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(p)|0),this._header=new D(this._maxLevel,y,y)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,y,y),this._size=0}has(C){return!!R._search(this,C,this.comparator)}get(C){return R._search(this,C,this.comparator)?.value}set(C,p){return R._insert(this,C,p,this.comparator)&&(this._size+=1),this}delete(C){const p=R._delete(this,C,this.comparator);return p&&(this._size-=1),p}forEach(C,p){let l=this._header.forward[0];for(;l;)C.call(p,l.value,l.key,this),l=l.forward[0]}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",p=this._header.forward[0];for(;p;)C+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return C}static _search(C,p,l){let a=C._header;for(let c=C._level-1;c>=0;c--)for(;a.forward[c]&&l(a.forward[c].key,p)<0;)a=a.forward[c];if(a=a.forward[0],a&&l(a.key,p)===0)return a}static _insert(C,p,l,a){const c=[];let h=C._header;for(let m=C._level-1;m>=0;m--){for(;h.forward[m]&&a(h.forward[m].key,p)<0;)h=h.forward[m];c[m]=h}if(h=h.forward[0],h&&a(h.key,p)===0)return h.value=l,!1;{const m=R._randomLevel(C);if(m>C._level){for(let S=C._level;S<m;S++)c[S]=C._header;C._level=m}h=new D(m,p,l);for(let S=0;S<m;S++)h.forward[S]=c[S].forward[S],c[S].forward[S]=h;return!0}}static _randomLevel(C,p=.5){let l=1;for(;Math.random()<p&&l<C._maxLevel;)l+=1;return l}static _delete(C,p,l){const a=[];let c=C._header;for(let h=C._level-1;h>=0;h--){for(;c.forward[h]&&l(c.forward[h].key,p)<0;)c=c.forward[h];a[h]=c}if(c=c.forward[0],!c||l(c.key,p)!==0)return!1;for(let h=0;h<C._level&&a[h].forward[h]===c;h++)a[h].forward[h]=c.forward[h];for(;C._level>0&&C._header.forward[C._level-1]===y;)C._level-=1;return!0}}t.SkipList=R}),define(se[46],oe([0,1,9,2]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isReadable=y,t.isReadableStream=R,t.isReadableBufferedStream=L,t.newWriteableStream=C,t.consumeReadable=l,t.peekReadable=a,t.consumeStream=c,t.listenStream=h,t.peekStream=m,t.toStream=S,t.emptyStream=T,t.toReadable=g,t.transform=d,t.prefixedReadable=v,t.prefixedStream=P;function y(E){const u=E;return u?typeof u.read=="function":!1}function R(E){const u=E;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}function L(E){const u=E;return u?R(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function C(E,u){return new p(E,u)}class p{constructor(u,i){this.reducer=u,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u<"u"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(i=>i(u))}emitError(u){this.listeners.error.length===0?(0,b.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(i=>i(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,i){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(u,i){if(this.state.destroyed)return;let o;switch(u){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const r=o.indexOf(i);r>=0&&o.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(E,u){const i=[];let o;for(;(o=E.read())!==null;)i.push(o);return u(i)}function a(E,u,i){const o=[];let r;for(;(r=E.read())!==null&&o.length<i;)o.push(r);return r===null&&o.length>0?u(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const e=r;return r=void 0,e}return E.read()}}}function c(E,u){return new Promise((i,o)=>{const r=[];h(E,{onData:e=>{u&&r.push(e)},onError:e=>{u?o(e):i(void 0)},onEnd:()=>{i(u?u(r):void 0)}})})}function h(E,u,i){E.on("error",o=>{i?.isCancellationRequested||u.onError(o)}),E.on("end",()=>{i?.isCancellationRequested||u.onEnd()}),E.on("data",o=>{i?.isCancellationRequested||u.onData(o)})}function m(E,u){return new Promise((i,o)=>{const r=new D.DisposableStore,e=[],n=I=>{if(e.push(I),e.length>u)return r.dispose(),E.pause(),i({stream:E,buffer:e,ended:!1})},s=I=>(r.dispose(),o(I)),f=()=>(r.dispose(),i({stream:E,buffer:e,ended:!0}));r.add((0,D.toDisposable)(()=>E.removeListener("error",s))),E.on("error",s),r.add((0,D.toDisposable)(()=>E.removeListener("end",f))),E.on("end",f),r.add((0,D.toDisposable)(()=>E.removeListener("data",n))),E.on("data",n)})}function S(E,u){const i=C(u);return i.end(E),i}function T(){const E=C(()=>{throw new Error("not supported")});return E.end(),E}function g(E){let u=!1;return{read:()=>u?null:(u=!0,E)}}function d(E,u,i){const o=C(i);return h(E,{onData:r=>o.write(u.data(r)),onError:r=>o.error(u.error?u.error(r):r),onEnd:()=>o.end()}),o}function v(E,u,i){let o=!1;return{read:()=>{const r=u.read();return o?r:(o=!0,r!==null?i([E,r]):E)}}}function P(E,u,i){let o=!1;const r=C(i);return h(u,{onData:e=>o?r.write(e):(o=!0,r.write(i([E,e]))),onError:e=>r.error(e),onEnd:()=>{o||(o=!0,r.write(E)),r.end()}}),r}}),define(se[14],oe([0,1,170,46]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VSBuffer=void 0,t.binaryIndexOf=l,t.readUInt16LE=a,t.writeUInt16LE=c,t.readUInt32BE=h,t.writeUInt32BE=m,t.readUInt32LE=S,t.writeUInt32LE=T,t.readUInt8=g,t.writeUInt8=d,t.readableToBuffer=v,t.bufferToReadable=P,t.streamToBuffer=E,t.bufferedStreamToBuffer=u,t.bufferToStream=i,t.streamToBufferReadableStream=o,t.newWriteableBufferStream=r,t.prefixedBufferReadable=e,t.prefixedBufferStream=n,t.decodeBase64=s,t.encodeBase64=O;const y=typeof Buffer<"u",R=new b.Lazy(()=>new Uint8Array(256));let L,C;class p{static alloc(k){return y?new p(Buffer.allocUnsafe(k)):new p(new Uint8Array(k))}static wrap(k){return y&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new p(k)}static fromString(k,F){return!(F?.dontUseNodeBuffer||!1)&&y?new p(Buffer.from(k)):(L||(L=new TextEncoder),new p(L.encode(k)))}static fromByteArray(k){const F=p.alloc(k.length);for(let _=0,K=k.length;_<K;_++)F.buffer[_]=k[_];return F}static concat(k,F){if(typeof F>"u"){F=0;for(let ae=0,ie=k.length;ae<ie;ae++)F+=k[ae].byteLength}const _=p.alloc(F);let K=0;for(let ae=0,ie=k.length;ae<ie;ae++){const ce=k[ae];_.set(ce,K),K+=ce.byteLength}return _}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=p.alloc(this.byteLength);return k.set(this),k}toString(){return y?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(k,F){return new p(this.buffer.subarray(k,F))}set(k,F){if(k instanceof p)this.buffer.set(k.buffer,F);else if(k instanceof Uint8Array)this.buffer.set(k,F);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),F);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return h(this.buffer,k)}writeUInt32BE(k,F){m(this.buffer,k,F)}readUInt32LE(k){return S(this.buffer,k)}writeUInt32LE(k,F){T(this.buffer,k,F)}readUInt8(k){return g(this.buffer,k)}writeUInt8(k,F){d(this.buffer,k,F)}indexOf(k,F=0){return l(this.buffer,k instanceof p?k.buffer:k,F)}}t.VSBuffer=p;function l(N,k,F=0){const _=k.byteLength,K=N.byteLength;if(_===0)return 0;if(_===1)return N.indexOf(k[0]);if(_>K-F)return-1;const ae=R.value;ae.fill(k.length);for(let le=0;le<k.length;le++)ae[k[le]]=k.length-le-1;let ie=F+k.length-1,ce=ie,ue=-1;for(;ie<K;)if(N[ie]===k[ce]){if(ce===0){ue=ie;break}ie--,ce--}else ie+=Math.max(k.length-ce,ae[N[ie]]),ce=k.length-1;return ue}function a(N,k){return N[k+0]<<0>>>0|N[k+1]<<8>>>0}function c(N,k,F){N[F+0]=k&255,k=k>>>8,N[F+1]=k&255}function h(N,k){return N[k]*2**24+N[k+1]*2**16+N[k+2]*2**8+N[k+3]}function m(N,k,F){N[F+3]=k,k=k>>>8,N[F+2]=k,k=k>>>8,N[F+1]=k,k=k>>>8,N[F]=k}function S(N,k){return N[k+0]<<0>>>0|N[k+1]<<8>>>0|N[k+2]<<16>>>0|N[k+3]<<24>>>0}function T(N,k,F){N[F+0]=k&255,k=k>>>8,N[F+1]=k&255,k=k>>>8,N[F+2]=k&255,k=k>>>8,N[F+3]=k&255}function g(N,k){return N[k]}function d(N,k,F){N[F]=k}function v(N){return D.consumeReadable(N,k=>p.concat(k))}function P(N){return D.toReadable(N)}function E(N){return D.consumeStream(N,k=>p.concat(k))}async function u(N){return N.ended?p.concat(N.buffer):p.concat([...N.buffer,await E(N.stream)])}function i(N){return D.toStream(N,k=>p.concat(k))}function o(N){return D.transform(N,{data:k=>typeof k=="string"?p.fromString(k):p.wrap(k)},k=>p.concat(k))}function r(N){return D.newWriteableStream(k=>p.concat(k),N)}function e(N,k){return D.prefixedReadable(N,k,F=>p.concat(F))}function n(N,k){return D.prefixedStream(N,k,F=>p.concat(F))}function s(N){let k=0,F=0,_=0;const K=new Uint8Array(Math.floor(N.length/4*3)),ae=ce=>{switch(F){case 3:K[_++]=k|ce,F=0;break;case 2:K[_++]=k|ce>>>2,k=ce<<6,F=3;break;case 1:K[_++]=k|ce>>>4,k=ce<<4,F=2;break;default:k=ce<<2,F=1}};for(let ce=0;ce<N.length;ce++){const ue=N.charCodeAt(ce);if(ue>=65&&ue<=90)ae(ue-65);else if(ue>=97&&ue<=122)ae(ue-97+26);else if(ue>=48&&ue<=57)ae(ue-48+52);else if(ue===43||ue===45)ae(62);else if(ue===47||ue===95)ae(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${N[ce]}`)}}const ie=_;for(;F>0;)ae(0);return p.wrap(K).slice(0,ie)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:N},k=!0,F=!1){const _=F?I:f;let K="";const ae=N.byteLength%3;let ie=0;for(;ie<N.byteLength-ae;ie+=3){const ce=N[ie+0],ue=N[ie+1],le=N[ie+2];K+=_[ce>>>2],K+=_[(ce<<4|ue>>>4)&63],K+=_[(ue<<2|le>>>6)&63],K+=_[le&63]}if(ae===1){const ce=N[ie+0];K+=_[ce>>>2],K+=_[ce<<4&63],k&&(K+="==")}else if(ae===2){const ce=N[ie+0],ue=N[ie+1];K+=_[ce>>>2],K+=_[(ce<<4|ue>>>4)&63],K+=_[ue<<2&63],k&&(K+="=")}return K}}),define(se[28],oe([0,1,3]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=D,t.deepFreeze=y,t.cloneAndChange=L,t.mixin=p,t.equals=l,t.safeStringify=a,t.distinct=c,t.getCaseInsensitive=h,t.filter=m,t.getAllPropertyNames=S,t.getAllMethodNames=T,t.createProxyObject=g,t.mapValues=d;function D(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const P=Array.isArray(v)?[]:{};return Object.entries(v).forEach(([E,u])=>{P[E]=u&&typeof u=="object"?D(u):u}),P}function y(v){if(!v||typeof v!="object")return v;const P=[v];for(;P.length>0;){const E=P.shift();Object.freeze(E);for(const u in E)if(R.call(E,u)){const i=E[u];typeof i=="object"&&!Object.isFrozen(i)&&!(0,b.isTypedArray)(i)&&P.push(i)}}return v}const R=Object.prototype.hasOwnProperty;function L(v,P){return C(v,P,new Set)}function C(v,P,E){if((0,b.isUndefinedOrNull)(v))return v;const u=P(v);if(typeof u<"u")return u;if(Array.isArray(v)){const i=[];for(const o of v)i.push(C(o,P,E));return i}if((0,b.isObject)(v)){if(E.has(v))throw new Error("Cannot clone recursive data-structure");E.add(v);const i={};for(const o in v)R.call(v,o)&&(i[o]=C(v[o],P,E));return E.delete(v),i}return v}function p(v,P,E=!0){return(0,b.isObject)(v)?((0,b.isObject)(P)&&Object.keys(P).forEach(u=>{u in v?E&&((0,b.isObject)(v[u])&&(0,b.isObject)(P[u])?p(v[u],P[u],E):v[u]=P[u]):v[u]=P[u]}),v):P}function l(v,P){if(v===P)return!0;if(v==null||P===null||P===void 0||typeof v!=typeof P||typeof v!="object"||Array.isArray(v)!==Array.isArray(P))return!1;let E,u;if(Array.isArray(v)){if(v.length!==P.length)return!1;for(E=0;E<v.length;E++)if(!l(v[E],P[E]))return!1}else{const i=[];for(u in v)i.push(u);i.sort();const o=[];for(u in P)o.push(u);if(o.sort(),!l(i,o))return!1;for(E=0;E<i.length;E++)if(!l(v[i[E]],P[i[E]]))return!1}return!0}function a(v){const P=new Set;return JSON.stringify(v,(E,u)=>{if((0,b.isObject)(u)||Array.isArray(u)){if(P.has(u))return"[Circular]";P.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function c(v,P){const E=Object.create(null);return!v||!P||Object.keys(P).forEach(i=>{const o=v[i],r=P[i];l(o,r)||(E[i]=r)}),E}function h(v,P){const E=P.toLowerCase(),u=Object.keys(v).find(i=>i.toLowerCase()===E);return u?v[u]:v[P]}function m(v,P){const E=Object.create(null);for(const[u,i]of Object.entries(v))P(u,i)&&(E[u]=i);return E}function S(v){let P=[];for(;Object.prototype!==v;)P=P.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return P}function T(v){const P=[];for(const E of S(v))typeof v[E]=="function"&&P.push(E);return P}function g(v,P){const E=i=>function(){const o=Array.prototype.slice.call(arguments,0);return P(i,o)},u={};for(const i of v)u[i]=E(i);return u}function d(v,P){const E={};for(const[u,i]of Object.entries(v))E[u]=P(i,u);return E}}),define(se[43],oe([0,1,32]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=void 0,t.hash=D,t.doHash=y,t.numberHash=R,t.stringHash=C,t.toHexString=T;function D(d){return y(d,0)}function y(d,v){switch(typeof d){case"object":return d===null?R(349,v):Array.isArray(d)?p(d,v):l(d,v);case"string":return C(d,v);case"boolean":return L(d,v);case"number":return R(d,v);case"undefined":return R(937,v);default:return R(617,v)}}function R(d,v){return(v<<5)-v+d|0}function L(d,v){return R(d?433:863,v)}function C(d,v){v=R(149417,v);for(let P=0,E=d.length;P<E;P++)v=R(d.charCodeAt(P),v);return v}function p(d,v){return v=R(104579,v),d.reduce((P,E)=>y(E,P),v)}function l(d,v){return v=R(181387,v),Object.keys(d).sort().reduce((P,E)=>(P=C(E,P),y(d[E],P)),v)}class a{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=y(v,this._value),this._value}}t.Hasher=a;var c;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(c||(c={}));function h(d,v,P=32){const E=P-v,u=~((1<<E)-1);return(d<<v|(u&d)>>>E)>>>0}function m(d,v=0,P=d.byteLength,E=0){for(let u=0;u<P;u++)d[v+u]=E}function S(d,v,P="0"){for(;d.length<v;)d=P+d;return d}function T(d,v=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(P=>P.toString(16).padStart(2,"0")).join(""):S((d>>>0).toString(16),v/4)}class g{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(c.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const P=v.length;if(P===0)return;const E=this._buff;let u=this._buffLen,i=this._leftoverHighSurrogate,o,r;for(i!==0?(o=i,r=-1,i=0):(o=v.charCodeAt(0),r=0);;){let e=o;if(b.isHighSurrogate(o))if(r+1<P){const n=v.charCodeAt(r+1);b.isLowSurrogate(n)?(r++,e=b.computeCodePoint(o,n)):e=c.UNICODE_REPLACEMENT}else{i=o;break}else b.isLowSurrogate(o)&&(e=c.UNICODE_REPLACEMENT);if(u=this._push(E,u,e),r++,r<P)o=v.charCodeAt(r);else break}this._buffLen=u,this._leftoverHighSurrogate=i}_push(v,P,E){return E<128?v[P++]=E:E<2048?(v[P++]=192|(E&1984)>>>6,v[P++]=128|(E&63)>>>0):E<65536?(v[P++]=224|(E&61440)>>>12,v[P++]=128|(E&4032)>>>6,v[P++]=128|(E&63)>>>0):(v[P++]=240|(E&1835008)>>>18,v[P++]=128|(E&258048)>>>12,v[P++]=128|(E&4032)>>>6,v[P++]=128|(E&63)>>>0),P>=c.BLOCK_SIZE&&(this._step(),P-=c.BLOCK_SIZE,this._totalLen+=c.BLOCK_SIZE,v[0]=v[c.BLOCK_SIZE+0],v[1]=v[c.BLOCK_SIZE+1],v[2]=v[c.BLOCK_SIZE+2]),P}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,c.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),T(this._h0)+T(this._h1)+T(this._h2)+T(this._h3)+T(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=g._bigBlock32,P=this._buffDV;for(let f=0;f<64;f+=4)v.setUint32(f,P.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)v.setUint32(f,h(v.getUint32(f-12,!1)^v.getUint32(f-32,!1)^v.getUint32(f-56,!1)^v.getUint32(f-64,!1),1),!1);let E=this._h0,u=this._h1,i=this._h2,o=this._h3,r=this._h4,e,n,s;for(let f=0;f<80;f++)f<20?(e=u&i|~u&o,n=1518500249):f<40?(e=u^i^o,n=1859775393):f<60?(e=u&i|u&o|i&o,n=2400959708):(e=u^i^o,n=3395469782),s=h(E,5)+e+r+n+v.getUint32(f*4,!1)&4294967295,r=o,o=i,i=h(u,30),u=E,E=s;this._h0=this._h0+E&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+r&4294967295}}t.StringSHA1=g}),define(se[56],oe([0,1,32]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var D;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(D||(D={})),function(y){const R="error",L="warning",C="warn",p="info",l="ignore";function a(h){return h?b.equalsIgnoreCase(R,h)?y.Error:b.equalsIgnoreCase(L,h)||b.equalsIgnoreCase(C,h)?y.Warning:b.equalsIgnoreCase(p,h)?y.Info:y.Ignore:y.Ignore}y.fromValue=a;function c(h){switch(h){case y.Error:return R;case y.Warning:return L;case y.Info:return p;default:return l}}y.toString=c}(D||(D={})),t.default=D}),define(se[29],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=void 0,t.isUUID=D;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(y){return b.test(y)}t.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(C){for(let p=0;p<C.length;p++)C[p]=Math.floor(Math.random()*256);return C};const R=new Uint8Array(16),L=[];for(let C=0;C<256;C++)L.push(C.toString(16).padStart(2,"0"));return function(){y(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,l="";return l+=L[R[p++]],l+=L[R[p++]],l+=L[R[p++]],l+=L[R[p++]],l+="-",l+=L[R[p++]],l+=L[R[p++]],l+="-",l+=L[R[p++]],l+=L[R[p++]],l+="-",l+=L[R[p++]],l+=L[R[p++]],l+="-",l+=L[R[p++]],l+=L[R[p++]],l+=L[R[p++]],l+=L[R[p++]],l+=L[R[p++]],l+=L[R[p++]],l}}()}),define(se[81],oe([0,1,35]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMac=R;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function y(L){const C=L.replace(/\-/g,":").toLowerCase();return!D.has(C)}function R(){const L=(0,b.networkInterfaces)();for(const C in L){const p=L[C];if(p){for(const{mac:l}of p)if(y(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[82],oe([7,4]),function(H,t){return H.create("vs/base/common/date",t)}),define(se[83],oe([0,1,82]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fromNow=l,t.getDurationString=a,t.toLocalISOString=c;const D=60,y=D*60,R=y*24,L=R*7,C=R*30,p=R*365;function l(h,m,S,T){typeof h!="number"&&(h=h.getTime());const g=Math.round((new Date().getTime()-h)/1e3);if(g<-30)return(0,b.localize)(0,null,l(new Date().getTime()+g*1e3,!1));if(!T&&g<30)return(0,b.localize)(1,null);let d;return g<D?(d=g,m?d===1?S?(0,b.localize)(2,null,d):(0,b.localize)(3,null,d):S?(0,b.localize)(4,null,d):(0,b.localize)(5,null,d):d===1?S?(0,b.localize)(6,null,d):(0,b.localize)(7,null,d):S?(0,b.localize)(8,null,d):(0,b.localize)(9,null,d)):g<y?(d=Math.floor(g/D),m?d===1?S?(0,b.localize)(10,null,d):(0,b.localize)(11,null,d):S?(0,b.localize)(12,null,d):(0,b.localize)(13,null,d):d===1?S?(0,b.localize)(14,null,d):(0,b.localize)(15,null,d):S?(0,b.localize)(16,null,d):(0,b.localize)(17,null,d)):g<R?(d=Math.floor(g/y),m?d===1?S?(0,b.localize)(18,null,d):(0,b.localize)(19,null,d):S?(0,b.localize)(20,null,d):(0,b.localize)(21,null,d):d===1?S?(0,b.localize)(22,null,d):(0,b.localize)(23,null,d):S?(0,b.localize)(24,null,d):(0,b.localize)(25,null,d)):g<L?(d=Math.floor(g/R),m?d===1?(0,b.localize)(26,null,d):(0,b.localize)(27,null,d):d===1?(0,b.localize)(28,null,d):(0,b.localize)(29,null,d)):g<C?(d=Math.floor(g/L),m?d===1?S?(0,b.localize)(30,null,d):(0,b.localize)(31,null,d):S?(0,b.localize)(32,null,d):(0,b.localize)(33,null,d):d===1?S?(0,b.localize)(34,null,d):(0,b.localize)(35,null,d):S?(0,b.localize)(36,null,d):(0,b.localize)(37,null,d)):g<p?(d=Math.floor(g/C),m?d===1?S?(0,b.localize)(38,null,d):(0,b.localize)(39,null,d):S?(0,b.localize)(40,null,d):(0,b.localize)(41,null,d):d===1?S?(0,b.localize)(42,null,d):(0,b.localize)(43,null,d):S?(0,b.localize)(44,null,d):(0,b.localize)(45,null,d)):(d=Math.floor(g/p),m?d===1?S?(0,b.localize)(46,null,d):(0,b.localize)(47,null,d):S?(0,b.localize)(48,null,d):(0,b.localize)(49,null,d):d===1?S?(0,b.localize)(50,null,d):(0,b.localize)(51,null,d):S?(0,b.localize)(52,null,d):(0,b.localize)(53,null,d))}function a(h,m){const S=Math.abs(h/1e3);return S<1?m?(0,b.localize)(54,null,h):(0,b.localize)(55,null,h):S<D?m?(0,b.localize)(56,null,Math.round(h)/1e3):(0,b.localize)(57,null,Math.round(h)/1e3):S<y?m?(0,b.localize)(58,null,Math.round(h/(1e3*D))):(0,b.localize)(59,null,Math.round(h/(1e3*D))):S<R?m?(0,b.localize)(60,null,Math.round(h/(1e3*y))):(0,b.localize)(61,null,Math.round(h/(1e3*y))):(0,b.localize)(62,null,Math.round(h/(1e3*R)))}function c(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[84],oe([7,4]),function(H,t){return H.create("vs/base/common/errorMessage",t)}),define(se[36],oe([0,1,20,3,84]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=p,t.isErrorWithActions=l,t.createErrorWithActions=a;function R(c,h){return h&&(c.stack||c.stacktrace)?y.localize(0,null,C(c),L(c.stack)||L(c.stacktrace)):C(c)}function L(c){return Array.isArray(c)?c.join(`
`):c}function C(c){return c.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?y.localize(1,null,c.message):c.message||y.localize(2,null)}function p(c=null,h=!1){if(!c)return y.localize(3,null);if(Array.isArray(c)){const m=b.coalesce(c),S=p(m[0],h);return m.length>1?y.localize(4,null,S,m.length):S}if(D.isString(c))return c;if(c.detail){const m=c.detail;if(m.error)return R(m.error,h);if(m.exception)return R(m.exception,h)}return c.stack?R(c,h):c.message?c.message:y.localize(5,null)}function l(c){const h=c;return h instanceof Error&&Array.isArray(h.actions)}function a(c,h){let m;return typeof c=="string"?m=new Error(c):m=c,m.actions=h,m}}),define(se[85],oe([7,4]),function(H,t){return H.create("vs/base/common/jsonErrorMessages",t)}),define(se[86],oe([0,1,85,34]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getParseErrorMessage=y;function y(R){switch(R){case D.ParseErrorCode.InvalidSymbol:return(0,b.localize)(0,null);case D.ParseErrorCode.InvalidNumberFormat:return(0,b.localize)(1,null);case D.ParseErrorCode.PropertyNameExpected:return(0,b.localize)(2,null);case D.ParseErrorCode.ValueExpected:return(0,b.localize)(3,null);case D.ParseErrorCode.ColonExpected:return(0,b.localize)(4,null);case D.ParseErrorCode.CommaExpected:return(0,b.localize)(5,null);case D.ParseErrorCode.CloseBraceExpected:return(0,b.localize)(6,null);case D.ParseErrorCode.CloseBracketExpected:return(0,b.localize)(7,null);case D.ParseErrorCode.EndOfFileExpected:return(0,b.localize)(8,null);default:return""}}}),define(se[57],oe([0,1,13]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminateResponseCode=t.Source=void 0,t.sanitizeProcessEnvironment=R,t.removeDangerousEnvVariables=L;var D;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(D||(t.Source=D={}));var y;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(y||(t.TerminateResponseCode=y={}));function R(C,...p){const l=p.reduce((h,m)=>(h[m]=!0,h),{}),a=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(h=>!l[h]).forEach(h=>{for(let m=0;m<a.length;m++)if(h.search(a[m])!==-1){delete C[h];break}})}function L(C){C&&(delete C.DEBUG,b.isMacintosh&&delete C.DYLD_LIBRARY_PATH,b.isLinux&&delete C.LD_PRELOAD)}}),define(se[87],oe([0,1,12]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isRemoteConsoleLog=D,t.parse=y,t.getFirstFrame=R,t.log=C;function D(l){const a=l;return a&&typeof a.type=="string"&&typeof a.severity=="string"}function y(l){const a=[];let c;try{const h=JSON.parse(l.arguments),m=h[h.length-1];m&&m.__$stack&&(h.pop(),c=m.__$stack),a.push(...h)}catch{a.push("Unable to log remote console arguments",l.arguments)}return{args:a,stack:c}}function R(l){if(typeof l!="string")return R(y(l).stack);const a=l;if(a){const c=L(a),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(c||"");if(h&&h.length===4)return{uri:b.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function L(l){if(!l)return l;const a=l.indexOf(`
`);return a===-1?l:l.substring(0,a)}function C(l,a){const{args:c,stack:h}=y(l),m=typeof c[0]=="string"&&c.length===1;let S=L(h);S&&(S=`(${S.trim()})`);let T=[];if(typeof c[0]=="string"?S&&m?T=[`%c[${a}] %c${c[0]} %c${S}`,p("blue"),p(""),p("grey")]:T=[`%c[${a}] %c${c[0]}`,p("blue"),p(""),...c.slice(1)]:T=[`%c[${a}]%`,p("blue"),...c],S&&!m&&T.push(S),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,T)}function p(l){return`color: ${l}`}}),define(se[47],oe([0,1,14,12,171]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stringify=R,t.parse=L,t.revive=p;function R(l){return JSON.stringify(l,C)}function L(l){let a=JSON.parse(l);return a=p(a),a}function C(l,a){return a instanceof RegExp?{$mid:y.MarshalledId.Regexp,source:a.source,flags:a.flags}:a}function p(l,a=0){if(!l||a>200)return l;if(typeof l=="object"){switch(l.$mid){case y.MarshalledId.Uri:return D.URI.revive(l);case y.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case y.MarshalledId.Date:return new Date(l.source)}if(l instanceof b.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let c=0;c<l.length;++c)l[c]=p(l[c],a+1);else for(const c in l)Object.hasOwnProperty.call(l,c)&&(l[c]=p(l[c],a+1))}return l}}),define(se[88],oe([0,1,75,15,13,12]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.importAMDNodeModule=a;class L{constructor(h,m,S){this.id=h,this.dependencies=m,this.callback=S}}class C{static{this.INSTANCE=new C}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(h,m,S)=>{typeof h!="string"&&(S=m,m=h,h=null),(typeof m!="object"||!Array.isArray(m))&&(S=m,m=null),this._defineCalls.push(new L(h,m,S))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this._initialize();const m=await(this._isWebWorker?this._workerLoadScript(h):this._isRenderer?this._rendererLoadScript(h):this._nodeJSLoadScript(h));if(!m)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}_rendererLoadScript(h){return new Promise((m,S)=>{const T=document.createElement("script");T.setAttribute("async","async"),T.setAttribute("type","text/javascript");const g=()=>{T.removeEventListener("load",d),T.removeEventListener("error",v)},d=P=>{g(),m(this._defineCalls.pop())},v=P=>{g(),S(P)};T.addEventListener("load",d),T.addEventListener("error",v),this._amdPolicy&&(h=this._amdPolicy.createScriptURL(h)),T.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(T)})}_workerLoadScript(h){return new Promise((m,S)=>{try{this._amdPolicy&&(h=this._amdPolicy.createScriptURL(h)),importScripts(h),m(this._defineCalls.pop())}catch(T){S(T)}})}async _nodeJSLoadScript(h){try{const m=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,T=globalThis._VSCODE_NODE_MODULES.module,g=R.URI.parse(h).fsPath,d=m.readFileSync(g).toString(),v=T.wrap(d.replace(/^#!.*/,""));return new S.Script(v).runInThisContext().apply(),this._defineCalls.pop()}catch(m){throw m}}}const p=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function a(c,h,m){if(b.isESM){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[c]&&(c=l[c]);const S=`${c}/${h}`;if(p.has(S))return p.get(S);let T;if(/^\w[\w\d+.-]*:\/\//.test(S))T=S;else{const P=`${m&&!y.isWeb?D.nodeModulesAsarPath:D.nodeModulesPath}/${S}`;T=D.FileAccess.asBrowserUri(P).toString(!0)}const g=C.INSTANCE.load(T);return p.set(S,g),g}else return await new Promise((S,T)=>{H([c],S,T)})}}),define(se[89],oe([0,1,35,48,29,81,13]),function(H,t,b,D,y,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.virtualMachineHint=void 0,t.getMachineId=p,t.getSqmMachineId=c,t.getdevDeviceId=h,t.virtualMachineHint=new class{_isVirtualMachineMacAddress(m){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(m)}value(){if(this._value===void 0){let m=0,S=0;const T=(0,b.networkInterfaces)();for(const g in T){const d=T[g];if(d)for(const{mac:v,internal:P}of d)P||(S+=1,this._isVirtualMachineMacAddress(v.toUpperCase())&&(m+=1))}this._value=S>0?m/S:0}return this._value}};let C;async function p(m){return C||(C=(async()=>await l(m)||y.generateUuid())()),C}async function l(m){try{const S=await new Promise((g,d)=>{H(["crypto"],g,d)}),T=(0,R.getMac)();return S.createHash("sha256").update(T,"utf8").digest("hex")}catch(S){m(S);return}}const a="Software\\Microsoft\\SQMClient";async function c(m){if(L.isWindows){const S=await new Promise((T,g)=>{H(["@vscode/windows-registry"],T,g)});try{return S.GetStringRegKey("HKEY_LOCAL_MACHINE",a,"MachineId")||""}catch(T){return m(T),""}}return""}async function h(m){try{return await(await new Promise((g,d)=>{H(["@vscode/deviceid"],g,d)})).getDeviceId()}catch(S){return m(S),""}}}),define(se[90],oe([0,1,35,16,25]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.enumeratePowerShellInstallations=v,t.getFirstAvailablePowerShellInstallation=P;const R=/^\d+$/,L=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var p;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(p||(p={}));let l;switch(process.arch){case"ia32":l=p.x86;break;case"arm":case"arm64":l=p.ARM;break;default:l=p.x64;break}let a;process.env.PROCESSOR_ARCHITEW6432?a=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?p.ARM:p.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?a=p.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?a=p.x86:a=p.x64;class c{constructor(u,i,o){this.exePath=u,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await y.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:E=!1}={}){return E?l===p.x64?process.env["ProgramFiles(x86)"]||null:a===p.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:E=!1,findPreview:u=!1}={}){const i=h({useAlternateBitness:E});if(!i)return null;const o=D.join(i,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(o))return null;let r=-1,e=null;for(const f of await y.Promises.readdir(o)){let I=-1;if(u){const N=f.indexOf("-");if(N<0)continue;const k=f.substring(0,N);if(!R.test(k)||f.substring(N+1)!=="preview")continue;I=parseInt(k,10)}else{if(!R.test(f))continue;I=parseInt(f,10)}if(I<=r)continue;const O=D.join(o,f,"pwsh.exe");await y.SymlinkSupport.existsFile(O)&&(e=O,r=I)}if(!e)return null;const n=i.includes("x86")?" (x86)":"",s=u?" Preview":"";return new c(e,`PowerShell${s}${n}`,!0)}async function S({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const u=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=E?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const r of await y.Promises.readdir(u))if(i.test(r)){const e=D.join(u,r,"pwsh.exe");return new c(e,o)}return null}function T(){const E=D.join(b.homedir(),".dotnet","tools","pwsh.exe");return new c(E,".NET Core PowerShell Global Tool")}function g(){const E=D.join(process.env.windir,l===p.x86&&a!==p.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new c(E,"Windows PowerShell",!0)}async function*d(){let E=await m();E&&(yield E),E=await m({useAlternateBitness:!0}),E&&(yield E),E=await S(),E&&(yield E),E=T(),E&&(yield E),E=await m({findPreview:!0}),E&&(yield E),E=await S({findPreview:!0}),E&&(yield E),E=await m({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=g(),E&&(yield E)}async function*v(){for await(const E of d())await E.exists()&&(yield E)}async function P(){for await(const E of v())return E;return null}}),define(se[58],oe([0,1,16,13,37,57,3,25]),function(H,t,b,D,y,R,L,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.TerminateResponseCode=t.Source=void 0,t.getWindowsShell=p,t.createQueuedSender=l,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function p(c=y.env){return c.comspec||"cmd.exe"}function l(c){let h=[],m=!1;const S=function(T){if(m){h.push(T);return}(!c.send(T,d=>{if(d&&console.error(d),m=!1,h.length>0){const v=h.slice(0);h=[],v.forEach(P=>S(P))}})||D.isWindows)&&(m=!0)};return{send:S}}var a;(function(c){async function h(m,S,T){if(b.isAbsolute(m))return m;if(S===void 0&&(S=y.cwd()),b.dirname(m)!=="."||(T===void 0&&L.isString(y.env.PATH)&&(T=y.env.PATH.split(b.delimiter)),T===void 0||T.length===0))return b.join(S,m);async function d(v){if(await C.Promises.exists(v)){let P;try{P=await C.Promises.stat(v)}catch(E){E.message.startsWith("EACCES")&&(P=await C.Promises.lstat(v))}return P?!P.isDirectory():!1}return!1}for(const v of T){let P;if(b.isAbsolute(v)?P=b.join(v,m):P=b.join(S,v,m),await d(P))return P;let E=P+".com";if(await d(E)||(E=P+".exe",await d(E)))return E}return b.join(S,m)}c.findExecutable=h})(a||(t.win32=a={}))}),define(se[91],oe([0,1,35,13,90,58]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShell=L;async function L(c,h){return c===D.OperatingSystem.Windows?D.isWindows?a():R.getWindowsShell(h):p(c,h)}let C=null;function p(c,h){if(D.isLinux&&c===D.OperatingSystem.Macintosh||D.isMacintosh&&c===D.OperatingSystem.Linux)return"/bin/bash";if(!C){let m;if(D.isWindows)m="/bin/bash";else{if(m=h.SHELL,!m)try{m=(0,b.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}C=m}return C}let l=null;async function a(){return l||(l=(await(0,y.getFirstAvailablePowerShellInstallation)()).exePath),l}});var Se=this&&this.__decorate||function(H,t,b,D){var y=arguments.length,R=y<3?t:D===null?D=Object.getOwnPropertyDescriptor(t,b):D,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(H,t,b,D);else for(var C=H.length-1;C>=0;C--)(L=H[C])&&(R=(y<3?L(R):y>3?L(t,b,R):L(t,b))||R);return y>3&&R&&Object.defineProperty(t,b,R),R};define(se[59],oe([0,1,20,8,14,22,55,9,5,2,47,32,3]),function(H,t,b,D,y,R,L,C,p,l,a,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.BufferWriter=t.BufferReader=void 0,t.serialize=s,t.deserialize=f,t.getDelayedChannel=_,t.getNextTickChannel=K;var m;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(m||(m={}));function S(z){switch(z){case m.Promise:return"req";case m.PromiseCancel:return"cancel";case m.EventListen:return"subscribe";case m.EventDispose:return"unsubscribe"}}var T;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(T||(T={}));function g(z){switch(z){case T.Initialize:return"init";case T.PromiseSuccess:return"reply:";case T.PromiseError:case T.PromiseErrorObj:return"replyErr:";case T.EventFire:return"event:"}}var d;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(d||(d={}));function v(z){let M=0;for(let G=0;;G+=7){const J=z.read(1);if(M|=(J.buffer[0]&127)<<G,!(J.buffer[0]&128))return M}}const P=r(0);function E(z,M){if(M===0){z.write(P);return}let G=0;for(let Q=M;Q!==0;Q=Q>>>7)G++;const J=y.VSBuffer.alloc(G);for(let Q=0;M!==0;Q++)J.buffer[Q]=M&127,M=M>>>7,M>0&&(J.buffer[Q]|=128);z.write(J)}class u{constructor(M){this.buffer=M,this.pos=0}read(M){const G=this.buffer.slice(this.pos,this.pos+M);return this.pos+=G.byteLength,G}}t.BufferReader=u;class i{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}t.BufferWriter=i;var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(o||(o={}));function r(z){const M=y.VSBuffer.alloc(1);return M.writeUInt8(z,0),M}const e={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function s(z,M){if(typeof M>"u")z.write(e.Undefined);else if(typeof M=="string"){const G=y.VSBuffer.fromString(M);z.write(e.String),E(z,G.byteLength),z.write(G)}else if(n&&Buffer.isBuffer(M)){const G=y.VSBuffer.wrap(M);z.write(e.Buffer),E(z,G.byteLength),z.write(G)}else if(M instanceof y.VSBuffer)z.write(e.VSBuffer),E(z,M.byteLength),z.write(M);else if(Array.isArray(M)){z.write(e.Array),E(z,M.length);for(const G of M)s(z,G)}else if(typeof M=="number"&&(M|0)===M)z.write(e.Uint),E(z,M);else{const G=y.VSBuffer.fromString(JSON.stringify(M));z.write(e.Object),E(z,G.byteLength),z.write(G)}}function f(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(v(z)).toString();case o.Buffer:return z.read(v(z)).buffer;case o.VSBuffer:return z.read(v(z));case o.Array:{const G=v(z),J=[];for(let Q=0;Q<G;Q++)J.push(f(z));return J}case o.Object:return JSON.parse(z.read(v(z)).toString());case o.Int:return v(z)}}class I{constructor(M,G,J=null,Q=1e3){this.protocol=M,this.ctx=G,this.logger=J,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(U=>this.onRawMessage(U)),this.sendResponse({type:T.Initialize})}registerChannel(M,G){this.channels.set(M,G),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case T.Initialize:{const G=this.send([M.type]);this.logger?.logOutgoing(G,0,O.OtherSide,g(M.type));return}case T.PromiseSuccess:case T.PromiseError:case T.EventFire:case T.PromiseErrorObj:{const G=this.send([M.type,M.id],M.data);this.logger?.logOutgoing(G,M.id,O.OtherSide,g(M.type),M.data);return}}}send(M,G=void 0){const J=new i;return s(J,M),s(J,G),this.sendBuffer(J.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onRawMessage(M){const G=new u(M),J=f(G),Q=f(G),U=J[0];switch(U){case m.Promise:return this.logger?.logIncoming(M.byteLength,J[1],O.OtherSide,`${S(U)}: ${J[2]}.${J[3]}`,Q),this.onPromise({type:U,id:J[1],channelName:J[2],name:J[3],arg:Q});case m.EventListen:return this.logger?.logIncoming(M.byteLength,J[1],O.OtherSide,`${S(U)}: ${J[2]}.${J[3]}`,Q),this.onEventListen({type:U,id:J[1],channelName:J[2],name:J[3],arg:Q});case m.PromiseCancel:return this.logger?.logIncoming(M.byteLength,J[1],O.OtherSide,`${S(U)}`),this.disposeActiveRequest({type:U,id:J[1]});case m.EventDispose:return this.logger?.logIncoming(M.byteLength,J[1],O.OtherSide,`${S(U)}`),this.disposeActiveRequest({type:U,id:J[1]})}}onPromise(M){const G=this.channels.get(M.channelName);if(!G){this.collectPendingRequest(M);return}const J=new R.CancellationTokenSource;let Q;try{Q=G.call(this.ctx,M.name,M.arg,J.token)}catch(q){Q=Promise.reject(q)}const U=M.id;Q.then(q=>{this.sendResponse({id:U,data:q,type:T.PromiseSuccess})},q=>{q instanceof Error?this.sendResponse({id:U,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:T.PromiseError}):this.sendResponse({id:U,data:q,type:T.PromiseErrorObj})}).finally(()=>{W.dispose(),this.activeRequests.delete(M.id)});const W=(0,l.toDisposable)(()=>J.cancel());this.activeRequests.set(M.id,W)}onEventListen(M){const G=this.channels.get(M.channelName);if(!G){this.collectPendingRequest(M);return}const J=M.id,U=G.listen(this.ctx,M.name,M.arg)(W=>this.sendResponse({id:J,data:W,type:T.EventFire}));this.activeRequests.set(M.id,U)}disposeActiveRequest(M){const G=this.activeRequests.get(M.id);G&&(G.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let G=this.pendingRequests.get(M.channelName);G||(G=[],this.pendingRequests.set(M.channelName,G));const J=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===m.Promise&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:T.PromiseError})},this.timeoutDelay);G.push({request:M,timeoutTimer:J})}flushPendingRequests(M){const G=this.pendingRequests.get(M);if(G){for(const J of G)switch(clearTimeout(J.timeoutTimer),J.request.type){case m.Promise:this.onPromise(J.request);break;case m.EventListen:this.onEventListen(J.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=I;var O;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(O||(t.RequestInitiator=O={}));class N{constructor(M,G=null){this.protocol=M,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=G}getChannel(M){const G=this;return{call(J,Q,U){return G.isDisposed?Promise.reject(new C.CancellationError):G.requestPromise(M,J,Q,U)},listen(J,Q){return G.isDisposed?p.Event.None:G.requestEvent(M,J,Q)}}}requestPromise(M,G,J,Q=R.CancellationToken.None){const U=this.lastRequestId++,W=m.Promise,q={id:U,type:W,channelName:M,name:G,arg:J};if(Q.isCancellationRequested)return Promise.reject(new C.CancellationError);let $;return new Promise((A,x)=>{if(Q.isCancellationRequested)return x(new C.CancellationError);const V=()=>{const he=fe=>{switch(fe.type){case T.PromiseSuccess:this.handlers.delete(U),A(fe.data);break;case T.PromiseError:{this.handlers.delete(U);const ye=new Error(fe.data.message);ye.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ye.name=fe.data.name,x(ye);break}case T.PromiseErrorObj:this.handlers.delete(U),x(fe.data);break}};this.handlers.set(U,he),this.sendRequest(q)};let Y=null;this.state===d.Idle?V():(Y=(0,D.createCancelablePromise)(he=>this.whenInitialized()),Y.then(()=>{Y=null,V()}));const X=()=>{Y?(Y.cancel(),Y=null):this.sendRequest({id:U,type:m.PromiseCancel}),x(new C.CancellationError)},ne=Q.onCancellationRequested(X);$=(0,l.combinedDisposable)((0,l.toDisposable)(X),ne),this.activeRequests.add($)}).finally(()=>{$.dispose(),this.activeRequests.delete($)})}requestEvent(M,G,J){const Q=this.lastRequestId++,U=m.EventListen,W={id:Q,type:U,channelName:M,name:G,arg:J};let q=null;const $=new p.Emitter({onWillAddFirstListener:()=>{q=(0,D.createCancelablePromise)(A=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add($),this.sendRequest(W)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete($),this.sendRequest({id:Q,type:m.EventDispose}))}}),w=A=>$.fire(A.data);return this.handlers.set(Q,w),$.event}sendRequest(M){switch(M.type){case m.Promise:case m.EventListen:{const G=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger?.logOutgoing(G,M.id,O.LocalSide,`${S(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case m.PromiseCancel:case m.EventDispose:{const G=this.send([M.type,M.id]);this.logger?.logOutgoing(G,M.id,O.LocalSide,S(M.type));return}}}send(M,G=void 0){const J=new i;return s(J,M),s(J,G),this.sendBuffer(J.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onBuffer(M){const G=new u(M),J=f(G),Q=f(G),U=J[0];switch(U){case T.Initialize:return this.logger?.logIncoming(M.byteLength,0,O.LocalSide,g(U)),this.onResponse({type:J[0]});case T.PromiseSuccess:case T.PromiseError:case T.EventFire:case T.PromiseErrorObj:return this.logger?.logIncoming(M.byteLength,J[1],O.LocalSide,g(U),Q),this.onResponse({type:J[0],id:J[1],data:Q})}}onResponse(M){if(M.type===T.Initialize){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(M.id)?.(M)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelClient=N,Se([L.memoize],N.prototype,"onDidInitializePromise",null);class k{get connections(){const M=[];return this._connections.forEach(G=>M.push(G)),M}constructor(M,G,J){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add(M(({protocol:Q,onDidClientDisconnect:U})=>{const W=p.Event.once(Q.onMessage);this.disposables.add(W(q=>{const $=new u(q),w=f($),A=new I(Q,w,G,J),x=new N(Q,G);this.channels.forEach((Y,X)=>A.registerChannel(X,Y));const V={channelServer:A,channelClient:x,ctx:w};this._connections.add(V),this._onDidAddConnection.fire(V),this.disposables.add(U(()=>{A.dispose(),x.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)}))}))}))}getChannel(M,G){const J=this;return{call(Q,U,W){let q;if((0,h.isFunction)(G)){const w=(0,b.getRandomElement)(J.connections.filter(G));q=w?Promise.resolve(w):p.Event.toPromise(p.Event.filter(J.onDidAddConnection,G))}else q=G.routeCall(J,Q,U);const $=q.then(w=>w.channelClient.getChannel(M));return _($).call(Q,U,W)},listen(Q,U){if((0,h.isFunction)(G))return J.getMulticastEvent(M,G,Q,U);const W=G.routeEvent(J,Q,U).then(q=>q.channelClient.getChannel(M));return _(W).listen(Q,U)}}}getMulticastEvent(M,G,J,Q){const U=this;let W;const q=new p.Emitter({onWillAddFirstListener:()=>{W=new l.DisposableStore;const $=new p.EventMultiplexer,w=new Map,A=V=>{const X=V.channelClient.getChannel(M).listen(J,Q),ne=$.add(X);w.set(V,ne)},x=V=>{const Y=w.get(V);Y&&(Y.dispose(),w.delete(V))};U.connections.filter(G).forEach(A),p.Event.filter(U.onDidAddConnection,G)(A,void 0,W),U.onDidRemoveConnection(x,void 0,W),$.event(q.fire,q,W),W.add($)},onDidRemoveLastListener:()=>{W?.dispose(),W=void 0}});return q.event}registerChannel(M,G){this.channels.set(M,G);for(const J of this._connections)J.channelServer.registerChannel(M,G)}dispose(){this.disposables.dispose();for(const M of this._connections)M.channelClient.dispose(),M.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=k;class F{constructor(M,G,J=null){const Q=new i;s(Q,G),M.send(Q.buffer),this.channelClient=new N(M,J),this.channelServer=new I(M,G,J)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,G){this.channelServer.registerChannel(M,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=F;function _(z){return{call(M,G,J){return z.then(Q=>Q.call(M,G,J))},listen(M,G){const J=new p.Relay;return z.then(Q=>J.input=Q.listen(M,G)),J.event}}}function K(z){let M=!1;return{call(G,J,Q){return M?z.call(G,J,Q):(0,D.timeout)(0).then(()=>M=!0).then(()=>z.call(G,J,Q))},listen(G,J){if(M)return z.listen(G,J);const Q=new p.Relay;return(0,D.timeout)(0).then(()=>M=!0).then(()=>Q.input=z.listen(G,J)),Q.event}}}class ae{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const G of M.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await p.Event.toPromise(M.onDidAddConnection),await this.route(M)}}t.StaticRouter=ae;var ie;(function(z){function M(U,W,q){const $=U,w=q&&q.disableMarshalling,A=new Map;for(const x in $)J(x)&&A.set(x,p.Event.buffer($[x],!0,void 0,W));return new class{listen(x,V,Y){const X=A.get(V);if(X)return X;const ne=$[V];if(typeof ne=="function"){if(Q(V))return ne.call($,Y);if(J(V))return A.set(V,p.Event.buffer($[V],!0,void 0,W)),A.get(V)}throw new C.ErrorNoTelemetry(`Event not found: ${V}`)}call(x,V,Y){const X=$[V];if(typeof X=="function"){if(!w&&Array.isArray(Y))for(let he=0;he<Y.length;he++)Y[he]=(0,a.revive)(Y[he]);let ne=X.apply($,Y);return ne instanceof Promise||(ne=Promise.resolve(ne)),ne}throw new C.ErrorNoTelemetry(`Method not found: ${V}`)}}}z.fromService=M;function G(U,W){const q=W&&W.disableMarshalling;return new Proxy({},{get($,w){if(typeof w=="string")return W?.properties?.has(w)?W.properties.get(w):Q(w)?function(A){return U.listen(w,A)}:J(w)?U.listen(w):async function(...A){let x;W&&!(0,h.isUndefinedOrNull)(W.context)?x=[W.context,...A]:x=A;const V=await U.call(w,x);return q?V:(0,a.revive)(V)};throw new C.ErrorNoTelemetry(`Property not found: ${String(w)}`)}})}z.toService=G;function J(U){return U[0]==="o"&&U[1]==="n"&&c.isUpperAsciiLetter(U.charCodeAt(2))}function Q(U){return/^onDynamic/.test(U)&&c.isUpperAsciiLetter(U.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const M=z.toString();if(M!=="[object Object]")return M}return z}function le(z){return Array.isArray(z)?z.map(ue):ue(z)}function B(z,M,G,J,Q,U,W){W=le(W);const q=ce[Q],$=q[J%q.length];let w=[`%c[${z}]%c[${String(M).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${U}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(U)?(w=w.concat(W),w.push(")")):w.push(W),console.log.apply(console,w)}class Z{constructor(M,G){this._outgoingPrefix=M,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,G,J,Q,U){this._totalOutgoing+=M,B(this._outgoingPrefix,this._totalOutgoing,M,G,J,Q,U)}logIncoming(M,G,J,Q,U){this._totalIncoming+=M,B(this._incomingPrefix,this._totalIncoming,M,G,J,Q,U)}}t.IPCLogger=Z}),define(se[92],oe([0,1,60,8,14,22,87,9,5,2,28,58,57,59]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class S extends m.ChannelServer{constructor(d){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",v=>y.VSBuffer.wrap(Buffer.from(v,"base64")))},d),process.once("disconnect",()=>this.dispose())}}t.Server=S;class T{constructor(d,v){this.modulePath=d,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new D.Delayer(P),this.child=null,this._client=null}getChannel(d){const v=this;return{call(P,E,u){return v.requestPromise(d,P,E,u)},listen(P,E){return v.requestEvent(d,P,E)}}}requestPromise(d,v,P,E=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(d),i=(0,D.createCancelablePromise)(e=>u.call(v,P,e)),o=E.onCancellationRequested(()=>i.cancel()),r=(0,l.toDisposable)(()=>i.cancel());return this.activeRequests.add(r),i.finally(()=>{o.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(d,v,P){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let E;const u=new p.Emitter({onWillAddFirstListener:()=>{E=this.getCachedChannel(d).listen(v,P)(u.fire,u),this.activeRequests.add(E)},onDidRemoveLastListener:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,a.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,h.removeDangerousEnvVariables)(v.env),this.child=(0,b.fork)(this.modulePath,d,v);const P=new p.Emitter,u=p.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,L.isRemoteConsoleLog)(s)){(0,L.log)(s,`IPC Library: ${this.options.serverName}`);return}P.fire(y.VSBuffer.wrap(Buffer.from(s,"base64")))}),i=this.options.useQueue?(0,c.createQueuedSender)(this.child):this.child,o=s=>this.child&&this.child.connected&&i.send(s.buffer.toString("base64")),r=P.event,e={send:o,onMessage:r};this._client=new m.ChannelClient(e);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,f)=>{process.removeListener("exit",n),u.dispose(),this.activeRequests.forEach(I=>(0,l.dispose)(I)),this.activeRequests.clear(),s!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+f),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:f})})}return this._client}getCachedChannel(d){let v=this.channels.get(d);return v||(v=this.client.getChannel(d),this.channels.set(d,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}t.Client=T}),define(se[93],oe([0,1,8,5,2,47,3]),function(H,t,b,D,y,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageState=t.StorageHint=void 0,t.isStorageItemsChangeEvent=p;var C;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(t.StorageHint=C={}));function p(h){const m=h;return m?.changed instanceof Map||m?.deleted instanceof Set}var l;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(l||(t.StorageState=l={}));class a extends y.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(m,S=Object.create(null)){super(),this.database=m,this.options=S,this._onDidChangeStorage=this._register(new D.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new b.ThrottledDelayer(a.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){this._onDidChangeStorage.pause();try{m.changed?.forEach((S,T)=>this.acceptExternal(T,S)),m.deleted?.forEach(S=>this.acceptExternal(S,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(m,S){if(this.state===l.Closed)return;let T=!1;(0,L.isUndefinedOrNull)(S)?T=this.cache.delete(m):this.cache.get(m)!==S&&(this.cache.set(m,S),T=!0),T&&this._onDidChangeStorage.fire({key:m,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,S){const T=this.cache.get(m);return(0,L.isUndefinedOrNull)(T)?S:T}getBoolean(m,S){const T=this.get(m);return(0,L.isUndefinedOrNull)(T)?S:T==="true"}getNumber(m,S){const T=this.get(m);return(0,L.isUndefinedOrNull)(T)?S:parseInt(T,10)}getObject(m,S){const T=this.get(m);return(0,L.isUndefinedOrNull)(T)?S:(0,R.parse)(T)}async set(m,S,T=!1){if(this.state===l.Closed)return;if((0,L.isUndefinedOrNull)(S))return this.delete(m,T);const g=(0,L.isObject)(S)||Array.isArray(S)?(0,R.stringify)(S):String(S);if(this.cache.get(m)!==g)return this.cache.set(m,g),this.pendingInserts.set(m,g),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire({key:m,external:T}),this.doFlush()}async delete(m,S=!1){if(!(this.state===l.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire({key:m,external:S}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!(this.state===l.Closed||this.pendingClose))return this.doFlush(m)}async doFlush(m){return this.options.hint===C.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}isInMemory(){return this.options.hint===C.STORAGE_IN_MEMORY}}t.Storage=a;class c{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((S,T)=>this.items.set(T,S)),m.delete?.forEach(S=>this.items.delete(S))}async optimize(){}async close(){}}t.InMemoryStorageDatabase=c}),define(se[94],oe([7,4]),function(H,t){return H.create("vs/base/node/zip",t)}),define(se[49],oe([0,1,61,8,16,3,25,94]),function(H,t,b,D,y,R,L,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtractError=t.CorruptZipMessage=void 0,t.zip=g,t.extract=d,t.buffer=P,t.CorruptZipMessage="end of central directory record signature not found";const p=new RegExp(t.CorruptZipMessage);class l extends Error{constructor(u,i){let o=i.message;switch(u){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=u,this.cause=i}}t.ExtractError=l;function a(E){const u=E.externalFileAttributes>>16||33188;return[448,56,7].map(i=>u&i).reduce((i,o)=>i+o,u&61440)}function c(E){if(E instanceof l)return E;let u;return p.test(E.message)&&(u="CorruptZip"),new l(u,E)}function h(E,u,i,o,r,e){const n=y.dirname(u),s=y.join(o,n);if(!s.startsWith(o))return Promise.reject(new Error(C.localize(0,null,u)));const f=y.join(o,u);let I;return e.onCancellationRequested(()=>{I?.destroy()}),Promise.resolve(L.Promises.mkdir(s,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!e.isCancellationRequested)try{I=(0,b.createWriteStream)(f,{mode:i}),I.once("close",()=>O()),I.once("error",N),E.once("error",N),E.pipe(I)}catch(k){N(k)}}))}function m(E,u,i,o){let r=(0,D.createCancelablePromise)(()=>Promise.resolve()),e=0;const n=o.onCancellationRequested(()=>{r.cancel(),E.close()});return new Promise((s,f)=>{const I=new D.Sequencer,O=N=>{N.isCancellationRequested||(e++,E.readEntry())};E.once("error",f),E.once("close",()=>r.then(()=>{o.isCancellationRequested||E.entryCount===e?s():f(new l("Incomplete",new Error(C.localize(1,null,e,E.entryCount))))},f)),E.readEntry(),E.on("entry",N=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(N.fileName)){O(o);return}const k=N.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(k)){const K=y.join(u,k);r=(0,D.createCancelablePromise)(ae=>L.Promises.mkdir(K,{recursive:!0}).then(()=>O(ae)).then(void 0,f));return}const F=T(E,N),_=a(N);r=(0,D.createCancelablePromise)(K=>I.queue(()=>F.then(ae=>h(ae,k,_,u,i,K).then(()=>O(K)))).then(null,f))})}).finally(()=>n.dispose())}async function S(E,u=!1){const{open:i}=await new Promise((o,r)=>{H(["yauzl"],o,r)});return new Promise((o,r)=>{i(E,u?{lazyEntries:!0}:void 0,(e,n)=>{e?r(c(e)):o((0,R.assertIsDefined)(n))})})}function T(E,u){return new Promise((i,o)=>{E.openReadStream(u,(r,e)=>{r?o(c(r)):i((0,R.assertIsDefined)(e))})})}async function g(E,u){const{ZipFile:i}=await new Promise((o,r)=>{H(["yazl"],o,r)});return new Promise((o,r)=>{const e=new i;u.forEach(s=>{s.contents?e.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&e.addFile(s.localPath,s.path)}),e.end();const n=(0,b.createWriteStream)(E);e.outputStream.pipe(n),e.outputStream.once("error",r),n.once("error",r),n.once("finish",()=>o(E))})}function d(E,u,i={},o){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let e=S(E,!0);return i.overwrite&&(e=e.then(n=>L.Promises.rm(u).then(()=>n))),e.then(n=>m(n,u,{sourcePathRegex:r},o))}function v(E,u){return S(E).then(i=>new Promise((o,r)=>{i.on("entry",e=>{e.fileName===u&&T(i,e).then(n=>o(n),n=>r(n))}),i.once("close",()=>r(new Error(C.localize(2,null,u))))}))}function P(E,u){return v(E,u).then(i=>new Promise((o,r)=>{const e=[];i.once("error",r),i.on("data",n=>e.push(n)),i.on("end",()=>o(Buffer.concat(e)))}))}}),define(se[95],oe([7,4]),function(H,t){return H.create("vs/platform/configuration/common/configurationRegistry",t)}),define(se[96],oe([7,4]),function(H,t){return H.create("vs/platform/contextkey/common/contextkey",t)}),define(se[97],oe([7,4]),function(H,t){return H.create("vs/platform/contextkey/common/scanner",t)}),define(se[98],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(se[99],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(se[100],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionManagementCLI",t)}),define(se[101],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionNls",t)}),define(se[102],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(se[103],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(se[104],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(se[105],oe([7,4]),function(H,t){return H.create("vs/platform/extensions/common/extensionValidator",t)}),define(se[106],oe([7,4]),function(H,t){return H.create("vs/platform/files/common/fileService",t)}),define(se[107],oe([7,4]),function(H,t){return H.create("vs/platform/files/common/io",t)}),define(se[108],oe([7,4]),function(H,t){return H.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(se[109],oe([7,4]),function(H,t){return H.create("vs/platform/languagePacks/common/languagePacks",t)}),define(se[110],oe([7,4]),function(H,t){return H.create("vs/platform/log/common/log",t)}),define(se[111],oe([7,4]),function(H,t){return H.create("vs/platform/request/common/request",t)}),define(se[112],oe([7,4]),function(H,t){return H.create("vs/platform/shell/node/shellEnv",t)}),define(se[113],oe([7,4]),function(H,t){return H.create("vs/platform/telemetry/common/telemetryService",t)}),define(se[114],oe([7,4]),function(H,t){return H.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(se[115],oe([7,4]),function(H,t){return H.create("vs/platform/workspace/common/workspace",t)}),define(se[116],oe([0,1,117,9,97]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Scanner=t.TokenType=void 0;var R;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(R||(t.TokenType=R={}));function L(...a){switch(a.length){case 1:return(0,y.localize)(0,null,a[0]);case 2:return(0,y.localize)(1,null,a[0],a[1]);case 3:return(0,y.localize)(2,null,a[0],a[1],a[2]);default:return}}const C=(0,y.localize)(3,null),p=(0,y.localize)(4,null);class l{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(c){switch(c.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return c.isTripleEq?"===":"==";case R.NotEq:return c.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return c.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return c.lexeme;case R.QuotedStr:return c.lexeme;case R.Error:return c.lexeme;case R.EOF:return"EOF";default:throw(0,D.illegalState)(`unhandled token type: ${JSON.stringify(c)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0)))}static{this._keywords=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this._errors}reset(c){return this._input=c,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case b.CharCode.OpenParen:this._addToken(R.LParen);break;case b.CharCode.CloseParen:this._addToken(R.RParen);break;case b.CharCode.ExclamationMark:if(this._match(b.CharCode.Equals)){const h=this._match(b.CharCode.Equals);this._tokens.push({type:R.NotEq,offset:this._start,isTripleEq:h})}else this._addToken(R.Neg);break;case b.CharCode.SingleQuote:this._quotedString();break;case b.CharCode.Slash:this._regex();break;case b.CharCode.Equals:if(this._match(b.CharCode.Equals)){const h=this._match(b.CharCode.Equals);this._tokens.push({type:R.Eq,offset:this._start,isTripleEq:h})}else this._match(b.CharCode.Tilde)?this._addToken(R.RegexOp):this._error(L("==","=~"));break;case b.CharCode.LessThan:this._addToken(this._match(b.CharCode.Equals)?R.LtEq:R.Lt);break;case b.CharCode.GreaterThan:this._addToken(this._match(b.CharCode.Equals)?R.GtEq:R.Gt);break;case b.CharCode.Ampersand:this._match(b.CharCode.Ampersand)?this._addToken(R.And):this._error(L("&&"));break;case b.CharCode.Pipe:this._match(b.CharCode.Pipe)?this._addToken(R.Or):this._error(L("||"));break;case b.CharCode.Space:case b.CharCode.CarriageReturn:case b.CharCode.Tab:case b.CharCode.LineFeed:case b.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(R.EOF),Array.from(this._tokens)}_match(c){return this._isAtEnd()||this._input.charCodeAt(this._current)!==c?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?b.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(c){this._tokens.push({type:c,offset:this._start})}_error(c){const h=this._start,m=this._input.substring(this._start,this._current),S={type:R.Error,offset:this._start,lexeme:m};this._errors.push({offset:h,lexeme:m,additionalInfo:c}),this._tokens.push(S)}_string(){this.stringRe.lastIndex=this._start;const c=this.stringRe.exec(this._input);if(c){this._current=this._start+c[0].length;const h=this._input.substring(this._start,this._current),m=l._keywords.get(h);m?this._addToken(m):this._tokens.push({type:R.Str,lexeme:h,offset:this._start})}}_quotedString(){for(;this._peek()!==b.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(C);return}this._advance(),this._tokens.push({type:R.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let c=this._current,h=!1,m=!1;for(;;){if(c>=this._input.length){this._current=c,this._error(p);return}const T=this._input.charCodeAt(c);if(h)h=!1;else if(T===b.CharCode.Slash&&!m){c++;break}else T===b.CharCode.OpenSquareBracket?m=!0:T===b.CharCode.Backslash?h=!0:T===b.CharCode.CloseSquareBracket&&(m=!1);c++}for(;c<this._input.length&&l._regexFlags.has(this._input.charCodeAt(c));)c++;this._current=c;const S=this._input.substring(this._start,this._current);this._tokens.push({type:R.RegexStr,lexeme:S,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}t.Scanner=l}),define(se[118],oe([0,1,83,55,15,16,37,17,12]),function(H,t,b,D,y,R,L,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractNativeEnvironmentService=t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,t.parseExtensionHostDebugPort=a,t.parseDebugParams=c,t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,R.dirname)(y.FileAccess.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return p.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.paths.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,C.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:y.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",m)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(p.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=L.env.VSCODE_PORTABLE;return m?p.URI.file((0,R.join)(m,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,R.resolve)(m):(0,R.normalize)((0,R.join)(y.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?p.URI.file((0,R.resolve)(m)):p.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,R.resolve)(m);const S=L.env.VSCODE_EXTENSIONS;if(S)return S;const T=L.env.VSCODE_PORTABLE;return T?(0,R.join)(T,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(S=>/^[^:/?#]+?:\/\//.test(S)?p.URI.parse(S):p.URI.file((0,R.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?p.URI.parse(m):p.URI.file((0,R.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return a(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const S of this.args.log||[]){const T=t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);T&&T[1]&&T[2]&&m.push([T[1],T[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,C.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=L.env.VSCODE_PORTABLE;return m?p.URI.file((0,R.join)(m,"policy.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this._args}constructor(m,S,T){this._args=m,this.paths=S,this.productService=T,this.editSessionId=this.args.editSessionId}}t.AbstractNativeEnvironmentService=l,Se([D.memoize],l.prototype,"appRoot",null),Se([D.memoize],l.prototype,"userHome",null),Se([D.memoize],l.prototype,"userDataPath",null),Se([D.memoize],l.prototype,"appSettingsHome",null),Se([D.memoize],l.prototype,"tmpDir",null),Se([D.memoize],l.prototype,"cacheHome",null),Se([D.memoize],l.prototype,"stateResource",null),Se([D.memoize],l.prototype,"userRoamingDataHome",null),Se([D.memoize],l.prototype,"userDataSyncHome",null),Se([D.memoize],l.prototype,"sync",null),Se([D.memoize],l.prototype,"machineSettingsResource",null),Se([D.memoize],l.prototype,"workspaceStorageHome",null),Se([D.memoize],l.prototype,"localHistoryHome",null),Se([D.memoize],l.prototype,"keyboardLayoutResource",null),Se([D.memoize],l.prototype,"argvResource",null),Se([D.memoize],l.prototype,"isExtensionDevelopment",null),Se([D.memoize],l.prototype,"untitledWorkspacesHome",null),Se([D.memoize],l.prototype,"builtinExtensionsPath",null),Se([D.memoize],l.prototype,"extensionsPath",null),Se([D.memoize],l.prototype,"extensionDevelopmentLocationURI",null),Se([D.memoize],l.prototype,"extensionDevelopmentKind",null),Se([D.memoize],l.prototype,"extensionTestsLocationURI",null),Se([D.memoize],l.prototype,"debugExtensionHost",null),Se([D.memoize],l.prototype,"logLevel",null),Se([D.memoize],l.prototype,"extensionLogLevel",null),Se([D.memoize],l.prototype,"serviceMachineIdResource",null),Se([D.memoize],l.prototype,"disableTelemetry",null),Se([D.memoize],l.prototype,"disableWorkspaceTrust",null),Se([D.memoize],l.prototype,"useInMemorySecretStorage",null),Se([D.memoize],l.prototype,"policyFile",null);function a(h,m){return c(h["inspect-extensions"],h["inspect-brk-extensions"],5870,m,h.debugId,h.extensionEnvironment)}function c(h,m,S,T,g,d){const P=Number(m||h)||(T?null:S),E=P?!!m:!1;let u;if(d)try{u=JSON.parse(d)}catch{}return{port:P,break:E,debugId:g,env:u}}}),function(){"use strict";function H(t,b,D){function y(L,C){const p=R(L,C),l=[p];return t.isAbsolute(p)||l.unshift(D),t.resolve(...l)}function R(L,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return t.join(p,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return t.join(l,C);const a=L["user-data-dir"];if(a)return a;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const c=process.env.USERPROFILE;if(typeof c!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=t.join(c,"AppData","Roaming")}break;case"darwin":l=t.join(b.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||t.join(b.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(l,C)}return{getUserDataPath:y}}if(typeof define=="function")define(se[119],oe([172,35,37]),function(t,b,D){return H(t,b,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("path"),b=require("os");module.exports=H(t,b,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[120],oe([0,1,35,118,119]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0,t.parsePtyHostDebugPort=L,t.parseSharedProcessDebugPort=C;class R extends D.AbstractNativeEnvironmentService{constructor(l,a){super(l,{homeDir:(0,b.homedir)(),tmpDir:(0,b.tmpdir)(),userDataDir:(0,y.getUserDataPath)(l,a.nameShort)},a)}}t.NativeEnvironmentService=R;function L(p,l){return(0,D.parseDebugParams)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,l,p.extensionEnvironment)}function C(p,l){return(0,D.parseDebugParams)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,l,p.extensionEnvironment)}}),define(se[121],oe([0,1,3,101]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=y;function y(L,C,p,l){try{R(L,C,p,l)}catch(a){L.error(a?.message??a)}return C}function R(L,C,p,l){const a=(c,h,m)=>{const S=c[h];if((0,b.isString)(S)){const T=S,g=T.length;if(g>1&&T[0]==="%"&&T[g-1]==="%"){const d=T.substr(1,g-2);let v=p[d];v===void 0&&l&&(v=l[d]);const P=typeof v=="string"?v:v?.message,E=l?.[d],u=typeof E=="string"?E:E?.message;if(!P){u||L.warn(`[${C.name}]: ${(0,D.localize)(0,null,d)}`);return}if(m&&(h==="title"||h==="category")&&u&&u!==P){const i={value:P,original:u};c[h]=i}else c[h]=P}}else if((0,b.isObject)(S))for(const T in S)S.hasOwnProperty(T)&&(T==="commands"?a(S,T,!0):a(S,T,m));else if(Array.isArray(S))for(let T=0;T<S.length;T++)a(S,T,m)};for(const c in C)C.hasOwnProperty(c)&&a(C,c)}}),define(se[50],oe([0,1,17,56,105,44]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidVersionStr=p,t.parseVersion=l,t.normalizeVersion=a,t.isValidVersion=c,t.validateExtensionManifest=h,t.isValidExtensionVersion=m,t.isEngineValid=S;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function p(d){return d=d.trim(),d==="*"||L.test(d)}function l(d){if(!p(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=d.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}function a(d){if(!d)return null;const v=d.majorBase,P=d.majorMustEqual,E=d.minorBase;let u=d.minorMustEqual;const i=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(v===0||(u=!1),o=!1);let r=0;if(d.preRelease){const e=C.exec(d.preRelease);if(e){const[,n,s,f]=e;r=Date.UTC(Number(n),Number(s)-1,Number(f))}}return{majorBase:v,majorMustEqual:P,minorBase:E,minorMustEqual:u,patchBase:i,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:r}}function c(d,v,P){let E;typeof d=="string"?E=a(l(d)):E=d;let u;v instanceof Date?u=v.getTime():typeof v=="string"&&(u=new Date(v).getTime());let i;if(typeof P=="string"?i=a(l(P)):i=P,!E||!i)return!1;const o=E.majorBase,r=E.minorBase,e=E.patchBase;let n=i.majorBase,s=i.minorBase,f=i.patchBase;const I=i.notBefore;let O=i.majorMustEqual,N=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?o>n?!0:o<n?!1:r>s?!0:r<s||u&&u<I?!1:e>=f:(o===1&&n===0&&(!O||!N||!k)&&(n=1,s=0,f=0,O=!0,N=!1,k=!1),o<n?!1:o>n?!O:r<s?!1:r>s?!N:e<f?!1:e>f?!k:!(u&&u<I))}function h(d,v,P,E,u){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([D.default.Error,y.localize(0,null)]),i;if(typeof E.name!="string")return i.push([D.default.Error,y.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([D.default.Error,y.localize(2,null,"version")]),i;if(!E.engines)return i.push([D.default.Error,y.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([D.default.Error,y.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!g(E.extensionDependencies))return i.push([D.default.Error,y.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!g(E.activationEvents))return i.push([D.default.Error,y.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([D.default.Error,y.localize(7,null,"activationEvents","main","browser")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([D.default.Warning,y.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([D.default.Error,y.localize(9,null,"main")]),i;{const e=(0,b.joinPath)(P,E.main);(0,b.isEqualOrParent)(e,P)||i.push([D.default.Warning,y.localize(10,null,e.path,P.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([D.default.Error,y.localize(11,null,"browser")]),i;{const e=(0,b.joinPath)(P,E.browser);(0,b.isEqualOrParent)(e,P)||i.push([D.default.Warning,y.localize(12,null,e.path,P.path)])}}if(!R.valid(E.version))return i.push([D.default.Error,y.localize(13,null)]),i;const o=[];if(!m(d,v,E,u,o))for(const e of o)i.push([D.default.Error,e]);return i}function m(d,v,P,E,u){return E||typeof P.main>"u"&&typeof P.browser>"u"?!0:T(d,v,P.engines.vscode,u)}function S(d,v,P){return d==="*"||T(v,P,d)}function T(d,v,P,E=[]){const u=a(l(P));if(!u)return E.push(y.localize(14,null,P)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return E.push(y.localize(15,null,P)),!1}else if(!u.majorMustEqual)return E.push(y.localize(16,null,P)),!1;return c(d,v,u)?!0:(E.push(y.localize(17,null,d,P)),!1)}function g(d){if(!Array.isArray(d))return!1;for(let v=0,P=d.length;v<P;v++)if(typeof d[v]!="string")return!1;return!0}}),define(se[51],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class b{constructor(y,R=[],L=!1){this.ctor=y,this.staticArguments=R,this.supportsDelayedInstantiation=L}}t.SyncDescriptor=b}),define(se[122],oe([0,1,51]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationType=void 0,t.registerSingleton=R,t.getSingletonServiceDescriptors=L;const D=[];var y;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(y||(t.InstantiationType=y={}));function R(C,p,l){p instanceof b.SyncDescriptor||(p=new b.SyncDescriptor(p,[],!!l)),D.push([C,p])}function L(){return D}}),define(se[123],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class b{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}t.Node=b;class D{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const L of this._nodes.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const C=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(L);C.outgoing.set(p.key,p),p.incoming.set(C.key,C)}removeNode(R){const L=this._hashFn(R);this._nodes.delete(L);for(const C of this._nodes.values())C.outgoing.delete(L),C.incoming.delete(L)}lookupOrInsertNode(R){const L=this._hashFn(R);let C=this._nodes.get(L);return C||(C=new b(L,R),this._nodes.set(L,C)),C}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[L,C]of this._nodes)R.push(`${L}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this._nodes){const C=new Set([R]),p=this._findCycle(L,C);if(p)return p}}_findCycle(R,L){for(const[C,p]of R.outgoing){if(L.has(C))return[...L,C].join(" -> ");L.add(C);const l=this._findCycle(p,L);if(l)return l;L.delete(C)}}}t.Graph=D}),define(se[30],oe([0,1,3,12,11]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationTarget=t.IConfigurationService=void 0,t.isConfigurationOverrides=R,t.isConfigurationUpdateOverrides=L,t.ConfigurationTargetToString=p,t.isConfigured=l,t.toValuesTree=a,t.addToValueTree=c,t.removeFromValueTree=h,t.getConfigurationValue=S,t.merge=T,t.getLanguageTagSettingPlainKey=g,t.IConfigurationService=(0,y.createDecorator)("configurationService");function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof D.URI)}function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof D.URI)}var C;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(C||(t.ConfigurationTarget=C={}));function p(d){switch(d){case C.APPLICATION:return"APPLICATION";case C.USER:return"USER";case C.USER_LOCAL:return"USER_LOCAL";case C.USER_REMOTE:return"USER_REMOTE";case C.WORKSPACE:return"WORKSPACE";case C.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case C.DEFAULT:return"DEFAULT";case C.MEMORY:return"MEMORY"}}function l(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function a(d,v){const P=Object.create(null);for(const E in d)c(P,E,d[E],v);return P}function c(d,v,P,E){const u=v.split("."),i=u.pop();let o=d;for(let r=0;r<u.length;r++){const e=u[r];let n=o[e];switch(typeof n){case"undefined":n=o[e]=Object.create(null);break;case"object":if(n===null){E(`Ignoring ${v} as ${u.slice(0,r+1).join(".")} is null`);return}break;default:E(`Ignoring ${v} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[i]=P}catch{E(`Ignoring ${v} as ${u.join(".")} is ${JSON.stringify(o)}`)}else E(`Ignoring ${v} as ${u.join(".")} is ${JSON.stringify(o)}`)}function h(d,v){const P=v.split(".");m(d,P)}function m(d,v){const P=v.shift();if(v.length===0){delete d[P];return}if(Object.keys(d).indexOf(P)!==-1){const E=d[P];typeof E=="object"&&!Array.isArray(E)&&(m(E,v),Object.keys(E).length===0&&delete d[P])}}function S(d,v,P){function E(o,r){let e=o;for(const n of r){if(typeof e!="object"||e===null)return;e=e[n]}return e}const u=v.split("."),i=E(d,u);return typeof i>"u"?P:i}function T(d,v,P){Object.keys(v).forEach(E=>{E!=="__proto__"&&(E in d?b.isObject(d[E])&&b.isObject(v[E])?T(d[E],v[E],P):P&&(d[E]=v[E]):d[E]=v[E])})}function g(d){return d.replace(/[\[\]]/g,"")}}),define(se[124],oe([0,1,117,13,32,116,11,96,9]),function(H,t,b,D,y,R,L,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IContextKeyService=t.RawContextKey=t.ContextKeyOrExpr=t.ContextKeyAndExpr=t.ContextKeyNotRegexExpr=t.ContextKeyRegexExpr=t.ContextKeySmallerEqualsExpr=t.ContextKeySmallerExpr=t.ContextKeyGreaterEqualsExpr=t.ContextKeyGreaterExpr=t.ContextKeyNotExpr=t.ContextKeyNotEqualsExpr=t.ContextKeyNotInExpr=t.ContextKeyInExpr=t.ContextKeyEqualsExpr=t.ContextKeyDefinedExpr=t.ContextKeyTrueExpr=t.ContextKeyFalseExpr=t.ContextKeyExpr=t.Parser=t.ContextKeyExprType=void 0,t.setConstant=a,t.validateWhenClauses=r,t.expressionsAreEqualWithConstantSubstitution=e,t.implies=U;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",D.isMacintosh),l.set("isLinux",D.isLinux),l.set("isWindows",D.isWindows),l.set("isWeb",D.isWeb),l.set("isMacNative",D.isMacintosh&&!D.isWeb),l.set("isEdge",D.isEdge),l.set("isFirefox",D.isFirefox),l.set("isChrome",D.isChrome),l.set("isSafari",D.isSafari);function a($,w){if(l.get($)!==void 0)throw(0,p.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set($,w)}const c=Object.prototype.hasOwnProperty;var h;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(h||(t.ContextKeyExprType=h={}));const m={regexParsingWithErrorRecovery:!0},S=(0,C.localize)(0,null),T=(0,C.localize)(1,null),g=(0,C.localize)(2,null),d=(0,C.localize)(3,null),v=(0,C.localize)(4,null),P=(0,C.localize)(5,null),E=(0,C.localize)(6,null),u=(0,C.localize)(7,null);class i{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(w=m){this._config=w,this._scanner=new R.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(w){if(w===""){this._parsingErrors.push({message:S,offset:0,lexeme:"",additionalInfo:T});return}this._tokens=this._scanner.reset(w).scan(),this._current=0,this._parsingErrors=[];try{const A=this._expr();if(!this._isAtEnd()){const x=this._peek(),V=x.type===R.TokenType.Str?P:void 0;throw this._parsingErrors.push({message:v,offset:x.offset,lexeme:R.Scanner.getLexeme(x),additionalInfo:V}),i._parseError}return A}catch(A){if(A!==i._parseError)throw A;return}}_expr(){return this._or()}_or(){const w=[this._and()];for(;this._matchOne(R.TokenType.Or);){const A=this._and();w.push(A)}return w.length===1?w[0]:o.or(...w)}_and(){const w=[this._term()];for(;this._matchOne(R.TokenType.And);){const A=this._term();w.push(A)}return w.length===1?w[0]:o.and(...w)}_term(){if(this._matchOne(R.TokenType.Neg)){const w=this._peek();switch(w.type){case R.TokenType.True:return this._advance(),s.INSTANCE;case R.TokenType.False:return this._advance(),f.INSTANCE;case R.TokenType.LParen:{this._advance();const A=this._expr();return this._consume(R.TokenType.RParen,d),A?.negate()}case R.TokenType.Str:return this._advance(),_.create(w.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",w)}}return this._primary()}_primary(){const w=this._peek();switch(w.type){case R.TokenType.True:return this._advance(),o.true();case R.TokenType.False:return this._advance(),o.false();case R.TokenType.LParen:{this._advance();const A=this._expr();return this._consume(R.TokenType.RParen,d),A}case R.TokenType.Str:{const A=w.lexeme;if(this._advance(),this._matchOne(R.TokenType.RegexOp)){const V=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),V.type!==R.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",V);const Y=V.lexeme,X=Y.lastIndexOf("/"),ne=X===Y.length-1?void 0:this._removeFlagsGY(Y.substring(X+1));let he;try{he=new RegExp(Y.substring(1,X),ne)}catch{throw this._errExpectedButGot("REGEX",V)}return le.create(A,he)}switch(V.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const Y=[V.lexeme];this._advance();let X=this._peek(),ne=0;for(let ge=0;ge<V.lexeme.length;ge++)V.lexeme.charCodeAt(ge)===b.CharCode.OpenParen?ne++:V.lexeme.charCodeAt(ge)===b.CharCode.CloseParen&&ne--;for(;!this._isAtEnd()&&X.type!==R.TokenType.And&&X.type!==R.TokenType.Or;){switch(X.type){case R.TokenType.LParen:ne++;break;case R.TokenType.RParen:ne--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let ge=0;ge<X.lexeme.length;ge++)X.lexeme.charCodeAt(ge)===b.CharCode.OpenParen?ne++:V.lexeme.charCodeAt(ge)===b.CharCode.CloseParen&&ne--}if(ne<0)break;Y.push(R.Scanner.getLexeme(X)),this._advance(),X=this._peek()}const he=Y.join(""),fe=he.lastIndexOf("/"),ye=fe===he.length-1?void 0:this._removeFlagsGY(he.substring(fe+1));let me;try{me=new RegExp(he.substring(1,fe),ye)}catch{throw this._errExpectedButGot("REGEX",V)}return o.regex(A,me)}case R.TokenType.QuotedStr:{const Y=V.lexeme;this._advance();let X=null;if(!(0,y.isFalsyOrWhitespace)(Y)){const ne=Y.indexOf("/"),he=Y.lastIndexOf("/");if(ne!==he&&ne>=0){const fe=Y.slice(ne+1,he),ye=Y[he+1]==="i"?"i":"";try{X=new RegExp(fe,ye)}catch{throw this._errExpectedButGot("REGEX",V)}}}if(X===null)throw this._errExpectedButGot("REGEX",V);return le.create(A,X)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(R.TokenType.Not)){this._consume(R.TokenType.In,g);const V=this._value();return o.notIn(A,V)}switch(this._peek().type){case R.TokenType.Eq:{this._advance();const V=this._value();if(this._previous().type===R.TokenType.QuotedStr)return o.equals(A,V);switch(V){case"true":return o.has(A);case"false":return o.not(A);default:return o.equals(A,V)}}case R.TokenType.NotEq:{this._advance();const V=this._value();if(this._previous().type===R.TokenType.QuotedStr)return o.notEquals(A,V);switch(V){case"true":return o.not(A);case"false":return o.has(A);default:return o.notEquals(A,V)}}case R.TokenType.Lt:return this._advance(),ce.create(A,this._value());case R.TokenType.LtEq:return this._advance(),ue.create(A,this._value());case R.TokenType.Gt:return this._advance(),ae.create(A,this._value());case R.TokenType.GtEq:return this._advance(),ie.create(A,this._value());case R.TokenType.In:return this._advance(),o.in(A,this._value());default:return o.has(A)}}case R.TokenType.EOF:throw this._parsingErrors.push({message:E,offset:w.offset,lexeme:"",additionalInfo:u}),i._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const w=this._peek();switch(w.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this._advance(),w.lexeme;case R.TokenType.True:return this._advance(),"true";case R.TokenType.False:return this._advance(),"false";case R.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(w){return w.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(w){return this._check(w)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(w,A){if(this._check(w))return this._advance();throw this._errExpectedButGot(A,this._peek())}_errExpectedButGot(w,A,x){const V=(0,C.localize)(8,null,w,R.Scanner.getLexeme(A)),Y=A.offset,X=R.Scanner.getLexeme(A);return this._parsingErrors.push({message:V,offset:Y,lexeme:X,additionalInfo:x}),i._parseError}_check(w){return this._peek().type===w}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===R.TokenType.EOF}}t.Parser=i;class o{static false(){return s.INSTANCE}static true(){return f.INSTANCE}static has(w){return I.create(w)}static equals(w,A){return O.create(w,A)}static notEquals(w,A){return F.create(w,A)}static regex(w,A){return le.create(w,A)}static in(w,A){return N.create(w,A)}static notIn(w,A){return k.create(w,A)}static not(w){return _.create(w)}static and(...w){return z.create(w,null,!0)}static or(...w){return M.create(w,null,!0)}static greater(w,A){return ae.create(w,A)}static greaterEquals(w,A){return ie.create(w,A)}static smaller(w,A){return ce.create(w,A)}static smallerEquals(w,A){return ue.create(w,A)}static{this._parser=new i({regexParsingWithErrorRecovery:!1})}static deserialize(w){return w==null?void 0:this._parser.parse(w)}}t.ContextKeyExpr=o;function r($){const w=new i({regexParsingWithErrorRecovery:!1});return $.map(A=>(w.parse(A),w.lexingErrors.length>0?w.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,C.localize)(9,null,x.additionalInfo):(0,C.localize)(10,null),offset:x.offset,length:x.lexeme.length})):w.parsingErrors.length>0?w.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}function e($,w){const A=$?$.substituteConstants():void 0,x=w?w.substituteConstants():void 0;return!A&&!x?!0:!A||!x?!1:A.equals(x)}function n($,w){return $.cmp(w)}class s{static{this.INSTANCE=new s}constructor(){this.type=h.False}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}substituteConstants(){return this}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return f.INSTANCE}}t.ContextKeyFalseExpr=s;class f{static{this.INSTANCE=new f}constructor(){this.type=h.True}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}substituteConstants(){return this}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return s.INSTANCE}}t.ContextKeyTrueExpr=f;class I{static create(w,A=null){const x=l.get(w);return typeof x=="boolean"?x?f.INSTANCE:s.INSTANCE:new I(w,A)}constructor(w,A){this.key=w,this.negated=A,this.type=h.Defined}cmp(w){return w.type!==this.type?this.type-w.type:J(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}substituteConstants(){const w=l.get(this.key);return typeof w=="boolean"?w?f.INSTANCE:s.INSTANCE:this}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}t.ContextKeyDefinedExpr=I;class O{static create(w,A,x=null){if(typeof A=="boolean")return A?I.create(w,x):_.create(w,x);const V=l.get(w);return typeof V=="boolean"?A===(V?"true":"false")?f.INSTANCE:s.INSTANCE:new O(w,A,x)}constructor(w,A,x){this.key=w,this.value=A,this.negated=x,this.type=h.Equals}cmp(w){return w.type!==this.type?this.type-w.type:Q(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){const w=l.get(this.key);if(typeof w=="boolean"){const A=w?"true":"false";return this.value===A?f.INSTANCE:s.INSTANCE}return this}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}t.ContextKeyEqualsExpr=O;class N{static create(w,A){return new N(w,A)}constructor(w,A){this.key=w,this.valueKey=A,this.type=h.In,this.negated=null}cmp(w){return w.type!==this.type?this.type-w.type:Q(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}substituteConstants(){return this}evaluate(w){const A=w.getValue(this.valueKey),x=w.getValue(this.key);return Array.isArray(A)?A.includes(x):typeof x=="string"&&typeof A=="object"&&A!==null?c.call(A,x):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=k.create(this.key,this.valueKey)),this.negated}}t.ContextKeyInExpr=N;class k{static create(w,A){return new k(w,A)}constructor(w,A){this.key=w,this.valueKey=A,this.type=h.NotIn,this._negated=N.create(w,A)}cmp(w){return w.type!==this.type?this.type-w.type:this._negated.cmp(w._negated)}equals(w){return w.type===this.type?this._negated.equals(w._negated):!1}substituteConstants(){return this}evaluate(w){return!this._negated.evaluate(w)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(w){return w.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}t.ContextKeyNotInExpr=k;class F{static create(w,A,x=null){if(typeof A=="boolean")return A?_.create(w,x):I.create(w,x);const V=l.get(w);return typeof V=="boolean"?A===(V?"true":"false")?s.INSTANCE:f.INSTANCE:new F(w,A,x)}constructor(w,A,x){this.key=w,this.value=A,this.negated=x,this.type=h.NotEquals}cmp(w){return w.type!==this.type?this.type-w.type:Q(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){const w=l.get(this.key);if(typeof w=="boolean"){const A=w?"true":"false";return this.value===A?s.INSTANCE:f.INSTANCE}return this}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=O.create(this.key,this.value,this)),this.negated}}t.ContextKeyNotEqualsExpr=F;class _{static create(w,A=null){const x=l.get(w);return typeof x=="boolean"?x?s.INSTANCE:f.INSTANCE:new _(w,A)}constructor(w,A){this.key=w,this.negated=A,this.type=h.Not}cmp(w){return w.type!==this.type?this.type-w.type:J(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}substituteConstants(){const w=l.get(this.key);return typeof w=="boolean"?w?s.INSTANCE:f.INSTANCE:this}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}t.ContextKeyNotExpr=_;function K($,w){if(typeof $=="string"){const A=parseFloat($);isNaN(A)||($=A)}return typeof $=="string"||typeof $=="number"?w($):s.INSTANCE}class ae{static create(w,A,x=null){return K(A,V=>new ae(w,V,x))}constructor(w,A,x){this.key=w,this.value=A,this.negated=x,this.type=h.Greater}cmp(w){return w.type!==this.type?this.type-w.type:Q(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return typeof this.value=="string"?!1:parseFloat(w.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ue.create(this.key,this.value,this)),this.negated}}t.ContextKeyGreaterExpr=ae;class ie{static create(w,A,x=null){return K(A,V=>new ie(w,V,x))}constructor(w,A,x){this.key=w,this.value=A,this.negated=x,this.type=h.GreaterEquals}cmp(w){return w.type!==this.type?this.type-w.type:Q(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return typeof this.value=="string"?!1:parseFloat(w.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ce.create(this.key,this.value,this)),this.negated}}t.ContextKeyGreaterEqualsExpr=ie;class ce{static create(w,A,x=null){return K(A,V=>new ce(w,V,x))}constructor(w,A,x){this.key=w,this.value=A,this.negated=x,this.type=h.Smaller}cmp(w){return w.type!==this.type?this.type-w.type:Q(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return typeof this.value=="string"?!1:parseFloat(w.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=ie.create(this.key,this.value,this)),this.negated}}t.ContextKeySmallerExpr=ce;class ue{static create(w,A,x=null){return K(A,V=>new ue(w,V,x))}constructor(w,A,x){this.key=w,this.value=A,this.negated=x,this.type=h.SmallerEquals}cmp(w){return w.type!==this.type?this.type-w.type:Q(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return typeof this.value=="string"?!1:parseFloat(w.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ae.create(this.key,this.value,this)),this.negated}}t.ContextKeySmallerEqualsExpr=ue;class le{static create(w,A){return new le(w,A)}constructor(w,A){this.key=w,this.regexp=A,this.type=h.Regex,this.negated=null}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const A=this.regexp?this.regexp.source:"",x=w.regexp?w.regexp.source:"";return A<x?-1:A>x?1:0}equals(w){if(w.type===this.type){const A=this.regexp?this.regexp.source:"",x=w.regexp?w.regexp.source:"";return this.key===w.key&&A===x}return!1}substituteConstants(){return this}evaluate(w){const A=w.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=B.create(this)),this.negated}}t.ContextKeyRegexExpr=le;class B{static create(w){return new B(w)}constructor(w){this._actual=w,this.type=h.NotRegex}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}substituteConstants(){return this}evaluate(w){return!this._actual.evaluate(w)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(w){return new B(this._actual.map(w))}negate(){return this._actual}}t.ContextKeyNotRegexExpr=B;function Z($){let w=null;for(let A=0,x=$.length;A<x;A++){const V=$[A].substituteConstants();if($[A]!==V&&w===null){w=[];for(let Y=0;Y<A;Y++)w[Y]=$[Y]}w!==null&&(w[A]=V)}return w===null?$:w}class z{static create(w,A,x){return z._normalizeArr(w,A,x)}constructor(w,A){this.expr=w,this.negated=A,this.type=h.And}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let A=0,x=this.expr.length;A<x;A++){const V=n(this.expr[A],w.expr[A]);if(V!==0)return V}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let A=0,x=this.expr.length;A<x;A++)if(!this.expr[A].equals(w.expr[A]))return!1;return!0}return!1}substituteConstants(){const w=Z(this.expr);return w===this.expr?this:z.create(w,this.negated,!1)}evaluate(w){for(let A=0,x=this.expr.length;A<x;A++)if(!this.expr[A].evaluate(w))return!1;return!0}static _normalizeArr(w,A,x){const V=[];let Y=!1;for(const X of w)if(X){if(X.type===h.True){Y=!0;continue}if(X.type===h.False)return s.INSTANCE;if(X.type===h.And){V.push(...X.expr);continue}V.push(X)}if(V.length===0&&Y)return f.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(n);for(let X=1;X<V.length;X++)V[X-1].equals(V[X])&&(V.splice(X,1),X--);if(V.length===1)return V[0];for(;V.length>1;){const X=V[V.length-1];if(X.type!==h.Or)break;V.pop();const ne=V.pop(),he=V.length===0,fe=M.create(X.expr.map(ye=>z.create([ye,ne],null,x)),null,he);fe&&(V.push(fe),V.sort(n))}if(V.length===1)return V[0];if(x){for(let X=0;X<V.length;X++)for(let ne=X+1;ne<V.length;ne++)if(V[X].negate().equals(V[ne]))return s.INSTANCE;if(V.length===1)return V[0]}return new z(V,A)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(const A of this.expr)w.push(...A.keys());return w}map(w){return new z(this.expr.map(A=>A.map(w)),null)}negate(){if(!this.negated){const w=[];for(const A of this.expr)w.push(A.negate());this.negated=M.create(w,this,!0)}return this.negated}}t.ContextKeyAndExpr=z;class M{static create(w,A,x){return M._normalizeArr(w,A,x)}constructor(w,A){this.expr=w,this.negated=A,this.type=h.Or}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let A=0,x=this.expr.length;A<x;A++){const V=n(this.expr[A],w.expr[A]);if(V!==0)return V}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let A=0,x=this.expr.length;A<x;A++)if(!this.expr[A].equals(w.expr[A]))return!1;return!0}return!1}substituteConstants(){const w=Z(this.expr);return w===this.expr?this:M.create(w,this.negated,!1)}evaluate(w){for(let A=0,x=this.expr.length;A<x;A++)if(this.expr[A].evaluate(w))return!0;return!1}static _normalizeArr(w,A,x){let V=[],Y=!1;if(w){for(let X=0,ne=w.length;X<ne;X++){const he=w[X];if(he){if(he.type===h.False){Y=!0;continue}if(he.type===h.True)return f.INSTANCE;if(he.type===h.Or){V=V.concat(he.expr);continue}V.push(he)}}if(V.length===0&&Y)return s.INSTANCE;V.sort(n)}if(V.length!==0){if(V.length===1)return V[0];for(let X=1;X<V.length;X++)V[X-1].equals(V[X])&&(V.splice(X,1),X--);if(V.length===1)return V[0];if(x){for(let X=0;X<V.length;X++)for(let ne=X+1;ne<V.length;ne++)if(V[X].negate().equals(V[ne]))return f.INSTANCE;if(V.length===1)return V[0]}return new M(V,A)}}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(const A of this.expr)w.push(...A.keys());return w}map(w){return new M(this.expr.map(A=>A.map(w)),null)}negate(){if(!this.negated){const w=[];for(const A of this.expr)w.push(A.negate());for(;w.length>1;){const A=w.shift(),x=w.shift(),V=[];for(const Y of q(A))for(const X of q(x))V.push(z.create([Y,X],null,!1));w.unshift(M.create(V,null,!1))}this.negated=M.create(w,this,!0)}return this.negated}}t.ContextKeyOrExpr=M;class G extends I{static{this._info=[]}static all(){return G._info.values()}constructor(w,A,x){super(w,null),this._defaultValue=A,typeof x=="object"?G._info.push({...x,key:w}):x!==!0&&G._info.push({key:w,description:x,type:A!=null?typeof A:void 0})}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(w){return O.create(this.key,w)}notEqualsTo(w){return F.create(this.key,w)}}t.RawContextKey=G,t.IContextKeyService=(0,L.createDecorator)("contextKeyService");function J($,w){return $<w?-1:$>w?1:0}function Q($,w,A,x){return $<A?-1:$>A?1:w<x?-1:w>x?1:0}function U($,w){if($.type===h.False||w.type===h.True)return!0;if($.type===h.Or)return w.type===h.Or?W($.expr,w.expr):!1;if(w.type===h.Or){for(const A of w.expr)if(U($,A))return!0;return!1}if($.type===h.And){if(w.type===h.And)return W(w.expr,$.expr);for(const A of $.expr)if(U(A,w))return!0;return!1}return $.equals(w)}function W($,w){let A=0,x=0;for(;A<$.length&&x<w.length;){const V=$[A].cmp(w[x]);if(V<0)return!1;V===0&&A++,x++}return A===$.length}function q($){return $.type===h.Or?$.expr:[$]}}),define(se[62],oe([0,1,11]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,b.createDecorator)("downloadService")}),define(se[18],oe([0,1,11]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,b.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,b.refineServiceDecorator)(t.IEnvironmentService)}),define(se[63],oe([0,1,14,9,107,10]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=L;async function L(a,c,h,m,S,T){let g;try{await C(a,c,h,m,S,T)}catch(d){g=d}finally{g&&S.errorTransformer&&(g=S.errorTransformer(g)),typeof g<"u"&&h.error(g),h.end()}}async function C(a,c,h,m,S,T){p(T);const g=await a.open(c,{create:!1});try{p(T);let d=0,v=0,P=S&&typeof S.length=="number"?S.length:void 0,E=b.VSBuffer.alloc(Math.min(S.bufferSize,typeof P=="number"?P:S.bufferSize)),u=S&&typeof S.position=="number"?S.position:0,i=0;do v=await a.read(g,u,E.buffer,i,E.byteLength-i),u+=v,i+=v,d+=v,typeof P=="number"&&(P-=v),i===E.byteLength&&(await h.write(m(E)),E=b.VSBuffer.alloc(Math.min(S.bufferSize,typeof P=="number"?P:S.bufferSize)),i=0);while(v>0&&(typeof P!="number"||P>0)&&p(T)&&l(d,S));if(i>0){let o=i;typeof P=="number"&&(o=Math.min(i,P)),h.write(m(E.slice(0,o)))}}catch(d){throw(0,R.ensureFileSystemProviderError)(d)}finally{await a.close(g)}}function p(a){if(a.isCancellationRequested)throw(0,D.canceled)();return!0}function l(a,c){if(typeof c?.limits?.size=="number"&&a>c.limits.size)throw(0,R.createFileSystemProviderError)((0,y.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[125],oe([0,1,61,2,52,5,10,12,8]),function(H,t,b,D,y,R,L,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BaseWatcher=void 0;class l extends D.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new R.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new D.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new p.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(c=>this.handleDidWatchFail(c)))}handleDidWatchFail(c){this.isCorrelated(c)&&this.suspendWatchRequest(c)}isCorrelated(c){return(0,y.isWatchRequestWithCorrelation)(c)}async watch(c){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new p.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const h of c)this.isCorrelated(h)?this.allCorrelatedWatchRequests.set(h.correlationId,h):this.allNonCorrelatedWatchRequests.add(h);for(const[h]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(h)||(this.suspendedWatchRequests.deleteAndDispose(h),this.suspendedWatchRequestsWithPolling.delete(h));return await this.updateWatchers()}finally{this.joinWatch.complete()}}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(c=>!this.suspendedWatchRequests.has(c.correlationId))])}isSuspended(c){return typeof c.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(c.correlationId)?"polling":this.suspendedWatchRequests.has(c.correlationId)}async suspendWatchRequest(c){if(this.suspendedWatchRequests.has(c.correlationId))return;const h=new D.DisposableStore;this.suspendedWatchRequests.set(c.correlationId,h),await this.joinWatch.p,!h.isDisposed&&(this.monitorSuspendedWatchRequest(c,h),this.updateWatchers())}resumeWatchRequest(c){this.suspendedWatchRequests.deleteAndDispose(c.correlationId),this.suspendedWatchRequestsWithPolling.delete(c.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(c,h){this.doMonitorWithExistingWatcher(c,h)?(this.trace(`reusing an existing recursive watcher to monitor ${c.path}`),this.suspendedWatchRequestsWithPolling.delete(c.correlationId)):(this.doMonitorWithNodeJS(c,h),this.suspendedWatchRequestsWithPolling.add(c.correlationId))}doMonitorWithExistingWatcher(c,h){const m=this.recursiveWatcher?.subscribe(c.path,(S,T)=>{h.isDisposed||(S?this.monitorSuspendedWatchRequest(c,h):T?.type===L.FileChangeType.ADDED&&this.onMonitoredPathAdded(c))});return m?(h.add(m),!0):!1}doMonitorWithNodeJS(c,h){let m=!1;const S=(T,g)=>{if(h.isDisposed)return;const d=this.isPathNotFound(T),v=this.isPathNotFound(g),P=m;m=d,!d&&(v||P)&&this.onMonitoredPathAdded(c)};this.trace(`starting fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,b.watchFile)(c.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},S)}catch(T){this.warn(`fs.watchFile() failed with error ${T} on path ${c.path} (correlationId: ${c.correlationId})`)}h.add((0,D.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,b.unwatchFile)(c.path,S)}catch(T){this.warn(`fs.unwatchFile() failed with error ${T} on path ${c.path} (correlationId: ${c.correlationId})`)}}))}onMonitoredPathAdded(c){this.trace(`detected ${c.path} exists again, resuming watcher (correlationId: ${c.correlationId})`);const h={resource:C.URI.file(c.path),type:L.FileChangeType.ADDED,cId:c.correlationId};this._onDidChangeFile.fire([h]),this.traceEvent(h,c),this.resumeWatchRequest(c)}isPathNotFound(c){return c.ctimeMs===0&&c.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(c,h){if(this.verboseLogging){const m=` >> normalized ${c.type===L.FileChangeType.ADDED?"[ADDED]":c.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`;this.traceWithCorrelation(m,h)}}traceWithCorrelation(c,h){this.verboseLogging&&this.trace(`${c}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}requestToString(c){return`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,y.requestFilterToString)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`}async setVerboseLogging(c){this.verboseLogging=c}}t.BaseWatcher=l}),define(se[126],oe([0,1,5,173,125,13,174,64]),function(H,t,b,D,y,R,L,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcher=void 0;class p extends y.BaseWatcher{constructor(a){super(),this.recursiveWatcher=a,this.onDidError=b.Event.None,this.watchers=new Set}async doWatch(a){a=this.removeDuplicateRequests(a);const c=[],h=new Set(Array.from(this.watchers));for(const m of a){const S=this.findWatcher(m);S&&(0,D.patternsEquals)(S.request.excludes,m.excludes)&&(0,D.patternsEquals)(S.request.includes,m.includes)?h.delete(S):c.push(m)}c.length&&this.trace(`Request to start watching: ${c.map(m=>this.requestToString(m)).join(",")}`),h.size&&this.trace(`Request to stop watching: ${Array.from(h).map(m=>this.requestToString(m.request)).join(",")}`);for(const m of h)this.stopWatching(m);for(const m of c)this.startWatching(m)}findWatcher(a){for(const c of this.watchers)if(typeof a.correlationId=="number"||typeof c.request.correlationId=="number"){if(c.request.correlationId===a.correlationId)return c}else if((0,C.isEqual)(c.request.path,a.path,!R.isLinux))return c}startWatching(a){const c=new L.NodeJSFileWatcherLibrary(a,this.recursiveWatcher,m=>this._onDidChangeFile.fire(m),()=>this._onDidWatchFail.fire(a),m=>this._onDidLogMessage.fire(m),this.verboseLogging),h={request:a,instance:c};this.watchers.add(h)}async stop(){await super.stop();for(const a of this.watchers)this.stopWatching(a)}stopWatching(a){this.trace("stopping file watcher",a),this.watchers.delete(a),a.instance.dispose()}removeDuplicateRequests(a){const c=new Map;for(const h of a){const m=R.isLinux?h.path:h.path.toLowerCase();let S=c.get(h.correlationId);S||(S=new Map,c.set(h.correlationId,S)),S.has(m)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(h)}`),S.set(m,h)}return Array.from(c.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(a){super.setVerboseLogging(a);for(const c of this.watchers)c.instance.setVerboseLogging(a)}trace(a,c){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(a,c)})}warn(a){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(a)})}toMessage(a,c){return c?`[File Watcher (node.js)] ${a} (${this.requestToString(c.request)})`:`[File Watcher (node.js)] ${a}`}}t.NodeJSWatcher=p}),define(se[127],oe([0,1,52,126]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcherClient=void 0;class y extends b.AbstractNonRecursiveWatcherClient{constructor(L,C,p){super(L,C,p),this.init()}createWatcher(L){return L.add(new D.NodeJSWatcher(void 0))}}t.NodeJSWatcherClient=y}),define(se[128],oe([0,1,15,59,92,52]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UniversalWatcherClient=void 0;class L extends R.AbstractUniversalWatcherClient{constructor(p,l,a){super(p,l,a),this.init()}createWatcher(p){const l=p.add(new y.Client(b.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(l.onDidProcessExit(({code:a,signal:c})=>this.onError(`terminated by itself with code ${a}, signal: ${c} (ETERM)`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(l.getChannel("watcher")))}}t.UniversalWatcherClient=L}),define(se[65],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class b{constructor(...y){this._entries=new Map;for(const[R,L]of y)this.set(R,L)}set(y,R){const L=this._entries.get(y);return this._entries.set(y,R),L}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}t.ServiceCollection=b}),define(se[129],oe([0,1,8,9,2,51,123,11,65,175]),function(H,t,b,D,y,R,L,C,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Trace=t.InstantiationService=void 0;const a=!1;class c extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class h{constructor(g=new p.ServiceCollection,d=!1,v,P=a){this._services=g,this._strict=d,this._parent=v,this._enableTracing=P,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(C.IInstantiationService,this),this._globalGraph=P?v?._globalGraph??new L.Graph(E=>E):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,y.dispose)(this._children),this._children.clear();for(const g of this._servicesToMaybeDispose)(0,y.isDisposable)(g)&&g.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(g,d){this._throwIfDisposed();const v=this,P=new class extends h{dispose(){v._children.delete(P),super.dispose()}}(g,this._strict,this,this._enableTracing);return this._children.add(P),d?.add(P),P}invokeFunction(g,...d){this._throwIfDisposed();const v=S.traceInvocation(this._enableTracing,g);let P=!1;try{return g({get:u=>{if(P)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(u,v);if(!i)throw new Error(`[invokeFunction] unknown service '${u}'`);return i}},...d)}finally{P=!0,v.stop()}}createInstance(g,...d){this._throwIfDisposed();let v,P;return g instanceof R.SyncDescriptor?(v=S.traceCreation(this._enableTracing,g.ctor),P=this._createInstance(g.ctor,g.staticArguments.concat(d),v)):(v=S.traceCreation(this._enableTracing,g),P=this._createInstance(g,d,v)),v.stop(),P}_createInstance(g,d=[],v){const P=C._util.getServiceDependencies(g).sort((i,o)=>i.index-o.index),E=[];for(const i of P){const o=this._getOrCreateServiceInstance(i.id,v);o||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(o)}const u=P.length>0?P[0].index:d.length;if(d.length!==u){console.trace(`[createInstance] First service dependency of ${g.name} at position ${u+1} conflicts with ${d.length} static arguments`);const i=u-d.length;i>0?d=d.concat(new Array(i)):d=d.slice(0,u)}return Reflect.construct(g,d.concat(E))}_setCreatedServiceInstance(g,d){if(this._services.get(g)instanceof R.SyncDescriptor)this._services.set(g,d);else if(this._parent)this._parent._setCreatedServiceInstance(g,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){const d=this._services.get(g);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):d}_getOrCreateServiceInstance(g,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(g));const v=this._getServiceInstanceOrDescriptor(g);return v instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,v,d.branch(g,!0)):(d.branch(g,!1),v)}_safeCreateAndCacheServiceInstance(g,d,v){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,d,v)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,d,v){const P=new L.Graph(i=>i.id.toString());let E=0;const u=[{id:g,desc:d,_trace:v}];for(;u.length;){const i=u.pop();if(P.lookupOrInsertNode(i),E++>1e3)throw new c(P);for(const o of C._util.getServiceDependencies(i.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(o.id);if(r||this._throwIfStrict(`[createInstance] ${g} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),r instanceof R.SyncDescriptor){const e={id:o.id,desc:r,_trace:i._trace.branch(o.id,!0)};P.insertEdge(i,e),u.push(e)}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new c(P);break}for(const{data:o}of i){if(this._getServiceInstanceOrDescriptor(o.id)instanceof R.SyncDescriptor){const e=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setCreatedServiceInstance(o.id,e)}P.removeNode(o)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,d,v=[],P,E){if(this._services.get(g)instanceof R.SyncDescriptor)return this._createServiceInstance(g,d,v,P,E,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,d,v,P,E);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(g,d,v=[],P,E,u){if(P){const i=new h(void 0,this._strict,this,this._enableTracing);i._globalGraphImplicitDependency=String(g);const o=new Map,r=new b.GlobalIdleValue(()=>{const e=i._createInstance(d,v,E);for(const[n,s]of o){const f=e[n];if(typeof f=="function")for(const I of s)I.disposable=f.apply(e,I.listener)}return o.clear(),u.add(e),e});return new Proxy(Object.create(null),{get(e,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let I=o.get(n);return I||(I=new l.LinkedList,o.set(n,I)),(N,k,F)=>{if(r.isInitialized)return r.value[n](N,k,F);{const _={listener:[N,k,F],disposable:void 0},K=I.push(_);return(0,y.toDisposable)(()=>{K(),_.disposable?.dispose()})}}}if(n in e)return e[n];const s=r.value;let f=s[n];return typeof f!="function"||(f=f.bind(s),e[n]=f),f},set(e,n,s){return r.value[n]=s,!0},getPrototypeOf(e){return d.prototype}})}else{const i=this._createInstance(d,v,E);return u.add(i),i}}_throwIfStrict(g,d){if(d&&console.warn(g),this._strict)throw new Error(g)}}t.InstantiationService=h;var m;(function(T){T[T.None=0]="None",T[T.Creation=1]="Creation",T[T.Invocation=2]="Invocation",T[T.Branch=3]="Branch"})(m||(m={}));class S{static{this.all=new Set}static{this._None=new class extends S{constructor(){super(m.None,null)}stop(){}branch(){return this}}}static traceInvocation(g,d){return g?new S(m.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(g,d){return g?new S(m.Creation,d.name):S._None}static{this._totals=0}constructor(g,d){this.type=g,this.name=d,this._start=Date.now(),this._dep=[]}branch(g,d){const v=new S(m.Branch,g.toString());return this._dep.push([g,d,v]),v}stop(){const g=Date.now()-this._start;S._totals+=g;let d=!1;function v(E,u){const i=[],o=new Array(E+1).join("	");for(const[r,e,n]of u._dep)if(e&&n){d=!0,i.push(`${o}CREATES -> ${r}`);const s=v(E+1,n);s&&i.push(s)}else i.push(`${o}uses -> ${r}`);return i.join(`
`)}const P=[`${this.type===m.Creation?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(g>2||d)&&S.all.add(P.join(`
`))}}t.Trace=S}),define(se[6],oe([0,1,110,36,5,43,2,31,13,17,3,12,124,11]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_LOG_LEVEL=t.NullLogService=t.NullLogger=t.AbstractLoggerService=t.MultiplexLogger=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.isLogLevel=T,t.log=d,t.getLogLevel=f,t.LogLevelToString=I,t.LogLevelToLocalizedString=O,t.parseLogLevel=N,t.ILogService=(0,m.createDecorator)("logService"),t.ILoggerService=(0,m.createDecorator)("loggerService");function S(){return new Date().toISOString()}function T(k){return(0,a.isNumber)(k)}var g;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(g||(t.LogLevel=g={})),t.DEFAULT_LOG_LEVEL=g.Info;function d(k,F,_){switch(F){case g.Trace:k.trace(_);break;case g.Debug:k.debug(_);break;case g.Info:k.info(_);break;case g.Warning:k.warn(_);break;case g.Error:k.error(_);break;case g.Off:break;default:throw new Error(`Invalid log level ${F}`)}}function v(k,F=!1){let _="";for(let K=0;K<k.length;K++){let ae=k[K];if(ae instanceof Error&&(ae=(0,D.toErrorMessage)(ae,F)),typeof ae=="object")try{ae=JSON.stringify(ae)}catch{}_+=(K>0?" ":"")+ae}return _}class P extends L.Disposable{constructor(){super(...arguments),this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(F){this.level!==F&&(this.level=F,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(F){return this.level!==g.Off&&this.level<=F}}t.AbstractLogger=P;class E extends P{constructor(F){super(),this.logAlways=F}checkLogLevel(F){return this.logAlways||super.checkLogLevel(F)}trace(F,..._){this.checkLogLevel(g.Trace)&&this.log(g.Trace,v([F,..._],!0))}debug(F,..._){this.checkLogLevel(g.Debug)&&this.log(g.Debug,v([F,..._]))}info(F,..._){this.checkLogLevel(g.Info)&&this.log(g.Info,v([F,..._]))}warn(F,..._){this.checkLogLevel(g.Warning)&&this.log(g.Warning,v([F,..._]))}error(F,..._){if(this.checkLogLevel(g.Error))if(F instanceof Error){const K=Array.prototype.slice.call(arguments);K[0]=F.stack,this.log(g.Error,v(K))}else this.log(g.Error,v([F,..._]))}flush(){}}t.AbstractMessageLogger=E;class u extends P{constructor(F=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(F),this.useColors=!p.isWindows}trace(F,..._){this.checkLogLevel(g.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,F,..._):console.log(`[main ${S()}]`,F,..._))}debug(F,..._){this.checkLogLevel(g.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,F,..._):console.log(`[main ${S()}]`,F,..._))}info(F,..._){this.checkLogLevel(g.Info)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,F,..._):console.log(`[main ${S()}]`,F,..._))}warn(F,..._){this.checkLogLevel(g.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,F,..._):console.warn(`[main ${S()}]`,F,..._))}error(F,..._){this.checkLogLevel(g.Error)&&(this.useColors?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,F,..._):console.error(`[main ${S()}]`,F,..._))}flush(){}}t.ConsoleMainLogger=u;class i extends P{constructor(F=t.DEFAULT_LOG_LEVEL,_=!0){super(),this.useColors=_,this.setLevel(F)}trace(F,..._){this.checkLogLevel(g.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",F,..._):console.log(F,..._))}debug(F,..._){this.checkLogLevel(g.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",F,..._):console.log(F,..._))}info(F,..._){this.checkLogLevel(g.Info)&&(this.useColors?console.log("%c INFO","color: #33f",F,..._):console.log(F,..._))}warn(F,..._){this.checkLogLevel(g.Warning)&&(this.useColors?console.log("%c WARN","color: #993",F,..._):console.log(F,..._))}error(F,..._){this.checkLogLevel(g.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",F,..._):console.error(F,..._))}flush(){}}t.ConsoleLogger=i;class o extends P{constructor(F,_=t.DEFAULT_LOG_LEVEL){super(),this.adapter=F,this.setLevel(_)}trace(F,..._){this.checkLogLevel(g.Trace)&&this.adapter.log(g.Trace,[this.extractMessage(F),..._])}debug(F,..._){this.checkLogLevel(g.Debug)&&this.adapter.log(g.Debug,[this.extractMessage(F),..._])}info(F,..._){this.checkLogLevel(g.Info)&&this.adapter.log(g.Info,[this.extractMessage(F),..._])}warn(F,..._){this.checkLogLevel(g.Warning)&&this.adapter.log(g.Warning,[this.extractMessage(F),..._])}error(F,..._){this.checkLogLevel(g.Error)&&this.adapter.log(g.Error,[this.extractMessage(F),..._])}extractMessage(F){return typeof F=="string"?F:(0,D.toErrorMessage)(F,this.checkLogLevel(g.Trace))}flush(){}}t.AdapterLogger=o;class r extends P{constructor(F){super(),this.loggers=F,F.length&&this.setLevel(F[0].getLevel())}setLevel(F){for(const _ of this.loggers)_.setLevel(F);super.setLevel(F)}trace(F,..._){for(const K of this.loggers)K.trace(F,..._)}debug(F,..._){for(const K of this.loggers)K.debug(F,..._)}info(F,..._){for(const K of this.loggers)K.info(F,..._)}warn(F,..._){for(const K of this.loggers)K.warn(F,..._)}error(F,..._){for(const K of this.loggers)K.error(F,..._)}flush(){for(const F of this.loggers)F.flush()}dispose(){for(const F of this.loggers)F.dispose();super.dispose()}}t.MultiplexLogger=r;class e extends L.Disposable{constructor(F,_,K){if(super(),this.logLevel=F,this.logsHome=_,this._loggers=new C.ResourceMap,this._onDidChangeLoggers=this._register(new y.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,K)for(const ae of K)this._loggers.set(ae.resource,{logger:void 0,info:ae})}getLoggerEntry(F){return(0,a.isString)(F)?[...this._loggers.values()].find(_=>_.info.id===F):this._loggers.get(F)}getLogger(F){return this.getLoggerEntry(F)?.logger}createLogger(F,_){const K=this.toResource(F),ae=(0,a.isString)(F)?F:_?.id??(0,R.hash)(K.toString()).toString(16);let ie=this._loggers.get(K)?.logger;const ce=_?.logLevel==="always"?g.Trace:_?.logLevel;ie||(ie=this.doCreateLogger(K,ce??this.getLogLevel(K)??this.logLevel,{..._,id:ae}));const ue={logger:ie,info:{resource:K,id:ae,logLevel:ce,name:_?.name,hidden:_?.hidden,extensionId:_?.extensionId,when:_?.when}};return this.registerLogger(ue.info),this._loggers.set(K,ue),ie}toResource(F){return(0,a.isString)(F)?(0,l.joinPath)(this.logsHome,`${F}.log`):F}setLogLevel(F,_){if(c.URI.isUri(F)){const K=F,ae=_,ie=this._loggers.get(K);ie&&ae!==ie.info.logLevel&&(ie.info.logLevel=ae===this.logLevel?void 0:ae,ie.logger?.setLevel(ae),this._loggers.set(ie.info.resource,ie),this._onDidChangeLogLevel.fire([K,ae]))}else{this.logLevel=F;for(const[K,ae]of this._loggers.entries())this._loggers.get(K)?.info.logLevel===void 0&&ae.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(F,_){const K=this.getLoggerEntry(F);K&&_!==!K.info.hidden&&(K.info.hidden=!_,this._loggers.set(K.info.resource,K),this._onDidChangeVisibility.fire([K.info.resource,_]))}getLogLevel(F){let _;return F&&(_=this._loggers.get(F)?.info.logLevel),_??this.logLevel}registerLogger(F){const _=this._loggers.get(F.resource);_?_.info.hidden!==F.hidden&&this.setVisibility(F.resource,!F.hidden):(this._loggers.set(F.resource,{info:F,logger:void 0}),this._onDidChangeLoggers.fire({added:[F],removed:[]}))}deregisterLogger(F){const _=this._loggers.get(F);_&&(_.logger&&_.logger.dispose(),this._loggers.delete(F),this._onDidChangeLoggers.fire({added:[],removed:[_.info]}))}*getRegisteredLoggers(){for(const F of this._loggers.values())yield F.info}getRegisteredLogger(F){return this._loggers.get(F)?.info}dispose(){this._loggers.forEach(F=>F.logger?.dispose()),this._loggers.clear(),super.dispose()}}t.AbstractLoggerService=e;class n{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(F){}getLevel(){return g.Info}trace(F,..._){}debug(F,..._){}info(F,..._){}warn(F,..._){}error(F,..._){}critical(F,..._){}dispose(){}flush(){}}t.NullLogger=n;class s extends n{}t.NullLogService=s;function f(k){if(k.verbose)return g.Trace;if(typeof k.logLevel=="string"){const F=N(k.logLevel.toLowerCase());if(F!==void 0)return F}return t.DEFAULT_LOG_LEVEL}function I(k){switch(k){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function O(k){switch(k){case g.Trace:return{original:"Trace",value:b.localize(0,null)};case g.Debug:return{original:"Debug",value:b.localize(1,null)};case g.Info:return{original:"Info",value:b.localize(2,null)};case g.Warning:return{original:"Warning",value:b.localize(3,null)};case g.Error:return{original:"Error",value:b.localize(4,null)};case g.Off:return{original:"Off",value:b.localize(5,null)}}}function N(k){switch(k){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}t.CONTEXT_LOG_LEVEL=new h.RawContextKey("logLevel",I(g.Info))}),define(se[130],oe([0,1,20,8,9,5,64,2,16,52,6]),function(H,t,b,D,y,R,L,C,p,l,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class c extends C.Disposable{constructor(m,S){super(),this.logService=m,this.options=S,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new D.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(m,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,S):this.watchNonRecursive(m,S)}watchUniversal(m,S){const T={path:this.toWatchPath(m),excludes:S.excludes,includes:S.includes,recursive:S.recursive,filter:S.filter,correlationId:S.correlationId},g=(0,b.insert)(this.universalWatchRequests,T);return this.refreshUniversalWatchers(),(0,C.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,y.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const S of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const S of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(S)&&m.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(m,S){const T={path:this.toWatchPath(m),excludes:S.excludes,includes:S.includes,recursive:!1,filter:S.filter,correlationId:S.correlationId},g=(0,b.insert)(this.nonRecursiveWatchRequests,T);return this.refreshNonRecursiveWatchers(),(0,C.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,y.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logWatcherMessage(m)}logWatcherMessage(m){this.logService[m.type](m.message)}toFilePath(m){return(0,p.normalize)(m.fsPath)}toWatchPath(m){const S=this.toFilePath(m);return(0,L.removeTrailingPathSeparator)(S)}}t.AbstractDiskFileSystemProvider=c});var re=this&&this.__param||function(H,t){return function(b,D){t(b,D,H)}};define(se[131],oe([0,1,20,8,14,22,5,43,66,2,48,15,132,17,46,106,10,63,6,9]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S,T,g,d,v,P){"use strict";var E;Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let u=class extends l.Disposable{static{E=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new L.Emitter),this._onDidUncorrelatedFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(o,r){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${o}`);const e=new l.DisposableStore;return this.provider.set(o,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:r}),e.add(r.onDidChangeFile(n=>{const s=new g.FileChangesEvent(n,!this.isPathCaseSensitive(r));this.internalOnDidFilesChange.fire(s),s.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(s)})),typeof r.onDidWatchError=="function"&&e.add(r.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:o}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:r}),this.provider.delete(o),(0,l.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){r.push(e)}}),!this.provider.has(o)&&await D.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,r){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return p.Iterable.map(this.provider,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async withProvider(o){if(!(0,m.isAbsolutePath)(o))throw new g.FileOperationError((0,T.localize)(0,null,this.resourceForError(o)),g.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(o.scheme);const r=this.provider.get(o.scheme);if(!r){const e=new P.ErrorNoTelemetry;throw e.message=(0,T.localize)(1,null,o.toString()),e}return r}async withReadProvider(o){const r=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(r)||(0,g.hasReadWriteCapability)(r)||(0,g.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const r=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(r)||(0,g.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.doResolveFile(o,r)}catch(e){throw(0,g.toFileSystemProviderErrorCode)(e)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,T.localize)(2,null,this.resourceForError(o)),g.FileOperationResult.FILE_NOT_FOUND):(0,g.ensureFileSystemProviderError)(e)}}async doResolveFile(o,r){const e=await this.withProvider(o),n=this.isPathCaseSensitive(e),s=r?.resolveTo,f=r?.resolveSingleChildDescendants,I=r?.resolveMetadata,O=await e.stat(o);let N;return this.toFileStat(e,o,O,void 0,!!I,(k,F)=>(N||(N=a.TernarySearchTree.forUris(()=>!n),N.set(o,!0),s&&N.fill(!0,s)),N.get(k.resource)||N.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&f?F===1:!1))}async toFileStat(o,r,e,n,s,f){const{providerExtUri:I}=this.getExtUri(o),O={resource:r,name:I.basename(r),isFile:(e.type&g.FileType.File)!==0,isDirectory:(e.type&g.FileType.Directory)!==0,isSymbolicLink:(e.type&g.FileType.SymbolicLink)!==0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:!!((e.permissions??0)&g.FilePermission.Readonly)||!!(o.capabilities&g.FileSystemProviderCapabilities.Readonly),locked:!!((e.permissions??0)&g.FilePermission.Locked),etag:(0,g.etag)({mtime:e.mtime,size:e.size}),children:void 0};if(O.isDirectory&&f(O,n)){try{const N=await o.readdir(r),k=await D.Promises.settled(N.map(async([F,_])=>{try{const K=I.joinPath(r,F),ae=s?await o.stat(K):{type:_};return await this.toFileStat(o,K,ae,N.length,s,f)}catch(K){return this.logService.trace(K),null}}));O.children=(0,b.coalesce)(k)}catch(N){this.logService.trace(N),O.children=[]}return O}return O}async resolveAll(o){return D.Promises.settled(o.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.withProvider(o),e=await r.stat(o);return this.toFileStat(r,o,e,void 0,!0,()=>!1)}async exists(o){const r=await this.withProvider(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.doValidateCreateFile(o,r)}catch(e){return e}return!0}async doValidateCreateFile(o,r){if(!r?.overwrite&&await this.exists(o))throw new g.FileOperationError((0,T.localize)(3,null,this.resourceForError(o)),g.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(o,r=y.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const n=await this.writeFile(o,r);return this._onDidRunOperation.fire(new g.FileOperationEvent(o,g.FileOperation.CREATE,n)),n}async writeFile(o,r,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(n);let f=e;if((0,g.hasFileAtomicWriteCapability)(n)&&!f?.atomic){const I=n.enforceAtomicWriteFile?.(o);I&&(f={...e,atomic:I})}try{await this.validateWriteFile(n,o,f)||await this.mkdirp(n,s.dirname(o));let O;if((0,g.hasReadWriteCapability)(n)&&!(r instanceof y.VSBuffer))if((0,S.isReadableStream)(r)){const N=await(0,S.peekStream)(r,3);N.ended?O=y.VSBuffer.concat(N.buffer):O=N}else O=(0,S.peekReadable)(r,N=>y.VSBuffer.concat(N),3);else O=r;!(0,g.hasOpenReadWriteCloseCapability)(n)||(0,g.hasReadWriteCapability)(n)&&O instanceof y.VSBuffer||(0,g.hasReadWriteCapability)(n)&&(0,g.hasFileAtomicWriteCapability)(n)&&f?.atomic?await this.doWriteUnbuffered(n,o,f,O):await this.doWriteBuffered(n,o,f,O instanceof y.VSBuffer?(0,y.bufferToReadable)(O):O),this._onDidRunOperation.fire(new g.FileOperationEvent(o,g.FileOperation.WRITE))}catch(I){throw new g.FileOperationError((0,T.localize)(4,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(I).toString()),(0,g.toFileOperationResult)(I),f)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,r,e){const n=!!e?.unlock;if(n&&!(o.capabilities&g.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,T.localize)(5,null,this.resourceForError(r)));if(!!e?.atomic){if(!(o.capabilities&g.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,T.localize)(6,null,this.resourceForError(r)));if(!(o.capabilities&g.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,T.localize)(7,null,this.resourceForError(r)));if(n)throw new Error((0,T.localize)(8,null,this.resourceForError(r)))}let f;try{f=await o.stat(r)}catch{return}if(f.type&g.FileType.Directory)throw new g.FileOperationError((0,T.localize)(9,null,this.resourceForError(r)),g.FileOperationResult.FILE_IS_DIRECTORY,e);if(this.throwIfFileIsReadonly(r,f),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==g.ETAG_DISABLED&&typeof f.mtime=="number"&&typeof f.size=="number"&&e.mtime<f.mtime&&e.etag!==(0,g.etag)({mtime:e.mtime,size:f.size}))throw new g.FileOperationError((0,T.localize)(10,null),g.FileOperationResult.FILE_MODIFIED_SINCE,e);return f}async readFile(o,r,e){const n=await this.withReadProvider(o);return r?.atomic?this.doReadFileAtomic(n,o,r,e):this.doReadFile(n,o,r,e)}async doReadFileAtomic(o,r,e,n){return new Promise((s,f)=>{this.writeQueue.queueFor(r,async()=>{try{const I=await this.doReadFile(o,r,e,n);s(I)}catch(I){f(I)}},this.getExtUri(o).providerExtUri)})}async doReadFile(o,r,e,n){const s=await this.doReadFileStream(o,r,{...e,preferUnbuffered:!0},n);return{...s,value:await(0,y.streamToBuffer)(s.value)}}async readFileStream(o,r,e){const n=await this.withReadProvider(o);return this.doReadFileStream(n,o,r,e)}async doReadFileStream(o,r,e,n){const s=new R.CancellationTokenSource(n);let f=e;(0,g.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(r)&&(f={...e,atomic:!0});const I=this.validateReadFile(r,f).then(N=>N,N=>{throw s.dispose(!0),N});let O;try{return typeof f?.etag=="string"&&f.etag!==g.ETAG_DISABLED&&await I,f?.atomic&&(0,g.hasFileAtomicReadCapability)(o)||!((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasFileReadStreamCapability)(o))||(0,g.hasReadWriteCapability)(o)&&f?.preferUnbuffered?O=this.readFileUnbuffered(o,r,f):(0,g.hasFileReadStreamCapability)(o)?O=this.readFileStreamed(o,r,s.token,f):O=this.readFileBuffered(o,r,s.token,f),O.on("end",()=>s.dispose()),O.on("error",()=>s.dispose()),{...await I,value:O}}catch(N){throw O&&await(0,S.consumeStream)(O),this.restoreReadError(N,r,f)}}restoreReadError(o,r,e){const n=(0,T.localize)(11,null,this.resourceForError(r),(0,g.ensureFileSystemProviderError)(o).toString());return o instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(n,o.stat,e):o instanceof g.TooLargeFileOperationError?new g.TooLargeFileOperationError(n,o.fileOperationResult,o.size,o.options):new g.FileOperationError(n,(0,g.toFileOperationResult)(o),e)}readFileStreamed(o,r,e,n=Object.create(null)){const s=o.readFileStream(r,n,e);return(0,S.transform)(s,{data:f=>f instanceof y.VSBuffer?f:y.VSBuffer.wrap(f),error:f=>this.restoreReadError(f,r,n)},f=>y.VSBuffer.concat(f))}readFileBuffered(o,r,e,n=Object.create(null)){const s=(0,y.newWriteableBufferStream)();return(0,d.readFileIntoStream)(o,r,s,f=>f,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:f=>this.restoreReadError(f,r,n)},e),s}readFileUnbuffered(o,r,e){const n=(0,S.newWriteableStream)(s=>y.VSBuffer.concat(s));return(async()=>{try{let s;e?.atomic&&(0,g.hasFileAtomicReadCapability)(o)?s=await o.readFile(r,{atomic:!0}):s=await o.readFile(r),typeof e?.position=="number"&&(s=s.slice(e.position)),typeof e?.length=="number"&&(s=s.slice(0,e.length)),this.validateReadFileLimits(r,s.byteLength,e),n.end(y.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async validateReadFile(o,r){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new g.FileOperationError((0,T.localize)(12,null,this.resourceForError(o)),g.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==g.ETAG_DISABLED&&r.etag===e.etag)throw new g.NotModifiedSinceFileOperationError((0,T.localize)(13,null),e,r);return this.validateReadFileLimits(o,e.size,r),e}validateReadFileLimits(o,r,e){if(typeof e?.limits?.size=="number"&&r>e.limits.size)throw new g.TooLargeFileOperationError((0,T.localize)(14,null,this.resourceForError(o)),g.FileOperationResult.FILE_TOO_LARGE,r,e)}async canMove(o,r,e){return this.doCanMoveCopy(o,r,"move",e)}async canCopy(o,r,e){return this.doCanMoveCopy(o,r,"copy",e)}async doCanMoveCopy(o,r,e,n){if(o.toString()!==r.toString())try{const s=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),f=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(s,o,f,r,e,n)}catch(s){return s}return!0}async move(o,r,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),f=await this.doMoveCopy(n,o,s,r,"move",!!e),I=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,f==="move"?g.FileOperation.MOVE:g.FileOperation.COPY,I)),I}async copy(o,r,e){const n=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),f=await this.doMoveCopy(n,o,s,r,"copy",!!e),I=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,f==="copy"?g.FileOperation.COPY:g.FileOperation.MOVE,I)),I}async doMoveCopy(o,r,e,n,s,f){if(r.toString()===n.toString())return s;const{exists:I,isSameResourceWithDifferentPathCase:O}=await this.doValidateMoveCopy(o,r,e,n,s,f);if(I&&!O&&f&&await this.del(n,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(n)),s==="copy"){if(o===e&&(0,g.hasFileFolderCopyCapability)(o))await o.copy(r,n,{overwrite:f});else{const N=await this.resolve(r);N.isDirectory?await this.doCopyFolder(o,N,e,n):await this.doCopyFile(o,r,e,n)}return s}else return o===e?(await o.rename(r,n,{overwrite:f}),s):(await this.doMoveCopy(o,r,e,n,"copy",f),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(o,r,e,n){if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,r,e,n);if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,r,e,n);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,r,e,n);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,r,e,n)}async doCopyFolder(o,r,e,n){await e.mkdir(n),Array.isArray(r.children)&&await D.Promises.settled(r.children.map(async s=>{const f=this.getExtUri(e).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),e,f):this.doCopyFile(o,s.resource,e,f)}))}async doValidateMoveCopy(o,r,e,n,s,f){let I=!1;if(o===e){const{providerExtUri:N,isPathCaseSensitive:k}=this.getExtUri(o);if(k||(I=N.isEqual(r,n)),I&&s==="copy")throw new Error((0,T.localize)(15,null,this.resourceForError(r),this.resourceForError(n)));if(!I&&N.isEqualOrParent(n,r))throw new Error((0,T.localize)(16,null,this.resourceForError(r),this.resourceForError(n)))}const O=await this.exists(n);if(O&&!I){if(!f)throw new g.FileOperationError((0,T.localize)(17,null,this.resourceForError(r),this.resourceForError(n)),g.FileOperationResult.FILE_MOVE_CONFLICT);if(o===e){const{providerExtUri:N}=this.getExtUri(o);if(N.isEqualOrParent(r,n))throw new Error((0,T.localize)(18,null,this.resourceForError(r),this.resourceForError(n)))}}return{exists:O,isSameResourceWithDifferentPathCase:I}}getExtUri(o){const r=this.isPathCaseSensitive(o);return{providerExtUri:r?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(o){return!!(o.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(o){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(r,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,g.FileOperation.CREATE,e)),e}async mkdirp(o,r){const e=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&g.FileType.Directory))throw new Error((0,T.localize)(19,null,this.resourceForError(r)));break}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileNotFound)throw s;e.push(n.basename(r)),r=n.dirname(r)}for(let s=e.length-1;s>=0;s--){r=n.joinPath(r,e[s]);try{await o.mkdir(r)}catch(f){if((0,g.toFileSystemProviderErrorCode)(f)!==g.FileSystemProviderErrorCode.FileExists)throw f}}}async canDelete(o,r){try{await this.doValidateDelete(o,r)}catch(e){return e}return!0}async doValidateDelete(o,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),n=!!r?.useTrash;if(n&&!(e.capabilities&g.FileSystemProviderCapabilities.Trash))throw new Error((0,T.localize)(20,null,this.resourceForError(o)));const s=r?.atomic;if(s&&!(e.capabilities&g.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,T.localize)(21,null,this.resourceForError(o)));if(n&&s)throw new Error((0,T.localize)(22,null,this.resourceForError(o)));let f;try{f=await e.stat(o)}catch{}if(f)this.throwIfFileIsReadonly(o,f);else throw new g.FileOperationError((0,T.localize)(23,null,this.resourceForError(o)),g.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const O=await this.resolve(o);if(O.isDirectory&&Array.isArray(O.children)&&O.children.length>0)throw new Error((0,T.localize)(24,null,this.resourceForError(o)))}return e}async del(o,r){const e=await this.doValidateDelete(o,r);let n=r;if((0,g.hasFileAtomicDeleteCapability)(e)&&!n?.atomic){const O=e.enforceAtomicDelete?.(o);O&&(n={...r,atomic:O})}const s=!!n?.useTrash,f=!!n?.recursive,I=n?.atomic??!1;await e.delete(o,{recursive:f,useTrash:s,atomic:I}),this._onDidRunOperation.fire(new g.FileOperationEvent(o,g.FileOperation.DELETE))}async cloneFile(o,r){const e=await this.withProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(!(e===n&&this.getExtUri(e).providerExtUri.isEqual(o,r)))return e===n&&(0,g.hasFileCloneCapability)(e)?e.cloneFile(o,r):(await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(r)),e===n&&(0,g.hasFileFolderCopyCapability)(e)?this.writeQueue.queueFor(o,()=>e.copy(o,r,{overwrite:!0}),this.getExtUri(e).providerExtUri):this.writeQueue.queueFor(o,()=>this.doCopyFile(e,o,n,r),this.getExtUri(e).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:E.WATCHER_CORRELATION_IDS++})}watch(o,r={recursive:!1,excludes:[]}){const e=new l.DisposableStore;let n=!1,s=()=>{n=!0};e.add((0,l.toDisposable)(()=>s())),(async()=>{try{const I=await this.doWatch(o,r);n?(0,l.dispose)(I):s=()=>(0,l.dispose)(I)}catch(I){this.logService.error(I)}})();const f=r.correlationId;if(typeof f=="number"){const I=e.add(new L.Emitter);return e.add(this.internalOnDidFilesChange.event(N=>{N.correlates(f)&&I.fire(N)})),{onDidChange:I.event,dispose:()=>e.dispose()}}return e}async doWatch(o,r){const e=await this.withProvider(o),n=(0,C.hash)([this.getExtUri(e).providerExtUri.getComparisonKey(o),r]);let s=this.activeWatchers.get(n);return s||(s={count:0,disposable:e.watch(o,r)},this.activeWatchers.set(n,s)),s.count+=1,(0,l.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,l.dispose)(s.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,r,e,n){return this.writeQueue.queueFor(r,async()=>{const s=await o.open(r,{create:!0,unlock:e?.unlock??!1});try{(0,S.isReadableStream)(n)||(0,S.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,s,n):await this.doWriteReadableBufferedQueued(o,s,n)}catch(f){throw(0,g.ensureFileSystemProviderError)(f)}finally{await o.close(s)}},this.getExtUri(o).providerExtUri)}async doWriteStreamBufferedQueued(o,r,e){let n=0,s;if((0,S.isReadableBufferedStream)(e)){if(e.buffer.length>0){const f=y.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,r,f,f.byteLength,n,0),n+=f.byteLength}if(e.ended)return;s=e.stream}else s=e;return new Promise((f,I)=>{(0,S.listenStream)(s,{onData:async O=>{s.pause();try{await this.doWriteBuffer(o,r,O,O.byteLength,n,0)}catch(N){return I(N)}n+=O.byteLength,setTimeout(()=>s.resume())},onError:O=>I(O),onEnd:()=>f()})})}async doWriteReadableBufferedQueued(o,r,e){let n=0,s;for(;(s=e.read())!==null;)await this.doWriteBuffer(o,r,s,s.byteLength,n,0),n+=s.byteLength}async doWriteBuffer(o,r,e,n,s,f){let I=0;for(;I<n;){const O=await o.write(r,s+I,e.buffer,f+I,n-I);I+=O}}async doWriteUnbuffered(o,r,e,n){return this.writeQueue.queueFor(r,()=>this.doWriteUnbufferedQueued(o,r,e,n),this.getExtUri(o).providerExtUri)}async doWriteUnbufferedQueued(o,r,e,n){let s;n instanceof y.VSBuffer?s=n:(0,S.isReadableStream)(n)?s=await(0,y.streamToBuffer)(n):(0,S.isReadableBufferedStream)(n)?s=await(0,y.bufferedStreamToBuffer)(n):s=(0,y.readableToBuffer)(n),await o.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1,atomic:e?.atomic??!1})}async doPipeBuffered(o,r,e,n){return this.writeQueue.queueFor(n,()=>this.doPipeBufferedQueued(o,r,e,n),this.getExtUri(e).providerExtUri)}async doPipeBufferedQueued(o,r,e,n){let s,f;try{s=await o.open(r,{create:!1}),f=await e.open(n,{create:!0,unlock:!1});const I=y.VSBuffer.alloc(this.BUFFER_SIZE);let O=0,N=0,k=0;do k=await o.read(s,O,I.buffer,N,I.byteLength-N),await this.doWriteBuffer(e,f,I,k,O,N),O+=k,N+=k,N===I.byteLength&&(N=0);while(k>0)}catch(I){throw(0,g.ensureFileSystemProviderError)(I)}finally{await D.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof f=="number"?e.close(f):Promise.resolve()])}}async doPipeUnbuffered(o,r,e,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedQueued(o,r,e,n),this.getExtUri(e).providerExtUri)}async doPipeUnbufferedQueued(o,r,e,n){return e.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,r,e,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedToBufferedQueued(o,r,e,n),this.getExtUri(e).providerExtUri)}async doPipeUnbufferedToBufferedQueued(o,r,e,n){const s=await e.open(n,{create:!0,unlock:!1});try{const f=await o.readFile(r);await this.doWriteBuffer(e,s,y.VSBuffer.wrap(f),f.byteLength,0,0)}catch(f){throw(0,g.ensureFileSystemProviderError)(f)}finally{await e.close(s)}}async doPipeBufferedToUnbuffered(o,r,e,n){const s=await(0,y.streamToBuffer)(this.readFileBuffered(o,r,R.CancellationToken.None));await this.doWriteUnbuffered(e,n,void 0,s)}throwIfFileSystemIsReadonly(o,r){if(o.capabilities&g.FileSystemProviderCapabilities.Readonly)throw new g.FileOperationError((0,T.localize)(25,null,this.resourceForError(r)),g.FileOperationResult.FILE_PERMISSION_DENIED);return o}throwIfFileIsReadonly(o,r){if((r.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,T.localize)(26,null,this.resourceForError(o)),g.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(o){return o.scheme===c.Schemas.file?o.fsPath:o.toString(!0)}};t.FileService=u,t.FileService=u=E=Se([re(0,v.ILogService)],u)}),define(se[133],oe([0,1,61,176,8,31,14,5,64,2,16,13,17,46,25,108,10,63,130,36,128,127]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S,T,g,d,v,P,E,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(b)}catch(o){console.error(`Error enabling graceful-fs: ${(0,P.toErrorMessage)(o)}`)}})();class i extends v.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(r,e){super(r,e),this.onDidChangeCapabilities=C.Event.None,this.resourceLocks=new R.ResourceMap(n=>h.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,c.isLinux&&(this._capabilities|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(r){try{const{stat:e,symbolicLink:n}=await S.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(e,n),ctime:e.birthtime.getTime(),mtime:e.mtime.getTime(),size:e.size,permissions:e.mode&128?void 0:g.FilePermission.Locked}}catch(e){throw this.toFileSystemProviderError(e)}}async statIgnoreError(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const e=await S.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),n=[];return await Promise.all(e.map(async s=>{try{let f;s.isSymbolicLink()?f=(await this.stat((0,h.joinPath)(r,s.name))).type:f=this.toType(s),n.push([s.name,f])}catch(f){this.logService.trace(f)}})),n}catch(e){throw this.toFileSystemProviderError(e)}}toType(r,e){let n;return e?.dangling?n=g.FileType.Unknown:r.isFile()?n=g.FileType.File:r.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,e&&(n|=g.FileType.SymbolicLink),n}async createResourceLock(r){const e=this.toFilePath(r);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${e})`);let n;for(;n=this.resourceLocks.get(r);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${e})`),await n.wait();const s=new y.Barrier;return this.resourceLocks.set(r,s),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${e})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${e})`),this.resourceLocks.get(r)===s&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${e})`),this.resourceLocks.delete(r)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${e})`),s.open()})}async readFile(r,e){let n;try{e?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),n=await this.createResourceLock(r));const s=this.toFilePath(r);return await S.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{n?.dispose()}}traceLock(r){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(r)}readFileStream(r,e,n){const s=(0,m.newWriteableStream)(f=>L.VSBuffer.concat(f.map(I=>L.VSBuffer.wrap(I))).buffer);return(0,d.readFileIntoStream)(this,r,s,f=>f.buffer,{...e,bufferSize:256*1024},n),s}async writeFile(r,e,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(r)?this.doWriteFileAtomic(r,(0,h.joinPath)((0,h.dirname)(r),`${(0,h.basename)(r)}${n.atomic.postfix}`),e,n):this.doWriteFile(r,e,n)}async canWriteFileAtomic(r){try{const e=this.toFilePath(r),{symbolicLink:n}=await S.SymlinkSupport.stat(e);if(n)return!1}catch{}return!0}async doWriteFileAtomic(r,e,n,s){const f=new l.DisposableStore;try{f.add(await this.createResourceLock(r)),f.add(await this.createResourceLock(e)),await this.doWriteFile(e,n,s,!0);try{await this.rename(e,r,{overwrite:!0})}catch(I){try{await this.delete(e,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{f.dispose()}}async doWriteFile(r,e,n,s){let f;try{const I=this.toFilePath(r);if(!n.create||!n.overwrite){if(await S.Promises.exists(I)){if(!n.overwrite)throw(0,g.createFileSystemProviderError)((0,T.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.createFileSystemProviderError)((0,T.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(r,{create:!0,unlock:n.unlock},s),await this.write(f,0,e,0,e.byteLength)}catch(I){throw await this.toFileSystemProviderWriteError(r,I)}finally{typeof f=="number"&&await this.close(f)}}static{this.canFlush=!0}static configureFlushOnWrite(r){i.canFlush=r}async open(r,e,n){const s=this.toFilePath(r);let f;(0,g.isFileOpenForWriteOptions)(e)&&!n&&(f=await this.createResourceLock(r));let I;try{if((0,g.isFileOpenForWriteOptions)(e)&&e.unlock)try{const{stat:N}=await S.SymlinkSupport.stat(s);N.mode&128||await S.Promises.chmod(s,N.mode|128)}catch(N){N.code!=="ENOENT"&&this.logService.trace(N)}let O;if((0,g.isFileOpenForWriteOptions)(e)){if(c.isWindows)try{await S.Promises.truncate(s,0),O="r+"}catch(N){N.code!=="ENOENT"&&this.logService.trace(N)}O||(O="w")}else O="r";I=await S.Promises.open(s,O)}catch(O){throw f?.dispose(),(0,g.isFileOpenForWriteOptions)(e)?await this.toFileSystemProviderWriteError(r,O):this.toFileSystemProviderError(O)}if(this.mapHandleToPos.set(I,0),(0,g.isFileOpenForWriteOptions)(e)&&this.writeHandles.set(I,r),f){const O=this.mapHandleToLock.get(I);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${s})`),this.mapHandleToLock.set(I,f),O&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${s})`),O.dispose())}return I}async close(r){const e=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&i.canFlush)try{await S.Promises.fdatasync(r)}catch(n){i.configureFlushOnWrite(!1),this.logService.error(n)}return await S.Promises.close(r)}catch(n){throw this.toFileSystemProviderError(n)}finally{e&&(this.mapHandleToLock.get(r)===e&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),e.dispose())}}async read(r,e,n,s,f){const I=this.normalizePos(r,e);let O=null;try{O=(await S.Promises.read(r,n,s,f,I)).bytesRead}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(r,I,O)}return O}normalizePos(r,e){return e===this.mapHandleToPos.get(r)?null:e}updatePos(r,e,n){const s=this.mapHandleToPos.get(r);typeof s=="number"&&(typeof e=="number"||(typeof n=="number"?this.mapHandleToPos.set(r,s+n):this.mapHandleToPos.delete(r)))}async write(r,e,n,s,f){return(0,y.retry)(()=>this.doWrite(r,e,n,s,f),100,3)}async doWrite(r,e,n,s,f){const I=this.normalizePos(r,e);let O=null;try{O=(await S.Promises.write(r,n,s,f,I)).bytesWritten}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),N)}finally{this.updatePos(r,I,O)}return O}async mkdir(r){try{await S.Promises.mkdir(this.toFilePath(r))}catch(e){throw this.toFileSystemProviderError(e)}}async delete(r,e){try{const n=this.toFilePath(r);if(e.recursive){let s;e?.atomic!==!1&&e.atomic.postfix&&(s=(0,a.join)((0,a.dirname)(n),`${(0,a.basename)(n)}${e.atomic.postfix}`)),await S.Promises.rm(n,S.RimRafMode.MOVE,s)}else try{await S.Promises.unlink(n)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let f=!1;try{const{stat:I,symbolicLink:O}=await S.SymlinkSupport.stat(n);f=I.isDirectory()&&!O}catch{}if(f)await S.Promises.rmdir(n);else throw s}else throw s}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(r,e,n){const s=this.toFilePath(r),f=this.toFilePath(e);if(s!==f)try{await this.validateMoveCopy(r,e,"move",n.overwrite),await S.Promises.rename(s,f)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,T.localize)(2,null,(0,a.basename)(s),(0,a.basename)((0,a.dirname)(f)),I.toString()))),this.toFileSystemProviderError(I)}}async copy(r,e,n){const s=this.toFilePath(r),f=this.toFilePath(e);if(s!==f)try{await this.validateMoveCopy(r,e,"copy",n.overwrite),await S.Promises.copy(s,f,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,T.localize)(3,null,(0,a.basename)(s),(0,a.basename)((0,a.dirname)(f)),I.toString()))),this.toFileSystemProviderError(I)}}async validateMoveCopy(r,e,n,s){const f=this.toFilePath(r),I=this.toFilePath(e);let O=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(O=(0,p.isEqual)(f,I,!0)),O){if(n==="copy")throw(0,g.createFileSystemProviderError)((0,T.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const k=await this.statIgnoreError(r);if(!k)throw(0,g.createFileSystemProviderError)((0,T.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const F=await this.statIgnoreError(e);if(F){if(!s)throw(0,g.createFileSystemProviderError)((0,T.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);k.type&g.FileType.File&&F.type&g.FileType.File||await this.delete(e,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,e){return this.doCloneFile(r,e,!1)}async doCloneFile(r,e,n){const s=this.toFilePath(r),f=this.toFilePath(e),I=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,p.isEqual)(s,f,!I))return;const O=new l.DisposableStore;try{O.add(await this.createResourceLock(r)),O.add(await this.createResourceLock(e)),n&&await S.Promises.mkdir((0,a.dirname)(f),{recursive:!0}),await S.Promises.copyFile(s,f)}catch(N){if(N.code==="ENOENT"&&!n)return this.doCloneFile(r,e,!0);throw this.toFileSystemProviderError(N)}finally{O.dispose()}}createUniversalWatcher(r,e,n){return new E.UniversalWatcherClient(s=>r(s),s=>e(s),n)}createNonRecursiveWatcher(r,e,n){return new u.NodeJSWatcherClient(s=>r(s),s=>e(s),n)}toFileSystemProviderError(r){if(r instanceof g.FileSystemProviderError)return r;let e=r,n;switch(r.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":e=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(e,n)}async toFileSystemProviderWriteError(r,e){let n=this.toFileSystemProviderError(e);if(r&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await S.SymlinkSupport.stat(this.toFilePath(r));s.mode&128||(n=(0,g.createFileSystemProviderError)(e,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return n}}t.DiskFileSystemProvider=i}),define(se[134],oe([0,1,2,6]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogService=void 0;class y extends b.Disposable{constructor(L,C=[]){super(),this.logger=new D.MultiplexLogger([L,...C]),this._register(L.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(L){this.logger.setLevel(L)}getLevel(){return this.logger.getLevel()}trace(L,...C){this.logger.trace(L,...C)}debug(L,...C){this.logger.debug(L,...C)}info(L,...C){this.logger.info(L,...C)}warn(L,...C){this.logger.warn(L,...C)}error(L,...C){this.logger.error(L,...C)}flush(){this.logger.flush()}}t.LogService=y}),define(se[135],oe([0,1,10,6]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;var y;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(y||(y={}));async function R(l,a,c,h,m){try{const S=await new Promise((g,d)=>{H(["@vscode/spdlog"],g,d)});S.setFlushOn(y.Trace);const T=await S.createAsyncRotatingLogger(l,a,c,h);return m?T.clearFormatters():T.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),T}catch(S){console.error(S)}return null}function L(l,a,c){switch(a){case D.LogLevel.Trace:l.trace(c);break;case D.LogLevel.Debug:l.debug(c);break;case D.LogLevel.Info:l.info(c);break;case D.LogLevel.Warning:l.warn(c);break;case D.LogLevel.Error:l.error(c);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${a}`)}}function C(l,a){switch(a){case D.LogLevel.Trace:l.setLevel(y.Trace);break;case D.LogLevel.Debug:l.setLevel(y.Debug);break;case D.LogLevel.Info:l.setLevel(y.Info);break;case D.LogLevel.Warning:l.setLevel(y.Warning);break;case D.LogLevel.Error:l.setLevel(y.Error);break;case D.LogLevel.Off:l.setLevel(y.Off);break;default:throw new Error(`Invalid log level ${a}`)}}class p extends D.AbstractMessageLogger{constructor(a,c,h,m,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(a,c,h,m),this._register(this.onDidChangeLogLevel(T=>{this._logger&&C(this._logger,T)}))}async _createSpdLogLogger(a,c,h,m){const S=h?6:1,T=30/S*b.ByteSize.MB,g=await R(a,c,T,S,m);if(g){this._logger=g,C(this._logger,this.getLevel());for(const{level:d,message:v}of this.buffer)L(this._logger,d,v);this.buffer=[]}}log(a,c){this._logger?L(this._logger,a,c):this.getLevel()<=a&&this.buffer.push({level:a,message:c})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=p}),define(se[136],oe([0,1,29,6,135]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LoggerService=void 0;class R extends D.AbstractLoggerService{doCreateLogger(C,p,l){return new y.SpdLogLogger((0,b.generateUuid)(),C.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,p)}}t.LoggerService=R}),define(se[39],oe([0,1,5,66,2,11]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullPolicyService=t.AbstractPolicyService=t.IPolicyService=void 0,t.IPolicyService=(0,R.createDecorator)("policy");class L extends y.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const a=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},a!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),D.Iterable.reduce(this.policies.entries(),(c,[h,m])=>({...c,[h]:m}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return D.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[a,c])=>({...l,[a]:{definition:c,value:this.policies.get(a)}}),{})}}t.AbstractPolicyService=L;class C{constructor(){this.onDidChange=b.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.NullPolicyService=C}),define(se[137],oe([0,1,8,5,66,3,10,6,39]),function(H,t,b,D,y,R,L,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FilePolicyService=void 0;function l(c,h){const m=[];for(const S of new Set(y.Iterable.concat(c.keys(),h.keys())))c.get(S)!==h.get(S)&&m.push(S);return m}let a=class extends p.AbstractPolicyService{constructor(h,m,S){super(),this.file=h,this.fileService=m,this.logService=S,this.throttledDelayer=this._register(new b.ThrottledDelayer(500));const T=D.Event.filter(m.onDidFilesChange,g=>g.affects(h));this._register(m.watch(h)),this._register(T(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const h=new Map;try{const m=await this.fileService.readFile(this.file),S=JSON.parse(m.value.toString());if(!(0,R.isObject)(S))throw new Error("Policy file isn't a JSON object");for(const T of Object.keys(S))this.policyDefinitions[T]&&h.set(T,S[T])}catch(m){m.fileOperationResult!==L.FileOperationResult.FILE_NOT_FOUND&&this.logService.error("[FilePolicyService] Failed to read policies",m)}return h}async refresh(){const h=await this.read(),m=l(this.policies,h);this.policies=h,m.length>0&&this._onDidChange.fire(m)}};t.FilePolicyService=a,t.FilePolicyService=a=Se([re(1,L.IFileService),re(2,C.ILogService)],a)}),define(se[138],oe([0,1,39,8,2,6]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativePolicyService=void 0;let L=class extends b.AbstractPolicyService{constructor(p,l){super(),this.logService=p,this.productName=l,this.throttler=new D.Throttler,this.watcher=this._register(new y.MutableDisposable)}async _updatePolicyDefinitions(p){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(p).length} policy definitions`);const{createWatcher:l}=await new Promise((a,c)=>{H(["@vscode/policy-watcher"],a,c)});await this.throttler.queue(()=>new Promise((a,c)=>{try{this.watcher.value=l(this.productName,p,h=>{this._onDidPolicyChange(h),a()})}catch(h){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",h),c(h)}}))}_onDidPolicyChange(p){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(p)}`);for(const l in p){const a=p[l];a===void 0?this.policies.delete(l):this.policies.set(l,a)}this._onDidChange.fire(Object.keys(p))}};t.NativePolicyService=L,t.NativePolicyService=L=Se([re(0,R.ILogService)],L)}),define(se[33],oe([0,1,11]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,b.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(se[38],oe([0,1,76,3]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class y{constructor(){this.data=new Map}add(L,C){b.ok(D.isString(L)),b.ok(D.isObject(C)),b.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,C)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}t.Registry=new y}),define(se[139],oe([0,1,5,38]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function y(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this._onDidChangeSchema=new b.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,l){this.schemasById[y(p)]=l,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new R;D.Registry.add(t.Extensions.JSONContribution,L)}),define(se[40],oe([0,1,20,5,3,95,30,139,38]),function(H,t,b,D,y,R,L,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0,t.overrideIdentifiersFromKey=T,t.keyFromOverrideIdentifiers=g,t.getDefaultValue=d,t.validateProperty=P,t.getScopes=E;var l;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(l||(t.EditPresentationTypes=l={})),t.Extensions={Configuration:"base.contributions.configuration"};var a;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(a||(t.ConfigurationScope=a={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const c=p.Registry.as(C.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const r=new Set;this.doRegisterConfigurations(i,o,r),c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(i){const o=new Set;this.doDeregisterConfigurations(i,o),c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const r=new Set;this.doDeregisterConfigurations(o,r),this.doRegisterConfigurations(i,!1,r),c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(i){const o=new Set;this.doRegisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,o){const r=[];for(const{overrides:e,source:n}of i)for(const s in e)if(o.add(s),t.OVERRIDE_PROPERTY_REGEX.test(s)){const f=this.configurationDefaultsOverrides.get(s),I=f?.valuesSources??new Map;if(n)for(const F of Object.keys(e[s]))I.set(F,n);const O={...f?.value||{},...e[s]};this.configurationDefaultsOverrides.set(s,{source:n,value:O,valuesSources:I});const N=(0,L.getLanguageTagSettingPlainKey)(s),k={type:"object",default:O,description:R.localize(1,null,N),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:O,source:y.isString(n)?void 0:n,defaultValueSource:n};r.push(...T(s)),this.configurationProperties[s]=k,this.defaultLanguageConfigurationOverridesNode.properties[s]=k}else{this.configurationDefaultsOverrides.set(s,{value:e[s],source:n});const f=this.configurationProperties[s];f&&(this.updatePropertyDefaultValue(s,f),this.updateSchema(s,f))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(i){const o=new Set;this.doDeregisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,o){for(const{overrides:r,source:e}of i)for(const n in r){const s=this.configurationDefaultsOverrides.get(n),f=y.isString(e)?e:e?.id,I=y.isString(s?.source)?s?.source:s?.source?.id;if(f===I)if(o.add(n),this.configurationDefaultsOverrides.delete(n),t.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const O=this.configurationProperties[n];O&&(this.updatePropertyDefaultValue(n,O),this.updateSchema(n,O))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let o=!1;const r=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,r),o=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,r),o=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,r),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o,r){i.forEach(e=>{this.validateAndRegisterProperties(e,o,e.extensionInfo,e.restrictedProperties,void 0,r),this.configurationContributors.push(e),this.registerJSONConfiguration(e)})}doDeregisterConfigurations(i,o){const r=e=>{if(e.properties)for(const n in e.properties){o.add(n);const s=this.configurationProperties[n];s?.policy?.name&&this.policyConfigurations.delete(s.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,e.properties[n])}e.allOf?.forEach(n=>r(n))};for(const e of i){r(e);const n=this.configurationContributors.indexOf(e);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(i,o=!0,r,e,n=a.WINDOW,s){n=y.isUndefinedOrNull(i.scope)?n:i.scope;const f=i.properties;if(f)for(const O in f){const N=f[O];if(o&&P(O,N)){delete f[O];continue}if(N.source=r,N.defaultDefaultValue=f[O].default,this.updatePropertyDefaultValue(O,N),t.OVERRIDE_PROPERTY_REGEX.test(O)?N.scope=void 0:(N.scope=y.isUndefinedOrNull(N.scope)?n:N.scope,N.restricted=y.isUndefinedOrNull(N.restricted)?!!e?.includes(O):N.restricted),f[O].hasOwnProperty("included")&&!f[O].included){this.excludedConfigurationProperties[O]=f[O],delete f[O];continue}else this.configurationProperties[O]=f[O],f[O].policy?.name&&this.policyConfigurations.set(f[O].policy.name,O);!f[O].deprecationMessage&&f[O].markdownDeprecationMessage&&(f[O].deprecationMessage=f[O].markdownDeprecationMessage),s.add(O)}const I=i.allOf;if(I)for(const O of I)this.validateAndRegisterProperties(O,o,r,e,n,s)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=r=>{const e=r.properties;if(e)for(const s in e)this.updateSchema(s,e[s]);r.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(t.allSettings.properties[i]=o,o.scope){case a.APPLICATION:t.applicationSettings.properties[i]=o;break;case a.MACHINE:t.machineSettings.properties[i]=o;break;case a.MACHINE_OVERRIDABLE:t.machineOverridableSettings.properties[i]=o;break;case a.WINDOW:t.windowSettings.properties[i]=o;break;case a.RESOURCE:t.resourceSettings.properties[i]=o;break;case a.LANGUAGE_OVERRIDABLE:t.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete t.allSettings.properties[i],o.scope){case a.APPLICATION:delete t.applicationSettings.properties[i];break;case a.MACHINE:delete t.machineSettings.properties[i];break;case a.MACHINE_OVERRIDABLE:delete t.machineOverridableSettings.properties[i];break;case a.WINDOW:delete t.windowSettings.properties[i];break;case a.RESOURCE:case a.LANGUAGE_OVERRIDABLE:delete t.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,r),t.allSettings.properties[o]=r,t.applicationSettings.properties[o]=r,t.machineSettings.properties[o]=r,t.machineOverridableSettings.properties[o]=r,t.windowSettings.properties[o]=r,t.resourceSettings.properties[o]=r}}registerOverridePropertyPatternKey(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const r=this.configurationDefaultsOverrides.get(i);let e=r?.value,n=r?.source;y.isUndefined(e)&&(e=o.defaultDefaultValue,n=void 0),y.isUndefined(e)&&(e=d(o.type)),o.default=e,o.defaultValueSource=n}}const m="\\[([^\\]]+)\\]",S=new RegExp(m,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function T(u){const i=[];if(t.OVERRIDE_PROPERTY_REGEX.test(u)){let o=S.exec(u);for(;o?.length;){const r=o[1].trim();r&&i.push(r),o=S.exec(u)}}return(0,b.distinct)(i)}function g(u){return u.reduce((i,o)=>`${i}[${o}]`,"")}function d(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const v=new h;p.Registry.add(t.Extensions.Configuration,v);function P(u,i){return u.trim()?t.OVERRIDE_PROPERTY_REGEX.test(u)?R.localize(7,null,u):v.getConfigurationProperties()[u]!==void 0?R.localize(8,null,u):i.policy?.name&&v.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,u,i.policy?.name,v.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}function E(){const u=[],i=v.getConfigurationProperties();for(const o of Object.keys(i))u.push([o,i[o].scope]);return u.push(["launch",a.RESOURCE]),u.push(["task",a.RESOURCE]),u}}),define(se[67],oe([0,1,20,5,34,2,31,28,3,12,30,40,10,38]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationChangeEvent=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.ConfigurationModel=void 0,t.mergeChanges=E;function S(r){return Object.isFrozen(r)?r:C.deepFreeze(r)}class T{static createEmptyModel(e){return new T({},[],[],void 0,e)}constructor(e,n,s,f,I){this._contents=e,this._keys=n,this._overrides=s,this.raw=f,this.logService=I,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const e=this.raw.map(n=>{if(n instanceof T)return n;const s=new g("",this.logService);return s.parseRaw(n),s.configurationModel});this._rawConfiguration=e.reduce((n,s)=>s===n?s:n.merge(s),e[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,a.getConfigurationValue)(this.contents,e):this.contents}inspect(e,n){const s=this;return{get value(){return S(s.rawConfiguration.getValue(e))},get override(){return n?S(s.rawConfiguration.getOverrideValue(e,n)):void 0},get merged(){return S(n?s.rawConfiguration.override(n).getValue(e):s.rawConfiguration.getValue(e))},get overrides(){const f=[];for(const{contents:I,identifiers:O,keys:N}of s.rawConfiguration.overrides){const k=new T(I,N,[],void 0,s.logService).getValue(e);k!==void 0&&f.push({identifiers:O,value:k})}return f.length?S(f):void 0}}}getOverrideValue(e,n){const s=this.getContentsForOverrideIdentifer(n);return s?e?(0,a.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const s of this.overrides)s.identifiers.includes(e)&&n.push(...s.keys);return b.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return b.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=C.deepClone(this.contents),s=C.deepClone(this.overrides),f=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const O of e)if(I.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.mergeContents(n,O.contents);for(const N of O.overrides){const[k]=s.filter(F=>b.equals(F.identifiers,N.identifiers));k?(this.mergeContents(k.contents,N.contents),k.keys.push(...N.keys),k.keys=b.distinct(k.keys)):s.push(C.deepClone(N))}for(const N of O.keys)f.indexOf(N)===-1&&f.push(N)}return new T(n,f,s,I.every(O=>O instanceof T)?void 0:I,this.logService)}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const f of b.distinct([...Object.keys(this.contents),...Object.keys(n)])){let I=this.contents[f];const O=n[f];O&&(typeof I=="object"&&typeof O=="object"?(I=C.deepClone(I),this.mergeContents(I,O)):I=O),s[f]=I}return new T(s,this.keys,this.overrides,void 0,this.logService)}mergeContents(e,n){for(const s of Object.keys(n)){if(s in e&&p.isObject(e[s])&&p.isObject(n[s])){this.mergeContents(e[s],n[s]);continue}e[s]=C.deepClone(n[s])}}getContentsForOverrideIdentifer(e){let n=null,s=null;const f=I=>{I&&(s?this.mergeContents(s,I):s=C.deepClone(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===e?n=I.contents:I.identifiers.includes(e)&&f(I.contents);return f(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(e,n){this.updateValue(e,n,!0)}setValue(e,n){this.updateValue(e,n,!1)}removeValue(e){const n=this.keys.indexOf(e);n!==-1&&(this.keys.splice(n,1),(0,a.removeFromValueTree)(this.contents,e),c.OVERRIDE_PROPERTY_REGEX.test(e)&&this.overrides.splice(this.overrides.findIndex(s=>b.equals(s.identifiers,(0,c.overrideIdentifiersFromKey)(e))),1))}updateValue(e,n,s){(0,a.addToValueTree)(this.contents,e,n,f=>this.logService.error(f)),s=s||this.keys.indexOf(e)===-1,s&&this.keys.push(e),c.OVERRIDE_PROPERTY_REGEX.test(e)&&this.overrides.push({identifiers:(0,c.overrideIdentifiersFromKey)(e),keys:Object.keys(this.contents[e]),contents:(0,a.toValuesTree)(this.contents[e],f=>this.logService.error(f))})}}t.ConfigurationModel=T;class g{constructor(e,n){this._name=e,this.logService=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||T.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!p.isUndefinedOrNull(e)){const s=this.doParseContent(e);this.parseRaw(s,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:s,keys:f,overrides:I,restricted:O,hasExcludedProperties:N}=this.doParseRaw(e,n);this._configurationModel=new T(s,f,I,N?[e]:void 0,this.logService),this._restrictedConfigurations=O||[]}doParseContent(e){let n={},s=null,f=[];const I=[],O=[];function N(F){Array.isArray(f)?f.push(F):s!==null&&(f[s]=F)}const k={onObjectBegin:()=>{const F={};N(F),I.push(f),f=F,s=null},onObjectProperty:F=>{s=F},onObjectEnd:()=>{f=I.pop()},onArrayBegin:()=>{const F=[];N(F),I.push(f),f=F,s=null},onArrayEnd:()=>{f=I.pop()},onLiteralValue:N,onError:(F,_,K)=>{O.push({error:F,offset:_,length:K})}};if(e)try{y.visit(e,k),n=f[0]||{}}catch(F){this.logService.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return n}doParseRaw(e,n){const s=m.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),f=this.filter(e,s,!0,n);e=f.raw;const I=(0,a.toValuesTree)(e,k=>this.logService.error(`Conflict in settings file ${this._name}: ${k}`)),O=Object.keys(e),N=this.toOverrides(e,k=>this.logService.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:I,keys:O,overrides:N,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}filter(e,n,s,f){let I=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:e,restricted:[],hasExcludedProperties:I};const O={},N=[];for(const k in e)if(c.OVERRIDE_PROPERTY_REGEX.test(k)&&s){const F=this.filter(e[k],n,!1,f);O[k]=F.raw,I=I||F.hasExcludedProperties,N.push(...F.restricted)}else{const F=n[k],_=F?typeof F.scope<"u"?F.scope:c.ConfigurationScope.WINDOW:void 0;F?.restricted&&N.push(k),!f.exclude?.includes(k)&&(f.include?.includes(k)||(_===void 0||f.scopes===void 0||f.scopes.includes(_))&&!(f.skipRestricted&&F?.restricted))?O[k]=e[k]:I=!0}return{raw:O,restricted:N,hasExcludedProperties:I}}toOverrides(e,n){const s=[];for(const f of Object.keys(e))if(c.OVERRIDE_PROPERTY_REGEX.test(f)){const I={};for(const O in e[f])I[O]=e[f][O];s.push({identifiers:(0,c.overrideIdentifiersFromKey)(f),keys:Object.keys(I),contents:(0,a.toValuesTree)(I,n)})}return s}}t.ConfigurationModelParser=g;class d extends R.Disposable{constructor(e,n,s,f,I){super(),this.userSettingsResource=e,this.parseOptions=n,this.fileService=f,this.logService=I,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString(),I),this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.any(D.Event.filter(this.fileService.onDidFilesChange,O=>O.contains(this.userSettingsResource)),D.Event.filter(this.fileService.onDidRunOperation,O=>(O.isOperation(h.FileOperation.CREATE)||O.isOperation(h.FileOperation.COPY)||O.isOperation(h.FileOperation.DELETE)||O.isOperation(h.FileOperation.WRITE))&&s.isEqual(O.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return T.createEmptyModel(this.logService)}}reparse(e){return e&&(this.parseOptions=e),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=d;class v{constructor(e,n,s,f,I,O,N,k,F,_,K,ae,ie){this.key=e,this.overrides=n,this._value=s,this.overrideIdentifiers=f,this.defaultConfiguration=I,this.policyConfiguration=O,this.applicationConfiguration=N,this.userConfiguration=k,this.localUserConfiguration=F,this.remoteUserConfiguration=_,this.workspaceConfiguration=K,this.folderConfigurationModel=ae,this.memoryConfigurationModel=ie}get value(){return S(this._value)}toInspectValue(e){return e?.value!==void 0||e?.override!==void 0||e?.overrides!==void 0?e:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class P{constructor(e,n,s,f,I,O,N,k,F,_){this._defaultConfiguration=e,this._policyConfiguration=n,this._applicationConfiguration=s,this._localUserConfiguration=f,this._remoteUserConfiguration=I,this._workspaceConfiguration=O,this._folderConfigurations=N,this._memoryConfiguration=k,this._memoryConfigurationByResource=F,this.logService=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,n,s){return this.getConsolidatedConfigurationModel(e,n,s).getValue(e)}updateValue(e,n,s={}){let f;s.resource?(f=this._memoryConfigurationByResource.get(s.resource),f||(f=T.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(s.resource,f))):f=this._memoryConfiguration,n===void 0?f.removeValue(e):f.setValue(e,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,s){const f=this.getConsolidatedConfigurationModel(e,n,s),I=this.getFolderConfigurationModelForResource(n.resource,s),O=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,N=new Set;for(const k of f.overrides)for(const F of k.identifiers)f.getOverrideValue(e,F)!==void 0&&N.add(F);return new v(e,n,f.getValue(e),N.size?[...N]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this._workspaceConfiguration:void 0,I||void 0,O)}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(e){this._policyConfiguration=e}updateApplicationConfiguration(e){this._applicationConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const s=[];if(!n){const{added:f,updated:I,removed:O}=i(this._defaultConfiguration,e);n=[...f,...I,...O]}for(const f of n)for(const I of(0,c.overrideIdentifiersFromKey)(f)){const O=this._defaultConfiguration.getKeysForOverrideIdentifier(I),N=e.getKeysForOverrideIdentifier(I),k=[...N.filter(F=>O.indexOf(F)===-1),...O.filter(F=>N.indexOf(F)===-1),...O.filter(F=>!C.equals(this._defaultConfiguration.override(I).getValue(F),e.override(I).getValue(F)))];s.push([I,k])}return this.updateDefaultConfiguration(e),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(e){const{added:n,updated:s,removed:f}=i(this._policyConfiguration,e),I=[...n,...s,...f];return I.length&&this.updatePolicyConfiguration(e),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(e){const{added:n,updated:s,removed:f,overrides:I}=i(this.applicationConfiguration,e),O=[...n,...s,...f];return O.length&&this.updateApplicationConfiguration(e),{keys:O,overrides:I}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:s,removed:f,overrides:I}=i(this.localUserConfiguration,e),O=[...n,...s,...f];return O.length&&this.updateLocalUserConfiguration(e),{keys:O,overrides:I}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:s,removed:f,overrides:I}=i(this.remoteUserConfiguration,e),O=[...n,...s,...f];return O.length&&this.updateRemoteUserConfiguration(e),{keys:O,overrides:I}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:s,removed:f,overrides:I}=i(this.workspaceConfiguration,e),O=[...n,...s,...f];return O.length&&this.updateWorkspaceConfiguration(e),{keys:O,overrides:I}}compareAndUpdateFolderConfiguration(e,n){const s=this.folderConfigurations.get(e),{added:f,updated:I,removed:O,overrides:N}=i(s,n),k=[...f,...I,...O];return(k.length||!s)&&this.updateFolderConfiguration(e,n),{keys:k,overrides:N}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:f,removed:I,overrides:O}=i(n,void 0);return{keys:[...s,...f,...I],overrides:O}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(e,n,s){let f=this.getConsolidatedConfigurationModelForResource(n,s);return n.overrideIdentifier&&(f=f.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(e)!==void 0&&(f=f.merge(this._policyConfiguration)),f}getConsolidatedConfigurationModelForResource({resource:e},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const f=n.getFolder(e);f&&(s=this.getFolderConsolidatedConfiguration(f.uri)||s);const I=this._memoryConfigurationByResource.get(e);I&&(s=s.merge(I))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),f=this._folderConfigurations.get(e);f?(n=s.merge(f),this._foldersConsolidatedConfigurations.set(e,n)):n=s}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const s=n.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:s,overrides:f,keys:I}=this._folderConfigurations.get(n);return e.push([n,{contents:s,overrides:f,keys:I}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.keys.forEach(n=>e.add(n)),this.userConfiguration.keys.forEach(n=>e.add(n)),this._workspaceConfiguration.keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(s=>e.add(s))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(f=>n.add(f))),[...n.values()]}static parse(e,n){const s=this.parseConfigurationModel(e.defaults,n),f=this.parseConfigurationModel(e.policy,n),I=this.parseConfigurationModel(e.application,n),O=this.parseConfigurationModel(e.user,n),N=this.parseConfigurationModel(e.workspace,n),k=e.folders.reduce((F,_)=>(F.set(l.URI.revive(_[0]),this.parseConfigurationModel(_[1],n)),F),new L.ResourceMap);return new P(s,f,I,O,T.createEmptyModel(n),N,k,T.createEmptyModel(n),new L.ResourceMap,n)}static parseConfigurationModel(e,n){return new T(e.contents,e.keys,e.overrides,void 0,n)}}t.Configuration=P;function E(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,n=new Map;for(const f of r)f.keys.forEach(I=>e.add(I)),f.overrides.forEach(([I,O])=>{const N=(0,L.getOrSet)(n,I,new Set);O.forEach(k=>N.add(k))});const s=[];return n.forEach((f,I)=>s.push([I,[...f.values()]])),{keys:[...e.values()],overrides:s}}class u{constructor(e,n,s,f,I){this.change=e,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=f,this.logService=I,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const O of e.keys)this.affectedKeys.add(O);for(const[,O]of e.overrides)for(const N of O)this.affectedKeys.add(N);this._affectsConfigStr=this._marker;for(const O of this.affectedKeys)this._affectsConfigStr+=O+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(e,n){const s=this._marker+e,f=this._affectsConfigStr.indexOf(s);if(f<0)return!1;const I=f+s.length;if(I>=this._affectsConfigStr.length)return!1;const O=this._affectsConfigStr.charCodeAt(I);if(O!==this._markerCode1&&O!==this._markerCode2)return!1;if(n){const N=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,k=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!C.equals(N,k)}return!0}}t.ConfigurationChangeEvent=u;function i(r,e){const{added:n,removed:s,updated:f}=o(e?.rawConfiguration,r?.rawConfiguration),I=[],O=r?.getAllOverrideIdentifiers()||[],N=e?.getAllOverrideIdentifiers()||[];if(e){const k=N.filter(F=>!O.includes(F));for(const F of k)I.push([F,e.getKeysForOverrideIdentifier(F)])}if(r){const k=O.filter(F=>!N.includes(F));for(const F of k)I.push([F,r.getKeysForOverrideIdentifier(F)])}if(e&&r){for(const k of O)if(N.includes(k)){const F=o({contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)},{contents:e.getOverrideValue(void 0,k)||{},keys:e.getKeysForOverrideIdentifier(k)});I.push([k,[...F.added,...F.removed,...F.updated]])}}return{added:n,removed:s,updated:f,overrides:I}}function o(r,e){const n=r?e?r.keys.filter(I=>e.keys.indexOf(I)===-1):[...r.keys]:[],s=e?r?e.keys.filter(I=>r.keys.indexOf(I)===-1):[...e.keys]:[],f=[];if(r&&e){for(const I of e.keys)if(r.keys.indexOf(I)!==-1){const O=(0,a.getConfigurationValue)(e.contents,I),N=(0,a.getConfigurationValue)(r.contents,I);C.equals(O,N)||f.push(I)}}return{added:n,removed:s,updated:f}}}),define(se[140],oe([0,1,20,5,2,28,3,67,40,6,39,38]),function(H,t,b,D,y,R,L,C,p,l,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PolicyConfiguration=t.NullPolicyConfiguration=t.DefaultConfiguration=void 0;class h extends y.Disposable{get configurationModel(){return this._configurationModel}constructor(g){super(),this.logService=g,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=C.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(c.Registry.as(p.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:d})=>this.onDidUpdateConfiguration(Array.from(g),d))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(g,d){this.updateConfigurationModel(g,c.Registry.as(p.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=C.ConfigurationModel.createEmptyModel(this.logService);const g=c.Registry.as(p.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(g),g)}updateConfigurationModel(g,d){const v=this.getConfigurationDefaultOverrides();for(const P of g){const E=v[P],u=d[P];E!==void 0?this._configurationModel.addValue(P,E):u?this._configurationModel.addValue(P,u.default):this._configurationModel.removeValue(P)}}}t.DefaultConfiguration=h;class m{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=C.ConfigurationModel.createEmptyModel(new l.NullLogService)}async initialize(){return this.configurationModel}}t.NullPolicyConfiguration=m;let S=class extends y.Disposable{get configurationModel(){return this._configurationModel}constructor(g,d,v){super(),this.defaultConfiguration=g,this.policyService=d,this.logService=v,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=C.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.updatePolicyDefinitions(g),!0))),this._configurationModel}async updatePolicyDefinitions(g){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",g);const d={},v=[],P=c.Registry.as(p.Extensions.Configuration).getConfigurationProperties();for(const E of g){const u=P[E];if(!u){v.push(E);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.logService.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}v.push(E),d[u.policy.name]={type:u.type}}}return(0,L.isEmptyObject)(d)||await this.policyService.updatePolicyDefinitions(d),v}onDidChangePolicies(g){this.logService.trace("PolicyConfiguration#onDidChangePolicies",g);const d=c.Registry.as(p.Extensions.Configuration).getPolicyConfigurations(),v=(0,b.coalesce)(g.map(P=>d.get(P)));this.update(v,!0)}update(g,d){this.logService.trace("PolicyConfiguration#update",g);const v=c.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),P=[],E=this._configurationModel.isEmpty();for(const u of g){const i=v[u]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(E?o!==void 0:!(0,R.equals)(this._configurationModel.getValue(u),o))&&P.push([u,o])}else this._configurationModel.getValue(u)!==void 0&&P.push([u,void 0])}if(P.length){this.logService.trace("PolicyConfiguration#changed",P);const u=this._configurationModel;this._configurationModel=C.ConfigurationModel.createEmptyModel(this.logService);for(const i of u.keys)this._configurationModel.setValue(i,u.getValue(i));for(const[i,o]of P)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};t.PolicyConfiguration=S,t.PolicyConfiguration=S=Se([re(1,a.IPolicyService),re(2,l.ILogService)],S)}),define(se[141],oe([0,1,20,8,14,5,34,78,2,31,28,13,17,30,67,40,140,10,39]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S,T,g,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class P extends p.Disposable{constructor(i,o,r,e){super(),this.settingsResource=i,this.logService=e,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new g.DefaultConfiguration(e)),this.policyConfiguration=r instanceof v.NullPolicyService?new g.NullPolicyConfiguration:this._register(new g.PolicyConfiguration(this.defaultConfiguration,r,e)),this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,{},h.extUriBiasedIgnorePathCase,o,e)),this.configuration=new S.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,S.ConfigurationModel.createEmptyModel(e),S.ConfigurationModel.createEmptyModel(e),S.ConfigurationModel.createEmptyModel(e),S.ConfigurationModel.createEmptyModel(e),new l.ResourceMap,S.ConfigurationModel.createEmptyModel(e),new l.ResourceMap,e),this.configurationEditing=new E(i,o,this),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:n,properties:s})=>this.onDidDefaultConfigurationChange(n,s))),this._register(this.policyConfiguration.onDidChangeConfiguration(n=>this.onDidPolicyConfigurationChange(n))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[i,o,r]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new S.Configuration(i,o,S.ConfigurationModel.createEmptyModel(this.logService),r,S.ConfigurationModel.createEmptyModel(this.logService),S.ConfigurationModel.createEmptyModel(this.logService),new l.ResourceMap,S.ConfigurationModel.createEmptyModel(this.logService),new l.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(i,o){const r=typeof i=="string"?i:void 0,e=(0,m.isConfigurationOverrides)(i)?i:(0,m.isConfigurationOverrides)(o)?o:{};return this.configuration.getValue(r,e,void 0)}async updateValue(i,o,r,e,n){const s=(0,m.isConfigurationUpdateOverrides)(r)?r:(0,m.isConfigurationOverrides)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,f=s?e:r;if(f!==void 0&&f!==m.ConfigurationTarget.USER_LOCAL&&f!==m.ConfigurationTarget.USER)throw new Error(`Unable to write ${i} to target ${f}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,b.distinct)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const I=this.inspect(i,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(I.policyValue!==void 0)throw new Error(`Unable to write ${i} because it is configured in system policy.`);if((0,a.equals)(o,I.defaultValue)&&(o=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const N=s.overrideIdentifiers.sort(),k=this.configuration.localUserConfiguration.overrides.find(F=>(0,b.equals)([...F.identifiers].sort(),N));k&&(s.overrideIdentifiers=k.identifiers)}const O=s?.overrideIdentifiers?.length?[(0,T.keyFromOverrideIdentifiers)(s.overrideIdentifiers),i]:[i];await this.configurationEditing.write(O,o),await this.reloadConfiguration()}inspect(i,o={}){return this.configuration.inspect(i,o,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const i=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(i)}onDidChangeUserConfiguration(i){const o=this.configuration.toData(),r=this.configuration.compareAndUpdateLocalUserConfiguration(i);this.trigger(r,o,m.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(i,o){const r=this.configuration.toData(),e=this.configuration.compareAndUpdateDefaultConfiguration(i,o);this.trigger(e,r,m.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(i){const o=this.configuration.toData(),r=this.configuration.compareAndUpdatePolicyConfiguration(i);this.trigger(r,o,m.ConfigurationTarget.DEFAULT)}trigger(i,o,r){const e=new S.ConfigurationChangeEvent(i,{data:o},this.configuration,void 0,this.logService);e.source=r,this._onDidChangeConfiguration.fire(e)}}t.ConfigurationService=P;class E{constructor(i,o,r){this.settingsResource=i,this.fileService=o,this.configurationService=r,this.queue=new D.Queue}write(i,o){return this.queue.queue(()=>this.doWriteConfiguration(i,o))}async doWriteConfiguration(i,o){let r;try{r=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(s){if(s.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw s}const e=[];if((0,L.parse)(r,e,{allowTrailingComma:!0,allowEmptyContent:!0}),e.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.getEdits(r,i,o);r=(0,C.applyEdits)(r,n),await this.fileService.writeFile(this.settingsResource,y.VSBuffer.fromString(r))}getEdits(i,o,r){const{tabSize:e,insertSpaces:n,eol:s}=this.formattingOptions;if(!o.length){const f=JSON.stringify(r,null,n?" ".repeat(e):"	");return[{content:f,length:f.length,offset:0}]}return(0,C.setProperty)(i,o,r,{tabSize:e,insertSpaces:n,eol:s})}get formattingOptions(){if(!this._formattingOptions){let i=c.OS===c.OperatingSystem.Linux||c.OS===c.OperatingSystem.Macintosh?`
`:`\r
`;const o=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});o&&typeof o=="string"&&o!=="auto"&&(i=o),this._formattingOptions={eol:i,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(se[68],oe([0,1,15]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getRemoteAuthority=D,t.getRemoteName=y,t.parseAuthorityWithPort=R,t.parseAuthorityWithOptionalPort=L;function D(p){return p.scheme===b.Schemas.vscodeRemote?p.authority:void 0}function y(p){if(!p)return;const l=p.indexOf("+");return l<0?p:p.substr(0,l)}function R(p){const{host:l,port:a}=C(p);if(typeof a>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:a}}function L(p,l){let{host:a,port:c}=C(p);return typeof c>"u"&&(c=l),{host:a,port:c}}function C(p){const l=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const a=p.match(/^(\[[0-9a-z:]+\])$/);if(a)return{host:a[1],port:void 0};const c=p.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:p,port:void 0}}}),define(se[26],oe([0,1,32,11,68]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.ExtensionIdentifierMap=t.ExtensionIdentifierSet=t.ExtensionIdentifier=t.TargetPlatform=t.ExtensionType=t.EXTENSION_CATEGORIES=t.ALL_EXTENSION_KINDS=t.UNDEFINED_PUBLISHER=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=void 0,t.getWorkspaceSupportTypeMessage=R,t.isApplicationScopedExtension=c,t.isLanguagePackExtension=h,t.isAuthenticationProviderExtension=m,t.isResolverExtension=S,t.USER_MANIFEST_CACHE_FILE="extensions.user.cache",t.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",t.UNDEFINED_PUBLISHER="undefined_publisher",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(T){if(typeof T=="object"&&T!==null&&T.supported!==!0)return T.description}t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var L;(function(T){T[T.System=0]="System",T[T.User=1]="User"})(L||(t.ExtensionType=L={}));var C;(function(T){T.WIN32_X64="win32-x64",T.WIN32_ARM64="win32-arm64",T.LINUX_X64="linux-x64",T.LINUX_ARM64="linux-arm64",T.LINUX_ARMHF="linux-armhf",T.LINUX_PPC64LE="linux-ppc64le",T.LINUX_RISCV64="linux-riscv64",T.ALPINE_X64="alpine-x64",T.ALPINE_ARM64="alpine-arm64",T.DARWIN_X64="darwin-x64",T.DARWIN_ARM64="darwin-arm64",T.WEB="web",T.UNIVERSAL="universal",T.UNKNOWN="unknown",T.UNDEFINED="undefined"})(C||(t.TargetPlatform=C={}));class p{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,d){if(typeof g>"u"||g===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof g=="string"||typeof d=="string"){const v=typeof g=="string"?g:g.value,P=typeof d=="string"?d:d.value;return b.equalsIgnoreCase(v,P)}return g._lower===d._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}t.ExtensionIdentifier=p;class l{get size(){return this._set.size}constructor(g){if(this._set=new Set,g)for(const d of g)this.add(d)}add(g){this._set.add(p.toKey(g))}delete(g){return this._set.delete(p.toKey(g))}has(g){return this._set.has(p.toKey(g))}}t.ExtensionIdentifierSet=l;class a{constructor(){this._map=new Map}clear(){this._map.clear()}delete(g){this._map.delete(p.toKey(g))}get(g){return this._map.get(p.toKey(g))}has(g){return this._map.has(p.toKey(g))}set(g,d){this._map.set(p.toKey(g),d)}values(){return this._map.values()}forEach(g){this._map.forEach(g)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}t.ExtensionIdentifierMap=a;function c(T){return h(T)}function h(T){return T.contributes&&T.contributes.localizations?T.contributes.localizations.length>0:!1}function m(T){return T.contributes&&T.contributes.authentication?T.contributes.authentication.length>0:!1}function S(T,g){if(g){const d=`onResolveRemoteAuthority:${(0,y.getRemoteName)(g)}`;return!!T.activationEvents?.includes(d)}return!1}t.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(se[21],oe([0,1,13,99,26,11]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PreferencesLocalizedLabel=t.ExtensionsLocalizedLabel=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.ExtensionGalleryError=t.ExtensionGalleryErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.ExtensionInstallSource=t.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=t.EXTENSION_INSTALL_DEP_PACK_CONTEXT=t.EXTENSION_INSTALL_SOURCE_CONTEXT=t.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.TargetPlatformToString=C,t.toTargetPlatform=p,t.getTargetPlatform=l,t.isNotWebExtensionInWebTargetPlatform=a,t.isTargetPlatformCompatible=c,t.isIExtensionIdentifier=h,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension",t.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",t.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",t.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",t.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var L;(function(u){u.COMMAND="command",u.SETTINGS_SYNC="settingsSync"})(L||(t.ExtensionInstallSource=L={}));function C(u){switch(u){case y.TargetPlatform.WIN32_X64:return"Windows 64 bit";case y.TargetPlatform.WIN32_ARM64:return"Windows ARM";case y.TargetPlatform.LINUX_X64:return"Linux 64 bit";case y.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case y.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case y.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case y.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case y.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case y.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case y.TargetPlatform.DARWIN_X64:return"Mac";case y.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case y.TargetPlatform.WEB:return"Web";case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;case y.TargetPlatform.UNKNOWN:return y.TargetPlatform.UNKNOWN;case y.TargetPlatform.UNDEFINED:return y.TargetPlatform.UNDEFINED}}function p(u){switch(u){case y.TargetPlatform.WIN32_X64:return y.TargetPlatform.WIN32_X64;case y.TargetPlatform.WIN32_ARM64:return y.TargetPlatform.WIN32_ARM64;case y.TargetPlatform.LINUX_X64:return y.TargetPlatform.LINUX_X64;case y.TargetPlatform.LINUX_ARM64:return y.TargetPlatform.LINUX_ARM64;case y.TargetPlatform.LINUX_ARMHF:return y.TargetPlatform.LINUX_ARMHF;case y.TargetPlatform.LINUX_PPC64LE:return y.TargetPlatform.LINUX_PPC64LE;case y.TargetPlatform.LINUX_RISCV64:return y.TargetPlatform.LINUX_RISCV64;case y.TargetPlatform.ALPINE_X64:return y.TargetPlatform.ALPINE_X64;case y.TargetPlatform.ALPINE_ARM64:return y.TargetPlatform.ALPINE_ARM64;case y.TargetPlatform.DARWIN_X64:return y.TargetPlatform.DARWIN_X64;case y.TargetPlatform.DARWIN_ARM64:return y.TargetPlatform.DARWIN_ARM64;case y.TargetPlatform.WEB:return y.TargetPlatform.WEB;case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;default:return y.TargetPlatform.UNKNOWN}}function l(u,i){switch(u){case b.Platform.Windows:return i==="x64"?y.TargetPlatform.WIN32_X64:i==="arm64"?y.TargetPlatform.WIN32_ARM64:y.TargetPlatform.UNKNOWN;case b.Platform.Linux:return i==="x64"?y.TargetPlatform.LINUX_X64:i==="arm64"?y.TargetPlatform.LINUX_ARM64:i==="arm"?y.TargetPlatform.LINUX_ARMHF:i==="ppc64le"?y.TargetPlatform.LINUX_PPC64LE:i==="riscv64"?y.TargetPlatform.LINUX_RISCV64:y.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?y.TargetPlatform.ALPINE_X64:i==="arm64"?y.TargetPlatform.ALPINE_ARM64:y.TargetPlatform.UNKNOWN;case b.Platform.Mac:return i==="x64"?y.TargetPlatform.DARWIN_X64:i==="arm64"?y.TargetPlatform.DARWIN_ARM64:y.TargetPlatform.UNKNOWN;case b.Platform.Web:return y.TargetPlatform.WEB}}function a(u,i){return i===y.TargetPlatform.WEB&&!u.includes(y.TargetPlatform.WEB)}function c(u,i,o){return a(i,o)?!1:u===y.TargetPlatform.UNDEFINED||u===y.TargetPlatform.UNIVERSAL?!0:u===y.TargetPlatform.UNKNOWN?!1:u===o}function h(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var m;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(m||(t.SortBy=m={}));var S;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(S||(t.SortOrder=S={}));var T;(function(u){u.Install="install",u.Uninstall="uninstall"})(T||(t.StatisticType=T={}));var g;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(g||(t.InstallOperation=g={})),t.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var d;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed",u.DownloadFailedWriting="DownloadFailedWriting"})(d||(t.ExtensionGalleryErrorCode=d={}));class v extends Error{constructor(i,o){super(i),this.code=o,this.name=o}}t.ExtensionGalleryError=v;var P;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.DownloadFailedWriting="DownloadFailedWriting",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.ScanningExtension="ScanningExtension",u.ReadUninstalled="ReadUninstalled",u.UnsetUninstalled="UnsetUninstalled",u.Delete="Delete",u.Rename="Rename",u.IntializeDefaultProfile="IntializeDefaultProfile",u.AddToProfile="AddToProfile",u.InstalledExtensionNotFound="InstalledExtensionNotFound",u.PostInstall="PostInstall",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(P||(t.ExtensionManagementErrorCode=P={}));class E extends Error{constructor(i,o){super(i),this.code=o,this.name=o}}t.ExtensionManagementError=E,t.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),t.ExtensionsLocalizedLabel=(0,D.localize2)(0,"Extensions"),t.PreferencesLocalizedLabel=(0,D.localize2)(1,"Preferences")}),define(se[142],oe([0,1,2,26,10]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class R extends b.Disposable{constructor(C,p,l,a,c){super(),this.userDataProfilesService=C,this.fileService=p,this.uriIdentityService=l,this.logService=c,this._register(a.onDidInstallExtensions(h=>this.onDidInstallExtensions(h))),this._register(a.onDidUninstallExtension(h=>this.onDidUnInstallExtension(h)))}onDidInstallExtensions(C){for(const p of C)p.local&&this.invalidate(p.profileLocation)}onDidUnInstallExtension(C){C.error||this.invalidate(C.profileLocation)}async invalidate(C){if(C)for(const p of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(p.extensionsResource,C)&&await this.deleteUserCacheFile(p);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(C){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(C.cacheHome,D.USER_MANIFEST_CACHE_FILE))}catch(p){(0,y.toFileOperationResult)(p)!==y.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(p)}}}t.ExtensionsManifestCache=R}),define(se[69],oe([0,1,22,2,13,109,21,11]),function(H,t,b,D,y,R,L,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LanguagePackBaseService=t.ILanguagePackService=void 0,t.getLocale=p;function p(a){return a.tags.find(c=>c.startsWith("lp-"))?.split("lp-")[1]}t.ILanguagePackService=(0,C.createDecorator)("languagePackService");let l=class extends D.Disposable{constructor(c){super(),this.extensionGalleryService=c}async getAvailableLanguages(){const c=new b.CancellationTokenSource;setTimeout(()=>c.cancel(),1e3);let h;try{h=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},c.token)}catch{return[]}const S=h.firstPage.filter(T=>T.properties.localizedLanguages?.length&&T.tags.some(g=>g.startsWith("lp-"))).map(T=>{const g=T.properties.localizedLanguages?.[0],d=p(T);return{...this.createQuickPickItem(d,g,T),extensionId:T.identifier.id,galleryExtension:T}});return S.push(this.createQuickPickItem("en","English")),S}createQuickPickItem(c,h,m){const S=h??c;let T;if(S!==c&&(T=`(${c})`),c.toLowerCase()===y.language.toLowerCase()&&(T??="",T+=(0,R.localize)(0,null)),m?.installCount){T??="";const g=m.installCount;let d;g>1e6?d=`${Math.floor(g/1e5)/10}M`:g>1e3?d=`${Math.floor(g/1e3)}K`:d=String(g),T+=` $(cloud-download) ${d}`}return{id:c,label:S,description:T}}};t.LanguagePackBaseService=l,t.LanguagePackBaseService=l=Se([re(0,L.IExtensionGalleryService)],l)}),define(se[45],oe([0,1,14,9,2,111,40,11,6,38]),function(H,t,b,D,y,R,L,C,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractRequestService=t.IRequestService=void 0,t.isSuccess=h,t.hasNoContent=m,t.asText=S,t.asTextOrError=T,t.asJson=g,t.updateProxyConfigurationsScope=d,t.IRequestService=(0,C.createDecorator)("requestService");class a{constructor(u){this.original=u}toJSON(){if(!this.headers){const u=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?u[i]="*****":u[i]=this.original[i];this.headers=u}return this.headers}}class c extends y.Disposable{constructor(u){super(),this.counter=0,this.logger=u.createLogger("network",{name:(0,R.localize)(0,null),when:p.CONTEXT_LOG_LEVEL.isEqualTo((0,p.LogLevelToString)(p.LogLevel.Trace)).serialize()})}async logAndRequest(u,i,o){const r=`${u} #${++this.counter}: ${i.url}`;this.logger.trace(`${r} - begin`,i.type,new a(i.headers??{}));try{const e=await o();return this.logger.trace(`${r} - end`,i.type,e.res.statusCode,e.res.headers),e}catch(e){throw this.logger.error(`${r} - error`,i.type,(0,D.getErrorMessage)(e)),e}}}t.AbstractRequestService=c;function h(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}function m(E){return E.res.statusCode===204}async function S(E){return m(E)?null:(await(0,b.streamToBuffer)(E.stream)).toString()}async function T(E){if(!h(E))throw new Error("Server returned "+E.res.statusCode);return S(E)}async function g(E){if(!h(E))throw new Error("Server returned "+E.res.statusCode);if(m(E))return null;const i=(await(0,b.streamToBuffer)(E.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}function d(E){P(E)}let v;function P(E){const u=l.Registry.as(L.Extensions.Configuration),i=v;v={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[v],remove:i?[i]:[]})}P(L.ConfigurationScope.APPLICATION)}),define(se[143],oe([0,1,22,15,10,45]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let L=class{constructor(p,l){this.requestService=p,this.fileService=l}async download(p,l,a=b.CancellationToken.None){if(p.scheme===D.Schemas.file||p.scheme===D.Schemas.vscodeRemote){await this.fileService.copy(p,l);return}const c={type:"GET",url:p.toString(!0)},h=await this.requestService.request(c,a);if(h.res.statusCode===200)await this.fileService.writeFile(l,h.stream);else{const m=await(0,R.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${m}`)}}};t.DownloadService=L,t.DownloadService=L=Se([re(0,R.IRequestService),re(1,y.IFileService)],L)}),define(se[144],oe([0,1,145,3]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=R;function y(L,C){return L.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:L.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function R(L,C,p={}){const l=(0,b.parse)(L),a=p.proxyUrl||y(l,C);if(!a)return null;const c=(0,b.parse)(a);if(!/^https?:$/.test(c.protocol||""))return null;const h={host:c.hostname||"",port:(c.port?+c.port:0)||(c.protocol==="https"?443:80),auth:c.auth,rejectUnauthorized:(0,D.isBoolean)(p.strictSSL)?p.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((m,S)=>{H(["http-proxy-agent"],m,S)})).HttpProxyAgent(a,h):new(await new Promise((m,S)=>{H(["https-proxy-agent"],m,S)})).HttpsProxyAgent(a,h)}}),define(se[146],oe([0,1,60,16,112,22,36,9,13,29,91,177,8,79]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=T;let S;async function T(d,v,P,E){return P["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,c.isLaunchedFromCli)(E)&&!P["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,c.isLaunchedFromCli)(E)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=h.Promises.withAsyncBody(async(u,i)=>{const o=new R.CancellationTokenSource;let r=1e4;const e=d.getValue("application.shellEnvironmentResolutionTimeout");typeof e=="number"&&(r=(0,m.clamp)(e,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),i(new Error((0,y.localize)(0,null)))},r);try{u(await g(v,o.token))}catch(s){!(0,C.isCancellationError)(s)&&!o.token.isCancellationRequested?i(new Error((0,y.localize)(1,null,(0,L.toErrorMessage)(s)))):u({})}finally{clearTimeout(n),o.dispose()}})),S)}async function g(d,v){const P=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",P);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",E);const u=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(u+"({.*})"+u),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",o);const r=await(0,a.getSystemShell)(p.OS,o);return d.trace("getUnixShellEnvironment#shell",r),new Promise((e,n)=>{if(v.isCancellationRequested)return n(new C.CancellationError);const s=(0,D.basename)(r);let f,I;const O="";/^pwsh(-preview)?$/.test(s)?(f=`& '${process.execPath}' ${O} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,I=["-Login","-Command"]):s==="nu"?(f=`^'${process.execPath}' ${O} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,I=["-i","-l","-c"]):s==="xonsh"?(f=`import os, json; print("${u}", json.dumps(dict(os.environ)), "${u}")`,I=["-i","-l","-c"]):(f=`'${process.execPath}' ${O} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,s==="tcsh"||s==="csh"?I=["-ic"]:I=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),f);const N=(0,b.spawn)(r,[...I,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});v.onCancellationRequested(()=>(N.kill(),n(new C.CancellationError))),N.on("error",_=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(_)),n(_)});const k=[];N.stdout.on("data",_=>k.push(_));const F=[];N.stderr.on("data",_=>F.push(_)),N.on("close",(_,K)=>{const ae=Buffer.concat(k).toString("utf8");d.trace("getUnixShellEnvironment#raw",ae);const ie=Buffer.concat(F).toString("utf8");if(ie.trim()&&d.trace("getUnixShellEnvironment#stderr",ie),_||K)return n(new Error((0,y.localize)(2,null,_,K)));const ce=i.exec(ae),ue=ce?ce[1]:"{}";try{const le=JSON.parse(ue);P?le.ELECTRON_RUN_AS_NODE=P:delete le.ELECTRON_RUN_AS_NODE,E?le.ELECTRON_NO_ATTACH_CONSOLE=E:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",le),e(le)}catch(le){d.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(le)),n(le)}})})}}),define(se[147],oe([0,1,11]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=t.IStateReadService=void 0,t.IStateReadService=(0,b.createDecorator)("stateReadService"),t.IStateService=(0,b.createDecorator)("stateService")}),define(se[70],oe([0,1,8,14,2,3,18,10,6]),function(H,t,b,D,y,R,L,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.StateReadonlyService=t.FileStorage=t.SaveStrategy=void 0;var l;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(l||(t.SaveStrategy=l={}));class a extends y.Disposable{constructor(S,T,g,d){super(),this.storagePath=S,this.saveStrategy=T,this.logService=g,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new b.ThrottledDelayer(this.saveStrategy===l.IMMEDIATE?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(S){S.fileOperationResult!==C.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(S)}}getItem(S,T){const g=this.storage[S];return(0,R.isUndefinedOrNull)(g)?T:g}setItem(S,T){this.setItems([{key:S,data:T}])}setItems(S){let T=!1;for(const{key:g,data:d}of S)this.storage[g]!==d&&((0,R.isUndefinedOrNull)(d)?(0,R.isUndefined)(this.storage[g])||(this.storage[g]=void 0,T=!0):(this.storage[g]=d,T=!0));T&&this.save()}removeItem(S){(0,R.isUndefined)(this.storage[S])||(this.storage[S]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const S=JSON.stringify(this.storage,null,4);if(S!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,D.VSBuffer.fromString(S),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=S}catch(T){this.logService.error(T)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}t.FileStorage=a;let c=class extends y.Disposable{constructor(S,T,g,d){super(),this.fileStorage=this._register(new a(T.stateResource,S,g,d))}async init(){await this.fileStorage.init()}getItem(S,T){return this.fileStorage.getItem(S,T)}};t.StateReadonlyService=c,t.StateReadonlyService=c=Se([re(1,L.IEnvironmentService),re(2,p.ILogService),re(3,C.IFileService)],c);class h extends c{setItem(S,T){this.fileStorage.setItem(S,T)}setItems(S){this.fileStorage.setItems(S)}removeItem(S){this.fileStorage.removeItem(S)}close(){return this.fileStorage.close()}}t.StateService=h}),define(se[71],oe([0,1,13,37,29]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=L,t.verifyMicrosoftInternalDomain=C;function R(p){if(b.platform===b.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function L(p,l,a,c,h,m,S,T,g,d){const v=Object.create(null);v["common.machineId"]=m,v["common.sqmId"]=S,v["common.devDeviceId"]=T,v.sessionID=(0,y.generateUuid)()+Date.now(),v.commitHash=c,v.version=h,v["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,b.PlatformToString)(b.platform),v["common.nodePlatform"]=D.platform,v["common.nodeArch"]=a,v["common.product"]=d||"desktop",g&&(v["common.msftInternal"]=g);let P=0;const E=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-E,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),b.isLinuxSnap&&(v["common.snap"]="true");const u=R(l);return u&&(v["common.platformDetail"]=u),v}function C(p){const l=D.env.USERDNSDOMAIN;if(!l)return!1;const a=l.toLowerCase();return p.some(c=>a===c)}}),define(se[19],oe([0,1,11]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_CRASH_REPORTER_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.devDeviceIdKey=t.sqmIdKey=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,b.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,b.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.sqmIdKey="telemetry.sqmId",t.devDeviceIdKey="telemetry.devDeviceId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(D||(t.TelemetryLevel=D={}));var y;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(y||(t.TelemetryConfiguration=y={}))}),define(se[72],oe([0,1,9,11,6,19]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionSignatureVerificationService=t.ExtensionSignatureVerificationError=t.ExtensionSignatureVerificationCode=t.IExtensionSignatureVerificationService=void 0,t.IExtensionSignatureVerificationService=(0,D.createDecorator)("IExtensionSignatureVerificationService");var L;(function(l){l.None="None",l.RequiredArgumentMissing="RequiredArgumentMissing",l.InvalidArgument="InvalidArgument",l.PackageIsUnreadable="PackageIsUnreadable",l.UnhandledException="UnhandledException",l.SignatureManifestIsMissing="SignatureManifestIsMissing",l.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",l.SignatureIsMissing="SignatureIsMissing",l.SignatureIsUnreadable="SignatureIsUnreadable",l.CertificateIsUnreadable="CertificateIsUnreadable",l.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",l.FileAlreadyExists="FileAlreadyExists",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",l.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",l.Success="Success",l.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",l.SignatureIsInvalid="SignatureIsInvalid",l.SignatureManifestIsInvalid="SignatureManifestIsInvalid",l.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",l.EntryIsMissing="EntryIsMissing",l.EntryIsTampered="EntryIsTampered",l.Untrusted="Untrusted",l.CertificateRevoked="CertificateRevoked",l.SignatureIsNotValid="SignatureIsNotValid",l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(L||(t.ExtensionSignatureVerificationCode=L={}));class C extends Error{constructor(a){super(a),this.code=a}}t.ExtensionSignatureVerificationError=C;let p=class{constructor(a,c){this.logService=a,this.telemetryService=c}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((a,c)=>H(["@vscode/vsce-sign"],async h=>a(h),c))),this.moduleLoadingPromise}async verify(a,c,h,m){let S;const T=a.identifier.id;try{S=await this.vsceSign()}catch(P){return this.logService.error("Could not load vsce-sign module",(0,b.getErrorMessage)(P)),this.logService.info(`Extension signature verification is not done: ${T}`),!1}const g=new Date().getTime();let d;try{this.logService.trace(`Verifying extension signature for ${T}...`),d=await S.verify(c,h,this.logService.getLevel()===y.LogLevel.Trace)}catch(P){d={code:L.UnknownError,didExecute:!1,output:(0,b.getErrorMessage)(P)}}const v=new Date().getTime()-g;if(this.logService.info(`Extension signature verification result for ${T}: ${d.code}. Executed: ${d.didExecute}. Duration: ${v}ms.`),this.logService.trace(`Extension signature verification output for ${T}:
${d.output}`),this.telemetryService.publicLog2("extensionsignature:verification",{extensionId:T,extensionVersion:a.version,code:d.code,internalCode:d.internalCode,duration:v,didExecute:d.didExecute,clientTargetPlatform:m}),d.code===L.Success)return!0;throw new C(d.code)}};t.ExtensionSignatureVerificationService=p,t.ExtensionSignatureVerificationService=p=Se([re(0,y.ILogService),re(1,R.ITelemetryService)],p)}),define(se[41],oe([0,1,28,3,68,71,19]),function(H,t,b,D,y,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullAppender=t.extensionTelemetryLogChannelId=t.telemetryLogId=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=t.TelemetryTrustedValue=void 0,t.supportsTelemetry=a,t.isLoggingOnly=c,t.getTelemetryLevel=h,t.validateTelemetryData=m,t.cleanRemoteAuthority=T,t.isInternalTelemetry=d,t.getPiiPathsFromEnvironment=v,t.cleanData=u;class C{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}t.TelemetryTrustedValue=C;class p{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}t.NullTelemetryServiceShape=p,t.NullTelemetryService=new p;class l{async publicLog(o,r,e){}async publicLogError(o,r,e){}}t.NullEndpointTelemetryService=l,t.telemetryLogId="telemetry",t.extensionTelemetryLogChannelId="extensionTelemetryLog",t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function a(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}function c(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function h(i){const o=i.getValue(L.TELEMETRY_SETTING_ID),r=i.getValue(L.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return L.TelemetryLevel.NONE;switch(o??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function m(i){const o={},r={},e={};g(i,e);for(let n in e){n=n.length>150?n.substr(n.length-149):n;const s=e[n];typeof s=="number"?r[n]=s:typeof s=="boolean"?r[n]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${s.length}`),o[n]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(o[n]=s)}return{properties:o,measurements:r}}const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function T(i){if(!i)return"none";const o=(0,y.getRemoteName)(i);return S.has(o)?o:"other"}function g(i,o,r=0,e){if(i)for(const n of Object.getOwnPropertyNames(i)){const s=i[n],f=e?e+n:n;Array.isArray(s)?o[f]=(0,b.safeStringify)(s):s instanceof Date?o[f]=s.toISOString():(0,D.isObject)(s)?r<2?g(s,o,r+1,f+"."):o[f]=(0,b.safeStringify)(s):o[f]=s}}function d(i,o){const r=i.msftInternalDomains||[],e=o.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(r)||e}function v(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function P(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const e=[];for(const I of o)for(;;){const O=I.exec(i);if(!O)break;e.push([O.index,I.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const I=s.exec(i);if(!I)break;const O=e.some(([N,k])=>I.index<k&&N<s.lastIndex);!n.test(I[0])&&!O&&(r+=i.substring(f,I.index)+"<REDACTED: user-file-path>",f=s.lastIndex)}return f<i.length&&(r+=i.substr(f)),r}function E(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function u(i,o){return(0,b.cloneAndChange)(i,r=>{if(r instanceof C||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let e=r.replaceAll("%20"," ");e=P(e,o);for(const n of o)e=e.replace(n,"");return e=E(e),e}})}}),define(se[27],oe([0,1,32,21,26,13,12,9,37,41]),function(H,t,b,D,y,R,L,C,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BetterMergeId=t.ExtensionKey=void 0,t.areSameExtensions=a,t.getIdAndVersion=S,t.getExtensionId=T,t.adoptToGalleryExtensionId=g,t.getGalleryExtensionId=d,t.groupByExtension=v,t.getLocalExtensionTelemetryData=P,t.getGalleryExtensionTelemetryData=E,t.getExtensionDependencies=u,t.computeTargetPlatform=o;function a(r,e){return r.uuid&&e.uuid?r.uuid===e.uuid:r.id===e.id?!0:(0,b.compareIgnoreCase)(r.id,e.id)===0}const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(e){const n=e.manifest?e.manifest.version:e.version,s=e.manifest?e.targetPlatform:e.properties.targetPlatform;return new h(e.identifier,n,s)}static parse(e){const n=c.exec(e);return n&&n[1]&&n[2]?new h({id:n[1]},n[2],n[4]||void 0):null}constructor(e,n,s=y.TargetPlatform.UNDEFINED){this.identifier=e,this.version=n,this.targetPlatform=s,this.id=e.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==y.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(e){return e instanceof h?a(this,e)&&this.version===e.version&&this.targetPlatform===e.targetPlatform:!1}}t.ExtensionKey=h;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(r){const e=m.exec(r);return e&&e[1]?[g(e[1]),e[2]]:[g(r),void 0]}function T(r,e){return`${r}.${e}`}function g(r){return r.toLowerCase()}function d(r,e){return g(T(r??y.UNDEFINED_PUBLISHER,e))}function v(r,e){const n=[],s=f=>{for(const I of n)if(I.some(O=>a(e(O),e(f))))return I;return null};for(const f of r){const I=s(f);I?I.push(f):n.push([f])}return n}function P(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function E(r){return{id:new l.TelemetryTrustedValue(r.identifier.id),name:new l.TelemetryTrustedValue(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}t.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function u(r,e){const n=[],s=e.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const f=s.shift();if(f&&n.every(I=>!a(I.identifier,{id:f}))){const I=r.filter(O=>a(O.identifier,{id:f}));I.length===1&&(n.push(I[0]),s.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function i(r,e){if(!R.isLinux)return!1;let n;try{n=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){e.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(f))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,e){const n=await i(r,e),s=(0,D.getTargetPlatform)(n?"alpine":R.platform,p.arch);return e.debug("ComputeTargetPlatform:",s),s}}),define(se[148],oe([0,1,22,9,15,17,44,12,100,21,27,26]),function(H,t,b,D,y,R,L,C,p,l,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLI=void 0;const h=T=>(0,p.localize)(0,null,T),m=(0,p.localize)(1,null,"ms-dotnettools.csharp");let S=class{constructor(g,d,v){this.logger=g,this.extensionManagementService=d,this.extensionGalleryService=v}get location(){}async listExtensions(g,d,v){let P=await this.extensionManagementService.getInstalled(c.ExtensionType.User,v);const E=c.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(d&&d!==""){if(E.indexOf(d.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}P=P.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.logger.info("Possible Categories: "),E.forEach(i=>{this.logger.info(i)});return}this.location&&this.logger.info((0,p.localize)(2,null,this.location)),P=P.sort((i,o)=>i.identifier.id.localeCompare(o.identifier.id));let u;for(const i of P)u!==i.identifier.id&&(u=i.identifier.id,this.logger.info(g?`${u}@${i.manifest.version}`:u))}async installExtensions(g,d,v,P){const E=[];try{g.length&&this.logger.info(this.location?(0,p.localize)(3,null,this.location):(0,p.localize)(4,null));const u=[],i=[],o=(e,n,s)=>{i.push({id:e,version:n!=="prerelease"?n:void 0,installOptions:{...v,isBuiltin:s,installPreReleaseVersion:n==="prerelease"||v.installPreReleaseVersion}})};for(const e of g)if(e instanceof C.URI)u.push({vsix:e,installOptions:v});else{const[n,s]=(0,a.getIdAndVersion)(e);o(n,s,!1)}for(const e of d)if(e instanceof C.URI)u.push({vsix:e,installOptions:{...v,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[n,s]=(0,a.getIdAndVersion)(e);o(n,s,!0)}const r=await this.extensionManagementService.getInstalled(void 0,v.profileLocation);if(u.length&&await Promise.all(u.map(async({vsix:e,installOptions:n})=>{try{await this.installVSIX(e,n,P,r)}catch(s){this.logger.error(s),E.push(e.toString())}})),i.length){const e=await this.installGalleryExtensions(i,r,P);E.push(...e)}}catch(u){throw this.logger.error((0,p.localize)(5,null,(0,D.getErrorMessage)(u))),u}if(E.length)throw new Error((0,p.localize)(6,null,E.join(", ")))}async updateExtensions(g){const d=await this.extensionManagementService.getInstalled(c.ExtensionType.User,g),v=[];for(const i of d)i.identifier.uuid&&v.push({...i.identifier,preRelease:i.preRelease});this.logger.trace((0,p.localize)(7,null,v.length));const P=await this.extensionGalleryService.getExtensions(v,{compatible:!0},b.CancellationToken.None),E=[];for(const i of P)for(const o of d)(0,a.areSameExtensions)(o.identifier,i.identifier)&&(0,L.gt)(i.version,o.manifest.version)&&E.push({extension:i,options:{operation:l.InstallOperation.Update,installPreReleaseVersion:o.preRelease,profileLocation:g}});if(!E.length){this.logger.info((0,p.localize)(8,null));return}this.logger.info((0,p.localize)(9,null,E.map(i=>i.extension.identifier.id).join(", ")));const u=await this.extensionManagementService.installGalleryExtensions(E);for(const i of u)i.error?this.logger.error((0,p.localize)(10,null,i.identifier.id,(0,D.getErrorMessage)(i.error))):this.logger.info((0,p.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async installGalleryExtensions(g,d,v){if(g=g.filter(({id:i,version:o})=>{const r=d.find(e=>(0,a.areSameExtensions)(e.identifier,{id:i}));if(r){if(!v&&(!o||o==="prerelease"&&r.preRelease))return this.logger.info((0,p.localize)(12,null,i,r.manifest.version,i)),!1;if(o&&r.manifest.version===o)return this.logger.info((0,p.localize)(13,null,`${i}@${o}`)),!1}return!0}),!g.length)return[];const P=[],E=[],u=await this.getGalleryExtensions(g);if(await Promise.all(g.map(async({id:i,version:o,installOptions:r})=>{const e=u.get(i.toLowerCase());if(!e){this.logger.error(`${h(o?`${i}@${o}`:i)}
${m}`),P.push(i);return}try{const s=await this.extensionGalleryService.getManifest(e,b.CancellationToken.None);if(s&&!this.validateExtensionKind(s))return}catch(s){this.logger.error(s.message||s.stack||s),P.push(i);return}const n=d.find(s=>(0,a.areSameExtensions)(s.identifier,e.identifier));if(n){if(e.version===n.manifest.version){this.logger.info((0,p.localize)(14,null,o?`${i}@${o}`:i));return}this.logger.info((0,p.localize)(15,null,i,e.version))}r.isBuiltin?this.logger.info(o?(0,p.localize)(16,null,i,o):(0,p.localize)(17,null,i)):this.logger.info(o?(0,p.localize)(18,null,i,o):(0,p.localize)(19,null,i)),E.push({extension:e,options:{...r,installGivenVersion:!!o}})})),E.length){const i=await this.extensionManagementService.installGalleryExtensions(E);for(const o of i)o.error?(this.logger.error((0,p.localize)(20,null,o.identifier.id,(0,D.getErrorMessage)(o.error))),P.push(o.identifier.id)):this.logger.info((0,p.localize)(21,null,o.identifier.id,o.local?.manifest.version))}return P}async installVSIX(g,d,v,P){const E=await this.extensionManagementService.getManifest(g);if(!E)throw new Error("Invalid vsix");if(await this.validateVSIX(E,v,d.profileLocation,P))try{await this.extensionManagementService.install(g,d),this.logger.info((0,p.localize)(22,null,(0,R.basename)(g)))}catch(i){if((0,D.isCancellationError)(i))this.logger.info((0,p.localize)(23,null,(0,R.basename)(g)));else throw i}}async getGalleryExtensions(g){const d=new Map,v=g.some(u=>u.installOptions.installPreReleaseVersion),P=await this.extensionManagementService.getTargetPlatform(),E=[];for(const u of g)l.EXTENSION_IDENTIFIER_REGEX.test(u.id)&&E.push({...u,preRelease:v});if(E.length){const u=await this.extensionGalleryService.getExtensions(E,{targetPlatform:P},b.CancellationToken.None);for(const i of u)d.set(i.identifier.id.toLowerCase(),i)}return d}validateExtensionKind(g){return!0}async validateVSIX(g,d,v,P){if(!d){const E={id:(0,a.getGalleryExtensionId)(g.publisher,g.name)},u=P.find(i=>(0,a.areSameExtensions)(E,i.identifier)&&(0,L.gt)(i.manifest.version,g.version));if(u)return this.logger.info((0,p.localize)(24,null,u.identifier.id,u.manifest.version,g.version)),!1}return this.validateExtensionKind(g)}async uninstallExtensions(g,d,v){const P=async u=>{if(u instanceof C.URI){const i=await this.extensionManagementService.getManifest(u);return(0,a.getExtensionId)(i.publisher,i.name)}return u},E=[];for(const u of g){const i=await P(u),r=(await this.extensionManagementService.getInstalled(void 0,v)).filter(e=>(0,a.areSameExtensions)(e.identifier,{id:i}));if(!r.length)throw new Error(`${this.notInstalled(i)}
${m}`);if(r.some(e=>e.type===c.ExtensionType.System)){this.logger.info((0,p.localize)(25,null,i));return}if(!d&&r.some(e=>e.isBuiltin)){this.logger.info((0,p.localize)(26,null,i));return}this.logger.info((0,p.localize)(27,null,i));for(const e of r)await this.extensionManagementService.uninstall(e,{profileLocation:v}),E.push(e);this.location?this.logger.info((0,p.localize)(28,null,i,this.location)):this.logger.info((0,p.localize)(29,null,i))}}async locateExtension(g){const d=await this.extensionManagementService.getInstalled();g.forEach(v=>{d.forEach(P=>{if(P.identifier.id===v&&P.location.scheme===y.Schemas.file){this.logger.info(P.location.fsPath);return}})})}notInstalled(g){return this.location?(0,p.localize)(30,null,g,this.location):(0,p.localize)(31,null,g)}};t.ExtensionManagementCLI=S,t.ExtensionManagementCLI=S=Se([re(1,l.IExtensionManagementService),re(2,l.IExtensionGalleryService)],S)}),define(se[149],oe([0,1,5,2,31,27,26,10]),function(H,t,b,D,y,R,L,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;class p extends D.Disposable{constructor(a,c,h,m,S,T,g){super(),this.extensionManagementService=a,this.extensionsScannerService=c,this.userDataProfilesService=h,this.extensionsProfileScannerService=m,this.uriIdentityService=S,this.fileService=T,this.logService=g,this._onDidChangeExtensionsByAnotherSource=this._register(new b.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new D.DisposableMap),this.initialize().then(null,d=>g.error(d))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(a=>this.onDidChangeProfiles(a.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(a=>this.onAddExtensions(a))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(a=>this.onDidAddExtensions(a))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(a=>this.onRemoveExtensions(a))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(a=>this.onDidRemoveExtensions(a))),this._register(this.fileService.onDidFilesChange(a=>this.onDidFilesChange(a)))}async onDidChangeProfiles(a){try{a.length&&await Promise.all(a.map(c=>(this.extensionsProfileWatchDisposables.set(c.id,(0,D.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(c.extensionsResource)),this.fileService.watch(c.extensionsResource))),this.populateExtensionsFromProfile(c.extensionsResource))))}catch(c){throw this.logService.error(c),c}}async onAddExtensions(a){for(const c of a.extensions)this.addExtensionWithKey(this.getKey(c.identifier,c.version),a.profileLocation)}async onDidAddExtensions(a){for(const c of a.extensions){const h=this.getKey(c.identifier,c.version);a.error?this.removeExtensionWithKey(h,a.profileLocation):this.addExtensionWithKey(h,a.profileLocation)}}async onRemoveExtensions(a){for(const c of a.extensions)this.removeExtensionWithKey(this.getKey(c.identifier,c.version),a.profileLocation)}async onDidRemoveExtensions(a){const c=[],h=[];for(const m of a.extensions){const S=this.getKey(m.identifier,m.version);a.error?this.addExtensionWithKey(S,a.profileLocation):(this.removeExtensionWithKey(S,a.profileLocation),this.allExtensions.has(S)||(this.logService.debug("Extension is removed from all profiles",m.identifier.id,m.version),h.push(this.extensionManagementService.scanInstalledExtensionAtLocation(m.location).then(T=>{T?c.push(T):this.logService.info("Extension not found at the location",m.location.toString())},T=>this.logService.error(T)))))}try{await Promise.all(h),c.length&&await this.uninstallExtensionsNotInProfiles(c)}catch(m){this.logService.error(m)}}onDidFilesChange(a){for(const c of this.userDataProfilesService.profiles)a.contains(c.extensionsResource,C.FileChangeType.UPDATED,C.FileChangeType.ADDED)&&this.onDidExtensionsProfileChange(c.extensionsResource)}async onDidExtensionsProfileChange(a){const c=[],h=[],m=await this.extensionsProfileScannerService.scanProfileExtensions(a),S=new Set,T=new Set;for(const[g,d]of this.allExtensions)d.has(a)&&T.add(g);for(const g of m){const d=this.getKey(g.identifier,g.version);S.add(d),T.has(d)||(c.push(g.identifier),this.addExtensionWithKey(d,a))}for(const g of T)if(!S.has(g)){const d=this.fromKey(g);d&&(h.push(d.identifier),this.removeExtensionWithKey(g,a))}(c.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:c.length?{extensions:c,profileLocation:a}:void 0,removed:h.length?{extensions:h,profileLocation:a}:void 0})}async populateExtensionsFromProfile(a){const c=await this.extensionsProfileScannerService.scanProfileExtensions(a);for(const h of c)this.addExtensionWithKey(this.getKey(h.identifier,h.version),a)}async uninstallExtensionsNotInProfiles(a){a||(a=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(h=>!this.allExtensions.has(this.getKey(h.identifier,h.manifest.version)))),a.length&&await this.extensionManagementService.markAsUninstalled(...a)}addExtensionWithKey(a,c){let h=this.allExtensions.get(a);h||this.allExtensions.set(a,h=new y.ResourceSet(m=>this.uriIdentityService.extUri.getComparisonKey(m))),h.add(c)}removeExtensionWithKey(a,c){const h=this.allExtensions.get(a);h&&h.delete(c),h?.size||this.allExtensions.delete(a)}getKey(a,c){return`${L.ExtensionIdentifier.toKey(a.id)}@${c}`}fromKey(a){const[c,h]=(0,R.getIdAndVersion)(a);return h?{identifier:{id:c},version:h}:void 0}}t.ExtensionsWatcher=p}),define(se[150],oe([0,1,178,20,8,2,15,16,25,18,21,27,6,69,12]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeLanguagePackService=void 0;let T=class extends m.LanguagePackBaseService{constructor(P,E,u,i){super(u),this.extensionManagementService=P,this.logService=i,this.cache=this._register(new g(E,i)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(P,E){const i=(await this.cache.getLanguagePacks())[E];if(!i){this.logService.warn(`No language pack found for ${E}`);return}const o=i.translations[P];return o?S.URI.file(o):void 0}async getInstalledLanguages(){const P=await this.cache.getLanguagePacks(),E=Object.keys(P).map(u=>{const i=P[u];return{...this.createQuickPickItem(u,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return E.push(this.createQuickPickItem("en","English")),E.sort((u,i)=>u.label.localeCompare(i.label)),E}async postInstallExtension(P){P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",P.identifier.id),await this.update())}async postUninstallExtension(P){const E=await this.cache.getLanguagePacks();Object.keys(E).some(u=>E[u]&&E[u].extensions.some(i=>(0,c.areSameExtensions)(i.extensionIdentifier,P.identifier)))&&(this.logService.info("Removing language packs from the extension",P.identifier.id),await this.update())}async update(){const[P,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),u=await this.cache.update(E);return!(0,D.equals)(Object.keys(P),Object.keys(u))}};t.NativeLanguagePackService=T,t.NativeLanguagePackService=T=Se([re(0,a.IExtensionManagementService),re(1,l.INativeEnvironmentService),re(2,a.IExtensionGalleryService),re(3,h.ILogService)],T);let g=class extends R.Disposable{constructor(P,E){super(),this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(P.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new y.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(P){return this.withLanguagePacks(E=>{Object.keys(E).forEach(u=>delete E[u]),this.createLanguagePacksFromExtensions(E,...P)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(P,...E){for(const u of E)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(P,u);Object.keys(P).forEach(u=>this.updateHash(P[u]))}createLanguagePacksFromExtension(P,E){const u=E.identifier,i=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const o of i)if(E.location.scheme===L.Schemas.file&&d(o)){let r=P[o.languageId];r||(r={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},P[o.languageId]=r);const e=r.extensions.filter(n=>(0,c.areSameExtensions)(n.extensionIdentifier,u))[0];e?e.version=E.manifest.version:r.extensions.push({extensionIdentifier:u,version:E.manifest.version});for(const n of o.translations)r.translations[n.id]=(0,C.join)(E.location.fsPath,n.path)}}updateHash(P){if(P){const E=(0,b.createHash)("md5");for(const u of P.extensions)E.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);P.hash=E.digest("hex")}}withLanguagePacks(P=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return p.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(E=P(u),u)).then(u=>{for(const o of Object.keys(u))u[o]||delete u[o];this.languagePacks=u,this.initializedCache=!0;const i=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",i),p.Promises.writeFile(this.languagePacksFilePath,i)}).then(()=>E,u=>this.logService.error(u))})}};g=Se([re(0,l.INativeEnvironmentService),re(1,h.ILogService)],g);function d(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const P of v.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}}),define(se[151],oe([0,1,88,9,28,41]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractOneDataSystemAppender=void 0;const L="https://0.0.0.0/OneCollector/1.0",C="https://0.0.0.0/ping";async function p(a,c,h){const m=await(0,b.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),S=await(0,b.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),T=new m.AppInsightsCore,g=new S.PostChannel,d={instrumentationKey:a,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(h){d.extensionConfig={};const v={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};d.extensionConfig[g.identifier]=v}return T.initialize(d,[]),T.addTelemetryInitializer(v=>{v.ext=v.ext??{},v.ext.web=v.ext.web??{},v.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',c&&(v.ext.utc=v.ext.utc??{},v.ext.utc.flags=8462029)}),T}class l{constructor(c,h,m,S,T){this._isInternalTelemetry=c,this._eventPrefix=h,this._defaultData=m,this._xhrOverride=T,this.endPointUrl=L,this.endPointHealthUrl=C,this._defaultData||(this._defaultData={}),typeof S=="function"?this._aiCoreOrKey=S():this._aiCoreOrKey=S,this._asyncAiCore=null}_withAIClient(c){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){c(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=p(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(h=>{c(h)},h=>{(0,D.onUnexpectedError)(h),console.error(h)})}}log(c,h){if(!this._aiCoreOrKey)return;h=(0,y.mixin)(h,this._defaultData),h=(0,R.validateTelemetryData)(h);const m=this._eventPrefix+"/"+c;try{this._withAIClient(S=>{S.pluginVersionString=h?.properties.version??"Unknown",S.track({name:m,baseData:{name:m,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(c=>{this._withAIClient(h=>{h.unload(!0,()=>{this._aiCoreOrKey=void 0,c(void 0)})})}):Promise.resolve(void 0)}}t.AbstractOneDataSystemAppender=l}),define(se[152],oe([0,1,2,28,13,32,113,30,40,153,33,38,19,41]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let S=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,v,P){this._configurationService=v,this._productService=P,this._experimentProperties={},this._disposables=new b.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=d.piiPaths||[],this._telemetryLevel=h.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(E=>{(E.affectsConfiguration(h.TELEMETRY_SETTING_ID)||E.affectsConfiguration(h.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(h.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(d,v){this._experimentProperties[d]=v}_updateTelemetryLevel(){let d=(0,m.getTelemetryLevel)(this._configurationService);const v=this._productService.enabledTelemetryLevels;if(v){this._sendErrorTelemetry=this.sendErrorTelemetry?v.error:!1;const P=v.usage?h.TelemetryLevel.USAGE:v.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;d=Math.min(d,P)}this._telemetryLevel=d}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(d,v,P){this._telemetryLevel<v||(P=(0,D.mixin)(P,this._experimentProperties),P=(0,m.cleanData)(P,this._cleanupPatterns),P=(0,D.mixin)(P,this._commonProperties),this._appenders.forEach(E=>E.log(d,P)))}publicLog(d,v){this._log(d,h.TelemetryLevel.USAGE,v)}publicLog2(d,v){this.publicLog(d,v)}publicLogError(d,v){this._sendErrorTelemetry&&this._log(d,h.TelemetryLevel.ERROR,v)}publicLogError2(d,v){this.publicLogError(d,v)}};t.TelemetryService=S,t.TelemetryService=S=Se([re(1,C.IConfigurationService),re(2,a.IProductService)],S);function T(){const g=(0,L.localize)(0,null,l.default.nameLong),d=l.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=y.isWeb?"":(0,L.localize)(3,null),P=(0,L.localize)(4,null),E=(0,L.localize)(5,null),u=(0,L.localize)(6,null),i=(0,L.localize)(7,null),o=`
|       | ${P} | ${E} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(8,null);return`
${g} ${d} ${v}

&nbsp;

${i}
${o}

&nbsp;

${r}
`}c.Registry.as(p.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[h.TELEMETRY_SETTING_ID]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:T(),default:h.TelemetryConfiguration.OFF,restricted:!0,scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),c.Registry.as(p.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[h.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,L.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,L.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${h.TELEMETRY_SETTING_ID}#\``),scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(se[154],oe([0,1,14,22,179,151]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OneDataSystemAppender=void 0;async function L(a,c){const h=await c.request(a,D.CancellationToken.None),m=(await(0,b.streamToBuffer)(h.stream)).toString(),S=h.res.statusCode??200;return{headers:h.res.headers,statusCode:S,responseData:m}}async function C(a){const c={method:a.type,headers:a.headers};return new Promise((m,S)=>{const T=y.request(a.url??"",c,g=>{g.on("data",function(d){m({headers:g.headers,statusCode:g.statusCode??200,responseData:d.toString()})}),g.on("error",function(d){S(d)})});T.write(a.data,g=>{g&&S(g)}),T.end()})}async function p(a,c,h){const m=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),S={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:m};try{const T=a?await L(S,a):await C(S);h(T.statusCode,T.headers,T.responseData)}catch{h(0,{})}}class l extends R.AbstractOneDataSystemAppender{constructor(c,h,m,S,T){const g={sendPOST:(d,v)=>{p(c,d,v)}};super(h,m,S,T,g)}}t.OneDataSystemAppender=l}),define(se[155],oe([0,1,16,25]),function(H,t,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=y;async function y(R,L){const C=Object.create(null),p=(a,c)=>{const h=JSON.parse(a);C[c]=h};if(L){const a=[],c=await D.Promises.readdir(L);for(const m of c)try{(await D.Promises.stat((0,b.join)(L,m))).isDirectory()&&a.push(m)}catch{}const h=[];for(const m of a)(await D.Promises.readdir((0,b.join)(L,m))).filter(T=>T==="telemetry.json").length===1&&h.push(m);for(const m of h){const S=(await D.Promises.readFile((0,b.join)(L,m,"telemetry.json"))).toString();p(S,m)}}let l=(await D.Promises.readFile((0,b.join)(R,"telemetry-core.json"))).toString();return p(l,"vscode-core"),l=(await D.Promises.readFile((0,b.join)(R,"telemetry-extensions.json"))).toString(),p(l,"vscode-extensions"),JSON.stringify(C,null,4)}}),define(se[156],oe([0,1,13,89,19]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMachineId=R,t.resolveSqmId=L,t.resolvedevDeviceId=C;async function R(p,l){let a=p.getItem(y.machineIdKey);return(typeof a!="string"||b.isMacintosh&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.getMachineId)(l.error.bind(l))),a}async function L(p,l){let a=p.getItem(y.sqmIdKey);return typeof a!="string"&&(a=await(0,D.getSqmMachineId)(l.error.bind(l))),a}async function C(p,l){let a=p.getItem(y.devDeviceIdKey);return typeof a!="string"&&(a=await(0,D.getdevDeviceId)(l.error.bind(l))),a}}),define(se[23],oe([0,1,11]),function(H,t,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,b.createDecorator)("IUriIdentityService")}),define(se[157],oe([0,1,23,122,10,17,80,5,2]),function(H,t,b,D,y,R,L,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class l{static{this._clock=0}constructor(h){this.uri=h,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let a=class{constructor(h){this._fileService=h,this._dispooables=new p.DisposableStore,this._limit=2**16;const m=new Map,S=T=>{let g=m.get(T.scheme);return g===void 0&&(g=h.hasProvider(T)&&!this._fileService.hasCapability(T,y.FileSystemProviderCapabilities.PathCaseSensitive),m.set(T.scheme,g)),g};this._dispooables.add(C.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(T=>{m.delete(T.scheme)})),this.extUri=new R.ExtUri(S),this._canonicalUris=new L.SkipList((T,g)=>this.extUri.compare(T,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,R.normalizePath)(h));const m=this._canonicalUris.get(h);return m?m.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new l(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((S,T)=>S[1].time<T[1].time?1:S[1].time>T[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const m=this._limit*.5;for(let S=0;S<m;S++)this._canonicalUris.set(h[S][0],h[S][1].touch())}};t.UriIdentityService=a,t.UriIdentityService=a=Se([re(0,y.IFileService)],a),(0,D.registerSingleton)(b.IUriIdentityService,a,D.InstantiationType.Delayed)}),define(se[158],oe([0,1,5,2,10,48,31]),function(H,t,b,D,y,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileUserDataProvider=void 0;class C extends D.Disposable{constructor(l,a,c,h,m,S){super(),this.fileSystemScheme=l,this.fileSystemProvider=a,this.userDataScheme=c,this.userDataProfilesService=h,this.uriIdentityService=m,this.logService=S,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new b.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=R.TernarySearchTree.forUris(()=>!(this.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new L.ResourceSet(T=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(T))),this.updateAtomicReadWritesResources(),this._register(h.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(T=>this.handleFileChanges(T)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const l of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(l.settingsResource),this.atomicReadWriteResources.add(l.keybindingsResource),this.atomicReadWriteResources.add(l.tasksResource),this.atomicReadWriteResources.add(l.extensionsResource)}open(l,a){return this.fileSystemProvider.open(this.toFileSystemResource(l),a)}close(l){return this.fileSystemProvider.close(l)}read(l,a,c,h,m){return this.fileSystemProvider.read(l,a,c,h,m)}write(l,a,c,h,m){return this.fileSystemProvider.write(l,a,c,h,m)}watch(l,a){this.watchResources.set(l,l);const c=this.fileSystemProvider.watch(this.toFileSystemResource(l),a);return(0,D.toDisposable)(()=>{this.watchResources.delete(l),c.dispose()})}stat(l){return this.fileSystemProvider.stat(this.toFileSystemResource(l))}mkdir(l){return this.fileSystemProvider.mkdir(this.toFileSystemResource(l))}rename(l,a,c){return this.fileSystemProvider.rename(this.toFileSystemResource(l),this.toFileSystemResource(a),c)}readFile(l,a){return this.fileSystemProvider.readFile(this.toFileSystemResource(l),a)}readFileStream(l,a,c){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(l),a,c)}readdir(l){return this.fileSystemProvider.readdir(this.toFileSystemResource(l))}enforceAtomicReadFile(l){return this.atomicReadWriteResources.has(l)}writeFile(l,a,c){return this.fileSystemProvider.writeFile(this.toFileSystemResource(l),a,c)}enforceAtomicWriteFile(l){return this.atomicReadWriteResources.has(l)?{postfix:".vsctmp"}:!1}delete(l,a){return this.fileSystemProvider.delete(this.toFileSystemResource(l),a)}copy(l,a,c){if((0,y.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(l),this.toFileSystemResource(a),c);throw new Error("copy not supported")}cloneFile(l,a){if((0,y.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(l),this.toFileSystemResource(a));throw new Error("clone not supported")}handleFileChanges(l){const a=[];for(const c of l){if(c.resource.scheme!==this.fileSystemScheme)continue;const h=this.toUserDataResource(c.resource);this.watchResources.findSubstr(h)&&a.push({resource:h,type:c.type,cId:c.cId})}a.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(a))}toFileSystemResource(l){return l.with({scheme:this.fileSystemScheme})}toUserDataResource(l){return l.with({scheme:this.userDataScheme})}}t.FileUserDataProvider=C}),define(se[159],oe([0,1,115,16,48,17,12,11,15]),function(H,t,b,D,y,R,L,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.STANDALONE_EDITOR_WORKSPACE_ID=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_SUFFIX=t.WORKSPACE_EXTENSION=t.WorkspaceFolder=t.Workspace=t.WorkbenchState=t.UNKNOWN_EMPTY_WINDOW_WORKSPACE=t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=t.IWorkspaceContextService=void 0,t.isSingleFolderWorkspaceIdentifier=l,t.isEmptyWorkspaceIdentifier=a,t.toWorkspaceIdentifier=c,t.isWorkspaceIdentifier=h,t.reviveIdentifier=m,t.isWorkspace=T,t.isWorkspaceFolder=g,t.toWorkspaceFolder=P,t.isUntitledWorkspace=E,t.isTemporaryWorkspace=u,t.isStandaloneEditorWorkspace=i,t.isSavedWorkspace=o,t.hasWorkspaceFileExtension=r,t.IWorkspaceContextService=(0,C.createDecorator)("contextService");function l(e){const n=e;return typeof n?.id=="string"&&L.URI.isUri(n.uri)}function a(e){return typeof e?.id=="string"&&!l(e)&&!h(e)}t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},t.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function c(e,n){if(typeof e=="string"||typeof e>"u")return typeof e=="string"?{id:(0,D.basename)(e)}:n?t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:t.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=e;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}function h(e){const n=e;return typeof n?.id=="string"&&L.URI.isUri(n.configPath)}function m(e){const n=e;if(n?.uri)return{id:n.id,uri:L.URI.revive(n.uri)};const s=e;if(s?.configPath)return{id:s.id,configPath:L.URI.revive(s.configPath)};if(e?.id)return{id:e.id}}var S;(function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"})(S||(t.WorkbenchState=S={}));function T(e){const n=e;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function g(e){const n=e;return!!(n&&typeof n=="object"&&L.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class d{constructor(n,s,f,I,O){this._id=n,this._transient=f,this._configuration=I,this._ignorePathCasing=O,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.Workspace=d;class v{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.WorkspaceFolder=v;function P(e){return new v({uri:e,index:0,name:(0,R.basenameOrAuthority)(e)},{uri:e.toString()})}t.WORKSPACE_EXTENSION="code-workspace",t.WORKSPACE_SUFFIX=`.${t.WORKSPACE_EXTENSION}`,t.WORKSPACE_FILTER=[{name:(0,b.localize)(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json";function E(e,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(e,n.untitledWorkspacesHome)}function u(e){let n;return L.URI.isUri(e)?n=e:n=e.configuration,n?.scheme===p.Schemas.tmp}t.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(e){return e.id===t.STANDALONE_EDITOR_WORKSPACE_ID}function o(e,n){return!E(e,n)&&!u(e)}function r(e){return(typeof e=="string"?(0,D.extname)(e):(0,R.extname)(e))===t.WORKSPACE_SUFFIX}}),define(se[24],oe([0,1,43,5,2,17,12,114,18,10,11,6,159,31,23,8,29,32,3]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S,T,g,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryUserDataProfilesService=t.UserDataProfilesService=t.IUserDataProfilesService=t.ProfileResourceType=void 0,t.isUserDataProfile=E,t.reviveProfile=u,t.toUserDataProfile=i;var P;(function(e){e.Settings="settings",e.Keybindings="keybindings",e.Snippets="snippets",e.Tasks="tasks",e.Extensions="extensions",e.GlobalState="globalState"})(P||(t.ProfileResourceType=P={}));function E(e){const n=e;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&L.URI.isUri(n.location)&&L.URI.isUri(n.globalStorageHome)&&L.URI.isUri(n.settingsResource)&&L.URI.isUri(n.keybindingsResource)&&L.URI.isUri(n.tasksResource)&&L.URI.isUri(n.snippetsHome)&&L.URI.isUri(n.extensionsResource))}t.IUserDataProfilesService=(0,a.createDecorator)("IUserDataProfilesService");function u(e,n){return{id:e.id,isDefault:e.isDefault,name:e.name,shortName:e.shortName,icon:e.icon,location:L.URI.revive(e.location).with({scheme:n}),globalStorageHome:L.URI.revive(e.globalStorageHome).with({scheme:n}),settingsResource:L.URI.revive(e.settingsResource).with({scheme:n}),keybindingsResource:L.URI.revive(e.keybindingsResource).with({scheme:n}),tasksResource:L.URI.revive(e.tasksResource).with({scheme:n}),snippetsHome:L.URI.revive(e.snippetsHome).with({scheme:n}),extensionsResource:L.URI.revive(e.extensionsResource).with({scheme:n}),cacheHome:L.URI.revive(e.cacheHome).with({scheme:n}),useDefaultFlags:e.useDefaultFlags,isTransient:e.isTransient}}function i(e,n,s,f,I,O){return{id:e,name:n,location:s,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:O&&I?.useDefaultFlags?.globalState?O.globalStorageHome:(0,R.joinPath)(s,"globalStorage"),settingsResource:O&&I?.useDefaultFlags?.settings?O.settingsResource:(0,R.joinPath)(s,"settings.json"),keybindingsResource:O&&I?.useDefaultFlags?.keybindings?O.keybindingsResource:(0,R.joinPath)(s,"keybindings.json"),tasksResource:O&&I?.useDefaultFlags?.tasks?O.tasksResource:(0,R.joinPath)(s,"tasks.json"),snippetsHome:O&&I?.useDefaultFlags?.snippets?O.snippetsHome:(0,R.joinPath)(s,"snippets"),extensionsResource:O&&I?.useDefaultFlags?.extensions?O.extensionsResource:(0,R.joinPath)(s,"extensions.json"),cacheHome:(0,R.joinPath)(f,e),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}let o=class extends y.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,s,f,I){super(),this.environmentService=n,this.fileService=s,this.uriIdentityService=f,this.logService=I,this.enabled=!0,this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new D.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new D.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new D.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new m.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,R.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),s=[n];if(this.enabled)try{for(const O of this.getStoredProfiles()){if(!O.name||!(0,v.isString)(O.name)||!O.location){this.logService.warn("Skipping the invalid stored profile",O.location||O.name);continue}s.push(i((0,R.basename)(O.location),O.name,O.location,this.profilesCacheHome,{shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags},n))}}catch(O){this.logService.error(O)}const f=new m.ResourceMap,I=new Map;if(s.length)try{const O=this.getStoredProfileAssociations();if(O.workspaces)for(const[N,k]of Object.entries(O.workspaces)){const F=L.URI.parse(N),_=s.find(K=>K.id===k);_&&f.set(F,_)}if(O.emptyWindows)for(const[N,k]of Object.entries(O.emptyWindows)){const F=s.find(_=>_.id===k);F&&I.set(N,F)}}catch(O){this.logService.error(O)}this._profilesObject={profiles:s,workspaces:f,emptyWindows:I}}return this._profilesObject}createDefaultProfile(){const n=i("__default__profile__",(0,C.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const s="Temp",f=new RegExp(`${(0,d.escapeRegExpCharacters)(s)}\\s(\\d+)`);let I=0;for(const N of this.profiles){const k=f.exec(N.name),F=k?parseInt(k[1]):0;I=F>I?F:I}const O=`${s} ${I+1}`;return this.createProfile((0,b.hash)((0,g.generateUuid)()).toString(16),O,{transient:!0},n)}async createNamedProfile(n,s,f){return this.createProfile((0,b.hash)((0,g.generateUuid)()).toString(16),n,s,f)}async createProfile(n,s,f,I){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const O=await this.doCreateProfile(n,s,f);return I&&await this.setProfileForWorkspace(I,O),O}async doCreateProfile(n,s,f){if(!(0,v.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.profileCreationPromises.get(s);return I||(I=(async()=>{try{if(this.profiles.find(F=>F.name===s||F.id===n))throw new Error(`Profile with ${s} name already exists`);const N=i(n,s,(0,R.joinPath)(this.profilesHome,n),this.profilesCacheHome,f,this.defaultProfile);await this.fileService.createFolder(N.location);const k=[];return this._onWillCreateProfile.fire({profile:N,join(F){k.push(F)}}),await T.Promises.settled(k),this.updateProfiles([N],[],[]),N}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,I)),I}async updateProfile(n,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(I=>I.id===n.id);if(!f)throw new Error(`Profile '${n.name}' does not exist`);return f=i(f.id,s.name??f.name,f.location,this.profilesCacheHome,{shortName:s.shortName??f.shortName,icon:s.icon===null?void 0:s.icon??f.icon,transient:s.transient??f.isTransient,useDefaultFlags:s.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[f]),f}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(I=>I.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const f=[];this._onWillRemoveProfile.fire({profile:s,join(I){f.push(I)}});try{await Promise.allSettled(f)}catch(I){this.logService.error(I)}for(const I of[...this.profilesObject.emptyWindows.keys()])s.id===this.profilesObject.emptyWindows.get(I)?.id&&this.profilesObject.emptyWindows.delete(I);for(const I of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(I)?.id&&this.profilesObject.workspaces.delete(I);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{await this.fileService.del(s.cacheHome,{recursive:!0})}catch(I){(0,l.toFileOperationResult)(I)!==l.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(I)}}async setProfileForWorkspace(n,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(I=>I.id===s.id);if(!f)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(n,f)}unsetWorkspace(n,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(f=>!this.uriIdentityService.extUri.isEqual(f.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.getWorkspace(n);return L.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindows.get(s)??this.profilesObject.emptyWindows.get(s)}getWorkspace(n){return(0,h.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,h.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location)))}updateProfiles(n,s,f){const I=[...this.profiles,...n],O=[];this.transientProfilesObject.profiles=[];for(let N of I)N.isDefault||s.some(k=>N.id===k.id)||(N=f.find(k=>N.id===k.id)??N,N.isTransient?this.transientProfilesObject.profiles.push(N):O.push({location:N.location,name:N.name,shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags}));this.saveStoredProfiles(O),this._profilesObject=void 0,this.triggerProfilesChanges(n,s,f)}triggerProfilesChanges(n,s,f){this._onDidChangeProfiles.fire({added:n,removed:s,updated:f,all:this.profiles})}updateWorkspaceAssociation(n,s,f){f=s?.isTransient?!0:f,f||this.updateWorkspaceAssociation(n,void 0,!0);const I=this.getWorkspace(n),O=f?this.transientProfilesObject:this.profilesObject;L.URI.isUri(I)?(O.workspaces.delete(I),s&&O.workspaces.set(I,s)):(O.emptyWindows.delete(I),s&&O.emptyWindows.set(I,s)),f||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[f,I]of this.profilesObject.workspaces.entries())n[f.toString()]=I.id;const s={};for(const[f,I]of this.profilesObject.emptyWindows.entries())s[f.toString()]=I.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:s}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const s={},f=this.createDefaultProfile();if(n.workspaces)for(const[O,N]of Object.entries(n.workspaces)){const k=L.URI.parse(N);s[O]=this.uriIdentityService.extUri.isEqual(k,f.location)?f.id:this.uriIdentityService.extUri.basename(k)}const I={};if(n.emptyWindows)for(const[O,N]of Object.entries(n.emptyWindows)){const k=L.URI.parse(N);I[O]=this.uriIdentityService.extUri.isEqual(k,f.location)?f.id:this.uriIdentityService.extUri.basename(k)}return{workspaces:s,emptyWindows:I}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.UserDataProfilesService=o,t.UserDataProfilesService=o=Se([re(0,p.IEnvironmentService),re(1,l.IFileService),re(2,S.IUriIdentityService),re(3,c.ILogService)],o);class r extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}t.InMemoryUserDataProfilesService=r}),define(se[53],oe([0,1,20,8,22,9,5,2,13,3,12,98,21,27,26,6,33,19,23,24]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S,T,g,d,v,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.AbstractExtensionManagementService=void 0,t.toExtensionManagementError=u;let E=class extends C.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(e,n,s,f,I,O){super(),this.galleryService=e,this.telemetryService=n,this.uriIdentityService=s,this.logService=f,this.productService=I,this.userDataProfilesService=O,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this._onDidUpdateExtensionMetadata=this._register(new L.Emitter),this.participants=[],this._register((0,C.toDisposable)(()=>{this.installingExtensions.forEach(({task:N})=>N.cancel()),this.uninstallingExtensions.forEach(N=>N.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(e){const n=await this.getTargetPlatform();return e.allTargetPlatforms.some(s=>(0,h.isTargetPlatformCompatible)(s,e.allTargetPlatforms,n))}async installFromGallery(e,n={}){try{const f=(await this.installGalleryExtensions([{extension:e,options:n}])).find(({identifier:I})=>(0,m.areSameExtensions)(I,e.identifier));if(f?.local)return f?.local;throw f?.error?f.error:new h.ExtensionManagementError(`Unknown error while installing extension ${e.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(s){throw u(s)}}async installGalleryExtensions(e){if(!this.galleryService.isEnabled())throw new h.ExtensionManagementError(c.localize(0,null),h.ExtensionManagementErrorCode.NotAllowed);const n=[],s=[];return await Promise.allSettled(e.map(async({extension:f,options:I})=>{try{const O=await this.checkAndGetCompatibleVersion(f,!!I?.installGivenVersion,!!I?.installPreReleaseVersion,I.productVersion??{version:this.productService.version,date:this.productService.date});s.push({...O,options:I})}catch(O){n.push({identifier:f.identifier,operation:h.InstallOperation.Install,source:f,error:O})}})),s.length&&n.push(...await this.installExtensions(s)),n}async uninstall(e,n={}){return this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id),this.uninstallExtension(e,n)}async toggleAppliationScope(e,n){if((0,S.isApplicationScopedExtension)(e.manifest)||e.isBuiltin)return e;if(e.isApplicationScoped){let s=await this.updateMetadata(e,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)||(s=await this.copyExtension(e,this.userDataProfilesService.defaultProfile.extensionsResource,n));for(const f of this.userDataProfilesService.profiles){const I=(await this.getInstalled(S.ExtensionType.User,f.extensionsResource)).find(O=>(0,m.areSameExtensions)(O.identifier,e.identifier));I?this._onDidUpdateExtensionMetadata.fire(I):this._onDidUninstallExtension.fire({identifier:e.identifier,profileLocation:f.extensionsResource})}return s}else{const s=this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(e,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(e,n,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:s.identifier,operation:h.InstallOperation.Install,local:s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),s}}getExtensionsControlManifest(){const e=new Date().getTime();return(!this.extensionsControlManifest||e-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=e),this.extensionsControlManifest}registerParticipant(e){this.participants.push(e)}async installExtensions(e){const n=new Map,s=new Map,f=[],I=(N,k)=>`${m.ExtensionKey.create(N).toString()}-${k.toString()}`,O=(N,k,F,_)=>{const K=this.createInstallExtensionTask(N,k,F),ae=`${(0,m.getGalleryExtensionId)(N.publisher,N.name)}-${F.profileLocation.toString()}`;s.set(ae,{task:K,root:_}),this._onInstallExtension.fire({identifier:K.identifier,source:k,profileLocation:F.profileLocation}),this.logService.info("Installing extension:",K.identifier.id,F.profileLocation.toString()),a.URI.isUri(k)||this.installingExtensions.set(I(k,F.profileLocation),{task:K,waitingTasks:[]})};try{for(const{manifest:N,extension:k,options:F}of e){const _=F.isApplicationScoped||F.isBuiltin||(0,S.isApplicationScopedExtension)(N),K={...F,installOnlyNewlyAddedFromExtensionPack:F.installOnlyNewlyAddedFromExtensionPack??!a.URI.isUri(k),isApplicationScoped:_,profileLocation:_?this.userDataProfilesService.defaultProfile.extensionsResource:F.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:F.productVersion??{version:this.productService.version,date:this.productService.date}},ae=a.URI.isUri(k)?void 0:this.installingExtensions.get(I(k,K.profileLocation));ae?(this.logService.info("Extension is already requested to install",ae.task.identifier.id,K.profileLocation.toString()),f.push(ae.task.waitUntilTaskIsFinished())):O(N,k,K,void 0)}return await Promise.all([...s.values()].map(async({task:N})=>{if(N.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const k=await this.getAllDepsAndPackExtensions(N.identifier,N.manifest,!!N.options.installOnlyNewlyAddedFromExtensionPack,!!N.options.installPreReleaseVersion,N.options.profileLocation,N.options.productVersion),F=await this.getInstalled(void 0,N.options.profileLocation,N.options.productVersion),_={...N.options,context:{...N.options.context,[h.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:K,manifest:ae}of(0,b.distinct)(k,({gallery:ie})=>ie.identifier.id)){if(s.has(`${K.identifier.id.toLowerCase()}-${_.profileLocation.toString()}`))continue;const ie=this.installingExtensions.get(I(K,_.profileLocation));if(ie){if(this.canWaitForTask(N,ie.task)){const ce=ie.task.identifier;this.logService.info("Waiting for already requested installing extension",ce.id,N.identifier.id,_.profileLocation.toString()),ie.waitingTasks.push(N),f.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,ue=>ue.some(le=>(0,m.areSameExtensions)(le.identifier,ce)))).then(ue=>{if(this.logService.info("Finished waiting for already requested installing extension",ce.id,N.identifier.id,_.profileLocation.toString()),!ue.find(B=>(0,m.areSameExtensions)(B.identifier,ce))?.local)throw new Error(`Extension ${ce.id} is not installed`)}))}}else F.some(({identifier:ce})=>(0,m.areSameExtensions)(ce,K.identifier))||O(ae,K,_,N)}}catch(k){if(a.URI.isUri(N.source))(0,b.isNonEmptyArray)(N.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",N.identifier.id,k.message),(0,b.isNonEmptyArray)(N.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",N.identifier.id,k.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),k}})),await this.joinAllSettled([...s.entries()].map(async([N,{task:k}])=>{const F=new Date().getTime();let _;try{_=await k.run(),await this.joinAllSettled(this.participants.map(K=>K.postInstall(_,k.source,k.options,y.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(K){const ae=u(K);throw a.URI.isUri(k.source)||i(this.telemetryService,k.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(k.source),error:ae,source:k.options.context?.[h.EXTENSION_INSTALL_SOURCE_CONTEXT]}),n.set(N,{error:ae,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.options.profileLocation,applicationScoped:k.options.isApplicationScoped}),this.logService.error("Error while installing the extension",k.identifier.id,(0,R.getErrorMessage)(ae),k.options.profileLocation.toString()),ae}if(!a.URI.isUri(k.source)){const K=k.operation===h.InstallOperation.Update,ae=K?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(i(this.telemetryService,K?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(k.source),verificationStatus:k.verificationStatus,duration:new Date().getTime()-F,durationSinceUpdate:ae,source:k.options.context?.[h.EXTENSION_INSTALL_SOURCE_CONTEXT]}),p.isWeb&&k.operation!==h.InstallOperation.Update)try{await this.galleryService.reportStatistic(_.manifest.publisher,_.manifest.name,_.manifest.version,h.StatisticType.Install)}catch{}}n.set(N,{local:_,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.options.profileLocation,applicationScoped:_.isApplicationScoped})})),f.length&&await this.joinAllSettled(f),[...n.values()]}catch(N){const k=(K,ae,ie)=>{const ce=[];K.manifest.extensionDependencies?.length&&ce.push(...K.manifest.extensionDependencies),K.manifest.extensionPack?.length&&ce.push(...K.manifest.extensionPack);for(const ue of ce){if(ie.includes(ue.toLowerCase()))continue;ie.push(ue.toLowerCase());const le=n.get(`${ue.toLowerCase()}-${ae.toString()}`);le?.local&&(ie=k(le.local,ae,ie))}return ie},F=K=>({identifier:K.identifier,operation:h.InstallOperation.Install,source:K.source,context:K.options.context,profileLocation:K.options.profileLocation,error:N}),_=[];for(const[K,{task:ae,root:ie}]of s){const ce=n.get(K);ce?ce.local&&ie&&!n.get(`${ie.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(_.push(this.createUninstallExtensionTask(ce.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),n.set(K,F(ae))):(ae.cancel(),n.set(K,F(ae)))}for(const[K,{task:ae}]of s){const ie=n.get(K);if(!ie?.local||ae.options.donotIncludePackAndDependencies)continue;k(ie.local,ae.options.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(ue=>s.has(`${ue.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!n.get(`${ue.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(_.push(this.createUninstallExtensionTask(ie.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),n.set(K,F(ae)))}throw _.length&&await Promise.allSettled(_.map(async K=>{try{await K.run(),this.logService.info("Rollback: Uninstalled extension",K.extension.identifier.id)}catch(ae){this.logService.warn("Rollback: Error while uninstalling extension",K.extension.identifier.id,(0,R.getErrorMessage)(ae))}})),N}finally{for(const{task:N}of s.values())N.source&&!a.URI.isUri(N.source)&&this.installingExtensions.delete(I(N.source,N.options.profileLocation));if(n.size){const N=[...n.values()];for(const k of N)k.local&&this.logService.info("Extension installed successfully:",k.identifier.id,k.profileLocation.toString());this._onDidInstallExtensions.fire(N)}}}canWaitForTask(e,n){for(const[,{task:s,waitingTasks:f}]of this.installingExtensions.entries())if(s===e&&(f.includes(n)||f.some(I=>this.canWaitForTask(I,n)))||s===n&&f[0]&&!this.canWaitForTask(e,f[0]))return!1;return!0}async joinAllSettled(e,n){const s=[],f=[],I=await Promise.allSettled(e);for(const N of I)N.status==="fulfilled"?s.push(N.value):f.push(u(N.reason,n));if(!f.length)return s;if(f.length===1)throw f[0];let O=new h.ExtensionManagementError("",h.ExtensionManagementErrorCode.Unknown);for(const N of f)O=new h.ExtensionManagementError(O.message?`${O.message}, ${N.message}`:N.message,N.code!==h.ExtensionManagementErrorCode.Unknown&&N.code!==h.ExtensionManagementErrorCode.Internal?N.code:O.code);throw O}async getAllDepsAndPackExtensions(e,n,s,f,I,O){if(!this.galleryService.isEnabled())return[];const N=await this.getInstalled(void 0,I,O),k=[],F=[],_=async(K,ae)=>{k.push(K);const ie=ae.extensionDependencies||[],ce=[...ie];if(ae.extensionPack){const ue=s?N.find(le=>(0,m.areSameExtensions)(le.identifier,K)):void 0;for(const le of ae.extensionPack)ue&&ue.manifest.extensionPack&&ue.manifest.extensionPack.some(B=>(0,m.areSameExtensions)({id:B},{id:le}))||ce.every(B=>!(0,m.areSameExtensions)({id:B},{id:le}))&&ce.push(le)}if(ce.length){const ue=ce.filter(le=>k.every(B=>!(0,m.areSameExtensions)(B,{id:le})));if(ue.length){const le=await this.galleryService.getExtensions(ue.map(B=>({id:B,preRelease:f})),y.CancellationToken.None);for(const B of le){if(k.find(M=>(0,m.areSameExtensions)(M,B.identifier)))continue;const Z=ie.some(M=>(0,m.areSameExtensions)({id:M},B.identifier));let z;try{z=await this.checkAndGetCompatibleVersion(B,!1,f,O)}catch(M){if(Z)throw M;this.logService.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,R.getErrorMessage)(M));continue}F.push({gallery:z.extension,manifest:z.manifest}),await _(z.extension.identifier,z.manifest)}}}};return await _(e,n),F}async checkAndGetCompatibleVersion(e,n,s,f){let I;const O=await this.getExtensionsControlManifest();if(O.malicious.some(F=>(0,m.areSameExtensions)(e.identifier,F)))throw new h.ExtensionManagementError(c.localize(1,null,e.identifier.id),h.ExtensionManagementErrorCode.Malicious);const N=O.deprecated[e.identifier.id.toLowerCase()];if(N?.extension?.autoMigrate){if(this.logService.info(`The '${e.identifier.id}' extension is deprecated, fetching the compatible '${N.extension.id}' extension instead.`),I=(await this.galleryService.getExtensions([{id:N.extension.id,preRelease:N.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:f},y.CancellationToken.None))[0],!I)throw new h.ExtensionManagementError(c.localize(2,null,e.identifier.id,N.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(e)){const F=await this.getTargetPlatform();throw new h.ExtensionManagementError(c.localize(3,null,e.identifier.id,this.productService.nameLong,(0,h.TargetPlatformToString)(F)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.getCompatibleVersion(e,n,s,f),!I)throw!s&&e.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([e.identifier],y.CancellationToken.None))[0]?new h.ExtensionManagementError(c.localize(4,null,e.displayName??e.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.ExtensionManagementError(c.localize(5,null,e.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",I.identifier.id);const k=await this.galleryService.getManifest(I,y.CancellationToken.None);if(k===null)throw new h.ExtensionManagementError(`Missing manifest for extension ${I.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(k.version!==I.version)throw new h.ExtensionManagementError(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:k}}async getCompatibleVersion(e,n,s,f){const I=await this.getTargetPlatform();let O=null;return!n&&e.hasPreReleaseVersion&&e.properties.isPreReleaseVersion!==s&&(O=(await this.galleryService.getExtensions([{...e.identifier,preRelease:s}],{targetPlatform:I,compatible:!0,productVersion:f},y.CancellationToken.None))[0]||null),!O&&await this.galleryService.isExtensionCompatible(e,s,I,f)&&(O=e),O||(n?O=(await this.galleryService.getExtensions([{...e.identifier,version:e.version}],{targetPlatform:I,compatible:!0,productVersion:f},y.CancellationToken.None))[0]||null:O=await this.galleryService.getCompatibleExtension(e,s,I,f)),O}async uninstallExtension(e,n){const s={...n,profileLocation:e.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:n.profileLocation??this.getCurrentExtensionsManifestLocation()},f=_=>`${_.id.toLowerCase()}${s.versionOnly?`-${e.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,I=this.uninstallingExtensions.get(f(e.identifier));if(I)return this.logService.info("Extensions is already requested to uninstall",e.identifier.id),I.waitUntilTaskIsFinished();const O=_=>{const K=this.createUninstallExtensionTask(_,s);return this.uninstallingExtensions.set(f(K.extension.identifier),K),s.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,s.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:s.profileLocation,applicationScoped:_.isApplicationScoped}),K},N=(_,K)=>{K?s.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,s.profileLocation.toString(),K.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,K.message):s.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,s.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),i(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(_),error:K}),this._onDidUninstallExtension.fire({identifier:_.identifier,error:K?.code,profileLocation:s.profileLocation,applicationScoped:_.isApplicationScoped})},k=[],F=[];try{k.push(O(e));const _=await this.getInstalled(S.ExtensionType.User,s.profileLocation);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${e.identifier.id}@${e.manifest.version}`);else{const K=this.getAllPackExtensionsToUninstall(e,_);for(const ae of K)this.uninstallingExtensions.has(f(ae.identifier))?this.logService.info("Extensions is already requested to uninstall",ae.identifier.id):k.push(O(ae))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${e.identifier.id}@${e.manifest.version}`):this.checkForDependents(k.map(K=>K.extension),_,e),await this.joinAllSettled(k.map(async K=>{try{if(await K.run(),await this.joinAllSettled(this.participants.map(ae=>ae.postUninstall(K.extension,s,y.CancellationToken.None))),K.extension.identifier.uuid)try{await this.galleryService.reportStatistic(K.extension.manifest.publisher,K.extension.manifest.name,K.extension.manifest.version,h.StatisticType.Uninstall)}catch{}N(K.extension)}catch(ae){const ie=u(ae);throw N(K.extension,ie),ie}finally{F.push(K)}}))}catch(_){const K=u(_);for(const ae of k){try{ae.cancel()}catch{}F.includes(ae)||N(ae.extension,K)}throw K}finally{for(const _ of k)this.uninstallingExtensions.delete(f(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(e,n,s){for(const f of e){const I=this.getDependents(f,n);if(I.length){const O=I.filter(N=>!e.some(k=>(0,m.areSameExtensions)(k.identifier,N.identifier)));if(O.length)throw new Error(this.getDependentsErrorMessage(f,O,s))}}}getDependentsErrorMessage(e,n,s){return s===e?n.length===1?c.localize(6,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?c.localize(7,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):c.localize(8,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?c.localize(9,null,s.manifest.displayName||s.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?c.localize(10,null,s.manifest.displayName||s.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):c.localize(11,null,s.manifest.displayName||s.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(e,n,s=[]){if(s.indexOf(e)!==-1)return[];s.push(e);const f=e.manifest.extensionPack?e.manifest.extensionPack:[];if(f.length){const I=n.filter(N=>!N.isBuiltin&&f.some(k=>(0,m.areSameExtensions)({id:k},N.identifier))),O=[];for(const N of I)O.push(...this.getAllPackExtensionsToUninstall(N,n,s));return[...I,...O]}return[]}getDependents(e,n){return n.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(f=>(0,m.areSameExtensions)({id:f},e.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(e){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,R.getErrorMessage)(e)),{malicious:[],deprecated:{},search:[]}}}};t.AbstractExtensionManagementService=E,t.AbstractExtensionManagementService=E=Se([re(0,h.IExtensionGalleryService),re(1,d.ITelemetryService),re(2,v.IUriIdentityService),re(3,T.ILogService),re(4,g.IProductService),re(5,P.IUserDataProfilesService)],E);function u(r,e){if(r instanceof h.ExtensionManagementError)return r;let n;return r instanceof h.ExtensionGalleryError?n=new h.ExtensionManagementError(r.message,r.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):n=new h.ExtensionManagementError(r.message,(0,R.isCancellationError)(r)?h.ExtensionManagementErrorCode.Cancelled:e??h.ExtensionManagementErrorCode.Internal),n.stack=r.stack,n}function i(r,e,{extensionData:n,verificationStatus:s,duration:f,error:I,source:O,durationSinceUpdate:N}){let k,F;(0,l.isDefined)(s)&&(s===!0?s="Verified":(s===!1||(k=h.ExtensionManagementErrorCode.Signature,F=s),s="Unverified")),I&&(k=I.code,I.code===h.ExtensionManagementErrorCode.Signature&&(F=I.message)),r.publicLog(e,{...n,verificationStatus:s,success:!I,duration:f,errorcode:k,errorcodeDetail:F,durationSinceUpdate:N,source:O})}class o{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(e=>this.doRun(e))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(e=>new Promise((n,s)=>{const f=e.onCancellationRequested(()=>{f.dispose(),s(new R.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=o}),define(se[42],oe([0,1,8,14,2,5,31,12,21,27,10,11,6,24,23,3,9,19]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S,T,g,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionsProfileScannerService=t.IExtensionsProfileScannerService=t.ExtensionsProfileScanningError=t.ExtensionsProfileScanningErrorCode=void 0;var v;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(v||(t.ExtensionsProfileScanningErrorCode=v={}));class P extends Error{constructor(r,e){super(r),this.code=e}}t.ExtensionsProfileScanningError=P,t.IExtensionsProfileScannerService=(0,c.createDecorator)("IExtensionsProfileScannerService");let E=class extends y.Disposable{constructor(r,e,n,s,f,I){super(),this.extensionsLocation=r,this.fileService=e,this.userDataProfilesService=n,this.uriIdentityService=s,this.telemetryService=f,this.logService=I,this._onAddExtensions=this._register(new R.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new R.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new R.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new R.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(r,e){return this.withProfileExtensions(r,void 0,e)}async addExtensionsToProfile(r,e,n){const s=[],f=[];try{return await this.withProfileExtensions(e,I=>{const O=[];if(n)O.push(...I);else for(const N of I)r.some(([k])=>(0,l.areSameExtensions)(k.identifier,N.identifier)&&k.manifest.version!==N.version)?s.push(N):O.push(N);for(const[N,k]of r){const F=O.findIndex(K=>(0,l.areSameExtensions)(K.identifier,N.identifier)&&K.version===N.manifest.version),_={identifier:N.identifier,version:N.manifest.version,location:N.location,metadata:k};F===-1?(f.push(_),O.push(_)):O.splice(F,1,_)}return f.length&&this._onAddExtensions.fire({extensions:f,profileLocation:e}),s.length&&this._onRemoveExtensions.fire({extensions:s,profileLocation:e}),O}),f.length&&this._onDidAddExtensions.fire({extensions:f,profileLocation:e}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,profileLocation:e}),f}catch(I){throw f.length&&this._onDidAddExtensions.fire({extensions:f,error:I,profileLocation:e}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,error:I,profileLocation:e}),I}}async updateMetadata(r,e){const n=[];return await this.withProfileExtensions(e,s=>{const f=[];for(const I of s){const O=r.find(([N])=>(0,l.areSameExtensions)(N.identifier,I.identifier)&&N.manifest.version===I.version);O&&(I.metadata={...I.metadata,...O[1]},n.push(I)),f.push(I)}return f}),n}async removeExtensionFromProfile(r,e){const n=[];try{await this.withProfileExtensions(e,s=>{const f=[];for(const I of s)(0,l.areSameExtensions)(I.identifier,r.identifier)?n.push(I):f.push(I);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:e}),f}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:e})}catch(s){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:s,profileLocation:e}),s}}async withProfileExtensions(r,e,n){return this.getResourceAccessQueue(r).queue(async()=>{let s=[],f;try{const I=await this.fileService.readFile(r);f=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,a.toFileOperationResult)(I)!==a.FileOperationResult.FILE_NOT_FOUND)throw I;if(this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)&&(f=await this.migrateFromOldDefaultProfileExtensionsLocation()),!f&&n?.bailOutWhenFileNotFound)throw new P((0,g.getErrorMessage)(I),v.ERROR_PROFILE_NOT_FOUND)}if(f){Array.isArray(f)||this.reportAndThrowInvalidConentError(r);let I=!1;for(const O of f){u(O)||this.reportAndThrowInvalidConentError(r);let N;if((0,T.isString)(O.relativeLocation)&&O.relativeLocation)N=this.resolveExtensionLocation(O.relativeLocation);else if((0,T.isString)(O.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${O.location}`);continue}else{N=C.URI.revive(O.location);const k=this.toRelativePath(N);k&&(I=!0,O.relativeLocation=k)}(0,T.isUndefined)(O.metadata?.hasPreReleaseVersion)&&O.metadata?.preRelease&&(I=!0,O.metadata.hasPreReleaseVersion=!0),s.push({identifier:O.identifier,location:N,version:O.version,metadata:O.metadata})}I&&await this.fileService.writeFile(r,D.VSBuffer.fromString(JSON.stringify(f)))}if(e){s=e(s);const I=s.map(O=>({identifier:O.identifier,version:O.version,location:O.location.toJSON(),relativeLocation:this.toRelativePath(O.location),metadata:O.metadata}));await this.fileService.writeFile(r,D.VSBuffer.fromString(JSON.stringify(I)))}return s})}reportAndThrowInvalidConentError(r){const e=new P(`Invalid extensions content in ${r.toString()}`,v.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:e.code}),e}toRelativePath(r){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(r),this.extensionsLocation)?this.uriIdentityService.extUri.basename(r):void 0}resolveExtensionLocation(r){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,r)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const r=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),e=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(r)).value.toString()}catch(f){if((0,a.toFileOperationResult)(f)===a.FileOperationResult.FILE_NOT_FOUND)return;throw f}this.logService.info("Migrating extensions from old default profile location",r.toString());let s;try{const f=JSON.parse(n);Array.isArray(f)&&f.every(I=>u(I))?s=f:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.logService.error(f)}if(s)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",r.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(f){if((0,a.toFileOperationResult)(f)===a.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",r.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw f}try{await this.fileService.del(r)}catch(f){(0,a.toFileOperationResult)(f)!==a.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(f)}try{await this.fileService.del(e)}catch(f){(0,a.toFileOperationResult)(f)!==a.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(f)}return s})()),this._migrationPromise}getResourceAccessQueue(r){let e=this.resourcesAccessQueueMap.get(r);return e||(e=new b.Queue,this.resourcesAccessQueueMap.set(r,e)),e}};t.AbstractExtensionsProfileScannerService=E,t.AbstractExtensionsProfileScannerService=E=Se([re(1,a.IFileService),re(2,m.IUserDataProfilesService),re(3,S.IUriIdentityService),re(4,d.ITelemetryService),re(5,h.ILogService)],E);function u(o){return(0,T.isObject)(o)&&(0,p.isIExtensionIdentifier)(o.identifier)&&(i(o.location)||(0,T.isString)(o.location)&&o.location)&&((0,T.isUndefined)(o.relativeLocation)||(0,T.isString)(o.relativeLocation))&&o.version&&(0,T.isString)(o.version)}function i(o){return o?(0,T.isString)(o.path)&&(0,T.isString)(o.scheme):!1}}),define(se[54],oe([0,1,20,8,28,14,9,34,86,2,15,16,13,17,44,56,3,12,102,18,27,26,50,10,11,6,33,5,47,42,24,23,121]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S,T,g,d,v,P,E,u,i,o,r,e,n,s,f,I,O,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeExtensionsScannerService=t.ExtensionScannerInput=t.AbstractExtensionsScannerService=t.IExtensionsScannerService=t.Translations=void 0,t.toExtensionDescription=ce;var F;(function(le){function B(Z,z){if(Z===z)return!0;const M=Object.keys(Z),G=new Set;for(const J of Object.keys(z))G.add(J);if(M.length!==G.size)return!1;for(const J of M){if(Z[J]!==z[J])return!1;G.delete(J)}return G.size===0}le.equals=B})(F||(t.Translations=F={})),t.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let _=class extends l.Disposable{constructor(B,Z,z,M,G,J,Q,U,W,q,$,w){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=Z,this.extensionsControlLocation=z,this.currentProfile=M,this.userDataProfilesService=G,this.extensionsProfileScannerService=J,this.fileService=Q,this.logService=U,this.environmentService=W,this.productService=q,this.uriIdentityService=$,this.instantiationService=w,this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ae,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(u.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(u.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,E.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(B,Z,z){const[M,G]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(Z)]),J=z?await this.scanExtensionsUnderDevelopment(B,[...M,...G]):[];return this.dedupExtensions(M,G,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const Z=[];Z.push(this.scanDefaultSystemExtensions(!!B.useCache,B.language)),Z.push(this.scanDevSystemExtensions(B.language,!!B.checkControlFile));const[z,M]=await Promise.all(Z);return this.applyScanOptions([...z,...M],u.ExtensionType.System,B,!1)}async scanUserExtensions(B){const Z=B.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Z);const z=this.uriIdentityService.extUri.isEqual(B.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.createExtensionScannerInput(Z,!!B.profileLocation,u.ExtensionType.User,!B.includeUninstalled,B.language,!0,z,B.productVersion??this.getProductVersion()),G=B.useCache&&!M.devMode&&M.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let J;try{J=await G.scanExtensions(M)}catch(Q){if(Q instanceof I.ExtensionsProfileScanningError&&Q.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),J=await G.scanExtensions(M);else throw Q}return J=await this.applyScanOptions(J,u.ExtensionType.User,B,!0),this.logService.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(B,Z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const z=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(M=>M.scheme===a.Schemas.file).map(async M=>{const G=await this.createExtensionScannerInput(M,!1,u.ExtensionType.User,!0,B.language,!1,void 0,B.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(G)).map(Q=>(Q.type=Z.find(U=>(0,E.areSameExtensions)(U.identifier,Q.identifier))?.type??Q.type,this.extensionsScanner.validate(Q,G)))}))).flat();return this.applyScanOptions(z,"development",B,!0)}return[]}async scanExistingExtension(B,Z,z){const M=await this.createExtensionScannerInput(B,!1,Z,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),G=await this.extensionsScanner.scanExtension(M);return!G||!z.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(B,Z,z){const M=await this.createExtensionScannerInput(B,!1,Z,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),G=await this.extensionsScanner.scanOneOrMultipleExtensions(M);return this.applyScanOptions(G,Z,z,!0)}async scanMultipleExtensions(B,Z,z){const M=[];return await Promise.all(B.map(async G=>{const J=await this.scanOneOrMultipleExtensions(G,Z,z);M.push(...J)})),this.applyScanOptions(M,Z,z,!0)}async scanMetadata(B){const Z=(0,m.joinPath)(B,"package.json"),z=(await this.fileService.readFile(Z)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(B,Z){const z=(0,m.joinPath)(B,"package.json"),M=(await this.fileService.readFile(z)).value.toString(),G=JSON.parse(M);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,G.__metadata={...G.__metadata,...Z},await this.fileService.writeFile((0,m.joinPath)(B,"package.json"),R.VSBuffer.fromString(JSON.stringify(G,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof I.ExtensionsProfileScanningError&&B.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw B}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.extensionsProfileScannerService.addExtensionsToProfile(B.map(Z=>[Z,Z.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch(Z){(0,o.toFileOperationResult)(Z)!==o.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.getErrorMessage)(Z))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.logService.error(B)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(B,Z,z,M){return z.includeAllVersions||(B=this.dedupExtensions(Z===u.ExtensionType.System?B:void 0,Z===u.ExtensionType.User?B:void 0,Z==="development"?B:void 0,await this.getTargetPlatform(),M)),z.includeInvalid||(B=B.filter(G=>G.isValid)),B.sort((G,J)=>{const Q=c.basename(G.location.fsPath),U=c.basename(J.location.fsPath);return Q<U?-1:Q>U?1:0})}dedupExtensions(B,Z,z,M,G){const J=(U,W,q)=>{if(U.isValid&&!W.isValid)return!1;if(U.isValid===W.isValid){if(G&&S.gt(U.manifest.version,W.manifest.version))return this.logService.debug(`Skipping extension ${W.location.path} with lower version ${W.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(S.eq(U.manifest.version,W.manifest.version)){if(U.type===u.ExtensionType.System)return this.logService.debug(`Skipping extension ${W.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===M)return this.logService.debug(`Skipping extension ${W.location.path} from different target platform ${W.targetPlatform}`),!1}}return q?this.logService.warn(`Overwriting user extension ${U.location.path} with ${W.location.path}.`):this.logService.debug(`Overwriting user extension ${U.location.path} with ${W.location.path}.`),!0},Q=new u.ExtensionIdentifierMap;return B?.forEach(U=>{const W=Q.get(U.identifier.id);(!W||J(W,U,!1))&&Q.set(U.identifier.id,U)}),Z?.forEach(U=>{const W=Q.get(U.identifier.id);if(!W&&B&&U.type===u.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!W||J(W,U,!1))&&Q.set(U.identifier.id,U)}),z?.forEach(U=>{const W=Q.get(U.identifier.id);(!W||J(W,U,!0))&&Q.set(U.identifier.id,U),Q.set(U.identifier.id,U)}),[...Q.values()]}async scanDefaultSystemExtensions(B,Z){this.logService.trace("Started scanning system extensions");const z=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,u.ExtensionType.System,!0,Z,!0,void 0,this.getProductVersion()),G=await(B&&!z.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return this.logService.trace("Scanned system extensions:",G.length),G}async scanDevSystemExtensions(B,Z){const z=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!z?.length)return[];this.logService.trace("Started scanning dev system extensions");const M=Z?await this.getBuiltInExtensionControl():{},G=[],J=d.URI.file(c.normalize(c.join(a.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const U of z){const W=M[U.name]||"marketplace";switch(W){case"disabled":break;case"marketplace":G.push((0,m.joinPath)(J,U.name));break;default:G.push(d.URI.file(W));break}}const Q=await Promise.all(G.map(async U=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(U,!1,u.ExtensionType.System,!0,B,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",Q.length),(0,b.coalesce)(Q)}async getBuiltInExtensionControl(){try{const B=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(B.value.toString())}catch{return{}}}async createExtensionScannerInput(B,Z,z,M,G,J,Q,U){const W=await this.getTranslations(G??h.language),q=await this.getMtime(B),$=Z&&!this.uriIdentityService.extUri.isEqual(B,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,w=$?await this.getMtime($):void 0;return new K(B,q,$,w,Z,Q,z,M,J,U.version,U.date,this.productService.commit,!this.environmentService.isBuilt,G,W)}async getMtime(B){try{const Z=await this.fileService.stat(B);if(typeof Z.mtime=="number")return Z.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};t.AbstractExtensionsScannerService=_,t.AbstractExtensionsScannerService=_=Se([re(4,O.IUserDataProfilesService),re(5,I.IExtensionsProfileScannerService),re(6,o.IFileService),re(7,e.ILogService),re(8,P.IEnvironmentService),re(9,n.IProductService),re(10,N.IUriIdentityService),re(11,r.IInstantiationService)],_);class K{constructor(B,Z,z,M,G,J,Q,U,W,q,$,w,A,x,V){this.location=B,this.mtime=Z,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=M,this.profile=G,this.profileScanOptions=J,this.type=Q,this.excludeObsolete=U,this.validate=W,this.productVersion=q,this.productDate=$,this.productCommit=w,this.devMode=A,this.language=x,this.translations=V}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,Z){return(0,m.isEqual)(B.location,Z.location)&&B.mtime===Z.mtime&&(0,m.isEqual)(B.applicationExtensionslocation,Z.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&B.profile===Z.profile&&y.equals(B.profileScanOptions,Z.profileScanOptions)&&B.type===Z.type&&B.excludeObsolete===Z.excludeObsolete&&B.validate===Z.validate&&B.productVersion===Z.productVersion&&B.productDate===Z.productDate&&B.productCommit===Z.productCommit&&B.devMode===Z.devMode&&B.language===Z.language&&F.equals(B.translations,Z.translations)}}t.ExtensionScannerInput=K;let ae=class extends l.Disposable{constructor(B,Z,z,M,G){super(),this.obsoleteFile=B,this.extensionsProfileScannerService=Z,this.uriIdentityService=z,this.fileService=M,this.logService=G}async scanExtensions(B){const Z=B.profile?await this.scanExtensionsFromProfile(B):await this.scanExtensionsFromLocation(B);let z={};if(B.excludeObsolete&&B.type===u.ExtensionType.User)try{const M=(await this.fileService.readFile(this.obsoleteFile)).value.toString();z=JSON.parse(M)}catch{}return(0,g.isEmptyObject)(z)?Z:Z.filter(M=>!z[E.ExtensionKey.create(M).toString()])}async scanExtensionsFromLocation(B){const Z=await this.fileService.resolve(B.location);if(!Z.children?.length)return[];const z=await Promise.all(Z.children.map(async M=>{if(!M.isDirectory||B.type===u.ExtensionType.User&&(0,m.basename)(M.resource).indexOf(".")===0)return null;const G=new K(M.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(G)}));return(0,b.coalesce)(z).sort((M,G)=>M.location.path<G.location.path?-1:1)}async scanExtensionsFromProfile(B){let Z=await this.scanExtensionsFromProfileResource(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(B.location,B.applicationExtensionslocation)){Z=Z.filter(M=>!M.metadata?.isApplicationScoped);const z=await this.scanExtensionsFromProfileResource(B.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,B);Z.push(...z)}return Z}async scanExtensionsFromProfileResource(B,Z,z){const M=await this.extensionsProfileScannerService.scanProfileExtensions(B,z.profileScanOptions);if(!M.length)return[];const G=await Promise.all(M.map(async J=>{if(Z(J)){const Q=new K(J.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(Q,J.metadata)}return null}));return(0,b.coalesce)(G)}async scanOneOrMultipleExtensions(B){try{if(await this.fileService.exists((0,m.joinPath)(B.location,"package.json"))){const Z=await this.scanExtension(B);return Z?[Z]:[]}else return await this.scanExtensions(B)}catch(Z){return this.logService.error(`Error scanning extensions at ${B.location.path}:`,(0,L.getErrorMessage)(Z)),[]}}async scanExtension(B,Z){try{let z=await this.scanExtensionManifest(B.location);if(z){z.publisher||(z.publisher=u.UNDEFINED_PUBLISHER),Z=Z??z.__metadata,delete z.__metadata;const M=(0,E.getGalleryExtensionId)(z.publisher,z.name),G=Z?.id?{id:M,uuid:Z.id}:{id:M},J=Z?.isSystem?u.ExtensionType.System:B.type,Q=J===u.ExtensionType.System||!!Z?.isBuiltin;z=await this.translateManifest(B.location,z,K.createNlsConfiguration(B));const U={type:J,identifier:G,manifest:z,location:B.location,isBuiltin:Q,targetPlatform:Z?.targetPlatform??u.TargetPlatform.UNDEFINED,publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return B.validate?this.validate(U,B):U}}catch(z){B.type!==u.ExtensionType.System&&this.logService.error(z)}return null}validate(B,Z){let z=!0;const M=(0,i.validateExtensionManifest)(Z.productVersion,Z.productDate,Z.location,B.manifest,B.isBuiltin);for(const[G,J]of M)G===T.default.Error&&(z=!1,this.logService.error(this.formatMessage(Z.location,J)));return B.isValid=z,B.validations=M,B}async scanExtensionManifest(B){const Z=(0,m.joinPath)(B,"package.json");let z;try{z=(await this.fileService.readFile(Z)).value.toString()}catch(G){return(0,o.toFileOperationResult)(G)!==o.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(B,(0,v.localize)(0,null,Z.path,G.message))),null}let M;try{M=JSON.parse(z)}catch{const J=[];(0,C.parse)(z,J);for(const Q of J)this.logService.error(this.formatMessage(B,(0,v.localize)(1,null,Z.path,Q.offset,Q.length,(0,p.getParseErrorMessage)(Q.error))));return null}return(0,C.getNodeType)(M)!=="object"?(this.logService.error(this.formatMessage(B,(0,v.localize)(2,null,Z.path))),null):M}async translateManifest(B,Z,z){const M=await this.getLocalizedMessages(B,Z,z);if(M)try{const G=[],J=await this.resolveOriginalMessageBundle(M.default,G);if(G.length>0)return G.forEach(U=>{this.logService.error(this.formatMessage(B,(0,v.localize)(3,null,M.default?.path,(0,p.getParseErrorMessage)(U.error))))}),Z;if((0,C.getNodeType)(M)!=="object")return this.logService.error(this.formatMessage(B,(0,v.localize)(4,null,M.default?.path))),Z;const Q=M.values||Object.create(null);return(0,k.localizeManifest)(this.logService,Z,Q,J)}catch{}return Z}async getLocalizedMessages(B,Z,z){const M=(0,m.joinPath)(B,"package.nls.json"),G=(W,q)=>{q.forEach($=>{this.logService.error(this.formatMessage(B,(0,v.localize)(5,null,W?.path,(0,p.getParseErrorMessage)($.error))))})},J=W=>{this.logService.error(this.formatMessage(B,(0,v.localize)(6,null,W?.path)))},Q=`${Z.publisher}.${Z.name}`,U=z.translations[Q];if(U)try{const W=d.URI.file(U),q=(await this.fileService.readFile(W)).value.toString(),$=[],w=(0,C.parse)(q,$);return $.length>0?(G(W,$),{values:void 0,default:M}):(0,C.getNodeType)(w)!=="object"?(J(W),{values:void 0,default:M}):{values:w.contents?w.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.fileService.exists(M))return;let q;try{q=await this.findMessageBundles(B,z)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const $=(await this.fileService.readFile(q.localized)).value.toString(),w=[],A=(0,C.parse)($,w);return w.length>0?(G(q.localized,w),{values:void 0,default:q.original}):(0,C.getNodeType)(A)!=="object"?(J(q.localized),{values:void 0,default:q.original}):{values:A,default:q.original}}catch{return{values:void 0,default:q.original}}}}async resolveOriginalMessageBundle(B,Z){if(B)try{const z=(await this.fileService.readFile(B)).value.toString();return(0,C.parse)(z,Z)}catch{}}findMessageBundles(B,Z){return new Promise((z,M)=>{const G=J=>{const Q=(0,m.joinPath)(B,`package.nls.${J}.json`);this.fileService.exists(Q).then(U=>{U&&z({localized:Q,original:(0,m.joinPath)(B,"package.nls.json")});const W=J.lastIndexOf("-");W===-1?z({localized:(0,m.joinPath)(B,"package.nls.json"),original:null}):(J=J.substring(0,W),G(J))})};if(Z.devMode||Z.pseudo||!Z.language)return z({localized:(0,m.joinPath)(B,"package.nls.json"),original:null});G(Z.language)})}formatMessage(B,Z){return`[${B.path}]: ${Z}`}};ae=Se([re(1,I.IExtensionsProfileScannerService),re(2,N.IUriIdentityService),re(3,o.IFileService),re(4,e.ILogService)],ae);let ie=class extends ae{constructor(B,Z,z,M,G,J,Q){super(Z,M,G,J,Q),this.currentProfile=B,this.userDataProfilesService=z,this.cacheValidatorThrottler=this._register(new D.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(B){const Z=this.getCacheFile(B),z=await this.readExtensionCache(Z);if(this.input=B,z&&z.input&&K.equals(z.input,this.input))return this.logService.debug("Using cached extensions scan result",B.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(G=>(G.location=d.URI.revive(G.location),G));const M=await super.scanExtensions(B);return await this.writeExtensionCache(Z,{input:B,result:M}),M}async readExtensionCache(B){try{const Z=await this.fileService.readFile(B),z=JSON.parse(Z.value.toString());return{result:z.result,input:(0,f.revive)(z.input)}}catch(Z){this.logService.debug("Error while reading the extension cache file:",B.path,(0,L.getErrorMessage)(Z))}return null}async writeExtensionCache(B,Z){try{await this.fileService.writeFile(B,R.VSBuffer.fromString(JSON.stringify(Z)))}catch(z){this.logService.debug("Error while writing the extension cache file:",B.path,(0,L.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const B=this.getCacheFile(this.input),Z=await this.readExtensionCache(B);if(!Z)return;const z=Z.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!y.equals(M,z))try{this.logService.info("Invalidating Cache",z,M),await this.fileService.del(B),this._onDidChangeCache.fire()}catch(G){this.logService.error(G)}}getCacheFile(B){const Z=this.getProfile(B);return this.uriIdentityService.extUri.joinPath(Z.cacheHome,B.type===u.ExtensionType.System?u.BUILTIN_MANIFEST_CACHE_FILE:u.USER_MANIFEST_CACHE_FILE)}getProfile(B){return B.type===u.ExtensionType.System?this.userDataProfilesService.defaultProfile:B.profile?this.uriIdentityService.extUri.isEqual(B.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Z=>this.uriIdentityService.extUri.isEqual(B.location,Z.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};ie=Se([re(2,O.IUserDataProfilesService),re(3,I.IExtensionsProfileScannerService),re(4,N.IUriIdentityService),re(5,o.IFileService),re(6,e.ILogService)],ie);function ce(le,B){const Z=(0,E.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:Z,identifier:new u.ExtensionIdentifier(Z),isBuiltin:le.type===u.ExtensionType.System,isUserBuiltin:le.type===u.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:B,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class ue extends _{constructor(B,Z,z,M,G,J,Q,U,W,q,$,w){super(B,Z,(0,m.joinPath)(z,".vscode-oss-dev","extensions","control.json"),M,G,J,Q,U,W,q,$,w),this.translationsPromise=(async()=>{if(h.translationsConfigFile)try{const A=await this.fileService.readFile(d.URI.file(h.translationsConfigFile));return JSON.parse(A.value.toString())}catch{}return Object.create(null)})()}getTranslations(B){return this.translationsPromise}}t.NativeExtensionsScannerService=ue}),define(se[160],oe([0,1,60,8,36,5,2,15,16,25,6,24]),function(H,t,b,D,y,R,L,C,p,l,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let h=class extends L.Disposable{constructor(S,T){super(),this.userDataProfilesService=S,this.logService=T,this.processesLimiter=new D.Limiter(5)}async postUninstall(S){const T=this.parseScript(S,"uninstall");T&&(this.logService.info(S.identifier.id,S.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(T.script,"uninstall",T.args,!0,S),this.logService.info("Finished running post uninstall script",S.identifier.id,S.manifest.version)}catch(g){this.logService.error("Failed to run post uninstall script",S.identifier.id,S.manifest.version),this.logService.error(g)}}));try{await l.Promises.rm(this.getExtensionStoragePath(S))}catch(g){this.logService.error("Error while removing extension storage path",S.identifier.id),this.logService.error(g)}}parseScript(S,T){const g=`vscode:${T}`;if(S.location.scheme===C.Schemas.file&&S.manifest&&S.manifest.scripts&&typeof S.manifest.scripts[g]=="string"){const d=S.manifest.scripts[g].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(S.identifier.id,S.manifest.version,`${g} should be a node script`),null):{script:(0,p.join)(S.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(S,T,g,d,v){return new Promise((P,E)=>{const u=this.start(S,T,g,v);let i;const o=r=>{i&&(clearTimeout(i),i=null),r?E(r):P(void 0)};u.on("error",r=>{o((0,y.toErrorMessage)(r)||"Unknown")}),u.on("exit",(r,e)=>{o(r?`post-${T} process exited with code ${r}`:void 0)}),d&&(i=setTimeout(()=>{i=null,u.kill(),E("timed out")},5e3))})}start(S,T,g,d){const v={silent:!0,execArgv:void 0},P=(0,b.fork)(S,[`--type=extension-post-${T}`,...g],v);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const E=R.Event.fromNodeEventEmitter(P.stdout,"data"),u=R.Event.fromNodeEventEmitter(P.stderr,"data");this._register(E(r=>this.logService.info(d.identifier.id,d.manifest.version,`post-${T}`,r))),this._register(u(r=>this.logService.error(d.identifier.id,d.manifest.version,`post-${T}`,r)));const i=R.Event.any(R.Event.map(E,r=>({data:`%c${r}`,format:[""]}),this._store),R.Event.map(u,r=>({data:`%c${r}`,format:["color: red"]}),this._store));return R.Event.debounce(i,(r,e)=>r?{data:r.data+e.data,format:[...r.format,...e.format]}:{data:e.data,format:e.format},100,void 0,void 0,void 0,this._store)(r=>{console.group(d.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),P}getExtensionStoragePath(S){return(0,p.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,S.identifier.id.toLowerCase())}};t.ExtensionsLifecycle=h,t.ExtensionsLifecycle=h=Se([re(0,c.IUserDataProfilesService),re(1,a.ILogService)],h)}),define(se[73],oe([0,1,49,104,53,21]),function(H,t,b,D,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fromExtractError=L,t.getManifest=C;function L(p){let l=R.ExtensionManagementErrorCode.Extract;return p instanceof b.ExtractError&&(p.type==="CorruptZip"?l=R.ExtensionManagementErrorCode.CorruptZip:p.type==="Incomplete"&&(l=R.ExtensionManagementErrorCode.IncompleteZip)),(0,y.toExtensionManagementError)(p,l)}async function C(p){let l;try{l=await(0,b.buffer)(p,"extension/package.json")}catch(a){throw L(a)}try{return JSON.parse(l.toString("utf8"))}catch{throw new R.ExtensionManagementError((0,D.localize)(0,null),R.ExtensionManagementErrorCode.Invalid)}}}),define(se[161],oe([0,1,8,9,2,15,17,44,29,25,49,30,18,53,21,27,73,72,10,6,19]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S,T,g,d,v,P,E){"use strict";var u;Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;let i=class extends y.Disposable{static{u=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(r,e,n,s,f,I,O){super(),this.fileService=e,this.extensionGalleryService=n,this.configurationService=s,this.extensionSignatureVerificationService=f,this.telemetryService=I,this.logService=O,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(r,e,n,s){await this.cleanUpPromise;const f=await this.downloadVSIX(r,e);let I=!1;if(n&&this.shouldVerifySignature(r)){let O;try{O=await this.downloadSignatureArchive(r)}catch(N){try{await this.delete(f)}catch(k){this.logService.error(k)}throw N}try{I=await this.extensionSignatureVerificationService.verify(r,f.fsPath,O.fsPath,s)}catch(N){if(I=N.code,I===d.ExtensionSignatureVerificationCode.PackageIsInvalidZip||I===d.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(f)}catch(k){this.logService.error(k)}throw new S.ExtensionManagementError(a.CorruptZipMessage,S.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(O)}catch(N){this.logService.error(N)}}}return{location:f,verificationStatus:I}}shouldVerifySignature(r){return r.isSigned||this.logService.info(`Extension is not signed: ${r.identifier.id}`),!1}async downloadVSIX(r,e){try{const n=(0,L.joinPath)(this.extensionsDownloadDir,this.getName(r)),s=await this.doDownload(r,"vsix",async()=>{await this.downloadFile(r,n,f=>this.extensionGalleryService.download(r,f,e));try{await this.validate(n.fsPath,"extension/package.json")}catch(f){try{await this.fileService.del(n)}catch(I){this.logService.warn(`Error while deleting: ${n.path}`,(0,D.getErrorMessage)(I))}throw f}},2);return s>1&&this.telemetryService.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:r.identifier.id,attempts:s}),n}catch(n){throw(0,m.toExtensionManagementError)(n,S.ExtensionManagementErrorCode.Download)}}async downloadSignatureArchive(r){try{const e=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`),n=await this.doDownload(r,"sigzip",async()=>{await this.extensionGalleryService.downloadSignatureArchive(r,e);try{await this.validate(e.fsPath,".signature.p7s")}catch(s){try{await this.fileService.del(e)}catch(f){this.logService.warn(`Error while deleting: ${e.path}`,(0,D.getErrorMessage)(f))}throw s}},2);return n>1&&this.telemetryService.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:r.identifier.id,attempts:n}),e}catch(e){throw(0,m.toExtensionManagementError)(e,S.ExtensionManagementErrorCode.DownloadSignature)}}async downloadFile(r,e,n){if(await this.fileService.exists(e))return;if(e.scheme!==R.Schemas.file){await n(e);return}const s=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);try{await n(s)}catch(f){try{await this.fileService.del(s)}catch{}throw f}try{await l.Promises.rename(s.fsPath,e.fsPath,2*60*1e3)}catch(f){try{await this.fileService.del(s)}catch{}let I=!1;try{I=await this.fileService.exists(e)}catch{}if(I)this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",r.identifier.id,e.path);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(f)}. Deleted the file from downloaded location`,s.path),f}}async doDownload(r,e,n,s){let f=1;for(;;)try{return await n(),f}catch(I){if(f++>s)throw I;this.logService.warn(`Failed downloading ${e}. ${(0,D.getErrorMessage)(I)}. Retry again...`,r.identifier.id)}}async validate(r,e){try{await(0,a.buffer)(r,e)}catch(n){throw(0,g.fromExtractError)(n)}}async delete(r){await this.cleanUpPromise,await this.fileService.del(r)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const r=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(r.children){const e=[],n=[],s=[];for(const O of r.children)if(O.name.endsWith(u.SignatureArchiveExtension))s.push(O.resource);else{const N=T.ExtensionKey.parse(O.name);N&&n.push([N,O])}const f=(0,T.groupByExtension)(n,([O])=>O),I=[];for(const O of f)O.sort((N,k)=>C.rcompare(N[0].version,k[0].version)),e.push(...O.slice(1).map(N=>N[1].resource)),I.push(O[0][1]);I.sort((O,N)=>O.mtime-N.mtime),e.push(...I.slice(0,Math.max(0,I.length-this.cache)).map(O=>O.resource)),e.push(...s),await b.Promises.settled(e.map(O=>(this.logService.trace("Deleting from cache",O.path),this.fileService.del(O))))}}catch(r){this.logService.error(r)}}getName(r){return this.cache?T.ExtensionKey.create(r).toString().toLowerCase():(0,p.generateUuid)()}};t.ExtensionsDownloader=i,t.ExtensionsDownloader=i=u=Se([re(0,h.INativeEnvironmentService),re(1,v.IFileService),re(2,S.IExtensionGalleryService),re(3,c.IConfigurationService),re(4,d.IExtensionSignatureVerificationService),re(5,E.ITelemetryService),re(6,P.ILogService)],i)}),define(se[162],oe([0,1,8,14,22,36,9,5,43,2,31,15,16,17,44,3,12,29,25,49,103,62,18,53,21,27,42,54,161,160,73,142,149,26,50,10,11,6,33,19,23,24]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S,T,g,d,v,P,E,u,i,o,r,e,n,s,f,I,O,N,k,F,_,K,ae,ie,ce,ue,le,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=t.ExtensionManagementService=t.INativeServerExtensionManagementService=void 0,t.INativeServerExtensionManagementService=(0,ae.refineServiceDecorator)(r.IExtensionManagementService);const Z=".vsctmp";let z=class extends o.AbstractExtensionManagementService{constructor(U,W,q,$,w,A,x,V,Y,X,ne,he){super(U,W,ne,q,X,he),this.extensionsScannerService=w,this.extensionsProfileScannerService=A,this.downloadService=x,this.instantiationService=V,this.fileService=Y,this.extractingGalleryExtensions=new Map,this.knownDirectories=new a.ResourceSet;const fe=this._register(V.createInstance(I.ExtensionsLifecycle));this.extensionsScanner=this._register(V.createInstance(M,me=>fe.postUninstall(me))),this.manifestCache=this._register(new N.ExtensionsManifestCache(he,Y,ne,this,this.logService)),this.extensionsDownloader=this._register(V.createInstance(f.ExtensionsDownloader));const ye=this._register(new k.ExtensionsWatcher(this,this.extensionsScannerService,he,A,ne,Y,q));this._register(ye.onDidChangeExtensionsByAnotherSource(me=>this.onDidChangeExtensionsFromAnotherSource(me))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,e.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const W=await this.collectFiles(U),q=await(0,P.zip)((0,m.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,d.generateUuid)()).fsPath,W);return g.URI.file(q)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:W,cleanup:q}=await this.downloadVsix(U),$=h.resolve(W.fsPath);try{return await(0,O.getManifest)($)}finally{await q()}}getInstalled(U,W=this.userDataProfilesService.defaultProfile.extensionsResource,q={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(U??null,W,q)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.extensionsScanner.scanUserExtensionAtLocation(U)}async install(U,W={}){this.logService.trace("ExtensionManagementService#install",U.toString());const{location:q,cleanup:$}=await this.downloadVsix(U);try{const w=await(0,O.getManifest)(h.resolve(q.fsPath)),A=(0,e.getGalleryExtensionId)(w.publisher,w.name);if(w.engines&&w.engines.vscode&&!(0,_.isEngineValid)(w.engines.vscode,this.productService.version,this.productService.date))throw new Error(E.localize(0,null,A,this.productService.version));const V=(await this.installExtensions([{manifest:w,extension:q,options:W}])).find(({identifier:Y})=>(0,e.areSameExtensions)(Y,{id:A}));if(V?.local)return V.local;throw V?.error?V.error:(0,o.toExtensionManagementError)(new Error(`Unknown error while installing extension ${A}`))}finally{await $()}}async installFromLocation(U,W){this.logService.trace("ExtensionManagementService#installFromLocation",U.toString());const q=await this.extensionsScanner.scanUserExtensionAtLocation(U);if(!q||!q.manifest.name||!q.manifest.version)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.addExtensionsToProfile([[q,{source:"resource"}]],W),this.logService.info("Successfully installed extension",q.identifier.id,W.toString()),q}async installExtensionsFromProfile(U,W,q){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",U,W.toString(),q.toString());const $=(await this.getInstalled(F.ExtensionType.User,W)).filter(w=>U.some(A=>(0,e.areSameExtensions)(A,w.identifier)));if($.length){const w=await Promise.all($.map(A=>this.extensionsScanner.scanMetadata(A,W)));await this.addExtensionsToProfile($.map((A,x)=>[A,w[x]]),q),this.logService.info("Successfully installed extensions",$.map(A=>A.identifier.id),q.toString())}return $}async updateMetadata(U,W,q=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0,W.hasPreReleaseVersion=!0),W.isMachineScoped===!1&&(W.isMachineScoped=void 0),W.isBuiltin===!1&&(W.isBuiltin=void 0),W.pinned===!1&&(W.pinned=void 0),U=await this.extensionsScanner.updateMetadata(U,W,q),this.manifestCache.invalidate(q),this._onDidUpdateExtensionMetadata.fire(U),U}async reinstallFromGallery(U){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const W=await this.getTargetPlatform(),[q]=await this.galleryService.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:W,compatible:!0},y.CancellationToken.None);if(!q)throw new Error(E.localize(2,null));await this.extensionsScanner.setUninstalled(U);try{await this.extensionsScanner.removeUninstalledExtension(U)}catch($){throw new Error(E.localize(3,null,(0,R.toErrorMessage)($)))}return this.installFromGallery(q)}copyExtension(U,W,q,$){return this.extensionsScanner.copyExtension(U,W,q,$)}copyExtensions(U,W){return this.extensionsScanner.copyExtensions(U,W,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...U){return this.extensionsScanner.setUninstalled(...U)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(U){this.logService.error(U)}}async download(U,W,q){const{location:$}=await this.extensionsDownloader.download(U,W,!q);return $}async downloadVsix(U){if(U.scheme===c.Schemas.file)return{location:U,async cleanup(){}};this.logService.trace("Downloading extension from",U.toString());const W=(0,m.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,d.generateUuid)());return await this.downloadService.download(U,W),this.logService.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.fileService.del(W)}catch($){this.logService.error($)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(U,W,q){const $=W instanceof g.URI?new e.ExtensionKey({id:(0,e.getGalleryExtensionId)(U.publisher,U.name)},U.version):e.ExtensionKey.create(W);return this.instantiationService.createInstance(G,$,U,W,q,(w,A)=>{if(W instanceof g.URI)return this.extractVSIX($,W,q,A);let x=this.extractingGalleryExtensions.get($.toString());return x||(this.extractingGalleryExtensions.set($.toString(),x=this.downloadAndExtractGalleryExtension($,W,w,q,A)),x.finally(()=>this.extractingGalleryExtensions.delete($.toString()))),x},this.extensionsScanner)}createUninstallExtensionTask(U,W){return new J(U,W.profileLocation,this.extensionsProfileScannerService)}async downloadAndExtractGalleryExtension(U,W,q,$,w){const{verificationStatus:A,location:x}=await this.extensionsDownloader.download(W,q,!$.donotVerifySignature,$.context?.[r.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT]);try{if(w.isCancellationRequested)throw new L.CancellationError;return await(0,O.getManifest)(x.fsPath),{local:await this.extensionsScanner.extractUserExtension(U,x.fsPath,{id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName,targetPlatform:W.properties.targetPlatform,isApplicationScoped:$.isApplicationScoped,isMachineScoped:$.isMachineScoped,isBuiltin:$.isBuiltin,isPreReleaseVersion:W.properties.isPreReleaseVersion,hasPreReleaseVersion:W.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:$.installGivenVersion?!0:!!$.pinned,preRelease:(0,T.isBoolean)($.preRelease)?$.preRelease:$.installPreReleaseVersion||W.properties.isPreReleaseVersion,source:"gallery"},!1,w),verificationStatus:A}}catch(V){try{await this.extensionsDownloader.delete(x)}catch(Y){this.logService.warn("Error while deleting the downloaded file",x.toString(),(0,L.getErrorMessage)(Y))}throw(0,o.toExtensionManagementError)(V)}}async extractVSIX(U,W,q,$){return{local:await this.extensionsScanner.extractUserExtension(U,h.resolve(W.fsPath),{isApplicationScoped:q.isApplicationScoped,isMachineScoped:q.isMachineScoped,isBuiltin:q.isBuiltin,installedTimestamp:Date.now(),pinned:q.installGivenVersion?!0:!!q.pinned,source:"vsix"},!0,$)}}async collectFiles(U){const W=async $=>{let w=await v.Promises.readdir($);w=w.map(V=>h.join($,V));const A=await Promise.all(w.map(V=>v.Promises.stat(V)));let x=Promise.resolve([]);return A.forEach((V,Y)=>{const X=w[Y];V.isFile()&&(x=x.then(ne=>[...ne,X])),V.isDirectory()&&(x=x.then(ne=>W(X).then(he=>[...ne,...he])))}),x};return(await W(U.location.fsPath)).map($=>({path:`extension/${h.relative(U.location.fsPath,$)}`,localPath:$}))}async onDidChangeExtensionsFromAnotherSource({added:U,removed:W}){if(W){const q=U&&this.uriIdentityService.extUri.isEqual(W.profileLocation,U.profileLocation)?W.extensions.filter($=>U.extensions.every(w=>!(0,e.areSameExtensions)(w,$))):W.extensions;for(const $ of q)this.logService.info("Extensions removed from another source",$.id,W.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:$,profileLocation:W.profileLocation})}if(U){const $=(await this.getInstalled(F.ExtensionType.User,U.profileLocation)).filter(w=>U.extensions.some(A=>(0,e.areSameExtensions)(A,w.identifier)));this._onDidInstallExtensions.fire($.map(w=>(this.logService.info("Extensions added from another source",w.identifier.id,U.profileLocation.toString()),{identifier:w.identifier,local:w,profileLocation:U.profileLocation,operation:r.InstallOperation.None})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(W=>this.knownDirectories.add(W)));const U=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const W of U.children??[])W.isDirectory&&this.knownDirectories.add(W.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(W=>this.onDidFilesChange(W)))}async onDidFilesChange(U){if(!U.affects(this.extensionsScannerService.userExtensionsLocation,K.FileChangeType.ADDED))return;const W=[];for(const q of U.rawAdded){if(this.knownDirectories.has(q)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(q),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(q,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(q).startsWith(".")||!(await this.fileService.stat(q)).isDirectory)continue;const $=await this.extensionsScanner.scanUserExtensionAtLocation(q);$&&$.installedTimestamp===void 0&&(this.knownDirectories.add(q),W.push($))}W.length&&(await this.addExtensionsToProfile(W.map(q=>[q,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",W.map(q=>q.identifier.id)))}async addExtensionsToProfile(U,W){const q=U.map($=>$[0]);await this.setInstalled(q),await this.extensionsProfileScannerService.addExtensionsToProfile(U,W),this._onDidInstallExtensions.fire(q.map($=>({local:$,identifier:$.identifier,operation:r.InstallOperation.None,profileLocation:W})))}async setInstalled(U){const W=await this.extensionsScanner.getUninstalledExtensions();for(const q of U){const $=e.ExtensionKey.create(q);W[$.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",$.id),await this.extensionsScanner.setInstalled($),this.logService.info("Removed the extension from uninstalled list:",$.id))}}};t.ExtensionManagementService=z,t.ExtensionManagementService=z=Se([re(0,r.IExtensionGalleryService),re(1,ue.ITelemetryService),re(2,ie.ILogService),re(3,i.INativeEnvironmentService),re(4,s.IExtensionsScannerService),re(5,n.IExtensionsProfileScannerService),re(6,u.IDownloadService),re(7,ae.IInstantiationService),re(8,K.IFileService),re(9,ce.IProductService),re(10,le.IUriIdentityService),re(11,B.IUserDataProfilesService)],z);let M=class extends l.Disposable{constructor(U,W,q,$,w,A){super(),this.beforeRemovingExtension=U,this.fileService=W,this.extensionsScannerService=q,this.extensionsProfileScannerService=$,this.uriIdentityService=w,this.logService=A,this._onExtract=this._register(new C.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,m.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new b.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(U,W,q){try{const $={includeInvalid:!0,profileLocation:W,productVersion:q};let w=[];return U===null||U===F.ExtensionType.System?w.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},$,!1)):U===F.ExtensionType.User&&w.push(...await this.extensionsScannerService.scanUserExtensions($)),w=U!==null?w.filter(A=>A.type===U):w,await Promise.all(w.map(A=>this.toLocalExtension(A)))}catch($){throw(0,o.toExtensionManagementError)($,r.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(U){try{const W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return await Promise.all(W.map(q=>this.toLocalExtension(q)))}catch(W){throw(0,o.toExtensionManagementError)(W,r.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(U){try{const W=await this.extensionsScannerService.scanExistingExtension(U,F.ExtensionType.User,{includeInvalid:!0});if(W)return await this.toLocalExtension(W)}catch(W){this.logService.error(W)}return null}async extractUserExtension(U,W,q,$,w){const A=U.toString(),x=g.URI.file(h.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,d.generateUuid)()}`)),V=g.URI.file(h.join(this.extensionsScannerService.userExtensionsLocation.fsPath,A));let Y=await this.fileService.exists(V);if(Y&&$){try{await this.deleteExtensionFromLocation(U.id,V,"removeExisting")}catch{throw new r.ExtensionManagementError(E.localize(4,null,V.fsPath,U.id),r.ExtensionManagementErrorCode.Delete)}Y=!1}if(Y)try{await this.extensionsScannerService.updateMetadata(V,q)}catch(X){throw(0,o.toExtensionManagementError)(X,r.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(w.isCancellationRequested)throw new L.CancellationError;try{this.logService.trace(`Started extracting the extension from ${W} to ${V.fsPath}`),await(0,P.extract)(W,x.fsPath,{sourcePath:"extension",overwrite:!0},w),this.logService.info(`Extracted extension to ${V}:`,U.id)}catch(X){throw(0,O.fromExtractError)(X)}try{await this.extensionsScannerService.updateMetadata(x,q)}catch(X){throw(0,o.toExtensionManagementError)(X,r.ExtensionManagementErrorCode.UpdateMetadata)}if(w.isCancellationRequested)throw new L.CancellationError;try{this.logService.trace(`Started renaming the extension from ${x.fsPath} to ${V.fsPath}`),await this.rename(x.fsPath,V.fsPath),this.logService.info("Renamed to",V.fsPath)}catch(X){if(X.code==="ENOTEMPTY"){this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);try{await this.fileService.del(x,{recursive:!0})}catch{}}else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(X)}. Deleted from extracted location`,x),X}this._onExtract.fire(V)}catch(X){try{await this.fileService.del(x,{recursive:!0})}catch{}throw X}return this.scanLocalExtension(V,F.ExtensionType.User)}async scanMetadata(U,W){return W?(await this.getScannedExtension(U,W))?.metadata:this.extensionsScannerService.scanMetadata(U.location)}async getScannedExtension(U,W){return(await this.extensionsProfileScannerService.scanProfileExtensions(W)).find($=>(0,e.areSameExtensions)($.identifier,U.identifier))}async updateMetadata(U,W,q){try{q?await this.extensionsProfileScannerService.updateMetadata([[U,W]],q):await this.extensionsScannerService.updateMetadata(U.location,W)}catch($){throw(0,o.toExtensionManagementError)($,r.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(U.location,U.type,q)}async getUninstalledExtensions(){try{return await this.withUninstalledExtensions()}catch(U){throw(0,o.toExtensionManagementError)(U,r.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...U){const W=U.map(q=>e.ExtensionKey.create(q));await this.withUninstalledExtensions(q=>W.forEach($=>{q[$.toString()]=!0,this.logService.info("Marked extension as uninstalled",$.toString())}))}async setInstalled(U){try{await this.withUninstalledExtensions(W=>delete W[U.toString()])}catch(W){throw(0,o.toExtensionManagementError)(W,r.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(U,W){if(this.uriIdentityService.extUri.isEqualOrParent(U.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(U.identifier.id,U.location,W)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.withUninstalledExtensions(W=>delete W[e.ExtensionKey.create(U).toString()])}async copyExtension(U,W,q,$){const w=await this.getScannedExtension(U,W),A=await this.getScannedExtension(U,q);if($={...w?.metadata,...$},A)if(this.uriIdentityService.extUri.isEqual(A.location,U.location))await this.extensionsProfileScannerService.updateMetadata([[U,{...A.metadata,...$}]],q);else{const x=await this.scanLocalExtension(A.location,U.type,q);await this.extensionsProfileScannerService.removeExtensionFromProfile(x,q),await this.extensionsProfileScannerService.addExtensionsToProfile([[U,{...A.metadata,...$}]],q)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[U,$]],q);return this.scanLocalExtension(U.location,U.type,q)}async copyExtensions(U,W,q){const $=await this.scanExtensions(F.ExtensionType.User,U,q),w=await Promise.all($.filter(A=>!A.isApplicationScoped).map(async A=>[A,await this.scanMetadata(A,U)]));await this.extensionsProfileScannerService.addExtensionsToProfile(w,W)}async deleteExtensionFromLocation(U,W,q){this.logService.trace(`Deleting ${q} extension from disk`,U,W.fsPath);const $=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(W),`${this.uriIdentityService.extUri.basename(W)}.${(0,p.hash)((0,d.generateUuid)()).toString(16)}${Z}`);await this.rename(W.fsPath,$.fsPath),await this.fileService.del($,{recursive:!0}),this.logService.info(`Deleted ${q} extension from disk`,U,W.fsPath)}withUninstalledExtensions(U){return this.uninstalledFileLimiter.queue(async()=>{let W;try{W=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch($){if((0,K.toFileOperationResult)($)!==K.FileOperationResult.FILE_NOT_FOUND)throw $}let q={};if(W)try{q=JSON.parse(W)}catch{}return U&&(U(q),Object.keys(q).length?await this.fileService.writeFile(this.uninstalledResource,D.VSBuffer.fromString(JSON.stringify(q))):await this.fileService.del(this.uninstalledResource)),q})}async rename(U,W){try{await v.Promises.rename(U,W,2*60*1e3)}catch(q){throw(0,o.toExtensionManagementError)(q,r.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(U,W,q){try{if(q){const w=(await this.extensionsScannerService.scanUserExtensions({profileLocation:q})).find(A=>this.uriIdentityService.extUri.isEqual(A.location,U));if(w)return await this.toLocalExtension(w)}else{const $=await this.extensionsScannerService.scanExistingExtension(U,W,{includeInvalid:!0});if($)return await this.toLocalExtension($)}throw new r.ExtensionManagementError(E.localize(5,null,U.path),r.ExtensionManagementErrorCode.ScanningExtension)}catch($){throw(0,o.toExtensionManagementError)($,r.ExtensionManagementErrorCode.ScanningExtension)}}async toLocalExtension(U){const W=await this.fileService.resolve(U.location);let q,$;return W.children&&(q=W.children.find(({name:w})=>/^readme(\.txt|\.md|)$/i.test(w))?.resource,$=W.children.find(({name:w})=>/^changelog(\.txt|\.md|)$/i.test(w))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:q,changelogUrl:$,publisherDisplayName:U.metadata?.publisherDisplayName,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!U.metadata?.hasPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned,isWorkspaceScoped:!1,source:U.metadata?.source??(U.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(U));const W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const w of W)U[e.ExtensionKey.create(w).toString()]||q.add(w.identifier.id.toLowerCase());try{const w=(0,e.groupByExtension)(W,A=>A.identifier);await b.Promises.settled(w.map(async A=>{const x=A.sort((V,Y)=>S.rcompare(V.manifest.version,Y.manifest.version))[0];q.has(x.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(x))}))}catch(w){this.logService.error(w)}const $=W.filter(w=>w.metadata&&U[e.ExtensionKey.create(w).toString()]);await Promise.allSettled($.map(w=>this.removeUninstalledExtension(w)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(W){(0,K.toFileOperationResult)(W)!==K.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(W);return}if(U?.children)try{await Promise.allSettled(U.children.map(async W=>{if(!(!W.isDirectory||!W.name.endsWith(Z))){this.logService.trace("Deleting the temporarily deleted folder",W.resource.toString());try{await this.fileService.del(W.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",W.resource.toString())}catch(q){(0,K.toFileOperationResult)(q)!==K.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(q)}}}))}catch{}}};t.ExtensionsScanner=M,t.ExtensionsScanner=M=Se([re(1,K.IFileService),re(2,s.IExtensionsScannerService),re(3,n.IExtensionsProfileScannerService),re(4,le.IUriIdentityService),re(5,ie.ILogService)],M);let G=class extends o.AbstractExtensionTask{get operation(){return this.options.operation??this._operation}get verificationStatus(){return this._verificationStatus}constructor(U,W,q,$,w,A,x,V,Y,X,ne,he){super(),this.extensionKey=U,this.manifest=W,this.source=q,this.options=$,this.extractExtensionFn=w,this.extensionsScanner=A,this.uriIdentityService=x,this.galleryService=V,this.userDataProfilesService=Y,this.extensionsScannerService=X,this.extensionsProfileScannerService=ne,this.logService=he,this._operation=r.InstallOperation.Install,this.identifier=this.extensionKey.identifier}async getExistingExtension(){return(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(W=>(0,e.areSameExtensions)(W.identifier,this.identifier))}async doRun(U){const W=await this.getExistingExtension();W&&(this._operation=r.InstallOperation.Update);const q={isApplicationScoped:this.options.isApplicationScoped||W?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||W?.isMachineScoped,isBuiltin:this.options.isBuiltin||W?.isBuiltin,isSystem:W?.type===F.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??W?.pinned,source:this.source instanceof g.URI?"vsix":"gallery"};let $;if(this.source instanceof g.URI)if(W){if(this.extensionKey.equals(new e.ExtensionKey(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(E.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const A=await this.unsetIfUninstalled(this.extensionKey);if(A)try{await this.extensionsScanner.removeExtension(A,"existing")}catch{throw new Error(E.localize(7,null,this.manifest.displayName||this.manifest.name))}}else q.id=this.source.identifier.uuid,q.publisherId=this.source.publisherId,q.publisherDisplayName=this.source.publisherDisplayName,q.targetPlatform=this.source.properties.targetPlatform,q.updated=!!W,q.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,q.hasPreReleaseVersion=W?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,q.preRelease=(0,T.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||W?.preRelease,W&&W.type!==F.ExtensionType.System&&W.manifest.version===this.source.version?$=await this.extensionsScanner.updateMetadata(W,q):$=await this.unsetIfUninstalled(this.extensionKey);if(U.isCancellationRequested)throw(0,o.toExtensionManagementError)(new L.CancellationError);if(!$){const A=await this.extractExtensionFn(this.operation,U);$=A.local,this._verificationStatus=A.verificationStatus}if(this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.extensionsScannerService.initializeDefaultProfileExtensions()}catch(A){throw(0,o.toExtensionManagementError)(A,r.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(U.isCancellationRequested)throw(0,o.toExtensionManagementError)(new L.CancellationError);try{await this.extensionsProfileScannerService.addExtensionsToProfile([[$,q]],this.options.profileLocation,!$.isValid)}catch(A){throw(0,o.toExtensionManagementError)(A,r.ExtensionManagementErrorCode.AddToProfile)}const w=await this.getExistingExtension();if(!w)throw new r.ExtensionManagementError("Cannot find the installed extension",r.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof g.URI&&this.updateMetadata($,U),w}async unsetIfUninstalled(U){return(await this.extensionsScanner.getUninstalledExtensions())[U.toString()]?(this.logService.trace("Removing the extension from uninstalled list:",U.id),await this.extensionsScanner.setInstalled(U),this.logService.info("Removed the extension from uninstalled list:",U.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find($=>e.ExtensionKey.create($).equals(U))):void 0}async updateMetadata(U,W){try{let[q]=await this.galleryService.getExtensions([{id:U.identifier.id,version:U.manifest.version}],W);if(q||([q]=await this.galleryService.getExtensions([{id:U.identifier.id}],W)),q){const $={id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:U.hasPreReleaseVersion||q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(U,$,this.options.profileLocation)}}catch{}}};G=Se([re(6,le.IUriIdentityService),re(7,r.IExtensionGalleryService),re(8,B.IUserDataProfilesService),re(9,s.IExtensionsScannerService),re(10,n.IExtensionsProfileScannerService),re(11,ie.ILogService)],G);class J extends o.AbstractExtensionTask{constructor(U,W,q){super(),this.extension=U,this.profileLocation=W,this.extensionsProfileScannerService=q}async doRun(U){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(se[163],oe([0,1,6,24,23,19,42,10,18,12]),function(H,t,b,D,y,R,L,C,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsProfileScannerService=void 0;let a=class extends L.AbstractExtensionsProfileScannerService{constructor(h,m,S,T,g,d){super(l.URI.file(h.extensionsPath),m,S,T,g,d)}};t.ExtensionsProfileScannerService=a,t.ExtensionsProfileScannerService=a=Se([re(0,p.INativeEnvironmentService),re(1,C.IFileService),re(2,D.IUserDataProfilesService),re(3,y.IUriIdentityService),re(4,R.ITelemetryService),re(5,b.ILogService)],a)}),define(se[164],oe([0,1,12,18,42,54,10,11,6,33,23,24]),function(H,t,b,D,y,R,L,C,p,l,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScannerService=void 0;let h=class extends R.NativeExtensionsScannerService{constructor(S,T,g,d,v,P,E,u){super(b.URI.file(v.builtinExtensionsPath),b.URI.file(v.extensionsPath),v.userHome,S.defaultProfile,S,T,g,d,v,P,E,u)}};t.ExtensionsScannerService=h,t.ExtensionsScannerService=h=Se([re(0,c.IUserDataProfilesService),re(1,y.IExtensionsProfileScannerService),re(2,L.IFileService),re(3,p.ILogService),re(4,D.INativeEnvironmentService),re(5,l.IProductService),re(6,a.IUriIdentityService),re(7,C.IInstantiationService)],h)}),define(se[74],oe([0,1,8,5,2,132,3,93,11,24]),function(H,t,b,D,y,R,L,C,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.TARGET_KEY=t.IS_NEW_KEY=void 0,t.loadKeyTargets=m,t.isProfileUsingDefaultStorage=T,t.logStorage=d,t.IS_NEW_KEY="__$__isNewStorageMarker",t.TARGET_KEY="__$__targetStorageMarker",t.IStorageService=(0,p.createDecorator)("storageService");var a;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(a||(t.WillSaveStateReason=a={}));var c;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(c||(t.StorageScope=c={}));var h;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(h||(t.StorageTarget=h={}));function m(v){const P=v.get(t.TARGET_KEY);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class S extends y.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(P={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super(),this.options=P,this._onDidChangeValue=this._register(new D.PauseableEmitter),this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new b.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new y.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(P,E,u){return D.Event.filter(this._onDidChangeValue.event,i=>i.scope===P&&(E===void 0||i.key===E),u)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,b.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,y.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,E){const{key:u,external:i}=E;if(u===t.TARGET_KEY){switch(P){case c.APPLICATION:this._applicationKeyTargets=void 0;break;case c.PROFILE:this._profileKeyTargets=void 0;break;case c.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:P})}else this._onDidChangeValue.fire({scope:P,key:u,target:this.getKeyTargets(P)[u],external:i})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,E,u){return this.getStorage(E)?.get(P,u)}getBoolean(P,E,u){return this.getStorage(E)?.getBoolean(P,u)}getNumber(P,E,u){return this.getStorage(E)?.getNumber(P,u)}getObject(P,E,u){return this.getStorage(E)?.getObject(P,u)}storeAll(P,E){this.withPausedEmitters(()=>{for(const u of P)this.store(u.key,u.value,u.scope,u.target,E)})}store(P,E,u,i,o=!1){if((0,L.isUndefinedOrNull)(E)){this.remove(P,u,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,u,i),this.getStorage(u)?.set(P,E,o)})}remove(P,E,u=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(P,E,void 0),this.getStorage(E)?.delete(P,u)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,E){const u=[],i=this.getKeyTargets(P);for(const o of Object.keys(i))i[o]===E&&u.push(o);return u}updateKeyTarget(P,E,u,i=!1){const o=this.getKeyTargets(E);typeof u=="number"?o[P]!==u&&(o[P]=u,this.getStorage(E)?.set(t.TARGET_KEY,JSON.stringify(o),i)):typeof o[P]=="number"&&(delete o[P],this.getStorage(E)?.set(t.TARGET_KEY,JSON.stringify(o),i))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(c.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(c.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(c.APPLICATION)),this._applicationKeyTargets}getKeyTargets(P){switch(P){case c.APPLICATION:return this.applicationKeyTargets;case c.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(P){const E=this.getStorage(P);return E?m(E):Object.create(null)}isNew(P){return this.getBoolean(t.IS_NEW_KEY,P)===!0}async flush(P=a.NONE){this._onWillSaveState.fire({reason:P});const E=this.getStorage(c.APPLICATION),u=this.getStorage(c.PROFILE),i=this.getStorage(c.WORKSPACE);switch(P){case a.NONE:await b.Promises.settled([E?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case a.SHUTDOWN:await b.Promises.settled([E?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.getStorage(c.APPLICATION)?.items??new Map,E=this.getStorage(c.PROFILE)?.items??new Map,u=this.getStorage(c.WORKSPACE)?.items??new Map;return d(P,E,u,this.getLogDetails(c.APPLICATION)??"",this.getLogDetails(c.PROFILE)??"",this.getLogDetails(c.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.getStorage(P)?.optimize()}async switch(P,E){return this.emitWillSaveState(a.NONE),(0,l.isUserDataProfile)(P)?this.switchToProfile(P,E):this.switchToWorkspace(P,E)}canSwitchProfile(P,E){return!(P.id===E.id||T(E)&&T(P))}switchData(P,E,u){this.withPausedEmitters(()=>{const i=new Set;for(const[o,r]of P)i.add(o),E.get(o)!==r&&this.emitDidChangeValue(u,{key:o,external:!0});for(const[o]of E.items)i.has(o)||this.emitDidChangeValue(u,{key:o,external:!0})})}}t.AbstractStorageService=S;function T(v){return v.isDefault||!!v.useDefaultFlags?.globalState}class g extends S{constructor(){super(),this.applicationStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(c.WORKSPACE,P))),this._register(this.profileStorage.onDidChangeStorage(P=>this.emitDidChangeValue(c.PROFILE,P))),this._register(this.applicationStorage.onDidChangeStorage(P=>this.emitDidChangeValue(c.APPLICATION,P)))}getStorage(P){switch(P){case c.APPLICATION:return this.applicationStorage;case c.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(P){switch(P){case c.APPLICATION:return"inMemory (application)";case c.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(P){return!1}}t.InMemoryStorageService=g;async function d(v,P,E,u,i,o){const r=F=>{try{return JSON.parse(F)}catch{return F}},e=new Map,n=new Map;v.forEach((F,_)=>{e.set(_,F),n.set(_,r(F))});const s=new Map,f=new Map;P.forEach((F,_)=>{s.set(_,F),f.set(_,r(F))});const I=new Map,O=new Map;E.forEach((F,_)=>{I.set(_,F),O.set(_,r(F))}),console.group(u!==i?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const N=[];if(e.forEach((F,_)=>{N.push({key:_,value:F})}),console.table(N),console.groupEnd(),console.log(n),u!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const F=[];s.forEach((_,K)=>{F.push({key:K,value:_})}),console.table(F),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${o})`);const k=[];I.forEach((F,_)=>{k.push({key:_,value:F})}),console.table(k),console.groupEnd(),console.log(O)}}),define(se[165],oe([0,1,14,29,74]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=R;async function R(L,C,p){let l=p&&p.get("storage.serviceMachineId",y.StorageScope.APPLICATION)||null;if(l)return l;try{const c=(await C.readFile(L.serviceMachineIdResource)).value.toString();l=(0,D.isUUID)(c)?c:null}catch{l=null}if(!l){l=(0,D.generateUuid)();try{await C.writeFile(L.serviceMachineIdResource,b.VSBuffer.fromString(l))}catch{}}return p?.store("storage.serviceMachineId",l,y.StorageScope.APPLICATION,y.StorageTarget.MACHINE),l}}),define(se[166],oe([0,1,165,19,41]),function(H,t,b,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=R;async function R(L,C,p,l,a,c,h){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${C.nameShort})`};if((0,y.supportsTelemetry)(C,p)&&(0,y.getTelemetryLevel)(l)===D.TelemetryLevel.USAGE){const S=await(0,b.getServiceMachineId)(p,a,c);m["X-Market-User-Id"]=S,m["VSCode-SessionId"]=h.machineId||S}return m}}),define(se[167],oe([0,1,20,22,9,13,37,3,12,30,18,21,27,26,50,10,6,33,45,166,74,19,180]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S,T,g,d,v,P,E,u,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=void 0,t.sortExtensionVersions=Q;const o=R.isWeb?m.TargetPlatform.WEB:(0,c.getTargetPlatform)(R.platform,L.arch),r="X-Market-Search-Activity-Id";var e;(function(A){A[A.None=0]="None",A[A.IncludeVersions=1]="IncludeVersions",A[A.IncludeFiles=2]="IncludeFiles",A[A.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",A[A.IncludeSharedAccounts=8]="IncludeSharedAccounts",A[A.IncludeVersionProperties=16]="IncludeVersionProperties",A[A.ExcludeNonValidated=32]="ExcludeNonValidated",A[A.IncludeInstallationTargets=64]="IncludeInstallationTargets",A[A.IncludeAssetUri=128]="IncludeAssetUri",A[A.IncludeStatistics=256]="IncludeStatistics",A[A.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",A[A.Unpublished=4096]="Unpublished",A[A.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function n(...A){return String(A.reduce((x,V)=>x|V,0))}var s;(function(A){A[A.Tag=1]="Tag",A[A.ExtensionId=4]="ExtensionId",A[A.Category=5]="Category",A[A.ExtensionName=7]="ExtensionName",A[A.Target=8]="Target",A[A.Featured=9]="Featured",A[A.SearchText=10]="SearchText",A[A.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const f={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},I={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},N={pageNumber:1,pageSize:10,sortBy:c.SortBy.NoneOrRelevance,sortOrder:c.SortOrder.Default,flags:e.None,criteria:[],assetTypes:[]};class k{constructor(x=N){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(x,V=this.state.pageSize){return new k({...this.state,pageNumber:x,pageSize:V})}withFilter(x,...V){const Y=[...this.state.criteria,...V.length?V.map(X=>({filterType:x,value:X})):[{filterType:x}]];return new k({...this.state,criteria:Y})}withSortBy(x){return new k({...this.state,sortBy:x})}withSortOrder(x){return new k({...this.state,sortOrder:x})}withFlags(...x){return new k({...this.state,flags:x.reduce((V,Y)=>V|Y,0)})}withAssetTypes(...x){return new k({...this.state,assetTypes:x})}withSource(x){return new k({...this.state,source:x})}get raw(){const{criteria:x,pageNumber:V,pageSize:Y,sortBy:X,sortOrder:ne,flags:he,assetTypes:fe}=this.state;return{filters:[{criteria:x,pageNumber:V,pageSize:Y,sortBy:X,sortOrder:ne}],assetTypes:fe,flags:he}}get searchText(){const x=this.state.criteria.filter(V=>V.filterType===s.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function F(A,x){const V=(A||[]).filter(Y=>Y.statisticName===x)[0];return V?V.value:0}function _(A){const x="Microsoft.VisualStudio.Code.Translation.";return A.files.filter(Y=>Y.assetType.indexOf(x)===0).reduce((Y,X)=>{const ne=ie(A,X.assetType);return ne&&Y.push([X.assetType.substring(x.length),ne]),Y},[])}function K(A){if(A.properties){const x=A.properties.filter(X=>X.key===f.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Y=x.filter(X=>V.test(X.value))[0];return Y?{uri:Y.value,fallbackUri:Y.value}:null}return ie(A,f.Repository)}function ae(A){return{uri:`${A.fallbackAssetUri}/${f.VSIX}?redirect=true${A.targetPlatform?`&targetPlatform=${A.targetPlatform}`:""}`,fallbackUri:`${A.fallbackAssetUri}/${f.VSIX}${A.targetPlatform?`?targetPlatform=${A.targetPlatform}`:""}`}}function ie(A,x){return A.files.filter(Y=>Y.assetType===x)[0]?{uri:`${A.assetUri}/${x}${A.targetPlatform?`?targetPlatform=${A.targetPlatform}`:""}`,fallbackUri:`${A.fallbackAssetUri}/${x}${A.targetPlatform?`?targetPlatform=${A.targetPlatform}`:""}`}:null}function ce(A,x){const V=A.properties?A.properties.filter(X=>X.key===x):[],Y=V.length>0&&V[0].value;return Y?Y.split(",").map(X=>(0,h.adoptToGalleryExtensionId)(X)):[]}function ue(A){const x=A.properties?A.properties.filter(V=>V.key===I.Engine):[];return x.length>0&&x[0].value||""}function le(A){const x=A.properties?A.properties.filter(V=>V.key===I.PreRelease):[];return x.length>0&&x[0].value==="true"}function B(A){const x=A.properties?A.properties.filter(Y=>Y.key===I.LocalizedLanguages):[],V=x.length>0&&x[0].value||"";return V?V.split(","):[]}function Z(A){return A.properties?.find(x=>x.key===I.SponsorLink)?.value}function z(A){return A.properties?.find(x=>x.key===I.SupportLink)?.value}function M(A){return A.indexOf("preview")!==-1}function G(A){return A.targetPlatform?(0,c.toTargetPlatform)(A.targetPlatform):m.TargetPlatform.UNDEFINED}function J(A){const x=(0,b.distinct)(A.versions.map(G)),V=!!A.tags?.includes(c.WEB_EXTENSION_TAG),Y=x.indexOf(m.TargetPlatform.WEB);return V?Y===-1&&x.push(m.TargetPlatform.WEB):Y!==-1&&x.splice(Y,1),x}function Q(A,x){for(let V=0;V<A.length;V++){const Y=A[V];if(Y.version===A[V-1]?.version){let X=V;if(G(Y)===x)for(;X>0&&A[X-1].version===Y.version;)X--;X!==V&&(A.splice(V,1),A.splice(X,0,Y))}}return A}function U(A,x,V){A.telemetryData={index:x,querySource:V,queryActivityId:A.queryContext?.[r]}}function W(A,x,V,Y){const X=A.versions[0],ne={manifest:ie(x,f.Manifest),readme:ie(x,f.Details),changelog:ie(x,f.Changelog),license:ie(x,f.License),repository:K(x),download:ae(x),icon:ie(x,f.Icon),signature:ie(x,f.Signature),coreTranslations:_(x)};return{type:"gallery",identifier:{id:(0,h.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},name:A.extensionName,version:x.version,displayName:A.displayName,publisherId:A.publisher.publisherId,publisher:A.publisher.publisherName,publisherDisplayName:A.publisher.displayName,publisherDomain:A.publisher.domain?{link:A.publisher.domain,verified:!!A.publisher.isDomainVerified}:void 0,publisherSponsorLink:Z(X),description:A.shortDescription??"",installCount:F(A.statistics,"install"),rating:F(A.statistics,"averagerating"),ratingCount:F(A.statistics,"ratingcount"),categories:A.categories||[],tags:A.tags||[],releaseDate:Date.parse(A.releaseDate),lastUpdated:Date.parse(A.lastUpdated),allTargetPlatforms:V,assets:ne,properties:{dependencies:ce(x,I.Dependency),extensionPack:ce(x,I.ExtensionPack),engine:ue(x),localizedLanguages:B(x),targetPlatform:G(x),isPreReleaseVersion:le(x)},hasPreReleaseVersion:le(X),hasReleaseVersion:!0,preview:M(A.flags),isSigned:!!ne.signature,queryContext:Y,supportLink:z(X)}}let q=class{constructor(x,V,Y,X,ne,he,fe,ye){this.requestService=V,this.logService=Y,this.environmentService=X,this.telemetryService=ne,this.fileService=he,this.productService=fe,this.configurationService=ye;const me=fe.extensionsGallery,ge=me?.servicePPEUrl&&ye.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ge?me.servicePPEUrl:me?.serviceUrl,this.extensionsGallerySearchUrl=ge?void 0:me?.searchUrl,this.extensionsControlUrl=me?.controlUrl,this.commonHeadersPromise=(0,P.resolveMarketplaceHeaders)(fe.version,fe,this.environmentService,this.configurationService,this.fileService,x,this.telemetryService)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,V,Y){const X=D.CancellationToken.isCancellationToken(V)?{}:V,ne=D.CancellationToken.isCancellationToken(V)?V:Y,he=[],fe=[],ye=[],me=[];let ge=!0;for(const Ee of x){Ee.uuid?fe.push(Ee.uuid):he.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);ye.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&me.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),ge=ge&&!!Ee.hasPreRelease&&!Ce}if(!fe.length&&!he.length)return[];let de=new k().withPage(1,x.length);fe.length&&(de=de.withFilter(s.ExtensionId,...fe)),he.length&&(de=de.withFilter(s.ExtensionName,...he)),(X.queryAllVersions||ge)&&(de=de.withFlags(de.flags,e.IncludeVersions)),X.source&&(de=de.withSource(X.source));const{extensions:ve}=await this.queryGalleryExtensions(de,{targetPlatform:X.targetPlatform??o,includePreRelease:ye,versions:me,compatible:!!X.compatible,productVersion:X.productVersion??{version:this.productService.version,date:this.productService.date}},ne);return X.source&&ve.forEach((Ee,Ce)=>U(Ee,Ce,X.source)),ve}async getCompatibleExtension(x,V,Y,X={version:this.productService.version,date:this.productService.date}){if((0,c.isNotWebExtensionInWebTargetPlatform)(x.allTargetPlatforms,Y))return null;if(await this.isExtensionCompatible(x,V,Y))return x;const ne=new k().withFlags(e.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,x.identifier.uuid),{extensions:he}=await this.queryGalleryExtensions(ne,{targetPlatform:Y,compatible:!0,includePreRelease:V,productVersion:X},D.CancellationToken.None);return he[0]||null}async isExtensionCompatible(x,V,Y,X={version:this.productService.version,date:this.productService.date}){if(!(0,c.isTargetPlatformCompatible)(x.properties.targetPlatform,x.allTargetPlatforms,Y)||!V&&x.properties.isPreReleaseVersion)return!1;let ne=x.properties.engine;if(!ne){const he=await this.getManifest(x,D.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ne=he.engines.vscode}return(0,S.isEngineValid)(ne,X.version,X.date)}async isValidVersion(x,V,Y,X,ne,he,fe={version:this.productService.version,date:this.productService.date}){if(!(0,c.isTargetPlatformCompatible)(G(V),ne,he)||Y!=="any"&&le(V)!==(Y==="prerelease"))return!1;if(X)try{const ye=await this.getEngine(x,V);if(!(0,S.isEngineValid)(ye,fe.version,fe.date))return!1}catch(ye){return this.logService.error(`Error while getting the engine for the version ${V.version}.`,(0,y.getErrorMessage)(ye)),!1}return!0}async query(x,V){let Y=x.text||"";const X=x.pageSize??50;let ne=new k().withPage(1,X);Y?(Y=Y.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,ve)=>(ne=ne.withFilter(s.Category,ve||de),"")),Y=Y.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,ve)=>(ne=ne.withFilter(s.Tag,ve||de),"")),Y=Y.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(s.Featured),"")),Y=Y.trim(),Y&&(Y=Y.length<200?Y:Y.substring(0,200),ne=ne.withFilter(s.SearchText,Y)),ne=ne.withSortBy(c.SortBy.NoneOrRelevance)):x.ids?ne=ne.withFilter(s.ExtensionId,...x.ids):x.names?ne=ne.withFilter(s.ExtensionName,...x.names):ne=ne.withSortBy(c.SortBy.InstallCount),typeof x.sortBy=="number"&&(ne=ne.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(ne=ne.withSortOrder(x.sortOrder)),x.source&&(ne=ne.withSource(x.source));const he=async(ge,de)=>{const{extensions:ve,total:Ee}=await this.queryGalleryExtensions(ge,{targetPlatform:o,compatible:!1,includePreRelease:!!x.includePreRelease,productVersion:x.productVersion??{version:this.productService.version,date:this.productService.date}},de);return ve.forEach((Ce,j)=>U(Ce,(ge.pageNumber-1)*ge.pageSize+j,x.source)),{extensions:ve,total:Ee}},{extensions:fe,total:ye}=await he(ne,V),me=async(ge,de)=>{if(de.isCancellationRequested)throw new y.CancellationError;const{extensions:ve}=await he(ne.withPage(ge+1),de);return ve};return{firstPage:fe,total:ye,pageSize:ne.pageSize,getPage:me}}async queryGalleryExtensions(x,V,Y){const X=x.flags;x.flags&e.IncludeLatestVersionOnly&&x.flags&e.IncludeVersions&&(x=x.withFlags(x.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(x.flags&e.IncludeLatestVersionOnly)&&!(x.flags&e.IncludeVersions)&&(x=x.withFlags(x.flags,e.IncludeLatestVersionOnly)),V.versions?.length&&(x=x.withFlags(x.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),x=x.withFlags(x.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:ne,total:he,context:fe}=await this.queryRawGalleryExtensions(x,Y);if(!(x.flags&e.IncludeLatestVersionOnly)){const de=[];for(const ve of ne){const Ee=await this.toGalleryExtensionWithCriteria(ve,V,fe);Ee&&de.push(Ee)}return{extensions:de,total:he}}const me=[],ge=new Map;for(let de=0;de<ne.length;de++){const ve=ne[de],Ee={id:(0,h.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ce=(0,C.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(ee=>(0,h.areSameExtensions)(ee,Ee))?.includePreRelease;if(V.compatible&&(0,c.isNotWebExtensionInWebTargetPlatform)(J(ve),V.targetPlatform))continue;const j=await this.toGalleryExtensionWithCriteria(ve,V,fe);!j||j.properties.isPreReleaseVersion&&(!Ce||!j.hasReleaseVersion)||!j.properties.isPreReleaseVersion&&j.properties.targetPlatform!==V.targetPlatform&&j.hasPreReleaseVersion?ge.set(ve.extensionId,de):me.push([de,j])}if(ge.size){const de=new i.StopWatch,ve=new k().withFlags(X&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,ge.size).withFilter(s.ExtensionId,...ge.keys()),{extensions:Ee}=await this.queryGalleryExtensions(ve,V,Y);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:ge.size});for(const Ce of Ee){const j=ge.get(Ce.identifier.uuid);me.push([j,Ce])}}return{extensions:me.sort((de,ve)=>de[0]-ve[0]).map(([,de])=>de),total:he}}async toGalleryExtensionWithCriteria(x,V,Y){const X={id:(0,h.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},ne=V.versions?.find(me=>(0,h.areSameExtensions)(me,X))?.version,he=(0,C.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(me=>(0,h.areSameExtensions)(me,X))?.includePreRelease,fe=J(x),ye=Q(x.versions,V.targetPlatform);if(V.compatible&&(0,c.isNotWebExtensionInWebTargetPlatform)(fe,V.targetPlatform))return null;for(let me=0;me<ye.length;me++){const ge=ye[me];if(!(ne&&ge.version!==ne)){if(await this.isValidVersion((0,h.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),ge,he?"any":"release",V.compatible,fe,V.targetPlatform,V.productVersion))return W(x,ge,fe,Y);if(ne&&ge.version===ne)return null}}return ne||V.compatible?null:W(x,x.versions[0],fe)}async queryRawGalleryExtensions(x,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,e.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(e.Unpublished));const Y=await this.commonHeadersPromise,X=JSON.stringify(x.raw),ne={...Y,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},he=new i.StopWatch;let fe,ye,me=0;try{if(fe=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&x.criteria.some(de=>de.filterType===s.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:X,headers:ne},V),fe.res.statusCode&&fe.res.statusCode>=400&&fe.res.statusCode<500)return{galleryExtensions:[],total:me};const ge=await(0,v.asJson)(fe);if(ge){const de=ge.results[0],ve=de.extensions,Ee=de.resultMetadata&&de.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return me=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:me,context:{[r]:fe.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(ge){if((0,y.isCancellationError)(ge))throw ye=c.ExtensionGalleryErrorCode.Cancelled,ge;{const de=(0,y.getErrorMessage)(ge);throw ye=de.startsWith("XHR timeout")?c.ExtensionGalleryErrorCode.Timeout:c.ExtensionGalleryErrorCode.Failed,new c.ExtensionGalleryError(de,ye)}}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(X.length),duration:he.elapsed(),success:!!fe&&(0,v.isSuccess)(fe),responseBodySize:fe?.res.headers["Content-Length"],statusCode:fe?String(fe.res.statusCode):void 0,errorCode:ye,count:String(me)})}}async reportStatistic(x,V,Y,X){if(!this.isEnabled())return;const ne=R.isWeb?this.api(`/itemName/${x}.${V}/version/${Y}/statType/${X===c.StatisticType.Install?"1":"3"}/vscodewebextension`):this.api(`/publishers/${x}/extensions/${V}/${Y}/stats?statType=${X}`),he=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ye={...await this.commonHeadersPromise,Accept:he};try{await this.requestService.request({type:"POST",url:ne,headers:ye},D.CancellationToken.None)}catch{}}async download(x,V,Y){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const X=(0,h.getGalleryExtensionTelemetryData)(x),ne=new Date().getTime(),he=Y===c.InstallOperation.Install?"install":Y===c.InstallOperation.Update?"update":"",fe=he?{uri:`${x.assets.download.uri}${p.URI.parse(x.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${x.assets.download.fallbackUri}${p.URI.parse(x.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:x.assets.download,ye=x.queryContext?.[r]?{[r]:x.queryContext[r]}:void 0,me=await this.getAsset(x.identifier.id,fe,f.VSIX,ye?{headers:ye}:void 0);try{await this.fileService.writeFile(V,me.stream)}catch(ge){try{await this.fileService.del(V)}catch(de){this.logService.warn(`Error while deleting the file ${V.toString()}`,(0,y.getErrorMessage)(de))}throw new c.ExtensionGalleryError((0,y.getErrorMessage)(ge),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:new Date().getTime()-ne})}async downloadSignatureArchive(x,V){if(!x.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",x.identifier.id);const Y=await this.getAsset(x.identifier.id,x.assets.signature,f.Signature);try{await this.fileService.writeFile(V,Y.stream)}catch(X){try{await this.fileService.del(V)}catch(ne){this.logService.warn(`Error while deleting the file ${V.toString()}`,(0,y.getErrorMessage)(ne))}throw new c.ExtensionGalleryError((0,y.getErrorMessage)(X),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(x,V){if(x.assets.readme){const Y=await this.getAsset(x.identifier.id,x.assets.readme,f.Details,{},V);return await(0,v.asTextOrError)(Y)||""}return""}async getManifest(x,V){if(x.assets.manifest){const Y=await this.getAsset(x.identifier.id,x.assets.manifest,f.Manifest,{},V),X=await(0,v.asTextOrError)(Y);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(x,V,Y){const X=ie(V,f.Manifest);if(!X)throw new Error("Manifest was not found");const ne={"Accept-Encoding":"gzip"},he=await this.getAsset(x,X,f.Manifest,{headers:ne});return await(0,v.asJson)(he)}async getCoreTranslation(x,V){const Y=x.assets.coreTranslations.filter(X=>X[0]===V.toUpperCase())[0];if(Y){const X=await this.getAsset(x.identifier.id,Y[1],Y[0]),ne=await(0,v.asTextOrError)(X);return ne?JSON.parse(ne):null}return null}async getChangelog(x,V){if(x.assets.changelog){const Y=await this.getAsset(x.identifier.id,x.assets.changelog,f.Changelog,{},V);return await(0,v.asTextOrError)(Y)||""}return""}async getAllCompatibleVersions(x,V,Y){let X=new k().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);x.identifier.uuid?X=X.withFilter(s.ExtensionId,x.identifier.uuid):X=X.withFilter(s.ExtensionName,x.identifier.id);const{galleryExtensions:ne}=await this.queryRawGalleryExtensions(X,D.CancellationToken.None);if(!ne.length)return[];const he=J(ne[0]);if((0,c.isNotWebExtensionInWebTargetPlatform)(he,Y))return[];const fe=[];await Promise.all(ne[0].versions.map(async ge=>{try{await this.isValidVersion(x.identifier.id,ge,V?"any":"release",!0,he,Y)&&fe.push(ge)}catch{}}));const ye=[],me=new Set;for(const ge of Q(fe,Y))me.has(ge.version)||(me.add(ge.version),ye.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return ye}async getAsset(x,V,Y,X={},ne=D.CancellationToken.None){const he=await this.commonHeadersPromise,fe={type:"GET"},ye={...he,...X.headers||{}};X={...X,...fe,headers:ye};const me=V.uri,ge=V.fallbackUri,de={...X,url:me};try{const ve=await this.requestService.request(de,ne);if(ve.res.statusCode===200)return ve;const Ee=await(0,v.asTextOrError)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${Ee}`)}catch(ve){if((0,y.isCancellationError)(ve))throw ve;const Ee=(0,y.getErrorMessage)(ve);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:x,assetType:Y,message:Ee});const Ce={...X,url:ge};return this.requestService.request(Ce,ne)}}async getEngine(x,V){let Y=ue(V);if(!Y){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:x,version:V.version});const X=await this.getManifestFromRawExtensionVersion(x,V,D.CancellationToken.None);if(!X)throw new Error("Manifest was not found");Y=X.engines.vscode}return Y}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,v.asJson)(x),Y=[],X={},ne=[];if(V){for(const he of V.malicious)Y.push({id:he});if(V.migrateToPreRelease)for(const[he,fe]of Object.entries(V.migrateToPreRelease))(!fe.engine||(0,S.isEngineValid)(fe.engine,this.productService.version,this.productService.date))&&(X[he.toLowerCase()]={disallowInstall:!0,extension:{id:fe.id,displayName:fe.displayName,autoMigrate:{storage:!!fe.migrateStorage},preRelease:!0}});if(V.deprecated)for(const[he,fe]of Object.entries(V.deprecated))fe&&(X[he.toLowerCase()]=(0,C.isBoolean)(fe)?{}:fe);if(V.search)for(const he of V.search)ne.push(he)}return{malicious:Y,deprecated:X,search:ne}}};q=Se([re(1,v.IRequestService),re(2,g.ILogService),re(3,a.IEnvironmentService),re(4,u.ITelemetryService),re(5,T.IFileService),re(6,d.IProductService),re(7,l.IConfigurationService)],q);let $=class extends q{constructor(x,V,Y,X,ne,he,fe,ye){super(x,V,Y,X,ne,he,fe,ye)}};t.ExtensionGalleryService=$,t.ExtensionGalleryService=$=Se([re(0,E.IStorageService),re(1,v.IRequestService),re(2,g.ILogService),re(3,a.IEnvironmentService),re(4,u.ITelemetryService),re(5,T.IFileService),re(6,d.IProductService),re(7,l.IConfigurationService)],$);let w=class extends q{constructor(x,V,Y,X,ne,he,fe){super(void 0,x,V,Y,X,ne,he,fe)}};t.ExtensionGalleryServiceWithNoStorageService=w,t.ExtensionGalleryServiceWithNoStorageService=w=Se([re(0,v.IRequestService),re(1,g.ILogService),re(2,a.IEnvironmentService),re(3,u.ITelemetryService),re(4,T.IFileService),re(5,d.IProductService),re(6,l.IConfigurationService)],w)}),define(se[168],oe([0,1,12,18,10,6,147,23,24,3,70]),function(H,t,b,D,y,R,L,C,p,l,a){"use strict";var c,h;Object.defineProperty(t,"__esModule",{value:!0}),t.ServerUserDataProfilesService=t.UserDataProfilesService=t.UserDataProfilesReadonlyService=void 0;let m=class extends p.UserDataProfilesService{static{c=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(d,v,P,E,u){super(P,E,v,u),this.stateReadonlyService=d,this.nativeEnvironmentService=P}getStoredProfiles(){return this.stateReadonlyService.getItem(c.PROFILES_KEY,[]).map(v=>({...v,location:(0,l.isString)(v.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,v.location):b.URI.revive(v.location)}))}getStoredProfileAssociations(){const d=this.stateReadonlyService.getItem(c.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(c.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?d:this.migrateStoredProfileAssociations(d)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(b.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};t.UserDataProfilesReadonlyService=m,t.UserDataProfilesReadonlyService=m=c=Se([re(0,L.IStateReadService),re(1,C.IUriIdentityService),re(2,D.INativeEnvironmentService),re(3,y.IFileService),re(4,R.ILogService)],m);let S=h=class extends m{constructor(d,v,P,E,u){super(d,v,P,E,u),this.stateService=d}saveStoredProfiles(d){d.length?this.stateService.setItem(h.PROFILES_KEY,d.map(v=>({...v,location:this.uriIdentityService.extUri.basename(v.location)}))):this.stateService.removeItem(h.PROFILES_KEY)}getStoredProfiles(){const d=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(d),this.stateService.setItem("userDataProfilesMigration",!0)),d}saveStoredProfileAssociations(d){d.emptyWindows||d.workspaces?this.stateService.setItem(h.PROFILE_ASSOCIATIONS_KEY,d):this.stateService.removeItem(h.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const d="workspaceAndProfileInfo",v=this.stateService.getItem(d,void 0);if(v){this.stateService.removeItem(d);const E=v.reduce((u,{workspace:i,profile:o})=>(u[b.URI.revive(i).toString()]=b.URI.revive(o).toString(),u),{});this.stateService.setItem(h.PROFILE_ASSOCIATIONS_KEY,{workspaces:E})}const P=super.getStoredProfileAssociations();return this.stateService.getItem(h.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(P),this.stateService.setItem(h.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),P}};t.UserDataProfilesService=S,t.UserDataProfilesService=S=h=Se([re(0,L.IStateService),re(1,C.IUriIdentityService),re(2,D.INativeEnvironmentService),re(3,y.IFileService),re(4,R.ILogService)],S);let T=class extends S{constructor(d,v,P,E){super(new a.StateService(a.SaveStrategy.IMMEDIATE,v,E,P),d,v,P,E)}async init(){return await this.stateService.init(),super.init()}};t.ServerUserDataProfilesService=T,t.ServerUserDataProfilesService=T=Se([re(0,C.IUriIdentityService),re(1,D.INativeEnvironmentService),re(2,y.IFileService),re(3,R.ILogService)],T)}),define(se[169],oe([0,1,145,8,14,9,3,30,18,146,6,45,144,181]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0,t.nodeRequest=g;let S=class extends c.AbstractRequestService{constructor(v,P,E,u){super(u),this.configurationService=v,this.environmentService=P,this.logService=E,this.configure(),this._register(v.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.configure()}))}configure(){const v=this.configurationService.getValue("http");this.proxyUrl=v?.proxy,this.strictSSL=!!v?.proxyStrictSSL,this.authorization=v?.proxyAuthorization}async request(v,P){const{proxyUrl:E,strictSSL:u}=this;let i;try{i=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(e){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,R.getErrorMessage)(e)))}const o={...process.env,...i},r=v.agent?v.agent:await(0,h.getProxyAgent)(v.url||"",o,{proxyUrl:E,strictSSL:u});return v.agent=r,v.strictSSL=u,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(v.isChromiumNetwork?"electron":"node",v,()=>g(v,P))}async resolveProxy(v){}async loadCertificates(){return(await new Promise((P,E)=>{H(["@vscode/proxy-agent"],P,E)})).loadSystemCertificates({log:this.logService})}};t.RequestService=S,t.RequestService=S=Se([re(0,C.IConfigurationService),re(1,p.INativeEnvironmentService),re(2,a.ILogService),re(3,a.ILoggerService)],S);async function T(d){return((0,b.parse)(d.url).protocol==="https:"?await new Promise((E,u)=>{H(["https"],E,u)}):await new Promise((E,u)=>{H(["http"],E,u)})).request}async function g(d,v){return D.Promises.withAsyncBody(async(P,E)=>{const u=(0,b.parse)(d.url),i=d.getRawRequest?d.getRawRequest(d):await T(d),o={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,L.isBoolean)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(o.auth=d.user+":"+d.password);const r=i(o,e=>{const n=(0,L.isNumber)(d.followRedirects)?d.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)g({...d,url:e.headers.location,followRedirects:n-1},v).then(P,E);else{let s=e;!d.isChromiumNetwork&&e.headers["content-encoding"]==="gzip"&&(s=e.pipe((0,m.createGunzip)())),P({res:e,stream:(0,y.streamToBufferReadableStream)(s)})}});r.on("error",E),d.timeout&&r.setTimeout(d.timeout),d.isChromiumNetwork&&r.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&r.write(d.data),r.end(),v.onCancellationRequested(()=>{r.abort(),E(new R.CancellationError)})})}}),define(se[182],oe([0,1,35,8,36,9,2,15,16,13,37,12,25,30,141,62,143,18,120,167,21,72,148,42,54,162,164,10,131,133,51,129,65,69,150,6,137,39,138,153,33,45,169,70,71,19,152,41,154,155,23,157,24,168,156,163,134,136,4,158,183]),function(H,t,b,D,y,R,L,C,p,l,a,c,h,m,S,T,g,d,v,P,E,u,i,o,r,e,n,s,f,I,O,N,k,F,_,K,ae,ie,ce,ue,le,B,Z,z,M,G,J,Q,U,W,q,$,w,A,x,V,Y,X,ne,he,fe){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=me;class ye extends L.Disposable{constructor(de){super(),this.argv=de,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[de,ve]=await this.initServices();return de.invokeFunction(async Ee=>{const Ce=Ee.get(K.ILogService),j=Ee.get(s.IFileService),ee=Ee.get(d.INativeEnvironmentService),te=Ee.get(w.IUserDataProfilesService);Ce.info("CLI main",this.argv),this.registerErrorHandler(Ce),await this.doRun(ee,j,te,de),await Promise.all(ve.map(pe=>{(0,D.raceTimeout)(pe.flush(),1e3)}))})}async initServices(){const de=new k.ServiceCollection,ve={_serviceBrand:void 0,...ue.default};de.set(le.IProductService,ve);const Ee=new v.NativeEnvironmentService(this.argv,ve);de.set(d.INativeEnvironmentService,Ee),await Promise.all([this.allowWindowsUNCPath(Ee.appSettingsHome.with({scheme:C.Schemas.file}).fsPath),this.allowWindowsUNCPath(Ee.extensionsPath)].map(Pe=>Pe?h.Promises.mkdir(Pe,{recursive:!0}):void 0));const Ce=new X.LoggerService((0,K.getLogLevel)(Ee),Ee.logsHome);de.set(K.ILoggerService,Ce);const j=this._register(Ce.createLogger("cli",{name:(0,ne.localize)(0,null)})),ee=[];Ce.getLogLevel()===K.LogLevel.Trace&&ee.push(new K.ConsoleLogger(Ce.getLogLevel()));const te=this._register(new Y.LogService(j,ee));de.set(K.ILogService,te);const pe=this._register(new f.FileService(te));de.set(s.IFileService,pe);const we=this._register(new I.DiskFileSystemProvider(te));pe.registerProvider(C.Schemas.file,we);const Le=new $.UriIdentityService(pe);de.set(q.IUriIdentityService,Le);const be=new z.StateReadonlyService(z.SaveStrategy.DELAYED,Ee,te,pe),Ne=new A.UserDataProfilesReadonlyService(be,Le,Ee,pe,te);de.set(w.IUserDataProfilesService,Ne),pe.registerProvider(C.Schemas.vscodeUserData,new he.FileUserDataProvider(C.Schemas.file,we,C.Schemas.vscodeUserData,Ne,Le,te));const De=l.isWindows&&ve.win32RegValueName?this._register(new ce.NativePolicyService(te,ve.win32RegValueName)):Ee.policyFile?this._register(new ae.FilePolicyService(Ee.policyFile,pe,te)):new ie.NullPolicyService;de.set(ie.IPolicyService,De);const ke=this._register(new S.ConfigurationService(Ne.defaultProfile.settingsResource,pe,De,te));de.set(m.IConfigurationService,ke),await Promise.all([be.init(),ke.initialize()]);let Me;try{Me=await(0,x.resolveMachineId)(be,te)}catch(Pe){Pe.code!=="ENOENT"&&te.error(Pe)}const Te=await(0,x.resolveSqmId)(be,te),Ae=await(0,x.resolvedevDeviceId)(be,te);Ne.init(),de.set(q.IUriIdentityService,new $.UriIdentityService(pe));const Fe=new Z.RequestService(ke,Ee,te,Ce);de.set(B.IRequestService,Fe),de.set(T.IDownloadService,new O.SyncDescriptor(g.DownloadService,void 0,!0)),de.set(o.IExtensionsProfileScannerService,new O.SyncDescriptor(V.ExtensionsProfileScannerService,void 0,!0)),de.set(r.IExtensionsScannerService,new O.SyncDescriptor(n.ExtensionsScannerService,void 0,!0)),de.set(u.IExtensionSignatureVerificationService,new O.SyncDescriptor(u.ExtensionSignatureVerificationService,void 0,!0)),de.set(e.INativeServerExtensionManagementService,new O.SyncDescriptor(e.ExtensionManagementService,void 0,!0)),de.set(E.IExtensionGalleryService,new O.SyncDescriptor(P.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),de.set(F.ILanguagePackService,new O.SyncDescriptor(_.NativeLanguagePackService,void 0,!1));const Ue=[],Ie=(0,Q.isInternalTelemetry)(ve,ke);if((0,Q.supportsTelemetry)(ve,Ee)){ve.aiConfig&&ve.aiConfig.ariaKey&&Ue.push(new U.OneDataSystemAppender(Fe,Ie,"monacoworkbench",null,ve.aiConfig.ariaKey));const Pe={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,M.resolveCommonProperties)((0,b.release)(),(0,b.hostname)(),process.arch,ve.commit,ve.version,Me,Te,Ae,Ie),piiPaths:(0,Q.getPiiPathsFromEnvironment)(Ee)};de.set(G.ITelemetryService,new O.SyncDescriptor(J.TelemetryService,[Pe],!1))}else de.set(G.ITelemetryService,Q.NullTelemetryService);return[new N.InstantiationService(de),Ue]}allowWindowsUNCPath(de){if(l.isWindows){const ve=(0,fe.getUNCHost)(de);ve&&(0,fe.addUNCHostToAllowlist)(ve)}return de}registerErrorHandler(de){(0,R.setUnexpectedErrorHandler)(ve=>{const Ee=(0,y.toErrorMessage)(ve,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",ve=>{(0,R.isSigPipeError)(ve)||(0,R.onUnexpectedError)(ve)}),process.on("unhandledRejection",ve=>(0,R.onUnexpectedError)(ve))}async doRun(de,ve,Ee,Ce){let j;if(de.args.profile&&(j=Ee.profiles.find(te=>te.name===de.args.profile),!j))throw new Error(`Profile '${de.args.profile}' not found.`);const ee=(j??Ee.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return Ce.createInstance(i.ExtensionManagementCLI,new K.ConsoleLogger(K.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,ee);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const te={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:ee};return Ce.createInstance(i.ExtensionManagementCLI,new K.ConsoleLogger(K.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),te,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return Ce.createInstance(i.ExtensionManagementCLI,new K.ConsoleLogger(K.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,ee);if(this.argv["update-extensions"])return Ce.createInstance(i.ExtensionManagementCLI,new K.ConsoleLogger(K.LogLevel.Info,!1)).updateExtensions(ee);if(this.argv["locate-extension"])return Ce.createInstance(i.ExtensionManagementCLI,new K.ConsoleLogger(K.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,W.buildTelemetryMessage)(de.appRoot,de.extensionsPath))}}asExtensionIdOrVSIX(de){return de.map(ve=>/\.vsix$/i.test(ve)?c.URI.file((0,p.isAbsolute)(ve)?ve:(0,p.join)((0,a.cwd)(),ve)):ve)}}async function me(ge){const de=new ye(ge);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d98c6de73fb939f1eb4b8a500c569b858b2d297/core/vs/code/node/cliProcessMain.js.map
