/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","vs/platform/extensions/common/extensions","os","vs/base/common/charCode","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ue=function(ne){for(var e=[],D=0,a=ne.length;D<a;D++)e[D]=le[ne[D]];return e};define(le[129],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.isESM=void 0,e.isESM=!1;var D;(function(A){A[A.LoaderAvailable=1]="LoaderAvailable",A[A.BeginLoadingScript=10]="BeginLoadingScript",A[A.EndLoadingScriptOK=11]="EndLoadingScriptOK",A[A.EndLoadingScriptError=12]="EndLoadingScriptError",A[A.BeginInvokeFactory=21]="BeginInvokeFactory",A[A.EndInvokeFactory=22]="EndInvokeFactory",A[A.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",A[A.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",A[A.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",A[A.NodeEndNativeRequire=34]="NodeEndNativeRequire",A[A.CachedDataFound=60]="CachedDataFound",A[A.CachedDataMissed=61]="CachedDataMissed",A[A.CachedDataRejected=62]="CachedDataRejected",A[A.CachedDataCreated=63]="CachedDataCreated"})(D||(e.LoaderEventType=D={}));class a{static get(){const L=new Map,k=new Map,_=new Map,T=new Map;function y(c,g){c.has(g.detail)||c.set(g.detail,-g.timestamp)}function P(c,g){const f=c.get(g.detail);f&&(f>=0||c.set(g.detail,f+g.timestamp))}let S=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(S=ne.getStats().slice(0).sort((c,g)=>c.timestamp-g.timestamp));for(const c of S)switch(c.type){case D.BeginLoadingScript:y(L,c);break;case D.EndLoadingScriptOK:case D.EndLoadingScriptError:P(L,c);break;case D.BeginInvokeFactory:y(k,c);break;case D.EndInvokeFactory:P(k,c);break;case D.NodeBeginNativeRequire:y(_,c);break;case D.NodeEndNativeRequire:P(_,c);break;case D.NodeBeginEvaluatingScript:y(T,c);break;case D.NodeEndEvaluatingScript:P(T,c);break}let u=0;_.forEach(c=>u+=c);function p(c){const g=[];return c.forEach((f,h)=>g.push([h,f])),g}return{amdLoad:p(L),amdInvoke:p(k),nodeRequire:p(_),nodeEval:p(T),nodeRequireTotal:u}}static toMarkdownTable(L,k){let _="";const T=[];return L.forEach((y,P)=>{T[P]=y.length}),k.forEach(y=>{y.forEach((P,S)=>{typeof P>"u"&&(P=y[S]="-");const u=P.toString().length;T[S]=Math.max(u,T[S])})}),L.forEach((y,P)=>{_+=`| ${y+" ".repeat(T[P]-y.toString().length)} `}),_+=`|
`,L.forEach((y,P)=>{_+=`| ${"-".repeat(T[P])} `}),_+=`|
`,k.forEach(y=>{y.forEach((P,S)=>{typeof P<"u"&&(_+=`| ${P+" ".repeat(T[S]-P.toString().length)} `)}),_+=`|
`}),_}}e.LoaderStats=a}),define(le[130],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=D,e.findLastIdx=a,e.findLastMonotonous=A,e.findLastIdxMonotonous=L,e.findFirstMonotonous=k,e.findFirstIdxMonotonousOrArrLen=_,e.findFirstIdxMonotonous=T,e.findFirstMax=P,e.findLastMax=S,e.findFirstMin=u,e.findMaxIdx=p,e.mapFindFirst=c;function D(g,f){const h=a(g,f);if(h!==-1)return g[h]}function a(g,f,h=g.length-1){for(let E=h;E>=0;E--){const I=g[E];if(f(I))return E}return-1}function A(g,f){const h=L(g,f);return h===-1?void 0:g[h]}function L(g,f,h=0,E=g.length){let I=h,d=E;for(;I<d;){const v=Math.floor((I+d)/2);f(g[v])?I=v+1:d=v}return I-1}function k(g,f){const h=_(g,f);return h===g.length?void 0:g[h]}function _(g,f,h=0,E=g.length){let I=h,d=E;for(;I<d;){const v=Math.floor((I+d)/2);f(g[v])?d=v:I=v+1}return I}function T(g,f,h=0,E=g.length){const I=_(g,f,h,E);return I===g.length?-1:I}class y{static{this.assertInvariants=!1}constructor(f){this._array=f,this._findLastMonotonousLastIdx=0}findLastMonotonous(f){if(y.assertInvariants){if(this._prevFindLastPredicate){for(const E of this._array)if(this._prevFindLastPredicate(E)&&!f(E))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=f}const h=L(this._array,f,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=h+1,h===-1?void 0:this._array[h]}}e.MonotonousArray=y;function P(g,f){if(g.length===0)return;let h=g[0];for(let E=1;E<g.length;E++){const I=g[E];f(I,h)>0&&(h=I)}return h}function S(g,f){if(g.length===0)return;let h=g[0];for(let E=1;E<g.length;E++){const I=g[E];f(I,h)>=0&&(h=I)}return h}function u(g,f){return P(g,(h,E)=>-f(h,E))}function p(g,f){if(g.length===0)return-1;let h=0;for(let E=1;E<g.length;E++){const I=g[E];f(I,g[h])>0&&(h=E)}return h}function c(g,f){for(const h of g){const E=f(h);if(E!==void 0)return E}}}),define(le[39],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var D;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(D||(e.CharCode=D={}))}),define(le[131],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=D,e.diffSets=a,e.diffMaps=A,e.intersection=L;function D(k,_){const T=Object.create(null);for(const y of k){const P=_(y);let S=T[P];S||(S=T[P]=[]),S.push(y)}return T}function a(k,_){const T=[],y=[];for(const P of k)_.has(P)||T.push(P);for(const P of _)k.has(P)||y.push(P);return{removed:T,added:y}}function A(k,_){const T=[],y=[];for(const[P,S]of k)_.has(P)||T.push(S);for(const[P,S]of _)k.has(P)||y.push(S);return{removed:T,added:y}}function L(k,_){const T=new Set;for(const y of _)k.has(y)&&T.add(y);return T}}),define(le[88],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=a,e.debounce=A,e.throttle=L;function D(k){return(_,T,y)=>{let P=null,S=null;if(typeof y.value=="function"?(P="value",S=y.value):typeof y.get=="function"&&(P="get",S=y.get),!S)throw new Error("not supported");y[P]=k(S,T)}}function a(k,_,T){let y=null,P=null;if(typeof T.value=="function"?(y="value",P=T.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof T.get=="function"&&(y="get",P=T.get),!P)throw new Error("not supported");const S=`$memoize$${_}`;T[y]=function(...u){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[S]}}function A(k,_,T){return D((y,P)=>{const S=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...p){this[u]||(this[u]=T?T():void 0),clearTimeout(this[S]),_&&(this[u]=_(this[u],...p),p=[this[u]]),this[S]=setTimeout(()=>{y.apply(this,p),this[u]=T?T():void 0},k)}})}function L(k,_,T){return D((y,P)=>{const S=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,c=`$throttle$pending$${P}`;return function(...g){if(this[u]||(this[u]=T?T():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),_&&(this[u]=_(this[u],...g)),this[c])return;const f=this[p]+k;f<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[u]]),this[u]=T?T():void 0):(this[c]=!0,this[S]=setTimeout(()=>{this[c]=!1,this[p]=Date.now(),y.apply(this,[this[u]]),this[u]=T?T():void 0},f-Date.now()))}})}}),define(le[8],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=a,e.isSigPipeError=A,e.onUnexpectedError=L,e.onUnexpectedExternalError=k,e.transformErrorForSerialization=_,e.isCancellationError=y,e.canceled=S,e.illegalArgument=u,e.illegalState=p,e.getErrorMessage=g;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?I.isErrorNoTelemetry(t)?new I(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function a(v){e.errorHandler.setUnexpectedErrorHandler(v)}function A(v){if(!v||typeof v!="object")return!1;const t=v;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function L(v){y(v)||e.errorHandler.onUnexpectedError(v)}function k(v){y(v)||e.errorHandler.onUnexpectedExternalError(v)}function _(v){if(v instanceof Error){const{name:t,message:r}=v,s=v.stacktrace||v.stack;return{$isError:!0,name:t,message:r,stack:s,noTelemetry:I.isErrorNoTelemetry(v)}}return v}const T="Canceled";function y(v){return v instanceof P?!0:v instanceof Error&&v.name===T&&v.message===T}class P extends Error{constructor(){super(T),this.name=this.message}}e.CancellationError=P;function S(){const v=new Error(T);return v.name=v.message,v}function u(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}function p(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=c;function g(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=f;class h extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=h;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=E;class I extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof I)return t;const r=new I;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=I;class d extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.BugIndicatingError=d}),define(le[19],ue([0,1,8,130]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=A,e.tail2=L,e.equals=k,e.removeFastWithoutKeepingOrder=_,e.binarySearch=T,e.binarySearch2=y,e.quickSelect=P,e.groupBy=S,e.groupAdjacentBy=u,e.forEachAdjacent=p,e.forEachWithNeighbors=c,e.sortedDiff=g,e.delta=f,e.top=h,e.topAsync=E,e.coalesce=d,e.coalesceInPlace=v,e.move=t,e.isFalsyOrEmpty=r,e.isNonEmptyArray=s,e.distinct=i,e.uniqueFilter=n,e.firstOrDefault=o,e.lastOrDefault=l,e.commonPrefixLength=m,e.range=w,e.index=C,e.insert=b,e.remove=R,e.arrayInsert=U,e.shuffle=N,e.pushToStart=M,e.pushToEnd=F,e.pushMany=K,e.mapArrayOrNot=H,e.asArray=X,e.getRandomElement=j,e.insertInto=ie,e.splice=z,e.compareBy=se,e.tieBreakComparators=ce,e.reverseOrder=G;function A(x,q=0){return x[x.length-(1+q)]}function L(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function k(x,q,te=(Z,Y)=>Z===Y){if(x===q)return!0;if(!x||!q||x.length!==q.length)return!1;for(let Z=0,Y=x.length;Z<Y;Z++)if(!te(x[Z],q[Z]))return!1;return!0}function _(x,q){const te=x.length-1;q<te&&(x[q]=x[te]),x.pop()}function T(x,q,te){return y(x.length,Z=>te(x[Z],q))}function y(x,q){let te=0,Z=x-1;for(;te<=Z;){const Y=(te+Z)/2|0,ae=q(Y);if(ae<0)te=Y+1;else if(ae>0)Z=Y-1;else return Y}return-(te+1)}function P(x,q,te){if(x=x|0,x>=q.length)throw new TypeError("invalid index");const Z=q[Math.floor(q.length*Math.random())],Y=[],ae=[],he=[];for(const ge of q){const ve=te(ge,Z);ve<0?Y.push(ge):ve>0?ae.push(ge):he.push(ge)}return x<Y.length?P(x,Y,te):x<Y.length+he.length?he[0]:P(x-(Y.length+he.length),ae,te)}function S(x,q){const te=[];let Z;for(const Y of x.slice(0).sort(q))!Z||q(Z[0],Y)!==0?(Z=[Y],te.push(Z)):Z.push(Y);return te}function*u(x,q){let te,Z;for(const Y of x)Z!==void 0&&q(Z,Y)?te.push(Y):(te&&(yield te),te=[Y]),Z=Y;te&&(yield te)}function p(x,q){for(let te=0;te<=x.length;te++)q(te===0?void 0:x[te-1],te===x.length?void 0:x[te])}function c(x,q){for(let te=0;te<x.length;te++)q(te===0?void 0:x[te-1],x[te],te+1===x.length?void 0:x[te+1])}function g(x,q,te){const Z=[];function Y(ge,ve,Ie){if(ve===0&&Ie.length===0)return;const pe=Z[Z.length-1];pe&&pe.start+pe.deleteCount===ge?(pe.deleteCount+=ve,pe.toInsert.push(...Ie)):Z.push({start:ge,deleteCount:ve,toInsert:Ie})}let ae=0,he=0;for(;;){if(ae===x.length){Y(ae,0,q.slice(he));break}if(he===q.length){Y(ae,x.length-ae,[]);break}const ge=x[ae],ve=q[he],Ie=te(ge,ve);Ie===0?(ae+=1,he+=1):Ie<0?(Y(ae,1,[]),ae+=1):Ie>0&&(Y(ae,0,[ve]),he+=1)}return Z}function f(x,q,te){const Z=g(x,q,te),Y=[],ae=[];for(const he of Z)Y.push(...x.slice(he.start,he.start+he.deleteCount)),ae.push(...he.toInsert);return{removed:Y,added:ae}}function h(x,q,te){if(te===0)return[];const Z=x.slice(0,te).sort(q);return I(x,q,Z,te,x.length),Z}function E(x,q,te,Z,Y){return te===0?Promise.resolve([]):new Promise((ae,he)=>{(async()=>{const ge=x.length,ve=x.slice(0,te).sort(q);for(let Ie=te,pe=Math.min(te+Z,ge);Ie<ge;Ie=pe,pe=Math.min(pe+Z,ge)){if(Ie>te&&await new Promise(ye=>setTimeout(ye)),Y&&Y.isCancellationRequested)throw new D.CancellationError;I(x,q,ve,Ie,pe)}return ve})().then(ae,he)})}function I(x,q,te,Z,Y){for(const ae=te.length;Z<Y;Z++){const he=x[Z];if(q(he,te[ae-1])<0){te.pop();const ge=(0,a.findFirstIdxMonotonousOrArrLen)(te,ve=>q(he,ve)<0);te.splice(ge,0,he)}}}function d(x){return x.filter(q=>!!q)}function v(x){let q=0;for(let te=0;te<x.length;te++)x[te]&&(x[q]=x[te],q+=1);x.length=q}function t(x,q,te){x.splice(te,0,x.splice(q,1)[0])}function r(x){return!Array.isArray(x)||x.length===0}function s(x){return Array.isArray(x)&&x.length>0}function i(x,q=te=>te){const te=new Set;return x.filter(Z=>{const Y=q(Z);return te.has(Y)?!1:(te.add(Y),!0)})}function n(x){const q=new Set;return te=>{const Z=x(te);return q.has(Z)?!1:(q.add(Z),!0)}}function o(x,q){return x.length>0?x[0]:q}function l(x,q){return x.length>0?x[x.length-1]:q}function m(x,q,te=(Z,Y)=>Z===Y){let Z=0;for(let Y=0,ae=Math.min(x.length,q.length);Y<ae&&te(x[Y],q[Y]);Y++)Z++;return Z}function w(x,q){let te=typeof q=="number"?x:0;typeof q=="number"?te=x:(te=0,q=x);const Z=[];if(te<=q)for(let Y=te;Y<q;Y++)Z.push(Y);else for(let Y=te;Y>q;Y--)Z.push(Y);return Z}function C(x,q,te){return x.reduce((Z,Y)=>(Z[q(Y)]=te?te(Y):Y,Z),Object.create(null))}function b(x,q){return x.push(q),()=>R(x,q)}function R(x,q){const te=x.indexOf(q);if(te>-1)return x.splice(te,1),q}function U(x,q,te){const Z=x.slice(0,q),Y=x.slice(q);return Z.concat(te,Y)}function N(x,q){let te;if(typeof q=="number"){let Z=q;te=()=>{const Y=Math.sin(Z++)*179426549;return Y-Math.floor(Y)}}else te=Math.random;for(let Z=x.length-1;Z>0;Z-=1){const Y=Math.floor(te()*(Z+1)),ae=x[Z];x[Z]=x[Y],x[Y]=ae}}function M(x,q){const te=x.indexOf(q);te>-1&&(x.splice(te,1),x.unshift(q))}function F(x,q){const te=x.indexOf(q);te>-1&&(x.splice(te,1),x.push(q))}function K(x,q){for(const te of q)x.push(te)}function H(x,q){return Array.isArray(x)?x.map(q):q(x)}function X(x){return Array.isArray(x)?x:[x]}function j(x){return x[Math.floor(Math.random()*x.length)]}function ie(x,q,te){const Z=B(x,q),Y=x.length,ae=te.length;x.length=Y+ae;for(let he=Y-1;he>=Z;he--)x[he+ae]=x[he];for(let he=0;he<ae;he++)x[he+Z]=te[he]}function z(x,q,te,Z){const Y=B(x,q);let ae=x.splice(Y,te);return ae===void 0&&(ae=[]),ie(x,Y,Z),ae}function B(x,q){return q<0?Math.max(q+x.length,0):Math.min(q,x.length)}var ee;(function(x){function q(ae){return ae<0}x.isLessThan=q;function te(ae){return ae<=0}x.isLessThanOrEqual=te;function Z(ae){return ae>0}x.isGreaterThan=Z;function Y(ae){return ae===0}x.isNeitherLessOrGreaterThan=Y,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function se(x,q){return(te,Z)=>q(x(te),x(Z))}function ce(...x){return(q,te)=>{for(const Z of x){const Y=Z(q,te);if(!ee.isNeitherLessOrGreaterThan(Y))return Y}return ee.neitherLessOrGreaterThan}}const W=(x,q)=>x-q;e.numberComparator=W;const J=(x,q)=>(0,e.numberComparator)(x?1:0,q?1:0);e.booleanComparator=J;function G(x){return(q,te)=>-x(q,te)}class V{constructor(q){this.items=q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(q){let te=this.firstIdx;for(;te<this.items.length&&q(this.items[te]);)te++;const Z=te===this.firstIdx?null:this.items.slice(this.firstIdx,te);return this.firstIdx=te,Z}takeFromEndWhile(q){let te=this.lastIdx;for(;te>=0&&q(this.items[te]);)te--;const Z=te===this.lastIdx?null:this.items.slice(te+1,this.lastIdx+1);return this.lastIdx=te,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const q=this.items[this.firstIdx];return this.firstIdx++,q}removeLast(){const q=this.items[this.lastIdx];return this.lastIdx--,q}takeCount(q){const te=this.items.slice(this.firstIdx,this.firstIdx+q);return this.firstIdx+=q,te}}e.ArrayQueue=V;class O{static{this.empty=new O(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(te=>(q(te),!0))}toArray(){const q=[];return this.iterate(te=>(q.push(te),!0)),q}filter(q){return new O(te=>this.iterate(Z=>q(Z)?te(Z):!0))}map(q){return new O(te=>this.iterate(Z=>te(q(Z))))}some(q){let te=!1;return this.iterate(Z=>(te=q(Z),!te)),te}findFirst(q){let te;return this.iterate(Z=>q(Z)?(te=Z,!1):!0),te}findLast(q){let te;return this.iterate(Z=>(q(Z)&&(te=Z),!0)),te}findLastMaxBy(q){let te,Z=!0;return this.iterate(Y=>((Z||ee.isGreaterThan(q(Y,te)))&&(Z=!1,te=Y),!0)),te}}e.CallbackIterable=O;class ${constructor(q){this._indexMap=q}static createSortPermutation(q,te){const Z=Array.from(q.keys()).sort((Y,ae)=>te(q[Y],q[ae]));return new $(Z)}apply(q){return q.map((te,Z)=>q[this._indexMap[Z]])}inverse(){const q=this._indexMap.slice();for(let te=0;te<this._indexMap.length;te++)q[this._indexMap[te]]=te;return new $(q)}}e.Permutation=$}),define(le[132],ue([0,1,8]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.assertNever=A,e.assert=L,e.softAssert=k,e.assertFn=_,e.checkAdjacentItems=T;function a(y,P){if(!y)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}function A(y,P="Unreachable"){throw new Error(P)}function L(y,P="unexpected state"){if(!y)throw new D.BugIndicatingError(`Assertion Failed: ${P}`)}function k(y){y||(0,D.onUnexpectedError)(new D.BugIndicatingError("Soft Assertion Failed"))}function _(y){if(!y()){debugger;y(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}function T(y,P){let S=0;for(;S<y.length-1;){const u=y[S],p=y[S+1];if(!P(u,p))return!1;S++}return!0}}),define(le[89],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=D;function D(a,A){const L=this;let k=!1,_;return function(){if(k)return _;if(k=!0,A)try{_=a.apply(L,arguments)}finally{A()}else _=a.apply(L,arguments);return _}}}),define(le[62],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(a){function A(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}a.is=A;const L=Object.freeze([]);function k(){return L}a.empty=k;function*_(t){yield t}a.single=_;function T(t){return A(t)?t:_(t)}a.wrap=T;function y(t){return t||L}a.from=y;function*P(t){for(let r=t.length-1;r>=0;r--)yield t[r]}a.reverse=P;function S(t){return!t||t[Symbol.iterator]().next().done===!0}a.isEmpty=S;function u(t){return t[Symbol.iterator]().next().value}a.first=u;function p(t,r){for(const s of t)if(r(s))return!0;return!1}a.some=p;function c(t,r){for(const s of t)if(r(s))return s}a.find=c;function*g(t,r){for(const s of t)r(s)&&(yield s)}a.filter=g;function*f(t,r){let s=0;for(const i of t)yield r(i,s++)}a.map=f;function*h(...t){for(const r of t)yield*r}a.concat=h;function E(t,r,s){let i=s;for(const n of t)i=r(i,n);return i}a.reduce=E;function*I(t,r,s=t.length){for(r<0&&(r+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);r<s;r++)yield t[r]}a.slice=I;function d(t,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,t];const i=t[Symbol.iterator]();for(let n=0;n<r;n++){const o=i.next();if(o.done)return[s,a.empty()];s.push(o.value)}return[s,{[Symbol.iterator](){return i}}]}a.consume=d;async function v(t){const r=[];for await(const s of t)r.push(s);return Promise.resolve(r)}a.asyncToArray=v})(D||(e.Iterable=D={}))}),define(le[34],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=k,e.getLocation=S,e.parse=u,e.parseTree=p,e.findNodeAtLocation=c,e.getNodePath=g,e.getNodeValue=f,e.contains=h,e.findNodeAtOffset=E,e.visit=I,e.stripComments=d,e.getNodeType=v;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var a;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function k(t,r=!1){let s=0;const i=t.length;let n="",o=0,l=a.Unknown,m=D.None;function w(F){let K=0,H=0;for(;K<F;){const X=t.charCodeAt(s);if(X>=P._0&&X<=P._9)H=H*16+X-P._0;else if(X>=P.A&&X<=P.F)H=H*16+X-P.A+10;else if(X>=P.a&&X<=P.f)H=H*16+X-P.a+10;else break;s++,K++}return K<F&&(H=-1),H}function C(F){s=F,n="",o=0,l=a.Unknown,m=D.None}function b(){const F=s;if(t.charCodeAt(s)===P._0)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===P.dot)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return m=D.UnexpectedEndOfNumber,t.substring(F,s);let K=s;if(s<t.length&&(t.charCodeAt(s)===P.E||t.charCodeAt(s)===P.e))if(s++,(s<t.length&&t.charCodeAt(s)===P.plus||t.charCodeAt(s)===P.minus)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;K=s}else m=D.UnexpectedEndOfNumber;return t.substring(F,K)}function R(){let F="",K=s;for(;;){if(s>=i){F+=t.substring(K,s),m=D.UnexpectedEndOfString;break}const H=t.charCodeAt(s);if(H===P.doubleQuote){F+=t.substring(K,s),s++;break}if(H===P.backslash){if(F+=t.substring(K,s),s++,s>=i){m=D.UnexpectedEndOfString;break}switch(t.charCodeAt(s++)){case P.doubleQuote:F+='"';break;case P.backslash:F+="\\";break;case P.slash:F+="/";break;case P.b:F+="\b";break;case P.f:F+="\f";break;case P.n:F+=`
`;break;case P.r:F+="\r";break;case P.t:F+="	";break;case P.u:{const j=w(4);j>=0?F+=String.fromCharCode(j):m=D.InvalidUnicode;break}default:m=D.InvalidEscapeCharacter}K=s;continue}if(H>=0&&H<=31)if(T(H)){F+=t.substring(K,s),m=D.UnexpectedEndOfString;break}else m=D.InvalidCharacter;s++}return F}function U(){if(n="",m=D.None,o=s,s>=i)return o=i,l=a.EOF;let F=t.charCodeAt(s);if(_(F)){do s++,n+=String.fromCharCode(F),F=t.charCodeAt(s);while(_(F));return l=a.Trivia}if(T(F))return s++,n+=String.fromCharCode(F),F===P.carriageReturn&&t.charCodeAt(s)===P.lineFeed&&(s++,n+=`
`),l=a.LineBreakTrivia;switch(F){case P.openBrace:return s++,l=a.OpenBraceToken;case P.closeBrace:return s++,l=a.CloseBraceToken;case P.openBracket:return s++,l=a.OpenBracketToken;case P.closeBracket:return s++,l=a.CloseBracketToken;case P.colon:return s++,l=a.ColonToken;case P.comma:return s++,l=a.CommaToken;case P.doubleQuote:return s++,n=R(),l=a.StringLiteral;case P.slash:{const K=s-1;if(t.charCodeAt(s+1)===P.slash){for(s+=2;s<i&&!T(t.charCodeAt(s));)s++;return n=t.substring(K,s),l=a.LineCommentTrivia}if(t.charCodeAt(s+1)===P.asterisk){s+=2;const H=i-1;let X=!1;for(;s<H;){if(t.charCodeAt(s)===P.asterisk&&t.charCodeAt(s+1)===P.slash){s+=2,X=!0;break}s++}return X||(s++,m=D.UnexpectedEndOfComment),n=t.substring(K,s),l=a.BlockCommentTrivia}return n+=String.fromCharCode(F),s++,l=a.Unknown}case P.minus:if(n+=String.fromCharCode(F),s++,s===i||!y(t.charCodeAt(s)))return l=a.Unknown;case P._0:case P._1:case P._2:case P._3:case P._4:case P._5:case P._6:case P._7:case P._8:case P._9:return n+=b(),l=a.NumericLiteral;default:for(;s<i&&N(F);)s++,F=t.charCodeAt(s);if(o!==s){switch(n=t.substring(o,s),n){case"true":return l=a.TrueKeyword;case"false":return l=a.FalseKeyword;case"null":return l=a.NullKeyword}return l=a.Unknown}return n+=String.fromCharCode(F),s++,l=a.Unknown}}function N(F){if(_(F)||T(F))return!1;switch(F){case P.closeBrace:case P.closeBracket:case P.openBrace:case P.openBracket:case P.doubleQuote:case P.colon:case P.comma:case P.slash:return!1}return!0}function M(){let F;do F=U();while(F>=a.LineCommentTrivia&&F<=a.Trivia);return F}return{setPosition:C,getPosition:()=>s,scan:r?M:U,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>s-o,getTokenError:()=>m}}function _(t){return t===P.space||t===P.tab||t===P.verticalTab||t===P.formFeed||t===P.nonBreakingSpace||t===P.ogham||t>=P.enQuad&&t<=P.zeroWidthSpace||t===P.narrowNoBreakSpace||t===P.mathematicalSpace||t===P.ideographicSpace||t===P.byteOrderMark}function T(t){return t===P.lineFeed||t===P.carriageReturn||t===P.lineSeparator||t===P.paragraphSeparator}function y(t){return t>=P._0&&t<=P._9}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function S(t,r){const s=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function m(w,C,b,R){o.value=w,o.offset=C,o.length=b,o.type=R,o.colonOffset=void 0,n=o}try{I(t,{onObjectBegin:(w,C)=>{if(r<=w)throw i;n=void 0,l=r>w,s.push("")},onObjectProperty:(w,C,b)=>{if(r<C||(m(w,C,b,"property"),s[s.length-1]=w,r<=C+b))throw i},onObjectEnd:(w,C)=>{if(r<=w)throw i;n=void 0,s.pop()},onArrayBegin:(w,C)=>{if(r<=w)throw i;n=void 0,s.push(0)},onArrayEnd:(w,C)=>{if(r<=w)throw i;n=void 0,s.pop()},onLiteralValue:(w,C,b)=>{if(r<C||(m(w,C,b,v(w)),r<=C+b))throw i},onSeparator:(w,C,b)=>{if(r<=C)throw i;if(w===":"&&n&&n.type==="property")n.colonOffset=C,l=!1,n=void 0;else if(w===","){const R=s[s.length-1];typeof R=="number"?s[s.length-1]=R+1:(l=!0,s[s.length-1]=""),n=void 0}}})}catch(w){if(w!==i)throw w}return{path:s,previousNode:n,isAtPropertyKey:l,matches:w=>{let C=0;for(let b=0;C<w.length&&b<s.length;b++)if(w[C]===s[b]||w[C]==="*")C++;else if(w[C]!=="**")return!1;return C===w.length}}}function u(t,r=[],s=L.DEFAULT){let i=null,n=[];const o=[];function l(w){Array.isArray(n)?n.push(w):i!==null&&(n[i]=w)}return I(t,{onObjectBegin:()=>{const w={};l(w),o.push(n),n=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const w=[];l(w),o.push(n),n=w,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:l,onError:(w,C,b)=>{r.push({error:w,offset:C,length:b})}},s),n[0]}function p(t,r=[],s=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function o(w){return i.children.push(w),w}I(t,{onObjectBegin:w=>{i=o({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,C,b)=>{i=o({type:"property",offset:C,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:C,length:b,parent:i})},onObjectEnd:(w,C)=>{i.length=w+C-i.offset,i=i.parent,n(w+C)},onArrayBegin:(w,C)=>{i=o({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,C)=>{i.length=w+C-i.offset,i=i.parent,n(w+C)},onLiteralValue:(w,C,b)=>{o({type:v(w),offset:C,length:b,parent:i,value:w}),n(C+b)},onSeparator:(w,C,b)=>{i.type==="property"&&(w===":"?i.colonOffset=C:w===","&&n(C))},onError:(w,C,b)=>{r.push({error:w,offset:C,length:b})}},s);const m=i.children[0];return m&&delete m.parent,m}function c(t,r){if(!t)return;let s=t;for(const i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const o of s.children)if(Array.isArray(o.children)&&o.children[0].value===i){s=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const r=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=f(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function h(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}function E(t,r,s=!1){if(h(t,r,s)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=r;n++){const o=E(i[n],r,s);if(o)return o}return t}}function I(t,r,s=L.DEFAULT){const i=k(t,!1);function n(ce){return ce?()=>ce(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(ce){return ce?W=>ce(W,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(r.onObjectBegin),m=o(r.onObjectProperty),w=n(r.onObjectEnd),C=n(r.onArrayBegin),b=n(r.onArrayEnd),R=o(r.onLiteralValue),U=o(r.onSeparator),N=n(r.onComment),M=o(r.onError),F=s&&s.disallowComments,K=s&&s.allowTrailingComma;function H(){for(;;){const ce=i.scan();switch(i.getTokenError()){case D.InvalidUnicode:X(A.InvalidUnicode);break;case D.InvalidEscapeCharacter:X(A.InvalidEscapeCharacter);break;case D.UnexpectedEndOfNumber:X(A.UnexpectedEndOfNumber);break;case D.UnexpectedEndOfComment:F||X(A.UnexpectedEndOfComment);break;case D.UnexpectedEndOfString:X(A.UnexpectedEndOfString);break;case D.InvalidCharacter:X(A.InvalidCharacter);break}switch(ce){case a.LineCommentTrivia:case a.BlockCommentTrivia:F?X(A.InvalidCommentToken):N();break;case a.Unknown:X(A.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ce}}}function X(ce,W=[],J=[]){if(M(ce),W.length+J.length>0){let G=i.getToken();for(;G!==a.EOF;){if(W.indexOf(G)!==-1){H();break}else if(J.indexOf(G)!==-1)break;G=H()}}}function j(ce){const W=i.getTokenValue();return ce?R(W):m(W),H(),!0}function ie(){switch(i.getToken()){case a.NumericLiteral:{let ce=0;try{ce=JSON.parse(i.getTokenValue()),typeof ce!="number"&&(X(A.InvalidNumberFormat),ce=0)}catch{X(A.InvalidNumberFormat)}R(ce);break}case a.NullKeyword:R(null);break;case a.TrueKeyword:R(!0);break;case a.FalseKeyword:R(!1);break;default:return!1}return H(),!0}function z(){return i.getToken()!==a.StringLiteral?(X(A.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(j(!1),i.getToken()===a.ColonToken?(U(":"),H(),se()||X(A.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):X(A.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function B(){l(),H();let ce=!1;for(;i.getToken()!==a.CloseBraceToken&&i.getToken()!==a.EOF;){if(i.getToken()===a.CommaToken){if(ce||X(A.ValueExpected,[],[]),U(","),H(),i.getToken()===a.CloseBraceToken&&K)break}else ce&&X(A.CommaExpected,[],[]);z()||X(A.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ce=!0}return w(),i.getToken()!==a.CloseBraceToken?X(A.CloseBraceExpected,[a.CloseBraceToken],[]):H(),!0}function ee(){C(),H();let ce=!1;for(;i.getToken()!==a.CloseBracketToken&&i.getToken()!==a.EOF;){if(i.getToken()===a.CommaToken){if(ce||X(A.ValueExpected,[],[]),U(","),H(),i.getToken()===a.CloseBracketToken&&K)break}else ce&&X(A.CommaExpected,[],[]);se()||X(A.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ce=!0}return b(),i.getToken()!==a.CloseBracketToken?X(A.CloseBracketExpected,[a.CloseBracketToken],[]):H(),!0}function se(){switch(i.getToken()){case a.OpenBracketToken:return ee();case a.OpenBraceToken:return B();case a.StringLiteral:return j(!0);default:return ie()}}return H(),i.getToken()===a.EOF?s.allowEmptyContent?!0:(X(A.ValueExpected,[],[]),!1):se()?(i.getToken()!==a.EOF&&X(A.EndOfFileExpected,[],[]),!0):(X(A.ValueExpected,[],[]),!1)}function d(t,r){const s=k(t),i=[];let n,o=0,l;do switch(l=s.getPosition(),n=s.scan(),n){case a.LineCommentTrivia:case a.BlockCommentTrivia:case a.EOF:o!==l&&i.push(t.substring(o,l)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),o=s.getPosition();break}while(n!==a.EOF);return i.join("")}function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[46],ue([0,1,34]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=a,e.toFormattedString=A,e.getEOL=_,e.isEOL=T;function a(y,P,S){let u,p,c,g,f;if(P){for(g=P.offset,f=g+P.length,c=g;c>0&&!T(y,c-1);)c--;let l=f;for(;l<y.length&&!T(y,l);)l++;p=y.substring(c,l),u=k(p,S)}else p=y,u=0,c=0,g=0,f=y.length;const h=_(S,y);let E=!1,I=0,d;S.insertSpaces?d=L(" ",S.tabSize||4):d="	";const v=(0,D.createScanner)(p,!1);let t=!1;function r(){return h+L(d,u+I)}function s(){let l=v.scan();for(E=!1;l===D.SyntaxKind.Trivia||l===D.SyntaxKind.LineBreakTrivia;)E=E||l===D.SyntaxKind.LineBreakTrivia,l=v.scan();return t=l===D.SyntaxKind.Unknown||v.getTokenError()!==D.ScanError.None,l}const i=[];function n(l,m,w){!t&&m<f&&w>g&&y.substring(m,w)!==l&&i.push({offset:m,length:w-m,content:l})}let o=s();if(o!==D.SyntaxKind.EOF){const l=v.getTokenOffset()+c,m=L(d,u);n(m,c,l)}for(;o!==D.SyntaxKind.EOF;){let l=v.getTokenOffset()+v.getTokenLength()+c,m=s(),w="";for(;!E&&(m===D.SyntaxKind.LineCommentTrivia||m===D.SyntaxKind.BlockCommentTrivia);){const b=v.getTokenOffset()+c;n(" ",l,b),l=v.getTokenOffset()+v.getTokenLength()+c,w=m===D.SyntaxKind.LineCommentTrivia?r():"",m=s()}if(m===D.SyntaxKind.CloseBraceToken)o!==D.SyntaxKind.OpenBraceToken&&(I--,w=r());else if(m===D.SyntaxKind.CloseBracketToken)o!==D.SyntaxKind.OpenBracketToken&&(I--,w=r());else{switch(o){case D.SyntaxKind.OpenBracketToken:case D.SyntaxKind.OpenBraceToken:I++,w=r();break;case D.SyntaxKind.CommaToken:case D.SyntaxKind.LineCommentTrivia:w=r();break;case D.SyntaxKind.BlockCommentTrivia:E?w=r():w=" ";break;case D.SyntaxKind.ColonToken:w=" ";break;case D.SyntaxKind.StringLiteral:if(m===D.SyntaxKind.ColonToken){w="";break}case D.SyntaxKind.NullKeyword:case D.SyntaxKind.TrueKeyword:case D.SyntaxKind.FalseKeyword:case D.SyntaxKind.NumericLiteral:case D.SyntaxKind.CloseBraceToken:case D.SyntaxKind.CloseBracketToken:m===D.SyntaxKind.LineCommentTrivia||m===D.SyntaxKind.BlockCommentTrivia?w=" ":m!==D.SyntaxKind.CommaToken&&m!==D.SyntaxKind.EOF&&(t=!0);break;case D.SyntaxKind.Unknown:t=!0;break}E&&(m===D.SyntaxKind.LineCommentTrivia||m===D.SyntaxKind.BlockCommentTrivia)&&(w=r())}const C=v.getTokenOffset()+c;n(w,l,C),o=m}return i}function A(y,P){const S=JSON.stringify(y,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?S.replace(/\r\n|\r|\n/g,P.eol):S}function L(y,P){let S="";for(let u=0;u<P;u++)S+=y;return S}function k(y,P){let S=0,u=0;const p=P.tabSize||4;for(;S<y.length;){const c=y.charAt(S);if(c===" ")u++;else if(c==="	")u+=p;else break;S++}return Math.floor(u/p)}function _(y,P){for(let S=0;S<P.length;S++){const u=P.charAt(S);if(u==="\r")return S+1<P.length&&P.charAt(S+1)===`
`?`\r
`:"\r";if(u===`
`)return`
`}return y&&y.eol||`
`}function T(y,P){return`\r
`.indexOf(y.charAt(P))!==-1}}),define(le[63],ue([0,1,34,46]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=A,e.setProperty=L,e.withFormatting=k,e.applyEdit=_,e.applyEdits=T;function A(y,P,S){return L(y,P,void 0,S)}function L(y,P,S,u,p){const c=P.slice(),g=[],f=(0,D.parseTree)(y,g);let h,E;for(;c.length>0&&(E=c.pop(),h=(0,D.findNodeAtLocation)(f,c),h===void 0&&S!==void 0);)typeof E=="string"?S={[E]:S}:S=[S];if(h)if(h.type==="object"&&typeof E=="string"&&Array.isArray(h.children)){const I=(0,D.findNodeAtLocation)(h,[E]);if(I!==void 0)if(S===void 0){if(!I.parent)throw new Error("Malformed AST");const d=h.children.indexOf(I.parent);let v,t=I.parent.offset+I.parent.length;if(d>0){const r=h.children[d-1];v=r.offset+r.length}else v=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return k(y,{offset:v,length:t-v,content:""},u)}else return k(y,{offset:I.offset,length:I.length,content:JSON.stringify(S)},u);else{if(S===void 0)return[];const d=`${JSON.stringify(E)}: ${JSON.stringify(S)}`,v=p?p(h.children.map(r=>r.children[0].value)):h.children.length;let t;if(v>0){const r=h.children[v-1];t={offset:r.offset+r.length,length:0,content:","+d}}else h.children.length===0?t={offset:h.offset+1,length:0,content:d}:t={offset:h.offset+1,length:0,content:d+","};return k(y,t,u)}}else if(h.type==="array"&&typeof E=="number"&&Array.isArray(h.children))if(S!==void 0){const I=`${JSON.stringify(S)}`;let d;if(h.children.length===0||E===0)d={offset:h.offset+1,length:0,content:h.children.length===0?I:I+","};else{const v=E===-1||E>h.children.length?h.children.length:E,t=h.children[v-1];d={offset:t.offset+t.length,length:0,content:","+I}}return k(y,d,u)}else{const I=E,d=h.children[I];let v;if(h.children.length===1)v={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===I){const t=h.children[I-1],r=t.offset+t.length,s=h.offset+h.length;v={offset:r,length:s-2-r,content:""}}else v={offset:d.offset,length:h.children[I+1].offset-d.offset,content:""};return k(y,v,u)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${h.type}`);else return S===void 0?[]:k(y,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(S)},u)}function k(y,P,S){let u=_(y,P),p=P.offset,c=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;p>0&&!(0,a.isEOL)(u,p-1);)p--;for(;c<u.length&&!(0,a.isEOL)(u,c);)c++}const g=(0,a.format)(u,{offset:p,length:c-p},S);for(let h=g.length-1;h>=0;h--){const E=g[h];u=_(u,E),p=Math.min(p,E.offset),c=Math.max(c,E.offset+E.length),c+=E.content.length-E.length}const f=y.length-(u.length-c)-p;return[{offset:p,length:f,content:u.substring(p,c)}]}function _(y,P){return y.substring(0,P.offset)+P.content+y.substring(P.offset+P.length)}function T(y,P){const S=P.slice(0).sort((p,c)=>{const g=p.offset-c.offset;return g===0?p.length-c.length:g});let u=y.length;for(let p=S.length-1;p>=0;p--){const c=S[p];if(c.offset+c.length<=u)y=_(y,c);else throw new Error("Overlapping edit");u=c.offset}return y}}),define(le[54],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(A){this.executor=A,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=D}),define(le[90],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{static{this.Undefined=new D(void 0)}constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}class a{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let L=this._first;for(;L!==D.Undefined;){const k=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=k}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,k){const _=new D(L);if(this._first===D.Undefined)this._first=_,this._last=_;else if(k){const y=this._last;this._last=_,_.prev=y,y.next=_}else{const y=this._first;this._first=_,_.next=y,y.prev=_}this._size+=1;let T=!1;return()=>{T||(T=!0,this._remove(_))}}shift(){if(this._first!==D.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==D.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const k=L.prev;k.next=L.next,L.next.prev=k}else L.prev===D.Undefined&&L.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):L.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):L.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.LinkedList=a}),define(le[35],ue([0,1]),function(ne,e){"use strict";var D,a,A;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=L,e.mapToString=k,e.setToString=_,e.mapsStrictEqualIgnoreOrder=d;function L(v,t,r){let s=v.get(t);return s===void 0&&(s=r,v.set(t,s)),s}function k(v){const t=[];return v.forEach((r,s)=>{t.push(`${s} => ${r}`)}),`Map(${v.size}) {${t.join(", ")}}`}function _(v){const t=[];return v.forEach(r=>{t.push(r)}),`Set(${v.size}) {${t.join(", ")}}`}class T{constructor(t,r){this.uri=t,this.value=r}}function y(v){return Array.isArray(v)}class P{static{this.defaultToKey=t=>t.toString()}constructor(t,r){if(this[D]="ResourceMap",t instanceof P)this.map=new Map(t.map),this.toKey=r??P.defaultToKey;else if(y(t)){this.map=new Map,this.toKey=r??P.defaultToKey;for(const[s,i]of t)this.set(s,i)}else this.map=new Map,this.toKey=t??P.defaultToKey}set(t,r){return this.map.set(this.toKey(t),new T(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[s,i]of this.map)t(i.value,i.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=P;class S{constructor(t,r){this[a]="ResourceSet",!t||typeof t=="function"?this._map=new P(t):(this._map=new P(r),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,r){this._map.forEach((s,i)=>t.call(r,i,i,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=S;var u;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class p{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=u.None){const s=this._map.get(t);if(s)return r!==u.None&&this.touch(s,r),s.value}set(t,r,s=u.None){let i=this._map.get(t);if(i)i.value=r,s!==u.None&&this.touch(i,s);else{switch(i={key:t,value:r,next:void 0,previous:void 0},s){case u.None:this.addItemLast(i);break;case u.AsOld:this.addItemFirst(i);break;case u.AsNew:this.addItemLast(i);break;default:this.addItemLast(i);break}this._map.set(t,i),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const s=this._state;let i=this._head;for(;i;){if(r?t.bind(r)(i.value,i.key,this):t(i.value,i.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,r=this._state;let s=this._head;const i={[Symbol.iterator](){return i},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const n={value:s.key,done:!1};return s=s.next,n}else return{value:void 0,done:!0}}};return i}values(){const t=this,r=this._state;let s=this._head;const i={[Symbol.iterator](){return i},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const n={value:s.value,done:!1};return s=s.next,n}else return{value:void 0,done:!0}}};return i}entries(){const t=this,r=this._state;let s=this._head;const i={[Symbol.iterator](){return i},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const n={value:[s.key,s.value],done:!1};return s=s.next,n}else return{value:void 0,done:!0}}};return i}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,s=this.size;for(;r&&s>t;)this._map.delete(r.key),r=r.next,s--;this._head=r,this._size=s,r&&(r.previous=void 0),this._state++}trimNew(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._tail,s=this.size;for(;r&&s>t;)this._map.delete(r.key),r=r.previous,s--;this._tail=r,this._size=s,r&&(r.next=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,s=t.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==u.AsOld&&r!==u.AsNew)){if(r===u.AsOld){if(t===this._head)return;const s=t.next,i=t.previous;t===this._tail?(i.next=void 0,this._tail=i):(s.previous=i,i.next=s),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===u.AsNew){if(t===this._tail)return;const s=t.next,i=t.previous;t===this._head?(s.previous=void 0,this._head=s):(s.previous=i,i.next=s),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,s)=>{t.push([s,r])}),t}fromJSON(t){this.clear();for(const[r,s]of t)this.set(r,s)}}e.LinkedMap=p;class c extends p{constructor(t,r=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=u.AsNew){return super.get(t,r)}peek(t){return super.get(t,u.None)}set(t,r){return super.set(t,r,u.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class g extends c{constructor(t,r=1){super(t,r)}trim(t){this.trimOld(t)}set(t,r){return super.set(t,r),this.checkTrim(),this}}e.LRUCache=g;class f extends c{constructor(t,r=1){super(t,r)}trim(t){this.trimNew(t)}set(t,r){return this._limit<=this.size&&!this.has(t)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(t,r),this}}e.MRUCache=f;class h{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let r=this.map.get(t)||0;return r===0?!1:(r--,r===0?this.map.delete(t):this.map.set(t,r),!0)}has(t){return this.map.has(t)}}e.CounterSet=h;class E{constructor(t){if(this._m1=new Map,this._m2=new Map,t)for(const[r,s]of t)this.set(r,s)}clear(){this._m1.clear(),this._m2.clear()}set(t,r){this._m1.set(t,r),this._m2.set(r,t)}get(t){return this._m1.get(t)}getKey(t){return this._m2.get(t)}delete(t){const r=this._m1.get(t);return r===void 0?!1:(this._m1.delete(t),this._m2.delete(r),!0)}forEach(t,r){this._m1.forEach((s,i)=>{t.call(r,s,i,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=E;class I{constructor(){this.map=new Map}add(t,r){let s=this.map.get(t);s||(s=new Set,this.map.set(t,s)),s.add(r)}delete(t,r){const s=this.map.get(t);s&&(s.delete(r),s.size===0&&this.map.delete(t))}forEach(t,r){const s=this.map.get(t);s&&s.forEach(r)}get(t){const r=this.map.get(t);return r||new Set}}e.SetMap=I;function d(v,t){if(v===t)return!0;if(v.size!==t.size)return!1;for(const[r,s]of v)if(!t.has(r)||t.get(r)!==s)return!1;for(const[r]of t)if(!v.has(r))return!1;return!0}}),define(le[2],ue([0,1,19,131,35,89,62]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=P,e.trackDisposable=S,e.markAsDisposed=u,e.markAsSingleton=g,e.isDisposable=f,e.dispose=h,e.disposeIfDisposable=E,e.combinedDisposable=I,e.toDisposable=d,e.disposeOnReturn=w;const _=!1;let T=null;class y{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(R){let U=this.livingDisposables.get(R);return U||(U={parent:null,source:null,isSingleton:!1,value:R,idx:y.idx++},this.livingDisposables.set(R,U)),U}trackDisposable(R){const U=this.getDisposableData(R);U.source||(U.source=new Error().stack)}setParent(R,U){const N=this.getDisposableData(R);N.parent=U}markAsDisposed(R){this.livingDisposables.delete(R)}markAsSingleton(R){this.getDisposableData(R).isSingleton=!0}getRootParent(R,U){const N=U.get(R);if(N)return N;const M=R.parent?this.getRootParent(this.getDisposableData(R.parent),U):R;return U.set(R,M),M}getTrackedDisposables(){const R=new Map;return[...this.livingDisposables.entries()].filter(([,N])=>N.source!==null&&!this.getRootParent(N,R).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(R=10,U){let N;if(U)N=U;else{const X=new Map,j=[...this.livingDisposables.values()].filter(z=>z.source!==null&&!this.getRootParent(z,X).isSingleton);if(j.length===0)return;const ie=new Set(j.map(z=>z.value));if(N=j.filter(z=>!(z.parent&&ie.has(z.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function M(X){function j(z,B){for(;z.length>0&&B.some(ee=>typeof ee=="string"?ee===z[0]:z[0].match(ee));)z.shift()}const ie=X.source.split(`
`).map(z=>z.trim().replace("at ","")).filter(z=>z!=="");return j(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const F=new A.SetMap;for(const X of N){const j=M(X);for(let ie=0;ie<=j.length;ie++)F.add(j.slice(0,ie).join(`
`),X)}N.sort((0,D.compareBy)(X=>X.idx,D.numberComparator));let K="",H=0;for(const X of N.slice(0,R)){H++;const j=M(X),ie=[];for(let z=0;z<j.length;z++){let B=j[z];B=`(shared with ${F.get(j.slice(0,z+1).join(`
`)).size}/${N.length} leaks) at ${B}`;const se=F.get(j.slice(0,z).join(`
`)),ce=(0,a.groupBy)([...se].map(W=>M(W)[z]),W=>W);delete ce[j[z]];for(const[W,J]of Object.entries(ce))ie.unshift(`    - stacktraces of ${J.length} other leaks continue with ${W}`);ie.unshift(B)}K+=`


==================== Leaking disposable ${H}/${N.length}: ${X.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return N.length>R&&(K+=`


... and ${N.length-R} more leaking disposables

`),{leaks:N,details:K}}}e.DisposableTracker=y;function P(b){T=b}if(_){const b="__is_disposable_tracked__";P(new class{trackDisposable(R){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[b]||console.log(U)},3e3)}setParent(R,U){if(R&&R!==t.None)try{R[b]=!0}catch{}}markAsDisposed(R){if(R&&R!==t.None)try{R[b]=!0}catch{}}markAsSingleton(R){}})}function S(b){return T?.trackDisposable(b),b}function u(b){T?.markAsDisposed(b)}function p(b,R){T?.setParent(b,R)}function c(b,R){if(T)for(const U of b)T.setParent(U,R)}function g(b){return T?.markAsSingleton(b),b}function f(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function h(b){if(k.Iterable.is(b)){const R=[];for(const U of b)if(U)try{U.dispose()}catch(N){R.push(N)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function E(b){for(const R of b)f(R)&&R.dispose();return[]}function I(...b){const R=d(()=>h(b));return c(b,R),R}function d(b){const R=S({dispose:(0,L.createSingleCallFunction)(()=>{u(R),b()})});return R}class v{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return p(R,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(R),R.dispose()}}deleteAndLeak(R){R&&this._toDispose.has(R)&&(this._toDispose.delete(R),p(R,null))}}e.DisposableStore=v;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new v,S(this),p(this._store,this)}dispose(){u(this),this._store.dispose()}_register(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(R)}}e.Disposable=t;class r{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(R){this._isDisposed||R===this._value||(this._value?.dispose(),R&&p(R,this),this._value=R)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const R=this._value;return this._value=void 0,R&&p(R,null),R}}e.MutableDisposable=r;class s{constructor(R){this._disposable=new r,this._isDisposed=!1,this._disposable.value=R}get value(){return this._disposable.value}set value(R){this._isDisposed||R===this._disposable.value||(this._disposable.value=R)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=s;class i{constructor(R){this._disposable=R,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(R){let U=R;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,u(this))},this}}e.SafeDisposable=n;class o{constructor(){this.references=new Map}acquire(R,...U){let N=this.references.get(R);N||(N={counter:0,object:this.createReferencedObject(R,...U)},this.references.set(R,N));const{object:M}=N,F=(0,L.createSingleCallFunction)(()=>{--N.counter===0&&(this.destroyReferencedObject(R,N.object),this.references.delete(R))});return N.counter++,{object:M,dispose:F}}}e.ReferenceCollection=o;class l{constructor(R){this.referenceCollection=R}async acquire(R,...U){const N=this.referenceCollection.acquire(R,...U);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(M){throw N.dispose(),M}}}e.AsyncReferenceCollection=l;class m{constructor(R){this.object=R}dispose(){}}e.ImmortalReference=m;function w(b){const R=new v;try{b(R)}finally{R.dispose()}}class C{constructor(){this._store=new Map,this._isDisposed=!1,S(this)}dispose(){u(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{h(this._store.values())}finally{this._store.clear()}}has(R){return this._store.has(R)}get size(){return this._store.size}get(R){return this._store.get(R)}set(R,U,N=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this._store.get(R)?.dispose(),this._store.set(R,U)}deleteAndDispose(R){this._store.get(R)?.dispose(),this._store.delete(R)}deleteAndLeak(R){const U=this._store.get(R);return this._store.delete(R),U}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=C}),define(le[64],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var D;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(D||(e.MarshalledId=D={}))}),define(le[91],ue([0,1,35]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=A,e.normalizeNFD=k;const a=new D.LRUCache(1e4);function A(y){return T(y,"NFC",a)}const L=new D.LRUCache(1e4);function k(y){return T(y,"NFD",L)}const _=/[^\u0000-\u0080]/;function T(y,P,S){if(!y)return y;const u=S.get(y);if(u)return u;let p;return _.test(y)?p=y.normalize(P):p=y,S.set(y,p),p}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(P){return k(P).replace(y,"")}}()}),function(){function ne(A){const L=[];typeof A=="number"&&L.push("code/timeOrigin",A);function k(T){L.push(T,Date.now())}function _(){const T=[];for(let y=0;y<L.length;y+=2)T.push({name:L[y],startTime:L[y+1]});return T}return{mark:k,getMarks:_}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const k of performance.getEntriesByType("mark"))L.push({name:k.name,startTime:Math.round(A+k.startTime)});return L}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function D(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=D(a))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var a in D)(typeof exports=="object"?exports:ne)[a]=D[a]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function D(a){if(e[a])return e[a].exports;var A=e[a]={i:a,l:!1,exports:{}};return ne[a].call(A.exports,A,A.exports,D),A.l=!0,A.exports}return D.m=ne,D.c=e,D.d=function(a,A,L){D.o(a,A)||Object.defineProperty(a,A,{enumerable:!0,get:L})},D.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},D.t=function(a,A){if(1&A&&(a=D(a)),8&A||4&A&&typeof a=="object"&&a&&a.__esModule)return a;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:a}),2&A&&typeof a!="string")for(var k in a)D.d(L,k,function(_){return a[_]}.bind(null,k));return L},D.n=function(a){var A=a&&a.__esModule?function(){return a.default}:function(){return a};return D.d(A,"a",A),A},D.o=function(a,A){return Object.prototype.hasOwnProperty.call(a,A)},D.p="",D(D.s=0)}([function(ne,e,D){(function(a){var A;e=ne.exports=J,A=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,_=e.re=[],T=e.src=[],y=0,P=y++;T[P]="0|[1-9]\\d*";var S=y++;T[S]="[0-9]+";var u=y++;T[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=y++;T[p]="("+T[P]+")\\.("+T[P]+")\\.("+T[P]+")";var c=y++;T[c]="("+T[S]+")\\.("+T[S]+")\\.("+T[S]+")";var g=y++;T[g]="(?:"+T[P]+"|"+T[u]+")";var f=y++;T[f]="(?:"+T[S]+"|"+T[u]+")";var h=y++;T[h]="(?:-("+T[g]+"(?:\\."+T[g]+")*))";var E=y++;T[E]="(?:-?("+T[f]+"(?:\\."+T[f]+")*))";var I=y++;T[I]="[0-9A-Za-z-]+";var d=y++;T[d]="(?:\\+("+T[I]+"(?:\\."+T[I]+")*))";var v=y++,t="v?"+T[p]+T[h]+"?"+T[d]+"?";T[v]="^"+t+"$";var r="[v=\\s]*"+T[c]+T[E]+"?"+T[d]+"?",s=y++;T[s]="^"+r+"$";var i=y++;T[i]="((?:<|>)?=?)";var n=y++;T[n]=T[S]+"|x|X|\\*";var o=y++;T[o]=T[P]+"|x|X|\\*";var l=y++;T[l]="[v=\\s]*("+T[o]+")(?:\\.("+T[o]+")(?:\\.("+T[o]+")(?:"+T[h]+")?"+T[d]+"?)?)?";var m=y++;T[m]="[v=\\s]*("+T[n]+")(?:\\.("+T[n]+")(?:\\.("+T[n]+")(?:"+T[E]+")?"+T[d]+"?)?)?";var w=y++;T[w]="^"+T[i]+"\\s*"+T[l]+"$";var C=y++;T[C]="^"+T[i]+"\\s*"+T[m]+"$";var b=y++;T[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=y++;T[R]="(?:~>?)";var U=y++;T[U]="(\\s*)"+T[R]+"\\s+",_[U]=new RegExp(T[U],"g");var N=y++;T[N]="^"+T[R]+T[l]+"$";var M=y++;T[M]="^"+T[R]+T[m]+"$";var F=y++;T[F]="(?:\\^)";var K=y++;T[K]="(\\s*)"+T[F]+"\\s+",_[K]=new RegExp(T[K],"g");var H=y++;T[H]="^"+T[F]+T[l]+"$";var X=y++;T[X]="^"+T[F]+T[m]+"$";var j=y++;T[j]="^"+T[i]+"\\s*("+r+")$|^$";var ie=y++;T[ie]="^"+T[i]+"\\s*("+t+")$|^$";var z=y++;T[z]="(\\s*)"+T[i]+"\\s*("+r+"|"+T[l]+")",_[z]=new RegExp(T[z],"g");var B=y++;T[B]="^\\s*("+T[l]+")\\s+-\\s+("+T[l]+")\\s*$";var ee=y++;T[ee]="^\\s*("+T[m]+")\\s+-\\s+("+T[m]+")\\s*$";var se=y++;T[se]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)A(ce,T[ce]),_[ce]||(_[ce]=new RegExp(T[ce]));function W(oe,fe){if(oe instanceof J)return oe;if(typeof oe!="string"||oe.length>L||!(fe?_[s]:_[v]).test(oe))return null;try{return new J(oe,fe)}catch{return null}}function J(oe,fe){if(oe instanceof J){if(oe.loose===fe)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof J))return new J(oe,fe);A("SemVer",oe,fe),this.loose=fe;var me=oe.trim().match(fe?_[s]:_[v]);if(!me)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var De=+Ce;if(De>=0&&De<k)return De}return Ce}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=W,e.valid=function(oe,fe){var me=W(oe,fe);return me?me.version:null},e.clean=function(oe,fe){var me=W(oe.trim().replace(/^[=v]+/,""),fe);return me?me.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(oe){return A("SemVer.compare",this.version,this.loose,oe),oe instanceof J||(oe=new J(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},J.prototype.compareMain=function(oe){return oe instanceof J||(oe=new J(oe,this.loose)),V(this.major,oe.major)||V(this.minor,oe.minor)||V(this.patch,oe.patch)},J.prototype.comparePre=function(oe){if(oe instanceof J||(oe=new J(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var fe=0;do{var me=this.prerelease[fe],Ce=oe.prerelease[fe];if(A("prerelease compare",fe,me,Ce),me===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(me===void 0)return-1;if(me!==Ce)return V(me,Ce)}while(++fe)},J.prototype.inc=function(oe,fe){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,fe,me,Ce){typeof me=="string"&&(Ce=me,me=void 0);try{return new J(oe,me).inc(fe,Ce).version}catch{return null}},e.diff=function(oe,fe){if(q(oe,fe))return null;var me=W(oe),Ce=W(fe);if(me.prerelease.length||Ce.prerelease.length){for(var De in me)if((De==="major"||De==="minor"||De==="patch")&&me[De]!==Ce[De])return"pre"+De;return"prerelease"}for(var De in me)if((De==="major"||De==="minor"||De==="patch")&&me[De]!==Ce[De])return De},e.compareIdentifiers=V;var G=/^[0-9]+$/;function V(oe,fe){var me=G.test(oe),Ce=G.test(fe);return me&&Ce&&(oe=+oe,fe=+fe),me&&!Ce?-1:Ce&&!me?1:oe<fe?-1:oe>fe?1:0}function O(oe,fe,me){return new J(oe,me).compare(new J(fe,me))}function $(oe,fe,me){return O(oe,fe,me)>0}function x(oe,fe,me){return O(oe,fe,me)<0}function q(oe,fe,me){return O(oe,fe,me)===0}function te(oe,fe,me){return O(oe,fe,me)!==0}function Z(oe,fe,me){return O(oe,fe,me)>=0}function Y(oe,fe,me){return O(oe,fe,me)<=0}function ae(oe,fe,me,Ce){var De;switch(fe){case"===":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),De=oe===me;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),De=oe!==me;break;case"":case"=":case"==":De=q(oe,me,Ce);break;case"!=":De=te(oe,me,Ce);break;case">":De=$(oe,me,Ce);break;case">=":De=Z(oe,me,Ce);break;case"<":De=x(oe,me,Ce);break;case"<=":De=Y(oe,me,Ce);break;default:throw new TypeError("Invalid operator: "+fe)}return De}function he(oe,fe){if(oe instanceof he){if(oe.loose===fe)return oe;oe=oe.value}if(!(this instanceof he))return new he(oe,fe);A("comparator",oe,fe),this.loose=fe,this.parse(oe),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(oe,fe){return V(fe,oe)},e.major=function(oe,fe){return new J(oe,fe).major},e.minor=function(oe,fe){return new J(oe,fe).minor},e.patch=function(oe,fe){return new J(oe,fe).patch},e.compare=O,e.compareLoose=function(oe,fe){return O(oe,fe,!0)},e.rcompare=function(oe,fe,me){return O(fe,oe,me)},e.sort=function(oe,fe){return oe.sort(function(me,Ce){return e.compare(me,Ce,fe)})},e.rsort=function(oe,fe){return oe.sort(function(me,Ce){return e.rcompare(me,Ce,fe)})},e.gt=$,e.lt=x,e.eq=q,e.neq=te,e.gte=Z,e.lte=Y,e.cmp=ae,e.Comparator=he;var ge={};function ve(oe,fe){if(oe instanceof ve)return oe.loose===fe?oe:new ve(oe.raw,fe);if(oe instanceof he)return new ve(oe.value,fe);if(!(this instanceof ve))return new ve(oe,fe);if(this.loose=fe,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Ie(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function pe(oe,fe,me,Ce,De,Ne,ke,Le,Oe,xe,ze,Fe,We){return((fe=Ie(me)?"":Ie(Ce)?">="+me+".0.0":Ie(De)?">="+me+"."+Ce+".0":">="+fe)+" "+(Le=Ie(Oe)?"":Ie(xe)?"<"+(+Oe+1)+".0.0":Ie(ze)?"<"+Oe+"."+(+xe+1)+".0":Fe?"<="+Oe+"."+xe+"."+ze+"-"+Fe:"<="+Le)).trim()}function ye(oe,fe){for(var me=0;me<oe.length;me++)if(!oe[me].test(fe))return!1;if(fe.prerelease.length){for(me=0;me<oe.length;me++)if(A(oe[me].semver),oe[me].semver!==ge&&oe[me].semver.prerelease.length>0){var Ce=oe[me].semver;if(Ce.major===fe.major&&Ce.minor===fe.minor&&Ce.patch===fe.patch)return!0}return!1}return!0}function Pe(oe,fe,me){try{fe=new ve(fe,me)}catch{return!1}return fe.test(oe)}function Re(oe,fe,me,Ce){var De,Ne,ke,Le,Oe;switch(oe=new J(oe,Ce),fe=new ve(fe,Ce),me){case">":De=$,Ne=Y,ke=x,Le=">",Oe=">=";break;case"<":De=x,Ne=Z,ke=$,Le="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(oe,fe,Ce))return!1;for(var xe=0;xe<fe.set.length;++xe){var ze=fe.set[xe],Fe=null,We=null;if(ze.forEach(function($e){$e.semver===ge&&($e=new he(">=0.0.0")),Fe=Fe||$e,We=We||$e,De($e.semver,Fe.semver,Ce)?Fe=$e:ke($e.semver,We.semver,Ce)&&(We=$e)}),Fe.operator===Le||Fe.operator===Oe||(!We.operator||We.operator===Le)&&Ne(oe,We.semver)||We.operator===Oe&&ke(oe,We.semver))return!1}return!0}he.prototype.parse=function(oe){var fe=this.loose?_[j]:_[ie],me=oe.match(fe);if(!me)throw new TypeError("Invalid comparator: "+oe);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new J(me[2],this.loose):this.semver=ge},he.prototype.toString=function(){return this.value},he.prototype.test=function(oe){return A("Comparator.test",oe,this.loose),this.semver===ge||(typeof oe=="string"&&(oe=new J(oe,this.loose)),ae(oe,this.operator,this.semver,this.loose))},he.prototype.intersects=function(oe,fe){if(!(oe instanceof he))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new ve(oe.value,fe),Pe(this.value,me,fe);if(oe.operator==="")return me=new ve(this.value,fe),Pe(oe.semver,me,fe);var Ce=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Ne=this.semver.version===oe.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),Le=ae(this.semver,"<",oe.semver,fe)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Oe=ae(this.semver,">",oe.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Ce||De||Ne&&ke||Le||Oe},e.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(oe){var fe=this.loose;oe=oe.trim(),A("range",oe,fe);var me=fe?_[ee]:_[B];oe=oe.replace(me,pe),A("hyphen replace",oe),oe=oe.replace(_[z],"$1$2$3"),A("comparator trim",oe,_[z]),oe=(oe=(oe=oe.replace(_[U],"$1~")).replace(_[K],"$1^")).split(/\s+/).join(" ");var Ce=fe?_[j]:_[ie],De=oe.split(" ").map(function(Ne){return function(ke,Le){return A("comp",ke),ke=function(Oe,xe){return Oe.trim().split(/\s+/).map(function(ze){return function(Fe,We){A("caret",Fe,We);var $e=We?_[X]:_[H];return Fe.replace($e,function(qe,_e,re,de,Se){var Ee;return A("caret",Fe,qe,_e,re,de,Se),Ie(_e)?Ee="":Ie(re)?Ee=">="+_e+".0.0 <"+(+_e+1)+".0.0":Ie(de)?Ee=_e==="0"?">="+_e+"."+re+".0 <"+_e+"."+(+re+1)+".0":">="+_e+"."+re+".0 <"+(+_e+1)+".0.0":Se?(A("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Ee=_e==="0"?re==="0"?">="+_e+"."+re+"."+de+Se+" <"+_e+"."+re+"."+(+de+1):">="+_e+"."+re+"."+de+Se+" <"+_e+"."+(+re+1)+".0":">="+_e+"."+re+"."+de+Se+" <"+(+_e+1)+".0.0"):(A("no pr"),Ee=_e==="0"?re==="0"?">="+_e+"."+re+"."+de+" <"+_e+"."+re+"."+(+de+1):">="+_e+"."+re+"."+de+" <"+_e+"."+(+re+1)+".0":">="+_e+"."+re+"."+de+" <"+(+_e+1)+".0.0"),A("caret return",Ee),Ee})}(ze,xe)}).join(" ")}(ke,Le),A("caret",ke),ke=function(Oe,xe){return Oe.trim().split(/\s+/).map(function(ze){return function(Fe,We){var $e=We?_[M]:_[N];return Fe.replace($e,function(qe,_e,re,de,Se){var Ee;return A("tilde",Fe,qe,_e,re,de,Se),Ie(_e)?Ee="":Ie(re)?Ee=">="+_e+".0.0 <"+(+_e+1)+".0.0":Ie(de)?Ee=">="+_e+"."+re+".0 <"+_e+"."+(+re+1)+".0":Se?(A("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Ee=">="+_e+"."+re+"."+de+Se+" <"+_e+"."+(+re+1)+".0"):Ee=">="+_e+"."+re+"."+de+" <"+_e+"."+(+re+1)+".0",A("tilde return",Ee),Ee})}(ze,xe)}).join(" ")}(ke,Le),A("tildes",ke),ke=function(Oe,xe){return A("replaceXRanges",Oe,xe),Oe.split(/\s+/).map(function(ze){return function(Fe,We){Fe=Fe.trim();var $e=We?_[C]:_[w];return Fe.replace($e,function(qe,_e,re,de,Se,Ee){A("xRange",Fe,qe,_e,re,de,Se,Ee);var Te=Ie(re),Ae=Te||Ie(de),Me=Ae||Ie(Se);return _e==="="&&Me&&(_e=""),Te?qe=_e===">"||_e==="<"?"<0.0.0":"*":_e&&Me?(Ae&&(de=0),Me&&(Se=0),_e===">"?(_e=">=",Ae?(re=+re+1,de=0,Se=0):Me&&(de=+de+1,Se=0)):_e==="<="&&(_e="<",Ae?re=+re+1:de=+de+1),qe=_e+re+"."+de+"."+Se):Ae?qe=">="+re+".0.0 <"+(+re+1)+".0.0":Me&&(qe=">="+re+"."+de+".0 <"+re+"."+(+de+1)+".0"),A("xRange return",qe),qe})}(ze,xe)}).join(" ")}(ke,Le),A("xrange",ke),ke=function(Oe,xe){return A("replaceStars",Oe,xe),Oe.trim().replace(_[se],"")}(ke,Le),A("stars",ke),ke}(Ne,fe)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Ne){return!!Ne.match(Ce)})),De=De.map(function(Ne){return new he(Ne,fe)})},ve.prototype.intersects=function(oe,fe){if(!(oe instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Ce){return oe.set.some(function(De){return De.every(function(Ne){return Ce.intersects(Ne,fe)})})})})},e.toComparators=function(oe,fe){return new ve(oe,fe).set.map(function(me){return me.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new J(oe,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ye(this.set[fe],oe))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(oe,fe,me){var Ce=null,De=null;try{var Ne=new ve(fe,me)}catch{return null}return oe.forEach(function(ke){Ne.test(ke)&&(Ce&&De.compare(ke)!==-1||(De=new J(Ce=ke,me)))}),Ce},e.minSatisfying=function(oe,fe,me){var Ce=null,De=null;try{var Ne=new ve(fe,me)}catch{return null}return oe.forEach(function(ke){Ne.test(ke)&&(Ce&&De.compare(ke)!==1||(De=new J(Ce=ke,me)))}),Ce},e.validRange=function(oe,fe){try{return new ve(oe,fe).range||"*"}catch{return null}},e.ltr=function(oe,fe,me){return Re(oe,fe,"<",me)},e.gtr=function(oe,fe,me){return Re(oe,fe,">",me)},e.outside=Re,e.prerelease=function(oe,fe){var me=W(oe,fe);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(oe,fe,me){return oe=new ve(oe,me),fe=new ve(fe,me),oe.intersects(fe)},e.coerce=function(oe){if(oe instanceof J)return oe;if(typeof oe!="string")return null;var fe=oe.match(_[b]);return fe==null?null:W((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,D(1))},function(ne,e){var D,a,A=ne.exports={};function L(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function _(f){if(D===setTimeout)return setTimeout(f,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{a=typeof clearTimeout=="function"?clearTimeout:k}catch{a=k}})();var T,y=[],P=!1,S=-1;function u(){P&&T&&(P=!1,T.length?y=T.concat(y):S=-1,y.length&&p())}function p(){if(!P){var f=_(u);P=!0;for(var h=y.length;h;){for(T=y,y=[];++S<h;)T&&T[S].run();S=-1,h=y.length}T=null,P=!1,function(E){if(a===clearTimeout)return clearTimeout(E);if((a===k||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(E);try{a(E)}catch{try{return a.call(null,E)}catch{return a.call(this,E)}}}(f)}}function c(f,h){this.fun=f,this.array=h}function g(){}A.nextTick=function(f){var h=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)h[E-1]=arguments[E];y.push(new c(f,h)),y.length!==1||P||_(p)},c.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=g,A.addListener=g,A.once=g,A.off=g,A.removeListener=g,A.removeAllListeners=g,A.emit=g,A.prependListener=g,A.prependOnceListener=g,A.listeners=function(f){return[]},A.binding=function(f){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(f){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(le[133],ue([0,1]),function(ne,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class a{constructor(_,T,y){this.level=_,this.key=T,this.value=y,this.forward=[]}}const A=void 0;class L{constructor(_,T=2**16){this.comparator=_,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(T)|0),this._header=new a(this._maxLevel,A,A)}get size(){return this._size}clear(){this._header=new a(this._maxLevel,A,A),this._size=0}has(_){return!!L._search(this,_,this.comparator)}get(_){return L._search(this,_,this.comparator)?.value}set(_,T){return L._insert(this,_,T,this.comparator)&&(this._size+=1),this}delete(_){const T=L._delete(this,_,this.comparator);return T&&(this._size-=1),T}forEach(_,T){let y=this._header.forward[0];for(;y;)_.call(T,y.value,y.key,this),y=y.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let _=this._header.forward[0];for(;_;)yield[_.key,_.value],_=_.forward[0]}*keys(){let _=this._header.forward[0];for(;_;)yield _.key,_=_.forward[0]}*values(){let _=this._header.forward[0];for(;_;)yield _.value,_=_.forward[0]}toString(){let _="[SkipList]:",T=this._header.forward[0];for(;T;)_+=`node(${T.key}, ${T.value}, lvl:${T.level})`,T=T.forward[0];return _}static _search(_,T,y){let P=_._header;for(let S=_._level-1;S>=0;S--)for(;P.forward[S]&&y(P.forward[S].key,T)<0;)P=P.forward[S];if(P=P.forward[0],P&&y(P.key,T)===0)return P}static _insert(_,T,y,P){const S=[];let u=_._header;for(let p=_._level-1;p>=0;p--){for(;u.forward[p]&&P(u.forward[p].key,T)<0;)u=u.forward[p];S[p]=u}if(u=u.forward[0],u&&P(u.key,T)===0)return u.value=y,!1;{const p=L._randomLevel(_);if(p>_._level){for(let c=_._level;c<p;c++)S[c]=_._header;_._level=p}u=new a(p,T,y);for(let c=0;c<p;c++)u.forward[c]=S[c].forward[c],S[c].forward[c]=u;return!0}}static _randomLevel(_,T=.5){let y=1;for(;Math.random()<T&&y<_._maxLevel;)y+=1;return y}static _delete(_,T,y){const P=[];let S=_._header;for(let u=_._level-1;u>=0;u--){for(;S.forward[u]&&y(S.forward[u].key,T)<0;)S=S.forward[u];P[u]=S}if(S=S.forward[0],!S||y(S.key,T)!==0)return!1;for(let u=0;u<_._level&&P[u].forward[u]===S;u++)P[u].forward[u]=S.forward[u];for(;_._level>0&&_._header.forward[_._level-1]===A;)_._level-=1;return!0}}e.SkipList=L}),define(le[65],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(L){return new a(L)}constructor(L){this._now=D&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=a}),define(le[3],ue([0,1,8,89,2,90,65]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=p;const _=!1,T=!1,y=!1;var P;(function(M){M.None=()=>A.Disposable.None;function F(pe){if(y){const{onDidAddListener:ye}=pe,Pe=g.create();let Re=0;pe.onDidAddListener=()=>{++Re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Pe.print()),ye?.()}}}function K(pe,ye){return W(pe,()=>{},0,void 0,!0,void 0,ye)}M.defer=K;function H(pe){return(ye,Pe=null,Re)=>{let oe=!1,fe;return fe=pe(me=>{if(!oe)return fe?fe.dispose():oe=!0,ye.call(Pe,me)},null,Re),oe&&fe.dispose(),fe}}M.once=H;function X(pe,ye,Pe){return se((Re,oe=null,fe)=>pe(me=>Re.call(oe,ye(me)),null,fe),Pe)}M.map=X;function j(pe,ye,Pe){return se((Re,oe=null,fe)=>pe(me=>{ye(me),Re.call(oe,me)},null,fe),Pe)}M.forEach=j;function ie(pe,ye,Pe){return se((Re,oe=null,fe)=>pe(me=>ye(me)&&Re.call(oe,me),null,fe),Pe)}M.filter=ie;function z(pe){return pe}M.signal=z;function B(...pe){return(ye,Pe=null,Re)=>{const oe=(0,A.combinedDisposable)(...pe.map(fe=>fe(me=>ye.call(Pe,me))));return ce(oe,Re)}}M.any=B;function ee(pe,ye,Pe,Re){let oe=Pe;return X(pe,fe=>(oe=ye(oe,fe),oe),Re)}M.reduce=ee;function se(pe,ye){let Pe;const Re={onWillAddFirstListener(){Pe=pe(oe.fire,oe)},onDidRemoveLastListener(){Pe?.dispose()}};ye||F(Re);const oe=new r(Re);return ye?.add(oe),oe.event}function ce(pe,ye){return ye instanceof Array?ye.push(pe):ye&&ye.add(pe),pe}function W(pe,ye,Pe=100,Re=!1,oe=!1,fe,me){let Ce,De,Ne,ke=0,Le;const Oe={leakWarningThreshold:fe,onWillAddFirstListener(){Ce=pe(ze=>{ke++,De=ye(De,ze),Re&&!Ne&&(xe.fire(De),De=void 0),Le=()=>{const Fe=De;De=void 0,Ne=void 0,(!Re||ke>1)&&xe.fire(Fe),ke=0},typeof Pe=="number"?(clearTimeout(Ne),Ne=setTimeout(Le,Pe)):Ne===void 0&&(Ne=0,queueMicrotask(Le))})},onWillRemoveListener(){oe&&ke>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,Ce.dispose()}};me||F(Oe);const xe=new r(Oe);return me?.add(xe),xe.event}M.debounce=W;function J(pe,ye=0,Pe){return M.debounce(pe,(Re,oe)=>Re?(Re.push(oe),Re):[oe],ye,void 0,!0,void 0,Pe)}M.accumulate=J;function G(pe,ye=(Re,oe)=>Re===oe,Pe){let Re=!0,oe;return ie(pe,fe=>{const me=Re||!ye(fe,oe);return Re=!1,oe=fe,me},Pe)}M.latch=G;function V(pe,ye,Pe){return[M.filter(pe,ye,Pe),M.filter(pe,Re=>!ye(Re),Pe)]}M.split=V;function O(pe,ye=!1,Pe=[],Re){let oe=Pe.slice(),fe=pe(De=>{oe?oe.push(De):Ce.fire(De)});Re&&Re.add(fe);const me=()=>{oe?.forEach(De=>Ce.fire(De)),oe=null},Ce=new r({onWillAddFirstListener(){fe||(fe=pe(De=>Ce.fire(De)),Re&&Re.add(fe))},onDidAddFirstListener(){oe&&(ye?setTimeout(me):me())},onDidRemoveLastListener(){fe&&fe.dispose(),fe=null}});return Re&&Re.add(Ce),Ce.event}M.buffer=O;function $(pe,ye){return(Re,oe,fe)=>{const me=ye(new q);return pe(function(Ce){const De=me.evaluate(Ce);De!==x&&Re.call(oe,De)},void 0,fe)}}M.chain=$;const x=Symbol("HaltChainable");class q{constructor(){this.steps=[]}map(ye){return this.steps.push(ye),this}forEach(ye){return this.steps.push(Pe=>(ye(Pe),Pe)),this}filter(ye){return this.steps.push(Pe=>ye(Pe)?Pe:x),this}reduce(ye,Pe){let Re=Pe;return this.steps.push(oe=>(Re=ye(Re,oe),Re)),this}latch(ye=(Pe,Re)=>Pe===Re){let Pe=!0,Re;return this.steps.push(oe=>{const fe=Pe||!ye(oe,Re);return Pe=!1,Re=oe,fe?oe:x}),this}evaluate(ye){for(const Pe of this.steps)if(ye=Pe(ye),ye===x)break;return ye}}function te(pe,ye,Pe=Re=>Re){const Re=(...Ce)=>me.fire(Pe(...Ce)),oe=()=>pe.on(ye,Re),fe=()=>pe.removeListener(ye,Re),me=new r({onWillAddFirstListener:oe,onDidRemoveLastListener:fe});return me.event}M.fromNodeEventEmitter=te;function Z(pe,ye,Pe=Re=>Re){const Re=(...Ce)=>me.fire(Pe(...Ce)),oe=()=>pe.addEventListener(ye,Re),fe=()=>pe.removeEventListener(ye,Re),me=new r({onWillAddFirstListener:oe,onDidRemoveLastListener:fe});return me.event}M.fromDOMEventEmitter=Z;function Y(pe){return new Promise(ye=>H(pe)(ye))}M.toPromise=Y;function ae(pe){const ye=new r;return pe.then(Pe=>{ye.fire(Pe)},()=>{ye.fire(void 0)}).finally(()=>{ye.dispose()}),ye.event}M.fromPromise=ae;function he(pe,ye,Pe){return ye(Pe),pe(Re=>ye(Re))}M.runAndSubscribe=he;class ge{constructor(ye,Pe){this._observable=ye,this._counter=0,this._hasChanged=!1;const Re={onWillAddFirstListener:()=>{ye.addObserver(this)},onDidRemoveLastListener:()=>{ye.removeObserver(this)}};Pe||F(Re),this.emitter=new r(Re),Pe&&Pe.add(this.emitter)}beginUpdate(ye){this._counter++}handlePossibleChange(ye){}handleChange(ye,Pe){this._hasChanged=!0}endUpdate(ye){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ve(pe,ye){return new ge(pe,ye).emitter.event}M.fromObservable=ve;function Ie(pe){return(ye,Pe,Re)=>{let oe=0,fe=!1;const me={beginUpdate(){oe++},endUpdate(){oe--,oe===0&&(pe.reportChanges(),fe&&(fe=!1,ye.call(Pe)))},handlePossibleChange(){},handleChange(){fe=!0}};pe.addObserver(me),pe.reportChanges();const Ce={dispose(){pe.removeObserver(me)}};return Re instanceof A.DisposableStore?Re.add(Ce):Array.isArray(Re)&&Re.push(Ce),Ce}}M.fromObservableLight=Ie})(P||(e.Event=P={}));class S{static{this.all=new Set}static{this._idPool=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${S._idPool++}`,S.all.add(this)}start(F){this._stopWatch=new k.StopWatch,this.listenerCount=F}stop(){if(this._stopWatch){const F=this._stopWatch.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=S;let u=-1;function p(M){const F=u;return u=M,{dispose(){u=F}}}class c{constructor(F,K,H=Math.random().toString(18).slice(2,5)){this._errorHandler=F,this.threshold=K,this.name=H,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(F,K){const H=this.threshold;if(H<=0||K<H)return;this._stacks||(this._stacks=new Map);const X=this._stacks.get(F.value)||0;if(this._stacks.set(F.value,X+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=H*.5;const[j,ie]=this.getMostFrequentStack(),z=`[${this.name}] potential listener LEAK detected, having ${K} listeners already. MOST frequent listener (${ie}):`;console.warn(z),console.warn(j);const B=new f(z,j);this._errorHandler(B)}return()=>{const j=this._stacks.get(F.value)||0;this._stacks.set(F.value,j-1)}}getMostFrequentStack(){if(!this._stacks)return;let F,K=0;for(const[H,X]of this._stacks)(!F||K<X)&&(F=[H,X],K=X);return F}}class g{static create(){const F=new Error;return new g(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f extends Error{constructor(F,K){super(F),this.name="ListenerLeakError",this.stack=K}}e.ListenerLeakError=f;class h extends Error{constructor(F,K){super(F),this.name="ListenerRefusalError",this.stack=K}}e.ListenerRefusalError=h;let E=0;class I{constructor(F){this.value=F,this.id=E++}}const d=2,v=(M,F)=>{if(M instanceof I)F(M);else for(let K=0;K<M.length;K++){const H=M[K];H&&F(H)}},t=_?new FinalizationRegistry(M=>{typeof M=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(M))}):void 0;class r{constructor(F){this._size=0,this._options=F,this._leakageMon=u>0||this._options?.leakWarningThreshold?new c(F?.onListenerError??D.onUnexpectedError,this._options?.leakWarningThreshold??u):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(T){const F=this._listeners;queueMicrotask(()=>{v(F,K=>K.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(F,K,H)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const B=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(B);const ee=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],se=new h(`${B}. HINT: Stack shows most frequent listener (${ee[1]}-times)`,ee[0]);return(this._options?.onListenerError||D.onUnexpectedError)(se),A.Disposable.None}if(this._disposed)return A.Disposable.None;K&&(F=F.bind(K));const X=new I(F);let j,ie;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(X.stack=g.create(),j=this._leakageMon.check(X.stack,this._size+1)),T&&(X.stack=ie??g.create()),this._listeners?this._listeners instanceof I?(this._deliveryQueue??=new i,this._listeners=[this._listeners,X]):this._listeners.push(X):(this._options?.onWillAddFirstListener?.(this),this._listeners=X,this._options?.onDidAddFirstListener?.(this)),this._size++;const z=(0,A.toDisposable)(()=>{t?.unregister(z),j?.(),this._removeListener(X)});if(H instanceof A.DisposableStore?H.add(z):Array.isArray(H)&&H.push(z),t){const B=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(z,B,z)}return z},this._event}_removeListener(F){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const K=this._listeners,H=K.indexOf(F);if(H===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,K[H]=void 0;const X=this._deliveryQueue.current===this;if(this._size*d<=K.length){let j=0;for(let ie=0;ie<K.length;ie++)K[ie]?K[j++]=K[ie]:X&&(this._deliveryQueue.end--,j<this._deliveryQueue.i&&this._deliveryQueue.i--);K.length=j}}_deliver(F,K){if(!F)return;const H=this._options?.onListenerError||D.onUnexpectedError;if(!H){F.value(K);return}try{F.value(K)}catch(X){H(X)}}_deliverQueue(F){const K=F.current._listeners;for(;F.i<F.end;)this._deliver(K[F.i++],F.value);F.reset()}fire(F){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof I)this._deliver(this._listeners,F);else{const K=this._deliveryQueue;K.enqueue(this,F,this._listeners.length),this._deliverQueue(K)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=r;const s=()=>new i;e.createEventDeliveryQueue=s;class i{constructor(){this.i=-1,this.end=0}enqueue(F,K,H){this.i=0,this.end=H,this.current=F,this.value=K}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends r{async fireAsync(F,K,H){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList),v(this._listeners,X=>this._asyncDeliveryQueue.push([X.value,F]));this._asyncDeliveryQueue.size>0&&!K.isCancellationRequested;){const[X,j]=this._asyncDeliveryQueue.shift(),ie=[],z={...j,token:K,waitUntil:B=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");H&&(B=H(B,X)),ie.push(B)}};try{X(z)}catch(B){(0,D.onUnexpectedError)(B);continue}Object.freeze(ie),await Promise.allSettled(ie).then(B=>{for(const ee of B)ee.status==="rejected"&&(0,D.onUnexpectedError)(ee.reason)})}}}e.AsyncEmitter=n;class o extends r{get isPaused(){return this._isPaused!==0}constructor(F){super(F),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=F?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const F=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(F))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(F){this._size&&(this._isPaused!==0?this._eventQueue.push(F):super.fire(F))}}e.PauseableEmitter=o;class l extends o{constructor(F){super(F),this._delay=F.delay??100}fire(F){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(F)}}e.DebounceEmitter=l;class m extends r{constructor(F){super(F),this._queuedEvents=[],this._mergeFn=F?.merge}fire(F){this.hasListeners()&&(this._queuedEvents.push(F),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(K=>super.fire(K)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=m;class w{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new r({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(F){const K={event:F,listener:null};this.events.push(K),this.hasListeners&&this.hook(K);const H=()=>{this.hasListeners&&this.unhook(K);const X=this.events.indexOf(K);this.events.splice(X,1)};return(0,A.toDisposable)((0,a.createSingleCallFunction)(H))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(F=>this.hook(F))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(F=>this.unhook(F))}hook(F){F.listener=F.event(K=>this.emitter.fire(K))}unhook(F){F.listener?.dispose(),F.listener=null}dispose(){this.emitter.dispose();for(const F of this.events)F.listener?.dispose();this.events=[]}}e.EventMultiplexer=w;class C{constructor(F,K,H,X){this._store=new A.DisposableStore;const j=this._store.add(new w),ie=this._store.add(new A.DisposableMap);function z(B){ie.set(B,j.add(X(B)))}for(const B of F)z(B);this._store.add(K(B=>{z(B)})),this._store.add(H(B=>{ie.deleteAndDispose(B)})),this.event=j.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=C;class b{constructor(){this.data=[]}wrapEvent(F,K,H){return(X,j,ie)=>F(z=>{const B=this.data[this.data.length-1];if(!K){B?B.buffers.push(()=>X.call(j,z)):X.call(j,z);return}const ee=B;if(!ee){X.call(j,K(H,z));return}ee.items??=[],ee.items.push(z),ee.buffers.length===0&&B.buffers.push(()=>{ee.reducedResult??=H?ee.items.reduce(K,H):ee.items.reduce(K),X.call(j,ee.reducedResult)})},void 0,ie)}bufferEvents(F){const K={buffers:new Array};this.data.push(K);const H=F();return this.data.pop(),K.buffers.forEach(X=>X()),H}}e.EventBufferer=b;class R{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=A.Disposable.None,this.emitter=new r({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(F){this.inputEvent=F,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=F(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=R;class U{static const(F){return new N(F)}constructor(F){this._value=F,this._onDidChange=new r,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(F){F!==this._value&&(this._value=F,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=U;class N{constructor(F){this.value=F,this.onDidChange=P.None}}}),define(le[26],ue([0,1,3]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=_;const a=Object.freeze(function(T,y){const P=setTimeout(T.bind(y),0);return{dispose(){clearTimeout(P)}}});var A;(function(T){function y(P){return P===T.None||P===T.Cancelled||P instanceof L?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}T.isCancellationToken=y,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(A||(e.CancellationToken=A={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?a:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=A.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=k;function _(T){const y=new k;return T.add({dispose(){y.cancel()}}),y.token}}),define(le[134],ue([0,1,26]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=A;class a{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new D.CancellationTokenSource,y=this.task(T.token);return this.result={promise:y,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=a;function A(_){return _}class L{constructor(T,y){this.lastCache=void 0,this.lastArgKey=void 0,typeof T=="function"?(this._fn=T,this._computeKey=A):(this._fn=y,this._computeKey=T.getCacheKey)}get(T){const y=this._computeKey(T);return this.lastArgKey!==y&&(this.lastArgKey=y,this.lastCache=this._fn(T)),this.lastCache}}e.LRUCachedFunction=L;class k{get cachedValues(){return this._map}constructor(T,y){this._map=new Map,this._map2=new Map,typeof T=="function"?(this._fn=T,this._computeKey=A):(this._fn=y,this._computeKey=T.getCacheKey)}get(T){const y=this._computeKey(T);if(this._map2.has(y))return this._map2.get(y);const P=this._fn(T);return this._map.set(T,P),this._map2.set(y,P),P}}e.CachedFunction=k}),define(le[51],ue([0,1,8,2]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=A,e.isReadableStream=L,e.isReadableBufferedStream=k,e.newWriteableStream=_,e.consumeReadable=y,e.peekReadable=P,e.consumeStream=S,e.listenStream=u,e.peekStream=p,e.toStream=c,e.emptyStream=g,e.toReadable=f,e.transform=h,e.prefixedReadable=E,e.prefixedStream=I;function A(d){const v=d;return v?typeof v.read=="function":!1}function L(d){const v=d;return v?[v.on,v.pause,v.resume,v.destroy].every(t=>typeof t=="function"):!1}function k(d){const v=d;return v?L(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}function _(d,v){return new T(d,v)}class T{constructor(v,t){this.reducer=v,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v<"u"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(t=>t(v))}emitError(v){this.listeners.error.length===0?(0,D.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(t=>t(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,t){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(v,t){if(this.state.destroyed)return;let r;switch(v){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const s=r.indexOf(t);s>=0&&r.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(d,v){const t=[];let r;for(;(r=d.read())!==null;)t.push(r);return v(t)}function P(d,v,t){const r=[];let s;for(;(s=d.read())!==null&&r.length<t;)r.push(s);return s===null&&r.length>0?v(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return d.read()}}}function S(d,v){return new Promise((t,r)=>{const s=[];u(d,{onData:i=>{v&&s.push(i)},onError:i=>{v?r(i):t(void 0)},onEnd:()=>{t(v?v(s):void 0)}})})}function u(d,v,t){d.on("error",r=>{t?.isCancellationRequested||v.onError(r)}),d.on("end",()=>{t?.isCancellationRequested||v.onEnd()}),d.on("data",r=>{t?.isCancellationRequested||v.onData(r)})}function p(d,v){return new Promise((t,r)=>{const s=new a.DisposableStore,i=[],n=m=>{if(i.push(m),i.length>v)return s.dispose(),d.pause(),t({stream:d,buffer:i,ended:!1})},o=m=>(s.dispose(),r(m)),l=()=>(s.dispose(),t({stream:d,buffer:i,ended:!0}));s.add((0,a.toDisposable)(()=>d.removeListener("error",o))),d.on("error",o),s.add((0,a.toDisposable)(()=>d.removeListener("end",l))),d.on("end",l),s.add((0,a.toDisposable)(()=>d.removeListener("data",n))),d.on("data",n)})}function c(d,v){const t=_(v);return t.end(d),t}function g(){const d=_(()=>{throw new Error("not supported")});return d.end(),d}function f(d){let v=!1;return{read:()=>v?null:(v=!0,d)}}function h(d,v,t){const r=_(t);return u(d,{onData:s=>r.write(v.data(s)),onError:s=>r.error(v.error?v.error(s):s),onEnd:()=>r.end()}),r}function E(d,v,t){let r=!1;return{read:()=>{const s=v.read();return r?s:(r=!0,s!==null?t([d,s]):d)}}}function I(d,v,t){let r=!1;const s=_(t);return u(v,{onData:i=>r?s.write(i):(r=!0,s.write(t([d,i]))),onError:i=>s.error(i),onEnd:()=>{r||(r=!0,s.write(d)),s.end()}}),s}}),define(le[15],ue([0,1,54,51]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=y,e.readUInt16LE=P,e.writeUInt16LE=S,e.readUInt32BE=u,e.writeUInt32BE=p,e.readUInt32LE=c,e.writeUInt32LE=g,e.readUInt8=f,e.writeUInt8=h,e.readableToBuffer=E,e.bufferToReadable=I,e.streamToBuffer=d,e.bufferedStreamToBuffer=v,e.bufferToStream=t,e.streamToBufferReadableStream=r,e.newWriteableBufferStream=s,e.prefixedBufferReadable=i,e.prefixedBufferStream=n,e.decodeBase64=o,e.encodeBase64=w;const A=typeof Buffer<"u",L=new D.Lazy(()=>new Uint8Array(256));let k,_;class T{static alloc(b){return A?new T(Buffer.allocUnsafe(b)):new T(new Uint8Array(b))}static wrap(b){return A&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new T(b)}static fromString(b,R){return!(R?.dontUseNodeBuffer||!1)&&A?new T(Buffer.from(b)):(k||(k=new TextEncoder),new T(k.encode(b)))}static fromByteArray(b){const R=T.alloc(b.length);for(let U=0,N=b.length;U<N;U++)R.buffer[U]=b[U];return R}static concat(b,R){if(typeof R>"u"){R=0;for(let M=0,F=b.length;M<F;M++)R+=b[M].byteLength}const U=T.alloc(R);let N=0;for(let M=0,F=b.length;M<F;M++){const K=b[M];U.set(K,N),N+=K.byteLength}return U}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=T.alloc(this.byteLength);return b.set(this),b}toString(){return A?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(b,R){return new T(this.buffer.subarray(b,R))}set(b,R){if(b instanceof T)this.buffer.set(b.buffer,R);else if(b instanceof Uint8Array)this.buffer.set(b,R);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),R);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return u(this.buffer,b)}writeUInt32BE(b,R){p(this.buffer,b,R)}readUInt32LE(b){return c(this.buffer,b)}writeUInt32LE(b,R){g(this.buffer,b,R)}readUInt8(b){return f(this.buffer,b)}writeUInt8(b,R){h(this.buffer,b,R)}indexOf(b,R=0){return y(this.buffer,b instanceof T?b.buffer:b,R)}}e.VSBuffer=T;function y(C,b,R=0){const U=b.byteLength,N=C.byteLength;if(U===0)return 0;if(U===1)return C.indexOf(b[0]);if(U>N-R)return-1;const M=L.value;M.fill(b.length);for(let X=0;X<b.length;X++)M[b[X]]=b.length-X-1;let F=R+b.length-1,K=F,H=-1;for(;F<N;)if(C[F]===b[K]){if(K===0){H=F;break}F--,K--}else F+=Math.max(b.length-K,M[C[F]]),K=b.length-1;return H}function P(C,b){return C[b+0]<<0>>>0|C[b+1]<<8>>>0}function S(C,b,R){C[R+0]=b&255,b=b>>>8,C[R+1]=b&255}function u(C,b){return C[b]*2**24+C[b+1]*2**16+C[b+2]*2**8+C[b+3]}function p(C,b,R){C[R+3]=b,b=b>>>8,C[R+2]=b,b=b>>>8,C[R+1]=b,b=b>>>8,C[R]=b}function c(C,b){return C[b+0]<<0>>>0|C[b+1]<<8>>>0|C[b+2]<<16>>>0|C[b+3]<<24>>>0}function g(C,b,R){C[R+0]=b&255,b=b>>>8,C[R+1]=b&255,b=b>>>8,C[R+2]=b&255,b=b>>>8,C[R+3]=b&255}function f(C,b){return C[b]}function h(C,b,R){C[R]=b}function E(C){return a.consumeReadable(C,b=>T.concat(b))}function I(C){return a.toReadable(C)}function d(C){return a.consumeStream(C,b=>T.concat(b))}async function v(C){return C.ended?T.concat(C.buffer):T.concat([...C.buffer,await d(C.stream)])}function t(C){return a.toStream(C,b=>T.concat(b))}function r(C){return a.transform(C,{data:b=>typeof b=="string"?T.fromString(b):T.wrap(b)},b=>T.concat(b))}function s(C){return a.newWriteableStream(b=>T.concat(b),C)}function i(C,b){return a.prefixedReadable(C,b,R=>T.concat(R))}function n(C,b){return a.prefixedStream(C,b,R=>T.concat(R))}function o(C){let b=0,R=0,U=0;const N=new Uint8Array(Math.floor(C.length/4*3)),M=K=>{switch(R){case 3:N[U++]=b|K,R=0;break;case 2:N[U++]=b|K>>>2,b=K<<6,R=3;break;case 1:N[U++]=b|K>>>4,b=K<<4,R=2;break;default:b=K<<2,R=1}};for(let K=0;K<C.length;K++){const H=C.charCodeAt(K);if(H>=65&&H<=90)M(H-65);else if(H>=97&&H<=122)M(H-97+26);else if(H>=48&&H<=57)M(H-48+52);else if(H===43||H===45)M(62);else if(H===47||H===95)M(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${C[K]}`)}}const F=U;for(;R>0;)M(0);return T.wrap(N).slice(0,F)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:C},b=!0,R=!1){const U=R?m:l;let N="";const M=C.byteLength%3;let F=0;for(;F<C.byteLength-M;F+=3){const K=C[F+0],H=C[F+1],X=C[F+2];N+=U[K>>>2],N+=U[(K<<4|H>>>4)&63],N+=U[(H<<2|X>>>6)&63],N+=U[X&63]}if(M===1){const K=C[F+0];N+=U[K>>>2],N+=U[K<<4&63],b&&(N+="==")}else if(M===2){const K=C[F+0],H=C[F+1];N+=U[K>>>2],N+=U[(K<<4|H>>>4)&63],N+=U[H<<2&63],b&&(N+="=")}return N}}),define(le[135],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(le[13],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=D,e.isStringArray=a,e.isObject=A,e.isTypedArray=L,e.isNumber=k,e.isIterable=_,e.isBoolean=T,e.isUndefined=y,e.isDefined=P,e.isUndefinedOrNull=S,e.assertType=u,e.assertIsDefined=p,e.assertAllDefined=c,e.isEmptyObject=f,e.isFunction=h,e.areFunctions=E,e.validateConstraints=I,e.validateConstraint=d;function D(v){return typeof v=="string"}function a(v){return Array.isArray(v)&&v.every(t=>D(t))}function A(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}function L(v){const t=Object.getPrototypeOf(Uint8Array);return typeof v=="object"&&v instanceof t}function k(v){return typeof v=="number"&&!isNaN(v)}function _(v){return!!v&&typeof v[Symbol.iterator]=="function"}function T(v){return v===!0||v===!1}function y(v){return typeof v>"u"}function P(v){return!S(v)}function S(v){return y(v)||v===null}function u(v,t){if(!v)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function p(v){if(S(v))throw new Error("Assertion Failed: argument is undefined or null");return v}function c(...v){const t=[];for(let r=0;r<v.length;r++){const s=v[r];if(S(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}const g=Object.prototype.hasOwnProperty;function f(v){if(!A(v))return!1;for(const t in v)if(g.call(v,t))return!1;return!0}function h(v){return typeof v=="function"}function E(...v){return v.length>0&&v.every(h)}function I(v,t){const r=Math.min(v.length,t.length);for(let s=0;s<r;s++)d(v[s],t[s])}function d(v,t){if(D(t)){if(typeof v!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(v instanceof t)return}catch{}if(!S(v)&&v.constructor===t||t.length===1&&t.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],ue([0,1,13]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=a,e.deepFreeze=A,e.cloneAndChange=k,e.mixin=T,e.equals=y,e.safeStringify=P,e.distinct=S,e.getCaseInsensitive=u,e.filter=p,e.getAllPropertyNames=c,e.getAllMethodNames=g,e.createProxyObject=f,e.mapValues=h;function a(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const I=Array.isArray(E)?[]:{};return Object.entries(E).forEach(([d,v])=>{I[d]=v&&typeof v=="object"?a(v):v}),I}function A(E){if(!E||typeof E!="object")return E;const I=[E];for(;I.length>0;){const d=I.shift();Object.freeze(d);for(const v in d)if(L.call(d,v)){const t=d[v];typeof t=="object"&&!Object.isFrozen(t)&&!(0,D.isTypedArray)(t)&&I.push(t)}}return E}const L=Object.prototype.hasOwnProperty;function k(E,I){return _(E,I,new Set)}function _(E,I,d){if((0,D.isUndefinedOrNull)(E))return E;const v=I(E);if(typeof v<"u")return v;if(Array.isArray(E)){const t=[];for(const r of E)t.push(_(r,I,d));return t}if((0,D.isObject)(E)){if(d.has(E))throw new Error("Cannot clone recursive data-structure");d.add(E);const t={};for(const r in E)L.call(E,r)&&(t[r]=_(E[r],I,d));return d.delete(E),t}return E}function T(E,I,d=!0){return(0,D.isObject)(E)?((0,D.isObject)(I)&&Object.keys(I).forEach(v=>{v in E?d&&((0,D.isObject)(E[v])&&(0,D.isObject)(I[v])?T(E[v],I[v],d):E[v]=I[v]):E[v]=I[v]}),E):I}function y(E,I){if(E===I)return!0;if(E==null||I===null||I===void 0||typeof E!=typeof I||typeof E!="object"||Array.isArray(E)!==Array.isArray(I))return!1;let d,v;if(Array.isArray(E)){if(E.length!==I.length)return!1;for(d=0;d<E.length;d++)if(!y(E[d],I[d]))return!1}else{const t=[];for(v in E)t.push(v);t.sort();const r=[];for(v in I)r.push(v);if(r.sort(),!y(t,r))return!1;for(d=0;d<t.length;d++)if(!y(E[t[d]],I[t[d]]))return!1}return!0}function P(E){const I=new Set;return JSON.stringify(E,(d,v)=>{if((0,D.isObject)(v)||Array.isArray(v)){if(I.has(v))return"[Circular]";I.add(v)}return typeof v=="bigint"?`[BigInt ${v.toString()}]`:v})}function S(E,I){const d=Object.create(null);return!E||!I||Object.keys(I).forEach(t=>{const r=E[t],s=I[t];y(r,s)||(d[t]=s)}),d}function u(E,I){const d=I.toLowerCase(),v=Object.keys(E).find(t=>t.toLowerCase()===d);return v?E[v]:E[I]}function p(E,I){const d=Object.create(null);for(const[v,t]of Object.entries(E))I(v,t)&&(d[v]=t);return d}function c(E){let I=[];for(;Object.prototype!==E;)I=I.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return I}function g(E){const I=[];for(const d of c(E))typeof E[d]=="function"&&I.push(d);return I}function f(E,I){const d=t=>function(){const r=Array.prototype.slice.call(arguments,0);return I(t,r)},v={};for(const t of E)v[t]=d(t);return v}function h(E,I){const d={};for(const[v,t]of Object.entries(E))d[v]=I(t,v);return d}}),define(le[136],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=a,e.toUint32=A;var D;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function a(L){return L<0?0:L>D.MAX_UINT_8?D.MAX_UINT_8:L|0}function A(L){return L<0?0:L>D.MAX_UINT_32?D.MAX_UINT_32:L|0}}),define(le[27],ue([0,1,134,39,54,136]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=k,e.format=T,e.format2=P,e.htmlAttributeEncodeValue=S,e.escape=u,e.escapeRegExpCharacters=p,e.count=c,e.truncate=g,e.truncateMiddle=f,e.trim=h,e.ltrim=E,e.rtrim=I,e.convertSimple2RegExpPattern=d,e.stripWildcards=v,e.createRegExp=t,e.regExpLeadsToEndlessLoop=r,e.splitLines=s,e.splitLinesIncludeSeparators=i,e.firstNonWhitespaceIndex=n,e.getLeadingWhitespace=o,e.lastNonWhitespaceIndex=l,e.replaceAsync=m,e.compare=w,e.compareSubstring=C,e.compareIgnoreCase=b,e.compareSubstringIgnoreCase=R,e.isAsciiDigit=U,e.isLowerAsciiLetter=N,e.isUpperAsciiLetter=M,e.equalsIgnoreCase=F,e.startsWithIgnoreCase=K,e.commonPrefixLength=H,e.commonSuffixLength=X,e.isHighSurrogate=j,e.isLowSurrogate=ie,e.computeCodePoint=z,e.getNextCodePoint=B,e.nextCharLength=W,e.prevCharLength=J,e.getCharContainingOffset=G,e.charCount=V,e.containsRTL=x,e.isBasicASCII=te,e.containsUnusualLineTerminators=Z,e.isFullWidthCharacter=Y,e.isEmojiImprecise=ae,e.lcut=he,e.forAnsiStringParts=ve,e.removeAnsiEscapeCodes=Ie,e.removeAnsiEscapeCodesFromPrompt=ye,e.startsWithUTF8BOM=Pe,e.stripUTF8BOM=Re,e.fuzzyContains=oe,e.containsUppercaseCharacter=fe,e.uppercaseFirstLetter=me,e.getNLines=Ce,e.singleLetterHash=De,e.getGraphemeBreakType=Ne,e.getLeftDeleteOffset=ze;function k(re){return!re||typeof re!="string"?!0:re.trim().length===0}const _=/{(\d+)}/g;function T(re,...de){return de.length===0?re:re.replace(_,function(Se,Ee){const Te=parseInt(Ee,10);return isNaN(Te)||Te<0||Te>=de.length?Se:de[Te]})}const y=/{([^}]+)}/g;function P(re,de){return Object.keys(de).length===0?re:re.replace(y,(Se,Ee)=>de[Ee]??Se)}function S(re){return re.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function u(re){return re.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function p(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(re,de){let Se=0,Ee=re.indexOf(de);for(;Ee!==-1;)Se++,Ee=re.indexOf(de,Ee+de.length);return Se}function g(re,de,Se="\u2026"){return re.length<=de?re:`${re.substr(0,de)}${Se}`}function f(re,de,Se="\u2026"){if(re.length<=de)return re;const Ee=Math.ceil(de/2)-Se.length/2,Te=Math.floor(de/2)-Se.length/2;return`${re.substr(0,Ee)}${Se}${re.substr(re.length-Te)}`}function h(re,de=" "){const Se=E(re,de);return I(Se,de)}function E(re,de){if(!re||!de)return re;const Se=de.length;if(Se===0||re.length===0)return re;let Ee=0;for(;re.indexOf(de,Ee)===Ee;)Ee=Ee+Se;return re.substring(Ee)}function I(re,de){if(!re||!de)return re;const Se=de.length,Ee=re.length;if(Se===0||Ee===0)return re;let Te=Ee,Ae=-1;for(;Ae=re.lastIndexOf(de,Te-1),!(Ae===-1||Ae+Se!==Te);){if(Ae===0)return"";Te=Ae}return re.substring(0,Te)}function d(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function v(re){return re.replace(/\*/g,"")}function t(re,de,Se={}){if(!re)throw new Error("Cannot create regex from empty string");de||(re=p(re)),Se.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let Ee="";return Se.global&&(Ee+="g"),Se.matchCase||(Ee+="i"),Se.multiline&&(Ee+="m"),Se.unicode&&(Ee+="u"),new RegExp(re,Ee)}function r(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function s(re){return re.split(/\r\n|\r|\n/)}function i(re){const de=[],Se=re.split(/(\r\n|\r|\n)/);for(let Ee=0;Ee<Math.ceil(Se.length/2);Ee++)de.push(Se[2*Ee]+(Se[2*Ee+1]??""));return de}function n(re){for(let de=0,Se=re.length;de<Se;de++){const Ee=re.charCodeAt(de);if(Ee!==a.CharCode.Space&&Ee!==a.CharCode.Tab)return de}return-1}function o(re,de=0,Se=re.length){for(let Ee=de;Ee<Se;Ee++){const Te=re.charCodeAt(Ee);if(Te!==a.CharCode.Space&&Te!==a.CharCode.Tab)return re.substring(de,Ee)}return re.substring(de,Se)}function l(re,de=re.length-1){for(let Se=de;Se>=0;Se--){const Ee=re.charCodeAt(Se);if(Ee!==a.CharCode.Space&&Ee!==a.CharCode.Tab)return Se}return-1}function m(re,de,Se){const Ee=[];let Te=0;for(const Ae of re.matchAll(de)){if(Ee.push(re.slice(Te,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");Te=Ae.index+Ae[0].length,Ee.push(Se(Ae[0],...Ae.slice(1),Ae.index,re,Ae.groups))}return Ee.push(re.slice(Te)),Promise.all(Ee).then(Ae=>Ae.join(""))}function w(re,de){return re<de?-1:re>de?1:0}function C(re,de,Se=0,Ee=re.length,Te=0,Ae=de.length){for(;Se<Ee&&Te<Ae;Se++,Te++){const He=re.charCodeAt(Se),Ke=de.charCodeAt(Te);if(He<Ke)return-1;if(He>Ke)return 1}const Me=Ee-Se,Qe=Ae-Te;return Me<Qe?-1:Me>Qe?1:0}function b(re,de){return R(re,de,0,re.length,0,de.length)}function R(re,de,Se=0,Ee=re.length,Te=0,Ae=de.length){for(;Se<Ee&&Te<Ae;Se++,Te++){let He=re.charCodeAt(Se),Ke=de.charCodeAt(Te);if(He===Ke)continue;if(He>=128||Ke>=128)return C(re.toLowerCase(),de.toLowerCase(),Se,Ee,Te,Ae);N(He)&&(He-=32),N(Ke)&&(Ke-=32);const Be=He-Ke;if(Be!==0)return Be}const Me=Ee-Se,Qe=Ae-Te;return Me<Qe?-1:Me>Qe?1:0}function U(re){return re>=a.CharCode.Digit0&&re<=a.CharCode.Digit9}function N(re){return re>=a.CharCode.a&&re<=a.CharCode.z}function M(re){return re>=a.CharCode.A&&re<=a.CharCode.Z}function F(re,de){return re.length===de.length&&R(re,de)===0}function K(re,de){const Se=de.length;return de.length>re.length?!1:R(re,de,0,Se)===0}function H(re,de){const Se=Math.min(re.length,de.length);let Ee;for(Ee=0;Ee<Se;Ee++)if(re.charCodeAt(Ee)!==de.charCodeAt(Ee))return Ee;return Se}function X(re,de){const Se=Math.min(re.length,de.length);let Ee;const Te=re.length-1,Ae=de.length-1;for(Ee=0;Ee<Se;Ee++)if(re.charCodeAt(Te-Ee)!==de.charCodeAt(Ae-Ee))return Ee;return Se}function j(re){return 55296<=re&&re<=56319}function ie(re){return 56320<=re&&re<=57343}function z(re,de){return(re-55296<<10)+(de-56320)+65536}function B(re,de,Se){const Ee=re.charCodeAt(Se);if(j(Ee)&&Se+1<de){const Te=re.charCodeAt(Se+1);if(ie(Te))return z(Ee,Te)}return Ee}function ee(re,de){const Se=re.charCodeAt(de-1);if(ie(Se)&&de>1){const Ee=re.charCodeAt(de-2);if(j(Ee))return z(Ee,Se)}return Se}class se{get offset(){return this._offset}constructor(de,Se=0){this._str=de,this._len=de.length,this._offset=Se}setOffset(de){this._offset=de}prevCodePoint(){const de=ee(this._str,this._offset);return this._offset-=de>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,de}nextCodePoint(){const de=B(this._str,this._len,this._offset);return this._offset+=de>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,de}eol(){return this._offset>=this._len}}e.CodePointIterator=se;class ce{get offset(){return this._iterator.offset}constructor(de,Se=0){this._iterator=new se(de,Se)}nextGraphemeLength(){const de=Oe.getInstance(),Se=this._iterator,Ee=Se.offset;let Te=de.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const Ae=Se.offset,Me=de.getGraphemeBreakType(Se.nextCodePoint());if(ke(Te,Me)){Se.setOffset(Ae);break}Te=Me}return Se.offset-Ee}prevGraphemeLength(){const de=Oe.getInstance(),Se=this._iterator,Ee=Se.offset;let Te=de.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const Ae=Se.offset,Me=de.getGraphemeBreakType(Se.prevCodePoint());if(ke(Me,Te)){Se.setOffset(Ae);break}Te=Me}return Ee-Se.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ce;function W(re,de){return new ce(re,de).nextGraphemeLength()}function J(re,de){return new ce(re,de).prevGraphemeLength()}function G(re,de){de>0&&ie(re.charCodeAt(de))&&de--;const Se=de+W(re,de);return[Se-J(re,Se),Se]}function V(re){const de=new ce(re);let Se=0;for(;!de.eol();)Se++,de.nextGraphemeLength();return Se}let O;function $(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function x(re){return O||(O=$()),O.test(re)}const q=/^[\t\n\r\x20-\x7E]*$/;function te(re){return q.test(re)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}function Y(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function ae(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function he(re,de,Se=""){const Ee=re.trimStart();if(Ee.length<de)return Ee;const Te=/\b/g;let Ae=0;for(;Te.test(Ee)&&!(Ee.length-Te.lastIndex<de);)Ae=Te.lastIndex,Te.lastIndex+=1;return Ae===0?Ee:Se+Ee.substring(Ae).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ve(re){let de=0;for(const Se of re.matchAll(ge))de!==Se.index&&(yield{isCode:!1,str:re.substring(de,Se.index)}),yield{isCode:!0,str:Se[0]},de=Se.index+Se[0].length;de!==re.length&&(yield{isCode:!1,str:re.substring(de)})}function Ie(re){return re&&(re=re.replace(ge,"")),re}const pe=/\\\[.*?\\\]/g;function ye(re){return Ie(re).replace(pe,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(a.CharCode.UTF8_BOM);function Pe(re){return!!(re&&re.length>0&&re.charCodeAt(0)===a.CharCode.UTF8_BOM)}function Re(re){return Pe(re)?re.substr(1):re}function oe(re,de){if(!re||!de||re.length<de.length)return!1;const Se=de.length,Ee=re.toLowerCase();let Te=0,Ae=-1;for(;Te<Se;){const Me=Ee.indexOf(de[Te],Ae+1);if(Me<0)return!1;Ae=Me,Te++}return!0}function fe(re,de=!1){return re?(de&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function me(re){return re.charAt(0).toUpperCase()+re.slice(1)}function Ce(re,de=1){if(de===0)return"";let Se=-1;do Se=re.indexOf(`
`,Se+1),de--;while(de>0&&Se>=0);return Se===-1?re:(re[Se-1]==="\r"&&Se--,re.substr(0,Se))}function De(re){const de=a.CharCode.Z-a.CharCode.A+1;return re=re%(2*de),re<de?String.fromCharCode(a.CharCode.a+re):String.fromCharCode(a.CharCode.A+re-de)}function Ne(re){return Oe.getInstance().getGraphemeBreakType(re)}function ke(re,de){return re===Le.Other?de!==Le.Extend&&de!==Le.SpacingMark:re===Le.CR&&de===Le.LF?!1:re===Le.Control||re===Le.CR||re===Le.LF||de===Le.Control||de===Le.CR||de===Le.LF?!0:!(re===Le.L&&(de===Le.L||de===Le.V||de===Le.LV||de===Le.LVT)||(re===Le.LV||re===Le.V)&&(de===Le.V||de===Le.T)||(re===Le.LVT||re===Le.T)&&de===Le.T||de===Le.Extend||de===Le.ZWJ||de===Le.SpacingMark||re===Le.Prepend||re===Le.ZWJ&&de===Le.Extended_Pictographic||re===Le.Regional_Indicator&&de===Le.Regional_Indicator)}var Le;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Oe{static{this._INSTANCE=null}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}constructor(){this._data=xe()}getGraphemeBreakType(de){if(de<32)return de===a.CharCode.LineFeed?Le.LF:de===a.CharCode.CarriageReturn?Le.CR:Le.Control;if(de<127)return Le.Other;const Se=this._data,Ee=Se.length/3;let Te=1;for(;Te<=Ee;)if(de<Se[3*Te])Te=2*Te;else if(de>Se[3*Te+1])Te=2*Te+1;else return Se[3*Te+2];return Le.Other}}function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(re,de){if(re===0)return 0;const Se=Fe(re,de);if(Se!==void 0)return Se;const Ee=new se(de,re);return Ee.prevCodePoint(),Ee.offset}function Fe(re,de){const Se=new se(de,re);let Ee=Se.prevCodePoint();for(;We(Ee)||Ee===$e.emojiVariantSelector||Ee===$e.enclosingKeyCap;){if(Se.offset===0)return;Ee=Se.prevCodePoint()}if(!ae(Ee))return;let Te=Se.offset;return Te>0&&Se.prevCodePoint()===$e.zwj&&(Te=Se.offset),Te}function We(re){return 127995<=re&&re<=127999}var $e;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})($e||($e={})),e.noBreakWhitespace="\xA0";class qe{static{this.ambiguousCharacterData=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new D.LRUCachedFunction({getCacheKey:JSON.stringify},de=>{function Se(Be){const Je=new Map;for(let Ye=0;Ye<Be.length;Ye+=2)Je.set(Be[Ye],Be[Ye+1]);return Je}function Ee(Be,Je){const Ye=new Map(Be);for(const[tt,st]of Je)Ye.set(tt,st);return Ye}function Te(Be,Je){if(!Be)return Je;const Ye=new Map;for(const[tt,st]of Be)Je.has(tt)&&Ye.set(tt,st);return Ye}const Ae=this.ambiguousCharacterData.value;let Me=de.filter(Be=>!Be.startsWith("_")&&Be in Ae);Me.length===0&&(Me=["_default"]);let Qe;for(const Be of Me){const Je=Se(Ae[Be]);Qe=Te(Qe,Je)}const He=Se(Ae._common),Ke=Ee(He,Qe);return new qe(Ke)})}static getInstance(de){return qe.cache.get(Array.from(de))}static{this._locales=new A.Lazy(()=>Object.keys(qe.ambiguousCharacterData.value).filter(de=>!de.startsWith("_")))}static getLocales(){return qe._locales.value}constructor(de){this.confusableDictionary=de}isAmbiguous(de){return this.confusableDictionary.has(de)}containsAmbiguousCharacter(de){for(let Se=0;Se<de.length;Se++){const Ee=de.codePointAt(Se);if(typeof Ee=="number"&&this.isAmbiguous(Ee))return!0}return!1}getPrimaryConfusable(de){return this.confusableDictionary.get(de)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=qe;class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(de){return _e.getData().has(de)}static containsInvisibleCharacter(de){for(let Se=0;Se<de.length;Se++){const Ee=de.codePointAt(Se);if(typeof Ee=="number"&&_e.isInvisibleCharacter(Ee))return!0}return!1}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e}),define(le[55],ue([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=a,e.doHash=A,e.numberHash=L,e.stringHash=_,e.toHexString=g;function a(h){return A(h,0)}function A(h,E){switch(typeof h){case"object":return h===null?L(349,E):Array.isArray(h)?T(h,E):y(h,E);case"string":return _(h,E);case"boolean":return k(h,E);case"number":return L(h,E);case"undefined":return L(937,E);default:return L(617,E)}}function L(h,E){return(E<<5)-E+h|0}function k(h,E){return L(h?433:863,E)}function _(h,E){E=L(149417,E);for(let I=0,d=h.length;I<d;I++)E=L(h.charCodeAt(I),E);return E}function T(h,E){return E=L(104579,E),h.reduce((I,d)=>A(d,I),E)}function y(h,E){return E=L(181387,E),Object.keys(h).sort().reduce((I,d)=>(I=_(d,I),A(h[d],I)),E)}class P{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=A(E,this._value),this._value}}e.Hasher=P;var S;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function u(h,E,I=32){const d=I-E,v=~((1<<d)-1);return(h<<E|(v&h)>>>d)>>>0}function p(h,E=0,I=h.byteLength,d=0){for(let v=0;v<I;v++)h[E+v]=d}function c(h,E,I="0"){for(;h.length<E;)h=I+h;return h}function g(h,E=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(I=>I.toString(16).padStart(2,"0")).join(""):c((h>>>0).toString(16),E/4)}class f{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(S.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const I=E.length;if(I===0)return;const d=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=E.charCodeAt(0),s=0);;){let i=r;if(D.isHighSurrogate(r))if(s+1<I){const n=E.charCodeAt(s+1);D.isLowSurrogate(n)?(s++,i=D.computeCodePoint(r,n)):i=S.UNICODE_REPLACEMENT}else{t=r;break}else D.isLowSurrogate(r)&&(i=S.UNICODE_REPLACEMENT);if(v=this._push(d,v,i),s++,s<I)r=E.charCodeAt(s);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(E,I,d){return d<128?E[I++]=d:d<2048?(E[I++]=192|(d&1984)>>>6,E[I++]=128|(d&63)>>>0):d<65536?(E[I++]=224|(d&61440)>>>12,E[I++]=128|(d&4032)>>>6,E[I++]=128|(d&63)>>>0):(E[I++]=240|(d&1835008)>>>18,E[I++]=128|(d&258048)>>>12,E[I++]=128|(d&4032)>>>6,E[I++]=128|(d&63)>>>0),I>=S.BLOCK_SIZE&&(this._step(),I-=S.BLOCK_SIZE,this._totalLen+=S.BLOCK_SIZE,E[0]=E[S.BLOCK_SIZE+0],E[1]=E[S.BLOCK_SIZE+1],E[2]=E[S.BLOCK_SIZE+2]),I}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,S.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=f._bigBlock32,I=this._buffDV;for(let l=0;l<64;l+=4)E.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)E.setUint32(l,u(E.getUint32(l-12,!1)^E.getUint32(l-32,!1)^E.getUint32(l-56,!1)^E.getUint32(l-64,!1),1),!1);let d=this._h0,v=this._h1,t=this._h2,r=this._h3,s=this._h4,i,n,o;for(let l=0;l<80;l++)l<20?(i=v&t|~v&r,n=1518500249):l<40?(i=v^t^r,n=1859775393):l<60?(i=v&t|v&r|t&r,n=2400959708):(i=v^t^r,n=3395469782),o=u(d,5)+i+s+n+E.getUint32(l*4,!1)&4294967295,s=r,r=t,t=u(v,30),v=d,d=o;this._h0=this._h0+d&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=f}),define(le[92],ue([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var a;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(a||(a={})),function(A){const L="error",k="warning",_="warn",T="info",y="ignore";function P(u){return u?D.equalsIgnoreCase(L,u)?A.Error:D.equalsIgnoreCase(k,u)||D.equalsIgnoreCase(_,u)?A.Warning:D.equalsIgnoreCase(T,u)?A.Info:A.Ignore:A.Ignore}A.fromValue=P;function S(u){switch(u){case A.Error:return L;case A.Warning:return k;case A.Info:return T;default:return y}}A.toString=S}(a||(a={})),e.default=a}),define(le[52],ue([0,1,19,39,27]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class L{constructor(){this._value="",this._pos=0}reset(c){return this._value=c,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(c){const g=c.charCodeAt(0),f=this._value.charCodeAt(this._pos);return g-f}value(){return this._value[this._pos]}}e.StringIterator=L;class k{constructor(c=!0){this._caseSensitive=c}reset(c){return this._value=c,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let c=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===a.CharCode.Period)if(c)this._from++;else break;else c=!1;return this}cmp(c){return this._caseSensitive?(0,A.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class _{constructor(c=!0,g=!0){this._splitOnBackslash=c,this._caseSensitive=g}reset(c){this._from=0,this._to=0,this._value=c,this._valueLen=c.length;for(let g=c.length-1;g>=0;g--,this._valueLen--){const f=this._value.charCodeAt(g);if(!(f===a.CharCode.Slash||this._splitOnBackslash&&f===a.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let c=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===a.CharCode.Slash||this._splitOnBackslash&&g===a.CharCode.Backslash)if(c)this._from++;else break;else c=!1}return this}cmp(c){return this._caseSensitive?(0,A.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var T;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(T||(T={}));class y{constructor(c,g){this._ignorePathCasing=c,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(c){return this._value=c,this._states=[],this._value.scheme&&this._states.push(T.Scheme),this._value.authority&&this._states.push(T.Authority),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(c)),this._pathIterator.reset(c.path),this._pathIterator.value()&&this._states.push(T.Path)),this._ignoreQueryAndFragment(c)||(this._value.query&&this._states.push(T.Query),this._value.fragment&&this._states.push(T.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===T.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===T.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(c){if(this._states[this._stateIdx]===T.Scheme)return(0,A.compareIgnoreCase)(c,this._value.scheme);if(this._states[this._stateIdx]===T.Authority)return(0,A.compareIgnoreCase)(c,this._value.authority);if(this._states[this._stateIdx]===T.Path)return this._pathIterator.cmp(c);if(this._states[this._stateIdx]===T.Query)return(0,A.compare)(c,this._value.query);if(this._states[this._stateIdx]===T.Fragment)return(0,A.compare)(c,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===T.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===T.Authority)return this._value.authority;if(this._states[this._stateIdx]===T.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===T.Query)return this._value.query;if(this._states[this._stateIdx]===T.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=y;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(S||(S={}));class u{static forUris(c=()=>!1,g=()=>!1){return new u(new y(c,g))}static forPaths(c=!1){return new u(new _(void 0,!c))}static forStrings(){return new u(new L)}static forConfigKeys(){return new u(new k)}constructor(c){this._iter=c}clear(){this._root=void 0}fill(c,g){if(g){const f=g.slice(0);(0,D.shuffle)(f);for(const h of f)this.set(h,c)}else{const f=c.slice(0);(0,D.shuffle)(f);for(const h of f)this.set(h[0],h[1])}}set(c,g){const f=this._iter.reset(c);let h;this._root||(this._root=new P,this._root.segment=f.value());const E=[];for(h=this._root;;){const d=f.cmp(h.segment);if(d>0)h.left||(h.left=new P,h.left.segment=f.value()),E.push([S.Left,h]),h=h.left;else if(d<0)h.right||(h.right=new P,h.right.segment=f.value()),E.push([S.Right,h]),h=h.right;else if(f.hasNext())f.next(),h.mid||(h.mid=new P,h.mid.segment=f.value()),E.push([S.Mid,h]),h=h.mid;else break}const I=h.value;h.value=g,h.key=c;for(let d=E.length-1;d>=0;d--){const v=E[d][1];v.updateHeight();const t=v.balanceFactor();if(t<-1||t>1){const r=E[d][0],s=E[d+1][0];if(r===S.Right&&s===S.Right)E[d][1]=v.rotateLeft();else if(r===S.Left&&s===S.Left)E[d][1]=v.rotateRight();else if(r===S.Right&&s===S.Left)v.right=E[d+1][1]=E[d+1][1].rotateRight(),E[d][1]=v.rotateLeft();else if(r===S.Left&&s===S.Right)v.left=E[d+1][1]=E[d+1][1].rotateLeft(),E[d][1]=v.rotateRight();else throw new Error;if(d>0)switch(E[d-1][0]){case S.Left:E[d-1][1].left=E[d][1];break;case S.Right:E[d-1][1].right=E[d][1];break;case S.Mid:E[d-1][1].mid=E[d][1];break}else this._root=E[0][1]}}return I}get(c){return this._getNode(c)?.value}_getNode(c){const g=this._iter.reset(c);let f=this._root;for(;f;){const h=g.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(g.hasNext())g.next(),f=f.mid;else break}return f}has(c){const g=this._getNode(c);return!(g?.value===void 0&&g?.mid===void 0)}delete(c){return this._delete(c,!1)}deleteSuperstr(c){return this._delete(c,!0)}_delete(c,g){const f=this._iter.reset(c),h=[];let E=this._root;for(;E;){const I=f.cmp(E.segment);if(I>0)h.push([S.Left,E]),E=E.left;else if(I<0)h.push([S.Right,E]),E=E.right;else if(f.hasNext())f.next(),h.push([S.Mid,E]),E=E.mid;else break}if(E){if(g?(E.left=void 0,E.mid=void 0,E.right=void 0,E.height=1):(E.key=void 0,E.value=void 0),!E.mid&&!E.value)if(E.left&&E.right){const I=this._min(E.right);if(I.key){const{key:d,value:v,segment:t}=I;this._delete(I.key,!1),E.key=d,E.value=v,E.segment=t}}else{const I=E.left??E.right;if(h.length>0){const[d,v]=h[h.length-1];switch(d){case S.Left:v.left=I;break;case S.Mid:v.mid=I;break;case S.Right:v.right=I;break}}else this._root=I}for(let I=h.length-1;I>=0;I--){const d=h[I][1];d.updateHeight();const v=d.balanceFactor();if(v>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),h[I][1]=d.rotateLeft()):v<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),h[I][1]=d.rotateRight()),I>0)switch(h[I-1][0]){case S.Left:h[I-1][1].left=h[I][1];break;case S.Right:h[I-1][1].right=h[I][1];break;case S.Mid:h[I-1][1].mid=h[I][1];break}else this._root=h[0][1]}}}_min(c){for(;c.left;)c=c.left;return c}findSubstr(c){const g=this._iter.reset(c);let f=this._root,h;for(;f;){const E=g.cmp(f.segment);if(E>0)f=f.left;else if(E<0)f=f.right;else if(g.hasNext())g.next(),h=f.value||h,f=f.mid;else break}return f&&f.value||h}findSuperstr(c){return this._findSuperstrOrElement(c,!1)}_findSuperstrOrElement(c,g){const f=this._iter.reset(c);let h=this._root;for(;h;){const E=f.cmp(h.segment);if(E>0)h=h.left;else if(E<0)h=h.right;else if(f.hasNext())f.next(),h=h.mid;else return h.mid?this._entries(h.mid):g?h.value:void 0}}hasElementOrSubtree(c){return this._findSuperstrOrElement(c,!0)!==void 0}forEach(c){for(const[g,f]of this)c(f,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(c){const g=[];return this._dfsEntries(c,g),g[Symbol.iterator]()}_dfsEntries(c,g){c&&(c.left&&this._dfsEntries(c.left,g),c.value&&g.push([c.key,c.value]),c.mid&&this._dfsEntries(c.mid,g),c.right&&this._dfsEntries(c.right,g))}_isBalanced(){const c=g=>{if(!g)return!0;const f=g.balanceFactor();return f<-1||f>1?!1:c(g.left)&&c(g.right)};return c(this._root)}}e.TernarySearchTree=u}),define(le[32],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=a;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(A){return D.test(A)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(_){for(let T=0;T<_.length;T++)_[T]=Math.floor(Math.random()*256);return _};const L=new Uint8Array(16),k=[];for(let _=0;_<256;_++)k.push(_.toString(16).padStart(2,"0"));return function(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let T=0,y="";return y+=k[L[T++]],y+=k[L[T++]],y+=k[L[T++]],y+=k[L[T++]],y+="-",y+=k[L[T++]],y+=k[L[T++]],y+="-",y+=k[L[T++]],y+=k[L[T++]],y+="-",y+=k[L[T++]],y+=k[L[T++]],y+="-",y+=k[L[T++]],y+=k[L[T++]],y+=k[L[T++]],y+=k[L[T++]],y+=k[L[T++]],y+=k[L[T++]],y}}()}),define(le[137],ue([0,1,38]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=L;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(k){const _=k.replace(/\-/g,":").toLowerCase();return!a.has(_)}function L(){const k=(0,D.networkInterfaces)();for(const _ in k){const T=k[_];if(T){for(const{mac:y}of T)if(A(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[138],ue([0,1,276,15]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class A extends D.Transform{constructor(k){if(super(),typeof k=="number")this.splitter=k,this.spitterLen=1;else{const _=Buffer.isBuffer(k)?k:Buffer.from(k);this.splitter=_.length===1?_[0]:_,this.spitterLen=_.length}}_transform(k,_,T){this.buffer?this.buffer=Buffer.concat([this.buffer,k]):this.buffer=k;let y=0;for(;y<this.buffer.length;){const P=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,y):(0,a.binaryIndexOf)(this.buffer,this.splitter,y);if(P===-1)break;this.push(this.buffer.slice(y,P+this.spitterLen)),y=P+this.spitterLen}this.buffer=y===this.buffer.length?void 0:this.buffer.slice(y),T()}_flush(k){this.buffer&&this.push(this.buffer),k()}}e.StreamSplitter=A}),define(le[139],ue([0,1,66]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=a,e.findFreePortFaster=L;function a(_,T,y,P=1){let S=!1;return new Promise(u=>{const p=setTimeout(()=>{if(!S)return S=!0,u(0)},y);A(_,T,P,c=>{if(!S)return S=!0,clearTimeout(p),u(c)})})}function A(_,T,y,P){if(T===0)return P(0);const S=new D.Socket;S.once("connect",()=>(k(S),A(_+y,T-1,y,P))),S.once("data",()=>{}),S.once("error",u=>(k(S),u.code!=="ECONNREFUSED"?A(_+y,T-1,y,P):P(_))),S.connect(_,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(_,T,y,P="127.0.0.1"){let S=!1,u,p=1;const c=D.createServer({pauseOnConnect:!0});function g(f,h){S||(S=!0,c.removeAllListeners(),c.close(),u&&clearTimeout(u),h(f))}return new Promise(f=>{u=setTimeout(()=>{g(0,f)},y),c.on("listening",()=>{g(_,f)}),c.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&p<T?(_++,p++,c.listen(_,P)):g(0,f)}),c.on("close",()=>{g(0,f)}),c.listen(_,P)})}function k(_){try{_.removeAllListeners("connect"),_.removeAllListeners("error"),_.end(),_.destroy(),_.unref()}catch(T){console.error(T)}}}),define(le[140],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=D;function D(a){return!!a.parentPort}}),define(le[141],ue([12,11]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(le[67],ue([0,1,141]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=y,e.getDurationString=P,e.toLocalISOString=S;const a=60,A=a*60,L=A*24,k=L*7,_=L*30,T=L*365;function y(u,p,c,g){typeof u!="number"&&(u=u.getTime());const f=Math.round((new Date().getTime()-u)/1e3);if(f<-30)return(0,D.localize)(0,null,y(new Date().getTime()+f*1e3,!1));if(!g&&f<30)return(0,D.localize)(1,null);let h;return f<a?(h=f,p?h===1?c?(0,D.localize)(2,null,h):(0,D.localize)(3,null,h):c?(0,D.localize)(4,null,h):(0,D.localize)(5,null,h):h===1?c?(0,D.localize)(6,null,h):(0,D.localize)(7,null,h):c?(0,D.localize)(8,null,h):(0,D.localize)(9,null,h)):f<A?(h=Math.floor(f/a),p?h===1?c?(0,D.localize)(10,null,h):(0,D.localize)(11,null,h):c?(0,D.localize)(12,null,h):(0,D.localize)(13,null,h):h===1?c?(0,D.localize)(14,null,h):(0,D.localize)(15,null,h):c?(0,D.localize)(16,null,h):(0,D.localize)(17,null,h)):f<L?(h=Math.floor(f/A),p?h===1?c?(0,D.localize)(18,null,h):(0,D.localize)(19,null,h):c?(0,D.localize)(20,null,h):(0,D.localize)(21,null,h):h===1?c?(0,D.localize)(22,null,h):(0,D.localize)(23,null,h):c?(0,D.localize)(24,null,h):(0,D.localize)(25,null,h)):f<k?(h=Math.floor(f/L),p?h===1?(0,D.localize)(26,null,h):(0,D.localize)(27,null,h):h===1?(0,D.localize)(28,null,h):(0,D.localize)(29,null,h)):f<_?(h=Math.floor(f/k),p?h===1?c?(0,D.localize)(30,null,h):(0,D.localize)(31,null,h):c?(0,D.localize)(32,null,h):(0,D.localize)(33,null,h):h===1?c?(0,D.localize)(34,null,h):(0,D.localize)(35,null,h):c?(0,D.localize)(36,null,h):(0,D.localize)(37,null,h)):f<T?(h=Math.floor(f/_),p?h===1?c?(0,D.localize)(38,null,h):(0,D.localize)(39,null,h):c?(0,D.localize)(40,null,h):(0,D.localize)(41,null,h):h===1?c?(0,D.localize)(42,null,h):(0,D.localize)(43,null,h):c?(0,D.localize)(44,null,h):(0,D.localize)(45,null,h)):(h=Math.floor(f/T),p?h===1?c?(0,D.localize)(46,null,h):(0,D.localize)(47,null,h):c?(0,D.localize)(48,null,h):(0,D.localize)(49,null,h):h===1?c?(0,D.localize)(50,null,h):(0,D.localize)(51,null,h):c?(0,D.localize)(52,null,h):(0,D.localize)(53,null,h))}function P(u,p){const c=Math.abs(u/1e3);return c<1?p?(0,D.localize)(54,null,u):(0,D.localize)(55,null,u):c<a?p?(0,D.localize)(56,null,Math.round(u)/1e3):(0,D.localize)(57,null,Math.round(u)/1e3):c<A?p?(0,D.localize)(58,null,Math.round(u/(1e3*a))):(0,D.localize)(59,null,Math.round(u/(1e3*a))):c<L?p?(0,D.localize)(60,null,Math.round(u/(1e3*A))):(0,D.localize)(61,null,Math.round(u/(1e3*A))):(0,D.localize)(62,null,Math.round(u/(1e3*L)))}function S(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[142],ue([12,11]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(le[40],ue([0,1,19,13,142]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=T,e.isErrorWithActions=y,e.createErrorWithActions=P;function L(S,u){return u&&(S.stack||S.stacktrace)?A.localize(0,null,_(S),k(S.stack)||k(S.stacktrace)):_(S)}function k(S){return Array.isArray(S)?S.join(`
`):S}function _(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?A.localize(1,null,S.message):S.message||A.localize(2,null)}function T(S=null,u=!1){if(!S)return A.localize(3,null);if(Array.isArray(S)){const p=D.coalesce(S),c=T(p[0],u);return p.length>1?A.localize(4,null,c,p.length):c}if(a.isString(S))return S;if(S.detail){const p=S.detail;if(p.error)return L(p.error,u);if(p.exception)return L(p.exception,u)}return S.stack?L(S,u):S.message?S.message:A.localize(5,null)}function y(S){const u=S;return u instanceof Error&&Array.isArray(u.actions)}function P(S,u){let p;return typeof S=="string"?p=new Error(S):p=S,p.actions=u,p}}),define(le[143],ue([12,11]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(le[144],ue([0,1,143,34]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=A;function A(L){switch(L){case a.ParseErrorCode.InvalidSymbol:return(0,D.localize)(0,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,D.localize)(1,null);case a.ParseErrorCode.PropertyNameExpected:return(0,D.localize)(2,null);case a.ParseErrorCode.ValueExpected:return(0,D.localize)(3,null);case a.ParseErrorCode.ColonExpected:return(0,D.localize)(4,null);case a.ParseErrorCode.CommaExpected:return(0,D.localize)(5,null);case a.ParseErrorCode.CloseBraceExpected:return(0,D.localize)(6,null);case a.ParseErrorCode.CloseBracketExpected:return(0,D.localize)(7,null);case a.ParseErrorCode.EndOfFileExpected:return(0,D.localize)(8,null);default:return""}}}),define(le[145],ue([12,11]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(le[5],ue([0,1,145]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=r,e.isLittleEndian=m,e.isBigSurOrNewer=w,e.LANGUAGE_DEFAULT="en";let a=!1,A=!1,L=!1,k=!1,_=!1,T=!1,y=!1,P=!1,S=!1,u=!1,p,c=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT,f,h;const E=globalThis;let I;typeof E.vscode<"u"&&typeof E.vscode.process<"u"?I=E.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(I=process);const d=typeof I?.versions?.electron=="string",v=d&&I?.type==="renderer";if(typeof I=="object"){a=I.platform==="win32",A=I.platform==="darwin",L=I.platform==="linux",k=L&&!!I.env.SNAP&&!!I.env.SNAP_REVISION,y=d,S=!!I.env.CI||!!I.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.LANGUAGE_DEFAULT,c=e.LANGUAGE_DEFAULT;const C=I.env.VSCODE_NLS_CONFIG;if(C)try{const b=JSON.parse(C),R=b.availableLanguages["*"];p=b.locale,g=b.osLocale,c=R||e.LANGUAGE_DEFAULT,f=b._translationsConfigFile}catch{}_=!0}else typeof navigator=="object"&&!v?(h=navigator.userAgent,a=h.indexOf("Windows")>=0,A=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=h.indexOf("Linux")>=0,u=h?.indexOf("Mobi")>=0,T=!0,p=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,c=p,g=navigator.language):console.error("Unable to resolve platform.");var t;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(C){switch(C){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let s=t.Web;A?s=t.Mac:a?s=t.Windows:L&&(s=t.Linux),e.isWindows=a,e.isMacintosh=A,e.isLinux=L,e.isLinuxSnap=k,e.isNative=_,e.isElectron=y,e.isWeb=T,e.isWebWorker=T&&typeof E.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?E.origin:void 0,e.isIOS=P,e.isMobile=u,e.isCI=S,e.platform=s,e.userAgent=h,e.language=c;var i;(function(C){function b(){return e.language}C.value=b;function R(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}C.isDefaultVariant=R;function U(){return e.language==="en"}C.isDefault=U})(i||(e.Language=i={})),e.locale=p,e.platformLocale=g,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof E.postMessage=="function"&&!E.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const C=[];E.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let U=0,N=C.length;U<N;U++){const M=C[U];if(M.id===R.data.vscodeScheduleAsyncWork){C.splice(U,1),M.callback();return}}});let b=0;return R=>{const U=++b;C.push({id:U,callback:R}),E.postMessage({vscodeScheduleAsyncWork:U},"*")}}return C=>setTimeout(C)})();var n;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=A||P?n.Macintosh:a?n.Windows:n.Linux;let o=!0,l=!1;function m(){if(!l){l=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,o=new Uint16Array(C.buffer)[0]===513}return o}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function w(C){return parseFloat(C)>=20}}),define(le[36],ue([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let a;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const L=A.process;a={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.platform=a.platform,e.arch=a.arch}),define(le[146],ue([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDesktopEnvironment=k;var a;(function(_){_.UNKNOWN="UNKNOWN",_.CINNAMON="CINNAMON",_.DEEPIN="DEEPIN",_.GNOME="GNOME",_.KDE3="KDE3",_.KDE4="KDE4",_.KDE5="KDE5",_.KDE6="KDE6",_.PANTHEON="PANTHEON",_.UNITY="UNITY",_.XFCE="XFCE",_.UKUI="UKUI",_.LXQT="LXQT"})(a||(a={}));const A="XDG_CURRENT_DESKTOP",L="KDE_SESSION_VERSION";function k(){const _=D.env[A];if(_){const y=_.split(":").map(P=>P.trim()).filter(P=>P.length>0);for(const P of y)switch(P){case"Unity":{const S=D.env.DESKTOP_SESSION;return S&&S.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const S=D.env[L];return S==="5"?a.KDE5:S==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const T=D.env.DESKTOP_SESSION;if(T)switch(T){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return L in D.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in D.env?a.GNOME:"KDE_FULL_SESSION"in D.env?L in D.env?a.KDE4:a.KDE3:a.UNKNOWN}}),define(le[14],ue([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const a=65,A=97,L=90,k=122,_=46,T=47,y=92,P=58,S=63;class u extends Error{constructor(r,s,i){let n;typeof s=="string"&&s.indexOf("not ")===0?(n="must not be",s=s.replace(/^not /,"")):n="must be";const o=r.indexOf(".")!==-1?"property":"argument";let l=`The "${r}" ${o} ${n} of type ${s}`;l+=`. Received type ${typeof i}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function p(t,r){if(t===null||typeof t!="object")throw new u(r,"Object",t)}function c(t,r){if(typeof t!="string")throw new u(r,"string",t)}const g=D.platform==="win32";function f(t){return t===T||t===y}function h(t){return t===T}function E(t){return t>=a&&t<=L||t>=A&&t<=k}function I(t,r,s,i){let n="",o=0,l=-1,m=0,w=0;for(let C=0;C<=t.length;++C){if(C<t.length)w=t.charCodeAt(C);else{if(i(w))break;w=T}if(i(w)){if(!(l===C-1||m===1))if(m===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==_||n.charCodeAt(n.length-2)!==_){if(n.length>2){const b=n.lastIndexOf(s);b===-1?(n="",o=0):(n=n.slice(0,b),o=n.length-1-n.lastIndexOf(s)),l=C,m=0;continue}else if(n.length!==0){n="",o=0,l=C,m=0;continue}}r&&(n+=n.length>0?`${s}..`:"..",o=2)}else n.length>0?n+=`${s}${t.slice(l+1,C)}`:n=t.slice(l+1,C),o=C-l-1;l=C,m=0}else w===_&&m!==-1?++m:m=-1}return n}function d(t,r){p(r,"pathObject");const s=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${i}`:`${s}${t}${i}`:i}e.win32={resolve(...t){let r="",s="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],c(o,"path"),o.length===0)continue}else r.length===0?o=D.cwd():(o=D.env[`=${r}`]||D.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===y)&&(o=`${r}\\`));const l=o.length;let m=0,w="",C=!1;const b=o.charCodeAt(0);if(l===1)f(b)&&(m=1,C=!0);else if(f(b))if(C=!0,f(o.charCodeAt(1))){let R=2,U=R;for(;R<l&&!f(o.charCodeAt(R));)R++;if(R<l&&R!==U){const N=o.slice(U,R);for(U=R;R<l&&f(o.charCodeAt(R));)R++;if(R<l&&R!==U){for(U=R;R<l&&!f(o.charCodeAt(R));)R++;(R===l||R!==U)&&(w=`\\\\${N}\\${o.slice(U,R)}`,m=R)}}}else m=1;else E(b)&&o.charCodeAt(1)===P&&(w=o.slice(0,2),m=2,l>2&&f(o.charCodeAt(2))&&(C=!0,m=3));if(w.length>0)if(r.length>0){if(w.toLowerCase()!==r.toLowerCase())continue}else r=w;if(i){if(r.length>0)break}else if(s=`${o.slice(m)}\\${s}`,i=C,C&&r.length>0)break}return s=I(s,!i,"\\",f),i?`${r}\\${s}`:`${r}${s}`||"."},normalize(t){c(t,"path");const r=t.length;if(r===0)return".";let s=0,i,n=!1;const o=t.charCodeAt(0);if(r===1)return h(o)?"\\":t;if(f(o))if(n=!0,f(t.charCodeAt(1))){let m=2,w=m;for(;m<r&&!f(t.charCodeAt(m));)m++;if(m<r&&m!==w){const C=t.slice(w,m);for(w=m;m<r&&f(t.charCodeAt(m));)m++;if(m<r&&m!==w){for(w=m;m<r&&!f(t.charCodeAt(m));)m++;if(m===r)return`\\\\${C}\\${t.slice(w)}\\`;m!==w&&(i=`\\\\${C}\\${t.slice(w,m)}`,s=m)}}}else s=1;else E(o)&&t.charCodeAt(1)===P&&(i=t.slice(0,2),s=2,r>2&&f(t.charCodeAt(2))&&(n=!0,s=3));let l=s<r?I(t.slice(s),!n,"\\",f):"";return l.length===0&&!n&&(l="."),l.length>0&&f(t.charCodeAt(r-1))&&(l+="\\"),i===void 0?n?`\\${l}`:l:n?`${i}\\${l}`:`${i}${l}`},isAbsolute(t){c(t,"path");const r=t.length;if(r===0)return!1;const s=t.charCodeAt(0);return f(s)||r>2&&E(s)&&t.charCodeAt(1)===P&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,s;for(let o=0;o<t.length;++o){const l=t[o];c(l,"path"),l.length>0&&(r===void 0?r=s=l:r+=`\\${l}`)}if(r===void 0)return".";let i=!0,n=0;if(typeof s=="string"&&f(s.charCodeAt(0))){++n;const o=s.length;o>1&&f(s.charCodeAt(1))&&(++n,o>2&&(f(s.charCodeAt(2))?++n:i=!1))}if(i){for(;n<r.length&&f(r.charCodeAt(n));)n++;n>=2&&(r=`\\${r.slice(n)}`)}return e.win32.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r)return"";const s=e.win32.resolve(t),i=e.win32.resolve(r);if(s===i||(t=s.toLowerCase(),r=i.toLowerCase(),t===r))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===y;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===y;)o--;const l=o-n;let m=0;for(;m<r.length&&r.charCodeAt(m)===y;)m++;let w=r.length;for(;w-1>m&&r.charCodeAt(w-1)===y;)w--;const C=w-m,b=l<C?l:C;let R=-1,U=0;for(;U<b;U++){const M=t.charCodeAt(n+U);if(M!==r.charCodeAt(m+U))break;M===y&&(R=U)}if(U!==b){if(R===-1)return i}else{if(C>b){if(r.charCodeAt(m+U)===y)return i.slice(m+U+1);if(U===2)return i.slice(m+U)}l>b&&(t.charCodeAt(n+U)===y?R=U:U===2&&(R=3)),R===-1&&(R=0)}let N="";for(U=n+R+1;U<=o;++U)(U===o||t.charCodeAt(U)===y)&&(N+=N.length===0?"..":"\\..");return m+=R,N.length>0?`${N}${i.slice(m,w)}`:(i.charCodeAt(m)===y&&++m,i.slice(m,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.win32.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const s=r.charCodeAt(2);if(s!==S&&s!==_)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(E(r.charCodeAt(0))&&r.charCodeAt(1)===P&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return t},dirname(t){c(t,"path");const r=t.length;if(r===0)return".";let s=-1,i=0;const n=t.charCodeAt(0);if(r===1)return f(n)?t:".";if(f(n)){if(s=i=1,f(t.charCodeAt(1))){let m=2,w=m;for(;m<r&&!f(t.charCodeAt(m));)m++;if(m<r&&m!==w){for(w=m;m<r&&f(t.charCodeAt(m));)m++;if(m<r&&m!==w){for(w=m;m<r&&!f(t.charCodeAt(m));)m++;if(m===r)return t;m!==w&&(s=i=m+1)}}}}else E(n)&&t.charCodeAt(1)===P&&(s=r>2&&f(t.charCodeAt(2))?3:2,i=s);let o=-1,l=!0;for(let m=r-1;m>=i;--m)if(f(t.charCodeAt(m))){if(!l){o=m;break}}else l=!1;if(o===-1){if(s===-1)return".";o=s}return t.slice(0,o)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let s=0,i=-1,n=!0,o;if(t.length>=2&&E(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(s=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let l=r.length-1,m=-1;for(o=t.length-1;o>=s;--o){const w=t.charCodeAt(o);if(f(w)){if(!n){s=o+1;break}}else m===-1&&(n=!1,m=o+1),l>=0&&(w===r.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=m))}return s===i?i=m:i===-1&&(i=t.length),t.slice(s,i)}for(o=t.length-1;o>=s;--o)if(f(t.charCodeAt(o))){if(!n){s=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(s,i)},extname(t){c(t,"path");let r=0,s=-1,i=0,n=-1,o=!0,l=0;t.length>=2&&t.charCodeAt(1)===P&&E(t.charCodeAt(0))&&(r=i=2);for(let m=t.length-1;m>=r;--m){const w=t.charCodeAt(m);if(f(w)){if(!o){i=m+1;break}continue}n===-1&&(o=!1,n=m+1),w===_?s===-1?s=m:l!==1&&(l=1):s!==-1&&(l=-1)}return s===-1||n===-1||l===0||l===1&&s===n-1&&s===i+1?"":t.slice(s,n)},format:d.bind(null,"\\"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.length;let i=0,n=t.charCodeAt(0);if(s===1)return f(n)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(f(n)){if(i=1,f(t.charCodeAt(1))){let R=2,U=R;for(;R<s&&!f(t.charCodeAt(R));)R++;if(R<s&&R!==U){for(U=R;R<s&&f(t.charCodeAt(R));)R++;if(R<s&&R!==U){for(U=R;R<s&&!f(t.charCodeAt(R));)R++;R===s?i=R:R!==U&&(i=R+1)}}}}else if(E(n)&&t.charCodeAt(1)===P){if(s<=2)return r.root=r.dir=t,r;if(i=2,f(t.charCodeAt(2))){if(s===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let o=-1,l=i,m=-1,w=!0,C=t.length-1,b=0;for(;C>=i;--C){if(n=t.charCodeAt(C),f(n)){if(!w){l=C+1;break}continue}m===-1&&(w=!1,m=C+1),n===_?o===-1?o=C:b!==1&&(b=1):o!==-1&&(b=-1)}return m!==-1&&(o===-1||b===0||b===1&&o===m-1&&o===l+1?r.base=r.name=t.slice(l,m):(r.name=t.slice(l,o),r.base=t.slice(l,m),r.ext=t.slice(o,m))),l>0&&l!==i?r.dir=t.slice(0,l-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const v=(()=>{if(g){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.posix={resolve(...t){let r="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const n=i>=0?t[i]:v();c(n,"path"),n.length!==0&&(r=`${n}/${r}`,s=n.charCodeAt(0)===T)}return r=I(r,!s,"/",h),s?`/${r}`:r.length>0?r:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===T,s=t.charCodeAt(t.length-1)===T;return t=I(t,!r,"/",h),t.length===0?r?"/":s?"./":".":(s&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===T},join(...t){if(t.length===0)return".";let r;for(let s=0;s<t.length;++s){const i=t[s];c(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.posix.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r||(t=e.posix.resolve(t),r=e.posix.resolve(r),t===r))return"";const s=1,i=t.length,n=i-s,o=1,l=r.length-o,m=n<l?n:l;let w=-1,C=0;for(;C<m;C++){const R=t.charCodeAt(s+C);if(R!==r.charCodeAt(o+C))break;R===T&&(w=C)}if(C===m)if(l>m){if(r.charCodeAt(o+C)===T)return r.slice(o+C+1);if(C===0)return r.slice(o+C)}else n>m&&(t.charCodeAt(s+C)===T?w=C:C===0&&(w=0));let b="";for(C=s+w+1;C<=i;++C)(C===i||t.charCodeAt(C)===T)&&(b+=b.length===0?"..":"/..");return`${b}${r.slice(o+w)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===T;let s=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===T){if(!i){s=n;break}}else i=!1;return s===-1?r?"/":".":r&&s===1?"//":t.slice(0,s)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let s=0,i=-1,n=!0,o;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let l=r.length-1,m=-1;for(o=t.length-1;o>=0;--o){const w=t.charCodeAt(o);if(w===T){if(!n){s=o+1;break}}else m===-1&&(n=!1,m=o+1),l>=0&&(w===r.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=m))}return s===i?i=m:i===-1&&(i=t.length),t.slice(s,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===T){if(!n){s=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(s,i)},extname(t){c(t,"path");let r=-1,s=0,i=-1,n=!0,o=0;for(let l=t.length-1;l>=0;--l){const m=t.charCodeAt(l);if(m===T){if(!n){s=l+1;break}continue}i===-1&&(n=!1,i=l+1),m===_?r===-1?r=l:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||i===-1||o===0||o===1&&r===i-1&&r===s+1?"":t.slice(r,i)},format:d.bind(null,"/"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.charCodeAt(0)===T;let i;s?(r.root="/",i=1):i=0;let n=-1,o=0,l=-1,m=!0,w=t.length-1,C=0;for(;w>=i;--w){const b=t.charCodeAt(w);if(b===T){if(!m){o=w+1;break}continue}l===-1&&(m=!1,l=w+1),b===_?n===-1?n=w:C!==1&&(C=1):n!==-1&&(C=-1)}if(l!==-1){const b=o===0&&s?1:o;n===-1||C===0||C===1&&n===l-1&&n===o+1?r.base=r.name=t.slice(b,l):(r.name=t.slice(b,n),r.base=t.slice(b,l),r.ext=t.slice(n,l))}return o>0?r.dir=t.slice(0,o-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g?e.win32.normalize:e.posix.normalize,e.isAbsolute=g?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g?e.win32.join:e.posix.join,e.resolve=g?e.win32.resolve:e.posix.resolve,e.relative=g?e.win32.relative:e.posix.relative,e.dirname=g?e.win32.dirname:e.posix.dirname,e.basename=g?e.win32.basename:e.posix.basename,e.extname=g?e.win32.extname:e.posix.extname,e.format=g?e.win32.format:e.posix.format,e.parse=g?e.win32.parse:e.posix.parse,e.toNamespacedPath=g?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g?e.win32.sep:e.posix.sep,e.delimiter=g?e.win32.delimiter:e.posix.delimiter}),define(le[42],ue([0,1,39,14,5,27,13]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=_,e.toSlashes=T,e.toPosixPath=y,e.getRoot=P,e.isUNC=S,e.isValidBasename=g,e.isEqual=f,e.isEqualOrParent=h,e.isWindowsDriveLetter=E,e.sanitizeFilePath=I,e.removeTrailingPathSeparator=d,e.isRootOrDriveLetter=v,e.hasDriveLetter=t,e.getDriveLetter=r,e.indexOfPath=s,e.parseLineAndColumnAware=i,e.randomPath=l;function _(m){return m===D.CharCode.Slash||m===D.CharCode.Backslash}function T(m){return m.replace(/[\\/]/g,a.posix.sep)}function y(m){return m.indexOf("/")===-1&&(m=T(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}function P(m,w=a.posix.sep){if(!m)return"";const C=m.length,b=m.charCodeAt(0);if(_(b)){if(_(m.charCodeAt(1))&&!_(m.charCodeAt(2))){let U=3;const N=U;for(;U<C&&!_(m.charCodeAt(U));U++);if(N!==U&&!_(m.charCodeAt(U+1))){for(U+=1;U<C;U++)if(_(m.charCodeAt(U)))return m.slice(0,U+1).replace(/[\\/]/g,w)}}return w}else if(E(b)&&m.charCodeAt(1)===D.CharCode.Colon)return _(m.charCodeAt(2))?m.slice(0,2)+w:m.slice(0,2);let R=m.indexOf("://");if(R!==-1){for(R+=3;R<C;R++)if(_(m.charCodeAt(R)))return m.slice(0,R+1)}return""}function S(m){if(!A.isWindows||!m||m.length<5)return!1;let w=m.charCodeAt(0);if(w!==D.CharCode.Backslash||(w=m.charCodeAt(1),w!==D.CharCode.Backslash))return!1;let C=2;const b=C;for(;C<m.length&&(w=m.charCodeAt(C),w!==D.CharCode.Backslash);C++);return!(b===C||(w=m.charCodeAt(C+1),isNaN(w)||w===D.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,p=/[/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(m,w=A.isWindows){const C=w?u:p;return!(!m||m.length===0||/^\s+$/.test(m)||(C.lastIndex=0,C.test(m))||w&&c.test(m)||m==="."||m===".."||w&&m[m.length-1]==="."||w&&m.length!==m.trim().length||m.length>255)}function f(m,w,C){const b=m===w;return!C||b?b:!m||!w?!1:(0,L.equalsIgnoreCase)(m,w)}function h(m,w,C,b=a.sep){if(m===w)return!0;if(!m||!w||w.length>m.length)return!1;if(C){if(!(0,L.startsWithIgnoreCase)(m,w))return!1;if(w.length===m.length)return!0;let U=w.length;return w.charAt(w.length-1)===b&&U--,m.charAt(U)===b}return w.charAt(w.length-1)!==b&&(w+=b),m.indexOf(w)===0}function E(m){return m>=D.CharCode.A&&m<=D.CharCode.Z||m>=D.CharCode.a&&m<=D.CharCode.z}function I(m,w){return A.isWindows&&m.endsWith(":")&&(m+=a.sep),(0,a.isAbsolute)(m)||(m=(0,a.join)(w,m)),m=(0,a.normalize)(m),d(m)}function d(m){return A.isWindows?(m=(0,L.rtrim)(m,a.sep),m.endsWith(":")&&(m+=a.sep)):(m=(0,L.rtrim)(m,a.sep),m||(m=a.sep)),m}function v(m){const w=(0,a.normalize)(m);return A.isWindows?m.length>3?!1:t(w)&&(m.length===2||w.charCodeAt(2)===D.CharCode.Backslash):w===a.posix.sep}function t(m,w=A.isWindows){return w?E(m.charCodeAt(0))&&m.charCodeAt(1)===D.CharCode.Colon:!1}function r(m,w=A.isWindows){return t(m,w)?m[0]:void 0}function s(m,w,C){return w.length>m.length?-1:m===w?0:(C&&(m=m.toLowerCase(),w=w.toLowerCase()),m.indexOf(w))}function i(m){const w=m.split(":");let C,b,R;for(const U of w){const N=Number(U);(0,k.isNumber)(N)?b===void 0?b=N:R===void 0&&(R=N):C=C?[C,U].join(":"):U}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:b!==void 0?b:void 0,column:R!==void 0?R:b!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(m,w,C=8){let b="";for(let U=0;U<C;U++){let N;U===0&&A.isWindows&&!w&&(C===3||C===4)?N=o:N=n,b+=N.charAt(Math.floor(Math.random()*N.length))}let R;return w?R=`${w}-${b}`:R=b,m?(0,a.join)(m,R):R}}),define(le[147],ue([0,1,14]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=L,e.getMediaMime=k,e.getExtensionForMimeType=_,e.normalizeMimeType=y,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const S=(0,D.extname)(P),u=a[S.toLowerCase()];return u!==void 0?u:k(P)}function k(P){const S=(0,D.extname)(P);return A[S.toLowerCase()]}function _(P){for(const S in A)if(A[S]===P)return S}const T=/^(.+)\/(.+?)(;.+)?$/;function y(P,S){const u=T.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:S?void 0:P}}),define(le[93],ue([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=L,e.removeDangerousEnvVariables=k;var a;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(a||(e.Source=a={}));var A;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function L(_,...T){const y=T.reduce((u,p)=>(u[p]=!0,u),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(u=>!y[u]).forEach(u=>{for(let p=0;p<P.length;p++)if(u.search(P[p])!==-1){delete _[u];break}})}function k(_){_&&(delete _.DEBUG,D.isMacintosh&&delete _.DYLD_LIBRARY_PATH,D.isLinux&&delete _.LD_PRELOAD)}}),define(le[9],ue([0,1,39,64,14,5]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=f,e.uriToFsPath=t;const k=/^\w[\w\d+.-]*$/,_=/^\//,T=/^\/\//;function y(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!k.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!_.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(o,l){return!o&&!l?"file":o}function S(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==p&&(l=p+l):l=p;break}return l}const u="",p="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(l){return l instanceof g?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,m,w,C,b,R=!1){typeof l=="object"?(this.scheme=l.scheme||u,this.authority=l.authority||u,this.path=l.path||u,this.query=l.query||u,this.fragment=l.fragment||u):(this.scheme=P(l,R),this.authority=m||u,this.path=S(this.scheme,w||u),this.query=C||u,this.fragment=b||u,y(this,R))}get fsPath(){return t(this,!1)}with(l){if(!l)return this;let{scheme:m,authority:w,path:C,query:b,fragment:R}=l;return m===void 0?m=this.scheme:m===null&&(m=u),w===void 0?w=this.authority:w===null&&(w=u),C===void 0?C=this.path:C===null&&(C=u),b===void 0?b=this.query:b===null&&(b=u),R===void 0?R=this.fragment:R===null&&(R=u),m===this.scheme&&w===this.authority&&C===this.path&&b===this.query&&R===this.fragment?this:new E(m,w,C,b,R)}static parse(l,m=!1){const w=c.exec(l);return w?new E(w[2]||u,n(w[4]||u),n(w[5]||u),n(w[7]||u),n(w[9]||u),m):new E(u,u,u,u,u)}static file(l){let m=u;if(L.isWindows&&(l=l.replace(/\\/g,p)),l[0]===p&&l[1]===p){const w=l.indexOf(p,2);w===-1?(m=l.substring(2),l=p):(m=l.substring(2,w),l=l.substring(w)||p)}return new E("file",m,l,u,u)}static from(l,m){return new E(l.scheme,l.authority,l.path,l.query,l.fragment,m)}static joinPath(l,...m){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return L.isWindows&&l.scheme==="file"?w=g.file(A.win32.join(t(l,!0),...m)).path:w=A.posix.join(l.path,...m),l.with({path:w})}toString(l=!1){return r(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof g)return l;{const m=new E(l);return m._formatted=l.external??null,m._fsPath=l._sep===h?l.fsPath??null:null,m}}else return l}}e.URI=g;function f(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}const h=L.isWindows?1:void 0;class E extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(l=!1){return l?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const l={$mid:a.MarshalledId.Uri};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=h),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const I={[D.CharCode.Colon]:"%3A",[D.CharCode.Slash]:"%2F",[D.CharCode.QuestionMark]:"%3F",[D.CharCode.Hash]:"%23",[D.CharCode.OpenSquareBracket]:"%5B",[D.CharCode.CloseSquareBracket]:"%5D",[D.CharCode.AtSign]:"%40",[D.CharCode.ExclamationMark]:"%21",[D.CharCode.DollarSign]:"%24",[D.CharCode.Ampersand]:"%26",[D.CharCode.SingleQuote]:"%27",[D.CharCode.OpenParen]:"%28",[D.CharCode.CloseParen]:"%29",[D.CharCode.Asterisk]:"%2A",[D.CharCode.Plus]:"%2B",[D.CharCode.Comma]:"%2C",[D.CharCode.Semicolon]:"%3B",[D.CharCode.Equals]:"%3D",[D.CharCode.Space]:"%20"};function d(o,l,m){let w,C=-1;for(let b=0;b<o.length;b++){const R=o.charCodeAt(b);if(R>=D.CharCode.a&&R<=D.CharCode.z||R>=D.CharCode.A&&R<=D.CharCode.Z||R>=D.CharCode.Digit0&&R<=D.CharCode.Digit9||R===D.CharCode.Dash||R===D.CharCode.Period||R===D.CharCode.Underline||R===D.CharCode.Tilde||l&&R===D.CharCode.Slash||m&&R===D.CharCode.OpenSquareBracket||m&&R===D.CharCode.CloseSquareBracket||m&&R===D.CharCode.Colon)C!==-1&&(w+=encodeURIComponent(o.substring(C,b)),C=-1),w!==void 0&&(w+=o.charAt(b));else{w===void 0&&(w=o.substr(0,b));const U=I[R];U!==void 0?(C!==-1&&(w+=encodeURIComponent(o.substring(C,b)),C=-1),w+=U):C===-1&&(C=b)}}return C!==-1&&(w+=encodeURIComponent(o.substring(C))),w!==void 0?w:o}function v(o){let l;for(let m=0;m<o.length;m++){const w=o.charCodeAt(m);w===D.CharCode.Hash||w===D.CharCode.QuestionMark?(l===void 0&&(l=o.substr(0,m)),l+=I[w]):l!==void 0&&(l+=o[m])}return l!==void 0?l:o}function t(o,l){let m;return o.authority&&o.path.length>1&&o.scheme==="file"?m=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===D.CharCode.Slash&&(o.path.charCodeAt(1)>=D.CharCode.A&&o.path.charCodeAt(1)<=D.CharCode.Z||o.path.charCodeAt(1)>=D.CharCode.a&&o.path.charCodeAt(1)<=D.CharCode.z)&&o.path.charCodeAt(2)===D.CharCode.Colon?l?m=o.path.substr(1):m=o.path[1].toLowerCase()+o.path.substr(2):m=o.path,L.isWindows&&(m=m.replace(/\//g,"\\")),m}function r(o,l){const m=l?v:d;let w="",{scheme:C,authority:b,path:R,query:U,fragment:N}=o;if(C&&(w+=C,w+=":"),(b||C==="file")&&(w+=p,w+=p),b){let M=b.indexOf("@");if(M!==-1){const F=b.substr(0,M);b=b.substr(M+1),M=F.lastIndexOf(":"),M===-1?w+=m(F,!1,!1):(w+=m(F.substr(0,M),!1,!1),w+=":",w+=m(F.substr(M+1),!1,!0)),w+="@"}b=b.toLowerCase(),M=b.lastIndexOf(":"),M===-1?w+=m(b,!1,!0):(w+=m(b.substr(0,M),!1,!0),w+=b.substr(M))}if(R){if(R.length>=3&&R.charCodeAt(0)===D.CharCode.Slash&&R.charCodeAt(2)===D.CharCode.Colon){const M=R.charCodeAt(1);M>=D.CharCode.A&&M<=D.CharCode.Z&&(R=`/${String.fromCharCode(M+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===D.CharCode.Colon){const M=R.charCodeAt(0);M>=D.CharCode.A&&M<=D.CharCode.Z&&(R=`${String.fromCharCode(M+32)}:${R.substr(2)}`)}w+=m(R,!0,!1)}return U&&(w+="?",w+=m(U,!1,!1)),N&&(w+="#",w+=l?N:d(N,!1,!1)),w}function s(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+s(o.substr(3)):o}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(i)?o.replace(i,l=>s(l)):o}}),define(le[148],ue([0,1,9]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=a,e.parse=A,e.getFirstFrame=L,e.log=_;function a(y){const P=y;return P&&typeof P.type=="string"&&typeof P.severity=="string"}function A(y){const P=[];let S;try{const u=JSON.parse(y.arguments),p=u[u.length-1];p&&p.__$stack&&(u.pop(),S=p.__$stack),P.push(...u)}catch{P.push("Unable to log remote console arguments",y.arguments)}return{args:P,stack:S}}function L(y){if(typeof y!="string")return L(A(y).stack);const P=y;if(P){const S=k(P),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(u&&u.length===4)return{uri:D.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function k(y){if(!y)return y;const P=y.indexOf(`
`);return P===-1?y:y.substring(0,P)}function _(y,P){const{args:S,stack:u}=A(y),p=typeof S[0]=="string"&&S.length===1;let c=k(u);c&&(c=`(${c.trim()})`);let g=[];if(typeof S[0]=="string"?c&&p?g=[`%c[${P}] %c${S[0]} %c${c}`,T("blue"),T(""),T("grey")]:g=[`%c[${P}] %c${S[0]}`,T("blue"),T(""),...S.slice(1)]:g=[`%c[${P}]%`,T("blue"),...S],c&&!p&&g.push(c),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,g)}function T(y){return`color: ${y}`}}),define(le[68],ue([0,1,15,9,64]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=L,e.parse=k,e.revive=T;function L(y){return JSON.stringify(y,_)}function k(y){let P=JSON.parse(y);return P=T(P),P}function _(y,P){return P instanceof RegExp?{$mid:A.MarshalledId.Regexp,source:P.source,flags:P.flags}:P}function T(y,P=0){if(!y||P>200)return y;if(typeof y=="object"){switch(y.$mid){case A.MarshalledId.Uri:return a.URI.revive(y);case A.MarshalledId.Regexp:return new RegExp(y.source,y.flags);case A.MarshalledId.Date:return new Date(y.source)}if(y instanceof D.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let S=0;S<y.length;++S)y[S]=T(y[S],P+1);else for(const S in y)Object.hasOwnProperty.call(y,S)&&(y[S]=T(y[S],P+1))}return y}}),define(le[23],ue([0,1,8,5,27,9,14]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=T,e.matchesSomeScheme=y,e.getServerRootPath=S;var _;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(_||(e.Schemas=_={}));function T(c,g){return L.URI.isUri(c)?(0,A.equalsIgnoreCase)(c.scheme,g):(0,A.startsWithIgnoreCase)(c,g+":")}function y(c,...g){return g.some(f=>T(c,f))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g,f){this._serverRootPath=S(g,f)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return k.posix.join(this._serverRootPath,_.vscodeRemoteResource)}set(g,f,h){this._hosts[g]=f,this._ports[g]=h}setConnectionToken(g,f){this._connectionTokens[g]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)try{return this._delegate(g)}catch(v){return D.onUnexpectedError(v),g}const f=g.authority;let h=this._hosts[f];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const E=this._ports[f],I=this._connectionTokens[f];let d=`path=${encodeURIComponent(g.path)}`;return typeof I=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),L.URI.from({scheme:a.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${h}:${E}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new P;function S(c,g){return k.posix.join(g??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class u{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(g){const f=this.toUri(g,ne);return this.uriToBrowserUri(f)}uriToBrowserUri(g){return g.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(g):g.scheme===_.file&&(a.isNative||a.webWorkerOrigin===`${_.vscodeFileResource}://${u.FALLBACK_AUTHORITY}`)?g.with({scheme:_.vscodeFileResource,authority:g.authority||u.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(g){const f=this.toUri(g,ne);return this.uriToFileUri(f)}uriToFileUri(g){return g.scheme===_.vscodeFileResource?g.with({scheme:_.file,authority:g.authority!==u.FALLBACK_AUTHORITY?g.authority:null,query:null,fragment:null}):g}toUri(g,f){return L.URI.isUri(g)?g:L.URI.parse(f.toUrl(g))}}e.FileAccess=new u;var p;(function(c){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(g.get("3"));const f="vscode-coi";function h(I){let d;typeof I=="string"?d=new URL(I).searchParams:I instanceof URL?d=I.searchParams:L.URI.isUri(I)&&(d=new URL(I.toString(!0)).searchParams);const v=d?.get(f);if(v)return g.get(v)}c.getHeadersFromQuery=h;function E(I,d,v){if(!globalThis.crossOriginIsolated)return;const t=d&&v?"3":v?"2":"1";I instanceof URLSearchParams?I.set(f,t):I[f]=t}c.addSearchParam=E})(p||(e.COI=p={}))}),define(le[149],ue([0,1,129,23,5,9]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=P;class k{constructor(u,p,c){this.id=u,this.dependencies=p,this.callback=c}}class _{static{this.INSTANCE=new _}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(u,p,c)=>{typeof u!="string"&&(c=p,p=u,u=null),(typeof p!="object"||!Array.isArray(p))&&(c=p,p=null),this._defineCalls.push(new k(u,p,c))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this._initialize();const p=await(this._isWebWorker?this._workerLoadScript(u):this._isRenderer?this._rendererLoadScript(u):this._nodeJSLoadScript(u));if(!p)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}_rendererLoadScript(u){return new Promise((p,c)=>{const g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript");const f=()=>{g.removeEventListener("load",h),g.removeEventListener("error",E)},h=I=>{f(),p(this._defineCalls.pop())},E=I=>{f(),c(I)};g.addEventListener("load",h),g.addEventListener("error",E),this._amdPolicy&&(u=this._amdPolicy.createScriptURL(u)),g.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(g)})}_workerLoadScript(u){return new Promise((p,c)=>{try{this._amdPolicy&&(u=this._amdPolicy.createScriptURL(u)),importScripts(u),p(this._defineCalls.pop())}catch(g){c(g)}})}async _nodeJSLoadScript(u){try{const p=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,g=globalThis._VSCODE_NODE_MODULES.module,f=L.URI.parse(u).fsPath,h=p.readFileSync(f).toString(),E=g.wrap(h.replace(/^#!.*/,""));return new c.Script(E).runInThisContext().apply(),this._defineCalls.pop()}catch(p){throw p}}}const T=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function P(S,u,p){if(D.isESM){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[S]&&(S=y[S]);const c=`${S}/${u}`;if(T.has(c))return T.get(c);let g;if(/^\w[\w\d+.-]*:\/\//.test(c))g=c;else{const I=`${p&&!A.isWeb?a.nodeModulesAsarPath:a.nodeModulesPath}/${c}`;g=a.FileAccess.asBrowserUri(I).toString(!0)}const f=_.INSTANCE.load(g);return T.set(c,f),f}else return await new Promise((c,g)=>{ne([S],c,g)})}}),define(le[21],ue([0,1,39,42,23,14,5,27,9]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=y,e.distinctParents=S,e.toLocalResource=p;function y(c){return(0,T.uriToFsPath)(c,!0)}class P{constructor(g){this._ignorePathCasing=g}compare(g,f,h=!1){return g===f?0:(0,_.compare)(this.getComparisonKey(g,h),this.getComparisonKey(f,h))}isEqual(g,f,h=!1){return g===f?!0:!g||!f?!1:this.getComparisonKey(g,h)===this.getComparisonKey(f,h)}getComparisonKey(g,f=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,f,h=!1){if(g.scheme===f.scheme){if(g.scheme===A.Schemas.file)return a.isEqualOrParent(y(g),y(f),this._ignorePathCasing(g))&&g.query===f.query&&(h||g.fragment===f.fragment);if((0,e.isEqualAuthority)(g.authority,f.authority))return a.isEqualOrParent(g.path,f.path,this._ignorePathCasing(g),"/")&&g.query===f.query&&(h||g.fragment===f.fragment)}return!1}joinPath(g,...f){return T.URI.joinPath(g,...f)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return L.posix.basename(g.path)}extname(g){return L.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let f;return g.scheme===A.Schemas.file?f=T.URI.file(L.dirname(y(g))).path:(f=L.posix.dirname(g.path),g.authority&&f.length&&f.charCodeAt(0)!==D.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),f="/")),g.with({path:f})}normalizePath(g){if(!g.path.length)return g;let f;return g.scheme===A.Schemas.file?f=T.URI.file(L.normalize(y(g))).path:f=L.posix.normalize(g.path),g.with({path:f})}relativePath(g,f){if(g.scheme!==f.scheme||!(0,e.isEqualAuthority)(g.authority,f.authority))return;if(g.scheme===A.Schemas.file){const I=L.relative(y(g),y(f));return k.isWindows?a.toSlashes(I):I}let h=g.path||"/";const E=f.path||"/";if(this._ignorePathCasing(g)){let I=0;for(const d=Math.min(h.length,E.length);I<d&&!(h.charCodeAt(I)!==E.charCodeAt(I)&&h.charAt(I).toLowerCase()!==E.charAt(I).toLowerCase());I++);h=E.substr(0,I)+h.substr(I)}return L.posix.relative(h,E)}resolvePath(g,f){if(g.scheme===A.Schemas.file){const h=T.URI.file(L.resolve(y(g),f));return g.with({authority:h.authority,path:h.path})}return f=a.toPosixPath(f),g.with({path:L.posix.resolve(g.path,f)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,f){return g===f||g!==void 0&&f!==void 0&&(0,_.equalsIgnoreCase)(g,f)}hasTrailingPathSeparator(g,f=L.sep){if(g.scheme===A.Schemas.file){const h=y(g);return h.length>a.getRoot(h).length&&h[h.length-1]===f}else{const h=g.path;return h.length>1&&h.charCodeAt(h.length-1)===D.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,f=L.sep){return(0,e.hasTrailingPathSeparator)(g,f)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,f=L.sep){let h=!1;if(g.scheme===A.Schemas.file){const E=y(g);h=E!==void 0&&E.length===a.getRoot(E).length&&E[E.length-1]===f}else{f="/";const E=g.path;h=E.length===1&&E.charCodeAt(E.length-1)===D.CharCode.Slash}return!h&&!(0,e.hasTrailingPathSeparator)(g,f)?g.with({path:g.path+"/"}):g}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(c=>c.scheme===A.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new P(c=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function S(c,g){const f=[];for(let h=0;h<c.length;h++){const E=g(c[h]);c.some((I,d)=>d===h?!1:(0,e.isEqualOrParent)(E,g(I)))||f.push(c[h])}return f}var u;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function g(f){const h=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(d=>{const[v,t]=d.split(":");v&&t&&h.set(v,t)});const I=f.path.substring(0,f.path.indexOf(";"));return I&&h.set(c.META_DATA_MIME,I),h}c.parseMetaData=g})(u||(e.DataUri=u={}));function p(c,g,f){if(g){let h=c.path;return h&&h[0]!==L.posix.sep&&(h=L.posix.sep+h),c.with({scheme:f,authority:g,path:h})}return c.with({scheme:f})}}),define(le[6],ue([0,1,26,8,3,2,21,5,135,54]),function(ne,e,D,a,A,L,k,_,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=P,e.createCancelablePromise=S,e.raceCancellation=u,e.raceCancellationError=p,e.raceCancellablePromises=c,e.raceTimeout=g,e.asPromise=f,e.promiseWithResolvers=h,e.timeout=o,e.disposableTimeout=l,e.sequence=m,e.first=w,e.firstParallel=C,e.retry=B,e.createCancelableAsyncIterable=q;function P(Z){return!!Z&&typeof Z.then=="function"}function S(Z){const Y=new D.CancellationTokenSource,ae=Z(Y.token),he=new Promise((ge,ve)=>{const Ie=Y.token.onCancellationRequested(()=>{Ie.dispose(),ve(new a.CancellationError)});Promise.resolve(ae).then(pe=>{Ie.dispose(),Y.dispose(),ge(pe)},pe=>{Ie.dispose(),Y.dispose(),ve(pe)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(ge,ve){return he.then(ge,ve)}catch(ge){return this.then(void 0,ge)}finally(ge){return he.finally(ge)}}}function u(Z,Y,ae){return new Promise((he,ge)=>{const ve=Y.onCancellationRequested(()=>{ve.dispose(),he(ae)});Z.then(he,ge).finally(()=>ve.dispose())})}function p(Z,Y){return new Promise((ae,he)=>{const ge=Y.onCancellationRequested(()=>{ge.dispose(),he(new a.CancellationError)});Z.then(ae,he).finally(()=>ge.dispose())})}async function c(Z){let Y=-1;const ae=Z.map((he,ge)=>he.then(ve=>(Y=ge,ve)));try{return await Promise.race(ae)}finally{Z.forEach((he,ge)=>{ge!==Y&&he.cancel()})}}function g(Z,Y,ae){let he;const ge=setTimeout(()=>{he?.(void 0),ae?.()},Y);return Promise.race([Z.finally(()=>clearTimeout(ge)),new Promise(ve=>he=ve)])}function f(Z){return new Promise((Y,ae)=>{const he=Z();P(he)?he.then(Y,ae):Y(he)})}function h(){let Z,Y;return{promise:new Promise((he,ge)=>{Z=he,Y=ge}),resolve:Z,reject:Y}}class E{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const ae=()=>{if(this.queuedPromise=null,this.isDisposed)return;const he=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,he};this.queuedPromise=new Promise(he=>{this.activePromise.then(ae,ae).then(he)})}return new Promise((ae,he)=>{this.queuedPromise.then(ae,he)})}return this.activePromise=Y(),new Promise((ae,he)=>{this.activePromise.then(ge=>{this.activePromise=null,ae(ge)},ge=>{this.activePromise=null,he(ge)})})}dispose(){this.isDisposed=!0}}e.Throttler=E;class I{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=I;class d{constructor(){this.promiseMap=new Map}queue(Y,ae){const ge=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.promiseMap.get(Y)===ge&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,ge),ge}}e.SequencerByKey=d;const v=(Z,Y)=>{let ae=!0;const he=setTimeout(()=>{ae=!1,Y()},Z);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(he),ae=!1}}},t=Z=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,Z())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class r{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,ae=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,ve)=>{this.doResolve=ge,this.doReject=ve}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const he=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ae===T.MicrotaskDelay?t(he):v(ae,he),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new a.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=r;class s{constructor(Y){this.delayer=new r(Y),this.throttler=new E}trigger(Y,ae){return this.delayer.trigger(()=>this.throttler.queue(Y),ae)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=s;class i{constructor(){this._isOpen=!1,this._promise=new Promise((Y,ae)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class n extends i{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function o(Z,Y){return Y?new Promise((ae,he)=>{const ge=setTimeout(()=>{ve.dispose(),ae()},Z),ve=Y.onCancellationRequested(()=>{clearTimeout(ge),ve.dispose(),he(new a.CancellationError)})}):S(ae=>o(Z,ae))}function l(Z,Y=0,ae){const he=setTimeout(()=>{Z(),ae&&ge.dispose()},Y),ge=(0,L.toDisposable)(()=>{clearTimeout(he),ae?.deleteAndLeak(ge)});return ae?.add(ge),ge}function m(Z){const Y=[];let ae=0;const he=Z.length;function ge(){return ae<he?Z[ae++]():null}function ve(Ie){Ie!=null&&Y.push(Ie);const pe=ge();return pe?pe.then(ve):Promise.resolve(Y)}return Promise.resolve(null).then(ve)}function w(Z,Y=he=>!!he,ae=null){let he=0;const ge=Z.length,ve=()=>{if(he>=ge)return Promise.resolve(ae);const Ie=Z[he++];return Promise.resolve(Ie()).then(ye=>Y(ye)?Promise.resolve(ye):ve())};return ve()}function C(Z,Y=he=>!!he,ae=null){if(Z.length===0)return Promise.resolve(ae);let he=Z.length;const ge=()=>{he=-1;for(const ve of Z)ve.cancel?.()};return new Promise((ve,Ie)=>{for(const pe of Z)pe.then(ye=>{--he>=0&&Y(ye)?(ge(),ve(ye)):he===0&&ve(ae)}).catch(ye=>{--he>=0&&(ge(),Ie(ye))})})}class b{constructor(Y){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new A.Emitter}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((ae,he)=>{this.outstandingPromises.push({factory:Y,c:ae,e:he}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const ae=Y.factory();ae.then(Y.c,Y.e),ae.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=b;class R extends b{constructor(){super(1)}}e.Queue=R;class U{constructor(){this.sequentializer=new ee,this.tasks=0}queue(Y){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,Y())):this.sequentializer.run(this.tasks++,Y())}}e.LimitedQueue=U;class N{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const Y=new W;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueSize(Y,ae=k.extUri){const he=ae.getComparisonKey(Y);return this.queues.get(he)?.size??0}queueFor(Y,ae,he=k.extUri){const ge=he.getComparisonKey(Y);let ve=this.queues.get(ge);if(!ve){ve=new R;const Ie=this.drainListenerCount++,pe=A.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.queues.delete(ge),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Ie),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new L.DisposableMap),this.drainListeners.set(Ie,pe),this.queues.set(ge,ve)}return ve.queue(ae)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=N;class M{constructor(Y,ae){this._isDisposed=!1,this._token=-1,typeof Y=="function"&&typeof ae=="number"&&this.setIfNotSet(Y,ae)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,ae){if(this._isDisposed)throw new a.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},ae)}setIfNotSet(Y,ae){if(this._isDisposed)throw new a.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},ae))}}e.TimeoutTimer=M;class F{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(Y,ae,he=globalThis){if(this.isDisposed)throw new a.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=he.setInterval(()=>{Y()},ae);this.disposable=(0,L.toDisposable)(()=>{he.clearInterval(ge),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=F;class K{constructor(Y,ae){this.timeoutToken=-1,this.runner=Y,this.timeout=ae,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=K;class H{constructor(Y,ae){ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=ae,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=H;class X extends K{constructor(Y,ae){super(Y,ae),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X;class j extends L.Disposable{constructor(Y,ae){super(),this.options=Y,this.handler=ae,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ae of Y)this.pendingWork.push(ae);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new K(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=j,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(Z,Y)=>{(0,_.setTimeout0)(()=>{if(ae)return;const he=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e._runWhenIdle=(Z,Y,ae)=>{const he=Z.requestIdleCallback(Y,typeof ae=="number"?{timeout:ae}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,Z.cancelIdleCallback(he))}}},e.runWhenGlobalIdle=Z=>(0,e._runWhenIdle)(globalThis,Z)}();class ie{constructor(Y,ae){this._didRun=!1,this._executor=()=>{try{this._value=ae()}catch(he){this._error=he}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(Y,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ie;class z extends ie{constructor(Y){super(globalThis,Y)}}e.GlobalIdleValue=z;async function B(Z,Y,ae){let he;for(let ge=0;ge<ae;ge++)try{return await Z()}catch(ve){he=ve,await o(Y)}throw he}class ee{isRunning(Y){return typeof Y=="number"?this._running?.taskId===Y:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(Y,ae,he){return this._running={taskId:Y,cancel:()=>he?.(),promise:ae},ae.then(()=>this.doneRunning(Y),()=>this.doneRunning(Y)),ae}doneRunning(Y){this._running&&Y===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const Y=this._queued;this._queued=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this._queued)this._queued.run=Y;else{const{promise:ae,resolve:he,reject:ge}=h();this._queued={run:Y,promise:ae,promiseResolve:he,promiseReject:ge}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=ee;class se{constructor(Y,ae=()=>Date.now()){this.interval=Y,this.nowFn=ae,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=se;var ce;(function(Z){Z[Z.Resolved=0]="Resolved",Z[Z.Rejected=1]="Rejected"})(ce||(ce={}));class W{get isRejected(){return this.outcome?.outcome===ce.Rejected}get isResolved(){return this.outcome?.outcome===ce.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ce.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((Y,ae)=>{this.completeCallback=Y,this.errorCallback=ae})}complete(Y){return new Promise(ae=>{this.completeCallback(Y),this.outcome={outcome:ce.Resolved,value:Y},ae()})}error(Y){return new Promise(ae=>{this.errorCallback(Y),this.outcome={outcome:ce.Rejected,value:Y},ae()})}cancel(){return this.error(new a.CancellationError)}}e.DeferredPromise=W;var J;(function(Z){async function Y(he){let ge;const ve=await Promise.all(he.map(Ie=>Ie.then(pe=>pe,pe=>{ge||(ge=pe)})));if(typeof ge<"u")throw ge;return ve}Z.settled=Y;function ae(he){return new Promise(async(ge,ve)=>{try{await he(ge,ve)}catch(Ie){ve(Ie)}})}Z.withAsyncBody=ae})(J||(e.Promises=J={}));class G{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(Y){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=Y.then(ae=>(this._value=ae,this._isResolved=!0,ae),ae=>{throw this._error=ae,this._isResolved=!0,ae})}requireValue(){if(!this._isResolved)throw new a.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=G;class V{constructor(Y){this._compute=Y,this._promise=new y.Lazy(()=>new G(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=V;var O;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(O||(O={}));class ${static fromArray(Y){return new $(ae=>{ae.emitMany(Y)})}static fromPromise(Y){return new $(async ae=>{ae.emitMany(await Y)})}static fromPromises(Y){return new $(async ae=>{await Promise.all(Y.map(async he=>ae.emitOne(await he)))})}static merge(Y){return new $(async ae=>{await Promise.all(Y.map(async he=>{for await(const ge of he)ae.emitOne(ge)}))})}static{this.EMPTY=$.fromArray([])}constructor(Y,ae){this._state=O.Initial,this._results=[],this._error=null,this._onReturn=ae,this._onStateChanged=new A.Emitter,queueMicrotask(async()=>{const he={emitOne:ge=>this.emitOne(ge),emitMany:ge=>this.emitMany(ge),reject:ge=>this.reject(ge)};try{await Promise.resolve(Y(he)),this.resolve()}catch(ge){this.reject(ge)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===O.DoneError)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===O.DoneOK)return{done:!0,value:void 0};await A.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(Y,ae){return new $(async he=>{for await(const ge of Y)he.emitOne(ae(ge))})}map(Y){return $.map(this,Y)}static filter(Y,ae){return new $(async he=>{for await(const ge of Y)ae(ge)&&he.emitOne(ge)})}filter(Y){return $.filter(this,Y)}static coalesce(Y){return $.filter(Y,ae=>!!ae)}coalesce(){return $.coalesce(this)}static async toPromise(Y){const ae=[];for await(const he of Y)ae.push(he);return ae}toPromise(){return $.toPromise(this)}emitOne(Y){this._state===O.Initial&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===O.Initial&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===O.Initial&&(this._state=O.DoneOK,this._onStateChanged.fire())}reject(Y){this._state===O.Initial&&(this._state=O.DoneError,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=$;class x extends ${constructor(Y,ae){super(ae),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=x;function q(Z){const Y=new D.CancellationTokenSource,ae=Z(Y.token);return new x(Y,async he=>{const ge=Y.token.onCancellationRequested(()=>{ge.dispose(),Y.dispose(),he.reject(new a.CancellationError)});try{for await(const ve of ae){if(Y.token.isCancellationRequested)return;he.emitOne(ve)}ge.dispose(),Y.dispose()}catch(ve){ge.dispose(),Y.dispose(),he.reject(ve)}})}class te{constructor(Y){this._deferred=new W,this._asyncIterable=new $(ge=>{if(ae){ge.reject(ae);return}return he&&ge.emitMany(he),this._errorFn=ve=>ge.reject(ve),this._emitFn=ve=>ge.emitOne(ve),this._deferred.p},Y);let ae,he;this._emitFn=ge=>{he||(he=[]),he.push(ge)},this._errorFn=ge=>{ae||(ae=ge)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(Y){this._errorFn(Y),this._deferred.complete()}emitOne(Y){this._emitFn(Y)}}e.AsyncIterableSource=te}),define(le[94],ue([0,1,19,6,39,42,35,14,5,27]),function(ne,e,D,a,A,L,k,_,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=P,e.splitGlobAware=g,e.match=U,e.parse=N,e.isRelativePattern=M,e.getBasenameTerms=F,e.getPathTerms=K,e.patternsEquals=ie;function P(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const S="[/\\\\]",u="[^/\\\\]",p=/\//g;function c(z,B){switch(z){case 0:return"";case 1:return`${u}*?`;default:return`(?:${S}|${u}+${S}${B?`|${S}${u}+`:""})*?`}}function g(z,B){if(!z)return[];const ee=[];let se=!1,ce=!1,W="";for(const J of z){switch(J){case B:if(!se&&!ce){ee.push(W),W="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}W+=J}return W&&ee.push(W),ee}function f(z){if(!z)return"";let B="";const ee=g(z,e.GLOB_SPLIT);if(ee.every(se=>se===e.GLOBSTAR))B=".*";else{let se=!1;ee.forEach((ce,W)=>{if(ce===e.GLOBSTAR){if(se)return;B+=c(2,W===ee.length-1)}else{let J=!1,G="",V=!1,O="";for(const $ of ce){if($!=="}"&&J){G+=$;continue}if(V&&($!=="]"||!O)){let x;$==="-"?x=$:($==="^"||$==="!")&&!O?x="^":$===e.GLOB_SPLIT?x="":x=(0,y.escapeRegExpCharacters)($),O+=x;continue}switch($){case"{":J=!0;continue;case"[":V=!0;continue;case"}":{const q=`(?:${g(G,",").map(te=>f(te)).join("|")})`;B+=q,J=!1,G="";break}case"]":{B+="["+O+"]",V=!1,O="";break}case"?":B+=u;continue;case"*":B+=c(1);continue;default:B+=(0,y.escapeRegExpCharacters)($)}}W<ee.length-1&&(ee[W+1]!==e.GLOBSTAR||W+2<ee.length)&&(B+=S)}se=ce===e.GLOBSTAR})}return B}const h=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new k.LRUCache(1e4),s=function(){return!1},i=function(){return null};function n(z,B){if(!z)return i;let ee;typeof z!="string"?ee=z.pattern:ee=z,ee=ee.trim();const se=`${ee}_${!!B.trimForExclusions}`;let ce=r.get(se);if(ce)return o(ce,z);let W;return h.test(ee)?ce=m(ee.substr(4),ee):(W=E.exec(l(ee,B)))?ce=w(W[1],ee):(B.trimForExclusions?d:I).test(ee)?ce=C(ee,B):(W=v.exec(l(ee,B)))?ce=b(W[1].substr(1),ee,!0):(W=t.exec(l(ee,B)))?ce=b(W[1],ee,!1):ce=R(ee),r.set(se,ce),o(ce,z)}function o(z,B){if(typeof B=="string")return z;const ee=function(se,ce){return(0,L.isEqualOrParent)(se,B.base,!T.isLinux)?z((0,y.ltrim)(se.substr(B.base.length),_.sep),ce):null};return ee.allBasenames=z.allBasenames,ee.allPaths=z.allPaths,ee.basenames=z.basenames,ee.patterns=z.patterns,ee}function l(z,B){return B.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function m(z,B){return function(ee,se){return typeof ee=="string"&&ee.endsWith(z)?B:null}}function w(z,B){const ee=`/${z}`,se=`\\${z}`,ce=function(J,G){return typeof J!="string"?null:G?G===z?B:null:J===z||J.endsWith(ee)||J.endsWith(se)?B:null},W=[z];return ce.basenames=W,ce.patterns=[B],ce.allBasenames=W,ce}function C(z,B){const ee=j(z.slice(1,-1).split(",").map(G=>n(G,B)).filter(G=>G!==i),z),se=ee.length;if(!se)return i;if(se===1)return ee[0];const ce=function(G,V){for(let O=0,$=ee.length;O<$;O++)if(ee[O](G,V))return z;return null},W=ee.find(G=>!!G.allBasenames);W&&(ce.allBasenames=W.allBasenames);const J=ee.reduce((G,V)=>V.allPaths?G.concat(V.allPaths):G,[]);return J.length&&(ce.allPaths=J),ce}function b(z,B,ee){const se=_.sep===_.posix.sep,ce=se?z:z.replace(p,_.sep),W=_.sep+ce,J=_.posix.sep+z;let G;return ee?G=function(V,O){return typeof V=="string"&&(V===ce||V.endsWith(W)||!se&&(V===z||V.endsWith(J)))?B:null}:G=function(V,O){return typeof V=="string"&&(V===ce||!se&&V===z)?B:null},G.allPaths=[(ee?"*/":"./")+z],G}function R(z){try{const B=new RegExp(`^${f(z)}$`);return function(ee){return B.lastIndex=0,typeof ee=="string"&&B.test(ee)?z:null}}catch{return i}}function U(z,B,ee){return!z||typeof B!="string"?!1:N(z)(B,void 0,ee)}function N(z,B={}){if(!z)return s;if(typeof z=="string"||M(z)){const ee=n(z,B);if(ee===i)return s;const se=function(ce,W){return!!ee(ce,W)};return ee.allBasenames&&(se.allBasenames=ee.allBasenames),ee.allPaths&&(se.allPaths=ee.allPaths),se}return H(z,B)}function M(z){const B=z;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function F(z){return z.allBasenames||[]}function K(z){return z.allPaths||[]}function H(z,B){const ee=j(Object.getOwnPropertyNames(z).map(G=>X(G,z[G],B)).filter(G=>G!==i)),se=ee.length;if(!se)return i;if(!ee.some(G=>!!G.requiresSiblings)){if(se===1)return ee[0];const G=function($,x){let q;for(let te=0,Z=ee.length;te<Z;te++){const Y=ee[te]($,x);if(typeof Y=="string")return Y;(0,a.isThenable)(Y)&&(q||(q=[]),q.push(Y))}return q?(async()=>{for(const te of q){const Z=await te;if(typeof Z=="string")return Z}return null})():null},V=ee.find($=>!!$.allBasenames);V&&(G.allBasenames=V.allBasenames);const O=ee.reduce(($,x)=>x.allPaths?$.concat(x.allPaths):$,[]);return O.length&&(G.allPaths=O),G}const ce=function(G,V,O){let $,x;for(let q=0,te=ee.length;q<te;q++){const Z=ee[q];Z.requiresSiblings&&O&&(V||(V=(0,_.basename)(G)),$||($=V.substr(0,V.length-(0,_.extname)(G).length)));const Y=Z(G,V,$,O);if(typeof Y=="string")return Y;(0,a.isThenable)(Y)&&(x||(x=[]),x.push(Y))}return x?(async()=>{for(const q of x){const te=await q;if(typeof te=="string")return te}return null})():null},W=ee.find(G=>!!G.allBasenames);W&&(ce.allBasenames=W.allBasenames);const J=ee.reduce((G,V)=>V.allPaths?G.concat(V.allPaths):G,[]);return J.length&&(ce.allPaths=J),ce}function X(z,B,ee){if(B===!1)return i;const se=n(z,ee);if(se===i)return i;if(typeof B=="boolean")return se;if(B){const ce=B.when;if(typeof ce=="string"){const W=(J,G,V,O)=>{if(!O||!se(J,G))return null;const $=ce.replace("$(basename)",()=>V),x=O($);return(0,a.isThenable)(x)?x.then(q=>q?z:null):x?z:null};return W.requiresSiblings=!0,W}}return se}function j(z,B){const ee=z.filter(G=>!!G.basenames);if(ee.length<2)return z;const se=ee.reduce((G,V)=>{const O=V.basenames;return O?G.concat(O):G},[]);let ce;if(B){ce=[];for(let G=0,V=se.length;G<V;G++)ce.push(B)}else ce=ee.reduce((G,V)=>{const O=V.patterns;return O?G.concat(O):G},[]);const W=function(G,V){if(typeof G!="string")return null;if(!V){let $;for($=G.length;$>0;$--){const x=G.charCodeAt($-1);if(x===A.CharCode.Slash||x===A.CharCode.Backslash)break}V=G.substr($)}const O=se.indexOf(V);return O!==-1?ce[O]:null};W.basenames=se,W.patterns=ce,W.allBasenames=se;const J=z.filter(G=>!G.basenames);return J.push(W),J}function ie(z,B){return(0,D.equals)(z,B,(ee,se)=>typeof ee=="string"&&typeof se=="string"?ee===se:typeof ee!="string"&&typeof se!="string"?ee.base===se.base&&ee.pattern===se.pattern:!1)}}),define(le[95],ue([0,1,15,64,9]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=T,e.transformIncomingURIs=P,e.transformAndReviveIncomingURIs=S;function L(u){return u.toJSON()}class k{constructor(p){this._uriTransformer=p}transformIncoming(p){const c=this._uriTransformer.transformIncoming(p);return c===p?p:L(A.URI.from(c))}transformOutgoing(p){const c=this._uriTransformer.transformOutgoing(p);return c===p?p:L(A.URI.from(c))}transformOutgoingURI(p){const c=this._uriTransformer.transformOutgoing(p);return c===p?p:A.URI.from(c)}transformOutgoingScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function _(u,p,c){if(!u||c>200)return null;if(typeof u=="object"){if(u instanceof A.URI)return p.transformOutgoing(u);for(const g in u)if(Object.hasOwnProperty.call(u,g)){const f=_(u[g],p,c+1);f!==null&&(u[g]=f)}}return null}function T(u,p){const c=_(u,p,0);return c===null?u:c}function y(u,p,c,g){if(!u||g>200)return null;if(typeof u=="object"){if(u.$mid===a.MarshalledId.Uri)return c?A.URI.revive(p.transformIncoming(u)):p.transformIncoming(u);if(u instanceof D.VSBuffer)return null;for(const f in u)if(Object.hasOwnProperty.call(u,f)){const h=y(u[f],p,c,g+1);h!==null&&(u[f]=h)}}return null}function P(u,p){const c=y(u,p,!1,0);return c===null?u:c}function S(u,p){const c=y(u,p,!0,0);return c===null?u:c}}),define(le[150],ue([0,1,38,52,32,137,5]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=T,e.getSqmMachineId=S,e.getdevDeviceId=u,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(p){return this._virtualMachineOUIs||(this._virtualMachineOUIs=a.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(p)}value(){if(this._value===void 0){let p=0,c=0;const g=(0,D.networkInterfaces)();for(const f in g){const h=g[f];if(h)for(const{mac:E,internal:I}of h)I||(c+=1,this._isVirtualMachineMacAddress(E.toUpperCase())&&(p+=1))}this._value=c>0?p/c:0}return this._value}};let _;async function T(p){return _||(_=(async()=>await y(p)||A.generateUuid())()),_}async function y(p){try{const c=await new Promise((f,h)=>{ne(["crypto"],f,h)}),g=(0,L.getMac)();return c.createHash("sha256").update(g,"utf8").digest("hex")}catch(c){p(c);return}}const P="Software\\Microsoft\\SQMClient";async function S(p){if(k.isWindows){const c=await new Promise((g,f)=>{ne(["@vscode/windows-registry"],g,f)});try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(g){return p(g),""}}return""}async function u(p){try{return await(await new Promise((f,h)=>{ne(["@vscode/deviceid"],f,h)})).getDeviceId()}catch(c){return p(c),""}}}),define(le[151],ue([0,1,43,152,14,36]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDisplayProtocol=P,e.getCodeDisplayProtocol=S;const k="XDG_SESSION_TYPE",_="WAYLAND_DISPLAY",T="XDG_RUNTIME_DIR";var y;(function(u){u.Wayland="wayland",u.XWayland="xwayland",u.X11="x11",u.Unknown="unknown"})(y||(y={}));async function P(u){const p=L.env[k];if(p)return p===y.Wayland||p===y.X11?p:y.Unknown;if(L.env[_]){const g=L.env[T];if(g){const f=(0,A.join)(g,"wayland-0");try{return await(0,a.access)(f,D.constants.R_OK),y.Wayland}catch(h){return u(h),y.Unknown}}else return y.Unknown}else return y.X11}function S(u,p){if(p)switch(p){case"auto":return u;case"x11":return u===y.Wayland?y.XWayland:y.X11;case"wayland":return y.Wayland;default:return y.Unknown}else return u===y.Wayland?y.XWayland:y.X11}}),define(le[153],ue([0,1,43,152,277,5]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOSReleaseInfo=k;async function k(_){if(L.isMacintosh||L.isWindows)return;let T;for(const y of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{T=await(0,a.open)(y,D.constants.R_OK);break}catch{}if(!T){_("Unable to retrieve release information from known identifier paths.");return}try{const y=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),P={id:"unknown"};for await(const S of(0,A.createInterface)({input:T.createReadStream(),crlfDelay:1/0})){if(!S.includes("="))continue;const u=S.split("=")[0].toUpperCase().trim();if(y.has(u)){const p=S.split("=")[1].replace(/"/g,"").toLowerCase().trim();u==="ID"||u==="DISTRIB_ID"?P.id=p:u==="ID_LIKE"?P.id_like=p:(u==="VERSION_ID"||u==="DISTRIB_RELEASE")&&(P.version_id=p)}}return P}catch(y){_(y)}}}),define(le[31],ue([0,1,43,38,278,6,42,91,14,5,21,9]),function(ne,e,D,a,A,L,k,_,T,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=I,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=m;var u;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function p(H,X=u.UNLINK,j){if((0,k.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");return X===u.UNLINK?g(H):c(H,j)}async function c(H,X=(0,k.randomPath)((0,a.tmpdir)())){try{try{await D.promises.rename(H,X)}catch(j){return j.code==="ENOENT"?void 0:g(H)}g(X).catch(j=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function g(H){return(0,A.promisify)(D.rm)(H,{recursive:!0,force:!0,maxRetries:3})}function f(H){if((0,k.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}async function h(H,X){return d(await(X?E(H):(0,A.promisify)(D.readdir)(H)))}async function E(H){try{return await(0,A.promisify)(D.readdir)(H,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const X=[],j=await h(H);for(const ie of j){let z=!1,B=!1,ee=!1;try{const se=await e.Promises.lstat((0,T.join)(H,ie));z=se.isFile(),B=se.isDirectory(),ee=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}X.push({name:ie,isFile:()=>z,isDirectory:()=>B,isSymbolicLink:()=>ee})}return X}function I(H){return d(D.readdirSync(H))}function d(H){return H.map(X=>typeof X=="string"?y.isMacintosh?(0,_.normalizeNFC)(X):X:(X.name=y.isMacintosh?(0,_.normalizeNFC)(X.name):X.name,X))}async function v(H){const X=await h(H),j=[];for(const ie of X)await r.existsDirectory((0,T.join)(H,ie))&&j.push(ie);return j}function t(H,X=1e3){return new Promise(j=>{let ie=!1;const z=setInterval(()=>{ie||(ie=!0,D.access(H,B=>{ie=!1,B&&(clearInterval(z),j(void 0))}))},X)})}var r;(function(H){async function X(z){let B;try{if(B=await e.Promises.lstat(z),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(y.isWindows&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw se}throw ee}}H.stat=X;async function j(z){try{const{stat:B,symbolicLink:ee}=await H.stat(z);return B.isFile()&&ee?.dangling!==!0}catch{}return!1}H.existsFile=j;async function ie(z){try{const{stat:B,symbolicLink:ee}=await H.stat(z);return B.isDirectory()&&ee?.dangling!==!0}catch{}return!1}H.existsDirectory=ie})(r||(e.SymlinkSupport=r={}));const s=new L.ResourceQueue;function i(H,X,j){return s.queueFor(S.URI.file(H),()=>{const ie=w(j);return new Promise((z,B)=>l(H,X,ie,ee=>ee?B(ee):z()))},P.extUriBiasedIgnorePathCase)}let n=!0;function o(H){n=H}function l(H,X,j,ie){if(!n)return D.writeFile(H,X,{mode:j.mode,flag:j.flag},ie);D.open(H,j.flag,j.mode,(z,B)=>{if(z)return ie(z);D.writeFile(B,X,ee=>{if(ee)return D.close(B,()=>ie(ee));D.fdatasync(B,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),o(!1)),D.close(B,ce=>ie(ce))))})})}function m(H,X,j){const ie=w(j);if(!n)return D.writeFileSync(H,X,{mode:ie.mode,flag:ie.flag});const z=D.openSync(H,ie.flag,ie.mode);try{D.writeFileSync(z,X);try{D.fdatasyncSync(z)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),o(!1)}}finally{D.closeSync(z)}}function w(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function C(H,X,j=6e4){if(H!==X)try{y.isWindows&&typeof j=="number"?await b(H,X,Date.now(),j):await(0,A.promisify)(D.rename)(H,X)}catch(ie){if(H.toLowerCase()!==X.toLowerCase()&&ie.code==="EXDEV"||H.endsWith("."))await R(H,X,{preserveSymlinks:!1}),await p(H,u.MOVE);else throw ie}}async function b(H,X,j,ie,z=0){try{return await(0,A.promisify)(D.rename)(H,X)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-j>=ie)throw console.error(`[node.js fs] rename failed after ${z} retries with error: ${B}`),B;if(z===0){let ee=!1;try{const{stat:se}=await r.stat(X);se.isFile()||(ee=!0)}catch{}if(ee)throw B}return await(0,L.timeout)(Math.min(100,z*10)),b(H,X,j,ie,z+1)}}async function R(H,X,j){return N(H,X,{root:{source:H,target:X},options:j,handledSourcePaths:new Set})}const U=511;async function N(H,X,j){if(j.handledSourcePaths.has(H))return;j.handledSourcePaths.add(H);const{stat:ie,symbolicLink:z}=await r.stat(H);if(z){if(j.options.preserveSymlinks)try{return await K(H,X,j)}catch{}if(z.dangling)return}return ie.isDirectory()?M(H,X,ie.mode&U,j):F(H,X,ie.mode&U)}async function M(H,X,j,ie){await e.Promises.mkdir(X,{recursive:!0,mode:j});const z=await h(H);for(const B of z)await N((0,T.join)(H,B),(0,T.join)(X,B),ie)}async function F(H,X,j){await e.Promises.copyFile(H,X),await e.Promises.chmod(X,j)}async function K(H,X,j){let ie=await e.Promises.readlink(H);(0,k.isEqualOrParent)(ie,j.root.source,!y.isLinux)&&(ie=(0,T.join)(j.root.target,ie.substr(j.root.source.length+1))),await e.Promises.symlink(ie,X)}e.Promises=new class{get access(){return(0,A.promisify)(D.access)}get stat(){return(0,A.promisify)(D.stat)}get lstat(){return(0,A.promisify)(D.lstat)}get utimes(){return(0,A.promisify)(D.utimes)}get read(){return(H,X,j,ie,z)=>new Promise((B,ee)=>{D.read(H,X,j,ie,z,(se,ce,W)=>se?ee(se):B({bytesRead:ce,buffer:W}))})}get readFile(){return(0,A.promisify)(D.readFile)}get write(){return(H,X,j,ie,z)=>new Promise((B,ee)=>{D.write(H,X,j,ie,z,(se,ce,W)=>se?ee(se):B({bytesWritten:ce,buffer:W}))})}get appendFile(){return(0,A.promisify)(D.appendFile)}get fdatasync(){return(0,A.promisify)(D.fdatasync)}get truncate(){return(0,A.promisify)(D.truncate)}get copyFile(){return(0,A.promisify)(D.copyFile)}get open(){return(0,A.promisify)(D.open)}get close(){return(0,A.promisify)(D.close)}get symlink(){return(0,A.promisify)(D.symlink)}get readlink(){return(0,A.promisify)(D.readlink)}get chmod(){return(0,A.promisify)(D.chmod)}get mkdir(){return(0,A.promisify)(D.mkdir)}get unlink(){return(0,A.promisify)(D.unlink)}get rmdir(){return(0,A.promisify)(D.rmdir)}get realpath(){return(0,A.promisify)(D.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return v}get writeFile(){return i}get rm(){return p}get rename(){return C}get copy(){return R}}}),define(le[154],ue([0,1,43,14,5,27,31]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=_,e.realcase=T,e.realpath=y,e.realpathSync=P;function _(u){if(A.isLinux)return u;const p=(0,a.dirname)(u);if(u===p)return u;const c=((0,a.basename)(u)||u).toLowerCase();try{const f=(0,k.readdirSync)(p).filter(h=>h.toLowerCase()===c);if(f.length===1){const h=_(p);if(h)return(0,a.join)(h,f[0])}else if(f.length>1){const h=f.indexOf(c);if(h>=0){const E=_(p);if(E)return(0,a.join)(E,f[h])}}}catch{}return null}async function T(u,p){if(A.isLinux)return u;const c=(0,a.dirname)(u);if(u===c)return u;const g=((0,a.basename)(u)||u).toLowerCase();try{if(p?.isCancellationRequested)return null;const h=(await k.Promises.readdir(c)).filter(E=>E.toLowerCase()===g);if(h.length===1){const E=await T(c,p);if(E)return(0,a.join)(E,h[0])}else if(h.length>1){const E=h.indexOf(g);if(E>=0){const I=await T(c,p);if(I)return(0,a.join)(I,h[E])}}}catch{}return null}async function y(u){try{return await k.Promises.realpath(u)}catch{const c=S(u);return await k.Promises.access(c,D.constants.R_OK),c}}function P(u){try{return D.realpathSync(u)}catch{const c=S(u);return D.accessSync(c,D.constants.R_OK),c}}function S(u){return(0,L.rtrim)((0,a.normalize)(u),a.sep)}}),define(le[155],ue([0,1,14,5,36,93,13,31]),function(ne,e,D,a,A,L,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=T,e.createQueuedSender=y,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function T(S=A.env){return S.comspec||"cmd.exe"}function y(S){let u=[],p=!1;const c=function(g){if(p){u.push(g);return}(!S.send(g,h=>{if(h&&console.error(h),p=!1,u.length>0){const E=u.slice(0);u=[],E.forEach(I=>c(I))}})||a.isWindows)&&(p=!0)};return{send:c}}var P;(function(S){async function u(p,c,g){if(D.isAbsolute(p))return p;if(c===void 0&&(c=A.cwd()),D.dirname(p)!=="."||(g===void 0&&k.isString(A.env.PATH)&&(g=A.env.PATH.split(D.delimiter)),g===void 0||g.length===0))return D.join(c,p);async function h(E){if(await _.Promises.exists(E)){let I;try{I=await _.Promises.stat(E)}catch(d){d.message.startsWith("EACCES")&&(I=await _.Promises.lstat(E))}return I?!I.isDirectory():!1}return!1}for(const E of g){let I;if(D.isAbsolute(E)?I=D.join(E,p):I=D.join(c,E,p),await h(I))return I;let d=I+".com";if(await h(d)||(d=I+".exe",await h(d)))return d}return D.join(c,p)}S.findExecutable=u})(P||(e.win32=P={}))}),define(le[156],ue([0,1,69,23]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=A;function A(k){return new Promise((_,T)=>{let y;const P=new Map;function S(p,c,g,f,h){const E=P.get(c);if(p===k||E){const I={name:u(g),cmd:g,pid:p,ppid:c,load:f,mem:h};P.set(p,I),p===k&&(y=I),E&&(E.children||(E.children=[]),E.children.push(I),E.children.length>1&&(E.children=E.children.sort((d,v)=>d.pid-v.pid)))}}function u(p){const c=/--utility-sub-type=network/i,g=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,E=/--type=([a-zA-Z-]+)/;if(g.exec(p))return"electron-crash-reporter";if(f.exec(p))return"winpty-agent";if(h.exec(p))return"conpty-agent";let I=E.exec(p);if(I&&I.length===2)return I[1]==="renderer"?"window":I[1]==="utility"?c.exec(p)?"utility-network-service":"utility-process":I[1]==="extensionHost"?"extension-host":I[1];const d=/[a-zA-Z-]+\.js/g;let v="";do I=d.exec(p),I&&(v+=I+" ");while(I);return v&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron-nodejs (${v})`:p}if(process.platform==="win32"){const p=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,g)=>{ne(["@vscode/windows-process-tree"],c,g)}).then(c=>{c.getProcessList(k,g=>{if(!g){T(new Error(`Root process ${k} not found`));return}c.getProcessCpuUsage(g,f=>{const h=new Map;f.forEach(E=>{const I=p(E.commandLine||"");h.set(E.pid,{name:u(I),cmd:I,pid:E.pid,ppid:E.ppid,load:E.cpu||0,mem:E.memory||0})}),y=h.get(k),y?(h.forEach(E=>{const I=h.get(E.ppid);I&&(I.children||(I.children=[]),I.children.push(E))}),h.forEach(E=>{E.children&&(E.children=E.children.sort((I,d)=>I.pid-d.pid))}),_(y)):T(new Error(`Root process ${k} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let p=function(){let c=[y];const g=[];for(;c.length;){const h=c.shift();h&&(g.push(h.pid),h.children&&(c=c.concat(h.children)))}let f=JSON.stringify(a.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+g.join(" "),(0,D.exec)(f,{},(h,E,I)=>{if(h||I)T(h||new Error(I.toString()));else{const d=E.toString().split(`
`);for(let v=0;v<g.length;v++){const t=P.get(g[v]);t.load=parseFloat(d[v])}if(!y){T(new Error(`Root process ${k} not found`));return}_(y)}})};(0,D.exec)("which ps",{},(c,g,f)=>{if(c||f)if(process.platform!=="linux")T(c||new Error(f.toString()));else{const h=JSON.stringify(a.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(h,{},(E,I,d)=>{E||d?T(E||new Error(d.toString())):(L(I,S),p())})}else{const h=g.toString().trim();(0,D.exec)(`${h} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(I,d,v)=>{I||v&&!v.includes("screen size is bogus")?T(I||new Error(v.toString())):(L(d,S),process.platform==="linux"?p():y?_(y):T(new Error(`Root process ${k} not found`)))})}})}})}function L(k,_){const T=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=k.toString().split(`
`);for(const P of y){const S=T.exec(P.trim());S&&S.length===6&&_(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}});var we=this&&this.__decorate||function(ne,e,D,a){var A=arguments.length,L=A<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,D):a,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ne,e,D,a);else for(var _=ne.length-1;_>=0;_--)(k=ne[_])&&(L=(A<3?k(L):A>3?k(e,D,L):k(e,D))||L);return A>3&&L&&Object.defineProperty(e,D,L),L};define(le[44],ue([0,1,19,6,15,26,88,8,3,2,68,27,13]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=o,e.deserialize=l,e.getDelayedChannel=U,e.getNextTickChannel=N;var p;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(p||(p={}));function c(z){switch(z){case p.Promise:return"req";case p.PromiseCancel:return"cancel";case p.EventListen:return"subscribe";case p.EventDispose:return"unsubscribe"}}var g;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(g||(g={}));function f(z){switch(z){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var h;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(h||(h={}));function E(z){let B=0;for(let ee=0;;ee+=7){const se=z.read(1);if(B|=(se.buffer[0]&127)<<ee,!(se.buffer[0]&128))return B}}const I=s(0);function d(z,B){if(B===0){z.write(I);return}let ee=0;for(let ce=B;ce!==0;ce=ce>>>7)ee++;const se=A.VSBuffer.alloc(ee);for(let ce=0;B!==0;ce++)se.buffer[ce]=B&127,B=B>>>7,B>0&&(se.buffer[ce]|=128);z.write(se)}class v{constructor(B){this.buffer=B,this.pos=0}read(B){const ee=this.buffer.slice(this.pos,this.pos+B);return this.pos+=ee.byteLength,ee}}e.BufferReader=v;class t{constructor(){this.buffers=[]}get buffer(){return A.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}e.BufferWriter=t;var r;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(r||(r={}));function s(z){const B=A.VSBuffer.alloc(1);return B.writeUInt8(z,0),B}const i={Undefined:s(r.Undefined),String:s(r.String),Buffer:s(r.Buffer),VSBuffer:s(r.VSBuffer),Array:s(r.Array),Object:s(r.Object),Uint:s(r.Int)},n=typeof Buffer<"u";function o(z,B){if(typeof B>"u")z.write(i.Undefined);else if(typeof B=="string"){const ee=A.VSBuffer.fromString(B);z.write(i.String),d(z,ee.byteLength),z.write(ee)}else if(n&&Buffer.isBuffer(B)){const ee=A.VSBuffer.wrap(B);z.write(i.Buffer),d(z,ee.byteLength),z.write(ee)}else if(B instanceof A.VSBuffer)z.write(i.VSBuffer),d(z,B.byteLength),z.write(B);else if(Array.isArray(B)){z.write(i.Array),d(z,B.length);for(const ee of B)o(z,ee)}else if(typeof B=="number"&&(B|0)===B)z.write(i.Uint),d(z,B);else{const ee=A.VSBuffer.fromString(JSON.stringify(B));z.write(i.Object),d(z,ee.byteLength),z.write(ee)}}function l(z){switch(z.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return z.read(E(z)).toString();case r.Buffer:return z.read(E(z)).buffer;case r.VSBuffer:return z.read(E(z));case r.Array:{const ee=E(z),se=[];for(let ce=0;ce<ee;ce++)se.push(l(z));return se}case r.Object:return JSON.parse(z.read(E(z)).toString());case r.Int:return E(z)}}class m{constructor(B,ee,se=null,ce=1e3){this.protocol=B,this.ctx=ee,this.logger=se,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:g.Initialize})}registerChannel(B,ee){this.channels.set(B,ee),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case g.Initialize:{const ee=this.send([B.type]);this.logger?.logOutgoing(ee,0,w.OtherSide,f(B.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const ee=this.send([B.type,B.id],B.data);this.logger?.logOutgoing(ee,B.id,w.OtherSide,f(B.type),B.data);return}}}send(B,ee=void 0){const se=new t;return o(se,B),o(se,ee),this.sendBuffer(se.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const ee=new v(B),se=l(ee),ce=l(ee),W=se[0];switch(W){case p.Promise:return this.logger?.logIncoming(B.byteLength,se[1],w.OtherSide,`${c(W)}: ${se[2]}.${se[3]}`,ce),this.onPromise({type:W,id:se[1],channelName:se[2],name:se[3],arg:ce});case p.EventListen:return this.logger?.logIncoming(B.byteLength,se[1],w.OtherSide,`${c(W)}: ${se[2]}.${se[3]}`,ce),this.onEventListen({type:W,id:se[1],channelName:se[2],name:se[3],arg:ce});case p.PromiseCancel:return this.logger?.logIncoming(B.byteLength,se[1],w.OtherSide,`${c(W)}`),this.disposeActiveRequest({type:W,id:se[1]});case p.EventDispose:return this.logger?.logIncoming(B.byteLength,se[1],w.OtherSide,`${c(W)}`),this.disposeActiveRequest({type:W,id:se[1]})}}onPromise(B){const ee=this.channels.get(B.channelName);if(!ee){this.collectPendingRequest(B);return}const se=new L.CancellationTokenSource;let ce;try{ce=ee.call(this.ctx,B.name,B.arg,se.token)}catch(G){ce=Promise.reject(G)}const W=B.id;ce.then(G=>{this.sendResponse({id:W,data:G,type:g.PromiseSuccess})},G=>{G instanceof Error?this.sendResponse({id:W,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:g.PromiseError}):this.sendResponse({id:W,data:G,type:g.PromiseErrorObj})}).finally(()=>{J.dispose(),this.activeRequests.delete(B.id)});const J=(0,y.toDisposable)(()=>se.cancel());this.activeRequests.set(B.id,J)}onEventListen(B){const ee=this.channels.get(B.channelName);if(!ee){this.collectPendingRequest(B);return}const se=B.id,W=ee.listen(this.ctx,B.name,B.arg)(J=>this.sendResponse({id:se,data:J,type:g.EventFire}));this.activeRequests.set(B.id,W)}disposeActiveRequest(B){const ee=this.activeRequests.get(B.id);ee&&(ee.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let ee=this.pendingRequests.get(B.channelName);ee||(ee=[],this.pendingRequests.set(B.channelName,ee));const se=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===p.Promise&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:g.PromiseError})},this.timeoutDelay);ee.push({request:B,timeoutTimer:se})}flushPendingRequests(B){const ee=this.pendingRequests.get(B);if(ee){for(const se of ee)switch(clearTimeout(se.timeoutTimer),se.request.type){case p.Promise:this.onPromise(se.request);break;case p.EventListen:this.onEventListen(se.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=m;var w;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class C{constructor(B,ee=null){this.protocol=B,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new T.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(se=>this.onBuffer(se)),this.logger=ee}getChannel(B){const ee=this;return{call(se,ce,W){return ee.isDisposed?Promise.reject(new _.CancellationError):ee.requestPromise(B,se,ce,W)},listen(se,ce){return ee.isDisposed?T.Event.None:ee.requestEvent(B,se,ce)}}}requestPromise(B,ee,se,ce=L.CancellationToken.None){const W=this.lastRequestId++,J=p.Promise,G={id:W,type:J,channelName:B,name:ee,arg:se};if(ce.isCancellationRequested)return Promise.reject(new _.CancellationError);let V;return new Promise(($,x)=>{if(ce.isCancellationRequested)return x(new _.CancellationError);const q=()=>{const ae=he=>{switch(he.type){case g.PromiseSuccess:this.handlers.delete(W),$(he.data);break;case g.PromiseError:{this.handlers.delete(W);const ge=new Error(he.data.message);ge.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ge.name=he.data.name,x(ge);break}case g.PromiseErrorObj:this.handlers.delete(W),x(he.data);break}};this.handlers.set(W,ae),this.sendRequest(G)};let te=null;this.state===h.Idle?q():(te=(0,a.createCancelablePromise)(ae=>this.whenInitialized()),te.then(()=>{te=null,q()}));const Z=()=>{te?(te.cancel(),te=null):this.sendRequest({id:W,type:p.PromiseCancel}),x(new _.CancellationError)},Y=ce.onCancellationRequested(Z);V=(0,y.combinedDisposable)((0,y.toDisposable)(Z),Y),this.activeRequests.add(V)}).finally(()=>{V.dispose(),this.activeRequests.delete(V)})}requestEvent(B,ee,se){const ce=this.lastRequestId++,W=p.EventListen,J={id:ce,type:W,channelName:B,name:ee,arg:se};let G=null;const V=new T.Emitter({onWillAddFirstListener:()=>{G=(0,a.createCancelablePromise)($=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(V),this.sendRequest(J)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(V),this.sendRequest({id:ce,type:p.EventDispose}))}}),O=$=>V.fire($.data);return this.handlers.set(ce,O),V.event}sendRequest(B){switch(B.type){case p.Promise:case p.EventListen:{const ee=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger?.logOutgoing(ee,B.id,w.LocalSide,`${c(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case p.PromiseCancel:case p.EventDispose:{const ee=this.send([B.type,B.id]);this.logger?.logOutgoing(ee,B.id,w.LocalSide,c(B.type));return}}}send(B,ee=void 0){const se=new t;return o(se,B),o(se,ee),this.sendBuffer(se.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const ee=new v(B),se=l(ee),ce=l(ee),W=se[0];switch(W){case g.Initialize:return this.logger?.logIncoming(B.byteLength,0,w.LocalSide,f(W)),this.onResponse({type:se[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.logger?.logIncoming(B.byteLength,se[1],w.LocalSide,f(W),ce),this.onResponse({type:se[0],id:se[1],data:ce})}}onResponse(B){if(B.type===g.Initialize){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(B.id)?.(B)}get onDidInitializePromise(){return T.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=C,we([k.memoize],C.prototype,"onDidInitializePromise",null);class b{get connections(){const B=[];return this._connections.forEach(ee=>B.push(ee)),B}constructor(B,ee,se){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new T.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new T.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new y.DisposableStore,this.disposables.add(B(({protocol:ce,onDidClientDisconnect:W})=>{const J=T.Event.once(ce.onMessage);this.disposables.add(J(G=>{const V=new v(G),O=l(V),$=new m(ce,O,ee,se),x=new C(ce,ee);this.channels.forEach((te,Z)=>$.registerChannel(Z,te));const q={channelServer:$,channelClient:x,ctx:O};this._connections.add(q),this._onDidAddConnection.fire(q),this.disposables.add(W(()=>{$.dispose(),x.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)}))}))}))}getChannel(B,ee){const se=this;return{call(ce,W,J){let G;if((0,u.isFunction)(ee)){const O=(0,D.getRandomElement)(se.connections.filter(ee));G=O?Promise.resolve(O):T.Event.toPromise(T.Event.filter(se.onDidAddConnection,ee))}else G=ee.routeCall(se,ce,W);const V=G.then(O=>O.channelClient.getChannel(B));return U(V).call(ce,W,J)},listen(ce,W){if((0,u.isFunction)(ee))return se.getMulticastEvent(B,ee,ce,W);const J=ee.routeEvent(se,ce,W).then(G=>G.channelClient.getChannel(B));return U(J).listen(ce,W)}}}getMulticastEvent(B,ee,se,ce){const W=this;let J;const G=new T.Emitter({onWillAddFirstListener:()=>{J=new y.DisposableStore;const V=new T.EventMultiplexer,O=new Map,$=q=>{const Z=q.channelClient.getChannel(B).listen(se,ce),Y=V.add(Z);O.set(q,Y)},x=q=>{const te=O.get(q);te&&(te.dispose(),O.delete(q))};W.connections.filter(ee).forEach($),T.Event.filter(W.onDidAddConnection,ee)($,void 0,J),W.onDidRemoveConnection(x,void 0,J),V.event(G.fire,G,J),J.add(V)},onDidRemoveLastListener:()=>{J?.dispose(),J=void 0}});return G.event}registerChannel(B,ee){this.channels.set(B,ee);for(const se of this._connections)se.channelServer.registerChannel(B,ee)}dispose(){this.disposables.dispose();for(const B of this._connections)B.channelClient.dispose(),B.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class R{constructor(B,ee,se=null){const ce=new t;o(ce,ee),B.send(ce.buffer),this.channelClient=new C(B,se),this.channelServer=new m(B,ee,se)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,ee){this.channelServer.registerChannel(B,ee)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function U(z){return{call(B,ee,se){return z.then(ce=>ce.call(B,ee,se))},listen(B,ee){const se=new T.Relay;return z.then(ce=>se.input=ce.listen(B,ee)),se.event}}}function N(z){let B=!1;return{call(ee,se,ce){return B?z.call(ee,se,ce):(0,a.timeout)(0).then(()=>B=!0).then(()=>z.call(ee,se,ce))},listen(ee,se){if(B)return z.listen(ee,se);const ce=new T.Relay;return(0,a.timeout)(0).then(()=>B=!0).then(()=>ce.input=z.listen(ee,se)),ce.event}}}class M{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const ee of B.connections)if(await Promise.resolve(this.fn(ee.ctx)))return Promise.resolve(ee);return await T.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=M;var F;(function(z){function B(W,J,G){const V=W,O=G&&G.disableMarshalling,$=new Map;for(const x in V)se(x)&&$.set(x,T.Event.buffer(V[x],!0,void 0,J));return new class{listen(x,q,te){const Z=$.get(q);if(Z)return Z;const Y=V[q];if(typeof Y=="function"){if(ce(q))return Y.call(V,te);if(se(q))return $.set(q,T.Event.buffer(V[q],!0,void 0,J)),$.get(q)}throw new _.ErrorNoTelemetry(`Event not found: ${q}`)}call(x,q,te){const Z=V[q];if(typeof Z=="function"){if(!O&&Array.isArray(te))for(let ae=0;ae<te.length;ae++)te[ae]=(0,P.revive)(te[ae]);let Y=Z.apply(V,te);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new _.ErrorNoTelemetry(`Method not found: ${q}`)}}}z.fromService=B;function ee(W,J){const G=J&&J.disableMarshalling;return new Proxy({},{get(V,O){if(typeof O=="string")return J?.properties?.has(O)?J.properties.get(O):ce(O)?function($){return W.listen(O,$)}:se(O)?W.listen(O):async function(...$){let x;J&&!(0,u.isUndefinedOrNull)(J.context)?x=[J.context,...$]:x=$;const q=await W.call(O,x);return G?q:(0,P.revive)(q)};throw new _.ErrorNoTelemetry(`Property not found: ${String(O)}`)}})}z.toService=ee;function se(W){return W[0]==="o"&&W[1]==="n"&&S.isUpperAsciiLetter(W.charCodeAt(2))}function ce(W){return/^onDynamic/.test(W)&&S.isUpperAsciiLetter(W.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const B=z.toString();if(B!=="[object Object]")return B}return z}function X(z){return Array.isArray(z)?z.map(H):H(z)}function j(z,B,ee,se,ce,W,J){J=X(J);const G=K[ce],V=G[se%G.length];let O=[`%c[${z}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(W)?(O=O.concat(J),O.push(")")):O.push(J),console.log.apply(console,O)}class ie{constructor(B,ee){this._outgoingPrefix=B,this._incomingPrefix=ee,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,ee,se,ce,W){this._totalOutgoing+=B,j(this._outgoingPrefix,this._totalOutgoing,B,ee,se,ce,W)}logIncoming(B,ee,se,ce,W){this._totalIncoming+=B,j(this._incomingPrefix,this._totalIncoming,B,ee,se,ce,W)}}e.IPCLogger=ie}),define(le[70],ue([0,1,15,3,2,44]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var _;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function l(w,C){if(!n.has(w)){const b=String(++o);n.set(w,b)}return n.get(w)}function m(w,C,b,R){if(!i.enableDiagnostics)return;const U=l(w,C);if(R instanceof D.VSBuffer||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const N=D.VSBuffer.alloc(R.byteLength);N.set(R),i.records.push({timestamp:Date.now(),id:U,label:C,type:b,buff:N})}else i.records.push({timestamp:Date.now(),id:U,label:C,type:b,data:R})}i.traceSocketEvent=m})(_||(e.SocketDiagnostics=_={}));var T;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(T||(e.SocketCloseEventType=T={}));let y=null;function P(){return y||(y=D.VSBuffer.alloc(0)),y}class S{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return P();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const C=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),C}if(this._chunks[0].byteLength>n){const C=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),C}const l=D.VSBuffer.alloc(n);let m=0,w=0;for(;n>0;){const C=this._chunks[w];if(C.byteLength>n){const b=C.slice(0,n);l.set(b,m),m+=n,o&&(this._chunks[w]=C.slice(n),this._totalLength-=n),n-=n}else l.set(C,m),m+=C.byteLength,o?(this._chunks.shift(),this._totalLength-=C.byteLength):w++,n-=C.byteLength}return l}}e.ChunkStream=S;var u;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(u||(u={}));function p(i){switch(i){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var c;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(c||(e.ProtocolConstants=c={}));class g{constructor(n,o,l,m){this.type=n,this.id=o,this.ack=l,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends A.Disposable{constructor(n){super(),this._onMessage=this._register(new a.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:c.HeaderLength,messageType:u.None,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new S,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent(k.ProtocolHeaderRead,{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,m=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=c.HeaderLength,this._state.messageType=u.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(k.ProtocolMessageRead,o),this._onMessage.fire(new g(l,m,w,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=D.VSBuffer.alloc(c.HeaderLength);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent(k.ProtocolHeaderWrite,{messageType:p(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent(k.ProtocolMessageWrite,n.data),this._writeSoon(o,n.data)}_bufferAdd(n,o){const l=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,l}_bufferTake(){const n=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent(k.ProtocolWrite,{byteLength:n.byteLength}),this._socket.write(n)}}class E extends A.Disposable{constructor(n){super(),this._onMessage=new a.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new a.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===u.Regular&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new g(u.Regular,0,0,n))}}e.Protocol=E;class I extends L.IPCClient{static fromSocket(n,o){return new I(new E(n),o)}get onDidDispose(){return this.protocol.onDidDispose}constructor(n,o,l=null){super(n,o,l),this.protocol=n}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=I;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new a.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class v{constructor(n){this.data=n,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let n=0,o=this._first;for(;o;)o=o.next,n++;return n}peek(){return this._first?this._first.data:null}toArray(){const n=[];let o=0,l=this._first;for(;l;)n[o++]=l.data,l=l.next;return n}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new v(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class r{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<r._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=r._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}load(){const n=Date.now(),o=(1+r._HISTORY_LENGTH)*1e3;let l=0;for(let m=0;m<r._HISTORY_LENGTH;m++)n-this.lastRuns[m]<=o&&l++;return 1-l/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(n){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n.loadEstimator??r.getInstance(),this._shouldSendKeepAlive=n.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=n.socket,this._socketWriter=this._socketDisposables.add(new h(this._socket)),this._socketReader=this._socketDisposables.add(new f(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.add(this._socket.onClose(o=>this._onSocketClose.fire(o))),n.initialChunk&&this._socketReader.acceptChunk(n.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},c.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new g(u.Disconnect,0,0,P());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new g(u.Pause,0,0,P());this._socketWriter.write(n)}sendResume(){const n=new g(u.Resume,0,0,P());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=this._socketDisposables.add(new h(this._socket)),this._socketReader=this._socketDisposables.add(new f(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.add(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new g(u.Ack,0,this._incomingAckId,P());this._socketWriter.write(n);const o=this._outgoingUnackMsg.toArray();for(let l=0,m=o.length;l<m;l++)this._socketWriter.write(o[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case u.None:break;case u.Regular:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new g(u.ReplayRequest,0,0,P())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case u.Control:{this._onControlMessage.fire(n.data);break}case u.Ack:break;case u.Disconnect:{this._onDidDispose.fire();break}case u.ReplayRequest:{const o=this._outgoingUnackMsg.toArray();for(let l=0,m=o.length;l<m;l++)this._socketWriter.write(o[l]);this._recvAckCheck();break}case u.Pause:{this._socketWriter.pause();break}case u.Resume:{this._socketWriter.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new g(u.Regular,o,this._incomingAckId,n);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(n){const o=new g(u.Control,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=c.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},c.AcknowledgeTime-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime,l=Date.now()-this._socketReader.lastReadTime,m=Date.now()-this._lastSocketTimeoutTime;if(o>=c.TimeoutTime&&l>=c.TimeoutTime&&m>=c.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:l});return}const w=Math.max(c.TimeoutTime-o,c.TimeoutTime-l,c.TimeoutTime-m,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},w)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new g(u.Ack,0,this._incomingAckId,P());this._socketWriter.write(n)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const n=new g(u.KeepAlive,0,this._incomingAckId,P());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(le[96],ue([0,1,69,6,15,26,148,8,3,2,30,155,93,44]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class c extends p.ChannelServer{constructor(h){super({send:E=>{try{process.send?.(E.buffer.toString("base64"))}catch{}},onMessage:T.Event.fromNodeEventEmitter(process,"message",E=>A.VSBuffer.wrap(Buffer.from(E,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=c;class g{constructor(h,E){this.modulePath=h,this.options=E,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const I=E&&E.timeout?E.timeout:6e4;this.disposeDelayer=new a.Delayer(I),this.child=null,this._client=null}getChannel(h){const E=this;return{call(I,d,v){return E.requestPromise(h,I,d,v)},listen(I,d){return E.requestEvent(h,I,d)}}}requestPromise(h,E,I,d=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(_.canceled());this.disposeDelayer.cancel();const v=this.getCachedChannel(h),t=(0,a.createCancelablePromise)(i=>v.call(E,I,i)),r=d.onCancellationRequested(()=>t.cancel()),s=(0,y.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(h,E,I){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let d;const v=new T.Emitter({onWillAddFirstListener:()=>{d=this.getCachedChannel(h).listen(E,I)(v.fire,v),this.activeRequests.add(d)},onDidRemoveLastListener:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return v.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],E=Object.create(null);E.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(E.env={...E.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(E.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(E.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(E.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),E.execArgv===void 0&&(E.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,u.removeDangerousEnvVariables)(E.env),this.child=(0,D.fork)(this.modulePath,h,E);const I=new T.Emitter,v=T.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,k.isRemoteConsoleLog)(o)){(0,k.log)(o,`IPC Library: ${this.options.serverName}`);return}I.fire(A.VSBuffer.wrap(Buffer.from(o,"base64")))}),t=this.options.useQueue?(0,S.createQueuedSender)(this.child):this.child,r=o=>this.child&&this.child.connected&&t.send(o.buffer.toString("base64")),s=I.event,i={send:r,onMessage:s};this._client=new p.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,l)=>{process.removeListener("exit",n),v.dispose(),this.activeRequests.forEach(m=>(0,y.dispose)(m)),this.activeRequests.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:l})})}return this._client}getCachedChannel(h){let E=this.channels.get(h);return E||(E=this.client.getChannel(h),this.channels.set(h,E)),E}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(le[157],ue([0,1,140,15,44,3,13,19]),function(ne,e,D,a,A,L,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=P;class T{constructor(u){this.port=u,this.onMessage=L.Event.fromNodeEventEmitter(this.port,"message",p=>p.data?a.VSBuffer.wrap(p.data):a.VSBuffer.alloc(0)),u.start()}send(u){this.port.postMessage(u.buffer)}disconnect(){this.port.close()}}class y extends A.IPCServer{static getOnDidClientConnect(u){(0,k.assertType)((0,D.isUtilityProcess)(process),"Electron Utility Process");const p=new L.Emitter;return process.parentPort.on("message",c=>{if(u?.handledClientConnection(c))return;const g=(0,_.firstOrDefault)(c.ports);g&&p.fire(g)}),L.Event.map(p.event,c=>({protocol:new T(c),onDidClientDisconnect:L.Event.fromNodeEventEmitter(c,"close")}))}constructor(u){super(y.getOnDidClientConnect(u))}}e.Server=y;function P(S,u,p){const c=g=>{g.data===u&&(S.removeListener("message",c),p())};S.on("message",c)}}),define(le[71],ue([0,1,6,3,2,68,13]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=T;var _;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(_||(e.StorageHint=_={}));function T(u){const p=u;return p?.changed instanceof Map||p?.deleted instanceof Set}var y;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(y||(e.StorageState=y={}));class P extends A.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(p,c=Object.create(null)){super(),this.database=p,this.options=c,this._onDidChangeStorage=this._register(new a.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=y.None,this.cache=new Map,this.flushDelayer=this._register(new D.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){this._onDidChangeStorage.pause();try{p.changed?.forEach((c,g)=>this.acceptExternal(g,c)),p.deleted?.forEach(c=>this.acceptExternal(c,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(p,c){if(this.state===y.Closed)return;let g=!1;(0,k.isUndefinedOrNull)(c)?g=this.cache.delete(p):this.cache.get(p)!==c&&(this.cache.set(p,c),g=!0),g&&this._onDidChangeStorage.fire({key:p,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===y.None&&(this.state=y.Initialized,this.options.hint!==_.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,c){const g=this.cache.get(p);return(0,k.isUndefinedOrNull)(g)?c:g}getBoolean(p,c){const g=this.get(p);return(0,k.isUndefinedOrNull)(g)?c:g==="true"}getNumber(p,c){const g=this.get(p);return(0,k.isUndefinedOrNull)(g)?c:parseInt(g,10)}getObject(p,c){const g=this.get(p);return(0,k.isUndefinedOrNull)(g)?c:(0,L.parse)(g)}async set(p,c,g=!1){if(this.state===y.Closed)return;if((0,k.isUndefinedOrNull)(c))return this.delete(p,g);const f=(0,k.isObject)(c)||Array.isArray(c)?(0,L.stringify)(c):String(c);if(this.cache.get(p)!==f)return this.cache.set(p,f),this.pendingInserts.set(p,f),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire({key:p,external:g}),this.doFlush()}async delete(p,c=!1){if(!(this.state===y.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire({key:p,external:c}),this.doFlush()}async optimize(){if(this.state!==y.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=y.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!(this.state===y.Closed||this.pendingClose))return this.doFlush(p)}async doFlush(p){return this.options.hint===_.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}isInMemory(){return this.options.hint===_.STORAGE_IN_MEMORY}}e.Storage=P;class S{constructor(){this.onDidChangeItemsExternal=a.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((c,g)=>this.items.set(g,c)),p.delete?.forEach(c=>this.items.delete(c))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=S}),define(le[158],ue([12,11]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(le[72],ue([0,1,43,6,14,13,31,158]),function(ne,e,D,a,A,L,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtractError=e.CorruptZipMessage=void 0,e.zip=f,e.extract=h,e.buffer=I,e.CorruptZipMessage="end of central directory record signature not found";const T=new RegExp(e.CorruptZipMessage);class y extends Error{constructor(v,t){let r=t.message;switch(v){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=v,this.cause=t}}e.ExtractError=y;function P(d){const v=d.externalFileAttributes>>16||33188;return[448,56,7].map(t=>v&t).reduce((t,r)=>t+r,v&61440)}function S(d){if(d instanceof y)return d;let v;return T.test(d.message)&&(v="CorruptZip"),new y(v,d)}function u(d,v,t,r,s,i){const n=A.dirname(v),o=A.join(r,n);if(!o.startsWith(r))return Promise.reject(new Error(_.localize(0,null,v)));const l=A.join(r,v);let m;return i.onCancellationRequested(()=>{m?.destroy()}),Promise.resolve(k.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((w,C)=>{if(!i.isCancellationRequested)try{m=(0,D.createWriteStream)(l,{mode:t}),m.once("close",()=>w()),m.once("error",C),d.once("error",C),d.pipe(m)}catch(b){C(b)}}))}function p(d,v,t,r){let s=(0,a.createCancelablePromise)(()=>Promise.resolve()),i=0;const n=r.onCancellationRequested(()=>{s.cancel(),d.close()});return new Promise((o,l)=>{const m=new a.Sequencer,w=C=>{C.isCancellationRequested||(i++,d.readEntry())};d.once("error",l),d.once("close",()=>s.then(()=>{r.isCancellationRequested||d.entryCount===i?o():l(new y("Incomplete",new Error(_.localize(1,null,i,d.entryCount))))},l)),d.readEntry(),d.on("entry",C=>{if(r.isCancellationRequested)return;if(!t.sourcePathRegex.test(C.fileName)){w(r);return}const b=C.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(b)){const N=A.join(v,b);s=(0,a.createCancelablePromise)(M=>k.Promises.mkdir(N,{recursive:!0}).then(()=>w(M)).then(void 0,l));return}const R=g(d,C),U=P(C);s=(0,a.createCancelablePromise)(N=>m.queue(()=>R.then(M=>u(M,b,U,v,t,N).then(()=>w(N)))).then(null,l))})}).finally(()=>n.dispose())}async function c(d,v=!1){const{open:t}=await new Promise((r,s)=>{ne(["yauzl"],r,s)});return new Promise((r,s)=>{t(d,v?{lazyEntries:!0}:void 0,(i,n)=>{i?s(S(i)):r((0,L.assertIsDefined)(n))})})}function g(d,v){return new Promise((t,r)=>{d.openReadStream(v,(s,i)=>{s?r(S(s)):t((0,L.assertIsDefined)(i))})})}async function f(d,v){const{ZipFile:t}=await new Promise((r,s)=>{ne(["yazl"],r,s)});return new Promise((r,s)=>{const i=new t;v.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const n=(0,D.createWriteStream)(d);i.outputStream.pipe(n),i.outputStream.once("error",s),n.once("error",s),n.once("finish",()=>r(d))})}function h(d,v,t={},r){const s=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let i=c(d,!0);return t.overwrite&&(i=i.then(n=>k.Promises.rm(v).then(()=>n))),i.then(n=>p(n,v,{sourcePathRegex:s},r))}function E(d,v){return c(d).then(t=>new Promise((r,s)=>{t.on("entry",i=>{i.fileName===v&&g(t,i).then(n=>r(n),n=>s(n))}),t.once("close",()=>s(new Error(_.localize(2,null,v))))}))}function I(d,v){return E(d,v).then(t=>new Promise((r,s)=>{const i=[];t.once("error",s),t.on("data",n=>i.push(n)),t.on("end",()=>r(Buffer.concat(i)))}))}}),define(le[159],ue([12,11]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[160],ue([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(le[161],ue([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(le[162],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[163],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[164],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[165],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[166],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[167],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[168],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[169],ue([12,11]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(le[170],ue([12,11]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(le[171],ue([12,11]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(le[172],ue([12,11]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[173],ue([12,11]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[174],ue([12,11]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(le[175],ue([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[176],ue([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[177],ue([12,11]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(le[178],ue([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[179],ue([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[180],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[181],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[182],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[183],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[184],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[185],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[186],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[187],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[188],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[189],ue([12,11]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(le[190],ue([0,1,39,8,161]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var L;(function(P){P[P.LParen=0]="LParen",P[P.RParen=1]="RParen",P[P.Neg=2]="Neg",P[P.Eq=3]="Eq",P[P.NotEq=4]="NotEq",P[P.Lt=5]="Lt",P[P.LtEq=6]="LtEq",P[P.Gt=7]="Gt",P[P.GtEq=8]="GtEq",P[P.RegexOp=9]="RegexOp",P[P.RegexStr=10]="RegexStr",P[P.True=11]="True",P[P.False=12]="False",P[P.In=13]="In",P[P.Not=14]="Not",P[P.And=15]="And",P[P.Or=16]="Or",P[P.Str=17]="Str",P[P.QuotedStr=18]="QuotedStr",P[P.Error=19]="Error",P[P.EOF=20]="EOF"})(L||(e.TokenType=L={}));function k(...P){switch(P.length){case 1:return(0,A.localize)(0,null,P[0]);case 2:return(0,A.localize)(1,null,P[0],P[1]);case 3:return(0,A.localize)(2,null,P[0],P[1],P[2]);default:return}}const _=(0,A.localize)(3,null),T=(0,A.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case L.LParen:return"(";case L.RParen:return")";case L.Neg:return"!";case L.Eq:return S.isTripleEq?"===":"==";case L.NotEq:return S.isTripleEq?"!==":"!=";case L.Lt:return"<";case L.LtEq:return"<=";case L.Gt:return">=";case L.GtEq:return">=";case L.RegexOp:return"=~";case L.RegexStr:return S.lexeme;case L.True:return"true";case L.False:return"false";case L.In:return"in";case L.Not:return"not";case L.And:return"&&";case L.Or:return"||";case L.Str:return S.lexeme;case L.QuotedStr:return S.lexeme;case L.Error:return S.lexeme;case L.EOF:return"EOF";default:throw(0,a.illegalState)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this._keywords=new Map([["not",L.Not],["in",L.In],["false",L.False],["true",L.True]])}get errors(){return this._errors}reset(S){return this._input=S,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case D.CharCode.OpenParen:this._addToken(L.LParen);break;case D.CharCode.CloseParen:this._addToken(L.RParen);break;case D.CharCode.ExclamationMark:if(this._match(D.CharCode.Equals)){const u=this._match(D.CharCode.Equals);this._tokens.push({type:L.NotEq,offset:this._start,isTripleEq:u})}else this._addToken(L.Neg);break;case D.CharCode.SingleQuote:this._quotedString();break;case D.CharCode.Slash:this._regex();break;case D.CharCode.Equals:if(this._match(D.CharCode.Equals)){const u=this._match(D.CharCode.Equals);this._tokens.push({type:L.Eq,offset:this._start,isTripleEq:u})}else this._match(D.CharCode.Tilde)?this._addToken(L.RegexOp):this._error(k("==","=~"));break;case D.CharCode.LessThan:this._addToken(this._match(D.CharCode.Equals)?L.LtEq:L.Lt);break;case D.CharCode.GreaterThan:this._addToken(this._match(D.CharCode.Equals)?L.GtEq:L.Gt);break;case D.CharCode.Ampersand:this._match(D.CharCode.Ampersand)?this._addToken(L.And):this._error(k("&&"));break;case D.CharCode.Pipe:this._match(D.CharCode.Pipe)?this._addToken(L.Or):this._error(k("||"));break;case D.CharCode.Space:case D.CharCode.CarriageReturn:case D.CharCode.Tab:case D.CharCode.LineFeed:case D.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(L.EOF),Array.from(this._tokens)}_match(S){return this._isAtEnd()||this._input.charCodeAt(this._current)!==S?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?D.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(S){this._tokens.push({type:S,offset:this._start})}_error(S){const u=this._start,p=this._input.substring(this._start,this._current),c={type:L.Error,offset:this._start,lexeme:p};this._errors.push({offset:u,lexeme:p,additionalInfo:S}),this._tokens.push(c)}_string(){this.stringRe.lastIndex=this._start;const S=this.stringRe.exec(this._input);if(S){this._current=this._start+S[0].length;const u=this._input.substring(this._start,this._current),p=y._keywords.get(u);p?this._addToken(p):this._tokens.push({type:L.Str,lexeme:u,offset:this._start})}}_quotedString(){for(;this._peek()!==D.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(_);return}this._advance(),this._tokens.push({type:L.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let S=this._current,u=!1,p=!1;for(;;){if(S>=this._input.length){this._current=S,this._error(T);return}const g=this._input.charCodeAt(S);if(u)u=!1;else if(g===D.CharCode.Slash&&!p){S++;break}else g===D.CharCode.OpenSquareBracket?p=!0:g===D.CharCode.Backslash?u=!0:g===D.CharCode.CloseSquareBracket&&(p=!1);S++}for(;S<this._input.length&&y._regexFlags.has(this._input.charCodeAt(S));)S++;this._current=S;const c=this._input.substring(this._start,this._current);this._tokens.push({type:L.RegexStr,lexeme:c,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=y}),define(le[191],ue([0,1,67,88,23,14,36,21,9]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=P,e.parseDebugParams=S,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class y{get appRoot(){return(0,L.dirname)(A.FileAccess.asFileUri("").fsPath)}get userHome(){return T.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return T.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return T.URI.file(this.paths.tmpDir)}get cacheHome(){return T.URI.file(this.userDataPath)}get stateResource(){return(0,_.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,_.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",p)}return T.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,_.joinPath)(T.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,_.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,_.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,_.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=k.env.VSCODE_PORTABLE;return p?T.URI.file((0,L.join)(p,"argv.json")):(0,_.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return T.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,L.resolve)(p):(0,L.normalize)((0,L.join)(A.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?T.URI.file((0,L.resolve)(p)):T.URI.file((0,L.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,L.resolve)(p);const c=k.env.VSCODE_EXTENSIONS;if(c)return c;const g=k.env.VSCODE_PORTABLE;return g?(0,L.join)(g,"extensions"):(0,_.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(c=>/^[^:/?#]+?:\/\//.test(c)?T.URI.parse(c):T.URI.file((0,L.normalize)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?T.URI.parse(p):T.URI.file((0,L.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(p))}get extensionLogLevel(){const p=[];for(const c of this.args.log||[]){const g=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(c);g&&g[1]&&g[2]&&p.push([g[1],g[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,_.joinPath)(T.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=k.env.VSCODE_PORTABLE;return p?T.URI.file((0,L.join)(p,"policy.json")):(0,_.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this._args}constructor(p,c,g){this._args=p,this.paths=c,this.productService=g,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=y,we([a.memoize],y.prototype,"appRoot",null),we([a.memoize],y.prototype,"userHome",null),we([a.memoize],y.prototype,"userDataPath",null),we([a.memoize],y.prototype,"appSettingsHome",null),we([a.memoize],y.prototype,"tmpDir",null),we([a.memoize],y.prototype,"cacheHome",null),we([a.memoize],y.prototype,"stateResource",null),we([a.memoize],y.prototype,"userRoamingDataHome",null),we([a.memoize],y.prototype,"userDataSyncHome",null),we([a.memoize],y.prototype,"sync",null),we([a.memoize],y.prototype,"machineSettingsResource",null),we([a.memoize],y.prototype,"workspaceStorageHome",null),we([a.memoize],y.prototype,"localHistoryHome",null),we([a.memoize],y.prototype,"keyboardLayoutResource",null),we([a.memoize],y.prototype,"argvResource",null),we([a.memoize],y.prototype,"isExtensionDevelopment",null),we([a.memoize],y.prototype,"untitledWorkspacesHome",null),we([a.memoize],y.prototype,"builtinExtensionsPath",null),we([a.memoize],y.prototype,"extensionsPath",null),we([a.memoize],y.prototype,"extensionDevelopmentLocationURI",null),we([a.memoize],y.prototype,"extensionDevelopmentKind",null),we([a.memoize],y.prototype,"extensionTestsLocationURI",null),we([a.memoize],y.prototype,"debugExtensionHost",null),we([a.memoize],y.prototype,"logLevel",null),we([a.memoize],y.prototype,"extensionLogLevel",null),we([a.memoize],y.prototype,"serviceMachineIdResource",null),we([a.memoize],y.prototype,"disableTelemetry",null),we([a.memoize],y.prototype,"disableWorkspaceTrust",null),we([a.memoize],y.prototype,"useInMemorySecretStorage",null),we([a.memoize],y.prototype,"policyFile",null);function P(u,p){return S(u["inspect-extensions"],u["inspect-brk-extensions"],5870,p,u.debugId,u.extensionEnvironment)}function S(u,p,c,g,f,h){const I=Number(p||u)||(g?null:c),d=I?!!p:!1;let v;if(h)try{v=JSON.parse(h)}catch{}return{port:I,break:d,debugId:f,env:v}}}),function(){"use strict";function ne(e,D,a){function A(k,_){const T=L(k,_),y=[T];return e.isAbsolute(T)||y.unshift(a),e.resolve(...y)}function L(k,_){process.env.VSCODE_DEV&&(_="code-oss-dev");const T=process.env.VSCODE_PORTABLE;if(T)return e.join(T,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,_);const P=k["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(S,"AppData","Roaming")}break;case"darwin":y=e.join(D.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,_)}return{getUserDataPath:A}}if(typeof define=="function")define(le[192],ue([279,38,36]),function(e,D,a){return ne(e,D,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=ne(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[193],ue([0,1,38,191,192]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=k,e.parseSharedProcessDebugPort=_;class L extends a.AbstractNativeEnvironmentService{constructor(y,P){super(y,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,A.getUserDataPath)(y,P.nameShort)},P)}}e.NativeEnvironmentService=L;function k(T,y){return(0,a.parseDebugParams)(T["inspect-ptyhost"],T["inspect-brk-ptyhost"],5877,y,T.extensionEnvironment)}function _(T,y){return(0,a.parseDebugParams)(T["inspect-sharedprocess"],T["inspect-brk-sharedprocess"],5879,y,T.extensionEnvironment)}}),define(le[194],ue([0,1,13,164]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=A;function A(k,_,T,y){try{L(k,_,T,y)}catch(P){k.error(P?.message??P)}return _}function L(k,_,T,y){const P=(S,u,p)=>{const c=S[u];if((0,D.isString)(c)){const g=c,f=g.length;if(f>1&&g[0]==="%"&&g[f-1]==="%"){const h=g.substr(1,f-2);let E=T[h];E===void 0&&y&&(E=y[h]);const I=typeof E=="string"?E:E?.message,d=y?.[h],v=typeof d=="string"?d:d?.message;if(!I){v||k.warn(`[${_.name}]: ${(0,a.localize)(0,null,h)}`);return}if(p&&(u==="title"||u==="category")&&v&&v!==I){const t={value:I,original:v};S[u]=t}else S[u]=I}}else if((0,D.isObject)(c))for(const g in c)c.hasOwnProperty(g)&&(g==="commands"?P(c,g,!0):P(c,g,p));else if(Array.isArray(c))for(let g=0;g<c.length;g++)P(c,g,p)};for(const S in _)_.hasOwnProperty(S)&&P(_,S)}}),define(le[195],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.channel.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class a{constructor(L){this.service=L}listen(L,k){throw new Error(`Event not found: ${k}`)}call(L,k,_){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(_[0])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=a}),define(le[73],ue([0,1,21,92,168,56]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=T,e.parseVersion=y,e.normalizeVersion=P,e.isValidVersion=S,e.validateExtensionManifest=u,e.isValidExtensionVersion=p,e.isEngineValid=c;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function T(h){return h=h.trim(),h==="*"||k.test(h)}function y(h){if(!T(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const E=h.match(k);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}function P(h){if(!h)return null;const E=h.majorBase,I=h.majorMustEqual,d=h.minorBase;let v=h.minorMustEqual;const t=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(E===0||(v=!1),r=!1);let s=0;if(h.preRelease){const i=_.exec(h.preRelease);if(i){const[,n,o,l]=i;s=Date.UTC(Number(n),Number(o)-1,Number(l))}}return{majorBase:E,majorMustEqual:I,minorBase:d,minorMustEqual:v,patchBase:t,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:s}}function S(h,E,I){let d;typeof h=="string"?d=P(y(h)):d=h;let v;E instanceof Date?v=E.getTime():typeof E=="string"&&(v=new Date(E).getTime());let t;if(typeof I=="string"?t=P(y(I)):t=I,!d||!t)return!1;const r=d.majorBase,s=d.minorBase,i=d.patchBase;let n=t.majorBase,o=t.minorBase,l=t.patchBase;const m=t.notBefore;let w=t.majorMustEqual,C=t.minorMustEqual,b=t.patchMustEqual;return t.isMinimum?r>n?!0:r<n?!1:s>o?!0:s<o||v&&v<m?!1:i>=l:(r===1&&n===0&&(!w||!C||!b)&&(n=1,o=0,l=0,w=!0,C=!1,b=!1),r<n?!1:r>n?!w:s<o?!1:s>o?!C:i<l?!1:i>l?!b:!(v&&v<m))}function u(h,E,I,d,v){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([a.default.Error,A.localize(0,null)]),t;if(typeof d.name!="string")return t.push([a.default.Error,A.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([a.default.Error,A.localize(2,null,"version")]),t;if(!d.engines)return t.push([a.default.Error,A.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([a.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!f(d.extensionDependencies))return t.push([a.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!f(d.activationEvents))return t.push([a.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([a.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([a.default.Warning,A.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([a.default.Error,A.localize(9,null,"main")]),t;{const i=(0,D.joinPath)(I,d.main);(0,D.isEqualOrParent)(i,I)||t.push([a.default.Warning,A.localize(10,null,i.path,I.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([a.default.Error,A.localize(11,null,"browser")]),t;{const i=(0,D.joinPath)(I,d.browser);(0,D.isEqualOrParent)(i,I)||t.push([a.default.Warning,A.localize(12,null,i.path,I.path)])}}if(!L.valid(d.version))return t.push([a.default.Error,A.localize(13,null)]),t;const r=[];if(!p(h,E,d,v,r))for(const i of r)t.push([a.default.Error,i]);return t}function p(h,E,I,d,v){return d||typeof I.main>"u"&&typeof I.browser>"u"?!0:g(h,E,I.engines.vscode,v)}function c(h,E,I){return h==="*"||g(E,I,h)}function g(h,E,I,d=[]){const v=P(y(I));if(!v)return d.push(A.localize(14,null,I)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return d.push(A.localize(15,null,I)),!1}else if(!v.majorMustEqual)return d.push(A.localize(16,null,I)),!1;return S(h,E,v)?!0:(d.push(A.localize(17,null,h,I)),!1)}function f(h){if(!Array.isArray(h))return!1;for(let E=0,I=h.length;E<I;E++)if(typeof h[E]!="string")return!1;return!0}}),define(le[74],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(A,L=[],k=!1){this.ctor=A,this.staticArguments=L,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=D}),define(le[196],ue([0,1,74]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=L,e.getSingletonServiceDescriptors=k;const a=[];var A;(function(_){_[_.Eager=0]="Eager",_[_.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function L(_,T,y){T instanceof D.SyncDescriptor||(T=new D.SyncDescriptor(T,[],!!y)),a.push([_,T])}function k(){return a}}),define(le[197],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(L,k){this.key=L,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class a{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const k of this._nodes.values())k.outgoing.size===0&&L.push(k);return L}insertEdge(L,k){const _=this.lookupOrInsertNode(L),T=this.lookupOrInsertNode(k);_.outgoing.set(T.key,T),T.incoming.set(_.key,_)}removeNode(L){const k=this._hashFn(L);this._nodes.delete(k);for(const _ of this._nodes.values())_.outgoing.delete(k),_.incoming.delete(k)}lookupOrInsertNode(L){const k=this._hashFn(L);let _=this._nodes.get(k);return _||(_=new D(k,L),this._nodes.set(k,_)),_}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[k,_]of this._nodes)L.push(`${k}
	(-> incoming)[${[..._.incoming.keys()].join(", ")}]
	(outgoing ->)[${[..._.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,k]of this._nodes){const _=new Set([L]),T=this._findCycle(k,_);if(T)return T}}_findCycle(L,k){for(const[_,T]of L.outgoing){if(k.has(_))return[...k,_].join(" -> ");k.add(_);const y=this._findCycle(T,k);if(y)return y;k.delete(_)}}}e.Graph=a}),define(le[4],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=A,e.refineServiceDecorator=L;var D;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function _(T){return T[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=_})(D||(e._util=D={})),e.IInstantiationService=A("instantiationService");function a(k,_,T){_[D.DI_TARGET]===_?_[D.DI_DEPENDENCIES].push({id:k,index:T}):(_[D.DI_DEPENDENCIES]=[{id:k,index:T}],_[D.DI_TARGET]=_)}function A(k){if(D.serviceIds.has(k))return D.serviceIds.get(k);const _=function(T,y,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(_,T,P)};return _.toString=()=>k,D.serviceIds.set(k,_),_}function L(k){return k}}),define(le[198],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(le[22],ue([0,1,13,9,4]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=L,e.isConfigurationUpdateOverrides=k,e.ConfigurationTargetToString=T,e.isConfigured=y,e.toValuesTree=P,e.addToValueTree=S,e.removeFromValueTree=u,e.getConfigurationValue=c,e.merge=g,e.getLanguageTagSettingPlainKey=f,e.IConfigurationService=(0,A.createDecorator)("configurationService");function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof a.URI)}function k(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof a.URI)}var _;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(_||(e.ConfigurationTarget=_={}));function T(h){switch(h){case _.APPLICATION:return"APPLICATION";case _.USER:return"USER";case _.USER_LOCAL:return"USER_LOCAL";case _.USER_REMOTE:return"USER_REMOTE";case _.WORKSPACE:return"WORKSPACE";case _.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case _.DEFAULT:return"DEFAULT";case _.MEMORY:return"MEMORY"}}function y(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}function P(h,E){const I=Object.create(null);for(const d in h)S(I,d,h[d],E);return I}function S(h,E,I,d){const v=E.split("."),t=v.pop();let r=h;for(let s=0;s<v.length;s++){const i=v[s];let n=r[i];switch(typeof n){case"undefined":n=r[i]=Object.create(null);break;case"object":if(n===null){d(`Ignoring ${E} as ${v.slice(0,s+1).join(".")} is null`);return}break;default:d(`Ignoring ${E} as ${v.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}r=n}if(typeof r=="object"&&r!==null)try{r[t]=I}catch{d(`Ignoring ${E} as ${v.join(".")} is ${JSON.stringify(r)}`)}else d(`Ignoring ${E} as ${v.join(".")} is ${JSON.stringify(r)}`)}function u(h,E){const I=E.split(".");p(h,I)}function p(h,E){const I=E.shift();if(E.length===0){delete h[I];return}if(Object.keys(h).indexOf(I)!==-1){const d=h[I];typeof d=="object"&&!Array.isArray(d)&&(p(d,E),Object.keys(d).length===0&&delete h[I])}}function c(h,E,I){function d(r,s){let i=r;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const v=E.split("."),t=d(h,v);return typeof t>"u"?I:t}function g(h,E,I){Object.keys(E).forEach(d=>{d!=="__proto__"&&(d in h?D.isObject(h[d])&&D.isObject(E[d])?g(h[d],E[d],I):I&&(h[d]=E[d]):h[d]=E[d])})}function f(h){return h.replace(/[\[\]]/g,"")}}),define(le[97],ue([0,1,39,5,27,190,4,160,8]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=P,e.validateWhenClauses=s,e.expressionsAreEqualWithConstantSubstitution=i,e.implies=W;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",a.isMacintosh),y.set("isLinux",a.isLinux),y.set("isWindows",a.isWindows),y.set("isWeb",a.isWeb),y.set("isMacNative",a.isMacintosh&&!a.isWeb),y.set("isEdge",a.isEdge),y.set("isFirefox",a.isFirefox),y.set("isChrome",a.isChrome),y.set("isSafari",a.isSafari);function P(V,O){if(y.get(V)!==void 0)throw(0,T.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(V,O)}const S=Object.prototype.hasOwnProperty;var u;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const p={regexParsingWithErrorRecovery:!0},c=(0,_.localize)(0,null),g=(0,_.localize)(1,null),f=(0,_.localize)(2,null),h=(0,_.localize)(3,null),E=(0,_.localize)(4,null),I=(0,_.localize)(5,null),d=(0,_.localize)(6,null),v=(0,_.localize)(7,null);class t{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(O=p){this._config=O,this._scanner=new L.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(O){if(O===""){this._parsingErrors.push({message:c,offset:0,lexeme:"",additionalInfo:g});return}this._tokens=this._scanner.reset(O).scan(),this._current=0,this._parsingErrors=[];try{const $=this._expr();if(!this._isAtEnd()){const x=this._peek(),q=x.type===L.TokenType.Str?I:void 0;throw this._parsingErrors.push({message:E,offset:x.offset,lexeme:L.Scanner.getLexeme(x),additionalInfo:q}),t._parseError}return $}catch($){if($!==t._parseError)throw $;return}}_expr(){return this._or()}_or(){const O=[this._and()];for(;this._matchOne(L.TokenType.Or);){const $=this._and();O.push($)}return O.length===1?O[0]:r.or(...O)}_and(){const O=[this._term()];for(;this._matchOne(L.TokenType.And);){const $=this._term();O.push($)}return O.length===1?O[0]:r.and(...O)}_term(){if(this._matchOne(L.TokenType.Neg)){const O=this._peek();switch(O.type){case L.TokenType.True:return this._advance(),o.INSTANCE;case L.TokenType.False:return this._advance(),l.INSTANCE;case L.TokenType.LParen:{this._advance();const $=this._expr();return this._consume(L.TokenType.RParen,h),$?.negate()}case L.TokenType.Str:return this._advance(),U.create(O.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",O)}}return this._primary()}_primary(){const O=this._peek();switch(O.type){case L.TokenType.True:return this._advance(),r.true();case L.TokenType.False:return this._advance(),r.false();case L.TokenType.LParen:{this._advance();const $=this._expr();return this._consume(L.TokenType.RParen,h),$}case L.TokenType.Str:{const $=O.lexeme;if(this._advance(),this._matchOne(L.TokenType.RegexOp)){const q=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),q.type!==L.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",q);const te=q.lexeme,Z=te.lastIndexOf("/"),Y=Z===te.length-1?void 0:this._removeFlagsGY(te.substring(Z+1));let ae;try{ae=new RegExp(te.substring(1,Z),Y)}catch{throw this._errExpectedButGot("REGEX",q)}return X.create($,ae)}switch(q.type){case L.TokenType.RegexStr:case L.TokenType.Error:{const te=[q.lexeme];this._advance();let Z=this._peek(),Y=0;for(let Ie=0;Ie<q.lexeme.length;Ie++)q.lexeme.charCodeAt(Ie)===D.CharCode.OpenParen?Y++:q.lexeme.charCodeAt(Ie)===D.CharCode.CloseParen&&Y--;for(;!this._isAtEnd()&&Z.type!==L.TokenType.And&&Z.type!==L.TokenType.Or;){switch(Z.type){case L.TokenType.LParen:Y++;break;case L.TokenType.RParen:Y--;break;case L.TokenType.RegexStr:case L.TokenType.QuotedStr:for(let Ie=0;Ie<Z.lexeme.length;Ie++)Z.lexeme.charCodeAt(Ie)===D.CharCode.OpenParen?Y++:q.lexeme.charCodeAt(Ie)===D.CharCode.CloseParen&&Y--}if(Y<0)break;te.push(L.Scanner.getLexeme(Z)),this._advance(),Z=this._peek()}const ae=te.join(""),he=ae.lastIndexOf("/"),ge=he===ae.length-1?void 0:this._removeFlagsGY(ae.substring(he+1));let ve;try{ve=new RegExp(ae.substring(1,he),ge)}catch{throw this._errExpectedButGot("REGEX",q)}return r.regex($,ve)}case L.TokenType.QuotedStr:{const te=q.lexeme;this._advance();let Z=null;if(!(0,A.isFalsyOrWhitespace)(te)){const Y=te.indexOf("/"),ae=te.lastIndexOf("/");if(Y!==ae&&Y>=0){const he=te.slice(Y+1,ae),ge=te[ae+1]==="i"?"i":"";try{Z=new RegExp(he,ge)}catch{throw this._errExpectedButGot("REGEX",q)}}}if(Z===null)throw this._errExpectedButGot("REGEX",q);return X.create($,Z)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(L.TokenType.Not)){this._consume(L.TokenType.In,f);const q=this._value();return r.notIn($,q)}switch(this._peek().type){case L.TokenType.Eq:{this._advance();const q=this._value();if(this._previous().type===L.TokenType.QuotedStr)return r.equals($,q);switch(q){case"true":return r.has($);case"false":return r.not($);default:return r.equals($,q)}}case L.TokenType.NotEq:{this._advance();const q=this._value();if(this._previous().type===L.TokenType.QuotedStr)return r.notEquals($,q);switch(q){case"true":return r.not($);case"false":return r.has($);default:return r.notEquals($,q)}}case L.TokenType.Lt:return this._advance(),K.create($,this._value());case L.TokenType.LtEq:return this._advance(),H.create($,this._value());case L.TokenType.Gt:return this._advance(),M.create($,this._value());case L.TokenType.GtEq:return this._advance(),F.create($,this._value());case L.TokenType.In:return this._advance(),r.in($,this._value());default:return r.has($)}}case L.TokenType.EOF:throw this._parsingErrors.push({message:d,offset:O.offset,lexeme:"",additionalInfo:v}),t._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const O=this._peek();switch(O.type){case L.TokenType.Str:case L.TokenType.QuotedStr:return this._advance(),O.lexeme;case L.TokenType.True:return this._advance(),"true";case L.TokenType.False:return this._advance(),"false";case L.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(O){return O.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(O){return this._check(O)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(O,$){if(this._check(O))return this._advance();throw this._errExpectedButGot($,this._peek())}_errExpectedButGot(O,$,x){const q=(0,_.localize)(8,null,O,L.Scanner.getLexeme($)),te=$.offset,Z=L.Scanner.getLexeme($);return this._parsingErrors.push({message:q,offset:te,lexeme:Z,additionalInfo:x}),t._parseError}_check(O){return this._peek().type===O}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===L.TokenType.EOF}}e.Parser=t;class r{static false(){return o.INSTANCE}static true(){return l.INSTANCE}static has(O){return m.create(O)}static equals(O,$){return w.create(O,$)}static notEquals(O,$){return R.create(O,$)}static regex(O,$){return X.create(O,$)}static in(O,$){return C.create(O,$)}static notIn(O,$){return b.create(O,$)}static not(O){return U.create(O)}static and(...O){return z.create(O,null,!0)}static or(...O){return B.create(O,null,!0)}static greater(O,$){return M.create(O,$)}static greaterEquals(O,$){return F.create(O,$)}static smaller(O,$){return K.create(O,$)}static smallerEquals(O,$){return H.create(O,$)}static{this._parser=new t({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this._parser.parse(O)}}e.ContextKeyExpr=r;function s(V){const O=new t({regexParsingWithErrorRecovery:!1});return V.map($=>(O.parse($),O.lexingErrors.length>0?O.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,_.localize)(9,null,x.additionalInfo):(0,_.localize)(10,null),offset:x.offset,length:x.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}function i(V,O){const $=V?V.substituteConstants():void 0,x=O?O.substituteConstants():void 0;return!$&&!x?!0:!$||!x?!1:$.equals(x)}function n(V,O){return V.cmp(O)}class o{static{this.INSTANCE=new o}constructor(){this.type=u.False}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=o;class l{static{this.INSTANCE=new l}constructor(){this.type=u.True}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return o.INSTANCE}}e.ContextKeyTrueExpr=l;class m{static create(O,$=null){const x=y.get(O);return typeof x=="boolean"?x?l.INSTANCE:o.INSTANCE:new m(O,$)}constructor(O,$){this.key=O,this.negated=$,this.type=u.Defined}cmp(O){return O.type!==this.type?this.type-O.type:se(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=y.get(this.key);return typeof O=="boolean"?O?l.INSTANCE:o.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.negated||(this.negated=U.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=m;class w{static create(O,$,x=null){if(typeof $=="boolean")return $?m.create(O,x):U.create(O,x);const q=y.get(O);return typeof q=="boolean"?$===(q?"true":"false")?l.INSTANCE:o.INSTANCE:new w(O,$,x)}constructor(O,$,x){this.key=O,this.value=$,this.negated=x,this.type=u.Equals}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=y.get(this.key);if(typeof O=="boolean"){const $=O?"true":"false";return this.value===$?l.INSTANCE:o.INSTANCE}return this}evaluate(O){return O.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(O){return O.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class C{static create(O,$){return new C(O,$)}constructor(O,$){this.key=O,this.valueKey=$,this.type=u.In,this.negated=null}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.valueKey,O.key,O.valueKey)}equals(O){return O.type===this.type?this.key===O.key&&this.valueKey===O.valueKey:!1}substituteConstants(){return this}evaluate(O){const $=O.getValue(this.valueKey),x=O.getValue(this.key);return Array.isArray($)?$.includes(x):typeof x=="string"&&typeof $=="object"&&$!==null?S.call($,x):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(O){return O.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=C;class b{static create(O,$){return new b(O,$)}constructor(O,$){this.key=O,this.valueKey=$,this.type=u.NotIn,this._negated=C.create(O,$)}cmp(O){return O.type!==this.type?this.type-O.type:this._negated.cmp(O._negated)}equals(O){return O.type===this.type?this._negated.equals(O._negated):!1}substituteConstants(){return this}evaluate(O){return!this._negated.evaluate(O)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(O){return O.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class R{static create(O,$,x=null){if(typeof $=="boolean")return $?U.create(O,x):m.create(O,x);const q=y.get(O);return typeof q=="boolean"?$===(q?"true":"false")?o.INSTANCE:l.INSTANCE:new R(O,$,x)}constructor(O,$,x){this.key=O,this.value=$,this.negated=x,this.type=u.NotEquals}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=y.get(this.key);if(typeof O=="boolean"){const $=O?"true":"false";return this.value===$?o.INSTANCE:l.INSTANCE}return this}evaluate(O){return O.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(O){return O.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=R;class U{static create(O,$=null){const x=y.get(O);return typeof x=="boolean"?x?o.INSTANCE:l.INSTANCE:new U(O,$)}constructor(O,$){this.key=O,this.negated=$,this.type=u.Not}cmp(O){return O.type!==this.type?this.type-O.type:se(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=y.get(this.key);return typeof O=="boolean"?O?o.INSTANCE:l.INSTANCE:this}evaluate(O){return!O.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(O){return O.mapNot(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=U;function N(V,O){if(typeof V=="string"){const $=parseFloat(V);isNaN($)||(V=$)}return typeof V=="string"||typeof V=="number"?O(V):o.INSTANCE}class M{static create(O,$,x=null){return N($,q=>new M(O,q,x))}constructor(O,$,x){this.key=O,this.value=$,this.negated=x,this.type=u.Greater}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=M;class F{static create(O,$,x=null){return N($,q=>new F(O,q,x))}constructor(O,$,x){this.key=O,this.value=$,this.negated=x,this.type=u.GreaterEquals}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=K.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=F;class K{static create(O,$,x=null){return N($,q=>new K(O,q,x))}constructor(O,$,x){this.key=O,this.value=$,this.negated=x,this.type=u.Smaller}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=K;class H{static create(O,$,x=null){return N($,q=>new H(O,q,x))}constructor(O,$,x){this.key=O,this.value=$,this.negated=x,this.type=u.SmallerEquals}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=H;class X{static create(O,$){return new X(O,$)}constructor(O,$){this.key=O,this.regexp=$,this.type=u.Regex,this.negated=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.key<O.key)return-1;if(this.key>O.key)return 1;const $=this.regexp?this.regexp.source:"",x=O.regexp?O.regexp.source:"";return $<x?-1:$>x?1:0}equals(O){if(O.type===this.type){const $=this.regexp?this.regexp.source:"",x=O.regexp?O.regexp.source:"";return this.key===O.key&&$===x}return!1}substituteConstants(){return this}evaluate(O){const $=O.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const O=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${O}`}keys(){return[this.key]}map(O){return O.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=j.create(this)),this.negated}}e.ContextKeyRegexExpr=X;class j{static create(O){return new j(O)}constructor(O){this._actual=O,this.type=u.NotRegex}cmp(O){return O.type!==this.type?this.type-O.type:this._actual.cmp(O._actual)}equals(O){return O.type===this.type?this._actual.equals(O._actual):!1}substituteConstants(){return this}evaluate(O){return!this._actual.evaluate(O)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(O){return new j(this._actual.map(O))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=j;function ie(V){let O=null;for(let $=0,x=V.length;$<x;$++){const q=V[$].substituteConstants();if(V[$]!==q&&O===null){O=[];for(let te=0;te<$;te++)O[te]=V[te]}O!==null&&(O[$]=q)}return O===null?V:O}class z{static create(O,$,x){return z._normalizeArr(O,$,x)}constructor(O,$){this.expr=O,this.negated=$,this.type=u.And}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let $=0,x=this.expr.length;$<x;$++){const q=n(this.expr[$],O.expr[$]);if(q!==0)return q}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let $=0,x=this.expr.length;$<x;$++)if(!this.expr[$].equals(O.expr[$]))return!1;return!0}return!1}substituteConstants(){const O=ie(this.expr);return O===this.expr?this:z.create(O,this.negated,!1)}evaluate(O){for(let $=0,x=this.expr.length;$<x;$++)if(!this.expr[$].evaluate(O))return!1;return!0}static _normalizeArr(O,$,x){const q=[];let te=!1;for(const Z of O)if(Z){if(Z.type===u.True){te=!0;continue}if(Z.type===u.False)return o.INSTANCE;if(Z.type===u.And){q.push(...Z.expr);continue}q.push(Z)}if(q.length===0&&te)return l.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(n);for(let Z=1;Z<q.length;Z++)q[Z-1].equals(q[Z])&&(q.splice(Z,1),Z--);if(q.length===1)return q[0];for(;q.length>1;){const Z=q[q.length-1];if(Z.type!==u.Or)break;q.pop();const Y=q.pop(),ae=q.length===0,he=B.create(Z.expr.map(ge=>z.create([ge,Y],null,x)),null,ae);he&&(q.push(he),q.sort(n))}if(q.length===1)return q[0];if(x){for(let Z=0;Z<q.length;Z++)for(let Y=Z+1;Y<q.length;Y++)if(q[Z].negate().equals(q[Y]))return o.INSTANCE;if(q.length===1)return q[0]}return new z(q,$)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const $ of this.expr)O.push(...$.keys());return O}map(O){return new z(this.expr.map($=>$.map(O)),null)}negate(){if(!this.negated){const O=[];for(const $ of this.expr)O.push($.negate());this.negated=B.create(O,this,!0)}return this.negated}}e.ContextKeyAndExpr=z;class B{static create(O,$,x){return B._normalizeArr(O,$,x)}constructor(O,$){this.expr=O,this.negated=$,this.type=u.Or}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let $=0,x=this.expr.length;$<x;$++){const q=n(this.expr[$],O.expr[$]);if(q!==0)return q}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let $=0,x=this.expr.length;$<x;$++)if(!this.expr[$].equals(O.expr[$]))return!1;return!0}return!1}substituteConstants(){const O=ie(this.expr);return O===this.expr?this:B.create(O,this.negated,!1)}evaluate(O){for(let $=0,x=this.expr.length;$<x;$++)if(this.expr[$].evaluate(O))return!0;return!1}static _normalizeArr(O,$,x){let q=[],te=!1;if(O){for(let Z=0,Y=O.length;Z<Y;Z++){const ae=O[Z];if(ae){if(ae.type===u.False){te=!0;continue}if(ae.type===u.True)return l.INSTANCE;if(ae.type===u.Or){q=q.concat(ae.expr);continue}q.push(ae)}}if(q.length===0&&te)return o.INSTANCE;q.sort(n)}if(q.length!==0){if(q.length===1)return q[0];for(let Z=1;Z<q.length;Z++)q[Z-1].equals(q[Z])&&(q.splice(Z,1),Z--);if(q.length===1)return q[0];if(x){for(let Z=0;Z<q.length;Z++)for(let Y=Z+1;Y<q.length;Y++)if(q[Z].negate().equals(q[Y]))return l.INSTANCE;if(q.length===1)return q[0]}return new B(q,$)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const $ of this.expr)O.push(...$.keys());return O}map(O){return new B(this.expr.map($=>$.map(O)),null)}negate(){if(!this.negated){const O=[];for(const $ of this.expr)O.push($.negate());for(;O.length>1;){const $=O.shift(),x=O.shift(),q=[];for(const te of G($))for(const Z of G(x))q.push(z.create([te,Z],null,!1));O.unshift(B.create(q,null,!1))}this.negated=B.create(O,this,!0)}return this.negated}}e.ContextKeyOrExpr=B;class ee extends m{static{this._info=[]}static all(){return ee._info.values()}constructor(O,$,x){super(O,null),this._defaultValue=$,typeof x=="object"?ee._info.push({...x,key:O}):x!==!0&&ee._info.push({key:O,description:x,type:$!=null?typeof $:void 0})}bindTo(O){return O.createKey(this.key,this._defaultValue)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return w.create(this.key,O)}notEqualsTo(O){return R.create(this.key,O)}}e.RawContextKey=ee,e.IContextKeyService=(0,k.createDecorator)("contextKeyService");function se(V,O){return V<O?-1:V>O?1:0}function ce(V,O,$,x){return V<$?-1:V>$?1:O<x?-1:O>x?1:0}function W(V,O){if(V.type===u.False||O.type===u.True)return!0;if(V.type===u.Or)return O.type===u.Or?J(V.expr,O.expr):!1;if(O.type===u.Or){for(const $ of O.expr)if(W(V,$))return!0;return!1}if(V.type===u.And){if(O.type===u.And)return J(O.expr,V.expr);for(const $ of V.expr)if(W($,O))return!0;return!1}return V.equals(O)}function J(V,O){let $=0,x=0;for(;$<V.length&&x<O.length;){const q=V[$].cmp(O[x]);if(q<0)return!1;q===0&&$++,x++}return $===V.length}function G(V){return V.type===u.Or?V.expr:[V]}}),define(le[98],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=a,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function a(L){return!!L.hostName&&!!L.errorMessage}class A{async getPerformanceInfo(k,_){return{}}async getSystemInfo(k,_){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,_){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=A}),define(le[99],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(le[16],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(le[75],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.RecommendationSourceToString=A;var a;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function A(k){switch(k){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var L;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(le[7],ue([0,1,52,14,27,13,9,170,4,5,23,54]),function(ne,e,D,a,A,L,k,_,T,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=u,e.isFileSystemWatcher=f,e.hasReadWriteCapability=E,e.hasFileFolderCopyCapability=I,e.hasFileCloneCapability=d,e.hasOpenReadWriteCloseCapability=v,e.hasFileReadStreamCapability=t,e.hasFileAtomicReadCapability=r,e.hasFileAtomicWriteCapability=s,e.hasFileAtomicDeleteCapability=i,e.hasReadonlyCapability=n,e.createFileSystemProviderError=m,e.ensureFileSystemProviderError=w,e.markAsFileSystemProviderError=C,e.toFileSystemProviderErrorCode=b,e.toFileOperationResult=R,e.isParent=K,e.etag=B,e.whenProviderRegistered=ee,e.getLargeFileConfirmationLimit=ce,e.IFileService=(0,T.createDecorator)("fileService");function u(W){return W.create===!0}var p;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var c;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var g;(function(W){W[W.UPDATED=2]="UPDATED",W[W.ADDED=4]="ADDED",W[W.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function f(W){const J=W;return!!J&&typeof J.onDidChange=="function"}var h;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(h||(e.FileSystemProviderCapabilities=h={}));function E(W){return!!(W.capabilities&h.FileReadWrite)}function I(W){return!!(W.capabilities&h.FileFolderCopy)}function d(W){return!!(W.capabilities&h.FileClone)}function v(W){return!!(W.capabilities&h.FileOpenReadWriteClose)}function t(W){return!!(W.capabilities&h.FileReadStream)}function r(W){return E(W)?!!(W.capabilities&h.FileAtomicRead):!1}function s(W){return E(W)?!!(W.capabilities&h.FileAtomicWrite):!1}function i(W){return!!(W.capabilities&h.FileAtomicDelete)}function n(W){return!!(W.capabilities&h.Readonly)}var o;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class l extends Error{static create(J,G){const V=new l(J.toString(),G);return C(V,G),V}constructor(J,G){super(J),this.code=G}}e.FileSystemProviderError=l;function m(W,J){return l.create(W,J)}function w(W){return W||m((0,_.localize)(0,null),o.Unknown)}function C(W,J){return W.name=J?`${J} (FileSystemError)`:"FileSystemError",W}function b(W){if(!W)return o.Unknown;if(W instanceof l)return W.code;const J=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!J)return o.Unknown;switch(J[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function R(W){if(W instanceof H)return W.fileOperationResult;switch(b(W)){case o.FileNotFound:return ie.FILE_NOT_FOUND;case o.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case o.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case o.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case o.NoPermissions:return ie.FILE_PERMISSION_DENIED;case o.FileExists:return ie.FILE_MOVE_CONFLICT;case o.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var U;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(U||(e.FileOperation=U={}));class N{constructor(J,G,V){this.resource=J,this.operation=G,this.target=V}isOperation(J){return this.operation===J}}e.FileOperationEvent=N;var M;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class F{static{this.MIXED_CORRELATION=null}constructor(J,G){this.ignorePathCasing=G,this.correlationId=void 0,this.added=new S.Lazy(()=>{const V=D.TernarySearchTree.forUris(()=>this.ignorePathCasing);return V.fill(this.rawAdded.map(O=>[O,!0])),V}),this.updated=new S.Lazy(()=>{const V=D.TernarySearchTree.forUris(()=>this.ignorePathCasing);return V.fill(this.rawUpdated.map(O=>[O,!0])),V}),this.deleted=new S.Lazy(()=>{const V=D.TernarySearchTree.forUris(()=>this.ignorePathCasing);return V.fill(this.rawDeleted.map(O=>[O,!0])),V}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const V of J){switch(V.type){case M.ADDED:this.rawAdded.push(V.resource);break;case M.UPDATED:this.rawUpdated.push(V.resource);break;case M.DELETED:this.rawDeleted.push(V.resource);break}this.correlationId!==F.MIXED_CORRELATION&&(typeof V.cId=="number"?this.correlationId===void 0?this.correlationId=V.cId:this.correlationId!==V.cId&&(this.correlationId=F.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=F.MIXED_CORRELATION))}}contains(J,...G){return this.doContains(J,{includeChildren:!1},...G)}affects(J,...G){return this.doContains(J,{includeChildren:!0},...G)}doContains(J,G,...V){if(!J)return!1;const O=V.length>0;return!!((!O||V.includes(M.ADDED))&&(this.added.value.get(J)||G.includeChildren&&this.added.value.findSuperstr(J))||(!O||V.includes(M.UPDATED))&&(this.updated.value.get(J)||G.includeChildren&&this.updated.value.findSuperstr(J))||(!O||V.includes(M.DELETED))&&(this.deleted.value.findSubstr(J)||G.includeChildren&&this.deleted.value.findSuperstr(J)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(J){return this.correlationId===J}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=F;function K(W,J,G){return!W||!J||W===J||J.length>W.length?!1:(J.charAt(J.length-1)!==a.sep&&(J+=a.sep),G?(0,A.startsWithIgnoreCase)(W,J):W.indexOf(J)===0)}class H extends Error{constructor(J,G,V){super(J),this.fileOperationResult=G,this.options=V}}e.FileOperationError=H;class X extends H{constructor(J,G,V,O){super(J,G,O),this.fileOperationResult=G,this.size=V}}e.TooLargeFileOperationError=X;class j extends H{constructor(J,G,V){super(J,ie.FILE_NOT_MODIFIED_SINCE,V),this.stat=G}}e.NotModifiedSinceFileOperationError=j;var ie;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var z;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(z||(e.FileKind=z={})),e.ETAG_DISABLED="";function B(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}async function ee(W,J){if(!J.hasProvider(k.URI.from({scheme:W.scheme})))return new Promise(G=>{const V=J.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===W.scheme&&O.added&&(V.dispose(),G())})})}class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(J){return(0,L.isNumber)(J)||(J=0),J<se.KB?(0,_.localize)(1,null,J.toFixed(0)):J<se.MB?(0,_.localize)(2,null,(J/se.KB).toFixed(2)):J<se.GB?(0,_.localize)(3,null,(J/se.MB).toFixed(2)):J<se.TB?(0,_.localize)(4,null,(J/se.GB).toFixed(2)):(0,_.localize)(5,null,(J/se.TB).toFixed(2))}}e.ByteSize=se;function ce(W){const J=typeof W=="string"||W?.scheme===P.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===P.Schemas.file?1024*se.MB:J?10*se.MB:y.isWeb?50*se.MB:1024*se.MB}});var Q=this&&this.__param||function(ne,e){return function(D,a){e(D,a,ne)}};define(le[199],ue([0,1,76,51,7]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(_){this.fileService=_}async checksum(_){const T=(await this.fileService.readFileStream(_)).value;return new Promise((y,P)=>{const S=(0,D.createHash)("sha256");(0,a.listenStream)(T,{onData:u=>S.update(u.buffer),onError:u=>P(u),onEnd:()=>y(S.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=L,e.ChecksumService=L=we([Q(0,A.IFileService)],L)}),define(le[100],ue([0,1,15,8,171,7]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=k;async function k(P,S,u,p,c,g){let f;try{await _(P,S,u,p,c,g)}catch(h){f=h}finally{f&&c.errorTransformer&&(f=c.errorTransformer(f)),typeof f<"u"&&u.error(f),u.end()}}async function _(P,S,u,p,c,g){T(g);const f=await P.open(S,{create:!1});try{T(g);let h=0,E=0,I=c&&typeof c.length=="number"?c.length:void 0,d=D.VSBuffer.alloc(Math.min(c.bufferSize,typeof I=="number"?I:c.bufferSize)),v=c&&typeof c.position=="number"?c.position:0,t=0;do E=await P.read(f,v,d.buffer,t,d.byteLength-t),v+=E,t+=E,h+=E,typeof I=="number"&&(I-=E),t===d.byteLength&&(await u.write(p(d)),d=D.VSBuffer.alloc(Math.min(c.bufferSize,typeof I=="number"?I:c.bufferSize)),t=0);while(E>0&&(typeof I!="number"||I>0)&&T(g)&&y(h,c));if(t>0){let r=t;typeof I=="number"&&(r=Math.min(t,I)),u.write(p(d.slice(0,r)))}}catch(h){throw(0,L.ensureFileSystemProviderError)(h)}finally{await P.close(f)}}function T(P){if(P.isCancellationRequested)throw(0,a.canceled)();return!0}function y(P,S){if(typeof S?.limits?.size=="number"&&P>S.limits.size)throw(0,L.createFileSystemProviderError)((0,A.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[47],ue([0,1,94,2,14,5,9,7]),function(ne,e,D,a,A,L,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=T,e.isRecursiveWatchRequest=y,e.reviveFileChanges=p,e.coalesceEvents=c,e.normalizeWatcherPattern=g,e.parseWatcherPatterns=f,e.isFiltered=E,e.requestFilterToString=I;function T(d){return typeof d.correlationId=="number"}function y(d){return d.recursive===!0}class P extends a.Disposable{static{this.MAX_RESTARTS_PER_REQUEST_ERROR=3}static{this.MAX_RESTARTS_PER_UNKNOWN_ERROR=10}constructor(v,t,r,s){super(),this.onFileChanges=v,this.onLogMessage=t,this.verboseLogging=r,this.options=s,this.watcherDisposables=this._register(new a.MutableDisposable),this.requests=void 0,this.restartsPerRequestError=new Map,this.restartsPerUnknownError=0}init(){const v=new a.DisposableStore;this.watcherDisposables.value=v,this.watcher=this.createWatcher(v),this.watcher.setVerboseLogging(this.verboseLogging),v.add(this.watcher.onDidChangeFile(t=>this.onFileChanges(t))),v.add(this.watcher.onDidLogMessage(t=>this.onLogMessage(t))),v.add(this.watcher.onDidError(t=>this.onError(t.error,t.request)))}onError(v,t){if(this.options.restartOnError&&this.requests?.length)if(t){const r=this.restartsPerRequestError.get(t.path)??0;r<P.MAX_RESTARTS_PER_REQUEST_ERROR?(this.error(`restarting watcher from error in watch request (retrying request): ${v} (${JSON.stringify(t)})`),this.restartsPerRequestError.set(t.path,r+1),this.restart(this.requests)):(this.error(`restarting watcher from error in watch request (skipping request): ${v} (${JSON.stringify(t)})`),this.restart(this.requests.filter(s=>s.path!==t.path)))}else this.restartsPerUnknownError<P.MAX_RESTARTS_PER_UNKNOWN_ERROR?(this.error(`restarting watcher after unknown global error: ${v}`),this.restartsPerUnknownError++,this.restart(this.requests)):this.error(`giving up attempting to restart watcher after error: ${v}`);else this.error(v)}restart(v){this.init(),this.watch(v)}async watch(v){this.requests=v,await this.watcher?.watch(v)}async setVerboseLogging(v){this.verboseLogging=v,await this.watcher?.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${v}`})}trace(v){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${v}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=P;class S extends P{constructor(v,t,r){super(v,t,r,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=S;class u extends P{constructor(v,t,r){super(v,t,r,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=u;function p(d){return d.map(v=>({type:v.type,resource:k.URI.revive(v.resource),cId:v.cId}))}function c(d){const v=new h;for(const t of d)v.processEvent(t);return v.coalesce()}function g(d,v){return typeof v=="string"&&!v.startsWith(D.GLOBSTAR)&&!(0,A.isAbsolute)(v)?{base:d,pattern:v}:v}function f(d,v){const t=[];for(const r of v)t.push((0,D.parse)(g(d,r)));return t}class h{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(v){return L.isLinux?v.resource.fsPath:v.resource.fsPath.toLowerCase()}processEvent(v){const t=this.mapPathToChange.get(this.toKey(v));let r=!1;if(t){const s=t.type,i=v.type;t.resource.fsPath!==v.resource.fsPath&&(v.type===_.FileChangeType.DELETED||v.type===_.FileChangeType.ADDED)?r=!0:s===_.FileChangeType.ADDED&&i===_.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(v)),this.coalesced.delete(t)):s===_.FileChangeType.DELETED&&i===_.FileChangeType.ADDED?t.type=_.FileChangeType.UPDATED:s===_.FileChangeType.ADDED&&i===_.FileChangeType.UPDATED||(t.type=i)}else r=!0;r&&(this.coalesced.add(v),this.mapPathToChange.set(this.toKey(v),v))}coalesce(){const v=[],t=[];return Array.from(this.coalesced).filter(r=>r.type!==_.FileChangeType.DELETED?(v.push(r),!1):!0).sort((r,s)=>r.resource.fsPath.length-s.resource.fsPath.length).filter(r=>t.some(s=>(0,_.isParent)(r.resource.fsPath,s,!L.isLinux))?!1:(t.push(r.resource.fsPath),!0)).concat(v)}}function E(d,v){if(typeof v=="number")switch(d.type){case _.FileChangeType.ADDED:return(v&_.FileChangeFilter.ADDED)===0;case _.FileChangeType.DELETED:return(v&_.FileChangeFilter.DELETED)===0;case _.FileChangeType.UPDATED:return(v&_.FileChangeFilter.UPDATED)===0}return!1}function I(d){if(typeof d=="number"){const v=[];return d&_.FileChangeFilter.ADDED&&v.push("Added"),d&_.FileChangeFilter.DELETED&&v.push("Deleted"),d&_.FileChangeFilter.UPDATED&&v.push("Updated"),v.length===0?"<all>":`[${v.join(", ")}]`}return"<none>"}}),define(le[200],ue([0,1,15,40,8,3,2,51,32,7,47]),function(ne,e,D,a,A,L,k,_,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends k.Disposable{constructor(p,c){super(),this.channel=p,this.extraCapabilities=c,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,T.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=y.FileSystemProviderCapabilities.FileReadWrite|y.FileSystemProviderCapabilities.FileOpenReadWriteClose|y.FileSystemProviderCapabilities.FileReadStream|y.FileSystemProviderCapabilities.FileFolderCopy|y.FileSystemProviderCapabilities.FileWriteUnlock|y.FileSystemProviderCapabilities.FileAtomicRead|y.FileSystemProviderCapabilities.FileAtomicWrite|y.FileSystemProviderCapabilities.FileAtomicDelete|y.FileSystemProviderCapabilities.FileClone,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=y.FileSystemProviderCapabilities.PathCaseSensitive),this.extraCapabilities.trash&&(this._capabilities|=y.FileSystemProviderCapabilities.Trash)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,c){const{buffer:g}=await this.channel.call("readFile",[p,c]);return g}readFileStream(p,c,g){const f=(0,_.newWriteableStream)(E=>D.VSBuffer.concat(E.map(I=>D.VSBuffer.wrap(I))).buffer),h=new k.DisposableStore;return h.add(this.channel.listen("readFileStream",[p,c])(E=>{if(E instanceof D.VSBuffer)f.write(E.buffer);else{if(E==="end")f.end();else{let I;if(E instanceof Error)I=E;else{const d=E;I=(0,y.createFileSystemProviderError)(d.message??(0,a.toErrorMessage)(d),d.code??y.FileSystemProviderErrorCode.Unknown)}f.error(I),f.end()}h.dispose()}})),h.add(g.onCancellationRequested(()=>{f.error((0,A.canceled)()),f.end(),h.dispose()})),f}writeFile(p,c,g){return this.channel.call("writeFile",[p,D.VSBuffer.wrap(c),g])}open(p,c){return this.channel.call("open",[p,c])}close(p){return this.channel.call("close",[p])}async read(p,c,g,f,h){const[E,I]=await this.channel.call("read",[p,c,h]);return g.set(E.buffer.slice(0,I),f),I}write(p,c,g,f,h){return this.channel.call("write",[p,c,D.VSBuffer.wrap(g),f,h])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,c){return this.channel.call("delete",[p,c])}rename(p,c,g){return this.channel.call("rename",[p,c,g])}copy(p,c,g){return this.channel.call("copy",[p,c,g])}cloneFile(p,c){return this.channel.call("cloneFile",[p,c])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const c=p;this._onDidChange.fire((0,P.reviveFileChanges)(c))}else{const c=p;this._onDidWatchError.fire(c)}}))}watch(p,c){const g=(0,T.generateUuid)();return this.channel.call("watch",[this.sessionId,g,p,c]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,g]))}}e.DiskFileSystemProviderClient=S}),define(le[201],ue([0,1,43,2,47,3,7,9,6]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class y extends a.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new L.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new L.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new a.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new T.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(S=>this.handleDidWatchFail(S)))}handleDidWatchFail(S){this.isCorrelated(S)&&this.suspendWatchRequest(S)}isCorrelated(S){return(0,A.isWatchRequestWithCorrelation)(S)}async watch(S){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new T.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const u of S)this.isCorrelated(u)?this.allCorrelatedWatchRequests.set(u.correlationId,u):this.allNonCorrelatedWatchRequests.add(u);for(const[u]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(u)||(this.suspendedWatchRequests.deleteAndDispose(u),this.suspendedWatchRequestsWithPolling.delete(u));return await this.updateWatchers()}finally{this.joinWatch.complete()}}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(S=>!this.suspendedWatchRequests.has(S.correlationId))])}isSuspended(S){return typeof S.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(S.correlationId)?"polling":this.suspendedWatchRequests.has(S.correlationId)}async suspendWatchRequest(S){if(this.suspendedWatchRequests.has(S.correlationId))return;const u=new a.DisposableStore;this.suspendedWatchRequests.set(S.correlationId,u),await this.joinWatch.p,!u.isDisposed&&(this.monitorSuspendedWatchRequest(S,u),this.updateWatchers())}resumeWatchRequest(S){this.suspendedWatchRequests.deleteAndDispose(S.correlationId),this.suspendedWatchRequestsWithPolling.delete(S.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(S,u){this.doMonitorWithExistingWatcher(S,u)?(this.trace(`reusing an existing recursive watcher to monitor ${S.path}`),this.suspendedWatchRequestsWithPolling.delete(S.correlationId)):(this.doMonitorWithNodeJS(S,u),this.suspendedWatchRequestsWithPolling.add(S.correlationId))}doMonitorWithExistingWatcher(S,u){const p=this.recursiveWatcher?.subscribe(S.path,(c,g)=>{u.isDisposed||(c?this.monitorSuspendedWatchRequest(S,u):g?.type===k.FileChangeType.ADDED&&this.onMonitoredPathAdded(S))});return p?(u.add(p),!0):!1}doMonitorWithNodeJS(S,u){let p=!1;const c=(g,f)=>{if(u.isDisposed)return;const h=this.isPathNotFound(g),E=this.isPathNotFound(f),I=p;p=h,!h&&(E||I)&&this.onMonitoredPathAdded(S)};this.trace(`starting fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,D.watchFile)(S.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},c)}catch(g){this.warn(`fs.watchFile() failed with error ${g} on path ${S.path} (correlationId: ${S.correlationId})`)}u.add((0,a.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,D.unwatchFile)(S.path,c)}catch(g){this.warn(`fs.unwatchFile() failed with error ${g} on path ${S.path} (correlationId: ${S.correlationId})`)}}))}onMonitoredPathAdded(S){this.trace(`detected ${S.path} exists again, resuming watcher (correlationId: ${S.correlationId})`);const u={resource:_.URI.file(S.path),type:k.FileChangeType.ADDED,cId:S.correlationId};this._onDidChangeFile.fire([u]),this.traceEvent(u,S),this.resumeWatchRequest(S)}isPathNotFound(S){return S.ctimeMs===0&&S.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(S,u){if(this.verboseLogging){const p=` >> normalized ${S.type===k.FileChangeType.ADDED?"[ADDED]":S.type===k.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`;this.traceWithCorrelation(p,u)}}traceWithCorrelation(S,u){this.verboseLogging&&this.trace(`${S}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}requestToString(S){return`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, filter: ${(0,A.requestFilterToString)(S.filter)}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`}async setVerboseLogging(S){this.verboseLogging=S}}e.BaseWatcher=y}),define(le[202],ue([0,1,43,6,26,42,2,91,14,5,21,9,154,31,7,47]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=h;class f extends k.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(I,d,v,t,r,s){super(),this.request=I,this.recursiveWatcher=d,this.onDidFilesChange=v,this.onDidWatchFail=t,this.onLogMessage=r,this.verboseLogging=s,this.throttledFileChangesEmitter=this._register(new a.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.onDidFilesChange(i))),this.fileChangesAggregator=this._register(new a.RunOnceWorker(i=>this.handleFileChanges(i),f.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,g.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,g.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,g.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new A.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const I=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await p.Promises.stat(I);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(I,d.isDirectory()))}catch(I){I.code!=="ENOENT"?this.error(I):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${I})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(I){let d=I.path;try{d=await p.Promises.realpath(I.path),I.path===d&&(d=await(0,u.realcase)(I.path,this.cts.token)??I.path),I.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${I.path}, real: ${d})`)}catch{}return d}async doWatch(I,d){const v=new k.DisposableStore;return this.doWatchWithExistingWatcher(I,d,v)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(I,d,v)),v}doWatchWithExistingWatcher(I,d,v){if(d)return!1;const t=S.URI.file(this.request.path),r=this.recursiveWatcher?.subscribe(this.request.path,async(s,i)=>{if(!v.isDisposed)if(s){const n=await this.doWatch(I,d);v.isDisposed?n.dispose():v.add(n)}else i&&(typeof i.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:t,type:i.type,cId:this.request.correlationId},!0)});return r?(v.add(r),!0):!1}async doWatchWithNodeJS(I,d,v){if(y.isMacintosh&&(0,L.isEqualOrParent)(I,"/Volumes/",!0)){this.error(`Refusing to watch ${I} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new A.CancellationTokenSource(this.cts.token);v.add((0,k.toDisposable)(()=>t.dispose(!0)));const r=new k.DisposableStore;v.add(r);try{const s=S.URI.file(this.request.path),i=(0,T.basename)(I),n=(0,D.watch)(I);r.add((0,k.toDisposable)(()=>{n.removeAllListeners(),n.close()})),this.trace(`Started watching: '${I}'`);const o=new Set;if(d)try{for(const m of await p.Promises.readdir(I))o.add(m)}catch(m){this.error(m)}if(t.token.isCancellationRequested)return;const l=new Map;r.add((0,k.toDisposable)(()=>{for(const[,m]of l)m.dispose();l.clear()})),n.on("error",(m,w)=>{t.token.isCancellationRequested||(this.error(`Failed to watch ${I} for changes using fs.watch() (${m}, ${w})`),this.notifyWatchFailed())}),n.on("change",(m,w)=>{if(t.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${m}"] ${w}`);let C="";if(w&&(C=w.toString(),y.isMacintosh&&(C=(0,_.normalizeNFC)(C))),!(!C||m!=="change"&&m!=="rename"))if(d)if(m==="rename"){l.get(C)?.dispose();const b=setTimeout(async()=>{if(l.delete(C),C===i&&!await p.Promises.exists(I)){this.onWatchedPathDeleted(s);return}if(t.token.isCancellationRequested)return;const R=await this.existsChildStrictCase((0,T.join)(I,C));if(t.token.isCancellationRequested)return;let U;R?o.has(C)?U=c.FileChangeType.UPDATED:(U=c.FileChangeType.ADDED,o.add(C)):(o.delete(C),U=c.FileChangeType.DELETED),this.onFileChange({resource:(0,P.joinPath)(s,C),type:U,cId:this.request.correlationId})},f.FILE_DELETE_HANDLER_DELAY);l.set(C,(0,k.toDisposable)(()=>clearTimeout(b)))}else{let b;o.has(C)?b=c.FileChangeType.UPDATED:(b=c.FileChangeType.ADDED,o.add(C)),this.onFileChange({resource:(0,P.joinPath)(s,C),type:b,cId:this.request.correlationId})}else if(m==="rename"||C!==i){const b=setTimeout(async()=>{const R=await p.Promises.exists(I);t.token.isCancellationRequested||(R?(this.onFileChange({resource:s,type:c.FileChangeType.UPDATED,cId:this.request.correlationId},!0),r.add(await this.doWatch(I,!1))):this.onWatchedPathDeleted(s))},f.FILE_DELETE_HANDLER_DELAY);r.clear(),r.add((0,k.toDisposable)(()=>clearTimeout(b)))}else this.onFileChange({resource:s,type:c.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(s){t.token.isCancellationRequested||this.error(`Failed to watch ${I} for changes using fs.watch() (${s.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(I){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:I,type:c.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(I,d=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${I.type===c.FileChangeType.ADDED?"[ADDED]":I.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${I.resource.fsPath}`),!d&&this.excludes.some(v=>v(I.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${I.resource.fsPath}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(v=>v(I.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${I.resource.fsPath}`):this.fileChangesAggregator.work(I))}handleFileChanges(I){const d=(0,g.coalesceEvents)(I),v=[];for(const r of d){if((0,g.isFiltered)(r,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${r.resource.fsPath}`);continue}v.push(r)}if(v.length===0)return;if(this.verboseLogging)for(const r of v)this.traceWithCorrelation(` >> normalized ${r.type===c.FileChangeType.ADDED?"[ADDED]":r.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${r.resource.fsPath}`);this.throttledFileChangesEmitter.work(v)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${v[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${v.length}, most recent change: ${v[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(I){if(y.isLinux)return p.Promises.exists(I);try{const d=(0,T.basename)(I);return(await p.Promises.readdir((0,T.dirname)(I))).some(t=>t===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(I){this.verboseLogging=I}error(I){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${I}`})}warn(I){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${I}`})}trace(I){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${I}`})}traceWithCorrelation(I){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${I}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f;async function h(E,I,d,v,t=512){const r=await p.Promises.open(E,"r"),s=Buffer.allocUnsafe(t),i=new A.CancellationTokenSource(v);let n,o=!1;const l={path:E,excludes:[],recursive:!1},m=new f(l,void 0,w=>{(async()=>{for(const{type:C}of w)if(C===c.FileChangeType.UPDATED){if(o)return;o=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:b}=await p.Promises.read(r,s,0,t,null);if(!b||i.token.isCancellationRequested)break;I(s.slice(0,b))}}catch(b){n=new Error(b),i.dispose(!0)}finally{o=!1}}})()});return await m.ready,d(),new Promise((w,C)=>{i.token.onCancellationRequested(async()=>{m.dispose();try{await p.Promises.close(r)}catch(b){n=new Error(b)}n?C(n):w()})})}}),define(le[203],ue([0,1,3,94,201,5,202,42]),function(ne,e,D,a,A,L,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class T extends A.BaseWatcher{constructor(P){super(),this.recursiveWatcher=P,this.onDidError=D.Event.None,this.watchers=new Set}async doWatch(P){P=this.removeDuplicateRequests(P);const S=[],u=new Set(Array.from(this.watchers));for(const p of P){const c=this.findWatcher(p);c&&(0,a.patternsEquals)(c.request.excludes,p.excludes)&&(0,a.patternsEquals)(c.request.includes,p.includes)?u.delete(c):S.push(p)}S.length&&this.trace(`Request to start watching: ${S.map(p=>this.requestToString(p)).join(",")}`),u.size&&this.trace(`Request to stop watching: ${Array.from(u).map(p=>this.requestToString(p.request)).join(",")}`);for(const p of u)this.stopWatching(p);for(const p of S)this.startWatching(p)}findWatcher(P){for(const S of this.watchers)if(typeof P.correlationId=="number"||typeof S.request.correlationId=="number"){if(S.request.correlationId===P.correlationId)return S}else if((0,_.isEqual)(S.request.path,P.path,!L.isLinux))return S}startWatching(P){const S=new k.NodeJSFileWatcherLibrary(P,this.recursiveWatcher,p=>this._onDidChangeFile.fire(p),()=>this._onDidWatchFail.fire(P),p=>this._onDidLogMessage.fire(p),this.verboseLogging),u={request:P,instance:S};this.watchers.add(u)}async stop(){await super.stop();for(const P of this.watchers)this.stopWatching(P)}stopWatching(P){this.trace("stopping file watcher",P),this.watchers.delete(P),P.instance.dispose()}removeDuplicateRequests(P){const S=new Map;for(const u of P){const p=L.isLinux?u.path:u.path.toLowerCase();let c=S.get(u.correlationId);c||(c=new Map,S.set(u.correlationId,c)),c.has(p)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(u)}`),c.set(p,u)}return Array.from(S.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(P){super.setVerboseLogging(P);for(const S of this.watchers)S.instance.setVerboseLogging(P)}trace(P,S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(P,S)})}warn(P){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(P)})}toMessage(P,S){return S?`[File Watcher (node.js)] ${P} (${this.requestToString(S.request)})`:`[File Watcher (node.js)] ${P}`}}e.NodeJSWatcher=T}),define(le[204],ue([0,1,47,203]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class A extends D.AbstractNonRecursiveWatcherClient{constructor(k,_,T){super(k,_,T),this.init()}createWatcher(k){return k.add(new a.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=A}),define(le[205],ue([0,1,23,44,96,47]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends L.AbstractUniversalWatcherClient{constructor(T,y,P){super(T,y,P),this.init()}createWatcher(T){const y=T.add(new A.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return T.add(y.onDidProcessExit(({code:P,signal:S})=>this.onError(`terminated by itself with code ${P}, signal: ${S} (ETERM)`))),a.ProxyChannel.toService((0,a.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(le[77],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...A){this._entries=new Map;for(const[L,k]of A)this.set(L,k)}set(A,L){const k=this._entries.get(A);return this._entries.set(A,L),k}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=D}),define(le[206],ue([0,1,6,8,2,74,197,4,77,90]),function(ne,e,D,a,A,L,k,_,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class S extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class u{constructor(f=new T.ServiceCollection,h=!1,E,I=P){this._services=f,this._strict=h,this._parent=E,this._enableTracing=I,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(_.IInstantiationService,this),this._globalGraph=I?E?._globalGraph??new k.Graph(d=>d):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,A.dispose)(this._children),this._children.clear();for(const f of this._servicesToMaybeDispose)(0,A.isDisposable)(f)&&f.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(f,h){this._throwIfDisposed();const E=this,I=new class extends u{dispose(){E._children.delete(I),super.dispose()}}(f,this._strict,this,this._enableTracing);return this._children.add(I),h?.add(I),I}invokeFunction(f,...h){this._throwIfDisposed();const E=c.traceInvocation(this._enableTracing,f);let I=!1;try{return f({get:v=>{if(I)throw(0,a.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(v,E);if(!t)throw new Error(`[invokeFunction] unknown service '${v}'`);return t}},...h)}finally{I=!0,E.stop()}}createInstance(f,...h){this._throwIfDisposed();let E,I;return f instanceof L.SyncDescriptor?(E=c.traceCreation(this._enableTracing,f.ctor),I=this._createInstance(f.ctor,f.staticArguments.concat(h),E)):(E=c.traceCreation(this._enableTracing,f),I=this._createInstance(f,h,E)),E.stop(),I}_createInstance(f,h=[],E){const I=_._util.getServiceDependencies(f).sort((t,r)=>t.index-r.index),d=[];for(const t of I){const r=this._getOrCreateServiceInstance(t.id,E);r||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(r)}const v=I.length>0?I[0].index:h.length;if(h.length!==v){console.trace(`[createInstance] First service dependency of ${f.name} at position ${v+1} conflicts with ${h.length} static arguments`);const t=v-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,v)}return Reflect.construct(f,h.concat(d))}_setCreatedServiceInstance(f,h){if(this._services.get(f)instanceof L.SyncDescriptor)this._services.set(f,h);else if(this._parent)this._parent._setCreatedServiceInstance(f,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const h=this._services.get(f);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):h}_getOrCreateServiceInstance(f,h){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(f));const E=this._getServiceInstanceOrDescriptor(f);return E instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,E,h.branch(f,!0)):(h.branch(f,!1),E)}_safeCreateAndCacheServiceInstance(f,h,E){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,h,E)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,h,E){const I=new k.Graph(t=>t.id.toString());let d=0;const v=[{id:f,desc:h,_trace:E}];for(;v.length;){const t=v.pop();if(I.lookupOrInsertNode(t),d++>1e3)throw new S(I);for(const r of _._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(r.id);if(s||this._throwIfStrict(`[createInstance] ${f} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),s instanceof L.SyncDescriptor){const i={id:r.id,desc:s,_trace:t._trace.branch(r.id,!0)};I.insertEdge(t,i),v.push(i)}}}for(;;){const t=I.roots();if(t.length===0){if(!I.isEmpty())throw new S(I);break}for(const{data:r}of t){if(this._getServiceInstanceOrDescriptor(r.id)instanceof L.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setCreatedServiceInstance(r.id,i)}I.removeNode(r)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,h,E=[],I,d){if(this._services.get(f)instanceof L.SyncDescriptor)return this._createServiceInstance(f,h,E,I,d,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,h,E,I,d);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(f,h,E=[],I,d,v){if(I){const t=new u(void 0,this._strict,this,this._enableTracing);t._globalGraphImplicitDependency=String(f);const r=new Map,s=new D.GlobalIdleValue(()=>{const i=t._createInstance(h,E,d);for(const[n,o]of r){const l=i[n];if(typeof l=="function")for(const m of o)m.disposable=l.apply(i,m.listener)}return r.clear(),v.add(i),i});return new Proxy(Object.create(null),{get(i,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let m=r.get(n);return m||(m=new y.LinkedList,r.set(n,m)),(C,b,R)=>{if(s.isInitialized)return s.value[n](C,b,R);{const U={listener:[C,b,R],disposable:void 0},N=m.push(U);return(0,A.toDisposable)(()=>{N(),U.disposable?.dispose()})}}}if(n in i)return i[n];const o=s.value;let l=o[n];return typeof l!="function"||(l=l.bind(o),i[n]=l),l},set(i,n,o){return s.value[n]=o,!0},getPrototypeOf(i){return h.prototype}})}else{const t=this._createInstance(h,E,d);return v.add(t),t}}_throwIfStrict(f,h){if(h&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=u;var p;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(p||(p={}));class c{static{this.all=new Set}static{this._None=new class extends c{constructor(){super(p.None,null)}stop(){}branch(){return this}}}static traceInvocation(f,h){return f?new c(p.Invocation,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):c._None}static traceCreation(f,h){return f?new c(p.Creation,h.name):c._None}static{this._totals=0}constructor(f,h){this.type=f,this.name=h,this._start=Date.now(),this._dep=[]}branch(f,h){const E=new c(p.Branch,f.toString());return this._dep.push([f,h,E]),E}stop(){const f=Date.now()-this._start;c._totals+=f;let h=!1;function E(d,v){const t=[],r=new Array(d+1).join("	");for(const[s,i,n]of v._dep)if(i&&n){h=!0,t.push(`${r}CREATES -> ${s}`);const o=E(d+1,n);o&&t.push(o)}else t.push(`${r}uses -> ${s}`);return t.join(`
`)}const I=[`${this.type===p.Creation?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(f>2||h)&&c.all.add(I.join(`
`))}}e.Trace=c}),define(le[57],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,D.createDecorator)("mainProcessService");class a{constructor(L,k){this.server=L,this.router=k}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,k){this.server.registerChannel(L,k)}}e.MainProcessService=a}),define(le[10],ue([0,1,174,40,3,55,2,35,5,21,13,9,97,4]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=g,e.log=h,e.getLogLevel=l,e.LogLevelToString=m,e.LogLevelToLocalizedString=w,e.parseLogLevel=C,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function c(){return new Date().toISOString()}function g(b){return(0,P.isNumber)(b)}var f;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(f||(e.LogLevel=f={})),e.DEFAULT_LOG_LEVEL=f.Info;function h(b,R,U){switch(R){case f.Trace:b.trace(U);break;case f.Debug:b.debug(U);break;case f.Info:b.info(U);break;case f.Warning:b.warn(U);break;case f.Error:b.error(U);break;case f.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function E(b,R=!1){let U="";for(let N=0;N<b.length;N++){let M=b[N];if(M instanceof Error&&(M=(0,a.toErrorMessage)(M,R)),typeof M=="object")try{M=JSON.stringify(M)}catch{}U+=(N>0?" ":"")+M}return U}class I extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(R){this.level!==R&&(this.level=R,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(R){return this.level!==f.Off&&this.level<=R}}e.AbstractLogger=I;class d extends I{constructor(R){super(),this.logAlways=R}checkLogLevel(R){return this.logAlways||super.checkLogLevel(R)}trace(R,...U){this.checkLogLevel(f.Trace)&&this.log(f.Trace,E([R,...U],!0))}debug(R,...U){this.checkLogLevel(f.Debug)&&this.log(f.Debug,E([R,...U]))}info(R,...U){this.checkLogLevel(f.Info)&&this.log(f.Info,E([R,...U]))}warn(R,...U){this.checkLogLevel(f.Warning)&&this.log(f.Warning,E([R,...U]))}error(R,...U){if(this.checkLogLevel(f.Error))if(R instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=R.stack,this.log(f.Error,E(N))}else this.log(f.Error,E([R,...U]))}flush(){}}e.AbstractMessageLogger=d;class v extends I{constructor(R=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(R),this.useColors=!T.isWindows}trace(R,...U){this.checkLogLevel(f.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,R,...U):console.log(`[main ${c()}]`,R,...U))}debug(R,...U){this.checkLogLevel(f.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,R,...U):console.log(`[main ${c()}]`,R,...U))}info(R,...U){this.checkLogLevel(f.Info)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,R,...U):console.log(`[main ${c()}]`,R,...U))}warn(R,...U){this.checkLogLevel(f.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,R,...U):console.warn(`[main ${c()}]`,R,...U))}error(R,...U){this.checkLogLevel(f.Error)&&(this.useColors?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,R,...U):console.error(`[main ${c()}]`,R,...U))}flush(){}}e.ConsoleMainLogger=v;class t extends I{constructor(R=e.DEFAULT_LOG_LEVEL,U=!0){super(),this.useColors=U,this.setLevel(R)}trace(R,...U){this.checkLogLevel(f.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",R,...U):console.log(R,...U))}debug(R,...U){this.checkLogLevel(f.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",R,...U):console.log(R,...U))}info(R,...U){this.checkLogLevel(f.Info)&&(this.useColors?console.log("%c INFO","color: #33f",R,...U):console.log(R,...U))}warn(R,...U){this.checkLogLevel(f.Warning)&&(this.useColors?console.log("%c WARN","color: #993",R,...U):console.log(R,...U))}error(R,...U){this.checkLogLevel(f.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",R,...U):console.error(R,...U))}flush(){}}e.ConsoleLogger=t;class r extends I{constructor(R,U=e.DEFAULT_LOG_LEVEL){super(),this.adapter=R,this.setLevel(U)}trace(R,...U){this.checkLogLevel(f.Trace)&&this.adapter.log(f.Trace,[this.extractMessage(R),...U])}debug(R,...U){this.checkLogLevel(f.Debug)&&this.adapter.log(f.Debug,[this.extractMessage(R),...U])}info(R,...U){this.checkLogLevel(f.Info)&&this.adapter.log(f.Info,[this.extractMessage(R),...U])}warn(R,...U){this.checkLogLevel(f.Warning)&&this.adapter.log(f.Warning,[this.extractMessage(R),...U])}error(R,...U){this.checkLogLevel(f.Error)&&this.adapter.log(f.Error,[this.extractMessage(R),...U])}extractMessage(R){return typeof R=="string"?R:(0,a.toErrorMessage)(R,this.checkLogLevel(f.Trace))}flush(){}}e.AdapterLogger=r;class s extends I{constructor(R){super(),this.loggers=R,R.length&&this.setLevel(R[0].getLevel())}setLevel(R){for(const U of this.loggers)U.setLevel(R);super.setLevel(R)}trace(R,...U){for(const N of this.loggers)N.trace(R,...U)}debug(R,...U){for(const N of this.loggers)N.debug(R,...U)}info(R,...U){for(const N of this.loggers)N.info(R,...U)}warn(R,...U){for(const N of this.loggers)N.warn(R,...U)}error(R,...U){for(const N of this.loggers)N.error(R,...U)}flush(){for(const R of this.loggers)R.flush()}dispose(){for(const R of this.loggers)R.dispose();super.dispose()}}e.MultiplexLogger=s;class i extends k.Disposable{constructor(R,U,N){if(super(),this.logLevel=R,this.logsHome=U,this._loggers=new _.ResourceMap,this._onDidChangeLoggers=this._register(new A.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,N)for(const M of N)this._loggers.set(M.resource,{logger:void 0,info:M})}getLoggerEntry(R){return(0,P.isString)(R)?[...this._loggers.values()].find(U=>U.info.id===R):this._loggers.get(R)}getLogger(R){return this.getLoggerEntry(R)?.logger}createLogger(R,U){const N=this.toResource(R),M=(0,P.isString)(R)?R:U?.id??(0,L.hash)(N.toString()).toString(16);let F=this._loggers.get(N)?.logger;const K=U?.logLevel==="always"?f.Trace:U?.logLevel;F||(F=this.doCreateLogger(N,K??this.getLogLevel(N)??this.logLevel,{...U,id:M}));const H={logger:F,info:{resource:N,id:M,logLevel:K,name:U?.name,hidden:U?.hidden,extensionId:U?.extensionId,when:U?.when}};return this.registerLogger(H.info),this._loggers.set(N,H),F}toResource(R){return(0,P.isString)(R)?(0,y.joinPath)(this.logsHome,`${R}.log`):R}setLogLevel(R,U){if(S.URI.isUri(R)){const N=R,M=U,F=this._loggers.get(N);F&&M!==F.info.logLevel&&(F.info.logLevel=M===this.logLevel?void 0:M,F.logger?.setLevel(M),this._loggers.set(F.info.resource,F),this._onDidChangeLogLevel.fire([N,M]))}else{this.logLevel=R;for(const[N,M]of this._loggers.entries())this._loggers.get(N)?.info.logLevel===void 0&&M.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(R,U){const N=this.getLoggerEntry(R);N&&U!==!N.info.hidden&&(N.info.hidden=!U,this._loggers.set(N.info.resource,N),this._onDidChangeVisibility.fire([N.info.resource,U]))}getLogLevel(R){let U;return R&&(U=this._loggers.get(R)?.info.logLevel),U??this.logLevel}registerLogger(R){const U=this._loggers.get(R.resource);U?U.info.hidden!==R.hidden&&this.setVisibility(R.resource,!R.hidden):(this._loggers.set(R.resource,{info:R,logger:void 0}),this._onDidChangeLoggers.fire({added:[R],removed:[]}))}deregisterLogger(R){const U=this._loggers.get(R);U&&(U.logger&&U.logger.dispose(),this._loggers.delete(R),this._onDidChangeLoggers.fire({added:[],removed:[U.info]}))}*getRegisteredLoggers(){for(const R of this._loggers.values())yield R.info}getRegisteredLogger(R){return this._loggers.get(R)?.info}dispose(){this._loggers.forEach(R=>R.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class n{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(R){}getLevel(){return f.Info}trace(R,...U){}debug(R,...U){}info(R,...U){}warn(R,...U){}error(R,...U){}critical(R,...U){}dispose(){}flush(){}}e.NullLogger=n;class o extends n{}e.NullLogService=o;function l(b){if(b.verbose)return f.Trace;if(typeof b.logLevel=="string"){const R=C(b.logLevel.toLowerCase());if(R!==void 0)return R}return e.DEFAULT_LOG_LEVEL}function m(b){switch(b){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function w(b){switch(b){case f.Trace:return{original:"Trace",value:D.localize(0,null)};case f.Debug:return{original:"Debug",value:D.localize(1,null)};case f.Info:return{original:"Info",value:D.localize(2,null)};case f.Warning:return{original:"Warning",value:D.localize(3,null)};case f.Error:return{original:"Error",value:D.localize(4,null)};case f.Off:return{original:"Off",value:D.localize(5,null)}}}function C(b){switch(b){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.CONTEXT_LOG_LEVEL=new u.RawContextKey("logLevel",m(f.Info))}),define(le[207],ue([0,1,6,8,2,23,14,21,31,16,10]),function(ne,e,D,a,A,L,k,_,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends A.Disposable{constructor(p,c){super(),this.environmentService=p,this.logService=c,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const p=(0,_.basename)(this.environmentService.logsHome),c=(0,_.dirname)(this.environmentService.logsHome.with({scheme:L.Schemas.file})).fsPath,h=(await T.Promises.readdir(c)).filter(I=>/^\d{8}T\d{6}$/.test(I)).sort().filter(I=>I!==p),E=h.slice(0,Math.max(0,h.length-9));E.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${E.join(", ")}'`),await Promise.all(E.map(I=>T.Promises.rm((0,k.join)(c,I)))))}catch(p){(0,a.onUnexpectedError)(p)}}};e.LogsDataCleaner=S,e.LogsDataCleaner=S=we([Q(0,y.IEnvironmentService),Q(1,P.ILogService)],S)}),define(le[208],ue([0,1,19,6,8,3,42,2,14,47,10]),function(ne,e,D,a,A,L,k,_,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends _.Disposable{constructor(p,c){super(),this.logService=p,this.options=c,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new a.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new a.ThrottledDelayer(0))}watch(p,c){return c.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,c):this.watchNonRecursive(p,c)}watchUniversal(p,c){const g={path:this.toWatchPath(p),excludes:c.excludes,includes:c.includes,recursive:c.recursive,filter:c.filter,correlationId:c.correlationId},f=(0,D.insert)(this.universalWatchRequests,g);return this.refreshUniversalWatchers(),(0,_.toDisposable)(()=>{f(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,A.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(c=>this._onDidChangeFile.fire((0,y.reviveFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const c of this.universalWatchRequests)(0,y.isRecursiveWatchRequest)(c)&&(c.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const c of this.universalWatchRequests)(0,y.isRecursiveWatchRequest)(c)&&p.includes(c.path)&&(c.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(p,c){const g={path:this.toWatchPath(p),excludes:c.excludes,includes:c.includes,recursive:!1,filter:c.filter,correlationId:c.correlationId},f=(0,D.insert)(this.nonRecursiveWatchRequests,g);return this.refreshNonRecursiveWatchers(),(0,_.toDisposable)(()=>{f(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,A.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,y.reviveFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logWatcherMessage(p)}logWatcherMessage(p){this.logService[p.type](p.message)}toFilePath(p){return(0,T.normalize)(p.fsPath)}toWatchPath(p){const c=this.toFilePath(p);return(0,k.removeTrailingPathSeparator)(c)}}e.AbstractDiskFileSystemProvider=S}),define(le[209],ue([0,1,19,6,15,26,3,55,62,2,52,23,101,21,51,169,7,100,10,8]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends y.Disposable{static{d=this}constructor(r){super(),this.logService=r,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new k.Emitter),this._onDidUncorrelatedFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new a.ResourceQueue)}registerProvider(r,s){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,u.mark)(`code/registerFilesystem/${r}`);const i=new y.DisposableStore;return this.provider.set(r,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:s}),i.add(s.onDidChangeFile(n=>{const o=new f.FileChangesEvent(n,!this.isPathCaseSensitive(s));this.internalOnDidFilesChange.fire(o),o.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(o)})),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:r}))),(0,y.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:s}),this.provider.delete(r),(0,y.dispose)(i)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(i){s.push(i)}}),!this.provider.has(r)&&await a.Promises.settled(s)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.provider.has(r.scheme)}hasCapability(r,s){const i=this.provider.get(r.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return T.Iterable.map(this.provider,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async withProvider(r){if(!(0,p.isAbsolutePath)(r))throw new f.FileOperationError((0,g.localize)(0,null,this.resourceForError(r)),f.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(r.scheme);const s=this.provider.get(r.scheme);if(!s){const i=new I.ErrorNoTelemetry;throw i.message=(0,g.localize)(1,null,r.toString()),i}return s}async withReadProvider(r){const s=await this.withProvider(r);if((0,f.hasOpenReadWriteCloseCapability)(s)||(0,f.hasReadWriteCapability)(s)||(0,f.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const s=await this.withProvider(r);if((0,f.hasOpenReadWriteCloseCapability)(s)||(0,f.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.doResolveFile(r,s)}catch(i){throw(0,f.toFileSystemProviderErrorCode)(i)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,g.localize)(2,null,this.resourceForError(r)),f.FileOperationResult.FILE_NOT_FOUND):(0,f.ensureFileSystemProviderError)(i)}}async doResolveFile(r,s){const i=await this.withProvider(r),n=this.isPathCaseSensitive(i),o=s?.resolveTo,l=s?.resolveSingleChildDescendants,m=s?.resolveMetadata,w=await i.stat(r);let C;return this.toFileStat(i,r,w,void 0,!!m,(b,R)=>(C||(C=P.TernarySearchTree.forUris(()=>!n),C.set(r,!0),o&&C.fill(!0,o)),C.get(b.resource)||C.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&l?R===1:!1))}async toFileStat(r,s,i,n,o,l){const{providerExtUri:m}=this.getExtUri(r),w={resource:s,name:m.basename(s),isFile:(i.type&f.FileType.File)!==0,isDirectory:(i.type&f.FileType.Directory)!==0,isSymbolicLink:(i.type&f.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&f.FilePermission.Readonly)||!!(r.capabilities&f.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&f.FilePermission.Locked),etag:(0,f.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(w.isDirectory&&l(w,n)){try{const C=await r.readdir(s),b=await a.Promises.settled(C.map(async([R,U])=>{try{const N=m.joinPath(s,R),M=o?await r.stat(N):{type:U};return await this.toFileStat(r,N,M,C.length,o,l)}catch(N){return this.logService.trace(N),null}}));w.children=(0,D.coalesce)(b)}catch(C){this.logService.trace(C),w.children=[]}return w}return w}async resolveAll(r){return a.Promises.settled(r.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const s=await this.withProvider(r),i=await s.stat(r);return this.toFileStat(s,r,i,void 0,!0,()=>!1)}async exists(r){const s=await this.withProvider(r);try{return!!await s.stat(r)}catch{return!1}}async canCreateFile(r,s){try{await this.doValidateCreateFile(r,s)}catch(i){return i}return!0}async doValidateCreateFile(r,s){if(!s?.overwrite&&await this.exists(r))throw new f.FileOperationError((0,g.localize)(3,null,this.resourceForError(r)),f.FileOperationResult.FILE_MODIFIED_SINCE,s)}async createFile(r,s=A.VSBuffer.fromString(""),i){await this.doValidateCreateFile(r,i);const n=await this.writeFile(r,s);return this._onDidRunOperation.fire(new f.FileOperationEvent(r,f.FileOperation.CREATE,n)),n}async writeFile(r,s,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:o}=this.getExtUri(n);let l=i;if((0,f.hasFileAtomicWriteCapability)(n)&&!l?.atomic){const m=n.enforceAtomicWriteFile?.(r);m&&(l={...i,atomic:m})}try{await this.validateWriteFile(n,r,l)||await this.mkdirp(n,o.dirname(r));let w;if((0,f.hasReadWriteCapability)(n)&&!(s instanceof A.VSBuffer))if((0,c.isReadableStream)(s)){const C=await(0,c.peekStream)(s,3);C.ended?w=A.VSBuffer.concat(C.buffer):w=C}else w=(0,c.peekReadable)(s,C=>A.VSBuffer.concat(C),3);else w=s;!(0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasReadWriteCapability)(n)&&w instanceof A.VSBuffer||(0,f.hasReadWriteCapability)(n)&&(0,f.hasFileAtomicWriteCapability)(n)&&l?.atomic?await this.doWriteUnbuffered(n,r,l,w):await this.doWriteBuffered(n,r,l,w instanceof A.VSBuffer?(0,A.bufferToReadable)(w):w),this._onDidRunOperation.fire(new f.FileOperationEvent(r,f.FileOperation.WRITE))}catch(m){throw new f.FileOperationError((0,g.localize)(4,null,this.resourceForError(r),(0,f.ensureFileSystemProviderError)(m).toString()),(0,f.toFileOperationResult)(m),l)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,s,i){const n=!!i?.unlock;if(n&&!(r.capabilities&f.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(5,null,this.resourceForError(s)));if(!!i?.atomic){if(!(r.capabilities&f.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(6,null,this.resourceForError(s)));if(!(r.capabilities&f.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(7,null,this.resourceForError(s)));if(n)throw new Error((0,g.localize)(8,null,this.resourceForError(s)))}let l;try{l=await r.stat(s)}catch{return}if(l.type&f.FileType.Directory)throw new f.FileOperationError((0,g.localize)(9,null,this.resourceForError(s)),f.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.throwIfFileIsReadonly(s,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==f.ETAG_DISABLED&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,f.etag)({mtime:i.mtime,size:l.size}))throw new f.FileOperationError((0,g.localize)(10,null),f.FileOperationResult.FILE_MODIFIED_SINCE,i);return l}async readFile(r,s,i){const n=await this.withReadProvider(r);return s?.atomic?this.doReadFileAtomic(n,r,s,i):this.doReadFile(n,r,s,i)}async doReadFileAtomic(r,s,i,n){return new Promise((o,l)=>{this.writeQueue.queueFor(s,async()=>{try{const m=await this.doReadFile(r,s,i,n);o(m)}catch(m){l(m)}},this.getExtUri(r).providerExtUri)})}async doReadFile(r,s,i,n){const o=await this.doReadFileStream(r,s,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,A.streamToBuffer)(o.value)}}async readFileStream(r,s,i){const n=await this.withReadProvider(r);return this.doReadFileStream(n,r,s,i)}async doReadFileStream(r,s,i,n){const o=new L.CancellationTokenSource(n);let l=i;(0,f.hasFileAtomicReadCapability)(r)&&r.enforceAtomicReadFile?.(s)&&(l={...i,atomic:!0});const m=this.validateReadFile(s,l).then(C=>C,C=>{throw o.dispose(!0),C});let w;try{return typeof l?.etag=="string"&&l.etag!==f.ETAG_DISABLED&&await m,l?.atomic&&(0,f.hasFileAtomicReadCapability)(r)||!((0,f.hasOpenReadWriteCloseCapability)(r)||(0,f.hasFileReadStreamCapability)(r))||(0,f.hasReadWriteCapability)(r)&&l?.preferUnbuffered?w=this.readFileUnbuffered(r,s,l):(0,f.hasFileReadStreamCapability)(r)?w=this.readFileStreamed(r,s,o.token,l):w=this.readFileBuffered(r,s,o.token,l),w.on("end",()=>o.dispose()),w.on("error",()=>o.dispose()),{...await m,value:w}}catch(C){throw w&&await(0,c.consumeStream)(w),this.restoreReadError(C,s,l)}}restoreReadError(r,s,i){const n=(0,g.localize)(11,null,this.resourceForError(s),(0,f.ensureFileSystemProviderError)(r).toString());return r instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(n,r.stat,i):r instanceof f.TooLargeFileOperationError?new f.TooLargeFileOperationError(n,r.fileOperationResult,r.size,r.options):new f.FileOperationError(n,(0,f.toFileOperationResult)(r),i)}readFileStreamed(r,s,i,n=Object.create(null)){const o=r.readFileStream(s,n,i);return(0,c.transform)(o,{data:l=>l instanceof A.VSBuffer?l:A.VSBuffer.wrap(l),error:l=>this.restoreReadError(l,s,n)},l=>A.VSBuffer.concat(l))}readFileBuffered(r,s,i,n=Object.create(null)){const o=(0,A.newWriteableBufferStream)();return(0,h.readFileIntoStream)(r,s,o,l=>l,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:l=>this.restoreReadError(l,s,n)},i),o}readFileUnbuffered(r,s,i){const n=(0,c.newWriteableStream)(o=>A.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,f.hasFileAtomicReadCapability)(r)?o=await r.readFile(s,{atomic:!0}):o=await r.readFile(s),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.validateReadFileLimits(s,o.byteLength,i),n.end(A.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async validateReadFile(r,s){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new f.FileOperationError((0,g.localize)(12,null,this.resourceForError(r)),f.FileOperationResult.FILE_IS_DIRECTORY,s);if(typeof s?.etag=="string"&&s.etag!==f.ETAG_DISABLED&&s.etag===i.etag)throw new f.NotModifiedSinceFileOperationError((0,g.localize)(13,null),i,s);return this.validateReadFileLimits(r,i.size,s),i}validateReadFileLimits(r,s,i){if(typeof i?.limits?.size=="number"&&s>i.limits.size)throw new f.TooLargeFileOperationError((0,g.localize)(14,null,this.resourceForError(r)),f.FileOperationResult.FILE_TOO_LARGE,s,i)}async canMove(r,s,i){return this.doCanMoveCopy(r,s,"move",i)}async canCopy(r,s,i){return this.doCanMoveCopy(r,s,"copy",i)}async doCanMoveCopy(r,s,i,n){if(r.toString()!==s.toString())try{const o=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(o,r,l,s,i,n)}catch(o){return o}return!0}async move(r,s,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),l=await this.doMoveCopy(n,r,o,s,"move",!!i),m=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(r,l==="move"?f.FileOperation.MOVE:f.FileOperation.COPY,m)),m}async copy(r,s,i){const n=await this.withReadProvider(r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),l=await this.doMoveCopy(n,r,o,s,"copy",!!i),m=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(r,l==="copy"?f.FileOperation.COPY:f.FileOperation.MOVE,m)),m}async doMoveCopy(r,s,i,n,o,l){if(s.toString()===n.toString())return o;const{exists:m,isSameResourceWithDifferentPathCase:w}=await this.doValidateMoveCopy(r,s,i,n,o,l);if(m&&!w&&l&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),o==="copy"){if(r===i&&(0,f.hasFileFolderCopyCapability)(r))await r.copy(s,n,{overwrite:l});else{const C=await this.resolve(s);C.isDirectory?await this.doCopyFolder(r,C,i,n):await this.doCopyFile(r,s,i,n)}return o}else return r===i?(await r.rename(s,n,{overwrite:l}),o):(await this.doMoveCopy(r,s,i,n,"copy",l),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(r,s,i,n){if((0,f.hasOpenReadWriteCloseCapability)(r)&&(0,f.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(r,s,i,n);if((0,f.hasOpenReadWriteCloseCapability)(r)&&(0,f.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(r,s,i,n);if((0,f.hasReadWriteCapability)(r)&&(0,f.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(r,s,i,n);if((0,f.hasReadWriteCapability)(r)&&(0,f.hasReadWriteCapability)(i))return this.doPipeUnbuffered(r,s,i,n)}async doCopyFolder(r,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await a.Promises.settled(s.children.map(async o=>{const l=this.getExtUri(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.doCopyFolder(r,await this.resolve(o.resource),i,l):this.doCopyFile(r,o.resource,i,l)}))}async doValidateMoveCopy(r,s,i,n,o,l){let m=!1;if(r===i){const{providerExtUri:C,isPathCaseSensitive:b}=this.getExtUri(r);if(b||(m=C.isEqual(s,n)),m&&o==="copy")throw new Error((0,g.localize)(15,null,this.resourceForError(s),this.resourceForError(n)));if(!m&&C.isEqualOrParent(n,s))throw new Error((0,g.localize)(16,null,this.resourceForError(s),this.resourceForError(n)))}const w=await this.exists(n);if(w&&!m){if(!l)throw new f.FileOperationError((0,g.localize)(17,null,this.resourceForError(s),this.resourceForError(n)),f.FileOperationResult.FILE_MOVE_CONFLICT);if(r===i){const{providerExtUri:C}=this.getExtUri(r);if(C.isEqualOrParent(s,n))throw new Error((0,g.localize)(18,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:w,isSameResourceWithDifferentPathCase:m}}getExtUri(r){const s=this.isPathCaseSensitive(r);return{providerExtUri:s?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(r){return!!(r.capabilities&f.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(r){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(s,r);const i=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(r,f.FileOperation.CREATE,i)),i}async mkdirp(r,s){const i=[],{providerExtUri:n}=this.getExtUri(r);for(;!n.isEqual(s,n.dirname(s));)try{if(!((await r.stat(s)).type&f.FileType.Directory))throw new Error((0,g.localize)(19,null,this.resourceForError(s)));break}catch(o){if((0,f.toFileSystemProviderErrorCode)(o)!==f.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(s)),s=n.dirname(s)}for(let o=i.length-1;o>=0;o--){s=n.joinPath(s,i[o]);try{await r.mkdir(s)}catch(l){if((0,f.toFileSystemProviderErrorCode)(l)!==f.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,s){try{await this.doValidateDelete(r,s)}catch(i){return i}return!0}async doValidateDelete(r,s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r),n=!!s?.useTrash;if(n&&!(i.capabilities&f.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(20,null,this.resourceForError(r)));const o=s?.atomic;if(o&&!(i.capabilities&f.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(21,null,this.resourceForError(r)));if(n&&o)throw new Error((0,g.localize)(22,null,this.resourceForError(r)));let l;try{l=await i.stat(r)}catch{}if(l)this.throwIfFileIsReadonly(r,l);else throw new f.FileOperationError((0,g.localize)(23,null,this.resourceForError(r)),f.FileOperationResult.FILE_NOT_FOUND);if(!!!s?.recursive){const w=await this.resolve(r);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,g.localize)(24,null,this.resourceForError(r)))}return i}async del(r,s){const i=await this.doValidateDelete(r,s);let n=s;if((0,f.hasFileAtomicDeleteCapability)(i)&&!n?.atomic){const w=i.enforceAtomicDelete?.(r);w&&(n={...s,atomic:w})}const o=!!n?.useTrash,l=!!n?.recursive,m=n?.atomic??!1;await i.delete(r,{recursive:l,useTrash:o,atomic:m}),this._onDidRunOperation.fire(new f.FileOperationEvent(r,f.FileOperation.DELETE))}async cloneFile(r,s){const i=await this.withProvider(r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(!(i===n&&this.getExtUri(i).providerExtUri.isEqual(r,s)))return i===n&&(0,f.hasFileCloneCapability)(i)?i.cloneFile(r,s):(await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s)),i===n&&(0,f.hasFileFolderCopyCapability)(i)?this.writeQueue.queueFor(r,()=>i.copy(r,s,{overwrite:!0}),this.getExtUri(i).providerExtUri):this.writeQueue.queueFor(r,()=>this.doCopyFile(i,r,n,s),this.getExtUri(i).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(r,s){return this.watch(r,{...s,correlationId:d.WATCHER_CORRELATION_IDS++})}watch(r,s={recursive:!1,excludes:[]}){const i=new y.DisposableStore;let n=!1,o=()=>{n=!0};i.add((0,y.toDisposable)(()=>o())),(async()=>{try{const m=await this.doWatch(r,s);n?(0,y.dispose)(m):o=()=>(0,y.dispose)(m)}catch(m){this.logService.error(m)}})();const l=s.correlationId;if(typeof l=="number"){const m=i.add(new k.Emitter);return i.add(this.internalOnDidFilesChange.event(C=>{C.correlates(l)&&m.fire(C)})),{onDidChange:m.event,dispose:()=>i.dispose()}}return i}async doWatch(r,s){const i=await this.withProvider(r),n=(0,_.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(r),s]);let o=this.activeWatchers.get(n);return o||(o={count:0,disposable:i.watch(r,s)},this.activeWatchers.set(n,o)),o.count+=1,(0,y.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,y.dispose)(o.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,r]of this.activeWatchers)(0,y.dispose)(r.disposable);this.activeWatchers.clear()}async doWriteBuffered(r,s,i,n){return this.writeQueue.queueFor(s,async()=>{const o=await r.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,c.isReadableStream)(n)||(0,c.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(r,o,n):await this.doWriteReadableBufferedQueued(r,o,n)}catch(l){throw(0,f.ensureFileSystemProviderError)(l)}finally{await r.close(o)}},this.getExtUri(r).providerExtUri)}async doWriteStreamBufferedQueued(r,s,i){let n=0,o;if((0,c.isReadableBufferedStream)(i)){if(i.buffer.length>0){const l=A.VSBuffer.concat(i.buffer);await this.doWriteBuffer(r,s,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((l,m)=>{(0,c.listenStream)(o,{onData:async w=>{o.pause();try{await this.doWriteBuffer(r,s,w,w.byteLength,n,0)}catch(C){return m(C)}n+=w.byteLength,setTimeout(()=>o.resume())},onError:w=>m(w),onEnd:()=>l()})})}async doWriteReadableBufferedQueued(r,s,i){let n=0,o;for(;(o=i.read())!==null;)await this.doWriteBuffer(r,s,o,o.byteLength,n,0),n+=o.byteLength}async doWriteBuffer(r,s,i,n,o,l){let m=0;for(;m<n;){const w=await r.write(s,o+m,i.buffer,l+m,n-m);m+=w}}async doWriteUnbuffered(r,s,i,n){return this.writeQueue.queueFor(s,()=>this.doWriteUnbufferedQueued(r,s,i,n),this.getExtUri(r).providerExtUri)}async doWriteUnbufferedQueued(r,s,i,n){let o;n instanceof A.VSBuffer?o=n:(0,c.isReadableStream)(n)?o=await(0,A.streamToBuffer)(n):(0,c.isReadableBufferedStream)(n)?o=await(0,A.bufferedStreamToBuffer)(n):o=(0,A.readableToBuffer)(n),await r.writeFile(s,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(r,s,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeBufferedQueued(r,s,i,n),this.getExtUri(i).providerExtUri)}async doPipeBufferedQueued(r,s,i,n){let o,l;try{o=await r.open(s,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const m=A.VSBuffer.alloc(this.BUFFER_SIZE);let w=0,C=0,b=0;do b=await r.read(o,w,m.buffer,C,m.byteLength-C),await this.doWriteBuffer(i,l,m,b,w,C),w+=b,C+=b,C===m.byteLength&&(C=0);while(b>0)}catch(m){throw(0,f.ensureFileSystemProviderError)(m)}finally{await a.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async doPipeUnbuffered(r,s,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedQueued(r,s,i,n),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedQueued(r,s,i,n){return i.writeFile(n,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(r,s,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedToBufferedQueued(r,s,i,n),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedToBufferedQueued(r,s,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const l=await r.readFile(s);await this.doWriteBuffer(i,o,A.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,f.ensureFileSystemProviderError)(l)}finally{await i.close(o)}}async doPipeBufferedToUnbuffered(r,s,i,n){const o=await(0,A.streamToBuffer)(this.readFileBuffered(r,s,L.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,o)}throwIfFileSystemIsReadonly(r,s){if(r.capabilities&f.FileSystemProviderCapabilities.Readonly)throw new f.FileOperationError((0,g.localize)(25,null,this.resourceForError(s)),f.FileOperationResult.FILE_PERMISSION_DENIED);return r}throwIfFileIsReadonly(r,s){if((s.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,g.localize)(26,null,this.resourceForError(r)),f.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(r){return r.scheme===S.Schemas.file?r.fsPath:r.toString(!0)}};e.FileService=v,e.FileService=v=d=we([Q(0,E.ILogService)],v)}),define(le[210],ue([0,1,43,280,6,35,15,3,42,2,14,5,21,51,31,172,7,100,208,40,205,204]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,a.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,I.toErrorMessage)(r)}`)}})();class t extends E.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=_.Event.None,this.resourceLocks=new L.ResourceMap(n=>u.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=f.FileSystemProviderCapabilities.FileReadWrite|f.FileSystemProviderCapabilities.FileOpenReadWriteClose|f.FileSystemProviderCapabilities.FileReadStream|f.FileSystemProviderCapabilities.FileFolderCopy|f.FileSystemProviderCapabilities.FileWriteUnlock|f.FileSystemProviderCapabilities.FileAtomicRead|f.FileSystemProviderCapabilities.FileAtomicWrite|f.FileSystemProviderCapabilities.FileAtomicDelete|f.FileSystemProviderCapabilities.FileClone,S.isLinux&&(this._capabilities|=f.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:n}=await c.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:f.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await c.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,u.joinPath)(s,o.name))).type:l=this.toType(o),n.push([o.name,l])}catch(l){this.logService.trace(l)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let n;return i?.dangling?n=f.FileType.Unknown:s.isFile()?n=f.FileType.File:s.isDirectory()?n=f.FileType.Directory:n=f.FileType.Unknown,i&&(n|=f.FileType.SymbolicLink),n}async createResourceLock(s){const i=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new A.Barrier;return this.resourceLocks.set(s,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,y.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(s)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(s,i){let n;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),n=await this.createResourceLock(s));const o=this.toFilePath(s);return await c.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{n?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,i,n){const o=(0,p.newWriteableStream)(l=>k.VSBuffer.concat(l.map(m=>k.VSBuffer.wrap(m))).buffer);return(0,h.readFileIntoStream)(this,s,o,l=>l.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(s,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,u.joinPath)((0,u.dirname)(s),`${(0,u.basename)(s)}${n.atomic.postfix}`),i,n):this.doWriteFile(s,i,n)}async canWriteFileAtomic(s){try{const i=this.toFilePath(s),{symbolicLink:n}=await c.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async doWriteFileAtomic(s,i,n,o){const l=new y.DisposableStore;try{l.add(await this.createResourceLock(s)),l.add(await this.createResourceLock(i)),await this.doWriteFile(i,n,o,!0);try{await this.rename(i,s,{overwrite:!0})}catch(m){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw m}}finally{l.dispose()}}async doWriteFile(s,i,n,o){let l;try{const m=this.toFilePath(s);if(!n.create||!n.overwrite){if(await c.Promises.exists(m)){if(!n.overwrite)throw(0,f.createFileSystemProviderError)((0,g.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,f.createFileSystemProviderError)((0,g.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(s,{create:!0,unlock:n.unlock},o),await this.write(l,0,i,0,i.byteLength)}catch(m){throw await this.toFileSystemProviderWriteError(s,m)}finally{typeof l=="number"&&await this.close(l)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,i,n){const o=this.toFilePath(s);let l;(0,f.isFileOpenForWriteOptions)(i)&&!n&&(l=await this.createResourceLock(s));let m;try{if((0,f.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:C}=await c.SymlinkSupport.stat(o);C.mode&128||await c.Promises.chmod(o,C.mode|128)}catch(C){C.code!=="ENOENT"&&this.logService.trace(C)}let w;if((0,f.isFileOpenForWriteOptions)(i)){if(S.isWindows)try{await c.Promises.truncate(o,0),w="r+"}catch(C){C.code!=="ENOENT"&&this.logService.trace(C)}w||(w="w")}else w="r";m=await c.Promises.open(o,w)}catch(w){throw l?.dispose(),(0,f.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,w):this.toFileSystemProviderError(w)}if(this.mapHandleToPos.set(m,0),(0,f.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(m,s),l){const w=this.mapHandleToLock.get(m);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${m} (${o})`),this.mapHandleToLock.set(m,l),w&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${m} (${o})`),w.dispose())}return m}async close(s){const i=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await c.Promises.fdatasync(s)}catch(n){t.configureFlushOnWrite(!1),this.logService.error(n)}return await c.Promises.close(s)}catch(n){throw this.toFileSystemProviderError(n)}finally{i&&(this.mapHandleToLock.get(s)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,n,o,l){const m=this.normalizePos(s,i);let w=null;try{w=(await c.Promises.read(s,n,o,l,m)).bytesRead}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(s,m,w)}return w}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,n){const o=this.mapHandleToPos.get(s);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(s,o+n):this.mapHandleToPos.delete(s)))}async write(s,i,n,o,l){return(0,A.retry)(()=>this.doWrite(s,i,n,o,l),100,3)}async doWrite(s,i,n,o,l){const m=this.normalizePos(s,i);let w=null;try{w=(await c.Promises.write(s,n,o,l,m)).bytesWritten}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),C)}finally{this.updatePos(s,m,w)}return w}async mkdir(s){try{await c.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const n=this.toFilePath(s);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,P.join)((0,P.dirname)(n),`${(0,P.basename)(n)}${i.atomic.postfix}`)),await c.Promises.rm(n,c.RimRafMode.MOVE,o)}else try{await c.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:m,symbolicLink:w}=await c.SymlinkSupport.stat(n);l=m.isDirectory()&&!w}catch{}if(l)await c.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(s,i,n){const o=this.toFilePath(s),l=this.toFilePath(i);if(o!==l)try{await this.validateMoveCopy(s,i,"move",n.overwrite),await c.Promises.rename(o,l)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,g.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(s,i,n){const o=this.toFilePath(s),l=this.toFilePath(i);if(o!==l)try{await this.validateMoveCopy(s,i,"copy",n.overwrite),await c.Promises.copy(o,l,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,g.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),m.toString()))),this.toFileSystemProviderError(m)}}async validateMoveCopy(s,i,n,o){const l=this.toFilePath(s),m=this.toFilePath(i);let w=!1;if(!!(this.capabilities&f.FileSystemProviderCapabilities.PathCaseSensitive)||(w=(0,T.isEqual)(l,m,!0)),w){if(n==="copy")throw(0,f.createFileSystemProviderError)((0,g.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const b=await this.statIgnoreError(s);if(!b)throw(0,f.createFileSystemProviderError)((0,g.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const R=await this.statIgnoreError(i);if(R){if(!o)throw(0,f.createFileSystemProviderError)((0,g.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);b.type&f.FileType.File&&R.type&f.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.doCloneFile(s,i,!1)}async doCloneFile(s,i,n){const o=this.toFilePath(s),l=this.toFilePath(i),m=!!(this.capabilities&f.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.isEqual)(o,l,!m))return;const w=new y.DisposableStore;try{w.add(await this.createResourceLock(s)),w.add(await this.createResourceLock(i)),n&&await c.Promises.mkdir((0,P.dirname)(l),{recursive:!0}),await c.Promises.copyFile(o,l)}catch(C){if(C.code==="ENOENT"&&!n)return this.doCloneFile(s,i,!0);throw this.toFileSystemProviderError(C)}finally{w.dispose()}}createUniversalWatcher(s,i,n){return new d.UniversalWatcherClient(o=>s(o),o=>i(o),n)}createNonRecursiveWatcher(s,i,n){return new v.NodeJSWatcherClient(o=>s(o),o=>i(o),n)}toFileSystemProviderError(s){if(s instanceof f.FileSystemProviderError)return s;let i=s,n;switch(s.code){case"ENOENT":n=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=f.FileSystemProviderErrorCode.Unknown;break;default:n=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(s,i){let n=this.toFileSystemProviderError(i);if(s&&n.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await c.SymlinkSupport.stat(this.toFilePath(s));o.mode&128||(n=(0,f.createFileSystemProviderError)(i,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return n}}e.DiskFileSystemProvider=t}),define(le[102],ue([0,1,3,2,4,10]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("sharedProcessLifecycleService");let k=class extends a.Disposable{constructor(T){super(),this.logService=T,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=k,e.SharedProcessLifecycleService=k=we([Q(0,L.ILogService)],k)}),define(le[211],ue([0,1,9,3,10,2]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class k extends A.AbstractLoggerService{constructor(S,u,p,c,g){super(u,p,c),this.windowId=S,this.channel=g,this._register(g.listen("onDidChangeLogLevel",S)(f=>{(0,A.isLogLevel)(f)?super.setLogLevel(f):super.setLogLevel(D.URI.revive(f[0]),f[1])})),this._register(g.listen("onDidChangeVisibility",S)(([f,h])=>super.setVisibility(D.URI.revive(f),h))),this._register(g.listen("onDidChangeLoggers",S)(({added:f,removed:h})=>{for(const E of f)super.registerLogger({...E,resource:D.URI.revive(E.resource)});for(const E of h)super.deregisterLogger(E.resource)}))}createConsoleMainLogger(){return new A.AdapterLogger({log:(S,u)=>{this.channel.call("consoleLog",[S,u])}})}registerLogger(S){super.registerLogger(S),this.channel.call("registerLogger",[S,this.windowId])}deregisterLogger(S){super.deregisterLogger(S),this.channel.call("deregisterLogger",[S,this.windowId])}setLogLevel(S,u){super.setLogLevel(S,u),this.channel.call("setLogLevel",[S,u])}setVisibility(S,u){super.setVisibility(S,u),this.channel.call("setVisibility",[this.toResource(S),u])}doCreateLogger(S,u,p){return new _(this.channel,S,u,p,this.windowId)}static setLogLevel(S,u,p){return S.call("setLogLevel",[u,p])}}e.LoggerChannelClient=k;class _ extends A.AbstractMessageLogger{constructor(S,u,p,c,g){super(c?.logLevel==="always"),this.channel=S,this.file=u,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(p),this.channel.call("createLogger",[u,c,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,u){const p=[[S,u]];this.isLoggerCreated?this.doLog(p):this.buffer.push(...p)}doLog(S){this.channel.call("log",[this.file,S])}}class T{constructor(S,u){this.loggerService=S,this.getUriTransformer=u}listen(S,u){const p=this.getUriTransformer(S);switch(u){case"onDidChangeLoggers":return a.Event.map(this.loggerService.onDidChangeLoggers,c=>({added:[...c.added].map(g=>this.transformLogger(g,p)),removed:[...c.removed].map(g=>this.transformLogger(g,p))}));case"onDidChangeVisibility":return a.Event.map(this.loggerService.onDidChangeVisibility,c=>[p.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return a.Event.map(this.loggerService.onDidChangeLogLevel,c=>(0,A.isLogLevel)(c)?c:[p.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${u}`)}async call(S,u,p){const c=this.getUriTransformer(S);switch(u){case"setLogLevel":return(0,A.isLogLevel)(p[0])?this.loggerService.setLogLevel(p[0]):this.loggerService.setLogLevel(D.URI.revive(c.transformIncoming(p[0][0])),p[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(g=>this.transformLogger(g,c)))}throw new Error(`Call not found: ${u}`)}transformLogger(S,u){return{...S,resource:u.transformOutgoingURI(S.resource)}}}e.LoggerChannel=T;class y extends L.Disposable{constructor(S,u){super(),u.call("setLogLevel",[S.getLogLevel()]),this._register(S.onDidChangeLogLevel(p=>u.call("setLogLevel",[p]))),u.call("getRegisteredLoggers").then(p=>{for(const c of p)S.registerLogger({...c,resource:D.URI.revive(c.resource)})}),this._register(u.listen("onDidChangeVisibility")(([p,c])=>S.setVisibility(D.URI.revive(p),c))),this._register(u.listen("onDidChangeLoggers")(({added:p,removed:c})=>{for(const g of p)S.registerLogger({...g,resource:D.URI.revive(g.resource)});for(const g of c)S.deregisterLogger(g.resource)}))}}e.RemoteLoggerChannelClient=y}),define(le[212],ue([0,1,2,10]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class A extends D.Disposable{constructor(k,_=[]){super(),this.logger=new a.MultiplexLogger([k,..._]),this._register(k.onDidChangeLogLevel(T=>this.setLevel(T)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(k){this.logger.setLevel(k)}getLevel(){return this.logger.getLevel()}trace(k,..._){this.logger.trace(k,..._)}debug(k,..._){this.logger.debug(k,..._)}info(k,..._){this.logger.info(k,..._)}warn(k,..._){this.logger.warn(k,..._)}error(k,..._){this.logger.error(k,..._)}flush(){this.logger.flush()}}e.LogService=A}),define(le[58],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(le[213],ue([0,1,44,57]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostService=void 0;let A=class{constructor(k,_){return this.windowId=k,D.ProxyChannel.toService(_.getChannel("nativeHost"),{context:k,properties:(()=>{const T=new Map;return T.set("windowId",k),T})()})}};e.NativeHostService=A,e.NativeHostService=A=we([Q(1,a.IMainProcessService)],A)}),define(le[59],ue([0,1,3,62,2,4]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class k extends A.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(y){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...y,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(y),a.Iterable.reduce(this.policies.entries(),(S,[u,p])=>({...S,[u]:p}),{})}getPolicyValue(y){return this.policies.get(y)}serialize(){return a.Iterable.reduce(Object.entries(this.policyDefinitions),(y,[P,S])=>({...y,[P]:{definition:S,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=k;class _{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=_}),define(le[214],ue([0,1,3,2,59]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(T){this.service=T,this.disposables=new a.DisposableStore}listen(T,y){switch(y){case"onDidChange":return D.Event.map(this.service.onDidChange,P=>P.reduce((S,u)=>({...S,[u]:this.service.getPolicyValue(u)??null}),{}),this.disposables)}throw new Error(`Event not found: ${y}`)}call(T,y,P){switch(y){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${y}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class k extends A.AbstractPolicyService{constructor(T,y){super(),this.channel=y;for(const P in T){const{definition:S,value:u}=T[P];this.policyDefinitions[P]=S,u!==void 0&&this.policies.set(P,u)}this.channel.listen("onDidChange")(P=>{for(const S in P){const u=P[S];u===null?this.policies.delete(S):this.policies.set(S,u)}this._onDidChange.fire(Object.keys(P))})}async _updatePolicyDefinitions(T){const y=await this.channel.call("updatePolicyDefinitions",T);for(const P in y)this.policies.set(P,y[P])}}e.PolicyChannelClient=k}),define(le[103],ue([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const L=A.context.configuration();if(L)a=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){a=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:L,searchUrl:k,itemUrl:_,controlUrl:T}=a.extensionsGallery||{};Object.assign(a,{extensionsGallery:{serviceUrl:D.env.VSCODE_GALLERY_SERVICE_URL||L,searchUrl:D.env.VSCODE_GALLERY_SEARCH_URL||k,itemUrl:D.env.VSCODE_GALLERY_ITEM_URL||_,controlUrl:D.env.VSCODE_GALLERY_CONTROL_URL||T}});try{const y=(...S)=>S.reduce((u,p)=>(Object.keys(p).forEach(c=>{Array.isArray(u[c])&&Array.isArray(p[c])?u[c]=p[c]:typeof u[c]=="object"&&typeof p[c]=="object"?u[c]=y(u[c],p[c]):u[c]=p[c]}),u),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};a=y(a,P)}catch{}if(D.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const y=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:y.version,release:y.release})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(le[24],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(le[215],ue([0,1,6,8,2,14,31,10,24]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let y=class extends A.Disposable{constructor(S,u,p){super(),this.productService=u,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(S)},3e4)).schedule()}async cleanUpCodeCaches(S){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const u=Date.now(),p=(0,L.dirname)(S),c=(0,L.basename)(S),g=await k.Promises.readdir(p);await Promise.all(g.map(async f=>{if(f===c)return;const h=(0,L.join)(p,f),E=await k.Promises.stat(h);if(E.isDirectory()&&u-E.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),k.Promises.rm(h)}))}catch(u){(0,a.onUnexpectedError)(u)}}};e.CodeCacheCleaner=y,e.CodeCacheCleaner=y=we([Q(1,T.IProductService),Q(2,_.ILogService)],y)}),define(le[216],ue([0,1,6,8,2,14,31,16,10,24]),function(ne,e,D,a,A,L,k,_,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends A.Disposable{constructor(u,p,c){super(),this.environmentService=u,this.logService=p,this.productService=c,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const u=Object.create(null),p=JSON.parse(await k.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const E of Object.keys(p)){const I=p[E];u[`${I.hash}.${E}`]=!0}const c=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(c))return;const f=await k.Promises.readdir(c);for(const E of f){if(u[E]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${E}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${E}`),await k.Promises.rm((0,L.join)(c,E))}const h=Date.now();for(const E of Object.keys(u)){const I=(0,L.join)(c,E),d=await k.Promises.readdir(I);for(const v of d){if(v==="tcf.json")continue;const t=(0,L.join)(I,v),r=await k.Promises.stat(t);r.isDirectory()&&h-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(E,v)}`),await k.Promises.rm(t))}}}catch(u){(0,a.onUnexpectedError)(u)}}};e.LanguagePackCachedDataCleaner=P,e.LanguagePackCachedDataCleaner=P=we([Q(0,_.INativeEnvironmentService),Q(1,T.ILogService),Q(2,y.IProductService)],P)}),define(le[217],ue([0,1,14,4]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,a.createDecorator)("IV8InspectProfilingService");var A;(function(L){function k(T){return!!(T.samples&&T.timeDeltas)}L.isValidProfile=k;function _(T,y="noAbsolutePaths"){for(const P of T.nodes)P.callFrame&&P.callFrame.url&&((0,D.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,D.join)(y,(0,D.basename)(P.callFrame.url)));return T}L.rewriteAbsolutePaths=_})(A||(e.Utils=A={}))}),define(le[218],ue([0,1,32]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class a{constructor(){this._sessions=new Map}async startProfiling(L){const _=await(await new Promise((y,P)=>{ne(["v8-inspect-profiler"],y,P)})).startProfiling({host:L.host,port:L.port,checkForPaused:!0}),T=(0,D.generateUuid)();return this._sessions.set(T,_),T}async stopProfiling(L){const k=this._sessions.get(L);if(!k)throw new Error(`UNKNOWN session '${L}'`);const _=await k.stop();return this._sessions.delete(L),_.profile}}e.InspectProfilingService=a}),define(le[45],ue([0,1,132,13]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(k,_){D.ok(a.isString(k)),D.ok(a.isObject(_)),D.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,_)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new A}),define(le[104],ue([0,1,3,45]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(_){return _.length>0&&_.charAt(_.length-1)==="#"?_.substring(0,_.length-1):_}class L{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(T,y){this.schemasById[A(T)]=y,this._onDidChangeSchema.fire(T)}notifySchemaChanged(T){this._onDidChangeSchema.fire(T)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new L;a.Registry.add(e.Extensions.JSONContribution,k)}),define(le[48],ue([0,1,19,3,13,159,22,104,45]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=g,e.keyFromOverrideIdentifiers=f,e.getDefaultValue=h,e.validateProperty=I,e.getScopes=d;var y;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=T.Registry.as(_.Extensions.JSONContribution);class u{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new a.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new a.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const s=new Set;this.doRegisterConfigurations(t,r,s),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const r=new Set;this.doDeregisterConfigurations(t,r),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:t,remove:r}){const s=new Set;this.doDeregisterConfigurations(r,s),this.doRegisterConfigurations(t,!1,s),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const r=new Set;this.doRegisterDefaultConfigurations(t,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,r){const s=[];for(const{overrides:i,source:n}of t)for(const o in i)if(r.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const l=this.configurationDefaultsOverrides.get(o),m=l?.valuesSources??new Map;if(n)for(const R of Object.keys(i[o]))m.set(R,n);const w={...l?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:n,value:w,valuesSources:m});const C=(0,k.getLanguageTagSettingPlainKey)(o),b={type:"object",default:w,description:L.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:A.isString(n)?void 0:n,defaultValueSource:n};s.push(...g(o)),this.configurationProperties[o]=b,this.defaultLanguageConfigurationOverridesNode.properties[o]=b}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:n});const l=this.configurationProperties[o];l&&(this.updatePropertyDefaultValue(o,l),this.updateSchema(o,l))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const r=new Set;this.doDeregisterDefaultConfigurations(t,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,r){for(const{overrides:s,source:i}of t)for(const n in s){const o=this.configurationDefaultsOverrides.get(n),l=A.isString(i)?i:i?.id,m=A.isString(o?.source)?o?.source:o?.source?.id;if(l===m)if(r.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const w=this.configurationProperties[n];w&&(this.updatePropertyDefaultValue(n,w),this.updateSchema(n,w))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let r=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),r=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),r=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const r of t)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,r,s){t.forEach(i=>{this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties,void 0,s),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,r){const s=i=>{if(i.properties)for(const n in i.properties){r.add(n);const o=this.configurationProperties[n];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n])}i.allOf?.forEach(n=>s(n))};for(const i of t){s(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(t,r=!0,s,i,n=P.WINDOW,o){n=A.isUndefinedOrNull(t.scope)?n:t.scope;const l=t.properties;if(l)for(const w in l){const C=l[w];if(r&&I(w,C)){delete l[w];continue}if(C.source=s,C.defaultDefaultValue=l[w].default,this.updatePropertyDefaultValue(w,C),e.OVERRIDE_PROPERTY_REGEX.test(w)?C.scope=void 0:(C.scope=A.isUndefinedOrNull(C.scope)?n:C.scope,C.restricted=A.isUndefinedOrNull(C.restricted)?!!i?.includes(w):C.restricted),l[w].hasOwnProperty("included")&&!l[w].included){this.excludedConfigurationProperties[w]=l[w],delete l[w];continue}else this.configurationProperties[w]=l[w],l[w].policy?.name&&this.policyConfigurations.set(l[w].policy.name,w);!l[w].deprecationMessage&&l[w].markdownDeprecationMessage&&(l[w].deprecationMessage=l[w].markdownDeprecationMessage),o.add(w)}const m=t.allOf;if(m)for(const w of m)this.validateAndRegisterProperties(w,r,s,i,n,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const r=s=>{const i=s.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);s.allOf?.forEach(r)};r(t)}updateSchema(t,r){switch(e.allSettings.properties[t]=r,r.scope){case P.APPLICATION:e.applicationSettings.properties[t]=r;break;case P.MACHINE:e.machineSettings.properties[t]=r;break;case P.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[t]=r;break;case P.WINDOW:e.windowSettings.properties[t]=r;break;case P.RESOURCE:e.resourceSettings.properties[t]=r;break;case P.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[t]=r,this.resourceLanguageSettingsSchema.properties[t]=r;break}}removeFromSchema(t,r){switch(delete e.allSettings.properties[t],r.scope){case P.APPLICATION:delete e.applicationSettings.properties[t];break;case P.MACHINE:delete e.machineSettings.properties[t];break;case P.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[t];break;case P.WINDOW:delete e.windowSettings.properties[t];break;case P.RESOURCE:case P.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const r=`[${t}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,s),e.allSettings.properties[r]=s,e.applicationSettings.properties[r]=s,e.machineSettings.properties[r]=s,e.machineOverridableSettings.properties[r]=s,e.windowSettings.properties[r]=s,e.resourceSettings.properties[r]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,r){const s=this.configurationDefaultsOverrides.get(t);let i=s?.value,n=s?.source;A.isUndefined(i)&&(i=r.defaultDefaultValue,n=void 0),A.isUndefined(i)&&(i=h(r.type)),r.default=i,r.defaultValueSource=n}}const p="\\[([^\\]]+)\\]",c=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(v){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let r=c.exec(v);for(;r?.length;){const s=r[1].trim();s&&t.push(s),r=c.exec(v)}}return(0,D.distinct)(t)}function f(v){return v.reduce((t,r)=>`${t}[${r}]`,"")}function h(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const E=new u;T.Registry.add(e.Extensions.Configuration,E);function I(v,t){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?L.localize(7,null,v):E.getConfigurationProperties()[v]!==void 0?L.localize(8,null,v):t.policy?.name&&E.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,v,t.policy?.name,E.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}function d(){const v=[],t=E.getConfigurationProperties();for(const r of Object.keys(t))v.push([r,t[r].scope]);return v.push(["launch",P.RESOURCE]),v.push(["task",P.RESOURCE]),v}}),define(le[78],ue([0,1,19,3,34,2,35,30,13,9,22,48,7,45]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=d;function c(s){return Object.isFrozen(s)?s:_.deepFreeze(s)}class g{static createEmptyModel(i){return new g({},[],[],void 0,i)}constructor(i,n,o,l,m){this._contents=i,this._keys=n,this._overrides=o,this.raw=l,this.logService=m,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof g)return n;const o=new f("",this.logService);return o.parseRaw(n),o.configurationModel});this._rawConfiguration=i.reduce((n,o)=>o===n?o:n.merge(o),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const o=this;return{get value(){return c(o.rawConfiguration.getValue(i))},get override(){return n?c(o.rawConfiguration.getOverrideValue(i,n)):void 0},get merged(){return c(n?o.rawConfiguration.override(n).getValue(i):o.rawConfiguration.getValue(i))},get overrides(){const l=[];for(const{contents:m,identifiers:w,keys:C}of o.rawConfiguration.overrides){const b=new g(m,C,[],void 0,o.logService).getValue(i);b!==void 0&&l.push({identifiers:w,value:b})}return l.length?c(l):void 0}}}getOverrideValue(i,n){const o=this.getContentsForOverrideIdentifer(n);return o?i?(0,P.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return D.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=_.deepClone(this.contents),o=_.deepClone(this.overrides),l=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const w of i)if(m.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.mergeContents(n,w.contents);for(const C of w.overrides){const[b]=o.filter(R=>D.equals(R.identifiers,C.identifiers));b?(this.mergeContents(b.contents,C.contents),b.keys.push(...C.keys),b.keys=D.distinct(b.keys)):o.push(_.deepClone(C))}for(const C of w.keys)l.indexOf(C)===-1&&l.push(C)}return new g(n,l,o,m.every(w=>w instanceof g)?void 0:m,this.logService)}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const l of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let m=this.contents[l];const w=n[l];w&&(typeof m=="object"&&typeof w=="object"?(m=_.deepClone(m),this.mergeContents(m,w)):m=w),o[l]=m}return new g(o,this.keys,this.overrides,void 0,this.logService)}mergeContents(i,n){for(const o of Object.keys(n)){if(o in i&&T.isObject(i[o])&&T.isObject(n[o])){this.mergeContents(i[o],n[o]);continue}i[o]=_.deepClone(n[o])}}getContentsForOverrideIdentifer(i){let n=null,o=null;const l=m=>{m&&(o?this.mergeContents(o,m):o=_.deepClone(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===i?n=m.contents:m.identifiers.includes(i)&&l(m.contents);return l(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.updateValue(i,n,!0)}setValue(i,n){this.updateValue(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,P.removeFromValueTree)(this.contents,i),S.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>D.equals(o.identifiers,(0,S.overrideIdentifiersFromKey)(i))),1))}updateValue(i,n,o){(0,P.addToValueTree)(this.contents,i,n,l=>this.logService.error(l)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),S.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,S.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,P.toValuesTree)(this.contents[i],l=>this.logService.error(l))})}}e.ConfigurationModel=g;class f{constructor(i,n){this._name=i,this.logService=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||g.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!T.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:o,keys:l,overrides:m,restricted:w,hasExcludedProperties:C}=this.doParseRaw(i,n);this._configurationModel=new g(o,l,m,C?[i]:void 0,this.logService),this._restrictedConfigurations=w||[]}doParseContent(i){let n={},o=null,l=[];const m=[],w=[];function C(R){Array.isArray(l)?l.push(R):o!==null&&(l[o]=R)}const b={onObjectBegin:()=>{const R={};C(R),m.push(l),l=R,o=null},onObjectProperty:R=>{o=R},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{const R=[];C(R),m.push(l),l=R,o=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:C,onError:(R,U,N)=>{w.push({error:R,offset:U,length:N})}};if(i)try{A.visit(i,b),n=l[0]||{}}catch(R){this.logService.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return n}doParseRaw(i,n){const o=p.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),l=this.filter(i,o,!0,n);i=l.raw;const m=(0,P.toValuesTree)(i,b=>this.logService.error(`Conflict in settings file ${this._name}: ${b}`)),w=Object.keys(i),C=this.toOverrides(i,b=>this.logService.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:m,keys:w,overrides:C,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}filter(i,n,o,l){let m=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:m};const w={},C=[];for(const b in i)if(S.OVERRIDE_PROPERTY_REGEX.test(b)&&o){const R=this.filter(i[b],n,!1,l);w[b]=R.raw,m=m||R.hasExcludedProperties,C.push(...R.restricted)}else{const R=n[b],U=R?typeof R.scope<"u"?R.scope:S.ConfigurationScope.WINDOW:void 0;R?.restricted&&C.push(b),!l.exclude?.includes(b)&&(l.include?.includes(b)||(U===void 0||l.scopes===void 0||l.scopes.includes(U))&&!(l.skipRestricted&&R?.restricted))?w[b]=i[b]:m=!0}return{raw:w,restricted:C,hasExcludedProperties:m}}toOverrides(i,n){const o=[];for(const l of Object.keys(i))if(S.OVERRIDE_PROPERTY_REGEX.test(l)){const m={};for(const w in i[l])m[w]=i[l][w];o.push({identifiers:(0,S.overrideIdentifiersFromKey)(l),keys:Object.keys(m),contents:(0,P.toValuesTree)(m,n)})}return o}}e.ConfigurationModelParser=f;class h extends L.Disposable{constructor(i,n,o,l,m){super(),this.userSettingsResource=i,this.parseOptions=n,this.fileService=l,this.logService=m,this._onDidChange=this._register(new a.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString(),m),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(a.Event.any(a.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource)),a.Event.filter(this.fileService.onDidRunOperation,w=>(w.isOperation(u.FileOperation.CREATE)||w.isOperation(u.FileOperation.COPY)||w.isOperation(u.FileOperation.DELETE)||w.isOperation(u.FileOperation.WRITE))&&o.isEqual(w.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return g.createEmptyModel(this.logService)}}reparse(i){return i&&(this.parseOptions=i),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class E{constructor(i,n,o,l,m,w,C,b,R,U,N,M,F){this.key=i,this.overrides=n,this._value=o,this.overrideIdentifiers=l,this.defaultConfiguration=m,this.policyConfiguration=w,this.applicationConfiguration=C,this.userConfiguration=b,this.localUserConfiguration=R,this.remoteUserConfiguration=U,this.workspaceConfiguration=N,this.folderConfigurationModel=M,this.memoryConfigurationModel=F}get value(){return c(this._value)}toInspectValue(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class I{constructor(i,n,o,l,m,w,C,b,R,U){this._defaultConfiguration=i,this._policyConfiguration=n,this._applicationConfiguration=o,this._localUserConfiguration=l,this._remoteUserConfiguration=m,this._workspaceConfiguration=w,this._folderConfigurations=C,this._memoryConfiguration=b,this._memoryConfigurationByResource=R,this.logService=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(i,n,o){return this.getConsolidatedConfigurationModel(i,n,o).getValue(i)}updateValue(i,n,o={}){let l;o.resource?(l=this._memoryConfigurationByResource.get(o.resource),l||(l=g.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(o.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(i):l.setValue(i,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,o){const l=this.getConsolidatedConfigurationModel(i,n,o),m=this.getFolderConfigurationModelForResource(n.resource,o),w=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,C=new Set;for(const b of l.overrides)for(const R of b.identifiers)l.getOverrideValue(i,R)!==void 0&&C.add(R);return new E(i,n,l.getValue(i),C.size?[...C]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this._workspaceConfiguration:void 0,m||void 0,w)}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:l,updated:m,removed:w}=t(this._defaultConfiguration,i);n=[...l,...m,...w]}for(const l of n)for(const m of(0,S.overrideIdentifiersFromKey)(l)){const w=this._defaultConfiguration.getKeysForOverrideIdentifier(m),C=i.getKeysForOverrideIdentifier(m),b=[...C.filter(R=>w.indexOf(R)===-1),...w.filter(R=>C.indexOf(R)===-1),...w.filter(R=>!_.equals(this._defaultConfiguration.override(m).getValue(R),i.override(m).getValue(R)))];o.push([m,b])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:o,removed:l}=t(this._policyConfiguration,i),m=[...n,...o,...l];return m.length&&this.updatePolicyConfiguration(i),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:o,removed:l,overrides:m}=t(this.applicationConfiguration,i),w=[...n,...o,...l];return w.length&&this.updateApplicationConfiguration(i),{keys:w,overrides:m}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:m}=t(this.localUserConfiguration,i),w=[...n,...o,...l];return w.length&&this.updateLocalUserConfiguration(i),{keys:w,overrides:m}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:m}=t(this.remoteUserConfiguration,i),w=[...n,...o,...l];return w.length&&this.updateRemoteUserConfiguration(i),{keys:w,overrides:m}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:l,overrides:m}=t(this.workspaceConfiguration,i),w=[...n,...o,...l];return w.length&&this.updateWorkspaceConfiguration(i),{keys:w,overrides:m}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:l,updated:m,removed:w,overrides:C}=t(o,n),b=[...l,...m,...w];return(b.length||!o)&&this.updateFolderConfiguration(i,n),{keys:b,overrides:C}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:l,removed:m,overrides:w}=t(n,void 0);return{keys:[...o,...l,...m],overrides:w}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,n,o){let l=this.getConsolidatedConfigurationModelForResource(n,o);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(l=l.merge(this._policyConfiguration)),l}getConsolidatedConfigurationModelForResource({resource:i},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const l=n.getFolder(i);l&&(o=this.getFolderConsolidatedConfiguration(l.uri)||o);const m=this._memoryConfigurationByResource.get(i);m&&(o=o.merge(m))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(i);l?(n=o.merge(l),this._foldersConsolidatedConfigurations.set(i,n)):n=o}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:o,overrides:l,keys:m}=this._folderConfigurations.get(n);return i.push([n,{contents:o,overrides:l,keys:m}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this._workspaceConfiguration.keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(l=>n.add(l))),[...n.values()]}static parse(i,n){const o=this.parseConfigurationModel(i.defaults,n),l=this.parseConfigurationModel(i.policy,n),m=this.parseConfigurationModel(i.application,n),w=this.parseConfigurationModel(i.user,n),C=this.parseConfigurationModel(i.workspace,n),b=i.folders.reduce((R,U)=>(R.set(y.URI.revive(U[0]),this.parseConfigurationModel(U[1],n)),R),new k.ResourceMap);return new I(o,l,m,w,g.createEmptyModel(n),C,b,g.createEmptyModel(n),new k.ResourceMap,n)}static parseConfigurationModel(i,n){return new g(i.contents,i.keys,i.overrides,void 0,n)}}e.Configuration=I;function d(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const l of s)l.keys.forEach(m=>i.add(m)),l.overrides.forEach(([m,w])=>{const C=(0,k.getOrSet)(n,m,new Set);w.forEach(b=>C.add(b))});const o=[];return n.forEach((l,m)=>o.push([m,[...l.values()]])),{keys:[...i.values()],overrides:o}}class v{constructor(i,n,o,l,m){this.change=i,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=l,this.logService=m,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const w of i.keys)this.affectedKeys.add(w);for(const[,w]of i.overrides)for(const C of w)this.affectedKeys.add(C);this._affectsConfigStr=this._marker;for(const w of this.affectedKeys)this._affectsConfigStr+=w+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(i,n){const o=this._marker+i,l=this._affectsConfigStr.indexOf(o);if(l<0)return!1;const m=l+o.length;if(m>=this._affectsConfigStr.length)return!1;const w=this._affectsConfigStr.charCodeAt(m);if(w!==this._markerCode1&&w!==this._markerCode2)return!1;if(n){const C=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,b=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!_.equals(C,b)}return!0}}e.ConfigurationChangeEvent=v;function t(s,i){const{added:n,removed:o,updated:l}=r(i?.rawConfiguration,s?.rawConfiguration),m=[],w=s?.getAllOverrideIdentifiers()||[],C=i?.getAllOverrideIdentifiers()||[];if(i){const b=C.filter(R=>!w.includes(R));for(const R of b)m.push([R,i.getKeysForOverrideIdentifier(R)])}if(s){const b=w.filter(R=>!C.includes(R));for(const R of b)m.push([R,s.getKeysForOverrideIdentifier(R)])}if(i&&s){for(const b of w)if(C.includes(b)){const R=r({contents:s.getOverrideValue(void 0,b)||{},keys:s.getKeysForOverrideIdentifier(b)},{contents:i.getOverrideValue(void 0,b)||{},keys:i.getKeysForOverrideIdentifier(b)});m.push([b,[...R.added,...R.removed,...R.updated]])}}return{added:n,removed:o,updated:l,overrides:m}}function r(s,i){const n=s?i?s.keys.filter(m=>i.keys.indexOf(m)===-1):[...s.keys]:[],o=i?s?i.keys.filter(m=>s.keys.indexOf(m)===-1):[...i.keys]:[],l=[];if(s&&i){for(const m of i.keys)if(s.keys.indexOf(m)!==-1){const w=(0,P.getConfigurationValue)(i.contents,m),C=(0,P.getConfigurationValue)(s.contents,m);_.equals(w,C)||l.push(m)}}return{added:n,removed:o,updated:l}}}),define(le[219],ue([0,1,19,3,2,30,13,78,48,10,59,45]),function(ne,e,D,a,A,L,k,_,T,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class u extends A.Disposable{get configurationModel(){return this._configurationModel}constructor(f){super(),this.logService=f,this._onDidChangeConfiguration=this._register(new a.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=_.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(S.Registry.as(T.Extensions.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:h})=>this.onDidUpdateConfiguration(Array.from(f),h))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(f,h){this.updateConfigurationModel(f,S.Registry.as(T.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:f})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=_.ConfigurationModel.createEmptyModel(this.logService);const f=S.Registry.as(T.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(f),f)}updateConfigurationModel(f,h){const E=this.getConfigurationDefaultOverrides();for(const I of f){const d=E[I],v=h[I];d!==void 0?this._configurationModel.addValue(I,d):v?this._configurationModel.addValue(I,v.default):this._configurationModel.removeValue(I)}}}e.DefaultConfiguration=u;class p{constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=_.ConfigurationModel.createEmptyModel(new y.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=p;let c=class extends A.Disposable{get configurationModel(){return this._configurationModel}constructor(f,h,E){super(),this.defaultConfiguration=f,this.policyService=h,this.logService=E,this._onDidChangeConfiguration=this._register(new a.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=_.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(f=>this.onDidChangePolicies(f))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:f})=>this.update(await this.updatePolicyDefinitions(f),!0))),this._configurationModel}async updatePolicyDefinitions(f){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",f);const h={},E=[],I=S.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(const d of f){const v=I[d];if(!v){E.push(d);continue}if(v.policy){if(v.type!=="string"&&v.type!=="number"){this.logService.warn(`Policy ${v.policy.name} has unsupported type ${v.type}`);continue}E.push(d),h[v.policy.name]={type:v.type}}}return(0,k.isEmptyObject)(h)||await this.policyService.updatePolicyDefinitions(h),E}onDidChangePolicies(f){this.logService.trace("PolicyConfiguration#onDidChangePolicies",f);const h=S.Registry.as(T.Extensions.Configuration).getPolicyConfigurations(),E=(0,D.coalesce)(f.map(I=>h.get(I)));this.update(E,!0)}update(f,h){this.logService.trace("PolicyConfiguration#update",f);const E=S.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),I=[],d=this._configurationModel.isEmpty();for(const v of f){const t=E[v]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(d?r!==void 0:!(0,L.equals)(this._configurationModel.getValue(v),r))&&I.push([v,r])}else this._configurationModel.getValue(v)!==void 0&&I.push([v,void 0])}if(I.length){this.logService.trace("PolicyConfiguration#changed",I);const v=this._configurationModel;this._configurationModel=_.ConfigurationModel.createEmptyModel(this.logService);for(const t of v.keys)this._configurationModel.setValue(t,v.getValue(t));for(const[t,r]of I)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);h&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=c,e.PolicyConfiguration=c=we([Q(1,P.IPolicyService),Q(2,y.ILogService)],c)}),define(le[220],ue([0,1,19,6,15,3,34,63,2,35,30,5,21,22,78,48,219,7,59]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends T.Disposable{constructor(t,r,s,i){super(),this.settingsResource=t,this.logService=i,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new f.DefaultConfiguration(i)),this.policyConfiguration=s instanceof E.NullPolicyService?new f.NullPolicyConfiguration:this._register(new f.PolicyConfiguration(this.defaultConfiguration,s,i)),this.userConfiguration=this._register(new c.UserSettings(this.settingsResource,{},u.extUriBiasedIgnorePathCase,r,i)),this.configuration=new c.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,c.ConfigurationModel.createEmptyModel(i),c.ConfigurationModel.createEmptyModel(i),c.ConfigurationModel.createEmptyModel(i),c.ConfigurationModel.createEmptyModel(i),new y.ResourceMap,c.ConfigurationModel.createEmptyModel(i),new y.ResourceMap,i),this.configurationEditing=new d(t,r,this),this.reloadConfigurationScheduler=this._register(new a.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:n,properties:o})=>this.onDidDefaultConfigurationChange(n,o))),this._register(this.policyConfiguration.onDidChangeConfiguration(n=>this.onDidPolicyConfigurationChange(n))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[t,r,s]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new c.Configuration(t,r,c.ConfigurationModel.createEmptyModel(this.logService),s,c.ConfigurationModel.createEmptyModel(this.logService),c.ConfigurationModel.createEmptyModel(this.logService),new y.ResourceMap,c.ConfigurationModel.createEmptyModel(this.logService),new y.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(t,r){const s=typeof t=="string"?t:void 0,i=(0,p.isConfigurationOverrides)(t)?t:(0,p.isConfigurationOverrides)(r)?r:{};return this.configuration.getValue(s,i,void 0)}async updateValue(t,r,s,i,n){const o=(0,p.isConfigurationUpdateOverrides)(s)?s:(0,p.isConfigurationOverrides)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,l=o?i:s;if(l!==void 0&&l!==p.ConfigurationTarget.USER_LOCAL&&l!==p.ConfigurationTarget.USER)throw new Error(`Unable to write ${t} to target ${l}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,D.distinct)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const m=this.inspect(t,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(m.policyValue!==void 0)throw new Error(`Unable to write ${t} because it is configured in system policy.`);if((0,P.equals)(r,m.defaultValue)&&(r=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const C=o.overrideIdentifiers.sort(),b=this.configuration.localUserConfiguration.overrides.find(R=>(0,D.equals)([...R.identifiers].sort(),C));b&&(o.overrideIdentifiers=b.identifiers)}const w=o?.overrideIdentifiers?.length?[(0,g.keyFromOverrideIdentifiers)(o.overrideIdentifiers),t]:[t];await this.configurationEditing.write(w,r),await this.reloadConfiguration()}inspect(t,r={}){return this.configuration.inspect(t,r,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const t=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(t)}onDidChangeUserConfiguration(t){const r=this.configuration.toData(),s=this.configuration.compareAndUpdateLocalUserConfiguration(t);this.trigger(s,r,p.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(t,r){const s=this.configuration.toData(),i=this.configuration.compareAndUpdateDefaultConfiguration(t,r);this.trigger(i,s,p.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(t){const r=this.configuration.toData(),s=this.configuration.compareAndUpdatePolicyConfiguration(t);this.trigger(s,r,p.ConfigurationTarget.DEFAULT)}trigger(t,r,s){const i=new c.ConfigurationChangeEvent(t,{data:r},this.configuration,void 0,this.logService);i.source=s,this._onDidChangeConfiguration.fire(i)}}e.ConfigurationService=I;class d{constructor(t,r,s){this.settingsResource=t,this.fileService=r,this.configurationService=s,this.queue=new a.Queue}write(t,r){return this.queue.queue(()=>this.doWriteConfiguration(t,r))}async doWriteConfiguration(t,r){let s;try{s=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(o){if(o.fileOperationResult===h.FileOperationResult.FILE_NOT_FOUND)s="{}";else throw o}const i=[];if((0,k.parse)(s,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.getEdits(s,t,r);s=(0,_.applyEdits)(s,n),await this.fileService.writeFile(this.settingsResource,A.VSBuffer.fromString(s))}getEdits(t,r,s){const{tabSize:i,insertSpaces:n,eol:o}=this.formattingOptions;if(!r.length){const l=JSON.stringify(s,null,n?" ".repeat(i):"	");return[{content:l,length:l.length,offset:0}]}return(0,_.setProperty)(t,r,s,{tabSize:i,insertSpaces:n,eol:o})}get formattingOptions(){if(!this._formattingOptions){let t=S.OS===S.OperatingSystem.Linux||S.OS===S.OperatingSystem.Macintosh?`
`:`\r
`;const r=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});r&&typeof r=="string"&&r!=="auto"&&(t=r),this._formattingOptions={eol:t,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(le[221],ue([0,1,15,3,2,70]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=_;const k=(y,P,S)=>{const u=new Uint8Array(16);for(let g=0;g<16;g++)u[g]=Math.round(Math.random()*256);const p=(0,D.encodeBase64)(D.VSBuffer.wrap(u));return[`GET ws://localhost${y}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=k,e.socketRawEndHeaderSequence=D.VSBuffer.fromString(`\r
\r
`);async function _(y,P,S,u,p){y.write(D.VSBuffer.fromString((0,e.makeRawSocketHeaders)(P,S,u)));const c=new A.DisposableStore;try{return await new Promise((g,f)=>{let h;c.add(y.onData(E=>{h?h=D.VSBuffer.concat([h,E],h.byteLength+E.byteLength):h=E;const I=h.indexOf(e.socketRawEndHeaderSequence);if(I===-1)return;g(y),y.pauseData();const d=h.slice(I+e.socketRawEndHeaderSequence.byteLength);d.byteLength&&p.onData.fire(d)})),c.add(y.onClose(E=>f(E??new Error("socket closed")))),c.add(y.onEnd(()=>f(new Error("socket ended"))))})}catch(g){throw y.dispose(),g}finally{c.dispose()}}class T extends A.Disposable{constructor(P,S){super(),this.debugLabel=P,this.pausableDataEmitter=this._register(new a.PauseableEmitter),this.onData=(...u)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...u)),this.didDisposeEmitter=this._register(new a.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(S.onData),this._register(S.onData.event(u=>this.pausableDataEmitter.fire(u))),this.onClose=this._register(S.onClose).event,this.onEnd=this._register(S.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(P,S){L.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,P,S)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=T}),define(le[105],ue([0,1,8,4]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=y,e.IRemoteAuthorityResolverService=(0,a.createDecorator)("remoteAuthorityResolverService");var A;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class L{constructor(S){this.id=S,this.type=A.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=L;class k{constructor(S,u){this.host=S,this.port=u,this.type=A.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=k;var _;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(_||(e.RemoteAuthorityResolverErrorCode=_={}));class T extends D.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof T&&S._code===_.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof T&&S._code===_.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof T&&S._code===_.NoResolverFound}static isInvalidAuthority(S){return S instanceof T&&S._code===_.InvalidAuthority}static isHandled(S){return S instanceof T&&S.isHandled}constructor(S,u=_.Unknown,p){super(S),this._message=S,this._code=u,this._detail=p,this.isHandled=u===_.NotAvailable&&p===!0,Object.setPrototypeOf(this,T.prototype)}}e.RemoteAuthorityResolverError=T;function y(P){const S=P.indexOf("+");return S===-1?P:P.substring(0,S)}}),define(le[222],ue([0,1,6,15,26,8,3,2,23,101,65,32,70,105]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=m,e.connectRemoteAgentExtensionHost=w,e.connectRemoteAgentTunnel=b;const c=30*1e3;var g;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function f(G){switch(G){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function h(G){const V=new A.CancellationTokenSource;return setTimeout(()=>V.cancel(),G),V.token}function E(G,V){if(G.isCancellationRequested||V.isCancellationRequested)return A.CancellationToken.Cancelled;const O=new A.CancellationTokenSource;return G.onCancellationRequested(()=>O.cancel()),V.onCancellationRequested(()=>O.cancel()),O.token}class I{get didTimeout(){return this._state==="timedout"}constructor(V){this._state="pending",this._disposables=new _.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,D.promiseWithResolvers)(),V.isCancellationRequested?this._timeout():this._disposables.add(V.onCancellationRequested(()=>this._timeout()))}registerDisposable(V){this._state==="pending"?this._disposables.add(V):V.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(V))}reject(V){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(V))}}function d(G,V){const O=new I(V);return O.registerDisposable(G.onControlMessage($=>{const x=JSON.parse($.toString()),q=B(x);q?O.reject(q):O.resolve(x)})),O.promise}function v(G,V,O,$,x,q,te,Z){const Y=new I(Z),ae=P.StopWatch.create(!1);return G.info(`Creating a socket (${te})...`),y.mark(`code/willCreateSocket/${q}`),V.connect(O,$,x,te).then(he=>{Y.didTimeout?(y.mark(`code/didCreateSocketError/${q}`),G.info(`Creating a socket (${te}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(y.mark(`code/didCreateSocketOK/${q}`),G.info(`Creating a socket (${te}) was successful after ${ae.elapsed()} ms.`),Y.resolve(he))},he=>{y.mark(`code/didCreateSocketError/${q}`),G.info(`Creating a socket (${te}) returned an error after ${ae.elapsed()} ms.`),G.error(he),Y.reject(he)}),Y.promise}function t(G,V){const O=new I(V);return G.then($=>{O.didTimeout||O.resolve($)},$=>{O.didTimeout||O.reject($)}),O.promise}async function r(G,V,O,$){const x=W(G,V);G.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let q;try{q=await v(G.logService,G.remoteSocketFactoryService,G.connectTo,T.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,f(V),`renderer-${f(V)}-${G.reconnectionToken}`,$)}catch(he){throw G.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),G.logService.error(he),he}G.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let te,Z;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(q,null),te=G.reconnectionProtocol,Z=!1):(te=new u.PersistentProtocol({socket:q}),Z=!0),G.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const Y=await t(G.signService.createNewMessage((0,S.generateUuid)()),$),ae={type:"auth",auth:G.connectionToken||"00000000000000000000",data:Y.data};te.sendControl(a.VSBuffer.fromString(JSON.stringify(ae)));try{const he=await d(te,E($,h(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const pe=new Error("Unexpected handshake message");throw pe.code="VSCODE_CONNECTION_ERROR",pe}if(G.logService.trace(`${x} 4/6. received SignRequest control message.`),!await t(G.signService.validate(Y,he.signedData),$)){const pe=new Error("Refused to connect to unsupported server");throw pe.code="VSCODE_CONNECTION_ERROR",pe}const ve=await t(G.signService.sign(he.data),$),Ie={type:"connectionType",commit:G.commit,signedData:ve,desiredConnectionType:V};return O&&(Ie.args=O),G.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(a.VSBuffer.fromString(JSON.stringify(Ie))),{protocol:te,ownsProtocol:Z}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(G.logService.error(`${x} the handshake timed out. Error:`),G.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${x} received error control message when negotiating connection. Error:`),G.logService.error(he)),Z&&z(te),he}}async function s(G,V,O,$){const x=Date.now(),q=W(G,V),{protocol:te,ownsProtocol:Z}=await r(G,V,O,$),Y=new I($);return Y.registerDisposable(te.onControlMessage(ae=>{const he=JSON.parse(ae.toString()),ge=B(he);ge?(G.logService.error(`${q} received error control message when negotiating connection. Error:`),G.logService.error(ge),Z&&z(te),Y.reject(ge)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${J(x)}!`),Y.resolve({protocol:te,firstMessage:he}))})),Y.promise}async function i(G,V){const{protocol:O}=await s(G,g.Management,void 0,V);return{protocol:O}}async function n(G,V,O){const{protocol:$,firstMessage:x}=await s(G,g.ExtensionHost,V,O),q=x&&x.debugPort;return{protocol:$,debugPort:q}}async function o(G,V,O){const $=Date.now(),x=W(G,g.Tunnel),{protocol:q}=await r(G,g.Tunnel,V,O);return G.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${J($)}!`),q}async function l(G,V,O){const{connectTo:$,connectionToken:x}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:$,connectionToken:x,reconnectionToken:V,reconnectionProtocol:O,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function m(G,V,O){return C(G,async $=>{const{protocol:x}=await i($,A.CancellationToken.None);return new j(G,V,O,$.reconnectionToken,x)})}async function w(G,V){return C(G,async O=>{const{protocol:$,debugPort:x}=await n(O,V,A.CancellationToken.None);return new ie(G,V,O.reconnectionToken,$,x)})}async function C(G,V){for(let $=1;;$++)try{const x=(0,S.generateUuid)(),q=await l(G,x,null);return await V(q)}catch(x){if($<5)G.logService.error(`[remote-connection][attempt ${$}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(x);else throw G.logService.error(`[remote-connection][attempt ${$}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(x),X.triggerPermanentFailure(0,0,p.RemoteAuthorityResolverError.isHandled(x)),x}}async function b(G,V,O){const $=await l(G,(0,S.generateUuid)(),null);return await o($,{host:V,port:O},A.CancellationToken.None)}function R(G){return(0,D.createCancelablePromise)(V=>new Promise((O,$)=>{const x=setTimeout(O,G*1e3);V.onCancellationRequested(()=>{clearTimeout(x),O()})}))}var U;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class N{constructor(V,O){this.reconnectionToken=V,this.millisSinceLastIncomingData=O,this.type=U.ConnectionLost}}e.ConnectionLostEvent=N;class M{constructor(V,O,$,x){this.reconnectionToken=V,this.millisSinceLastIncomingData=O,this.durationSeconds=$,this.cancellableTimer=x,this.type=U.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=M;class F{constructor(V,O,$){this.reconnectionToken=V,this.millisSinceLastIncomingData=O,this.attempt=$,this.type=U.ReconnectionRunning}}e.ReconnectionRunningEvent=F;class K{constructor(V,O,$){this.reconnectionToken=V,this.millisSinceLastIncomingData=O,this.attempt=$,this.type=U.ConnectionGain}}e.ConnectionGainEvent=K;class H{constructor(V,O,$,x){this.reconnectionToken=V,this.millisSinceLastIncomingData=O,this.attempt=$,this.handled=x,this.type=U.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=H;class X extends _.Disposable{static triggerPermanentFailure(V,O,$){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=V,this._permanentFailureAttempt=O,this._permanentFailureHandled=$,this._instances.forEach(x=>x._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(V=>V._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(V=>V._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||X._permanentFailure}constructor(V,O,$,x,q){super(),this._connectionType=V,this._options=O,this.reconnectionToken=$,this.protocol=x,this._reconnectionFailureIsFatal=q,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new K(this.reconnectionToken,0,0)),this._register(x.onSocketClose(te=>{const Z=ce(this._connectionType,this.reconnectionToken,!0);te?te.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${Z} received socket close event (hadError: ${te.hadError}).`),te.error&&this._options.logService.error(te.error)):(this._options.logService.info(`${Z} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this._options.logService.error(te.event)):this._options.logService.info(`${Z} received socket close event.`),this._beginReconnecting()})),this._register(x.onSocketTimeout(te=>{const Z=ce(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),X._instances.push(this),this._register((0,_.toDisposable)(()=>{const te=X._instances.indexOf(this);te>=0&&X._instances.splice(te,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(X._permanentFailureMillisSinceLastIncomingData,X._permanentFailureAttempt,X._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const V=ce(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let $=-1;do{$++;const x=$<O.length?O[$]:O[O.length-1];try{if(x>0){const te=R(x);this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,te)),this._options.logService.info(`${V} waiting for ${x} seconds before reconnecting...`);try{await te}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1)),this._options.logService.info(`${V} resolving connection...`);const q=await l(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${V} connecting to ${q.connectTo}...`),await this._reconnect(q,h(c)),this._options.logService.info(`${V} reconnected!`),this._onDidStateChange.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if($>360){this._options.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if(p.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this._options.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this._options.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((0,L.isCancellationError)(q)){this._options.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(q instanceof p.RemoteAuthorityResolverError){this._options.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,p.RemoteAuthorityResolverError.isHandled(q));break}this._options.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(V,O,$){this._reconnectionFailureIsFatal?X.triggerPermanentFailure(V,O,$):this._gotoPermanentFailure(V,O,$)}_gotoPermanentFailure(V,O,$){this._onDidStateChange.fire(new H(this.reconnectionToken,V,O,$)),z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=X;class j extends X{constructor(V,O,$,x,q){super(g.Management,V,x,q,!0),this.client=this._register(new u.Client(q,{remoteAuthority:O,clientId:$},V.ipcLogger))}async _reconnect(V,O){await i(V,O)}}e.ManagementPersistentConnection=j;class ie extends X{constructor(V,O,$,x,q){super(g.ExtensionHost,V,$,x,!1),this._startArguments=O,this.debugPort=q}async _reconnect(V,O){await n(V,this._startArguments,O)}}e.ExtensionHostPersistentConnection=ie;function z(G){try{G.acceptDisconnect();const V=G.getSocket();G.dispose(),V.dispose()}catch(V){(0,L.onUnexpectedError)(V)}}function B(G){if(G&&G.type==="error"){const V=new Error(`Connection error: ${G.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function ee(G,V){for(;G.length<V;)G+=" ";return G}function se(G,V){return`[remote-connection][${ee(f(G),13)}][${V.substr(0,5)}\u2026]`}function ce(G,V,O){return`${se(G,V)}[${O?"reconnect":"initial"}]`}function W(G,V){return`${ce(V,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function J(G){return`${Date.now()-G} ms`}}),define(le[106],ue([0,1,23]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=a,e.getRemoteName=A,e.parseAuthorityWithPort=L,e.parseAuthorityWithOptionalPort=k;function a(T){return T.scheme===D.Schemas.vscodeRemote?T.authority:void 0}function A(T){if(!T)return;const y=T.indexOf("+");return y<0?T:T.substr(0,y)}function L(T){const{host:y,port:P}=_(T);if(typeof P>"u")throw new Error(`Invalid remote authority: ${T}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:P}}function k(T,y){let{host:P,port:S}=_(T);return typeof S>"u"&&(S=y),{host:P,port:S}}function _(T){const y=T.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const P=T.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const S=T.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:T,port:void 0}}}),define(le[37],ue([0,1,27,4,106]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=L,e.isApplicationScopedExtension=S,e.isLanguagePackExtension=u,e.isAuthenticationProviderExtension=p,e.isResolverExtension=c,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var k;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(k||(e.ExtensionType=k={}));var _;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.LINUX_PPC64LE="linux-ppc64le",g.LINUX_RISCV64="linux-riscv64",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(_||(e.TargetPlatform=_={}));class T{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,h){if(typeof f>"u"||f===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof f=="string"||typeof h=="string"){const E=typeof f=="string"?f:f.value,I=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(E,I)}return f._lower===h._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=T;class y{get size(){return this._set.size}constructor(f){if(this._set=new Set,f)for(const h of f)this.add(h)}add(f){this._set.add(T.toKey(f))}delete(f){return this._set.delete(T.toKey(f))}has(f){return this._set.has(T.toKey(f))}}e.ExtensionIdentifierSet=y;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(f){this._map.delete(T.toKey(f))}get(f){return this._map.get(T.toKey(f))}has(f){return this._map.has(T.toKey(f))}set(f,h){this._map.set(T.toKey(f),h)}values(){return this._map.values()}forEach(f){this._map.forEach(f)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function S(g){return u(g)}function u(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}function p(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}function c(g,f){if(f){const h=`onResolveRemoteAuthority:${(0,A.getRemoteName)(f)}`;return!!g.activationEvents?.includes(h)}return!1}e.IBuiltinExtensionsScannerService=(0,a.createDecorator)("IBuiltinExtensionsScannerService")}),define(le[28],ue([0,1,5,163,37,4]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=_,e.toTargetPlatform=T,e.getTargetPlatform=y,e.isNotWebExtensionInWebTargetPlatform=P,e.isTargetPlatformCompatible=S,e.isIExtensionIdentifier=u,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var k;(function(v){v.COMMAND="command",v.SETTINGS_SYNC="settingsSync"})(k||(e.ExtensionInstallSource=k={}));function _(v){switch(v){case A.TargetPlatform.WIN32_X64:return"Windows 64 bit";case A.TargetPlatform.WIN32_ARM64:return"Windows ARM";case A.TargetPlatform.LINUX_X64:return"Linux 64 bit";case A.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case A.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case A.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case A.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case A.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case A.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case A.TargetPlatform.DARWIN_X64:return"Mac";case A.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case A.TargetPlatform.WEB:return"Web";case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;case A.TargetPlatform.UNKNOWN:return A.TargetPlatform.UNKNOWN;case A.TargetPlatform.UNDEFINED:return A.TargetPlatform.UNDEFINED}}function T(v){switch(v){case A.TargetPlatform.WIN32_X64:return A.TargetPlatform.WIN32_X64;case A.TargetPlatform.WIN32_ARM64:return A.TargetPlatform.WIN32_ARM64;case A.TargetPlatform.LINUX_X64:return A.TargetPlatform.LINUX_X64;case A.TargetPlatform.LINUX_ARM64:return A.TargetPlatform.LINUX_ARM64;case A.TargetPlatform.LINUX_ARMHF:return A.TargetPlatform.LINUX_ARMHF;case A.TargetPlatform.LINUX_PPC64LE:return A.TargetPlatform.LINUX_PPC64LE;case A.TargetPlatform.LINUX_RISCV64:return A.TargetPlatform.LINUX_RISCV64;case A.TargetPlatform.ALPINE_X64:return A.TargetPlatform.ALPINE_X64;case A.TargetPlatform.ALPINE_ARM64:return A.TargetPlatform.ALPINE_ARM64;case A.TargetPlatform.DARWIN_X64:return A.TargetPlatform.DARWIN_X64;case A.TargetPlatform.DARWIN_ARM64:return A.TargetPlatform.DARWIN_ARM64;case A.TargetPlatform.WEB:return A.TargetPlatform.WEB;case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;default:return A.TargetPlatform.UNKNOWN}}function y(v,t){switch(v){case D.Platform.Windows:return t==="x64"?A.TargetPlatform.WIN32_X64:t==="arm64"?A.TargetPlatform.WIN32_ARM64:A.TargetPlatform.UNKNOWN;case D.Platform.Linux:return t==="x64"?A.TargetPlatform.LINUX_X64:t==="arm64"?A.TargetPlatform.LINUX_ARM64:t==="arm"?A.TargetPlatform.LINUX_ARMHF:t==="ppc64le"?A.TargetPlatform.LINUX_PPC64LE:t==="riscv64"?A.TargetPlatform.LINUX_RISCV64:A.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?A.TargetPlatform.ALPINE_X64:t==="arm64"?A.TargetPlatform.ALPINE_ARM64:A.TargetPlatform.UNKNOWN;case D.Platform.Mac:return t==="x64"?A.TargetPlatform.DARWIN_X64:t==="arm64"?A.TargetPlatform.DARWIN_ARM64:A.TargetPlatform.UNKNOWN;case D.Platform.Web:return A.TargetPlatform.WEB}}function P(v,t){return t===A.TargetPlatform.WEB&&!v.includes(A.TargetPlatform.WEB)}function S(v,t,r){return P(t,r)?!1:v===A.TargetPlatform.UNDEFINED||v===A.TargetPlatform.UNIVERSAL?!0:v===A.TargetPlatform.UNKNOWN?!1:v===r}function u(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}var p;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=10]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var c;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var g;(function(v){v.Install="install",v.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var f;(function(v){v[v.None=1]="None",v[v.Install=2]="Install",v[v.Update=3]="Update",v[v.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var h;(function(v){v.Timeout="Timeout",v.Cancelled="Cancelled",v.Failed="Failed",v.DownloadFailedWriting="DownloadFailedWriting"})(h||(e.ExtensionGalleryErrorCode=h={}));class E extends Error{constructor(t,r){super(t),this.code=r,this.name=r}}e.ExtensionGalleryError=E;var I;(function(v){v.Unsupported="Unsupported",v.Deprecated="Deprecated",v.Malicious="Malicious",v.Incompatible="Incompatible",v.IncompatibleTargetPlatform="IncompatibleTargetPlatform",v.ReleaseVersionNotFound="ReleaseVersionNotFound",v.Invalid="Invalid",v.Download="Download",v.DownloadSignature="DownloadSignature",v.DownloadFailedWriting="DownloadFailedWriting",v.UpdateMetadata="UpdateMetadata",v.Extract="Extract",v.Scanning="Scanning",v.ScanningExtension="ScanningExtension",v.ReadUninstalled="ReadUninstalled",v.UnsetUninstalled="UnsetUninstalled",v.Delete="Delete",v.Rename="Rename",v.IntializeDefaultProfile="IntializeDefaultProfile",v.AddToProfile="AddToProfile",v.InstalledExtensionNotFound="InstalledExtensionNotFound",v.PostInstall="PostInstall",v.CorruptZip="CorruptZip",v.IncompleteZip="IncompleteZip",v.Signature="Signature",v.NotAllowed="NotAllowed",v.Gallery="Gallery",v.Cancelled="Cancelled",v.Unknown="Unknown",v.Internal="Internal"})(I||(e.ExtensionManagementErrorCode=I={}));class d extends Error{constructor(t,r){super(t),this.code=r,this.name=r}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,a.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,a.localize2)(1,"Preferences")}),define(le[223],ue([0,1,3,2,30,9,95,28]),function(ne,e,D,a,A,L,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function T(f,h){return f?L.URI.revive(h?h.transformIncoming(f):f):void 0}function y(f,h){return h?h.transformOutgoingURI(f):f}function P(f,h){h=h||k.DefaultURITransformer;const E=f.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...f,manifest:void 0},h),manifest:E}}function S(f,h){return f?.profileLocation?(0,k.transformAndReviveIncomingURIs)(f,h??k.DefaultURITransformer):f}function u(f,h){return h?(0,A.cloneAndChange)(f,E=>E instanceof L.URI?h.transformOutgoingURI(E):void 0):f}class p{constructor(h,E){this.service=h,this.getUriTransformer=E,this.onInstallExtension=D.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,E){const I=this.getUriTransformer(h);switch(E){case"onInstallExtension":return D.Event.map(this.onInstallExtension,d=>({...d,profileLocation:d.profileLocation?y(d.profileLocation,I):d.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map(v=>({...v,local:v.local?u(v.local,I):v.local,profileLocation:v.profileLocation?y(v.profileLocation,I):v.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,d=>({...d,profileLocation:d.profileLocation?y(d.profileLocation,I):d.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,d=>({...d,profileLocation:d.profileLocation?y(d.profileLocation,I):d.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,d=>u(d,I))}throw new Error("Invalid listen")}async call(h,E,I){const d=this.getUriTransformer(h);switch(E){case"zip":{const v=P(I[0],d),t=await this.service.zip(v);return y(t,d)}case"unzip":return this.service.unzip(T(I[0],d));case"install":return this.service.install(T(I[0],d),S(I[1],d));case"installFromLocation":return this.service.installFromLocation(T(I[0],d),T(I[1],d));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(I[0],T(I[1],d),T(I[2],d));case"getManifest":return this.service.getManifest(T(I[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(I[0]);case"installFromGallery":return this.service.installFromGallery(I[0],S(I[1],d));case"installGalleryExtensions":{const v=I[0];return this.service.installGalleryExtensions(v.map(({extension:t,options:r})=>({extension:t,options:S(r,d)??{}})))}case"uninstall":return this.service.uninstall(P(I[0],d),S(I[1],d));case"reinstallFromGallery":return this.service.reinstallFromGallery(P(I[0],d));case"getInstalled":return(await this.service.getInstalled(I[0],T(I[1],d),I[2])).map(t=>u(t,d));case"toggleAppliationScope":{const v=await this.service.toggleAppliationScope(P(I[0],d),T(I[1],d));return u(v,d)}case"copyExtensions":return this.service.copyExtensions(T(I[0],d),T(I[1],d));case"updateMetadata":{const v=await this.service.updateMetadata(P(I[0],d),I[1],T(I[2],d));return u(v,d)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(I[0],I[1],I[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=p;class c extends a.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(h){super(),this.channel=h,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._onDidUpdateExtensionMetadata=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(E=>this.fireEvent(this._onInstallExtension,{...E,source:this.isUriComponents(E.source)?L.URI.revive(E.source):E.source,profileLocation:L.URI.revive(E.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(E=>this.fireEvent(this._onDidInstallExtensions,E.map(I=>({...I,local:I.local?P(I.local,null):I.local,source:this.isUriComponents(I.source)?L.URI.revive(I.source):I.source,profileLocation:L.URI.revive(I.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(E=>this.fireEvent(this._onUninstallExtension,{...E,profileLocation:L.URI.revive(E.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(E=>this.fireEvent(this._onDidUninstallExtension,{...E,profileLocation:L.URI.revive(E.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(E=>this._onDidUpdateExtensionMetadata.fire(P(E,null))))}fireEvent(h,E){h.fire(E)}isUriComponents(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(h){const E=await this.getTargetPlatform();return h.allTargetPlatforms.some(I=>(0,_.isTargetPlatformCompatible)(I,h.allTargetPlatforms,E))}zip(h){return Promise.resolve(this.channel.call("zip",[h]).then(E=>L.URI.revive(E)))}unzip(h){return Promise.resolve(this.channel.call("unzip",[h]))}install(h,E){return Promise.resolve(this.channel.call("install",[h,E])).then(I=>P(I,null))}installFromLocation(h,E){return Promise.resolve(this.channel.call("installFromLocation",[h,E])).then(I=>P(I,null))}async installExtensionsFromProfile(h,E,I){return(await this.channel.call("installExtensionsFromProfile",[h,E,I])).map(v=>P(v,null))}getManifest(h){return Promise.resolve(this.channel.call("getManifest",[h]))}installFromGallery(h,E){return Promise.resolve(this.channel.call("installFromGallery",[h,E])).then(I=>P(I,null))}async installGalleryExtensions(h){return(await this.channel.call("installGalleryExtensions",[h])).map(I=>({...I,local:I.local?P(I.local,null):I.local,source:this.isUriComponents(I.source)?L.URI.revive(I.source):I.source,profileLocation:L.URI.revive(I.profileLocation)}))}uninstall(h,E){if(h.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.channel.call("uninstall",[h,E]))}reinstallFromGallery(h){return Promise.resolve(this.channel.call("reinstallFromGallery",[h])).then(E=>P(E,null))}getInstalled(h=null,E,I){return Promise.resolve(this.channel.call("getInstalled",[h,E,I])).then(d=>d.map(v=>P(v,null)))}updateMetadata(h,E,I){return Promise.resolve(this.channel.call("updateMetadata",[h,E,I])).then(d=>P(d,null))}toggleAppliationScope(h,E){return this.channel.call("toggleAppliationScope",[h,E]).then(I=>P(I,null))}copyExtensions(h,E){return this.channel.call("copyExtensions",[h,E])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(h,E,I){const d=await this.channel.call("download",[h,E,I]);return L.URI.revive(d)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=c;class g{constructor(h){this.service=h}listen(h,E){throw new Error("Invalid listen")}call(h,E,I){switch(E){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(I[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(le[224],ue([0,1,2,37,7]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(_,T,y,P,S){super(),this.userDataProfilesService=_,this.fileService=T,this.uriIdentityService=y,this.logService=S,this._register(P.onDidInstallExtensions(u=>this.onDidInstallExtensions(u))),this._register(P.onDidUninstallExtension(u=>this.onDidUnInstallExtension(u)))}onDidInstallExtensions(_){for(const T of _)T.local&&this.invalidate(T.profileLocation)}onDidUnInstallExtension(_){_.error||this.invalidate(_.profileLocation)}async invalidate(_){if(_)for(const T of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(T.extensionsResource,_)&&await this.deleteUserCacheFile(T);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(_){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(_.cacheHome,a.USER_MANIFEST_CACHE_FILE))}catch(T){(0,A.toFileOperationResult)(T)!==A.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(T)}}}e.ExtensionsManifestCache=L}),define(le[79],ue([0,1,26,2,5,173,28,4]),function(ne,e,D,a,A,L,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.getLocale=T;function T(P){return P.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.ILanguagePackService=(0,_.createDecorator)("languagePackService");let y=class extends a.Disposable{constructor(S){super(),this.extensionGalleryService=S}async getAvailableLanguages(){const S=new D.CancellationTokenSource;setTimeout(()=>S.cancel(),1e3);let u;try{u=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const c=u.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(f=>f.startsWith("lp-"))).map(g=>{const f=g.properties.localizedLanguages?.[0],h=T(g);return{...this.createQuickPickItem(h,f,g),extensionId:g.identifier.id,galleryExtension:g}});return c.push(this.createQuickPickItem("en","English")),c}createQuickPickItem(S,u,p){const c=u??S;let g;if(c!==S&&(g=`(${S})`),S.toLowerCase()===A.language.toLowerCase()&&(g??="",g+=(0,L.localize)(0,null)),p?.installCount){g??="";const f=p.installCount;let h;f>1e6?h=`${Math.floor(f/1e5)/10}M`:f>1e3?h=`${Math.floor(f/1e3)}K`:h=String(f),g+=` $(cloud-download) ${h}`}return{id:S,label:c,description:g}}};e.LanguagePackBaseService=y,e.LanguagePackBaseService=y=we([Q(0,k.IExtensionGalleryService)],y)}),define(le[225],ue([0,1,2,79]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends D.Disposable{constructor(k){super(),this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=A,e.LocalizationsUpdater=A=we([Q(0,a.ILanguagePackService)],A)}),define(le[107],ue([0,1,2,4]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,a.createDecorator)("remoteSocketFactoryService");class A{constructor(){this.factories={}}register(k,_){return this.factories[k]??=[],this.factories[k].push(_),(0,D.toDisposable)(()=>{const T=this.factories[k]?.indexOf(_);typeof T=="number"&&T>=0&&this.factories[k]?.splice(T,1)})}getSocketFactory(k){return(this.factories[k.type]||[]).find(T=>T.supports(k))}connect(k,_,T,y){const P=this.getSocketFactory(k);if(!P)throw new Error(`No socket factory found for ${k}`);return P.connect(k,_,T,y)}}e.RemoteSocketFactoryService=A}),define(le[226],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(le[108],ue([0,1,4,175]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,D.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var A;(function(L){L.disconnected=k=>({type:"disconnected",onTokenFailed:k}),L.connected=(k,_)=>({type:"connected",info:k,serviceInstallFailed:_}),L.connecting=k=>({type:"connecting",progress:k}),L.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,a.localize)(0,null)}),define(le[60],ue([0,1,15,8,2,177,48,4,10,45]),function(ne,e,D,a,A,L,k,_,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=u,e.hasNoContent=p,e.asText=c,e.asTextOrError=g,e.asJson=f,e.updateProxyConfigurationsScope=h,e.IRequestService=(0,_.createDecorator)("requestService");class P{constructor(v){this.original=v}toJSON(){if(!this.headers){const v=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?v[t]="*****":v[t]=this.original[t];this.headers=v}return this.headers}}class S extends A.Disposable{constructor(v){super(),this.counter=0,this.logger=v.createLogger("network",{name:(0,L.localize)(0,null),when:T.CONTEXT_LOG_LEVEL.isEqualTo((0,T.LogLevelToString)(T.LogLevel.Trace)).serialize()})}async logAndRequest(v,t,r){const s=`${v} #${++this.counter}: ${t.url}`;this.logger.trace(`${s} - begin`,t.type,new P(t.headers??{}));try{const i=await r();return this.logger.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${s} - error`,t.type,(0,a.getErrorMessage)(i)),i}}}e.AbstractRequestService=S;function u(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}function p(d){return d.res.statusCode===204}async function c(d){return p(d)?null:(await(0,D.streamToBuffer)(d.stream)).toString()}async function g(d){if(!u(d))throw new Error("Server returned "+d.res.statusCode);return c(d)}async function f(d){if(!u(d))throw new Error("Server returned "+d.res.statusCode);if(p(d))return null;const t=(await(0,D.streamToBuffer)(d.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function h(d){I(d)}let E;function I(d){const v=y.Registry.as(k.Extensions.Configuration),t=E;E={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},v.updateConfigurations({add:[E],remove:t?[t]:[]})}I(k.ConfigurationScope.APPLICATION)}),define(le[227],ue([0,1,26,23,7,60]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(T,y){this.requestService=T,this.fileService=y}async download(T,y,P=D.CancellationToken.None){if(T.scheme===a.Schemas.file||T.scheme===a.Schemas.vscodeRemote){await this.fileService.copy(T,y);return}const S={type:"GET",url:T.toString(!0)},u=await this.requestService.request(S,P);if(u.res.statusCode===200)await this.fileService.writeFile(y,u.stream);else{const p=await(0,L.asTextOrError)(u);throw new Error(`Expected 200, got back ${u.res.statusCode} instead.

${p}`)}}};e.DownloadService=k,e.DownloadService=k=we([Q(0,L.IRequestService),Q(1,A.IFileService)],k)}),define(le[228],ue([0,1,15,26]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class A{constructor(_){this.service=_}listen(_,T){throw new Error("Invalid listen")}call(_,T,y,P=a.CancellationToken.None){switch(T){case"request":return this.service.request(y[0],P).then(async({res:S,stream:u})=>{const p=await(0,D.streamToBuffer)(u);return[{statusCode:S.statusCode,headers:S.headers},p]});case"resolveProxy":return this.service.resolveProxy(y[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=A;class L{constructor(_){this.channel=_}async request(_,T){const[y,P]=await this.channel.call("request",[_],T);return{res:y,stream:(0,D.bufferToStream)(P)}}async resolveProxy(_){return this.channel.call("resolveProxy",[_])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=L}),define(le[229],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[230],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class D{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(A){try{const L=await this.getValidator();if(L){const k=String(D._nextId++);return this.validators.set(k,L),{id:k,data:L.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,L){if(!A.id)return!0;const k=this.validators.get(A.id);if(!k)return!1;this.validators.delete(A.id);try{return k.validate(L)==="ok"}catch{return!1}finally{k.dispose?.()}}async sign(A){try{return await this.signValue(A)}catch{}return A}}e.AbstractSignService=D}),define(le[109],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(le[231],ue([0,1,230]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a extends D.AbstractSignService{getValidator(){return this.vsda().then(L=>new L.validator)}signValue(L){return this.vsda().then(k=>new k.signer().sign(L))}vsda(){return new Promise((L,k)=>ne(["vsda"],L,k))}}e.SignService=a}),define(le[80],ue([0,1,3,2]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class A extends a.Disposable{constructor(S,u,p){super(),this.channel=S,this.profile=u,this.workspace=p}async getItems(){const S={profile:this.profile,workspace:this.workspace},u=await this.channel.call("getItems",S);return new Map(u)}updateItems(S){const u={profile:this.profile,workspace:this.workspace};return S.insert&&(u.insert=Array.from(S.insert.entries())),S.delete&&(u.delete=Array.from(S.delete.values())),this.channel.call("updateItems",u)}optimize(){const S={profile:this.profile,workspace:this.workspace};return this.channel.call("optimize",S)}}class L extends A{constructor(S,u){super(S,u,void 0),this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(S=>this.onDidChangeStorage(S)))}onDidChangeStorage(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this._onDidChangeItemsExternal.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class k extends L{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=k;class _ extends L{constructor(S,u){super(S,u)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=_;class T extends A{constructor(S,u){super(S,void 0,u),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=T;class y{constructor(S){this.channel=S}isUsed(S){const u={payload:S,profile:void 0,workspace:void 0};return this.channel.call("isUsed",u)}}e.StorageClient=y}),define(le[110],ue([0,1,5,36,32]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=k,e.verifyMicrosoftInternalDomain=_;function L(T){if(D.platform===D.Platform.Linux&&/^penguin(\.|$)/i.test(T))return"chromebook"}function k(T,y,P,S,u,p,c,g,f,h){const E=Object.create(null);E["common.machineId"]=p,E["common.sqmId"]=c,E["common.devDeviceId"]=g,E.sessionID=(0,A.generateUuid)()+Date.now(),E.commitHash=S,E.version=u,E["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,D.PlatformToString)(D.platform),E["common.nodePlatform"]=a.platform,E["common.nodeArch"]=P,E["common.product"]=h||"desktop",f&&(E["common.msftInternal"]=f);let I=0;const d=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),D.isLinuxSnap&&(E["common.snap"]="true");const v=L(y);return v&&(E["common.platformDetail"]=v),E}function _(T){const y=a.env.USERDNSDOMAIN;if(!y)return!1;const P=y.toLowerCase();return T.some(S=>P===S)}}),define(le[18],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var a;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var A;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(le[232],ue([0,1,38,6,34,23,14,5,9,150,31,156,98,7,24,18]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=h,e.getMachineInfo=I,e.collectLaunchConfigs=d;const f=new Map;async function h(t,r){const s=`${t}::${r.join(":")}`,i=f.get(s);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,l=new Map,m=2e4;function w(b,R,U,N){const M=R.substring(b.length+1);return a.Promises.withAsyncBody(async F=>{let K;try{K=await P.Promises.readdir(R,{withFileTypes:!0})}catch{F();return}if(N.count>=m){N.count+=K.length,N.maxReached=!0,F();return}let H=K.length;if(H===0){F();return}let X=K;N.count+K.length>m&&(N.maxReached=!0,H=m-N.count,X=K.slice(0,H)),N.count+=K.length;for(const j of X)if(j.isDirectory()){if(U.includes(j.name)||await w(b,(0,k.join)(R,j.name),U,N),--H===0){F();return}}else{const ie=j.name.lastIndexOf(".");if(ie>=0){const z=j.name.substring(ie+1);z&&o.set(z,(o.get(z)??0)+1)}for(const z of n)z.relativePathPattern?.test(M)!==!1&&z.filePattern.test(j.name)&&l.set(z.tag,(l.get(z.tag)??0)+1);if(--H===0){F();return}}})}const C=a.Promises.withAsyncBody(async b=>{const R={count:0,maxReached:!1};await w(t,t,r,R);const U=await d(t);b({configFiles:E(l),fileTypes:E(o),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:U})});return f.set(s,C),C}function E(t){return Array.from(t.entries(),([r,s])=>({name:r,count:s})).sort((r,s)=>s.count-r.count)}function I(){const t={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},r=D.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function d(t){try{const r=new Map,s=(0,k.join)(t,".vscode","launch.json"),i=await P.Promises.readFile(s),n=[],o=(0,A.parse)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${s}`),[];if((0,A.getNodeType)(o)==="object"&&o.configurations)for(const l of o.configurations){const m=l.type;m&&(r.has(m)?r.set(m,r.get(m)+1):r.set(m,1))}return E(r)}catch{return[]}}let v=class{constructor(r,s){this.telemetryService=r,this.productService=s}formatMachineInfo(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}formatEnvironment(r){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(D.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),_.isWindows||s.push(`Load (avg):       ${D.loadavg().map(n=>Math.round(n)).join(", ")}`),s.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([(0,S.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async i=>{let[n,o]=i,l=this.formatProcessList(r,n);return s.forEach(m=>{if((0,u.isRemoteDiagnosticError)(m))l+=`
${m.errorMessage}`,o+=`
${m.errorMessage}`;else if(l+=`

Remote: ${m.hostName}`,m.processes&&(l+=`
${this.formatProcessList(r,m.processes)}`),m.workspaceMetadata){o+=`
|  Remote: ${m.hostName}`;for(const w of Object.keys(m.workspaceMetadata)){const C=m.workspaceMetadata[w];let b=`${C.fileCount} files`;C.maxFilesReached&&(b=`more than ${b}`),o+=`|    Folder (${w}): ${b}`,o+=this.formatWorkspaceStats(C)}}}),{processInfo:l,workspaceInfo:o}})}async getSystemInfo(r,s){const{memory:i,vmHint:n,os:o,cpus:l}=I(),m={os:o,memory:i,cpus:l,vmHint:n,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return _.isWindows||(m.load=`${D.loadavg().map(w=>Math.round(w)).join(", ")}`),_.isLinux&&(m.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(m)}async getDiagnostics(r,s){const i=[];return(0,S.listProcesses)(r.mainPID).then(async n=>(i.push(""),i.push(this.formatEnvironment(r)),i.push(""),i.push(this.formatProcessList(r,n)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(r))),s.forEach(o=>{if((0,u.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.formatMachineInfo(o.machineInfo)),o.processes&&i.push(this.formatProcessList(r,o.processes)),o.workspaceMetadata)for(const l of Object.keys(o.workspaceMetadata)){const m=o.workspaceMetadata[l];let w=`${m.fileCount} files`;m.maxFilesReached&&(w=`more than ${w}`),i.push(`Folder (${l}): ${w}`),i.push(this.formatWorkspaceStats(m))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(r){const s=[];let n=0;const o=(C,b)=>{const R=` ${C}(${b})`;n+R.length>60?(s.push(l),l="|                 ",n=l.length):n+=R.length,l+=R};let l="|      File types:";const m=10,w=r.fileTypes.length>m?m:r.fileTypes.length;for(let C=0;C<w;C++){const b=r.fileTypes[C];o(b.name,b.count)}if(s.push(l),r.configFiles.length>=0&&(l="|      Conf files:",n=0,r.configFiles.forEach(C=>{o(C.name,C.count)}),s.push(l)),r.launchConfigFiles.length>0){let C="|      Launch Configs:";r.launchConfigFiles.forEach(b=>{const R=b.count>1?` ${b.name}(${b.count})`:` ${b.name}`;C+=R}),s.push(C)}return s.join(`
`)}expandGPUFeatures(r){const s=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${r[i]}`).join(`
                  `)}formatWorkspaceMetadata(r){const s=[],i=[];return r.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(s.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const l=T.URI.revive(o);if(l.scheme===L.Schemas.file){const m=l.fsPath;i.push(h(m,["node_modules",".git"]).then(w=>{let C=`${w.fileCount} files`;w.maxFilesReached&&(C=`more than ${C}`),s.push(`|    Folder (${(0,k.basename)(m)}): ${C}`),s.push(this.formatWorkspaceStats(w))}).catch(w=>{s.push(`|      Error: Unable to collect workspace stats for folder ${m} (${w.toString()})`)}))}else s.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>s.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}formatProcessList(r,s){const i=new Map;r.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:l})=>i.set(o,l));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(r.mainPID,i,n,s,0),n.join(`
`)}formatProcessItem(r,s,i,n,o){const l=o===0;let m;l?m=n.pid===r?`${this.productService.applicationName} main`:"remote agent":s.has(n.pid)?m=s.get(n.pid):m=`${"  ".repeat(o)} ${n.name}`;const w=process.platform==="win32"?n.mem:D.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(w/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${m}`),Array.isArray(n.children)&&n.children.forEach(C=>this.formatProcessItem(r,s,i,C,o+1))}async getWorkspaceFileExtensions(r){const s=new Set;for(const{uri:i}of r.folders){const n=T.URI.revive(i);if(n.scheme!==L.Schemas.file)continue;const o=n.fsPath;try{(await h(o,["node_modules",".git"])).fileTypes.forEach(m=>s.add(m.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const i=T.URI.revive(s);if(i.scheme!==L.Schemas.file)continue;const n=i.fsPath;try{const o=await h(n,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),o.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),o.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};e.DiagnosticsService=v,e.DiagnosticsService=v=we([Q(0,g.ITelemetryService),Q(1,c.IProductService)],v)}),define(le[111],ue([0,1,8,4,10,18]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.ExtensionSignatureVerificationError=e.ExtensionSignatureVerificationCode=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,a.createDecorator)("IExtensionSignatureVerificationService");var k;(function(y){y.None="None",y.RequiredArgumentMissing="RequiredArgumentMissing",y.InvalidArgument="InvalidArgument",y.PackageIsUnreadable="PackageIsUnreadable",y.UnhandledException="UnhandledException",y.SignatureManifestIsMissing="SignatureManifestIsMissing",y.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",y.SignatureIsMissing="SignatureIsMissing",y.SignatureIsUnreadable="SignatureIsUnreadable",y.CertificateIsUnreadable="CertificateIsUnreadable",y.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",y.FileAlreadyExists="FileAlreadyExists",y.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",y.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",y.Success="Success",y.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",y.SignatureIsInvalid="SignatureIsInvalid",y.SignatureManifestIsInvalid="SignatureManifestIsInvalid",y.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",y.EntryIsMissing="EntryIsMissing",y.EntryIsTampered="EntryIsTampered",y.Untrusted="Untrusted",y.CertificateRevoked="CertificateRevoked",y.SignatureIsNotValid="SignatureIsNotValid",y.UnknownError="UnknownError",y.PackageIsInvalidZip="PackageIsInvalidZip",y.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(k||(e.ExtensionSignatureVerificationCode=k={}));class _ extends Error{constructor(P){super(P),this.code=P}}e.ExtensionSignatureVerificationError=_;let T=class{constructor(P,S){this.logService=P,this.telemetryService=S}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((P,S)=>ne(["@vscode/vsce-sign"],async u=>P(u),S))),this.moduleLoadingPromise}async verify(P,S,u,p){let c;const g=P.identifier.id;try{c=await this.vsceSign()}catch(I){return this.logService.error("Could not load vsce-sign module",(0,D.getErrorMessage)(I)),this.logService.info(`Extension signature verification is not done: ${g}`),!1}const f=new Date().getTime();let h;try{this.logService.trace(`Verifying extension signature for ${g}...`),h=await c.verify(S,u,this.logService.getLevel()===A.LogLevel.Trace)}catch(I){h={code:k.UnknownError,didExecute:!1,output:(0,D.getErrorMessage)(I)}}const E=new Date().getTime()-f;if(this.logService.info(`Extension signature verification result for ${g}: ${h.code}. Executed: ${h.didExecute}. Duration: ${E}ms.`),this.logService.trace(`Extension signature verification output for ${g}:
${h.output}`),this.telemetryService.publicLog2("extensionsignature:verification",{extensionId:g,extensionVersion:P.version,code:h.code,internalCode:h.internalCode,duration:E,didExecute:h.didExecute,clientTargetPlatform:p}),h.code===k.Success)return!0;throw new _(h.code)}};e.ExtensionSignatureVerificationService=T,e.ExtensionSignatureVerificationService=T=we([Q(0,A.ILogService),Q(1,L.ITelemetryService)],T)}),define(le[112],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(L){this.appenders=L}listen(L,k){throw new Error(`Event not found: ${k}`)}call(L,k,{eventName:_,data:T}){return this.appenders.forEach(y=>y.log(_,T)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class a{constructor(L){this.channel=L}log(L,k){return this.channel.call("log",{eventName:L,data:k}).then(void 0,_=>`Failed to log telemetry: ${console.warn(_)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=a}),define(le[49],ue([0,1,30,13,106,110,18]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=P,e.isLoggingOnly=S,e.getTelemetryLevel=u,e.validateTelemetryData=p,e.cleanRemoteAuthority=g,e.isInternalTelemetry=h,e.getPiiPathsFromEnvironment=E,e.cleanData=v;class _{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=_;class T{constructor(){this.telemetryLevel=k.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class y{async publicLog(r,s,i){}async publicLogError(r,s,i){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function S(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const r=t.getValue(k.TELEMETRY_SETTING_ID),s=t.getValue(k.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return k.TelemetryLevel.NONE;switch(r??k.TelemetryConfiguration.ON){case k.TelemetryConfiguration.ON:return k.TelemetryLevel.USAGE;case k.TelemetryConfiguration.ERROR:return k.TelemetryLevel.ERROR;case k.TelemetryConfiguration.CRASH:return k.TelemetryLevel.CRASH;case k.TelemetryConfiguration.OFF:return k.TelemetryLevel.NONE}}function p(t){const r={},s={},i={};f(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const o=i[n];typeof o=="number"?s[n]=o:typeof o=="boolean"?s[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),r[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[n]=o)}return{properties:r,measurements:s}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(t){if(!t)return"none";const r=(0,A.getRemoteName)(t);return c.has(r)?r:"other"}function f(t,r,s=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const o=t[n],l=i?i+n:n;Array.isArray(o)?r[l]=(0,D.safeStringify)(o):o instanceof Date?r[l]=o.toISOString():(0,a.isObject)(o)?s<2?f(o,r,s+1,l+"."):r[l]=(0,D.safeStringify)(o):r[l]=o}}function h(t,r){const s=t.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(s)||i}function E(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function I(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const i=[];for(const m of r)for(;;){const w=m.exec(t);if(!w)break;i.push([w.index,m.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(s="";;){const m=o.exec(t);if(!m)break;const w=i.some(([C,b])=>m.index<b&&C<o.lastIndex);!n.test(m[0])&&!w&&(s+=t.substring(l,m.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<t.length&&(s+=t.substr(l)),s}function d(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of r)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function v(t,r){return(0,D.cloneAndChange)(t,s=>{if(s instanceof _||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let i=s.replaceAll("%20"," ");i=I(i,r);for(const n of r)i=i.replace(n,"");return i=d(i),i}})}}),define(le[33],ue([0,1,27,28,37,5,9,8,36,49]),function(ne,e,D,a,A,L,k,_,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=P,e.getIdAndVersion=c,e.getExtensionId=g,e.adoptToGalleryExtensionId=f,e.getGalleryExtensionId=h,e.groupByExtension=E,e.getLocalExtensionTelemetryData=I,e.getGalleryExtensionTelemetryData=d,e.getExtensionDependencies=v,e.computeTargetPlatform=r;function P(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,D.compareIgnoreCase)(s.id,i.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new u(i.identifier,n,o)}static parse(i){const n=S.exec(i);return n&&n[1]&&n[2]?new u({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o=A.TargetPlatform.UNDEFINED){this.identifier=i,this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==A.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof u?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=u;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function c(s){const i=p.exec(s);return i&&i[1]?[f(i[1]),i[2]]:[f(s),void 0]}function g(s,i){return`${s}.${i}`}function f(s){return s.toLowerCase()}function h(s,i){return f(g(s??A.UNDEFINED_PUBLISHER,i))}function E(s,i){const n=[],o=l=>{for(const m of n)if(m.some(w=>P(i(w),i(l))))return m;return null};for(const l of s){const m=o(l);m?m.push(l):n.push([l])}return n}function I(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function d(s){return{id:new y.TelemetryTrustedValue(s.identifier.id),name:new y.TelemetryTrustedValue(s.name),version:s.version,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function v(s,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&n.every(m=>!P(m.identifier,{id:l}))){const m=s.filter(w=>P(w.identifier,{id:l}));m.length===1&&(n.push(m[0]),o.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function t(s,i){if(!L.isLinux)return!1;let n;try{n=(await s.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,_.getErrorMessage)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,i){const n=await t(s,i),o=(0,a.getTargetPlatform)(n?"alpine":L.platform,T.arch);return i.debug("ComputeTargetPlatform:",o),o}}),define(le[233],ue([0,1,26,28,33,37]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=k;async function k(_,T,y,P,S){try{const u=await _.getExtensionsControlManifest();if(!u.deprecated)return;const p=await _.getInstalled(L.ExtensionType.User);for(const[c,g]of Object.entries(u.deprecated)){if(!g?.extension)continue;const{id:f,autoMigrate:h,preRelease:E}=g.extension;if(!h)continue;const I=p.find(v=>(0,A.areSameExtensions)(v.identifier,{id:c}));if(!I)continue;const d=(await T.getExtensions([{id:f,preRelease:E}],{targetPlatform:await _.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!d){S.info(`Skipping migrating '${I.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{S.info(`Migrating '${I.identifier.id}' extension to '${f}' extension...`);const v=!P.getDisabledExtensions().some(r=>(0,A.areSameExtensions)(r,I.identifier));await _.uninstall(I),S.info(`Uninstalled the unsupported extension '${I.identifier.id}'`);let t=p.find(r=>(0,A.areSameExtensions)(r.identifier,{id:f}));(!t||!t.isPreReleaseVersion&&v)&&(t=await _.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:I.isMachineScoped,operation:a.InstallOperation.Migrate}),S.info(`Installed the pre-release extension '${t.identifier.id}'`),v||(await P.disableExtension(t.identifier),S.info(`Disabled the pre-release extension '${t.identifier.id}' because the unsupported extension '${I.identifier.id}' is disabled`)),h.storage&&(y.addToMigrationList((0,A.getExtensionId)(I.manifest.publisher,I.manifest.name),(0,A.getExtensionId)(t.manifest.publisher,t.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${I.identifier.id}' extension to '${f}' extension.`)}catch(v){S.error(v)}}}catch(u){S.error(u)}}}),define(le[234],ue([0,1,3,2,35,33,37,7]),function(ne,e,D,a,A,L,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class T extends a.Disposable{constructor(P,S,u,p,c,g,f){super(),this.extensionManagementService=P,this.extensionsScannerService=S,this.userDataProfilesService=u,this.extensionsProfileScannerService=p,this.uriIdentityService=c,this.fileService=g,this.logService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new a.DisposableMap),this.initialize().then(null,h=>f.error(h))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(P=>this.onDidChangeProfiles(P.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(P=>this.onAddExtensions(P))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(P=>this.onDidAddExtensions(P))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(P=>this.onRemoveExtensions(P))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(P=>this.onDidRemoveExtensions(P))),this._register(this.fileService.onDidFilesChange(P=>this.onDidFilesChange(P)))}async onDidChangeProfiles(P){try{P.length&&await Promise.all(P.map(S=>(this.extensionsProfileWatchDisposables.set(S.id,(0,a.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(S.extensionsResource)),this.fileService.watch(S.extensionsResource))),this.populateExtensionsFromProfile(S.extensionsResource))))}catch(S){throw this.logService.error(S),S}}async onAddExtensions(P){for(const S of P.extensions)this.addExtensionWithKey(this.getKey(S.identifier,S.version),P.profileLocation)}async onDidAddExtensions(P){for(const S of P.extensions){const u=this.getKey(S.identifier,S.version);P.error?this.removeExtensionWithKey(u,P.profileLocation):this.addExtensionWithKey(u,P.profileLocation)}}async onRemoveExtensions(P){for(const S of P.extensions)this.removeExtensionWithKey(this.getKey(S.identifier,S.version),P.profileLocation)}async onDidRemoveExtensions(P){const S=[],u=[];for(const p of P.extensions){const c=this.getKey(p.identifier,p.version);P.error?this.addExtensionWithKey(c,P.profileLocation):(this.removeExtensionWithKey(c,P.profileLocation),this.allExtensions.has(c)||(this.logService.debug("Extension is removed from all profiles",p.identifier.id,p.version),u.push(this.extensionManagementService.scanInstalledExtensionAtLocation(p.location).then(g=>{g?S.push(g):this.logService.info("Extension not found at the location",p.location.toString())},g=>this.logService.error(g)))))}try{await Promise.all(u),S.length&&await this.uninstallExtensionsNotInProfiles(S)}catch(p){this.logService.error(p)}}onDidFilesChange(P){for(const S of this.userDataProfilesService.profiles)P.contains(S.extensionsResource,_.FileChangeType.UPDATED,_.FileChangeType.ADDED)&&this.onDidExtensionsProfileChange(S.extensionsResource)}async onDidExtensionsProfileChange(P){const S=[],u=[],p=await this.extensionsProfileScannerService.scanProfileExtensions(P),c=new Set,g=new Set;for(const[f,h]of this.allExtensions)h.has(P)&&g.add(f);for(const f of p){const h=this.getKey(f.identifier,f.version);c.add(h),g.has(h)||(S.push(f.identifier),this.addExtensionWithKey(h,P))}for(const f of g)if(!c.has(f)){const h=this.fromKey(f);h&&(u.push(h.identifier),this.removeExtensionWithKey(f,P))}(S.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S.length?{extensions:S,profileLocation:P}:void 0,removed:u.length?{extensions:u,profileLocation:P}:void 0})}async populateExtensionsFromProfile(P){const S=await this.extensionsProfileScannerService.scanProfileExtensions(P);for(const u of S)this.addExtensionWithKey(this.getKey(u.identifier,u.version),P)}async uninstallExtensionsNotInProfiles(P){P||(P=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(u=>!this.allExtensions.has(this.getKey(u.identifier,u.manifest.version)))),P.length&&await this.extensionManagementService.markAsUninstalled(...P)}addExtensionWithKey(P,S){let u=this.allExtensions.get(P);u||this.allExtensions.set(P,u=new A.ResourceSet(p=>this.uriIdentityService.extUri.getComparisonKey(p))),u.add(S)}removeExtensionWithKey(P,S){const u=this.allExtensions.get(P);u&&u.delete(S),u?.size||this.allExtensions.delete(P)}getKey(P,S){return`${k.ExtensionIdentifier.toKey(P.id)}@${S}`}fromKey(P){const[S,u]=(0,L.getIdAndVersion)(P);return u?{identifier:{id:S},version:u}:void 0}}e.ExtensionsWatcher=T}),define(le[235],ue([0,1,76,19,6,2,23,14,31,16,28,33,10,79,9]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let g=class extends p.LanguagePackBaseService{constructor(I,d,v,t){super(v),this.extensionManagementService=I,this.logService=t,this.cache=this._register(new f(d,t)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getBuiltInExtensionTranslationsUri(I,d){const t=(await this.cache.getLanguagePacks())[d];if(!t){this.logService.warn(`No language pack found for ${d}`);return}const r=t.translations[I];return r?c.URI.file(r):void 0}async getInstalledLanguages(){const I=await this.cache.getLanguagePacks(),d=Object.keys(I).map(v=>{const t=I[v];return{...this.createQuickPickItem(v,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return d.push(this.createQuickPickItem("en","English")),d.sort((v,t)=>v.label.localeCompare(t.label)),d}async postInstallExtension(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",I.identifier.id),await this.update())}async postUninstallExtension(I){const d=await this.cache.getLanguagePacks();Object.keys(d).some(v=>d[v]&&d[v].extensions.some(t=>(0,S.areSameExtensions)(t.extensionIdentifier,I.identifier)))&&(this.logService.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,d]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(d);return!(0,a.equals)(Object.keys(I),Object.keys(v))}};e.NativeLanguagePackService=g,e.NativeLanguagePackService=g=we([Q(0,P.IExtensionManagementService),Q(1,y.INativeEnvironmentService),Q(2,P.IExtensionGalleryService),Q(3,u.ILogService)],g);let f=class extends L.Disposable{constructor(I,d){super(),this.logService=d,this.languagePacks={},this.languagePacksFilePath=(0,_.join)(I.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new A.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(I){return this.withLanguagePacks(d=>{Object.keys(d).forEach(v=>delete d[v]),this.createLanguagePacksFromExtensions(d,...I)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(I,...d){for(const v of d)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(I,v);Object.keys(I).forEach(v=>this.updateHash(I[v]))}createLanguagePacksFromExtension(I,d){const v=d.identifier,t=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const r of t)if(d.location.scheme===k.Schemas.file&&h(r)){let s=I[r.languageId];s||(s={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},I[r.languageId]=s);const i=s.extensions.filter(n=>(0,S.areSameExtensions)(n.extensionIdentifier,v))[0];i?i.version=d.manifest.version:s.extensions.push({extensionIdentifier:v,version:d.manifest.version});for(const n of r.translations)s.translations[n.id]=(0,_.join)(d.location.fsPath,n.path)}}updateHash(I){if(I){const d=(0,D.createHash)("md5");for(const v of I.extensions)d.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);I.hash=d.digest("hex")}}withLanguagePacks(I=()=>null){return this.languagePacksFileLimiter.queue(()=>{let d=null;return T.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch{return{}}}).then(v=>(d=I(v),v)).then(v=>{for(const r of Object.keys(v))v[r]||delete v[r];this.languagePacks=v,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),T.Promises.writeFile(this.languagePacksFilePath,t)}).then(()=>d,v=>this.logService.error(v))})}};f=we([Q(0,y.INativeEnvironmentService),Q(1,u.ILogService)],f);function h(E){if(typeof E.languageId!="string"||!Array.isArray(E.translations)||E.translations.length===0)return!1;for(const I of E.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(E.languageName&&typeof E.languageName!="string"||E.localizedLanguageName&&typeof E.localizedLanguageName!="string")}}),define(le[236],ue([0,1,149,8,30,49]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://0.0.0.0/OneCollector/1.0",_="https://0.0.0.0/ping";async function T(P,S,u){const p=await(0,D.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,D.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),g=new p.AppInsightsCore,f=new c.PostChannel,h={instrumentationKey:P,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(u){h.extensionConfig={};const E={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:u};h.extensionConfig[f.identifier]=E}return g.initialize(h,[]),g.addTelemetryInitializer(E=>{E.ext=E.ext??{},E.ext.web=E.ext.web??{},E.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',S&&(E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),g}class y{constructor(S,u,p,c,g){this._isInternalTelemetry=S,this._eventPrefix=u,this._defaultData=p,this._xhrOverride=g,this.endPointUrl=k,this.endPointHealthUrl=_,this._defaultData||(this._defaultData={}),typeof c=="function"?this._aiCoreOrKey=c():this._aiCoreOrKey=c,this._asyncAiCore=null}_withAIClient(S){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){S(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(u=>{S(u)},u=>{(0,a.onUnexpectedError)(u),console.error(u)})}}log(S,u){if(!this._aiCoreOrKey)return;u=(0,A.mixin)(u,this._defaultData),u=(0,L.validateTelemetryData)(u);const p=this._eventPrefix+"/"+S;try{this._withAIClient(c=>{c.pluginVersionString=u?.properties.version??"Unknown",c.track({name:p,baseData:{name:p,properties:u?.properties,measurements:u?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(S=>{this._withAIClient(u=>{u.unload(!0,()=>{this._aiCoreOrKey=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=y}),define(le[113],ue([0,1,2,178,16,10,24,49]),function(ne,e,D,a,A,L,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(P,S,u,p,c=""){super(),this.prefix=c;const g=S.getLogger(_.telemetryLogId);if(g)this.logger=this._register(g);else{const h=(0,_.isLoggingOnly)(p,u)?" (Not Sent)":"",E=()=>(0,_.supportsTelemetry)(p,u)&&P.getLevel()===L.LogLevel.Trace;this.logger=this._register(S.createLogger(_.telemetryLogId,{name:(0,a.localize)(0,null,h),hidden:!E()})),this._register(P.onDidChangeLogLevel(()=>S.setVisibility(_.telemetryLogId,E()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,S){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,_.validateTelemetryData)(S))}};e.TelemetryLogAppender=T,e.TelemetryLogAppender=T=we([Q(0,L.ILogService),Q(1,L.ILoggerService),Q(2,A.IEnvironmentService),Q(3,k.IProductService)],T)}),define(le[114],ue([0,1,2,30,5,27,179,22,48,103,24,45,18,49]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let c=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,E,I){this._configurationService=E,this._productService=I,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=h.piiPaths||[],this._telemetryLevel=u.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(d),"gi")),d.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(d.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(d=>{(d.affectsConfiguration(u.TELEMETRY_SETTING_ID)||d.affectsConfiguration(u.TELEMETRY_OLD_SETTING_ID)||d.affectsConfiguration(u.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(h,E){this._experimentProperties[h]=E}_updateTelemetryLevel(){let h=(0,p.getTelemetryLevel)(this._configurationService);const E=this._productService.enabledTelemetryLevels;if(E){this._sendErrorTelemetry=this.sendErrorTelemetry?E.error:!1;const I=E.usage?u.TelemetryLevel.USAGE:E.error?u.TelemetryLevel.ERROR:u.TelemetryLevel.NONE;h=Math.min(h,I)}this._telemetryLevel=h}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(h,E,I){this._telemetryLevel<E||(I=(0,a.mixin)(I,this._experimentProperties),I=(0,p.cleanData)(I,this._cleanupPatterns),I=(0,a.mixin)(I,this._commonProperties),this._appenders.forEach(d=>d.log(h,I)))}publicLog(h,E){this._log(h,u.TelemetryLevel.USAGE,E)}publicLog2(h,E){this.publicLog(h,E)}publicLogError(h,E){this._sendErrorTelemetry&&this._log(h,u.TelemetryLevel.ERROR,E)}publicLogError2(h,E){this.publicLogError(h,E)}};e.TelemetryService=c,e.TelemetryService=c=we([Q(1,_.IConfigurationService),Q(2,P.IProductService)],c);function g(){const f=(0,k.localize)(0,null,y.default.nameLong),h=y.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),E=A.isWeb?"":(0,k.localize)(3,null),I=(0,k.localize)(4,null),d=(0,k.localize)(5,null),v=(0,k.localize)(6,null),t=(0,k.localize)(7,null),r=`
|       | ${I} | ${d} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,k.localize)(8,null);return`
${f} ${h} ${E}

&nbsp;

${t}
${r}

&nbsp;

${s}
`}S.Registry.as(T.Extensions.Configuration).registerConfiguration({id:u.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[u.TELEMETRY_SETTING_ID]:{type:"string",enum:[u.TelemetryConfiguration.ON,u.TelemetryConfiguration.ERROR,u.TelemetryConfiguration.CRASH,u.TelemetryConfiguration.OFF],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:g(),default:u.TelemetryConfiguration.OFF,restricted:!0,scope:T.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(T.Extensions.Configuration).registerConfiguration({id:u.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[u.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,k.localize)(16,null,y.default.nameLong,y.default.privacyStatementUrl):(0,k.localize)(15,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${u.TELEMETRY_SETTING_ID}#\``),scope:T.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[237],ue([0,1,15,26,281,236]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function k(P,S){const u=await S.request(P,a.CancellationToken.None),p=(await(0,D.streamToBuffer)(u.stream)).toString(),c=u.res.statusCode??200;return{headers:u.res.headers,statusCode:c,responseData:p}}async function _(P){const S={method:P.type,headers:P.headers};return new Promise((p,c)=>{const g=A.request(P.url??"",S,f=>{f.on("data",function(h){p({headers:f.headers,statusCode:f.statusCode??200,responseData:h.toString()})}),f.on("error",function(h){c(h)})});g.write(P.data,f=>{f&&c(f)}),g.end()})}async function T(P,S,u){const p=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),c={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:p};try{const g=P?await k(c,P):await _(c);u(g.statusCode,g.headers,g.responseData)}catch{u(0,{})}}class y extends L.AbstractOneDataSystemAppender{constructor(S,u,p,c,g){const f={sendPOST:(h,E)=>{T(S,h,E)}};super(u,p,c,g,f)}}e.OneDataSystemAppender=y}),define(le[238],ue([0,1,23,96,22,16,10,24,18,112,113,114]),function(ne,e,D,a,A,L,k,_,T,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let u=class{constructor(c,g,f,h,E,I){this.configurationService=c,this.telemetryService=g,this.logService=f,this.loggerService=h,this.environmentService=E,this.productService=I,this.customTelemetryServices=new Map}getCustomTelemetryService(c){if(!this.customTelemetryServices.has(c.id)){const g=Object.create(null);g["common.vscodemachineid"]=this.telemetryService.machineId,g["common.vscodesessionid"]=this.telemetryService.sessionId;const f=[c.id,JSON.stringify(g),c.aiKey],E=new a.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),I=[new y.TelemetryAppenderClient(E),new P.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${c.id}] `)];this.customTelemetryServices.set(c.id,new S.TelemetryService({appenders:I,sendErrorTelemetry:c.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(c.id)}publicLog(c,g,f){this.getCustomTelemetryService(c).publicLog(g,f)}publicLogError(c,g,f){this.getCustomTelemetryService(c).publicLogError(g,f)}};e.CustomEndpointTelemetryService=u,e.CustomEndpointTelemetryService=u=we([Q(0,A.IConfigurationService),Q(1,T.ITelemetryService),Q(2,k.ILogService),Q(3,k.ILoggerService),Q(4,L.IEnvironmentService),Q(5,_.IProductService)],u)}),define(le[81],ue([0,1,3,5,9,22,4,10]),function(ne,e,D,a,A,L,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=P,e.extractLocalHostUriMetaDataForPortMapping=u,e.extractQueryLocalHostUriMetaDataForPortMapping=p,e.isLocalhost=c,e.isAllInterfaces=g,e.isPortPrivileged=f,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var T;(function(I){I.Http="http",I.Https="https"})(T||(e.TunnelProtocol=T={}));var y;(function(I){I.ConstantPrivate="constantPrivate",I.Private="private",I.Public="public"})(y||(e.TunnelPrivacyId=y={}));function P(I){return!!I.forwardPort}var S;(function(I){I[I.Notify=1]="Notify",I[I.OpenBrowser=2]="OpenBrowser",I[I.OpenPreview=3]="OpenPreview",I[I.Silent=4]="Silent",I[I.Ignore=5]="Ignore",I[I.OpenBrowserOnce=6]="OpenBrowserOnce"})(S||(e.ProvidedOnAutoForward=S={}));function u(I){if(I.scheme!=="http"&&I.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(I.authority);if(d)return{address:d[1],port:+d[2]}}function p(I){if(I.scheme!=="http"&&I.scheme!=="https"||!I.query)return;const d=I.query.split("&");for(const v of d){const t=v.split("=")[1];if(/^https?:/.exec(t)){const r=u(A.URI.parse(t));if(r)return r}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function c(I){return e.LOCALHOST_ADDRESSES.indexOf(I)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(I){return e.ALL_INTERFACES_ADDRESSES.indexOf(I)>=0}function f(I,d,v,t){if(v===a.OperatingSystem.Windows)return!1;if(v===a.OperatingSystem.Macintosh&&g(d)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(r?.length===4&&parseInt(r[1])>=18)return!1}return I<1024}class h{constructor(d,v,t){this.remoteAddress=d,this.localAddress=v,this._dispose=t,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=h;let E=class{constructor(d,v){this.logService=d,this.configurationService=v,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions,this._canChangeProtocol=d.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],v=Array.from(this._tunnels.values());for(const t of v){const r=Array.from(t.values());for(const s of r){const i=await s.value;i&&typeof i!="string"&&d.push(i)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:v}of d.values())await v.then(t=>typeof t!="string"?t?.dispose():void 0);d.clear()}this._tunnels.clear()}setEnvironmentTunnel(d,v,t,r,s){this.addTunnelToMap(d,v,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:v,localAddress:t,privacy:r,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,v){(g(d)||c(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const t=this.getTunnelFromMap(d,v);if(t)return++t.refcount,t.value}openTunnel(d,v,t,r,s,i=!1,n,o){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${t} on local port ${s}.`);const l=this._tunnelProvider??d;if(!l)return;if(v||(v="localhost"),r||(r=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(t)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const m=this.retainOrCreateTunnel(l,v,t,r,s,i,n,o);return m?m.then(w=>{if(w){if(typeof w=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(v,t),w}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(v,t);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const C=this.makeTunnel(w);return(w.tunnelRemoteHost!==v||w.tunnelRemotePort!==t)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&w.privacy!==n&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(C),C}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const v=this._tunnels.get(d.tunnelRemoteHost);if(v){const t=v.get(d.tunnelRemotePort);t&&(t.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,t))}}}}async tryDisposeTunnel(d,v,t){if(t.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${v}.`);const r=t.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(v),r}}async closeTunnel(d,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${v} `);const t=this._tunnels.get(d);if(t&&t.has(v)){const r=t.get(v);r.refcount=0,await this.tryDisposeTunnel(d,v,r)}}addTunnelToMap(d,v,t){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(v,{refcount:1,value:t})}async removeEmptyOrErrorTunnelFromMap(d,v){const t=this._tunnels.get(d);if(t){const r=t.get(v),s=r?await r.value:void 0;(!s||typeof s=="string")&&t.delete(v),t.size===0&&this._tunnels.delete(d)}}getTunnelFromMap(d,v){const t=[d];c(d)?(t.push(...e.LOCALHOST_ADDRESSES),t.push(...e.ALL_INTERFACES_ADDRESSES)):g(d)&&t.push(...e.ALL_INTERFACES_ADDRESSES);const r=t.map(s=>this._tunnels.get(s));for(const s of r){const i=s?.get(v);if(i)return i}}canTunnel(d){return!!u(d)}createWithProvider(d,v,t,r,s,i,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${t} on local port ${r}.`);const o=t;this._factoryInProgress.add(o);const l=r===void 0?t:r,m={elevationRequired:s?this.isPortPrivileged(l):!1},w={remoteAddress:{host:v,port:t},localAddressPort:r,privacy:i,public:i?i!==y.Private:void 0,protocol:n},C=d.forwardPort(w,m);return C?(this.addTunnelToMap(v,t,C),C.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),C}};e.AbstractTunnelService=E,e.AbstractTunnelService=E=we([Q(0,_.ILogService),Q(1,L.IConfigurationService)],E)}),define(le[239],ue([0,1,10,81,2,8,6]),function(ne,e,D,a,A,L,k){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class T extends A.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new k.DeferredPromise),this._addressPromise.p)}setAddress(S){this._address=S,this._addressPromise&&(this._addressPromise.complete(S),this._addressPromise=null)}setTunnel(S){this._register(S)}}let y=class extends A.Disposable{static{_=this}static{this._lastId=0}constructor(S,u){super(),this._tunnelService=S,this._logService=u,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(S=>S.dispose())}async createTunnel(){return{id:String(++_._lastId)}}async startTunnel(S,u,p,c,g,f,h){const E=new T,I=await Promise.resolve(this._tunnelService.openTunnel(S,E,p,c,g,f,h));if(!I||typeof I=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${c} (remote).`),E.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(u))throw this._disposedTunnels.delete(u),E.dispose(),await I.dispose(),(0,L.canceled)();return E.setTunnel(I),this._tunnels.set(u,E),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${u}: ${I.localAddress} (local) to ${p}:${c} (remote).`),{tunnelLocalPort:I.tunnelLocalPort,localAddress:I.localAddress}}async setAddress(S,u){const p=this._tunnels.get(S);p&&p.setAddress(u)}async destroyTunnel(S){const u=this._tunnels.get(S);if(u){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${S}.`),this._tunnels.delete(S),await u.dispose();return}this._disposedTunnels.add(S)}};e.SharedProcessTunnelService=y,e.SharedProcessTunnelService=y=_=we([Q(0,a.ISharedTunnelsService),Q(1,D.ILogService)],y)}),define(le[29],ue([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(le[240],ue([0,1,29,196,7,21,133,3,2]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class y{static{this._clock=0}constructor(u){this.uri=u,this.time=y._clock++}touch(){return this.time=y._clock++,this}}let P=class{constructor(u){this._fileService=u,this._dispooables=new T.DisposableStore,this._limit=2**16;const p=new Map,c=g=>{let f=p.get(g.scheme);return f===void 0&&(f=u.hasProvider(g)&&!this._fileService.hasCapability(g,A.FileSystemProviderCapabilities.PathCaseSensitive),p.set(g.scheme,f)),f};this._dispooables.add(_.Event.any(u.onDidChangeFileSystemProviderRegistrations,u.onDidChangeFileSystemProviderCapabilities)(g=>{p.delete(g.scheme)})),this.extUri=new L.ExtUri(c),this._canonicalUris=new k.SkipList((g,f)=>this.extUri.compare(g,f,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(u){this._fileService.hasProvider(u)&&(u=(0,L.normalizePath)(u));const p=this._canonicalUris.get(u);return p?p.touch().uri.with({fragment:u.fragment}):(this._canonicalUris.set(u,new y(u)),this._checkTrim(),u)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const u=[...this._canonicalUris.entries()].sort((c,g)=>c[1].time<g[1].time?1:c[1].time>g[1].time?-1:0);y._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let c=0;c<p;c++)this._canonicalUris.set(u[c][0],u[c][1].touch())}};e.UriIdentityService=P,e.UriIdentityService=P=we([Q(0,A.IFileService)],P),(0,a.registerSingleton)(D.IUriIdentityService,P,a.InstantiationType.Delayed)}),define(le[241],ue([0,1,3,2,7,52,35]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class _ extends a.Disposable{constructor(y,P,S,u,p,c){super(),this.fileSystemScheme=y,this.fileSystemProvider=P,this.userDataScheme=S,this.userDataProfilesService=u,this.uriIdentityService=p,this.logService=c,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=L.TernarySearchTree.forUris(()=>!(this.capabilities&A.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new k.ResourceSet(g=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(g))),this.updateAtomicReadWritesResources(),this._register(u.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(g=>this.handleFileChanges(g)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const y of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(y.settingsResource),this.atomicReadWriteResources.add(y.keybindingsResource),this.atomicReadWriteResources.add(y.tasksResource),this.atomicReadWriteResources.add(y.extensionsResource)}open(y,P){return this.fileSystemProvider.open(this.toFileSystemResource(y),P)}close(y){return this.fileSystemProvider.close(y)}read(y,P,S,u,p){return this.fileSystemProvider.read(y,P,S,u,p)}write(y,P,S,u,p){return this.fileSystemProvider.write(y,P,S,u,p)}watch(y,P){this.watchResources.set(y,y);const S=this.fileSystemProvider.watch(this.toFileSystemResource(y),P);return(0,a.toDisposable)(()=>{this.watchResources.delete(y),S.dispose()})}stat(y){return this.fileSystemProvider.stat(this.toFileSystemResource(y))}mkdir(y){return this.fileSystemProvider.mkdir(this.toFileSystemResource(y))}rename(y,P,S){return this.fileSystemProvider.rename(this.toFileSystemResource(y),this.toFileSystemResource(P),S)}readFile(y,P){return this.fileSystemProvider.readFile(this.toFileSystemResource(y),P)}readFileStream(y,P,S){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(y),P,S)}readdir(y){return this.fileSystemProvider.readdir(this.toFileSystemResource(y))}enforceAtomicReadFile(y){return this.atomicReadWriteResources.has(y)}writeFile(y,P,S){return this.fileSystemProvider.writeFile(this.toFileSystemResource(y),P,S)}enforceAtomicWriteFile(y){return this.atomicReadWriteResources.has(y)?{postfix:".vsctmp"}:!1}delete(y,P){return this.fileSystemProvider.delete(this.toFileSystemResource(y),P)}copy(y,P,S){if((0,A.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(y),this.toFileSystemResource(P),S);throw new Error("copy not supported")}cloneFile(y,P){if((0,A.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(y),this.toFileSystemResource(P));throw new Error("clone not supported")}handleFileChanges(y){const P=[];for(const S of y){if(S.resource.scheme!==this.fileSystemScheme)continue;const u=this.toUserDataResource(S.resource);this.watchResources.findSubstr(u)&&P.push({resource:u,type:S.type,cId:S.cId})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(y){return y.with({scheme:this.fileSystemScheme})}toUserDataResource(y){return y.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=_}),define(le[82],ue([0,1,63]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.getLineStartOffset=A,e.getLineEndOffset=L;function a(k,_,T,y){const P=(0,D.setProperty)(k,_,T,y)[0];return P&&(k=k.substring(0,P.offset)+P.content+k.substring(P.offset+P.length)),k}function A(k,_,T){let y=T;for(;y>=0;){if(k.charAt(y)===_.charAt(_.length-1)&&_.length===1)return y+1;if(y--,_.length===2&&y>=0&&k.charAt(y)===_.charAt(0))return y+2}return 0}function L(k,_,T){let y=T;for(;y>=0;)if(k.charAt(y)===_.charAt(_.length-1)&&_.length===1||(y++,_.length===2&&y>=0&&k.charAt(y)===_.charAt(1)))return y;return k.length-1}}),define(le[242],ue([0,1,30,56,13]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=L;function L(p,c,g,f,h,E){const I=[],d=[],v=[];if(!c){const F=p.filter(({identifier:K})=>h.every(H=>H.toLowerCase()!==K.id.toLowerCase()));return{local:{added:I,removed:d,updated:v},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}p=p.map(S),c=c.map(S),g=g?g.map(S):null;const t=new Map,r=F=>{F.uuid&&t.set(F.id.toLowerCase(),F.uuid)};p.forEach(({identifier:F})=>r(F)),c.forEach(({identifier:F})=>r(F)),g?.forEach(({identifier:F})=>r(F)),f?.forEach(({identifier:F})=>r(F)),E?.forEach(F=>r(F));const s=F=>{const K=F.identifier.uuid||t.get(F.identifier.id.toLowerCase());return K?`uuid:${K}`:`id:${F.identifier.id.toLowerCase()}`},i=(F,K)=>(F.set(s(K),K),F),n=p.reduce(i,new Map),o=c.reduce(i,new Map),l=c.reduce((F,K)=>i(F,(0,D.deepClone)(K)),new Map),m=g?g.reduce(i,new Map):null,w=f.reduce(i,new Map),C=h.reduce((F,K)=>{const H=t.get(K.toLowerCase());return F.add(H?`uuid:${H}`:`id:${K.toLowerCase()}`)},new Set),b=E?E.reduce((F,{id:K,uuid:H})=>(H=H??t.get(K.toLowerCase()),F.add(H?`uuid:${H}`:`id:${K.toLowerCase()}`)),new Set):null,R=k(n,o,C,!1);if(R.added.size>0||R.removed.size>0||R.updated.size>0){const F=k(m,n,C,!1),K=k(m,o,C,!0),H=(X,j,ie,z)=>{let B,ee,se;return j.installed?(B=z.pinned,se=z.preRelease,B&&(ee=z.version)):(B=ie.pinned,se=ie.preRelease,B&&(ee=ie.version)),B===void 0&&(B=j.pinned,B&&(ee=j.version)),se===void 0&&(se=j.preRelease),{...z,installed:j.installed||ie.installed,pinned:B,preRelease:se,version:ee??(ie.version&&(!j.installed||a.gt(ie.version,j.version))?ie.version:j.version),state:T(j,ie,m?.get(X))}};for(const X of K.removed.values()){const j=n.get(X);if(!j)continue;const ie=(0,A.assertIsDefined)(m?.get(X)),z=b&&!b.has(X)&&ie.installed;j.installed&&z?d.push(j.identifier):l.set(X,j)}for(const X of K.added.values()){const j=(0,A.assertIsDefined)(o.get(X)),ie=n.get(X);if(ie){if(R.updated.has(X)){const z=H(X,ie,j,j);_(ie,j,!1,!1)||v.push(u(z,X)),l.set(X,z)}}else j.installed&&I.push(u(j,X))}for(const X of K.updated.values()){const j=(0,A.assertIsDefined)(o.get(X)),ie=(0,A.assertIsDefined)(m?.get(X)),z=n.get(X);if(z)if(b&&!b.has(X)&&ie.installed&&z.installed&&!j.installed)d.push(z.identifier);else{const ee=H(X,z,j,j);v.push(u(ee,X)),l.set(X,ee)}else j.installed&&I.push(u(j,X))}for(const X of F.added.values())K.added.has(X)||l.set(X,(0,A.assertIsDefined)(n.get(X)));for(const X of F.updated.values()){if(K.removed.has(X)||K.updated.has(X))continue;const j=(0,A.assertIsDefined)(n.get(X)),ie=(0,A.assertIsDefined)(o.get(X));l.set(X,H(X,j,ie,j))}for(const X of F.removed.values())K.updated.has(X)||K.removed.has(X)||w.has(X)||(0,A.assertIsDefined)(o.get(X)).installed&&b&&(b.has(X)||!(0,A.assertIsDefined)(m?.get(X)).installed||l.delete(X))}const U=[],N=k(o,l,new Set,!0),M=N.added.size>0||N.updated.size>0||N.removed.size>0;return M&&l.forEach((F,K)=>U.push(u(F,K))),{local:{added:I,removed:d,updated:v},remote:M?{added:[...N.added].map(F=>l.get(F)),updated:[...N.updated].map(F=>l.get(F)),removed:[...N.removed].map(F=>o.get(F)),all:U}:null}}function k(p,c,g,f){const h=p?[...p.keys()].filter(t=>!g.has(t)):[],E=[...c.keys()].filter(t=>!g.has(t)),I=E.filter(t=>!h.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),d=h.filter(t=>!E.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),v=new Set;for(const t of h){if(d.has(t))continue;const r=p.get(t),s=c.get(t);(!s||!_(r,s,f,!0))&&v.add(t)}return{added:I,removed:d,updated:v}}function _(p,c,g,f){return!(p.disabled!==c.disabled||!!p.isApplicationScoped!=!!c.isApplicationScoped||f&&p.installed!==c.installed||p.installed&&c.installed&&(p.preRelease!==c.preRelease||p.pinned!==c.pinned||c.pinned&&p.version!==c.version)||!P(p.state,c.state)||g&&p.version!==c.version)}function T(p,c,g){const f=p.state,h=c.state,E=g?.state;if(!c.version||f&&a.gt(p.version,c.version))return f;if(h&&a.gt(c.version,p.version)||!f)return h;if(!h)return f;const I=(0,D.deepClone)(f),d=E?y(E,h):{added:Object.keys(h).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set},v=E?y(E,f):{added:Object.keys(f).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set};for(const t of[...d.added.values(),...d.updated.values()])I[t]=h[t];for(const t of d.removed.values())v.updated.has(t)||delete I[t];return I}function y(p,c){const g=Object.keys(p),f=Object.keys(c),h=f.filter(d=>!g.includes(d)).reduce((d,v)=>(d.add(v),d),new Set),E=g.filter(d=>!f.includes(d)).reduce((d,v)=>(d.add(v),d),new Set),I=new Set;for(const d of g){if(E.has(d))continue;const v=p[d],t=c[d];(0,D.equals)(v,t)||I.add(d)}return{added:h,removed:E,updated:I}}function P(p={},c={}){const{added:g,removed:f,updated:h}=y(p,c);return g.size===0&&f.size===0&&h.size===0}function S(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function u(p,c){const g={...p,identifier:{id:p.identifier.id,uuid:c.startsWith("uuid:")?c.substring(5):void 0},preRelease:!!p.preRelease,pinned:!!p.pinned};return p.disabled||delete g.disabled,p.installed||delete g.installed,p.state||delete g.state,p.isApplicationScoped||delete g.isApplicationScoped,g}}),define(le[115],ue([0,1,19,22,4]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(_){this.configurationService=_}hasToNeverSyncExtension(_){return this.getConfiguredIgnoredExtensions().includes(_.toLowerCase())}hasToAlwaysSyncExtension(_){return this.getConfiguredIgnoredExtensions().includes(`-${_.toLowerCase()}`)}updateIgnoredExtensions(_,T){let y=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return y=y.filter(P=>P!==_&&P!==`-${_}`),T&&y.push(_.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(_,T){let y=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return y=y.filter(P=>P!==_&&P!==`-${_}`),T&&y.push(`-${_.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(_){const T=_.filter(u=>u.isMachineScoped).map(u=>u.identifier.id.toLowerCase()),y=this.getConfiguredIgnoredExtensions().map(u=>u.toLowerCase()),P=[],S=[];if(Array.isArray(y))for(const u of y)u.startsWith("-")?S.push(u.substring(1)):P.push(u);return(0,D.distinct)([...T,...P].filter(u=>!S.includes(u)))}getConfiguredIgnoredExtensions(){let _=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return _!==void 0||(_=this.configurationService.inspect("sync.ignoredExtensions").userValue,_!==void 0)?_:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(T=>T.toLowerCase())}};e.IgnoredExtensionsManagementService=L,e.IgnoredExtensionsManagementService=L=we([Q(0,a.IConfigurationService)],L)}),define(le[243],ue([0,1,19,34,30,97,82]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=T;function _(d){return(0,a.parse)(d)||[]}async function T(d,v,t,r,s){const i=_(d),n=_(v),o=t?_(t):null,l=[...i,...n,...o||[]].map(H=>H.key),m=await s.resolveUserBindings(l),w=P(i,n,o,m);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const C=u(i),b=u(n),R=o?u(o):null,U=c(C,b,m),N=R?c(R,C,m):{added:[...C.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},M=R?c(R,b,m):{added:[...b.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},F=y(U,N,M);let K=d;for(const H of F.removed.values())F.conflicts.has(H)||(K=E(K,H,r));for(const H of F.added.values()){if(F.conflicts.has(H))continue;const X=b.get(H);if(X.some(j=>j.command!==`-${H}`&&w.conflicts.has(m[j.key]))){F.conflicts.add(H);continue}K=h(K,X,r)}for(const H of F.updated.values()){if(F.conflicts.has(H))continue;const X=b.get(H);if(X.some(j=>j.command!==`-${H}`&&w.conflicts.has(m[j.key]))){F.conflicts.add(H);continue}K=I(K,H,X,r)}return{mergeContent:K,hasChanges:!0,hasConflicts:F.conflicts.size>0}}function y(d,v,t){const r=new Set,s=new Set,i=new Set,n=new Set;for(const o of v.removed.values())t.updated.has(o)&&n.add(o);for(const o of t.removed.values())n.has(o)||(v.updated.has(o)?n.add(o):s.add(o));for(const o of v.added.values())n.has(o)||t.added.has(o)&&d.updated.has(o)&&n.add(o);for(const o of t.added.values())n.has(o)||(v.added.has(o)?d.updated.has(o)&&n.add(o):r.add(o));for(const o of v.updated.values())n.has(o)||t.updated.has(o)&&d.updated.has(o)&&n.add(o);for(const o of t.updated.values())n.has(o)||(v.updated.has(o)?d.updated.has(o)&&n.add(o):i.add(o));return{added:r,removed:s,updated:i,conflicts:n}}function P(d,v,t,r){const s=new Set,i=S(d,r),n=S(v,r),o=t?S(t,r):null,l=p(i,n);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const m=o?p(o,i):{added:[...i.keys()].reduce((N,M)=>(N.add(M),N),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const w=o?p(o,n):{added:[...n.keys()].reduce((N,M)=>(N.add(M),N),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:C,removed:b,updated:R,conflicts:U}=y(l,m,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:C,removed:b,updated:R,conflicts:U}}function S(d,v){const t=new Map;for(const r of d){const s=v[r.key];let i=t.get(s);i||(i=[],t.set(s,i)),i.push(r)}return t}function u(d){const v=new Map;for(const t of d){const r=t.command[0]==="-"?t.command.substring(1):t.command;let s=v.get(r);s||(s=[],v.set(r,s)),s.push(t)}return v}function p(d,v){const t=[...d.keys()],r=[...v.keys()],s=r.filter(o=>!t.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),i=t.filter(o=>!r.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),n=new Set;for(const o of t){if(i.has(o))continue;const l=d.get(o).map(w=>({...w,key:o})),m=v.get(o).map(w=>({...w,key:o}));(0,D.equals)(l,m,(w,C)=>f(w,C))||n.add(o)}return{added:s,removed:i,updated:n}}function c(d,v,t){const r=[...d.keys()],s=[...v.keys()],i=s.filter(l=>!r.includes(l)).reduce((l,m)=>(l.add(m),l),new Set),n=r.filter(l=>!s.includes(l)).reduce((l,m)=>(l.add(m),l),new Set),o=new Set;for(const l of r){if(n.has(l))continue;const m=d.get(l).map(C=>({...C,key:t[C.key]})),w=v.get(l).map(C=>({...C,key:t[C.key]}));g(m,w)||o.add(l)}return{added:i,removed:n,updated:o}}function g(d,v){return!(!(0,D.equals)(d.filter(({command:t})=>t[0]!=="-"),v.filter(({command:t})=>t[0]!=="-"),(t,r)=>f(t,r))||!(0,D.equals)(d.filter(({command:t})=>t[0]==="-"),v.filter(({command:t})=>t[0]==="-"),(t,r)=>f(t,r)))}function f(d,v){if(d.command!==v.command||d.key!==v.key)return!1;const t=L.ContextKeyExpr.deserialize(d.when),r=L.ContextKeyExpr.deserialize(v.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!A.equals(d.args,v.args))}function h(d,v,t){for(const r of v)d=k.edit(d,[-1],r,t);return d}function E(d,v,t){const r=_(d);for(let s=r.length-1;s>=0;s--)(r[s].command===v||r[s].command===`-${v}`)&&(d=k.edit(d,[s],void 0,t));return d}function I(d,v,t,r){const s=_(d),i=s.findIndex(n=>n.command===v||n.command===`-${v}`);for(let n=s.length-1;n>=0;n--)(s[n].command===v||s[n].command===`-${v}`)&&(d=k.edit(d,[n],void 0,r));for(let n=t.length-1;n>=0;n--)d=k.edit(d,[i],t[n],r);return d}}),define(le[244],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=D,e.areSame=A;function D(L,k,_){const T={},y={},P=new Set;if(!k)return{local:{added:T,updated:y,removed:[...P.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const S=a(L,k);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:T,updated:y,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const u=a(_,L),p=a(_,k),c={},g={},f=new Set,h=new Set;for(const E of u.removed.values())p.updated.has(E)?T[E]=k[E]:f.add(E);for(const E of p.removed.values())h.has(E)||(u.updated.has(E)?h.add(E):P.add(E));for(const E of u.updated.values())h.has(E)||(p.updated.has(E)?S.updated.has(E)&&h.add(E):g[E]=L[E]);for(const E of p.updated.values())h.has(E)||(u.updated.has(E)?S.updated.has(E)&&h.add(E):L[E]!==void 0&&(y[E]=k[E]));for(const E of u.added.values())h.has(E)||(p.added.has(E)?S.updated.has(E)&&h.add(E):c[E]=L[E]);for(const E of p.added.values())h.has(E)||(u.added.has(E)?S.updated.has(E)&&h.add(E):T[E]=k[E]);return{local:{added:T,removed:[...P.values()],updated:y},remote:{added:c,removed:[...f.values()],updated:g},conflicts:[...h.values()]}}function a(L,k){const _=L?Object.keys(L):[],T=k?Object.keys(k):[],y=T.filter(u=>!_.includes(u)).reduce((u,p)=>(u.add(p),u),new Set),P=_.filter(u=>!T.includes(u)).reduce((u,p)=>(u.add(p),u),new Set),S=new Set;for(const u of _){if(P.has(u))continue;const p=L[u],c=k[u];p!==c&&S.add(u)}return{added:y,removed:P,updated:S}}function A(L,k){const{added:_,removed:T,updated:y}=a(L,k);return _.size===0&&T.size===0&&y.size===0}}),define(le[245],ue([0,1,30]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=a;function a(L,k,_,T){const y={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!k){const u=L.filter(({id:p})=>!T.includes(p));return u.length?P.added=u:P=null,{local:y,remote:P}}const S=A(L,k,T);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const u=A(_,L,T),p=A(_,k,T);for(const c of p.removed){const g=L.find(f=>f.id===c);g&&y.removed.push(g)}for(const c of p.added){const g=k.find(f=>f.id===c);u.added.includes(c)?S.updated.includes(c)&&y.updated.push(g):y.added.push(g)}for(const c of p.updated)y.updated.push(k.find(g=>g.id===c));for(const c of u.added)p.added.includes(c)||P.added.push(L.find(g=>g.id===c));for(const c of u.updated)p.removed.includes(c)||p.updated.includes(c)||P.updated.push(L.find(g=>g.id===c));for(const c of u.removed){const g=k.find(f=>f.id===c);g&&P.removed.push(g)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:y,remote:P}}function A(L,k,_){L=L?L.filter(({id:p})=>!_.includes(p)):[],k=k.filter(({id:p})=>!_.includes(p));const T=L.map(({id:p})=>p),y=k.map(({id:p})=>p),P=y.filter(p=>!T.includes(p)),S=T.filter(p=>!y.includes(p)),u=[];for(const{id:p,name:c,shortName:g,icon:f,useDefaultFlags:h}of L){if(S.includes(p))continue;const E=k.find(I=>I.id===p);(!E||E.name!==c||E.shortName!==g||E.icon!==f||!(0,D.equals)(E.useDefaultFlags,h))&&u.push(p)}return{added:P,removed:S,updated:u}}}),define(le[25],ue([0,1,19,13,185,48,28,4,104,45]),function(ne,e,D,a,A,L,k,_,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncLocalStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=void 0,e.getDisallowedIgnoredSettings=P,e.getDefaultIgnoredSettings=S,e.registerConfiguration=u,e.isAuthenticationProvider=p,e.getPathSegments=g,e.getLastSyncResourceUri=f,e.createSyncHeaders=h,e.getEnablementKey=i;function P(){const n=y.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(n).filter(o=>!!n[o].disallowSyncIgnore)}function S(){const n=y.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(n).filter(w=>!!n[w].ignoreSync),l=Object.keys(n).filter(w=>n[w].scope===L.ConfigurationScope.MACHINE||n[w].scope===L.ConfigurationScope.MACHINE_OVERRIDABLE),m=P();return(0,D.distinct)([...o,...l,...m])}e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function u(){const n="vscode://schemas/ignoredSettings",o=y.Registry.as(L.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:L.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:L.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:L.ConfigurationScope.APPLICATION,$ref:n,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=y.Registry.as(T.Extensions.JSONContribution),m=()=>{const w=P(),C=S(),b=Object.keys(L.allSettings.properties).filter(N=>!C.includes(N)),R=C.filter(N=>!w.includes(N)),U={items:{type:"string",enum:[...b,...R.map(N=>`-${N}`)]}};l.registerSchema(n,U)};return o.onDidUpdateConfiguration(()=>m())}function p(n){return n&&(0,a.isObject)(n)&&(0,a.isString)(n.id)&&Array.isArray(n.scopes)}var c;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState",n.Profiles="profiles",n.WorkspaceState="workspaceState"})(c||(e.SyncResource=c={})),e.ALL_SYNC_RESOURCES=[c.Settings,c.Keybindings,c.Snippets,c.Tasks,c.Extensions,c.GlobalState,c.Profiles];function g(n,...o){return n?[n,...o]:o}function f(n,o,l,m){return m.joinPath(l.userDataSyncHome,...g(n,o,`lastSync${o}.json`))}e.IUserDataSyncStoreManagementService=(0,_.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,_.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncLocalStoreService=(0,_.createDecorator)("IUserDataSyncLocalStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function h(n){const o={};return o[e.HEADER_EXECUTION_ID]=n,o}var E;(function(n){n.Unauthorized="Unauthorized",n.Forbidden="Forbidden",n.NotFound="NotFound",n.MethodNotFound="MethodNotFound",n.Conflict="Conflict",n.Gone="Gone",n.PreconditionFailed="PreconditionFailed",n.TooLarge="TooLarge",n.UpgradeRequired="UpgradeRequired",n.PreconditionRequired="PreconditionRequired",n.TooManyRequests="RemoteTooManyRequests",n.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",n.RequestFailed="RequestFailed",n.RequestCanceled="RequestCanceled",n.RequestTimeout="RequestTimeout",n.RequestProtocolNotSupported="RequestProtocolNotSupported",n.RequestPathNotEscaped="RequestPathNotEscaped",n.RequestHeadersNotObject="RequestHeadersNotObject",n.NoCollection="NoCollection",n.NoRef="NoRef",n.EmptyResponse="EmptyResponse",n.TurnedOff="TurnedOff",n.SessionExpired="SessionExpired",n.ServiceChanged="ServiceChanged",n.DefaultServiceChanged="DefaultServiceChanged",n.LocalTooManyProfiles="LocalTooManyProfiles",n.LocalTooManyRequests="LocalTooManyRequests",n.LocalPreconditionFailed="LocalPreconditionFailed",n.LocalInvalidContent="LocalInvalidContent",n.LocalError="LocalError",n.IncompatibleLocalContent="IncompatibleLocalContent",n.IncompatibleRemoteContent="IncompatibleRemoteContent",n.Unknown="Unknown"})(E||(e.UserDataSyncErrorCode=E={}));class I extends Error{constructor(o,l,m,w){super(o),this.code=l,this.resource=m,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=I;class d extends I{constructor(o,l,m,w,C){super(o,m,void 0,C),this.url=l,this.serverCode=w}}e.UserDataSyncStoreError=d;class v extends I{constructor(o,l){super(o,l)}}e.UserDataAutoSyncError=v,function(n){function o(l){if(l instanceof n)return l;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(m&&m[1]){const w=m[2]==="unknown"?void 0:m[2],C=m[3]==="unknown"?void 0:m[3];return new n(l.message,m[1],w,C)}return new n(l.message,E.Unknown)}n.toUserDataSyncError=o}(I||(e.UserDataSyncError=I={}));var t;(function(n){n.Uninitialized="uninitialized",n.Idle="idle",n.Syncing="syncing",n.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var r;(function(n){n[n.None=0]="None",n[n.Added=1]="Added",n[n.Modified=2]="Modified",n[n.Deleted=3]="Deleted"})(r||(e.Change=r={}));var s;(function(n){n.Preview="preview",n.Conflict="conflict",n.Accepted="accepted"})(s||(e.MergeState=s={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(n){return`sync.enable.${n}`}e.IUserDataSyncEnablementService=(0,_.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,_.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,_.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,_.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,_.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,_.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(le[246],ue([0,1,30,25]),function(ne,e,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=A;function A(k,_,T,y,P){if(!_)return{remote:{added:Object.keys(k),removed:[],updated:[],all:Object.keys(k).length>0?k:null},local:{added:{},removed:[],updated:{}}};const S=L(k,_);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const u=T?L(T,_):{added:Object.keys(_).reduce((E,I)=>(E.add(I),E),new Set),removed:new Set,updated:new Set},p=T?L(T,k):{added:Object.keys(k).reduce((E,I)=>(E.add(I),E),new Set),removed:new Set,updated:new Set},c={added:{},removed:[],updated:{}},g=D.deepClone(_),f=!T;for(const E of p.added.values())E!==a.SYNC_SERVICE_URL_TYPE&&f&&u.added.has(E)||(g[E]=k[E]);for(const E of p.updated.values())g[E]=k[E];for(const E of p.removed.values())y.unregistered.includes(E)||delete g[E];for(const E of u.added.values()){const I=_[E];if(y.machine.includes(E)){P.info(`GlobalState: Skipped adding ${E} in local storage because it is declared as machine scoped.`);continue}if(T&&p.added.has(E))continue;const d=k[E];d&&d.value===I.value||E===a.SYNC_SERVICE_URL_TYPE&&f&&p.added.has(E)||(d?c.updated[E]=I:c.added[E]=I)}for(const E of u.updated.values()){const I=_[E];if(y.machine.includes(E)){P.info(`GlobalState: Skipped updating ${E} in local storage because it is declared as machine scoped.`);continue}if(p.updated.has(E)||p.removed.has(E))continue;const d=k[E];d&&d.value===I.value||(c.updated[E]=I)}for(const E of u.removed.values()){if(y.machine.includes(E)){P.trace(`GlobalState: Skipped removing ${E} in local storage because it is declared as machine scoped.`);continue}p.updated.has(E)||p.removed.has(E)||c.removed.push(E)}const h=L(_,g);return{local:c,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:g}}}function L(k,_){const T=Object.keys(k),y=Object.keys(_),P=y.filter(p=>!T.includes(p)).reduce((p,c)=>(p.add(c),p),new Set),S=T.filter(p=>!y.includes(p)).reduce((p,c)=>(p.add(c),p),new Set),u=new Set;for(const p of T){if(S.has(p))continue;const c=k[p],g=_[p];D.equals(c,g)||u.add(p)}return{added:P,removed:S,updated:u}}}),define(le[247],ue([0,1,19,34,63,46,30,82,25]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getIgnoredSettings=y,e.removeComments=u,e.updateIgnoredSettings=p,e.merge=c,e.isEmpty=f,e.addSetting=E;function y(l,m,w){let C=[];w?C=S(w):C=P(m);const b=[],R=[...(0,T.getDisallowedIgnoredSettings)()];if(Array.isArray(C))for(const U of C)U.startsWith("-")?R.push(U.substring(1)):b.push(U);return(0,D.distinct)([...l,...b].filter(U=>!R.includes(U)))}function P(l){let m=l.inspect("settingsSync.ignoredSettings").userValue;return m!==void 0||(m=l.inspect("sync.ignoredSettings").userValue,m!==void 0)?m:l.getValue("settingsSync.ignoredSettings")||[]}function S(l){const m=(0,a.parse)(l);return m?m["settingsSync.ignoredSettings"]||m["sync.ignoredSettings"]||[]:[]}function u(l,m){const w=(0,a.parse)(l)||{};let C="{}";for(const b of Object.keys(w)){const R=(0,A.setProperty)(C,[b],w[b],m);C=(0,A.applyEdits)(C,R)}return C}function p(l,m,w,C){if(w.length){const b=o(m),R=(0,a.parse)(m)||{},U=(0,a.parse)(l);if(!U)return l;const N=[];for(const M of w){const F=R[M],K=U[M];F===void 0?l=_.edit(l,[M],void 0,C):K!==void 0?l=_.edit(l,[M],F,C):N.push(t(M,b))}N.sort((M,F)=>M.startOffset-F.startOffset),N.forEach(M=>l=E(M.setting.key,m,l,C))}return l}function c(l,m,w,C,b,R){const U=p(l,m,C,R),N=w!==U,M=w!==m;if(!N&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!M)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(M&&!N)return{conflictsSettings:[],localContent:p(m,l,C,R),remoteContent:null,hasConflicts:!1};if(w===null&&f(l)){const O=g(l,m,C)?null:p(m,l,C,R);return{conflictsSettings:[],localContent:O,remoteContent:null,hasConflicts:!1}}let F=l,K=m;const H=(0,a.parse)(l),X=(0,a.parse)(m),j=w?(0,a.parse)(w):null,ie=C.reduce((O,$)=>(O.add($),O),new Set),z=h(H,X,ie),B=h(j,H,ie),ee=h(j,X,ie),se=new Map,ce=new Set,W=O=>{ce.add(O);const $=b.filter(({key:x})=>x===O)[0];$?(F=_.edit(F,[O],$.value,R),K=_.edit(K,[O],$.value,R)):se.set(O,{key:O,localValue:H[O],remoteValue:X[O]})};for(const O of B.removed.values())ee.updated.has(O)?W(O):K=_.edit(K,[O],void 0,R);for(const O of ee.removed.values())ce.has(O)||(B.updated.has(O)?W(O):F=_.edit(F,[O],void 0,R));for(const O of B.updated.values())ce.has(O)||(ee.updated.has(O)?z.updated.has(O)&&W(O):K=_.edit(K,[O],H[O],R));for(const O of ee.updated.values())ce.has(O)||(B.updated.has(O)?z.updated.has(O)&&W(O):F=_.edit(F,[O],X[O],R));for(const O of B.added.values())ce.has(O)||(ee.added.has(O)?z.updated.has(O)&&W(O):K=E(O,F,K,R));for(const O of ee.added.values())ce.has(O)||(B.added.has(O)?z.updated.has(O)&&W(O):F=E(O,K,F,R));const J=se.size>0||!g(F,K,C),G=J||!g(F,l,[]),V=J||!g(K,m,[]);return{localContent:G?F:null,remoteContent:V?K:null,conflictsSettings:[...se.values()],hasConflicts:J}}function g(l,m,w){if(l===m)return!0;const C=(0,a.parse)(l),b=(0,a.parse)(m),R=w.reduce((M,F)=>(M.add(F),M),new Set),U=o(l).filter(M=>!(M.setting&&R.has(M.setting.key))),N=o(m).filter(M=>!(M.setting&&R.has(M.setting.key)));if(U.length!==N.length)return!1;for(let M=0;M<U.length;M++){const F=U[M],K=N[M];if(F.setting&&K.setting){if(F.setting.key!==K.setting.key||!k.equals(C[F.setting.key],b[F.setting.key]))return!1}else if(!F.setting&&!K.setting){if(F.value!==K.value)return!1}else return!1}return!0}function f(l){return l?o(l).length===0:!0}function h(l,m,w){const C=l?Object.keys(l).filter(M=>!w.has(M)):[],b=Object.keys(m).filter(M=>!w.has(M)),R=b.filter(M=>!C.includes(M)).reduce((M,F)=>(M.add(F),M),new Set),U=C.filter(M=>!b.includes(M)).reduce((M,F)=>(M.add(F),M),new Set),N=new Set;if(l)for(const M of C){if(U.has(M))continue;const F=l[M],K=m[M];k.equals(F,K)||N.add(M)}return{added:R,removed:U,updated:N}}function E(l,m,w,C){const b=(0,a.parse)(m),R=o(m),U=o(w),N=I(l,R,U);return d(w,l,b[l],N,U,C)}function I(l,m,w){const C=m.findIndex(R=>R.setting?.key===l),b=m[C-1];if(b){if(b.setting){const U=t(b.setting.key,w);if(U)return{index:w.indexOf(U),insertAfter:!0}}else{const U=r(C,m);if(U){const N=t(U.setting.key,w);if(N){const M=s(w.indexOf(N),w),F=i(m,U,m[C]);if(M){const K=i(w,N,M),H=n(F,K);return H?{index:w.indexOf(H),insertAfter:!0}:{index:w.indexOf(M),insertAfter:!1}}else{const K=i(w,N,w[w.length-1]),H=n(F,K);return H?{index:w.indexOf(H),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const R=m[C+1];if(R)if(R.setting){const U=t(R.setting.key,w);if(U)return{index:w.indexOf(U),insertAfter:!1}}else{const U=s(C,m);if(U){const N=t(U.setting.key,w);if(N){const M=r(w.indexOf(N),w),F=i(m,m[C],U);if(M){const K=i(w,M,N),H=n(F.reverse(),K.reverse());return H?{index:w.indexOf(H),insertAfter:!1}:{index:w.indexOf(M),insertAfter:!0}}else{const K=i(w,w[0],N),H=n(F.reverse(),K.reverse());return H?{index:w.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function d(l,m,w,C,b,R){let U;return C.index===-1?U=(0,A.setProperty)(l,[m],w,R):U=v(l,m,w,C,b,R).map(N=>(0,A.withFormatting)(l,N,R)[0]),(0,A.applyEdits)(l,U)}function v(l,m,w,C,b,R){const U=`${JSON.stringify(m)}: ${JSON.stringify(w)}`,N=(0,L.getEOL)(R,l),M=b[C.index];if(C.insertAfter){const F=[];if(M.setting)F.push({offset:M.endOffset,length:0,content:","+U});else{const K=s(C.index,b),H=r(C.index,b),X=H?.setting?.commaOffset;H&&X===void 0&&F.push({offset:H.endOffset,length:0,content:","});const j=X!==void 0&&X>M.endOffset;F.push({offset:j?X+1:M.endOffset,length:0,content:K?N+U+",":N+U})}return F}else{if(M.setting)return[{offset:M.startOffset,length:0,content:U+","}];const F=(b[C.index-1]&&!b[C.index-1].setting?N:"")+U+(s(C.index,b)?",":"")+N;return[{offset:M.startOffset,length:0,content:F}]}}function t(l,m){return m.filter(w=>w.setting?.key===l)[0]}function r(l,m){for(let w=l-1;w>=0;w--)if(m[w].setting)return m[w]}function s(l,m){for(let w=l+1;w<m.length;w++)if(m[w].setting)return m[w]}function i(l,m,w){const C=l.indexOf(m),b=l.indexOf(w);return l.filter((R,U)=>C<U&&U<b)}function n(l,m){if(l.length&&m.length){let w=0;for(;w<m.length&&w<l.length;w++)if(l[w].value!==m[w].value)return m[w-1];return m[w-1]}}function o(l){const m=[];let w=-1,C,b;const R={onObjectBegin:U=>{w++},onObjectProperty:(U,N,M)=>{w===0&&(C=N,b=U)},onObjectEnd:(U,N)=>{w--,w===0&&m.push({startOffset:C,endOffset:U+N,value:l.substring(C,U+N),setting:{key:b,commaOffset:void 0}})},onArrayBegin:(U,N)=>{w++},onArrayEnd:(U,N)=>{w--,w===0&&m.push({startOffset:C,endOffset:U+N,value:l.substring(C,U+N),setting:{key:b,commaOffset:void 0}})},onLiteralValue:(U,N,M)=>{w===0&&m.push({startOffset:C,endOffset:N+M,value:l.substring(C,N+M),setting:{key:b,commaOffset:void 0}})},onSeparator:(U,N,M)=>{if(w===0&&U===","){let F=m.length-1;for(;F>=0&&!m[F].setting;F--);const K=m[F];K&&m.splice(F,1,{startOffset:K.startOffset,endOffset:K.endOffset,value:K.value,setting:{key:K.setting.key,commaOffset:N}})}},onComment:(U,N)=>{w===0&&m.push({startOffset:U,endOffset:U+N,value:l.substring(U,U+N)})}};return(0,a.visit)(l,R),m}}),define(le[83],ue([0,1,3,2,4,25]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,A.createDecorator)("IUserDataSyncAccountService");let k=class extends a.Disposable{get account(){return this._account}constructor(T,y){super(),this.userDataSyncStoreService=T,this.logService=y,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(T.onTokenFailed(P=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,P),this.updateAccount(void 0),P===L.UserDataSyncErrorCode.Forbidden?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(T.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(T){(T&&this._account?T.token!==this._account.token||T.authenticationProviderId!==this._account.authenticationProviderId:T!==this._account)&&(this._account=T,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(T))}};e.UserDataSyncAccountService=k,e.UserDataSyncAccountService=k=we([Q(0,L.IUserDataSyncStoreService),Q(1,L.IUserDataSyncLogService)],k)}),define(le[248],ue([0,1,21,186,16,10,25]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let _=class extends L.AbstractLogger{constructor(y,P){super(),this.logger=this._register(y.createLogger((0,D.joinPath)(P.logsHome,`${k.USER_DATA_SYNC_LOG_ID}.log`),{id:k.USER_DATA_SYNC_LOG_ID,name:(0,a.localize)(0,null)}))}trace(y,...P){this.logger.trace(y,...P)}debug(y,...P){this.logger.debug(y,...P)}info(y,...P){this.logger.info(y,...P)}warn(y,...P){this.logger.warn(y,...P)}error(y,...P){this.logger.error(y,...P)}flush(){this.logger.flush()}};e.UserDataSyncLogService=_,e.UserDataSyncLogService=_=we([Q(0,L.ILoggerService),Q(1,A.IEnvironmentService)],_)}),define(le[249],ue([0,1,6,3,2]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends A.Disposable{constructor({onDidOpenMainWindow:_,onDidFocusMainWindow:T,getActiveWindowId:y}){super(),this.disposables=this._register(new A.DisposableStore),a.Event.latch(a.Event.any(_,T))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>y()),(async()=>{try{const S=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:S}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(_){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=_}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(le[116],ue([0,1,189,14,52,21,9,4,23]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=y,e.isEmptyWorkspaceIdentifier=P,e.toWorkspaceIdentifier=S,e.isWorkspaceIdentifier=u,e.reviveIdentifier=p,e.isWorkspace=g,e.isWorkspaceFolder=f,e.toWorkspaceFolder=I,e.isUntitledWorkspace=d,e.isTemporaryWorkspace=v,e.isStandaloneEditorWorkspace=t,e.isSavedWorkspace=r,e.hasWorkspaceFileExtension=s,e.IWorkspaceContextService=(0,_.createDecorator)("contextService");function y(i){const n=i;return typeof n?.id=="string"&&k.URI.isUri(n.uri)}function P(i){return typeof i?.id=="string"&&!y(i)&&!u(i)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,a.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function u(i){const n=i;return typeof n?.id=="string"&&k.URI.isUri(n.configPath)}function p(i){const n=i;if(n?.uri)return{id:n.id,uri:k.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:k.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var c;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(c||(e.WorkbenchState=c={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function f(i){const n=i;return!!(n&&typeof n=="object"&&k.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class h{constructor(n,o,l,m,w){this._id=n,this._transient=l,this._configuration=m,this._ignorePathCasing=w,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class E{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,L.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=E;function I(i){return new E({uri:i,index:0,name:(0,L.basenameOrAuthority)(i)},{uri:i.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(i,n){return L.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}function v(i){let n;return k.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===T.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function r(i,n){return!d(i,n)&&!v(i)}function s(i){return(typeof i=="string"?(0,a.extname)(i):(0,L.extname)(i))===e.WORKSPACE_SUFFIX}}),define(le[20],ue([0,1,55,3,2,21,9,180,16,7,4,10,116,35,29,6,32,27,13]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=d,e.reviveProfile=v,e.toUserDataProfile=t;var I;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function d(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&k.URI.isUri(n.location)&&k.URI.isUri(n.globalStorageHome)&&k.URI.isUri(n.settingsResource)&&k.URI.isUri(n.keybindingsResource)&&k.URI.isUri(n.tasksResource)&&k.URI.isUri(n.snippetsHome)&&k.URI.isUri(n.extensionsResource))}e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function v(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:k.URI.revive(i.location).with({scheme:n}),globalStorageHome:k.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:k.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:k.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:k.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:k.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:k.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:k.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,n,o,l,m,w){return{id:i,name:n,location:o,isDefault:!1,shortName:m?.shortName,icon:m?.icon,globalStorageHome:w&&m?.useDefaultFlags?.globalState?w.globalStorageHome:(0,L.joinPath)(o,"globalStorage"),settingsResource:w&&m?.useDefaultFlags?.settings?w.settingsResource:(0,L.joinPath)(o,"settings.json"),keybindingsResource:w&&m?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,L.joinPath)(o,"keybindings.json"),tasksResource:w&&m?.useDefaultFlags?.tasks?w.tasksResource:(0,L.joinPath)(o,"tasks.json"),snippetsHome:w&&m?.useDefaultFlags?.snippets?w.snippetsHome:(0,L.joinPath)(o,"snippets"),extensionsResource:w&&m?.useDefaultFlags?.extensions?w.extensionsResource:(0,L.joinPath)(o,"extensions.json"),cacheHome:(0,L.joinPath)(l,i),useDefaultFlags:m?.useDefaultFlags,isTransient:m?.transient}}let r=class extends A.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,l,m){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=l,this.logService=m,this.enabled=!0,this._onDidChangeProfiles=this._register(new a.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new a.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new a.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new a.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new p.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,L.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),o=[n];if(this.enabled)try{for(const w of this.getStoredProfiles()){if(!w.name||!(0,E.isString)(w.name)||!w.location){this.logService.warn("Skipping the invalid stored profile",w.location||w.name);continue}o.push(t((0,L.basename)(w.location),w.name,w.location,this.profilesCacheHome,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},n))}}catch(w){this.logService.error(w)}const l=new p.ResourceMap,m=new Map;if(o.length)try{const w=this.getStoredProfileAssociations();if(w.workspaces)for(const[C,b]of Object.entries(w.workspaces)){const R=k.URI.parse(C),U=o.find(N=>N.id===b);U&&l.set(R,U)}if(w.emptyWindows)for(const[C,b]of Object.entries(w.emptyWindows)){const R=o.find(U=>U.id===b);R&&m.set(C,R)}}catch(w){this.logService.error(w)}this._profilesObject={profiles:o,workspaces:l,emptyWindows:m}}return this._profilesObject}createDefaultProfile(){const n=t("__default__profile__",(0,_.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",l=new RegExp(`${(0,h.escapeRegExpCharacters)(o)}\\s(\\d+)`);let m=0;for(const C of this.profiles){const b=l.exec(C.name),R=b?parseInt(b[1]):0;m=R>m?R:m}const w=`${o} ${m+1}`;return this.createProfile((0,D.hash)((0,f.generateUuid)()).toString(16),w,{transient:!0},n)}async createNamedProfile(n,o,l){return this.createProfile((0,D.hash)((0,f.generateUuid)()).toString(16),n,o,l)}async createProfile(n,o,l,m){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const w=await this.doCreateProfile(n,o,l);return m&&await this.setProfileForWorkspace(m,w),w}async doCreateProfile(n,o,l){if(!(0,E.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let m=this.profileCreationPromises.get(o);return m||(m=(async()=>{try{if(this.profiles.find(R=>R.name===o||R.id===n))throw new Error(`Profile with ${o} name already exists`);const C=t(n,o,(0,L.joinPath)(this.profilesHome,n),this.profilesCacheHome,l,this.defaultProfile);await this.fileService.createFolder(C.location);const b=[];return this._onWillCreateProfile.fire({profile:C,join(R){b.push(R)}}),await g.Promises.settled(b),this.updateProfiles([C],[],[]),C}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,m)),m}async updateProfile(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(m=>m.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=t(l.id,o.name??l.name,l.location,this.profilesCacheHome,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[l]),l}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(m=>m.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this._onWillRemoveProfile.fire({profile:o,join(m){l.push(m)}});try{await Promise.allSettled(l)}catch(m){this.logService.error(m)}for(const m of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(m)?.id&&this.profilesObject.emptyWindows.delete(m);for(const m of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(m)?.id&&this.profilesObject.workspaces.delete(m);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(m){(0,y.toFileOperationResult)(m)!==y.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(m)}}async setProfileForWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(m=>m.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,l)}unsetWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.uriIdentityService.extUri.isEqual(l.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return k.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(n){return(0,u.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,u.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,l){const m=[...this.profiles,...n],w=[];this.transientProfilesObject.profiles=[];for(let C of m)C.isDefault||o.some(b=>C.id===b.id)||(C=l.find(b=>C.id===b.id)??C,C.isTransient?this.transientProfilesObject.profiles.push(C):w.push({location:C.location,name:C.name,shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags}));this.saveStoredProfiles(w),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,l)}triggerProfilesChanges(n,o,l){this._onDidChangeProfiles.fire({added:n,removed:o,updated:l,all:this.profiles})}updateWorkspaceAssociation(n,o,l){l=o?.isTransient?!0:l,l||this.updateWorkspaceAssociation(n,void 0,!0);const m=this.getWorkspace(n),w=l?this.transientProfilesObject:this.profilesObject;k.URI.isUri(m)?(w.workspaces.delete(m),o&&w.workspaces.set(m,o)):(w.emptyWindows.delete(m),o&&w.emptyWindows.set(m,o)),l||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[l,m]of this.profilesObject.workspaces.entries())n[l.toString()]=m.id;const o={};for(const[l,m]of this.profilesObject.emptyWindows.entries())o[l.toString()]=m.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const o={},l=this.createDefaultProfile();if(n.workspaces)for(const[w,C]of Object.entries(n.workspaces)){const b=k.URI.parse(C);o[w]=this.uriIdentityService.extUri.isEqual(b,l.location)?l.id:this.uriIdentityService.extUri.basename(b)}const m={};if(n.emptyWindows)for(const[w,C]of Object.entries(n.emptyWindows)){const b=k.URI.parse(C);m[w]=this.uriIdentityService.extUri.isEqual(b,l.location)?l.id:this.uriIdentityService.extUri.basename(b)}return{workspaces:o,emptyWindows:m}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=r,e.UserDataProfilesService=r=we([Q(0,T.IEnvironmentService),Q(1,y.IFileService),Q(2,c.IUriIdentityService),Q(3,S.ILogService)],r);class s extends r{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(le[250],ue([0,1,6,2,20]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let L=class extends a.Disposable{constructor(_){super(),this._register(new D.RunOnceScheduler(()=>{_.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=L,e.UserDataProfilesCleaner=L=we([Q(0,A.IUserDataProfilesService)],L)}),define(le[84],ue([0,1,19,6,26,8,3,2,5,13,9,162,28,33,37,10,24,18,29,20]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.AbstractExtensionManagementService=void 0,e.toExtensionManagementError=v;let d=class extends _.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(i,n,o,l,m,w){super(),this.galleryService=i,this.telemetryService=n,this.uriIdentityService=o,this.logService=l,this.productService=m,this.userDataProfilesService=w,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this.participants=[],this._register((0,_.toDisposable)(()=>{this.installingExtensions.forEach(({task:C})=>C.cancel()),this.uninstallingExtensions.forEach(C=>C.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const n=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,u.isTargetPlatformCompatible)(o,i.allTargetPlatforms,n))}async installFromGallery(i,n={}){try{const l=(await this.installGalleryExtensions([{extension:i,options:n}])).find(({identifier:m})=>(0,p.areSameExtensions)(m,i.identifier));if(l?.local)return l?.local;throw l?.error?l.error:new u.ExtensionManagementError(`Unknown error while installing extension ${i.identifier.id}`,u.ExtensionManagementErrorCode.Unknown)}catch(o){throw v(o)}}async installGalleryExtensions(i){if(!this.galleryService.isEnabled())throw new u.ExtensionManagementError(S.localize(0,null),u.ExtensionManagementErrorCode.NotAllowed);const n=[],o=[];return await Promise.allSettled(i.map(async({extension:l,options:m})=>{try{const w=await this.checkAndGetCompatibleVersion(l,!!m?.installGivenVersion,!!m?.installPreReleaseVersion,m.productVersion??{version:this.productService.version,date:this.productService.date});o.push({...w,options:m})}catch(w){n.push({identifier:l.identifier,operation:u.InstallOperation.Install,source:l,error:w})}})),o.length&&n.push(...await this.installExtensions(o)),n}async uninstall(i,n={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,n)}async toggleAppliationScope(i,n){if((0,c.isApplicationScopedExtension)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)||(o=await this.copyExtension(i,this.userDataProfilesService.defaultProfile.extensionsResource,n));for(const l of this.userDataProfilesService.profiles){const m=(await this.getInstalled(c.ExtensionType.User,l.extensionsResource)).find(w=>(0,p.areSameExtensions)(w.identifier,i.identifier));m?this._onDidUpdateExtensionMetadata.fire(m):this._onDidUninstallExtension.fire({identifier:i.identifier,profileLocation:l.extensionsResource})}return o}else{const o=this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(i,n,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:o.identifier,operation:u.InstallOperation.Install,local:o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtensions(i){const n=new Map,o=new Map,l=[],m=(C,b)=>`${p.ExtensionKey.create(C).toString()}-${b.toString()}`,w=(C,b,R,U)=>{const N=this.createInstallExtensionTask(C,b,R),M=`${(0,p.getGalleryExtensionId)(C.publisher,C.name)}-${R.profileLocation.toString()}`;o.set(M,{task:N,root:U}),this._onInstallExtension.fire({identifier:N.identifier,source:b,profileLocation:R.profileLocation}),this.logService.info("Installing extension:",N.identifier.id,R.profileLocation.toString()),P.URI.isUri(b)||this.installingExtensions.set(m(b,R.profileLocation),{task:N,waitingTasks:[]})};try{for(const{manifest:C,extension:b,options:R}of i){const U=R.isApplicationScoped||R.isBuiltin||(0,c.isApplicationScopedExtension)(C),N={...R,installOnlyNewlyAddedFromExtensionPack:R.installOnlyNewlyAddedFromExtensionPack??!P.URI.isUri(b),isApplicationScoped:U,profileLocation:U?this.userDataProfilesService.defaultProfile.extensionsResource:R.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:R.productVersion??{version:this.productService.version,date:this.productService.date}},M=P.URI.isUri(b)?void 0:this.installingExtensions.get(m(b,N.profileLocation));M?(this.logService.info("Extension is already requested to install",M.task.identifier.id,N.profileLocation.toString()),l.push(M.task.waitUntilTaskIsFinished())):w(C,b,N,void 0)}return await Promise.all([...o.values()].map(async({task:C})=>{if(C.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",C.identifier.id);else try{const b=await this.getAllDepsAndPackExtensions(C.identifier,C.manifest,!!C.options.installOnlyNewlyAddedFromExtensionPack,!!C.options.installPreReleaseVersion,C.options.profileLocation,C.options.productVersion),R=await this.getInstalled(void 0,C.options.profileLocation,C.options.productVersion),U={...C.options,context:{...C.options.context,[u.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:N,manifest:M}of(0,D.distinct)(b,({gallery:F})=>F.identifier.id)){if(o.has(`${N.identifier.id.toLowerCase()}-${U.profileLocation.toString()}`))continue;const F=this.installingExtensions.get(m(N,U.profileLocation));if(F){if(this.canWaitForTask(C,F.task)){const K=F.task.identifier;this.logService.info("Waiting for already requested installing extension",K.id,C.identifier.id,U.profileLocation.toString()),F.waitingTasks.push(C),l.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,H=>H.some(X=>(0,p.areSameExtensions)(X.identifier,K)))).then(H=>{if(this.logService.info("Finished waiting for already requested installing extension",K.id,C.identifier.id,U.profileLocation.toString()),!H.find(j=>(0,p.areSameExtensions)(j.identifier,K))?.local)throw new Error(`Extension ${K.id} is not installed`)}))}}else R.some(({identifier:K})=>(0,p.areSameExtensions)(K,N.identifier))||w(M,N,U,C)}}catch(b){if(P.URI.isUri(C.source))(0,D.isNonEmptyArray)(C.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",C.identifier.id,b.message),(0,D.isNonEmptyArray)(C.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",C.identifier.id,b.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",C.identifier.id),b}})),await this.joinAllSettled([...o.entries()].map(async([C,{task:b}])=>{const R=new Date().getTime();let U;try{U=await b.run(),await this.joinAllSettled(this.participants.map(N=>N.postInstall(U,b.source,b.options,A.CancellationToken.None)),u.ExtensionManagementErrorCode.PostInstall)}catch(N){const M=v(N);throw P.URI.isUri(b.source)||t(this.telemetryService,b.operation===u.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(b.source),error:M,source:b.options.context?.[u.EXTENSION_INSTALL_SOURCE_CONTEXT]}),n.set(C,{error:M,identifier:b.identifier,operation:b.operation,source:b.source,context:b.options.context,profileLocation:b.options.profileLocation,applicationScoped:b.options.isApplicationScoped}),this.logService.error("Error while installing the extension",b.identifier.id,(0,L.getErrorMessage)(M),b.options.profileLocation.toString()),M}if(!P.URI.isUri(b.source)){const N=b.operation===u.InstallOperation.Update,M=N?void 0:(new Date().getTime()-b.source.lastUpdated)/1e3;if(t(this.telemetryService,N?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(b.source),verificationStatus:b.verificationStatus,duration:new Date().getTime()-R,durationSinceUpdate:M,source:b.options.context?.[u.EXTENSION_INSTALL_SOURCE_CONTEXT]}),T.isWeb&&b.operation!==u.InstallOperation.Update)try{await this.galleryService.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,u.StatisticType.Install)}catch{}}n.set(C,{local:U,identifier:b.identifier,operation:b.operation,source:b.source,context:b.options.context,profileLocation:b.options.profileLocation,applicationScoped:U.isApplicationScoped})})),l.length&&await this.joinAllSettled(l),[...n.values()]}catch(C){const b=(N,M,F)=>{const K=[];N.manifest.extensionDependencies?.length&&K.push(...N.manifest.extensionDependencies),N.manifest.extensionPack?.length&&K.push(...N.manifest.extensionPack);for(const H of K){if(F.includes(H.toLowerCase()))continue;F.push(H.toLowerCase());const X=n.get(`${H.toLowerCase()}-${M.toString()}`);X?.local&&(F=b(X.local,M,F))}return F},R=N=>({identifier:N.identifier,operation:u.InstallOperation.Install,source:N.source,context:N.options.context,profileLocation:N.options.profileLocation,error:C}),U=[];for(const[N,{task:M,root:F}]of o){const K=n.get(N);K?K.local&&F&&!n.get(`${F.identifier.id.toLowerCase()}-${M.options.profileLocation.toString()}`)?.local&&(U.push(this.createUninstallExtensionTask(K.local,{versionOnly:!0,profileLocation:M.options.profileLocation})),n.set(N,R(M))):(M.cancel(),n.set(N,R(M)))}for(const[N,{task:M}]of o){const F=n.get(N);if(!F?.local||M.options.donotIncludePackAndDependencies)continue;b(F.local,M.options.profileLocation,[F.local.identifier.id.toLowerCase()]).slice(1).some(H=>o.has(`${H.toLowerCase()}-${M.options.profileLocation.toString()}`)&&!n.get(`${H.toLowerCase()}-${M.options.profileLocation.toString()}`)?.local)&&(U.push(this.createUninstallExtensionTask(F.local,{versionOnly:!0,profileLocation:M.options.profileLocation})),n.set(N,R(M)))}throw U.length&&await Promise.allSettled(U.map(async N=>{try{await N.run(),this.logService.info("Rollback: Uninstalled extension",N.extension.identifier.id)}catch(M){this.logService.warn("Rollback: Error while uninstalling extension",N.extension.identifier.id,(0,L.getErrorMessage)(M))}})),C}finally{for(const{task:C}of o.values())C.source&&!P.URI.isUri(C.source)&&this.installingExtensions.delete(m(C.source,C.options.profileLocation));if(n.size){const C=[...n.values()];for(const b of C)b.local&&this.logService.info("Extension installed successfully:",b.identifier.id,b.profileLocation.toString());this._onDidInstallExtensions.fire(C)}}}canWaitForTask(i,n){for(const[,{task:o,waitingTasks:l}]of this.installingExtensions.entries())if(o===i&&(l.includes(n)||l.some(m=>this.canWaitForTask(m,n)))||o===n&&l[0]&&!this.canWaitForTask(i,l[0]))return!1;return!0}async joinAllSettled(i,n){const o=[],l=[],m=await Promise.allSettled(i);for(const C of m)C.status==="fulfilled"?o.push(C.value):l.push(v(C.reason,n));if(!l.length)return o;if(l.length===1)throw l[0];let w=new u.ExtensionManagementError("",u.ExtensionManagementErrorCode.Unknown);for(const C of l)w=new u.ExtensionManagementError(w.message?`${w.message}, ${C.message}`:C.message,C.code!==u.ExtensionManagementErrorCode.Unknown&&C.code!==u.ExtensionManagementErrorCode.Internal?C.code:w.code);throw w}async getAllDepsAndPackExtensions(i,n,o,l,m,w){if(!this.galleryService.isEnabled())return[];const C=await this.getInstalled(void 0,m,w),b=[],R=[],U=async(N,M)=>{b.push(N);const F=M.extensionDependencies||[],K=[...F];if(M.extensionPack){const H=o?C.find(X=>(0,p.areSameExtensions)(X.identifier,N)):void 0;for(const X of M.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(j=>(0,p.areSameExtensions)({id:j},{id:X}))||K.every(j=>!(0,p.areSameExtensions)({id:j},{id:X}))&&K.push(X)}if(K.length){const H=K.filter(X=>b.every(j=>!(0,p.areSameExtensions)(j,{id:X})));if(H.length){const X=await this.galleryService.getExtensions(H.map(j=>({id:j,preRelease:l})),A.CancellationToken.None);for(const j of X){if(b.find(B=>(0,p.areSameExtensions)(B,j.identifier)))continue;const ie=F.some(B=>(0,p.areSameExtensions)({id:B},j.identifier));let z;try{z=await this.checkAndGetCompatibleVersion(j,!1,l,w)}catch(B){if(ie)throw B;this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id,(0,L.getErrorMessage)(B));continue}R.push({gallery:z.extension,manifest:z.manifest}),await U(z.extension.identifier,z.manifest)}}}};return await U(i,n),R}async checkAndGetCompatibleVersion(i,n,o,l){let m;const w=await this.getExtensionsControlManifest();if(w.malicious.some(R=>(0,p.areSameExtensions)(i.identifier,R)))throw new u.ExtensionManagementError(S.localize(1,null,i.identifier.id),u.ExtensionManagementErrorCode.Malicious);const C=w.deprecated[i.identifier.id.toLowerCase()];if(C?.extension?.autoMigrate){if(this.logService.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${C.extension.id}' extension instead.`),m=(await this.galleryService.getExtensions([{id:C.extension.id,preRelease:C.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:l},A.CancellationToken.None))[0],!m)throw new u.ExtensionManagementError(S.localize(2,null,i.identifier.id,C.extension.id),u.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const R=await this.getTargetPlatform();throw new u.ExtensionManagementError(S.localize(3,null,i.identifier.id,this.productService.nameLong,(0,u.TargetPlatformToString)(R)),u.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(m=await this.getCompatibleVersion(i,n,o,l),!m)throw!o&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],A.CancellationToken.None))[0]?new u.ExtensionManagementError(S.localize(4,null,i.displayName??i.identifier.id),u.ExtensionManagementErrorCode.ReleaseVersionNotFound):new u.ExtensionManagementError(S.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),u.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",m.identifier.id);const b=await this.galleryService.getManifest(m,A.CancellationToken.None);if(b===null)throw new u.ExtensionManagementError(`Missing manifest for extension ${m.identifier.id}`,u.ExtensionManagementErrorCode.Invalid);if(b.version!==m.version)throw new u.ExtensionManagementError(`Cannot install '${m.identifier.id}' extension because of version mismatch in Marketplace`,u.ExtensionManagementErrorCode.Invalid);return{extension:m,manifest:b}}async getCompatibleVersion(i,n,o,l){const m=await this.getTargetPlatform();let w=null;return!n&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(w=(await this.galleryService.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:m,compatible:!0,productVersion:l},A.CancellationToken.None))[0]||null),!w&&await this.galleryService.isExtensionCompatible(i,o,m,l)&&(w=i),w||(n?w=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:m,compatible:!0,productVersion:l},A.CancellationToken.None))[0]||null:w=await this.galleryService.getCompatibleExtension(i,o,m,l)),w}async uninstallExtension(i,n){const o={...n,profileLocation:i.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:n.profileLocation??this.getCurrentExtensionsManifestLocation()},l=U=>`${U.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,m=this.uninstallingExtensions.get(l(i.identifier));if(m)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),m.waitUntilTaskIsFinished();const w=U=>{const N=this.createUninstallExtensionTask(U,o);return this.uninstallingExtensions.set(l(N.extension.identifier),N),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${U.identifier.id}@${U.manifest.version}`),this._onUninstallExtension.fire({identifier:U.identifier,profileLocation:o.profileLocation,applicationScoped:U.isApplicationScoped}),N},C=(U,N)=>{N?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,o.profileLocation.toString(),N.message):this.logService.error("Failed to uninstall extension:",`${U.identifier.id}@${U.manifest.version}`,N.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${U.identifier.id}@${U.manifest.version}`),t(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(U),error:N}),this._onDidUninstallExtension.fire({identifier:U.identifier,error:N?.code,profileLocation:o.profileLocation,applicationScoped:U.isApplicationScoped})},b=[],R=[];try{b.push(w(i));const U=await this.getInstalled(c.ExtensionType.User,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const N=this.getAllPackExtensionsToUninstall(i,U);for(const M of N)this.uninstallingExtensions.has(l(M.identifier))?this.logService.info("Extensions is already requested to uninstall",M.identifier.id):b.push(w(M))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(b.map(N=>N.extension),U,i),await this.joinAllSettled(b.map(async N=>{try{if(await N.run(),await this.joinAllSettled(this.participants.map(M=>M.postUninstall(N.extension,o,A.CancellationToken.None))),N.extension.identifier.uuid)try{await this.galleryService.reportStatistic(N.extension.manifest.publisher,N.extension.manifest.name,N.extension.manifest.version,u.StatisticType.Uninstall)}catch{}C(N.extension)}catch(M){const F=v(M);throw C(N.extension,F),F}finally{R.push(N)}}))}catch(U){const N=v(U);for(const M of b){try{M.cancel()}catch{}R.includes(M)||C(M.extension,N)}throw N}finally{for(const U of b)this.uninstallingExtensions.delete(l(U.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}checkForDependents(i,n,o){for(const l of i){const m=this.getDependents(l,n);if(m.length){const w=m.filter(C=>!i.some(b=>(0,p.areSameExtensions)(b.identifier,C.identifier)));if(w.length)throw new Error(this.getDependentsErrorMessage(l,w,o))}}}getDependentsErrorMessage(i,n,o){return o===i?n.length===1?S.localize(6,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?S.localize(7,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):S.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?S.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?S.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):S.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(i,n,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const m=n.filter(C=>!C.isBuiltin&&l.some(b=>(0,p.areSameExtensions)({id:b},C.identifier))),w=[];for(const C of m)w.push(...this.getAllPackExtensionsToUninstall(C,n,o));return[...m,...w]}return[]}getDependents(i,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,p.areSameExtensions)({id:l},i.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(i){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.getErrorMessage)(i)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=d,e.AbstractExtensionManagementService=d=we([Q(0,u.IExtensionGalleryService),Q(1,h.ITelemetryService),Q(2,E.IUriIdentityService),Q(3,g.ILogService),Q(4,f.IProductService),Q(5,I.IUserDataProfilesService)],d);function v(s,i){if(s instanceof u.ExtensionManagementError)return s;let n;return s instanceof u.ExtensionGalleryError?n=new u.ExtensionManagementError(s.message,s.code===u.ExtensionGalleryErrorCode.DownloadFailedWriting?u.ExtensionManagementErrorCode.DownloadFailedWriting:u.ExtensionManagementErrorCode.Gallery):n=new u.ExtensionManagementError(s.message,(0,L.isCancellationError)(s)?u.ExtensionManagementErrorCode.Cancelled:i??u.ExtensionManagementErrorCode.Internal),n.stack=s.stack,n}function t(s,i,{extensionData:n,verificationStatus:o,duration:l,error:m,source:w,durationSinceUpdate:C}){let b,R;(0,y.isDefined)(o)&&(o===!0?o="Verified":(o===!1||(b=u.ExtensionManagementErrorCode.Signature,R=o),o="Unverified")),m&&(b=m.code,m.code===u.ExtensionManagementErrorCode.Signature&&(R=m.message)),s.publicLog(i,{...n,verificationStatus:o,success:!m,duration:l,errorcode:b,errorcodeDetail:R,durationSinceUpdate:C,source:w})}class r{constructor(){this.barrier=new a.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}run(){return this.cancellablePromise||(this.cancellablePromise=(0,a.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,a.createCancelablePromise)(i=>new Promise((n,o)=>{const l=i.onCancellationRequested(()=>{l.dispose(),o(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=r}),define(le[53],ue([0,1,6,15,2,3,35,9,28,33,7,4,10,20,29,13,8,18]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var E;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(E||(e.ExtensionsProfileScanningErrorCode=E={}));class I extends Error{constructor(s,i){super(s),this.code=i}}e.ExtensionsProfileScanningError=I,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let d=class extends A.Disposable{constructor(s,i,n,o,l,m){super(),this.extensionsLocation=s,this.fileService=i,this.userDataProfilesService=n,this.uriIdentityService=o,this.telemetryService=l,this.logService=m,this._onAddExtensions=this._register(new L.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new L.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new L.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new L.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(s,i){return this.withProfileExtensions(s,void 0,i)}async addExtensionsToProfile(s,i,n){const o=[],l=[];try{return await this.withProfileExtensions(i,m=>{const w=[];if(n)w.push(...m);else for(const C of m)s.some(([b])=>(0,y.areSameExtensions)(b.identifier,C.identifier)&&b.manifest.version!==C.version)?o.push(C):w.push(C);for(const[C,b]of s){const R=w.findIndex(N=>(0,y.areSameExtensions)(N.identifier,C.identifier)&&N.version===C.manifest.version),U={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:b};R===-1?(l.push(U),w.push(U)):w.splice(R,1,U)}return l.length&&this._onAddExtensions.fire({extensions:l,profileLocation:i}),o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:i}),w}),l.length&&this._onDidAddExtensions.fire({extensions:l,profileLocation:i}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:i}),l}catch(m){throw l.length&&this._onDidAddExtensions.fire({extensions:l,error:m,profileLocation:i}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:m,profileLocation:i}),m}}async updateMetadata(s,i){const n=[];return await this.withProfileExtensions(i,o=>{const l=[];for(const m of o){const w=s.find(([C])=>(0,y.areSameExtensions)(C.identifier,m.identifier)&&C.manifest.version===m.version);w&&(m.metadata={...m.metadata,...w[1]},n.push(m)),l.push(m)}return l}),n}async removeExtensionFromProfile(s,i){const n=[];try{await this.withProfileExtensions(i,o=>{const l=[];for(const m of o)(0,y.areSameExtensions)(m.identifier,s.identifier)?n.push(m):l.push(m);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),l}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:o,profileLocation:i}),o}}async withProfileExtensions(s,i,n){return this.getResourceAccessQueue(s).queue(async()=>{let o=[],l;try{const m=await this.fileService.readFile(s);l=JSON.parse(m.value.toString().trim()||"[]")}catch(m){if((0,P.toFileOperationResult)(m)!==P.FileOperationResult.FILE_NOT_FOUND)throw m;if(this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)&&(l=await this.migrateFromOldDefaultProfileExtensionsLocation()),!l&&n?.bailOutWhenFileNotFound)throw new I((0,f.getErrorMessage)(m),E.ERROR_PROFILE_NOT_FOUND)}if(l){Array.isArray(l)||this.reportAndThrowInvalidConentError(s);let m=!1;for(const w of l){v(w)||this.reportAndThrowInvalidConentError(s);let C;if((0,g.isString)(w.relativeLocation)&&w.relativeLocation)C=this.resolveExtensionLocation(w.relativeLocation);else if((0,g.isString)(w.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${w.location}`);continue}else{C=_.URI.revive(w.location);const b=this.toRelativePath(C);b&&(m=!0,w.relativeLocation=b)}(0,g.isUndefined)(w.metadata?.hasPreReleaseVersion)&&w.metadata?.preRelease&&(m=!0,w.metadata.hasPreReleaseVersion=!0),o.push({identifier:w.identifier,location:C,version:w.version,metadata:w.metadata})}m&&await this.fileService.writeFile(s,a.VSBuffer.fromString(JSON.stringify(l)))}if(i){o=i(o);const m=o.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.toRelativePath(w.location),metadata:w.metadata}));await this.fileService.writeFile(s,a.VSBuffer.fromString(JSON.stringify(m)))}return o})}reportAndThrowInvalidConentError(s){const i=new I(`Invalid extensions content in ${s.toString()}`,E.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(s){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(s),this.extensionsLocation)?this.uriIdentityService.extUri.basename(s):void 0}resolveExtensionLocation(s){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,s)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const s=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(s)).value.toString()}catch(l){if((0,P.toFileOperationResult)(l)===P.FileOperationResult.FILE_NOT_FOUND)return;throw l}this.logService.info("Migrating extensions from old default profile location",s.toString());let o;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(m=>v(m))?o=l:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.logService.error(l)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,a.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(l){if((0,P.toFileOperationResult)(l)===P.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw l}try{await this.fileService.del(s)}catch(l){(0,P.toFileOperationResult)(l)!==P.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(l)}try{await this.fileService.del(i)}catch(l){(0,P.toFileOperationResult)(l)!==P.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(l)}return o})()),this._migrationPromise}getResourceAccessQueue(s){let i=this.resourcesAccessQueueMap.get(s);return i||(i=new D.Queue,this.resourcesAccessQueueMap.set(s,i)),i}};e.AbstractExtensionsProfileScannerService=d,e.AbstractExtensionsProfileScannerService=d=we([Q(1,P.IFileService),Q(2,p.IUserDataProfilesService),Q(3,c.IUriIdentityService),Q(4,h.ITelemetryService),Q(5,u.ILogService)],d);function v(r){return(0,g.isObject)(r)&&(0,T.isIExtensionIdentifier)(r.identifier)&&(t(r.location)||(0,g.isString)(r.location)&&r.location)&&((0,g.isUndefined)(r.relativeLocation)||(0,g.isString)(r.relativeLocation))&&r.version&&(0,g.isString)(r.version)}function t(r){return r?(0,g.isString)(r.path)&&(0,g.isString)(r.scheme):!1}}),define(le[85],ue([0,1,19,6,30,15,8,34,144,2,23,14,5,21,56,92,13,9,165,16,33,37,73,7,4,10,24,3,68,53,20,29,194]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d,v,t,r,s,i,n,o,l,m,w,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=K;var R;(function(X){function j(ie,z){if(ie===z)return!0;const B=Object.keys(ie),ee=new Set;for(const se of Object.keys(z))ee.add(se);if(B.length!==ee.size)return!1;for(const se of B){if(ie[se]!==z[se])return!1;ee.delete(se)}return ee.size===0}X.equals=j})(R||(e.Translations=R={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let U=class extends y.Disposable{constructor(j,ie,z,B,ee,se,ce,W,J,G,V,O){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=ie,this.extensionsControlLocation=z,this.currentProfile=B,this.userDataProfilesService=ee,this.extensionsProfileScannerService=se,this.fileService=ce,this.logService=W,this.environmentService=J,this.productService=G,this.uriIdentityService=V,this.instantiationService=O,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,p.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(F,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(F,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(M,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(v.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(v.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,d.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,ie,z){const[B,ee]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(ie)]),se=z?await this.scanExtensionsUnderDevelopment(j,[...B,...ee]):[];return this.dedupExtensions(B,ee,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const ie=[];ie.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),ie.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[z,B]=await Promise.all(ie);return this.applyScanOptions([...z,...B],v.ExtensionType.System,j,!1)}async scanUserExtensions(j){const ie=j.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",ie);const z=this.uriIdentityService.extUri.isEqual(j.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.createExtensionScannerInput(ie,!!j.profileLocation,v.ExtensionType.User,!j.includeUninstalled,j.language,!0,z,j.productVersion??this.getProductVersion()),ee=j.useCache&&!B.devMode&&B.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let se;try{se=await ee.scanExtensions(B)}catch(ce){if(ce instanceof m.ExtensionsProfileScanningError&&ce.code===m.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),se=await ee.scanExtensions(B);else throw ce}return se=await this.applyScanOptions(se,v.ExtensionType.User,j,!0),this.logService.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(j,ie){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const z=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(B=>B.scheme===P.Schemas.file).map(async B=>{const ee=await this.createExtensionScannerInput(B,!1,v.ExtensionType.User,!0,j.language,!1,void 0,j.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(ee)).map(ce=>(ce.type=ie.find(W=>(0,d.areSameExtensions)(W.identifier,ce.identifier))?.type??ce.type,this.extensionsScanner.validate(ce,ee)))}))).flat();return this.applyScanOptions(z,"development",j,!0)}return[]}async scanExistingExtension(j,ie,z){const B=await this.createExtensionScannerInput(j,!1,ie,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),ee=await this.extensionsScanner.scanExtension(B);return!ee||!z.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(j,ie,z){const B=await this.createExtensionScannerInput(j,!1,ie,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),ee=await this.extensionsScanner.scanOneOrMultipleExtensions(B);return this.applyScanOptions(ee,ie,z,!0)}async scanMultipleExtensions(j,ie,z){const B=[];return await Promise.all(j.map(async ee=>{const se=await this.scanOneOrMultipleExtensions(ee,ie,z);B.push(...se)})),this.applyScanOptions(B,ie,z,!0)}async scanMetadata(j){const ie=(0,p.joinPath)(j,"package.json"),z=(await this.fileService.readFile(ie)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(j,ie){const z=(0,p.joinPath)(j,"package.json"),B=(await this.fileService.readFile(z)).value.toString(),ee=JSON.parse(B);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,ee.__metadata={...ee.__metadata,...ie},await this.fileService.writeFile((0,p.joinPath)(j,"package.json"),L.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(j){if(j instanceof m.ExtensionsProfileScanningError&&j.code===m.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw j}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const j=await this.scanUserExtensions({includeInvalid:!0});if(j.length)await this.extensionsProfileScannerService.addExtensionsToProfile(j.map(ie=>[ie,ie.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify([])))}catch(ie){(0,r.toFileOperationResult)(ie)!==r.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(ie))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(j){this.logService.error(j)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(j,ie,z,B){return z.includeAllVersions||(j=this.dedupExtensions(ie===v.ExtensionType.System?j:void 0,ie===v.ExtensionType.User?j:void 0,ie==="development"?j:void 0,await this.getTargetPlatform(),B)),z.includeInvalid||(j=j.filter(ee=>ee.isValid)),j.sort((ee,se)=>{const ce=S.basename(ee.location.fsPath),W=S.basename(se.location.fsPath);return ce<W?-1:ce>W?1:0})}dedupExtensions(j,ie,z,B,ee){const se=(W,J,G)=>{if(W.isValid&&!J.isValid)return!1;if(W.isValid===J.isValid){if(ee&&c.gt(W.manifest.version,J.manifest.version))return this.logService.debug(`Skipping extension ${J.location.path} with lower version ${J.manifest.version} in favour of ${W.location.path} with version ${W.manifest.version}`),!1;if(c.eq(W.manifest.version,J.manifest.version)){if(W.type===v.ExtensionType.System)return this.logService.debug(`Skipping extension ${J.location.path} in favour of system extension ${W.location.path} with same version`),!1;if(W.targetPlatform===B)return this.logService.debug(`Skipping extension ${J.location.path} from different target platform ${J.targetPlatform}`),!1}}return G?this.logService.warn(`Overwriting user extension ${W.location.path} with ${J.location.path}.`):this.logService.debug(`Overwriting user extension ${W.location.path} with ${J.location.path}.`),!0},ce=new v.ExtensionIdentifierMap;return j?.forEach(W=>{const J=ce.get(W.identifier.id);(!J||se(J,W,!1))&&ce.set(W.identifier.id,W)}),ie?.forEach(W=>{const J=ce.get(W.identifier.id);if(!J&&j&&W.type===v.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${W.location.path}.`);return}(!J||se(J,W,!1))&&ce.set(W.identifier.id,W)}),z?.forEach(W=>{const J=ce.get(W.identifier.id);(!J||se(J,W,!0))&&ce.set(W.identifier.id,W),ce.set(W.identifier.id,W)}),[...ce.values()]}async scanDefaultSystemExtensions(j,ie){this.logService.trace("Started scanning system extensions");const z=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,v.ExtensionType.System,!0,ie,!0,void 0,this.getProductVersion()),ee=await(j&&!z.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return this.logService.trace("Scanned system extensions:",ee.length),ee}async scanDevSystemExtensions(j,ie){const z=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!z?.length)return[];this.logService.trace("Started scanning dev system extensions");const B=ie?await this.getBuiltInExtensionControl():{},ee=[],se=h.URI.file(S.normalize(S.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const W of z){const J=B[W.name]||"marketplace";switch(J){case"disabled":break;case"marketplace":ee.push((0,p.joinPath)(se,W.name));break;default:ee.push(h.URI.file(J));break}}const ce=await Promise.all(ee.map(async W=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(W,!1,v.ExtensionType.System,!0,j,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",ce.length),(0,D.coalesce)(ce)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,ie,z,B,ee,se,ce,W){const J=await this.getTranslations(ee??u.language),G=await this.getMtime(j),V=ie&&!this.uriIdentityService.extUri.isEqual(j,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=V?await this.getMtime(V):void 0;return new N(j,G,V,O,ie,ce,z,B,se,W.version,W.date,this.productService.commit,!this.environmentService.isBuilt,ee,J)}async getMtime(j){try{const ie=await this.fileService.stat(j);if(typeof ie.mtime=="number")return ie.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=U,e.AbstractExtensionsScannerService=U=we([Q(4,w.IUserDataProfilesService),Q(5,m.IExtensionsProfileScannerService),Q(6,r.IFileService),Q(7,i.ILogService),Q(8,I.IEnvironmentService),Q(9,n.IProductService),Q(10,C.IUriIdentityService),Q(11,s.IInstantiationService)],U);class N{constructor(j,ie,z,B,ee,se,ce,W,J,G,V,O,$,x,q){this.location=j,this.mtime=ie,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=B,this.profile=ee,this.profileScanOptions=se,this.type=ce,this.excludeObsolete=W,this.validate=J,this.productVersion=G,this.productDate=V,this.productCommit=O,this.devMode=$,this.language=x,this.translations=q}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,ie){return(0,p.isEqual)(j.location,ie.location)&&j.mtime===ie.mtime&&(0,p.isEqual)(j.applicationExtensionslocation,ie.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&j.profile===ie.profile&&A.equals(j.profileScanOptions,ie.profileScanOptions)&&j.type===ie.type&&j.excludeObsolete===ie.excludeObsolete&&j.validate===ie.validate&&j.productVersion===ie.productVersion&&j.productDate===ie.productDate&&j.productCommit===ie.productCommit&&j.devMode===ie.devMode&&j.language===ie.language&&R.equals(j.translations,ie.translations)}}e.ExtensionScannerInput=N;let M=class extends y.Disposable{constructor(j,ie,z,B,ee){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=ie,this.uriIdentityService=z,this.fileService=B,this.logService=ee}async scanExtensions(j){const ie=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let z={};if(j.excludeObsolete&&j.type===v.ExtensionType.User)try{const B=(await this.fileService.readFile(this.obsoleteFile)).value.toString();z=JSON.parse(B)}catch{}return(0,f.isEmptyObject)(z)?ie:ie.filter(B=>!z[d.ExtensionKey.create(B).toString()])}async scanExtensionsFromLocation(j){const ie=await this.fileService.resolve(j.location);if(!ie.children?.length)return[];const z=await Promise.all(ie.children.map(async B=>{if(!B.isDirectory||j.type===v.ExtensionType.User&&(0,p.basename)(B.resource).indexOf(".")===0)return null;const ee=new N(B.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(ee)}));return(0,D.coalesce)(z).sort((B,ee)=>B.location.path<ee.location.path?-1:1)}async scanExtensionsFromProfile(j){let ie=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){ie=ie.filter(B=>!B.metadata?.isApplicationScoped);const z=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,j);ie.push(...z)}return ie}async scanExtensionsFromProfileResource(j,ie,z){const B=await this.extensionsProfileScannerService.scanProfileExtensions(j,z.profileScanOptions);if(!B.length)return[];const ee=await Promise.all(B.map(async se=>{if(ie(se)){const ce=new N(se.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(ce,se.metadata)}return null}));return(0,D.coalesce)(ee)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,p.joinPath)(j.location,"package.json"))){const ie=await this.scanExtension(j);return ie?[ie]:[]}else return await this.scanExtensions(j)}catch(ie){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,k.getErrorMessage)(ie)),[]}}async scanExtension(j,ie){try{let z=await this.scanExtensionManifest(j.location);if(z){z.publisher||(z.publisher=v.UNDEFINED_PUBLISHER),ie=ie??z.__metadata,delete z.__metadata;const B=(0,d.getGalleryExtensionId)(z.publisher,z.name),ee=ie?.id?{id:B,uuid:ie.id}:{id:B},se=ie?.isSystem?v.ExtensionType.System:j.type,ce=se===v.ExtensionType.System||!!ie?.isBuiltin;z=await this.translateManifest(j.location,z,N.createNlsConfiguration(j));const W={type:se,identifier:ee,manifest:z,location:j.location,isBuiltin:ce,targetPlatform:ie?.targetPlatform??v.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return j.validate?this.validate(W,j):W}}catch(z){j.type!==v.ExtensionType.System&&this.logService.error(z)}return null}validate(j,ie){let z=!0;const B=(0,t.validateExtensionManifest)(ie.productVersion,ie.productDate,ie.location,j.manifest,j.isBuiltin);for(const[ee,se]of B)ee===g.default.Error&&(z=!1,this.logService.error(this.formatMessage(ie.location,se)));return j.isValid=z,j.validations=B,j}async scanExtensionManifest(j){const ie=(0,p.joinPath)(j,"package.json");let z;try{z=(await this.fileService.readFile(ie)).value.toString()}catch(ee){return(0,r.toFileOperationResult)(ee)!==r.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(j,(0,E.localize)(0,null,ie.path,ee.message))),null}let B;try{B=JSON.parse(z)}catch{const se=[];(0,_.parse)(z,se);for(const ce of se)this.logService.error(this.formatMessage(j,(0,E.localize)(1,null,ie.path,ce.offset,ce.length,(0,T.getParseErrorMessage)(ce.error))));return null}return(0,_.getNodeType)(B)!=="object"?(this.logService.error(this.formatMessage(j,(0,E.localize)(2,null,ie.path))),null):B}async translateManifest(j,ie,z){const B=await this.getLocalizedMessages(j,ie,z);if(B)try{const ee=[],se=await this.resolveOriginalMessageBundle(B.default,ee);if(ee.length>0)return ee.forEach(W=>{this.logService.error(this.formatMessage(j,(0,E.localize)(3,null,B.default?.path,(0,T.getParseErrorMessage)(W.error))))}),ie;if((0,_.getNodeType)(B)!=="object")return this.logService.error(this.formatMessage(j,(0,E.localize)(4,null,B.default?.path))),ie;const ce=B.values||Object.create(null);return(0,b.localizeManifest)(this.logService,ie,ce,se)}catch{}return ie}async getLocalizedMessages(j,ie,z){const B=(0,p.joinPath)(j,"package.nls.json"),ee=(J,G)=>{G.forEach(V=>{this.logService.error(this.formatMessage(j,(0,E.localize)(5,null,J?.path,(0,T.getParseErrorMessage)(V.error))))})},se=J=>{this.logService.error(this.formatMessage(j,(0,E.localize)(6,null,J?.path)))},ce=`${ie.publisher}.${ie.name}`,W=z.translations[ce];if(W)try{const J=h.URI.file(W),G=(await this.fileService.readFile(J)).value.toString(),V=[],O=(0,_.parse)(G,V);return V.length>0?(ee(J,V),{values:void 0,default:B}):(0,_.getNodeType)(O)!=="object"?(se(J),{values:void 0,default:B}):{values:O.contents?O.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.fileService.exists(B))return;let G;try{G=await this.findMessageBundles(j,z)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const V=(await this.fileService.readFile(G.localized)).value.toString(),O=[],$=(0,_.parse)(V,O);return O.length>0?(ee(G.localized,O),{values:void 0,default:G.original}):(0,_.getNodeType)($)!=="object"?(se(G.localized),{values:void 0,default:G.original}):{values:$,default:G.original}}catch{return{values:void 0,default:G.original}}}}async resolveOriginalMessageBundle(j,ie){if(j)try{const z=(await this.fileService.readFile(j)).value.toString();return(0,_.parse)(z,ie)}catch{}}findMessageBundles(j,ie){return new Promise((z,B)=>{const ee=se=>{const ce=(0,p.joinPath)(j,`package.nls.${se}.json`);this.fileService.exists(ce).then(W=>{W&&z({localized:ce,original:(0,p.joinPath)(j,"package.nls.json")});const J=se.lastIndexOf("-");J===-1?z({localized:(0,p.joinPath)(j,"package.nls.json"),original:null}):(se=se.substring(0,J),ee(se))})};if(ie.devMode||ie.pseudo||!ie.language)return z({localized:(0,p.joinPath)(j,"package.nls.json"),original:null});ee(ie.language)})}formatMessage(j,ie){return`[${j.path}]: ${ie}`}};M=we([Q(1,m.IExtensionsProfileScannerService),Q(2,C.IUriIdentityService),Q(3,r.IFileService),Q(4,i.ILogService)],M);let F=class extends M{constructor(j,ie,z,B,ee,se,ce){super(ie,B,ee,se,ce),this.currentProfile=j,this.userDataProfilesService=z,this.cacheValidatorThrottler=this._register(new a.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const ie=this.getCacheFile(j),z=await this.readExtensionCache(ie);if(this.input=j,z&&z.input&&N.equals(z.input,this.input))return this.logService.debug("Using cached extensions scan result",j.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(ee=>(ee.location=h.URI.revive(ee.location),ee));const B=await super.scanExtensions(j);return await this.writeExtensionCache(ie,{input:j,result:B}),B}async readExtensionCache(j){try{const ie=await this.fileService.readFile(j),z=JSON.parse(ie.value.toString());return{result:z.result,input:(0,l.revive)(z.input)}}catch(ie){this.logService.debug("Error while reading the extension cache file:",j.path,(0,k.getErrorMessage)(ie))}return null}async writeExtensionCache(j,ie){try{await this.fileService.writeFile(j,L.VSBuffer.fromString(JSON.stringify(ie)))}catch(z){this.logService.debug("Error while writing the extension cache file:",j.path,(0,k.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const j=this.getCacheFile(this.input),ie=await this.readExtensionCache(j);if(!ie)return;const z=ie.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!A.equals(B,z))try{this.logService.info("Invalidating Cache",z,B),await this.fileService.del(j),this._onDidChangeCache.fire()}catch(ee){this.logService.error(ee)}}getCacheFile(j){const ie=this.getProfile(j);return this.uriIdentityService.extUri.joinPath(ie.cacheHome,j.type===v.ExtensionType.System?v.BUILTIN_MANIFEST_CACHE_FILE:v.USER_MANIFEST_CACHE_FILE)}getProfile(j){return j.type===v.ExtensionType.System?this.userDataProfilesService.defaultProfile:j.profile?this.uriIdentityService.extUri.isEqual(j.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(ie=>this.uriIdentityService.extUri.isEqual(j.location,ie.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};F=we([Q(2,w.IUserDataProfilesService),Q(3,m.IExtensionsProfileScannerService),Q(4,C.IUriIdentityService),Q(5,r.IFileService),Q(6,i.ILogService)],F);function K(X,j){const ie=(0,d.getExtensionId)(X.manifest.publisher,X.manifest.name);return{id:ie,identifier:new v.ExtensionIdentifier(ie),isBuiltin:X.type===v.ExtensionType.System,isUserBuiltin:X.type===v.ExtensionType.User&&X.isBuiltin,isUnderDevelopment:j,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,publisherDisplayName:X.publisherDisplayName,...X.manifest}}class H extends U{constructor(j,ie,z,B,ee,se,ce,W,J,G,V,O){super(j,ie,(0,p.joinPath)(z,".vscode-oss-dev","extensions","control.json"),B,ee,se,ce,W,J,G,V,O),this.translationsPromise=(async()=>{if(u.translationsConfigFile)try{const $=await this.fileService.readFile(h.URI.file(u.translationsConfigFile));return JSON.parse($.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=H}),define(le[251],ue([0,1,69,6,40,3,2,23,14,31,10,20]),function(ne,e,D,a,A,L,k,_,T,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let u=class extends k.Disposable{constructor(c,g){super(),this.userDataProfilesService=c,this.logService=g,this.processesLimiter=new a.Limiter(5)}async postUninstall(c){const g=this.parseScript(c,"uninstall");g&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(g.script,"uninstall",g.args,!0,c),this.logService.info("Finished running post uninstall script",c.identifier.id,c.manifest.version)}catch(f){this.logService.error("Failed to run post uninstall script",c.identifier.id,c.manifest.version),this.logService.error(f)}}));try{await y.Promises.rm(this.getExtensionStoragePath(c))}catch(f){this.logService.error("Error while removing extension storage path",c.identifier.id),this.logService.error(f)}}parseScript(c,g){const f=`vscode:${g}`;if(c.location.scheme===_.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[f]=="string"){const h=c.manifest.scripts[f].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${f} should be a node script`),null):{script:(0,T.join)(c.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}runLifecycleHook(c,g,f,h,E){return new Promise((I,d)=>{const v=this.start(c,g,f,E);let t;const r=s=>{t&&(clearTimeout(t),t=null),s?d(s):I(void 0)};v.on("error",s=>{r((0,A.toErrorMessage)(s)||"Unknown")}),v.on("exit",(s,i)=>{r(s?`post-${g} process exited with code ${s}`:void 0)}),h&&(t=setTimeout(()=>{t=null,v.kill(),d("timed out")},5e3))})}start(c,g,f,h){const E={silent:!0,execArgv:void 0},I=(0,D.fork)(c,[`--type=extension-post-${g}`,...f],E);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const d=L.Event.fromNodeEventEmitter(I.stdout,"data"),v=L.Event.fromNodeEventEmitter(I.stderr,"data");this._register(d(s=>this.logService.info(h.identifier.id,h.manifest.version,`post-${g}`,s))),this._register(v(s=>this.logService.error(h.identifier.id,h.manifest.version,`post-${g}`,s)));const t=L.Event.any(L.Event.map(d,s=>({data:`%c${s}`,format:[""]}),this._store),L.Event.map(v,s=>({data:`%c${s}`,format:["color: red"]}),this._store));return L.Event.debounce(t,(s,i)=>s?{data:s.data+i.data,format:[...s.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this._store)(s=>{console.group(h.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),I}getExtensionStoragePath(c){return(0,T.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=u,e.ExtensionsLifecycle=u=we([Q(0,S.IUserDataProfilesService),Q(1,P.ILogService)],u)}),define(le[117],ue([0,1,72,167,84,28]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromExtractError=k,e.getManifest=_;function k(T){let y=L.ExtensionManagementErrorCode.Extract;return T instanceof D.ExtractError&&(T.type==="CorruptZip"?y=L.ExtensionManagementErrorCode.CorruptZip:T.type==="Incomplete"&&(y=L.ExtensionManagementErrorCode.IncompleteZip)),(0,A.toExtensionManagementError)(T,y)}async function _(T){let y;try{y=await(0,D.buffer)(T,"extension/package.json")}catch(P){throw k(P)}try{return JSON.parse(y.toString("utf8"))}catch{throw new L.ExtensionManagementError((0,a.localize)(0,null),L.ExtensionManagementErrorCode.Invalid)}}}),define(le[252],ue([0,1,6,8,2,23,21,56,32,31,72,22,16,84,28,33,117,111,7,10,18]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let t=class extends A.Disposable{static{v=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(s,i,n,o,l,m,w){super(),this.fileService=i,this.extensionGalleryService=n,this.configurationService=o,this.extensionSignatureVerificationService=l,this.telemetryService=m,this.logService=w,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(s,i,n,o){await this.cleanUpPromise;const l=await this.downloadVSIX(s,i);let m=!1;if(n&&this.shouldVerifySignature(s)){let w;try{w=await this.downloadSignatureArchive(s)}catch(C){try{await this.delete(l)}catch(b){this.logService.error(b)}throw C}try{m=await this.extensionSignatureVerificationService.verify(s,l.fsPath,w.fsPath,o)}catch(C){if(m=C.code,m===h.ExtensionSignatureVerificationCode.PackageIsInvalidZip||m===h.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(l)}catch(b){this.logService.error(b)}throw new c.ExtensionManagementError(P.CorruptZipMessage,c.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(w)}catch(C){this.logService.error(C)}}}return{location:l,verificationStatus:m}}shouldVerifySignature(s){return s.isSigned||this.logService.info(`Extension is not signed: ${s.identifier.id}`),!1}async downloadVSIX(s,i){try{const n=(0,k.joinPath)(this.extensionsDownloadDir,this.getName(s)),o=await this.doDownload(s,"vsix",async()=>{await this.downloadFile(s,n,l=>this.extensionGalleryService.download(s,l,i));try{await this.validate(n.fsPath,"extension/package.json")}catch(l){try{await this.fileService.del(n)}catch(m){this.logService.warn(`Error while deleting: ${n.path}`,(0,a.getErrorMessage)(m))}throw l}},2);return o>1&&this.telemetryService.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:s.identifier.id,attempts:o}),n}catch(n){throw(0,p.toExtensionManagementError)(n,c.ExtensionManagementErrorCode.Download)}}async downloadSignatureArchive(s){try{const i=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,T.generateUuid)()}`),n=await this.doDownload(s,"sigzip",async()=>{await this.extensionGalleryService.downloadSignatureArchive(s,i);try{await this.validate(i.fsPath,".signature.p7s")}catch(o){try{await this.fileService.del(i)}catch(l){this.logService.warn(`Error while deleting: ${i.path}`,(0,a.getErrorMessage)(l))}throw o}},2);return n>1&&this.telemetryService.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:s.identifier.id,attempts:n}),i}catch(i){throw(0,p.toExtensionManagementError)(i,c.ExtensionManagementErrorCode.DownloadSignature)}}async downloadFile(s,i,n){if(await this.fileService.exists(i))return;if(i.scheme!==L.Schemas.file){await n(i);return}const o=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,T.generateUuid)()}`);try{await n(o)}catch(l){try{await this.fileService.del(o)}catch{}throw l}try{await y.Promises.rename(o.fsPath,i.fsPath,2*60*1e3)}catch(l){try{await this.fileService.del(o)}catch{}let m=!1;try{m=await this.fileService.exists(i)}catch{}if(m)this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,i.path);else throw this.logService.info(`Rename failed because of ${(0,a.getErrorMessage)(l)}. Deleted the file from downloaded location`,o.path),l}}async doDownload(s,i,n,o){let l=1;for(;;)try{return await n(),l}catch(m){if(l++>o)throw m;this.logService.warn(`Failed downloading ${i}. ${(0,a.getErrorMessage)(m)}. Retry again...`,s.identifier.id)}}async validate(s,i){try{await(0,P.buffer)(s,i)}catch(n){throw(0,f.fromExtractError)(n)}}async delete(s){await this.cleanUpPromise,await this.fileService.del(s)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const i=[],n=[],o=[];for(const w of s.children)if(w.name.endsWith(v.SignatureArchiveExtension))o.push(w.resource);else{const C=g.ExtensionKey.parse(w.name);C&&n.push([C,w])}const l=(0,g.groupByExtension)(n,([w])=>w),m=[];for(const w of l)w.sort((C,b)=>_.rcompare(C[0].version,b[0].version)),i.push(...w.slice(1).map(C=>C[1].resource)),m.push(w[0][1]);m.sort((w,C)=>w.mtime-C.mtime),i.push(...m.slice(0,Math.max(0,m.length-this.cache)).map(w=>w.resource)),i.push(...o),await D.Promises.settled(i.map(w=>(this.logService.trace("Deleting from cache",w.path),this.fileService.del(w))))}}catch(s){this.logService.error(s)}}getName(s){return this.cache?g.ExtensionKey.create(s).toString().toLowerCase():(0,T.generateUuid)()}};e.ExtensionsDownloader=t,e.ExtensionsDownloader=t=v=we([Q(0,u.INativeEnvironmentService),Q(1,E.IFileService),Q(2,c.IExtensionGalleryService),Q(3,S.IConfigurationService),Q(4,h.IExtensionSignatureVerificationService),Q(5,d.ITelemetryService),Q(6,I.ILogService)],t)}),define(le[118],ue([0,1,6,15,26,40,8,3,55,2,35,23,14,21,56,13,9,32,31,72,166,99,16,84,28,33,53,85,252,251,117,224,234,37,73,7,4,10,24,18,29,20]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d,v,t,r,s,i,n,o,l,m,w,C,b,R,U,N,M,F,K,H,X,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(s.IExtensionManagementService);const ie=".vsctmp";let z=class extends r.AbstractExtensionManagementService{constructor(W,J,G,V,O,$,x,q,te,Z,Y,ae){super(W,J,Y,G,Z,ae),this.extensionsScannerService=O,this.extensionsProfileScannerService=$,this.downloadService=x,this.instantiationService=q,this.fileService=te,this.extractingGalleryExtensions=new Map,this.knownDirectories=new P.ResourceSet;const he=this._register(q.createInstance(m.ExtensionsLifecycle));this.extensionsScanner=this._register(q.createInstance(B,ve=>he.postUninstall(ve))),this.manifestCache=this._register(new C.ExtensionsManifestCache(ae,te,Y,this,this.logService)),this.extensionsDownloader=this._register(q.createInstance(l.ExtensionsDownloader));const ge=this._register(new b.ExtensionsWatcher(this,this.extensionsScannerService,ae,$,Y,te,G));this._register(ge.onDidChangeExtensionsByAnotherSource(ve=>this.onDidChangeExtensionsFromAnotherSource(ve))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const J=await this.collectFiles(W),G=await(0,I.zip)((0,p.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,J);return f.URI.file(G)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const{location:J,cleanup:G}=await this.downloadVsix(W),V=u.resolve(J.fsPath);try{return await(0,w.getManifest)(V)}finally{await G()}}getInstalled(W,J=this.userDataProfilesService.defaultProfile.extensionsResource,G={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(W??null,J,G)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(W){return this.extensionsScanner.scanUserExtensionAtLocation(W)}async install(W,J={}){this.logService.trace("ExtensionManagementService#install",W.toString());const{location:G,cleanup:V}=await this.downloadVsix(W);try{const O=await(0,w.getManifest)(u.resolve(G.fsPath)),$=(0,i.getGalleryExtensionId)(O.publisher,O.name);if(O.engines&&O.engines.vscode&&!(0,U.isEngineValid)(O.engines.vscode,this.productService.version,this.productService.date))throw new Error(d.localize(0,null,$,this.productService.version));const q=(await this.installExtensions([{manifest:O,extension:G,options:J}])).find(({identifier:te})=>(0,i.areSameExtensions)(te,{id:$}));if(q?.local)return q.local;throw q?.error?q.error:(0,r.toExtensionManagementError)(new Error(`Unknown error while installing extension ${$}`))}finally{await V()}}async installFromLocation(W,J){this.logService.trace("ExtensionManagementService#installFromLocation",W.toString());const G=await this.extensionsScanner.scanUserExtensionAtLocation(W);if(!G||!G.manifest.name||!G.manifest.version)throw new Error(`Cannot find a valid extension from the location ${W.toString()}`);return await this.addExtensionsToProfile([[G,{source:"resource"}]],J),this.logService.info("Successfully installed extension",G.identifier.id,J.toString()),G}async installExtensionsFromProfile(W,J,G){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",W,J.toString(),G.toString());const V=(await this.getInstalled(R.ExtensionType.User,J)).filter(O=>W.some($=>(0,i.areSameExtensions)($,O.identifier)));if(V.length){const O=await Promise.all(V.map($=>this.extensionsScanner.scanMetadata($,J)));await this.addExtensionsToProfile(V.map(($,x)=>[$,O[x]]),G),this.logService.info("Successfully installed extensions",V.map($=>$.identifier.id),G.toString())}return V}async updateMetadata(W,J,G=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id),J.isPreReleaseVersion&&(J.preRelease=!0,J.hasPreReleaseVersion=!0),J.isMachineScoped===!1&&(J.isMachineScoped=void 0),J.isBuiltin===!1&&(J.isBuiltin=void 0),J.pinned===!1&&(J.pinned=void 0),W=await this.extensionsScanner.updateMetadata(W,J,G),this.manifestCache.invalidate(G),this._onDidUpdateExtensionMetadata.fire(W),W}async reinstallFromGallery(W){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",W.identifier.id),!this.galleryService.isEnabled())throw new Error(d.localize(1,null));const J=await this.getTargetPlatform(),[G]=await this.galleryService.getExtensions([{...W.identifier,preRelease:W.preRelease}],{targetPlatform:J,compatible:!0},A.CancellationToken.None);if(!G)throw new Error(d.localize(2,null));await this.extensionsScanner.setUninstalled(W);try{await this.extensionsScanner.removeUninstalledExtension(W)}catch(V){throw new Error(d.localize(3,null,(0,L.toErrorMessage)(V)))}return this.installFromGallery(G)}copyExtension(W,J,G,V){return this.extensionsScanner.copyExtension(W,J,G,V)}copyExtensions(W,J){return this.extensionsScanner.copyExtensions(W,J,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...W){return this.extensionsScanner.setUninstalled(...W)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(W){this.logService.error(W)}}async download(W,J,G){const{location:V}=await this.extensionsDownloader.download(W,J,!G);return V}async downloadVsix(W){if(W.scheme===S.Schemas.file)return{location:W,async cleanup(){}};this.logService.trace("Downloading extension from",W.toString());const J=(0,p.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)());return await this.downloadService.download(W,J),this.logService.info("Downloaded extension to",J.toString()),{location:J,cleanup:async()=>{try{await this.fileService.del(J)}catch(V){this.logService.error(V)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(W,J,G){const V=J instanceof f.URI?new i.ExtensionKey({id:(0,i.getGalleryExtensionId)(W.publisher,W.name)},W.version):i.ExtensionKey.create(J);return this.instantiationService.createInstance(ee,V,W,J,G,(O,$)=>{if(J instanceof f.URI)return this.extractVSIX(V,J,G,$);let x=this.extractingGalleryExtensions.get(V.toString());return x||(this.extractingGalleryExtensions.set(V.toString(),x=this.downloadAndExtractGalleryExtension(V,J,O,G,$)),x.finally(()=>this.extractingGalleryExtensions.delete(V.toString()))),x},this.extensionsScanner)}createUninstallExtensionTask(W,J){return new se(W,J.profileLocation,this.extensionsProfileScannerService)}async downloadAndExtractGalleryExtension(W,J,G,V,O){const{verificationStatus:$,location:x}=await this.extensionsDownloader.download(J,G,!V.donotVerifySignature,V.context?.[s.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT]);try{if(O.isCancellationRequested)throw new k.CancellationError;return await(0,w.getManifest)(x.fsPath),{local:await this.extensionsScanner.extractUserExtension(W,x.fsPath,{id:J.identifier.uuid,publisherId:J.publisherId,publisherDisplayName:J.publisherDisplayName,targetPlatform:J.properties.targetPlatform,isApplicationScoped:V.isApplicationScoped,isMachineScoped:V.isMachineScoped,isBuiltin:V.isBuiltin,isPreReleaseVersion:J.properties.isPreReleaseVersion,hasPreReleaseVersion:J.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:V.installGivenVersion?!0:!!V.pinned,preRelease:(0,g.isBoolean)(V.preRelease)?V.preRelease:V.installPreReleaseVersion||J.properties.isPreReleaseVersion,source:"gallery"},!1,O),verificationStatus:$}}catch(q){try{await this.extensionsDownloader.delete(x)}catch(te){this.logService.warn("Error while deleting the downloaded file",x.toString(),(0,k.getErrorMessage)(te))}throw(0,r.toExtensionManagementError)(q)}}async extractVSIX(W,J,G,V){return{local:await this.extensionsScanner.extractUserExtension(W,u.resolve(J.fsPath),{isApplicationScoped:G.isApplicationScoped,isMachineScoped:G.isMachineScoped,isBuiltin:G.isBuiltin,installedTimestamp:Date.now(),pinned:G.installGivenVersion?!0:!!G.pinned,source:"vsix"},!0,V)}}async collectFiles(W){const J=async V=>{let O=await E.Promises.readdir(V);O=O.map(q=>u.join(V,q));const $=await Promise.all(O.map(q=>E.Promises.stat(q)));let x=Promise.resolve([]);return $.forEach((q,te)=>{const Z=O[te];q.isFile()&&(x=x.then(Y=>[...Y,Z])),q.isDirectory()&&(x=x.then(Y=>J(Z).then(ae=>[...Y,...ae])))}),x};return(await J(W.location.fsPath)).map(V=>({path:`extension/${u.relative(W.location.fsPath,V)}`,localPath:V}))}async onDidChangeExtensionsFromAnotherSource({added:W,removed:J}){if(J){const G=W&&this.uriIdentityService.extUri.isEqual(J.profileLocation,W.profileLocation)?J.extensions.filter(V=>W.extensions.every(O=>!(0,i.areSameExtensions)(O,V))):J.extensions;for(const V of G)this.logService.info("Extensions removed from another source",V.id,J.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:V,profileLocation:J.profileLocation})}if(W){const V=(await this.getInstalled(R.ExtensionType.User,W.profileLocation)).filter(O=>W.extensions.some($=>(0,i.areSameExtensions)($,O.identifier)));this._onDidInstallExtensions.fire(V.map(O=>(this.logService.info("Extensions added from another source",O.identifier.id,W.profileLocation.toString()),{identifier:O.identifier,local:O,profileLocation:W.profileLocation,operation:s.InstallOperation.None})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(J=>this.knownDirectories.add(J)));const W=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const J of W.children??[])J.isDirectory&&this.knownDirectories.add(J.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(J=>this.onDidFilesChange(J)))}async onDidFilesChange(W){if(!W.affects(this.extensionsScannerService.userExtensionsLocation,N.FileChangeType.ADDED))return;const J=[];for(const G of W.rawAdded){if(this.knownDirectories.has(G)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(G),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(G,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(G).startsWith(".")||!(await this.fileService.stat(G)).isDirectory)continue;const V=await this.extensionsScanner.scanUserExtensionAtLocation(G);V&&V.installedTimestamp===void 0&&(this.knownDirectories.add(G),J.push(V))}J.length&&(await this.addExtensionsToProfile(J.map(G=>[G,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",J.map(G=>G.identifier.id)))}async addExtensionsToProfile(W,J){const G=W.map(V=>V[0]);await this.setInstalled(G),await this.extensionsProfileScannerService.addExtensionsToProfile(W,J),this._onDidInstallExtensions.fire(G.map(V=>({local:V,identifier:V.identifier,operation:s.InstallOperation.None,profileLocation:J})))}async setInstalled(W){const J=await this.extensionsScanner.getUninstalledExtensions();for(const G of W){const V=i.ExtensionKey.create(G);J[V.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",V.id),await this.extensionsScanner.setInstalled(V),this.logService.info("Removed the extension from uninstalled list:",V.id))}}};e.ExtensionManagementService=z,e.ExtensionManagementService=z=we([Q(0,s.IExtensionGalleryService),Q(1,H.ITelemetryService),Q(2,F.ILogService),Q(3,t.INativeEnvironmentService),Q(4,o.IExtensionsScannerService),Q(5,n.IExtensionsProfileScannerService),Q(6,v.IDownloadService),Q(7,M.IInstantiationService),Q(8,N.IFileService),Q(9,K.IProductService),Q(10,X.IUriIdentityService),Q(11,j.IUserDataProfilesService)],z);let B=class extends y.Disposable{constructor(W,J,G,V,O,$){super(),this.beforeRemovingExtension=W,this.fileService=J,this.extensionsScannerService=G,this.extensionsProfileScannerService=V,this.uriIdentityService=O,this.logService=$,this._onExtract=this._register(new _.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,p.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(W,J,G){try{const V={includeInvalid:!0,profileLocation:J,productVersion:G};let O=[];return W===null||W===R.ExtensionType.System?O.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},V,!1)):W===R.ExtensionType.User&&O.push(...await this.extensionsScannerService.scanUserExtensions(V)),O=W!==null?O.filter($=>$.type===W):O,await Promise.all(O.map($=>this.toLocalExtension($)))}catch(V){throw(0,r.toExtensionManagementError)(V,s.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(W){try{const J=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!W,includeInvalid:!0});return await Promise.all(J.map(G=>this.toLocalExtension(G)))}catch(J){throw(0,r.toExtensionManagementError)(J,s.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(W){try{const J=await this.extensionsScannerService.scanExistingExtension(W,R.ExtensionType.User,{includeInvalid:!0});if(J)return await this.toLocalExtension(J)}catch(J){this.logService.error(J)}return null}async extractUserExtension(W,J,G,V,O){const $=W.toString(),x=f.URI.file(u.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`)),q=f.URI.file(u.join(this.extensionsScannerService.userExtensionsLocation.fsPath,$));let te=await this.fileService.exists(q);if(te&&V){try{await this.deleteExtensionFromLocation(W.id,q,"removeExisting")}catch{throw new s.ExtensionManagementError(d.localize(4,null,q.fsPath,W.id),s.ExtensionManagementErrorCode.Delete)}te=!1}if(te)try{await this.extensionsScannerService.updateMetadata(q,G)}catch(Z){throw(0,r.toExtensionManagementError)(Z,s.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(O.isCancellationRequested)throw new k.CancellationError;try{this.logService.trace(`Started extracting the extension from ${J} to ${q.fsPath}`),await(0,I.extract)(J,x.fsPath,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${q}:`,W.id)}catch(Z){throw(0,w.fromExtractError)(Z)}try{await this.extensionsScannerService.updateMetadata(x,G)}catch(Z){throw(0,r.toExtensionManagementError)(Z,s.ExtensionManagementErrorCode.UpdateMetadata)}if(O.isCancellationRequested)throw new k.CancellationError;try{this.logService.trace(`Started renaming the extension from ${x.fsPath} to ${q.fsPath}`),await this.rename(x.fsPath,q.fsPath),this.logService.info("Renamed to",q.fsPath)}catch(Z){if(Z.code==="ENOTEMPTY"){this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",W.id);try{await this.fileService.del(x,{recursive:!0})}catch{}}else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(Z)}. Deleted from extracted location`,x),Z}this._onExtract.fire(q)}catch(Z){try{await this.fileService.del(x,{recursive:!0})}catch{}throw Z}return this.scanLocalExtension(q,R.ExtensionType.User)}async scanMetadata(W,J){return J?(await this.getScannedExtension(W,J))?.metadata:this.extensionsScannerService.scanMetadata(W.location)}async getScannedExtension(W,J){return(await this.extensionsProfileScannerService.scanProfileExtensions(J)).find(V=>(0,i.areSameExtensions)(V.identifier,W.identifier))}async updateMetadata(W,J,G){try{G?await this.extensionsProfileScannerService.updateMetadata([[W,J]],G):await this.extensionsScannerService.updateMetadata(W.location,J)}catch(V){throw(0,r.toExtensionManagementError)(V,s.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(W.location,W.type,G)}async getUninstalledExtensions(){try{return await this.withUninstalledExtensions()}catch(W){throw(0,r.toExtensionManagementError)(W,s.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...W){const J=W.map(G=>i.ExtensionKey.create(G));await this.withUninstalledExtensions(G=>J.forEach(V=>{G[V.toString()]=!0,this.logService.info("Marked extension as uninstalled",V.toString())}))}async setInstalled(W){try{await this.withUninstalledExtensions(J=>delete J[W.toString()])}catch(J){throw(0,r.toExtensionManagementError)(J,s.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(W,J){if(this.uriIdentityService.extUri.isEqualOrParent(W.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(W.identifier.id,W.location,J)}async removeUninstalledExtension(W){await this.removeExtension(W,"uninstalled"),await this.withUninstalledExtensions(J=>delete J[i.ExtensionKey.create(W).toString()])}async copyExtension(W,J,G,V){const O=await this.getScannedExtension(W,J),$=await this.getScannedExtension(W,G);if(V={...O?.metadata,...V},$)if(this.uriIdentityService.extUri.isEqual($.location,W.location))await this.extensionsProfileScannerService.updateMetadata([[W,{...$.metadata,...V}]],G);else{const x=await this.scanLocalExtension($.location,W.type,G);await this.extensionsProfileScannerService.removeExtensionFromProfile(x,G),await this.extensionsProfileScannerService.addExtensionsToProfile([[W,{...$.metadata,...V}]],G)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[W,V]],G);return this.scanLocalExtension(W.location,W.type,G)}async copyExtensions(W,J,G){const V=await this.scanExtensions(R.ExtensionType.User,W,G),O=await Promise.all(V.filter($=>!$.isApplicationScoped).map(async $=>[$,await this.scanMetadata($,W)]));await this.extensionsProfileScannerService.addExtensionsToProfile(O,J)}async deleteExtensionFromLocation(W,J,G){this.logService.trace(`Deleting ${G} extension from disk`,W,J.fsPath);const V=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(J),`${this.uriIdentityService.extUri.basename(J)}.${(0,T.hash)((0,h.generateUuid)()).toString(16)}${ie}`);await this.rename(J.fsPath,V.fsPath),await this.fileService.del(V,{recursive:!0}),this.logService.info(`Deleted ${G} extension from disk`,W,J.fsPath)}withUninstalledExtensions(W){return this.uninstalledFileLimiter.queue(async()=>{let J;try{J=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(V){if((0,N.toFileOperationResult)(V)!==N.FileOperationResult.FILE_NOT_FOUND)throw V}let G={};if(J)try{G=JSON.parse(J)}catch{}return W&&(W(G),Object.keys(G).length?await this.fileService.writeFile(this.uninstalledResource,a.VSBuffer.fromString(JSON.stringify(G))):await this.fileService.del(this.uninstalledResource)),G})}async rename(W,J){try{await E.Promises.rename(W,J,2*60*1e3)}catch(G){throw(0,r.toExtensionManagementError)(G,s.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(W,J,G){try{if(G){const O=(await this.extensionsScannerService.scanUserExtensions({profileLocation:G})).find($=>this.uriIdentityService.extUri.isEqual($.location,W));if(O)return await this.toLocalExtension(O)}else{const V=await this.extensionsScannerService.scanExistingExtension(W,J,{includeInvalid:!0});if(V)return await this.toLocalExtension(V)}throw new s.ExtensionManagementError(d.localize(5,null,W.path),s.ExtensionManagementErrorCode.ScanningExtension)}catch(V){throw(0,r.toExtensionManagementError)(V,s.ExtensionManagementErrorCode.ScanningExtension)}}async toLocalExtension(W){const J=await this.fileService.resolve(W.location);let G,V;return J.children&&(G=J.children.find(({name:O})=>/^readme(\.txt|\.md|)$/i.test(O))?.resource,V=J.children.find(({name:O})=>/^changelog(\.txt|\.md|)$/i.test(O))?.resource),{identifier:W.identifier,type:W.type,isBuiltin:W.isBuiltin||!!W.metadata?.isBuiltin,location:W.location,manifest:W.manifest,targetPlatform:W.targetPlatform,validations:W.validations,isValid:W.isValid,readmeUrl:G,changelogUrl:V,publisherDisplayName:W.metadata?.publisherDisplayName,publisherId:W.metadata?.publisherId||null,isApplicationScoped:!!W.metadata?.isApplicationScoped,isMachineScoped:!!W.metadata?.isMachineScoped,isPreReleaseVersion:!!W.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!W.metadata?.hasPreReleaseVersion,preRelease:!!W.metadata?.preRelease,installedTimestamp:W.metadata?.installedTimestamp,updated:!!W.metadata?.updated,pinned:!!W.metadata?.pinned,isWorkspaceScoped:!1,source:W.metadata?.source??(W.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const W=await this.getUninstalledExtensions();if(Object.keys(W).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(W));const J=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),G=new Set;for(const O of J)W[i.ExtensionKey.create(O).toString()]||G.add(O.identifier.id.toLowerCase());try{const O=(0,i.groupByExtension)(J,$=>$.identifier);await D.Promises.settled(O.map(async $=>{const x=$.sort((q,te)=>c.rcompare(q.manifest.version,te.manifest.version))[0];G.has(x.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(x))}))}catch(O){this.logService.error(O)}const V=J.filter(O=>O.metadata&&W[i.ExtensionKey.create(O).toString()]);await Promise.allSettled(V.map(O=>this.removeUninstalledExtension(O)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let W;try{W=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(J){(0,N.toFileOperationResult)(J)!==N.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(J);return}if(W?.children)try{await Promise.allSettled(W.children.map(async J=>{if(!(!J.isDirectory||!J.name.endsWith(ie))){this.logService.trace("Deleting the temporarily deleted folder",J.resource.toString());try{await this.fileService.del(J.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",J.resource.toString())}catch(G){(0,N.toFileOperationResult)(G)!==N.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(G)}}}))}catch{}}};e.ExtensionsScanner=B,e.ExtensionsScanner=B=we([Q(1,N.IFileService),Q(2,o.IExtensionsScannerService),Q(3,n.IExtensionsProfileScannerService),Q(4,X.IUriIdentityService),Q(5,F.ILogService)],B);let ee=class extends r.AbstractExtensionTask{get operation(){return this.options.operation??this._operation}get verificationStatus(){return this._verificationStatus}constructor(W,J,G,V,O,$,x,q,te,Z,Y,ae){super(),this.extensionKey=W,this.manifest=J,this.source=G,this.options=V,this.extractExtensionFn=O,this.extensionsScanner=$,this.uriIdentityService=x,this.galleryService=q,this.userDataProfilesService=te,this.extensionsScannerService=Z,this.extensionsProfileScannerService=Y,this.logService=ae,this._operation=s.InstallOperation.Install,this.identifier=this.extensionKey.identifier}async getExistingExtension(){return(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(J=>(0,i.areSameExtensions)(J.identifier,this.identifier))}async doRun(W){const J=await this.getExistingExtension();J&&(this._operation=s.InstallOperation.Update);const G={isApplicationScoped:this.options.isApplicationScoped||J?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||J?.isMachineScoped,isBuiltin:this.options.isBuiltin||J?.isBuiltin,isSystem:J?.type===R.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??J?.pinned,source:this.source instanceof f.URI?"vsix":"gallery"};let V;if(this.source instanceof f.URI)if(J){if(this.extensionKey.equals(new i.ExtensionKey(J.identifier,J.manifest.version)))try{await this.extensionsScanner.removeExtension(J,"existing")}catch{throw new Error(d.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const $=await this.unsetIfUninstalled(this.extensionKey);if($)try{await this.extensionsScanner.removeExtension($,"existing")}catch{throw new Error(d.localize(7,null,this.manifest.displayName||this.manifest.name))}}else G.id=this.source.identifier.uuid,G.publisherId=this.source.publisherId,G.publisherDisplayName=this.source.publisherDisplayName,G.targetPlatform=this.source.properties.targetPlatform,G.updated=!!J,G.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,G.hasPreReleaseVersion=J?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,G.preRelease=(0,g.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||J?.preRelease,J&&J.type!==R.ExtensionType.System&&J.manifest.version===this.source.version?V=await this.extensionsScanner.updateMetadata(J,G):V=await this.unsetIfUninstalled(this.extensionKey);if(W.isCancellationRequested)throw(0,r.toExtensionManagementError)(new k.CancellationError);if(!V){const $=await this.extractExtensionFn(this.operation,W);V=$.local,this._verificationStatus=$.verificationStatus}if(this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.extensionsScannerService.initializeDefaultProfileExtensions()}catch($){throw(0,r.toExtensionManagementError)($,s.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(W.isCancellationRequested)throw(0,r.toExtensionManagementError)(new k.CancellationError);try{await this.extensionsProfileScannerService.addExtensionsToProfile([[V,G]],this.options.profileLocation,!V.isValid)}catch($){throw(0,r.toExtensionManagementError)($,s.ExtensionManagementErrorCode.AddToProfile)}const O=await this.getExistingExtension();if(!O)throw new s.ExtensionManagementError("Cannot find the installed extension",s.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof f.URI&&this.updateMetadata(V,W),O}async unsetIfUninstalled(W){return(await this.extensionsScanner.getUninstalledExtensions())[W.toString()]?(this.logService.trace("Removing the extension from uninstalled list:",W.id),await this.extensionsScanner.setInstalled(W),this.logService.info("Removed the extension from uninstalled list:",W.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(V=>i.ExtensionKey.create(V).equals(W))):void 0}async updateMetadata(W,J){try{let[G]=await this.galleryService.getExtensions([{id:W.identifier.id,version:W.manifest.version}],J);if(G||([G]=await this.galleryService.getExtensions([{id:W.identifier.id}],J)),G){const V={id:G.identifier.uuid,publisherDisplayName:G.publisherDisplayName,publisherId:G.publisherId,isPreReleaseVersion:G.properties.isPreReleaseVersion,hasPreReleaseVersion:W.hasPreReleaseVersion||G.properties.isPreReleaseVersion,preRelease:G.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(W,V,this.options.profileLocation)}}catch{}}};ee=we([Q(6,X.IUriIdentityService),Q(7,s.IExtensionGalleryService),Q(8,j.IUserDataProfilesService),Q(9,o.IExtensionsScannerService),Q(10,n.IExtensionsProfileScannerService),Q(11,F.ILogService)],ee);class se extends r.AbstractExtensionTask{constructor(W,J,G){super(),this.extension=W,this.profileLocation=J,this.extensionsProfileScannerService=G}async doRun(W){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(le[253],ue([0,1,10,20,29,18,53,7,16,9]),function(ne,e,D,a,A,L,k,_,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends k.AbstractExtensionsProfileScannerService{constructor(u,p,c,g,f,h){super(y.URI.file(u.extensionsPath),p,c,g,f,h)}};e.ExtensionsProfileScannerService=P,e.ExtensionsProfileScannerService=P=we([Q(0,T.INativeEnvironmentService),Q(1,_.IFileService),Q(2,a.IUserDataProfilesService),Q(3,A.IUriIdentityService),Q(4,L.ITelemetryService),Q(5,D.ILogService)],P)}),define(le[254],ue([0,1,9,16,53,85,7,4,10,24,29,20]),function(ne,e,D,a,A,L,k,_,T,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let u=class extends L.NativeExtensionsScannerService{constructor(c,g,f,h,E,I,d,v){super(D.URI.file(E.builtinExtensionsPath),D.URI.file(E.extensionsPath),E.userHome,c.defaultProfile,c,g,f,h,E,I,d,v)}};e.ExtensionsScannerService=u,e.ExtensionsScannerService=u=we([Q(0,S.IUserDataProfilesService),Q(1,A.IExtensionsProfileScannerService),Q(2,k.IFileService),Q(3,T.ILogService),Q(4,a.INativeEnvironmentService),Q(5,y.IProductService),Q(6,P.IUriIdentityService),Q(7,_.IInstantiationService)],u)}),define(le[17],ue([0,1,6,3,2,101,13,71,4,20]),function(ne,e,D,a,A,L,k,_,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=p,e.isProfileUsingDefaultStorage=g,e.logStorage=h,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,T.createDecorator)("storageService");var P;(function(E){E[E.NONE=0]="NONE",E[E.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var S;(function(E){E[E.APPLICATION=-1]="APPLICATION",E[E.PROFILE=0]="PROFILE",E[E.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var u;(function(E){E[E.USER=0]="USER",E[E.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function p(E){const I=E.get(e.TARGET_KEY);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}class c extends A.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(I={flushInterval:c.DEFAULT_FLUSH_INTERVAL}){super(),this.options=I,this._onDidChangeValue=this._register(new a.PauseableEmitter),this._onDidChangeTarget=this._register(new a.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new a.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(I,d,v){return a.Event.filter(this._onDidChangeValue.event,t=>t.scope===I&&(d===void 0||t.key===d),v)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,d){const{key:v,external:t}=d;if(v===e.TARGET_KEY){switch(I){case S.APPLICATION:this._applicationKeyTargets=void 0;break;case S.PROFILE:this._profileKeyTargets=void 0;break;case S.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:I})}else this._onDidChangeValue.fire({scope:I,key:v,target:this.getKeyTargets(I)[v],external:t})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,d,v){return this.getStorage(d)?.get(I,v)}getBoolean(I,d,v){return this.getStorage(d)?.getBoolean(I,v)}getNumber(I,d,v){return this.getStorage(d)?.getNumber(I,v)}getObject(I,d,v){return this.getStorage(d)?.getObject(I,v)}storeAll(I,d){this.withPausedEmitters(()=>{for(const v of I)this.store(v.key,v.value,v.scope,v.target,d)})}store(I,d,v,t,r=!1){if((0,k.isUndefinedOrNull)(d)){this.remove(I,v,r);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,v,t),this.getStorage(v)?.set(I,d,r)})}remove(I,d,v=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(I,d,void 0),this.getStorage(d)?.delete(I,v)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,d){const v=[],t=this.getKeyTargets(I);for(const r of Object.keys(t))t[r]===d&&v.push(r);return v}updateKeyTarget(I,d,v,t=!1){const r=this.getKeyTargets(d);typeof v=="number"?r[I]!==v&&(r[I]=v,this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(r),t)):typeof r[I]=="number"&&(delete r[I],this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(r),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(S.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(S.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(S.APPLICATION)),this._applicationKeyTargets}getKeyTargets(I){switch(I){case S.APPLICATION:return this.applicationKeyTargets;case S.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(I){const d=this.getStorage(I);return d?p(d):Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=P.NONE){this._onWillSaveState.fire({reason:I});const d=this.getStorage(S.APPLICATION),v=this.getStorage(S.PROFILE),t=this.getStorage(S.WORKSPACE);switch(I){case P.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.getStorage(S.APPLICATION)?.items??new Map,d=this.getStorage(S.PROFILE)?.items??new Map,v=this.getStorage(S.WORKSPACE)?.items??new Map;return h(I,d,v,this.getLogDetails(S.APPLICATION)??"",this.getLogDetails(S.PROFILE)??"",this.getLogDetails(S.WORKSPACE)??"")}async optimize(I){return await this.flush(),this.getStorage(I)?.optimize()}async switch(I,d){return this.emitWillSaveState(P.NONE),(0,y.isUserDataProfile)(I)?this.switchToProfile(I,d):this.switchToWorkspace(I,d)}canSwitchProfile(I,d){return!(I.id===d.id||g(d)&&g(I))}switchData(I,d,v){this.withPausedEmitters(()=>{const t=new Set;for(const[r,s]of I)t.add(r),d.get(r)!==s&&this.emitDidChangeValue(v,{key:r,external:!0});for(const[r]of d.items)t.has(r)||this.emitDidChangeValue(v,{key:r,external:!0})})}}e.AbstractStorageService=c;function g(E){return E.isDefault||!!E.useDefaultFlags?.globalState}class f extends c{constructor(){super(),this.applicationStorage=this._register(new _.Storage(new _.InMemoryStorageDatabase,{hint:_.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new _.Storage(new _.InMemoryStorageDatabase,{hint:_.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new _.Storage(new _.InMemoryStorageDatabase,{hint:_.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(S.WORKSPACE,I))),this._register(this.profileStorage.onDidChangeStorage(I=>this.emitDidChangeValue(S.PROFILE,I))),this._register(this.applicationStorage.onDidChangeStorage(I=>this.emitDidChangeValue(S.APPLICATION,I)))}getStorage(I){switch(I){case S.APPLICATION:return this.applicationStorage;case S.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(I){switch(I){case S.APPLICATION:return"inMemory (application)";case S.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(I){return!1}}e.InMemoryStorageService=f;async function h(E,I,d,v,t,r){const s=R=>{try{return JSON.parse(R)}catch{return R}},i=new Map,n=new Map;E.forEach((R,U)=>{i.set(U,R),n.set(U,s(R))});const o=new Map,l=new Map;I.forEach((R,U)=>{o.set(U,R),l.set(U,s(R))});const m=new Map,w=new Map;d.forEach((R,U)=>{m.set(U,R),w.set(U,s(R))}),console.group(v!==t?`Storage: Application (path: ${v})`:`Storage: Application & Profile (path: ${v}, default profile)`);const C=[];if(i.forEach((R,U)=>{C.push({key:U,value:R})}),console.table(C),console.groupEnd(),console.log(n),v!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const R=[];o.forEach((U,N)=>{R.push({key:N,value:U})}),console.table(R),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const b=[];m.forEach((R,U)=>{b.push({key:U,value:R})}),console.table(b),console.groupEnd(),console.log(w)}}),define(le[119],ue([0,1,3,2,13,28,33,17]),function(ne,e,D,a,A,L,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let T=class extends a.Disposable{constructor(S,u){super(),this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new y(S)),this._register(this.storageManger.onDidChange(p=>this._onDidChangeEnablement.fire({extensions:p,source:"storage"}))),this._register(u.onDidInstallExtensions(p=>p.forEach(({local:c,operation:g})=>{c&&g===L.InstallOperation.Migrate&&this._removeFromDisabledExtensions(c.identifier)})))}async enableExtension(S,u){return this._removeFromDisabledExtensions(S)?(this._onDidChangeEnablement.fire({extensions:[S],source:u}),!0):!1}async disableExtension(S,u){return this._addToDisabledExtensions(S)?(this._onDidChangeEnablement.fire({extensions:[S],source:u}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(S){const u=this.getDisabledExtensions();return u.every(p=>!(0,k.areSameExtensions)(p,S))?(u.push(S),this._setDisabledExtensions(u),!0):!1}_removeFromDisabledExtensions(S){const u=this.getDisabledExtensions();for(let p=0;p<u.length;p++){const c=u[p];if((0,k.areSameExtensions)(c,S))return u.splice(p,1),this._setDisabledExtensions(u),!0}return!1}_setDisabledExtensions(S){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,S)}_getExtensions(S){return this.storageManger.get(S,_.StorageScope.PROFILE)}_setExtensions(S,u){this.storageManger.set(S,u,_.StorageScope.PROFILE)}};e.GlobalExtensionEnablementService=T,e.GlobalExtensionEnablementService=T=we([Q(0,_.IStorageService),Q(1,L.IExtensionManagementService)],T);class y extends a.Disposable{constructor(S){super(),this.storageService=S,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(S.onDidChangeValue(_.StorageScope.PROFILE,void 0,this._register(new a.DisposableStore))(u=>this.onDidStorageChange(u)))}get(S,u){let p;return u===_.StorageScope.PROFILE?((0,A.isUndefinedOrNull)(this.storage[S])&&(this.storage[S]=this._get(S,u)),p=this.storage[S]):p=this._get(S,u),JSON.parse(p)}set(S,u,p){const c=JSON.stringify(u.map(({id:f,uuid:h})=>({id:f,uuid:h})));this._get(S,p)!==c&&(p===_.StorageScope.PROFILE&&(u.length?this.storage[S]=c:delete this.storage[S]),this._set(S,u.length?c:void 0,p))}onDidStorageChange(S){if(!(0,A.isUndefinedOrNull)(this.storage[S.key])&&this._get(S.key,S.scope)!==this.storage[S.key]){const p=this.get(S.key,S.scope);delete this.storage[S.key];const c=this.get(S.key,S.scope),g=p.filter(h=>!c.some(E=>(0,k.areSameExtensions)(h,E))),f=c.filter(h=>!p.some(E=>(0,k.areSameExtensions)(E,h)));(g.length||f.length)&&this._onDidChange.fire([...g,...f])}}_get(S,u){return this.storageService.get(S,u,"[]")}_set(S,u,p){u?this.storageService.store(S,u,p,_.StorageTarget.MACHINE):this.storageService.remove(S,p)}}e.StorageManager=y}),define(le[86],ue([0,1,4,3,2,17,33,24,19,10,13]),function(ne,e,D,a,A,L,k,_,T,y,P){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const u=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class extends A.Disposable{static{S=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(g){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const f=u.exec(g);if(f&&f[1])return{id:f[1],version:f[2]}}static async removeOutdatedExtensionVersions(g,f){const h=await g.getInstalled(),E=[];for(const[I,d]of S.readAllExtensionsWithKeysForSync(f)){const v=h.find(t=>(0,k.areSameExtensions)(t.identifier,{id:I}))?.manifest.version;for(const t of d)v!==t&&E.push(S.toKey({id:I,version:t}))}for(const I of E)f.remove(I,L.StorageScope.PROFILE)}static readAllExtensionsWithKeysForSync(g){const f=new Map,h=g.keys(L.StorageScope.PROFILE,L.StorageTarget.MACHINE);for(const E of h){const I=S.fromKey(E);if(I){let d=f.get(I.id.toLowerCase());d||f.set(I.id.toLowerCase(),d=[]),d.push(I.version)}}return f}constructor(g,f,h){super(),this.storageService=g,this.productService=f,this.logService=h,this._onDidChangeExtensionStorageToSync=this._register(new a.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=S.readAllExtensionsWithKeysForSync(g),this._register(this.storageService.onDidChangeValue(L.StorageScope.PROFILE,void 0,this._register(new A.DisposableStore))(E=>this.onDidChangeStorageValue(E)))}onDidChangeStorageValue(g){if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const f=S.fromKey(g.key);if(f){if(this.storageService.get(g.key,L.StorageScope.PROFILE)===void 0)this.extensionsWithKeysForSync.delete(f.id.toLowerCase());else{let h=this.extensionsWithKeysForSync.get(f.id.toLowerCase());h||this.extensionsWithKeysForSync.set(f.id.toLowerCase(),h=[]),h.push(f.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(g){if((0,P.isString)(g))return g;const f=g.manifest?g.manifest.publisher:g.publisher,h=g.manifest?g.manifest.name:g.name;return(0,k.getExtensionId)(f,h)}getExtensionState(g,f){const h=this.getExtensionId(g),E=this.getExtensionStateRaw(g,f);if(E)try{return JSON.parse(E)}catch(I){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${f}): ${I}`)}}getExtensionStateRaw(g,f){const h=this.getExtensionId(g),E=this.storageService.get(h,f?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE);return E&&E?.length>S.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${f}): ${E.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),E}setExtensionState(g,f,h){const E=this.getExtensionId(g);f===void 0?this.storageService.remove(E,h?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE):this.storageService.store(E,JSON.stringify(f),h?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE,L.StorageTarget.MACHINE)}setKeysForSync(g,f){this.storageService.store(S.toKey(g),JSON.stringify(f),L.StorageScope.PROFILE,L.StorageTarget.MACHINE)}getKeysForSync(g){const f=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],h=this.storageService.get(S.toKey(g),L.StorageScope.PROFILE),E=h?JSON.parse(h):void 0;return E&&f?(0,T.distinct)([...E,...f]):E||f}addToMigrationList(g,f){if(g!==f){const h=this.migrationList.filter(E=>!E.includes(g)&&!E.includes(f));h.push([g,f]),this.migrationList=h}}getSourceExtensionToMigrate(g){const f=this.migrationList.find(([,h])=>g===h);return f?f[0]:void 0}get migrationList(){const g=this.storageService.get("extensionStorage.migrationList",L.StorageScope.APPLICATION,"[]");try{const f=JSON.parse(g);if(Array.isArray(f))return f}catch{}return[]}set migrationList(g){g.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(g),L.StorageScope.APPLICATION,L.StorageTarget.MACHINE):this.storageService.remove("extensionStorage.migrationList",L.StorageScope.APPLICATION)}};e.ExtensionStorageService=p,e.ExtensionStorageService=p=S=we([Q(0,L.IStorageService),Q(1,_.IProductService),Q(2,y.ILogService)],p)}),define(le[255],ue([0,1,2,28,86,233,118,10,17]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let y=class extends D.Disposable{constructor(S,u,p,c,g,f){super(),S.cleanUp(),(0,L.migrateUnsupportedExtensions)(S,u,p,c,f),A.ExtensionStorageService.removeOutdatedExtensionVersions(S,g)}};e.ExtensionsContributions=y,e.ExtensionsContributions=y=we([Q(0,k.INativeServerExtensionManagementService),Q(1,a.IExtensionGalleryService),Q(2,A.IExtensionStorageService),Q(3,a.IGlobalExtensionEnablementService),Q(4,T.IStorageService),Q(5,_.ILogService)],y)}),define(le[256],ue([0,1,19,2,21,9,7,24,6,3,14,5,36,33,75,37,17]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let h=class extends a.Disposable{constructor(t,r){super(),this.fileService=t,this.productService=r,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,s])=>this.allConfigBasedTips.set(s.configPath,s))}getConfigBasedTips(t){return this.getValidConfigBasedTips(t)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(t){const r=[];for(const[s,i]of this.allConfigBasedTips)if(!(i.configScheme&&i.configScheme!==t.scheme))try{const n=(await this.fileService.readFile((0,A.joinPath)(t,s))).value.toString();for(const[o,l]of Object.entries(i.recommendations))(!l.contentPattern||new RegExp(l.contentPattern,"mig").test(n))&&r.push({extensionId:o,extensionName:l.name,configName:i.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})}catch{}return r}};e.ExtensionTipsService=h,e.ExtensionTipsService=h=we([Q(0,k.IFileService),Q(1,_.IProductService)],h);const E="extensionTips/promptedExecutableTips",I="extensionTips/lastPromptedMediumImpExeTime";class d extends h{constructor(t,r,s,i,n,o,l,m){super(l,m),this.userHome=t,this.windowEvents=r,this.telemetryService=s,this.extensionManagementService=i,this.storageService=n,this.extensionRecommendationNotificationService=o,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,m.exeBasedExtensionTips&&Object.entries(m.exeBasedExtensionTips).forEach(([w,C])=>{const b=[],R=[],U=[];Object.entries(C.recommendations).forEach(([N,M])=>{M.important?C.important?b.push({extensionId:N,extensionName:M.name,isExtensionPack:!!M.isExtensionPack}):R.push({extensionId:N,extensionName:M.name,isExtensionPack:!!M.isExtensionPack}):U.push({extensionId:N,extensionName:M.name,isExtensionPack:!!M.isExtensionPack})}),b.length&&this.highImportanceExecutableTips.set(w,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:b}),R.length&&this.mediumImportanceExecutableTips.set(w,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:R}),U.length&&this.allOtherExecutableTips.set(w,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:U})}),(0,T.disposableTimeout)(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()},3e3,this._store)}async getImportantExecutableBasedTips(){const t=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),r=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...t,...r]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const t=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),r=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),s=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(t,s),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(r,s)}groupImportantTipsByExe(t,r){const s=new Map;t.forEach(m=>s.set(m.extensionId.toLowerCase(),m));const{installed:i,uninstalled:n}=this.groupByInstalled([...s.keys()],r);for(const m of i){const w=s.get(m);w&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:m,exeName:w.exeName})}for(const m of n){const w=s.get(m);w&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:m,exeName:w.exeName})}const o=this.getPromptedExecutableTips(),l=new Map;for(const m of n){const w=s.get(m);if(w&&(!o[w.exeName]||!o[w.exeName].includes(w.extensionId))){let C=l.get(w.exeName);C||(C=[],l.set(w.exeName,C)),C.push(w)}}return l}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[t,r]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(r).then(s=>{switch(s){case c.RecommendationsNotificationResult.Accepted:this.addToRecommendedExecutables(r[0].exeName,r);break;case c.RecommendationsNotificationResult.Ignored:this.highImportanceTipsByExe.delete(t);break;case c.RecommendationsNotificationResult.IncompatibleWindow:{const i=y.Event.once(y.Event.latch(y.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(i(()=>this.promptHighImportanceExeBasedTip()));break}case c.RecommendationsNotificationResult.TooMany:{const i=this._register(new a.MutableDisposable);i.value=(0,T.disposableTimeout)(()=>{i.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3);break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const t=this.getLastPromptedMediumExeTime(),r=Date.now()-t,s=7*24*60*60*1e3;if(r<s){const o=this._register(new a.MutableDisposable);o.value=(0,T.disposableTimeout)(()=>{o.dispose(),this.promptMediumImportanceExeBasedTip()},s-r);return}const[i,n]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(n).then(o=>{switch(o){case c.RecommendationsNotificationResult.Accepted:{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(i),this.addToRecommendedExecutables(n[0].exeName,n);const l=this._register(new a.MutableDisposable);l.value=(0,T.disposableTimeout)(()=>{l.dispose(),this.promptMediumImportanceExeBasedTip()},s);break}case c.RecommendationsNotificationResult.Ignored:this.mediumImportanceTipsByExe.delete(i),this.promptMediumImportanceExeBasedTip();break;case c.RecommendationsNotificationResult.IncompatibleWindow:{const l=y.Event.once(y.Event.latch(y.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(l(()=>this.promptMediumImportanceExeBasedTip()));break}case c.RecommendationsNotificationResult.TooMany:{const l=this._register(new a.MutableDisposable);l.value=(0,T.disposableTimeout)(()=>{l.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3);break}}})}async promptExeRecommendations(t){const r=await this.extensionManagementService.getInstalled(g.ExtensionType.User),s=t.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(n=>r.every(o=>!(0,p.areSameExtensions)(o.identifier,{id:n})))).map(({extensionId:i})=>i.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:s,source:c.RecommendationSource.EXE,name:t[0].exeFriendlyName,searchValue:`@exe:"${t[0].exeName}"`})}getLastPromptedMediumExeTime(){let t=this.storageService.getNumber(I,f.StorageScope.APPLICATION);return t||(t=Date.now(),this.updateLastPromptedMediumExeTime(t)),t}updateLastPromptedMediumExeTime(t){this.storageService.store(I,t,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(E,f.StorageScope.APPLICATION,"{}"))}addToRecommendedExecutables(t,r){const s=this.getPromptedExecutableTips();s[t]=r.map(({extensionId:i})=>i.toLowerCase()),this.storageService.store(E,JSON.stringify(s),f.StorageScope.APPLICATION,f.StorageTarget.USER)}groupByInstalled(t,r){const s=[],i=[],n=r.reduce((o,l)=>(o.add(l.identifier.id.toLowerCase()),o),new Set);return t.forEach(o=>{n.has(o.toLowerCase())?s.push(o):i.push(o)}),{installed:s,uninstalled:i}}async getValidExecutableBasedExtensionTips(t){const r=[],s=new Map;for(const i of t.keys()){const n=t.get(i);if(!n||!(0,D.isNonEmptyArray)(n.recommendations))continue;const o=[];S.isWindows?n.windowsPath&&o.push(n.windowsPath.replace("%USERPROFILE%",()=>u.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>u.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>u.env.ProgramFiles).replace("%APPDATA%",()=>u.env.APPDATA).replace("%WINDIR%",()=>u.env.WINDIR)):(o.push((0,P.join)("/usr/local/bin",i)),o.push((0,P.join)("/usr/bin",i)),o.push((0,P.join)(this.userHome.fsPath,i)));for(const l of o){let m=s.get(l);if(m===void 0&&(m=await this.fileService.exists(L.URI.file(l)),s.set(l,m)),m)for(const{extensionId:w,extensionName:C,isExtensionPack:b,whenNotInstalled:R}of n.recommendations)r.push({extensionId:w,extensionName:C,isExtensionPack:b,exeName:i,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:R})}}return r}}e.AbstractNativeExtensionTipsService=d}),define(le[257],ue([0,1,28,7,24,16,75,58,17,18,256]),function(ne,e,D,a,A,L,k,_,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let S=class extends P.AbstractNativeExtensionTipsService{constructor(p,c,g,f,h,E,I,d){super(p.userHome,h,c,g,f,E,I,d)}};e.ExtensionTipsService=S,e.ExtensionTipsService=S=we([Q(0,L.INativeEnvironmentService),Q(1,y.ITelemetryService),Q(2,D.IExtensionManagementService),Q(3,T.IStorageService),Q(4,_.INativeHostService),Q(5,k.IExtensionRecommendationNotificationService),Q(6,a.IFileService),Q(7,A.IProductService)],S)}),define(le[50],ue([0,1,15,32,17]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=L;async function L(k,_,T){let y=T&&T.get("storage.serviceMachineId",A.StorageScope.APPLICATION)||null;if(y)return y;try{const S=(await _.readFile(k.serviceMachineIdResource)).value.toString();y=(0,a.isUUID)(S)?S:null}catch{y=null}if(!y){y=(0,a.generateUuid)();try{await _.writeFile(k.serviceMachineIdResource,D.VSBuffer.fromString(y))}catch{}}return T?.store("storage.serviceMachineId",y,A.StorageScope.APPLICATION,A.StorageTarget.MACHINE),y}}),define(le[258],ue([0,1,50,18,49]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=L;async function L(k,_,T,y,P,S,u){const p={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${_.nameShort})`};if((0,A.supportsTelemetry)(_,T)&&(0,A.getTelemetryLevel)(y)===a.TelemetryLevel.USAGE){const c=await(0,D.getServiceMachineId)(T,P,S);p["X-Market-User-Id"]=c,p["VSCode-SessionId"]=u.machineId||c}return p}}),define(le[259],ue([0,1,19,26,8,5,36,13,9,22,16,28,33,37,73,7,10,24,60,258,17,18,65]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0,e.sortExtensionVersions=ce;const r=L.isWeb?p.TargetPlatform.WEB:(0,S.getTargetPlatform)(L.platform,k.arch),s="X-Market-Search-Activity-Id";var i;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished",$[$.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...$){return String($.reduce((x,q)=>x|q,0))}var o;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},C={pageNumber:1,pageSize:10,sortBy:S.SortBy.NoneOrRelevance,sortOrder:S.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class b{constructor(x=C){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(x,q=this.state.pageSize){return new b({...this.state,pageNumber:x,pageSize:q})}withFilter(x,...q){const te=[...this.state.criteria,...q.length?q.map(Z=>({filterType:x,value:Z})):[{filterType:x}]];return new b({...this.state,criteria:te})}withSortBy(x){return new b({...this.state,sortBy:x})}withSortOrder(x){return new b({...this.state,sortOrder:x})}withFlags(...x){return new b({...this.state,flags:x.reduce((q,te)=>q|te,0)})}withAssetTypes(...x){return new b({...this.state,assetTypes:x})}withSource(x){return new b({...this.state,source:x})}get raw(){const{criteria:x,pageNumber:q,pageSize:te,sortBy:Z,sortOrder:Y,flags:ae,assetTypes:he}=this.state;return{filters:[{criteria:x,pageNumber:q,pageSize:te,sortBy:Z,sortOrder:Y}],assetTypes:he,flags:ae}}get searchText(){const x=this.state.criteria.filter(q=>q.filterType===o.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function R($,x){const q=($||[]).filter(te=>te.statisticName===x)[0];return q?q.value:0}function U($){const x="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(te=>te.assetType.indexOf(x)===0).reduce((te,Z)=>{const Y=F($,Z.assetType);return Y&&te.push([Z.assetType.substring(x.length),Y]),te},[])}function N($){if($.properties){const x=$.properties.filter(Z=>Z.key===l.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=x.filter(Z=>q.test(Z.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return F($,l.Repository)}function M($){return{uri:`${$.fallbackAssetUri}/${l.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${l.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function F($,x){return $.files.filter(te=>te.assetType===x)[0]?{uri:`${$.assetUri}/${x}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${x}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}:null}function K($,x){const q=$.properties?$.properties.filter(Z=>Z.key===x):[],te=q.length>0&&q[0].value;return te?te.split(",").map(Z=>(0,u.adoptToGalleryExtensionId)(Z)):[]}function H($){const x=$.properties?$.properties.filter(q=>q.key===m.Engine):[];return x.length>0&&x[0].value||""}function X($){const x=$.properties?$.properties.filter(q=>q.key===m.PreRelease):[];return x.length>0&&x[0].value==="true"}function j($){const x=$.properties?$.properties.filter(te=>te.key===m.LocalizedLanguages):[],q=x.length>0&&x[0].value||"";return q?q.split(","):[]}function ie($){return $.properties?.find(x=>x.key===m.SponsorLink)?.value}function z($){return $.properties?.find(x=>x.key===m.SupportLink)?.value}function B($){return $.indexOf("preview")!==-1}function ee($){return $.targetPlatform?(0,S.toTargetPlatform)($.targetPlatform):p.TargetPlatform.UNDEFINED}function se($){const x=(0,D.distinct)($.versions.map(ee)),q=!!$.tags?.includes(S.WEB_EXTENSION_TAG),te=x.indexOf(p.TargetPlatform.WEB);return q?te===-1&&x.push(p.TargetPlatform.WEB):te!==-1&&x.splice(te,1),x}function ce($,x){for(let q=0;q<$.length;q++){const te=$[q];if(te.version===$[q-1]?.version){let Z=q;if(ee(te)===x)for(;Z>0&&$[Z-1].version===te.version;)Z--;Z!==q&&($.splice(q,1),$.splice(Z,0,te))}}return $}function W($,x,q){$.telemetryData={index:x,querySource:q,queryActivityId:$.queryContext?.[s]}}function J($,x,q,te){const Z=$.versions[0],Y={manifest:F(x,l.Manifest),readme:F(x,l.Details),changelog:F(x,l.Changelog),license:F(x,l.License),repository:N(x),download:M(x),icon:F(x,l.Icon),signature:F(x,l.Signature),coreTranslations:U(x)};return{type:"gallery",identifier:{id:(0,u.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:x.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,publisherSponsorLink:ie(Z),description:$.shortDescription??"",installCount:R($.statistics,"install"),rating:R($.statistics,"averagerating"),ratingCount:R($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:q,assets:Y,properties:{dependencies:K(x,m.Dependency),extensionPack:K(x,m.ExtensionPack),engine:H(x),localizedLanguages:j(x),targetPlatform:ee(x),isPreReleaseVersion:X(x)},hasPreReleaseVersion:X(Z),hasReleaseVersion:!0,preview:B($.flags),isSigned:!!Y.signature,queryContext:te,supportLink:z(Z)}}let G=class{constructor(x,q,te,Z,Y,ae,he,ge){this.requestService=q,this.logService=te,this.environmentService=Z,this.telemetryService=Y,this.fileService=ae,this.productService=he,this.configurationService=ge;const ve=he.extensionsGallery,Ie=ve?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=Ie?ve.servicePPEUrl:ve?.serviceUrl,this.extensionsGallerySearchUrl=Ie?void 0:ve?.searchUrl,this.extensionsControlUrl=ve?.controlUrl,this.commonHeadersPromise=(0,I.resolveMarketplaceHeaders)(he.version,he,this.environmentService,this.configurationService,this.fileService,x,this.telemetryService)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,q,te){const Z=a.CancellationToken.isCancellationToken(q)?{}:q,Y=a.CancellationToken.isCancellationToken(q)?q:te,ae=[],he=[],ge=[],ve=[];let Ie=!0;for(const Pe of x){Pe.uuid?he.push(Pe.uuid):ae.push(Pe.id);const Re=!!(Pe.version||Pe.preRelease);ge.push({id:Pe.id,uuid:Pe.uuid,includePreRelease:Re}),Pe.version&&ve.push({id:Pe.id,uuid:Pe.uuid,version:Pe.version}),Ie=Ie&&!!Pe.hasPreRelease&&!Re}if(!he.length&&!ae.length)return[];let pe=new b().withPage(1,x.length);he.length&&(pe=pe.withFilter(o.ExtensionId,...he)),ae.length&&(pe=pe.withFilter(o.ExtensionName,...ae)),(Z.queryAllVersions||Ie)&&(pe=pe.withFlags(pe.flags,i.IncludeVersions)),Z.source&&(pe=pe.withSource(Z.source));const{extensions:ye}=await this.queryGalleryExtensions(pe,{targetPlatform:Z.targetPlatform??r,includePreRelease:ge,versions:ve,compatible:!!Z.compatible,productVersion:Z.productVersion??{version:this.productService.version,date:this.productService.date}},Y);return Z.source&&ye.forEach((Pe,Re)=>W(Pe,Re,Z.source)),ye}async getCompatibleExtension(x,q,te,Z={version:this.productService.version,date:this.productService.date}){if((0,S.isNotWebExtensionInWebTargetPlatform)(x.allTargetPlatforms,te))return null;if(await this.isExtensionCompatible(x,q,te))return x;const Y=new b().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,x.identifier.uuid),{extensions:ae}=await this.queryGalleryExtensions(Y,{targetPlatform:te,compatible:!0,includePreRelease:q,productVersion:Z},a.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(x,q,te,Z={version:this.productService.version,date:this.productService.date}){if(!(0,S.isTargetPlatformCompatible)(x.properties.targetPlatform,x.allTargetPlatforms,te)||!q&&x.properties.isPreReleaseVersion)return!1;let Y=x.properties.engine;if(!Y){const ae=await this.getManifest(x,a.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");Y=ae.engines.vscode}return(0,c.isEngineValid)(Y,Z.version,Z.date)}async isValidVersion(x,q,te,Z,Y,ae,he={version:this.productService.version,date:this.productService.date}){if(!(0,S.isTargetPlatformCompatible)(ee(q),Y,ae)||te!=="any"&&X(q)!==(te==="prerelease"))return!1;if(Z)try{const ge=await this.getEngine(x,q);if(!(0,c.isEngineValid)(ge,he.version,he.date))return!1}catch(ge){return this.logService.error(`Error while getting the engine for the version ${q.version}.`,(0,A.getErrorMessage)(ge)),!1}return!0}async query(x,q){let te=x.text||"";const Z=x.pageSize??50;let Y=new b().withPage(1,Z);te?(te=te.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ie,pe,ye)=>(Y=Y.withFilter(o.Category,ye||pe),"")),te=te.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ie,pe,ye)=>(Y=Y.withFilter(o.Tag,ye||pe),"")),te=te.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(o.Featured),"")),te=te.trim(),te&&(te=te.length<200?te:te.substring(0,200),Y=Y.withFilter(o.SearchText,te)),Y=Y.withSortBy(S.SortBy.NoneOrRelevance)):x.ids?Y=Y.withFilter(o.ExtensionId,...x.ids):x.names?Y=Y.withFilter(o.ExtensionName,...x.names):Y=Y.withSortBy(S.SortBy.InstallCount),typeof x.sortBy=="number"&&(Y=Y.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(Y=Y.withSortOrder(x.sortOrder)),x.source&&(Y=Y.withSource(x.source));const ae=async(Ie,pe)=>{const{extensions:ye,total:Pe}=await this.queryGalleryExtensions(Ie,{targetPlatform:r,compatible:!1,includePreRelease:!!x.includePreRelease,productVersion:x.productVersion??{version:this.productService.version,date:this.productService.date}},pe);return ye.forEach((Re,oe)=>W(Re,(Ie.pageNumber-1)*Ie.pageSize+oe,x.source)),{extensions:ye,total:Pe}},{extensions:he,total:ge}=await ae(Y,q),ve=async(Ie,pe)=>{if(pe.isCancellationRequested)throw new A.CancellationError;const{extensions:ye}=await ae(Y.withPage(Ie+1),pe);return ye};return{firstPage:he,total:ge,pageSize:Y.pageSize,getPage:ve}}async queryGalleryExtensions(x,q,te){const Z=x.flags;x.flags&i.IncludeLatestVersionOnly&&x.flags&i.IncludeVersions&&(x=x.withFlags(x.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(x.flags&i.IncludeLatestVersionOnly)&&!(x.flags&i.IncludeVersions)&&(x=x.withFlags(x.flags,i.IncludeLatestVersionOnly)),q.versions?.length&&(x=x.withFlags(x.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),x=x.withFlags(x.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:Y,total:ae,context:he}=await this.queryRawGalleryExtensions(x,te);if(!(x.flags&i.IncludeLatestVersionOnly)){const pe=[];for(const ye of Y){const Pe=await this.toGalleryExtensionWithCriteria(ye,q,he);Pe&&pe.push(Pe)}return{extensions:pe,total:ae}}const ve=[],Ie=new Map;for(let pe=0;pe<Y.length;pe++){const ye=Y[pe],Pe={id:(0,u.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},Re=(0,_.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(fe=>(0,u.areSameExtensions)(fe,Pe))?.includePreRelease;if(q.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(se(ye),q.targetPlatform))continue;const oe=await this.toGalleryExtensionWithCriteria(ye,q,he);!oe||oe.properties.isPreReleaseVersion&&(!Re||!oe.hasReleaseVersion)||!oe.properties.isPreReleaseVersion&&oe.properties.targetPlatform!==q.targetPlatform&&oe.hasPreReleaseVersion?Ie.set(ye.extensionId,pe):ve.push([pe,oe])}if(Ie.size){const pe=new t.StopWatch,ye=new b().withFlags(Z&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Ie.size).withFilter(o.ExtensionId,...Ie.keys()),{extensions:Pe}=await this.queryGalleryExtensions(ye,q,te);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:Ie.size});for(const Re of Pe){const oe=Ie.get(Re.identifier.uuid);ve.push([oe,Re])}}return{extensions:ve.sort((pe,ye)=>pe[0]-ye[0]).map(([,pe])=>pe),total:ae}}async toGalleryExtensionWithCriteria(x,q,te){const Z={id:(0,u.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},Y=q.versions?.find(ve=>(0,u.areSameExtensions)(ve,Z))?.version,ae=(0,_.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ve=>(0,u.areSameExtensions)(ve,Z))?.includePreRelease,he=se(x),ge=ce(x.versions,q.targetPlatform);if(q.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(he,q.targetPlatform))return null;for(let ve=0;ve<ge.length;ve++){const Ie=ge[ve];if(!(Y&&Ie.version!==Y)){if(await this.isValidVersion((0,u.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),Ie,ae?"any":"release",q.compatible,he,q.targetPlatform,q.productVersion))return J(x,Ie,he,te);if(Y&&Ie.version===Y)return null}}return Y||q.compatible?null:J(x,x.versions[0],he)}async queryRawGalleryExtensions(x,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,n(i.Unpublished));const te=await this.commonHeadersPromise,Z=JSON.stringify(x.raw),Y={...te,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},ae=new t.StopWatch;let he,ge,ve=0;try{if(he=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&x.criteria.some(pe=>pe.filterType===o.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:Z,headers:Y},q),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:ve};const Ie=await(0,E.asJson)(he);if(Ie){const pe=Ie.results[0],ye=pe.extensions,Pe=pe.resultMetadata&&pe.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return ve=Pe&&Pe.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ve,context:{[s]:he.res.headers.activityid}}}return{galleryExtensions:[],total:ve}}catch(Ie){if((0,A.isCancellationError)(Ie))throw ge=S.ExtensionGalleryErrorCode.Cancelled,Ie;{const pe=(0,A.getErrorMessage)(Ie);throw ge=pe.startsWith("XHR timeout")?S.ExtensionGalleryErrorCode.Timeout:S.ExtensionGalleryErrorCode.Failed,new S.ExtensionGalleryError(pe,ge)}}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(Z.length),duration:ae.elapsed(),success:!!he&&(0,E.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:ge,count:String(ve)})}}async reportStatistic(x,q,te,Z){if(!this.isEnabled())return;const Y=L.isWeb?this.api(`/itemName/${x}.${q}/version/${te}/statType/${Z===S.StatisticType.Install?"1":"3"}/vscodewebextension`):this.api(`/publishers/${x}/extensions/${q}/${te}/stats?statType=${Z}`),ae=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:Y,headers:ge},a.CancellationToken.None)}catch{}}async download(x,q,te){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const Z=(0,u.getGalleryExtensionTelemetryData)(x),Y=new Date().getTime(),ae=te===S.InstallOperation.Install?"install":te===S.InstallOperation.Update?"update":"",he=ae?{uri:`${x.assets.download.uri}${T.URI.parse(x.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${x.assets.download.fallbackUri}${T.URI.parse(x.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:x.assets.download,ge=x.queryContext?.[s]?{[s]:x.queryContext[s]}:void 0,ve=await this.getAsset(x.identifier.id,he,l.VSIX,ge?{headers:ge}:void 0);try{await this.fileService.writeFile(q,ve.stream)}catch(Ie){try{await this.fileService.del(q)}catch(pe){this.logService.warn(`Error while deleting the file ${q.toString()}`,(0,A.getErrorMessage)(pe))}throw new S.ExtensionGalleryError((0,A.getErrorMessage)(Ie),S.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:new Date().getTime()-Y})}async downloadSignatureArchive(x,q){if(!x.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",x.identifier.id);const te=await this.getAsset(x.identifier.id,x.assets.signature,l.Signature);try{await this.fileService.writeFile(q,te.stream)}catch(Z){try{await this.fileService.del(q)}catch(Y){this.logService.warn(`Error while deleting the file ${q.toString()}`,(0,A.getErrorMessage)(Y))}throw new S.ExtensionGalleryError((0,A.getErrorMessage)(Z),S.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(x,q){if(x.assets.readme){const te=await this.getAsset(x.identifier.id,x.assets.readme,l.Details,{},q);return await(0,E.asTextOrError)(te)||""}return""}async getManifest(x,q){if(x.assets.manifest){const te=await this.getAsset(x.identifier.id,x.assets.manifest,l.Manifest,{},q),Z=await(0,E.asTextOrError)(te);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(x,q,te){const Z=F(q,l.Manifest);if(!Z)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},ae=await this.getAsset(x,Z,l.Manifest,{headers:Y});return await(0,E.asJson)(ae)}async getCoreTranslation(x,q){const te=x.assets.coreTranslations.filter(Z=>Z[0]===q.toUpperCase())[0];if(te){const Z=await this.getAsset(x.identifier.id,te[1],te[0]),Y=await(0,E.asTextOrError)(Z);return Y?JSON.parse(Y):null}return null}async getChangelog(x,q){if(x.assets.changelog){const te=await this.getAsset(x.identifier.id,x.assets.changelog,l.Changelog,{},q);return await(0,E.asTextOrError)(te)||""}return""}async getAllCompatibleVersions(x,q,te){let Z=new b().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);x.identifier.uuid?Z=Z.withFilter(o.ExtensionId,x.identifier.uuid):Z=Z.withFilter(o.ExtensionName,x.identifier.id);const{galleryExtensions:Y}=await this.queryRawGalleryExtensions(Z,a.CancellationToken.None);if(!Y.length)return[];const ae=se(Y[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(ae,te))return[];const he=[];await Promise.all(Y[0].versions.map(async Ie=>{try{await this.isValidVersion(x.identifier.id,Ie,q?"any":"release",!0,ae,te)&&he.push(Ie)}catch{}}));const ge=[],ve=new Set;for(const Ie of ce(he,te))ve.has(Ie.version)||(ve.add(Ie.version),ge.push({version:Ie.version,date:Ie.lastUpdated,isPreReleaseVersion:X(Ie)}));return ge}async getAsset(x,q,te,Z={},Y=a.CancellationToken.None){const ae=await this.commonHeadersPromise,he={type:"GET"},ge={...ae,...Z.headers||{}};Z={...Z,...he,headers:ge};const ve=q.uri,Ie=q.fallbackUri,pe={...Z,url:ve};try{const ye=await this.requestService.request(pe,Y);if(ye.res.statusCode===200)return ye;const Pe=await(0,E.asTextOrError)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${Pe}`)}catch(ye){if((0,A.isCancellationError)(ye))throw ye;const Pe=(0,A.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:x,assetType:te,message:Pe});const Re={...Z,url:Ie};return this.requestService.request(Re,Y)}}async getEngine(x,q){let te=H(q);if(!te){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:x,version:q.version});const Z=await this.getManifestFromRawExtensionVersion(x,q,a.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");te=Z.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},a.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,E.asJson)(x),te=[],Z={},Y=[];if(q){for(const ae of q.malicious)te.push({id:ae});if(q.migrateToPreRelease)for(const[ae,he]of Object.entries(q.migrateToPreRelease))(!he.engine||(0,c.isEngineValid)(he.engine,this.productService.version,this.productService.date))&&(Z[ae.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[ae,he]of Object.entries(q.deprecated))he&&(Z[ae.toLowerCase()]=(0,_.isBoolean)(he)?{}:he);if(q.search)for(const ae of q.search)Y.push(ae)}return{malicious:te,deprecated:Z,search:Y}}};G=we([Q(1,E.IRequestService),Q(2,f.ILogService),Q(3,P.IEnvironmentService),Q(4,v.ITelemetryService),Q(5,g.IFileService),Q(6,h.IProductService),Q(7,y.IConfigurationService)],G);let V=class extends G{constructor(x,q,te,Z,Y,ae,he,ge){super(x,q,te,Z,Y,ae,he,ge)}};e.ExtensionGalleryService=V,e.ExtensionGalleryService=V=we([Q(0,d.IStorageService),Q(1,E.IRequestService),Q(2,f.ILogService),Q(3,P.IEnvironmentService),Q(4,v.ITelemetryService),Q(5,g.IFileService),Q(6,h.IProductService),Q(7,y.IConfigurationService)],V);let O=class extends G{constructor(x,q,te,Z,Y,ae,he){super(void 0,x,q,te,Z,Y,ae,he)}};e.ExtensionGalleryServiceWithNoStorageService=O,e.ExtensionGalleryServiceWithNoStorageService=O=we([Q(0,E.IRequestService),Q(1,f.ILogService),Q(2,P.IEnvironmentService),Q(3,v.ITelemetryService),Q(4,g.IFileService),Q(5,h.IProductService),Q(6,y.IConfigurationService)],O)}),define(le[260],ue([0,1,108,3,18,16,2,10,14,69,24,5,6,102,22,176,38,17,13,138,21]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const v=[D.CONFIGURATION_KEY_HOST_NAME,D.CONFIGURATION_KEY_PREVENT_SLEEP],t="remoteTunnelSession",r="remoteTunnelIsService";let s=class extends k.Disposable{constructor(l,m,w,C,b,R,U){super(),this.telemetryService=l,this.productService=m,this.environmentService=w,this.configurationService=R,this.storageService=U,this._onDidTokenFailedEmitter=new a.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new a.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new a.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=D.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(N,M)=>{M?this._logger.error(N):this._logger.info(N)},this._logger=this._register(C.createLogger((0,d.joinPath)(w.logsHome,`${D.LOG_ID}.log`),{id:D.LOG_ID,name:D.LOGGER_NAME})),this._startTunnelProcessDelayer=new u.Delayer(100),this._register(this._logger.onDidChangeLogLevel(N=>this._logger.info("Log level changed to "+(0,_.LogLevelToString)(N)))),this._register(b.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(R.onDidChangeConfiguration(N=>{v.some(M=>N.affectsConfiguration(M))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=D.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(l){this._tunnelStatus=l,this._onDidChangeTunnelStatusEmitter.fire(l)}setMode(l){n(this._mode,l)||(this._mode=l,this._storeMode(l),this._onDidChangeModeEmitter.fire(this._mode),l.active?(this._logger.info(`Session updated: ${l.session.accountLabel} (${l.session.providerId}) (service=${l.asService})`),l.session.token&&this._logger.info(`Session token updated: ${l.session.accountLabel} (${l.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(l){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(l);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(m){this._logger.error(m)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let l;S.isMacintosh?l=this.environmentService.appRoot:l=(0,T.dirname)((0,T.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,T.join)(l,"bin",`${this.productService.tunnelApplicationName}${S.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(l){if(n(this._mode,l)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(l);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(m){this._logger.error(m)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this._mode.active){const l=this._mode.asService;this.setMode(D.INACTIVE_TUNNEL_MODE);try{l&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(m){this._logger.error(m)}}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(l){this._logger.error(l)}this.setTunnelStatus(D.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let l="",m=!1;const w=(M,F)=>{F?this._logger.error(M):l+=M,!this.environmentService.isBuilt&&M.startsWith("   Compiling")&&this.setTunnelStatus(D.TunnelStates.connecting((0,g.localize)(0,null)))},C=this.runCodeTunnelCommand("status",["status"],w);this._tunnelProcess=C;try{if(await C,this._tunnelProcess!==C)return;let M;try{M=JSON.parse(l.trim().split(`
`).find(F=>F.startsWith("{")))}catch{this._logger.error(`Could not parse status output: ${JSON.stringify(l.trim())}`),this.setTunnelStatus(D.TunnelStates.disconnected());return}if(m=M.service_installed,this._logger.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this._mode.active){this.setTunnelStatus(D.TunnelStates.disconnected());return}}catch(M){this._logger.error(M),this.setTunnelStatus(D.TunnelStates.disconnected());return}finally{this._tunnelProcess===C&&(this._tunnelProcess=void 0)}const b=this._mode.active?this._mode.session:void 0;if(b&&b.token){const M=b.token;this.setTunnelStatus(D.TunnelStates.connecting((0,g.localize)(1,null,b.accountLabel,b.providerId)));const F=(H,X)=>{H=H.replaceAll(M,"*".repeat(4)),w(H,X)},K=this.runCodeTunnelCommand("login",["user","login","--provider",b.providerId,"--log",(0,_.LogLevelToString)(this._logger.getLevel())],F,{VSCODE_CLI_ACCESS_TOKEN:M});this._tunnelProcess=K;try{if(await K,this._tunnelProcess!==K)return}catch(H){this._logger.error(H),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(b),this.setTunnelStatus(D.TunnelStates.disconnected(b));return}}const R=this._getTunnelName();R?this.setTunnelStatus(D.TunnelStates.connecting((0,g.localize)(2,null,R))):this.setTunnelStatus(D.TunnelStates.connecting((0,g.localize)(3,null)));const U=["--accept-server-license-terms","--log",(0,_.LogLevelToString)(this._logger.getLevel())];R?U.push("--name",R):U.push("--random-name");let N=!1;return this._mode.active&&this._mode.asService&&!m&&(N=await this.installTunnelService(U)===!1),this.serverOrAttachTunnel(b,U,N)}async installTunnelService(l){let m;try{m=await this.runCodeTunnelCommand("serviceInstall",["service","install",...l])}catch(w){this._logger.error(w),m=1}if(m!==0){const w=(0,g.localize)(4,null);return this._logger.warn(w),this.setTunnelStatus(D.TunnelStates.connecting(w)),!1}return!0}async serverOrAttachTunnel(l,m,w){m.push("--parent-process-id",String(process.pid)),this._preventSleep()&&m.push("--no-sleep");let C=!1;const b=this.runCodeTunnelCommand("tunnel",m,(R,U)=>{U?this._logger.error(R):this._logger.info(R),R.includes("Connected to an existing tunnel process")&&(C=!0);const N=R.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(N){const M={link:N[1],domain:N[2],tunnelName:N[4],isAttached:C};this.setTunnelStatus(D.TunnelStates.connected(M,w))}else R.match(/error refreshing token/)&&(b.cancel(),this._onDidTokenFailedEmitter.fire(l),this.setTunnelStatus(D.TunnelStates.disconnected(l)))});this._tunnelProcess=b,b.finally(()=>{b===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=D.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(D.TunnelStates.disconnected()))})}runCodeTunnelCommand(l,m,w=this.defaultOnOutput,C){return(0,u.createCancelablePromise)(b=>new Promise((R,U)=>{b.isCancellationRequested&&R(-1);let N;const M=["ignore","pipe","pipe"];if(b.onCancellationRequested(()=>{N&&(this._logger.info(`${l} terminating(${N.pid})`),N.kill())}),!this.environmentService.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${l} Spawning: cargo run -- tunnel ${m.join(" ")}
`,!1),N=(0,y.spawn)("cargo",["run","--","tunnel",...m],{cwd:(0,T.join)(this.environmentService.appRoot,"cli"),stdio:M,env:{...process.env,RUST_BACKTRACE:"1",...C}});else{w(`Running tunnel CLI
`,!1);const F=this.getTunnelCommandLocation();w(`${l} Spawning: ${F} tunnel ${m.join(" ")}
`,!1),N=(0,y.spawn)(F,["tunnel",...m],{cwd:(0,f.homedir)(),stdio:M,env:{...process.env,...C}})}N.stdout.pipe(new I.StreamSplitter(`
`)).on("data",F=>{if(N){const K=F.toString();w(K,!1)}}),N.stderr.pipe(new I.StreamSplitter(`
`)).on("data",F=>{if(N){const K=F.toString();w(K,!0)}}),N.on("exit",F=>{N&&(w(`${l} exit(${N.pid}): + ${F} `,!1),N=void 0,R(F||0))}),N.on("error",F=>{N&&(w(`${l} error(${N.pid}): + ${F} `,!0),N=void 0,U())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(D.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let l=this.configurationService.getValue(D.CONFIGURATION_KEY_HOST_NAME)||(0,f.hostname)();return l=l.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),l||void 0}_restoreMode(){try{const l=this.storageService.get(t,h.StorageScope.APPLICATION),m=this.storageService.getBoolean(r,h.StorageScope.APPLICATION,!1);if(l){const w=JSON.parse(l);if(w&&(0,E.isString)(w.accountLabel)&&(0,E.isString)(w.sessionId)&&(0,E.isString)(w.providerId))return{active:!0,session:w,asService:m};this._logger.error("Problems restoring session from storage, invalid format",w)}}catch(l){this._logger.error("Problems restoring session from storage",l)}return D.INACTIVE_TUNNEL_MODE}_storeMode(l){if(l.active){const m={providerId:l.session.providerId,sessionId:l.session.sessionId,accountLabel:l.session.accountLabel};this.storageService.store(t,JSON.stringify(m),h.StorageScope.APPLICATION,h.StorageTarget.MACHINE),this.storageService.store(r,l.asService,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}else this.storageService.remove(t,h.StorageScope.APPLICATION),this.storageService.remove(r,h.StorageScope.APPLICATION)}};e.RemoteTunnelService=s,e.RemoteTunnelService=s=we([Q(0,A.ITelemetryService),Q(1,P.IProductService),Q(2,L.INativeEnvironmentService),Q(3,_.ILoggerService),Q(4,p.ISharedProcessLifecycleService),Q(5,c.IConfigurationService),Q(6,h.IStorageService)],s);function i(o,l){return o&&l?o.sessionId===l.sessionId&&o.providerId===l.providerId&&o.token===l.token:o===l}const n=(o,l)=>o.active!==l.active?!1:o.active&&l.active?o.asService===l.asService&&i(o.session,l.session):!0}),define(le[261],ue([0,1,6,2,23,21,71,17,80,20]),function(ne,e,D,a,A,L,k,_,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class P extends _.AbstractStorageService{constructor(u,p,c,g){super(),this.initialWorkspace=u,this.initialProfiles=p,this.remoteService=c,this.environmentService=g,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new a.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new a.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const u=this._register(new T.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),p=this._register(new k.Storage(u));return this._register(p.onDidChangeStorage(c=>this.emitDidChangeValue(_.StorageScope.APPLICATION,c))),p}createProfileStorage(u){this.profileStorageDisposables.clear(),this.profileStorageProfile=u;let p;if((0,_.isProfileUsingDefaultStorage)(u))p=this.applicationStorage;else{const c=this.profileStorageDisposables.add(new T.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),u));p=this.profileStorageDisposables.add(new k.Storage(c))}return this.profileStorageDisposables.add(p.onDidChangeStorage(c=>this.emitDidChangeValue(_.StorageScope.PROFILE,c))),p}createWorkspaceStorage(u){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=u?.id;let p;if(u){const c=this.workspaceStorageDisposables.add(new T.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),u));p=this.workspaceStorageDisposables.add(new k.Storage(c)),this.workspaceStorageDisposables.add(p.onDidChangeStorage(g=>this.emitDidChangeValue(_.StorageScope.WORKSPACE,g)))}return p}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(u){switch(u){case _.StorageScope.APPLICATION:return this.applicationStorage;case _.StorageScope.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(u){switch(u){case _.StorageScope.APPLICATION:return this.applicationStorageProfile.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case _.StorageScope.PROFILE:return this.profileStorageProfile?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(_.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(u){if(!this.canSwitchProfile(this.profileStorageProfile,u))return;const p=this.profileStorage,c=p.items;p!==this.applicationStorage&&await p.close(),this.profileStorage=this.createProfileStorage(u),await this.profileStorage.init(),this.switchData(c,this.profileStorage,_.StorageScope.PROFILE)}async switchToWorkspace(u,p){const c=this.workspaceStorage,g=c?.items??new Map;await c?.close(),this.workspaceStorage=this.createWorkspaceStorage(u),await this.workspaceStorage.init(),this.switchData(g,this.workspaceStorage,_.StorageScope.WORKSPACE)}hasScope(u){return(0,y.isUserDataProfile)(u)?this.profileStorageProfile.id===u.id:this.workspaceStorageId===u.id}}e.RemoteStorageService=P}),define(le[262],ue([0,1,3,2,20,95]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class k{constructor(y,P){this.service=y,this.getUriTransformer=P}listen(y,P){const S=this.getUriTransformer(y);switch(P){case"onDidChangeProfiles":return D.Event.map(this.service.onDidChangeProfiles,u=>({all:u.all.map(p=>(0,L.transformOutgoingURIs)({...p},S)),added:u.added.map(p=>(0,L.transformOutgoingURIs)({...p},S)),removed:u.removed.map(p=>(0,L.transformOutgoingURIs)({...p},S)),updated:u.updated.map(p=>(0,L.transformOutgoingURIs)({...p},S))}))}throw new Error(`Invalid listen ${P}`)}async call(y,P,S){const u=this.getUriTransformer(y);switch(P){case"createProfile":{const p=await this.service.createProfile(S[0],S[1],S[2]);return(0,L.transformOutgoingURIs)({...p},u)}case"updateProfile":{let p=(0,A.reviveProfile)((0,L.transformIncomingURIs)(S[0],u),this.service.profilesHome.scheme);return p=await this.service.updateProfile(p,S[1]),(0,L.transformOutgoingURIs)({...p},u)}case"removeProfile":{const p=(0,A.reviveProfile)((0,L.transformIncomingURIs)(S[0],u),this.service.profilesHome.scheme);return this.service.removeProfile(p)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=k;class _ extends a.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(y,P,S){super(),this.profilesHome=P,this.channel=S,this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=y.map(u=>(0,A.reviveProfile)(u,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(u=>{const p=u.added.map(f=>(0,A.reviveProfile)(f,this.profilesHome.scheme)),c=u.removed.map(f=>(0,A.reviveProfile)(f,this.profilesHome.scheme)),g=u.updated.map(f=>(0,A.reviveProfile)(f,this.profilesHome.scheme));this._profiles=u.all.map(f=>(0,A.reviveProfile)(f,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:p,removed:c,updated:g,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(y){this.enabled=y}isEnabled(){return this.enabled}async createNamedProfile(y,P,S){const u=await this.channel.call("createNamedProfile",[y,P,S]);return(0,A.reviveProfile)(u,this.profilesHome.scheme)}async createProfile(y,P,S,u){const p=await this.channel.call("createProfile",[y,P,S,u]);return(0,A.reviveProfile)(p,this.profilesHome.scheme)}async createTransientProfile(y){const P=await this.channel.call("createTransientProfile",[y]);return(0,A.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(y,P){await this.channel.call("setProfileForWorkspace",[y,P])}removeProfile(y){return this.channel.call("removeProfile",[y])}async updateProfile(y,P){const S=await this.channel.call("updateProfile",[y,P]);return(0,A.reviveProfile)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=_}),define(le[61],ue([0,1,2,71,4,17,3,80,20]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,A.createDecorator)("IUserDataProfileStorageService");let y=class extends D.Disposable{constructor(p){super(),this.storageService=p}async readStorageData(p){return this.withProfileScopedStorageService(p,async c=>this.getItems(c))}async updateStorageData(p,c,g){return this.withProfileScopedStorageService(p,async f=>this.writeItems(f,c,g))}async withProfileScopedStorageService(p,c){if(this.storageService.hasScope(p))return c(this.storageService);const g=await this.createStorageDatabase(p),f=new S(g);try{await f.initialize();const h=await c(f);return await f.flush(),h}finally{f.dispose(),await this.closeAndDispose(g)}}getItems(p){const c=new Map,g=f=>{for(const h of p.keys(L.StorageScope.PROFILE,f))c.set(h,{value:p.get(h,L.StorageScope.PROFILE),target:f})};return g(L.StorageTarget.USER),g(L.StorageTarget.MACHINE),c}writeItems(p,c,g){p.storeAll(Array.from(c.entries()).map(([f,h])=>({key:f,value:h,scope:L.StorageScope.PROFILE,target:g})),!0)}async closeAndDispose(p){try{await p.close()}finally{(0,D.isDisposable)(p)&&p.dispose()}}};e.AbstractUserDataProfileStorageService=y,e.AbstractUserDataProfileStorageService=y=we([Q(0,L.IStorageService)],y);class P extends y{constructor(p,c,g,f){super(g),this.remoteService=p;const h=p.getChannel("profileStorageListener"),E=this._register(new D.MutableDisposable);this._onDidChange=this._register(new k.Emitter({onWillAddFirstListener:()=>{E.value=h.listen("onDidChange")(I=>{f.trace("profile storage changes",I),this._onDidChange.fire({targetChanges:I.targetChanges.map(d=>(0,T.reviveProfile)(d,c.profilesHome.scheme)),valueChanges:I.valueChanges.map(d=>({...d,profile:(0,T.reviveProfile)(d.profile,c.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>E.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(p){const c=this.remoteService.getChannel("storage");return(0,L.isProfileUsingDefaultStorage)(p)?new _.ApplicationStorageDatabaseClient(c):new _.ProfileStorageDatabaseClient(c,p)}}e.RemoteUserDataProfileStorageService=P;class S extends L.AbstractStorageService{constructor(p){super({flushInterval:100}),this.profileStorage=this._register(new a.Storage(p))}doInitialize(){return this.profileStorage.init()}getStorage(p){return p===L.StorageScope.PROFILE?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(le[263],ue([0,1,17,10,20,57,61]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let _=class extends k.RemoteUserDataProfileStorageService{constructor(y,P,S,u){super(y,P,S,u)}};e.NativeUserDataProfileStorageService=_,e.NativeUserDataProfileStorageService=_=we([Q(0,L.IMainProcessService),Q(1,A.IUserDataProfilesService),Q(2,D.IStorageService),Q(3,a.ILogService)],_)}),define(le[41],ue([0,1,19,6,15,26,3,34,2,27,13,181,22,16,7,10,50,17,18,29,25,20]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=void 0,e.isRemoteUserData=t,e.isSyncData=r,e.getSyncResourceLogLabel=s;function t(m){return!!(m&&m.ref!==void 0&&typeof m.ref=="string"&&m.ref!==""&&m.syncData!==void 0&&(m.syncData===null||r(m.syncData)))}function r(m){return!!(m&&m.version!==void 0&&typeof m.version=="number"&&m.content!==void 0&&typeof m.content=="string"&&(Object.keys(m).length===2||Object.keys(m).length===3&&m.machineId!==void 0&&typeof m.machineId=="string"))}function s(m,w){return`${(0,y.uppercaseFirstLetter)(m)}${w.isDefault?"":` (${w.name})`}`}let i=class extends T.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(w,C,b,R,U,N,M,F,K,H,X,j){super(),this.syncResource=w,this.collection=C,this.fileService=b,this.environmentService=R,this.storageService=U,this.userDataSyncStoreService=N,this.userDataSyncLocalStoreService=M,this.userDataSyncEnablementService=F,this.telemetryService=K,this.logService=H,this.configurationService=X,this.syncPreviewPromise=null,this._status=d.SyncStatus.Idle,this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=this._register(new a.ThrottledDelayer(50)),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=s(w.syncResource,w.profile),this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath(R.userDataSyncHome,...(0,d.getPathSegments)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,d.PREVIEW_DIR_NAME),this.lastSyncResource=(0,d.getLastSyncResourceUri)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,R,this.extUri),this.currentMachineIdPromise=(0,f.getServiceMachineId)(R,b,U)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status===d.SyncStatus.HasConflicts){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const w=await this.syncPreviewPromise;this.syncPreviewPromise=null;const C=await this.performSync(w.remoteUserData,w.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(C)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.hasRemoteChanged(w):!0)&&this._onDidChangeLocal.fire()}}setStatus(w){this._status!==w&&(this._status=w,this._onDidChangStatus.fire(w))}async sync(w,C={}){await this._sync(w,!0,this.getUserDataSyncConfiguration(),C)}async preview(w,C,b={}){return this._sync(w,!1,C,b)}async apply(w,C={}){try{this.syncHeaders={...C};const b=await this.doApply(w);return this.setStatus(b),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(w,C,b,R){try{if(this.syncHeaders={...R},this.status===d.SyncStatus.HasConflicts)return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status===d.SyncStatus.Syncing)return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus(d.SyncStatus.Syncing);let U=d.SyncStatus.Idle;try{const N=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(w,N);return U=await this.performSync(M,N,C,b),U===d.SyncStatus.HasConflicts?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):U===d.SyncStatus.Idle&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(U)}}finally{this.syncHeaders={}}}async replace(w){const C=this.parseSyncData(w);if(!C)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus(d.SyncStatus.Syncing);const b=await this.getLastSyncUserData(),R=await this.getLatestRemoteUserData(null,b),U=await this.isRemoteDataFromCurrentMachine(R),N=await this.generateSyncPreview({ref:R.ref,syncData:C},b,U,this.getUserDataSyncConfiguration(),L.CancellationToken.None),M=[];for(const F of N){const K=await this.getAcceptResult(F,F.remoteResource,void 0,L.CancellationToken.None),{remoteChange:H}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,L.CancellationToken.None);M.push([F,{...K,remoteChange:H!==d.Change.None?H:d.Change.Modified}])}await this.applyResult(R,b,M,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus(d.SyncStatus.Idle)}return!0}async isRemoteDataFromCurrentMachine(w){const C=await this.currentMachineIdPromise;return!!w.syncData?.machineId&&w.syncData.machineId===C}async getLatestRemoteUserData(w,C){if(C){const b=w?w[this.resource]:void 0;if(C.ref===b||b===void 0&&C.syncData===null)return C}return this.getRemoteUserData(C)}async performSync(w,C,b,R){if(w.syncData&&w.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new d.UserDataSyncError((0,S.localize)(0,null,this.resource,this.version,w.syncData.version),d.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(w,C,b,R)}catch(U){if(U instanceof d.UserDataSyncError)switch(U.code){case d.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(w,C,b,R);case d.UserDataSyncErrorCode.Conflict:case d.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),C=await this.getLastSyncUserData(),this.performSync(w,C,b,R)}throw U}}async doSync(w,C,b,R){try{const U=await this.isRemoteDataFromCurrentMachine(w),N=!U&&C===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,M=b&&!N;this.syncPreviewPromise||(this.syncPreviewPromise=(0,a.createCancelablePromise)(K=>this.doGenerateSyncResourcePreview(w,C,U,M,R,K)));let F=await this.syncPreviewPromise;if(b&&N){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const K of F.resourcePreviews)F=await this.accept(K.remoteResource)||F}return this.updateConflicts(F.resourcePreviews),F.resourcePreviews.some(({mergeState:K})=>K===d.MergeState.Conflict)?d.SyncStatus.HasConflicts:b?await this.doApply(!1):d.SyncStatus.Syncing}catch(U){throw this.syncPreviewPromise=null,U}}async merge(w){return await this.updateSyncResourcePreview(w,async C=>{const b=await this.getMergeResult(C,L.CancellationToken.None);await this.fileService.writeFile(C.previewResource,A.VSBuffer.fromString(b?.content||""));const R=b&&!b.hasConflicts?await this.getAcceptResult(C,C.previewResource,void 0,L.CancellationToken.None):void 0;return C.acceptResult=R,C.mergeState=b.hasConflicts?d.MergeState.Conflict:R?d.MergeState.Accepted:d.MergeState.Preview,C.localChange=R?R.localChange:b.localChange,C.remoteChange=R?R.remoteChange:b.remoteChange,C}),this.syncPreviewPromise}async accept(w,C){return await this.updateSyncResourcePreview(w,async b=>{const R=await this.getAcceptResult(b,w,C,L.CancellationToken.None);return b.acceptResult=R,b.mergeState=d.MergeState.Accepted,b.localChange=R.localChange,b.remoteChange=R.remoteChange,b}),this.syncPreviewPromise}async discard(w){return await this.updateSyncResourcePreview(w,async C=>{const b=await this.getMergeResult(C,L.CancellationToken.None);return await this.fileService.writeFile(C.previewResource,A.VSBuffer.fromString(b.content||"")),C.acceptResult=void 0,C.mergeState=d.MergeState.Preview,C.localChange=b.localChange,C.remoteChange=b.remoteChange,C}),this.syncPreviewPromise}async updateSyncResourcePreview(w,C){if(!this.syncPreviewPromise)return;let b=await this.syncPreviewPromise;const R=b.resourcePreviews.findIndex(({localResource:U,remoteResource:N,previewResource:M})=>this.extUri.isEqual(U,w)||this.extUri.isEqual(N,w)||this.extUri.isEqual(M,w));R!==-1&&(this.syncPreviewPromise=(0,a.createCancelablePromise)(async U=>{const N=[...b.resourcePreviews];return N[R]=await C(N[R]),{...b,resourcePreviews:N}}),b=await this.syncPreviewPromise,this.updateConflicts(b.resourcePreviews),b.resourcePreviews.some(({mergeState:U})=>U===d.MergeState.Conflict)?this.setStatus(d.SyncStatus.HasConflicts):this.setStatus(d.SyncStatus.Syncing))}async doApply(w){if(!this.syncPreviewPromise)return d.SyncStatus.Idle;const C=await this.syncPreviewPromise;return C.resourcePreviews.some(({mergeState:b})=>b===d.MergeState.Conflict)?d.SyncStatus.HasConflicts:C.resourcePreviews.some(({mergeState:b})=>b!==d.MergeState.Accepted)?d.SyncStatus.Syncing:(await this.applyResult(C.remoteUserData,C.lastSyncUserData,C.resourcePreviews.map(b=>[b,b.acceptResult]),w),this.syncPreviewPromise=null,await this.clearPreviewFolder(),d.SyncStatus.Idle)}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(w){const C=w.filter(({mergeState:b})=>b===d.MergeState.Conflict);(0,D.equals)(this._conflicts,C,(b,R)=>this.extUri.isEqual(b.previewResource,R.previewResource))||(this._conflicts=C,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async resolvePreviewContent(w){const C=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(C)for(const b of C.resourcePreviews){if(this.extUri.isEqual(b.acceptedResource,w))return b.acceptResult?b.acceptResult.content:null;if(this.extUri.isEqual(b.remoteResource,w))return b.remoteContent;if(this.extUri.isEqual(b.localResource,w))return b.localContent;if(this.extUri.isEqual(b.baseResource,w))return b.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,h.StorageScope.APPLICATION);try{await this.fileService.del(this.lastSyncResource)}catch(w){(0,c.toFileOperationResult)(w)!==c.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(w)}}async doGenerateSyncResourcePreview(w,C,b,R,U,N){const M=await this.generateSyncPreview(w,C,b,U,N),F=[];for(const K of M){const H=K.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(K.localChange===d.Change.None&&K.remoteChange===d.Change.None)F.push({...K,acceptedResource:H,acceptResult:{content:null,localChange:d.Change.None,remoteChange:d.Change.None},mergeState:d.MergeState.Accepted});else{const X=R?await this.getMergeResult(K,N):void 0;if(N.isCancellationRequested)break;await this.fileService.writeFile(K.previewResource,A.VSBuffer.fromString(X?.content||""));const j=X&&!X.hasConflicts?await this.getAcceptResult(K,K.previewResource,void 0,N):void 0;F.push({...K,acceptResult:j,mergeState:X?.hasConflicts?d.MergeState.Conflict:j?d.MergeState.Accepted:d.MergeState.Preview,localChange:j?j.localChange:X?X.localChange:K.localChange,remoteChange:j?j.remoteChange:X?X.remoteChange:K.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:C,resourcePreviews:F,isLastSyncFromCurrentMachine:b}}async getLastSyncUserData(){let w=this.getStoredLastSyncUserDataStateContent();if(w||(w=await this.migrateLastSyncUserData()),!w)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const C=JSON.parse(w),b=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!C.version&&!!b&&C.version!==b,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${C.version} is not compatible with current sync state version ${b}.`),await this.resetLocal(),null;let R,U=1;for(;R===void 0&&U++<6;)try{const N=await this.readLastSyncStoredRemoteUserData();N&&(N.ref===C.ref?R=N.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(N){if(N instanceof c.FileOperationError&&N.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(N instanceof d.UserDataSyncError)throw N;this.logService.error(N,U)}}if(R===void 0)try{const N=await this.userDataSyncStoreService.resolveResourceContent(this.resource,C.ref,this.collection,this.syncHeaders);R=N===null?null:this.parseSyncData(N),await this.writeLastSyncStoredRemoteUserData({ref:C.ref,syncData:R})}catch(N){if(N instanceof d.UserDataSyncError&&N.code===d.UserDataSyncErrorCode.NotFound)this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw N}return R===void 0?null:{...C,syncData:R}}async updateLastSyncUserData(w,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const b=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),R={ref:w.ref,version:b,...C};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(R),h.StorageScope.APPLICATION,h.StorageTarget.MACHINE),await this.writeLastSyncStoredRemoteUserData(w)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,h.StorageScope.APPLICATION)}async readLastSyncStoredRemoteUserData(){const w=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const C=w?JSON.parse(w):void 0;if(t(C))return C}catch(C){this.logService.error(C)}}async writeLastSyncStoredRemoteUserData(w){await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(w)))}async migrateLastSyncUserData(){try{const w=await this.fileService.readFile(this.lastSyncResource),C=JSON.parse(w.value.toString());await this.fileService.del(this.lastSyncResource),C.ref&&C.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...C,content:void 0}),h.StorageScope.APPLICATION,h.StorageTarget.MACHINE),await this.writeLastSyncStoredRemoteUserData({ref:C.ref,syncData:C.content===null?null:JSON.parse(C.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,C)}catch(w){w instanceof c.FileOperationError&&w.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(w)}return this.storageService.get(this.lastSyncUserDataStateKey,h.StorageScope.APPLICATION)}async getRemoteUserData(w){const{ref:C,content:b}=await this.getUserData(w);let R=null;return b!==null&&(R=this.parseSyncData(b)),{ref:C,syncData:R}}parseSyncData(w){try{const C=JSON.parse(w);if(r(C))return C}catch(C){this.logService.error(C)}throw new d.UserDataSyncError((0,S.localize)(1,null),d.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(w){const C=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,C,this.collection,this.syncHeaders)}async updateRemoteUserData(w,C){const b=await this.currentMachineIdPromise,R={version:this.version,machineId:b,content:w};try{return C=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(R),C,this.collection,this.syncHeaders),{ref:C,syncData:R}}catch(U){throw U instanceof d.UserDataSyncError&&U.code===d.UserDataSyncErrorCode.TooLarge&&(U=new d.UserDataSyncError(U.message,U.code,this.resource)),U}}async backupLocal(w){const C={version:this.version,content:w};return this.userDataSyncLocalStoreService.writeResource(this.resource,JSON.stringify(C),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==d.SyncStatus.Idle&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus(d.SyncStatus.Idle),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=i,e.AbstractSynchroniser=i=we([Q(2,c.IFileService),Q(3,p.IEnvironmentService),Q(4,h.IStorageService),Q(5,d.IUserDataSyncStoreService),Q(6,d.IUserDataSyncLocalStoreService),Q(7,d.IUserDataSyncEnablementService),Q(8,E.ITelemetryService),Q(9,d.IUserDataSyncLogService),Q(10,u.IConfigurationService),Q(11,I.IUriIdentityService)],i);let n=class extends i{constructor(w,C,b,R,U,N,M,F,K,H,X,j,ie){super(C,b,R,U,N,M,F,K,H,X,j,ie),this.file=w,this._register(this.fileService.watch(this.extUri.dirname(w))),this._register(this.fileService.onDidFilesChange(z=>this.onFileChanges(z)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(w,C,b){try{C?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(w),b?void 0:C):await this.fileService.createFile(this.file,A.VSBuffer.fromString(w),{overwrite:b})}catch(R){throw R instanceof c.FileOperationError&&R.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND||R instanceof c.FileOperationError&&R.fileOperationResult===c.FileOperationResult.FILE_MODIFIED_SINCE?new d.UserDataSyncError(R.message,d.UserDataSyncErrorCode.LocalPreconditionFailed):R}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(w){if(!(w instanceof c.FileOperationError&&w.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND))throw w}}onFileChanges(w){w.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=n,e.AbstractFileSynchroniser=n=we([Q(3,c.IFileService),Q(4,p.IEnvironmentService),Q(5,h.IStorageService),Q(6,d.IUserDataSyncStoreService),Q(7,d.IUserDataSyncLocalStoreService),Q(8,d.IUserDataSyncEnablementService),Q(9,E.ITelemetryService),Q(10,d.IUserDataSyncLogService),Q(11,u.IConfigurationService),Q(12,I.IUriIdentityService)],n);let o=class extends n{constructor(w,C,b,R,U,N,M,F,K,H,X,j,ie,z){super(w,C,b,R,U,N,M,F,K,H,X,ie,z),this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(w,C){const b=[],R=(0,_.parse)(w,b,{allowEmptyContent:!0,allowTrailingComma:!0});return b.length>0||!(0,P.isUndefined)(R)&&C!==Array.isArray(R)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=o,e.AbstractJsonFileSynchroniser=o=we([Q(3,c.IFileService),Q(4,p.IEnvironmentService),Q(5,h.IStorageService),Q(6,d.IUserDataSyncStoreService),Q(7,d.IUserDataSyncLocalStoreService),Q(8,d.IUserDataSyncEnablementService),Q(9,E.ITelemetryService),Q(10,d.IUserDataSyncLogService),Q(11,d.IUserDataSyncUtilService),Q(12,u.IConfigurationService),Q(13,I.IUriIdentityService)],o);let l=class{constructor(w,C,b,R,U,N,M){this.resource=w,this.userDataProfilesService=C,this.environmentService=b,this.logService=R,this.fileService=U,this.storageService=N,this.extUri=M.extUri,this.lastSyncResource=(0,d.getLastSyncResourceUri)(void 0,this.resource,b,this.extUri)}async initialize({ref:w,content:C}){if(!C){this.logService.info("Remote content does not exist.",this.resource);return}const b=this.parseSyncData(C);if(b)try{await this.doInitialize({ref:w,syncData:b})}catch(R){this.logService.error(R)}}parseSyncData(w){try{const C=JSON.parse(w);if(r(C))return C}catch(C){this.logService.error(C)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(w,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const b={ref:w.ref,version:void 0,...C};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(b),h.StorageScope.APPLICATION,h.StorageTarget.MACHINE),await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(w)))}};e.AbstractInitializer=l,e.AbstractInitializer=l=we([Q(1,v.IUserDataProfilesService),Q(2,p.IEnvironmentService),Q(3,g.ILogService),Q(4,c.IFileService),Q(5,h.IStorageService),Q(6,I.IUriIdentityService)],l)}),define(le[120],ue([0,1,6,26,8,3,46,2,27,22,16,119,28,33,86,37,7,4,77,10,17,18,29,20,41,242,115,25,61]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d,v,t,r,s,i,n,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=void 0,e.parseExtensions=w,e.stringify=C;async function m(N,M){const F=JSON.parse(N.content);if(N.version===1||N.version===2){const K=(await M.getInstalled(g.ExtensionType.System)).filter(H=>H.isBuiltin);for(const H of F)N.version===1&&(H.enabled===!1&&(H.disabled=!0),delete H.enabled),N.version===2&&K.every(X=>!(0,p.areSameExtensions)(X.identifier,H.identifier))&&(H.installed=!0)}return F}function w(N){return JSON.parse(N.content)}function C(N,M){return N.sort((F,K)=>!F.identifier.uuid&&K.identifier.uuid?-1:F.identifier.uuid&&!K.identifier.uuid?1:(0,T.compare)(F.identifier.id,K.identifier.id)),M?(0,k.toFormattedString)(N,{}):JSON.stringify(N)}let b=class extends s.AbstractSynchroniser{constructor(M,F,K,H,X,j,ie,z,B,ee,se,ce,W,J,G,V,O){super({syncResource:o.SyncResource.Extensions,profile:M},F,H,K,X,j,ie,ce,W,ee,se,G),this.extensionManagementService=z,this.ignoredExtensionsManagementService=B,this.instantiationService=O,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(R),this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,$=>$.some(({local:x})=>!!x)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,$=>!$.error),L.Event.filter(V.onDidChange,$=>$.valueChanges.some(({profile:x,changes:q})=>this.syncResource.profile.id===x.id&&q.some(te=>te.key===u.DISABLED_EXTENSIONS_STORAGE_PATH))),J.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(M,F){const K=M.syncData?await m(M.syncData,this.extensionManagementService):null,H=F?.skippedExtensions??[],X=F?.builtinExtensions??null,j=F?.syncData?await m(F.syncData,this.extensionManagementService):null,{localExtensions:ie,ignoredExtensions:z}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);K?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ee}=(0,i.merge)(ie,K,j,H,z,X),se={local:B,remote:ee,content:this.getPreviewContent(ie,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ee!==null?o.Change.Modified:o.Change.None},ce=this.stringify(ie,!1);return[{skippedExtensions:H,builtinExtensions:X,baseResource:this.baseResource,baseContent:j?this.stringify(j,!1):ce,localResource:this.localResource,localContent:ce,localExtensions:ie,remoteResource:this.remoteResource,remoteExtensions:K,remoteContent:K?this.stringify(K,!1):null,previewResource:this.previewResource,previewResult:se,localChange:se.localChange,remoteChange:se.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(M){const F=M.syncData?await m(M.syncData,this.extensionManagementService):null,{localExtensions:K,ignoredExtensions:H}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,i.merge)(K,F,F,M.skippedExtensions||[],H,M.builtinExtensions||[]);return X!==null}getPreviewContent(M,F,K,H){const X=[...F,...K],j=new Set,ie=z=>{j.add(z.id.toLowerCase()),z.uuid&&j.add(z.uuid)};X.forEach(({identifier:z})=>ie(z)),H.forEach(ie);for(const z of M)j.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&j.has(z.identifier.uuid)||X.push(z);return this.stringify(X,!1)}async getMergeResult(M,F){return{...M.previewResult,hasConflicts:!1}}async getAcceptResult(M,F,K,H){if(this.extUri.isEqual(F,this.localResource))return this.acceptLocal(M);if(this.extUri.isEqual(F,this.remoteResource))return this.acceptRemote(M);if(this.extUri.isEqual(F,this.previewResource))return M.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async acceptLocal(M){const F=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.ignoredExtensionsManagementService.getIgnoredExtensions(F),H=(0,i.merge)(M.localExtensions,null,null,M.skippedExtensions,K,M.builtinExtensions),{local:X,remote:j}=H;return{content:M.localContent,local:X,remote:j,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:j!==null?o.Change.Modified:o.Change.None}}async acceptRemote(M){const F=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.ignoredExtensionsManagementService.getIgnoredExtensions(F),H=M.remoteContent?JSON.parse(M.remoteContent):null;if(H!==null){const X=(0,i.merge)(M.localExtensions,H,M.localExtensions,[],K,M.builtinExtensions),{local:j,remote:ie}=X;return{content:M.remoteContent,local:j,remote:ie,localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ie!==null?o.Change.Modified:o.Change.None}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:o.Change.None,remoteChange:o.Change.None}}async applyResult(M,F,K,H){let{skippedExtensions:X,builtinExtensions:j,localExtensions:ie}=K[0][0];const{local:z,remote:B,localChange:ee,remoteChange:se}=K[0][1];if(ee===o.Change.None&&se===o.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),ee!==o.Change.None&&(await this.backupLocal(JSON.stringify(ie)),X=await this.localExtensionsProvider.updateLocalExtensions(z.added,z.removed,z.updated,X,this.syncResource.profile)),B){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ce=JSON.stringify(B.all);M=await this.updateRemoteUserData(ce,H?null:M.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(W=>W.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(W=>W.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(W=>W.identifier.id))}.`:""}`)}F?.ref!==M.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),j=this.computeBuiltinExtensions(ie,j),await this.updateLastSyncUserData(M,{skippedExtensions:X,builtinExtensions:j}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(ce=>ce.identifier.id))}.`:""}`))}computeBuiltinExtensions(M,F){const K=new Set,H=[];for(const X of M)K.add(X.identifier.id.toLowerCase()),X.installed||H.push(X.identifier);if(F)for(const X of F)K.has(X.id.toLowerCase())||H.push(X);return H}async resolveContent(M){if(this.extUri.isEqual(this.remoteResource,M)||this.extUri.isEqual(this.baseResource,M)||this.extUri.isEqual(this.localResource,M)||this.extUri.isEqual(this.acceptedResource,M)){const F=await this.resolvePreviewContent(M);return F&&this.stringify(JSON.parse(F),!0)}return null}stringify(M,F){return C(M,F)}async hasLocalData(){try{const{localExtensions:M}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(M.some(F=>F.installed||F.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=b,e.ExtensionsSynchroniser=b=we([Q(2,P.IEnvironmentService),Q(3,f.IFileService),Q(4,d.IStorageService),Q(5,o.IUserDataSyncStoreService),Q(6,o.IUserDataSyncLocalStoreService),Q(7,u.IExtensionManagementService),Q(8,n.IIgnoredExtensionsManagementService),Q(9,o.IUserDataSyncLogService),Q(10,y.IConfigurationService),Q(11,o.IUserDataSyncEnablementService),Q(12,v.ITelemetryService),Q(13,c.IExtensionStorageService),Q(14,t.IUriIdentityService),Q(15,l.IUserDataProfileStorageService),Q(16,h.IInstantiationService)],b);let R=class{constructor(M,F,K,H,X,j){this.extensionManagementService=M,this.userDataProfileStorageService=F,this.extensionGalleryService=K,this.ignoredExtensionsManagementService=H,this.instantiationService=X,this.logService=j}async getLocalExtensions(M){const F=await this.extensionManagementService.getInstalled(void 0,M.extensionsResource),K=this.ignoredExtensionsManagementService.getIgnoredExtensions(F);return{localExtensions:await this.withProfileScopedServices(M,async(X,j)=>{const ie=X.getDisabledExtensions();return F.map(z=>{const{identifier:B,isBuiltin:ee,manifest:se,preRelease:ce,pinned:W,isApplicationScoped:J}=z,G={identifier:B,preRelease:ce,version:se.version,pinned:!!W};J&&!(0,g.isApplicationScopedExtension)(se)&&(G.isApplicationScoped=J),ie.some(V=>(0,p.areSameExtensions)(V,B))&&(G.disabled=!0),ee||(G.installed=!0);try{const V=j.getKeysForSync({id:B.id,version:se.version});if(V){const O=j.getExtensionState(z,!0)||{};G.state=Object.keys(O).reduce(($,x)=>(V.includes(x)&&($[x]=O[x]),$),{})}}catch(V){this.logService.info(`${(0,s.getSyncResourceLogLabel)(o.SyncResource.Extensions,M)}: Error while parsing extension state`,(0,A.getErrorMessage)(V))}return G})}),ignoredExtensions:K}}async updateLocalExtensions(M,F,K,H,X){const j=(0,s.getSyncResourceLogLabel)(o.SyncResource.Extensions,X),ie=[],z=new Map,B=[],ee=[],se=await this.extensionManagementService.getInstalled(void 0,X.extensionsResource);if((M.length||K.length)&&await this.withProfileScopedServices(X,async(J,G)=>{await D.Promises.settled([...M,...K].map(async V=>{const O=se.find(q=>(0,p.areSameExtensions)(q.identifier,V.identifier));if(O&&O.isBuiltin){V.state&&O.manifest.version===V.version&&this.updateExtensionState(V.state,O,O.manifest.version,G),J.getDisabledExtensions().some(te=>(0,p.areSameExtensions)(te,V.identifier))!==!!V.disabled&&(V.disabled?(this.logService.trace(`${j}: Disabling extension...`,V.identifier.id),await J.disableExtension(V.identifier),this.logService.info(`${j}: Disabled extension`,V.identifier.id)):(this.logService.trace(`${j}: Enabling extension...`,V.identifier.id),await J.enableExtension(V.identifier),this.logService.info(`${j}: Enabled extension`,V.identifier.id))),B.push(V.identifier);return}const $=V.pinned?V.version:void 0,x=(await this.extensionGalleryService.getExtensions([{...V.identifier,version:$,preRelease:$?void 0:V.preRelease}],a.CancellationToken.None))[0];if(V.state&&(O?O.manifest.version===V.version:x)&&this.updateExtensionState(V.state,O||x,O?.manifest.version,G),x)try{J.getDisabledExtensions().some(te=>(0,p.areSameExtensions)(te,V.identifier))!==!!V.disabled&&(V.disabled?(this.logService.trace(`${j}: Disabling extension...`,V.identifier.id,x.version),await J.disableExtension(x.identifier),this.logService.info(`${j}: Disabled extension`,V.identifier.id,x.version)):(this.logService.trace(`${j}: Enabling extension...`,V.identifier.id,x.version),await J.enableExtension(x.identifier),this.logService.info(`${j}: Enabled extension`,V.identifier.id,x.version))),(!O||O.preRelease!==V.preRelease||O.pinned!==V.pinned||$&&O.manifest.version!==$)&&(await this.extensionManagementService.canInstall(x)?(ie.push({extension:x,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:V.pinned&&!!V.version,pinned:V.pinned,installPreReleaseVersion:V.preRelease,profileLocation:X.extensionsResource,isApplicationScoped:V.isApplicationScoped,context:{[u.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[u.EXTENSION_INSTALL_SOURCE_CONTEXT]:u.ExtensionInstallSource.SETTINGS_SYNC}}}),z.set(x.identifier.id.toLowerCase(),V)):(this.logService.info(`${j}: Skipped synchronizing extension because it cannot be installed.`,x.displayName||x.identifier.id),ee.push(V)))}catch(q){ee.push(V),this.logService.error(q),this.logService.info(`${j}: Skipped synchronizing extension`,x.displayName||x.identifier.id)}else ee.push(V),this.logService.info(`${j}: Skipped synchronizing extension because the extension is not found.`,V.identifier.id)}))}),F.length){const J=se.filter(({identifier:G,isBuiltin:V})=>!V&&F.some(O=>(0,p.areSameExtensions)(G,O)));await D.Promises.settled(J.map(async G=>{this.logService.trace(`${j}: Uninstalling local extension...`,G.identifier.id),await this.extensionManagementService.uninstall(G,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.logService.info(`${j}: Uninstalled local extension.`,G.identifier.id),B.push(G.identifier)}))}const ce=await this.extensionManagementService.installGalleryExtensions(ie);for(const{identifier:J,local:G,error:V,source:O}of ce){const $=O;if(G)this.logService.info(`${j}: Installed extension.`,J.id,$.version),B.push(J);else{const x=z.get(J.id.toLowerCase());x&&(ee.push(x),this.logService.info(`${j}: Skipped synchronizing extension`,$.displayName||$.identifier.id)),V instanceof u.ExtensionManagementError&&[u.ExtensionManagementErrorCode.Incompatible,u.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(V.code)?this.logService.info(`${j}: Skipped synchronizing extension because the compatible extension is not found.`,$.displayName||$.identifier.id):V&&this.logService.error(V)}}const W=[];for(const J of H)B.some(G=>(0,p.areSameExtensions)(G,J.identifier))||W.push(J);for(const J of ee)W.some(G=>(0,p.areSameExtensions)(G.identifier,J.identifier))||W.push(J);return W}updateExtensionState(M,F,K,H){const X=H.getExtensionState(F,!0)||{},j=K?H.getKeysForSync({id:F.identifier.id,version:K}):void 0;j?j.forEach(ie=>{X[ie]=M[ie]}):Object.keys(M).forEach(ie=>X[ie]=M[ie]),H.setExtensionState(F,X,!0)}async withProfileScopedServices(M,F){return this.userDataProfileStorageService.withProfileScopedStorageService(M,async K=>{const H=new _.DisposableStore,X=H.add(this.instantiationService.createChild(new E.ServiceCollection([d.IStorageService,K]))),j=H.add(X.createInstance(S.GlobalExtensionEnablementService)),ie=H.add(X.createInstance(c.ExtensionStorageService));try{return await F(j,ie)}finally{H.dispose()}})}};e.LocalExtensionsProvider=R,e.LocalExtensionsProvider=R=we([Q(0,u.IExtensionManagementService),Q(1,l.IUserDataProfileStorageService),Q(2,u.IExtensionGalleryService),Q(3,n.IIgnoredExtensionsManagementService),Q(4,h.IInstantiationService),Q(5,o.IUserDataSyncLogService)],R);let U=class extends s.AbstractInitializer{constructor(M,F,K,H,X,j,ie,z){super(o.SyncResource.Extensions,H,X,j,K,ie,z),this.extensionManagementService=M,this.ignoredExtensionsManagementService=F}async parseExtensions(M){return M.syncData?await m(M.syncData,this.extensionManagementService):null}generatePreview(M,F){const K=[],H=[],X=[];for(const j of M){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(j.identifier.id))continue;const ie=F.find(z=>(0,p.areSameExtensions)(z.identifier,j.identifier));ie?(K.push(ie),j.disabled&&X.push(j.identifier)):j.installed&&(H.push({...j.identifier,preRelease:!!j.preRelease}),j.disabled&&X.push(j.identifier))}return{installedExtensions:K,newExtensions:H,disabledExtensions:X,remoteExtensions:M}}};e.AbstractExtensionsInitializer=U,e.AbstractExtensionsInitializer=U=we([Q(0,u.IExtensionManagementService),Q(1,n.IIgnoredExtensionsManagementService),Q(2,f.IFileService),Q(3,r.IUserDataProfilesService),Q(4,P.IEnvironmentService),Q(5,I.ILogService),Q(6,d.IStorageService),Q(7,t.IUriIdentityService)],U)}),define(le[121],ue([0,1,15,8,3,34,46,5,32,22,16,7,10,50,17,18,29,41,82,246,25,20,61,4]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d,v,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=void 0,e.stringify=n;const s="globalState.argv.",i=["locale"];function n(b,R){const U=b.storage?Object.keys(b.storage).sort():[],N={};return U.forEach(M=>N[M]=b.storage[M]),b.storage=N,R?(0,k.toFormattedString)(b,{}):JSON.stringify(b)}const o=1;let l=class extends h.AbstractSynchroniser{constructor(R,U,N,M,F,K,H,X,j,ie,z,B,ee,se){super({syncResource:d.SyncResource.GlobalState,profile:R},U,M,X,B,F,K,j,ie,H,z,ee),this.userDataProfileStorageService=N,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=se.createInstance(m),this._register(M.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(M.onDidFilesChange,ce=>ce.contains(this.environmentService.argvResource)),A.Event.filter(N.onDidChange,ce=>!!(ce.targetChanges.some(W=>this.syncResource.profile.id===W.id)||ce.valueChanges.some(({profile:W,changes:J})=>this.syncResource.profile.id===W.id&&J.some(G=>G.target===c.StorageTarget.USER)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(R,U,N){const M=R.syncData?JSON.parse(R.syncData.content):null;U=U===null&&N?R:U;const F=U&&U.syncData?JSON.parse(U.syncData.content):null,K=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);M?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=await this.getStorageKeys(F),{local:X,remote:j}=(0,I.merge)(K.storage,M?M.storage:null,F?F.storage:null,H,this.logService),ie={content:null,local:X,remote:j,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?d.Change.Modified:d.Change.None,remoteChange:j.all!==null?d.Change.Modified:d.Change.None},z=n(K,!1);return[{baseResource:this.baseResource,baseContent:F?n(F,!1):z,localResource:this.localResource,localContent:z,localUserData:K,remoteResource:this.remoteResource,remoteContent:M?n(M,!1):null,previewResource:this.previewResource,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.acceptedResource,storageKeys:H}]}async hasRemoteChanged(R){const U=R.syncData?JSON.parse(R.syncData.content):null;if(U===null)return!0;const N=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),M=await this.getStorageKeys(U),{remote:F}=(0,I.merge)(N.storage,U.storage,U.storage,M,this.logService);return F.all!==null}async getMergeResult(R,U){return{...R.previewResult,hasConflicts:!1}}async getAcceptResult(R,U,N,M){if(this.extUri.isEqual(U,this.localResource))return this.acceptLocal(R);if(this.extUri.isEqual(U,this.remoteResource))return this.acceptRemote(R);if(this.extUri.isEqual(U,this.previewResource))return R.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async acceptLocal(R){return{content:R.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(R.localUserData.storage),removed:[],updated:[],all:R.localUserData.storage},localChange:d.Change.None,remoteChange:d.Change.Modified}}async acceptRemote(R){if(R.remoteContent!==null){const U=JSON.parse(R.remoteContent),{local:N,remote:M}=(0,I.merge)(R.localUserData.storage,U.storage,null,R.storageKeys,this.logService);return{content:R.remoteContent,local:N,remote:M,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?d.Change.Modified:d.Change.None,remoteChange:M!==null?d.Change.Modified:d.Change.None}}else return{content:R.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:d.Change.None,remoteChange:d.Change.None}}async applyResult(R,U,N,M){const{localUserData:F}=N[0][0],{local:K,remote:H,localChange:X,remoteChange:j}=N[0][1];if(X===d.Change.None&&j===d.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),X!==d.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.localGlobalStateProvider.writeLocalGlobalState(K,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==d.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const ie=JSON.stringify({storage:H.all});R=await this.updateRemoteUserData(ie,M?null:R.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${H.added.length?` Added: ${H.added}.`:""}${H.updated.length?` Updated: ${H.updated}.`:""}${H.removed.length?` Removed: ${H.removed}.`:""}`)}U?.ref!==R.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(R),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(R){if(this.extUri.isEqual(this.remoteResource,R)||this.extUri.isEqual(this.baseResource,R)||this.extUri.isEqual(this.localResource,R)||this.extUri.isEqual(this.acceptedResource,R)){const U=await this.resolvePreviewContent(R);return U&&n(JSON.parse(U),!0)}return null}async hasLocalData(){try{const{storage:R}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(R).length>1||R[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(R){const U=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),N=[],M=[];for(const[H,X]of U)X.target===c.StorageTarget.USER?N.push(H):X.target===c.StorageTarget.MACHINE&&M.push(H);const F=[...N,...M],K=R?.storage?Object.keys(R.storage).filter(H=>!H.startsWith(s)&&!F.includes(H)&&U.get(H)!==void 0):[];if(!_.isWeb){const H=[...d.ALL_SYNC_RESOURCES.map(X=>(0,d.getEnablementKey)(X)),d.SYNC_SERVICE_URL_TYPE];K.push(...H),M.push(...H)}return{user:N,machine:M,unregistered:K}}};e.GlobalStateSynchroniser=l,e.GlobalStateSynchroniser=l=we([Q(2,t.IUserDataProfileStorageService),Q(3,S.IFileService),Q(4,d.IUserDataSyncStoreService),Q(5,d.IUserDataSyncLocalStoreService),Q(6,d.IUserDataSyncLogService),Q(7,P.IEnvironmentService),Q(8,d.IUserDataSyncEnablementService),Q(9,g.ITelemetryService),Q(10,y.IConfigurationService),Q(11,c.IStorageService),Q(12,f.IUriIdentityService),Q(13,r.IInstantiationService)],l);let m=class{constructor(R,U,N,M){this.fileService=R,this.environmentService=U,this.userDataProfileStorageService=N,this.logService=M}async getLocalGlobalState(R){const U={};if(R.isDefault){const M=await this.getLocalArgvContent(),F=(0,L.parse)(M);for(const K of i)F[K]!==void 0&&(U[`${s}${K}`]={version:1,value:F[K]})}const N=await this.userDataProfileStorageService.readStorageData(R);for(const[M,F]of N)F.value&&F.target===c.StorageTarget.USER&&(U[M]={version:1,value:F.value});return{storage:U}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const R=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),R.value.toString()}catch(R){this.logService.debug((0,a.getErrorMessage)(R))}return"{}"}async writeLocalGlobalState({added:R,removed:U,updated:N},M){const F=(0,h.getSyncResourceLogLabel)(d.SyncResource.GlobalState,M),K={},H=new Map,X=await this.userDataProfileStorageService.readStorageData(M),j=(ie,z)=>{for(const B of ie){if(B.startsWith(s)){K[B.substring(s.length)]=z?z[B].value:void 0;continue}if(z){const ee=z[B];ee.value!==X.get(B)?.value&&H.set(B,ee.value)}else X.get(B)!==void 0&&H.set(B,void 0)}};if(j(Object.keys(R),R),j(Object.keys(N),N),j(U),Object.keys(K).length){this.logService.trace(`${F}: Updating locale...`);const ie=await this.getLocalArgvContent();let z=ie;for(const B of Object.keys(K))z=(0,E.edit)(z,[B],K[B],{});ie!==z&&(this.logService.trace(`${F}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(z)),this.logService.info(`${F}: Updated locale.`)),this.logService.info(`${F}: Updated locale`)}H.size&&(this.logService.trace(`${F}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(M,H,c.StorageTarget.USER),this.logService.info(`${F}: Updated global state`,[...H.keys()]))}};e.LocalGlobalStateProvider=m,e.LocalGlobalStateProvider=m=we([Q(0,S.IFileService),Q(1,P.IEnvironmentService),Q(2,t.IUserDataProfileStorageService),Q(3,d.IUserDataSyncLogService)],m);let w=class extends h.AbstractInitializer{constructor(R,U,N,M,F,K){super(d.SyncResource.GlobalState,N,M,F,U,R,K)}async doInitialize(R){const U=R.syncData?JSON.parse(R.syncData.content):null;if(!U){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const N={},M={};for(const F of Object.keys(U.storage))F.startsWith(s)?N[F.substring(s.length)]=U.storage[F].value:this.storageService.get(F,c.StorageScope.PROFILE)===void 0&&(M[F]=U.storage[F].value);if(Object.keys(N).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const K of Object.keys(N))F=(0,E.edit)(F,[K],N[K],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(F))}if(Object.keys(M).length){const F=[];for(const K of Object.keys(M))F.push({key:K,value:M[K],scope:c.StorageScope.PROFILE,target:c.StorageTarget.USER});this.storageService.storeAll(F,!0)}}};e.GlobalStateInitializer=w,e.GlobalStateInitializer=w=we([Q(0,c.IStorageService),Q(1,S.IFileService),Q(2,v.IUserDataProfilesService),Q(3,P.IEnvironmentService),Q(4,d.IUserDataSyncLogService),Q(5,f.IUriIdentityService)],w);let C=class{constructor(R,U,N,M,F){this.userDataSyncStoreClient=R,this.storageService=U,this.environmentService=N,this.fileService=M,this.logService=F}getSyncStoreType(R){return this.parseGlobalState(R)?.storage[d.SYNC_SERVICE_URL_TYPE]?.value}async sync(R){const U=(0,d.createSyncHeaders)((0,T.generateUuid)());try{return await this.doSync(R,U)}catch(N){if(N instanceof d.UserDataSyncError)switch(N.code){case d.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(R,U)}throw N}}async doSync(R,U){const N=await this.userDataSyncStoreClient.readResource(d.SyncResource.GlobalState,null,void 0,U),M=this.parseGlobalState(N)||{storage:{}};M.storage[d.SYNC_SERVICE_URL_TYPE]={value:R,version:o};const F=await(0,p.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),K={version:o,machineId:F,content:n(M,!1)};await this.userDataSyncStoreClient.writeResource(d.SyncResource.GlobalState,JSON.stringify(K),N.ref,void 0,U)}parseGlobalState({content:R}){if(!R)return null;const U=JSON.parse(R);if((0,h.isSyncData)(U))return U?JSON.parse(U.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=C,e.UserDataSyncStoreTypeSynchronizer=C=we([Q(1,c.IStorageService),Q(2,P.IEnvironmentService),Q(3,S.IFileService),Q(4,u.ILogService)],C)}),define(le[122],ue([0,1,19,15,3,34,5,13,182,22,16,7,17,18,29,20,41,243,25]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=void 0,e.getKeybindingsContentFromSyncContent=I;function I(t,r,s){try{const i=JSON.parse(t);if(!r)return(0,_.isUndefined)(i.all)?null:i.all;switch(k.OS){case k.OperatingSystem.Macintosh:return(0,_.isUndefined)(i.mac)?null:i.mac;case k.OperatingSystem.Linux:return(0,_.isUndefined)(i.linux)?null:i.linux;case k.OperatingSystem.Windows:return(0,_.isUndefined)(i.windows)?null:i.windows}}catch(i){return s.error(i),null}}let d=class extends f.AbstractJsonFileSynchroniser{constructor(r,s,i,n,o,l,m,w,C,b,R,U,N){super(r.keybindingsResource,{syncResource:E.SyncResource.Keybindings,profile:r},s,w,C,b,i,n,m,U,o,R,l,N),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.filter(l.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,s,i,n){const o=r.syncData?I(r.syncData.content,n.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;s=s===null&&i?r:s;const l=s?this.getKeybindingsContentFromLastSyncUserData(s):null,m=await this.getLocalFileContent(),w=await this.getFormattingOptions();let C=null,b=!1,R=!1,U=!1;if(o){let F=m?m.value.toString():"[]";if(F=F||"[]",this.hasErrors(F,!0))throw new E.UserDataSyncError((0,T.localize)(0,null),E.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!l||l!==F||l!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const K=await(0,h.merge)(F,o,l,w,this.userDataSyncUtilService);K.hasChanges&&(C=K.mergeContent,U=K.hasConflicts,b=U||K.mergeContent!==F,R=U||K.mergeContent!==o)}}else m&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),C=m.value.toString(),R=!0);const N={content:U?l:C,localChange:b?m?E.Change.Modified:E.Change.Added:E.Change.None,remoteChange:R?E.Change.Modified:E.Change.None,hasConflicts:U},M=m?m.value.toString():null;return[{fileContent:m,baseResource:this.baseResource,baseContent:l,localResource:this.localResource,localContent:M,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const s=this.getKeybindingsContentFromLastSyncUserData(r);if(s===null)return!0;const i=await this.getLocalFileContent(),n=i?i.value.toString():"",o=await this.getFormattingOptions(),l=await(0,h.merge)(n||"[]",s,s,o,this.userDataSyncUtilService);return l.hasConflicts||l.mergeContent!==s}async getMergeResult(r,s){return r.previewResult}async getAcceptResult(r,s,i,n){if(this.extUri.isEqual(s,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:E.Change.None,remoteChange:E.Change.Modified};if(this.extUri.isEqual(s,this.remoteResource))return{content:r.remoteContent,localChange:E.Change.Modified,remoteChange:E.Change.None};if(this.extUri.isEqual(s,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:E.Change.Modified,remoteChange:E.Change.Modified};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(r,s,i,n){const{fileContent:o}=i[0][0];let{content:l,localChange:m,remoteChange:w}=i[0][1];if(m===E.Change.None&&w===E.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l,!0)))throw new E.UserDataSyncError((0,T.localize)(1,null),E.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(m!==E.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(l||"[]",o,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),w!==E.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const C=this.toSyncContent(l||"[]",r.syncData?.content);r=await this.updateRemoteUserData(C,n?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}s?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const s=(0,L.parse)(r.value.toString());if((0,D.isNonEmptyArray)(s))return!0}}catch(r){if(r.fileOperationResult!==S.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(r){return this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.baseResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)?this.resolvePreviewContent(r):null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:I(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,s){let i={};try{i=JSON.parse(s||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,k.OS){case k.OperatingSystem.Macintosh:i.mac=r;break;case k.OperatingSystem.Linux:i.linux=r;break;case k.OperatingSystem.Windows:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(E.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=d,e.KeybindingsSynchroniser=d=we([Q(2,E.IUserDataSyncStoreService),Q(3,E.IUserDataSyncLocalStoreService),Q(4,E.IUserDataSyncLogService),Q(5,y.IConfigurationService),Q(6,E.IUserDataSyncEnablementService),Q(7,S.IFileService),Q(8,P.IEnvironmentService),Q(9,u.IStorageService),Q(10,E.IUserDataSyncUtilService),Q(11,p.ITelemetryService),Q(12,c.IUriIdentityService)],d);let v=class extends f.AbstractInitializer{constructor(r,s,i,n,o,l){super(E.SyncResource.Keybindings,s,i,n,r,o,l)}async doInitialize(r){const s=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!s){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,a.VSBuffer.fromString(s)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),s=(0,L.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(s)}catch(r){return r.fileOperationResult===S.FileOperationResult.FILE_NOT_FOUND}}getKeybindingsContentFromSyncContent(r){try{return I(r,!0,this.logService)}catch(s){return this.logService.error(s),null}}};e.KeybindingsInitializer=v,e.KeybindingsInitializer=v=we([Q(0,S.IFileService),Q(1,g.IUserDataProfilesService),Q(2,P.IEnvironmentService),Q(3,E.IUserDataSyncLogService),Q(4,u.IStorageService),Q(5,c.IUriIdentityService)],v)}),define(le[123],ue([0,1,15,3,183,22,78,16,28,7,17,18,29,20,41,247,25]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=void 0,e.parseSettingsSyncContent=E;function h(v){return v&&v.settings&&typeof v.settings=="string"&&Object.keys(v).length===1}function E(v){const t=JSON.parse(v);return h(t)?t:{settings:v}}let I=class extends c.AbstractJsonFileSynchroniser{constructor(t,r,s,i,n,o,l,m,w,C,b,R,U,N){super(t.settingsResource,{syncResource:f.SyncResource.Settings,profile:t},r,s,i,n,o,l,b,R,m,w,C,N),this.extensionManagementService=U,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const r=await this.getLastSyncUserData(),s=await this.getLatestRemoteUserData(t,r),i=this.getSettingsSyncContent(s),n=new k.ConfigurationModelParser(f.USER_DATA_SYNC_CONFIGURATION_SCOPE,this.logService);return i?.settings&&n.parse(i.settings),n.configurationModel.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,r,s){const i=await this.getLocalFileContent(),n=await this.getFormattingOptions(),o=this.getSettingsSyncContent(t);r=r===null&&s?t:r;const l=r?this.getSettingsSyncContent(r):null,m=await this.getIgnoredSettings();let w=null,C=!1,b=!1,R=!1;if(o){let F=i?i.value.toString().trim():"{}";F=F||"{}",this.validateContent(F),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const K=(0,g.merge)(F,o.settings,l?l.settings:null,m,[],n);w=K.localContent||K.remoteContent,C=K.localContent!==null,b=K.remoteContent!==null,R=K.hasConflicts}else i&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),w=i.value.toString().trim()||"{}",this.validateContent(w),b=!0);const U=i?i.value.toString():null,N=l?.settings??null,M={content:R?N:w,localChange:C?f.Change.Modified:f.Change.None,remoteChange:b?f.Change.Modified:f.Change.None,hasConflicts:R};return[{fileContent:i,baseResource:this.baseResource,baseContent:N,localResource:this.localResource,localContent:U,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const r=this.getSettingsSyncContent(t);if(r===null)return!0;const s=await this.getLocalFileContent(),i=s?s.value.toString().trim():"",n=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,g.merge)(i||"{}",r.settings,r.settings,n,[],o).remoteContent!==null}async getMergeResult(t,r){const s=await this.getFormattingOptions(),i=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,g.updateIgnoredSettings)(t.previewResult.content,"{}",i,s):null}}async getAcceptResult(t,r,s,i){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,g.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",o,n):null,localChange:f.Change.None,remoteChange:f.Change.Modified};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,g.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,n):null,localChange:f.Change.Modified,remoteChange:f.Change.None};if(this.extUri.isEqual(r,this.previewResource))return s===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:s!==null?(0,g.updateIgnoredSettings)(s,t.fileContent?t.fileContent.value.toString():"{}",o,n):null,localChange:f.Change.Modified,remoteChange:f.Change.Modified};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,s,i){const{fileContent:n}=s[0][0];let{content:o,localChange:l,remoteChange:m}=s[0][1];if(l===f.Change.None&&m===f.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),l!==f.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),n&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(n.value.toString()))),await this.updateLocalFileContent(o,n,i),await this.configurationService.reloadConfiguration(L.ConfigurationTarget.USER_LOCAL),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),m!==f.Change.None){const w=await this.getFormattingOptions(),C=this.getSettingsSyncContent(t),b=await this.getIgnoredSettings(o);o=(0,g.updateIgnoredSettings)(o,C?C.settings:"{}",b,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),i?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t)return!(0,g.isEmpty)(t.value.toString())}catch(t){if(t.fileOperationResult!==y.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(t){return this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t)||this.extUri.isEqual(this.baseResource,t)?this.resolvePreviewContent(t):null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const s=await this.getFormattingOptions(),i=await this.getIgnoredSettings();r=(0,g.updateIgnoredSettings)(r,"{}",i,s)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return E(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const s=this._register(a.Event.any(a.Event.filter(this.extensionManagementService.onDidInstallExtensions,i=>i.some(({local:n})=>!!n)),a.Event.filter(this.extensionManagementService.onDidUninstallExtension,i=>!i.error))(()=>{s.dispose(),this._defaultIgnoredSettings=void 0}))}const r=await this._defaultIgnoredSettings;return(0,g.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t,!1))throw new f.UserDataSyncError((0,A.localize)(0,null),f.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.SettingsSynchroniser=I,e.SettingsSynchroniser=I=we([Q(2,y.IFileService),Q(3,_.IEnvironmentService),Q(4,P.IStorageService),Q(5,f.IUserDataSyncStoreService),Q(6,f.IUserDataSyncLocalStoreService),Q(7,f.IUserDataSyncLogService),Q(8,f.IUserDataSyncUtilService),Q(9,L.IConfigurationService),Q(10,f.IUserDataSyncEnablementService),Q(11,S.ITelemetryService),Q(12,T.IExtensionManagementService),Q(13,u.IUriIdentityService)],I);let d=class extends c.AbstractInitializer{constructor(t,r,s,i,n,o){super(f.SyncResource.Settings,r,s,i,t,n,o)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,g.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===y.FileOperationResult.FILE_NOT_FOUND}}parseSettingsSyncContent(t){try{return E(t)}catch(r){this.logService.error(r)}return null}};e.SettingsInitializer=d,e.SettingsInitializer=d=we([Q(0,y.IFileService),Q(1,p.IUserDataProfilesService),Q(2,_.IEnvironmentService),Q(3,f.IUserDataSyncLogService),Q(4,P.IStorageService),Q(5,u.IUriIdentityService)],d)}),define(le[124],ue([0,1,15,3,30,22,16,7,17,18,29,20,41,244,25]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0,e.parseSnippets=g;function g(E){return JSON.parse(E.content)}let f=class extends u.AbstractSynchroniser{constructor(I,d,v,t,r,s,i,n,o,l,m,w){super({syncResource:c.SyncResource.Snippets,profile:I},d,t,v,r,s,i,l,m,n,o,w),this.version=1,this.snippetsFolder=I.snippetsHome,this._register(this.fileService.watch(v.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(a.Event.filter(this.fileService.onDidFilesChange,C=>C.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(I,d,v){const t=await this.getSnippetsFileContents(),r=this.toSnippetsContents(t),s=I.syncData?this.parseSnippets(I.syncData):null;d=d===null&&v?I:d;const i=d&&d.syncData?this.parseSnippets(d.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,p.merge)(r,s,i);return this.getResourcePreviews(n,t,s||{},i||{})}async hasRemoteChanged(I){const d=I.syncData?this.parseSnippets(I.syncData):null;if(d===null)return!0;const v=await this.getSnippetsFileContents(),t=this.toSnippetsContents(v),r=(0,p.merge)(t,d,d);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async getMergeResult(I,d){return I.previewResult}async getAcceptResult(I,d,v,t){if(this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:c.Change.None,remoteChange:I.fileContent?I.remoteContent!==null?c.Change.Modified:c.Change.Added:c.Change.Deleted};if(this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?c.Change.Modified:c.Change.Added:c.Change.Deleted,remoteChange:c.Change.None};if(this.extUri.isEqualOrParent(d,this.syncPreviewFolder))return v===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:v,localChange:v===null?I.fileContent!==null?c.Change.Deleted:c.Change.None:c.Change.Modified,remoteChange:v===null?I.remoteContent!==null?c.Change.Deleted:c.Change.None:c.Change.Modified};throw new Error(`Invalid Resource: ${d.toString()}`)}async applyResult(I,d,v,t){const r=v.map(([s,i])=>({...s,acceptResult:i}));r.every(({localChange:s,remoteChange:i})=>s===c.Change.None&&i===c.Change.None)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),r.some(({localChange:s})=>s!==c.Change.None)&&(await this.updateLocalBackup(r),await this.updateLocalSnippets(r,t)),r.some(({remoteChange:s})=>s!==c.Change.None)&&(I=await this.updateRemoteSnippets(r,I,t)),d?.ref!==I.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(I),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of r)try{await this.fileService.del(s)}catch{}}getResourcePreviews(I,d,v,t){const r=new Map;for(const s of Object.keys(I.local.added)){const i={content:I.local.added[s],hasConflicts:!1,localChange:c.Change.Added,remoteChange:c.Change.None};r.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(I.local.updated)){const i={content:I.local.updated[s],hasConflicts:!1,localChange:c.Change.Modified,remoteChange:c.Change.None},n=d[s]?d[s].value.toString():null;r.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of I.local.removed){const i={content:null,hasConflicts:!1,localChange:c.Change.Deleted,remoteChange:c.Change.None},n=d[s]?d[s].value.toString():null;r.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(I.remote.added)){const i={content:I.remote.added[s],hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Added},n=d[s]?d[s].value.toString():null;r.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(I.remote.updated)){const i={content:I.remote.updated[s],hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Modified},n=d[s]?d[s].value.toString():null;r.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of I.remote.removed){const i={content:null,hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Deleted};r.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of I.conflicts){const i={content:t[s]??null,hasConflicts:!0,localChange:d[s]?c.Change.Modified:c.Change.Added,remoteChange:v[s]?c.Change.Modified:c.Change.Added},n=d[s]?d[s].value.toString():null;r.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[s]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(d))if(!r.has(s)){const i={content:d[s]?d[s].value.toString():null,hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.None},n=d[s]?d[s].value.toString():null;r.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[s]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(I){return this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(I):null}async hasLocalData(){try{const I=await this.getSnippetsFileContents();if(Object.keys(I).length)return!0}catch{}return!1}async updateLocalBackup(I){const d={};for(const v of I)v.fileContent&&(d[this.extUri.basename(v.localResource)]=v.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(d)))}async updateLocalSnippets(I,d){for(const{fileContent:v,acceptResult:t,localResource:r,remoteResource:s,localChange:i}of I)if(i!==c.Change.None){const n=s?this.extUri.basename(s):this.extUri.basename(r),o=this.extUri.joinPath(this.snippetsFolder,n);i===c.Change.Deleted?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):i===c.Change.Added?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,D.VSBuffer.fromString(t.content),{overwrite:d}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,D.VSBuffer.fromString(t.content),d?void 0:v),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(I,d,v){const t=d.syncData?this.parseSnippets(d.syncData):{},r=(0,A.deepClone)(t);for(const{acceptResult:s,localResource:i,remoteResource:n,remoteChange:o}of I)if(o!==c.Change.None){const l=i?this.extUri.basename(i):this.extUri.basename(n);o===c.Change.Deleted?delete r[l]:r[l]=s.content}return(0,p.areSame)(t,r)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),d=await this.updateRemoteUserData(JSON.stringify(r),v?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),d}parseSnippets(I){return g(I)}toSnippetsContents(I){const d={};for(const v of Object.keys(I))d[v]=I[v].value.toString();return d}async getSnippetsFileContents(){const I={};let d;try{d=await this.fileService.resolve(this.snippetsFolder)}catch(v){if(v instanceof _.FileOperationError&&v.fileOperationResult===_.FileOperationResult.FILE_NOT_FOUND)return I;throw v}for(const v of d.children||[]){const t=v.resource,r=this.extUri.extname(t);if(r===".json"||r===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,t),i=await this.fileService.readFile(t);I[s]=i}}return I}};e.SnippetsSynchroniser=f,e.SnippetsSynchroniser=f=we([Q(2,k.IEnvironmentService),Q(3,_.IFileService),Q(4,T.IStorageService),Q(5,c.IUserDataSyncStoreService),Q(6,c.IUserDataSyncLocalStoreService),Q(7,c.IUserDataSyncLogService),Q(8,L.IConfigurationService),Q(9,c.IUserDataSyncEnablementService),Q(10,y.ITelemetryService),Q(11,P.IUriIdentityService)],f);let h=class extends u.AbstractInitializer{constructor(I,d,v,t,r,s){super(c.SyncResource.Snippets,d,v,t,I,r,s)}async doInitialize(I){const d=I.syncData?JSON.parse(I.syncData.content):null;if(!d){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(d)){const r=d[t];if(r){const s=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,t);await this.fileService.createFile(s,D.VSBuffer.fromString(r)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(I)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===_.FileOperationResult.FILE_NOT_FOUND}}};e.SnippetsInitializer=h,e.SnippetsInitializer=h=we([Q(0,_.IFileService),Q(1,S.IUserDataProfilesService),Q(2,k.IEnvironmentService),Q(3,c.IUserDataSyncLogService),Q(4,T.IStorageService),Q(5,P.IUriIdentityService)],h)}),define(le[125],ue([0,1,15,22,16,7,17,18,29,20,41,25]),function(ne,e,D,a,A,L,k,_,T,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=void 0,e.getTasksContentFromSyncContent=u;function u(f,h){try{return JSON.parse(f).tasks??null}catch(E){return h.error(E),null}}let p=class extends P.AbstractFileSynchroniser{constructor(h,E,I,d,v,t,r,s,i,n,o,l){super(h.tasksResource,{syncResource:S.SyncResource.Tasks,profile:h},E,s,i,n,I,d,r,o,v,t,l),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(h,E,I,d){const v=h.syncData?u(h.syncData.content,this.logService):null;E=E===null&&I?h:E;const t=E?.syncData?u(E.syncData.content,this.logService):null,r=await this.getLocalFileContent();let s=null,i=!1,n=!1,o=!1;if(h.syncData){const w=r?r.value.toString():null;if(!t||t!==w||t!==v){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const C=g(w,v,t);s=C.content,o=C.hasConflicts,i=C.hasLocalChanged,n=C.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=r.value.toString(),n=!0);const l={content:o?t:s,localChange:i?r?S.Change.Modified:S.Change.Added:S.Change.None,remoteChange:n?S.Change.Modified:S.Change.None,hasConflicts:o},m=r?r.value.toString():null;return[{fileContent:r,baseResource:this.baseResource,baseContent:t,localResource:this.localResource,localContent:m,localChange:l.localChange,remoteResource:this.remoteResource,remoteContent:v,remoteChange:l.remoteChange,previewResource:this.previewResource,previewResult:l,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const E=h?.syncData?u(h.syncData.content,this.logService):null;if(E===null)return!0;const I=await this.getLocalFileContent(),d=I?I.value.toString():null,v=g(d,E,E);return v.hasLocalChanged||v.hasRemoteChanged}async getMergeResult(h,E){return h.previewResult}async getAcceptResult(h,E,I,d){if(this.extUri.isEqual(E,this.localResource))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:S.Change.None,remoteChange:S.Change.Modified};if(this.extUri.isEqual(E,this.remoteResource))return{content:h.remoteContent,localChange:S.Change.Modified,remoteChange:S.Change.None};if(this.extUri.isEqual(E,this.previewResource))return I===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:I,localChange:S.Change.Modified,remoteChange:S.Change.Modified};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(h,E,I,d){const{fileContent:v}=I[0][0],{content:t,localChange:r,remoteChange:s}=I[0][1];if(r===S.Change.None&&s===S.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==S.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),v&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(v.value.toString()))),t?await this.updateLocalFileContent(t,v,d):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),s!==S.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(t));h=await this.updateRemoteUserData(i,d?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}E?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(h){return this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)?this.resolvePreviewContent(h):null}toTasksSyncContent(h){return h?{tasks:h}:{}}};e.TasksSynchroniser=p,e.TasksSynchroniser=p=we([Q(2,S.IUserDataSyncStoreService),Q(3,S.IUserDataSyncLocalStoreService),Q(4,S.IUserDataSyncLogService),Q(5,a.IConfigurationService),Q(6,S.IUserDataSyncEnablementService),Q(7,L.IFileService),Q(8,A.IEnvironmentService),Q(9,k.IStorageService),Q(10,_.ITelemetryService),Q(11,T.IUriIdentityService)],p);let c=class extends P.AbstractInitializer{constructor(h,E,I,d,v,t){super(S.SyncResource.Tasks,E,I,d,h,v,t),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(h){const E=h.syncData?u(h.syncData.content,this.logService):null;if(!E){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(E)),await this.updateLastSyncUserData(h)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=c,e.TasksInitializer=c=we([Q(0,L.IFileService),Q(1,y.IUserDataProfilesService),Q(2,A.IEnvironmentService),Q(3,S.IUserDataSyncLogService),Q(4,k.IStorageService),Q(5,T.IUriIdentityService)],c);function g(f,h,E){if(f===null&&h===null&&E===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(f===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const I=E!==f,d=E!==h;return!I&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:I&&!d?{content:f,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!I?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:f,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[126],ue([0,1,46,22,16,7,17,18,29,20,41,245,25]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0,e.stringifyLocalProfiles=c,e.parseUserDataProfilesManifest=g;let p=class extends P.AbstractSynchroniser{constructor(h,E,I,d,v,t,r,s,i,n,o,l,m){super({syncResource:u.SyncResource.Profiles,profile:h},E,d,v,t,r,s,o,l,i,n,m),this.userDataProfilesService=I,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(I.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?g(h.syncData):null}async getRemoteSyncedProfiles(h){const E=await this.getLastSyncUserData(),I=await this.getLatestRemoteUserData(h,E);return I?.syncData?g(I.syncData):null}async generateSyncPreview(h,E,I){if(!this.userDataProfilesService.isEnabled())throw new u.UserDataSyncError("Cannot sync profiles because they are disabled",u.UserDataSyncErrorCode.LocalError);const d=h.syncData?g(h.syncData):null,v=E?.syncData?g(E.syncData):null,t=this.getLocalUserDataProfiles(),{local:r,remote:s}=(0,S.merge)(t,d,v,[]),i={local:r,remote:s,content:v?this.stringifyRemoteProfiles(v):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:s!==null?u.Change.Modified:u.Change.None},n=c(t,!1);return[{baseResource:this.baseResource,baseContent:v?this.stringifyRemoteProfiles(v):null,localResource:this.localResource,localContent:n,remoteResource:this.remoteResource,remoteContent:d?this.stringifyRemoteProfiles(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const E=h?.syncData?g(h.syncData):null,I=this.getLocalUserDataProfiles(),{remote:d}=(0,S.merge)(I,E,E,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async getMergeResult(h,E){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,E,I,d){if(this.extUri.isEqual(E,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(E,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(E,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${E.toString()}`)}async acceptLocal(h){const E=this.getLocalUserDataProfiles(),I=(0,S.merge)(E,null,null,[]),{local:d,remote:v}=I;return{content:h.localContent,local:d,remote:v,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:v!==null?u.Change.Modified:u.Change.None}}async acceptRemote(h){const E=h.remoteContent?JSON.parse(h.remoteContent):null,I=[],d=[];for(const v of this.getLocalUserDataProfiles()){const t=E?.find(r=>r.id===v.id);t&&(I.push({id:v.id,name:v.name,collection:t.collection}),d.push(v))}if(E!==null){const v=(0,S.merge)(d,E,I,[]),{local:t,remote:r}=v;return{content:h.remoteContent,local:t,remote:r,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:r!==null?u.Change.Modified:u.Change.None}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:u.Change.None,remoteChange:u.Change.None}}async applyResult(h,E,I,d){const{local:v,remote:t,localChange:r,remoteChange:s}=I[0][1];r===u.Change.None&&s===u.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const i=I[0][0].remoteProfiles||[];if(i.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new u.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.",u.UserDataSyncErrorCode.LocalTooManyProfiles);if(r!==u.Change.None&&(await this.backupLocal(c(this.getLocalUserDataProfiles(),!1)),await Promise.all(v.removed.map(async n=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${n.name}' profile...`),await this.userDataProfilesService.removeProfile(n),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${n.name}'.`)})),await Promise.all(v.added.map(async n=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${n.name}' profile...`),await this.userDataProfilesService.createProfile(n.id,n.name,{shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${n.name}'.`)})),await Promise.all(v.updated.map(async n=>{const o=this.userDataProfilesService.profiles.find(l=>l.id===n.id);o?(this.logService.trace(`${this.syncResourceLogLabel}: Updating '${n.name}' profile...`),await this.userDataProfilesService.updateProfile(o,{name:n.name,shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${n.name}'.`)):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${n.id}' to update.`)}))),s!==u.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const n=[],o=i.length+(t?.added.length??0)<=20;if(o)for(const l of t?.added||[]){const m=await this.userDataSyncStoreService.createCollection(this.syncHeaders);n.push(m),i.push({id:l.id,name:l.name,collection:m,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const l of t?.removed||[])i.splice(i.findIndex(({id:m})=>l.id===m),1);for(const l of t?.updated||[]){const m=i.find(({id:w})=>l.id===w);m&&i.splice(i.indexOf(m),1,{...m,id:l.id,name:l.name,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags})}try{h=await this.updateRemoteProfiles(i,d?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(l=>l.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(l=>l.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(l=>l.name))}.`:""}`)}catch(l){if(n.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const m of n)await this.userDataSyncStoreService.deleteCollection(m,this.syncHeaders)}throw l}for(const l of t?.removed||[])await this.userDataSyncStoreService.deleteCollection(l.collection,this.syncHeaders)}E?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,E){return this.updateRemoteUserData(this.stringifyRemoteProfiles(h),E)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(h){if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)){const E=await this.resolvePreviewContent(h);return E&&(0,D.toFormattedString)(JSON.parse(E),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(h=>!h.isDefault&&!h.isTransient)}stringifyRemoteProfiles(h){return JSON.stringify([...h].sort((E,I)=>E.name.localeCompare(I.name)))}};e.UserDataProfilesManifestSynchroniser=p,e.UserDataProfilesManifestSynchroniser=p=we([Q(2,y.IUserDataProfilesService),Q(3,L.IFileService),Q(4,A.IEnvironmentService),Q(5,k.IStorageService),Q(6,u.IUserDataSyncStoreService),Q(7,u.IUserDataSyncLocalStoreService),Q(8,u.IUserDataSyncLogService),Q(9,a.IConfigurationService),Q(10,u.IUserDataSyncEnablementService),Q(11,_.ITelemetryService),Q(12,T.IUriIdentityService)],p);function c(f,h){const E=[...f].sort((I,d)=>I.name.localeCompare(d.name)).map(I=>({id:I.id,name:I.name}));return h?(0,D.toFormattedString)(E,{}):JSON.stringify(E)}function g(f){return JSON.parse(f.content)}}),define(le[264],ue([0,1,3,2,5,16,17,18,25]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const y="sync.enable";let P=class extends a.Disposable{constructor(u,p,c,g){super(),this.storageService=u,this.telemetryService=p,this.environmentService=c,this.userDataSyncStoreManagementService=g,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(u.onDidChangeValue(k.StorageScope.APPLICATION,void 0,this._register(new a.DisposableStore))(f=>this.onDidStorageChange(f)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(y,k.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(y,{enabled:u}),this.storageService.store(y,u,k.StorageScope.APPLICATION,k.StorageTarget.MACHINE))}isResourceEnabled(u){return this.storageService.getBoolean((0,T.getEnablementKey)(u),k.StorageScope.APPLICATION,!0)}setResourceEnablement(u,p){if(this.isResourceEnabled(u)!==p){const c=(0,T.getEnablementKey)(u);this.storeResourceEnablement(c,p)}}getResourceSyncStateVersion(u){}storeResourceEnablement(u,p){this.storageService.store(u,p,k.StorageScope.APPLICATION,A.isWeb?k.StorageTarget.USER:k.StorageTarget.MACHINE)}onDidStorageChange(u){if(y===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const p=T.ALL_SYNC_RESOURCES.filter(c=>(0,T.getEnablementKey)(c)===u.key)[0];if(p){this._onDidChangeResourceEnablement.fire([p,this.isResourceEnabled(p)]);return}}};e.UserDataSyncEnablementService=P,e.UserDataSyncEnablementService=P=we([Q(0,k.IStorageService),Q(1,_.ITelemetryService),Q(2,L.IEnvironmentService),Q(3,T.IUserDataSyncStoreManagementService)],P)}),define(le[265],ue([0,1,6,15,67,2,21,22,16,7,20,25]),function(ne,e,D,a,A,L,k,_,T,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLocalStoreService=void 0;let u=class extends L.Disposable{constructor(c,g,f,h,E){super(),this.environmentService=c,this.fileService=g,this.configurationService=f,this.logService=h,this.userDataProfilesService=E,this.cleanUp()}async cleanUp(){for(const g of this.userDataProfilesService.profiles)for(const f of S.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(f,g.isDefault?void 0:g.id))}catch(h){this.logService.error(h)}let c;try{c=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(g){(0,y.toFileOperationResult)(g)!==y.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(g);return}if(c.children){for(const g of c.children)if(g.isDirectory&&!this.userDataProfilesService.profiles.some(f=>f.id===g.name))try{this.logService.info("Deleting non existing profile from backup",g.resource.path),await this.fileService.del(g.resource,{recursive:!0})}catch(f){this.logService.error(f)}}}async getAllResourceRefs(c,g,f){const h=this.getResourceBackupHome(c,g,f);try{const E=await this.fileService.resolve(h);if(E.children)return E.children.filter(d=>d.isFile&&!d.name.startsWith("lastSync")).sort().reverse().map(d=>({ref:d.name,created:this.getCreationTime(d)}))}catch(E){if((0,y.toFileOperationResult)(E)!==y.FileOperationResult.FILE_NOT_FOUND)throw E}return[]}async resolveResourceContent(c,g,f,h){const E=this.getResourceBackupHome(c,f,h),I=(0,k.joinPath)(E,g);try{return(await this.fileService.readFile(I)).value.toString()}catch(d){return this.logService.error(d),null}}async writeResource(c,g,f,h,E){const I=this.getResourceBackupHome(c,h,E),d=(0,k.joinPath)(I,`${(0,A.toLocalISOString)(f).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(d,a.VSBuffer.fromString(g))}catch(v){this.logService.error(v)}}getResourceBackupHome(c,g,f=this.environmentService.userDataSyncHome){return(0,k.joinPath)(f,...g?[g,c]:[c])}async cleanUpBackup(c){try{try{if(!await this.fileService.exists(c))return}catch{return}const g=await this.fileService.resolve(c);if(g.children){const f=g.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),h=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let E=f.filter(d=>Date.now()-this.getCreationTime(d)>h);const I=f.length-E.length;I<10&&(E=E.slice(10-I)),await D.Promises.settled(E.map(async d=>{this.logService.info("Deleting from backup",d.resource.path),await this.fileService.del(d.resource)}))}}catch(g){this.logService.error(g)}}getCreationTime(c){return new Date(parseInt(c.name.substring(0,4)),parseInt(c.name.substring(4,6))-1,parseInt(c.name.substring(6,8)),parseInt(c.name.substring(9,11)),parseInt(c.name.substring(11,13)),parseInt(c.name.substring(13,15))).getTime()}};e.UserDataSyncLocalStoreService=u,e.UserDataSyncLocalStoreService=u=we([Q(0,T.IEnvironmentService),Q(1,y.IFileService),Q(2,_.IConfigurationService),Q(3,S.IUserDataSyncLogService),Q(4,P.IUserDataProfilesService)],u)}),define(le[87],ue([0,1,3,2,5,27,187,16,7,4,24,50,17,25]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.isWebPlatform=v,e.IUserDataSyncMachinesService=(0,y.createDecorator)("IUserDataSyncMachinesService");const g="sync.currentMachineName",f="Safari",h="Chrome",E="Edge",I="Firefox",d="Android";function v(s){switch(s){case f:case h:case E:case I:case d:case(0,A.PlatformToString)(A.Platform.Web):return!0}return!1}function t(){return A.isSafari?f:A.isChrome?h:A.isEdge?E:A.isFirefox?I:A.isAndroid?d:(0,A.PlatformToString)(A.isWeb?A.Platform.Web:A.platform)}let r=class extends a.Disposable{static{c=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(i,n,o,l,m,w){super(),this.storageService=o,this.userDataSyncStoreService=l,this.logService=m,this.productService=w,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,S.getServiceMachineId)(i,n,o)}async getMachines(i){const n=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(l=>({...l,isCurrent:l.id===n}))}async addCurrentMachine(i){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(i);o.machines.some(({id:l})=>l===n)||(o.machines.push({id:n,name:this.computeCurrentMachineName(o.machines),platform:t()}),await this.writeMachinesData(o))}async removeCurrentMachine(i){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(i),l=o.machines.filter(({id:m})=>m!==n);l.length!==o.machines.length&&(o.machines=l,await this.writeMachinesData(o))}async renameMachine(i,n,o){const l=await this.readMachinesData(o),m=l.machines.find(({id:w})=>w===i);if(m){m.name=n,await this.writeMachinesData(l);const w=await this.currentMachineIdPromise;i===w&&this.storageService.store(g,n,u.StorageScope.APPLICATION,u.StorageTarget.MACHINE)}}async setEnablements(i){const n=await this.readMachinesData();for(const[o,l]of i){const m=n.machines.find(w=>w.id===o);m&&(m.disabled=l?void 0:!0)}await this.writeMachinesData(n)}computeCurrentMachineName(i){const n=this.storageService.get(g,u.StorageScope.APPLICATION);if(n)return n;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${t()} (${this.productService.nameShort})`,l=new RegExp(`${(0,L.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let m=0;for(const w of i){const C=l.exec(w.name),b=C?parseInt(C[1]):0;m=b>m?b:m}return`${o} #${m+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const n=this.parse(this.userData);if(n.version!==c.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return n}async writeMachinesData(i){const n=JSON.stringify(i),o=await this.userDataSyncStoreService.writeResource(c.RESOURCE,n,this.userData?.ref||null);this.userData={ref:o,content:n},this._onDidChange.fire()}async readUserData(i){if(this.userData){const n=i&&i.latest?i.latest[c.RESOURCE]:void 0;if(this.userData.ref===n)return this.userData;if(n===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(c.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.logService.error(n)}return{version:c.VERSION,machines:[]}}};e.UserDataSyncMachinesService=r,e.UserDataSyncMachinesService=r=c=we([Q(0,_.IEnvironmentService),Q(1,T.IFileService),Q(2,u.IStorageService),Q(3,p.IUserDataSyncStoreService),Q(4,p.IUserDataSyncLogService),Q(5,P.IProductService)],r)}),define(le[266],ue([0,1,6,67,40,8,3,2,5,21,9,184,24,17,18,25,83,87]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const E="sync.disableMachineEventually",I="sync.sessionId",d="sync.storeUrl",v="sync.productQuality";let t=class extends _.Disposable{get syncUrl(){const i=this.storageService.get(d,p.StorageScope.APPLICATION);return i?P.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(d,i.toString(),p.StorageScope.APPLICATION,p.StorageTarget.MACHINE):this.storageService.remove(d,p.StorageScope.APPLICATION)}get productQuality(){return this.storageService.get(v,p.StorageScope.APPLICATION)}set productQuality(i){i?this.storageService.store(v,i,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE):this.storageService.remove(v,p.StorageScope.APPLICATION)}constructor(i,n,o,l,m,w,C,b,R,U){super(),this.userDataSyncStoreManagementService=n,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=l,this.userDataSyncService=m,this.logService=w,this.userDataSyncAccountService=C,this.telemetryService=b,this.userDataSyncMachinesService=R,this.storageService=U,this.autoSync=this._register(new _.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=n.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(n.onDidChangeUserDataSyncStore(()=>{(0,y.isEqual)(this.syncUrl,n.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=n.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(C.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(m.onDidChangeLocal(N=>this.triggerSync([N],!1,!1))),this._register(k.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,N])=>N)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:i,message:n}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(n&&this.logService.info(n),this.autoSync.clear()):n&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(n))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,n,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(I,p.StorageScope.APPLICATION),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(l){if(this.logService.error(l),n)this.updateEnablement(!1);else throw l}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const n=g.UserDataSyncError.toUserDataSyncError(i);n instanceof g.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:n.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),n.code===g.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):n.code===g.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):n.code===g.UserDataSyncErrorCode.LocalTooManyRequests?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):n.code===g.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):n.code===g.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):n.code===g.UserDataSyncErrorCode.UpgradeRequired||n.code===g.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):n.code===g.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${n.resource} content with newer version than of client. Requires client upgrade.`)):n.code===g.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${n.resource} content with older version than of client. Requires server reset.`)):n.code===g.UserDataSyncErrorCode.ServiceChanged||n.code===g.UserDataSyncErrorCode.DefaultServiceChanged?T.isWeb&&n.code===g.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(n),this.successiveFailures++),this._onError.fire(n)}async disableMachineEventually(){this.storageService.store(E,!0,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),await(0,D.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(E,p.StorageScope.APPLICATION,!1)}stopDisableMachineEventually(){this.storageService.remove(E,p.StorageScope.APPLICATION)}async triggerSync(i,n,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(n&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const l=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:l}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=t,e.UserDataAutoSyncService=t=we([Q(0,u.IProductService),Q(1,g.IUserDataSyncStoreManagementService),Q(2,g.IUserDataSyncStoreService),Q(3,g.IUserDataSyncEnablementService),Q(4,g.IUserDataSyncService),Q(5,g.IUserDataSyncLogService),Q(6,f.IUserDataSyncAccountService),Q(7,c.ITelemetryService),Q(8,h.IUserDataSyncMachinesService),Q(9,p.IStorageService)],t);class r extends _.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(i,n,o,l,m,w,C,b,R){super(),this.lastSyncUrl=i,this.interval=n,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=l,this.userDataSyncService=m,this.userDataSyncMachinesService=w,this.logService=C,this.telemetryService=b,this.storageService=R,this.intervalHandler=this._register(new _.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,_.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>{this.sync(r.INTERVAL_SYNCING,!1),this.intervalHandler.value=void 0},this.interval)}sync(i,n){const o=(0,D.createCancelablePromise)(async l=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(m){if((0,L.isCancellationError)(m))return}return this.doSync(i,n,l)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,y.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),n=this.userDataSyncStoreManagementService.userDataSyncStore;return!!n&&!!i&&(!(0,y.isEqual)(n.defaultUrl,i.defaultUrl)||!(0,y.isEqual)(n.insidersUrl,i.insidersUrl)||!(0,y.isEqual)(n.stableUrl,i.stableUrl))}async doSync(i,n,o){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let l;try{await this.createAndRunSyncTask(n,o)}catch(m){if(this.logService.error(m),l=m,g.UserDataSyncError.toUserDataSyncError(m).code===g.UserDataSyncErrorCode.MethodNotFound)try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(n,o),l=void 0}catch(w){this.logService.error(w),l=w}}this._onDidFinishSync.fire(l)}async createAndRunSyncTask(i,n){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,i),n.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,S.localize)(0,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.UserDataAutoSyncError((0,S.localize)(1,null),g.UserDataSyncErrorCode.ServiceChanged):new g.UserDataAutoSyncError((0,S.localize)(2,null),g.UserDataSyncErrorCode.TurnedOff);const o=this.storageService.get(I,p.StorageScope.APPLICATION);if(o&&this.manifest&&o!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,S.localize)(3,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.UserDataAutoSyncError((0,S.localize)(4,null),g.UserDataSyncErrorCode.ServiceChanged):new g.UserDataAutoSyncError((0,S.localize)(5,null),g.UserDataSyncErrorCode.SessionExpired);const l=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(n.isCancellationRequested)return;const m=l.find(C=>C.isCurrent);if(m?.disabled)throw new g.UserDataAutoSyncError((0,S.localize)(6,null),g.UserDataSyncErrorCode.TurnedOff);const w=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-w}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(C){throw new g.UserDataAutoSyncError((0,A.toErrorMessage)(C),C instanceof g.UserDataSyncError?C.code:g.UserDataSyncErrorCode.Unknown)}this.manifest&&this.manifest.session!==o&&this.storageService.store(I,this.manifest.session,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),!n.isCancellationRequested&&(m||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(i){return super._register(i)}}}),define(le[267],ue([0,1,9,188,16,7,50,17,29,25,20,41,124,123,122,22,125,120,121,4,126,46,27]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d,v,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let s=class{static{r=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(n,o,l,m,w,C,b,R,U,N){this.userDataSyncStoreService=n,this.userDataSyncLocalStoreService=o,this.logService=l,this.environmentService=w,this.storageService=C,this.fileService=b,this.userDataProfilesService=R,this.configurationService=U,this.instantiationService=N,this.extUri=m.extUri}async getRemoteSyncedProfiles(){const n=await this.userDataSyncStoreService.readResource(y.SyncResource.Profiles,null,void 0);if(n.content){const o=this.parseSyncData(n.content,y.SyncResource.Profiles);return(0,d.parseUserDataProfilesManifest)(o)}return[]}async getLocalSyncedProfiles(n){const o=await this.userDataSyncLocalStoreService.getAllResourceRefs(y.SyncResource.Profiles,void 0,n);if(o.length){const l=await this.userDataSyncLocalStoreService.resolveResourceContent(y.SyncResource.Profiles,o[0].ref,void 0,n);if(l){const m=this.parseSyncData(l,y.SyncResource.Profiles);return(0,d.parseUserDataProfilesManifest)(m)}}return[]}async getLocalSyncedMachines(n){const o=await this.userDataSyncLocalStoreService.getAllResourceRefs("machines",void 0,n);if(o.length){const l=await this.userDataSyncLocalStoreService.resolveResourceContent("machines",o[0].ref,void 0,n);if(l)return JSON.parse(l).machines.map(w=>({...w,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(n,o){return(await this.userDataSyncStoreService.getAllResourceRefs(n,o?.collection)).map(({created:m,ref:w})=>({created:m,uri:this.toUri({remote:!0,syncResource:n,profile:o?.id??this.userDataProfilesService.defaultProfile.id,location:void 0,collection:o?.collection,ref:w,node:void 0})}))}async getLocalSyncResourceHandles(n,o,l){return(await this.userDataSyncLocalStoreService.getAllResourceRefs(n,o?.collection,l)).map(({created:w,ref:C})=>({created:w,uri:this.toUri({remote:!1,syncResource:n,profile:o?.id??this.userDataProfilesService.defaultProfile.id,collection:o?.collection,ref:C,node:void 0,location:l})}))}resolveUserDataSyncResource({uri:n}){const o=this.resolveUri(n),l=o?this.userDataProfilesService.profiles.find(m=>m.id===o.profile):void 0;return o&&l?{profile:l,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:n}){const o=this.resolveUri(n);if(!o)return[];const l=this.userDataProfilesService.profiles.find(m=>m.id===o.profile);switch(o.syncResource){case y.SyncResource.Settings:return this.getSettingsAssociatedResources(n,l);case y.SyncResource.Keybindings:return this.getKeybindingsAssociatedResources(n,l);case y.SyncResource.Tasks:return this.getTasksAssociatedResources(n,l);case y.SyncResource.Snippets:return this.getSnippetsAssociatedResources(n,l);case y.SyncResource.GlobalState:return this.getGlobalStateAssociatedResources(n,l);case y.SyncResource.Extensions:return this.getExtensionsAssociatedResources(n,l);case y.SyncResource.Profiles:return this.getProfilesAssociatedResources(n,l);case y.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:n}){const o=this.resolveUri(n);if(o){if(o.remote){if(o.ref){const{content:l}=await this.getUserData(o.syncResource,o.ref,o.collection);if(l)return this.parseSyncData(l,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const l=await this.userDataSyncLocalStoreService.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(l)return this.parseSyncData(l,o.syncResource)?.machineId}return}return(0,k.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(n){const o=this.resolveUri(n);if(!o||o.node===r.NOT_EXISTING_RESOURCE)return null;if(o.ref){const l=await this.getContentFromStore(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&l?this.resolveNodeContent(o.syncResource,l,o.node):l}return!o.remote&&!o.node?this.resolveLatestContent(o.syncResource,o.profile):null}async getContentFromStore(n,o,l,m,w){if(n){const{content:C}=await this.getUserData(o,m,l);return C}return this.userDataSyncLocalStoreService.resolveResourceContent(o,m,l,w)}resolveNodeContent(n,o,l){const m=this.parseSyncData(o,n);switch(n){case y.SyncResource.Settings:return this.resolveSettingsNodeContent(m,l);case y.SyncResource.Keybindings:return this.resolveKeybindingsNodeContent(m,l);case y.SyncResource.Tasks:return this.resolveTasksNodeContent(m,l);case y.SyncResource.Snippets:return this.resolveSnippetsNodeContent(m,l);case y.SyncResource.GlobalState:return this.resolveGlobalStateNodeContent(m,l);case y.SyncResource.Extensions:return this.resolveExtensionsNodeContent(m,l);case y.SyncResource.Profiles:return this.resolveProfileNodeContent(m,l);case y.SyncResource.WorkspaceState:return null}}async resolveLatestContent(n,o){const l=this.userDataProfilesService.profiles.find(m=>m.id===o);if(!l)return null;switch(n){case y.SyncResource.GlobalState:return this.resolveLatestGlobalStateContent(l);case y.SyncResource.Extensions:return this.resolveLatestExtensionsContent(l);case y.SyncResource.Profiles:return this.resolveLatestProfilesContent(l);case y.SyncResource.Settings:return null;case y.SyncResource.Keybindings:return null;case y.SyncResource.Tasks:return null;case y.SyncResource.Snippets:return null;case y.SyncResource.WorkspaceState:return null}}getSettingsAssociatedResources(n,o){const l=this.extUri.joinPath(n,"settings.json"),m=o?o.settingsResource:this.extUri.joinPath(n,r.NOT_EXISTING_RESOURCE);return[{resource:l,comparableResource:m}]}resolveSettingsNodeContent(n,o){switch(o){case"settings.json":return(0,p.parseSettingsSyncContent)(n.content).settings}return null}getKeybindingsAssociatedResources(n,o){const l=this.extUri.joinPath(n,"keybindings.json"),m=o?o.keybindingsResource:this.extUri.joinPath(n,r.NOT_EXISTING_RESOURCE);return[{resource:l,comparableResource:m}]}resolveKeybindingsNodeContent(n,o){switch(o){case"keybindings.json":return(0,c.getKeybindingsContentFromSyncContent)(n.content,!!this.configurationService.getValue(y.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(n,o){const l=this.extUri.joinPath(n,"tasks.json"),m=o?o.tasksResource:this.extUri.joinPath(n,r.NOT_EXISTING_RESOURCE);return[{resource:l,comparableResource:m}]}resolveTasksNodeContent(n,o){switch(o){case"tasks.json":return(0,f.getTasksContentFromSyncContent)(n.content,this.logService)}return null}async getSnippetsAssociatedResources(n,o){const l=await this.resolveContent(n);if(l){const m=this.parseSyncData(l,y.SyncResource.Snippets);if(m){const w=(0,u.parseSnippets)(m),C=[];for(const b of Object.keys(w)){const R=this.extUri.joinPath(n,b),U=o?this.extUri.joinPath(o.snippetsHome,b):this.extUri.joinPath(n,r.NOT_EXISTING_RESOURCE);C.push({resource:R,comparableResource:U})}return C}}return[]}resolveSnippetsNodeContent(n,o){return(0,u.parseSnippets)(n)[o]||null}getExtensionsAssociatedResources(n,o){const l=this.extUri.joinPath(n,"extensions.json"),m=o?this.toUri({remote:!1,syncResource:y.SyncResource.Extensions,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(n,r.NOT_EXISTING_RESOURCE);return[{resource:l,comparableResource:m}]}resolveExtensionsNodeContent(n,o){switch(o){case"extensions.json":return(0,h.stringify)((0,h.parseExtensions)(n),!0)}return null}async resolveLatestExtensionsContent(n){const{localExtensions:o}=await this.instantiationService.createInstance(h.LocalExtensionsProvider).getLocalExtensions(n);return(0,h.stringify)(o,!0)}getGlobalStateAssociatedResources(n,o){const l=this.extUri.joinPath(n,"globalState.json"),m=o?this.toUri({remote:!1,syncResource:y.SyncResource.GlobalState,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(n,r.NOT_EXISTING_RESOURCE);return[{resource:l,comparableResource:m}]}resolveGlobalStateNodeContent(n,o){switch(o){case"globalState.json":return(0,E.stringify)(JSON.parse(n.content),!0)}return null}async resolveLatestGlobalStateContent(n){const o=await this.instantiationService.createInstance(E.LocalGlobalStateProvider).getLocalGlobalState(n);return(0,E.stringify)(o,!0)}getProfilesAssociatedResources(n,o){const l=this.extUri.joinPath(n,"profiles.json"),m=this.toUri({remote:!1,syncResource:y.SyncResource.Profiles,profile:this.userDataProfilesService.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:l,comparableResource:m}]}resolveProfileNodeContent(n,o){switch(o){case"profiles.json":return(0,v.toFormattedString)(JSON.parse(n.content),{})}return null}async resolveLatestProfilesContent(n){return(0,d.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}toUri(n){const o=n.remote?r.REMOTE_BACKUP_AUTHORITY:r.LOCAL_BACKUP_AUTHORITY,l=[];return n.location&&(l.push(`scheme:${n.location.scheme}`),l.push(`authority:${n.location.authority}`),l.push((0,t.trim)(n.location.path,"/"))),l.push(`syncResource:${n.syncResource}`),l.push(`profile:${n.profile}`),n.collection&&l.push(`collection:${n.collection}`),n.ref&&l.push(`ref:${n.ref}`),n.node&&l.push(n.node),this.extUri.joinPath(D.URI.from({scheme:y.USER_DATA_SYNC_SCHEME,authority:o,path:"/",query:n.location?.query,fragment:n.location?.fragment}),...l)}resolveUri(n){if(n.scheme!==y.USER_DATA_SYNC_SCHEME)return;const o=[];for(;n.path!=="/";)o.unshift(this.extUri.basename(n)),n=this.extUri.dirname(n);if(o.length<2)return;const l=n.authority===r.REMOTE_BACKUP_AUTHORITY;let m,w;const C=[];let b,R,U,N,M;for(;o.length;){const F=o.shift();F.startsWith("scheme:")?m=F.substring(7):F.startsWith("authority:")?w=F.substring(10):F.startsWith("syncResource:")?b=F.substring(13):F.startsWith("profile:")?R=F.substring(8):F.startsWith("collection:")?U=F.substring(11):F.startsWith("ref:")?N=F.substring(4):b?M=F:C.push(F)}return{remote:l,syncResource:b,profile:R,collection:U,ref:N,node:M,location:m&&w!==void 0?this.extUri.joinPath(D.URI.from({scheme:m,authority:w,query:n.query,fragment:n.fragment,path:"/"}),...C):void 0}}parseSyncData(n,o){try{const l=JSON.parse(n);if((0,S.isSyncData)(l))return l}catch(l){this.logService.error(l)}throw new y.UserDataSyncError((0,a.localize)(0,null),y.UserDataSyncErrorCode.IncompatibleRemoteContent,o)}async getUserData(n,o,l){const m=await this.userDataSyncStoreService.resolveResourceContent(n,o,l);return{ref:o,content:m}}};e.UserDataSyncResourceProviderService=s,e.UserDataSyncResourceProviderService=s=r=we([Q(0,y.IUserDataSyncStoreService),Q(1,y.IUserDataSyncLocalStoreService),Q(2,y.IUserDataSyncLogService),Q(3,T.IUriIdentityService),Q(4,A.IEnvironmentService),Q(5,_.IStorageService),Q(6,L.IFileService),Q(7,P.IUserDataProfilesService),Q(8,g.IConfigurationService),Q(9,I.IInstantiationService)],s)}),define(le[268],ue([0,1,19,6,26,40,3,2,21,13,32,22,28,7,4,17,18,20,120,121,122,123,124,125,126,25]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d,v,t,r,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let o=class extends _.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(b,R,U,N,M,F,K,H,X,j,ie){super(),this.fileService=b,this.userDataSyncStoreService=R,this.userDataSyncStoreManagementService=U,this.instantiationService=N,this.logService=M,this.telemetryService=F,this.storageService=K,this.userDataSyncEnablementService=H,this.userDataProfilesService=X,this.userDataSyncResourceProviderService=j,this.userDataSyncLocalStoreService=ie,this._status=i.SyncStatus.Uninitialized,this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=U.userDataSyncStore?i.SyncStatus.Idle:i.SyncStatus.Uninitialized,this._lastSyncTime=this.storageService.getNumber(n,g.StorageScope.APPLICATION,void 0),this._register((0,_.toDisposable)(()=>this.clearActiveProfileSynchronizers())),this._register(new a.RunOnceScheduler(()=>this.cleanUpStaleStorageData(),5*1e3)).schedule()}async createSyncTask(b,R){this.checkEnablement(),this.logService.info("Sync started.");const U=new Date().getTime(),N=(0,P.generateUuid)();try{const H=(0,i.createSyncHeaders)(N);R&&(H["Cache-Control"]="no-cache"),b=await this.userDataSyncStoreService.manifest(b,H)}catch(H){const X=i.UserDataSyncError.toUserDataSyncError(H);throw w(X,N,this.userDataSyncStoreManagementService,this.telemetryService),X}const M=!1,F=this;let K;return{manifest:b,async run(){if(M)throw new Error("Can run a task only once");K=(0,a.createCancelablePromise)(H=>F.sync(b,!1,N,H)),await K.finally(()=>K=void 0),F.logService.info(`Sync done. Took ${new Date().getTime()-U}ms`),F.updateLastSyncTime()},stop(){return K?.cancel(),F.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new i.UserDataSyncError("Cannot start manual sync when sync is enabled",i.UserDataSyncErrorCode.LocalError);this.logService.info("Sync started.");const b=new Date().getTime(),R=(0,P.generateUuid)(),U=(0,i.createSyncHeaders)(R);let N;try{N=await this.userDataSyncStoreService.manifest(null,U)}catch(K){const H=i.UserDataSyncError.toUserDataSyncError(K);throw w(H,R,this.userDataSyncStoreManagementService,this.telemetryService),H}await this.resetLocal();const M=this,F=new A.CancellationTokenSource;return{id:R,async merge(){return M.sync(N,!0,R,F.token)},async apply(){try{try{await M.applyManualSync(N,R,F.token)}catch(K){if(i.UserDataSyncError.toUserDataSyncError(K).code===i.UserDataSyncErrorCode.MethodNotFound)M.logService.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.logService.info("Applying manual sync again..."),await M.applyManualSync(N,R,F.token);else throw K}}catch(K){throw M.logService.error(K),K}M.logService.info(`Sync done. Took ${new Date().getTime()-b}ms`),M.updateLastSyncTime()},async stop(){F.cancel(),await M.stop(),await M.resetLocal()}}}async sync(b,R,U,N){this._syncErrors=[];try{this.status!==i.SyncStatus.HasConflicts&&this.setStatus(i.SyncStatus.Syncing);const M=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(M,b,R,U,N));const F=M.enabled.find(K=>K.resource===i.SyncResource.Profiles);if(F){const K=await F.getLastSyncedProfiles()||[];if(N.isCancellationRequested)return;await this.syncRemoteProfiles(K,b,R,U,N)}}finally{this.status!==i.SyncStatus.HasConflicts&&this.setStatus(i.SyncStatus.Idle),this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(b,R,U,N,M){for(const F of b){if(M.isCancellationRequested)return;const K=this.userDataProfilesService.profiles.find(X=>X.id===F.id);if(!K){this.logService.error(`Profile with id:${F.id} and name: ${F.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",F.name);const H=this.getOrCreateActiveProfileSynchronizer(K,F);this._syncErrors.push(...await this.syncProfile(H,R,U,N,M))}for(const[F,K]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(H=>H.id===K[0].profile.id)||(await K[0].resetLocal(),K[1].dispose(),this.activeProfileSynchronizers.delete(F))}async applyManualSync(b,R,U){const N=this.getActiveProfileSynchronizers();for(const X of N){if(U.isCancellationRequested)return;await X.apply(R,U)}const M=N.find(X=>X.profile.isDefault);if(!M)return;const F=M.enabled.find(X=>X.resource===i.SyncResource.Profiles);if(!F)return;const H=(await F.getRemoteSyncedProfiles(b?.latest??null)||[]).filter(X=>N.every(j=>j.profile.id!==X.id));H.length&&await this.syncRemoteProfiles(H,b,!1,R,U)}async syncProfile(b,R,U,N,M){return(await b.sync(R,U,N,M)).map(([K,H])=>({profile:b.profile,syncResource:K,error:H}))}async stop(){this.status!==i.SyncStatus.Idle&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(b=>b.stop()))}async resolveContent(b){const R=await this.userDataSyncResourceProviderService.resolveContent(b);if(R)return R;for(const U of this.getActiveProfileSynchronizers())for(const N of U.enabled){const M=await N.resolveContent(b);if(M)return M}return null}async replace(b){this.checkEnablement();const R=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(b);if(!R)return;const U=await this.resolveContent(b.uri);U&&await this.performAction(R.profile,async N=>{if(R.syncResource===N.resource)return await N.replace(U),!0})}async accept(b,R,U,N){this.checkEnablement(),await this.performAction(b.profile,async M=>{if(b.syncResource===M.resource)return await M.accept(R,U),N&&await M.apply((0,y.isBoolean)(N)?!1:N.force,(0,i.createSyncHeaders)((0,P.generateUuid)())),!0})}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async R=>{if(R.resource!==i.SyncResource.GlobalState&&await R.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async R=>{if(await R.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(b){this.logService.error(b)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(n,g.StorageScope.APPLICATION);for(const[b]of this.activeProfileSynchronizers.values())try{await b.resetLocal()}catch(R){this.logService.error(R)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpStaleStorageData(){const b=this.storageService.keys(g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),R=[];for(const N of b){if(!N.endsWith(".lastSyncUserData"))continue;const M=N.split(".");M.length===3&&R.push([N,M[0]])}if(!R.length)return;const U=new _.DisposableStore;try{let N=this.activeProfileSynchronizers.get(this.userDataProfilesService.defaultProfile.id)?.[0];N||(N=U.add(this.instantiationService.createInstance(l,this.userDataProfilesService.defaultProfile,void 0)));const M=N.enabled.find(H=>H.resource===i.SyncResource.Profiles);if(!M)return;const K=(await M.getLastSyncedProfiles())?.map(H=>H.collection)??[];for(const[H,X]of R)K.includes(X)||(this.logService.info(`Removing last sync state for stale profile: ${X}`),this.storageService.remove(H,g.StorageScope.APPLICATION))}finally{U.dispose()}}async cleanUpRemoteData(){const b=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),R=b.map(F=>F.collection),U=await this.userDataSyncStoreService.getAllCollections(),N=U.filter(F=>!R.includes(F));N.length&&(this.logService.info(`Deleting ${N.length} redundant collections on server`),await Promise.allSettled(N.map(F=>this.userDataSyncStoreService.deleteCollection(F))),this.logService.info("Deleted redundant collections on server"));const M=b.filter(F=>U.includes(F.collection));if(M.length!==b.length){const F=this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await F.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await F.updateRemoteProfiles(M,null),this.logService.info("Updated remote profiles on server")}finally{F.dispose()}}}async saveRemoteActivityData(b){this.checkEnablement();const R=await this.userDataSyncStoreService.getActivityData();await this.fileService.writeFile(b,R)}async extractActivityData(b,R){const U=(await this.fileService.readFile(b)).value.toString(),N=JSON.parse(U);if(N.resources)for(const M in N.resources)for(const F of N.resources[M])await this.userDataSyncLocalStoreService.writeResource(M,F.content,new Date(F.created*1e3),void 0,R);if(N.collections)for(const M in N.collections)for(const F in N.collections[M].resources)for(const K of N.collections[M].resources?.[F]??[])await this.userDataSyncLocalStoreService.writeResource(F,K.content,new Date(K.created*1e3),M,R)}async performAction(b,R){const U=new _.DisposableStore;try{const N=this.activeProfileSynchronizers.get(b.id);if(N){const X=await this.performActionWithProfileSynchronizer(N[0],R,U);return(0,y.isUndefined)(X)?null:X}if(b.isDefault){const X=U.add(this.instantiationService.createInstance(l,b,void 0)),j=await this.performActionWithProfileSynchronizer(X,R,U);return(0,y.isUndefined)(j)?null:j}if(this.userDataProfilesService.isEnabled())return null;const M=U.add(this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,b,void 0)),F=await this.userDataSyncStoreService.manifest(null),H=(await M.getRemoteSyncedProfiles(F?.latest??null)||[]).find(X=>X.id===b.id);if(H){const X=U.add(this.instantiationService.createInstance(l,b,H.collection)),j=await this.performActionWithProfileSynchronizer(X,R,U);return(0,y.isUndefined)(j)?null:j}return null}finally{U.dispose()}}async performActionWithProfileSynchronizer(b,R,U){const N=[...b.enabled,...b.disabled.reduce((M,F)=>(F!==i.SyncResource.WorkspaceState&&M.push(U.add(b.createSynchronizer(F))),M),[])];for(const M of N){const F=await R(M);if(!(0,y.isUndefined)(F))return F}}setStatus(b){const R=this._status;this._status!==b&&(this._status=b,this._onDidChangeStatus.fire(b),R===i.SyncStatus.HasConflicts&&this.updateLastSyncTime())}updateConflicts(){const b=this.getActiveProfileSynchronizers().map(R=>R.conflicts).flat();(0,D.equals)(this._conflicts,b,(R,U)=>R.profile.id===U.profile.id&&R.syncResource===U.syncResource&&(0,D.equals)(R.conflicts,U.conflicts,(N,M)=>(0,T.isEqual)(N.previewResource,M.previewResource)))||(this._conflicts=b,this._onDidChangeConflicts.fire(b))}updateLastSyncTime(){this.status===i.SyncStatus.Idle&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(n,this._lastSyncTime,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(b,R){let U=this.activeProfileSynchronizers.get(b.id);if(U&&U[0].collection!==R?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),U[1].dispose(),U=void 0,this.activeProfileSynchronizers.delete(b.id)),!U){const N=new _.DisposableStore,M=N.add(this.instantiationService.createInstance(l,b,R?.collection));N.add(M.onDidChangeStatus(F=>this.setStatus(F))),N.add(M.onDidChangeConflicts(F=>this.updateConflicts())),N.add(M.onDidChangeLocal(F=>this._onDidChangeLocal.fire(F))),this.activeProfileSynchronizers.set(b.id,U=[M,N])}return U[0]}getActiveProfileSynchronizers(){const b=[];for(const[R]of this.activeProfileSynchronizers.values())b.push(R);return b}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,b])=>b.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=o,e.UserDataSyncService=o=we([Q(0,p.IFileService),Q(1,i.IUserDataSyncStoreService),Q(2,i.IUserDataSyncStoreManagementService),Q(3,c.IInstantiationService),Q(4,i.IUserDataSyncLogService),Q(5,f.ITelemetryService),Q(6,g.IStorageService),Q(7,i.IUserDataSyncEnablementService),Q(8,h.IUserDataProfilesService),Q(9,i.IUserDataSyncResourceProviderService),Q(10,i.IUserDataSyncLocalStoreService)],o);let l=class extends _.Disposable{get enabled(){return this._enabled.sort((b,R)=>b[1]-R[1]).map(([b])=>b)}get disabled(){return i.ALL_SYNC_RESOURCES.filter(b=>!this.userDataSyncEnablementService.isResourceEnabled(b))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(b,R,U,N,M,F,K,H,X,j){super(),this.profile=b,this.collection=R,this.userDataSyncEnablementService=U,this.instantiationService=N,this.extensionGalleryService=M,this.userDataSyncStoreManagementService=F,this.telemetryService=K,this.logService=H,this.userDataProfilesService=X,this.configurationService=j,this._enabled=[],this._status=i.SyncStatus.Idle,this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(U.onDidChangeResourceEnablement(([ie,z])=>this.onDidChangeResourceEnablement(ie,z))),this._register((0,_.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,ie])=>ie.dispose())));for(const ie of i.ALL_SYNC_RESOURCES)U.isResourceEnabled(ie)&&this.registerSynchronizer(ie)}onDidChangeResourceEnablement(b,R){R?this.registerSynchronizer(b):this.deRegisterSynchronizer(b)}registerSynchronizer(b){if(this._enabled.some(([M])=>M.resource===b))return;if(b===i.SyncResource.Extensions&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(b===i.SyncResource.Profiles&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||b===i.SyncResource.WorkspaceState)return;if(b!==i.SyncResource.Profiles&&this.profile.useDefaultFlags?.[b]){this.logService.debug(`Skipping syncing ${b} in ${this.profile.name} because it is already synced by default profile`);return}const R=new _.DisposableStore,U=R.add(this.createSynchronizer(b));R.add(U.onDidChangeStatus(()=>this.updateStatus())),R.add(U.onDidChangeConflicts(()=>this.updateConflicts())),R.add(U.onDidChangeLocal(()=>this._onDidChangeLocal.fire(b)));const N=this.getOrder(b);this._enabled.push([U,N,R])}deRegisterSynchronizer(b){const R=this._enabled.findIndex(([U])=>U.resource===b);if(R!==-1){const[[U,,N]]=this._enabled.splice(R,1);N.dispose(),this.updateStatus(),Promise.allSettled([U.stop(),U.resetLocal()]).then(null,M=>this.logService.error(M))}}createSynchronizer(b){switch(b){case i.SyncResource.Settings:return this.instantiationService.createInstance(v.SettingsSynchroniser,this.profile,this.collection);case i.SyncResource.Keybindings:return this.instantiationService.createInstance(d.KeybindingsSynchroniser,this.profile,this.collection);case i.SyncResource.Snippets:return this.instantiationService.createInstance(t.SnippetsSynchroniser,this.profile,this.collection);case i.SyncResource.Tasks:return this.instantiationService.createInstance(r.TasksSynchroniser,this.profile,this.collection);case i.SyncResource.GlobalState:return this.instantiationService.createInstance(I.GlobalStateSynchroniser,this.profile,this.collection);case i.SyncResource.Extensions:return this.instantiationService.createInstance(E.ExtensionsSynchroniser,this.profile,this.collection);case i.SyncResource.Profiles:return this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(b,R,U,N){if(N.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const F=[],K=(0,i.createSyncHeaders)(U),H=(this.collection?b?.collections?.[this.collection]?.latest:b?.latest)??null,X=R?await this.getUserDataSyncConfiguration(H):{};for(const j of M){if(N.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(j.resource))return[];try{if(R){const ie=await j.preview(H,X,K);if(ie)for(const z of ie.resourcePreviews)(z.localChange!==i.Change.None||z.remoteChange!==i.Change.None)&&z.mergeState===i.MergeState.Preview&&await j.merge(z.previewResource)}else await j.sync(H,K)}catch(ie){const z=i.UserDataSyncError.toUserDataSyncError(ie);if(w(z,U,this.userDataSyncStoreManagementService,this.telemetryService),m(ie))throw z;this.logService.error(ie),this.logService.error(`${j.resource}: ${(0,L.toErrorMessage)(ie)}`),F.push([j.resource,z])}}return F}finally{this.updateStatus()}}async apply(b,R){const U=(0,i.createSyncHeaders)(b);for(const N of this.enabled){if(R.isCancellationRequested)return;try{await N.apply(!1,U)}catch(M){const F=i.UserDataSyncError.toUserDataSyncError(M);if(w(F,b,this.userDataSyncStoreManagementService,this.telemetryService),m(M))throw F;this.logService.error(M),this.logService.error(`${N.resource}: ${(0,L.toErrorMessage)(M)}`)}}}async stop(){for(const b of this.enabled)try{b.status!==i.SyncStatus.Idle&&await b.stop()}catch(R){this.logService.error(R)}}async resetLocal(){for(const b of this.enabled)try{await b.resetLocal()}catch(R){this.logService.error(`${b.resource}: ${(0,L.toErrorMessage)(R)}`),this.logService.error(R)}}async getUserDataSyncConfiguration(b){if(!this.profile.isDefault)return{};const R=this.configurationService.getValue(i.USER_DATA_SYNC_CONFIGURATION_SCOPE),U=this.enabled.find(N=>N instanceof v.SettingsSynchroniser);if(U){const N=await U.getRemoteUserDataSyncConfiguration(b);return{...R,...N}}return R}setStatus(b){this._status!==b&&(this._status=b,this._onDidChangeStatus.fire(b))}updateStatus(){return this.updateConflicts(),this.enabled.some(b=>b.status===i.SyncStatus.HasConflicts)?this.setStatus(i.SyncStatus.HasConflicts):this.enabled.some(b=>b.status===i.SyncStatus.Syncing)?this.setStatus(i.SyncStatus.Syncing):this.setStatus(i.SyncStatus.Idle)}updateConflicts(){const b=this.enabled.filter(R=>R.status===i.SyncStatus.HasConflicts).filter(R=>R.conflicts.conflicts.length>0).map(R=>R.conflicts);(0,D.equals)(this._conflicts,b,(R,U)=>R.syncResource===U.syncResource&&(0,D.equals)(R.conflicts,U.conflicts,(N,M)=>(0,T.isEqual)(N.previewResource,M.previewResource)))||(this._conflicts=b,this._onDidChangeConflicts.fire(b))}getOrder(b){switch(b){case i.SyncResource.Settings:return 0;case i.SyncResource.Keybindings:return 1;case i.SyncResource.Snippets:return 2;case i.SyncResource.Tasks:return 3;case i.SyncResource.GlobalState:return 4;case i.SyncResource.Extensions:return 5;case i.SyncResource.Profiles:return 6;case i.SyncResource.WorkspaceState:return 7}}};l=we([Q(2,i.IUserDataSyncEnablementService),Q(3,c.IInstantiationService),Q(4,u.IExtensionGalleryService),Q(5,i.IUserDataSyncStoreManagementService),Q(6,f.ITelemetryService),Q(7,i.IUserDataSyncLogService),Q(8,h.IUserDataProfilesService),Q(9,S.IConfigurationService)],l);function m(C){if(C instanceof i.UserDataSyncError)switch(C.code){case i.UserDataSyncErrorCode.MethodNotFound:case i.UserDataSyncErrorCode.TooLarge:case i.UserDataSyncErrorCode.TooManyRequests:case i.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case i.UserDataSyncErrorCode.LocalTooManyRequests:case i.UserDataSyncErrorCode.LocalTooManyProfiles:case i.UserDataSyncErrorCode.Gone:case i.UserDataSyncErrorCode.UpgradeRequired:case i.UserDataSyncErrorCode.IncompatibleRemoteContent:case i.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function w(C,b,R,U){U.publicLog2("sync/error",{code:C.code,serverCode:C instanceof i.UserDataSyncStoreError?String(C.serverCode):void 0,url:C instanceof i.UserDataSyncStoreError?C.url:void 0,resource:C.resource,executionId:b,service:R.userDataSyncStore.url.toString()})}}),define(le[269],ue([0,1,3,2,9,20,25]),function(ne,e,D,a,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncServiceChannelClient=e.UserDataSyncServiceChannel=void 0;function _(u,p){return{...u,profile:(0,L.reviveProfile)(u.profile,p.profilesHome.scheme)}}function T(u){return{created:u.created,uri:A.URI.revive(u.uri)}}class y{constructor(p,c,g){this.service=p,this.userDataProfilesService=c,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(p,c){switch(c){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${c}`)}async call(p,c,g){try{return await this._call(p,c,g)}catch(f){throw this.logService.error(f),f}}async _call(p,c,g){switch(c){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(A.URI.revive(g[0]));case"accept":return this.service.accept(_(g[0],this.userDataProfilesService),A.URI.revive(g[1]),g[2],g[3]);case"replace":return this.service.replace(T(g[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"getRemoteActivityData":return this.service.saveRemoteActivityData(A.URI.revive(g[0]));case"extractActivityData":return this.service.extractActivityData(A.URI.revive(g[0]),A.URI.revive(g[1]));case"createManualSyncTask":return this.createManualSyncTask()}if(c.startsWith("manualSync/")){const f=c.substring(11),h=g[0],E=this.getManualSyncTask(h);switch(g=g.slice(1),f){case"merge":return E.merge();case"apply":return E.apply().then(()=>this.manualSyncTasks.delete(this.createKey(E.id)));case"stop":return E.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(E.id)))}}throw new Error("Invalid call")}getManualSyncTask(p){const c=this.manualSyncTasks.get(this.createKey(p));if(!c)throw new Error(`Manual sync taks not found: ${p}`);return c}async createManualSyncTask(){const p=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(p.id),p),p.id}createKey(p){return`manualSyncTask-${p}`}}e.UserDataSyncServiceChannel=y;let P=class extends a.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(p,c){super(),this.userDataProfilesService=c,this._status=k.SyncStatus.Uninitialized,this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,f,h){return p.call(g,f,h).then(null,E=>{throw k.UserDataSyncError.toUserDataSyncError(E)})},listen(g,f){return p.listen(g,f)}},this.channel.call("_getInitialData").then(([g,f,h])=>{this.updateStatus(g),this.updateConflicts(f),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(E=>this.updateStatus(E))),this._register(this.channel.listen("onDidChangeLastSyncTime")(E=>this.updateLastSyncTime(E)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(f=>({...f,error:k.UserDataSyncError.toUserDataSyncError(f.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.channel.call("createManualSyncTask"),c=this;return new S(p,{async call(f,h,E){return c.channel.call(`manualSync/${f}`,[p,...Array.isArray(h)?h:[h]],E)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(p,c,g,f){return this.channel.call("accept",[p,c,g,f])}resolveContent(p){return this.channel.call("resolveContent",[p])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(p){return this.channel.call("replace",[p])}saveRemoteActivityData(p){return this.channel.call("getRemoteActivityData",[p])}extractActivityData(p,c){return this.channel.call("extractActivityData",[p,c])}async updateStatus(p){this._status=p,this._onDidChangeStatus.fire(p)}async updateConflicts(p){this._conflicts=p.map(c=>({syncResource:c.syncResource,profile:(0,L.reviveProfile)(c.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:c.conflicts.map(g=>({...g,baseResource:A.URI.revive(g.baseResource),localResource:A.URI.revive(g.localResource),remoteResource:A.URI.revive(g.remoteResource),previewResource:A.URI.revive(g.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(p){this._lastSyncTime!==p&&(this._lastSyncTime=p,this._onDidChangeLastSyncTime.fire(p))}};e.UserDataSyncServiceChannelClient=P,e.UserDataSyncServiceChannelClient=P=we([Q(1,L.IUserDataProfilesService)],P);class S extends a.Disposable{constructor(p,c){super(),this.id=p,this.channel=c}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose"),super.dispose()}}}),define(le[127],ue([0,1,6,26,8,3,2,147,5,21,13,9,32,22,16,7,24,60,50,17,25]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const v="configurationSync.store",t="sync.previous.store",r="sync.donot-make-requests-until",s="sync.user-session-id",i="sync.machine-session-id",n=100,o=1e3*60*5;let l=class extends k.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(d.SYNC_SERVICE_URL_TYPE,I.StorageScope.APPLICATION)}set userDataSyncStoreType(U){this.storageService.store(d.SYNC_SERVICE_URL_TYPE,U,I.StorageScope.APPLICATION,T.isWeb?I.StorageTarget.USER:I.StorageTarget.MACHINE)}constructor(U,N,M){super(),this.productService=U,this.configurationService=N,this.storageService=M,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const F=this._register(new k.DisposableStore);this._register(L.Event.filter(M.onDidChangeValue(I.StorageScope.APPLICATION,d.SYNC_SERVICE_URL_TYPE,F),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,F)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[v]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(U){if(U&&(U=T.isWeb&&U.web?{...U,...U.web}:U,(0,P.isString)(U.url)&&(0,P.isObject)(U.authenticationProviders)&&Object.keys(U.authenticationProviders).every(N=>Array.isArray(U.authenticationProviders[N].scopes)))){const N=U,M=!!N.canSwitch,F=N.url===N.insidersUrl?"insiders":"stable",K=(M?this.userDataSyncStoreType:void 0)||F,H=K==="insiders"?N.insidersUrl:K==="stable"?N.stableUrl:N.url;return{url:S.URI.parse(H),type:K,defaultType:F,defaultUrl:S.URI.parse(N.url),stableUrl:S.URI.parse(N.stableUrl),insidersUrl:S.URI.parse(N.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(N.authenticationProviders).reduce((X,j)=>(X.push({id:j,scopes:N.authenticationProviders[j].scopes}),X),[])}}}};e.AbstractUserDataSyncStoreManagementService=l,e.AbstractUserDataSyncStoreManagementService=l=we([Q(0,f.IProductService),Q(1,p.IConfigurationService),Q(2,I.IStorageService)],l);let m=class extends l{constructor(U,N,M){super(U,N,M);const F=this.storageService.get(t,I.StorageScope.APPLICATION);F&&(this.previousConfigurationSyncStore=JSON.parse(F));const K=this.productService[v];K?this.storageService.store(t,JSON.stringify(K),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE):this.storageService.remove(t,I.StorageScope.APPLICATION)}async switch(U){U!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=U,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=m,e.UserDataSyncStoreManagementService=m=we([Q(0,f.IProductService),Q(1,p.IConfigurationService),Q(2,I.IStorageService)],m);let w=class extends k.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(U,N,M,F,K,H,X){super(),this.requestService=M,this.logService=F,this.storageService=X,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(U),this.commonHeadersPromise=(0,E.getServiceMachineId)(K,H,X).then(j=>{const ie={"X-Client-Name":`${N.applicationName}${T.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(ie["X-Client-Commit"]=N.commit),ie}),this.session=new b(n,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(U,N){this.authToken={token:U,type:N}}updateUserDataSyncStoreUrl(U){this.userDataSyncStoreUrl=U?(0,y.joinPath)(U,"v1"):void 0}initDonotMakeRequestsUntil(){const U=this.storageService.getNumber(r,I.StorageScope.APPLICATION);U&&Date.now()<U&&this.setDonotMakeRequestsUntil(new Date(U))}setDonotMakeRequestsUntil(U){this._donotMakeRequestsUntil?.getTime()!==U?.getTime()&&(this._donotMakeRequestsUntil=U,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(N=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(r,I.StorageScope.APPLICATION),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,y.joinPath)(this.userDataSyncStoreUrl,"collection").toString();U={...U},U["Content-Type"]="application/json";const M=await this.request(N,{type:"GET",headers:U},[],a.CancellationToken.None);return(await(0,h.asJson)(M))?.map(({id:F})=>F)||[]}async createCollection(U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,y.joinPath)(this.userDataSyncStoreUrl,"collection").toString();U={...U},U["Content-Type"]=_.Mimes.text;const M=await this.request(N,{type:"POST",headers:U},[],a.CancellationToken.None),F=await(0,h.asTextOrError)(M);if(!F)throw new d.UserDataSyncStoreError("Server did not return the collection id",N,d.UserDataSyncErrorCode.NoCollection,M.res.statusCode,M.res.headers[d.HEADER_OPERATION_ID]);return F}async deleteCollection(U,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=U?(0,y.joinPath)(this.userDataSyncStoreUrl,"collection",U).toString():(0,y.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},await this.request(M,{type:"DELETE",headers:N},[],a.CancellationToken.None)}async getAllResourceRefs(U,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=this.getResourceUrl(this.userDataSyncStoreUrl,N,U),F={},K=await this.request(M.toString(),{type:"GET",headers:F},[],a.CancellationToken.None);return(await(0,h.asJson)(K)||[]).map(({url:X,created:j})=>({ref:(0,y.relativePath)(M,M.with({path:X})),created:j*1e3}))}async resolveResourceContent(U,N,M,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const K=(0,y.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,U),N).toString();F={...F},F["Cache-Control"]="no-cache";const H=await this.request(K,{type:"GET",headers:F},[],a.CancellationToken.None);return await(0,h.asTextOrError)(H)}async deleteResource(U,N,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=N!==null?(0,y.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,U),N).toString():this.getResourceUrl(this.userDataSyncStoreUrl,M,U).toString(),K={};await this.request(F,{type:"DELETE",headers:K},[],a.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,y.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":_.Mimes.text};await this.request(U,{type:"DELETE",headers:N},[],a.CancellationToken.None)}async readResource(U,N,M,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const K=(0,y.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,U),"latest").toString();F={...F},F["Cache-Control"]="no-cache",N&&(F["If-None-Match"]=N.ref);const H=await this.request(K,{type:"GET",headers:F},[304],a.CancellationToken.None);let X=null;if(H.res.statusCode===304&&(X=N),X===null){const j=H.res.headers.etag;if(!j)throw new d.UserDataSyncStoreError("Server did not return the ref",K,d.UserDataSyncErrorCode.NoRef,H.res.statusCode,H.res.headers[d.HEADER_OPERATION_ID]);const ie=await(0,h.asTextOrError)(H);if(!ie&&H.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",K,d.UserDataSyncErrorCode.EmptyResponse,H.res.statusCode,H.res.headers[d.HEADER_OPERATION_ID]);X={ref:j,content:ie}}return X}async writeResource(U,N,M,F,K={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=this.getResourceUrl(this.userDataSyncStoreUrl,F,U).toString();K={...K},K["Content-Type"]=_.Mimes.text,M&&(K["If-Match"]=M);const X=await this.request(H,{type:"POST",data:N,headers:K},[],a.CancellationToken.None),j=X.res.headers.etag;if(!j)throw new d.UserDataSyncStoreError("Server did not return the ref",H,d.UserDataSyncErrorCode.NoRef,X.res.statusCode,X.res.headers[d.HEADER_OPERATION_ID]);return j}async manifest(U,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,y.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",U&&(N["If-None-Match"]=U.ref);const F=await this.request(M,{type:"GET",headers:N},[304],a.CancellationToken.None);let K=null;if(F.res.statusCode===304&&(K=U),!K){const X=F.res.headers.etag;if(!X)throw new d.UserDataSyncStoreError("Server did not return the ref",M,d.UserDataSyncErrorCode.NoRef,F.res.statusCode,F.res.headers[d.HEADER_OPERATION_ID]);const j=await(0,h.asTextOrError)(F);if(!j&&F.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",M,d.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[d.HEADER_OPERATION_ID]);j&&(K={...JSON.parse(j),ref:X})}const H=this.storageService.get(s,I.StorageScope.APPLICATION);return H&&K&&H!==K.session&&this.clearSession(),K===null&&H&&this.clearSession(),K&&this.storageService.store(s,K.session,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),K}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}async getActivityData(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,y.joinPath)(this.userDataSyncStoreUrl,"download").toString(),N={},M=await this.request(U,{type:"GET",headers:N},[],a.CancellationToken.None);if(!(0,h.isSuccess)(M))throw new d.UserDataSyncStoreError("Server returned "+M.res.statusCode,U,d.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[d.HEADER_OPERATION_ID]);if((0,h.hasNoContent)(M))throw new d.UserDataSyncStoreError("Empty response",U,d.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[d.HEADER_OPERATION_ID]);return M.stream}getResourceUrl(U,N,M){return N?(0,y.joinPath)(U,"collection",N,"resource",M):(0,y.joinPath)(U,"resource",M)}clearSession(){this.storageService.remove(s,I.StorageScope.APPLICATION),this.storageService.remove(i,I.StorageScope.APPLICATION)}async request(U,N,M,F){if(!this.authToken)throw new d.UserDataSyncStoreError("No Auth Token Available",U,d.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new d.UserDataSyncStoreError(`${N.type} request '${U}' failed because of too many requests (429).`,U,d.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const K=await this.commonHeadersPromise;N.headers={...N.headers||{},...K,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:U,type:N.type,headers:{...N.headers,authorization:void 0}});let H;try{H=await this.session.request(U,N,F)}catch(B){if(!(B instanceof d.UserDataSyncStoreError)){let ee=d.UserDataSyncErrorCode.RequestFailed;const se=(0,A.getErrorMessage)(B).toLowerCase();se.includes("xhr timeout")?ee=d.UserDataSyncErrorCode.RequestTimeout:se.includes("protocol")&&se.includes("not supported")?ee=d.UserDataSyncErrorCode.RequestProtocolNotSupported:se.includes("request path contains unescaped characters")?ee=d.UserDataSyncErrorCode.RequestPathNotEscaped:se.includes("headers must be an object")?ee=d.UserDataSyncErrorCode.RequestHeadersNotObject:(0,A.isCancellationError)(B)&&(ee=d.UserDataSyncErrorCode.RequestCanceled),B=new d.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,ee,void 0,void 0)}throw this.logService.info("Request failed",U),B}const X=H.res.headers[d.HEADER_OPERATION_ID],j={url:U,status:H.res.statusCode,"execution-id":N.headers[d.HEADER_EXECUTION_ID],"operation-id":X},ie=(0,h.isSuccess)(H)||H.res.statusCode&&M.includes(H.res.statusCode);let z="";if(ie?this.logService.trace("Request succeeded",j):(z=await(0,h.asText)(H)||"",this.logService.info("Request failed",j,z)),H.res.statusCode===401||H.res.statusCode===403){if(this.authToken=void 0,H.res.statusCode===401)throw this._onTokenFailed.fire(d.UserDataSyncErrorCode.Unauthorized),new d.UserDataSyncStoreError(`${N.type} request '${U}' failed because of Unauthorized (401).`,U,d.UserDataSyncErrorCode.Unauthorized,H.res.statusCode,X);if(H.res.statusCode===403)throw this._onTokenFailed.fire(d.UserDataSyncErrorCode.Forbidden),new d.UserDataSyncStoreError(`${N.type} request '${U}' failed because the access is forbidden (403).`,U,d.UserDataSyncErrorCode.Forbidden,H.res.statusCode,X)}if(this._onTokenSucceed.fire(),H.res.statusCode===404)throw new d.UserDataSyncStoreError(`${N.type} request '${U}' failed because the requested resource is not found (404).`,U,d.UserDataSyncErrorCode.NotFound,H.res.statusCode,X);if(H.res.statusCode===405)throw new d.UserDataSyncStoreError(`${N.type} request '${U}' failed because the requested endpoint is not found (405). ${z}`,U,d.UserDataSyncErrorCode.MethodNotFound,H.res.statusCode,X);if(H.res.statusCode===409)throw new d.UserDataSyncStoreError(`${N.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,d.UserDataSyncErrorCode.Conflict,H.res.statusCode,X);if(H.res.statusCode===410)throw new d.UserDataSyncStoreError(`${N.type} request '${U}' failed because the requested resource is not longer available (410).`,U,d.UserDataSyncErrorCode.Gone,H.res.statusCode,X);if(H.res.statusCode===412)throw new d.UserDataSyncStoreError(`${N.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,d.UserDataSyncErrorCode.PreconditionFailed,H.res.statusCode,X);if(H.res.statusCode===413)throw new d.UserDataSyncStoreError(`${N.type} request '${U}' failed because of too large payload (413).`,U,d.UserDataSyncErrorCode.TooLarge,H.res.statusCode,X);if(H.res.statusCode===426)throw new d.UserDataSyncStoreError(`${N.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,d.UserDataSyncErrorCode.UpgradeRequired,H.res.statusCode,X);if(H.res.statusCode===429){const B=H.res.headers["retry-after"];throw B?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(B)*1e3)),new d.UserDataSyncStoreError(`${N.type} request '${U}' failed because of too many requests (429).`,U,d.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,H.res.statusCode,X)):new d.UserDataSyncStoreError(`${N.type} request '${U}' failed because of too many requests (429).`,U,d.UserDataSyncErrorCode.TooManyRequests,H.res.statusCode,X)}if(!ie)throw new d.UserDataSyncStoreError("Server returned "+H.res.statusCode,U,d.UserDataSyncErrorCode.Unknown,H.res.statusCode,X);return H}addSessionHeaders(U){let N=this.storageService.get(i,I.StorageScope.APPLICATION);N===void 0&&(N=(0,u.generateUuid)(),this.storageService.store(i,N,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE)),U["X-Machine-Session-Id"]=N;const M=this.storageService.get(s,I.StorageScope.APPLICATION);M!==void 0&&(U["X-User-Session-Id"]=M)}};e.UserDataSyncStoreClient=w,e.UserDataSyncStoreClient=w=we([Q(1,f.IProductService),Q(2,h.IRequestService),Q(3,d.IUserDataSyncLogService),Q(4,c.IEnvironmentService),Q(5,g.IFileService),Q(6,I.IStorageService)],w);let C=class extends w{constructor(U,N,M,F,K,H,X){super(U.userDataSyncStore?.url,N,M,F,K,H,X),this._register(U.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(U.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=C,e.UserDataSyncStoreService=C=we([Q(0,d.IUserDataSyncStoreManagementService),Q(1,f.IProductService),Q(2,h.IRequestService),Q(3,d.IUserDataSyncLogService),Q(4,c.IEnvironmentService),Q(5,g.IFileService),Q(6,I.IStorageService)],C);class b{constructor(U,N,M,F){this.limit=U,this.interval=N,this.requestService=M,this.logService=F,this.requests=[],this.startTime=void 0}request(U,N,M){if(this.isExpired()&&this.reset(),N.url=U,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new d.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,U,d.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(U),this.requestService.request(N,M)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=b}),define(le[270],ue([0,1,3,2,9,22,24,17,127]),function(ne,e,D,a,A,L,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannelClient=e.UserDataSyncAccountServiceChannel=void 0;class y{constructor(c){this.service=c}listen(c,g){switch(g){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${g}`)}call(c,g,f){switch(g){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=y;class P extends a.Disposable{get account(){return this._account}get onTokenFailed(){return this.channel.listen("onTokenFailed")}constructor(c){super(),this.channel=c,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this.channel.call("_getInitialData").then(g=>{this._account=g,this._register(this.channel.listen("onDidChangeAccount")(f=>{this._account=f,this._onDidChangeAccount.fire(f)}))})}updateAccount(c){return this.channel.call("updateAccount",c)}}e.UserDataSyncAccountServiceChannelClient=P;class S{constructor(c){this.service=c}listen(c,g){switch(g){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${g}`)}call(c,g,f){switch(g){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;let u=class extends T.AbstractUserDataSyncStoreManagementService{constructor(c,g,f,h){super(g,f,h),this.channel=c,this._register(this.channel.listen("onDidChangeUserDataSyncStore")(()=>this.updateUserDataSyncStore()))}async switch(c){return this.channel.call("switch",[c])}async getPreviousUserDataSyncStore(){const c=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(c)}revive(c){return{url:A.URI.revive(c.url),type:c.type,defaultUrl:A.URI.revive(c.defaultUrl),insidersUrl:A.URI.revive(c.insidersUrl),stableUrl:A.URI.revive(c.stableUrl),canSwitch:c.canSwitch,authenticationProviders:c.authenticationProviders}}};e.UserDataSyncStoreManagementServiceChannelClient=u,e.UserDataSyncStoreManagementServiceChannelClient=u=we([Q(1,k.IProductService),Q(2,L.IConfigurationService),Q(3,_.IStorageService)],u)}),define(le[271],ue([0,1,3,58,24,17,18,266,25,83,87]),function(ne,e,D,a,A,L,k,_,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let S=class extends _.UserDataAutoSyncService{constructor(p,c,g,f,h,E,I,d,v,t,r){super(p,c,g,f,h,I,d,v,t,r),this._register(D.Event.debounce(D.Event.any(D.Event.map(E.onDidFocusMainWindow,()=>"windowFocus"),D.Event.map(E.onDidOpenMainWindow,()=>"windowOpen")),(s,i)=>s?[...s,i]:[i],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.UserDataAutoSyncService=S,e.UserDataAutoSyncService=S=we([Q(0,A.IProductService),Q(1,T.IUserDataSyncStoreManagementService),Q(2,T.IUserDataSyncStoreService),Q(3,T.IUserDataSyncEnablementService),Q(4,T.IUserDataSyncService),Q(5,a.INativeHostService),Q(6,T.IUserDataSyncLogService),Q(7,y.IUserDataSyncAccountService),Q(8,k.ITelemetryService),Q(9,P.IUserDataSyncMachinesService),Q(10,L.IStorageService)],S)}),define(le[272],ue([0,1,76,23,5,21]),function(ne,e,D,a,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=k,e.getSingleFolderWorkspaceIdentifier=_,e.createEmptyWorkspaceIdentifier=T,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function k(y){function P(){let S=y.scheme===a.Schemas.file?(0,L.originalFSPath)(y):y.toString();return A.isLinux||(S=S.toLowerCase()),(0,D.createHash)("md5").update(S).digest("hex")}return{id:P(),configPath:y}}function _(y,P){function S(){if(y.scheme!==a.Schemas.file)return(0,D.createHash)("md5").update(y.toString()).digest("hex");if(!P)return;let p;return A.isLinux?p=P.ino:A.isMacintosh?p=P.birthtime.getTime():A.isWindows&&(typeof P.birthtimeMs=="number"?p=Math.floor(P.birthtimeMs):p=P.birthtime.getTime()),(0,D.createHash)("md5").update(y.fsPath).update(p?String(p):"").digest("hex")}const u=S();if(typeof u=="string")return{id:u,uri:y}}function T(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[273],ue([0,1,6,8,2,14,31,16,10,80,116,272,58,57,23]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let g=class extends A.Disposable{constructor(h,E,I,d){super(),this.environmentService=h,this.logService=E,this.nativeHostService=I,this.mainProcessService=d,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=this.environmentService.workspaceStorageHome.with({scheme:c.Schemas.file}).fsPath,E=await k.Promises.readdir(h),I=new y.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(E.map(async d=>{const v=(0,L.join)(h,d);d.length===S.NON_EMPTY_WORKSPACE_ID_LENGTH||d===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows({includeAuxiliaryWindows:!1})).some(s=>s.workspace?.id===d)||await I.isUsed(v)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await k.Promises.rm(v))}))}catch(h){(0,a.onUnexpectedError)(h)}}};e.UnusedWorkspaceStorageDataCleaner=g,e.UnusedWorkspaceStorageDataCleaner=g=we([Q(0,_.INativeEnvironmentService),Q(1,T.ILogService),Q(2,u.INativeHostService),Q(3,p.IMainProcessService)],g)}),define(le[128],ue([0,1,76,66,38,282,15,8,3,2,14,5,32,44,70]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=s,e.createStaticIPCHandle=i,e.serve=l,e.connect=m;class g{traceSocketEvent(C,b){c.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,b)}constructor(C,b=""){this._canWrite=!0,this.debugLabel=b,this.socket=C,this.traceSocketEvent(c.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=R=>{if(this.traceSocketEvent(c.SocketDiagnosticsEventType.Error,{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,_.onUnexpectedError)(R)}},this.socket.on("error",this._errorListener),this._closeListener=R=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.Close,{hadError:R}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(C){const b=R=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.Read,R),C(k.VSBuffer.wrap(R))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(C){const b=R=>{C({type:c.SocketCloseEventType.NodeSocketCloseEvent,hadError:R,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(C){const b=()=>{C()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(C){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(c.SocketDiagnosticsEventType.Write,C),this.socket.write(C.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,_.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,_.onUnexpectedError)(b)}}end(){this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((C,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainEnd),C();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainEnd),C()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=g;var f;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var h;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(h||(h={}));class E extends y.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(C,b){this.socket.traceSocketEvent(C,b)}constructor(C,b,R,U){super(),this._onData=this._register(new T.Emitter),this._onClose=this._register(new T.Emitter),this._isEnded=!1,this._state={state:h.PeekHeader,readLen:f.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=C,this.traceSocketEvent(c.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:R?.byteLength||0,recordInflateBytes:U}),this._flowManager=this._register(new I(this,b,R,U,this._onData,(N,M)=>this._write(N,M))),this._register(this._flowManager.onError(N=>{console.error(N),(0,_.onUnexpectedError)(N),this._onClose.fire({type:c.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:N})})),this._incomingData=new c.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(async N=>{this._flowManager.isProcessingReadQueue()&&await T.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(N)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this._onData.event(C)}onClose(C){return this._onClose.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let b=0;for(;b<C.byteLength;)this._flowManager.writeMessage(C.slice(b,Math.min(b+f.MaxWebSocketMessageLength,C.byteLength)),{compressed:!0,opcode:2}),b+=f.MaxWebSocketMessageLength}_write(C,{compressed:b,opcode:R}){if(this._isEnded)return;this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,C);let U=f.MinHeaderByteSize;C.byteLength<126?U+=0:C.byteLength<2**16?U+=2:U+=8;const N=k.VSBuffer.alloc(U),M=b?64:0,F=R&15;if(N.writeUInt8(128|M|F,0),C.byteLength<126)N.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){N.writeUInt8(126,1);let K=1;N.writeUInt8(C.byteLength>>>8&255,++K),N.writeUInt8(C.byteLength>>>0&255,++K)}else{N.writeUInt8(127,1);let K=1;N.writeUInt8(0,++K),N.writeUInt8(0,++K),N.writeUInt8(0,++K),N.writeUInt8(0,++K),N.writeUInt8(C.byteLength>>>24&255,++K),N.writeUInt8(C.byteLength>>>16&255,++K),N.writeUInt8(C.byteLength>>>8&255,++K),N.writeUInt8(C.byteLength>>>0&255,++K)}this.socket.write(k.VSBuffer.concat([N,C]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(C){if(C.byteLength!==0){for(this._incomingData.acceptChunk(C);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===h.PeekHeader){const b=this._incomingData.peek(this._state.readLen),R=b.readUInt8(0),U=(R&128)>>>7,N=(R&64)>>>6,M=R&15,F=b.readUInt8(1),K=(F&128)>>>7,H=F&127;this._state.state=h.ReadHeader,this._state.readLen=f.MinHeaderByteSize+(K?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=U,this._state.firstFrameOfMessage&&(this._state.compressed=!!N),this._state.firstFrameOfMessage=!!U,this._state.mask=0,this._state.opcode=M,this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===h.ReadHeader){const b=this._incomingData.read(this._state.readLen),R=b.readUInt8(1),U=(R&128)>>>7;let N=R&127,M=1;N===126?N=b.readUInt8(++M)*2**8+b.readUInt8(++M):N===127&&(N=b.readUInt8(++M)*0+b.readUInt8(++M)*0+b.readUInt8(++M)*0+b.readUInt8(++M)*0+b.readUInt8(++M)*2**24+b.readUInt8(++M)*2**16+b.readUInt8(++M)*2**8+b.readUInt8(++M));let F=0;U&&(F=b.readUInt8(++M)*2**24+b.readUInt8(++M)*2**16+b.readUInt8(++M)*2**8+b.readUInt8(++M)),this._state.state=h.ReadBody,this._state.readLen=N,this._state.mask=F,this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===h.ReadBody){const b=this._incomingData.read(this._state.readLen);this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,b),t(b,this._state.mask),this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,b),this._state.state=h.PeekHeader,this._state.readLen=f.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(b,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(b,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await T.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=E;class I extends y.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(C,b,R,U,N,M){super(),this._tracer=C,this._onData=N,this._writeFn=M,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new T.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new T.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,b?(this._zlibInflateStream=this._register(new d(this._tracer,U,R,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(C,b){this._writeQueue.push({data:C,options:b}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:C,options:b}=this._writeQueue.shift();if(this._zlibDeflateStream&&b.compressed){const R=await this._deflateMessage(this._zlibDeflateStream,C);this._writeFn(R,b)}else this._writeFn(C,{...b,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(C,b){return new Promise((R,U)=>{C.write(b),C.flush(N=>R(N))})}acceptFrame(C,b,R){this._readQueue.push({data:C,isCompressed:b,isLastFrameOfMessage:R}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const C=this._readQueue.shift();if(this._zlibInflateStream&&C.isCompressed){const b=await this._inflateFrame(this._zlibInflateStream,C.data,C.isLastFrameOfMessage);this._onData.fire(b)}else this._onData.fire(C.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(C,b,R){return new Promise((U,N)=>{C.write(b),R&&C.write(k.VSBuffer.fromByteArray([0,0,255,255])),C.flush(M=>U(M))})}}class d extends y.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.concat(this._recordedInflateBytes):k.VSBuffer.alloc(0)}constructor(C,b,R,U){super(),this._tracer=C,this._recordInflateBytes=b,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,L.createInflateRaw)(U),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateError,{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateData,N),this._pendingInflateData.push(k.VSBuffer.wrap(N))}),R&&(this._tracer.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateInitialWrite,R.buffer),this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(C){this._recordInflateBytes&&this._recordedInflateBytes.push(C.clone()),this._tracer.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateWrite,C),this._zlibInflate.write(C.buffer)}flush(C){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateFlushFired);const b=k.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,C(b)})}}class v extends y.Disposable{constructor(C,b){super(),this._tracer=C,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,L.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",R=>{this._tracer.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateError,{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibDeflate.on("data",R=>{this._tracer.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateData,R),this._pendingDeflateData.push(k.VSBuffer.wrap(R))})}write(C){this._tracer.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateWrite,C.buffer),this._zlibDeflate.write(C.buffer)}flush(C){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateFlushFired);let b=k.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.byteLength-4),C(b)})}}function t(w,C){if(C===0)return;const b=w.byteLength>>>2;for(let K=0;K<b;K++){const H=w.readUInt32BE(K*4);w.writeUInt32BE(H^C,K*4)}const R=b*4,U=w.byteLength-R,N=C>>>24&255,M=C>>>16&255,F=C>>>8&255;U>=1&&w.writeUInt8(w.readUInt8(R)^N,R),U>=2&&w.writeUInt8(w.readUInt8(R+1)^M,R+1),U>=3&&w.writeUInt8(w.readUInt8(R+2)^F,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[S.Platform.Linux]:107,[S.Platform.Mac]:103};function s(){const w=(0,u.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const C=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,A.tmpdir)(),b=(0,P.join)(C,`vscode-ipc-${w}.sock`);return n(b),b}function i(w,C,b){const U=(0,D.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${b}-${C}-sock`;const N=b.substr(0,4),M=C.substr(0,6);let F;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${U}-${N}-${M}.sock`):F=(0,P.join)(w,`${N}-${M}.sock`),n(F),F}function n(w){const C=r[S.platform];typeof C=="number"&&w.length>=C&&console.warn(`WARNING: IPC handle "${w}" is longer than ${C} chars, try a shorter --user-data-dir`)}class o extends p.IPCServer{static toClientConnectionEvent(C){const b=T.Event.fromNodeEventEmitter(C,"connection");return T.Event.map(b,R=>({protocol:new c.Protocol(new g(R,"ipc-server-connection")),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(R,"close"))}))}constructor(C){super(o.toClientConnectionEvent(C)),this.server=C}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function l(w){return new Promise((C,b)=>{const R=(0,a.createServer)();R.on("error",b),R.listen(w,()=>{R.removeListener("error",b),C(new o(R))})})}function m(w,C){return new Promise((b,R)=>{const U=(0,a.createConnection)(w,()=>{U.removeListener("error",R),b(c.Client.fromSocket(new g(U,`ipc-client${C}`),C))});U.once("error",R)})}}),define(le[274],ue([0,1,66,128,221]),function(ne,e,D,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(L){return!0}connect({host:L,port:k},_,T,y){return new Promise((P,S)=>{const u=D.createConnection({host:L,port:k},()=>{u.removeListener("error",S),u.write((0,A.makeRawSocketHeaders)(_,T,y));const p=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(u.off("data",p),P(new a.NodeSocket(u,y)))};u.on("data",p)});u.setNoDelay(!0),u.once("error",S)})}}}),define(le[275],ue([0,1,66,38,139,128,6,2,5,22,10,24,222,107,109,81,15]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function h(t,r,s,i,n){let o;for(let l=3;l&&(o?.dispose(),o=await new E(t,r,s,i,n).waitForReady(),!(n&&A.BROWSER_RESTRICTED_PORTS[n]||!A.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));l--);return o}class E extends _.Disposable{constructor(r,s,i,n,o){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=o,this.privacy=g.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=r,this._server=D.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=l=>this._onConnection(l),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const r=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,g.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,A.findFreePortFaster)(r,2,1e3,s),n=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(r){r.pause();const s=(0,g.isLocalhost)(this.tunnelRemoteHost)||(0,g.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,u.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&r.write(o.buffer),r.on("end",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),n.end()}),r.on("close",()=>n.end()),r.on("error",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),n instanceof L.NodeSocket?n.socket.destroy():n.end()}),n instanceof L.NodeSocket?this._mirrorNodeSocket(r,n):this._mirrorGenericSocket(r,n),r.localAddress&&this._socketsDispose.set(r.localAddress,()=>{r.end(),n.end()})}_mirrorGenericSocket(r,s){s.onClose(()=>r.destroy()),s.onEnd(()=>r.end()),s.onData(i=>r.write(i.buffer)),r.on("data",i=>s.write(f.VSBuffer.wrap(i))),r.resume()}_mirrorNodeSocket(r,s){const i=s.socket;i.on("end",()=>r.end()),i.on("close",()=>r.end()),i.on("error",()=>{r.destroy()}),i.pipe(r),r.pipe(i)}}e.NodeRemoteTunnel=E;let I=class extends g.AbstractTunnelService{constructor(r,s,i,n,o){super(s,o),this.remoteSocketFactoryService=r,this.signService=i,this.productService=n}isPortPrivileged(r){return(0,g.isPortPrivileged)(r,this.defaultTunnelHost,T.OS,a.release())}retainOrCreateTunnel(r,s,i,n,o,l,m,w){const C=this.getTunnelFromMap(s,i);if(C)return++C.refcount,C.value;if((0,g.isTunnelProvider)(r))return this.createWithProvider(r,s,i,o,l,m,w);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${o}.`);const b={commit:this.productService.commit,quality:this.productService.quality,addressProvider:r,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},R=h(b,n,s,i,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,i,R),R}}};e.BaseTunnelService=I,e.BaseTunnelService=I=we([Q(0,p.IRemoteSocketFactoryService),Q(1,P.ILogService),Q(2,c.ISignService),Q(3,S.IProductService),Q(4,y.IConfigurationService)],I);let d=class extends I{constructor(r,s,i,n,o){super(r,s,i,n,o)}};e.TunnelService=d,e.TunnelService=d=we([Q(0,p.IRemoteSocketFactoryService),Q(1,P.ILogService),Q(2,c.ISignService),Q(3,S.IProductService),Q(4,y.IConfigurationService)],d);let v=class extends _.Disposable{constructor(r,s,i,n,o){super(),this.remoteSocketFactoryService=r,this.logService=s,this.productService=i,this.signService=n,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(r,s,i,n,o,l,m,w,C){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${l}.`),!this._tunnelServices.has(r)){const b=new d(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(b),this._tunnelServices.set(r,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this._tunnelServices.delete(r))})}return this._tunnelServices.get(r).openTunnel(s,i,n,o,l,m,w,C)}};e.SharedTunnelsService=v,e.SharedTunnelsService=v=we([Q(0,p.IRemoteSocketFactoryService),Q(1,P.ILogService),Q(2,S.IProductService),Q(3,c.ISignService),Q(4,y.IConfigurationService)],v)}),define(le[283],ue([0,1,38,40,8,2,23,9,19,3,44,157,215,216,225,207,273,198,199,22,220,98,232,99,227,16,119,259,28,111,223,118,75,7,209,210,74,4,206,77,79,235,10,211,103,24,60,17,110,18,112,113,114,49,238,86,115,25,83,265,270,248,87,264,268,269,127,61,263,249,109,231,81,275,226,239,29,240,5,241,200,218,217,85,254,20,53,214,59,262,237,250,108,267,255,11,212,102,260,253,228,195,58,213,271,257,57,261,107,105,274,193,229,153,146,151]),function(ne,e,D,a,A,L,k,_,T,y,P,S,u,p,c,g,f,h,E,I,d,v,t,r,s,i,n,o,l,m,w,C,b,R,U,N,M,F,K,H,X,j,ie,z,B,ee,se,ce,W,J,G,V,O,$,x,q,te,Z,Y,ae,he,ge,ve,Ie,pe,ye,Pe,Re,oe,fe,me,Ce,De,Ne,ke,Le,Oe,xe,ze,Fe,We,$e,qe,_e,re,de,Se,Ee,Te,Ae,Me,Qe,He,Ke,Be,Je,Ye,tt,st,Ct,Dt,Tt,Lt,_t,At,kt,vt,Ut,yt,Ot,Nt,Ft,ct,Mt,xt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=wt;class Wt extends L.Disposable{constructor(be){super(),this.configuration=be,this.server=this._register(new S.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new y.Emitter),this.registerListeners()}registerListeners(){let be=!1;const Ue=()=>{be||(be=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ue),(0,S.once)(process.parentPort,ct.SharedProcessLifecycle.exit,Ue)}async init(){const be=await this.initServices();(0,Z.registerConfiguration)(),be.invokeFunction(Ue=>{const Ve=Ue.get(ie.ILogService),je=Ue.get(J.ITelemetryService),Ze=Ue.get(de.IUserDataProfilesService);Ve.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(Ve),this.reportProfilesInfo(je,Ze),this._register(Ze.onDidChangeProfiles(()=>this.reportProfilesInfo(je,Ze))),this.reportClientOSInfo(je,Ve)}),this._register((0,L.combinedDisposable)(be.createInstance(u.CodeCacheCleaner,this.configuration.codeCachePath),be.createInstance(p.LanguagePackCachedDataCleaner),be.createInstance(f.UnusedWorkspaceStorageDataCleaner),be.createInstance(g.LogsDataCleaner),be.createInstance(c.LocalizationsUpdater),be.createInstance(Be.ExtensionsContributions),be.createInstance(Qe.UserDataProfilesCleaner)))}async initServices(){const be=new H.ServiceCollection,Ue={_serviceBrand:void 0,...B.default};be.set(ee.IProductService,Ue);const Ve=new P.StaticRouter(Xe=>Xe==="main"),je=new vt.MainProcessService(this.server,Ve);be.set(vt.IMainProcessService,je);const Ze=this.configuration.policiesData?new Ee.PolicyChannelClient(this.configuration.policiesData,je.getChannel("policy")):new Te.NullPolicyService;be.set(Te.IPolicyService,Ze);const Ge=new Ft.NativeEnvironmentService(this.configuration.args,Ue);be.set(i.INativeEnvironmentService,Ge);const rt=new z.LoggerChannelClient(void 0,this.configuration.logLevel,Ge.logsHome,this.configuration.loggers.map(Xe=>({...Xe,resource:_.URI.revive(Xe.resource)})),je.getChannel("logger"));be.set(ie.ILoggerService,rt);const ut=this._register(rt.createLogger("sharedprocess",{name:(0,Je.localize)(0,null)})),gt=this._register(new ie.ConsoleLogger(ut.getLevel())),et=this._register(new Ye.LogService(ut,[gt]));be.set(ie.ILogService,et),this.lifecycleService=this._register(new tt.SharedProcessLifecycleService(et)),be.set(tt.ISharedProcessLifecycleService,this.lifecycleService);const it=this._register(new U.FileService(et));be.set(R.IFileService,it);const mt=this._register(new N.DiskFileSystemProvider(et));it.registerProvider(k.Schemas.file,mt);const ht=new xe.UriIdentityService(it);be.set(Oe.IUriIdentityService,ht);const nt=this._register(new Ae.UserDataProfilesService(this.configuration.profiles.all,_.URI.revive(this.configuration.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),je.getChannel("userDataProfiles")));be.set(de.IUserDataProfilesService,nt);const St=this._register(new Fe.FileUserDataProvider(k.Schemas.file,this._register(new We.DiskFileSystemProviderClient(je.getChannel(We.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ze.isLinux})),k.Schemas.vscodeUserData,nt,ht,et));it.registerProvider(k.Schemas.vscodeUserData,St);const ot=this._register(new d.ConfigurationService(nt.defaultProfile.settingsResource,it,Ze,et));be.set(I.IConfigurationService,ot);const pt=new Ut.RemoteStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},je,Ge);be.set(ce.IStorageService,pt),this._register((0,L.toDisposable)(()=>pt.flush())),await Promise.all([ot.initialize(),pt.initialize()]);const It=new Dt.RequestChannelClient(je.getChannel("request"));be.set(se.IRequestService,It),be.set(h.IChecksumService,new M.SyncDescriptor(E.ChecksumService,void 0,!1)),be.set(qe.IV8InspectProfilingService,new M.SyncDescriptor($e.InspectProfilingService,void 0,!1));const Pt=new _t.NativeHostService(-1,je);be.set(Lt.INativeHostService,Pt),be.set(r.IDownloadService,new M.SyncDescriptor(s.DownloadService,void 0,!0));const qt=this._register(new fe.ActiveWindowManager(Pt)),Bt=new P.StaticRouter(Xe=>qt.getActiveClientId().then(ft=>Xe===ft));be.set(b.IExtensionRecommendationNotificationService,new Tt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Bt)));let dt;const at=[],Rt=(0,$.isInternalTelemetry)(Ue,ot);if((0,$.supportsTelemetry)(Ue,Ge)){const Xe=new V.TelemetryLogAppender(et,rt,Ge,Ue);if(at.push(Xe),!(0,$.isLoggingOnly)(Ue,Ge)&&Ue.aiConfig?.ariaKey){const ft=new Me.OneDataSystemAppender(It,Rt,"monacoworkbench",null,Ue.aiConfig.ariaKey);this._register((0,L.toDisposable)(()=>ft.flush())),at.push(ft)}dt=new O.TelemetryService({appenders:at,commonProperties:(0,W.resolveCommonProperties)((0,D.release)(),(0,D.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,this.configuration.sqmId,this.configuration.devDeviceId,Rt),sendErrorTelemetry:!0,piiPaths:(0,$.getPiiPathsFromEnvironment)(Ge)},ot,Ue)}else{dt=$.NullTelemetryService;const Xe=$.NullAppender;at.push(Xe)}this.server.registerChannel("telemetryAppender",new G.TelemetryAppenderChannel(at)),be.set(J.ITelemetryService,dt);const zt=new x.CustomEndpointTelemetryService(ot,dt,et,rt,Ge,Ue);be.set(J.ICustomEndpointTelemetryService,zt),be.set(Se.IExtensionsProfileScannerService,new M.SyncDescriptor(Ct.ExtensionsProfileScannerService,void 0,!0)),be.set(_e.IExtensionsScannerService,new M.SyncDescriptor(re.ExtensionsScannerService,void 0,!0)),be.set(m.IExtensionSignatureVerificationService,new M.SyncDescriptor(m.ExtensionSignatureVerificationService,void 0,!0)),be.set(C.INativeServerExtensionManagementService,new M.SyncDescriptor(C.ExtensionManagementService,void 0,!0)),be.set(l.IExtensionGalleryService,new M.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),be.set(l.IExtensionTipsService,new M.SyncDescriptor(kt.ExtensionTipsService,void 0,!1)),be.set(X.ILanguagePackService,new M.SyncDescriptor(j.NativeLanguagePackService,void 0,!1)),be.set(v.IDiagnosticsService,new M.SyncDescriptor(t.DiagnosticsService,void 0,!1)),be.set(Y.IUserDataSyncAccountService,new M.SyncDescriptor(Y.UserDataSyncAccountService,void 0,!0)),be.set(Z.IUserDataSyncLogService,new M.SyncDescriptor(ge.UserDataSyncLogService,void 0,!0)),be.set(Z.IUserDataSyncUtilService,P.ProxyChannel.toService(this.server.getChannel("userDataSyncUtil",Xe=>Xe.ctx!=="main"))),be.set(l.IGlobalExtensionEnablementService,new M.SyncDescriptor(n.GlobalExtensionEnablementService,void 0,!1)),be.set(te.IIgnoredExtensionsManagementService,new M.SyncDescriptor(te.IgnoredExtensionsManagementService,void 0,!0)),be.set(q.IExtensionStorageService,new M.SyncDescriptor(q.ExtensionStorageService)),be.set(Z.IUserDataSyncStoreManagementService,new M.SyncDescriptor(Pe.UserDataSyncStoreManagementService,void 0,!0)),be.set(Z.IUserDataSyncStoreService,new M.SyncDescriptor(Pe.UserDataSyncStoreService,void 0,!0)),be.set(ve.IUserDataSyncMachinesService,new M.SyncDescriptor(ve.UserDataSyncMachinesService,void 0,!0)),be.set(Z.IUserDataSyncLocalStoreService,new M.SyncDescriptor(ae.UserDataSyncLocalStoreService,void 0,!1)),be.set(Z.IUserDataSyncEnablementService,new M.SyncDescriptor(Ie.UserDataSyncEnablementService,void 0,!0)),be.set(Z.IUserDataSyncService,new M.SyncDescriptor(pe.UserDataSyncService,void 0,!1)),be.set(Re.IUserDataProfileStorageService,new M.SyncDescriptor(oe.NativeUserDataProfileStorageService,void 0,!0)),be.set(Z.IUserDataSyncResourceProviderService,new M.SyncDescriptor(Ke.UserDataSyncResourceProviderService,void 0,!0)),be.set(me.ISignService,new M.SyncDescriptor(Ce.SignService,void 0,!1));const bt=new yt.RemoteSocketFactoryService;return be.set(yt.IRemoteSocketFactoryService,bt),bt.register(Ot.RemoteConnectionType.WebSocket,Nt.nodeSocketFactory),be.set(De.ISharedTunnelsService,new M.SyncDescriptor(Ne.SharedTunnelsService)),be.set(ke.ISharedProcessTunnelService,new M.SyncDescriptor(Le.SharedProcessTunnelService)),be.set(He.IRemoteTunnelService,new M.SyncDescriptor(st.RemoteTunnelService)),new K.InstantiationService(be)}initChannels(be){const Ue=new w.ExtensionManagementChannel(be.get(l.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const Ve=P.ProxyChannel.fromService(be.get(X.ILanguagePackService),this._store);this.server.registerChannel("languagePacks",Ve);const je=P.ProxyChannel.fromService(be.get(v.IDiagnosticsService),this._store);this.server.registerChannel("diagnostics",je);const Ze=new w.ExtensionTipsChannel(be.get(l.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ze);const Ge=P.ProxyChannel.fromService(be.get(h.IChecksumService),this._store);this.server.registerChannel("checksum",Ge);const rt=P.ProxyChannel.fromService(be.get(qe.IV8InspectProfilingService),this._store);this.server.registerChannel("v8InspectProfiling",rt);const ut=P.ProxyChannel.fromService(be.get(ve.IUserDataSyncMachinesService),this._store);this.server.registerChannel("userDataSyncMachines",ut);const gt=P.ProxyChannel.fromService(be.get(J.ICustomEndpointTelemetryService),this._store);this.server.registerChannel("customEndpointTelemetry",gt);const et=new he.UserDataSyncAccountServiceChannel(be.get(Y.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",et);const it=new he.UserDataSyncStoreManagementServiceChannel(be.get(Z.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",it);const mt=new ye.UserDataSyncServiceChannel(be.get(Z.IUserDataSyncService),be.get(de.IUserDataProfilesService),be.get(ie.ILogService));this.server.registerChannel("userDataSync",mt);const ht=this._register(be.get(F.IInstantiationService).createInstance(At.UserDataAutoSyncService));this.server.registerChannel("userDataAutoSync",P.ProxyChannel.fromService(ht,this._store)),this.server.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(be.get(Z.IUserDataSyncResourceProviderService),this._store));const nt=P.ProxyChannel.fromService(be.get(ke.ISharedProcessTunnelService),this._store);this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,nt);const St=P.ProxyChannel.fromService(be.get(He.IRemoteTunnelService),this._store);this.server.registerChannel("remoteTunnel",St)}registerErrorHandler(be){process.on("uncaughtException",Ue=>(0,A.onUnexpectedError)(Ue)),process.on("unhandledRejection",Ue=>(0,A.onUnexpectedError)(Ue)),(0,A.setUnexpectedErrorHandler)(Ue=>{const Ve=(0,a.toErrorMessage)(Ue,!0);Ve&&be.error(`[uncaught exception in sharedProcess]: ${Ve}`)})}reportProfilesInfo(be,Ue){be.publicLog2("profilesInfo",{count:Ue.profiles.length})}async reportClientOSInfo(be,Ue){if(ze.isLinux){const[Ve,je]=await Promise.all([(0,Mt.getOSReleaseInfo)(Ue.error.bind(Ue)),(0,Et.getDisplayProtocol)(Ue.error.bind(Ue))]),Ze=(0,xt.getDesktopEnvironment)(),Ge=(0,Et.getCodeDisplayProtocol)(je,this.configuration.args["ozone-platform"]);Ve&&be.publicLog2("clientPlatformInfo",{platformId:Ve.id,platformVersionId:Ve.version_id,platformIdLike:Ve.id_like,desktopEnvironment:Ze,displayProtocol:je,codeDisplayProtocol:Ge})}}handledClientConnection(be){if(be.data!==ct.SharedProcessRawConnection.response)return!1;const Ue=(0,T.firstOrDefault)(be.ports);return Ue?(this.onDidWindowConnectRaw.fire(Ue),!0):!1}}async function wt(lt){try{const be=new Wt(lt);process.parentPort.postMessage(ct.SharedProcessLifecycle.ipcReady),await be.init(),process.parentPort.postMessage(ct.SharedProcessLifecycle.initDone)}catch(be){process.parentPort.postMessage({error:be.toString()})}}const $t=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",lt=>{clearTimeout($t),wt(lt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d98c6de73fb939f1eb4b8a500c569b858b2d297/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
