/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/process","vs/base/common/marshalling","fs","child_process","vs/base/common/decorators","vs/base/common/hash","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(he){for(var e=[],r=0,g=he.length;r<g;r++)e[r]=we[he[r]];return e};define(we[172],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.isESM=void 0,e.isESM=!1;var r;(function(k){k[k.LoaderAvailable=1]="LoaderAvailable",k[k.BeginLoadingScript=10]="BeginLoadingScript",k[k.EndLoadingScriptOK=11]="EndLoadingScriptOK",k[k.EndLoadingScriptError=12]="EndLoadingScriptError",k[k.BeginInvokeFactory=21]="BeginInvokeFactory",k[k.EndInvokeFactory=22]="EndInvokeFactory",k[k.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",k[k.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",k[k.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",k[k.NodeEndNativeRequire=34]="NodeEndNativeRequire",k[k.CachedDataFound=60]="CachedDataFound",k[k.CachedDataMissed=61]="CachedDataMissed",k[k.CachedDataRejected=62]="CachedDataRejected",k[k.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class g{static get(){const A=new Map,L=new Map,R=new Map,v=new Map;function l(E,a){E.has(a.detail)||E.set(a.detail,-a.timestamp)}function P(E,a){const u=E.get(a.detail);u&&(u>=0||E.set(a.detail,u+a.timestamp))}let y=[];typeof he=="function"&&typeof he.getStats=="function"&&(y=he.getStats().slice(0).sort((E,a)=>E.timestamp-a.timestamp));for(const E of y)switch(E.type){case r.BeginLoadingScript:l(A,E);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:P(A,E);break;case r.BeginInvokeFactory:l(L,E);break;case r.EndInvokeFactory:P(L,E);break;case r.NodeBeginNativeRequire:l(R,E);break;case r.NodeEndNativeRequire:P(R,E);break;case r.NodeBeginEvaluatingScript:l(v,E);break;case r.NodeEndEvaluatingScript:P(v,E);break}let d=0;R.forEach(E=>d+=E);function T(E){const a=[];return E.forEach((u,f)=>a.push([f,u])),a}return{amdLoad:T(A),amdInvoke:T(L),nodeRequire:T(R),nodeEval:T(v),nodeRequireTotal:d}}static toMarkdownTable(A,L){let R="";const v=[];return A.forEach((l,P)=>{v[P]=l.length}),L.forEach(l=>{l.forEach((P,y)=>{typeof P>"u"&&(P=l[y]="-");const d=P.toString().length;v[y]=Math.max(d,v[y])})}),A.forEach((l,P)=>{R+=`| ${l+" ".repeat(v[P]-l.toString().length)} `}),R+=`|
`,A.forEach((l,P)=>{R+=`| ${"-".repeat(v[P])} `}),R+=`|
`,L.forEach(l=>{l.forEach((P,y)=>{typeof P<"u"&&(R+=`| ${P+" ".repeat(v[y]-P.toString().length)} `)}),R+=`|
`}),R}}e.LoaderStats=g}),define(we[131],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=r,e.findLastIdx=g,e.findLastMonotonous=k,e.findLastIdxMonotonous=A,e.findFirstMonotonous=L,e.findFirstIdxMonotonousOrArrLen=R,e.findFirstIdxMonotonous=v,e.findFirstMax=P,e.findLastMax=y,e.findFirstMin=d,e.findMaxIdx=T,e.mapFindFirst=E;function r(a,u){const f=g(a,u);if(f!==-1)return a[f]}function g(a,u,f=a.length-1){for(let m=f;m>=0;m--){const n=a[m];if(u(n))return m}return-1}function k(a,u){const f=A(a,u);return f===-1?void 0:a[f]}function A(a,u,f=0,m=a.length){let n=f,s=m;for(;n<s;){const i=Math.floor((n+s)/2);u(a[i])?n=i+1:s=i}return n-1}function L(a,u){const f=R(a,u);return f===a.length?void 0:a[f]}function R(a,u,f=0,m=a.length){let n=f,s=m;for(;n<s;){const i=Math.floor((n+s)/2);u(a[i])?s=i:n=i+1}return n}function v(a,u,f=0,m=a.length){const n=R(a,u,f,m);return n===a.length?-1:n}class l{static{this.assertInvariants=!1}constructor(u){this._array=u,this._findLastMonotonousLastIdx=0}findLastMonotonous(u){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const m of this._array)if(this._prevFindLastPredicate(m)&&!u(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=u}const f=A(this._array,u,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=f+1,f===-1?void 0:this._array[f]}}e.MonotonousArray=l;function P(a,u){if(a.length===0)return;let f=a[0];for(let m=1;m<a.length;m++){const n=a[m];u(n,f)>0&&(f=n)}return f}function y(a,u){if(a.length===0)return;let f=a[0];for(let m=1;m<a.length;m++){const n=a[m];u(n,f)>=0&&(f=n)}return f}function d(a,u){return P(a,(f,m)=>-u(f,m))}function T(a,u){if(a.length===0)return-1;let f=0;for(let m=1;m<a.length;m++){const n=a[m];u(n,a[f])>0&&(f=m)}return f}function E(a,u){for(const f of a){const m=u(f);if(m!==void 0)return m}}}),define(we[27],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(g){g[g.Null=0]="Null",g[g.Backspace=8]="Backspace",g[g.Tab=9]="Tab",g[g.LineFeed=10]="LineFeed",g[g.CarriageReturn=13]="CarriageReturn",g[g.Space=32]="Space",g[g.ExclamationMark=33]="ExclamationMark",g[g.DoubleQuote=34]="DoubleQuote",g[g.Hash=35]="Hash",g[g.DollarSign=36]="DollarSign",g[g.PercentSign=37]="PercentSign",g[g.Ampersand=38]="Ampersand",g[g.SingleQuote=39]="SingleQuote",g[g.OpenParen=40]="OpenParen",g[g.CloseParen=41]="CloseParen",g[g.Asterisk=42]="Asterisk",g[g.Plus=43]="Plus",g[g.Comma=44]="Comma",g[g.Dash=45]="Dash",g[g.Period=46]="Period",g[g.Slash=47]="Slash",g[g.Digit0=48]="Digit0",g[g.Digit1=49]="Digit1",g[g.Digit2=50]="Digit2",g[g.Digit3=51]="Digit3",g[g.Digit4=52]="Digit4",g[g.Digit5=53]="Digit5",g[g.Digit6=54]="Digit6",g[g.Digit7=55]="Digit7",g[g.Digit8=56]="Digit8",g[g.Digit9=57]="Digit9",g[g.Colon=58]="Colon",g[g.Semicolon=59]="Semicolon",g[g.LessThan=60]="LessThan",g[g.Equals=61]="Equals",g[g.GreaterThan=62]="GreaterThan",g[g.QuestionMark=63]="QuestionMark",g[g.AtSign=64]="AtSign",g[g.A=65]="A",g[g.B=66]="B",g[g.C=67]="C",g[g.D=68]="D",g[g.E=69]="E",g[g.F=70]="F",g[g.G=71]="G",g[g.H=72]="H",g[g.I=73]="I",g[g.J=74]="J",g[g.K=75]="K",g[g.L=76]="L",g[g.M=77]="M",g[g.N=78]="N",g[g.O=79]="O",g[g.P=80]="P",g[g.Q=81]="Q",g[g.R=82]="R",g[g.S=83]="S",g[g.T=84]="T",g[g.U=85]="U",g[g.V=86]="V",g[g.W=87]="W",g[g.X=88]="X",g[g.Y=89]="Y",g[g.Z=90]="Z",g[g.OpenSquareBracket=91]="OpenSquareBracket",g[g.Backslash=92]="Backslash",g[g.CloseSquareBracket=93]="CloseSquareBracket",g[g.Caret=94]="Caret",g[g.Underline=95]="Underline",g[g.BackTick=96]="BackTick",g[g.a=97]="a",g[g.b=98]="b",g[g.c=99]="c",g[g.d=100]="d",g[g.e=101]="e",g[g.f=102]="f",g[g.g=103]="g",g[g.h=104]="h",g[g.i=105]="i",g[g.j=106]="j",g[g.k=107]="k",g[g.l=108]="l",g[g.m=109]="m",g[g.n=110]="n",g[g.o=111]="o",g[g.p=112]="p",g[g.q=113]="q",g[g.r=114]="r",g[g.s=115]="s",g[g.t=116]="t",g[g.u=117]="u",g[g.v=118]="v",g[g.w=119]="w",g[g.x=120]="x",g[g.y=121]="y",g[g.z=122]="z",g[g.OpenCurlyBrace=123]="OpenCurlyBrace",g[g.Pipe=124]="Pipe",g[g.CloseCurlyBrace=125]="CloseCurlyBrace",g[g.Tilde=126]="Tilde",g[g.NoBreakSpace=160]="NoBreakSpace",g[g.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",g[g.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",g[g.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",g[g.U_Combining_Tilde=771]="U_Combining_Tilde",g[g.U_Combining_Macron=772]="U_Combining_Macron",g[g.U_Combining_Overline=773]="U_Combining_Overline",g[g.U_Combining_Breve=774]="U_Combining_Breve",g[g.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",g[g.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",g[g.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",g[g.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",g[g.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",g[g.U_Combining_Caron=780]="U_Combining_Caron",g[g.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",g[g.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",g[g.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",g[g.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",g[g.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",g[g.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",g[g.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",g[g.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",g[g.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",g[g.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",g[g.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",g[g.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",g[g.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",g[g.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",g[g.U_Combining_Horn=795]="U_Combining_Horn",g[g.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",g[g.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",g[g.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",g[g.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",g[g.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",g[g.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",g[g.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",g[g.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",g[g.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",g[g.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",g[g.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",g[g.U_Combining_Cedilla=807]="U_Combining_Cedilla",g[g.U_Combining_Ogonek=808]="U_Combining_Ogonek",g[g.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",g[g.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",g[g.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",g[g.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",g[g.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",g[g.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",g[g.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",g[g.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",g[g.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",g[g.U_Combining_Low_Line=818]="U_Combining_Low_Line",g[g.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",g[g.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",g[g.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",g[g.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",g[g.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",g[g.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",g[g.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",g[g.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",g[g.U_Combining_Square_Below=827]="U_Combining_Square_Below",g[g.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",g[g.U_Combining_X_Above=829]="U_Combining_X_Above",g[g.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",g[g.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",g[g.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",g[g.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",g[g.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",g[g.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",g[g.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",g[g.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",g[g.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",g[g.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",g[g.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",g[g.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",g[g.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",g[g.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",g[g.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",g[g.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",g[g.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",g[g.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",g[g.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",g[g.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",g[g.U_Combining_Fermata=850]="U_Combining_Fermata",g[g.U_Combining_X_Below=851]="U_Combining_X_Below",g[g.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",g[g.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",g[g.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",g[g.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",g[g.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",g[g.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",g[g.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",g[g.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",g[g.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",g[g.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",g[g.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",g[g.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",g[g.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",g[g.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",g[g.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",g[g.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",g[g.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",g[g.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",g[g.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",g[g.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",g[g.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",g[g.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",g[g.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",g[g.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",g[g.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",g[g.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",g[g.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",g[g.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",g[g.LINE_SEPARATOR=8232]="LINE_SEPARATOR",g[g.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",g[g.NEXT_LINE=133]="NEXT_LINE",g[g.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",g[g.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",g[g.U_DIAERESIS=168]="U_DIAERESIS",g[g.U_MACRON=175]="U_MACRON",g[g.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",g[g.U_CEDILLA=184]="U_CEDILLA",g[g.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",g[g.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",g[g.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",g[g.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",g[g.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",g[g.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",g[g.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",g[g.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",g[g.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",g[g.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",g[g.U_BREVE=728]="U_BREVE",g[g.U_DOT_ABOVE=729]="U_DOT_ABOVE",g[g.U_RING_ABOVE=730]="U_RING_ABOVE",g[g.U_OGONEK=731]="U_OGONEK",g[g.U_SMALL_TILDE=732]="U_SMALL_TILDE",g[g.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",g[g.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",g[g.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",g[g.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",g[g.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",g[g.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",g[g.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",g[g.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",g[g.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",g[g.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",g[g.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",g[g.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",g[g.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",g[g.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",g[g.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",g[g.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",g[g.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",g[g.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",g[g.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",g[g.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",g[g.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",g[g.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",g[g.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",g[g.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",g[g.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",g[g.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",g[g.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",g[g.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",g[g.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",g[g.U_GREEK_TONOS=900]="U_GREEK_TONOS",g[g.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",g[g.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",g[g.U_GREEK_PSILI=8127]="U_GREEK_PSILI",g[g.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",g[g.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",g[g.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",g[g.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",g[g.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",g[g.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",g[g.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",g[g.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",g[g.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",g[g.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",g[g.U_GREEK_VARIA=8175]="U_GREEK_VARIA",g[g.U_GREEK_OXIA=8189]="U_GREEK_OXIA",g[g.U_GREEK_DASIA=8190]="U_GREEK_DASIA",g[g.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",g[g.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",g[g.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",g[g.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",g[g.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",g[g.U_OVERLINE=8254]="U_OVERLINE",g[g.UTF8_BOM=65279]="UTF8_BOM",g[g.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",g[g.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(we[79],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=r,e.diffSets=g,e.diffMaps=k,e.intersection=A;function r(L,R){const v=Object.create(null);for(const l of L){const P=R(l);let y=v[P];y||(y=v[P]=[]),y.push(l)}return v}function g(L,R){const v=[],l=[];for(const P of L)R.has(P)||v.push(P);for(const P of R)L.has(P)||l.push(P);return{removed:v,added:l}}function k(L,R){const v=[],l=[];for(const[P,y]of L)R.has(P)||v.push(y);for(const[P,y]of R)L.has(P)||l.push(y);return{removed:v,added:l}}function A(L,R){const v=new Set;for(const l of R)L.has(l)&&v.add(l);return v}}),define(we[60],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=g,e.debounce=k,e.throttle=A;function r(L){return(R,v,l)=>{let P=null,y=null;if(typeof l.value=="function"?(P="value",y=l.value):typeof l.get=="function"&&(P="get",y=l.get),!y)throw new Error("not supported");l[P]=L(y,v)}}function g(L,R,v){let l=null,P=null;if(typeof v.value=="function"?(l="value",P=v.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(l="get",P=v.get),!P)throw new Error("not supported");const y=`$memoize$${R}`;v[l]=function(...d){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,d)}),this[y]}}function k(L,R,v){return r((l,P)=>{const y=`$debounce$${P}`,d=`$debounce$result$${P}`;return function(...T){this[d]||(this[d]=v?v():void 0),clearTimeout(this[y]),R&&(this[d]=R(this[d],...T),T=[this[d]]),this[y]=setTimeout(()=>{l.apply(this,T),this[d]=v?v():void 0},L)}})}function A(L,R,v){return r((l,P)=>{const y=`$throttle$timer$${P}`,d=`$throttle$result$${P}`,T=`$throttle$lastRun$${P}`,E=`$throttle$pending$${P}`;return function(...a){if(this[d]||(this[d]=v?v():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),R&&(this[d]=R(this[d],...a)),this[E])return;const u=this[T]+L;u<=Date.now()?(this[T]=Date.now(),l.apply(this,[this[d]]),this[d]=v?v():void 0):(this[E]=!0,this[y]=setTimeout(()=>{this[E]=!1,this[T]=Date.now(),l.apply(this,[this[d]]),this[d]=v?v():void 0},u-Date.now()))}})}}),define(we[14],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=g,e.isSigPipeError=k,e.onUnexpectedError=A,e.onUnexpectedExternalError=L,e.transformErrorForSerialization=R,e.isCancellationError=l,e.canceled=y,e.illegalArgument=d,e.illegalState=T,e.getErrorMessage=a;class r{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(c=>{c(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=r,e.errorHandler=new r;function g(i){e.errorHandler.setUnexpectedErrorHandler(i)}function k(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(i){l(i)||e.errorHandler.onUnexpectedError(i)}function L(i){l(i)||e.errorHandler.onUnexpectedExternalError(i)}function R(i){if(i instanceof Error){const{name:t,message:c}=i,h=i.stacktrace||i.stack;return{$isError:!0,name:t,message:c,stack:h,noTelemetry:n.isErrorNoTelemetry(i)}}return i}const v="Canceled";function l(i){return i instanceof P?!0:i instanceof Error&&i.name===v&&i.message===v}class P extends Error{constructor(){super(v),this.name=this.message}}e.CancellationError=P;function y(){const i=new Error(v);return i.name=i.message,i}function d(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function T(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class E extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=E;function a(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class u extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=u;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=f;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=m;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const c=new n;return c.message=t.message,c.stack=t.stack,c}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=n;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.BugIndicatingError=s}),define(we[19],ye([1,0,14,131]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=k,e.tail2=A,e.equals=L,e.removeFastWithoutKeepingOrder=R,e.binarySearch=v,e.binarySearch2=l,e.quickSelect=P,e.groupBy=y,e.groupAdjacentBy=d,e.forEachAdjacent=T,e.forEachWithNeighbors=E,e.sortedDiff=a,e.delta=u,e.top=f,e.topAsync=m,e.coalesce=s,e.coalesceInPlace=i,e.move=t,e.isFalsyOrEmpty=c,e.isNonEmptyArray=h,e.distinct=o,e.uniqueFilter=p,e.firstOrDefault=_,e.lastOrDefault=D,e.commonPrefixLength=C,e.range=S,e.index=I,e.insert=b,e.remove=w,e.arrayInsert=N,e.shuffle=O,e.pushToStart=U,e.pushToEnd=x,e.pushMany=B,e.mapArrayOrNot=F,e.asArray=M,e.getRandomElement=K,e.insertInto=ee,e.splice=$,e.compareBy=ne,e.tieBreakComparators=de,e.reverseOrder=ve;function k(ae,ie=0){return ae[ae.length-(1+ie)]}function A(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function L(ae,ie,le=(ue,Y)=>ue===Y){if(ae===ie)return!0;if(!ae||!ie||ae.length!==ie.length)return!1;for(let ue=0,Y=ae.length;ue<Y;ue++)if(!le(ae[ue],ie[ue]))return!1;return!0}function R(ae,ie){const le=ae.length-1;ie<le&&(ae[ie]=ae[le]),ae.pop()}function v(ae,ie,le){return l(ae.length,ue=>le(ae[ue],ie))}function l(ae,ie){let le=0,ue=ae-1;for(;le<=ue;){const Y=(le+ue)/2|0,oe=ie(Y);if(oe<0)le=Y+1;else if(oe>0)ue=Y-1;else return Y}return-(le+1)}function P(ae,ie,le){if(ae=ae|0,ae>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],Y=[],oe=[],pe=[];for(const Ee of ie){const Ne=le(Ee,ue);Ne<0?Y.push(Ee):Ne>0?oe.push(Ee):pe.push(Ee)}return ae<Y.length?P(ae,Y,le):ae<Y.length+pe.length?pe[0]:P(ae-(Y.length+pe.length),oe,le)}function y(ae,ie){const le=[];let ue;for(const Y of ae.slice(0).sort(ie))!ue||ie(ue[0],Y)!==0?(ue=[Y],le.push(ue)):ue.push(Y);return le}function*d(ae,ie){let le,ue;for(const Y of ae)ue!==void 0&&ie(ue,Y)?le.push(Y):(le&&(yield le),le=[Y]),ue=Y;le&&(yield le)}function T(ae,ie){for(let le=0;le<=ae.length;le++)ie(le===0?void 0:ae[le-1],le===ae.length?void 0:ae[le])}function E(ae,ie){for(let le=0;le<ae.length;le++)ie(le===0?void 0:ae[le-1],ae[le],le+1===ae.length?void 0:ae[le+1])}function a(ae,ie,le){const ue=[];function Y(Ee,Ne,We){if(Ne===0&&We.length===0)return;const Ce=ue[ue.length-1];Ce&&Ce.start+Ce.deleteCount===Ee?(Ce.deleteCount+=Ne,Ce.toInsert.push(...We)):ue.push({start:Ee,deleteCount:Ne,toInsert:We})}let oe=0,pe=0;for(;;){if(oe===ae.length){Y(oe,0,ie.slice(pe));break}if(pe===ie.length){Y(oe,ae.length-oe,[]);break}const Ee=ae[oe],Ne=ie[pe],We=le(Ee,Ne);We===0?(oe+=1,pe+=1):We<0?(Y(oe,1,[]),oe+=1):We>0&&(Y(oe,0,[Ne]),pe+=1)}return ue}function u(ae,ie,le){const ue=a(ae,ie,le),Y=[],oe=[];for(const pe of ue)Y.push(...ae.slice(pe.start,pe.start+pe.deleteCount)),oe.push(...pe.toInsert);return{removed:Y,added:oe}}function f(ae,ie,le){if(le===0)return[];const ue=ae.slice(0,le).sort(ie);return n(ae,ie,ue,le,ae.length),ue}function m(ae,ie,le,ue,Y){return le===0?Promise.resolve([]):new Promise((oe,pe)=>{(async()=>{const Ee=ae.length,Ne=ae.slice(0,le).sort(ie);for(let We=le,Ce=Math.min(le+ue,Ee);We<Ee;We=Ce,Ce=Math.min(Ce+ue,Ee)){if(We>le&&await new Promise(Ie=>setTimeout(Ie)),Y&&Y.isCancellationRequested)throw new r.CancellationError;n(ae,ie,Ne,We,Ce)}return Ne})().then(oe,pe)})}function n(ae,ie,le,ue,Y){for(const oe=le.length;ue<Y;ue++){const pe=ae[ue];if(ie(pe,le[oe-1])<0){le.pop();const Ee=(0,g.findFirstIdxMonotonousOrArrLen)(le,Ne=>ie(pe,Ne)<0);le.splice(Ee,0,pe)}}}function s(ae){return ae.filter(ie=>!!ie)}function i(ae){let ie=0;for(let le=0;le<ae.length;le++)ae[le]&&(ae[ie]=ae[le],ie+=1);ae.length=ie}function t(ae,ie,le){ae.splice(le,0,ae.splice(ie,1)[0])}function c(ae){return!Array.isArray(ae)||ae.length===0}function h(ae){return Array.isArray(ae)&&ae.length>0}function o(ae,ie=le=>le){const le=new Set;return ae.filter(ue=>{const Y=ie(ue);return le.has(Y)?!1:(le.add(Y),!0)})}function p(ae){const ie=new Set;return le=>{const ue=ae(le);return ie.has(ue)?!1:(ie.add(ue),!0)}}function _(ae,ie){return ae.length>0?ae[0]:ie}function D(ae,ie){return ae.length>0?ae[ae.length-1]:ie}function C(ae,ie,le=(ue,Y)=>ue===Y){let ue=0;for(let Y=0,oe=Math.min(ae.length,ie.length);Y<oe&&le(ae[Y],ie[Y]);Y++)ue++;return ue}function S(ae,ie){let le=typeof ie=="number"?ae:0;typeof ie=="number"?le=ae:(le=0,ie=ae);const ue=[];if(le<=ie)for(let Y=le;Y<ie;Y++)ue.push(Y);else for(let Y=le;Y>ie;Y--)ue.push(Y);return ue}function I(ae,ie,le){return ae.reduce((ue,Y)=>(ue[ie(Y)]=le?le(Y):Y,ue),Object.create(null))}function b(ae,ie){return ae.push(ie),()=>w(ae,ie)}function w(ae,ie){const le=ae.indexOf(ie);if(le>-1)return ae.splice(le,1),ie}function N(ae,ie,le){const ue=ae.slice(0,ie),Y=ae.slice(ie);return ue.concat(le,Y)}function O(ae,ie){let le;if(typeof ie=="number"){let ue=ie;le=()=>{const Y=Math.sin(ue++)*179426549;return Y-Math.floor(Y)}}else le=Math.random;for(let ue=ae.length-1;ue>0;ue-=1){const Y=Math.floor(le()*(ue+1)),oe=ae[ue];ae[ue]=ae[Y],ae[Y]=oe}}function U(ae,ie){const le=ae.indexOf(ie);le>-1&&(ae.splice(le,1),ae.unshift(ie))}function x(ae,ie){const le=ae.indexOf(ie);le>-1&&(ae.splice(le,1),ae.push(ie))}function B(ae,ie){for(const le of ie)ae.push(le)}function F(ae,ie){return Array.isArray(ae)?ae.map(ie):ie(ae)}function M(ae){return Array.isArray(ae)?ae:[ae]}function K(ae){return ae[Math.floor(Math.random()*ae.length)]}function ee(ae,ie,le){const ue=q(ae,ie),Y=ae.length,oe=le.length;ae.length=Y+oe;for(let pe=Y-1;pe>=ue;pe--)ae[pe+oe]=ae[pe];for(let pe=0;pe<oe;pe++)ae[pe+ue]=le[pe]}function $(ae,ie,le,ue){const Y=q(ae,ie);let oe=ae.splice(Y,le);return oe===void 0&&(oe=[]),ee(ae,Y,ue),oe}function q(ae,ie){return ie<0?Math.max(ie+ae.length,0):Math.min(ie,ae.length)}var Z;(function(ae){function ie(oe){return oe<0}ae.isLessThan=ie;function le(oe){return oe<=0}ae.isLessThanOrEqual=le;function ue(oe){return oe>0}ae.isGreaterThan=ue;function Y(oe){return oe===0}ae.isNeitherLessOrGreaterThan=Y,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(Z||(e.CompareResult=Z={}));function ne(ae,ie){return(le,ue)=>ie(ae(le),ae(ue))}function de(...ae){return(ie,le)=>{for(const ue of ae){const Y=ue(ie,le);if(!Z.isNeitherLessOrGreaterThan(Y))return Y}return Z.neitherLessOrGreaterThan}}const re=(ae,ie)=>ae-ie;e.numberComparator=re;const Se=(ae,ie)=>(0,e.numberComparator)(ae?1:0,ie?1:0);e.booleanComparator=Se;function ve(ae){return(ie,le)=>-ae(ie,le)}class G{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let le=this.firstIdx;for(;le<this.items.length&&ie(this.items[le]);)le++;const ue=le===this.firstIdx?null:this.items.slice(this.firstIdx,le);return this.firstIdx=le,ue}takeFromEndWhile(ie){let le=this.lastIdx;for(;le>=0&&ie(this.items[le]);)le--;const ue=le===this.lastIdx?null:this.items.slice(le+1,this.lastIdx+1);return this.lastIdx=le,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const le=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,le}}e.ArrayQueue=G;class W{static{this.empty=new W(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(le=>(ie(le),!0))}toArray(){const ie=[];return this.iterate(le=>(ie.push(le),!0)),ie}filter(ie){return new W(le=>this.iterate(ue=>ie(ue)?le(ue):!0))}map(ie){return new W(le=>this.iterate(ue=>le(ie(ue))))}some(ie){let le=!1;return this.iterate(ue=>(le=ie(ue),!le)),le}findFirst(ie){let le;return this.iterate(ue=>ie(ue)?(le=ue,!1):!0),le}findLast(ie){let le;return this.iterate(ue=>(ie(ue)&&(le=ue),!0)),le}findLastMaxBy(ie){let le,ue=!0;return this.iterate(Y=>((ue||Z.isGreaterThan(ie(Y,le)))&&(ue=!1,le=Y),!0)),le}}e.CallbackIterable=W;class se{constructor(ie){this._indexMap=ie}static createSortPermutation(ie,le){const ue=Array.from(ie.keys()).sort((Y,oe)=>le(ie[Y],ie[oe]));return new se(ue)}apply(ie){return ie.map((le,ue)=>ie[this._indexMap[ue]])}inverse(){const ie=this._indexMap.slice();for(let le=0;le<this._indexMap.length;le++)ie[this._indexMap[le]]=le;return new se(ie)}}e.Permutation=se}),define(we[65],ye([1,0,14]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=g,e.assertNever=k,e.assert=A,e.softAssert=L,e.assertFn=R,e.checkAdjacentItems=v;function g(l,P){if(!l)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}function k(l,P="Unreachable"){throw new Error(P)}function A(l,P="unexpected state"){if(!l)throw new r.BugIndicatingError(`Assertion Failed: ${P}`)}function L(l){l||(0,r.onUnexpectedError)(new r.BugIndicatingError("Soft Assertion Failed"))}function R(l){if(!l()){debugger;l(),(0,r.onUnexpectedError)(new r.BugIndicatingError("Assertion Failed"))}}function v(l,P){let y=0;for(;y<l.length-1;){const d=l[y],T=l[y+1];if(!P(d,T))return!1;y++}return!0}}),define(we[173],ye([1,0,19]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.strictEquals=void 0,e.itemsEquals=k,e.jsonStringifyEquals=A,e.itemEquals=L,e.equalsIfDefined=R,e.structuralEquals=v,e.getStructuralKey=l;const g=(T,E)=>T===E;e.strictEquals=g;function k(T=e.strictEquals){return(E,a)=>r.equals(E,a,T)}function A(){return(T,E)=>JSON.stringify(T)===JSON.stringify(E)}function L(){return(T,E)=>T.equals(E)}function R(T,E,a){return!T||!E?T===E:a(T,E)}function v(T,E){if(T===E)return!0;if(Array.isArray(T)&&Array.isArray(E)){if(T.length!==E.length)return!1;for(let a=0;a<T.length;a++)if(!v(T[a],E[a]))return!1;return!0}if(T&&typeof T=="object"&&E&&typeof E=="object"&&Object.getPrototypeOf(T)===Object.prototype&&Object.getPrototypeOf(E)===Object.prototype){const a=T,u=E,f=Object.keys(a),m=Object.keys(u),n=new Set(m);if(f.length!==m.length)return!1;for(const s of f)if(!n.has(s)||!v(a[s],u[s]))return!1;return!0}return!1}function l(T){return JSON.stringify(d(T))}let P=0;const y=new WeakMap;function d(T){if(Array.isArray(T))return T.map(d);if(T&&typeof T=="object")if(Object.getPrototypeOf(T)===Object.prototype){const E=T,a=Object.create(null);for(const u of Object.keys(E).sort())a[u]=d(E[u]);return a}else{let E=y.get(T);return E===void 0&&(E=P++,y.set(T,E)),E+"----2b76a038c20c4bcc"}return T}}),define(we[80],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=r;function r(g,k){const A=this;let L=!1,R;return function(){if(L)return R;if(L=!0,k)try{R=g.apply(A,arguments)}finally{k()}else R=g.apply(A,arguments);return R}}}),define(we[132],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(we[40],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(g){function k(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}g.is=k;const A=Object.freeze([]);function L(){return A}g.empty=L;function*R(t){yield t}g.single=R;function v(t){return k(t)?t:R(t)}g.wrap=v;function l(t){return t||A}g.from=l;function*P(t){for(let c=t.length-1;c>=0;c--)yield t[c]}g.reverse=P;function y(t){return!t||t[Symbol.iterator]().next().done===!0}g.isEmpty=y;function d(t){return t[Symbol.iterator]().next().value}g.first=d;function T(t,c){for(const h of t)if(c(h))return!0;return!1}g.some=T;function E(t,c){for(const h of t)if(c(h))return h}g.find=E;function*a(t,c){for(const h of t)c(h)&&(yield h)}g.filter=a;function*u(t,c){let h=0;for(const o of t)yield c(o,h++)}g.map=u;function*f(...t){for(const c of t)yield*c}g.concat=f;function m(t,c,h){let o=h;for(const p of t)o=c(o,p);return o}g.reduce=m;function*n(t,c,h=t.length){for(c<0&&(c+=t.length),h<0?h+=t.length:h>t.length&&(h=t.length);c<h;c++)yield t[c]}g.slice=n;function s(t,c=Number.POSITIVE_INFINITY){const h=[];if(c===0)return[h,t];const o=t[Symbol.iterator]();for(let p=0;p<c;p++){const _=o.next();if(_.done)return[h,g.empty()];h.push(_.value)}return[h,{[Symbol.iterator](){return o}}]}g.consume=s;async function i(t){const c=[];for await(const h of t)c.push(h);return Promise.resolve(c)}g.asyncToArray=i})(r||(e.Iterable=r={}))}),define(we[174],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=L,e.getLocation=y,e.parse=d,e.parseTree=T,e.findNodeAtLocation=E,e.getNodePath=a,e.getNodeValue=u,e.contains=f,e.findNodeAtOffset=m,e.visit=n,e.stripComments=s,e.getNodeType=i;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var g;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(g||(e.SyntaxKind=g={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function L(t,c=!1){let h=0;const o=t.length;let p="",_=0,D=g.Unknown,C=r.None;function S(x){let B=0,F=0;for(;B<x;){const M=t.charCodeAt(h);if(M>=P._0&&M<=P._9)F=F*16+M-P._0;else if(M>=P.A&&M<=P.F)F=F*16+M-P.A+10;else if(M>=P.a&&M<=P.f)F=F*16+M-P.a+10;else break;h++,B++}return B<x&&(F=-1),F}function I(x){h=x,p="",_=0,D=g.Unknown,C=r.None}function b(){const x=h;if(t.charCodeAt(h)===P._0)h++;else for(h++;h<t.length&&l(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===P.dot)if(h++,h<t.length&&l(t.charCodeAt(h)))for(h++;h<t.length&&l(t.charCodeAt(h));)h++;else return C=r.UnexpectedEndOfNumber,t.substring(x,h);let B=h;if(h<t.length&&(t.charCodeAt(h)===P.E||t.charCodeAt(h)===P.e))if(h++,(h<t.length&&t.charCodeAt(h)===P.plus||t.charCodeAt(h)===P.minus)&&h++,h<t.length&&l(t.charCodeAt(h))){for(h++;h<t.length&&l(t.charCodeAt(h));)h++;B=h}else C=r.UnexpectedEndOfNumber;return t.substring(x,B)}function w(){let x="",B=h;for(;;){if(h>=o){x+=t.substring(B,h),C=r.UnexpectedEndOfString;break}const F=t.charCodeAt(h);if(F===P.doubleQuote){x+=t.substring(B,h),h++;break}if(F===P.backslash){if(x+=t.substring(B,h),h++,h>=o){C=r.UnexpectedEndOfString;break}switch(t.charCodeAt(h++)){case P.doubleQuote:x+='"';break;case P.backslash:x+="\\";break;case P.slash:x+="/";break;case P.b:x+="\b";break;case P.f:x+="\f";break;case P.n:x+=`
`;break;case P.r:x+="\r";break;case P.t:x+="	";break;case P.u:{const K=S(4);K>=0?x+=String.fromCharCode(K):C=r.InvalidUnicode;break}default:C=r.InvalidEscapeCharacter}B=h;continue}if(F>=0&&F<=31)if(v(F)){x+=t.substring(B,h),C=r.UnexpectedEndOfString;break}else C=r.InvalidCharacter;h++}return x}function N(){if(p="",C=r.None,_=h,h>=o)return _=o,D=g.EOF;let x=t.charCodeAt(h);if(R(x)){do h++,p+=String.fromCharCode(x),x=t.charCodeAt(h);while(R(x));return D=g.Trivia}if(v(x))return h++,p+=String.fromCharCode(x),x===P.carriageReturn&&t.charCodeAt(h)===P.lineFeed&&(h++,p+=`
`),D=g.LineBreakTrivia;switch(x){case P.openBrace:return h++,D=g.OpenBraceToken;case P.closeBrace:return h++,D=g.CloseBraceToken;case P.openBracket:return h++,D=g.OpenBracketToken;case P.closeBracket:return h++,D=g.CloseBracketToken;case P.colon:return h++,D=g.ColonToken;case P.comma:return h++,D=g.CommaToken;case P.doubleQuote:return h++,p=w(),D=g.StringLiteral;case P.slash:{const B=h-1;if(t.charCodeAt(h+1)===P.slash){for(h+=2;h<o&&!v(t.charCodeAt(h));)h++;return p=t.substring(B,h),D=g.LineCommentTrivia}if(t.charCodeAt(h+1)===P.asterisk){h+=2;const F=o-1;let M=!1;for(;h<F;){if(t.charCodeAt(h)===P.asterisk&&t.charCodeAt(h+1)===P.slash){h+=2,M=!0;break}h++}return M||(h++,C=r.UnexpectedEndOfComment),p=t.substring(B,h),D=g.BlockCommentTrivia}return p+=String.fromCharCode(x),h++,D=g.Unknown}case P.minus:if(p+=String.fromCharCode(x),h++,h===o||!l(t.charCodeAt(h)))return D=g.Unknown;case P._0:case P._1:case P._2:case P._3:case P._4:case P._5:case P._6:case P._7:case P._8:case P._9:return p+=b(),D=g.NumericLiteral;default:for(;h<o&&O(x);)h++,x=t.charCodeAt(h);if(_!==h){switch(p=t.substring(_,h),p){case"true":return D=g.TrueKeyword;case"false":return D=g.FalseKeyword;case"null":return D=g.NullKeyword}return D=g.Unknown}return p+=String.fromCharCode(x),h++,D=g.Unknown}}function O(x){if(R(x)||v(x))return!1;switch(x){case P.closeBrace:case P.closeBracket:case P.openBrace:case P.openBracket:case P.doubleQuote:case P.colon:case P.comma:case P.slash:return!1}return!0}function U(){let x;do x=N();while(x>=g.LineCommentTrivia&&x<=g.Trivia);return x}return{setPosition:I,getPosition:()=>h,scan:c?U:N,getToken:()=>D,getTokenValue:()=>p,getTokenOffset:()=>_,getTokenLength:()=>h-_,getTokenError:()=>C}}function R(t){return t===P.space||t===P.tab||t===P.verticalTab||t===P.formFeed||t===P.nonBreakingSpace||t===P.ogham||t>=P.enQuad&&t<=P.zeroWidthSpace||t===P.narrowNoBreakSpace||t===P.mathematicalSpace||t===P.ideographicSpace||t===P.byteOrderMark}function v(t){return t===P.lineFeed||t===P.carriageReturn||t===P.lineSeparator||t===P.paragraphSeparator}function l(t){return t>=P._0&&t<=P._9}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function y(t,c){const h=[],o=new Object;let p;const _={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function C(S,I,b,w){_.value=S,_.offset=I,_.length=b,_.type=w,_.colonOffset=void 0,p=_}try{n(t,{onObjectBegin:(S,I)=>{if(c<=S)throw o;p=void 0,D=c>S,h.push("")},onObjectProperty:(S,I,b)=>{if(c<I||(C(S,I,b,"property"),h[h.length-1]=S,c<=I+b))throw o},onObjectEnd:(S,I)=>{if(c<=S)throw o;p=void 0,h.pop()},onArrayBegin:(S,I)=>{if(c<=S)throw o;p=void 0,h.push(0)},onArrayEnd:(S,I)=>{if(c<=S)throw o;p=void 0,h.pop()},onLiteralValue:(S,I,b)=>{if(c<I||(C(S,I,b,i(S)),c<=I+b))throw o},onSeparator:(S,I,b)=>{if(c<=I)throw o;if(S===":"&&p&&p.type==="property")p.colonOffset=I,D=!1,p=void 0;else if(S===","){const w=h[h.length-1];typeof w=="number"?h[h.length-1]=w+1:(D=!0,h[h.length-1]=""),p=void 0}}})}catch(S){if(S!==o)throw S}return{path:h,previousNode:p,isAtPropertyKey:D,matches:S=>{let I=0;for(let b=0;I<S.length&&b<h.length;b++)if(S[I]===h[b]||S[I]==="*")I++;else if(S[I]!=="**")return!1;return I===S.length}}}function d(t,c=[],h=A.DEFAULT){let o=null,p=[];const _=[];function D(S){Array.isArray(p)?p.push(S):o!==null&&(p[o]=S)}return n(t,{onObjectBegin:()=>{const S={};D(S),_.push(p),p=S,o=null},onObjectProperty:S=>{o=S},onObjectEnd:()=>{p=_.pop()},onArrayBegin:()=>{const S=[];D(S),_.push(p),p=S,o=null},onArrayEnd:()=>{p=_.pop()},onLiteralValue:D,onError:(S,I,b)=>{c.push({error:S,offset:I,length:b})}},h),p[0]}function T(t,c=[],h=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(S){o.type==="property"&&(o.length=S-o.offset,o=o.parent)}function _(S){return o.children.push(S),S}n(t,{onObjectBegin:S=>{o=_({type:"object",offset:S,length:-1,parent:o,children:[]})},onObjectProperty:(S,I,b)=>{o=_({type:"property",offset:I,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:S,offset:I,length:b,parent:o})},onObjectEnd:(S,I)=>{o.length=S+I-o.offset,o=o.parent,p(S+I)},onArrayBegin:(S,I)=>{o=_({type:"array",offset:S,length:-1,parent:o,children:[]})},onArrayEnd:(S,I)=>{o.length=S+I-o.offset,o=o.parent,p(S+I)},onLiteralValue:(S,I,b)=>{_({type:i(S),offset:I,length:b,parent:o,value:S}),p(I+b)},onSeparator:(S,I,b)=>{o.type==="property"&&(S===":"?o.colonOffset=I:S===","&&p(I))},onError:(S,I,b)=>{c.push({error:S,offset:I,length:b})}},h);const C=o.children[0];return C&&delete C.parent,C}function E(t,c){if(!t)return;let h=t;for(const o of c)if(typeof o=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let p=!1;for(const _ of h.children)if(Array.isArray(_.children)&&_.children[0].value===o){h=_.children[1],p=!0;break}if(!p)return}else{const p=o;if(h.type!=="array"||p<0||!Array.isArray(h.children)||p>=h.children.length)return;h=h.children[p]}return h}function a(t){if(!t.parent||!t.parent.children)return[];const c=a(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;c.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&c.push(h)}return c}function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const c=Object.create(null);for(const h of t.children){const o=h.children[1];o&&(c[h.children[0].value]=u(o))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function f(t,c,h=!1){return c>=t.offset&&c<t.offset+t.length||h&&c===t.offset+t.length}function m(t,c,h=!1){if(f(t,c,h)){const o=t.children;if(Array.isArray(o))for(let p=0;p<o.length&&o[p].offset<=c;p++){const _=m(o[p],c,h);if(_)return _}return t}}function n(t,c,h=A.DEFAULT){const o=L(t,!1);function p(de){return de?()=>de(o.getTokenOffset(),o.getTokenLength()):()=>!0}function _(de){return de?re=>de(re,o.getTokenOffset(),o.getTokenLength()):()=>!0}const D=p(c.onObjectBegin),C=_(c.onObjectProperty),S=p(c.onObjectEnd),I=p(c.onArrayBegin),b=p(c.onArrayEnd),w=_(c.onLiteralValue),N=_(c.onSeparator),O=p(c.onComment),U=_(c.onError),x=h&&h.disallowComments,B=h&&h.allowTrailingComma;function F(){for(;;){const de=o.scan();switch(o.getTokenError()){case r.InvalidUnicode:M(k.InvalidUnicode);break;case r.InvalidEscapeCharacter:M(k.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:M(k.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:x||M(k.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:M(k.UnexpectedEndOfString);break;case r.InvalidCharacter:M(k.InvalidCharacter);break}switch(de){case g.LineCommentTrivia:case g.BlockCommentTrivia:x?M(k.InvalidCommentToken):O();break;case g.Unknown:M(k.InvalidSymbol);break;case g.Trivia:case g.LineBreakTrivia:break;default:return de}}}function M(de,re=[],Se=[]){if(U(de),re.length+Se.length>0){let ve=o.getToken();for(;ve!==g.EOF;){if(re.indexOf(ve)!==-1){F();break}else if(Se.indexOf(ve)!==-1)break;ve=F()}}}function K(de){const re=o.getTokenValue();return de?w(re):C(re),F(),!0}function ee(){switch(o.getToken()){case g.NumericLiteral:{let de=0;try{de=JSON.parse(o.getTokenValue()),typeof de!="number"&&(M(k.InvalidNumberFormat),de=0)}catch{M(k.InvalidNumberFormat)}w(de);break}case g.NullKeyword:w(null);break;case g.TrueKeyword:w(!0);break;case g.FalseKeyword:w(!1);break;default:return!1}return F(),!0}function $(){return o.getToken()!==g.StringLiteral?(M(k.PropertyNameExpected,[],[g.CloseBraceToken,g.CommaToken]),!1):(K(!1),o.getToken()===g.ColonToken?(N(":"),F(),ne()||M(k.ValueExpected,[],[g.CloseBraceToken,g.CommaToken])):M(k.ColonExpected,[],[g.CloseBraceToken,g.CommaToken]),!0)}function q(){D(),F();let de=!1;for(;o.getToken()!==g.CloseBraceToken&&o.getToken()!==g.EOF;){if(o.getToken()===g.CommaToken){if(de||M(k.ValueExpected,[],[]),N(","),F(),o.getToken()===g.CloseBraceToken&&B)break}else de&&M(k.CommaExpected,[],[]);$()||M(k.ValueExpected,[],[g.CloseBraceToken,g.CommaToken]),de=!0}return S(),o.getToken()!==g.CloseBraceToken?M(k.CloseBraceExpected,[g.CloseBraceToken],[]):F(),!0}function Z(){I(),F();let de=!1;for(;o.getToken()!==g.CloseBracketToken&&o.getToken()!==g.EOF;){if(o.getToken()===g.CommaToken){if(de||M(k.ValueExpected,[],[]),N(","),F(),o.getToken()===g.CloseBracketToken&&B)break}else de&&M(k.CommaExpected,[],[]);ne()||M(k.ValueExpected,[],[g.CloseBracketToken,g.CommaToken]),de=!0}return b(),o.getToken()!==g.CloseBracketToken?M(k.CloseBracketExpected,[g.CloseBracketToken],[]):F(),!0}function ne(){switch(o.getToken()){case g.OpenBracketToken:return Z();case g.OpenBraceToken:return q();case g.StringLiteral:return K(!0);default:return ee()}}return F(),o.getToken()===g.EOF?h.allowEmptyContent?!0:(M(k.ValueExpected,[],[]),!1):ne()?(o.getToken()!==g.EOF&&M(k.EndOfFileExpected,[],[]),!0):(M(k.ValueExpected,[],[]),!1)}function s(t,c){const h=L(t),o=[];let p,_=0,D;do switch(D=h.getPosition(),p=h.scan(),p){case g.LineCommentTrivia:case g.BlockCommentTrivia:case g.EOF:_!==D&&o.push(t.substring(_,D)),c!==void 0&&o.push(h.getTokenValue().replace(/[^\r\n]/g,c)),_=h.getPosition();break}while(p!==g.EOF);return o.join("")}function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(we[49],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class r{constructor(k){this.executor=k,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=r}),define(we[81],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class r{static{this.Undefined=new r(void 0)}constructor(A){this.element=A,this.next=r.Undefined,this.prev=r.Undefined}}class g{constructor(){this._first=r.Undefined,this._last=r.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===r.Undefined}clear(){let A=this._first;for(;A!==r.Undefined;){const L=A.next;A.prev=r.Undefined,A.next=r.Undefined,A=L}this._first=r.Undefined,this._last=r.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,L){const R=new r(A);if(this._first===r.Undefined)this._first=R,this._last=R;else if(L){const l=this._last;this._last=R,R.prev=l,l.next=R}else{const l=this._first;this._first=R,R.next=l,l.prev=R}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(R))}}shift(){if(this._first!==r.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==r.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==r.Undefined&&A.next!==r.Undefined){const L=A.prev;L.next=A.next,A.next.prev=L}else A.prev===r.Undefined&&A.next===r.Undefined?(this._first=r.Undefined,this._last=r.Undefined):A.next===r.Undefined?(this._last=this._last.prev,this._last.next=r.Undefined):A.prev===r.Undefined&&(this._first=this._first.next,this._first.prev=r.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==r.Undefined;)yield A.element,A=A.next}}e.LinkedList=g}),define(we[29],ye([1,0]),function(he,e){"use strict";var r,g,k;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=A,e.mapToString=L,e.setToString=R,e.mapsStrictEqualIgnoreOrder=s;function A(i,t,c){let h=i.get(t);return h===void 0&&(h=c,i.set(t,h)),h}function L(i){const t=[];return i.forEach((c,h)=>{t.push(`${h} => ${c}`)}),`Map(${i.size}) {${t.join(", ")}}`}function R(i){const t=[];return i.forEach(c=>{t.push(c)}),`Set(${i.size}) {${t.join(", ")}}`}class v{constructor(t,c){this.uri=t,this.value=c}}function l(i){return Array.isArray(i)}class P{static{this.defaultToKey=t=>t.toString()}constructor(t,c){if(this[r]="ResourceMap",t instanceof P)this.map=new Map(t.map),this.toKey=c??P.defaultToKey;else if(l(t)){this.map=new Map,this.toKey=c??P.defaultToKey;for(const[h,o]of t)this.set(h,o)}else this.map=new Map,this.toKey=t??P.defaultToKey}set(t,c){return this.map.set(this.toKey(t),new v(t,c)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,c){typeof c<"u"&&(t=t.bind(c));for(const[h,o]of this.map)t(o.value,o.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=P;class y{constructor(t,c){this[g]="ResourceSet",!t||typeof t=="function"?this._map=new P(t):(this._map=new P(c),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,c){this._map.forEach((h,o)=>t.call(c,o,o,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=y;var d;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class T{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,c=d.None){const h=this._map.get(t);if(h)return c!==d.None&&this.touch(h,c),h.value}set(t,c,h=d.None){let o=this._map.get(t);if(o)o.value=c,h!==d.None&&this.touch(o,h);else{switch(o={key:t,value:c,next:void 0,previous:void 0},h){case d.None:this.addItemLast(o);break;case d.AsOld:this.addItemFirst(o);break;case d.AsNew:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(t,o),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this._map.get(t);if(c)return this._map.delete(t),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,c){const h=this._state;let o=this._head;for(;o;){if(c?t.bind(c)(o.value,o.key,this):t(o.value,o.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const t=this,c=this._state;let h=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:h.key,done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return o}values(){const t=this,c=this._state;let h=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:h.value,done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return o}entries(){const t=this,c=this._state;let h=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:[h.key,h.value],done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return o}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this._head,h=this.size;for(;c&&h>t;)this._map.delete(c.key),c=c.next,h--;this._head=c,this._size=h,c&&(c.previous=void 0),this._state++}trimNew(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this._tail,h=this.size;for(;c&&h>t;)this._map.delete(c.key),c=c.previous,h--;this._tail=c,this._size=h,c&&(c.next=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const c=t.next,h=t.previous;if(!c||!h)throw new Error("Invalid list");c.previous=h,h.next=c}t.next=void 0,t.previous=void 0,this._state++}touch(t,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==d.AsOld&&c!==d.AsNew)){if(c===d.AsOld){if(t===this._head)return;const h=t.next,o=t.previous;t===this._tail?(o.next=void 0,this._tail=o):(h.previous=o,o.next=h),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(c===d.AsNew){if(t===this._tail)return;const h=t.next,o=t.previous;t===this._head?(h.previous=void 0,this._head=h):(h.previous=o,o.next=h),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((c,h)=>{t.push([h,c])}),t}fromJSON(t){this.clear();for(const[c,h]of t)this.set(c,h)}}e.LinkedMap=T;class E extends T{constructor(t,c=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,c=d.AsNew){return super.get(t,c)}peek(t){return super.get(t,d.None)}set(t,c){return super.set(t,c,d.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class a extends E{constructor(t,c=1){super(t,c)}trim(t){this.trimOld(t)}set(t,c){return super.set(t,c),this.checkTrim(),this}}e.LRUCache=a;class u extends E{constructor(t,c=1){super(t,c)}trim(t){this.trimNew(t)}set(t,c){return this._limit<=this.size&&!this.has(t)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(t,c),this}}e.MRUCache=u;class f{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let c=this.map.get(t)||0;return c===0?!1:(c--,c===0?this.map.delete(t):this.map.set(t,c),!0)}has(t){return this.map.has(t)}}e.CounterSet=f;class m{constructor(t){if(this._m1=new Map,this._m2=new Map,t)for(const[c,h]of t)this.set(c,h)}clear(){this._m1.clear(),this._m2.clear()}set(t,c){this._m1.set(t,c),this._m2.set(c,t)}get(t){return this._m1.get(t)}getKey(t){return this._m2.get(t)}delete(t){const c=this._m1.get(t);return c===void 0?!1:(this._m1.delete(t),this._m2.delete(c),!0)}forEach(t,c){this._m1.forEach((h,o)=>{t.call(c,h,o,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=m;class n{constructor(){this.map=new Map}add(t,c){let h=this.map.get(t);h||(h=new Set,this.map.set(t,h)),h.add(c)}delete(t,c){const h=this.map.get(t);h&&(h.delete(c),h.size===0&&this.map.delete(t))}forEach(t,c){const h=this.map.get(t);h&&h.forEach(c)}get(t){const c=this.map.get(t);return c||new Set}}e.SetMap=n;function s(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[c,h]of i)if(!t.has(c)||t.get(c)!==h)return!1;for(const[c]of t)if(!i.has(c))return!1;return!0}}),define(we[3],ye([1,0,19,79,29,80,40]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=P,e.trackDisposable=y,e.markAsDisposed=d,e.markAsSingleton=a,e.isDisposable=u,e.dispose=f,e.disposeIfDisposable=m,e.combinedDisposable=n,e.toDisposable=s,e.disposeOnReturn=S;const R=!1;let v=null;class l{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(w){let N=this.livingDisposables.get(w);return N||(N={parent:null,source:null,isSingleton:!1,value:w,idx:l.idx++},this.livingDisposables.set(w,N)),N}trackDisposable(w){const N=this.getDisposableData(w);N.source||(N.source=new Error().stack)}setParent(w,N){const O=this.getDisposableData(w);O.parent=N}markAsDisposed(w){this.livingDisposables.delete(w)}markAsSingleton(w){this.getDisposableData(w).isSingleton=!0}getRootParent(w,N){const O=N.get(w);if(O)return O;const U=w.parent?this.getRootParent(this.getDisposableData(w.parent),N):w;return N.set(w,U),U}getTrackedDisposables(){const w=new Map;return[...this.livingDisposables.entries()].filter(([,O])=>O.source!==null&&!this.getRootParent(O,w).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(w=10,N){let O;if(N)O=N;else{const M=new Map,K=[...this.livingDisposables.values()].filter($=>$.source!==null&&!this.getRootParent($,M).isSingleton);if(K.length===0)return;const ee=new Set(K.map($=>$.value));if(O=K.filter($=>!($.parent&&ee.has($.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function U(M){function K($,q){for(;$.length>0&&q.some(Z=>typeof Z=="string"?Z===$[0]:$[0].match(Z));)$.shift()}const ee=M.source.split(`
`).map($=>$.trim().replace("at ","")).filter($=>$!=="");return K(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const x=new k.SetMap;for(const M of O){const K=U(M);for(let ee=0;ee<=K.length;ee++)x.add(K.slice(0,ee).join(`
`),M)}O.sort((0,r.compareBy)(M=>M.idx,r.numberComparator));let B="",F=0;for(const M of O.slice(0,w)){F++;const K=U(M),ee=[];for(let $=0;$<K.length;$++){let q=K[$];q=`(shared with ${x.get(K.slice(0,$+1).join(`
`)).size}/${O.length} leaks) at ${q}`;const ne=x.get(K.slice(0,$).join(`
`)),de=(0,g.groupBy)([...ne].map(re=>U(re)[$]),re=>re);delete de[K[$]];for(const[re,Se]of Object.entries(de))ee.unshift(`    - stacktraces of ${Se.length} other leaks continue with ${re}`);ee.unshift(q)}B+=`


==================== Leaking disposable ${F}/${O.length}: ${M.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return O.length>w&&(B+=`


... and ${O.length-w} more leaking disposables

`),{leaks:O,details:B}}}e.DisposableTracker=l;function P(b){v=b}if(R){const b="__is_disposable_tracked__";P(new class{trackDisposable(w){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{w[b]||console.log(N)},3e3)}setParent(w,N){if(w&&w!==t.None)try{w[b]=!0}catch{}}markAsDisposed(w){if(w&&w!==t.None)try{w[b]=!0}catch{}}markAsSingleton(w){}})}function y(b){return v?.trackDisposable(b),b}function d(b){v?.markAsDisposed(b)}function T(b,w){v?.setParent(b,w)}function E(b,w){if(v)for(const N of b)v.setParent(N,w)}function a(b){return v?.markAsSingleton(b),b}function u(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function f(b){if(L.Iterable.is(b)){const w=[];for(const N of b)if(N)try{N.dispose()}catch(O){w.push(O)}if(w.length===1)throw w[0];if(w.length>1)throw new AggregateError(w,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function m(b){for(const w of b)u(w)&&w.dispose();return[]}function n(...b){const w=s(()=>f(b));return E(b,w),w}function s(b){const w=y({dispose:(0,A.createSingleCallFunction)(()=>{d(w),b()})});return w}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{f(this._toDispose)}finally{this._toDispose.clear()}}add(w){if(!w)return w;if(w===this)throw new Error("Cannot register a disposable on itself!");return T(w,this),this._isDisposed?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(w),w}delete(w){if(w){if(w===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(w),w.dispose()}}deleteAndLeak(w){w&&this._toDispose.has(w)&&(this._toDispose.delete(w),T(w,null))}}e.DisposableStore=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new i,y(this),T(this._store,this)}dispose(){d(this),this._store.dispose()}_register(w){if(w===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(w)}}e.Disposable=t;class c{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(w){this._isDisposed||w===this._value||(this._value?.dispose(),w&&T(w,this),this._value=w)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const w=this._value;return this._value=void 0,w&&T(w,null),w}}e.MutableDisposable=c;class h{constructor(w){this._disposable=new c,this._isDisposed=!1,this._disposable.value=w}get value(){return this._disposable.value}set value(w){this._isDisposed||w===this._disposable.value||(this._disposable.value=w)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=h;class o{constructor(w){this._disposable=w,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(w){let N=w;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,d(this))},this}}e.SafeDisposable=p;class _{constructor(){this.references=new Map}acquire(w,...N){let O=this.references.get(w);O||(O={counter:0,object:this.createReferencedObject(w,...N)},this.references.set(w,O));const{object:U}=O,x=(0,A.createSingleCallFunction)(()=>{--O.counter===0&&(this.destroyReferencedObject(w,O.object),this.references.delete(w))});return O.counter++,{object:U,dispose:x}}}e.ReferenceCollection=_;class D{constructor(w){this.referenceCollection=w}async acquire(w,...N){const O=this.referenceCollection.acquire(w,...N);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(U){throw O.dispose(),U}}}e.AsyncReferenceCollection=D;class C{constructor(w){this.object=w}dispose(){}}e.ImmortalReference=C;function S(b){const w=new i;try{b(w)}finally{w.dispose()}}class I{constructor(){this._store=new Map,this._isDisposed=!1,y(this)}dispose(){d(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{f(this._store.values())}finally{this._store.clear()}}has(w){return this._store.has(w)}get size(){return this._store.size}get(w){return this._store.get(w)}set(w,N,O=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this._store.get(w)?.dispose(),this._store.set(w,N)}deleteAndDispose(w){this._store.get(w)?.dispose(),this._store.delete(w)}deleteAndLeak(w){const N=this._store.get(w);return this._store.delete(w),N}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=I}),function(he,e){typeof define=="function"&&define.amd?define(we[175],ye([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(ie,le){for(var ue=0;ue<le.length;ue++){var Y=le[ue];Y.enumerable=Y.enumerable||!1,Y.configurable=!0,"value"in Y&&(Y.writable=!0),Object.defineProperty(ie,Y.key,Y)}}function r(ie,le,ue){return le&&e(ie.prototype,le),ue&&e(ie,ue),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function g(ie,le){if(ie){if(typeof ie=="string")return k(ie,le);var ue=Object.prototype.toString.call(ie).slice(8,-1);if(ue==="Object"&&ie.constructor&&(ue=ie.constructor.name),ue==="Map"||ue==="Set")return Array.from(ie);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return k(ie,le)}}function k(ie,le){(le==null||le>ie.length)&&(le=ie.length);for(var ue=0,Y=new Array(le);ue<le;ue++)Y[ue]=ie[ue];return Y}function A(ie,le){var ue=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(ue)return(ue=ue.call(ie)).next.bind(ue);if(Array.isArray(ie)||(ue=g(ie))||le&&ie&&typeof ie.length=="number"){ue&&(ie=ue);var Y=0;return function(){return Y>=ie.length?{done:!0}:{done:!1,value:ie[Y++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=L();function R(ie){he.defaults=ie}var v=/[&<>"']/,l=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(le){return d[le]};function E(ie,le){if(le){if(v.test(ie))return ie.replace(l,T)}else if(P.test(ie))return ie.replace(y,T);return ie}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(ie){return ie.replace(a,function(le,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var f=/(^|[^\[])\^/g;function m(ie,le){ie=typeof ie=="string"?ie:ie.source,le=le||"";var ue={replace:function(oe,pe){return pe=pe.source||pe,pe=pe.replace(f,"$1"),ie=ie.replace(oe,pe),ue},getRegex:function(){return new RegExp(ie,le)}};return ue}var n=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function i(ie,le,ue){if(ie){var Y;try{Y=decodeURIComponent(u(ue)).replace(n,"").toLowerCase()}catch{return null}if(Y.indexOf("javascript:")===0||Y.indexOf("vbscript:")===0||Y.indexOf("data:")===0)return null}le&&!s.test(ue)&&(ue=p(le,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var t={},c=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(ie,le){t[" "+ie]||(c.test(ie)?t[" "+ie]=ie+"/":t[" "+ie]=S(ie,"/",!0)),ie=t[" "+ie];var ue=ie.indexOf(":")===-1;return le.substring(0,2)==="//"?ue?le:ie.replace(h,"$1")+le:le.charAt(0)==="/"?ue?le:ie.replace(o,"$1")+le:ie+le}var _={exec:function(){}};function D(ie){for(var le=1,ue,Y;le<arguments.length;le++){ue=arguments[le];for(Y in ue)Object.prototype.hasOwnProperty.call(ue,Y)&&(ie[Y]=ue[Y])}return ie}function C(ie,le){var ue=ie.replace(/\|/g,function(pe,Ee,Ne){for(var We=!1,Ce=Ee;--Ce>=0&&Ne[Ce]==="\\";)We=!We;return We?"|":" |"}),Y=ue.split(/ \|/),oe=0;if(Y[0].trim()||Y.shift(),Y.length>0&&!Y[Y.length-1].trim()&&Y.pop(),Y.length>le)Y.splice(le);else for(;Y.length<le;)Y.push("");for(;oe<Y.length;oe++)Y[oe]=Y[oe].trim().replace(/\\\|/g,"|");return Y}function S(ie,le,ue){var Y=ie.length;if(Y===0)return"";for(var oe=0;oe<Y;){var pe=ie.charAt(Y-oe-1);if(pe===le&&!ue)oe++;else if(pe!==le&&ue)oe++;else break}return ie.slice(0,Y-oe)}function I(ie,le){if(ie.indexOf(le[1])===-1)return-1;for(var ue=ie.length,Y=0,oe=0;oe<ue;oe++)if(ie[oe]==="\\")oe++;else if(ie[oe]===le[0])Y++;else if(ie[oe]===le[1]&&(Y--,Y<0))return oe;return-1}function b(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(ie,le){if(le<1)return"";for(var ue="";le>1;)le&1&&(ue+=ie),le>>=1,ie+=ie;return ue+ie}function N(ie,le,ue,Y){var oe=le.href,pe=le.title?E(le.title):null,Ee=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){Y.state.inLink=!0;var Ne={type:"link",raw:ue,href:oe,title:pe,text:Ee,tokens:Y.inlineTokens(Ee)};return Y.state.inLink=!1,Ne}return{type:"image",raw:ue,href:oe,title:pe,text:E(Ee)}}function O(ie,le){var ue=ie.match(/^(\s+)(?:```)/);if(ue===null)return le;var Y=ue[1];return le.split(`
`).map(function(oe){var pe=oe.match(/^\s+/);if(pe===null)return oe;var Ee=pe[0];return Ee.length>=Y.length?oe.slice(Y.length):oe}).join(`
`)}var U=function(){function ie(ue){this.options=ue||he.defaults}var le=ie.prototype;return le.space=function(Y){var oe=this.rules.block.newline.exec(Y);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},le.code=function(Y){var oe=this.rules.block.code.exec(Y);if(oe){var pe=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:S(pe,`
`)}}},le.fences=function(Y){var oe=this.rules.block.fences.exec(Y);if(oe){var pe=oe[0],Ee=O(pe,oe[3]||"");return{type:"code",raw:pe,lang:oe[2]?oe[2].trim():oe[2],text:Ee}}},le.heading=function(Y){var oe=this.rules.block.heading.exec(Y);if(oe){var pe=oe[2].trim();if(/#$/.test(pe)){var Ee=S(pe,"#");(this.options.pedantic||!Ee||/ $/.test(Ee))&&(pe=Ee.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:pe,tokens:this.lexer.inline(pe)}}},le.hr=function(Y){var oe=this.rules.block.hr.exec(Y);if(oe)return{type:"hr",raw:oe[0]}},le.blockquote=function(Y){var oe=this.rules.block.blockquote.exec(Y);if(oe){var pe=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},le.list=function(Y){var oe=this.rules.block.list.exec(Y);if(oe){var pe,Ee,Ne,We,Ce,Ie,Le,z,H,X,J,fe,be=oe[1].trim(),Fe=be.length>1,He={type:"list",raw:"",ordered:Fe,start:Fe?+be.slice(0,-1):"",loose:!1,items:[]};be=Fe?"\\d{1,9}\\"+be.slice(-1):"\\"+be,this.options.pedantic&&(be=Fe?be:"[*+-]");for(var qe=new RegExp("^( {0,3}"+be+")((?:[	 ][^\\n]*)?(?:\\n|$))");Y&&(fe=!1,!(!(oe=qe.exec(Y))||this.rules.block.hr.test(Y)));){if(pe=oe[0],Y=Y.substring(pe.length),z=oe[2].split(`
`,1)[0],H=Y.split(`
`,1)[0],this.options.pedantic?(We=2,J=z.trimLeft()):(We=oe[2].search(/[^ ]/),We=We>4?1:We,J=z.slice(We),We+=oe[1].length),Ie=!1,!z&&/^ *$/.test(H)&&(pe+=H+`
`,Y=Y.substring(H.length+1),fe=!0),!fe)for(var Ye=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,We-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,We-1)+"}#");Y&&(X=Y.split(`
`,1)[0],z=X,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(z)||rt.test(z)||Ye.test(z)||it.test(Y)));){if(z.search(/[^ ]/)>=We||!z.trim())J+=`
`+z.slice(We);else if(!Ie)J+=`
`+z;else break;!Ie&&!z.trim()&&(Ie=!0),pe+=X+`
`,Y=Y.substring(X.length+1)}He.loose||(Le?He.loose=!0:/\n *\n *$/.test(pe)&&(Le=!0)),this.options.gfm&&(Ee=/^\[[ xX]\] /.exec(J),Ee&&(Ne=Ee[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:pe,task:!!Ee,checked:Ne,loose:!1,text:J}),He.raw+=pe}He.items[He.items.length-1].raw=pe.trimRight(),He.items[He.items.length-1].text=J.trimRight(),He.raw=He.raw.trimRight();var ot=He.items.length;for(Ce=0;Ce<ot;Ce++){this.lexer.state.top=!1,He.items[Ce].tokens=this.lexer.blockTokens(He.items[Ce].text,[]);var ft=He.items[Ce].tokens.filter(function(st){return st.type==="space"}),ut=ft.every(function(st){for(var Te=st.raw.split(""),Ue=0,ke=A(Te),Re;!(Re=ke()).done;){var ce=Re.value;if(ce===`
`&&(Ue+=1),Ue>1)return!0}return!1});!He.loose&&ft.length&&ut&&(He.loose=!0,He.items[Ce].loose=!0)}return He}},le.html=function(Y){var oe=this.rules.block.html.exec(Y);if(oe){var pe={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var Ee=this.options.sanitizer?this.options.sanitizer(oe[0]):E(oe[0]);pe.type="paragraph",pe.text=Ee,pe.tokens=this.lexer.inline(Ee)}return pe}},le.def=function(Y){var oe=this.rules.block.def.exec(Y);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var pe=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:oe[0],href:oe[2],title:oe[3]}}},le.table=function(Y){var oe=this.rules.block.table.exec(Y);if(oe){var pe={type:"table",header:C(oe[1]).map(function(Le){return{text:Le}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=oe[0];var Ee=pe.align.length,Ne,We,Ce,Ie;for(Ne=0;Ne<Ee;Ne++)/^ *-+: *$/.test(pe.align[Ne])?pe.align[Ne]="right":/^ *:-+: *$/.test(pe.align[Ne])?pe.align[Ne]="center":/^ *:-+ *$/.test(pe.align[Ne])?pe.align[Ne]="left":pe.align[Ne]=null;for(Ee=pe.rows.length,Ne=0;Ne<Ee;Ne++)pe.rows[Ne]=C(pe.rows[Ne],pe.header.length).map(function(Le){return{text:Le}});for(Ee=pe.header.length,We=0;We<Ee;We++)pe.header[We].tokens=this.lexer.inline(pe.header[We].text);for(Ee=pe.rows.length,We=0;We<Ee;We++)for(Ie=pe.rows[We],Ce=0;Ce<Ie.length;Ce++)Ie[Ce].tokens=this.lexer.inline(Ie[Ce].text);return pe}}},le.lheading=function(Y){var oe=this.rules.block.lheading.exec(Y);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},le.paragraph=function(Y){var oe=this.rules.block.paragraph.exec(Y);if(oe){var pe=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:pe,tokens:this.lexer.inline(pe)}}},le.text=function(Y){var oe=this.rules.block.text.exec(Y);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},le.escape=function(Y){var oe=this.rules.inline.escape.exec(Y);if(oe)return{type:"escape",raw:oe[0],text:E(oe[1])}},le.tag=function(Y){var oe=this.rules.inline.tag.exec(Y);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):E(oe[0]):oe[0]}},le.link=function(Y){var oe=this.rules.inline.link.exec(Y);if(oe){var pe=oe[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var Ee=S(pe.slice(0,-1),"\\");if((pe.length-Ee.length)%2===0)return}else{var Ne=I(oe[2],"()");if(Ne>-1){var We=oe[0].indexOf("!")===0?5:4,Ce=We+oe[1].length+Ne;oe[2]=oe[2].substring(0,Ne),oe[0]=oe[0].substring(0,Ce).trim(),oe[3]=""}}var Ie=oe[2],Le="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);z&&(Ie=z[1],Le=z[3])}else Le=oe[3]?oe[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(pe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),N(oe,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Le&&Le.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},le.reflink=function(Y,oe){var pe;if((pe=this.rules.inline.reflink.exec(Y))||(pe=this.rules.inline.nolink.exec(Y))){var Ee=(pe[2]||pe[1]).replace(/\s+/g," ");if(Ee=oe[Ee.toLowerCase()],!Ee||!Ee.href){var Ne=pe[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return N(pe,Ee,pe[0],this.lexer)}},le.emStrong=function(Y,oe,pe){pe===void 0&&(pe="");var Ee=this.rules.inline.emStrong.lDelim.exec(Y);if(Ee&&!(Ee[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=Ee[1]||Ee[2]||"";if(!Ne||Ne&&(pe===""||this.rules.inline.punctuation.exec(pe))){var We=Ee[0].length-1,Ce,Ie,Le=We,z=0,H=Ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,oe=oe.slice(-1*Y.length+We);(Ee=H.exec(oe))!=null;)if(Ce=Ee[1]||Ee[2]||Ee[3]||Ee[4]||Ee[5]||Ee[6],!!Ce){if(Ie=Ce.length,Ee[3]||Ee[4]){Le+=Ie;continue}else if((Ee[5]||Ee[6])&&We%3&&!((We+Ie)%3)){z+=Ie;continue}if(Le-=Ie,!(Le>0)){if(Ie=Math.min(Ie,Ie+Le+z),Math.min(We,Ie)%2){var X=Y.slice(1,We+Ee.index+Ie);return{type:"em",raw:Y.slice(0,We+Ee.index+Ie+1),text:X,tokens:this.lexer.inlineTokens(X)}}var J=Y.slice(2,We+Ee.index+Ie-1);return{type:"strong",raw:Y.slice(0,We+Ee.index+Ie+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},le.codespan=function(Y){var oe=this.rules.inline.code.exec(Y);if(oe){var pe=oe[2].replace(/\n/g," "),Ee=/[^ ]/.test(pe),Ne=/^ /.test(pe)&&/ $/.test(pe);return Ee&&Ne&&(pe=pe.substring(1,pe.length-1)),pe=E(pe,!0),{type:"codespan",raw:oe[0],text:pe}}},le.br=function(Y){var oe=this.rules.inline.br.exec(Y);if(oe)return{type:"br",raw:oe[0]}},le.del=function(Y){var oe=this.rules.inline.del.exec(Y);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},le.autolink=function(Y,oe){var pe=this.rules.inline.autolink.exec(Y);if(pe){var Ee,Ne;return pe[2]==="@"?(Ee=E(this.options.mangle?oe(pe[1]):pe[1]),Ne="mailto:"+Ee):(Ee=E(pe[1]),Ne=Ee),{type:"link",raw:pe[0],text:Ee,href:Ne,tokens:[{type:"text",raw:Ee,text:Ee}]}}},le.url=function(Y,oe){var pe;if(pe=this.rules.inline.url.exec(Y)){var Ee,Ne;if(pe[2]==="@")Ee=E(this.options.mangle?oe(pe[0]):pe[0]),Ne="mailto:"+Ee;else{var We;do We=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(We!==pe[0]);Ee=E(pe[0]),pe[1]==="www."?Ne="http://"+Ee:Ne=Ee}return{type:"link",raw:pe[0],text:Ee,href:Ne,tokens:[{type:"text",raw:Ee,text:Ee}]}}},le.inlineText=function(Y,oe){var pe=this.rules.inline.text.exec(Y);if(pe){var Ee;return this.lexer.state.inRawBlock?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):E(pe[0]):pe[0]:Ee=E(this.options.smartypants?oe(pe[0]):pe[0]),{type:"text",raw:pe[0],text:Ee}}},ie}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:_,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=m(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=m(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=m(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=m(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=m(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=m(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=D({},x),x.gfm=D({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=m(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=m(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=D({},x.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:_,paragraph:m(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:_,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:_,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=m(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=m(x._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=m(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=m(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=m(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=m(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=m(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=m(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=m(B.reflink).replace("label",B._label).replace("ref",x._label).getRegex(),B.nolink=m(B.nolink).replace("ref",x._label).getRegex(),B.reflinkSearch=m(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=D({},B),B.pedantic=D({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=D({},B.normal,{escape:m(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=m(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=D({},B.gfm,{br:m(B.br).replace("{2,}","*").getRegex(),text:m(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function M(ie){var le="",ue,Y,oe=ie.length;for(ue=0;ue<oe;ue++)Y=ie.charCodeAt(ue),Math.random()>.5&&(Y="x"+Y.toString(16)),le+="&#"+Y+";";return le}var K=function(){function ie(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||he.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Y={block:x.normal,inline:B.normal};this.options.pedantic?(Y.block=x.pedantic,Y.inline=B.pedantic):this.options.gfm&&(Y.block=x.gfm,this.options.breaks?Y.inline=B.breaks:Y.inline=B.gfm),this.tokenizer.rules=Y}ie.lex=function(Y,oe){var pe=new ie(oe);return pe.lex(Y)},ie.lexInline=function(Y,oe){var pe=new ie(oe);return pe.inlineTokens(Y)};var le=ie.prototype;return le.lex=function(Y){Y=Y.replace(/\r\n|\r/g,`
`),this.blockTokens(Y,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},le.blockTokens=function(Y,oe){var pe=this;oe===void 0&&(oe=[]),this.options.pedantic?Y=Y.replace(/\t/g,"    ").replace(/^ +$/gm,""):Y=Y.replace(/^( *)(\t+)/gm,function(Le,z,H){return z+"    ".repeat(H.length)});for(var Ee,Ne,We,Ce;Y;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Le){return(Ee=Le.call({lexer:pe},Y,oe))?(Y=Y.substring(Ee.raw.length),oe.push(Ee),!0):!1}))){if(Ee=this.tokenizer.space(Y)){Y=Y.substring(Ee.raw.length),Ee.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(Ee);continue}if(Ee=this.tokenizer.code(Y)){Y=Y.substring(Ee.raw.length),Ne=oe[oe.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+Ee.raw,Ne.text+=`
`+Ee.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):oe.push(Ee);continue}if(Ee=this.tokenizer.fences(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.heading(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.hr(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.blockquote(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.list(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.html(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.def(Y)){Y=Y.substring(Ee.raw.length),Ne=oe[oe.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+Ee.raw,Ne.text+=`
`+Ee.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[Ee.tag]||(this.tokens.links[Ee.tag]={href:Ee.href,title:Ee.title});continue}if(Ee=this.tokenizer.table(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.lheading(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(We=Y,this.options.extensions&&this.options.extensions.startBlock&&function(){var Le=1/0,z=Y.slice(1),H=void 0;pe.options.extensions.startBlock.forEach(function(X){H=X.call({lexer:this},z),typeof H=="number"&&H>=0&&(Le=Math.min(Le,H))}),Le<1/0&&Le>=0&&(We=Y.substring(0,Le+1))}(),this.state.top&&(Ee=this.tokenizer.paragraph(We))){Ne=oe[oe.length-1],Ce&&Ne.type==="paragraph"?(Ne.raw+=`
`+Ee.raw,Ne.text+=`
`+Ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):oe.push(Ee),Ce=We.length!==Y.length,Y=Y.substring(Ee.raw.length);continue}if(Ee=this.tokenizer.text(Y)){Y=Y.substring(Ee.raw.length),Ne=oe[oe.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+Ee.raw,Ne.text+=`
`+Ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):oe.push(Ee);continue}if(Y){var Ie="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,oe},le.inline=function(Y,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:Y,tokens:oe}),oe},le.inlineTokens=function(Y,oe){var pe=this;oe===void 0&&(oe=[]);var Ee,Ne,We,Ce=Y,Ie,Le,z;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)H.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ie.index)+"["+w("a",Ie[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ie.index)+"["+w("a",Ie[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ie.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Y;)if(Le||(z=""),Le=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(Ee=J.call({lexer:pe},Y,oe))?(Y=Y.substring(Ee.raw.length),oe.push(Ee),!0):!1}))){if(Ee=this.tokenizer.escape(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.tag(Y)){Y=Y.substring(Ee.raw.length),Ne=oe[oe.length-1],Ne&&Ee.type==="text"&&Ne.type==="text"?(Ne.raw+=Ee.raw,Ne.text+=Ee.text):oe.push(Ee);continue}if(Ee=this.tokenizer.link(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.reflink(Y,this.tokens.links)){Y=Y.substring(Ee.raw.length),Ne=oe[oe.length-1],Ne&&Ee.type==="text"&&Ne.type==="text"?(Ne.raw+=Ee.raw,Ne.text+=Ee.text):oe.push(Ee);continue}if(Ee=this.tokenizer.emStrong(Y,Ce,z)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.codespan(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.br(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.del(Y)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(Ee=this.tokenizer.autolink(Y,M)){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(!this.state.inLink&&(Ee=this.tokenizer.url(Y,M))){Y=Y.substring(Ee.raw.length),oe.push(Ee);continue}if(We=Y,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,fe=Y.slice(1),be=void 0;pe.options.extensions.startInline.forEach(function(Fe){be=Fe.call({lexer:this},fe),typeof be=="number"&&be>=0&&(J=Math.min(J,be))}),J<1/0&&J>=0&&(We=Y.substring(0,J+1))}(),Ee=this.tokenizer.inlineText(We,F)){Y=Y.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(z=Ee.raw.slice(-1)),Le=!0,Ne=oe[oe.length-1],Ne&&Ne.type==="text"?(Ne.raw+=Ee.raw,Ne.text+=Ee.text):oe.push(Ee);continue}if(Y){var X="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return oe},r(ie,null,[{key:"rules",get:function(){return{block:x,inline:B}}}]),ie}(),ee=function(){function ie(ue){this.options=ue||he.defaults}var le=ie.prototype;return le.code=function(Y,oe,pe){var Ee=(oe||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(Y,Ee);Ne!=null&&Ne!==Y&&(pe=!0,Y=Ne)}return Y=Y.replace(/\n$/,"")+`
`,Ee?'<pre><code class="'+this.options.langPrefix+E(Ee,!0)+'">'+(pe?Y:E(Y,!0))+`</code></pre>
`:"<pre><code>"+(pe?Y:E(Y,!0))+`</code></pre>
`},le.blockquote=function(Y){return`<blockquote>
`+Y+`</blockquote>
`},le.html=function(Y){return Y},le.heading=function(Y,oe,pe,Ee){if(this.options.headerIds){var Ne=this.options.headerPrefix+Ee.slug(pe);return"<h"+oe+' id="'+Ne+'">'+Y+"</h"+oe+`>
`}return"<h"+oe+">"+Y+"</h"+oe+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Y,oe,pe){var Ee=oe?"ol":"ul",Ne=oe&&pe!==1?' start="'+pe+'"':"";return"<"+Ee+Ne+`>
`+Y+"</"+Ee+`>
`},le.listitem=function(Y){return"<li>"+Y+`</li>
`},le.checkbox=function(Y){return"<input "+(Y?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Y){return"<p>"+Y+`</p>
`},le.table=function(Y,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+Y+`</thead>
`+oe+`</table>
`},le.tablerow=function(Y){return`<tr>
`+Y+`</tr>
`},le.tablecell=function(Y,oe){var pe=oe.header?"th":"td",Ee=oe.align?"<"+pe+' align="'+oe.align+'">':"<"+pe+">";return Ee+Y+("</"+pe+`>
`)},le.strong=function(Y){return"<strong>"+Y+"</strong>"},le.em=function(Y){return"<em>"+Y+"</em>"},le.codespan=function(Y){return"<code>"+Y+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Y){return"<del>"+Y+"</del>"},le.link=function(Y,oe,pe){if(Y=i(this.options.sanitize,this.options.baseUrl,Y),Y===null)return pe;var Ee='<a href="'+E(Y)+'"';return oe&&(Ee+=' title="'+oe+'"'),Ee+=">"+pe+"</a>",Ee},le.image=function(Y,oe,pe){if(Y=i(this.options.sanitize,this.options.baseUrl,Y),Y===null)return pe;var Ee='<img src="'+Y+'" alt="'+pe+'"';return oe&&(Ee+=' title="'+oe+'"'),Ee+=this.options.xhtml?"/>":">",Ee},le.text=function(Y){return Y},ie}(),$=function(){function ie(){}var le=ie.prototype;return le.strong=function(Y){return Y},le.em=function(Y){return Y},le.codespan=function(Y){return Y},le.del=function(Y){return Y},le.html=function(Y){return Y},le.text=function(Y){return Y},le.link=function(Y,oe,pe){return""+pe},le.image=function(Y,oe,pe){return""+pe},le.br=function(){return""},ie}(),q=function(){function ie(){this.seen={}}var le=ie.prototype;return le.serialize=function(Y){return Y.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Y,oe){var pe=Y,Ee=0;if(this.seen.hasOwnProperty(pe)){Ee=this.seen[Y];do Ee++,pe=Y+"-"+Ee;while(this.seen.hasOwnProperty(pe))}return oe||(this.seen[Y]=Ee,this.seen[pe]=0),pe},le.slug=function(Y,oe){oe===void 0&&(oe={});var pe=this.serialize(Y);return this.getNextSafeSlug(pe,oe.dryrun)},ie}(),Z=function(){function ie(ue){this.options=ue||he.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $,this.slugger=new q}ie.parse=function(Y,oe){var pe=new ie(oe);return pe.parse(Y)},ie.parseInline=function(Y,oe){var pe=new ie(oe);return pe.parseInline(Y)};var le=ie.prototype;return le.parse=function(Y,oe){oe===void 0&&(oe=!0);var pe="",Ee,Ne,We,Ce,Ie,Le,z,H,X,J,fe,be,Fe,He,qe,Ye,it,tt,rt,ot=Y.length;for(Ee=0;Ee<ot;Ee++){if(J=Y[Ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(rt=this.options.extensions.renderers[J.type].call({parser:this},J),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){pe+=rt||"";continue}switch(J.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(J.tokens),J.depth,u(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(H="",z="",Ce=J.header.length,Ne=0;Ne<Ce;Ne++)z+=this.renderer.tablecell(this.parseInline(J.header[Ne].tokens),{header:!0,align:J.align[Ne]});for(H+=this.renderer.tablerow(z),X="",Ce=J.rows.length,Ne=0;Ne<Ce;Ne++){for(Le=J.rows[Ne],z="",Ie=Le.length,We=0;We<Ie;We++)z+=this.renderer.tablecell(this.parseInline(Le[We].tokens),{header:!1,align:J.align[We]});X+=this.renderer.tablerow(z)}pe+=this.renderer.table(H,X);continue}case"blockquote":{X=this.parse(J.tokens),pe+=this.renderer.blockquote(X);continue}case"list":{for(fe=J.ordered,be=J.start,Fe=J.loose,Ce=J.items.length,X="",Ne=0;Ne<Ce;Ne++)qe=J.items[Ne],Ye=qe.checked,it=qe.task,He="",qe.task&&(tt=this.renderer.checkbox(Ye),Fe?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=tt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=tt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:tt}):He+=tt),He+=this.parse(qe.tokens,Fe),X+=this.renderer.listitem(He,it,Ye);pe+=this.renderer.list(X,fe,be);continue}case"html":{pe+=this.renderer.html(J.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(X=J.tokens?this.parseInline(J.tokens):J.text;Ee+1<ot&&Y[Ee+1].type==="text";)J=Y[++Ee],X+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);pe+=oe?this.renderer.paragraph(X):X;continue}default:{var ft='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return pe},le.parseInline=function(Y,oe){oe=oe||this.renderer;var pe="",Ee,Ne,We,Ce=Y.length;for(Ee=0;Ee<Ce;Ee++){if(Ne=Y[Ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(We=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),We!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){pe+=We||"";continue}switch(Ne.type){case"escape":{pe+=oe.text(Ne.text);break}case"html":{pe+=oe.html(Ne.text);break}case"link":{pe+=oe.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,oe));break}case"image":{pe+=oe.image(Ne.href,Ne.title,Ne.text);break}case"strong":{pe+=oe.strong(this.parseInline(Ne.tokens,oe));break}case"em":{pe+=oe.em(this.parseInline(Ne.tokens,oe));break}case"codespan":{pe+=oe.codespan(Ne.text);break}case"br":{pe+=oe.br();break}case"del":{pe+=oe.del(this.parseInline(Ne.tokens,oe));break}case"text":{pe+=oe.text(Ne.text);break}default:{var Ie='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return pe},ie}();function ne(ie,le,ue){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof le=="function"&&(ue=le,le=null),le=D({},ne.defaults,le||{}),b(le),ue){var Y=le.highlight,oe;try{oe=K.lex(ie,le)}catch(Ce){return ue(Ce)}var pe=function(Ie){var Le;if(!Ie)try{le.walkTokens&&ne.walkTokens(oe,le.walkTokens),Le=Z.parse(oe,le)}catch(z){Ie=z}return le.highlight=Y,Ie?ue(Ie):ue(null,Le)};if(!Y||Y.length<3||(delete le.highlight,!oe.length))return pe();var Ee=0;ne.walkTokens(oe,function(Ce){Ce.type==="code"&&(Ee++,setTimeout(function(){Y(Ce.text,Ce.lang,function(Ie,Le){if(Ie)return pe(Ie);Le!=null&&Le!==Ce.text&&(Ce.text=Le,Ce.escaped=!0),Ee--,Ee===0&&pe()})},0))}),Ee===0&&pe();return}function Ne(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(Ce.message+"",!0)+"</pre>";throw Ce}try{var We=K.lex(ie,le);if(le.walkTokens){if(le.async)return Promise.all(ne.walkTokens(We,le.walkTokens)).then(function(){return Z.parse(We,le)}).catch(Ne);ne.walkTokens(We,le.walkTokens)}return Z.parse(We,le)}catch(Ce){Ne(Ce)}}ne.options=ne.setOptions=function(ie){return D(ne.defaults,ie),R(ne.defaults),ne},ne.getDefaults=L,ne.defaults=he.defaults,ne.use=function(){for(var ie=arguments.length,le=new Array(ie),ue=0;ue<ie;ue++)le[ue]=arguments[ue];var Y=D.apply(void 0,[{}].concat(le)),oe=ne.defaults.extensions||{renderers:{},childTokens:{}},pe;le.forEach(function(Ee){if(Ee.extensions&&(pe=!0,Ee.extensions.forEach(function(We){if(!We.name)throw new Error("extension name required");if(We.renderer){var Ce=oe.renderers?oe.renderers[We.name]:null;Ce?oe.renderers[We.name]=function(){for(var Ie=arguments.length,Le=new Array(Ie),z=0;z<Ie;z++)Le[z]=arguments[z];var H=We.renderer.apply(this,Le);return H===!1&&(H=Ce.apply(this,Le)),H}:oe.renderers[We.name]=We.renderer}if(We.tokenizer){if(!We.level||We.level!=="block"&&We.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[We.level]?oe[We.level].unshift(We.tokenizer):oe[We.level]=[We.tokenizer],We.start&&(We.level==="block"?oe.startBlock?oe.startBlock.push(We.start):oe.startBlock=[We.start]:We.level==="inline"&&(oe.startInline?oe.startInline.push(We.start):oe.startInline=[We.start]))}We.childTokens&&(oe.childTokens[We.name]=We.childTokens)})),Ee.renderer&&function(){var We=ne.defaults.renderer||new ee,Ce=function(z){var H=We[z];We[z]=function(){for(var X=arguments.length,J=new Array(X),fe=0;fe<X;fe++)J[fe]=arguments[fe];var be=Ee.renderer[z].apply(We,J);return be===!1&&(be=H.apply(We,J)),be}};for(var Ie in Ee.renderer)Ce(Ie);Y.renderer=We}(),Ee.tokenizer&&function(){var We=ne.defaults.tokenizer||new U,Ce=function(z){var H=We[z];We[z]=function(){for(var X=arguments.length,J=new Array(X),fe=0;fe<X;fe++)J[fe]=arguments[fe];var be=Ee.tokenizer[z].apply(We,J);return be===!1&&(be=H.apply(We,J)),be}};for(var Ie in Ee.tokenizer)Ce(Ie);Y.tokenizer=We}(),Ee.walkTokens){var Ne=ne.defaults.walkTokens;Y.walkTokens=function(We){var Ce=[];return Ce.push(Ee.walkTokens.call(this,We)),Ne&&(Ce=Ce.concat(Ne.call(this,We))),Ce}}pe&&(Y.extensions=oe),ne.setOptions(Y)})},ne.walkTokens=function(ie,le){for(var ue=[],Y=function(){var Ne=pe.value;switch(ue=ue.concat(le.call(ne,Ne)),Ne.type){case"table":{for(var We=A(Ne.header),Ce;!(Ce=We()).done;){var Ie=Ce.value;ue=ue.concat(ne.walkTokens(Ie.tokens,le))}for(var Le=A(Ne.rows),z;!(z=Le()).done;)for(var H=z.value,X=A(H),J;!(J=X()).done;){var fe=J.value;ue=ue.concat(ne.walkTokens(fe.tokens,le))}break}case"list":{ue=ue.concat(ne.walkTokens(Ne.items,le));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[Ne.type]?ne.defaults.extensions.childTokens[Ne.type].forEach(function(be){ue=ue.concat(ne.walkTokens(Ne[be],le))}):Ne.tokens&&(ue=ue.concat(ne.walkTokens(Ne.tokens,le)))}},oe=A(ie),pe;!(pe=oe()).done;)Y();return ue},ne.parseInline=function(ie,le){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");le=D({},ne.defaults,le||{}),b(le);try{var ue=K.lexInline(ie,le);return le.walkTokens&&ne.walkTokens(ue,le.walkTokens),Z.parseInline(ue,le)}catch(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(Y.message+"",!0)+"</pre>";throw Y}},ne.Parser=Z,ne.parser=Z.parse,ne.Renderer=ee,ne.TextRenderer=$,ne.Lexer=K,ne.lexer=K.lex,ne.Tokenizer=U,ne.Slugger=q,ne.parse=ne;var de=ne.options,re=ne.setOptions,Se=ne.use,ve=ne.walkTokens,G=ne.parseInline,W=ne,se=Z.parse,ae=K.lex;he.Lexer=K,he.Parser=Z,he.Renderer=ee,he.Slugger=q,he.TextRenderer=$,he.Tokenizer=U,he.getDefaults=L,he.lexer=ae,he.marked=ne,he.options=de,he.parse=W,he.parseInline=G,he.parser=se,he.setOptions=re,he.use=Se,he.walkTokens=ve,Object.defineProperty(he,"__esModule",{value:!0})}),define(we[41],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(g){g[g.Uri=1]="Uri",g[g.Regexp=2]="Regexp",g[g.ScmResource=3]="ScmResource",g[g.ScmResourceGroup=4]="ScmResourceGroup",g[g.ScmProvider=5]="ScmProvider",g[g.CommentController=6]="CommentController",g[g.CommentThread=7]="CommentThread",g[g.CommentThreadInstance=8]="CommentThreadInstance",g[g.CommentThreadReply=9]="CommentThreadReply",g[g.CommentNode=10]="CommentNode",g[g.CommentThreadNode=11]="CommentThreadNode",g[g.TimelineActionContext=12]="TimelineActionContext",g[g.NotebookCellActionContext=13]="NotebookCellActionContext",g[g.NotebookActionContext=14]="NotebookActionContext",g[g.TerminalContext=15]="TerminalContext",g[g.TestItemContext=16]="TestItemContext",g[g.Date=17]="Date",g[g.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(we[176],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=r;function r(a){const u=A(a);if(u&&u.length>0)return new Uint32Array(u)}let g=0;const k=new Uint32Array(10);function A(a){if(g=0,L(a,y,v.InitialConsonant),g>0||(L(a,d,v.Vowel),g>0)||(L(a,T,v.FinalConsonant),g>0)||(L(a,E,v.CompatibilityJamo),g))return k.subarray(0,g);if(a>=44032&&a<=55203){const u=a-44032,f=u%588,m=Math.floor(u/588),n=Math.floor(f/28),s=f%28-1;if(m<y.length?L(m,y,0):v.InitialConsonant+m-v.CompatibilityJamo<E.length&&L(v.InitialConsonant+m,E,v.CompatibilityJamo),n<d.length?L(n,d,0):v.Vowel+n-v.CompatibilityJamo<E.length&&L(v.Vowel+n-v.CompatibilityJamo,E,v.CompatibilityJamo),s>=0&&(s<T.length?L(s,T,0):v.FinalConsonant+s-v.CompatibilityJamo<E.length&&L(v.FinalConsonant+s-v.CompatibilityJamo,E,v.CompatibilityJamo)),g>0)return k.subarray(0,g)}}function L(a,u,f){a>=f&&a<f+u.length&&R(u[a-f])}function R(a){a!==l.NUL&&(k[g++]=a&255,a>>8&&(k[g++]=a>>8&255),a>>16&&(k[g++]=a>>16&255))}var v;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var l;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(l||(l={}));var P;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(P||(P={}));const y=new Uint8Array([l.r,l.R,l.s,l.e,l.E,l.f,l.a,l.q,l.Q,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g]),d=new Uint16Array([l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,P.hk,P.ho,P.hl,l.y,l.n,P.nj,P.np,P.nl,l.b,l.m,P.ml,l.l]),T=new Uint16Array([l.r,l.R,P.rt,l.s,P.sw,P.sg,l.e,l.f,P.fr,P.fa,P.fq,P.ft,P.fx,P.fv,P.fg,l.a,l.q,P.qt,l.t,l.T,l.d,l.w,l.c,l.z,l.x,l.v,l.g]),E=new Uint16Array([l.r,l.R,P.rt,l.s,P.sw,P.sg,l.e,l.E,l.f,P.fr,P.fa,P.fq,P.ft,P.fx,P.fv,P.fg,l.a,l.q,l.Q,P.qt,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g,l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,P.hk,P.ho,P.hl,l.y,l.n,P.nj,P.np,P.nl,l.b,l.m,P.ml,l.l])}),define(we[82],ye([1,0,29]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=k,e.normalizeNFD=L;const g=new r.LRUCache(1e4);function k(l){return v(l,"NFC",g)}const A=new r.LRUCache(1e4);function L(l){return v(l,"NFD",A)}const R=/[^\u0000-\u0080]/;function v(l,P,y){if(!l)return l;const d=y.get(l);if(d)return d;let T;return R.test(l)?T=l.normalize(P):T=l,y.set(l,T),T}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(P){return L(P).replace(l,"")}}()}),define(we[133],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=r,e.rot=g;function r(R,v,l){return Math.min(Math.max(R,v),l)}function g(R,v){return(v+R%v)%v}class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class A{constructor(){this._n=1,this._val=0}update(v){return this._val=this._val+(v-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class L{constructor(v){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(v),this._values.fill(0,0,v)}update(v){const l=this._values[this._index];return this._values[this._index]=v,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=v,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=L}),define(we[177],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=A,e.getFunctionName=d;class r{constructor(E,a,u){this.owner=E,this.debugNameSource=a,this.referenceFn=u}getDebugName(E){return A(E,this)}}e.DebugNameData=r;const g=new Map,k=new WeakMap;function A(T,E){const a=k.get(T);if(a)return a;const u=L(T,E);if(u){let f=g.get(u)??0;f++,g.set(u,f);const m=f===1?u:`${u}#${f}`;return k.set(T,m),m}}function L(T,E){const a=k.get(T);if(a)return a;const u=E.owner?P(E.owner)+".":"";let f;const m=E.debugNameSource;if(m!==void 0)if(typeof m=="function"){if(f=m(),f!==void 0)return u+f}else return u+m;const n=E.referenceFn;if(n!==void 0&&(f=d(n),f!==void 0))return u+f;if(E.owner!==void 0){const s=R(E.owner,T);if(s!==void 0)return u+s}}function R(T,E){for(const a in T)if(T[a]===E)return a}const v=new Map,l=new WeakMap;function P(T){const E=l.get(T);if(E)return E;const a=y(T);let u=v.get(a)??0;u++,v.set(a,u);const f=u===1?a:`${a}#${u}`;return l.set(T,f),f}function y(T){const E=T.constructor;return E?E.name:"Object"}function d(T){const E=T.toString(),u=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(E);return(u?u[1]:void 0)?.trim()}}),define(we[178],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=g,e.getLogger=k;let r;function g(a){r=a}function k(){return r}class A{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(u){return L([R(T("|  ",this.indentation)),u])}formatInfo(u){return u.hadValue?u.didChange?[R(" "),l(P(u.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),l(P(u.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),l(P(u.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged(u,f){console.log(...this.textToConsoleArgs([v("observable value changed"),l(u.debugName,{color:"BlueViolet"}),...this.formatInfo(f)]))}formatChanges(u){if(u.size!==0)return l(" (changed deps: "+[...u].map(f=>f.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(u){const f=u.handleChange;this.changedObservablesSets.set(u,new Set),u.handleChange=(m,n)=>(this.changedObservablesSets.get(u).add(m),f.apply(u,[m,n]))}handleDerivedRecomputed(u,f){const m=this.changedObservablesSets.get(u);console.log(...this.textToConsoleArgs([v("derived recomputed"),l(u.debugName,{color:"BlueViolet"}),...this.formatInfo(f),this.formatChanges(m),{data:[{fn:u._computeFn}]}])),m.clear()}handleFromEventObservableTriggered(u,f){console.log(...this.textToConsoleArgs([v("observable from event triggered"),l(u.debugName,{color:"BlueViolet"}),...this.formatInfo(f),{data:[{fn:u._getValue}]}]))}handleAutorunCreated(u){const f=u.handleChange;this.changedObservablesSets.set(u,new Set),u.handleChange=(m,n)=>(this.changedObservablesSets.get(u).add(m),f.apply(u,[m,n]))}handleAutorunTriggered(u){const f=this.changedObservablesSets.get(u);console.log(...this.textToConsoleArgs([v("autorun"),l(u.debugName,{color:"BlueViolet"}),this.formatChanges(f),{data:[{fn:u._runFn}]}])),f.clear(),this.indentation++}handleAutorunFinished(u){this.indentation--}handleBeginTransaction(u){let f=u.getDebugName();f===void 0&&(f=""),console.log(...this.textToConsoleArgs([v("transaction"),l(f,{color:"BlueViolet"}),{data:[{fn:u._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=A;function L(a){const u=new Array,f=[];let m="";function n(i){if("length"in i)for(const t of i)t&&n(t);else"text"in i?(m+=`%c${i.text}`,u.push(i.style),i.data&&f.push(...i.data)):"data"in i&&f.push(...i.data)}n(a);const s=[m,...u];return s.push(...f),s}function R(a){return l(a,{color:"black"})}function v(a){return l(E(`${a}: `,10),{color:"black",bold:!0})}function l(a,u={color:"black"}){function f(n){return Object.entries(n).reduce((s,[i,t])=>`${s}${i}:${t};`,"")}const m={color:u.color};return u.strikeThrough&&(m["text-decoration"]="line-through"),u.bold&&(m["font-weight"]="bold"),{text:a,style:f(m)}}function P(a,u){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=u?`"${a}"`:`"${a.substr(0,u-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?y(a,u):d(a,u);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function y(a,u){let f="[ ",m=!0;for(const n of a){if(m||(f+=", "),f.length-5>u){f+="...";break}m=!1,f+=`${P(n,u-f.length)}`}return f+=" ]",f}function d(a,u){let f="{ ",m=!0;for(const[n,s]of Object.entries(a)){if(m||(f+=", "),f.length-5>u){f+="...";break}m=!1,f+=`${n}: ${P(s,u-f.length)}`}return f+=" }",f}function T(a,u){let f="";for(let m=1;m<=u;m++)f+=a;return f}function E(a,u){for(;a.length<u;)a+=" ";return a}}),define(we[179],ye([1,0,173,177,178]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=L,e._setKeepObserved=v,e._setDerivedOpts=P,e.transaction=T,e.globalTransaction=a,e.asyncTransaction=u,e.subtransaction=f,e.observableValue=n,e.observableValueOpts=s,e.disposableObservableValue=t;let A;function L(h){A=h}let R;function v(h){R=h}let l;function P(h){l=h}class y{get TChange(){return null}reportChanges(){this.get()}read(o){return o?o.readObservable(this):this.get()}map(o,p){const _=p===void 0?void 0:o,D=p===void 0?o:p;return l({owner:_,debugName:()=>{const C=(0,g.getFunctionName)(D);if(C!==void 0)return C;const I=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(D.toString());if(I)return`${this.debugName}.${I[2]}`;if(!_)return`${this.debugName} (mapped)`},debugReferenceFn:D},C=>D(this.read(C),C))}recomputeInitiallyAndOnChange(o,p){return o.add(A(this,p)),this}keepObserved(o){return o.add(R(this)),this}get debugValue(){return this.get()}}e.ConvenientObservable=y;class d extends y{constructor(){super(...arguments),this.observers=new Set}addObserver(o){const p=this.observers.size;this.observers.add(o),p===0&&this.onFirstObserverAdded()}removeObserver(o){this.observers.delete(o)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=d;function T(h,o){const p=new m(h,o);try{h(p)}finally{p.finish()}}let E;function a(h){if(E)h(E);else{const o=new m(h,void 0);E=o;try{h(o)}finally{o.finish(),E=void 0}}}async function u(h,o){const p=new m(h,o);try{await h(p)}finally{p.finish()}}function f(h,o,p){h?o(h):T(o,p)}class m{constructor(o,p){this._fn=o,this._getDebugName=p,this.updatingObservers=[],(0,k.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,g.getFunctionName)(this._fn)}updateObserver(o,p){this.updatingObservers.push({observer:o,observable:p}),o.beginUpdate(p)}finish(){const o=this.updatingObservers;for(let p=0;p<o.length;p++){const{observer:_,observable:D}=o[p];_.endUpdate(D)}this.updatingObservers=null,(0,k.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=m;function n(h,o){let p;return typeof h=="string"?p=new g.DebugNameData(void 0,h,void 0):p=new g.DebugNameData(h,void 0,void 0),new i(p,o,r.strictEquals)}function s(h,o){return new i(new g.DebugNameData(h.owner,h.debugName,void 0),o,h.equalsFn??r.strictEquals)}class i extends d{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(o,p,_){super(),this._debugNameData=o,this._equalityComparator=_,this._value=p}get(){return this._value}set(o,p,_){if(_===void 0&&this._equalityComparator(this._value,o))return;let D;p||(p=D=new m(()=>{},()=>`Setting ${this.debugName}`));try{const C=this._value;this._setValue(o),(0,k.getLogger)()?.handleObservableChanged(this,{oldValue:C,newValue:o,change:_,didChange:!0,hadValue:!0});for(const S of this.observers)p.updateObserver(S,this),S.handleChange(this,_)}finally{D&&D.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(o){this._value=o}}e.ObservableValue=i;function t(h,o){let p;return typeof h=="string"?p=new g.DebugNameData(void 0,h,void 0):p=new g.DebugNameData(h,void 0,void 0),new c(p,o,r.strictEquals)}class c extends i{_setValue(o){this._value!==o&&(this._value&&this._value.dispose(),this._value=o)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=c}),function(){function he(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function L(v){A.push(v,Date.now())}function R(){const v=[];for(let l=0;l<A.length;l+=2)v.push({name:A[l],startTime:A[l+1]});return v}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const L of performance.getEntriesByType("mark"))A.push({name:L.name,startTime:Math.round(k+L.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function r(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var g;typeof global=="object"?g=global:typeof self=="object"?g=self:g={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(g)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(g):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),g.perf=r(g))}(),define(we[180],ye([1,0,40]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const g=Symbol("unset");class k{constructor(){this.root=new L,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||r.Iterable.empty()}insert(v,l,P){this.opNode(v,y=>y._value=l,P)}mutate(v,l){this.opNode(v,P=>P._value=l(P._value===g?void 0:P._value))}mutatePath(v,l){this.opNode(v,()=>{},P=>l(P))}delete(v){const l=this.getPathToKey(v);if(!l)return;let P=l.length-1;const y=l[P].node._value;if(y!==g){for(this._size--,l[P].node._value=g;P>0;P--){const{node:d,part:T}=l[P];if(d.children?.size||d._value!==g)break;l[P-1].node.children.delete(T)}return y}}*deleteRecursive(v){const l=this.getPathToKey(v);if(!l)return;const P=l[l.length-1].node;for(let y=l.length-1;y>0;y--){const d=l[y-1];if(d.node.children.delete(l[y].part),d.node.children.size>0||d.node._value!==g)break}for(const y of A(P))y._value!==g&&(this._size--,yield y._value)}find(v){let l=this.root;for(const P of v){const y=l.children?.get(P);if(!y)return;l=y}return l._value===g?void 0:l._value}hasKeyOrParent(v){let l=this.root;for(const P of v){const y=l.children?.get(P);if(!y)return!1;if(y._value!==g)return!0;l=y}return!1}hasKeyOrChildren(v){let l=this.root;for(const P of v){const y=l.children?.get(P);if(!y)return!1;l=y}return!0}hasKey(v){let l=this.root;for(const P of v){const y=l.children?.get(P);if(!y)return!1;l=y}return l._value!==g}getPathToKey(v){const l=[{part:"",node:this.root}];let P=0;for(const y of v){const d=l[P].node.children?.get(y);if(!d)return;l.push({part:y,node:d}),P++}return l}opNode(v,l,P){let y=this.root;for(const E of v){if(y.children)if(y.children.has(E))y=y.children.get(E);else{const a=new L;y.children.set(E,a),y=a}else{const a=new L;y.children=new Map([[E,a]]),y=a}P?.(y)}const d=y._value===g?0:1;l(y);const T=y._value===g?0:1;this._size+=T-d}*values(){for(const{_value:v}of A(this.root))v!==g&&(yield v)}}e.WellDefinedPrefixTree=k;function*A(R){const v=[R];for(;v.length>0;){const l=v.pop();if(yield l,l.children)for(const P of l.children.values())v.push(P)}}class L{constructor(){this._value=g}get value(){return this._value===g?void 0:this._value}set value(v){this._value=v===void 0?g:v}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var g in r)(typeof exports=="object"?exports:he)[g]=r[g]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function r(g){if(e[g])return e[g].exports;var k=e[g]={i:g,l:!1,exports:{}};return he[g].call(k.exports,k,k.exports,r),k.l=!0,k.exports}return r.m=he,r.c=e,r.d=function(g,k,A){r.o(g,k)||Object.defineProperty(g,k,{enumerable:!0,get:A})},r.r=function(g){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(g,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(g,"__esModule",{value:!0})},r.t=function(g,k){if(1&k&&(g=r(g)),8&k||4&k&&typeof g=="object"&&g&&g.__esModule)return g;var A=Object.create(null);if(r.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:g}),2&k&&typeof g!="string")for(var L in g)r.d(A,L,function(R){return g[R]}.bind(null,L));return A},r.n=function(g){var k=g&&g.__esModule?function(){return g.default}:function(){return g};return r.d(k,"a",k),k},r.o=function(g,k){return Object.prototype.hasOwnProperty.call(g,k)},r.p="",r(r.s=0)}([function(he,e,r){(function(g){var k;e=he.exports=Se,k=typeof g=="object"&&g.env&&g.env.NODE_DEBUG&&/\bsemver\b/i.test(g.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],v=e.src=[],l=0,P=l++;v[P]="0|[1-9]\\d*";var y=l++;v[y]="[0-9]+";var d=l++;v[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=l++;v[T]="("+v[P]+")\\.("+v[P]+")\\.("+v[P]+")";var E=l++;v[E]="("+v[y]+")\\.("+v[y]+")\\.("+v[y]+")";var a=l++;v[a]="(?:"+v[P]+"|"+v[d]+")";var u=l++;v[u]="(?:"+v[y]+"|"+v[d]+")";var f=l++;v[f]="(?:-("+v[a]+"(?:\\."+v[a]+")*))";var m=l++;v[m]="(?:-?("+v[u]+"(?:\\."+v[u]+")*))";var n=l++;v[n]="[0-9A-Za-z-]+";var s=l++;v[s]="(?:\\+("+v[n]+"(?:\\."+v[n]+")*))";var i=l++,t="v?"+v[T]+v[f]+"?"+v[s]+"?";v[i]="^"+t+"$";var c="[v=\\s]*"+v[E]+v[m]+"?"+v[s]+"?",h=l++;v[h]="^"+c+"$";var o=l++;v[o]="((?:<|>)?=?)";var p=l++;v[p]=v[y]+"|x|X|\\*";var _=l++;v[_]=v[P]+"|x|X|\\*";var D=l++;v[D]="[v=\\s]*("+v[_]+")(?:\\.("+v[_]+")(?:\\.("+v[_]+")(?:"+v[f]+")?"+v[s]+"?)?)?";var C=l++;v[C]="[v=\\s]*("+v[p]+")(?:\\.("+v[p]+")(?:\\.("+v[p]+")(?:"+v[m]+")?"+v[s]+"?)?)?";var S=l++;v[S]="^"+v[o]+"\\s*"+v[D]+"$";var I=l++;v[I]="^"+v[o]+"\\s*"+v[C]+"$";var b=l++;v[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=l++;v[w]="(?:~>?)";var N=l++;v[N]="(\\s*)"+v[w]+"\\s+",R[N]=new RegExp(v[N],"g");var O=l++;v[O]="^"+v[w]+v[D]+"$";var U=l++;v[U]="^"+v[w]+v[C]+"$";var x=l++;v[x]="(?:\\^)";var B=l++;v[B]="(\\s*)"+v[x]+"\\s+",R[B]=new RegExp(v[B],"g");var F=l++;v[F]="^"+v[x]+v[D]+"$";var M=l++;v[M]="^"+v[x]+v[C]+"$";var K=l++;v[K]="^"+v[o]+"\\s*("+c+")$|^$";var ee=l++;v[ee]="^"+v[o]+"\\s*("+t+")$|^$";var $=l++;v[$]="(\\s*)"+v[o]+"\\s*("+c+"|"+v[D]+")",R[$]=new RegExp(v[$],"g");var q=l++;v[q]="^\\s*("+v[D]+")\\s+-\\s+("+v[D]+")\\s*$";var Z=l++;v[Z]="^\\s*("+v[C]+")\\s+-\\s+("+v[C]+")\\s*$";var ne=l++;v[ne]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)k(de,v[de]),R[de]||(R[de]=new RegExp(v[de]));function re(H,X){if(H instanceof Se)return H;if(typeof H!="string"||H.length>A||!(X?R[h]:R[i]).test(H))return null;try{return new Se(H,X)}catch{return null}}function Se(H,X){if(H instanceof Se){if(H.loose===X)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Se))return new Se(H,X);k("SemVer",H,X),this.loose=X;var J=H.trim().match(X?R[h]:R[i]);if(!J)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var be=+fe;if(be>=0&&be<L)return be}return fe}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=re,e.valid=function(H,X){var J=re(H,X);return J?J.version:null},e.clean=function(H,X){var J=re(H.trim().replace(/^[=v]+/,""),X);return J?J.version:null},e.SemVer=Se,Se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Se.prototype.toString=function(){return this.version},Se.prototype.compare=function(H){return k("SemVer.compare",this.version,this.loose,H),H instanceof Se||(H=new Se(H,this.loose)),this.compareMain(H)||this.comparePre(H)},Se.prototype.compareMain=function(H){return H instanceof Se||(H=new Se(H,this.loose)),G(this.major,H.major)||G(this.minor,H.minor)||G(this.patch,H.patch)},Se.prototype.comparePre=function(H){if(H instanceof Se||(H=new Se(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var X=0;do{var J=this.prerelease[X],fe=H.prerelease[X];if(k("prerelease compare",X,J,fe),J===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(J===void 0)return-1;if(J!==fe)return G(J,fe)}while(++X)},Se.prototype.inc=function(H,X){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,X,J,fe){typeof J=="string"&&(fe=J,J=void 0);try{return new Se(H,J).inc(X,fe).version}catch{return null}},e.diff=function(H,X){if(ie(H,X))return null;var J=re(H),fe=re(X);if(J.prerelease.length||fe.prerelease.length){for(var be in J)if((be==="major"||be==="minor"||be==="patch")&&J[be]!==fe[be])return"pre"+be;return"prerelease"}for(var be in J)if((be==="major"||be==="minor"||be==="patch")&&J[be]!==fe[be])return be},e.compareIdentifiers=G;var ve=/^[0-9]+$/;function G(H,X){var J=ve.test(H),fe=ve.test(X);return J&&fe&&(H=+H,X=+X),J&&!fe?-1:fe&&!J?1:H<X?-1:H>X?1:0}function W(H,X,J){return new Se(H,J).compare(new Se(X,J))}function se(H,X,J){return W(H,X,J)>0}function ae(H,X,J){return W(H,X,J)<0}function ie(H,X,J){return W(H,X,J)===0}function le(H,X,J){return W(H,X,J)!==0}function ue(H,X,J){return W(H,X,J)>=0}function Y(H,X,J){return W(H,X,J)<=0}function oe(H,X,J,fe){var be;switch(X){case"===":typeof H=="object"&&(H=H.version),typeof J=="object"&&(J=J.version),be=H===J;break;case"!==":typeof H=="object"&&(H=H.version),typeof J=="object"&&(J=J.version),be=H!==J;break;case"":case"=":case"==":be=ie(H,J,fe);break;case"!=":be=le(H,J,fe);break;case">":be=se(H,J,fe);break;case">=":be=ue(H,J,fe);break;case"<":be=ae(H,J,fe);break;case"<=":be=Y(H,J,fe);break;default:throw new TypeError("Invalid operator: "+X)}return be}function pe(H,X){if(H instanceof pe){if(H.loose===X)return H;H=H.value}if(!(this instanceof pe))return new pe(H,X);k("comparator",H,X),this.loose=X,this.parse(H),this.semver===Ee?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(H,X){return G(X,H)},e.major=function(H,X){return new Se(H,X).major},e.minor=function(H,X){return new Se(H,X).minor},e.patch=function(H,X){return new Se(H,X).patch},e.compare=W,e.compareLoose=function(H,X){return W(H,X,!0)},e.rcompare=function(H,X,J){return W(X,H,J)},e.sort=function(H,X){return H.sort(function(J,fe){return e.compare(J,fe,X)})},e.rsort=function(H,X){return H.sort(function(J,fe){return e.rcompare(J,fe,X)})},e.gt=se,e.lt=ae,e.eq=ie,e.neq=le,e.gte=ue,e.lte=Y,e.cmp=oe,e.Comparator=pe;var Ee={};function Ne(H,X){if(H instanceof Ne)return H.loose===X?H:new Ne(H.raw,X);if(H instanceof pe)return new Ne(H.value,X);if(!(this instanceof Ne))return new Ne(H,X);if(this.loose=X,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function We(H){return!H||H.toLowerCase()==="x"||H==="*"}function Ce(H,X,J,fe,be,Fe,He,qe,Ye,it,tt,rt,ot){return((X=We(J)?"":We(fe)?">="+J+".0.0":We(be)?">="+J+"."+fe+".0":">="+X)+" "+(qe=We(Ye)?"":We(it)?"<"+(+Ye+1)+".0.0":We(tt)?"<"+Ye+"."+(+it+1)+".0":rt?"<="+Ye+"."+it+"."+tt+"-"+rt:"<="+qe)).trim()}function Ie(H,X){for(var J=0;J<H.length;J++)if(!H[J].test(X))return!1;if(X.prerelease.length){for(J=0;J<H.length;J++)if(k(H[J].semver),H[J].semver!==Ee&&H[J].semver.prerelease.length>0){var fe=H[J].semver;if(fe.major===X.major&&fe.minor===X.minor&&fe.patch===X.patch)return!0}return!1}return!0}function Le(H,X,J){try{X=new Ne(X,J)}catch{return!1}return X.test(H)}function z(H,X,J,fe){var be,Fe,He,qe,Ye;switch(H=new Se(H,fe),X=new Ne(X,fe),J){case">":be=se,Fe=Y,He=ae,qe=">",Ye=">=";break;case"<":be=ae,Fe=ue,He=se,qe="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(H,X,fe))return!1;for(var it=0;it<X.set.length;++it){var tt=X.set[it],rt=null,ot=null;if(tt.forEach(function(ft){ft.semver===Ee&&(ft=new pe(">=0.0.0")),rt=rt||ft,ot=ot||ft,be(ft.semver,rt.semver,fe)?rt=ft:He(ft.semver,ot.semver,fe)&&(ot=ft)}),rt.operator===qe||rt.operator===Ye||(!ot.operator||ot.operator===qe)&&Fe(H,ot.semver)||ot.operator===Ye&&He(H,ot.semver))return!1}return!0}pe.prototype.parse=function(H){var X=this.loose?R[K]:R[ee],J=H.match(X);if(!J)throw new TypeError("Invalid comparator: "+H);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new Se(J[2],this.loose):this.semver=Ee},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(H){return k("Comparator.test",H,this.loose),this.semver===Ee||(typeof H=="string"&&(H=new Se(H,this.loose)),oe(H,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(H,X){if(!(H instanceof pe))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Ne(H.value,X),Le(this.value,J,X);if(H.operator==="")return J=new Ne(this.value,X),Le(H.semver,J,X);var fe=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Fe=this.semver.version===H.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),qe=oe(this.semver,"<",H.semver,X)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),Ye=oe(this.semver,">",H.semver,X)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return fe||be||Fe&&He||qe||Ye},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(H){var X=this.loose;H=H.trim(),k("range",H,X);var J=X?R[Z]:R[q];H=H.replace(J,Ce),k("hyphen replace",H),H=H.replace(R[$],"$1$2$3"),k("comparator trim",H,R[$]),H=(H=(H=H.replace(R[N],"$1~")).replace(R[B],"$1^")).split(/\s+/).join(" ");var fe=X?R[K]:R[ee],be=H.split(" ").map(function(Fe){return function(He,qe){return k("comp",He),He=function(Ye,it){return Ye.trim().split(/\s+/).map(function(tt){return function(rt,ot){k("caret",rt,ot);var ft=ot?R[M]:R[F];return rt.replace(ft,function(ut,st,Te,Ue,ke){var Re;return k("caret",rt,ut,st,Te,Ue,ke),We(st)?Re="":We(Te)?Re=">="+st+".0.0 <"+(+st+1)+".0.0":We(Ue)?Re=st==="0"?">="+st+"."+Te+".0 <"+st+"."+(+Te+1)+".0":">="+st+"."+Te+".0 <"+(+st+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Re=st==="0"?Te==="0"?">="+st+"."+Te+"."+Ue+ke+" <"+st+"."+Te+"."+(+Ue+1):">="+st+"."+Te+"."+Ue+ke+" <"+st+"."+(+Te+1)+".0":">="+st+"."+Te+"."+Ue+ke+" <"+(+st+1)+".0.0"):(k("no pr"),Re=st==="0"?Te==="0"?">="+st+"."+Te+"."+Ue+" <"+st+"."+Te+"."+(+Ue+1):">="+st+"."+Te+"."+Ue+" <"+st+"."+(+Te+1)+".0":">="+st+"."+Te+"."+Ue+" <"+(+st+1)+".0.0"),k("caret return",Re),Re})}(tt,it)}).join(" ")}(He,qe),k("caret",He),He=function(Ye,it){return Ye.trim().split(/\s+/).map(function(tt){return function(rt,ot){var ft=ot?R[U]:R[O];return rt.replace(ft,function(ut,st,Te,Ue,ke){var Re;return k("tilde",rt,ut,st,Te,Ue,ke),We(st)?Re="":We(Te)?Re=">="+st+".0.0 <"+(+st+1)+".0.0":We(Ue)?Re=">="+st+"."+Te+".0 <"+st+"."+(+Te+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Re=">="+st+"."+Te+"."+Ue+ke+" <"+st+"."+(+Te+1)+".0"):Re=">="+st+"."+Te+"."+Ue+" <"+st+"."+(+Te+1)+".0",k("tilde return",Re),Re})}(tt,it)}).join(" ")}(He,qe),k("tildes",He),He=function(Ye,it){return k("replaceXRanges",Ye,it),Ye.split(/\s+/).map(function(tt){return function(rt,ot){rt=rt.trim();var ft=ot?R[I]:R[S];return rt.replace(ft,function(ut,st,Te,Ue,ke,Re){k("xRange",rt,ut,st,Te,Ue,ke,Re);var ce=We(Te),Q=ce||We(Ue),Pe=Q||We(ke);return st==="="&&Pe&&(st=""),ce?ut=st===">"||st==="<"?"<0.0.0":"*":st&&Pe?(Q&&(Ue=0),Pe&&(ke=0),st===">"?(st=">=",Q?(Te=+Te+1,Ue=0,ke=0):Pe&&(Ue=+Ue+1,ke=0)):st==="<="&&(st="<",Q?Te=+Te+1:Ue=+Ue+1),ut=st+Te+"."+Ue+"."+ke):Q?ut=">="+Te+".0.0 <"+(+Te+1)+".0.0":Pe&&(ut=">="+Te+"."+Ue+".0 <"+Te+"."+(+Ue+1)+".0"),k("xRange return",ut),ut})}(tt,it)}).join(" ")}(He,qe),k("xrange",He),He=function(Ye,it){return k("replaceStars",Ye,it),Ye.trim().replace(R[ne],"")}(He,qe),k("stars",He),He}(Fe,X)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Fe){return!!Fe.match(fe)})),be=be.map(function(Fe){return new pe(Fe,X)})},Ne.prototype.intersects=function(H,X){if(!(H instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(fe){return H.set.some(function(be){return be.every(function(Fe){return fe.intersects(Fe,X)})})})})},e.toComparators=function(H,X){return new Ne(H,X).set.map(function(J){return J.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new Se(H,this.loose));for(var X=0;X<this.set.length;X++)if(Ie(this.set[X],H))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(H,X,J){var fe=null,be=null;try{var Fe=new Ne(X,J)}catch{return null}return H.forEach(function(He){Fe.test(He)&&(fe&&be.compare(He)!==-1||(be=new Se(fe=He,J)))}),fe},e.minSatisfying=function(H,X,J){var fe=null,be=null;try{var Fe=new Ne(X,J)}catch{return null}return H.forEach(function(He){Fe.test(He)&&(fe&&be.compare(He)!==1||(be=new Se(fe=He,J)))}),fe},e.validRange=function(H,X){try{return new Ne(H,X).range||"*"}catch{return null}},e.ltr=function(H,X,J){return z(H,X,"<",J)},e.gtr=function(H,X,J){return z(H,X,">",J)},e.outside=z,e.prerelease=function(H,X){var J=re(H,X);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(H,X,J){return H=new Ne(H,J),X=new Ne(X,J),H.intersects(X)},e.coerce=function(H){if(H instanceof Se)return H;if(typeof H!="string")return null;var X=H.match(R[b]);return X==null?null:re((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,r(1))},function(he,e){var r,g,k=he.exports={};function A(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(u){if(r===setTimeout)return setTimeout(u,0);if((r===A||!r)&&setTimeout)return r=setTimeout,setTimeout(u,0);try{return r(u,0)}catch{try{return r.call(null,u,0)}catch{return r.call(this,u,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:A}catch{r=A}try{g=typeof clearTimeout=="function"?clearTimeout:L}catch{g=L}})();var v,l=[],P=!1,y=-1;function d(){P&&v&&(P=!1,v.length?l=v.concat(l):y=-1,l.length&&T())}function T(){if(!P){var u=R(d);P=!0;for(var f=l.length;f;){for(v=l,l=[];++y<f;)v&&v[y].run();y=-1,f=l.length}v=null,P=!1,function(m){if(g===clearTimeout)return clearTimeout(m);if((g===L||!g)&&clearTimeout)return g=clearTimeout,clearTimeout(m);try{g(m)}catch{try{return g.call(null,m)}catch{return g.call(this,m)}}}(u)}}function E(u,f){this.fun=u,this.array=f}function a(){}k.nextTick=function(u){var f=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)f[m-1]=arguments[m];l.push(new E(u,f)),l.length!==1||P||R(T)},E.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=a,k.addListener=a,k.once=a,k.off=a,k.removeListener=a,k.removeAllListeners=a,k.emit=a,k.prependListener=a,k.prependOnceListener=a,k.listeners=function(u){return[]},k.binding=function(u){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(u){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(we[42],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class g{static create(A){return new g(A)}constructor(A){this._now=r&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=g}),define(we[4],ye([1,0,14,80,3,81,42]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=T;const R=!1,v=!1,l=!1;var P;(function(U){U.None=()=>k.Disposable.None;function x(Ce){if(l){const{onDidAddListener:Ie}=Ce,Le=a.create();let z=0;Ce.onDidAddListener=()=>{++z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Le.print()),Ie?.()}}}function B(Ce,Ie){return re(Ce,()=>{},0,void 0,!0,void 0,Ie)}U.defer=B;function F(Ce){return(Ie,Le=null,z)=>{let H=!1,X;return X=Ce(J=>{if(!H)return X?X.dispose():H=!0,Ie.call(Le,J)},null,z),H&&X.dispose(),X}}U.once=F;function M(Ce,Ie,Le){return ne((z,H=null,X)=>Ce(J=>z.call(H,Ie(J)),null,X),Le)}U.map=M;function K(Ce,Ie,Le){return ne((z,H=null,X)=>Ce(J=>{Ie(J),z.call(H,J)},null,X),Le)}U.forEach=K;function ee(Ce,Ie,Le){return ne((z,H=null,X)=>Ce(J=>Ie(J)&&z.call(H,J),null,X),Le)}U.filter=ee;function $(Ce){return Ce}U.signal=$;function q(...Ce){return(Ie,Le=null,z)=>{const H=(0,k.combinedDisposable)(...Ce.map(X=>X(J=>Ie.call(Le,J))));return de(H,z)}}U.any=q;function Z(Ce,Ie,Le,z){let H=Le;return M(Ce,X=>(H=Ie(H,X),H),z)}U.reduce=Z;function ne(Ce,Ie){let Le;const z={onWillAddFirstListener(){Le=Ce(H.fire,H)},onDidRemoveLastListener(){Le?.dispose()}};Ie||x(z);const H=new c(z);return Ie?.add(H),H.event}function de(Ce,Ie){return Ie instanceof Array?Ie.push(Ce):Ie&&Ie.add(Ce),Ce}function re(Ce,Ie,Le=100,z=!1,H=!1,X,J){let fe,be,Fe,He=0,qe;const Ye={leakWarningThreshold:X,onWillAddFirstListener(){fe=Ce(tt=>{He++,be=Ie(be,tt),z&&!Fe&&(it.fire(be),be=void 0),qe=()=>{const rt=be;be=void 0,Fe=void 0,(!z||He>1)&&it.fire(rt),He=0},typeof Le=="number"?(clearTimeout(Fe),Fe=setTimeout(qe,Le)):Fe===void 0&&(Fe=0,queueMicrotask(qe))})},onWillRemoveListener(){H&&He>0&&qe?.()},onDidRemoveLastListener(){qe=void 0,fe.dispose()}};J||x(Ye);const it=new c(Ye);return J?.add(it),it.event}U.debounce=re;function Se(Ce,Ie=0,Le){return U.debounce(Ce,(z,H)=>z?(z.push(H),z):[H],Ie,void 0,!0,void 0,Le)}U.accumulate=Se;function ve(Ce,Ie=(z,H)=>z===H,Le){let z=!0,H;return ee(Ce,X=>{const J=z||!Ie(X,H);return z=!1,H=X,J},Le)}U.latch=ve;function G(Ce,Ie,Le){return[U.filter(Ce,Ie,Le),U.filter(Ce,z=>!Ie(z),Le)]}U.split=G;function W(Ce,Ie=!1,Le=[],z){let H=Le.slice(),X=Ce(be=>{H?H.push(be):fe.fire(be)});z&&z.add(X);const J=()=>{H?.forEach(be=>fe.fire(be)),H=null},fe=new c({onWillAddFirstListener(){X||(X=Ce(be=>fe.fire(be)),z&&z.add(X))},onDidAddFirstListener(){H&&(Ie?setTimeout(J):J())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return z&&z.add(fe),fe.event}U.buffer=W;function se(Ce,Ie){return(z,H,X)=>{const J=Ie(new ie);return Ce(function(fe){const be=J.evaluate(fe);be!==ae&&z.call(H,be)},void 0,X)}}U.chain=se;const ae=Symbol("HaltChainable");class ie{constructor(){this.steps=[]}map(Ie){return this.steps.push(Ie),this}forEach(Ie){return this.steps.push(Le=>(Ie(Le),Le)),this}filter(Ie){return this.steps.push(Le=>Ie(Le)?Le:ae),this}reduce(Ie,Le){let z=Le;return this.steps.push(H=>(z=Ie(z,H),z)),this}latch(Ie=(Le,z)=>Le===z){let Le=!0,z;return this.steps.push(H=>{const X=Le||!Ie(H,z);return Le=!1,z=H,X?H:ae}),this}evaluate(Ie){for(const Le of this.steps)if(Ie=Le(Ie),Ie===ae)break;return Ie}}function le(Ce,Ie,Le=z=>z){const z=(...fe)=>J.fire(Le(...fe)),H=()=>Ce.on(Ie,z),X=()=>Ce.removeListener(Ie,z),J=new c({onWillAddFirstListener:H,onDidRemoveLastListener:X});return J.event}U.fromNodeEventEmitter=le;function ue(Ce,Ie,Le=z=>z){const z=(...fe)=>J.fire(Le(...fe)),H=()=>Ce.addEventListener(Ie,z),X=()=>Ce.removeEventListener(Ie,z),J=new c({onWillAddFirstListener:H,onDidRemoveLastListener:X});return J.event}U.fromDOMEventEmitter=ue;function Y(Ce){return new Promise(Ie=>F(Ce)(Ie))}U.toPromise=Y;function oe(Ce){const Ie=new c;return Ce.then(Le=>{Ie.fire(Le)},()=>{Ie.fire(void 0)}).finally(()=>{Ie.dispose()}),Ie.event}U.fromPromise=oe;function pe(Ce,Ie,Le){return Ie(Le),Ce(z=>Ie(z))}U.runAndSubscribe=pe;class Ee{constructor(Ie,Le){this._observable=Ie,this._counter=0,this._hasChanged=!1;const z={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Le||x(z),this.emitter=new c(z),Le&&Le.add(this.emitter)}beginUpdate(Ie){this._counter++}handlePossibleChange(Ie){}handleChange(Ie,Le){this._hasChanged=!0}endUpdate(Ie){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Ne(Ce,Ie){return new Ee(Ce,Ie).emitter.event}U.fromObservable=Ne;function We(Ce){return(Ie,Le,z)=>{let H=0,X=!1;const J={beginUpdate(){H++},endUpdate(){H--,H===0&&(Ce.reportChanges(),X&&(X=!1,Ie.call(Le)))},handlePossibleChange(){},handleChange(){X=!0}};Ce.addObserver(J),Ce.reportChanges();const fe={dispose(){Ce.removeObserver(J)}};return z instanceof k.DisposableStore?z.add(fe):Array.isArray(z)&&z.push(fe),fe}}U.fromObservableLight=We})(P||(e.Event=P={}));class y{static{this.all=new Set}static{this._idPool=0}constructor(x){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${x}_${y._idPool++}`,y.all.add(this)}start(x){this._stopWatch=new L.StopWatch,this.listenerCount=x}stop(){if(this._stopWatch){const x=this._stopWatch.elapsed();this.durations.push(x),this.elapsedOverall+=x,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=y;let d=-1;function T(U){const x=d;return d=U,{dispose(){d=x}}}class E{constructor(x,B,F=Math.random().toString(18).slice(2,5)){this._errorHandler=x,this.threshold=B,this.name=F,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(x,B){const F=this.threshold;if(F<=0||B<F)return;this._stacks||(this._stacks=new Map);const M=this._stacks.get(x.value)||0;if(this._stacks.set(x.value,M+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=F*.5;const[K,ee]=this.getMostFrequentStack(),$=`[${this.name}] potential listener LEAK detected, having ${B} listeners already. MOST frequent listener (${ee}):`;console.warn($),console.warn(K);const q=new u($,K);this._errorHandler(q)}return()=>{const K=this._stacks.get(x.value)||0;this._stacks.set(x.value,K-1)}}getMostFrequentStack(){if(!this._stacks)return;let x,B=0;for(const[F,M]of this._stacks)(!x||B<M)&&(x=[F,M],B=M);return x}}class a{static create(){const x=new Error;return new a(x.stack??"")}constructor(x){this.value=x}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u extends Error{constructor(x,B){super(x),this.name="ListenerLeakError",this.stack=B}}e.ListenerLeakError=u;class f extends Error{constructor(x,B){super(x),this.name="ListenerRefusalError",this.stack=B}}e.ListenerRefusalError=f;let m=0;class n{constructor(x){this.value=x,this.id=m++}}const s=2,i=(U,x)=>{if(U instanceof n)x(U);else for(let B=0;B<U.length;B++){const F=U[B];F&&x(F)}},t=R?new FinalizationRegistry(U=>{typeof U=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(U))}):void 0;class c{constructor(x){this._size=0,this._options=x,this._leakageMon=d>0||this._options?.leakWarningThreshold?new E(x?.onListenerError??r.onUnexpectedError,this._options?.leakWarningThreshold??d):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(v){const x=this._listeners;queueMicrotask(()=>{i(x,B=>B.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(x,B,F)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const q=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(q);const Z=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new f(`${q}. HINT: Stack shows most frequent listener (${Z[1]}-times)`,Z[0]);return(this._options?.onListenerError||r.onUnexpectedError)(ne),k.Disposable.None}if(this._disposed)return k.Disposable.None;B&&(x=x.bind(B));const M=new n(x);let K,ee;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(M.stack=a.create(),K=this._leakageMon.check(M.stack,this._size+1)),v&&(M.stack=ee??a.create()),this._listeners?this._listeners instanceof n?(this._deliveryQueue??=new o,this._listeners=[this._listeners,M]):this._listeners.push(M):(this._options?.onWillAddFirstListener?.(this),this._listeners=M,this._options?.onDidAddFirstListener?.(this)),this._size++;const $=(0,k.toDisposable)(()=>{t?.unregister($),K?.(),this._removeListener(M)});if(F instanceof k.DisposableStore?F.add($):Array.isArray(F)&&F.push($),t){const q=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register($,q,$)}return $},this._event}_removeListener(x){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const B=this._listeners,F=B.indexOf(x);if(F===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,B[F]=void 0;const M=this._deliveryQueue.current===this;if(this._size*s<=B.length){let K=0;for(let ee=0;ee<B.length;ee++)B[ee]?B[K++]=B[ee]:M&&(this._deliveryQueue.end--,K<this._deliveryQueue.i&&this._deliveryQueue.i--);B.length=K}}_deliver(x,B){if(!x)return;const F=this._options?.onListenerError||r.onUnexpectedError;if(!F){x.value(B);return}try{x.value(B)}catch(M){F(M)}}_deliverQueue(x){const B=x.current._listeners;for(;x.i<x.end;)this._deliver(B[x.i++],x.value);x.reset()}fire(x){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof n)this._deliver(this._listeners,x);else{const B=this._deliveryQueue;B.enqueue(this,x,this._listeners.length),this._deliverQueue(B)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=c;const h=()=>new o;e.createEventDeliveryQueue=h;class o{constructor(){this.i=-1,this.end=0}enqueue(x,B,F){this.i=0,this.end=F,this.current=x,this.value=B}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class p extends c{async fireAsync(x,B,F){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),i(this._listeners,M=>this._asyncDeliveryQueue.push([M.value,x]));this._asyncDeliveryQueue.size>0&&!B.isCancellationRequested;){const[M,K]=this._asyncDeliveryQueue.shift(),ee=[],$={...K,token:B,waitUntil:q=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");F&&(q=F(q,M)),ee.push(q)}};try{M($)}catch(q){(0,r.onUnexpectedError)(q);continue}Object.freeze(ee),await Promise.allSettled(ee).then(q=>{for(const Z of q)Z.status==="rejected"&&(0,r.onUnexpectedError)(Z.reason)})}}}e.AsyncEmitter=p;class _ extends c{get isPaused(){return this._isPaused!==0}constructor(x){super(x),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=x?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const x=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(x))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(x){this._size&&(this._isPaused!==0?this._eventQueue.push(x):super.fire(x))}}e.PauseableEmitter=_;class D extends _{constructor(x){super(x),this._delay=x.delay??100}fire(x){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(x)}}e.DebounceEmitter=D;class C extends c{constructor(x){super(x),this._queuedEvents=[],this._mergeFn=x?.merge}fire(x){this.hasListeners()&&(this._queuedEvents.push(x),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(B=>super.fire(B)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=C;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(x){const B={event:x,listener:null};this.events.push(B),this.hasListeners&&this.hook(B);const F=()=>{this.hasListeners&&this.unhook(B);const M=this.events.indexOf(B);this.events.splice(M,1)};return(0,k.toDisposable)((0,g.createSingleCallFunction)(F))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(x=>this.hook(x))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(x=>this.unhook(x))}hook(x){x.listener=x.event(B=>this.emitter.fire(B))}unhook(x){x.listener?.dispose(),x.listener=null}dispose(){this.emitter.dispose();for(const x of this.events)x.listener?.dispose();this.events=[]}}e.EventMultiplexer=S;class I{constructor(x,B,F,M){this._store=new k.DisposableStore;const K=this._store.add(new S),ee=this._store.add(new k.DisposableMap);function $(q){ee.set(q,K.add(M(q)))}for(const q of x)$(q);this._store.add(B(q=>{$(q)})),this._store.add(F(q=>{ee.deleteAndDispose(q)})),this.event=K.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=I;class b{constructor(){this.data=[]}wrapEvent(x,B,F){return(M,K,ee)=>x($=>{const q=this.data[this.data.length-1];if(!B){q?q.buffers.push(()=>M.call(K,$)):M.call(K,$);return}const Z=q;if(!Z){M.call(K,B(F,$));return}Z.items??=[],Z.items.push($),Z.buffers.length===0&&q.buffers.push(()=>{Z.reducedResult??=F?Z.items.reduce(B,F):Z.items.reduce(B),M.call(K,Z.reducedResult)})},void 0,ee)}bufferEvents(x){const B={buffers:new Array};this.data.push(B);const F=x();return this.data.pop(),B.buffers.forEach(M=>M()),F}}e.EventBufferer=b;class w{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=k.Disposable.None,this.emitter=new c({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(x){this.inputEvent=x,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=x(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w;class N{static const(x){return new O(x)}constructor(x){this._value=x,this._onDidChange=new c,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(x){x!==this._value&&(this._value=x,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=N;class O{constructor(x){this.value=x,this.onDidChange=P.None}}}),define(we[21],ye([1,0,4]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=R;const g=Object.freeze(function(v,l){const P=setTimeout(v.bind(l),0);return{dispose(){clearTimeout(P)}}});var k;(function(v){function l(P){return P===v.None||P===v.Cancelled||P instanceof A?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}v.isCancellationToken=l,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:g})})(k||(e.CancellationToken=k={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?g:(this._emitter||(this._emitter=new r.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=k.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=L;function R(v){const l=new L;return v.add({dispose(){l.cancel()}}),l.token}}),define(we[181],ye([1,0,21]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=k;class g{constructor(v){this.task=v,this.result=null}get(){if(this.result)return this.result;const v=new r.CancellationTokenSource,l=this.task(v.token);return this.result={promise:l,dispose:()=>{this.result=null,v.cancel(),v.dispose()}},this.result}}e.Cache=g;function k(R){return R}class A{constructor(v,l){this.lastCache=void 0,this.lastArgKey=void 0,typeof v=="function"?(this._fn=v,this._computeKey=k):(this._fn=l,this._computeKey=v.getCacheKey)}get(v){const l=this._computeKey(v);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this._fn(v)),this.lastCache}}e.LRUCachedFunction=A;class L{get cachedValues(){return this._map}constructor(v,l){this._map=new Map,this._map2=new Map,typeof v=="function"?(this._fn=v,this._computeKey=k):(this._fn=l,this._computeKey=v.getCacheKey)}get(v){const l=this._computeKey(v);if(this._map2.has(l))return this._map2.get(l);const P=this._fn(v);return this._map.set(v,P),this._map2.set(l,P),P}}e.CachedFunction=L}),define(we[182],ye([1,0,4,3]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SmoothScrollingOperation=e.SmoothScrollingUpdate=e.Scrollable=e.ScrollState=e.ScrollbarVisibility=void 0;var k;(function(T){T[T.Auto=1]="Auto",T[T.Hidden=2]="Hidden",T[T.Visible=3]="Visible"})(k||(e.ScrollbarVisibility=k={}));class A{constructor(E,a,u,f,m,n,s){this._forceIntegerValues=E,this._scrollStateBrand=void 0,this._forceIntegerValues&&(a=a|0,u=u|0,f=f|0,m=m|0,n=n|0,s=s|0),this.rawScrollLeft=f,this.rawScrollTop=s,a<0&&(a=0),f+a>u&&(f=u-a),f<0&&(f=0),m<0&&(m=0),s+m>n&&(s=n-m),s<0&&(s=0),this.width=a,this.scrollWidth=u,this.scrollLeft=f,this.height=m,this.scrollHeight=n,this.scrollTop=s}equals(E){return this.rawScrollLeft===E.rawScrollLeft&&this.rawScrollTop===E.rawScrollTop&&this.width===E.width&&this.scrollWidth===E.scrollWidth&&this.scrollLeft===E.scrollLeft&&this.height===E.height&&this.scrollHeight===E.scrollHeight&&this.scrollTop===E.scrollTop}withScrollDimensions(E,a){return new A(this._forceIntegerValues,typeof E.width<"u"?E.width:this.width,typeof E.scrollWidth<"u"?E.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof E.height<"u"?E.height:this.height,typeof E.scrollHeight<"u"?E.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(E){return new A(this._forceIntegerValues,this.width,this.scrollWidth,typeof E.scrollLeft<"u"?E.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof E.scrollTop<"u"?E.scrollTop:this.rawScrollTop)}createScrollEvent(E,a){const u=this.width!==E.width,f=this.scrollWidth!==E.scrollWidth,m=this.scrollLeft!==E.scrollLeft,n=this.height!==E.height,s=this.scrollHeight!==E.scrollHeight,i=this.scrollTop!==E.scrollTop;return{inSmoothScrolling:a,oldWidth:E.width,oldScrollWidth:E.scrollWidth,oldScrollLeft:E.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:E.height,oldScrollHeight:E.scrollHeight,oldScrollTop:E.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:u,scrollWidthChanged:f,scrollLeftChanged:m,heightChanged:n,scrollHeightChanged:s,scrollTopChanged:i}}}e.ScrollState=A;class L extends g.Disposable{constructor(E){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new r.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=E.smoothScrollDuration,this._scheduleAtNextAnimationFrame=E.scheduleAtNextAnimationFrame,this._state=new A(E.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(E){this._smoothScrollDuration=E}validateScrollPosition(E){return this._state.withScrollPosition(E)}getScrollDimensions(){return this._state}setScrollDimensions(E,a){const u=this._state.withScrollDimensions(E,a);this._setState(u,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(E){const a=this._state.withScrollPosition(E);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(a,!1)}setScrollPositionSmooth(E,a){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(E);if(this._smoothScrolling){E={scrollLeft:typeof E.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:E.scrollLeft,scrollTop:typeof E.scrollTop>"u"?this._smoothScrolling.to.scrollTop:E.scrollTop};const u=this._state.withScrollPosition(E);if(this._smoothScrolling.to.scrollLeft===u.scrollLeft&&this._smoothScrolling.to.scrollTop===u.scrollTop)return;let f;a?f=new P(this._smoothScrolling.from,u,this._smoothScrolling.startTime,this._smoothScrolling.duration):f=this._smoothScrolling.combine(this._state,u,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=f}else{const u=this._state.withScrollPosition(E);this._smoothScrolling=P.start(this._state,u,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const E=this._smoothScrolling.tick(),a=this._state.withScrollPosition(E);if(this._setState(a,!0),!!this._smoothScrolling){if(E.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(E,a){const u=this._state;u.equals(E)||(this._state=E,this._onScroll.fire(this._state.createScrollEvent(u,a)))}}e.Scrollable=L;class R{constructor(E,a,u){this.scrollLeft=E,this.scrollTop=a,this.isDone=u}}e.SmoothScrollingUpdate=R;function v(T,E){const a=E-T;return function(u){return T+a*d(u)}}function l(T,E,a){return function(u){return u<a?T(u/a):E((u-a)/(1-a))}}class P{constructor(E,a,u,f){this.from=E,this.to=a,this.duration=f,this.startTime=u,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(E,a,u){if(Math.abs(E-a)>2.5*u){let m,n;return E<a?(m=E+.75*u,n=a-.75*u):(m=E-.75*u,n=a+.75*u),l(v(E,m),v(n,a),.33)}return v(E,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(E){this.to=E.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(E){const a=(E-this.startTime)/this.duration;if(a<1){const u=this.scrollLeft(a),f=this.scrollTop(a);return new R(u,f,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(E,a,u){return P.start(E,a,u)}static start(E,a,u){u=u+10;const f=Date.now()-10;return new P(E,a,f,u)}}e.SmoothScrollingOperation=P;function y(T){return Math.pow(T,3)}function d(T){return 1-y(1-T)}}),define(we[103],ye([1,0,14,3]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=k,e.isReadableStream=A,e.isReadableBufferedStream=L,e.newWriteableStream=R,e.consumeReadable=l,e.peekReadable=P,e.consumeStream=y,e.listenStream=d,e.peekStream=T,e.toStream=E,e.emptyStream=a,e.toReadable=u,e.transform=f,e.prefixedReadable=m,e.prefixedStream=n;function k(s){const i=s;return i?typeof i.read=="function":!1}function A(s){const i=s;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function L(s){const i=s;return i?A(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function R(s,i){return new v(s,i)}class v{constructor(i,t){this.reducer=i,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(i){if(!this.state.destroyed){if(this.state.flowing)this.emitData(i);else if(this.buffer.data.push(i),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(i){this.state.destroyed||(this.state.flowing?this.emitError(i):this.buffer.error.push(i))}end(i){this.state.destroyed||(typeof i<"u"&&this.write(i),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(i){this.listeners.data.slice(0).forEach(t=>t(i))}emitError(i){this.listeners.error.length===0?(0,r.onUnexpectedError)(i):this.listeners.error.slice(0).forEach(t=>t(i))}emitEnd(){this.listeners.end.slice(0).forEach(i=>i())}on(i,t){if(!this.state.destroyed)switch(i){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(i,t){if(this.state.destroyed)return;let c;switch(i){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const h=c.indexOf(t);h>=0&&c.splice(h,1)}}flowData(){if(this.buffer.data.length>0){const i=this.reducer(this.buffer.data);this.emitData(i),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const i of this.buffer.error)this.emitError(i);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(s,i){const t=[];let c;for(;(c=s.read())!==null;)t.push(c);return i(t)}function P(s,i,t){const c=[];let h;for(;(h=s.read())!==null&&c.length<t;)c.push(h);return h===null&&c.length>0?i(c):{read:()=>{if(c.length>0)return c.shift();if(typeof h<"u"){const o=h;return h=void 0,o}return s.read()}}}function y(s,i){return new Promise((t,c)=>{const h=[];d(s,{onData:o=>{i&&h.push(o)},onError:o=>{i?c(o):t(void 0)},onEnd:()=>{t(i?i(h):void 0)}})})}function d(s,i,t){s.on("error",c=>{t?.isCancellationRequested||i.onError(c)}),s.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),s.on("data",c=>{t?.isCancellationRequested||i.onData(c)})}function T(s,i){return new Promise((t,c)=>{const h=new g.DisposableStore,o=[],p=C=>{if(o.push(C),o.length>i)return h.dispose(),s.pause(),t({stream:s,buffer:o,ended:!1})},_=C=>(h.dispose(),c(C)),D=()=>(h.dispose(),t({stream:s,buffer:o,ended:!0}));h.add((0,g.toDisposable)(()=>s.removeListener("error",_))),s.on("error",_),h.add((0,g.toDisposable)(()=>s.removeListener("end",D))),s.on("end",D),h.add((0,g.toDisposable)(()=>s.removeListener("data",p))),s.on("data",p)})}function E(s,i){const t=R(i);return t.end(s),t}function a(){const s=R(()=>{throw new Error("not supported")});return s.end(),s}function u(s){let i=!1;return{read:()=>i?null:(i=!0,s)}}function f(s,i,t){const c=R(t);return d(s,{onData:h=>c.write(i.data(h)),onError:h=>c.error(i.error?i.error(h):h),onEnd:()=>c.end()}),c}function m(s,i,t){let c=!1;return{read:()=>{const h=i.read();return c?h:(c=!0,h!==null?t([s,h]):s)}}}function n(s,i,t){let c=!1;const h=R(t);return d(i,{onData:o=>c?h.write(o):(c=!0,h.write(t([s,o]))),onError:o=>h.error(o),onEnd:()=>{c||(c=!0,h.write(s)),h.end()}}),h}}),define(we[22],ye([1,0,49,103]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=l,e.readUInt16LE=P,e.writeUInt16LE=y,e.readUInt32BE=d,e.writeUInt32BE=T,e.readUInt32LE=E,e.writeUInt32LE=a,e.readUInt8=u,e.writeUInt8=f,e.readableToBuffer=m,e.bufferToReadable=n,e.streamToBuffer=s,e.bufferedStreamToBuffer=i,e.bufferToStream=t,e.streamToBufferReadableStream=c,e.newWriteableBufferStream=h,e.prefixedBufferReadable=o,e.prefixedBufferStream=p,e.decodeBase64=_,e.encodeBase64=S;const k=typeof Buffer<"u",A=new r.Lazy(()=>new Uint8Array(256));let L,R;class v{static alloc(b){return k?new v(Buffer.allocUnsafe(b)):new v(new Uint8Array(b))}static wrap(b){return k&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new v(b)}static fromString(b,w){return!(w?.dontUseNodeBuffer||!1)&&k?new v(Buffer.from(b)):(L||(L=new TextEncoder),new v(L.encode(b)))}static fromByteArray(b){const w=v.alloc(b.length);for(let N=0,O=b.length;N<O;N++)w.buffer[N]=b[N];return w}static concat(b,w){if(typeof w>"u"){w=0;for(let U=0,x=b.length;U<x;U++)w+=b[U].byteLength}const N=v.alloc(w);let O=0;for(let U=0,x=b.length;U<x;U++){const B=b[U];N.set(B,O),O+=B.byteLength}return N}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=v.alloc(this.byteLength);return b.set(this),b}toString(){return k?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(b,w){return new v(this.buffer.subarray(b,w))}set(b,w){if(b instanceof v)this.buffer.set(b.buffer,w);else if(b instanceof Uint8Array)this.buffer.set(b,w);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),w);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return d(this.buffer,b)}writeUInt32BE(b,w){T(this.buffer,b,w)}readUInt32LE(b){return E(this.buffer,b)}writeUInt32LE(b,w){a(this.buffer,b,w)}readUInt8(b){return u(this.buffer,b)}writeUInt8(b,w){f(this.buffer,b,w)}indexOf(b,w=0){return l(this.buffer,b instanceof v?b.buffer:b,w)}}e.VSBuffer=v;function l(I,b,w=0){const N=b.byteLength,O=I.byteLength;if(N===0)return 0;if(N===1)return I.indexOf(b[0]);if(N>O-w)return-1;const U=A.value;U.fill(b.length);for(let M=0;M<b.length;M++)U[b[M]]=b.length-M-1;let x=w+b.length-1,B=x,F=-1;for(;x<O;)if(I[x]===b[B]){if(B===0){F=x;break}x--,B--}else x+=Math.max(b.length-B,U[I[x]]),B=b.length-1;return F}function P(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0}function y(I,b,w){I[w+0]=b&255,b=b>>>8,I[w+1]=b&255}function d(I,b){return I[b]*2**24+I[b+1]*2**16+I[b+2]*2**8+I[b+3]}function T(I,b,w){I[w+3]=b,b=b>>>8,I[w+2]=b,b=b>>>8,I[w+1]=b,b=b>>>8,I[w]=b}function E(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0|I[b+2]<<16>>>0|I[b+3]<<24>>>0}function a(I,b,w){I[w+0]=b&255,b=b>>>8,I[w+1]=b&255,b=b>>>8,I[w+2]=b&255,b=b>>>8,I[w+3]=b&255}function u(I,b){return I[b]}function f(I,b,w){I[w]=b}function m(I){return g.consumeReadable(I,b=>v.concat(b))}function n(I){return g.toReadable(I)}function s(I){return g.consumeStream(I,b=>v.concat(b))}async function i(I){return I.ended?v.concat(I.buffer):v.concat([...I.buffer,await s(I.stream)])}function t(I){return g.toStream(I,b=>v.concat(b))}function c(I){return g.transform(I,{data:b=>typeof b=="string"?v.fromString(b):v.wrap(b)},b=>v.concat(b))}function h(I){return g.newWriteableStream(b=>v.concat(b),I)}function o(I,b){return g.prefixedReadable(I,b,w=>v.concat(w))}function p(I,b){return g.prefixedStream(I,b,w=>v.concat(w))}function _(I){let b=0,w=0,N=0;const O=new Uint8Array(Math.floor(I.length/4*3)),U=B=>{switch(w){case 3:O[N++]=b|B,w=0;break;case 2:O[N++]=b|B>>>2,b=B<<6,w=3;break;case 1:O[N++]=b|B>>>4,b=B<<4,w=2;break;default:b=B<<2,w=1}};for(let B=0;B<I.length;B++){const F=I.charCodeAt(B);if(F>=65&&F<=90)U(F-65);else if(F>=97&&F<=122)U(F-97+26);else if(F>=48&&F<=57)U(F-48+52);else if(F===43||F===45)U(62);else if(F===47||F===95)U(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${I[B]}`)}}const x=N;for(;w>0;)U(0);return v.wrap(O).slice(0,x)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:I},b=!0,w=!1){const N=w?C:D;let O="";const U=I.byteLength%3;let x=0;for(;x<I.byteLength-U;x+=3){const B=I[x+0],F=I[x+1],M=I[x+2];O+=N[B>>>2],O+=N[(B<<4|F>>>4)&63],O+=N[(F<<2|M>>>6)&63],O+=N[M&63]}if(U===1){const B=I[x+0];O+=N[B>>>2],O+=N[B<<4&63],b&&(O+="==")}else if(U===2){const B=I[x+0],F=I[x+1];O+=N[B>>>2],O+=N[(B<<4|F>>>4)&63],O+=N[F<<2&63],b&&(O+="=")}return O}}),define(we[183],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(we[18],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=r,e.isStringArray=g,e.isObject=k,e.isTypedArray=A,e.isNumber=L,e.isIterable=R,e.isBoolean=v,e.isUndefined=l,e.isDefined=P,e.isUndefinedOrNull=y,e.assertType=d,e.assertIsDefined=T,e.assertAllDefined=E,e.isEmptyObject=u,e.isFunction=f,e.areFunctions=m,e.validateConstraints=n,e.validateConstraint=s;function r(i){return typeof i=="string"}function g(i){return Array.isArray(i)&&i.every(t=>r(t))}function k(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function A(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function L(i){return typeof i=="number"&&!isNaN(i)}function R(i){return!!i&&typeof i[Symbol.iterator]=="function"}function v(i){return i===!0||i===!1}function l(i){return typeof i>"u"}function P(i){return!y(i)}function y(i){return l(i)||i===null}function d(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function T(i){if(y(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function E(...i){const t=[];for(let c=0;c<i.length;c++){const h=i[c];if(y(h))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);t.push(h)}return t}const a=Object.prototype.hasOwnProperty;function u(i){if(!k(i))return!1;for(const t in i)if(a.call(i,t))return!1;return!0}function f(i){return typeof i=="function"}function m(...i){return i.length>0&&i.every(f)}function n(i,t){const c=Math.min(i.length,t.length);for(let h=0;h<c;h++)s(i[h],t[h])}function s(i,t){if(r(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(i instanceof t)return}catch{}if(!y(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(we[104],ye([1,0,18]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=k,e.getCodiconFontCharacters=A;const g=Object.create(null);function k(L,R){if((0,r.isString)(R)){const v=g[R];if(v===void 0)throw new Error(`${L} references an unknown codicon: ${R}`);R=v}return g[L]=R,{id:L}}function A(){return g}}),define(we[184],ye([1,0,104]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,r.register)("add",6e4),plus:(0,r.register)("plus",6e4),gistNew:(0,r.register)("gist-new",6e4),repoCreate:(0,r.register)("repo-create",6e4),lightbulb:(0,r.register)("lightbulb",60001),lightBulb:(0,r.register)("light-bulb",60001),repo:(0,r.register)("repo",60002),repoDelete:(0,r.register)("repo-delete",60002),gistFork:(0,r.register)("gist-fork",60003),repoForked:(0,r.register)("repo-forked",60003),gitPullRequest:(0,r.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.register)("git-pull-request-abandoned",60004),recordKeys:(0,r.register)("record-keys",60005),keyboard:(0,r.register)("keyboard",60005),tag:(0,r.register)("tag",60006),gitPullRequestLabel:(0,r.register)("git-pull-request-label",60006),tagAdd:(0,r.register)("tag-add",60006),tagRemove:(0,r.register)("tag-remove",60006),person:(0,r.register)("person",60007),personFollow:(0,r.register)("person-follow",60007),personOutline:(0,r.register)("person-outline",60007),personFilled:(0,r.register)("person-filled",60007),gitBranch:(0,r.register)("git-branch",60008),gitBranchCreate:(0,r.register)("git-branch-create",60008),gitBranchDelete:(0,r.register)("git-branch-delete",60008),sourceControl:(0,r.register)("source-control",60008),mirror:(0,r.register)("mirror",60009),mirrorPublic:(0,r.register)("mirror-public",60009),star:(0,r.register)("star",60010),starAdd:(0,r.register)("star-add",60010),starDelete:(0,r.register)("star-delete",60010),starEmpty:(0,r.register)("star-empty",60010),comment:(0,r.register)("comment",60011),commentAdd:(0,r.register)("comment-add",60011),alert:(0,r.register)("alert",60012),warning:(0,r.register)("warning",60012),search:(0,r.register)("search",60013),searchSave:(0,r.register)("search-save",60013),logOut:(0,r.register)("log-out",60014),signOut:(0,r.register)("sign-out",60014),logIn:(0,r.register)("log-in",60015),signIn:(0,r.register)("sign-in",60015),eye:(0,r.register)("eye",60016),eyeUnwatch:(0,r.register)("eye-unwatch",60016),eyeWatch:(0,r.register)("eye-watch",60016),circleFilled:(0,r.register)("circle-filled",60017),primitiveDot:(0,r.register)("primitive-dot",60017),closeDirty:(0,r.register)("close-dirty",60017),debugBreakpoint:(0,r.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.register)("debug-breakpoint-disabled",60017),debugHint:(0,r.register)("debug-hint",60017),terminalDecorationSuccess:(0,r.register)("terminal-decoration-success",60017),primitiveSquare:(0,r.register)("primitive-square",60018),edit:(0,r.register)("edit",60019),pencil:(0,r.register)("pencil",60019),info:(0,r.register)("info",60020),issueOpened:(0,r.register)("issue-opened",60020),gistPrivate:(0,r.register)("gist-private",60021),gitForkPrivate:(0,r.register)("git-fork-private",60021),lock:(0,r.register)("lock",60021),mirrorPrivate:(0,r.register)("mirror-private",60021),close:(0,r.register)("close",60022),removeClose:(0,r.register)("remove-close",60022),x:(0,r.register)("x",60022),repoSync:(0,r.register)("repo-sync",60023),sync:(0,r.register)("sync",60023),clone:(0,r.register)("clone",60024),desktopDownload:(0,r.register)("desktop-download",60024),beaker:(0,r.register)("beaker",60025),microscope:(0,r.register)("microscope",60025),vm:(0,r.register)("vm",60026),deviceDesktop:(0,r.register)("device-desktop",60026),file:(0,r.register)("file",60027),fileText:(0,r.register)("file-text",60027),more:(0,r.register)("more",60028),ellipsis:(0,r.register)("ellipsis",60028),kebabHorizontal:(0,r.register)("kebab-horizontal",60028),mailReply:(0,r.register)("mail-reply",60029),reply:(0,r.register)("reply",60029),organization:(0,r.register)("organization",60030),organizationFilled:(0,r.register)("organization-filled",60030),organizationOutline:(0,r.register)("organization-outline",60030),newFile:(0,r.register)("new-file",60031),fileAdd:(0,r.register)("file-add",60031),newFolder:(0,r.register)("new-folder",60032),fileDirectoryCreate:(0,r.register)("file-directory-create",60032),trash:(0,r.register)("trash",60033),trashcan:(0,r.register)("trashcan",60033),history:(0,r.register)("history",60034),clock:(0,r.register)("clock",60034),folder:(0,r.register)("folder",60035),fileDirectory:(0,r.register)("file-directory",60035),symbolFolder:(0,r.register)("symbol-folder",60035),logoGithub:(0,r.register)("logo-github",60036),markGithub:(0,r.register)("mark-github",60036),github:(0,r.register)("github",60036),terminal:(0,r.register)("terminal",60037),console:(0,r.register)("console",60037),repl:(0,r.register)("repl",60037),zap:(0,r.register)("zap",60038),symbolEvent:(0,r.register)("symbol-event",60038),error:(0,r.register)("error",60039),stop:(0,r.register)("stop",60039),variable:(0,r.register)("variable",60040),symbolVariable:(0,r.register)("symbol-variable",60040),array:(0,r.register)("array",60042),symbolArray:(0,r.register)("symbol-array",60042),symbolModule:(0,r.register)("symbol-module",60043),symbolPackage:(0,r.register)("symbol-package",60043),symbolNamespace:(0,r.register)("symbol-namespace",60043),symbolObject:(0,r.register)("symbol-object",60043),symbolMethod:(0,r.register)("symbol-method",60044),symbolFunction:(0,r.register)("symbol-function",60044),symbolConstructor:(0,r.register)("symbol-constructor",60044),symbolBoolean:(0,r.register)("symbol-boolean",60047),symbolNull:(0,r.register)("symbol-null",60047),symbolNumeric:(0,r.register)("symbol-numeric",60048),symbolNumber:(0,r.register)("symbol-number",60048),symbolStructure:(0,r.register)("symbol-structure",60049),symbolStruct:(0,r.register)("symbol-struct",60049),symbolParameter:(0,r.register)("symbol-parameter",60050),symbolTypeParameter:(0,r.register)("symbol-type-parameter",60050),symbolKey:(0,r.register)("symbol-key",60051),symbolText:(0,r.register)("symbol-text",60051),symbolReference:(0,r.register)("symbol-reference",60052),goToFile:(0,r.register)("go-to-file",60052),symbolEnum:(0,r.register)("symbol-enum",60053),symbolValue:(0,r.register)("symbol-value",60053),symbolRuler:(0,r.register)("symbol-ruler",60054),symbolUnit:(0,r.register)("symbol-unit",60054),activateBreakpoints:(0,r.register)("activate-breakpoints",60055),archive:(0,r.register)("archive",60056),arrowBoth:(0,r.register)("arrow-both",60057),arrowDown:(0,r.register)("arrow-down",60058),arrowLeft:(0,r.register)("arrow-left",60059),arrowRight:(0,r.register)("arrow-right",60060),arrowSmallDown:(0,r.register)("arrow-small-down",60061),arrowSmallLeft:(0,r.register)("arrow-small-left",60062),arrowSmallRight:(0,r.register)("arrow-small-right",60063),arrowSmallUp:(0,r.register)("arrow-small-up",60064),arrowUp:(0,r.register)("arrow-up",60065),bell:(0,r.register)("bell",60066),bold:(0,r.register)("bold",60067),book:(0,r.register)("book",60068),bookmark:(0,r.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.register)("briefcase",60076),broadcast:(0,r.register)("broadcast",60077),browser:(0,r.register)("browser",60078),bug:(0,r.register)("bug",60079),calendar:(0,r.register)("calendar",60080),caseSensitive:(0,r.register)("case-sensitive",60081),check:(0,r.register)("check",60082),checklist:(0,r.register)("checklist",60083),chevronDown:(0,r.register)("chevron-down",60084),chevronLeft:(0,r.register)("chevron-left",60085),chevronRight:(0,r.register)("chevron-right",60086),chevronUp:(0,r.register)("chevron-up",60087),chromeClose:(0,r.register)("chrome-close",60088),chromeMaximize:(0,r.register)("chrome-maximize",60089),chromeMinimize:(0,r.register)("chrome-minimize",60090),chromeRestore:(0,r.register)("chrome-restore",60091),circleOutline:(0,r.register)("circle-outline",60092),circle:(0,r.register)("circle",60092),debugBreakpointUnverified:(0,r.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.register)("terminal-decoration-incomplete",60092),circleSlash:(0,r.register)("circle-slash",60093),circuitBoard:(0,r.register)("circuit-board",60094),clearAll:(0,r.register)("clear-all",60095),clippy:(0,r.register)("clippy",60096),closeAll:(0,r.register)("close-all",60097),cloudDownload:(0,r.register)("cloud-download",60098),cloudUpload:(0,r.register)("cloud-upload",60099),code:(0,r.register)("code",60100),collapseAll:(0,r.register)("collapse-all",60101),colorMode:(0,r.register)("color-mode",60102),commentDiscussion:(0,r.register)("comment-discussion",60103),creditCard:(0,r.register)("credit-card",60105),dash:(0,r.register)("dash",60108),dashboard:(0,r.register)("dashboard",60109),database:(0,r.register)("database",60110),debugContinue:(0,r.register)("debug-continue",60111),debugDisconnect:(0,r.register)("debug-disconnect",60112),debugPause:(0,r.register)("debug-pause",60113),debugRestart:(0,r.register)("debug-restart",60114),debugStart:(0,r.register)("debug-start",60115),debugStepInto:(0,r.register)("debug-step-into",60116),debugStepOut:(0,r.register)("debug-step-out",60117),debugStepOver:(0,r.register)("debug-step-over",60118),debugStop:(0,r.register)("debug-stop",60119),debug:(0,r.register)("debug",60120),deviceCameraVideo:(0,r.register)("device-camera-video",60121),deviceCamera:(0,r.register)("device-camera",60122),deviceMobile:(0,r.register)("device-mobile",60123),diffAdded:(0,r.register)("diff-added",60124),diffIgnored:(0,r.register)("diff-ignored",60125),diffModified:(0,r.register)("diff-modified",60126),diffRemoved:(0,r.register)("diff-removed",60127),diffRenamed:(0,r.register)("diff-renamed",60128),diff:(0,r.register)("diff",60129),diffSidebyside:(0,r.register)("diff-sidebyside",60129),discard:(0,r.register)("discard",60130),editorLayout:(0,r.register)("editor-layout",60131),emptyWindow:(0,r.register)("empty-window",60132),exclude:(0,r.register)("exclude",60133),extensions:(0,r.register)("extensions",60134),eyeClosed:(0,r.register)("eye-closed",60135),fileBinary:(0,r.register)("file-binary",60136),fileCode:(0,r.register)("file-code",60137),fileMedia:(0,r.register)("file-media",60138),filePdf:(0,r.register)("file-pdf",60139),fileSubmodule:(0,r.register)("file-submodule",60140),fileSymlinkDirectory:(0,r.register)("file-symlink-directory",60141),fileSymlinkFile:(0,r.register)("file-symlink-file",60142),fileZip:(0,r.register)("file-zip",60143),files:(0,r.register)("files",60144),filter:(0,r.register)("filter",60145),flame:(0,r.register)("flame",60146),foldDown:(0,r.register)("fold-down",60147),foldUp:(0,r.register)("fold-up",60148),fold:(0,r.register)("fold",60149),folderActive:(0,r.register)("folder-active",60150),folderOpened:(0,r.register)("folder-opened",60151),gear:(0,r.register)("gear",60152),gift:(0,r.register)("gift",60153),gistSecret:(0,r.register)("gist-secret",60154),gist:(0,r.register)("gist",60155),gitCommit:(0,r.register)("git-commit",60156),gitCompare:(0,r.register)("git-compare",60157),compareChanges:(0,r.register)("compare-changes",60157),gitMerge:(0,r.register)("git-merge",60158),githubAction:(0,r.register)("github-action",60159),githubAlt:(0,r.register)("github-alt",60160),globe:(0,r.register)("globe",60161),grabber:(0,r.register)("grabber",60162),graph:(0,r.register)("graph",60163),gripper:(0,r.register)("gripper",60164),heart:(0,r.register)("heart",60165),home:(0,r.register)("home",60166),horizontalRule:(0,r.register)("horizontal-rule",60167),hubot:(0,r.register)("hubot",60168),inbox:(0,r.register)("inbox",60169),issueReopened:(0,r.register)("issue-reopened",60171),issues:(0,r.register)("issues",60172),italic:(0,r.register)("italic",60173),jersey:(0,r.register)("jersey",60174),json:(0,r.register)("json",60175),kebabVertical:(0,r.register)("kebab-vertical",60176),key:(0,r.register)("key",60177),law:(0,r.register)("law",60178),lightbulbAutofix:(0,r.register)("lightbulb-autofix",60179),linkExternal:(0,r.register)("link-external",60180),link:(0,r.register)("link",60181),listOrdered:(0,r.register)("list-ordered",60182),listUnordered:(0,r.register)("list-unordered",60183),liveShare:(0,r.register)("live-share",60184),loading:(0,r.register)("loading",60185),location:(0,r.register)("location",60186),mailRead:(0,r.register)("mail-read",60187),mail:(0,r.register)("mail",60188),markdown:(0,r.register)("markdown",60189),megaphone:(0,r.register)("megaphone",60190),mention:(0,r.register)("mention",60191),milestone:(0,r.register)("milestone",60192),gitPullRequestMilestone:(0,r.register)("git-pull-request-milestone",60192),mortarBoard:(0,r.register)("mortar-board",60193),move:(0,r.register)("move",60194),multipleWindows:(0,r.register)("multiple-windows",60195),mute:(0,r.register)("mute",60196),noNewline:(0,r.register)("no-newline",60197),note:(0,r.register)("note",60198),octoface:(0,r.register)("octoface",60199),openPreview:(0,r.register)("open-preview",60200),package:(0,r.register)("package",60201),paintcan:(0,r.register)("paintcan",60202),pin:(0,r.register)("pin",60203),play:(0,r.register)("play",60204),run:(0,r.register)("run",60204),plug:(0,r.register)("plug",60205),preserveCase:(0,r.register)("preserve-case",60206),preview:(0,r.register)("preview",60207),project:(0,r.register)("project",60208),pulse:(0,r.register)("pulse",60209),question:(0,r.register)("question",60210),quote:(0,r.register)("quote",60211),radioTower:(0,r.register)("radio-tower",60212),reactions:(0,r.register)("reactions",60213),references:(0,r.register)("references",60214),refresh:(0,r.register)("refresh",60215),regex:(0,r.register)("regex",60216),remoteExplorer:(0,r.register)("remote-explorer",60217),remote:(0,r.register)("remote",60218),remove:(0,r.register)("remove",60219),replaceAll:(0,r.register)("replace-all",60220),replace:(0,r.register)("replace",60221),repoClone:(0,r.register)("repo-clone",60222),repoForcePush:(0,r.register)("repo-force-push",60223),repoPull:(0,r.register)("repo-pull",60224),repoPush:(0,r.register)("repo-push",60225),report:(0,r.register)("report",60226),requestChanges:(0,r.register)("request-changes",60227),rocket:(0,r.register)("rocket",60228),rootFolderOpened:(0,r.register)("root-folder-opened",60229),rootFolder:(0,r.register)("root-folder",60230),rss:(0,r.register)("rss",60231),ruby:(0,r.register)("ruby",60232),saveAll:(0,r.register)("save-all",60233),saveAs:(0,r.register)("save-as",60234),save:(0,r.register)("save",60235),screenFull:(0,r.register)("screen-full",60236),screenNormal:(0,r.register)("screen-normal",60237),searchStop:(0,r.register)("search-stop",60238),server:(0,r.register)("server",60240),settingsGear:(0,r.register)("settings-gear",60241),settings:(0,r.register)("settings",60242),shield:(0,r.register)("shield",60243),smiley:(0,r.register)("smiley",60244),sortPrecedence:(0,r.register)("sort-precedence",60245),splitHorizontal:(0,r.register)("split-horizontal",60246),splitVertical:(0,r.register)("split-vertical",60247),squirrel:(0,r.register)("squirrel",60248),starFull:(0,r.register)("star-full",60249),starHalf:(0,r.register)("star-half",60250),symbolClass:(0,r.register)("symbol-class",60251),symbolColor:(0,r.register)("symbol-color",60252),symbolConstant:(0,r.register)("symbol-constant",60253),symbolEnumMember:(0,r.register)("symbol-enum-member",60254),symbolField:(0,r.register)("symbol-field",60255),symbolFile:(0,r.register)("symbol-file",60256),symbolInterface:(0,r.register)("symbol-interface",60257),symbolKeyword:(0,r.register)("symbol-keyword",60258),symbolMisc:(0,r.register)("symbol-misc",60259),symbolOperator:(0,r.register)("symbol-operator",60260),symbolProperty:(0,r.register)("symbol-property",60261),wrench:(0,r.register)("wrench",60261),wrenchSubaction:(0,r.register)("wrench-subaction",60261),symbolSnippet:(0,r.register)("symbol-snippet",60262),tasklist:(0,r.register)("tasklist",60263),telescope:(0,r.register)("telescope",60264),textSize:(0,r.register)("text-size",60265),threeBars:(0,r.register)("three-bars",60266),thumbsdown:(0,r.register)("thumbsdown",60267),thumbsup:(0,r.register)("thumbsup",60268),tools:(0,r.register)("tools",60269),triangleDown:(0,r.register)("triangle-down",60270),triangleLeft:(0,r.register)("triangle-left",60271),triangleRight:(0,r.register)("triangle-right",60272),triangleUp:(0,r.register)("triangle-up",60273),twitter:(0,r.register)("twitter",60274),unfold:(0,r.register)("unfold",60275),unlock:(0,r.register)("unlock",60276),unmute:(0,r.register)("unmute",60277),unverified:(0,r.register)("unverified",60278),verified:(0,r.register)("verified",60279),versions:(0,r.register)("versions",60280),vmActive:(0,r.register)("vm-active",60281),vmOutline:(0,r.register)("vm-outline",60282),vmRunning:(0,r.register)("vm-running",60283),watch:(0,r.register)("watch",60284),whitespace:(0,r.register)("whitespace",60285),wholeWord:(0,r.register)("whole-word",60286),window:(0,r.register)("window",60287),wordWrap:(0,r.register)("word-wrap",60288),zoomIn:(0,r.register)("zoom-in",60289),zoomOut:(0,r.register)("zoom-out",60290),listFilter:(0,r.register)("list-filter",60291),listFlat:(0,r.register)("list-flat",60292),listSelection:(0,r.register)("list-selection",60293),selection:(0,r.register)("selection",60293),listTree:(0,r.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.register)("debug-stackframe-active",60297),circleSmallFilled:(0,r.register)("circle-small-filled",60298),debugStackframeDot:(0,r.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.register)("terminal-decoration-mark",60298),debugStackframe:(0,r.register)("debug-stackframe",60299),debugStackframeFocused:(0,r.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.register)("debug-breakpoint-unsupported",60300),symbolString:(0,r.register)("symbol-string",60301),debugReverseContinue:(0,r.register)("debug-reverse-continue",60302),debugStepBack:(0,r.register)("debug-step-back",60303),debugRestartFrame:(0,r.register)("debug-restart-frame",60304),debugAlt:(0,r.register)("debug-alt",60305),callIncoming:(0,r.register)("call-incoming",60306),callOutgoing:(0,r.register)("call-outgoing",60307),menu:(0,r.register)("menu",60308),expandAll:(0,r.register)("expand-all",60309),feedback:(0,r.register)("feedback",60310),gitPullRequestReviewer:(0,r.register)("git-pull-request-reviewer",60310),groupByRefType:(0,r.register)("group-by-ref-type",60311),ungroupByRefType:(0,r.register)("ungroup-by-ref-type",60312),account:(0,r.register)("account",60313),gitPullRequestAssignee:(0,r.register)("git-pull-request-assignee",60313),bellDot:(0,r.register)("bell-dot",60314),debugConsole:(0,r.register)("debug-console",60315),library:(0,r.register)("library",60316),output:(0,r.register)("output",60317),runAll:(0,r.register)("run-all",60318),syncIgnored:(0,r.register)("sync-ignored",60319),pinned:(0,r.register)("pinned",60320),githubInverted:(0,r.register)("github-inverted",60321),serverProcess:(0,r.register)("server-process",60322),serverEnvironment:(0,r.register)("server-environment",60323),pass:(0,r.register)("pass",60324),issueClosed:(0,r.register)("issue-closed",60324),stopCircle:(0,r.register)("stop-circle",60325),playCircle:(0,r.register)("play-circle",60326),record:(0,r.register)("record",60327),debugAltSmall:(0,r.register)("debug-alt-small",60328),vmConnect:(0,r.register)("vm-connect",60329),cloud:(0,r.register)("cloud",60330),merge:(0,r.register)("merge",60331),export:(0,r.register)("export",60332),graphLeft:(0,r.register)("graph-left",60333),magnet:(0,r.register)("magnet",60334),notebook:(0,r.register)("notebook",60335),redo:(0,r.register)("redo",60336),checkAll:(0,r.register)("check-all",60337),pinnedDirty:(0,r.register)("pinned-dirty",60338),passFilled:(0,r.register)("pass-filled",60339),circleLargeFilled:(0,r.register)("circle-large-filled",60340),circleLarge:(0,r.register)("circle-large",60341),circleLargeOutline:(0,r.register)("circle-large-outline",60341),combine:(0,r.register)("combine",60342),gather:(0,r.register)("gather",60342),table:(0,r.register)("table",60343),variableGroup:(0,r.register)("variable-group",60344),typeHierarchy:(0,r.register)("type-hierarchy",60345),typeHierarchySub:(0,r.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.register)("git-pull-request-create",60348),runAbove:(0,r.register)("run-above",60349),runBelow:(0,r.register)("run-below",60350),notebookTemplate:(0,r.register)("notebook-template",60351),debugRerun:(0,r.register)("debug-rerun",60352),workspaceTrusted:(0,r.register)("workspace-trusted",60353),workspaceUntrusted:(0,r.register)("workspace-untrusted",60354),workspaceUnknown:(0,r.register)("workspace-unknown",60355),terminalCmd:(0,r.register)("terminal-cmd",60356),terminalDebian:(0,r.register)("terminal-debian",60357),terminalLinux:(0,r.register)("terminal-linux",60358),terminalPowershell:(0,r.register)("terminal-powershell",60359),terminalTmux:(0,r.register)("terminal-tmux",60360),terminalUbuntu:(0,r.register)("terminal-ubuntu",60361),terminalBash:(0,r.register)("terminal-bash",60362),arrowSwap:(0,r.register)("arrow-swap",60363),copy:(0,r.register)("copy",60364),personAdd:(0,r.register)("person-add",60365),filterFilled:(0,r.register)("filter-filled",60366),wand:(0,r.register)("wand",60367),debugLineByLine:(0,r.register)("debug-line-by-line",60368),inspect:(0,r.register)("inspect",60369),layers:(0,r.register)("layers",60370),layersDot:(0,r.register)("layers-dot",60371),layersActive:(0,r.register)("layers-active",60372),compass:(0,r.register)("compass",60373),compassDot:(0,r.register)("compass-dot",60374),compassActive:(0,r.register)("compass-active",60375),azure:(0,r.register)("azure",60376),issueDraft:(0,r.register)("issue-draft",60377),gitPullRequestClosed:(0,r.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.register)("git-pull-request-draft",60379),debugAll:(0,r.register)("debug-all",60380),debugCoverage:(0,r.register)("debug-coverage",60381),runErrors:(0,r.register)("run-errors",60382),folderLibrary:(0,r.register)("folder-library",60383),debugContinueSmall:(0,r.register)("debug-continue-small",60384),beakerStop:(0,r.register)("beaker-stop",60385),graphLine:(0,r.register)("graph-line",60386),graphScatter:(0,r.register)("graph-scatter",60387),pieChart:(0,r.register)("pie-chart",60388),bracket:(0,r.register)("bracket",60175),bracketDot:(0,r.register)("bracket-dot",60389),bracketError:(0,r.register)("bracket-error",60390),lockSmall:(0,r.register)("lock-small",60391),azureDevops:(0,r.register)("azure-devops",60392),verifiedFilled:(0,r.register)("verified-filled",60393),newline:(0,r.register)("newline",60394),layout:(0,r.register)("layout",60395),layoutActivitybarLeft:(0,r.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.register)("layout-panel-left",60398),layoutPanelCenter:(0,r.register)("layout-panel-center",60399),layoutPanelJustify:(0,r.register)("layout-panel-justify",60400),layoutPanelRight:(0,r.register)("layout-panel-right",60401),layoutPanel:(0,r.register)("layout-panel",60402),layoutSidebarLeft:(0,r.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.register)("layout-sidebar-right",60404),layoutStatusbar:(0,r.register)("layout-statusbar",60405),layoutMenubar:(0,r.register)("layout-menubar",60406),layoutCentered:(0,r.register)("layout-centered",60407),target:(0,r.register)("target",60408),indent:(0,r.register)("indent",60409),recordSmall:(0,r.register)("record-small",60410),errorSmall:(0,r.register)("error-small",60411),terminalDecorationError:(0,r.register)("terminal-decoration-error",60411),arrowCircleDown:(0,r.register)("arrow-circle-down",60412),arrowCircleLeft:(0,r.register)("arrow-circle-left",60413),arrowCircleRight:(0,r.register)("arrow-circle-right",60414),arrowCircleUp:(0,r.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.register)("layout-sidebar-left-off",60418),blank:(0,r.register)("blank",60419),heartFilled:(0,r.register)("heart-filled",60420),map:(0,r.register)("map",60421),mapHorizontal:(0,r.register)("map-horizontal",60421),foldHorizontal:(0,r.register)("fold-horizontal",60421),mapFilled:(0,r.register)("map-filled",60422),mapHorizontalFilled:(0,r.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.register)("fold-horizontal-filled",60422),circleSmall:(0,r.register)("circle-small",60423),bellSlash:(0,r.register)("bell-slash",60424),bellSlashDot:(0,r.register)("bell-slash-dot",60425),commentUnresolved:(0,r.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.register)("search-fuzzy",60429),commentDraft:(0,r.register)("comment-draft",60430),send:(0,r.register)("send",60431),sparkle:(0,r.register)("sparkle",60432),insert:(0,r.register)("insert",60433),mic:(0,r.register)("mic",60434),thumbsdownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsupFilled:(0,r.register)("thumbsup-filled",60436),coffee:(0,r.register)("coffee",60437),snake:(0,r.register)("snake",60438),game:(0,r.register)("game",60439),vr:(0,r.register)("vr",60440),chip:(0,r.register)("chip",60441),piano:(0,r.register)("piano",60442),music:(0,r.register)("music",60443),micFilled:(0,r.register)("mic-filled",60444),repoFetch:(0,r.register)("repo-fetch",60445),copilot:(0,r.register)("copilot",60446),lightbulbSparkle:(0,r.register)("lightbulb-sparkle",60447),robot:(0,r.register)("robot",60448),sparkleFilled:(0,r.register)("sparkle-filled",60449),diffSingle:(0,r.register)("diff-single",60450),diffMultiple:(0,r.register)("diff-multiple",60451),surroundWith:(0,r.register)("surround-with",60452),share:(0,r.register)("share",60453),gitStash:(0,r.register)("git-stash",60454),gitStashApply:(0,r.register)("git-stash-apply",60455),gitStashPop:(0,r.register)("git-stash-pop",60456),vscode:(0,r.register)("vscode",60457),vscodeInsiders:(0,r.register)("vscode-insiders",60458),codeOss:(0,r.register)("code-oss",60459),runCoverage:(0,r.register)("run-coverage",60460),runAllCoverage:(0,r.register)("run-all-coverage",60461),coverage:(0,r.register)("coverage",60462),githubProject:(0,r.register)("github-project",60463),mapVertical:(0,r.register)("map-vertical",60464),foldVertical:(0,r.register)("fold-vertical",60464),mapVerticalFilled:(0,r.register)("map-vertical-filled",60465),foldVerticalFilled:(0,r.register)("fold-vertical-filled",60465),goToSearch:(0,r.register)("go-to-search",60466),percentage:(0,r.register)("percentage",60467),sortPercentage:(0,r.register)("sort-percentage",60467),attach:(0,r.register)("attach",60468)}}),define(we[83],ye([1,0,104,184]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=k;function k(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,r.register)("dialog-error","error"),dialogWarning:(0,r.register)("dialog-warning","warning"),dialogInfo:(0,r.register)("dialog-info","info"),dialogClose:(0,r.register)("dialog-close","close"),treeItemExpanded:(0,r.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.register)("tree-filter-clear","close"),treeItemLoading:(0,r.register)("tree-item-loading","loading"),menuSelection:(0,r.register)("menu-selection","check"),menuSubmenu:(0,r.register)("menu-submenu","chevron-right"),menuBarMore:(0,r.register)("menubar-more","more"),scrollbarButtonLeft:(0,r.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.register)("toolbar-more","more"),quickInputBack:(0,r.register)("quick-input-back","arrow-left"),dropDownButton:(0,r.register)("drop-down-button",60084),symbolCustomColor:(0,r.register)("symbol-customcolor",60252),exportIcon:(0,r.register)("export",60332),workspaceUnspecified:(0,r.register)("workspace-unspecified",60355),newLine:(0,r.register)("newline",60394),thumbsDownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.register)("thumbsup-filled",60436),gitFetch:(0,r.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.register)("debug-breakpoint-pending",60377)},e.Codicon={...g.codiconsLibrary,...e.codiconsDerived}}),define(we[25],ye([1,0,18]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=g,e.deepFreeze=k,e.cloneAndChange=L,e.mixin=v,e.equals=l,e.safeStringify=P,e.distinct=y,e.getCaseInsensitive=d,e.filter=T,e.getAllPropertyNames=E,e.getAllMethodNames=a,e.createProxyObject=u,e.mapValues=f;function g(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([s,i])=>{n[s]=i&&typeof i=="object"?g(i):i}),n}function k(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const s=n.shift();Object.freeze(s);for(const i in s)if(A.call(s,i)){const t=s[i];typeof t=="object"&&!Object.isFrozen(t)&&!(0,r.isTypedArray)(t)&&n.push(t)}}return m}const A=Object.prototype.hasOwnProperty;function L(m,n){return R(m,n,new Set)}function R(m,n,s){if((0,r.isUndefinedOrNull)(m))return m;const i=n(m);if(typeof i<"u")return i;if(Array.isArray(m)){const t=[];for(const c of m)t.push(R(c,n,s));return t}if((0,r.isObject)(m)){if(s.has(m))throw new Error("Cannot clone recursive data-structure");s.add(m);const t={};for(const c in m)A.call(m,c)&&(t[c]=R(m[c],n,s));return s.delete(m),t}return m}function v(m,n,s=!0){return(0,r.isObject)(m)?((0,r.isObject)(n)&&Object.keys(n).forEach(i=>{i in m?s&&((0,r.isObject)(m[i])&&(0,r.isObject)(n[i])?v(m[i],n[i],s):m[i]=n[i]):m[i]=n[i]}),m):n}function l(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let s,i;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(s=0;s<m.length;s++)if(!l(m[s],n[s]))return!1}else{const t=[];for(i in m)t.push(i);t.sort();const c=[];for(i in n)c.push(i);if(c.sort(),!l(t,c))return!1;for(s=0;s<t.length;s++)if(!l(m[t[s]],n[t[s]]))return!1}return!0}function P(m){const n=new Set;return JSON.stringify(m,(s,i)=>{if((0,r.isObject)(i)||Array.isArray(i)){if(n.has(i))return"[Circular]";n.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function y(m,n){const s=Object.create(null);return!m||!n||Object.keys(n).forEach(t=>{const c=m[t],h=n[t];l(c,h)||(s[t]=h)}),s}function d(m,n){const s=n.toLowerCase(),i=Object.keys(m).find(t=>t.toLowerCase()===s);return i?m[i]:m[n]}function T(m,n){const s=Object.create(null);for(const[i,t]of Object.entries(m))n(i,t)&&(s[i]=t);return s}function E(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}function a(m){const n=[];for(const s of E(m))typeof m[s]=="function"&&n.push(s);return n}function u(m,n){const s=t=>function(){const c=Array.prototype.slice.call(arguments,0);return n(t,c)},i={};for(const t of m)i[t]=s(t);return i}function f(m,n){const s={};for(const[i,t]of Object.entries(m))s[i]=n(t,i);return s}}),define(we[50],ye([1,0,83]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=k;var g;(function(L){function R(v){return v&&typeof v=="object"&&typeof v.id=="string"}L.isThemeColor=R})(g||(e.ThemeColor=g={}));function k(L){return{id:L}}var A;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function v(m){const n=R.exec(m.id);if(!n)return v(r.Codicon.error);const[,s,i]=n,t=["codicon","codicon-"+s];return i&&t.push("codicon-modifier-"+i.substring(1)),t}L.asClassNameArray=v;function l(m){return v(m).join(" ")}L.asClassName=l;function P(m){return"."+v(m).join(".")}L.asCSSSelector=P;function y(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||g.isThemeColor(m.color))}L.isThemeIcon=y;const d=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function T(m){const n=d.exec(m);if(!n)return;const[,s]=n;return{id:s}}L.fromString=T;function E(m){return{id:m}}L.fromId=E;function a(m,n){let s=m.id;const i=s.lastIndexOf("~");return i!==-1&&(s=s.substring(0,i)),n&&(s=`${s}~${n}`),{id:s}}L.modify=a;function u(m){const n=m.id.lastIndexOf("~");if(n!==-1)return m.id.substring(n+1)}L.getModifier=u;function f(m,n){return m.id===n.id&&m.color?.id===n.color?.id}L.isEqual=f})(A||(e.ThemeIcon=A={}))}),define(we[84],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=g,e.toUint32=k;var r;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function g(A){return A<0?0:A>r.MAX_UINT_8?r.MAX_UINT_8:A|0}function k(A){return A<0?0:A>r.MAX_UINT_32?r.MAX_UINT_32:A|0}}),define(we[13],ye([1,0,181,27,49,84]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=L,e.format=v,e.format2=P,e.htmlAttributeEncodeValue=y,e.escape=d,e.escapeRegExpCharacters=T,e.count=E,e.truncate=a,e.truncateMiddle=u,e.trim=f,e.ltrim=m,e.rtrim=n,e.convertSimple2RegExpPattern=s,e.stripWildcards=i,e.createRegExp=t,e.regExpLeadsToEndlessLoop=c,e.splitLines=h,e.splitLinesIncludeSeparators=o,e.firstNonWhitespaceIndex=p,e.getLeadingWhitespace=_,e.lastNonWhitespaceIndex=D,e.replaceAsync=C,e.compare=S,e.compareSubstring=I,e.compareIgnoreCase=b,e.compareSubstringIgnoreCase=w,e.isAsciiDigit=N,e.isLowerAsciiLetter=O,e.isUpperAsciiLetter=U,e.equalsIgnoreCase=x,e.startsWithIgnoreCase=B,e.commonPrefixLength=F,e.commonSuffixLength=M,e.isHighSurrogate=K,e.isLowSurrogate=ee,e.computeCodePoint=$,e.getNextCodePoint=q,e.nextCharLength=re,e.prevCharLength=Se,e.getCharContainingOffset=ve,e.charCount=G,e.containsRTL=ae,e.isBasicASCII=le,e.containsUnusualLineTerminators=ue,e.isFullWidthCharacter=Y,e.isEmojiImprecise=oe,e.lcut=pe,e.forAnsiStringParts=Ne,e.removeAnsiEscapeCodes=We,e.removeAnsiEscapeCodesFromPrompt=Ie,e.startsWithUTF8BOM=Le,e.stripUTF8BOM=z,e.fuzzyContains=H,e.containsUppercaseCharacter=X,e.uppercaseFirstLetter=J,e.getNLines=fe,e.singleLetterHash=be,e.getGraphemeBreakType=Fe,e.getLeftDeleteOffset=tt;function L(Te){return!Te||typeof Te!="string"?!0:Te.trim().length===0}const R=/{(\d+)}/g;function v(Te,...Ue){return Ue.length===0?Te:Te.replace(R,function(ke,Re){const ce=parseInt(Re,10);return isNaN(ce)||ce<0||ce>=Ue.length?ke:Ue[ce]})}const l=/{([^}]+)}/g;function P(Te,Ue){return Object.keys(Ue).length===0?Te:Te.replace(l,(ke,Re)=>Ue[Re]??ke)}function y(Te){return Te.replace(/[<>"'&]/g,Ue=>{switch(Ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ue})}function d(Te){return Te.replace(/[<>&]/g,function(Ue){switch(Ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ue}})}function T(Te){return Te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function E(Te,Ue){let ke=0,Re=Te.indexOf(Ue);for(;Re!==-1;)ke++,Re=Te.indexOf(Ue,Re+Ue.length);return ke}function a(Te,Ue,ke="\u2026"){return Te.length<=Ue?Te:`${Te.substr(0,Ue)}${ke}`}function u(Te,Ue,ke="\u2026"){if(Te.length<=Ue)return Te;const Re=Math.ceil(Ue/2)-ke.length/2,ce=Math.floor(Ue/2)-ke.length/2;return`${Te.substr(0,Re)}${ke}${Te.substr(Te.length-ce)}`}function f(Te,Ue=" "){const ke=m(Te,Ue);return n(ke,Ue)}function m(Te,Ue){if(!Te||!Ue)return Te;const ke=Ue.length;if(ke===0||Te.length===0)return Te;let Re=0;for(;Te.indexOf(Ue,Re)===Re;)Re=Re+ke;return Te.substring(Re)}function n(Te,Ue){if(!Te||!Ue)return Te;const ke=Ue.length,Re=Te.length;if(ke===0||Re===0)return Te;let ce=Re,Q=-1;for(;Q=Te.lastIndexOf(Ue,ce-1),!(Q===-1||Q+ke!==ce);){if(Q===0)return"";ce=Q}return Te.substring(0,ce)}function s(Te){return Te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Te){return Te.replace(/\*/g,"")}function t(Te,Ue,ke={}){if(!Te)throw new Error("Cannot create regex from empty string");Ue||(Te=T(Te)),ke.wholeWord&&(/\B/.test(Te.charAt(0))||(Te="\\b"+Te),/\B/.test(Te.charAt(Te.length-1))||(Te=Te+"\\b"));let Re="";return ke.global&&(Re+="g"),ke.matchCase||(Re+="i"),ke.multiline&&(Re+="m"),ke.unicode&&(Re+="u"),new RegExp(Te,Re)}function c(Te){return Te.source==="^"||Te.source==="^$"||Te.source==="$"||Te.source==="^\\s*$"?!1:!!(Te.exec("")&&Te.lastIndex===0)}function h(Te){return Te.split(/\r\n|\r|\n/)}function o(Te){const Ue=[],ke=Te.split(/(\r\n|\r|\n)/);for(let Re=0;Re<Math.ceil(ke.length/2);Re++)Ue.push(ke[2*Re]+(ke[2*Re+1]??""));return Ue}function p(Te){for(let Ue=0,ke=Te.length;Ue<ke;Ue++){const Re=Te.charCodeAt(Ue);if(Re!==g.CharCode.Space&&Re!==g.CharCode.Tab)return Ue}return-1}function _(Te,Ue=0,ke=Te.length){for(let Re=Ue;Re<ke;Re++){const ce=Te.charCodeAt(Re);if(ce!==g.CharCode.Space&&ce!==g.CharCode.Tab)return Te.substring(Ue,Re)}return Te.substring(Ue,ke)}function D(Te,Ue=Te.length-1){for(let ke=Ue;ke>=0;ke--){const Re=Te.charCodeAt(ke);if(Re!==g.CharCode.Space&&Re!==g.CharCode.Tab)return ke}return-1}function C(Te,Ue,ke){const Re=[];let ce=0;for(const Q of Te.matchAll(Ue)){if(Re.push(Te.slice(ce,Q.index)),Q.index===void 0)throw new Error("match.index should be defined");ce=Q.index+Q[0].length,Re.push(ke(Q[0],...Q.slice(1),Q.index,Te,Q.groups))}return Re.push(Te.slice(ce)),Promise.all(Re).then(Q=>Q.join(""))}function S(Te,Ue){return Te<Ue?-1:Te>Ue?1:0}function I(Te,Ue,ke=0,Re=Te.length,ce=0,Q=Ue.length){for(;ke<Re&&ce<Q;ke++,ce++){const Ze=Te.charCodeAt(ke),at=Ue.charCodeAt(ce);if(Ze<at)return-1;if(Ze>at)return 1}const Pe=Re-ke,Ge=Q-ce;return Pe<Ge?-1:Pe>Ge?1:0}function b(Te,Ue){return w(Te,Ue,0,Te.length,0,Ue.length)}function w(Te,Ue,ke=0,Re=Te.length,ce=0,Q=Ue.length){for(;ke<Re&&ce<Q;ke++,ce++){let Ze=Te.charCodeAt(ke),at=Ue.charCodeAt(ce);if(Ze===at)continue;if(Ze>=128||at>=128)return I(Te.toLowerCase(),Ue.toLowerCase(),ke,Re,ce,Q);O(Ze)&&(Ze-=32),O(at)&&(at-=32);const ct=Ze-at;if(ct!==0)return ct}const Pe=Re-ke,Ge=Q-ce;return Pe<Ge?-1:Pe>Ge?1:0}function N(Te){return Te>=g.CharCode.Digit0&&Te<=g.CharCode.Digit9}function O(Te){return Te>=g.CharCode.a&&Te<=g.CharCode.z}function U(Te){return Te>=g.CharCode.A&&Te<=g.CharCode.Z}function x(Te,Ue){return Te.length===Ue.length&&w(Te,Ue)===0}function B(Te,Ue){const ke=Ue.length;return Ue.length>Te.length?!1:w(Te,Ue,0,ke)===0}function F(Te,Ue){const ke=Math.min(Te.length,Ue.length);let Re;for(Re=0;Re<ke;Re++)if(Te.charCodeAt(Re)!==Ue.charCodeAt(Re))return Re;return ke}function M(Te,Ue){const ke=Math.min(Te.length,Ue.length);let Re;const ce=Te.length-1,Q=Ue.length-1;for(Re=0;Re<ke;Re++)if(Te.charCodeAt(ce-Re)!==Ue.charCodeAt(Q-Re))return Re;return ke}function K(Te){return 55296<=Te&&Te<=56319}function ee(Te){return 56320<=Te&&Te<=57343}function $(Te,Ue){return(Te-55296<<10)+(Ue-56320)+65536}function q(Te,Ue,ke){const Re=Te.charCodeAt(ke);if(K(Re)&&ke+1<Ue){const ce=Te.charCodeAt(ke+1);if(ee(ce))return $(Re,ce)}return Re}function Z(Te,Ue){const ke=Te.charCodeAt(Ue-1);if(ee(ke)&&Ue>1){const Re=Te.charCodeAt(Ue-2);if(K(Re))return $(Re,ke)}return ke}class ne{get offset(){return this._offset}constructor(Ue,ke=0){this._str=Ue,this._len=Ue.length,this._offset=ke}setOffset(Ue){this._offset=Ue}prevCodePoint(){const Ue=Z(this._str,this._offset);return this._offset-=Ue>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ue}nextCodePoint(){const Ue=q(this._str,this._len,this._offset);return this._offset+=Ue>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ue}eol(){return this._offset>=this._len}}e.CodePointIterator=ne;class de{get offset(){return this._iterator.offset}constructor(Ue,ke=0){this._iterator=new ne(Ue,ke)}nextGraphemeLength(){const Ue=Ye.getInstance(),ke=this._iterator,Re=ke.offset;let ce=Ue.getGraphemeBreakType(ke.nextCodePoint());for(;!ke.eol();){const Q=ke.offset,Pe=Ue.getGraphemeBreakType(ke.nextCodePoint());if(He(ce,Pe)){ke.setOffset(Q);break}ce=Pe}return ke.offset-Re}prevGraphemeLength(){const Ue=Ye.getInstance(),ke=this._iterator,Re=ke.offset;let ce=Ue.getGraphemeBreakType(ke.prevCodePoint());for(;ke.offset>0;){const Q=ke.offset,Pe=Ue.getGraphemeBreakType(ke.prevCodePoint());if(He(Pe,ce)){ke.setOffset(Q);break}ce=Pe}return Re-ke.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=de;function re(Te,Ue){return new de(Te,Ue).nextGraphemeLength()}function Se(Te,Ue){return new de(Te,Ue).prevGraphemeLength()}function ve(Te,Ue){Ue>0&&ee(Te.charCodeAt(Ue))&&Ue--;const ke=Ue+re(Te,Ue);return[ke-Se(Te,ke),ke]}function G(Te){const Ue=new de(Te);let ke=0;for(;!Ue.eol();)ke++,Ue.nextGraphemeLength();return ke}let W;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(Te){return W||(W=se()),W.test(Te)}const ie=/^[\t\n\r\x20-\x7E]*$/;function le(Te){return ie.test(Te)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ue(Te){return e.UNUSUAL_LINE_TERMINATORS.test(Te)}function Y(Te){return Te>=11904&&Te<=55215||Te>=63744&&Te<=64255||Te>=65281&&Te<=65374}function oe(Te){return Te>=127462&&Te<=127487||Te===8986||Te===8987||Te===9200||Te===9203||Te>=9728&&Te<=10175||Te===11088||Te===11093||Te>=127744&&Te<=128591||Te>=128640&&Te<=128764||Te>=128992&&Te<=129008||Te>=129280&&Te<=129535||Te>=129648&&Te<=129782}function pe(Te,Ue,ke=""){const Re=Te.trimStart();if(Re.length<Ue)return Re;const ce=/\b/g;let Q=0;for(;ce.test(Re)&&!(Re.length-ce.lastIndex<Ue);)Q=ce.lastIndex,ce.lastIndex+=1;return Q===0?Re:ke+Re.substring(Q).trimStart()}const Ee=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Ne(Te){let Ue=0;for(const ke of Te.matchAll(Ee))Ue!==ke.index&&(yield{isCode:!1,str:Te.substring(Ue,ke.index)}),yield{isCode:!0,str:ke[0]},Ue=ke.index+ke[0].length;Ue!==Te.length&&(yield{isCode:!1,str:Te.substring(Ue)})}function We(Te){return Te&&(Te=Te.replace(Ee,"")),Te}const Ce=/\\\[.*?\\\]/g;function Ie(Te){return We(Te).replace(Ce,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(g.CharCode.UTF8_BOM);function Le(Te){return!!(Te&&Te.length>0&&Te.charCodeAt(0)===g.CharCode.UTF8_BOM)}function z(Te){return Le(Te)?Te.substr(1):Te}function H(Te,Ue){if(!Te||!Ue||Te.length<Ue.length)return!1;const ke=Ue.length,Re=Te.toLowerCase();let ce=0,Q=-1;for(;ce<ke;){const Pe=Re.indexOf(Ue[ce],Q+1);if(Pe<0)return!1;Q=Pe,ce++}return!0}function X(Te,Ue=!1){return Te?(Ue&&(Te=Te.replace(/\\./g,"")),Te.toLowerCase()!==Te):!1}function J(Te){return Te.charAt(0).toUpperCase()+Te.slice(1)}function fe(Te,Ue=1){if(Ue===0)return"";let ke=-1;do ke=Te.indexOf(`
`,ke+1),Ue--;while(Ue>0&&ke>=0);return ke===-1?Te:(Te[ke-1]==="\r"&&ke--,Te.substr(0,ke))}function be(Te){const Ue=g.CharCode.Z-g.CharCode.A+1;return Te=Te%(2*Ue),Te<Ue?String.fromCharCode(g.CharCode.a+Te):String.fromCharCode(g.CharCode.A+Te-Ue)}function Fe(Te){return Ye.getInstance().getGraphemeBreakType(Te)}function He(Te,Ue){return Te===qe.Other?Ue!==qe.Extend&&Ue!==qe.SpacingMark:Te===qe.CR&&Ue===qe.LF?!1:Te===qe.Control||Te===qe.CR||Te===qe.LF||Ue===qe.Control||Ue===qe.CR||Ue===qe.LF?!0:!(Te===qe.L&&(Ue===qe.L||Ue===qe.V||Ue===qe.LV||Ue===qe.LVT)||(Te===qe.LV||Te===qe.V)&&(Ue===qe.V||Ue===qe.T)||(Te===qe.LVT||Te===qe.T)&&Ue===qe.T||Ue===qe.Extend||Ue===qe.ZWJ||Ue===qe.SpacingMark||Te===qe.Prepend||Te===qe.ZWJ&&Ue===qe.Extended_Pictographic||Te===qe.Regional_Indicator&&Ue===qe.Regional_Indicator)}var qe;(function(Te){Te[Te.Other=0]="Other",Te[Te.Prepend=1]="Prepend",Te[Te.CR=2]="CR",Te[Te.LF=3]="LF",Te[Te.Control=4]="Control",Te[Te.Extend=5]="Extend",Te[Te.Regional_Indicator=6]="Regional_Indicator",Te[Te.SpacingMark=7]="SpacingMark",Te[Te.L=8]="L",Te[Te.V=9]="V",Te[Te.T=10]="T",Te[Te.LV=11]="LV",Te[Te.LVT=12]="LVT",Te[Te.ZWJ=13]="ZWJ",Te[Te.Extended_Pictographic=14]="Extended_Pictographic"})(qe||(e.GraphemeBreakType=qe={}));class Ye{static{this._INSTANCE=null}static getInstance(){return Ye._INSTANCE||(Ye._INSTANCE=new Ye),Ye._INSTANCE}constructor(){this._data=it()}getGraphemeBreakType(Ue){if(Ue<32)return Ue===g.CharCode.LineFeed?qe.LF:Ue===g.CharCode.CarriageReturn?qe.CR:qe.Control;if(Ue<127)return qe.Other;const ke=this._data,Re=ke.length/3;let ce=1;for(;ce<=Re;)if(Ue<ke[3*ce])ce=2*ce;else if(Ue>ke[3*ce+1])ce=2*ce+1;else return ke[3*ce+2];return qe.Other}}function it(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(Te,Ue){if(Te===0)return 0;const ke=rt(Te,Ue);if(ke!==void 0)return ke;const Re=new ne(Ue,Te);return Re.prevCodePoint(),Re.offset}function rt(Te,Ue){const ke=new ne(Ue,Te);let Re=ke.prevCodePoint();for(;ot(Re)||Re===ft.emojiVariantSelector||Re===ft.enclosingKeyCap;){if(ke.offset===0)return;Re=ke.prevCodePoint()}if(!oe(Re))return;let ce=ke.offset;return ce>0&&ke.prevCodePoint()===ft.zwj&&(ce=ke.offset),ce}function ot(Te){return 127995<=Te&&Te<=127999}var ft;(function(Te){Te[Te.zwj=8205]="zwj",Te[Te.emojiVariantSelector=65039]="emojiVariantSelector",Te[Te.enclosingKeyCap=8419]="enclosingKeyCap"})(ft||(ft={})),e.noBreakWhitespace="\xA0";class ut{static{this.ambiguousCharacterData=new k.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new r.LRUCachedFunction({getCacheKey:JSON.stringify},Ue=>{function ke(ct){const Ct=new Map;for(let Pt=0;Pt<ct.length;Pt+=2)Ct.set(ct[Pt],ct[Pt+1]);return Ct}function Re(ct,Ct){const Pt=new Map(ct);for(const[Ot,Xt]of Ct)Pt.set(Ot,Xt);return Pt}function ce(ct,Ct){if(!ct)return Ct;const Pt=new Map;for(const[Ot,Xt]of ct)Ct.has(Ot)&&Pt.set(Ot,Xt);return Pt}const Q=this.ambiguousCharacterData.value;let Pe=Ue.filter(ct=>!ct.startsWith("_")&&ct in Q);Pe.length===0&&(Pe=["_default"]);let Ge;for(const ct of Pe){const Ct=ke(Q[ct]);Ge=ce(Ge,Ct)}const Ze=ke(Q._common),at=Re(Ze,Ge);return new ut(at)})}static getInstance(Ue){return ut.cache.get(Array.from(Ue))}static{this._locales=new k.Lazy(()=>Object.keys(ut.ambiguousCharacterData.value).filter(Ue=>!Ue.startsWith("_")))}static getLocales(){return ut._locales.value}constructor(Ue){this.confusableDictionary=Ue}isAmbiguous(Ue){return this.confusableDictionary.has(Ue)}containsAmbiguousCharacter(Ue){for(let ke=0;ke<Ue.length;ke++){const Re=Ue.codePointAt(ke);if(typeof Re=="number"&&this.isAmbiguous(Re))return!0}return!1}getPrimaryConfusable(Ue){return this.confusableDictionary.get(Ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ut;class st{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(st.getRawData())),this._data}static isInvisibleCharacter(Ue){return st.getData().has(Ue)}static containsInvisibleCharacter(Ue){for(let ke=0;ke<Ue.length;ke++){const Re=Ue.codePointAt(ke);if(typeof Re=="number"&&st.isInvisibleCharacter(Re))return!0}return!1}static get codePoints(){return st.getData()}}e.InvisibleCharacters=st}),define(we[134],ye([1,0,27,29,176,13]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=L,e.matchesContiguousSubString=v,e.matchesSubString=l,e.isUpper=d,e.matchesCamelCase=D,e.matchesWords=C,e.matchesFuzzy=O,e.matchesFuzzy2=U,e.anyScore=x,e.createMatches=B,e.isPatternInWord=se,e.fuzzyScore=ue,e.fuzzyScoreGracefulAggressive=pe,e.fuzzyScoreGraceful=Ee;function L(...Ce){return function(Ie,Le){for(let z=0,H=Ce.length;z<H;z++){const X=Ce[z](Ie,Le);if(X)return X}return null}}e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(Ce,Ie,Le){if(!Le||Le.length<Ie.length)return null;let z;return Ce?z=A.startsWithIgnoreCase(Le,Ie):z=Le.indexOf(Ie)===0,z?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function v(Ce,Ie){const Le=Ie.toLowerCase().indexOf(Ce.toLowerCase());return Le===-1?null:[{start:Le,end:Le+Ce.length}]}function l(Ce,Ie){return P(Ce.toLowerCase(),Ie.toLowerCase(),0,0)}function P(Ce,Ie,Le,z){if(Le===Ce.length)return[];if(z===Ie.length)return null;if(Ce[Le]===Ie[z]){let H=null;return(H=P(Ce,Ie,Le+1,z+1))?i({start:z,end:z+1},H):null}return P(Ce,Ie,Le,z+1)}function y(Ce){return r.CharCode.a<=Ce&&Ce<=r.CharCode.z}function d(Ce){return r.CharCode.A<=Ce&&Ce<=r.CharCode.Z}function T(Ce){return r.CharCode.Digit0<=Ce&&Ce<=r.CharCode.Digit9}function E(Ce){return Ce===r.CharCode.Space||Ce===r.CharCode.Tab||Ce===r.CharCode.LineFeed||Ce===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ce=>a.add(Ce.charCodeAt(0)));function u(Ce){return E(Ce)||a.has(Ce)}function f(Ce,Ie){return Ce===Ie||u(Ce)&&u(Ie)}const m=new Map;function n(Ce){if(m.has(Ce))return m.get(Ce);let Ie;const Le=(0,k.getKoreanAltChars)(Ce);return Le&&(Ie=Le),m.set(Ce,Ie),Ie}function s(Ce){return y(Ce)||d(Ce)||T(Ce)}function i(Ce,Ie){return Ie.length===0?Ie=[Ce]:Ce.end===Ie[0].start?Ie[0].start=Ce.start:Ie.unshift(Ce),Ie}function t(Ce,Ie){for(let Le=Ie;Le<Ce.length;Le++){const z=Ce.charCodeAt(Le);if(d(z)||T(z)||Le>0&&!s(Ce.charCodeAt(Le-1)))return Le}return Ce.length}function c(Ce,Ie,Le,z){if(Le===Ce.length)return[];if(z===Ie.length)return null;if(Ce[Le]!==Ie[z].toLowerCase())return null;{let H=null,X=z+1;for(H=c(Ce,Ie,Le+1,z+1);!H&&(X=t(Ie,X))<Ie.length;)H=c(Ce,Ie,Le+1,X),X++;return H===null?null:i({start:z,end:z+1},H)}}function h(Ce){let Ie=0,Le=0,z=0,H=0,X=0;for(let He=0;He<Ce.length;He++)X=Ce.charCodeAt(He),d(X)&&Ie++,y(X)&&Le++,s(X)&&z++,T(X)&&H++;const J=Ie/Ce.length,fe=Le/Ce.length,be=z/Ce.length,Fe=H/Ce.length;return{upperPercent:J,lowerPercent:fe,alphaPercent:be,numericPercent:Fe}}function o(Ce){const{upperPercent:Ie,lowerPercent:Le}=Ce;return Le===0&&Ie>.6}function p(Ce){const{upperPercent:Ie,lowerPercent:Le,alphaPercent:z,numericPercent:H}=Ce;return Le>.2&&Ie<.8&&z>.6&&H<.2}function _(Ce){let Ie=0,Le=0,z=0,H=0;for(let X=0;X<Ce.length;X++)z=Ce.charCodeAt(X),d(z)&&Ie++,y(z)&&Le++,E(z)&&H++;return(Ie===0||Le===0)&&H===0?Ce.length<=30:Ie<=5}function D(Ce,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!_(Ce))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Le=h(Ie);if(!p(Le)){if(!o(Le))return null;Ie=Ie.toLowerCase()}let z=null,H=0;for(Ce=Ce.toLowerCase();H<Ie.length&&(z=c(Ce,Ie,0,H))===null;)H=t(Ie,H+1);return z}function C(Ce,Ie,Le=!1){if(!Ie||Ie.length===0)return null;let z=null,H=0;for(Ce=Ce.toLowerCase(),Ie=Ie.toLowerCase();H<Ie.length&&(z=S(Ce,Ie,0,H,Le),z===null);)H=I(Ie,H+1);return z}function S(Ce,Ie,Le,z,H){let X=0;if(Le===Ce.length)return[];if(z===Ie.length)return null;if(!f(Ce.charCodeAt(Le),Ie.charCodeAt(z))){const be=n(Ce.charCodeAt(Le));if(!be)return null;for(let Fe=0;Fe<be.length;Fe++)if(!f(be[Fe],Ie.charCodeAt(z+Fe)))return null;X+=be.length-1}let J=null,fe=z+X+1;if(J=S(Ce,Ie,Le+1,fe,H),!H)for(;!J&&(fe=I(Ie,fe))<Ie.length;)J=S(Ce,Ie,Le+1,fe,H),fe++;if(!J)return null;if(Ce.charCodeAt(Le)!==Ie.charCodeAt(z)){const be=n(Ce.charCodeAt(Le));if(!be)return J;for(let Fe=0;Fe<be.length;Fe++)if(be[Fe]!==Ie.charCodeAt(z+Fe))return J}return i({start:z,end:z+X+1},J)}function I(Ce,Ie){for(let Le=Ie;Le<Ce.length;Le++)if(u(Ce.charCodeAt(Le))||Le>0&&u(Ce.charCodeAt(Le-1)))return Le;return Ce.length}const b=L(e.matchesPrefix,D,v),w=L(e.matchesPrefix,D,l),N=new g.LRUCache(1e4);function O(Ce,Ie,Le=!1){if(typeof Ce!="string"||typeof Ie!="string")return null;let z=N.get(Ce);z||(z=new RegExp(A.convertSimple2RegExpPattern(Ce),"i"),N.set(Ce,z));const H=z.exec(Ie);return H?[{start:H.index,end:H.index+H[0].length}]:Le?w(Ce,Ie):b(Ce,Ie)}function U(Ce,Ie){const Le=ue(Ce,Ce.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Le?B(Le):null}function x(Ce,Ie,Le,z,H,X){const J=Math.min(13,Ce.length);for(;Le<J;Le++){const fe=ue(Ce,Ie,Le,z,H,X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,X]}function B(Ce){if(typeof Ce>"u")return[];const Ie=[],Le=Ce[1];for(let z=Ce.length-1;z>1;z--){const H=Ce[z]+Le,X=Ie[Ie.length-1];X&&X.end===H?X.end=H+1:Ie.push({start:H,end:H+1})}return Ie}const F=128;function M(){const Ce=[],Ie=[];for(let Le=0;Le<=F;Le++)Ie[Le]=0;for(let Le=0;Le<=F;Le++)Ce.push(Ie.slice(0));return Ce}function K(Ce){const Ie=[];for(let Le=0;Le<=Ce;Le++)Ie[Le]=0;return Ie}const ee=K(2*F),$=K(2*F),q=M(),Z=M(),ne=M(),de=!1;function re(Ce,Ie,Le,z,H){function X(fe,be,Fe=" "){for(;fe.length<be;)fe=Fe+fe;return fe}let J=` |   |${z.split("").map(fe=>X(fe,3)).join("|")}
`;for(let fe=0;fe<=Le;fe++)fe===0?J+=" |":J+=`${Ie[fe-1]}|`,J+=Ce[fe].slice(0,H+1).map(be=>X(be.toString(),3)).join("|")+`
`;return J}function Se(Ce,Ie,Le,z){Ce=Ce.substr(Ie),Le=Le.substr(z),console.log(re(Z,Ce,Ce.length,Le,Le.length)),console.log(re(ne,Ce,Ce.length,Le,Le.length)),console.log(re(q,Ce,Ce.length,Le,Le.length))}function ve(Ce,Ie){if(Ie<0||Ie>=Ce.length)return!1;const Le=Ce.codePointAt(Ie);switch(Le){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(Le)}}function G(Ce,Ie){if(Ie<0||Ie>=Ce.length)return!1;switch(Ce.charCodeAt(Ie)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function W(Ce,Ie,Le){return Ie[Ce]!==Le[Ce]}function se(Ce,Ie,Le,z,H,X,J=!1){for(;Ie<Le&&H<X;)Ce[Ie]===z[H]&&(J&&(ee[Ie]=H),Ie+=1),H+=1;return Ie===Le}var ae;(function(Ce){Ce[Ce.Diag=1]="Diag",Ce[Ce.Left=2]="Left",Ce[Ce.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var ie;(function(Ce){Ce.Default=[-100,0];function Ie(Le){return!Le||Le.length===2&&Le[0]===-100&&Le[1]===0}Ce.isDefault=Ie})(ie||(e.FuzzyScore=ie={}));class le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Le){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Le}}e.FuzzyScoreOptions=le;function ue(Ce,Ie,Le,z,H,X,J=le.default){const fe=Ce.length>F?F:Ce.length,be=z.length>F?F:z.length;if(Le>=fe||X>=be||fe-Le>be-X||!se(Ie,Le,fe,H,X,be,!0))return;Y(fe,be,Le,X,Ie,H);let Fe=1,He=1,qe=Le,Ye=X;const it=[!1];for(Fe=1,qe=Le;qe<fe;Fe++,qe++){const ut=ee[qe],st=$[qe],Te=qe+1<fe?$[qe+1]:be;for(He=ut-X+1,Ye=ut;Ye<Te;He++,Ye++){let Ue=Number.MIN_SAFE_INTEGER,ke=!1;Ye<=st&&(Ue=oe(Ce,Ie,qe,Le,z,H,Ye,be,X,q[Fe-1][He-1]===0,it));let Re=0;Ue!==Number.MAX_SAFE_INTEGER&&(ke=!0,Re=Ue+Z[Fe-1][He-1]);const ce=Ye>ut,Q=ce?Z[Fe][He-1]+(q[Fe][He-1]>0?-5:0):0,Pe=Ye>ut+1&&q[Fe][He-1]>0,Ge=Pe?Z[Fe][He-2]+(q[Fe][He-2]>0?-5:0):0;if(Pe&&(!ce||Ge>=Q)&&(!ke||Ge>=Re))Z[Fe][He]=Ge,ne[Fe][He]=ae.LeftLeft,q[Fe][He]=0;else if(ce&&(!ke||Q>=Re))Z[Fe][He]=Q,ne[Fe][He]=ae.Left,q[Fe][He]=0;else if(ke)Z[Fe][He]=Re,ne[Fe][He]=ae.Diag,q[Fe][He]=q[Fe-1][He-1]+1;else throw new Error("not possible")}}if(de&&Se(Ce,Le,z,X),!it[0]&&!J.firstMatchCanBeWeak)return;Fe--,He--;const tt=[Z[Fe][He],X];let rt=0,ot=0;for(;Fe>=1;){let ut=He;do{const st=ne[Fe][ut];if(st===ae.LeftLeft)ut=ut-2;else if(st===ae.Left)ut=ut-1;else break}while(ut>=1);rt>1&&Ie[Le+Fe-1]===H[X+He-1]&&!W(ut+X-1,z,H)&&rt+1>q[Fe][ut]&&(ut=He),ut===He?rt++:rt=1,ot||(ot=ut),Fe--,He=ut-1,tt.push(He)}be-X===fe&&J.boostFullMatch&&(tt[0]+=2);const ft=ot-fe;return tt[0]-=ft,tt}function Y(Ce,Ie,Le,z,H,X){let J=Ce-1,fe=Ie-1;for(;J>=Le&&fe>=z;)H[J]===X[fe]&&($[J]=fe,J--),fe--}function oe(Ce,Ie,Le,z,H,X,J,fe,be,Fe,He){if(Ie[Le]!==X[J])return Number.MIN_SAFE_INTEGER;let qe=1,Ye=!1;return J===Le-z?qe=Ce[Le]===H[J]?7:5:W(J,H,X)&&(J===0||!W(J-1,H,X))?(qe=Ce[Le]===H[J]?7:5,Ye=!0):ve(X,J)&&(J===0||!ve(X,J-1))?qe=5:(ve(X,J-1)||G(X,J-1))&&(qe=5,Ye=!0),qe>1&&Le===z&&(He[0]=!0),Ye||(Ye=W(J,H,X)||ve(X,J-1)||G(X,J-1)),Le===z?J>be&&(qe-=Ye?3:5):Fe?qe+=Ye?2:0:qe+=Ye?0:1,J+1===fe&&(qe-=Ye?3:5),qe}function pe(Ce,Ie,Le,z,H,X,J){return Ne(Ce,Ie,Le,z,H,X,!0,J)}function Ee(Ce,Ie,Le,z,H,X,J){return Ne(Ce,Ie,Le,z,H,X,!1,J)}function Ne(Ce,Ie,Le,z,H,X,J,fe){let be=ue(Ce,Ie,Le,z,H,X,fe);if(be&&!J)return be;if(Ce.length>=3){const Fe=Math.min(7,Ce.length-1);for(let He=Le+1;He<Fe;He++){const qe=We(Ce,He);if(qe){const Ye=ue(qe,qe.toLowerCase(),Le,z,H,X,fe);Ye&&(Ye[0]-=3,(!be||Ye[0]>be[0])&&(be=Ye))}}}return be}function We(Ce,Ie){if(Ie+1>=Ce.length)return;const Le=Ce[Ie],z=Ce[Ie+1];if(Le!==z)return Ce.slice(0,Ie)+z+Le+Ce.slice(Ie+2)}}),define(we[61],ye([1,0,13]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=g,e.doHash=k,e.numberHash=A,e.stringHash=R,e.toHexString=a;function g(f){return k(f,0)}function k(f,m){switch(typeof f){case"object":return f===null?A(349,m):Array.isArray(f)?v(f,m):l(f,m);case"string":return R(f,m);case"boolean":return L(f,m);case"number":return A(f,m);case"undefined":return A(937,m);default:return A(617,m)}}function A(f,m){return(m<<5)-m+f|0}function L(f,m){return A(f?433:863,m)}function R(f,m){m=A(149417,m);for(let n=0,s=f.length;n<s;n++)m=A(f.charCodeAt(n),m);return m}function v(f,m){return m=A(104579,m),f.reduce((n,s)=>k(s,n),m)}function l(f,m){return m=A(181387,m),Object.keys(f).sort().reduce((n,s)=>(n=R(s,n),k(f[s],n)),m)}class P{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=k(m,this._value),this._value}}e.Hasher=P;var y;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function d(f,m,n=32){const s=n-m,i=~((1<<s)-1);return(f<<m|(i&f)>>>s)>>>0}function T(f,m=0,n=f.byteLength,s=0){for(let i=0;i<n;i++)f[m+i]=s}function E(f,m,n="0"){for(;f.length<m;)f=n+f;return f}function a(f,m=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(n=>n.toString(16).padStart(2,"0")).join(""):E((f>>>0).toString(16),m/4)}class u{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(y.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const n=m.length;if(n===0)return;const s=this._buff;let i=this._buffLen,t=this._leftoverHighSurrogate,c,h;for(t!==0?(c=t,h=-1,t=0):(c=m.charCodeAt(0),h=0);;){let o=c;if(r.isHighSurrogate(c))if(h+1<n){const p=m.charCodeAt(h+1);r.isLowSurrogate(p)?(h++,o=r.computeCodePoint(c,p)):o=y.UNICODE_REPLACEMENT}else{t=c;break}else r.isLowSurrogate(c)&&(o=y.UNICODE_REPLACEMENT);if(i=this._push(s,i,o),h++,h<n)c=m.charCodeAt(h);else break}this._buffLen=i,this._leftoverHighSurrogate=t}_push(m,n,s){return s<128?m[n++]=s:s<2048?(m[n++]=192|(s&1984)>>>6,m[n++]=128|(s&63)>>>0):s<65536?(m[n++]=224|(s&61440)>>>12,m[n++]=128|(s&4032)>>>6,m[n++]=128|(s&63)>>>0):(m[n++]=240|(s&1835008)>>>18,m[n++]=128|(s&258048)>>>12,m[n++]=128|(s&4032)>>>6,m[n++]=128|(s&63)>>>0),n>=y.BLOCK_SIZE&&(this._step(),n-=y.BLOCK_SIZE,this._totalLen+=y.BLOCK_SIZE,m[0]=m[y.BLOCK_SIZE+0],m[1]=m[y.BLOCK_SIZE+1],m[2]=m[y.BLOCK_SIZE+2]),n}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,y.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=u._bigBlock32,n=this._buffDV;for(let D=0;D<64;D+=4)m.setUint32(D,n.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)m.setUint32(D,d(m.getUint32(D-12,!1)^m.getUint32(D-32,!1)^m.getUint32(D-56,!1)^m.getUint32(D-64,!1),1),!1);let s=this._h0,i=this._h1,t=this._h2,c=this._h3,h=this._h4,o,p,_;for(let D=0;D<80;D++)D<20?(o=i&t|~i&c,p=1518500249):D<40?(o=i^t^c,p=1859775393):D<60?(o=i&t|i&c|t&c,p=2400959708):(o=i^t^c,p=3395469782),_=d(s,5)+o+h+p+m.getUint32(D*4,!1)&4294967295,h=c,c=t,t=d(i,30),i=s,s=_;this._h0=this._h0+s&4294967295,this._h1=this._h1+i&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+h&4294967295}}e.StringSHA1=u}),define(we[135],ye([1,0,134,13,50]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=v,e.markdownEscapeEscapedIcons=P,e.stripIcons=d,e.getCodiconAriaLabel=T,e.parseLabelWithIcons=a,e.matchesFuzzyIconAware=u;const A="$(",L=new RegExp(`\\$\\(${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${L.source}`,"g");function v(f){return f.replace(R,(m,n)=>n?m:`\\${m}`)}const l=new RegExp(`\\\\${L.source}`,"g");function P(f){return f.replace(l,m=>`\\${m}`)}const y=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function d(f){return f.indexOf(A)===-1?f:f.replace(y,(m,n,s,i)=>s?m:n||i||"")}function T(f){return f?f.replace(/\$\((.*?)\)/g,(m,n)=>` ${n} `).trim():""}const E=new RegExp(`\\$\\(${k.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(f){E.lastIndex=0;let m="";const n=[];let s=0;for(;;){const i=E.lastIndex,t=E.exec(f),c=f.substring(i,t?.index);if(c.length>0){m+=c;for(let h=0;h<c.length;h++)n.push(s)}if(!t)break;s+=t[0].length}return{text:m,iconOffsets:n}}function u(f,m,n=!1){const{text:s,iconOffsets:i}=m;if(!i||i.length===0)return(0,r.matchesFuzzy)(f,s,n);const t=(0,g.ltrim)(s," "),c=s.length-t.length,h=(0,r.matchesFuzzy)(f,t,n);if(h)for(const o of h){const p=i[o.start+c]+c;o.start+=p,o.end+=p}return h}}),define(we[43],ye([1,0,13]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var g;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(g||(g={})),function(k){const A="error",L="warning",R="warn",v="info",l="ignore";function P(d){return d?r.equalsIgnoreCase(A,d)?k.Error:r.equalsIgnoreCase(L,d)||r.equalsIgnoreCase(R,d)?k.Warning:r.equalsIgnoreCase(v,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=P;function y(d){switch(d){case k.Error:return A;case k.Warning:return L;case k.Info:return v;default:return l}}k.toString=y}(g||(g={})),e.default=g}),define(we[85],ye([1,0,19,27,13]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class A{constructor(){this._value="",this._pos=0}reset(E){return this._value=E,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(E){const a=E.charCodeAt(0),u=this._value.charCodeAt(this._pos);return a-u}value(){return this._value[this._pos]}}e.StringIterator=A;class L{constructor(E=!0){this._caseSensitive=E}reset(E){return this._value=E,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let E=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===g.CharCode.Period)if(E)this._from++;else break;else E=!1;return this}cmp(E){return this._caseSensitive?(0,k.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class R{constructor(E=!0,a=!0){this._splitOnBackslash=E,this._caseSensitive=a}reset(E){this._from=0,this._to=0,this._value=E,this._valueLen=E.length;for(let a=E.length-1;a>=0;a--,this._valueLen--){const u=this._value.charCodeAt(a);if(!(u===g.CharCode.Slash||this._splitOnBackslash&&u===g.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let E=!0;for(;this._to<this._valueLen;this._to++){const a=this._value.charCodeAt(this._to);if(a===g.CharCode.Slash||this._splitOnBackslash&&a===g.CharCode.Backslash)if(E)this._from++;else break;else E=!1}return this}cmp(E){return this._caseSensitive?(0,k.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var v;(function(T){T[T.Scheme=1]="Scheme",T[T.Authority=2]="Authority",T[T.Path=3]="Path",T[T.Query=4]="Query",T[T.Fragment=5]="Fragment"})(v||(v={}));class l{constructor(E,a){this._ignorePathCasing=E,this._ignoreQueryAndFragment=a,this._states=[],this._stateIdx=0}reset(E){return this._value=E,this._states=[],this._value.scheme&&this._states.push(v.Scheme),this._value.authority&&this._states.push(v.Authority),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(E)),this._pathIterator.reset(E.path),this._pathIterator.value()&&this._states.push(v.Path)),this._ignoreQueryAndFragment(E)||(this._value.query&&this._states.push(v.Query),this._value.fragment&&this._states.push(v.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(E){if(this._states[this._stateIdx]===v.Scheme)return(0,k.compareIgnoreCase)(E,this._value.scheme);if(this._states[this._stateIdx]===v.Authority)return(0,k.compareIgnoreCase)(E,this._value.authority);if(this._states[this._stateIdx]===v.Path)return this._pathIterator.cmp(E);if(this._states[this._stateIdx]===v.Query)return(0,k.compare)(E,this._value.query);if(this._states[this._stateIdx]===v.Fragment)return(0,k.compare)(E,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===v.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===v.Authority)return this._value.authority;if(this._states[this._stateIdx]===v.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===v.Query)return this._value.query;if(this._states[this._stateIdx]===v.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=l;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(T){T[T.Left=-1]="Left",T[T.Mid=0]="Mid",T[T.Right=1]="Right"})(y||(y={}));class d{static forUris(E=()=>!1,a=()=>!1){return new d(new l(E,a))}static forPaths(E=!1){return new d(new R(void 0,!E))}static forStrings(){return new d(new A)}static forConfigKeys(){return new d(new L)}constructor(E){this._iter=E}clear(){this._root=void 0}fill(E,a){if(a){const u=a.slice(0);(0,r.shuffle)(u);for(const f of u)this.set(f,E)}else{const u=E.slice(0);(0,r.shuffle)(u);for(const f of u)this.set(f[0],f[1])}}set(E,a){const u=this._iter.reset(E);let f;this._root||(this._root=new P,this._root.segment=u.value());const m=[];for(f=this._root;;){const s=u.cmp(f.segment);if(s>0)f.left||(f.left=new P,f.left.segment=u.value()),m.push([y.Left,f]),f=f.left;else if(s<0)f.right||(f.right=new P,f.right.segment=u.value()),m.push([y.Right,f]),f=f.right;else if(u.hasNext())u.next(),f.mid||(f.mid=new P,f.mid.segment=u.value()),m.push([y.Mid,f]),f=f.mid;else break}const n=f.value;f.value=a,f.key=E;for(let s=m.length-1;s>=0;s--){const i=m[s][1];i.updateHeight();const t=i.balanceFactor();if(t<-1||t>1){const c=m[s][0],h=m[s+1][0];if(c===y.Right&&h===y.Right)m[s][1]=i.rotateLeft();else if(c===y.Left&&h===y.Left)m[s][1]=i.rotateRight();else if(c===y.Right&&h===y.Left)i.right=m[s+1][1]=m[s+1][1].rotateRight(),m[s][1]=i.rotateLeft();else if(c===y.Left&&h===y.Right)i.left=m[s+1][1]=m[s+1][1].rotateLeft(),m[s][1]=i.rotateRight();else throw new Error;if(s>0)switch(m[s-1][0]){case y.Left:m[s-1][1].left=m[s][1];break;case y.Right:m[s-1][1].right=m[s][1];break;case y.Mid:m[s-1][1].mid=m[s][1];break}else this._root=m[0][1]}}return n}get(E){return this._getNode(E)?.value}_getNode(E){const a=this._iter.reset(E);let u=this._root;for(;u;){const f=a.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(a.hasNext())a.next(),u=u.mid;else break}return u}has(E){const a=this._getNode(E);return!(a?.value===void 0&&a?.mid===void 0)}delete(E){return this._delete(E,!1)}deleteSuperstr(E){return this._delete(E,!0)}_delete(E,a){const u=this._iter.reset(E),f=[];let m=this._root;for(;m;){const n=u.cmp(m.segment);if(n>0)f.push([y.Left,m]),m=m.left;else if(n<0)f.push([y.Right,m]),m=m.right;else if(u.hasNext())u.next(),f.push([y.Mid,m]),m=m.mid;else break}if(m){if(a?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this._min(m.right);if(n.key){const{key:s,value:i,segment:t}=n;this._delete(n.key,!1),m.key=s,m.value=i,m.segment=t}}else{const n=m.left??m.right;if(f.length>0){const[s,i]=f[f.length-1];switch(s){case y.Left:i.left=n;break;case y.Mid:i.mid=n;break;case y.Right:i.right=n;break}}else this._root=n}for(let n=f.length-1;n>=0;n--){const s=f[n][1];s.updateHeight();const i=s.balanceFactor();if(i>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),f[n][1]=s.rotateLeft()):i<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),f[n][1]=s.rotateRight()),n>0)switch(f[n-1][0]){case y.Left:f[n-1][1].left=f[n][1];break;case y.Right:f[n-1][1].right=f[n][1];break;case y.Mid:f[n-1][1].mid=f[n][1];break}else this._root=f[0][1]}}}_min(E){for(;E.left;)E=E.left;return E}findSubstr(E){const a=this._iter.reset(E);let u=this._root,f;for(;u;){const m=a.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(a.hasNext())a.next(),f=u.value||f,u=u.mid;else break}return u&&u.value||f}findSuperstr(E){return this._findSuperstrOrElement(E,!1)}_findSuperstrOrElement(E,a){const u=this._iter.reset(E);let f=this._root;for(;f;){const m=u.cmp(f.segment);if(m>0)f=f.left;else if(m<0)f=f.right;else if(u.hasNext())u.next(),f=f.mid;else return f.mid?this._entries(f.mid):a?f.value:void 0}}hasElementOrSubtree(E){return this._findSuperstrOrElement(E,!0)!==void 0}forEach(E){for(const[a,u]of this)E(u,a)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(E){const a=[];return this._dfsEntries(E,a),a[Symbol.iterator]()}_dfsEntries(E,a){E&&(E.left&&this._dfsEntries(E.left,a),E.value&&a.push([E.key,E.value]),E.mid&&this._dfsEntries(E.mid,a),E.right&&this._dfsEntries(E.right,a))}_isBalanced(){const E=a=>{if(!a)return!0;const u=a.balanceFactor();return u<-1||u>1?!1:E(a.left)&&E(a.right)};return E(this._root)}}e.TernarySearchTree=d}),define(we[32],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=g;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function g(k){return r.test(k)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(R){for(let v=0;v<R.length;v++)R[v]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let v=0,l="";return l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l+="-",l+=L[A[v++]],l+=L[A[v++]],l+="-",l+=L[A[v++]],l+=L[A[v++]],l+="-",l+=L[A[v++]],l+=L[A[v++]],l+="-",l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l+=L[A[v++]],l}}()}),define(we[185],ye([1,0,19,40,32]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=A,e.createFileDataTransferItem=L,e.matchesMimeType=l;function A(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function L(y,d,T){const E={id:(0,k.generateUuid)(),name:y,uri:d,data:T};return{asString:async()=>"",asFile:()=>E,value:void 0}}class R{constructor(){this._entries=new Map}get size(){let d=0;for(const T of this._entries)d++;return d}has(d){return this._entries.has(this.toKey(d))}matches(d){const T=[...this._entries.keys()];return g.Iterable.some(this,([E,a])=>a.asFile())&&T.push("files"),P(v(d),T)}get(d){return this._entries.get(this.toKey(d))?.[0]}append(d,T){const E=this._entries.get(d);E?E.push(T):this._entries.set(this.toKey(d),[T])}replace(d,T){this._entries.set(this.toKey(d),[T])}delete(d){this._entries.delete(this.toKey(d))}*[Symbol.iterator](){for(const[d,T]of this._entries)for(const E of T)yield[d,E]}toKey(d){return v(d)}}e.VSDataTransfer=R;function v(y){return y.toLowerCase()}function l(y,d){return P(v(y),d.map(v))}function P(y,d){if(y==="*/*")return d.length>0;if(d.includes(y))return!0;const T=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!T)return!1;const[E,a,u]=T;return u==="*"?d.some(f=>f.startsWith(a+"/")):!1}e.UriList=Object.freeze({create:y=>(0,r.distinct)(y.map(d=>d.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.UriList.split(y).filter(d=>!d.startsWith("#"))})}),define(we[186],ye([1,0,66]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=g,e.findFreePortFaster=A;function g(R,v,l,P=1){let y=!1;return new Promise(d=>{const T=setTimeout(()=>{if(!y)return y=!0,d(0)},l);k(R,v,P,E=>{if(!y)return y=!0,clearTimeout(T),d(E)})})}function k(R,v,l,P){if(v===0)return P(0);const y=new r.Socket;y.once("connect",()=>(L(y),k(R+l,v-1,l,P))),y.once("data",()=>{}),y.once("error",d=>(L(y),d.code!=="ECONNREFUSED"?k(R+l,v-1,l,P):P(R))),y.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,v,l,P="127.0.0.1"){let y=!1,d,T=1;const E=r.createServer({pauseOnConnect:!0});function a(u,f){y||(y=!0,E.removeAllListeners(),E.close(),d&&clearTimeout(d),f(u))}return new Promise(u=>{d=setTimeout(()=>{a(0,u)},l),E.on("listening",()=>{a(R,u)}),E.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&T<v?(R++,T++,E.listen(R,P)):a(0,u)}),E.on("close",()=>{a(0,u)}),E.listen(R,P)})}function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(v){console.error(v)}}}),define(we[136],ye([1,0,84]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class g{constructor(R){const v=(0,r.toUint8)(R);this._defaultValue=v,this._asciiMap=g._createAsciiMap(v),this._map=new Map}static _createAsciiMap(R){const v=new Uint8Array(256);return v.fill(R),v}set(R,v){const l=(0,r.toUint8)(v);R>=0&&R<256?this._asciiMap[R]=l:this._map.set(R,l)}get(R){return R>=0&&R<256?this._asciiMap[R]:this._map.get(R)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=g;var k;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(k||(k={}));class A{constructor(){this._actual=new g(k.False)}add(R){this._actual.set(R,k.True)}has(R){return this._actual.get(R)===k.True}clear(){return this._actual.clear()}}e.CharacterSet=A}),define(we[187],ye([1,0,27]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=k;var g;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(g||(e.StringEOL=g={}));function k(A){let L=0,R=0,v=0,l=g.Unknown;for(let P=0,y=A.length;P<y;P++){const d=A.charCodeAt(P);d===r.CharCode.CarriageReturn?(L===0&&(R=P),L++,P+1<y&&A.charCodeAt(P+1)===r.CharCode.LineFeed?(l|=g.CRLF,P++):l|=g.Invalid,v=P+1):d===r.CharCode.LineFeed&&(l|=g.LF,L===0&&(R=P),L++,v=P+1)}return L===0&&(R=A.length),[L,R,A.length-v,l]}}),define(we[54],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class r{constructor(k,A){this.lineNumber=k,this.column=A}with(k=this.lineNumber,A=this.column){return k===this.lineNumber&&A===this.column?this:new r(k,A)}delta(k=0,A=0){return this.with(this.lineNumber+k,this.column+A)}equals(k){return r.equals(this,k)}static equals(k,A){return!k&&!A?!0:!!k&&!!A&&k.lineNumber===A.lineNumber&&k.column===A.column}isBefore(k){return r.isBefore(this,k)}static isBefore(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<A.column}isBeforeOrEqual(k){return r.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<=A.column}static compare(k,A){const L=k.lineNumber|0,R=A.lineNumber|0;if(L===R){const v=k.column|0,l=A.column|0;return v-l}return L-R}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new r(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.Position=r}),define(we[31],ye([1,0,54]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class g{constructor(A,L,R,v){A>R||A===R&&L>v?(this.startLineNumber=R,this.startColumn=v,this.endLineNumber=A,this.endColumn=L):(this.startLineNumber=A,this.startColumn=L,this.endLineNumber=R,this.endColumn=v)}isEmpty(){return g.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return g.containsPosition(this,A)}static containsPosition(A,L){return!(L.lineNumber<A.startLineNumber||L.lineNumber>A.endLineNumber||L.lineNumber===A.startLineNumber&&L.column<A.startColumn||L.lineNumber===A.endLineNumber&&L.column>A.endColumn)}static strictContainsPosition(A,L){return!(L.lineNumber<A.startLineNumber||L.lineNumber>A.endLineNumber||L.lineNumber===A.startLineNumber&&L.column<=A.startColumn||L.lineNumber===A.endLineNumber&&L.column>=A.endColumn)}containsRange(A){return g.containsRange(this,A)}static containsRange(A,L){return!(L.startLineNumber<A.startLineNumber||L.endLineNumber<A.startLineNumber||L.startLineNumber>A.endLineNumber||L.endLineNumber>A.endLineNumber||L.startLineNumber===A.startLineNumber&&L.startColumn<A.startColumn||L.endLineNumber===A.endLineNumber&&L.endColumn>A.endColumn)}strictContainsRange(A){return g.strictContainsRange(this,A)}static strictContainsRange(A,L){return!(L.startLineNumber<A.startLineNumber||L.endLineNumber<A.startLineNumber||L.startLineNumber>A.endLineNumber||L.endLineNumber>A.endLineNumber||L.startLineNumber===A.startLineNumber&&L.startColumn<=A.startColumn||L.endLineNumber===A.endLineNumber&&L.endColumn>=A.endColumn)}plusRange(A){return g.plusRange(this,A)}static plusRange(A,L){let R,v,l,P;return L.startLineNumber<A.startLineNumber?(R=L.startLineNumber,v=L.startColumn):L.startLineNumber===A.startLineNumber?(R=L.startLineNumber,v=Math.min(L.startColumn,A.startColumn)):(R=A.startLineNumber,v=A.startColumn),L.endLineNumber>A.endLineNumber?(l=L.endLineNumber,P=L.endColumn):L.endLineNumber===A.endLineNumber?(l=L.endLineNumber,P=Math.max(L.endColumn,A.endColumn)):(l=A.endLineNumber,P=A.endColumn),new g(R,v,l,P)}intersectRanges(A){return g.intersectRanges(this,A)}static intersectRanges(A,L){let R=A.startLineNumber,v=A.startColumn,l=A.endLineNumber,P=A.endColumn;const y=L.startLineNumber,d=L.startColumn,T=L.endLineNumber,E=L.endColumn;return R<y?(R=y,v=d):R===y&&(v=Math.max(v,d)),l>T?(l=T,P=E):l===T&&(P=Math.min(P,E)),R>l||R===l&&v>P?null:new g(R,v,l,P)}equalsRange(A){return g.equalsRange(this,A)}static equalsRange(A,L){return!A&&!L?!0:!!A&&!!L&&A.startLineNumber===L.startLineNumber&&A.startColumn===L.startColumn&&A.endLineNumber===L.endLineNumber&&A.endColumn===L.endColumn}getEndPosition(){return g.getEndPosition(this)}static getEndPosition(A){return new r.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return g.getStartPosition(this)}static getStartPosition(A){return new r.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,L){return new g(this.startLineNumber,this.startColumn,A,L)}setStartPosition(A,L){return new g(A,L,this.endLineNumber,this.endColumn)}collapseToStart(){return g.collapseToStart(this)}static collapseToStart(A){return new g(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return g.collapseToEnd(this)}static collapseToEnd(A){return new g(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new g(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,L=A){return new g(A.lineNumber,A.column,L.lineNumber,L.column)}static lift(A){return A?new g(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,L){return!(A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<L.startColumn||L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<A.startColumn)}static areIntersecting(A,L){return!(A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<=L.startColumn||L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,L){if(A&&L){const l=A.startLineNumber|0,P=L.startLineNumber|0;if(l===P){const y=A.startColumn|0,d=L.startColumn|0;if(y===d){const T=A.endLineNumber|0,E=L.endLineNumber|0;if(T===E){const a=A.endColumn|0,u=L.endColumn|0;return a-u}return T-E}return y-d}return l-P}return(A?1:0)-(L?1:0)}static compareRangesUsingEnds(A,L){return A.endLineNumber===L.endLineNumber?A.endColumn===L.endColumn?A.startLineNumber===L.startLineNumber?A.startColumn-L.startColumn:A.startLineNumber-L.startLineNumber:A.endColumn-L.endColumn:A.endLineNumber-L.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=g}),define(we[188],ye([1,0,31]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class g{static insert(A,L){return{range:new r.Range(A.lineNumber,A.column,A.lineNumber,A.column),text:L,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,L){return{range:A,text:L}}static replaceMove(A,L){return{range:A,text:L,forceMoveMarkers:!0}}}e.EditOperation=g}),define(we[189],ye([1,0,54,31]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(k||(e.SelectionDirection=k={}));class A extends g.Range{constructor(R,v,l,P){super(R,v,l,P),this.selectionStartLineNumber=R,this.selectionStartColumn=v,this.positionLineNumber=l,this.positionColumn=P}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(R){return A.selectionsEqual(this,R)}static selectionsEqual(R,v){return R.selectionStartLineNumber===v.selectionStartLineNumber&&R.selectionStartColumn===v.selectionStartColumn&&R.positionLineNumber===v.positionLineNumber&&R.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?k.LTR:k.RTL}setEndPosition(R,v){return this.getDirection()===k.LTR?new A(this.startLineNumber,this.startColumn,R,v):new A(R,v,this.startLineNumber,this.startColumn)}getPosition(){return new r.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(R,v){return this.getDirection()===k.LTR?new A(R,v,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,R,v)}static fromPositions(R,v=R){return new A(R.lineNumber,R.column,v.lineNumber,v.column)}static fromRange(R,v){return v===k.LTR?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):new A(R.endLineNumber,R.endColumn,R.startLineNumber,R.startColumn)}static liftSelection(R){return new A(R.selectionStartLineNumber,R.selectionStartColumn,R.positionLineNumber,R.positionColumn)}static selectionsArrEqual(R,v){if(R&&!v||!R&&v)return!1;if(!R&&!v)return!0;if(R.length!==v.length)return!1;for(let l=0,P=R.length;l<P;l++)if(!this.selectionsEqual(R[l],v[l]))return!1;return!0}static isISelection(R){return R&&typeof R.selectionStartLineNumber=="number"&&typeof R.selectionStartColumn=="number"&&typeof R.positionLineNumber=="number"&&typeof R.positionColumn=="number"}static createWithDirection(R,v,l,P,y){return y===k.LTR?new A(R,v,l,P):new A(l,P,R,v)}}e.Selection=A}),define(we[190],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(we[191],ye([1,0,27,29,136]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WordCharacterClassifier=e.WordCharacterClass=void 0,e.getMapForWordSeparators=v;var A;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(A||(e.WordCharacterClass=A={}));class L extends k.CharacterClassifier{constructor(P,y){super(A.Regular),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=y,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let d=0,T=P.length;d<T;d++)this.set(P.charCodeAt(d),A.WordSeparator);this.set(r.CharCode.Space,A.Whitespace),this.set(r.CharCode.Tab,A.Whitespace)}findPrevIntlWordBeforeOrAtOffset(P,y){let d=null;for(const T of this._getIntlSegmenterWordsOnLine(P)){if(T.index>y)break;d=T}return d}findNextIntlWordAtOrAfterOffset(P,y){for(const d of this._getIntlSegmenterWordsOnLine(P))if(!(d.index<y))return d;return null}_getIntlSegmenterWordsOnLine(P){return this._segmenter?this._cachedLine===P?this._cachedSegments:(this._cachedLine=P,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(P)),this._cachedSegments):[]}_filterWordSegments(P){const y=[];for(const d of P)this._isWordLike(d)&&y.push(d);return y}_isWordLike(P){return!!P.isWordLike}}e.WordCharacterClassifier=L;const R=new g.LRUCache(10);function v(l,P){const y=`${l}/${P.join(",")}`;let d=R.get(y);return d||(d=new L(l,P),R.set(y,d)),d}}),define(we[137],ye([1,0,40,3,81]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.ensureValidWordDefinition=L,e.setDefaultGetWordAtTextConfig=v,e.getWordAtText=l,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(y=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)y.indexOf(T)>=0||(d+="\\"+T);return d+="\\s]+)",new RegExp(d,"g")}e.DEFAULT_WORD_REGEXP=A();function L(y){let d=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)d=y;else{let T="g";y.ignoreCase&&(T+="i"),y.multiline&&(T+="m"),y.unicode&&(T+="u"),d=new RegExp(y.source,T)}return d.lastIndex=0,d}const R=new k.LinkedList;R.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(y){const d=R.unshift(y);return(0,g.toDisposable)(d)}function l(y,d,T,E,a){if(d=L(d),a||(a=r.Iterable.first(R)),T.length>a.maxLen){let s=y-a.maxLen/2;return s<0?s=0:E+=s,T=T.substring(s,y+a.maxLen/2),l(y,d,T,E,a)}const u=Date.now(),f=y-1-E;let m=-1,n=null;for(let s=1;!(Date.now()-u>=a.timeBudget);s++){const i=f-a.windowSize*s;d.lastIndex=Math.max(0,i);const t=P(d,T,f,m);if(!t&&n||(n=t,i<=0))break;m=i}if(n){const s={word:n[0],startColumn:E+1+n.index,endColumn:E+1+n.index+n[0].length};return d.lastIndex=0,s}return null}function P(y,d,T,E){let a;for(;a=y.exec(d);){const u=a.index||0;if(u<=T&&y.lastIndex>=T)return a;if(E>0&&u>E)return null}return null}}),define(we[105],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var g;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(g||(e.FontStyle=g={}));var k;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var A;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(A||(e.StandardTokenType=A={}));var L;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",v[v.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class R{static getLanguageId(l){return(l&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(l){return(l&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(l){return(l&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(l){return(l&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let y="mtk"+this.getForeground(l);const d=this.getFontStyle(l);return d&g.Italic&&(y+=" mtki"),d&g.Bold&&(y+=" mtkb"),d&g.Underline&&(y+=" mtku"),d&g.Strikethrough&&(y+=" mtks"),y}static getInlineStyleFromMetadata(l,P){const y=this.getForeground(l),d=this.getFontStyle(l);let T=`color: ${P[y]};`;d&g.Italic&&(T+="font-style: italic;"),d&g.Bold&&(T+="font-weight: bold;");let E="";return d&g.Underline&&(E+=" underline"),d&g.Strikethrough&&(E+=" line-through"),E&&(T+=`text-decoration:${E};`),T}static getPresentationFromMetadata(l){const P=this.getForeground(l),y=this.getFontStyle(l);return{foreground:P,italic:!!(y&g.Italic),bold:!!(y&g.Bold),underline:!!(y&g.Underline),strikethrough:!!(y&g.Strikethrough)}}}e.TokenMetadata=R}),define(we[192],ye([1,0,27,105]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var k;(function(v){v[v.None=0]="None",v[v.Indent=1]="Indent",v[v.IndentOutdent=2]="IndentOutdent",v[v.Outdent=3]="Outdent"})(k||(e.IndentAction=k={}));class A{constructor(l){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=l.open,this.close=l.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(l.notIn))for(let P=0,y=l.notIn.length;P<y;P++)switch(l.notIn[P]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(l){switch(l){case g.StandardTokenType.Other:return!0;case g.StandardTokenType.Comment:return this._inComment;case g.StandardTokenType.String:return this._inString;case g.StandardTokenType.RegEx:return this._inRegEx}}shouldAutoClose(l,P){if(l.getTokenCount()===0)return!0;const y=l.findTokenIndexAtOffset(P-2),d=l.getStandardTokenType(y);return this.isOK(d)}_findNeutralCharacterInRange(l,P){for(let y=l;y<=P;y++){const d=String.fromCharCode(y);if(!this.open.includes(d)&&!this.close.includes(d))return d}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(r.CharCode.Digit0,r.CharCode.Digit9)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(r.CharCode.a,r.CharCode.z)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(r.CharCode.A,r.CharCode.Z))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=A;class L{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const P of l)R(this.autoClosingPairsOpenByStart,P.open.charAt(0),P),R(this.autoClosingPairsOpenByEnd,P.open.charAt(P.open.length-1),P),R(this.autoClosingPairsCloseByStart,P.close.charAt(0),P),R(this.autoClosingPairsCloseByEnd,P.close.charAt(P.close.length-1),P),P.close.length===1&&P.open.length===1&&R(this.autoClosingPairsCloseSingleChar,P.close,P)}}e.AutoClosingPairs=L;function R(v,l,P){v.has(l)?v.get(l).push(P):v.set(l,[P])}}),define(we[193],ye([1,0,27,136]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkComputer=e.StateMachine=e.State=void 0,e.computeLinks=T;var k;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(k||(e.State=k={}));class A{constructor(a,u,f){const m=new Uint8Array(a*u);for(let n=0,s=a*u;n<s;n++)m[n]=f;this._data=m,this.rows=a,this.cols=u}get(a,u){return this._data[a*this.cols+u]}set(a,u,f){this._data[a*this.cols+u]=f}}class L{constructor(a){let u=0,f=k.Invalid;for(let n=0,s=a.length;n<s;n++){const[i,t,c]=a[n];t>u&&(u=t),i>f&&(f=i),c>f&&(f=c)}u++,f++;const m=new A(f,u,k.Invalid);for(let n=0,s=a.length;n<s;n++){const[i,t,c]=a[n];m.set(i,t,c)}this._states=m,this._maxCharCode=u}nextState(a,u){return u<0||u>=this._maxCharCode?k.Invalid:this._states.get(a,u)}}e.StateMachine=L;let R=null;function v(){return R===null&&(R=new L([[k.Start,r.CharCode.h,k.H],[k.Start,r.CharCode.H,k.H],[k.Start,r.CharCode.f,k.F],[k.Start,r.CharCode.F,k.F],[k.H,r.CharCode.t,k.HT],[k.H,r.CharCode.T,k.HT],[k.HT,r.CharCode.t,k.HTT],[k.HT,r.CharCode.T,k.HTT],[k.HTT,r.CharCode.p,k.HTTP],[k.HTT,r.CharCode.P,k.HTTP],[k.HTTP,r.CharCode.s,k.BeforeColon],[k.HTTP,r.CharCode.S,k.BeforeColon],[k.HTTP,r.CharCode.Colon,k.AfterColon],[k.F,r.CharCode.i,k.FI],[k.F,r.CharCode.I,k.FI],[k.FI,r.CharCode.l,k.FIL],[k.FI,r.CharCode.L,k.FIL],[k.FIL,r.CharCode.e,k.BeforeColon],[k.FIL,r.CharCode.E,k.BeforeColon],[k.BeforeColon,r.CharCode.Colon,k.AfterColon],[k.AfterColon,r.CharCode.Slash,k.AlmostThere],[k.AlmostThere,r.CharCode.Slash,k.End]])),R}var l;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let P=null;function y(){if(P===null){P=new g.CharacterClassifier(l.None);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<E.length;u++)P.set(E.charCodeAt(u),l.ForceTermination);const a=".,;:";for(let u=0;u<a.length;u++)P.set(a.charCodeAt(u),l.CannotEndIn)}return P}class d{static _createLink(a,u,f,m,n){let s=n-1;do{const i=u.charCodeAt(s);if(a.get(i)!==l.CannotEndIn)break;s--}while(s>m);if(m>0){const i=u.charCodeAt(m-1),t=u.charCodeAt(s);(i===r.CharCode.OpenParen&&t===r.CharCode.CloseParen||i===r.CharCode.OpenSquareBracket&&t===r.CharCode.CloseSquareBracket||i===r.CharCode.OpenCurlyBrace&&t===r.CharCode.CloseCurlyBrace)&&s--}return{range:{startLineNumber:f,startColumn:m+1,endLineNumber:f,endColumn:s+2},url:u.substring(m,s+1)}}static computeLinks(a,u=v()){const f=y(),m=[];for(let n=1,s=a.getLineCount();n<=s;n++){const i=a.getLineContent(n),t=i.length;let c=0,h=0,o=0,p=k.Start,_=!1,D=!1,C=!1,S=!1;for(;c<t;){let I=!1;const b=i.charCodeAt(c);if(p===k.Accept){let w;switch(b){case r.CharCode.OpenParen:_=!0,w=l.None;break;case r.CharCode.CloseParen:w=_?l.None:l.ForceTermination;break;case r.CharCode.OpenSquareBracket:C=!0,D=!0,w=l.None;break;case r.CharCode.CloseSquareBracket:C=!1,w=D?l.None:l.ForceTermination;break;case r.CharCode.OpenCurlyBrace:S=!0,w=l.None;break;case r.CharCode.CloseCurlyBrace:w=S?l.None:l.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:o===b?w=l.ForceTermination:o===r.CharCode.SingleQuote||o===r.CharCode.DoubleQuote||o===r.CharCode.BackTick?w=l.None:w=l.ForceTermination;break;case r.CharCode.Asterisk:w=o===r.CharCode.Asterisk?l.ForceTermination:l.None;break;case r.CharCode.Pipe:w=o===r.CharCode.Pipe?l.ForceTermination:l.None;break;case r.CharCode.Space:w=C?l.None:l.ForceTermination;break;default:w=f.get(b)}w===l.ForceTermination&&(m.push(d._createLink(f,i,n,h,c)),I=!0)}else if(p===k.End){let w;b===r.CharCode.OpenSquareBracket?(D=!0,w=l.None):w=f.get(b),w===l.ForceTermination?I=!0:p=k.Accept}else p=u.nextState(p,b),p===k.Invalid&&(I=!0);I&&(p=k.Start,_=!1,D=!1,S=!1,h=c+1,o=b),c++}p===k.Accept&&m.push(d._createLink(f,i,n,h,t))}return m}}e.LinkComputer=d;function T(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:d.computeLinks(E)}}),define(we[55],ye([1,0,25]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.isITextSnapshot=E,e.shouldSynchronizeModel=s;var g;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(g||(e.OverviewRulerLane=g={}));var k;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=3]="Right"})(k||(e.GlyphMarginLane=k={}));var A;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var L;(function(i){i[i.Normal=1]="Normal",i[i.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var R;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var v;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var l;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(l||(e.DefaultEndOfLine=l={}));var P;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(P||(e.EndOfLineSequence=P={}));class y{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,t.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this._indentSizeIsTabSize===t._indentSizeIsTabSize&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,r.equals)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class d{constructor(t,c){this._findMatchBrand=void 0,this.range=t,this.matches=c}}e.FindMatch=d;var T;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T||(e.TrackedRangeStickiness=T={}));function E(i){return i&&typeof i.read=="function"}var a;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var u;(function(i){i[i.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u||(e.ModelConstants=u={}));class f{constructor(t,c,h,o,p,_){this.identifier=t,this.range=c,this.text=h,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=p,this._isTracked=_}}e.ValidAnnotatedEditOperation=f;class m{constructor(t,c,h){this.regex=t,this.wordSeparators=c,this.simpleSearch=h}}e.SearchData=m;class n{constructor(t,c,h){this.reverseEdits=t,this.changes=c,this.trimAutoWhitespaceLineNumbers=h}}e.ApplyEditsResult=n;function s(i){return!i.isTooLargeForSyncing()&&!i.isForSimpleWidget}}),define(we[194],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=k,e.righttest=A,e.leftRotate=l,e.rightRotate=P,e.rbDelete=y,e.fixInsert=d,e.updateTreeMetadata=T,e.recomputeTreeMetadata=E;class r{constructor(u,f){this.piece=u,this.color=f,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return k(this.right);let u=this;for(;u.parent!==e.SENTINEL&&u.parent.left!==u;)u=u.parent;return u.parent===e.SENTINEL?e.SENTINEL:u.parent}prev(){if(this.left!==e.SENTINEL)return A(this.left);let u=this;for(;u.parent!==e.SENTINEL&&u.parent.right!==u;)u=u.parent;return u.parent===e.SENTINEL?e.SENTINEL:u.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=r;var g;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(g||(e.NodeColor=g={})),e.SENTINEL=new r(null,g.Black),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=g.Black;function k(a){for(;a.left!==e.SENTINEL;)a=a.left;return a}function A(a){for(;a.right!==e.SENTINEL;)a=a.right;return a}function L(a){return a===e.SENTINEL?0:a.size_left+a.piece.length+L(a.right)}function R(a){return a===e.SENTINEL?0:a.lf_left+a.piece.lineFeedCnt+R(a.right)}function v(){e.SENTINEL.parent=e.SENTINEL}function l(a,u){const f=u.right;f.size_left+=u.size_left+(u.piece?u.piece.length:0),f.lf_left+=u.lf_left+(u.piece?u.piece.lineFeedCnt:0),u.right=f.left,f.left!==e.SENTINEL&&(f.left.parent=u),f.parent=u.parent,u.parent===e.SENTINEL?a.root=f:u.parent.left===u?u.parent.left=f:u.parent.right=f,f.left=u,u.parent=f}function P(a,u){const f=u.left;u.left=f.right,f.right!==e.SENTINEL&&(f.right.parent=u),f.parent=u.parent,u.size_left-=f.size_left+(f.piece?f.piece.length:0),u.lf_left-=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),u.parent===e.SENTINEL?a.root=f:u===u.parent.right?u.parent.right=f:u.parent.left=f,f.right=u,u.parent=f}function y(a,u){let f,m;if(u.left===e.SENTINEL?(m=u,f=m.right):u.right===e.SENTINEL?(m=u,f=m.left):(m=k(u.right),f=m.right),m===a.root){a.root=f,f.color=g.Black,u.detach(),v(),a.root.parent=e.SENTINEL;return}const n=m.color===g.Red;if(m===m.parent.left?m.parent.left=f:m.parent.right=f,m===u?(f.parent=m.parent,E(a,f)):(m.parent===u?f.parent=m:f.parent=m.parent,E(a,f),m.left=u.left,m.right=u.right,m.parent=u.parent,m.color=u.color,u===a.root?a.root=m:u===u.parent.left?u.parent.left=m:u.parent.right=m,m.left!==e.SENTINEL&&(m.left.parent=m),m.right!==e.SENTINEL&&(m.right.parent=m),m.size_left=u.size_left,m.lf_left=u.lf_left,E(a,m)),u.detach(),f.parent.left===f){const i=L(f),t=R(f);if(i!==f.parent.size_left||t!==f.parent.lf_left){const c=i-f.parent.size_left,h=t-f.parent.lf_left;f.parent.size_left=i,f.parent.lf_left=t,T(a,f.parent,c,h)}}if(E(a,f.parent),n){v();return}let s;for(;f!==a.root&&f.color===g.Black;)f===f.parent.left?(s=f.parent.right,s.color===g.Red&&(s.color=g.Black,f.parent.color=g.Red,l(a,f.parent),s=f.parent.right),s.left.color===g.Black&&s.right.color===g.Black?(s.color=g.Red,f=f.parent):(s.right.color===g.Black&&(s.left.color=g.Black,s.color=g.Red,P(a,s),s=f.parent.right),s.color=f.parent.color,f.parent.color=g.Black,s.right.color=g.Black,l(a,f.parent),f=a.root)):(s=f.parent.left,s.color===g.Red&&(s.color=g.Black,f.parent.color=g.Red,P(a,f.parent),s=f.parent.left),s.left.color===g.Black&&s.right.color===g.Black?(s.color=g.Red,f=f.parent):(s.left.color===g.Black&&(s.right.color=g.Black,s.color=g.Red,l(a,s),s=f.parent.left),s.color=f.parent.color,f.parent.color=g.Black,s.left.color=g.Black,P(a,f.parent),f=a.root));f.color=g.Black,v()}function d(a,u){for(E(a,u);u!==a.root&&u.parent.color===g.Red;)if(u.parent===u.parent.parent.left){const f=u.parent.parent.right;f.color===g.Red?(u.parent.color=g.Black,f.color=g.Black,u.parent.parent.color=g.Red,u=u.parent.parent):(u===u.parent.right&&(u=u.parent,l(a,u)),u.parent.color=g.Black,u.parent.parent.color=g.Red,P(a,u.parent.parent))}else{const f=u.parent.parent.left;f.color===g.Red?(u.parent.color=g.Black,f.color=g.Black,u.parent.parent.color=g.Red,u=u.parent.parent):(u===u.parent.left&&(u=u.parent,P(a,u)),u.parent.color=g.Black,u.parent.parent.color=g.Red,l(a,u.parent.parent))}a.root.color=g.Black}function T(a,u,f,m){for(;u!==a.root&&u!==e.SENTINEL;)u.parent.left===u&&(u.parent.size_left+=f,u.parent.lf_left+=m),u=u.parent}function E(a,u){let f=0,m=0;if(u!==a.root){for(;u!==a.root&&u===u.parent.right;)u=u.parent;if(u!==a.root)for(u=u.parent,f=L(u.left)-u.size_left,m=R(u.left)-u.lf_left,u.size_left+=f,u.lf_left+=m;u!==a.root&&(f!==0||m!==0);)u.parent.left===u&&(u.parent.size_left+=f,u.parent.lf_left+=m),u=u.parent}}}),define(we[195],ye([1,0,19,84]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(v){this.values=v,this.prefixSum=new Uint32Array(v.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(v,l){v=(0,g.toUint32)(v);const P=this.values,y=this.prefixSum,d=l.length;return d===0?!1:(this.values=new Uint32Array(P.length+d),this.values.set(P.subarray(0,v),0),this.values.set(P.subarray(v),v+d),this.values.set(l,v),v-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=v-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(v,l){return v=(0,g.toUint32)(v),l=(0,g.toUint32)(l),this.values[v]===l?!1:(this.values[v]=l,v-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=v-1),!0)}removeValues(v,l){v=(0,g.toUint32)(v),l=(0,g.toUint32)(l);const P=this.values,y=this.prefixSum;if(v>=P.length)return!1;const d=P.length-v;return l>=d&&(l=d),l===0?!1:(this.values=new Uint32Array(P.length-l),this.values.set(P.subarray(0,v),0),this.values.set(P.subarray(v+l),v),this.prefixSum=new Uint32Array(this.values.length),v-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=v-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(v){return v<0?0:(v=(0,g.toUint32)(v),this._getPrefixSum(v))}_getPrefixSum(v){if(v<=this.prefixSumValidIndex[0])return this.prefixSum[v];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),v>=this.values.length&&(v=this.values.length-1);for(let P=l;P<=v;P++)this.prefixSum[P]=this.prefixSum[P-1]+this.values[P];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],v),this.prefixSum[v]}getIndexOf(v){v=Math.floor(v),this.getTotalSum();let l=0,P=this.values.length-1,y=0,d=0,T=0;for(;l<=P;)if(y=l+(P-l)/2|0,d=this.prefixSum[y],T=d-this.values[y],v<T)P=y-1;else if(v>=d)l=y+1;else break;return new L(y,v-T)}}e.PrefixSumComputer=k;class A{constructor(v){this._values=v,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(v){return this._ensureValid(),v===0?0:this._prefixSum[v-1]}getIndexOf(v){this._ensureValid();const l=this._indexBySum[v],P=l>0?this._prefixSum[l-1]:0;return new L(l,v-P)}removeValues(v,l){this._values.splice(v,l),this._invalidate(v)}insertValues(v,l){this._values=(0,r.arrayInsert)(this._values,v,l),this._invalidate(v)}_invalidate(v){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,v-1)}_ensureValid(){if(!this._isValid){for(let v=this._validEndIndex+1,l=this._values.length;v<l;v++){const P=this._values[v],y=v>0?this._prefixSum[v-1]:0;this._prefixSum[v]=y+P;for(let d=0;d<P;d++)this._indexBySum[y+d]=v}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(v,l){this._values[v]!==l&&(this._values[v]=l,this._invalidate(v))}}e.ConstantTimePrefixSumComputer=A;class L{constructor(v,l){this.index=v,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=v,this.remainder=l}}e.PrefixSumIndexOfResult=L}),define(we[196],ye([1,0,13,54,195]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(R,v,l,P){this._uri=R,this._lines=v,this._eol=l,this._versionId=P,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(R){R.eol&&R.eol!==this._eol&&(this._eol=R.eol,this._lineStarts=null);const v=R.changes;for(const l of v)this._acceptDeleteRange(l.range),this._acceptInsertText(new g.Position(l.range.startLineNumber,l.range.startColumn),l.text);this._versionId=R.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const R=this._eol.length,v=this._lines.length,l=new Uint32Array(v);for(let P=0;P<v;P++)l[P]=this._lines[P].length+R;this._lineStarts=new k.PrefixSumComputer(l)}}_setLineText(R,v){this._lines[R]=v,this._lineStarts&&this._lineStarts.setValue(R,this._lines[R].length+this._eol.length)}_acceptDeleteRange(R){if(R.startLineNumber===R.endLineNumber){if(R.startColumn===R.endColumn)return;this._setLineText(R.startLineNumber-1,this._lines[R.startLineNumber-1].substring(0,R.startColumn-1)+this._lines[R.startLineNumber-1].substring(R.endColumn-1));return}this._setLineText(R.startLineNumber-1,this._lines[R.startLineNumber-1].substring(0,R.startColumn-1)+this._lines[R.endLineNumber-1].substring(R.endColumn-1)),this._lines.splice(R.startLineNumber,R.endLineNumber-R.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(R.startLineNumber,R.endLineNumber-R.startLineNumber)}_acceptInsertText(R,v){if(v.length===0)return;const l=(0,r.splitLines)(v);if(l.length===1){this._setLineText(R.lineNumber-1,this._lines[R.lineNumber-1].substring(0,R.column-1)+l[0]+this._lines[R.lineNumber-1].substring(R.column-1));return}l[l.length-1]+=this._lines[R.lineNumber-1].substring(R.column-1),this._setLineText(R.lineNumber-1,this._lines[R.lineNumber-1].substring(0,R.column-1)+l[0]);const P=new Uint32Array(l.length-1);for(let y=1;y<l.length;y++)this._lines.splice(R.lineNumber+y-1,0,l[y]),P[y-1]=l[y].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(R.lineNumber,P)}}e.MirrorTextModel=A}),define(we[106],ye([1,0,27,13,191,54,31,55]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.TextModelSearch=e.SearchParams=void 0,e.isMultilineRegexSource=P,e.createFindMatch=y,e.isValidMatch=u;const v=999;class l{constructor(n,s,i,t){this.searchString=n,this.isRegex=s,this.matchCase=i,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=P(this.searchString):n=this.searchString.indexOf(`
`)>=0;let s=null;try{s=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!s)return null;let i=!this.isRegex&&!n;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new R.SearchData(s,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators,[]):null,i?this.searchString:null)}}e.SearchParams=l;function P(m){if(!m||m.length===0)return!1;for(let n=0,s=m.length;n<s;n++){const i=m.charCodeAt(n);if(i===r.CharCode.LineFeed)return!0;if(i===r.CharCode.Backslash){if(n++,n>=s)break;const t=m.charCodeAt(n);if(t===r.CharCode.n||t===r.CharCode.r||t===r.CharCode.W)return!0}}return!1}function y(m,n,s){if(!s)return new R.FindMatch(m,null);const i=[];for(let t=0,c=n.length;t<c;t++)i[t]=n[t];return new R.FindMatch(m,i)}class d{constructor(n){const s=[];let i=0;for(let t=0,c=n.length;t<c;t++)n.charCodeAt(t)===r.CharCode.LineFeed&&(s[i++]=t);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(n){const s=this._lineFeedsOffsets;let i=0,t=s.length-1;if(t===-1||n<=s[0])return 0;for(;i<t;){const c=i+((t-i)/2>>0);s[c]>=n?t=c-1:s[c+1]>=n?(i=c,t=c):i=c+1}return i+1}}class T{static findMatches(n,s,i,t,c){const h=s.parseSearchRequest();return h?h.regex.multiline?this._doFindMatchesMultiline(n,i,new f(h.wordSeparators,h.regex),t,c):this._doFindMatchesLineByLine(n,i,h,t,c):[]}static _getMultilineMatchRange(n,s,i,t,c,h){let o,p=0;t?(p=t.findLineFeedCountBeforeOffset(c),o=s+c+p):o=s+c;let _;if(t){const I=t.findLineFeedCountBeforeOffset(c+h.length)-p;_=o+h.length+I}else _=o+h.length;const D=n.getPositionAt(o),C=n.getPositionAt(_);return new L.Range(D.lineNumber,D.column,C.lineNumber,C.column)}static _doFindMatchesMultiline(n,s,i,t,c){const h=n.getOffsetAt(s.getStartPosition()),o=n.getValueInRange(s,R.EndOfLinePreference.LF),p=n.getEOL()===`\r
`?new d(o):null,_=[];let D=0,C;for(i.reset(0);C=i.next(o);)if(_[D++]=y(this._getMultilineMatchRange(n,h,o,p,C.index,C[0]),C,t),D>=c)return _;return _}static _doFindMatchesLineByLine(n,s,i,t,c){const h=[];let o=0;if(s.startLineNumber===s.endLineNumber){const _=n.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return o=this._findMatchesInLine(i,_,s.startLineNumber,s.startColumn-1,o,h,t,c),h}const p=n.getLineContent(s.startLineNumber).substring(s.startColumn-1);o=this._findMatchesInLine(i,p,s.startLineNumber,s.startColumn-1,o,h,t,c);for(let _=s.startLineNumber+1;_<s.endLineNumber&&o<c;_++)o=this._findMatchesInLine(i,n.getLineContent(_),_,0,o,h,t,c);if(o<c){const _=n.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);o=this._findMatchesInLine(i,_,s.endLineNumber,0,o,h,t,c)}return h}static _findMatchesInLine(n,s,i,t,c,h,o,p){const _=n.wordSeparators;if(!o&&n.simpleSearch){const S=n.simpleSearch,I=S.length,b=s.length;let w=-I;for(;(w=s.indexOf(S,w+I))!==-1;)if((!_||u(_,s,b,w,I))&&(h[c++]=new R.FindMatch(new L.Range(i,w+1+t,i,w+1+I+t),null),c>=p))return c;return c}const D=new f(n.wordSeparators,n.regex);let C;D.reset(0);do if(C=D.next(s),C&&(h[c++]=y(new L.Range(i,C.index+1+t,i,C.index+1+C[0].length+t),C,o),c>=p))return c;while(C);return c}static findNextMatch(n,s,i,t){const c=s.parseSearchRequest();if(!c)return null;const h=new f(c.wordSeparators,c.regex);return c.regex.multiline?this._doFindNextMatchMultiline(n,i,h,t):this._doFindNextMatchLineByLine(n,i,h,t)}static _doFindNextMatchMultiline(n,s,i,t){const c=new A.Position(s.lineNumber,1),h=n.getOffsetAt(c),o=n.getLineCount(),p=n.getValueInRange(new L.Range(c.lineNumber,c.column,o,n.getLineMaxColumn(o)),R.EndOfLinePreference.LF),_=n.getEOL()===`\r
`?new d(p):null;i.reset(s.column-1);const D=i.next(p);return D?y(this._getMultilineMatchRange(n,h,p,_,D.index,D[0]),D,t):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(n,new A.Position(1,1),i,t):null}static _doFindNextMatchLineByLine(n,s,i,t){const c=n.getLineCount(),h=s.lineNumber,o=n.getLineContent(h),p=this._findFirstMatchInLine(i,o,h,s.column,t);if(p)return p;for(let _=1;_<=c;_++){const D=(h+_-1)%c,C=n.getLineContent(D+1),S=this._findFirstMatchInLine(i,C,D+1,1,t);if(S)return S}return null}static _findFirstMatchInLine(n,s,i,t,c){n.reset(t-1);const h=n.next(s);return h?y(new L.Range(i,h.index+1,i,h.index+1+h[0].length),h,c):null}static findPreviousMatch(n,s,i,t){const c=s.parseSearchRequest();if(!c)return null;const h=new f(c.wordSeparators,c.regex);return c.regex.multiline?this._doFindPreviousMatchMultiline(n,i,h,t):this._doFindPreviousMatchLineByLine(n,i,h,t)}static _doFindPreviousMatchMultiline(n,s,i,t){const c=this._doFindMatchesMultiline(n,new L.Range(1,1,s.lineNumber,s.column),i,t,10*v);if(c.length>0)return c[c.length-1];const h=n.getLineCount();return s.lineNumber!==h||s.column!==n.getLineMaxColumn(h)?this._doFindPreviousMatchMultiline(n,new A.Position(h,n.getLineMaxColumn(h)),i,t):null}static _doFindPreviousMatchLineByLine(n,s,i,t){const c=n.getLineCount(),h=s.lineNumber,o=n.getLineContent(h).substring(0,s.column-1),p=this._findLastMatchInLine(i,o,h,t);if(p)return p;for(let _=1;_<=c;_++){const D=(c+h-_-1)%c,C=n.getLineContent(D+1),S=this._findLastMatchInLine(i,C,D+1,t);if(S)return S}return null}static _findLastMatchInLine(n,s,i,t){let c=null,h;for(n.reset(0);h=n.next(s);)c=y(new L.Range(i,h.index+1,i,h.index+1+h[0].length),h,t);return c}}e.TextModelSearch=T;function E(m,n,s,i,t){if(i===0)return!0;const c=n.charCodeAt(i-1);if(m.get(c)!==k.WordCharacterClass.Regular||c===r.CharCode.CarriageReturn||c===r.CharCode.LineFeed)return!0;if(t>0){const h=n.charCodeAt(i);if(m.get(h)!==k.WordCharacterClass.Regular)return!0}return!1}function a(m,n,s,i,t){if(i+t===s)return!0;const c=n.charCodeAt(i+t);if(m.get(c)!==k.WordCharacterClass.Regular||c===r.CharCode.CarriageReturn||c===r.CharCode.LineFeed)return!0;if(t>0){const h=n.charCodeAt(i+t-1);if(m.get(h)!==k.WordCharacterClass.Regular)return!0}return!1}function u(m,n,s,i,t){return E(m,n,s,i,t)&&a(m,n,s,i,t)}class f{constructor(n,s){this._wordSeparators=n,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(n){this._searchRegex.lastIndex=n,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(n){const s=n.length;let i;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(i=this._searchRegex.exec(n),!i))return null;const t=i.index,c=i[0].length;if(t===this._prevMatchStartIndex&&c===this._prevMatchLength){if(c===0){g.getNextCodePoint(n,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=c,!this._wordSeparators||u(this._wordSeparators,n,s,t,c))return i}while(i);return null}}e.Searcher=f}),define(we[138],ye([1,0,27,54,31,55,194,106]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=y,e.createLineStarts=d;const v=65535;function l(m){let n;return m[m.length-1]<65536?n=new Uint16Array(m.length):n=new Uint32Array(m.length),n.set(m,0),n}class P{constructor(n,s,i,t,c){this.lineStarts=n,this.cr=s,this.lf=i,this.crlf=t,this.isBasicASCII=c}}function y(m,n=!0){const s=[0];let i=1;for(let t=0,c=m.length;t<c;t++){const h=m.charCodeAt(t);h===r.CharCode.CarriageReturn?t+1<c&&m.charCodeAt(t+1)===r.CharCode.LineFeed?(s[i++]=t+2,t++):s[i++]=t+1:h===r.CharCode.LineFeed&&(s[i++]=t+1)}return n?l(s):s}function d(m,n){m.length=0,m[0]=0;let s=1,i=0,t=0,c=0,h=!0;for(let p=0,_=n.length;p<_;p++){const D=n.charCodeAt(p);D===r.CharCode.CarriageReturn?p+1<_&&n.charCodeAt(p+1)===r.CharCode.LineFeed?(c++,m[s++]=p+2,p++):(i++,m[s++]=p+1):D===r.CharCode.LineFeed?(t++,m[s++]=p+1):h&&D!==r.CharCode.Tab&&(D<32||D>126)&&(h=!1)}const o=new P(l(m),i,t,c,h);return m.length=0,o}class T{constructor(n,s,i,t,c){this.bufferIndex=n,this.start=s,this.end=i,this.lineFeedCnt=t,this.length=c}}e.Piece=T;class E{constructor(n,s){this.buffer=n,this.lineStarts=s}}e.StringBuffer=E;class a{constructor(n,s){this._pieces=[],this._tree=n,this._BOM=s,this._index=0,n.root!==L.SENTINEL&&n.iterate(n.root,i=>(i!==L.SENTINEL&&this._pieces.push(i.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class u{constructor(n){this._limit=n,this._cache=[]}get(n){for(let s=this._cache.length-1;s>=0;s--){const i=this._cache[s];if(i.nodeStartOffset<=n&&i.nodeStartOffset+i.node.piece.length>=n)return i}return null}get2(n){for(let s=this._cache.length-1;s>=0;s--){const i=this._cache[s];if(i.nodeStartLineNumber&&i.nodeStartLineNumber<n&&i.nodeStartLineNumber+i.node.piece.lineFeedCnt>=n)return i}return null}set(n){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(n)}validate(n){let s=!1;const i=this._cache;for(let t=0;t<i.length;t++){const c=i[t];if(c.node.parent===null||c.nodeStartOffset>=n){i[t]=null,s=!0;continue}}if(s){const t=[];for(const c of i)c!==null&&t.push(c);this._cache=t}}}class f{constructor(n,s,i){this.create(n,s,i)}create(n,s,i){this._buffers=[new E("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=L.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=s,this._EOLLength=s.length,this._EOLNormalized=i;let t=null;for(let c=0,h=n.length;c<h;c++)if(n[c].buffer.length>0){n[c].lineStarts||(n[c].lineStarts=y(n[c].buffer));const o=new T(c+1,{line:0,column:0},{line:n[c].lineStarts.length-1,column:n[c].buffer.length-n[c].lineStarts[n[c].lineStarts.length-1]},n[c].lineStarts.length-1,n[c].buffer.length);this._buffers.push(n[c]),t=this.rbInsertRight(t,o)}this._searchCache=new u(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(n){const s=v,i=s-Math.floor(s/3),t=i*2;let c="",h=0;const o=[];if(this.iterate(this.root,p=>{const _=this.getNodeContent(p),D=_.length;if(h<=i||h+D<t)return c+=_,h+=D,!0;const C=c.replace(/\r\n|\r|\n/g,n);return o.push(new E(C,y(C))),c=_,h=D,!0}),h>0){const p=c.replace(/\r\n|\r|\n/g,n);o.push(new E(p,y(p)))}this.create(o,n,!0)}getEOL(){return this._EOL}setEOL(n){this._EOL=n,this._EOLLength=this._EOL.length,this.normalizeEOL(n)}createSnapshot(n){return new a(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let s=0;return this.iterate(this.root,t=>{if(t===L.SENTINEL)return!0;const c=this.getNodeContent(t),h=c.length,o=n.nodeAt(s),p=n.nodeAt(s+h),_=n.getValueInRange2(o,p);return s+=h,c===_})}getOffsetAt(n,s){let i=0,t=this.root;for(;t!==L.SENTINEL;)if(t.left!==L.SENTINEL&&t.lf_left+1>=n)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt+1>=n){i+=t.size_left;const c=this.getAccumulatedValue(t,n-t.lf_left-2);return i+=c+s-1}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;return i}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let s=this.root,i=0;const t=n;for(;s!==L.SENTINEL;)if(s.size_left!==0&&s.size_left>=n)s=s.left;else if(s.size_left+s.piece.length>=n){const c=this.getIndexOf(s,n-s.size_left);if(i+=s.lf_left+c.index,c.index===0){const h=this.getOffsetAt(i+1,1),o=t-h;return new g.Position(i+1,o+1)}return new g.Position(i+1,c.remainder+1)}else if(n-=s.size_left+s.piece.length,i+=s.lf_left+s.piece.lineFeedCnt,s.right===L.SENTINEL){const c=this.getOffsetAt(i+1,1),h=t-n-c;return new g.Position(i+1,h+1)}else s=s.right;return new g.Position(1,1)}getValueInRange(n,s){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const i=this.nodeAt2(n.startLineNumber,n.startColumn),t=this.nodeAt2(n.endLineNumber,n.endColumn),c=this.getValueInRange2(i,t);return s?s!==this._EOL||!this._EOLNormalized?c.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this._EOLNormalized?c:c.replace(/\r\n|\r|\n/g,s):c}getValueInRange2(n,s){if(n.node===s.node){const o=n.node,p=this._buffers[o.piece.bufferIndex].buffer,_=this.offsetInBuffer(o.piece.bufferIndex,o.piece.start);return p.substring(_+n.remainder,_+s.remainder)}let i=n.node;const t=this._buffers[i.piece.bufferIndex].buffer,c=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);let h=t.substring(c+n.remainder,c+i.piece.length);for(i=i.next();i!==L.SENTINEL;){const o=this._buffers[i.piece.bufferIndex].buffer,p=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);if(i===s.node){h+=o.substring(p,p+s.remainder);break}else h+=o.substr(p,i.piece.length);i=i.next()}return h}getLinesContent(){const n=[];let s=0,i="",t=!1;return this.iterate(this.root,c=>{if(c===L.SENTINEL)return!0;const h=c.piece;let o=h.length;if(o===0)return!0;const p=this._buffers[h.bufferIndex].buffer,_=this._buffers[h.bufferIndex].lineStarts,D=h.start.line,C=h.end.line;let S=_[D]+h.start.column;if(t&&(p.charCodeAt(S)===r.CharCode.LineFeed&&(S++,o--),n[s++]=i,i="",t=!1,o===0))return!0;if(D===C)return!this._EOLNormalized&&p.charCodeAt(S+o-1)===r.CharCode.CarriageReturn?(t=!0,i+=p.substr(S,o-1)):i+=p.substr(S,o),!0;i+=this._EOLNormalized?p.substring(S,Math.max(S,_[D+1]-this._EOLLength)):p.substring(S,_[D+1]).replace(/(\r\n|\r|\n)$/,""),n[s++]=i;for(let I=D+1;I<C;I++)i=this._EOLNormalized?p.substring(_[I],_[I+1]-this._EOLLength):p.substring(_[I],_[I+1]).replace(/(\r\n|\r|\n)$/,""),n[s++]=i;return!this._EOLNormalized&&p.charCodeAt(_[C]+h.end.column-1)===r.CharCode.CarriageReturn?(t=!0,h.end.column===0?s--:i=p.substr(_[C],h.end.column-1)):i=p.substr(_[C],h.end.column),!0}),t&&(n[s++]=i,i=""),n[s++]=i,n}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(n){return this._lastVisitedLine.lineNumber===n?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=n,n===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(n):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(n,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(n){if(n.remainder===n.node.piece.length){const s=n.node.next();if(!s)return 0;const i=this._buffers[s.piece.bufferIndex],t=this.offsetInBuffer(s.piece.bufferIndex,s.piece.start);return i.buffer.charCodeAt(t)}else{const s=this._buffers[n.node.piece.bufferIndex],t=this.offsetInBuffer(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return s.buffer.charCodeAt(t)}}getLineCharCode(n,s){const i=this.nodeAt2(n,s+1);return this._getCharCode(i)}getLineLength(n){if(n===this.getLineCount()){const s=this.getOffsetAt(n,1);return this.getLength()-s}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this._EOLLength}getCharCode(n){const s=this.nodeAt(n);return this._getCharCode(s)}findMatchesInNode(n,s,i,t,c,h,o,p,_,D,C){const S=this._buffers[n.piece.bufferIndex],I=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start),b=this.offsetInBuffer(n.piece.bufferIndex,c),w=this.offsetInBuffer(n.piece.bufferIndex,h);let N;const O={line:0,column:0};let U,x;s._wordSeparators?(U=S.buffer.substring(b,w),x=B=>B+b,s.reset(0)):(U=S.buffer,x=B=>B,s.reset(b));do if(N=s.next(U),N){if(x(N.index)>=w)return D;this.positionInBuffer(n,x(N.index)-I,O);const B=this.getLineFeedCnt(n.piece.bufferIndex,c,O),F=O.line===c.line?O.column-c.column+t:O.column+1,M=F+N[0].length;if(C[D++]=(0,R.createFindMatch)(new k.Range(i+B,F,i+B,M),N,p),x(N.index)+N[0].length>=w||D>=_)return D}while(N);return D}findMatchesLineByLine(n,s,i,t){const c=[];let h=0;const o=new R.Searcher(s.wordSeparators,s.regex);let p=this.nodeAt2(n.startLineNumber,n.startColumn);if(p===null)return[];const _=this.nodeAt2(n.endLineNumber,n.endColumn);if(_===null)return[];let D=this.positionInBuffer(p.node,p.remainder);const C=this.positionInBuffer(_.node,_.remainder);if(p.node===_.node)return this.findMatchesInNode(p.node,o,n.startLineNumber,n.startColumn,D,C,s,i,t,h,c),c;let S=n.startLineNumber,I=p.node;for(;I!==_.node;){const w=this.getLineFeedCnt(I.piece.bufferIndex,D,I.piece.end);if(w>=1){const O=this._buffers[I.piece.bufferIndex].lineStarts,U=this.offsetInBuffer(I.piece.bufferIndex,I.piece.start),x=O[D.line+w],B=S===n.startLineNumber?n.startColumn:1;if(h=this.findMatchesInNode(I,o,S,B,D,this.positionInBuffer(I,x-U),s,i,t,h,c),h>=t)return c;S+=w}const N=S===n.startLineNumber?n.startColumn-1:0;if(S===n.endLineNumber){const O=this.getLineContent(S).substring(N,n.endColumn-1);return h=this._findMatchesInLine(s,o,O,n.endLineNumber,N,h,c,i,t),c}if(h=this._findMatchesInLine(s,o,this.getLineContent(S).substr(N),S,N,h,c,i,t),h>=t)return c;S++,p=this.nodeAt2(S,1),I=p.node,D=this.positionInBuffer(p.node,p.remainder)}if(S===n.endLineNumber){const w=S===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(S).substring(w,n.endColumn-1);return h=this._findMatchesInLine(s,o,N,n.endLineNumber,w,h,c,i,t),c}const b=S===n.startLineNumber?n.startColumn:1;return h=this.findMatchesInNode(_.node,o,S,b,D,C,s,i,t,h,c),c}_findMatchesInLine(n,s,i,t,c,h,o,p,_){const D=n.wordSeparators;if(!p&&n.simpleSearch){const S=n.simpleSearch,I=S.length,b=i.length;let w=-I;for(;(w=i.indexOf(S,w+I))!==-1;)if((!D||(0,R.isValidMatch)(D,i,b,w,I))&&(o[h++]=new A.FindMatch(new k.Range(t,w+1+c,t,w+1+I+c),null),h>=_))return h;return h}let C;s.reset(0);do if(C=s.next(i),C&&(o[h++]=(0,R.createFindMatch)(new k.Range(t,C.index+1+c,t,C.index+1+C[0].length+c),C,p),h>=_))return h;while(C);return h}insert(n,s,i=!1){if(this._EOLNormalized=this._EOLNormalized&&i,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==L.SENTINEL){const{node:t,remainder:c,nodeStartOffset:h}=this.nodeAt(n),o=t.piece,p=o.bufferIndex,_=this.positionInBuffer(t,c);if(t.piece.bufferIndex===0&&o.end.line===this._lastChangeBufferPos.line&&o.end.column===this._lastChangeBufferPos.column&&h+o.length===n&&s.length<v){this.appendToNode(t,s),this.computeBufferMetadata();return}if(h===n)this.insertContentToNodeLeft(s,t),this._searchCache.validate(n);else if(h+t.piece.length>n){const D=[];let C=new T(o.bufferIndex,_,o.end,this.getLineFeedCnt(o.bufferIndex,_,o.end),this.offsetInBuffer(p,o.end)-this.offsetInBuffer(p,_));if(this.shouldCheckCRLF()&&this.endWithCR(s)&&this.nodeCharCodeAt(t,c)===10){const w={line:C.start.line+1,column:0};C=new T(C.bufferIndex,w,C.end,this.getLineFeedCnt(C.bufferIndex,w,C.end),C.length-1),s+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(s))if(this.nodeCharCodeAt(t,c-1)===13){const w=this.positionInBuffer(t,c-1);this.deleteNodeTail(t,w),s="\r"+s,t.piece.length===0&&D.push(t)}else this.deleteNodeTail(t,_);else this.deleteNodeTail(t,_);const S=this.createNewPieces(s);C.length>0&&this.rbInsertRight(t,C);let I=t;for(let b=0;b<S.length;b++)I=this.rbInsertRight(I,S[b]);this.deleteNodes(D)}else this.insertContentToNodeRight(s,t)}else{const t=this.createNewPieces(s);let c=this.rbInsertLeft(null,t[0]);for(let h=1;h<t.length;h++)c=this.rbInsertRight(c,t[h])}this.computeBufferMetadata()}delete(n,s){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",s<=0||this.root===L.SENTINEL)return;const i=this.nodeAt(n),t=this.nodeAt(n+s),c=i.node,h=t.node;if(c===h){const S=this.positionInBuffer(c,i.remainder),I=this.positionInBuffer(c,t.remainder);if(i.nodeStartOffset===n){if(s===c.piece.length){const b=c.next();(0,L.rbDelete)(this,c),this.validateCRLFWithPrevNode(b),this.computeBufferMetadata();return}this.deleteNodeHead(c,I),this._searchCache.validate(n),this.validateCRLFWithPrevNode(c),this.computeBufferMetadata();return}if(i.nodeStartOffset+c.piece.length===n+s){this.deleteNodeTail(c,S),this.validateCRLFWithNextNode(c),this.computeBufferMetadata();return}this.shrinkNode(c,S,I),this.computeBufferMetadata();return}const o=[],p=this.positionInBuffer(c,i.remainder);this.deleteNodeTail(c,p),this._searchCache.validate(n),c.piece.length===0&&o.push(c);const _=this.positionInBuffer(h,t.remainder);this.deleteNodeHead(h,_),h.piece.length===0&&o.push(h);const D=c.next();for(let S=D;S!==L.SENTINEL&&S!==h;S=S.next())o.push(S);const C=c.piece.length===0?c.prev():c;this.deleteNodes(o),this.validateCRLFWithNextNode(C),this.computeBufferMetadata()}insertContentToNodeLeft(n,s){const i=[];if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.startWithLF(s)){const h=s.piece,o={line:h.start.line+1,column:0},p=new T(h.bufferIndex,o,h.end,this.getLineFeedCnt(h.bufferIndex,o,h.end),h.length-1);s.piece=p,n+=`
`,(0,L.updateTreeMetadata)(this,s,-1,-1),s.piece.length===0&&i.push(s)}const t=this.createNewPieces(n);let c=this.rbInsertLeft(s,t[t.length-1]);for(let h=t.length-2;h>=0;h--)c=this.rbInsertLeft(c,t[h]);this.validateCRLFWithPrevNode(c),this.deleteNodes(i)}insertContentToNodeRight(n,s){this.adjustCarriageReturnFromNext(n,s)&&(n+=`
`);const i=this.createNewPieces(n),t=this.rbInsertRight(s,i[0]);let c=t;for(let h=1;h<i.length;h++)c=this.rbInsertRight(c,i[h]);this.validateCRLFWithPrevNode(t)}positionInBuffer(n,s,i){const t=n.piece,c=n.piece.bufferIndex,h=this._buffers[c].lineStarts,p=h[t.start.line]+t.start.column+s;let _=t.start.line,D=t.end.line,C=0,S=0,I=0;for(;_<=D&&(C=_+(D-_)/2|0,I=h[C],C!==D);)if(S=h[C+1],p<I)D=C-1;else if(p>=S)_=C+1;else break;return i?(i.line=C,i.column=p-I,null):{line:C,column:p-I}}getLineFeedCnt(n,s,i){if(i.column===0)return i.line-s.line;const t=this._buffers[n].lineStarts;if(i.line===t.length-1)return i.line-s.line;const c=t[i.line+1],h=t[i.line]+i.column;if(c>h+1)return i.line-s.line;const o=h-1;return this._buffers[n].buffer.charCodeAt(o)===13?i.line-s.line+1:i.line-s.line}offsetInBuffer(n,s){return this._buffers[n].lineStarts[s.line]+s.column}deleteNodes(n){for(let s=0;s<n.length;s++)(0,L.rbDelete)(this,n[s])}createNewPieces(n){if(n.length>v){const D=[];for(;n.length>v;){const S=n.charCodeAt(v-1);let I;S===r.CharCode.CarriageReturn||S>=55296&&S<=56319?(I=n.substring(0,v-1),n=n.substring(v-1)):(I=n.substring(0,v),n=n.substring(v));const b=y(I);D.push(new T(this._buffers.length,{line:0,column:0},{line:b.length-1,column:I.length-b[b.length-1]},b.length-1,I.length)),this._buffers.push(new E(I,b))}const C=y(n);return D.push(new T(this._buffers.length,{line:0,column:0},{line:C.length-1,column:n.length-C[C.length-1]},C.length-1,n.length)),this._buffers.push(new E(n,C)),D}let s=this._buffers[0].buffer.length;const i=y(n,!1);let t=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===s&&s!==0&&this.startWithLF(n)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},t=this._lastChangeBufferPos;for(let D=0;D<i.length;D++)i[D]+=s+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(i.slice(1)),this._buffers[0].buffer+="_"+n,s+=1}else{if(s!==0)for(let D=0;D<i.length;D++)i[D]+=s;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(i.slice(1)),this._buffers[0].buffer+=n}const c=this._buffers[0].buffer.length,h=this._buffers[0].lineStarts.length-1,o=c-this._buffers[0].lineStarts[h],p={line:h,column:o},_=new T(0,t,p,this.getLineFeedCnt(0,t,p),c-s);return this._lastChangeBufferPos=p,[_]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(n,s=0){let i=this.root,t="";const c=this._searchCache.get2(n);if(c){i=c.node;const h=this.getAccumulatedValue(i,n-c.nodeStartLineNumber-1),o=this._buffers[i.piece.bufferIndex].buffer,p=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);if(c.nodeStartLineNumber+i.piece.lineFeedCnt===n)t=o.substring(p+h,p+i.piece.length);else{const _=this.getAccumulatedValue(i,n-c.nodeStartLineNumber);return o.substring(p+h,p+_-s)}}else{let h=0;const o=n;for(;i!==L.SENTINEL;)if(i.left!==L.SENTINEL&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const p=this.getAccumulatedValue(i,n-i.lf_left-2),_=this.getAccumulatedValue(i,n-i.lf_left-1),D=this._buffers[i.piece.bufferIndex].buffer,C=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);return h+=i.size_left,this._searchCache.set({node:i,nodeStartOffset:h,nodeStartLineNumber:o-(n-1-i.lf_left)}),D.substring(C+p,C+_-s)}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const p=this.getAccumulatedValue(i,n-i.lf_left-2),_=this._buffers[i.piece.bufferIndex].buffer,D=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);t=_.substring(D+p,D+i.piece.length);break}else n-=i.lf_left+i.piece.lineFeedCnt,h+=i.size_left+i.piece.length,i=i.right}for(i=i.next();i!==L.SENTINEL;){const h=this._buffers[i.piece.bufferIndex].buffer;if(i.piece.lineFeedCnt>0){const o=this.getAccumulatedValue(i,0),p=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);return t+=h.substring(p,p+o-s),t}else{const o=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);t+=h.substr(o,i.piece.length)}i=i.next()}return t}computeBufferMetadata(){let n=this.root,s=1,i=0;for(;n!==L.SENTINEL;)s+=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;this._lineCnt=s,this._length=i,this._searchCache.validate(this._length)}getIndexOf(n,s){const i=n.piece,t=this.positionInBuffer(n,s),c=t.line-i.start.line;if(this.offsetInBuffer(i.bufferIndex,i.end)-this.offsetInBuffer(i.bufferIndex,i.start)===s){const h=this.getLineFeedCnt(n.piece.bufferIndex,i.start,t);if(h!==c)return{index:h,remainder:0}}return{index:c,remainder:t.column}}getAccumulatedValue(n,s){if(s<0)return 0;const i=n.piece,t=this._buffers[i.bufferIndex].lineStarts,c=i.start.line+s+1;return c>i.end.line?t[i.end.line]+i.end.column-t[i.start.line]-i.start.column:t[c]-t[i.start.line]-i.start.column}deleteNodeTail(n,s){const i=n.piece,t=i.lineFeedCnt,c=this.offsetInBuffer(i.bufferIndex,i.end),h=s,o=this.offsetInBuffer(i.bufferIndex,h),p=this.getLineFeedCnt(i.bufferIndex,i.start,h),_=p-t,D=o-c,C=i.length+D;n.piece=new T(i.bufferIndex,i.start,h,p,C),(0,L.updateTreeMetadata)(this,n,D,_)}deleteNodeHead(n,s){const i=n.piece,t=i.lineFeedCnt,c=this.offsetInBuffer(i.bufferIndex,i.start),h=s,o=this.getLineFeedCnt(i.bufferIndex,h,i.end),p=this.offsetInBuffer(i.bufferIndex,h),_=o-t,D=c-p,C=i.length+D;n.piece=new T(i.bufferIndex,h,i.end,o,C),(0,L.updateTreeMetadata)(this,n,D,_)}shrinkNode(n,s,i){const t=n.piece,c=t.start,h=t.end,o=t.length,p=t.lineFeedCnt,_=s,D=this.getLineFeedCnt(t.bufferIndex,t.start,_),C=this.offsetInBuffer(t.bufferIndex,s)-this.offsetInBuffer(t.bufferIndex,c);n.piece=new T(t.bufferIndex,t.start,_,D,C),(0,L.updateTreeMetadata)(this,n,C-o,D-p);const S=new T(t.bufferIndex,i,h,this.getLineFeedCnt(t.bufferIndex,i,h),this.offsetInBuffer(t.bufferIndex,h)-this.offsetInBuffer(t.bufferIndex,i)),I=this.rbInsertRight(n,S);this.validateCRLFWithPrevNode(I)}appendToNode(n,s){this.adjustCarriageReturnFromNext(s,n)&&(s+=`
`);const i=this.shouldCheckCRLF()&&this.startWithLF(s)&&this.endWithCR(n),t=this._buffers[0].buffer.length;this._buffers[0].buffer+=s;const c=y(s,!1);for(let I=0;I<c.length;I++)c[I]+=t;if(i){const I=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:t-I}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(c.slice(1));const h=this._buffers[0].lineStarts.length-1,o=this._buffers[0].buffer.length-this._buffers[0].lineStarts[h],p={line:h,column:o},_=n.piece.length+s.length,D=n.piece.lineFeedCnt,C=this.getLineFeedCnt(0,n.piece.start,p),S=C-D;n.piece=new T(n.piece.bufferIndex,n.piece.start,p,C,_),this._lastChangeBufferPos=p,(0,L.updateTreeMetadata)(this,n,s.length,S)}nodeAt(n){let s=this.root;const i=this._searchCache.get(n);if(i)return{node:i.node,nodeStartOffset:i.nodeStartOffset,remainder:n-i.nodeStartOffset};let t=0;for(;s!==L.SENTINEL;)if(s.size_left>n)s=s.left;else if(s.size_left+s.piece.length>=n){t+=s.size_left;const c={node:s,remainder:n-s.size_left,nodeStartOffset:t};return this._searchCache.set(c),c}else n-=s.size_left+s.piece.length,t+=s.size_left+s.piece.length,s=s.right;return null}nodeAt2(n,s){let i=this.root,t=0;for(;i!==L.SENTINEL;)if(i.left!==L.SENTINEL&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const c=this.getAccumulatedValue(i,n-i.lf_left-2),h=this.getAccumulatedValue(i,n-i.lf_left-1);return t+=i.size_left,{node:i,remainder:Math.min(c+s-1,h),nodeStartOffset:t}}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const c=this.getAccumulatedValue(i,n-i.lf_left-2);if(c+s-1<=i.piece.length)return{node:i,remainder:c+s-1,nodeStartOffset:t};s-=i.piece.length-c;break}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;for(i=i.next();i!==L.SENTINEL;){if(i.piece.lineFeedCnt>0){const c=this.getAccumulatedValue(i,0),h=this.offsetOfNode(i);return{node:i,remainder:Math.min(s-1,c),nodeStartOffset:h}}else if(i.piece.length>=s-1){const c=this.offsetOfNode(i);return{node:i,remainder:s-1,nodeStartOffset:c}}else s-=i.piece.length;i=i.next()}return null}nodeCharCodeAt(n,s){if(n.piece.lineFeedCnt<1)return-1;const i=this._buffers[n.piece.bufferIndex],t=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start)+s;return i.buffer.charCodeAt(t)}offsetOfNode(n){if(!n)return 0;let s=n.size_left;for(;n!==this.root;)n.parent.right===n&&(s+=n.parent.size_left+n.parent.piece.length),n=n.parent;return s}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===L.SENTINEL||n.piece.lineFeedCnt===0)return!1;const s=n.piece,i=this._buffers[s.bufferIndex].lineStarts,t=s.start.line,c=i[t]+s.start.column;return t===i.length-1||i[t+1]>c+1?!1:this._buffers[s.bufferIndex].buffer.charCodeAt(c)===10}endWithCR(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===L.SENTINEL||n.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(n,n.piece.length-1)===13}validateCRLFWithPrevNode(n){if(this.shouldCheckCRLF()&&this.startWithLF(n)){const s=n.prev();this.endWithCR(s)&&this.fixCRLF(s,n)}}validateCRLFWithNextNode(n){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const s=n.next();this.startWithLF(s)&&this.fixCRLF(n,s)}}fixCRLF(n,s){const i=[],t=this._buffers[n.piece.bufferIndex].lineStarts;let c;n.piece.end.column===0?c={line:n.piece.end.line-1,column:t[n.piece.end.line]-t[n.piece.end.line-1]-1}:c={line:n.piece.end.line,column:n.piece.end.column-1};const h=n.piece.length-1,o=n.piece.lineFeedCnt-1;n.piece=new T(n.piece.bufferIndex,n.piece.start,c,o,h),(0,L.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&i.push(n);const p={line:s.piece.start.line+1,column:0},_=s.piece.length-1,D=this.getLineFeedCnt(s.piece.bufferIndex,p,s.piece.end);s.piece=new T(s.piece.bufferIndex,p,s.piece.end,D,_),(0,L.updateTreeMetadata)(this,s,-1,-1),s.piece.length===0&&i.push(s);const C=this.createNewPieces(`\r
`);this.rbInsertRight(n,C[0]);for(let S=0;S<i.length;S++)(0,L.rbDelete)(this,i[S])}adjustCarriageReturnFromNext(n,s){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const i=s.next();if(this.startWithLF(i)){if(n+=`
`,i.piece.length===1)(0,L.rbDelete)(this,i);else{const t=i.piece,c={line:t.start.line+1,column:0},h=t.length-1,o=this.getLineFeedCnt(t.bufferIndex,c,t.end);i.piece=new T(t.bufferIndex,c,t.end,o,h),(0,L.updateTreeMetadata)(this,i,-1,-1)}return!0}}return!1}iterate(n,s){if(n===L.SENTINEL)return s(L.SENTINEL);const i=this.iterate(n.left,s);return i&&s(n)&&this.iterate(n.right,s)}getNodeContent(n){if(n===L.SENTINEL)return"";const s=this._buffers[n.piece.bufferIndex],i=n.piece,t=this.offsetInBuffer(i.bufferIndex,i.start),c=this.offsetInBuffer(i.bufferIndex,i.end);return s.buffer.substring(t,c)}getPieceContent(n){const s=this._buffers[n.bufferIndex],i=this.offsetInBuffer(n.bufferIndex,n.start),t=this.offsetInBuffer(n.bufferIndex,n.end);return s.buffer.substring(i,t)}rbInsertRight(n,s){const i=new L.TreeNode(s,L.NodeColor.Red);if(i.left=L.SENTINEL,i.right=L.SENTINEL,i.parent=L.SENTINEL,i.size_left=0,i.lf_left=0,this.root===L.SENTINEL)this.root=i,i.color=L.NodeColor.Black;else if(n.right===L.SENTINEL)n.right=i,i.parent=n;else{const c=(0,L.leftest)(n.right);c.left=i,i.parent=c}return(0,L.fixInsert)(this,i),i}rbInsertLeft(n,s){const i=new L.TreeNode(s,L.NodeColor.Red);if(i.left=L.SENTINEL,i.right=L.SENTINEL,i.parent=L.SENTINEL,i.size_left=0,i.lf_left=0,this.root===L.SENTINEL)this.root=i,i.color=L.NodeColor.Black;else if(n.left===L.SENTINEL)n.left=i,i.parent=n;else{const t=(0,L.righttest)(n.left);t.right=i,i.parent=t}return(0,L.fixInsert)(this,i),i}getContentOfSubTree(n){let s="";return this.iterate(n,i=>(s+=this.getNodeContent(i),!0)),s}}e.PieceTreeBase=f}),define(we[197],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class r{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(A){if(A&&this._dragOperations.has(A)){const L=this._dragOperations.get(A);return this._dragOperations.delete(A),L}}addDragOperationTransfer(A,L){this._dragOperations.set(A,L)}}e.TreeViewsDnDService=r;class g{constructor(A){this.identifier=A}}e.DraggedTreeItemsIdentifier=g}),define(we[198],ye([1,0,4,3,105]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class A{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(v){this._onDidChange.fire({changedLanguages:v,changedColorMap:!1})}register(v,l){return this._tokenizationSupports.set(v,l),this.handleChange([v]),(0,g.toDisposable)(()=>{this._tokenizationSupports.get(v)===l&&(this._tokenizationSupports.delete(v),this.handleChange([v]))})}get(v){return this._tokenizationSupports.get(v)||null}registerFactory(v,l){this._factories.get(v)?.dispose();const P=new L(this,v,l);return this._factories.set(v,P),(0,g.toDisposable)(()=>{const y=this._factories.get(v);!y||y!==P||(this._factories.delete(v),y.dispose())})}async getOrCreate(v){const l=this.get(v);if(l)return l;const P=this._factories.get(v);return!P||P.isResolved?null:(await P.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const P=this._factories.get(v);return!!(!P||P.isResolved)}setColorMap(v){this._colorMap=v,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>k.ColorId.DefaultBackground?this._colorMap[k.ColorId.DefaultBackground]:null}}e.TokenizationRegistry=A;class L extends g.Disposable{get isResolved(){return this._isResolved}constructor(v,l,P){super(),this._registry=v,this._languageId=l,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const v=await this._factory.tokenizationSupport;this._isResolved=!0,v&&!this._isDisposed&&this._register(this._registry.register(this._languageId,v))}}}),define(we[199],ye([7,8]),function(he,e){return he.create("vs/base/common/actions",e)}),define(we[200],ye([1,0,4,3,199]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=P;class A extends g.Disposable{constructor(d,T="",E="",a=!0,u){super(),this._onDidChange=this._register(new r.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=d,this._label=T,this._cssClass=E,this._enabled=a,this._actionCallback=u}get id(){return this._id}get label(){return this._label}set label(d){this._setLabel(d)}_setLabel(d){this._label!==d&&(this._label=d,this._onDidChange.fire({label:d}))}get tooltip(){return this._tooltip||""}set tooltip(d){this._setTooltip(d)}_setTooltip(d){this._tooltip!==d&&(this._tooltip=d,this._onDidChange.fire({tooltip:d}))}get class(){return this._cssClass}set class(d){this._setClass(d)}_setClass(d){this._cssClass!==d&&(this._cssClass=d,this._onDidChange.fire({class:d}))}get enabled(){return this._enabled}set enabled(d){this._setEnabled(d)}_setEnabled(d){this._enabled!==d&&(this._enabled=d,this._onDidChange.fire({enabled:d}))}get checked(){return this._checked}set checked(d){this._setChecked(d)}_setChecked(d){this._checked!==d&&(this._checked=d,this._onDidChange.fire({checked:d}))}async run(d,T){this._actionCallback&&await this._actionCallback(d)}}e.Action=A;class L extends g.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new r.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new r.Emitter),this.onDidRun=this._onDidRun.event}async run(d,T){if(!d.enabled)return;this._onWillRun.fire({action:d});let E;try{await this.runAction(d,T)}catch(a){E=a}this._onDidRun.fire({action:d,error:E})}async runAction(d,T){await d.run(T)}}e.ActionRunner=L;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...d){let T=[];for(const E of d)E.length&&(T.length?T=[...T,new R,...E]:T=E);return T}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=R;class v{get actions(){return this._actions}constructor(d,T,E,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=d,this.label=T,this.class=a,this._actions=E}async run(){}}e.SubmenuAction=v;class l extends A{static{this.ID="vs.actions.empty"}constructor(){super(l.ID,k.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=l;function P(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...d)=>y.run(...d)}}}),define(we[201],ye([7,8]),function(he,e){return he.create("vs/base/common/date",e)}),define(we[202],ye([1,0,201]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=l,e.getDurationString=P,e.toLocalISOString=y;const g=60,k=g*60,A=k*24,L=A*7,R=A*30,v=A*365;function l(d,T,E,a){typeof d!="number"&&(d=d.getTime());const u=Math.round((new Date().getTime()-d)/1e3);if(u<-30)return(0,r.localize)(0,null,l(new Date().getTime()+u*1e3,!1));if(!a&&u<30)return(0,r.localize)(1,null);let f;return u<g?(f=u,T?f===1?E?(0,r.localize)(2,null,f):(0,r.localize)(3,null,f):E?(0,r.localize)(4,null,f):(0,r.localize)(5,null,f):f===1?E?(0,r.localize)(6,null,f):(0,r.localize)(7,null,f):E?(0,r.localize)(8,null,f):(0,r.localize)(9,null,f)):u<k?(f=Math.floor(u/g),T?f===1?E?(0,r.localize)(10,null,f):(0,r.localize)(11,null,f):E?(0,r.localize)(12,null,f):(0,r.localize)(13,null,f):f===1?E?(0,r.localize)(14,null,f):(0,r.localize)(15,null,f):E?(0,r.localize)(16,null,f):(0,r.localize)(17,null,f)):u<A?(f=Math.floor(u/k),T?f===1?E?(0,r.localize)(18,null,f):(0,r.localize)(19,null,f):E?(0,r.localize)(20,null,f):(0,r.localize)(21,null,f):f===1?E?(0,r.localize)(22,null,f):(0,r.localize)(23,null,f):E?(0,r.localize)(24,null,f):(0,r.localize)(25,null,f)):u<L?(f=Math.floor(u/A),T?f===1?(0,r.localize)(26,null,f):(0,r.localize)(27,null,f):f===1?(0,r.localize)(28,null,f):(0,r.localize)(29,null,f)):u<R?(f=Math.floor(u/L),T?f===1?E?(0,r.localize)(30,null,f):(0,r.localize)(31,null,f):E?(0,r.localize)(32,null,f):(0,r.localize)(33,null,f):f===1?E?(0,r.localize)(34,null,f):(0,r.localize)(35,null,f):E?(0,r.localize)(36,null,f):(0,r.localize)(37,null,f)):u<v?(f=Math.floor(u/R),T?f===1?E?(0,r.localize)(38,null,f):(0,r.localize)(39,null,f):E?(0,r.localize)(40,null,f):(0,r.localize)(41,null,f):f===1?E?(0,r.localize)(42,null,f):(0,r.localize)(43,null,f):E?(0,r.localize)(44,null,f):(0,r.localize)(45,null,f)):(f=Math.floor(u/v),T?f===1?E?(0,r.localize)(46,null,f):(0,r.localize)(47,null,f):E?(0,r.localize)(48,null,f):(0,r.localize)(49,null,f):f===1?E?(0,r.localize)(50,null,f):(0,r.localize)(51,null,f):E?(0,r.localize)(52,null,f):(0,r.localize)(53,null,f))}function P(d,T){const E=Math.abs(d/1e3);return E<1?T?(0,r.localize)(54,null,d):(0,r.localize)(55,null,d):E<g?T?(0,r.localize)(56,null,Math.round(d)/1e3):(0,r.localize)(57,null,Math.round(d)/1e3):E<k?T?(0,r.localize)(58,null,Math.round(d/(1e3*g))):(0,r.localize)(59,null,Math.round(d/(1e3*g))):E<A?T?(0,r.localize)(60,null,Math.round(d/(1e3*k))):(0,r.localize)(61,null,Math.round(d/(1e3*k))):(0,r.localize)(62,null,Math.round(d/(1e3*A)))}function y(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(we[203],ye([7,8]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(we[51],ye([1,0,19,18,203]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=v,e.isErrorWithActions=l,e.createErrorWithActions=P;function A(y,d){return d&&(y.stack||y.stacktrace)?k.localize(0,null,R(y),L(y.stack)||L(y.stacktrace)):R(y)}function L(y){return Array.isArray(y)?y.join(`
`):y}function R(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?k.localize(1,null,y.message):y.message||k.localize(2,null)}function v(y=null,d=!1){if(!y)return k.localize(3,null);if(Array.isArray(y)){const T=r.coalesce(y),E=v(T[0],d);return T.length>1?k.localize(4,null,E,T.length):E}if(g.isString(y))return y;if(y.detail){const T=y.detail;if(T.error)return A(T.error,d);if(T.exception)return A(T.exception,d)}return y.stack?A(y,d):y.message?y.message:k.localize(5,null)}function l(y){const d=y;return d instanceof Error&&Array.isArray(d.actions)}function P(y,d){let T;return typeof y=="string"?T=new Error(y):T=y,T.actions=d,T}}),define(we[204],ye([7,8]),function(he,e){return he.create("vs/base/common/platform",e)}),define(we[11],ye([1,0,204]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=c,e.isLittleEndian=C,e.isBigSurOrNewer=S,e.LANGUAGE_DEFAULT="en";let g=!1,k=!1,A=!1,L=!1,R=!1,v=!1,l=!1,P=!1,y=!1,d=!1,T,E=e.LANGUAGE_DEFAULT,a=e.LANGUAGE_DEFAULT,u,f;const m=globalThis;let n;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?n=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const s=typeof n?.versions?.electron=="string",i=s&&n?.type==="renderer";if(typeof n=="object"){g=n.platform==="win32",k=n.platform==="darwin",A=n.platform==="linux",L=A&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,l=s,y=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT;const I=n.env.VSCODE_NLS_CONFIG;if(I)try{const b=JSON.parse(I),w=b.availableLanguages["*"];T=b.locale,a=b.osLocale,E=w||e.LANGUAGE_DEFAULT,u=b._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!i?(f=navigator.userAgent,g=f.indexOf("Windows")>=0,k=f.indexOf("Macintosh")>=0,P=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=f.indexOf("Linux")>=0,d=f?.indexOf("Mobi")>=0,v=!0,T=r.getConfiguredDefaultLocale(r.localize(0,null))||e.LANGUAGE_DEFAULT,E=T,a=navigator.language):console.error("Unable to resolve platform.");var t;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(t||(e.Platform=t={}));function c(I){switch(I){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let h=t.Web;k?h=t.Mac:g?h=t.Windows:A&&(h=t.Linux),e.isWindows=g,e.isMacintosh=k,e.isLinux=A,e.isLinuxSnap=L,e.isNative=R,e.isElectron=l,e.isWeb=v,e.isWebWorker=v&&typeof m.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?m.origin:void 0,e.isIOS=P,e.isMobile=d,e.isCI=y,e.platform=h,e.userAgent=f,e.language=E;var o;(function(I){function b(){return e.language}I.value=b;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}I.isDefaultVariant=w;function N(){return e.language==="en"}I.isDefault=N})(o||(e.Language=o={})),e.locale=T,e.platformLocale=a,e.translationsConfigFile=u,e.setTimeout0IsFaster=typeof m.postMessage=="function"&&!m.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const I=[];m.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let N=0,O=I.length;N<O;N++){const U=I[N];if(U.id===w.data.vscodeScheduleAsyncWork){I.splice(N,1),U.callback();return}}});let b=0;return w=>{const N=++b;I.push({id:N,callback:w}),m.postMessage({vscodeScheduleAsyncWork:N},"*")}}return I=>setTimeout(I)})();var p;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(p||(e.OperatingSystem=p={})),e.OS=k||P?p.Macintosh:g?p.Windows:p.Linux;let _=!0,D=!1;function C(){if(!D){D=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,_=new Uint16Array(I.buffer)[0]===513}return _}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function S(I){return parseFloat(I)>=20}}),define(we[56],ye([1,0,11]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let g;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.process<"u"){const A=k.process;g={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?g={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:g={get platform(){return r.isWindows?"win32":r.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=g.cwd,e.env=g.env,e.platform=g.platform,e.arch=g.arch}),define(we[16],ye([1,0,56]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const g=65,k=97,A=90,L=122,R=46,v=47,l=92,P=58,y=63;class d extends Error{constructor(c,h,o){let p;typeof h=="string"&&h.indexOf("not ")===0?(p="must not be",h=h.replace(/^not /,"")):p="must be";const _=c.indexOf(".")!==-1?"property":"argument";let D=`The "${c}" ${_} ${p} of type ${h}`;D+=`. Received type ${typeof o}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function T(t,c){if(t===null||typeof t!="object")throw new d(c,"Object",t)}function E(t,c){if(typeof t!="string")throw new d(c,"string",t)}const a=r.platform==="win32";function u(t){return t===v||t===l}function f(t){return t===v}function m(t){return t>=g&&t<=A||t>=k&&t<=L}function n(t,c,h,o){let p="",_=0,D=-1,C=0,S=0;for(let I=0;I<=t.length;++I){if(I<t.length)S=t.charCodeAt(I);else{if(o(S))break;S=v}if(o(S)){if(!(D===I-1||C===1))if(C===2){if(p.length<2||_!==2||p.charCodeAt(p.length-1)!==R||p.charCodeAt(p.length-2)!==R){if(p.length>2){const b=p.lastIndexOf(h);b===-1?(p="",_=0):(p=p.slice(0,b),_=p.length-1-p.lastIndexOf(h)),D=I,C=0;continue}else if(p.length!==0){p="",_=0,D=I,C=0;continue}}c&&(p+=p.length>0?`${h}..`:"..",_=2)}else p.length>0?p+=`${h}${t.slice(D+1,I)}`:p=t.slice(D+1,I),_=I-D-1;D=I,C=0}else S===R&&C!==-1?++C:C=-1}return p}function s(t,c){T(c,"pathObject");const h=c.dir||c.root,o=c.base||`${c.name||""}${c.ext||""}`;return h?h===c.root?`${h}${o}`:`${h}${t}${o}`:o}e.win32={resolve(...t){let c="",h="",o=!1;for(let p=t.length-1;p>=-1;p--){let _;if(p>=0){if(_=t[p],E(_,"path"),_.length===0)continue}else c.length===0?_=r.cwd():(_=r.env[`=${c}`]||r.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==c.toLowerCase()&&_.charCodeAt(2)===l)&&(_=`${c}\\`));const D=_.length;let C=0,S="",I=!1;const b=_.charCodeAt(0);if(D===1)u(b)&&(C=1,I=!0);else if(u(b))if(I=!0,u(_.charCodeAt(1))){let w=2,N=w;for(;w<D&&!u(_.charCodeAt(w));)w++;if(w<D&&w!==N){const O=_.slice(N,w);for(N=w;w<D&&u(_.charCodeAt(w));)w++;if(w<D&&w!==N){for(N=w;w<D&&!u(_.charCodeAt(w));)w++;(w===D||w!==N)&&(S=`\\\\${O}\\${_.slice(N,w)}`,C=w)}}}else C=1;else m(b)&&_.charCodeAt(1)===P&&(S=_.slice(0,2),C=2,D>2&&u(_.charCodeAt(2))&&(I=!0,C=3));if(S.length>0)if(c.length>0){if(S.toLowerCase()!==c.toLowerCase())continue}else c=S;if(o){if(c.length>0)break}else if(h=`${_.slice(C)}\\${h}`,o=I,I&&c.length>0)break}return h=n(h,!o,"\\",u),o?`${c}\\${h}`:`${c}${h}`||"."},normalize(t){E(t,"path");const c=t.length;if(c===0)return".";let h=0,o,p=!1;const _=t.charCodeAt(0);if(c===1)return f(_)?"\\":t;if(u(_))if(p=!0,u(t.charCodeAt(1))){let C=2,S=C;for(;C<c&&!u(t.charCodeAt(C));)C++;if(C<c&&C!==S){const I=t.slice(S,C);for(S=C;C<c&&u(t.charCodeAt(C));)C++;if(C<c&&C!==S){for(S=C;C<c&&!u(t.charCodeAt(C));)C++;if(C===c)return`\\\\${I}\\${t.slice(S)}\\`;C!==S&&(o=`\\\\${I}\\${t.slice(S,C)}`,h=C)}}}else h=1;else m(_)&&t.charCodeAt(1)===P&&(o=t.slice(0,2),h=2,c>2&&u(t.charCodeAt(2))&&(p=!0,h=3));let D=h<c?n(t.slice(h),!p,"\\",u):"";return D.length===0&&!p&&(D="."),D.length>0&&u(t.charCodeAt(c-1))&&(D+="\\"),o===void 0?p?`\\${D}`:D:p?`${o}\\${D}`:`${o}${D}`},isAbsolute(t){E(t,"path");const c=t.length;if(c===0)return!1;const h=t.charCodeAt(0);return u(h)||c>2&&m(h)&&t.charCodeAt(1)===P&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,h;for(let _=0;_<t.length;++_){const D=t[_];E(D,"path"),D.length>0&&(c===void 0?c=h=D:c+=`\\${D}`)}if(c===void 0)return".";let o=!0,p=0;if(typeof h=="string"&&u(h.charCodeAt(0))){++p;const _=h.length;_>1&&u(h.charCodeAt(1))&&(++p,_>2&&(u(h.charCodeAt(2))?++p:o=!1))}if(o){for(;p<c.length&&u(c.charCodeAt(p));)p++;p>=2&&(c=`\\${c.slice(p)}`)}return e.win32.normalize(c)},relative(t,c){if(E(t,"from"),E(c,"to"),t===c)return"";const h=e.win32.resolve(t),o=e.win32.resolve(c);if(h===o||(t=h.toLowerCase(),c=o.toLowerCase(),t===c))return"";let p=0;for(;p<t.length&&t.charCodeAt(p)===l;)p++;let _=t.length;for(;_-1>p&&t.charCodeAt(_-1)===l;)_--;const D=_-p;let C=0;for(;C<c.length&&c.charCodeAt(C)===l;)C++;let S=c.length;for(;S-1>C&&c.charCodeAt(S-1)===l;)S--;const I=S-C,b=D<I?D:I;let w=-1,N=0;for(;N<b;N++){const U=t.charCodeAt(p+N);if(U!==c.charCodeAt(C+N))break;U===l&&(w=N)}if(N!==b){if(w===-1)return o}else{if(I>b){if(c.charCodeAt(C+N)===l)return o.slice(C+N+1);if(N===2)return o.slice(C+N)}D>b&&(t.charCodeAt(p+N)===l?w=N:N===2&&(w=3)),w===-1&&(w=0)}let O="";for(N=p+w+1;N<=_;++N)(N===_||t.charCodeAt(N)===l)&&(O+=O.length===0?"..":"\\..");return C+=w,O.length>0?`${O}${o.slice(C,S)}`:(o.charCodeAt(C)===l&&++C,o.slice(C,S))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.win32.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===l){if(c.charCodeAt(1)===l){const h=c.charCodeAt(2);if(h!==y&&h!==R)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(m(c.charCodeAt(0))&&c.charCodeAt(1)===P&&c.charCodeAt(2)===l)return`\\\\?\\${c}`;return t},dirname(t){E(t,"path");const c=t.length;if(c===0)return".";let h=-1,o=0;const p=t.charCodeAt(0);if(c===1)return u(p)?t:".";if(u(p)){if(h=o=1,u(t.charCodeAt(1))){let C=2,S=C;for(;C<c&&!u(t.charCodeAt(C));)C++;if(C<c&&C!==S){for(S=C;C<c&&u(t.charCodeAt(C));)C++;if(C<c&&C!==S){for(S=C;C<c&&!u(t.charCodeAt(C));)C++;if(C===c)return t;C!==S&&(h=o=C+1)}}}}else m(p)&&t.charCodeAt(1)===P&&(h=c>2&&u(t.charCodeAt(2))?3:2,o=h);let _=-1,D=!0;for(let C=c-1;C>=o;--C)if(u(t.charCodeAt(C))){if(!D){_=C;break}}else D=!1;if(_===-1){if(h===-1)return".";_=h}return t.slice(0,_)},basename(t,c){c!==void 0&&E(c,"ext"),E(t,"path");let h=0,o=-1,p=!0,_;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(h=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let D=c.length-1,C=-1;for(_=t.length-1;_>=h;--_){const S=t.charCodeAt(_);if(u(S)){if(!p){h=_+1;break}}else C===-1&&(p=!1,C=_+1),D>=0&&(S===c.charCodeAt(D)?--D===-1&&(o=_):(D=-1,o=C))}return h===o?o=C:o===-1&&(o=t.length),t.slice(h,o)}for(_=t.length-1;_>=h;--_)if(u(t.charCodeAt(_))){if(!p){h=_+1;break}}else o===-1&&(p=!1,o=_+1);return o===-1?"":t.slice(h,o)},extname(t){E(t,"path");let c=0,h=-1,o=0,p=-1,_=!0,D=0;t.length>=2&&t.charCodeAt(1)===P&&m(t.charCodeAt(0))&&(c=o=2);for(let C=t.length-1;C>=c;--C){const S=t.charCodeAt(C);if(u(S)){if(!_){o=C+1;break}continue}p===-1&&(_=!1,p=C+1),S===R?h===-1?h=C:D!==1&&(D=1):h!==-1&&(D=-1)}return h===-1||p===-1||D===0||D===1&&h===p-1&&h===o+1?"":t.slice(h,p)},format:s.bind(null,"\\"),parse(t){E(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const h=t.length;let o=0,p=t.charCodeAt(0);if(h===1)return u(p)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(u(p)){if(o=1,u(t.charCodeAt(1))){let w=2,N=w;for(;w<h&&!u(t.charCodeAt(w));)w++;if(w<h&&w!==N){for(N=w;w<h&&u(t.charCodeAt(w));)w++;if(w<h&&w!==N){for(N=w;w<h&&!u(t.charCodeAt(w));)w++;w===h?o=w:w!==N&&(o=w+1)}}}}else if(m(p)&&t.charCodeAt(1)===P){if(h<=2)return c.root=c.dir=t,c;if(o=2,u(t.charCodeAt(2))){if(h===3)return c.root=c.dir=t,c;o=3}}o>0&&(c.root=t.slice(0,o));let _=-1,D=o,C=-1,S=!0,I=t.length-1,b=0;for(;I>=o;--I){if(p=t.charCodeAt(I),u(p)){if(!S){D=I+1;break}continue}C===-1&&(S=!1,C=I+1),p===R?_===-1?_=I:b!==1&&(b=1):_!==-1&&(b=-1)}return C!==-1&&(_===-1||b===0||b===1&&_===C-1&&_===D+1?c.base=c.name=t.slice(D,C):(c.name=t.slice(D,_),c.base=t.slice(D,C),c.ext=t.slice(_,C))),D>0&&D!==o?c.dir=t.slice(0,D-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(a){const t=/\\/g;return()=>{const c=r.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>r.cwd()})();e.posix={resolve(...t){let c="",h=!1;for(let o=t.length-1;o>=-1&&!h;o--){const p=o>=0?t[o]:i();E(p,"path"),p.length!==0&&(c=`${p}/${c}`,h=p.charCodeAt(0)===v)}return c=n(c,!h,"/",f),h?`/${c}`:c.length>0?c:"."},normalize(t){if(E(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===v,h=t.charCodeAt(t.length-1)===v;return t=n(t,!c,"/",f),t.length===0?c?"/":h?"./":".":(h&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return E(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let c;for(let h=0;h<t.length;++h){const o=t[h];E(o,"path"),o.length>0&&(c===void 0?c=o:c+=`/${o}`)}return c===void 0?".":e.posix.normalize(c)},relative(t,c){if(E(t,"from"),E(c,"to"),t===c||(t=e.posix.resolve(t),c=e.posix.resolve(c),t===c))return"";const h=1,o=t.length,p=o-h,_=1,D=c.length-_,C=p<D?p:D;let S=-1,I=0;for(;I<C;I++){const w=t.charCodeAt(h+I);if(w!==c.charCodeAt(_+I))break;w===v&&(S=I)}if(I===C)if(D>C){if(c.charCodeAt(_+I)===v)return c.slice(_+I+1);if(I===0)return c.slice(_+I)}else p>C&&(t.charCodeAt(h+I)===v?S=I:I===0&&(S=0));let b="";for(I=h+S+1;I<=o;++I)(I===o||t.charCodeAt(I)===v)&&(b+=b.length===0?"..":"/..");return`${b}${c.slice(_+S)}`},toNamespacedPath(t){return t},dirname(t){if(E(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===v;let h=-1,o=!0;for(let p=t.length-1;p>=1;--p)if(t.charCodeAt(p)===v){if(!o){h=p;break}}else o=!1;return h===-1?c?"/":".":c&&h===1?"//":t.slice(0,h)},basename(t,c){c!==void 0&&E(c,"ext"),E(t,"path");let h=0,o=-1,p=!0,_;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let D=c.length-1,C=-1;for(_=t.length-1;_>=0;--_){const S=t.charCodeAt(_);if(S===v){if(!p){h=_+1;break}}else C===-1&&(p=!1,C=_+1),D>=0&&(S===c.charCodeAt(D)?--D===-1&&(o=_):(D=-1,o=C))}return h===o?o=C:o===-1&&(o=t.length),t.slice(h,o)}for(_=t.length-1;_>=0;--_)if(t.charCodeAt(_)===v){if(!p){h=_+1;break}}else o===-1&&(p=!1,o=_+1);return o===-1?"":t.slice(h,o)},extname(t){E(t,"path");let c=-1,h=0,o=-1,p=!0,_=0;for(let D=t.length-1;D>=0;--D){const C=t.charCodeAt(D);if(C===v){if(!p){h=D+1;break}continue}o===-1&&(p=!1,o=D+1),C===R?c===-1?c=D:_!==1&&(_=1):c!==-1&&(_=-1)}return c===-1||o===-1||_===0||_===1&&c===o-1&&c===h+1?"":t.slice(c,o)},format:s.bind(null,"/"),parse(t){E(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const h=t.charCodeAt(0)===v;let o;h?(c.root="/",o=1):o=0;let p=-1,_=0,D=-1,C=!0,S=t.length-1,I=0;for(;S>=o;--S){const b=t.charCodeAt(S);if(b===v){if(!C){_=S+1;break}continue}D===-1&&(C=!1,D=S+1),b===R?p===-1?p=S:I!==1&&(I=1):p!==-1&&(I=-1)}if(D!==-1){const b=_===0&&h?1:_;p===-1||I===0||I===1&&p===D-1&&p===_+1?c.base=c.name=t.slice(b,D):(c.name=t.slice(b,p),c.base=t.slice(b,D),c.ext=t.slice(p,D))}return _>0?c.dir=t.slice(0,_-1):h&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=a?e.win32.normalize:e.posix.normalize,e.isAbsolute=a?e.win32.isAbsolute:e.posix.isAbsolute,e.join=a?e.win32.join:e.posix.join,e.resolve=a?e.win32.resolve:e.posix.resolve,e.relative=a?e.win32.relative:e.posix.relative,e.dirname=a?e.win32.dirname:e.posix.dirname,e.basename=a?e.win32.basename:e.posix.basename,e.extname=a?e.win32.extname:e.posix.extname,e.format=a?e.win32.format:e.posix.format,e.parse=a?e.win32.parse:e.posix.parse,e.toNamespacedPath=a?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=a?e.win32.sep:e.posix.sep,e.delimiter=a?e.win32.delimiter:e.posix.delimiter}),define(we[139],ye([1,0,49,16]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=R,e.compareFileNamesDefault=v,e.compareFileNamesUpper=l,e.compareFileNamesLower=P,e.compareFileNamesUnicode=y,e.compareFileExtensions=d,e.compareFileExtensionsDefault=T,e.compareFileExtensionsUpper=E,e.compareFileExtensionsLower=a,e.compareFileExtensionsUnicode=u,e.comparePaths=p,e.compareAnything=_,e.compareByPrefix=D;const k=new r.Lazy(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),A=new r.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new r.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(C,S,I=!1){const b=C||"",w=S||"",N=k.value.collator.compare(b,w);return k.value.collatorIsNumeric&&N===0&&b!==w?b<w?-1:1:N}function v(C,S){const I=A.value.collator;return C=C||"",S=S||"",s(I,C,S)}function l(C,S){const I=A.value.collator;return C=C||"",S=S||"",h(C,S)||s(I,C,S)}function P(C,S){const I=A.value.collator;return C=C||"",S=S||"",c(C,S)||s(I,C,S)}function y(C,S){return C=C||"",S=S||"",C===S?0:C<S?-1:1}function d(C,S){const[I,b]=m(C),[w,N]=m(S);let O=k.value.collator.compare(b,N);if(O===0){if(k.value.collatorIsNumeric&&b!==N)return b<N?-1:1;if(O=k.value.collator.compare(I,w),k.value.collatorIsNumeric&&O===0&&I!==w)return I<w?-1:1}return O}function T(C,S){C=C||"",S=S||"";const I=n(C),b=n(S),w=A.value.collator,N=L.value.collator;return s(N,I,b)||s(w,C,S)}function E(C,S){C=C||"",S=S||"";const I=n(C),b=n(S),w=A.value.collator,N=L.value.collator;return s(N,I,b)||h(C,S)||s(w,C,S)}function a(C,S){C=C||"",S=S||"";const I=n(C),b=n(S),w=A.value.collator,N=L.value.collator;return s(N,I,b)||c(C,S)||s(w,C,S)}function u(C,S){C=C||"",S=S||"";const I=n(C).toLowerCase(),b=n(S).toLowerCase();return I!==b?I<b?-1:1:C!==S?C<S?-1:1:0}const f=/^(.*?)(\.([^.]*))?$/;function m(C,S=!1){const I=C?f.exec(C):[];let b=[I&&I[1]||"",I&&I[3]||""];return S&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function n(C){const S=C?f.exec(C):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function s(C,S,I){const b=C.compare(S,I);return b!==0?b:S.length!==I.length?S.length<I.length?-1:1:0}function i(C){const S=C.charAt(0);return S.toLocaleUpperCase()!==S}function t(C){const S=C.charAt(0);return S.toLocaleLowerCase()!==S}function c(C,S){return i(C)&&t(S)?-1:t(C)&&i(S)?1:0}function h(C,S){return t(C)&&i(S)?-1:i(C)&&t(S)?1:0}function o(C,S,I=!1){return I||(C=C&&C.toLowerCase(),S=S&&S.toLowerCase()),C===S?0:C<S?-1:1}function p(C,S,I=!1){const b=C.split(g.sep),w=S.split(g.sep),N=b.length-1,O=w.length-1;let U,x;for(let B=0;;B++){if(U=N===B,x=O===B,U&&x)return R(b[B],w[B],I);if(U)return-1;if(x)return 1;const F=o(b[B],w[B],I);if(F!==0)return F}}function _(C,S,I){const b=C.toLowerCase(),w=S.toLowerCase(),N=D(C,S,I);if(N)return N;const O=b.endsWith(I),U=w.endsWith(I);if(O!==U)return O?-1:1;const x=R(b,w);return x!==0?x:b.localeCompare(w)}function D(C,S,I){const b=C.toLowerCase(),w=S.toLowerCase(),N=b.startsWith(I),O=w.startsWith(I);if(N!==O)return N?-1:1;if(N&&O){if(b.length<w.length)return-1;if(b.length>w.length)return 1}return 0}}),define(we[33],ye([1,0,27,16,11,13,18]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=v,e.toPosixPath=l,e.getRoot=P,e.isUNC=y,e.isValidBasename=a,e.isEqual=u,e.isEqualOrParent=f,e.isWindowsDriveLetter=m,e.sanitizeFilePath=n,e.removeTrailingPathSeparator=s,e.isRootOrDriveLetter=i,e.hasDriveLetter=t,e.getDriveLetter=c,e.indexOfPath=h,e.parseLineAndColumnAware=o,e.randomPath=D;function R(C){return C===r.CharCode.Slash||C===r.CharCode.Backslash}function v(C){return C.replace(/[\\/]/g,g.posix.sep)}function l(C){return C.indexOf("/")===-1&&(C=v(C)),/^[a-zA-Z]:(\/|$)/.test(C)&&(C="/"+C),C}function P(C,S=g.posix.sep){if(!C)return"";const I=C.length,b=C.charCodeAt(0);if(R(b)){if(R(C.charCodeAt(1))&&!R(C.charCodeAt(2))){let N=3;const O=N;for(;N<I&&!R(C.charCodeAt(N));N++);if(O!==N&&!R(C.charCodeAt(N+1))){for(N+=1;N<I;N++)if(R(C.charCodeAt(N)))return C.slice(0,N+1).replace(/[\\/]/g,S)}}return S}else if(m(b)&&C.charCodeAt(1)===r.CharCode.Colon)return R(C.charCodeAt(2))?C.slice(0,2)+S:C.slice(0,2);let w=C.indexOf("://");if(w!==-1){for(w+=3;w<I;w++)if(R(C.charCodeAt(w)))return C.slice(0,w+1)}return""}function y(C){if(!k.isWindows||!C||C.length<5)return!1;let S=C.charCodeAt(0);if(S!==r.CharCode.Backslash||(S=C.charCodeAt(1),S!==r.CharCode.Backslash))return!1;let I=2;const b=I;for(;I<C.length&&(S=C.charCodeAt(I),S!==r.CharCode.Backslash);I++);return!(b===I||(S=C.charCodeAt(I+1),isNaN(S)||S===r.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,T=/[/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(C,S=k.isWindows){const I=S?d:T;return!(!C||C.length===0||/^\s+$/.test(C)||(I.lastIndex=0,I.test(C))||S&&E.test(C)||C==="."||C===".."||S&&C[C.length-1]==="."||S&&C.length!==C.trim().length||C.length>255)}function u(C,S,I){const b=C===S;return!I||b?b:!C||!S?!1:(0,A.equalsIgnoreCase)(C,S)}function f(C,S,I,b=g.sep){if(C===S)return!0;if(!C||!S||S.length>C.length)return!1;if(I){if(!(0,A.startsWithIgnoreCase)(C,S))return!1;if(S.length===C.length)return!0;let N=S.length;return S.charAt(S.length-1)===b&&N--,C.charAt(N)===b}return S.charAt(S.length-1)!==b&&(S+=b),C.indexOf(S)===0}function m(C){return C>=r.CharCode.A&&C<=r.CharCode.Z||C>=r.CharCode.a&&C<=r.CharCode.z}function n(C,S){return k.isWindows&&C.endsWith(":")&&(C+=g.sep),(0,g.isAbsolute)(C)||(C=(0,g.join)(S,C)),C=(0,g.normalize)(C),s(C)}function s(C){return k.isWindows?(C=(0,A.rtrim)(C,g.sep),C.endsWith(":")&&(C+=g.sep)):(C=(0,A.rtrim)(C,g.sep),C||(C=g.sep)),C}function i(C){const S=(0,g.normalize)(C);return k.isWindows?C.length>3?!1:t(S)&&(C.length===2||S.charCodeAt(2)===r.CharCode.Backslash):S===g.posix.sep}function t(C,S=k.isWindows){return S?m(C.charCodeAt(0))&&C.charCodeAt(1)===r.CharCode.Colon:!1}function c(C,S=k.isWindows){return t(C,S)?C[0]:void 0}function h(C,S,I){return S.length>C.length?-1:C===S?0:(I&&(C=C.toLowerCase(),S=S.toLowerCase()),C.indexOf(S))}function o(C){const S=C.split(":");let I,b,w;for(const N of S){const O=Number(N);(0,L.isNumber)(O)?b===void 0?b=O:w===void 0&&(w=O):I=I?[I,N].join(":"):N}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:b!==void 0?b:void 0,column:w!==void 0?w:b!==void 0?1:void 0}}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",_="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(C,S,I=8){let b="";for(let N=0;N<I;N++){let O;N===0&&k.isWindows&&!S&&(I===3||I===4)?O=_:O=p,b+=O.charAt(Math.floor(Math.random()*O.length))}let w;return S?w=`${S}-${b}`:w=b,C?(0,g.join)(C,w):w}}),define(we[140],ye([1,0,27,139,134,61,16,11,13]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.scoreFuzzy=y,e.scoreFuzzy2=f,e.scoreItemFuzzy=o,e.compareItemsByFuzzyScore=b,e.prepareQuery=B,e.pieceToQuery=M;const l=0,P=[l,[]];function y(K,ee,$,q){if(!K||!ee)return P;const Z=K.length,ne=ee.length;if(Z<ne)return P;const de=K.toLowerCase();return d(ee,$,ne,K,de,Z,q)}function d(K,ee,$,q,Z,ne,de){const re=[],Se=[];for(let se=0;se<$;se++){const ae=se*ne,ie=ae-ne,le=se>0,ue=K[se],Y=ee[se];for(let oe=0;oe<ne;oe++){const pe=oe>0,Ee=ae+oe,Ne=Ee-1,We=ie+oe-1,Ce=pe?re[Ne]:0,Ie=le&&pe?re[We]:0,Le=le&&pe?Se[We]:0;let z;!Ie&&le?z=0:z=T(ue,Y,q,Z,oe,Le),z&&Ie+z>=Ce&&(de||le||Z.startsWith(ee,oe))?(Se[Ee]=Le+1,re[Ee]=Ie+z):(Se[Ee]=l,re[Ee]=Ce)}}const ve=[];let G=$-1,W=ne-1;for(;G>=0&&W>=0;){const se=G*ne+W;Se[se]===l||(ve.push(W),G--),W--}return[re[$*ne-1],ve.reverse()]}function T(K,ee,$,q,Z,ne){let de=0;if(!E(ee,q[Z]))return de;if(de+=1,ne>0&&(de+=ne*5),K===$[Z]&&(de+=1),Z===0)de+=8;else{const re=a($.charCodeAt(Z-1));re?de+=re:(0,k.isUpper)($.charCodeAt(Z))&&ne===0&&(de+=2)}return de}function E(K,ee){return K===ee?!0:K==="/"||K==="\\"?ee==="/"||ee==="\\":!1}function a(K){switch(K){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const u=[void 0,[]];function f(K,ee,$=0,q=0){const Z=ee;return Z.values&&Z.values.length>1?m(K,Z.values,$,q):n(K,ee,$,q)}function m(K,ee,$,q){let Z=0;const ne=[];for(const de of ee){const[re,Se]=n(K,de,$,q);if(typeof re!="number")return u;Z+=re,ne.push(...Se)}return[Z,S(ne)]}function n(K,ee,$,q){const Z=(0,k.fuzzyScore)(ee.original,ee.originalLowercase,$,K,K.toLowerCase(),q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?[Z[0],(0,k.createMatches)(Z)]:u}const s=Object.freeze({score:0}),i=1<<18,t=1<<17,c=65536;function h(K,ee,$,q){const Z=q.values?q.values:[q];return(0,A.hash)({[q.normalized]:{values:Z.map(de=>({value:de.normalized,expectContiguousMatch:de.expectContiguousMatch})),label:K,description:ee,allowNonContiguousMatches:$}})}function o(K,ee,$,q,Z){if(!K||!ee.normalized)return s;const ne=q.getItemLabel(K);if(!ne)return s;const de=q.getItemDescription(K),re=h(ne,de,$,ee),Se=Z[re];if(Se)return Se;const ve=p(ne,de,q.getItemPath(K),ee,$);return Z[re]=ve,ve}function p(K,ee,$,q,Z){const ne=!$||!q.containsPathSeparator;return $&&(R.isLinux?q.pathNormalized===$:(0,v.equalsIgnoreCase)(q.pathNormalized,$))?{score:i,labelMatch:[{start:0,end:K.length}],descriptionMatch:ee?[{start:0,end:ee.length}]:void 0}:q.values&&q.values.length>1?_(K,ee,$,q.values,ne,Z):D(K,ee,$,q,ne,Z)}function _(K,ee,$,q,Z,ne){let de=0;const re=[],Se=[];for(const ve of q){const{score:G,labelMatch:W,descriptionMatch:se}=D(K,ee,$,ve,Z,ne);if(G===l)return s;de+=G,W&&re.push(...W),se&&Se.push(...se)}return{score:de,labelMatch:S(re),descriptionMatch:S(Se)}}function D(K,ee,$,q,Z,ne){if(Z||!ee){const[de,re]=y(K,q.normalized,q.normalizedLowercase,ne&&!q.expectContiguousMatch);if(de){const Se=(0,k.matchesPrefix)(q.normalized,K);let ve;if(Se){ve=t;const G=Math.round(q.normalized.length/K.length*100);ve+=G}else ve=c;return{score:ve+de,labelMatch:Se||C(re)}}}if(ee){let de=ee;$&&(de=`${ee}${L.sep}`);const re=de.length,Se=`${de}${K}`,[ve,G]=y(Se,q.normalized,q.normalizedLowercase,ne&&!q.expectContiguousMatch);if(ve){const W=C(G),se=[],ae=[];return W.forEach(ie=>{ie.start<re&&ie.end>re?(se.push({start:0,end:ie.end-re}),ae.push({start:ie.start,end:re})):ie.start>=re?se.push({start:ie.start-re,end:ie.end-re}):ae.push(ie)}),{score:ve,labelMatch:se,descriptionMatch:ae}}}return s}function C(K){const ee=[];if(!K)return ee;let $;for(const q of K)$&&$.end===q?$.end+=1:($={start:q,end:q+1},ee.push($));return ee}function S(K){const ee=K.sort((Z,ne)=>Z.start-ne.start),$=[];let q;for(const Z of ee)!q||!I(q,Z)?(q=Z,$.push(Z)):(q.start=Math.min(q.start,Z.start),q.end=Math.max(q.end,Z.end));return $}function I(K,ee){return!(K.end<ee.start||ee.end<K.start)}function b(K,ee,$,q,Z,ne){const de=o(K,$,q,Z,ne),re=o(ee,$,q,Z,ne),Se=de.score,ve=re.score;if((Se===i||ve===i)&&Se!==ve)return Se===i?-1:1;if(Se>c||ve>c){if(Se!==ve)return Se>ve?-1:1;if(Se<t&&ve<t){const ue=N(de.labelMatch,re.labelMatch);if(ue!==0)return ue}const ie=Z.getItemLabel(K)||"",le=Z.getItemLabel(ee)||"";if(ie.length!==le.length)return ie.length-le.length}if(Se!==ve)return Se>ve?-1:1;const G=Array.isArray(de.labelMatch)&&de.labelMatch.length>0,W=Array.isArray(re.labelMatch)&&re.labelMatch.length>0;if(G&&!W)return-1;if(W&&!G)return 1;const se=w(K,de,Z),ae=w(ee,re,Z);return se&&ae&&se!==ae?ae>se?-1:1:O(K,ee,$,Z)}function w(K,ee,$){let q=-1,Z=-1;if(ee.descriptionMatch&&ee.descriptionMatch.length?q=ee.descriptionMatch[0].start:ee.labelMatch&&ee.labelMatch.length&&(q=ee.labelMatch[0].start),ee.labelMatch&&ee.labelMatch.length){if(Z=ee.labelMatch[ee.labelMatch.length-1].end,ee.descriptionMatch&&ee.descriptionMatch.length){const ne=$.getItemDescription(K);ne&&(Z+=ne.length)}}else ee.descriptionMatch&&ee.descriptionMatch.length&&(Z=ee.descriptionMatch[ee.descriptionMatch.length-1].end);return Z-q}function N(K,ee){if(!K&&!ee||(!K||!K.length)&&(!ee||!ee.length))return 0;if(!ee||!ee.length)return-1;if(!K||!K.length)return 1;const $=K[0].start,Z=K[K.length-1].end-$,ne=ee[0].start,re=ee[ee.length-1].end-ne;return Z===re?0:re<Z?1:-1}function O(K,ee,$,q){const Z=q.getItemLabel(K)||"",ne=q.getItemLabel(ee)||"",de=q.getItemDescription(K),re=q.getItemDescription(ee),Se=Z.length+(de?de.length:0),ve=ne.length+(re?re.length:0);if(Se!==ve)return Se-ve;const G=q.getItemPath(K),W=q.getItemPath(ee);return G&&W&&G.length!==W.length?G.length-W.length:Z!==ne?(0,g.compareAnything)(Z,ne,$.normalized):de&&re&&de!==re?(0,g.compareAnything)(de,re,$.normalized):G&&W&&G!==W?(0,g.compareAnything)(G,W,$.normalized):0}function U(K){return K.startsWith('"')&&K.endsWith('"')}const x=" ";function B(K){typeof K!="string"&&(K="");const ee=K.toLowerCase(),{pathNormalized:$,normalized:q,normalizedLowercase:Z}=F(K),ne=$.indexOf(L.sep)>=0,de=U(K);let re;const Se=K.split(x);if(Se.length>1)for(const ve of Se){const G=U(ve),{pathNormalized:W,normalized:se,normalizedLowercase:ae}=F(ve);se&&(re||(re=[]),re.push({original:ve,originalLowercase:ve.toLowerCase(),pathNormalized:W,normalized:se,normalizedLowercase:ae,expectContiguousMatch:G}))}return{original:K,originalLowercase:ee,pathNormalized:$,normalized:q,normalizedLowercase:Z,values:re,containsPathSeparator:ne,expectContiguousMatch:de}}function F(K){let ee;R.isWindows?ee=K.replace(/\//g,L.sep):ee=K.replace(/\\/g,L.sep);const $=(0,v.stripWildcards)(ee).replace(/\s|"/g,"");return{pathNormalized:ee,normalized:$,normalizedLowercase:$.toLowerCase()}}function M(K){return Array.isArray(K)?B(K.map(ee=>ee.original).join(x)):B(K.original)}}),define(we[107],ye([1,0,16]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=A,e.getMediaMime=L,e.getExtensionForMimeType=R,e.normalizeMimeType=l,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const g={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(P){const y=(0,r.extname)(P),d=g[y.toLowerCase()];return d!==void 0?d:L(P)}function L(P){const y=(0,r.extname)(P);return k[y.toLowerCase()]}function R(P){for(const y in k)if(k[y]===P)return y}const v=/^(.+)\/(.+?)(;.+)?$/;function l(P,y){const d=v.exec(P);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:y?void 0:P}}),define(we[108],ye([1,0,11]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=A,e.removeDangerousEnvVariables=L;var g;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(g||(e.Source=g={}));var k;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(R,...v){const l=v.reduce((d,T)=>(d[T]=!0,d),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(d=>!l[d]).forEach(d=>{for(let T=0;T<P.length;T++)if(d.search(P[T])!==-1){delete R[d];break}})}function L(R){R&&(delete R.DEBUG,r.isMacintosh&&delete R.DYLD_LIBRARY_PATH,r.isLinux&&delete R.LD_PRELOAD)}}),define(we[2],ye([1,0,27,41,16,11]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=u,e.uriToFsPath=t;const L=/^\w[\w\d+.-]*$/,R=/^\//,v=/^\/\//;function l(_,D){if(!_.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!L.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!R.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(_,D){return!_&&!D?"file":_}function y(_,D){switch(_){case"https":case"http":case"file":D?D[0]!==T&&(D=T+D):D=T;break}return D}const d="",T="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(D){return D instanceof a?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,C,S,I,b,w=!1){typeof D=="object"?(this.scheme=D.scheme||d,this.authority=D.authority||d,this.path=D.path||d,this.query=D.query||d,this.fragment=D.fragment||d):(this.scheme=P(D,w),this.authority=C||d,this.path=y(this.scheme,S||d),this.query=I||d,this.fragment=b||d,l(this,w))}get fsPath(){return t(this,!1)}with(D){if(!D)return this;let{scheme:C,authority:S,path:I,query:b,fragment:w}=D;return C===void 0?C=this.scheme:C===null&&(C=d),S===void 0?S=this.authority:S===null&&(S=d),I===void 0?I=this.path:I===null&&(I=d),b===void 0?b=this.query:b===null&&(b=d),w===void 0?w=this.fragment:w===null&&(w=d),C===this.scheme&&S===this.authority&&I===this.path&&b===this.query&&w===this.fragment?this:new m(C,S,I,b,w)}static parse(D,C=!1){const S=E.exec(D);return S?new m(S[2]||d,p(S[4]||d),p(S[5]||d),p(S[7]||d),p(S[9]||d),C):new m(d,d,d,d,d)}static file(D){let C=d;if(A.isWindows&&(D=D.replace(/\\/g,T)),D[0]===T&&D[1]===T){const S=D.indexOf(T,2);S===-1?(C=D.substring(2),D=T):(C=D.substring(2,S),D=D.substring(S)||T)}return new m("file",C,D,d,d)}static from(D,C){return new m(D.scheme,D.authority,D.path,D.query,D.fragment,C)}static joinPath(D,...C){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return A.isWindows&&D.scheme==="file"?S=a.file(k.win32.join(t(D,!0),...C)).path:S=k.posix.join(D.path,...C),D.with({path:S})}toString(D=!1){return c(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof a)return D;{const C=new m(D);return C._formatted=D.external??null,C._fsPath=D._sep===f?D.fsPath??null:null,C}}else return D}}e.URI=a;function u(_){return!_||typeof _!="object"?!1:typeof _.scheme=="string"&&(typeof _.authority=="string"||typeof _.authority>"u")&&(typeof _.path=="string"||typeof _.path>"u")&&(typeof _.query=="string"||typeof _.query>"u")&&(typeof _.fragment=="string"||typeof _.fragment>"u")}const f=A.isWindows?1:void 0;class m extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(D=!1){return D?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const D={$mid:g.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=f),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const n={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function s(_,D,C){let S,I=-1;for(let b=0;b<_.length;b++){const w=_.charCodeAt(b);if(w>=r.CharCode.a&&w<=r.CharCode.z||w>=r.CharCode.A&&w<=r.CharCode.Z||w>=r.CharCode.Digit0&&w<=r.CharCode.Digit9||w===r.CharCode.Dash||w===r.CharCode.Period||w===r.CharCode.Underline||w===r.CharCode.Tilde||D&&w===r.CharCode.Slash||C&&w===r.CharCode.OpenSquareBracket||C&&w===r.CharCode.CloseSquareBracket||C&&w===r.CharCode.Colon)I!==-1&&(S+=encodeURIComponent(_.substring(I,b)),I=-1),S!==void 0&&(S+=_.charAt(b));else{S===void 0&&(S=_.substr(0,b));const N=n[w];N!==void 0?(I!==-1&&(S+=encodeURIComponent(_.substring(I,b)),I=-1),S+=N):I===-1&&(I=b)}}return I!==-1&&(S+=encodeURIComponent(_.substring(I))),S!==void 0?S:_}function i(_){let D;for(let C=0;C<_.length;C++){const S=_.charCodeAt(C);S===r.CharCode.Hash||S===r.CharCode.QuestionMark?(D===void 0&&(D=_.substr(0,C)),D+=n[S]):D!==void 0&&(D+=_[C])}return D!==void 0?D:_}function t(_,D){let C;return _.authority&&_.path.length>1&&_.scheme==="file"?C=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===r.CharCode.Slash&&(_.path.charCodeAt(1)>=r.CharCode.A&&_.path.charCodeAt(1)<=r.CharCode.Z||_.path.charCodeAt(1)>=r.CharCode.a&&_.path.charCodeAt(1)<=r.CharCode.z)&&_.path.charCodeAt(2)===r.CharCode.Colon?D?C=_.path.substr(1):C=_.path[1].toLowerCase()+_.path.substr(2):C=_.path,A.isWindows&&(C=C.replace(/\//g,"\\")),C}function c(_,D){const C=D?i:s;let S="",{scheme:I,authority:b,path:w,query:N,fragment:O}=_;if(I&&(S+=I,S+=":"),(b||I==="file")&&(S+=T,S+=T),b){let U=b.indexOf("@");if(U!==-1){const x=b.substr(0,U);b=b.substr(U+1),U=x.lastIndexOf(":"),U===-1?S+=C(x,!1,!1):(S+=C(x.substr(0,U),!1,!1),S+=":",S+=C(x.substr(U+1),!1,!0)),S+="@"}b=b.toLowerCase(),U=b.lastIndexOf(":"),U===-1?S+=C(b,!1,!0):(S+=C(b.substr(0,U),!1,!0),S+=b.substr(U))}if(w){if(w.length>=3&&w.charCodeAt(0)===r.CharCode.Slash&&w.charCodeAt(2)===r.CharCode.Colon){const U=w.charCodeAt(1);U>=r.CharCode.A&&U<=r.CharCode.Z&&(w=`/${String.fromCharCode(U+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===r.CharCode.Colon){const U=w.charCodeAt(0);U>=r.CharCode.A&&U<=r.CharCode.Z&&(w=`${String.fromCharCode(U+32)}:${w.substr(2)}`)}S+=C(w,!0,!1)}return N&&(S+="?",S+=C(N,!1,!1)),O&&(S+="#",S+=D?O:s(O,!1,!1)),S}function h(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+h(_.substr(3)):_}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function p(_){return _.match(o)?_.replace(o,D=>h(D)):_}}),define(we[205],ye([1,0,2]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=g,e.parse=k,e.getFirstFrame=A,e.log=R;function g(l){const P=l;return P&&typeof P.type=="string"&&typeof P.severity=="string"}function k(l){const P=[];let y;try{const d=JSON.parse(l.arguments),T=d[d.length-1];T&&T.__$stack&&(d.pop(),y=T.__$stack),P.push(...d)}catch{P.push("Unable to log remote console arguments",l.arguments)}return{args:P,stack:y}}function A(l){if(typeof l!="string")return A(k(l).stack);const P=l;if(P){const y=L(P),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(d&&d.length===4)return{uri:r.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function L(l){if(!l)return l;const P=l.indexOf(`
`);return P===-1?l:l.substring(0,P)}function R(l,P){const{args:y,stack:d}=k(l),T=typeof y[0]=="string"&&y.length===1;let E=L(d);E&&(E=`(${E.trim()})`);let a=[];if(typeof y[0]=="string"?E&&T?a=[`%c[${P}] %c${y[0]} %c${E}`,v("blue"),v(""),v("grey")]:a=[`%c[${P}] %c${y[0]}`,v("blue"),v(""),...y.slice(1)]:a=[`%c[${P}]%`,v("blue"),...y],E&&!T&&a.push(E),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,a)}function v(l){return`color: ${l}`}}),define(we[57],ye([1,0,22,2,41]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=A,e.parse=L,e.revive=v;function A(l){return JSON.stringify(l,R)}function L(l){let P=JSON.parse(l);return P=v(P),P}function R(l,P){return P instanceof RegExp?{$mid:k.MarshalledId.Regexp,source:P.source,flags:P.flags}:P}function v(l,P=0){if(!l||P>200)return l;if(typeof l=="object"){switch(l.$mid){case k.MarshalledId.Uri:return g.URI.revive(l);case k.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case k.MarshalledId.Date:return new Date(l.source)}if(l instanceof r.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let y=0;y<l.length;++y)l[y]=v(l[y],P+1);else for(const y in l)Object.hasOwnProperty.call(l,y)&&(l[y]=v(l[y],P+1))}return l}}),define(we[15],ye([1,0,14,11,13,2,16]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=v,e.matchesSomeScheme=l,e.getServerRootPath=y;var R;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeManagedRemoteResource="vscode-managed-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.vscodeChatCodeBlock="vscode-chat-code-block",E.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",E.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",E.vscodeChatSesssion="vscode-chat-editor",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm",E.commentsInput="comment",E.codeSetting="code-setting"})(R||(e.Schemas=R={}));function v(E,a){return A.URI.isUri(E)?(0,k.equalsIgnoreCase)(E.scheme,a):(0,k.startsWithIgnoreCase)(E,a+":")}function l(E,...a){return a.some(u=>v(E,u))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(a){this._preferredWebSchema=a}setDelegate(a){this._delegate=a}setServerRootPath(a,u){this._serverRootPath=y(a,u)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return L.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(a,u,f){this._hosts[a]=u,this._ports[a]=f}setConnectionToken(a,u){this._connectionTokens[a]=u}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(a){if(this._delegate)try{return this._delegate(a)}catch(i){return r.onUnexpectedError(i),a}const u=a.authority;let f=this._hosts[u];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const m=this._ports[u],n=this._connectionTokens[u];let s=`path=${encodeURIComponent(a.path)}`;return typeof n=="string"&&(s+=`&${e.connectionTokenQueryName}=${encodeURIComponent(n)}`),A.URI.from({scheme:g.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${f}:${m}`,path:this._remoteResourcesPath,query:s})}}e.RemoteAuthorities=new P;function y(E,a){return L.posix.join(a??"/",`${E.quality??"oss"}-${E.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class d{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(a){const u=this.toUri(a,he);return this.uriToBrowserUri(u)}uriToBrowserUri(a){return a.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(a):a.scheme===R.file&&(g.isNative||g.webWorkerOrigin===`${R.vscodeFileResource}://${d.FALLBACK_AUTHORITY}`)?a.with({scheme:R.vscodeFileResource,authority:a.authority||d.FALLBACK_AUTHORITY,query:null,fragment:null}):a}asFileUri(a){const u=this.toUri(a,he);return this.uriToFileUri(u)}uriToFileUri(a){return a.scheme===R.vscodeFileResource?a.with({scheme:R.file,authority:a.authority!==d.FALLBACK_AUTHORITY?a.authority:null,query:null,fragment:null}):a}toUri(a,u){return A.URI.isUri(a)?a:A.URI.parse(u.toUrl(a))}}e.FileAccess=new d;var T;(function(E){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(a.get("3"));const u="vscode-coi";function f(n){let s;typeof n=="string"?s=new URL(n).searchParams:n instanceof URL?s=n.searchParams:A.URI.isUri(n)&&(s=new URL(n.toString(!0)).searchParams);const i=s?.get(u);if(i)return a.get(i)}E.getHeadersFromQuery=f;function m(n,s,i){if(!globalThis.crossOriginIsolated)return;const t=s&&i?"3":i?"2":"1";n instanceof URLSearchParams?n.set(u,t):n[u]=t}E.addSearchParam=m})(T||(e.COI=T={}))}),define(we[206],ye([1,0,172,15,11,2]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=P;class L{constructor(d,T,E){this.id=d,this.dependencies=T,this.callback=E}}class R{static{this.INSTANCE=new R}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(d,T,E)=>{typeof d!="string"&&(E=T,T=d,d=null),(typeof T!="object"||!Array.isArray(T))&&(E=T,T=null),this._defineCalls.push(new L(d,T,E))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this._initialize();const T=await(this._isWebWorker?this._workerLoadScript(d):this._isRenderer?this._rendererLoadScript(d):this._nodeJSLoadScript(d));if(!T)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(T.dependencies)&&T.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${T.dependencies.join(", ")}`);return typeof T.callback=="function"?T.callback([]):T.callback}_rendererLoadScript(d){return new Promise((T,E)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const u=()=>{a.removeEventListener("load",f),a.removeEventListener("error",m)},f=n=>{u(),T(this._defineCalls.pop())},m=n=>{u(),E(n)};a.addEventListener("load",f),a.addEventListener("error",m),this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),a.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(a)})}_workerLoadScript(d){return new Promise((T,E)=>{try{this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),importScripts(d),T(this._defineCalls.pop())}catch(a){E(a)}})}async _nodeJSLoadScript(d){try{const T=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,u=A.URI.parse(d).fsPath,f=T.readFileSync(u).toString(),m=a.wrap(f.replace(/^#!.*/,""));return new E.Script(m).runInThisContext().apply(),this._defineCalls.pop()}catch(T){throw T}}}const v=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function P(y,d,T){if(r.isESM){T===void 0&&(T=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[y]&&(y=l[y]);const E=`${y}/${d}`;if(v.has(E))return v.get(E);let a;if(/^\w[\w\d+.-]*:\/\//.test(E))a=E;else{const n=`${T&&!k.isWeb?g.nodeModulesAsarPath:g.nodeModulesPath}/${E}`;a=g.FileAccess.asBrowserUri(n).toString(!0)}const u=R.INSTANCE.load(a);return v.set(E,u),u}else return await new Promise((E,a)=>{he([y],E,a)})}}),define(we[23],ye([1,0,27,33,15,16,11,13,2]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=l,e.distinctParents=y,e.toLocalResource=T;function l(E){return(0,v.uriToFsPath)(E,!0)}class P{constructor(a){this._ignorePathCasing=a}compare(a,u,f=!1){return a===u?0:(0,R.compare)(this.getComparisonKey(a,f),this.getComparisonKey(u,f))}isEqual(a,u,f=!1){return a===u?!0:!a||!u?!1:this.getComparisonKey(a,f)===this.getComparisonKey(u,f)}getComparisonKey(a,u=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,u,f=!1){if(a.scheme===u.scheme){if(a.scheme===k.Schemas.file)return g.isEqualOrParent(l(a),l(u),this._ignorePathCasing(a))&&a.query===u.query&&(f||a.fragment===u.fragment);if((0,e.isEqualAuthority)(a.authority,u.authority))return g.isEqualOrParent(a.path,u.path,this._ignorePathCasing(a),"/")&&a.query===u.query&&(f||a.fragment===u.fragment)}return!1}joinPath(a,...u){return v.URI.joinPath(a,...u)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return A.posix.basename(a.path)}extname(a){return A.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let u;return a.scheme===k.Schemas.file?u=v.URI.file(A.dirname(l(a))).path:(u=A.posix.dirname(a.path),a.authority&&u.length&&u.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),u="/")),a.with({path:u})}normalizePath(a){if(!a.path.length)return a;let u;return a.scheme===k.Schemas.file?u=v.URI.file(A.normalize(l(a))).path:u=A.posix.normalize(a.path),a.with({path:u})}relativePath(a,u){if(a.scheme!==u.scheme||!(0,e.isEqualAuthority)(a.authority,u.authority))return;if(a.scheme===k.Schemas.file){const n=A.relative(l(a),l(u));return L.isWindows?g.toSlashes(n):n}let f=a.path||"/";const m=u.path||"/";if(this._ignorePathCasing(a)){let n=0;for(const s=Math.min(f.length,m.length);n<s&&!(f.charCodeAt(n)!==m.charCodeAt(n)&&f.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);f=m.substr(0,n)+f.substr(n)}return A.posix.relative(f,m)}resolvePath(a,u){if(a.scheme===k.Schemas.file){const f=v.URI.file(A.resolve(l(a),u));return a.with({authority:f.authority,path:f.path})}return u=g.toPosixPath(u),a.with({path:A.posix.resolve(a.path,u)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,u){return a===u||a!==void 0&&u!==void 0&&(0,R.equalsIgnoreCase)(a,u)}hasTrailingPathSeparator(a,u=A.sep){if(a.scheme===k.Schemas.file){const f=l(a);return f.length>g.getRoot(f).length&&f[f.length-1]===u}else{const f=a.path;return f.length>1&&f.charCodeAt(f.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,u=A.sep){return(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,u=A.sep){let f=!1;if(a.scheme===k.Schemas.file){const m=l(a);f=m!==void 0&&m.length===g.getRoot(m).length&&m[m.length-1]===u}else{u="/";const m=a.path;f=m.length===1&&m.charCodeAt(m.length-1)===r.CharCode.Slash}return!f&&!(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path+"/"}):a}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(E=>E.scheme===k.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new P(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(E,a){const u=[];for(let f=0;f<E.length;f++){const m=a(E[f]);E.some((n,s)=>s===f?!1:(0,e.isEqualOrParent)(m,a(n)))||u.push(E[f])}return u}var d;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function a(u){const f=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(s=>{const[i,t]=s.split(":");i&&t&&f.set(i,t)});const n=u.path.substring(0,u.path.indexOf(";"));return n&&f.set(E.META_DATA_MIME,n),f}E.parseMetaData=a})(d||(e.DataUri=d={}));function T(E,a,u){if(a){let f=E.path;return f&&f[0]!==A.posix.sep&&(f=A.posix.sep+f),E.with({scheme:u,authority:a,path:f})}return E.with({scheme:u})}}),define(we[9],ye([1,0,21,14,4,3,23,11,183,49]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=P,e.createCancelablePromise=y,e.raceCancellation=d,e.raceCancellationError=T,e.raceCancellablePromises=E,e.raceTimeout=a,e.asPromise=u,e.promiseWithResolvers=f,e.timeout=_,e.disposableTimeout=D,e.sequence=C,e.first=S,e.firstParallel=I,e.retry=q,e.createCancelableAsyncIterable=ie;function P(ue){return!!ue&&typeof ue.then=="function"}function y(ue){const Y=new r.CancellationTokenSource,oe=ue(Y.token),pe=new Promise((Ee,Ne)=>{const We=Y.token.onCancellationRequested(()=>{We.dispose(),Ne(new g.CancellationError)});Promise.resolve(oe).then(Ce=>{We.dispose(),Y.dispose(),Ee(Ce)},Ce=>{We.dispose(),Y.dispose(),Ne(Ce)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(Ee,Ne){return pe.then(Ee,Ne)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return pe.finally(Ee)}}}function d(ue,Y,oe){return new Promise((pe,Ee)=>{const Ne=Y.onCancellationRequested(()=>{Ne.dispose(),pe(oe)});ue.then(pe,Ee).finally(()=>Ne.dispose())})}function T(ue,Y){return new Promise((oe,pe)=>{const Ee=Y.onCancellationRequested(()=>{Ee.dispose(),pe(new g.CancellationError)});ue.then(oe,pe).finally(()=>Ee.dispose())})}async function E(ue){let Y=-1;const oe=ue.map((pe,Ee)=>pe.then(Ne=>(Y=Ee,Ne)));try{return await Promise.race(oe)}finally{ue.forEach((pe,Ee)=>{Ee!==Y&&pe.cancel()})}}function a(ue,Y,oe){let pe;const Ee=setTimeout(()=>{pe?.(void 0),oe?.()},Y);return Promise.race([ue.finally(()=>clearTimeout(Ee)),new Promise(Ne=>pe=Ne)])}function u(ue){return new Promise((Y,oe)=>{const pe=ue();P(pe)?pe.then(Y,oe):Y(pe)})}function f(){let ue,Y;return{promise:new Promise((pe,Ee)=>{ue=pe,Y=Ee}),resolve:ue,reject:Y}}class m{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const oe=()=>{if(this.queuedPromise=null,this.isDisposed)return;const pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,pe};this.queuedPromise=new Promise(pe=>{this.activePromise.then(oe,oe).then(pe)})}return new Promise((oe,pe)=>{this.queuedPromise.then(oe,pe)})}return this.activePromise=Y(),new Promise((oe,pe)=>{this.activePromise.then(Ee=>{this.activePromise=null,oe(Ee)},Ee=>{this.activePromise=null,pe(Ee)})})}dispose(){this.isDisposed=!0}}e.Throttler=m;class n{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=n;class s{constructor(){this.promiseMap=new Map}queue(Y,oe){const Ee=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.promiseMap.get(Y)===Ee&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,Ee),Ee}}e.SequencerByKey=s;const i=(ue,Y)=>{let oe=!0;const pe=setTimeout(()=>{oe=!1,Y()},ue);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(pe),oe=!1}}},t=ue=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,ue())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class c{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,oe=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ee,Ne)=>{this.doResolve=Ee,this.doReject=Ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ee=this.task;return this.task=null,Ee()}}));const pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=oe===v.MicrotaskDelay?t(pe):i(oe,pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new g.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class h{constructor(Y){this.delayer=new c(Y),this.throttler=new m}trigger(Y,oe){return this.delayer.trigger(()=>this.throttler.queue(Y),oe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=h;class o{constructor(){this._isOpen=!1,this._promise=new Promise((Y,oe)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class p extends o{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=p;function _(ue,Y){return Y?new Promise((oe,pe)=>{const Ee=setTimeout(()=>{Ne.dispose(),oe()},ue),Ne=Y.onCancellationRequested(()=>{clearTimeout(Ee),Ne.dispose(),pe(new g.CancellationError)})}):y(oe=>_(ue,oe))}function D(ue,Y=0,oe){const pe=setTimeout(()=>{ue(),oe&&Ee.dispose()},Y),Ee=(0,A.toDisposable)(()=>{clearTimeout(pe),oe?.deleteAndLeak(Ee)});return oe?.add(Ee),Ee}function C(ue){const Y=[];let oe=0;const pe=ue.length;function Ee(){return oe<pe?ue[oe++]():null}function Ne(We){We!=null&&Y.push(We);const Ce=Ee();return Ce?Ce.then(Ne):Promise.resolve(Y)}return Promise.resolve(null).then(Ne)}function S(ue,Y=pe=>!!pe,oe=null){let pe=0;const Ee=ue.length,Ne=()=>{if(pe>=Ee)return Promise.resolve(oe);const We=ue[pe++];return Promise.resolve(We()).then(Ie=>Y(Ie)?Promise.resolve(Ie):Ne())};return Ne()}function I(ue,Y=pe=>!!pe,oe=null){if(ue.length===0)return Promise.resolve(oe);let pe=ue.length;const Ee=()=>{pe=-1;for(const Ne of ue)Ne.cancel?.()};return new Promise((Ne,We)=>{for(const Ce of ue)Ce.then(Ie=>{--pe>=0&&Y(Ie)?(Ee(),Ne(Ie)):pe===0&&Ne(oe)}).catch(Ie=>{--pe>=0&&(Ee(),We(Ie))})})}class b{constructor(Y){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((oe,pe)=>{this.outstandingPromises.push({factory:Y,c:oe,e:pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const oe=Y.factory();oe.then(Y.c,Y.e),oe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=b;class w extends b{constructor(){super(1)}}e.Queue=w;class N{constructor(){this.sequentializer=new Z,this.tasks=0}queue(Y){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,Y())):this.sequentializer.run(this.tasks++,Y())}}e.LimitedQueue=N;class O{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const Y=new re;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueSize(Y,oe=L.extUri){const pe=oe.getComparisonKey(Y);return this.queues.get(pe)?.size??0}queueFor(Y,oe,pe=L.extUri){const Ee=pe.getComparisonKey(Y);let Ne=this.queues.get(Ee);if(!Ne){Ne=new w;const We=this.drainListenerCount++,Ce=k.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.queues.delete(Ee),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(We),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new A.DisposableMap),this.drainListeners.set(We,Ce),this.queues.set(Ee,Ne)}return Ne.queue(oe)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=O;class U{constructor(Y,oe){this._isDisposed=!1,this._token=-1,typeof Y=="function"&&typeof oe=="number"&&this.setIfNotSet(Y,oe)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,oe){if(this._isDisposed)throw new g.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},oe)}setIfNotSet(Y,oe){if(this._isDisposed)throw new g.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},oe))}}e.TimeoutTimer=U;class x{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(Y,oe,pe=globalThis){if(this.isDisposed)throw new g.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const Ee=pe.setInterval(()=>{Y()},oe);this.disposable=(0,A.toDisposable)(()=>{pe.clearInterval(Ee),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=x;class B{constructor(Y,oe){this.timeoutToken=-1,this.runner=Y,this.timeout=oe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=B;class F{constructor(Y,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=oe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=F;class M extends B{constructor(Y,oe){super(Y,oe),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class K extends A.Disposable{constructor(Y,oe){super(),this.options=Y,this.handler=oe,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const oe of Y)this.pendingWork.push(oe);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new B(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(ue,Y)=>{(0,R.setTimeout0)(()=>{if(oe)return;const pe=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e._runWhenIdle=(ue,Y,oe)=>{const pe=ue.requestIdleCallback(Y,typeof oe=="number"?{timeout:oe}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,ue.cancelIdleCallback(pe))}}},e.runWhenGlobalIdle=ue=>(0,e._runWhenIdle)(globalThis,ue)}();class ee{constructor(Y,oe){this._didRun=!1,this._executor=()=>{try{this._value=oe()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(Y,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ee;class $ extends ee{constructor(Y){super(globalThis,Y)}}e.GlobalIdleValue=$;async function q(ue,Y,oe){let pe;for(let Ee=0;Ee<oe;Ee++)try{return await ue()}catch(Ne){pe=Ne,await _(Y)}throw pe}class Z{isRunning(Y){return typeof Y=="number"?this._running?.taskId===Y:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(Y,oe,pe){return this._running={taskId:Y,cancel:()=>pe?.(),promise:oe},oe.then(()=>this.doneRunning(Y),()=>this.doneRunning(Y)),oe}doneRunning(Y){this._running&&Y===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const Y=this._queued;this._queued=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this._queued)this._queued.run=Y;else{const{promise:oe,resolve:pe,reject:Ee}=f();this._queued={run:Y,promise:oe,promiseResolve:pe,promiseReject:Ee}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Z;class ne{constructor(Y,oe=()=>Date.now()){this.interval=Y,this.nowFn=oe,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=ne;var de;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})(de||(de={}));class re{get isRejected(){return this.outcome?.outcome===de.Rejected}get isResolved(){return this.outcome?.outcome===de.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===de.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((Y,oe)=>{this.completeCallback=Y,this.errorCallback=oe})}complete(Y){return new Promise(oe=>{this.completeCallback(Y),this.outcome={outcome:de.Resolved,value:Y},oe()})}error(Y){return new Promise(oe=>{this.errorCallback(Y),this.outcome={outcome:de.Rejected,value:Y},oe()})}cancel(){return this.error(new g.CancellationError)}}e.DeferredPromise=re;var Se;(function(ue){async function Y(pe){let Ee;const Ne=await Promise.all(pe.map(We=>We.then(Ce=>Ce,Ce=>{Ee||(Ee=Ce)})));if(typeof Ee<"u")throw Ee;return Ne}ue.settled=Y;function oe(pe){return new Promise(async(Ee,Ne)=>{try{await pe(Ee,Ne)}catch(We){Ne(We)}})}ue.withAsyncBody=oe})(Se||(e.Promises=Se={}));class ve{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(Y){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=Y.then(oe=>(this._value=oe,this._isResolved=!0,oe),oe=>{throw this._error=oe,this._isResolved=!0,oe})}requireValue(){if(!this._isResolved)throw new g.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=ve;class G{constructor(Y){this._compute=Y,this._promise=new l.Lazy(()=>new ve(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=G;var W;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(W||(W={}));class se{static fromArray(Y){return new se(oe=>{oe.emitMany(Y)})}static fromPromise(Y){return new se(async oe=>{oe.emitMany(await Y)})}static fromPromises(Y){return new se(async oe=>{await Promise.all(Y.map(async pe=>oe.emitOne(await pe)))})}static merge(Y){return new se(async oe=>{await Promise.all(Y.map(async pe=>{for await(const Ee of pe)oe.emitOne(Ee)}))})}static{this.EMPTY=se.fromArray([])}constructor(Y,oe){this._state=W.Initial,this._results=[],this._error=null,this._onReturn=oe,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const pe={emitOne:Ee=>this.emitOne(Ee),emitMany:Ee=>this.emitMany(Ee),reject:Ee=>this.reject(Ee)};try{await Promise.resolve(Y(pe)),this.resolve()}catch(Ee){this.reject(Ee)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===W.DoneError)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===W.DoneOK)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(Y,oe){return new se(async pe=>{for await(const Ee of Y)pe.emitOne(oe(Ee))})}map(Y){return se.map(this,Y)}static filter(Y,oe){return new se(async pe=>{for await(const Ee of Y)oe(Ee)&&pe.emitOne(Ee)})}filter(Y){return se.filter(this,Y)}static coalesce(Y){return se.filter(Y,oe=>!!oe)}coalesce(){return se.coalesce(this)}static async toPromise(Y){const oe=[];for await(const pe of Y)oe.push(pe);return oe}toPromise(){return se.toPromise(this)}emitOne(Y){this._state===W.Initial&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===W.Initial&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===W.Initial&&(this._state=W.DoneOK,this._onStateChanged.fire())}reject(Y){this._state===W.Initial&&(this._state=W.DoneError,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=se;class ae extends se{constructor(Y,oe){super(oe),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ae;function ie(ue){const Y=new r.CancellationTokenSource,oe=ue(Y.token);return new ae(Y,async pe=>{const Ee=Y.token.onCancellationRequested(()=>{Ee.dispose(),Y.dispose(),pe.reject(new g.CancellationError)});try{for await(const Ne of oe){if(Y.token.isCancellationRequested)return;pe.emitOne(Ne)}Ee.dispose(),Y.dispose()}catch(Ne){Ee.dispose(),Y.dispose(),pe.reject(Ne)}})}class le{constructor(Y){this._deferred=new re,this._asyncIterable=new se(Ee=>{if(oe){Ee.reject(oe);return}return pe&&Ee.emitMany(pe),this._errorFn=Ne=>Ee.reject(Ne),this._emitFn=Ne=>Ee.emitOne(Ne),this._deferred.p},Y);let oe,pe;this._emitFn=Ee=>{pe||(pe=[]),pe.push(Ee)},this._errorFn=Ee=>{oe||(oe=Ee)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(Y){this._errorFn(Y),this._deferred.complete()}emitOne(Y){this._emitFn(Y)}}e.AsyncIterableSource=le}),define(we[39],ye([1,0,19,9,27,33,29,16,11,13]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=P,e.splitGlobAware=a,e.match=N,e.parse=O,e.isRelativePattern=U,e.getBasenameTerms=x,e.getPathTerms=B,e.patternsEquals=ee;function P(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",d="[^/\\\\]",T=/\//g;function E($,q){switch($){case 0:return"";case 1:return`${d}*?`;default:return`(?:${y}|${d}+${y}${q?`|${y}${d}+`:""})*?`}}function a($,q){if(!$)return[];const Z=[];let ne=!1,de=!1,re="";for(const Se of $){switch(Se){case q:if(!ne&&!de){Z.push(re),re="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":de=!0;break;case"]":de=!1;break}re+=Se}return re&&Z.push(re),Z}function u($){if(!$)return"";let q="";const Z=a($,e.GLOB_SPLIT);if(Z.every(ne=>ne===e.GLOBSTAR))q=".*";else{let ne=!1;Z.forEach((de,re)=>{if(de===e.GLOBSTAR){if(ne)return;q+=E(2,re===Z.length-1)}else{let Se=!1,ve="",G=!1,W="";for(const se of de){if(se!=="}"&&Se){ve+=se;continue}if(G&&(se!=="]"||!W)){let ae;se==="-"?ae=se:(se==="^"||se==="!")&&!W?ae="^":se===e.GLOB_SPLIT?ae="":ae=(0,l.escapeRegExpCharacters)(se),W+=ae;continue}switch(se){case"{":Se=!0;continue;case"[":G=!0;continue;case"}":{const ie=`(?:${a(ve,",").map(le=>u(le)).join("|")})`;q+=ie,Se=!1,ve="";break}case"]":{q+="["+W+"]",G=!1,W="";break}case"?":q+=d;continue;case"*":q+=E(1);continue;default:q+=(0,l.escapeRegExpCharacters)(se)}}re<Z.length-1&&(Z[re+1]!==e.GLOBSTAR||re+2<Z.length)&&(q+=y)}ne=de===e.GLOBSTAR})}return q}const f=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new L.LRUCache(1e4),h=function(){return!1},o=function(){return null};function p($,q){if(!$)return o;let Z;typeof $!="string"?Z=$.pattern:Z=$,Z=Z.trim();const ne=`${Z}_${!!q.trimForExclusions}`;let de=c.get(ne);if(de)return _(de,$);let re;return f.test(Z)?de=C(Z.substr(4),Z):(re=m.exec(D(Z,q)))?de=S(re[1],Z):(q.trimForExclusions?s:n).test(Z)?de=I(Z,q):(re=i.exec(D(Z,q)))?de=b(re[1].substr(1),Z,!0):(re=t.exec(D(Z,q)))?de=b(re[1],Z,!1):de=w(Z),c.set(ne,de),_(de,$)}function _($,q){if(typeof q=="string")return $;const Z=function(ne,de){return(0,A.isEqualOrParent)(ne,q.base,!v.isLinux)?$((0,l.ltrim)(ne.substr(q.base.length),R.sep),de):null};return Z.allBasenames=$.allBasenames,Z.allPaths=$.allPaths,Z.basenames=$.basenames,Z.patterns=$.patterns,Z}function D($,q){return q.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function C($,q){return function(Z,ne){return typeof Z=="string"&&Z.endsWith($)?q:null}}function S($,q){const Z=`/${$}`,ne=`\\${$}`,de=function(Se,ve){return typeof Se!="string"?null:ve?ve===$?q:null:Se===$||Se.endsWith(Z)||Se.endsWith(ne)?q:null},re=[$];return de.basenames=re,de.patterns=[q],de.allBasenames=re,de}function I($,q){const Z=K($.slice(1,-1).split(",").map(ve=>p(ve,q)).filter(ve=>ve!==o),$),ne=Z.length;if(!ne)return o;if(ne===1)return Z[0];const de=function(ve,G){for(let W=0,se=Z.length;W<se;W++)if(Z[W](ve,G))return $;return null},re=Z.find(ve=>!!ve.allBasenames);re&&(de.allBasenames=re.allBasenames);const Se=Z.reduce((ve,G)=>G.allPaths?ve.concat(G.allPaths):ve,[]);return Se.length&&(de.allPaths=Se),de}function b($,q,Z){const ne=R.sep===R.posix.sep,de=ne?$:$.replace(T,R.sep),re=R.sep+de,Se=R.posix.sep+$;let ve;return Z?ve=function(G,W){return typeof G=="string"&&(G===de||G.endsWith(re)||!ne&&(G===$||G.endsWith(Se)))?q:null}:ve=function(G,W){return typeof G=="string"&&(G===de||!ne&&G===$)?q:null},ve.allPaths=[(Z?"*/":"./")+$],ve}function w($){try{const q=new RegExp(`^${u($)}$`);return function(Z){return q.lastIndex=0,typeof Z=="string"&&q.test(Z)?$:null}}catch{return o}}function N($,q,Z){return!$||typeof q!="string"?!1:O($)(q,void 0,Z)}function O($,q={}){if(!$)return h;if(typeof $=="string"||U($)){const Z=p($,q);if(Z===o)return h;const ne=function(de,re){return!!Z(de,re)};return Z.allBasenames&&(ne.allBasenames=Z.allBasenames),Z.allPaths&&(ne.allPaths=Z.allPaths),ne}return F($,q)}function U($){const q=$;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function x($){return $.allBasenames||[]}function B($){return $.allPaths||[]}function F($,q){const Z=K(Object.getOwnPropertyNames($).map(ve=>M(ve,$[ve],q)).filter(ve=>ve!==o)),ne=Z.length;if(!ne)return o;if(!Z.some(ve=>!!ve.requiresSiblings)){if(ne===1)return Z[0];const ve=function(se,ae){let ie;for(let le=0,ue=Z.length;le<ue;le++){const Y=Z[le](se,ae);if(typeof Y=="string")return Y;(0,g.isThenable)(Y)&&(ie||(ie=[]),ie.push(Y))}return ie?(async()=>{for(const le of ie){const ue=await le;if(typeof ue=="string")return ue}return null})():null},G=Z.find(se=>!!se.allBasenames);G&&(ve.allBasenames=G.allBasenames);const W=Z.reduce((se,ae)=>ae.allPaths?se.concat(ae.allPaths):se,[]);return W.length&&(ve.allPaths=W),ve}const de=function(ve,G,W){let se,ae;for(let ie=0,le=Z.length;ie<le;ie++){const ue=Z[ie];ue.requiresSiblings&&W&&(G||(G=(0,R.basename)(ve)),se||(se=G.substr(0,G.length-(0,R.extname)(ve).length)));const Y=ue(ve,G,se,W);if(typeof Y=="string")return Y;(0,g.isThenable)(Y)&&(ae||(ae=[]),ae.push(Y))}return ae?(async()=>{for(const ie of ae){const le=await ie;if(typeof le=="string")return le}return null})():null},re=Z.find(ve=>!!ve.allBasenames);re&&(de.allBasenames=re.allBasenames);const Se=Z.reduce((ve,G)=>G.allPaths?ve.concat(G.allPaths):ve,[]);return Se.length&&(de.allPaths=Se),de}function M($,q,Z){if(q===!1)return o;const ne=p($,Z);if(ne===o)return o;if(typeof q=="boolean")return ne;if(q){const de=q.when;if(typeof de=="string"){const re=(Se,ve,G,W)=>{if(!W||!ne(Se,ve))return null;const se=de.replace("$(basename)",()=>G),ae=W(se);return(0,g.isThenable)(ae)?ae.then(ie=>ie?$:null):ae?$:null};return re.requiresSiblings=!0,re}}return ne}function K($,q){const Z=$.filter(ve=>!!ve.basenames);if(Z.length<2)return $;const ne=Z.reduce((ve,G)=>{const W=G.basenames;return W?ve.concat(W):ve},[]);let de;if(q){de=[];for(let ve=0,G=ne.length;ve<G;ve++)de.push(q)}else de=Z.reduce((ve,G)=>{const W=G.patterns;return W?ve.concat(W):ve},[]);const re=function(ve,G){if(typeof ve!="string")return null;if(!G){let se;for(se=ve.length;se>0;se--){const ae=ve.charCodeAt(se-1);if(ae===k.CharCode.Slash||ae===k.CharCode.Backslash)break}G=ve.substr(se)}const W=ne.indexOf(G);return W!==-1?de[W]:null};re.basenames=ne,re.patterns=de,re.allBasenames=ne;const Se=$.filter(ve=>!ve.basenames);return Se.push(re),Se}function ee($,q){return(0,r.equals)($,q,(Z,ne)=>typeof Z=="string"&&typeof ne=="string"?Z===ne:typeof Z!="string"&&typeof ne!="string"?Z.base===ne.base&&Z.pattern===ne.pattern:!1)}}),define(we[86],ye([1,0,14,135,23,13,2]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=l,e.isMarkdownString=P,e.markdownStringEqual=y,e.escapeMarkdownSyntaxTokens=d,e.appendEscapedMarkdownCodeBlockFence=T,e.escapeDoubleQuotes=E,e.removeMarkdownEscapes=a,e.parseHrefAndDimensions=u;var R;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class v{constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=R.Paragraph){return this.value+=d(this.supportThemeIcons?(0,g.escapeIcons)(m):m).replace(/([ \t]+)/g,(s,i)=>"&nbsp;".repeat(i.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===R.Break?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+=`
${T(n,m)}
`,this}appendLink(m,n,s){return this.value+="[",this.value+=this._escape(n,"]"),this.value+="](",this.value+=this._escape(String(m),")"),s&&(this.value+=` "${this._escape(this._escape(s,'"'),")")}"`),this.value+=")",this}_escape(m,n){const s=new RegExp((0,A.escapeRegExpCharacters)(n),"g");return m.replace(s,(i,t)=>m.charAt(t-1)!=="\\"?`\\${i}`:i)}}e.MarkdownString=v;function l(f){return P(f)?!f.value:Array.isArray(f)?f.every(l):!0}function P(f){return f instanceof v?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||typeof f.isTrusted=="object"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}function y(f,m){return f===m?!0:!f||!m?!1:f.value===m.value&&f.isTrusted===m.isTrusted&&f.supportThemeIcons===m.supportThemeIcons&&f.supportHtml===m.supportHtml&&(f.baseUri===m.baseUri||!!f.baseUri&&!!m.baseUri&&(0,k.isEqual)(L.URI.from(f.baseUri),L.URI.from(m.baseUri)))}function d(f){return f.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function T(f,m){const n=f.match(/^`+/gm)?.reduce((i,t)=>i.length>t.length?i:t).length??0,s=n>=3?n+1:3;return[`${"`".repeat(s)}${m}`,f,`${"`".repeat(s)}`].join(`
`)}function E(f){return f.replace(/"/g,"&quot;")}function a(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function u(f){const m=[],n=f.split("|").map(i=>i.trim());f=n[0];const s=n[1];if(s){const i=/height=(\d+)/.exec(s),t=/width=(\d+)/.exec(s),c=i?i[1]:"",h=t?t[1]:"",o=isFinite(parseInt(h)),p=isFinite(parseInt(c));o&&m.push(`width="${h}"`),p&&m.push(`height="${c}"`)}return{href:f,dimensions:m}}}),define(we[109],ye([1,0,19,33,16,11,23,13]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=v,e.normalizeDriveLetter=P,e.tildify=d,e.untildify=T,e.shorten=f,e.template=n,e.mnemonicMenuLabel=s,e.mnemonicButtonLabel=i,e.unmnemonicLabel=t,e.splitRecentLabel=c;function v(o,p){const{os:_,tildify:D,relative:C}=p;if(C){const b=l(o,C,_);if(typeof b=="string")return b}let S=o.fsPath;if(_===A.OperatingSystem.Windows&&!A.isWindows?S=S.replace(/\//g,"\\"):_!==A.OperatingSystem.Windows&&A.isWindows&&(S=S.replace(/\\/g,"/")),_!==A.OperatingSystem.Windows&&D?.userHome){const b=D.userHome.fsPath;let w;o.scheme!==D.userHome.scheme&&o.path[0]===k.posix.sep&&o.path[1]!==k.posix.sep?w=D.userHome.with({path:o.path}).fsPath:w=S,S=d(w,b,_)}return(_===A.OperatingSystem.Windows?k.win32:k.posix).normalize(P(S,_===A.OperatingSystem.Windows))}function l(o,p,_){const D=_===A.OperatingSystem.Windows?k.win32:k.posix,C=_===A.OperatingSystem.Linux?L.extUri:L.extUriIgnorePathCase,S=p.getWorkspace(),I=(0,r.firstOrDefault)(S.folders);if(!I)return;o.scheme!==I.uri.scheme&&o.path[0]===k.posix.sep&&o.path[1]!==k.posix.sep&&(o=I.uri.with({path:o.path}));const b=p.getWorkspaceFolder(o);if(!b)return;let w;if(C.isEqual(b.uri,o)?w="":w=C.relativePath(b.uri,o)??"",w&&(w=D.normalize(w)),S.folders.length>1&&!p.noPrefix){const N=b.name?b.name:C.basenameOrAuthority(b.uri);w=w?`${N} \u2022 ${w}`:N}return w}function P(o,p=A.isWindows){return(0,g.hasDriveLetter)(o,p)?o.charAt(0).toUpperCase()+o.slice(1):o}let y=Object.create(null);function d(o,p,_=A.OS){if(_===A.OperatingSystem.Windows||!o||!p)return o;let D=y.original===p?y.normalized:void 0;D||(D=p,A.isWindows&&(D=(0,g.toSlashes)(D)),D=`${(0,R.rtrim)(D,k.posix.sep)}${k.posix.sep}`,y={original:p,normalized:D});let C=o;return A.isWindows&&(C=(0,g.toSlashes)(C)),(_===A.OperatingSystem.Linux?C.startsWith(D):(0,R.startsWithIgnoreCase)(C,D))?`~/${C.substr(D.length)}`:o}function T(o,p){return o.replace(/^~($|\/|\\)/,`${p}$1`)}const E="\u2026",a="\\\\",u="~";function f(o,p=k.sep){const _=new Array(o.length);let D=!1;for(let C=0;C<o.length;C++){const S=o[C];if(S===""){_[C]=`.${p}`;continue}if(!S){_[C]=S;continue}D=!0;let I="",b=S;b.indexOf(a)===0?(I=b.substr(0,b.indexOf(a)+a.length),b=b.substr(b.indexOf(a)+a.length)):b.indexOf(p)===0?(I=b.substr(0,b.indexOf(p)+p.length),b=b.substr(b.indexOf(p)+p.length)):b.indexOf(u)===0&&(I=b.substr(0,b.indexOf(u)+u.length),b=b.substr(b.indexOf(u)+u.length));const w=b.split(p);for(let N=1;D&&N<=w.length;N++)for(let O=w.length-N;D&&O>=0;O--){D=!1;let U=w.slice(O,O+N).join(p);for(let x=0;!D&&x<o.length;x++)if(x!==C&&o[x]&&o[x].indexOf(U)>-1){const B=O+N===w.length,F=O>0&&o[x].indexOf(p)>-1?p+U:U,M=o[x].endsWith(F);D=!B||M}if(!D){let x="";(w[0].endsWith(":")||I!=="")&&(O===1&&(O=0,N++,U=w[0]+p+U),O>0&&(x=w[0]+p),x=I+x),O>0&&(x=x+E+p),x=x+U,O+N<w.length&&(x=x+p+E),_[C]=x}}D&&(_[C]=S)}return _}var m;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function n(o,p=Object.create(null)){const _=[];let D=!1,C="";for(const S of o)if(S==="$"||D&&S==="{")C&&_.push({value:C,type:m.TEXT}),C="",D=!0;else if(S==="}"&&D){const I=p[C];if(typeof I=="string")I.length&&_.push({value:I,type:m.VARIABLE});else if(I){const b=_[_.length-1];(!b||b.type!==m.SEPARATOR)&&_.push({value:I.label,type:m.SEPARATOR})}C="",D=!1}else C+=S;return C&&!D&&_.push({value:C,type:m.TEXT}),_.filter((S,I)=>{if(S.type===m.SEPARATOR){const b=_[I-1],w=_[I+1];return[b,w].every(N=>N&&(N.type===m.VARIABLE||N.type===m.TEXT)&&N.value.length>0)}return!0}).map(S=>S.value).join("")}function s(o,p){return A.isMacintosh||p?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):o.replace(/&&|&/g,_=>_==="&"?"&&":"&")}function i(o,p){return A.isMacintosh||p?o.replace(/\(&&\w\)|&&/g,""):A.isWindows?o.replace(/&&|&/g,_=>_==="&"?"&&":"&"):o.replace(/&&/g,"_")}function t(o){return o.replace(/&/g,"&&")}function c(o){if(o.endsWith("]")){const p=o.lastIndexOf(" [",o.length-2);if(p!==-1){const _=h(o.substring(0,p)),D=o.substring(p);return{name:_.name+D,parentPath:_.parentPath}}}return h(o)}function h(o){const p=o.indexOf("/")!==-1?k.posix:k.win32,_=p.basename(o),D=p.dirname(o);return _.length?{name:_,parentPath:D}:{name:D,parentPath:""}}}),define(we[141],ye([1,0,22,41,2]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=v,e.transformIncomingURIs=P,e.transformAndReviveIncomingURIs=y;function A(d){return d.toJSON()}class L{constructor(T){this._uriTransformer=T}transformIncoming(T){const E=this._uriTransformer.transformIncoming(T);return E===T?T:A(k.URI.from(E))}transformOutgoing(T){const E=this._uriTransformer.transformOutgoing(T);return E===T?T:A(k.URI.from(E))}transformOutgoingURI(T){const E=this._uriTransformer.transformOutgoing(T);return E===T?T:k.URI.from(E)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function R(d,T,E){if(!d||E>200)return null;if(typeof d=="object"){if(d instanceof k.URI)return T.transformOutgoing(d);for(const a in d)if(Object.hasOwnProperty.call(d,a)){const u=R(d[a],T,E+1);u!==null&&(d[a]=u)}}return null}function v(d,T){const E=R(d,T,0);return E===null?d:E}function l(d,T,E,a){if(!d||a>200)return null;if(typeof d=="object"){if(d.$mid===g.MarshalledId.Uri)return E?k.URI.revive(T.transformIncoming(d)):T.transformIncoming(d);if(d instanceof r.VSBuffer)return null;for(const u in d)if(Object.hasOwnProperty.call(d,u)){const f=l(d[u],T,E,a+1);f!==null&&(d[u]=f)}}return null}function P(d,T){const E=l(d,T,!1,0);return E===null?d:E}function y(d,T){const E=l(d,T,!0,0);return E===null?d:E}}),define(we[34],ye([1,0,58,67,410,9,33,82,16,11,23,2]),function(he,e,r,g,k,A,L,R,v,l,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=u,e.readdirSync=n,e.whenDeleted=t,e.configureFlushOnWrite=_,e.writeFileSync=C;var d;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function T(F,M=d.UNLINK,K){if((0,L.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return M===d.UNLINK?a(F):E(F,K)}async function E(F,M=(0,L.randomPath)((0,g.tmpdir)())){try{try{await r.promises.rename(F,M)}catch(K){return K.code==="ENOENT"?void 0:a(F)}a(M).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function a(F){return(0,k.promisify)(r.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function u(F){if((0,L.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function f(F,M){return s(await(M?m(F):(0,k.promisify)(r.readdir)(F)))}async function m(F){try{return await(0,k.promisify)(r.readdir)(F,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const M=[],K=await f(F);for(const ee of K){let $=!1,q=!1,Z=!1;try{const ne=await e.Promises.lstat((0,v.join)(F,ee));$=ne.isFile(),q=ne.isDirectory(),Z=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}M.push({name:ee,isFile:()=>$,isDirectory:()=>q,isSymbolicLink:()=>Z})}return M}function n(F){return s(r.readdirSync(F))}function s(F){return F.map(M=>typeof M=="string"?l.isMacintosh?(0,R.normalizeNFC)(M):M:(M.name=l.isMacintosh?(0,R.normalizeNFC)(M.name):M.name,M))}async function i(F){const M=await f(F),K=[];for(const ee of M)await c.existsDirectory((0,v.join)(F,ee))&&K.push(ee);return K}function t(F,M=1e3){return new Promise(K=>{let ee=!1;const $=setInterval(()=>{ee||(ee=!0,r.access(F,q=>{ee=!1,q&&(clearInterval($),K(void 0))}))},M)})}var c;(function(F){async function M($){let q;try{if(q=await e.Promises.lstat($),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(l.isWindows&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw ne}throw Z}}F.stat=M;async function K($){try{const{stat:q,symbolicLink:Z}=await F.stat($);return q.isFile()&&Z?.dangling!==!0}catch{}return!1}F.existsFile=K;async function ee($){try{const{stat:q,symbolicLink:Z}=await F.stat($);return q.isDirectory()&&Z?.dangling!==!0}catch{}return!1}F.existsDirectory=ee})(c||(e.SymlinkSupport=c={}));const h=new A.ResourceQueue;function o(F,M,K){return h.queueFor(y.URI.file(F),()=>{const ee=S(K);return new Promise(($,q)=>D(F,M,ee,Z=>Z?q(Z):$()))},P.extUriBiasedIgnorePathCase)}let p=!0;function _(F){p=F}function D(F,M,K,ee){if(!p)return r.writeFile(F,M,{mode:K.mode,flag:K.flag},ee);r.open(F,K.flag,K.mode,($,q)=>{if($)return ee($);r.writeFile(q,M,Z=>{if(Z)return r.close(q,()=>ee(Z));r.fdatasync(q,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),_(!1)),r.close(q,de=>ee(de))))})})}function C(F,M,K){const ee=S(K);if(!p)return r.writeFileSync(F,M,{mode:ee.mode,flag:ee.flag});const $=r.openSync(F,ee.flag,ee.mode);try{r.writeFileSync($,M);try{r.fdatasyncSync($)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),_(!1)}}finally{r.closeSync($)}}function S(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function I(F,M,K=6e4){if(F!==M)try{l.isWindows&&typeof K=="number"?await b(F,M,Date.now(),K):await(0,k.promisify)(r.rename)(F,M)}catch(ee){if(F.toLowerCase()!==M.toLowerCase()&&ee.code==="EXDEV"||F.endsWith("."))await w(F,M,{preserveSymlinks:!1}),await T(F,d.MOVE);else throw ee}}async function b(F,M,K,ee,$=0){try{return await(0,k.promisify)(r.rename)(F,M)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-K>=ee)throw console.error(`[node.js fs] rename failed after ${$} retries with error: ${q}`),q;if($===0){let Z=!1;try{const{stat:ne}=await c.stat(M);ne.isFile()||(Z=!0)}catch{}if(Z)throw q}return await(0,A.timeout)(Math.min(100,$*10)),b(F,M,K,ee,$+1)}}async function w(F,M,K){return O(F,M,{root:{source:F,target:M},options:K,handledSourcePaths:new Set})}const N=511;async function O(F,M,K){if(K.handledSourcePaths.has(F))return;K.handledSourcePaths.add(F);const{stat:ee,symbolicLink:$}=await c.stat(F);if($){if(K.options.preserveSymlinks)try{return await B(F,M,K)}catch{}if($.dangling)return}return ee.isDirectory()?U(F,M,ee.mode&N,K):x(F,M,ee.mode&N)}async function U(F,M,K,ee){await e.Promises.mkdir(M,{recursive:!0,mode:K});const $=await f(F);for(const q of $)await O((0,v.join)(F,q),(0,v.join)(M,q),ee)}async function x(F,M,K){await e.Promises.copyFile(F,M),await e.Promises.chmod(M,K)}async function B(F,M,K){let ee=await e.Promises.readlink(F);(0,L.isEqualOrParent)(ee,K.root.source,!l.isLinux)&&(ee=(0,v.join)(K.root.target,ee.substr(K.root.source.length+1))),await e.Promises.symlink(ee,M)}e.Promises=new class{get access(){return(0,k.promisify)(r.access)}get stat(){return(0,k.promisify)(r.stat)}get lstat(){return(0,k.promisify)(r.lstat)}get utimes(){return(0,k.promisify)(r.utimes)}get read(){return(F,M,K,ee,$)=>new Promise((q,Z)=>{r.read(F,M,K,ee,$,(ne,de,re)=>ne?Z(ne):q({bytesRead:de,buffer:re}))})}get readFile(){return(0,k.promisify)(r.readFile)}get write(){return(F,M,K,ee,$)=>new Promise((q,Z)=>{r.write(F,M,K,ee,$,(ne,de,re)=>ne?Z(ne):q({bytesWritten:de,buffer:re}))})}get appendFile(){return(0,k.promisify)(r.appendFile)}get fdatasync(){return(0,k.promisify)(r.fdatasync)}get truncate(){return(0,k.promisify)(r.truncate)}get copyFile(){return(0,k.promisify)(r.copyFile)}get open(){return(0,k.promisify)(r.open)}get close(){return(0,k.promisify)(r.close)}get symlink(){return(0,k.promisify)(r.symlink)}get readlink(){return(0,k.promisify)(r.readlink)}get chmod(){return(0,k.promisify)(r.chmod)}get mkdir(){return(0,k.promisify)(r.mkdir)}get unlink(){return(0,k.promisify)(r.unlink)}get rmdir(){return(0,k.promisify)(r.rmdir)}get realpath(){return(0,k.promisify)(r.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return i}get writeFile(){return o}get rm(){return T}get rename(){return I}get copy(){return w}}}),define(we[110],ye([1,0,58,16,11,13,34]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=R,e.realcase=v,e.realpath=l,e.realpathSync=P;function R(d){if(k.isLinux)return d;const T=(0,g.dirname)(d);if(d===T)return d;const E=((0,g.basename)(d)||d).toLowerCase();try{const u=(0,L.readdirSync)(T).filter(f=>f.toLowerCase()===E);if(u.length===1){const f=R(T);if(f)return(0,g.join)(f,u[0])}else if(u.length>1){const f=u.indexOf(E);if(f>=0){const m=R(T);if(m)return(0,g.join)(m,u[f])}}}catch{}return null}async function v(d,T){if(k.isLinux)return d;const E=(0,g.dirname)(d);if(d===E)return d;const a=((0,g.basename)(d)||d).toLowerCase();try{if(T?.isCancellationRequested)return null;const f=(await L.Promises.readdir(E)).filter(m=>m.toLowerCase()===a);if(f.length===1){const m=await v(E,T);if(m)return(0,g.join)(m,f[0])}else if(f.length>1){const m=f.indexOf(a);if(m>=0){const n=await v(E,T);if(n)return(0,g.join)(n,f[m])}}}catch{}return null}async function l(d){try{return await L.Promises.realpath(d)}catch{const E=y(d);return await L.Promises.access(E,r.constants.R_OK),E}}function P(d){try{return r.realpathSync(d)}catch{const E=y(d);return r.accessSync(E,r.constants.R_OK),E}}function y(d){return(0,A.rtrim)((0,g.normalize)(d),g.sep)}}),define(we[111],ye([1,0,16,11,56,108,18,34]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=v,e.createQueuedSender=l,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function v(y=k.env){return y.comspec||"cmd.exe"}function l(y){let d=[],T=!1;const E=function(a){if(T){d.push(a);return}(!y.send(a,f=>{if(f&&console.error(f),T=!1,d.length>0){const m=d.slice(0);d=[],m.forEach(n=>E(n))}})||g.isWindows)&&(T=!0)};return{send:E}}var P;(function(y){async function d(T,E,a){if(r.isAbsolute(T))return T;if(E===void 0&&(E=k.cwd()),r.dirname(T)!=="."||(a===void 0&&L.isString(k.env.PATH)&&(a=k.env.PATH.split(r.delimiter)),a===void 0||a.length===0))return r.join(E,T);async function f(m){if(await R.Promises.exists(m)){let n;try{n=await R.Promises.stat(m)}catch(s){s.message.startsWith("EACCES")&&(n=await R.Promises.lstat(m))}return n?!n.isDirectory():!1}return!1}for(const m of a){let n;if(r.isAbsolute(m)?n=r.join(m,T):n=r.join(E,m,T),await f(n))return n;let s=n+".com";if(await f(s)||(s=n+".exe",await f(s)))return s}return r.join(E,T)}y.findExecutable=d})(P||(e.win32=P={}))});var Ke=this&&this.__decorate||function(he,e,r,g){var k=arguments.length,A=k<3?e:g===null?g=Object.getOwnPropertyDescriptor(e,r):g,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(he,e,r,g);else for(var R=he.length-1;R>=0;R--)(L=he[R])&&(A=(k<3?L(A):k>3?L(e,r,A):L(e,r))||A);return k>3&&A&&Object.defineProperty(e,r,A),A};define(we[87],ye([1,0,19,9,22,21,60,14,4,3,57,13,18]),function(he,e,r,g,k,A,L,R,v,l,P,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=_,e.deserialize=D,e.getDelayedChannel=N,e.getNextTickChannel=O;var T;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(T||(T={}));function E($){switch($){case T.Promise:return"req";case T.PromiseCancel:return"cancel";case T.EventListen:return"subscribe";case T.EventDispose:return"unsubscribe"}}var a;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(a||(a={}));function u($){switch($){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var f;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(f||(f={}));function m($){let q=0;for(let Z=0;;Z+=7){const ne=$.read(1);if(q|=(ne.buffer[0]&127)<<Z,!(ne.buffer[0]&128))return q}}const n=h(0);function s($,q){if(q===0){$.write(n);return}let Z=0;for(let de=q;de!==0;de=de>>>7)Z++;const ne=k.VSBuffer.alloc(Z);for(let de=0;q!==0;de++)ne.buffer[de]=q&127,q=q>>>7,q>0&&(ne.buffer[de]|=128);$.write(ne)}class i{constructor(q){this.buffer=q,this.pos=0}read(q){const Z=this.buffer.slice(this.pos,this.pos+q);return this.pos+=Z.byteLength,Z}}e.BufferReader=i;class t{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}e.BufferWriter=t;var c;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object",$[$.Int=6]="Int"})(c||(c={}));function h($){const q=k.VSBuffer.alloc(1);return q.writeUInt8($,0),q}const o={Undefined:h(c.Undefined),String:h(c.String),Buffer:h(c.Buffer),VSBuffer:h(c.VSBuffer),Array:h(c.Array),Object:h(c.Object),Uint:h(c.Int)},p=typeof Buffer<"u";function _($,q){if(typeof q>"u")$.write(o.Undefined);else if(typeof q=="string"){const Z=k.VSBuffer.fromString(q);$.write(o.String),s($,Z.byteLength),$.write(Z)}else if(p&&Buffer.isBuffer(q)){const Z=k.VSBuffer.wrap(q);$.write(o.Buffer),s($,Z.byteLength),$.write(Z)}else if(q instanceof k.VSBuffer)$.write(o.VSBuffer),s($,q.byteLength),$.write(q);else if(Array.isArray(q)){$.write(o.Array),s($,q.length);for(const Z of q)_($,Z)}else if(typeof q=="number"&&(q|0)===q)$.write(o.Uint),s($,q);else{const Z=k.VSBuffer.fromString(JSON.stringify(q));$.write(o.Object),s($,Z.byteLength),$.write(Z)}}function D($){switch($.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return $.read(m($)).toString();case c.Buffer:return $.read(m($)).buffer;case c.VSBuffer:return $.read(m($));case c.Array:{const Z=m($),ne=[];for(let de=0;de<Z;de++)ne.push(D($));return ne}case c.Object:return JSON.parse($.read(m($)).toString());case c.Int:return m($)}}class C{constructor(q,Z,ne=null,de=1e3){this.protocol=q,this.ctx=Z,this.logger=ne,this.timeoutDelay=de,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(re=>this.onRawMessage(re)),this.sendResponse({type:a.Initialize})}registerChannel(q,Z){this.channels.set(q,Z),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case a.Initialize:{const Z=this.send([q.type]);this.logger?.logOutgoing(Z,0,S.OtherSide,u(q.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const Z=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(Z,q.id,S.OtherSide,u(q.type),q.data);return}}}send(q,Z=void 0){const ne=new t;return _(ne,q),_(ne,Z),this.sendBuffer(ne.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const Z=new i(q),ne=D(Z),de=D(Z),re=ne[0];switch(re){case T.Promise:return this.logger?.logIncoming(q.byteLength,ne[1],S.OtherSide,`${E(re)}: ${ne[2]}.${ne[3]}`,de),this.onPromise({type:re,id:ne[1],channelName:ne[2],name:ne[3],arg:de});case T.EventListen:return this.logger?.logIncoming(q.byteLength,ne[1],S.OtherSide,`${E(re)}: ${ne[2]}.${ne[3]}`,de),this.onEventListen({type:re,id:ne[1],channelName:ne[2],name:ne[3],arg:de});case T.PromiseCancel:return this.logger?.logIncoming(q.byteLength,ne[1],S.OtherSide,`${E(re)}`),this.disposeActiveRequest({type:re,id:ne[1]});case T.EventDispose:return this.logger?.logIncoming(q.byteLength,ne[1],S.OtherSide,`${E(re)}`),this.disposeActiveRequest({type:re,id:ne[1]})}}onPromise(q){const Z=this.channels.get(q.channelName);if(!Z){this.collectPendingRequest(q);return}const ne=new A.CancellationTokenSource;let de;try{de=Z.call(this.ctx,q.name,q.arg,ne.token)}catch(ve){de=Promise.reject(ve)}const re=q.id;de.then(ve=>{this.sendResponse({id:re,data:ve,type:a.PromiseSuccess})},ve=>{ve instanceof Error?this.sendResponse({id:re,data:{message:ve.message,name:ve.name,stack:ve.stack?ve.stack.split?ve.stack.split(`
`):ve.stack:void 0},type:a.PromiseError}):this.sendResponse({id:re,data:ve,type:a.PromiseErrorObj})}).finally(()=>{Se.dispose(),this.activeRequests.delete(q.id)});const Se=(0,l.toDisposable)(()=>ne.cancel());this.activeRequests.set(q.id,Se)}onEventListen(q){const Z=this.channels.get(q.channelName);if(!Z){this.collectPendingRequest(q);return}const ne=q.id,re=Z.listen(this.ctx,q.name,q.arg)(Se=>this.sendResponse({id:ne,data:Se,type:a.EventFire}));this.activeRequests.set(q.id,re)}disposeActiveRequest(q){const Z=this.activeRequests.get(q.id);Z&&(Z.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let Z=this.pendingRequests.get(q.channelName);Z||(Z=[],this.pendingRequests.set(q.channelName,Z));const ne=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===T.Promise&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:a.PromiseError})},this.timeoutDelay);Z.push({request:q,timeoutTimer:ne})}flushPendingRequests(q){const Z=this.pendingRequests.get(q);if(Z){for(const ne of Z)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case T.Promise:this.onPromise(ne.request);break;case T.EventListen:this.onEventListen(ne.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=C;var S;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class I{constructor(q,Z=null){this.protocol=q,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=Z}getChannel(q){const Z=this;return{call(ne,de,re){return Z.isDisposed?Promise.reject(new R.CancellationError):Z.requestPromise(q,ne,de,re)},listen(ne,de){return Z.isDisposed?v.Event.None:Z.requestEvent(q,ne,de)}}}requestPromise(q,Z,ne,de=A.CancellationToken.None){const re=this.lastRequestId++,Se=T.Promise,ve={id:re,type:Se,channelName:q,name:Z,arg:ne};if(de.isCancellationRequested)return Promise.reject(new R.CancellationError);let G;return new Promise((se,ae)=>{if(de.isCancellationRequested)return ae(new R.CancellationError);const ie=()=>{const oe=pe=>{switch(pe.type){case a.PromiseSuccess:this.handlers.delete(re),se(pe.data);break;case a.PromiseError:{this.handlers.delete(re);const Ee=new Error(pe.data.message);Ee.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,Ee.name=pe.data.name,ae(Ee);break}case a.PromiseErrorObj:this.handlers.delete(re),ae(pe.data);break}};this.handlers.set(re,oe),this.sendRequest(ve)};let le=null;this.state===f.Idle?ie():(le=(0,g.createCancelablePromise)(oe=>this.whenInitialized()),le.then(()=>{le=null,ie()}));const ue=()=>{le?(le.cancel(),le=null):this.sendRequest({id:re,type:T.PromiseCancel}),ae(new R.CancellationError)},Y=de.onCancellationRequested(ue);G=(0,l.combinedDisposable)((0,l.toDisposable)(ue),Y),this.activeRequests.add(G)}).finally(()=>{G.dispose(),this.activeRequests.delete(G)})}requestEvent(q,Z,ne){const de=this.lastRequestId++,re=T.EventListen,Se={id:de,type:re,channelName:q,name:Z,arg:ne};let ve=null;const G=new v.Emitter({onWillAddFirstListener:()=>{ve=(0,g.createCancelablePromise)(se=>this.whenInitialized()),ve.then(()=>{ve=null,this.activeRequests.add(G),this.sendRequest(Se)})},onDidRemoveLastListener:()=>{ve?(ve.cancel(),ve=null):(this.activeRequests.delete(G),this.sendRequest({id:de,type:T.EventDispose}))}}),W=se=>G.fire(se.data);return this.handlers.set(de,W),G.event}sendRequest(q){switch(q.type){case T.Promise:case T.EventListen:{const Z=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(Z,q.id,S.LocalSide,`${E(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case T.PromiseCancel:case T.EventDispose:{const Z=this.send([q.type,q.id]);this.logger?.logOutgoing(Z,q.id,S.LocalSide,E(q.type));return}}}send(q,Z=void 0){const ne=new t;return _(ne,q),_(ne,Z),this.sendBuffer(ne.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const Z=new i(q),ne=D(Z),de=D(Z),re=ne[0];switch(re){case a.Initialize:return this.logger?.logIncoming(q.byteLength,0,S.LocalSide,u(re)),this.onResponse({type:ne[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.logger?.logIncoming(q.byteLength,ne[1],S.LocalSide,u(re),de),this.onResponse({type:ne[0],id:ne[1],data:de})}}onResponse(q){if(q.type===a.Initialize){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=I,Ke([L.memoize],I.prototype,"onDidInitializePromise",null);class b{get connections(){const q=[];return this._connections.forEach(Z=>q.push(Z)),q}constructor(q,Z,ne){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add(q(({protocol:de,onDidClientDisconnect:re})=>{const Se=v.Event.once(de.onMessage);this.disposables.add(Se(ve=>{const G=new i(ve),W=D(G),se=new C(de,W,Z,ne),ae=new I(de,Z);this.channels.forEach((le,ue)=>se.registerChannel(ue,le));const ie={channelServer:se,channelClient:ae,ctx:W};this._connections.add(ie),this._onDidAddConnection.fire(ie),this.disposables.add(re(()=>{se.dispose(),ae.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)}))}))}))}getChannel(q,Z){const ne=this;return{call(de,re,Se){let ve;if((0,d.isFunction)(Z)){const W=(0,r.getRandomElement)(ne.connections.filter(Z));ve=W?Promise.resolve(W):v.Event.toPromise(v.Event.filter(ne.onDidAddConnection,Z))}else ve=Z.routeCall(ne,de,re);const G=ve.then(W=>W.channelClient.getChannel(q));return N(G).call(de,re,Se)},listen(de,re){if((0,d.isFunction)(Z))return ne.getMulticastEvent(q,Z,de,re);const Se=Z.routeEvent(ne,de,re).then(ve=>ve.channelClient.getChannel(q));return N(Se).listen(de,re)}}}getMulticastEvent(q,Z,ne,de){const re=this;let Se;const ve=new v.Emitter({onWillAddFirstListener:()=>{Se=new l.DisposableStore;const G=new v.EventMultiplexer,W=new Map,se=ie=>{const ue=ie.channelClient.getChannel(q).listen(ne,de),Y=G.add(ue);W.set(ie,Y)},ae=ie=>{const le=W.get(ie);le&&(le.dispose(),W.delete(ie))};re.connections.filter(Z).forEach(se),v.Event.filter(re.onDidAddConnection,Z)(se,void 0,Se),re.onDidRemoveConnection(ae,void 0,Se),G.event(ve.fire,ve,Se),Se.add(G)},onDidRemoveLastListener:()=>{Se?.dispose(),Se=void 0}});return ve.event}registerChannel(q,Z){this.channels.set(q,Z);for(const ne of this._connections)ne.channelServer.registerChannel(q,Z)}dispose(){this.disposables.dispose();for(const q of this._connections)q.channelClient.dispose(),q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class w{constructor(q,Z,ne=null){const de=new t;_(de,Z),q.send(de.buffer),this.channelClient=new I(q,ne),this.channelServer=new C(q,Z,ne)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,Z){this.channelServer.registerChannel(q,Z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=w;function N($){return{call(q,Z,ne){return $.then(de=>de.call(q,Z,ne))},listen(q,Z){const ne=new v.Relay;return $.then(de=>ne.input=de.listen(q,Z)),ne.event}}}function O($){let q=!1;return{call(Z,ne,de){return q?$.call(Z,ne,de):(0,g.timeout)(0).then(()=>q=!0).then(()=>$.call(Z,ne,de))},listen(Z,ne){if(q)return $.listen(Z,ne);const de=new v.Relay;return(0,g.timeout)(0).then(()=>q=!0).then(()=>de.input=$.listen(Z,ne)),de.event}}}class U{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const Z of q.connections)if(await Promise.resolve(this.fn(Z.ctx)))return Promise.resolve(Z);return await v.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=U;var x;(function($){function q(re,Se,ve){const G=re,W=ve&&ve.disableMarshalling,se=new Map;for(const ae in G)ne(ae)&&se.set(ae,v.Event.buffer(G[ae],!0,void 0,Se));return new class{listen(ae,ie,le){const ue=se.get(ie);if(ue)return ue;const Y=G[ie];if(typeof Y=="function"){if(de(ie))return Y.call(G,le);if(ne(ie))return se.set(ie,v.Event.buffer(G[ie],!0,void 0,Se)),se.get(ie)}throw new R.ErrorNoTelemetry(`Event not found: ${ie}`)}call(ae,ie,le){const ue=G[ie];if(typeof ue=="function"){if(!W&&Array.isArray(le))for(let oe=0;oe<le.length;oe++)le[oe]=(0,P.revive)(le[oe]);let Y=ue.apply(G,le);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new R.ErrorNoTelemetry(`Method not found: ${ie}`)}}}$.fromService=q;function Z(re,Se){const ve=Se&&Se.disableMarshalling;return new Proxy({},{get(G,W){if(typeof W=="string")return Se?.properties?.has(W)?Se.properties.get(W):de(W)?function(se){return re.listen(W,se)}:ne(W)?re.listen(W):async function(...se){let ae;Se&&!(0,d.isUndefinedOrNull)(Se.context)?ae=[Se.context,...se]:ae=se;const ie=await re.call(W,ae);return ve?ie:(0,P.revive)(ie)};throw new R.ErrorNoTelemetry(`Property not found: ${String(W)}`)}})}$.toService=Z;function ne(re){return re[0]==="o"&&re[1]==="n"&&y.isUpperAsciiLetter(re.charCodeAt(2))}function de(re){return/^onDynamic/.test(re)&&y.isUpperAsciiLetter(re.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){const q=$.toString();if(q!=="[object Object]")return q}return $}function M($){return Array.isArray($)?$.map(F):F($)}function K($,q,Z,ne,de,re,Se){Se=M(Se);const ve=B[de],G=ve[ne%ve.length];let W=[`%c[${$}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(re)?(W=W.concat(Se),W.push(")")):W.push(Se),console.log.apply(console,W)}class ee{constructor(q,Z){this._outgoingPrefix=q,this._incomingPrefix=Z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,Z,ne,de,re){this._totalOutgoing+=q,K(this._outgoingPrefix,this._totalOutgoing,q,Z,ne,de,re)}logIncoming(q,Z,ne,de,re){this._totalIncoming+=q,K(this._incomingPrefix,this._totalIncoming,q,Z,ne,de,re)}}e.IPCLogger=ee}),define(we[68],ye([1,0,22,4,3,87]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var R;(function(o){o.enableDiagnostics=!1,o.records=[];const p=new WeakMap;let _=0;function D(S,I){if(!p.has(S)){const b=String(++_);p.set(S,b)}return p.get(S)}function C(S,I,b,w){if(!o.enableDiagnostics)return;const N=D(S,I);if(w instanceof r.VSBuffer||w instanceof Uint8Array||w instanceof ArrayBuffer||ArrayBuffer.isView(w)){const O=r.VSBuffer.alloc(w.byteLength);O.set(w),o.records.push({timestamp:Date.now(),id:N,label:I,type:b,buff:O})}else o.records.push({timestamp:Date.now(),id:N,label:I,type:b,data:w})}o.traceSocketEvent=C})(R||(e.SocketDiagnostics=R={}));var v;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let l=null;function P(){return l||(l=r.VSBuffer.alloc(0)),l}class y{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(p){this._chunks.push(p),this._totalLength+=p.byteLength}read(p){return this._read(p,!0)}peek(p){return this._read(p,!1)}_read(p,_){if(p===0)return P();if(p>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===p){const I=this._chunks[0];return _&&(this._chunks.shift(),this._totalLength-=p),I}if(this._chunks[0].byteLength>p){const I=this._chunks[0].slice(0,p);return _&&(this._chunks[0]=this._chunks[0].slice(p),this._totalLength-=p),I}const D=r.VSBuffer.alloc(p);let C=0,S=0;for(;p>0;){const I=this._chunks[S];if(I.byteLength>p){const b=I.slice(0,p);D.set(b,C),C+=p,_&&(this._chunks[S]=I.slice(p),this._totalLength-=p),p-=p}else D.set(I,C),C+=I.byteLength,_?(this._chunks.shift(),this._totalLength-=I.byteLength):S++,p-=I.byteLength}return D}}e.ChunkStream=y;var d;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(d||(d={}));function T(o){switch(o){case d.None:return"None";case d.Regular:return"Regular";case d.Control:return"Control";case d.Ack:return"Ack";case d.Disconnect:return"Disconnect";case d.ReplayRequest:return"ReplayRequest";case d.Pause:return"PauseWriting";case d.Resume:return"ResumeWriting";case d.KeepAlive:return"KeepAlive"}}var E;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",o[o.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(E||(e.ProtocolConstants=E={}));class a{constructor(p,_,D,C){this.type=p,this.id=_,this.ack=D,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends k.Disposable{constructor(p){super(),this._onMessage=this._register(new g.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:E.HeaderLength,messageType:d.None,id:0,ack:0},this._socket=p,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(_=>this.acceptChunk(_))),this.lastReadTime=Date.now()}acceptChunk(p){if(!(!p||p.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;){const _=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=_.readUInt32BE(9),this._state.messageType=_.readUInt8(0),this._state.id=_.readUInt32BE(1),this._state.ack=_.readUInt32BE(5),this._socket.traceSocketEvent(L.ProtocolHeaderRead,{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const D=this._state.messageType,C=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=E.HeaderLength,this._state.messageType=d.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(L.ProtocolMessageRead,_),this._onMessage.fire(new a(D,C,S,_)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(p){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=p,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(p){if(this._isDisposed)return;p.writtenTime=Date.now(),this.lastWriteTime=Date.now();const _=r.VSBuffer.alloc(E.HeaderLength);_.writeUInt8(p.type,0),_.writeUInt32BE(p.id,1),_.writeUInt32BE(p.ack,5),_.writeUInt32BE(p.data.byteLength,9),this._socket.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:T(p.type),id:p.id,ack:p.ack,messageSize:p.data.byteLength}),this._socket.traceSocketEvent(L.ProtocolMessageWrite,p.data),this._writeSoon(_,p.data)}_bufferAdd(p,_){const D=this._totalLength===0;return this._data.push(p,_),this._totalLength+=p.byteLength+_.byteLength,D}_bufferTake(){const p=r.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,p}_writeSoon(p,_){this._bufferAdd(p,_)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const p=this._bufferTake();this._socket.traceSocketEvent(L.ProtocolWrite,{byteLength:p.byteLength}),this._socket.write(p)}}class m extends k.Disposable{constructor(p){super(),this._onMessage=new g.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new g.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=p,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new u(this._socket)),this._register(this._socketReader.onMessage(_=>{_.type===d.Regular&&this._onMessage.fire(_.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(p){this._socketWriter.write(new a(d.Regular,0,0,p))}}e.Protocol=m;class n extends A.IPCClient{static fromSocket(p,_){return new n(new m(p),_)}get onDidDispose(){return this.protocol.onDidDispose}constructor(p,_,D=null){super(p,_,D),this.protocol=p}dispose(){super.dispose();const p=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),p.end()}}e.Client=n;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new g.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(p){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(p):this._emitter.fire(p):this._bufferedMessages.push(p)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class i{constructor(p){this.data=p,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let p=0,_=this._first;for(;_;)_=_.next,p++;return p}peek(){return this._first?this._first.data:null}toArray(){const p=[];let _=0,D=this._first;for(;D;)p[_++]=D.data,D=D.next;return p}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(p){const _=new i(p);if(!this._first){this._first=_,this._last=_;return}this._last.next=_,this._last=_}}class c{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}constructor(){this.lastRuns=[];const p=Date.now();for(let _=0;_<c._HISTORY_LENGTH;_++)this.lastRuns[_]=p-1e3*_;setInterval(()=>{for(let _=c._HISTORY_LENGTH;_>=1;_--)this.lastRuns[_]=this.lastRuns[_-1];this.lastRuns[0]=Date.now()},1e3)}load(){const p=Date.now(),_=(1+c._HISTORY_LENGTH)*1e3;let D=0;for(let C=0;C<c._HISTORY_LENGTH;C++)p-this.lastRuns[C]<=_&&D++;return 1-D/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class h{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(p){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=p.loadEstimator??c.getInstance(),this._shouldSendKeepAlive=p.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new k.DisposableStore,this._socket=p.socket,this._socketWriter=this._socketDisposables.add(new f(this._socket)),this._socketReader=this._socketDisposables.add(new u(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(_=>this._receiveMessage(_))),this._socketDisposables.add(this._socket.onClose(_=>this._onSocketClose.fire(_))),p.initialChunk&&this._socketReader.acceptChunk(p.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},E.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const p=new a(d.Disconnect,0,0,P());this._socketWriter.write(p),this._socketWriter.flush()}sendPause(){const p=new a(d.Pause,0,0,P());this._socketWriter.write(p)}sendResume(){const p=new a(d.Resume,0,0,P());this._socketWriter.write(p)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(p,_){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new k.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=p,this._socketWriter=this._socketDisposables.add(new f(this._socket)),this._socketReader=this._socketDisposables.add(new u(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(D=>this._receiveMessage(D))),this._socketDisposables.add(this._socket.onClose(D=>this._onSocketClose.fire(D))),this._socketReader.acceptChunk(_)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const p=new a(d.Ack,0,this._incomingAckId,P());this._socketWriter.write(p);const _=this._outgoingUnackMsg.toArray();for(let D=0,C=_.length;D<C;D++)this._socketWriter.write(_[D]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(p){if(p.ack>this._outgoingAckId){this._outgoingAckId=p.ack;do{const _=this._outgoingUnackMsg.peek();if(_&&_.id<=p.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(p.type){case d.None:break;case d.Regular:{if(p.id>this._incomingMsgId)if(p.id!==this._incomingMsgId+1){const _=Date.now();_-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=_,this._socketWriter.write(new a(d.ReplayRequest,0,0,P())))}else this._incomingMsgId=p.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(p.data);break}case d.Control:{this._onControlMessage.fire(p.data);break}case d.Ack:break;case d.Disconnect:{this._onDidDispose.fire();break}case d.ReplayRequest:{const _=this._outgoingUnackMsg.toArray();for(let D=0,C=_.length;D<C;D++)this._socketWriter.write(_[D]);this._recvAckCheck();break}case d.Pause:{this._socketWriter.pause();break}case d.Resume:{this._socketWriter.resume();break}case d.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(p){const _=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const D=new a(d.Regular,_,this._incomingAckId,p);this._outgoingUnackMsg.push(D),this._isReconnecting||(this._socketWriter.write(D),this._recvAckCheck())}sendControl(p){const _=new a(d.Control,0,0,p);this._socketWriter.write(_)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const p=Date.now()-this._incomingMsgLastTime;if(p>=E.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},E.AcknowledgeTime-p+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const p=this._outgoingUnackMsg.peek(),_=Date.now()-p.writtenTime,D=Date.now()-this._socketReader.lastReadTime,C=Date.now()-this._lastSocketTimeoutTime;if(_>=E.TimeoutTime&&D>=E.TimeoutTime&&C>=E.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:_,timeSinceLastReceivedSomeData:D});return}const S=Math.max(E.TimeoutTime-_,E.TimeoutTime-D,E.TimeoutTime-C,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},S)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const p=new a(d.Ack,0,this._incomingAckId,P());this._socketWriter.write(p)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const p=new a(d.KeepAlive,0,this._incomingAckId,P());this._socketWriter.write(p)}}e.PersistentProtocol=h}),define(we[207],ye([1,0,59,9,22,21,205,14,4,3,25,111,108,87]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends T.ChannelServer{constructor(f){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",m=>k.VSBuffer.wrap(Buffer.from(m,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=E;class a{constructor(f,m){this.modulePath=f,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new v.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const n=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new g.Delayer(n),this.child=null,this._client=null}getChannel(f){const m=this;return{call(n,s,i){return m.requestPromise(f,n,s,i)},listen(n,s){return m.requestEvent(f,n,s)}}}requestPromise(f,m,n,s=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(f),t=(0,g.createCancelablePromise)(o=>i.call(m,n,o)),c=s.onCancellationRequested(()=>t.cancel()),h=(0,l.toDisposable)(()=>t.cancel());return this.activeRequests.add(h),t.finally(()=>{c.dispose(),this.activeRequests.delete(h),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(f,m,n){if(!this.disposeDelayer)return v.Event.None;this.disposeDelayer.cancel();let s;const i=new v.Emitter({onWillAddFirstListener:()=>{s=this.getCachedChannel(f).listen(m,n)(i.fire,i),this.activeRequests.add(s)},onDidRemoveLastListener:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(_=>!/^--inspect(-brk)?=/.test(_)).filter(_=>!_.startsWith("--vscode-"))),(0,d.removeDangerousEnvVariables)(m.env),this.child=(0,r.fork)(this.modulePath,f,m);const n=new v.Emitter,i=v.Event.fromNodeEventEmitter(this.child,"message",_=>_)(_=>{if((0,L.isRemoteConsoleLog)(_)){(0,L.log)(_,`IPC Library: ${this.options.serverName}`);return}n.fire(k.VSBuffer.wrap(Buffer.from(_,"base64")))}),t=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,c=_=>this.child&&this.child.connected&&t.send(_.buffer.toString("base64")),h=n.event,o={send:c,onMessage:h};this._client=new T.ChannelClient(o);const p=()=>this.disposeClient();process.once("exit",p),this.child.on("error",_=>console.warn('IPC "'+this.options.serverName+'" errored with '+_)),this.child.on("exit",(_,D)=>{process.removeListener("exit",p),i.dispose(),this.activeRequests.forEach(C=>(0,l.dispose)(C)),this.activeRequests.clear(),_!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+_+" and signal "+D),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:_,signal:D})})}return this._client}getCachedChannel(f){let m=this.channels.get(f);return m||(m=this.client.getChannel(f),this.channels.set(f,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=a}),define(we[208],ye([1,0,9,4,3,57,18]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=v;var R;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function v(d){const T=d;return T?.changed instanceof Map||T?.deleted instanceof Set}var l;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(l||(e.StorageState=l={}));class P extends k.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(T,E=Object.create(null)){super(),this.database=T,this.options=E,this._onDidChangeStorage=this._register(new g.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new r.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(T=>this.onDidChangeItemsExternal(T)))}onDidChangeItemsExternal(T){this._onDidChangeStorage.pause();try{T.changed?.forEach((E,a)=>this.acceptExternal(a,E)),T.deleted?.forEach(E=>this.acceptExternal(E,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(T,E){if(this.state===l.Closed)return;let a=!1;(0,L.isUndefinedOrNull)(E)?a=this.cache.delete(T):this.cache.get(T)!==E&&(this.cache.set(T,E),a=!0),a&&this._onDidChangeStorage.fire({key:T,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(T,E){const a=this.cache.get(T);return(0,L.isUndefinedOrNull)(a)?E:a}getBoolean(T,E){const a=this.get(T);return(0,L.isUndefinedOrNull)(a)?E:a==="true"}getNumber(T,E){const a=this.get(T);return(0,L.isUndefinedOrNull)(a)?E:parseInt(a,10)}getObject(T,E){const a=this.get(T);return(0,L.isUndefinedOrNull)(a)?E:(0,A.parse)(a)}async set(T,E,a=!1){if(this.state===l.Closed)return;if((0,L.isUndefinedOrNull)(E))return this.delete(T,a);const u=(0,L.isObject)(E)||Array.isArray(E)?(0,A.stringify)(E):String(E);if(this.cache.get(T)!==u)return this.cache.set(T,u),this.pendingInserts.set(T,u),this.pendingDeletes.delete(T),this._onDidChangeStorage.fire({key:T,external:a}),this.doFlush()}async delete(T,E=!1){if(!(this.state===l.Closed||!this.cache.delete(T)))return this.pendingDeletes.has(T)||this.pendingDeletes.add(T),this.pendingInserts.delete(T),this._onDidChangeStorage.fire({key:T,external:E}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const T={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(T).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(T){if(!(this.state===l.Closed||this.pendingClose))return this.doFlush(T)}async doFlush(T){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),T)}async whenFlushed(){if(this.hasPending)return new Promise(T=>this.whenFlushedCallbacks.push(T))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=P;class y{constructor(){this.onDidChangeItemsExternal=g.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(T){T.insert?.forEach((E,a)=>this.items.set(a,E)),T.delete?.forEach(E=>this.items.delete(E))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=y}),define(we[209],ye([1,0,13,11,22]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=P,e.decodeUTF16LE=y;let A;function L(){return A||(A=new TextDecoder("UTF-16LE")),A}let R;function v(){return R||(R=new TextDecoder("UTF-16BE")),R}let l;function P(){return l||(l=g.isLittleEndian()?L():v()),l}function y(E,a,u){const f=new Uint16Array(E.buffer,a,u);return u>0&&(f[0]===65279||f[0]===65534)?d(E,a,u):L().decode(f)}function d(E,a,u){const f=[];let m=0;for(let n=0;n<u;n++){const s=k.readUInt16LE(E,a);a+=2,f[m++]=String.fromCharCode(s)}return f.join("")}class T{constructor(a){this._capacity=a|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const a=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return P().decode(a)}_flushBuffer(){const a=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[a]:this._completedStrings[this._completedStrings.length]=a}appendCharCode(a){const u=this._capacity-this._bufferLength;u<=1&&(u===0||r.isHighSurrogate(a))&&this._flushBuffer(),this._buffer[this._bufferLength++]=a}appendASCIICharCode(a){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=a}appendString(a){const u=a.length;if(this._bufferLength+u>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=a;return}for(let f=0;f<u;f++)this._buffer[this._bufferLength++]=a.charCodeAt(f)}}e.StringBuilder=T}),define(we[210],ye([1,0,22,209]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=L;function k(v){return v.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(l,P,y,d){this.oldPosition=l,this.oldText=P,this.newPosition=y,this.newText=d}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${k(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${k(this.oldText)}")`:`(replace@${this.oldPosition} "${k(this.oldText)}" with "${k(this.newText)}")`}static _writeStringSize(l){return 4+2*l.length}static _writeString(l,P,y){const d=P.length;r.writeUInt32BE(l,d,y),y+=4;for(let T=0;T<d;T++)r.writeUInt16LE(l,P.charCodeAt(T),y),y+=2;return y}static _readString(l,P){const y=r.readUInt32BE(l,P);return P+=4,(0,g.decodeUTF16LE)(l,P,y)}writeSize(){return 8+A._writeStringSize(this.oldText)+A._writeStringSize(this.newText)}write(l,P){return r.writeUInt32BE(l,this.oldPosition,P),P+=4,r.writeUInt32BE(l,this.newPosition,P),P+=4,P=A._writeString(l,this.oldText,P),P=A._writeString(l,this.newText,P),P}static read(l,P,y){const d=r.readUInt32BE(l,P);P+=4;const T=r.readUInt32BE(l,P);P+=4;const E=A._readString(l,P);P+=A._writeStringSize(E);const a=A._readString(l,P);return P+=A._writeStringSize(a),y.push(new A(d,E,T,a)),P}}e.TextChange=A;function L(v,l){return v===null||v.length===0?l:new R(v,l).compress()}class R{constructor(l,P){this._prevEdits=l,this._currEdits=P,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let l=0,P=0,y=this._getPrev(l),d=this._getCurr(P);for(;l<this._prevLen||P<this._currLen;){if(y===null){this._acceptCurr(d),d=this._getCurr(++P);continue}if(d===null){this._acceptPrev(y),y=this._getPrev(++l);continue}if(d.oldEnd<=y.newPosition){this._acceptCurr(d),d=this._getCurr(++P);continue}if(y.newEnd<=d.oldPosition){this._acceptPrev(y),y=this._getPrev(++l);continue}if(d.oldPosition<y.newPosition){const[f,m]=R._splitCurr(d,y.newPosition-d.oldPosition);this._acceptCurr(f),d=m;continue}if(y.newPosition<d.oldPosition){const[f,m]=R._splitPrev(y,d.oldPosition-y.newPosition);this._acceptPrev(f),y=m;continue}let a,u;if(d.oldEnd===y.newEnd)a=y,u=d,y=this._getPrev(++l),d=this._getCurr(++P);else if(d.oldEnd<y.newEnd){const[f,m]=R._splitPrev(y,d.oldLength);a=f,u=d,y=m,d=this._getCurr(++P)}else{const[f,m]=R._splitCurr(d,y.newLength);a=y,u=f,y=this._getPrev(++l),d=m}this._result[this._resultLen++]=new A(a.oldPosition,a.oldText,u.newPosition,u.newText),this._prevDeltaOffset+=a.newLength-a.oldLength,this._currDeltaOffset+=u.newLength-u.oldLength}const T=R._merge(this._result);return R._removeNoOps(T)}_acceptCurr(l){this._result[this._resultLen++]=R._rebaseCurr(this._prevDeltaOffset,l),this._currDeltaOffset+=l.newLength-l.oldLength}_getCurr(l){return l<this._currLen?this._currEdits[l]:null}_acceptPrev(l){this._result[this._resultLen++]=R._rebasePrev(this._currDeltaOffset,l),this._prevDeltaOffset+=l.newLength-l.oldLength}_getPrev(l){return l<this._prevLen?this._prevEdits[l]:null}static _rebaseCurr(l,P){return new A(P.oldPosition-l,P.oldText,P.newPosition,P.newText)}static _rebasePrev(l,P){return new A(P.oldPosition,P.oldText,P.newPosition+l,P.newText)}static _splitPrev(l,P){const y=l.newText.substr(0,P),d=l.newText.substr(P);return[new A(l.oldPosition,l.oldText,l.newPosition,y),new A(l.oldEnd,"",l.newPosition+P,d)]}static _splitCurr(l,P){const y=l.oldText.substr(0,P),d=l.oldText.substr(P);return[new A(l.oldPosition,y,l.newPosition,l.newText),new A(l.oldPosition+P,d,l.newEnd,"")]}static _merge(l){if(l.length===0)return l;const P=[];let y=0,d=l[0];for(let T=1;T<l.length;T++){const E=l[T];d.oldEnd===E.oldPosition?d=new A(d.oldPosition,d.oldText+E.oldText,d.newPosition,d.newText+E.newText):(P[y++]=d,d=E)}return P[y++]=d,P}static _removeNoOps(l){if(l.length===0)return l;const P=[];let y=0;for(let d=0;d<l.length;d++){const T=l[d];T.oldText!==T.newText&&(P[y++]=T)}return P}}}),define(we[211],ye([1,0,39,16]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=k,e.targetsNotebooks=A;function k(L,R,v,l,P,y){if(Array.isArray(L)){let d=0;for(const T of L){const E=k(T,R,v,l,P,y);if(E===10)return E;E>d&&(d=E)}return d}else{if(typeof L=="string")return l?L==="*"?5:L===v?10:0:0;if(L){const{language:d,pattern:T,scheme:E,hasAccessToAllModels:a,notebookType:u}=L;if(!l&&!a)return 0;u&&P&&(R=P);let f=0;if(E)if(E===R.scheme)f=10;else if(E==="*")f=5;else return 0;if(d)if(d===v)f=10;else if(d==="*")f=Math.max(f,5);else return 0;if(u)if(u===y)f=10;else if(u==="*"&&y!==void 0)f=Math.max(f,5);else return 0;if(T){let m;if(typeof T=="string"?m=T:m={...T,base:(0,g.normalize)(T.base)},m===R.fsPath||(0,r.match)(m,R.fsPath))f=10;else return 0}return f}else return 0}}function A(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(A):!!L.notebookType}}),define(we[212],ye([1,0,4,13,31,55,138,187,210,3]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class P extends l.Disposable{constructor(d,T,E,a,u,f,m){super(),this._onDidChangeContent=this._register(new r.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=T,this._mightContainNonBasicASCII=!f,this._mightContainRTL=a,this._mightContainUnusualLineTerminators=u,this._pieceTree=new L.PieceTreeBase(d,E,m)}equals(d){return!(d instanceof P)||this._BOM!==d._BOM||this.getEOL()!==d.getEOL()?!1:this._pieceTree.equal(d._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(d){return this._pieceTree.createSnapshot(d?this._BOM:"")}getOffsetAt(d,T){return this._pieceTree.getOffsetAt(d,T)}getPositionAt(d){return this._pieceTree.getPositionAt(d)}getRangeAt(d,T){const E=d+T,a=this.getPositionAt(d),u=this.getPositionAt(E);return new k.Range(a.lineNumber,a.column,u.lineNumber,u.column)}getValueInRange(d,T=A.EndOfLinePreference.TextDefined){if(d.isEmpty())return"";const E=this._getEndOfLine(T);return this._pieceTree.getValueInRange(d,E)}getValueLengthInRange(d,T=A.EndOfLinePreference.TextDefined){if(d.isEmpty())return 0;if(d.startLineNumber===d.endLineNumber)return d.endColumn-d.startColumn;const E=this.getOffsetAt(d.startLineNumber,d.startColumn),a=this.getOffsetAt(d.endLineNumber,d.endColumn);let u=0;const f=this._getEndOfLine(T),m=this.getEOL();if(f.length!==m.length){const n=f.length-m.length,s=d.endLineNumber-d.startLineNumber;u=n*s}return a-E+u}getCharacterCountInRange(d,T=A.EndOfLinePreference.TextDefined){if(this._mightContainNonBasicASCII){let E=0;const a=d.startLineNumber,u=d.endLineNumber;for(let f=a;f<=u;f++){const m=this.getLineContent(f),n=f===a?d.startColumn-1:0,s=f===u?d.endColumn-1:m.length;for(let i=n;i<s;i++)g.isHighSurrogate(m.charCodeAt(i))?(E=E+1,i=i+1):E=E+1}return E+=this._getEndOfLine(T).length*(u-a),E}return this.getValueLengthInRange(d,T)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(d){return this._pieceTree.getLineContent(d)}getLineCharCode(d,T){return this._pieceTree.getLineCharCode(d,T)}getCharCode(d){return this._pieceTree.getCharCode(d)}getLineLength(d){return this._pieceTree.getLineLength(d)}getLineMinColumn(d){return 1}getLineMaxColumn(d){return this.getLineLength(d)+1}getLineFirstNonWhitespaceColumn(d){const T=g.firstNonWhitespaceIndex(this.getLineContent(d));return T===-1?0:T+1}getLineLastNonWhitespaceColumn(d){const T=g.lastNonWhitespaceIndex(this.getLineContent(d));return T===-1?0:T+2}_getEndOfLine(d){switch(d){case A.EndOfLinePreference.LF:return`
`;case A.EndOfLinePreference.CRLF:return`\r
`;case A.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(d){this._pieceTree.setEOL(d)}applyEdits(d,T,E){let a=this._mightContainRTL,u=this._mightContainUnusualLineTerminators,f=this._mightContainNonBasicASCII,m=!0,n=[];for(let p=0;p<d.length;p++){const _=d[p];m&&_._isTracked&&(m=!1);const D=_.range;if(_.text){let w=!0;f||(w=!g.isBasicASCII(_.text),f=w),!a&&w&&(a=g.containsRTL(_.text)),!u&&w&&(u=g.containsUnusualLineTerminators(_.text))}let C="",S=0,I=0,b=0;if(_.text){let w;[S,I,b,w]=(0,R.countEOL)(_.text);const N=this.getEOL(),O=N===`\r
`?R.StringEOL.CRLF:R.StringEOL.LF;w===R.StringEOL.Unknown||w===O?C=_.text:C=_.text.replace(/\r\n|\r|\n/g,N)}n[p]={sortIndex:p,identifier:_.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:C,eolCount:S,firstLineLength:I,lastLineLength:b,forceMoveMarkers:!!_.forceMoveMarkers,isAutoWhitespaceEdit:_.isAutoWhitespaceEdit||!1}}n.sort(P._sortOpsAscending);let s=!1;for(let p=0,_=n.length-1;p<_;p++){const D=n[p].range.getEndPosition(),C=n[p+1].range.getStartPosition();if(C.isBeforeOrEqual(D)){if(C.isBefore(D))throw new Error("Overlapping ranges are not allowed!");s=!0}}m&&(n=this._reduceOperations(n));const i=E||T?P._getInverseEditRanges(n):[],t=[];if(T)for(let p=0;p<n.length;p++){const _=n[p],D=i[p];if(_.isAutoWhitespaceEdit&&_.range.isEmpty())for(let C=D.startLineNumber;C<=D.endLineNumber;C++){let S="";C===D.startLineNumber&&(S=this.getLineContent(_.range.startLineNumber),g.firstNonWhitespaceIndex(S)!==-1)||t.push({lineNumber:C,oldContent:S})}}let c=null;if(E){let p=0;c=[];for(let _=0;_<n.length;_++){const D=n[_],C=i[_],S=this.getValueInRange(D.range),I=D.rangeOffset+p;p+=D.text.length-S.length,c[_]={sortIndex:D.sortIndex,identifier:D.identifier,range:C,text:S,textChange:new v.TextChange(D.rangeOffset,S,I,D.text)}}s||c.sort((_,D)=>_.sortIndex-D.sortIndex)}this._mightContainRTL=a,this._mightContainUnusualLineTerminators=u,this._mightContainNonBasicASCII=f;const h=this._doApplyEdits(n);let o=null;if(T&&t.length>0){t.sort((p,_)=>_.lineNumber-p.lineNumber),o=[];for(let p=0,_=t.length;p<_;p++){const D=t[p].lineNumber;if(p>0&&t[p-1].lineNumber===D)continue;const C=t[p].oldContent,S=this.getLineContent(D);S.length===0||S===C||g.firstNonWhitespaceIndex(S)!==-1||o.push(D)}}return this._onDidChangeContent.fire(),new A.ApplyEditsResult(c,h,o)}_reduceOperations(d){return d.length<1e3?d:[this._toSingleEditOperation(d)]}_toSingleEditOperation(d){let T=!1;const E=d[0].range,a=d[d.length-1].range,u=new k.Range(E.startLineNumber,E.startColumn,a.endLineNumber,a.endColumn);let f=E.startLineNumber,m=E.startColumn;const n=[];for(let h=0,o=d.length;h<o;h++){const p=d[h],_=p.range;T=T||p.forceMoveMarkers,n.push(this.getValueInRange(new k.Range(f,m,_.startLineNumber,_.startColumn))),p.text.length>0&&n.push(p.text),f=_.endLineNumber,m=_.endColumn}const s=n.join(""),[i,t,c]=(0,R.countEOL)(s);return{sortIndex:0,identifier:d[0].identifier,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u,A.EndOfLinePreference.TextDefined),text:s,eolCount:i,firstLineLength:t,lastLineLength:c,forceMoveMarkers:T,isAutoWhitespaceEdit:!1}}_doApplyEdits(d){d.sort(P._sortOpsDescending);const T=[];for(let E=0;E<d.length;E++){const a=d[E],u=a.range.startLineNumber,f=a.range.startColumn,m=a.range.endLineNumber,n=a.range.endColumn;if(u===m&&f===n&&a.text.length===0)continue;a.text?(this._pieceTree.delete(a.rangeOffset,a.rangeLength),this._pieceTree.insert(a.rangeOffset,a.text,!0)):this._pieceTree.delete(a.rangeOffset,a.rangeLength);const s=new k.Range(u,f,m,n);T.push({range:s,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return T}findMatchesLineByLine(d,T,E,a){return this._pieceTree.findMatchesLineByLine(d,T,E,a)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(d,T){const E=d.startLineNumber,a=d.startColumn,[u,f,m]=(0,R.countEOL)(T);let n;if(T.length>0){const s=u+1;s===1?n=new k.Range(E,a,E,a+f):n=new k.Range(E,a,E+s-1,m+1)}else n=new k.Range(E,a,E,a);return n}static _getInverseEditRanges(d){const T=[];let E=0,a=0,u=null;for(let f=0,m=d.length;f<m;f++){const n=d[f];let s,i;u?u.range.endLineNumber===n.range.startLineNumber?(s=E,i=a+(n.range.startColumn-u.range.endColumn)):(s=E+(n.range.startLineNumber-u.range.endLineNumber),i=n.range.startColumn):(s=n.range.startLineNumber,i=n.range.startColumn);let t;if(n.text.length>0){const c=n.eolCount+1;c===1?t=new k.Range(s,i,s,i+n.firstLineLength):t=new k.Range(s,i,s+c-1,n.lastLineLength+1)}else t=new k.Range(s,i,s,i);E=t.endLineNumber,a=t.endColumn,T.push(t),u=n}return T}static _sortOpsAscending(d,T){const E=k.Range.compareRangesUsingEnds(d.range,T.range);return E===0?d.sortIndex-T.sortIndex:E}static _sortOpsDescending(d,T){const E=k.Range.compareRangesUsingEnds(d.range,T.range);return E===0?T.sortIndex-d.sortIndex:-E}}e.PieceTreeTextBuffer=P}),define(we[213],ye([1,0,27,13,55,138,212]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class R{constructor(P,y,d,T,E,a,u,f,m){this._chunks=P,this._bom=y,this._cr=d,this._lf=T,this._crlf=E,this._containsRTL=a,this._containsUnusualLineTerminators=u,this._isBasicASCII=f,this._normalizeEOL=m}_getEOL(P){const y=this._cr+this._lf+this._crlf,d=this._cr+this._crlf;return y===0?P===k.DefaultEndOfLine.LF?`
`:`\r
`:d>y/2?`\r
`:`
`}create(P){const y=this._getEOL(P),d=this._chunks;if(this._normalizeEOL&&(y===`\r
`&&(this._cr>0||this._lf>0)||y===`
`&&(this._cr>0||this._crlf>0)))for(let E=0,a=d.length;E<a;E++){const u=d[E].buffer.replace(/\r\n|\r|\n/g,y),f=(0,A.createLineStartsFast)(u);d[E]=new A.StringBuffer(u,f)}const T=new L.PieceTreeTextBuffer(d,this._bom,y,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:T,disposable:T}}getFirstLineText(P){return this._chunks[0].buffer.substr(0,P).split(/\r\n|\r|\n/)[0]}}class v{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(P){if(P.length===0)return;this.chunks.length===0&&g.startsWithUTF8BOM(P)&&(this.BOM=g.UTF8_BOM_CHARACTER,P=P.substr(1));const y=P.charCodeAt(P.length-1);y===r.CharCode.CarriageReturn||y>=55296&&y<=56319?(this._acceptChunk1(P.substr(0,P.length-1),!1),this._hasPreviousChar=!0,this._previousChar=y):(this._acceptChunk1(P,!1),this._hasPreviousChar=!1,this._previousChar=y)}_acceptChunk1(P,y){!y&&P.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+P):this._acceptChunk2(P))}_acceptChunk2(P){const y=(0,A.createLineStarts)(this._tmpLineStarts,P);this.chunks.push(new A.StringBuffer(P,y.lineStarts)),this.cr+=y.cr,this.lf+=y.lf,this.crlf+=y.crlf,y.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=g.containsRTL(P)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=g.containsUnusualLineTerminators(P)))}finish(P=!0){return this._finish(),new R(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,P)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const P=this.chunks[this.chunks.length-1];P.buffer+=String.fromCharCode(this._previousChar);const y=(0,A.createLineStartsFast)(P.buffer);P.lineStarts=y,this._previousChar===r.CharCode.CarriageReturn&&this.cr++}}}e.PieceTreeTextBufferBuilder=v}),define(we[142],ye([1,0,22,11]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=v,e.decodeSemanticTokensDto=P;var k;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(k||(k={}));function A(y){for(let d=0,T=y.length;d<T;d+=4){const E=y[d+0],a=y[d+1],u=y[d+2],f=y[d+3];y[d+0]=f,y[d+1]=u,y[d+2]=a,y[d+3]=E}}function L(y){const d=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return g.isLittleEndian()||A(d),r.VSBuffer.wrap(d)}function R(y){const d=y.buffer;if(g.isLittleEndian()||A(d),d.byteOffset%4===0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const T=new Uint8Array(d.byteLength);return T.set(d),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function v(y){const d=new Uint32Array(l(y));let T=0;if(d[T++]=y.id,y.type==="full")d[T++]=k.Full,d[T++]=y.data.length,d.set(y.data,T),T+=y.data.length;else{d[T++]=k.Delta,d[T++]=y.deltas.length;for(const E of y.deltas)d[T++]=E.start,d[T++]=E.deleteCount,E.data?(d[T++]=E.data.length,d.set(E.data,T),T+=E.data.length):d[T++]=0}return L(d)}function l(y){let d=0;if(d+=2,y.type==="full")d+=1+y.data.length;else{d+=1,d+=3*y.deltas.length;for(const T of y.deltas)T.data&&(d+=T.data.length)}return d}function P(y){const d=R(y);let T=0;const E=d[T++];if(d[T++]===k.Full){const m=d[T++],n=d.subarray(T,T+m);return T+=m,{id:E,type:"full",data:n}}const u=d[T++],f=[];for(let m=0;m<u;m++){const n=d[T++],s=d[T++],i=d[T++];let t;i>0&&(t=d.subarray(T,T+i),T+=i),f[m]={start:n,deleteCount:s,data:t}}return{id:E,type:"delta",deltas:f}}}),define(we[214],ye([7,8]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(we[215],ye([7,8]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(we[88],ye([1,0,83,2,188,31,198,215]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.symbolKindNames=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0,e.isLocationLink=h,e.getAriaLabelForSymbol=p;class v{constructor(q,Z,ne){this.offset=q,this.type=Z,this.language=ne,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=v;class l{constructor(q,Z){this.tokens=q,this.endState=Z,this._tokenizationResultBrand=void 0}}e.TokenizationResult=l;class P{constructor(q,Z){this.tokens=q,this.endState=Z,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=P;var y;(function($){$[$.Increase=0]="Increase",$[$.Decrease=1]="Decrease"})(y||(e.HoverVerbosityAction=y={}));var d;(function($){$[$.Method=0]="Method",$[$.Function=1]="Function",$[$.Constructor=2]="Constructor",$[$.Field=3]="Field",$[$.Variable=4]="Variable",$[$.Class=5]="Class",$[$.Struct=6]="Struct",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Event=10]="Event",$[$.Operator=11]="Operator",$[$.Unit=12]="Unit",$[$.Value=13]="Value",$[$.Constant=14]="Constant",$[$.Enum=15]="Enum",$[$.EnumMember=16]="EnumMember",$[$.Keyword=17]="Keyword",$[$.Text=18]="Text",$[$.Color=19]="Color",$[$.File=20]="File",$[$.Reference=21]="Reference",$[$.Customcolor=22]="Customcolor",$[$.Folder=23]="Folder",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue",$[$.Snippet=27]="Snippet"})(d||(e.CompletionItemKind=d={}));var T;(function($){const q=new Map;q.set(d.Method,r.Codicon.symbolMethod),q.set(d.Function,r.Codicon.symbolFunction),q.set(d.Constructor,r.Codicon.symbolConstructor),q.set(d.Field,r.Codicon.symbolField),q.set(d.Variable,r.Codicon.symbolVariable),q.set(d.Class,r.Codicon.symbolClass),q.set(d.Struct,r.Codicon.symbolStruct),q.set(d.Interface,r.Codicon.symbolInterface),q.set(d.Module,r.Codicon.symbolModule),q.set(d.Property,r.Codicon.symbolProperty),q.set(d.Event,r.Codicon.symbolEvent),q.set(d.Operator,r.Codicon.symbolOperator),q.set(d.Unit,r.Codicon.symbolUnit),q.set(d.Value,r.Codicon.symbolValue),q.set(d.Enum,r.Codicon.symbolEnum),q.set(d.Constant,r.Codicon.symbolConstant),q.set(d.Enum,r.Codicon.symbolEnum),q.set(d.EnumMember,r.Codicon.symbolEnumMember),q.set(d.Keyword,r.Codicon.symbolKeyword),q.set(d.Snippet,r.Codicon.symbolSnippet),q.set(d.Text,r.Codicon.symbolText),q.set(d.Color,r.Codicon.symbolColor),q.set(d.File,r.Codicon.symbolFile),q.set(d.Reference,r.Codicon.symbolReference),q.set(d.Customcolor,r.Codicon.symbolCustomColor),q.set(d.Folder,r.Codicon.symbolFolder),q.set(d.TypeParameter,r.Codicon.symbolTypeParameter),q.set(d.User,r.Codicon.account),q.set(d.Issue,r.Codicon.issues);function Z(re){let Se=q.get(re);return Se||(console.info("No codicon found for CompletionItemKind "+re),Se=r.Codicon.symbolProperty),Se}$.toIcon=Z;const ne=new Map;ne.set("method",d.Method),ne.set("function",d.Function),ne.set("constructor",d.Constructor),ne.set("field",d.Field),ne.set("variable",d.Variable),ne.set("class",d.Class),ne.set("struct",d.Struct),ne.set("interface",d.Interface),ne.set("module",d.Module),ne.set("property",d.Property),ne.set("event",d.Event),ne.set("operator",d.Operator),ne.set("unit",d.Unit),ne.set("value",d.Value),ne.set("constant",d.Constant),ne.set("enum",d.Enum),ne.set("enum-member",d.EnumMember),ne.set("enumMember",d.EnumMember),ne.set("keyword",d.Keyword),ne.set("snippet",d.Snippet),ne.set("text",d.Text),ne.set("color",d.Color),ne.set("file",d.File),ne.set("reference",d.Reference),ne.set("customcolor",d.Customcolor),ne.set("folder",d.Folder),ne.set("type-parameter",d.TypeParameter),ne.set("typeParameter",d.TypeParameter),ne.set("account",d.User),ne.set("issue",d.Issue);function de(re,Se){let ve=ne.get(re);return typeof ve>"u"&&!Se&&(ve=d.Property),ve}$.fromString=de})(T||(e.CompletionItemKinds=T={}));var E;(function($){$[$.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var a;(function($){$[$.None=0]="None",$[$.KeepWhitespace=1]="KeepWhitespace",$[$.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var u;(function($){$[$.Word=0]="Word",$[$.Line=1]="Line",$[$.Suggest=2]="Suggest"})(u||(e.PartialAcceptTriggerKind=u={}));var f;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(e.CompletionTriggerKind=f={}));var m;(function($){$[$.Automatic=0]="Automatic",$[$.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class n{constructor(q,Z,ne,de){this.range=q,this.text=Z,this.completionKind=ne,this.isSnippetText=de}equals(q){return A.Range.lift(this.range).equalsRange(q.range)&&this.text===q.text&&this.completionKind===q.completionKind&&this.isSnippetText===q.isSnippetText}}e.SelectedSuggestionInfo=n;var s;(function($){$[$.Invoke=1]="Invoke",$[$.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var i;(function($){$[$.Automatic=0]="Automatic",$[$.PasteAs=1]="PasteAs"})(i||(e.DocumentPasteTriggerKind=i={}));var t;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var c;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(c||(e.DocumentHighlightKind=c={}));function h($){return $&&g.URI.isUri($.uri)&&A.Range.isIRange($.range)&&(A.Range.isIRange($.originSelectionRange)||A.Range.isIRange($.targetSelectionRange))}var o;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(o||(e.SymbolKind=o={})),e.symbolKindNames={[o.Array]:(0,R.localize)(0,null),[o.Boolean]:(0,R.localize)(1,null),[o.Class]:(0,R.localize)(2,null),[o.Constant]:(0,R.localize)(3,null),[o.Constructor]:(0,R.localize)(4,null),[o.Enum]:(0,R.localize)(5,null),[o.EnumMember]:(0,R.localize)(6,null),[o.Event]:(0,R.localize)(7,null),[o.Field]:(0,R.localize)(8,null),[o.File]:(0,R.localize)(9,null),[o.Function]:(0,R.localize)(10,null),[o.Interface]:(0,R.localize)(11,null),[o.Key]:(0,R.localize)(12,null),[o.Method]:(0,R.localize)(13,null),[o.Module]:(0,R.localize)(14,null),[o.Namespace]:(0,R.localize)(15,null),[o.Null]:(0,R.localize)(16,null),[o.Number]:(0,R.localize)(17,null),[o.Object]:(0,R.localize)(18,null),[o.Operator]:(0,R.localize)(19,null),[o.Package]:(0,R.localize)(20,null),[o.Property]:(0,R.localize)(21,null),[o.String]:(0,R.localize)(22,null),[o.Struct]:(0,R.localize)(23,null),[o.TypeParameter]:(0,R.localize)(24,null),[o.Variable]:(0,R.localize)(25,null)};function p($,q){return(0,R.localize)(26,null,$,e.symbolKindNames[q])}var _;(function($){$[$.Deprecated=1]="Deprecated"})(_||(e.SymbolTag=_={}));var D;(function($){const q=new Map;q.set(o.File,r.Codicon.symbolFile),q.set(o.Module,r.Codicon.symbolModule),q.set(o.Namespace,r.Codicon.symbolNamespace),q.set(o.Package,r.Codicon.symbolPackage),q.set(o.Class,r.Codicon.symbolClass),q.set(o.Method,r.Codicon.symbolMethod),q.set(o.Property,r.Codicon.symbolProperty),q.set(o.Field,r.Codicon.symbolField),q.set(o.Constructor,r.Codicon.symbolConstructor),q.set(o.Enum,r.Codicon.symbolEnum),q.set(o.Interface,r.Codicon.symbolInterface),q.set(o.Function,r.Codicon.symbolFunction),q.set(o.Variable,r.Codicon.symbolVariable),q.set(o.Constant,r.Codicon.symbolConstant),q.set(o.String,r.Codicon.symbolString),q.set(o.Number,r.Codicon.symbolNumber),q.set(o.Boolean,r.Codicon.symbolBoolean),q.set(o.Array,r.Codicon.symbolArray),q.set(o.Object,r.Codicon.symbolObject),q.set(o.Key,r.Codicon.symbolKey),q.set(o.Null,r.Codicon.symbolNull),q.set(o.EnumMember,r.Codicon.symbolEnumMember),q.set(o.Struct,r.Codicon.symbolStruct),q.set(o.Event,r.Codicon.symbolEvent),q.set(o.Operator,r.Codicon.symbolOperator),q.set(o.TypeParameter,r.Codicon.symbolTypeParameter);function Z(ne){let de=q.get(ne);return de||(console.info("No codicon found for SymbolKind "+ne),de=r.Codicon.symbolProperty),de}$.toIcon=Z})(D||(e.SymbolKinds=D={}));class C{static asEditOperation(q){return k.EditOperation.replace(A.Range.lift(q.range),q.text)}}e.TextEdit=C;class S{static{this.Comment=new S("comment")}static{this.Imports=new S("imports")}static{this.Region=new S("region")}static fromValue(q){switch(q){case"comment":return S.Comment;case"imports":return S.Imports;case"region":return S.Region}return new S(q)}constructor(q){this.value=q}}e.FoldingRangeKind=S;var I;(function($){$[$.AIGenerated=1]="AIGenerated"})(I||(e.NewSymbolNameTag=I={}));var b;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(b||(e.NewSymbolNameTriggerKind=b={}));var w;(function($){function q(Z){return!Z||typeof Z!="object"?!1:typeof Z.id=="string"&&typeof Z.title=="string"}$.is=q})(w||(e.Command=w={}));var N;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(N||(e.CommentThreadCollapsibleState=N={}));var O;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(O||(e.CommentThreadState=O={}));var U;(function($){$[$.Current=0]="Current",$[$.Outdated=1]="Outdated"})(U||(e.CommentThreadApplicability=U={}));var x;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(x||(e.CommentMode=x={}));var B;(function($){$[$.Published=0]="Published",$[$.Draft=1]="Draft"})(B||(e.CommentState=B={}));var F;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class M{constructor(q){this.createSupport=q,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(q=>{q&&q.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=M,e.TokenizationRegistry=new L.TokenizationRegistry;var K;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(K||(e.ExternalUriOpenerPriority=K={}));var ee;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(ee||(e.InlineEditTriggerKind=ee={}))}),define(we[216],ye([7,8]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[217],ye([7,8]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(we[218],ye([7,8]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(we[219],ye([7,8]),function(he,e){return he.create("vs/platform/dialogs/common/dialogs",e)}),define(we[220],ye([7,8]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[221],ye([7,8]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[222],ye([7,8]),function(he,e){return he.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(we[223],ye([7,8]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(we[224],ye([7,8]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(we[225],ye([7,8]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[226],ye([7,8]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(we[227],ye([7,8]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(we[228],ye([7,8]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(we[229],ye([7,8]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(we[230],ye([7,8]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(we[231],ye([7,8]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(we[232],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[233],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[234],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(we[235],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(we[236],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(we[237],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(we[238],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[239],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(we[240],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[241],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[242],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(we[243],ye([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[244],ye([7,8]),function(he,e){return he.create("vs/workbench/api/node/extHostDebugService",e)}),define(we[245],ye([7,8]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(we[246],ye([7,8]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(we[247],ye([7,8]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(we[248],ye([7,8]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(we[249],ye([7,8]),function(he,e){return he.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(we[250],ye([7,8]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[251],ye([7,8]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(we[252],ye([7,8]),function(he,e){return he.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(we[253],ye([7,8]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(we[254],ye([7,8]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(we[255],ye([7,8]),function(he,e){return he.create("vs/workbench/contrib/testing/common/constants",e)}),define(we[256],ye([7,8]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[257],ye([7,8]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(we[258],ye([7,8]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(we[259],ye([7,8]),function(he,e){return he.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(we[260],ye([7,8]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(we[261],ye([1,0,27,14,218]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(P){P[P.LParen=0]="LParen",P[P.RParen=1]="RParen",P[P.Neg=2]="Neg",P[P.Eq=3]="Eq",P[P.NotEq=4]="NotEq",P[P.Lt=5]="Lt",P[P.LtEq=6]="LtEq",P[P.Gt=7]="Gt",P[P.GtEq=8]="GtEq",P[P.RegexOp=9]="RegexOp",P[P.RegexStr=10]="RegexStr",P[P.True=11]="True",P[P.False=12]="False",P[P.In=13]="In",P[P.Not=14]="Not",P[P.And=15]="And",P[P.Or=16]="Or",P[P.Str=17]="Str",P[P.QuotedStr=18]="QuotedStr",P[P.Error=19]="Error",P[P.EOF=20]="EOF"})(A||(e.TokenType=A={}));function L(...P){switch(P.length){case 1:return(0,k.localize)(0,null,P[0]);case 2:return(0,k.localize)(1,null,P[0],P[1]);case 3:return(0,k.localize)(2,null,P[0],P[1],P[2]);default:return}}const R=(0,k.localize)(3,null),v=(0,k.localize)(4,null);class l{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return y.isTripleEq?"===":"==";case A.NotEq:return y.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return y.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return y.lexeme;case A.QuotedStr:return y.lexeme;case A.Error:return y.lexeme;case A.EOF:return"EOF";default:throw(0,g.illegalState)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this._keywords=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this._errors}reset(y){return this._input=y,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case r.CharCode.OpenParen:this._addToken(A.LParen);break;case r.CharCode.CloseParen:this._addToken(A.RParen);break;case r.CharCode.ExclamationMark:if(this._match(r.CharCode.Equals)){const d=this._match(r.CharCode.Equals);this._tokens.push({type:A.NotEq,offset:this._start,isTripleEq:d})}else this._addToken(A.Neg);break;case r.CharCode.SingleQuote:this._quotedString();break;case r.CharCode.Slash:this._regex();break;case r.CharCode.Equals:if(this._match(r.CharCode.Equals)){const d=this._match(r.CharCode.Equals);this._tokens.push({type:A.Eq,offset:this._start,isTripleEq:d})}else this._match(r.CharCode.Tilde)?this._addToken(A.RegexOp):this._error(L("==","=~"));break;case r.CharCode.LessThan:this._addToken(this._match(r.CharCode.Equals)?A.LtEq:A.Lt);break;case r.CharCode.GreaterThan:this._addToken(this._match(r.CharCode.Equals)?A.GtEq:A.Gt);break;case r.CharCode.Ampersand:this._match(r.CharCode.Ampersand)?this._addToken(A.And):this._error(L("&&"));break;case r.CharCode.Pipe:this._match(r.CharCode.Pipe)?this._addToken(A.Or):this._error(L("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(A.EOF),Array.from(this._tokens)}_match(y){return this._isAtEnd()||this._input.charCodeAt(this._current)!==y?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?r.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(y){this._tokens.push({type:y,offset:this._start})}_error(y){const d=this._start,T=this._input.substring(this._start,this._current),E={type:A.Error,offset:this._start,lexeme:T};this._errors.push({offset:d,lexeme:T,additionalInfo:y}),this._tokens.push(E)}_string(){this.stringRe.lastIndex=this._start;const y=this.stringRe.exec(this._input);if(y){this._current=this._start+y[0].length;const d=this._input.substring(this._start,this._current),T=l._keywords.get(d);T?this._addToken(T):this._tokens.push({type:A.Str,lexeme:d,offset:this._start})}}_quotedString(){for(;this._peek()!==r.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:A.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let y=this._current,d=!1,T=!1;for(;;){if(y>=this._input.length){this._current=y,this._error(v);return}const a=this._input.charCodeAt(y);if(d)d=!1;else if(a===r.CharCode.Slash&&!T){y++;break}else a===r.CharCode.OpenSquareBracket?T=!0:a===r.CharCode.Backslash?d=!0:a===r.CharCode.CloseSquareBracket&&(T=!1);y++}for(;y<this._input.length&&l._regexFlags.has(this._input.charCodeAt(y));)y++;this._current=y;const E=this._input.substring(this._start,this._current);this._tokens.push({type:A.RegexStr,lexeme:E,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=l}),define(we[262],ye([1,0,23,43,221,411]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=v,e.parseVersion=l,e.normalizeVersion=P,e.isValidVersion=y,e.validateExtensionManifest=d,e.isValidExtensionVersion=T,e.isEngineValid=E;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function v(f){return f=f.trim(),f==="*"||L.test(f)}function l(f){if(!v(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=f.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}function P(f){if(!f)return null;const m=f.majorBase,n=f.majorMustEqual,s=f.minorBase;let i=f.minorMustEqual;const t=f.patchBase;let c=f.patchMustEqual;f.hasCaret&&(m===0||(i=!1),c=!1);let h=0;if(f.preRelease){const o=R.exec(f.preRelease);if(o){const[,p,_,D]=o;h=Date.UTC(Number(p),Number(_)-1,Number(D))}}return{majorBase:m,majorMustEqual:n,minorBase:s,minorMustEqual:i,patchBase:t,patchMustEqual:c,isMinimum:f.hasGreaterEquals,notBefore:h}}function y(f,m,n){let s;typeof f=="string"?s=P(l(f)):s=f;let i;m instanceof Date?i=m.getTime():typeof m=="string"&&(i=new Date(m).getTime());let t;if(typeof n=="string"?t=P(l(n)):t=n,!s||!t)return!1;const c=s.majorBase,h=s.minorBase,o=s.patchBase;let p=t.majorBase,_=t.minorBase,D=t.patchBase;const C=t.notBefore;let S=t.majorMustEqual,I=t.minorMustEqual,b=t.patchMustEqual;return t.isMinimum?c>p?!0:c<p?!1:h>_?!0:h<_||i&&i<C?!1:o>=D:(c===1&&p===0&&(!S||!I||!b)&&(p=1,_=0,D=0,S=!0,I=!1,b=!1),c<p?!1:c>p?!S:h<_?!1:h>_?!I:o<D?!1:o>D?!b:!(i&&i<C))}function d(f,m,n,s,i){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([g.default.Error,k.localize(0,null)]),t;if(typeof s.name!="string")return t.push([g.default.Error,k.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([g.default.Error,k.localize(2,null,"version")]),t;if(!s.engines)return t.push([g.default.Error,k.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([g.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!u(s.extensionDependencies))return t.push([g.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!u(s.activationEvents))return t.push([g.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([g.default.Error,k.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([g.default.Warning,k.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([g.default.Error,k.localize(9,null,"main")]),t;{const o=(0,r.joinPath)(n,s.main);(0,r.isEqualOrParent)(o,n)||t.push([g.default.Warning,k.localize(10,null,o.path,n.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([g.default.Error,k.localize(11,null,"browser")]),t;{const o=(0,r.joinPath)(n,s.browser);(0,r.isEqualOrParent)(o,n)||t.push([g.default.Warning,k.localize(12,null,o.path,n.path)])}}if(!A.valid(s.version))return t.push([g.default.Error,k.localize(13,null)]),t;const c=[];if(!T(f,m,s,i,c))for(const o of c)t.push([g.default.Error,o]);return t}function T(f,m,n,s,i){return s||typeof n.main>"u"&&typeof n.browser>"u"?!0:a(f,m,n.engines.vscode,i)}function E(f,m,n){return f==="*"||a(m,n,f)}function a(f,m,n,s=[]){const i=P(l(n));if(!i)return s.push(k.localize(14,null,n)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return s.push(k.localize(15,null,n)),!1}else if(!i.majorMustEqual)return s.push(k.localize(16,null,n)),!1;return y(f,m,i)?!0:(s.push(k.localize(17,null,f,n)),!1)}function u(f){if(!Array.isArray(f))return!1;for(let m=0,n=f.length;m<n;m++)if(typeof f[m]!="string")return!1;return!0}}),define(we[112],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(k,A=[],L=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=r}),define(we[89],ye([1,0,112]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=A,e.getSingletonServiceDescriptors=L;const g=[];var k;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(R,v,l){v instanceof r.SyncDescriptor||(v=new r.SyncDescriptor(v,[],!!l)),g.push([R,v])}function L(){return g}}),define(we[263],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(A,L){this.key=A,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=r;class g{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const L of this._nodes.values())L.outgoing.size===0&&A.push(L);return A}insertEdge(A,L){const R=this.lookupOrInsertNode(A),v=this.lookupOrInsertNode(L);R.outgoing.set(v.key,v),v.incoming.set(R.key,R)}removeNode(A){const L=this._hashFn(A);this._nodes.delete(L);for(const R of this._nodes.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(A){const L=this._hashFn(A);let R=this._nodes.get(L);return R||(R=new r(L,A),this._nodes.set(L,R)),R}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[L,R]of this._nodes)A.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,L]of this._nodes){const R=new Set([A]),v=this._findCycle(L,R);if(v)return v}}_findCycle(A,L){for(const[R,v]of A.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const l=this._findCycle(v,L);if(l)return l;L.delete(R)}}}e.Graph=g}),define(we[5],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=k,e.refineServiceDecorator=A;var r;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function R(v){return v[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=R})(r||(e._util=r={})),e.IInstantiationService=k("instantiationService");function g(L,R,v){R[r.DI_TARGET]===R?R[r.DI_DEPENDENCIES].push({id:L,index:v}):(R[r.DI_DEPENDENCIES]=[{id:L,index:v}],R[r.DI_TARGET]=R)}function k(L){if(r.serviceIds.has(L))return r.serviceIds.get(L);const R=function(v,l,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");g(R,v,P)};return R.toString=()=>L,r.serviceIds.set(L,R),R}function A(L){return L}}),define(we[44],ye([1,0,18,2,5]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=A,e.isConfigurationUpdateOverrides=L,e.ConfigurationTargetToString=v,e.isConfigured=l,e.toValuesTree=P,e.addToValueTree=y,e.removeFromValueTree=d,e.getConfigurationValue=E,e.merge=a,e.getLanguageTagSettingPlainKey=u,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof g.URI)}function L(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof g.URI)}var R;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function v(f){switch(f){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function l(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function P(f,m){const n=Object.create(null);for(const s in f)y(n,s,f[s],m);return n}function y(f,m,n,s){const i=m.split("."),t=i.pop();let c=f;for(let h=0;h<i.length;h++){const o=i[h];let p=c[o];switch(typeof p){case"undefined":p=c[o]=Object.create(null);break;case"object":if(p===null){s(`Ignoring ${m} as ${i.slice(0,h+1).join(".")} is null`);return}break;default:s(`Ignoring ${m} as ${i.slice(0,h+1).join(".")} is ${JSON.stringify(p)}`);return}c=p}if(typeof c=="object"&&c!==null)try{c[t]=n}catch{s(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(c)}`)}else s(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(c)}`)}function d(f,m){const n=m.split(".");T(f,n)}function T(f,m){const n=m.shift();if(m.length===0){delete f[n];return}if(Object.keys(f).indexOf(n)!==-1){const s=f[n];typeof s=="object"&&!Array.isArray(s)&&(T(s,m),Object.keys(s).length===0&&delete f[n])}}function E(f,m,n){function s(c,h){let o=c;for(const p of h){if(typeof o!="object"||o===null)return;o=o[p]}return o}const i=m.split("."),t=s(f,i);return typeof t>"u"?n:t}function a(f,m,n){Object.keys(m).forEach(s=>{s!=="__proto__"&&(s in f?r.isObject(f[s])&&r.isObject(m[s])?a(f[s],m[s],n):n&&(f[s]=m[s]):f[s]=m[s])})}function u(f){return f.replace(/[\[\]]/g,"")}}),define(we[35],ye([1,0,27,11,13,261,5,217,14]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=P,e.validateWhenClauses=h,e.expressionsAreEqualWithConstantSubstitution=o,e.implies=re;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",g.isMacintosh),l.set("isLinux",g.isLinux),l.set("isWindows",g.isWindows),l.set("isWeb",g.isWeb),l.set("isMacNative",g.isMacintosh&&!g.isWeb),l.set("isEdge",g.isEdge),l.set("isFirefox",g.isFirefox),l.set("isChrome",g.isChrome),l.set("isSafari",g.isSafari);function P(G,W){if(l.get(G)!==void 0)throw(0,v.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(G,W)}const y=Object.prototype.hasOwnProperty;var d;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const T={regexParsingWithErrorRecovery:!0},E=(0,R.localize)(0,null),a=(0,R.localize)(1,null),u=(0,R.localize)(2,null),f=(0,R.localize)(3,null),m=(0,R.localize)(4,null),n=(0,R.localize)(5,null),s=(0,R.localize)(6,null),i=(0,R.localize)(7,null);class t{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(W=T){this._config=W,this._scanner=new A.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(W){if(W===""){this._parsingErrors.push({message:E,offset:0,lexeme:"",additionalInfo:a});return}this._tokens=this._scanner.reset(W).scan(),this._current=0,this._parsingErrors=[];try{const se=this._expr();if(!this._isAtEnd()){const ae=this._peek(),ie=ae.type===A.TokenType.Str?n:void 0;throw this._parsingErrors.push({message:m,offset:ae.offset,lexeme:A.Scanner.getLexeme(ae),additionalInfo:ie}),t._parseError}return se}catch(se){if(se!==t._parseError)throw se;return}}_expr(){return this._or()}_or(){const W=[this._and()];for(;this._matchOne(A.TokenType.Or);){const se=this._and();W.push(se)}return W.length===1?W[0]:c.or(...W)}_and(){const W=[this._term()];for(;this._matchOne(A.TokenType.And);){const se=this._term();W.push(se)}return W.length===1?W[0]:c.and(...W)}_term(){if(this._matchOne(A.TokenType.Neg)){const W=this._peek();switch(W.type){case A.TokenType.True:return this._advance(),_.INSTANCE;case A.TokenType.False:return this._advance(),D.INSTANCE;case A.TokenType.LParen:{this._advance();const se=this._expr();return this._consume(A.TokenType.RParen,f),se?.negate()}case A.TokenType.Str:return this._advance(),N.create(W.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",W)}}return this._primary()}_primary(){const W=this._peek();switch(W.type){case A.TokenType.True:return this._advance(),c.true();case A.TokenType.False:return this._advance(),c.false();case A.TokenType.LParen:{this._advance();const se=this._expr();return this._consume(A.TokenType.RParen,f),se}case A.TokenType.Str:{const se=W.lexeme;if(this._advance(),this._matchOne(A.TokenType.RegexOp)){const ie=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),ie.type!==A.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",ie);const le=ie.lexeme,ue=le.lastIndexOf("/"),Y=ue===le.length-1?void 0:this._removeFlagsGY(le.substring(ue+1));let oe;try{oe=new RegExp(le.substring(1,ue),Y)}catch{throw this._errExpectedButGot("REGEX",ie)}return M.create(se,oe)}switch(ie.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const le=[ie.lexeme];this._advance();let ue=this._peek(),Y=0;for(let We=0;We<ie.lexeme.length;We++)ie.lexeme.charCodeAt(We)===r.CharCode.OpenParen?Y++:ie.lexeme.charCodeAt(We)===r.CharCode.CloseParen&&Y--;for(;!this._isAtEnd()&&ue.type!==A.TokenType.And&&ue.type!==A.TokenType.Or;){switch(ue.type){case A.TokenType.LParen:Y++;break;case A.TokenType.RParen:Y--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let We=0;We<ue.lexeme.length;We++)ue.lexeme.charCodeAt(We)===r.CharCode.OpenParen?Y++:ie.lexeme.charCodeAt(We)===r.CharCode.CloseParen&&Y--}if(Y<0)break;le.push(A.Scanner.getLexeme(ue)),this._advance(),ue=this._peek()}const oe=le.join(""),pe=oe.lastIndexOf("/"),Ee=pe===oe.length-1?void 0:this._removeFlagsGY(oe.substring(pe+1));let Ne;try{Ne=new RegExp(oe.substring(1,pe),Ee)}catch{throw this._errExpectedButGot("REGEX",ie)}return c.regex(se,Ne)}case A.TokenType.QuotedStr:{const le=ie.lexeme;this._advance();let ue=null;if(!(0,k.isFalsyOrWhitespace)(le)){const Y=le.indexOf("/"),oe=le.lastIndexOf("/");if(Y!==oe&&Y>=0){const pe=le.slice(Y+1,oe),Ee=le[oe+1]==="i"?"i":"";try{ue=new RegExp(pe,Ee)}catch{throw this._errExpectedButGot("REGEX",ie)}}}if(ue===null)throw this._errExpectedButGot("REGEX",ie);return M.create(se,ue)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(A.TokenType.Not)){this._consume(A.TokenType.In,u);const ie=this._value();return c.notIn(se,ie)}switch(this._peek().type){case A.TokenType.Eq:{this._advance();const ie=this._value();if(this._previous().type===A.TokenType.QuotedStr)return c.equals(se,ie);switch(ie){case"true":return c.has(se);case"false":return c.not(se);default:return c.equals(se,ie)}}case A.TokenType.NotEq:{this._advance();const ie=this._value();if(this._previous().type===A.TokenType.QuotedStr)return c.notEquals(se,ie);switch(ie){case"true":return c.not(se);case"false":return c.has(se);default:return c.notEquals(se,ie)}}case A.TokenType.Lt:return this._advance(),B.create(se,this._value());case A.TokenType.LtEq:return this._advance(),F.create(se,this._value());case A.TokenType.Gt:return this._advance(),U.create(se,this._value());case A.TokenType.GtEq:return this._advance(),x.create(se,this._value());case A.TokenType.In:return this._advance(),c.in(se,this._value());default:return c.has(se)}}case A.TokenType.EOF:throw this._parsingErrors.push({message:s,offset:W.offset,lexeme:"",additionalInfo:i}),t._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const W=this._peek();switch(W.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this._advance(),W.lexeme;case A.TokenType.True:return this._advance(),"true";case A.TokenType.False:return this._advance(),"false";case A.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(W){return W.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(W){return this._check(W)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(W,se){if(this._check(W))return this._advance();throw this._errExpectedButGot(se,this._peek())}_errExpectedButGot(W,se,ae){const ie=(0,R.localize)(8,null,W,A.Scanner.getLexeme(se)),le=se.offset,ue=A.Scanner.getLexeme(se);return this._parsingErrors.push({message:ie,offset:le,lexeme:ue,additionalInfo:ae}),t._parseError}_check(W){return this._peek().type===W}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===A.TokenType.EOF}}e.Parser=t;class c{static false(){return _.INSTANCE}static true(){return D.INSTANCE}static has(W){return C.create(W)}static equals(W,se){return S.create(W,se)}static notEquals(W,se){return w.create(W,se)}static regex(W,se){return M.create(W,se)}static in(W,se){return I.create(W,se)}static notIn(W,se){return b.create(W,se)}static not(W){return N.create(W)}static and(...W){return $.create(W,null,!0)}static or(...W){return q.create(W,null,!0)}static greater(W,se){return U.create(W,se)}static greaterEquals(W,se){return x.create(W,se)}static smaller(W,se){return B.create(W,se)}static smallerEquals(W,se){return F.create(W,se)}static{this._parser=new t({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this._parser.parse(W)}}e.ContextKeyExpr=c;function h(G){const W=new t({regexParsingWithErrorRecovery:!1});return G.map(se=>(W.parse(se),W.lexingErrors.length>0?W.lexingErrors.map(ae=>({errorMessage:ae.additionalInfo?(0,R.localize)(9,null,ae.additionalInfo):(0,R.localize)(10,null),offset:ae.offset,length:ae.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ae=>({errorMessage:ae.additionalInfo?`${ae.message}. ${ae.additionalInfo}`:ae.message,offset:ae.offset,length:ae.lexeme.length})):[]))}function o(G,W){const se=G?G.substituteConstants():void 0,ae=W?W.substituteConstants():void 0;return!se&&!ae?!0:!se||!ae?!1:se.equals(ae)}function p(G,W){return G.cmp(W)}class _{static{this.INSTANCE=new _}constructor(){this.type=d.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return D.INSTANCE}}e.ContextKeyFalseExpr=_;class D{static{this.INSTANCE=new D}constructor(){this.type=d.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return _.INSTANCE}}e.ContextKeyTrueExpr=D;class C{static create(W,se=null){const ae=l.get(W);return typeof ae=="boolean"?ae?D.INSTANCE:_.INSTANCE:new C(W,se)}constructor(W,se){this.key=W,this.negated=se,this.type=d.Defined}cmp(W){return W.type!==this.type?this.type-W.type:ne(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=l.get(this.key);return typeof W=="boolean"?W?D.INSTANCE:_.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.negated||(this.negated=N.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=C;class S{static create(W,se,ae=null){if(typeof se=="boolean")return se?C.create(W,ae):N.create(W,ae);const ie=l.get(W);return typeof ie=="boolean"?se===(ie?"true":"false")?D.INSTANCE:_.INSTANCE:new S(W,se,ae)}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=d.Equals}cmp(W){return W.type!==this.type?this.type-W.type:de(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=l.get(this.key);if(typeof W=="boolean"){const se=W?"true":"false";return this.value===se?D.INSTANCE:_.INSTANCE}return this}evaluate(W){return W.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(W){return W.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=S;class I{static create(W,se){return new I(W,se)}constructor(W,se){this.key=W,this.valueKey=se,this.type=d.In,this.negated=null}cmp(W){return W.type!==this.type?this.type-W.type:de(this.key,this.valueKey,W.key,W.valueKey)}equals(W){return W.type===this.type?this.key===W.key&&this.valueKey===W.valueKey:!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.valueKey),ae=W.getValue(this.key);return Array.isArray(se)?se.includes(ae):typeof ae=="string"&&typeof se=="object"&&se!==null?y.call(se,ae):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(W){return W.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=I;class b{static create(W,se){return new b(W,se)}constructor(W,se){this.key=W,this.valueKey=se,this.type=d.NotIn,this._negated=I.create(W,se)}cmp(W){return W.type!==this.type?this.type-W.type:this._negated.cmp(W._negated)}equals(W){return W.type===this.type?this._negated.equals(W._negated):!1}substituteConstants(){return this}evaluate(W){return!this._negated.evaluate(W)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(W){return W.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class w{static create(W,se,ae=null){if(typeof se=="boolean")return se?N.create(W,ae):C.create(W,ae);const ie=l.get(W);return typeof ie=="boolean"?se===(ie?"true":"false")?_.INSTANCE:D.INSTANCE:new w(W,se,ae)}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=d.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:de(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=l.get(this.key);if(typeof W=="boolean"){const se=W?"true":"false";return this.value===se?_.INSTANCE:D.INSTANCE}return this}evaluate(W){return W.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(W){return W.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class N{static create(W,se=null){const ae=l.get(W);return typeof ae=="boolean"?ae?_.INSTANCE:D.INSTANCE:new N(W,se)}constructor(W,se){this.key=W,this.negated=se,this.type=d.Not}cmp(W){return W.type!==this.type?this.type-W.type:ne(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=l.get(this.key);return typeof W=="boolean"?W?_.INSTANCE:D.INSTANCE:this}evaluate(W){return!W.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(W){return W.mapNot(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=N;function O(G,W){if(typeof G=="string"){const se=parseFloat(G);isNaN(se)||(G=se)}return typeof G=="string"||typeof G=="number"?W(G):_.INSTANCE}class U{static create(W,se,ae=null){return O(se,ie=>new U(W,ie,ae))}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=d.Greater}cmp(W){return W.type!==this.type?this.type-W.type:de(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=U;class x{static create(W,se,ae=null){return O(se,ie=>new x(W,ie,ae))}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=d.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:de(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=x;class B{static create(W,se,ae=null){return O(se,ie=>new B(W,ie,ae))}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=d.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:de(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=B;class F{static create(W,se,ae=null){return O(se,ie=>new F(W,ie,ae))}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=d.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:de(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=F;class M{static create(W,se){return new M(W,se)}constructor(W,se){this.key=W,this.regexp=se,this.type=d.Regex,this.negated=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.key<W.key)return-1;if(this.key>W.key)return 1;const se=this.regexp?this.regexp.source:"",ae=W.regexp?W.regexp.source:"";return se<ae?-1:se>ae?1:0}equals(W){if(W.type===this.type){const se=this.regexp?this.regexp.source:"",ae=W.regexp?W.regexp.source:"";return this.key===W.key&&se===ae}return!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.key);return this.regexp?this.regexp.test(se):!1}serialize(){const W=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${W}`}keys(){return[this.key]}map(W){return W.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=K.create(this)),this.negated}}e.ContextKeyRegexExpr=M;class K{static create(W){return new K(W)}constructor(W){this._actual=W,this.type=d.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this._actual.cmp(W._actual)}equals(W){return W.type===this.type?this._actual.equals(W._actual):!1}substituteConstants(){return this}evaluate(W){return!this._actual.evaluate(W)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(W){return new K(this._actual.map(W))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=K;function ee(G){let W=null;for(let se=0,ae=G.length;se<ae;se++){const ie=G[se].substituteConstants();if(G[se]!==ie&&W===null){W=[];for(let le=0;le<se;le++)W[le]=G[le]}W!==null&&(W[se]=ie)}return W===null?G:W}class ${static create(W,se,ae){return $._normalizeArr(W,se,ae)}constructor(W,se){this.expr=W,this.negated=se,this.type=d.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const ie=p(this.expr[se],W.expr[se]);if(ie!==0)return ie}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=ee(this.expr);return W===this.expr?this:$.create(W,this.negated,!1)}evaluate(W){for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].evaluate(W))return!1;return!0}static _normalizeArr(W,se,ae){const ie=[];let le=!1;for(const ue of W)if(ue){if(ue.type===d.True){le=!0;continue}if(ue.type===d.False)return _.INSTANCE;if(ue.type===d.And){ie.push(...ue.expr);continue}ie.push(ue)}if(ie.length===0&&le)return D.INSTANCE;if(ie.length!==0){if(ie.length===1)return ie[0];ie.sort(p);for(let ue=1;ue<ie.length;ue++)ie[ue-1].equals(ie[ue])&&(ie.splice(ue,1),ue--);if(ie.length===1)return ie[0];for(;ie.length>1;){const ue=ie[ie.length-1];if(ue.type!==d.Or)break;ie.pop();const Y=ie.pop(),oe=ie.length===0,pe=q.create(ue.expr.map(Ee=>$.create([Ee,Y],null,ae)),null,oe);pe&&(ie.push(pe),ie.sort(p))}if(ie.length===1)return ie[0];if(ae){for(let ue=0;ue<ie.length;ue++)for(let Y=ue+1;Y<ie.length;Y++)if(ie[ue].negate().equals(ie[Y]))return _.INSTANCE;if(ie.length===1)return ie[0]}return new $(ie,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new $(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.negated){const W=[];for(const se of this.expr)W.push(se.negate());this.negated=q.create(W,this,!0)}return this.negated}}e.ContextKeyAndExpr=$;class q{static create(W,se,ae){return q._normalizeArr(W,se,ae)}constructor(W,se){this.expr=W,this.negated=se,this.type=d.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const ie=p(this.expr[se],W.expr[se]);if(ie!==0)return ie}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=ee(this.expr);return W===this.expr?this:q.create(W,this.negated,!1)}evaluate(W){for(let se=0,ae=this.expr.length;se<ae;se++)if(this.expr[se].evaluate(W))return!0;return!1}static _normalizeArr(W,se,ae){let ie=[],le=!1;if(W){for(let ue=0,Y=W.length;ue<Y;ue++){const oe=W[ue];if(oe){if(oe.type===d.False){le=!0;continue}if(oe.type===d.True)return D.INSTANCE;if(oe.type===d.Or){ie=ie.concat(oe.expr);continue}ie.push(oe)}}if(ie.length===0&&le)return _.INSTANCE;ie.sort(p)}if(ie.length!==0){if(ie.length===1)return ie[0];for(let ue=1;ue<ie.length;ue++)ie[ue-1].equals(ie[ue])&&(ie.splice(ue,1),ue--);if(ie.length===1)return ie[0];if(ae){for(let ue=0;ue<ie.length;ue++)for(let Y=ue+1;Y<ie.length;Y++)if(ie[ue].negate().equals(ie[Y]))return D.INSTANCE;if(ie.length===1)return ie[0]}return new q(ie,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new q(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.negated){const W=[];for(const se of this.expr)W.push(se.negate());for(;W.length>1;){const se=W.shift(),ae=W.shift(),ie=[];for(const le of ve(se))for(const ue of ve(ae))ie.push($.create([le,ue],null,!1));W.unshift(q.create(ie,null,!1))}this.negated=q.create(W,this,!0)}return this.negated}}e.ContextKeyOrExpr=q;class Z extends C{static{this._info=[]}static all(){return Z._info.values()}constructor(W,se,ae){super(W,null),this._defaultValue=se,typeof ae=="object"?Z._info.push({...ae,key:W}):ae!==!0&&Z._info.push({key:W,description:ae,type:se!=null?typeof se:void 0})}bindTo(W){return W.createKey(this.key,this._defaultValue)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return S.create(this.key,W)}notEqualsTo(W){return w.create(this.key,W)}}e.RawContextKey=Z,e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function ne(G,W){return G<W?-1:G>W?1:0}function de(G,W,se,ae){return G<se?-1:G>se?1:W<ae?-1:W>ae?1:0}function re(G,W){if(G.type===d.False||W.type===d.True)return!0;if(G.type===d.Or)return W.type===d.Or?Se(G.expr,W.expr):!1;if(W.type===d.Or){for(const se of W.expr)if(re(G,se))return!0;return!1}if(G.type===d.And){if(W.type===d.And)return Se(W.expr,G.expr);for(const se of G.expr)if(re(se,W))return!0;return!1}return G.equals(W)}function Se(G,W){let se=0,ae=0;for(;se<G.length&&ae<W.length;){const ie=G[se].cmp(W[ae]);if(ie<0)return!1;ie===0&&se++,ae++}return se===G.length}function ve(G){return G.type===d.Or?G.expr:[G]}}),define(we[264],ye([1,0,35,5]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX=e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=e.AccessibilitySupport=e.IAccessibilityService=void 0,e.isAccessibilityInformation=A,e.IAccessibilityService=(0,g.createDecorator)("accessibilityService");var k;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(k||(e.AccessibilitySupport=k={})),e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=new r.RawContextKey("accessibilityModeEnabled",!1);function A(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX="ACCESSIBLE_VIEW_SHOWN_"}),define(we[113],ye([1,0,19,25,11,182,84,190,137,214,264]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=i,e.clampedFloat=c,e.stringSet=p,e.cursorStyleToString=O,e.filterValidationDecorations=Ce;var y;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class d{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=d;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class E{constructor(Q,Pe,Ge,Ze){this.id=Q,this.name=Pe,this.defaultValue=Ge,this.schema=Ze}applyUpdate(Q,Pe){return u(Q,Pe)}compute(Q,Pe,Ge){return Ge}}class a{constructor(Q,Pe){this.newValue=Q,this.didChange=Pe}}e.ApplyUpdateResult=a;function u(ce,Q){if(typeof ce!="object"||typeof Q!="object"||!ce||!Q)return new a(Q,ce!==Q);if(Array.isArray(ce)||Array.isArray(Q)){const Ge=Array.isArray(ce)&&Array.isArray(Q)&&r.equals(ce,Q);return new a(Q,!Ge)}let Pe=!1;for(const Ge in Q)if(Q.hasOwnProperty(Ge)){const Ze=u(ce[Ge],Q[Ge]);Ze.didChange&&(ce[Ge]=Ze.newValue,Pe=!0)}return new a(ce,Pe)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,Pe){return u(Q,Pe)}validate(Q){return this.defaultValue}}class m{constructor(Q,Pe,Ge,Ze){this.id=Q,this.name=Pe,this.defaultValue=Ge,this.schema=Ze}applyUpdate(Q,Pe){return u(Q,Pe)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,Pe,Ge){return Ge}}function n(ce,Q){return typeof ce>"u"?Q:ce==="false"?!1:!!ce}class s extends m{constructor(Q,Pe,Ge,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=Ge),super(Q,Pe,Ge,Ze)}validate(Q){return n(Q,this.defaultValue)}}function i(ce,Q,Pe,Ge){if(typeof ce>"u")return Q;let Ze=parseInt(ce,10);return isNaN(Ze)?Q:(Ze=Math.max(Pe,Ze),Ze=Math.min(Ge,Ze),Ze|0)}class t extends m{static clampedInt(Q,Pe,Ge,Ze){return i(Q,Pe,Ge,Ze)}constructor(Q,Pe,Ge,Ze,at,ct=void 0){typeof ct<"u"&&(ct.type="integer",ct.default=Ge,ct.minimum=Ze,ct.maximum=at),super(Q,Pe,Ge,ct),this.minimum=Ze,this.maximum=at}validate(Q){return t.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function c(ce,Q,Pe,Ge){if(typeof ce>"u")return Q;const Ze=h.float(ce,Q);return h.clamp(Ze,Pe,Ge)}class h extends m{static clamp(Q,Pe,Ge){return Q<Pe?Pe:Q>Ge?Ge:Q}static float(Q,Pe){if(typeof Q=="number")return Q;if(typeof Q>"u")return Pe;const Ge=parseFloat(Q);return isNaN(Ge)?Pe:Ge}constructor(Q,Pe,Ge,Ze,at){typeof at<"u"&&(at.type="number",at.default=Ge),super(Q,Pe,Ge,at),this.validationFn=Ze}validate(Q){return this.validationFn(h.float(Q,this.defaultValue))}}class o extends m{static string(Q,Pe){return typeof Q!="string"?Pe:Q}constructor(Q,Pe,Ge,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=Ge),super(Q,Pe,Ge,Ze)}validate(Q){return o.string(Q,this.defaultValue)}}function p(ce,Q,Pe,Ge){return typeof ce!="string"?Q:Ge&&ce in Ge?Ge[ce]:Pe.indexOf(ce)===-1?Q:ce}class _ extends m{constructor(Q,Pe,Ge,Ze,at=void 0){typeof at<"u"&&(at.type="string",at.enum=Ze,at.default=Ge),super(Q,Pe,Ge,at),this._allowedValues=Ze}validate(Q){return p(Q,this.defaultValue,this._allowedValues)}}class D extends E{constructor(Q,Pe,Ge,Ze,at,ct,Ct=void 0){typeof Ct<"u"&&(Ct.type="string",Ct.enum=at,Ct.default=Ze),super(Q,Pe,Ge,Ct),this._allowedValues=at,this._convert=ct}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function C(ce){switch(ce){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class S extends E{constructor(){super(Re.accessibilitySupport,"accessibilitySupport",P.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Q){switch(Q){case"auto":return P.AccessibilitySupport.Unknown;case"off":return P.AccessibilitySupport.Disabled;case"on":return P.AccessibilitySupport.Enabled}return this.defaultValue}compute(Q,Pe,Ge){return Ge===P.AccessibilitySupport.Unknown?Q.accessibilitySupport:Ge}}class I extends E{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(Re.comments,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{insertSpace:n(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var b;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(b||(e.TextEditorCursorBlinkingStyle=b={}));function w(ce){switch(ce){case"blink":return b.Blink;case"smooth":return b.Smooth;case"phase":return b.Phase;case"expand":return b.Expand;case"solid":return b.Solid}}var N;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(N||(e.TextEditorCursorStyle=N={}));function O(ce){switch(ce){case N.Line:return"line";case N.Block:return"block";case N.Underline:return"underline";case N.LineThin:return"line-thin";case N.BlockOutline:return"block-outline";case N.UnderlineThin:return"underline-thin"}}function U(ce){switch(ce){case"line":return N.Line;case"block":return N.Block;case"underline":return N.Underline;case"line-thin":return N.LineThin;case"block-outline":return N.BlockOutline;case"underline-thin":return N.UnderlineThin}}class x extends f{constructor(){super(Re.editorClassName)}compute(Q,Pe,Ge){const Ze=["monaco-editor"];return Pe.get(Re.extraEditorClassName)&&Ze.push(Pe.get(Re.extraEditorClassName)),Q.extraEditorClassName&&Ze.push(Q.extraEditorClassName),Pe.get(Re.mouseStyle)==="default"?Ze.push("mouse-default"):Pe.get(Re.mouseStyle)==="copy"&&Ze.push("mouse-copy"),Pe.get(Re.showUnused)&&Ze.push("showUnused"),Pe.get(Re.showDeprecated)&&Ze.push("showDeprecated"),Ze.join(" ")}}class B extends s{constructor(){super(Re.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Q,Pe,Ge){return Ge&&Q.emptySelectionClipboard}}class F extends E{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Re.find,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:l.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:l.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{cursorMoveOnType:n(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":p(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":p(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Pe.loop,this.defaultValue.loop)}}}class M extends E{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Re.fontLigatures,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"||Q.length===0?M.OFF:Q==="true"?M.ON:Q:Q?M.ON:M.OFF}}e.EditorFontLigatures=M;class K extends E{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Re.fontVariations,"fontVariations",K.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?K.OFF:Q==="true"?K.TRANSLATE:Q:Q?K.TRANSLATE:K.OFF}compute(Q,Pe,Ge){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=K;class ee extends f{constructor(){super(Re.fontInfo)}compute(Q,Pe,Ge){return Q.fontInfo}}class $ extends m{constructor(){super(Re.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Q){const Pe=h.float(Q,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Pe,6,100)}compute(Q,Pe,Ge){return Q.fontInfo.fontSize}}class q extends E{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(Re.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.MINIMUM_VALUE,maximum:q.MAXIMUM_VALUE,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(t.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,q.MINIMUM_VALUE,q.MAXIMUM_VALUE))}}class Z extends E{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Re.gotoLocation,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...Pe},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ge,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ge,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ge,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ge,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ge,description:l.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{multiple:p(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??p(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??p(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??p(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??p(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??p(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:o.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:o.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:o.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:o.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:o.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ne extends E{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Re.hover,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:l.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{enabled:n(Pe.enabled,this.defaultValue.enabled),delay:t.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:n(Pe.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(Pe.above,this.defaultValue.above)}}}var de;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(de||(e.RenderMinimap=de={}));class re extends f{constructor(){super(Re.layoutInfo)}compute(Q,Pe,Ge){return re.computeLayout(Pe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const Pe=Q.height/Q.lineHeight,Ge=Math.floor(Q.paddingTop/Q.lineHeight);let Ze=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Ze=Math.max(Ze,Pe-1));const at=(Ge+Q.viewLineCount+Ze)/(Q.pixelRatio*Q.height),ct=Math.floor(Q.viewLineCount/at);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:Ze,desiredRatio:at,minimapLineCount:ct}}static _computeMinimapLayout(Q,Pe){const Ge=Q.outerWidth,Ze=Q.outerHeight,at=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:de.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(at*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const ct=Pe.stableMinimapLayoutInput,Ct=ct&&Q.outerHeight===ct.outerHeight&&Q.lineHeight===ct.lineHeight&&Q.typicalHalfwidthCharacterWidth===ct.typicalHalfwidthCharacterWidth&&Q.pixelRatio===ct.pixelRatio&&Q.scrollBeyondLastLine===ct.scrollBeyondLastLine&&Q.paddingTop===ct.paddingTop&&Q.paddingBottom===ct.paddingBottom&&Q.minimap.enabled===ct.minimap.enabled&&Q.minimap.side===ct.minimap.side&&Q.minimap.size===ct.minimap.size&&Q.minimap.showSlider===ct.minimap.showSlider&&Q.minimap.renderCharacters===ct.minimap.renderCharacters&&Q.minimap.maxColumn===ct.minimap.maxColumn&&Q.minimap.scale===ct.minimap.scale&&Q.verticalScrollbarWidth===ct.verticalScrollbarWidth&&Q.isViewportWrapping===ct.isViewportWrapping,Pt=Q.lineHeight,Ot=Q.typicalHalfwidthCharacterWidth,Xt=Q.scrollBeyondLastLine,Zt=Q.minimap.renderCharacters;let Je=at>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const $t=Q.minimap.maxColumn,Bt=Q.minimap.size,mt=Q.minimap.side,pt=Q.verticalScrollbarWidth,ei=Q.viewLineCount,Qt=Q.remainingWidth,Wt=Q.isViewportWrapping,Et=Zt?2:3;let Ft=Math.floor(at*Ze);const qt=Ft/at;let zt=!1,Qe=!1,ti=Et*Je,ii=Je/at,ci=1;if(Bt==="fill"||Bt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Ut,extraLinesBeyondLastLine:Yt,desiredRatio:oi,minimapLineCount:kt}=re.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Xt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Ze,lineHeight:Pt,pixelRatio:at});if(ei/kt>1)zt=!0,Qe=!0,Je=1,ti=1,ii=Je/at;else{let vt=!1,Vt=Je+1;if(Bt==="fit"){const yt=Math.ceil((Ut+ei+Yt)*ti);Wt&&Ct&&Qt<=Pe.stableFitRemainingWidth?(vt=!0,Vt=Pe.stableFitMaxMinimapScale):vt=yt>Ft}if(Bt==="fill"||vt){zt=!0;const yt=Je;ti=Math.min(Pt*at,Math.max(1,Math.floor(1/oi))),Wt&&Ct&&Qt<=Pe.stableFitRemainingWidth&&(Vt=Pe.stableFitMaxMinimapScale),Je=Math.min(Vt,Math.max(1,Math.floor(ti/Et))),Je>yt&&(ci=Math.min(2,Je/yt)),ii=Je/at/ci,Ft=Math.ceil(Math.max(si,Ut+ei+Yt)*ti),Wt?(Pe.stableMinimapLayoutInput=Q,Pe.stableFitRemainingWidth=Qt,Pe.stableFitMaxMinimapScale=Je):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const Dt=Math.floor($t*ii),Nt=Math.min(Dt,Math.max(0,Math.floor((Qt-pt-2)*ii/(Ot+ii)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(at*Nt);const Mt=At/at;At=Math.floor(At*ci);const ui=Zt?de.Text:de.Blocks,Ht=mt==="left"?0:Ge-Nt-pt;return{renderMinimap:ui,minimapLeft:Ht,minimapWidth:Nt,minimapHeightIsEditorHeight:zt,minimapIsSampling:Qe,minimapScale:Je,minimapLineHeight:ti,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:Ft,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:qt}}static computeLayout(Q,Pe){const Ge=Pe.outerWidth|0,Ze=Pe.outerHeight|0,at=Pe.lineHeight|0,ct=Pe.lineNumbersDigitCount|0,Ct=Pe.typicalHalfwidthCharacterWidth,Pt=Pe.maxDigitWidth,Ot=Pe.pixelRatio,Xt=Pe.viewLineCount,Zt=Q.get(Re.wordWrapOverride2),Je=Zt==="inherit"?Q.get(Re.wordWrapOverride1):Zt,$t=Je==="inherit"?Q.get(Re.wordWrap):Je,Bt=Q.get(Re.wordWrapColumn),mt=Pe.isDominatedByLongLines,pt=Q.get(Re.glyphMargin),ei=Q.get(Re.lineNumbers).renderType!==Ne.Off,Qt=Q.get(Re.lineNumbersMinChars),Wt=Q.get(Re.scrollBeyondLastLine),Et=Q.get(Re.padding),Ft=Q.get(Re.minimap),qt=Q.get(Re.scrollbar),zt=qt.verticalScrollbarSize,Qe=qt.verticalHasArrows,ti=qt.arrowSize,ii=qt.horizontalScrollbarSize,ci=Q.get(Re.folding),Dt=Q.get(Re.showFoldingControls)!=="never";let Nt=Q.get(Re.lineDecorationsWidth);ci&&Dt&&(Nt+=16);let At=0;if(ei){const jt=Math.max(ct,Qt);At=Math.round(jt*Pt)}let Mt=0;pt&&(Mt=at*Pe.glyphMarginDecorationLaneCount);let ui=0,Ht=ui+Mt,si=Ht+At,Ut=si+Nt;const Yt=Ge-Mt-At-Nt;let oi=!1,kt=!1,St=-1;Je==="inherit"&&mt?(oi=!0,kt=!0):$t==="on"||$t==="bounded"?kt=!0:$t==="wordWrapColumn"&&(St=Bt);const vt=re._computeMinimapLayout({outerWidth:Ge,outerHeight:Ze,lineHeight:at,typicalHalfwidthCharacterWidth:Ct,pixelRatio:Ot,scrollBeyondLastLine:Wt,paddingTop:Et.top,paddingBottom:Et.bottom,minimap:Ft,verticalScrollbarWidth:zt,viewLineCount:Xt,remainingWidth:Yt,isViewportWrapping:kt},Pe.memory||new T);vt.renderMinimap!==de.None&&vt.minimapLeft===0&&(ui+=vt.minimapWidth,Ht+=vt.minimapWidth,si+=vt.minimapWidth,Ut+=vt.minimapWidth);const Vt=Yt-vt.minimapWidth,yt=Math.max(1,Math.floor((Vt-zt-2)/Ct)),ai=Qe?ti:0;return kt&&(St=Math.max(1,yt),$t==="bounded"&&(St=Math.min(St,Bt))),{width:Ge,height:Ze,glyphMarginLeft:ui,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ht,lineNumbersWidth:At,decorationsLeft:si,decorationsWidth:Nt,contentLeft:Ut,contentWidth:Vt,minimap:vt,viewportColumn:yt,isWordWrapMinified:oi,isViewportWrapping:kt,wrappingColumn:St,verticalScrollbarWidth:zt,horizontalScrollbarHeight:ii,overviewRuler:{top:ai,width:zt,height:Ze-2*ai,right:0}}}}e.EditorLayoutInfoComputer=re;class Se extends E{constructor(){super(Re.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Q){return p(Q,"simple",["simple","advanced"])}compute(Q,Pe,Ge){return Pe.get(Re.accessibilitySupport)===P.AccessibilitySupport.Enabled?"advanced":Ge}}var ve;(function(ce){ce.Off="off",ce.OnCode="onCode",ce.On="on"})(ve||(e.ShowLightbulbIconMode=ve={}));class G extends E{constructor(){const Q={enabled:ve.On};super(Re.lightbulb,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ve.Off,ve.OnCode,ve.On],default:Q.enabled,enumDescriptions:[l.localize(50,null),l.localize(51,null),l.localize(52,null)],description:l.localize(53,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:p(Q.enabled,this.defaultValue.enabled,[ve.Off,ve.OnCode,ve.On])}}}class W extends E{constructor(){const Q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Re.stickyScroll,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:l.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:20,description:l.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:l.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:l.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{enabled:n(Pe.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:p(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends E{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Re.inlayHints,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:l.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(59,null),l.localize(60,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(61,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:l.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:l.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:l.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:p(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:o.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:n(Pe.padding,this.defaultValue.padding)}}}class ae extends E{constructor(){super(Re.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):t.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,Pe,Ge){return Ge<0?t.clampedInt(-Ge*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ie extends h{constructor(){super(Re.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>h.clamp(Q,0,150),{markdownDescription:l.localize(66,null)})}compute(Q,Pe,Ge){return Q.fontInfo.lineHeight}}class le extends E{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Re.minimap,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:l.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:l.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(69,null),l.localize(70,null),l.localize(71,null)],default:Q.size,description:l.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:l.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:l.localize(74,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:l.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:l.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Q.showRegionSectionHeaders,description:l.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Q.showMarkSectionHeaders,description:l.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Q.sectionHeaderFontSize,description:l.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:Q.sectionHeaderLetterSpacing,description:l.localize(81,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{enabled:n(Pe.enabled,this.defaultValue.enabled),autohide:n(Pe.autohide,this.defaultValue.autohide),size:p(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(Pe.side,this.defaultValue.side,["right","left"]),showSlider:p(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(Pe.scale,1,1,3),maxColumn:t.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(Pe.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(Pe.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(Pe.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:h.clamp(Pe.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ue(ce){return ce==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Y extends E{constructor(){super(Re.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(83,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{top:t.clampedInt(Pe.top,0,0,1e3),bottom:t.clampedInt(Pe.bottom,0,0,1e3)}}}class oe extends E{constructor(){const Q={enabled:!0,cycle:!0};super(Re.parameterHints,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:l.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:l.localize(85,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{enabled:n(Pe.enabled,this.defaultValue.enabled),cycle:n(Pe.cycle,this.defaultValue.cycle)}}}class pe extends f{constructor(){super(Re.pixelRatio)}compute(Q,Pe,Ge){return Q.pixelRatio}}class Ee extends E{constructor(){const Q={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null)]}];super(Re.quickSuggestions,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:Q.strings,description:l.localize(89,null)},comments:{anyOf:Pe,default:Q.comments,description:l.localize(90,null)},other:{anyOf:Pe,default:Q.other,description:l.localize(91,null)}},default:Q,markdownDescription:l.localize(92,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Ot=Q?"on":"off";return{comments:Ot,strings:Ot,other:Ot}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:Pe,comments:Ge,strings:Ze}=Q,at=["on","inline","off"];let ct,Ct,Pt;return typeof Pe=="boolean"?ct=Pe?"on":"off":ct=p(Pe,this.defaultValue.other,at),typeof Ge=="boolean"?Ct=Ge?"on":"off":Ct=p(Ge,this.defaultValue.comments,at),typeof Ze=="boolean"?Pt=Ze?"on":"off":Pt=p(Ze,this.defaultValue.strings,at),{other:ct,comments:Ct,strings:Pt}}}var Ne;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(Ne||(e.RenderLineNumbersType=Ne={}));class We extends E{constructor(){super(Re.lineNumbers,"lineNumbers",{renderType:Ne.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(93,null),l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"on",description:l.localize(97,null)})}validate(Q){let Pe=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(Pe=Ne.Custom,Ge=Q):Q==="interval"?Pe=Ne.Interval:Q==="relative"?Pe=Ne.Relative:Q==="on"?Pe=Ne.On:Pe=Ne.Off),{renderType:Pe,renderFn:Ge}}}function Ce(ce){const Q=ce.get(Re.renderValidationDecorations);return Q==="editable"?ce.get(Re.readOnly):Q!=="on"}class Ie extends E{constructor(){const Q=[],Pe={type:"number",description:l.localize(98,null)};super(Re.rulers,"rulers",Q,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:l.localize(99,null),format:"color-hex"}}}]},default:Q,description:l.localize(100,null)})}validate(Q){if(Array.isArray(Q)){const Pe=[];for(const Ge of Q)if(typeof Ge=="number")Pe.push({column:t.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Ze=Ge;Pe.push({column:t.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return Pe.sort((Ge,Ze)=>Ge.column-Ze.column),Pe}return this.defaultValue}}class Le extends E{constructor(){super(Re.readOnlyMessage,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function z(ce,Q){if(typeof ce!="string")return Q;switch(ce){case"hidden":return A.ScrollbarVisibility.Hidden;case"visible":return A.ScrollbarVisibility.Visible;default:return A.ScrollbarVisibility.Auto}}class H extends E{constructor(){const Q={vertical:A.ScrollbarVisibility.Auto,horizontal:A.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Re.scrollbar,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(101,null),l.localize(102,null),l.localize(103,null)],default:"auto",description:l.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(105,null),l.localize(106,null),l.localize(107,null)],default:"auto",description:l.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:l.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:l.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:l.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:l.localize(112,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q,Ge=t.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=t.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(Pe.vertical,this.defaultValue.vertical),horizontal:z(Pe.horizontal,this.defaultValue.horizontal),useShadows:n(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:t.clampedInt(Pe.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:t.clampedInt(Pe.verticalSliderSize,Ze,0,1e3),scrollByPage:n(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends E{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Re.unicodeHighlighting,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:l.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:l.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:l.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:l.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:l.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:l.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:l.localize(119,null)}})}applyUpdate(Q,Pe){let Ge=!1;Pe.allowedCharacters&&Q&&(g.equals(Q.allowedCharacters,Pe.allowedCharacters)||(Q={...Q,allowedCharacters:Pe.allowedCharacters},Ge=!0)),Pe.allowedLocales&&Q&&(g.equals(Q.allowedLocales,Pe.allowedLocales)||(Q={...Q,allowedLocales:Pe.allowedLocales},Ge=!0));const Ze=super.applyUpdate(Q,Pe);return Ge?new a(Ze.newValue,!0):Ze}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{nonBasicASCII:He(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:He(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:He(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,Pe){if(typeof Q!="object"||!Q)return Pe;const Ge={};for(const[Ze,at]of Object.entries(Q))at===!0&&(Ge[Ze]=!0);return Ge}}class J extends E{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Re.inlineSuggest,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:l.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(121,null),l.localize(122,null),l.localize(123,null)],description:l.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:l.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Q.fontFamily,description:l.localize(126,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{enabled:n(Pe.enabled,this.defaultValue.enabled),mode:p(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:p(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:o.string(Pe.fontFamily,this.defaultValue.fontFamily)}}}class fe extends E{constructor(){const Q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Re.inlineEdit,"experimentalInlineEdit",Q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Q.enabled,description:l.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(128,null),l.localize(129,null),l.localize(130,null)],description:l.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Q.fontFamily,description:l.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Q.backgroundColoring,description:l.localize(133,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{enabled:n(Pe.enabled,this.defaultValue.enabled),showToolbar:p(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:o.string(Pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(Pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(Pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class be extends E{constructor(){const Q={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Re.bracketPairColorization,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:l.localize(135,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{enabled:n(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Fe extends E{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Re.guides,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(136,null),l.localize(137,null),l.localize(138,null)],default:Q.bracketPairs,description:l.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Q.bracketPairsHorizontal,description:l.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:l.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:l.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(146,null),l.localize(147,null),l.localize(148,null)],default:Q.highlightActiveIndentation,description:l.localize(149,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{bracketPairs:He(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:He(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:He(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function He(ce,Q,Pe){const Ge=Pe.indexOf(ce);return Ge===-1?Q:Pe[Ge]}class qe extends E{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Re.suggest,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(150,null),l.localize(151,null)],default:Q.insertMode,description:l.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:l.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:l.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:l.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(156,null),l.localize(157,null),l.localize(158,null),l.localize(159,null)],default:Q.selectionMode,markdownDescription:l.localize(160,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:l.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:l.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:l.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:l.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:l.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(197,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{insertMode:p(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:p(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:n(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:n(Pe.preview,this.defaultValue.preview),previewMode:p(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Pe.showMethods,this.defaultValue.showMethods),showFunctions:n(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Pe.showFields,this.defaultValue.showFields),showVariables:n(Pe.showVariables,this.defaultValue.showVariables),showClasses:n(Pe.showClasses,this.defaultValue.showClasses),showStructs:n(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:n(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Pe.showModules,this.defaultValue.showModules),showProperties:n(Pe.showProperties,this.defaultValue.showProperties),showEvents:n(Pe.showEvents,this.defaultValue.showEvents),showOperators:n(Pe.showOperators,this.defaultValue.showOperators),showUnits:n(Pe.showUnits,this.defaultValue.showUnits),showValues:n(Pe.showValues,this.defaultValue.showValues),showConstants:n(Pe.showConstants,this.defaultValue.showConstants),showEnums:n(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Pe.showKeywords,this.defaultValue.showKeywords),showWords:n(Pe.showWords,this.defaultValue.showWords),showColors:n(Pe.showColors,this.defaultValue.showColors),showFiles:n(Pe.showFiles,this.defaultValue.showFiles),showReferences:n(Pe.showReferences,this.defaultValue.showReferences),showFolders:n(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:n(Pe.showUsers,this.defaultValue.showUsers),showIssues:n(Pe.showIssues,this.defaultValue.showIssues)}}}class Ye extends E{constructor(){super(Re.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(199,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(Q.selectSubwords,this.defaultValue.selectSubwords)}}}class it extends E{constructor(){const Q=[];super(Re.wordSegmenterLocales,"wordSegmenterLocales",Q,{anyOf:[{description:l.localize(200,null),type:"string"},{description:l.localize(201,null),type:"array",items:{type:"string"}}]})}validate(Q){if(typeof Q=="string"&&(Q=[Q]),Array.isArray(Q)){const Pe=[];for(const Ge of Q)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&Pe.push(Ge)}catch{}return Pe}return this.defaultValue}}var tt;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(tt||(e.WrappingIndent=tt={}));class rt extends E{constructor(){super(Re.wrappingIndent,"wrappingIndent",tt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(202,null),l.localize(203,null),l.localize(204,null),l.localize(205,null)],description:l.localize(206,null),default:"same"}})}validate(Q){switch(Q){case"none":return tt.None;case"same":return tt.Same;case"indent":return tt.Indent;case"deepIndent":return tt.DeepIndent}return tt.Same}compute(Q,Pe,Ge){return Pe.get(Re.accessibilitySupport)===P.AccessibilitySupport.Enabled?tt.None:Ge}}class ot extends f{constructor(){super(Re.wrappingInfo)}compute(Q,Pe,Ge){const Ze=Pe.get(Re.layoutInfo);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class ft extends E{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(Re.dropIntoEditor,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(209,null),l.localize(210,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{enabled:n(Pe.enabled,this.defaultValue.enabled),showDropSelector:p(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ut extends E{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(Re.pasteAs,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(213,null),l.localize(214,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Pe=Q;return{enabled:n(Pe.enabled,this.defaultValue.enabled),showPasteSelector:p(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Te:k.isLinux?Ue:st,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var Re;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.ariaRequired=5]="ariaRequired",ce[ce.autoClosingBrackets=6]="autoClosingBrackets",ce[ce.autoClosingComments=7]="autoClosingComments",ce[ce.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ce[ce.autoClosingDelete=9]="autoClosingDelete",ce[ce.autoClosingOvertype=10]="autoClosingOvertype",ce[ce.autoClosingQuotes=11]="autoClosingQuotes",ce[ce.autoIndent=12]="autoIndent",ce[ce.automaticLayout=13]="automaticLayout",ce[ce.autoSurround=14]="autoSurround",ce[ce.bracketPairColorization=15]="bracketPairColorization",ce[ce.guides=16]="guides",ce[ce.codeLens=17]="codeLens",ce[ce.codeLensFontFamily=18]="codeLensFontFamily",ce[ce.codeLensFontSize=19]="codeLensFontSize",ce[ce.colorDecorators=20]="colorDecorators",ce[ce.colorDecoratorsLimit=21]="colorDecoratorsLimit",ce[ce.columnSelection=22]="columnSelection",ce[ce.comments=23]="comments",ce[ce.contextmenu=24]="contextmenu",ce[ce.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=26]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=28]="cursorStyle",ce[ce.cursorSurroundingLines=29]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=31]="cursorWidth",ce[ce.disableLayerHinting=32]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ce[ce.domReadOnly=34]="domReadOnly",ce[ce.dragAndDrop=35]="dragAndDrop",ce[ce.dropIntoEditor=36]="dropIntoEditor",ce[ce.emptySelectionClipboard=37]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=39]="extraEditorClassName",ce[ce.fastScrollSensitivity=40]="fastScrollSensitivity",ce[ce.find=41]="find",ce[ce.fixedOverflowWidgets=42]="fixedOverflowWidgets",ce[ce.folding=43]="folding",ce[ce.foldingStrategy=44]="foldingStrategy",ce[ce.foldingHighlight=45]="foldingHighlight",ce[ce.foldingImportsByDefault=46]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=47]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=49]="fontFamily",ce[ce.fontInfo=50]="fontInfo",ce[ce.fontLigatures=51]="fontLigatures",ce[ce.fontSize=52]="fontSize",ce[ce.fontWeight=53]="fontWeight",ce[ce.fontVariations=54]="fontVariations",ce[ce.formatOnPaste=55]="formatOnPaste",ce[ce.formatOnType=56]="formatOnType",ce[ce.glyphMargin=57]="glyphMargin",ce[ce.gotoLocation=58]="gotoLocation",ce[ce.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ce[ce.hover=60]="hover",ce[ce.inDiffEditor=61]="inDiffEditor",ce[ce.inlineSuggest=62]="inlineSuggest",ce[ce.inlineEdit=63]="inlineEdit",ce[ce.letterSpacing=64]="letterSpacing",ce[ce.lightbulb=65]="lightbulb",ce[ce.lineDecorationsWidth=66]="lineDecorationsWidth",ce[ce.lineHeight=67]="lineHeight",ce[ce.lineNumbers=68]="lineNumbers",ce[ce.lineNumbersMinChars=69]="lineNumbersMinChars",ce[ce.linkedEditing=70]="linkedEditing",ce[ce.links=71]="links",ce[ce.matchBrackets=72]="matchBrackets",ce[ce.minimap=73]="minimap",ce[ce.mouseStyle=74]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=76]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=78]="multiCursorModifier",ce[ce.multiCursorPaste=79]="multiCursorPaste",ce[ce.multiCursorLimit=80]="multiCursorLimit",ce[ce.occurrencesHighlight=81]="occurrencesHighlight",ce[ce.overviewRulerBorder=82]="overviewRulerBorder",ce[ce.overviewRulerLanes=83]="overviewRulerLanes",ce[ce.padding=84]="padding",ce[ce.pasteAs=85]="pasteAs",ce[ce.parameterHints=86]="parameterHints",ce[ce.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=89]="quickSuggestions",ce[ce.quickSuggestionsDelay=90]="quickSuggestionsDelay",ce[ce.readOnly=91]="readOnly",ce[ce.readOnlyMessage=92]="readOnlyMessage",ce[ce.renameOnType=93]="renameOnType",ce[ce.renderControlCharacters=94]="renderControlCharacters",ce[ce.renderFinalNewline=95]="renderFinalNewline",ce[ce.renderLineHighlight=96]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=98]="renderValidationDecorations",ce[ce.renderWhitespace=99]="renderWhitespace",ce[ce.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ce[ce.roundedSelection=101]="roundedSelection",ce[ce.rulers=102]="rulers",ce[ce.scrollbar=103]="scrollbar",ce[ce.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=105]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=106]="scrollPredominantAxis",ce[ce.selectionClipboard=107]="selectionClipboard",ce[ce.selectionHighlight=108]="selectionHighlight",ce[ce.selectOnLineNumbers=109]="selectOnLineNumbers",ce[ce.showFoldingControls=110]="showFoldingControls",ce[ce.showUnused=111]="showUnused",ce[ce.snippetSuggestions=112]="snippetSuggestions",ce[ce.smartSelect=113]="smartSelect",ce[ce.smoothScrolling=114]="smoothScrolling",ce[ce.stickyScroll=115]="stickyScroll",ce[ce.stickyTabStops=116]="stickyTabStops",ce[ce.stopRenderingLineAfter=117]="stopRenderingLineAfter",ce[ce.suggest=118]="suggest",ce[ce.suggestFontSize=119]="suggestFontSize",ce[ce.suggestLineHeight=120]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ce[ce.suggestSelection=122]="suggestSelection",ce[ce.tabCompletion=123]="tabCompletion",ce[ce.tabIndex=124]="tabIndex",ce[ce.unicodeHighlighting=125]="unicodeHighlighting",ce[ce.unusualLineTerminators=126]="unusualLineTerminators",ce[ce.useShadowDOM=127]="useShadowDOM",ce[ce.useTabStops=128]="useTabStops",ce[ce.wordBreak=129]="wordBreak",ce[ce.wordSegmenterLocales=130]="wordSegmenterLocales",ce[ce.wordSeparators=131]="wordSeparators",ce[ce.wordWrap=132]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=135]="wordWrapColumn",ce[ce.wordWrapOverride1=136]="wordWrapOverride1",ce[ce.wordWrapOverride2=137]="wordWrapOverride2",ce[ce.wrappingIndent=138]="wrappingIndent",ce[ce.wrappingStrategy=139]="wrappingStrategy",ce[ce.showDeprecated=140]="showDeprecated",ce[ce.inlayHints=141]="inlayHints",ce[ce.editorClassName=142]="editorClassName",ce[ce.pixelRatio=143]="pixelRatio",ce[ce.tabFocusMode=144]="tabFocusMode",ce[ce.layoutInfo=145]="layoutInfo",ce[ce.wrappingInfo=146]="wrappingInfo",ce[ce.defaultColorDecorators=147]="defaultColorDecorators",ce[ce.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ce[ce.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Re||(e.EditorOption=Re={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new s(Re.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(215,null)})),acceptSuggestionOnEnter:ke(new _(Re.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(216,null),""],markdownDescription:l.localize(217,null)})),accessibilitySupport:ke(new S),accessibilityPageSize:ke(new t(Re.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(218,null),tags:["accessibility"]})),ariaLabel:ke(new o(Re.ariaLabel,"ariaLabel",l.localize(219,null))),ariaRequired:ke(new s(Re.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ke(new s(Re.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:ke(new _(Re.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(221,null),l.localize(222,null),""],description:l.localize(223,null)})),autoClosingComments:ke(new _(Re.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(224,null),l.localize(225,null),""],description:l.localize(226,null)})),autoClosingDelete:ke(new _(Re.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(227,null),""],description:l.localize(228,null)})),autoClosingOvertype:ke(new _(Re.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(229,null),""],description:l.localize(230,null)})),autoClosingQuotes:ke(new _(Re.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(231,null),l.localize(232,null),""],description:l.localize(233,null)})),autoIndent:ke(new D(Re.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],C,{enumDescriptions:[l.localize(234,null),l.localize(235,null),l.localize(236,null),l.localize(237,null),l.localize(238,null)],description:l.localize(239,null)})),automaticLayout:ke(new s(Re.automaticLayout,"automaticLayout",!1)),autoSurround:ke(new _(Re.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(240,null),l.localize(241,null),l.localize(242,null),""],description:l.localize(243,null)})),bracketPairColorization:ke(new be),bracketPairGuides:ke(new Fe),stickyTabStops:ke(new s(Re.stickyTabStops,"stickyTabStops",!1,{description:l.localize(244,null)})),codeLens:ke(new s(Re.codeLens,"codeLens",!0,{description:l.localize(245,null)})),codeLensFontFamily:ke(new o(Re.codeLensFontFamily,"codeLensFontFamily","",{description:l.localize(246,null)})),codeLensFontSize:ke(new t(Re.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(247,null)})),colorDecorators:ke(new s(Re.colorDecorators,"colorDecorators",!0,{description:l.localize(248,null)})),colorDecoratorActivatedOn:ke(new _(Re.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),colorDecoratorsLimit:ke(new t(Re.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(253,null)})),columnSelection:ke(new s(Re.columnSelection,"columnSelection",!1,{description:l.localize(254,null)})),comments:ke(new I),contextmenu:ke(new s(Re.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new s(Re.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:l.localize(255,null)})),cursorBlinking:ke(new D(Re.cursorBlinking,"cursorBlinking",b.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:l.localize(256,null)})),cursorSmoothCaretAnimation:ke(new _(Re.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),cursorStyle:ke(new D(Re.cursorStyle,"cursorStyle",N.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],U,{description:l.localize(261,null)})),cursorSurroundingLines:ke(new t(Re.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(262,null)})),cursorSurroundingLinesStyle:ke(new _(Re.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(263,null),l.localize(264,null)],markdownDescription:l.localize(265,null)})),cursorWidth:ke(new t(Re.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(266,null)})),disableLayerHinting:ke(new s(Re.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new s(Re.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new s(Re.domReadOnly,"domReadOnly",!1)),dragAndDrop:ke(new s(Re.dragAndDrop,"dragAndDrop",!0,{description:l.localize(267,null)})),emptySelectionClipboard:ke(new B),dropIntoEditor:ke(new ft),stickyScroll:ke(new W),experimentalWhitespaceRendering:ke(new _(Re.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(268,null),l.localize(269,null),l.localize(270,null)],description:l.localize(271,null)})),extraEditorClassName:ke(new o(Re.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:ke(new h(Re.fastScrollSensitivity,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:l.localize(272,null)})),find:ke(new F),fixedOverflowWidgets:ke(new s(Re.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:ke(new s(Re.folding,"folding",!0,{description:l.localize(273,null)})),foldingStrategy:ke(new _(Re.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(274,null),l.localize(275,null)],description:l.localize(276,null)})),foldingHighlight:ke(new s(Re.foldingHighlight,"foldingHighlight",!0,{description:l.localize(277,null)})),foldingImportsByDefault:ke(new s(Re.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:l.localize(278,null)})),foldingMaximumRegions:ke(new t(Re.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(279,null)})),unfoldOnClickAfterEndOfLine:ke(new s(Re.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(280,null)})),fontFamily:ke(new o(Re.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(281,null)})),fontInfo:ke(new ee),fontLigatures2:ke(new M),fontSize:ke(new $),fontWeight:ke(new q),fontVariations:ke(new K),formatOnPaste:ke(new s(Re.formatOnPaste,"formatOnPaste",!1,{description:l.localize(282,null)})),formatOnType:ke(new s(Re.formatOnType,"formatOnType",!1,{description:l.localize(283,null)})),glyphMargin:ke(new s(Re.glyphMargin,"glyphMargin",!0,{description:l.localize(284,null)})),gotoLocation:ke(new Z),hideCursorInOverviewRuler:ke(new s(Re.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:l.localize(285,null)})),hover:ke(new ne),inDiffEditor:ke(new s(Re.inDiffEditor,"inDiffEditor",!1)),letterSpacing:ke(new h(Re.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>h.clamp(ce,-5,20),{description:l.localize(286,null)})),lightbulb:ke(new G),lineDecorationsWidth:ke(new ae),lineHeight:ke(new ie),lineNumbers:ke(new We),lineNumbersMinChars:ke(new t(Re.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new s(Re.linkedEditing,"linkedEditing",!1,{description:l.localize(287,null)})),links:ke(new s(Re.links,"links",!0,{description:l.localize(288,null)})),matchBrackets:ke(new _(Re.matchBrackets,"matchBrackets","always",["always","near","never"],{description:l.localize(289,null)})),minimap:ke(new le),mouseStyle:ke(new _(Re.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new h(Re.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:l.localize(290,null)})),mouseWheelZoom:ke(new s(Re.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:k.isMacintosh?l.localize(291,null):l.localize(292,null)})),multiCursorMergeOverlapping:ke(new s(Re.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:l.localize(293,null)})),multiCursorModifier:ke(new D(Re.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[l.localize(294,null),l.localize(295,null)],markdownDescription:l.localize(296,null)})),multiCursorPaste:ke(new _(Re.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(297,null),l.localize(298,null)],markdownDescription:l.localize(299,null)})),multiCursorLimit:ke(new t(Re.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(300,null)})),occurrencesHighlight:ke(new _(Re.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[l.localize(301,null),l.localize(302,null),l.localize(303,null)],markdownDescription:l.localize(304,null)})),overviewRulerBorder:ke(new s(Re.overviewRulerBorder,"overviewRulerBorder",!0,{description:l.localize(305,null)})),overviewRulerLanes:ke(new t(Re.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:ke(new Y),pasteAs:ke(new ut),parameterHints:ke(new oe),peekWidgetDefaultFocus:ke(new _(Re.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),definitionLinkOpensInPeek:ke(new s(Re.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:l.localize(309,null)})),quickSuggestions:ke(new Ee),quickSuggestionsDelay:ke(new t(Re.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(310,null)})),readOnly:ke(new s(Re.readOnly,"readOnly",!1)),readOnlyMessage:ke(new Le),renameOnType:ke(new s(Re.renameOnType,"renameOnType",!1,{description:l.localize(311,null),markdownDeprecationMessage:l.localize(312,null)})),renderControlCharacters:ke(new s(Re.renderControlCharacters,"renderControlCharacters",!0,{description:l.localize(313,null),restricted:!0})),renderFinalNewline:ke(new _(Re.renderFinalNewline,"renderFinalNewline",k.isLinux?"dimmed":"on",["off","on","dimmed"],{description:l.localize(314,null)})),renderLineHighlight:ke(new _(Re.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(315,null)],description:l.localize(316,null)})),renderLineHighlightOnlyWhenFocus:ke(new s(Re.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(317,null)})),renderValidationDecorations:ke(new _(Re.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new _(Re.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(318,null),l.localize(319,null),l.localize(320,null),""],description:l.localize(321,null)})),revealHorizontalRightPadding:ke(new t(Re.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ke(new s(Re.roundedSelection,"roundedSelection",!0,{description:l.localize(322,null)})),rulers:ke(new Ie),scrollbar:ke(new H),scrollBeyondLastColumn:ke(new t(Re.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(323,null)})),scrollBeyondLastLine:ke(new s(Re.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:l.localize(324,null)})),scrollPredominantAxis:ke(new s(Re.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:l.localize(325,null)})),selectionClipboard:ke(new s(Re.selectionClipboard,"selectionClipboard",!0,{description:l.localize(326,null),included:k.isLinux})),selectionHighlight:ke(new s(Re.selectionHighlight,"selectionHighlight",!0,{description:l.localize(327,null)})),selectOnLineNumbers:ke(new s(Re.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:ke(new _(Re.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(328,null),l.localize(329,null),l.localize(330,null)],description:l.localize(331,null)})),showUnused:ke(new s(Re.showUnused,"showUnused",!0,{description:l.localize(332,null)})),showDeprecated:ke(new s(Re.showDeprecated,"showDeprecated",!0,{description:l.localize(333,null)})),inlayHints:ke(new se),snippetSuggestions:ke(new _(Re.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(334,null),l.localize(335,null),l.localize(336,null),l.localize(337,null)],description:l.localize(338,null)})),smartSelect:ke(new Ye),smoothScrolling:ke(new s(Re.smoothScrolling,"smoothScrolling",!1,{description:l.localize(339,null)})),stopRenderingLineAfter:ke(new t(Re.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:ke(new qe),inlineSuggest:ke(new J),inlineEdit:ke(new fe),inlineCompletionsAccessibilityVerbose:ke(new s(Re.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(340,null)})),suggestFontSize:ke(new t(Re.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new t(Re.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new s(Re.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:l.localize(343,null)})),suggestSelection:ke(new _(Re.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(344,null),l.localize(345,null),l.localize(346,null)],description:l.localize(347,null)})),tabCompletion:ke(new _(Re.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(348,null),l.localize(349,null),l.localize(350,null)],description:l.localize(351,null)})),tabIndex:ke(new t(Re.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:ke(new X),unusualLineTerminators:ke(new _(Re.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(352,null),l.localize(353,null),l.localize(354,null)],description:l.localize(355,null)})),useShadowDOM:ke(new s(Re.useShadowDOM,"useShadowDOM",!0)),useTabStops:ke(new s(Re.useTabStops,"useTabStops",!0,{description:l.localize(356,null)})),wordBreak:ke(new _(Re.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(357,null),l.localize(358,null)],description:l.localize(359,null)})),wordSegmenterLocales:ke(new it),wordSeparators:ke(new o(Re.wordSeparators,"wordSeparators",v.USUAL_WORD_SEPARATORS,{description:l.localize(360,null)})),wordWrap:ke(new _(Re.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(361,null),l.localize(362,null),l.localize(363,null),l.localize(364,null)],description:l.localize(365,null)})),wordWrapBreakAfterCharacters:ke(new o(Re.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new o(Re.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new t(Re.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(366,null)})),wordWrapOverride1:ke(new _(Re.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new _(Re.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ke(new x),defaultColorDecorators:ke(new s(Re.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:l.localize(367,null)})),pixelRatio:ke(new pe),tabFocusMode:ke(new s(Re.tabFocusMode,"tabFocusMode",!1,{markdownDescription:l.localize(368,null)})),layoutInfo:ke(new re),wrappingInfo:ke(new ot),wrappingIndent:ke(new rt),wrappingStrategy:ke(new Se)}}),define(we[265],ye([1,0,23,43,219,5,109,11,25]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=T,e.massageMessageBoxOptions=E,e.IDialogService=(0,A.createDecorator)("dialogService");var l;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(l||(l={}));class P{getConfirmationButtons(u){return this.getButtons(u,l.Confirmation)}getPromptButtons(u){return this.getButtons(u,l.Prompt)}getInputButtons(u){return this.getButtons(u,l.Input)}getButtons(u,f){const m=[];switch(f){case l.Confirmation:{const n=u;n.primaryButton?m.push(n.primaryButton):m.push((0,k.localize)(0,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,k.localize)(1,null));break}case l.Prompt:{const n=u;Array.isArray(n.buttons)&&n.buttons.length>0&&m.push(...n.buttons.map(s=>s.label)),n.cancelButton&&(n.cancelButton===!0?m.push((0,k.localize)(2,null)):typeof n.cancelButton=="string"?m.push(n.cancelButton):n.cancelButton.label?m.push(n.cancelButton.label):m.push((0,k.localize)(3,null))),m.length===0&&m.push((0,k.localize)(4,null));break}case l.Input:{const n=u;n.primaryButton?m.push(n.primaryButton):m.push((0,k.localize)(5,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,k.localize)(6,null));break}}return m}getDialogType(u){if(typeof u=="string")return u;if(typeof u=="number")return u===g.default.Info?"info":u===g.default.Error?"error":u===g.default.Warning?"warning":"none"}getPromptResult(u,f,m){const n=[...u.buttons??[]];u.cancelButton&&typeof u.cancelButton!="string"&&typeof u.cancelButton!="boolean"&&n.push(u.cancelButton);let s=n[f]?.run({checkboxChecked:m});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:m}}}e.AbstractDialogHandler=P,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var y;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const d=10;function T(a){const u=[];return u.push(...a.slice(0,d).map(f=>typeof f=="string"?f:(0,r.basename)(f))),a.length>d&&(a.length-d===1?u.push((0,k.localize)(7,null)):u.push((0,k.localize)(8,null,a.length-d))),u.push(""),u.join(`
`)}function E(a,u){const f=(0,v.deepClone)(a);let m=(f.buttons??[]).map(t=>(0,L.mnemonicButtonLabel)(t)),n=(a.buttons||[]).map((t,c)=>c),s=0,i=f.cancelId??m.length-1;if(m.length>1){const t=typeof i=="number"?m[i]:void 0;if(R.isLinux||R.isMacintosh){if(typeof t=="string"&&m.length>1&&i!==1){m.splice(i,1),m.splice(1,0,t);const c=n[i];n.splice(i,1),n.splice(1,0,c),i=1}R.isLinux&&m.length>1&&(m=m.reverse(),n=n.reverse(),s=m.length-1,typeof t=="string"&&(i=s-1))}else if(R.isWindows&&typeof t=="string"&&m.length>1&&i!==m.length-1){m.splice(i,1),m.push(t);const c=n[i];n.splice(i,1),n.push(c),i=m.length-1}}return f.buttons=m,f.defaultId=s,f.cancelId=i,f.noLink=!0,f.title=f.title||u.nameLong,{options:f,buttonIndeces:n}}}),define(we[143],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(we[266],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,r.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(we[267],ye([1,0,59,60,15,16,11,108,34,111,222,266]),function(he,e,r,g,k,A,L,R,v,l,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const d=P.localize(0,null);class T{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await u.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends T{static{this.CMD="cmd.exe"}openTerminal(i,t){return this.spawnTerminal(r,i,l.getWindowsShell(),t)}spawnTerminal(i,t,c,h){const o=t.windowsExec||E.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const p=A.basename(o,".exe").toLowerCase();if(p==="cmder")return i.spawn(o,h?[h]:void 0),Promise.resolve(void 0);const _=["/c","start","/wait"];return o.indexOf(" ")>=0&&_.push('""'),_.push(o),p==="wt"&&_.push("-d ."),new Promise((D,C)=>{const S=f(process),I=i.spawn(c,_,{cwd:h,env:S,detached:!0});I.on("error",C),I.on("exit",()=>D())})}async runInTerminal(i,t,c,h,o){const p="windowsExec"in o&&o.windowsExec?o.windowsExec:E.getDefaultTerminalWindows(),_=await E.getWtExePath();return new Promise((D,C)=>{const S=`"${t} - ${d}"`,I=`"${c.join('" "')}" & pause`,b=Object.assign({},f(process),h);Object.keys(b).filter(x=>b[x]===null).forEach(x=>delete b[x]);const w={cwd:t,env:b,windowsVerbatimArguments:!0};let N,O;A.basename(p,".exe")==="wt"?(N=p,O=["-d",".",E.CMD,"/c",I]):_?(N=_,O=["-d",".",p,"/c",I]):(N=E.CMD,O=["/c","start",S,"/wait",p,"/c",`"${I}"`]),r.spawn(N,O,w).on("error",x=>{C(m(x))}),D(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const i=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${i?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const i=await l.win32.findExecutable("wt");return await v.Promises.exists(i)?i:void 0}catch{return}}}e.WindowsExternalTerminalService=E,Ke([g.memoize],E,"getWtExePath",null);class a extends T{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,c,h,o){const p=o.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((_,D)=>{if(p===y.DEFAULT_TERMINAL_OSX||p==="iTerm.app"){const C=p===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",I=[k.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${C}.scpt`).fsPath,"-t",i||d,"-w",t];for(const N of c)I.push("-a"),I.push(N);if(h){const N=Object.assign({},f(process),h);for(const O in N){const U=N[O];U===null?(I.push("-u"),I.push(O)):(I.push("-e"),I.push(`${O}=${U}`))}}let b="";const w=r.spawn(a.OSASCRIPT,I);w.on("error",N=>{D(m(N))}),w.stderr.on("data",N=>{b+=N.toString()}),w.on("exit",N=>{if(N===0)_(void 0);else if(b){const O=b.split(`
`,1);D(new Error(O[0]))}else D(new Error(P.localize(1,null,C,N)))})}else D(new Error(P.localize(2,null,p)))})}spawnTerminal(i,t,c){const h=t.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((o,p)=>{const _=["-a",h];c&&_.push(c);const D=f(process),C=i.spawn("/usr/bin/open",_,{cwd:c,env:D});C.on("error",p),C.on("exit",()=>o())})}}e.MacExternalTerminalService=a;class u extends T{static{this.WAIT_MESSAGE=P.localize(3,null)}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,c,h,o){const p=o.linuxExec?Promise.resolve(o.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((_,D)=>{const C=[];p.then(S=>{S.indexOf("gnome-terminal")>=0?C.push("-x"):C.push("-e"),C.push("bash"),C.push("-c");const I=`${n(c)}; echo; read -p "${u.WAIT_MESSAGE}" -n1;`;C.push(`''${I}''`);const b=Object.assign({},f(process),h);Object.keys(b).filter(U=>b[U]===null).forEach(U=>delete b[U]);const w={cwd:t,env:b};let N="";const O=r.spawn(S,C,w);O.on("error",U=>{D(m(U))}),O.stderr.on("data",U=>{N+=U.toString()}),O.on("exit",U=>{if(U===0)_(void 0);else if(N){const x=N.split(`
`,1);D(new Error(x[0]))}else D(new Error(P.localize(4,null,S,U)))})})})}static async getDefaultTerminalLinuxReady(){if(!u._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)u._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const i=await v.Promises.exists("/etc/debian_version");u._DEFAULT_TERMINAL_LINUX_READY=new Promise(t=>{i?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return u._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(i,t,c){const h=t.linuxExec?Promise.resolve(t.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((o,p)=>{h.then(_=>{const D=f(process),C=i.spawn(_,[],{cwd:c,env:D});C.on("error",p),C.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=u;function f(s){const i={...s.env};return(0,R.sanitizeProcessEnvironment)(i),i}function m(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(P.localize(5,null,s.path)):s}function n(s){let i="";for(const t of s)t.indexOf(" ")>=0?i+='"'+t+'"':i+=t,i+=" ";return i}}),define(we[28],ye([1,0,85,16,13,18,2,223,5,11,15,49]),function(he,e,r,g,k,A,L,R,v,l,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=d,e.isFileSystemWatcher=u,e.hasReadWriteCapability=m,e.hasFileFolderCopyCapability=n,e.hasFileCloneCapability=s,e.hasOpenReadWriteCloseCapability=i,e.hasFileReadStreamCapability=t,e.hasFileAtomicReadCapability=c,e.hasFileAtomicWriteCapability=h,e.hasFileAtomicDeleteCapability=o,e.hasReadonlyCapability=p,e.createFileSystemProviderError=C,e.ensureFileSystemProviderError=S,e.markAsFileSystemProviderError=I,e.toFileSystemProviderErrorCode=b,e.toFileOperationResult=w,e.isParent=B,e.etag=q,e.whenProviderRegistered=Z,e.getLargeFileConfirmationLimit=de,e.IFileService=(0,v.createDecorator)("fileService");function d(re){return re.create===!0}var T;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(T||(e.FileType=T={}));var E;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(E||(e.FilePermission=E={}));var a;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function u(re){const Se=re;return!!Se&&typeof Se.onDidChange=="function"}var f;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function m(re){return!!(re.capabilities&f.FileReadWrite)}function n(re){return!!(re.capabilities&f.FileFolderCopy)}function s(re){return!!(re.capabilities&f.FileClone)}function i(re){return!!(re.capabilities&f.FileOpenReadWriteClose)}function t(re){return!!(re.capabilities&f.FileReadStream)}function c(re){return m(re)?!!(re.capabilities&f.FileAtomicRead):!1}function h(re){return m(re)?!!(re.capabilities&f.FileAtomicWrite):!1}function o(re){return!!(re.capabilities&f.FileAtomicDelete)}function p(re){return!!(re.capabilities&f.Readonly)}var _;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(_||(e.FileSystemProviderErrorCode=_={}));class D extends Error{static create(Se,ve){const G=new D(Se.toString(),ve);return I(G,ve),G}constructor(Se,ve){super(Se),this.code=ve}}e.FileSystemProviderError=D;function C(re,Se){return D.create(re,Se)}function S(re){return re||C((0,R.localize)(0,null),_.Unknown)}function I(re,Se){return re.name=Se?`${Se} (FileSystemError)`:"FileSystemError",re}function b(re){if(!re)return _.Unknown;if(re instanceof D)return re.code;const Se=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Se)return _.Unknown;switch(Se[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}function w(re){if(re instanceof F)return re.fileOperationResult;switch(b(re)){case _.FileNotFound:return ee.FILE_NOT_FOUND;case _.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case _.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case _.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case _.NoPermissions:return ee.FILE_PERMISSION_DENIED;case _.FileExists:return ee.FILE_MOVE_CONFLICT;case _.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var N;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class O{constructor(Se,ve,G){this.resource=Se,this.operation=ve,this.target=G}isOperation(Se){return this.operation===Se}}e.FileOperationEvent=O;var U;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class x{static{this.MIXED_CORRELATION=null}constructor(Se,ve){this.ignorePathCasing=ve,this.correlationId=void 0,this.added=new y.Lazy(()=>{const G=r.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawAdded.map(W=>[W,!0])),G}),this.updated=new y.Lazy(()=>{const G=r.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawUpdated.map(W=>[W,!0])),G}),this.deleted=new y.Lazy(()=>{const G=r.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawDeleted.map(W=>[W,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of Se){switch(G.type){case U.ADDED:this.rawAdded.push(G.resource);break;case U.UPDATED:this.rawUpdated.push(G.resource);break;case U.DELETED:this.rawDeleted.push(G.resource);break}this.correlationId!==x.MIXED_CORRELATION&&(typeof G.cId=="number"?this.correlationId===void 0?this.correlationId=G.cId:this.correlationId!==G.cId&&(this.correlationId=x.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=x.MIXED_CORRELATION))}}contains(Se,...ve){return this.doContains(Se,{includeChildren:!1},...ve)}affects(Se,...ve){return this.doContains(Se,{includeChildren:!0},...ve)}doContains(Se,ve,...G){if(!Se)return!1;const W=G.length>0;return!!((!W||G.includes(U.ADDED))&&(this.added.value.get(Se)||ve.includeChildren&&this.added.value.findSuperstr(Se))||(!W||G.includes(U.UPDATED))&&(this.updated.value.get(Se)||ve.includeChildren&&this.updated.value.findSuperstr(Se))||(!W||G.includes(U.DELETED))&&(this.deleted.value.findSubstr(Se)||ve.includeChildren&&this.deleted.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.correlationId===Se}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=x;function B(re,Se,ve){return!re||!Se||re===Se||Se.length>re.length?!1:(Se.charAt(Se.length-1)!==g.sep&&(Se+=g.sep),ve?(0,k.startsWithIgnoreCase)(re,Se):re.indexOf(Se)===0)}class F extends Error{constructor(Se,ve,G){super(Se),this.fileOperationResult=ve,this.options=G}}e.FileOperationError=F;class M extends F{constructor(Se,ve,G,W){super(Se,ve,W),this.fileOperationResult=ve,this.size=G}}e.TooLargeFileOperationError=M;class K extends F{constructor(Se,ve,G){super(Se,ee.FILE_NOT_MODIFIED_SINCE,G),this.stat=ve}}e.NotModifiedSinceFileOperationError=K;var ee;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var $;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})($||(e.FileKind=$={})),e.ETAG_DISABLED="";function q(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function Z(re,Se){if(!Se.hasProvider(L.URI.from({scheme:re.scheme})))return new Promise(ve=>{const G=Se.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===re.scheme&&W.added&&(G.dispose(),ve())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(Se){return(0,A.isNumber)(Se)||(Se=0),Se<ne.KB?(0,R.localize)(1,null,Se.toFixed(0)):Se<ne.MB?(0,R.localize)(2,null,(Se/ne.KB).toFixed(2)):Se<ne.GB?(0,R.localize)(3,null,(Se/ne.MB).toFixed(2)):Se<ne.TB?(0,R.localize)(4,null,(Se/ne.GB).toFixed(2)):(0,R.localize)(5,null,(Se/ne.TB).toFixed(2))}}e.ByteSize=ne;function de(re){const Se=typeof re=="string"||re?.scheme===P.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===P.Schemas.file?1024*ne.MB:Se?10*ne.MB:l.isWeb?50*ne.MB:1024*ne.MB}}),define(we[268],ye([1,0,22,14,224,28]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=L;async function L(P,y,d,T,E,a){let u;try{await R(P,y,d,T,E,a)}catch(f){u=f}finally{u&&E.errorTransformer&&(u=E.errorTransformer(u)),typeof u<"u"&&d.error(u),d.end()}}async function R(P,y,d,T,E,a){v(a);const u=await P.open(y,{create:!1});try{v(a);let f=0,m=0,n=E&&typeof E.length=="number"?E.length:void 0,s=r.VSBuffer.alloc(Math.min(E.bufferSize,typeof n=="number"?n:E.bufferSize)),i=E&&typeof E.position=="number"?E.position:0,t=0;do m=await P.read(u,i,s.buffer,t,s.byteLength-t),i+=m,t+=m,f+=m,typeof n=="number"&&(n-=m),t===s.byteLength&&(await d.write(T(s)),s=r.VSBuffer.alloc(Math.min(E.bufferSize,typeof n=="number"?n:E.bufferSize)),t=0);while(m>0&&(typeof n!="number"||n>0)&&v(a)&&l(f,E));if(t>0){let c=t;typeof n=="number"&&(c=Math.min(t,n)),d.write(T(s.slice(0,c)))}}catch(f){throw(0,A.ensureFileSystemProviderError)(f)}finally{await P.close(u)}}function v(P){if(P.isCancellationRequested)throw(0,g.canceled)();return!0}function l(P,y){if(typeof y?.limits?.size=="number"&&P>y.limits.size)throw(0,A.createFileSystemProviderError)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(we[69],ye([1,0,39,3,16,11,2,28]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=v,e.isRecursiveWatchRequest=l,e.reviveFileChanges=T,e.coalesceEvents=E,e.normalizeWatcherPattern=a,e.parseWatcherPatterns=u,e.isFiltered=m,e.requestFilterToString=n;function v(s){return typeof s.correlationId=="number"}function l(s){return s.recursive===!0}class P extends g.Disposable{static{this.MAX_RESTARTS_PER_REQUEST_ERROR=3}static{this.MAX_RESTARTS_PER_UNKNOWN_ERROR=10}constructor(i,t,c,h){super(),this.onFileChanges=i,this.onLogMessage=t,this.verboseLogging=c,this.options=h,this.watcherDisposables=this._register(new g.MutableDisposable),this.requests=void 0,this.restartsPerRequestError=new Map,this.restartsPerUnknownError=0}init(){const i=new g.DisposableStore;this.watcherDisposables.value=i,this.watcher=this.createWatcher(i),this.watcher.setVerboseLogging(this.verboseLogging),i.add(this.watcher.onDidChangeFile(t=>this.onFileChanges(t))),i.add(this.watcher.onDidLogMessage(t=>this.onLogMessage(t))),i.add(this.watcher.onDidError(t=>this.onError(t.error,t.request)))}onError(i,t){if(this.options.restartOnError&&this.requests?.length)if(t){const c=this.restartsPerRequestError.get(t.path)??0;c<P.MAX_RESTARTS_PER_REQUEST_ERROR?(this.error(`restarting watcher from error in watch request (retrying request): ${i} (${JSON.stringify(t)})`),this.restartsPerRequestError.set(t.path,c+1),this.restart(this.requests)):(this.error(`restarting watcher from error in watch request (skipping request): ${i} (${JSON.stringify(t)})`),this.restart(this.requests.filter(h=>h.path!==t.path)))}else this.restartsPerUnknownError<P.MAX_RESTARTS_PER_UNKNOWN_ERROR?(this.error(`restarting watcher after unknown global error: ${i}`),this.restartsPerUnknownError++,this.restart(this.requests)):this.error(`giving up attempting to restart watcher after error: ${i}`);else this.error(i)}restart(i){this.init(),this.watch(i)}async watch(i){this.requests=i,await this.watcher?.watch(i)}async setVerboseLogging(i){this.verboseLogging=i,await this.watcher?.setVerboseLogging(i)}error(i){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${i}`})}trace(i){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${i}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=P;class y extends P{constructor(i,t,c){super(i,t,c,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class d extends P{constructor(i,t,c){super(i,t,c,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=d;function T(s){return s.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}function E(s){const i=new f;for(const t of s)i.processEvent(t);return i.coalesce()}function a(s,i){return typeof i=="string"&&!i.startsWith(r.GLOBSTAR)&&!(0,k.isAbsolute)(i)?{base:s,pattern:i}:i}function u(s,i){const t=[];for(const c of i)t.push((0,r.parse)(a(s,c)));return t}class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(i){return A.isLinux?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const t=this.mapPathToChange.get(this.toKey(i));let c=!1;if(t){const h=t.type,o=i.type;t.resource.fsPath!==i.resource.fsPath&&(i.type===R.FileChangeType.DELETED||i.type===R.FileChangeType.ADDED)?c=!0:h===R.FileChangeType.ADDED&&o===R.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(i)),this.coalesced.delete(t)):h===R.FileChangeType.DELETED&&o===R.FileChangeType.ADDED?t.type=R.FileChangeType.UPDATED:h===R.FileChangeType.ADDED&&o===R.FileChangeType.UPDATED||(t.type=o)}else c=!0;c&&(this.coalesced.add(i),this.mapPathToChange.set(this.toKey(i),i))}coalesce(){const i=[],t=[];return Array.from(this.coalesced).filter(c=>c.type!==R.FileChangeType.DELETED?(i.push(c),!1):!0).sort((c,h)=>c.resource.fsPath.length-h.resource.fsPath.length).filter(c=>t.some(h=>(0,R.isParent)(c.resource.fsPath,h,!A.isLinux))?!1:(t.push(c.resource.fsPath),!0)).concat(i)}}function m(s,i){if(typeof i=="number")switch(s.type){case R.FileChangeType.ADDED:return(i&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(i&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(i&R.FileChangeFilter.UPDATED)===0}return!1}function n(s){if(typeof s=="number"){const i=[];return s&R.FileChangeFilter.ADDED&&i.push("Added"),s&R.FileChangeFilter.DELETED&&i.push("Deleted"),s&R.FileChangeFilter.UPDATED&&i.push("Updated"),i.length===0?"<all>":`[${i.join(", ")}]`}return"<none>"}}),define(we[269],ye([1,0,58,3,69,4,28,2,9]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class l extends g.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new A.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new A.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new g.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new v.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(y=>this.handleDidWatchFail(y)))}handleDidWatchFail(y){this.isCorrelated(y)&&this.suspendWatchRequest(y)}isCorrelated(y){return(0,k.isWatchRequestWithCorrelation)(y)}async watch(y){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new v.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const d of y)this.isCorrelated(d)?this.allCorrelatedWatchRequests.set(d.correlationId,d):this.allNonCorrelatedWatchRequests.add(d);for(const[d]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(d)||(this.suspendedWatchRequests.deleteAndDispose(d),this.suspendedWatchRequestsWithPolling.delete(d));return await this.updateWatchers()}finally{this.joinWatch.complete()}}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(y=>!this.suspendedWatchRequests.has(y.correlationId))])}isSuspended(y){return typeof y.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(y.correlationId)?"polling":this.suspendedWatchRequests.has(y.correlationId)}async suspendWatchRequest(y){if(this.suspendedWatchRequests.has(y.correlationId))return;const d=new g.DisposableStore;this.suspendedWatchRequests.set(y.correlationId,d),await this.joinWatch.p,!d.isDisposed&&(this.monitorSuspendedWatchRequest(y,d),this.updateWatchers())}resumeWatchRequest(y){this.suspendedWatchRequests.deleteAndDispose(y.correlationId),this.suspendedWatchRequestsWithPolling.delete(y.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(y,d){this.doMonitorWithExistingWatcher(y,d)?(this.trace(`reusing an existing recursive watcher to monitor ${y.path}`),this.suspendedWatchRequestsWithPolling.delete(y.correlationId)):(this.doMonitorWithNodeJS(y,d),this.suspendedWatchRequestsWithPolling.add(y.correlationId))}doMonitorWithExistingWatcher(y,d){const T=this.recursiveWatcher?.subscribe(y.path,(E,a)=>{d.isDisposed||(E?this.monitorSuspendedWatchRequest(y,d):a?.type===L.FileChangeType.ADDED&&this.onMonitoredPathAdded(y))});return T?(d.add(T),!0):!1}doMonitorWithNodeJS(y,d){let T=!1;const E=(a,u)=>{if(d.isDisposed)return;const f=this.isPathNotFound(a),m=this.isPathNotFound(u),n=T;T=f,!f&&(m||n)&&this.onMonitoredPathAdded(y)};this.trace(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,r.watchFile)(y.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},E)}catch(a){this.warn(`fs.watchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}d.add((0,g.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,r.unwatchFile)(y.path,E)}catch(a){this.warn(`fs.unwatchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}onMonitoredPathAdded(y){this.trace(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const d={resource:R.URI.file(y.path),type:L.FileChangeType.ADDED,cId:y.correlationId};this._onDidChangeFile.fire([d]),this.traceEvent(d,y),this.resumeWatchRequest(y)}isPathNotFound(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(y,d){if(this.verboseLogging){const T=` >> normalized ${y.type===L.FileChangeType.ADDED?"[ADDED]":y.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.traceWithCorrelation(T,d)}}traceWithCorrelation(y,d){this.verboseLogging&&this.trace(`${y}${typeof d.correlationId=="number"?` <${d.correlationId}> `:""}`)}requestToString(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,k.requestFilterToString)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.verboseLogging=y}}e.BaseWatcher=l}),define(we[270],ye([1,0,58,9,21,33,3,82,16,11,23,2,110,34,28,69]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=f;class u extends L.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(n,s,i,t,c,h){super(),this.request=n,this.recursiveWatcher=s,this.onDidFilesChange=i,this.onDidWatchFail=t,this.onLogMessage=c,this.verboseLogging=h,this.throttledFileChangesEmitter=this._register(new g.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.onDidFilesChange(o))),this.fileChangesAggregator=this._register(new g.RunOnceWorker(o=>this.handleFileChanges(o),u.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,a.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,a.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,a.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const n=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const s=await T.Promises.stat(n);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(n,s.isDirectory()))}catch(n){n.code!=="ENOENT"?this.error(n):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${n})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(n){let s=n.path;try{s=await T.Promises.realpath(n.path),n.path===s&&(s=await(0,d.realcase)(n.path,this.cts.token)??n.path),n.path!==s&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${s})`)}catch{}return s}async doWatch(n,s){const i=new L.DisposableStore;return this.doWatchWithExistingWatcher(n,s,i)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(n,s,i)),i}doWatchWithExistingWatcher(n,s,i){if(s)return!1;const t=y.URI.file(this.request.path),c=this.recursiveWatcher?.subscribe(this.request.path,async(h,o)=>{if(!i.isDisposed)if(h){const p=await this.doWatch(n,s);i.isDisposed?p.dispose():i.add(p)}else o&&(typeof o.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:t,type:o.type,cId:this.request.correlationId},!0)});return c?(i.add(c),!0):!1}async doWatchWithNodeJS(n,s,i){if(l.isMacintosh&&(0,A.isEqualOrParent)(n,"/Volumes/",!0)){this.error(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new k.CancellationTokenSource(this.cts.token);i.add((0,L.toDisposable)(()=>t.dispose(!0)));const c=new L.DisposableStore;i.add(c);try{const h=y.URI.file(this.request.path),o=(0,v.basename)(n),p=(0,r.watch)(n);c.add((0,L.toDisposable)(()=>{p.removeAllListeners(),p.close()})),this.trace(`Started watching: '${n}'`);const _=new Set;if(s)try{for(const C of await T.Promises.readdir(n))_.add(C)}catch(C){this.error(C)}if(t.token.isCancellationRequested)return;const D=new Map;c.add((0,L.toDisposable)(()=>{for(const[,C]of D)C.dispose();D.clear()})),p.on("error",(C,S)=>{t.token.isCancellationRequested||(this.error(`Failed to watch ${n} for changes using fs.watch() (${C}, ${S})`),this.notifyWatchFailed())}),p.on("change",(C,S)=>{if(t.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${C}"] ${S}`);let I="";if(S&&(I=S.toString(),l.isMacintosh&&(I=(0,R.normalizeNFC)(I))),!(!I||C!=="change"&&C!=="rename"))if(s)if(C==="rename"){D.get(I)?.dispose();const b=setTimeout(async()=>{if(D.delete(I),I===o&&!await T.Promises.exists(n)){this.onWatchedPathDeleted(h);return}if(t.token.isCancellationRequested)return;const w=await this.existsChildStrictCase((0,v.join)(n,I));if(t.token.isCancellationRequested)return;let N;w?_.has(I)?N=E.FileChangeType.UPDATED:(N=E.FileChangeType.ADDED,_.add(I)):(_.delete(I),N=E.FileChangeType.DELETED),this.onFileChange({resource:(0,P.joinPath)(h,I),type:N,cId:this.request.correlationId})},u.FILE_DELETE_HANDLER_DELAY);D.set(I,(0,L.toDisposable)(()=>clearTimeout(b)))}else{let b;_.has(I)?b=E.FileChangeType.UPDATED:(b=E.FileChangeType.ADDED,_.add(I)),this.onFileChange({resource:(0,P.joinPath)(h,I),type:b,cId:this.request.correlationId})}else if(C==="rename"||I!==o){const b=setTimeout(async()=>{const w=await T.Promises.exists(n);t.token.isCancellationRequested||(w?(this.onFileChange({resource:h,type:E.FileChangeType.UPDATED,cId:this.request.correlationId},!0),c.add(await this.doWatch(n,!1))):this.onWatchedPathDeleted(h))},u.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,L.toDisposable)(()=>clearTimeout(b)))}else this.onFileChange({resource:h,type:E.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(h){t.token.isCancellationRequested||this.error(`Failed to watch ${n} for changes using fs.watch() (${h.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(n){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:n,type:E.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(n,s=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${n.type===E.FileChangeType.ADDED?"[ADDED]":n.type===E.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!s&&this.excludes.some(i=>i(n.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${n.resource.fsPath}`):!s&&this.includes&&this.includes.length>0&&!this.includes.some(i=>i(n.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${n.resource.fsPath}`):this.fileChangesAggregator.work(n))}handleFileChanges(n){const s=(0,a.coalesceEvents)(n),i=[];for(const c of s){if((0,a.isFiltered)(c,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${c.resource.fsPath}`);continue}i.push(c)}if(i.length===0)return;if(this.verboseLogging)for(const c of i)this.traceWithCorrelation(` >> normalized ${c.type===E.FileChangeType.ADDED?"[ADDED]":c.type===E.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.throttledFileChangesEmitter.work(i)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(n){if(l.isLinux)return T.Promises.exists(n);try{const s=(0,v.basename)(n);return(await T.Promises.readdir((0,v.dirname)(n))).some(t=>t===s)}catch(s){return this.trace(s),!1}}setVerboseLogging(n){this.verboseLogging=n}error(n){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}warn(n){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}trace(n){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}traceWithCorrelation(n){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${n}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u;async function f(m,n,s,i,t=512){const c=await T.Promises.open(m,"r"),h=Buffer.allocUnsafe(t),o=new k.CancellationTokenSource(i);let p,_=!1;const D={path:m,excludes:[],recursive:!1},C=new u(D,void 0,S=>{(async()=>{for(const{type:I}of S)if(I===E.FileChangeType.UPDATED){if(_)return;_=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:b}=await T.Promises.read(c,h,0,t,null);if(!b||o.token.isCancellationRequested)break;n(h.slice(0,b))}}catch(b){p=new Error(b),o.dispose(!0)}finally{_=!1}}})()});return await C.ready,s(),new Promise((S,I)=>{o.token.onCancellationRequested(async()=>{C.dispose();try{await T.Promises.close(c)}catch(b){p=new Error(b)}p?I(p):S()})})}}),define(we[271],ye([1,0,4,39,269,11,270,33]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class v extends k.BaseWatcher{constructor(P){super(),this.recursiveWatcher=P,this.onDidError=r.Event.None,this.watchers=new Set}async doWatch(P){P=this.removeDuplicateRequests(P);const y=[],d=new Set(Array.from(this.watchers));for(const T of P){const E=this.findWatcher(T);E&&(0,g.patternsEquals)(E.request.excludes,T.excludes)&&(0,g.patternsEquals)(E.request.includes,T.includes)?d.delete(E):y.push(T)}y.length&&this.trace(`Request to start watching: ${y.map(T=>this.requestToString(T)).join(",")}`),d.size&&this.trace(`Request to stop watching: ${Array.from(d).map(T=>this.requestToString(T.request)).join(",")}`);for(const T of d)this.stopWatching(T);for(const T of y)this.startWatching(T)}findWatcher(P){for(const y of this.watchers)if(typeof P.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===P.correlationId)return y}else if((0,R.isEqual)(y.request.path,P.path,!A.isLinux))return y}startWatching(P){const y=new L.NodeJSFileWatcherLibrary(P,this.recursiveWatcher,T=>this._onDidChangeFile.fire(T),()=>this._onDidWatchFail.fire(P),T=>this._onDidLogMessage.fire(T),this.verboseLogging),d={request:P,instance:y};this.watchers.add(d)}async stop(){await super.stop();for(const P of this.watchers)this.stopWatching(P)}stopWatching(P){this.trace("stopping file watcher",P),this.watchers.delete(P),P.instance.dispose()}removeDuplicateRequests(P){const y=new Map;for(const d of P){const T=A.isLinux?d.path:d.path.toLowerCase();let E=y.get(d.correlationId);E||(E=new Map,y.set(d.correlationId,E)),E.has(T)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(d)}`),E.set(T,d)}return Array.from(y.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(P){super.setVerboseLogging(P);for(const y of this.watchers)y.instance.setVerboseLogging(P)}trace(P,y){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(P,y)})}warn(P){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(P)})}toMessage(P,y){return y?`[File Watcher (node.js)] ${P} (${this.requestToString(y.request)})`:`[File Watcher (node.js)] ${P}`}}e.NodeJSWatcher=v}),define(we[272],ye([1,0,69,271]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends r.AbstractNonRecursiveWatcherClient{constructor(L,R,v){super(L,R,v),this.init()}createWatcher(L){return L.add(new g.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=k}),define(we[273],ye([1,0,15,87,207,69]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends A.AbstractUniversalWatcherClient{constructor(v,l,P){super(v,l,P),this.init()}createWatcher(v){const l=v.add(new k.Client(r.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(l.onDidProcessExit(({code:P,signal:y})=>this.onError(`terminated by itself with code ${P}, signal: ${y} (ETERM)`))),g.ProxyChannel.toService((0,g.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(we[114],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...k){this._entries=new Map;for(const[A,L]of k)this.set(A,L)}set(k,A){const L=this._entries.get(k);return this._entries.set(k,A),L}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=r}),define(we[274],ye([1,0,9,14,3,112,263,5,114,81]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class y extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class d{constructor(u=new v.ServiceCollection,f=!1,m,n=P){this._services=u,this._strict=f,this._parent=m,this._enableTracing=n,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=n?m?._globalGraph??new L.Graph(s=>s):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,k.dispose)(this._children),this._children.clear();for(const u of this._servicesToMaybeDispose)(0,k.isDisposable)(u)&&u.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(u,f){this._throwIfDisposed();const m=this,n=new class extends d{dispose(){m._children.delete(n),super.dispose()}}(u,this._strict,this,this._enableTracing);return this._children.add(n),f?.add(n),n}invokeFunction(u,...f){this._throwIfDisposed();const m=E.traceInvocation(this._enableTracing,u);let n=!1;try{return u({get:i=>{if(n)throw(0,g.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(i,m);if(!t)throw new Error(`[invokeFunction] unknown service '${i}'`);return t}},...f)}finally{n=!0,m.stop()}}createInstance(u,...f){this._throwIfDisposed();let m,n;return u instanceof A.SyncDescriptor?(m=E.traceCreation(this._enableTracing,u.ctor),n=this._createInstance(u.ctor,u.staticArguments.concat(f),m)):(m=E.traceCreation(this._enableTracing,u),n=this._createInstance(u,f,m)),m.stop(),n}_createInstance(u,f=[],m){const n=R._util.getServiceDependencies(u).sort((t,c)=>t.index-c.index),s=[];for(const t of n){const c=this._getOrCreateServiceInstance(t.id,m);c||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(c)}const i=n.length>0?n[0].index:f.length;if(f.length!==i){console.trace(`[createInstance] First service dependency of ${u.name} at position ${i+1} conflicts with ${f.length} static arguments`);const t=i-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,i)}return Reflect.construct(u,f.concat(s))}_setCreatedServiceInstance(u,f){if(this._services.get(u)instanceof A.SyncDescriptor)this._services.set(u,f);else if(this._parent)this._parent._setCreatedServiceInstance(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){const f=this._services.get(u);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):f}_getOrCreateServiceInstance(u,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(u));const m=this._getServiceInstanceOrDescriptor(u);return m instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,m,f.branch(u,!0)):(f.branch(u,!1),m)}_safeCreateAndCacheServiceInstance(u,f,m){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,f,m)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,f,m){const n=new L.Graph(t=>t.id.toString());let s=0;const i=[{id:u,desc:f,_trace:m}];for(;i.length;){const t=i.pop();if(n.lookupOrInsertNode(t),s++>1e3)throw new y(n);for(const c of R._util.getServiceDependencies(t.desc.ctor)){const h=this._getServiceInstanceOrDescriptor(c.id);if(h||this._throwIfStrict(`[createInstance] ${u} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),h instanceof A.SyncDescriptor){const o={id:c.id,desc:h,_trace:t._trace.branch(c.id,!0)};n.insertEdge(t,o),i.push(o)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new y(n);break}for(const{data:c}of t){if(this._getServiceInstanceOrDescriptor(c.id)instanceof A.SyncDescriptor){const o=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setCreatedServiceInstance(c.id,o)}n.removeNode(c)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,f,m=[],n,s){if(this._services.get(u)instanceof A.SyncDescriptor)return this._createServiceInstance(u,f,m,n,s,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,f,m,n,s);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(u,f,m=[],n,s,i){if(n){const t=new d(void 0,this._strict,this,this._enableTracing);t._globalGraphImplicitDependency=String(u);const c=new Map,h=new r.GlobalIdleValue(()=>{const o=t._createInstance(f,m,s);for(const[p,_]of c){const D=o[p];if(typeof D=="function")for(const C of _)C.disposable=D.apply(o,C.listener)}return c.clear(),i.add(o),o});return new Proxy(Object.create(null),{get(o,p){if(!h.isInitialized&&typeof p=="string"&&(p.startsWith("onDid")||p.startsWith("onWill"))){let C=c.get(p);return C||(C=new l.LinkedList,c.set(p,C)),(I,b,w)=>{if(h.isInitialized)return h.value[p](I,b,w);{const N={listener:[I,b,w],disposable:void 0},O=C.push(N);return(0,k.toDisposable)(()=>{O(),N.disposable?.dispose()})}}}if(p in o)return o[p];const _=h.value;let D=_[p];return typeof D!="function"||(D=D.bind(_),o[p]=D),D},set(o,p,_){return h.value[p]=_,!0},getPrototypeOf(o){return f.prototype}})}else{const t=this._createInstance(f,m,s);return i.add(t),t}}_throwIfStrict(u,f){if(f&&console.warn(u),this._strict)throw new Error(u)}}e.InstantiationService=d;var T;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(T||(T={}));class E{static{this.all=new Set}static{this._None=new class extends E{constructor(){super(T.None,null)}stop(){}branch(){return this}}}static traceInvocation(u,f){return u?new E(T.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E._None}static traceCreation(u,f){return u?new E(T.Creation,f.name):E._None}static{this._totals=0}constructor(u,f){this.type=u,this.name=f,this._start=Date.now(),this._dep=[]}branch(u,f){const m=new E(T.Branch,u.toString());return this._dep.push([u,f,m]),m}stop(){const u=Date.now()-this._start;E._totals+=u;let f=!1;function m(s,i){const t=[],c=new Array(s+1).join("	");for(const[h,o,p]of i._dep)if(o&&p){f=!0,t.push(`${c}CREATES -> ${h}`);const _=m(s+1,p);_&&t.push(_)}else t.push(`${c}uses -> ${h}`);return t.join(`
`)}const n=[`${this.type===T.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(u>2||f)&&E.all.add(n.join(`
`))}}e.Trace=E}),define(we[12],ye([1,0,226,51,4,61,3,29,11,23,18,2,35,5]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=a,e.log=f,e.getLogLevel=D,e.LogLevelToString=C,e.LogLevelToLocalizedString=S,e.parseLogLevel=I,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function E(){return new Date().toISOString()}function a(b){return(0,P.isNumber)(b)}var u;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(u||(e.LogLevel=u={})),e.DEFAULT_LOG_LEVEL=u.Info;function f(b,w,N){switch(w){case u.Trace:b.trace(N);break;case u.Debug:b.debug(N);break;case u.Info:b.info(N);break;case u.Warning:b.warn(N);break;case u.Error:b.error(N);break;case u.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function m(b,w=!1){let N="";for(let O=0;O<b.length;O++){let U=b[O];if(U instanceof Error&&(U=(0,g.toErrorMessage)(U,w)),typeof U=="object")try{U=JSON.stringify(U)}catch{}N+=(O>0?" ":"")+U}return N}class n extends L.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(w){this.level!==w&&(this.level=w,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(w){return this.level!==u.Off&&this.level<=w}}e.AbstractLogger=n;class s extends n{constructor(w){super(),this.logAlways=w}checkLogLevel(w){return this.logAlways||super.checkLogLevel(w)}trace(w,...N){this.checkLogLevel(u.Trace)&&this.log(u.Trace,m([w,...N],!0))}debug(w,...N){this.checkLogLevel(u.Debug)&&this.log(u.Debug,m([w,...N]))}info(w,...N){this.checkLogLevel(u.Info)&&this.log(u.Info,m([w,...N]))}warn(w,...N){this.checkLogLevel(u.Warning)&&this.log(u.Warning,m([w,...N]))}error(w,...N){if(this.checkLogLevel(u.Error))if(w instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=w.stack,this.log(u.Error,m(O))}else this.log(u.Error,m([w,...N]))}flush(){}}e.AbstractMessageLogger=s;class i extends n{constructor(w=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(w),this.useColors=!v.isWindows}trace(w,...N){this.checkLogLevel(u.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,w,...N):console.log(`[main ${E()}]`,w,...N))}debug(w,...N){this.checkLogLevel(u.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,w,...N):console.log(`[main ${E()}]`,w,...N))}info(w,...N){this.checkLogLevel(u.Info)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,w,...N):console.log(`[main ${E()}]`,w,...N))}warn(w,...N){this.checkLogLevel(u.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,w,...N):console.warn(`[main ${E()}]`,w,...N))}error(w,...N){this.checkLogLevel(u.Error)&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,w,...N):console.error(`[main ${E()}]`,w,...N))}flush(){}}e.ConsoleMainLogger=i;class t extends n{constructor(w=e.DEFAULT_LOG_LEVEL,N=!0){super(),this.useColors=N,this.setLevel(w)}trace(w,...N){this.checkLogLevel(u.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",w,...N):console.log(w,...N))}debug(w,...N){this.checkLogLevel(u.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",w,...N):console.log(w,...N))}info(w,...N){this.checkLogLevel(u.Info)&&(this.useColors?console.log("%c INFO","color: #33f",w,...N):console.log(w,...N))}warn(w,...N){this.checkLogLevel(u.Warning)&&(this.useColors?console.log("%c WARN","color: #993",w,...N):console.log(w,...N))}error(w,...N){this.checkLogLevel(u.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",w,...N):console.error(w,...N))}flush(){}}e.ConsoleLogger=t;class c extends n{constructor(w,N=e.DEFAULT_LOG_LEVEL){super(),this.adapter=w,this.setLevel(N)}trace(w,...N){this.checkLogLevel(u.Trace)&&this.adapter.log(u.Trace,[this.extractMessage(w),...N])}debug(w,...N){this.checkLogLevel(u.Debug)&&this.adapter.log(u.Debug,[this.extractMessage(w),...N])}info(w,...N){this.checkLogLevel(u.Info)&&this.adapter.log(u.Info,[this.extractMessage(w),...N])}warn(w,...N){this.checkLogLevel(u.Warning)&&this.adapter.log(u.Warning,[this.extractMessage(w),...N])}error(w,...N){this.checkLogLevel(u.Error)&&this.adapter.log(u.Error,[this.extractMessage(w),...N])}extractMessage(w){return typeof w=="string"?w:(0,g.toErrorMessage)(w,this.checkLogLevel(u.Trace))}flush(){}}e.AdapterLogger=c;class h extends n{constructor(w){super(),this.loggers=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const N of this.loggers)N.setLevel(w);super.setLevel(w)}trace(w,...N){for(const O of this.loggers)O.trace(w,...N)}debug(w,...N){for(const O of this.loggers)O.debug(w,...N)}info(w,...N){for(const O of this.loggers)O.info(w,...N)}warn(w,...N){for(const O of this.loggers)O.warn(w,...N)}error(w,...N){for(const O of this.loggers)O.error(w,...N)}flush(){for(const w of this.loggers)w.flush()}dispose(){for(const w of this.loggers)w.dispose();super.dispose()}}e.MultiplexLogger=h;class o extends L.Disposable{constructor(w,N,O){if(super(),this.logLevel=w,this.logsHome=N,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new k.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new k.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const U of O)this._loggers.set(U.resource,{logger:void 0,info:U})}getLoggerEntry(w){return(0,P.isString)(w)?[...this._loggers.values()].find(N=>N.info.id===w):this._loggers.get(w)}getLogger(w){return this.getLoggerEntry(w)?.logger}createLogger(w,N){const O=this.toResource(w),U=(0,P.isString)(w)?w:N?.id??(0,A.hash)(O.toString()).toString(16);let x=this._loggers.get(O)?.logger;const B=N?.logLevel==="always"?u.Trace:N?.logLevel;x||(x=this.doCreateLogger(O,B??this.getLogLevel(O)??this.logLevel,{...N,id:U}));const F={logger:x,info:{resource:O,id:U,logLevel:B,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(F.info),this._loggers.set(O,F),x}toResource(w){return(0,P.isString)(w)?(0,l.joinPath)(this.logsHome,`${w}.log`):w}setLogLevel(w,N){if(y.URI.isUri(w)){const O=w,U=N,x=this._loggers.get(O);x&&U!==x.info.logLevel&&(x.info.logLevel=U===this.logLevel?void 0:U,x.logger?.setLevel(U),this._loggers.set(x.info.resource,x),this._onDidChangeLogLevel.fire([O,U]))}else{this.logLevel=w;for(const[O,U]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&U.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(w,N){const O=this.getLoggerEntry(w);O&&N!==!O.info.hidden&&(O.info.hidden=!N,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,N]))}getLogLevel(w){let N;return w&&(N=this._loggers.get(w)?.info.logLevel),N??this.logLevel}registerLogger(w){const N=this._loggers.get(w.resource);N?N.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this._loggers.set(w.resource,{info:w,logger:void 0}),this._onDidChangeLoggers.fire({added:[w],removed:[]}))}deregisterLogger(w){const N=this._loggers.get(w);N&&(N.logger&&N.logger.dispose(),this._loggers.delete(w),this._onDidChangeLoggers.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const w of this._loggers.values())yield w.info}getRegisteredLogger(w){return this._loggers.get(w)?.info}dispose(){this._loggers.forEach(w=>w.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=o;class p{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(w){}getLevel(){return u.Info}trace(w,...N){}debug(w,...N){}info(w,...N){}warn(w,...N){}error(w,...N){}critical(w,...N){}dispose(){}flush(){}}e.NullLogger=p;class _ extends p{}e.NullLogService=_;function D(b){if(b.verbose)return u.Trace;if(typeof b.logLevel=="string"){const w=I(b.logLevel.toLowerCase());if(w!==void 0)return w}return e.DEFAULT_LOG_LEVEL}function C(b){switch(b){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}function S(b){switch(b){case u.Trace:return{original:"Trace",value:r.localize(0,null)};case u.Debug:return{original:"Debug",value:r.localize(1,null)};case u.Info:return{original:"Info",value:r.localize(2,null)};case u.Warning:return{original:"Warning",value:r.localize(3,null)};case u.Error:return{original:"Error",value:r.localize(4,null)};case u.Off:return{original:"Off",value:r.localize(5,null)}}}function I(b){switch(b){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.CONTEXT_LOG_LEVEL=new d.RawContextKey("logLevel",C(u.Info))}),define(we[275],ye([1,0,19,9,14,4,33,3,16,69,12]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends R.Disposable{constructor(T,E){super(),this.logService=T,this.options=E,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new g.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new g.ThrottledDelayer(0))}watch(T,E){return E.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(T,E):this.watchNonRecursive(T,E)}watchUniversal(T,E){const a={path:this.toWatchPath(T),excludes:E.excludes,includes:E.includes,recursive:E.recursive,filter:E.filter,correlationId:E.correlationId},u=(0,r.insert)(this.universalWatchRequests,a);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{u(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(T=>(0,k.onUnexpectedError)(T))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(E=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})));const T=this.options?.watcher?.recursive?.usePolling;if(T===!0)for(const E of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(E)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(T))for(const E of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(E)&&T.includes(E.path)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(T,E){const a={path:this.toWatchPath(T),excludes:E.excludes,includes:E.includes,recursive:!1,filter:E.filter,correlationId:E.correlationId},u=(0,r.insert)(this.nonRecursiveWatchRequests,a);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{u(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(T=>(0,k.onUnexpectedError)(T))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(T=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(T)),T=>this.onWatcherLogMessage(T),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(T){T.type==="error"&&this._onDidWatchError.fire(T.message),this.logWatcherMessage(T)}logWatcherMessage(T){this.logService[T.type](T.message)}toFilePath(T){return(0,v.normalize)(T.fsPath)}toWatchPath(T){const E=this.toFilePath(T);return(0,L.removeTrailingPathSeparator)(E)}}e.AbstractDiskFileSystemProvider=y}),define(we[276],ye([1,0,58,412,9,29,22,4,33,3,16,11,23,103,34,225,28,268,275,51,273,272]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,g.gracefulify)(r)}catch(c){console.error(`Error enabling graceful-fs: ${(0,n.toErrorMessage)(c)}`)}})();class t extends m.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(h,o){super(h,o),this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new A.ResourceMap(p=>d.extUriBiasedIgnorePathCase.getComparisonKey(p)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=u.FileSystemProviderCapabilities.FileReadWrite|u.FileSystemProviderCapabilities.FileOpenReadWriteClose|u.FileSystemProviderCapabilities.FileReadStream|u.FileSystemProviderCapabilities.FileFolderCopy|u.FileSystemProviderCapabilities.FileWriteUnlock|u.FileSystemProviderCapabilities.FileAtomicRead|u.FileSystemProviderCapabilities.FileAtomicWrite|u.FileSystemProviderCapabilities.FileAtomicDelete|u.FileSystemProviderCapabilities.FileClone,y.isLinux&&(this._capabilities|=u.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(h){try{const{stat:o,symbolicLink:p}=await E.SymlinkSupport.stat(this.toFilePath(h));return{type:this.toType(o,p),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size,permissions:o.mode&128?void 0:u.FilePermission.Locked}}catch(o){throw this.toFileSystemProviderError(o)}}async statIgnoreError(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const o=await E.Promises.readdir(this.toFilePath(h),{withFileTypes:!0}),p=[];return await Promise.all(o.map(async _=>{try{let D;_.isSymbolicLink()?D=(await this.stat((0,d.joinPath)(h,_.name))).type:D=this.toType(_),p.push([_.name,D])}catch(D){this.logService.trace(D)}})),p}catch(o){throw this.toFileSystemProviderError(o)}}toType(h,o){let p;return o?.dangling?p=u.FileType.Unknown:h.isFile()?p=u.FileType.File:h.isDirectory()?p=u.FileType.Directory:p=u.FileType.Unknown,o&&(p|=u.FileType.SymbolicLink),p}async createResourceLock(h){const o=this.toFilePath(h);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let p;for(;p=this.resourceLocks.get(h);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await p.wait();const _=new k.Barrier;return this.resourceLocks.set(h,_),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.resourceLocks.get(h)===_&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.resourceLocks.delete(h)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),_.open()})}async readFile(h,o){let p;try{o?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(h)})`),p=await this.createResourceLock(h));const _=this.toFilePath(h);return await E.Promises.readFile(_)}catch(_){throw this.toFileSystemProviderError(_)}finally{p?.dispose()}}traceLock(h){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(h)}readFileStream(h,o,p){const _=(0,T.newWriteableStream)(D=>L.VSBuffer.concat(D.map(C=>L.VSBuffer.wrap(C))).buffer);return(0,f.readFileIntoStream)(this,h,_,D=>D.buffer,{...o,bufferSize:256*1024},p),_}async writeFile(h,o,p){return p?.atomic!==!1&&p?.atomic?.postfix&&await this.canWriteFileAtomic(h)?this.doWriteFileAtomic(h,(0,d.joinPath)((0,d.dirname)(h),`${(0,d.basename)(h)}${p.atomic.postfix}`),o,p):this.doWriteFile(h,o,p)}async canWriteFileAtomic(h){try{const o=this.toFilePath(h),{symbolicLink:p}=await E.SymlinkSupport.stat(o);if(p)return!1}catch{}return!0}async doWriteFileAtomic(h,o,p,_){const D=new l.DisposableStore;try{D.add(await this.createResourceLock(h)),D.add(await this.createResourceLock(o)),await this.doWriteFile(o,p,_,!0);try{await this.rename(o,h,{overwrite:!0})}catch(C){try{await this.delete(o,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{D.dispose()}}async doWriteFile(h,o,p,_){let D;try{const C=this.toFilePath(h);if(!p.create||!p.overwrite){if(await E.Promises.exists(C)){if(!p.overwrite)throw(0,u.createFileSystemProviderError)((0,a.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!p.create)throw(0,u.createFileSystemProviderError)((0,a.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}D=await this.open(h,{create:!0,unlock:p.unlock},_),await this.write(D,0,o,0,o.byteLength)}catch(C){throw await this.toFileSystemProviderWriteError(h,C)}finally{typeof D=="number"&&await this.close(D)}}static{this.canFlush=!0}static configureFlushOnWrite(h){t.canFlush=h}async open(h,o,p){const _=this.toFilePath(h);let D;(0,u.isFileOpenForWriteOptions)(o)&&!p&&(D=await this.createResourceLock(h));let C;try{if((0,u.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:I}=await E.SymlinkSupport.stat(_);I.mode&128||await E.Promises.chmod(_,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.logService.trace(I)}let S;if((0,u.isFileOpenForWriteOptions)(o)){if(y.isWindows)try{await E.Promises.truncate(_,0),S="r+"}catch(I){I.code!=="ENOENT"&&this.logService.trace(I)}S||(S="w")}else S="r";C=await E.Promises.open(_,S)}catch(S){throw D?.dispose(),(0,u.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(h,S):this.toFileSystemProviderError(S)}if(this.mapHandleToPos.set(C,0),(0,u.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(C,h),D){const S=this.mapHandleToLock.get(C);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${_})`),this.mapHandleToLock.set(C,D),S&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${_})`),S.dispose())}return C}async close(h){const o=this.mapHandleToLock.get(h);try{if(this.mapHandleToPos.delete(h),this.writeHandles.delete(h)&&t.canFlush)try{await E.Promises.fdatasync(h)}catch(p){t.configureFlushOnWrite(!1),this.logService.error(p)}return await E.Promises.close(h)}catch(p){throw this.toFileSystemProviderError(p)}finally{o&&(this.mapHandleToLock.get(h)===o&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.mapHandleToLock.delete(h)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),o.dispose())}}async read(h,o,p,_,D){const C=this.normalizePos(h,o);let S=null;try{S=(await E.Promises.read(h,p,_,D,C)).bytesRead}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(h,C,S)}return S}normalizePos(h,o){return o===this.mapHandleToPos.get(h)?null:o}updatePos(h,o,p){const _=this.mapHandleToPos.get(h);typeof _=="number"&&(typeof o=="number"||(typeof p=="number"?this.mapHandleToPos.set(h,_+p):this.mapHandleToPos.delete(h)))}async write(h,o,p,_,D){return(0,k.retry)(()=>this.doWrite(h,o,p,_,D),100,3)}async doWrite(h,o,p,_,D){const C=this.normalizePos(h,o);let S=null;try{S=(await E.Promises.write(h,p,_,D,C)).bytesWritten}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(h),I)}finally{this.updatePos(h,C,S)}return S}async mkdir(h){try{await E.Promises.mkdir(this.toFilePath(h))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(h,o){try{const p=this.toFilePath(h);if(o.recursive){let _;o?.atomic!==!1&&o.atomic.postfix&&(_=(0,P.join)((0,P.dirname)(p),`${(0,P.basename)(p)}${o.atomic.postfix}`)),await E.Promises.rm(p,E.RimRafMode.MOVE,_)}else try{await E.Promises.unlink(p)}catch(_){if(_.code==="EPERM"||_.code==="EISDIR"){let D=!1;try{const{stat:C,symbolicLink:S}=await E.SymlinkSupport.stat(p);D=C.isDirectory()&&!S}catch{}if(D)await E.Promises.rmdir(p);else throw _}else throw _}}catch(p){throw this.toFileSystemProviderError(p)}}async rename(h,o,p){const _=this.toFilePath(h),D=this.toFilePath(o);if(_!==D)try{await this.validateMoveCopy(h,o,"move",p.overwrite),await E.Promises.rename(_,D)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,a.localize)(2,null,(0,P.basename)(_),(0,P.basename)((0,P.dirname)(D)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(h,o,p){const _=this.toFilePath(h),D=this.toFilePath(o);if(_!==D)try{await this.validateMoveCopy(h,o,"copy",p.overwrite),await E.Promises.copy(_,D,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,a.localize)(3,null,(0,P.basename)(_),(0,P.basename)((0,P.dirname)(D)),C.toString()))),this.toFileSystemProviderError(C)}}async validateMoveCopy(h,o,p,_){const D=this.toFilePath(h),C=this.toFilePath(o);let S=!1;if(!!(this.capabilities&u.FileSystemProviderCapabilities.PathCaseSensitive)||(S=(0,v.isEqual)(D,C,!0)),S){if(p==="copy")throw(0,u.createFileSystemProviderError)((0,a.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(p==="move")return}const b=await this.statIgnoreError(h);if(!b)throw(0,u.createFileSystemProviderError)((0,a.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const w=await this.statIgnoreError(o);if(w){if(!_)throw(0,u.createFileSystemProviderError)((0,a.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);b.type&u.FileType.File&&w.type&u.FileType.File||await this.delete(o,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,o){return this.doCloneFile(h,o,!1)}async doCloneFile(h,o,p){const _=this.toFilePath(h),D=this.toFilePath(o),C=!!(this.capabilities&u.FileSystemProviderCapabilities.PathCaseSensitive);if((0,v.isEqual)(_,D,!C))return;const S=new l.DisposableStore;try{S.add(await this.createResourceLock(h)),S.add(await this.createResourceLock(o)),p&&await E.Promises.mkdir((0,P.dirname)(D),{recursive:!0}),await E.Promises.copyFile(_,D)}catch(I){if(I.code==="ENOENT"&&!p)return this.doCloneFile(h,o,!0);throw this.toFileSystemProviderError(I)}finally{S.dispose()}}createUniversalWatcher(h,o,p){return new s.UniversalWatcherClient(_=>h(_),_=>o(_),p)}createNonRecursiveWatcher(h,o,p){return new i.NodeJSWatcherClient(_=>h(_),_=>o(_),p)}toFileSystemProviderError(h){if(h instanceof u.FileSystemProviderError)return h;let o=h,p;switch(h.code){case"ENOENT":p=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":p=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":p=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":p=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":p=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":o=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,p=u.FileSystemProviderErrorCode.Unknown;break;default:p=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(o,p)}async toFileSystemProviderWriteError(h,o){let p=this.toFileSystemProviderError(o);if(h&&p.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:_}=await E.SymlinkSupport.stat(this.toFilePath(h));_.mode&128||(p=(0,u.createFileSystemProviderError)(o,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(_){this.logService.trace(_)}return p}}e.DiskFileSystemProvider=t}),define(we[277],ye([1,0,3,12]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends r.Disposable{constructor(L,R=[]){super(),this.logger=new g.MultiplexLogger([L,...R]),this._register(L.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(L){this.logger.setLevel(L)}getLevel(){return this.logger.getLevel()}trace(L,...R){this.logger.trace(L,...R)}debug(L,...R){this.logger.debug(L,...R)}info(L,...R){this.logger.info(L,...R)}warn(L,...R){this.logger.warn(L,...R)}error(L,...R){this.logger.error(L,...R)}flush(){this.logger.flush()}}e.LogService=k}),define(we[278],ye([1,0,28,12]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(k||(k={}));async function A(l,P,y,d,T){try{const E=await new Promise((u,f)=>{he(["@vscode/spdlog"],u,f)});E.setFlushOn(k.Trace);const a=await E.createAsyncRotatingLogger(l,P,y,d);return T?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(E){console.error(E)}return null}function L(l,P,y){switch(P){case g.LogLevel.Trace:l.trace(y);break;case g.LogLevel.Debug:l.debug(y);break;case g.LogLevel.Info:l.info(y);break;case g.LogLevel.Warning:l.warn(y);break;case g.LogLevel.Error:l.error(y);break;case g.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function R(l,P){switch(P){case g.LogLevel.Trace:l.setLevel(k.Trace);break;case g.LogLevel.Debug:l.setLevel(k.Debug);break;case g.LogLevel.Info:l.setLevel(k.Info);break;case g.LogLevel.Warning:l.setLevel(k.Warning);break;case g.LogLevel.Error:l.setLevel(k.Error);break;case g.LogLevel.Off:l.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class v extends g.AbstractMessageLogger{constructor(P,y,d,T,E){super(),this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(P,y,d,T),this._register(this.onDidChangeLogLevel(a=>{this._logger&&R(this._logger,a)}))}async _createSpdLogLogger(P,y,d,T){const E=d?6:1,a=30/E*r.ByteSize.MB,u=await A(P,y,a,E,T);if(u){this._logger=u,R(this._logger,this.getLevel());for(const{level:f,message:m}of this.buffer)L(this._logger,f,m);this.buffer=[]}}log(P,y){this._logger?L(this._logger,P,y):this.getLevel()<=P&&this.buffer.push({level:P,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=v}),define(we[144],ye([1,0,43,227,5]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var L;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(v){function l(E,a){return a-E}v.compare=l;const P=Object.create(null);P[v.Error]=(0,g.localize)(0,null),P[v.Warning]=(0,g.localize)(1,null),P[v.Info]=(0,g.localize)(2,null);function y(E){return P[E]||""}v.toString=y;function d(E){switch(E){case r.default.Error:return v.Error;case r.default.Warning:return v.Warning;case r.default.Info:return v.Info;case r.default.Ignore:return v.Hint}}v.fromSeverity=d;function T(E){switch(E){case v.Error:return r.default.Error;case v.Warning:return r.default.Warning;case v.Info:return r.default.Info;case v.Hint:return r.default.Ignore}}v.toSeverity=T}(L||(e.MarkerSeverity=L={}));var R;(function(v){const l="";function P(d){return y(d,!0)}v.makeKey=P;function y(d,T){const E=[l];return d.source?E.push(d.source.replace("\xA6","\\\xA6")):E.push(l),d.code?typeof d.code=="string"?E.push(d.code.replace("\xA6","\\\xA6")):E.push(d.code.value.replace("\xA6","\\\xA6")):E.push(l),d.severity!==void 0&&d.severity!==null?E.push(L.toString(d.severity)):E.push(l),d.message&&T?E.push(d.message.replace("\xA6","\\\xA6")):E.push(l),d.startLineNumber!==void 0&&d.startLineNumber!==null?E.push(d.startLineNumber.toString()):E.push(l),d.startColumn!==void 0&&d.startColumn!==null?E.push(d.startColumn.toString()):E.push(l),d.endLineNumber!==void 0&&d.endLineNumber!==null?E.push(d.endLineNumber.toString()):E.push(l),d.endColumn!==void 0&&d.endColumn!==null?E.push(d.endColumn.toString()):E.push(l),E.push(l),E.join("\xA6")}v.makeKeyOptionalMessage=y})(R||(e.IMarkerData=R={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(we[279],ye([1,0,4,43,5]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=R,e.Severity=g.default,e.INotificationService=(0,k.createDecorator)("notificationService");var A;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var L;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function R(y){if(y){const d=y;return typeof d.id=="string"&&typeof d.label=="string"}return!1}var v;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(v||(e.NotificationsFilter=v={}));class l{constructor(){this.progress=new P,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(d){}updateMessage(d){}updateActions(d){}close(){}}e.NoOpNotification=l;class P{infinite(){}done(){}total(d){}worked(d){}}e.NoOpProgress=P}),define(we[280],ye([1,0,56]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let g;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.context<"u"){const A=k.context.configuration();if(A)g=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){g=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:L,itemUrl:R,controlUrl:v}=g.extensionsGallery||{};Object.assign(g,{extensionsGallery:{serviceUrl:r.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:r.env.VSCODE_GALLERY_SEARCH_URL||L,itemUrl:r.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:r.env.VSCODE_GALLERY_CONTROL_URL||v}});try{const l=(...y)=>y.reduce((d,T)=>(Object.keys(T).forEach(E=>{Array.isArray(d[E])&&Array.isArray(T[E])?d[E]=T[E]:typeof d[E]=="object"&&typeof T[E]=="object"?d[E]=l(d[E],T[E]):d[E]=T[E]}),d),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};g=l(g,P)}catch{}if(r.env.VSCODE_DEV&&Object.assign(g,{nameShort:`${g.nameShort} Dev`,nameLong:`${g.nameLong} Dev`,dataFolderName:`${g.dataFolderName}-dev`,serverDataFolderName:g.serverDataFolderName?`${g.serverDataFolderName}-dev`:void 0}),!g.version){const l=globalThis._VSCODE_PACKAGE_JSON;Object.assign(g,{version:l.version,release:l.release})}}else g={},Object.keys(g).length===0&&Object.assign(g,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=g}),define(we[115],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,r.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(he,e){return function(r,g){e(r,g,he)}};define(we[90],ye([1,0,9,21,3,5]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var L;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(d){this.callback=d}report(d){this._value=d,this.callback(this._value)}}e.Progress=R;class v{get value(){return this._value}constructor(d){this.callback=d}report(d){this._asyncQueue?this._asyncQueue.push(d):this._asyncQueue=[d],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const d=this._asyncQueue.shift();this._value=d,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const d=this._drainListener;this._drainListener=void 0,d?.()}}drain(){return this._processingAsyncQueue?new Promise(d=>{const T=this._drainListener;this._drainListener=()=>{T?.(),d()}}):Promise.resolve()}}e.AsyncProgress=v;let l=class extends k.Disposable{constructor(d,T){super(),this.deferred=new r.DeferredPromise,T.withProgress(d,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(d){this.reporter?this.reporter.report(d):this.lastStep=d}};e.UnmanagedProgress=l,e.UnmanagedProgress=l=Ke([Ve(1,e.IProgressService)],l);class P extends k.Disposable{constructor(d){super(),this.progressIndicator=d,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(d){this.stop();const T=++this.currentOperationId,E=new g.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{T===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},d),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:T,token:E.token,stop:()=>this.doStop(T),isCurrent:()=>this.currentOperationId===T}}stop(){this.doStop(this.currentOperationId)}doStop(d){this.currentOperationId===d&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(we[36],ye([1,0,65,18]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(L,R){r.ok(g.isString(L)),r.ok(g.isObject(R)),r.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,R)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new k}),define(we[116],ye([1,0,4,36]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,l){this.schemasById[k(v)]=l,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new A;g.Registry.add(e.Extensions.JSONContribution,L)}),define(we[70],ye([1,0,19,4,18,216,44,116,36]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=a,e.keyFromOverrideIdentifiers=u,e.getDefaultValue=f,e.validateProperty=n,e.getScopes=s;var l;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=v.Registry.as(R.Extensions.JSONContribution);class d{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new g.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new g.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const h=new Set;this.doRegisterConfigurations(t,c,h),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}deregisterConfigurations(t){const c=new Set;this.doDeregisterConfigurations(t,c),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:t,remove:c}){const h=new Set;this.doDeregisterConfigurations(c,h),this.doRegisterConfigurations(t,!1,h),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}registerDefaultConfigurations(t){const c=new Set;this.doRegisterDefaultConfigurations(t,c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,c){const h=[];for(const{overrides:o,source:p}of t)for(const _ in o)if(c.add(_),e.OVERRIDE_PROPERTY_REGEX.test(_)){const D=this.configurationDefaultsOverrides.get(_),C=D?.valuesSources??new Map;if(p)for(const w of Object.keys(o[_]))C.set(w,p);const S={...D?.value||{},...o[_]};this.configurationDefaultsOverrides.set(_,{source:p,value:S,valuesSources:C});const I=(0,L.getLanguageTagSettingPlainKey)(_),b={type:"object",default:S,description:A.localize(1,null,I),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:k.isString(p)?void 0:p,defaultValueSource:p};h.push(...a(_)),this.configurationProperties[_]=b,this.defaultLanguageConfigurationOverridesNode.properties[_]=b}else{this.configurationDefaultsOverrides.set(_,{value:o[_],source:p});const D=this.configurationProperties[_];D&&(this.updatePropertyDefaultValue(_,D),this.updateSchema(_,D))}this.doRegisterOverrideIdentifiers(h)}deregisterDefaultConfigurations(t){const c=new Set;this.doDeregisterDefaultConfigurations(t,c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,c){for(const{overrides:h,source:o}of t)for(const p in h){const _=this.configurationDefaultsOverrides.get(p),D=k.isString(o)?o:o?.id,C=k.isString(_?.source)?_?.source:_?.source?.id;if(D===C)if(c.add(p),this.configurationDefaultsOverrides.delete(p),e.OVERRIDE_PROPERTY_REGEX.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const S=this.configurationProperties[p];S&&(this.updatePropertyDefaultValue(p,S),this.updateSchema(p,S))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let c=!1;const h=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,h),c=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,h),c=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,h),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const c of t)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,c,h){t.forEach(o=>{this.validateAndRegisterProperties(o,c,o.extensionInfo,o.restrictedProperties,void 0,h),this.configurationContributors.push(o),this.registerJSONConfiguration(o)})}doDeregisterConfigurations(t,c){const h=o=>{if(o.properties)for(const p in o.properties){c.add(p);const _=this.configurationProperties[p];_?.policy?.name&&this.policyConfigurations.delete(_.policy.name),delete this.configurationProperties[p],this.removeFromSchema(p,o.properties[p])}o.allOf?.forEach(p=>h(p))};for(const o of t){h(o);const p=this.configurationContributors.indexOf(o);p!==-1&&this.configurationContributors.splice(p,1)}}validateAndRegisterProperties(t,c=!0,h,o,p=P.WINDOW,_){p=k.isUndefinedOrNull(t.scope)?p:t.scope;const D=t.properties;if(D)for(const S in D){const I=D[S];if(c&&n(S,I)){delete D[S];continue}if(I.source=h,I.defaultDefaultValue=D[S].default,this.updatePropertyDefaultValue(S,I),e.OVERRIDE_PROPERTY_REGEX.test(S)?I.scope=void 0:(I.scope=k.isUndefinedOrNull(I.scope)?p:I.scope,I.restricted=k.isUndefinedOrNull(I.restricted)?!!o?.includes(S):I.restricted),D[S].hasOwnProperty("included")&&!D[S].included){this.excludedConfigurationProperties[S]=D[S],delete D[S];continue}else this.configurationProperties[S]=D[S],D[S].policy?.name&&this.policyConfigurations.set(D[S].policy.name,S);!D[S].deprecationMessage&&D[S].markdownDeprecationMessage&&(D[S].deprecationMessage=D[S].markdownDeprecationMessage),_.add(S)}const C=t.allOf;if(C)for(const S of C)this.validateAndRegisterProperties(S,c,h,o,p,_)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const c=h=>{const o=h.properties;if(o)for(const _ in o)this.updateSchema(_,o[_]);h.allOf?.forEach(c)};c(t)}updateSchema(t,c){switch(e.allSettings.properties[t]=c,c.scope){case P.APPLICATION:e.applicationSettings.properties[t]=c;break;case P.MACHINE:e.machineSettings.properties[t]=c;break;case P.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[t]=c;break;case P.WINDOW:e.windowSettings.properties[t]=c;break;case P.RESOURCE:e.resourceSettings.properties[t]=c;break;case P.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[t]=c,this.resourceLanguageSettingsSchema.properties[t]=c;break}}removeFromSchema(t,c){switch(delete e.allSettings.properties[t],c.scope){case P.APPLICATION:delete e.applicationSettings.properties[t];break;case P.MACHINE:delete e.machineSettings.properties[t];break;case P.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[t];break;case P.WINDOW:delete e.windowSettings.properties[t];break;case P.RESOURCE:case P.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const c=`[${t}]`,h={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,h),e.allSettings.properties[c]=h,e.applicationSettings.properties[c]=h,e.machineSettings.properties[c]=h,e.machineOverridableSettings.properties[c]=h,e.windowSettings.properties[c]=h,e.resourceSettings.properties[c]=h}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,c){const h=this.configurationDefaultsOverrides.get(t);let o=h?.value,p=h?.source;k.isUndefined(o)&&(o=c.defaultDefaultValue,p=void 0),k.isUndefined(o)&&(o=f(c.type)),c.default=o,c.defaultValueSource=p}}const T="\\[([^\\]]+)\\]",E=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(i){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(i)){let c=E.exec(i);for(;c?.length;){const h=c[1].trim();h&&t.push(h),c=E.exec(i)}}return(0,r.distinct)(t)}function u(i){return i.reduce((t,c)=>`${t}[${c}]`,"")}function f(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new d;v.Registry.add(e.Extensions.Configuration,m);function n(i,t){return i.trim()?e.OVERRIDE_PROPERTY_REGEX.test(i)?A.localize(7,null,i):m.getConfigurationProperties()[i]!==void 0?A.localize(8,null,i):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,i,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function s(){const i=[],t=m.getConfigurationProperties();for(const c of Object.keys(t))i.push([c,t[c].scope]);return i.push(["launch",P.RESOURCE]),i.push(["task",P.RESOURCE]),i}}),define(we[281],ye([1,0,19,4,174,3,29,25,18,2,44,70,28,36]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=s;function E(h){return Object.isFrozen(h)?h:R.deepFreeze(h)}class a{static createEmptyModel(o){return new a({},[],[],void 0,o)}constructor(o,p,_,D,C){this._contents=o,this._keys=p,this._overrides=_,this.raw=D,this.logService=C,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const o=this.raw.map(p=>{if(p instanceof a)return p;const _=new u("",this.logService);return _.parseRaw(p),_.configurationModel});this._rawConfiguration=o.reduce((p,_)=>_===p?_:p.merge(_),o[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(o){return o?(0,P.getConfigurationValue)(this.contents,o):this.contents}inspect(o,p){const _=this;return{get value(){return E(_.rawConfiguration.getValue(o))},get override(){return p?E(_.rawConfiguration.getOverrideValue(o,p)):void 0},get merged(){return E(p?_.rawConfiguration.override(p).getValue(o):_.rawConfiguration.getValue(o))},get overrides(){const D=[];for(const{contents:C,identifiers:S,keys:I}of _.rawConfiguration.overrides){const b=new a(C,I,[],void 0,_.logService).getValue(o);b!==void 0&&D.push({identifiers:S,value:b})}return D.length?E(D):void 0}}}getOverrideValue(o,p){const _=this.getContentsForOverrideIdentifer(p);return _?o?(0,P.getConfigurationValue)(_,o):_:void 0}getKeysForOverrideIdentifier(o){const p=[];for(const _ of this.overrides)_.identifiers.includes(o)&&p.push(..._.keys);return r.distinct(p)}getAllOverrideIdentifiers(){const o=[];for(const p of this.overrides)o.push(...p.identifiers);return r.distinct(o)}override(o){let p=this.overrideConfigurations.get(o);return p||(p=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,p)),p}merge(...o){const p=R.deepClone(this.contents),_=R.deepClone(this.overrides),D=[...this.keys],C=this.raw?.length?[...this.raw]:[this];for(const S of o)if(C.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.mergeContents(p,S.contents);for(const I of S.overrides){const[b]=_.filter(w=>r.equals(w.identifiers,I.identifiers));b?(this.mergeContents(b.contents,I.contents),b.keys.push(...I.keys),b.keys=r.distinct(b.keys)):_.push(R.deepClone(I))}for(const I of S.keys)D.indexOf(I)===-1&&D.push(I)}return new a(p,D,_,C.every(S=>S instanceof a)?void 0:C,this.logService)}createOverrideConfigurationModel(o){const p=this.getContentsForOverrideIdentifer(o);if(!p||typeof p!="object"||!Object.keys(p).length)return this;const _={};for(const D of r.distinct([...Object.keys(this.contents),...Object.keys(p)])){let C=this.contents[D];const S=p[D];S&&(typeof C=="object"&&typeof S=="object"?(C=R.deepClone(C),this.mergeContents(C,S)):C=S),_[D]=C}return new a(_,this.keys,this.overrides,void 0,this.logService)}mergeContents(o,p){for(const _ of Object.keys(p)){if(_ in o&&v.isObject(o[_])&&v.isObject(p[_])){this.mergeContents(o[_],p[_]);continue}o[_]=R.deepClone(p[_])}}getContentsForOverrideIdentifer(o){let p=null,_=null;const D=C=>{C&&(_?this.mergeContents(_,C):_=R.deepClone(C))};for(const C of this.overrides)C.identifiers.length===1&&C.identifiers[0]===o?p=C.contents:C.identifiers.includes(o)&&D(C.contents);return D(p),_}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,p){this.updateValue(o,p,!0)}setValue(o,p){this.updateValue(o,p,!1)}removeValue(o){const p=this.keys.indexOf(o);p!==-1&&(this.keys.splice(p,1),(0,P.removeFromValueTree)(this.contents,o),y.OVERRIDE_PROPERTY_REGEX.test(o)&&this.overrides.splice(this.overrides.findIndex(_=>r.equals(_.identifiers,(0,y.overrideIdentifiersFromKey)(o))),1))}updateValue(o,p,_){(0,P.addToValueTree)(this.contents,o,p,D=>this.logService.error(D)),_=_||this.keys.indexOf(o)===-1,_&&this.keys.push(o),y.OVERRIDE_PROPERTY_REGEX.test(o)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(o),keys:Object.keys(this.contents[o]),contents:(0,P.toValuesTree)(this.contents[o],D=>this.logService.error(D))})}}e.ConfigurationModel=a;class u{constructor(o,p){this._name=o,this.logService=p,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||a.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,p){if(!v.isUndefinedOrNull(o)){const _=this.doParseContent(o);this.parseRaw(_,p)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,p){this._raw=o;const{contents:_,keys:D,overrides:C,restricted:S,hasExcludedProperties:I}=this.doParseRaw(o,p);this._configurationModel=new a(_,D,C,I?[o]:void 0,this.logService),this._restrictedConfigurations=S||[]}doParseContent(o){let p={},_=null,D=[];const C=[],S=[];function I(w){Array.isArray(D)?D.push(w):_!==null&&(D[_]=w)}const b={onObjectBegin:()=>{const w={};I(w),C.push(D),D=w,_=null},onObjectProperty:w=>{_=w},onObjectEnd:()=>{D=C.pop()},onArrayBegin:()=>{const w=[];I(w),C.push(D),D=w,_=null},onArrayEnd:()=>{D=C.pop()},onLiteralValue:I,onError:(w,N,O)=>{S.push({error:w,offset:N,length:O})}};if(o)try{k.visit(o,b),p=D[0]||{}}catch(w){this.logService.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return p}doParseRaw(o,p){const _=T.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),D=this.filter(o,_,!0,p);o=D.raw;const C=(0,P.toValuesTree)(o,b=>this.logService.error(`Conflict in settings file ${this._name}: ${b}`)),S=Object.keys(o),I=this.toOverrides(o,b=>this.logService.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:C,keys:S,overrides:I,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}filter(o,p,_,D){let C=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:C};const S={},I=[];for(const b in o)if(y.OVERRIDE_PROPERTY_REGEX.test(b)&&_){const w=this.filter(o[b],p,!1,D);S[b]=w.raw,C=C||w.hasExcludedProperties,I.push(...w.restricted)}else{const w=p[b],N=w?typeof w.scope<"u"?w.scope:y.ConfigurationScope.WINDOW:void 0;w?.restricted&&I.push(b),!D.exclude?.includes(b)&&(D.include?.includes(b)||(N===void 0||D.scopes===void 0||D.scopes.includes(N))&&!(D.skipRestricted&&w?.restricted))?S[b]=o[b]:C=!0}return{raw:S,restricted:I,hasExcludedProperties:C}}toOverrides(o,p){const _=[];for(const D of Object.keys(o))if(y.OVERRIDE_PROPERTY_REGEX.test(D)){const C={};for(const S in o[D])C[S]=o[D][S];_.push({identifiers:(0,y.overrideIdentifiersFromKey)(D),keys:Object.keys(C),contents:(0,P.toValuesTree)(C,p)})}return _}}e.ConfigurationModelParser=u;class f extends A.Disposable{constructor(o,p,_,D,C){super(),this.userSettingsResource=o,this.parseOptions=p,this.fileService=D,this.logService=C,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString(),C),this._register(this.fileService.watch(_.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(g.Event.any(g.Event.filter(this.fileService.onDidFilesChange,S=>S.contains(this.userSettingsResource)),g.Event.filter(this.fileService.onDidRunOperation,S=>(S.isOperation(d.FileOperation.CREATE)||S.isOperation(d.FileOperation.COPY)||S.isOperation(d.FileOperation.DELETE)||S.isOperation(d.FileOperation.WRITE))&&_.isEqual(S.resource,o)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return a.createEmptyModel(this.logService)}}reparse(o){return o&&(this.parseOptions=o),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class m{constructor(o,p,_,D,C,S,I,b,w,N,O,U,x){this.key=o,this.overrides=p,this._value=_,this.overrideIdentifiers=D,this.defaultConfiguration=C,this.policyConfiguration=S,this.applicationConfiguration=I,this.userConfiguration=b,this.localUserConfiguration=w,this.remoteUserConfiguration=N,this.workspaceConfiguration=O,this.folderConfigurationModel=U,this.memoryConfigurationModel=x}get value(){return E(this._value)}toInspectValue(o){return o?.value!==void 0||o?.override!==void 0||o?.overrides!==void 0?o:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class n{constructor(o,p,_,D,C,S,I,b,w,N){this._defaultConfiguration=o,this._policyConfiguration=p,this._applicationConfiguration=_,this._localUserConfiguration=D,this._remoteUserConfiguration=C,this._workspaceConfiguration=S,this._folderConfigurations=I,this._memoryConfiguration=b,this._memoryConfigurationByResource=w,this.logService=N,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(o,p,_){return this.getConsolidatedConfigurationModel(o,p,_).getValue(o)}updateValue(o,p,_={}){let D;_.resource?(D=this._memoryConfigurationByResource.get(_.resource),D||(D=a.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(_.resource,D))):D=this._memoryConfiguration,p===void 0?D.removeValue(o):D.setValue(o,p),_.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,p,_){const D=this.getConsolidatedConfigurationModel(o,p,_),C=this.getFolderConfigurationModelForResource(p.resource,_),S=p.resource?this._memoryConfigurationByResource.get(p.resource)||this._memoryConfiguration:this._memoryConfiguration,I=new Set;for(const b of D.overrides)for(const w of b.identifiers)D.getOverrideValue(o,w)!==void 0&&I.add(w);return new m(o,p,D.getValue(o),I.size?[...I]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,_?this._workspaceConfiguration:void 0,C||void 0,S)}keys(o){const p=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:p?p.keys.slice(0):[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(o){this._policyConfiguration=o}updateApplicationConfiguration(o){this._applicationConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,p){this._folderConfigurations.set(o,p),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,p){const _=[];if(!p){const{added:D,updated:C,removed:S}=t(this._defaultConfiguration,o);p=[...D,...C,...S]}for(const D of p)for(const C of(0,y.overrideIdentifiersFromKey)(D)){const S=this._defaultConfiguration.getKeysForOverrideIdentifier(C),I=o.getKeysForOverrideIdentifier(C),b=[...I.filter(w=>S.indexOf(w)===-1),...S.filter(w=>I.indexOf(w)===-1),...S.filter(w=>!R.equals(this._defaultConfiguration.override(C).getValue(w),o.override(C).getValue(w)))];_.push([C,b])}return this.updateDefaultConfiguration(o),{keys:p,overrides:_}}compareAndUpdatePolicyConfiguration(o){const{added:p,updated:_,removed:D}=t(this._policyConfiguration,o),C=[...p,..._,...D];return C.length&&this.updatePolicyConfiguration(o),{keys:C,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:p,updated:_,removed:D,overrides:C}=t(this.applicationConfiguration,o),S=[...p,..._,...D];return S.length&&this.updateApplicationConfiguration(o),{keys:S,overrides:C}}compareAndUpdateLocalUserConfiguration(o){const{added:p,updated:_,removed:D,overrides:C}=t(this.localUserConfiguration,o),S=[...p,..._,...D];return S.length&&this.updateLocalUserConfiguration(o),{keys:S,overrides:C}}compareAndUpdateRemoteUserConfiguration(o){const{added:p,updated:_,removed:D,overrides:C}=t(this.remoteUserConfiguration,o),S=[...p,..._,...D];return S.length&&this.updateRemoteUserConfiguration(o),{keys:S,overrides:C}}compareAndUpdateWorkspaceConfiguration(o){const{added:p,updated:_,removed:D,overrides:C}=t(this.workspaceConfiguration,o),S=[...p,..._,...D];return S.length&&this.updateWorkspaceConfiguration(o),{keys:S,overrides:C}}compareAndUpdateFolderConfiguration(o,p){const _=this.folderConfigurations.get(o),{added:D,updated:C,removed:S,overrides:I}=t(_,p),b=[...D,...C,...S];return(b.length||!_)&&this.updateFolderConfiguration(o,p),{keys:b,overrides:I}}compareAndDeleteFolderConfiguration(o){const p=this.folderConfigurations.get(o);if(!p)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:_,updated:D,removed:C,overrides:S}=t(p,void 0);return{keys:[..._,...D,...C],overrides:S}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(o,p,_){let D=this.getConsolidatedConfigurationModelForResource(p,_);return p.overrideIdentifier&&(D=D.override(p.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(o)!==void 0&&(D=D.merge(this._policyConfiguration)),D}getConsolidatedConfigurationModelForResource({resource:o},p){let _=this.getWorkspaceConsolidatedConfiguration();if(p&&o){const D=p.getFolder(o);D&&(_=this.getFolderConsolidatedConfiguration(D.uri)||_);const C=this._memoryConfigurationByResource.get(o);C&&(_=_.merge(C))}return _}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let p=this._foldersConsolidatedConfigurations.get(o);if(!p){const _=this.getWorkspaceConsolidatedConfiguration(),D=this._folderConfigurations.get(o);D?(p=_.merge(D),this._foldersConsolidatedConfigurations.set(o,p)):p=_}return p}getFolderConfigurationModelForResource(o,p){if(p&&o){const _=p.getFolder(o);if(_)return this._folderConfigurations.get(_.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,p)=>{const{contents:_,overrides:D,keys:C}=this._folderConfigurations.get(p);return o.push([p,{contents:_,overrides:D,keys:C}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.keys.forEach(p=>o.add(p)),this.userConfiguration.keys.forEach(p=>o.add(p)),this._workspaceConfiguration.keys.forEach(p=>o.add(p)),this._folderConfigurations.forEach(p=>p.keys.forEach(_=>o.add(_))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(p=>o.add(p)),this.userConfiguration.getAllOverrideIdentifiers().forEach(p=>o.add(p)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(p=>o.add(p)),this._folderConfigurations.forEach(p=>p.getAllOverrideIdentifiers().forEach(_=>o.add(_))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const p=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(_=>p.add(_)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(_=>p.add(_)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(_=>p.add(_)),this._folderConfigurations.forEach(_=>_.getKeysForOverrideIdentifier(o).forEach(D=>p.add(D))),[...p.values()]}static parse(o,p){const _=this.parseConfigurationModel(o.defaults,p),D=this.parseConfigurationModel(o.policy,p),C=this.parseConfigurationModel(o.application,p),S=this.parseConfigurationModel(o.user,p),I=this.parseConfigurationModel(o.workspace,p),b=o.folders.reduce((w,N)=>(w.set(l.URI.revive(N[0]),this.parseConfigurationModel(N[1],p)),w),new L.ResourceMap);return new n(_,D,C,S,a.createEmptyModel(p),I,b,a.createEmptyModel(p),new L.ResourceMap,p)}static parseConfigurationModel(o,p){return new a(o.contents,o.keys,o.overrides,void 0,p)}}e.Configuration=n;function s(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const o=new Set,p=new Map;for(const D of h)D.keys.forEach(C=>o.add(C)),D.overrides.forEach(([C,S])=>{const I=(0,L.getOrSet)(p,C,new Set);S.forEach(b=>I.add(b))});const _=[];return p.forEach((D,C)=>_.push([C,[...D.values()]])),{keys:[...o.values()],overrides:_}}class i{constructor(o,p,_,D,C){this.change=o,this.previous=p,this.currentConfiguraiton=_,this.currentWorkspace=D,this.logService=C,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const S of o.keys)this.affectedKeys.add(S);for(const[,S]of o.overrides)for(const I of S)this.affectedKeys.add(I);this._affectsConfigStr=this._marker;for(const S of this.affectedKeys)this._affectsConfigStr+=S+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=n.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(o,p){const _=this._marker+o,D=this._affectsConfigStr.indexOf(_);if(D<0)return!1;const C=D+_.length;if(C>=this._affectsConfigStr.length)return!1;const S=this._affectsConfigStr.charCodeAt(C);if(S!==this._markerCode1&&S!==this._markerCode2)return!1;if(p){const I=this.previousConfiguration?this.previousConfiguration.getValue(o,p,this.previous?.workspace):void 0,b=this.currentConfiguraiton.getValue(o,p,this.currentWorkspace);return!R.equals(I,b)}return!0}}e.ConfigurationChangeEvent=i;function t(h,o){const{added:p,removed:_,updated:D}=c(o?.rawConfiguration,h?.rawConfiguration),C=[],S=h?.getAllOverrideIdentifiers()||[],I=o?.getAllOverrideIdentifiers()||[];if(o){const b=I.filter(w=>!S.includes(w));for(const w of b)C.push([w,o.getKeysForOverrideIdentifier(w)])}if(h){const b=S.filter(w=>!I.includes(w));for(const w of b)C.push([w,h.getKeysForOverrideIdentifier(w)])}if(o&&h){for(const b of S)if(I.includes(b)){const w=c({contents:h.getOverrideValue(void 0,b)||{},keys:h.getKeysForOverrideIdentifier(b)},{contents:o.getOverrideValue(void 0,b)||{},keys:o.getKeysForOverrideIdentifier(b)});C.push([b,[...w.added,...w.removed,...w.updated]])}}return{added:p,removed:_,updated:D,overrides:C}}function c(h,o){const p=h?o?h.keys.filter(C=>o.keys.indexOf(C)===-1):[...h.keys]:[],_=o?h?o.keys.filter(C=>h.keys.indexOf(C)===-1):[...o.keys]:[],D=[];if(h&&o){for(const C of o.keys)if(h.keys.indexOf(C)!==-1){const S=(0,P.getConfigurationValue)(o.contents,C),I=(0,P.getConfigurationValue)(h.contents,C);R.equals(S,I)||D.push(C)}}return{added:p,removed:_,updated:D}}}),define(we[282],ye([1,0,22,4,3,68]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=R;const L=(l,P,y)=>{const d=new Uint8Array(16);for(let a=0;a<16;a++)d[a]=Math.round(Math.random()*256);const T=(0,r.encodeBase64)(r.VSBuffer.wrap(d));return[`GET ws://localhost${l}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${T}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=L,e.socketRawEndHeaderSequence=r.VSBuffer.fromString(`\r
\r
`);async function R(l,P,y,d,T){l.write(r.VSBuffer.fromString((0,e.makeRawSocketHeaders)(P,y,d)));const E=new k.DisposableStore;try{return await new Promise((a,u)=>{let f;E.add(l.onData(m=>{f?f=r.VSBuffer.concat([f,m],f.byteLength+m.byteLength):f=m;const n=f.indexOf(e.socketRawEndHeaderSequence);if(n===-1)return;a(l),l.pauseData();const s=f.slice(n+e.socketRawEndHeaderSequence.byteLength);s.byteLength&&T.onData.fire(s)})),E.add(l.onClose(m=>u(m??new Error("socket closed")))),E.add(l.onEnd(()=>u(new Error("socket ended"))))})}catch(a){throw l.dispose(),a}finally{E.dispose()}}class v extends k.Disposable{constructor(P,y){super(),this.debugLabel=P,this.pausableDataEmitter=this._register(new g.PauseableEmitter),this.onData=(...d)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...d)),this.didDisposeEmitter=this._register(new g.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(y.onData),this._register(y.onData.event(d=>this.pausableDataEmitter.fire(d))),this.onClose=this._register(y.onClose).event,this.onEnd=this._register(y.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(P,y){A.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,P,y)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=v}),define(we[71],ye([1,0,14,5]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=l,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var k;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class A{constructor(y){this.id=y,this.type=k.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class L{constructor(y,d){this.host=y,this.port=d,this.type=k.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=L;var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class v extends r.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof v&&y._code===R.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof v&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof v&&y._code===R.NoResolverFound}static isInvalidAuthority(y){return y instanceof v&&y._code===R.InvalidAuthority}static isHandled(y){return y instanceof v&&y.isHandled}constructor(y,d=R.Unknown,T){super(y),this._message=y,this._code=d,this._detail=T,this.isHandled=d===R.NotAvailable&&T===!0,Object.setPrototypeOf(this,v.prototype)}}e.RemoteAuthorityResolverError=v;function l(P){const y=P.indexOf("+");return y===-1?P:P.substring(0,y)}}),define(we[283],ye([1,0,9,22,21,14,4,3,15,62,42,32,68,71]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=C,e.connectRemoteAgentExtensionHost=S,e.connectRemoteAgentTunnel=b;const E=30*1e3;var a;(function(ve){ve[ve.Management=1]="Management",ve[ve.ExtensionHost=2]="ExtensionHost",ve[ve.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function u(ve){switch(ve){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function f(ve){const G=new k.CancellationTokenSource;return setTimeout(()=>G.cancel(),ve),G.token}function m(ve,G){if(ve.isCancellationRequested||G.isCancellationRequested)return k.CancellationToken.Cancelled;const W=new k.CancellationTokenSource;return ve.onCancellationRequested(()=>W.cancel()),G.onCancellationRequested(()=>W.cancel()),W.token}class n{get didTimeout(){return this._state==="timedout"}constructor(G){this._state="pending",this._disposables=new R.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,r.promiseWithResolvers)(),G.isCancellationRequested?this._timeout():this._disposables.add(G.onCancellationRequested(()=>this._timeout()))}registerDisposable(G){this._state==="pending"?this._disposables.add(G):G.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const G=new Error("Time limit reached");return G.code="ETIMEDOUT",G.syscall="connect",G}resolve(G){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(G))}reject(G){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(G))}}function s(ve,G){const W=new n(G);return W.registerDisposable(ve.onControlMessage(se=>{const ae=JSON.parse(se.toString()),ie=q(ae);ie?W.reject(ie):W.resolve(ae)})),W.promise}function i(ve,G,W,se,ae,ie,le,ue){const Y=new n(ue),oe=P.StopWatch.create(!1);return ve.info(`Creating a socket (${le})...`),l.mark(`code/willCreateSocket/${ie}`),G.connect(W,se,ae,le).then(pe=>{Y.didTimeout?(l.mark(`code/didCreateSocketError/${ie}`),ve.info(`Creating a socket (${le}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(l.mark(`code/didCreateSocketOK/${ie}`),ve.info(`Creating a socket (${le}) was successful after ${oe.elapsed()} ms.`),Y.resolve(pe))},pe=>{l.mark(`code/didCreateSocketError/${ie}`),ve.info(`Creating a socket (${le}) returned an error after ${oe.elapsed()} ms.`),ve.error(pe),Y.reject(pe)}),Y.promise}function t(ve,G){const W=new n(G);return ve.then(se=>{W.didTimeout||W.resolve(se)},se=>{W.didTimeout||W.reject(se)}),W.promise}async function c(ve,G,W,se){const ae=re(ve,G);ve.logService.trace(`${ae} 1/6. invoking socketFactory.connect().`);let ie;try{ie=await i(ve.logService,ve.remoteSocketFactoryService,ve.connectTo,v.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${ve.reconnectionToken}&reconnection=${ve.reconnectionProtocol?"true":"false"}`,u(G),`renderer-${u(G)}-${ve.reconnectionToken}`,se)}catch(pe){throw ve.logService.error(`${ae} socketFactory.connect() failed or timed out. Error:`),ve.logService.error(pe),pe}ve.logService.trace(`${ae} 2/6. socketFactory.connect() was successful.`);let le,ue;ve.reconnectionProtocol?(ve.reconnectionProtocol.beginAcceptReconnection(ie,null),le=ve.reconnectionProtocol,ue=!1):(le=new d.PersistentProtocol({socket:ie}),ue=!0),ve.logService.trace(`${ae} 3/6. sending AuthRequest control message.`);const Y=await t(ve.signService.createNewMessage((0,y.generateUuid)()),se),oe={type:"auth",auth:ve.connectionToken||"00000000000000000000",data:Y.data};le.sendControl(g.VSBuffer.fromString(JSON.stringify(oe)));try{const pe=await s(le,m(se,f(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(ve.logService.trace(`${ae} 4/6. received SignRequest control message.`),!await t(ve.signService.validate(Y,pe.signedData),se)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const Ne=await t(ve.signService.sign(pe.data),se),We={type:"connectionType",commit:ve.commit,signedData:Ne,desiredConnectionType:G};return W&&(We.args=W),ve.logService.trace(`${ae} 5/6. sending ConnectionTypeRequest control message.`),le.sendControl(g.VSBuffer.fromString(JSON.stringify(We))),{protocol:le,ownsProtocol:ue}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(ve.logService.error(`${ae} the handshake timed out. Error:`),ve.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(ve.logService.error(`${ae} received error control message when negotiating connection. Error:`),ve.logService.error(pe)),ue&&$(le),pe}}async function h(ve,G,W,se){const ae=Date.now(),ie=re(ve,G),{protocol:le,ownsProtocol:ue}=await c(ve,G,W,se),Y=new n(se);return Y.registerDisposable(le.onControlMessage(oe=>{const pe=JSON.parse(oe.toString()),Ee=q(pe);Ee?(ve.logService.error(`${ie} received error control message when negotiating connection. Error:`),ve.logService.error(Ee),ue&&$(le),Y.reject(Ee)):(ve.reconnectionProtocol?.endAcceptReconnection(),ve.logService.trace(`${ie} 6/6. handshake finished, connection is up and running after ${Se(ae)}!`),Y.resolve({protocol:le,firstMessage:pe}))})),Y.promise}async function o(ve,G){const{protocol:W}=await h(ve,a.Management,void 0,G);return{protocol:W}}async function p(ve,G,W){const{protocol:se,firstMessage:ae}=await h(ve,a.ExtensionHost,G,W),ie=ae&&ae.debugPort;return{protocol:se,debugPort:ie}}async function _(ve,G,W){const se=Date.now(),ae=re(ve,a.Tunnel),{protocol:ie}=await c(ve,a.Tunnel,G,W);return ve.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${Se(se)}!`),ie}async function D(ve,G,W){const{connectTo:se,connectionToken:ae}=await ve.addressProvider.getAddress();return{commit:ve.commit,quality:ve.quality,connectTo:se,connectionToken:ae,reconnectionToken:G,reconnectionProtocol:W,remoteSocketFactoryService:ve.remoteSocketFactoryService,signService:ve.signService,logService:ve.logService}}async function C(ve,G,W){return I(ve,async se=>{const{protocol:ae}=await o(se,k.CancellationToken.None);return new K(ve,G,W,se.reconnectionToken,ae)})}async function S(ve,G){return I(ve,async W=>{const{protocol:se,debugPort:ae}=await p(W,G,k.CancellationToken.None);return new ee(ve,G,W.reconnectionToken,se,ae)})}async function I(ve,G){for(let se=1;;se++)try{const ae=(0,y.generateUuid)(),ie=await D(ve,ae,null);return await G(ie)}catch(ae){if(se<5)ve.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),ve.logService.error(ae);else throw ve.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ve.logService.error(ae),M.triggerPermanentFailure(0,0,T.RemoteAuthorityResolverError.isHandled(ae)),ae}}async function b(ve,G,W){const se=await D(ve,(0,y.generateUuid)(),null);return await _(se,{host:G,port:W},k.CancellationToken.None)}function w(ve){return(0,r.createCancelablePromise)(G=>new Promise((W,se)=>{const ae=setTimeout(W,ve*1e3);G.onCancellationRequested(()=>{clearTimeout(ae),W()})}))}var N;(function(ve){ve[ve.ConnectionLost=0]="ConnectionLost",ve[ve.ReconnectionWait=1]="ReconnectionWait",ve[ve.ReconnectionRunning=2]="ReconnectionRunning",ve[ve.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ve[ve.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class O{constructor(G,W){this.reconnectionToken=G,this.millisSinceLastIncomingData=W,this.type=N.ConnectionLost}}e.ConnectionLostEvent=O;class U{constructor(G,W,se,ae){this.reconnectionToken=G,this.millisSinceLastIncomingData=W,this.durationSeconds=se,this.cancellableTimer=ae,this.type=N.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=U;class x{constructor(G,W,se){this.reconnectionToken=G,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=N.ReconnectionRunning}}e.ReconnectionRunningEvent=x;class B{constructor(G,W,se){this.reconnectionToken=G,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=N.ConnectionGain}}e.ConnectionGainEvent=B;class F{constructor(G,W,se,ae){this.reconnectionToken=G,this.millisSinceLastIncomingData=W,this.attempt=se,this.handled=ae,this.type=N.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=F;class M extends R.Disposable{static triggerPermanentFailure(G,W,se){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=G,this._permanentFailureAttempt=W,this._permanentFailureHandled=se,this._instances.forEach(ae=>ae._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(G=>G._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(G=>G._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||M._permanentFailure}constructor(G,W,se,ae,ie){super(),this._connectionType=G,this._options=W,this.reconnectionToken=se,this.protocol=ae,this._reconnectionFailureIsFatal=ie,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new B(this.reconnectionToken,0,0)),this._register(ae.onSocketClose(le=>{const ue=de(this._connectionType,this.reconnectionToken,!0);le?le.type===d.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${ue} received socket close event (hadError: ${le.hadError}).`),le.error&&this._options.logService.error(le.error)):(this._options.logService.info(`${ue} received socket close event (wasClean: ${le.wasClean}, code: ${le.code}, reason: ${le.reason}).`),le.event&&this._options.logService.error(le.event)):this._options.logService.info(`${ue} received socket close event.`),this._beginReconnecting()})),this._register(ae.onSocketTimeout(le=>{const ue=de(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ue} received socket timeout event (unacknowledgedMsgCount: ${le.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${le.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${le.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),M._instances.push(this),this._register((0,R.toDisposable)(()=>{const le=M._instances.indexOf(this);le>=0&&M._instances.splice(le,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(M._permanentFailureMillisSinceLastIncomingData,M._permanentFailureAttempt,M._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const G=de(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${G} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const ae=se<W.length?W[se]:W[W.length-1];try{if(ae>0){const le=w(ae);this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ae,le)),this._options.logService.info(`${G} waiting for ${ae} seconds before reconnecting...`);try{await le}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${G} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this._options.logService.info(`${G} resolving connection...`);const ie=await D(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${G} connecting to ${ie.connectTo}...`),await this._reconnect(ie,f(E)),this._options.logService.info(`${G} reconnected!`),this._onDidStateChange.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(ie){if(ie.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${G} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ie),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this._options.logService.error(`${G} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ie),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(T.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ie)){this._options.logService.info(`${G} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ie);continue}if((ie.code==="ETIMEDOUT"||ie.code==="ENETUNREACH"||ie.code==="ECONNREFUSED"||ie.code==="ECONNRESET")&&ie.syscall==="connect"){this._options.logService.info(`${G} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ie);continue}if((0,A.isCancellationError)(ie)){this._options.logService.info(`${G} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ie);continue}if(ie instanceof T.RemoteAuthorityResolverError){this._options.logService.error(`${G} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ie),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,T.RemoteAuthorityResolverError.isHandled(ie));break}this._options.logService.error(`${G} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ie),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(G,W,se){this._reconnectionFailureIsFatal?M.triggerPermanentFailure(G,W,se):this._gotoPermanentFailure(G,W,se)}_gotoPermanentFailure(G,W,se){this._onDidStateChange.fire(new F(this.reconnectionToken,G,W,se)),$(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=M;class K extends M{constructor(G,W,se,ae,ie){super(a.Management,G,ae,ie,!0),this.client=this._register(new d.Client(ie,{remoteAuthority:W,clientId:se},G.ipcLogger))}async _reconnect(G,W){await o(G,W)}}e.ManagementPersistentConnection=K;class ee extends M{constructor(G,W,se,ae,ie){super(a.ExtensionHost,G,se,ae,!1),this._startArguments=W,this.debugPort=ie}async _reconnect(G,W){await p(G,this._startArguments,W)}}e.ExtensionHostPersistentConnection=ee;function $(ve){try{ve.acceptDisconnect();const G=ve.getSocket();ve.dispose(),G.dispose()}catch(G){(0,A.onUnexpectedError)(G)}}function q(ve){if(ve&&ve.type==="error"){const G=new Error(`Connection error: ${ve.reason}`);return G.code="VSCODE_CONNECTION_ERROR",G}return null}function Z(ve,G){for(;ve.length<G;)ve+=" ";return ve}function ne(ve,G){return`[remote-connection][${Z(u(ve),13)}][${G.substr(0,5)}\u2026]`}function de(ve,G,W){return`${ne(ve,G)}[${W?"reconnect":"initial"}]`}function re(ve,G){return`${de(G,ve.reconnectionToken,!!ve.reconnectionProtocol)}[${ve.connectTo}]`}function Se(ve){return`${Date.now()-ve} ms`}}),define(we[91],ye([1,0,15]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=g,e.getRemoteName=k,e.parseAuthorityWithPort=A,e.parseAuthorityWithOptionalPort=L;function g(v){return v.scheme===r.Schemas.vscodeRemote?v.authority:void 0}function k(v){if(!v)return;const l=v.indexOf("+");return l<0?v:v.substr(0,l)}function A(v){const{host:l,port:P}=R(v);if(typeof P>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:P}}function L(v,l){let{host:P,port:y}=R(v);return typeof y>"u"&&(y=l),{host:P,port:y}}function R(v){const l=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const P=v.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const y=v.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:v,port:void 0}}}),define(we[24],ye([1,0,13,5,91]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=A,e.isApplicationScopedExtension=y,e.isLanguagePackExtension=d,e.isAuthenticationProviderExtension=T,e.isResolverExtension=E,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var L;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(L||(e.ExtensionType=L={}));var R;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.LINUX_PPC64LE="linux-ppc64le",a.LINUX_RISCV64="linux-riscv64",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class v{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,f){if(typeof u>"u"||u===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof u=="string"||typeof f=="string"){const m=typeof u=="string"?u:u.value,n=typeof f=="string"?f:f.value;return r.equalsIgnoreCase(m,n)}return u._lower===f._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.ExtensionIdentifier=v;class l{get size(){return this._set.size}constructor(u){if(this._set=new Set,u)for(const f of u)this.add(f)}add(u){this._set.add(v.toKey(u))}delete(u){return this._set.delete(v.toKey(u))}has(u){return this._set.has(v.toKey(u))}}e.ExtensionIdentifierSet=l;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(u){this._map.delete(v.toKey(u))}get(u){return this._map.get(v.toKey(u))}has(u){return this._map.has(v.toKey(u))}set(u,f){this._map.set(v.toKey(u),f)}values(){return this._map.values()}forEach(u){this._map.forEach(u)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function y(a){return d(a)}function d(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function T(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function E(a,u){if(u){const f=`onResolveRemoteAuthority:${(0,k.getRemoteName)(u)}`;return!!a.activationEvents?.includes(f)}return!1}e.IBuiltinExtensionsScannerService=(0,g.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[145],ye([1,0,11,220,24,5]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=R,e.toTargetPlatform=v,e.getTargetPlatform=l,e.isNotWebExtensionInWebTargetPlatform=P,e.isTargetPlatformCompatible=y,e.isIExtensionIdentifier=d,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var L;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function R(i){switch(i){case k.TargetPlatform.WIN32_X64:return"Windows 64 bit";case k.TargetPlatform.WIN32_ARM64:return"Windows ARM";case k.TargetPlatform.LINUX_X64:return"Linux 64 bit";case k.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case k.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case k.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case k.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case k.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case k.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case k.TargetPlatform.DARWIN_X64:return"Mac";case k.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case k.TargetPlatform.WEB:return"Web";case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;case k.TargetPlatform.UNKNOWN:return k.TargetPlatform.UNKNOWN;case k.TargetPlatform.UNDEFINED:return k.TargetPlatform.UNDEFINED}}function v(i){switch(i){case k.TargetPlatform.WIN32_X64:return k.TargetPlatform.WIN32_X64;case k.TargetPlatform.WIN32_ARM64:return k.TargetPlatform.WIN32_ARM64;case k.TargetPlatform.LINUX_X64:return k.TargetPlatform.LINUX_X64;case k.TargetPlatform.LINUX_ARM64:return k.TargetPlatform.LINUX_ARM64;case k.TargetPlatform.LINUX_ARMHF:return k.TargetPlatform.LINUX_ARMHF;case k.TargetPlatform.LINUX_PPC64LE:return k.TargetPlatform.LINUX_PPC64LE;case k.TargetPlatform.LINUX_RISCV64:return k.TargetPlatform.LINUX_RISCV64;case k.TargetPlatform.ALPINE_X64:return k.TargetPlatform.ALPINE_X64;case k.TargetPlatform.ALPINE_ARM64:return k.TargetPlatform.ALPINE_ARM64;case k.TargetPlatform.DARWIN_X64:return k.TargetPlatform.DARWIN_X64;case k.TargetPlatform.DARWIN_ARM64:return k.TargetPlatform.DARWIN_ARM64;case k.TargetPlatform.WEB:return k.TargetPlatform.WEB;case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;default:return k.TargetPlatform.UNKNOWN}}function l(i,t){switch(i){case r.Platform.Windows:return t==="x64"?k.TargetPlatform.WIN32_X64:t==="arm64"?k.TargetPlatform.WIN32_ARM64:k.TargetPlatform.UNKNOWN;case r.Platform.Linux:return t==="x64"?k.TargetPlatform.LINUX_X64:t==="arm64"?k.TargetPlatform.LINUX_ARM64:t==="arm"?k.TargetPlatform.LINUX_ARMHF:t==="ppc64le"?k.TargetPlatform.LINUX_PPC64LE:t==="riscv64"?k.TargetPlatform.LINUX_RISCV64:k.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?k.TargetPlatform.ALPINE_X64:t==="arm64"?k.TargetPlatform.ALPINE_ARM64:k.TargetPlatform.UNKNOWN;case r.Platform.Mac:return t==="x64"?k.TargetPlatform.DARWIN_X64:t==="arm64"?k.TargetPlatform.DARWIN_ARM64:k.TargetPlatform.UNKNOWN;case r.Platform.Web:return k.TargetPlatform.WEB}}function P(i,t){return t===k.TargetPlatform.WEB&&!i.includes(k.TargetPlatform.WEB)}function y(i,t,c){return P(t,c)?!1:i===k.TargetPlatform.UNDEFINED||i===k.TargetPlatform.UNIVERSAL?!0:i===k.TargetPlatform.UNKNOWN?!1:i===c}function d(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var T;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var E;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var a;(function(i){i.Install="install",i.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var u;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(u||(e.InstallOperation=u={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var f;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class m extends Error{constructor(t,c){super(t),this.code=c,this.name=c}}e.ExtensionGalleryError=m;var n;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class s extends Error{constructor(t,c){super(t),this.code=c,this.name=c}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,g.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,g.localize2)(1,"Preferences")}),define(we[146],ye([1,0,14,24]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this._generators=new Map,this._cache=new WeakMap}register(L,R){this._generators.set(L,R)}readActivationEvents(L){return this._cache.has(L)||this._cache.set(L,this._readActivationEvents(L)),this._cache.get(L)}createActivationEventsMap(L){const R=Object.create(null);for(const v of L){const l=this.readActivationEvents(v);l.length>0&&(R[g.ExtensionIdentifier.toKey(v.identifier)]=l)}return R}_readActivationEvents(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const R=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let v=0;v<R.length;v++)R[v]==="onUri"&&(R[v]=`onUri:${g.ExtensionIdentifier.toKey(L.identifier)}`);if(!L.contributes)return R;for(const v in L.contributes){const l=this._generators.get(v);if(!l)continue;const P=L.contributes[v],y=Array.isArray(P)?P:[P];try{l(y,R)}catch(d){(0,r.onUnexpectedError)(d)}}return R}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(we[284],ye([1,0,3,5]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,g.createDecorator)("remoteSocketFactoryService");class k{constructor(){this.factories={}}register(L,R){return this.factories[L]??=[],this.factories[L].push(R),(0,r.toDisposable)(()=>{const v=this.factories[L]?.indexOf(R);typeof v=="number"&&v>=0&&this.factories[L]?.splice(v,1)})}getSocketFactory(L){return(this.factories[L.type]||[]).find(v=>v.supports(L))}connect(L,R,v,l){const P=this.getSocketFactory(L);if(!P)throw new Error(`No socket factory found for ${L}`);return P.connect(L,R,v,l)}}e.RemoteSocketFactoryService=k}),define(we[285],ye([1,0,22,14,3,228,70,5,12,36]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=d,e.hasNoContent=T,e.asText=E,e.asTextOrError=a,e.asJson=u,e.updateProxyConfigurationsScope=f,e.IRequestService=(0,R.createDecorator)("requestService");class P{constructor(i){this.original=i}toJSON(){if(!this.headers){const i=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?i[t]="*****":i[t]=this.original[t];this.headers=i}return this.headers}}class y extends k.Disposable{constructor(i){super(),this.counter=0,this.logger=i.createLogger("network",{name:(0,A.localize)(0,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async logAndRequest(i,t,c){const h=`${i} #${++this.counter}: ${t.url}`;this.logger.trace(`${h} - begin`,t.type,new P(t.headers??{}));try{const o=await c();return this.logger.trace(`${h} - end`,t.type,o.res.statusCode,o.res.headers),o}catch(o){throw this.logger.error(`${h} - error`,t.type,(0,g.getErrorMessage)(o)),o}}}e.AbstractRequestService=y;function d(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function T(s){return s.res.statusCode===204}async function E(s){return T(s)?null:(await(0,r.streamToBuffer)(s.stream)).toString()}async function a(s){if(!d(s))throw new Error("Server returned "+s.res.statusCode);return E(s)}async function u(s){if(!d(s))throw new Error("Server returned "+s.res.statusCode);if(T(s))return null;const t=(await(0,r.streamToBuffer)(s.stream)).toString();try{return JSON.parse(t)}catch(c){throw c.message+=`:
`+t,c}}function f(s){n(s)}let m;function n(s){const i=l.Registry.as(L.Extensions.Configuration),t=m;m={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},i.updateConfigurations({add:[m],remove:t?[t]:[]})}n(L.ConfigurationScope.APPLICATION)}),define(we[286],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class r{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(k){try{const A=await this.getValidator();if(A){const L=String(r._nextId++);return this.validators.set(L,A),{id:L,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,A){if(!k.id)return!0;const L=this.validators.get(k.id);if(!L)return!1;this.validators.delete(k.id);try{return L.validate(A)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(k){try{return await this.signValue(k)}catch{}return k}}e.AbstractSignService=r}),define(we[117],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,r.createDecorator)(e.SIGN_SERVICE_ID)}),define(we[147],ye([1,0,286]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g extends r.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(L=>new L.signer().sign(A))}vsda(){return new Promise((A,L)=>he(["vsda"],A,L))}}e.SignService=g}),define(we[287],ye([1,0,11,56,32]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=L,e.verifyMicrosoftInternalDomain=R;function A(v){if(r.platform===r.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function L(v,l,P,y,d,T,E,a,u,f){const m=Object.create(null);m["common.machineId"]=T,m["common.sqmId"]=E,m["common.devDeviceId"]=a,m.sessionID=(0,k.generateUuid)()+Date.now(),m.commitHash=y,m.version=d,m["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,r.PlatformToString)(r.platform),m["common.nodePlatform"]=g.platform,m["common.nodeArch"]=P,m["common.product"]=f||"desktop",u&&(m["common.msftInternal"]=u);let n=0;const s=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),r.isLinuxSnap&&(m["common.snap"]="true");const i=A(l);return i&&(m["common.platformDetail"]=i),m}function R(v){const l=g.env.USERDNSDOMAIN;if(!l)return!1;const P=l.toLowerCase();return v.some(y=>P===y)}}),define(we[148],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,r.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,r.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var g;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(g||(e.TelemetryLevel=g={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(we[92],ye([1,0,25,18,91,287,148]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=P,e.isLoggingOnly=y,e.getTelemetryLevel=d,e.validateTelemetryData=T,e.cleanRemoteAuthority=a,e.isInternalTelemetry=f,e.getPiiPathsFromEnvironment=m,e.cleanData=i;class R{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class v{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=v,e.NullTelemetryService=new v;class l{async publicLog(c,h,o){}async publicLogError(c,h,o){}}e.NullEndpointTelemetryService=l,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(t,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!t.enableTelemetry)}function y(t,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function d(t){const c=t.getValue(L.TELEMETRY_SETTING_ID),h=t.getValue(L.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return L.TelemetryLevel.NONE;switch(c??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function T(t){const c={},h={},o={};u(t,o);for(let p in o){p=p.length>150?p.substr(p.length-149):p;const _=o[p];typeof _=="number"?h[p]=_:typeof _=="boolean"?h[p]=_?1:0:typeof _=="string"?(_.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${_.length}`),c[p]=_.substring(0,8191)):typeof _<"u"&&_!==null&&(c[p]=_)}return{properties:c,measurements:h}}const E=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const c=(0,k.getRemoteName)(t);return E.has(c)?c:"other"}function u(t,c,h=0,o){if(t)for(const p of Object.getOwnPropertyNames(t)){const _=t[p],D=o?o+p:p;Array.isArray(_)?c[D]=(0,r.safeStringify)(_):_ instanceof Date?c[D]=_.toISOString():(0,g.isObject)(_)?h<2?u(_,c,h+1,D+"."):c[D]=(0,r.safeStringify)(_):c[D]=_}}function f(t,c){const h=t.msftInternalDomains||[],o=c.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(h)||o}function m(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,c){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let h=t;const o=[];for(const C of c)for(;;){const S=C.exec(t);if(!S)break;o.push([S.index,C.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,_=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(h="";;){const C=_.exec(t);if(!C)break;const S=o.some(([I,b])=>C.index<b&&I<_.lastIndex);!p.test(C[0])&&!S&&(h+=t.substring(D,C.index)+"<REDACTED: user-file-path>",D=_.lastIndex)}return D<t.length&&(h+=t.substr(D)),h}function s(t){if(!t)return t;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of c)if(h.regex.test(t))return`<REDACTED: ${h.label}>`;return t}function i(t,c){return(0,r.cloneAndChange)(t,h=>{if(h instanceof R||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let o=h.replaceAll("%20"," ");o=n(o,c);for(const p of c)o=o.replace(p,"");return o=s(o),o}})}}),define(we[288],ye([1,0,13,145,24,11,2,14,56,92]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=P,e.getIdAndVersion=E,e.getExtensionId=a,e.adoptToGalleryExtensionId=u,e.getGalleryExtensionId=f,e.groupByExtension=m,e.getLocalExtensionTelemetryData=n,e.getGalleryExtensionTelemetryData=s,e.getExtensionDependencies=i,e.computeTargetPlatform=c;function P(h,o){return h.uuid&&o.uuid?h.uuid===o.uuid:h.id===o.id?!0:(0,r.compareIgnoreCase)(h.id,o.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(o){const p=o.manifest?o.manifest.version:o.version,_=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new d(o.identifier,p,_)}static parse(o){const p=y.exec(o);return p&&p[1]&&p[2]?new d({id:p[1]},p[2],p[4]||void 0):null}constructor(o,p,_=k.TargetPlatform.UNDEFINED){this.identifier=o,this.version=p,this.targetPlatform=_,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==k.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof d?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=d;const T=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(h){const o=T.exec(h);return o&&o[1]?[u(o[1]),o[2]]:[u(h),void 0]}function a(h,o){return`${h}.${o}`}function u(h){return h.toLowerCase()}function f(h,o){return u(a(h??k.UNDEFINED_PUBLISHER,o))}function m(h,o){const p=[],_=D=>{for(const C of p)if(C.some(S=>P(o(S),o(D))))return C;return null};for(const D of h){const C=_(D);C?C.push(D):p.push([D])}return p}function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}function s(h){return{id:new l.TelemetryTrustedValue(h.identifier.id),name:new l.TelemetryTrustedValue(h.name),version:h.version,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function i(h,o){const p=[],_=o.manifest.extensionDependencies?.slice(0)??[];for(;_.length;){const D=_.shift();if(D&&p.every(C=>!P(C.identifier,{id:D}))){const C=h.filter(S=>P(S.identifier,{id:D}));C.length===1&&(p.push(C[0]),_.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}async function t(h,o){if(!A.isLinux)return!1;let p;try{p=(await h.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{p=(await h.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){o.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(D))}}return!!p&&(p.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(h,o){const p=await t(h,o),_=(0,g.getTargetPlatform)(p?"alpine":A.platform,v.arch);return o.debug("ComputeTargetPlatform:",_),_}}),define(we[289],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=r,e.serializeEnvironmentDescriptionMap=g,e.deserializeEnvironmentVariableCollection=k,e.deserializeEnvironmentDescriptionMap=A,e.serializeEnvironmentVariableCollections=L,e.deserializeEnvironmentVariableCollections=R;function r(v){return[...v.entries()]}function g(v){return v?[...v.entries()]:[]}function k(v){return new Map(v)}function A(v){return new Map(v??[])}function L(v){return Array.from(v.entries()).map(l=>[l[0],r(l[1].map),g(l[1].descriptionMap)])}function R(v){return new Map(v.map(l=>[l[0],{map:k(l[1]),descriptionMap:A(l[2])}]))}}),define(we[290],ye([1,0,5,35,36]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new g.RawContextKey("terminalTabFocusMode",!1,!0);var A;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var L;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var R;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(R||(e.PosixShellType=R={}));var v;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(v||(e.WindowsShellType=v={}));var l;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var P;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(P||(e.TerminalIpcChannels=P={}));var y;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.IPtyService=(0,r.createDecorator)("ptyService");var d;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(d||(e.HeartbeatConstants=d={}));var T;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(T||(e.TerminalLocation=T={}));var E;(function(i){i.TerminalView="view",i.Editor="editor"})(E||(e.TerminalLocationString=E={}));var a;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var u;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(u||(e.FlowControlConstants=u={}));var f;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(f||(e.ProfileSource=f={}));var m;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var n;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const c=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(c))throw new Error(`A terminal backend with remote authority '${c}' was already registered.`);this._backends.set(c,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}k.Registry.add(e.TerminalExtensions.Backend,new s),e.ILocalPtyService=(0,r.createDecorator)("localPtyService"),e.ITerminalLogService=(0,r.createDecorator)("terminalLogService")}),define(we[291],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,A,L=5){const R=A(v=>{const l=typeof v=="string"?v:v.data;let P=this._terminalBufferMap.get(k);if(P){P.data.push(l);return}const y=setTimeout(()=>this.flushBuffer(k),L);P={data:[l],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(k),R.dispose()}},this._terminalBufferMap.set(k,P)});return R}stopBuffering(k){this._terminalBufferMap.get(k)?.dispose()}flushBuffer(k){const A=this._terminalBufferMap.get(k);A&&(this._terminalBufferMap.delete(k),this._callback(k,A.data.join("")))}}e.TerminalDataBufferer=r}),define(we[292],ye([1,0,9,83,104,50,4,18,2,229,116,36]),function(he,e,r,g,k,A,L,R,v,l,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=u,e.getIconRegistry=f,e.Extensions={IconContribution:"base.contributions.icons"};var d;(function(i){function t(c,h){let o=c.defaults;for(;A.ThemeIcon.isThemeIcon(o);){const p=a.getIcon(o.id);if(!p)return;o=p.defaults}return o}i.getDefinition=t})(d||(e.IconContribution=d={}));var T;(function(i){function t(h){return{weight:h.weight,style:h.style,src:h.src.map(o=>({format:o.format,location:o.location.toString()}))}}i.toJSONObject=t;function c(h){const o=p=>(0,R.isString)(p)?p:void 0;if(h&&Array.isArray(h.src)&&h.src.every(p=>(0,R.isString)(p.format)&&(0,R.isString)(p.location)))return{weight:o(h.weight),style:o(h.style),src:h.src.map(p=>({format:p.format,location:v.URI.parse(p.location)}))}}i.fromJSONObject=c})(T||(e.IconFontDefinition=T={}));class E{constructor(){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,l.localize)(0,null)},fontCharacter:{type:"string",description:(0,l.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(t,c,h,o){const p=this.iconsById[t];if(p){if(h&&!p.description){p.description=h,this.iconSchema.properties[t].markdownDescription=`${h} $(${t})`;const C=this.iconReferenceSchema.enum.indexOf(t);C!==-1&&(this.iconReferenceSchema.enumDescriptions[C]=h),this._onDidChange.fire()}return p}const _={id:t,description:h,defaults:c,deprecationMessage:o};this.iconsById[t]=_;const D={$ref:"#/definitions/icons"};return o&&(D.deprecationMessage=o),h&&(D.markdownDescription=`${h}: $(${t})`),this.iconSchema.properties[t]=D,this.iconReferenceSchema.enum.push(t),this.iconReferenceSchema.enumDescriptions.push(h||""),this._onDidChange.fire(),{id:t}}deregisterIcon(t){delete this.iconsById[t],delete this.iconSchema.properties[t];const c=this.iconReferenceSchema.enum.indexOf(t);c!==-1&&(this.iconReferenceSchema.enum.splice(c,1),this.iconReferenceSchema.enumDescriptions.splice(c,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(t=>this.iconsById[t])}getIcon(t){return this.iconsById[t]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(t,c){const h=this.iconFontsById[t];return h||(this.iconFontsById[t]=c,this._onDidChange.fire(),c)}deregisterIconFont(t){delete this.iconFontsById[t]}getIconFont(t){return this.iconFontsById[t]}toString(){const t=(p,_)=>p.id.localeCompare(_.id),c=p=>{for(;A.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of o.filter(_=>!!_.description).sort(t))h.push(`|<i class="${c(p)}"></i>|${p.id}|${A.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const p of o.filter(_=>!A.ThemeIcon.isThemeIcon(_.defaults)).sort(t))h.push(`|<i class="${c(p)}"></i>|${p.id}|`);return h.join(`
`)}}const a=new E;y.Registry.add(e.Extensions.IconContribution,a);function u(i,t,c,h){return a.registerIcon(i,t,c,h)}function f(){return a}function m(){const i=(0,k.getCodiconFontCharacters)();for(const t in i){const c="\\"+i[t].toString(16);a.registerIcon(t,{fontCharacter:c})}}m(),e.iconsSchemaId="vscode://schemas/icons";const n=y.Registry.as(P.Extensions.JSONContribution);n.registerSchema(e.iconsSchemaId,a.getIconSchema());const s=new r.RunOnceScheduler(()=>n.notifySchemaChanged(e.iconsSchemaId),200);a.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.widgetClose=u("widget-close",g.Codicon.close,(0,l.localize)(2,null)),e.gotoPreviousLocation=u("goto-previous-location",g.Codicon.arrowUp,(0,l.localize)(3,null)),e.gotoNextLocation=u("goto-next-location",g.Codicon.arrowDown,(0,l.localize)(4,null)),e.syncing=A.ThemeIcon.modify(g.Codicon.sync,"spin"),e.spinningLoading=A.ThemeIcon.modify(g.Codicon.loading,"spin")}),define(we[93],ye([1,0,4,11,2,44,5,12]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=P,e.extractLocalHostUriMetaDataForPortMapping=d,e.extractQueryLocalHostUriMetaDataForPortMapping=T,e.isLocalhost=E,e.isAllInterfaces=a,e.isPortPrivileged=u,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var v;(function(n){n.Http="http",n.Https="https"})(v||(e.TunnelProtocol=v={}));var l;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(l||(e.TunnelPrivacyId=l={}));function P(n){return!!n.forwardPort}var y;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function d(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(s)return{address:s[1],port:+s[2]}}function T(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const s=n.query.split("&");for(const i of s){const t=i.split("=")[1];if(/^https?:/.exec(t)){const c=d(k.URI.parse(t));if(c)return c}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(n){return e.LOCALHOST_ADDRESSES.indexOf(n)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(n){return e.ALL_INTERFACES_ADDRESSES.indexOf(n)>=0}function u(n,s,i,t){if(i===g.OperatingSystem.Windows)return!1;if(i===g.OperatingSystem.Macintosh&&a(s)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(c?.length===4&&parseInt(c[1])>=18)return!1}return n<1024}class f{constructor(s,i,t){this.remoteAddress=s,this.localAddress=i,this._dispose=t,this._onDispose=new r.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let m=class{constructor(s,i){this.logService=s,this.configurationService=i,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const s=this.configurationService.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this._tunnelProvider=s,s?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this._canElevate=s.elevation,this._privacyOptions=s.privacyOptions,this._canChangeProtocol=s.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const s=[],i=Array.from(this._tunnels.values());for(const t of i){const c=Array.from(t.values());for(const h of c){const o=await h.value;o&&typeof o!="string"&&s.push(o)}}return s}async dispose(){for(const s of this._tunnels.values()){for(const{value:i}of s.values())await i.then(t=>typeof t!="string"?t?.dispose():void 0);s.clear()}this._tunnels.clear()}setEnvironmentTunnel(s,i,t,c,h){this.addTunnelToMap(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:t,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(a(s)||E(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const t=this.getTunnelFromMap(s,i);if(t)return++t.refcount,t.value}openTunnel(s,i,t,c,h,o=!1,p,_){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${t} on local port ${h}.`);const D=this._tunnelProvider??s;if(!D)return;if(i||(i="localhost"),c||(c=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(t)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.retainOrCreateTunnel(D,i,t,c,h,o,p,_);return C?C.then(S=>{if(S){if(typeof S=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(i,t),S}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(i,t);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.makeTunnel(S);return(S.tunnelRemoteHost!==i||S.tunnelRemotePort!==t)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),p&&S.privacy!==p&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(I),I}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}makeTunnel(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this._tunnels.get(s.tunnelRemoteHost);if(i){const t=i.get(s.tunnelRemotePort);t&&(t.refcount--,await this.tryDisposeTunnel(s.tunnelRemoteHost,s.tunnelRemotePort,t))}}}}async tryDisposeTunnel(s,i,t){if(t.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const c=t.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(s)&&this._tunnels.get(s).delete(i),c}}async closeTunnel(s,i){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const t=this._tunnels.get(s);if(t&&t.has(i)){const c=t.get(i);c.refcount=0,await this.tryDisposeTunnel(s,i,c)}}addTunnelToMap(s,i,t){this._tunnels.has(s)||this._tunnels.set(s,new Map),this._tunnels.get(s).set(i,{refcount:1,value:t})}async removeEmptyOrErrorTunnelFromMap(s,i){const t=this._tunnels.get(s);if(t){const c=t.get(i),h=c?await c.value:void 0;(!h||typeof h=="string")&&t.delete(i),t.size===0&&this._tunnels.delete(s)}}getTunnelFromMap(s,i){const t=[s];E(s)?(t.push(...e.LOCALHOST_ADDRESSES),t.push(...e.ALL_INTERFACES_ADDRESSES)):a(s)&&t.push(...e.ALL_INTERFACES_ADDRESSES);const c=t.map(h=>this._tunnels.get(h));for(const h of c){const o=h?.get(i);if(o)return o}}canTunnel(s){return!!d(s)}createWithProvider(s,i,t,c,h,o,p){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${t} on local port ${c}.`);const _=t;this._factoryInProgress.add(_);const D=c===void 0?t:c,C={elevationRequired:h?this.isPortPrivileged(D):!1},S={remoteAddress:{host:i,port:t},localAddressPort:c,privacy:o,public:o?o!==l.Private:void 0,protocol:p},I=s.forwardPort(S,C);return I?(this.addTunnelToMap(i,t,I),I.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(_)})):this._factoryInProgress.delete(_),I}};e.AbstractTunnelService=m,e.AbstractTunnelService=m=Ke([Ve(0,R.ILogService),Ve(1,A.IConfigurationService)],m)}),define(we[293],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,r.createDecorator)("IUriIdentityService")}),define(we[294],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,r.createDecorator)("editSessionIdentityService");var g;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(g||(e.EditSessionIdentityMatch=g={}))}),define(we[295],ye([1,0,15]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=g,e.getVirtualWorkspaceLocation=k,e.getVirtualWorkspaceScheme=A,e.getVirtualWorkspaceAuthority=L,e.isVirtualWorkspace=R;function g(v){return v.scheme!==r.Schemas.file&&v.scheme!==r.Schemas.vscodeRemote}function k(v){if(v.folders.length)return v.folders.every(l=>g(l.uri))?v.folders[0].uri:void 0;if(v.configuration&&g(v.configuration))return v.configuration}function A(v){return k(v)?.scheme}function L(v){return k(v)?.authority}function R(v){return k(v)!==void 0}}),define(we[45],ye([1,0,231,16,85,23,2,5,15]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=l,e.isEmptyWorkspaceIdentifier=P,e.toWorkspaceIdentifier=y,e.isWorkspaceIdentifier=d,e.reviveIdentifier=T,e.isWorkspace=a,e.isWorkspaceFolder=u,e.toWorkspaceFolder=n,e.isUntitledWorkspace=s,e.isTemporaryWorkspace=i,e.isStandaloneEditorWorkspace=t,e.isSavedWorkspace=c,e.hasWorkspaceFileExtension=h,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function l(o){const p=o;return typeof p?.id=="string"&&L.URI.isUri(p.uri)}function P(o){return typeof o?.id=="string"&&!l(o)&&!d(o)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(o,p){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,g.basename)(o)}:p?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const _=o;return _.configuration?{id:_.id,configPath:_.configuration}:_.folders.length===1?{id:_.id,uri:_.folders[0].uri}:{id:_.id}}function d(o){const p=o;return typeof p?.id=="string"&&L.URI.isUri(p.configPath)}function T(o){const p=o;if(p?.uri)return{id:p.id,uri:L.URI.revive(p.uri)};const _=o;if(_?.configPath)return{id:_.id,configPath:L.URI.revive(_.configPath)};if(o?.id)return{id:o.id}}var E;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function a(o){const p=o;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}function u(o){const p=o;return!!(p&&typeof p=="object"&&L.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}class f{constructor(p,_,D,C,S){this._id=p,this._transient=D,this._configuration=C,this._ignorePathCasing=S,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=_}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class m{constructor(p,_){this.raw=_,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,A.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function n(o){return new m({uri:o,index:0,name:(0,A.basenameOrAuthority)(o)},{uri:o.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,r.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function s(o,p){return A.extUriBiasedIgnorePathCase.isEqualOrParent(o,p.untitledWorkspacesHome)}function i(o){let p;return L.URI.isUri(o)?p=o:p=o.configuration,p?.scheme===v.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(o){return o.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function c(o,p){return!s(o,p)&&!i(o)}function h(o){return(typeof o=="string"?(0,g.extname)(o):(0,A.extname)(o))===e.WORKSPACE_SUFFIX}}),define(we[149],ye([1,0,61,4,3,23,2,230,143,28,5,12,45,29,293,9,32,13,18]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=s,e.reviveProfile=i,e.toUserDataProfile=t;var n;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function s(o){const p=o;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&typeof p.isDefault=="boolean"&&typeof p.name=="string"&&L.URI.isUri(p.location)&&L.URI.isUri(p.globalStorageHome)&&L.URI.isUri(p.settingsResource)&&L.URI.isUri(p.keybindingsResource)&&L.URI.isUri(p.tasksResource)&&L.URI.isUri(p.snippetsHome)&&L.URI.isUri(p.extensionsResource))}e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function i(o,p){return{id:o.id,isDefault:o.isDefault,name:o.name,shortName:o.shortName,icon:o.icon,location:L.URI.revive(o.location).with({scheme:p}),globalStorageHome:L.URI.revive(o.globalStorageHome).with({scheme:p}),settingsResource:L.URI.revive(o.settingsResource).with({scheme:p}),keybindingsResource:L.URI.revive(o.keybindingsResource).with({scheme:p}),tasksResource:L.URI.revive(o.tasksResource).with({scheme:p}),snippetsHome:L.URI.revive(o.snippetsHome).with({scheme:p}),extensionsResource:L.URI.revive(o.extensionsResource).with({scheme:p}),cacheHome:L.URI.revive(o.cacheHome).with({scheme:p}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}function t(o,p,_,D,C,S){return{id:o,name:p,location:_,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:S&&C?.useDefaultFlags?.globalState?S.globalStorageHome:(0,A.joinPath)(_,"globalStorage"),settingsResource:S&&C?.useDefaultFlags?.settings?S.settingsResource:(0,A.joinPath)(_,"settings.json"),keybindingsResource:S&&C?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,A.joinPath)(_,"keybindings.json"),tasksResource:S&&C?.useDefaultFlags?.tasks?S.tasksResource:(0,A.joinPath)(_,"tasks.json"),snippetsHome:S&&C?.useDefaultFlags?.snippets?S.snippetsHome:(0,A.joinPath)(_,"snippets"),extensionsResource:S&&C?.useDefaultFlags?.extensions?S.extensionsResource:(0,A.joinPath)(_,"extensions.json"),cacheHome:(0,A.joinPath)(D,o),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}let c=class extends k.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(p,_,D,C){super(),this.environmentService=p,this.fileService=_,this.uriIdentityService=D,this.logService=C,this.enabled=!0,this._onDidChangeProfiles=this._register(new g.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new g.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new g.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new g.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new T.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(p){this.enabled!==p&&(this._profilesObject=void 0,this.enabled=p)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const p=this.createDefaultProfile(),_=[p];if(this.enabled)try{for(const S of this.getStoredProfiles()){if(!S.name||!(0,m.isString)(S.name)||!S.location){this.logService.warn("Skipping the invalid stored profile",S.location||S.name);continue}_.push(t((0,A.basename)(S.location),S.name,S.location,this.profilesCacheHome,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},p))}}catch(S){this.logService.error(S)}const D=new T.ResourceMap,C=new Map;if(_.length)try{const S=this.getStoredProfileAssociations();if(S.workspaces)for(const[I,b]of Object.entries(S.workspaces)){const w=L.URI.parse(I),N=_.find(O=>O.id===b);N&&D.set(w,N)}if(S.emptyWindows)for(const[I,b]of Object.entries(S.emptyWindows)){const w=_.find(N=>N.id===b);w&&C.set(I,w)}}catch(S){this.logService.error(S)}this._profilesObject={profiles:_,workspaces:D,emptyWindows:C}}return this._profilesObject}createDefaultProfile(){const p=t("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...p,extensionsResource:this.getDefaultProfileExtensionsLocation()??p.extensionsResource,isDefault:!0}}async createTransientProfile(p){const _="Temp",D=new RegExp(`${(0,f.escapeRegExpCharacters)(_)}\\s(\\d+)`);let C=0;for(const I of this.profiles){const b=D.exec(I.name),w=b?parseInt(b[1]):0;C=w>C?w:C}const S=`${_} ${C+1}`;return this.createProfile((0,r.hash)((0,u.generateUuid)()).toString(16),S,{transient:!0},p)}async createNamedProfile(p,_,D){return this.createProfile((0,r.hash)((0,u.generateUuid)()).toString(16),p,_,D)}async createProfile(p,_,D,C){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const S=await this.doCreateProfile(p,_,D);return C&&await this.setProfileForWorkspace(C,S),S}async doCreateProfile(p,_,D){if(!(0,m.isString)(_)||!_)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.profileCreationPromises.get(_);return C||(C=(async()=>{try{if(this.profiles.find(w=>w.name===_||w.id===p))throw new Error(`Profile with ${_} name already exists`);const I=t(p,_,(0,A.joinPath)(this.profilesHome,p),this.profilesCacheHome,D,this.defaultProfile);await this.fileService.createFolder(I.location);const b=[];return this._onWillCreateProfile.fire({profile:I,join(w){b.push(w)}}),await a.Promises.settled(b),this.updateProfiles([I],[],[]),I}finally{this.profileCreationPromises.delete(_)}})(),this.profileCreationPromises.set(_,C)),C}async updateProfile(p,_){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(C=>C.id===p.id);if(!D)throw new Error(`Profile '${p.name}' does not exist`);return D=t(D.id,_.name??D.name,D.location,this.profilesCacheHome,{shortName:_.shortName??D.shortName,icon:_.icon===null?void 0:_.icon??D.icon,transient:_.transient??D.isTransient,useDefaultFlags:_.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[D]),D}async removeProfile(p){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(p.isDefault)throw new Error("Cannot remove default profile");const _=this.profiles.find(C=>C.id===p.id);if(!_)throw new Error(`Profile '${p.name}' does not exist`);const D=[];this._onWillRemoveProfile.fire({profile:_,join(C){D.push(C)}});try{await Promise.allSettled(D)}catch(C){this.logService.error(C)}for(const C of[...this.profilesObject.emptyWindows.keys()])_.id===this.profilesObject.emptyWindows.get(C)?.id&&this.profilesObject.emptyWindows.delete(C);for(const C of[...this.profilesObject.workspaces.keys()])_.id===this.profilesObject.workspaces.get(C)?.id&&this.profilesObject.workspaces.delete(C);this.updateStoredProfileAssociations(),this.updateProfiles([],[_],[]);try{await this.fileService.del(_.cacheHome,{recursive:!0})}catch(C){(0,l.toFileOperationResult)(C)!==l.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(C)}}async setProfileForWorkspace(p,_){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(C=>C.id===_.id);if(!D)throw new Error(`Profile '${_.name}' does not exist`);this.updateWorkspaceAssociation(p,D)}unsetWorkspace(p,_){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(p,void 0,_)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const p=await this.fileService.resolve(this.profilesHome);await Promise.all((p.children||[]).filter(_=>_.isDirectory&&this.profiles.every(D=>!this.uriIdentityService.extUri.isEqual(D.location,_.resource))).map(_=>this.fileService.del(_.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const p=this.transientProfilesObject.profiles.filter(_=>!this.isProfileAssociatedToWorkspace(_));await Promise.allSettled(p.map(_=>this.removeProfile(_)))}getProfileForWorkspace(p){const _=this.getWorkspace(p);return L.URI.isUri(_)?this.transientProfilesObject.workspaces.get(_)??this.profilesObject.workspaces.get(_):this.transientProfilesObject.emptyWindows.get(_)??this.profilesObject.emptyWindows.get(_)}getWorkspace(p){return(0,d.isSingleFolderWorkspaceIdentifier)(p)?p.uri:(0,d.isWorkspaceIdentifier)(p)?p.configPath:p.id}isProfileAssociatedToWorkspace(p){return!!([...this.transientProfilesObject.emptyWindows.values()].some(_=>this.uriIdentityService.extUri.isEqual(_.location,p.location))||[...this.transientProfilesObject.workspaces.values()].some(_=>this.uriIdentityService.extUri.isEqual(_.location,p.location))||[...this.profilesObject.emptyWindows.values()].some(_=>this.uriIdentityService.extUri.isEqual(_.location,p.location))||[...this.profilesObject.workspaces.values()].some(_=>this.uriIdentityService.extUri.isEqual(_.location,p.location)))}updateProfiles(p,_,D){const C=[...this.profiles,...p],S=[];this.transientProfilesObject.profiles=[];for(let I of C)I.isDefault||_.some(b=>I.id===b.id)||(I=D.find(b=>I.id===b.id)??I,I.isTransient?this.transientProfilesObject.profiles.push(I):S.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags}));this.saveStoredProfiles(S),this._profilesObject=void 0,this.triggerProfilesChanges(p,_,D)}triggerProfilesChanges(p,_,D){this._onDidChangeProfiles.fire({added:p,removed:_,updated:D,all:this.profiles})}updateWorkspaceAssociation(p,_,D){D=_?.isTransient?!0:D,D||this.updateWorkspaceAssociation(p,void 0,!0);const C=this.getWorkspace(p),S=D?this.transientProfilesObject:this.profilesObject;L.URI.isUri(C)?(S.workspaces.delete(C),_&&S.workspaces.set(C,_)):(S.emptyWindows.delete(C),_&&S.emptyWindows.set(C,_)),D||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const p={};for(const[D,C]of this.profilesObject.workspaces.entries())p[D.toString()]=C.id;const _={};for(const[D,C]of this.profilesObject.emptyWindows.entries())_[D.toString()]=C.id;this.saveStoredProfileAssociations({workspaces:p,emptyWindows:_}),this._profilesObject=void 0}migrateStoredProfileAssociations(p){const _={},D=this.createDefaultProfile();if(p.workspaces)for(const[S,I]of Object.entries(p.workspaces)){const b=L.URI.parse(I);_[S]=this.uriIdentityService.extUri.isEqual(b,D.location)?D.id:this.uriIdentityService.extUri.basename(b)}const C={};if(p.emptyWindows)for(const[S,I]of Object.entries(p.emptyWindows)){const b=L.URI.parse(I);C[S]=this.uriIdentityService.extUri.isEqual(b,D.location)?D.id:this.uriIdentityService.extUri.basename(b)}return{workspaces:_,emptyWindows:C}}getStoredProfiles(){return[]}saveStoredProfiles(p){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(p){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=c,e.UserDataProfilesService=c=Ke([Ve(0,v.IEnvironmentService),Ve(1,l.IFileService),Ve(2,E.IUriIdentityService),Ve(3,y.ILogService)],c);class h extends c{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(p){this.storedProfiles=p}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(p){this.storedProfileAssociations=p}}e.InMemoryUserDataProfilesService=h}),define(we[150],ye([1,0,9,4,3,62,18,208,5,149]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=T,e.isProfileUsingDefaultStorage=a,e.logStorage=f,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var P;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var y;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var d;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function T(m){const n=m.get(e.TARGET_KEY);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class E extends k.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(n={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super(),this.options=n,this._onDidChangeValue=this._register(new g.PauseableEmitter),this._onDidChangeTarget=this._register(new g.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new g.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new r.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(n,s,i){return g.Event.filter(this._onDidChangeValue.event,t=>t.scope===n&&(s===void 0||t.key===s),i)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,r.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(n,s){const{key:i,external:t}=s;if(i===e.TARGET_KEY){switch(n){case y.APPLICATION:this._applicationKeyTargets=void 0;break;case y.PROFILE:this._profileKeyTargets=void 0;break;case y.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:n})}else this._onDidChangeValue.fire({scope:n,key:i,target:this.getKeyTargets(n)[i],external:t})}emitWillSaveState(n){this._onWillSaveState.fire({reason:n})}get(n,s,i){return this.getStorage(s)?.get(n,i)}getBoolean(n,s,i){return this.getStorage(s)?.getBoolean(n,i)}getNumber(n,s,i){return this.getStorage(s)?.getNumber(n,i)}getObject(n,s,i){return this.getStorage(s)?.getObject(n,i)}storeAll(n,s){this.withPausedEmitters(()=>{for(const i of n)this.store(i.key,i.value,i.scope,i.target,s)})}store(n,s,i,t,c=!1){if((0,L.isUndefinedOrNull)(s)){this.remove(n,i,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(n,i,t),this.getStorage(i)?.set(n,s,c)})}remove(n,s,i=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(n,s,void 0),this.getStorage(s)?.delete(n,i)})}withPausedEmitters(n){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{n()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(n,s){const i=[],t=this.getKeyTargets(n);for(const c of Object.keys(t))t[c]===s&&i.push(c);return i}updateKeyTarget(n,s,i,t=!1){const c=this.getKeyTargets(s);typeof i=="number"?c[n]!==i&&(c[n]=i,this.getStorage(s)?.set(e.TARGET_KEY,JSON.stringify(c),t)):typeof c[n]=="number"&&(delete c[n],this.getStorage(s)?.set(e.TARGET_KEY,JSON.stringify(c),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(y.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(y.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(y.APPLICATION)),this._applicationKeyTargets}getKeyTargets(n){switch(n){case y.APPLICATION:return this.applicationKeyTargets;case y.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(n){const s=this.getStorage(n);return s?T(s):Object.create(null)}isNew(n){return this.getBoolean(e.IS_NEW_KEY,n)===!0}async flush(n=P.NONE){this._onWillSaveState.fire({reason:n});const s=this.getStorage(y.APPLICATION),i=this.getStorage(y.PROFILE),t=this.getStorage(y.WORKSPACE);switch(n){case P.NONE:await r.Promises.settled([s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await r.Promises.settled([s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.getStorage(y.APPLICATION)?.items??new Map,s=this.getStorage(y.PROFILE)?.items??new Map,i=this.getStorage(y.WORKSPACE)?.items??new Map;return f(n,s,i,this.getLogDetails(y.APPLICATION)??"",this.getLogDetails(y.PROFILE)??"",this.getLogDetails(y.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.getStorage(n)?.optimize()}async switch(n,s){return this.emitWillSaveState(P.NONE),(0,l.isUserDataProfile)(n)?this.switchToProfile(n,s):this.switchToWorkspace(n,s)}canSwitchProfile(n,s){return!(n.id===s.id||a(s)&&a(n))}switchData(n,s,i){this.withPausedEmitters(()=>{const t=new Set;for(const[c,h]of n)t.add(c),s.get(c)!==h&&this.emitDidChangeValue(i,{key:c,external:!0});for(const[c]of s.items)t.has(c)||this.emitDidChangeValue(i,{key:c,external:!0})})}}e.AbstractStorageService=E;function a(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class u extends E{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(n=>this.emitDidChangeValue(y.WORKSPACE,n))),this._register(this.profileStorage.onDidChangeStorage(n=>this.emitDidChangeValue(y.PROFILE,n))),this._register(this.applicationStorage.onDidChangeStorage(n=>this.emitDidChangeValue(y.APPLICATION,n)))}getStorage(n){switch(n){case y.APPLICATION:return this.applicationStorage;case y.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(n){switch(n){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(n){return!1}}e.InMemoryStorageService=u;async function f(m,n,s,i,t,c){const h=w=>{try{return JSON.parse(w)}catch{return w}},o=new Map,p=new Map;m.forEach((w,N)=>{o.set(N,w),p.set(N,h(w))});const _=new Map,D=new Map;n.forEach((w,N)=>{_.set(N,w),D.set(N,h(w))});const C=new Map,S=new Map;s.forEach((w,N)=>{C.set(N,w),S.set(N,h(w))}),console.group(i!==t?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const I=[];if(o.forEach((w,N)=>{I.push({key:N,value:w})}),console.table(I),console.groupEnd(),console.log(p),i!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const w=[];_.forEach((N,O)=>{w.push({key:O,value:N})}),console.table(w),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${c})`);const b=[];C.forEach((w,N)=>{b.push({key:N,value:w})}),console.table(b),console.groupEnd(),console.log(S)}}),define(we[118],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{static{this.enableDebugLogging=!1}constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const A=this._idPool++;return this._data.set(A,k),this.logDebugInfo(),A}get(k,A){return this._data.has(k)?this._data.get(k)[A]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){r.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r}),define(we[63],ye([1,0,15,23,28,5]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new g.ExtUri(v=>{const l=this._providerInfo.get(v.scheme);return!(l===void 0||l&k.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(v,l){l===null?this._providerInfo.delete(v.scheme):this._providerInfo.set(v.scheme,l)}isFreeScheme(v){return!this._providerInfo.has(v)&&!this._systemSchemes.has(v)}getCapabilities(v){return this._providerInfo.get(v)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,A.createDecorator)("IExtHostFileSystemInfo")}),define(we[30],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(we[296],ye([1,0,236,12,277,30]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends k.LogService{constructor(v,l,P){const y=P.remote.isRemote?"remoteexthost":v?"workerexthost":"exthost",d=P.remote.isRemote?(0,r.localize)(0,null):v?(0,r.localize)(1,null):(0,r.localize)(2,null);super(l.createLogger(y,{name:d}))}};e.ExtHostLogService=L,e.ExtHostLogService=L=Ke([Ve(1,g.ILoggerService),Ve(2,A.IExtHostInitDataService)],L)}),define(we[297],ye([1,0,9]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class g{constructor(L,R,v){this._deferredPromises=new Map,this._id=L,this._shared=R,this._storage=v,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(l=>(this._value=l,this)),this._storageListener=this._storage.onDidChangeStorage(l=>{l.shared===this._shared&&l.key===this._id&&(this._value=l.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const l=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const P of l.values())P.complete()}catch(P){for(const y of l.values())y.error(P)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this._init}get(L,R){let v=this._value[L];return typeof v>"u"&&(v=R),v}update(L,R){this._value[L]=R;const v=this._deferredPromises.get(L);if(v!==void 0)return v.p;const l=new r.DeferredPromise;return this._deferredPromises.set(L,l),this._scheduler.isScheduled()||this._scheduler.schedule(),l.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=g;class k extends g{setKeysForSync(L){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},L)}constructor(L,R){super(L.identifier.value,!0,R),this._extension=L}}e.ExtensionGlobalMemento=k}),define(we[298],ye([1,0,4,2]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class k{constructor(L){this._notebooksAndEditors=L,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new r.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(L,R,v,l){const y=this._notebooksAndEditors.getNotebookDocument(g.URI.revive(L)).acceptModelChanged(R.value,v,l);this._onDidChangeNotebookDocument.fire(y)}$acceptDirtyStateChanged(L,R){this._notebooksAndEditors.getNotebookDocument(g.URI.revive(L)).acceptDirty(R)}$acceptModelSaved(L){const R=this._notebooksAndEditors.getNotebookDocument(g.URI.revive(L));this._onDidSaveNotebookDocument.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=k}),define(we[20],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class g{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=g}),define(we[299],ye([1,0,24,4]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class k{#e;constructor(L,R){this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(L.identifier),this.#e=R,this.#e.onDidChangePassword(v=>{v.extensionId===this._id&&this._onDidChange.fire({key:v.key})})}get(L){return this.#e.get(this._id,L)}store(L,R){return this.#e.store(this._id,L,R)}delete(L){return this.#e.delete(this._id,L)}}e.ExtensionSecrets=k}),define(we[72],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class g{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.URITransformerService=g}),define(we[300],ye([1,0,301,413,414,66,2,12,415]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=P;const l=!1;function P(n,s,i,t,c,h){const o=h.environment.useHostProxy,p=typeof o=="boolean"?o:!h.remote.isRemote,_={resolveProxy:S=>n.resolveProxy(S),lookupProxyAuthorization:u.bind(void 0,t,c,s,{},h.remote.isRemote),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>d(s),addCertificatesV2:()=>T(s),log:t,getLogLevel:()=>{const S=t.getLevel();switch(S){case R.LogLevel.Trace:return v.LogLevel.Trace;case R.LogLevel.Debug:return v.LogLevel.Debug;case R.LogLevel.Info:return v.LogLevel.Info;case R.LogLevel.Warning:return v.LogLevel.Warning;case R.LogLevel.Error:return v.LogLevel.Error;case R.LogLevel.Off:return v.LogLevel.Off;default:return I(S)}function I(b){return t.error("Unknown log level",b),v.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:p,loadAdditionalCertificates:async()=>{const S=[];if(h.remote.isRemote&&S.push((0,v.loadSystemCertificates)({log:t})),p){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const I=n.loadCertificates();I.then(b=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",b.length)),S.push(I)}return(await Promise.all(S)).flat()},env:process.env},D=(0,v.createProxyResolver)(_),C=y(_,D);return a(i,C)}function y(n,s){return{http:Object.assign(r,(0,v.createHttpPatch)(n,r,s)),https:Object.assign(g,(0,v.createHttpPatch)(n,g,s)),net:Object.assign(A,(0,v.createNetPatch)(n,A)),tls:Object.assign(k,(0,v.createTlsPatch)(n,k))}}function d(n){const s=n.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",l)&&!!s.get("systemCertificates")}function T(n){const s=n.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",l)&&!!s.get("systemCertificates")}const E=new Map;function a(n,s){return n.getExtensionPathIndex().then(i=>{const t=globalThis._VSCODE_NODE_MODULES.module,c=t._load;t._load=function(o,p,_){if(o==="net")return s.net;if(o==="tls")return s.tls;if(o!=="http"&&o!=="https")return c.apply(this,arguments);const D=i.findSubstr(L.URI.file(p.filename));let C=E.get(D);if(C||E.set(D,C={}),!C[o]){const S=s[o];C[o]={...S}}return C[o]}})}async function u(n,s,i,t,c,h,o,p){const _=t[h];o&&(t[h]=o),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${o}`,`proxyAuthenticateCache:${_}`);const D=o||_,C=Array.isArray(D)?D:typeof D=="string"?[D]:[];if(m(s,C,c),C.some(S=>/^(Negotiate|Kerberos)( |$)/i.test(S))&&!p.kerberosRequested)try{p.kerberosRequested=!0;const S=await new Promise((O,U)=>{he(["kerberos"],O,U)}),I=new URL(h),b=i.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${I.hostname}`:`HTTP@${I.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${b}`),"Negotiate "+await(await S.initializeClient(b)).step("")}catch(S){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",S)}}let f=!1;function m(n,s,i){f||!s.length||(f=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(t=>t.split(" ")[0]).join(","),extensionHostType:i?"remote":"local"}))}}),define(we[302],ye([1,0,141]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=k;function g(A){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:A,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function k(A){return new r.URITransformer(g(A))}}),define(we[151],ye([1,0,246,18,2,3,5,36,28,15,51,200,43]),function(he,e,r,g,k,A,L,R,v,l,P,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=a,e.isEditorPaneWithScrolling=u,e.findViewStateForEditor=f,e.isResourceEditorInput=m,e.isResourceDiffEditorInput=n,e.isResourceMultiDiffEditorInput=s,e.isResourceSideBySideEditorInput=i,e.isUntitledResourceEditorInput=t,e.isResourceMergeEditorInput=c,e.isEditorInput=C,e.isSideBySideEditorInput=I,e.isDiffEditorInput=b,e.createTooLargeFileError=w,e.isEditorInputWithOptions=N,e.isEditorInputWithOptionsAndGroup=O,e.isEditorIdentifier=U,e.isEditorCommandsContext=x,e.preventEditorClose=$,e.pathsToEditors=ne,e.isTextEditorViewState=re,e.isEditorOpenError=Se,e.createEditorOpenError=ve,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var T;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(T||(e.EditorPaneSelectionChangeReason=T={}));var E;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(E||(e.EditorPaneSelectionCompareResult=E={}));function a(G){const W=G;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function u(G){const W=G;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function f(G,W,se){for(const ae of se.visibleEditorPanes)if(ae.group.id===W&&G.matches(ae.input))return ae.getViewState()}function m(G){if(C(G))return!1;const W=G;return k.URI.isUri(W?.resource)}function n(G){if(C(G))return!1;const W=G;return W?.original!==void 0&&W.modified!==void 0}function s(G){if(C(G))return!1;const W=G;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function i(G){if(C(G)||n(G))return!1;const W=G;return W?.primary!==void 0&&W.secondary!==void 0}function t(G){if(C(G))return!1;const W=G;return W?W.resource===void 0||W.resource.scheme===l.Schemas.untitled||W.forceUntitled===!0:!1}function c(G){if(C(G))return!1;const W=G;return k.URI.isUri(W?.base?.resource)&&k.URI.isUri(W?.input1?.resource)&&k.URI.isUri(W?.input2?.resource)&&k.URI.isUri(W?.result?.resource)}var h;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var o;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class p{constructor(){this.mapIdToSaveSource=new Map}registerSource(W,se){let ae=this.mapIdToSaveSource.get(W);return ae||(ae={source:W,label:se},this.mapIdToSaveSource.set(W,ae)),ae.source}getSourceLabel(W){return this.mapIdToSaveSource.get(W)?.label??W}}e.SaveSourceRegistry=new p;var _;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors",G[G.Scratchpad=512]="Scratchpad"})(_||(e.EditorInputCapabilities=_={}));class D extends A.Disposable{}e.AbstractEditorInput=D;function C(G){return G instanceof D}function S(G){const W=G;return k.URI.isUri(W?.preferredResource)}function I(G){const W=G;return C(W?.primary)&&C(W?.secondary)}function b(G){const W=G;return C(W?.modified)&&C(W?.original)}function w(G,W,se,ae,ie){return ve(ae,[(0,y.toAction)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const le={...se,limits:{size:Number.MAX_VALUE}};G.openEditor(W,le)}}),(0,y.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:d.default.Warning})}function N(G){return C(G?.editor)}function O(G){const W=G;return N(G)&&W?.group!==void 0}function U(G){const W=G;return typeof W?.groupId=="number"&&C(W.editor)}function x(G){return typeof G?.groupId=="number"}var B;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(B||(e.EditorCloseContext=B={}));var F;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LABEL=2]="GROUP_LABEL",G[G.GROUP_LOCKED=3]="GROUP_LOCKED",G[G.EDITORS_SELECTION=4]="EDITORS_SELECTION",G[G.EDITOR_OPEN=5]="EDITOR_OPEN",G[G.EDITOR_CLOSE=6]="EDITOR_CLOSE",G[G.EDITOR_MOVE=7]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=9]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=11]="EDITOR_PIN",G[G.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",G[G.EDITOR_STICKY=13]="EDITOR_STICKY",G[G.EDITOR_DIRTY=14]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var M;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(M||(e.SideBySideEditor=M={}));class K{getOriginalUri(W,se){if(!W)return;if(c(W))return e.EditorResourceAccessor.getOriginalUri(W.result,se);if(se?.supportSideBySide){const{primary:ie,secondary:le}=this.getSideEditors(W);if(ie&&le){if(se?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(ie,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===M.ANY)return this.getOriginalUri(ie,{filterByScheme:se.filterByScheme})??this.getOriginalUri(le,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===M.PRIMARY?ie:le}}if(n(W)||s(W)||i(W)||c(W))return;const ae=S(W)?W.preferredResource:W.resource;return!ae||!se||!se.filterByScheme?ae:this.filterUri(ae,se.filterByScheme)}getSideEditors(W){return I(W)||i(W)?{primary:W.primary,secondary:W.secondary}:b(W)||n(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,se){if(!W)return;if(c(W))return e.EditorResourceAccessor.getCanonicalUri(W.result,se);if(se?.supportSideBySide){const{primary:ie,secondary:le}=this.getSideEditors(W);if(ie&&le){if(se?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(ie,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===M.ANY)return this.getCanonicalUri(ie,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===M.PRIMARY?ie:le}}if(n(W)||s(W)||i(W)||c(W))return;const ae=W.resource;return!ae||!se||!se.filterByScheme?ae:this.filterUri(ae,se.filterByScheme)}filterUri(W,se){if(Array.isArray(se)){if(se.some(ae=>W.scheme===ae))return W}else if(se===W.scheme)return W}}var ee;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.KEYBOARD=1]="KEYBOARD",G[G.MOUSE=2]="MOUSE"})(ee||(e.EditorCloseMethod=ee={}));function $(G,W,se,ae){if(!G.isSticky(W))return!1;switch(ae.preventPinnedEditorClose){case"keyboardAndMouse":return se===ee.MOUSE||se===ee.KEYBOARD;case"mouse":return se===ee.MOUSE;case"keyboard":return se===ee.KEYBOARD}return!1}e.EditorResourceAccessor=new K;var q;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class Z{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(W){const se=this.instantiationService=W.get(L.IInstantiationService);for(const[ae,ie]of this.editorSerializerConstructors)this.createEditorSerializer(ae,ie,se);this.editorSerializerConstructors.clear()}createEditorSerializer(W,se,ae){const ie=ae.createInstance(se);this.editorSerializerInstances.set(W,ie)}registerFileEditorFactory(W){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=W}getFileEditorFactory(){return(0,g.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(W,se){if(this.editorSerializerConstructors.has(W)||this.editorSerializerInstances.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.instantiationService?this.createEditorSerializer(W,se,this.instantiationService):this.editorSerializerConstructors.set(W,se),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(W),this.editorSerializerInstances.delete(W)})}getEditorSerializer(W){return this.editorSerializerInstances.get(typeof W=="string"?W:W.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new Z);async function ne(G,W,se){return!G||!G.length?[]:await Promise.all(G.map(async ae=>{const ie=k.URI.revive(ae.fileUri);if(!ie){se.info("Cannot resolve the path because it is not valid.",ae);return}if(!await W.canHandleResource(ie)){se.info("Cannot resolve the path because it cannot be handled",ae);return}let ue=ae.exists,Y=ae.type;if(typeof ue!="boolean"||typeof Y!="number")try{Y=(await W.stat(ie)).isDirectory?v.FileType.Directory:v.FileType.Unknown,ue=!0}catch(pe){se.error(pe),ue=!1}if(!ue&&ae.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",ae);return}if(Y===v.FileType.Directory){se.info("Cannot resolve the path because it is a directory",ae);return}const oe={...ae.options,pinned:!0};return ue?{resource:ie,options:oe}:{resource:ie,options:oe,forceUntitled:!0}}))}var de;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(de||(e.EditorsOrder=de={}));function re(G){const W=G;if(!W)return!1;const se=W;if(se.modified)return re(se.modified);const ae=W;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}function Se(G){return(0,P.isErrorWithActions)(G)}function ve(G,W,se){const ae=(0,P.createErrorWithActions)(G,W);return ae.forceMessage=se?.forceMessage,ae.forceSeverity=se?.forceSeverity,ae.allowDialog=se?.allowDialog,ae}}),define(we[303],ye([1,0,4,247,5,3,29,36,25,83,292]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=T,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,g.localize)(0,null),e.defaultViewIcon=(0,P.registerIcon)("default-view-icon",l.Codicon.window,(0,g.localize)(1,null));var y;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var d;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(d||(e.ViewContainerLocation=d={})),e.ViewContainerLocations=[d.Sidebar,d.Panel,d.AuxiliaryBar];function T(t){switch(t){case d.Sidebar:return"sidebar";case d.Panel:return"panel";case d.AuxiliaryBar:return"auxiliarybar"}}class E extends A.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new r.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new r.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return[...this.viewContainers.values()].flat()}registerViewContainer(c,h,o){const p=this.get(c.id);if(p)return p;const _=c;return _.openCommandActionDescriptor=o?.doNotRegisterOpenCommand?void 0:_.openCommandActionDescriptor??{id:_.id},(0,L.getOrSet)(this.viewContainers,h,[]).push(_),o?.isDefault&&this.defaultViewContainers.push(_),this._onDidRegister.fire({viewContainer:_,viewContainerLocation:h}),_}deregisterViewContainer(c){for(const h of this.viewContainers.keys()){const o=this.viewContainers.get(h),p=o?.indexOf(c);if(p!==-1){o?.splice(p,1),o.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:h});return}}}get(c){return this.all.filter(h=>h.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(o=>o?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===c)}}R.Registry.add(y.ViewContainersRegistry,new E);var a;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(a||(e.ViewContentGroups=a={}));function u(t,c){const h=t.group??a.More,o=c.group??a.More;return h!==o?h.localeCompare(o):(t.order??5)-(c.order??5)}class f extends A.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new r.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new r.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new r.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new r.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new L.SetMap}registerViews(c,h){this.registerViews2([{views:c,viewContainer:h}])}registerViews2(c){c.forEach(({views:h,viewContainer:o})=>this.addViews(h,o)),this._onViewsRegistered.fire(c)}deregisterViews(c,h){const o=this.removeViews(c,h);o.length&&this._onViewsDeregistered.fire({views:o,viewContainer:h})}moveViews(c,h){for(const o of this._views.keys())if(o!==h){const p=this.removeViews(c,o);p.length&&(this.addViews(p,h),this._onDidChangeContainer.fire({views:p,from:o,to:h}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const h of this._viewContainers){const o=(this._views.get(h)||[]).filter(p=>p.id===c)[0];if(o)return o}return null}getViewContainer(c){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(p=>p.id===c)[0])return h;return null}registerViewWelcomeContent(c,h){return this._viewWelcomeContents.add(c,h),this._onDidChangeViewWelcomeContent.fire(c),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(c,h),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,h){const o=new Map;for(const[p,_]of h)this._viewWelcomeContents.add(c,_),o.set(p,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(c,_),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),o}getViewWelcomeContent(c){const h=[];return this._viewWelcomeContents.forEach(c,o=>h.push(o)),h.sort(u)}addViews(c,h){let o=this._views.get(h);o||(o=[],this._views.set(h,o),this._viewContainers.push(h));for(const p of c){if(this.getView(p.id)!==null)throw new Error((0,g.localize)(2,null,p.id));o.push(p)}}removeViews(c,h){const o=this._views.get(h);if(!o)return[];const p=[],_=[];for(const D of o)c.includes(D)?p.push(D):_.push(D);return p.length&&(_.length?this._views.set(h,_):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),p}}R.Registry.add(y.ViewsRegistry,new f),e.IViewDescriptorService=(0,k.createDecorator)("viewDescriptorService");var m;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(m||(e.ViewVisibilityState=m={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class s{constructor(c,h){this.resolved=!1,this._hasResolve=!1,(0,v.mixin)(this,c),this._hasResolve=!!h,this.resolve=async o=>{if(h&&!this.resolved){const p=await h(o);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}o.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s;class i extends Error{constructor(c){super((0,g.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.NoTreeViewError=i}),define(we[304],ye([1,0,248,35]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_IN_QUICK_CHAT=e.CONTEXT_CHAT_LOCATION=e.CONTEXT_CHAT_INPUT_HAS_AGENT=e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=e.CONTEXT_CHAT_ENABLED=e.CONTEXT_IN_CHAT_SESSION=e.CONTEXT_IN_CHAT_INPUT=e.CONTEXT_CHAT_INPUT_HAS_FOCUS=e.CONTEXT_CHAT_INPUT_HAS_TEXT=e.CONTEXT_CHAT_EDIT_APPLIED=e.CONTEXT_REQUEST=e.CONTEXT_RESPONSE=e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=e.CONTEXT_RESPONSE_FILTERED=e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=e.CONTEXT_RESPONSE_VOTE=void 0,e.CONTEXT_RESPONSE_VOTE=new g.RawContextKey("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(0,null)}),e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=new g.RawContextKey("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(1,null)}),e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=new g.RawContextKey("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(2,null)}),e.CONTEXT_RESPONSE_FILTERED=new g.RawContextKey("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(3,null)}),e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=new g.RawContextKey("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4,null)}),e.CONTEXT_RESPONSE=new g.RawContextKey("chatResponse",!1,{type:"boolean",description:(0,r.localize)(5,null)}),e.CONTEXT_REQUEST=new g.RawContextKey("chatRequest",!1,{type:"boolean",description:(0,r.localize)(6,null)}),e.CONTEXT_CHAT_EDIT_APPLIED=new g.RawContextKey("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(7,null)}),e.CONTEXT_CHAT_INPUT_HAS_TEXT=new g.RawContextKey("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8,null)}),e.CONTEXT_CHAT_INPUT_HAS_FOCUS=new g.RawContextKey("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(9,null)}),e.CONTEXT_IN_CHAT_INPUT=new g.RawContextKey("inChatInput",!1,{type:"boolean",description:(0,r.localize)(10,null)}),e.CONTEXT_IN_CHAT_SESSION=new g.RawContextKey("inChat",!1,{type:"boolean",description:(0,r.localize)(11,null)}),e.CONTEXT_CHAT_ENABLED=new g.RawContextKey("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(12,null)}),e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=new g.RawContextKey("chatCursorAtTop",!1),e.CONTEXT_CHAT_INPUT_HAS_AGENT=new g.RawContextKey("chatInputHasAgent",!1),e.CONTEXT_CHAT_LOCATION=new g.RawContextKey("chatLocation",void 0),e.CONTEXT_IN_QUICK_CHAT=new g.RawContextKey("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(13,null)})}),define(we[305],ye([1,0,131,9,21,4,40,3,57,179,13,35,24,5,12,115,285,150,304]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.ChatAgentNameService=e.IChatAgentNameService=e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0,e.getFullyQualifiedId=h,e.reviveSerializedAgent=o;var s;(function(p){p.Panel="panel",p.Terminal="terminal",p.Notebook="notebook",p.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(p){function _(D){switch(D){case"panel":return p.Panel;case"terminal":return p.Terminal;case"notebook":return p.Notebook;case"editor":return p.Editor}return p.Panel}p.fromRaw=_}(s||(e.ChatAgentLocation=s={})),e.IChatAgentService=(0,T.createDecorator)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(_){this.contextKeyService=_,this._agents=new Map,this._onDidChangeAgents=new A.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event,this._agentCompletionProviders=new Map,this._hasDefaultAgent=m.CONTEXT_CHAT_ENABLED.bindTo(this.contextKeyService)}registerAgent(_,D){if(this.getAgent(_))throw new Error(`Agent already registered: ${JSON.stringify(_)}`);const S=this,I=D.slashCommands;D={...D,get slashCommands(){return I.filter(w=>!w.when||S.contextKeyService.contextMatchesRules(y.ContextKeyExpr.deserialize(w.when)))}};const b={data:D};return this._agents.set(_,b),(0,R.toDisposable)(()=>{this._agents.delete(_),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(_,D){const C=this._agents.get(_);if(!C)throw new Error(`Unknown agent: ${JSON.stringify(_)}`);if(C.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(_)}`);return C.data.isDefault&&this._hasDefaultAgent.set(!0),C.impl=D,this._onDidChangeAgents.fire(new t(C.data,D)),(0,R.toDisposable)(()=>{C.impl=void 0,this._onDidChangeAgents.fire(void 0),C.data.isDefault&&this._hasDefaultAgent.set(!1)})}registerDynamicAgent(_,D){_.isDynamic=!0;const C={data:_,impl:D};return this._agents.set(_.id,C),this._onDidChangeAgents.fire(new t(_,D)),(0,R.toDisposable)(()=>{this._agents.delete(_.id),this._onDidChangeAgents.fire(void 0)})}registerAgentCompletionProvider(_,D){return this._agentCompletionProviders.set(_,D),{dispose:()=>{this._agentCompletionProviders.delete(_)}}}async getAgentCompletionItems(_,D,C){return await this._agentCompletionProviders.get(_)?.(D,C)??[]}updateAgent(_,D){const C=this._agents.get(_);if(!C?.impl)throw new Error(`No activated agent with id ${JSON.stringify(_)} registered`);C.data.metadata={...C.data.metadata,...D},this._onDidChangeAgents.fire(new t(C.data,C.impl))}getDefaultAgent(_){return(0,r.findLast)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(_))}getContributedDefaultAgent(_){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(_))}getSecondaryAgent(){return L.Iterable.find(this._agents.values(),_=>!!_.data.metadata.isSecondary)?.data}getAgent(_){if(this._agentIsEnabled(_))return this._agents.get(_)?.data}_agentIsEnabled(_){const D=this._agents.get(_);return!D?.data.when||this.contextKeyService.contextMatchesRules(y.ContextKeyExpr.deserialize(D.data.when))}getAgentByFullyQualifiedId(_){const D=L.Iterable.find(this._agents.values(),C=>h(C.data)===_)?.data;if(!(D&&!this._agentIsEnabled(D.id)))return D}getAgents(){return Array.from(this._agents.values()).map(_=>_.data).filter(_=>this._agentIsEnabled(_.id))}getActivatedAgents(){return Array.from(this._agents.values()).filter(_=>!!_.impl).filter(_=>this._agentIsEnabled(_.data.id)).map(_=>new t(_.data,_.impl))}getAgentsByName(_){return this.getAgents().filter(D=>D.name===_)}async invokeAgent(_,D,C,S,I){const b=this._agents.get(_);if(!b?.impl)throw new Error(`No activated agent with id "${_}"`);return await b.impl.invoke(D,C,S,I)}async getFollowups(_,D,C,S,I){const b=this._agents.get(_);if(!b?.impl)throw new Error(`No activated agent with id "${_}"`);return b.impl?.provideFollowups?b.impl.provideFollowups(D,C,S,I):[]}};e.ChatAgentService=i,e.ChatAgentService=i=Ke([Ve(0,y.IContextKeyService)],i);class t{constructor(_,D){this.data=_,this.impl=D}get id(){return this.data.id}get name(){return this.data.name??""}get fullName(){return this.data.fullName??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get extensionPublisherId(){return this.data.extensionPublisherId}get extensionPublisherDisplayName(){return this.data.publisherDisplayName}get extensionDisplayName(){return this.data.extensionDisplayName}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get defaultImplicitVariables(){return this.data.defaultImplicitVariables}get locations(){return this.data.locations}async invoke(_,D,C,S){return this.impl.invoke(_,D,C,S)}async provideFollowups(_,D,C,S){return this.impl.provideFollowups?this.impl.provideFollowups(_,D,C,S):[]}provideWelcomeMessage(_,D){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(_,D)}provideSampleQuestions(_,D){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(_,D)}}e.MergedChatAgent=t,e.IChatAgentNameService=(0,T.createDecorator)("chatAgentNameService");let c=class{static{n=this}static{this.StorageKey="chat.participantNameRegistry"}constructor(_,D,C,S){if(this.requestService=D,this.logService=C,this.storageService=S,this.registry=(0,l.observableValue)(this,Object.create(null)),this.disposed=!1,!_.chatParticipantRegistry)return;this.url=_.chatParticipantRegistry;const I=S.get(n.StorageKey,f.StorageScope.APPLICATION);try{this.registry.set(JSON.parse(I??"{}"),void 0)}catch{S.remove(n.StorageKey,f.StorageScope.APPLICATION)}this.refresh()}refresh(){this.disposed||this.update().catch(_=>this.logService.warn("Failed to fetch chat participant registry",_)).then(()=>(0,g.timeout)(5*60*1e3)).then(()=>this.refresh())}async update(){const _=await this.requestService.request({type:"GET",url:this.url},k.CancellationToken.None);if(_.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,u.asJson)(_);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const C=D.restrictedChatParticipants;this.registry.set(C,void 0),this.storageService.store(n.StorageKey,JSON.stringify(C),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}getAgentNameRestriction(_){const D=this.checkAgentNameRestriction(_.name,_).get(),C=!_.fullName||this.checkAgentNameRestriction(_.fullName.replace(/\s/g,""),_).get();return D&&C}checkAgentNameRestriction(_,D){return this.registry.map(S=>S[_.toLowerCase()]).map(S=>S?S.some(I=>(0,P.equalsIgnoreCase)(I,I.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.disposed=!0}};e.ChatAgentNameService=c,e.ChatAgentNameService=c=n=Ke([Ve(0,a.IProductService),Ve(1,u.IRequestService),Ve(2,E.ILogService),Ve(3,f.IStorageService)],c);function h(p){return`${p.extensionId.value}.${p.id}`}function o(p){const _="name"in p?p:{...p,name:p.id};return"extensionPublisherId"in _||(_.extensionPublisherId=_.extensionPublisher??""),"extensionDisplayName"in _||(_.extensionDisplayName=""),"extensionId"in _||(_.extensionId=new d.ExtensionIdentifier("")),(0,v.revive)(_)}}),define(we[306],ye([1,0,2,31,5]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.isIDocumentContext=A,e.isIUsedContext=L;function A(l){return!!l&&typeof l=="object"&&"uri"in l&&l.uri instanceof r.URI&&"version"in l&&typeof l.version=="number"&&"ranges"in l&&Array.isArray(l.ranges)&&l.ranges.every(g.Range.isIRange)}function L(l){return!!l&&typeof l=="object"&&"documents"in l&&Array.isArray(l.documents)&&l.documents.every(A)}var R;(function(l){l[l.Down=0]="Down",l[l.Up=1]="Up"})(R||(e.ChatAgentVoteDirection=R={}));var v;(function(l){l[l.Action=1]="Action",l[l.Toolbar=2]="Toolbar"})(v||(e.ChatCopyKind=v={})),e.IChatService=(0,k.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(we[152],ye([1,0,4,9,250]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(R){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=R}onEvent(R){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=R}onRequest(R){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=R}sendResponse(R){R.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.internalSend("response",R)}sendRequest(R,v,l,P){const y={command:R};if(v&&Object.keys(v).length>0&&(y.arguments=v),this.internalSend("request",y),typeof P=="number"){const d=setTimeout(()=>{clearTimeout(d);const T=this.pendingRequests.get(y.seq);if(T){this.pendingRequests.delete(y.seq);const E={type:"response",seq:0,request_seq:y.seq,success:!1,command:R,message:(0,k.localize)(0,null,P,R)};T(E)}},P)}return l&&this.pendingRequests.set(y.seq,l),y.seq}acceptMessage(R){this.messageCallback?this.messageCallback(R):(this.queue.push(R),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(R,v){return R.type!=="event"||v.type!=="event"}async processQueue(){let R;for(;this.queue.length;){if((!R||this.needsTaskBoundaryBetween(this.queue[0],R))&&await(0,g.timeout)(0),R=this.queue.shift(),!R)return;switch(R.type){case"event":this.eventCallback?.(R);break;case"request":this.requestCallback?.(R);break;case"response":{const v=R,l=this.pendingRequests.get(v.request_seq);l&&(this.pendingRequests.delete(v.request_seq),l(v));break}}}}internalSend(R,v){v.type=R,v.seq=this.sequence++,this.sendMessage(v)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const R=new Map;this.pendingRequests.forEach((v,l)=>R.set(l,v)),await(0,g.timeout)(500),R.forEach((v,l)=>{v({type:"response",seq:0,request_seq:l,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(l)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(we[119],ye([1,0,2,251,35,5]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=v,e.isFrameDeemphasized=P,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new k.RawContextKey("debugType",void 0,{type:"string",description:g.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new k.RawContextKey("debugConfigurationType",void 0,{type:"string",description:g.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new k.RawContextKey("debugState","inactive",{type:"string",description:g.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new k.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:g.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new k.RawContextKey("hasDebugged",!1,{type:"boolean",description:g.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new k.RawContextKey("inDebugMode",!1,{type:"boolean",description:g.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new k.RawContextKey("inDebugRepl",!1,{type:"boolean",description:g.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new k.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:g.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new k.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:g.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new k.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:g.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new k.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:g.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new k.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:g.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new k.RawContextKey("variablesFocused",!0,{type:"boolean",description:g.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new k.RawContextKey("expressionSelected",!1,{type:"boolean",description:g.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new k.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:g.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new k.RawContextKey("callStackItemType",void 0,{type:"string",description:g.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new k.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:g.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new k.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:g.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new k.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:g.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new k.RawContextKey("watchItemType",void 0,{type:"string",description:g.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new k.RawContextKey("canViewMemory",void 0,{type:"boolean",description:g.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new k.RawContextKey("breakpointItemType",void 0,{type:"string",description:g.localize(21,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new k.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:g.localize(22,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new k.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:g.localize(23,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new k.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:g.localize(24,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new k.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:g.localize(25,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new k.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:g.localize(26,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new k.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:g.localize(27,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new k.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:g.localize(28,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new k.RawContextKey("stepBackSupported",!1,{type:"boolean",description:g.localize(29,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new k.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:g.localize(30,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new k.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:g.localize(31,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new k.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:g.localize(32,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new k.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:g.localize(33,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new k.RawContextKey("breakpointsExist",!1,{type:"boolean",description:g.localize(34,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new k.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:g.localize(35,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new k.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:g.localize(36,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new k.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:g.localize(37,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new k.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:g.localize(38,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new k.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:g.localize(39,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new k.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:g.localize(40,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new k.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:g.localize(41,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new k.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:g.localize(42,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new k.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:g.localize(43,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new k.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:g.localize(44,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new k.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:g.localize(45,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new k.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:g.localize(46,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new k.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:g.localize(47,null)}),e.CONTEXT_VARIABLE_VALUE=new k.RawContextKey("variableValue",!1,{type:"string",description:g.localize(48,null)}),e.CONTEXT_VARIABLE_TYPE=new k.RawContextKey("variableType",!1,{type:"string",description:g.localize(49,null)}),e.CONTEXT_VARIABLE_INTERFACES=new k.RawContextKey("variableInterfaces",!1,{type:"array",description:g.localize(50,null)}),e.CONTEXT_VARIABLE_NAME=new k.RawContextKey("variableName",!1,{type:"string",description:g.localize(51,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new k.RawContextKey("variableLanguage",!1,{type:"string",description:g.localize(52,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new k.RawContextKey("variableExtensionId",!1,{type:"string",description:g.localize(53,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new k.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:g.localize(54,null)}),e.CONTEXT_MULTI_SESSION_REPL=new k.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:g.localize(55,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new k.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:g.localize(56,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new k.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:g.localize(57,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new k.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:g.localize(58,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new k.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:g.localize(59,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new k.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:g.localize(60,null)});const L=n=>g.localize(61,null,n);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:g.localize(62,null)};var R;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(R||(e.State=R={}));function v(n){switch(n){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var l;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(l||(e.MemoryRangeType=l={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";function P(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var y;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var d;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(d||(e.DebugConfigurationProviderTriggerKind=d={}));var T;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(T||(e.DebuggerString=T={})),e.IDebugService=(0,A.createDecorator)("debugService");var E;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(E||(e.BreakpointWidgetContext=E={}));var a;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var u;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(u||(e.DebugTreeItemCollapsibleState=u={}));var f;(function(n){n.deserialize=s=>s,n.serialize=s=>s})(f||(e.IDebugVisualizationTreeItem=f={}));var m;(function(n){n.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:r.URI.revive(s.iconPath.light),dark:r.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),n.serialize=s=>s})(m||(e.IDebugVisualization=m={}))}),define(we[307],ye([1,0,13,2,16,25,15,31,21,19]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=y,e.filterExceptionsFromTelemetry=d,e.isSessionAttach=T,e.getExtensionHostDebugSession=E,e.isDebuggerMainContribution=a,e.getExactExpressionStartAndEnd=u,e.getEvaluatableExpressionAtPosition=f,e.isUri=n,e.convertToDAPaths=t,e.convertToVSCPaths=c,e.getVisibleAndSorted=o,e.saveAllBeforeDebugStart=_;const P=/{([^}]+)}/g;function y(C,S,I){return C.replace(P,function(b,w){return S&&w.length>0&&w[0]!=="_"?b:I&&I.hasOwnProperty(w)?I[w]:b})}function d(C){const S={};for(const I of Object.keys(C))I.startsWith("!")||(S[I]=C[I]);return S}function T(C){return C.configuration.request==="attach"&&!E(C)&&(!C.parentSession||T(C.parentSession))}function E(C){let S=C.configuration.type;if(S)return S==="vslsShare"&&(S=C.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(S,"extensionhost")||(0,r.equalsIgnoreCase)(S,"pwa-extensionhost")?C:C.parentSession?E(C.parentSession):void 0}function a(C){return C.type&&(C.label||C.program||C.runtime)}function u(C,S,I){let b,w=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=N.exec(C);){const U=O.index+1,x=U+O[0].length;if(U<=S&&x>=I){b=O[0],w=U;break}}if(b){const U=/\w+/g;let x=null;for(;(x=U.exec(b))&&!(x.index+1+w+x[0].length>=I););x&&(b=b.substring(0,U.lastIndex))}return b?{start:w,end:w+b.length-1}:{start:0,end:0}}async function f(C,S,I,b){if(C.evaluatableExpressionProvider.has(S)){const w=C.evaluatableExpressionProvider.ordered(S),N=(0,l.coalesce)(await Promise.all(w.map(async O=>{try{return await O.provideEvaluatableExpression(S,I,b??v.CancellationToken.None)}catch{return}})));if(N.length>0){let O=N[0].expression;const U=N[0].range;return O||(O=S.getLineContent(I.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:O}}}else{const w=S.getLineContent(I.lineNumber),{start:N,end:O}=u(w,I.column,I.column),U=w.substring(N-1,O);return{matchingExpression:U,range:new R.Range(I.lineNumber,N,I.lineNumber,N+U.length)}}return null}const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(C){return!!(C&&C.match(m))}function s(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(n(C.path))return g.URI.parse(C.path);if((0,k.isAbsolute)(C.path))return g.URI.file(C.path)}return C.path}function i(C){if(typeof C.path=="object"){const S=g.URI.revive(C.path);if(S)return S.scheme===L.Schemas.file?S.fsPath:S.toString()}return C.path}function t(C,S){const I=S?s:i,b=(0,A.deepClone)(C);return h(b,(w,N)=>{w&&N&&(N.path=I(N))}),b}function c(C,S){const I=S?s:i,b=(0,A.deepClone)(C);return h(b,(w,N)=>{!w&&N&&(N.path=I(N))}),b}function h(C,S){switch(C.type){case"event":{const I=C;switch(I.event){case"output":S(!1,I.body.source);break;case"loadedSource":S(!1,I.body.source);break;case"breakpoint":S(!1,I.body.breakpoint.source);break;default:break}break}case"request":{const I=C;switch(I.command){case"setBreakpoints":S(!0,I.arguments.source);break;case"breakpointLocations":S(!0,I.arguments.source);break;case"source":S(!0,I.arguments.source);break;case"gotoTargets":S(!0,I.arguments.source);break;case"launchVSCode":I.arguments.args.forEach(b=>S(!1,b));break;default:break}break}case"response":{const I=C;if(I.success&&I.body)switch(I.command){case"stackTrace":I.body.stackFrames.forEach(b=>S(!1,b.source));break;case"loadedSources":I.body.sources.forEach(b=>S(!1,b));break;case"scopes":I.body.scopes.forEach(b=>S(!1,b.source));break;case"setFunctionBreakpoints":I.body.breakpoints.forEach(b=>S(!1,b.source));break;case"setBreakpoints":I.body.breakpoints.forEach(b=>S(!1,b.source));break;case"disassemble":I.body?.instructions.forEach(w=>S(!1,w.location));break;default:break}break}}}function o(C){return C.filter(S=>!S.presentation?.hidden).sort((S,I)=>S.presentation?I.presentation?S.presentation.group?I.presentation.group?S.presentation.group!==I.presentation.group?S.presentation.group.localeCompare(I.presentation.group):p(S.presentation.order,I.presentation.order):-1:I.presentation.group?1:p(S.presentation.order,I.presentation.order):-1:I.presentation?1:0)}function p(C,S){return typeof C!="number"?typeof S!="number"?0:1:typeof S!="number"?-1:C-S}async function _(C,S){const I=C.getValue("debug.saveBeforeStart",{overrideIdentifier:S.activeTextEditorLanguageId});if(I!=="none"&&(await S.saveAll(),I==="allEditorsInActiveGroup")){const b=S.activeEditorPane;b&&b.input.resource?.scheme===L.Schemas.untitled&&await S.save({editor:b.input,groupId:b.group.id})}await C.reloadConfiguration()}const D=(C,S)=>!C||!S?C===S:C.name===S.name&&C.path===S.path&&C.sourceReference===S.sourceReference;e.sourcesEqual=D}),define(we[308],ye([1,0,59,66,25,16,11,13,34,252,152]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class y extends P.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(f,m){this.outputStream=m,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,f.on("data",n=>this.handleData(n))}sendMessage(f){if(this.outputStream){const m=JSON.stringify(f);this.outputStream.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${y.TWO_CRLF}${m}`,"utf8")}}handleData(f){for(this.rawData=Buffer.concat([this.rawData,f]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const m=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(n){this._onError.fire(new Error((n.message||n)+`
`+m))}continue}}else{const m=this.rawData.indexOf(y.TWO_CRLF);if(m!==-1){const s=this.rawData.toString("utf8",0,m).split(y.HEADER_LINESEPARATOR);for(const i of s){const t=i.split(y.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(m+y.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=y;class d extends y{startSession(){return new Promise((f,m)=>{let n=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),f(),n=!0}),this.socket.on("close",()=>{n?this._onError.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.socket.on("error",s=>{n?this._onError.fire(s):m(s)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=d;class T extends d{constructor(f){super(),this.adapterServer=f}createConnection(f){return g.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",f)}}e.SocketDebugAdapter=T;class E extends d{constructor(f){super(),this.adapterServer=f}createConnection(f){return g.createConnection(this.adapterServer.path,f)}}e.NamedPipeDebugAdapter=E;class a extends y{constructor(f,m){super(),this.adapterExecutable=f,this.debugType=m}async startSession(){const f=this.adapterExecutable.command,m=this.adapterExecutable.args,n=this.adapterExecutable.options||{};try{if(f)if(A.isAbsolute(f)){if(!await v.Promises.exists(f))throw new Error(l.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(l.localize(1,null,this.debugType));let s=process.env;if(n.env&&Object.keys(n.env).length>0&&(s=k.mixin(k.deepClone(process.env),n.env)),f==="node")if(Array.isArray(m)&&m.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:s,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const c=r.fork(m[0],m.slice(1),t);if(!c.pid)throw new Error(l.localize(2,null,m[0]));this.serverProcess=c}else throw new Error(l.localize(3,null));else{const i={env:s};n.cwd&&(i.cwd=n.cwd),this.serverProcess=r.spawn(f,m,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,t)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(s){this._onError.fire(s)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),L.isWindows?new Promise((f,m)=>{const n=r.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(s,i,t){if(s)return m(s)});n.on("exit",f),n.on("error",m)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(f,m){if(!f)return;const n=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?n.runtime=A.join(m,f.runtime):n.runtime=f.runtime),f.runtimeArgs&&(n.runtimeArgs=f.runtimeArgs),f.program&&(A.isAbsolute(f.program)?n.program=f.program:n.program=A.join(m,f.program)),f.args&&(n.args=f.args);const s=f;return s.win&&(n.win=a.extract(s.win,m)),s.winx86&&(n.winx86=a.extract(s.winx86,m)),s.windows&&(n.windows=a.extract(s.windows,m)),s.osx&&(n.osx=a.extract(s.osx,m)),s.linux&&(n.linux=a.extract(s.linux,m)),n}static platformAdapterExecutable(f,m){let n=Object.create(null);m=m.toLowerCase();for(const o of f)if(o.contributes){const p=o.contributes.debuggers;p&&p.length>0&&p.filter(_=>typeof _.type=="string"&&R.equalsIgnoreCase(_.type,m)).forEach(_=>{const D=a.extract(_,o.extensionLocation.fsPath);n=k.mixin(n,D,o.isBuiltin)})}let s;L.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=n.winx86||n.win||n.windows:L.isWindows?s=n.win||n.windows:L.isMacintosh?s=n.osx:L.isLinux&&(s=n.linux),s=s||n;const i=s.program||n.program,t=s.args||n.args,c=s.runtime||n.runtime,h=s.runtimeArgs||n.runtimeArgs;if(c)return{type:"executable",command:c,args:(h||[]).concat(typeof i=="string"?[i]:[]).concat(t||[])};if(i)return{type:"executable",command:i,args:t||[]}}}e.ExecutableDebugAdapter=a}),define(we[309],ye([1,0,59,33,11]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasChildProcesses=L,e.prepareCommand=v;function A(l,P){return new Promise((y,d)=>{let T="";const E=r.spawn(l,P);E.pid&&E.stdout.on("data",a=>{T+=a.toString()}),E.on("error",a=>{d(a)}),E.on("close",a=>{y(T)})})}async function L(l){if(l)if(k.isWindows){const P=await new Promise((y,d)=>{he(["@vscode/windows-process-tree"],y,d)});return new Promise(y=>{P.getProcessTree(l,d=>{y(!!d&&d.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(l)]).then(P=>{const y=P.trim();return!(y.length===0||y.indexOf(" tmux")>=0)},P=>!0);return Promise.resolve(!0)}var R;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(R||(R={}));function v(l,P,y,d,T){l=l.trim().toLowerCase();let E;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?E=R.powershell:l.indexOf("cmd.exe")>=0?E=R.cmd:l.indexOf("bash")>=0?E=R.bash:k.isWindows?E=R.cmd:E=R.bash;let a,u=" ";switch(E){case R.powershell:if(a=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),d){const f=(0,g.getDriveLetter)(d);f&&(u+=`${f}:; `),u+=`cd ${a(d)}; `}if(T)for(const f in T){const m=T[f];m===null?u+=`Remove-Item env:${f}; `:u+=`\${env:${f}}='${m}'; `}if(P.length>0){const f=P.shift(),m=y?f:a(f);u+=m[0]==="'"?`& ${m} `:`${m} `;for(const n of P)u+=n==="<"||n===">"||y?n:a(n),u+=" "}break;case R.cmd:if(a=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(m=>f.includes(m))||f.length===0?`"${f}"`:f),d){const f=(0,g.getDriveLetter)(d);f&&(u+=`${f}: && `),u+=`cd ${a(d)} && `}if(T){u+='cmd /C "';for(const f in T){let m=T[f];m===null?u+=`set "${f}=" && `:(m=m.replace(/[&^|<>]/g,n=>`^${n}`),u+=`set "${f}=${m}" && `)}}for(const f of P)u+=f==="<"||f===">"||y?f:a(f),u+=" ";T&&(u+='"');break;case R.bash:{a=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m);const f=m=>/[^\w@%\/+=,.:^-]/.test(m)?`'${m.replace(/'/g,"'\\''")}'`:m;if(d&&(u+=`cd ${a(d)} ; `),T){u+="/usr/bin/env";for(const m in T){const n=T[m];n===null?u+=` -u ${f(m)}`:u+=` ${f(`${m}=${n}`)}`}u+=" "}for(const m of P)u+=m==="<"||m===">"||y?m:a(m),u+=" ";break}}return u}}),define(we[310],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var g;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(g||(e.CellExecutionUpdateType=g={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(we[311],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var g;(function(k){k[k.Disconnected=1]="Disconnected",k[k.Connected=2]="Connected",k[k.Initializing=3]="Initializing"})(g||(e.ProxyKernelState=g={})),e.INotebookKernelService=(0,r.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,r.createDecorator)("INotebookKernelHistoryService")}),define(we[312],ye([1,0,3,31,55,213,106]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class R extends r.Disposable{constructor(l,P,y){super(),this._source=l,this._inputTextBuffer=P,this._outputs=y,this._outputTextBuffers=void 0}_getFullModelRange(l){const P=l.getLineCount();return new g.Range(1,1,P,this._getLineMaxColumn(l,P))}_getLineMaxColumn(l,P){if(P<1||P>l.getLineCount())throw new Error("Illegal value for lineNumber");return l.getLineLength(P)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const l=new A.PieceTreeTextBufferBuilder;l.acceptChunk(this._source);const P=l.finish(!0),{textBuffer:y,disposable:d}=P.create(k.DefaultEndOfLine.LF);this._inputTextBuffer=y,this._register(d)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(l=>{const P=new A.PieceTreeTextBufferBuilder;P.acceptChunk(l);const y=P.finish(!0),{textBuffer:d,disposable:T}=y.create(k.DefaultEndOfLine.LF);return this._register(T),d})),this._outputTextBuffers}findInInputs(l){const y=new L.SearchParams(l,!1,!1,null).parseSearchRequest();if(!y)return[];const d=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(d,y,!0,5e3)}findInOutputs(l){const y=new L.SearchParams(l,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(d=>{const T=d.findMatchesLineByLine(this._getFullModelRange(d),y,!0,5e3);if(T.length!==0)return{textBuffer:d,matches:T}}).filter(d=>!!d):[]}}e.CellSearchModel=R}),define(we[73],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(A){A.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var g;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(g||(e.TestPosition=g={}));class k{static fromExtHostTestItem(L,R,v=L.parent){if(L._isRoot)return new k([R]);const l=[L.id];for(let P=v;P&&P.id!==R;P=P.parent)l.push(P.id);return l.push(R),new k(l.reverse())}static isRoot(L){return!L.includes(r.Delimiter)}static root(L){const R=L.indexOf(r.Delimiter);return R===-1?L:L.slice(0,R)}static fromString(L){return new k(L.split(r.Delimiter))}static join(L,R){return new k([...L.path,R])}static joinToString(L,R){return L.toString()+r.Delimiter+R}static parentId(L){const R=L.lastIndexOf(r.Delimiter);return R===-1?void 0:L.slice(0,R)}static localId(L){const R=L.lastIndexOf(r.Delimiter);return R===-1?L:L.slice(R+r.Delimiter.length)}static isChild(L,R){return R.startsWith(L)&&R[L.length]===r.Delimiter}static compare(L,R){return L===R?g.IsSame:k.isChild(L,R)?g.IsChild:k.isChild(R,L)?g.IsParent:g.Disconnected}static getLengthOfCommonPrefix(L,R){if(L===0)return 0;let v=0;for(;v<L-1;){for(let l=1;l<L;l++){const P=R(l-1),y=R(l);if(P.path[v]!==y.path[v])return v}v++}return v}constructor(L,R=L.length){if(this.path=L,this.viewEnd=R,L.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new k(this.path,1)}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let L=1;L<=this.viewEnd;L++)yield new k(this.path,L)}*idsToRoot(){for(let L=this.viewEnd;L>0;L--)yield new k(this.path,L)}compare(L){if(typeof L=="string")return k.compare(this.toString(),L);for(let R=0;R<L.viewEnd&&R<this.viewEnd;R++)if(L.path[R]!==this.path[R])return g.Disconnected;return L.viewEnd>this.viewEnd?g.IsChild:L.viewEnd<this.viewEnd?g.IsParent:g.IsSame}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let L=1;L<this.viewEnd;L++)this.stringifed+=r.Delimiter,this.stringifed+=this.path[L]}return this.stringifed}}e.TestId=k}),define(we[74],ye([1,0,2,54,31,73]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var L;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.testResultStateToContextValues={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var R;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var v;(function(B){B[B.Run=2]="Run",B[B.Debug=4]="Debug",B[B.Coverage=8]="Coverage",B[B.HasNonDefaultProfile=16]="HasNonDefaultProfile",B[B.HasConfigurable=32]="HasConfigurable",B[B.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.testRunProfileBitsetList=[v.Run,v.Debug,v.Coverage,v.HasNonDefaultProfile,v.HasConfigurable,v.SupportsContinuousRun];const l=B=>"runId"in B;e.isStartControllerTests=l;var P;(function(B){B.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),B.deserialize=(F,M)=>({range:k.Range.lift(M.range),uri:F.asCanonicalUri(r.URI.revive(M.uri))})})(P||(e.IRichLocation=P={}));var y;(function(B){B[B.Error=0]="Error",B[B.Output=1]="Output"})(y||(e.TestMessageType=y={}));var d;(function(B){B.serialize=F=>({message:F.message,type:y.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&P.serialize(F.location)}),B.deserialize=(F,M)=>({message:M.message,type:y.Error,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&P.deserialize(F,M.location)})})(d||(e.ITestErrorMessage=d={}));const T=(B,F)=>`${F?"s":"e"}${B}`;e.getMarkId=T;var E;(function(B){B.serialize=F=>({message:F.message,type:y.Output,offset:F.offset,length:F.length,location:F.location&&P.serialize(F.location)}),B.deserialize=(F,M)=>({message:M.message,type:y.Output,offset:M.offset,length:M.length,location:M.location&&P.deserialize(F,M.location)})})(E||(e.ITestOutputMessage=E={}));var a;(function(B){B.serialize=F=>F.type===y.Error?d.serialize(F):E.serialize(F),B.deserialize=(F,M)=>M.type===y.Error?d.deserialize(F,M):E.deserialize(F,M)})(a||(e.ITestMessage=a={}));var u;(function(B){B.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),B.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(a.serialize)}),B.deserialize=(F,M)=>({state:M.state,duration:M.duration,messages:M.messages.map(K=>a.deserialize(F,K))})})(u||(e.ITestTaskState=u={}));const f="\0",m=(B,F)=>B+f+F;e.namespaceTestTag=m;const n=B=>{const F=B.indexOf(f);return{ctrlId:B.slice(0,F),tagId:B.slice(F+1)}};e.denamespaceTestTag=n;var s;(function(B){B.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),B.deserialize=(F,M)=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?F.asCanonicalUri(r.URI.revive(M.uri)):void 0,range:M.range?k.Range.lift(M.range):null,description:M.description,error:M.error,sortText:M.sortText})})(s||(e.ITestItem=s={}));var i;(function(B){B[B.NotExpandable=0]="NotExpandable",B[B.Expandable=1]="Expandable",B[B.BusyExpanding=2]="BusyExpanding",B[B.Expanded=3]="Expanded"})(i||(e.TestItemExpandState=i={}));var t;(function(B){B.serialize=F=>({expand:F.expand,item:s.serialize(F.item)}),B.deserialize=(F,M)=>({controllerId:A.TestId.root(M.item.extId),expand:M.expand,item:s.deserialize(F,M.item)})})(t||(e.InternalTestItem=t={}));var c;(function(B){B.serialize=F=>{let M;return F.item&&(M={},F.item.label!==void 0&&(M.label=F.item.label),F.item.tags!==void 0&&(M.tags=F.item.tags),F.item.busy!==void 0&&(M.busy=F.item.busy),F.item.uri!==void 0&&(M.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(M.range=F.item.range?.toJSON()),F.item.description!==void 0&&(M.description=F.item.description),F.item.error!==void 0&&(M.error=F.item.error),F.item.sortText!==void 0&&(M.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:M}},B.deserialize=F=>{let M;return F.item&&(M={},F.item.label!==void 0&&(M.label=F.item.label),F.item.tags!==void 0&&(M.tags=F.item.tags),F.item.busy!==void 0&&(M.busy=F.item.busy),F.item.range!==void 0&&(M.range=F.item.range?k.Range.lift(F.item.range):null),F.item.description!==void 0&&(M.description=F.item.description),F.item.error!==void 0&&(M.error=F.item.error),F.item.sortText!==void 0&&(M.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:M}}})(c||(e.ITestItemUpdate=c={}));const h=(B,F)=>{F.expand!==void 0&&(B.expand=F.expand),F.item!==void 0&&(B.item=B.item?Object.assign(B.item,F.item):F.item)};e.applyTestItemUpdate=h;var o;(function(B){B.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(u.serializeWithoutMessages)}),B.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(u.serialize)}),B.deserialize=(F,M)=>({...t.deserialize(F,M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(K=>u.deserialize(F,K)),retired:!0})})(o||(e.TestResultItem=o={}));var p;(function(B){B.empty=()=>({covered:0,total:0}),B.sum=(F,M)=>{F.covered+=M.covered,F.total+=M.total}})(p||(e.ICoverageCount=p={}));var _;(function(B){B.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testId:F.testId?.toString(),uri:F.uri.toJSON()}),B.deserialize=(F,M)=>({id:M.id,statement:M.statement,branch:M.branch,declaration:M.declaration,testId:M.testId?A.TestId.fromString(M.testId):void 0,uri:F.asCanonicalUri(r.URI.revive(M.uri))}),B.empty=(F,M)=>({id:F,uri:M,testId:void 0,statement:p.empty()})})(_||(e.IFileCoverage=_={}));function D(B){return{...B,location:B.location?.toJSON()}}function C(B){return B.location=B.location?g.Position.isIPosition(B.location)?g.Position.lift(B.location):k.Range.lift(B.location):void 0,B}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var S;(function(B){B[B.Declaration=0]="Declaration",B[B.Statement=1]="Statement",B[B.Branch=2]="Branch"})(S||(e.DetailType=S={}));var I;(function(B){B.serialize=F=>F.type===S.Declaration?w.serialize(F):N.serialize(F),B.deserialize=F=>F.type===S.Declaration?w.deserialize(F):N.deserialize(F)})(I||(e.CoverageDetails=I={}));var b;(function(B){B.serialize=D,B.deserialize=C})(b||(e.IBranchCoverage=b={}));var w;(function(B){B.serialize=D,B.deserialize=C})(w||(e.IDeclarationCoverage=w={}));var N;(function(B){B.serialize=F=>({...D(F),branches:F.branches?.map(b.serialize)}),B.deserialize=F=>({...C(F),branches:F.branches?.map(b.deserialize)})})(N||(e.IStatementCoverage=N={}));var O;(function(B){B[B.Add=0]="Add",B[B.Update=1]="Update",B[B.DocumentSynced=2]="DocumentSynced",B[B.Remove=3]="Remove",B[B.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",B[B.Retire=5]="Retire",B[B.AddTag=6]="AddTag",B[B.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var U;(function(B){B.deserialize=(F,M)=>M.op===O.Add?{op:M.op,item:t.deserialize(F,M.item)}:M.op===O.Update?{op:M.op,item:c.deserialize(M.item)}:M.op===O.DocumentSynced?{op:M.op,uri:F.asCanonicalUri(r.URI.revive(M.uri)),docv:M.docv}:M,B.serialize=F=>F.op===O.Add?{op:F.op,item:t.serialize(F.item)}:F.op===O.Update?{op:F.op,item:c.serialize(F.item)}:F})(U||(e.TestsDiffOp=U={}));class x{constructor(F){this.uriIdentity=F,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(F){const M=this.createChangeCollector();for(const K of F)switch(K.op){case O.Add:this.add(t.deserialize(this.uriIdentity,K.item),M);break;case O.Update:this.update(c.deserialize(K.item),M);break;case O.Remove:this.remove(K.itemId,M);break;case O.Retire:this.retireTest(K.itemId);break;case O.IncrementPendingExtHosts:this.updatePendingRoots(K.amount);break;case O.AddTag:this._tags.set(K.tag.id,K.tag);break;case O.RemoveTag:this._tags.delete(K.id);break}M.complete?.()}add(F,M){const K=A.TestId.parentId(F.item.extId)?.toString();let ee;if(!K)ee=this.createItem(F),this.roots.add(ee),this.items.set(F.item.extId,ee);else if(this.items.has(K)){const $=this.items.get(K);$.children.add(F.item.extId),ee=this.createItem(F,$),this.items.set(F.item.extId,ee)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return M.add?.(ee),F.expand===i.BusyExpanding&&this.busyControllerCount++,ee}update(F,M){const K=this.items.get(F.extId);if(K)return F.expand!==void 0&&(K.expand===i.BusyExpanding&&this.busyControllerCount--,F.expand===i.BusyExpanding&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(K,F),M.update?.(K),K}remove(F,M){const K=this.items.get(F);if(!K)return;const ee=A.TestId.parentId(K.item.extId)?.toString();ee?this.items.get(ee).children.delete(K.item.extId):this.roots.delete(K);const $=[[F]];for(;$.length;)for(const q of $.pop()){const Z=this.items.get(q);Z&&($.push(Z.children),this.items.delete(q),M.remove?.(Z,Z!==K),Z.expand===i.BusyExpanding&&this.busyControllerCount--)}}retireTest(F){}updatePendingRoots(F){this.pendingRootCount+=F}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=x}),define(we[313],ye([1,0,135,255,74]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.testConfigurationGroupNames=e.labelForTestInState=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var A;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(A||(e.Testing=A={}));var L;(function(y){y.List="list",y.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var R;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(R||(e.TestExplorerViewSorting=R={}));const v={[k.TestResultState.Errored]:(0,g.localize)(0,null),[k.TestResultState.Failed]:(0,g.localize)(1,null),[k.TestResultState.Passed]:(0,g.localize)(2,null),[k.TestResultState.Queued]:(0,g.localize)(3,null),[k.TestResultState.Running]:(0,g.localize)(4,null),[k.TestResultState.Skipped]:(0,g.localize)(5,null),[k.TestResultState.Unset]:(0,g.localize)(6,null)},l=(y,d)=>(0,g.localize)(7,null,(0,r.stripIcons)(y),v[d]);e.labelForTestInState=l,e.testConfigurationGroupNames={[k.TestRunProfileBitset.Debug]:(0,g.localize)(8,null),[k.TestRunProfileBitset.Run]:(0,g.localize)(9,null),[k.TestRunProfileBitset.Coverage]:(0,g.localize)(10,null)};var P;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(P||(e.TestCommandId=P={}))}),define(we[120],ye([1,0,9,4,3,65,74,73]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const l=(m,n)=>m===n,y=Object.entries({range:(m,n)=>m===n?!0:!m||!n?!1:m.equalsRange(n),busy:l,label:l,description:l,error:l,sortText:l,tags:(m,n)=>!(m.length!==n.length||m.some(s=>!n.includes(s)))}),d=(m,n)=>{let s;for(const[i,t]of y)t(m[i],n[i])||(s?s[i]=n[i]:s={[i]:n[i]});return s};class T extends k.Disposable{get root(){return this.options.root}constructor(n){super(),this.options=n,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new g.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const s of this.tree.values())this.updateExpandability(s)}get resolveHandler(){return this._resolveHandler}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){switch(n.op){case L.TestDiffOpType.DocumentSynced:{for(const s of this.diff)if(s.op===L.TestDiffOpType.DocumentSynced&&s.uri===n.uri){s.docv=n.docv;return}break}case L.TestDiffOpType.Update:{const s=this.diff[this.diff.length-1];if(s){if(s.op===L.TestDiffOpType.Update&&s.item.extId===n.item.extId){(0,L.applyTestItemUpdate)(s.item,n.item);return}if(s.op===L.TestDiffOpType.Add&&s.item.item.extId===n.item.extId){(0,L.applyTestItemUpdate)(s.item,n.item);return}}break}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,s){const i=this.tree.get(n);if(i){if((i.expandLevels===void 0||s>i.expandLevels)&&(i.expandLevels=s),i.expand===L.TestItemExpandState.Expandable){const t=this.resolveChildren(i);return t.isOpen()?this.expandChildren(i,s-1):t.wait().then(()=>this.expandChildren(i,s-1))}else if(i.expand===L.TestItemExpandState.Expanded)return i.resolveBarrier?.isOpen()===!1?i.resolveBarrier.wait().then(()=>this.expandChildren(i,s-1)):this.expandChildren(i,s-1)}}dispose(){for(const n of this.tree.values())this.options.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,s){switch(s.op){case v.RemoveChild:this.removeItem(R.TestId.joinToString(n.fullId,s.id));break;case v.Upsert:this.upsertItem(s.item,n);break;case v.Bulk:for(const i of s.ops)this.onTestItemEvent(n,i);break;case v.SetTags:this.diffTagRefs(s.new,s.old,n.fullId.toString());break;case v.UpdateCanResolveChildren:this.updateExpandability(n);break;case v.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:s.update}});break;case v.DocumentSynced:this.documentSynced(n.actual.uri);break;default:(0,A.assertNever)(s)}}documentSynced(n){n&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:n,docv:this.options.getDocumentVersion(n)})}upsertItem(n,s){const i=R.TestId.fromExtHostTestItem(n,this.root.id,s?.actual),t=this.options.getApiFor(n);t.parent&&t.parent!==s?.actual&&this.options.getChildren(t.parent).delete(n.id);let c=this.tree.get(i.toString());if(!c){c={fullId:i,actual:n,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(c.fullId.toString(),c),this.setItemParent(n,s),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.options.controllerId,expand:c.expand,item:this.options.toITestItem(n)}}),this.connectItemAndChildren(n,c,s);return}if(c.actual===n){this.connectItem(n,c,s);return}if(c.actual.uri?.toString()!==n.uri?.toString())return this.removeItem(i.toString()),this.upsertItem(n,s);const h=this.options.getChildren(c.actual),o=c.actual,p=d(this.options.toITestItem(o),this.options.toITestItem(n));this.options.getApiFor(o).listener=void 0,c.actual=n,c.resolveBarrier=void 0,c.expand=L.TestItemExpandState.NotExpandable,p&&(p.hasOwnProperty("tags")&&(this.diffTagRefs(n.tags,o.tags,i.toString()),delete p.tags),this.onTestItemEvent(c,{op:v.SetProp,update:p})),this.connectItemAndChildren(n,c,s);for(const[D,C]of h)this.options.getChildren(n).get(C.id)||this.removeItem(R.TestId.joinToString(i,C.id));const _=c.expandLevels;_!==void 0&&queueMicrotask(()=>{c.expand===L.TestItemExpandState.Expandable&&(c.expandLevels=void 0,this.expand(i.toString(),_))}),this.documentSynced(c.actual.uri)}diffTagRefs(n,s,i){const t=new Set(s.map(c=>c.id));for(const c of n)t.delete(c.id)||this.incrementTagRefs(c);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i,item:{tags:n.map(c=>(0,L.namespaceTestTag)(this.options.controllerId,c.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const s=this.tags.get(n.id);s?s.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.namespaceTestTag)(this.options.controllerId,n.id)}}))}decrementTagRefs(n){const s=this.tags.get(n);s&&!--s.refCount&&(this.tags.delete(n),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.namespaceTestTag)(this.options.controllerId,n)}))}setItemParent(n,s){this.options.getApiFor(n).parent=s&&s.actual!==this.root?s.actual:void 0}connectItem(n,s,i){this.setItemParent(n,i);const t=this.options.getApiFor(n);t.parent=i?.actual,t.listener=c=>this.onTestItemEvent(s,c),this.updateExpandability(s)}connectItemAndChildren(n,s,i){this.connectItem(n,s,i);for(const[t,c]of this.options.getChildren(n))this.upsertItem(c,s)}updateExpandability(n){let s;this._resolveHandler?n.resolveBarrier?s=n.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:s=n.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:s=L.TestItemExpandState.NotExpandable,s!==n.expand&&(n.expand=s,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:s}}),s===L.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,s){if(s<0)return;const i=[];for(const[t,c]of this.options.getChildren(n.actual)){const h=this.expand(R.TestId.joinToString(n.fullId,c.id),s);(0,r.isThenable)(h)&&i.push(h)}if(i.length)return Promise.all(i).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const c=new r.Barrier;return c.open(),c}n.expand=L.TestItemExpandState.BusyExpanding,this.pushExpandStateUpdate(n);const s=n.resolveBarrier=new r.Barrier,i=c=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,c)};let t;try{t=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(c){i(c)}return(0,r.isThenable)(t)?t.catch(i).then(()=>{s.open(),this.updateExpandability(n)}):(s.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}removeItem(n){const s=this.tree.get(n);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:n});const i=[s];for(;i.length;){const t=i.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const c of t.actual.tags)this.decrementTagRefs(c.id);this.tree.delete(t.fullId.toString());for(const[c,h]of this.options.getChildren(t.actual))i.push(this.tree.get(R.TestId.joinToString(t.fullId,h.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.TestItemCollection=T;class E extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.DuplicateTestItemError=E;class a extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=a;class u extends Error{constructor(n,s,i){super(`TestItem with ID "${n}" is from controller "${s}" and cannot be added as a child of an item from controller "${i}".`)}}e.MixedTestItemController=u;const f=(m,n,s)=>{let i=new Map;return{get size(){return i.size},forEach(t,c){for(const h of i.values())t.call(c,h,this)},[Symbol.iterator](){return i.entries()},replace(t){const c=new Map,h=new Set(i.keys()),o={op:v.Bulk,ops:[]};for(const p of t){if(!(p instanceof s))throw new a(p.id);const _=n(p).controllerId;if(_!==m.controllerId)throw new u(p.id,_,m.controllerId);if(c.has(p.id))throw new E(p.id);c.set(p.id,p),h.delete(p.id),o.ops.push({op:v.Upsert,item:p})}for(const p of h.keys())o.ops.push({op:v.RemoveChild,id:p});m.listener?.(o),i=c},add(t){if(!(t instanceof s))throw new a(t.id);i.set(t.id,t),m.listener?.({op:v.Upsert,item:t})},delete(t){i.delete(t)&&m.listener?.({op:v.RemoveChild,id:t})},get(t){return i.get(t)},toJSON(){return Array.from(i.values())}}};e.createTestItemChildren=f}),define(we[153],ye([1,0,120]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const g=new WeakMap,k=(L,R)=>{const v={controllerId:R};return g.set(L,v),v};e.createPrivateApiFor=k;const A=L=>{const R=g.get(L);if(!R)throw new r.InvalidTestItemError(L?.id||"<unknown>");return R};e.getPrivateApiFor=A}),define(we[121],ye([1,0,27,15,2]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=A,e.decodeAuthority=R,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function A(v,l){return v.scheme===g.Schemas.http||v.scheme===g.Schemas.https?v:(l&&l.authority&&l.isRemote&&v.scheme===g.Schemas.file&&(v=k.URI.from({scheme:g.Schemas.vscodeRemote,authority:l.authority,path:v.path})),k.URI.from({scheme:g.Schemas.https,authority:`${v.scheme}+${L(v.authority)}.${e.webviewRootResourceAuthority}`,path:v.path,fragment:v.fragment,query:v.query}))}function L(v){return v.replace(/./g,l=>{const P=l.charCodeAt(0);return P>=r.CharCode.a&&P<=r.CharCode.z||P>=r.CharCode.A&&P<=r.CharCode.Z||P>=r.CharCode.Digit0&&P<=r.CharCode.Digit9?l:"-"+P.toString(16).padStart(4,"0")})}function R(v){return v.replace(/-([0-9a-f]{4})/g,(l,P)=>String.fromCharCode(parseInt(P,16)))}}),define(we[314],ye([1,0,4,3,121]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(R,v,l){this._proxy=R,this._editors=v,this._remoteInfo=l,this._handlePool=0,this._disposables=new g.DisposableStore,this._insets=new Map,this._disposables.add(v.onDidChangeVisibleTextEditors(()=>{const P=v.getVisibleTextEditors();for(const y of this._insets.values())P.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(R=>R.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(R,v,l,P,y){let d;for(const n of this._editors.getVisibleTextEditors(!0))if(n.value===R){d=n;break}if(!d)throw new Error("not a visible editor");const T=this,E=this._handlePool++,a=new r.Emitter,u=new r.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(n){return(0,k.asWebviewUri)(n,T._remoteInfo)}get cspSource(){return k.webviewGenericCspSource}set options(n){this._options=n,T._proxy.$setOptions(E,n)}get options(){return this._options}set html(n){this._html=n,T._proxy.$setHtml(E,n)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(n){return T._proxy.$postMessage(E,n)}},m=new class{constructor(){this.editor=R,this.line=v,this.height=l,this.webview=f,this.onDidDispose=u.event}dispose(){T._insets.has(E)&&(T._insets.delete(E),T._proxy.$disposeEditorInset(E),u.fire(),u.dispose(),a.dispose())}};return this._proxy.$createEditorInset(E,d.id,d.value.document.uri,v+1,l,P||{},y.identifier,y.extensionLocation),this._insets.set(E,{editor:R,inset:m,onDidReceiveMessage:a}),m}$onDidDispose(R){const v=this._insets.get(R);v&&v.inset.dispose()}$onDidReceiveMessage(R,v){this._insets.get(R)?.onDidReceiveMessage.fire(v)}}e.ExtHostEditorInsets=A}),define(we[154],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,r.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,r.createDecorator)("IAuthenticationExtensionsService")}),define(we[315],ye([1,0,5]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,r.createDecorator)("configurationResolverService");var g;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(g||(e.VariableKind=g={}));class k extends Error{constructor(L,R){super(R),this.variable=L}}e.VariableError=k}),define(we[316],ye([1,0,16,56,18,25,11,109,256,315,13]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(T,E,a,u){this._contributedVariables=new Map,this._context=T,this._labelService=E,this._userHomePromise=a,u&&(this._envVariablesPromise=u.then(f=>this.prepareEnv(f)))}prepareEnv(T){if(L.isWindows){const E=Object.create(null);return Object.keys(T).forEach(a=>{E[a.toLowerCase()]=T[a]}),E}return T}resolveWithEnvironment(T,E,a){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},E?E.uri:void 0,a)}async resolveAsync(T,E){const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,T?T.uri:void 0,E)}async resolveAnyBase(T,E,a,u){const f=A.deepClone(E);L.isWindows&&f.windows?Object.keys(f.windows).forEach(n=>f[n]=f.windows[n]):L.isMacintosh&&f.osx?Object.keys(f.osx).forEach(n=>f[n]=f.osx[n]):L.isLinux&&f.linux&&Object.keys(f.linux).forEach(n=>f[n]=f.linux[n]),delete f.windows,delete f.osx,delete f.linux;const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,T?T.uri:void 0,f,a,u)}async resolveAnyAsync(T,E,a){return this.resolveAnyBase(T,E,a)}async resolveAnyMap(T,E,a){const u=new Map;return{newConfig:await this.resolveAnyBase(T,E,a,u),resolvedVariables:u}}resolveWithInteractionReplace(T,E,a,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,E,a,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,E){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,E)}async recursiveResolve(T,E,a,u,f){if(k.isString(a))return this.resolveString(T,E,a,u,f);if(Array.isArray(a))return Promise.all(a.map(m=>this.recursiveResolve(T,E,m,u,f)));if(k.isObject(a)){const m=Object.create(null),n=await Promise.all(Object.keys(a).map(async s=>[await this.resolveString(T,E,s,u,f),await this.recursiveResolve(T,E,a[s],u,f)]));for(const[s,i]of n)m[s]=i;return m}return a}resolveString(T,E,a,u,f){return(0,P.replaceAsync)(a,y.VARIABLE_REGEXP,async(m,n)=>{if(n.includes(y.VARIABLE_LHS))return m;let s=await this.evaluateSingleVariable(T,m,n,E,u);return f?.set(n,s),s!==m&&k.isString(s)&&s.match(y.VARIABLE_REGEXP)&&(s=await this.resolveString(T,E,s,u,f)),s})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,E,a,u,f){let m;const n=a.split(":");n.length>1&&(a=n[0],m=n[1]);const s=c=>{const h=this._context.getFilePath();if(h)return(0,R.normalizeDriveLetter)(h);throw new l.VariableError(c,(0,v.localize)(0,null,E))},i=c=>{const h=s(c);if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return(0,R.normalizeDriveLetter)(o)}throw new l.VariableError(c,(0,v.localize)(1,null,E,r.basename(h)))},t=c=>{if(m){const h=this._context.getFolderUri(m);if(h)return h;throw new l.VariableError(c,(0,v.localize)(2,null,E,m))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new l.VariableError(c,(0,v.localize)(3,null,E)):new l.VariableError(c,(0,v.localize)(4,null,E))};switch(a){case"env":if(m){if(T.env){const c=T.env[L.isWindows?m.toLowerCase():m];if(k.isString(c))return c}return""}throw new l.VariableError(l.VariableKind.Env,(0,v.localize)(5,null,E));case"config":if(m){const c=this._context.getConfigurationValue(u,m);if(k.isUndefinedOrNull(c))throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(6,null,E,m));if(k.isObject(c))throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(7,null,E,m));return c}throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(8,null,E));case"command":return this.resolveFromMap(l.VariableKind.Command,E,m,f,"command");case"input":return this.resolveFromMap(l.VariableKind.Input,E,m,f,"input");case"extensionInstallFolder":if(m){const c=await this._context.getExtension(m);if(!c)throw new l.VariableError(l.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,E,m));return this.fsPath(c.extensionLocation)}throw new l.VariableError(l.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,E));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.fsPath(t(l.VariableKind.WorkspaceFolder)));case"cwd":return u||m?(0,R.normalizeDriveLetter)(this.fsPath(t(l.VariableKind.Cwd))):g.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(r.basename(this.fsPath(t(l.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(T.userHome)return T.userHome;throw new l.VariableError(l.VariableKind.UserHome,(0,v.localize)(11,null,E))}case"lineNumber":{const c=this._context.getLineNumber();if(c)return c;throw new l.VariableError(l.VariableKind.LineNumber,(0,v.localize)(12,null,E))}case"selectedText":{const c=this._context.getSelectedText();if(c)return c;throw new l.VariableError(l.VariableKind.SelectedText,(0,v.localize)(13,null,E))}case"file":return s(l.VariableKind.File);case"fileWorkspaceFolder":return i(l.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.basename(i(l.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return u||m?r.relative(this.fsPath(t(l.VariableKind.RelativeFile)),s(l.VariableKind.RelativeFile)):s(l.VariableKind.RelativeFile);case"relativeFileDirname":{const c=r.dirname(s(l.VariableKind.RelativeFileDirname));if(u||m){const h=r.relative(this.fsPath(t(l.VariableKind.RelativeFileDirname)),c);return h.length===0?".":h}return c}case"fileDirname":return r.dirname(s(l.VariableKind.FileDirname));case"fileExtname":return r.extname(s(l.VariableKind.FileExtname));case"fileBasename":return r.basename(s(l.VariableKind.FileBasename));case"fileBasenameNoExtension":{const c=r.basename(s(l.VariableKind.FileBasenameNoExtension));return c.slice(0,c.length-r.extname(c).length)}case"fileDirnameBasename":return r.basename(r.dirname(s(l.VariableKind.FileDirnameBasename)));case"execPath":{const c=this._context.getExecPath();return c||E}case"execInstallFolder":{const c=this._context.getAppRoot();return c||E}case"pathSeparator":case"/":return r.sep;default:try{const c=m?`${a}:${m}`:a;return this.resolveFromMap(l.VariableKind.Unknown,E,c,f,void 0)}catch{return E}}}}resolveFromMap(T,E,a,u,f){if(a&&u){const m=f===void 0?u[a]:u[f+":"+a];if(typeof m=="string")return m;throw new l.VariableError(T,(0,v.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=y}),define(we[155],ye([1,0,5,151]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=l,e.isEditorGroup=d,e.preferredSideBySideGroupDirection=T,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var k;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(k||(e.GroupDirection=k={}));var A;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var L;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var R;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EXPAND=1]="EXPAND",E[E.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var v;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function l(E){const a=E;return(0,g.isEditorInput)(a?.editor)&&(0,g.isEditorInput)(a?.replacement)}var P;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var y;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function d(E){const a=E;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function T(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?k.DOWN:k.RIGHT}}),define(we[317],ye([1,0,5,155]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=k,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function k(A){const L=A;return typeof A=="number"||(0,g.isEditorGroup)(L)}}),define(we[156],ye([1,0,5,143]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(g.IEnvironmentService)}),define(we[157],ye([1,0,24,4,16,3,9]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(m,n){this.versionId=m,this.removedDueToLooping=n}}e.DeltaExtensionsResult=R;class v{static isHostExtension(m,n,s){if(n.getExtensionDescription(m))return!1;const i=s.getExtensionDescription(m);return i?!!((i.main||i.browser)&&i.api==="none"):!1}constructor(m,n){this._activationEventsReader=m,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(a),this._extensionsMap=new r.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const m of this._extensionDescriptions){if(this._extensionsMap.has(m.identifier)){console.error("Extension `"+m.identifier.value+"` is already registered");continue}this._extensionsMap.set(m.identifier,m),this._extensionsArr.push(m);const n=this._activationEventsReader.readActivationEvents(m);for(const s of n)this._activationMap.has(s)||this._activationMap.set(s,[]),this._activationMap.get(s).push(m)}}set(m){return this._extensionDescriptions=m,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(m,n){this._extensionDescriptions=u(this._extensionDescriptions,n),this._extensionDescriptions=this._extensionDescriptions.concat(m);const s=v._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=u(this._extensionDescriptions,s.map(i=>i.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new R(this._versionId,s)}static _findLoopingExtensions(m){const n=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,o){this.addNode(h),this.addNode(o),this._arcs.has(h)?this._arcs.get(h).push(o):this._arcs.set(h,[o])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,o){const p=n.getArcs(h);for(let _=0;_<p.length;_++)if(!o.has(p[_]))return!1;return!0}getNodes(){return this._nodesArr}},s=new r.ExtensionIdentifierMap;for(const h of m)if(s.set(h.identifier,h),h.extensionDependencies)for(const o of h.extensionDependencies)n.addArc(r.ExtensionIdentifier.toKey(h.identifier),r.ExtensionIdentifier.toKey(o));const i=new Set;n.getNodes().filter(h=>n.getArcs(h).length===0).forEach(h=>i.add(h));const t=n.getNodes().filter(h=>!i.has(h));let c;do{c=!1;for(let h=0;h<t.length;h++){const o=t[h];n.hasOnlyGoodArcs(o,i)&&(t.splice(h,1),h--,i.add(o),c=!0)}}while(c);return t.map(h=>s.get(h))}containsActivationEvent(m){return this._activationMap.has(m)}containsExtension(m){return this._extensionsMap.has(m)}getExtensionDescriptionsForActivationEvent(m){const n=this._activationMap.get(m);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new l(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(m){const n=this._extensionsMap.get(m);return n||void 0}getExtensionDescriptionByUUID(m){for(const n of this._extensionsArr)if(n.uuid===m)return n}getExtensionDescriptionByIdOrUUID(m,n){return this.getExtensionDescription(m)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.ExtensionDescriptionRegistry=v;class l{constructor(m,n){this.versionId=m,this.extensions=n}}e.ExtensionDescriptionRegistrySnapshot=l;class P{constructor(m){this._lock=new T,this._actual=new v(m,[])}async acquireLock(m){const n=await this._lock.acquire(m);return new y(this,n)}deltaExtensions(m,n,s){if(!m.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(n,s)}containsActivationEvent(m){return this._actual.containsActivationEvent(m)}containsExtension(m){return this._actual.containsExtension(m)}getExtensionDescriptionsForActivationEvent(m){return this._actual.getExtensionDescriptionsForActivationEvent(m)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(m){return this._actual.getExtensionDescription(m)}getExtensionDescriptionByUUID(m){return this._actual.getExtensionDescriptionByUUID(m)}getExtensionDescriptionByIdOrUUID(m,n){return this._actual.getExtensionDescriptionByIdOrUUID(m,n)}}e.LockableExtensionDescriptionRegistry=P;class y extends A.Disposable{constructor(m,n){super(),this._registry=m,this._isDisposed=!1,this._register(n)}isAcquiredFor(m){return!this._isDisposed&&this._registry===m}}e.ExtensionDescriptionRegistryLock=y;class d{constructor(m){this.name=m;const n=(0,L.promiseWithResolvers)();this.promise=n.promise,this._resolve=n.resolve}resolve(m){this._resolve(m)}}class T{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(m){const n=new d(m);return this._pendingCustomers.push(n),this._advance(),n.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const m=this._pendingCustomers.shift();this._isLocked=!0;let n=!0;const s=setTimeout(()=>{n&&console.warn(`The customer named ${m.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),i=()=>{n&&(clearTimeout(s),n=!1,this._isLocked=!1,this._advance())};m.resolve((0,A.toDisposable)(i))}}var E;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(E||(E={}));function a(f,m){const n=f.isBuiltin?E.Builtin:f.isUnderDevelopment?E.Dev:E.User,s=m.isBuiltin?E.Builtin:m.isUnderDevelopment?E.Dev:E.User;if(n!==s)return n-s;const i=k.posix.basename(f.extensionLocation.path),t=k.posix.basename(m.extensionLocation.path);return i<t?-1:i>t?1:0}function u(f,m){const n=new r.ExtensionIdentifierSet(m);return f.filter(s=>!n.has(s.identifier))}}),define(we[318],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0,e.writeExtHostConnection=R,e.readExtHostConnection=v;var r;(function(P){P[P.IPC=1]="IPC",P[P.Socket=2]="Socket",P[P.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class g{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(y){this.pipeName=y,this.type=r.IPC}serialize(y){y[g.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=g;class k{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(y){y[k.ENV_KEY]="1"}}e.SocketExtHostConnection=k;class A{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(y){y[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A;function L(P){delete P[g.ENV_KEY],delete P[k.ENV_KEY],delete P[A.ENV_KEY]}function R(P,y){L(y),P.serialize(y)}function v(P){if(P[g.ENV_KEY])return l(P,new g(P[g.ENV_KEY]));if(P[k.ENV_KEY])return l(P,new k);if(P[A.ENV_KEY])return l(P,new A);throw new Error("No connection information defined in environment!")}function l(P,y){return L(P),y}}),define(we[94],ye([1,0,22]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=L,e.isMessageOfType=R;var g;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(g||(e.UIKind=g={}));var k;(function(l){l[l.VersionMismatch=55]="VersionMismatch",l[l.UnexpectedError=81]="UnexpectedError"})(k||(e.ExtensionHostExitCode=k={}));var A;(function(l){l[l.Initialized=0]="Initialized",l[l.Ready=1]="Ready",l[l.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function L(l){const P=r.VSBuffer.alloc(1);switch(l){case A.Initialized:P.writeUInt8(1,0);break;case A.Ready:P.writeUInt8(2,0);break;case A.Terminate:P.writeUInt8(3,0);break}return P}function R(l,P){if(l.byteLength!==1)return!1;switch(l.readUInt8(0)){case 1:return P===A.Initialized;case 2:return P===A.Ready;case 3:return P===A.Terminate;default:return!1}}var v;(function(l){l.Start="START_NATIVE_LOG",l.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(we[95],ye([1,0,5,4,148,12,30,94,91,92,25,2,3,239]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=u;let E=class extends d.Disposable{constructor(m,n){super(),this.initData=m,this.loggerService=n,this._onDidChangeTelemetryEnabled=this._register(new g.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new g.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=k.TelemetryLevel.NONE,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=y.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=n.createLogger(this.extHostTelemetryLogFile,{id:l.extensionTelemetryLogChannelId,name:(0,T.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(n.onDidChangeLogLevel(s=>{(0,A.isLogLevel)(s)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===k.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this._level>=k.TelemetryLevel.CRASH,isErrorsEnabled:this._productConfig.error?this._level>=k.TelemetryLevel.ERROR:!1,isUsageEnabled:this._productConfig.usage?this._level>=k.TelemetryLevel.USAGE:!1}}instantiateLogger(m,n,s){const i=this.getTelemetryDetails(),t=new a(n,s,m,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(m),{isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}),c=this._telemetryLoggers.get(m.identifier.value)??[];return this._telemetryLoggers.set(m.identifier.value,[...c,t]),t.apiTelemetryLogger}$initializeTelemetryLevel(m,n,s){this._level=m,this._telemetryIsSupported=n,this._productConfig=s??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(m){const n=Object.create(null);switch(n["common.extname"]=`${m.publisher}.${m.name}`,n["common.extversion"]=m.version,n["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,n["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,n["common.sqmid"]=this.initData.telemetryInfo.sqmId,n["common.devDeviceId"]=this.initData.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.initData.version,n["common.isnewappinstall"]=u(this.initData.telemetryInfo.firstSessionDate),n["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,v.getRemoteName)((0,l.cleanRemoteAuthority)(this.initData.remote.authority)),n}$onDidChangeTelemetryLevel(m){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=m;const n=this.getTelemetryDetails();this._telemetryLoggers.forEach((s,i)=>{const t=s.filter(c=>!c.isDisposed);t.length===0?this._telemetryLoggers.delete(i):this._telemetryLoggers.set(i,t)}),this._telemetryLoggers.forEach(s=>{for(const i of s)i.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(m,n){const i=this._telemetryLoggers.get(m.value)?.filter(c=>!c.isDisposed);if(!i)return this._telemetryLoggers.delete(m.value),!1;let t=!1;for(const c of i)c.ignoreUnhandledExtHostErrors||(c.logError(n),t=!0);return t}};e.ExtHostTelemetry=E,e.ExtHostTelemetry=E=Ke([Ve(0,L.IExtHostInitDataService),Ve(1,A.ILoggerService)],E);class a{static validateSender(m){if(typeof m!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof m.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof m.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof m.flush<"u"&&typeof m.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(m,n,s,i,t,c,h){this._extension=s,this._logger=i,this._inLoggingOnlyMode=t,this._commonProperties=c,this._onDidChangeEnableStates=new g.Emitter,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=n?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=n?.additionalCommonProperties,this._sender=m,this._telemetryEnablements={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(m,n){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:m,isErrorsEnabled:n},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(m){let n="properties"in m?m.properties??{}:m;return n=(0,l.cleanData)(n,[]),this._additionalCommonProperties&&(n=(0,P.mixin)(n,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(n=(0,P.mixin)(n,this._commonProperties)),"properties"in m?m.properties=n:m=n,m}logEvent(m,n){this._sender&&(this._extension.publisher==="vscode"?m=this._extension.name+"/"+m:m=this._extension.identifier.value+"/"+m,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(m,n),this._logger.trace(m,n))}logUsage(m,n){this._telemetryEnablements.isUsageEnabled&&this.logEvent(m,n)}logError(m,n){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof m=="string")this.logEvent(m,n);else{const s={name:m.name,message:m.message,stack:m.stack,cause:m.cause},i=(0,l.cleanData)(s,[]),t=new Error(i.message,{cause:i.cause});t.stack=i.stack,t.name=i.name,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(t,n),this._logger.trace("exception",n)}}get apiTelemetryLogger(){if(!this._apiObject){const m=this,n={logUsage:m.logUsage.bind(m),get isUsageEnabled(){return m._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return m._telemetryEnablements.isErrorsEnabled},logError:m.logError.bind(m),dispose:m.dispose.bind(m),onDidChangeEnableStates:m._onDidChangeEnableStates.event.bind(m)};this._apiObject=Object.freeze(n)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let m=this._sender;this._sender=void 0,Promise.resolve(m.flush()).then(m=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=a;function u(f){const m=Date.now()-new Date(f).getTime();return isNaN(m)?!1:m<1e3*60*60*24}e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(we[26],ye([1,0,4,2,288,146,24,5]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=d,e.checkProposedApiEnabled=T,e.toExtension=f,e.toExtensionDescription=m,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:g.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class v{constructor(i){this.dependency=i}}e.MissingExtensionDependency=v;var l;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(l||(e.ExtensionHostStartup=l={}));class P{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(i,t,c){this._versionId=i,this._allExtensions=t.slice(0),this._myExtensions=c.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:A.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(i,t,c){if(this._versionId>i)throw new Error(`ExtensionHostExtensions: invalid versionId ${i} (current: ${this._versionId})`);const h=[],o=[],p=[],_=[],D=y(this._allExtensions),C=y(t),S=(O,U)=>O.extensionLocation.toString()===U.extensionLocation.toString()||O.isBuiltin===U.isBuiltin||O.isUserBuiltin===U.isUserBuiltin||O.isUnderDevelopment===U.isUnderDevelopment;for(const O of this._allExtensions){const U=C.get(O.identifier);if(!U){h.push(O.identifier),D.delete(O.identifier);continue}if(!S(O,U)){h.push(O.identifier),D.delete(O.identifier);continue}}for(const O of t){const U=D.get(O.identifier);if(!U){o.push(O);continue}if(!S(U,O)){h.push(U.identifier),D.delete(U.identifier);continue}}const I=new L.ExtensionIdentifierSet(this._myExtensions),b=new L.ExtensionIdentifierSet(c);for(const O of this._myExtensions)b.has(O)||p.push(O);for(const O of c)I.has(O)||_.push(O);const w=A.ImplicitActivationEvents.createActivationEventsMap(o),N={versionId:i,toRemove:h,toAdd:o,addActivationEvents:w,myToRemove:p,myToAdd:_};return this.delta(N),N}delta(i){if(this._versionId>=i.versionId)return null;const{toRemove:t,toAdd:c,myToRemove:h,myToAdd:o}=i,p=new L.ExtensionIdentifierSet(t),_=new L.ExtensionIdentifierSet(h);for(let D=0;D<this._allExtensions.length;D++)p.has(this._allExtensions[D].identifier)&&(this._allExtensions.splice(D,1),D--);for(let D=0;D<this._myExtensions.length;D++)_.has(this._myExtensions[D])&&(this._myExtensions.splice(D,1),D--);for(const D of c)this._allExtensions.push(D);for(const D of o)this._myExtensions.push(D);return this._myActivationEvents=null,i}containsExtension(i){for(const t of this._myExtensions)if(L.ExtensionIdentifier.equals(t,i))return!0;return!1}containsActivationEvent(i){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(i)}_readMyActivationEvents(){const i=new Set;for(const t of this._allExtensions){if(!this.containsExtension(t.identifier))continue;const c=A.ImplicitActivationEvents.readActivationEvents(t);for(const h of c)i.add(h)}return i}}e.ExtensionHostExtensions=P;function y(s){const i=new L.ExtensionIdentifierMap;for(const t of s)i.set(t.identifier,t);return i}function d(s,i){return s.enabledApiProposals?s.enabledApiProposals.includes(i):!1}function T(s,i){if(!d(s,i))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${i}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${i}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class E{constructor(i,t,c,h){this.codeLoadingTime=i,this.activateCallTime=t,this.activateResolvedTime=c,this.activationReason=h}}e.ActivationTimes=E;class a{constructor(i,t){this.description=i,this.value=t}}e.ExtensionPointContribution=a;var u;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function f(s){return{type:s.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function m(s,i){return{identifier:new L.ExtensionIdentifier((0,k.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===L.ExtensionType.System,isUserBuiltin:s.type===L.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!i,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(i){return Promise.resolve(void 0)}activateById(i,t){return Promise.resolve(void 0)}activationEventIsDone(i){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(i){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(i,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(i){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=n}),define(we[319],ye([1,0,14,157,24,26,12,9]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class v{static{this.NONE=new v(!1,-1,-1,-1)}constructor(f,m,n,s){this.startup=f,this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=s}}e.ExtensionActivationTimes=v;class l{constructor(f){this._startup=f,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(f,m){return f===-1||m===-1?-1:m-f}build(){return new v(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=l;class P{constructor(f,m,n,s,i,t){this.activationFailed=f,this.activationFailedError=m,this.activationTimes=n,this.module=s,this.exports=i,this.subscriptions=t}}e.ActivatedExtension=P;class y extends P{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=y;class d extends P{constructor(){super(!1,null,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=d;class T extends P{constructor(f){super(!0,f,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(f,m,n,s){this._logService=s,this._registry=f,this._globalRegistry=m,this._host=n,this._operations=new k.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[f,m]of this._operations)m.dispose()}async waitForActivatingExtensions(){const f=[];for(const[m,n]of this._operations)f.push(n.wait());await Promise.all(f)}isActivated(f){const m=this._operations.get(f);return!!(m&&m.value)}getActivatedExtension(f){const m=this._operations.get(f);if(!m||!m.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return m.value}async activateByEvent(f,m){if(this._alreadyActivatedEvents[f])return;const n=this._registry.getExtensionDescriptionsForActivationEvent(f);await this._activateExtensions(n.map(s=>({id:s.identifier,reason:{startup:m,extensionId:s.identifier,activationEvent:f}}))),this._alreadyActivatedEvents[f]=!0}activateById(f,m){const n=this._registry.getExtensionDescription(f);if(!n)throw new Error(`Extension '${f.value}' is not known`);return this._activateExtensions([{id:n.identifier,reason:m}])}async _activateExtensions(f){const m=f.filter(n=>!this.isActivated(n.id)).map(n=>this._handleActivationRequest(n));await Promise.all(m.map(n=>n.wait()))}_handleActivationRequest(f){if(this._operations.has(f.id))return this._operations.get(f.id);if(this._isHostExtension(f.id))return this._createAndSaveOperation(f,null,[],null);const m=this._registry.getExtensionDescription(f.id);if(!m){const i=new Error(`Cannot activate unknown extension '${f.id.value}'`),t=this._createAndSaveOperation(f,null,[],new T(i));return this._host.onExtensionActivationError(f.id,i,new A.MissingExtensionDependency(f.id.value)),t}const n=[],s=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const i of s){if(this._isResolvedExtension(i))continue;const t=this._operations.get(i);if(t){n.push(t);continue}if(this._isHostExtension(i)){n.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(i).identifier,reason:f.reason}));continue}const c=this._registry.getExtensionDescription(i);if(c){if(!c.main&&!c.browser)continue;n.push(this._handleActivationRequest({id:c.identifier,reason:f.reason}));continue}const h=m.displayName||m.identifier.value,o=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${i}'`),p=this._createAndSaveOperation(f,m.displayName,[],new T(o));return this._host.onExtensionActivationError(m.identifier,o,new A.MissingExtensionDependency(i)),p}return this._createAndSaveOperation(f,m.displayName,n,null)}_createAndSaveOperation(f,m,n,s){const i=new a(f.id,m,f.reason,n,s,this._host,this._logService);return this._operations.set(f.id,i),i}_isHostExtension(f){return g.ExtensionDescriptionRegistry.isHostExtension(f,this._registry,this._globalRegistry)}_isResolvedExtension(f){const m=this._globalRegistry.getExtensionDescription(f);return m?!m.main&&!m.browser:!1}};e.ExtensionsActivator=E,e.ExtensionsActivator=E=Ke([Ve(3,L.ILogService)],E);let a=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(f,m,n,s,i,t,c){this._id=f,this._displayName=m,this._reason=n,this._deps=s,this._value=i,this._host=t,this._logService=c,this._barrier=new R.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let f=0;f<this._deps.length;f++){const m=this._deps[f];if(m.value&&!m.value.activationFailed){this._deps.splice(f,1),f--;continue}if(m.value&&m.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);n.detail=m.value.activationFailedError,this._value=new T(n),this._host.onExtensionActivationError(this._id,n,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(f=>f.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(f){const m=new Error;if(f&&f.name&&(m.name=f.name),f&&f.message?m.message=`Activating extension '${this._id.value}' failed: ${f.message}.`:m.message=`Activating extension '${this._id.value}' failed: ${f}.`,f&&f.stack&&(m.stack=f.stack),this._value=new T(m),this._isDisposed&&r.isCancellationError(f))return;this._host.onExtensionActivationError(this._id,m,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(f)}}};a=Ke([Ve(6,L.ILogService)],a)}),define(we[320],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(we[158],ye([1,0,258,14,43,145,116,36,24,320,115,146]),function(he,e,r,g,k,A,L,R,v,l,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const d=R.Registry.as(L.Extensions.JSONContribution);class T{constructor(i,t,c){this._messageHandler=i,this._extension=t,this._extensionPointId=c}_msg(i,t){this._messageHandler({type:i,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(i){this._msg(k.default.Error,i)}warn(i){this._msg(k.default.Warning,i)}info(i){this._msg(k.default.Info,i)}}e.ExtensionMessageCollector=T;class E{static _toSet(i){const t=new v.ExtensionIdentifierSet;for(let c=0,h=i.length;c<h;c++)t.add(i[c].description.identifier);return t}static compute(i,t){if(!i||!i.length)return new E(t,[]);if(!t||!t.length)return new E([],i);const c=this._toSet(i),h=this._toSet(t),o=t.filter(_=>!c.has(_.description.identifier)),p=i.filter(_=>!h.has(_.description.identifier));return new E(o,p)}constructor(i,t){this.added=i,this.removed=t}}e.ExtensionPointUserDelta=E;class a{constructor(i,t){this.name=i,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(i){if(this._handler!==null)throw new Error("Handler already set!");return this._handler=i,this._handle(),{dispose:()=>{this._handler=null}}}acceptUsers(i){this._delta=E.compute(this._users,i),this._users=i,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(i){(0,g.onUnexpectedError)(i)}}}e.ExtensionPoint=a;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},f="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(42,null)},{label:"*",description:r.localize(43,null),body:"*"}]}},badges:{type:"array",description:r.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(45,null)},href:{type:"string",description:r.localize(46,null)},description:{type:"string",description:r.localize(47,null)}}}},markdown:{type:"string",description:r.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:r.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:r.localize(52,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(53,null)},{body:["workspace"],description:r.localize(54,null)},{body:["ui","workspace"],description:r.localize(55,null)},{body:["workspace","ui"],description:r.localize(56,null)},{body:[],description:r.localize(57,null)}]},capabilities:{description:r.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(61,null),r.localize(62,null),r.localize(63,null)]},description:{type:"string",markdownDescription:r.localize(64,null)}}},untrustedWorkspaces:{description:r.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(67,null),r.localize(68,null),r.localize(69,null)]},restrictedConfigurations:{description:r.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(71,null)}}}}},sponsor:{description:r.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(74,null),type:"string"},"vscode:uninstall":{description:r.localize(75,null),type:"string"}}},icon:{type:"string",description:r.localize(76,null)},l10n:{type:"string",description:r.localize(77,null)},pricing:{type:"string",markdownDescription:r.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class m{constructor(){this._extensionPoints=new Map}registerExtensionPoint(i){if(this._extensionPoints.has(i.extensionPoint))throw new Error("Duplicate extension point: "+i.extensionPoint);const t=new a(i.extensionPoint,i.defaultExtensionKind);return this._extensionPoints.set(i.extensionPoint,t),i.activationEventsGenerator&&y.ImplicitActivationEvents.register(i.extensionPoint,i.activationEventsGenerator),e.schema.properties.contributes.properties[i.extensionPoint]=i.jsonSchema,d.registerSchema(f,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=m;const n={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(n.ExtensionsRegistry,new m),e.ExtensionsRegistry=R.Registry.as(n.ExtensionsRegistry),d.registerSchema(f,e.schema),d.registerSchema(P.productSchemaId,{properties:{extensionEnabledApiProposals:{description:r.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}}]}}}})}),define(we[321],ye([1,0,4,40,3,13,249,24,5,12,26,158]),function(he,e,r,g,k,A,L,R,v,l,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelsService=e.languageModelExtensionPoint=e.ILanguageModelsService=e.ChatMessageRole=void 0;var d;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(d||(e.ChatMessageRole=d={})),e.ILanguageModelsService=(0,v.createDecorator)("ILanguageModelsService");const T={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(0,null)}}};e.languageModelExtensionPoint=y.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(1,null),oneOf:[T,{type:"array",items:T}]},activationEventsGenerator:(a,u)=>{for(const f of a)u.push(`onLanguageModelChat:${f.vendor}`)}});let E=class{constructor(u,f){this._extensionService=u,this._logService=f,this._store=new k.DisposableStore,this._providers=new Map,this._vendors=new Set,this._onDidChangeProviders=this._store.add(new r.Emitter),this.onDidChangeLanguageModels=this._onDidChangeProviders.event,this._store.add(e.languageModelExtensionPoint.setHandler(m=>{this._vendors.clear();for(const s of m){if(!(0,P.isProposedApiEnabled)(s.description,"chatProvider")){s.collector.error((0,L.localize)(2,null));continue}for(const i of g.Iterable.wrap(s.value)){if(this._vendors.has(i.vendor)){s.collector.error((0,L.localize)(3,null,i.vendor));continue}if((0,A.isFalsyOrWhitespace)(i.vendor)){s.collector.error((0,L.localize)(4,null));continue}if(i.vendor.trim()!==i.vendor){s.collector.error((0,L.localize)(5,null));continue}this._vendors.add(i.vendor)}}const n=[];for(const[s,i]of this._providers)this._vendors.has(i.metadata.vendor)||(this._providers.delete(s),n.push(s));n.length>0&&this._onDidChangeProviders.fire({removed:n})}))}dispose(){this._store.dispose(),this._providers.clear()}getLanguageModelIds(){return Array.from(this._providers.keys())}lookupLanguageModel(u){return this._providers.get(u)?.metadata}async selectLanguageModels(u){if(u.vendor)await this._extensionService.activateByEvent(`onLanguageModelChat:${u.vendor}}`);else{const m=Array.from(this._vendors).map(n=>this._extensionService.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(m)}const f=[];for(const[m,n]of this._providers)(u.vendor===void 0||n.metadata.vendor===u.vendor)&&(u.family===void 0||n.metadata.family===u.family)&&(u.version===void 0||n.metadata.version===u.version)&&(u.identifier===void 0||n.metadata.id===u.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(s=>R.ExtensionIdentifier.equals(s,u.extension)))&&f.push(m);return this._logService.trace("[LM] selected language models",u,f),f}registerLanguageModelChat(u,f){if(this._logService.trace("[LM] registering language model chat",u,f.metadata),!this._vendors.has(f.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${f.metadata.vendor}.`);if(this._providers.has(u))throw new Error(`Chat response provider with identifier ${u} is already registered.`);return this._providers.set(u,f),this._onDidChangeProviders.fire({added:[{identifier:u,metadata:f.metadata}]}),(0,k.toDisposable)(()=>{this._providers.delete(u)&&(this._onDidChangeProviders.fire({removed:[u]}),this._logService.trace("[LM] UNregistered language model chat",u,f.metadata))})}makeLanguageModelChatRequest(u,f,m,n,s,i){const t=this._providers.get(u);if(!t)throw new Error(`Chat response provider with identifier ${u} is not registered.`);return t.provideChatResponse(m,f,n,s,i)}computeTokenLength(u,f,m){const n=this._providers.get(u);if(!n)throw new Error(`Chat response provider with identifier ${u} is not registered.`);return n.provideTokenCount(f,m)}};e.LanguageModelsService=E,e.LanguageModelsService=E=Ke([Ve(0,P.IExtensionService),Ve(1,l.ILogService)],E)}),define(we[322],ye([1,0,253,18,25,158,35,4]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const v={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var l;(function(d){function T(E,a,u){if(!E)return;const f=g.isString(E.type)?E.type:void 0;if(!f||f.length===0){u.error(r.localize(3,null));return}const m=[];if(Array.isArray(E.required))for(const n of E.required)g.isString(n)&&m.push(n);return{extensionId:a.value,taskType:f,required:m,properties:E.properties?k.deepClone(E.properties):{},when:E.when?L.ContextKeyExpr.deserialize(E.when):void 0}}d.from=T})(l||(l={}));const P=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(d,T)=>{for(const E of d)E.type&&T.push(`onTaskType:${E.type}`)},jsonSchema:{description:r.localize(4,null),type:"array",items:v}});class y{constructor(){this._onDefinitionsChanged=new R.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,E)=>{P.setHandler((a,u)=>{this._schema=void 0;try{for(const f of u.removed){const m=f.value;for(const n of m)this.taskTypes&&n.type&&this.taskTypes[n.type]&&delete this.taskTypes[n.type]}for(const f of u.added){const m=f.value;for(const n of m){const s=l.from(n,f.description.identifier,f.collector);s&&(this.taskTypes[s.taskType]=s)}}(u.removed.length>0||u.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const E of this.all()){const a={type:"object",additionalProperties:!1};E.required.length>0&&(a.required=E.required.slice(0)),E.properties!==void 0?a.properties=k.deepClone(E.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[E.taskType]},T.push(a)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistry=new y}),define(we[323],ye([1,0,254,18,23,25,35,322,44]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new L.RawContextKey("taskRunning",!1,r.localize(0,null)),e.TASKS_CATEGORY=r.localize2(2,"Tasks");var l;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(l||(e.ShellQuoting=l={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function M(K){if(!K)return F.Strong;switch(K.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=M}(l||(e.ShellQuoting=l={}));var P;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(P||(e.CommandOptions=P={}));var y;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(y||(e.RevealKind=y={})),function(F){function M(K){switch(K.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=M}(y||(e.RevealKind=y={}));var d;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(d||(e.RevealProblemKind=d={})),function(F){function M(K){switch(K.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=M}(d||(e.RevealProblemKind=d={}));var T;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(T||(e.PanelKind=T={})),function(F){function M(K){switch(K.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=M}(T||(e.PanelKind=T={}));var E;(function(F){F.defaults={echo:!0,reveal:y.Always,revealProblems:d.Never,focus:!1,panel:T.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var a;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(F){function M(ee){switch(ee.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=M;function K(ee){switch(ee){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=K}(a||(e.RuntimeType=a={}));var u;(function(F){function M(K){return g.isString(K)?K:K.value}F.value=M})(u||(e.CommandString=u={}));var f;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function M(ee){return ee===F.Clean._id||ee===F.Build._id||ee===F.Rebuild._id||ee===F.Test._id}F.is=M;function K(ee){if(ee!==void 0)return g.isString(ee)?M(ee)?{_id:ee,isDefault:!1}:void 0:ee}F.from=K})(f||(e.TaskGroup=f={}));var m;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(m||(e.TaskScope=m={}));var n;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function M(K){switch(K){case F.User:return v.ConfigurationTarget.USER;case F.WorkspaceFile:return v.ConfigurationTarget.WORKSPACE;default:return v.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=M})(n||(e.TaskSourceKind=n={}));var s;(function(F){F.parallel="parallel",F.sequence="sequence"})(s||(e.DependsOrder=s={}));var i;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(i||(e.RunOnOptions=i={}));var t;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:i.default,instanceLimit:1}})(t||(e.RunOptions=t={}));class c{constructor(M,K,ee,$,q,Z){this._label="",this._id=M,K&&(this._label=K),ee&&(this.type=ee),this.runOptions=$,this.configurationProperties=q,this._source=Z}getDefinition(M){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const M={folder:this.getFolderId(),id:this._id};return JSON.stringify(M)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,K=!1){if(M===void 0)return!1;if(g.isString(M))return M===this._label||M===this.configurationProperties.identifier||K&&M===this._id;const ee=this.getDefinition(!0);return ee!==void 0&&ee._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),M&&(this._taskLoadMessages=this._taskLoadMessages.concat(M))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=c;class h extends c{constructor(M,K,ee,$,q,Z,ne,de){super(M,ee,void 0,ne,de,K),this.command={},this._source=K,this.hasDefinedMatchers=Z,q&&(this.command=q)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case a.Shell:K="shell";break;case a.Process:K="process";break;case a.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(M){return M instanceof h}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const M=this.getFolderId();if(!M)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ee={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:K};return JSON.stringify(ee)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(M){return new h(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.CustomTask=h;class o extends c{constructor(M,K,ee,$,q,Z,ne){super(M,ee,$,Z,ne,K),this._source=K,this.configures=q}static is(M){return M instanceof o}fromObject(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const M=this.getFolderId();if(!M)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ee={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:K};return JSON.stringify(ee)}}e.ConfiguringTask=o;class p extends c{constructor(M,K,ee,$,q,Z,ne,de,re){super(M,ee,$,de,re,K),this.defines=q,this.hasDefinedMatchers=ne,this.command=Z,this.icon=re.icon,this.hide=re.hide}clone(){return new p(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof p}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===m.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.getFolderId(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(M){return new p(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.ContributedTask=p;class _ extends c{constructor(M,K,ee,$,q,Z){super(M,ee,$,q,Z,K),this._source=K}clone(){return new _(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof _}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(M){return new _(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.InMemoryTask=_;var D;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(F){F._default=F.Terminal}(D||(e.ExecutionEngine=D={}));var C;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(C||(e.JsonSchemaVersion=C={}));class S{constructor(M){this._order=new Map;for(let K=0;K<M.length;K++)this._order.set(M[K].uri.toString(),K)}compare(M,K){const ee=M.getWorkspaceFolder(),$=K.getWorkspaceFolder();if(ee&&$){let q=this._order.get(ee.uri.toString());q=q===void 0?0:q+1;let Z=this._order.get($.uri.toString());return Z=Z===void 0?0:Z+1,q===Z?M._label.localeCompare(K._label):q-Z}else return!ee&&$?-1:ee&&!$?1:0}}e.TaskSorter=S;var I;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(I||(e.TaskEventKind=I={}));var b;(function(F){F.SingleRun="singleRun",F.Background="background"})(b||(e.TaskRunType=b={}));var w;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var N;(function(F){function M(de){return{taskId:de._id,taskName:de.configurationProperties.name,runType:de.configurationProperties.isBackground?b.Background:b.SingleRun,group:de.configurationProperties.group,__task:de}}function K(de,re,Se){return{...M(de),kind:I.Start,terminalId:re,resolvedVariables:Se}}F.start=K;function ee(de,re,Se){return{...M(de),kind:I.ProcessStarted,terminalId:re,processId:Se}}F.processStarted=ee;function $(de,re,Se){return{...M(de),kind:I.ProcessEnded,terminalId:re,exitCode:Se}}F.processEnded=$;function q(de,re,Se){return{...M(de),kind:I.Terminated,exitReason:Se,terminalId:re}}F.terminated=q;function Z(de,re,Se){return{...M(re),kind:de,terminalId:Se}}F.general=Z;function ne(){return{kind:I.Changed}}F.changed=ne})(N||(e.TaskEvent=N={}));var O;(function(F){function M(ee){const $=Object.keys(ee).sort();let q="";for(const Z of $){let ne=ee[Z];ne instanceof Object?ne=M(ne):typeof ne=="string"&&(ne=ne.replace(/,/g,",,")),q+=Z+","+ne+","}return q}function K(ee){const q={_key:M(ee),type:ee.taskType};return Object.assign(q,ee),q}F.create=K})(O||(e.KeyedTaskIdentifier=O={}));var U;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var x;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(x||(e.TasksSchemaProperties=x={}));var B;(function(F){function M(K,ee){const $=R.TaskDefinitionRegistry.get(K.type);if($===void 0){const de=A.deepClone(K);return delete de._key,O.create(de)}const q=Object.create(null);q.type=$.taskType;const Z=new Set;$.required.forEach(de=>Z.add(de));const ne=$.properties;for(const de of Object.keys(ne)){const re=K[de];if(re!=null)q[de]=re;else if(Z.has(de)){const Se=ne[de];if(Se.default!==void 0)q[de]=A.deepClone(Se.default);else switch(Se.type){case"boolean":q[de]=!1;break;case"number":case"integer":q[de]=0;break;case"string":q[de]="";break;default:ee.error(r.localize(1,null,JSON.stringify(K,void 0,0),de));return}}}return O.create(q)}F.createTaskIdentifier=M})(B||(e.TaskDefinition=B={}))}),define(we[324],ye([1,0,14]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class g{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((L,R)=>{this._actualOk=L,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(L){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=L,this._actual&&this._actualOk(L))}resolveErr(L){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=L,this._actual?this._actualErr(L):(0,r.onUnexpectedError)(L))}then(L,R){return this._ensureActual().then(L,R)}catch(L){return this._ensureActual().then(void 0,L)}finally(L){return this._ensureActual().finally(L)}}e.LazyPromise=g;class k extends g{constructor(){super(),this._hasErr=!0,this._err=new r.CancellationError}}e.CanceledLazyPromise=k}),define(we[52],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=k,e.getStringIdentifierForProxy=A;class r{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++r.count}}e.ProxyIdentifier=r;const g=[];function k(R){const v=new r(R);return g[v.nid]=v,v}function A(R){return g[R].sid}class L{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=L}),define(we[6],ye([1,0,52]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var g;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(g||(e.TextEditorRevealType=g={}));var k;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(k||(e.TabInputKind=k={}));var A;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var L;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var R;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var v;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var l;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(l||(e.NotebookEditorRevealType=l={}));var P;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(P||(e.CandidatePortSource=P={}));class y{static{this._n=0}static mixin(u){return u._id=y._n++,u}}e.IdObject=y;var d;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(d||(e.ISuggestDataDtoField=d={}));var T;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(T||(e.ISuggestResultDtoField=T={}));var E;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(E||(e.ExtHostTestingResource=E={})),e.MainContext={MainThreadAuthentication:(0,r.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.createProxyIdentifier)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,r.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,r.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,r.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,r.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,r.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,r.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,r.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,r.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,r.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,r.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,r.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,r.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,r.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,r.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,r.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,r.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,r.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,r.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,r.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,r.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,r.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,r.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,r.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,r.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,r.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,r.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,r.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,r.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,r.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,r.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.createProxyIdentifier)("MainThreadAiEmbeddingVector")},e.ExtHostContext={ExtHostCommands:(0,r.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,r.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,r.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,r.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,r.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,r.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,r.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,r.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,r.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,r.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,r.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,r.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,r.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,r.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,r.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,r.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,r.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,r.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,r.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.createProxyIdentifier)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,r.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,r.createProxyIdentifier)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.createProxyIdentifier)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,r.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,r.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,r.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,r.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,r.createProxyIdentifier)("ExtHostLocalization")}}),define(we[96],ye([1,0,5,12,6,20]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let L=class{constructor(v,l){this._extHostLogService=l,this._reportedUsages=new Set,this._telemetryShape=v.getProxy(k.MainContext.MainThreadTelemetry)}report(v,l,P){const y=this.getUsageKey(v,l);this._reportedUsages.has(y)||(this._reportedUsages.add(y),l.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${v}' is deprecated. ${P}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:l.identifier.value,apiId:v}))}getUsageKey(v,l){return`${v}-${l.identifier.value}`}};e.ExtHostApiDeprecationService=L,e.ExtHostApiDeprecationService=L=Ke([Ve(0,A.IExtHostRpcService),Ve(1,g.ILogService)],L),e.NullApiDeprecationService=Object.freeze(new class{report(R,v,l){}})}),define(we[325],ye([1,0,6]),function(he,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class g{constructor(A){const L=A.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(R){return L.$writeText(R)}})}}e.ExtHostClipboard=g}),define(we[326],ye([1,0,25,6,30,20]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let L=class{constructor(P,y){this._mainThreadConsole=P.getProxy(g.MainContext.MainThreadConsole),this._includeStack=y.consoleForward.includeStack,this._logNative=y.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(P,y){const d=this,T=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){d._handleConsoleCall(P,y,T,arguments)}})}_handleConsoleCall(P,y,d,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:y,arguments:v(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(P,d,T)}};e.AbstractExtHostConsoleForwarder=L,e.AbstractExtHostConsoleForwarder=L=Ke([Ve(0,A.IExtHostRpcService),Ve(1,k.IExtHostInitDataService)],L);const R=1e5;function v(l,P){const y=[];if(l.length)for(let d=0;d<l.length;d++){let T=l[d];if(typeof T>"u")T="undefined";else if(T instanceof Error){const E=T;E.stack?T=E.stack:T=E.toString()}y.push(T)}if(P){const d=new Error().stack;d&&y.push({__$stack:d.split(`
`).slice(3).join(`
`)})}try{const d=(0,r.safeStringify)(y);return d.length>R?"Output omitted for a large object that exceeds the limits":d}catch(d){return`Output omitted for an object that cannot be inspected ('${d.toString()}')`}}}),define(we[327],ye([1,0,2,6,26]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(R){this._proxy=R.getProxy(g.MainContext.MainThreadDialogs)}showOpenDialog(R,v){return v?.allowUIResources&&(0,k.checkProposedApiEnabled)(R,"showLocal"),this._proxy.$showOpenDialog(v).then(l=>l?l.map(P=>r.URI.revive(P)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(v=>v?r.URI.revive(v):void 0)}}e.ExtHostDialogs=A}),define(we[328],ye([1,0,21,4,3,6]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEmbeddings=void 0;class L{constructor(v){this._provider=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._allKnownModels=new Set,this._handlePool=0,this._proxy=v.getProxy(A.MainContext.MainThreadEmbeddings)}registerEmbeddingsProvider(v,l,P){if(this._allKnownModels.has(l))throw new Error("An embeddings provider for this model is already registered");const y=this._handlePool++;return this._proxy.$registerEmbeddingProvider(y,l),this._provider.set(y,{id:l,provider:P}),(0,k.toDisposable)(()=>{this._proxy.$unregisterEmbeddingProvider(y),this._provider.delete(y)})}async computeEmbeddings(v,l,P){P??=r.CancellationToken.None;let y=!1;typeof l=="string"&&(l=[l],y=!0);const d=await this._proxy.$computeEmbeddings(v,l,P);if(d.length!==l.length)throw new Error;if(y){if(d.length!==1)throw new Error;return d[0]}return d}async $provideEmbeddings(v,l,P){const y=this._provider.get(v);if(!y)return[];const d=await y.provider.provideEmbeddings(l,P);return d||[]}get embeddingsModels(){return Array.from(this._allKnownModels)}$acceptEmbeddingModels(v){this._allKnownModels=new Set(v),this._onDidChange.fire()}}e.ExtHostEmbeddings=L}),define(we[329],ye([1,0,3,6]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(L){this._handlePool=0,this._proxy=L.getProxy(g.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(L){const R=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(R,L),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=k}),define(we[122],ye([1,0,11,13,2,5,12,6,30,20]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let P=class{constructor(d,T,E){this.logService=E,this.bundleCache=new Map,this._proxy=T.getProxy(R.MainContext.MainThreadLocalization),this.currentLanguage=d.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===r.LANGUAGE_DEFAULT}getMessage(d,T){const{message:E,args:a,comment:u}=T;if(this.isDefaultLanguage)return(0,g.format2)(E,a??{});let f=E;u&&u.length>0&&(f+=`/${Array.isArray(u)?u.join(""):u}`);const m=this.bundleCache.get(d)?.contents[f];return m||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,g.format2)(m??E,a??{})}getBundle(d){return this.bundleCache.get(d)?.contents}getBundleUri(d){return this.bundleCache.get(d)?.uri}async initializeLocalizedMessages(d){if(this.isDefaultLanguage||!d.l10n&&!d.isBuiltin||this.bundleCache.has(d.identifier.value))return;let T;const E=await this.getBundleLocation(d);if(!E){this.logService.error(`No bundle location found for extension ${d.identifier.value}`);return}try{const a=await this._proxy.$fetchBundleContents(E),u=JSON.parse(a);T=d.isBuiltin?u.contents?.bundle:u}catch(a){this.logService.error(`Failed to load translations for ${d.identifier.value} from ${E}: ${a.message}`);return}T&&this.bundleCache.set(d.identifier.value,{contents:T,uri:E})}async getBundleLocation(d){if(d.isBuiltin){const T=await this._proxy.$fetchBuiltInBundleUri(d.identifier.value,this.currentLanguage);return k.URI.revive(T)}return d.l10n?k.URI.joinPath(d.extensionLocation,d.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=P,e.ExtHostLocalizationService=P=Ke([Ve(0,v.IExtHostInitDataService),Ve(1,l.IExtHostRpcService),Ve(2,L.ILogService)],P),e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(we[159],ye([1,0,12,6,30,20,2,57]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let v=class extends r.AbstractLoggerService{constructor(y,d){super(d.logLevel,d.logsLocation,d.loggers.map(T=>(0,R.revive)(T))),this._proxy=y.getProxy(g.MainContext.MainThreadLogger)}$setLogLevel(y,d){d?this.setLogLevel(L.URI.revive(d),y):this.setLogLevel(y)}setVisibility(y,d){super.setVisibility(y,d),this._proxy.$setVisibility(y,d)}doCreateLogger(y,d,T){return new l(this._proxy,y,d,T)}};e.ExtHostLoggerService=v,e.ExtHostLoggerService=v=Ke([Ve(0,A.IExtHostRpcService),Ve(1,k.IExtHostInitDataService)],v);class l extends r.AbstractMessageLogger{constructor(y,d,T,E){super(E?.logLevel==="always"),this.proxy=y,this.file=d,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(T),this.proxy.$createLogger(d,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,d){const T=[[y,d]];this.isLoggerCreated?this.doLog(T):this.buffer.push(...T)}doLog(y){this.proxy.$log(this.file,y)}flush(){this.proxy.$flush(this.file)}}}),define(we[123],ye([1,0,6,5,3,20,22]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,g.createDecorator)("IExtHostManagedSockets");let R=class{constructor(y){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=y.getProxy(r.MainContext.MainThreadManagedSockets)}setFactory(y,d){for(const T of this._managedRemoteSockets.values())T.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new v(y,d),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(y){if(!this._factory||this._factory.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const d=++this._remoteSocketIdCounter,T=await this._factory.makeConnection(),E=new k.DisposableStore;return this._managedRemoteSockets.set(d,new l(d,T,E)),E.add((0,k.toDisposable)(()=>this._managedRemoteSockets.delete(d))),E.add(T.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(d),E.dispose()})),E.add(T.onDidClose(a=>{this._proxy.$onDidManagedSocketClose(d,a?.stack??a?.message),E.dispose()})),E.add(T.onDidReceiveMessage(a=>this._proxy.$onDidManagedSocketHaveData(d,L.VSBuffer.wrap(a)))),d}$remoteSocketWrite(y,d){this._managedRemoteSockets.get(y)?.actual.send(d.buffer)}$remoteSocketEnd(y){const d=this._managedRemoteSockets.get(y);d&&(d.actual.end(),d.dispose())}async $remoteSocketDrain(y){await this._managedRemoteSockets.get(y)?.actual.drain?.()}};e.ExtHostManagedSockets=R,e.ExtHostManagedSockets=R=Ke([Ve(0,A.IExtHostRpcService)],R);class v{constructor(y,d){this.socketFactoryId=y,this.makeConnection=d}}class l extends k.Disposable{constructor(y,d,T){super(),this.socketId=y,this.actual=d,this._register(T)}}}),define(we[330],ye([1,0,6,12,26]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(R){return R&&R.title}let L=class{constructor(v,l){this._logService=l,this._proxy=v.getProxy(r.MainContext.MainThreadMessageService)}showMessage(v,l,P,y,d){const T={source:{identifier:v.identifier,label:v.displayName||v.name}};let E;typeof y=="string"||A(y)?E=[y,...d]:(T.modal=y?.modal,T.useCustom=y?.useCustom,T.detail=y?.detail,E=d),T.useCustom&&(0,k.checkProposedApiEnabled)(v,"resolvers");const a=[];let u=!1;for(let f=0;f<E.length;f++){const m=E[f];if(typeof m=="string")a.push({title:m,handle:f,isCloseAffordance:!1});else if(typeof m=="object"){const{title:n,isCloseAffordance:s}=m;a.push({title:n,isCloseAffordance:!!s,handle:f}),s&&(u?this._logService.warn(`[${v.identifier}] Only one message item can have 'isCloseAffordance':`,m):u=!0)}else this._logService.warn(`[${v.identifier}] Invalid message item:`,m)}return this._proxy.$showMessage(l,P,T,a).then(f=>{if(typeof f=="number")return E[f]})}};e.ExtHostMessageService=L,e.ExtHostMessageService=L=Ke([Ve(1,g.ILogService)],L)}),define(we[331],ye([1,0,3,18,2,26,6]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(l){this.handlers=new Map,this.proxy=l.getProxy(L.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(l,P,y){if((0,A.checkProposedApiEnabled)(l,"profileContentHandlers"),this.handlers.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.handlers.set(P,y),this.proxy.$registerProfileContentHandler(P,y.name,y.description,l.identifier.value),(0,r.toDisposable)(()=>{this.handlers.delete(P),this.proxy.$unregisterProfileContentHandler(P)})}async $saveProfile(l,P,y,d){const T=this.handlers.get(l);if(!T)throw new Error(`Unknown handler with id: ${l}`);return T.saveProfile(P,y,d)}async $readProfile(l,P,y){const d=this.handlers.get(l);if(!d)throw new Error(`Unknown handler with id: ${l}`);return d.readProfile((0,g.isString)(P)?P:k.URI.revive(P),y)}}e.ExtHostProfileContentHandlers=R}),define(we[124],ye([1,0,6,4,5]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(R){this._onDidChangePassword=new g.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=R.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this._onDidChangePassword.fire(R)}get(R,v){return this._proxy.$getPassword(R,v)}store(R,v,l){return this._proxy.$setPassword(R,v,l)}delete(R,v){return this._proxy.$deletePassword(R,v)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(we[332],ye([1,0,21,3,6]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class A{static{this.ID_POOL=1}constructor(R){this.providers=new Map,this.sessions=new Map,this.synthesizers=new Map,this.proxy=R.getProxy(k.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(R,v,l){const P=this.providers.get(R);if(!P)return;const y=new g.DisposableStore,d=new r.CancellationTokenSource;this.sessions.set(v,d);const T=await P.provideSpeechToTextSession(d.token,l?{language:l}:void 0);T&&(y.add(T.onDidChange(E=>{d.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(v,E)})),y.add(d.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}async $createTextToSpeechSession(R,v,l){const P=this.providers.get(R);if(!P)return;const y=new g.DisposableStore,d=new r.CancellationTokenSource;this.sessions.set(v,d);const T=await P.provideTextToSpeechSession(d.token,l?{language:l}:void 0);T&&(this.synthesizers.set(v,T),y.add(T.onDidChange(E=>{d.token.isCancellationRequested||this.proxy.$emitTextToSpeechEvent(v,E)})),y.add(d.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(R,v){this.synthesizers.get(R)?.synthesize(v)}async $cancelTextToSpeechSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R),this.synthesizers.delete(R)}async $createKeywordRecognitionSession(R,v){const l=this.providers.get(R);if(!l)return;const P=new g.DisposableStore,y=new r.CancellationTokenSource;this.sessions.set(v,y);const d=await l.provideKeywordRecognitionSession(y.token);d&&(P.add(d.onDidChange(T=>{y.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(v,T)})),P.add(y.token.onCancellationRequested(()=>P.dispose())))}async $cancelKeywordRecognitionSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}registerProvider(R,v,l){const P=A.ID_POOL++;return this.providers.set(P,l),this.proxy.$registerProvider(P,v,{extension:R,displayName:R.value}),(0,g.toDisposable)(()=>{this.proxy.$unregisterProvider(P),this.providers.delete(P)})}}e.ExtHostSpeech=A}),define(we[125],ye([1,0,6,4,5]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(R,v){this._logService=v,this._onDidChangeStorage=new g.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=R.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,v){this._proxy.$registerExtensionStorageKeysToSync(R,v)}async initializeExtensionStorage(R,v,l){const P=await this._proxy.$initializeExtensionStorage(R,v);let y;return P&&(y=this.safeParseValue(R,v,P)),y||l}setValue(R,v,l){return this._proxy.$setValue(R,v,l)}$acceptValue(R,v,l){const P=this.safeParseValue(R,v,l);P&&this._onDidChangeStorage.fire({shared:R,key:v,value:P})}safeParseValue(R,v,l){try{return JSON.parse(l)}catch(P){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${R}): ${P}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(we[333],ye([1,0,3,15,2,6]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class L{static{this.supportedSchemes=new Set([g.Schemas.http,g.Schemas.https])}constructor(v){this._openers=new Map,this._proxy=v.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(v,l,P,y){if(this._openers.has(l))throw new Error(`Opener with id '${l}' already registered`);const d=y.schemes.find(T=>!L.supportedSchemes.has(T));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(l,P),this._proxy.$registerUriOpener(l,y.schemes,v,y.label),(0,r.toDisposable)(()=>{this._openers.delete(l),this._proxy.$unregisterUriOpener(l)})}async $canOpenUri(v,l,P){const y=this._openers.get(v);if(!y)throw new Error(`Unknown opener with id: ${v}`);const d=k.URI.revive(l);return y.canOpenExternalUri(d,P)}async $openUri(v,l,P){const y=this._openers.get(v);if(!y)throw new Error(`Unknown opener id: '${v}'`);return y.openExternalUri(k.URI.revive(l.resolvedUri),{sourceUri:k.URI.revive(l.sourceUri)},P)}}e.ExtHostUriOpeners=L}),define(we[334],ye([1,0,6,2,3,14,24]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{static{this.HandlePool=0}constructor(l){this.handles=new L.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=l.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(l,P){const y=l.identifier;if(this.handles.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const d=R.HandlePool++;return this.handles.add(y),this.handlers.set(d,P),this._proxy.$registerUriHandler(d,y,l.displayName||l.name),(0,k.toDisposable)(()=>{this.handles.delete(y),this.handlers.delete(d),this._proxy.$unregisterUriHandler(d)})}$handleExternalUri(l,P){const y=this.handlers.get(l);if(!y)return Promise.resolve(void 0);try{y.handleUri(g.URI.revive(P))}catch(d){(0,A.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(l){return g.URI.revive(await this._proxy.$createAppUri(l))}}e.ExtHostUrls=R}),define(we[335],ye([1,0,22,6]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=A,e.deserializeWebviewMessage=R;class k{constructor(){this.buffers=[]}add(l){let P=this.buffers.indexOf(l);return P<0&&(P=this.buffers.length,this.buffers.push(l)),P}}function A(v,l){if(l.serializeBuffersForPostMessage){const P=new k,d=JSON.stringify(v,(E,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:P.add(a)};if(ArrayBuffer.isView(a)){const u=L(a);if(u)return{$$vscode_array_buffer_reference$$:!0,index:P.add(a.buffer),view:{type:u,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),T=P.buffers.map(E=>{const a=new Uint8Array(E);return r.VSBuffer.wrap(a)});return{message:d,buffers:T}}else return{message:JSON.stringify(v),buffers:[]}}function L(v){switch(v.constructor.name){case"Int8Array":return g.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return g.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return g.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return g.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return g.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return g.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return g.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return g.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return g.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return g.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return g.WebviewMessageArrayBufferViewType.BigUint64Array}}function R(v,l){const P=l.map(T=>{const E=new ArrayBuffer(T.byteLength);return new Uint8Array(E).set(T.buffer),E}),y=l.length?(T,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const a=E,{index:u}=a,f=P[u];if(a.view)switch(a.view.type){case g.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(f,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case g.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(f,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case g.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(f,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case g.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(f,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case g.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(f,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case g.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(f,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case g.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(f,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case g.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(f,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case g.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(f,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case g.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(f,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case g.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(f,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return E}:void 0;return{message:JSON.parse(v,y),arrayBuffers:P}}}),define(we[97],ye([1,0,4,3,15,25,2,262,335,121,6]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=d,e.toExtensionData=a,e.serializeWebviewOptions=u;class y{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;constructor(s,i,t,c,h,o,p){this.#a="",this.#l=!1,this.#c=!1,this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new r.Emitter,this._onDidDispose=this.#d.event,this.#e=s,this.#t=i,this.#o=t,this.#n=c,this.#s=h,this.#r=o,this.#u=d(o),this.#h=T(o),this.#i=p}#d;dispose(){this.#l=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#c=!0,(0,l.asWebviewUri)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===k.Schemas.https||s.scheme===k.Schemas.http){let i=s.toString();return i.endsWith("/")||(i+="/"),i+" "+l.webviewGenericCspSource}return l.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(s){this.assertNotDisposed(),this.#a!==s&&(this.#a=s,this.#h&&!this.#c&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#c=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(s)))}get options(){return this.assertNotDisposed(),this.#o}set options(s){this.assertNotDisposed(),A.equals(this.#o,s)||this.#t.$setOptions(this.#e,u(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#l)return!1;const i=(0,v.serializeWebviewMessage)(s,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,i.message,...i.buffers)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(s){if(!this.#h)return s;const i=this.#r.extensionLocation?.scheme===k.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===k.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,h,o,p,_,D)=>{const C=L.URI.from({scheme:p||"file",path:decodeURIComponent(_)}),S=(0,l.asWebviewUri)(C,{isRemote:i,authority:t}).toString();return`${h}${S}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,h,o,p,_,D)=>{const C=L.URI.from({scheme:p||"file",path:decodeURIComponent(_)}),S=(0,l.asWebviewUri)(C,{isRemote:i,authority:t}).toString();return`${h}${S}${D}`})}}e.ExtHostWebview=y;function d(n){try{const s=(0,R.normalizeVersion)((0,R.parseVersion)(n.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function T(n){try{const s=(0,R.normalizeVersion)((0,R.parseVersion)(n.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class E extends g.Disposable{constructor(s,i,t,c,h){super(),this.remoteInfo=i,this.workspace=t,this._logService=c,this._deprecationService=h,this._webviews=new Map,this._webviewProxy=s.getProxy(P.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const s of this._webviews.values())s.dispose();this._webviews.clear()}$onMessage(s,i,t){const c=this.getWebview(s);if(c){const{message:h}=(0,v.deserializeWebviewMessage)(i,t.value);c._onMessageEmitter.fire(h)}}$onMissingCsp(s,i){this._logService.warn(`${i} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,i,t){const c=new y(s,this._webviewProxy,f(i),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(s,c);const h=c._onDidDispose(()=>{h.dispose(),this.deleteWebview(s)});return c}deleteWebview(s){this._webviews.delete(s)}getWebview(s){return this._webviews.get(s)}}e.ExtHostWebviews=E;function a(n){return{id:n.identifier,location:n.extensionLocation}}function u(n,s,i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots||m(n,s)}}function f(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(s=>L.URI.from(s))}}function m(n,s){return[...(s?.getWorkspaceFolders()||[]).map(i=>i.uri),n.extensionLocation]}}),define(we[160],ye([1,0,4,15,13,2,5,20,6]),function(he,e,r,g,k,A,L,R,v){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class{static{l=this}static{this.InitialState={focused:!0,active:!0}}getState(){const d=this._state;return{get focused(){return d.focused},get active(){return d.active}}}constructor(d){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=l.InitialState,this._proxy=d.getProxy(v.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:T,isActive:E})=>{this.onDidChangeWindowProperty("focused",T),this.onDidChangeWindowProperty("active",E)})}$onDidChangeWindowFocus(d){this.onDidChangeWindowProperty("focused",d)}$onDidChangeWindowActive(d){this.onDidChangeWindowProperty("active",d)}onDidChangeWindowProperty(d,T){T!==this._state[d]&&(this._state={...this._state,[d]:T},this._onDidChangeWindowState.fire(this._state))}openUri(d,T){let E;if(typeof d=="string"){E=d;try{d=A.URI.parse(d)}catch{return Promise.reject(`Invalid uri - '${d}'`)}}return(0,k.isFalsyOrWhitespace)(d.scheme)?Promise.reject("Invalid scheme - cannot be empty"):d.scheme===g.Schemas.command?Promise.reject(`Invalid scheme '${d.scheme}'`):this._proxy.$openUri(d,E,T)}async asExternalUri(d,T){if((0,k.isFalsyOrWhitespace)(d.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(d,T);return A.URI.from(E)}};e.ExtHostWindow=P,e.ExtHostWindow=P=l=Ke([Ve(0,R.IExtHostRpcService)],P),e.IExtHostWindow=(0,L.createDecorator)("IExtHostWindow")}),define(we[336],ye([1,0,326,30,20,94]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const L=1024*1024;let R=class extends r.AbstractExtHostConsoleForwarder{constructor(l,P){super(l,P),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(l,P,y){const d=l==="error"||l==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,d.write(`
${A.NativeLogMarkers.Start}
`),P.apply(console,y),d.write(`
${A.NativeLogMarkers.End}
`),this._isMakingConsoleCall=!1}_wrapStream(l,P){const y=process[l],d=y.write;let T="";Object.defineProperty(y,"write",{set:()=>{},get:()=>(E,a,u)=>{if(!this._isMakingConsoleCall){T+=E.toString(a);const f=T.length>L?T.length:T.lastIndexOf(`
`);f!==-1&&(console[P](T.slice(0,f)),T=T.slice(f+1))}d.call(y,E,a,u)}})}};e.ExtHostConsoleForwarder=R,e.ExtHostConsoleForwarder=R=Ke([Ve(0,k.IExtHostRpcService),Ve(1,g.IExtHostInitDataService)],R)}),define(we[337],ye([1,0,159,15,278,32]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class L extends r.ExtHostLoggerService{doCreateLogger(v,l,P){return v.scheme===g.Schemas.file?new k.SpdLogLogger(P?.name||(0,A.generateUuid)(),v.fsPath,!P?.donotRotate,!!P?.donotUseFormatters,l):super.doCreateLogger(v,l,P)}registerLogger(v){super.registerLogger(v),this._proxy.$registerLogger(v)}deregisterLogger(v){super.deregisterLogger(v),this._proxy.$deregisterLogger(v)}}e.ExtHostLoggerService=L}),define(we[338],ye([1,0,9,22,21,27,14,4,3,41,141,324,52]),function(he,e,r,g,k,A,L,R,v,l,P,y,d){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=m,e.parseJsonAndRestoreBufferRefs=n;function E(N,O){try{return JSON.stringify(N,O)}catch{return"null"}}const a="$$ref$$",u={[a]:-1};class f{constructor(O,U){this.jsonString=O,this.referencedBuffers=U}}function m(N,O=null,U=!1){const x=[];return{jsonString:(U?E:JSON.stringify)(N,(F,M)=>{if(typeof M>"u")return u;if(typeof M=="object"){if(M instanceof g.VSBuffer){const K=x.push(M)-1;return{[a]:K}}if(O)return O(F,M)}return M}),referencedBuffers:x}}function n(N,O,U){return JSON.parse(N,(x,B)=>{if(B){const F=B[a];if(typeof F=="number")return O[F];if(U&&B.$mid===l.MarshalledId.Uri)return U.transformIncoming(B)}return B})}function s(N,O){return JSON.stringify(N,O)}function i(N){return N?(O,U)=>U&&U.$mid===l.MarshalledId.Uri?N.transformOutgoing(U):U:null}var t;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(t||(e.RequestInitiator=t={}));var c;(function(N){N[N.Responsive=0]="Responsive",N[N.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const h=()=>{},o=Symbol.for("rpcProtocol"),p=Symbol.for("rpcProxy");class _ extends v.Disposable{static{T=o}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(O,U=null,x=null){super(),this[T]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=O,this._logger=U,this._uriTransformer=x,this._uriReplacer=i(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let B=0,F=d.ProxyIdentifier.count;B<F;B++)this._locals[B]=null,this._proxies[B]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=c.Responsive,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(B=>this._receiveOneMessage(B))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(O=>{const U=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],U.resolveErr(L.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(O){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+_.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(O){this._unresponsiveTime=Date.now()+_.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(c.Responsive)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(c.Unresponsive):this._asyncCheckUresponsive.schedule())}_setResponsiveState(O){this._responsiveState!==O&&(this._responsiveState=O,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(O){return this._uriTransformer?(0,P.transformIncomingURIs)(O,this._uriTransformer):O}getProxy(O){const{nid:U,sid:x}=O;return this._proxies[U]||(this._proxies[U]=this._createProxy(U,x)),this._proxies[U]}_createProxy(O,U){const x={get:(B,F)=>(typeof F=="string"&&!B[F]&&F.charCodeAt(0)===A.CharCode.DollarSign&&(B[F]=(...M)=>this._remoteCall(O,F,M)),F===p?U:B[F])};return new Proxy(Object.create(null),x)}set(O,U){return this._locals[O.nid]=U,U}assertRegistered(O){for(let U=0,x=O.length;U<x;U++){const B=O[U];if(!this._locals[B.nid])throw new Error(`Missing proxy instance ${B.sid}`)}}_receiveOneMessage(O){if(this._isDisposed)return;const U=O.byteLength,x=C.read(O,0),B=x.readUInt8(),F=x.readUInt32();switch(B){case b.RequestJSONArgs:case b.RequestJSONArgsWithCancellation:{let{rpcId:M,method:K,args:ee}=I.deserializeRequestJSONArgs(x);this._uriTransformer&&(ee=(0,P.transformIncomingURIs)(ee,this._uriTransformer)),this._receiveRequest(U,F,M,K,ee,B===b.RequestJSONArgsWithCancellation);break}case b.RequestMixedArgs:case b.RequestMixedArgsWithCancellation:{let{rpcId:M,method:K,args:ee}=I.deserializeRequestMixedArgs(x);this._uriTransformer&&(ee=(0,P.transformIncomingURIs)(ee,this._uriTransformer)),this._receiveRequest(U,F,M,K,ee,B===b.RequestMixedArgsWithCancellation);break}case b.Acknowledged:{this._logger?.logIncoming(U,F,t.LocalSide,"ack"),this._onDidReceiveAcknowledge(F);break}case b.Cancel:{this._receiveCancel(U,F);break}case b.ReplyOKEmpty:{this._receiveReply(U,F,void 0);break}case b.ReplyOKJSON:{let M=I.deserializeReplyOKJSON(x);this._uriTransformer&&(M=(0,P.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(U,F,M);break}case b.ReplyOKJSONWithBuffers:{const M=I.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(U,F,M);break}case b.ReplyOKVSBuffer:{const M=I.deserializeReplyOKVSBuffer(x);this._receiveReply(U,F,M);break}case b.ReplyErrError:{let M=I.deserializeReplyErrError(x);this._uriTransformer&&(M=(0,P.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(U,F,M);break}case b.ReplyErrEmpty:{this._receiveReplyErr(U,F,void 0);break}default:console.error("received unexpected message"),console.error(O)}}_receiveRequest(O,U,x,B,F,M){this._logger?.logIncoming(O,U,t.OtherSide,`receiveRequest ${(0,d.getStringIdentifierForProxy)(x)}.${B}(`,F);const K=String(U);let ee,$;if(M){const Z=new k.CancellationTokenSource;F.push(Z.token),ee=this._invokeHandler(x,B,F),$=()=>Z.cancel()}else ee=this._invokeHandler(x,B,F),$=h;this._cancelInvokedHandlers[K]=$;const q=I.serializeAcknowledged(U);this._logger?.logOutgoing(q.byteLength,U,t.OtherSide,"ack"),this._protocol.send(q),ee.then(Z=>{delete this._cancelInvokedHandlers[K];const ne=I.serializeReplyOK(U,Z,this._uriReplacer);this._logger?.logOutgoing(ne.byteLength,U,t.OtherSide,"reply:",Z),this._protocol.send(ne)},Z=>{delete this._cancelInvokedHandlers[K];const ne=I.serializeReplyErr(U,Z);this._logger?.logOutgoing(ne.byteLength,U,t.OtherSide,"replyErr:",Z),this._protocol.send(ne)})}_receiveCancel(O,U){this._logger?.logIncoming(O,U,t.OtherSide,"receiveCancel");const x=String(U);this._cancelInvokedHandlers[x]?.()}_receiveReply(O,U,x){this._logger?.logIncoming(O,U,t.LocalSide,"receiveReply:",x);const B=String(U);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B],F.resolveOk(x)}_receiveReplyErr(O,U,x){this._logger?.logIncoming(O,U,t.LocalSide,"receiveReplyErr:",x);const B=String(U);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B];let M;x&&(x.$isError?(M=new Error,M.name=x.name,M.message=x.message,M.stack=x.stack):M=x),F.resolveErr(M)}_invokeHandler(O,U,x){try{return Promise.resolve(this._doInvokeHandler(O,U,x))}catch(B){return Promise.reject(B)}}_doInvokeHandler(O,U,x){const B=this._locals[O];if(!B)throw new Error("Unknown actor "+(0,d.getStringIdentifierForProxy)(O));const F=B[U];if(typeof F!="function")throw new Error("Unknown method "+U+" on actor "+(0,d.getStringIdentifierForProxy)(O));return F.apply(B,x)}_remoteCall(O,U,x){if(this._isDisposed)return new y.CanceledLazyPromise;let B=null;if(x.length>0&&k.CancellationToken.isCancellationToken(x[x.length-1])&&(B=x.pop()),B&&B.isCancellationRequested)return Promise.reject(L.canceled());const F=I.serializeRequestArguments(x,this._uriReplacer),M=++this._lastMessageId,K=String(M),ee=new y.LazyPromise,$=new v.DisposableStore;B&&$.add(B.onCancellationRequested(()=>{const Z=I.serializeCancel(M);this._logger?.logOutgoing(Z.byteLength,M,t.LocalSide,"cancel"),this._protocol.send(I.serializeCancel(M))})),this._pendingRPCReplies[K]=new D(ee,$),this._onWillSendRequest(M);const q=I.serializeRequest(M,O,U,F,!!B);return this._logger?.logOutgoing(q.byteLength,M,t.LocalSide,`request: ${(0,d.getStringIdentifierForProxy)(O)}.${U}(`,x),this._protocol.send(q),ee}}e.RPCProtocol=_;class D{constructor(O,U){this._promise=O,this._disposable=U}resolveOk(O){this._promise.resolveOk(O),this._disposable.dispose()}resolveErr(O){this._promise.resolveErr(O),this._disposable.dispose()}}class C{static alloc(O,U,x){const B=new C(g.VSBuffer.alloc(x+1+4),0);return B.writeUInt8(O),B.writeUInt32(U),B}static read(O,U){return new C(O,U)}get buffer(){return this._buff}constructor(O,U){this._buff=O,this._offset=U}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this._buff.writeUInt8(O,this._offset),this._offset+=1}readUInt8(){const O=this._buff.readUInt8(this._offset);return this._offset+=1,O}writeUInt32(O){this._buff.writeUInt32BE(O,this._offset),this._offset+=4}readUInt32(){const O=this._buff.readUInt32BE(this._offset);return this._offset+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this._buff.writeUInt8(O.byteLength,this._offset),this._offset+=1,this._buff.set(O,this._offset),this._offset+=O.byteLength}readShortString(){const O=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+O).toString();return this._offset+=O,x}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}readLongString(){const O=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+O).toString();return this._offset+=O,x}writeBuffer(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}readVSBuffer(){const O=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+O);return this._offset+=O,U}static sizeMixedArray(O){let U=0;U+=1;for(let x=0,B=O.length;x<B;x++){const F=O[x];switch(U+=1,F.type){case w.String:U+=this.sizeLongString(F.value);break;case w.VSBuffer:U+=this.sizeVSBuffer(F.value);break;case w.SerializedObjectWithBuffers:U+=this.sizeUInt32,U+=this.sizeLongString(F.value);for(let M=0;M<F.buffers.length;++M)U+=this.sizeVSBuffer(F.buffers[M]);break;case w.Undefined:break}}return U}writeMixedArray(O){this._buff.writeUInt8(O.length,this._offset),this._offset+=1;for(let U=0,x=O.length;U<x;U++){const B=O[U];switch(B.type){case w.String:this.writeUInt8(w.String),this.writeLongString(B.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(B.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let F=0;F<B.buffers.length;++F)this.writeBuffer(B.buffers[F]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const O=this._buff.readUInt8(this._offset);this._offset+=1;const U=new Array(O);for(let x=0;x<O;x++)switch(this.readUInt8()){case w.String:U[x]=this.readLongString();break;case w.VSBuffer:U[x]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const F=this.readUInt32(),M=this.readLongString(),K=[];for(let ee=0;ee<F;++ee)K.push(this.readVSBuffer());U[x]=new d.SerializableObjectWithBuffers(n(M,K,null));break}case w.Undefined:U[x]=void 0;break}return U}}var S;(function(N){N[N.Simple=0]="Simple",N[N.Mixed=1]="Mixed"})(S||(S={}));class I{static _useMixedArgSerialization(O){for(let U=0,x=O.length;U<x;U++)if(O[U]instanceof g.VSBuffer||O[U]instanceof d.SerializableObjectWithBuffers||typeof O[U]>"u")return!0;return!1}static serializeRequestArguments(O,U){if(this._useMixedArgSerialization(O)){const x=[];for(let B=0,F=O.length;B<F;B++){const M=O[B];if(M instanceof g.VSBuffer)x[B]={type:w.VSBuffer,value:M};else if(typeof M>"u")x[B]={type:w.Undefined};else if(M instanceof d.SerializableObjectWithBuffers){const{jsonString:K,referencedBuffers:ee}=m(M.value,U);x[B]={type:w.SerializedObjectWithBuffers,value:g.VSBuffer.fromString(K),buffers:ee}}else x[B]={type:w.String,value:g.VSBuffer.fromString(s(M,U))}}return{type:S.Mixed,args:x}}return{type:S.Simple,args:s(O,U)}}static serializeRequest(O,U,x,B,F){switch(B.type){case S.Simple:return this._requestJSONArgs(O,U,x,B.args,F);case S.Mixed:return this._requestMixedArgs(O,U,x,B.args,F)}}static _requestJSONArgs(O,U,x,B,F){const M=g.VSBuffer.fromString(x),K=g.VSBuffer.fromString(B);let ee=0;ee+=C.sizeUInt8(),ee+=C.sizeShortString(M),ee+=C.sizeLongString(K);const $=C.alloc(F?b.RequestJSONArgsWithCancellation:b.RequestJSONArgs,O,ee);return $.writeUInt8(U),$.writeShortString(M),$.writeLongString(K),$.buffer}static deserializeRequestJSONArgs(O){const U=O.readUInt8(),x=O.readShortString(),B=O.readLongString();return{rpcId:U,method:x,args:JSON.parse(B)}}static _requestMixedArgs(O,U,x,B,F){const M=g.VSBuffer.fromString(x);let K=0;K+=C.sizeUInt8(),K+=C.sizeShortString(M),K+=C.sizeMixedArray(B);const ee=C.alloc(F?b.RequestMixedArgsWithCancellation:b.RequestMixedArgs,O,K);return ee.writeUInt8(U),ee.writeShortString(M),ee.writeMixedArray(B),ee.buffer}static deserializeRequestMixedArgs(O){const U=O.readUInt8(),x=O.readShortString(),B=O.readMixedArray(),F=new Array(B.length);for(let M=0,K=B.length;M<K;M++){const ee=B[M];typeof ee=="string"?F[M]=JSON.parse(ee):F[M]=ee}return{rpcId:U,method:x,args:F}}static serializeAcknowledged(O){return C.alloc(b.Acknowledged,O,0).buffer}static serializeCancel(O){return C.alloc(b.Cancel,O,0).buffer}static serializeReplyOK(O,U,x){if(typeof U>"u")return this._serializeReplyOKEmpty(O);if(U instanceof g.VSBuffer)return this._serializeReplyOKVSBuffer(O,U);if(U instanceof d.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:F}=m(U.value,x,!0);return this._serializeReplyOKJSONWithBuffers(O,B,F)}else return this._serializeReplyOKJSON(O,E(U,x))}static _serializeReplyOKEmpty(O){return C.alloc(b.ReplyOKEmpty,O,0).buffer}static _serializeReplyOKVSBuffer(O,U){let x=0;x+=C.sizeVSBuffer(U);const B=C.alloc(b.ReplyOKVSBuffer,O,x);return B.writeVSBuffer(U),B.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static _serializeReplyOKJSON(O,U){const x=g.VSBuffer.fromString(U);let B=0;B+=C.sizeLongString(x);const F=C.alloc(b.ReplyOKJSON,O,B);return F.writeLongString(x),F.buffer}static _serializeReplyOKJSONWithBuffers(O,U,x){const B=g.VSBuffer.fromString(U);let F=0;F+=C.sizeUInt32,F+=C.sizeLongString(B);for(const K of x)F+=C.sizeVSBuffer(K);const M=C.alloc(b.ReplyOKJSONWithBuffers,O,F);M.writeUInt32(x.length),M.writeLongString(B);for(const K of x)M.writeBuffer(K);return M.buffer}static deserializeReplyOKJSON(O){const U=O.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(O,U){const x=O.readUInt32(),B=O.readLongString(),F=[];for(let M=0;M<x;++M)F.push(O.readVSBuffer());return new d.SerializableObjectWithBuffers(n(B,F,U))}static serializeReplyErr(O,U){const x=U?E(L.transformErrorForSerialization(U),null):void 0;if(typeof x!="string")return this._serializeReplyErrEmpty(O);const B=g.VSBuffer.fromString(x);let F=0;F+=C.sizeLongString(B);const M=C.alloc(b.ReplyErrError,O,F);return M.writeLongString(B),M.buffer}static deserializeReplyErrError(O){const U=O.readLongString();return JSON.parse(U)}static _serializeReplyErrEmpty(O){return C.alloc(b.ReplyErrEmpty,O,0).buffer}}var b;(function(N){N[N.RequestJSONArgs=1]="RequestJSONArgs",N[N.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",N[N.RequestMixedArgs=3]="RequestMixedArgs",N[N.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",N[N.Acknowledged=5]="Acknowledged",N[N.Cancel=6]="Cancel",N[N.ReplyOKEmpty=7]="ReplyOKEmpty",N[N.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",N[N.ReplyOKJSON=9]="ReplyOKJSON",N[N.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",N[N.ReplyErrError=11]="ReplyErrError",N[N.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var w;(function(N){N[N.String=1]="String",N[N.VSBuffer=2]="VSBuffer",N[N.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",N[N.Undefined=4]="Undefined"})(w||(w={}))}),define(we[339],ye([1,0,22,29,15,89,5]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=P,e.generate=y,e.INotebookDocumentService=(0,L.createDecorator)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${R.join("")}]+`),l=7;function P(T){if(T.scheme!==k.Schemas.vscodeNotebookCell)return;const E=T.fragment.indexOf("s");if(E<0)return;const a=parseInt(T.fragment.substring(0,E).replace(v,""),l),u=(0,r.decodeBase64)(T.fragment.substring(E+1)).toString();if(!isNaN(a))return{handle:a,notebook:T.with({scheme:u,fragment:null})}}function y(T,E){const a=E.toString(l),f=`${a.length<R.length?R[a.length-1]:"z"}${a}s${(0,r.encodeBase64)(r.VSBuffer.fromString(T.scheme),!0,!0)}`;return T.with({scheme:k.Schemas.vscodeNotebookCell,fragment:f})}class d{constructor(){this._documents=new g.ResourceMap}getNotebook(E){if(E.scheme===k.Schemas.vscodeNotebookCell){const a=P(E);if(a){const u=this._documents.get(a.notebook);if(u)return u}}return this._documents.get(E)}addNotebookDocument(E){this._documents.set(E.uri,E)}removeNotebookDocument(E){this._documents.delete(E.uri)}}e.NotebookDocumentWorkbenchService=d,(0,A.registerSingleton)(e.INotebookDocumentService,d,A.InstantiationType.Delayed)}),define(we[126],ye([1,0,22,39,40,107,15,16,11,35,339]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=c,e.isDocumentExcludePattern=o,e.notebookDocumentFilterMatch=p,e.isTextStreamMime=C,e.compressOutputItemStreams=I,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var y;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(y||(e.CellKind=y={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var d;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(d||(e.NotebookRunState=d={}));var T;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(T||(e.NotebookCellExecutionState=T={}));var E;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(E||(e.NotebookExecutionState=E={}));var a;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var u;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(u||(e.RendererMessagingSpec=u={}));var f;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var m;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(m||(e.SelectionStateType=m={}));var n;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var s;(function(M){M.scheme=L.Schemas.vscodeNotebookCell;function K(de,re){return(0,P.generate)(de,re)}M.generate=K;function ee(de){return(0,P.parse)(de)}M.parse=ee;function $(de,re){return de.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${de.scheme!==L.Schemas.file?de.scheme:""}`})}M.generateCellOutputUri=$;function q(de){if(de.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(de.fragment);if(!re)return;const Se=re[1]&&re[1]!==""?re[1]:void 0,ve=re[2];return{outputId:Se,notebook:de.with({scheme:ve||L.Schemas.file,fragment:null})}}M.parseCellOutputUri=q;function Z(de,re,Se){return M.generate(de,re).with({scheme:Se})}M.generateCellPropertyUri=Z;function ne(de,re){if(de.scheme===re)return M.parse(de.with({scheme:M.scheme}))}M.parseCellPropertyUri=ne})(s||(e.CellUri=s={}));const i=M=>v.isWindows?M.replace(/\//g,"\\"):M;class t{constructor(K=[],ee=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=ee,this.order=[...new Set(K)].map($=>({pattern:$,matches:g.parse(i($))}))}sort(K){const ee=new Map(k.Iterable.map(K,q=>[q,i(q)]));let $=[];for(const{matches:q}of this.order)for(const[Z,ne]of ee)if(q(ne)){$.push(Z),ee.delete(Z);break}return ee.size&&($=$.concat([...ee.keys()].sort((q,Z)=>this.defaultOrder.indexOf(q)-this.defaultOrder.indexOf(Z)))),$}prioritize(K,ee){const $=this.findIndex(K);if($===-1){this.order.unshift({pattern:K,matches:g.parse(i(K))});return}const q=new Set(ee.map(ne=>this.findIndex(ne,$)));q.delete(-1);const Z=Array.from(q).sort();this.order.splice($+1,0,...Z.map(ne=>this.order[ne]));for(let ne=Z.length-1;ne>=0;ne--)this.order.splice(Z[ne],1)}toArray(){return this.order.map(K=>K.pattern)}findIndex(K,ee=this.order.length){const $=i(K);for(let q=0;q<ee;q++)if(this.order[q].matches($))return q;return-1}}e.MimeTypeDisplayOrder=t;function c(M,K,ee,$=(q,Z)=>q===Z){const q=[];function Z(re,Se,ve){if(Se===0&&ve.length===0)return;const G=q[q.length-1];G&&G.start+G.deleteCount===re?(G.deleteCount+=Se,G.toInsert.push(...ve)):q.push({start:re,deleteCount:Se,toInsert:ve})}let ne=0,de=0;for(;;){if(ne===M.length){Z(ne,0,K.slice(de));break}if(de===K.length){Z(ne,M.length-ne,[]);break}const re=M[ne],Se=K[de];if($(re,Se)){ne+=1,de+=1;continue}ee(Se)?(Z(ne,1,[]),ne+=1):(Z(ne,0,[Se]),de+=1)}return q}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new l.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new l.RawContextKey("notebookEditorCursorAtLineBoundary","none");var h;(function(M){M.default="default",M.option="option"})(h||(e.NotebookEditorPriority=h={}));function o(M){const K=M;return!!((typeof K.include=="string"||g.isRelativePattern(K.include))&&(typeof K.exclude=="string"||g.isRelativePattern(K.exclude)))}function p(M,K,ee){if(Array.isArray(M.viewType)&&M.viewType.indexOf(K)>=0||M.viewType===K)return!0;if(M.filenamePattern){const $=o(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,q=o(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(g.match($,(0,R.basename)(ee.fsPath).toLowerCase()))return!(q&&g.match(q,(0,R.basename)(ee.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var _;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(_||(e.CellStatusbarAlignment=_={}));class D{static{this._prefix="notebook/"}static create(K){return`${D._prefix}${K}`}static parse(K){if(K.startsWith(D._prefix))return K.substring(D._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=D;function C(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}const S=new TextDecoder;function I(M){const K=[];let ee=!1;for(const ne of M)(K.length===0||ee)&&(K.push(ne),ee=!0);let $=N(K);const q=r.VSBuffer.concat(K.map(ne=>r.VSBuffer.wrap(ne))),Z=F(q);return $=$||Z.byteLength!==q.byteLength,{data:Z,didCompression:$}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const b=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(M=>M.charCodeAt(0)),w=10;function N(M){let K=!1;return M.forEach((ee,$)=>{if($===0||ee.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const q=M[$-1],Z=ee.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(Z[0]===b[0]&&Z[1]===b[1]&&Z[2]===b[2]){const ne=q.lastIndexOf(w);if(ne===-1)return;K=!0,M[$-1]=q.subarray(0,ne),M[$]=ee.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),K}function O(M){let K=M;do M=K,K=M.replace(/[^\n]\x08/gm,"");while(K.length<M.length);return M}function U(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const K=M.match(/^(.*)\r+/m)[1];let ee=M.match(/\r+(.*)$/m)[1];ee=ee+K.slice(ee.length,K.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return M}const x=8,B=13;function F(M){return!M.buffer.includes(x)&&!M.buffer.includes(B)?M:r.VSBuffer.fromString(U(O(S.decode(M.buffer))))}}),define(we[10],ye([1,0,19,14,86,29,107,13,18,2,32,24,28,71,126]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E){"use strict";var a,u,f,m,n,s,i,t,c,h,o,p,_,D,C,S,I;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseTextEditPart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart2=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugThread=e.DebugStackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropOrPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.HoverVerbosityAction=e.VerboseHover=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.asStatusBarItemIdentifier=at,e.setBreakpointId=ki,e.validateTestCoverageCount=_n;function b(j){return Object.assign(j,{apply:function(...me){if(me.length===0)return Reflect.construct(j,[]);{const Oe=me.length===1?[]:me[1];return Reflect.construct(j,Oe,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(j,[]);{const[Oe,...Xe]=me;return Reflect.construct(j,Xe,Oe.constructor)}}})}var w;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var N;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let O=a=class{static from(...V){let me=V;return new a(function(){if(me){for(const Oe of me)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();me=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=O,e.Disposable=O=a=Ke([b],O);let U=u=class{static Min(...V){if(V.length===0)throw new TypeError;let me=V[0];for(let Oe=1;Oe<V.length;Oe++){const Xe=V[Oe];Xe.isBefore(me)&&(me=Xe)}return me}static Max(...V){if(V.length===0)throw new TypeError;let me=V[0];for(let Oe=1;Oe<V.length;Oe++){const Xe=V[Oe];Xe.isAfter(me)&&(me=Xe)}return me}static isPosition(V){if(!V)return!1;if(V instanceof u)return!0;const{line:me,character:Oe}=V;return typeof me=="number"&&typeof Oe=="number"}static of(V){if(V instanceof u)return V;if(this.isPosition(V))return new u(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(V,me){if(V<0)throw(0,g.illegalArgument)("line must be non-negative");if(me<0)throw(0,g.illegalArgument)("character must be non-negative");this._line=V,this._character=me}isBefore(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<V._character}isBeforeOrEqual(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<=V._character}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this._line===V._line&&this._character===V._character}compareTo(V){return this._line<V._line?-1:this._line>V.line?1:this._character<V._character?-1:this._character>V._character?1:0}translate(V,me=0){if(V===null||me===null)throw(0,g.illegalArgument)();let Oe;return typeof V>"u"?Oe=0:typeof V=="number"?Oe=V:(Oe=typeof V.lineDelta=="number"?V.lineDelta:0,me=typeof V.characterDelta=="number"?V.characterDelta:0),Oe===0&&me===0?this:new u(this.line+Oe,this.character+me)}with(V,me=this.character){if(V===null||me===null)throw(0,g.illegalArgument)();let Oe;return typeof V>"u"?Oe=this.line:typeof V=="number"?Oe=V:(Oe=typeof V.line=="number"?V.line:this.line,me=typeof V.character=="number"?V.character:this.character),Oe===this.line&&me===this.character?this:new u(Oe,me)}toJSON(){return{line:this.line,character:this.character}}};e.Position=U,e.Position=U=u=Ke([b],U);let x=f=class{static isRange(V){return V instanceof f?!0:V?U.isPosition(V.start)&&U.isPosition(V.end):!1}static of(V){if(V instanceof f)return V;if(this.isRange(V))return new f(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(V,me,Oe,Xe){let nt,gt;if(typeof V=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Xe=="number"?(nt=new U(V,me),gt=new U(Oe,Xe)):U.isPosition(V)&&U.isPosition(me)&&(nt=U.of(V),gt=U.of(me)),!nt||!gt)throw new Error("Invalid arguments");nt.isBefore(gt)?(this._start=nt,this._end=gt):(this._start=gt,this._end=nt)}contains(V){return f.isRange(V)?this.contains(V.start)&&this.contains(V.end):U.isPosition(V)?!(U.of(V).isBefore(this._start)||this._end.isBefore(V)):!1}isEqual(V){return this._start.isEqual(V._start)&&this._end.isEqual(V._end)}intersection(V){const me=U.Max(V.start,this._start),Oe=U.Min(V.end,this._end);if(!me.isAfter(Oe))return new f(me,Oe)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const me=U.Min(V.start,this._start),Oe=U.Max(V.end,this.end);return new f(me,Oe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(V,me=this.end){if(V===null||me===null)throw(0,g.illegalArgument)();let Oe;return V?U.isPosition(V)?Oe=V:(Oe=V.start||this.start,me=V.end||this.end):Oe=this.start,Oe.isEqual(this._start)&&me.isEqual(this.end)?this:new f(Oe,me)}toJSON(){return[this.start,this.end]}};e.Range=x,e.Range=x=f=Ke([b],x);let B=m=class extends x{static isSelection(V){return V instanceof m?!0:V?x.isRange(V)&&U.isPosition(V.anchor)&&U.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(V,me,Oe,Xe){let nt,gt;if(typeof V=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Xe=="number"?(nt=new U(V,me),gt=new U(Oe,Xe)):U.isPosition(V)&&U.isPosition(me)&&(nt=U.of(V),gt=U.of(me)),!nt||!gt)throw new Error("Invalid arguments");super(nt,gt),this._anchor=nt,this._active=gt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=B,e.Selection=B=m=Ke([b],B);const F=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,g.illegalArgument)("connectionToken")};class M{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,me,Oe){if(typeof V!="string"||V.length===0)throw(0,g.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,g.illegalArgument)("port");typeof Oe<"u"&&F(Oe),this.host=V,this.port=Math.round(me),this.connectionToken=Oe}}e.ResolvedAuthority=M;class K{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,me){this.makeConnection=V,this.connectionToken=me,typeof me<"u"&&F(me)}}e.ManagedResolvedAuthority=K;class ee extends Error{static NotAvailable(V,me){return new ee(V,T.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(V){return new ee(V,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,me=T.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(V),this._message=V,this._code=me,this._detail=Oe,Object.setPrototypeOf(this,ee.prototype)}}e.RemoteAuthorityResolverError=ee;var $;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})($||(e.EndOfLine=$={}));var q;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(q||(e.EnvironmentVariableMutatorType=q={}));let Z=n=class{static isTextEdit(V){return V instanceof n?!0:V?x.isRange(V)&&typeof V.newText=="string":!1}static replace(V,me){return new n(V,me)}static insert(V,me){return n.replace(new x(V,V),me)}static delete(V){return n.replace(V,"")}static setEndOfLine(V){const me=new n(new x(new U(0,0),new U(0,0)),"");return me.newEol=V,me}get range(){return this._range}set range(V){if(V&&!x.isRange(V))throw(0,g.illegalArgument)("range");this._range=V}get newText(){return this._newText||""}set newText(V){if(V&&typeof V!="string")throw(0,g.illegalArgument)("newText");this._newText=V}get newEol(){return this._newEol}set newEol(V){if(V&&typeof V!="number")throw(0,g.illegalArgument)("newEol");this._newEol=V}constructor(V,me){this._range=V,this._newText=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=Z,e.TextEdit=Z=n=Ke([b],Z);let ne=s=class{static isNotebookCellEdit(V){return V instanceof s?!0:V?Ei.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,me){return new s(V,me)}static insertCells(V,me){return new s(new Ei(V,V),me)}static deleteCells(V){return new s(V,[])}static updateCellMetadata(V,me){const Oe=new s(new Ei(V,V),[]);return Oe.newCellMetadata=me,Oe}static updateNotebookMetadata(V){const me=new s(new Ei(0,0),[]);return me.newNotebookMetadata=V,me}constructor(V,me){this.range=V,this.newCells=me}};e.NotebookEdit=ne,e.NotebookEdit=ne=s=Ke([b],ne);class de{static isSnippetTextEdit(V){return V instanceof de?!0:V?x.isRange(V.range)&&ve.isSnippetString(V.snippet):!1}static replace(V,me){return new de(V,me)}static insert(V,me){return de.replace(new x(V,V),me)}constructor(V,me){this.range=V,this.snippet=me}}e.SnippetTextEdit=de;var re;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let Se=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(V,me,Oe,Xe){this._edits.push({_type:re.File,from:V,to:me,options:Oe,metadata:Xe})}createFile(V,me,Oe){this._edits.push({_type:re.File,from:void 0,to:V,options:me,metadata:Oe})}deleteFile(V,me,Oe){this._edits.push({_type:re.File,from:V,to:void 0,options:me,metadata:Oe})}replaceNotebookMetadata(V,me,Oe){this._edits.push({_type:re.Cell,metadata:Oe,uri:V,edit:{editType:E.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}replaceNotebookCells(V,me,Oe,Xe){const nt=me.start,gt=me.end;(nt!==gt||Oe.length>0)&&this._edits.push({_type:re.CellReplace,uri:V,index:nt,count:gt-nt,cells:Oe,metadata:Xe})}replaceNotebookCellMetadata(V,me,Oe,Xe){this._edits.push({_type:re.Cell,metadata:Xe,uri:V,edit:{editType:E.CellEditType.Metadata,index:me,metadata:Oe}})}replace(V,me,Oe,Xe){this._edits.push({_type:re.Text,uri:V,edit:new Z(me,Oe),metadata:Xe})}insert(V,me,Oe,Xe){this.replace(V,new x(me,me),Oe,Xe)}delete(V,me,Oe){this.replace(V,me,"",Oe)}has(V){return this._edits.some(me=>me._type===re.Text&&me.uri.toString()===V.toString())}set(V,me){if(me)for(const Oe of me){if(!Oe)continue;let Xe,nt;Array.isArray(Oe)?(Xe=Oe[0],nt=Oe[1]):Xe=Oe,ne.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.replaceNotebookCellMetadata(V,Xe.range.start,Xe.newCellMetadata,nt):Xe.newNotebookMetadata?this.replaceNotebookMetadata(V,Xe.newNotebookMetadata,nt):this.replaceNotebookCells(V,Xe.range,Xe.newCells,nt):de.isSnippetTextEdit(Xe)?this._edits.push({_type:re.Snippet,uri:V,range:Xe.range,edit:Xe.snippet,metadata:nt}):this._edits.push({_type:re.Text,uri:V,edit:Xe,metadata:nt})}else{for(let Oe=0;Oe<this._edits.length;Oe++){const Xe=this._edits[Oe];switch(Xe._type){case re.Text:case re.Snippet:case re.Cell:case re.CellReplace:Xe.uri.toString()===V.toString()&&(this._edits[Oe]=void 0);break}}(0,r.coalesceInPlace)(this._edits)}}get(V){const me=[];for(const Oe of this._edits)Oe._type===re.Text&&Oe.uri.toString()===V.toString()&&me.push(Oe.edit);return me}entries(){const V=new A.ResourceMap;for(const me of this._edits)if(me._type===re.Text){let Oe=V.get(me.uri);Oe||(Oe=[me.uri,[]],V.set(me.uri,Oe)),Oe[1].push(me.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Se,e.WorkspaceEdit=Se=Ke([b],Se);let ve=i=class{static isSnippetString(V){return V instanceof i?!0:V?typeof V.value=="string":!1}static _escape(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this._tabstop=1,this.value=V||""}appendText(V){return this.value+=i._escape(V),this}appendTabstop(V=this._tabstop++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,me=this._tabstop++){if(typeof V=="function"){const Oe=new i;Oe._tabstop=this._tabstop,V(Oe),this._tabstop=Oe._tabstop,V=Oe.value}else V=i._escape(V);return this.value+="${",this.value+=me,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,me=this._tabstop++){const Oe=V.map(Xe=>Xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(V,me){if(typeof me=="function"){const Oe=new i;Oe._tabstop=this._tabstop,me(Oe),this._tabstop=Oe._tabstop,me=Oe.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.SnippetString=ve,e.SnippetString=ve=i=Ke([b],ve);var G;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(G||(e.DiagnosticTag=G={}));var W;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let se=t=class{static isLocation(V){return V instanceof t?!0:V?x.isRange(V.range)&&l.URI.isUri(V.uri):!1}constructor(V,me){if(this.uri=V,me)if(x.isRange(me))this.range=x.of(me);else if(U.isPosition(me))this.range=new x(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=se,e.Location=se=t=Ke([b],se);let ae=class{static is(V){return V?typeof V.message=="string"&&V.location&&x.isRange(V.location.range)&&l.URI.isUri(V.location.uri):!1}constructor(V,me){this.location=V,this.message=me}static isEqual(V,me){return V===me?!0:!V||!me?!1:V.message===me.message&&V.location.range.isEqual(me.location.range)&&V.location.uri.toString()===me.location.uri.toString()}};e.DiagnosticRelatedInformation=ae,e.DiagnosticRelatedInformation=ae=Ke([b],ae);let ie=class{constructor(V,me,Oe=W.Error){if(!x.isRange(V))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=V,this.message=me,this.severity=Oe}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,me){return V===me?!0:!V||!me?!1:V.message===me.message&&V.severity===me.severity&&V.code===me.code&&V.severity===me.severity&&V.source===me.source&&V.range.isEqual(me.range)&&(0,r.equals)(V.tags,me.tags)&&(0,r.equals)(V.relatedInformation,me.relatedInformation,ae.isEqual)}};e.Diagnostic=ie,e.Diagnostic=ie=Ke([b],ie);let le=class{constructor(V,me){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=me}};e.Hover=le,e.Hover=le=Ke([b],le);let ue=class extends le{constructor(V,me,Oe,Xe){super(V,me),this.canIncreaseHover=Oe,this.canDecreaseHover=Xe}};e.VerboseHover=ue,e.VerboseHover=ue=Ke([b],ue);var Y;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(Y||(e.HoverVerbosityAction=Y={}));var oe;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let pe=class{constructor(V,me=oe.Text){this.range=V,this.kind=me}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.DocumentHighlight=pe,e.DocumentHighlight=pe=Ke([b],pe);let Ee=class{constructor(V,me){this.uri=V,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(V=>V.toJSON())}}};e.MultiDocumentHighlight=Ee,e.MultiDocumentHighlight=Ee=Ke([b],Ee);var Ne;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ne||(e.SymbolKind=Ne={}));var We;(function(j){j[j.Deprecated=1]="Deprecated"})(We||(e.SymbolTag=We={}));let Ce=c=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,me,Oe,Xe,nt){this.name=V,this.kind=me,this.containerName=nt,typeof Oe=="string"&&(this.containerName=Oe),Xe instanceof se?this.location=Xe:Oe instanceof x&&(this.location=new se(Xe,Oe)),c.validate(this)}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Ce,e.SymbolInformation=Ce=c=Ke([b],Ce);let Ie=h=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(h.validate)}constructor(V,me,Oe,Xe,nt){this.name=V,this.detail=me,this.kind=Oe,this.range=Xe,this.selectionRange=nt,this.children=[],h.validate(this)}};e.DocumentSymbol=Ie,e.DocumentSymbol=Ie=h=Ke([b],Ie);var Le;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Le||(e.CodeActionTriggerKind=Le={}));let z=class{constructor(V,me){this.title=V,this.kind=me}};e.CodeAction=z,e.CodeAction=z=Ke([b],z);let H=class{static{o=this}static{this.sep="."}constructor(V){this.value=V}append(V){return new o(this.value?this.value+o.sep+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+o.sep)}};e.CodeActionKind=H,e.CodeActionKind=H=o=Ke([b],H),H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let X=class{constructor(V,me){if(this.range=V,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=X,e.SelectionRange=X=Ke([b],X);class J{constructor(V,me,Oe,Xe,nt,gt){this.kind=V,this.name=me,this.detail=Oe,this.uri=Xe,this.range=nt,this.selectionRange=gt}}e.CallHierarchyItem=J;class fe{constructor(V,me){this.fromRanges=me,this.from=V}}e.CallHierarchyIncomingCall=fe;class be{constructor(V,me){this.fromRanges=me,this.to=V}}e.CallHierarchyOutgoingCall=be;var Fe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let He=class{constructor(V,me){this.range=V,this.command=me}get isResolved(){return!!this.command}};e.CodeLens=He,e.CodeLens=He=Ke([b],He);let qe=p=class{#e;static isMarkdownString(V){return V instanceof p?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,me=!1){this.#e=new k.MarkdownString(V,{supportThemeIcons:me})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,me){return this.#e.appendCodeblock(me??"",V),this}};e.MarkdownString=qe,e.MarkdownString=qe=p=Ke([b],qe);let Ye=class{constructor(V,me){this.label=V,this.documentation=me}};e.ParameterInformation=Ye,e.ParameterInformation=Ye=Ke([b],Ye);let it=class{constructor(V,me){this.label=V,this.documentation=me,this.parameters=[]}};e.SignatureInformation=it,e.SignatureInformation=it=Ke([b],it);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=tt,e.SignatureHelp=tt=Ke([b],tt);var rt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(rt||(e.SignatureHelpTriggerKind=rt={}));var ot;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(ot||(e.InlayHintKind=ot={}));let ft=class{constructor(V){this.value=V}};e.InlayHintLabelPart=ft,e.InlayHintLabelPart=ft=Ke([b],ft);let ut=class{constructor(V,me,Oe){this.position=V,this.label=me,this.kind=Oe}};e.InlayHint=ut,e.InlayHint=ut=Ke([b],ut);var st;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var Te;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Te||(e.CompletionItemKind=Te={}));var Ue;(function(j){j[j.Deprecated=1]="Deprecated"})(Ue||(e.CompletionItemTag=Ue={}));let ke=class{constructor(V,me){this.label=V,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Te[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=ke,e.CompletionItem=ke=Ke([b],ke);let Re=class{constructor(V=[],me=!1){this.items=V,this.isIncomplete=me}};e.CompletionList=Re,e.CompletionList=Re=Ke([b],Re);let ce=class{constructor(V,me,Oe){this.insertText=V,this.range=me,this.command=Oe}};e.InlineSuggestion=ce,e.InlineSuggestion=ce=Ke([b],ce);let Q=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.InlineSuggestionList=Q,e.InlineSuggestionList=Q=Ke([b],Q);var Pe;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(Pe||(e.PartialAcceptTriggerKind=Pe={}));var Ge;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Ge||(e.ViewColumn=Ge={}));var Ze;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ze||(e.StatusBarAlignment=Ze={}));function at(j,V){return`${y.ExtensionIdentifier.toKey(j)}.${V}`}var ct;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(ct||(e.TextEditorLineNumbersStyle=ct={}));var Ct;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Ct||(e.TextDocumentSaveReason=Ct={}));var Pt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Pt||(e.TextEditorRevealType=Pt={}));var Ot;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var Xt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Xt||(e.TextDocumentChangeReason=Xt={}));var Zt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Zt||(e.DecorationRangeBehavior=Zt={})),function(j){function V(me){switch(me){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=V}(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var Je;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Je||(e.SyntaxTokenType=Je={})),function(j){function V(me){switch(me){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=V}(Je||(e.SyntaxTokenType=Je={}));let $t=class{constructor(V,me){if(me&&!l.URI.isUri(me))throw(0,g.illegalArgument)("target");if(!x.isRange(V)||V.isEmpty)throw(0,g.illegalArgument)("range");this.range=V,this.target=me}};e.DocumentLink=$t,e.DocumentLink=$t=Ke([b],$t);let Bt=class{constructor(V,me,Oe,Xe){this.red=V,this.green=me,this.blue=Oe,this.alpha=Xe}};e.Color=Bt,e.Color=Bt=Ke([b],Bt);let mt=class{constructor(V,me){if(me&&!(me instanceof Bt))throw(0,g.illegalArgument)("color");if(!x.isRange(V)||V.isEmpty)throw(0,g.illegalArgument)("range");this.range=V,this.color=me}};e.ColorInformation=mt,e.ColorInformation=mt=Ke([b],mt);let pt=class{constructor(V){if(!V||typeof V!="string")throw(0,g.illegalArgument)("label");this.label=V}};e.ColorPresentation=pt,e.ColorPresentation=pt=Ke([b],pt);var ei;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(ei||(e.ColorFormat=ei={}));var Qt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Qt||(e.SourceControlInputBoxValidationType=Qt={}));var Wt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Wt||(e.TerminalExitReason=Wt={}));var Et;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(Et||(e.TerminalShellExecutionCommandLineConfidence=Et={}));class Ft{constructor(V,me,Oe){if(this.startIndex=V,this.length=me,this.tooltip=Oe,typeof V!="number"||V<0)throw(0,g.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,g.illegalArgument)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,g.illegalArgument)("tooltip")}}e.TerminalLink=Ft;class qt{constructor(V){this.uri=V}}e.TerminalQuickFixOpener=qt;class zt{constructor(V){this.terminalCommand=V}}e.TerminalQuickFixCommand=zt;var Qe;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ti{constructor(V){if(this.options=V,typeof V!="object")throw(0,g.illegalArgument)("options")}}e.TerminalProfile=ti;var ii;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ii||(e.TaskRevealKind=ii={}));var ci;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(ci||(e.TaskPanelKind=ci={}));let Dt=class{static{_=this}static{this.Clean=new _("clean","Clean")}static{this.Build=new _("build","Build")}static{this.Rebuild=new _("rebuild","Rebuild")}static{this.Test=new _("test","Test")}static from(V){switch(V){case"clean":return _.Clean;case"build":return _.Build;case"rebuild":return _.Rebuild;case"test":return _.Test;default:return}}constructor(V,me){if(this.label=me,typeof V!="string"||typeof me!="string")throw(0,g.illegalArgument)("name");this._id=V}get id(){return this._id}};e.TaskGroup=Dt,e.TaskGroup=Dt=_=Ke([b],Dt);function Nt(j){let V="";for(let me=0;me<j.length;me++)V+=j[me].replace(/,/g,",,")+",";return V}let At=class{constructor(V,me,Oe){if(typeof V!="string")throw(0,g.illegalArgument)("process");this._args=[],this._process=V,me!==void 0&&(Array.isArray(me)?(this._args=me,this._options=Oe):this._options=me)}get process(){return this._process}set process(V){if(typeof V!="string")throw(0,g.illegalArgument)("process");this._process=V}get args(){return this._args}set args(V){Array.isArray(V)||(V=[]),this._args=V}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("process"),this._process!==void 0&&V.push(this._process),this._args&&this._args.length>0)for(const me of this._args)V.push(me);return Nt(V)}};e.ProcessExecution=At,e.ProcessExecution=At=Ke([b],At);let Mt=class{constructor(V,me,Oe){if(this._args=[],Array.isArray(me)){if(!V)throw(0,g.illegalArgument)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,g.illegalArgument)("command");this._command=V,this._args=me,this._options=Oe}else{if(typeof V!="string")throw(0,g.illegalArgument)("commandLine");this._commandLine=V,this._options=me}}get commandLine(){return this._commandLine}set commandLine(V){if(typeof V!="string")throw(0,g.illegalArgument)("commandLine");this._commandLine=V}get command(){return this._command?this._command:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,g.illegalArgument)("command");this._command=V}get args(){return this._args}set args(V){this._args=V||[]}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("shell"),this._commandLine!==void 0&&V.push(this._commandLine),this._command!==void 0&&V.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const me of this._args)V.push(typeof me=="string"?me:me.value);return Nt(V)}};e.ShellExecution=Mt,e.ShellExecution=Mt=Ke([b],Mt);var ui;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ui||(e.ShellQuoting=ui={}));var Ht;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ht||(e.TaskScope=Ht={}));class si{constructor(V){this._callback=V}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(V){this._callback=V}get callback(){return this._callback}}e.CustomExecution=si;let Ut=class{static{D=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(V,me,Oe,Xe,nt,gt){this.__deprecated=!1,this._definition=this.definition=V;let bt;typeof me=="string"?(this._name=this.name=me,this._source=this.source=Oe,this.execution=Xe,bt=nt,this.__deprecated=!0):me===Ht.Global||me===Ht.Workspace?(this.target=me,this._name=this.name=Oe,this._source=this.source=Xe,this.execution=nt,bt=gt):(this.target=me,this._name=this.name=Oe,this._source=this.source=Xe,this.execution=nt,bt=gt),typeof bt=="string"?(this._problemMatchers=[bt],this._hasDefinedMatchers=!0):Array.isArray(bt)?(this._problemMatchers=bt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(V){this.__id=V}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof At?this._definition={type:D.ProcessType,id:this._execution.computeId()}:this._execution instanceof Mt?this._definition={type:D.ShellType,id:this._execution.computeId()}:this._execution instanceof si?this._definition={type:D.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:D.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(V){if(V==null)throw(0,g.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=V}get scope(){return this._scope}set target(V){this.clear(),this._scope=V}get name(){return this._name}set name(V){if(typeof V!="string")throw(0,g.illegalArgument)("name");this.clear(),this._name=V}get execution(){return this._execution}set execution(V){V===null&&(V=void 0),this.clear(),this._execution=V;const me=this._definition.type;(D.EmptyType===me||D.ProcessType===me||D.ShellType===me||D.ExtensionCallbackType===me)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(V){if(Array.isArray(V))this.clear(),this._problemMatchers=V,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.clear(),this._isBackground=V}get source(){return this._source}set source(V){if(typeof V!="string"||V.length===0)throw(0,g.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=V}get group(){return this._group}set group(V){V===null&&(V=void 0),this.clear(),this._group=V}get detail(){return this._detail}set detail(V){V===null&&(V=void 0),this._detail=V}get presentationOptions(){return this._presentationOptions}set presentationOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._presentationOptions=V}get runOptions(){return this._runOptions}set runOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._runOptions=V}};e.Task=Ut,e.Task=Ut=D=Ke([b],Ut);var Yt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Yt||(e.ProgressLocation=Yt={}));var oi;(function(j){function V(me){const Oe=me;return(0,v.isNumber)(Oe.value)?Oe.tooltip&&!(0,v.isString)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}j.isViewBadge=V})(oi||(e.ViewBadge=oi={}));let kt=C=class{static isTreeItem(V,me){const Oe=V;if(Oe.checkboxState!==void 0){const Xe=(0,v.isNumber)(Oe.checkboxState)?Oe.checkboxState:(0,v.isObject)(Oe.checkboxState)&&(0,v.isNumber)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,nt=!(0,v.isNumber)(Oe.checkboxState)&&(0,v.isObject)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==vt.Checked&&Xe!==vt.Unchecked||nt!==void 0&&!(0,v.isString)(nt))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(V instanceof C)return!0;if(Oe.label!==void 0&&!(0,v.isString)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,v.isString)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,v.isString)(Oe.iconPath)&&!l.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,v.isString)(Oe.iconPath.id))){const Xe=Oe.iconPath;if(!Xe||!(0,v.isString)(Xe.light)&&!l.URI.isUri(Xe.light)&&!(0,v.isString)(Xe.dark)&&!l.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,v.isString)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!l.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,v.isString)(Oe.tooltip)&&!(Oe.tooltip instanceof qe)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<St.None&&Oe.collapsibleState>St.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,v.isString)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(V,me=St.None){this.collapsibleState=me,l.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.TreeItem=kt,e.TreeItem=kt=C=Ke([b],kt);var St;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(St||(e.TreeItemCollapsibleState=St={}));var vt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(vt||(e.TreeItemCheckboxState=vt={}));let Vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.DataTransferItem=Vt,e.DataTransferItem=Vt=Ke([b],Vt);class yt extends Vt{}e.InternalDataTransferItem=yt;class ai extends yt{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.InternalFileDataTransferItem=ai;class jt{constructor(V,me,Oe,Xe){this.name=V,this.uri=me,this._itemId=Oe,this._getData=Xe}data(){return this._getData()}}e.DataTransferFile=jt;let pi=class{#e=new Map;constructor(V){for(const[me,Oe]of V??[]){const Xe=this.#e.get(this.#t(me));Xe?Xe.push(Oe):this.#e.set(this.#t(me),[Oe])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,me){this.#e.set(this.#t(V),[me])}forEach(V,me){for(const[Oe,Xe]of this.#e)for(const nt of Xe)V.call(me,nt,Oe,this)}*[Symbol.iterator](){for(const[V,me]of this.#e)for(const Oe of me)yield[V,Oe]}#t(V){return V.toLowerCase()}};e.DataTransfer=pi,e.DataTransfer=pi=Ke([b],pi);let hi=class{constructor(V,me,Oe){this.insertText=V,this.title=me,this.kind=Oe}};e.DocumentDropEdit=hi,e.DocumentDropEdit=hi=Ke([b],hi);var Ci;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(Ci||(e.DocumentPasteTriggerKind=Ci={}));class Rt{static{this.sep="."}constructor(V){this.value=V}append(...V){return new Rt((this.value?[this.value,...V]:V).join(Rt.sep))}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+Rt.sep)}}e.DocumentDropOrPasteEditKind=Rt,Rt.Empty=new Rt("");class Pi{constructor(V,me,Oe){this.title=me,this.insertText=V,this.kind=Oe}}e.DocumentPasteEdit=Pi;let li=class{constructor(V,me){this.id=V,this.color=me}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.ThemeIcon=li,e.ThemeIcon=li=Ke([b],li),li.File=new li("file"),li.Folder=new li("folder");let Tt=class{constructor(V){this.id=V}};e.ThemeColor=Tt,e.ThemeColor=Tt=Ke([b],Tt);var Ii;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ii||(e.ConfigurationTarget=Ii={}));let Si=class{get base(){return this._base}set base(V){this._base=V,this._baseUri=l.URI.file(V)}get baseUri(){return this._baseUri}set baseUri(V){this._baseUri=V,this._base=V.fsPath}constructor(V,me){if(typeof V!="string"&&(!V||!l.URI.isUri(V)&&!l.URI.isUri(V.uri)))throw(0,g.illegalArgument)("base");if(typeof me!="string")throw(0,g.illegalArgument)("pattern");typeof V=="string"?this.baseUri=l.URI.file(V):l.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Si,e.RelativePattern=Si=Ke([b],Si);const vi=new WeakMap;function ki(j,V){vi.set(j,V)}let fi=class{constructor(V,me,Oe,Xe,nt){this.enabled=typeof V=="boolean"?V:!0,typeof me=="string"&&(this.condition=me),typeof Oe=="string"&&(this.hitCondition=Oe),typeof Xe=="string"&&(this.logMessage=Xe),typeof nt=="string"&&(this.mode=nt)}get id(){return this._id||(this._id=vi.get(this)??(0,P.generateUuid)()),this._id}};e.Breakpoint=fi,e.Breakpoint=fi=Ke([b],fi);let Ae=class extends fi{constructor(V,me,Oe,Xe,nt,gt){if(super(me,Oe,Xe,nt,gt),V===null)throw(0,g.illegalArgument)("location");this.location=V}};e.SourceBreakpoint=Ae,e.SourceBreakpoint=Ae=Ke([b],Ae);let xe=class extends fi{constructor(V,me,Oe,Xe,nt,gt){super(me,Oe,Xe,nt,gt),this.functionName=V}};e.FunctionBreakpoint=xe,e.FunctionBreakpoint=xe=Ke([b],xe);let De=class extends fi{constructor(V,me,Oe,Xe,nt,gt,bt,Gt){if(super(Xe,nt,gt,bt,Gt),!me)throw(0,g.illegalArgument)("dataId");this.label=V,this.dataId=me,this.canPersist=Oe}};e.DataBreakpoint=De,e.DataBreakpoint=De=Ke([b],De);let te=class{constructor(V,me,Oe){this.command=V,this.args=me||[],this.options=Oe}};e.DebugAdapterExecutable=te,e.DebugAdapterExecutable=te=Ke([b],te);let Me=class{constructor(V,me){this.port=V,this.host=me}};e.DebugAdapterServer=Me,e.DebugAdapterServer=Me=Ke([b],Me);let $e=class{constructor(V){this.path=V}};e.DebugAdapterNamedPipeServer=$e,e.DebugAdapterNamedPipeServer=$e=Ke([b],$e);let et=class{constructor(V){this.implementation=V}};e.DebugAdapterInlineImplementation=et,e.DebugAdapterInlineImplementation=et=Ke([b],et);class je{constructor(V,me,Oe){this.session=V,this.threadId=me,this.frameId=Oe}}e.DebugStackFrame=je;class ht{constructor(V,me){this.session=V,this.threadId=me}}e.DebugThread=ht;let It=class{constructor(V,me){this.range=V,this.expression=me}};e.EvaluatableExpression=It,e.EvaluatableExpression=It=Ke([b],It);var Jt;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Jt||(e.InlineCompletionTriggerKind=Jt={}));let ni=class{constructor(V,me){this.range=V,this.text=me}};e.InlineValueText=ni,e.InlineValueText=ni=Ke([b],ni);let xt=class{constructor(V,me,Oe=!0){this.range=V,this.variableName=me,this.caseSensitiveLookup=Oe}};e.InlineValueVariableLookup=xt,e.InlineValueVariableLookup=xt=Ke([b],xt);let Kt=class{constructor(V,me){this.range=V,this.expression=me}};e.InlineValueEvaluatableExpression=Kt,e.InlineValueEvaluatableExpression=Kt=Ke([b],Kt);let Mi=class{constructor(V,me){this.frameId=V,this.stoppedLocation=me}};e.InlineValueContext=Mi,e.InlineValueContext=Mi=Ke([b],Mi);var xi;(function(j){j[j.AIGenerated=1]="AIGenerated"})(xi||(e.NewSymbolNameTag=xi={}));var Qi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Qi||(e.NewSymbolNameTriggerKind=Qi={}));class Ui{constructor(V,me){this.newSymbolName=V,this.tags=me}}e.NewSymbolName=Ui;var Ri;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Bi=S=class extends Error{static FileExists(V){return new S(V,d.FileSystemProviderErrorCode.FileExists,S.FileExists)}static FileNotFound(V){return new S(V,d.FileSystemProviderErrorCode.FileNotFound,S.FileNotFound)}static FileNotADirectory(V){return new S(V,d.FileSystemProviderErrorCode.FileNotADirectory,S.FileNotADirectory)}static FileIsADirectory(V){return new S(V,d.FileSystemProviderErrorCode.FileIsADirectory,S.FileIsADirectory)}static NoPermissions(V){return new S(V,d.FileSystemProviderErrorCode.NoPermissions,S.NoPermissions)}static Unavailable(V){return new S(V,d.FileSystemProviderErrorCode.Unavailable,S.Unavailable)}constructor(V,me=d.FileSystemProviderErrorCode.Unknown,Oe){super(l.URI.isUri(V)?V.toString(!0):V),this.code=Oe?.name??"Unknown",(0,d.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,S.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.FileSystemError=Bi,e.FileSystemError=Bi=S=Ke([b],Bi);let Wi=class{constructor(V,me,Oe){this.start=V,this.end=me,this.kind=Oe}};e.FoldingRange=Wi,e.FoldingRange=Wi=Ke([b],Wi);var wi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(wi||(e.FoldingRangeKind=wi={}));var Yi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Yi||(e.CommentThreadCollapsibleState=Yi={}));var Ji;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Ji||(e.CommentMode=Ji={}));var Li;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Li||(e.CommentState=Li={}));var zi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(zi||(e.CommentThreadState=zi={}));var $i;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})($i||(e.CommentThreadApplicability=$i={}));class gn{constructor(V,me=[]){this.tokenTypes=V,this.tokenModifiers=me}}e.SemanticTokensLegend=gn;function Zi(j){return typeof j>"u"||(0,v.isStringArray)(j)}class Hi{constructor(V){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,V){this._hasLegend=!0;for(let me=0,Oe=V.tokenTypes.length;me<Oe;me++)this._tokenTypeStrToInt.set(V.tokenTypes[me],me);for(let me=0,Oe=V.tokenModifiers.length;me<Oe;me++)this._tokenModifierStrToInt.set(V.tokenModifiers[me],me)}}push(V,me,Oe,Xe,nt){if(typeof V=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Xe=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this._pushEncoded(V,me,Oe,Xe,nt);if(x.isRange(V)&&typeof me=="string"&&Zi(Oe))return this._push(V,me,Oe);throw(0,g.illegalArgument)()}_push(V,me,Oe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(me))throw new Error("`tokenType` is not in the provided legend");const Xe=V.start.line,nt=V.start.character,gt=V.end.character-V.start.character,bt=this._tokenTypeStrToInt.get(me);let Gt=0;if(Oe)for(const di of Oe){if(!this._tokenModifierStrToInt.has(di))throw new Error("`tokenModifier` is not in the provided legend");const mi=this._tokenModifierStrToInt.get(di);Gt|=1<<mi>>>0}this._pushEncoded(Xe,nt,gt,bt,Gt)}_pushEncoded(V,me,Oe,Xe,nt){if(this._dataIsSortedAndDeltaEncoded&&(V<this._prevLine||V===this._prevLine&&me<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Gt=this._data.length/5|0;let di=0,mi=0;for(let bi=0;bi<Gt;bi++){let Di=this._data[5*bi],Gi=this._data[5*bi+1];Di===0?(Di=di,Gi+=mi):Di+=di,this._data[5*bi]=Di,this._data[5*bi+1]=Gi,di=Di,mi=Gi}}let gt=V,bt=me;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(gt-=this._prevLine,gt===0&&(bt-=this._prevChar)),this._data[this._dataLen++]=gt,this._data[this._dataLen++]=bt,this._data[this._dataLen++]=Oe,this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=nt,this._prevLine=V,this._prevChar=me}static _sortAndDeltaEncode(V){const me=[],Oe=V.length/5|0;for(let bt=0;bt<Oe;bt++)me[bt]=bt;me.sort((bt,Gt)=>{const di=V[5*bt],mi=V[5*Gt];if(di===mi){const bi=V[5*bt+1],Di=V[5*Gt+1];return bi-Di}return di-mi});const Xe=new Uint32Array(V.length);let nt=0,gt=0;for(let bt=0;bt<Oe;bt++){const Gt=5*me[bt],di=V[Gt+0],mi=V[Gt+1],bi=V[Gt+2],Di=V[Gt+3],Gi=V[Gt+4],xn=di-nt,Er=xn===0?mi-gt:mi,Xi=5*bt;Xe[Xi+0]=xn,Xe[Xi+1]=Er,Xe[Xi+2]=bi,Xe[Xi+3]=Di,Xe[Xi+4]=Gi,nt=di,gt=mi}return Xe}build(V){return this._dataIsSortedAndDeltaEncoded?new _i(new Uint32Array(this._data),V):new _i(Hi._sortAndDeltaEncode(this._data),V)}}e.SemanticTokensBuilder=Hi;class _i{constructor(V,me){this.resultId=me,this.data=V}}e.SemanticTokens=_i;class mn{constructor(V,me,Oe){this.start=V,this.deleteCount=me,this.data=Oe}}e.SemanticTokensEdit=mn;class pn{constructor(V,me){this.resultId=me,this.edits=V}}e.SemanticTokensEdits=pn;var en;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));class Vi{constructor(V){this.name=V}}e.DebugVisualization=Vi;let Oi=class{static{this.Back={iconPath:new li("arrow-left")}}constructor(){}};e.QuickInputButtons=Oi,e.QuickInputButtons=Oi=Ke([b],Oi);var ze;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(ze||(e.QuickPickItemKind=ze={}));var gi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var qi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(qi||(e.ExtensionKind=qi={}));class lt{static validate(V){if(typeof V.badge=="string"){let me=(0,R.nextCharLength)(V.badge,0);if(me<V.badge.length&&(me+=(0,R.nextCharLength)(V.badge,me)),V.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!li.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,me,Oe){this.badge=V,this.tooltip=me,this.color=Oe}}e.FileDecoration=lt;let wt=class{constructor(V){this.kind=V}};e.ColorTheme=wt,e.ColorTheme=wt=Ke([b],wt);var tn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(tn||(e.ColorThemeKind=tn={}));class Ei{static isNotebookRange(V){return V instanceof Ei?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(V,me){if(V<0)throw(0,g.illegalArgument)("start must be positive");if(me<0)throw(0,g.illegalArgument)("end must be positive");V<=me?(this._start=V,this._end=me):(this._start=me,this._end=V)}with(V){let me=this._start,Oe=this._end;return V.start!==void 0&&(me=V.start),V.end!==void 0&&(Oe=V.end),me===this._start&&Oe===this._end?this:new Ei(me,Oe)}}e.NotebookRange=Ei;class Ai{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(me=>Ai.isNotebookCellData(me))}static isNotebookCellData(V){return!0}constructor(V,me,Oe,Xe,nt,gt,bt){this.kind=V,this.value=me,this.languageId=Oe,this.mime=Xe,this.outputs=nt??[],this.metadata=gt,this.executionSummary=bt,Ai.validate(this)}}e.NotebookCellData=Ai;class vn{constructor(V){this.cells=V}}e.NotebookData=vn;class ri{static isNotebookCellOutputItem(V){return V instanceof ri?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const me={name:V.name,message:V.message,stack:V.stack};return ri.json(me,"application/vnd.code.notebook.error")}static stdout(V){return ri.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return ri.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,me="application/octet-stream"){return new ri(V,me)}static#e=new TextEncoder;static text(V,me=L.Mimes.text){const Oe=ri.#e.encode(String(V));return new ri(Oe,me)}static json(V,me="text/x-json"){const Oe=JSON.stringify(V,void 0,"	");return ri.text(Oe,me)}constructor(V,me){this.data=V,this.mime=me;const Oe=(0,L.normalizeMimeType)(me,!0);if(!Oe)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.NotebookCellOutputItem=ri;class Ni{static isNotebookCellOutput(V){return V instanceof Ni?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,me=!1){const Oe=new Set,Xe=new Set;for(let nt=0;nt<V.length;nt++){const gt=V[nt],bt=(0,L.normalizeMimeType)(gt.mime);if(!Oe.has(bt)||(0,E.isTextStreamMime)(bt)){Oe.add(bt);continue}Xe.add(nt),me&&console.warn(`DUPLICATED mime type '${gt.mime}' will be dropped`)}return Xe.size===0?V:V.filter((nt,gt)=>!Xe.has(gt))}constructor(V,me,Oe){this.items=Ni.ensureUniqueMimeTypes(V,!0),typeof me=="string"?(this.id=me,this.metadata=Oe):(this.id=(0,P.generateUuid)(),this.metadata=me??Oe)}}e.NotebookCellOutput=Ni;var nn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(nn||(e.NotebookCellKind=nn={}));var rn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(rn||(e.NotebookCellExecutionState=rn={}));var ji;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ji||(e.NotebookCellStatusBarAlignment=ji={}));var sn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class En{constructor(V,me){this.text=V,this.alignment=me}}e.NotebookCellStatusBarItem=En;var on;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(on||(e.NotebookControllerAffinity=on={}));var an;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(an||(e.NotebookControllerAffinity2=an={}));class bn{constructor(V,me=[]){this.uri=V,this.provides=(0,r.asArray)(me)}}e.NotebookRendererScript=bn;class Sn{constructor(V){this.label=V}}e.NotebookKernelSourceAction=Sn;var ln;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(ln||(e.NotebookVariablesRequestKind=ln={}));let Ki=class{constructor(V,me){this.label=V,this.timestamp=me}};e.TimelineItem=Ki,e.TimelineItem=Ki=Ke([b],Ki);var cn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var dn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(dn||(e.StandardTokenType=dn={}));class ge{constructor(V,me){this.ranges=V,this.wordPattern=me}}e.LinkedEditingRanges=ge;class _e{constructor(V){this._autoForwardAction=V}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=_e;var Be;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Be||(e.TestResultState=Be={}));var dt;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(dt||(e.TestRunProfileKind=dt={}));let _t=class{constructor(V=void 0,me=void 0,Oe=void 0,Xe=!1,nt=!0){this.include=V,this.exclude=me,this.profile=Oe,this.continuous=Xe,this.preserveFocus=nt}};e.TestRunRequest=_t,e.TestRunRequest=_t=Ke([b],_t);let Lt=I=class{static diff(V,me,Oe){const Xe=new I(V);return Xe.expectedOutput=me,Xe.actualOutput=Oe,Xe}constructor(V){this.message=V}};e.TestMessage=Lt,e.TestMessage=Lt=I=Ke([b],Lt);let yi=class{constructor(V){this.id=V}};e.TestTag=yi,e.TestTag=yi=Ke([b],yi);class Fi{constructor(V,me){this.covered=V,this.total=me,_n(this)}}e.TestCoverageCount=Fi;function _n(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class wn{static fromDetails(V,me){const Oe=new Fi(0,0),Xe=new Fi(0,0),nt=new Fi(0,0);for(const bt of me)if("branches"in bt){Oe.total+=1,Oe.covered+=bt.executed?1:0;for(const Gt of bt.branches)Xe.total+=1,Xe.covered+=Gt.executed?1:0}else nt.total+=1,nt.covered+=bt.executed?1:0;const gt=new wn(V,Oe,Xe.total>0?Xe:void 0,nt.total>0?nt:void 0);return gt.detailedCoverage=me,gt}constructor(V,me,Oe,Xe,nt){this.uri=V,this.statementCoverage=me,this.branchCoverage=Oe,this.declarationCoverage=Xe,this.testItem=nt}}e.FileCoverage=wn;class Un{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,me,Oe=[]){this.executed=V,this.location=me,this.branches=Oe}}e.StatementCoverage=Un;class Bn{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,me,Oe){this.executed=V,this.location=me,this.label=Oe}}e.BranchCoverage=Bn;class Wn{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,me,Oe){this.name=V,this.executed=me,this.location=Oe}}e.DeclarationCoverage=Wn;var yn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(yn||(e.ExternalUriOpenerPriority=yn={}));var Dn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Dn||(e.WorkspaceTrustState=Dn={}));var Cn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Cn||(e.PortAutoForwardAction=Cn={}));class zn{constructor(V,me,Oe,Xe,nt,gt){this.kind=V,this.name=me,this.detail=Oe,this.uri=Xe,this.range=nt,this.selectionRange=gt}}e.TypeHierarchyItem=zn;class $n{constructor(V){this.uri=V}}e.TextTabInput=$n;class Hn{constructor(V,me){this.original=V,this.modified=me}}e.TextDiffTabInput=Hn;class Vn{constructor(V,me,Oe,Xe){this.base=V,this.input1=me,this.input2=Oe,this.result=Xe}}e.TextMergeTabInput=Vn;class qn{constructor(V,me){this.uri=V,this.viewType=me}}e.CustomEditorTabInput=qn;class jn{constructor(V){this.viewType=V}}e.WebviewEditorTabInput=jn;class Kn{constructor(V,me){this.uri=V,this.notebookType=me}}e.NotebookEditorTabInput=Kn;class Gn{constructor(V,me,Oe){this.original=V,this.modified=me,this.notebookType=Oe}}e.NotebookDiffEditorTabInput=Gn;class Xn{constructor(){}}e.TerminalEditorTabInput=Xn;class Qn{constructor(V,me){this.uri=V,this.inputBoxUri=me}}e.InteractiveWindowInput=Qn;class Yn{constructor(){}}e.ChatEditorTabInput=Yn;class Jn{constructor(V){this.textDiffs=V}}e.TextMultiDiffTabInput=Jn;var In;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(In||(e.InteractiveSessionVoteDirection=In={}));var Tn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Tn||(e.ChatCopyKind=Tn={}));var Pn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Pn||(e.ChatVariableLevel=Pn={}));class Zn{constructor(V,me,Oe){this.id=V,this.label=me,this.values=Oe}}e.ChatCompletionItem=Zn;var kn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(kn||(e.InteractiveEditorResponseFeedbackKind=kn={}));var An;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(An||(e.ChatResultFeedbackKind=An={}));class er{constructor(V){if(typeof V!="string"&&V.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof V=="string"?new qe(V):V}}e.ChatResponseMarkdownPart=er;class tr{constructor(V,me){if(typeof V!="string"&&V.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof V=="string"?new qe(V):V,this.vulnerabilities=me}}e.ChatResponseMarkdownWithVulnerabilitiesPart=tr;class ir{constructor(V,me){this.participant=V,this.command=me}}e.ChatResponseDetectedParticipantPart=ir;class nr{constructor(V,me,Oe){this.title=V,this.message=me,this.data=Oe}}e.ChatResponseConfirmationPart=nr;class rr{constructor(V,me){this.value=V,this.baseUri=me}}e.ChatResponseFileTreePart=rr;class sr{constructor(V,me){this.value=V,this.title=me}}e.ChatResponseAnchorPart=sr;class or{constructor(V){this.value=V}}e.ChatResponseProgressPart=or;class ar{constructor(V,me){this.value=V,this.task=me}}e.ChatResponseProgressPart2=ar;class lr{constructor(V){if(typeof V!="string"&&V.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof V=="string"?new qe(V):V}}e.ChatResponseWarningPart=lr;class cr{constructor(V){this.value=V}}e.ChatResponseCommandButtonPart=cr;class ur{constructor(V,me){this.value=V,this.iconPath=me}}e.ChatResponseReferencePart=ur;class dr{constructor(V,me){this.uri=V,this.edits=Array.isArray(me)?me:[me]}}e.ChatResponseTextEditPart=dr;class hr{constructor(V,me,Oe,Xe){this.prompt=V,this.command=me,this.references=Oe,this.participant=Xe}}e.ChatRequestTurn=hr;class fr{constructor(V,me,Oe,Xe){this.response=V,this.result=me,this.participant=Oe,this.command=Xe}}e.ChatResponseTurn=fr;var Rn;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(Rn||(e.ChatLocation=Rn={}));var hn;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})(hn||(e.LanguageModelChatMessageRole=hn={}));class fn{static User(V,me){return new fn(hn.User,V,me)}static Assistant(V,me){return new fn(hn.Assistant,V,me)}constructor(V,me,Oe){this.role=V,this.content=me,this.name=Oe}}e.LanguageModelChatMessage=fn;class gr{constructor(V){this.content=V}}e.LanguageModelChatSystemMessage=gr;class mr{constructor(V,me){this.content=V,this.name=me}}e.LanguageModelChatUserMessage=mr;class pr{constructor(V,me){this.content=V,this.name=me}}e.LanguageModelChatAssistantMessage=pr;class Ti extends Error{static NotFound(V){return new Ti(V,Ti.NotFound.name)}static NoPermissions(V){return new Ti(V,Ti.NoPermissions.name)}static Blocked(V){return new Ti(V,Ti.Blocked.name)}constructor(V,me,Oe){super(V,{cause:Oe}),this.name="LanguageModelError",this.code=me??""}}e.LanguageModelError=Ti;var Ln;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Ln||(e.RelatedInformationType=Ln={}));var On;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(On||(e.SpeechToTextStatus=On={}));var Nn;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Nn||(e.TextToSpeechStatus=Nn={}));var Fn;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(Fn||(e.KeywordRecognitionStatus=Fn={}));class vr{constructor(V,me){this.text=V,this.range=me}}e.InlineEdit=vr;var Mn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Mn||(e.InlineEditTriggerKind=Mn={}))}),define(we[340],ye([1,0,6,10]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class k{constructor(L){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=L.getProxy(r.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,R,v){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const l=this._relatedInformationProviders.get(L);if(!l)throw new Error("related information provider not found");return await l.provideRelatedInformation(R,v)??[]}getRelatedInformation(L,R,v){return this._proxy.$getAiRelatedInformation(R,v)}registerRelatedInformationProvider(L,R,v){const l=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(l,v),this._proxy.$registerAiRelatedInformationProvider(l,R),new g.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(l),this._relatedInformationProviders.delete(l)})}}e.ExtHostRelatedInformation=k}),define(we[127],ye([1,0,4,6,10,24,154,5,20]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,R.createDecorator)("IExtHostAuthentication");let l=class{constructor(d){this._authenticationProviders=new Map,this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new P,this._getSessionsTaskSingler=new P,this._proxy=d.getProxy(g.MainContext.MainThreadAuthentication)}async getSession(d,T,E,a={}){const u=A.ExtensionIdentifier.toKey(d.identifier),f=[...E].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${u} ${T} ${f}`,async()=>{await this._proxy.$ensureProvider(T);const m=d.displayName||d.name;return this._proxy.$getSession(T,E,u,m,a)})}async getSessions(d,T,E){const a=A.ExtensionIdentifier.toKey(d.identifier),u=[...E].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${a} ${u}`,async()=>{await this._proxy.$ensureProvider(T);const f=d.displayName||d.name;return this._proxy.$getSessions(T,E,a,f)})}async removeSession(d,T){const E=this._authenticationProviders.get(d);return E?E.provider.removeSession(T):this._proxy.$removeSession(d,T)}registerAuthenticationProvider(d,T,E,a){if(this._authenticationProviders.get(d))throw new Error(`An authentication provider with id '${d}' is already registered.`);this._authenticationProviders.set(d,{label:T,provider:E,options:a??{supportsMultipleAccounts:!1}});const u=E.onDidChangeSessions(f=>this._proxy.$sendDidChangeSessions(d,f));return this._proxy.$registerAuthenticationProvider(d,T,a?.supportsMultipleAccounts??!1),new k.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(d),this._proxy.$unregisterAuthenticationProvider(d)})}async $createSession(d,T,E){const a=this._authenticationProviders.get(d);if(a)return await a.provider.createSession(T,E);throw new Error(`Unable to find authentication provider with handle: ${d}`)}async $removeSession(d,T){const E=this._authenticationProviders.get(d);if(E)return await E.provider.removeSession(T);throw new Error(`Unable to find authentication provider with handle: ${d}`)}async $getSessions(d,T){const E=this._authenticationProviders.get(d);if(E)return await E.provider.getSessions(T);throw new Error(`Unable to find authentication provider with handle: ${d}`)}$onDidChangeAuthenticationSessions(d,T){return d.startsWith(L.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:d,label:T}}),Promise.resolve()}};e.ExtHostAuthentication=l,e.ExtHostAuthentication=l=Ke([Ve(0,v.IExtHostRpcService)],l);class P{constructor(){this._inFlightPromises=new Map}getOrCreate(d,T){const E=this._inFlightPromises.get(d);if(E)return E;const a=T().finally(()=>this._inFlightPromises.delete(d));return this._inFlightPromises.set(d,a),a}}}),define(we[161],ye([1,0,2,6,10,5,20,12,19,13,16,26]),function(he,e,r,g,k,A,L,R,v,l,P,y){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let T=class{static{d=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(a,u){this._logService=u,this._provider=new Map,this._proxy=a.getProxy(g.MainContext.MainThreadDecorations)}registerFileDecorationProvider(a,u){const f=d._handlePool++;this._provider.set(f,{provider:a,extensionDescription:u}),this._proxy.$registerDecorationProvider(f,u.identifier.value);const m=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(n=>{if(!n){this._proxy.$onDidChange(f,null);return}const s=(0,v.asArray)(n);if(s.length<=d._maxEventSize){this._proxy.$onDidChange(f,s);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,s.length);const i=s.map(h=>({uri:h,rank:(0,l.count)(h.path,"/")})),t=(0,v.groupBy)(i,(h,o)=>h.rank-o.rank||(0,l.compare)(h.uri.path,o.uri.path)),c=[];e:for(const h of t){let o;for(const p of h){const _=(0,P.dirname)(p.uri.path);if(o!==_&&(o=_,c.push(p.uri)>=d._maxEventSize))break e}}this._proxy.$onDidChange(f,c)});return new k.Disposable(()=>{m?.dispose(),this._proxy.$unregisterDecorationProvider(f),this._provider.delete(f)})}async $provideDecorations(a,u,f){if(!this._provider.has(a))return Object.create(null);const m=Object.create(null),{provider:n,extensionDescription:s}=this._provider.get(a);return await Promise.all(u.map(async i=>{try{const{uri:t,id:c}=i,h=await Promise.resolve(n.provideFileDecoration(r.URI.revive(t),f));if(!h)return;try{k.FileDecoration.validate(h),h.badge&&typeof h.badge!="string"&&(0,y.checkProposedApiEnabled)(s,"codiconDecoration"),m[c]=[h.propagate,h.tooltip,h.badge,h.color]}catch(o){this._logService.warn(`INVALID decoration from extension '${s.identifier.value}': ${o}`)}}catch(t){this._logService.error(t)}})),m}};e.ExtHostDecorations=T,e.ExtHostDecorations=T=d=Ke([Ve(0,L.IExtHostRpcService),Ve(1,R.ILogService)],T),e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(we[341],ye([1,0,14,2,10,6,15,21,13]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class l{static{this._handlePool=0}constructor(y,d,T){this._documentsAndEditors=d,this._logService=T,this._documentContentProviders=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,d){if(Object.keys(L.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const T=l._handlePool++;this._documentContentProviders.set(T,d),this._proxy.$registerTextContentProvider(T,y);let E;if(typeof d.onDidChange=="function"){let a;E=d.onDidChange(async u=>{if(u.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(u))return;a&&await a;const f=this.$provideTextDocumentContent(T,u).then(async m=>{if(!m&&typeof m!="string")return;const n=this._documentsAndEditors.getDocument(u);if(!n)return;const s=(0,v.splitLines)(m);if(!n.equalLines(s))return this._proxy.$onVirtualDocumentChange(u,m)}).catch(r.onUnexpectedError).finally(()=>{a===f&&(a=void 0)});a=f})}return new k.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(y,d){const T=this._documentContentProviders.get(y);return T?Promise.resolve(T.provideTextDocumentContent(g.URI.revive(d),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=l}),define(we[162],ye([1,0,65,15,13,196,137,10,19]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=P;const l=new Map;function P(E,a){a?l.set(E,a):l.delete(E)}function y(E){return l.get(E)}class d extends A.MirrorTextModel{constructor(a,u,f,m,n,s,i){super(u,f,m,n),this._proxy=a,this._languageId=s,this._isDirty=i,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,v.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===g.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},save(){return a._save()},getText(u){return u?a._getTextInRange(u):a.getText()},get eol(){return a._eol===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(u){return a._lineAt(u)},offsetAt(u){return a._offsetAt(u)},positionAt(u){return a._positionAt(u)},validateRange(u){return a._validateRange(u)},validatePosition(u){return a._validatePosition(u)},getWordRangeAtPosition(u,f){return a._getWordRangeAtPosition(u,f)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,r.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,r.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const u=this._validateRange(a);if(u.isEmpty)return"";if(u.isSingleLine)return this._lines[u.start.line].substring(u.start.character,u.end.character);const f=this._eol,m=u.start.line,n=u.end.line,s=[];s.push(this._lines[m].substring(u.start.character));for(let i=m+1;i<n;i++)s.push(this._lines[i]);return s.push(this._lines[n].substring(0,u.end.character)),s.join(f)}_lineAt(a){let u;if(a instanceof R.Position?u=a.line:typeof a=="number"&&(u=a),typeof u!="number"||u<0||u>=this._lines.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new T(u,this._lines[u],u===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(a),f=this._lines[u.index].length;return new R.Position(u.index,Math.min(u.remainder,f))}_validateRange(a){if(!(a instanceof R.Range))throw new Error("Invalid argument");const u=this._validatePosition(a.start),f=this._validatePosition(a.end);return u===a.start&&f===a.end?a:new R.Range(u.line,u.character,f.line,f.character)}_validatePosition(a){if(!(a instanceof R.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:u,character:f}=a,m=!1;if(u<0)u=0,f=0,m=!0;else if(u>=this._lines.length)u=this._lines.length-1,f=this._lines[u].length,m=!0;else{const n=this._lines[u].length;f<0?(f=0,m=!0):f>n&&(f=n,m=!0)}return m?new R.Position(u,f):a}_getWordRangeAtPosition(a,u){const f=this._validatePosition(a);if(!u)u=y(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const m=(0,L.getWordAtText)(f.character+1,(0,L.ensureValidWordDefinition)(u),this._lines[f.line],0);if(m)return new R.Range(f.line,m.startColumn-1,f.line,m.endColumn-1)}}e.ExtHostDocumentData=d;class T{constructor(a,u,f){this._line=a,this._text=u,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new R.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new R.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(we[342],ye([1,0,6,10]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class k{constructor(L){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=L.getProxy(r.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,R,v){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const l=this._AiEmbeddingVectorProviders.get(L);if(!l)throw new Error("Embedding vector provider not found");const P=await l.provideEmbeddingVector(R,v);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(L,R,v){const l=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(l,v),this._proxy.$registerAiEmbeddingVectorProvider(R,l),new g.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(l),this._AiEmbeddingVectorProviders.delete(l)})}}e.ExtHostAiEmbeddingVector=k}),define(we[75],ye([1,0,6,28,10,22,5,20,63,3,9,23,15]),function(he,e,r,g,k,A,L,R,v,l,P,y,d){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let E=T=class{constructor(u,f){this._fileSystemProvider=new Map,this._writeQueue=new P.ResourceQueue,this._proxy=u.getProxy(r.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(n){try{let s;const i=m._fileSystemProvider.get(n.scheme);return i?(await m._proxy.$ensureActivation(n.scheme),s=await i.impl.stat(n)):s=await m._proxy.$stat(n),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===g.FilePermission.Readonly?1:void 0}}catch(s){T._handleError(s)}},async readDirectory(n){try{const s=m._fileSystemProvider.get(n.scheme);return s?(await m._proxy.$ensureActivation(n.scheme),(await s.impl.readDirectory(n)).slice()):await m._proxy.$readdir(n)}catch(s){return T._handleError(s)}},async createDirectory(n){try{const s=m._fileSystemProvider.get(n.scheme);return s&&!s.isReadonly?(await m._proxy.$ensureActivation(n.scheme),await m.mkdirp(s.impl,s.extUri,n)):await m._proxy.$mkdir(n)}catch(s){return T._handleError(s)}},async readFile(n){try{const s=m._fileSystemProvider.get(n.scheme);return s?(await m._proxy.$ensureActivation(n.scheme),(await s.impl.readFile(n)).slice()):(await m._proxy.$readFile(n)).buffer}catch(s){return T._handleError(s)}},async writeFile(n,s){try{const i=m._fileSystemProvider.get(n.scheme);return i&&!i.isReadonly?(await m._proxy.$ensureActivation(n.scheme),await m.mkdirp(i.impl,i.extUri,i.extUri.dirname(n)),await m._writeQueue.queueFor(n,()=>Promise.resolve(i.impl.writeFile(n,s,{create:!0,overwrite:!0})))):await m._proxy.$writeFile(n,A.VSBuffer.wrap(s))}catch(i){return T._handleError(i)}},async delete(n,s){try{const i=m._fileSystemProvider.get(n.scheme);return i&&!i.isReadonly&&!s?.useTrash?(await m._proxy.$ensureActivation(n.scheme),await i.impl.delete(n,{recursive:!1,...s})):await m._proxy.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(i){return T._handleError(i)}},async rename(n,s,i){try{return await m._proxy.$rename(n,s,{overwrite:!1,...i})}catch(t){return T._handleError(t)}},async copy(n,s,i){try{return await m._proxy.$copy(n,s,{overwrite:!1,...i})}catch(t){return T._handleError(t)}},isWritableFileSystem(n){const s=f.getCapabilities(n);if(typeof s=="number")return!(s&g.FileSystemProviderCapabilities.Readonly)}})}async mkdirp(u,f,m){const n=[];for(;!f.isEqual(m,f.dirname(m));)try{if(!((await u.stat(m)).type&g.FileType.Directory))throw k.FileSystemError.FileExists(`Unable to create folder '${m.scheme===d.Schemas.file?m.fsPath:m.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(g.toFileSystemProviderErrorCode(s)!==g.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(f.basename(m)),m=f.dirname(m)}for(let s=n.length-1;s>=0;s--){m=f.joinPath(m,n[s]);try{await u.createDirectory(m)}catch(i){if(g.toFileSystemProviderErrorCode(i)!==g.FileSystemProviderErrorCode.FileExists)throw i}}}static _handleError(u){if(u instanceof k.FileSystemError)throw u;if(u instanceof g.FileSystemProviderError)switch(u.code){case g.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(u.message);case g.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(u.message);case g.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(u.message);case g.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(u.message);case g.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(u.message);case g.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(u.message);default:throw new k.FileSystemError(u.message,u.name)}if(!(u instanceof Error))throw new k.FileSystemError(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw k.FileSystemError.Unavailable(u.message);switch(u.name){case g.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(u.message);case g.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(u.message);case g.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(u.message);case g.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(u.message);case g.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(u.message);case g.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(u.message);default:throw new k.FileSystemError(u.message,u.name)}}addFileSystemProvider(u,f,m){return this._fileSystemProvider.set(u,{impl:f,extUri:m?.isCaseSensitive?y.extUri:y.extUriIgnorePathCase,isReadonly:!!m?.isReadonly}),(0,l.toDisposable)(()=>this._fileSystemProvider.delete(u))}getFileSystemProviderExtUri(u){return this._fileSystemProvider.get(u)?.extUri??y.extUri}};e.ExtHostConsumerFileSystem=E,e.ExtHostConsumerFileSystem=E=T=Ke([Ve(0,R.IExtHostRpcService),Ve(1,v.IExtHostFileSystemInfo)],E),e.IExtHostConsumerFileSystem=(0,L.createDecorator)("IExtHostConsumerFileSystem")}),define(we[98],ye([1,0,5,30,12,75,2]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let R=class{constructor(l,P,y){this._logService=P,this._extHostFileSystem=y,this._workspace=l.workspace??void 0,this._environment=l.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getWorkspaceStorageURI(l){return L.URI.joinPath(this._environment.workspaceStorageHome,l)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const l=this._workspace.id,P=await this._getWorkspaceStorageURI(l);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(L.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:L.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),P}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(l){if(this._value)return L.URI.joinPath(this._value,l.identifier.value)}globalValue(l){return L.URI.joinPath(this._environment.globalStorageHome,l.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=R,e.ExtensionStoragePaths=R=Ke([Ve(0,g.IExtHostInitDataService),Ve(1,k.ILogService),Ve(2,A.IExtHostConsumerFileSystem)],R)}),define(we[343],ye([1,0,10,20,4]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(R){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(R){let v;switch(R){case"light":v=r.ColorThemeKind.Light;break;case"hcDark":v=r.ColorThemeKind.HighContrast;break;case"hcLight":v=r.ColorThemeKind.HighContrastLight;break;default:v=r.ColorThemeKind.Dark}this._actual=new r.ColorTheme(v),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=A,e.ExtHostTheming=A=Ke([Ve(0,g.IExtHostRpcService)],A)}),define(we[76],ye([1,0,21,4,3,242,5,12,93,6,30,20,10]),function(he,e,r,g,k,A,L,R,v,l,P,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class T extends v.DisposableTunnel{}var E;(function(u){function f(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?v.TunnelPrivacyId.Public:v.TunnelPrivacyId.Private),protocol:n.protocol}}u.fromApiTunnel=f;function m(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==v.TunnelPrivacyId.ConstantPrivate&&n.privacy!==v.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}u.fromServiceTunnel=m})(E||(e.TunnelDtoConverter=E={})),e.IExtHostTunnelService=(0,L.createDecorator)("IExtHostTunnelService");let a=class extends k.Disposable{constructor(f,m,n){super(),this.logService=n,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new g.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(l.MainContext.MainThreadTunnelService)}async openTunnel(f,m){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const n=await this._proxy.$openTunnel(m,f.displayName);if(n){const s=new T(n.remoteAddress,n.localAddress,()=>this._proxy.$closeTunnel(n.remoteAddress));return this._register(s),s}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,m){f.portRange===void 0&&f.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(n,{selector:f,provider:m}),this._proxy.$registerPortsAttributesProvider(f,n),new d.Disposable(()=>{this._portAttributesProviders.delete(n),this._proxy.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(f,m,n,s,i){const t=[];for(const h of f){const o=this._portAttributesProviders.get(h);if(!o)return[];t.push(...await Promise.all(m.map(async p=>{let _;try{_=await o.provider.providePortAttributes({port:p,pid:n,commandLine:s},i)}catch{_=await o.provider.providePortAttributes(p,n,s,i)}return{providedAttributes:_,port:p}})))}const c=t.filter(h=>!!h.providedAttributes);return c.length>0?c.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(f){}registerTunnelProvider(f,m){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(s,i)=>await f.provideTunnel(s,i,r.CancellationToken.None)??void 0;const n=m.tunnelFeatures?{elevation:!!m.tunnelFeatures?.elevation,privacyOptions:m.tunnelFeatures?.privacyOptions,protocol:m.tunnelFeatures.protocol===void 0?!0:m.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(n),Promise.resolve((0,k.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(f,m){if(f){f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter());const n=f.tunnelFactory??(m?this.makeManagedTunnelFactory(m):void 0);if(n){this._forwardPortProvider=n;let s=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const i=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this._proxy.$setTunnelProvider(i)}}else this._forwardPortProvider=void 0;return(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(f){}async $closeTunnel(f,m){if(this._extensionTunnels.has(f.host)){const n=this._extensionTunnels.get(f.host);n.has(f.port)&&(m&&n.get(f.port).disposeListener.dispose(),await n.get(f.port).tunnel.dispose(),n.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,m){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this._forwardPortProvider(f,m);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const s=await n;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const i=this._register(s.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(s.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:s,disposeListener:i}),E.fromApiTunnel(s)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(f){const m=await Promise.all(f.map(s=>this._showCandidatePort(s.host,s.port,s.detail??""))),n=f.filter((s,i)=>m[i]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(s=>s.port).join(", ")} to ${n.map(s=>s.port).join(", ")}`),n}};e.ExtHostTunnelService=a,e.ExtHostTunnelService=a=Ke([Ve(0,y.IExtHostRpcService),Ve(1,P.IExtHostInitDataService),Ve(2,R.ILogService)],a)}),define(we[17],ye([1,0,19,22,185,80,86,29,175,57,107,25,180,23,50,18,2,113,31,105,88,55,144,90,153,151,305,321,119,126,73,74,317,10]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i,t,c,h,o,p,_,D,C,S,I,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=ne,e.fromRangeOrRangeWithMessage=re,e.pathOrURIToURI=Se;var N;(function(Ae){function xe(te){const{selectionStartLineNumber:Me,selectionStartColumn:$e,positionLineNumber:et,positionColumn:je}=te,ht=new w.Position(Me-1,$e-1),It=new w.Position(et-1,je-1);return new w.Selection(ht,It)}Ae.to=xe;function De(te){const{anchor:Me,active:$e}=te;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Ae.from=De})(N||(e.Selection=N={}));var O;(function(Ae){function xe(te){if(!te)return;const{start:Me,end:$e}=te;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Ae.from=xe;function De(te){if(!te)return;const{startLineNumber:Me,startColumn:$e,endLineNumber:et,endColumn:je}=te;return new w.Range(Me-1,$e-1,et-1,je-1)}Ae.to=De})(O||(e.Range=O={}));var U;(function(Ae){function xe(te){return{uri:te.uri,range:O.from(te.range)}}Ae.from=xe;function De(te){return new w.Location(u.URI.revive(te.uri),O.to(te.range))}Ae.to=De})(U||(e.Location=U={}));var x;(function(Ae){function xe(De){switch(De){case n.StandardTokenType.Comment:return w.StandardTokenType.Comment;case n.StandardTokenType.Other:return w.StandardTokenType.Other;case n.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case n.StandardTokenType.String:return w.StandardTokenType.String}}Ae.to=xe})(x||(e.TokenType=x={}));var B;(function(Ae){function xe(te){return new w.Position(te.lineNumber-1,te.column-1)}Ae.to=xe;function De(te){return{lineNumber:te.line+1,column:te.character+1}}Ae.from=De})(B||(e.Position=B={}));var F;(function(Ae){function xe(Me,$e,et){return(0,r.coalesce)((0,r.asArray)(Me).map(je=>De(je,$e,et)))}Ae.from=xe;function De(Me,$e,et){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:et?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:te(Me.scheme,$e),pattern:at.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:et?.isBuiltin}}function te(Me,$e){return $e&&typeof Me=="string"?$e.transformOutgoingScheme(Me):Me}})(F||(e.DocumentSelector=F={}));var M;(function(Ae){function xe(te){switch(te){case w.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}Ae.from=xe;function De(te){switch(te){case t.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}Ae.to=De})(M||(e.DiagnosticTag=M={}));var K;(function(Ae){function xe(te){let Me;return te.code&&((0,a.isString)(te.code)||(0,a.isNumber)(te.code)?Me=String(te.code):Me={value:String(te.code.value),target:te.code.target}),{...O.from(te.range),message:te.message,source:te.source,code:Me,severity:$.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(ee.from),tags:Array.isArray(te.tags)?(0,r.coalesce)(te.tags.map(M.from)):void 0}}Ae.from=xe;function De(te){const Me=new w.Diagnostic(O.to(te),te.message,$.to(te.severity));return Me.source=te.source,Me.code=(0,a.isString)(te.code)?te.code:te.code?.value,Me.relatedInformation=te.relatedInformation&&te.relatedInformation.map(ee.to),Me.tags=te.tags&&(0,r.coalesce)(te.tags.map(M.to)),Me}Ae.to=De})(K||(e.Diagnostic=K={}));var ee;(function(Ae){function xe(te){return{...O.from(te.location.range),message:te.message,resource:te.location.uri}}Ae.from=xe;function De(te){return new w.DiagnosticRelatedInformation(new w.Location(te.resource,O.to(te)),te.message)}Ae.to=De})(ee||(e.DiagnosticRelatedInformation=ee={}));var $;(function(Ae){function xe(te){switch(te){case w.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ae.from=xe;function De(te){switch(te){case t.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}Ae.to=De})($||(e.DiagnosticSeverity=$={}));var q;(function(Ae){function xe(te){return typeof te=="number"&&te>=w.ViewColumn.One?te-1:te===w.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}Ae.from=xe;function De(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=De})(q||(e.ViewColumn=q={}));function Z(Ae){return typeof Ae.range<"u"}function ne(Ae){return Ae.length===0?!0:!!Z(Ae[0])}var de;(function(Ae){function xe(je){return je.map(Ae.from)}Ae.fromMany=xe;function De(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function te(je){let ht;if(De(je)){const{language:xt,value:Kt}=je;ht={value:"```"+xt+`
`+Kt+"\n```\n"}}else w.MarkdownString.isMarkdownString(je)?ht={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?ht={value:je}:ht={value:""};const It=Object.create(null);ht.uris=It;const Jt=xt=>{try{let Kt=u.URI.parse(xt,!0);Kt=Kt.with({query:Me(Kt.query,It)}),It[xt]=Kt}catch{}return""},ni=new v.marked.Renderer;return ni.link=Jt,ni.image=xt=>typeof xt=="string"?Jt(L.parseHrefAndDimensions(xt).href):"",(0,v.marked)(ht.value,{renderer:ni}),ht}Ae.from=te;function Me(je,ht){if(!je)return je;let It;try{It=(0,l.parse)(je)}catch{}if(!It)return je;let Jt=!1;return It=(0,y.cloneAndChange)(It,ni=>{if(u.URI.isUri(ni)){const xt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[xt]=ni,Jt=!0,xt}else return}),Jt?JSON.stringify(It):je}function $e(je){const ht=new w.MarkdownString(je.value,je.supportThemeIcons);return ht.isTrusted=je.isTrusted,ht.supportHtml=je.supportHtml,ht.baseUri=je.baseUri?u.URI.from(je.baseUri):void 0,ht}Ae.to=$e;function et(je){if(je)return typeof je=="string"?je:Ae.from(je)}Ae.fromStrict=et})(de||(e.MarkdownString=de={}));function re(Ae){return ne(Ae)?Ae.map(xe=>({range:O.from(xe.range),hoverMessage:Array.isArray(xe.hoverMessage)?de.fromMany(xe.hoverMessage):xe.hoverMessage?de.from(xe.hoverMessage):void 0,renderOptions:xe.renderOptions})):Ae.map(xe=>({range:O.from(xe)}))}function Se(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?u.URI.file(Ae):Ae}var ve;(function(Ae){function xe(De){return typeof De>"u"?De:{contentText:De.contentText,contentIconPath:De.contentIconPath?Se(De.contentIconPath):void 0,border:De.border,borderColor:De.borderColor,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,color:De.color,backgroundColor:De.backgroundColor,margin:De.margin,width:De.width,height:De.height}}Ae.from=xe})(ve||(e.ThemableDecorationAttachmentRenderOptions=ve={}));var G;(function(Ae){function xe(De){return typeof De>"u"?De:{backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?Se(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?ve.from(De.before):void 0,after:De.after?ve.from(De.after):void 0}}Ae.from=xe})(G||(e.ThemableDecorationRenderOptions=G={}));var W;(function(Ae){function xe(De){if(typeof De>"u")return De;switch(De){case w.DecorationRangeBehavior.OpenOpen:return i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ae.from=xe})(W||(e.DecorationRangeBehavior=W={}));var se;(function(Ae){function xe(De){return{isWholeLine:De.isWholeLine,rangeBehavior:De.rangeBehavior?W.from(De.rangeBehavior):void 0,overviewRulerLane:De.overviewRulerLane,light:De.light?G.from(De.light):void 0,dark:De.dark?G.from(De.dark):void 0,backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?Se(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?ve.from(De.before):void 0,after:De.after?ve.from(De.after):void 0}}Ae.from=xe})(se||(e.DecorationRenderOptions=se={}));var ae;(function(Ae){function xe(te){return{text:te.newText,eol:te.newEol&&ce.from(te.newEol),range:O.from(te.range)}}Ae.from=xe;function De(te){const Me=new w.TextEdit(O.to(te.range),te.text);return Me.newEol=typeof te.eol>"u"?void 0:ce.to(te.eol),Me}Ae.to=De})(ae||(e.TextEdit=ae={}));var ie;(function(Ae){function xe(te,Me){const $e={edits:[]};if(te instanceof w.WorkspaceEdit){const et=new R.ResourceSet;for(const je of te._allEntries())je._type===w.FileEditType.File&&u.URI.isUri(je.to)&&je.from===void 0&&et.add(je.to);for(const je of te._allEntries())if(je._type===w.FileEditType.File){let ht;je.options?.contents&&(ArrayBuffer.isView(je.options.contents)?ht={type:"base64",value:(0,g.encodeBase64)(g.VSBuffer.wrap(je.options.contents))}:ht={type:"dataTransferItem",id:je.options.contents._itemId}),$e.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contents:ht},metadata:je.metadata})}else je._type===w.FileEditType.Text?$e.edits.push({resource:je.uri,textEdit:ae.from(je.edit),versionId:et.has(je.uri)?void 0:Me?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===w.FileEditType.Snippet?$e.edits.push({resource:je.uri,textEdit:{range:O.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:et.has(je.uri)?void 0:Me?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===w.FileEditType.Cell?$e.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(je.uri)}):je._type===w.FileEditType.CellReplace&&$e.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Me?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:C.CellEditType.Replace,index:je.index,count:je.count,cells:je.cells.map($t.from)}})}return $e}Ae.from=xe;function De(te){const Me=new w.WorkspaceEdit,$e=new R.ResourceMap;for(const et of te.edits)if(et.textEdit){const je=et,ht=u.URI.revive(je.resource),It=O.to(je.textEdit.range),Jt=je.textEdit.text,ni=je.textEdit.insertAsSnippet;let xt;ni?xt=w.SnippetTextEdit.replace(It,new w.SnippetString(Jt)):xt=w.TextEdit.replace(It,Jt);const Kt=$e.get(ht);Kt?Kt.push(xt):$e.set(ht,[xt])}else Me.renameFile(u.URI.revive(et.oldResource),u.URI.revive(et.newResource),et.options);for(const[et,je]of $e)Me.set(et,je);return Me}Ae.to=De})(ie||(e.WorkspaceEdit=ie={}));var le;(function(Ae){const xe=Object.create(null);xe[w.SymbolKind.File]=s.SymbolKind.File,xe[w.SymbolKind.Module]=s.SymbolKind.Module,xe[w.SymbolKind.Namespace]=s.SymbolKind.Namespace,xe[w.SymbolKind.Package]=s.SymbolKind.Package,xe[w.SymbolKind.Class]=s.SymbolKind.Class,xe[w.SymbolKind.Method]=s.SymbolKind.Method,xe[w.SymbolKind.Property]=s.SymbolKind.Property,xe[w.SymbolKind.Field]=s.SymbolKind.Field,xe[w.SymbolKind.Constructor]=s.SymbolKind.Constructor,xe[w.SymbolKind.Enum]=s.SymbolKind.Enum,xe[w.SymbolKind.Interface]=s.SymbolKind.Interface,xe[w.SymbolKind.Function]=s.SymbolKind.Function,xe[w.SymbolKind.Variable]=s.SymbolKind.Variable,xe[w.SymbolKind.Constant]=s.SymbolKind.Constant,xe[w.SymbolKind.String]=s.SymbolKind.String,xe[w.SymbolKind.Number]=s.SymbolKind.Number,xe[w.SymbolKind.Boolean]=s.SymbolKind.Boolean,xe[w.SymbolKind.Array]=s.SymbolKind.Array,xe[w.SymbolKind.Object]=s.SymbolKind.Object,xe[w.SymbolKind.Key]=s.SymbolKind.Key,xe[w.SymbolKind.Null]=s.SymbolKind.Null,xe[w.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,xe[w.SymbolKind.Struct]=s.SymbolKind.Struct,xe[w.SymbolKind.Event]=s.SymbolKind.Event,xe[w.SymbolKind.Operator]=s.SymbolKind.Operator,xe[w.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function De(Me){return typeof xe[Me]=="number"?xe[Me]:s.SymbolKind.Property}Ae.from=De;function te(Me){for(const $e in xe)if(xe[$e]===Me)return Number($e);return w.SymbolKind.Property}Ae.to=te})(le||(e.SymbolKind=le={}));var ue;(function(Ae){function xe(te){switch(te){case w.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}Ae.from=xe;function De(te){switch(te){case s.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}Ae.to=De})(ue||(e.SymbolTag=ue={}));var Y;(function(Ae){function xe(te){return{name:te.name,kind:le.from(te.kind),tags:te.tags&&te.tags.map(ue.from),containerName:te.containerName,location:We.from(te.location)}}Ae.from=xe;function De(te){const Me=new w.SymbolInformation(te.name,le.to(te.kind),te.containerName,We.to(te.location));return Me.tags=te.tags&&te.tags.map(ue.to),Me}Ae.to=De})(Y||(e.WorkspaceSymbol=Y={}));var oe;(function(Ae){function xe(te){const Me={name:te.name||"!!MISSING: name!!",detail:te.detail,range:O.from(te.range),selectionRange:O.from(te.selectionRange),kind:le.from(te.kind),tags:te.tags?.map(ue.from)??[]};return te.children&&(Me.children=te.children.map(xe)),Me}Ae.from=xe;function De(te){const Me=new w.DocumentSymbol(te.name,te.detail,le.to(te.kind),O.to(te.range),O.to(te.selectionRange));return(0,r.isNonEmptyArray)(te.tags)&&(Me.tags=te.tags.map(ue.to)),te.children&&(Me.children=te.children.map(De)),Me}Ae.to=De})(oe||(e.DocumentSymbol=oe={}));var pe;(function(Ae){function xe(te){const Me=new w.CallHierarchyItem(le.to(te.kind),te.name,te.detail||"",u.URI.revive(te.uri),O.to(te.range),O.to(te.selectionRange));return Me._sessionId=te._sessionId,Me._itemId=te._itemId,Me}Ae.to=xe;function De(te,Me,$e){if(Me=Me??te._sessionId,$e=$e??te._itemId,Me===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:$e,name:te.name,detail:te.detail,kind:le.from(te.kind),uri:te.uri,range:O.from(te.range),selectionRange:O.from(te.selectionRange),tags:te.tags?.map(ue.from)}}Ae.from=De})(pe||(e.CallHierarchyItem=pe={}));var Ee;(function(Ae){function xe(De){return new w.CallHierarchyIncomingCall(pe.to(De.from),De.fromRanges.map(te=>O.to(te)))}Ae.to=xe})(Ee||(e.CallHierarchyIncomingCall=Ee={}));var Ne;(function(Ae){function xe(De){return new w.CallHierarchyOutgoingCall(pe.to(De.to),De.fromRanges.map(te=>O.to(te)))}Ae.to=xe})(Ne||(e.CallHierarchyOutgoingCall=Ne={}));var We;(function(Ae){function xe(te){return{range:te.range&&O.from(te.range),uri:te.uri}}Ae.from=xe;function De(te){return new w.Location(u.URI.revive(te.uri),O.to(te.range))}Ae.to=De})(We||(e.location=We={}));var Ce;(function(Ae){function xe(te){const Me=te,$e=te;return{originSelectionRange:Me.originSelectionRange?O.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:$e.uri,range:O.from(Me.targetRange?Me.targetRange:$e.range),targetSelectionRange:Me.targetSelectionRange?O.from(Me.targetSelectionRange):void 0}}Ae.from=xe;function De(te){return{targetUri:u.URI.revive(te.uri),targetRange:O.to(te.range),targetSelectionRange:te.targetSelectionRange?O.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?O.to(te.originSelectionRange):void 0}}Ae.to=De})(Ce||(e.DefinitionLink=Ce={}));var Ie;(function(Ae){function xe(te){return{range:O.from(te.range),contents:de.fromMany(te.contents),canIncreaseVerbosity:te.canIncreaseVerbosity,canDecreaseVerbosity:te.canDecreaseVerbosity}}Ae.from=xe;function De(te){const Me=te.contents.map(de.to),$e=O.to(te.range),et=te.canIncreaseVerbosity,je=te.canDecreaseVerbosity;return new w.VerboseHover(Me,$e,et,je)}Ae.to=De})(Ie||(e.Hover=Ie={}));var Le;(function(Ae){function xe(te){return{range:O.from(te.range),expression:te.expression}}Ae.from=xe;function De(te){return new w.EvaluatableExpression(O.to(te.range),te.expression)}Ae.to=De})(Le||(e.EvaluatableExpression=Le={}));var z;(function(Ae){function xe(te){if(te instanceof w.InlineValueText)return{type:"text",range:O.from(te.range),text:te.text};if(te instanceof w.InlineValueVariableLookup)return{type:"variable",range:O.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:O.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=xe;function De(te){switch(te.type){case"text":return{range:O.to(te.range),text:te.text};case"variable":return{range:O.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:O.to(te.range),expression:te.expression}}}Ae.to=De})(z||(e.InlineValue=z={}));var H;(function(Ae){function xe(te){return{frameId:te.frameId,stoppedLocation:O.from(te.stoppedLocation)}}Ae.from=xe;function De(te){return new w.InlineValueContext(te.frameId,O.to(te.stoppedLocation))}Ae.to=De})(H||(e.InlineValueContext=H={}));var X;(function(Ae){function xe(te){return{range:O.from(te.range),kind:te.kind}}Ae.from=xe;function De(te){return new w.DocumentHighlight(O.to(te.range),te.kind)}Ae.to=De})(X||(e.DocumentHighlight=X={}));var J;(function(Ae){function xe(te){return{uri:te.uri,highlights:te.highlights.map(X.from)}}Ae.from=xe;function De(te){return new w.MultiDocumentHighlight(u.URI.revive(te.uri),te.highlights.map(X.to))}Ae.to=De})(J||(e.MultiDocumentHighlight=J={}));var fe;(function(Ae){function xe(De){switch(De){case s.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}Ae.to=xe})(fe||(e.CompletionTriggerKind=fe={}));var be;(function(Ae){function xe(De){return{triggerKind:fe.to(De.triggerKind),triggerCharacter:De.triggerCharacter}}Ae.to=xe})(be||(e.CompletionContext=be={}));var Fe;(function(Ae){function xe(te){switch(te){case w.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}Ae.from=xe;function De(te){switch(te){case s.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}Ae.to=De})(Fe||(e.CompletionItemTag=Fe={}));var He;(function(Ae){const xe=new Map([[w.CompletionItemKind.Method,s.CompletionItemKind.Method],[w.CompletionItemKind.Function,s.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,s.CompletionItemKind.Field],[w.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[w.CompletionItemKind.Class,s.CompletionItemKind.Class],[w.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[w.CompletionItemKind.Module,s.CompletionItemKind.Module],[w.CompletionItemKind.Property,s.CompletionItemKind.Property],[w.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[w.CompletionItemKind.Value,s.CompletionItemKind.Value],[w.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,s.CompletionItemKind.Text],[w.CompletionItemKind.Color,s.CompletionItemKind.Color],[w.CompletionItemKind.File,s.CompletionItemKind.File],[w.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[w.CompletionItemKind.Event,s.CompletionItemKind.Event],[w.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[w.CompletionItemKind.User,s.CompletionItemKind.User]]);function De($e){return xe.get($e)??s.CompletionItemKind.Property}Ae.from=De;const te=new Map([[s.CompletionItemKind.Method,w.CompletionItemKind.Method],[s.CompletionItemKind.Function,w.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,w.CompletionItemKind.Field],[s.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[s.CompletionItemKind.Class,w.CompletionItemKind.Class],[s.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[s.CompletionItemKind.Module,w.CompletionItemKind.Module],[s.CompletionItemKind.Property,w.CompletionItemKind.Property],[s.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[s.CompletionItemKind.Value,w.CompletionItemKind.Value],[s.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,w.CompletionItemKind.Text],[s.CompletionItemKind.Color,w.CompletionItemKind.Color],[s.CompletionItemKind.File,w.CompletionItemKind.File],[s.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[s.CompletionItemKind.Event,w.CompletionItemKind.Event],[s.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,w.CompletionItemKind.User],[s.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function Me($e){return te.get($e)??w.CompletionItemKind.Property}Ae.to=Me})(He||(e.CompletionItemKind=He={}));var qe;(function(Ae){function xe(De,te){const Me=new w.CompletionItem(De.label);return Me.insertText=De.insertText,Me.kind=He.to(De.kind),Me.tags=De.tags?.map(Fe.to),Me.detail=De.detail,Me.documentation=L.isMarkdownString(De.documentation)?de.to(De.documentation):De.documentation,Me.sortText=De.sortText,Me.filterText=De.filterText,Me.preselect=De.preselect,Me.commitCharacters=De.commitCharacters,m.Range.isIRange(De.range)?Me.range=O.to(De.range):typeof De.range=="object"&&(Me.range={inserting:O.to(De.range.insert),replacing:O.to(De.range.replace)}),Me.keepWhitespace=typeof De.insertTextRules>"u"?!1:!!(De.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof De.insertTextRules<"u"&&De.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Me.insertText=new w.SnippetString(De.insertText):(Me.insertText=De.insertText,Me.textEdit=Me.range instanceof w.Range?new w.TextEdit(Me.range,Me.insertText):void 0),De.additionalTextEdits&&De.additionalTextEdits.length>0&&(Me.additionalTextEdits=De.additionalTextEdits.map($e=>ae.to($e))),Me.command=te&&De.command?te.fromInternal(De.command):void 0,Me}Ae.to=xe})(qe||(e.CompletionItem=qe={}));var Ye;(function(Ae){function xe(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:de.fromStrict(te.documentation)}}Ae.from=xe;function De(te){return{label:te.label,documentation:L.isMarkdownString(te.documentation)?de.to(te.documentation):te.documentation}}Ae.to=De})(Ye||(e.ParameterInformation=Ye={}));var it;(function(Ae){function xe(te){return{label:te.label,documentation:de.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(Ye.from):[],activeParameter:te.activeParameter}}Ae.from=xe;function De(te){return{label:te.label,documentation:L.isMarkdownString(te.documentation)?de.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(Ye.to):[],activeParameter:te.activeParameter}}Ae.to=De})(it||(e.SignatureInformation=it={}));var tt;(function(Ae){function xe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(it.from):[]}}Ae.from=xe;function De(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(it.to):[]}}Ae.to=De})(tt||(e.SignatureHelp=tt={}));var rt;(function(Ae){function xe(De,te){const Me=new w.InlayHint(B.to(te.position),typeof te.label=="string"?te.label:te.label.map(ot.to.bind(void 0,De)),te.kind&&ft.to(te.kind));return Me.textEdits=te.textEdits&&te.textEdits.map(ae.to),Me.tooltip=L.isMarkdownString(te.tooltip)?de.to(te.tooltip):te.tooltip,Me.paddingLeft=te.paddingLeft,Me.paddingRight=te.paddingRight,Me}Ae.to=xe})(rt||(e.InlayHint=rt={}));var ot;(function(Ae){function xe(De,te){const Me=new w.InlayHintLabelPart(te.label);return Me.tooltip=L.isMarkdownString(te.tooltip)?de.to(te.tooltip):te.tooltip,s.Command.is(te.command)&&(Me.command=De.fromInternal(te.command)),te.location&&(Me.location=We.to(te.location)),Me}Ae.to=xe})(ot||(e.InlayHintLabelPart=ot={}));var ft;(function(Ae){function xe(te){return te}Ae.from=xe;function De(te){return te}Ae.to=De})(ft||(e.InlayHintKind=ft={}));var ut;(function(Ae){function xe(te){return{range:O.from(te.range),url:te.target,tooltip:te.tooltip}}Ae.from=xe;function De(te){let Me;if(te.url)try{Me=typeof te.url=="string"?u.URI.parse(te.url,!0):u.URI.revive(te.url)}catch{}return new w.DocumentLink(O.to(te.range),Me)}Ae.to=De})(ut||(e.DocumentLink=ut={}));var st;(function(Ae){function xe(te){const Me=new w.ColorPresentation(te.label);return te.textEdit&&(Me.textEdit=ae.to(te.textEdit)),te.additionalTextEdits&&(Me.additionalTextEdits=te.additionalTextEdits.map($e=>ae.to($e))),Me}Ae.to=xe;function De(te){return{label:te.label,textEdit:te.textEdit?ae.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Me=>ae.from(Me)):void 0}}Ae.from=De})(st||(e.ColorPresentation=st={}));var Te;(function(Ae){function xe(te){return new w.Color(te[0],te[1],te[2],te[3])}Ae.to=xe;function De(te){return[te.red,te.green,te.blue,te.alpha]}Ae.from=De})(Te||(e.Color=Te={}));var Ue;(function(Ae){function xe(te){return{range:O.from(te.range)}}Ae.from=xe;function De(te){return new w.SelectionRange(O.to(te.range))}Ae.to=De})(Ue||(e.SelectionRange=Ue={}));var ke;(function(Ae){function xe(De){switch(De){case o.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case o.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case o.SaveReason.FOCUS_CHANGE:case o.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}Ae.to=xe})(ke||(e.TextDocumentSaveReason=ke={}));var Re;(function(Ae){function xe(te){switch(te){case w.TextEditorLineNumbersStyle.Off:return f.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return f.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return f.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return f.RenderLineNumbersType.On}}Ae.from=xe;function De(te){switch(te){case f.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case f.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case f.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case f.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}Ae.to=De})(Re||(e.TextEditorLineNumbersStyle=Re={}));var ce;(function(Ae){function xe(te){if(te===w.EndOfLine.CRLF)return i.EndOfLineSequence.CRLF;if(te===w.EndOfLine.LF)return i.EndOfLineSequence.LF}Ae.from=xe;function De(te){if(te===i.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(te===i.EndOfLineSequence.LF)return w.EndOfLine.LF}Ae.to=De})(ce||(e.EndOfLine=ce={}));var Q;(function(Ae){function xe(De){if(typeof De=="object")return De.viewId;switch(De){case w.ProgressLocation.SourceControl:return c.ProgressLocation.Scm;case w.ProgressLocation.Window:return c.ProgressLocation.Window;case w.ProgressLocation.Notification:return c.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ae.from=xe})(Q||(e.ProgressLocation=Q={}));var Pe;(function(Ae){function xe(te){const Me={start:te.start+1,end:te.end+1};return te.kind&&(Me.kind=Ge.from(te.kind)),Me}Ae.from=xe;function De(te){const Me={start:te.start-1,end:te.end-1};return te.kind&&(Me.kind=Ge.to(te.kind)),Me}Ae.to=De})(Pe||(e.FoldingRange=Pe={}));var Ge;(function(Ae){function xe(te){if(te)switch(te){case w.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}Ae.from=xe;function De(te){if(te)switch(te.value){case s.FoldingRangeKind.Comment.value:return w.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports.value:return w.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region.value:return w.FoldingRangeKind.Region}}Ae.to=De})(Ge||(e.FoldingRangeKind=Ge={}));var Ze;(function(Ae){function xe(De){if(De)return{pinned:typeof De.preview=="boolean"?!De.preview:void 0,inactive:De.background,preserveFocus:De.preserveFocus,selection:typeof De.selection=="object"?O.from(De.selection):void 0,override:typeof De.override=="boolean"?o.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=xe})(Ze||(e.TextEditorOpenOptions=Ze={}));var at;(function(Ae){function xe($e){return $e instanceof w.RelativePattern?$e.toJSON():typeof $e=="string"?$e:De($e)||te($e)?new w.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Ae.from=xe;function De($e){const et=$e;return et?u.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function te($e){const et=$e;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Me($e){return typeof $e=="string"?$e:new w.RelativePattern(u.URI.revive($e.baseUri),$e.pattern)}Ae.to=Me})(at||(e.GlobPattern=at={}));var ct;(function(Ae){function xe(De){if(De){if(Array.isArray(De))return De.map(xe);if(typeof De=="string")return De;{const te=De;return{language:te.language,scheme:te.scheme,pattern:at.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Ae.from=xe})(ct||(e.LanguageSelector=ct={}));var Ct;(function(Ae){function xe(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(Me=>Array.isArray(Me)&&Me.every($e=>$e&&typeof $e=="object"&&"uri"in $e&&u.URI.isUri($e.uri)&&"version"in $e&&typeof $e.version=="number"&&"ranges"in $e&&Array.isArray($e.ranges)&&$e.ranges.every(et=>et instanceof w.Range)))}Ae.is=xe;function De(te){return{documents:te.documents.map(Me=>Me.map($e=>({uri:u.URI.from($e.uri),version:$e.version,ranges:$e.ranges.map(et=>O.from(et))})))}}Ae.from=De})(Ct||(e.MappedEditsContext=Ct={}));var Pt;(function(Ae){function xe(te){return{start:te.start,end:te.end}}Ae.from=xe;function De(te){return new w.NotebookRange(te.start,te.end)}Ae.to=De})(Pt||(e.NotebookRange=Pt={}));var Ot;(function(Ae){function xe(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Ae.to=xe;function De(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Ae.from=De})(Ot||(e.NotebookCellExecutionSummary=Ot={}));var Xt;(function(Ae){function xe(De){if(De===C.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(De===C.NotebookCellExecutionState.Pending)return;if(De===C.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${De}`)}Ae.to=xe})(Xt||(e.NotebookCellExecutionState=Xt={}));var Zt;(function(Ae){function xe(te){switch(te){case w.NotebookCellKind.Markup:return C.CellKind.Markup;case w.NotebookCellKind.Code:default:return C.CellKind.Code}}Ae.from=xe;function De(te){switch(te){case C.CellKind.Markup:return w.NotebookCellKind.Markup;case C.CellKind.Code:default:return w.NotebookCellKind.Code}}Ae.to=De})(Zt||(e.NotebookCellKind=Zt={}));var Je;(function(Ae){function xe(te){const Me={metadata:te.metadata??Object.create(null),cells:[]};for(const $e of te.cells)w.NotebookCellData.validate($e),Me.cells.push($t.from($e));return Me}Ae.from=xe;function De(te){const Me=new w.NotebookData(te.cells.map($t.to));return(0,a.isEmptyObject)(te.metadata)||(Me.metadata=te.metadata),Me}Ae.to=De})(Je||(e.NotebookData=Je={}));var $t;(function(Ae){function xe(te){return{cellKind:Zt.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Ot.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(mt.from):[]}}Ae.from=xe;function De(te){return new w.NotebookCellData(Zt.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(mt.to):void 0,te.metadata,te.internalMetadata?Ot.to(te.internalMetadata):void 0)}Ae.to=De})($t||(e.NotebookCellData=$t={}));var Bt;(function(Ae){function xe(te){return{mime:te.mime,valueBytes:g.VSBuffer.wrap(te.data)}}Ae.from=xe;function De(te){return new w.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Ae.to=De})(Bt||(e.NotebookCellOutputItem=Bt={}));var mt;(function(Ae){function xe(te){return{outputId:te.id,items:te.items.map(Bt.from),metadata:te.metadata}}Ae.from=xe;function De(te){const Me=te.items.map(Bt.to);return new w.NotebookCellOutput(Me,te.outputId,te.metadata)}Ae.to=De})(mt||(e.NotebookCellOutput=mt={}));var pt;(function(Ae){function xe(Me){return te(Me)?{include:at.from(Me.include)??void 0,exclude:at.from(Me.exclude)??void 0}:at.from(Me)??void 0}Ae.from=xe;function De(Me){return te(Me)?{include:at.to(Me.include),exclude:at.to(Me.exclude)}:at.to(Me)}Ae.to=De;function te(Me){const $e=Me;return $e?!(0,a.isUndefinedOrNull)($e.include)&&!(0,a.isUndefinedOrNull)($e.exclude):!1}})(pt||(e.NotebookExclusiveDocumentPattern=pt={}));var ei;(function(Ae){function xe(De,te,Me){const $e=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{alignment:De.alignment===w.NotebookCellStatusBarAlignment.Left?C.CellStatusbarAlignment.Left:C.CellStatusbarAlignment.Right,command:te.toInternal($e,Me),text:De.text,tooltip:De.tooltip,accessibilityInformation:De.accessibilityInformation,priority:De.priority}}Ae.from=xe})(ei||(e.NotebookStatusBarItem=ei={}));var Qt;(function(Ae){function xe(De,te,Me){const $e=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{command:te.toInternal($e,Me),label:De.label,description:De.description,detail:De.detail,documentation:De.documentation}}Ae.from=xe})(Qt||(e.NotebookKernelSourceAction=Qt={}));var Wt;(function(Ae){function xe(De){return{transientOutputs:De?.transientOutputs??!1,transientCellMetadata:De?.transientCellMetadata??{},transientDocumentMetadata:De?.transientDocumentMetadata??{},cellContentMetadata:De?.cellContentMetadata??{}}}Ae.from=xe})(Wt||(e.NotebookDocumentContentOptions=Wt={}));var Et;(function(Ae){function xe(te){return{uri:te.uri,provides:te.provides}}Ae.from=xe;function De(te){return new w.NotebookRendererScript(u.URI.revive(te.uri),te.provides)}Ae.to=De})(Et||(e.NotebookRendererScript=Et={}));var Ft;(function(Ae){function xe(te){return{message:de.fromStrict(te.message)||"",type:I.TestMessageType.Error,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:O.from(te.location.range),uri:te.location.uri}}}Ae.from=xe;function De(te){const Me=new w.TestMessage(typeof te.message=="string"?te.message:de.to(te.message));return Me.actualOutput=te.actual,Me.expectedOutput=te.expected,Me.contextValue=te.contextValue,Me.location=te.location?We.to(te.location):void 0,Me}Ae.to=De})(Ft||(e.TestMessage=Ft={}));var qt;(function(Ae){Ae.namespace=I.namespaceTestTag,Ae.denamespace=I.denamespaceTestTag})(qt||(e.TestTag=qt={}));var zt;(function(Ae){function xe(te){const Me=(0,h.getPrivateApiFor)(te).controllerId;return{extId:S.TestId.fromExtHostTestItem(te,Me).toString(),label:te.label,uri:u.URI.revive(te.uri),busy:te.busy,tags:te.tags.map($e=>qt.namespace(Me,$e.id)),range:m.Range.lift(O.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&de.fromStrict(te.error)||null}}Ae.from=xe;function De(te){return{parent:void 0,error:void 0,id:S.TestId.fromString(te.extId).localId,label:te.label,uri:u.URI.revive(te.uri),tags:(te.tags||[]).map(Me=>{const{tagId:$e}=qt.denamespace(Me);return new w.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:O.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Ae.toPlain=De})(zt||(e.TestItem=zt={})),function(Ae){function xe(te){return{id:te.id}}Ae.from=xe;function De(te){return new w.TestTag(te.id)}Ae.to=De}(qt||(e.TestTag=qt={}));var Qe;(function(Ae){const xe=(te,Me)=>{const $e=te.value;if(!$e)return;const et={...zt.toPlain($e.item),parent:Me,taskStates:$e.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(ht=>ht.type===I.TestMessageType.Error).map(Ft.to)})),children:[]};if(te.children)for(const je of te.children.values()){const ht=xe(je,et);ht&&et.children.push(ht)}return et};function De(te){const Me=new d.WellDefinedPrefixTree;for(const je of te.items)Me.insert(S.TestId.fromString(je.item.extId).path,je);const $e=[Me.nodes],et=[];for(;$e.length;)for(const je of $e.pop())je.value?et.push(je):je.children&&$e.push(je.children.values());return{completedAt:te.completedAt,results:et.map(je=>xe(je)).filter(a.isDefined)}}Ae.to=De})(Qe||(e.TestResults=Qe={}));var ti;(function(Ae){function xe($e){return{covered:$e.covered,total:$e.total}}function De($e){return"line"in $e?B.from($e):O.from($e)}function te($e){if(typeof $e.executed=="number"&&$e.executed<0)throw new Error(`Invalid coverage count ${$e.executed}`);return"branches"in $e?{count:$e.executed,location:De($e.location),type:I.DetailType.Statement,branches:$e.branches.length?$e.branches.map(et=>({count:et.executed,location:et.location&&De(et.location),label:et.label})):void 0}:{type:I.DetailType.Declaration,name:$e.name,count:$e.executed,location:De($e.location)}}Ae.fromDetails=te;function Me($e,et,je){return w.validateTestCoverageCount(je.statementCoverage),w.validateTestCoverageCount(je.branchCoverage),w.validateTestCoverageCount(je.declarationCoverage),{id:et,uri:je.uri,statement:xe(je.statementCoverage),branch:je.branchCoverage&&xe(je.branchCoverage),declaration:je.declarationCoverage&&xe(je.declarationCoverage),testId:je instanceof w.FileCoverage&&je.testItem?S.TestId.fromExtHostTestItem(je.testItem,$e).toString():void 0}}Ae.fromFile=Me})(ti||(e.TestCoverage=ti={}));var ii;(function(Ae){function xe(De){switch(De){case s.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}Ae.to=xe})(ii||(e.CodeActionTriggerKind=ii={}));var ci;(function(Ae){function xe(te){const Me=new w.TypeHierarchyItem(le.to(te.kind),te.name,te.detail||"",u.URI.revive(te.uri),O.to(te.range),O.to(te.selectionRange));return Me._sessionId=te._sessionId,Me._itemId=te._itemId,Me}Ae.to=xe;function De(te,Me,$e){if(Me=Me??te._sessionId,$e=$e??te._itemId,Me===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:$e,kind:le.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:O.from(te.range),selectionRange:O.from(te.selectionRange),tags:te.tags?.map(ue.from)}}Ae.from=De})(ci||(e.TypeHierarchyItem=ci={}));var Dt;(function(Ae){function xe(De){if(De)return{value:De.value,tooltip:De.tooltip}}Ae.from=xe})(Dt||(e.ViewBadge=Dt={}));var Nt;(function(Ae){function xe($e,et,je){const ht=et.fileData;return ht?new w.InternalFileDataTransferItem(new w.DataTransferFile(ht.name,u.URI.revive(ht.uri),ht.id,(0,A.createSingleCallFunction)(()=>je(ht.id)))):$e===P.Mimes.uriList&&et.uriListData?new w.InternalDataTransferItem(Me(et.uriListData)):new w.InternalDataTransferItem(et.asString)}Ae.to=xe;async function De($e,et){const je=await et.asString();if($e===P.Mimes.uriList)return{asString:je,fileData:void 0,uriListData:te(je)};const ht=et.asFile();return{asString:je,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Ae.from=De;function te($e){return k.UriList.split($e).map(et=>{if(et.startsWith("#"))return et;try{return u.URI.parse(et)}catch{}return et})}function Me($e){return k.UriList.create($e.map(et=>typeof et=="string"?et:u.URI.revive(et)))}})(Nt||(e.DataTransferItem=Nt={}));var At;(function(Ae){function xe(te,Me){const $e=te.items.map(([et,je])=>[et,Nt.to(et,je,Me)]);return new w.DataTransfer($e)}Ae.toDataTransfer=xe;async function De(te){const Me={items:[]},$e=[];for(const[et,je]of te)$e.push((async()=>{Me.items.push([et,await Nt.from(et,je)])})());return await Promise.all($e),Me}Ae.from=De})(At||(e.DataTransfer=At={}));var Mt;(function(Ae){function xe(te,Me){return{kind:"reply",agentId:te.participant??Me?.agentId??"",subCommand:te.command??Me?.command,message:te.prompt,title:te.label}}Ae.from=xe;function De(te){return{prompt:te.message,label:te.title,participant:te.agentId,command:te.subCommand}}Ae.to=De})(Mt||(e.ChatFollowup=Mt={}));var ui;(function(Ae){function xe(te){switch(te.role){case _.ChatMessageRole.System:return new w.LanguageModelChatMessage(w.LanguageModelChatMessageRole.System,te.content);case _.ChatMessageRole.User:return new w.LanguageModelChatMessage(w.LanguageModelChatMessageRole.User,te.content);case _.ChatMessageRole.Assistant:return new w.LanguageModelChatMessage(w.LanguageModelChatMessageRole.Assistant,te.content)}}Ae.to=xe;function De(te){switch(te.role){case w.LanguageModelChatMessageRole.System:return{role:_.ChatMessageRole.System,content:te.content};case w.LanguageModelChatMessageRole.User:return{role:_.ChatMessageRole.User,content:te.content};case w.LanguageModelChatMessageRole.Assistant:return{role:_.ChatMessageRole.Assistant,content:te.content}}}Ae.from=De})(ui||(e.LanguageModelChatMessage=ui={}));var Ht;(function(Ae){function xe(te){return{kind:"markdownContent",content:de.from(te.value)}}Ae.from=xe;function De(te){return new w.ChatResponseMarkdownPart(de.to(te.content))}Ae.to=De})(Ht||(e.ChatResponseMarkdownPart=Ht={}));var si;(function(Ae){function xe(te){return{kind:"markdownVuln",content:de.from(te.value),vulnerabilities:te.vulnerabilities}}Ae.from=xe;function De(te){return new w.ChatResponseMarkdownWithVulnerabilitiesPart(de.to(te.content),te.vulnerabilities)}Ae.to=De})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Ut;(function(Ae){function xe(te){return{kind:"agentDetection",agentId:te.participant,command:te.command}}Ae.from=xe;function De(te){return new w.ChatResponseDetectedParticipantPart(te.agentId,te.command)}Ae.to=De})(Ut||(e.ChatResponseDetectedParticipantPart=Ut={}));var Yt;(function(Ae){function xe(De){return{kind:"confirmation",title:De.title,message:De.message,data:De.data}}Ae.from=xe})(Yt||(e.ChatResponseConfirmationPart=Yt={}));var oi;(function(Ae){function xe(te){const{value:Me,baseUri:$e}=te;function et(je,ht){return je.map(It=>{const Jt=u.URI.joinPath(ht,It.name);return{label:It.name,uri:Jt,children:It.children&&et(It.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,T.basename)($e),uri:$e,children:et(Me,$e)}}}Ae.from=xe;function De(te){const Me=(0,l.revive)(te.treeData);function $e(ht){return ht.map(It=>({name:It.label,children:It.children&&$e(It.children)}))}const et=Me.uri,je=Me.children?$e(Me.children):[];return new w.ChatResponseFileTreePart(je,et)}Ae.to=De})(oi||(e.ChatResponseFilesPart=oi={}));var kt;(function(Ae){function xe(te){const Me=$e=>u.URI.isUri($e);return{kind:"inlineReference",name:te.title,inlineReference:Me(te.value)?te.value:U.from(te.value)}}Ae.from=xe;function De(te){const Me=(0,l.revive)(te);return new w.ChatResponseAnchorPart(u.URI.isUri(Me.inlineReference)?Me.inlineReference:U.to(Me.inlineReference),te.name)}Ae.to=De})(kt||(e.ChatResponseAnchorPart=kt={}));var St;(function(Ae){function xe(te){return{kind:"progressMessage",content:de.from(te.value)}}Ae.from=xe;function De(te){return new w.ChatResponseProgressPart(te.content.value)}Ae.to=De})(St||(e.ChatResponseProgressPart=St={}));var vt;(function(Ae){function xe(te){return{kind:"warning",content:de.from(te.value)}}Ae.from=xe;function De(te){return new w.ChatResponseWarningPart(te.content.value)}Ae.to=De})(vt||(e.ChatResponseWarningPart=vt={}));var Vt;(function(Ae){function xe(De){return{kind:"progressTask",content:de.from(De.value)}}Ae.from=xe})(Vt||(e.ChatTask=Vt={}));var yt;(function(Ae){function xe(De){return{kind:"progressTaskResult",content:typeof De=="string"?de.from(De):void 0}}Ae.from=xe})(yt||(e.ChatTaskResult=yt={}));var ai;(function(Ae){function xe(te,Me,$e){return{kind:"command",command:Me.toInternal(te.value,$e)??{command:te.value.command,title:te.value.title}}}Ae.from=xe;function De(te,Me){return new w.ChatResponseCommandButtonPart(Me.fromInternal(te.command)??{command:te.command.id,title:te.command.title})}Ae.to=De})(ai||(e.ChatResponseCommandButtonPart=ai={}));var jt;(function(Ae){function xe(te){return{kind:"textEdit",uri:te.uri,edits:te.edits.map(Me=>ae.from(Me))}}Ae.from=xe;function De(te){return new w.ChatResponseTextEditPart(u.URI.revive(te.uri),te.edits.map(Me=>ae.to(Me)))}Ae.to=De})(jt||(e.ChatResponseTextEditPart=jt={}));var pi;(function(Ae){function xe(te){const Me=E.ThemeIcon.isThemeIcon(te.iconPath)?te.iconPath:u.URI.isUri(te.iconPath)?{light:u.URI.revive(te.iconPath)}:te.iconPath&&"light"in te.iconPath&&"dark"in te.iconPath&&u.URI.isUri(te.iconPath.light)&&u.URI.isUri(te.iconPath.dark)?{light:u.URI.revive(te.iconPath.light),dark:u.URI.revive(te.iconPath.dark)}:void 0;return"variableName"in te.value?{kind:"reference",reference:{variableName:te.value.variableName,value:u.URI.isUri(te.value.value)||!te.value.value?te.value.value:U.from(te.value.value)},iconPath:Me}:{kind:"reference",reference:u.URI.isUri(te.value)?te.value:U.from(te.value),iconPath:Me}}Ae.from=xe;function De(te){const Me=(0,l.revive)(te),$e=et=>u.URI.isUri(et)?et:U.to(et);return new w.ChatResponseReferencePart("variableName"in Me.reference?{variableName:Me.reference.variableName,value:Me.reference.value&&$e(Me.reference.value)}:$e(Me.reference))}Ae.to=De})(pi||(e.ChatResponseReferencePart=pi={}));var hi;(function(Ae){function xe(Me,$e,et){return Me instanceof w.ChatResponseMarkdownPart?Ht.from(Me):Me instanceof w.ChatResponseAnchorPart?kt.from(Me):Me instanceof w.ChatResponseReferencePart?pi.from(Me):Me instanceof w.ChatResponseProgressPart?St.from(Me):Me instanceof w.ChatResponseFileTreePart?oi.from(Me):Me instanceof w.ChatResponseCommandButtonPart?ai.from(Me,$e,et):Me instanceof w.ChatResponseTextEditPart?jt.from(Me):Me instanceof w.ChatResponseMarkdownWithVulnerabilitiesPart?si.from(Me):Me instanceof w.ChatResponseDetectedParticipantPart?Ut.from(Me):Me instanceof w.ChatResponseWarningPart?vt.from(Me):{kind:"markdownContent",content:de.from("")}}Ae.from=xe;function De(Me,$e){switch(Me.kind){case"reference":return pi.to(Me);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return te(Me,$e)}}Ae.to=De;function te(Me,$e){switch(Me.kind){case"markdownContent":return Ht.to(Me);case"inlineReference":return kt.to(Me);case"progressMessage":return;case"treeData":return oi.to(Me);case"command":return ai.to(Me,$e)}}Ae.toContent=te})(hi||(e.ChatResponsePart=hi={}));var Ci;(function(Ae){function xe(De){return{prompt:De.message,command:De.command,attempt:De.attempt??0,enableCommandDetection:De.enableCommandDetection??!0,references:De.variables.variables.map(Pi.to),location:Rt.to(De.location),acceptedConfirmationData:De.acceptedConfirmationData,rejectedConfirmationData:De.rejectedConfirmationData}}Ae.to=xe})(Ci||(e.ChatAgentRequest=Ci={}));var Rt;(function(Ae){function xe(te){switch(te){case p.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case p.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case p.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case p.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}Ae.to=xe;function De(te){switch(te){case w.ChatLocation.Notebook:return p.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return p.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return p.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return p.ChatAgentLocation.Editor}}Ae.from=De})(Rt||(e.ChatLocation=Rt={}));var Pi;(function(Ae){function xe(De){const te=De.value;if(!te)throw new Error("Invalid value reference");return{id:De.id,name:De.name,range:De.range&&[De.range.start,De.range.endExclusive],value:(0,u.isUriComponents)(te)?u.URI.revive(te):te&&typeof te=="object"&&"uri"in te&&"range"in te&&(0,u.isUriComponents)(te.uri)?U.to((0,l.revive)(te)):te,modelDescription:De.modelDescription}}Ae.to=xe})(Pi||(e.ChatAgentValueReference=Pi={}));var li;(function(Ae){function xe(De,te,Me){return{id:De.id,label:De.label,fullName:De.fullName,icon:De.icon?.id,value:De.values[0].value,insertText:De.insertText,detail:De.detail,documentation:De.documentation,command:te.toInternal(De.command,Me)}}Ae.from=xe})(li||(e.ChatAgentCompletionItem=li={}));var Tt;(function(Ae){function xe(De){return{errorDetails:De.errorDetails,metadata:De.metadata}}Ae.to=xe})(Tt||(e.ChatAgentResult=Tt={}));var Ii;(function(Ae){function xe(De,te,Me){if(te.action.kind==="vote")return;const $e=Tt.to(De);if(te.action.kind==="command"){const et=te.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Me.fromInternal(et)??{command:et.id,title:et.title}}},result:$e}}else return te.action.kind==="followUp"?{action:{kind:"followUp",followup:Mt.to(te.action.followup)},result:$e}:te.action.kind==="inlineChat"?{action:{kind:"editor",accepted:te.action.action==="accepted"},result:$e}:{action:te.action,result:$e}}Ae.to=xe})(Ii||(e.ChatAgentUserActionEvent=Ii={}));var Si;(function(Ae){function xe(De,te,Me){return"terminalCommand"in De?{terminalCommand:De.terminalCommand,shouldExecute:De.shouldExecute}:"uri"in De?{uri:De.uri}:te.toInternal(De,Me)}Ae.from=xe})(Si||(e.TerminalQuickFix=Si={}));var vi;(function(Ae){function xe(De){return{kind:ki.to(De.kind)}}Ae.to=xe})(vi||(e.PartialAcceptInfo=vi={}));var ki;(function(Ae){function xe(De){switch(De){case s.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}Ae.to=xe})(ki||(e.PartialAcceptTriggerKind=ki={}));var fi;(function(Ae){function xe(De,te){return{id:te,label:De.label,description:De.description,canEdit:De.canEdit,collapsibleState:De.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:De.contextValue}}Ae.from=xe})(fi||(e.DebugTreeItem=fi={}))}),define(we[344],ye([1,0,6,20,17,52]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(v,l){this._proxy=v.getProxy(r.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:P=>l.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,l,P){const y=new A.SerializableObjectWithBuffers(k.WorkspaceEdit.from(v,this._versionInformationProvider));return this._proxy.$tryApplyWorkspaceEdit(y,void 0,P?.isRefactoring??!1)}};e.ExtHostBulkEdits=L,e.ExtHostBulkEdits=L=Ke([Ve(0,g.IExtHostRpcService)],L)}),define(we[345],ye([1,0,19,9,51,4,40,3,42,18,2,24,6,17,10,306,26]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class f{constructor(i,t,c,h,o){this._extension=i,this._request=t,this._proxy=c,this._commandsConverter=h,this._sessionDisposables=o,this._stopWatch=v.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let t=function(h){if(i._isClosed){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,h),o}};const i=this;this._stopWatch.reset();const c=(h,o)=>{if(typeof this._firstProgress>"u"&&"content"in h&&(this._firstProgress=this._stopWatch.elapsed()),o){const p=this._proxy.$handleProgressChunk(this._request.requestId,h),_={report:D=>{p?.then(C=>{C&&(E.MarkdownString.isMarkdownString(D.value)?this._proxy.$handleProgressChunk(this._request.requestId,T.ChatResponseWarningPart.from(D),C):this._proxy.$handleProgressChunk(this._request.requestId,T.ChatResponseReferencePart.from(D),C))})}};Promise.all([p,o?.(_)]).then(([D,C])=>{D!==void 0&&C!==void 0&&this._proxy.$handleProgressChunk(this._request.requestId,T.ChatTaskResult.from(C),D)})}else this._proxy.$handleProgressChunk(this._request.requestId,h)};this._apiObject={markdown(h){t(this.markdown);const o=new E.ChatResponseMarkdownPart(h),p=T.ChatResponseMarkdownPart.from(o);return c(p),this},markdownWithVulnerabilities(h,o){t(this.markdown),o&&(0,u.checkProposedApiEnabled)(i._extension,"chatParticipantAdditions");const p=new E.ChatResponseMarkdownWithVulnerabilitiesPart(h,o),_=T.ChatResponseMarkdownWithVulnerabilitiesPart.from(p);return c(_),this},filetree(h,o){t(this.filetree);const p=new E.ChatResponseFileTreePart(h,o),_=T.ChatResponseFilesPart.from(p);return c(_),this},anchor(h,o){t(this.anchor);const p=new E.ChatResponseAnchorPart(h,o),_=T.ChatResponseAnchorPart.from(p);return c(_),this},button(h){t(this.anchor);const o=new E.ChatResponseCommandButtonPart(h),p=T.ChatResponseCommandButtonPart.from(o,i._commandsConverter,i._sessionDisposables);return c(p),this},progress(h,o){t(this.progress);const p=new E.ChatResponseProgressPart2(h,o),_=o?T.ChatTask.from(p):T.ChatResponseProgressPart.from(p);return c(_,o),this},warning(h){t(this.progress),(0,u.checkProposedApiEnabled)(i._extension,"chatParticipantAdditions");const o=new E.ChatResponseWarningPart(h),p=T.ChatResponseWarningPart.from(o);return c(p),this},reference(h,o){if(t(this.reference),"variableName"in h&&(0,u.checkProposedApiEnabled)(i._extension,"chatParticipantAdditions"),"variableName"in h&&!h.value){const p=i._request.variables.variables.find(_=>_.name===h.variableName);if(p){let _;if(p.references?.length)_=p.references.map(D=>({kind:"reference",reference:{variableName:h.variableName,value:D.reference}}));else{const D=new E.ChatResponseReferencePart(h,o);_=[T.ChatResponseReferencePart.from(D)]}return _.forEach(D=>c(D)),this}}else{const p=new E.ChatResponseReferencePart(h,o),_=T.ChatResponseReferencePart.from(p);c(_)}return this},textEdit(h,o){t(this.textEdit),(0,u.checkProposedApiEnabled)(i._extension,"chatParticipantAdditions");const p=new E.ChatResponseTextEditPart(h,o),_=T.ChatResponseTextEditPart.from(p);return c(_),this},detectedParticipant(h,o){t(this.detectedParticipant),(0,u.checkProposedApiEnabled)(i._extension,"chatParticipantAdditions");const p=new E.ChatResponseDetectedParticipantPart(h,o),_=T.ChatResponseDetectedParticipantPart.from(p);return c(_),this},confirmation(h,o,p){t(this.confirmation),(0,u.checkProposedApiEnabled)(i._extension,"chatParticipantAdditions");const _=new E.ChatResponseConfirmationPart(h,o,p),D=T.ChatResponseConfirmationPart.from(_);return c(D),this},push(h){if(t(this.push),(h instanceof E.ChatResponseTextEditPart||h instanceof E.ChatResponseMarkdownWithVulnerabilitiesPart||h instanceof E.ChatResponseDetectedParticipantPart||h instanceof E.ChatResponseWarningPart||h instanceof E.ChatResponseConfirmationPart)&&(0,u.checkProposedApiEnabled)(i._extension,"chatParticipantAdditions"),h instanceof E.ChatResponseReferencePart)this.reference(h.value,h.iconPath);else{const o=T.ChatResponsePart.from(h,i._commandsConverter,i._sessionDisposables);c(o)}return this}}}return this._apiObject}}class m extends R.Disposable{static{this._idPool=0}constructor(i,t,c,h){super(),this._logService=t,this.commands=c,this.quality=h,this._agents=new Map,this._sessionDisposables=this._register(new R.DisposableMap),this._completionDisposables=this._register(new R.DisposableMap),this._proxy=i.getProxy(d.MainContext.MainThreadChatAgents2)}transferActiveChat(i){this._proxy.$transferActiveChatSession(i)}createChatAgent(i,t,c){const h=m._idPool++,o=new n(i,this.quality,t,this._proxy,h,c);return this._agents.set(h,o),o.isAgentEnabled()&&this._proxy.$registerAgent(h,i.identifier,t,{},void 0),o.apiAgent}createDynamicChatAgent(i,t,c,h){const o=m._idPool++,p=new n(i,this.quality,t,this._proxy,o,h);return this._agents.set(o,p),this._proxy.$registerAgent(o,i.identifier,t,{isSticky:!0},c),p.apiAgent}async $invokeAgent(i,t,c,h){const o=this._agents.get(i);if(!o)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let p=this._sessionDisposables.get(t.sessionId);p||(p=new R.DisposableStore,this._sessionDisposables.set(t.sessionId,p));const _=new f(o.extension,t,this._proxy,this.commands.converter,p);try{const D=await this.prepareHistoryTurns(t.agentId,c),C=o.invoke(T.ChatAgentRequest.to(t),{history:D},_.apiObject,h);return await(0,g.raceCancellation)(Promise.resolve(C).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(b){const w=`result.metadata MUST be JSON.stringify-able. Got error: ${b.message}`;return this._logService.error(`[${o.extension.identifier.value}] [@${o.id}] ${w}`,o.extension),{errorDetails:{message:w},timings:_.timings}}let I;return S?.errorDetails&&(I={...S.errorDetails,responseIsIncomplete:!0}),I?.responseIsRedacted&&(0,u.checkProposedApiEnabled)(o.extension,"chatParticipantPrivate"),{errorDetails:I,timings:_.timings,metadata:S?.metadata}}),h)}catch(D){return this._logService.error(D,o.extension),D instanceof E.LanguageModelError&&D.cause&&(D=D.cause),{errorDetails:{message:(0,k.toErrorMessage)(D),responseIsIncomplete:!0}}}finally{_.close()}}async prepareHistoryTurns(i,t){const c=[];for(const h of t.history){const o=T.ChatAgentResult.to(h.result),p=i===h.request.agentId?o:{...o,metadata:void 0};c.push(new E.ChatRequestTurn(h.request.message,h.request.command,h.request.variables.variables.map(T.ChatAgentValueReference.to),h.request.agentId));const _=(0,r.coalesce)(h.response.map(D=>T.ChatResponsePart.toContent(D,this.commands.converter)));c.push(new E.ChatResponseTurn(_,p,h.request.agentId,h.request.command))}return c}$releaseSession(i){this._sessionDisposables.deleteAndDispose(i)}async $provideFollowups(i,t,c,h,o){const p=this._agents.get(t);if(!p)return Promise.resolve([]);const _=await this.prepareHistoryTurns(p.id,h),D=T.ChatAgentResult.to(c);return(await p.provideFollowups(D,{history:_},o)).filter(C=>{const S=!C.participant||L.Iterable.some(this._agents.values(),I=>I.id===C.participant&&y.ExtensionIdentifier.equals(I.extension.identifier,p.extension.identifier));return S||this._logService.warn(`[@${p.id}] ChatFollowup refers to an unknown participant: ${C.participant}`),S}).map(C=>T.ChatFollowup.from(C,i))}$acceptFeedback(i,t,c,h){const o=this._agents.get(i);if(!o)return;const p=T.ChatAgentResult.to(t);let _;switch(c){case a.ChatAgentVoteDirection.Down:_=E.ChatResultFeedbackKind.Unhelpful;break;case a.ChatAgentVoteDirection.Up:_=E.ChatResultFeedbackKind.Helpful;break}o.acceptFeedback(Object.freeze(h?{result:p,kind:_,reportIssue:h}:{result:p,kind:_}))}$acceptAction(i,t,c){const h=this._agents.get(i);if(!h||c.action.kind==="vote")return;const o=T.ChatAgentUserActionEvent.to(t,c,this.commands.converter);o&&h.acceptAction(Object.freeze(o))}async $invokeCompletionProvider(i,t,c){const h=this._agents.get(i);if(!h)return[];let o=this._completionDisposables.get(i);return o?o.clear():(o=new R.DisposableStore,this._completionDisposables.set(i,o)),(await h.invokeCompletionProvider(t,c)).map(_=>T.ChatAgentCompletionItem.from(_,this.commands.converter,o))}async $provideWelcomeMessage(i,t,c){const h=this._agents.get(i);if(h)return await h.provideWelcomeMessage(T.ChatLocation.to(t),c)}async $provideSampleQuestions(i,t,c){const h=this._agents.get(i);if(h)return(await h.provideSampleQuestions(T.ChatLocation.to(t),c)).map(o=>T.ChatFollowup.from(o,void 0))}}e.ExtHostChatAgents2=m;class n{constructor(i,t,c,h,o,p){this.extension=i,this.quality=t,this.id=c,this._proxy=h,this._handle=o,this._requestHandler=p,this._onDidReceiveFeedback=new A.Emitter,this._onDidPerformAction=new A.Emitter}acceptFeedback(i){this._onDidReceiveFeedback.fire(i)}acceptAction(i){this._onDidPerformAction.fire(i)}async invokeCompletionProvider(i,t){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(i,t)??[]:[]}isAgentEnabled(){return!(this.quality==="stable"&&!(0,u.isProposedApiEnabled)(this.extension,"chatParticipantPrivate"))}async provideFollowups(i,t,c){if(!this._followupProvider)return[];const h=await this._followupProvider.provideFollowups(i,t,c);return h?h.filter(o=>!(o&&"commandId"in o)).filter(o=>!(o&&"message"in o)):[]}async provideWelcomeMessage(i,t){if(!this._welcomeMessageProvider)return[];const c=await this._welcomeMessageProvider.provideWelcomeMessage(i,t);return c?c.map(h=>typeof h=="string"?h:T.MarkdownString.from(h)):[]}async provideSampleQuestions(i,t){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const c=await this._welcomeMessageProvider.provideSampleQuestions(i,t);return c||[]}get apiAgent(){let i=!1,t=!1;const c=()=>{i||t||(t=!0,queueMicrotask(()=>{h.isAgentEnabled()&&(this._proxy.$updateAgent(this._handle,{icon:this._iconPath?this._iconPath instanceof P.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof E.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:T.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:T.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:T.MarkdownString.from(this._helpTextPostfix),supportIssueReporting:this._supportIssueReporting,requester:this._requester,supportsSlowVariables:this._supportsSlowReferences}),t=!1)}))},h=this;return{get id(){return h.id},get iconPath(){return h._iconPath},set iconPath(o){h._iconPath=o,c()},get requestHandler(){return h._requestHandler},set requestHandler(o){(0,l.assertType)(typeof o=="function","Invalid request handler"),h._requestHandler=o},get followupProvider(){return h._followupProvider},set followupProvider(o){h._followupProvider=o,c()},get isDefault(){return(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._isDefault},set isDefault(o){(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._isDefault=o,c()},get helpTextPrefix(){return(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextPrefix},set helpTextPrefix(o){(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextPrefix=o,c()},get helpTextVariablesPrefix(){return(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextVariablesPrefix},set helpTextVariablesPrefix(o){(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextVariablesPrefix=o,c()},get helpTextPostfix(){return(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextPostfix},set helpTextPostfix(o){(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._helpTextPostfix=o,c()},get isSecondary(){return(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._isSecondary},set isSecondary(o){(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._isSecondary=o,c()},get supportIssueReporting(){return(0,u.checkProposedApiEnabled)(h.extension,"chatParticipantPrivate"),h._supportIssueReporting},set supportIssueReporting(o){(0,u.checkProposedApiEnabled)(h.extension,"chatParticipantPrivate"),h._supportIssueReporting=o,c()},get onDidReceiveFeedback(){return h._onDidReceiveFeedback.event},set participantVariableProvider(o){if((0,u.checkProposedApiEnabled)(h.extension,"chatParticipantAdditions"),h._agentVariableProvider=o,o){if(!o.triggerCharacters.length)throw new Error("triggerCharacters are required");h._proxy.$registerAgentCompletionsProvider(h._handle,h.id,o.triggerCharacters)}else h._proxy.$unregisterAgentCompletionsProvider(h._handle,h.id)},get participantVariableProvider(){return(0,u.checkProposedApiEnabled)(h.extension,"chatParticipantAdditions"),h._agentVariableProvider},set welcomeMessageProvider(o){(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._welcomeMessageProvider=o,c()},get welcomeMessageProvider(){return(0,u.checkProposedApiEnabled)(h.extension,"defaultChatParticipant"),h._welcomeMessageProvider},onDidPerformAction:(0,u.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(o){h._requester=o,c()},get requester(){return h._requester},set supportsSlowReferences(o){(0,u.checkProposedApiEnabled)(h.extension,"chatParticipantPrivate"),h._supportsSlowReferences=o,c()},get supportsSlowReferences(){return(0,u.checkProposedApiEnabled)(h.extension,"chatParticipantPrivate"),h._supportsSlowReferences},dispose(){i=!0,h._followupProvider=void 0,h._onDidReceiveFeedback.dispose(),h._proxy.$unregisterAgent(h._handle)}}}invoke(i,t,c,h){return this._requestHandler(i,t,c,h)}}}),define(we[346],ye([1,0,14,3,50,6,17,10,26]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class l{static{this._idPool=0}constructor(d){this._resolver=new Map,this._proxy=d.getProxy(A.MainContext.MainThreadChatVariables)}async $resolveVariable(d,T,E,a){const u=this._resolver.get(d);if(u)try{if(u.resolver.resolve2){(0,v.checkProposedApiEnabled)(u.extension,"chatParticipantAdditions");const f=new P(T,this._proxy),m=await u.resolver.resolve2(u.data.name,{prompt:E},f.apiObject,a);if(m&&m[0])return m[0].value}else{const f=await u.resolver.resolve(u.data.name,{prompt:E},a);if(f&&f[0])return f[0].value}}catch(f){(0,r.onUnexpectedExternalError)(f)}}registerVariableResolver(d,T,E,a,u,f,m,n,s){const i=l._idPool++,t=s?k.ThemeIcon.fromId(s):void 0;return this._resolver.set(i,{extension:d,data:{id:T,name:E,description:a,modelDescription:u,icon:t},resolver:m}),this._proxy.$registerVariable(i,{id:T,name:E,description:a,modelDescription:u,isSlow:f,fullName:n,icon:t}),(0,g.toDisposable)(()=>{this._resolver.delete(i),this._proxy.$unregisterVariable(i)})}attachContext(d,T,E){this._proxy.$attachContext(d,R.Location.isLocation(T)?L.Location.from(T):T,L.ChatLocation.from(E))}}e.ExtHostChatVariables=l;class P{constructor(d,T){this._requestId=d,this._proxy=T,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let T=function(a){if(d._isClosed){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,a),u}};const d=this,E=a=>{this._proxy.$handleProgressChunk(this._requestId,a)};this._apiObject={progress(a){T(this.progress);const u=new R.ChatResponseProgressPart(a),f=L.ChatResponseProgressPart.from(u);return E(f),this},reference(a){T(this.reference);const u=new R.ChatResponseReferencePart(a),f=L.ChatResponseReferencePart.from(u);return E(f),this},push(a){return T(this.push),a instanceof R.ChatResponseReferencePart?E(L.ChatResponseReferencePart.from(a)):a instanceof R.ChatResponseProgressPart&&E(L.ChatResponseProgressPart.from(a)),this}}}return this._apiObject}}}),define(we[347],ye([1,0,9,60,4,3,41,2,88,24,17,10,6,26]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=E;function E(a,u,f){const m=a.getProxy(d.MainContext.MainThreadComments);class n{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new l.ExtensionIdentifierMap,u.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===L.MarshalledId.CommentController){const S=this._commentControllers.get(C.handle);return S?S.value:C}else if(C&&C.$mid===L.MarshalledId.CommentThread){const S=C,I=this._commentControllers.get(S.commentControlHandle);if(!I)return S;const b=I.getCommentThread(S.commentThreadHandle);return b?b.value:S}else if(C&&(C.$mid===L.MarshalledId.CommentThreadReply||C.$mid===L.MarshalledId.CommentThreadInstance)){const S=this._commentControllers.get(C.thread.commentControlHandle);if(!S)return C;const I=S.getCommentThread(C.thread.commentThreadHandle);return I?C.$mid===L.MarshalledId.CommentThreadInstance?I.value:{thread:I.value,text:C.text}:C}else if(C&&C.$mid===L.MarshalledId.CommentNode){const S=this._commentControllers.get(C.thread.commentControlHandle);if(!S)return C;const I=S.getCommentThread(C.thread.commentThreadHandle);if(!I)return C;const b=C.commentUniqueId,w=I.getCommentByUniqueId(b);return w||C}else if(C&&C.$mid===L.MarshalledId.CommentThreadNode){const S=this._commentControllers.get(C.thread.commentControlHandle);if(!S)return C;const I=S.getCommentThread(C.thread.commentThreadHandle);if(!I)return C;const b=C.text,w=C.commentUniqueId,N=I.getCommentByUniqueId(w);return N?(typeof N.body=="string"?N.body=b:N.body=new y.MarkdownString(b),N):C}return C}})}createCommentController(C,S,I){const b=n.handlePool++,w=new i(C,b,S,I);this._commentControllers.set(w.handle,w);const N=this._commentControllersByExtension.get(C.identifier)||[];return N.push(w),this._commentControllersByExtension.set(C.identifier,N),w.value}async $createCommentThreadTemplate(C,S,I,b){const w=this._commentControllers.get(C);w&&w.$createCommentThreadTemplate(S,I,b)}async $setActiveComment(C,S){const I=this._commentControllers.get(C);I&&I.$setActiveComment(S??void 0)}async $updateCommentThreadTemplate(C,S,I){const b=this._commentControllers.get(C);b&&b.$updateCommentThreadTemplate(S,I)}$deleteCommentThread(C,S){this._commentControllers.get(C)?.$deleteCommentThread(S)}async $provideCommentingRanges(C,S,I){const b=this._commentControllers.get(C);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const w=await f.ensureDocumentData(R.URI.revive(S));return(0,r.asPromise)(async()=>{const N=await b.commentingRangeProvider.provideCommentingRanges(w.document,I);let O;return Array.isArray(N)?O={ranges:N,fileComments:!1}:N?O={ranges:N.ranges||[],fileComments:N.fileComments||!1}:O=N??void 0,O}).then(N=>{let O;return N&&(O={ranges:N.ranges.map(U=>P.Range.from(U)),fileComments:N.fileComments}),O})}$toggleReaction(C,S,I,b,w){const N=this._commentControllers.get(C);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const O=N.getCommentThread(S);if(O){const U=O.getCommentByUniqueId(b.uniqueIdInThread);if(N!==void 0&&U&&N.reactionHandler)return N.reactionHandler(U,h(w))}return Promise.resolve(void 0)})}}class s{static{this._handlePool=0}set threadId(C){this._id=C}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(C){(C===void 0!=(this._range===void 0)||!C||!this._range||!C.isEqual(this._range))&&(this._range=C,this.modifications.range=C,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(C){this._canReply!==C&&(this._canReply=C,this.modifications.canReply=C,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(C){this._label=C,this.modifications.label=C,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(C){this._contextValue=C,this.modifications.contextValue=C,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(C){this._comments=C,this.modifications.comments=C,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(C){this._collapseState=C,this.modifications.collapsibleState=C,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(C){this._state=C,typeof C=="object"?((0,T.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=C.resolved,this.modifications.applicability=C.applicability):this.modifications.state=C,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(C,S,I,b,w,N,O,U,x){this._commentControllerHandle=S,this._id=I,this._uri=b,this._range=w,this._comments=N,this.extensionDescription=O,this._isTemplate=U,this.handle=s._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${C}.${this.handle}`),m.$createCommentThread(S,this.handle,this._id,this._uri,P.Range.from(this._range),O.identifier,this._isTemplate,x),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this._localDisposables.push({dispose:()=>{m.$deleteCommentThread(S,this.handle)}});const B=this;this.value={get uri(){return B.uri},get range(){return B.range},set range(F){B.range=F},get comments(){return B.comments},set comments(F){B.comments=F},get collapsibleState(){return B.collapsibleState},set collapsibleState(F){B.collapsibleState=F},get canReply(){return B.canReply},set canReply(F){B.canReply=F},get contextValue(){return B.contextValue},set contextValue(F){B.contextValue=F},get label(){return B.label},set label(F){B.label=F},get state(){return B.state},set state(F){B.state=F},dispose:()=>{B.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const C=I=>Object.prototype.hasOwnProperty.call(this.modifications,I),S={};C("range")&&(S.range=P.Range.from(this._range)),C("label")&&(S.label=this.label),C("contextValue")&&(S.contextValue=this.contextValue??null),C("comments")&&(S.comments=this._comments.map(I=>t(this,I,this._commentsMap,this.extensionDescription))),C("collapsibleState")&&(S.collapseState=o(this._collapseState)),C("canReply")&&(S.canReply=this.canReply),C("state")&&(S.state=p(this._state)),C("applicability")&&(S.applicability=_(this._state)),C("isTemplate")&&(S.isTemplate=this._isTemplate),this.modifications={},m.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,S)}getCommentByUniqueId(C){for(const S of this._commentsMap){const I=S[0],b=S[1];if(C===b)return I}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(C=>C.dispose())}}Ke([(0,g.debounce)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class i{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(C){this._commentingRangeProvider=C,C?.resourceHints&&(0,T.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),m.$updateCommentingRanges(this.handle,C?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(C){this._reactionHandler=C,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!C})}get options(){return this._options}set options(C){this._options=C,m.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,T.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,T.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(C,S,I,b){this._extension=C,this._handle=S,this._id=I,this._label=b,this._threads=new Map,m.$registerCommentController(this.handle,I,b,this._extension.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(N){w.options=N},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(N){w.commentingRangeProvider=N},get reactionHandler(){return w.reactionHandler},set reactionHandler(N){w.reactionHandler=N},get activeCommentThread(){return w.activeCommentThread},createCommentThread(N,O,U){return w.createCommentThread(N,O,U).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}createCommentThread(C,S,I){S===void 0&&(0,T.checkProposedApiEnabled)(this._extension,"fileComments");const b=new s(this.id,this.handle,void 0,C,S,I,this._extension,!1);return this._threads.set(b.handle,b),b}$setActiveComment(C){if(!C){this._activeComment=void 0,this._activeThread=void 0;return}const S=this._threads.get(C.commentThreadHandle);S&&(this._activeComment=C.uniqueIdInThread?S.getCommentByUniqueId(C.uniqueIdInThread):void 0,this._activeThread=S)}$createCommentThreadTemplate(C,S,I){const b=new s(this.id,this.handle,void 0,R.URI.revive(C),P.Range.to(S),[],this._extension,!0,I);return b.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this._threads.set(b.handle,b),b}$updateCommentThreadTemplate(C,S){const I=this._threads.get(C);I&&(I.range=P.Range.to(S))}$deleteCommentThread(C){this._threads.get(C)?.dispose(),this._threads.delete(C)}getCommentThread(C){return this._threads.get(C)}dispose(){this._threads.forEach(C=>{C.dispose()}),this._localDisposables.forEach(C=>C.dispose())}}function t(D,C,S,I){let b=S.get(C);return b||(b=++D.commentHandle,S.set(C,b)),C.state!==void 0&&(0,T.checkProposedApiEnabled)(I,"commentsDraftState"),C.reactions?.some(w=>w.reactors!==void 0)&&(0,T.checkProposedApiEnabled)(I,"commentReactor"),{mode:C.mode,contextValue:C.contextValue,uniqueIdInThread:b,body:typeof C.body=="string"?C.body:P.MarkdownString.from(C.body),userName:C.author.name,userIconPath:C.author.iconPath,label:C.label,commentReactions:C.reactions?C.reactions.map(w=>c(w)):void 0,state:C.state,timestamp:C.timestamp?.toJSON()}}function c(D){return{label:D.label,iconPath:D.iconPath?P.pathOrURIToURI(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(C=>C.name):D.reactors}}function h(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?R.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(C=>({name:C}))}}function o(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function p(D){let C;if(typeof D=="object"?C=D.resolved:C=D,C!==void 0)switch(C){case y.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}function _(D){let C;if(typeof D=="object"&&(C=D.applicability),C!==void 0)switch(C){case y.CommentThreadApplicability.Current:return v.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return v.CommentThreadApplicability.Outdated}return v.CommentThreadApplicability.Current}return new n}}),define(we[348],ye([1,0,21,61,3,15,23,2,17,97,118,6,10]),function(he,e,r,g,k,A,L,R,v,l,P,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(c,h){this.document=c,this._storagePath=h,this._backupCounter=1,this._edits=new P.Cache("custom documents")}addEdit(c){return this._edits.add([c])}async undo(c,h){await this.getEdit(c).undo(),h||this.disposeBackup()}async redo(c,h){await this.getEdit(c).redo(),h||this.disposeBackup()}disposeEdits(c){for(const h of c)this._edits.delete(h)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const c=i(this.document.uri)+this._backupCounter++;return(0,L.joinPath)(this._storagePath,c)}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(c){const h=this._edits.get(c,0);if(!h)throw new Error("No edit found");return h}}class E{constructor(){this._documents=new Map}get(c,h){return this._documents.get(this.key(c,h))}add(c,h,o){const p=this.key(c,h.uri);if(this._documents.has(p))throw new Error(`Document already exists for viewType:${c} resource:${h.uri}`);const _=new T(h,o);return this._documents.set(p,_),_}delete(c,h){const o=this.key(c,h.uri);this._documents.delete(o)}key(c,h){return`${c}@@@${h}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class u{constructor(){this._providers=new Map}addTextProvider(c,h,o){return this.add(c,{type:a.Text,extension:h,provider:o})}addCustomProvider(c,h,o){return this.add(c,{type:a.Custom,extension:h,provider:o})}get(c){return this._providers.get(c)}add(c,h){if(this._providers.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this._providers.set(c,h),new d.Disposable(()=>this._providers.delete(c))}}class f{constructor(c,h,o,p,_){this._extHostDocuments=h,this._extensionStoragePaths=o,this._extHostWebview=p,this._extHostWebviewPanels=_,this._editorProviders=new u,this._documents=new E,this._proxy=c.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(c,h,o,p){const _=new k.DisposableStore;return n(o)?(_.add(this._editorProviders.addTextProvider(h,c,o)),this._proxy.$registerTextEditorProvider((0,l.toExtensionData)(c),h,p.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,l.shouldSerializeBuffersForPostMessage)(c))):(_.add(this._editorProviders.addCustomProvider(h,c,o)),m(o)&&_.add(o.onDidChangeCustomDocument(D=>{const C=this.getCustomDocumentEntry(h,D.document.uri);if(s(D)){const S=C.addEdit(D);this._proxy.$onDidEdit(D.document.uri,h,S,D.label)}else this._proxy.$onContentChange(D.document.uri,h)})),this._proxy.$registerCustomEditorProvider((0,l.toExtensionData)(c),h,p.webviewOptions||{},!!p.supportsMultipleEditorsPerDocument,(0,l.shouldSerializeBuffersForPostMessage)(c))),d.Disposable.from(_,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(h)}))}async $createCustomDocument(c,h,o,p,_){const D=this._editorProviders.get(h);if(!D)throw new Error(`No provider found for '${h}'`);if(D.type!==a.Custom)throw new Error(`Invalid provide type for '${h}'`);const C=R.URI.revive(c),S=await D.provider.openCustomDocument(C,{backupId:o,untitledDocumentData:p?.buffer},_);let I;return m(D.provider)&&this._extensionStoragePaths&&(I=this._extensionStoragePaths.workspaceValue(D.extension)??this._extensionStoragePaths.globalValue(D.extension)),this._documents.add(h,S,I),{editable:m(D.provider)}}async $disposeCustomDocument(c,h){const o=this._editorProviders.get(h);if(!o)throw new Error(`No provider found for '${h}'`);if(o.type!==a.Custom)throw new Error(`Invalid provider type for '${h}'`);const p=R.URI.revive(c),{document:_}=this.getCustomDocumentEntry(h,p);this._documents.delete(h,_),_.dispose()}async $resolveCustomEditor(c,h,o,p,_,D){const C=this._editorProviders.get(o);if(!C)throw new Error(`No provider found for '${o}'`);const S=v.ViewColumn.to(_),I=this._extHostWebview.createNewWebview(h,p.contentOptions,C.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(h,o,p.title,S,p.options,I,p.active),w=R.URI.revive(c);switch(C.type){case a.Custom:{const{document:N}=this.getCustomDocumentEntry(o,w);return C.provider.resolveCustomEditor(N,b,D)}case a.Text:{const N=this._extHostDocuments.getDocument(w);return C.provider.resolveCustomTextEditor(N,b,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,h,o){this.getCustomDocumentEntry(h,c).disposeEdits(o)}async $onMoveCustomEditor(c,h,o){const p=this._editorProviders.get(o);if(!p)throw new Error(`No provider found for '${o}'`);if(!p.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const _=this._extHostWebviewPanels.getWebviewPanel(c);if(!_)throw new Error("No webview found");const D=R.URI.revive(h),C=this._extHostDocuments.getDocument(D);await p.provider.moveCustomTextEditor(C,_,r.CancellationToken.None)}async $undo(c,h,o,p){return this.getCustomDocumentEntry(h,c).undo(o,p)}async $redo(c,h,o,p){return this.getCustomDocumentEntry(h,c).redo(o,p)}async $revert(c,h,o){const p=this.getCustomDocumentEntry(h,c);await this.getCustomEditorProvider(h).revertCustomDocument(p.document,o),p.disposeBackup()}async $onSave(c,h,o){const p=this.getCustomDocumentEntry(h,c);await this.getCustomEditorProvider(h).saveCustomDocument(p.document,o),p.disposeBackup()}async $onSaveAs(c,h,o,p){const _=this.getCustomDocumentEntry(h,c);return this.getCustomEditorProvider(h).saveCustomDocumentAs(_.document,R.URI.revive(o),p)}async $backup(c,h,o){const p=this.getCustomDocumentEntry(h,c),D=await this.getCustomEditorProvider(h).backupCustomDocument(p.document,{destination:p.getNewBackupUri()},o);return p.updateBackup(D),D.id}getCustomDocumentEntry(c,h){const o=this._documents.get(c,R.URI.revive(h));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(c){const o=this._editorProviders.get(c)?.provider;if(!o||!m(o))throw new Error("Custom document is not editable");return o}}e.ExtHostCustomEditors=f;function m(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function i(t){const c=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,g.hash)(c)+""}}),define(we[349],ye([1,0,232,144,2,6,10,17,4,12,29,63]),function(he,e,r,g,k,A,L,R,v,l,P,y){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class T{#e;#t;#i;constructor(u,f,m,n,s,i,t,c){this._name=u,this._owner=f,this._maxDiagnosticsTotal=m,this._maxDiagnosticsPerFile=n,this._modelVersionIdProvider=s,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(n,m),this.#i=new P.ResourceMap(h=>i.getComparisonKey(h)),this.#e=t,this.#t=c}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(u,f){if(!u){this.clear();return}this._checkDisposed();let m=[];if(k.URI.isUri(u)){if(!f){this.delete(u);return}this.#i.set(u,f.slice()),m=[u]}else if(Array.isArray(u)){m=[];let i;u=[...u].sort(T._compareIndexedTuplesByUri);for(const t of u){const[c,h]=t;if((!i||c.toString()!==i.toString())&&(i&&this.#i.get(i).length===0&&this.#i.delete(i),i=c,m.push(c),this.#i.set(c,[])),h)this.#i.get(c)?.push(...h);else{const o=this.#i.get(c);o&&(o.length=0)}}}if(this.#t.fire(m),!this.#e)return;const n=[];let s=0;for(const i of m){let t=[];const c=this.#i.get(i);if(c)if(c.length>this._maxDiagnosticsPerFile){t=[];const h=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const p of c)if(p.severity===h[o]&&t.push({...R.Diagnostic.from(p),modelVersionId:this._modelVersionIdProvider(i)})===this._maxDiagnosticsPerFile)break e;t.push({severity:g.MarkerSeverity.Info,message:(0,r.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=c.map(h=>({...R.Diagnostic.from(h),modelVersionId:this._modelVersionIdProvider(i)}));if(n.push([i,t]),s+=t.length,s>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,n)}delete(u){this._checkDisposed(),this.#t.fire([u]),this.#i.delete(u),this.#e?.$changeMany(this._owner,[[u,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(u,f){this._checkDisposed();for(const[m,n]of this)u.call(f,m,n,this)}*[Symbol.iterator](){this._checkDisposed();for(const u of this.#i.keys())yield[u,this.get(u)]}get(u){this._checkDisposed();const f=this.#i.get(u);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(u){return this._checkDisposed(),Array.isArray(this.#i.get(u))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(u,f){return u[0].toString()<f[0].toString()?-1:u[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=T;let E=class{static{d=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*d._maxDiagnosticsPerFile}static _mapper(u){const f=new P.ResourceMap;for(const m of u)f.set(m,m);return{uris:Object.freeze(Array.from(f.values()))}}constructor(u,f,m,n){this._logService=f,this._fileSystemInfoService=m,this._extHostDocumentsAndEditors=n,this._collections=new Map,this._onDidChangeDiagnostics=new v.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=v.Event.map(this._onDidChangeDiagnostics.event,d._mapper),this._proxy=u.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(u,f){const{_collections:m,_proxy:n,_onDidChangeDiagnostics:s,_logService:i,_fileSystemInfoService:t,_extHostDocumentsAndEditors:c}=this,h=new class{$changeMany(_,D){n.$changeMany(_,D),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,_,D.length===0?"CLEARING":D)}$clear(_){n.$clear(_),i.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,_)}dispose(){n.dispose()}};let o;if(!f)f="_generated_diagnostic_collection_name_#"+d._idPool++,o=f;else if(!m.has(f))o=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do o=f+d._idPool++;while(m.has(o))}return new class extends T{constructor(){super(f,o,d._maxDiagnosticsTotal,d._maxDiagnosticsPerFile,_=>c.getDocument(_)?.version,t.extUri,h,s),m.set(o,this)}dispose(){super.dispose(),m.delete(o)}}}getDiagnostics(u){if(u)return this._getDiagnostics(u);{const f=new Map,m=[];for(const n of this._collections.values())n.forEach((s,i)=>{let t=f.get(s.toString());typeof t>"u"&&(t=m.length,f.set(s.toString(),t),m.push([s,[]])),m[t][1]=m[t][1].concat(...i)});return m}}_getDiagnostics(u){let f=[];for(const m of this._collections.values())m.has(u)&&(f=f.concat(m.get(u)));return f}$acceptMarkersChange(u){if(!this._mirrorCollection){const f="_generated_mirror",m=new T(f,f,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,m),this._mirrorCollection=m}for(const[f,m]of u)this._mirrorCollection.set(k.URI.revive(f),m.map(R.Diagnostic.to))}};e.ExtHostDiagnostics=E,e.ExtHostDiagnostics=E=d=Ke([Ve(1,l.ILogService),Ve(2,y.IExtHostFileSystemInfo)],E)}),define(we[350],ye([1,0,2,14,10,17,81,52]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class v{constructor(P,y,d,T={timeout:1500,errors:3}){this._logService=P,this._documents=y,this._mainThreadBulkEdits=d,this._thresholds=T,this._callbacks=new L.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(y,d,T)=>{const a={dispose:this._callbacks.push([y,d,P])};return Array.isArray(T)&&T.push(a),a}}async $participateInSave(P,y){const d=r.URI.revive(P);let T=!1;const E=setTimeout(()=>T=!0,this._thresholds.timeout),a=[];try{for(const u of[...this._callbacks]){if(T)break;const f=this._documents.getDocument(d),m=await this._deliverEventAsyncAndBlameBadListeners(u,{document:f,reason:A.TextDocumentSaveReason.to(y)});a.push(m)}}finally{clearTimeout(E)}return a}_deliverEventAsyncAndBlameBadListeners([P,y,d],T){const E=this._badListeners.get(P);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(d,P,y,T).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const u=this._badListeners.get(P);this._badListeners.set(P,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,y,d,T){const E=[],a=Date.now(),{document:u,reason:f}=T,{version:m}=u,n=Object.freeze({document:u,reason:f,waitUntil(s){if(Object.isFrozen(E))throw(0,g.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(s))}});try{y.apply(d,[n])}catch(s){return Promise.reject(s)}return Object.freeze(E),new Promise((s,i)=>{const t=setTimeout(()=>i(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(c=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(t),s(c)}).catch(c=>{clearTimeout(t),i(c)})}).then(s=>{const i={edits:[]};for(const t of s)if(Array.isArray(t)&&t.every(c=>c instanceof k.TextEdit))for(const{newText:c,newEol:h,range:o}of t)i.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:o&&A.Range.from(o),text:c,eol:h&&A.EndOfLine.from(h)}});if(i.edits.length!==0)return m===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new R.SerializableObjectWithBuffers(i)):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=v}),define(we[351],ye([1,0,4,3,2,6,162,17,18,25,10]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(T,E){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new g.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=E,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const u of a)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const u of a)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const E=this._documentsAndEditors.getDocument(T);if(E)return E}getDocument(T){const E=this.getDocumentData(T);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return E.document}ensureDocumentData(T){const E=this._documentsAndEditors.getDocument(T);if(E)return Promise.resolve(E);let a=this._documentLoader.get(T.toString());return a||(a=this._proxy.$tryOpenDocument(T).then(u=>{this._documentLoader.delete(T.toString());const f=k.URI.revive(u);return(0,v.assertIsDefined)(this._documentsAndEditors.getDocument(f))},u=>(this._documentLoader.delete(T.toString()),Promise.reject(u))),this._documentLoader.set(T.toString(),a)),a}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(E=>k.URI.revive(E))}$acceptModelLanguageChanged(T,E){const a=k.URI.revive(T),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(E),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(T){const E=k.URI.revive(T),a=this._documentsAndEditors.getDocument(E);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(T,E){const a=k.URI.revive(T),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");u._acceptIsDirty(E),this._onDidChangeDocument.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,E,a){const u=k.URI.revive(T),f=this._documentsAndEditors.getDocument(u);if(!f)throw new Error("unknown document");f._acceptIsDirty(a),f.onEvents(E);let m;E.isUndoing?m=P.TextDocumentChangeReason.Undo:E.isRedoing&&(m=P.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,l.deepFreeze)({document:f.document,contentChanges:E.changes.map(n=>({range:R.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:m}))}setWordDefinitionFor(T,E){(0,L.setWordDefinitionFor)(T,E)}}e.ExtHostDocuments=y}),define(we[77],ye([1,0,79,4,18,2,5,6,20,17,10]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,L.createDecorator)("IExtHostEditorTabs");class y{constructor(u,f,m){this._activeTabIdGetter=m,this._parentGroup=f,this.acceptDtoUpdate(u)}get apiObject(){if(!this._apiObject){const u=this,f={get isActive(){return u._dto.id===u._activeTabIdGetter()},get label(){return u._dto.label},get input(){return u._input},get isDirty(){return u._dto.isDirty},get isPinned(){return u._dto.isPinned},get isPreview(){return u._dto.isPreview},get group(){return u._parentGroup.apiObject}};this._apiObject=Object.freeze(f)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(u){this._dto=u,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case R.TabInputKind.TextInput:return new P.TextTabInput(A.URI.revive(this._dto.input.uri));case R.TabInputKind.TextDiffInput:return new P.TextDiffTabInput(A.URI.revive(this._dto.input.original),A.URI.revive(this._dto.input.modified));case R.TabInputKind.TextMergeInput:return new P.TextMergeTabInput(A.URI.revive(this._dto.input.base),A.URI.revive(this._dto.input.input1),A.URI.revive(this._dto.input.input2),A.URI.revive(this._dto.input.result));case R.TabInputKind.CustomEditorInput:return new P.CustomEditorTabInput(A.URI.revive(this._dto.input.uri),this._dto.input.viewType);case R.TabInputKind.WebviewEditorInput:return new P.WebviewEditorTabInput(this._dto.input.viewType);case R.TabInputKind.NotebookInput:return new P.NotebookEditorTabInput(A.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case R.TabInputKind.NotebookDiffInput:return new P.NotebookDiffEditorTabInput(A.URI.revive(this._dto.input.original),A.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case R.TabInputKind.TerminalEditorInput:return new P.TerminalEditorTabInput;case R.TabInputKind.InteractiveEditorInput:return new P.InteractiveWindowInput(A.URI.revive(this._dto.input.uri),A.URI.revive(this._dto.input.inputBoxUri));case R.TabInputKind.ChatEditorInput:return new P.ChatEditorTabInput;case R.TabInputKind.MultiDiffEditorInput:return new P.TextMultiDiffTabInput(this._dto.input.diffEditors.map(u=>new P.TextDiffTabInput(A.URI.revive(u.original),A.URI.revive(u.modified))));default:return}}}class d{constructor(u,f){this._tabs=[],this._activeTabId="",this._dto=u,this._activeGroupIdGetter=f;for(const m of u.tabs)m.isActive&&(this._activeTabId=m.id),this._tabs.push(new y(m,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const u=this,f={get isActive(){return u._dto.groupId===u._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(u._dto.viewColumn)},get activeTab(){return u._tabs.find(m=>m.tabId===u._activeTabId)?.apiObject},get tabs(){return Object.freeze(u._tabs.map(m=>m.apiObject))}};this._apiObject=Object.freeze(f)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(u){this._dto=u}acceptTabOperation(u){if(u.kind===R.TabModelOperationKind.TAB_OPEN){const m=new y(u.tabDto,this,()=>this.activeTabId());return this._tabs.splice(u.index,0,m),u.tabDto.isActive&&(this._activeTabId=m.tabId),m}else if(u.kind===R.TabModelOperationKind.TAB_CLOSE){const m=this._tabs.splice(u.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return m.tabId===this._activeTabId&&(this._activeTabId=""),m}else if(u.kind===R.TabModelOperationKind.TAB_MOVE){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this._tabs.splice(u.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this._tabs.splice(u.index,0,m),m}const f=this._tabs.find(m=>m.tabId===u.tabDto.id);if(!f)throw new Error("INVALID tab");return u.tabDto.isActive?this._activeTabId=u.tabDto.id:this._activeTabId===u.tabDto.id&&!u.tabDto.isActive&&(this._activeTabId=""),f.acceptDtoUpdate(u.tabDto),f}activeTabId(){return this._activeTabId}}let T=class{constructor(u){this._onDidChangeTabs=new g.Emitter,this._onDidChangeTabGroups=new g.Emitter,this._extHostTabGroups=[],this._proxy=u.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const u=this,f={onDidChangeTabGroups:u._onDidChangeTabGroups.event,onDidChangeTabs:u._onDidChangeTabs.event,get all(){return Object.freeze(u._extHostTabGroups.map(m=>m.apiObject))},get activeTabGroup(){const m=u._activeGroupId;return(0,k.assertIsDefined)(u._extHostTabGroups.find(s=>s.groupId===m)?.apiObject)},close:async(m,n)=>{const s=Array.isArray(m)?m:[m];return s.length?E(s[0])?this._closeGroups(s,n):this._closeTabs(s,n):!0}};this._apiObject=Object.freeze(f)}return this._apiObject}$acceptEditorTabModel(u){const f=new Set(this._extHostTabGroups.map(h=>h.groupId)),m=new Set(u.map(h=>h.groupId)),n=(0,r.diffSets)(f,m),s=this._extHostTabGroups.filter(h=>n.removed.includes(h.groupId)).map(h=>h.apiObject),i=[],t=[];this._extHostTabGroups=u.map(h=>{const o=new d(h,()=>this._activeGroupId);return n.added.includes(o.groupId)?i.push(o.apiObject):t.push(o.apiObject),o});const c=(0,k.assertIsDefined)(u.find(h=>h.isActive===!0)?.groupId);c!==void 0&&this._activeGroupId!==c&&(this._activeGroupId=c),this._onDidChangeTabGroups.fire(Object.freeze({opened:i,closed:s,changed:t}))}$acceptTabGroupUpdate(u){const f=this._extHostTabGroups.find(m=>m.groupId===u.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(u),u.isActive&&(this._activeGroupId=u.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const f=this._extHostTabGroups.find(n=>n.groupId===u.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const m=f.acceptTabOperation(u);switch(u.kind){case R.TabModelOperationKind.TAB_OPEN:this._onDidChangeTabs.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case R.TabModelOperationKind.TAB_CLOSE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case R.TabModelOperationKind.TAB_MOVE:case R.TabModelOperationKind.TAB_UPDATE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}_findExtHostTabFromApi(u){for(const f of this._extHostTabGroups)for(const m of f.tabs)if(m.apiObject===u)return m}_findExtHostTabGroupFromApi(u){return this._extHostTabGroups.find(f=>f.apiObject===u)}async _closeTabs(u,f){const m=[];for(const n of u){const s=this._findExtHostTabFromApi(n);if(!s)throw new Error("Tab close: Invalid tab not found!");m.push(s.tabId)}return this._proxy.$closeTab(m,f)}async _closeGroups(u,f){const m=[];for(const n of u){const s=this._findExtHostTabGroupFromApi(n);if(!s)throw new Error("Group close: Invalid group not found!");m.push(s.groupId)}return this._proxy.$closeGroup(m,f)}};e.ExtHostEditorTabs=T,e.ExtHostEditorTabs=T=Ke([Ve(0,v.IExtHostRpcService)],T);function E(a){return a.tabs!==void 0}}),define(we[352],ye([1,0,2,6,28,3,10,17,193,13,27,22,26,86]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class E{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const m=this._schemes.indexOf(f);m>=0&&(this._schemes.splice(m,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),m=[];let n,s,i=v.State.LastKnownState,t=v.State.LastKnownState;for(const c of f){let h=n?(0,l.commonPrefixLength)(n,c):0;for(h===0?s=v.State.Start:s=t;h<c.length;h++)h+1===c.length?(i=t,t=v.State.BeforeColon):t+=1,m.push([s,c.toUpperCase().charCodeAt(h),t]),m.push([s,c.toLowerCase().charCodeAt(h),t]),s=t;n=c,t=i}m.push([v.State.BeforeColon,P.CharCode.Colon,v.State.AfterColon]),m.push([v.State.AfterColon,P.CharCode.Slash,v.State.End]),this._stateMachine=new v.StateMachine(m)}}provideDocumentLinks(f){this._initStateMachine();const m=[],n=v.LinkComputer.computeLinks({getLineContent(s){return f.lineAt(s-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const s of n){const i=R.DocumentLink.to(s);i.target&&m.push(i)}return m}}class a{constructor(f,m){this._extHostLanguageFeatures=m,this._linkProvider=new E,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(g.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,m,n,s={}){if(a._validateFileSystemProvider(n),this._registeredSchemes.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const i=this._handlePool++;this._linkProvider.add(m),this._registeredSchemes.add(m),this._fsProvider.set(i,n);let t=k.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(t+=k.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(t+=k.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(t+=k.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,d.checkProposedApiEnabled)(f,"fsChunks"),t+=k.FileSystemProviderCapabilities.FileOpenReadWriteClose);let c;s.isReadonly&&(0,T.isMarkdownString)(s.isReadonly)&&s.isReadonly.value!==""&&(c={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this._proxy.$registerFileSystemProvider(i,m,t,c).catch(o=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${m}`),console.error(o)});const h=n.onDidChangeFile(o=>{const p=[];for(const _ of o){const{uri:D,type:C}=_;if(D.scheme!==m)continue;let S;switch(C){case L.FileChangeType.Changed:S=k.FileChangeType.UPDATED;break;case L.FileChangeType.Created:S=k.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:S=k.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}p.push({resource:D,type:S})}this._proxy.$onFileSystemChange(i,p)});return(0,A.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(m),this._registeredSchemes.delete(m),this._fsProvider.delete(i),this._proxy.$unregisterProvider(i)})}static _validateFileSystemProvider(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(f){const{type:m,ctime:n,mtime:s,size:i,permissions:t}=f;return{type:m,ctime:n,mtime:s,size:i,permissions:t}}$stat(f,m){return Promise.resolve(this._getFsProvider(f).stat(r.URI.revive(m))).then(n=>a._asIStat(n))}$readdir(f,m){return Promise.resolve(this._getFsProvider(f).readDirectory(r.URI.revive(m)))}$readFile(f,m){return Promise.resolve(this._getFsProvider(f).readFile(r.URI.revive(m))).then(n=>y.VSBuffer.wrap(n))}$writeFile(f,m,n,s){return Promise.resolve(this._getFsProvider(f).writeFile(r.URI.revive(m),n.buffer,s))}$delete(f,m,n){return Promise.resolve(this._getFsProvider(f).delete(r.URI.revive(m),n))}$rename(f,m,n,s){return Promise.resolve(this._getFsProvider(f).rename(r.URI.revive(m),r.URI.revive(n),s))}$copy(f,m,n,s){const i=this._getFsProvider(f);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(r.URI.revive(m),r.URI.revive(n),s))}$mkdir(f,m){return Promise.resolve(this._getFsProvider(f).createDirectory(r.URI.revive(m)))}$watch(f,m,n,s){const i=this._getFsProvider(f).watch(r.URI.revive(n),s);this._watches.set(m,i)}$unwatch(f,m){const n=this._watches.get(m);n&&(n.dispose(),this._watches.delete(m))}$open(f,m,n){const s=this._getFsProvider(f);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(r.URI.revive(m),n))}$close(f,m){const n=this._getFsProvider(f);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(m))}$read(f,m,n,s){const i=this._getFsProvider(f);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const t=y.VSBuffer.alloc(s);return Promise.resolve(i.read(m,n,t.buffer,0,s)).then(c=>t.slice(0,c))}$write(f,m,n,s){const i=this._getFsProvider(f);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,n,s.buffer,0,s.byteLength))}_getFsProvider(f){const m=this._fsProvider.get(f);if(!m){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return m}}e.ExtHostFileSystem=a}),define(we[353],ye([1,0,4,39,2,6,17,10,28,49]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(E,a,u,f,m,n){this.session=Math.random(),this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter,this._config=0,n?.ignoreCreateEvents&&(this._config+=1),n?.ignoreChangeEvents&&(this._config+=2),n?.ignoreDeleteEvents&&(this._config+=4);const s=(0,g.parse)(m),i=typeof m=="string",t=n?.correlate,c=f(h=>{if(!(typeof h.session=="number"&&h.session!==this.session)&&!(t&&typeof h.session>"u")){if(!n?.ignoreCreateEvents)for(const o of h.created){const p=k.URI.revive(o);s(p.fsPath)&&(!i||a.getWorkspaceFolder(p))&&this._onDidCreate.fire(p)}if(!n?.ignoreChangeEvents)for(const o of h.changed){const p=k.URI.revive(o);s(p.fsPath)&&(!i||a.getWorkspaceFolder(p))&&this._onDidChange.fire(p)}if(!n?.ignoreDeleteEvents)for(const o of h.deleted){const p=k.URI.revive(o);s(p.fsPath)&&(!i||a.getWorkspaceFolder(p))&&this._onDidDelete.fire(p)}}});this._disposable=R.Disposable.from(this.ensureWatching(E,u,m,n,n?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,c)}ensureWatching(E,a,u,f,m){const n=R.Disposable.from();if(typeof u=="string"||f?.ignoreChangeEvents&&f?.ignoreCreateEvents&&f?.ignoreDeleteEvents)return n;const s=E.getProxy(A.MainContext.MainThreadFileSystemEventService);let i=!1;(u.pattern.includes(g.GLOBSTAR)||u.pattern.includes(g.GLOB_SPLIT))&&(i=!0);let t;return m&&(f?.ignoreChangeEvents||f?.ignoreCreateEvents||f?.ignoreDeleteEvents)&&(t=v.FileChangeFilter.UPDATED|v.FileChangeFilter.ADDED|v.FileChangeFilter.DELETED,f?.ignoreChangeEvents&&(t&=~v.FileChangeFilter.UPDATED),f?.ignoreCreateEvents&&(t&=~v.FileChangeFilter.ADDED),f?.ignoreDeleteEvents&&(t&=~v.FileChangeFilter.DELETED)),s.$watch(a.identifier.value,this.session,u.baseUri,{recursive:i,excludes:f?.excludes??[],filter:t},!!m),R.Disposable.from({dispose:()=>s.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(E){this._events=E,this.session=this._events.session,this._created=new l.Lazy(()=>this._events.created.map(k.URI.revive)),this._changed=new l.Lazy(()=>this._events.changed.map(k.URI.revive)),this._deleted=new l.Lazy(()=>this._events.deleted.map(k.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class d{constructor(E,a,u){this._mainContext=E,this._logService=a,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(E,a,u,f){return new P(this._mainContext,E,a,this._onFileSystemEvent.event,L.GlobPattern.from(u),f)}$onFileEvent(E){this._onFileSystemEvent.fire(new y(E))}$onDidRunFileOperation(E,a){switch(E){case v.FileOperation.MOVE:this._onDidRenameFile.fire(Object.freeze({files:a.map(u=>({oldUri:k.URI.revive(u.source),newUri:k.URI.revive(u.target)}))}));break;case v.FileOperation.DELETE:this._onDidDeleteFile.fire(Object.freeze({files:a.map(u=>k.URI.revive(u.target))}));break;case v.FileOperation.CREATE:case v.FileOperation.COPY:this._onDidCreateFile.fire(Object.freeze({files:a.map(u=>k.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(E){return this._createWillExecuteEvent(E,this._onWillRenameFile)}getOnWillCreateFileEvent(E){return this._createWillExecuteEvent(E,this._onWillCreateFile)}getOnWillDeleteFileEvent(E){return this._createWillExecuteEvent(E,this._onWillDeleteFile)}_createWillExecuteEvent(E,a){return(u,f,m)=>{const n=function(i){u.call(f,i)};return n.extension=E,a.event(n,void 0,m)}}async $onWillRunFileOperation(E,a,u,f){switch(E){case v.FileOperation.MOVE:return await this._fireWillEvent(this._onWillRenameFile,{files:a.map(m=>({oldUri:k.URI.revive(m.source),newUri:k.URI.revive(m.target)}))},u,f);case v.FileOperation.DELETE:return await this._fireWillEvent(this._onWillDeleteFile,{files:a.map(m=>k.URI.revive(m.target))},u,f);case v.FileOperation.CREATE:case v.FileOperation.COPY:return await this._fireWillEvent(this._onWillCreateFile,{files:a.map(m=>k.URI.revive(m.target))},u,f)}}async _fireWillEvent(E,a,u,f){const m=new Set,n=[];if(await E.fireAsync(a,f,async(i,t)=>{const c=Date.now(),h=await Promise.resolve(i);h instanceof R.WorkspaceEdit&&(n.push([t.extension,h]),m.add(t.extension.displayName??t.extension.identifier.value)),Date.now()-c>u&&this._logService.warn("SLOW file-participant",t.extension.identifier)}),f.isCancellationRequested||n.length===0)return;const s={edits:[]};for(const[,i]of n){const{edits:t}=L.WorkspaceEdit.from(i,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(t)}return{edit:s,extensionNames:Array.from(m)}}}e.ExtHostFileSystemEventService=d}),define(we[354],ye([1,0,19,9,21,14,132,3,25,42,13,18,2,31,189,88,142,234,24,17,10,26,118,6]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class h{constructor(z,H){this._documents=z,this._provider=H}async provideDocumentSymbols(z,H){const X=this._documents.getDocument(z),J=await this._provider.provideDocumentSymbols(X,H);if(!(0,r.isFalsyOrEmpty)(J))return J[0]instanceof s.DocumentSymbol?J.map(n.DocumentSymbol.from):h._asDocumentSymbolTree(J)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((J,fe)=>{let be=J.location.range.start.compareTo(fe.location.range.start);return be===0&&(be=fe.location.range.end.compareTo(J.location.range.end)),be});const H=[],X=[];for(const J of z){const fe={name:J.name||"!!MISSING: name!!",kind:n.SymbolKind.from(J.kind),tags:J.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:n.Range.from(J.location.range),selectionRange:n.Range.from(J.location.range),children:[]};for(;;){if(X.length===0){X.push(fe),H.push(fe);break}const be=X[X.length-1];if(T.Range.containsRange(be.range,fe.range)&&!T.Range.equalsRange(be.range,fe.range)){be.children?.push(fe),X.push(fe);break}X.pop()}}return H}}class o{constructor(z,H,X,J,fe,be){this._documents=z,this._commands=H,this._provider=X,this._extension=J,this._extTelemetry=fe,this._logService=be,this._cache=new t.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,H){const X=this._documents.getDocument(z),J=await this._provider.provideCodeLenses(X,H);if(!J||H.isCancellationRequested)return;const fe=this._cache.add(J),be=new R.DisposableStore;this._disposables.set(fe,be);const Fe={cacheId:fe,lenses:[]};for(let He=0;He<J.length;He++)Fe.lenses.push({cacheId:[fe,He],range:n.Range.from(J[He].range),command:this._commands.toInternal(J[He].command,be)});return Fe}async resolveCodeLens(z,H){const X=z.cacheId&&this._cache.get(...z.cacheId);if(!X)return;let J;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?J=X:J=await this._provider.resolveCodeLens(X,H),J||(J=X),H.isCancellationRequested)return;const fe=z.cacheId&&this._disposables.get(z.cacheId[0]);if(fe){if(!J.command){const be=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,be),this._logService.error(be);return}return z.command=this._commands.toInternal(J.command,fe),z}}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}function p(Le){return Array.isArray(Le)?Le.map(n.DefinitionLink.from):Le?[n.DefinitionLink.from(Le)]:[]}class _{constructor(z,H){this._documents=z,this._provider=H}async provideDefinition(z,H,X){const J=this._documents.getDocument(z),fe=n.Position.to(H),be=await this._provider.provideDefinition(J,fe,X);return p(be)}}class D{constructor(z,H){this._documents=z,this._provider=H}async provideDeclaration(z,H,X){const J=this._documents.getDocument(z),fe=n.Position.to(H),be=await this._provider.provideDeclaration(J,fe,X);return p(be)}}class C{constructor(z,H){this._documents=z,this._provider=H}async provideImplementation(z,H,X){const J=this._documents.getDocument(z),fe=n.Position.to(H),be=await this._provider.provideImplementation(J,fe,X);return p(be)}}class S{constructor(z,H){this._documents=z,this._provider=H}async provideTypeDefinition(z,H,X){const J=this._documents.getDocument(z),fe=n.Position.to(H),be=await this._provider.provideTypeDefinition(J,fe,X);return p(be)}}class I{static{this.HOVER_MAP_MAX_SIZE=10}constructor(z,H){this._documents=z,this._provider=H,this._hoverCounter=0,this._hoverMap=new Map}async provideHover(z,H,X,J){const fe=this._documents.getDocument(z),be=n.Position.to(H);let Fe;if(X&&X.verbosityRequest){const it=X.verbosityRequest.previousHover.id,tt=this._hoverMap.get(it);if(!tt)throw new Error(`Hover with id ${it} not found`);const rt={verbosityDelta:X.verbosityRequest.verbosityDelta,previousHover:tt};Fe=await this._provider.provideHover(fe,be,J,rt)}else Fe=await this._provider.provideHover(fe,be,J);if(!Fe||(0,r.isFalsyOrEmpty)(Fe.contents))return;Fe.range||(Fe.range=fe.getWordRangeAtPosition(be)),Fe.range||(Fe.range=new s.Range(be,be));const He=n.Hover.from(Fe),qe=this._hoverCounter;if(this._hoverMap.size===I.HOVER_MAP_MAX_SIZE){const it=Math.min(...this._hoverMap.keys());this._hoverMap.delete(it)}return this._hoverMap.set(qe,Fe),this._hoverCounter+=1,{...He,id:qe}}releaseHover(z){this._hoverMap.delete(z)}}class b{constructor(z,H){this._documents=z,this._provider=H}async provideEvaluatableExpression(z,H,X){const J=this._documents.getDocument(z),fe=n.Position.to(H),be=await this._provider.provideEvaluatableExpression(J,fe,X);if(be)return n.EvaluatableExpression.from(be)}}class w{constructor(z,H){this._documents=z,this._provider=H}async provideInlineValues(z,H,X,J){const fe=this._documents.getDocument(z),be=await this._provider.provideInlineValues(fe,n.Range.to(H),n.InlineValueContext.to(X),J);if(Array.isArray(be))return be.map(Fe=>n.InlineValue.from(Fe))}}class N{constructor(z,H){this._documents=z,this._provider=H}async provideDocumentHighlights(z,H,X){const J=this._documents.getDocument(z),fe=n.Position.to(H),be=await this._provider.provideDocumentHighlights(J,fe,X);if(Array.isArray(be))return be.map(n.DocumentHighlight.from)}}class O{constructor(z,H){this._documents=z,this._provider=H}async provideMultiDocumentHighlights(z,H,X,J){const fe=this._documents.getDocument(z),be=X.map(qe=>this._documents.getDocument(qe)),Fe=n.Position.to(H),He=await this._provider.provideMultiDocumentHighlights(fe,Fe,be,J);if(Array.isArray(He))return He.map(n.MultiDocumentHighlight.from)}}class U{constructor(z,H){this._documents=z,this._provider=H}async provideLinkedEditingRanges(z,H,X){const J=this._documents.getDocument(z),fe=n.Position.to(H),be=await this._provider.provideLinkedEditingRanges(J,fe,X);if(be&&Array.isArray(be.ranges))return{ranges:(0,r.coalesce)(be.ranges.map(n.Range.from)),wordPattern:be.wordPattern}}}class x{constructor(z,H){this._documents=z,this._provider=H}async provideReferences(z,H,X,J){const fe=this._documents.getDocument(z),be=n.Position.to(H),Fe=await this._provider.provideReferences(fe,be,X,J);if(Array.isArray(Fe))return Fe.map(n.location.from)}}class B{static{this._maxCodeActionsPerFile=1e3}constructor(z,H,X,J,fe,be,Fe){this._documents=z,this._commands=H,this._diagnostics=X,this._provider=J,this._logService=fe,this._extension=be,this._apiDeprecation=Fe,this._cache=new t.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,H,X,J){const fe=this._documents.getDocument(z),be=E.Selection.isISelection(H)?n.Selection.to(H):n.Range.to(H),Fe=[];for(const rt of this._diagnostics.getDiagnostics(z))if(be.intersection(rt.range)&&Fe.push(rt)>B._maxCodeActionsPerFile)break;const He={diagnostics:Fe,only:X.only?new s.CodeActionKind(X.only):void 0,triggerKind:n.CodeActionTriggerKind.to(X.trigger)},qe=await this._provider.provideCodeActions(fe,be,He,J);if(!(0,r.isNonEmptyArray)(qe)||J.isCancellationRequested)return;const Ye=this._cache.add(qe),it=new R.DisposableStore;this._disposables.set(Ye,it);const tt=[];for(let rt=0;rt<qe.length;rt++){const ot=qe[rt];if(ot)if(B._isCommand(ot))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:ot.title,command:this._commands.toInternal(ot,it)});else{He.only&&(ot.kind?He.only.contains(ot.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action is of kind '${ot.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=ot.ranges??[];tt.push({cacheId:[Ye,rt],title:ot.title,command:ot.command&&this._commands.toInternal(ot.command,it),diagnostics:ot.diagnostics&&ot.diagnostics.map(n.Diagnostic.from),edit:ot.edit&&n.WorkspaceEdit.from(ot.edit,void 0),kind:ot.kind&&ot.kind.value,isPreferred:ot.isPreferred,isAI:(0,i.isProposedApiEnabled)(this._extension,"codeActionAI")?ot.isAI:!1,ranges:(0,i.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,r.coalesce)(ft.map(n.Range.from)):void 0,disabled:ot.disabled?.reason})}}return{cacheId:Ye,actions:tt}}async resolveCodeAction(z,H){const[X,J]=z,fe=this._cache.get(X,J);if(!fe||B._isCommand(fe))return{};if(!this._provider.resolveCodeAction)return{};const be=await this._provider.resolveCodeAction(fe,H)??fe;let Fe;be.edit&&(Fe=n.WorkspaceEdit.from(be.edit,void 0));let He;if(be.command){const qe=this._disposables.get(X);qe&&(He=this._commands.toInternal(be.command,qe))}return{edit:Fe,command:He}}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}class F{constructor(z,H,X,J,fe){this._proxy=z,this._documents=H,this._provider=X,this._handle=J,this._extension=fe,this._cache=new t.Cache("DocumentPasteEdit")}async prepareDocumentPaste(z,H,X,J){if(!this._provider.prepareDocumentPaste)return;const fe=this._documents.getDocument(z),be=H.map(qe=>n.Range.to(qe)),Fe=n.DataTransfer.toDataTransfer(X,()=>{throw new A.NotImplementedError});if(await this._provider.prepareDocumentPaste(fe,be,Fe,J),J.isCancellationRequested)return;const He=Array.from(Fe).filter(([,qe])=>!(qe instanceof s.InternalDataTransferItem));return n.DataTransfer.from(He)}async providePasteEdits(z,H,X,J,fe,be){if(!this._provider.provideDocumentPasteEdits)return[];const Fe=this._documents.getDocument(H),He=X.map(tt=>n.Range.to(tt)),qe=n.DataTransfer.toDataTransfer(J,async tt=>(await this._proxy.$resolvePasteFileData(this._handle,z,tt)).buffer),Ye=await this._provider.provideDocumentPasteEdits(Fe,He,qe,{only:fe.only?new s.DocumentDropOrPasteEditKind(fe.only):void 0,triggerKind:fe.triggerKind},be);if(!Ye||be.isCancellationRequested)return[];const it=this._cache.add(Ye);return Ye.map((tt,rt)=>({_cacheId:[it,rt],title:tt.title??(0,f.localize)(0,null,this._extension.displayName||this._extension.name),kind:tt.kind,yieldTo:tt.yieldTo?.map(ot=>ot.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?n.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,H){const[X,J]=z,fe=this._cache.get(X,J);if(!fe||!this._provider.resolveDocumentPasteEdit)return{};const be=await this._provider.resolveDocumentPasteEdit(fe,H)??fe;return{additionalEdit:be.additionalEdit?n.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releasePasteEdits(z){this._cache.delete(z)}}class M{constructor(z,H){this._documents=z,this._provider=H}async provideDocumentFormattingEdits(z,H,X){const J=this._documents.getDocument(z),fe=await this._provider.provideDocumentFormattingEdits(J,H,X);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class K{constructor(z,H){this._documents=z,this._provider=H}async provideDocumentRangeFormattingEdits(z,H,X,J){const fe=this._documents.getDocument(z),be=n.Range.to(H),Fe=await this._provider.provideDocumentRangeFormattingEdits(fe,be,X,J);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,H,X,J){(0,y.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this._documents.getDocument(z),be=H.map(n.Range.to),Fe=await this._provider.provideDocumentRangesFormattingEdits(fe,be,X,J);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}}class ee{constructor(z,H){this._documents=z,this._provider=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,H,X,J,fe){const be=this._documents.getDocument(z),Fe=n.Position.to(H),He=await this._provider.provideOnTypeFormattingEdits(be,Fe,X,J,fe);if(Array.isArray(He))return He.map(n.TextEdit.from)}}class ${constructor(z,H){this._provider=z,this._logService=H,this._cache=new t.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(z,H){const X=await this._provider.provideWorkspaceSymbols(z,H);if(!(0,r.isNonEmptyArray)(X))return{symbols:[]};const J=this._cache.add(X),fe={cacheId:J,symbols:[]};for(let be=0;be<X.length;be++){const Fe=X[be];if(!Fe||!Fe.name){this._logService.warn("INVALID SymbolInformation",Fe);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Fe),cacheId:[J,be]})}return fe}async resolveWorkspaceSymbol(z,H){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const X=this._cache.get(...z.cacheId);if(X){const J=await this._provider.resolveWorkspaceSymbol(X,H);return J&&(0,v.mixin)(z,n.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(z){this._cache.delete(z)}}class q{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,H,X){this._documents=z,this._provider=H,this._logService=X}async provideRenameEdits(z,H,X,J){const fe=this._documents.getDocument(z),be=n.Position.to(H);try{const Fe=await this._provider.provideRenameEdits(fe,be,X,J);return Fe?n.WorkspaceEdit.from(Fe):void 0}catch(Fe){const He=q._asMessage(Fe);return He?{rejectReason:He,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(z,H,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const J=this._documents.getDocument(z),fe=n.Position.to(H);try{const be=await this._provider.prepareRename(J,fe,X);let Fe,He;if(s.Range.isRange(be)?(Fe=be,He=J.getText(be)):(0,y.isObject)(be)&&(Fe=be.range,He=be.placeholder),!Fe||!He)return;if(Fe.start.line>fe.line||Fe.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Fe),text:He}}catch(be){const Fe=q._asMessage(be);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(be)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class Z{static{this.languageTriggerKindToVSCodeTriggerKind={[a.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(z,H,X){this._documents=z,this._provider=H,this._logService=X}async supportsAutomaticNewSymbolNamesTriggerKind(){return this._provider.supportsAutomaticTriggerKind}async provideNewSymbolNames(z,H,X,J){const fe=this._documents.getDocument(z),be=n.Range.to(H);try{const Fe=Z.languageTriggerKindToVSCodeTriggerKind[X],He=await this._provider.provideNewSymbolNames(fe,be,Fe,J);return He?He.map(qe=>typeof qe=="string"?{newSymbolName:qe}:{newSymbolName:qe.newSymbolName,tags:qe.tags}):void 0}catch(Fe){this._logService.error(Z._asMessage(Fe)??JSON.stringify(Fe,null,"	"));return}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ne{constructor(z,H){this.resultId=z,this.tokens=H}}class de{constructor(z,H){this._documents=z,this._provider=H,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,H,X){const J=this._documents.getDocument(z),fe=H!==0?this._previousResults.get(H):null;let be=typeof fe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(J,fe.resultId,X):await this._provider.provideDocumentSemanticTokens(J,X);return fe&&this._previousResults.delete(H),be?(be=de._fixProvidedSemanticTokens(be),this._send(de._convertToEdits(fe,be),be)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return de._isSemanticTokens(z)?de._isCorrectSemanticTokens(z)?z:new s.SemanticTokens(new Uint32Array(z.data),z.resultId):de._isSemanticTokensEdits(z)?de._isCorrectSemanticTokensEdits(z)?z:new s.SemanticTokensEdits(z.edits.map(H=>new s.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const H of z.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,H){if(!de._isSemanticTokens(H)||!z||!z.tokens)return H;const X=z.tokens,J=X.length,fe=H.data,be=fe.length;let Fe=0;const He=Math.min(J,be);for(;Fe<He&&X[Fe]===fe[Fe];)Fe++;if(Fe===J&&Fe===be)return new s.SemanticTokensEdits([],H.resultId);let qe=0;const Ye=He-Fe;for(;qe<Ye&&X[J-qe-1]===fe[be-qe-1];)qe++;return new s.SemanticTokensEdits([{start:Fe,deleteCount:J-Fe-qe,data:fe.subarray(Fe,be-qe)}],H.resultId)}_send(z,H){if(de._isSemanticTokens(z)){const X=this._nextResultId++;return this._previousResults.set(X,new ne(z.resultId,z.data)),(0,u.encodeSemanticTokensDto)({id:X,type:"full",data:z.data})}if(de._isSemanticTokensEdits(z)){const X=this._nextResultId++;return de._isSemanticTokens(H)?this._previousResults.set(X,new ne(H.resultId,H.data)):this._previousResults.set(X,new ne(z.resultId)),(0,u.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(z.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class re{constructor(z,H){this._documents=z,this._provider=H}async provideDocumentRangeSemanticTokens(z,H,X){const J=this._documents.getDocument(z),fe=await this._provider.provideDocumentRangeSemanticTokens(J,n.Range.to(H),X);return fe?this._send(fe):null}_send(z){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}class Se{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,H,X,J,fe){this._documents=z,this._commands=H,this._provider=X,this._apiDeprecation=J,this._extension=fe,this._cache=new t.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(z,H,X,J){const fe=this._documents.getDocument(z),be=n.Position.to(H),Fe=fe.getWordRangeAtPosition(be)||new s.Range(be,be),He=Fe.with({end:be}),qe=new l.StopWatch,Ye=await this._provider.provideCompletionItems(fe,be,J,n.CompletionContext.to(X));if(!Ye||J.isCancellationRequested)return;const it=Array.isArray(Ye)?new s.CompletionList(Ye):Ye,tt=Se.supportsResolving(this._provider)?this._cache.add(it.items):this._cache.add([]),rt=new R.DisposableStore;this._disposables.set(tt,rt);const ot=[],ft={x:tt,[c.ISuggestResultDtoField.completions]:ot,[c.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Fe),insert:n.Range.from(He)},[c.ISuggestResultDtoField.isIncomplete]:it.isIncomplete||void 0,[c.ISuggestResultDtoField.duration]:qe.elapsed()};for(let ut=0;ut<it.items.length;ut++){const st=it.items[ut],Te=this._convertCompletionItem(st,[tt,ut],He,Fe);ot.push(Te)}return ft}async resolveCompletionItem(z,H){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...z);if(!X)return;const J=this._convertCompletionItem(X,z),fe=await this._provider.resolveCompletionItem(X,H);if(!fe)return;const be=this._convertCompletionItem(fe,z);return(J[c.ISuggestDataDtoField.insertText]!==be[c.ISuggestDataDtoField.insertText]||J[c.ISuggestDataDtoField.insertTextRules]!==be[c.ISuggestDataDtoField.insertTextRules])&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J[c.ISuggestDataDtoField.commandIdent]!==be[c.ISuggestDataDtoField.commandIdent]||J[c.ISuggestDataDtoField.commandId]!==be[c.ISuggestDataDtoField.commandId]||!(0,v.equals)(J[c.ISuggestDataDtoField.commandArguments],be[c.ISuggestDataDtoField.commandArguments]))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,[c.ISuggestDataDtoField.documentation]:be[c.ISuggestDataDtoField.documentation],[c.ISuggestDataDtoField.detail]:be[c.ISuggestDataDtoField.detail],[c.ISuggestDataDtoField.additionalTextEdits]:be[c.ISuggestDataDtoField.additionalTextEdits],[c.ISuggestDataDtoField.insertText]:be[c.ISuggestDataDtoField.insertText],[c.ISuggestDataDtoField.insertTextRules]:be[c.ISuggestDataDtoField.insertTextRules],[c.ISuggestDataDtoField.commandIdent]:be[c.ISuggestDataDtoField.commandIdent],[c.ISuggestDataDtoField.commandId]:be[c.ISuggestDataDtoField.commandId],[c.ISuggestDataDtoField.commandArguments]:be[c.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,H,X,J){const fe=this._disposables.get(H[0]);if(!fe)throw Error("DisposableStore is missing...");const be=this._commands.toInternal(z.command,fe),Fe={x:H,[c.ISuggestDataDtoField.label]:z.label,[c.ISuggestDataDtoField.kind]:z.kind!==void 0?n.CompletionItemKind.from(z.kind):void 0,[c.ISuggestDataDtoField.kindModifier]:z.tags&&z.tags.map(n.CompletionItemTag.from),[c.ISuggestDataDtoField.detail]:z.detail,[c.ISuggestDataDtoField.documentation]:typeof z.documentation>"u"?void 0:n.MarkdownString.fromStrict(z.documentation),[c.ISuggestDataDtoField.sortText]:z.sortText!==z.label?z.sortText:void 0,[c.ISuggestDataDtoField.filterText]:z.filterText!==z.label?z.filterText:void 0,[c.ISuggestDataDtoField.preselect]:z.preselect||void 0,[c.ISuggestDataDtoField.insertTextRules]:z.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[c.ISuggestDataDtoField.commitCharacters]:z.commitCharacters?.join(""),[c.ISuggestDataDtoField.additionalTextEdits]:z.additionalTextEdits&&z.additionalTextEdits.map(n.TextEdit.from),[c.ISuggestDataDtoField.commandIdent]:be?.$ident,[c.ISuggestDataDtoField.commandId]:be?.id,[c.ISuggestDataDtoField.commandArguments]:be?.$ident?void 0:be?.arguments};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe[c.ISuggestDataDtoField.insertText]=z.textEdit.newText):typeof z.insertText=="string"?Fe[c.ISuggestDataDtoField.insertText]=z.insertText:z.insertText instanceof s.SnippetString&&(Fe[c.ISuggestDataDtoField.insertText]=z.insertText.value,Fe[c.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let He;return z.textEdit?He=z.textEdit.range:z.range&&(He=z.range),s.Range.isRange(He)?Fe[c.ISuggestDataDtoField.range]=n.Range.from(He):He&&(!X?.isEqual(He.inserting)||!J?.isEqual(He.replacing))&&(Fe[c.ISuggestDataDtoField.range]={insert:n.Range.from(He.inserting),replace:n.Range.from(He.replacing)}),Fe}}class ve{async provideInlineCompletions(z,H,X,J){}disposeCompletions(z){}handleDidShowCompletionItem(z,H,X){}handlePartialAccept(z,H,X,J){}}class G extends ve{constructor(z,H,X,J){super(),this._extension=z,this._documents=H,this._provider=X,this._commands=J,this._references=new se,this._isAdditionsProposedApiEnabled=(0,i.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[a.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,H,X,J){const fe=this._documents.getDocument(z),be=n.Position.to(H),Fe=await this._provider.provideInlineCompletionItems(fe,be,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:n.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[X.triggerKind]},J);if(!Fe||J.isCancellationRequested)return;const He=Array.isArray(Fe)?Fe:Fe.items,qe=this._isAdditionsProposedApiEnabled?Array.isArray(Fe)?[]:Fe.commands||[]:[],Ye=this._isAdditionsProposedApiEnabled&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let it;return{pid:this._references.createReferenceId({dispose(){it?.dispose()},items:He}),items:He.map((rt,ot)=>{let ft;rt.command&&(it||(it=new R.DisposableStore),ft=this._commands.toInternal(rt.command,it));const ut=rt.insertText;return{insertText:typeof ut=="string"?ut:{snippet:ut.value},filterText:rt.filterText,range:rt.range?n.Range.from(rt.range):void 0,command:ft,idx:ot,completeBracketPairs:this._isAdditionsProposedApiEnabled?rt.completeBracketPairs:!1}}),commands:qe.map(rt=>(it||(it=new R.DisposableStore),this._commands.toInternal(rt,it))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(z){this._references.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,H,X){const J=this._references.get(z)?.items[H];J&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(J,X)}handlePartialAccept(z,H,X,J){const fe=this._references.get(z)?.items[H];fe&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(fe,X),this._provider.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(J)))}}class W{async provideInlineEdits(z,H,X){const J=this._documents.getDocument(z),fe=await this._provider.provideInlineEdit(J,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},X);if(!fe||X.isCancellationRequested)return;let be;const Fe=this._references.createReferenceId({dispose(){be?.dispose()},item:fe});let He;fe.accepted&&(be||(be=new R.DisposableStore),He=this._commands.toInternal(fe.accepted,be));let qe;return fe.rejected&&(be||(be=new R.DisposableStore),qe=this._commands.toInternal(fe.rejected,be)),{pid:Fe,text:fe.text,range:n.Range.from(fe.range),accepted:He,rejected:qe}}disposeEdit(z){this._references.disposeReferenceId(z)?.dispose()}constructor(z,H,X,J){this._documents=H,this._provider=X,this._commands=J,this._references=new se,this.languageTriggerKindToVSCodeTriggerKind={[a.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class se{constructor(){this._references=new Map,this._idPool=1}createReferenceId(z){const H=this._idPool++;return this._references.set(H,z),H}disposeReferenceId(z){const H=this._references.get(z);return this._references.delete(z),H}get(z){return this._references.get(z)}}class ae{constructor(z,H){this._documents=z,this._provider=H,this._cache=new t.Cache("SignatureHelp")}async provideSignatureHelp(z,H,X,J){const fe=this._documents.getDocument(z),be=n.Position.to(H),Fe=this.reviveContext(X),He=await this._provider.provideSignatureHelp(fe,be,J,Fe);if(He){const qe=this._cache.add([He]);return{...n.SignatureHelp.from(He),id:qe}}}reviveContext(z){let H;if(z.activeSignatureHelp){const X=n.SignatureHelp.to(z.activeSignatureHelp),J=this._cache.get(z.activeSignatureHelp.id,0);J?(H=J,H.activeSignature=X.activeSignature,H.activeParameter=X.activeParameter):H=X}return{...z,activeSignatureHelp:H}}releaseSignatureHelp(z){this._cache.delete(z)}}class ie{constructor(z,H,X,J,fe){this._documents=z,this._commands=H,this._provider=X,this._logService=J,this._extension=fe,this._cache=new t.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(z,H,X){const J=this._documents.getDocument(z),fe=n.Range.to(H),be=await this._provider.provideInlayHints(J,fe,X);if(!Array.isArray(be)||be.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(H)}`);return}if(X.isCancellationRequested)return;const Fe=this._cache.add(be);this._disposables.set(Fe,new R.DisposableStore);const He={hints:[],cacheId:Fe};for(let qe=0;qe<be.length;qe++)this._isValidInlayHint(be[qe],fe)&&He.hints.push(this._convertInlayHint(be[qe],[Fe,qe]));return this._logService.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(H)}`),He}async resolveInlayHint(z,H){if(typeof this._provider.resolveInlayHint!="function")return;const X=this._cache.get(...z);if(!X)return;const J=await this._provider.resolveInlayHint(X,H);if(J&&this._isValidInlayHint(J))return this._convertInlayHint(J,z)}releaseHints(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_isValidInlayHint(z,H){return z.label.length===0||Array.isArray(z.label)&&z.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(H&&!H.contains(z.position))}_convertInlayHint(z,H){const X=this._disposables.get(H[0]);if(!X)throw Error("DisposableStore is missing...");const J={label:"",cacheId:H,tooltip:n.MarkdownString.fromStrict(z.tooltip),position:n.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(n.TextEdit.from),kind:z.kind&&n.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")J.label=z.label;else{const fe=[];J.label=fe;for(const be of z.label){if(!be.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Fe={label:be.value,tooltip:n.MarkdownString.fromStrict(be.tooltip)};s.Location.isLocation(be.location)&&(Fe.location=n.location.from(be.location)),be.command&&(Fe.command=this._commands.toInternal(be.command,X)),fe.push(Fe)}}return J}}class le{constructor(z,H){this._documents=z,this._provider=H,this._cache=new t.Cache("DocumentLink")}async provideLinks(z,H){const X=this._documents.getDocument(z),J=await this._provider.provideDocumentLinks(X,H);if(!(!Array.isArray(J)||J.length===0)&&!H.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:J.filter(le._validateLink).map(n.DocumentLink.from)};{const fe=this._cache.add(J),be={links:[],cacheId:fe};for(let Fe=0;Fe<J.length;Fe++){if(!le._validateLink(J[Fe]))continue;const He=n.DocumentLink.from(J[Fe]);He.cacheId=[fe,Fe],be.links.push(He)}return be}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,H){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...z);if(!X)return;const J=await this._provider.resolveDocumentLink(X,H);if(!(!J||!le._validateLink(J)))return n.DocumentLink.from(J)}releaseLinks(z){this._cache.delete(z)}}class ue{constructor(z,H){this._documents=z,this._provider=H}async provideColors(z,H){const X=this._documents.getDocument(z),J=await this._provider.provideDocumentColors(X,H);return Array.isArray(J)?J.map(be=>({color:n.Color.from(be.color),range:n.Range.from(be.range)})):[]}async provideColorPresentations(z,H,X){const J=this._documents.getDocument(z),fe=n.Range.to(H.range),be=n.Color.to(H.color),Fe=await this._provider.provideColorPresentations(be,{document:J,range:fe},X);if(Array.isArray(Fe))return Fe.map(n.ColorPresentation.from)}}class Y{constructor(z,H){this._documents=z,this._provider=H}async provideFoldingRanges(z,H,X){const J=this._documents.getDocument(z),fe=await this._provider.provideFoldingRanges(J,H,X);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class oe{constructor(z,H,X){this._documents=z,this._provider=H,this._logService=X}async provideSelectionRanges(z,H,X){const J=this._documents.getDocument(z),fe=H.map(n.Position.to),be=await this._provider.provideSelectionRanges(J,fe,X);if(!(0,r.isNonEmptyArray)(be))return[];if(be.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let He=0;He<fe.length;He++){const qe=[];Fe.push(qe);let Ye=fe[He],it=be[He];for(;;){if(!it.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(n.SelectionRange.from(it)),!it.parent)break;Ye=it.range,it=it.parent}}return Fe}}class pe{constructor(z,H){this._documents=z,this._provider=H,this._idPool=new L.IdGenerator(""),this._cache=new Map}async prepareSession(z,H,X){const J=this._documents.getDocument(z),fe=n.Position.to(H),be=await this._provider.prepareCallHierarchy(J,fe,X);if(!be)return;const Fe=this._idPool.nextId();return this._cache.set(Fe,new Map),Array.isArray(be)?be.map(He=>this._cacheAndConvertItem(Fe,He)):[this._cacheAndConvertItem(Fe,be)]}async provideCallsTo(z,H,X){const J=this._itemFromCache(z,H);if(!J)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(J,X);if(fe)return fe.map(be=>({from:this._cacheAndConvertItem(z,be.from),fromRanges:be.fromRanges.map(Fe=>n.Range.from(Fe))}))}async provideCallsFrom(z,H,X){const J=this._itemFromCache(z,H);if(!J)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(J,X);if(fe)return fe.map(be=>({to:this._cacheAndConvertItem(z,be.to),fromRanges:be.fromRanges.map(Fe=>n.Range.from(Fe))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,H){const X=this._cache.get(z),J=n.CallHierarchyItem.from(H,z,X.size.toString(36));return X.set(J._itemId,H),J}_itemFromCache(z,H){return this._cache.get(z)?.get(H)}}class Ee{constructor(z,H){this._documents=z,this._provider=H,this._idPool=new L.IdGenerator(""),this._cache=new Map}async prepareSession(z,H,X){const J=this._documents.getDocument(z),fe=n.Position.to(H),be=await this._provider.prepareTypeHierarchy(J,fe,X);if(!be)return;const Fe=this._idPool.nextId();return this._cache.set(Fe,new Map),Array.isArray(be)?be.map(He=>this._cacheAndConvertItem(Fe,He)):[this._cacheAndConvertItem(Fe,be)]}async provideSupertypes(z,H,X){const J=this._itemFromCache(z,H);if(!J)throw new Error("missing type hierarchy item");const fe=await this._provider.provideTypeHierarchySupertypes(J,X);if(fe)return fe.map(be=>this._cacheAndConvertItem(z,be))}async provideSubtypes(z,H,X){const J=this._itemFromCache(z,H);if(!J)throw new Error("missing type hierarchy item");const fe=await this._provider.provideTypeHierarchySubtypes(J,X);if(fe)return fe.map(be=>this._cacheAndConvertItem(z,be))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,H){const X=this._cache.get(z),J=n.TypeHierarchyItem.from(H,z,X.size.toString(36));return X.set(J._itemId,H),J}_itemFromCache(z,H){return this._cache.get(z)?.get(H)}}class Ne{constructor(z,H,X,J,fe){this._proxy=z,this._documents=H,this._provider=X,this._handle=J,this._extension=fe,this._cache=new t.Cache("DocumentDropEdit")}async provideDocumentOnDropEdits(z,H,X,J,fe){const be=this._documents.getDocument(H),Fe=n.Position.to(X),He=n.DataTransfer.toDataTransfer(J,async tt=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,z,tt)).buffer),qe=await this._provider.provideDocumentDropEdits(be,Fe,He,fe);if(!qe)return;const Ye=(0,r.asArray)(qe),it=this._cache.add(Ye);return Ye.map((tt,rt)=>({_cacheId:[it,rt],title:tt.title??(0,f.localize)(1,null,this._extension.displayName||this._extension.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(ot=>ot.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?n.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,H){const[X,J]=z,fe=this._cache.get(X,J);if(!fe||!this._provider.resolveDocumentDropEdit)return{};const be=await this._provider.resolveDocumentDropEdit(fe,H)??fe;return{additionalEdit:be.additionalEdit?n.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releaseDropEdits(z){this._cache.delete(z)}}class We{constructor(z,H){this._documents=z,this._provider=H}async provideMappedEdits(z,H,X,J){const fe=d.URI.revive(z),be=this._documents.getDocument(fe),Fe=X.documents.map(Ye=>Ye.map(it=>({uri:d.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(tt=>n.Range.to(tt))}))),He={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},qe=await this._provider.provideMappedEdits(be,H,He,J);return qe?n.WorkspaceEdit.from(qe):null}}class Ce{constructor(z,H){this.adapter=z,this.extension=H}}class Ie{static{this._handlePool=0}constructor(z,H,X,J,fe,be,Fe,He){this._uriTransformer=H,this._documents=X,this._commands=J,this._diagnostics=fe,this._logService=be,this._apiDeprecation=Fe,this._extensionTelemetry=He,this._adapter=new Map,this._proxy=z.getProxy(c.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(z,H){return n.DocumentSelector.from(z,this._uriTransformer,H)}_createDisposable(z){return new s.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ie._handlePool++}async _withAdapter(z,H,X,J,fe,be=!1){const Fe=this._adapter.get(z);if(!Fe||!(Fe.adapter instanceof H))return J;const He=Date.now();be||this._logService.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const qe=X(Fe.adapter,Fe.extension);return Promise.resolve(qe).catch(Ye=>{(0,A.isCancellationError)(Ye)||(this._logService.error(`[${Fe.extension.identifier.value}] provider FAILED`),this._logService.error(Ye),this._extensionTelemetry.onExtensionError(Fe.extension.identifier,Ye))}).finally(()=>{be||this._logService.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),k.CancellationToken.isCancellationToken(fe)?(0,g.raceCancellationError)(qe,fe):qe}_addNewAdapter(z,H){const X=this._nextHandle();return this._adapter.set(X,new Ce(z,H)),X}static _extLabel(z){return z.displayName||z.name}static _extId(z){return z.identifier.value}registerDocumentSymbolProvider(z,H,X,J){const fe=this._addNewAdapter(new h(this._documents,X),z),be=J&&J.label||Ie._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(H,z),be),this._createDisposable(fe)}$provideDocumentSymbols(z,H,X){return this._withAdapter(z,h,J=>J.provideDocumentSymbols(d.URI.revive(H),X),void 0,X)}registerCodeLensProvider(z,H,X){const J=this._nextHandle(),fe=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(J,new Ce(new o(this._documents,this._commands.converter,X,z,this._extensionTelemetry,this._logService),z)),this._proxy.$registerCodeLensSupport(J,this._transformDocumentSelector(H,z),fe);let be=this._createDisposable(J);if(fe!==void 0){const Fe=X.onDidChangeCodeLenses(He=>this._proxy.$emitCodeLensEvent(fe));be=s.Disposable.from(be,Fe)}return be}$provideCodeLenses(z,H,X){return this._withAdapter(z,o,J=>J.provideCodeLenses(d.URI.revive(H),X),void 0,X)}$resolveCodeLens(z,H,X){return this._withAdapter(z,o,J=>J.resolveCodeLens(H,X),void 0,void 0)}$releaseCodeLenses(z,H){this._withAdapter(z,o,X=>Promise.resolve(X.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(z,H,X){const J=this._addNewAdapter(new _(this._documents,X),z);return this._proxy.$registerDefinitionSupport(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$provideDefinition(z,H,X,J){return this._withAdapter(z,_,fe=>fe.provideDefinition(d.URI.revive(H),X,J),[],J)}registerDeclarationProvider(z,H,X){const J=this._addNewAdapter(new D(this._documents,X),z);return this._proxy.$registerDeclarationSupport(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$provideDeclaration(z,H,X,J){return this._withAdapter(z,D,fe=>fe.provideDeclaration(d.URI.revive(H),X,J),[],J)}registerImplementationProvider(z,H,X){const J=this._addNewAdapter(new C(this._documents,X),z);return this._proxy.$registerImplementationSupport(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$provideImplementation(z,H,X,J){return this._withAdapter(z,C,fe=>fe.provideImplementation(d.URI.revive(H),X,J),[],J)}registerTypeDefinitionProvider(z,H,X){const J=this._addNewAdapter(new S(this._documents,X),z);return this._proxy.$registerTypeDefinitionSupport(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$provideTypeDefinition(z,H,X,J){return this._withAdapter(z,S,fe=>fe.provideTypeDefinition(d.URI.revive(H),X,J),[],J)}registerHoverProvider(z,H,X,J){const fe=this._addNewAdapter(new I(this._documents,X),z);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(H,z)),this._createDisposable(fe)}$provideHover(z,H,X,J,fe){return this._withAdapter(z,I,be=>be.provideHover(d.URI.revive(H),X,J,fe),void 0,fe)}$releaseHover(z,H){this._withAdapter(z,I,X=>Promise.resolve(X.releaseHover(H)),void 0,void 0)}registerEvaluatableExpressionProvider(z,H,X,J){const fe=this._addNewAdapter(new b(this._documents,X),z);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(H,z)),this._createDisposable(fe)}$provideEvaluatableExpression(z,H,X,J){return this._withAdapter(z,b,fe=>fe.provideEvaluatableExpression(d.URI.revive(H),X,J),void 0,J)}registerInlineValuesProvider(z,H,X,J){const fe=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,be=this._addNewAdapter(new w(this._documents,X),z);this._proxy.$registerInlineValuesProvider(be,this._transformDocumentSelector(H,z),fe);let Fe=this._createDisposable(be);if(fe!==void 0){const He=X.onDidChangeInlineValues(qe=>this._proxy.$emitInlineValuesEvent(fe));Fe=s.Disposable.from(Fe,He)}return Fe}$provideInlineValues(z,H,X,J,fe){return this._withAdapter(z,w,be=>be.provideInlineValues(d.URI.revive(H),X,J,fe),void 0,fe)}registerDocumentHighlightProvider(z,H,X){const J=this._addNewAdapter(new N(this._documents,X),z);return this._proxy.$registerDocumentHighlightProvider(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}registerMultiDocumentHighlightProvider(z,H,X){const J=this._addNewAdapter(new O(this._documents,X),z);return this._proxy.$registerMultiDocumentHighlightProvider(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$provideDocumentHighlights(z,H,X,J){return this._withAdapter(z,N,fe=>fe.provideDocumentHighlights(d.URI.revive(H),X,J),void 0,J)}$provideMultiDocumentHighlights(z,H,X,J,fe){return this._withAdapter(z,O,be=>be.provideMultiDocumentHighlights(d.URI.revive(H),X,J.map(Fe=>d.URI.revive(Fe)),fe),void 0,fe)}registerLinkedEditingRangeProvider(z,H,X){const J=this._addNewAdapter(new U(this._documents,X),z);return this._proxy.$registerLinkedEditingRangeProvider(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$provideLinkedEditingRanges(z,H,X,J){return this._withAdapter(z,U,async fe=>{const be=await fe.provideLinkedEditingRanges(d.URI.revive(H),X,J);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?Ie._serializeRegExp(be.wordPattern):void 0}},void 0,J)}registerReferenceProvider(z,H,X){const J=this._addNewAdapter(new x(this._documents,X),z);return this._proxy.$registerReferenceSupport(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$provideReferences(z,H,X,J,fe){return this._withAdapter(z,x,be=>be.provideReferences(d.URI.revive(H),X,J,fe),void 0,fe)}registerCodeActionProvider(z,H,X,J){const fe=new R.DisposableStore,be=this._addNewAdapter(new B(this._documents,this._commands.converter,this._diagnostics,X,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerCodeActionSupport(be,this._transformDocumentSelector(H,z),{providedKinds:J?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:J?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this._commands.converter.toInternal(Fe.command,fe)}))},Ie._extLabel(z),Ie._extId(z),!!X.resolveCodeAction),fe.add(this._createDisposable(be)),fe}$provideCodeActions(z,H,X,J,fe){return this._withAdapter(z,B,be=>be.provideCodeActions(d.URI.revive(H),X,J,fe),void 0,fe)}$resolveCodeAction(z,H,X){return this._withAdapter(z,B,J=>J.resolveCodeAction(H,X),{},void 0)}$releaseCodeActions(z,H){this._withAdapter(z,B,X=>Promise.resolve(X.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(z,H,X){const J=this._addNewAdapter(new M(this._documents,X),z);return this._proxy.$registerDocumentFormattingSupport(J,this._transformDocumentSelector(H,z),z.identifier,z.displayName||z.name),this._createDisposable(J)}$provideDocumentFormattingEdits(z,H,X,J){return this._withAdapter(z,M,fe=>fe.provideDocumentFormattingEdits(d.URI.revive(H),X,J),void 0,J)}registerDocumentRangeFormattingEditProvider(z,H,X){const J=typeof X.provideDocumentRangesFormattingEdits=="function",fe=this._addNewAdapter(new K(this._documents,X),z);return this._proxy.$registerRangeFormattingSupport(fe,this._transformDocumentSelector(H,z),z.identifier,z.displayName||z.name,J),this._createDisposable(fe)}$provideDocumentRangeFormattingEdits(z,H,X,J,fe){return this._withAdapter(z,K,be=>be.provideDocumentRangeFormattingEdits(d.URI.revive(H),X,J,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(z,H,X,J,fe){return this._withAdapter(z,K,be=>be.provideDocumentRangesFormattingEdits(d.URI.revive(H),X,J,fe),void 0,fe)}registerOnTypeFormattingEditProvider(z,H,X,J){const fe=this._addNewAdapter(new ee(this._documents,X),z);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(H,z),J,z.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(z,H,X,J,fe,be){return this._withAdapter(z,ee,Fe=>Fe.provideOnTypeFormattingEdits(d.URI.revive(H),X,J,fe,be),void 0,be)}registerWorkspaceSymbolProvider(z,H){const X=this._addNewAdapter(new $(H,this._logService),z);return this._proxy.$registerNavigateTypeSupport(X,typeof H.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols(z,H,X){return this._withAdapter(z,$,J=>J.provideWorkspaceSymbols(H,X),{symbols:[]},X)}$resolveWorkspaceSymbol(z,H,X){return this._withAdapter(z,$,J=>J.resolveWorkspaceSymbol(H,X),void 0,void 0)}$releaseWorkspaceSymbols(z,H){this._withAdapter(z,$,X=>X.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(z,H,X){const J=this._addNewAdapter(new q(this._documents,X,this._logService),z);return this._proxy.$registerRenameSupport(J,this._transformDocumentSelector(H,z),q.supportsResolving(X)),this._createDisposable(J)}$provideRenameEdits(z,H,X,J,fe){return this._withAdapter(z,q,be=>be.provideRenameEdits(d.URI.revive(H),X,J,fe),void 0,fe)}$resolveRenameLocation(z,H,X,J){return this._withAdapter(z,q,fe=>fe.resolveRenameLocation(d.URI.revive(H),X,J),void 0,J)}registerNewSymbolNamesProvider(z,H,X){const J=this._addNewAdapter(new Z(this._documents,X,this._logService),z);return this._proxy.$registerNewSymbolNamesProvider(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$supportsAutomaticNewSymbolNamesTriggerKind(z){return this._withAdapter(z,Z,H=>H.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(z,H,X,J,fe){return this._withAdapter(z,Z,be=>be.provideNewSymbolNames(d.URI.revive(H),X,J,fe),void 0,fe)}registerDocumentSemanticTokensProvider(z,H,X,J){const fe=this._addNewAdapter(new de(this._documents,X),z),be=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(H,z),J,be);let Fe=this._createDisposable(fe);if(be){const He=X.onDidChangeSemanticTokens(qe=>this._proxy.$emitDocumentSemanticTokensEvent(be));Fe=s.Disposable.from(Fe,He)}return Fe}$provideDocumentSemanticTokens(z,H,X,J){return this._withAdapter(z,de,fe=>fe.provideDocumentSemanticTokens(d.URI.revive(H),X,J),null,J)}$releaseDocumentSemanticTokens(z,H){this._withAdapter(z,de,X=>X.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,H,X,J){const fe=this._addNewAdapter(new re(this._documents,X),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(H,z),J),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(z,H,X,J){return this._withAdapter(z,re,fe=>fe.provideDocumentRangeSemanticTokens(d.URI.revive(H),X,J),null,J)}registerCompletionItemProvider(z,H,X,J){const fe=this._addNewAdapter(new Se(this._documents,this._commands.converter,X,this._apiDeprecation,z),z);return this._proxy.$registerCompletionsProvider(fe,this._transformDocumentSelector(H,z),J,Se.supportsResolving(X),z.identifier),this._createDisposable(fe)}$provideCompletionItems(z,H,X,J,fe){return this._withAdapter(z,Se,be=>be.provideCompletionItems(d.URI.revive(H),X,J,fe),void 0,fe)}$resolveCompletionItem(z,H,X){return this._withAdapter(z,Se,J=>J.resolveCompletionItem(H,X),void 0,X)}$releaseCompletionItems(z,H){this._withAdapter(z,Se,X=>X.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(z,H,X,J){const fe=new G(z,this._documents,X,this._commands.converter),be=this._addNewAdapter(fe,z);return this._proxy.$registerInlineCompletionsSupport(be,this._transformDocumentSelector(H,z),fe.supportsHandleEvents,m.ExtensionIdentifier.toKey(z.identifier.value),J?.yieldTo?.map(Fe=>m.ExtensionIdentifier.toKey(Fe))||[]),this._createDisposable(be)}$provideInlineCompletions(z,H,X,J,fe){return this._withAdapter(z,ve,be=>be.provideInlineCompletions(d.URI.revive(H),X,J,fe),void 0,fe)}$handleInlineCompletionDidShow(z,H,X,J){this._withAdapter(z,ve,async fe=>{fe.handleDidShowCompletionItem(H,X,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,H,X,J,fe){this._withAdapter(z,ve,async be=>{be.handlePartialAccept(H,X,J,fe)},void 0,void 0)}$freeInlineCompletionsList(z,H){this._withAdapter(z,ve,async X=>{X.disposeCompletions(H)},void 0,void 0)}registerInlineEditProvider(z,H,X){const J=new W(z,this._documents,X,this._commands.converter),fe=this._addNewAdapter(J,z);return this._proxy.$registerInlineEditProvider(fe,this._transformDocumentSelector(H,z),z.identifier),this._createDisposable(fe)}$provideInlineEdit(z,H,X,J){return this._withAdapter(z,W,fe=>fe.provideInlineEdits(d.URI.revive(H),X,J),void 0,J)}$freeInlineEdit(z,H){this._withAdapter(z,W,async X=>{X.disposeEdit(H)},void 0,void 0)}registerSignatureHelpProvider(z,H,X,J){const fe=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,be=this._addNewAdapter(new ae(this._documents,X),z);return this._proxy.$registerSignatureHelpProvider(be,this._transformDocumentSelector(H,z),fe),this._createDisposable(be)}$provideSignatureHelp(z,H,X,J,fe){return this._withAdapter(z,ae,be=>be.provideSignatureHelp(d.URI.revive(H),X,J,fe),void 0,fe)}$releaseSignatureHelp(z,H){this._withAdapter(z,ae,X=>X.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(z,H,X){const J=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new ie(this._documents,this._commands.converter,X,this._logService,z),z);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector(H,z),typeof X.resolveInlayHint=="function",J,Ie._extLabel(z));let be=this._createDisposable(fe);if(J!==void 0){const Fe=X.onDidChangeInlayHints(He=>this._proxy.$emitInlayHintsEvent(J));be=s.Disposable.from(be,Fe)}return be}$provideInlayHints(z,H,X,J){return this._withAdapter(z,ie,fe=>fe.provideInlayHints(d.URI.revive(H),X,J),void 0,J)}$resolveInlayHint(z,H,X){return this._withAdapter(z,ie,J=>J.resolveInlayHint(H,X),void 0,X)}$releaseInlayHints(z,H){this._withAdapter(z,ie,X=>X.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(z,H,X){const J=this._addNewAdapter(new le(this._documents,X),z);return this._proxy.$registerDocumentLinkProvider(J,this._transformDocumentSelector(H,z),typeof X.resolveDocumentLink=="function"),this._createDisposable(J)}$provideDocumentLinks(z,H,X){return this._withAdapter(z,le,J=>J.provideLinks(d.URI.revive(H),X),void 0,X,H.scheme==="output")}$resolveDocumentLink(z,H,X){return this._withAdapter(z,le,J=>J.resolveLink(H,X),void 0,void 0,!0)}$releaseDocumentLinks(z,H){this._withAdapter(z,le,X=>X.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(z,H,X){const J=this._addNewAdapter(new ue(this._documents,X),z);return this._proxy.$registerDocumentColorProvider(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$provideDocumentColors(z,H,X){return this._withAdapter(z,ue,J=>J.provideColors(d.URI.revive(H),X),[],X)}$provideColorPresentations(z,H,X,J){return this._withAdapter(z,ue,fe=>fe.provideColorPresentations(d.URI.revive(H),X,J),void 0,J)}registerFoldingRangeProvider(z,H,X){const J=this._nextHandle(),fe=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(J,new Ce(new Y(this._documents,X),z)),this._proxy.$registerFoldingRangeProvider(J,this._transformDocumentSelector(H,z),z.identifier,fe);let be=this._createDisposable(J);if(fe!==void 0){const Fe=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));be=s.Disposable.from(be,Fe)}return be}$provideFoldingRanges(z,H,X,J){return this._withAdapter(z,Y,fe=>fe.provideFoldingRanges(d.URI.revive(H),X,J),void 0,J)}registerSelectionRangeProvider(z,H,X){const J=this._addNewAdapter(new oe(this._documents,X,this._logService),z);return this._proxy.$registerSelectionRangeProvider(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$provideSelectionRanges(z,H,X,J){return this._withAdapter(z,oe,fe=>fe.provideSelectionRanges(d.URI.revive(H),X,J),[],J)}registerCallHierarchyProvider(z,H,X){const J=this._addNewAdapter(new pe(this._documents,X),z);return this._proxy.$registerCallHierarchyProvider(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$prepareCallHierarchy(z,H,X,J){return this._withAdapter(z,pe,fe=>Promise.resolve(fe.prepareSession(d.URI.revive(H),X,J)),void 0,J)}$provideCallHierarchyIncomingCalls(z,H,X,J){return this._withAdapter(z,pe,fe=>fe.provideCallsTo(H,X,J),void 0,J)}$provideCallHierarchyOutgoingCalls(z,H,X,J){return this._withAdapter(z,pe,fe=>fe.provideCallsFrom(H,X,J),void 0,J)}$releaseCallHierarchy(z,H){this._withAdapter(z,pe,X=>Promise.resolve(X.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(z,H,X){const J=this._addNewAdapter(new Ee(this._documents,X),z);return this._proxy.$registerTypeHierarchyProvider(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$prepareTypeHierarchy(z,H,X,J){return this._withAdapter(z,Ee,fe=>Promise.resolve(fe.prepareSession(d.URI.revive(H),X,J)),void 0,J)}$provideTypeHierarchySupertypes(z,H,X,J){return this._withAdapter(z,Ee,fe=>fe.provideSupertypes(H,X,J),void 0,J)}$provideTypeHierarchySubtypes(z,H,X,J){return this._withAdapter(z,Ee,fe=>fe.provideSubtypes(H,X,J),void 0,J)}$releaseTypeHierarchy(z,H){this._withAdapter(z,Ee,X=>Promise.resolve(X.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(z,H,X,J){const fe=this._nextHandle();return this._adapter.set(fe,new Ce(new Ne(this._proxy,this._documents,X,fe,z),z)),this._proxy.$registerDocumentOnDropEditProvider(fe,this._transformDocumentSelector(H,z),(0,i.isProposedApiEnabled)(z,"documentPaste")&&J?{supportsResolve:!!X.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this._createDisposable(fe)}$provideDocumentOnDropEdits(z,H,X,J,fe,be){return this._withAdapter(z,Ne,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(H,d.URI.revive(X),J,fe,be)),void 0,void 0)}$resolveDropEdit(z,H,X){return this._withAdapter(z,Ne,J=>J.resolveDropEdit(H,X),{},void 0)}$releaseDropEdits(z,H){this._withAdapter(z,Ne,X=>Promise.resolve(X.releaseDropEdits(H)),void 0,void 0)}registerMappedEditsProvider(z,H,X){const J=this._addNewAdapter(new We(this._documents,X),z);return this._proxy.$registerMappedEditsProvider(J,this._transformDocumentSelector(H,z)),this._createDisposable(J)}$provideMappedEdits(z,H,X,J,fe){return this._withAdapter(z,We,be=>Promise.resolve(be.provideMappedEdits(H,X,J,fe)),null,fe)}registerDocumentPasteEditProvider(z,H,X,J){const fe=this._nextHandle();return this._adapter.set(fe,new Ce(new F(this._proxy,this._documents,X,fe,z),z)),this._proxy.$registerPasteEditProvider(fe,this._transformDocumentSelector(H,z),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(be=>be.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this._createDisposable(fe)}$prepareDocumentPaste(z,H,X,J,fe){return this._withAdapter(z,F,be=>be.prepareDocumentPaste(d.URI.revive(H),X,J,fe),void 0,fe)}$providePasteEdits(z,H,X,J,fe,be,Fe){return this._withAdapter(z,F,He=>He.providePasteEdits(H,d.URI.revive(X),J,fe,be,Fe),void 0,Fe)}$resolvePasteEdit(z,H,X){return this._withAdapter(z,F,J=>J.resolvePasteEdit(H,X),{},void 0)}$releasePasteEdits(z,H){this._withAdapter(z,F,X=>Promise.resolve(X.releasePasteEdits(H)),void 0,void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:z.flags}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ie._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ie._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ie._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ie._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ie._serializeRegExp(z.beforeText),afterText:z.afterText?Ie._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ie._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ie._serializeOnEnterRule)}static _serializeAutoClosingPair(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(H=>s.SyntaxTokenType.toString(H)):void 0}}static _serializeAutoClosingPairs(z){return z.map(Ie._serializeAutoClosingPair)}setLanguageConfiguration(z,H,X){const{wordPattern:J}=X;if(J&&(0,P.regExpLeadsToEndlessLoop)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this._documents.setWordDefinitionFor(H,J):this._documents.setWordDefinitionFor(H,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const fe=this._nextHandle(),be={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ie._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Ie._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ie._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?Ie._serializeAutoClosingPairs(X.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(fe,H,be),this._createDisposable(fe)}$setWordDefinitions(z){for(const H of z)this._documents.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=Ie}),define(we[128],ye([1,0,9,21,14,4,40,3,235,24,5,12,90,6,127,20,17,10,154,26]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,e.IExtHostLanguageModels=(0,P.createDecorator)("IExtHostLanguageModels");class i{constructor(o,p){this.option=o,this.stream=new r.AsyncIterableSource,this.stream=p??new r.AsyncIterableSource}}class t{constructor(){this._responseStreams=new Map,this._defaultStream=new r.AsyncIterableSource,this._isDone=!1,this._isStreaming=!1;const o=this;this.apiObject={text:o._defaultStream.asyncIterable}}*_streams(){if(this._responseStreams.size>0)for(const[,o]of this._responseStreams)yield o.stream;else yield this._defaultStream}handleFragment(o){if(this._isDone)return;this._isStreaming=!0;let p=this._responseStreams.get(o.index);p||(this._responseStreams.size===0?p=new i(o.index,this._defaultStream):p=new i(o.index),this._responseStreams.set(o.index,p)),p.stream.emitOne(o.part)}get isStreaming(){return this._isStreaming}reject(o){this._isDone=!0;for(const p of this._streams())p.reject(o)}resolve(){this._isDone=!0;for(const o of this._streams())o.resolve()}}let c=class{static{s=this}static{this._idPool=1}constructor(o,p,_){this._logService=p,this._extHostAuthentication=_,this._onDidChangeModelAccess=new A.Emitter,this._onDidChangeProviders=new A.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new l.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=o.getProxy(T.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(o,p,_,D){const C=s._idPool++;this._languageModels.set(C,{extension:o.identifier,provider:_,languageModelId:p});let S;D.auth&&(S={providerLabel:o.displayName||o.name,accountLabel:typeof D.auth=="object"?D.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(C,`${l.ExtensionIdentifier.toKey(o.identifier)}/${C}/${p}`,{extension:o.identifier,id:p,vendor:D.vendor??l.ExtensionIdentifier.toKey(o.identifier),name:D.name??"",family:D.family??"",version:D.version,maxInputTokens:D.maxInputTokens,maxOutputTokens:D.maxOutputTokens,auth:S,targetExtensions:D.extensions});const I=_.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:w,tokenCount:N})=>{this._proxy.$whenLanguageModelChatRequestMade(p,new l.ExtensionIdentifier(b),w,N)});return(0,R.toDisposable)(()=>{this._languageModels.delete(C),this._proxy.$unregisterProvider(C),I?.dispose()})}async $provideLanguageModelResponse(o,p,_,D,C,S){const I=this._languageModels.get(o);if(!I)return;const b=new d.Progress(async w=>{if(S.isCancellationRequested){this._logService.warn(`[CHAT](${I.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(p,{index:w.index,part:w.part})});return I.provider.provideLanguageModelResponse(D.map(u.LanguageModelChatMessage.to),C,l.ExtensionIdentifier.toKey(_),b,S)}$provideTokenLength(o,p,_){const D=this._languageModels.get(o);return D?Promise.resolve(D.provider.provideTokenCount(p,_)):Promise.resolve(0)}$acceptChatModelMetadata(o){if(o.added)for(const{identifier:p,metadata:_}of o.added)this._allLanguageModelData.set(p,{metadata:_,apiObjects:new l.ExtensionIdentifierMap});if(o.removed)for(const p of o.removed){this._allLanguageModelData.delete(p);for(const[_,D]of this._pendingRequest)D.languageModelId===p&&(D.res.reject(new k.CancellationError),this._pendingRequest.delete(_))}o.added?.forEach(p=>this._fakeAuthPopulate(p.metadata)),this._onDidChangeProviders.fire(void 0)}async selectLanguageModels(o,p){const _=await this._proxy.$selectChatModels({...p,extension:o.identifier}),D=[],C=this;for(const S of _){const I=this._allLanguageModelData.get(S);if(!I)continue;this._isUsingAuth(o.identifier,I.metadata)&&await this._fakeAuthPopulate(I.metadata);let b=I.apiObjects.get(o.identifier);b||(b={id:S,vendor:I.metadata.vendor,family:I.metadata.family,version:I.metadata.version,name:I.metadata.name,maxInputTokens:I.metadata.maxInputTokens,countTokens(w,N){if(!C._allLanguageModelData.has(S))throw f.LanguageModelError.NotFound(S);return C._computeTokenLength(S,w,N??g.CancellationToken.None)},sendRequest(w,N,O){if(!C._allLanguageModelData.has(S))throw f.LanguageModelError.NotFound(S);return C._sendChatRequest(o,S,w,N??{},O??g.CancellationToken.None)}},Object.freeze(b),I.apiObjects.set(o.identifier,b)),D.push(b)}return D}async _sendChatRequest(o,p,_,D,C){const S=this._convertMessages(o,_),I=o.identifier,b=this._allLanguageModelData.get(p)?.metadata;if(!b||!this._allLanguageModelData.has(p))throw f.LanguageModelError.NotFound(`Language model '${p}' is unknown.`);if(this._isUsingAuth(I,b)&&(!await this._getAuthAccess(o,{identifier:b.extension,displayName:b.auth.providerLabel},D.justification,!1)||!this._modelAccessList.get(I)?.has(b.extension)))throw f.LanguageModelError.NoPermissions(`Language model '${p}' cannot be used by '${I.value}'.`);const w=Math.random()*1e6|0,N=this._proxy.$fetchResponse(I,p,w,S,D.modelOptions??{},C),O=new r.Barrier,U=new t;this._pendingRequest.set(w,{languageModelId:p,res:U});let x;if(N.catch(B=>{O.isOpen()?U.reject(B):x=B}).finally(()=>{this._pendingRequest.delete(w),U.resolve(),O.open()}),await O.wait(),x)throw x.name===f.LanguageModelError.name?x:new f.LanguageModelError(`Language model '${p}' errored, check cause for more details`,"Unknown",x);return U.apiObject}_convertMessages(o,p){const _=[];for(const D of p)D.role===f.LanguageModelChatMessageRole.System&&(0,n.checkProposedApiEnabled)(o,"languageModelSystem"),_.push(u.LanguageModelChatMessage.from(D));return _}async $handleResponseFragment(o,p){const _=this._pendingRequest.get(o);_&&_.res.handleFragment(p)}async _getAuthAccess(o,p,_,D){const C=m.INTERNAL_AUTH_PROVIDER_PREFIX+p.identifier.value;if(await this._extHostAuthentication.getSession(o,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:o.identifier,to:p.identifier,enabled:!0}]),!0;if(D)return!1;try{const I=_?(0,v.localize)(0,null,p.displayName,_):void 0;return await this._extHostAuthentication.getSession(o,C,[],{forceNewSession:{detail:I}}),this.$updateModelAccesslist([{from:o.identifier,to:p.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(o,p){return!!p.auth&&!l.ExtensionIdentifier.equals(p.extension,o)}async _fakeAuthPopulate(o){if(o.auth)for(const p of this._languageAccessInformationExtensions)try{await this._getAuthAccess(p,{identifier:o.extension,displayName:""},void 0,!0)}catch(_){this._logService.error("Fake Auth request failed"),this._logService.error(_)}}async _computeTokenLength(o,p,_){if(!this._allLanguageModelData.get(o))throw f.LanguageModelError.NotFound(`Language model '${o}' is unknown.`);const C=L.Iterable.find(this._languageModels.values(),S=>S.languageModelId===o);return C?C.provider.provideTokenCount(p,_):this._proxy.$countTokens(o,typeof p=="string"?p:u.LanguageModelChatMessage.from(p),_)}$updateModelAccesslist(o){const p=new Array;for(const{from:_,to:D,enabled:C}of o){const S=this._modelAccessList.get(_)??new l.ExtensionIdentifierSet;if(S.has(D)!==C){C?S.add(D):S.delete(D),this._modelAccessList.set(_,S);const b={from:_,to:D};p.push(b),this._onDidChangeModelAccess.fire(b)}}}createLanguageModelAccessInformation(o){this._languageAccessInformationExtensions.add(o);const p=this,_=A.Event.signal(A.Event.filter(this._onDidChangeModelAccess.event,C=>l.ExtensionIdentifier.equals(C.from,o.identifier))),D=A.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return A.Event.any(_,D)},canSendRequest(C){let S;e:for(const[b,w]of p._allLanguageModelData)for(const N of w.apiObjects.values())if(N===C){S=w.metadata;break e}if(!S)return;if(!p._isUsingAuth(o.identifier,S))return!0;const I=p._modelAccessList.get(o.identifier);if(I)return I.has(S.extension)}}}};e.ExtHostLanguageModels=c,e.ExtHostLanguageModels=c=s=Ke([Ve(0,a.IExtHostRpcService),Ve(1,y.ILogService),Ve(2,E.IExtHostAuthentication)],c)}),define(we[355],ye([1,0,6,17,10,43,9,3,26]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class l{constructor(y,d,T,E){this._documents=d,this._commands=T,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=y.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(y){this._languageIds=y}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(y,d){await this._proxy.$changeLanguage(y,d);const T=this._documents.getDocumentData(y);if(!T)throw new Error(`document '${y.toString()}' NOT found`);return T.document}async tokenAtPosition(y,d){const T=y.version,E=g.Position.from(d),a=await this._proxy.$tokensAtPosition(y.uri,E),u={type:k.StandardTokenType.Other,range:y.getWordRangeAtPosition(d)??new k.Range(d.line,d.character,d.line,d.character)};if(!a)return u;const f={range:g.Range.to(a.range),type:g.TokenType.to(a.type)};return!f.range.contains(d)||T!==y.version?u:f}createLanguageStatusItem(y,d,T){const E=this._handlePool++,a=this._proxy,u=this._ids,f=`${y.identifier.value}/${d}`;if(u.has(f))throw new Error(`LanguageStatusItem with id '${d}' ALREADY exists`);u.add(f);const m={selector:T,id:d,name:y.displayName??y.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const s=new R.DisposableStore,i=()=>{if(n?.dispose(),!u.has(f)){console.warn(`LanguageStatusItem (${d}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(E,{id:f,name:m.name??y.displayName??y.name,source:y.displayName??y.name,selector:g.DocumentSelector.from(m.selector,this._uriTransformer),label:m.text,detail:m.detail??"",severity:m.severity===k.LanguageStatusSeverity.Error?A.default.Error:m.severity===k.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:m.command&&this._commands.toInternal(m.command,s),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},t={dispose(){s.dispose(),n?.dispose(),a.$removeLanguageStatus(E),u.delete(f)},get id(){return m.id},get name(){return m.name},set name(c){m.name=c,i()},get selector(){return m.selector},set selector(c){m.selector=c,i()},get text(){return m.text},set text(c){m.text=c,i()},set text2(c){(0,v.checkProposedApiEnabled)(y,"languageStatusText"),m.text=c,i()},get text2(){return(0,v.checkProposedApiEnabled)(y,"languageStatusText"),m.text},get detail(){return m.detail},set detail(c){m.detail=c,i()},get severity(){return m.severity},set severity(c){m.severity=c,i()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(c){m.accessibilityInformation=c,i()},get command(){return m.command},set command(c){m.command=c,i()},get busy(){return m.busy},set busy(c){m.busy=c,i()}};return i(),t}}e.ExtHostLanguages=l}),define(we[356],ye([1,0,15,2,17,10,126]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(y,d,T,E){this.start=y,this.deletedCount=d,this.deletedItems=T,this.items=E}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class v{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,d,T){this.notebook=y,this._extHostDocument=d,this._cellData=T,this.handle=T.handle,this.uri=g.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(k.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return y._mime},set mime(E){y._mime=E},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(y){this._outputs=y.map(k.NotebookCellOutput.to)}setOutputItems(y,d,T){const E=T.map(k.NotebookCellOutputItem.to),a=this._outputs.find(u=>u.id===y);if(a&&(d||(a.items.length=0),a.items.push(...E),a.items.length>1&&a.items.every(u=>L.isTextStreamMime(u.mime)))){const u=new Map,f=[];a.items.forEach(m=>{let n;u.has(m.mime)?n=u.get(m.mime):(n=[],u.set(m.mime,n),f.push(m.mime)),n.push(m.data)}),a.items.length=0,f.forEach(m=>{const n=L.compressOutputItemStreams(u.get(m));a.items.push({mime:m,data:n.data.buffer})})}}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=v;class l{static{this._handlePool=0}constructor(y,d,T,E,a){this._proxy=y,this._textDocumentsAndEditors=d,this._textDocuments=T,this.uri=E,this.handle=l._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=a.viewType,this._metadata=Object.freeze(a.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,a.cells]],!0,void 0),this._versionId=a.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const y=this,d={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===r.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(T){return T=y._validateIndex(T),y._cells[T].apiCell},getCells(T){return(T?y._getCells(T):y._cells).map(a=>a.apiCell)},save(){return y._save()}};this._notebook=Object.freeze(d)}return this._notebook}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,d,T){this._versionId=y.versionId,this._isDirty=d,this.acceptDocumentPropertiesChanged({metadata:T});const E={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},a=[];for(const f of y.rawEvents)f.kind===L.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1,E.contentChanges):f.kind===L.NotebookCellsChangeType.Move?this._moveCells(f.index,f.length,f.newIdx,E.contentChanges):f.kind===L.NotebookCellsChangeType.Output?(this._setCellOutputs(f.index,f.outputs),a.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===L.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems),a.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(f.index,f.language),a.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document})):f.kind===L.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document}):f.kind===L.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(f.index,f.metadata),a.push({cell:this._cells[f.index].apiCell,metadata:this._cells[f.index].apiCell.metadata})):f.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(f.index,f.internalMetadata),a.push({cell:this._cells[f.index].apiCell,executionSummary:this._cells[f.index].apiCell.executionSummary}));const u=new Map;for(let f=0;f<a.length;f++){const m=a[f],n=u.get(m.cell);if(n===void 0){const s=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});u.set(m.cell,s-1)}else E.cellChanges[n]={...E.cellChanges[n],...m}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let d=y.start|0,T=y.end|0;return d<0&&(d=0),T>this._cells.length&&(T=this._cells.length),y.with({start:d,end:T})}_getCells(y){y=this._validateRange(y);const d=[];for(let T=y.start;T<y.end;T++)d.push(this._cells[T]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,d,T){if(this._disposed)return;const E=[],a=[],u=[];if(y.reverse().forEach(f=>{const n=f[2].map(t=>{const c=new v(this,this._textDocumentsAndEditors,t);return d||a.push(v.asModelAddData(t)),c}),s=new R(f[0],f[1],[],n),i=this._cells.splice(f[0],f[1],...n);for(const t of i)u.push(t.uri),s.deletedItems.push(t.apiCell);E.push(s)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:u}),T)for(const f of E)T.push(f.asApiEvent())}_moveCells(y,d,T,E){const a=this._cells.splice(y,d);this._cells.splice(T,0,...a);const u=[new R(y,d,a.map(f=>f.apiCell),[]),new R(T,0,[],a)];for(const f of u)E.push(f.asApiEvent())}_setCellOutputs(y,d){this._cells[y].setOutputs(d)}_setCellOutputItems(y,d,T,E){this._cells[y].setOutputItems(d,T,E)}_changeCellLanguage(y,d){const T=this._cells[y];T.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelLanguageChanged(T.uri,d)}_changeCellMime(y,d){const T=this._cells[y];T.apiCell.mime=d}_changeCellMetadata(y,d){this._cells[y].setMetadata(d)}_changeCellInternalMetadata(y,d){this._cells[y].setInternalMetadata(d)}getCellFromApiCell(y){return this._cells.find(d=>d.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(d=>d.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=l}),define(we[357],ye([1,0,4,2,17,10,52]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(l,P,y,d={timeout:1500,errors:3}){this._logService=l,this._notebooksAndEditors=P,this._mainThreadBulkEdits=y,this._thresholds=d,this._onWillSaveNotebookDocumentEvent=new r.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(l){return(P,y,d)=>{const T=function(a){P.call(y,a)};return T.extension=l,this._onWillSaveNotebookDocumentEvent.event(T,void 0,d)}}async $participateInSave(l,P,y){const d=g.URI.revive(l),T=this._notebooksAndEditors.getNotebookDocument(d);if(!T)throw new Error("Unable to resolve notebook document");const E=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:T.apiNotebook,reason:k.TextDocumentSaveReason.to(P)},y,async(u,f)=>{const m=Date.now(),n=await await Promise.resolve(u);Date.now()-m>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!y.isCancellationRequested&&n&&(n instanceof A.WorkspaceEdit?E.push(n):this._logService.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(E.length===0)return!0;const a={edits:[]};for(const u of E){const{edits:f}=k.WorkspaceEdit.from(u);a.edits=a.edits.concat(f)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new L.SerializableObjectWithBuffers(a))}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(we[163],ye([1,0,14,17,10]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(R,v,l,P,y,d){this.id=R,this._proxy=v,this.notebookData=l,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=y,this._visibleRanges=P,this._viewColumn=d}get apiEditor(){if(!this._editor){const R=this;this._editor={get notebook(){return R.notebookData.apiNotebook},get selection(){return R._selections[0]},set selection(v){this.selections=[v]},get selections(){return R._selections},set selections(v){if(!Array.isArray(v)||!v.every(k.NotebookRange.isNotebookRange))throw(0,r.illegalArgument)("selections");R._selections=v,R._trySetSelections(v)},get visibleRanges(){return R._visibleRanges},revealRange(v,l){R._proxy.$tryRevealRange(R.id,g.NotebookRange.from(v),l??k.NotebookEditorRevealType.Default)},get viewColumn(){return R._viewColumn}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(R){this._visible=R}_acceptVisibleRanges(R){this._visibleRanges=R}_acceptSelections(R){this._selections=R}_trySetSelections(R){this._proxy.$trySetSelections(this.id,R.map(g.NotebookRange.from))}_acceptViewColumn(R){this._viewColumn=R}}e.ExtHostNotebookEditor=A}),define(we[358],ye([1,0,4,12,17]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(R,v){this._logService=R,this._notebooksAndEditors=v,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(R,v){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,v);const l=this._notebooksAndEditors.getEditorById(R);v.visibleRanges&&l._acceptVisibleRanges(v.visibleRanges.ranges.map(k.NotebookRange.to)),v.selections&&l._acceptSelections(v.selections.selections.map(k.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:l.apiEditor,visibleRanges:l.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:l.apiEditor,selections:l.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const v in R)this._notebooksAndEditors.getEditorById(v)._acceptViewColumn(k.ViewColumn.to(R[v]))}};e.ExtHostNotebookEditors=A,e.ExtHostNotebookEditors=A=Ke([Ve(0,g.ILogService)],A)}),define(we[359],ye([1,0,4,6,163]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(R,v){this._extHostNotebook=v,this._rendererMessageEmitters=new Map,this.proxy=R.getProxy(g.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,v,l){const P=this._extHostNotebook.getEditorById(R);this._rendererMessageEmitters.get(v)?.fire({editor:P.apiEditor,message:l})}createRendererMessaging(R,v){if(!R.contributes?.notebookRenderer?.some(P=>P.id===v))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${v})`);return{onDidReceiveMessage:(P,y,d)=>this.getOrCreateEmitterFor(v).event(P,y,d),postMessage:(P,y)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(P)&&([P,y]=[y,P]);const d=y&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(y);return this.proxy.$postMessage(d?.id,v,P)}}}getOrCreateEmitterFor(R){let v=this._rendererMessageEmitters.get(R);return v||(v=new r.Emitter({onDidRemoveLastListener:()=>{v?.dispose(),this._rendererMessageEmitters.delete(R)}}),this._rendererMessageEmitters.set(R,v),v)}}e.ExtHostNotebookRenderers=A}),define(we[360],ye([1,0,17,90,21,60,14]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class R{constructor(y){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=y}async withProgress(y,d,T){const E=this._handles++,{title:a,location:u,cancellable:f}=d,m={label:y.displayName||y.name,id:y.identifier.value};return this._proxy.$startProgress(E,{location:r.ProgressLocation.from(u),title:a,source:m,cancellable:f},y.isUnderDevelopment?void 0:y.identifier.value).catch(L.onUnexpectedExternalError),this._withProgress(E,T,!!f)}_withProgress(y,d,T){let E;T&&(E=new k.CancellationTokenSource,this._mapHandleToCancellationSource.set(y,E));const a=f=>{this._proxy.$progressEnd(f),this._mapHandleToCancellationSource.delete(f),E?.dispose()};let u;try{u=d(new l(this._proxy,y),T&&E?E.token:k.CancellationToken.None)}catch(f){throw a(y),f}return u.then(f=>a(y),f=>a(y)),u}$acceptProgressCanceled(y){const d=this._mapHandleToCancellationSource.get(y);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(y))}}e.ExtHostProgress=R;function v(P,y){return P.message=y.message,typeof y.increment=="number"&&(typeof P.increment=="number"?P.increment+=y.increment:P.increment=y.increment),P}class l extends g.Progress{constructor(y,d){super(T=>this.throttledReport(T)),this._proxy=y,this._handle=d}throttledReport(y){this._proxy.$progressReport(this._handle,y)}}Ke([(0,A.throttle)(100,(P,y)=>v(P,y),()=>Object.create(null))],l.prototype,"throttledReport",null)}),define(we[361],ye([1,0,2,6,9,17]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class L{static{this.handlePool=0}constructor(v,l){this.uriTransformer=l,this.providers=new Map,this.proxy=v.getProxy(g.MainContext.MainThreadQuickDiff)}$provideOriginalResource(v,l,P){const y=r.URI.revive(l),d=this.providers.get(v);return d?(0,k.asPromise)(()=>d.provideOriginalResource(y,P)).then(T=>T||null):Promise.resolve(null)}registerQuickDiffProvider(v,l,P,y){const d=L.handlePool++;return this.providers.set(d,l),this.proxy.$registerQuickDiffProvider(d,A.DocumentSelector.from(v,this.uriTransformer),P,y),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(d),this.providers.delete(d)}}}}e.ExtHostQuickDiff=L}),define(we[362],ye([1,0,21,4,3,6,2,10,14,19,43,50,26,17]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=E;function E(a,u,f){const m=a.getProxy(A.MainContext.MainThreadQuickOpen);class n{constructor(D,C){this._sessions=new Map,this._instances=0,this._workspace=D,this._commands=C}showQuickPick(D,C,S,I=r.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(C),w=++this._instances,N=m.$show(w,{title:S?.title,placeHolder:S?.placeHolder,matchOnDescription:S?.matchOnDescription,matchOnDetail:S?.matchOnDetail,ignoreFocusLost:S?.ignoreFocusOut,canPickMany:S?.canPickMany},I),O={},U=N.then(()=>O);return Promise.race([U,b]).then(x=>{if(x===O)return;const B=(0,d.isProposedApiEnabled)(D,"quickPickItemTooltip");return b.then(F=>{const M=[];for(let K=0;K<F.length;K++){const ee=F[K];if(typeof ee=="string")M.push({label:ee,handle:K});else if(ee.kind===R.QuickPickItemKind.Separator)M.push({type:"separator",label:ee.label});else{ee.tooltip&&!B&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const $=ee.iconPath?h(ee.iconPath):void 0;M.push({label:ee.label,iconPath:$?.iconPath,iconClass:$?.iconClass,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:B?T.MarkdownString.fromStrict(ee.tooltip):void 0,handle:K})}}return S&&typeof S.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{S.onDidSelectItem(F[K])}),m.$setItems(w,M),N.then(K=>{if(typeof K=="number")return F[K];if(Array.isArray(K))return K.map(ee=>F[ee])})})}).then(void 0,x=>{if(!(0,v.isCancellationError)(x))return m.$setError(w,x),Promise.reject(x)})}$onItemSelected(D){this._onDidSelectItem?.(D)}showInput(D,C=r.CancellationToken.None){return this._validateInput=D?.validateInput,m.$input(D,typeof this._validateInput=="function",C).then(void 0,S=>{if(!(0,v.isCancellationError)(S))return Promise.reject(S)})}async $validateInput(D){if(!this._validateInput)return;const C=await this._validateInput(D);if(!C||typeof C=="string")return C;let S;switch(C.severity){case R.InputBoxValidationSeverity.Info:S=P.default.Info;break;case R.InputBoxValidationSeverity.Warning:S=P.default.Warning;break;case R.InputBoxValidationSeverity.Error:S=P.default.Error;break;default:S=C.message?P.default.Error:P.default.Ignore;break}return{content:C.message,severity:S}}async showWorkspaceFolderPick(D,C=r.CancellationToken.None){const S=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!S)return;const I=await this._workspace.getWorkspaceFolders2();if(I)return I.find(b=>b.uri.toString()===S.uri.toString())}createQuickPick(D){const C=new o(D,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}createInputBox(D){const C=new p(D,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}$onDidChangeValue(D,C){this._sessions.get(D)?._fireDidChangeValue(C)}$onDidAccept(D){this._sessions.get(D)?._fireDidAccept()}$onDidChangeActive(D,C){const S=this._sessions.get(D);S instanceof o&&S._fireDidChangeActive(C)}$onDidChangeSelection(D,C){const S=this._sessions.get(D);S instanceof o&&S._fireDidChangeSelection(C)}$onDidTriggerButton(D,C){this._sessions.get(D)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(D,C,S){const I=this._sessions.get(D);I instanceof o&&I._fireDidTriggerItemButton(C,S)}$onDidHide(D){this._sessions.get(D)?._fireDidHide()}}class s{static{this._nextId=1}constructor(D,C){this._extensionId=D,this._onDidDispose=C,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new g.Emitter,this._onDidChangeValueEmitter=new g.Emitter,this._onDidTriggerButtonEmitter=new g.Emitter,this._onDidHideEmitter=new g.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(D){this._title=D,this.update({title:D})}get step(){return this._steps}set step(D){this._steps=D,this.update({step:D})}get totalSteps(){return this._totalSteps}set totalSteps(D){this._totalSteps=D,this.update({totalSteps:D})}get enabled(){return this._enabled}set enabled(D){this._enabled=D,this.update({enabled:D})}get busy(){return this._busy}set busy(D){this._busy=D,this.update({busy:D})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(D){this._ignoreFocusOut=D,this.update({ignoreFocusOut:D})}get value(){return this._value}set value(D){this._value=D,this.update({value:D})}get placeholder(){return this._placeholder}set placeholder(D){this._placeholder=D,this.update({placeholder:D})}get buttons(){return this._buttons}set buttons(D){this._buttons=D.slice(),this._handlesToButtons.clear(),D.forEach((C,S)=>{const I=C===R.QuickInputButtons.Back?-1:S;this._handlesToButtons.set(I,C)}),this.update({buttons:D.map((C,S)=>({...h(C.iconPath),tooltip:C.tooltip,handle:C===R.QuickInputButtons.Back?-1:S}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(D){this._value=D,this._onDidChangeValueEmitter.fire(D)}_fireDidTriggerButton(D){const C=this._handlesToButtons.get(D);C&&this._onDidTriggerButtonEmitter.fire(C)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,k.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),m.$dispose(this._id))}update(D){if(!this._disposed){for(const C of Object.keys(D)){const S=D[C];this._pendingUpdate[C]=S===void 0?null:S}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){m.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function i(_){if(_ instanceof R.ThemeIcon)return{id:_.id};const D=c(_),C=t(_);return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof C=="string"?L.URI.file(C):C}}function t(_){return typeof _=="object"&&"light"in _?_.light:_}function c(_){return typeof _=="object"&&"dark"in _?_.dark:_}function h(_){const D=i(_);let C,S;return"id"in D?S=y.ThemeIcon.asClassName(D):C=D,{iconPath:C,iconClass:S}}class o extends s{constructor(D,C){super(D.identifier,C),this.extension=D,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new g.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new g.Emitter,this._onDidTriggerItemButtonEmitter=new g.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(D){this._items=D.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),D.forEach((I,b)=>{this._handlesToItems.set(b,I),this._itemsToHandles.set(I,b)});const C=(0,d.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),S=[];for(let I=0;I<D.length;I++){const b=D[I];if(b.kind===R.QuickPickItemKind.Separator)S.push({type:"separator",label:b.label});else{b.tooltip&&!C&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const w=b.iconPath?h(b.iconPath):void 0;S.push({handle:I,label:b.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:C?T.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((N,O)=>({...h(N.iconPath),tooltip:N.tooltip,handle:O}))})}}this.update({items:S})}get canSelectMany(){return this._canSelectMany}set canSelectMany(D){this._canSelectMany=D,this.update({canSelectMany:D})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(D){this._matchOnDescription=D,this.update({matchOnDescription:D})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(D){this._matchOnDetail=D,this.update({matchOnDetail:D})}get sortByLabel(){return this._sortByLabel}set sortByLabel(D){this._sortByLabel=D,this.update({sortByLabel:D})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(D){this._keepScrollPosition=D,this.update({keepScrollPosition:D})}get activeItems(){return this._activeItems}set activeItems(D){this._activeItems=D.filter(C=>this._itemsToHandles.has(C)),this.update({activeItems:this._activeItems.map(C=>this._itemsToHandles.get(C))})}get selectedItems(){return this._selectedItems}set selectedItems(D){this._selectedItems=D.filter(C=>this._itemsToHandles.has(C)),this.update({selectedItems:this._selectedItems.map(C=>this._itemsToHandles.get(C))})}_fireDidChangeActive(D){const C=(0,l.coalesce)(D.map(S=>this._handlesToItems.get(S)));this._activeItems=C,this._onDidChangeActiveEmitter.fire(C)}_fireDidChangeSelection(D){const C=(0,l.coalesce)(D.map(S=>this._handlesToItems.get(S)));this._selectedItems=C,this._onDidChangeSelectionEmitter.fire(C)}_fireDidTriggerItemButton(D,C){const S=this._handlesToItems.get(D);if(!S||!S.buttons||!S.buttons.length)return;const I=S.buttons[C];I&&this._onDidTriggerItemButtonEmitter.fire({button:I,item:S})}}class p extends s{constructor(D,C){super(D.identifier,C),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(D){this._password=D,this.update({password:D})}get prompt(){return this._prompt}set prompt(D){this._prompt=D,this.update({prompt:D})}get valueSelection(){return this._valueSelection}set valueSelection(D){this._valueSelection=D,this.update({valueSelection:D})}get validationMessage(){return this._validationMessage}set validationMessage(D){this._validationMessage=D,D?typeof D=="string"?this.update({validationMessage:D,severity:P.default.Error}):this.update({validationMessage:D.message,severity:D.severity??P.default.Error}):this.update({validationMessage:void 0,severity:P.default.Ignore})}}return new n(u,f)}}),define(we[363],ye([1,0,2,4,60,3,9,6,19,139,12,24,41,50,17,26,15,11]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function n(N){return N instanceof r.URI}function s(N,O){return N.scheme===u.Schemas.file&&O.scheme===u.Schemas.file&&f.isLinux?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function i(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||T.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function t(N){if(N.icon){if(r.URI.isUri(N.icon))return N.icon;if(T.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const O=N.icon;return{light:O.light,dark:O.dark}}}else return}function c(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const U=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,x=typeof O.iconPath=="string"?O.iconPath:r.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,l.comparePaths)(U,x)}function h(N,O){let U=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(U=c(N,O),U!==0)return U;if(N.light&&O.light)U=c(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(U!==0)return U;if(N.dark&&O.dark)U=c(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return U}function o(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let U=0;U<N.arguments.length;U++){const x=N.arguments[U],B=O.arguments[U];if(x!==B&&!(n(x)&&n(B)&&s(x,B)))return x<B?-1:1}return 0}function p(N,O){let U=(0,l.comparePaths)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(U!==0)return U;if(N.command&&O.command)U=o(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(U!==0)return U;if(N.decorations&&O.decorations)U=h(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)U=(0,l.comparePaths)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)U=(0,l.comparePaths)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return U}function _(N,O){for(let U=0;U<N.length;U++)if(N[U]!==O[U])return!1;return!0}function D(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?_(N.arguments,O.arguments):N.arguments===O.arguments)}function C(N,O){return(0,v.equals)(N,O,D)}class S{#e;#t;get value(){return this._value}set value(O){O=O??"",this._sequencer.queue(async()=>this.#e.$setInputBoxValue(this._sourceControlHandle,O)),this.updateValue(O)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(O){this._sequencer.queue(async()=>this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,O)),this._placeholder=O}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(O){if((0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=O,this._sequencer.queue(async()=>this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!O))}get enabled(){return this._enabled}set enabled(O){O=!!O,this._enabled!==O&&(this._enabled=O,this._sequencer.queue(async()=>this.#e.$setInputBoxEnablement(this._sourceControlHandle,O)))}get visible(){return this._visible}set visible(O){O=!!O,this._visible!==O&&(this._visible=O,this._sequencer.queue(async()=>this.#e.$setInputBoxVisibility(this._sourceControlHandle,O)))}get document(){return(0,a.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(O,U,x,B,F,M){this._extension=O,this._sequencer=B,this._sourceControlHandle=F,this._documentUri=M,this._value="",this._onDidChange=new g.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=U,this.#e=x}showValidationMessage(O,U){(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this._sequencer.queue(async()=>this.#e.$showValidationMessage(this._sourceControlHandle,O,U))}$onInputBoxValueChange(O){this.updateValue(O)}updateValue(O){this._value=O,this._onDidChange.fire(O)}}e.ExtHostSCMInputBox=S;class I{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(O){this._label=O,this._sequencer.queue(async()=>this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,O))}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(O){this._hideWhenEmpty=O,this._sequencer.queue(async()=>this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features))}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(O){this._resourceStates=[...O],this._onDidUpdateResourceStates.fire()}constructor(O,U,x,B,F,M,K,ee){this._proxy=O,this._commands=U,this._sequencer=x,this._sourceControlHandle=B,this._id=F,this._label=M,this.multiDiffEditorEnableViewChanges=K,this._extension=ee,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new g.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new g.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=I._handlePool++}getResourceState(O){return this._resourceStatesMap.get(O)}$executeResourceCommand(O,U){const x=this._resourceStatesCommandsMap.get(O);return x?(0,L.asPromise)(()=>this._commands.executeCommand(x.command,...x.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this._resourceStates].sort(p),x=(0,v.sortedDiff)(this._resourceSnapshot,O,p).map(M=>{const K=M.toInsert.map(ee=>{const $=this._resourceHandlePool++;this._resourceStatesMap.set($,ee);const q=ee.resourceUri;let Z;if(ee.command)if(ee.command.command==="vscode.open"||ee.command.command==="vscode.diff"||ee.command.command==="vscode.changes"){const Y=new A.DisposableStore;Z=this._commands.converter.toInternal(ee.command,Y),this._resourceStatesDisposablesMap.set($,Y)}else this._resourceStatesCommandsMap.set($,ee.command);const ne=(0,a.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),de=ne?ee.multiDiffEditorOriginalUri:void 0,re=ne?ee.multiFileDiffEditorModifiedUri:void 0,Se=i(ee.decorations),ve=ee.decorations&&i(ee.decorations.light)||Se,G=ee.decorations&&i(ee.decorations.dark)||Se,W=[ve,G],se=ee.decorations&&ee.decorations.tooltip||"",ae=ee.decorations&&!!ee.decorations.strikeThrough,ie=ee.decorations&&!!ee.decorations.faded,le=ee.contextValue||"";return{rawResource:[$,q,W,se,ae,ie,le,Z,de,re],handle:$}});return{start:M.start,deleteCount:M.deleteCount,toInsert:K}}),B=x.map(({start:M,deleteCount:K,toInsert:ee})=>[M,K,ee.map($=>$.rawResource)]),F=x.reverse();for(const{start:M,deleteCount:K,toInsert:ee}of F){const $=ee.map(Z=>Z.handle),q=this._handlesSnapshot.splice(M,K,...$);for(const Z of q)this._resourceStatesMap.delete(Z),this._resourceStatesCommandsMap.delete(Z),this._resourceStatesDisposablesMap.get(Z)?.dispose(),this._resourceStatesDisposablesMap.delete(Z)}return this._resourceSnapshot=O,B}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class b{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(O){this._count!==O&&(this._count=O,this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{count:O})))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(O){this._quickDiffProvider=O;let U;(0,a.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(U=O?.label),this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!O,quickDiffLabel:U}))}get historyProvider(){return(0,a.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(O){(0,a.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=O,this._historyProviderDisposable.value=new A.DisposableStore,this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!O})),O&&this._historyProviderDisposable.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=O?.currentHistoryItemGroup,this._sequencer.queue(async()=>this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup))}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(O){O!==this._commitTemplate&&(this._commitTemplate=O,this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{commitTemplate:O})))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(O){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=O;const U=this._commands.converter.toInternal(O,this._acceptInputDisposables.value);this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{acceptInputCommand:U}))}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(O){(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=O;const U=O!==void 0?{command:this._commands.converter.toInternal(O.command,this._actionButtonDisposables.value),secondaryCommands:O.secondaryCommands?.map(x=>x.map(B=>this._commands.converter.toInternal(B,this._actionButtonDisposables.value))),description:O.description,enabled:O.enabled}:void 0;this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{actionButton:U??null}))}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(O){if(this._statusBarCommands&&O&&C(this._statusBarCommands,O))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=O;const U=(O||[]).map(x=>this._commands.converter.toInternal(x,this._statusBarDisposables.value));this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{statusBarCommands:U}))}get selected(){return this._selected}constructor(O,U,x,B,F,M,K){this._extension=O,this._commands=B,this._id=F,this._label=M,this._rootUri=K,this._sequencer=new L.Sequencer,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new A.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new g.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=b._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=x;const ee=r.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${F}/scm${this.handle}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this._sequencer.queue(()=>this.#e.$registerSourceControl(this.handle,F,M,K,ee)),this._inputBox=new S(O,U,this.#e,this._sequencer,this.handle,ee)}createResourceGroup(O,U,x){const B=(0,a.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&x?.multiDiffEditorEnableViewChanges===!0,F=new I(this.#e,this._commands,this._sequencer,this.handle,O,U,B,this._extension),M=g.Event.once(F.onDidDispose)(()=>this.createdResourceGroups.delete(F));return this.createdResourceGroups.set(F,M),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const O=[],U=[];for(const[x,B]of this.createdResourceGroups){B.dispose();const F=x.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(x),this.eventuallyUpdateResourceStates()});g.Event.once(x.onDidDispose)(()=>{this.updatedResourceGroups.delete(x),F.dispose(),this._groups.delete(x.handle),this._sequencer.queue(async()=>this.#e.$unregisterGroup(this.handle,x.handle))}),O.push([x.handle,x.id,x.label,x.features,x.multiDiffEditorEnableViewChanges]);const M=x._takeResourceStateSnapshot();M.length>0&&U.push([x.handle,M]),this._groups.set(x.handle,x)}this._sequencer.queue(async()=>this.#e.$registerGroups(this.handle,O,U)),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const O=[];this.updatedResourceGroups.forEach(U=>{const x=U._takeResourceStateSnapshot();x.length!==0&&O.push([U.handle,x])}),O.length>0&&this._sequencer.queue(async()=>this.#e.$spliceResourceStates(this.handle,O)),this.updatedResourceGroups.clear()}getResourceGroup(O){return this._groups.get(O)}setSelectionState(O){this._selected=O,this._onDidChangeSelection.fire(O)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(O=>O.dispose()),this._sequencer.queue(async()=>this.#e.$unregisterSourceControl(this.handle))}}Ke([(0,k.debounce)(100)],b.prototype,"eventuallyAddResourceGroups",null),Ke([(0,k.debounce)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{m=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(O,U,x,B){this._commands=U,this._extHostDocuments=x,this.logService=B,this._sourceControls=new Map,this._sourceControlsByExtension=new y.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new g.Emitter,this._proxy=O.getProxy(R.MainContext.MainThreadSCM),this._telemetry=O.getProxy(R.MainContext.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===d.MarshalledId.ScmResource){const M=this._sourceControls.get(F.sourceControlHandle);if(!M)return F;const K=M.getResourceGroup(F.groupHandle);return K?K.getResourceState(F.handle):F}else if(F&&F.$mid===d.MarshalledId.ScmResourceGroup){const M=this._sourceControls.get(F.sourceControlHandle);return M?M.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===d.MarshalledId.ScmProvider){const M=this._sourceControls.get(F.handle);return M||F}return F}})}createSourceControl(O,U,x,B){this.logService.trace("ExtHostSCM#createSourceControl",O.identifier.value,U,x,B),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const F=m._handlePool++,M=new b(O,this._extHostDocuments,this._proxy,this._commands,U,x,B);this._sourceControls.set(F,M);const K=this._sourceControlsByExtension.get(O.identifier)||[];return K.push(M),this._sourceControlsByExtension.set(O.identifier,K),M}getLastInputBox(O){this.logService.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const U=this._sourceControlsByExtension.get(O.identifier),x=U&&U[U.length-1];return x&&x.inputBox}$provideOriginalResource(O,U,x){const B=r.URI.revive(U);this.logService.trace("ExtHostSCM#$provideOriginalResource",O,B.toString());const F=this._sourceControls.get(O);return!F||!F.quickDiffProvider||!F.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.asPromise)(()=>F.quickDiffProvider.provideOriginalResource(B,x)).then(M=>M||null)}$onInputBoxValueChange(O,U){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",O);const x=this._sourceControls.get(O);return x&&x.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(O,U,x,B){this.logService.trace("ExtHostSCM#$executeResourceCommand",O,U,x);const F=this._sourceControls.get(O);if(!F)return Promise.resolve(void 0);const M=F.getResourceGroup(U);return M?M.$executeResourceCommand(x,B):Promise.resolve(void 0)}$validateInput(O,U,x){this.logService.trace("ExtHostSCM#$validateInput",O);const B=this._sourceControls.get(O);return!B||!B.inputBox.validateInput?Promise.resolve(void 0):(0,L.asPromise)(()=>B.inputBox.validateInput(U,x)).then(F=>{if(!F)return Promise.resolve(void 0);const M=E.MarkdownString.fromStrict(F.message);return M?Promise.resolve([M,F.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this._sourceControls.get(O)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,U,x,B){return await this._sourceControls.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,x,B)??void 0}async $provideHistoryItems(O,U,x,B){return(await this._sourceControls.get(O)?.historyProvider?.provideHistoryItems(U,x,B))?.map(K=>({...K,icon:t(K)}))??void 0}async $provideHistoryItemSummary(O,U,x,B){const F=this._sourceControls.get(O)?.historyProvider;if(typeof F?.provideHistoryItemSummary!="function")return;const M=await F.provideHistoryItemSummary(U,x,B);return M?{...M,icon:t(M)}:void 0}async $provideHistoryItemChanges(O,U,x,B){return await this._sourceControls.get(O)?.historyProvider?.provideHistoryItemChanges(U,x,B)??void 0}};e.ExtHostSCM=w,e.ExtHostSCM=w=m=Ke([Ve(3,P.ILogService)],w)}),define(we[364],ye([1,0,6,17,2]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class A{static{this.handlePool=0}constructor(R,v){this.uriTransformer=v,this.providers=new Map,this.proxy=R.getProxy(r.MainContext.MainThreadShare)}async $provideShare(R,v,l){return await this.providers.get(R)?.provideShare({selection:g.Range.to(v.selection),resourceUri:k.URI.revive(v.resourceUri)},l)??void 0}registerShareProvider(R,v){const l=A.handlePool++;return this.providers.set(l,v),this.proxy.$registerShareProvider(l,g.DocumentSelector.from(R,this.uriTransformer),v.id,v.label,v.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(l),this.providers.delete(l)}}}}e.ExtHostShare=A}),define(we[365],ye([1,0,10,6,238,3,17,18]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class v{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(d,T,E,a,u,f=r.StatusBarAlignment.Left,m){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new A.DisposableStore,this.#e=d,this.#t=T,u&&a){this._entryId=(0,r.asStatusBarItemIdentifier)(a.identifier,u);const n=E.get(this._entryId);n&&(f=n.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,m=n.priority,this._visible=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this._entryId=String(v.ID_GEN++);this._extension=a,this._id=u,this._alignment=f,this._priority=this.validatePriority(m)}validatePriority(d){if((0,R.isNumber)(d))return d===Number.POSITIVE_INFINITY?Number.MAX_VALUE:d===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:d}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!v.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new A.DisposableStore,typeof d=="string"?this._command={fromApi:d,internal:this.#t.toInternal({title:"",command:d},this._latestCommandRegistration)}:d?this._command={fromApi:d,internal:this.#t.toInternal(d,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let T;this._name?T=this._name:T=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=v.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const a=L.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,d,this._extension?.identifier.value,T,this._text,a,this._command?.internal,E,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=v;class l{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const T={message:d};return this._messages.unshift(T),this._update(),new r.Disposable(()=>{const E=this._messages.indexOf(T);E>=0&&(this._messages.splice(E,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(d,T){this._existingItems=new Map,this._proxy=d.getProxy(g.MainContext.MainThreadStatusBar),this._commands=T,this._statusMessage=new l(this)}$acceptStaticEntries(d){for(const T of d)this._existingItems.set(T.entryId,T)}createStatusBarEntry(d,T,E,a){return new v(this._proxy,this._commands,this._existingItems,d,T,E,a)}setStatusBarMessage(d,T){const E=this._statusMessage.setMessage(d);let a;return typeof T=="number"?a=setTimeout(()=>E.dispose(),T):typeof T<"u"&&T.then(()=>E.dispose(),()=>E.dispose()),new r.Disposable(()=>{E.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=P}),define(we[164],ye([1,0,31,153,73,120,74,17,2]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const l=(n,s,i,t)=>{let c=s;return{enumerable:!0,configurable:!1,get(){return c},set(h){if(!i(c,h)){const o=c;c=h,n.listener?.(t(h,o))}}}},P=(n,s)=>n===s,y={range:(n,s)=>n===s?!0:!n||!s?!1:n.isEqual(s),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(n,s)=>!(n.length!==s.length||n.some(i=>!s.find(t=>i.id===t.id)))},d=n=>s=>({op:A.TestItemEventOp.SetProp,update:n(s)}),T=(n,s)=>({range:(()=>{let i;const t=d(c=>({range:r.Range.lift(R.Range.from(c))}));return{enumerable:!0,configurable:!1,get(){return i},set(c){n.listener?.({op:A.TestItemEventOp.DocumentSynced}),y.range(i,c)||(i=c,n.listener?.(t(c)))}}})(),label:l(n,s,y.label,d(i=>({label:i}))),description:l(n,void 0,y.description,d(i=>({description:i}))),sortText:l(n,void 0,y.sortText,d(i=>({sortText:i}))),canResolveChildren:l(n,!1,y.canResolveChildren,i=>({op:A.TestItemEventOp.UpdateCanResolveChildren,state:i})),busy:l(n,!1,y.busy,d(i=>({busy:i}))),error:l(n,void 0,y.error,d(i=>({error:R.MarkdownString.fromStrict(i)||null}))),tags:l(n,[],y.tags,(i,t)=>({op:A.TestItemEventOp.SetTags,new:i.map(R.TestTag.from),old:t.map(R.TestTag.from)}))}),E=n=>{const s=k.TestId.fromString(n.extId),i=new u(s.controllerId,s.localId,n.label,v.URI.revive(n.uri)||void 0);return i.range=R.Range.to(n.range||void 0),i.description=n.description||void 0,i.sortText=n.sortText||void 0,i.tags=n.tags.map(t=>R.TestTag.to({id:(0,L.denamespaceTestTag)(t).tagId})),i},a=n=>{let s;for(const i of n.tests){const t=E(i.item);(0,g.getPrivateApiFor)(t).parent=s,s=t}return s};e.toItemFromContext=a;class u{constructor(s,i,t,c){if(i.includes(k.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(i)} symbol`);const h=(0,g.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:i,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof f?void 0:h.parent}},children:{value:(0,A.createTestItemChildren)(h,g.getPrivateApiFor,u),enumerable:!0,writable:!1},...T(h,t)})}}e.TestItemImpl=u;class f extends u{constructor(s,i){super(s,s,i,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class m extends A.TestItemCollection{constructor(s,i,t){super({controllerId:s,getDocumentVersion:c=>c&&t.getDocument(c)?.version,getApiFor:g.getPrivateApiFor,getChildren:c=>c.children,root:new f(s,i),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=m}),define(we[37],ye([1,0,18,10,17,25,6,19,12,57,31,54,2,3,5,20,164,22,52,51,42,92,95,32]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let h=class{#e;#t;#i;constructor(S,I,b){this._commands=new Map,this._apiCommands=new Map,this.#e=S.getProxy(L.MainContext.MainThreadCommands),this._logService=I,this.#i=b,this.#t=S.getProxy(L.MainContext.MainThreadTelemetry),this.converter=new o(this,w=>{const N=this._apiCommands.get(w);return N?.result===_.Void?N:void 0},I),this._argumentProcessors=[{processArgument(w){return(0,l.revive)(w)}},{processArgument(w){return(0,A.cloneAndChange)(w,function(N){if(P.Range.isIRange(N))return k.Range.to(N);if(y.Position.isIPosition(N))return k.Position.to(N);if(P.Range.isIRange(N.range)&&d.URI.isUri(N.uri))return k.location.to(N);if(N instanceof f.VSBuffer)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(S){this._argumentProcessors.push(S)}registerApiCommand(S){const I=this.registerCommand(!1,S.id,async(...b)=>{const w=S.args.map((O,U)=>{if(!O.validate(b[U]))throw new Error(`Invalid argument '${O.name}' when running '${S.id}', received: ${typeof b[U]=="object"?JSON.stringify(b[U],null,"	"):b[U]} `);return O.convert(b[U])}),N=await this.executeCommand(S.internalId,...w);return S.result.convert(N,b,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this._apiCommands.set(S.id,S),new g.Disposable(()=>{I.dispose(),this._apiCommands.delete(S.id)})}registerCommand(S,I,b,w,N,O){if(this._logService.trace("ExtHostCommands#registerCommand",I),!I.trim().length)throw new Error("invalid id");if(this._commands.has(I))throw new Error(`command '${I}' already exists`);return this._commands.set(I,{callback:b,thisArg:w,metadata:N,extension:O}),S&&this.#e.$registerCommand(I),new g.Disposable(()=>{this._commands.delete(I)&&S&&this.#e.$unregisterCommand(I)})}executeCommand(S,...I){return this._logService.trace("ExtHostCommands#executeCommand",S),this._doExecuteCommand(S,I,!0)}async _doExecuteCommand(S,I,b){if(this._commands.has(S))return this.#e.$fireCommandActivationEvent(S),this._executeContributedCommand(S,I,!1);{let w=!1;const N=(0,A.cloneAndChange)(I,function(O){if(O instanceof g.Position)return k.Position.from(O);if(O instanceof g.Range)return k.Range.from(O);if(O instanceof g.Location)return k.location.from(O);if(g.NotebookRange.isNotebookRange(O))return k.NotebookRange.from(O);if(O instanceof ArrayBuffer)return w=!0,f.VSBuffer.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return w=!0,f.VSBuffer.wrap(O);if(O instanceof f.VSBuffer)return w=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(S,w?new m.SerializableObjectWithBuffers(N):N,b);return(0,l.revive)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this._doExecuteCommand(S,I,!1);throw O}}}async _executeContributedCommand(S,I,b){const w=this._commands.get(S);if(!w)throw new Error("Unknown command");const{callback:N,thisArg:O,metadata:U}=w;if(U?.args)for(let B=0;B<U.args.length;B++)try{(0,r.validateConstraint)(I[B],U.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${U.args[B].name}' - ${U.args[B].description}`)}const x=s.StopWatch.create();try{return await N.apply(O,I)}catch(B){if(S===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...I);F&&(S=F.command)}if(this._logService.error(B,S,w.extension?.identifier),!b)throw B;if(w.extension?.identifier){const F=this.#i.onExtensionError(w.extension.identifier,B);this._logService.trace("forwarded error to extension?",F,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.toErrorMessage)(B)),this.id=S,this.source=w.extension?.displayName??w.extension?.name}}}finally{this._reportTelemetry(w,S,x.elapsed())}}_reportTelemetry(S,I,b){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new i.TelemetryTrustedValue(I),duration:b})}$executeContributedCommand(S,...I){this._logService.trace("ExtHostCommands#$executeContributedCommand",S);const b=this._commands.get(S);return b?(I=I.map(w=>this._argumentProcessors.reduce((N,O)=>O.processArgument(N,b.extension?.identifier),w)),this._executeContributedCommand(S,I,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this._logService.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(I=>(S&&(I=I.filter(b=>b[0]!=="_")),I))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[I,b]of this._commands){const{metadata:w}=b;w&&(S[I]=w)}return Promise.resolve(S)}};e.ExtHostCommands=h,e.ExtHostCommands=h=Ke([Ve(0,a.IExtHostRpcService),Ve(1,v.ILogService),Ve(2,t.IExtHostTelemetry)],h),e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class o{constructor(S,I,b){this._commands=S,this._lookupApiCommand=I,this._logService=b,this.delegatingCommandId=`__vsc${(0,c.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(S,I){if(!S)return;const b={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return b;const w=this._lookupApiCommand(S.command);if(w)b.id=w.internalId,b.arguments=w.args.map((N,O)=>N.convert(S.arguments&&S.arguments[O]));else if((0,R.isNonEmptyArray)(S.arguments)){const N=`${S.command} /${++this._cachIdPool}`;this._cache.set(N,S),I.add((0,T.toDisposable)(()=>{this._cache.delete(N),this._logService.trace("CommandsConverter#DISPOSE",N)})),b.$ident=N,b.id=this.delegatingCommandId,b.arguments=[N],this._logService.trace("CommandsConverter#CREATE",S.command,N)}return b}fromInternal(S){return typeof S.$ident=="string"?this._cache.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this._cache.get(S[0])}_executeConvertedCommand(...S){const I=this.getActualCommand(...S);return this._logService.trace("CommandsConverter#EXECUTE",S[0],I?I.command:"MISSING"),I?this._commands.executeCommand(I.command,...I.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.CommandsConverter=o;class p{static{this.Uri=new p("uri","Uri of a text document",S=>d.URI.isUri(S),S=>S)}static{this.Position=new p("position","A position in a text document",S=>g.Position.isPosition(S),k.Position.from)}static{this.Range=new p("range","A range in a text document",S=>g.Range.isRange(S),k.Range.from)}static{this.Selection=new p("selection","A selection in a text document",S=>g.Selection.isSelection(S),k.Selection.from)}static{this.Number=new p("number","",S=>typeof S=="number",S=>S)}static{this.String=new p("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=p.Arr(p.String)}static Arr(S){return new p(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,I=>Array.isArray(I)&&I.every(b=>S.validate(b)),I=>I.map(b=>S.convert(b)))}static{this.CallHierarchyItem=new p("item","A call hierarchy item",S=>S instanceof g.CallHierarchyItem,k.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new p("item","A type hierarchy item",S=>S instanceof g.TypeHierarchyItem,k.TypeHierarchyItem.from)}static{this.TestItem=new p("testItem","A VSCodium TestItem",S=>S instanceof u.TestItemImpl,k.TestItem.from)}constructor(S,I,b,w){this.name=S,this.description=I,this.validate=b,this.convert=w}optional(){return new p(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,I){return new p(S??this.name,I??this.description,this.validate,this.convert)}}e.ApiCommandArgument=p;class _{static{this.Void=new _("no result",S=>S)}constructor(S,I){this.description=S,this.convert=I}}e.ApiCommandResult=_;class D{constructor(S,I,b,w,N){this.id=S,this.internalId=I,this.description=b,this.args=w,this.result=N}}e.ApiCommand=D}),define(we[366],ye([1,0,19,15,2,88,142,35,37,17,10]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new v.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(l.DocumentHighlight.to))),new v.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,u)=>{if((0,r.isFalsyOrEmpty)(a))return;class f extends P.SymbolInformation{static to(n){const s=new f(n.name,l.SymbolKind.to(n.kind),n.containerName||"",new P.Location(u[0],l.Range.to(n.range)));return s.detail=n.detail,s.range=s.location.range,s.selectionRange=l.Range.to(n.selectionRange),s.children=n.children?n.children.map(f.to):[],s}}return a.map(f.to)})),new v.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(l.TextEdit.to))),new v.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(l.TextEdit.to))),new v.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,new v.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new v.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(l.TextEdit.to))),new v.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(l.location.to))),new v.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(l.Hover.to))),new v.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(u=>P.Position.isPosition(u)),a=>a.map(l.Position.from))],new v.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(u=>{let f;for(const m of u.reverse())f=new P.SelectionRange(l.Range.to(m),f);return f}))),new v.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.ApiCommandArgument.String.with("query","Search string")],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(l.WorkspaceSymbol.to))),new v.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(l.CallHierarchyItem.to))),new v.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(l.CallHierarchyIncomingCall.to))),new v.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(l.CallHierarchyOutgoingCall.to))),new v.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:l.Range.to(a.range),placeholder:a.text}})),new v.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("newName","The new symbol name")],new v.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return l.WorkspaceEdit.to(a)}})),new v.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(l.DocumentLink.to))),new v.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new P.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const u=(0,L.decodeSemanticTokensDto)(a);if(u.type==="full")return new P.SemanticTokens(u.data,void 0)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range.optional()],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new P.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const u=(0,L.decodeSemanticTokensDto)(a);if(u.type==="full")return new P.SemanticTokens(u.data,void 0)})),new v.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,u,f)=>{if(!a)return new P.CompletionList([]);const m=a.suggestions.map(n=>l.CompletionItem.to(n,f));return new P.CompletionList(m,a.incomplete)})),new v.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return l.SignatureHelp.to(a)})),new v.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,u,f)=>T(m=>new P.CodeLens(l.Range.to(m.range),m.command&&f.fromInternal(m.command)))(a))),new v.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>P.Range.isRange(a),a=>P.Selection.isSelection(a)?l.Selection.from(a):l.Range.from(a)),v.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,u,f)=>T(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(m.command)}else{const n=new P.CodeAction(m.title,m.kind?new P.CodeActionKind(m.kind):void 0);return m.edit&&(n.edit=l.WorkspaceEdit.to(m.edit)),m.command&&(n.command=f.fromInternal(m.command)),n.isPreferred=m.isPreferred,n}})(a))),new v.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(u=>new P.ColorInformation(l.Range.to(u.range),l.Color.to(u.color))):[])),new v.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.ApiCommandArgument("color","The color to show and insert",a=>a instanceof P.Color,l.Color.from),new v.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:l.Range.from(a.range)}))],new v.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(l.ColorPresentation.to):[])),new v.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,u,f)=>a.map(l.InlayHint.to.bind(void 0,f)))),new v.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(a,u)=>{if(a)return a.map(l.FoldingRange.to)})),new v.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(u=>l.NotebookExclusiveDocumentPattern.to(u))})))),new v.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof P.Range,a=>l.InlineValueContext.from(a))],new v.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(l.InlineValue.to))),new v.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>k.URI.isUri(a)||typeof a=="string"&&(0,g.matchesSomeScheme)(a,g.Schemas.http,g.Schemas.https),a=>a),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[l.ViewColumn.from(a),void 0]:[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)])).optional(),v.ApiCommandArgument.String.with("label","").optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.ApiCommandArgument.Uri.with("resource","Resource to open"),v.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[l.ViewColumn.from(a),void 0]:[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)])).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),v.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),v.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)]).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[v.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new v.ApiCommandArgument("resourceList","List of resources to compare",a=>{for(const u of a){if(u.length!==3)return!1;const[f,m,n]=u;if(!k.URI.isUri(f)||!k.URI.isUri(m)&&m!==void 0&&m!==null||!k.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},a=>a)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.ApiCommandArgument.TestItem],v.ApiCommandResult.Void),new v.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.ApiCommandResult.Void),new v.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.ApiCommandArgument.String.with("name","The context key name"),new v.ApiCommandArgument("value","The context key value",()=>!0,a=>a)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.StringArray,new v.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",a=>l.MappedEditsContext.is(a),a=>l.MappedEditsContext.from(a))],new v.ApiCommandResult("A promise that resolves to a workspace edit or null",a=>a?l.WorkspaceEdit.to(a):null)),new v.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new v.ApiCommandArgument("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?l.Range.from(a.initialRange):void 0,initialSelection:P.Selection.isSelection(a.initialSelection)?l.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?l.Position.from(a.position):void 0}})],v.ApiCommandResult.Void)];class d{static register(u){y.forEach(u.registerApiCommand,u),this._registerValidateWhenClausesCommand(u)}static _registerValidateWhenClausesCommand(u){u.registerCommand(!1,"_validateWhenClauses",R.validateWhenClauses)}}e.ExtHostApiCommands=d;function T(a){return u=>{if(Array.isArray(u))return u.map(a)}}function E(a){if(!Array.isArray(a))return;const u=[];for(const f of a)A.isLocationLink(f)?u.push(l.DefinitionLink.to(f)):u.push(l.location.to(f));return u}}),define(we[367],ye([1,0,2,37]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(L,R,v,l,P){this._extHostNotebooks=R,this._textDocumentsAndEditors=v,this._commands=l;const y=new g.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new g.ApiCommandArgument("showOptions","Show Options",d=>!0,d=>d),new g.ApiCommandArgument("resource","Interactive resource Uri",d=>!0,d=>d),new g.ApiCommandArgument("controllerId","Notebook controller Id",d=>!0,d=>d),new g.ApiCommandArgument("title","Interactive editor title",d=>!0,d=>d)],new g.ApiCommandResult("Notebook and input URI",d=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",d.notebookEditorId),d.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(d.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:r.URI.revive(d.notebookUri),inputUri:r.URI.revive(d.inputUri),notebookEditor:T.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",d.notebookUri,d.inputUri),{notebookUri:r.URI.revive(d.notebookUri),inputUri:r.URI.revive(d.inputUri)}}));this._commands.registerApiCommand(y)}$willAddInteractiveDocument(L,R,v,l){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:v,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.ExtHostInteractive=k}),define(we[368],ye([1,0,19,9,21,4,3,29,2,24,12,6,37,17,10,121,310,26,52,311]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=p;let s=class{constructor(D,C,S,I,b){this._initData=C,this._extHostNotebook=S,this._commands=I,this._logService=b,this._activeExecutions=new R.ResourceMap,this._activeNotebookExecutions=new R.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=D.getProxy(y.MainContext.MainThreadNotebookKernels);const w=new d.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new d.ApiCommandArgument("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const U=this._extHostNotebook.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:U}}else if(O&&"notebookEditor"in O){const U=this._extHostNotebook.getIdByEditor(O.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return O})],d.ApiCommandResult.Void),N=new d.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[d.ApiCommandArgument.Uri],new d.ApiCommandResult("A promise that resolves to an array of variables",(O,U)=>O.map(x=>({variable:{name:x.name,value:x.value,expression:x.expression,type:x.type,language:x.language},hasNamedChildren:x.hasNamedChildren,indexedChildrenCount:x.indexedChildrenCount}))));this._commands.registerApiCommand(w),this._commands.registerApiCommand(N)}createNotebookController(D,C,S,I,b,w){for(const re of this._kernelData.values())if(re.controller.id===C&&l.ExtensionIdentifier.equals(D.identifier,re.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const N=this._handlePool++,O=this;this._logService.trace(`NotebookController[${N}], CREATED by ${D.identifier.value}, ${C}`);const U=()=>console.warn(`NO execute handler from notebook controller '${M.id}' of extension: '${D.identifier}'`);let x=!1;const B=new A.Emitter,F=new A.Emitter,M={id:p(D.identifier,C),notebookType:S,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:I||D.identifier.value,preloads:w?w.map(T.NotebookRendererScript.from):[]};let K=b??U,ee,$;this._proxy.$addKernel(N,M).catch(re=>{console.log(re),x=!0});let q=0;const Z=()=>{if(x)return;const re=++q;Promise.resolve().then(()=>{re===q&&this._proxy.$updateKernel(N,M)})},ne=new R.ResourceMap,de={get id(){return C},get notebookType(){return M.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return M.label},set label(re){M.label=re??D.displayName??D.name,Z()},get detail(){return M.detail??""},set detail(re){M.detail=re,Z()},get description(){return M.description??""},set description(re){M.description=re,Z()},get supportedLanguages(){return M.supportedLanguages},set supportedLanguages(re){M.supportedLanguages=re,Z()},get supportsExecutionOrder(){return M.supportsExecutionOrder??!1},set supportsExecutionOrder(re){M.supportsExecutionOrder=re,Z()},get rendererScripts(){return M.preloads?M.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(re){K=re??U},get interruptHandler(){return ee},set interruptHandler(re){ee=re,M.supportsInterrupt=!!re,Z()},set variableProvider(re){(0,f.checkProposedApiEnabled)(D,"notebookVariableProvider"),$=re,M.hasVariableProvider=!!re,re?.onDidChangeVariables(Se=>O._proxy.$variablesUpdated(Se.uri)),Z()},get variableProvider(){return $},createNotebookCellExecution(re){if(x)throw new Error("notebook controller is DISPOSED");if(!ne.has(re.notebook.uri))throw O._logService.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return O._createNotebookCellExecution(re,p(D.identifier,this.id))},createNotebookExecution(re){if((0,f.checkProposedApiEnabled)(D,"notebookExecution"),x)throw new Error("notebook controller is DISPOSED");if(!ne.has(re.uri))throw O._logService.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return O._createNotebookExecution(re,p(D.identifier,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${N}], DISPOSED`),x=!0,this._kernelData.delete(N),B.dispose(),F.dispose(),this._proxy.$removeKernel(N))},updateNotebookAffinity(re,Se){Se===E.NotebookControllerAffinity2.Hidden&&(0,f.checkProposedApiEnabled)(D,"notebookControllerAffinityHidden"),O._proxy.$updateNotebookPriority(N,re.uri,Se)},onDidReceiveMessage:F.event,postMessage(re,Se){return(0,f.checkProposedApiEnabled)(D,"notebookMessaging"),O._proxy.$postMessage(N,Se&&O._extHostNotebook.getIdByEditor(Se),re)},asWebviewUri(re){return(0,f.checkProposedApiEnabled)(D,"notebookMessaging"),(0,a.asWebviewUri)(re,O._initData.remote)}};return this._kernelData.set(N,{extensionId:D.identifier,controller:de,onDidReceiveMessage:F,onDidChangeSelection:B,associatedNotebooks:ne}),de}getIdByController(D){for(const[C,S]of this._kernelData)if(S.controller===D)return p(S.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,C){const S=this._kernelDetectionTaskHandlePool++,I=this;this._logService.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${D.identifier.value}`),this._proxy.$addKernelDetectionTask(S,C);const b={dispose:()=>{this._kernelDetectionTask.delete(S),I._proxy.$removeKernelDetectionTask(S)}};return this._kernelDetectionTask.set(S,b),b}registerKernelSourceActionProvider(D,C,S){const I=this._kernelSourceActionProviderHandlePool++,b=typeof S.onDidChangeNotebookKernelSourceActions=="function"?I:void 0,w=this;this._kernelSourceActionProviders.set(I,S),this._logService.trace(`NotebookKernelSourceActionProvider[${I}], CREATED by ${D.identifier.value}`),this._proxy.$addKernelSourceActionProvider(I,I,C);let N;return b!==void 0&&(N=S.onDidChangeNotebookKernelSourceActions(O=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this._kernelSourceActionProviders.delete(I),w._proxy.$removeKernelSourceActionProvider(I,I),N?.dispose()}}}async $provideKernelSourceActions(D,C){const S=this._kernelSourceActionProviders.get(D);if(S){const I=new L.DisposableStore;return(await S.provideNotebookKernelSourceActions(C)??[]).map(w=>T.NotebookKernelSourceAction.from(w,this._commands.converter,I))}return[]}$acceptNotebookAssociation(D,C,S){const I=this._kernelData.get(D);if(I){const b=this._extHostNotebook.getNotebookDocument(v.URI.revive(C));S?I.associatedNotebooks.set(b.uri,!0):I.associatedNotebooks.delete(b.uri),this._logService.trace(`NotebookController[${D}] ASSOCIATE notebook`,b.uri.toString(),S),I.onDidChangeSelection.fire({selected:S,notebook:b.apiNotebook})}}async $executeCells(D,C,S){const I=this._kernelData.get(D);if(!I)return;const b=this._extHostNotebook.getNotebookDocument(v.URI.revive(C)),w=[];for(const N of S){const O=b.getCell(N);O&&w.push(O.apiCell)}try{this._logService.trace(`NotebookController[${D}] EXECUTE cells`,b.uri.toString(),w.length),await I.controller.executeHandler.call(I.controller,w,b.apiNotebook,I.controller)}catch(N){this._logService.error(`NotebookController[${D}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(D,C,S){const I=this._kernelData.get(D);if(!I)return;const b=this._extHostNotebook.getNotebookDocument(v.URI.revive(C));if(I.controller.interruptHandler)await I.controller.interruptHandler.call(I.controller,b.apiNotebook);else for(const w of S){const N=b.getCell(w);N&&this._activeExecutions.get(N.uri)?.cancel()}if(I.controller.interruptHandler){const w=this._activeNotebookExecutions.get(b.uri);this._activeNotebookExecutions.delete(b.uri),S.length&&Array.isArray(w)&&w.length&&w.forEach(N=>N.dispose())}}async $provideVariables(D,C,S,I,b,w,N){const O=this._kernelData.get(D);if(!O)return;const U=this._extHostNotebook.getNotebookDocument(v.URI.revive(S)),x=O.controller.variableProvider;if(!x)return;let B;if(I!==void 0){if(B=this.variableStore[I],!B)return}else this.variableStore={};const F=b==="named"?E.NotebookVariablesRequestKind.Named:E.NotebookVariablesRequestKind.Indexed,M=x.provideVariables(U.apiNotebook,B,F,w,N);let K=0;for await(const ee of M){if(N.isCancellationRequested)return;const $={id:this.id++,name:ee.variable.name,value:ee.variable.value,type:ee.variable.type,interfaces:ee.variable.interfaces,language:ee.variable.language,expression:ee.variable.expression,hasNamedChildren:ee.hasNamedChildren,indexedChildrenCount:ee.indexedChildrenCount,extensionId:O.extensionId.value};if(this.variableStore[$.id]=ee.variable,this._proxy.$receiveVariable(C,$),K++>=n.variablePageSize)return}}$acceptKernelMessageFromRenderer(D,C,S){const I=this._kernelData.get(D);if(!I)return;const b=this._extHostNotebook.getEditorById(C);I.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:S}))}$cellExecutionChanged(D,C,S){const b=this._extHostNotebook.getNotebookDocument(v.URI.revive(D)).getCell(C);if(b){const w=S?T.NotebookCellExecutionState.to(S):E.NotebookCellExecutionState.Idle;w!==void 0&&this._onDidChangeCellExecutionState.fire({cell:b.apiCell,state:w})}}_createNotebookCellExecution(D,C){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const I=this._extHostNotebook.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!I)throw new Error("invalid cell");if(this._activeExecutions.has(I.uri))throw new Error(`duplicate execution for ${I.uri}`);const b=new t(C,I,this._proxy);this._activeExecutions.set(I.uri,b);const w=b.onDidChangeState(()=>{b.state===i.Resolved&&(b.dispose(),w.dispose(),this._activeExecutions.delete(I.uri))});return b.asApiObject()}_createNotebookExecution(D,C){const S=this._extHostNotebook.getNotebookDocument(D.uri),I=D.getCells().find(N=>{const O=S.getCellFromApiCell(N);return O&&this._activeExecutions.has(O.uri)});if(I)throw new Error(`duplicate cell execution for ${I.document.uri}`);if(this._activeNotebookExecutions.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const b=new h(C,S,this._proxy),w=b.onDidChangeState(()=>{b.state===c.Resolved&&(b.dispose(),w.dispose(),this._activeNotebookExecutions.delete(S.uri))});return this._activeNotebookExecutions.set(S.uri,[b,w]),b.asApiObject()}};e.ExtHostNotebookKernels=s,e.ExtHostNotebookKernels=s=Ke([Ve(4,P.ILogService)],s);var i;(function(_){_[_.Init=0]="Init",_[_.Started=1]="Started",_[_.Resolved=2]="Resolved"})(i||(i={}));class t extends L.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(D,C,S){super(),this._cell=C,this._proxy=S,this._handle=t.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=i.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new o(10,I=>this.update(I)),this._executionOrder=C.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,D,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(D){await this._collector.addItem(D)}async update(D){const C=Array.isArray(D)?D:[D];return this._proxy.$updateExecution(this._handle,new m.SerializableObjectWithBuffers(C))}verifyStateForOutput(){if(this._state===i.Init)throw new Error("Must call start before modifying cell output");if(this._state===i.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(D){let C=this._cell;if(D&&(C=this._cell.notebook.getCellFromApiCell(D)),!C)throw new Error("INVALID cell");return C.handle}validateAndConvertOutputs(D){return D.map(C=>{const S=E.NotebookCellOutput.ensureUniqueMimeTypes(C.items,!0);return S===C.items?T.NotebookCellOutput.from(C):T.NotebookCellOutput.from({items:S,id:C.id,metadata:C.metadata})})}async updateOutputs(D,C,S){const I=this.cellIndexToHandle(C),b=this.validateAndConvertOutputs((0,r.asArray)(D));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,cellHandle:I,append:S,outputs:b})}async updateOutputItems(D,C,S){return D=E.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(D),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,items:D.map(T.NotebookCellOutputItem.from),outputId:C.id,append:S})}asApiObject(){const D=this;return Object.freeze({get token(){return D._tokenSource.token},get cell(){return D._cell.apiCell},get executionOrder(){return D._executionOrder},set executionOrder(S){D._executionOrder=S,D.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:D._executionOrder}])},start(S){if(D._state===i.Resolved||D._state===i.Started)throw new Error("Cannot call start again");D._state=i.Started,D._onDidChangeState.fire(),D.update({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,I,b){if(D._state===i.Resolved)throw new Error("Cannot call resolve twice");D._state=i.Resolved,D._onDidChangeState.fire(),D._collector.flush();const w=b?{message:b.message,stack:b.stack,location:b?.location?{startLineNumber:b.location.start.line,startColumn:b.location.start.character,endLineNumber:b.location.end.line,endColumn:b.location.end.character}:void 0,uri:b.uri}:void 0;D._proxy.$completeExecution(D._handle,new m.SerializableObjectWithBuffers({runEndTime:I,lastRunSuccess:S,error:w}))},clearOutput(S){return D.verifyStateForOutput(),D.updateOutputs([],S,!1)},appendOutput(S,I){return D.verifyStateForOutput(),D.updateOutputs(S,I,!0)},replaceOutput(S,I){return D.verifyStateForOutput(),D.updateOutputs(S,I,!1)},appendOutputItems(S,I){return D.verifyStateForOutput(),D.updateOutputItems(S,I,!0)},replaceOutputItems(S,I){return D.verifyStateForOutput(),D.updateOutputItems(S,I,!1)}})}}var c;(function(_){_[_.Init=0]="Init",_[_.Started=1]="Started",_[_.Resolved=2]="Resolved"})(c||(c={}));class h extends L.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(D,C,S){super(),this._notebook=C,this._proxy=S,this._handle=h.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,D,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===c.Resolved||this._state===c.Started)throw new Error("Cannot call start again");this._state=c.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===c.Resolved)throw new Error("Cannot call resolve twice");this._state=c.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class o{constructor(D,C){this.delay=D,this.callback=C,this.batch=[],this.startedTimer=Date.now()}addItem(D){return this.batch.push(D),this.currentDeferred||(this.currentDeferred=new g.DeferredPromise,this.startedTimer=Date.now(),(0,g.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const D=this.currentDeferred;this.currentDeferred=void 0;const C=this.batch;return this.batch=[],this.callback(C).finally(()=>D.complete())}}function p(_,D){return`${_.value}/${D}`}}),define(we[46],ye([1,0,4,6,5,2,20,3,10,240,14,289,21,32,290,291,50,9,17,37,41]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class i extends R.Disposable{constructor(b,w,N,O){super(),this._proxy=b,this._id=w,this._creationOptions=N,this._name=O,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new r.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(x=>this._pidPromiseComplete=x);const U=this;this.value={get name(){return U._name||""},get processId(){return U._pidPromise},get creationOptions(){return U._creationOptions},get exitStatus(){return U._exitStatus},get state(){return U._state},get selection(){return U._selection},get shellIntegration(){return U.shellIntegration},sendText(x,B=!0){U._checkDisposed(),U._proxy.$sendText(U._id,x,B)},show(x){U._checkDisposed(),U._proxy.$show(U._id,x)},hide(){U._checkDisposed(),U._proxy.$hide(U._id)},dispose(){U._disposed||(U._disposed=!0,U._proxy.$dispose(U._id))},get dimensions(){if(!(U._cols===void 0||U._rows===void 0))return{columns:U._cols,rows:U._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(b,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??w?.cwd??void 0,env:b.env??void 0,icon:D(b.iconPath)??void 0,color:u.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this._serializeParentTerminal(b.location,w?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,w,N,O,U){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:O,color:u.ThemeColor.isThemeColor(U)?U.id:void 0,location:w?.location||this._serializeParentTerminal(b,N),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(b,w){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in b?{viewColumn:m.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(b){this._name=b}setExitStatus(b,w){this._exitStatus=Object.freeze({code:b,reason:w})}setDimensions(b,w){return b===this._cols&&w===this._rows||b===0||w===0?!1:(this._cols=b,this._rows=w,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(b){this._selection=b}_setProcessId(b){this._pidPromiseComplete?(this._pidPromiseComplete(b),this._pidPromiseComplete=void 0):this._pidPromise.then(w=>{w!==b&&(this._pidPromise=Promise.resolve(b))})}}e.ExtHostTerminal=i;class t{get onProcessReady(){return this._onProcessReady.event}constructor(b){this._pty=b,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${w}`)}async start(){}shutdown(){this._pty.close()}input(b){this._pty.handleInput?.(b)}resize(b,w){this._pty.setDimensions?.({columns:b,rows:w})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this._pty.onDidWrite(w=>this._onProcessData.fire(w)),this._pty.onDidClose?.((w=void 0)=>{this._onProcessExit.fire(w===void 0?void 0:w)}),this._pty.onDidOverrideDimensions?.(w=>{w&&this._onDidChangeProperty.fire({type:E.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this._pty.onDidChangeName?.(w=>{this._onDidChangeProperty.fire({type:E.ProcessPropertyType.Title,value:w})}),this._pty.open(b||void 0),b&&this._pty.setDimensions?.(b),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,h=class extends R.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(b=>b.value)}constructor(b,w,N){super(),this._extHostCommands=w,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new R.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new r.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new r.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new r.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=N.getProxy(g.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(b),this._extHostCommands.registerArgumentProcessor({processArgument:O=>{const U=x=>{const B=x;return this.getTerminalById(B.instanceId)?.value};switch(O?.$mid){case s.MarshalledId.TerminalContext:return U(O);default:{if(Array.isArray(O))for(let x=0;x<O.length&&O[x].$mid===s.MarshalledId.TerminalContext;x++)O[x]=U(O[x]);return O}}}}),this._register({dispose:()=>{for(const[O,U]of this._terminalProcesses)U.shutdown(!0)}})}getDefaultShell(b){return(b?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(b){return(b?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(b,w){const N=new i(this._proxy,(0,T.generateUuid)(),b,b.name),O=new t(b.pty);return N.createExtensionTerminal(b.location,w,this._serializeParentTerminal(b,w).resolvedExtHostIdentifier,D(b.iconPath),C(b.color)).then(U=>{const x=this._setupExtHostProcessListeners(U,O);this._terminalProcessDisposables[U]=x}),this._terminals.push(N),N.value}_serializeParentTerminal(b,w){if(w=w||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const N=b.location.parentTerminal;if(N){const O=this._terminals.find(U=>U.value===N);O&&(w.resolvedExtHostIdentifier=O._id)}}else b.location&&typeof b.location!="object"?w.location=b.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(b,w){if(!this.getTerminalById(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const O=new t(w),U=this._setupExtHostProcessListeners(b,O);this._terminalProcessDisposables[b]=U}async $acceptActiveTerminalChanged(b){const w=this._activeTerminal;if(b===null){this._activeTerminal=void 0,w!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const N=this.getTerminalById(b);N&&(this._activeTerminal=N,w!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(b,w){const N=this.getTerminalById(b);N&&this._onDidWriteTerminalData.fire({terminal:N.value,data:w})}async $acceptTerminalDimensions(b,w,N){const O=this.getTerminalById(b);O&&O.setDimensions(w,N)&&this._onDidChangeTerminalDimensions.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(b,w){const N=this.getTerminalById(b);N&&this._onDidExecuteCommand.fire({terminal:N.value,...w})}async $acceptTerminalMaximumDimensions(b,w,N){this._terminalProcesses.get(b)?.resize(w,N)}async $acceptTerminalTitleChange(b,w){const N=this.getTerminalById(b);N&&(N.name=w)}async $acceptTerminalClosed(b,w,N){const O=this._getTerminalObjectIndexById(this._terminals,b);if(O!==null){const U=this._terminals.splice(O,1)[0];U.setExitStatus(w,N),this._onDidCloseTerminal.fire(U.value)}}$acceptTerminalOpened(b,w,N,O){if(w){const B=this._getTerminalObjectIndexById(this._terminals,w);if(B!==null){this._terminals[B]._id=b,this._onDidOpenTerminal.fire(this.terminals[B]),this._terminals[B].isOpen=!0;return}}const U={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:A.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},x=new i(this._proxy,b,U,N);this._terminals.push(x),this._onDidOpenTerminal.fire(x.value),x.isOpen=!0}async $acceptTerminalProcessId(b,w){this.getTerminalById(b)?._setProcessId(w)}async $startExtensionTerminal(b,w){const N=this.getTerminalById(b);if(!N)return{message:(0,l.localize)(0,null,b)};N.isOpen||await new Promise(U=>{const x=this.onDidOpenTerminal(async B=>{B===N.value&&(x.dispose(),U())})});const O=this._terminalProcesses.get(b);O?O.startSendingEvents(w):this._extensionTerminalAwaitingStart[b]={initialDimensions:w}}_setupExtHostProcessListeners(b,w){const N=new R.DisposableStore;N.add(w.onProcessReady(U=>this._proxy.$sendProcessReady(b,U.pid,U.cwd,U.windowsPty))),N.add(w.onDidChangeProperty(U=>this._proxy.$sendProcessProperty(b,U))),this._bufferer.startBuffering(b,w.onProcessData),N.add(w.onProcessExit(U=>this._onProcessExit(b,U))),this._terminalProcesses.set(b,w);const O=this._extensionTerminalAwaitingStart[b];return O&&w instanceof t&&(w.startSendingEvents(O.initialDimensions),delete this._extensionTerminalAwaitingStart[b]),N}$acceptProcessAckDataEvent(b,w){this._terminalProcesses.get(b)?.acknowledgeDataEvent(w)}$acceptProcessInput(b,w){this._terminalProcesses.get(b)?.input(w)}$acceptTerminalInteraction(b){const w=this.getTerminalById(b);w?.setInteractedWith()&&this._onDidChangeTerminalState.fire(w.value)}$acceptTerminalSelection(b,w){this.getTerminalById(b)?.setSelection(w)}$acceptProcessResize(b,w,N){try{this._terminalProcesses.get(b)?.resize(w,N)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(b,w){this._terminalProcesses.get(b)?.shutdown(w)}$acceptProcessRequestInitialCwd(b){this._terminalProcesses.get(b)?.getInitialCwd().then(w=>this._proxy.$sendProcessProperty(b,{type:E.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd(b){this._terminalProcesses.get(b)?.getCwd().then(w=>this._proxy.$sendProcessProperty(b,{type:E.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this._linkProviders.add(b),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new v.Disposable(()=>{this._linkProviders.delete(b),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(b,w,N){if(this._profileProviders.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this._profileProviders.set(w,N),this._proxy.$registerProfileProvider(w,b.identifier.value),new v.Disposable(()=>{this._profileProviders.delete(w),this._proxy.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(b,w,N){if(this._quickFixProviders.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this._quickFixProviders.set(b,N),this._proxy.$registerQuickFixProvider(b,w),new v.Disposable(()=>{this._quickFixProviders.delete(b),this._proxy.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,w){const N=new d.CancellationTokenSource().token;if(N.isCancellationRequested)return;const O=this._quickFixProviders.get(b);if(!O)return;const U=await O.provideTerminalQuickFixes(w,N);if(U===null||Array.isArray(U)&&U.length===0)return;const x=new R.DisposableStore;if(this._lastQuickFixCommands.value=x,!Array.isArray(U))return U?m.TerminalQuickFix.from(U,this._extHostCommands.converter,x):void 0;const B=[];for(const F of U){const M=m.TerminalQuickFix.from(F,this._extHostCommands.converter,x);M&&B.push(M)}return B}async $createContributedProfileTerminal(b,w){const N=new d.CancellationTokenSource().token;let O=await this._profileProviders.get(b)?.provideTerminalProfile(N);if(!N.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,w);return}this.createTerminalFromOptions(O.options,w)}}async $provideLinks(b,w){const N=this.getTerminalById(b);if(!N)return[];this._terminalLinkCache.delete(b),this._terminalLinkCancellationSource.get(b)?.dispose(!0);const U=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(b,U);const x=[],B={terminal:N.value,line:w},F=[];for(const ee of this._linkProviders)F.push(f.Promises.withAsyncBody(async $=>{U.token.onCancellationRequested(()=>$({provider:ee,links:[]}));const q=await ee.provideTerminalLinks(B,U.token)||[];U.token.isCancellationRequested||$({provider:ee,links:q})}));const M=await Promise.all(F);if(U.token.isCancellationRequested)return[];const K=new Map;for(const ee of M)ee&&ee.links.length>0&&x.push(...ee.links.map($=>{const q={id:c++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return K.set(q.id,{provider:ee.provider,link:$}),q}));return this._terminalLinkCache.set(b,K),x}$activateLink(b,w){const N=this._terminalLinkCache.get(b)?.get(w);N&&N.provider.handleTerminalLink(N.link)}_onProcessExit(b,w){this._bufferer.stopBuffering(b),this._terminalProcesses.delete(b),delete this._extensionTerminalAwaitingStart[b];const N=this._terminalProcessDisposables[b];N&&(N.dispose(),delete this._terminalProcessDisposables[b]),this._proxy.$sendProcessExit(b,w)}getTerminalById(b){return this._getTerminalObjectById(this._terminals,b)}getTerminalIdByApiObject(b){const w=this._terminals.findIndex(N=>N.value===b);return w>=0?w:null}_getTerminalObjectById(b,w){const N=this._getTerminalObjectIndexById(b,w);return N!==null?b[N]:null}_getTerminalObjectIndexById(b,w){const N=b.findIndex(O=>O._id===w);return N>=0?N:null}getEnvironmentVariableCollection(b){let w=this._environmentVariableCollections.get(b.identifier.value);return w||(w=new o,this._setEnvironmentVariableCollection(b.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(b,w){const N=(0,y.serializeEnvironmentVariableCollection)(w.map),O=(0,y.serializeEnvironmentDescriptionMap)(w.descriptionMap);this._proxy.$setEnvironmentVariableCollection(b,w.persistent,N.length===0?void 0:N,O)}$initEnvironmentVariableCollections(b){b.forEach(w=>{const N=w[0],O=new o(w[1]);this._setEnvironmentVariableCollection(N,O)})}$acceptDefaultProfile(b,w){const N=this._defaultProfile;this._defaultProfile=b,this._defaultAutomationProfile=w,N?.path!==b.path&&this._onDidChangeShell.fire(b.path)}_setEnvironmentVariableCollection(b,w){this._environmentVariableCollections.set(b,w),w.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(b,w)})}};e.BaseExtHostTerminalService=h,e.BaseExtHostTerminalService=h=Ke([Ve(1,n.IExtHostCommands),Ve(2,L.IExtHostRpcService)],h);class o{get persistent(){return this._persistent}set persistent(b){this._persistent=b,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(b){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const w=this.getScopeKey(b);let N=this.scopedCollections.get(w);return N||(N=new p(this,b),this.scopedCollections.set(w,N),N.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),N}replace(b,w,N,O){this._setIfDiffers(b,{value:w,type:v.EnvironmentVariableMutatorType.Replace,options:N??{applyAtProcessCreation:!0},scope:O})}append(b,w,N,O){this._setIfDiffers(b,{value:w,type:v.EnvironmentVariableMutatorType.Append,options:N??{applyAtProcessCreation:!0},scope:O})}prepend(b,w,N,O){this._setIfDiffers(b,{value:w,type:v.EnvironmentVariableMutatorType.Prepend,options:N??{applyAtProcessCreation:!0},scope:O})}_setIfDiffers(b,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const N=this.getKey(b,w.scope),O=this.map.get(N),U=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==w.value||O.type!==w.type||O.options?.applyAtProcessCreation!==U.applyAtProcessCreation||O.options?.applyAtShellIntegration!==U.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const x=this.getKey(b,w.scope),B={variable:b,...w,options:U};this.map.set(x,B),this._onDidChangeCollection.fire()}}get(b,w){const N=this.getKey(b,w),O=this.map.get(N);return O?S(O):void 0}getKey(b,w){const N=this.getScopeKey(w);return N.length?`${b}:::${N}`:b}getScopeKey(b){return this.getWorkspaceKey(b?.workspaceFolder)??""}getWorkspaceKey(b){return b?b.uri.toString():void 0}getVariableMap(b){const w=new Map;for(const[N,O]of this.map)this.getScopeKey(O.scope)===this.getScopeKey(b)&&w.set(O.variable,S(O));return w}delete(b,w){const N=this.getKey(b,w);this.map.delete(N),this._onDidChangeCollection.fire()}clear(b){if(b?.workspaceFolder){for(const[w,N]of this.map)N.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(w);this.clearDescription(b)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(b,w){const N=this.getScopeKey(w),O=this.descriptionMap.get(N);if(!O||O.description!==b){let U;typeof b=="string"?U=b:U=b?.value.split(`

`)[0];const x={description:U,scope:w};this.descriptionMap.set(N,x),this._onDidChangeCollection.fire()}}getDescription(b){const w=this.getScopeKey(b);return this.descriptionMap.get(w)?.description}clearDescription(b){const w=this.getScopeKey(b);this.descriptionMap.delete(w)}}class p{get persistent(){return this.collection.persistent}set persistent(b){this.collection.persistent=b}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(b,w){this.collection=b,this.scope=w,this._onDidChangeCollection=new r.Emitter}getScoped(b){return this.collection.getScopedEnvironmentVariableCollection(b)}replace(b,w,N){this.collection.replace(b,w,N,this.scope)}append(b,w,N){this.collection.append(b,w,N,this.scope)}prepend(b,w,N){this.collection.prepend(b,w,N,this.scope)}get(b){return this.collection.get(b,this.scope)}forEach(b,w){this.collection.getVariableMap(this.scope).forEach((N,O)=>b.call(w,O,N,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(b){this.collection.delete(b,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(b){this.collection.setDescription(b,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let _=class extends h{constructor(b,w){super(!1,b,w)}createTerminal(b,w,N){throw new P.NotSupportedError}createTerminalFromOptions(b,w){throw new P.NotSupportedError}};e.WorkerExtHostTerminalService=_,e.WorkerExtHostTerminalService=_=Ke([Ve(0,n.IExtHostCommands),Ve(1,L.IExtHostRpcService)],_);function D(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function C(I){return u.ThemeColor.isThemeColor(I)?I:void 0}function S(I){const b={...I};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(we[165],ye([1,0,10,3,5,6,20,46,4,2,9]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,k.createDecorator)("IExtHostTerminalShellIntegration");let y=class extends g.Disposable{constructor(u,f){super(),this._extHostTerminalService=f,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new v.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new v.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new v.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=u.getProxy(A.MainContext.MainThreadTerminalShellIntegration),this._register((0,g.toDisposable)(()=>{for(const[m,n]of this._activeShellIntegrations)n.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(u){const f=this._extHostTerminalService.getTerminalById(u);if(!f)return;const m=f.value;let n=this._activeShellIntegrations.get(u);n||(n=new d(f.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(u,n),n.store.add(f.onWillDispose(()=>this._activeShellIntegrations.get(u)?.dispose())),n.store.add(n.onDidRequestShellExecution(s=>this._proxy.$executeCommand(u,s))),n.store.add(n.onDidRequestEndExecution(s=>this._onDidEndTerminalShellExecution.fire(s))),n.store.add(n.onDidRequestChangeShellIntegration(s=>this._onDidChangeTerminalShellIntegration.fire(s))),f.shellIntegration=n.value),this._onDidChangeTerminalShellIntegration.fire({terminal:m,shellIntegration:n.value})}$shellExecutionStart(u,f,m,n,s){this._activeShellIntegrations.has(u)||this.$shellIntegrationChange(u);const i={value:f,confidence:m,isTrusted:n};this._activeShellIntegrations.get(u)?.startShellExecution(i,s)}$shellExecutionEnd(u,f,m,n,s){const i={value:f,confidence:m,isTrusted:n};this._activeShellIntegrations.get(u)?.endShellExecution(i,s)}$shellExecutionData(u,f){this._activeShellIntegrations.get(u)?.emitData(f)}$cwdChange(u,f){this._activeShellIntegrations.get(u)?.setCwd((0,l.isUriComponents)(f)?l.URI.revive(f):f)}$closeTerminal(u){this._activeShellIntegrations.get(u)?.dispose(),this._activeShellIntegrations.delete(u)}};e.ExtHostTerminalShellIntegration=y,e.ExtHostTerminalShellIntegration=y=Ke([Ve(0,L.IExtHostRpcService),Ve(1,R.IExtHostTerminalService)],y);class d extends g.Disposable{get currentExecution(){return this._currentExecution}constructor(u,f){super(),this._terminal=u,this._onDidStartTerminalShellExecution=f,this._ignoreNextExecution=!1,this.store=this._register(new g.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new v.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new v.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new v.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const m=this;this.value={get cwd(){return m._cwd},executeCommand(n,s){let i=n;s&&(i+=` "${s.map(h=>`${h.replaceAll('"','\\"')}`).join('" "')}"`),m._onDidRequestShellExecution.fire(i);const t={value:i,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},c=m.startShellExecution(t,m._cwd,!0).value;return m._ignoreNextExecution=!0,c}}}startShellExecution(u,f,m){if(this._ignoreNextExecution&&this._currentExecution)this._ignoreNextExecution=!1;else{this._currentExecution&&(this._currentExecution.endExecution(void 0),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:void 0}));const n=this._currentExecution=new T(u,f);m?queueMicrotask(()=>this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:n.value})):this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value})}return this._currentExecution}emitData(u){this.currentExecution?.emitData(u)}endShellExecution(u,f){this._currentExecution&&(this._currentExecution.endExecution(u),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:f}),this._currentExecution=void 0)}setCwd(u){let f=!1;l.URI.isUri(this._cwd)?f=!l.URI.isUri(u)||this._cwd.toString()!==u.toString():this._cwd!==u&&(f=!0),f&&(this._cwd=u,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class T{constructor(u,f){this._commandLine=u,this.cwd=f,this._ended=!1;const m=this;this.value={get commandLine(){return m._commandLine},get cwd(){return m.cwd},read(){return m._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._ended)return P.AsyncIterableObject.EMPTY;this._dataStream=new E}return this._dataStream.createIterable()}emitData(u){this._dataStream?.emitData(u)}endExecution(u){u&&(this._commandLine=u),this._dataStream?.endExecution(),this._dataStream=void 0,this._ended=!0}}class E extends g.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){this._barrier||(this._barrier=new P.Barrier);const u=this._barrier;return new P.AsyncIterableObject(async m=>{this._emitters.push(m),await u.wait()})}emitData(u){for(const f of this._emitters)f.emitOne(u)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(we[369],ye([1,0,9,22,21,4,80,61,3,41,18,32,12,6,20,164,17,10,313,73,120,74,26]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let c=0;const h=new WeakMap;let o=class extends v.Disposable{constructor(M,K,ee,$){super(),this.logService=K,this.commands=ee,this.editors=$,this.resultsChangedEmitter=this._register(new A.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new A.Emitter),this.followupProviders=new Set,this.testFollowups=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(T.MainContext.MainThreadTesting),this.observer=new N(this.proxy),this.runTracker=new C(this.proxy,K),ee.registerArgumentProcessor({processArgument:q=>{switch(q?.$mid){case l.MarshalledId.TestItemContext:{const Z=q,ne=Z.tests[Z.tests.length-1].item.extId;return this.controllers.get(n.TestId.root(ne))?.collection.tree.get(ne)?.actual??(0,a.toItemFromContext)(q)}case l.MarshalledId.TestMessageMenuArgs:{const{test:Z,message:ne}=q,de=Z.item.extId;return{test:this.controllers.get(n.TestId.root(de))?.collection.tree.get(de)?.actual??(0,a.toItemFromContext)({$mid:l.MarshalledId.TestItemContext,tests:[Z]}),message:u.TestMessage.to(ne)}}default:return q}}}),ee.registerCommand(!1,"testing.getExplorerSelection",async()=>{const q=await ee.executeCommand(m.TestCommandId.GetExplorerSelection),Z=ne=>{const de=this.controllers.get(n.TestId.root(ne));if(de)return n.TestId.isRoot(ne)?de.controller:de.collection.tree.get(ne)?.actual};return{include:q?.include.map(Z).filter(P.isDefined)||[],exclude:q?.exclude.map(Z).filter(P.isDefined)||[]}})}createTestController(M,K,ee,$){if(this.controllers.has(K))throw new Error(`Attempt to insert a duplicate controller with ID "${K}"`);const q=new v.DisposableStore,Z=q.add(new a.ExtHostTestItemCollection(K,ee,this.editors));Z.root.label=ee;const ne=new Map,de=new Set,re=this.proxy,Se={items:Z.root.children,get label(){return ee},set label(G){ee=G,Z.root.label=G,re.$updateController(K,{label:ee})},get refreshHandler(){return $},set refreshHandler(G){$=G,re.$updateController(K,{canRefresh:!!G})},get id(){return K},createRunProfile:(G,W,se,ae,ie,le)=>{let ue=(0,R.hash)(G);for(;ne.has(ue);)ue++;return new U(this.proxy,ne,de,this.defaultProfilesChangedEmitter.event,K,ue,G,W,se,ae,ie,le)},createTestItem(G,W,se){return new a.TestItemImpl(K,G,W,se)},createTestRun:(G,W,se=!0)=>this.runTracker.createTestRun(M,K,Z,G,W,se),invalidateTestResults:G=>{if(G===void 0)this.proxy.$markTestRetired(void 0);else{const W=G instanceof Array?G:[G];this.proxy.$markTestRetired(W.map(se=>n.TestId.fromExtHostTestItem(se,K).toString()))}},set resolveHandler(G){Z.resolveHandler=G},get resolveHandler(){return Z.resolveHandler},dispose:()=>{q.dispose()}};re.$registerTestController(K,ee,!!$),q.add((0,v.toDisposable)(()=>re.$unregisterTestController(K)));const ve={controller:Se,collection:Z,profiles:ne,extension:M,activeProfiles:de};return this.controllers.set(K,ve),q.add((0,v.toDisposable)(()=>this.controllers.delete(K))),q.add(Z.onDidGenerateDiff(G=>re.$publishDiff(K,G.map(i.TestsDiffOp.serialize)))),Se}createTestObserver(){return this.observer.checkout()}async runTests(M,K=k.CancellationToken.None){const ee=S(M);if(!ee)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(ee.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({preserveFocus:M.preserveFocus??!0,targets:[{testIds:M.include?.map(q=>n.TestId.fromExtHostTestItem(q,$.collection.root.id).toString())??[$.collection.root.id],profileGroup:x[ee.kind],profileId:ee.profileId,controllerId:ee.controllerId}],exclude:M.exclude?.map(q=>q.id)},K)}registerTestFollowupProvider(M){return this.followupProviders.add(M),{dispose:()=>{this.followupProviders.delete(M)}}}$syncTests(){for(const{collection:M}of this.controllers.values())M.flushDiff();return Promise.resolve()}async $getCoverageDetails(M,K){return(await this.runTracker.getCoverageDetails(M,K))?.map(u.TestCoverage.fromDetails)}async $disposeRun(M){this.runTracker.disposeTestRun(M)}$configureRunProfile(M,K){this.controllers.get(M)?.profiles.get(K)?.configureHandler?.()}$setDefaultRunProfiles(M){const K=new Map;for(const[ee,$]of Object.entries(M)){const q=this.controllers.get(ee);if(!q)continue;const Z=new Map,ne=$.filter(re=>!q.activeProfiles.has(re)),de=[...q.activeProfiles].filter(re=>!$.includes(re));for(const re of ne)Z.set(re,!0),q.activeProfiles.add(re);for(const re of de)Z.set(re,!1),q.activeProfiles.delete(re);Z.size&&K.set(ee,Z)}this.defaultProfilesChangedEmitter.fire(K)}async $refreshTests(M,K){await this.controllers.get(M)?.controller.refreshHandler?.(K)}$publishTestResults(M){this.results=Object.freeze(M.map(K=>{const ee=u.TestResults.to(K);return h.set(ee,K.id),ee}).concat(this.results).sort((K,ee)=>ee.completedAt-K.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(M,K){const ee=this.controllers.get(n.TestId.fromString(M).controllerId)?.collection;ee&&(await ee.expand(M,K<0?1/0:K),ee.flushDiff())}$acceptDiff(M){this.observer.applyDiff(M.map(K=>i.TestsDiffOp.deserialize({asCanonicalUri:ee=>ee},K)))}async $runControllerTests(M,K){return Promise.all(M.map(ee=>this.runControllerTestRequest(ee,!1,K)))}async $startContinuousRun(M,K){const ee=new k.CancellationTokenSource(K),$=await Promise.all(M.map(q=>this.runControllerTestRequest(q,!0,ee.token)));return!K.isCancellationRequested&&!$.some(q=>q.error)&&await new Promise(q=>K.onCancellationRequested(q)),ee.dispose(!0),$}async $provideTestFollowups(M,K){const ee=this.results.find(Z=>h.get(Z)===M.resultId),$=ee&&B(n.TestId.fromString(M.extId),ee?.results);if(!$)return[];let q=[];return await Promise.all([...this.followupProviders].map(async Z=>{try{const ne=await Z.provideFollowup(ee,$,M.taskIndex,M.messageIndex,K);ne&&(q=q.concat(ne))}catch(ne){this.logService.error("Error thrown while providing followup for test message",ne)}})),K.isCancellationRequested?[]:q.map(Z=>{const ne=c++;return this.testFollowups.set(ne,Z),{title:Z.title,id:ne}})}$disposeTestFollowups(M){for(const K of M)this.testFollowups.delete(K)}$executeTestFollowup(M){const K=this.testFollowups.get(M);return K?this.commands.executeCommand(K.command,...K.arguments||[]):Promise.resolve()}async runControllerTestRequest(M,K,ee){const $=this.controllers.get(M.controllerId);if(!$)return{};const{collection:q,profiles:Z,extension:ne}=$,de=Z.get(M.profileId);if(!de)return{};const re=M.testIds.map(W=>q.tree.get(W)).filter(P.isDefined),Se=M.excludeExtIds.map(W=>$.collection.tree.get(W)).filter(P.isDefined).filter(W=>re.some(se=>se.fullId.compare(W.fullId)===n.TestPosition.IsChild));if(!re.length)return{};const ve=new f.TestRunRequest(re.some(W=>W.actual instanceof a.TestItemRootImpl)?void 0:re.map(W=>W.actual),Se.map(W=>W.actual),de,K),G=(0,i.isStartControllerTests)(M)&&this.runTracker.prepareForMainThreadTestRun(ne,ve,I.fromInternal(M,$.collection),de,ee);try{return await de.runHandler(ve,ee),{}}catch(W){return{error:String(W)}}finally{G&&G.hasRunningTasks&&!ee.isCancellationRequested&&await A.Event.toPromise(G.onEnd)}}$cancelExtensionTestRun(M){M===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(M)}};e.ExtHostTesting=o,e.ExtHostTesting=o=Ke([Ve(0,E.IExtHostRpcService),Ve(1,d.ILogService)],o);const p=1e4;var _;(function(F){F[F.Running=0]="Running",F[F.Cancelling=1]="Cancelling",F[F.Ended=2]="Ended"})(_||(_={}));class D extends v.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor(M,K,ee,$,q,Z){super(),this.dto=M,this.proxy=K,this.logService=ee,this.profile=$,this.extension=q,this.state=_.Running,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new k.CancellationTokenSource(Z));const ne=this._register(new r.RunOnceScheduler(()=>this.forciblyEndTasks(),p));this._register(this.cts.token.onCancellationRequested(()=>ne.schedule()));const de=new A.Emitter;this.onDidDispose=de.event,this._register((0,v.toDisposable)(()=>{de.fire(),de.dispose()}))}cancel(){this.state===_.Running?(this.cts.cancel(),this.state=_.Cancelling):this.state===_.Cancelling&&this.forciblyEndTasks()}getCoverageDetails(M,K){const[,ee]=n.TestId.fromString(M).path,$=this.publishedCoverage.get(M);if(!$)return[];const q=this.tasks.get(ee);if(!q)throw new Error("unreachable: run task was not found");return this.profile?.loadDetailedCoverage?.(q.run,$,K)??[]}createRun(M){const K=this.dto.id,ee=this.dto.controllerId,$=(0,y.generateUuid)(),q=Se=>(ve,...G)=>{if(ne){this.logService.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(ve)&&(this.ensureTestIsKnown(ve),Se(ve,...G))},Z=(Se,ve)=>{const G=ve instanceof Array?ve.map(u.TestMessage.from):[u.TestMessage.from(ve)];if(Se.uri&&Se.range){const W={range:u.Range.from(Se.range),uri:Se.uri};for(const se of G)se.location=se.location||W}this.proxy.$appendTestMessagesInRun(K,$,n.TestId.fromExtHostTestItem(Se,ee).toString(),G)};let ne=!1;const de=new Map,re={isPersisted:this.dto.isPersisted,token:this.cts.token,name:M,onDidDispose:this.onDidDispose,addCoverage:Se=>{if(ne)return;const ve=Se instanceof f.FileCoverage?Se.testItem:void 0;let G;if(ve){if((0,t.checkProposedApiEnabled)(this.extension,"attributableCoverage"),!this.dto.isIncluded(ve))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.ensureTestIsKnown(ve),G=de.get(ve),G===void 0&&(G=de.size,de.set(ve,G))}const W=Se.uri.toString(),se=new n.TestId(G!==void 0?[K,$,W,String(G)]:[K,$,W]).toString();this.publishedCoverage.set(se,Se),this.proxy.$appendCoverage(K,$,u.TestCoverage.fromFile(ee,se,Se))},enqueued:q(Se=>{this.proxy.$updateTestStateInRun(K,$,n.TestId.fromExtHostTestItem(Se,ee).toString(),i.TestResultState.Queued)}),skipped:q(Se=>{this.proxy.$updateTestStateInRun(K,$,n.TestId.fromExtHostTestItem(Se,ee).toString(),i.TestResultState.Skipped)}),started:q(Se=>{this.proxy.$updateTestStateInRun(K,$,n.TestId.fromExtHostTestItem(Se,ee).toString(),i.TestResultState.Running)}),errored:q((Se,ve,G)=>{Z(Se,ve),this.proxy.$updateTestStateInRun(K,$,n.TestId.fromExtHostTestItem(Se,ee).toString(),i.TestResultState.Errored,G)}),failed:q((Se,ve,G)=>{Z(Se,ve),this.proxy.$updateTestStateInRun(K,$,n.TestId.fromExtHostTestItem(Se,ee).toString(),i.TestResultState.Failed,G)}),passed:q((Se,ve)=>{this.proxy.$updateTestStateInRun(K,$,n.TestId.fromExtHostTestItem(Se,this.dto.controllerId).toString(),i.TestResultState.Passed,ve)}),appendOutput:(Se,ve,G)=>{ne||(G&&(this.dto.isIncluded(G)?this.ensureTestIsKnown(G):G=void 0),this.proxy.$appendOutputToRun(K,$,g.VSBuffer.fromString(Se),ve&&u.location.from(ve),G&&n.TestId.fromExtHostTestItem(G,ee).toString()))},end:()=>{ne||(ne=!0,de.clear(),this.proxy.$finishedTestRunTask(K,$),--this.running||this.markEnded())}};return this.running++,this.tasks.set($,{run:re}),this.proxy.$startedTestRunTask(K,{id:$,name:M,running:!0}),re}forciblyEndTasks(){for(const{run:M}of this.tasks.values())M.end()}markEnded(){this.state!==_.Ended&&(this.state=_.Ended,this.endEmitter.fire())}ensureTestIsKnown(M){if(!(M instanceof a.TestItemImpl))throw new s.InvalidTestItemError(M.id);if(this.sharedTestIds.has(n.TestId.fromExtHostTestItem(M,this.dto.controllerId).toString()))return;const K=[],ee=this.dto.colllection.root;for(;;){const $=u.TestItem.from(M);if(K.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),M===ee))break;M=M.parent||ee}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,K)}dispose(){this.markEnded(),super.dispose()}}class C{get trackers(){return this.tracked.values()}constructor(M,K){this.proxy=M,this.logService=K,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails(M,K){const ee=n.TestId.root(M);return this.trackedById.get(ee)?.getCoverageDetails(M,K)||[]}disposeTestRun(M){this.trackedById.get(M)?.dispose(),this.trackedById.delete(M);for(const[K,{id:ee}]of this.tracked)ee===M&&this.tracked.delete(K)}prepareForMainThreadTestRun(M,K,ee,$,q){return this.getTracker(K,ee,$,M,q)}cancelRunById(M){this.trackedById.get(M)?.cancel()}cancelAllRuns(){for(const M of this.tracked.values())M.cancel()}createTestRun(M,K,ee,$,q,Z){const ne=this.tracked.get($);if(ne)return ne.createRun(q);const de=I.fromPublic(K,ee,$,Z),re=S($);this.proxy.$startedExtensionTestRun({controllerId:K,continuous:!!$.continuous,profile:re&&{group:x[re.kind],id:re.profileId},exclude:$.exclude?.map(ve=>n.TestId.fromExtHostTestItem(ve,ee.root.id).toString())??[],id:de.id,include:$.include?.map(ve=>n.TestId.fromExtHostTestItem(ve,ee.root.id).toString())??[ee.root.id],preserveFocus:$.preserveFocus??!0,persist:Z});const Se=this.getTracker($,de,$.profile,M);return A.Event.once(Se.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(de.id)}),Se.createRun(q)}getTracker(M,K,ee,$,q){const Z=new D(K,this.proxy,this.logService,ee,$,q);return this.tracked.set(M,Z),this.trackedById.set(Z.id,Z),Z}}e.TestRunCoordinator=C;const S=F=>{if(F.profile){if(!(F.profile instanceof U))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return F.profile}};class I{static fromPublic(M,K,ee,$){return new I(M,(0,y.generateUuid)(),ee.include?.map(q=>n.TestId.fromExtHostTestItem(q,M).toString())??[M],ee.exclude?.map(q=>n.TestId.fromExtHostTestItem(q,M).toString())??[],$,K)}static fromInternal(M,K){return new I(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,K)}constructor(M,K,ee,$,q,Z){this.controllerId=M,this.id=K,this.isPersisted=q,this.colllection=Z,this.includePrefix=ee.map(ne=>ne+n.TestIdPathParts.Delimiter),this.excludePrefix=$.map(ne=>ne+n.TestIdPathParts.Delimiter)}isIncluded(M){const K=n.TestId.fromExtHostTestItem(M,this.controllerId).toString()+n.TestIdPathParts.Delimiter;for(const ee of this.excludePrefix)if(K===ee||K.startsWith(ee))return!1;for(const ee of this.includePrefix)if(K===ee||K.startsWith(ee))return!0;return!1}}e.TestRunDto=I;class b{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(M){this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(M){this.added.add(M)}update(M){Object.assign(M.revived,u.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}this.updated.delete(M);const K=n.TestId.parentId(M.item.extId);if(K&&this.alreadyRemoved.has(K.toString())){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:K,removed:ee}=this;return{get added(){return[...M].map($=>$.revived)},get updated(){return[...K].map($=>$.revived)},get removed(){return[...ee].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class w extends i.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,K){return{...M,revived:u.TestItem.toPlain(M.item),depth:K?K.depth+1:0,children:new Set}}createChangeCollector(){return new b(this.changeEmitter)}}class N{constructor(M){this.proxy=M}checkout(){this.current||(this.current=this.createObserverData());const M=this.current;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(K=>K.revived)},dispose:(0,L.createSingleCallFunction)(()=>{--M.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(M){return this.current?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.current?.tests.apply(M)}createObserverData(){const M=new w({asCanonicalUri:K=>K});return this.proxy.$subscribeToDiffs(),{observers:0,tests:M}}}const O=(F,M,K,ee)=>{K?Object.assign(K,ee):M.$updateTestRunConfig(F.controllerId,F.profileId,ee)};class U{#e;#t;#i;#n;#s;get label(){return this._label}set label(M){M!==this._label&&(this._label=M,O(this,this.#e,this.#n,{label:M}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(M){M!==this._supportsContinuousRun&&(this._supportsContinuousRun=M,O(this,this.#e,this.#n,{supportsContinuousRun:M}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(M){M!==this.isDefault&&(M?this.#t.add(this.profileId):this.#t.delete(this.profileId),O(this,this.#e,this.#n,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,O(this,this.#e,this.#n,{tag:M?u.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(M){M!==this._configureHandler&&(this._configureHandler=M,O(this,this.#e,this.#n,{hasConfigurationHandler:!!M}))}get onDidChangeDefault(){return A.Event.chain(this.#i,M=>M.map(K=>K.get(this.controllerId)?.get(this.profileId)).filter(P.isDefined))}constructor(M,K,ee,$,q,Z,ne,de,re,Se=!1,ve=void 0,G=!1){this.controllerId=q,this.profileId=Z,this._label=ne,this.kind=de,this.runHandler=re,this._tag=ve,this._supportsContinuousRun=G,this.#e=M,this.#s=K,this.#t=ee,this.#i=$,K.set(Z,this);const W=x[de];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${de}`);Se&&ee.add(Z),this.#n={profileId:Z,controllerId:q,tag:ve?u.TestTag.namespace(this.controllerId,ve.id):null,label:ne,group:W,isDefault:Se,hasConfigurationHandler:!1,supportsContinuousRun:G},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=U;const x={[f.TestRunProfileKind.Coverage]:i.TestRunProfileBitset.Coverage,[f.TestRunProfileKind.Debug]:i.TestRunProfileBitset.Debug,[f.TestRunProfileKind.Run]:i.TestRunProfileBitset.Run};function B(F,M){for(let K=0;K<F.path.length;K++){const ee=M.find($=>$.id===F.path[K]);if(!ee)return;if(K===F.path.length-1)return ee;M=ee.children}}}),define(we[166],ye([1,0,65,14,132,17,10]),function(he,e,r,g,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{static{this._Keys=new k.IdGenerator("TextEditorDecorationType")}constructor(d,T,E){const a=R._Keys.nextId();d.$registerTextEditorDecorationType(T.identifier,a,A.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:a,dispose(){d.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=R;class v{constructor(d,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,T){this._throwIfFinalized();let E=null;if(d instanceof L.Position)E=new L.Range(d,d);else if(d instanceof L.Range)E=d;else throw new Error("Unrecognized location");this._pushEdit(E,T,!1)}insert(d,T){this._throwIfFinalized(),this._pushEdit(new L.Range(d,d),T,!0)}delete(d){this._throwIfFinalized();let T=null;if(d instanceof L.Range)T=d;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(d,T,E){const a=this._document.validateRange(d);this._collectedEdits.push({range:a,text:T,forceMoveMarkers:E})}setEndOfLine(d){if(this._throwIfFinalized(),d!==L.EndOfLine.LF&&d!==L.EndOfLine.CRLF)throw(0,g.illegalArgument)("endOfLine");this._setEndOfLine=d}}class l{constructor(d,T,E,a){this._proxy=d,this._id=T,this._accept(E),this._logService=a;const u=this;this.value={get tabSize(){return u._tabSize},set tabSize(f){u._setTabSize(f)},get indentSize(){return u._indentSize},set indentSize(f){u._setIndentSize(f)},get insertSpaces(){return u._insertSpaces},set insertSpaces(f){u._setInsertSpaces(f)},get cursorStyle(){return u._cursorStyle},set cursorStyle(f){u._setCursorStyle(f)},get lineNumbers(){return u._lineNumbers},set lineNumbers(f){u._setLineNumbers(f)}}}_accept(d){this._tabSize=d.tabSize,this._indentSize=d.indentSize,this._originalIndentSize=d.originalIndentSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const T=Math.floor(d);return T>0?T:null}if(typeof d=="string"){const T=parseInt(d,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(d){const T=this._validateTabSize(d);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateIndentSize(d){if(d==="tabSize")return"tabSize";if(typeof d=="number"){const T=Math.floor(d);return T>0?T:null}if(typeof d=="string"){const T=parseInt(d,10);return isNaN(T)?null:T>0?T:null}return null}_setIndentSize(d){const T=this._validateIndentSize(d);if(T!==null){if(typeof T=="number"){if(this._originalIndentSize===T)return;this._indentSize=T,this._originalIndentSize=T}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:T}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:!!d}_setInsertSpaces(d){const T=this._validateInsertSpaces(d);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(d)})))}assign(d){const T={};let E=!1;if(typeof d.tabSize<"u"){const a=this._validateTabSize(d.tabSize);a==="auto"?(E=!0,T.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,E=!0,T.tabSize=a)}if(typeof d.indentSize<"u"){const a=this._validateIndentSize(d.indentSize);a==="tabSize"?(E=!0,T.indentSize=a):typeof a=="number"&&this._originalIndentSize!==a&&(this._indentSize=a,this._originalIndentSize=a,E=!0,T.indentSize=a)}if(typeof d.insertSpaces<"u"){const a=this._validateInsertSpaces(d.insertSpaces);a==="auto"?(E=!0,T.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,E=!0,T.insertSpaces=a)}typeof d.cursorStyle<"u"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,E=!0,T.cursorStyle=d.cursorStyle),typeof d.lineNumbers<"u"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,E=!0,T.lineNumbers=A.TextEditorLineNumbersStyle.from(d.lineNumbers)),E&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(d,T){T.catch(E=>{this._logService.warn(`ExtHostTextEditorOptions '${d}' failed:'`),this._logService.warn(E)})}}e.ExtHostTextEditorOptions=l;class P{constructor(d,T,E,a,u,f,m,n){this.id=d,this._proxy=T,this._logService=E,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._options=new l(this._proxy,this.id,f,E),this._visibleRanges=m,this._viewColumn=n;const s=this;this.value=Object.freeze({get document(){return a.value},set document(i){throw new g.ReadonlyError("document")},get selection(){return s._selections&&s._selections[0]},set selection(i){if(!(i instanceof L.Selection))throw(0,g.illegalArgument)("selection");s._selections=[i],s._trySetSelection()},get selections(){return s._selections},set selections(i){if(!Array.isArray(i)||i.some(t=>!(t instanceof L.Selection)))throw(0,g.illegalArgument)("selections");s._selections=i,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(i){throw new g.ReadonlyError("visibleRanges")},get options(){return s._options.value},set options(i){s._disposed||s._options.assign(i)},get viewColumn(){return s._viewColumn},set viewColumn(i){throw new g.ReadonlyError("viewColumn")},edit(i,t={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const c=new v(a.value,t);return i(c),s._applyEdit(c)},insertSnippet(i,t,c={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=s._selections.map(o=>A.Range.from(o));else if(t instanceof L.Position){const{lineNumber:o,column:p}=A.Position.from(t);h=[{startLineNumber:o,startColumn:p,endLineNumber:o,endColumn:p}]}else if(t instanceof L.Range)h=[A.Range.from(t)];else{h=[];for(const o of t)if(o instanceof L.Range)h.push(A.Range.from(o));else{const{lineNumber:p,column:_}=A.Position.from(o);h.push({startLineNumber:p,startColumn:_,endLineNumber:p,endColumn:_})}}return T.$tryInsertSnippet(d,a.value.version,i.value,h,c)},setDecorations(i,t){const c=t.length===0;c&&!s._hasDecorationsForKey.has(i.key)||(c?s._hasDecorationsForKey.delete(i.key):s._hasDecorationsForKey.add(i.key),s._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return T.$trySetDecorations(d,i.key,A.fromRangeOrRangeWithMessage(t));{const h=new Array(4*t.length);for(let o=0,p=t.length;o<p;o++){const _=t[o];h[4*o]=_.start.line+1,h[4*o+1]=_.start.character+1,h[4*o+2]=_.end.line+1,h[4*o+3]=_.end.character+1}return T.$trySetDecorationsFast(d,i.key,h)}}))},revealRange(i,t){s._runOnProxy(()=>T.$tryRevealRange(d,A.Range.from(i),t||L.TextEditorRevealType.Default))},show(i){T.$tryShowEditor(d,A.ViewColumn.from(i))},hide(){T.$tryHideEditor(d)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,r.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,r.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,r.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,r.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const T=d.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const E=T.edits.map(u=>u.range);E.sort((u,f)=>u.end.line===f.end.line?u.end.character===f.end.character?u.start.line===f.start.line?u.start.character-f.start.character:u.start.line-f.start.line:u.end.character-f.end.character:u.end.line-f.end.line);for(let u=0,f=E.length-1;u<f;u++){const m=E[u].end;if(E[u+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=T.edits.map(u=>({range:A.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,a,{setEndOfLine:typeof T.setEndOfLine=="number"?A.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=P}),define(we[78],ye([1,0,65,4,3,2,5,6,162,20,166,17,12,29,15,40,49]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let m=class{constructor(s,i){this._extHostRpc=s,this._logService=i,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new g.Emitter,this._onDidRemoveDocuments=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const i=[],t=[],c=[];if(s.removedDocuments)for(const h of s.removedDocuments){const o=A.URI.revive(h),p=this._documents.get(o);p?.unref()&&(this._documents.delete(o),i.push(p.value))}if(s.addedDocuments)for(const h of s.addedDocuments){const o=A.URI.revive(h.uri);let p=this._documents.get(o);if(p&&o.scheme!==E.Schemas.vscodeNotebookCell&&o.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);p||(p=new f(new v.ExtHostDocumentData(this._extHostRpc.getProxy(R.MainContext.MainThreadDocuments),o,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty)),this._documents.set(o,p),t.push(p.value)),p.ref()}if(s.removedEditors)for(const h of s.removedEditors){const o=this._editors.get(h);this._editors.delete(h),o&&c.push(o)}if(s.addedEditors)for(const h of s.addedEditors){const o=A.URI.revive(h.documentUri);r.ok(this._documents.has(o),`document '${o}' does not exist`),r.ok(!this._editors.has(h.id),`editor '${h.id}' already exists!`);const p=this._documents.get(o).value,_=new P.ExtHostTextEditor(h.id,this._extHostRpc.getProxy(R.MainContext.MainThreadTextEditors),this._logService,new u.Lazy(()=>p.document),h.selections.map(y.Selection.to),h.options,h.visibleRanges.map(D=>y.Range.to(D)),typeof h.editorPosition=="number"?y.ViewColumn.to(h.editorPosition):void 0);this._editors.set(h.id,_)}s.newActiveEditor!==void 0&&(r.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,k.dispose)(i),(0,k.dispose)(c),s.removedDocuments&&this._onDidRemoveDocuments.fire(i),s.addedDocuments&&this._onDidAddDocuments.fire(t),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(h=>h.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const i=this._editors.get(this._activeEditorId);return s?i:i?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=m,e.ExtHostDocumentsAndEditors=m=Ke([Ve(0,l.IExtHostRpcService),Ve(1,d.ILogService)],m),e.IExtHostDocumentsAndEditors=(0,L.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[370],ye([1,0,19,4,6,166,17,10]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class v{constructor(P,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=P.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(P){const y=this._extHostDocumentsAndEditors.allEditors();return P?y:y.map(d=>d.value)}async showTextDocument(P,y,d){let T;typeof y=="number"?T={position:L.ViewColumn.from(y),preserveFocus:d}:typeof y=="object"?T={position:L.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?L.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:T={preserveFocus:!1};const E=await this._proxy.$tryShowTextDocument(P.uri,T),a=E&&this._extHostDocumentsAndEditors.getEditor(E);if(a)return a.value;throw E?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,y){return new A.TextEditorDecorationType(this._proxy,P,y).value}$acceptEditorPropertiesChanged(P,y){const d=this._extHostDocumentsAndEditors.getEditor(P);if(!d)throw new Error("unknown text editor");if(y.options&&d._acceptOptions(y.options),y.selections){const T=y.selections.selections.map(L.Selection.to);d._acceptSelections(T)}if(y.visibleRanges){const T=r.coalesce(y.visibleRanges.map(L.Range.to));d._acceptVisibleRanges(T)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:{...y.options,lineNumbers:L.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const T=R.TextEditorSelectionChangeKind.fromValue(y.selections.source),E=y.selections.selections.map(L.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:E,kind:T})}if(y.visibleRanges){const T=r.coalesce(y.visibleRanges.map(L.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:T})}}$acceptEditorPositionData(P){for(const y in P){const d=this._extHostDocumentsAndEditors.getEditor(y);if(!d)throw new Error("Unknown text editor");const T=L.ViewColumn.to(P[y]);d.value.viewColumn!==T&&(d._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:T}))}}getDiffInformation(P){return Promise.resolve(this._proxy.$getDiffInformation(P))}}e.ExtHostEditors=v}),define(we[371],ye([1,0,2,5,6,3,10,17,24,41,18]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,g.createDecorator)("IExtHostTimeline");class y{constructor(E,a){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(k.MainContext.MainThreadTimeline),a.registerArgumentProcessor({processArgument:(u,f)=>{if(u&&u.$mid===l.MarshalledId.TimelineActionContext)if(this._providers.get(u.source)&&v.ExtensionIdentifier.equals(f,this._providers.get(u.source)?.extension)){const m=u.uri===void 0?void 0:r.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(d(m))?.get(u.handle)}else return;return u}})}async $getTimeline(E,a,u,f){return this._providers.get(E)?.provider.provideTimeline(r.URI.revive(a),u,f)}registerTimelineProvider(E,a,u,f){const m=new A.DisposableStore,n=this.convertTimelineItem(a.id,f,m).bind(this);let s;a.onDidChange&&(s=a.onDidChange(t=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...t,id:a.id}),this));const i=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...a,scheme:E,onDidChange:void 0,async provideTimeline(t,c,h){c?.resetCache&&(m.clear(),i.get(a.id)?.clear());const o=await a.provideTimeline(t,c,h);if(o==null)return;const p=n(t,c);return{...o,source:a.id,items:o.items.map(p)}},dispose(){for(const t of i.values())t.get(a.id)?.clear();s?.dispose(),m.dispose()}},u)}convertTimelineItem(E,a,u){return(f,m)=>{let n;if(m?.cacheResults){let s=this._itemsBySourceAndUriMap.get(E);s===void 0&&(s=new Map,this._itemsBySourceAndUriMap.set(E,s));const i=d(f);n=s.get(i),n===void 0&&(n=new Map,s.set(i,n))}return s=>{const{iconPath:i,...t}=s,c=`${E}|${s.id??s.timestamp}`;n?.set(c,s);let h,o,p;s.iconPath&&(i instanceof L.ThemeIcon?p={id:i.id,color:i.color}:r.URI.isUri(i)?(h=i,o=i):{light:h,dark:o}=i);let _;return L.MarkdownString.isMarkdownString(t.tooltip)?_=R.MarkdownString.from(t.tooltip):(0,P.isString)(t.tooltip)?_=t.tooltip:L.MarkdownString.isMarkdownString(t.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),_=R.MarkdownString.from(t.detail)):(0,P.isString)(t.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),_=t.detail),{...t,id:t.id??void 0,handle:c,source:E,command:s.command?a.toInternal(s.command,u):void 0,icon:h,iconDark:o,themeIcon:p,tooltip:_,accessibilityInformation:s.accessibilityInformation}}}}registerTimelineProviderCore(E,a){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,{provider:E,extension:a}),(0,A.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=y;function d(T){return T?.toString()}}),define(we[372],ye([1,0,241,23,2,4,3,303,9,10,18,19,17,86,21,197,26]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(s,i){if((0,P.isString)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class m extends L.Disposable{constructor(i,t,c){super(),this._proxy=i,this.commands=t,this.logService=c,this.treeViews=new Map,this.treeDragAndDropService=new a.TreeViewsDnDService;function h(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:o=>h(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(p=>h(p)?this.convertArgument(p):p):o})}registerTreeDataProvider(i,t,c){const h=this.createTreeView(i,{treeDataProvider:t},c);return{dispose:()=>h.dispose()}}createTreeView(i,t,c){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],o=t.dragAndDropController?.dragMimeTypes??[],p=!!t.dragAndDropController?.handleDrag,_=!!t.dragAndDropController?.handleDrop,D=this.createExtHostTreeView(i,t,c),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:o,hasHandleDrag:p,hasHandleDrop:_,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},S=this._proxy.$registerTreeViewDataProvider(i,C),I={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,u.checkProposedApiEnabled)(c,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,u.checkProposedApiEnabled)(c,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(b){(0,T.isMarkdownString)(b)&&(0,u.checkProposedApiEnabled)(c,"treeViewMarkdownMessage"),D.message=b},get title(){return D.title},set title(b){D.title=b},get description(){return D.description},set description(b){D.description=b},get badge(){return D.badge},set badge(b){b!==void 0&&l.ViewBadge.isViewBadge(b)?D.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(D.badge=void 0)},reveal:(b,w)=>D.reveal(b,w),dispose:async()=>{await S,this.treeViews.delete(i),D.dispose()}};return this._register(I),I}$getChildren(i,t){const c=this.treeViews.get(i);return c?c.getChildren(t):Promise.reject(new R.NoTreeViewError(i))}async $handleDrop(i,t,c,h,o,p,_,D){const C=this.treeViews.get(i);if(!C)return Promise.reject(new R.NoTreeViewError(i));const S=d.DataTransfer.toDataTransfer(c,async I=>(await this._proxy.$resolveDropFileData(i,t,I)).buffer);return _===i&&D&&await this.addAdditionalTransferItems(S,C,D,o,p),C.onDrop(S,h,o)}async addAdditionalTransferItems(i,t,c,h,o){const p=this.treeDragAndDropService.removeDragOperationTransfer(o);if(p)(await p)?.forEach((_,D)=>{_&&i.set(D,_)});else if(o&&t.handleDrag){const _=t.handleDrag(c,i,h);this.treeDragAndDropService.addDragOperationTransfer(o,_),await _}return i}async $handleDrag(i,t,c,h){const o=this.treeViews.get(i);if(!o)return Promise.reject(new R.NoTreeViewError(i));const p=await this.addAdditionalTransferItems(new l.DataTransfer,o,t,h,c);if(!(!p||h.isCancellationRequested))return d.DataTransfer.from(p)}async $hasResolve(i){const t=this.treeViews.get(i);if(!t)throw new R.NoTreeViewError(i);return t.hasResolve}$resolve(i,t,c){const h=this.treeViews.get(i);if(!h)throw new R.NoTreeViewError(i);return h.resolveTreeItem(t,c)}$setExpanded(i,t,c){const h=this.treeViews.get(i);if(!h)throw new R.NoTreeViewError(i);h.setExpanded(t,c)}$setSelectionAndFocus(i,t,c){const h=this.treeViews.get(i);if(!h)throw new R.NoTreeViewError(i);h.setSelectionAndFocus(t,c)}$setVisible(i,t){const c=this.treeViews.get(i);if(!c){if(!t)return;throw new R.NoTreeViewError(i)}c.setVisible(t)}$changeCheckboxState(i,t){const c=this.treeViews.get(i);if(!c)throw new R.NoTreeViewError(i);c.setCheckboxState(t)}createExtHostTreeView(i,t,c){const h=this._register(new n(i,t,this._proxy,this.commands.converter,this.logService,c));return this.treeViews.set(i,h),h}convertArgument(i){const t=this.treeViews.get(i.$treeViewId);return t&&"$treeItemHandle"in i?t.getExtensionElement(i.$treeItemHandle):t&&"$focusedTreeItem"in i&&i.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=m;class n extends L.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(i=>this.getExtensionElement(i)).filter(i=>!(0,P.isUndefinedOrNull)(i))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(i,t,c,h,o,p){if(super(),this.viewId=i,this.proxy=c,this.commands=h,this.logService=o,this.extension=p,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new A.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new A.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new E.CancellationTokenSource,p.contributes&&p.contributes.views)for(const S in p.contributes.views)for(const I of p.contributes.views[S])I.id===i&&(this._title=I.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(S=>{Array.isArray(S)&&S.length===0||this._onDidChangeData.fire({message:!1,element:S})}));let _,D;const C=A.Event.debounce(this._onDidChangeData.event,(S,I)=>(S||(S={message:!1,elements:[]}),I.element!==!1&&(_||(_=new Promise(b=>D=b),this.refreshPromise=this.refreshPromise.then(()=>_)),Array.isArray(I.element)?S.elements.push(...I.element):S.elements.push(I.element)),I.message&&(S.message=!0),S),200,!0);this._register(C(({message:S,elements:I})=>{I.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=D;return _=null,this.refresh(I).then(()=>b())})),S&&this.proxy.$setMessage(this.viewId,d.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(i){const t=i?this.getExtensionElement(i):void 0;if(i&&!t)return this.logService.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let c=this.getChildrenNodes(i);return c||(c=await this.fetchChildrenNodes(t)),c?c.map(h=>h.item):void 0}getExtensionElement(i){return this.elements.get(i)}reveal(i,t){t=t||{select:!0,focus:!1};const c=(0,P.isUndefinedOrNull)(t.select)?!0:t.select,h=(0,P.isUndefinedOrNull)(t.focus)?!1:t.focus,o=(0,P.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.refreshPromise.then(()=>this.resolveUnknownParentChain(i)).then(p=>this.resolveTreeNode(i,p[p.length-1]).then(_=>this.proxy.$reveal(this.viewId,{item:_.item,parentChain:p.map(D=>D.item)},{select:c,focus:h,expand:o})),p=>this.logService.error(p)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:h,expand:o})}get message(){return this._message}set message(i){this._message=i,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(i){this._title=i,this.proxy.$setTitle(this.viewId,i,this._description)}get description(){return this._description}set description(i){this._description=i,this.proxy.$setTitle(this.viewId,this._title,i)}get badge(){return this._badge}set badge(i){this._badge?.value===i?.value&&this._badge?.tooltip===i?.tooltip||(this._badge=d.ViewBadge.from(i),this.proxy.$setBadge(this.viewId,i))}setExpanded(i,t){const c=this.getExtensionElement(i);c&&(t?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelectionAndFocus(i,t){const c=!(0,y.equals)(this._selectedHandles,i);this._selectedHandles=i;const h=this._focusedHandle!==t;this._focusedHandle=t,c&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),h&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this._visible&&(this._visible=i,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(i){const t=(await Promise.all(i.map(async c=>{const h=this.getExtensionElement(c.treeItemHandle);return h?{extensionItem:h,treeItem:await this.dataProvider.getTreeItem(h),newState:c.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(c=>c!==void 0);t.forEach(c=>{c.treeItem.checkboxState=c.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(c=>[c.extensionItem,c.newState])})}async handleDrag(i,t,c){const h=[];for(const o of i){const p=this.getExtensionElement(o);p&&h.push(p)}if(!(!this.dndController?.handleDrag||h.length===0))return await this.dndController.handleDrag(h,t,c),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(i,t,c){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.dndController?.handleDrop))return(0,v.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(h,i,c):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(i,t){if(!this.dataProvider.resolveTreeItem)return;const c=this.elements.get(i);if(c){const h=this.nodes.get(c);if(h){const o=await this.dataProvider.resolveTreeItem(h.extensionItem,c,t)??h.extensionItem;return this.validateTreeItem(o),h.item.tooltip=this.getTooltip(o.tooltip),h.item.command=this.getCommand(h.disposableStore,o.command),h.item}}}resolveUnknownParentChain(i){return this.resolveParent(i).then(t=>t?this.resolveUnknownParentChain(t).then(c=>this.resolveTreeNode(t,c[c.length-1]).then(h=>(c.push(h),c))):Promise.resolve([]))}resolveParent(i){const t=this.nodes.get(i);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,v.asPromise)(()=>this.dataProvider.getParent(i))}resolveTreeNode(i,t){const c=this.nodes.get(i);return c?Promise.resolve(c):(0,v.asPromise)(()=>this.dataProvider.getTreeItem(i)).then(h=>this.createHandle(i,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const o=this.getExtensionElement(h);if(o){const p=this.nodes.get(o);if(p)return Promise.resolve(p)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(i){if(i){let t;if(typeof i=="string"){const c=this.getExtensionElement(i);t=c?this.nodes.get(c):void 0}else t=i;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(i){this.clearChildren(i);const t=new E.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=i?this.nodes.get(i):void 0,h=await this.dataProvider.getChildren(i);if(t.token.isCancellationRequested)return;const o=(0,y.coalesce)(h||[]),p=await Promise.all((0,y.coalesce)(o).map(D=>this.dataProvider.getTreeItem(D)));if(t.token.isCancellationRequested)return;const _=p.map((D,C)=>D?this.createAndRegisterTreeNode(o[C],D,c):null);return(0,y.coalesce)(_)}finally{t.dispose()}}refresh(i){if(i.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new E.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(i);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(i){const t=new Set,c=i.map(o=>this.nodes.get(o));for(const o of c)if(o&&!t.has(o.item.handle)){let p=o;for(;p&&p.parent&&c.findIndex(_=>p&&p.parent&&_&&_.item.handle===p.parent.item.handle)===-1;){const _=this.elements.get(p.parent.item.handle);p=_?this.nodes.get(_):void 0}p&&!p.parent&&t.add(o.item.handle)}const h=[];return t.forEach(o=>{const p=this.elements.get(o);if(p){const _=this.nodes.get(p);_&&(!_.parent||!t.has(_.parent.item.handle))&&h.push(o)}}),h}refreshHandles(i){const t={};return Promise.all(i.map(c=>this.refreshNode(c).then(h=>{h&&(t[c]=h.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(i){const t=this.getExtensionElement(i);if(t){const c=this.nodes.get(t);if(c)return this.clearChildren(t),(0,v.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(h=>{if(h){const o=this.createTreeNode(t,h,c.parent);return this.updateNodeCache(t,o,c,c.parent),c.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(i,t,c){const h=this.createTreeNode(i,t,c);if(t.id&&this.elements.has(h.item.handle))throw new Error((0,r.localize)(0,null,t.id));return this.addNodeToCache(i,h),this.addNodeToParentCache(h,c),h}getTooltip(i){return l.MarkdownString.isMarkdownString(i)?d.MarkdownString.from(i):i}getCommand(i,t){return t?{...this.commands.toInternal(t,i),originalId:t.command}:void 0}getCheckbox(i){if(i.checkboxState===void 0)return;let t,c,h;return typeof i.checkboxState=="number"?t=i.checkboxState:(t=i.checkboxState.state,c=i.checkboxState.tooltip,h=i.checkboxState.accessibilityInformation),{isChecked:t===l.TreeItemCheckboxState.Checked,tooltip:c,accessibilityInformation:h}}validateTreeItem(i){if(!l.TreeItem.isTreeItem(i,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(i,t,c){this.validateTreeItem(t);const h=this._register(new L.DisposableStore),o=this.createHandle(i,t,c),p=this.getLightIconPath(t);return{item:{handle:o,parentHandle:c?c.item.handle:void 0,label:f(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(h,t.command),contextValue:t.contextValue,icon:p,iconDark:this.getDarkIconPath(t)||p,themeIcon:this.getThemeIcon(t),collapsibleState:(0,P.isUndefinedOrNull)(t.collapsibleState)?l.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:c,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(i){return i.iconPath instanceof l.ThemeIcon?i.iconPath:void 0}createHandle(i,{id:t,label:c,resourceUri:h},o,p){if(t)return`${n.ID_HANDLE_PREFIX}/${t}`;const _=f(c,this.extension),D=o?o.item.handle:n.LABEL_HANDLE_PREFIX;let C=_?_.label:h?(0,g.basename)(h):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const S=this.nodes.has(i)?this.nodes.get(i).item.handle:void 0,I=this.getChildrenNodes(o)||[];let b,w=0;do{if(b=`${D}/${w}:${C}`,p||!this.elements.has(b)||S===b)break;w++}while(w<=I.length);return b}getLightIconPath(i){if(i.iconPath&&!(i.iconPath instanceof l.ThemeIcon))return typeof i.iconPath=="string"||k.URI.isUri(i.iconPath)?this.getIconPath(i.iconPath):this.getIconPath(i.iconPath.light)}getDarkIconPath(i){if(i.iconPath&&!(i.iconPath instanceof l.ThemeIcon)&&i.iconPath.dark)return this.getIconPath(i.iconPath.dark)}getIconPath(i){return k.URI.isUri(i)?i:k.URI.file(i)}addNodeToCache(i,t){this.elements.set(t.item.handle,i),this.nodes.set(i,t)}updateNodeCache(i,t,c,h){this.elements.delete(t.item.handle),this.nodes.delete(i),t.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(i,t);const o=this.getChildrenNodes(h)||[],p=o.filter(_=>_.item.handle===c.item.handle)[0];p&&o.splice(o.indexOf(p),1,t)}addNodeToParentCache(i,t){t?(t.children||(t.children=[]),t.children.push(i)):(this.roots||(this.roots=[]),this.roots.push(i))}clearChildren(i){if(i){const t=this.nodes.get(i);if(t){if(t.children)for(const c of t.children){const h=this.elements.get(c.item.handle);h&&this.clear(h)}t.children=void 0}}else this.clearAll()}clear(i){const t=this.nodes.get(i);if(t){if(t.children)for(const c of t.children){const h=this.elements.get(c.item.handle);h&&this.clear(h)}this.nodes.delete(i),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(i=>i.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(we[373],ye([1,0,4,3,2,32,17,97,6,10]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class P extends g.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;#d;constructor(E,a,u,f){super(),this.#o=void 0,this.#l=!0,this.#u=!1,this.#h=this._register(new r.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new r.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=E,this.#t=a,this.#n=u,this.#i=f.viewType,this.#s=f.panelOptions,this.#o=f.viewColumn,this.#r=f.title,this.#c=f.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(E){this.assertNotDisposed(),this.#r!==E&&(this.#r=E,this.#t.$setTitle(this.#e,E))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(E){this.assertNotDisposed(),this.#a!==E&&(this.#a=E,this.#t.$setIconPath(this.#e,k.URI.isUri(E)?{light:E,dark:E}:E))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#c}get visible(){return this.assertNotDisposed(),this.#l}_updateViewState(E){this.#u||(this.active!==E.active||this.visible!==E.visible||this.viewColumn!==E.viewColumn)&&(this.#c=E.active,this.#l=E.visible,this.#o=E.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(E,a){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof E>"u"?void 0:L.ViewColumn.from(E),preserveFocus:!!a})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class y extends g.Disposable{static newHandle(){return(0,A.generateUuid)()}constructor(E,a,u){super(),this.webviews=a,this.workspace=u,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=E.getProxy(v.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(E=>E.dispose()),this._webviewPanels.clear()}createWebviewPanel(E,a,u,f,m={}){const n=typeof f=="object"?f.viewColumn:f,s={viewColumn:L.ViewColumn.from(n),preserveFocus:typeof f=="object"&&!!f.preserveFocus},i=(0,R.shouldSerializeBuffersForPostMessage)(E),t=y.newHandle();this._proxy.$createWebviewPanel((0,R.toExtensionData)(E),t,a,{title:u,panelOptions:d(m),webviewOptions:(0,R.serializeWebviewOptions)(E,this.workspace,m),serializeBuffersForPostMessage:i},s);const c=this.webviews.createNewWebview(t,m,E);return this.createNewWebviewPanel(t,a,u,n,m,c,!0)}$onDidChangeWebviewPanelViewStates(E){const a=Object.keys(E);a.sort((u,f)=>{const m=E[u],n=E[f];return m.active?1:n.active?-1:+m.visible-+n.visible});for(const u of a){const f=this.getWebviewPanel(u);if(!f)continue;const m=E[u];f._updateViewState({active:m.active,visible:m.visible,viewColumn:L.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(E){this.getWebviewPanel(E)?.dispose(),this._webviewPanels.delete(E),this.webviews.deleteWebview(E)}registerWebviewPanelSerializer(E,a,u){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:u,extension:E}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(E)}),new l.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(E,a,u,f){const m=this._serializers.get(a);if(!m)throw new Error(`No serializer found for '${a}'`);const{serializer:n,extension:s}=m,i=this.webviews.createNewWebview(E,u.webviewOptions,s),t=this.createNewWebviewPanel(E,a,u.title,f,u.panelOptions,i,u.active);await n.deserializeWebviewPanel(t,u.state)}createNewWebviewPanel(E,a,u,f,m,n,s){const i=new P(E,this._proxy,n,{viewType:a,title:u,viewColumn:f,panelOptions:m,active:s});return this._webviewPanels.set(E,i),i}getWebviewPanel(E){return this._webviewPanels.get(E)}}e.ExtHostWebviewPanels=y;function d(T){return{enableFindWidget:T.enableFindWidget,retainContextWhenHidden:T.retainContextWhenHidden}}}),define(we[374],ye([1,0,4,3,97,17,6,10]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends g.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;constructor(y,d,T,E,a,u){super(),this.#s=!1,this.#c=this._register(new r.Emitter),this.onDidChangeVisibility=this.#c.event,this.#u=this._register(new r.Emitter),this.onDidDispose=this.#u.event,this.#i=T,this.#a=E,this.#e=y,this.#t=d,this.#n=a,this.#r=u}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#c;#u;get title(){return this.assertNotDisposed(),this.#a}set title(y){this.assertNotDisposed(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.assertNotDisposed(),this.#o}set description(y){this.assertNotDisposed(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#c.fire())}get badge(){return this.assertNotDisposed(),this.#l}set badge(y){this.assertNotDisposed(),!(y?.value===this.#l?.value&&y?.tooltip===this.#l?.tooltip)&&(this.#l=A.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.assertNotDisposed(),this.#t.$show(this.#e,!!y)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class l{constructor(y,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(y,d,T,E){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:T,extension:y}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(y),d,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(y)}),new R.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(y,d,T,E,a){const u=this._viewProviders.get(d);if(!u)throw new Error(`No view provider found for '${d}'`);const{provider:f,extension:m}=u,n=this._extHostWebview.createNewWebview(y,{},m),s=new v(y,this._proxy,d,T,n,!0);this._webviewViews.set(y,s),await f.resolveWebviewView(s,{state:E},a)}async $onDidChangeWebviewViewVisibility(y,d){this.getWebviewView(y)._setVisible(d)}async $disposeWebviewView(y){const d=this.getWebviewView(y);this._webviewViews.delete(y),d.dispose(),this._extHostWebview.deleteWebview(y)}getWebviewView(y){const d=this._webviewViews.get(y);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=l}),define(we[375],ye([1,0,75,15,12,276,28,11]),function(he,e,r,g,k,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let v=class{constructor(y,d){y.addFileSystemProvider(g.Schemas.file,new l(d),{isCaseSensitive:R.isLinux})}};e.ExtHostDiskFileSystemProvider=v,e.ExtHostDiskFileSystemProvider=v=Ke([Ve(0,r.IExtHostConsumerFileSystem),Ve(1,k.ILogService)],v);class l{constructor(y){this.logService=y,this.impl=new A.DiskFileSystemProvider(this.logService)}async stat(y){const d=await this.impl.stat(y);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(y){return this.impl.readdir(y)}createDirectory(y){return this.impl.mkdir(y)}readFile(y){return this.impl.readFile(y)}writeFile(y,d,T){return this.impl.writeFile(y,d,{...T,unlock:!1,atomic:!1})}delete(y,d){return this.impl.delete(y,{...d,useTrash:!1,atomic:!1})}rename(y,d,T){return this.impl.rename(y,d,T)}copy(y,d,T){return this.impl.copy(y,d,T)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(y,d){throw new Error("Method not implemented.")}}}),define(we[376],ye([1,0,16,67,32,37,3,6,2,20]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let P=class extends L.Disposable{constructor(d,T){super();const E=d.getProxy(R.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async a=>{const u=v.URI.file((0,r.join)((0,g.tmpdir)(),(0,k.generateUuid)()));return await E.$download(a,u),u})}};e.ExtHostDownloadService=P,e.ExtHostDownloadService=P=Ke([Ve(0,l.IExtHostRpcService),Ve(1,A.IExtHostCommands)],P)}),define(we[377],ye([1,0,58,16,2,98,3,15,9,34]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class P extends A.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const c=await super._getWorkspaceStorageURI(t);if(c.scheme!==R.Schemas.file)return c;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${c.fsPath}.`),c;const h=c.fsPath;let o=0;do{let p;o===0?p=h:p=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${o}`:`${h}-${o}`,await y(p);const _=g.join(p,"vscode.lock"),D=await a(this._logService,_,!1);if(D)return this._workspaceStorageLock=D,process.on("exit",()=>{D.dispose()}),k.URI.file(p);o++}while(o<10);return c}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=P;async function y(i){try{await l.Promises.stat(i);return}catch{}try{await l.Promises.mkdir(i,{recursive:!0})}catch{}}const d=1e3,T=10*60*1e3;class E extends L.Disposable{constructor(t,c){super(),this.logService=t,this.filename=c,this._timer=this._register(new v.IntervalTimer),this._timer.cancelAndSet(async()=>{const h=await u(t,c);(!h||h.pid!==process.pid)&&(t.info(`Lock '${c}': The lock was lost unexpectedly.`),this._timer.cancel());try{await l.Promises.utimes(c,new Date,new Date)}catch(o){t.error(o),t.info(`Lock '${c}': Could not update mtime.`)}},d)}dispose(){super.dispose();try{r.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const c={pid:process.pid,willReleaseAt:Date.now()+t};await l.Promises.writeFile(this.filename,JSON.stringify(c),{flag:"w"})}catch(c){this.logService.error(c)}}}async function a(i,t,c){try{const o={pid:process.pid,willReleaseAt:0};await l.Promises.writeFile(t,JSON.stringify(o),{flag:"wx"})}catch(o){i.error(o)}const h=await u(i,t);return!h||h.pid!==process.pid?c?(i.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(i.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(i,t)):(i.info(`Lock '${t}': Lock acquired.`),new E(i,t))}async function u(i,t){let c;try{c=await l.Promises.readFile(t)}catch(h){return i.error(h),null}try{return JSON.parse(String(c))}catch(h){return i.error(h),null}}async function f(i,t){let c;try{c=await l.Promises.stat(t)}catch(h){return i.error(h),0}return c.mtime.getTime()}function m(i){try{return process.kill(i,0),!0}catch{return!1}}async function n(i,t){const c=await u(i,t);if(!c)return i.info(`Lock '${t}': Could not read pid of lock holder.`),s(i,t);if(c.willReleaseAt){let D=c.willReleaseAt-Date.now();if(D<5e3){for(D>0?i.info(`Lock '${t}': The lockfile is scheduled to be released in ${D} ms.`):i.info(`Lock '${t}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,v.timeout)(Math.min(100,D)),await f(i,t)===0)return s(i,t);D=c.willReleaseAt-Date.now()}return s(i,t)}}if(!m(c.pid))return i.info(`Lock '${t}': The pid ${c.pid} appears to be gone.`),s(i,t);const h=await f(i,t),o=Date.now()-h;if(o<=T)return i.info(`Lock '${t}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;i.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,v.timeout)(2e3);const p=await f(i,t),_=Date.now()-p;return _<=T?(i.info(`Lock '${t}': The lock does not look stale, elapsed: ${_} ms, giving up.`),null):(i.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),s(i,t))}async function s(i,t){i.info(`Lock '${t}': Deleting a stale lock.`);try{await l.Promises.unlink(t)}catch{}return a(i,t,!0)}}),define(we[378],ye([1,0,32,20,46,37]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let L=class extends k.BaseExtHostTerminalService{constructor(v,l){super(!0,v,l)}createTerminal(v,l,P){return this.createTerminalFromOptions({name:v,shellPath:l,shellArgs:P})}createTerminalFromOptions(v,l){const P=new k.ExtHostTerminal(this._proxy,(0,r.generateUuid)(),v,v.name);return this._terminals.push(P),P.create(v,this._serializeParentTerminal(v,l)),P.value}};e.ExtHostTerminalService=L,e.ExtHostTerminalService=L=Ke([Ve(0,A.IExtHostCommands),Ve(1,g.IExtHostRpcService)],L)}),define(we[379],ye([1,0,4,36,35,5]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new k.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new k.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new k.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)("outputService");var L;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new r.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new r.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(l){this.channels.has(l.id)||(this.channels.set(l.id,l),this._onDidRegisterChannel.fire(l.id))}getChannels(){const l=[];return this.channels.forEach(P=>l.push(P)),l}getChannel(l){return this.channels.get(l)}removeChannel(l){this.channels.delete(l),this._onDidRemoveChannel.fire(l)}}g.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new k.RawContextKey("activeOutputChannel","")}),define(we[167],ye([1,0,6,5,20,24,12,379,75,30,63,202,22,18,28,4,3]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class f extends L.AbstractMessageLogger{get disposed(){return this._disposed}constructor(i,t,c,h,o){super(),this.id=i,this.name=t,this.logger=c,this.proxy=h,this.extension=o,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(c.getLevel()),this._register(c.onDidChangeLogLevel(p=>this.setLevel(p)))}get logLevel(){return this.getLevel()}appendLine(i){this.append(i+`
`)}append(i){this.info(i)}clear(){const i=this.offset;this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Clear,i)}replace(i){const t=this.offset;this.info(i),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(i,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof i=="boolean"?i:t))}hide(){this.proxy.$close(this.id)}log(i,t){this.offset+=d.VSBuffer.fromString(t).byteLength,(0,L.log)(this.logger,i,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class m extends f{appendLine(i){this.append(i)}}let n=class{constructor(i,t,c,h,o,p){this.initData=t,this.extHostFileSystem=c,this.extHostFileSystemInfo=h,this.loggerService=o,this.logService=p,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=i.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(i){this.visibleChannelId=i;for(const[t,c]of this.channels)c.visible=t===this.visibleChannelId}createOutputChannel(i,t,c){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,o=(0,T.isString)(t)?t:void 0;if((0,T.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let p;const _=this.initData.environment.extensionLogLevel?.find(([C])=>A.ExtensionIdentifier.equals(c.identifier,C))?.[1];_&&(p=(0,L.parseLogLevel)(_));const D=h?this.doCreateLogOutputChannel(i,p,c):this.doCreateOutputChannel(i,o,c);return D.then(C=>{this.channels.set(C.id,C),C.visible=C.id===this.visibleChannelId}),h?this.createExtHostLogOutputChannel(i,p??this.logService.getLevel(),D):this.createExtHostOutputChannel(i,D)}async doCreateOutputChannel(i,t,c){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const h=await this.outputDirectoryPromise,o=this.extHostFileSystemInfo.extUri.joinPath(h,`${this.namePool++}-${i.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.loggerService.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),_=await this.proxy.$register(i,o,t,c.identifier.value);return new f(_,i,p,this.proxy,c)}async doCreateLogOutputChannel(i,t,c){const h=await this.createExtensionLogDirectory(c),o=i.replace(/[\\/:\*\?"<>\|]/g,""),p=this.extHostFileSystemInfo.extUri.joinPath(h,`${o}.log`),_=`${c.identifier.value}.${o}`,D=this.loggerService.createLogger(p,{id:_,name:i,logLevel:t,extensionId:c.identifier.value});return new m(_,i,D,this.proxy,c)}createExtensionLogDirectory(i){let t=this.extensionLogDirectoryPromise.get(i.identifier.value);if(!t){const c=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,i.identifier.value);this.extensionLogDirectoryPromise.set(i.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(c)}catch(h){if((0,E.toFileSystemProviderErrorCode)(h)!==E.FileSystemProviderErrorCode.FileExists)throw h}return c})())}return t}createExtHostOutputChannel(i,t){let c=!1;const h=()=>{if(c)throw new Error("Channel has been closed")};return{get name(){return i},append(o){h(),t.then(p=>p.append(o))},appendLine(o){h(),t.then(p=>p.appendLine(o))},clear(){h(),t.then(o=>o.clear())},replace(o){h(),t.then(p=>p.replace(o))},show(o,p){h(),t.then(_=>_.show(o,p))},hide(){h(),t.then(o=>o.hide())},dispose(){c=!0,t.then(o=>o.dispose())}}}createExtHostLogOutputChannel(i,t,c){const h=new u.DisposableStore,o=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},p=h.add(new a.Emitter);function _(D){t=D,p.fire(D)}return c.then(D=>{h.add(D),D.logLevel!==t&&_(D.logLevel),h.add(D.onDidChangeLogLevel(C=>_(C)))}),{...this.createExtHostOutputChannel(i,c),get logLevel(){return t},onDidChangeLogLevel:p.event,trace(D,...C){o(),c.then(S=>S.trace(D,...C))},debug(D,...C){o(),c.then(S=>S.debug(D,...C))},info(D,...C){o(),c.then(S=>S.info(D,...C))},warn(D,...C){o(),c.then(S=>S.warn(D,...C))},error(D,...C){o(),c.then(S=>S.error(D,...C))},dispose(){h.dispose()}}}};e.ExtHostOutputService=n,e.ExtHostOutputService=n=Ke([Ve(0,k.IExtHostRpcService),Ve(1,l.IExtHostInitDataService),Ve(2,v.IExtHostConsumerFileSystem),Ve(3,P.IExtHostFileSystemInfo),Ve(4,L.ILoggerService),Ve(5,L.ILogService)],n),e.IExtHostOutputService=(0,g.createDecorator)("IExtHostOutputService")}),define(we[168],ye([1,0,5,9]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(k){let A=1/0;for(let R=0;R<this.maxSampleCount;R++){const v=await k.getRoundTripTime();if(v===void 0)return;A=Math.min(A,v/2),await(0,g.timeout)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(A):L=this.initial.reduce((R,v)=>R+v,0)/this.initial.length,this.lastMeasurement={initial:L,current:A,average:this.average.reduce((R,v)=>R+v,0)/this.average.length,high:typeof L>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(we[380],ye([1,0,245,70,36,45,44,3,4,168,11,25,9,149]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWindowConfiguration=e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.windowConfigurationNodeBase=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,r.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:g.ConfigurationScope.APPLICATION,title:(0,r.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,r.localize)(3,null),type:"object",order:101}),e.windowConfigurationNodeBase=Object.freeze({id:"window",order:8,title:(0,r.localize)(4,null),type:"object"}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new v.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const a=new E;k.Registry.add(e.Extensions.ConfigurationMigration,a);let u=class extends R.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,t){super(),this.configurationService=i,this.workspaceService=t,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async c=>{for(const h of c.added)await this.migrateConfigurationsForFolder(h,a.migrations)})),this.migrateConfigurations(a.migrations),this._register(a.onDidRegisterConfigurationMigration(c=>this.migrateConfigurations(c)))}async migrateConfigurations(i){await this.migrateConfigurationsForFolder(void 0,i);for(const t of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(t,i)}async migrateConfigurationsForFolder(i,t){await Promise.all([t.map(c=>this.migrateConfigurationsForFolderAndOverride(c,i?.uri))])}async migrateConfigurationsForFolderAndOverride(i,t){const c=this.configurationService.inspect(i.key,{resource:t}),h=this.workspaceService.getWorkbenchState()===A.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[o,p]of h){const _=c[o];if(!_)continue;const D=[];if(_.value!==void 0){const C=await this.runMigration(i,o,_.value,t,void 0);for(const S of C??[])D.push([S,[]])}for(const{identifiers:C,value:S}of _.overrides??[])if(S!==void 0){const I=await this.runMigration(i,o,S,t,C);for(const b of I??[])D.push([b,C])}D.length&&await Promise.allSettled(D.map(async([[C,S],I])=>this.configurationService.updateValue(C,S.value,{resource:t,overrideIdentifiers:I},p)))}}async runMigration(i,t,c,h,o){const p=D=>{const S=this.configurationService.inspect(D,{resource:h})[t];if(S)return o?S.overrides?.find(({identifiers:I})=>(0,y.equals)(I,o))?.value:S.value},_=await i.migrateFn(c,p);return Array.isArray(_)?_:[[i.key,_]]}};e.ConfigurationMigrationWorkbenchContribution=u,e.ConfigurationMigrationWorkbenchContribution=u=Ke([Ve(0,L.IConfigurationService),Ve(1,A.IWorkspaceContextService)],u);let f=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.remoteAgentService=i,this._ready=new d.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!P.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==P.OperatingSystem.Windows)return;k.Registry.as(g.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(5,null)},default:[],markdownDescription:(0,r.localize)(6,null),scope:g.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(7,null),scope:g.ConfigurationScope.MACHINE}}})}};e.DynamicWorkbenchSecurityConfiguration=f,e.DynamicWorkbenchSecurityConfiguration=f=Ke([Ve(0,l.IRemoteAgentService)],f);const m="window.newWindowProfile";let n=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(i,t){super(),this.userDataProfilesService=i,this.configurationService=t,this.registerNewWindowProfileConfiguration(),this._register(this.userDataProfilesService.onDidChangeProfiles(c=>this.registerNewWindowProfileConfiguration())),this.setNewWindowProfile(),this.checkAndResetNewWindowProfileConfig(),this._register(t.onDidChangeConfiguration(c=>{c.source!==L.ConfigurationTarget.DEFAULT&&c.affectsConfiguration(m)&&this.setNewWindowProfile()})),this._register(this.userDataProfilesService.onDidChangeProfiles(()=>this.checkAndResetNewWindowProfileConfig()))}registerNewWindowProfileConfiguration(){const i=k.Registry.as(g.Extensions.Configuration),t={...e.windowConfigurationNodeBase,properties:{[m]:{type:["string","null"],default:null,enum:[...this.userDataProfilesService.profiles.map(c=>c.name),null],enumItemLabels:[...this.userDataProfilesService.profiles.map(c=>""),(0,r.localize)(8,null)],description:(0,r.localize)(9,null),scope:g.ConfigurationScope.APPLICATION}}};this.configurationNode?i.updateConfigurations({add:[t],remove:[this.configurationNode]}):i.registerConfiguration(t),this.configurationNode=t}setNewWindowProfile(){const i=this.configurationService.getValue(m);this.newWindowProfile=i?this.userDataProfilesService.profiles.find(t=>t.name===i):void 0}checkAndResetNewWindowProfileConfig(){const i=this.configurationService.getValue(m);if(!i)return;const t=this.newWindowProfile?this.userDataProfilesService.profiles.find(c=>c.id===this.newWindowProfile.id):void 0;i!==t?.name&&this.configurationService.updateValue(m,t?.name)}};e.DynamicWindowConfiguration=n,e.DynamicWindowConfiguration=n=Ke([Ve(0,T.IUserDataProfilesService),Ve(1,L.IConfigurationService)],n)}),define(we[381],ye([1,0,39,15,16,23,257,380,70,5,36]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=a,e.globMatchesResource=u,e.IEditorResolverService=(0,l.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const y=P.Registry.as(v.Extensions.Configuration),d={...R.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(d);var T;(function(f){f.builtin="builtin",f.option="option",f.exclusive="exclusive",f.default="default"})(T||(e.RegisteredEditorPriority=T={}));var E;(function(f){f[f.ABORT=1]="ABORT",f[f.NONE=2]="NONE"})(E||(e.ResolvedStatus=E={}));function a(f){switch(f){case T.exclusive:return 5;case T.default:return 4;case T.builtin:return 3;case T.option:default:return 1}}function u(f,m){if(new Set([g.Schemas.extension,g.Schemas.webviewPanel,g.Schemas.vscodeWorkspaceTrust,g.Schemas.vscodeSettings]).has(m.scheme))return!1;const i=typeof f=="string"&&f.indexOf(k.posix.sep)>=0?`${m.scheme}:${m.path}`:(0,A.basename)(m);return r.match(typeof f=="string"?f.toLowerCase():f,i.toLowerCase())}}),define(we[382],ye([1,0,33,15,16,11,23,2,5,295,45,156,168]),function(he,e,r,g,k,A,L,R,v,l,P,y,d){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,v.createDecorator)("pathService");let E=T=class{constructor(u,f,m,n){this.localUserHome=u,this.remoteAgentService=f,this.environmentService=m,this.contextService=n,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const s=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=s?.userHome??u})()}hasValidBasename(u,f,m){return typeof f=="string"||typeof f>"u"?this.resolveOS.then(n=>this.doHasValidBasename(u,n,f)):this.doHasValidBasename(u,f,m)}doHasValidBasename(u,f,m){return u.scheme===g.Schemas.file||u.scheme===g.Schemas.vscodeRemote?(0,r.isValidBasename)(m??(0,L.basename)(u),f===A.OperatingSystem.Windows):!0}get defaultUriScheme(){return T.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,f){if(u.remoteAuthority)return g.Schemas.vscodeRemote;const m=(0,l.getVirtualWorkspaceScheme)(f.getWorkspace());if(m)return m;const n=f.getWorkspace().folders[0];if(n)return n.uri.scheme;const s=f.getWorkspace().configuration;return s?s.scheme:g.Schemas.file}userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===A.OperatingSystem.Windows?k.win32:k.posix)}async fileURI(u){let f="";if(await this.resolveOS===A.OperatingSystem.Windows&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const n=u.indexOf("/",2);n===-1?(f=u.substring(2),u="/"):(f=u.substring(2,n),u=u.substring(n)||"/")}return R.URI.from({scheme:g.Schemas.file,authority:f,path:u,query:"",fragment:""})}};e.AbstractPathService=E,e.AbstractPathService=E=T=Ke([Ve(1,d.IRemoteAgentService),Ve(2,y.IWorkbenchEnvironmentService),Ve(3,P.IWorkspaceContextService)],E)}),define(we[383],ye([1,0,259,60,4,61,3,2,44,265,12,71,150,93,45,156,26,21,18,25,35]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.OnPortForward=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0,e.parseAddress=o,e.mapHasAddress=D,e.mapHasAddressLocalhostOrAllInterfaces=C,e.makeAddress=S,e.isCandidatePort=b;const i=10*1e3,t="remote.tunnels.toRestore",c="remote.tunnels.toRestoreExpiration",h=1e3*60*60*24*14;e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new s.RawContextKey("forwardedPortsViewEnabled",!1,r.localize(0,null));function o(O){const U=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(U)return{host:U[1]?.substring(0,U[1].length-1)||"localhost",port:Number(U[2])}}var p;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})(p||(e.TunnelCloseReason=p={}));var _;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(_||(e.TunnelSource=_={})),e.UserTunnelSource={source:_.User,description:r.localize(1,null)},e.AutoTunnelSource={source:_.Auto,description:r.localize(2,null)};function D(O,U,x){const B=O.get(S(U,x));if(B)return B;if((0,T.isLocalhost)(U))for(const F of T.LOCALHOST_ADDRESSES){const M=S(F,x);if(O.has(M))return O.get(M)}else if((0,T.isAllInterfaces)(U))for(const F of T.ALL_INTERFACES_ADDRESSES){const M=S(F,x);if(O.has(M))return O.get(M)}}function C(O,U,x){const B=D(O,U,x);if(B)return B;const F=(0,T.isAllInterfaces)(U)?"localhost":(0,T.isLocalhost)(U)?"0.0.0.0":void 0;if(F)return D(O,F,x)}function S(O,U){return O+":"+U}var I;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})(I||(e.OnPortForward=I={}));function b(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}class w extends L.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(U){super(),this.configurationService=U,this.portsAttributes=[],this._onDidChangeAttributes=new k.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(U.onDidChangeConfiguration(x=>{(x.affectsConfiguration(w.SETTING)||x.affectsConfiguration(w.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(U,x,B){let F=this.findNextIndex(U,x,B,this.portsAttributes,0);const M={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const K=this.portsAttributes[F];K.key===U?(M.onAutoForward=K.onAutoForward??M.onAutoForward,M.elevateIfNeeded=K.elevateIfNeeded!==void 0?K.elevateIfNeeded:M.elevateIfNeeded,M.label=K.label??M.label,M.requireLocalPort=K.requireLocalPort,M.protocol=K.protocol):(M.onAutoForward=M.onAutoForward??K.onAutoForward,M.elevateIfNeeded=M.elevateIfNeeded!==void 0?M.elevateIfNeeded:K.elevateIfNeeded,M.label=M.label??K.label,M.requireLocalPort=M.requireLocalPort!==void 0?M.requireLocalPort:void 0,M.protocol=M.protocol??K.protocol),F=this.findNextIndex(U,x,B,this.portsAttributes,F+1)}return M.onAutoForward!==void 0||M.elevateIfNeeded!==void 0||M.label!==void 0||M.requireLocalPort!==void 0||M.protocol!==void 0?M:this.getOtherAttributes()}hasStartEnd(U){return U.start!==void 0&&U.end!==void 0}hasHostAndPort(U){return U.host!==void 0&&U.port!==void 0&&(0,m.isString)(U.host)&&(0,m.isNumber)(U.port)}findNextIndex(U,x,B,F,M){if(M>=F.length)return-1;const K=!(0,T.isLocalhost)(x)&&!(0,T.isAllInterfaces)(x),$=F.slice(M).findIndex(q=>(0,m.isNumber)(q.key)?K?!1:q.key===U:this.hasStartEnd(q.key)?K?!1:U>=q.key.start&&U<=q.key.end:this.hasHostAndPort(q.key)?U===q.key.port&&x===q.key.host:B?q.key.test(B):!1);return $>=0?$+M:-1}readSetting(){const U=this.configurationService.getValue(w.SETTING);if(!U||!(0,m.isObject)(U))return[];const x=[];for(const F in U){if(F===void 0)continue;const M=U[F];let K;if(Number(F))K=Number(F);else if((0,m.isString)(F))if(w.RANGE.test(F)){const ee=F.match(w.RANGE);K={start:Number(ee[1]),end:Number(ee[2])}}else if(w.HOST_AND_PORT.test(F)){const ee=F.match(w.HOST_AND_PORT);K={host:ee[1],port:Number(ee[2])}}else{let ee;try{ee=RegExp(F)}catch{}ee&&(K=ee)}K&&x.push({key:K,elevateIfNeeded:M.elevateIfNeeded,onAutoForward:M.onAutoForward,label:M.label,requireLocalPort:M.requireLocalPort,protocol:M.protocol})}const B=this.configurationService.getValue(w.DEFAULTS);return B&&(this.defaultPortAttributes={elevateIfNeeded:B.elevateIfNeeded,label:B.label,onAutoForward:B.onAutoForward,requireLocalPort:B.requireLocalPort,protocol:B.protocol}),this.sortAttributes(x)}sortAttributes(U){function x(B,F){return(0,m.isNumber)(B.key)?B.key:F.hasStartEnd(B.key)?B.key.start:F.hasHostAndPort(B.key)?B.key.port:Number.MAX_VALUE}return U.sort((B,F)=>x(B,this)-x(F,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(U){switch(U){case T.ProvidedOnAutoForward.Notify:return I.Notify;case T.ProvidedOnAutoForward.OpenBrowser:return I.OpenBrowser;case T.ProvidedOnAutoForward.OpenBrowserOnce:return I.OpenBrowserOnce;case T.ProvidedOnAutoForward.OpenPreview:return I.OpenPreview;case T.ProvidedOnAutoForward.Silent:return I.Silent;case T.ProvidedOnAutoForward.Ignore:return I.Ignore;default:return}}async addAttributes(U,x,B){const M=this.configurationService.inspect(w.SETTING).userRemoteValue;let K;!M||!(0,m.isObject)(M)?K={}:K=(0,n.deepClone)(M),K[`${U}`]||(K[`${U}`]={});for(const ee in x)K[`${U}`][ee]=x[ee];return this.configurationService.updateValue(w.SETTING,K,B)}}e.PortsAttributes=w;let N=class extends L.Disposable{constructor(U,x,B,F,M,K,ee,$,q,Z){super(),this.tunnelService=U,this.storageService=x,this.configurationService=B,this.environmentService=F,this.remoteAuthorityResolverService=M,this.workspaceContextService=K,this.logService=ee,this.dialogService=$,this.extensionService=q,this.contextKeyService=Z,this.inProgress=new Map,this._onForwardPort=new k.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new k.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new k.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new k.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new k.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new k.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new w(B),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async ne=>{const de=await this.getAttributes(ne.map(re=>({port:re.tunnelRemotePort,host:re.tunnelRemoteHost})));for(const re of ne)if(re.localAddress){const Se=S(re.tunnelRemoteHost,re.tunnelRemotePort),ve=C(this._candidates??new Map,re.tunnelRemoteHost,re.tunnelRemotePort);this.forwarded.set(Se,{remotePort:re.tunnelRemotePort,remoteHost:re.tunnelRemoteHost,localAddress:re.localAddress,protocol:de?.get(re.tunnelRemotePort)?.protocol??T.TunnelProtocol.Http,localUri:await this.makeLocalUri(re.localAddress,de?.get(re.tunnelRemotePort)),localPort:re.tunnelLocalPort,runningProcess:ve?.detail,hasRunningProcess:!!ve,pid:ve?.pid,privacy:re.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(Se,re)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async ne=>{const de=S(ne.tunnelRemoteHost,ne.tunnelRemotePort);if(!C(this.forwarded,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!C(this.detected,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!C(this.inProgress,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&ne.localAddress){const re=C(this._candidates??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort),Se=(await this.getAttributes([{port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost}]))?.get(ne.tunnelRemotePort);this.forwarded.set(de,{remoteHost:ne.tunnelRemoteHost,remotePort:ne.tunnelRemotePort,localAddress:ne.localAddress,protocol:Se?.protocol??T.TunnelProtocol.Http,localUri:await this.makeLocalUri(ne.localAddress,Se),localPort:ne.tunnelLocalPort,closeable:!0,runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,privacy:ne.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(de,ne),this._onForwardPort.fire(this.forwarded.get(de))})),this._register(this.tunnelService.onTunnelClosed(ne=>this.onTunnelClosed(ne,p.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(U=>U.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const U=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&U.dispose()}))}async onTunnelClosed(U,x){const B=S(U.host,U.port);this.forwarded.has(B)&&(this.forwarded.delete(B),await this.storeForwarded(),this._onClosePort.fire(U))}makeLocalUri(U,x){if(U.startsWith("http"))return R.URI.parse(U);const B=x?.protocol??"http";return R.URI.parse(`${B}://${U}`)}async addStorageKeyPostfix(U){const x=this.workspaceContextService.getWorkspace(),B=x.configuration?(0,A.hash)(x.configuration.path):x.folders.length>0?(0,A.hash)(x.folders[0].uri.path):void 0;if(B===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${U}.${this.environmentService.remoteAuthority}.${B}`}async getTunnelRestoreStorageKey(){return this.addStorageKeyPostfix(t)}async getRestoreExpirationStorageKey(){return this.addStorageKeyPostfix(c)}async getTunnelRestoreValue(){const U=this.storageService.get(t,d.StorageScope.WORKSPACE);if(U)return this.storageService.remove(t,d.StorageScope.WORKSPACE),await this.storeForwarded(),U;const x=await this.getTunnelRestoreStorageKey();if(x)return this.storageService.get(x,d.StorageScope.PROFILE)}async restoreForwarded(){if(this.cleanupExpiredTunnelsForRestore(),this.configurationService.getValue("remote.restoreForwardedPorts")){const U=await this.tunnelRestoreValue;if(U&&U!==this.knownPortsRestoreValue){const x=JSON.parse(U)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${x.map(B=>B.remotePort).join(", ")}`);for(const B of x){const F=C(this.detected,B.remoteHost,B.remotePort);B.source.source!==_.Extension&&!F||B.source.source===_.Extension&&F?await this.doForward({remote:{host:B.remoteHost,port:B.remotePort},local:B.localPort,name:B.name,elevateIfNeeded:!0,source:B.source}):B.source.source===_.Extension&&!F&&this.unrestoredExtensionTunnels.set(S(B.remoteHost,B.remotePort),B)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const U=await this.getTunnelRestoreStorageKey();this.restoreListener=this._register(new L.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(d.StorageScope.PROFILE,void 0,this.restoreListener)(async x=>{x.key===U&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(U,d.StorageScope.PROFILE)),await this.restoreForwarded())}))}}cleanupExpiredTunnelsForRestore(){const U=this.storageService.keys(d.StorageScope.PROFILE,d.StorageTarget.USER).filter(x=>x.startsWith(c));for(const x of U){const B=this.storageService.getNumber(x,d.StorageScope.PROFILE);if(B&&B<Date.now()){this.tunnelRestoreValue=Promise.resolve(void 0);const F=x.replace(c,t);this.storageService.remove(x,d.StorageScope.PROFILE),this.storageService.remove(F,d.StorageScope.PROFILE)}}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const U=Array.from(this.forwarded.values()),x=U.map(K=>({remoteHost:K.remoteHost,remotePort:K.remotePort,localPort:K.localPort,name:K.name,localAddress:K.localAddress,localUri:K.localUri,protocol:K.protocol,source:K.source}));let B;U.length>0&&(B=JSON.stringify(x));const F=await this.getTunnelRestoreStorageKey(),M=await this.getRestoreExpirationStorageKey();!B&&F&&M?(this.storageService.remove(F,d.StorageScope.PROFILE),this.storageService.remove(M,d.StorageScope.PROFILE)):B!==this.knownPortsRestoreValue&&F&&M&&(this.storageService.store(F,B,d.StorageScope.PROFILE,d.StorageTarget.USER),this.storageService.store(M,Date.now()+h,d.StorageScope.PROFILE,d.StorageTarget.USER)),this.knownPortsRestoreValue=B}}async showPortMismatchModalIfNeeded(U,x,B){if(!U.tunnelLocalPort||!B?.requireLocalPort||U.tunnelLocalPort===x)return;const F=new Date;if(this.mismatchCooldown.getTime()+i>F.getTime())return;this.mismatchCooldown=F;const M=r.localize(3,null,x,U.tunnelRemotePort,U.tunnelLocalPort);return this.dialogService.info(M)}async forward(U,x){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await k.Event.toPromise(this.onRestoreComplete.event),this.doForward(U,x)}async doForward(U,x){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const B=C(this.forwarded,U.remote.host,U.remote.port);x=x??(x!==null?(await this.getAttributes([U.remote]))?.get(U.remote.port):void 0);const F=U.local!==void 0?U.local:U.remote.port;let M;if(B)return this.mergeAttributesIntoExistingTunnel(B,U,x);{const K=this.environmentService.remoteAuthority,ee=K?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority(K)).authority}:void 0,$=S(U.remote.host,U.remote.port);this.inProgress.set($,!0),U=this.mergeCachedAndUnrestoredProperties($,U);const q=await this.tunnelService.openTunnel(ee,U.remote.host,U.remote.port,void 0,F,U.elevateIfNeeded?U.elevateIfNeeded:x?.elevateIfNeeded,U.privacy,x?.protocol);if(typeof q=="string")M=q;else if(q&&q.localAddress){const Z=C(this._candidates??new Map,U.remote.host,U.remote.port),ne=q.protocol?q.protocol===T.TunnelProtocol.Https?T.TunnelProtocol.Https:T.TunnelProtocol.Http:x?.protocol??T.TunnelProtocol.Http,de={remoteHost:q.tunnelRemoteHost,remotePort:q.tunnelRemotePort,localPort:q.tunnelLocalPort,name:x?.label??U.name,closeable:!0,localAddress:q.localAddress,protocol:ne,localUri:await this.makeLocalUri(q.localAddress,x),runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,source:U.source??e.UserTunnelSource,privacy:q.privacy};return this.forwarded.set($,de),this.remoteTunnels.set($,q),this.inProgress.delete($),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded(q,F,x),this._onForwardPort.fire(de),q}this.inProgress.delete($)}return M}mergeCachedAndUnrestoredProperties(U,x){const B=this.unrestoredExtensionTunnels.has(U)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(U)?this.sessionCachedProperties:void 0;if(B){const F=B.get(U);B.delete(U),F&&(x.name=F.name??x.name,x.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??x.local,x.privacy=x.privacy)}return x}async mergeAttributesIntoExistingTunnel(U,x,B){const F=B?.label??x.name;let M;(function(ee){ee[ee.None=0]="None",ee[ee.Fire=1]="Fire",ee[ee.Reopen=2]="Reopen"})(M||(M={}));let K=M.None;switch(F!==U.name&&(U.name=F,K=M.Fire),(B?.protocol||U.protocol!==T.TunnelProtocol.Http)&&B?.protocol!==U.protocol&&(x.source=U.source,K=M.Reopen),x.privacy&&U.privacy!==x.privacy&&(K=M.Reopen),K){case M.Fire:{this._onForwardPort.fire();break}case M.Reopen:await this.close(U.remoteHost,U.remotePort,p.User),await this.doForward(x,B)}return C(this.remoteTunnels,x.remote.host,x.remote.port)}async name(U,x,B){const F=C(this.forwarded,U,x),M=S(U,x);if(F){F.name=B,await this.storeForwarded(),this._onPortName.fire({host:U,port:x});return}else this.detected.has(M)&&(this.detected.get(M).name=B,this._onPortName.fire({host:U,port:x}))}async close(U,x,B){const F=S(U,x),M=this.forwarded.get(F);return B===p.AutoForwardEnd&&M&&M.source.source===_.Auto&&this.sessionCachedProperties.set(F,{local:M.localPort,name:M.name,privacy:M.privacy}),await this.tunnelService.closeTunnel(U,x),this.onTunnelClosed({host:U,port:x},B)}address(U,x){const B=S(U,x);return(this.forwarded.get(B)||this.detected.get(B))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(U){if(U)for(const x of U){const B=C(this._candidates??new Map,x.remoteAddress.host,x.remoteAddress.port),F=typeof x.localAddress=="string"?x.localAddress:S(x.localAddress.host,x.localAddress.port);this.detected.set(S(x.remoteAddress.host,x.remoteAddress.port),{remoteHost:x.remoteAddress.host,remotePort:x.remoteAddress.port,localAddress:F,protocol:T.TunnelProtocol.Http,localUri:this.makeLocalUri(F),closeable:!1,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:T.TunnelPrivacyId.ConstantPrivate,source:{source:_.Extension,description:r.localize(4,null)}}),this.tunnelService.setEnvironmentTunnel(x.remoteAddress.host,x.remoteAddress.port,F,T.TunnelPrivacyId.ConstantPrivate,T.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(U){this._candidateFilter=U}async setCandidates(U){let x=U;this._candidateFilter&&(x=await this._candidateFilter(U));const B=this.updateInResponseToCandidates(x);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(B.values()).map(F=>F.port).join(", ")}`),this._onCandidatesChanged.fire(B)}updateInResponseToCandidates(U){const x=this._candidates??new Map,B=new Map;return this._candidates=B,U.forEach(F=>{const M=S(F.host,F.port);B.set(M,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),x.has(M)&&x.delete(M);const K=C(this.forwarded,F.host,F.port);K&&(K.runningProcess=F.detail,K.hasRunningProcess=!0,K.pid=F.pid)}),x.forEach((F,M)=>{const K=o(M);if(!K)return;const ee=C(this.forwarded,K.host,K.port);ee&&(ee.runningProcess=void 0,ee.hasRunningProcess=!1,ee.pid=void 0);const $=C(this.detected,K.host,K.port);$&&($.runningProcess=void 0,$.hasRunningProcess=!1,$.pid=void 0)}),x}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const U=Array.from(this.forwarded.values()),x=await this.getAttributes(U.map(B=>({port:B.remotePort,host:B.remoteHost})),!1);if(x)for(const B of U){const F=x.get(B.remotePort);(F?.protocol||B.protocol!==T.TunnelProtocol.Http)&&F?.protocol!==B.protocol&&await this.doForward({remote:{host:B.remoteHost,port:B.remotePort},local:B.localPort,name:B.name,source:B.source},F),F&&F.label&&F.label!==B.name&&await this.name(B.remoteHost,B.remotePort,F.label)}}async getAttributes(U,x=!0){const B=new Map,F=new Map;U.forEach(q=>{const Z=C(this._candidates??new Map,T.LOCALHOST_ADDRESSES[0],q.port)??q;if(Z){B.set(q.port,Z);const ne=b(Z)?Z.pid:void 0;F.has(ne)||F.set(ne,[]),F.get(ne)?.push(q.port)}});const M=new Map;if(U.forEach(q=>{const Z=this.configPortsAttributes.getAttributes(q.port,q.host,B.get(q.port)?.detail);Z&&M.set(q.port,Z)}),this.portAttributesProviders.length===0||!x)return M.size>0?M:void 0;const K=await Promise.all(this.portAttributesProviders.flatMap(q=>Array.from(F.entries()).map(Z=>{const ne=Z[1],de=B.get(ne[0]);return q.providePortAttributes(ne,de?.pid,de?.detail,f.CancellationToken.None)}))),ee=new Map;if(K.forEach(q=>q.forEach(Z=>{Z&&ee.set(Z.port,Z)})),!M&&!ee)return;const $=new Map;return U.forEach(q=>{const Z=M.get(q.port),ne=ee.get(q.port);$.set(q.port,{elevateIfNeeded:Z?.elevateIfNeeded,label:Z?.label,onAutoForward:Z?.onAutoForward??w.providedActionToAction(ne?.autoForwardAction),requireLocalPort:Z?.requireLocalPort,protocol:Z?.protocol})}),$}addAttributesProvider(U){this.portAttributesProviders.push(U)}};e.TunnelModel=N,Ke([(0,g.debounce)(1e3)],N.prototype,"storeForwarded",null),e.TunnelModel=N=Ke([Ve(0,T.ITunnelService),Ve(1,d.IStorageService),Ve(2,v.IConfigurationService),Ve(3,a.IWorkbenchEnvironmentService),Ve(4,y.IRemoteAuthorityResolverService),Ve(5,E.IWorkspaceContextService),Ve(6,P.ILogService),Ve(7,l.IDialogService),Ve(8,u.IExtensionService),Ve(9,s.IContextKeyService)],N)}),define(we[99],ye([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(L,R){this.line=L,this.character=R}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,R){return new r(0,0)}with(L){return new r(0,0)}}e.Position=r;class g{constructor(L,R,v,l){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(L,R),this.end=new r(v,l)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new g(0,0,0,0)}with(L){return new g(0,0,0,0)}}e.Range=g;var k;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(k||(e.TextSearchCompleteMessageType=k={}))}),define(we[38],ye([1,0,19,39,25,33,13,5,16,14,99,9]),function(he,e,r,g,k,A,L,R,v,l,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=f,e.isFileMatch=m,e.isProgressMessage=n,e.getExcludes=D,e.pathIncludedInQuery=C,e.deserializeSearchError=b,e.serializeSearchError=w,e.isSerializedSearchComplete=N,e.isSerializedSearchSuccess=O,e.isSerializedFileMatch=U,e.isFilePatternMatch=x,e.resolvePatternsForProvider=F,e.hasSiblingPromiseFn=ee,e.hasSiblingFn=$,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const d="\u27EA ",T=" characters skipped \u27EB",E=(d.length+T.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var a;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text",Z[Z.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var u;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text",Z[Z.aiText=3]="aiText"})(u||(e.QueryType=u={}));function f(Z){return!!Z.preview}function m(Z){return!!Z.resource}function n(Z){return!!Z.message}var s;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class i{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=i;class t{constructor(ne,de,re,Se){this.ranges=de,this.webviewIndex=Se;const ve=Array.isArray(de)?de:[de];if(re&&re.matchLines===1&&c(ve)){ne=(0,L.getNLines)(ne,re.matchLines);let G="",W=0,se=0;const ae=Math.floor(re.charsPerLine/5),ie=[];for(const le of ve){const ue=Math.max(le.startColumn-ae,0),Y=le.startColumn+re.charsPerLine;if(ue>se+ae+E){const oe=d+(ue-se)+T;G+=oe+ne.slice(ue,Y),W+=ue-(se+oe.length)}else G+=ne.slice(se,Y);ie.push(new o(0,le.startColumn-W,le.endColumn-W)),se=Y}this.preview={text:G,matches:Array.isArray(this.ranges)?ie:ie[0]}}else{const G=Array.isArray(de)?de[0].startLineNumber:de.startLineNumber;this.preview={text:ne,matches:(0,r.mapArrayOrNot)(de,W=>new h(W.startLineNumber-G,W.startColumn,W.endLineNumber-G,W.endColumn))}}}}e.TextSearchMatch=t;function c(Z){const ne=Z[0].startLineNumber;for(const de of Z)if(de.startLineNumber!==ne||de.endLineNumber!==ne)return!1;return!0}class h{constructor(ne,de,re,Se){this.startLineNumber=ne,this.startColumn=de,this.endLineNumber=re,this.endColumn=Se}}e.SearchRange=h;class o extends h{constructor(ne,de,re){super(ne,de,ne,re)}}e.OneLineRange=o;var p;(function(Z){Z.List="list",Z.Tree="tree"})(p||(e.ViewMode=p={}));var _;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(_||(e.SearchSortOrder=_={}));function D(Z,ne=!0){const de=Z&&Z.files&&Z.files.exclude,re=ne&&Z&&Z.search&&Z.search.exclude;if(!de&&!re)return;if(!de||!re)return de||re;let Se=Object.create(null);return Se=k.mixin(Se,k.deepClone(de)),Se=k.mixin(Se,k.deepClone(re),!0),Se}function C(Z,ne){return Z.excludePattern&&g.match(Z.excludePattern,ne)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&g.match(Z.includePattern,ne)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(de=>{const re=de.folder.fsPath;if(A.isEqualOrParent(ne,re)){const Se=v.relative(re,ne);return!de.includePattern||!!g.match(de.includePattern,Se)}else return!1}):!1:!0}var S;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(S||(e.SearchErrorCode=S={}));class I extends Error{constructor(ne,de){super(ne),this.code=de}}e.SearchError=I;function b(Z){const ne=Z.message;if((0,l.isCancellationError)(Z))return new I(ne,S.canceled);try{const de=JSON.parse(ne);return new I(de.message,de.code)}catch{return new I(ne,S.other)}}function w(Z){const ne={message:Z.message,code:Z.code};return new Error(JSON.stringify(ne))}function N(Z){return Z.type==="error"?!0:Z.type==="success"}function O(Z){return Z.type==="success"}function U(Z){return!!Z.path}function x(Z,ne,de=!0){const re=Z.searchPath?Z.searchPath:Z.relativePath;return de?(0,L.fuzzyContains)(re,ne):g.match(ne,re)}class B{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function F(Z,ne){const de={...Z||{},...ne||{}};return Object.keys(de).filter(re=>{const Se=de[re];return typeof Se=="boolean"&&Se})}class M{constructor(ne,de){this._parsedIncludeExpression=null,this._excludeExpression={...ne.excludePattern||{},...de.excludePattern||{}},this._parsedExcludeExpression=g.parse(this._excludeExpression);let re=ne.includePattern;de.includePattern&&(re?re={...re,...de.includePattern}:re=de.includePattern),re&&(this._parsedIncludeExpression=g.parse(re))}matchesExcludesSync(ne,de,re){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,de,re))}includedInQuerySync(ne,de,re){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,de,re)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ne,de,re))}includedInQuery(ne,de,re){const Se=this._parsedExcludeExpression(ne,de,re),ve=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ne,de,re):!0;return(0,y.isThenable)(Se)?Se.then(G=>G?!1:ve()):ve()}hasSiblingExcludeClauses(){return K(this._excludeExpression)}}e.QueryGlobTester=M;function K(Z){for(const ne in Z)if(typeof Z[ne]!="boolean")return!0;return!1}function ee(Z){if(!Z)return;let ne;return de=>(ne||(ne=(Z()||Promise.resolve([])).then(re=>re?q(re):{})),ne.then(re=>!!re[de]))}function $(Z){if(!Z)return;let ne;return de=>{if(!ne){const re=Z();ne=re?q(re):{}}return!!ne[de]}}function q(Z){const ne={};for(const de of Z)ne[de]=!0;return ne}}),define(we[47],ye([1,0,19,9,21,4,3,85,15,133,23,13,2,243,28,5,12,279,45,63,30,20,17,10,72,38,6,57]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i,t,c,h,o,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function D(U,x,B){return new P.ExtUri(F=>b(F,B)).isEqual(U,x)}function C(U,x,B){return D(U.uri,x.uri,B)?0:(0,y.compare)(U.uri.toString(),x.uri.toString())}function S(U,x,B){return U.index!==x.index?U.index<x.index?-1:1:D(U.uri,x.uri,B)?(0,y.compare)(U.name,x.name):(0,y.compare)(U.uri.toString(),x.uri.toString())}function I(U,x,B,F){const M=U.slice(0).sort((ee,$)=>B(ee,$,F)),K=x.slice(0).sort((ee,$)=>B(ee,$,F));return(0,r.delta)(M,K,(ee,$)=>B(ee,$,F))}function b(U,x){const B=x.getCapabilities(U.scheme);return!(B&&B&E.FileSystemProviderCapabilities.PathCaseSensitive)}class w extends m.Workspace{static toExtHostWorkspace(x,B,F,M){if(!x)return{workspace:null,added:[],removed:[]};const{id:K,name:ee,folders:$,configuration:q,transient:Z,isUntitled:ne}=x,de=[],re=B;B?$.forEach((W,se)=>{const ae=d.URI.revive(W.uri),ie=w._findFolder(F||B,ae,M);ie?(ie.name=W.name,ie.index=W.index,de.push(ie)):de.push({uri:ae,name:W.name,index:se})}):de.push(...$.map(({uri:W,name:se,index:ae})=>({uri:d.URI.revive(W),name:se,index:ae}))),de.sort((W,se)=>W.index<se.index?-1:1);const Se=new w(K,ee,de,!!Z,q?d.URI.revive(q):null,!!ne,W=>b(W,M)),{added:ve,removed:G}=I(re?re.workspaceFolders:[],Se.workspaceFolders,C,M);return{workspace:Se,added:ve,removed:G}}static _findFolder(x,B,F){for(let M=0;M<x.folders.length;M++){const K=x.workspaceFolders[M];if(D(K.uri,B,F))return K}}constructor(x,B,F,M,K,ee,$){super(x,F.map(q=>new m.WorkspaceFolder(q)),M,K,$),this._name=B,this._isUntitled=ee,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris($),F.forEach(q=>{this._workspaceFolders.push(q),this._structure.set(q.uri,q)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,B){return B&&this._structure.get(x)&&(x=(0,P.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let N=class{constructor(x,B,F,M,K){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new A.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=M,this._extHostFileSystemInfo=F,this._uriTransformerService=K,this._requestIdProvider=new l.Counter,this._barrier=new g.Barrier,this._proxy=x.getProxy(p.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(p.MainContext.MainThreadMessageService);const ee=B.workspace;this._confirmedWorkspace=ee?new w(ee.id,ee.name,[],!!ee.transient,ee.configuration?d.URI.revive(ee.configuration):null,!!ee.isUntitled,$=>b($,F)):void 0}$initializeWorkspace(x,B){this._trusted=B,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:v.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,B,F,...M){const K=[];if(Array.isArray(M)&&M.forEach(ne=>{d.URI.isUri(ne.uri)&&!K.some(de=>D(de.uri,ne.uri,this._extHostFileSystemInfo))&&K.push({uri:ne.uri,name:ne.name||(0,P.basenameOrAuthority)(ne.uri)})}),this._unconfirmedWorkspace||[B,F].some(ne=>typeof ne!="number"||ne<0)||F===0&&K.length===0)return!1;const ee=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+F>ee.length)return!1;const $=ee.slice(0);$.splice(B,F,...K.map(ne=>({uri:ne.uri,name:ne.name||(0,P.basenameOrAuthority)(ne.uri),index:void 0})));for(let ne=0;ne<$.length;ne++){const de=$[ne];if($.some((re,Se)=>Se!==ne&&D(de.uri,re.uri,this._extHostFileSystemInfo)))return!1}$.forEach((ne,de)=>ne.index=de);const{added:q,removed:Z}=I(ee,$,S,this._extHostFileSystemInfo);if(q.length===0&&Z.length===0)return!1;if(this._proxy){const ne=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(ne,B,F,K).then(void 0,de=>{this._unconfirmedWorkspace=void 0;const re={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(f.Severity.Error,(0,T.localize)(0,null,ne,de.toString()),re,[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(x,B){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,B)}async getWorkspaceFolder2(x,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,B)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,B){let F,M="";if(typeof x=="string"?(F=d.URI.file(x),M=x):typeof x<"u"&&(F=x,M=x.fsPath),!F)return M;const K=this.getWorkspaceFolder(F,!0);if(!K)return M;typeof B>"u"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let ee=(0,P.relativePath)(K.uri,F);return B&&K.name&&(ee=`${K.name}/${ee}`),ee}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:B,added:F,removed:M}=w.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:M}))}findFiles(x,B,F,M,K=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let ee="",$=!0;return B===null?$=!1:B!==void 0&&(typeof B=="string"?ee=B:ee=B.pattern),this._findFilesImpl(x,void 0,{exclude:ee,maxResults:F,useDefaultExcludes:$,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(x,B={},F,M=k.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${F.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,x,B,M)}async _findFilesImpl(x,B,F,M=k.CancellationToken.None){if(M&&M.isCancellationRequested)return Promise.resolve([]);const K=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,ee={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof F.useDefaultSearchExcludes=="boolean"?!F.useDefaultSearchExcludes:!1,maxResults:F.maxResults,excludePattern:K,shouldGlobSearch:typeof F.fuzzy=="boolean"?!F.fuzzy:!0,_reason:"startFileSearch"};let $;if(x){const{includePattern:q,folder:Z}=O(t.GlobPattern.from(x));$=Z,ee.includePattern=q}else{const{includePattern:q,folder:Z}=O(t.GlobPattern.from(B));$=Z,ee.filePattern=q}return this._proxy.$startFileSearch($??null,ee,M).then(q=>Array.isArray(q)?q.map(Z=>d.URI.revive(Z)):[])}async findTextInFiles(x,B,F,M,K=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const ee=this._requestIdProvider.getNext(),$=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:q,folder:Z}=O(t.GlobPattern.from(B.include)),ne=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,de={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:$,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:q,excludePattern:ne},re=!1;if(this._activeSearchCallbacks[ee]=Se=>{if(re)return;const ve=d.URI.revive(Se.resource);Se.results.forEach(G=>{const W=(0,_.revive)(G);(0,o.resultIsMatch)(W)?F({uri:ve,preview:{text:W.preview.text,matches:(0,r.mapArrayOrNot)(W.preview.matches,se=>new c.Range(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,r.mapArrayOrNot)(W.ranges,se=>new c.Range(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):F({uri:ve,text:W.text,lineNumber:W.lineNumber})})},K.isCancellationRequested)return{};try{const Se=await this._proxy.$startTextSearch(x,Z??null,de,ee,K);return delete this._activeSearchCallbacks[ee],Se||{}}catch(Se){throw delete this._activeSearchCallbacks[ee],Se}}$handleTextSearchResult(x,B){this._activeSearchCallbacks[B]?.(x)}async save(x){const B=await this._proxy.$save(x,{saveAs:!1});return d.URI.revive(B)}async saveAs(x){const B=await this._proxy.$save(x,{saveAs:!0});return d.URI.revive(B)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(x,B){if(this._editSessionIdentityProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._editSessionIdentityProviders.set(x,B);const F=this._uriTransformerService.transformOutgoingScheme(x),M=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(M,F),(0,L.toDisposable)(()=>{this._editSessionIdentityProviders.delete(x),this._proxy.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(x,B){this._logService.info("Getting edit session identifier for workspaceFolder",x);const F=await this.resolveWorkspaceFolder(d.URI.revive(x));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const M=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!M),!M)return;const K=await M.provideEditSessionIdentity(F,B);if(this._logService.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(x,B,F,M){this._logService.info("Getting edit session identifier for workspaceFolder",x);const K=await this.resolveWorkspaceFolder(d.URI.revive(x));if(!K){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ee=this._editSessionIdentityProviders.get(K.uri.scheme);if(this._logService.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ee),!ee)return;const $=await ee.provideEditSessionIdentityMatch?.(B,F,M);if(this._logService.info("Provider returned edit session identifier match result: ",$),!!$)return $}getOnWillCreateEditSessionIdentityEvent(x){return(B,F,M)=>{const K=function($){B.call(F,$)};return K.extension=x,this._onWillCreateEditSessionIdentityEvent.event(K,void 0,M)}}async $onWillCreateEditSessionIdentity(x,B,F){const M=await this.resolveWorkspaceFolder(d.URI.revive(x));if(M===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:M},B,async(K,ee)=>{const $=Date.now();await Promise.resolve(K),Date.now()-$>F&&this._logService.warn("SLOW edit session create-participant",ee.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(x,B){if(this._canonicalUriProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._canonicalUriProviders.set(x,B);const F=this._uriTransformerService.transformOutgoingScheme(x),M=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(M,F),(0,L.toDisposable)(()=>{this._canonicalUriProviders.delete(x),this._proxy.$unregisterCanonicalUriProvider(M)})}async provideCanonicalUri(x,B,F){const M=this._canonicalUriProviders.get(x.scheme);if(!M)return;const K=await M.provideCanonicalUri?.(d.URI.revive(x),B,F);if(K)return K}async $provideCanonicalUri(x,B,F){return this.provideCanonicalUri(d.URI.revive(x),{targetScheme:B},F)}};e.ExtHostWorkspace=N,e.ExtHostWorkspace=N=Ke([Ve(0,i.IExtHostRpcService),Ve(1,s.IExtHostInitDataService),Ve(2,n.IExtHostFileSystemInfo),Ve(3,u.ILogService),Ve(4,h.IURITransformerService)],N),e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function O(U){let x,B;return U&&(typeof U=="string"?x=U:(x=U.pattern,B=d.URI.revive(U.baseUri))),{includePattern:x,folder:B}}}),define(we[48],ye([1,0,25,4,47,6,10,44,281,70,18,9,5,20,12,2]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(h,o){if(o){const p=o.split(".");let _=h;for(let D=0;_&&D<p.length;D++)_=_[p[D]];return _}}function f(h){return h instanceof a.URI}function m(h){return h&&h.uri instanceof a.URI&&h.languageId&&typeof h.languageId=="string"}function n(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function s(h){return h&&h.uri instanceof a.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function i(h){if(f(h))return{resource:h};if(m(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(n(h))return{overrideIdentifier:h.languageId};if(s(h))return{resource:h.uri};if(h===null)return{resource:null}}let t=class{constructor(o,p,_){this._proxy=o.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=p,this._logService=_,this._barrier=new y.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new c(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,p){this.getConfigProvider().then(_=>_.$acceptConfigurationChanged(o,p))}};e.ExtHostConfiguration=t,e.ExtHostConfiguration=t=Ke([Ve(0,T.IExtHostRpcService),Ve(1,k.IExtHostWorkspace),Ve(2,E.ILogService)],t);class c{constructor(o,p,_,D){this._onDidChangeConfiguration=new g.Emitter,this._proxy=o,this._logService=D,this._extHostWorkspace=p,this._configuration=v.Configuration.parse(_,D),this._configurationScopes=this._toMap(_.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,p){const _={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=v.Configuration.parse(o,this._logService),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(p,_))}getConfiguration(o,p,_){const D=i(p)||{},C=this._toReadonlyValue(o?u(this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,D,_?.identifier);function S(b){if(b==null)return null;if(typeof b=="boolean")return b?R.ConfigurationTarget.USER:R.ConfigurationTarget.WORKSPACE;switch(b){case L.ConfigurationTarget.Global:return R.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return R.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return R.ConfigurationTarget.WORKSPACE_FOLDER}}const I={has(b){return typeof u(C,b)<"u"},get:(b,w)=>{this._validateConfigurationAccess(o?`${o}.${b}`:b,D,_?.identifier);let N=u(C,b);if(typeof N>"u")N=w;else{let O;const U=(x,B)=>{if((0,P.isObject)(x)){let F;const M=()=>{O=O||(0,r.deepClone)(C),F=F||u(O,B)};return new Proxy(x,{get:(K,ee)=>{if(typeof ee=="string"&&ee.toLowerCase()==="tojson")return M(),()=>F;if(O)return F=F||u(O,B),F[ee];const $=K[ee];return typeof ee=="string"?U($,`${B}.${ee}`):$},set:(K,ee,$)=>(M(),F&&(F[ee]=$),!0),deleteProperty:(K,ee)=>(M(),F&&delete F[ee],!0),defineProperty:(K,ee,$)=>(M(),F&&Object.defineProperty(F,ee,$),!0)})}return Array.isArray(x)?(0,r.deepClone)(x):x};N=U(N,b)}return N},update:(b,w,N,O)=>{b=o?`${o}.${b}`:b;const U=S(N);return w!==void 0?this._proxy.$updateConfigurationOption(U,b,w,D,O):this._proxy.$removeConfigurationOption(U,b,D,O)},inspect:b=>{b=o?`${o}.${b}`:b;const w=this._configuration.inspect(b,D,this._extHostWorkspace.workspace);if(w)return{key:b,defaultValue:(0,r.deepClone)(w.policy?.value??w.default?.value),globalValue:(0,r.deepClone)(w.user?.value??w.application?.value),workspaceValue:(0,r.deepClone)(w.workspace?.value),workspaceFolderValue:(0,r.deepClone)(w.workspaceFolder?.value),defaultLanguageValue:(0,r.deepClone)(w.default?.override),globalLanguageValue:(0,r.deepClone)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,r.deepClone)(w.workspace?.override),workspaceFolderLanguageValue:(0,r.deepClone)(w.workspaceFolder?.override),languageIds:(0,r.deepClone)(w.overrideIdentifiers)}}};return typeof C=="object"&&(0,r.mixin)(I,C,!1),Object.freeze(I)}_toReadonlyValue(o){const p=_=>(0,P.isObject)(_)?new Proxy(_,{get:(D,C)=>p(D[C]),set:(D,C,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(C)}' of object`)},deleteProperty:(D,C)=>{throw new Error(`TypeError: Cannot delete read only property '${String(C)}' of object`)},defineProperty:(D,C)=>{throw new Error(`TypeError: Cannot define property '${String(C)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):_;return p(o)}_validateConfigurationAccess(o,p,_){const D=l.OVERRIDE_PROPERTY_REGEX.test(o)?l.ConfigurationScope.RESOURCE:this._configurationScopes.get(o),C=_?`[${_.value}] `:"";if(l.ConfigurationScope.RESOURCE===D){typeof p?.resource>"u"&&this._logService.warn(`${C}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(l.ConfigurationScope.WINDOW===D){p?.resource&&this._logService.warn(`${C}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,p){const _=new v.ConfigurationChangeEvent(o,p,this._configuration,this._extHostWorkspace.workspace,this._logService);return Object.freeze({affectsConfiguration:(D,C)=>_.affectsConfiguration(D,i(C))})}_toMap(o){return o.reduce((p,_)=>(p.set(_[0],_[1]),p),new Map)}}e.ExtHostConfigProvider=c,e.IExtHostConfiguration=(0,d.createDecorator)("IExtHostConfiguration")}),define(we[100],ye([1,0,2,9,4,6,10,47,78,48,21,46,20,30,5,15,11,12,96,323,14]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(O){function U(B){if(B!=null)return B}O.from=U;function x(B){if(B!=null)return B}O.to=x})(i||(i={}));var t;(function(O){function U(B){if(B!=null)return B}O.from=U;function x(B){if(B!=null)return B}O.to=x})(t||(t={}));var c;(function(O){function U(B){if(B!=null)return B}O.from=U;function x(B){if(B!=null)return B}O.to=x})(c||(c={}));var h;(function(O){function U(F){if(F){const M=F;return M&&!!M.process}else return!1}O.is=U;function x(F){if(F==null)return;const M={process:F.process,args:F.args};return F.options&&(M.options=c.from(F.options)),M}O.from=x;function B(F){if(F!=null)return new L.ProcessExecution(F.process,F.args,F.options)}O.to=B})(h||(h={}));var o;(function(O){function U(B){if(B!=null)return B}O.from=U;function x(B){if(B!=null)return B}O.to=x})(o||(o={}));var p;(function(O){function U(F){if(F){const M=F;return M&&(!!M.commandLine||!!M.command)}else return!1}O.is=U;function x(F){if(F==null)return;const M={};return F.commandLine!==void 0?M.commandLine=F.commandLine:(M.command=F.command,M.args=F.args),F.options&&(M.options=o.from(F.options)),M}O.from=x;function B(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new L.ShellExecution(F.commandLine,F.options):new L.ShellExecution(F.command,F.args?F.args:[],F.options)}O.to=B})(p||(p={}));var _;(function(O){function U(F){if(F){const M=F;return M&&M.customExecution==="customExecution"}else return!1}O.is=U;function x(F){return{customExecution:"customExecution"}}O.from=x;function B(F,M){return M.get(F)}O.to=B})(_||(e.CustomExecutionDTO=_={}));var D;(function(O){function U(x,B){let F;return x.scope!==void 0&&typeof x.scope!="number"?F=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===L.TaskScope.Workspace&&B&&B.workspaceFile?F=B.workspaceFile:F=n.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:F}}O.from=U})(D||(e.TaskHandleDTO=D={}));var C;(function(O){function U(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}O.from=U})(C||(C={}));var S;(function(O){function U(F,M){if(F==null)return[];const K=[];for(const ee of F){const $=x(ee,M);$&&K.push($)}return K}O.fromMany=U;function x(F,M){if(F==null)return;let K;F.execution instanceof L.ProcessExecution?K=h.from(F.execution):F.execution instanceof L.ShellExecution?K=p.from(F.execution):F.execution&&F.execution instanceof L.CustomExecution&&(K=_.from(F.execution));const ee=i.from(F.definition);let $;return F.scope?typeof F.scope=="number"?$=F.scope:$=F.scope.uri:$=L.TaskScope.Workspace,!ee||!$?void 0:{_id:F._id,definition:ee,name:F.name,source:{extensionId:M.identifier.value,label:F.source,scope:$},execution:K,isBackground:F.isBackground,group:C.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}O.from=x;async function B(F,M,K){if(F==null)return;let ee;h.is(F.execution)?ee=h.to(F.execution):p.is(F.execution)?ee=p.to(F.execution):_.is(F.execution)&&(ee=_.to(F._id,K));const $=i.to(F.definition);let q;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?q=F.source.scope:q=await M.resolveWorkspaceFolder(r.URI.revive(F.source.scope)):q=L.TaskScope.Workspace),!$||!q)return;const Z=new L.Task($,q,F.name,F.source.label,ee,F.problemMatchers);return F.isBackground!==void 0&&(Z.isBackground=F.isBackground),F.group!==void 0&&(Z.group=L.TaskGroup.from(F.group._id),Z.group&&F.group.isDefault&&(Z.group=new L.TaskGroup(Z.group.id,Z.group.label),F.group.isDefault===!0&&(Z.group.isDefault=F.group.isDefault))),F.presentationOptions&&(Z.presentationOptions=t.to(F.presentationOptions)),F._id&&(Z._id=F._id),F.detail&&(Z.detail=F.detail),Z}O.to=B})(S||(e.TaskDTO=S={}));var I;(function(O){function U(B){return B}O.from=U;function x(B){if(B)return Object.assign(Object.create(null),B)}O.to=x})(I||(I={}));class b{#e;constructor(U,x,B){this._id=x,this._task=B,this.#e=U}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let w=class{constructor(U,x,B,F,M,K,ee,$){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=U.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=F,this._configurationService=M,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ee,this._deprecationService=$,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,x,B){if(!B)return new L.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:x,provider:B,extension:U}),this._proxy.$registerTaskProvider(F,x),new L.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(U,x){this._proxy.$registerTaskSystem(U,x)}fetchTasks(U){return this._proxy.$fetchTasks(I.from(U)).then(async x=>{const B=[];for(const F of x){const M=await S.to(F,this._workspaceProvider,this._providedCustomExecutions2);M&&B.push(M)}return B})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(x=>U.push(x)),U}terminateTask(U){if(!(U instanceof b))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,x,B){const F=this._providedCustomExecutions2.get(U.id);F&&(this._activeCustomExecutions2.set(U.id,F),this._terminalService.attachPtyToTerminal(x,await F.callback(B))),this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){if(!this._taskExecutionPromises.has(U.id))return;const x=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const x=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:x,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const x=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:U.exitCode})}$provideTasks(U,x){const B=this._handlers.get(U);if(!B)return Promise.reject(new Error("no handler found"));const F=[],M=(0,g.asPromise)(()=>B.provider.provideTasks(P.CancellationToken.None)).then(K=>this.provideTasksInternal(x,F,B,K));return new Promise(K=>{M.then(ee=>{Promise.all(F).then(()=>{K(ee)})})})}async $resolveTask(U,x){const B=this._handlers.get(U);if(!B)return Promise.reject(new Error("no handler found"));if(x.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${B.type}].`);const F=await S.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const M=await B.provider.resolveTask(F,P.CancellationToken.None);if(!M)return;this.checkDeprecation(M,B);const K=S.from(M,B.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(M.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return _.is(K.execution)&&await this.addCustomExecution(K,M,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,x,B){const F=await this._proxy.$createTaskId(U);!B&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,x.execution)),this._providedCustomExecutions2.set(F,x.execution)}async getTaskExecution(U,x){if(typeof U=="string"){const M=this._taskExecutionPromises.get(U);if(!M)throw new s.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return M}const B=this._taskExecutionPromises.get(U.id);if(B)return B;let F;return x?F=Promise.resolve(new b(this,U.id,x)):F=S.to(U.task,this._workspaceProvider,this._providedCustomExecutions2).then(M=>{if(!M)throw new s.ErrorNoTelemetry("Unexpected: Task does not exist.");return new b(this,U.id,M)}),this._taskExecutionPromises.set(U.id,F),F.then(M=>(this._taskExecutions.set(U.id,M),M))}checkDeprecation(U,x){U._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));const B=this._notProvidedCustomExecutions.values();let F=B.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=B.next()}};e.ExtHostTaskBase=w,e.ExtHostTaskBase=w=Ke([Ve(0,d.IExtHostRpcService),Ve(1,T.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,v.IExtHostDocumentsAndEditors),Ve(4,l.IExtHostConfiguration),Ve(5,y.IExtHostTerminalService),Ve(6,f.ILogService),Ve(7,m.IExtHostApiDeprecationService)],w);let N=class extends w{constructor(U,x,B,F,M,K,ee,$){super(U,x,B,F,M,K,ee,$),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:u.PlatformToString(u.Platform.Web)})}async executeTask(U,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const B=S.from(x,U);if(B===void 0)throw new Error("Task is not valid");if(_.is(B.execution))await this.addCustomExecution(B,x,!1);else throw new s.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),x);return this._proxy.$executeTask(B).catch(M=>{throw new Error(M)}),F}provideTasksInternal(U,x,B,F){const M=[];if(F)for(const K of F){if(this.checkDeprecation(K,B),!K.definition||!U[K.definition.type]){const $=K.source?K.source:"No task source";this._logService.warn(`The task [${$}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`)}const ee=S.from(K,B.extension);ee&&_.is(ee.execution)?(M.push(ee),x.push(this.addCustomExecution(ee,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:M,extension:B.extension}}async resolveTaskInternal(U){if(_.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,x,B){}};e.WorkerExtHostTask=N,e.WorkerExtHostTask=N=Ke([Ve(0,d.IExtHostRpcService),Ve(1,T.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,v.IExtHostDocumentsAndEditors),Ve(4,l.IExtHostConfiguration),Ve(5,y.IExtHostTerminalService),Ve(6,f.ILogService),Ve(7,m.IExtHostApiDeprecationService)],N),e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(we[384],ye([1,0,38,31]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=k,e.genericCellMatchesToTextSearchMatches=A;function k(L){return"cellResults"in L}e.rawCellPrefix="rawCell#";function A(L,R){let v=-1;const l=[];let P=[];return L.forEach(d=>{d.range.startLineNumber!==v&&P.length>0&&(l.push([...P]),P=[]),P.push(d),v=d.range.endLineNumber}),P.length>0&&l.push([...P]),l.map(d=>{const T=[],E=d[0].range.startLineNumber,a=d[d.length-1].range.endLineNumber;for(let u=E;u<=a;u++)T.push(R.getLineContent(u));return new r.TextSearchMatch(T.join(`
`)+`
`,d.map(u=>new g.Range(u.range.startLineNumber-1,u.range.startColumn-1,u.range.endLineNumber-1,u.range.endColumn-1)))})}}),define(we[385],ye([1,0,237,22,4,3,29,41,13,18,2,28,118,6,37,17,10,52,356,163,25,15,38,312,384,381]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i,t,c,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class p{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(D=>D.apiEditor)}constructor(D,C,S,I,b,w,N){this._textDocumentsAndEditors=S,this._textDocuments=I,this._extHostFileSystem=b,this._extHostSearch=w,this._logService=N,this._notebookStatusBarItemProviders=new Map,this._documents=new L.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new d.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=D.getProxy(T.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=D.getProxy(T.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=D.getProxy(T.MainContext.MainThreadNotebookEditors),this._commandsConverter=C.converter,C.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===R.MarshalledId.NotebookCellActionContext){const U=O.notebookEditor?.notebookUri,x=O.cell.handle,F=this._documents.get(U)?.getCell(x);if(F)return F.apiCell}if(O&&O.$mid===R.MarshalledId.NotebookActionContext){const U=O.uri,x=this._documents.get(U);if(x)return x.apiNotebook}return O}}),p._registerApiCommands(C)}getEditorById(D){const C=this._editors.get(D);if(!C)throw new Error(`unknown text editor: ${D}. known editors: ${[...this._editors.keys()]} `);return C}getIdByEditor(D){for(const[C,S]of this._editors)if(S.apiEditor===D)return C}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(D,C){const S=this._documents.get(D);if(!S&&!C)throw new Error(`NO notebook document for '${D}'`);return S}static _convertNotebookRegistrationData(D,C){if(!C)return;const S=C.filenamePattern.map(I=>a.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(C.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${C.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:C.displayName,filenamePattern:S,exclusive:C.exclusive||!1}}registerNotebookCellStatusBarItemProvider(D,C,S){const I=p._notebookStatusBarItemProviderHandlePool++,b=typeof S.onDidChangeCellStatusBarItems=="function"?p._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(I,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(I,b,C);let w;return b!==void 0&&(w=S.onDidChangeCellStatusBarItems(N=>this._notebookProxy.$emitCellStatusBarEvent(b))),new u.Disposable(()=>{this._notebookStatusBarItemProviders.delete(I),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(I,b),w?.dispose()})}async createNotebookDocument(D){const C=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:D.viewType,content:D.content&&a.NotebookData.from(D.content)});return P.URI.revive(C)}async openNotebookDocument(D){const C=this._documents.get(D);if(C)return C.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(D),I=this._documents.get(P.URI.revive(S));return(0,l.assertIsDefined)(I?.apiNotebook)}async showNotebookDocument(D,C){P.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let S;typeof C=="object"?S={position:a.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selections:C.selections&&C.selections.map(a.NotebookRange.from),pinned:typeof C.preview=="boolean"?!C.preview:void 0}:S={preserveFocus:!1};const I=await this._notebookEditorsProxy.$tryShowNotebookDocument(D.uri,D.notebookType,S),b=I&&this._editors.get(I)?.apiEditor;if(b)return b;throw I?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,C,S,I){const b=this._notebookStatusBarItemProviders.get(D),w=P.URI.revive(C),N=this._documents.get(w);if(!N||!b)return;const O=N.getCellFromIndex(S);if(!O)return;const U=await b.provideCellStatusBarItems(O.apiCell,I);if(!U)return;const x=new A.DisposableStore,B=this._statusBarCache.add([x]),M=(Array.isArray(U)?U:[U]).map(K=>a.NotebookStatusBarItem.from(K,this._commandsConverter,x));return{cacheId:B,items:M}}$releaseNotebookCellStatusBarItems(D){this._statusBarCache.delete(D)}registerNotebookSerializer(D,C,S,I,b){if((0,v.isFalsyOrWhitespace)(C))throw new Error("viewType cannot be empty or just whitespace");const w=this._handlePool++;return this._notebookSerializer.set(w,{viewType:C,serializer:S,options:I}),this._notebookProxy.$registerNotebookSerializer(w,{id:D.identifier,location:D.extensionLocation},C,a.NotebookDocumentContentOptions.from(I),p._convertNotebookRegistrationData(D,b)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(w)})}async $dataToNotebook(D,C,S){const I=this._notebookSerializer.get(D);if(!I)throw new Error("NO serializer found");const b=await I.serializer.deserializeNotebook(C.buffer,S);return new f.SerializableObjectWithBuffers(a.NotebookData.from(b))}async $notebookToData(D,C,S){const I=this._notebookSerializer.get(D);if(!I)throw new Error("NO serializer found");const b=await I.serializer.serializeNotebook(a.NotebookData.to(C.value),S);return g.VSBuffer.wrap(b)}async $saveNotebook(D,C,S,I,b){const w=P.URI.revive(C),N=this._notebookSerializer.get(D);if(this.trace(`enter saveNotebook(versionId: ${S}, ${w.toString()})`),!N)throw new Error("NO serializer found");const O=this._documents.get(w);if(!O)throw new Error("Document NOT found");if(O.versionId!==S)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(w.scheme))throw new y.FileOperationError((0,r.localize)(0,null,this._resourceForError(w)),y.FileOperationResult.FILE_PERMISSION_DENIED);const U={metadata:(0,s.filter)(O.apiNotebook.metadata,K=>!(N.options?.transientDocumentMetadata??{})[K]),cells:[]};for(const K of O.apiNotebook.getCells()){const ee=new u.NotebookCellData(K.kind,K.document.getText(),K.document.languageId,K.mime,N.options?.transientOutputs?[]:[...K.outputs],K.metadata,K.executionSummary);ee.metadata=(0,s.filter)(K.metadata,$=>!(N.options?.transientCellMetadata??{})[$]),U.cells.push(ee)}if(await this._validateWriteFile(w,I),b.isCancellationRequested)throw new Error("canceled");const x=await N.serializer.serializeNotebook(U,b);if(b.isCancellationRequested)throw new Error("canceled");this.trace(`serialized versionId: ${S} ${w.toString()}`),await this._extHostFileSystem.value.writeFile(w,x),this.trace(`Finished write versionId: ${S} ${w.toString()}`);const B=this._extHostFileSystem.getFileSystemProviderExtUri(w.scheme),F=await this._extHostFileSystem.value.stat(w),M={name:B.basename(w),isFile:(F.type&y.FileType.File)!==0,isDirectory:(F.type&y.FileType.Directory)!==0,isSymbolicLink:(F.type&y.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&y.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(w.scheme),locked:!!((F.permissions??0)&y.FilePermission.Locked),etag:y.etag({mtime:F.mtime,size:F.size}),children:void 0};return this.trace(`exit saveNotebook(versionId: ${S}, ${w.toString()})`),M}async $searchInNotebooks(D,C,S,I,b){const w=this._notebookSerializer.get(D)?.serializer;if(!w)return{limitHit:!1,results:[]};const N=new L.ResourceSet;await(async(F,M,K)=>{await Promise.all(F.map(async ee=>await Promise.all(ee.filenamePatterns.map($=>{const q={_reason:K._reason,folderQueries:K.folderQueries,includePattern:K.includePattern,excludePattern:K.excludePattern,maxResults:K.maxResults,type:t.QueryType.File,filePattern:$};return this._extHostSearch.doInternalFileSearchWithCustomCallback(q,M,Z=>{Z.forEach(ne=>{N.has(ne)||I.some(re=>ee.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Se=>(0,o.globMatchesResource)(Se,ne)))||N.add(ne)})}).catch(Z=>{if(Z.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Z})}))))})(S,b,C);const U=new L.ResourceMap;let x=!1;const B=Array.from(N).map(async F=>{const M=[];try{if(b.isCancellationRequested)return;if(C.maxResults&&[...U.values()].reduce((q,Z)=>q+Z.cellResults.length,0)>C.maxResults){x=!0;return}const K=[],ee=this._documents.get(F);if(ee)ee.apiNotebook.getCells().forEach(Z=>K.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(ne=>ne.items.map(de=>de.data.toString()))}));else{const q=await this._extHostFileSystem.value.readFile(F),Z=g.VSBuffer.fromString(q.toString()),ne=await w.deserializeNotebook(Z.buffer,b);if(b.isCancellationRequested)return;a.NotebookData.from(ne).cells.forEach(re=>K.push({input:re.source,outputs:re.outputs.flatMap(Se=>Se.items.map(ve=>ve.valueBytes.toString()))}))}if(b.isCancellationRequested)return;K.forEach((q,Z)=>{const ne=C.contentPattern.pattern,de=new c.CellSearchModel(q.input,void 0,q.outputs),re=de.findInInputs(ne),Se=de.findInOutputs(ne),ve=Se.flatMap(G=>(0,h.genericCellMatchesToTextSearchMatches)(G.matches,G.textBuffer)).map((G,W)=>(G.webviewIndex=W,G));if(re.length>0||Se.length>0){const G={index:Z,contentResults:(0,h.genericCellMatchesToTextSearchMatches)(re,de.inputTextBuffer),webviewResults:ve};M.push(G)}});const $={resource:F,cellResults:M};U.set(F,$);return}catch{return}});return await Promise.all(B),{limitHit:x,results:[...U.values()]}}async _validateWriteFile(D,C){const S=await this._extHostFileSystem.value.stat(D);if(typeof C?.mtime=="number"&&typeof C.etag=="string"&&C.etag!==y.ETAG_DISABLED&&typeof S.mtime=="number"&&typeof S.size=="number"&&C.mtime<S.mtime&&C.etag!==y.etag({mtime:C.mtime,size:S.size}))throw new y.FileOperationError((0,r.localize)(1,null),y.FileOperationResult.FILE_MODIFIED_SINCE,C)}_resourceForError(D){return D.scheme===i.Schemas.file?D.fsPath:D.toString()}_createExtHostEditor(D,C,S){if(this._editors.has(C))throw new Error(`editor with id ALREADY EXSIST: ${C}`);const I=new n.ExtHostNotebookEditor(C,this._notebookEditorsProxy,D,S.visibleRanges.map(a.NotebookRange.to),S.selections.map(a.NotebookRange.to),typeof S.viewColumn=="number"?a.ViewColumn.to(S.viewColumn):void 0);this._editors.set(C,I)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const S of D.value.removedDocuments){const I=P.URI.revive(S),b=this._documents.get(I);b&&(b.dispose(),this._documents.delete(I),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(w=>w.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const w of this._editors.values())w.notebookData.uri.toString()===I.toString()&&this._editors.delete(w.id)}if(D.value.addedDocuments){const S=[];for(const I of D.value.addedDocuments){const b=P.URI.revive(I.uri);if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const w=new m.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,b,I);S.push(...I.cells.map(N=>m.ExtHostCell.asModelAddData(N))),this._documents.get(b)?.dispose(),this._documents.set(b,w),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(w.apiNotebook)}}if(D.value.addedEditors)for(const S of D.value.addedEditors){if(this._editors.has(S.id))return;const I=P.URI.revive(S.documentUri),b=this._documents.get(I);b&&this._createExtHostEditor(b,S.id,S)}const C=[];if(D.value.removedEditors)for(const S of D.value.removedEditors){const I=this._editors.get(S);I&&(this._editors.delete(S),this._activeNotebookEditor?.id===I.id&&(this._activeNotebookEditor=void 0),C.push(I))}if(D.value.visibleEditors){this._visibleNotebookEditors=D.value.visibleEditors.map(I=>this._editors.get(I)).filter(I=>!!I);const S=new Set;this._visibleNotebookEditors.forEach(I=>S.add(I.id));for(const I of this._editors.values()){const b=S.has(I.id);I._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(I=>I).filter(I=>I.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this._activeNotebookEditor=void 0:D.value.newActiveEditor&&(this._editors.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(D){const C=E.ApiCommandArgument.String.with("notebookType","A notebook type"),S=new E.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[C,new E.ApiCommandArgument("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>g.VSBuffer.wrap(b))],new E.ApiCommandResult("Notebook Data",b=>a.NotebookData.to(b.value))),I=new E.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[C,new E.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new f.SerializableObjectWithBuffers(a.NotebookData.from(b)))],new E.ApiCommandResult("Bytes",b=>b.buffer));D.registerApiCommand(S),D.registerApiCommand(I)}trace(D){this._logService.trace(`[Extension Host Notebook] ${D}`)}}e.ExtHostNotebookController=p}),define(we[386],ye([1,0,16,21,51,39,23,42,38]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class l{constructor(d,T,E){this.config=d,this.provider=T,this.sessionToken=E,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&A.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&A.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const T=this.config.folderQueries||[];return new Promise((E,a)=>{const u=f=>{this.resultCount++,d(f)};if(this.isCanceled)return E({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const m=f.toString(),n=r.basename(m);this.globalExcludePattern&&this.globalExcludePattern(m,n)||this.matchFile(u,{base:f,basename:n})}),Promise.all(T.map(f=>this.searchInFolder(f,u))).then(f=>{E({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{a(new Error((0,k.toErrorMessage)(f)))})})}async searchInFolder(d,T){const E=new g.CancellationTokenSource,a=this.getSearchOptionsForFolder(d),u=this.initDirectoryTree(),f=new v.QueryGlobTester(this.config,d),m=!f.hasSiblingExcludeClauses();let n;try{this.activeCancellationTokens.add(E),n=R.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,E.token),i=n.elapsed(),t=R.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(c=>{const h=r.posix.relative(d.folder.path,c.path);if(m){const o=r.basename(c.path);this.matchFile(T,{base:d.folder,relativePath:h,basename:o});return}this.addDirectoryEntries(u,d.folder,h,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(u,f,T),{providerTime:i,postProcessTime:t.elapsed()})}finally{E.dispose(),this.activeCancellationTokens.delete(E)}}getSearchOptionsForFolder(d){const T=(0,v.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),E=(0,v.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:E,includes:T,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},T,E,a){if(E===this.filePattern){const f=r.basename(this.filePattern);this.matchFile(a,{base:T,relativePath:this.filePattern,basename:f})}function u(f){const m=r.basename(f),n=r.dirname(f);let s=d[n];s||(s=d[n]=[],u(n)),s.push({base:T,relativePath:f,basename:m})}u(E)}matchDirectoryTree({rootEntries:d,pathToEntries:T},E,a){const u=this,f=this.filePattern;function m(n){const s=(0,v.hasSiblingFn)(()=>n.map(i=>i.basename));for(let i=0,t=n.length;i<t;i++){const c=n[i],{relativePath:h,basename:o}=c;if(E.matchesExcludesSync(h,o,f!==o?s:void 0))continue;const p=T[h];if(p)m(p);else{if(h===f)continue;u.matchFile(a,c)}if(u.isLimitHit)break}}m(d)}matchFile(d,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(T))}}class P{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(d,T,E,a){const u=this.getSessionTokenSource(d.cacheKey),f=new l(d,T,u&&u.token);let m=0;const n=s=>{m+=s.length,E(s.map(i=>this.rawMatchToSearchItem(i)))};return this.doSearch(f,P.BATCH_SIZE,n,a).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:s.stats}:void 0,messages:[]}))}clearCache(d){this.getSessionTokenSource(d)?.cancel()}getSessionTokenSource(d){if(d)return this.sessions.has(d)||this.sessions.set(d,new g.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:L.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,T,E,a){const u=a.onCancellationRequested(()=>{d.cancel()}),f=n=>{n&&(m.push(n),T>0&&m.length>=T&&(E(m),m=[]))};let m=[];return d.search(f).then(n=>(m.length&&E(m),u.dispose(),n),n=>(m.length&&E(m),u.dispose(),Promise.reject(n)))}}e.FileSearchManager=P}),define(we[387],ye([1,0,19,79,39,109,29,15,16,23,13,18,2,106,260,44,12,45,155,382,38]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.resolveResourcesForSearchIncludes=C;let i=class{constructor(I,b,w,N,O){this.configurationService=I,this.workspaceContextService=b,this.editorGroupsService=w,this.logService=N,this.pathService=O}text(I,b,w={}){I=this.getContentPattern(I,w);const N=this.configurationService.getValue(),O=b&&b.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(b?.map(f.toWorkspaceFolder),w),type:s.QueryType.Text,contentPattern:I,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:N.search.usePCRE2||O||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}getContentPattern(I,b){const w=this.configurationService.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const N={...I,wordSeparators:w.editor.wordSeparators};return this.isCaseSensitive(I,b)&&(N.isCaseSensitive=!0),this.isMultiline(I)&&(N.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),N}file(I,b={}){return{...this.commonQuery(I,b),type:s.QueryType.File,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}handleIncludeExclude(I,b){return I?(I=Array.isArray(I)?I.map(p):p(I),b?this.parseSearchPaths(I):{pattern:c(...Array.isArray(I)?I:[I])}):{}}commonQuery(I=[],b={}){const w=this.handleIncludeExclude(b.includePattern,b.expandPatterns),N=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),O=I.length>1,U=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(F=>this.getFolderQueryForSearchPath(F,b,N)):I.map(F=>this.getFolderQueryForRoot(F,b,N,O))).filter(F=>!!F),x={_reason:b._reason,folderQueries:U,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:N.pattern,includePattern:w.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const F=r.coalesce(this.editorGroupsService.groups.flatMap(ee=>ee.editors.map($=>$.resource)));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const M=F.filter(ee=>(0,s.pathIncludedInQuery)(x,ee.fsPath)),K=this.commonQueryFromFileList(M);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...x,...K}}const B=b.extraFileResources&&b.extraFileResources.filter(F=>(0,s.pathIncludedInQuery)(x,F.fsPath));return x.extraFileResources=B&&B.length?B:void 0,x}commonQueryFromFileList(I){const b=[],w=new L.ResourceMap,N={};let O=!1;return I.forEach(U=>{if(U.scheme===R.Schemas.walkThrough)return;if((0,l.isAbsolutePath)(U)){const B=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:v.dirname(U.fsPath)});let F=w.get(B);F||(O=!0,F={folder:B,includePattern:{}},b.push(F),w.set(B,F));const M=v.relative(B.fsPath,U.fsPath);(0,y.assertIsDefined)(F.includePattern)[M.replace(/\\/g,"/")]=!0}else U.fsPath&&(O=!0,N[U.fsPath]=!0)}),{folderQueries:b,includePattern:N,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(I,b){if(b.isSmartCase){if(I.isRegExp){if(P.containsUppercaseCharacter(I.pattern,!0))return!0}else if(P.containsUppercaseCharacter(I.pattern))return!0}return!!I.isCaseSensitive}isMultiline(I){return I.isMultiline||I.isRegExp&&(0,T.isMultilineRegexSource)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const b=K=>v.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),N=(Array.isArray(I)?I:h(I)).map(K=>{const ee=this.pathService.resolvedUserHome;return ee?(0,A.untildify)(K,ee.scheme===R.Schemas.file?ee.fsPath:ee.path):K}),O=g.groupBy(N,K=>b(K)?"searchPaths":"exprSegments"),U=(O.exprSegments||[]).map(K=>P.rtrim(K,"/")).map(K=>P.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),o(K))),x={},B=this.expandSearchPathPatterns(O.searchPaths||[]);B&&B.length&&(x.searchPaths=B);const F=U.flat(),M=c(...F);return M&&(x.pattern=M),x}getExcludesForFolder(I,b){return b.disregardExcludeSettings?void 0:(0,s.getExcludes)(I,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(I){if(!I||!I.length)return[];const b=I.flatMap(N=>{let{pathPortion:O,globPortion:U}=t(N);return U&&(U=_(U)),this.expandOneSearchPath(O).flatMap(B=>this.resolveOneSearchPathPattern(B,U))}),w=new Map;return b.forEach(N=>{const O=N.searchPath.toString(),U=w.get(O);U?N.pattern&&(U.pattern=U.pattern||{},U.pattern[N.pattern]=!0):w.set(O,{searchPath:N.searchPath,pattern:N.pattern?c(N.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(I){if(v.isAbsolute(I)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==R.Schemas.file?[{searchPath:b[0].uri.with({path:I})}]:[{searchPath:d.URI.file(v.normalize(I))}]}if(this.workspaceContextService.getWorkbenchState()===f.WorkbenchState.FOLDER){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(I=p(I),I.startsWith("../")||I===".."){const N=v.posix.resolve(b.path,I);return[{searchPath:b.with({path:N})}]}const w=_(I);return[{searchPath:b,pattern:w}]}else{if(I==="./"||I===".\\")return[];{const b=I.replace(/^\.[\/\\]/,""),N=this.workspaceContextService.getWorkspace().folders.map(O=>{const U=b.match(new RegExp(`^${P.escapeRegExpCharacters(O.name)}(?:/(.*)|$)`));return U?{match:U,folder:O}:null}).filter(y.isDefined);if(N.length)return N.map(O=>{const U=O.match[1];return{searchPath:O.folder.uri,pattern:U&&_(U)}});{const O=I.match(/\.[\/\\](.+)[\/\\]?/),U=O?O[1]:I,x=E.localize(0,null,U);throw new Error(x)}}}}resolveOneSearchPathPattern(I,b){const w=I.pattern&&b?`${I.pattern}/${b}`:I.pattern||b,N=[{searchPath:I.searchPath,pattern:w}];return w&&!w.endsWith("**")&&N.push({searchPath:I.searchPath,pattern:w+"/**"}),N}getFolderQueryForSearchPath(I,b,w){const N=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(I.searchPath),b,w,!1);return N?{...N,includePattern:I.pattern}:null}getFolderQueryForRoot(I,b,w,N){let O;const U=d.URI.isUri(I)?I:I.uri;if(w.searchPaths){const K=w.searchPaths.filter(ee=>(0,l.isEqual)(ee.searchPath,U))[0];if(K&&!K.pattern)return null;K&&(O=K.pattern)}const x=this.configurationService.getValue({resource:U}),F={...this.getExcludesForFolder(x,b)||{},...O||{}},M=d.URI.isUri(I)?(0,l.basename)(I):I.name;return{folder:U,folderName:N?M:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!x.search.followSymlinks}}};e.QueryBuilder=i,e.QueryBuilder=i=Ke([Ve(0,a.IConfigurationService),Ve(1,f.IWorkspaceContextService),Ve(2,m.IEditorGroupsService),Ve(3,u.ILogService),Ve(4,n.IPathService)],i);function t(S){const I=S.match(/[\*\{\}\(\)\[\]\?]/);if(I){const b=I.index,w=S.substr(0,b).match(/[/|\\][^/\\]*$/);if(w){let N=S.substr(0,w.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:S.substr((w.index||0)+1)}}}return{pathPortion:S}}function c(...S){return S.length?S.reduce((I,b)=>(I[b]=!0,I),Object.create(null)):void 0}function h(S){return k.splitGlobAware(S,",").map(I=>I.trim()).filter(I=>!!I.length)}function o(S){return[`**/${S}/**`,`**/${S}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function p(S){return S.replace(/\\/g,"/")}function _(S){return p(S).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(S){return S.replace(/([?*[\]])/g,"[$1]")}function C(S,I){S=r.distinct(S,N=>N.toString());const b=[],w=I.getWorkspace();return S&&S.forEach(N=>{let O;if(I.getWorkbenchState()===f.WorkbenchState.FOLDER)O=(0,l.relativePath)(w.folders[0].uri,N),O&&O!=="."&&(O="./"+O);else{const U=I.getWorkspaceFolder(N);if(U){const x=U.name;if(w.folders.filter(F=>F.name===x).length===1){const F=(0,l.relativePath)(U.uri,N);F===""?O=`./${U.name}`:O=`./${U.name}/${F}`}else O=N.fsPath}}O&&b.push(D(O))}),b}}),define(we[388],ye([1,0,23,2,21,14,5,387,38,45,9]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=d,e.checkGlobFileExists=a;const y=7e3;function d(u,f){const m=f.activationEvents;if(!m)return Promise.resolve(void 0);const n=[],s=[];for(const p of m)if(/^workspaceContains:/.test(p)){const _=p.substr(18);_.indexOf("*")>=0||_.indexOf("?")>=0||u.forceUsingSearch?s.push(_):n.push(_)}if(n.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:i,resolve:t}=(0,P.promiseWithResolvers)(),c=p=>t({activationEvent:p}),h=Promise.all(n.map(p=>T(u,p,c))).then(()=>{}),o=E(u,f.identifier,s,c);return Promise.all([h,o]).then(()=>{t(void 0)}),i}async function T(u,f,m){for(const n of u.folders)if(await u.exists(r.joinPath(g.URI.revive(n),f))){m(`workspaceContains:${f}`);return}}async function E(u,f,m,n){if(m.length===0)return Promise.resolve(void 0);const s=new k.CancellationTokenSource,i=u.checkExists(u.folders,m,s.token),t=setTimeout(async()=>{s.cancel(),u.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},y);let c=!1;try{c=await i}catch(h){A.isCancellationError(h)||A.onUnexpectedError(h)}s.dispose(),clearTimeout(t),c&&n(`workspaceContains:${m.join(",")}`)}function a(u,f,m,n){const s=u.get(L.IInstantiationService),i=u.get(v.ISearchService),c=s.createInstance(R.QueryBuilder).file(f.map(h=>(0,l.toWorkspaceFolder)(g.URI.revive(h))),{_reason:"checkExists",includePattern:m,exists:!0});return i.fileSearch(c,n).then(h=>!!h.limitHit,h=>A.isCancellationError(h)?!1:Promise.reject(h))}}),define(we[53],ye([1,0,233,16,62,23,9,3,85,2,12,6,48,319,125,47,26,157,14,24,22,297,10,71,5,30,98,20,114,76,46,128,4,388,124,299,15,122,42,11,123]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i,t,c,h,o,p,_,D,C,S,I,b,w,N,O,U,x,B,F,M){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,h.createDecorator)("IHostUtils");let ee=K=class extends R.Disposable{constructor(G,W,se,ae,ie,le,ue,Y,oe,pe,Ee,Ne,We){super(),this._extHostManagedSockets=Ne,this._extHostLanguageModels=We,this._onDidChangeRemoteConnectionData=this._register(new b.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=W,this._extHostContext=se,this._initData=ue,this._extHostWorkspace=ae,this._extHostConfiguration=ie,this._logService=le,this._extHostTunnelService=oe,this._extHostTerminalService=pe,this._extHostLocalizationService=Ee,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new L.Barrier,this._readyToStartExtensionHost=new L.Barrier,this._readyToRunExtensions=new L.Barrier,this._eagerExtensionsActivated=new L.Barrier,this._activationEventsReader=new Se(this._initData.extensions.activationEvents),this._globalRegistry=new f.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const Ce=new n.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new f.ExtensionDescriptionRegistry(this._activationEventsReader,de(this._globalRegistry,Ce)),F.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${Z(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${Z(this._myRegistry)}`)),this._storage=new E.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=Y,this._instaService=G.createChild(new D.ServiceCollection([E.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState])),this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Ie,Le,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ie,m.transformErrorForSerialization(Le),z)},actualActivateExtension:async(Ie,Le)=>{if(f.ExtensionDescriptionRegistry.isHostExtension(Ie,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Ie,Le),new T.HostExtension;const z=this._myRegistry.getExtensionDescription(Ie);return this._activateExtension(z,Le)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(G){m.onUnexpectedError(G)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let G=[];try{G=this._myRegistry.getAllExtensionDescriptions().map(ie=>ie.identifier).filter(ie=>this.isActivated(ie)).map(ie=>this._deactivate(ie))}catch{}await Promise.all(G)}terminate(G,W=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${G}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),m.setUnexpectedErrorHandler(ae=>{this._logService.error(ae)}),this._extHostContext.dispose();const se=this._deactivateAll();Promise.race([(0,L.timeout)(5e3),se]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${W}`):this._logService.info(`Extension host exiting with code ${W}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(W)})}isActivated(G){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(G):!1}async getExtension(G){const W=await this._mainThreadExtensionsProxy.$getExtension(G);return W&&{...W,identifier:new n.ExtensionIdentifier(W.identifier.value),extensionLocation:l.URI.revive(W.extensionLocation)}}_activateByEvent(G,W){return this._activator.activateByEvent(G,W)}_activateById(G,W){return this._activator.activateById(G,W)}activateByIdWithErrors(G,W){return this._activateById(G,W).then(()=>{const se=this._activator.getActivatedExtension(G);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(G=>this._myRegistry)}getExtensionExports(G){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(G).exports;try{return this._activator.getActivatedExtension(G).exports}catch{return null}}async _realPathExtensionUri(G){if(G.scheme===U.Schemas.file&&this._hostUtils.fsRealpath){const W=G.fsPath;this._realPathCache.has(W)||this._realPathCache.set(W,this._hostUtils.fsRealpath(W));const se=await this._realPathCache.get(W);return l.URI.file(se)}return G}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(G=>new re(G))),this._extensionPathIndex}async _createExtensionPathIndex(G){const W=v.TernarySearchTree.forUris(se=>A.extUriBiasedIgnorePathCase.ignorePathCasing(se));return await Promise.all(G.map(async se=>{if(this._getEntryPoint(se)){const ae=await this._realPathExtensionUri(se.extensionLocation);W.set(ae,se)}})),W}_deactivate(G){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(G))return W;const se=this._activator.getActivatedExtension(G);if(!se)return W;try{typeof se.module.deactivate=="function"&&(W=Promise.resolve(se.module.deactivate()).then(void 0,ae=>(this._logService.error(ae),Promise.resolve(void 0))))}catch(ae){this._logService.error(`An error occurred when deactivating the extension '${G.value}':`),this._logService.error(ae)}try{(0,R.dispose)(se.subscriptions)}catch(ae){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this._logService.error(ae)}return W}async _activateExtension(G,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier),this._doActivateExtension(G,W).then(se=>{const ae=se.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(G.identifier,ae.codeLoadingTime,ae.activateCallTime,ae.activateResolvedTime,W),this._logExtensionActivationTimes(G,W,"success",ae),se},se=>{throw this._logExtensionActivationTimes(G,W,"failure"),se})}_logExtensionActivationTimes(G,W,se,ae){const ie=q(G,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ie,...ae||{},outcome:se})}_doActivateExtension(G,W){const se=q(G,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",se);const ae=this._getEntryPoint(G);if(!ae)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${G.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this._logService.flush();const ie=new T.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(G,(0,A.joinPath)(G.extensionLocation,ae),ie),this._loadExtensionContext(G)]).then(le=>(k.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),K._callActivate(this._logService,G.identifier,le[0],le[1],ie))).then(le=>(k.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),le))}_loadExtensionContext(G){const W=this._extHostLanguageModels.createLanguageModelAccessInformation(G),se=new i.ExtensionGlobalMemento(G,this._storage),ae=new i.ExtensionMemento(G.identifier.value,!1,this._storage),ie=new O.ExtensionSecrets(G,this._secretState),le=G.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ue=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([se.whenReady,ae.whenReady,this._storagePath.whenReady]).then(()=>{const Y=this;let oe,pe;const Ee=(0,u.isProposedApiEnabled)(G,"ipc")?this._initData.messagePorts?.get(n.ExtensionIdentifier.toKey(G.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:ae,secrets:ie,subscriptions:[],get languageModelAccessInformation(){return W},get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(Ne){return g.join(G.extensionLocation.fsPath,Ne)},get storagePath(){return Y._storagePath.workspaceValue(G)?.fsPath},get globalStoragePath(){return Y._storagePath.globalValue(G).fsPath},get logPath(){return g.join(Y._initData.logsLocation.fsPath,G.identifier.value)},get logUri(){return l.URI.joinPath(Y._initData.logsLocation,G.identifier.value)},get storageUri(){return Y._storagePath.workspaceValue(G)},get globalStorageUri(){return Y._storagePath.globalValue(G)},get extensionMode(){return le},get extension(){return oe===void 0&&(oe=new ne(Y,G.identifier,G,ue,!1)),oe},get extensionRuntime(){return(0,u.checkProposedApiEnabled)(G,"extensionRuntime"),Y.extensionRuntime},get environmentVariableCollection(){return Y._extHostTerminalService.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!pe){if(!Ee)return;const Ne=b.Event.buffer(b.Event.fromDOMEventEmitter(Ee,"message",We=>We.data));Ee.start(),pe={onDidReceiveMessage:Ne,postMessage:Ee.postMessage.bind(Ee)}}return pe}})})}static _callActivate(G,W,se,ae,ie){return se=se||{activate:void 0,deactivate:void 0},this._callActivateOptional(G,W,se,ae,ie).then(le=>new T.ActivatedExtension(!1,null,ie.build(),se,le,ae.subscriptions))}static _callActivateOptional(G,W,se,ae,ie){if(typeof se.activate=="function")try{ie.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${W.value}`);const le=typeof global=="object"?global:self,ue=se.activate.apply(le,[ae]);return ie.activateCallStop(),ie.activateResolveStart(),Promise.resolve(ue).then(Y=>(ie.activateResolveStop(),Y))}catch(le){return Promise.reject(le)}else return Promise.resolve(se)}_activateOneStartupFinished(G,W){this._activateById(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:W}).then(void 0,se=>{this._logService.error(se)})}_activateAllStartupFinishedDeferred(G,W=0){const ae=Date.now();(0,F.setTimeout0)(()=>{for(let ie=W;ie<G.length;ie+=1){const le=G[ie];for(const ue of le.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-ae>50){this._activateAllStartupFinishedDeferred(G,ie);break}else this._activateOneStartupFinished(le,ue)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks()),this._extHostConfiguration.getConfigProvider().then(G=>{const W=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this._myRegistry.getAllExtensionDescriptions();if(W)this._activateAllStartupFinishedDeferred(se);else for(const ae of se)if(ae.activationEvents)for(const ie of ae.activationEvents)ie==="onStartupFinished"&&this._activateOneStartupFinished(ae,ie)})}_handleEagerExtensions(){const G=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._register(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],se=this._handleWorkspaceContainsEagerExtensions(W),ae=this._handleRemoteResolverEagerExtensions(),ie=Promise.all([ae,G,se]).then(()=>{});return Promise.race([ie,(0,L.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ie}_handleWorkspaceContainsEagerExtensions(G){return G.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(G,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(G,W){if(this.isActivated(W.identifier))return;const se=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ae={logService:this._logService,folders:G.map(le=>le.uri),forceUsingSearch:se||!this._hostUtils.fsExists,exists:le=>this._hostUtils.fsExists(le.fsPath),checkExists:(le,ue,Y)=>this._mainThreadWorkspaceProxy.$checkExists(le,ue,Y)},ie=await(0,w.checkActivateWorkspaceContainsExtension)(ae,W);if(ie)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:ie.activationEvent}).then(void 0,le=>this._logService.error(le))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(G){throw console.error(G),G}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:W}=this._initData.environment;if(!G||!W)throw new Error(r.localize(0,null));const se=await this._loadCommonJSModule(null,W,new T.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(r.localize(1,null,W.toString()));return new Promise((ae,ie)=>{const le=(oe,pe)=>{oe?(F.isCI&&this._logService.error("Test runner called back with error",oe),ie(oe)):(F.isCI&&(pe?this._logService.info(`Test runner called back with ${pe} failures.`):this._logService.info("Test runner called back with successful outcome.")),ae(typeof pe=="number"&&pe>0?1:0))},ue=(0,A.originalFSPath)(W),Y=se.run(ue,le);Y&&Y.then&&Y.then(()=>{F.isCI&&this._logService.info("Test runner finished successfully."),ae(0)}).catch(oe=>{F.isCI&&this._logService.error("Test runner finished with error",oe),ie(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,L.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,W){return this._resolvers[G]=W,(0,R.toDisposable)(()=>{delete this._resolvers[G]})}async getRemoteExecServer(G){const{resolver:W}=await this._activateAndGetResolver(G);return W?.resolveExecServer?.(G,{resolveAttempt:0})}async _activateAndGetResolver(G){const W=G.indexOf("+");if(W===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",c.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=G.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this._resolvers[se]}}async $resolveAuthority(G,W){const se=B.StopWatch.create(!1),ae=()=>`[resolveAuthority(${(0,c.getRemoteAuthorityPrefix)(G)},${W})][${se.elapsed()}ms] `,ie=H=>this._logService.info(`${ae()}${H}`),le=H=>this._logService.warn(`${ae()}${H}`),ue=(H,X=void 0)=>this._logService.error(`${ae()}${H}`,X),Y=H=>{if(H instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:H._code,message:H._message,detail:H._detail}};throw H},oe=async H=>{ie(`activating resolver for ${H}...`);const{resolver:X,authorityPrefix:J}=await this._activateAndGetResolver(H);if(!X)throw ue(`no resolver for ${J}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${J}.`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:J,remoteAuthority:H}},pe=G.split(/@|%40/g).reverse();ie(`activating remote resolvers ${pe.join(" -> ")}`);let Ee;try{Ee=await Promise.all(pe.map(oe)).catch(async H=>{if(!(H instanceof t.RemoteAuthorityResolverError)||H._code!==c.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw H;return le(`resolving nested authorities failed: ${H.message}`),[await oe(G)]})}catch(H){return Y(H)}const Ne=new L.IntervalTimer;Ne.cancelAndSet(()=>ie("waiting..."),1e3);let We,Ce;for(const[H,{authorityPrefix:X,resolver:J,remoteAuthority:fe}]of Ee.entries())try{if(H===Ee.length-1)ie("invoking final resolve()..."),k.mark(`code/extHost/willResolveAuthority/${X}`),We=await J.resolve(fe,{resolveAttempt:W,execServer:Ce}),k.mark(`code/extHost/didResolveAuthorityOK/${X}`),ie("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(J,t.ManagedResolvedAuthority.isManagedResolvedAuthority(We)?We:void 0));else{if(ie(`invoking resolveExecServer() for ${fe}`),k.mark(`code/extHost/willResolveExecServer/${X}`),Ce=await J.resolveExecServer?.(fe,{resolveAttempt:W,execServer:Ce}),!Ce)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${fe}`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);k.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(be){return k.mark(`code/extHost/didResolveAuthorityError/${X}`),ue("returned an error",be),Ne.dispose(),Y(be)}Ne.dispose();const Ie={environmentTunnels:We.environmentTunnels,features:We.tunnelFeatures?{elevation:We.tunnelFeatures.elevation,privacyOptions:We.tunnelFeatures.privacyOptions,protocol:We.tunnelFeatures.protocol===void 0?!0:We.tunnelFeatures.protocol}:void 0},Le={extensionHostEnv:We.extensionHostEnv,isTrusted:We.isTrusted,authenticationSession:We.authenticationSessionForInitializingExtensions?{id:We.authenticationSessionForInitializingExtensions.id,providerId:We.authenticationSessionForInitializingExtensions.providerId}:void 0};ie(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(We)?"managed authority":`${We.host}:${We.port}`}`);let z;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(We)){const H=W;this._extHostManagedSockets.setFactory(H,We.makeConnection),z={authority:G,connectTo:new c.ManagedRemoteConnection(H),connectionToken:We.connectionToken}}else z={authority:G,connectTo:new c.WebSocketRemoteConnection(We.host,We.port),connectionToken:We.connectionToken};return{type:"ok",value:{authority:z,options:Le,tunnelInformation:Ie}}}async $getCanonicalURI(G,W){this._logService.info(`$getCanonicalURI invoked for authority (${(0,c.getRemoteAuthorityPrefix)(G)})`);const{resolver:se}=await this._activateAndGetResolver(G);if(!se)return null;const ae=l.URI.revive(W);if(typeof se.getCanonicalURI>"u")return ae;const ie=await(0,L.asPromise)(()=>se.getCanonicalURI(ae));return ie||ae}async $startExtensionHost(G){G.toAdd.forEach(le=>le.extensionLocation=l.URI.revive(le.extensionLocation));const{globalRegistry:W,myExtensions:se}=$(this._activationEventsReader,this._globalRegistry,this._myRegistry,G),ae=await this._createExtensionPathIndex(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this._globalRegistry.set(W.getAllExtensionDescriptions()),this._myRegistry.set(se),F.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${Z(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${Z(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(G,W){return W===u.ActivationKind.Immediate?this._almostReadyToRunExtensions.wait().then(se=>this._activateByEvent(G,!1)):this._readyToRunExtensions.wait().then(se=>this._activateByEvent(G,!1))}async $activate(G,W){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(G)?(await this._activateById(G,W),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(le=>le.extensionLocation=l.URI.revive(le.extensionLocation));const{globalRegistry:W,myExtensions:se}=$(this._activationEventsReader,this._globalRegistry,this._myRegistry,G),ae=await this._createExtensionPathIndex(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this._globalRegistry.set(W.getAllExtensionDescriptions()),this._myRegistry.set(se),F.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${Z(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${Z(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const W=s.VSBuffer.alloc(G),se=Math.random()%256;for(let ae=0;ae<G;ae++)W.writeUInt8(se,ae);return W}async $updateRemoteConnectionData(G){this._remoteConnectionData=G,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=ee,e.AbstractExtHostExtensionService=ee=K=Ke([Ve(0,h.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,_.IExtHostRpcService),Ve(3,a.IExtHostWorkspace),Ve(4,d.IExtHostConfiguration),Ve(5,P.ILogService),Ve(6,o.IExtHostInitDataService),Ve(7,p.IExtensionStoragePaths),Ve(8,C.IExtHostTunnelService),Ve(9,S.IExtHostTerminalService),Ve(10,x.IExtHostLocalizationService),Ve(11,M.IExtHostManagedSockets),Ve(12,I.IExtHostLanguageModels)],ee);function $(ve,G,W,se){ve.addActivationEvents(se.addActivationEvents);const ae=new f.ExtensionDescriptionRegistry(ve,G.getAllExtensionDescriptions());ae.deltaExtensions(se.toAdd,se.toRemove);const ie=new n.ExtensionIdentifierSet(W.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of se.myToRemove)ie.delete(ue);for(const ue of se.myToAdd)ie.add(ue);const le=de(ae,ie);return{globalRegistry:ae,myExtensions:le}}function q(ve,G){return{id:ve.identifier.value,name:ve.name,extensionVersion:ve.version,publisherDisplayName:ve.publisher,activationEvents:ve.activationEvents?ve.activationEvents.join(","):null,isBuiltin:ve.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function Z(ve){return ve.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.IExtHostExtensionService=(0,h.createDecorator)("IExtHostExtensionService");class ne{#e;#t;#i;constructor(G,W,se,ae,ie){this.#e=G,this.#t=W,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=g.normalize((0,A.originalFSPath)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ae,this.isFromDifferentExtensionHost=ie}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=ne;function de(ve,G){return ve.getAllExtensionDescriptions().filter(W=>G.has(W.identifier))}class re{constructor(G){this._searchTree=G}setSearchTree(G){this._searchTree=G}findSubstr(G){return this._searchTree.findSubstr(G)}forEach(G){return this._searchTree.forEach(G)}}e.ExtensionPaths=re;class Se{constructor(G){this._map=new n.ExtensionIdentifierMap,this.addActivationEvents(G)}readActivationEvents(G){return this._map.get(G.identifier)??[]}addActivationEvents(G){for(const W of Object.keys(G))this._map.set(W,G[W])}}}),define(we[389],ye([1,0,62,2,6,48,26,24,20,30,5,53,12,13]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(s,i,t,c,h,o,p){this._apiFactory=s,this._extensionRegistry=i,this._instaService=t,this._extHostConfiguration=c,this._extHostExtensionService=h,this._initData=o,this._logService=p,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,i,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(u)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,i,this._initData.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const i of s.nodeModuleName)this._factories.set(i,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(i=>s.alternativeModuleName(i))}};e.RequireInterceptor=a,e.RequireInterceptor=a=Ke([Ve(2,P.IInstantiationService),Ve(3,A.IExtHostConfiguration),Ve(4,y.IExtHostExtensionService),Ve(5,l.IExtHostInitDataService),Ve(6,d.ILogService)],a);let u=class{static{E=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&E.aliased.size){const i=(0,T.escapeRegExpCharacters)(this.forceForwardSlashes(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",c=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${h}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(s){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(s));if(!i)return;const[,t,c,h]=i,o=E.aliased.get(c);if(o!==void 0)return console.warn(`${c} as been renamed to ${o}, please update your imports`),t+o+h}forceForwardSlashes(s){return s.replace(/\\/g,"/")}};u=E=Ke([Ve(0,l.IExtHostInitDataService)],u);class f{constructor(s,i,t,c,h){this._apiFactory=s,this._extensionPaths=i,this._extensionRegistry=t,this._configProvider=c,this._logService=h,this.nodeModuleName="vscode",this._extApiImpl=new R.ExtensionIdentifierMap}load(s,i){const t=this._extensionPaths.findSubstr(i);if(t){let c=this._extApiImpl.get(t.identifier);return c||(c=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,c)),c}if(!this._defaultApiImpl){let c="";this._extensionPaths.forEach((h,o)=>c+=`	${o} -> ${h.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${c}`),this._defaultApiImpl=this._apiFactory(L.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let m=class{constructor(s,i,t){this._extensionPaths=s,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(k.MainContext.MainThreadTelemetry);const c=t.getProxy(k.MainContext.MainThreadWindow);this._impl=(h,o)=>{const p=g.URI.parse(h);return o?this.callOriginal(h,o):p.scheme==="http"||p.scheme==="https"?c.$openUri(p,h,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this._appUriScheme?c.$openUri(p,h,{}):this.callOriginal(h,o)}}load(s,i,t){const c=this._extensionPaths.findSubstr(i);return c&&(this._extensionId=c.identifier.value,this.sendShimmingTelemetry()),this._original=t(s),this._impl}callOriginal(s,i){return this.sendNoForwardTelemetry(),this._original(s,i)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=Ke([Ve(2,v.IExtHostRpcService)],m)}),define(we[64],ye([1,0,49,3,16,56,5,78,77,53,10,47,316,48]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,L.createDecorator)("IExtHostVariableResolverProvider");class E extends d.AbstractVariableResolverService{constructor(f,m,n,s,i,t,c){function h(){if(n){const o=n.activeEditor();if(o)return o.document.uri;const p=s.tabGroups.all.find(_=>_.isActive)?.activeTab;if(p!==void 0){if(p.input instanceof P.TextDiffTabInput||p.input instanceof P.NotebookDiffEditorTabInput)return p.input.modified;if(p.input instanceof P.TextTabInput||p.input instanceof P.NotebookEditorTabInput||p.input instanceof P.CustomEditorTabInput)return p.input.uri}}}super({getFolderUri:o=>{const p=t.folders.filter(_=>_.name===o);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(o,p)=>i.getConfiguration(void 0,o).get(p),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=h();if(o)return k.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const o=h();if(o){const p=m.getWorkspaceFolder(o);if(p)return k.normalize(p.uri.fsPath)}}},getSelectedText:()=>{if(n){const o=n.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(n){const o=n.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>f.getExtension(o)},void 0,c?Promise.resolve(c):void 0,Promise.resolve(A.env))}}let a=class extends g.Disposable{constructor(f,m,n,s,i){super(),this.extensionService=f,this.workspaceService=m,this.editorService=n,this.configurationService=s,this.editorTabs=i,this._resolver=new r.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),h={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async o=>{h.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new E(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,h,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=a,e.ExtHostVariableResolverProviderService=a=Ke([Ve(0,l.IExtHostExtensionService),Ve(1,y.IExtHostWorkspace),Ve(2,R.IExtHostDocumentsAndEditors),Ve(3,T.IExtHostConfiguration),Ve(4,v.IExtHostEditorTabs)],a)}),define(we[101],ye([1,0,9,4,2,24,5,6,77,53,20,10,47,152,119,307,48,64,3,50,37,17,19]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,L.createDecorator)("IExtHostDebugService");let c=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(S,I,b,w,N,O,U){this._workspaceService=I,this._extensionService=b,this._configurationService=w,this._editorTabs=N,this._variableResolver=O,this._commands=U,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new g.Emitter,this._onDidTerminateDebugSession=new g.Emitter,this._onDidChangeActiveDebugSession=new g.Emitter,this._onDidReceiveDebugSessionCustomEvent=new g.Emitter,this._debugServiceProxy=S.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new g.Emitter,this._onDidChangeActiveStackItem=new g.Emitter,this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(B=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}async $getVisualizerTreeItem(S,I){const b=this.hydrateVisualizationContext(I);if(!b)return;const w=await this._debugVisualizationTrees.get(S)?.getTreeItem?.(b);return w?this.convertVisualizerTreeItem(S,w):void 0}registerDebugVisualizationTree(S,I,b){const w=A.ExtensionIdentifier.toKey(S.identifier),N=this.extensionVisKey(w,I);if(this._debugVisualizationProviders.has(N))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this._debugVisualizationTrees.set(N,b),this._debugServiceProxy.$registerDebugVisualizerTree(N,!!b.editItem),(0,m.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(N),this._debugVisualizationTrees.delete(I)})}async $getVisualizerTreeItemChildren(S,I){const b=this._debugVisualizationElements.get(I)?.item;return b?(await this._debugVisualizationTrees.get(S)?.getChildren?.(b))?.map(N=>this.convertVisualizerTreeItem(S,N))||[]:[]}async $editVisualizerTreeItem(S,I){const b=this._debugVisualizationElements.get(S);if(!b)return;const w=await this._debugVisualizationTrees.get(b.provider)?.editItem?.(b.item,I);return this.convertVisualizerTreeItem(b.provider,w||b.item)}$disposeVisualizedTree(S){const I=this._debugVisualizationElements.get(S);if(!I)return;const b=[I.children];for(const w of b)if(w)for(const N of w)b.push(this._debugVisualizationElements.get(N)?.children),this._debugVisualizationElements.delete(N)}convertVisualizerTreeItem(S,I){let b=this._debugVisualizationTreeItemIds.get(I);return b||(b=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(I,b),this._debugVisualizationElements.set(b,{provider:S,item:I})),i.DebugTreeItem.from(I,b)}asDebugSourceUri(S,I){const b=S;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let w=`debug:${encodeURIComponent(b.path||"")}`,N="?";return I&&(w+=`${N}session=${encodeURIComponent(I.id)}`,N="&"),w+=`${N}ref=${b.sourceReference}`,k.URI.parse(w)}else{if(b.path)return k.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(S){const I=[];for(const b of S.getAllExtensionDescriptions())if(b.contributes){const w=b.contributes.debuggers;if(w&&w.length>0)for(const N of w)(0,a.isDebuggerMainContribution)(N)&&I.push(N.type)}this._debugServiceProxy.$registerDebugTypes(I)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const S=[];return this._breakpoints.forEach(I=>S.push(I)),S}async $resolveDebugVisualizer(S,I){const b=this._visualizers.get(S);if(!b)throw new Error(`No debug visualizer found with id '${S}'`);let{v:w,provider:N,extensionId:O}=b;if(w.visualization||(w=await N.resolveDebugVisualization?.(w,I)||w,b.v=w),!w.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.serializeVisualization(O,w.visualization)}async $executeDebugVisualizerCommand(S){const I=this._visualizers.get(S);if(!I)throw new Error(`No debug visualizer found with id '${S}'`);const b=I.v.visualization;b&&"command"in b&&this._commands.executeCommand(b.command,...b.arguments||[])}hydrateVisualizationContext(S){const I=this._debugSessions.get(S.sessionId);return I&&{session:I.api,variable:S.variable,containerId:S.containerId,frameId:S.frameId,threadId:S.threadId}}async $provideDebugVisualizers(S,I,b,w){const N=this.hydrateVisualizationContext(b),O=this.extensionVisKey(S,I),U=this._debugVisualizationProviders.get(O);if(!N||!U)return[];const x=await U.provideDebugVisualization(N,w);return x?x.map(B=>{const F=++this._visualizerIdCounter;this._visualizers.set(F,{v:B,provider:U,extensionId:S});const M=B.iconPath?this.getIconPathOrClass(B.iconPath):void 0;return{id:F,name:B.name,iconClass:M?.iconClass,iconPath:M?.iconPath,visualization:this.serializeVisualization(S,B.visualization)}}):[]}$disposeDebugVisualizers(S){for(const I of S)this._visualizers.delete(I)}registerDebugVisualizationProvider(S,I,b){if(!S.contributes?.debugVisualizers?.some(O=>O.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const w=A.ExtensionIdentifier.toKey(S.identifier),N=this.extensionVisKey(w,I);if(this._debugVisualizationProviders.has(N))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this._debugVisualizationProviders.set(N,b),this._debugServiceProxy.$registerDebugVisualizer(w,I),(0,m.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(w,I),this._debugVisualizationProviders.delete(I)})}addBreakpoints(S){const I=S.filter(N=>{const O=N.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,N),!0)});this.fireBreakpointChanges(I,[],[]);const b=[],w=new Map;for(const N of I)if(N instanceof y.SourceBreakpoint){let O=w.get(N.location.uri.toString());O||(O={type:"sourceMulti",uri:N.location.uri,lines:[]},w.set(N.location.uri.toString(),O),b.push(O)),O.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof y.FunctionBreakpoint&&b.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(S){const I=S.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],I,[]);const b=I.filter(O=>O instanceof y.SourceBreakpoint).map(O=>O.id),w=I.filter(O=>O instanceof y.FunctionBreakpoint).map(O=>O.id),N=I.filter(O=>O instanceof y.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(b,w,N)}startDebugging(S,I,b){return this._debugServiceProxy.$startDebugging(S?S.uri:void 0,I,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(S){return this._debugServiceProxy.$stopDebugging(S?S.id:void 0)}registerDebugConfigurationProvider(S,I,b){if(!I)return new y.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:S,handle:w,provider:I}),this._debugServiceProxy.$registerDebugConfigurationProvider(S,b,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,w),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(N=>N.provider!==I),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(S,I,b){if(!b)return new y.Disposable(()=>{});if(!this.definesDebugType(S,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.getAdapterDescriptorFactoryByType(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:I,handle:w,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(I,w),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(N=>N.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(S,I){if(!I)return new y.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:S,handle:b,factory:I}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==I)})}async $runInTerminal(S,I){return Promise.resolve(void 0)}async $substituteVariables(S,I){let b;const w=await this.getFolder(S);return w&&(b={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(b,I)}createDebugAdapter(S,I){if(S.type==="implementation")return new _(S.implementation)}createSignService(){}async $startDASession(S,I){const b=this,w=await this.getSession(I);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const O=this.convertToDto(N),U=this.createDebugAdapter(O,w);if(!U)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const x=U;return this._debugAdapters.set(S,x),this.getDebugAdapterTrackers(w).then(B=>(B&&this._debugAdaptersTrackers.set(S,B),x.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const M=F,K={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const ee=await this._signService.sign(M.arguments.value);K.body={signature:ee},x.sendResponse(K)}else throw new Error("no signer")}catch(ee){K.success=!1,K.message=ee.message,x.sendResponse(K)}}else B&&B.onDidSendMessage&&B.onDidSendMessage(F),F=(0,a.convertToVSCPaths)(F,!0),b._debugServiceProxy.$acceptDAMessage(S,F)}),x.onError(F=>{B&&B.onError&&B.onError(F),this._debugServiceProxy.$acceptDAError(S,F.name,F.message,F.stack)}),x.onExit(F=>{B&&B.onExit&&B.onExit(F??void 0,void 0),this._debugServiceProxy.$acceptDAExit(S,F??void 0,void 0)}),B&&B.onWillStartSession&&B.onWillStartSession(),x.startSession()))})}$sendDAMessage(S,I){I=(0,a.convertToDAPaths)(I,!1);const b=this._debugAdaptersTrackers.get(S);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(I),this._debugAdapters.get(S)?.sendMessage(I)}$stopDASession(S){const I=this._debugAdaptersTrackers.get(S);this._debugAdaptersTrackers.delete(S),I&&I.onWillStopSession&&I.onWillStopSession();const b=this._debugAdapters.get(S);return this._debugAdapters.delete(S),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(S){const I=[],b=[],w=[];if(S.added)for(const N of S.added){const O=N.id;if(O&&!this._breakpoints.has(O)){let U;if(N.type==="function")U=new y.FunctionBreakpoint(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")U=new y.DataBreakpoint(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const x=k.URI.revive(N.uri);U=new y.SourceBreakpoint(new y.Location(x,new y.Position(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,y.setBreakpointId)(U,O),this._breakpoints.set(O,U),I.push(U)}}if(S.removed)for(const N of S.removed){const O=this._breakpoints.get(N);O&&(this._breakpoints.delete(N),b.push(O))}if(S.changed){for(const N of S.changed)if(N.id){const O=this._breakpoints.get(N.id);if(O){if(O instanceof y.FunctionBreakpoint&&N.type==="function"){const U=O;U.enabled=N.enabled,U.condition=N.condition,U.hitCondition=N.hitCondition,U.logMessage=N.logMessage,U.functionName=N.functionName}else if(O instanceof y.SourceBreakpoint&&N.type==="source"){const U=O;U.enabled=N.enabled,U.condition=N.condition,U.hitCondition=N.hitCondition,U.logMessage=N.logMessage,U.location=new y.Location(k.URI.revive(N.uri),new y.Position(N.line,N.character))}w.push(O)}}}this.fireBreakpointChanges(I,b,w)}async $acceptStackFrameFocus(S){let I;if(S){const b=await this.getSession(S.sessionId);S.kind==="thread"?I=new y.DebugThread(b.api,S.threadId):I=new y.DebugStackFrame(b.api,S.threadId,S.frameId)}this._activeStackItem=I,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(S,I,b){return(0,r.asPromise)(async()=>{const w=this.getConfigProviderByHandle(S);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.getFolder(I);return w.provideDebugConfigurations(N,b)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(S,I,b,w){return(0,r.asPromise)(async()=>{const N=this.getConfigProviderByHandle(S);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(I);return N.resolveDebugConfiguration(O,b,w)})}$resolveDebugConfigurationWithSubstitutedVariables(S,I,b,w){return(0,r.asPromise)(async()=>{const N=this.getConfigProviderByHandle(S);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(I);return N.resolveDebugConfigurationWithSubstitutedVariables(O,b,w)})}async $provideDebugAdapter(S,I){const b=this.getAdapterDescriptorFactoryByHandle(S);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(I);return this.getAdapterDescriptor(b,w).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(N)})}async $acceptDebugSessionStarted(S){const I=await this.getSession(S);this._onDidStartDebugSession.fire(I.api)}async $acceptDebugSessionTerminated(S){const I=await this.getSession(S);I&&(this._onDidTerminateDebugSession.fire(I.api),this._debugSessions.delete(I.id))}async $acceptDebugSessionActiveChanged(S){this._activeDebugSession=S?await this.getSession(S):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(S,I){(await this.getSession(S))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(S,I){const w={session:(await this.getSession(S)).api,event:I.event,body:I.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(S){if(S instanceof y.DebugAdapterExecutable)return{type:"executable",command:S.command,args:S.args,options:S.options};if(S instanceof y.DebugAdapterServer)return{type:"server",port:S.port,host:S.host};if(S instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:S.path};if(S instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:S.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(S){const I=this._adapterFactories.filter(b=>b.type===S);if(I.length>0)return I[0].factory}getAdapterDescriptorFactoryByHandle(S){const I=this._adapterFactories.filter(b=>b.handle===S);if(I.length>0)return I[0].factory}getConfigProviderByHandle(S){const I=this._configProviders.filter(b=>b.handle===S);if(I.length>0)return I[0].provider}definesDebugType(S,I){if(S.contributes){const b=S.contributes.debuggers;if(b&&b.length>0){for(const w of b)if(w.label&&w.type&&w.type===I)return!0}}return!1}getDebugAdapterTrackers(S){const b=S.configuration.type,w=this._trackerFactories.filter(N=>N.type===b||N.type==="*").map(N=>(0,r.asPromise)(()=>N.factory.createDebugAdapterTracker(S.api)).then(O=>O,O=>null));return Promise.race([Promise.all(w).then(N=>{const O=(0,t.coalesce)(N);if(O.length>0)return new p(O)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async getAdapterDescriptor(S,I){const b=I.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new y.DebugAdapterServer(b));if(S){const N=await this._extensionService.getExtensionRegistry();return(0,r.asPromise)(()=>S.createDebugAdapterDescriptor(I.api,this.daExecutableFromPackage(I,N))).then(O=>{if(O)return O})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(I,w))}daExecutableFromPackage(S,I){}fireBreakpointChanges(S,I,b){(S.length>0||I.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:S,removed:I,changed:b}))}async getSession(S){if(S)if(typeof S=="string"){const I=this._debugSessions.get(S);if(I)return I}else{let I=this._debugSessions.get(S.id);if(!I){const b=await this.getFolder(S.folderUri),w=S.parent?this._debugSessions.get(S.parent):void 0;I=new h(this._debugServiceProxy,S.id,S.type,S.name,b,S.configuration,w?.api),this._debugSessions.set(I.id,I),this._debugServiceProxy.$sessionCached(I.id)}return I}throw new Error("cannot find session")}getFolder(S){if(S){const I=k.URI.revive(S);return this._workspaceService.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}extensionVisKey(S,I){return`${S}\0${I}`}serializeVisualization(S,I){if(I){if("title"in I&&"command"in I)return{type:E.DebugVisualizationType.Command};if("treeId"in I)return{type:E.DebugVisualizationType.Tree,id:`${S}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(S){const I=this.getIconUris(S);let b,w;return"id"in I?w=n.ThemeIcon.asClassName(I):b=I,{iconPath:b,iconClass:w}}getIconUris(S){if(S instanceof y.ThemeIcon)return{id:S.id};const I=typeof S=="object"&&"dark"in S?S.dark:S,b=typeof S=="object"&&"light"in S?S.light:S;return{dark:typeof I=="string"?k.URI.file(I):I,light:typeof b=="string"?k.URI.file(b):b}}};e.ExtHostDebugServiceBase=c,e.ExtHostDebugServiceBase=c=Ke([Ve(0,P.IExtHostRpcService),Ve(1,d.IExtHostWorkspace),Ve(2,l.IExtHostExtensionService),Ve(3,u.IExtHostConfiguration),Ve(4,v.IExtHostEditorTabs),Ve(5,f.IExtHostVariableResolverProvider),Ve(6,s.IExtHostCommands)],c);class h{constructor(S,I,b,w,N,O,U){this._debugServiceProxy=S,this._id=I,this._type=b,this._name=w,this._workspaceFolder=N,this._configuration=O,this._parentSession=U}get api(){const S=this;return this.apiSession??=Object.freeze({id:S._id,type:S._type,get name(){return S._name},set name(I){S._name=I,S._debugServiceProxy.$setDebugSessionName(S._id,I)},parentSession:S._parentSession,workspaceFolder:S._workspaceFolder,configuration:S._configuration,customRequest(I,b){return S._debugServiceProxy.$customDebugAdapterRequest(S._id,I,b)},getDebugProtocolBreakpoint(I){return S._debugServiceProxy.$getDebugProtocolBreakpoint(S._id,I.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(S){this._name=S}get configuration(){return this._configuration}}e.ExtHostDebugSession=h;class o{constructor(S){this.value=Object.freeze({append(I){S.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.ExtHostDebugConsole=o;class p{constructor(S){this.trackers=S}onWillStartSession(){this.trackers.forEach(S=>S.onWillStartSession?S.onWillStartSession():void 0)}onWillReceiveMessage(S){this.trackers.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(S):void 0)}onDidSendMessage(S){this.trackers.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(S):void 0)}onWillStopSession(){this.trackers.forEach(S=>S.onWillStopSession?S.onWillStopSession():void 0)}onError(S){this.trackers.forEach(I=>I.onError?I.onError(S):void 0)}onExit(S,I){this.trackers.forEach(b=>b.onExit?b.onExit(S,I):void 0)}}class _ extends T.AbstractDebugAdapter{constructor(S){super(),this.implementation=S,S.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(S){this.implementation.handleMessage(S)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let D=class extends c{constructor(S,I,b,w,N,O,U){super(S,I,b,w,N,O,U)}};e.WorkerExtHostDebugService=D,e.WorkerExtHostDebugService=D=Ke([Ve(0,P.IExtHostRpcService),Ve(1,d.IExtHostWorkspace),Ve(2,l.IExtHostExtensionService),Ve(3,u.IExtHostConfiguration),Ve(4,v.IExtHostEditorTabs),Ve(5,f.IExtHostVariableResolverProvider),Ve(6,s.IExtHostCommands)],D)}),define(we[390],ye([1,0,14,62,2,6,338,12,89,114,30,274,20,72,53,95]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class u{static async installEarlyHandler(n){Error.stackTraceLimit=100;const s=n.get(R.ILogService),t=n.get(d.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);r.setUnexpectedErrorHandler(c=>{s.error(c);const h=r.transformErrorForSerialization(c);t.$onUnexpectedError(h)})}static async installFullHandler(n){const s=n.get(R.ILogService),i=n.get(d.IExtHostRpcService),t=n.get(E.IExtHostExtensionService),c=n.get(a.IExtHostTelemetry),h=i.getProxy(A.MainContext.MainThreadExtensionService),o=i.getProxy(A.MainContext.MainThreadErrors),p=await t.getExtensionPathIndex(),_=new WeakMap;function D(I,b){if(_.has(I))return _.get(I).stack;let w="",N,O;for(const x of b)w+=`
	at ${x.toString()}`,O=x.getFileName(),!N&&O&&(N=p.findSubstr(k.URI.file(O)));const U=`${I.name||"Error"}: ${I.message||""}${w}`;return _.set(I,{extensionIdentifier:N?.identifier,stack:U}),U}const C=Symbol("prepareStackTrace wrapped");let S=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return S},set(I){if(I===D||!I||I[C]){S=I||D;return}S=function(b,w){return D(b,w),I.call(Error,b,w)},Object.assign(S,{[C]:!0})}}),r.setUnexpectedErrorHandler(I=>{s.error(I);const b=r.transformErrorForSerialization(I),w=_.get(I);if(!w?.extensionIdentifier){o.$onUnexpectedError(b);return}h.$onExtensionRuntimeError(w.extensionIdentifier,b);const N=c.onExtensionError(w.extensionIdentifier,I);s.trace("forwarded error to extension?",N,w)})}}e.ErrorHandler=u;class f{constructor(n,s,i,t,c){this._hostUtils=i,this._rpcProtocol=new L.RPCProtocol(n,null,t),s=f._transform(s,this._rpcProtocol);const h=new l.ServiceCollection(...(0,v.getSingletonServiceDescriptors)());h.set(P.IExtHostInitDataService,{_serviceBrand:void 0,...s,messagePorts:c}),h.set(d.IExtHostRpcService,new d.ExtHostRpcService(this._rpcProtocol)),h.set(T.IURITransformerService,new T.URITransformerService(t)),h.set(E.IHostUtils,i);const o=new y.InstantiationService(h,!0);o.invokeFunction(u.installEarlyHandler),this._logService=o.invokeFunction(p=>p.get(R.ILogService)),g.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",s),this._extensionService=o.invokeFunction(p=>p.get(E.IExtHostExtensionService)),this._extensionService.initialize(),o.invokeFunction(u.installFullHandler)}async asBrowserUri(n){const s=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return k.URI.revive(await s.$asBrowserUri(n))}terminate(n){this._extensionService.terminate(n)}static _transform(n,s){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=k.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=k.URI.revive(s.transformIncomingURIs(n.environment.appRoot));const i=n.environment.extensionDevelopmentLocationURI;return i&&(n.environment.extensionDevelopmentLocationURI=i.map(t=>k.URI.revive(s.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=k.URI.revive(s.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=k.URI.revive(s.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=k.URI.revive(s.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=k.URI.revive(s.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=k.URI.revive(s.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=k.URI.revive(s.transformIncomingURIs(n.logsLocation)),n.workspace=s.transformIncomingURIs(n.workspace),n}}e.ExtensionHostMain=f}),define(we[391],ye([1,0,9,11,244,267,147,101,77,53,20,46,10,64,47,308,309,48,37]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let n=class extends R.ExtHostDebugServiceBase{constructor(h,o,p,_,D,C,S,I){super(h,o,p,_,C,S,I),this._terminalService=D,this._integratedTerminalInstances=new t}createDebugAdapter(h,o){switch(h.type){case"server":return new a.SocketDebugAdapter(h);case"pipeServer":return new a.NamedPipeDebugAdapter(h);case"executable":return new a.ExecutableDebugAdapter(h,o.type)}return super.createDebugAdapter(h,o)}daExecutableFromPackage(h,o){const p=a.ExecutableDebugAdapter.platformAdapterExecutable(o.getAllExtensionDescriptions(),h.type);if(p)return new d.DebugAdapterExecutable(p.command,p.args,p.options)}createSignService(){return new L.SignService}async $runInTerminal(h,o){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(x=>{this._integratedTerminalInstances.onTerminalClosed(x)}));const p=await this._configurationService.getConfigProvider(),_=this._terminalService.getDefaultShell(!0),D=this._terminalService.getDefaultShellArgs(!0),C=h.title||k.localize(0,null),S=JSON.stringify({shell:_,shellArgs:D});let I=await this._integratedTerminalInstances.checkout(S,C),b,w=!1;if(I)b=h.cwd;else{const x={shellPath:_,shellArgs:D,cwd:h.cwd,name:C,iconPath:new d.ThemeIcon("debug")};w=!0,I=this._terminalService.createTerminalFromOptions(x,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(I,S)}I.show(!0);const N=await I.processId;w?await new Promise(x=>setTimeout(x,1e3)):(I.state.isInteractedWith&&(I.sendText(""),await(0,r.timeout)(200)),p.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(_.indexOf("powershell")>=0||_.indexOf("pwsh")>=0||_.indexOf("cmd.exe")>=0?I.sendText("cls"):_.indexOf("bash")>=0?I.sendText("clear"):g.isWindows?I.sendText("cls"):I.sendText("clear")));const O=(0,u.prepareCommand)(_,h.args,!!h.argsCanBeInterpretedByShell,b,h.env);I.sendText(O);const U=this.onDidTerminateDebugSession(x=>{x.id===o&&(this._integratedTerminalInstances.free(I),U.dispose())});return N}else if(h.kind==="external")return i(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,o)}};e.ExtHostDebugService=n,e.ExtHostDebugService=n=Ke([Ve(0,P.IExtHostRpcService),Ve(1,E.IExtHostWorkspace),Ve(2,l.IExtHostExtensionService),Ve(3,f.IExtHostConfiguration),Ve(4,y.IExtHostTerminalService),Ve(5,v.IExtHostEditorTabs),Ve(6,T.IExtHostVariableResolverProvider),Ve(7,m.IExtHostCommands)],n);let s;function i(c,h){if(!s)if(g.isWindows)s=new A.WindowsExternalTerminalService;else if(g.isMacintosh)s=new A.MacExternalTerminalService;else if(g.isLinux)s=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const o=h.getConfiguration("terminal");return s.runInTerminal(c.title,c.cwd,c.args,c.env||{},o.external||{})}class t{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(h,o,p=!1){const D=[...this._terminalInstances.entries()].map(([C,S])=>(0,r.createCancelablePromise)(async I=>{if(C.name!==o||S.lastUsedAt!==-1&&await(0,u.hasChildProcesses)(await C.processId))return null;const b=Date.now();return S.lastUsedAt+t.minUseDelay>b||I.isCancellationRequested?null:S.config!==h?(p&&C.dispose(),null):(S.lastUsedAt=b,C)}));return await(0,r.firstParallel)(D,C=>!!C)}insert(h,o){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:o})}free(h){const o=this._terminalInstances.get(h);o&&(o.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}}),define(we[392],ye([1,0,16,2,111,47,78,48,45,46,20,30,100,15,12,96,23,67,64]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let n=class extends d.ExtHostTaskBase{constructor(i,t,c,h,o,p,_,D,C){super(i,t,c,h,o,p,_,D),this.workspaceService=c,this.variableResolver=C,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(i,t){const c=t;if(!t.execution&&c._id===void 0)throw new Error("Tasks to execute must include an execution");if(c._id!==void 0){const h=d.TaskHandleDTO.from(c,this.workspaceService),o=await this._proxy.$getTaskExecution(h);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const p=await this.getTaskExecution(o,t);return this._proxy.$executeTask(h).catch(()=>{}),p}else{const h=d.TaskDTO.from(t,i);if(h===void 0)return Promise.reject(new Error("Task is not valid"));d.CustomExecutionDTO.is(h.execution)&&await this.addCustomExecution(h,t,!1);const o=await this.getTaskExecution(await this._proxy.$getTaskExecution(h),t);return this._proxy.$executeTask(h).catch(()=>{}),o}}provideTasksInternal(i,t,c,h){const o=[];if(h)for(const p of h){this.checkDeprecation(p,c),(!p.definition||!i[p.definition.type])&&this._logService.warn(`The task [${p.source}, ${p.name}] uses an undefined task type. The task will be ignored in the future.`);const _=d.TaskDTO.from(p,c.extension);_&&(o.push(_),d.CustomExecutionDTO.is(_.execution)&&t.push(this.addCustomExecution(_,p,!0)))}return{tasks:o,extension:c.extension}}async resolveTaskInternal(i){return i}async getAFolder(i){let t=i&&i.length>0?i[0]:void 0;if(!t){const c=g.URI.file((0,f.homedir)());t=new v.WorkspaceFolder({uri:c,name:u.basename(c),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(i,t){const c=g.URI.revive(i),h={process:void 0,variables:Object.create(null)},o=await this._workspaceProvider.resolveWorkspaceFolder(c),p=await this._workspaceProvider.getWorkspaceFolders2()??[],_=await this.variableResolver.getResolver(),D=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(p);for(const C of t.variables)h.variables[C]=await _.resolveAsync(D,C);if(t.process!==void 0){let C;if(t.process.path!==void 0){C=t.process.path.split(r.delimiter);for(let S=0;S<C.length;S++)C[S]=await _.resolveAsync(D,C[S])}h.process=await k.win32.findExecutable(await _.resolveAsync(D,t.process.name),t.process.cwd!==void 0?await _.resolveAsync(D,t.process.cwd):void 0,C)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(i,t,c){return k.win32.findExecutable(i,t,c)}};e.ExtHostTask=n,e.ExtHostTask=n=Ke([Ve(0,P.IExtHostRpcService),Ve(1,y.IExtHostInitDataService),Ve(2,A.IExtHostWorkspace),Ve(3,L.IExtHostDocumentsAndEditors),Ve(4,R.IExtHostConfiguration),Ve(5,l.IExtHostTerminalService),Ve(6,E.ILogService),Ve(7,a.IExtHostApiDeprecationService),Ve(8,m.IExtHostVariableResolverProvider)],n)}),define(we[393],ye([1,0,67,64]),function(he,e,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class k extends g.ExtHostVariableResolverProviderService{homeDir(){return(0,r.homedir)()}}e.NodeExtHostVariableResolverProviderService=k}),define(we[169],ye([1,0,19,9,21,51,15,16,23,2,38]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,e.extensionResultIsMatch=a;class y{constructor(m,n,s){this.queryProviderPair=m,this.fileUtils=n,this.processType=s,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(m,n){const s=this.query.folderQueries||[],i=new k.CancellationTokenSource(n);return new Promise((t,c)=>{this.collector=new T(m);let h=!1;const o=(p,_)=>{if(!h&&!this.isLimitHit){const D=this.resultSize(p);a(p)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,h=!0,i.cancel(),p=this.trimResultToSize(p,this.query.maxResults-this.resultCount));const C=this.resultSize(p);this.resultCount+=C,(C>0||!a(p))&&this.collector.add(p,_)}};Promise.all(s.map((p,_)=>this.searchInFolder(p,D=>o(D,_),i.token))).then(p=>{i.dispose(),this.collector.flush();const _=p.some(D=>!!D&&!!D.limitHit);t({limitHit:this.isLimitHit||_,messages:p.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.processType}})},p=>{i.dispose();const _=(0,A.toErrorMessage)(p);c(new Error(_))})})}resultSize(m){return a(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}trimResultToSize(m,n){const s=Array.isArray(m.ranges)?m.ranges:[m.ranges],i=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:s.slice(0,n),preview:{matches:i.slice(0,n),text:m.preview.text},uri:m.uri}}async searchInFolder(m,n,s){const i=new P.QueryGlobTester(this.query,m),t=[],c={report:p=>{if(!this.validateProviderResult(p))return;const _=m.folder.scheme===L.Schemas.file?(0,P.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(v.dirname(p.uri))):void 0,D=v.relativePath(m.folder,p.uri);if(D){const C=i.includedInQuery(D,R.basename(D),_);(0,g.isThenable)(C)?t.push(C.then(S=>{S&&n(p)})):C&&n(p)}}},h=this.getSearchOptionsForFolder(m);let o;return this.queryProviderPair.query.type===P.QueryType.aiText?o=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,h,c,s):o=await this.queryProviderPair.provider.provideTextSearchResults(d(this.queryProviderPair.query.contentPattern),h,c,s),t.length&&await Promise.all(t),o}validateProviderResult(m){if(a(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(m){const n=(0,P.resolvePatternsForProvider)(this.query.includePattern,m.includePattern),s=(0,P.resolvePatternsForProvider)(this.query.excludePattern,m.excludePattern),i={folder:l.URI.from(m.folder),excludes:s,includes:n,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.fileUtils.toCanonicalName(m.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return"usePCRE2"in this.query&&(i.usePCRE2=this.query.usePCRE2),i}}e.TextSearchManager=y;function d(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class T{constructor(m){this._onResult=m,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new u(512,n=>this.sendItems(n))}add(m,n){this._currentFileMatch&&(this._currentFolderIdx!==n||!v.isEqual(this._currentUri,m.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=n,this._currentFileMatch={resource:m.uri,results:[]}),this._currentFileMatch.results.push(E(m))}pushToCollector(){const m=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,m)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(m){this._onResult(m)}}e.TextSearchResultsCollector=T;function E(f){return a(f)?{preview:{matches:(0,r.mapArrayOrNot)(f.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:f.preview.text},ranges:(0,r.mapArrayOrNot)(f.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function a(f){return!!f.preview}class u{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(m,n){this.maxBatchSize=m,this.cb=n,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(m,n){m&&this.addItemToBatch(m,n)}addItems(m,n){m&&this.addItemsToBatch(m,n)}addItemToBatch(m,n){this.batch.push(m),this.batchSize+=n,this.onUpdate()}addItemsToBatch(m,n){this.batch=this.batch.concat(m),this.batchSize+=n,this.onUpdate()}onUpdate(){this.totalNumberCompleted<u.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},u.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=u}),define(we[102],ye([1,0,3,6,5,386,20,72,12,2,169]),function(he,e,r,g,k,A,L,R,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=d,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let y=class{constructor(a,u,f){this.extHostRpc=a,this._uriTransformer=u,this._logService=f,this._proxy=this.extHostRpc.getProxy(g.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,u){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const f=this._handlePool++;return this._textSearchProvider.set(f,u),this._proxy.$registerTextSearchProvider(f,this._transformScheme(a)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerAITextSearchProvider(a,u){if(this._aiTextSearchUsedSchemes.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this._aiTextSearchUsedSchemes.add(a);const f=this._handlePool++;return this._aiTextSearchProvider.set(f,u),this._proxy.$registerAITextSearchProvider(f,this._transformScheme(a)),(0,r.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(a),this._aiTextSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(a,u){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const f=this._handlePool++;return this._fileSearchProvider.set(f,u),this._proxy.$registerFileSearchProvider(f,this._transformScheme(a)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(a,u,f,m){const n=d(f),s=this._fileSearchProvider.get(a);if(s)return this._fileSearchManager.fileSearch(n,s,i=>{this._proxy.$handleFileMatch(a,u,i.map(t=>t.resource))},m);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,u,f){return{messages:[]}}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,u,f,m){const n=this._textSearchProvider.get(a);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${a}`);const s=d(f);return this.createTextSearchManager(s,n).search(t=>this._proxy.$handleTextMatch(a,u,t),m)}$provideAITextSearchResults(a,u,f,m){const n=this._aiTextSearchProvider.get(a);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${a}`);const s=d(f);return this.createAITextSearchManager(s,n).search(t=>this._proxy.$handleTextMatch(a,u,t),m)}$enableExtensionHostSearch(){}createTextSearchManager(a,u){return new P.TextSearchManager({query:a,provider:u},{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}createAITextSearchManager(a,u){return new P.TextSearchManager({query:a,provider:u},{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"aiTextSearchProvider")}};e.ExtHostSearch=y,e.ExtHostSearch=y=Ke([Ve(0,L.IExtHostRpcService),Ve(1,R.IURITransformerService),Ve(2,v.ILogService)],y);function d(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(T),extraFileResources:E.extraFileResources&&E.extraFileResources.map(a=>l.URI.revive(a))}}function T(E){return{...E,folder:l.URI.revive(E.folder)}}}),define(we[394],ye([1,0,21,14,4,3,15,43,2,113,211,192,55,24,28,12,91,92,294,6,340,366,96,127,344,345,346,325,314,37,347,48,348,101,161,349,327,341,350,351,78,77,328,342,53,352,75,353,63,30,367,329,354,128,355,122,123,330,385,357,298,358,368,359,167,331,360,361,362,20,363,102,124,364,332,365,125,98,100,95,46,165,369,370,343,371,372,76,17,10,333,72,334,97,373,374,160,47,119,94,26,99]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i,t,c,h,o,p,_,D,C,S,I,b,w,N,O,U,x,B,F,M,K,ee,$,q,Z,ne,de,re,Se,ve,G,W,se,ae,ie,le,ue,Y,oe,pe,Ee,Ne,We,Ce,Ie,Le,z,H,X,J,fe,be,Fe,He,qe,Ye,it,tt,rt,ot,ft,ut,st,Te,Ue,ke,Re,ce,Q,Pe,Ge,Ze,at,ct,Ct,Pt,Ot,Xt,Zt,Je,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=Bt;function Bt(mt){const pt=mt.get(Se.IExtHostInitDataService),ei=mt.get(re.IExtHostFileSystemInfo),Qt=mt.get(ne.IExtHostConsumerFileSystem),Wt=mt.get(q.IExtHostExtensionService),Et=mt.get(Ot.IExtHostWorkspace),Ft=mt.get(rt.IExtHostTelemetry),qt=mt.get(I.IExtHostConfiguration),zt=mt.get(Ge.IURITransformerService),Qe=mt.get(X.IExtHostRpcService),ti=mt.get(Ye.IExtHostStorage),ii=mt.get(it.IExtensionStoragePaths),ci=mt.get(a.ILoggerService),Dt=mt.get(a.ILogService),Nt=mt.get(Re.IExtHostTunnelService),At=mt.get(t.IExtHostApiDeprecationService),Mt=mt.get(Pt.IExtHostWindow),ui=mt.get(be.IExtHostSecretState),Ht=mt.get(K.IExtHostEditorTabs),si=mt.get(le.IExtHostManagedSockets),Ut=mt.get(c.IExtHostAuthentication),Yt=mt.get(se.IExtHostLanguageModels);Qe.set(n.ExtHostContext.ExtHostFileSystemInfo,ei),Qe.set(n.ExtHostContext.ExtHostLogLevelServiceShape,ci),Qe.set(n.ExtHostContext.ExtHostWorkspace,Et),Qe.set(n.ExtHostContext.ExtHostConfiguration,qt),Qe.set(n.ExtHostContext.ExtHostExtensionService,Wt),Qe.set(n.ExtHostContext.ExtHostStorage,ti),Qe.set(n.ExtHostContext.ExtHostTunnelService,Nt),Qe.set(n.ExtHostContext.ExtHostWindow,Mt),Qe.set(n.ExtHostContext.ExtHostSecretState,ui),Qe.set(n.ExtHostContext.ExtHostTelemetry,Ft),Qe.set(n.ExtHostContext.ExtHostEditorTabs,Ht),Qe.set(n.ExtHostContext.ExtHostManagedSockets,si),Qe.set(n.ExtHostContext.ExtHostAuthentication,Ut),Qe.set(n.ExtHostContext.ExtHostChatProvider,Yt);const oi=Qe.set(n.ExtHostContext.ExtHostDecorations,mt.get(N.IExtHostDecorations)),kt=Qe.set(n.ExtHostContext.ExtHostDocumentsAndEditors,mt.get(M.IExtHostDocumentsAndEditors)),St=Qe.set(n.ExtHostContext.ExtHostCommands,mt.get(C.IExtHostCommands)),vt=Qe.set(n.ExtHostContext.ExtHostTerminalService,mt.get(ot.IExtHostTerminalService)),Vt=Qe.set(n.ExtHostContext.ExtHostTerminalShellIntegration,mt.get(ft.IExtHostTerminalShellIntegration)),yt=Qe.set(n.ExtHostContext.ExtHostDebugService,mt.get(w.IExtHostDebugService)),ai=Qe.set(n.ExtHostContext.ExtHostSearch,mt.get(fe.IExtHostSearch)),jt=Qe.set(n.ExtHostContext.ExtHostTask,mt.get(tt.IExtHostTask)),pi=Qe.set(n.ExtHostContext.ExtHostOutputService,mt.get(Ce.IExtHostOutputService)),hi=Qe.set(n.ExtHostContext.ExtHostLocalization,mt.get(ie.IExtHostLocalizationService)),Ci=Qe.set(n.ExtHostContext.ExtHostUrls,new Ze.ExtHostUrls(Qe)),Rt=Qe.set(n.ExtHostContext.ExtHostDocuments,new F.ExtHostDocuments(Qe,kt)),Pi=Qe.set(n.ExtHostContext.ExtHostDocumentContentProviders,new x.ExtHostDocumentContentProvider(Qe,kt,Dt)),li=Qe.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new B.ExtHostDocumentSaveParticipant(Dt,Rt,Qe.getProxy(n.MainContext.MainThreadBulkEdits))),Tt=Qe.set(n.ExtHostContext.ExtHostNotebook,new Y.ExtHostNotebookController(Qe,St,kt,Rt,Qt,ai,Dt)),Ii=Qe.set(n.ExtHostContext.ExtHostNotebookDocuments,new pe.ExtHostNotebookDocuments(Tt)),Si=Qe.set(n.ExtHostContext.ExtHostNotebookEditors,new Ee.ExtHostNotebookEditors(Dt,Tt)),vi=Qe.set(n.ExtHostContext.ExtHostNotebookKernels,new Ne.ExtHostNotebookKernels(Qe,pt,Tt,St,Dt)),ki=Qe.set(n.ExtHostContext.ExtHostNotebookRenderers,new We.ExtHostNotebookRenderers(Qe,Tt)),fi=Qe.set(n.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new oe.ExtHostNotebookDocumentSaveParticipant(Dt,Tt,Qe.getProxy(n.MainContext.MainThreadBulkEdits))),Ae=Qe.set(n.ExtHostContext.ExtHostEditors,new st.ExtHostEditors(Qe,kt)),xe=Qe.set(n.ExtHostContext.ExtHostTreeViews,new ke.ExtHostTreeViews(Qe.getProxy(n.MainContext.MainThreadTreeViews),St,Dt)),De=Qe.set(n.ExtHostContext.ExtHostEditorInsets,new D.ExtHostEditorInsets(Qe.getProxy(n.MainContext.MainThreadEditorInsets),Ae,pt.remote)),te=Qe.set(n.ExtHostContext.ExtHostDiagnostics,new O.ExtHostDiagnostics(Qe,Dt,ei,kt)),Me=Qe.set(n.ExtHostContext.ExtHostLanguages,new ae.ExtHostLanguages(Qe,Rt,St.converter,zt)),$e=Qe.set(n.ExtHostContext.ExtHostLanguageFeatures,new W.ExtHostLanguageFeatures(Qe,zt,Rt,St,te,Dt,At,Ft)),et=Qe.set(n.ExtHostContext.ExtHostFileSystem,new Z.ExtHostFileSystem(Qe,$e)),je=Qe.set(n.ExtHostContext.ExtHostFileSystemEventService,new de.ExtHostFileSystemEventService(Qe,Dt,kt)),ht=Qe.set(n.ExtHostContext.ExtHostQuickOpen,(0,H.createExtHostQuickOpen)(Qe,Et,St)),It=Qe.set(n.ExtHostContext.ExtHostSCM,new J.ExtHostSCM(Qe,St,Rt,Dt)),Jt=Qe.set(n.ExtHostContext.ExtHostQuickDiff,new z.ExtHostQuickDiff(Qe,zt)),ni=Qe.set(n.ExtHostContext.ExtHostShare,new Fe.ExtHostShare(Qe,zt)),xt=Qe.set(n.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(Qe,St,Rt)),Kt=Qe.set(n.ExtHostContext.ExtHostProgress,new Le.ExtHostProgress(Qe.getProxy(n.MainContext.MainThreadProgress))),Mi=Qe.set(n.ExtHostContext.ExtHostLabelService,new G.ExtHostLabelService(Qe)),xi=Qe.set(n.ExtHostContext.ExtHostTheming,new Te.ExtHostTheming(Qe)),Qi=Qe.set(n.ExtHostContext.ExtHostTimeline,new Ue.ExtHostTimeline(Qe,St)),Ui=Qe.set(n.ExtHostContext.ExtHostWebviews,new at.ExtHostWebviews(Qe,pt.remote,Et,Dt,At)),Ri=Qe.set(n.ExtHostContext.ExtHostWebviewPanels,new ct.ExtHostWebviewPanels(Qe,Ui,Et)),Bi=Qe.set(n.ExtHostContext.ExtHostCustomEditors,new b.ExtHostCustomEditors(Qe,Rt,ii,Ui,Ri)),Wi=Qe.set(n.ExtHostContext.ExtHostWebviewViews,new Ct.ExtHostWebviewViews(Qe,Ui)),wi=Qe.set(n.ExtHostContext.ExtHostTesting,new ut.ExtHostTesting(Qe,Dt,St,kt)),Yi=Qe.set(n.ExtHostContext.ExtHostUriOpeners,new Pe.ExtHostUriOpeners(Qe)),Ji=Qe.set(n.ExtHostContext.ExtHostProfileContentHandlers,new Ie.ExtHostProfileContentHandlers(Qe));Qe.set(n.ExtHostContext.ExtHostInteractive,new ve.ExtHostInteractive(Qe,Tt,kt,St,Dt));const Li=Qe.set(n.ExtHostContext.ExtHostChatAgents2,new o.ExtHostChatAgents2(Qe,Dt,St,pt.quality)),zi=Qe.set(n.ExtHostContext.ExtHostChatVariables,new p.ExtHostChatVariables(Qe)),$i=Qe.set(n.ExtHostContext.ExtHostAiRelatedInformation,new s.ExtHostRelatedInformation(Qe)),gn=Qe.set(n.ExtHostContext.ExtHostAiEmbeddingVector,new $.ExtHostAiEmbeddingVector(Qe)),Zi=Qe.set(n.ExtHostContext.ExtHostStatusBar,new qe.ExtHostStatusBar(Qe,St.converter)),Hi=Qe.set(n.ExtHostContext.ExtHostSpeech,new He.ExtHostSpeech(Qe)),_i=Qe.set(n.ExtHostContext.ExtHostEmbeddings,new ee.ExtHostEmbeddings(Qe)),mn=Object.values(n.ExtHostContext);Qe.assertRegistered(mn);const pn=new h.ExtHostBulkEdits(Qe,kt),en=new _.ExtHostClipboard(Qe),Vi=new ue.ExtHostMessageService(Qe,Dt),Oi=new U.ExtHostDialogs(Qe);return i.ExtHostApiCommands.register(St),function(ze,gi,qi){function lt(ge){return(_e,Be,dt)=>{const _t=ge(Lt=>{try{_e.call(Be,Lt)}catch(yi){g.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${yi.toString()}`,{cause:yi})),Ft.onExtensionError(ze.identifier,yi)}});return dt?.push(_t),_t}}const wt=function(){let ge=!ze.isUnderDevelopment;function _e(){ge||(Dt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Be(dt){if(Array.isArray(dt))dt.forEach(Be);else if(typeof dt=="string")_e();else{const _t=dt;typeof _t.scheme>"u"&&_e(),typeof _t.exclusive=="boolean"&&(0,Je.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return dt}}(),tn={getSession(ge,_e,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,Je.checkProposedApiEnabled)(ze,"authLearnMore"),Ut.getSession(ze,ge,_e,Be)},getSessions(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"authGetSessions"),Ut.getSessions(ze,ge,_e)},async hasSession(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"authSession"),!!await Ut.getSession(ze,ge,_e,{silent:!0})},get onDidChangeSessions(){return lt(Ut.onDidChangeSessions)},registerAuthenticationProvider(ge,_e,Be,dt){return Ut.registerAuthenticationProvider(ge,_e,Be,dt)}},Ei={registerCommand(ge,_e,Be){return St.registerCommand(!0,ge,_e,Be,void 0,ze)},registerTextEditorCommand(ge,_e,Be){return St.registerCommand(!0,ge,(...dt)=>{const _t=Ae.getActiveTextEditor();if(!_t){Dt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return _t.edit(Lt=>{_e.apply(Be,[_t,Lt,...dt])}).then(Lt=>{Lt||Dt.warn("Edits from command "+ge+" were not applied.")},Lt=>{Dt.warn("An error occurred while running command "+ge,Lt)})},void 0,void 0,ze)},registerDiffInformationCommand:(ge,_e,Be)=>((0,Je.checkProposedApiEnabled)(ze,"diffCommand"),St.registerCommand(!0,ge,async(...dt)=>{const _t=kt.activeEditor(!0);if(!_t){Dt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Lt=await Ae.getDiffInformation(_t.id);_e.apply(Be,[Lt,...dt])},void 0,void 0,ze)),executeCommand(ge,..._e){return St.executeCommand(ge,..._e)},getCommands(ge=!1){return St.getCommands(ge)}},Ai={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return en.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return lt(vt.onDidChangeShell)},get isTelemetryEnabled(){return Ft.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(Ft.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Je.checkProposedApiEnabled)(ze,"telemetry"),Ft.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Je.checkProposedApiEnabled)(ze,"telemetry"),lt(Ft.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,rt.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,_e){return rt.ExtHostTelemetryLogger.validateSender(ge),Ft.instantiateLogger(ze,ge,_e)},openExternal(ge,_e){return Mt.openUri(ge,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===pt.environment.appUriScheme)return Ci.createAppUri(ge);try{return await Mt.asExternalUri(ge,{allowTunneling:!!pt.remote.authority})}catch(_e){if((0,L.matchesScheme)(ge,L.Schemas.http)||(0,L.matchesScheme)(ge,L.Schemas.https))return ge;throw _e}},get remoteName(){return(0,u.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,Je.checkProposedApiEnabled)(ze,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return Dt.getLevel()},get onDidChangeLogLevel(){return lt(Dt.onDidChangeLogLevel)},get appQuality(){return(0,Je.checkProposedApiEnabled)(ze,"resolvers"),pt.quality},get appCommit(){return(0,Je.checkProposedApiEnabled)(ze,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Ai);const vn={createTestController(ge,_e,Be){return wi.createTestController(ze,ge,_e,Be)},createTestObserver(){return(0,Je.checkProposedApiEnabled)(ze,"testObserver"),wi.createTestObserver()},runTests(ge){return(0,Je.checkProposedApiEnabled)(ze,"testObserver"),wi.runTests(ge)},registerTestFollowupProvider(ge){return(0,Je.checkProposedApiEnabled)(ze,"testObserver"),wi.registerTestFollowupProvider(ge)},get onDidChangeTestResults(){return(0,Je.checkProposedApiEnabled)(ze,"testObserver"),lt(wi.onResultsChanged)},get testResults(){return(0,Je.checkProposedApiEnabled)(ze,"testObserver"),wi.results}},ri=pt.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,Ni={getExtension(ge,_e){(0,Je.isProposedApiEnabled)(ze,"extensionsAny")||(_e=!1);const Be=gi.mine.getExtensionDescription(ge);if(Be)return new q.Extension(Wt,ze.identifier,Be,ri,!1);if(_e){const dt=gi.all.getExtensionDescription(ge);if(dt)return new q.Extension(Wt,ze.identifier,dt,ri,!0)}},get all(){const ge=[];for(const _e of gi.mine.getAllExtensionDescriptions())ge.push(new q.Extension(Wt,ze.identifier,_e,ri,!1));return ge},get allAcrossExtensionHosts(){(0,Je.checkProposedApiEnabled)(ze,"extensionsAny");const ge=new T.ExtensionIdentifierSet(gi.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),_e=[];for(const Be of gi.all.getAllExtensionDescriptions()){const dt=!ge.has(Be.identifier);_e.push(new q.Extension(Wt,ze.identifier,Be,ri,dt))}return _e},get onDidChange(){return(0,Je.isProposedApiEnabled)(ze,"extensionsAny")?lt(k.Event.any(gi.mine.onDidChange,gi.all.onDidChange)):lt(gi.mine.onDidChange)}},nn={createDiagnosticCollection(ge){return te.createDiagnosticCollection(ze.identifier,ge)},get onDidChangeDiagnostics(){return lt(te.onDidChangeDiagnostics)},getDiagnostics:ge=>te.getDiagnostics(ge),getLanguages(){return Me.getLanguages()},setTextDocumentLanguage(ge,_e){return Me.changeLanguage(ge.uri,_e)},match(ge,_e){const Be=ce.LanguageSelector.from(ge);let dt;return(0,P.targetsNotebooks)(Be)&&(dt=Tt.notebookDocuments.find(_t=>_t.apiNotebook.getCells().find(Lt=>Lt.document===_e))?.apiNotebook),(0,P.score)(Be,_e.uri,_e.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(ge,_e,Be){return $e.registerCodeActionProvider(ze,wt(ge),_e,Be)},registerDocumentPasteEditProvider(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"documentPaste"),$e.registerDocumentPasteEditProvider(ze,wt(ge),_e,Be)},registerCodeLensProvider(ge,_e){return $e.registerCodeLensProvider(ze,wt(ge),_e)},registerDefinitionProvider(ge,_e){return $e.registerDefinitionProvider(ze,wt(ge),_e)},registerDeclarationProvider(ge,_e){return $e.registerDeclarationProvider(ze,wt(ge),_e)},registerImplementationProvider(ge,_e){return $e.registerImplementationProvider(ze,wt(ge),_e)},registerTypeDefinitionProvider(ge,_e){return $e.registerTypeDefinitionProvider(ze,wt(ge),_e)},registerHoverProvider(ge,_e){return $e.registerHoverProvider(ze,wt(ge),_e,ze.identifier)},registerEvaluatableExpressionProvider(ge,_e){return $e.registerEvaluatableExpressionProvider(ze,wt(ge),_e,ze.identifier)},registerInlineValuesProvider(ge,_e){return $e.registerInlineValuesProvider(ze,wt(ge),_e,ze.identifier)},registerDocumentHighlightProvider(ge,_e){return $e.registerDocumentHighlightProvider(ze,wt(ge),_e)},registerMultiDocumentHighlightProvider(ge,_e){return $e.registerMultiDocumentHighlightProvider(ze,wt(ge),_e)},registerLinkedEditingRangeProvider(ge,_e){return $e.registerLinkedEditingRangeProvider(ze,wt(ge),_e)},registerReferenceProvider(ge,_e){return $e.registerReferenceProvider(ze,wt(ge),_e)},registerRenameProvider(ge,_e){return $e.registerRenameProvider(ze,wt(ge),_e)},registerNewSymbolNamesProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"newSymbolNamesProvider"),$e.registerNewSymbolNamesProvider(ze,wt(ge),_e)},registerDocumentSymbolProvider(ge,_e,Be){return $e.registerDocumentSymbolProvider(ze,wt(ge),_e,Be)},registerWorkspaceSymbolProvider(ge){return $e.registerWorkspaceSymbolProvider(ze,ge)},registerDocumentFormattingEditProvider(ge,_e){return $e.registerDocumentFormattingEditProvider(ze,wt(ge),_e)},registerDocumentRangeFormattingEditProvider(ge,_e){return $e.registerDocumentRangeFormattingEditProvider(ze,wt(ge),_e)},registerOnTypeFormattingEditProvider(ge,_e,Be,...dt){return $e.registerOnTypeFormattingEditProvider(ze,wt(ge),_e,[Be].concat(dt))},registerDocumentSemanticTokensProvider(ge,_e,Be){return $e.registerDocumentSemanticTokensProvider(ze,wt(ge),_e,Be)},registerDocumentRangeSemanticTokensProvider(ge,_e,Be){return $e.registerDocumentRangeSemanticTokensProvider(ze,wt(ge),_e,Be)},registerSignatureHelpProvider(ge,_e,Be,...dt){return typeof Be=="object"?$e.registerSignatureHelpProvider(ze,wt(ge),_e,Be):$e.registerSignatureHelpProvider(ze,wt(ge),_e,typeof Be>"u"?[]:[Be,...dt])},registerCompletionItemProvider(ge,_e,...Be){return $e.registerCompletionItemProvider(ze,wt(ge),_e,Be)},registerInlineCompletionItemProvider(ge,_e,Be){return _e.handleDidShowCompletionItem&&(0,Je.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),_e.handleDidPartiallyAcceptCompletionItem&&(0,Je.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),Be&&(0,Je.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),$e.registerInlineCompletionsProvider(ze,wt(ge),_e,Be)},registerInlineEditProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"inlineEdit"),$e.registerInlineEditProvider(ze,wt(ge),_e)},registerDocumentLinkProvider(ge,_e){return $e.registerDocumentLinkProvider(ze,wt(ge),_e)},registerColorProvider(ge,_e){return $e.registerColorProvider(ze,wt(ge),_e)},registerFoldingRangeProvider(ge,_e){return $e.registerFoldingRangeProvider(ze,wt(ge),_e)},registerSelectionRangeProvider(ge,_e){return $e.registerSelectionRangeProvider(ze,ge,_e)},registerCallHierarchyProvider(ge,_e){return $e.registerCallHierarchyProvider(ze,ge,_e)},registerTypeHierarchyProvider(ge,_e){return $e.registerTypeHierarchyProvider(ze,ge,_e)},setLanguageConfiguration:(ge,_e)=>$e.setLanguageConfiguration(ze,ge,_e),getTokenInformationAtPosition(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"tokenInformation"),Me.tokenAtPosition(ge,_e)},registerInlayHintsProvider(ge,_e){return $e.registerInlayHintsProvider(ze,ge,_e)},createLanguageStatusItem(ge,_e){return Me.createLanguageStatusItem(ze,ge,_e)},registerDocumentDropEditProvider(ge,_e,Be){return $e.registerDocumentOnDropEditProvider(ze,ge,_e,(0,Je.isProposedApiEnabled)(ze,"documentPaste")?Be:void 0)}},rn={get activeTextEditor(){return Ae.getActiveTextEditor()},get visibleTextEditors(){return Ae.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(ge,_e,Be){v.URI.isUri(ge)&&ge.scheme===L.Schemas.vscodeRemote&&!ge.authority&&At.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await(v.URI.isUri(ge)?Promise.resolve(ji.openTextDocument(ge)):Promise.resolve(ge));return Ae.showTextDocument(dt,_e,Be)},createTextEditorDecorationType(ge){return Ae.createTextEditorDecorationType(ze,ge)},onDidChangeActiveTextEditor(ge,_e,Be){return lt(Ae.onDidChangeActiveTextEditor)(ge,_e,Be)},onDidChangeVisibleTextEditors(ge,_e,Be){return lt(Ae.onDidChangeVisibleTextEditors)(ge,_e,Be)},onDidChangeTextEditorSelection(ge,_e,Be){return lt(Ae.onDidChangeTextEditorSelection)(ge,_e,Be)},onDidChangeTextEditorOptions(ge,_e,Be){return lt(Ae.onDidChangeTextEditorOptions)(ge,_e,Be)},onDidChangeTextEditorVisibleRanges(ge,_e,Be){return lt(Ae.onDidChangeTextEditorVisibleRanges)(ge,_e,Be)},onDidChangeTextEditorViewColumn(ge,_e,Be){return lt(Ae.onDidChangeTextEditorViewColumn)(ge,_e,Be)},onDidCloseTerminal(ge,_e,Be){return lt(vt.onDidCloseTerminal)(ge,_e,Be)},onDidOpenTerminal(ge,_e,Be){return lt(vt.onDidOpenTerminal)(ge,_e,Be)},onDidChangeActiveTerminal(ge,_e,Be){return lt(vt.onDidChangeActiveTerminal)(ge,_e,Be)},onDidChangeTerminalDimensions(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"terminalDimensions"),lt(vt.onDidChangeTerminalDimensions)(ge,_e,Be)},onDidChangeTerminalState(ge,_e,Be){return lt(vt.onDidChangeTerminalState)(ge,_e,Be)},onDidWriteTerminalData(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),lt(vt.onDidWriteTerminalData)(ge,_e,Be)},onDidExecuteTerminalCommand(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"terminalExecuteCommandEvent"),lt(vt.onDidExecuteTerminalCommand)(ge,_e,Be)},onDidChangeTerminalShellIntegration(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"terminalShellIntegration"),lt(Vt.onDidChangeTerminalShellIntegration)(ge,_e,Be)},onDidStartTerminalShellExecution(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"terminalShellIntegration"),lt(Vt.onDidStartTerminalShellExecution)(ge,_e,Be)},onDidEndTerminalShellExecution(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"terminalShellIntegration"),lt(Vt.onDidEndTerminalShellExecution)(ge,_e,Be)},get state(){return Mt.getState()},onDidChangeWindowState(ge,_e,Be){return lt(Mt.onDidChangeWindowState)(ge,_e,Be)},showInformationMessage(ge,..._e){return Vi.showMessage(ze,R.default.Info,ge,_e[0],_e.slice(1))},showWarningMessage(ge,..._e){return Vi.showMessage(ze,R.default.Warning,ge,_e[0],_e.slice(1))},showErrorMessage(ge,..._e){return Vi.showMessage(ze,R.default.Error,ge,_e[0],_e.slice(1))},showQuickPick(ge,_e,Be){return ht.showQuickPick(ze,ge,_e,Be)},showWorkspaceFolderPick(ge){return ht.showWorkspaceFolderPick(ge)},showInputBox(ge,_e){return ht.showInput(ge,_e)},showOpenDialog(ge){return Oi.showOpenDialog(ze,ge)},showSaveDialog(ge){return Oi.showSaveDialog(ge)},createStatusBarItem(ge,_e,Be){let dt,_t,Lt;return typeof ge=="string"?(dt=ge,_t=_e,Lt=Be):(_t=ge,Lt=_e),Zi.createStatusBarEntry(ze,dt,_t,Lt)},setStatusBarMessage(ge,_e){return Zi.setStatusBarMessage(ge,_e)},withScmProgress(ge){return At.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Kt.withProgress(ze,{location:Q.ProgressLocation.SourceControl},(_e,Be)=>ge({report(dt){}}))},withProgress(ge,_e){return Kt.withProgress(ze,ge,_e)},createOutputChannel(ge,_e){return pi.createOutputChannel(ge,_e,ze)},createWebviewPanel(ge,_e,Be,dt){return Ri.createWebviewPanel(ze,ge,_e,Be,dt)},createWebviewTextEditorInset(ge,_e,Be,dt){return(0,Je.checkProposedApiEnabled)(ze,"editorInsets"),De.createWebviewEditorInset(ge,_e,Be,dt,ze)},createTerminal(ge,_e,Be){return typeof ge=="object"?"pty"in ge?vt.createExtensionTerminal(ge):vt.createTerminalFromOptions(ge):vt.createTerminal(ge,_e,Be)},registerTerminalLinkProvider(ge){return vt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,_e){return vt.registerProfileProvider(ze,ge,_e)},registerTerminalQuickFixProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(ge,ze.identifier.value,_e)},registerTreeDataProvider(ge,_e){return xe.registerTreeDataProvider(ge,_e,ze)},createTreeView(ge,_e){return xe.createTreeView(ge,_e,ze)},registerWebviewPanelSerializer:(ge,_e)=>Ri.registerWebviewPanelSerializer(ze,ge,_e),registerCustomEditorProvider:(ge,_e,Be={})=>Bi.registerCustomEditorProvider(ze,ge,_e,Be),registerFileDecorationProvider(ge){return oi.registerFileDecorationProvider(ge,ze)},registerUriHandler(ge){return Ci.registerUriHandler(ze,ge)},createQuickPick(){return ht.createQuickPick(ze)},createInputBox(){return ht.createInputBox(ze)},get activeColorTheme(){return xi.activeColorTheme},onDidChangeActiveColorTheme(ge,_e,Be){return lt(xi.onDidChangeActiveColorTheme)(ge,_e,Be)},registerWebviewViewProvider(ge,_e,Be){return Wi.registerWebviewViewProvider(ze,ge,_e,Be?.webviewOptions)},get activeNotebookEditor(){return Tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,_e,Be){return lt(Tt.onDidChangeActiveNotebookEditor)(ge,_e,Be)},get visibleNotebookEditors(){return Tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Tt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,_e,Be){return lt(Si.onDidChangeNotebookEditorSelection)(ge,_e,Be)},onDidChangeNotebookEditorVisibleRanges(ge,_e,Be){return lt(Si.onDidChangeNotebookEditorVisibleRanges)(ge,_e,Be)},showNotebookDocument(ge,_e){return Tt.showNotebookDocument(ge,_e)},registerExternalUriOpener(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"externalUriOpener"),Yi.registerExternalUriOpener(ze.identifier,ge,_e,Be)},registerProfileContentHandler(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"profileContentHandlers"),Ji.registerProfileContentHandler(ze,ge,_e)},registerQuickDiffProvider(ge,_e,Be,dt){return(0,Je.checkProposedApiEnabled)(ze,"quickDiffProvider"),Jt.registerQuickDiffProvider(wt(ge),_e,Be,dt)},get tabGroups(){return Ht.tabGroups},registerShareProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"shareProvider"),ni.registerShareProvider(wt(ge),_e)}},ji={get rootPath(){return At.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Et.getPath()},set rootPath(ge){throw new g.ReadonlyError("rootPath")},getWorkspaceFolder(ge){return Et.getWorkspaceFolder(ge)},get workspaceFolders(){return Et.getWorkspaceFolders()},get name(){return Et.name},set name(ge){throw new g.ReadonlyError("name")},get workspaceFile(){return Et.workspaceFile},set workspaceFile(ge){throw new g.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(ge,_e,...Be)=>Et.updateWorkspaceFolders(ze,ge,_e||0,...Be),onDidChangeWorkspaceFolders:function(ge,_e,Be){return lt(Et.onDidChangeWorkspace)(ge,_e,Be)},asRelativePath:(ge,_e)=>Et.getRelativePath(ge,_e),findFiles:(ge,_e,Be,dt)=>Et.findFiles(ge,_e,Be,ze.identifier,dt),findFiles2:(ge,_e,Be)=>((0,Je.checkProposedApiEnabled)(ze,"findFiles2"),Et.findFiles2(ge,_e,ze.identifier,Be)),findTextInFiles:(ge,_e,Be,dt)=>{(0,Je.checkProposedApiEnabled)(ze,"findTextInFiles");let _t,Lt;return typeof _e=="object"?(_t=_e,Lt=Be):(_t={},Lt=_e,dt=Be),Et.findTextInFiles(ge,_t||{},Lt,ze.identifier,dt)},save:ge=>Et.save(ge),saveAs:ge=>Et.saveAs(ge),saveAll:ge=>Et.saveAll(ge),applyEdit(ge,_e){return pn.applyWorkspaceEdit(ge,ze,_e)},createFileSystemWatcher:(ge,_e,Be,dt)=>{let _t;return typeof _e=="boolean"?_t={ignoreCreateEvents:!!_e,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!dt,correlate:!1}:_e&&((0,Je.checkProposedApiEnabled)(ze,"createFileSystemWatcher"),_t={..._e,correlate:!0}),je.createFileSystemWatcher(Et,ze,ge,_t)},get textDocuments(){return Rt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new g.ReadonlyError("textDocuments")},openTextDocument(ge){let _e;const Be=ge;if(typeof ge=="string")_e=Promise.resolve(v.URI.file(ge));else if(v.URI.isUri(ge))_e=Promise.resolve(ge);else if(!Be||typeof Be=="object")_e=Rt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(dt=>(dt.scheme===L.Schemas.vscodeRemote&&!dt.authority&&At.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),Rt.ensureDocumentData(dt).then(_t=>_t.document)))},onDidOpenTextDocument:(ge,_e,Be)=>lt(Rt.onDidAddDocument)(ge,_e,Be),onDidCloseTextDocument:(ge,_e,Be)=>lt(Rt.onDidRemoveDocument)(ge,_e,Be),onDidChangeTextDocument:(ge,_e,Be)=>lt(Rt.onDidChangeDocument)(ge,_e,Be),onDidSaveTextDocument:(ge,_e,Be)=>lt(Rt.onDidSaveDocument)(ge,_e,Be),onWillSaveTextDocument:(ge,_e,Be)=>lt(li.getOnWillSaveTextDocumentEvent(ze))(ge,_e,Be),get notebookDocuments(){return Tt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,_e){let Be;if(v.URI.isUri(ge))Be=ge,await Tt.openNotebookDocument(ge);else if(typeof ge=="string")Be=v.URI.revive(await Tt.createNotebookDocument({viewType:ge,content:_e}));else throw new Error("Invalid arguments");return Tt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(ge,_e,Be){return lt(Ii.onDidSaveNotebookDocument)(ge,_e,Be)},onDidChangeNotebookDocument(ge,_e,Be){return lt(Ii.onDidChangeNotebookDocument)(ge,_e,Be)},onWillSaveNotebookDocument(ge,_e,Be){return lt(fi.getOnWillSaveNotebookDocumentEvent(ze))(ge,_e,Be)},get onDidOpenNotebookDocument(){return lt(Tt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Tt.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,_e,Be,dt){return Tt.registerNotebookSerializer(ze,ge,_e,Be,(0,Je.isProposedApiEnabled)(ze,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(ge,_e,Be)=>lt(qi.onDidChangeConfiguration)(ge,_e,Be),getConfiguration(ge,_e){return _e=arguments.length===1?void 0:_e,qi.getConfiguration(ge,_e,ze)},registerTextDocumentContentProvider(ge,_e){return Pi.registerTextDocumentContentProvider(ge,_e)},registerTaskProvider:(ge,_e)=>(At.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),jt.registerTaskProvider(ze,ge,_e)),registerFileSystemProvider(ge,_e,Be){return(0,A.combinedDisposable)(et.registerFileSystemProvider(ze,ge,_e,Be),Qt.addFileSystemProvider(ge,_e,Be))},get fs(){return Qt.value},registerFileSearchProvider:(ge,_e)=>((0,Je.checkProposedApiEnabled)(ze,"fileSearchProvider"),ai.registerFileSearchProvider(ge,_e)),registerTextSearchProvider:(ge,_e)=>((0,Je.checkProposedApiEnabled)(ze,"textSearchProvider"),ai.registerTextSearchProvider(ge,_e)),registerAITextSearchProvider:(ge,_e)=>((0,Je.checkProposedApiEnabled)(ze,"aiTextSearchProvider"),(0,Je.checkProposedApiEnabled)(ze,"textSearchProvider"),ai.registerAITextSearchProvider(ge,_e)),registerRemoteAuthorityResolver:(ge,_e)=>((0,Je.checkProposedApiEnabled)(ze,"resolvers"),Wt.registerRemoteAuthorityResolver(ge,_e)),registerResourceLabelFormatter:ge=>((0,Je.checkProposedApiEnabled)(ze,"resolvers"),Mi.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,Je.checkProposedApiEnabled)(ze,"resolvers"),Wt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,_e,Be)=>lt(je.onDidCreateFile)(ge,_e,Be),onDidDeleteFiles:(ge,_e,Be)=>lt(je.onDidDeleteFile)(ge,_e,Be),onDidRenameFiles:(ge,_e,Be)=>lt(je.onDidRenameFile)(ge,_e,Be),onWillCreateFiles:(ge,_e,Be)=>lt(je.getOnWillCreateFileEvent(ze))(ge,_e,Be),onWillDeleteFiles:(ge,_e,Be)=>lt(je.getOnWillDeleteFileEvent(ze))(ge,_e,Be),onWillRenameFiles:(ge,_e,Be)=>lt(je.getOnWillRenameFileEvent(ze))(ge,_e,Be),openTunnel:ge=>((0,Je.checkProposedApiEnabled)(ze,"tunnels"),Nt.openTunnel(ze,ge).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,Je.checkProposedApiEnabled)(ze,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:(ge,_e,Be)=>((0,Je.checkProposedApiEnabled)(ze,"tunnels"),lt(Nt.onDidChangeTunnels)(ge,_e,Be)),registerPortAttributesProvider:(ge,_e)=>((0,Je.checkProposedApiEnabled)(ze,"portsAttributes"),Nt.registerPortsAttributesProvider(ge,_e)),registerTunnelProvider:(ge,_e)=>((0,Je.checkProposedApiEnabled)(ze,"tunnelFactory"),Nt.registerTunnelProvider(ge,_e)),registerTimelineProvider:(ge,_e)=>((0,Je.checkProposedApiEnabled)(ze,"timeline"),Qi.registerTimelineProvider(ge,_e,ze.identifier,St.converter)),get isTrusted(){return Et.trusted},requestWorkspaceTrust:ge=>((0,Je.checkProposedApiEnabled)(ze,"workspaceTrust"),Et.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,_e,Be)=>lt(Et.onDidGrantWorkspaceTrust)(ge,_e,Be),registerEditSessionIdentityProvider:(ge,_e)=>((0,Je.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),Et.registerEditSessionIdentityProvider(ge,_e)),onWillCreateEditSessionIdentity:(ge,_e,Be)=>((0,Je.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),lt(Et.getOnWillCreateEditSessionIdentityEvent(ze))(ge,_e,Be)),registerCanonicalUriProvider:(ge,_e)=>((0,Je.checkProposedApiEnabled)(ze,"canonicalUriProvider"),Et.registerCanonicalUriProvider(ge,_e)),getCanonicalUri:(ge,_e,Be)=>((0,Je.checkProposedApiEnabled)(ze,"canonicalUriProvider"),Et.provideCanonicalUri(ge,_e,Be))},sn={get inputBox(){return At.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),It.getLastInputBox(ze)},createSourceControl(ge,_e,Be){return It.createSourceControl(ze,ge,_e,Be)}},En={createCommentController(ge,_e){return xt.createCommentController(ze,ge,_e)}},on={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get activeStackItem(){return yt.activeStackItem},registerDebugVisualizationProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"debugVisualization"),yt.registerDebugVisualizationProvider(ze,ge,_e)},registerDebugVisualizationTreeProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"debugVisualization"),yt.registerDebugVisualizationTree(ze,ge,_e)},onDidStartDebugSession(ge,_e,Be){return lt(yt.onDidStartDebugSession)(ge,_e,Be)},onDidTerminateDebugSession(ge,_e,Be){return lt(yt.onDidTerminateDebugSession)(ge,_e,Be)},onDidChangeActiveDebugSession(ge,_e,Be){return lt(yt.onDidChangeActiveDebugSession)(ge,_e,Be)},onDidReceiveDebugSessionCustomEvent(ge,_e,Be){return lt(yt.onDidReceiveDebugSessionCustomEvent)(ge,_e,Be)},onDidChangeBreakpoints(ge,_e,Be){return lt(yt.onDidChangeBreakpoints)(ge,_e,Be)},onDidChangeActiveStackItem(ge,_e,Be){return lt(yt.onDidChangeActiveStackItem)(ge,_e,Be)},registerDebugConfigurationProvider(ge,_e,Be){return yt.registerDebugConfigurationProvider(ge,_e,Be||Xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,_e){return yt.registerDebugAdapterDescriptorFactory(ze,ge,_e)},registerDebugAdapterTrackerFactory(ge,_e){return yt.registerDebugAdapterTrackerFactory(ge,_e)},startDebugging(ge,_e,Be){return!Be||typeof Be=="object"&&"configuration"in Be?yt.startDebugging(ge,_e,{parentSession:Be}):yt.startDebugging(ge,_e,Be||{})},stopDebugging(ge){return yt.stopDebugging(ge)},addBreakpoints(ge){return yt.addBreakpoints(ge)},removeBreakpoints(ge){return yt.removeBreakpoints(ge)},asDebugSourceUri(ge,_e){return yt.asDebugSourceUri(ge,_e)}},an={registerTaskProvider:(ge,_e)=>jt.registerTaskProvider(ze,ge,_e),fetchTasks:ge=>jt.fetchTasks(ge),executeTask:ge=>jt.executeTask(ze,ge),get taskExecutions(){return jt.taskExecutions},onDidStartTask:(ge,_e,Be)=>lt(jt.onDidStartTask)(ge,_e,Be),onDidEndTask:(ge,_e,Be)=>lt(jt.onDidEndTask)(ge,_e,Be),onDidStartTaskProcess:(ge,_e,Be)=>lt(jt.onDidStartTaskProcess)(ge,_e,Be),onDidEndTaskProcess:(ge,_e,Be)=>lt(jt.onDidEndTaskProcess)(ge,_e,Be)},bn={createNotebookController(ge,_e,Be,dt,_t){return vi.createNotebookController(ze,ge,_e,Be,dt,(0,Je.isProposedApiEnabled)(ze,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(ge,_e)=>Tt.registerNotebookCellStatusBarItemProvider(ze,ge,_e),createRendererMessaging(ge){return ki.createRendererMessaging(ze,ge)},createNotebookControllerDetectionTask(ge){return(0,Je.checkProposedApiEnabled)(ze,"notebookKernelSource"),vi.createNotebookControllerDetectionTask(ze,ge)},registerKernelSourceActionProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"notebookKernelSource"),vi.registerKernelSourceActionProvider(ze,ge,_e)},onDidChangeNotebookCellExecutionState(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),lt(vi.onDidChangeNotebookCellExecutionState)(ge,_e,Be)}},Sn={t(...ge){if(typeof ge[0]=="string"){const _e=ge.shift(),Be=!ge||typeof ge[0]!="object"?ge:ge[0];return hi.getMessage(ze.identifier.value,{message:_e,args:Be})}return hi.getMessage(ze.identifier.value,ge[0])},get bundle(){return hi.getBundle(ze.identifier.value)},get uri(){return hi.getBundleUri(ze.identifier.value)}},ln={_version:1,transferActiveChat(ge){return(0,Je.checkProposedApiEnabled)(ze,"interactive"),Li.transferActiveChat(ge)}},Ki={getRelatedInformation(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"aiRelatedInformation"),$i.getRelatedInformation(ze,ge,_e)},registerRelatedInformationProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"aiRelatedInformation"),$i.registerRelatedInformationProvider(ze,ge,_e)},registerEmbeddingVectorProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"aiRelatedInformation"),gn.registerEmbeddingVectorProvider(ze,ge,_e)}},cn={_version:1,registerChatResponseProvider(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"chatProvider"),Yt.registerLanguageModel(ze,ge,_e,Be)},registerChatVariableResolver(ge,_e,Be,dt,_t,Lt,yi,Fi){return(0,Je.checkProposedApiEnabled)(ze,"chatVariableResolver"),zi.registerVariableResolver(ze,ge,_e,Be,dt,_t,Lt,yi,Fi?.id)},registerMappedEditsProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"mappedEditsProvider"),$e.registerMappedEditsProvider(ze,ge,_e)},createChatParticipant(ge,_e){return Li.createChatAgent(ze,ge,_e)},createDynamicChatParticipant(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"chatParticipantPrivate"),Li.createDynamicChatAgent(ze,ge,_e,Be)},attachContext(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"chatVariableResolver"),zi.attachContext(ge,_e,Be)}},un={selectChatModels:ge=>pt.quality==="stable"?(console.warn(`[${T.ExtensionIdentifier.toKey(ze.identifier)}] This API is disabled in '${pt.environment.appName}'-stable.`),Promise.resolve([])):Yt.selectLanguageModels(ze,ge??{}),onDidChangeChatModels:(ge,_e,Be)=>pt.quality==="stable"?(console.warn(`[${T.ExtensionIdentifier.toKey(ze.identifier)}] This API is disabled in '${pt.environment.appName}'-stable.`),k.Event.None(ge,_e,Be)):Yt.onDidChangeProviders(ge,_e,Be),get embeddingModels(){return(0,Je.checkProposedApiEnabled)(ze,"embeddings"),_i.embeddingsModels},onDidChangeEmbeddingModels:(ge,_e,Be)=>((0,Je.checkProposedApiEnabled)(ze,"embeddings"),_i.onDidChange(ge,_e,Be)),registerEmbeddingsProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"embeddings"),_i.registerEmbeddingsProvider(ze,ge,_e)},async computeEmbeddings(ge,_e,Be){return(0,Je.checkProposedApiEnabled)(ze,"embeddings"),_i.computeEmbeddings(ge,_e,Be)}},dn={registerSpeechProvider(ge,_e){return(0,Je.checkProposedApiEnabled)(ze,"speech"),Hi.registerProvider(ze.identifier,ge,_e)}};return{version:pt.version,ai:Ki,authentication:tn,commands:Ei,comments:En,chat:cn,debug:on,env:Ai,extensions:Ni,interactive:ln,l10n:Sn,languages:nn,lm:un,notebooks:bn,scm:sn,speech:dn,tasks:an,tests:vn,window:rn,workspace:ji,Breakpoint:Q.Breakpoint,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatResultFeedbackKind:Q.ChatResultFeedbackKind,ChatVariableLevel:Q.ChatVariableLevel,ChatCompletionItem:Q.ChatCompletionItem,CallHierarchyIncomingCall:Q.CallHierarchyIncomingCall,CallHierarchyItem:Q.CallHierarchyItem,CallHierarchyOutgoingCall:Q.CallHierarchyOutgoingCall,CancellationError:g.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:Q.CodeAction,CodeActionKind:Q.CodeActionKind,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.CodeLens,Color:Q.Color,ColorInformation:Q.ColorInformation,ColorPresentation:Q.ColorPresentation,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CommentThreadApplicability:Q.CommentThreadApplicability,CompletionItem:Q.CompletionItem,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.CompletionList,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.CustomExecution,DebugAdapterExecutable:Q.DebugAdapterExecutable,DebugAdapterInlineImplementation:Q.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Q.DebugAdapterNamedPipeServer,DebugAdapterServer:Q.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DebugVisualization:Q.DebugVisualization,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.Diagnostic,DiagnosticRelatedInformation:Q.DiagnosticRelatedInformation,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.Disposable,DocumentHighlight:Q.DocumentHighlight,DocumentHighlightKind:Q.DocumentHighlightKind,MultiDocumentHighlight:Q.MultiDocumentHighlight,DocumentLink:Q.DocumentLink,DocumentSymbol:Q.DocumentSymbol,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.EvaluatableExpression,InlineValueText:Q.InlineValueText,InlineValueVariableLookup:Q.InlineValueVariableLookup,InlineValueEvaluatableExpression:Q.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.FileDecoration,FileDecoration2:Q.FileDecoration,FileSystemError:Q.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:Q.FoldingRange,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.FunctionBreakpoint,InlineCompletionItem:Q.InlineSuggestion,InlineCompletionList:Q.InlineSuggestionList,Hover:Q.Hover,VerboseHover:Q.VerboseHover,HoverVerbosityAction:Q.HoverVerbosityAction,IndentAction:y.IndentAction,Location:Q.Location,MarkdownString:Q.MarkdownString,OverviewRulerLane:d.OverviewRulerLane,ParameterInformation:Q.ParameterInformation,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.Position,ProcessExecution:Q.ProcessExecution,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.QuickInputButtons,Range:Q.Range,RelativePattern:Q.RelativePattern,Selection:Q.Selection,SelectionRange:Q.SelectionRange,SemanticTokens:Q.SemanticTokens,SemanticTokensBuilder:Q.SemanticTokensBuilder,SemanticTokensEdit:Q.SemanticTokensEdit,SemanticTokensEdits:Q.SemanticTokensEdits,SemanticTokensLegend:Q.SemanticTokensLegend,ShellExecution:Q.ShellExecution,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.SignatureHelp,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.SignatureInformation,SnippetString:Q.SnippetString,SourceBreakpoint:Q.SourceBreakpoint,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.SymbolInformation,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.Task,TaskGroup:Q.TaskGroup,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.TerminalLink,TerminalQuickFixTerminalCommand:Q.TerminalQuickFixCommand,TerminalQuickFixOpener:Q.TerminalQuickFixOpener,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.TerminalProfile,TerminalExitReason:Q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.TextEdit,SnippetTextEdit:Q.SnippetTextEdit,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.ThemeColor,ThemeIcon:Q.ThemeIcon,TreeItem:Q.TreeItem,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.TypeHierarchyItem,UIKind:Zt.UIKind,Uri:v.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.WorkspaceEdit,DocumentPasteTriggerKind:Q.DocumentPasteTriggerKind,DocumentDropEdit:Q.DocumentDropEdit,DocumentDropOrPasteEditKind:Q.DocumentDropOrPasteEditKind,DocumentPasteEdit:Q.DocumentPasteEdit,InlayHint:Q.InlayHint,InlayHintLabelPart:Q.InlayHintLabelPart,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.RemoteAuthorityResolverError,ResolvedAuthority:Q.ResolvedAuthority,ManagedResolvedAuthority:Q.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.TimelineItem,NotebookRange:Q.NotebookRange,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.NotebookCellData,NotebookData:Q.NotebookData,NotebookRendererScript:Q.NotebookRendererScript,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.NotebookCellOutput,NotebookCellOutputItem:Q.NotebookCellOutputItem,NotebookCellStatusBarItem:Q.NotebookCellStatusBarItem,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.NotebookEdit,NotebookKernelSourceAction:Q.NotebookKernelSourceAction,NotebookVariablesRequestKind:Q.NotebookVariablesRequestKind,PortAttributes:Q.PortAttributes,LinkedEditingRanges:Q.LinkedEditingRanges,TestResultState:Q.TestResultState,TestRunRequest:Q.TestRunRequest,TestMessage:Q.TestMessage,TestTag:Q.TestTag,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:$t.TextSearchCompleteMessageType,DataTransfer:Q.DataTransfer,DataTransferItem:Q.DataTransferItem,TestCoverageCount:Q.TestCoverageCount,FileCoverage:Q.FileCoverage,FileCoverage2:Q.FileCoverage,StatementCoverage:Q.StatementCoverage,BranchCoverage:Q.BranchCoverage,DeclarationCoverage:Q.DeclarationCoverage,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.TextTabInput,TabInputTextDiff:Q.TextDiffTabInput,TabInputTextMerge:Q.TextMergeTabInput,TabInputCustom:Q.CustomEditorTabInput,TabInputNotebook:Q.NotebookEditorTabInput,TabInputNotebookDiff:Q.NotebookDiffEditorTabInput,TabInputWebview:Q.WebviewEditorTabInput,TabInputTerminal:Q.TerminalEditorTabInput,TabInputInteractiveWindow:Q.InteractiveWindowInput,TabInputChat:Q.ChatEditorTabInput,TabInputTextMultiDiff:Q.TextMultiDiffTabInput,TelemetryTrustedValue:f.TelemetryTrustedValue,LogLevel:a.LogLevel,EditSessionIdentityMatch:m.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,ChatCopyKind:Q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Q.DebugStackFrame,DebugThread:Q.DebugThread,RelatedInformationType:Q.RelatedInformationType,SpeechToTextStatus:Q.SpeechToTextStatus,TextToSpeechStatus:Q.TextToSpeechStatus,PartialAcceptTriggerKind:Q.PartialAcceptTriggerKind,KeywordRecognitionStatus:Q.KeywordRecognitionStatus,ChatResponseMarkdownPart:Q.ChatResponseMarkdownPart,ChatResponseFileTreePart:Q.ChatResponseFileTreePart,ChatResponseAnchorPart:Q.ChatResponseAnchorPart,ChatResponseProgressPart:Q.ChatResponseProgressPart,ChatResponseProgressPart2:Q.ChatResponseProgressPart2,ChatResponseReferencePart:Q.ChatResponseReferencePart,ChatResponseWarningPart:Q.ChatResponseWarningPart,ChatResponseTextEditPart:Q.ChatResponseTextEditPart,ChatResponseMarkdownWithVulnerabilitiesPart:Q.ChatResponseMarkdownWithVulnerabilitiesPart,ChatResponseCommandButtonPart:Q.ChatResponseCommandButtonPart,ChatResponseDetectedParticipantPart:Q.ChatResponseDetectedParticipantPart,ChatResponseConfirmationPart:Q.ChatResponseConfirmationPart,ChatRequestTurn:Q.ChatRequestTurn,ChatResponseTurn:Q.ChatResponseTurn,ChatLocation:Q.ChatLocation,LanguageModelChatMessageRole:Q.LanguageModelChatMessageRole,LanguageModelChatMessage:Q.LanguageModelChatMessage,LanguageModelChatMessage2:Q.LanguageModelChatMessage,LanguageModelChatSystemMessage:Q.LanguageModelChatSystemMessage,LanguageModelChatUserMessage:Q.LanguageModelChatUserMessage,LanguageModelChatAssistantMessage:Q.LanguageModelChatAssistantMessage,LanguageModelError:Q.LanguageModelError,NewSymbolName:Q.NewSymbolName,NewSymbolNameTag:Q.NewSymbolNameTag,NewSymbolNameTriggerKind:Q.NewSymbolNameTriggerKind,InlineEdit:Q.InlineEdit,InlineEditTriggerKind:Q.InlineEditTriggerKind}}}}),define(we[395],ye([1,0,89,167,47,161,48,37,78,46,100,101,102,125,76,96,160,75,63,124,95,77,159,12,64,122,123,127,128,165]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i,t,c,h,o,p,_,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,r.InstantiationType.Delayed),(0,r.registerSingleton)(c.ILoggerService,t.ExtHostLoggerService,r.InstantiationType.Delayed),(0,r.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,r.InstantiationType.Delayed),(0,r.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,r.InstantiationType.Eager),(0,r.registerSingleton)(_.IExtHostAuthentication,_.ExtHostAuthentication,r.InstantiationType.Eager),(0,r.registerSingleton)(D.IExtHostLanguageModels,D.ExtHostLanguageModels,r.InstantiationType.Eager),(0,r.registerSingleton)(L.IExtHostConfiguration,L.ExtHostConfiguration,r.InstantiationType.Eager),(0,r.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,r.InstantiationType.Eager),(0,r.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService,r.InstantiationType.Eager),(0,r.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,r.InstantiationType.Eager),(0,r.registerSingleton)(v.IExtHostDocumentsAndEditors,v.ExtHostDocumentsAndEditors,r.InstantiationType.Eager),(0,r.registerSingleton)(p.IExtHostManagedSockets,p.ExtHostManagedSockets,r.InstantiationType.Eager),(0,r.registerSingleton)(m.IExtHostFileSystemInfo,m.ExtHostFileSystemInfo,r.InstantiationType.Eager),(0,r.registerSingleton)(g.IExtHostOutputService,g.ExtHostOutputService,r.InstantiationType.Delayed),(0,r.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch,r.InstantiationType.Eager),(0,r.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,r.InstantiationType.Eager),(0,r.registerSingleton)(P.IExtHostTask,P.WorkerExtHostTask,r.InstantiationType.Eager),(0,r.registerSingleton)(l.IExtHostTerminalService,l.WorkerExtHostTerminalService,r.InstantiationType.Eager),(0,r.registerSingleton)(C.IExtHostTerminalShellIntegration,C.ExtHostTerminalShellIntegration,r.InstantiationType.Eager),(0,r.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,r.InstantiationType.Eager),(0,r.registerSingleton)(u.IExtHostWindow,u.ExtHostWindow,r.InstantiationType.Eager),(0,r.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace,r.InstantiationType.Eager),(0,r.registerSingleton)(n.IExtHostSecretState,n.ExtHostSecretState,r.InstantiationType.Eager),(0,r.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry,r.InstantiationType.Eager),(0,r.registerSingleton)(i.IExtHostEditorTabs,i.ExtHostEditorTabs,r.InstantiationType.Eager),(0,r.registerSingleton)(h.IExtHostVariableResolverProvider,h.ExtHostVariableResolverProviderService,r.InstantiationType.Eager)}),define(we[129],ye([1,0,19,12,38,99]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=void 0,e.anchorGlob=L,e.createTextSearchResult=R;function L(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}function R(y,d,T,E){const a=(0,r.mapArrayOrNot)(T,v),u=new k.TextSearchMatch(d,a,E),f=u.preview.matches;return{ranges:(0,r.mapArrayOrNot)(a,l),uri:y,preview:{text:u.preview.text,matches:(0,r.mapArrayOrNot)(f,l)}}}function v(y){return new k.SearchRange(y.start.line,y.start.character,y.end.line,y.end.character)}function l(y){return new A.Range(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let P=class{constructor(d,T){this.prefix=d,this.logService=T}appendLine(d){this.logService.debug(`${this.prefix}#search`,d)}};e.OutputChannel=P,e.OutputChannel=P=Ke([Ve(1,g.ILogService)],P)}),define(we[396],ye([1,0,59,16,82,33,11,13,129,397]),function(he,e,r,g,k,A,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnRipgrepCmd=y,e.getAbsoluteGlob=u,e.fixDriveC=m;const P=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(n,s,i,t){const c=d(n,s,i,t),h=s.folder.fsPath;return{cmd:r.spawn(P,c.args,{cwd:h}),rgDiskPath:P,siblingClauses:c.siblingClauses,rgArgs:c,cwd:h}}function d(n,s,i,t){const c=["--files","--hidden","--case-sensitive","--no-require-git"];E([s],i,!1).forEach(o=>{const p=(0,v.anchorGlob)(o);if(c.push("-g",p),L.isMacintosh){const _=(0,k.normalizeNFD)(p);_!==p&&c.push("-g",_)}});const h=T([s],t,void 0,!1);return h.globArgs.forEach(o=>{const p=`!${(0,v.anchorGlob)(o)}`;if(c.push("-g",p),L.isMacintosh){const _=(0,k.normalizeNFD)(p);_!==p&&c.push("-g",_)}}),s.disregardIgnoreFiles!==!1?c.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&c.push("--no-ignore-parent"),s.ignoreSymlinks||c.push("--follow"),n.exists&&c.push("--quiet"),c.push("--no-config"),s.disregardGlobalIgnoreFiles&&c.push("--no-ignore-global"),{args:c,siblingClauses:h.siblingClauses}}function T(n,s,i,t=!0){const c=[];let h={};return n.forEach(o=>{const p=Object.assign({},o.excludePattern||{},s||{}),_=a(p,t?o.folder.fsPath:void 0,i);c.push(..._.globArgs),_.siblingClauses&&(h=Object.assign(h,_.siblingClauses))}),{globArgs:c,siblingClauses:h}}function E(n,s,i=!0){const t=[];return n.forEach(c=>{const h=Object.assign({},s||{},c.includePattern||{}),o=a(h,i?c.folder.fsPath:void 0);t.push(...o.globArgs)}),t}function a(n,s,i){const t=[],c={};return Object.keys(n).forEach(h=>{if(i&&i.has(h)||!h)return;const o=n[h];h=f(s?u(s,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof o=="boolean"&&o?(h.startsWith("\\\\")&&(h+="**"),t.push(m(h))):o&&o.when&&(c[h]=o)}),{globArgs:t,siblingClauses:c}}function u(n,s){return g.isAbsolute(s)?s:g.join(n,s)}function f(n){return n=R.rtrim(n,"\\"),R.rtrim(n,"/")}function m(n){return A.getRoot(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(we[398],ye([1,0,59,58,16,399,19,51,39,82,33,11,42,13,18,34,38,396,140]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const n=new Set;process.on("exit",()=>{n.forEach(h=>h())});class s{constructor(o){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=o,this.filePattern=o.filePattern||"",this.includePattern=o.includePattern&&v.parse(o.includePattern),this.maxResults=o.maxResults||null,this.exists=!!o.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=o.shouldGlobMatchFilePattern?null:(0,m.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=o.excludePattern&&v.parse(o.excludePattern),this.folderExcludePatterns=new Map,o.folderQueries.forEach(p=>{const _=Object.assign({},p.excludePattern||{},this.config.excludePattern||{}),D=p.folder.fsPath;o.folderQueries.map(C=>C.folder.fsPath).filter(C=>C!==D).forEach(C=>{(0,P.isEqualOrParent)(C,D)&&(_[k.relative(D,C)]=!0)}),this.folderExcludePatterns.set(D,new t(_,D))})}cancel(){this.isCanceled=!0,n.forEach(o=>o())}walk(o,p,_,D,C){if(this.fileWalkSW=d.StopWatch.create(!1),this.isCanceled)return C(null,this.isLimitHit);p.forEach(S=>{const I=k.basename(S.fsPath);this.globalExcludePattern&&this.globalExcludePattern(S.fsPath,I)||this.matchFile(_,{relativePath:S.fsPath,searchPath:void 0})}),this.cmdSW=d.StopWatch.create(!1),this.parallel(o,(S,I)=>{this.call(this.cmdTraversal,this,S,_,D,b=>{if(b){const w=(0,R.toErrorMessage)(b);console.error(w),this.errors.push(w),I(b,void 0)}else I(null,void 0)})},(S,I)=>{this.fileWalkSW.stop();const b=S?L.coalesce(S)[0]:null;C(b,this.isLimitHit)})}parallel(o,p,_){const D=new Array(o.length),C=new Array(o.length);let S=!1,I=0;if(o.length===0)return _(null,[]);o.forEach((b,w)=>{p(b,(N,O)=>{if(N?(S=!0,D[w]=null,C[w]=N):(D[w]=O,C[w]=null),++I===o.length)return _(S?C:null,D)})})}call(o,p,..._){try{o.apply(p,_)}catch(D){_[_.length-1](D)}}cmdTraversal(o,p,_,D){const C=o.folder.fsPath,S=y.isMacintosh,I=()=>U&&U.kill();n.add(I);let b=M=>{n.delete(I),b=()=>{},D(M)},w="";const N=this.initDirectoryTree(),O=(0,f.spawnRipgrepCmd)(this.config,o,this.config.includePattern,this.folderExcludePatterns.get(o.folder.fsPath).expression),U=O.cmd,x=!Object.keys(O.siblingClauses).length,B=O.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let F=`${O.rgDiskPath} ${B}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),_({message:F}),this.cmdResultCount=0,this.collectStdout(U,"utf8",_,(M,K,ee)=>{if(M){b(M);return}if(this.isLimitHit){b();return}const q=(w+(S?l.normalizeNFC(K||""):K)).split(`
`);if(ee){const Z=q.length;q[Z-1]=q[Z-1].trim(),q[Z-1]||q.pop()}else w=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){b(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,x){for(const Z of q)if(this.matchFile(p,{base:C,relativePath:Z,searchPath:this.getSearchPath(o,Z)}),this.isLimitHit){I();break}(ee||this.isLimitHit)&&b();return}this.addDirectoryEntries(o,N,C,q,p),ee&&(this.matchDirectoryTree(N,C,p),b())})}spawnFindCmd(o){const p=this.folderExcludePatterns.get(o.folder.fsPath),_=p.getBasenameTerms(),D=p.getPathTerms(),C=["-L","."];if(_.length||D.length){C.push("-not","(","(");for(const S of _)C.push("-name",S),C.push("-o");for(const S of D)C.push("-path",S),C.push("-o");C.pop(),C.push(")","-prune",")")}return C.push("-type","f"),r.spawn("find",C,{cwd:o.folder.fsPath})}readStdout(o,p,_){let D="";this.collectStdout(o,p,()=>{},(C,S,I)=>{if(C){_(C);return}D+=S,I&&_(null,D)})}collectStdout(o,p,_,D){let C=(b,w,N)=>{(b||N)&&(C=()=>{},this.cmdSW?.stop()),D(b,w,N)},S=!1;o.stdout?(this.forwardData(o.stdout,p,C),o.stdout.once("data",()=>S=!0)):_({message:"stdout is null"});let I;o.stderr?I=this.collectData(o.stderr):_({message:"stderr is null"}),o.on("error",b=>{C(b)}),o.on("close",b=>{let w;!S&&(w=this.decodeData(I,p))&&c(w)?C(new Error(`command failed with error code ${b}: ${this.decodeData(I,p)}`)):(this.exists&&b===0&&(this.isLimitHit=!0),C(null,"",!0))})}forwardData(o,p,_){const D=new A.StringDecoder(p);return o.on("data",C=>{_(null,D.write(C))}),D}collectData(o){const p=[];return o.on("data",_=>{p.push(_)}),p}decodeData(o,p){const _=new A.StringDecoder(p);return o.map(D=>_.write(D)).join("")}initDirectoryTree(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}addDirectoryEntries(o,{pathToEntries:p},_,D,C){D.indexOf(this.filePattern)!==-1&&this.matchFile(C,{base:_,relativePath:this.filePattern,searchPath:this.getSearchPath(o,this.filePattern)});const S=I=>{const b=k.basename(I),w=k.dirname(I);let N=p[w];N||(N=p[w]=[],S(w)),N.push({base:_,relativePath:I,basename:b,searchPath:this.getSearchPath(o,I)})};D.forEach(S)}matchDirectoryTree({rootEntries:o,pathToEntries:p},_,D){const C=this,S=this.folderExcludePatterns.get(_),I=this.filePattern;function b(w){C.directoriesWalked++;const N=(0,u.hasSiblingFn)(()=>w.map(O=>O.basename));for(let O=0,U=w.length;O<U;O++){const x=w[O],{relativePath:B,basename:F}=x;if(S.test(B,F,I!==F?N:void 0))continue;const M=p[B];if(M)b(M);else{if(C.filesWalked++,B===I)continue;C.matchFile(D,x)}if(C.isLimitHit)break}}b(o)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(o,p,_,D,C){const S=o.folder,I=(0,u.hasSiblingFn)(()=>_);this.parallel(_,(b,w)=>{if(this.isCanceled||this.isLimitHit)return w(null);const N=p?[p,b].join(k.sep):b;if(this.folderExcludePatterns.get(o.folder.fsPath).test(N,b,this.config.filePattern!==b?I:void 0))return w(null);const O=[S.fsPath,N].join(k.sep);g.lstat(O,(U,x)=>{if(U||this.isCanceled||this.isLimitHit)return w(null);this.statLinkIfNeeded(O,x,(B,F)=>B||this.isCanceled||this.isLimitHit?w(null):F.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(O,x,(M,K)=>M||this.isCanceled||this.isLimitHit||(K=K||"",this.walkedPaths[K])?w(null):(this.walkedPaths[K]=!0,a.Promises.readdir(O).then(ee=>{if(this.isCanceled||this.isLimitHit)return w(null);this.doWalk(o,N,ee,D,$=>w($||null))},ee=>{w(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&E.isNumber(F.size)&&F.size>this.maxFilesize||this.matchFile(D,{base:S.fsPath,relativePath:N,searchPath:this.getSearchPath(o,N)}),w(null,void 0)))})},b=>{const w=b&&L.coalesce(b);return C(w&&w.length>0?w[0]:void 0)})}matchFile(o,p){this.isFileMatch(p)&&(!this.includePattern||this.includePattern(p.relativePath,k.basename(p.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||o(p))}isFileMatch(o){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,u.isFilePatternMatch)(o,this.normalizedFilePatternLowercase);if(this.filePattern)return(0,u.isFilePatternMatch)(o,this.filePattern,!1)}return!0}statLinkIfNeeded(o,p,_){return p.isSymbolicLink()?g.stat(o,_):_(null,p)}realPathIfNeeded(o,p,_){return p.isSymbolicLink()?g.realpath(o,(D,C)=>D?_(D):_(null,C)):_(null,o)}getSearchPath(o,p){return o.folderName?k.join(o.folderName,p):p}}e.FileWalker=s;class i{constructor(o){this.folderQueries=o.folderQueries,this.extraFiles=o.extraFileResources||[],this.walker=new s(o)}search(o,p,_){this.walker.walk(this.folderQueries,this.extraFiles,o,p,(D,C)=>{_(D,{limitHit:C,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=i;class t{constructor(o,p){this.expression=o,this.root=p,this.init(o)}init(o){let p,_;Object.keys(o).filter(D=>o[D]).forEach(D=>{k.isAbsolute(D)?(p=p||v.getEmptyExpression(),p[D]=o[D]):(_=_||v.getEmptyExpression(),_[D]=o[D])}),this.absoluteParsedExpr=p&&v.parse(p,{trimForExclusions:!0}),this.relativeParsedExpr=_&&v.parse(_,{trimForExclusions:!0})}test(o,p,_){return this.relativeParsedExpr&&this.relativeParsedExpr(o,p,_)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,o),p,_)}getBasenameTerms(){const o=[];return this.absoluteParsedExpr&&o.push(...v.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&o.push(...v.getBasenameTerms(this.relativeParsedExpr)),o}getPathTerms(){const o=[];return this.absoluteParsedExpr&&o.push(...v.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&o.push(...v.getPathTerms(this.relativeParsedExpr)),o}}function c(h){const o=h.trim().split(`
`),p=o[0].trim();if(p.startsWith("Error parsing regex"))return p;if(p.startsWith("regex parse error"))return T.uppercaseFirstLetter(o[o.length-1].trim());if(p.startsWith("error parsing glob")||p.startsWith("unsupported encoding"))return p.charAt(0).toUpperCase()+p.substr(1);if(p==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(p.startsWith("Literal "))return p}}),define(we[400],ye([1,0,103,22,206,21]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.isUTFEncoding=L,e.toDecodeStream=E,e.toEncodeReadable=a,e.encodingExists=u,e.toNodeEncoding=f,e.detectEncodingByBOMFromBuffer=m,e.toCanonicalName=h,e.detectEncodingFromBuffer=o,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function L(p){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(_=>_===p)}e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,v=512,l=512*8,P=512*128;var y;(function(p){p[p.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(y||(e.DecodeStreamErrorKind=y={}));class d extends Error{constructor(_,D){super(_),this.decodeStreamErrorKind=D}}e.DecodeStreamError=d;class T{static async create(_){let D;if(_!==e.UTF8)D=(await(0,k.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(f(_));else{const C=new TextDecoder;D={write(S){return C.decode(S,{stream:!0})},end(){return C.decode()}}}return new T(D)}constructor(_){this.iconvLiteDecoder=_}write(_){return this.iconvLiteDecoder.write(_)}end(){return this.iconvLiteDecoder.end()}}function E(p,_){const D=_.minBytesRequiredForDetection??_.guessEncoding?l:v;return new Promise((C,S)=>{const I=(0,r.newWriteableStream)(x=>x.join("")),b=[];let w=0,N;const O=new A.CancellationTokenSource,U=async()=>{try{const x=await o({buffer:g.VSBuffer.concat(b),bytesRead:w},_.guessEncoding);if(x.seemsBinary&&_.acceptTextOnly)throw new d("Stream is binary but only text is accepted for decoding",y.STREAM_IS_BINARY);x.encoding=await _.overwriteEncoding(x.encoding),N=await T.create(x.encoding);const B=N.write(g.VSBuffer.concat(b).buffer);I.write(B),b.length=0,w=0,C({stream:I,detected:x})}catch(x){O.cancel(),I.destroy(),S(x)}};(0,r.listenStream)(p,{onData:async x=>{N?I.write(N.write(x.buffer)):(b.push(x),w+=x.byteLength,w>=D&&(p.pause(),await U(),setTimeout(()=>p.resume())))},onError:x=>I.error(x),onEnd:async()=>{N||await U(),I.end(N?.end())}},O.token)})}async function a(p,_,D){const S=(await(0,k.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(f(_),D);let I=!1,b=!1;return{read(){if(b)return null;const w=p.read();if(typeof w!="string"){if(b=!0,!I&&D?.addBOM)switch(_){case e.UTF8:case e.UTF8_with_bom:return g.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return g.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return g.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const N=S.end();return N&&N.length>0?(I=!0,g.VSBuffer.wrap(N)):null}return I=!0,g.VSBuffer.wrap(S.write(w))}}}async function u(p){return(await(0,k.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(f(p))}function f(p){return p===e.UTF8_with_bom||p===null?e.UTF8:p}function m(p,_){if(!p||_<e.UTF16be_BOM.length)return null;const D=p.readUInt8(0),C=p.readUInt8(1);if(D===e.UTF16be_BOM[0]&&C===e.UTF16be_BOM[1])return e.UTF16be;if(D===e.UTF16le_BOM[0]&&C===e.UTF16le_BOM[1])return e.UTF16le;if(_<e.UTF8_BOM.length)return null;const S=p.readUInt8(2);return D===e.UTF8_BOM[0]&&C===e.UTF8_BOM[1]&&S===e.UTF8_BOM[2]?e.UTF8_with_bom:null}const n=["ascii","utf-16","utf-32"];async function s(p){const _=await(0,k.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),D=p.slice(0,P),C=c(D.buffer),S=_.detect(C);if(!S||!S.encoding)return null;const I=S.encoding.toLowerCase();return 0<=n.indexOf(I)?null:t(S.encoding)}const i={ibm866:"cp866",big5:"cp950"};function t(p){const _=p.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return i[_]||_}function c(p){let _="";for(let D=0;D<p.length;D++)_+=String.fromCharCode(p[D]);return _}function h(p){switch(p){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const _=p.match(/windows(\d+)/);return _?"windows-"+_[1]:p}}}function o({buffer:p,bytesRead:_},D){let C=m(p,_),S=!1;if(C!==e.UTF16be&&C!==e.UTF16le&&p){let I=!0,b=!0,w=!1;for(let N=0;N<_&&N<R;N++){const O=N%2===1,U=p.readUInt8(N)===0;if(U&&(w=!0),I&&(O&&!U||!O&&U)&&(I=!1),b&&(O&&U||!O&&!U)&&(b=!1),U&&!I&&!b)break}w&&(I?C=e.UTF16le:b?C=e.UTF16be:S=!0)}return D&&!S&&!C&&p?s(p.slice(0,_)).then(I=>({seemsBinary:!1,encoding:I})):{seemsBinary:S,encoding:C}}e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(we[170],ye([1,0,400,34,169]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends k.TextSearchManager{constructor(R,v,l=g,P="searchProcess"){super({query:R,provider:v},{readdir:y=>l.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,r.toCanonicalName)(y)},P)}}e.NativeTextSearchManager=A}),define(we[171],ye([1,0,59,416,399,19,79,39,13,2,38,99,417,397,129]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepParser=e.RipgrepTextSearchEngine=void 0,e.getRgArgs=t,e.unicodeEscapesToPCRE2=h,e.fixRegexNewline=p,e.fixNewline=_,e.performBraceExpansionForRipgrep=C;const a=T.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class u{constructor(I){this.outputChannel=I}provideTextSearchResults(I,b,w,N){return this.outputChannel.appendLine(`provideTextSearchResults ${I.pattern}, ${JSON.stringify({...b,folder:b.folder.toString()})}`),new Promise((O,U)=>{N.onCancellationRequested(()=>q());const x=t(I,b),B=b.folder.fsPath,F=x.map(Se=>Se.match(/^-/)?Se:`'${Se}'`).join(" ");this.outputChannel.appendLine(`${a} ${F}
 - cwd: ${B}`);let M=r.spawn(a,x,{cwd:B});M.on("error",Se=>{console.error(Se),this.outputChannel.appendLine("Error: "+(Se&&Se.message)),U((0,P.serializeSearchError)(new P.SearchError(Se&&Se.message,P.SearchErrorCode.rgProcessError)))});let K=!1;const ee=new n(b.maxResults,b.folder,b.previewOptions);ee.on("result",Se=>{K=!0,ne="",w.report(Se)});let $=!1;const q=()=>{$=!0,M?.kill(),ee?.cancel()};let Z=!1;ee.on("hitLimit",()=>{Z=!0,q()});let ne="";M.stdout.on("data",Se=>{ee.handleData(Se),K||(ne+=Se)});let de=!1;M.stdout.once("data",()=>de=!0);let re="";M.stderr.on("data",Se=>{const ve=Se.toString();this.outputChannel.appendLine(ve),re.length+ve.length<1e6&&(re+=ve)}),M.on("close",()=>{if(this.outputChannel.appendLine(de?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(K?"Got result from parser":"No result from parser"),ne&&this.outputChannel.appendLine(`Got data without result: ${ne}`),this.outputChannel.appendLine(""),$)O({limitHit:Z});else{ee.flush(),M=null;let Se;re&&!de&&(Se=f(re))?U((0,P.serializeSearchError)(new P.SearchError(Se.message,Se.code))):O({limitHit:Z})}})})}}e.RipgrepTextSearchEngine=u;function f(S){const I=S.split(`
`),b=I[0].trim();if(I.some(N=>N.startsWith("regex parse error")))return new P.SearchError(m(I),P.SearchErrorCode.regexParseError);const w=b.match(/grep config error: unknown encoding: (.*)/);if(w)return new P.SearchError(`Unknown encoding: ${w[1]}`,P.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new P.SearchError(b.charAt(0).toUpperCase()+b.substr(1),P.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new P.SearchError(b.charAt(0).toUpperCase()+b.substr(1),P.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(b,P.SearchErrorCode.regexParseError)}function m(S){const I=["Regex parse error"],b=S.filter(w=>w.startsWith("PCRE2:"));if(b.length>=1){const w=b[0].replace("PCRE2:","");if(w.indexOf(":")!==-1&&w.split(":").length>=2){const N=w.split(":")[1];I.push(":"+N)}}return I.join("")}class n extends g.EventEmitter{constructor(I,b,w){super(),this.maxResults=I,this.root=b,this.previewOptions=w,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(I,b){return super.on(I,b),this}handleData(I){if(this.isDone)return;const b=typeof I=="string"?I:this.stringDecoder.write(I);this.handleDecodedData(b)}handleDecodedData(I){let b=I.indexOf(`
`);const w=this.remainder+I;if(b>=0)b+=this.remainder.length;else{this.remainder=w;return}let N=0;for(;b>=0;)this.handleLine(w.substring(N,b).trim()),N=b+1,b=w.indexOf(`
`,N);this.remainder=w.substring(N)}handleLine(I){if(this.isDone||!I)return;let b;try{b=JSON.parse(I)}catch{throw new Error(`malformed line from rg: ${I}`)}if(b.type==="match"){const w=s(b.data.path),N=l.URI.joinPath(this.root,w),O=this.createTextSearchMatch(b.data,N);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const w=s(b.data.path),N=l.URI.joinPath(this.root,w);this.createTextSearchContext(b.data,N).forEach(U=>this.onResult(U))}}createTextSearchMatch(I,b){const w=I.line_number-1,N=s(I.lines),O=Buffer.from(N);let U=0,x=0,B=w;I.submatches.length===0&&I.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const F=(0,A.coalesce)(I.submatches.map((M,K)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const ee=s(M.match),$=O.slice(U,M.start).toString(),q=i($),Z=q.numLines>0?q.lastLineLength:q.lastLineLength+x,ne=i(ee),de=q.numLines+B,re=ne.numLines+de,Se=ne.numLines>0?ne.lastLineLength:ne.lastLineLength+Z;return U=M.end,x=Se,B=re,new y.Range(de,Z,re,Se)}));return(0,E.createTextSearchResult)(b,N,F,this.previewOptions)}createTextSearchContext(I,b){const w=s(I.lines),N=I.line_number;return w.replace(/\r?\n$/,"").split(`
`).map((O,U)=>({text:O,uri:b,lineNumber:N+U}))}onResult(I){this.emit("result",I)}}e.RipgrepParser=n;function s(S){return S.bytes?Buffer.from(S.bytes,"base64").toString():S.text}function i(S){const I=/\n/g;let b=0,w=-1,N;for(;N=I.exec(S);)b++,w=N.index;const O=w>=0?S.length-w-1:S.length;return{numLines:b,lastLineLength:O}}function t(S,I){const b=["--hidden","--no-require-git"];b.push(S.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:w,otherIncludes:N}=(0,L.groupBy)(I.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const U=new Set;N.forEach(x=>{U.add(x)}),b.push("-g","!*"),U.forEach(x=>{c(x).map(E.anchorGlob).forEach(B=>{b.push("-g",B)})})}w&&w.length&&w.forEach(U=>{b.push("-g",U)}),I.excludes.map(E.anchorGlob).forEach(U=>b.push("-g",`!${U}`)),I.maxFileSize&&b.push("--max-filesize",I.maxFileSize+""),I.useIgnoreFiles?I.useParentIgnoreFiles||b.push("--no-ignore-parent"):b.push("--no-ignore"),I.followSymlinks&&b.push("--follow"),I.encoding&&I.encoding!=="utf8"&&b.push("--encoding",I.encoding),S.pattern==="--"&&(S.isRegExp=!0,S.pattern="\\-\\-"),S.isMultiline&&!S.isRegExp&&(S.pattern=(0,v.escapeRegExpCharacters)(S.pattern),S.isRegExp=!0),I.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),S.isRegExp&&(S.pattern=h(S.pattern),b.push("--engine","auto"));let O;if(S.isWordMatch){const x=(0,v.createRegExp)(S.pattern,!!S.isRegExp,{wholeWord:S.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",x)}else if(S.isRegExp){let U=p(S.pattern);U=_(U),b.push("--regexp",U)}else O=S.pattern,b.push("--fixed-strings");return b.push("--no-config"),I.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),S.isMultiline&&b.push("--multiline"),I.beforeContext&&b.push("--before-context",I.beforeContext+""),I.afterContext&&b.push("--after-context",I.afterContext+""),b.push("--"),O&&b.push(O),b.push("."),b}function c(S){return C(S).flatMap(b=>{const w=(0,R.splitGlobAware)(b,"/");return w.map((N,O)=>w.slice(0,O+1).join("/"))})}function h(S){const I=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;S.match(I);)S=S.replace(I,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;S.match(b);)S=S.replace(b,"$1\\x{$2}");return S}const o=S=>S.type==="Assertion"&&S.kind==="lookbehind";function p(S){let I;try{I=new d.RegExpParser().parsePattern(S)}catch{return S}let b="",w=0;const N=(x,B,F)=>{b+=S.slice(w,x)+F,w=B},O=[];return new d.RegExpVisitor({onCharacterEnter(x){if(x.raw!=="\\n")return;const B=O[0];if(!B)N(x.start,x.end,"\\r?\\n");else if(!O.some(o))if(B.type==="CharacterClass")if(B.negate){const F=S.slice(B.start+2,x.start)+S.slice(x.end,B.end-1);B.parent?.type==="Quantifier"?N(B.start,B.end,F?`[^${F}]`:"."):N(B.start,B.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=S.slice(B.start+1,x.start)+S.slice(x.end,B.end-1);N(B.start,B.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else B.type==="Quantifier"&&N(x.start,x.end,"(?:\\r?\\n)")},onQuantifierEnter(x){O.unshift(x)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(x){O.unshift(x)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(x){O.unshift(x)},onCharacterClassLeave(){O.shift()},onAssertionEnter(x){o(x)&&O.push(x)},onAssertionLeave(x){O[0]===x&&O.shift()}}).visit(I),b+=S.slice(w),b}function _(S){return S.replace(/\n/g,"\\r?\\n")}function D(S){let I=!1,b=!1,w="",N="";for(let O=0;O<S.length;O++){const U=S[O];switch(U){case"\\":b?(I?N+="\\"+U:w+="\\"+U,b=!1):b=!0;break;case"{":if(b)I?N+=U:w+=U,b=!1;else{if(I)return{strInBraces:w+"{"+N+"{"+S.substring(O+1)};I=!0}break;case"}":if(b)I?N+=U:w+=U,b=!1;else{if(I)return{fixedStart:w,strInBraces:N,fixedEnd:S.substring(O+1)};w+=U}break;default:I?N+=(b?"\\":"")+U:w+=(b?"\\":"")+U,b=!1;break}}return{strInBraces:w+(I?"{"+N:"")}}function C(S){const{fixedStart:I,strInBraces:b,fixedEnd:w}=D(S);if(I===void 0||w===void 0)return[b];let N=(0,R.splitGlobAware)(b,",");N.length||(N=[""]);const O=C(w);return N.flatMap(U=>{const x=I+U;return O.map(B=>x+B)})}}),define(we[401],ye([1,0,21,171,90,15]),function(he,e,r,g,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class L{constructor(l){this.outputChannel=l,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(l,P,y,d){const T=new g.RipgrepTextSearchEngine(this.outputChannel);if(P.folder.scheme===A.Schemas.vscodeUserData){const E={...P,folder:P.folder.with({scheme:A.Schemas.file})},a=new k.Progress(u=>y.report({...u,uri:u.uri.with({scheme:P.folder.scheme})}));return this.withToken(d,u=>T.provideTextSearchResults(l,E,a,u))}else return this.withToken(d,E=>T.provideTextSearchResults(l,P,y,E))}async withToken(l,P){const y=R(l);this.inProgress.add(y);const d=await P(y.token);return this.inProgress.delete(y),d}dispose(){this.inProgress.forEach(l=>l.cancel())}}e.RipgrepSearchProvider=L;function R(v){const l=new r.CancellationTokenSource;return v.onCancellationRequested(()=>l.cancel()),l}}),define(we[402],ye([1,0,34,171,170]),function(he,e,r,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(v){this.query=v}search(v,l,P){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const y={appendLine(T){P({message:T})}},d=new k.NativeTextSearchManager(this.query,new g.RipgrepTextSearchEngine(y),r);return new Promise((T,E)=>d.search(a=>{l(a.map(L))},v).then(a=>T({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),E))}}e.TextSearchEngineAdapter=A;function L(R){return{path:R.resource&&R.resource.fsPath,results:R.results,numMatches:(R.results||[]).reduce((v,l)=>{if(l.ranges){const P=l;return v+(Array.isArray(P.ranges)?P.ranges.length:1)}else return v+1},0)}}}),define(we[403],ye([1,0,19,9,14,4,140,16,42,2,28,38,398,402]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{static{this.BATCH_SIZE=512}constructor(s="searchProcess"){this.processType=s,this.caches=Object.create(null)}fileSearch(s){let i;const t=f(s),c=new A.Emitter({onDidAddFirstListener:()=>{i=(0,g.createCancelablePromise)(h=>this.doFileSearchWithEngine(d.Engine,t,o=>c.fire(o),h)),i.then(h=>c.fire(h),h=>c.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return c.event}textSearch(s){let i;const t=f(s),c=new A.Emitter({onDidAddFirstListener:()=>{i=(0,g.createCancelablePromise)(h=>this.ripgrepTextSearch(t,o=>c.fire(o),h)),i.then(h=>c.fire(h),h=>c.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return c.event}ripgrepTextSearch(s,i,t){return s.maxFileSize=this.getPlatformFileLimits().maxFileSize,new T.TextSearchEngineAdapter(s).search(t,i,i)}getPlatformFileLimits(){return{maxFileSize:16*P.ByteSize.GB}}doFileSearch(s,i,t){return this.doFileSearchWithEngine(d.Engine,s,i,t)}doFileSearchWithEngine(s,i,t,c,h=E.BATCH_SIZE){let o=0;const p=D=>{Array.isArray(D)?(o+=D.length,t(D.map(C=>this.rawMatchToSearchItem(C)))):D.relativePath?(o++,t(this.rawMatchToSearchItem(D))):t(D)};if(i.sortByScore){let D=this.trySortedSearchFromCache(i,p,c);if(!D){const C=i.maxResults?Object.assign({},i,{maxResults:null}):i,S=new s(C);D=this.doSortedSearch(S,i,t,p,c)}return new Promise((C,S)=>{D.then(([I,b])=>{const w=b.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(w,t,h),C(I)},S)})}const _=new s(i);return this.doSearch(_,p,h,c).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:this.processType,fromCache:!1,resultCount:o,sortingTime:void 0},messages:[]}))}rawMatchToSearchItem(s){return{path:s.base?(0,R.join)(s.base,s.relativePath):s.relativePath}}doSortedSearch(s,i,t,c,h){const o=new A.Emitter;let p=(0,g.createCancelablePromise)(D=>{let C=[];const S=I=>{Array.isArray(I)?C=I:(c(I),o.fire(I))};return this.doSearch(s,S,-1,D).then(I=>[I,C])}),_;if(i.cacheKey){_=this.getOrCreateCache(i.cacheKey);const D={promise:p,event:o.event,resolved:!1};_.resultsToSearchCache[i.filePattern||""]=D,p.then(()=>{D.resolved=!0},C=>{delete _.resultsToSearchCache[i.filePattern||""]}),p=this.preventCancellation(p)}return p.then(([D,C])=>{const S=_?_.scorerCache:Object.create(null),I=(typeof i.maxResults!="number"||i.maxResults>0)&&v.StopWatch.create(!1);return this.sortResults(i,C,S,h).then(b=>{const w=I?I.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:w,fromCache:!1,type:this.processType,resultCount:b.length},messages:D.messages,limitHit:D.limitHit||typeof i.maxResults=="number"&&C.length>i.maxResults},b]})})}getOrCreateCache(s){const i=this.caches[s];return i||(this.caches[s]=new a)}trySortedSearchFromCache(s,i,t){const c=s.cacheKey&&this.caches[s.cacheKey];if(!c)return;const h=this.getResultsFromCache(c,s.filePattern||"",i,t);if(h)return h.then(([o,p,_])=>{const D=v.StopWatch.create(!1);return this.sortResults(s,p,c.scorerCache,t).then(C=>{const S=D.elapsed(),I={fromCache:!0,detailStats:_,type:this.processType,resultCount:p.length,sortingTime:S};return[{type:"success",limitHit:o.limitHit||typeof s.maxResults=="number"&&p.length>s.maxResults,stats:I,messages:[]},C]})})}sortResults(s,i,t,c){const h=(0,L.prepareQuery)(s.filePattern||""),o=(_,D)=>(0,L.compareItemsByFuzzyScore)(_,D,h,!0,u,t),p=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return r.topAsync(i,o,p,1e4,c)}sendProgress(s,i,t){if(t&&t>0)for(let c=0;c<s.length;c+=t)i(s.slice(c,c+t));else i(s)}getResultsFromCache(s,i,t,c){const h=v.StopWatch.create(!1),o=i.indexOf(R.sep)>=0;let p;for(const S in s.resultsToSearchCache)if(i.startsWith(S)){if(o&&S.indexOf(R.sep)<0&&S!=="")continue;const I=s.resultsToSearchCache[S];p={promise:this.preventCancellation(I.promise),event:I.event,resolved:I.resolved};break}if(!p)return null;const _=h.elapsed(),D=v.StopWatch.create(!1),C=p.event(t);return c&&c.onCancellationRequested(()=>{C.dispose()}),p.promise.then(([S,I])=>{if(c&&c.isCancellationRequested)throw(0,k.canceled)();const b=[],w=(0,L.prepareQuery)(i).normalizedLowercase;for(const N of I)(0,y.isFilePatternMatch)(N,w)&&b.push(N);return[S,b,{cacheWasResolved:p.resolved,cacheLookupTime:_,cacheFilterTime:D.elapsed(),cacheEntryCount:I.length}]})}doSearch(s,i,t,c){return new Promise((h,o)=>{let p=[];c?.onCancellationRequested(()=>s.cancel()),s.search(_=>{_&&(t?(p.push(_),t>0&&p.length>=t&&(i(p),p=[])):i(_))},_=>{i(_)},(_,D)=>{p.length&&i(p),_?(i({message:"Search finished. Error: "+_.message}),o(_)):(i({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),h(D))})})}clearCache(s){return delete this.caches[s],Promise.resolve(void 0)}preventCancellation(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,t){return s.then(i,t)}catch(i){return this.then(void 0,i)}finally(i){return s.finally(i)}}}}e.SearchService=E;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const u=new class{getItemLabel(n){return(0,R.basename)(n.relativePath)}getItemDescription(n){return(0,R.dirname)(n.relativePath)}getItemPath(n){return n.relativePath}};function f(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(m),extraFileResources:n.extraFileResources&&n.extraFileResources.map(s=>l.URI.revive(s))}}function m(n){return{...n,folder:l.URI.revive(n.folder)}}}),define(we[404],ye([1,0,3,15,2,34,12,30,20,102,72,38,403,401,129,170]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let u=class extends l.ExtHostSearch{constructor(m,n,s,i){super(m,s,i),this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new r.DisposableStore;const t=new E.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(g.Schemas.vscodeUserData,new T.RipgrepSearchProvider(t))),n.remote.isRemote&&n.remote.authority&&this._registerEHSearchProviders()}dispose(){this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const m=new E.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(g.Schemas.file,new T.RipgrepSearchProvider(m))),this._disposables.add(this.registerInternalFileSearchProvider(g.Schemas.file,new d.SearchService("fileSearchProvider")))}registerInternalFileSearchProvider(m,n){const s=this._handlePool++;return this._internalFileSearchProvider=n,this._internalFileSearchHandle=s,this._proxy.$registerFileSearchProvider(s,this._transformScheme(m)),(0,r.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(m,n,s,i){const t=(0,l.reviveQuery)(s);if(m===this._internalFileSearchHandle){const c=Date.now();return this.doInternalFileSearch(m,n,t,i).then(h=>{const o=Date.now()-c;return this._logService.debug(`Ext host file search time: ${o}ms`),h})}return super.$provideFileSearchResults(m,n,s,i)}doInternalFileSearchWithCustomCallback(m,n,s){const i=t=>{if((0,y.isSerializedFileMatch)(t)&&(t=[t]),Array.isArray(t)){s(t.map(c=>k.URI.file(c.path)));return}t.message&&this._logService.debug("ExtHostSearch",t.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(m,i,n)}async doInternalFileSearch(m,n,s,i){return this.doInternalFileSearchWithCustomCallback(s,i,t=>{this._proxy.$handleFileMatch(m,n,t)})}$clearCache(m){return this._internalFileSearchProvider?.clearCache(m),super.$clearCache(m)}createTextSearchManager(m,n){return new a.NativeTextSearchManager(m,n,void 0,"textSearchProvider")}};e.NativeExtHostSearch=u,e.NativeExtHostSearch=u=Ke([Ve(0,v.IExtHostRpcService),Ve(1,R.IExtHostInitDataService),Ve(2,P.IURITransformerService),Ve(3,L.ILogService)],u)}),define(we[130],ye([1,0,418,66,67,419,22,14,4,3,16,11,32,87,68]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=h,e.createStaticIPCHandle=o,e.serve=D,e.connect=C;class a{traceSocketEvent(I,b){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,b)}constructor(I,b=""){this._canWrite=!0,this.debugLabel=b,this.socket=I,this.traceSocketEvent(E.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=w=>{if(this.traceSocketEvent(E.SocketDiagnosticsEventType.Error,{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener),this._closeListener=w=>{this.traceSocketEvent(E.SocketDiagnosticsEventType.Close,{hadError:w}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(E.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(I){const b=w=>{this.traceSocketEvent(E.SocketDiagnosticsEventType.Read,w),I(L.VSBuffer.wrap(w))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(I){const b=w=>{I({type:E.SocketCloseEventType.NodeSocketCloseEvent,hadError:w,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(I){const b=()=>{I()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(I){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(E.SocketDiagnosticsEventType.Write,I),this.socket.write(I.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}}end(){this.traceSocketEvent(E.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(E.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((I,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(E.SocketDiagnosticsEventType.NodeDrainEnd),I();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent(E.SocketDiagnosticsEventType.NodeDrainEnd),I()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.NodeSocket=a;var u;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize",S[S.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var f;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(f||(f={}));class m extends l.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,b){this.socket.traceSocketEvent(I,b)}constructor(I,b,w,N){super(),this._onData=this._register(new v.Emitter),this._onClose=this._register(new v.Emitter),this._isEnded=!1,this._state={state:f.PeekHeader,readLen:u.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent(E.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:w?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new n(this,b,w,N,this._onData,(O,U)=>this._write(O,U))),this._register(this._flowManager.onError(O=>{console.error(O),(0,R.onUnexpectedError)(O),this._onClose.fire({type:E.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:O})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(async O=>{this._flowManager.isProcessingReadQueue()&&await v.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(O)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let b=0;for(;b<I.byteLength;)this._flowManager.writeMessage(I.slice(b,Math.min(b+u.MaxWebSocketMessageLength,I.byteLength)),{compressed:!0,opcode:2}),b+=u.MaxWebSocketMessageLength}_write(I,{compressed:b,opcode:w}){if(this._isEnded)return;this.traceSocketEvent(E.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,I);let N=u.MinHeaderByteSize;I.byteLength<126?N+=0:I.byteLength<2**16?N+=2:N+=8;const O=L.VSBuffer.alloc(N),U=b?64:0,x=w&15;if(O.writeUInt8(128|U|x,0),I.byteLength<126)O.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){O.writeUInt8(126,1);let B=1;O.writeUInt8(I.byteLength>>>8&255,++B),O.writeUInt8(I.byteLength>>>0&255,++B)}else{O.writeUInt8(127,1);let B=1;O.writeUInt8(0,++B),O.writeUInt8(0,++B),O.writeUInt8(0,++B),O.writeUInt8(0,++B),O.writeUInt8(I.byteLength>>>24&255,++B),O.writeUInt8(I.byteLength>>>16&255,++B),O.writeUInt8(I.byteLength>>>8&255,++B),O.writeUInt8(I.byteLength>>>0&255,++B)}this.socket.write(L.VSBuffer.concat([O,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===f.PeekHeader){const b=this._incomingData.peek(this._state.readLen),w=b.readUInt8(0),N=(w&128)>>>7,O=(w&64)>>>6,U=w&15,x=b.readUInt8(1),B=(x&128)>>>7,F=x&127;this._state.state=f.ReadHeader,this._state.readLen=u.MinHeaderByteSize+(B?4:0)+(F===126?2:0)+(F===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!O),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this._state.opcode=U,this.traceSocketEvent(E.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===f.ReadHeader){const b=this._incomingData.read(this._state.readLen),w=b.readUInt8(1),N=(w&128)>>>7;let O=w&127,U=1;O===126?O=b.readUInt8(++U)*2**8+b.readUInt8(++U):O===127&&(O=b.readUInt8(++U)*0+b.readUInt8(++U)*0+b.readUInt8(++U)*0+b.readUInt8(++U)*0+b.readUInt8(++U)*2**24+b.readUInt8(++U)*2**16+b.readUInt8(++U)*2**8+b.readUInt8(++U));let x=0;N&&(x=b.readUInt8(++U)*2**24+b.readUInt8(++U)*2**16+b.readUInt8(++U)*2**8+b.readUInt8(++U)),this._state.state=f.ReadBody,this._state.readLen=O,this._state.mask=x,this.traceSocketEvent(E.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===f.ReadBody){const b=this._incomingData.read(this._state.readLen);this.traceSocketEvent(E.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,b),t(b,this._state.mask),this.traceSocketEvent(E.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,b),this._state.state=f.PeekHeader,this._state.readLen=u.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(b,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(b,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(E.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await v.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(E.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=m;class n extends l.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(I,b,w,N,O,U){super(),this._tracer=I,this._onData=O,this._writeFn=U,this._onError=this._register(new v.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new v.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new v.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,b?(this._zlibInflateStream=this._register(new s(this._tracer,N,w,{windowBits:15})),this._zlibDeflateStream=this._register(new i(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(x=>this._onError.fire(x))),this._register(this._zlibDeflateStream.onError(x=>this._onError.fire(x)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(I,b){this._writeQueue.push({data:I,options:b}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:I,options:b}=this._writeQueue.shift();if(this._zlibDeflateStream&&b.compressed){const w=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(w,b)}else this._writeFn(I,{...b,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,b){return new Promise((w,N)=>{I.write(b),I.flush(O=>w(O))})}acceptFrame(I,b,w){this._readQueue.push({data:I,isCompressed:b,isLastFrameOfMessage:w}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const b=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(b)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(I,b,w){return new Promise((N,O)=>{I.write(b),w&&I.write(L.VSBuffer.fromByteArray([0,0,255,255])),I.flush(U=>N(U))})}}class s extends l.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}constructor(I,b,w,N){super(),this._tracer=I,this._recordInflateBytes=b,this._onError=this._register(new v.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(N),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent(E.SocketDiagnosticsEventType.zlibInflateError,{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent(E.SocketDiagnosticsEventType.zlibInflateData,O),this._pendingInflateData.push(L.VSBuffer.wrap(O))}),w&&(this._tracer.traceSocketEvent(E.SocketDiagnosticsEventType.zlibInflateInitialWrite,w.buffer),this._zlibInflate.write(w.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(E.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent(E.SocketDiagnosticsEventType.zlibInflateWrite,I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(E.SocketDiagnosticsEventType.zlibInflateFlushFired);const b=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(b)})}}class i extends l.Disposable{constructor(I,b){super(),this._tracer=I,this._onError=this._register(new v.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",w=>{this._tracer.traceSocketEvent(E.SocketDiagnosticsEventType.zlibDeflateError,{message:w?.message,code:w?.code}),this._onError.fire(w)}),this._zlibDeflate.on("data",w=>{this._tracer.traceSocketEvent(E.SocketDiagnosticsEventType.zlibDeflateData,w),this._pendingDeflateData.push(L.VSBuffer.wrap(w))})}write(I){this._tracer.traceSocketEvent(E.SocketDiagnosticsEventType.zlibDeflateWrite,I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(E.SocketDiagnosticsEventType.zlibDeflateFlushFired);let b=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.byteLength-4),I(b)})}}function t(S,I){if(I===0)return;const b=S.byteLength>>>2;for(let B=0;B<b;B++){const F=S.readUInt32BE(B*4);S.writeUInt32BE(F^I,B*4)}const w=b*4,N=S.byteLength-w,O=I>>>24&255,U=I>>>16&255,x=I>>>8&255;N>=1&&S.writeUInt8(S.readUInt8(w)^O,w),N>=2&&S.writeUInt8(S.readUInt8(w+1)^U,w+1),N>=3&&S.writeUInt8(S.readUInt8(w+2)^x,w+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[y.Platform.Linux]:107,[y.Platform.Mac]:103};function h(){const S=(0,d.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;const I=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,k.tmpdir)(),b=(0,P.join)(I,`vscode-ipc-${S}.sock`);return p(b),b}function o(S,I,b){const N=(0,r.createHash)("sha256").update(S).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${b}-${I}-sock`;const O=b.substr(0,4),U=I.substr(0,6);let x;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?x=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${O}-${U}.sock`):x=(0,P.join)(S,`${O}-${U}.sock`),p(x),x}function p(S){const I=c[y.platform];typeof I=="number"&&S.length>=I&&console.warn(`WARNING: IPC handle "${S}" is longer than ${I} chars, try a shorter --user-data-dir`)}class _ extends T.IPCServer{static toClientConnectionEvent(I){const b=v.Event.fromNodeEventEmitter(I,"connection");return v.Event.map(b,w=>({protocol:new E.Protocol(new a(w,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(w,"close"))}))}constructor(I){super(_.toClientConnectionEvent(I)),this.server=I}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=_;function D(S){return new Promise((I,b)=>{const w=(0,g.createServer)();w.on("error",b),w.listen(S,()=>{w.removeListener("error",b),I(new _(w))})})}function C(S,I){return new Promise((b,w)=>{const N=(0,g.createConnection)(S,()=>{N.removeListener("error",w),b(E.Client.fromSocket(new a(N,`ipc-client${I}`),I))});N.once("error",w)})}}),define(we[405],ye([1,0,66,67,186,130,9,3,11,44,12,115,283,284,117,93,22]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function f(t,c,h,o,p){let _;for(let D=3;D&&(_?.dispose(),_=await new m(t,c,h,o,p).waitForReady(),!(p&&k.BROWSER_RESTRICTED_PORTS[p]||!k.BROWSER_RESTRICTED_PORTS[_.tunnelLocalPort]));D--);return _}class m extends R.Disposable{constructor(c,h,o,p,_){super(),this.defaultTunnelHost=h,this.suggestedLocalPort=_,this.privacy=a.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=r.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=D=>this._onConnection(D),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=p,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){const c=this.suggestedLocalPort??this.tunnelRemotePort,h=(0,a.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let o=await(0,k.findFreePortFaster)(c,2,1e3,h),p=null;return this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address(),p||(o=0,this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address()),this.tunnelLocalPort=p.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${p.port}`,this}async _onConnection(c){c.pause();const h=(0,a.isLocalhost)(this.tunnelRemoteHost)||(0,a.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,d.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),p=o.getSocket(),_=o.readEntireBuffer();o.dispose(),_.byteLength>0&&c.write(_.buffer),c.on("end",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),p.end()}),c.on("close",()=>p.end()),c.on("error",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),p instanceof A.NodeSocket?p.socket.destroy():p.end()}),p instanceof A.NodeSocket?this._mirrorNodeSocket(c,p):this._mirrorGenericSocket(c,p),c.localAddress&&this._socketsDispose.set(c.localAddress,()=>{c.end(),p.end()})}_mirrorGenericSocket(c,h){h.onClose(()=>c.destroy()),h.onEnd(()=>c.end()),h.onData(o=>c.write(o.buffer)),c.on("data",o=>h.write(u.VSBuffer.wrap(o))),c.resume()}_mirrorNodeSocket(c,h){const o=h.socket;o.on("end",()=>c.end()),o.on("close",()=>c.end()),o.on("error",()=>{c.destroy()}),o.pipe(c),c.pipe(o)}}e.NodeRemoteTunnel=m;let n=class extends a.AbstractTunnelService{constructor(c,h,o,p,_){super(h,_),this.remoteSocketFactoryService=c,this.signService=o,this.productService=p}isPortPrivileged(c){return(0,a.isPortPrivileged)(c,this.defaultTunnelHost,v.OS,g.release())}retainOrCreateTunnel(c,h,o,p,_,D,C,S){const I=this.getTunnelFromMap(h,o);if(I)return++I.refcount,I.value;if((0,a.isTunnelProvider)(c))return this.createWithProvider(c,h,o,_,D,C,S);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${_}.`);const b={commit:this.productService.commit,quality:this.productService.quality,addressProvider:c,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},w=f(b,p,h,o,_);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,o,w),w}}};e.BaseTunnelService=n,e.BaseTunnelService=n=Ke([Ve(0,T.IRemoteSocketFactoryService),Ve(1,P.ILogService),Ve(2,E.ISignService),Ve(3,y.IProductService),Ve(4,l.IConfigurationService)],n);let s=class extends n{constructor(c,h,o,p,_){super(c,h,o,p,_)}};e.TunnelService=s,e.TunnelService=s=Ke([Ve(0,T.IRemoteSocketFactoryService),Ve(1,P.ILogService),Ve(2,E.ISignService),Ve(3,y.IProductService),Ve(4,l.IConfigurationService)],s);let i=class extends R.Disposable{constructor(c,h,o,p,_){super(),this.remoteSocketFactoryService=c,this.logService=h,this.productService=o,this.signService=p,this.configurationService=_,this._tunnelServices=new Map}async openTunnel(c,h,o,p,_,D,C,S,I){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${p} on local port ${D}.`),!this._tunnelServices.has(c)){const b=new s(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(b),this._tunnelServices.set(c,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(h,o,p,_,D,C,S,I)}};e.SharedTunnelsService=i,e.SharedTunnelsService=i=Ke([Ve(0,T.IRemoteSocketFactoryService),Ve(1,P.ILogService),Ve(2,y.IProductService),Ve(3,E.ISignService),Ve(4,l.IConfigurationService)],i)}),define(we[406],ye([1,0,130,301,58,37,2,12,45]),function(he,e,r,g,k,A,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class l{constructor(d,T,E){this._commands=d,this.logService=T,this._ipcHandlePath=E,this._server=g.createServer((a,u)=>this.onRequest(a,u)),this.setup().catch(a=>(T.error(a),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",d=>this.logService.error(d))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(d,T){const E=(u,f)=>{T.writeHead(u,{"content-type":"application/json"}),T.end(JSON.stringify(f||null),m=>m&&this.logService.error(m))},a=[];d.setEncoding("utf8"),d.on("data",u=>a.push(u)),d.on("end",async()=>{try{const u=JSON.parse(a.join(""));let f;switch(u.type){case"open":f=await this.open(u);break;case"openExternal":f=await this.openExternal(u);break;case"status":f=await this.getStatus(u);break;case"extensionManagement":f=await this.manageExtensions(u);break;default:E(404,`Unknown message type: ${u.type}`);break}E(200,f)}catch(u){const f=u instanceof Error?u.message:JSON.stringify(u);E(500,f),this.logService.error("Error while processing pipe request",u)}})}async open(d){const{fileURIs:T,folderURIs:E,forceNewWindow:a,diffMode:u,mergeMode:f,addMode:m,forceReuseWindow:n,gotoLineMode:s,waitMarkerFilePath:i,remoteAuthority:t}=d,c=[];if(Array.isArray(E))for(const _ of E)try{c.push({folderUri:L.URI.parse(_)})}catch{}if(Array.isArray(T))for(const _ of T)try{(0,v.hasWorkspaceFileExtension)(_)?c.push({workspaceUri:L.URI.parse(_)}):c.push({fileUri:L.URI.parse(_)})}catch{}const h=i?L.URI.file(i):void 0,p={forceNewWindow:a,diffMode:u,mergeMode:f,addMode:m,gotoLineMode:s,forceReuseWindow:n,preferNewWindow:!n&&!h&&!m,waitMarkerFileURI:h,remoteAuthority:t};this._commands.executeCommand("_remoteCLI.windowOpen",c,p)}async openExternal(d){for(const T of d.uris){const E=L.URI.parse(T),a=E.scheme==="file"?E:T;await this._commands.executeCommand("_remoteCLI.openExternal",a)}}async manageExtensions(d){const T=a=>a?.map(u=>/\.vsix$/i.test(u)?L.URI.parse(u):u),E={list:d.list,install:T(d.install),uninstall:T(d.uninstall),force:d.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",E)}async getStatus(d){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=l;let P=class extends l{constructor(d,T){super(d,T,(0,r.createRandomIPCHandle)())}};e.CLIServer=P,e.CLIServer=P=Ke([Ve(0,A.IExtHostCommands),Ve(1,R.ILogService)],P)}),define(we[407],ye([1,0,62,394,389,300,53,376,2,15,10,406,110,336,375]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends k.RequireInterceptor{_installInterceptor(){const m=this,n=globalThis._VSCODE_NODE_MODULES.module,s=n._load;n._load=function(h,o,p){return h=t(h),m._factories.has(h)?m._factories.get(h).load(h,v.URI.file((0,d.realpathSync)(o.filename)),_=>s.apply(this,[_,o,p])):s.apply(this,arguments)};const i=n._resolveLookupPaths;n._resolveLookupPaths=(c,h)=>i.call(this,t(c),h);const t=c=>{for(const h of m._alternatives){const o=h(c);if(o){c=o;break}}return c}}}class u extends L.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const m=this._instaService.invokeFunction(g.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(R.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const i=this._instaService.createInstance(y.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=i.ipcHandlePath}this._instaService.createInstance(E.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(a,m,{mine:this._myRegistry,all:this._globalRegistry}).install(),r.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),r.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(m){return m.main}async _loadCommonJSModule(m,n,s){if(n.scheme!==l.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let i=null;s.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this._logService.flush();const t=m?.identifier.value;m&&await this._extHostLocalizationService.initializeLocalizedMessages(m);try{t&&r.mark(`code/extHost/willLoadExtensionCode/${t}`),i=he.__$__nodeRequire(n.fsPath)}finally{t&&r.mark(`code/extHost/didLoadExtensionCode/${t}`),s.codeLoadingStop()}return i}async $setRemoteEnvironment(m){if(this._initData.remote.isRemote)for(const n in m){const s=m[n];s===null?delete process.env[n]:process.env[n]=s}}}e.ExtHostExtensionService=u}),define(we[408],ye([1,0,59,22,4,3,133,11,23,2,34,68,12,282,71,117,93,405,30,20,76,383]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=void 0,e.getSockets=t,e.loadListeningPorts=c,e.parseIpAddress=h,e.loadConnectionTable=o,e.getRootProcesses=_,e.findPorts=D,e.tryFindRootPorts=C;function t(b){const w=b.trim().split(`
`),N=[];return w.forEach(U=>{const x=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);x&&x.length>=3&&N.push({pid:parseInt(x[1],10),socket:parseInt(x[2],10)})}),N.reduce((U,x)=>(U[x.socket]=x,U),{})}function c(...b){const w=[].concat(...b.map(o));return[...new Map(w.filter(N=>N.st==="0A").map(N=>{const O=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:h(O[0]),port:parseInt(O[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function h(b){let w="";if(b.length===8)for(let N=b.length-2;N>=0;N-=2)w+=parseInt(b.substr(N,2),16),N!==0&&(w+=".");else for(let N=0;N<b.length;N+=8){const O=b.substring(N,N+8);let U="";for(let x=8;x>=2;x-=2)U+=O.substring(x-2,x),(x===6||x===2)&&(U=parseInt(U,16).toString(16),w+=`${U}`,U="",N+x!==b.length-6&&(w+=":"))}return w}function o(b){const w=b.trim().split(`
`),N=w.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return w.map(U=>U.trim().split(/\s+/).reduce((x,B,F)=>(x[N[F]||F]=B,x),{}))}function p(b){return!!b.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||b.indexOf("out/server-main.js")!==-1||b.indexOf("_productName=VSCode")!==-1}function _(b){const w=b.trim().split(`
`),N=[];return w.forEach(O=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);U&&U.length>=4&&N.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),N}async function D(b,w,N){const O=N.reduce((x,B)=>(x[B.pid]=B,x),{}),U=[];return b.forEach(({socket:x,ip:B,port:F})=>{const M=w[x]?w[x].pid:void 0,K=M?O[M]?.cmd:void 0;M&&K&&!p(K)&&U.push({host:B,port:F,detail:K,pid:M})}),U}function C(b,w,N){const O=new Map,U=_(w);for(const x of b){const B=N.get(x.port);if(B){O.set(x.port,B);continue}const F=U.find(M=>M.cmd.includes(`${x.port}`));if(F){let M=F,K;do K=U.find(ee=>ee.ppid===M.pid),K&&(M=K);while(K);O.set(x.port,{host:x.ip,port:x.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else O.set(x.port,{host:x.ip,port:x.port,ppid:Number.MAX_VALUE})}return O}let S=class extends s.ExtHostTunnelService{constructor(w,N,O,U){super(w,N,O),this.initData=N,this.signService=U,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,R.isLinux&&N.remote.isRemote&&N.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(w){if(w&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=w;let N;this._initialCandidates&&(N=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const O=new L.MovingAverage;let U=0;for(;this._candidateFindingEnabled;){const x=new Date().getTime(),B=(await this.findCandidatePorts()).filter(K=>(0,u.isLocalhost)(K.host)||(0,u.isAllInterfaces)(K.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${B.map(K=>K.port).join(", ")}`);const F=new Date().getTime()-x;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${F} ms.`),U++>3&&O.update(F),(!N||JSON.stringify(N)!==JSON.stringify(B))&&(N=B,await this._proxy.$onFoundNewCandidates(N));const M=this.calculateDelay(O.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${M} ms.`),await new Promise(K=>setTimeout(()=>K(),M))}}calculateDelay(w){return Math.max(w*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(w=>w.port).join(", ")}`)}async findCandidatePorts(){let w="",N="";try{w=await P.Promises.readFile("/proc/net/tcp","utf8"),N=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=c(w,N),U=await new Promise(q=>{(0,r.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Z,ne,de)=>{q(ne)})}),x=t(U),B=await P.Promises.readdir("/proc"),F=[];for(const q of B)try{const Z=Number(q),ne=v.joinPath(l.URI.file("/proc"),q);if((await P.Promises.stat(ne.fsPath)).isDirectory()&&!isNaN(Z)){const re=await P.Promises.readlink(v.joinPath(ne,"cwd").fsPath),Se=await P.Promises.readFile(v.joinPath(ne,"cmdline").fsPath,"utf8");F.push({pid:Z,cwd:re,cmd:Se})}}catch{}const M=[],K=O.filter(q=>{const Z=x[q.socket];return Z||M.push(q),Z}),ee=D(K,x,F);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const q=await new Promise(Z=>{(0,r.exec)("ps -F -A -l | grep root",(ne,de,re)=>{Z(de)})});this._foundRootPorts=C(M,q,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.map(Z=>Z.port).join(", ")}`)}return ee.then(q=>$?q.concat($):q)}makeManagedTunnelFactory(w){return async N=>{const O=new f.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(x,B,F,M){const K=await w.makeConnection();return I.connect(K,B,F,M)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.ManagedRemoteConnection(0),connectionToken:w.connectionToken})}},signService:this.signService},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await O.waitForReady();const U=new k.Emitter;return{localAddress:(0,i.parseAddress)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{O.dispose(),U.fire(),U.dispose()}}}}};e.NodeExtHostTunnelService=S,e.NodeExtHostTunnelService=S=Ke([Ve(0,n.IExtHostRpcService),Ve(1,m.IExtHostInitDataService),Ve(2,d.ILogService),Ve(3,a.ISignService)],S);class I extends T.ManagedSocket{static connect(w,N,O,U){const x=new A.DisposableStore,B={onClose:x.add(new k.Emitter),onData:x.add(new k.Emitter),onEnd:x.add(new k.Emitter)};x.add(w.onDidReceiveMessage(M=>B.onData.fire(g.VSBuffer.wrap(M)))),x.add(w.onDidEnd(()=>B.onEnd.fire())),x.add(w.onDidClose(M=>B.onClose.fire({type:y.SocketCloseEventType.NodeSocketCloseEvent,error:M,hadError:!!M})));const F=new I(w,U,B);return F._register(x),(0,T.connectManagedSocket)(F,N,O,U,B)}constructor(w,N,O){super(N,O),this.passing=w}write(w){this.passing.send(w.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(we[409],ye([1,0,89,378,392,391,404,407,408,101,53,102,100,46,76,98,377,337,12,393,64,296,112,117,147]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f,m,n,s,i,t,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(P.IExtHostExtensionService,R.ExtHostExtensionService,r.InstantiationType.Eager),(0,r.registerSingleton)(m.ILoggerService,f.ExtHostLoggerService,r.InstantiationType.Delayed),(0,r.registerSingleton)(m.ILogService,new t.SyncDescriptor(i.ExtHostLogService,[!1],!0)),(0,r.registerSingleton)(c.ISignService,h.SignService,r.InstantiationType.Delayed),(0,r.registerSingleton)(a.IExtensionStoragePaths,u.ExtensionStoragePaths,r.InstantiationType.Eager),(0,r.registerSingleton)(l.IExtHostDebugService,A.ExtHostDebugService,r.InstantiationType.Eager),(0,r.registerSingleton)(y.IExtHostSearch,L.NativeExtHostSearch,r.InstantiationType.Eager),(0,r.registerSingleton)(d.IExtHostTask,k.ExtHostTask,r.InstantiationType.Eager),(0,r.registerSingleton)(T.IExtHostTerminalService,g.ExtHostTerminalService,r.InstantiationType.Eager),(0,r.registerSingleton)(E.IExtHostTunnelService,v.NodeExtHostTunnelService,r.InstantiationType.Eager),(0,r.registerSingleton)(s.IExtHostVariableResolverProvider,n.NodeExtHostVariableResolverProviderService,r.InstantiationType.Eager)}),define(we[420],ye([1,0,66,421,62,14,68,130,280,94,390,22,34,110,9,113,302,318,395,409]),function(he,e,r,g,k,A,L,R,v,l,P,y,d,T,E,a,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let D=0;D<process.execArgv.length;D++)process.execArgv[D]==="--inspect-port=0"&&(process.execArgv.splice(D,1),D--)}();const m=g(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const _=globalThis._VSCODE_NODE_MODULES.module,D=_._load;_._load=function(C){if(C==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return D.apply(this,arguments)}})();const n=process.exit.bind(process),s=process.on.bind(process);function i(_){process.exit=function(D){if(_)n(D);else{const C=new Error("An extension called process.exit() and this was prevented.");console.warn(C.stack)}},process.crash=function(){const D=new Error("An extension called process.crash() and this was prevented.");console.warn(D.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(D,C){D==="uncaughtException"&&(C=function(){try{return C.call(void 0,arguments)}catch{}}),s(D,C)}}let t=function(_){n()};function c(){const _=(0,f.readExtHostConnection)(process.env);if(_.type===f.ExtHostConnectionType.MessagePort)return new Promise((D,C)=>{const S=I=>{const b=I[0],w=new L.BufferedEmitter;b.on("message",N=>w.fire(y.VSBuffer.wrap(N.data))),b.on("close",()=>{t("renderer closed the MessagePort")}),b.start(),D({onMessage:w.event,send:N=>b.postMessage(N.buffer)})};process.parentPort.on("message",I=>S(I.ports))});if(_.type===f.ExtHostConnectionType.Socket)return new Promise((D,C)=>{let S=null;const I=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=L.ProtocolConstants.ReconnectionGraceTime,w=L.ProtocolConstants.ReconnectionShortGraceTime,N=new E.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (1)"),b),O=new E.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (2)"),w);process.on("message",(x,B)=>{if(x&&x.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const F=y.VSBuffer.wrap(Buffer.from(x.initialDataChunk,"base64"));let M;if(x.skipWebSocketFrames)M=new R.NodeSocket(B,"extHost-socket");else{const K=y.VSBuffer.wrap(Buffer.from(x.inflateBytes,"base64"));M=new R.WebSocketNodeSocket(new R.NodeSocket(B,"extHost-socket"),x.permessageDeflate,K,!1)}S?(N.cancel(),O.cancel(),S.beginAcceptReconnection(M,F),S.endAcceptReconnection(),S.sendResume()):(clearTimeout(I),S=new L.PersistentProtocol({socket:M,initialChunk:F}),S.sendResume(),S.onDidDispose(()=>t("renderer disconnected")),D(S),S.onSocketClose(()=>{N.schedule()}))}if(x&&x.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;N.isScheduled()&&O.schedule()}});const U={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(U)});{const D=_.pipeName;return new Promise((C,S)=>{const I=r.createConnection(D,()=>{I.removeListener("error",S);const b=new L.PersistentProtocol({socket:new R.NodeSocket(I,"extHost-renderer")});b.sendResume(),C(b)});I.once("error",S),I.on("close",()=>{t("renderer closed the socket")})})}}async function h(){const _=await c();return new class{constructor(){this._onMessage=new L.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,_.onMessage(D=>{(0,l.isMessageOfType)(D,l.MessageType.Terminate)?(this._terminating=!0,t("received terminate message from renderer")):this._onMessage.fire(D)})}send(D){this._terminating||_.send(D)}async drain(){if(_.drain)return _.drain()}}}function o(_){return new Promise(D=>{const C=_.onMessage(S=>{C.dispose();const I=JSON.parse(S.toString()),b=I.commit,w=v.default.commit;if(b&&w&&b!==w&&n(l.ExtensionHostExitCode.VersionMismatch),I.parentPid){let N=0;setInterval(function(){try{process.kill(I.parentPid,0),N=0}catch(U){U&&U.code==="EPERM"?(N++,N>=3&&t(`parent process ${I.parentPid} does not exist anymore (3 x EPERM): ${U.message} (code: ${U.code}) (errno: ${U.errno})`)):t(`parent process ${I.parentPid} does not exist anymore: ${U.message} (code: ${U.code}) (errno: ${U.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(I.parentPid)}catch(U){(0,A.onUnexpectedError)(U)}}_.send((0,l.createMessageOfType)(l.MessageType.Initialized)),D({protocol:_,initData:I})});_.send((0,l.createMessageOfType)(l.MessageType.Ready))})}async function p(){const _=[];process.on("unhandledRejection",(N,O)=>{_.push(O),setTimeout(()=>{const U=_.indexOf(O);U>=0&&O.catch(x=>{_.splice(U,1),(0,A.isCancellationError)(x)||(console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),N&&(0,A.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const O=_.indexOf(N);O>=0&&_.splice(O,1)}),process.on("uncaughtException",function(N){(0,A.isSigPipeError)(N)||(0,A.onUnexpectedError)(N)}),k.mark("code/extHost/willConnectToRenderer");const D=await h();k.mark("code/extHost/didConnectToRenderer");const C=await o(D);k.mark("code/extHost/didWaitForInitData");const{initData:S}=C;i(!!S.environment.extensionTestsLocationURI),S.environment.useHostProxy=m.useHostProxy!==void 0?m.useHostProxy!=="false":void 0,S.environment.skipWorkspaceStorageLock=(0,a.boolean)(m.skipWorkspaceStorageLock,!1);const I=new class{constructor(){this.pid=process.pid}exit(O){n(O)}fsExists(O){return d.Promises.exists(O)}fsRealpath(O){return(0,T.realpath)(O)}};let b=null;S.remote.authority&&m.transformURIs&&(b=(0,u.createURITransformer)(S.remote.authority));const w=new P.ExtensionHostMain(C.protocol,S,I,b);t=N=>w.terminate(N)}p().catch(_=>console.log(_))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d98c6de73fb939f1eb4b8a500c569b858b2d297/core/vs/workbench/api/node/extensionHostProcess.js.map
