/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/iterator","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/uint","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(he){for(var e=[],y=0,k=he.length;y<k;y++)e[y]=De[he[y]];return e};define(De[72],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=k,e.debounce=P,e.throttle=O;function y(A){return(R,v,l)=>{let T=null,b=null;if(typeof l.value=="function"?(T="value",b=l.value):typeof l.get=="function"&&(T="get",b=l.get),!b)throw new Error("not supported");l[T]=A(b,v)}}function k(A,R,v){let l=null,T=null;if(typeof v.value=="function"?(l="value",T=v.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(l="get",T=v.get),!T)throw new Error("not supported");const b=`$memoize$${R}`;v[l]=function(...c){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,c)}),this[b]}}function P(A,R,v){return y((l,T)=>{const b=`$debounce$${T}`,c=`$debounce$result$${T}`;return function(...C){this[c]||(this[c]=v?v():void 0),clearTimeout(this[b]),R&&(this[c]=R(this[c],...C),C=[this[c]]),this[b]=setTimeout(()=>{l.apply(this,C),this[c]=v?v():void 0},A)}})}function O(A,R,v){return y((l,T)=>{const b=`$throttle$timer$${T}`,c=`$throttle$result$${T}`,C=`$throttle$lastRun$${T}`,h=`$throttle$pending$${T}`;return function(...r){if(this[c]||(this[c]=v?v():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),R&&(this[c]=R(this[c],...r)),this[h])return;const o=this[C]+A;o<=Date.now()?(this[C]=Date.now(),l.apply(this,[this[c]]),this[c]=v?v():void 0):(this[h]=!0,this[b]=setTimeout(()=>{this[h]=!1,this[C]=Date.now(),l.apply(this,[this[c]]),this[c]=v?v():void 0},o-Date.now()))}})}}),define(De[133],Ie([1,0,18]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.strictEquals=void 0,e.itemsEquals=P,e.jsonStringifyEquals=O,e.itemEquals=A,e.equalsIfDefined=R,e.structuralEquals=v,e.getStructuralKey=l;const k=(C,h)=>C===h;e.strictEquals=k;function P(C=e.strictEquals){return(h,r)=>y.equals(h,r,C)}function O(){return(C,h)=>JSON.stringify(C)===JSON.stringify(h)}function A(){return(C,h)=>C.equals(h)}function R(C,h,r){return!C||!h?C===h:r(C,h)}function v(C,h){if(C===h)return!0;if(Array.isArray(C)&&Array.isArray(h)){if(C.length!==h.length)return!1;for(let r=0;r<C.length;r++)if(!v(C[r],h[r]))return!1;return!0}if(C&&typeof C=="object"&&h&&typeof h=="object"&&Object.getPrototypeOf(C)===Object.prototype&&Object.getPrototypeOf(h)===Object.prototype){const r=C,o=h,a=Object.keys(r),d=Object.keys(o),t=new Set(d);if(a.length!==d.length)return!1;for(const s of a)if(!t.has(s)||!v(r[s],o[s]))return!1;return!0}return!1}function l(C){return JSON.stringify(c(C))}let T=0;const b=new WeakMap;function c(C){if(Array.isArray(C))return C.map(c);if(C&&typeof C=="object")if(Object.getPrototypeOf(C)===Object.prototype){const h=C,r=Object.create(null);for(const o of Object.keys(h).sort())r[o]=c(h[o]);return r}else{let h=b.get(C);return h===void 0&&(h=T++,b.set(C,h)),h+"----2b76a038c20c4bcc"}return C}}),define(De[96],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class y{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=y,e.defaultGenerator=new y("id#")}),define(De[134],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=A,e.getLocation=b,e.parse=c,e.parseTree=C,e.findNodeAtLocation=h,e.getNodePath=r,e.getNodeValue=o,e.contains=a,e.findNodeAtOffset=d,e.visit=t,e.stripComments=s,e.getNodeType=n;var y;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var k;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(k||(e.SyntaxKind=k={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(i,g=!1){let f=0;const u=i.length;let E="",I=0,_=k.Unknown,w=y.None;function p(V){let $=0,N=0;for(;$<V;){const F=i.charCodeAt(f);if(F>=T._0&&F<=T._9)N=N*16+F-T._0;else if(F>=T.A&&F<=T.F)N=N*16+F-T.A+10;else if(F>=T.a&&F<=T.f)N=N*16+F-T.a+10;else break;f++,$++}return $<V&&(N=-1),N}function D(V){f=V,E="",I=0,_=k.Unknown,w=y.None}function m(){const V=f;if(i.charCodeAt(f)===T._0)f++;else for(f++;f<i.length&&l(i.charCodeAt(f));)f++;if(f<i.length&&i.charCodeAt(f)===T.dot)if(f++,f<i.length&&l(i.charCodeAt(f)))for(f++;f<i.length&&l(i.charCodeAt(f));)f++;else return w=y.UnexpectedEndOfNumber,i.substring(V,f);let $=f;if(f<i.length&&(i.charCodeAt(f)===T.E||i.charCodeAt(f)===T.e))if(f++,(f<i.length&&i.charCodeAt(f)===T.plus||i.charCodeAt(f)===T.minus)&&f++,f<i.length&&l(i.charCodeAt(f))){for(f++;f<i.length&&l(i.charCodeAt(f));)f++;$=f}else w=y.UnexpectedEndOfNumber;return i.substring(V,$)}function S(){let V="",$=f;for(;;){if(f>=u){V+=i.substring($,f),w=y.UnexpectedEndOfString;break}const N=i.charCodeAt(f);if(N===T.doubleQuote){V+=i.substring($,f),f++;break}if(N===T.backslash){if(V+=i.substring($,f),f++,f>=u){w=y.UnexpectedEndOfString;break}switch(i.charCodeAt(f++)){case T.doubleQuote:V+='"';break;case T.backslash:V+="\\";break;case T.slash:V+="/";break;case T.b:V+="\b";break;case T.f:V+="\f";break;case T.n:V+=`
`;break;case T.r:V+="\r";break;case T.t:V+="	";break;case T.u:{const Y=p(4);Y>=0?V+=String.fromCharCode(Y):w=y.InvalidUnicode;break}default:w=y.InvalidEscapeCharacter}$=f;continue}if(N>=0&&N<=31)if(v(N)){V+=i.substring($,f),w=y.UnexpectedEndOfString;break}else w=y.InvalidCharacter;f++}return V}function M(){if(E="",w=y.None,I=f,f>=u)return I=u,_=k.EOF;let V=i.charCodeAt(f);if(R(V)){do f++,E+=String.fromCharCode(V),V=i.charCodeAt(f);while(R(V));return _=k.Trivia}if(v(V))return f++,E+=String.fromCharCode(V),V===T.carriageReturn&&i.charCodeAt(f)===T.lineFeed&&(f++,E+=`
`),_=k.LineBreakTrivia;switch(V){case T.openBrace:return f++,_=k.OpenBraceToken;case T.closeBrace:return f++,_=k.CloseBraceToken;case T.openBracket:return f++,_=k.OpenBracketToken;case T.closeBracket:return f++,_=k.CloseBracketToken;case T.colon:return f++,_=k.ColonToken;case T.comma:return f++,_=k.CommaToken;case T.doubleQuote:return f++,E=S(),_=k.StringLiteral;case T.slash:{const $=f-1;if(i.charCodeAt(f+1)===T.slash){for(f+=2;f<u&&!v(i.charCodeAt(f));)f++;return E=i.substring($,f),_=k.LineCommentTrivia}if(i.charCodeAt(f+1)===T.asterisk){f+=2;const N=u-1;let F=!1;for(;f<N;){if(i.charCodeAt(f)===T.asterisk&&i.charCodeAt(f+1)===T.slash){f+=2,F=!0;break}f++}return F||(f++,w=y.UnexpectedEndOfComment),E=i.substring($,f),_=k.BlockCommentTrivia}return E+=String.fromCharCode(V),f++,_=k.Unknown}case T.minus:if(E+=String.fromCharCode(V),f++,f===u||!l(i.charCodeAt(f)))return _=k.Unknown;case T._0:case T._1:case T._2:case T._3:case T._4:case T._5:case T._6:case T._7:case T._8:case T._9:return E+=m(),_=k.NumericLiteral;default:for(;f<u&&L(V);)f++,V=i.charCodeAt(f);if(I!==f){switch(E=i.substring(I,f),E){case"true":return _=k.TrueKeyword;case"false":return _=k.FalseKeyword;case"null":return _=k.NullKeyword}return _=k.Unknown}return E+=String.fromCharCode(V),f++,_=k.Unknown}}function L(V){if(R(V)||v(V))return!1;switch(V){case T.closeBrace:case T.closeBracket:case T.openBrace:case T.openBracket:case T.doubleQuote:case T.colon:case T.comma:case T.slash:return!1}return!0}function H(){let V;do V=M();while(V>=k.LineCommentTrivia&&V<=k.Trivia);return V}return{setPosition:D,getPosition:()=>f,scan:g?H:M,getToken:()=>_,getTokenValue:()=>E,getTokenOffset:()=>I,getTokenLength:()=>f-I,getTokenError:()=>w}}function R(i){return i===T.space||i===T.tab||i===T.verticalTab||i===T.formFeed||i===T.nonBreakingSpace||i===T.ogham||i>=T.enQuad&&i<=T.zeroWidthSpace||i===T.narrowNoBreakSpace||i===T.mathematicalSpace||i===T.ideographicSpace||i===T.byteOrderMark}function v(i){return i===T.lineFeed||i===T.carriageReturn||i===T.lineSeparator||i===T.paragraphSeparator}function l(i){return i>=T._0&&i<=T._9}var T;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(T||(T={}));function b(i,g){const f=[],u=new Object;let E;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let _=!1;function w(p,D,m,S){I.value=p,I.offset=D,I.length=m,I.type=S,I.colonOffset=void 0,E=I}try{t(i,{onObjectBegin:(p,D)=>{if(g<=p)throw u;E=void 0,_=g>p,f.push("")},onObjectProperty:(p,D,m)=>{if(g<D||(w(p,D,m,"property"),f[f.length-1]=p,g<=D+m))throw u},onObjectEnd:(p,D)=>{if(g<=p)throw u;E=void 0,f.pop()},onArrayBegin:(p,D)=>{if(g<=p)throw u;E=void 0,f.push(0)},onArrayEnd:(p,D)=>{if(g<=p)throw u;E=void 0,f.pop()},onLiteralValue:(p,D,m)=>{if(g<D||(w(p,D,m,n(p)),g<=D+m))throw u},onSeparator:(p,D,m)=>{if(g<=D)throw u;if(p===":"&&E&&E.type==="property")E.colonOffset=D,_=!1,E=void 0;else if(p===","){const S=f[f.length-1];typeof S=="number"?f[f.length-1]=S+1:(_=!0,f[f.length-1]=""),E=void 0}}})}catch(p){if(p!==u)throw p}return{path:f,previousNode:E,isAtPropertyKey:_,matches:p=>{let D=0;for(let m=0;D<p.length&&m<f.length;m++)if(p[D]===f[m]||p[D]==="*")D++;else if(p[D]!=="**")return!1;return D===p.length}}}function c(i,g=[],f=O.DEFAULT){let u=null,E=[];const I=[];function _(p){Array.isArray(E)?E.push(p):u!==null&&(E[u]=p)}return t(i,{onObjectBegin:()=>{const p={};_(p),I.push(E),E=p,u=null},onObjectProperty:p=>{u=p},onObjectEnd:()=>{E=I.pop()},onArrayBegin:()=>{const p=[];_(p),I.push(E),E=p,u=null},onArrayEnd:()=>{E=I.pop()},onLiteralValue:_,onError:(p,D,m)=>{g.push({error:p,offset:D,length:m})}},f),E[0]}function C(i,g=[],f=O.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function E(p){u.type==="property"&&(u.length=p-u.offset,u=u.parent)}function I(p){return u.children.push(p),p}t(i,{onObjectBegin:p=>{u=I({type:"object",offset:p,length:-1,parent:u,children:[]})},onObjectProperty:(p,D,m)=>{u=I({type:"property",offset:D,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:p,offset:D,length:m,parent:u})},onObjectEnd:(p,D)=>{u.length=p+D-u.offset,u=u.parent,E(p+D)},onArrayBegin:(p,D)=>{u=I({type:"array",offset:p,length:-1,parent:u,children:[]})},onArrayEnd:(p,D)=>{u.length=p+D-u.offset,u=u.parent,E(p+D)},onLiteralValue:(p,D,m)=>{I({type:n(p),offset:D,length:m,parent:u,value:p}),E(D+m)},onSeparator:(p,D,m)=>{u.type==="property"&&(p===":"?u.colonOffset=D:p===","&&E(D))},onError:(p,D,m)=>{g.push({error:p,offset:D,length:m})}},f);const w=u.children[0];return w&&delete w.parent,w}function h(i,g){if(!i)return;let f=i;for(const u of g)if(typeof u=="string"){if(f.type!=="object"||!Array.isArray(f.children))return;let E=!1;for(const I of f.children)if(Array.isArray(I.children)&&I.children[0].value===u){f=I.children[1],E=!0;break}if(!E)return}else{const E=u;if(f.type!=="array"||E<0||!Array.isArray(f.children)||E>=f.children.length)return;f=f.children[E]}return f}function r(i){if(!i.parent||!i.parent.children)return[];const g=r(i.parent);if(i.parent.type==="property"){const f=i.parent.children[0].value;g.push(f)}else if(i.parent.type==="array"){const f=i.parent.children.indexOf(i);f!==-1&&g.push(f)}return g}function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const g=Object.create(null);for(const f of i.children){const u=f.children[1];u&&(g[f.children[0].value]=o(u))}return g}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function a(i,g,f=!1){return g>=i.offset&&g<i.offset+i.length||f&&g===i.offset+i.length}function d(i,g,f=!1){if(a(i,g,f)){const u=i.children;if(Array.isArray(u))for(let E=0;E<u.length&&u[E].offset<=g;E++){const I=d(u[E],g,f);if(I)return I}return i}}function t(i,g,f=O.DEFAULT){const u=A(i,!1);function E(ve){return ve?()=>ve(u.getTokenOffset(),u.getTokenLength()):()=>!0}function I(ve){return ve?se=>ve(se,u.getTokenOffset(),u.getTokenLength()):()=>!0}const _=E(g.onObjectBegin),w=I(g.onObjectProperty),p=E(g.onObjectEnd),D=E(g.onArrayBegin),m=E(g.onArrayEnd),S=I(g.onLiteralValue),M=I(g.onSeparator),L=E(g.onComment),H=I(g.onError),V=f&&f.disallowComments,$=f&&f.allowTrailingComma;function N(){for(;;){const ve=u.scan();switch(u.getTokenError()){case y.InvalidUnicode:F(P.InvalidUnicode);break;case y.InvalidEscapeCharacter:F(P.InvalidEscapeCharacter);break;case y.UnexpectedEndOfNumber:F(P.UnexpectedEndOfNumber);break;case y.UnexpectedEndOfComment:V||F(P.UnexpectedEndOfComment);break;case y.UnexpectedEndOfString:F(P.UnexpectedEndOfString);break;case y.InvalidCharacter:F(P.InvalidCharacter);break}switch(ve){case k.LineCommentTrivia:case k.BlockCommentTrivia:V?F(P.InvalidCommentToken):L();break;case k.Unknown:F(P.InvalidSymbol);break;case k.Trivia:case k.LineBreakTrivia:break;default:return ve}}}function F(ve,se=[],Te=[]){if(H(ve),se.length+Te.length>0){let Me=u.getToken();for(;Me!==k.EOF;){if(se.indexOf(Me)!==-1){N();break}else if(Te.indexOf(Me)!==-1)break;Me=N()}}}function Y(ve){const se=u.getTokenValue();return ve?S(se):w(se),N(),!0}function re(){switch(u.getToken()){case k.NumericLiteral:{let ve=0;try{ve=JSON.parse(u.getTokenValue()),typeof ve!="number"&&(F(P.InvalidNumberFormat),ve=0)}catch{F(P.InvalidNumberFormat)}S(ve);break}case k.NullKeyword:S(null);break;case k.TrueKeyword:S(!0);break;case k.FalseKeyword:S(!1);break;default:return!1}return N(),!0}function fe(){return u.getToken()!==k.StringLiteral?(F(P.PropertyNameExpected,[],[k.CloseBraceToken,k.CommaToken]),!1):(Y(!1),u.getToken()===k.ColonToken?(M(":"),N(),pe()||F(P.ValueExpected,[],[k.CloseBraceToken,k.CommaToken])):F(P.ColonExpected,[],[k.CloseBraceToken,k.CommaToken]),!0)}function Ee(){_(),N();let ve=!1;for(;u.getToken()!==k.CloseBraceToken&&u.getToken()!==k.EOF;){if(u.getToken()===k.CommaToken){if(ve||F(P.ValueExpected,[],[]),M(","),N(),u.getToken()===k.CloseBraceToken&&$)break}else ve&&F(P.CommaExpected,[],[]);fe()||F(P.ValueExpected,[],[k.CloseBraceToken,k.CommaToken]),ve=!0}return p(),u.getToken()!==k.CloseBraceToken?F(P.CloseBraceExpected,[k.CloseBraceToken],[]):N(),!0}function oe(){D(),N();let ve=!1;for(;u.getToken()!==k.CloseBracketToken&&u.getToken()!==k.EOF;){if(u.getToken()===k.CommaToken){if(ve||F(P.ValueExpected,[],[]),M(","),N(),u.getToken()===k.CloseBracketToken&&$)break}else ve&&F(P.CommaExpected,[],[]);pe()||F(P.ValueExpected,[],[k.CloseBracketToken,k.CommaToken]),ve=!0}return m(),u.getToken()!==k.CloseBracketToken?F(P.CloseBracketExpected,[k.CloseBracketToken],[]):N(),!0}function pe(){switch(u.getToken()){case k.OpenBracketToken:return oe();case k.OpenBraceToken:return Ee();case k.StringLiteral:return Y(!0);default:return re()}}return N(),u.getToken()===k.EOF?f.allowEmptyContent?!0:(F(P.ValueExpected,[],[]),!1):pe()?(u.getToken()!==k.EOF&&F(P.EndOfFileExpected,[],[]),!0):(F(P.ValueExpected,[],[]),!1)}function s(i,g){const f=A(i),u=[];let E,I=0,_;do switch(_=f.getPosition(),E=f.scan(),E){case k.LineCommentTrivia:case k.BlockCommentTrivia:case k.EOF:I!==_&&u.push(i.substring(I,_)),g!==void 0&&u.push(f.getTokenValue().replace(/[^\r\n]/g,g)),I=f.getPosition();break}while(E!==k.EOF);return u.join("")}function n(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(he,e){typeof define=="function"&&define.amd?define(De[135],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(de,Se){for(var ae=0;ae<Se.length;ae++){var X=Se[ae];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(de,X.key,X)}}function y(de,Se,ae){return Se&&e(de.prototype,Se),ae&&e(de,ae),Object.defineProperty(de,"prototype",{writable:!1}),de}function k(de,Se){if(de){if(typeof de=="string")return P(de,Se);var ae=Object.prototype.toString.call(de).slice(8,-1);if(ae==="Object"&&de.constructor&&(ae=de.constructor.name),ae==="Map"||ae==="Set")return Array.from(de);if(ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ae))return P(de,Se)}}function P(de,Se){(Se==null||Se>de.length)&&(Se=de.length);for(var ae=0,X=new Array(Se);ae<Se;ae++)X[ae]=de[ae];return X}function O(de,Se){var ae=typeof Symbol<"u"&&de[Symbol.iterator]||de["@@iterator"];if(ae)return(ae=ae.call(de)).next.bind(ae);if(Array.isArray(de)||(ae=k(de))||Se&&de&&typeof de.length=="number"){ae&&(de=ae);var X=0;return function(){return X>=de.length?{done:!0}:{done:!1,value:de[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=A();function R(de){he.defaults=de}var v=/[&<>"']/,l=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(Se){return c[Se]};function h(de,Se){if(Se){if(v.test(de))return de.replace(l,C)}else if(T.test(de))return de.replace(b,C);return de}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(de){return de.replace(r,function(Se,ae){return ae=ae.toLowerCase(),ae==="colon"?":":ae.charAt(0)==="#"?ae.charAt(1)==="x"?String.fromCharCode(parseInt(ae.substring(2),16)):String.fromCharCode(+ae.substring(1)):""})}var a=/(^|[^\[])\^/g;function d(de,Se){de=typeof de=="string"?de:de.source,Se=Se||"";var ae={replace:function(J,me){return me=me.source||me,me=me.replace(a,"$1"),de=de.replace(J,me),ae},getRegex:function(){return new RegExp(de,Se)}};return ae}var t=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function n(de,Se,ae){if(de){var X;try{X=decodeURIComponent(o(ae)).replace(t,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}Se&&!s.test(ae)&&(ae=E(Se,ae));try{ae=encodeURI(ae).replace(/%25/g,"%")}catch{return null}return ae}var i={},g=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(de,Se){i[" "+de]||(g.test(de)?i[" "+de]=de+"/":i[" "+de]=p(de,"/",!0)),de=i[" "+de];var ae=de.indexOf(":")===-1;return Se.substring(0,2)==="//"?ae?Se:de.replace(f,"$1")+Se:Se.charAt(0)==="/"?ae?Se:de.replace(u,"$1")+Se:de+Se}var I={exec:function(){}};function _(de){for(var Se=1,ae,X;Se<arguments.length;Se++){ae=arguments[Se];for(X in ae)Object.prototype.hasOwnProperty.call(ae,X)&&(de[X]=ae[X])}return de}function w(de,Se){var ae=de.replace(/\|/g,function(me,ge,Le){for(var ze=!1,ye=ge;--ye>=0&&Le[ye]==="\\";)ze=!ze;return ze?"|":" |"}),X=ae.split(/ \|/),J=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>Se)X.splice(Se);else for(;X.length<Se;)X.push("");for(;J<X.length;J++)X[J]=X[J].trim().replace(/\\\|/g,"|");return X}function p(de,Se,ae){var X=de.length;if(X===0)return"";for(var J=0;J<X;){var me=de.charAt(X-J-1);if(me===Se&&!ae)J++;else if(me!==Se&&ae)J++;else break}return de.slice(0,X-J)}function D(de,Se){if(de.indexOf(Se[1])===-1)return-1;for(var ae=de.length,X=0,J=0;J<ae;J++)if(de[J]==="\\")J++;else if(de[J]===Se[0])X++;else if(de[J]===Se[1]&&(X--,X<0))return J;return-1}function m(de){de&&de.sanitize&&!de.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function S(de,Se){if(Se<1)return"";for(var ae="";Se>1;)Se&1&&(ae+=de),Se>>=1,de+=de;return ae+de}function M(de,Se,ae,X){var J=Se.href,me=Se.title?h(Se.title):null,ge=de[1].replace(/\\([\[\]])/g,"$1");if(de[0].charAt(0)!=="!"){X.state.inLink=!0;var Le={type:"link",raw:ae,href:J,title:me,text:ge,tokens:X.inlineTokens(ge)};return X.state.inLink=!1,Le}return{type:"image",raw:ae,href:J,title:me,text:h(ge)}}function L(de,Se){var ae=de.match(/^(\s+)(?:```)/);if(ae===null)return Se;var X=ae[1];return Se.split(`
`).map(function(J){var me=J.match(/^\s+/);if(me===null)return J;var ge=me[0];return ge.length>=X.length?J.slice(X.length):J}).join(`
`)}var H=function(){function de(ae){this.options=ae||he.defaults}var Se=de.prototype;return Se.space=function(X){var J=this.rules.block.newline.exec(X);if(J&&J[0].length>0)return{type:"space",raw:J[0]}},Se.code=function(X){var J=this.rules.block.code.exec(X);if(J){var me=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?me:p(me,`
`)}}},Se.fences=function(X){var J=this.rules.block.fences.exec(X);if(J){var me=J[0],ge=L(me,J[3]||"");return{type:"code",raw:me,lang:J[2]?J[2].trim():J[2],text:ge}}},Se.heading=function(X){var J=this.rules.block.heading.exec(X);if(J){var me=J[2].trim();if(/#$/.test(me)){var ge=p(me,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(me=ge.trim())}return{type:"heading",raw:J[0],depth:J[1].length,text:me,tokens:this.lexer.inline(me)}}},Se.hr=function(X){var J=this.rules.block.hr.exec(X);if(J)return{type:"hr",raw:J[0]}},Se.blockquote=function(X){var J=this.rules.block.blockquote.exec(X);if(J){var me=J[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:J[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},Se.list=function(X){var J=this.rules.block.list.exec(X);if(J){var me,ge,Le,ze,ye,ke,Oe,B,x,q,K,te,ue=J[1].trim(),Ae=ue.length>1,Be={type:"list",raw:"",ordered:Ae,start:Ae?+ue.slice(0,-1):"",loose:!1,items:[]};ue=Ae?"\\d{1,9}\\"+ue.slice(-1):"\\"+ue,this.options.pedantic&&(ue=Ae?ue:"[*+-]");for(var He=new RegExp("^( {0,3}"+ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(te=!1,!(!(J=He.exec(X))||this.rules.block.hr.test(X)));){if(me=J[0],X=X.substring(me.length),B=J[2].split(`
`,1)[0],x=X.split(`
`,1)[0],this.options.pedantic?(ze=2,K=B.trimLeft()):(ze=J[2].search(/[^ ]/),ze=ze>4?1:ze,K=B.slice(ze),ze+=J[1].length),ke=!1,!B&&/^ *$/.test(x)&&(me+=x+`
`,X=X.substring(x.length+1),te=!0),!te)for(var Ye=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ze=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");X&&(q=X.split(`
`,1)[0],B=q,this.options.pedantic&&(B=B.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ze.test(B)||it.test(B)||Ye.test(B)||tt.test(X)));){if(B.search(/[^ ]/)>=ze||!B.trim())K+=`
`+B.slice(ze);else if(!ke)K+=`
`+B;else break;!ke&&!B.trim()&&(ke=!0),me+=q+`
`,X=X.substring(q.length+1)}Be.loose||(Oe?Be.loose=!0:/\n *\n *$/.test(me)&&(Oe=!0)),this.options.gfm&&(ge=/^\[[ xX]\] /.exec(K),ge&&(Le=ge[0]!=="[ ] ",K=K.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:me,task:!!ge,checked:Le,loose:!1,text:K}),Be.raw+=me}Be.items[Be.items.length-1].raw=me.trimRight(),Be.items[Be.items.length-1].text=K.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(ye=0;ye<nt;ye++){this.lexer.state.top=!1,Be.items[ye].tokens=this.lexer.blockTokens(Be.items[ye].text,[]);var mt=Be.items[ye].tokens.filter(function(rt){return rt.type==="space"}),ut=mt.every(function(rt){for(var at=rt.raw.split(""),ht=0,We=O(at),xe;!(xe=We()).done;){var Z=xe.value;if(Z===`
`&&(ht+=1),ht>1)return!0}return!1});!Be.loose&&mt.length&&ut&&(Be.loose=!0,Be.items[ye].loose=!0)}return Be}},Se.html=function(X){var J=this.rules.block.html.exec(X);if(J){var me={type:"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:J[0]};if(this.options.sanitize){var ge=this.options.sanitizer?this.options.sanitizer(J[0]):h(J[0]);me.type="paragraph",me.text=ge,me.tokens=this.lexer.inline(ge)}return me}},Se.def=function(X){var J=this.rules.block.def.exec(X);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var me=J[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:J[0],href:J[2],title:J[3]}}},Se.table=function(X){var J=this.rules.block.table.exec(X);if(J){var me={type:"table",header:w(J[1]).map(function(Oe){return{text:Oe}}),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:J[3]&&J[3].trim()?J[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=J[0];var ge=me.align.length,Le,ze,ye,ke;for(Le=0;Le<ge;Le++)/^ *-+: *$/.test(me.align[Le])?me.align[Le]="right":/^ *:-+: *$/.test(me.align[Le])?me.align[Le]="center":/^ *:-+ *$/.test(me.align[Le])?me.align[Le]="left":me.align[Le]=null;for(ge=me.rows.length,Le=0;Le<ge;Le++)me.rows[Le]=w(me.rows[Le],me.header.length).map(function(Oe){return{text:Oe}});for(ge=me.header.length,ze=0;ze<ge;ze++)me.header[ze].tokens=this.lexer.inline(me.header[ze].text);for(ge=me.rows.length,ze=0;ze<ge;ze++)for(ke=me.rows[ze],ye=0;ye<ke.length;ye++)ke[ye].tokens=this.lexer.inline(ke[ye].text);return me}}},Se.lheading=function(X){var J=this.rules.block.lheading.exec(X);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1],tokens:this.lexer.inline(J[1])}},Se.paragraph=function(X){var J=this.rules.block.paragraph.exec(X);if(J){var me=J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1];return{type:"paragraph",raw:J[0],text:me,tokens:this.lexer.inline(me)}}},Se.text=function(X){var J=this.rules.block.text.exec(X);if(J)return{type:"text",raw:J[0],text:J[0],tokens:this.lexer.inline(J[0])}},Se.escape=function(X){var J=this.rules.inline.escape.exec(X);if(J)return{type:"escape",raw:J[0],text:h(J[1])}},Se.tag=function(X){var J=this.rules.inline.tag.exec(X);if(J)return!this.lexer.state.inLink&&/^<a /i.test(J[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(J[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):h(J[0]):J[0]}},Se.link=function(X){var J=this.rules.inline.link.exec(X);if(J){var me=J[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var ge=p(me.slice(0,-1),"\\");if((me.length-ge.length)%2===0)return}else{var Le=D(J[2],"()");if(Le>-1){var ze=J[0].indexOf("!")===0?5:4,ye=ze+J[1].length+Le;J[2]=J[2].substring(0,Le),J[0]=J[0].substring(0,ye).trim(),J[3]=""}}var ke=J[2],Oe="";if(this.options.pedantic){var B=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ke);B&&(ke=B[1],Oe=B[3])}else Oe=J[3]?J[3].slice(1,-1):"";return ke=ke.trim(),/^</.test(ke)&&(this.options.pedantic&&!/>$/.test(me)?ke=ke.slice(1):ke=ke.slice(1,-1)),M(J,{href:ke&&ke.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},J[0],this.lexer)}},Se.reflink=function(X,J){var me;if((me=this.rules.inline.reflink.exec(X))||(me=this.rules.inline.nolink.exec(X))){var ge=(me[2]||me[1]).replace(/\s+/g," ");if(ge=J[ge.toLowerCase()],!ge||!ge.href){var Le=me[0].charAt(0);return{type:"text",raw:Le,text:Le}}return M(me,ge,me[0],this.lexer)}},Se.emStrong=function(X,J,me){me===void 0&&(me="");var ge=this.rules.inline.emStrong.lDelim.exec(X);if(ge&&!(ge[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Le=ge[1]||ge[2]||"";if(!Le||Le&&(me===""||this.rules.inline.punctuation.exec(me))){var ze=ge[0].length-1,ye,ke,Oe=ze,B=0,x=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(x.lastIndex=0,J=J.slice(-1*X.length+ze);(ge=x.exec(J))!=null;)if(ye=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!ye){if(ke=ye.length,ge[3]||ge[4]){Oe+=ke;continue}else if((ge[5]||ge[6])&&ze%3&&!((ze+ke)%3)){B+=ke;continue}if(Oe-=ke,!(Oe>0)){if(ke=Math.min(ke,ke+Oe+B),Math.min(ze,ke)%2){var q=X.slice(1,ze+ge.index+ke);return{type:"em",raw:X.slice(0,ze+ge.index+ke+1),text:q,tokens:this.lexer.inlineTokens(q)}}var K=X.slice(2,ze+ge.index+ke-1);return{type:"strong",raw:X.slice(0,ze+ge.index+ke+1),text:K,tokens:this.lexer.inlineTokens(K)}}}}}},Se.codespan=function(X){var J=this.rules.inline.code.exec(X);if(J){var me=J[2].replace(/\n/g," "),ge=/[^ ]/.test(me),Le=/^ /.test(me)&&/ $/.test(me);return ge&&Le&&(me=me.substring(1,me.length-1)),me=h(me,!0),{type:"codespan",raw:J[0],text:me}}},Se.br=function(X){var J=this.rules.inline.br.exec(X);if(J)return{type:"br",raw:J[0]}},Se.del=function(X){var J=this.rules.inline.del.exec(X);if(J)return{type:"del",raw:J[0],text:J[2],tokens:this.lexer.inlineTokens(J[2])}},Se.autolink=function(X,J){var me=this.rules.inline.autolink.exec(X);if(me){var ge,Le;return me[2]==="@"?(ge=h(this.options.mangle?J(me[1]):me[1]),Le="mailto:"+ge):(ge=h(me[1]),Le=ge),{type:"link",raw:me[0],text:ge,href:Le,tokens:[{type:"text",raw:ge,text:ge}]}}},Se.url=function(X,J){var me;if(me=this.rules.inline.url.exec(X)){var ge,Le;if(me[2]==="@")ge=h(this.options.mangle?J(me[0]):me[0]),Le="mailto:"+ge;else{var ze;do ze=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(ze!==me[0]);ge=h(me[0]),me[1]==="www."?Le="http://"+ge:Le=ge}return{type:"link",raw:me[0],text:ge,href:Le,tokens:[{type:"text",raw:ge,text:ge}]}}},Se.inlineText=function(X,J){var me=this.rules.inline.text.exec(X);if(me){var ge;return this.lexer.state.inRawBlock?ge=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):h(me[0]):me[0]:ge=h(this.options.smartypants?J(me[0]):me[0]),{type:"text",raw:me[0],text:ge}}},de}(),V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=d(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=d(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=d(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=d(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=d(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=d(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=_({},V),V.gfm=_({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=d(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.gfm.paragraph=d(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",V.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=_({},V.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:d(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var $={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};$._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",$.punctuation=d($.punctuation).replace(/punctuation/g,$._punctuation).getRegex(),$.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,$.escapedEmSt=/\\\*|\\_/g,$._comment=d(V._comment).replace("(?:-->|$)","-->").getRegex(),$.emStrong.lDelim=d($.emStrong.lDelim).replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimAst=d($.emStrong.rDelimAst,"g").replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimUnd=d($.emStrong.rDelimUnd,"g").replace(/punct/g,$._punctuation).getRegex(),$._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,$._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,$._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,$.autolink=d($.autolink).replace("scheme",$._scheme).replace("email",$._email).getRegex(),$._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,$.tag=d($.tag).replace("comment",$._comment).replace("attribute",$._attribute).getRegex(),$._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,$._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,$._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,$.link=d($.link).replace("label",$._label).replace("href",$._href).replace("title",$._title).getRegex(),$.reflink=d($.reflink).replace("label",$._label).replace("ref",V._label).getRegex(),$.nolink=d($.nolink).replace("ref",V._label).getRegex(),$.reflinkSearch=d($.reflinkSearch,"g").replace("reflink",$.reflink).replace("nolink",$.nolink).getRegex(),$.normal=_({},$),$.pedantic=_({},$.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",$._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",$._label).getRegex()}),$.gfm=_({},$.normal,{escape:d($.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),$.gfm.url=d($.gfm.url,"i").replace("email",$.gfm._extended_email).getRegex(),$.breaks=_({},$.gfm,{br:d($.br).replace("{2,}","*").getRegex(),text:d($.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(de){return de.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(de){var Se="",ae,X,J=de.length;for(ae=0;ae<J;ae++)X=de.charCodeAt(ae),Math.random()>.5&&(X="x"+X.toString(16)),Se+="&#"+X+";";return Se}var Y=function(){function de(ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=ae||he.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:V.normal,inline:$.normal};this.options.pedantic?(X.block=V.pedantic,X.inline=$.pedantic):this.options.gfm&&(X.block=V.gfm,this.options.breaks?X.inline=$.breaks:X.inline=$.gfm),this.tokenizer.rules=X}de.lex=function(X,J){var me=new de(J);return me.lex(X)},de.lexInline=function(X,J){var me=new de(J);return me.inlineTokens(X)};var Se=de.prototype;return Se.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var J;J=this.inlineQueue.shift();)this.inlineTokens(J.src,J.tokens);return this.tokens},Se.blockTokens=function(X,J){var me=this;J===void 0&&(J=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Oe,B,x){return B+"    ".repeat(x.length)});for(var ge,Le,ze,ye;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return(ge=Oe.call({lexer:me},X,J))?(X=X.substring(ge.raw.length),J.push(ge),!0):!1}))){if(ge=this.tokenizer.space(X)){X=X.substring(ge.raw.length),ge.raw.length===1&&J.length>0?J[J.length-1].raw+=`
`:J.push(ge);continue}if(ge=this.tokenizer.code(X)){X=X.substring(ge.raw.length),Le=J[J.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+ge.raw,Le.text+=`
`+ge.text,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):J.push(ge);continue}if(ge=this.tokenizer.fences(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.heading(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.hr(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.blockquote(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.list(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.html(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.def(X)){X=X.substring(ge.raw.length),Le=J[J.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+ge.raw,Le.text+=`
`+ge.raw,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.lheading(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ze=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,B=X.slice(1),x=void 0;me.options.extensions.startBlock.forEach(function(q){x=q.call({lexer:this},B),typeof x=="number"&&x>=0&&(Oe=Math.min(Oe,x))}),Oe<1/0&&Oe>=0&&(ze=X.substring(0,Oe+1))}(),this.state.top&&(ge=this.tokenizer.paragraph(ze))){Le=J[J.length-1],ye&&Le.type==="paragraph"?(Le.raw+=`
`+ge.raw,Le.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):J.push(ge),ye=ze.length!==X.length,X=X.substring(ge.raw.length);continue}if(ge=this.tokenizer.text(X)){X=X.substring(ge.raw.length),Le=J[J.length-1],Le&&Le.type==="text"?(Le.raw+=`
`+ge.raw,Le.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):J.push(ge);continue}if(X){var ke="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return this.state.top=!0,J},Se.inline=function(X,J){return J===void 0&&(J=[]),this.inlineQueue.push({src:X,tokens:J}),J},Se.inlineTokens=function(X,J){var me=this;J===void 0&&(J=[]);var ge,Le,ze,ye=X,ke,Oe,B;if(this.tokens.links){var x=Object.keys(this.tokens.links);if(x.length>0)for(;(ke=this.tokenizer.rules.inline.reflinkSearch.exec(ye))!=null;)x.includes(ke[0].slice(ke[0].lastIndexOf("[")+1,-1))&&(ye=ye.slice(0,ke.index)+"["+S("a",ke[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ke=this.tokenizer.rules.inline.blockSkip.exec(ye))!=null;)ye=ye.slice(0,ke.index)+"["+S("a",ke[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ke=this.tokenizer.rules.inline.escapedEmSt.exec(ye))!=null;)ye=ye.slice(0,ke.index)+"++"+ye.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Oe||(B=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(K){return(ge=K.call({lexer:me},X,J))?(X=X.substring(ge.raw.length),J.push(ge),!0):!1}))){if(ge=this.tokenizer.escape(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.tag(X)){X=X.substring(ge.raw.length),Le=J[J.length-1],Le&&ge.type==="text"&&Le.type==="text"?(Le.raw+=ge.raw,Le.text+=ge.text):J.push(ge);continue}if(ge=this.tokenizer.link(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(ge.raw.length),Le=J[J.length-1],Le&&ge.type==="text"&&Le.type==="text"?(Le.raw+=ge.raw,Le.text+=ge.text):J.push(ge);continue}if(ge=this.tokenizer.emStrong(X,ye,B)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.codespan(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.br(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.del(X)){X=X.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.autolink(X,F)){X=X.substring(ge.raw.length),J.push(ge);continue}if(!this.state.inLink&&(ge=this.tokenizer.url(X,F))){X=X.substring(ge.raw.length),J.push(ge);continue}if(ze=X,this.options.extensions&&this.options.extensions.startInline&&function(){var K=1/0,te=X.slice(1),ue=void 0;me.options.extensions.startInline.forEach(function(Ae){ue=Ae.call({lexer:this},te),typeof ue=="number"&&ue>=0&&(K=Math.min(K,ue))}),K<1/0&&K>=0&&(ze=X.substring(0,K+1))}(),ge=this.tokenizer.inlineText(ze,N)){X=X.substring(ge.raw.length),ge.raw.slice(-1)!=="_"&&(B=ge.raw.slice(-1)),Oe=!0,Le=J[J.length-1],Le&&Le.type==="text"?(Le.raw+=ge.raw,Le.text+=ge.text):J.push(ge);continue}if(X){var q="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return J},y(de,null,[{key:"rules",get:function(){return{block:V,inline:$}}}]),de}(),re=function(){function de(ae){this.options=ae||he.defaults}var Se=de.prototype;return Se.code=function(X,J,me){var ge=(J||"").match(/\S*/)[0];if(this.options.highlight){var Le=this.options.highlight(X,ge);Le!=null&&Le!==X&&(me=!0,X=Le)}return X=X.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+h(ge,!0)+'">'+(me?X:h(X,!0))+`</code></pre>
`:"<pre><code>"+(me?X:h(X,!0))+`</code></pre>
`},Se.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},Se.html=function(X){return X},Se.heading=function(X,J,me,ge){if(this.options.headerIds){var Le=this.options.headerPrefix+ge.slug(me);return"<h"+J+' id="'+Le+'">'+X+"</h"+J+`>
`}return"<h"+J+">"+X+"</h"+J+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(X,J,me){var ge=J?"ol":"ul",Le=J&&me!==1?' start="'+me+'"':"";return"<"+ge+Le+`>
`+X+"</"+ge+`>
`},Se.listitem=function(X){return"<li>"+X+`</li>
`},Se.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(X){return"<p>"+X+`</p>
`},Se.table=function(X,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+J+`</table>
`},Se.tablerow=function(X){return`<tr>
`+X+`</tr>
`},Se.tablecell=function(X,J){var me=J.header?"th":"td",ge=J.align?"<"+me+' align="'+J.align+'">':"<"+me+">";return ge+X+("</"+me+`>
`)},Se.strong=function(X){return"<strong>"+X+"</strong>"},Se.em=function(X){return"<em>"+X+"</em>"},Se.codespan=function(X){return"<code>"+X+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(X){return"<del>"+X+"</del>"},Se.link=function(X,J,me){if(X=n(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var ge='<a href="'+h(X)+'"';return J&&(ge+=' title="'+J+'"'),ge+=">"+me+"</a>",ge},Se.image=function(X,J,me){if(X=n(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var ge='<img src="'+X+'" alt="'+me+'"';return J&&(ge+=' title="'+J+'"'),ge+=this.options.xhtml?"/>":">",ge},Se.text=function(X){return X},de}(),fe=function(){function de(){}var Se=de.prototype;return Se.strong=function(X){return X},Se.em=function(X){return X},Se.codespan=function(X){return X},Se.del=function(X){return X},Se.html=function(X){return X},Se.text=function(X){return X},Se.link=function(X,J,me){return""+me},Se.image=function(X,J,me){return""+me},Se.br=function(){return""},de}(),Ee=function(){function de(){this.seen={}}var Se=de.prototype;return Se.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(X,J){var me=X,ge=0;if(this.seen.hasOwnProperty(me)){ge=this.seen[X];do ge++,me=X+"-"+ge;while(this.seen.hasOwnProperty(me))}return J||(this.seen[X]=ge,this.seen[me]=0),me},Se.slug=function(X,J){J===void 0&&(J={});var me=this.serialize(X);return this.getNextSafeSlug(me,J.dryrun)},de}(),oe=function(){function de(ae){this.options=ae||he.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new Ee}de.parse=function(X,J){var me=new de(J);return me.parse(X)},de.parseInline=function(X,J){var me=new de(J);return me.parseInline(X)};var Se=de.prototype;return Se.parse=function(X,J){J===void 0&&(J=!0);var me="",ge,Le,ze,ye,ke,Oe,B,x,q,K,te,ue,Ae,Be,He,Ye,tt,Ze,it,nt=X.length;for(ge=0;ge<nt;ge++){if(K=X[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[K.type]&&(it=this.options.extensions.renderers[K.type].call({parser:this},K),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(K.type))){me+=it||"";continue}switch(K.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(K.tokens),K.depth,o(this.parseInline(K.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(K.text,K.lang,K.escaped);continue}case"table":{for(x="",B="",ye=K.header.length,Le=0;Le<ye;Le++)B+=this.renderer.tablecell(this.parseInline(K.header[Le].tokens),{header:!0,align:K.align[Le]});for(x+=this.renderer.tablerow(B),q="",ye=K.rows.length,Le=0;Le<ye;Le++){for(Oe=K.rows[Le],B="",ke=Oe.length,ze=0;ze<ke;ze++)B+=this.renderer.tablecell(this.parseInline(Oe[ze].tokens),{header:!1,align:K.align[ze]});q+=this.renderer.tablerow(B)}me+=this.renderer.table(x,q);continue}case"blockquote":{q=this.parse(K.tokens),me+=this.renderer.blockquote(q);continue}case"list":{for(te=K.ordered,ue=K.start,Ae=K.loose,ye=K.items.length,q="",Le=0;Le<ye;Le++)He=K.items[Le],Ye=He.checked,tt=He.task,Be="",He.task&&(Ze=this.renderer.checkbox(Ye),Ae?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=Ze+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=Ze+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:Ze}):Be+=Ze),Be+=this.parse(He.tokens,Ae),q+=this.renderer.listitem(Be,tt,Ye);me+=this.renderer.list(q,te,ue);continue}case"html":{me+=this.renderer.html(K.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(K.tokens));continue}case"text":{for(q=K.tokens?this.parseInline(K.tokens):K.text;ge+1<nt&&X[ge+1].type==="text";)K=X[++ge],q+=`
`+(K.tokens?this.parseInline(K.tokens):K.text);me+=J?this.renderer.paragraph(q):q;continue}default:{var mt='Token with "'+K.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return me},Se.parseInline=function(X,J){J=J||this.renderer;var me="",ge,Le,ze,ye=X.length;for(ge=0;ge<ye;ge++){if(Le=X[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Le.type]&&(ze=this.options.extensions.renderers[Le.type].call({parser:this},Le),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Le.type))){me+=ze||"";continue}switch(Le.type){case"escape":{me+=J.text(Le.text);break}case"html":{me+=J.html(Le.text);break}case"link":{me+=J.link(Le.href,Le.title,this.parseInline(Le.tokens,J));break}case"image":{me+=J.image(Le.href,Le.title,Le.text);break}case"strong":{me+=J.strong(this.parseInline(Le.tokens,J));break}case"em":{me+=J.em(this.parseInline(Le.tokens,J));break}case"codespan":{me+=J.codespan(Le.text);break}case"br":{me+=J.br();break}case"del":{me+=J.del(this.parseInline(Le.tokens,J));break}case"text":{me+=J.text(Le.text);break}default:{var ke='Token with "'+Le.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return me},de}();function pe(de,Se,ae){if(typeof de>"u"||de===null)throw new Error("marked(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");if(typeof Se=="function"&&(ae=Se,Se=null),Se=_({},pe.defaults,Se||{}),m(Se),ae){var X=Se.highlight,J;try{J=Y.lex(de,Se)}catch(ye){return ae(ye)}var me=function(ke){var Oe;if(!ke)try{Se.walkTokens&&pe.walkTokens(J,Se.walkTokens),Oe=oe.parse(J,Se)}catch(B){ke=B}return Se.highlight=X,ke?ae(ke):ae(null,Oe)};if(!X||X.length<3||(delete Se.highlight,!J.length))return me();var ge=0;pe.walkTokens(J,function(ye){ye.type==="code"&&(ge++,setTimeout(function(){X(ye.text,ye.lang,function(ke,Oe){if(ke)return me(ke);Oe!=null&&Oe!==ye.text&&(ye.text=Oe,ye.escaped=!0),ge--,ge===0&&me()})},0))}),ge===0&&me();return}function Le(ye){if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+h(ye.message+"",!0)+"</pre>";throw ye}try{var ze=Y.lex(de,Se);if(Se.walkTokens){if(Se.async)return Promise.all(pe.walkTokens(ze,Se.walkTokens)).then(function(){return oe.parse(ze,Se)}).catch(Le);pe.walkTokens(ze,Se.walkTokens)}return oe.parse(ze,Se)}catch(ye){Le(ye)}}pe.options=pe.setOptions=function(de){return _(pe.defaults,de),R(pe.defaults),pe},pe.getDefaults=A,pe.defaults=he.defaults,pe.use=function(){for(var de=arguments.length,Se=new Array(de),ae=0;ae<de;ae++)Se[ae]=arguments[ae];var X=_.apply(void 0,[{}].concat(Se)),J=pe.defaults.extensions||{renderers:{},childTokens:{}},me;Se.forEach(function(ge){if(ge.extensions&&(me=!0,ge.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var ye=J.renderers?J.renderers[ze.name]:null;ye?J.renderers[ze.name]=function(){for(var ke=arguments.length,Oe=new Array(ke),B=0;B<ke;B++)Oe[B]=arguments[B];var x=ze.renderer.apply(this,Oe);return x===!1&&(x=ye.apply(this,Oe)),x}:J.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");J[ze.level]?J[ze.level].unshift(ze.tokenizer):J[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?J.startBlock?J.startBlock.push(ze.start):J.startBlock=[ze.start]:ze.level==="inline"&&(J.startInline?J.startInline.push(ze.start):J.startInline=[ze.start]))}ze.childTokens&&(J.childTokens[ze.name]=ze.childTokens)})),ge.renderer&&function(){var ze=pe.defaults.renderer||new re,ye=function(B){var x=ze[B];ze[B]=function(){for(var q=arguments.length,K=new Array(q),te=0;te<q;te++)K[te]=arguments[te];var ue=ge.renderer[B].apply(ze,K);return ue===!1&&(ue=x.apply(ze,K)),ue}};for(var ke in ge.renderer)ye(ke);X.renderer=ze}(),ge.tokenizer&&function(){var ze=pe.defaults.tokenizer||new H,ye=function(B){var x=ze[B];ze[B]=function(){for(var q=arguments.length,K=new Array(q),te=0;te<q;te++)K[te]=arguments[te];var ue=ge.tokenizer[B].apply(ze,K);return ue===!1&&(ue=x.apply(ze,K)),ue}};for(var ke in ge.tokenizer)ye(ke);X.tokenizer=ze}(),ge.walkTokens){var Le=pe.defaults.walkTokens;X.walkTokens=function(ze){var ye=[];return ye.push(ge.walkTokens.call(this,ze)),Le&&(ye=ye.concat(Le.call(this,ze))),ye}}me&&(X.extensions=J),pe.setOptions(X)})},pe.walkTokens=function(de,Se){for(var ae=[],X=function(){var Le=me.value;switch(ae=ae.concat(Se.call(pe,Le)),Le.type){case"table":{for(var ze=O(Le.header),ye;!(ye=ze()).done;){var ke=ye.value;ae=ae.concat(pe.walkTokens(ke.tokens,Se))}for(var Oe=O(Le.rows),B;!(B=Oe()).done;)for(var x=B.value,q=O(x),K;!(K=q()).done;){var te=K.value;ae=ae.concat(pe.walkTokens(te.tokens,Se))}break}case"list":{ae=ae.concat(pe.walkTokens(Le.items,Se));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Le.type]?pe.defaults.extensions.childTokens[Le.type].forEach(function(ue){ae=ae.concat(pe.walkTokens(Le[ue],Se))}):Le.tokens&&(ae=ae.concat(pe.walkTokens(Le.tokens,Se)))}},J=O(de),me;!(me=J()).done;)X();return ae},pe.parseInline=function(de,Se){if(typeof de>"u"||de===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");Se=_({},pe.defaults,Se||{}),m(Se);try{var ae=Y.lexInline(de,Se);return Se.walkTokens&&pe.walkTokens(ae,Se.walkTokens),oe.parseInline(ae,Se)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+h(X.message+"",!0)+"</pre>";throw X}},pe.Parser=oe,pe.parser=oe.parse,pe.Renderer=re,pe.TextRenderer=fe,pe.Lexer=Y,pe.lexer=Y.lex,pe.Tokenizer=H,pe.Slugger=Ee,pe.parse=pe;var ve=pe.options,se=pe.setOptions,Te=pe.use,Me=pe.walkTokens,Q=pe.parseInline,W=pe,ie=oe.parse,_e=Y.lex;he.Lexer=Y,he.Parser=oe,he.Renderer=re,he.Slugger=Ee,he.TextRenderer=fe,he.Tokenizer=H,he.getDefaults=A,he.lexer=_e,he.marked=pe,he.options=ve,he.parse=W,he.parseInline=Q,he.parser=ie,he.setOptions=se,he.use=Te,he.walkTokens=Me,Object.defineProperty(he,"__esModule",{value:!0})}),define(De[136],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=y;function y(r){const o=O(r);if(o&&o.length>0)return new Uint32Array(o)}let k=0;const P=new Uint32Array(10);function O(r){if(k=0,A(r,b,v.InitialConsonant),k>0||(A(r,c,v.Vowel),k>0)||(A(r,C,v.FinalConsonant),k>0)||(A(r,h,v.CompatibilityJamo),k))return P.subarray(0,k);if(r>=44032&&r<=55203){const o=r-44032,a=o%588,d=Math.floor(o/588),t=Math.floor(a/28),s=a%28-1;if(d<b.length?A(d,b,0):v.InitialConsonant+d-v.CompatibilityJamo<h.length&&A(v.InitialConsonant+d,h,v.CompatibilityJamo),t<c.length?A(t,c,0):v.Vowel+t-v.CompatibilityJamo<h.length&&A(v.Vowel+t-v.CompatibilityJamo,h,v.CompatibilityJamo),s>=0&&(s<C.length?A(s,C,0):v.FinalConsonant+s-v.CompatibilityJamo<h.length&&A(v.FinalConsonant+s-v.CompatibilityJamo,h,v.CompatibilityJamo)),k>0)return P.subarray(0,k)}}function A(r,o,a){r>=a&&r<a+o.length&&R(o[r-a])}function R(r){r!==l.NUL&&(P[k++]=r&255,r>>8&&(P[k++]=r>>8&255),r>>16&&(P[k++]=r>>16&255))}var v;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var l;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(l||(l={}));var T;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(T||(T={}));const b=new Uint8Array([l.r,l.R,l.s,l.e,l.E,l.f,l.a,l.q,l.Q,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g]),c=new Uint16Array([l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,T.hk,T.ho,T.hl,l.y,l.n,T.nj,T.np,T.nl,l.b,l.m,T.ml,l.l]),C=new Uint16Array([l.r,l.R,T.rt,l.s,T.sw,T.sg,l.e,l.f,T.fr,T.fa,T.fq,T.ft,T.fx,T.fv,T.fg,l.a,l.q,T.qt,l.t,l.T,l.d,l.w,l.c,l.z,l.x,l.v,l.g]),h=new Uint16Array([l.r,l.R,T.rt,l.s,T.sw,T.sg,l.e,l.E,l.f,T.fr,T.fa,T.fq,T.ft,T.fx,T.fv,T.fg,l.a,l.q,l.Q,T.qt,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g,l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,T.hk,T.ho,T.hl,l.y,l.n,T.nj,T.np,T.nl,l.b,l.m,T.ml,l.l])}),define(De[137],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=y,e.rot=k;function y(R,v,l){return Math.min(Math.max(R,v),l)}function k(R,v){return(v+R%v)%v}class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class O{constructor(){this._n=1,this._val=0}update(v){return this._val=this._val+(v-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=O;class A{constructor(v){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(v),this._values.fill(0,0,v)}update(v){const l=this._values[this._index];return this._values[this._index]=v,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=v,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),define(De[138],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=O,e.getFunctionName=c;class y{constructor(h,r,o){this.owner=h,this.debugNameSource=r,this.referenceFn=o}getDebugName(h){return O(h,this)}}e.DebugNameData=y;const k=new Map,P=new WeakMap;function O(C,h){const r=P.get(C);if(r)return r;const o=A(C,h);if(o){let a=k.get(o)??0;a++,k.set(o,a);const d=a===1?o:`${o}#${a}`;return P.set(C,d),d}}function A(C,h){const r=P.get(C);if(r)return r;const o=h.owner?T(h.owner)+".":"";let a;const d=h.debugNameSource;if(d!==void 0)if(typeof d=="function"){if(a=d(),a!==void 0)return o+a}else return o+d;const t=h.referenceFn;if(t!==void 0&&(a=c(t),a!==void 0))return o+a;if(h.owner!==void 0){const s=R(h.owner,C);if(s!==void 0)return o+s}}function R(C,h){for(const r in C)if(C[r]===h)return r}const v=new Map,l=new WeakMap;function T(C){const h=l.get(C);if(h)return h;const r=b(C);let o=v.get(r)??0;o++,v.set(r,o);const a=o===1?r:`${r}#${o}`;return l.set(C,a),a}function b(C){const h=C.constructor;return h?h.name:"Object"}function c(C){const h=C.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(h);return(o?o[1]:void 0)?.trim()}}),define(De[139],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=k,e.getLogger=P;let y;function k(r){y=r}function P(){return y}class O{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(o){return A([R(C("|  ",this.indentation)),o])}formatInfo(o){return o.hadValue?o.didChange?[R(" "),l(T(o.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),l(T(o.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),l(T(o.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged(o,a){console.log(...this.textToConsoleArgs([v("observable value changed"),l(o.debugName,{color:"BlueViolet"}),...this.formatInfo(a)]))}formatChanges(o){if(o.size!==0)return l(" (changed deps: "+[...o].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const a=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(d,t)=>(this.changedObservablesSets.get(o).add(d),a.apply(o,[d,t]))}handleDerivedRecomputed(o,a){const d=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([v("derived recomputed"),l(o.debugName,{color:"BlueViolet"}),...this.formatInfo(a),this.formatChanges(d),{data:[{fn:o._computeFn}]}])),d.clear()}handleFromEventObservableTriggered(o,a){console.log(...this.textToConsoleArgs([v("observable from event triggered"),l(o.debugName,{color:"BlueViolet"}),...this.formatInfo(a),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const a=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(d,t)=>(this.changedObservablesSets.get(o).add(d),a.apply(o,[d,t]))}handleAutorunTriggered(o){const a=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([v("autorun"),l(o.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:o._runFn}]}])),a.clear(),this.indentation++}handleAutorunFinished(o){this.indentation--}handleBeginTransaction(o){let a=o.getDebugName();a===void 0&&(a=""),console.log(...this.textToConsoleArgs([v("transaction"),l(a,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=O;function A(r){const o=new Array,a=[];let d="";function t(n){if("length"in n)for(const i of n)i&&t(i);else"text"in n?(d+=`%c${n.text}`,o.push(n.style),n.data&&a.push(...n.data)):"data"in n&&a.push(...n.data)}t(r);const s=[d,...o];return s.push(...a),s}function R(r){return l(r,{color:"black"})}function v(r){return l(h(`${r}: `,10),{color:"black",bold:!0})}function l(r,o={color:"black"}){function a(t){return Object.entries(t).reduce((s,[n,i])=>`${s}${n}:${i};`,"")}const d={color:o.color};return o.strikeThrough&&(d["text-decoration"]="line-through"),o.bold&&(d["font-weight"]="bold"),{text:r,style:a(d)}}function T(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?b(r,o):c(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function b(r,o){let a="[ ",d=!0;for(const t of r){if(d||(a+=", "),a.length-5>o){a+="...";break}d=!1,a+=`${T(t,o-a.length)}`}return a+=" ]",a}function c(r,o){let a="{ ",d=!0;for(const[t,s]of Object.entries(r)){if(d||(a+=", "),a.length-5>o){a+="...";break}d=!1,a+=`${t}: ${T(s,o-a.length)}`}return a+=" }",a}function C(r,o){let a="";for(let d=1;d<=o;d++)a+=r;return a}function h(r,o){for(;r.length<o;)r+=" ";return r}}),define(De[140],Ie([1,0,133,138,139]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=A,e._setKeepObserved=v,e._setDerivedOpts=T,e.transaction=C,e.globalTransaction=r,e.asyncTransaction=o,e.subtransaction=a,e.observableValue=t,e.observableValueOpts=s,e.disposableObservableValue=i;let O;function A(f){O=f}let R;function v(f){R=f}let l;function T(f){l=f}class b{get TChange(){return null}reportChanges(){this.get()}read(u){return u?u.readObservable(this):this.get()}map(u,E){const I=E===void 0?void 0:u,_=E===void 0?u:E;return l({owner:I,debugName:()=>{const w=(0,k.getFunctionName)(_);if(w!==void 0)return w;const D=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(_.toString());if(D)return`${this.debugName}.${D[2]}`;if(!I)return`${this.debugName} (mapped)`},debugReferenceFn:_},w=>_(this.read(w),w))}recomputeInitiallyAndOnChange(u,E){return u.add(O(this,E)),this}keepObserved(u){return u.add(R(this)),this}get debugValue(){return this.get()}}e.ConvenientObservable=b;class c extends b{constructor(){super(...arguments),this.observers=new Set}addObserver(u){const E=this.observers.size;this.observers.add(u),E===0&&this.onFirstObserverAdded()}removeObserver(u){this.observers.delete(u)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=c;function C(f,u){const E=new d(f,u);try{f(E)}finally{E.finish()}}let h;function r(f){if(h)f(h);else{const u=new d(f,void 0);h=u;try{f(u)}finally{u.finish(),h=void 0}}}async function o(f,u){const E=new d(f,u);try{await f(E)}finally{E.finish()}}function a(f,u,E){f?u(f):C(u,E)}class d{constructor(u,E){this._fn=u,this._getDebugName=E,this.updatingObservers=[],(0,P.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,k.getFunctionName)(this._fn)}updateObserver(u,E){this.updatingObservers.push({observer:u,observable:E}),u.beginUpdate(E)}finish(){const u=this.updatingObservers;for(let E=0;E<u.length;E++){const{observer:I,observable:_}=u[E];I.endUpdate(_)}this.updatingObservers=null,(0,P.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=d;function t(f,u){let E;return typeof f=="string"?E=new k.DebugNameData(void 0,f,void 0):E=new k.DebugNameData(f,void 0,void 0),new n(E,u,y.strictEquals)}function s(f,u){return new n(new k.DebugNameData(f.owner,f.debugName,void 0),u,f.equalsFn??y.strictEquals)}class n extends c{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(u,E,I){super(),this._debugNameData=u,this._equalityComparator=I,this._value=E}get(){return this._value}set(u,E,I){if(I===void 0&&this._equalityComparator(this._value,u))return;let _;E||(E=_=new d(()=>{},()=>`Setting ${this.debugName}`));try{const w=this._value;this._setValue(u),(0,P.getLogger)()?.handleObservableChanged(this,{oldValue:w,newValue:u,change:I,didChange:!0,hadValue:!0});for(const p of this.observers)E.updateObserver(p,this),p.handleChange(this,I)}finally{_&&_.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(u){this._value=u}}e.ObservableValue=n;function i(f,u){let E;return typeof f=="string"?E=new k.DebugNameData(void 0,f,void 0):E=new k.DebugNameData(f,void 0,void 0),new g(E,u,y.strictEquals)}class g extends n{_setValue(u){this._value!==u&&(this._value&&this._value.dispose(),this._value=u)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=g}),function(){function he(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function A(v){O.push(v,Date.now())}function R(){const v=[];for(let l=0;l<O.length;l+=2)v.push({name:O[l],startTime:O[l+1]});return v}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(P+A.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function y(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=y(k))}(),define(De[141],Ie([1,0,40]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const k=Symbol("unset");class P{constructor(){this.root=new A,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||y.Iterable.empty()}insert(v,l,T){this.opNode(v,b=>b._value=l,T)}mutate(v,l){this.opNode(v,T=>T._value=l(T._value===k?void 0:T._value))}mutatePath(v,l){this.opNode(v,()=>{},T=>l(T))}delete(v){const l=this.getPathToKey(v);if(!l)return;let T=l.length-1;const b=l[T].node._value;if(b!==k){for(this._size--,l[T].node._value=k;T>0;T--){const{node:c,part:C}=l[T];if(c.children?.size||c._value!==k)break;l[T-1].node.children.delete(C)}return b}}*deleteRecursive(v){const l=this.getPathToKey(v);if(!l)return;const T=l[l.length-1].node;for(let b=l.length-1;b>0;b--){const c=l[b-1];if(c.node.children.delete(l[b].part),c.node.children.size>0||c.node._value!==k)break}for(const b of O(T))b._value!==k&&(this._size--,yield b._value)}find(v){let l=this.root;for(const T of v){const b=l.children?.get(T);if(!b)return;l=b}return l._value===k?void 0:l._value}hasKeyOrParent(v){let l=this.root;for(const T of v){const b=l.children?.get(T);if(!b)return!1;if(b._value!==k)return!0;l=b}return!1}hasKeyOrChildren(v){let l=this.root;for(const T of v){const b=l.children?.get(T);if(!b)return!1;l=b}return!0}hasKey(v){let l=this.root;for(const T of v){const b=l.children?.get(T);if(!b)return!1;l=b}return l._value!==k}getPathToKey(v){const l=[{part:"",node:this.root}];let T=0;for(const b of v){const c=l[T].node.children?.get(b);if(!c)return;l.push({part:b,node:c}),T++}return l}opNode(v,l,T){let b=this.root;for(const h of v){if(b.children)if(b.children.has(h))b=b.children.get(h);else{const r=new A;b.children.set(h,r),b=r}else{const r=new A;b.children=new Map([[h,r]]),b=r}T?.(b)}const c=b._value===k?0:1;l(b);const C=b._value===k?0:1;this._size+=C-c}*values(){for(const{_value:v}of O(this.root))v!==k&&(yield v)}}e.WellDefinedPrefixTree=P;function*O(R){const v=[R];for(;v.length>0;){const l=v.pop();if(yield l,l.children)for(const T of l.children.values())v.push(T)}}class A{constructor(){this._value=k}get value(){return this._value===k?void 0:this._value}set value(v){this._value=v===void 0?k:v}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var k in y)(typeof exports=="object"?exports:he)[k]=y[k]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function y(k){if(e[k])return e[k].exports;var P=e[k]={i:k,l:!1,exports:{}};return he[k].call(P.exports,P,P.exports,y),P.l=!0,P.exports}return y.m=he,y.c=e,y.d=function(k,P,O){y.o(k,P)||Object.defineProperty(k,P,{enumerable:!0,get:O})},y.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},y.t=function(k,P){if(1&P&&(k=y(k)),8&P||4&P&&typeof k=="object"&&k&&k.__esModule)return k;var O=Object.create(null);if(y.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:k}),2&P&&typeof k!="string")for(var A in k)y.d(O,A,function(R){return k[R]}.bind(null,A));return O},y.n=function(k){var P=k&&k.__esModule?function(){return k.default}:function(){return k};return y.d(P,"a",P),P},y.o=function(k,P){return Object.prototype.hasOwnProperty.call(k,P)},y.p="",y(y.s=0)}([function(he,e,y){(function(k){var P;e=he.exports=Te,P=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],v=e.src=[],l=0,T=l++;v[T]="0|[1-9]\\d*";var b=l++;v[b]="[0-9]+";var c=l++;v[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=l++;v[C]="("+v[T]+")\\.("+v[T]+")\\.("+v[T]+")";var h=l++;v[h]="("+v[b]+")\\.("+v[b]+")\\.("+v[b]+")";var r=l++;v[r]="(?:"+v[T]+"|"+v[c]+")";var o=l++;v[o]="(?:"+v[b]+"|"+v[c]+")";var a=l++;v[a]="(?:-("+v[r]+"(?:\\."+v[r]+")*))";var d=l++;v[d]="(?:-?("+v[o]+"(?:\\."+v[o]+")*))";var t=l++;v[t]="[0-9A-Za-z-]+";var s=l++;v[s]="(?:\\+("+v[t]+"(?:\\."+v[t]+")*))";var n=l++,i="v?"+v[C]+v[a]+"?"+v[s]+"?";v[n]="^"+i+"$";var g="[v=\\s]*"+v[h]+v[d]+"?"+v[s]+"?",f=l++;v[f]="^"+g+"$";var u=l++;v[u]="((?:<|>)?=?)";var E=l++;v[E]=v[b]+"|x|X|\\*";var I=l++;v[I]=v[T]+"|x|X|\\*";var _=l++;v[_]="[v=\\s]*("+v[I]+")(?:\\.("+v[I]+")(?:\\.("+v[I]+")(?:"+v[a]+")?"+v[s]+"?)?)?";var w=l++;v[w]="[v=\\s]*("+v[E]+")(?:\\.("+v[E]+")(?:\\.("+v[E]+")(?:"+v[d]+")?"+v[s]+"?)?)?";var p=l++;v[p]="^"+v[u]+"\\s*"+v[_]+"$";var D=l++;v[D]="^"+v[u]+"\\s*"+v[w]+"$";var m=l++;v[m]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var S=l++;v[S]="(?:~>?)";var M=l++;v[M]="(\\s*)"+v[S]+"\\s+",R[M]=new RegExp(v[M],"g");var L=l++;v[L]="^"+v[S]+v[_]+"$";var H=l++;v[H]="^"+v[S]+v[w]+"$";var V=l++;v[V]="(?:\\^)";var $=l++;v[$]="(\\s*)"+v[V]+"\\s+",R[$]=new RegExp(v[$],"g");var N=l++;v[N]="^"+v[V]+v[_]+"$";var F=l++;v[F]="^"+v[V]+v[w]+"$";var Y=l++;v[Y]="^"+v[u]+"\\s*("+g+")$|^$";var re=l++;v[re]="^"+v[u]+"\\s*("+i+")$|^$";var fe=l++;v[fe]="(\\s*)"+v[u]+"\\s*("+g+"|"+v[_]+")",R[fe]=new RegExp(v[fe],"g");var Ee=l++;v[Ee]="^\\s*("+v[_]+")\\s+-\\s+("+v[_]+")\\s*$";var oe=l++;v[oe]="^\\s*("+v[w]+")\\s+-\\s+("+v[w]+")\\s*$";var pe=l++;v[pe]="(<|>)?=?\\s*\\*";for(var ve=0;ve<35;ve++)P(ve,v[ve]),R[ve]||(R[ve]=new RegExp(v[ve]));function se(x,q){if(x instanceof Te)return x;if(typeof x!="string"||x.length>O||!(q?R[f]:R[n]).test(x))return null;try{return new Te(x,q)}catch{return null}}function Te(x,q){if(x instanceof Te){if(x.loose===q)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Te))return new Te(x,q);P("SemVer",x,q),this.loose=q;var K=x.trim().match(q?R[f]:R[n]);if(!K)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(te){if(/^[0-9]+$/.test(te)){var ue=+te;if(ue>=0&&ue<A)return ue}return te}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=se,e.valid=function(x,q){var K=se(x,q);return K?K.version:null},e.clean=function(x,q){var K=se(x.trim().replace(/^[=v]+/,""),q);return K?K.version:null},e.SemVer=Te,Te.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Te.prototype.toString=function(){return this.version},Te.prototype.compare=function(x){return P("SemVer.compare",this.version,this.loose,x),x instanceof Te||(x=new Te(x,this.loose)),this.compareMain(x)||this.comparePre(x)},Te.prototype.compareMain=function(x){return x instanceof Te||(x=new Te(x,this.loose)),Q(this.major,x.major)||Q(this.minor,x.minor)||Q(this.patch,x.patch)},Te.prototype.comparePre=function(x){if(x instanceof Te||(x=new Te(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var q=0;do{var K=this.prerelease[q],te=x.prerelease[q];if(P("prerelease compare",q,K,te),K===void 0&&te===void 0)return 0;if(te===void 0)return 1;if(K===void 0)return-1;if(K!==te)return Q(K,te)}while(++q)},Te.prototype.inc=function(x,q){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,q,K,te){typeof K=="string"&&(te=K,K=void 0);try{return new Te(x,K).inc(q,te).version}catch{return null}},e.diff=function(x,q){if(de(x,q))return null;var K=se(x),te=se(q);if(K.prerelease.length||te.prerelease.length){for(var ue in K)if((ue==="major"||ue==="minor"||ue==="patch")&&K[ue]!==te[ue])return"pre"+ue;return"prerelease"}for(var ue in K)if((ue==="major"||ue==="minor"||ue==="patch")&&K[ue]!==te[ue])return ue},e.compareIdentifiers=Q;var Me=/^[0-9]+$/;function Q(x,q){var K=Me.test(x),te=Me.test(q);return K&&te&&(x=+x,q=+q),K&&!te?-1:te&&!K?1:x<q?-1:x>q?1:0}function W(x,q,K){return new Te(x,K).compare(new Te(q,K))}function ie(x,q,K){return W(x,q,K)>0}function _e(x,q,K){return W(x,q,K)<0}function de(x,q,K){return W(x,q,K)===0}function Se(x,q,K){return W(x,q,K)!==0}function ae(x,q,K){return W(x,q,K)>=0}function X(x,q,K){return W(x,q,K)<=0}function J(x,q,K,te){var ue;switch(q){case"===":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),ue=x===K;break;case"!==":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),ue=x!==K;break;case"":case"=":case"==":ue=de(x,K,te);break;case"!=":ue=Se(x,K,te);break;case">":ue=ie(x,K,te);break;case">=":ue=ae(x,K,te);break;case"<":ue=_e(x,K,te);break;case"<=":ue=X(x,K,te);break;default:throw new TypeError("Invalid operator: "+q)}return ue}function me(x,q){if(x instanceof me){if(x.loose===q)return x;x=x.value}if(!(this instanceof me))return new me(x,q);P("comparator",x,q),this.loose=q,this.parse(x),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(x,q){return Q(q,x)},e.major=function(x,q){return new Te(x,q).major},e.minor=function(x,q){return new Te(x,q).minor},e.patch=function(x,q){return new Te(x,q).patch},e.compare=W,e.compareLoose=function(x,q){return W(x,q,!0)},e.rcompare=function(x,q,K){return W(q,x,K)},e.sort=function(x,q){return x.sort(function(K,te){return e.compare(K,te,q)})},e.rsort=function(x,q){return x.sort(function(K,te){return e.rcompare(K,te,q)})},e.gt=ie,e.lt=_e,e.eq=de,e.neq=Se,e.gte=ae,e.lte=X,e.cmp=J,e.Comparator=me;var ge={};function Le(x,q){if(x instanceof Le)return x.loose===q?x:new Le(x.raw,q);if(x instanceof me)return new Le(x.value,q);if(!(this instanceof Le))return new Le(x,q);if(this.loose=q,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function ze(x){return!x||x.toLowerCase()==="x"||x==="*"}function ye(x,q,K,te,ue,Ae,Be,He,Ye,tt,Ze,it,nt){return((q=ze(K)?"":ze(te)?">="+K+".0.0":ze(ue)?">="+K+"."+te+".0":">="+q)+" "+(He=ze(Ye)?"":ze(tt)?"<"+(+Ye+1)+".0.0":ze(Ze)?"<"+Ye+"."+(+tt+1)+".0":it?"<="+Ye+"."+tt+"."+Ze+"-"+it:"<="+He)).trim()}function ke(x,q){for(var K=0;K<x.length;K++)if(!x[K].test(q))return!1;if(q.prerelease.length){for(K=0;K<x.length;K++)if(P(x[K].semver),x[K].semver!==ge&&x[K].semver.prerelease.length>0){var te=x[K].semver;if(te.major===q.major&&te.minor===q.minor&&te.patch===q.patch)return!0}return!1}return!0}function Oe(x,q,K){try{q=new Le(q,K)}catch{return!1}return q.test(x)}function B(x,q,K,te){var ue,Ae,Be,He,Ye;switch(x=new Te(x,te),q=new Le(q,te),K){case">":ue=ie,Ae=X,Be=_e,He=">",Ye=">=";break;case"<":ue=_e,Ae=ae,Be=ie,He="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(x,q,te))return!1;for(var tt=0;tt<q.set.length;++tt){var Ze=q.set[tt],it=null,nt=null;if(Ze.forEach(function(mt){mt.semver===ge&&(mt=new me(">=0.0.0")),it=it||mt,nt=nt||mt,ue(mt.semver,it.semver,te)?it=mt:Be(mt.semver,nt.semver,te)&&(nt=mt)}),it.operator===He||it.operator===Ye||(!nt.operator||nt.operator===He)&&Ae(x,nt.semver)||nt.operator===Ye&&Be(x,nt.semver))return!1}return!0}me.prototype.parse=function(x){var q=this.loose?R[Y]:R[re],K=x.match(q);if(!K)throw new TypeError("Invalid comparator: "+x);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new Te(K[2],this.loose):this.semver=ge},me.prototype.toString=function(){return this.value},me.prototype.test=function(x){return P("Comparator.test",x,this.loose),this.semver===ge||(typeof x=="string"&&(x=new Te(x,this.loose)),J(x,this.operator,this.semver,this.loose))},me.prototype.intersects=function(x,q){if(!(x instanceof me))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new Le(x.value,q),Oe(this.value,K,q);if(x.operator==="")return K=new Le(this.value,q),Oe(x.semver,K,q);var te=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),ue=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Ae=this.semver.version===x.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),He=J(this.semver,"<",x.semver,q)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ye=J(this.semver,">",x.semver,q)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return te||ue||Ae&&Be||He||Ye},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(x){var q=this.loose;x=x.trim(),P("range",x,q);var K=q?R[oe]:R[Ee];x=x.replace(K,ye),P("hyphen replace",x),x=x.replace(R[fe],"$1$2$3"),P("comparator trim",x,R[fe]),x=(x=(x=x.replace(R[M],"$1~")).replace(R[$],"$1^")).split(/\s+/).join(" ");var te=q?R[Y]:R[re],ue=x.split(" ").map(function(Ae){return function(Be,He){return P("comp",Be),Be=function(Ye,tt){return Ye.trim().split(/\s+/).map(function(Ze){return function(it,nt){P("caret",it,nt);var mt=nt?R[F]:R[N];return it.replace(mt,function(ut,rt,at,ht,We){var xe;return P("caret",it,ut,rt,at,ht,We),ze(rt)?xe="":ze(at)?xe=">="+rt+".0.0 <"+(+rt+1)+".0.0":ze(ht)?xe=rt==="0"?">="+rt+"."+at+".0 <"+rt+"."+(+at+1)+".0":">="+rt+"."+at+".0 <"+(+rt+1)+".0.0":We?(P("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),xe=rt==="0"?at==="0"?">="+rt+"."+at+"."+ht+We+" <"+rt+"."+at+"."+(+ht+1):">="+rt+"."+at+"."+ht+We+" <"+rt+"."+(+at+1)+".0":">="+rt+"."+at+"."+ht+We+" <"+(+rt+1)+".0.0"):(P("no pr"),xe=rt==="0"?at==="0"?">="+rt+"."+at+"."+ht+" <"+rt+"."+at+"."+(+ht+1):">="+rt+"."+at+"."+ht+" <"+rt+"."+(+at+1)+".0":">="+rt+"."+at+"."+ht+" <"+(+rt+1)+".0.0"),P("caret return",xe),xe})}(Ze,tt)}).join(" ")}(Be,He),P("caret",Be),Be=function(Ye,tt){return Ye.trim().split(/\s+/).map(function(Ze){return function(it,nt){var mt=nt?R[H]:R[L];return it.replace(mt,function(ut,rt,at,ht,We){var xe;return P("tilde",it,ut,rt,at,ht,We),ze(rt)?xe="":ze(at)?xe=">="+rt+".0.0 <"+(+rt+1)+".0.0":ze(ht)?xe=">="+rt+"."+at+".0 <"+rt+"."+(+at+1)+".0":We?(P("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),xe=">="+rt+"."+at+"."+ht+We+" <"+rt+"."+(+at+1)+".0"):xe=">="+rt+"."+at+"."+ht+" <"+rt+"."+(+at+1)+".0",P("tilde return",xe),xe})}(Ze,tt)}).join(" ")}(Be,He),P("tildes",Be),Be=function(Ye,tt){return P("replaceXRanges",Ye,tt),Ye.split(/\s+/).map(function(Ze){return function(it,nt){it=it.trim();var mt=nt?R[D]:R[p];return it.replace(mt,function(ut,rt,at,ht,We,xe){P("xRange",it,ut,rt,at,ht,We,xe);var Z=ze(at),j=Z||ze(ht),we=j||ze(We);return rt==="="&&we&&(rt=""),Z?ut=rt===">"||rt==="<"?"<0.0.0":"*":rt&&we?(j&&(ht=0),we&&(We=0),rt===">"?(rt=">=",j?(at=+at+1,ht=0,We=0):we&&(ht=+ht+1,We=0)):rt==="<="&&(rt="<",j?at=+at+1:ht=+ht+1),ut=rt+at+"."+ht+"."+We):j?ut=">="+at+".0.0 <"+(+at+1)+".0.0":we&&(ut=">="+at+"."+ht+".0 <"+at+"."+(+ht+1)+".0"),P("xRange return",ut),ut})}(Ze,tt)}).join(" ")}(Be,He),P("xrange",Be),Be=function(Ye,tt){return P("replaceStars",Ye,tt),Ye.trim().replace(R[pe],"")}(Be,He),P("stars",Be),Be}(Ae,q)}).join(" ").split(/\s+/);return this.loose&&(ue=ue.filter(function(Ae){return!!Ae.match(te)})),ue=ue.map(function(Ae){return new me(Ae,q)})},Le.prototype.intersects=function(x,q){if(!(x instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(te){return x.set.some(function(ue){return ue.every(function(Ae){return te.intersects(Ae,q)})})})})},e.toComparators=function(x,q){return new Le(x,q).set.map(function(K){return K.map(function(te){return te.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new Te(x,this.loose));for(var q=0;q<this.set.length;q++)if(ke(this.set[q],x))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(x,q,K){var te=null,ue=null;try{var Ae=new Le(q,K)}catch{return null}return x.forEach(function(Be){Ae.test(Be)&&(te&&ue.compare(Be)!==-1||(ue=new Te(te=Be,K)))}),te},e.minSatisfying=function(x,q,K){var te=null,ue=null;try{var Ae=new Le(q,K)}catch{return null}return x.forEach(function(Be){Ae.test(Be)&&(te&&ue.compare(Be)!==1||(ue=new Te(te=Be,K)))}),te},e.validRange=function(x,q){try{return new Le(x,q).range||"*"}catch{return null}},e.ltr=function(x,q,K){return B(x,q,"<",K)},e.gtr=function(x,q,K){return B(x,q,">",K)},e.outside=B,e.prerelease=function(x,q){var K=se(x,q);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(x,q,K){return x=new Le(x,K),q=new Le(q,K),x.intersects(q)},e.coerce=function(x){if(x instanceof Te)return x;if(typeof x!="string")return null;var q=x.match(R[m]);return q==null?null:se((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,y(1))},function(he,e){var y,k,P=he.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(o){if(y===setTimeout)return setTimeout(o,0);if((y===O||!y)&&setTimeout)return y=setTimeout,setTimeout(o,0);try{return y(o,0)}catch{try{return y.call(null,o,0)}catch{return y.call(this,o,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:O}catch{y=O}try{k=typeof clearTimeout=="function"?clearTimeout:A}catch{k=A}})();var v,l=[],T=!1,b=-1;function c(){T&&v&&(T=!1,v.length?l=v.concat(l):b=-1,l.length&&C())}function C(){if(!T){var o=R(c);T=!0;for(var a=l.length;a;){for(v=l,l=[];++b<a;)v&&v[b].run();b=-1,a=l.length}v=null,T=!1,function(d){if(k===clearTimeout)return clearTimeout(d);if((k===A||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(d);try{k(d)}catch{try{return k.call(null,d)}catch{return k.call(this,d)}}}(o)}}function h(o,a){this.fun=o,this.array=a}function r(){}P.nextTick=function(o){var a=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)a[d-1]=arguments[d];l.push(new h(o,a)),l.length!==1||T||R(C)},h.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(o){return[]},P.binding=function(o){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(o){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(De[142],Ie([1,0,4,6]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SmoothScrollingOperation=e.SmoothScrollingUpdate=e.Scrollable=e.ScrollState=e.ScrollbarVisibility=void 0;var P;(function(C){C[C.Auto=1]="Auto",C[C.Hidden=2]="Hidden",C[C.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class O{constructor(h,r,o,a,d,t,s){this._forceIntegerValues=h,this._scrollStateBrand=void 0,this._forceIntegerValues&&(r=r|0,o=o|0,a=a|0,d=d|0,t=t|0,s=s|0),this.rawScrollLeft=a,this.rawScrollTop=s,r<0&&(r=0),a+r>o&&(a=o-r),a<0&&(a=0),d<0&&(d=0),s+d>t&&(s=t-d),s<0&&(s=0),this.width=r,this.scrollWidth=o,this.scrollLeft=a,this.height=d,this.scrollHeight=t,this.scrollTop=s}equals(h){return this.rawScrollLeft===h.rawScrollLeft&&this.rawScrollTop===h.rawScrollTop&&this.width===h.width&&this.scrollWidth===h.scrollWidth&&this.scrollLeft===h.scrollLeft&&this.height===h.height&&this.scrollHeight===h.scrollHeight&&this.scrollTop===h.scrollTop}withScrollDimensions(h,r){return new O(this._forceIntegerValues,typeof h.width<"u"?h.width:this.width,typeof h.scrollWidth<"u"?h.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof h.height<"u"?h.height:this.height,typeof h.scrollHeight<"u"?h.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(h){return new O(this._forceIntegerValues,this.width,this.scrollWidth,typeof h.scrollLeft<"u"?h.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof h.scrollTop<"u"?h.scrollTop:this.rawScrollTop)}createScrollEvent(h,r){const o=this.width!==h.width,a=this.scrollWidth!==h.scrollWidth,d=this.scrollLeft!==h.scrollLeft,t=this.height!==h.height,s=this.scrollHeight!==h.scrollHeight,n=this.scrollTop!==h.scrollTop;return{inSmoothScrolling:r,oldWidth:h.width,oldScrollWidth:h.scrollWidth,oldScrollLeft:h.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:h.height,oldScrollHeight:h.scrollHeight,oldScrollTop:h.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:a,scrollLeftChanged:d,heightChanged:t,scrollHeightChanged:s,scrollTopChanged:n}}}e.ScrollState=O;class A extends k.Disposable{constructor(h){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new y.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=h.smoothScrollDuration,this._scheduleAtNextAnimationFrame=h.scheduleAtNextAnimationFrame,this._state=new O(h.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(h){this._smoothScrollDuration=h}validateScrollPosition(h){return this._state.withScrollPosition(h)}getScrollDimensions(){return this._state}setScrollDimensions(h,r){const o=this._state.withScrollDimensions(h,r);this._setState(o,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(h){const r=this._state.withScrollPosition(h);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(r,!1)}setScrollPositionSmooth(h,r){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(h);if(this._smoothScrolling){h={scrollLeft:typeof h.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:h.scrollLeft,scrollTop:typeof h.scrollTop>"u"?this._smoothScrolling.to.scrollTop:h.scrollTop};const o=this._state.withScrollPosition(h);if(this._smoothScrolling.to.scrollLeft===o.scrollLeft&&this._smoothScrolling.to.scrollTop===o.scrollTop)return;let a;r?a=new T(this._smoothScrolling.from,o,this._smoothScrolling.startTime,this._smoothScrolling.duration):a=this._smoothScrolling.combine(this._state,o,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=a}else{const o=this._state.withScrollPosition(h);this._smoothScrolling=T.start(this._state,o,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const h=this._smoothScrolling.tick(),r=this._state.withScrollPosition(h);if(this._setState(r,!0),!!this._smoothScrolling){if(h.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(h,r){const o=this._state;o.equals(h)||(this._state=h,this._onScroll.fire(this._state.createScrollEvent(o,r)))}}e.Scrollable=A;class R{constructor(h,r,o){this.scrollLeft=h,this.scrollTop=r,this.isDone=o}}e.SmoothScrollingUpdate=R;function v(C,h){const r=h-C;return function(o){return C+r*c(o)}}function l(C,h,r){return function(o){return o<r?C(o/r):h((o-r)/(1-r))}}class T{constructor(h,r,o,a){this.from=h,this.to=r,this.duration=a,this.startTime=o,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(h,r,o){if(Math.abs(h-r)>2.5*o){let d,t;return h<r?(d=h+.75*o,t=r-.75*o):(d=h-.75*o,t=r+.75*o),l(v(h,d),v(t,r),.33)}return v(h,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(h){this.to=h.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(h){const r=(h-this.startTime)/this.duration;if(r<1){const o=this.scrollLeft(r),a=this.scrollTop(r);return new R(o,a,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(h,r,o){return T.start(h,r,o)}static start(h,r,o){o=o+10;const a=Date.now()-10;return new T(h,r,a,o)}}e.SmoothScrollingOperation=T;function b(C){return Math.pow(C,3)}function c(C){return 1-b(1-C)}}),define(De[143],Ie([1,0,14,6]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=P,e.isReadableStream=O,e.isReadableBufferedStream=A,e.newWriteableStream=R,e.consumeReadable=l,e.peekReadable=T,e.consumeStream=b,e.listenStream=c,e.peekStream=C,e.toStream=h,e.emptyStream=r,e.toReadable=o,e.transform=a,e.prefixedReadable=d,e.prefixedStream=t;function P(s){const n=s;return n?typeof n.read=="function":!1}function O(s){const n=s;return n?[n.on,n.pause,n.resume,n.destroy].every(i=>typeof i=="function"):!1}function A(s){const n=s;return n?O(n.stream)&&Array.isArray(n.buffer)&&typeof n.ended=="boolean":!1}function R(s,n){return new v(s,n)}class v{constructor(n,i){this.reducer=n,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(n){if(!this.state.destroyed){if(this.state.flowing)this.emitData(n);else if(this.buffer.data.push(n),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(n){this.state.destroyed||(this.state.flowing?this.emitError(n):this.buffer.error.push(n))}end(n){this.state.destroyed||(typeof n<"u"&&this.write(n),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(n){this.listeners.data.slice(0).forEach(i=>i(n))}emitError(n){this.listeners.error.length===0?(0,y.onUnexpectedError)(n):this.listeners.error.slice(0).forEach(i=>i(n))}emitEnd(){this.listeners.end.slice(0).forEach(n=>n())}on(n,i){if(!this.state.destroyed)switch(n){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(n,i){if(this.state.destroyed)return;let g;switch(n){case"data":g=this.listeners.data;break;case"end":g=this.listeners.end;break;case"error":g=this.listeners.error;break}if(g){const f=g.indexOf(i);f>=0&&g.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const n=this.reducer(this.buffer.data);this.emitData(n),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(g=>g())}}flowErrors(){if(this.listeners.error.length>0){for(const n of this.buffer.error)this.emitError(n);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(s,n){const i=[];let g;for(;(g=s.read())!==null;)i.push(g);return n(i)}function T(s,n,i){const g=[];let f;for(;(f=s.read())!==null&&g.length<i;)g.push(f);return f===null&&g.length>0?n(g):{read:()=>{if(g.length>0)return g.shift();if(typeof f<"u"){const u=f;return f=void 0,u}return s.read()}}}function b(s,n){return new Promise((i,g)=>{const f=[];c(s,{onData:u=>{n&&f.push(u)},onError:u=>{n?g(u):i(void 0)},onEnd:()=>{i(n?n(f):void 0)}})})}function c(s,n,i){s.on("error",g=>{i?.isCancellationRequested||n.onError(g)}),s.on("end",()=>{i?.isCancellationRequested||n.onEnd()}),s.on("data",g=>{i?.isCancellationRequested||n.onData(g)})}function C(s,n){return new Promise((i,g)=>{const f=new k.DisposableStore,u=[],E=w=>{if(u.push(w),u.length>n)return f.dispose(),s.pause(),i({stream:s,buffer:u,ended:!1})},I=w=>(f.dispose(),g(w)),_=()=>(f.dispose(),i({stream:s,buffer:u,ended:!0}));f.add((0,k.toDisposable)(()=>s.removeListener("error",I))),s.on("error",I),f.add((0,k.toDisposable)(()=>s.removeListener("end",_))),s.on("end",_),f.add((0,k.toDisposable)(()=>s.removeListener("data",E))),s.on("data",E)})}function h(s,n){const i=R(n);return i.end(s),i}function r(){const s=R(()=>{throw new Error("not supported")});return s.end(),s}function o(s){let n=!1;return{read:()=>n?null:(n=!0,s)}}function a(s,n,i){const g=R(i);return c(s,{onData:f=>g.write(n.data(f)),onError:f=>g.error(n.error?n.error(f):f),onEnd:()=>g.end()}),g}function d(s,n,i){let g=!1;return{read:()=>{const f=n.read();return g?f:(g=!0,f!==null?i([s,f]):s)}}}function t(s,n,i){let g=!1;const f=R(i);return c(n,{onData:u=>g?f.write(u):(g=!0,f.write(i([s,u]))),onError:u=>f.error(u),onEnd:()=>{g||(g=!0,f.write(s)),f.end()}}),f}}),define(De[23],Ie([1,0,47,143]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=l,e.readUInt16LE=T,e.writeUInt16LE=b,e.readUInt32BE=c,e.writeUInt32BE=C,e.readUInt32LE=h,e.writeUInt32LE=r,e.readUInt8=o,e.writeUInt8=a,e.readableToBuffer=d,e.bufferToReadable=t,e.streamToBuffer=s,e.bufferedStreamToBuffer=n,e.bufferToStream=i,e.streamToBufferReadableStream=g,e.newWriteableBufferStream=f,e.prefixedBufferReadable=u,e.prefixedBufferStream=E,e.decodeBase64=I,e.encodeBase64=p;const P=typeof Buffer<"u",O=new y.Lazy(()=>new Uint8Array(256));let A,R;class v{static alloc(m){return P?new v(Buffer.allocUnsafe(m)):new v(new Uint8Array(m))}static wrap(m){return P&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new v(m)}static fromString(m,S){return!(S?.dontUseNodeBuffer||!1)&&P?new v(Buffer.from(m)):(A||(A=new TextEncoder),new v(A.encode(m)))}static fromByteArray(m){const S=v.alloc(m.length);for(let M=0,L=m.length;M<L;M++)S.buffer[M]=m[M];return S}static concat(m,S){if(typeof S>"u"){S=0;for(let H=0,V=m.length;H<V;H++)S+=m[H].byteLength}const M=v.alloc(S);let L=0;for(let H=0,V=m.length;H<V;H++){const $=m[H];M.set($,L),L+=$.byteLength}return M}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=v.alloc(this.byteLength);return m.set(this),m}toString(){return P?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(m,S){return new v(this.buffer.subarray(m,S))}set(m,S){if(m instanceof v)this.buffer.set(m.buffer,S);else if(m instanceof Uint8Array)this.buffer.set(m,S);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),S);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return c(this.buffer,m)}writeUInt32BE(m,S){C(this.buffer,m,S)}readUInt32LE(m){return h(this.buffer,m)}writeUInt32LE(m,S){r(this.buffer,m,S)}readUInt8(m){return o(this.buffer,m)}writeUInt8(m,S){a(this.buffer,m,S)}indexOf(m,S=0){return l(this.buffer,m instanceof v?m.buffer:m,S)}}e.VSBuffer=v;function l(D,m,S=0){const M=m.byteLength,L=D.byteLength;if(M===0)return 0;if(M===1)return D.indexOf(m[0]);if(M>L-S)return-1;const H=O.value;H.fill(m.length);for(let F=0;F<m.length;F++)H[m[F]]=m.length-F-1;let V=S+m.length-1,$=V,N=-1;for(;V<L;)if(D[V]===m[$]){if($===0){N=V;break}V--,$--}else V+=Math.max(m.length-$,H[D[V]]),$=m.length-1;return N}function T(D,m){return D[m+0]<<0>>>0|D[m+1]<<8>>>0}function b(D,m,S){D[S+0]=m&255,m=m>>>8,D[S+1]=m&255}function c(D,m){return D[m]*2**24+D[m+1]*2**16+D[m+2]*2**8+D[m+3]}function C(D,m,S){D[S+3]=m,m=m>>>8,D[S+2]=m,m=m>>>8,D[S+1]=m,m=m>>>8,D[S]=m}function h(D,m){return D[m+0]<<0>>>0|D[m+1]<<8>>>0|D[m+2]<<16>>>0|D[m+3]<<24>>>0}function r(D,m,S){D[S+0]=m&255,m=m>>>8,D[S+1]=m&255,m=m>>>8,D[S+2]=m&255,m=m>>>8,D[S+3]=m&255}function o(D,m){return D[m]}function a(D,m,S){D[S]=m}function d(D){return k.consumeReadable(D,m=>v.concat(m))}function t(D){return k.toReadable(D)}function s(D){return k.consumeStream(D,m=>v.concat(m))}async function n(D){return D.ended?v.concat(D.buffer):v.concat([...D.buffer,await s(D.stream)])}function i(D){return k.toStream(D,m=>v.concat(m))}function g(D){return k.transform(D,{data:m=>typeof m=="string"?v.fromString(m):v.wrap(m)},m=>v.concat(m))}function f(D){return k.newWriteableStream(m=>v.concat(m),D)}function u(D,m){return k.prefixedReadable(D,m,S=>v.concat(S))}function E(D,m){return k.prefixedStream(D,m,S=>v.concat(S))}function I(D){let m=0,S=0,M=0;const L=new Uint8Array(Math.floor(D.length/4*3)),H=$=>{switch(S){case 3:L[M++]=m|$,S=0;break;case 2:L[M++]=m|$>>>2,m=$<<6,S=3;break;case 1:L[M++]=m|$>>>4,m=$<<4,S=2;break;default:m=$<<2,S=1}};for(let $=0;$<D.length;$++){const N=D.charCodeAt($);if(N>=65&&N<=90)H(N-65);else if(N>=97&&N<=122)H(N-97+26);else if(N>=48&&N<=57)H(N-48+52);else if(N===43||N===45)H(62);else if(N===47||N===95)H(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${D[$]}`)}}const V=M;for(;S>0;)H(0);return v.wrap(L).slice(0,V)}const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:D},m=!0,S=!1){const M=S?w:_;let L="";const H=D.byteLength%3;let V=0;for(;V<D.byteLength-H;V+=3){const $=D[V+0],N=D[V+1],F=D[V+2];L+=M[$>>>2],L+=M[($<<4|N>>>4)&63],L+=M[(N<<2|F>>>6)&63],L+=M[F&63]}if(H===1){const $=D[V+0];L+=M[$>>>2],L+=M[$<<4&63],m&&(L+="==")}else if(H===2){const $=D[V+0],N=D[V+1];L+=M[$>>>2],L+=M[($<<4|N>>>4)&63],L+=M[N<<2&63],m&&(L+="=")}return L}}),define(De[144],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(De[34],Ie([1,0,97]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=P;var k;(function(A){function R(v){return v&&typeof v=="object"&&typeof v.id=="string"}A.isThemeColor=R})(k||(e.ThemeColor=k={}));function P(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function v(d){const t=R.exec(d.id);if(!t)return v(y.Codicon.error);const[,s,n]=t,i=["codicon","codicon-"+s];return n&&i.push("codicon-modifier-"+n.substring(1)),i}A.asClassNameArray=v;function l(d){return v(d).join(" ")}A.asClassName=l;function T(d){return"."+v(d).join(".")}A.asCSSSelector=T;function b(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||k.isThemeColor(d.color))}A.isThemeIcon=b;const c=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function C(d){const t=c.exec(d);if(!t)return;const[,s]=t;return{id:s}}A.fromString=C;function h(d){return{id:d}}A.fromId=h;function r(d,t){let s=d.id;const n=s.lastIndexOf("~");return n!==-1&&(s=s.substring(0,n)),t&&(s=`${s}~${t}`),{id:s}}A.modify=r;function o(d){const t=d.id.lastIndexOf("~");if(t!==-1)return d.id.substring(t+1)}A.getModifier=o;function a(d,t){return d.id===t.id&&d.color?.id===t.color?.id}A.isEqual=a})(O||(e.ThemeIcon=O={}))}),define(De[145],Ie([1,0,28,29,136,13]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=A,e.matchesContiguousSubString=v,e.matchesSubString=l,e.isUpper=c,e.matchesCamelCase=_,e.matchesWords=w,e.matchesFuzzy=L,e.matchesFuzzy2=H,e.anyScore=V,e.createMatches=$,e.isPatternInWord=ie,e.fuzzyScore=ae,e.fuzzyScoreGracefulAggressive=me,e.fuzzyScoreGraceful=ge;function A(...ye){return function(ke,Oe){for(let B=0,x=ye.length;B<x;B++){const q=ye[B](ke,Oe);if(q)return q}return null}}e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ye,ke,Oe){if(!Oe||Oe.length<ke.length)return null;let B;return ye?B=O.startsWithIgnoreCase(Oe,ke):B=Oe.indexOf(ke)===0,B?ke.length>0?[{start:0,end:ke.length}]:[]:null}function v(ye,ke){const Oe=ke.toLowerCase().indexOf(ye.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+ye.length}]}function l(ye,ke){return T(ye.toLowerCase(),ke.toLowerCase(),0,0)}function T(ye,ke,Oe,B){if(Oe===ye.length)return[];if(B===ke.length)return null;if(ye[Oe]===ke[B]){let x=null;return(x=T(ye,ke,Oe+1,B+1))?n({start:B,end:B+1},x):null}return T(ye,ke,Oe,B+1)}function b(ye){return y.CharCode.a<=ye&&ye<=y.CharCode.z}function c(ye){return y.CharCode.A<=ye&&ye<=y.CharCode.Z}function C(ye){return y.CharCode.Digit0<=ye&&ye<=y.CharCode.Digit9}function h(ye){return ye===y.CharCode.Space||ye===y.CharCode.Tab||ye===y.CharCode.LineFeed||ye===y.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ye=>r.add(ye.charCodeAt(0)));function o(ye){return h(ye)||r.has(ye)}function a(ye,ke){return ye===ke||o(ye)&&o(ke)}const d=new Map;function t(ye){if(d.has(ye))return d.get(ye);let ke;const Oe=(0,P.getKoreanAltChars)(ye);return Oe&&(ke=Oe),d.set(ye,ke),ke}function s(ye){return b(ye)||c(ye)||C(ye)}function n(ye,ke){return ke.length===0?ke=[ye]:ye.end===ke[0].start?ke[0].start=ye.start:ke.unshift(ye),ke}function i(ye,ke){for(let Oe=ke;Oe<ye.length;Oe++){const B=ye.charCodeAt(Oe);if(c(B)||C(B)||Oe>0&&!s(ye.charCodeAt(Oe-1)))return Oe}return ye.length}function g(ye,ke,Oe,B){if(Oe===ye.length)return[];if(B===ke.length)return null;if(ye[Oe]!==ke[B].toLowerCase())return null;{let x=null,q=B+1;for(x=g(ye,ke,Oe+1,B+1);!x&&(q=i(ke,q))<ke.length;)x=g(ye,ke,Oe+1,q),q++;return x===null?null:n({start:B,end:B+1},x)}}function f(ye){let ke=0,Oe=0,B=0,x=0,q=0;for(let Be=0;Be<ye.length;Be++)q=ye.charCodeAt(Be),c(q)&&ke++,b(q)&&Oe++,s(q)&&B++,C(q)&&x++;const K=ke/ye.length,te=Oe/ye.length,ue=B/ye.length,Ae=x/ye.length;return{upperPercent:K,lowerPercent:te,alphaPercent:ue,numericPercent:Ae}}function u(ye){const{upperPercent:ke,lowerPercent:Oe}=ye;return Oe===0&&ke>.6}function E(ye){const{upperPercent:ke,lowerPercent:Oe,alphaPercent:B,numericPercent:x}=ye;return Oe>.2&&ke<.8&&B>.6&&x<.2}function I(ye){let ke=0,Oe=0,B=0,x=0;for(let q=0;q<ye.length;q++)B=ye.charCodeAt(q),c(B)&&ke++,b(B)&&Oe++,h(B)&&x++;return(ke===0||Oe===0)&&x===0?ye.length<=30:ke<=5}function _(ye,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!I(ye))return null;ke.length>60&&(ke=ke.substring(0,60));const Oe=f(ke);if(!E(Oe)){if(!u(Oe))return null;ke=ke.toLowerCase()}let B=null,x=0;for(ye=ye.toLowerCase();x<ke.length&&(B=g(ye,ke,0,x))===null;)x=i(ke,x+1);return B}function w(ye,ke,Oe=!1){if(!ke||ke.length===0)return null;let B=null,x=0;for(ye=ye.toLowerCase(),ke=ke.toLowerCase();x<ke.length&&(B=p(ye,ke,0,x,Oe),B===null);)x=D(ke,x+1);return B}function p(ye,ke,Oe,B,x){let q=0;if(Oe===ye.length)return[];if(B===ke.length)return null;if(!a(ye.charCodeAt(Oe),ke.charCodeAt(B))){const ue=t(ye.charCodeAt(Oe));if(!ue)return null;for(let Ae=0;Ae<ue.length;Ae++)if(!a(ue[Ae],ke.charCodeAt(B+Ae)))return null;q+=ue.length-1}let K=null,te=B+q+1;if(K=p(ye,ke,Oe+1,te,x),!x)for(;!K&&(te=D(ke,te))<ke.length;)K=p(ye,ke,Oe+1,te,x),te++;if(!K)return null;if(ye.charCodeAt(Oe)!==ke.charCodeAt(B)){const ue=t(ye.charCodeAt(Oe));if(!ue)return K;for(let Ae=0;Ae<ue.length;Ae++)if(ue[Ae]!==ke.charCodeAt(B+Ae))return K}return n({start:B,end:B+q+1},K)}function D(ye,ke){for(let Oe=ke;Oe<ye.length;Oe++)if(o(ye.charCodeAt(Oe))||Oe>0&&o(ye.charCodeAt(Oe-1)))return Oe;return ye.length}const m=A(e.matchesPrefix,_,v),S=A(e.matchesPrefix,_,l),M=new k.LRUCache(1e4);function L(ye,ke,Oe=!1){if(typeof ye!="string"||typeof ke!="string")return null;let B=M.get(ye);B||(B=new RegExp(O.convertSimple2RegExpPattern(ye),"i"),M.set(ye,B));const x=B.exec(ke);return x?[{start:x.index,end:x.index+x[0].length}]:Oe?S(ye,ke):m(ye,ke)}function H(ye,ke){const Oe=ae(ye,ye.toLowerCase(),0,ke,ke.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?$(Oe):null}function V(ye,ke,Oe,B,x,q){const K=Math.min(13,ye.length);for(;Oe<K;Oe++){const te=ae(ye,ke,Oe,B,x,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(te)return te}return[0,q]}function $(ye){if(typeof ye>"u")return[];const ke=[],Oe=ye[1];for(let B=ye.length-1;B>1;B--){const x=ye[B]+Oe,q=ke[ke.length-1];q&&q.end===x?q.end=x+1:ke.push({start:x,end:x+1})}return ke}const N=128;function F(){const ye=[],ke=[];for(let Oe=0;Oe<=N;Oe++)ke[Oe]=0;for(let Oe=0;Oe<=N;Oe++)ye.push(ke.slice(0));return ye}function Y(ye){const ke=[];for(let Oe=0;Oe<=ye;Oe++)ke[Oe]=0;return ke}const re=Y(2*N),fe=Y(2*N),Ee=F(),oe=F(),pe=F(),ve=!1;function se(ye,ke,Oe,B,x){function q(te,ue,Ae=" "){for(;te.length<ue;)te=Ae+te;return te}let K=` |   |${B.split("").map(te=>q(te,3)).join("|")}
`;for(let te=0;te<=Oe;te++)te===0?K+=" |":K+=`${ke[te-1]}|`,K+=ye[te].slice(0,x+1).map(ue=>q(ue.toString(),3)).join("|")+`
`;return K}function Te(ye,ke,Oe,B){ye=ye.substr(ke),Oe=Oe.substr(B),console.log(se(oe,ye,ye.length,Oe,Oe.length)),console.log(se(pe,ye,ye.length,Oe,Oe.length)),console.log(se(Ee,ye,ye.length,Oe,Oe.length))}function Me(ye,ke){if(ke<0||ke>=ye.length)return!1;const Oe=ye.codePointAt(ke);switch(Oe){case y.CharCode.Underline:case y.CharCode.Dash:case y.CharCode.Period:case y.CharCode.Space:case y.CharCode.Slash:case y.CharCode.Backslash:case y.CharCode.SingleQuote:case y.CharCode.DoubleQuote:case y.CharCode.Colon:case y.CharCode.DollarSign:case y.CharCode.LessThan:case y.CharCode.GreaterThan:case y.CharCode.OpenParen:case y.CharCode.CloseParen:case y.CharCode.OpenSquareBracket:case y.CharCode.CloseSquareBracket:case y.CharCode.OpenCurlyBrace:case y.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.isEmojiImprecise(Oe)}}function Q(ye,ke){if(ke<0||ke>=ye.length)return!1;switch(ye.charCodeAt(ke)){case y.CharCode.Space:case y.CharCode.Tab:return!0;default:return!1}}function W(ye,ke,Oe){return ke[ye]!==Oe[ye]}function ie(ye,ke,Oe,B,x,q,K=!1){for(;ke<Oe&&x<q;)ye[ke]===B[x]&&(K&&(re[ke]=x),ke+=1),x+=1;return ke===Oe}var _e;(function(ye){ye[ye.Diag=1]="Diag",ye[ye.Left=2]="Left",ye[ye.LeftLeft=3]="LeftLeft"})(_e||(_e={}));var de;(function(ye){ye.Default=[-100,0];function ke(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}ye.isDefault=ke})(de||(e.FuzzyScore=de={}));class Se{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ke,Oe){this.firstMatchCanBeWeak=ke,this.boostFullMatch=Oe}}e.FuzzyScoreOptions=Se;function ae(ye,ke,Oe,B,x,q,K=Se.default){const te=ye.length>N?N:ye.length,ue=B.length>N?N:B.length;if(Oe>=te||q>=ue||te-Oe>ue-q||!ie(ke,Oe,te,x,q,ue,!0))return;X(te,ue,Oe,q,ke,x);let Ae=1,Be=1,He=Oe,Ye=q;const tt=[!1];for(Ae=1,He=Oe;He<te;Ae++,He++){const ut=re[He],rt=fe[He],at=He+1<te?fe[He+1]:ue;for(Be=ut-q+1,Ye=ut;Ye<at;Be++,Ye++){let ht=Number.MIN_SAFE_INTEGER,We=!1;Ye<=rt&&(ht=J(ye,ke,He,Oe,B,x,Ye,ue,q,Ee[Ae-1][Be-1]===0,tt));let xe=0;ht!==Number.MAX_SAFE_INTEGER&&(We=!0,xe=ht+oe[Ae-1][Be-1]);const Z=Ye>ut,j=Z?oe[Ae][Be-1]+(Ee[Ae][Be-1]>0?-5:0):0,we=Ye>ut+1&&Ee[Ae][Be-1]>0,qe=we?oe[Ae][Be-2]+(Ee[Ae][Be-2]>0?-5:0):0;if(we&&(!Z||qe>=j)&&(!We||qe>=xe))oe[Ae][Be]=qe,pe[Ae][Be]=_e.LeftLeft,Ee[Ae][Be]=0;else if(Z&&(!We||j>=xe))oe[Ae][Be]=j,pe[Ae][Be]=_e.Left,Ee[Ae][Be]=0;else if(We)oe[Ae][Be]=xe,pe[Ae][Be]=_e.Diag,Ee[Ae][Be]=Ee[Ae-1][Be-1]+1;else throw new Error("not possible")}}if(ve&&Te(ye,Oe,B,q),!tt[0]&&!K.firstMatchCanBeWeak)return;Ae--,Be--;const Ze=[oe[Ae][Be],q];let it=0,nt=0;for(;Ae>=1;){let ut=Be;do{const rt=pe[Ae][ut];if(rt===_e.LeftLeft)ut=ut-2;else if(rt===_e.Left)ut=ut-1;else break}while(ut>=1);it>1&&ke[Oe+Ae-1]===x[q+Be-1]&&!W(ut+q-1,B,x)&&it+1>Ee[Ae][ut]&&(ut=Be),ut===Be?it++:it=1,nt||(nt=ut),Ae--,Be=ut-1,Ze.push(Be)}ue-q===te&&K.boostFullMatch&&(Ze[0]+=2);const mt=nt-te;return Ze[0]-=mt,Ze}function X(ye,ke,Oe,B,x,q){let K=ye-1,te=ke-1;for(;K>=Oe&&te>=B;)x[K]===q[te]&&(fe[K]=te,K--),te--}function J(ye,ke,Oe,B,x,q,K,te,ue,Ae,Be){if(ke[Oe]!==q[K])return Number.MIN_SAFE_INTEGER;let He=1,Ye=!1;return K===Oe-B?He=ye[Oe]===x[K]?7:5:W(K,x,q)&&(K===0||!W(K-1,x,q))?(He=ye[Oe]===x[K]?7:5,Ye=!0):Me(q,K)&&(K===0||!Me(q,K-1))?He=5:(Me(q,K-1)||Q(q,K-1))&&(He=5,Ye=!0),He>1&&Oe===B&&(Be[0]=!0),Ye||(Ye=W(K,x,q)||Me(q,K-1)||Q(q,K-1)),Oe===B?K>ue&&(He-=Ye?3:5):Ae?He+=Ye?2:0:He+=Ye?0:1,K+1===te&&(He-=Ye?3:5),He}function me(ye,ke,Oe,B,x,q,K){return Le(ye,ke,Oe,B,x,q,!0,K)}function ge(ye,ke,Oe,B,x,q,K){return Le(ye,ke,Oe,B,x,q,!1,K)}function Le(ye,ke,Oe,B,x,q,K,te){let ue=ae(ye,ke,Oe,B,x,q,te);if(ue&&!K)return ue;if(ye.length>=3){const Ae=Math.min(7,ye.length-1);for(let Be=Oe+1;Be<Ae;Be++){const He=ze(ye,Be);if(He){const Ye=ae(He,He.toLowerCase(),Oe,B,x,q,te);Ye&&(Ye[0]-=3,(!ue||Ye[0]>ue[0])&&(ue=Ye))}}}return ue}function ze(ye,ke){if(ke+1>=ye.length)return;const Oe=ye[ke],B=ye[ke+1];if(Oe!==B)return ye.slice(0,ke)+B+Oe+ye.slice(ke+2)}}),define(De[98],Ie([1,0,145,13,34]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=v,e.markdownEscapeEscapedIcons=T,e.stripIcons=c,e.getCodiconAriaLabel=C,e.parseLabelWithIcons=r,e.matchesFuzzyIconAware=o;const O="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${A.source}`,"g");function v(a){return a.replace(R,(d,t)=>t?d:`\\${d}`)}const l=new RegExp(`\\\\${A.source}`,"g");function T(a){return a.replace(l,d=>`\\${d}`)}const b=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function c(a){return a.indexOf(O)===-1?a:a.replace(b,(d,t,s,n)=>s?d:t||n||"")}function C(a){return a?a.replace(/\$\((.*?)\)/g,(d,t)=>` ${t} `).trim():""}const h=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(a){h.lastIndex=0;let d="";const t=[];let s=0;for(;;){const n=h.lastIndex,i=h.exec(a),g=a.substring(n,i?.index);if(g.length>0){d+=g;for(let f=0;f<g.length;f++)t.push(s)}if(!i)break;s+=i[0].length}return{text:d,iconOffsets:t}}function o(a,d,t=!1){const{text:s,iconOffsets:n}=d;if(!n||n.length===0)return(0,y.matchesFuzzy)(a,s,t);const i=(0,k.ltrim)(s," "),g=s.length-i.length,f=(0,y.matchesFuzzy)(a,i,t);if(f)for(const u of f){const E=n[u.start+g]+g;u.start+=E,u.end+=E}return f}}),define(De[35],Ie([1,0,13]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(k||(k={})),function(P){const O="error",A="warning",R="warn",v="info",l="ignore";function T(c){return c?y.equalsIgnoreCase(O,c)?P.Error:y.equalsIgnoreCase(A,c)||y.equalsIgnoreCase(R,c)?P.Warning:y.equalsIgnoreCase(v,c)?P.Info:P.Ignore:P.Ignore}P.fromValue=T;function b(c){switch(c){case P.Error:return O;case P.Warning:return A;case P.Info:return v;default:return l}}P.toString=b}(k||(k={})),e.default=k}),define(De[58],Ie([1,0,18,28,13]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class O{constructor(){this._value="",this._pos=0}reset(h){return this._value=h,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(h){const r=h.charCodeAt(0),o=this._value.charCodeAt(this._pos);return r-o}value(){return this._value[this._pos]}}e.StringIterator=O;class A{constructor(h=!0){this._caseSensitive=h}reset(h){return this._value=h,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let h=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===k.CharCode.Period)if(h)this._from++;else break;else h=!1;return this}cmp(h){return this._caseSensitive?(0,P.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class R{constructor(h=!0,r=!0){this._splitOnBackslash=h,this._caseSensitive=r}reset(h){this._from=0,this._to=0,this._value=h,this._valueLen=h.length;for(let r=h.length-1;r>=0;r--,this._valueLen--){const o=this._value.charCodeAt(r);if(!(o===k.CharCode.Slash||this._splitOnBackslash&&o===k.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let h=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===k.CharCode.Slash||this._splitOnBackslash&&r===k.CharCode.Backslash)if(h)this._from++;else break;else h=!1}return this}cmp(h){return this._caseSensitive?(0,P.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var v;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(v||(v={}));class l{constructor(h,r){this._ignorePathCasing=h,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(h){return this._value=h,this._states=[],this._value.scheme&&this._states.push(v.Scheme),this._value.authority&&this._states.push(v.Authority),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(h)),this._pathIterator.reset(h.path),this._pathIterator.value()&&this._states.push(v.Path)),this._ignoreQueryAndFragment(h)||(this._value.query&&this._states.push(v.Query),this._value.fragment&&this._states.push(v.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(h){if(this._states[this._stateIdx]===v.Scheme)return(0,P.compareIgnoreCase)(h,this._value.scheme);if(this._states[this._stateIdx]===v.Authority)return(0,P.compareIgnoreCase)(h,this._value.authority);if(this._states[this._stateIdx]===v.Path)return this._pathIterator.cmp(h);if(this._states[this._stateIdx]===v.Query)return(0,P.compare)(h,this._value.query);if(this._states[this._stateIdx]===v.Fragment)return(0,P.compare)(h,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===v.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===v.Authority)return this._value.authority;if(this._states[this._stateIdx]===v.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===v.Query)return this._value.query;if(this._states[this._stateIdx]===v.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=l;class T{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(b||(b={}));class c{static forUris(h=()=>!1,r=()=>!1){return new c(new l(h,r))}static forPaths(h=!1){return new c(new R(void 0,!h))}static forStrings(){return new c(new O)}static forConfigKeys(){return new c(new A)}constructor(h){this._iter=h}clear(){this._root=void 0}fill(h,r){if(r){const o=r.slice(0);(0,y.shuffle)(o);for(const a of o)this.set(a,h)}else{const o=h.slice(0);(0,y.shuffle)(o);for(const a of o)this.set(a[0],a[1])}}set(h,r){const o=this._iter.reset(h);let a;this._root||(this._root=new T,this._root.segment=o.value());const d=[];for(a=this._root;;){const s=o.cmp(a.segment);if(s>0)a.left||(a.left=new T,a.left.segment=o.value()),d.push([b.Left,a]),a=a.left;else if(s<0)a.right||(a.right=new T,a.right.segment=o.value()),d.push([b.Right,a]),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new T,a.mid.segment=o.value()),d.push([b.Mid,a]),a=a.mid;else break}const t=a.value;a.value=r,a.key=h;for(let s=d.length-1;s>=0;s--){const n=d[s][1];n.updateHeight();const i=n.balanceFactor();if(i<-1||i>1){const g=d[s][0],f=d[s+1][0];if(g===b.Right&&f===b.Right)d[s][1]=n.rotateLeft();else if(g===b.Left&&f===b.Left)d[s][1]=n.rotateRight();else if(g===b.Right&&f===b.Left)n.right=d[s+1][1]=d[s+1][1].rotateRight(),d[s][1]=n.rotateLeft();else if(g===b.Left&&f===b.Right)n.left=d[s+1][1]=d[s+1][1].rotateLeft(),d[s][1]=n.rotateRight();else throw new Error;if(s>0)switch(d[s-1][0]){case b.Left:d[s-1][1].left=d[s][1];break;case b.Right:d[s-1][1].right=d[s][1];break;case b.Mid:d[s-1][1].mid=d[s][1];break}else this._root=d[0][1]}}return t}get(h){return this._getNode(h)?.value}_getNode(h){const r=this._iter.reset(h);let o=this._root;for(;o;){const a=r.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(h){const r=this._getNode(h);return!(r?.value===void 0&&r?.mid===void 0)}delete(h){return this._delete(h,!1)}deleteSuperstr(h){return this._delete(h,!0)}_delete(h,r){const o=this._iter.reset(h),a=[];let d=this._root;for(;d;){const t=o.cmp(d.segment);if(t>0)a.push([b.Left,d]),d=d.left;else if(t<0)a.push([b.Right,d]),d=d.right;else if(o.hasNext())o.next(),a.push([b.Mid,d]),d=d.mid;else break}if(d){if(r?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const t=this._min(d.right);if(t.key){const{key:s,value:n,segment:i}=t;this._delete(t.key,!1),d.key=s,d.value=n,d.segment=i}}else{const t=d.left??d.right;if(a.length>0){const[s,n]=a[a.length-1];switch(s){case b.Left:n.left=t;break;case b.Mid:n.mid=t;break;case b.Right:n.right=t;break}}else this._root=t}for(let t=a.length-1;t>=0;t--){const s=a[t][1];s.updateHeight();const n=s.balanceFactor();if(n>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),a[t][1]=s.rotateLeft()):n<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),a[t][1]=s.rotateRight()),t>0)switch(a[t-1][0]){case b.Left:a[t-1][1].left=a[t][1];break;case b.Right:a[t-1][1].right=a[t][1];break;case b.Mid:a[t-1][1].mid=a[t][1];break}else this._root=a[0][1]}}}_min(h){for(;h.left;)h=h.left;return h}findSubstr(h){const r=this._iter.reset(h);let o=this._root,a;for(;o;){const d=r.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(r.hasNext())r.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(h){return this._findSuperstrOrElement(h,!1)}_findSuperstrOrElement(h,r){const o=this._iter.reset(h);let a=this._root;for(;a;){const d=o.cmp(a.segment);if(d>0)a=a.left;else if(d<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this._entries(a.mid):r?a.value:void 0}}hasElementOrSubtree(h){return this._findSuperstrOrElement(h,!0)!==void 0}forEach(h){for(const[r,o]of this)h(o,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(h){const r=[];return this._dfsEntries(h,r),r[Symbol.iterator]()}_dfsEntries(h,r){h&&(h.left&&this._dfsEntries(h.left,r),h.value&&r.push([h.key,h.value]),h.mid&&this._dfsEntries(h.mid,r),h.right&&this._dfsEntries(h.right,r))}_isBalanced(){const h=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:h(r.left)&&h(r.right)};return h(this._root)}}e.TernarySearchTree=c}),define(De[36],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=k;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(P){return y.test(P)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(R){for(let v=0;v<R.length;v++)R[v]=Math.floor(Math.random()*256);return R};const O=new Uint8Array(16),A=[];for(let R=0;R<256;R++)A.push(R.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let v=0,l="";return l+=A[O[v++]],l+=A[O[v++]],l+=A[O[v++]],l+=A[O[v++]],l+="-",l+=A[O[v++]],l+=A[O[v++]],l+="-",l+=A[O[v++]],l+=A[O[v++]],l+="-",l+=A[O[v++]],l+=A[O[v++]],l+="-",l+=A[O[v++]],l+=A[O[v++]],l+=A[O[v++]],l+=A[O[v++]],l+=A[O[v++]],l+=A[O[v++]],l}}()}),define(De[146],Ie([1,0,18,40,36]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=O,e.createFileDataTransferItem=A,e.matchesMimeType=l;function O(b){return{asString:async()=>b,asFile:()=>{},value:typeof b=="string"?b:void 0}}function A(b,c,C){const h={id:(0,P.generateUuid)(),name:b,uri:c,data:C};return{asString:async()=>"",asFile:()=>h,value:void 0}}class R{constructor(){this._entries=new Map}get size(){let c=0;for(const C of this._entries)c++;return c}has(c){return this._entries.has(this.toKey(c))}matches(c){const C=[...this._entries.keys()];return k.Iterable.some(this,([h,r])=>r.asFile())&&C.push("files"),T(v(c),C)}get(c){return this._entries.get(this.toKey(c))?.[0]}append(c,C){const h=this._entries.get(c);h?h.push(C):this._entries.set(this.toKey(c),[C])}replace(c,C){this._entries.set(this.toKey(c),[C])}delete(c){this._entries.delete(this.toKey(c))}*[Symbol.iterator](){for(const[c,C]of this._entries)for(const h of C)yield[c,h]}toKey(c){return v(c)}}e.VSDataTransfer=R;function v(b){return b.toLowerCase()}function l(b,c){return T(v(b),c.map(v))}function T(b,c){if(b==="*/*")return c.length>0;if(c.includes(b))return!0;const C=b.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!C)return!1;const[h,r,o]=C;return o==="*"?c.some(a=>a.startsWith(r+"/")):!1}e.UriList=Object.freeze({create:b=>(0,y.distinct)(b.map(c=>c.toString())).join(`\r
`),split:b=>b.split(`\r
`),parse:b=>e.UriList.split(b).filter(c=>!c.startsWith("#"))})}),define(De[147],Ie([1,0,28]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=P;var k;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(k||(e.StringEOL=k={}));function P(O){let A=0,R=0,v=0,l=k.Unknown;for(let T=0,b=O.length;T<b;T++){const c=O.charCodeAt(T);c===y.CharCode.CarriageReturn?(A===0&&(R=T),A++,T+1<b&&O.charCodeAt(T+1)===y.CharCode.LineFeed?(l|=k.CRLF,T++):l|=k.Invalid,v=T+1):c===y.CharCode.LineFeed&&(l|=k.LF,A===0&&(R=T),A++,v=T+1)}return A===0&&(R=O.length),[A,R,O.length-v,l]}}),define(De[148],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[149],Ie([1,0,28,150]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var P;(function(v){v[v.None=0]="None",v[v.Indent=1]="Indent",v[v.IndentOutdent=2]="IndentOutdent",v[v.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(l){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=l.open,this.close=l.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(l.notIn))for(let T=0,b=l.notIn.length;T<b;T++)switch(l.notIn[T]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(l){switch(l){case k.StandardTokenType.Other:return!0;case k.StandardTokenType.Comment:return this._inComment;case k.StandardTokenType.String:return this._inString;case k.StandardTokenType.RegEx:return this._inRegEx}}shouldAutoClose(l,T){if(l.getTokenCount()===0)return!0;const b=l.findTokenIndexAtOffset(T-2),c=l.getStandardTokenType(b);return this.isOK(c)}_findNeutralCharacterInRange(l,T){for(let b=l;b<=T;b++){const c=String.fromCharCode(b);if(!this.open.includes(c)&&!this.close.includes(c))return c}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(y.CharCode.Digit0,y.CharCode.Digit9)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(y.CharCode.a,y.CharCode.z)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(y.CharCode.A,y.CharCode.Z))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=O;class A{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const T of l)R(this.autoClosingPairsOpenByStart,T.open.charAt(0),T),R(this.autoClosingPairsOpenByEnd,T.open.charAt(T.open.length-1),T),R(this.autoClosingPairsCloseByStart,T.close.charAt(0),T),R(this.autoClosingPairsCloseByEnd,T.close.charAt(T.close.length-1),T),T.close.length===1&&T.open.length===1&&R(this.autoClosingPairsCloseSingleChar,T.close,T)}}e.AutoClosingPairs=A;function R(v,l,T){v.has(l)?v.get(l).push(T):v.set(l,[T])}}),define(De[151],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=P,e.righttest=O,e.leftRotate=l,e.rightRotate=T,e.rbDelete=b,e.fixInsert=c,e.updateTreeMetadata=C,e.recomputeTreeMetadata=h;class y{constructor(o,a){this.piece=o,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return P(this.right);let o=this;for(;o.parent!==e.SENTINEL&&o.parent.left!==o;)o=o.parent;return o.parent===e.SENTINEL?e.SENTINEL:o.parent}prev(){if(this.left!==e.SENTINEL)return O(this.left);let o=this;for(;o.parent!==e.SENTINEL&&o.parent.right!==o;)o=o.parent;return o.parent===e.SENTINEL?e.SENTINEL:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=y;var k;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(k||(e.NodeColor=k={})),e.SENTINEL=new y(null,k.Black),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=k.Black;function P(r){for(;r.left!==e.SENTINEL;)r=r.left;return r}function O(r){for(;r.right!==e.SENTINEL;)r=r.right;return r}function A(r){return r===e.SENTINEL?0:r.size_left+r.piece.length+A(r.right)}function R(r){return r===e.SENTINEL?0:r.lf_left+r.piece.lineFeedCnt+R(r.right)}function v(){e.SENTINEL.parent=e.SENTINEL}function l(r,o){const a=o.right;a.size_left+=o.size_left+(o.piece?o.piece.length:0),a.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=a.left,a.left!==e.SENTINEL&&(a.left.parent=o),a.parent=o.parent,o.parent===e.SENTINEL?r.root=a:o.parent.left===o?o.parent.left=a:o.parent.right=a,a.left=o,o.parent=a}function T(r,o){const a=o.left;o.left=a.right,a.right!==e.SENTINEL&&(a.right.parent=o),a.parent=o.parent,o.size_left-=a.size_left+(a.piece?a.piece.length:0),o.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),o.parent===e.SENTINEL?r.root=a:o===o.parent.right?o.parent.right=a:o.parent.left=a,a.right=o,o.parent=a}function b(r,o){let a,d;if(o.left===e.SENTINEL?(d=o,a=d.right):o.right===e.SENTINEL?(d=o,a=d.left):(d=P(o.right),a=d.right),d===r.root){r.root=a,a.color=k.Black,o.detach(),v(),r.root.parent=e.SENTINEL;return}const t=d.color===k.Red;if(d===d.parent.left?d.parent.left=a:d.parent.right=a,d===o?(a.parent=d.parent,h(r,a)):(d.parent===o?a.parent=d:a.parent=d.parent,h(r,a),d.left=o.left,d.right=o.right,d.parent=o.parent,d.color=o.color,o===r.root?r.root=d:o===o.parent.left?o.parent.left=d:o.parent.right=d,d.left!==e.SENTINEL&&(d.left.parent=d),d.right!==e.SENTINEL&&(d.right.parent=d),d.size_left=o.size_left,d.lf_left=o.lf_left,h(r,d)),o.detach(),a.parent.left===a){const n=A(a),i=R(a);if(n!==a.parent.size_left||i!==a.parent.lf_left){const g=n-a.parent.size_left,f=i-a.parent.lf_left;a.parent.size_left=n,a.parent.lf_left=i,C(r,a.parent,g,f)}}if(h(r,a.parent),t){v();return}let s;for(;a!==r.root&&a.color===k.Black;)a===a.parent.left?(s=a.parent.right,s.color===k.Red&&(s.color=k.Black,a.parent.color=k.Red,l(r,a.parent),s=a.parent.right),s.left.color===k.Black&&s.right.color===k.Black?(s.color=k.Red,a=a.parent):(s.right.color===k.Black&&(s.left.color=k.Black,s.color=k.Red,T(r,s),s=a.parent.right),s.color=a.parent.color,a.parent.color=k.Black,s.right.color=k.Black,l(r,a.parent),a=r.root)):(s=a.parent.left,s.color===k.Red&&(s.color=k.Black,a.parent.color=k.Red,T(r,a.parent),s=a.parent.left),s.left.color===k.Black&&s.right.color===k.Black?(s.color=k.Red,a=a.parent):(s.left.color===k.Black&&(s.right.color=k.Black,s.color=k.Red,l(r,s),s=a.parent.left),s.color=a.parent.color,a.parent.color=k.Black,s.left.color=k.Black,T(r,a.parent),a=r.root));a.color=k.Black,v()}function c(r,o){for(h(r,o);o!==r.root&&o.parent.color===k.Red;)if(o.parent===o.parent.parent.left){const a=o.parent.parent.right;a.color===k.Red?(o.parent.color=k.Black,a.color=k.Black,o.parent.parent.color=k.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,l(r,o)),o.parent.color=k.Black,o.parent.parent.color=k.Red,T(r,o.parent.parent))}else{const a=o.parent.parent.left;a.color===k.Red?(o.parent.color=k.Black,a.color=k.Black,o.parent.parent.color=k.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,T(r,o)),o.parent.color=k.Black,o.parent.parent.color=k.Red,l(r,o.parent.parent))}r.root.color=k.Black}function C(r,o,a,d){for(;o!==r.root&&o!==e.SENTINEL;)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=d),o=o.parent}function h(r,o){let a=0,d=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,a=A(o.left)-o.size_left,d=R(o.left)-o.lf_left,o.size_left+=a,o.lf_left+=d;o!==r.root&&(a!==0||d!==0);)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=d),o=o.parent}}}),define(De[99],Ie([1,0,28,100,33,52,151,101]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=b,e.createLineStarts=c;const v=65535;function l(d){let t;return d[d.length-1]<65536?t=new Uint16Array(d.length):t=new Uint32Array(d.length),t.set(d,0),t}class T{constructor(t,s,n,i,g){this.lineStarts=t,this.cr=s,this.lf=n,this.crlf=i,this.isBasicASCII=g}}function b(d,t=!0){const s=[0];let n=1;for(let i=0,g=d.length;i<g;i++){const f=d.charCodeAt(i);f===y.CharCode.CarriageReturn?i+1<g&&d.charCodeAt(i+1)===y.CharCode.LineFeed?(s[n++]=i+2,i++):s[n++]=i+1:f===y.CharCode.LineFeed&&(s[n++]=i+1)}return t?l(s):s}function c(d,t){d.length=0,d[0]=0;let s=1,n=0,i=0,g=0,f=!0;for(let E=0,I=t.length;E<I;E++){const _=t.charCodeAt(E);_===y.CharCode.CarriageReturn?E+1<I&&t.charCodeAt(E+1)===y.CharCode.LineFeed?(g++,d[s++]=E+2,E++):(n++,d[s++]=E+1):_===y.CharCode.LineFeed?(i++,d[s++]=E+1):f&&_!==y.CharCode.Tab&&(_<32||_>126)&&(f=!1)}const u=new T(l(d),n,i,g,f);return d.length=0,u}class C{constructor(t,s,n,i,g){this.bufferIndex=t,this.start=s,this.end=n,this.lineFeedCnt=i,this.length=g}}e.Piece=C;class h{constructor(t,s){this.buffer=t,this.lineStarts=s}}e.StringBuffer=h;class r{constructor(t,s){this._pieces=[],this._tree=t,this._BOM=s,this._index=0,t.root!==A.SENTINEL&&t.iterate(t.root,n=>(n!==A.SENTINEL&&this._pieces.push(n.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class o{constructor(t){this._limit=t,this._cache=[]}get(t){for(let s=this._cache.length-1;s>=0;s--){const n=this._cache[s];if(n.nodeStartOffset<=t&&n.nodeStartOffset+n.node.piece.length>=t)return n}return null}get2(t){for(let s=this._cache.length-1;s>=0;s--){const n=this._cache[s];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<t&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=t)return n}return null}set(t){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(t)}validate(t){let s=!1;const n=this._cache;for(let i=0;i<n.length;i++){const g=n[i];if(g.node.parent===null||g.nodeStartOffset>=t){n[i]=null,s=!0;continue}}if(s){const i=[];for(const g of n)g!==null&&i.push(g);this._cache=i}}}class a{constructor(t,s,n){this.create(t,s,n)}create(t,s,n){this._buffers=[new h("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=A.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=s,this._EOLLength=s.length,this._EOLNormalized=n;let i=null;for(let g=0,f=t.length;g<f;g++)if(t[g].buffer.length>0){t[g].lineStarts||(t[g].lineStarts=b(t[g].buffer));const u=new C(g+1,{line:0,column:0},{line:t[g].lineStarts.length-1,column:t[g].buffer.length-t[g].lineStarts[t[g].lineStarts.length-1]},t[g].lineStarts.length-1,t[g].buffer.length);this._buffers.push(t[g]),i=this.rbInsertRight(i,u)}this._searchCache=new o(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(t){const s=v,n=s-Math.floor(s/3),i=n*2;let g="",f=0;const u=[];if(this.iterate(this.root,E=>{const I=this.getNodeContent(E),_=I.length;if(f<=n||f+_<i)return g+=I,f+=_,!0;const w=g.replace(/\r\n|\r|\n/g,t);return u.push(new h(w,b(w))),g=I,f=_,!0}),f>0){const E=g.replace(/\r\n|\r|\n/g,t);u.push(new h(E,b(E)))}this.create(u,t,!0)}getEOL(){return this._EOL}setEOL(t){this._EOL=t,this._EOLLength=this._EOL.length,this.normalizeEOL(t)}createSnapshot(t){return new r(this,t)}equal(t){if(this.getLength()!==t.getLength()||this.getLineCount()!==t.getLineCount())return!1;let s=0;return this.iterate(this.root,i=>{if(i===A.SENTINEL)return!0;const g=this.getNodeContent(i),f=g.length,u=t.nodeAt(s),E=t.nodeAt(s+f),I=t.getValueInRange2(u,E);return s+=f,g===I})}getOffsetAt(t,s){let n=0,i=this.root;for(;i!==A.SENTINEL;)if(i.left!==A.SENTINEL&&i.lf_left+1>=t)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt+1>=t){n+=i.size_left;const g=this.getAccumulatedValue(i,t-i.lf_left-2);return n+=g+s-1}else t-=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;return n}getPositionAt(t){t=Math.floor(t),t=Math.max(0,t);let s=this.root,n=0;const i=t;for(;s!==A.SENTINEL;)if(s.size_left!==0&&s.size_left>=t)s=s.left;else if(s.size_left+s.piece.length>=t){const g=this.getIndexOf(s,t-s.size_left);if(n+=s.lf_left+g.index,g.index===0){const f=this.getOffsetAt(n+1,1),u=i-f;return new k.Position(n+1,u+1)}return new k.Position(n+1,g.remainder+1)}else if(t-=s.size_left+s.piece.length,n+=s.lf_left+s.piece.lineFeedCnt,s.right===A.SENTINEL){const g=this.getOffsetAt(n+1,1),f=i-t-g;return new k.Position(n+1,f+1)}else s=s.right;return new k.Position(1,1)}getValueInRange(t,s){if(t.startLineNumber===t.endLineNumber&&t.startColumn===t.endColumn)return"";const n=this.nodeAt2(t.startLineNumber,t.startColumn),i=this.nodeAt2(t.endLineNumber,t.endColumn),g=this.getValueInRange2(n,i);return s?s!==this._EOL||!this._EOLNormalized?g.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this._EOLNormalized?g:g.replace(/\r\n|\r|\n/g,s):g}getValueInRange2(t,s){if(t.node===s.node){const u=t.node,E=this._buffers[u.piece.bufferIndex].buffer,I=this.offsetInBuffer(u.piece.bufferIndex,u.piece.start);return E.substring(I+t.remainder,I+s.remainder)}let n=t.node;const i=this._buffers[n.piece.bufferIndex].buffer,g=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);let f=i.substring(g+t.remainder,g+n.piece.length);for(n=n.next();n!==A.SENTINEL;){const u=this._buffers[n.piece.bufferIndex].buffer,E=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);if(n===s.node){f+=u.substring(E,E+s.remainder);break}else f+=u.substr(E,n.piece.length);n=n.next()}return f}getLinesContent(){const t=[];let s=0,n="",i=!1;return this.iterate(this.root,g=>{if(g===A.SENTINEL)return!0;const f=g.piece;let u=f.length;if(u===0)return!0;const E=this._buffers[f.bufferIndex].buffer,I=this._buffers[f.bufferIndex].lineStarts,_=f.start.line,w=f.end.line;let p=I[_]+f.start.column;if(i&&(E.charCodeAt(p)===y.CharCode.LineFeed&&(p++,u--),t[s++]=n,n="",i=!1,u===0))return!0;if(_===w)return!this._EOLNormalized&&E.charCodeAt(p+u-1)===y.CharCode.CarriageReturn?(i=!0,n+=E.substr(p,u-1)):n+=E.substr(p,u),!0;n+=this._EOLNormalized?E.substring(p,Math.max(p,I[_+1]-this._EOLLength)):E.substring(p,I[_+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=n;for(let D=_+1;D<w;D++)n=this._EOLNormalized?E.substring(I[D],I[D+1]-this._EOLLength):E.substring(I[D],I[D+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=n;return!this._EOLNormalized&&E.charCodeAt(I[w]+f.end.column-1)===y.CharCode.CarriageReturn?(i=!0,f.end.column===0?s--:n=E.substr(I[w],f.end.column-1)):n=E.substr(I[w],f.end.column),!0}),i&&(t[s++]=n,n=""),t[s++]=n,t}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(t){return this._lastVisitedLine.lineNumber===t?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=t,t===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(t):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(t,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(t).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(t){if(t.remainder===t.node.piece.length){const s=t.node.next();if(!s)return 0;const n=this._buffers[s.piece.bufferIndex],i=this.offsetInBuffer(s.piece.bufferIndex,s.piece.start);return n.buffer.charCodeAt(i)}else{const s=this._buffers[t.node.piece.bufferIndex],i=this.offsetInBuffer(t.node.piece.bufferIndex,t.node.piece.start)+t.remainder;return s.buffer.charCodeAt(i)}}getLineCharCode(t,s){const n=this.nodeAt2(t,s+1);return this._getCharCode(n)}getLineLength(t){if(t===this.getLineCount()){const s=this.getOffsetAt(t,1);return this.getLength()-s}return this.getOffsetAt(t+1,1)-this.getOffsetAt(t,1)-this._EOLLength}getCharCode(t){const s=this.nodeAt(t);return this._getCharCode(s)}findMatchesInNode(t,s,n,i,g,f,u,E,I,_,w){const p=this._buffers[t.piece.bufferIndex],D=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start),m=this.offsetInBuffer(t.piece.bufferIndex,g),S=this.offsetInBuffer(t.piece.bufferIndex,f);let M;const L={line:0,column:0};let H,V;s._wordSeparators?(H=p.buffer.substring(m,S),V=$=>$+m,s.reset(0)):(H=p.buffer,V=$=>$,s.reset(m));do if(M=s.next(H),M){if(V(M.index)>=S)return _;this.positionInBuffer(t,V(M.index)-D,L);const $=this.getLineFeedCnt(t.piece.bufferIndex,g,L),N=L.line===g.line?L.column-g.column+i:L.column+1,F=N+M[0].length;if(w[_++]=(0,R.createFindMatch)(new P.Range(n+$,N,n+$,F),M,E),V(M.index)+M[0].length>=S||_>=I)return _}while(M);return _}findMatchesLineByLine(t,s,n,i){const g=[];let f=0;const u=new R.Searcher(s.wordSeparators,s.regex);let E=this.nodeAt2(t.startLineNumber,t.startColumn);if(E===null)return[];const I=this.nodeAt2(t.endLineNumber,t.endColumn);if(I===null)return[];let _=this.positionInBuffer(E.node,E.remainder);const w=this.positionInBuffer(I.node,I.remainder);if(E.node===I.node)return this.findMatchesInNode(E.node,u,t.startLineNumber,t.startColumn,_,w,s,n,i,f,g),g;let p=t.startLineNumber,D=E.node;for(;D!==I.node;){const S=this.getLineFeedCnt(D.piece.bufferIndex,_,D.piece.end);if(S>=1){const L=this._buffers[D.piece.bufferIndex].lineStarts,H=this.offsetInBuffer(D.piece.bufferIndex,D.piece.start),V=L[_.line+S],$=p===t.startLineNumber?t.startColumn:1;if(f=this.findMatchesInNode(D,u,p,$,_,this.positionInBuffer(D,V-H),s,n,i,f,g),f>=i)return g;p+=S}const M=p===t.startLineNumber?t.startColumn-1:0;if(p===t.endLineNumber){const L=this.getLineContent(p).substring(M,t.endColumn-1);return f=this._findMatchesInLine(s,u,L,t.endLineNumber,M,f,g,n,i),g}if(f=this._findMatchesInLine(s,u,this.getLineContent(p).substr(M),p,M,f,g,n,i),f>=i)return g;p++,E=this.nodeAt2(p,1),D=E.node,_=this.positionInBuffer(E.node,E.remainder)}if(p===t.endLineNumber){const S=p===t.startLineNumber?t.startColumn-1:0,M=this.getLineContent(p).substring(S,t.endColumn-1);return f=this._findMatchesInLine(s,u,M,t.endLineNumber,S,f,g,n,i),g}const m=p===t.startLineNumber?t.startColumn:1;return f=this.findMatchesInNode(I.node,u,p,m,_,w,s,n,i,f,g),g}_findMatchesInLine(t,s,n,i,g,f,u,E,I){const _=t.wordSeparators;if(!E&&t.simpleSearch){const p=t.simpleSearch,D=p.length,m=n.length;let S=-D;for(;(S=n.indexOf(p,S+D))!==-1;)if((!_||(0,R.isValidMatch)(_,n,m,S,D))&&(u[f++]=new O.FindMatch(new P.Range(i,S+1+g,i,S+1+D+g),null),f>=I))return f;return f}let w;s.reset(0);do if(w=s.next(n),w&&(u[f++]=(0,R.createFindMatch)(new P.Range(i,w.index+1+g,i,w.index+1+w[0].length+g),w,E),f>=I))return f;while(w);return f}insert(t,s,n=!1){if(this._EOLNormalized=this._EOLNormalized&&n,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==A.SENTINEL){const{node:i,remainder:g,nodeStartOffset:f}=this.nodeAt(t),u=i.piece,E=u.bufferIndex,I=this.positionInBuffer(i,g);if(i.piece.bufferIndex===0&&u.end.line===this._lastChangeBufferPos.line&&u.end.column===this._lastChangeBufferPos.column&&f+u.length===t&&s.length<v){this.appendToNode(i,s),this.computeBufferMetadata();return}if(f===t)this.insertContentToNodeLeft(s,i),this._searchCache.validate(t);else if(f+i.piece.length>t){const _=[];let w=new C(u.bufferIndex,I,u.end,this.getLineFeedCnt(u.bufferIndex,I,u.end),this.offsetInBuffer(E,u.end)-this.offsetInBuffer(E,I));if(this.shouldCheckCRLF()&&this.endWithCR(s)&&this.nodeCharCodeAt(i,g)===10){const S={line:w.start.line+1,column:0};w=new C(w.bufferIndex,S,w.end,this.getLineFeedCnt(w.bufferIndex,S,w.end),w.length-1),s+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(s))if(this.nodeCharCodeAt(i,g-1)===13){const S=this.positionInBuffer(i,g-1);this.deleteNodeTail(i,S),s="\r"+s,i.piece.length===0&&_.push(i)}else this.deleteNodeTail(i,I);else this.deleteNodeTail(i,I);const p=this.createNewPieces(s);w.length>0&&this.rbInsertRight(i,w);let D=i;for(let m=0;m<p.length;m++)D=this.rbInsertRight(D,p[m]);this.deleteNodes(_)}else this.insertContentToNodeRight(s,i)}else{const i=this.createNewPieces(s);let g=this.rbInsertLeft(null,i[0]);for(let f=1;f<i.length;f++)g=this.rbInsertRight(g,i[f])}this.computeBufferMetadata()}delete(t,s){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",s<=0||this.root===A.SENTINEL)return;const n=this.nodeAt(t),i=this.nodeAt(t+s),g=n.node,f=i.node;if(g===f){const p=this.positionInBuffer(g,n.remainder),D=this.positionInBuffer(g,i.remainder);if(n.nodeStartOffset===t){if(s===g.piece.length){const m=g.next();(0,A.rbDelete)(this,g),this.validateCRLFWithPrevNode(m),this.computeBufferMetadata();return}this.deleteNodeHead(g,D),this._searchCache.validate(t),this.validateCRLFWithPrevNode(g),this.computeBufferMetadata();return}if(n.nodeStartOffset+g.piece.length===t+s){this.deleteNodeTail(g,p),this.validateCRLFWithNextNode(g),this.computeBufferMetadata();return}this.shrinkNode(g,p,D),this.computeBufferMetadata();return}const u=[],E=this.positionInBuffer(g,n.remainder);this.deleteNodeTail(g,E),this._searchCache.validate(t),g.piece.length===0&&u.push(g);const I=this.positionInBuffer(f,i.remainder);this.deleteNodeHead(f,I),f.piece.length===0&&u.push(f);const _=g.next();for(let p=_;p!==A.SENTINEL&&p!==f;p=p.next())u.push(p);const w=g.piece.length===0?g.prev():g;this.deleteNodes(u),this.validateCRLFWithNextNode(w),this.computeBufferMetadata()}insertContentToNodeLeft(t,s){const n=[];if(this.shouldCheckCRLF()&&this.endWithCR(t)&&this.startWithLF(s)){const f=s.piece,u={line:f.start.line+1,column:0},E=new C(f.bufferIndex,u,f.end,this.getLineFeedCnt(f.bufferIndex,u,f.end),f.length-1);s.piece=E,t+=`
`,(0,A.updateTreeMetadata)(this,s,-1,-1),s.piece.length===0&&n.push(s)}const i=this.createNewPieces(t);let g=this.rbInsertLeft(s,i[i.length-1]);for(let f=i.length-2;f>=0;f--)g=this.rbInsertLeft(g,i[f]);this.validateCRLFWithPrevNode(g),this.deleteNodes(n)}insertContentToNodeRight(t,s){this.adjustCarriageReturnFromNext(t,s)&&(t+=`
`);const n=this.createNewPieces(t),i=this.rbInsertRight(s,n[0]);let g=i;for(let f=1;f<n.length;f++)g=this.rbInsertRight(g,n[f]);this.validateCRLFWithPrevNode(i)}positionInBuffer(t,s,n){const i=t.piece,g=t.piece.bufferIndex,f=this._buffers[g].lineStarts,E=f[i.start.line]+i.start.column+s;let I=i.start.line,_=i.end.line,w=0,p=0,D=0;for(;I<=_&&(w=I+(_-I)/2|0,D=f[w],w!==_);)if(p=f[w+1],E<D)_=w-1;else if(E>=p)I=w+1;else break;return n?(n.line=w,n.column=E-D,null):{line:w,column:E-D}}getLineFeedCnt(t,s,n){if(n.column===0)return n.line-s.line;const i=this._buffers[t].lineStarts;if(n.line===i.length-1)return n.line-s.line;const g=i[n.line+1],f=i[n.line]+n.column;if(g>f+1)return n.line-s.line;const u=f-1;return this._buffers[t].buffer.charCodeAt(u)===13?n.line-s.line+1:n.line-s.line}offsetInBuffer(t,s){return this._buffers[t].lineStarts[s.line]+s.column}deleteNodes(t){for(let s=0;s<t.length;s++)(0,A.rbDelete)(this,t[s])}createNewPieces(t){if(t.length>v){const _=[];for(;t.length>v;){const p=t.charCodeAt(v-1);let D;p===y.CharCode.CarriageReturn||p>=55296&&p<=56319?(D=t.substring(0,v-1),t=t.substring(v-1)):(D=t.substring(0,v),t=t.substring(v));const m=b(D);_.push(new C(this._buffers.length,{line:0,column:0},{line:m.length-1,column:D.length-m[m.length-1]},m.length-1,D.length)),this._buffers.push(new h(D,m))}const w=b(t);return _.push(new C(this._buffers.length,{line:0,column:0},{line:w.length-1,column:t.length-w[w.length-1]},w.length-1,t.length)),this._buffers.push(new h(t,w)),_}let s=this._buffers[0].buffer.length;const n=b(t,!1);let i=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===s&&s!==0&&this.startWithLF(t)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},i=this._lastChangeBufferPos;for(let _=0;_<n.length;_++)n[_]+=s+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(n.slice(1)),this._buffers[0].buffer+="_"+t,s+=1}else{if(s!==0)for(let _=0;_<n.length;_++)n[_]+=s;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(n.slice(1)),this._buffers[0].buffer+=t}const g=this._buffers[0].buffer.length,f=this._buffers[0].lineStarts.length-1,u=g-this._buffers[0].lineStarts[f],E={line:f,column:u},I=new C(0,i,E,this.getLineFeedCnt(0,i,E),g-s);return this._lastChangeBufferPos=E,[I]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(t,s=0){let n=this.root,i="";const g=this._searchCache.get2(t);if(g){n=g.node;const f=this.getAccumulatedValue(n,t-g.nodeStartLineNumber-1),u=this._buffers[n.piece.bufferIndex].buffer,E=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);if(g.nodeStartLineNumber+n.piece.lineFeedCnt===t)i=u.substring(E+f,E+n.piece.length);else{const I=this.getAccumulatedValue(n,t-g.nodeStartLineNumber);return u.substring(E+f,E+I-s)}}else{let f=0;const u=t;for(;n!==A.SENTINEL;)if(n.left!==A.SENTINEL&&n.lf_left>=t-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>t-1){const E=this.getAccumulatedValue(n,t-n.lf_left-2),I=this.getAccumulatedValue(n,t-n.lf_left-1),_=this._buffers[n.piece.bufferIndex].buffer,w=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);return f+=n.size_left,this._searchCache.set({node:n,nodeStartOffset:f,nodeStartLineNumber:u-(t-1-n.lf_left)}),_.substring(w+E,w+I-s)}else if(n.lf_left+n.piece.lineFeedCnt===t-1){const E=this.getAccumulatedValue(n,t-n.lf_left-2),I=this._buffers[n.piece.bufferIndex].buffer,_=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);i=I.substring(_+E,_+n.piece.length);break}else t-=n.lf_left+n.piece.lineFeedCnt,f+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==A.SENTINEL;){const f=this._buffers[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const u=this.getAccumulatedValue(n,0),E=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);return i+=f.substring(E,E+u-s),i}else{const u=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);i+=f.substr(u,n.piece.length)}n=n.next()}return i}computeBufferMetadata(){let t=this.root,s=1,n=0;for(;t!==A.SENTINEL;)s+=t.lf_left+t.piece.lineFeedCnt,n+=t.size_left+t.piece.length,t=t.right;this._lineCnt=s,this._length=n,this._searchCache.validate(this._length)}getIndexOf(t,s){const n=t.piece,i=this.positionInBuffer(t,s),g=i.line-n.start.line;if(this.offsetInBuffer(n.bufferIndex,n.end)-this.offsetInBuffer(n.bufferIndex,n.start)===s){const f=this.getLineFeedCnt(t.piece.bufferIndex,n.start,i);if(f!==g)return{index:f,remainder:0}}return{index:g,remainder:i.column}}getAccumulatedValue(t,s){if(s<0)return 0;const n=t.piece,i=this._buffers[n.bufferIndex].lineStarts,g=n.start.line+s+1;return g>n.end.line?i[n.end.line]+n.end.column-i[n.start.line]-n.start.column:i[g]-i[n.start.line]-n.start.column}deleteNodeTail(t,s){const n=t.piece,i=n.lineFeedCnt,g=this.offsetInBuffer(n.bufferIndex,n.end),f=s,u=this.offsetInBuffer(n.bufferIndex,f),E=this.getLineFeedCnt(n.bufferIndex,n.start,f),I=E-i,_=u-g,w=n.length+_;t.piece=new C(n.bufferIndex,n.start,f,E,w),(0,A.updateTreeMetadata)(this,t,_,I)}deleteNodeHead(t,s){const n=t.piece,i=n.lineFeedCnt,g=this.offsetInBuffer(n.bufferIndex,n.start),f=s,u=this.getLineFeedCnt(n.bufferIndex,f,n.end),E=this.offsetInBuffer(n.bufferIndex,f),I=u-i,_=g-E,w=n.length+_;t.piece=new C(n.bufferIndex,f,n.end,u,w),(0,A.updateTreeMetadata)(this,t,_,I)}shrinkNode(t,s,n){const i=t.piece,g=i.start,f=i.end,u=i.length,E=i.lineFeedCnt,I=s,_=this.getLineFeedCnt(i.bufferIndex,i.start,I),w=this.offsetInBuffer(i.bufferIndex,s)-this.offsetInBuffer(i.bufferIndex,g);t.piece=new C(i.bufferIndex,i.start,I,_,w),(0,A.updateTreeMetadata)(this,t,w-u,_-E);const p=new C(i.bufferIndex,n,f,this.getLineFeedCnt(i.bufferIndex,n,f),this.offsetInBuffer(i.bufferIndex,f)-this.offsetInBuffer(i.bufferIndex,n)),D=this.rbInsertRight(t,p);this.validateCRLFWithPrevNode(D)}appendToNode(t,s){this.adjustCarriageReturnFromNext(s,t)&&(s+=`
`);const n=this.shouldCheckCRLF()&&this.startWithLF(s)&&this.endWithCR(t),i=this._buffers[0].buffer.length;this._buffers[0].buffer+=s;const g=b(s,!1);for(let D=0;D<g.length;D++)g[D]+=i;if(n){const D=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:i-D}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(g.slice(1));const f=this._buffers[0].lineStarts.length-1,u=this._buffers[0].buffer.length-this._buffers[0].lineStarts[f],E={line:f,column:u},I=t.piece.length+s.length,_=t.piece.lineFeedCnt,w=this.getLineFeedCnt(0,t.piece.start,E),p=w-_;t.piece=new C(t.piece.bufferIndex,t.piece.start,E,w,I),this._lastChangeBufferPos=E,(0,A.updateTreeMetadata)(this,t,s.length,p)}nodeAt(t){let s=this.root;const n=this._searchCache.get(t);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:t-n.nodeStartOffset};let i=0;for(;s!==A.SENTINEL;)if(s.size_left>t)s=s.left;else if(s.size_left+s.piece.length>=t){i+=s.size_left;const g={node:s,remainder:t-s.size_left,nodeStartOffset:i};return this._searchCache.set(g),g}else t-=s.size_left+s.piece.length,i+=s.size_left+s.piece.length,s=s.right;return null}nodeAt2(t,s){let n=this.root,i=0;for(;n!==A.SENTINEL;)if(n.left!==A.SENTINEL&&n.lf_left>=t-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>t-1){const g=this.getAccumulatedValue(n,t-n.lf_left-2),f=this.getAccumulatedValue(n,t-n.lf_left-1);return i+=n.size_left,{node:n,remainder:Math.min(g+s-1,f),nodeStartOffset:i}}else if(n.lf_left+n.piece.lineFeedCnt===t-1){const g=this.getAccumulatedValue(n,t-n.lf_left-2);if(g+s-1<=n.piece.length)return{node:n,remainder:g+s-1,nodeStartOffset:i};s-=n.piece.length-g;break}else t-=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==A.SENTINEL;){if(n.piece.lineFeedCnt>0){const g=this.getAccumulatedValue(n,0),f=this.offsetOfNode(n);return{node:n,remainder:Math.min(s-1,g),nodeStartOffset:f}}else if(n.piece.length>=s-1){const g=this.offsetOfNode(n);return{node:n,remainder:s-1,nodeStartOffset:g}}else s-=n.piece.length;n=n.next()}return null}nodeCharCodeAt(t,s){if(t.piece.lineFeedCnt<1)return-1;const n=this._buffers[t.piece.bufferIndex],i=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start)+s;return n.buffer.charCodeAt(i)}offsetOfNode(t){if(!t)return 0;let s=t.size_left;for(;t!==this.root;)t.parent.right===t&&(s+=t.parent.size_left+t.parent.piece.length),t=t.parent;return s}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(t){if(typeof t=="string")return t.charCodeAt(0)===10;if(t===A.SENTINEL||t.piece.lineFeedCnt===0)return!1;const s=t.piece,n=this._buffers[s.bufferIndex].lineStarts,i=s.start.line,g=n[i]+s.start.column;return i===n.length-1||n[i+1]>g+1?!1:this._buffers[s.bufferIndex].buffer.charCodeAt(g)===10}endWithCR(t){return typeof t=="string"?t.charCodeAt(t.length-1)===13:t===A.SENTINEL||t.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(t,t.piece.length-1)===13}validateCRLFWithPrevNode(t){if(this.shouldCheckCRLF()&&this.startWithLF(t)){const s=t.prev();this.endWithCR(s)&&this.fixCRLF(s,t)}}validateCRLFWithNextNode(t){if(this.shouldCheckCRLF()&&this.endWithCR(t)){const s=t.next();this.startWithLF(s)&&this.fixCRLF(t,s)}}fixCRLF(t,s){const n=[],i=this._buffers[t.piece.bufferIndex].lineStarts;let g;t.piece.end.column===0?g={line:t.piece.end.line-1,column:i[t.piece.end.line]-i[t.piece.end.line-1]-1}:g={line:t.piece.end.line,column:t.piece.end.column-1};const f=t.piece.length-1,u=t.piece.lineFeedCnt-1;t.piece=new C(t.piece.bufferIndex,t.piece.start,g,u,f),(0,A.updateTreeMetadata)(this,t,-1,-1),t.piece.length===0&&n.push(t);const E={line:s.piece.start.line+1,column:0},I=s.piece.length-1,_=this.getLineFeedCnt(s.piece.bufferIndex,E,s.piece.end);s.piece=new C(s.piece.bufferIndex,E,s.piece.end,_,I),(0,A.updateTreeMetadata)(this,s,-1,-1),s.piece.length===0&&n.push(s);const w=this.createNewPieces(`\r
`);this.rbInsertRight(t,w[0]);for(let p=0;p<n.length;p++)(0,A.rbDelete)(this,n[p])}adjustCarriageReturnFromNext(t,s){if(this.shouldCheckCRLF()&&this.endWithCR(t)){const n=s.next();if(this.startWithLF(n)){if(t+=`
`,n.piece.length===1)(0,A.rbDelete)(this,n);else{const i=n.piece,g={line:i.start.line+1,column:0},f=i.length-1,u=this.getLineFeedCnt(i.bufferIndex,g,i.end);n.piece=new C(i.bufferIndex,g,i.end,u,f),(0,A.updateTreeMetadata)(this,n,-1,-1)}return!0}}return!1}iterate(t,s){if(t===A.SENTINEL)return s(A.SENTINEL);const n=this.iterate(t.left,s);return n&&s(t)&&this.iterate(t.right,s)}getNodeContent(t){if(t===A.SENTINEL)return"";const s=this._buffers[t.piece.bufferIndex],n=t.piece,i=this.offsetInBuffer(n.bufferIndex,n.start),g=this.offsetInBuffer(n.bufferIndex,n.end);return s.buffer.substring(i,g)}getPieceContent(t){const s=this._buffers[t.bufferIndex],n=this.offsetInBuffer(t.bufferIndex,t.start),i=this.offsetInBuffer(t.bufferIndex,t.end);return s.buffer.substring(n,i)}rbInsertRight(t,s){const n=new A.TreeNode(s,A.NodeColor.Red);if(n.left=A.SENTINEL,n.right=A.SENTINEL,n.parent=A.SENTINEL,n.size_left=0,n.lf_left=0,this.root===A.SENTINEL)this.root=n,n.color=A.NodeColor.Black;else if(t.right===A.SENTINEL)t.right=n,n.parent=t;else{const g=(0,A.leftest)(t.right);g.left=n,n.parent=g}return(0,A.fixInsert)(this,n),n}rbInsertLeft(t,s){const n=new A.TreeNode(s,A.NodeColor.Red);if(n.left=A.SENTINEL,n.right=A.SENTINEL,n.parent=A.SENTINEL,n.size_left=0,n.lf_left=0,this.root===A.SENTINEL)this.root=n,n.color=A.NodeColor.Black;else if(t.left===A.SENTINEL)t.left=n,n.parent=t;else{const i=(0,A.righttest)(t.left);i.right=n,n.parent=i}return(0,A.fixInsert)(this,n),n}getContentOfSubTree(t){let s="";return this.iterate(t,n=>(s+=this.getNodeContent(n),!0)),s}}e.PieceTreeBase=a}),define(De[152],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class y{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(O){if(O&&this._dragOperations.has(O)){const A=this._dragOperations.get(O);return this._dragOperations.delete(O),A}}addDragOperationTransfer(O,A){this._dragOperations.set(O,A)}}e.TreeViewsDnDService=y;class k{constructor(O){this.identifier=O}}e.DraggedTreeItemsIdentifier=k}),define(De[153],Ie([8,9]),function(he,e){return he.create("vs/base/common/actions",e)}),define(De[154],Ie([1,0,4,6,153]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=T;class O extends k.Disposable{constructor(c,C="",h="",r=!0,o){super(),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=c,this._label=C,this._cssClass=h,this._enabled=r,this._actionCallback=o}get id(){return this._id}get label(){return this._label}set label(c){this._setLabel(c)}_setLabel(c){this._label!==c&&(this._label=c,this._onDidChange.fire({label:c}))}get tooltip(){return this._tooltip||""}set tooltip(c){this._setTooltip(c)}_setTooltip(c){this._tooltip!==c&&(this._tooltip=c,this._onDidChange.fire({tooltip:c}))}get class(){return this._cssClass}set class(c){this._setClass(c)}_setClass(c){this._cssClass!==c&&(this._cssClass=c,this._onDidChange.fire({class:c}))}get enabled(){return this._enabled}set enabled(c){this._setEnabled(c)}_setEnabled(c){this._enabled!==c&&(this._enabled=c,this._onDidChange.fire({enabled:c}))}get checked(){return this._checked}set checked(c){this._setChecked(c)}_setChecked(c){this._checked!==c&&(this._checked=c,this._onDidChange.fire({checked:c}))}async run(c,C){this._actionCallback&&await this._actionCallback(c)}}e.Action=O;class A extends k.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new y.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new y.Emitter),this.onDidRun=this._onDidRun.event}async run(c,C){if(!c.enabled)return;this._onWillRun.fire({action:c});let h;try{await this.runAction(c,C)}catch(r){h=r}this._onDidRun.fire({action:c,error:h})}async runAction(c,C){await c.run(C)}}e.ActionRunner=A;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let C=[];for(const h of c)h.length&&(C.length?C=[...C,new R,...h]:C=h);return C}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=R;class v{get actions(){return this._actions}constructor(c,C,h,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=C,this.class=r,this._actions=h}async run(){}}e.SubmenuAction=v;class l extends O{static{this.ID="vs.actions.empty"}constructor(){super(l.ID,P.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=l;function T(b){return{id:b.id,label:b.label,tooltip:b.tooltip??b.label,class:b.class,enabled:b.enabled??!0,checked:b.checked,run:async(...c)=>b.run(...c)}}}),define(De[155],Ie([8,9]),function(he,e){return he.create("vs/base/common/date",e)}),define(De[156],Ie([1,0,155]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=l,e.getDurationString=T,e.toLocalISOString=b;const k=60,P=k*60,O=P*24,A=O*7,R=O*30,v=O*365;function l(c,C,h,r){typeof c!="number"&&(c=c.getTime());const o=Math.round((new Date().getTime()-c)/1e3);if(o<-30)return(0,y.localize)(0,null,l(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,y.localize)(1,null);let a;return o<k?(a=o,C?a===1?h?(0,y.localize)(2,null,a):(0,y.localize)(3,null,a):h?(0,y.localize)(4,null,a):(0,y.localize)(5,null,a):a===1?h?(0,y.localize)(6,null,a):(0,y.localize)(7,null,a):h?(0,y.localize)(8,null,a):(0,y.localize)(9,null,a)):o<P?(a=Math.floor(o/k),C?a===1?h?(0,y.localize)(10,null,a):(0,y.localize)(11,null,a):h?(0,y.localize)(12,null,a):(0,y.localize)(13,null,a):a===1?h?(0,y.localize)(14,null,a):(0,y.localize)(15,null,a):h?(0,y.localize)(16,null,a):(0,y.localize)(17,null,a)):o<O?(a=Math.floor(o/P),C?a===1?h?(0,y.localize)(18,null,a):(0,y.localize)(19,null,a):h?(0,y.localize)(20,null,a):(0,y.localize)(21,null,a):a===1?h?(0,y.localize)(22,null,a):(0,y.localize)(23,null,a):h?(0,y.localize)(24,null,a):(0,y.localize)(25,null,a)):o<A?(a=Math.floor(o/O),C?a===1?(0,y.localize)(26,null,a):(0,y.localize)(27,null,a):a===1?(0,y.localize)(28,null,a):(0,y.localize)(29,null,a)):o<R?(a=Math.floor(o/A),C?a===1?h?(0,y.localize)(30,null,a):(0,y.localize)(31,null,a):h?(0,y.localize)(32,null,a):(0,y.localize)(33,null,a):a===1?h?(0,y.localize)(34,null,a):(0,y.localize)(35,null,a):h?(0,y.localize)(36,null,a):(0,y.localize)(37,null,a)):o<v?(a=Math.floor(o/R),C?a===1?h?(0,y.localize)(38,null,a):(0,y.localize)(39,null,a):h?(0,y.localize)(40,null,a):(0,y.localize)(41,null,a):a===1?h?(0,y.localize)(42,null,a):(0,y.localize)(43,null,a):h?(0,y.localize)(44,null,a):(0,y.localize)(45,null,a)):(a=Math.floor(o/v),C?a===1?h?(0,y.localize)(46,null,a):(0,y.localize)(47,null,a):h?(0,y.localize)(48,null,a):(0,y.localize)(49,null,a):a===1?h?(0,y.localize)(50,null,a):(0,y.localize)(51,null,a):h?(0,y.localize)(52,null,a):(0,y.localize)(53,null,a))}function T(c,C){const h=Math.abs(c/1e3);return h<1?C?(0,y.localize)(54,null,c):(0,y.localize)(55,null,c):h<k?C?(0,y.localize)(56,null,Math.round(c)/1e3):(0,y.localize)(57,null,Math.round(c)/1e3):h<P?C?(0,y.localize)(58,null,Math.round(c/(1e3*k))):(0,y.localize)(59,null,Math.round(c/(1e3*k))):h<O?C?(0,y.localize)(60,null,Math.round(c/(1e3*P))):(0,y.localize)(61,null,Math.round(c/(1e3*P))):(0,y.localize)(62,null,Math.round(c/(1e3*O)))}function b(c){return c.getFullYear()+"-"+String(c.getMonth()+1).padStart(2,"0")+"-"+String(c.getDate()).padStart(2,"0")+"T"+String(c.getHours()).padStart(2,"0")+":"+String(c.getMinutes()).padStart(2,"0")+":"+String(c.getSeconds()).padStart(2,"0")+"."+(c.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(De[157],Ie([8,9]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(De[48],Ie([1,0,18,15,157]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=v,e.isErrorWithActions=l,e.createErrorWithActions=T;function O(b,c){return c&&(b.stack||b.stacktrace)?P.localize(0,null,R(b),A(b.stack)||A(b.stacktrace)):R(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function R(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?P.localize(1,null,b.message):b.message||P.localize(2,null)}function v(b=null,c=!1){if(!b)return P.localize(3,null);if(Array.isArray(b)){const C=y.coalesce(b),h=v(C[0],c);return C.length>1?P.localize(4,null,h,C.length):h}if(k.isString(b))return b;if(b.detail){const C=b.detail;if(C.error)return O(C.error,c);if(C.exception)return O(C.exception,c)}return b.stack?O(b,c):b.message?b.message:P.localize(5,null)}function l(b){const c=b;return c instanceof Error&&Array.isArray(c.actions)}function T(b,c){let C;return typeof b=="string"?C=new Error(b):C=b,C.actions=c,C}}),define(De[158],Ie([1,0,47,20]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=R,e.compareFileNamesDefault=v,e.compareFileNamesUpper=l,e.compareFileNamesLower=T,e.compareFileNamesUnicode=b,e.compareFileExtensions=c,e.compareFileExtensionsDefault=C,e.compareFileExtensionsUpper=h,e.compareFileExtensionsLower=r,e.compareFileExtensionsUnicode=o,e.comparePaths=E,e.compareAnything=I,e.compareByPrefix=_;const P=new y.Lazy(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),O=new y.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(w,p,D=!1){const m=w||"",S=p||"",M=P.value.collator.compare(m,S);return P.value.collatorIsNumeric&&M===0&&m!==S?m<S?-1:1:M}function v(w,p){const D=O.value.collator;return w=w||"",p=p||"",s(D,w,p)}function l(w,p){const D=O.value.collator;return w=w||"",p=p||"",f(w,p)||s(D,w,p)}function T(w,p){const D=O.value.collator;return w=w||"",p=p||"",g(w,p)||s(D,w,p)}function b(w,p){return w=w||"",p=p||"",w===p?0:w<p?-1:1}function c(w,p){const[D,m]=d(w),[S,M]=d(p);let L=P.value.collator.compare(m,M);if(L===0){if(P.value.collatorIsNumeric&&m!==M)return m<M?-1:1;if(L=P.value.collator.compare(D,S),P.value.collatorIsNumeric&&L===0&&D!==S)return D<S?-1:1}return L}function C(w,p){w=w||"",p=p||"";const D=t(w),m=t(p),S=O.value.collator,M=A.value.collator;return s(M,D,m)||s(S,w,p)}function h(w,p){w=w||"",p=p||"";const D=t(w),m=t(p),S=O.value.collator,M=A.value.collator;return s(M,D,m)||f(w,p)||s(S,w,p)}function r(w,p){w=w||"",p=p||"";const D=t(w),m=t(p),S=O.value.collator,M=A.value.collator;return s(M,D,m)||g(w,p)||s(S,w,p)}function o(w,p){w=w||"",p=p||"";const D=t(w).toLowerCase(),m=t(p).toLowerCase();return D!==m?D<m?-1:1:w!==p?w<p?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function d(w,p=!1){const D=w?a.exec(w):[];let m=[D&&D[1]||"",D&&D[3]||""];return p&&(!m[0]&&m[1]||m[0]&&m[0].charAt(0)===".")&&(m=[m[0]+"."+m[1],""]),m}function t(w){const p=w?a.exec(w):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function s(w,p,D){const m=w.compare(p,D);return m!==0?m:p.length!==D.length?p.length<D.length?-1:1:0}function n(w){const p=w.charAt(0);return p.toLocaleUpperCase()!==p}function i(w){const p=w.charAt(0);return p.toLocaleLowerCase()!==p}function g(w,p){return n(w)&&i(p)?-1:i(w)&&n(p)?1:0}function f(w,p){return i(w)&&n(p)?-1:n(w)&&i(p)?1:0}function u(w,p,D=!1){return D||(w=w&&w.toLowerCase(),p=p&&p.toLowerCase()),w===p?0:w<p?-1:1}function E(w,p,D=!1){const m=w.split(k.sep),S=p.split(k.sep),M=m.length-1,L=S.length-1;let H,V;for(let $=0;;$++){if(H=M===$,V=L===$,H&&V)return R(m[$],S[$],D);if(H)return-1;if(V)return 1;const N=u(m[$],S[$],D);if(N!==0)return N}}function I(w,p,D){const m=w.toLowerCase(),S=p.toLowerCase(),M=_(w,p,D);if(M)return M;const L=m.endsWith(D),H=S.endsWith(D);if(L!==H)return L?-1:1;const V=R(m,S);return V!==0?V:m.localeCompare(S)}function _(w,p,D){const m=w.toLowerCase(),S=p.toLowerCase(),M=m.startsWith(D),L=S.startsWith(D);if(M!==L)return M?-1:1;if(M&&L){if(m.length<S.length)return-1;if(m.length>S.length)return 1}return 0}}),define(De[53],Ie([1,0,28,20,21,13,15]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=v,e.toPosixPath=l,e.getRoot=T,e.isUNC=b,e.isValidBasename=r,e.isEqual=o,e.isEqualOrParent=a,e.isWindowsDriveLetter=d,e.sanitizeFilePath=t,e.removeTrailingPathSeparator=s,e.isRootOrDriveLetter=n,e.hasDriveLetter=i,e.getDriveLetter=g,e.indexOfPath=f,e.parseLineAndColumnAware=u,e.randomPath=_;function R(w){return w===y.CharCode.Slash||w===y.CharCode.Backslash}function v(w){return w.replace(/[\\/]/g,k.posix.sep)}function l(w){return w.indexOf("/")===-1&&(w=v(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function T(w,p=k.posix.sep){if(!w)return"";const D=w.length,m=w.charCodeAt(0);if(R(m)){if(R(w.charCodeAt(1))&&!R(w.charCodeAt(2))){let M=3;const L=M;for(;M<D&&!R(w.charCodeAt(M));M++);if(L!==M&&!R(w.charCodeAt(M+1))){for(M+=1;M<D;M++)if(R(w.charCodeAt(M)))return w.slice(0,M+1).replace(/[\\/]/g,p)}}return p}else if(d(m)&&w.charCodeAt(1)===y.CharCode.Colon)return R(w.charCodeAt(2))?w.slice(0,2)+p:w.slice(0,2);let S=w.indexOf("://");if(S!==-1){for(S+=3;S<D;S++)if(R(w.charCodeAt(S)))return w.slice(0,S+1)}return""}function b(w){if(!P.isWindows||!w||w.length<5)return!1;let p=w.charCodeAt(0);if(p!==y.CharCode.Backslash||(p=w.charCodeAt(1),p!==y.CharCode.Backslash))return!1;let D=2;const m=D;for(;D<w.length&&(p=w.charCodeAt(D),p!==y.CharCode.Backslash);D++);return!(m===D||(p=w.charCodeAt(D+1),isNaN(p)||p===y.CharCode.Backslash))}const c=/[\\/:\*\?"<>\|]/g,C=/[/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(w,p=P.isWindows){const D=p?c:C;return!(!w||w.length===0||/^\s+$/.test(w)||(D.lastIndex=0,D.test(w))||p&&h.test(w)||w==="."||w===".."||p&&w[w.length-1]==="."||p&&w.length!==w.trim().length||w.length>255)}function o(w,p,D){const m=w===p;return!D||m?m:!w||!p?!1:(0,O.equalsIgnoreCase)(w,p)}function a(w,p,D,m=k.sep){if(w===p)return!0;if(!w||!p||p.length>w.length)return!1;if(D){if(!(0,O.startsWithIgnoreCase)(w,p))return!1;if(p.length===w.length)return!0;let M=p.length;return p.charAt(p.length-1)===m&&M--,w.charAt(M)===m}return p.charAt(p.length-1)!==m&&(p+=m),w.indexOf(p)===0}function d(w){return w>=y.CharCode.A&&w<=y.CharCode.Z||w>=y.CharCode.a&&w<=y.CharCode.z}function t(w,p){return P.isWindows&&w.endsWith(":")&&(w+=k.sep),(0,k.isAbsolute)(w)||(w=(0,k.join)(p,w)),w=(0,k.normalize)(w),s(w)}function s(w){return P.isWindows?(w=(0,O.rtrim)(w,k.sep),w.endsWith(":")&&(w+=k.sep)):(w=(0,O.rtrim)(w,k.sep),w||(w=k.sep)),w}function n(w){const p=(0,k.normalize)(w);return P.isWindows?w.length>3?!1:i(p)&&(w.length===2||p.charCodeAt(2)===y.CharCode.Backslash):p===k.posix.sep}function i(w,p=P.isWindows){return p?d(w.charCodeAt(0))&&w.charCodeAt(1)===y.CharCode.Colon:!1}function g(w,p=P.isWindows){return i(w,p)?w[0]:void 0}function f(w,p,D){return p.length>w.length?-1:w===p?0:(D&&(w=w.toLowerCase(),p=p.toLowerCase()),w.indexOf(p))}function u(w){const p=w.split(":");let D,m,S;for(const M of p){const L=Number(M);(0,A.isNumber)(L)?m===void 0?m=L:S===void 0&&(S=L):D=D?[D,M].join(":"):M}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:m!==void 0?m:void 0,column:S!==void 0?S:m!==void 0?1:void 0}}const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function _(w,p,D=8){let m="";for(let M=0;M<D;M++){let L;M===0&&P.isWindows&&!p&&(D===3||D===4)?L=I:L=E,m+=L.charAt(Math.floor(Math.random()*L.length))}let S;return p?S=`${p}-${m}`:S=m,w?(0,k.join)(w,S):S}}),define(De[73],Ie([1,0,20]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=O,e.getMediaMime=A,e.getExtensionForMimeType=R,e.normalizeMimeType=l,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(T){const b=(0,y.extname)(T),c=k[b.toLowerCase()];return c!==void 0?c:A(T)}function A(T){const b=(0,y.extname)(T);return P[b.toLowerCase()]}function R(T){for(const b in P)if(P[b]===T)return b}const v=/^(.+)\/(.+?)(;.+)?$/;function l(T,b){const c=v.exec(T);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:b?void 0:T}}),define(De[49],Ie([1,0,23,2,37]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=O,e.parse=A,e.revive=v;function O(l){return JSON.stringify(l,R)}function A(l){let T=JSON.parse(l);return T=v(T),T}function R(l,T){return T instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:T.source,flags:T.flags}:T}function v(l,T=0){if(!l||T>200)return l;if(typeof l=="object"){switch(l.$mid){case P.MarshalledId.Uri:return k.URI.revive(l);case P.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case P.MarshalledId.Date:return new Date(l.source)}if(l instanceof y.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let b=0;b<l.length;++b)l[b]=v(l[b],T+1);else for(const b in l)Object.hasOwnProperty.call(l,b)&&(l[b]=v(l[b],T+1))}return l}}),define(De[16],Ie([1,0,14,21,13,2,20]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=v,e.matchesSomeScheme=l,e.getServerRootPath=b;var R;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",h.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.commentsInput="comment",h.codeSetting="code-setting"})(R||(e.Schemas=R={}));function v(h,r){return O.URI.isUri(h)?(0,P.equalsIgnoreCase)(h.scheme,r):(0,P.startsWithIgnoreCase)(h,r+":")}function l(h,...r){return r.some(o=>v(h,o))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(r){this._preferredWebSchema=r}setDelegate(r){this._delegate=r}setServerRootPath(r,o){this._serverRootPath=b(r,o)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return A.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(r,o,a){this._hosts[r]=o,this._ports[r]=a}setConnectionToken(r,o){this._connectionTokens[r]=o}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(r){if(this._delegate)try{return this._delegate(r)}catch(n){return y.onUnexpectedError(n),r}const o=r.authority;let a=this._hosts[o];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const d=this._ports[o],t=this._connectionTokens[o];let s=`path=${encodeURIComponent(r.path)}`;return typeof t=="string"&&(s+=`&${e.connectionTokenQueryName}=${encodeURIComponent(t)}`),O.URI.from({scheme:k.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${a}:${d}`,path:this._remoteResourcesPath,query:s})}}e.RemoteAuthorities=new T;function b(h,r){return A.posix.join(r??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class c{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(r){const o=this.toUri(r,he);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===R.file&&(k.isNative||k.webWorkerOrigin===`${R.vscodeFileResource}://${c.FALLBACK_AUTHORITY}`)?r.with({scheme:R.vscodeFileResource,authority:r.authority||c.FALLBACK_AUTHORITY,query:null,fragment:null}):r}asFileUri(r){const o=this.toUri(r,he);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===R.vscodeFileResource?r.with({scheme:R.file,authority:r.authority!==c.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(r,o){return O.URI.isUri(r)?r:O.URI.parse(o.toUrl(r))}}e.FileAccess=new c;var C;(function(h){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function a(t){let s;typeof t=="string"?s=new URL(t).searchParams:t instanceof URL?s=t.searchParams:O.URI.isUri(t)&&(s=new URL(t.toString(!0)).searchParams);const n=s?.get(o);if(n)return r.get(n)}h.getHeadersFromQuery=a;function d(t,s,n){if(!globalThis.crossOriginIsolated)return;const i=s&&n?"3":n?"2":"1";t instanceof URLSearchParams?t.set(o,i):t[o]=i}h.addSearchParam=d})(C||(e.COI=C={}))}),define(De[24],Ie([1,0,28,53,16,20,21,13,2]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=l,e.distinctParents=b,e.toLocalResource=C;function l(h){return(0,v.uriToFsPath)(h,!0)}class T{constructor(r){this._ignorePathCasing=r}compare(r,o,a=!1){return r===o?0:(0,R.compare)(this.getComparisonKey(r,a),this.getComparisonKey(o,a))}isEqual(r,o,a=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,a)===this.getComparisonKey(o,a)}getComparisonKey(r,o=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,o,a=!1){if(r.scheme===o.scheme){if(r.scheme===P.Schemas.file)return k.isEqualOrParent(l(r),l(o),this._ignorePathCasing(r))&&r.query===o.query&&(a||r.fragment===o.fragment);if((0,e.isEqualAuthority)(r.authority,o.authority))return k.isEqualOrParent(r.path,o.path,this._ignorePathCasing(r),"/")&&r.query===o.query&&(a||r.fragment===o.fragment)}return!1}joinPath(r,...o){return v.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return O.posix.basename(r.path)}extname(r){return O.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===P.Schemas.file?o=v.URI.file(O.dirname(l(r))).path:(o=O.posix.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==y.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===P.Schemas.file?o=v.URI.file(O.normalize(l(r))).path:o=O.posix.normalize(r.path),r.with({path:o})}relativePath(r,o){if(r.scheme!==o.scheme||!(0,e.isEqualAuthority)(r.authority,o.authority))return;if(r.scheme===P.Schemas.file){const t=O.relative(l(r),l(o));return A.isWindows?k.toSlashes(t):t}let a=r.path||"/";const d=o.path||"/";if(this._ignorePathCasing(r)){let t=0;for(const s=Math.min(a.length,d.length);t<s&&!(a.charCodeAt(t)!==d.charCodeAt(t)&&a.charAt(t).toLowerCase()!==d.charAt(t).toLowerCase());t++);a=d.substr(0,t)+a.substr(t)}return O.posix.relative(a,d)}resolvePath(r,o){if(r.scheme===P.Schemas.file){const a=v.URI.file(O.resolve(l(r),o));return r.with({authority:a.authority,path:a.path})}return o=k.toPosixPath(o),r.with({path:O.posix.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||r!==void 0&&o!==void 0&&(0,R.equalsIgnoreCase)(r,o)}hasTrailingPathSeparator(r,o=O.sep){if(r.scheme===P.Schemas.file){const a=l(r);return a.length>k.getRoot(a).length&&a[a.length-1]===o}else{const a=r.path;return a.length>1&&a.charCodeAt(a.length-1)===y.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=O.sep){return(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=O.sep){let a=!1;if(r.scheme===P.Schemas.file){const d=l(r);a=d!==void 0&&d.length===k.getRoot(d).length&&d[d.length-1]===o}else{o="/";const d=r.path;a=d.length===1&&d.charCodeAt(d.length-1)===y.CharCode.Slash}return!a&&!(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path+"/"}):r}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(h=>h.scheme===P.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(h,r){const o=[];for(let a=0;a<h.length;a++){const d=r(h[a]);h.some((t,s)=>s===a?!1:(0,e.isEqualOrParent)(d,r(t)))||o.push(h[a])}return o}var c;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function r(o){const a=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(s=>{const[n,i]=s.split(":");n&&i&&a.set(n,i)});const t=o.path.substring(0,o.path.indexOf(";"));return t&&a.set(h.META_DATA_MIME,t),a}h.parseMetaData=r})(c||(e.DataUri=c={}));function C(h,r,o){if(r){let a=h.path;return a&&a[0]!==O.posix.sep&&(a=O.posix.sep+a),h.with({scheme:o,authority:r,path:a})}return h.with({scheme:o})}}),define(De[11],Ie([1,0,22,14,4,6,24,21,144,47]),function(he,e,y,k,P,O,A,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=T,e.createCancelablePromise=b,e.raceCancellation=c,e.raceCancellationError=C,e.raceCancellablePromises=h,e.raceTimeout=r,e.asPromise=o,e.promiseWithResolvers=a,e.timeout=I,e.disposableTimeout=_,e.sequence=w,e.first=p,e.firstParallel=D,e.retry=Ee,e.createCancelableAsyncIterable=de;function T(ae){return!!ae&&typeof ae.then=="function"}function b(ae){const X=new y.CancellationTokenSource,J=ae(X.token),me=new Promise((ge,Le)=>{const ze=X.token.onCancellationRequested(()=>{ze.dispose(),Le(new k.CancellationError)});Promise.resolve(J).then(ye=>{ze.dispose(),X.dispose(),ge(ye)},ye=>{ze.dispose(),X.dispose(),Le(ye)})});return new class{cancel(){X.cancel(),X.dispose()}then(ge,Le){return me.then(ge,Le)}catch(ge){return this.then(void 0,ge)}finally(ge){return me.finally(ge)}}}function c(ae,X,J){return new Promise((me,ge)=>{const Le=X.onCancellationRequested(()=>{Le.dispose(),me(J)});ae.then(me,ge).finally(()=>Le.dispose())})}function C(ae,X){return new Promise((J,me)=>{const ge=X.onCancellationRequested(()=>{ge.dispose(),me(new k.CancellationError)});ae.then(J,me).finally(()=>ge.dispose())})}async function h(ae){let X=-1;const J=ae.map((me,ge)=>me.then(Le=>(X=ge,Le)));try{return await Promise.race(J)}finally{ae.forEach((me,ge)=>{ge!==X&&me.cancel()})}}function r(ae,X,J){let me;const ge=setTimeout(()=>{me?.(void 0),J?.()},X);return Promise.race([ae.finally(()=>clearTimeout(ge)),new Promise(Le=>me=Le)])}function o(ae){return new Promise((X,J)=>{const me=ae();T(me)?me.then(X,J):X(me)})}function a(){let ae,X;return{promise:new Promise((me,ge)=>{ae=me,X=ge}),resolve:ae,reject:X}}class d{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(X){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=X,!this.queuedPromise){const J=()=>{if(this.queuedPromise=null,this.isDisposed)return;const me=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,me};this.queuedPromise=new Promise(me=>{this.activePromise.then(J,J).then(me)})}return new Promise((J,me)=>{this.queuedPromise.then(J,me)})}return this.activePromise=X(),new Promise((J,me)=>{this.activePromise.then(ge=>{this.activePromise=null,J(ge)},ge=>{this.activePromise=null,me(ge)})})}dispose(){this.isDisposed=!0}}e.Throttler=d;class t{constructor(){this.current=Promise.resolve(null)}queue(X){return this.current=this.current.then(()=>X(),()=>X())}}e.Sequencer=t;class s{constructor(){this.promiseMap=new Map}queue(X,J){const ge=(this.promiseMap.get(X)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.promiseMap.get(X)===ge&&this.promiseMap.delete(X)});return this.promiseMap.set(X,ge),ge}}e.SequencerByKey=s;const n=(ae,X)=>{let J=!0;const me=setTimeout(()=>{J=!1,X()},ae);return{isTriggered:()=>J,dispose:()=>{clearTimeout(me),J=!1}}},i=ae=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ae())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class g{constructor(X){this.defaultDelay=X,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(X,J=this.defaultDelay){this.task=X,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,Le)=>{this.doResolve=ge,this.doReject=Le}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const me=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=J===v.MicrotaskDelay?i(me):n(J,me),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new k.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class f{constructor(X){this.delayer=new g(X),this.throttler=new d}trigger(X,J){return this.delayer.trigger(()=>this.throttler.queue(X),J)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=f;class u{constructor(){this._isOpen=!1,this._promise=new Promise((X,J)=>{this._completePromise=X})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class E extends u{constructor(X){super(),this._timeout=setTimeout(()=>this.open(),X)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=E;function I(ae,X){return X?new Promise((J,me)=>{const ge=setTimeout(()=>{Le.dispose(),J()},ae),Le=X.onCancellationRequested(()=>{clearTimeout(ge),Le.dispose(),me(new k.CancellationError)})}):b(J=>I(ae,J))}function _(ae,X=0,J){const me=setTimeout(()=>{ae(),J&&ge.dispose()},X),ge=(0,O.toDisposable)(()=>{clearTimeout(me),J?.deleteAndLeak(ge)});return J?.add(ge),ge}function w(ae){const X=[];let J=0;const me=ae.length;function ge(){return J<me?ae[J++]():null}function Le(ze){ze!=null&&X.push(ze);const ye=ge();return ye?ye.then(Le):Promise.resolve(X)}return Promise.resolve(null).then(Le)}function p(ae,X=me=>!!me,J=null){let me=0;const ge=ae.length,Le=()=>{if(me>=ge)return Promise.resolve(J);const ze=ae[me++];return Promise.resolve(ze()).then(ke=>X(ke)?Promise.resolve(ke):Le())};return Le()}function D(ae,X=me=>!!me,J=null){if(ae.length===0)return Promise.resolve(J);let me=ae.length;const ge=()=>{me=-1;for(const Le of ae)Le.cancel?.()};return new Promise((Le,ze)=>{for(const ye of ae)ye.then(ke=>{--me>=0&&X(ke)?(ge(),Le(ke)):me===0&&Le(J)}).catch(ke=>{--me>=0&&(ge(),ze(ke))})})}class m{constructor(X){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=X,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new P.Emitter}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(X){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((J,me)=>{this.outstandingPromises.push({factory:X,c:J,e:me}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const X=this.outstandingPromises.shift();this.runningPromises++;const J=X.factory();J.then(X.c,X.e),J.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=m;class S extends m{constructor(){super(1)}}e.Queue=S;class M{constructor(){this.sequentializer=new oe,this.tasks=0}queue(X){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,X())):this.sequentializer.run(this.tasks++,X())}}e.LimitedQueue=M;class L{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const X=new se;return this.drainers.add(X),X.p}isDrained(){for(const[,X]of this.queues)if(X.size>0)return!1;return!0}queueSize(X,J=A.extUri){const me=J.getComparisonKey(X);return this.queues.get(me)?.size??0}queueFor(X,J,me=A.extUri){const ge=me.getComparisonKey(X);let Le=this.queues.get(ge);if(!Le){Le=new S;const ze=this.drainListenerCount++,ye=P.Event.once(Le.onDrained)(()=>{Le?.dispose(),this.queues.delete(ge),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ze),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(ze,ye),this.queues.set(ge,Le)}return Le.queue(J)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const X of this.drainers)X.complete();this.drainers.clear()}dispose(){for(const[,X]of this.queues)X.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=L;class H{constructor(X,J){this._isDisposed=!1,this._token=-1,typeof X=="function"&&typeof J=="number"&&this.setIfNotSet(X,J)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(X,J){if(this._isDisposed)throw new k.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,X()},J)}setIfNotSet(X,J){if(this._isDisposed)throw new k.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,X()},J))}}e.TimeoutTimer=H;class V{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(X,J,me=globalThis){if(this.isDisposed)throw new k.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=me.setInterval(()=>{X()},J);this.disposable=(0,O.toDisposable)(()=>{me.clearInterval(ge),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=V;class ${constructor(X,J){this.timeoutToken=-1,this.runner=X,this.timeout=J,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(X=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,X)}get delay(){return this.timeout}set delay(X){this.timeout=X}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class N{constructor(X,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.runner=X,this.timeout=J,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(X=this.timeout){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(X/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=N;class F extends ${constructor(X,J){super(X,J),this.units=[]}work(X){this.units.push(X),this.isScheduled()||this.schedule()}doRun(){const X=this.units;this.units=[],this.runner?.(X)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class Y extends O.Disposable{constructor(X,J){super(),this.options=X,this.handler=J,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(X){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+X.length>this.options.maxBufferedWork)return!1}else if(this.pending+X.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const J of X)this.pendingWork.push(J);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(ae,X)=>{(0,R.setTimeout0)(()=>{if(J)return;const me=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e._runWhenIdle=(ae,X,J)=>{const me=ae.requestIdleCallback(X,typeof J=="number"?{timeout:J}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,ae.cancelIdleCallback(me))}}},e.runWhenGlobalIdle=ae=>(0,e._runWhenIdle)(globalThis,ae)}();class re{constructor(X,J){this._didRun=!1,this._executor=()=>{try{this._value=J()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(X,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=re;class fe extends re{constructor(X){super(globalThis,X)}}e.GlobalIdleValue=fe;async function Ee(ae,X,J){let me;for(let ge=0;ge<J;ge++)try{return await ae()}catch(Le){me=Le,await I(X)}throw me}class oe{isRunning(X){return typeof X=="number"?this._running?.taskId===X:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(X,J,me){return this._running={taskId:X,cancel:()=>me?.(),promise:J},J.then(()=>this.doneRunning(X),()=>this.doneRunning(X)),J}doneRunning(X){this._running&&X===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const X=this._queued;this._queued=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this._queued)this._queued.run=X;else{const{promise:J,resolve:me,reject:ge}=a();this._queued={run:X,promise:J,promiseResolve:me,promiseReject:ge}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=oe;class pe{constructor(X,J=()=>Date.now()){this.interval=X,this.nowFn=J,this.lastIncrementTime=0,this.value=0}increment(){const X=this.nowFn();return X-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=X,this.value=0),this.value++,this.value}}e.IntervalCounter=pe;var ve;(function(ae){ae[ae.Resolved=0]="Resolved",ae[ae.Rejected=1]="Rejected"})(ve||(ve={}));class se{get isRejected(){return this.outcome?.outcome===ve.Rejected}get isResolved(){return this.outcome?.outcome===ve.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ve.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((X,J)=>{this.completeCallback=X,this.errorCallback=J})}complete(X){return new Promise(J=>{this.completeCallback(X),this.outcome={outcome:ve.Resolved,value:X},J()})}error(X){return new Promise(J=>{this.errorCallback(X),this.outcome={outcome:ve.Rejected,value:X},J()})}cancel(){return this.error(new k.CancellationError)}}e.DeferredPromise=se;var Te;(function(ae){async function X(me){let ge;const Le=await Promise.all(me.map(ze=>ze.then(ye=>ye,ye=>{ge||(ge=ye)})));if(typeof ge<"u")throw ge;return Le}ae.settled=X;function J(me){return new Promise(async(ge,Le)=>{try{await me(ge,Le)}catch(ze){Le(ze)}})}ae.withAsyncBody=J})(Te||(e.Promises=Te={}));class Me{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(X){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=X.then(J=>(this._value=J,this._isResolved=!0,J),J=>{throw this._error=J,this._isResolved=!0,J})}requireValue(){if(!this._isResolved)throw new k.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=Me;class Q{constructor(X){this._compute=X,this._promise=new l.Lazy(()=>new Me(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=Q;var W;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(W||(W={}));class ie{static fromArray(X){return new ie(J=>{J.emitMany(X)})}static fromPromise(X){return new ie(async J=>{J.emitMany(await X)})}static fromPromises(X){return new ie(async J=>{await Promise.all(X.map(async me=>J.emitOne(await me)))})}static merge(X){return new ie(async J=>{await Promise.all(X.map(async me=>{for await(const ge of me)J.emitOne(ge)}))})}static{this.EMPTY=ie.fromArray([])}constructor(X,J){this._state=W.Initial,this._results=[],this._error=null,this._onReturn=J,this._onStateChanged=new P.Emitter,queueMicrotask(async()=>{const me={emitOne:ge=>this.emitOne(ge),emitMany:ge=>this.emitMany(ge),reject:ge=>this.reject(ge)};try{await Promise.resolve(X(me)),this.resolve()}catch(ge){this.reject(ge)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this._state===W.DoneError)throw this._error;if(X<this._results.length)return{done:!1,value:this._results[X++]};if(this._state===W.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(X,J){return new ie(async me=>{for await(const ge of X)me.emitOne(J(ge))})}map(X){return ie.map(this,X)}static filter(X,J){return new ie(async me=>{for await(const ge of X)J(ge)&&me.emitOne(ge)})}filter(X){return ie.filter(this,X)}static coalesce(X){return ie.filter(X,J=>!!J)}coalesce(){return ie.coalesce(this)}static async toPromise(X){const J=[];for await(const me of X)J.push(me);return J}toPromise(){return ie.toPromise(this)}emitOne(X){this._state===W.Initial&&(this._results.push(X),this._onStateChanged.fire())}emitMany(X){this._state===W.Initial&&(this._results=this._results.concat(X),this._onStateChanged.fire())}resolve(){this._state===W.Initial&&(this._state=W.DoneOK,this._onStateChanged.fire())}reject(X){this._state===W.Initial&&(this._state=W.DoneError,this._error=X,this._onStateChanged.fire())}}e.AsyncIterableObject=ie;class _e extends ie{constructor(X,J){super(J),this._source=X}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=_e;function de(ae){const X=new y.CancellationTokenSource,J=ae(X.token);return new _e(X,async me=>{const ge=X.token.onCancellationRequested(()=>{ge.dispose(),X.dispose(),me.reject(new k.CancellationError)});try{for await(const Le of J){if(X.token.isCancellationRequested)return;me.emitOne(Le)}ge.dispose(),X.dispose()}catch(Le){ge.dispose(),X.dispose(),me.reject(Le)}})}class Se{constructor(X){this._deferred=new se,this._asyncIterable=new ie(ge=>{if(J){ge.reject(J);return}return me&&ge.emitMany(me),this._errorFn=Le=>ge.reject(Le),this._emitFn=Le=>ge.emitOne(Le),this._deferred.p},X);let J,me;this._emitFn=ge=>{me||(me=[]),me.push(ge)},this._errorFn=ge=>{J||(J=ge)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(X){this._errorFn(X),this._deferred.complete()}emitOne(X){this._emitFn(X)}}e.AsyncIterableSource=Se}),define(De[41],Ie([1,0,18,11,28,53,29,20,21,13]),function(he,e,y,k,P,O,A,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=T,e.splitGlobAware=r,e.match=M,e.parse=L,e.isRelativePattern=H,e.getBasenameTerms=V,e.getPathTerms=$,e.patternsEquals=re;function T(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",c="[^/\\\\]",C=/\//g;function h(fe,Ee){switch(fe){case 0:return"";case 1:return`${c}*?`;default:return`(?:${b}|${c}+${b}${Ee?`|${b}${c}+`:""})*?`}}function r(fe,Ee){if(!fe)return[];const oe=[];let pe=!1,ve=!1,se="";for(const Te of fe){switch(Te){case Ee:if(!pe&&!ve){oe.push(se),se="";continue}break;case"{":pe=!0;break;case"}":pe=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}se+=Te}return se&&oe.push(se),oe}function o(fe){if(!fe)return"";let Ee="";const oe=r(fe,e.GLOB_SPLIT);if(oe.every(pe=>pe===e.GLOBSTAR))Ee=".*";else{let pe=!1;oe.forEach((ve,se)=>{if(ve===e.GLOBSTAR){if(pe)return;Ee+=h(2,se===oe.length-1)}else{let Te=!1,Me="",Q=!1,W="";for(const ie of ve){if(ie!=="}"&&Te){Me+=ie;continue}if(Q&&(ie!=="]"||!W)){let _e;ie==="-"?_e=ie:(ie==="^"||ie==="!")&&!W?_e="^":ie===e.GLOB_SPLIT?_e="":_e=(0,l.escapeRegExpCharacters)(ie),W+=_e;continue}switch(ie){case"{":Te=!0;continue;case"[":Q=!0;continue;case"}":{const de=`(?:${r(Me,",").map(Se=>o(Se)).join("|")})`;Ee+=de,Te=!1,Me="";break}case"]":{Ee+="["+W+"]",Q=!1,W="";break}case"?":Ee+=c;continue;case"*":Ee+=h(1);continue;default:Ee+=(0,l.escapeRegExpCharacters)(ie)}}se<oe.length-1&&(oe[se+1]!==e.GLOBSTAR||se+2<oe.length)&&(Ee+=b)}pe=ve===e.GLOBSTAR})}return Ee}const a=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,t=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,g=new A.LRUCache(1e4),f=function(){return!1},u=function(){return null};function E(fe,Ee){if(!fe)return u;let oe;typeof fe!="string"?oe=fe.pattern:oe=fe,oe=oe.trim();const pe=`${oe}_${!!Ee.trimForExclusions}`;let ve=g.get(pe);if(ve)return I(ve,fe);let se;return a.test(oe)?ve=w(oe.substr(4),oe):(se=d.exec(_(oe,Ee)))?ve=p(se[1],oe):(Ee.trimForExclusions?s:t).test(oe)?ve=D(oe,Ee):(se=n.exec(_(oe,Ee)))?ve=m(se[1].substr(1),oe,!0):(se=i.exec(_(oe,Ee)))?ve=m(se[1],oe,!1):ve=S(oe),g.set(pe,ve),I(ve,fe)}function I(fe,Ee){if(typeof Ee=="string")return fe;const oe=function(pe,ve){return(0,O.isEqualOrParent)(pe,Ee.base,!v.isLinux)?fe((0,l.ltrim)(pe.substr(Ee.base.length),R.sep),ve):null};return oe.allBasenames=fe.allBasenames,oe.allPaths=fe.allPaths,oe.basenames=fe.basenames,oe.patterns=fe.patterns,oe}function _(fe,Ee){return Ee.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function w(fe,Ee){return function(oe,pe){return typeof oe=="string"&&oe.endsWith(fe)?Ee:null}}function p(fe,Ee){const oe=`/${fe}`,pe=`\\${fe}`,ve=function(Te,Me){return typeof Te!="string"?null:Me?Me===fe?Ee:null:Te===fe||Te.endsWith(oe)||Te.endsWith(pe)?Ee:null},se=[fe];return ve.basenames=se,ve.patterns=[Ee],ve.allBasenames=se,ve}function D(fe,Ee){const oe=Y(fe.slice(1,-1).split(",").map(Me=>E(Me,Ee)).filter(Me=>Me!==u),fe),pe=oe.length;if(!pe)return u;if(pe===1)return oe[0];const ve=function(Me,Q){for(let W=0,ie=oe.length;W<ie;W++)if(oe[W](Me,Q))return fe;return null},se=oe.find(Me=>!!Me.allBasenames);se&&(ve.allBasenames=se.allBasenames);const Te=oe.reduce((Me,Q)=>Q.allPaths?Me.concat(Q.allPaths):Me,[]);return Te.length&&(ve.allPaths=Te),ve}function m(fe,Ee,oe){const pe=R.sep===R.posix.sep,ve=pe?fe:fe.replace(C,R.sep),se=R.sep+ve,Te=R.posix.sep+fe;let Me;return oe?Me=function(Q,W){return typeof Q=="string"&&(Q===ve||Q.endsWith(se)||!pe&&(Q===fe||Q.endsWith(Te)))?Ee:null}:Me=function(Q,W){return typeof Q=="string"&&(Q===ve||!pe&&Q===fe)?Ee:null},Me.allPaths=[(oe?"*/":"./")+fe],Me}function S(fe){try{const Ee=new RegExp(`^${o(fe)}$`);return function(oe){return Ee.lastIndex=0,typeof oe=="string"&&Ee.test(oe)?fe:null}}catch{return u}}function M(fe,Ee,oe){return!fe||typeof Ee!="string"?!1:L(fe)(Ee,void 0,oe)}function L(fe,Ee={}){if(!fe)return f;if(typeof fe=="string"||H(fe)){const oe=E(fe,Ee);if(oe===u)return f;const pe=function(ve,se){return!!oe(ve,se)};return oe.allBasenames&&(pe.allBasenames=oe.allBasenames),oe.allPaths&&(pe.allPaths=oe.allPaths),pe}return N(fe,Ee)}function H(fe){const Ee=fe;return Ee?typeof Ee.base=="string"&&typeof Ee.pattern=="string":!1}function V(fe){return fe.allBasenames||[]}function $(fe){return fe.allPaths||[]}function N(fe,Ee){const oe=Y(Object.getOwnPropertyNames(fe).map(Me=>F(Me,fe[Me],Ee)).filter(Me=>Me!==u)),pe=oe.length;if(!pe)return u;if(!oe.some(Me=>!!Me.requiresSiblings)){if(pe===1)return oe[0];const Me=function(ie,_e){let de;for(let Se=0,ae=oe.length;Se<ae;Se++){const X=oe[Se](ie,_e);if(typeof X=="string")return X;(0,k.isThenable)(X)&&(de||(de=[]),de.push(X))}return de?(async()=>{for(const Se of de){const ae=await Se;if(typeof ae=="string")return ae}return null})():null},Q=oe.find(ie=>!!ie.allBasenames);Q&&(Me.allBasenames=Q.allBasenames);const W=oe.reduce((ie,_e)=>_e.allPaths?ie.concat(_e.allPaths):ie,[]);return W.length&&(Me.allPaths=W),Me}const ve=function(Me,Q,W){let ie,_e;for(let de=0,Se=oe.length;de<Se;de++){const ae=oe[de];ae.requiresSiblings&&W&&(Q||(Q=(0,R.basename)(Me)),ie||(ie=Q.substr(0,Q.length-(0,R.extname)(Me).length)));const X=ae(Me,Q,ie,W);if(typeof X=="string")return X;(0,k.isThenable)(X)&&(_e||(_e=[]),_e.push(X))}return _e?(async()=>{for(const de of _e){const Se=await de;if(typeof Se=="string")return Se}return null})():null},se=oe.find(Me=>!!Me.allBasenames);se&&(ve.allBasenames=se.allBasenames);const Te=oe.reduce((Me,Q)=>Q.allPaths?Me.concat(Q.allPaths):Me,[]);return Te.length&&(ve.allPaths=Te),ve}function F(fe,Ee,oe){if(Ee===!1)return u;const pe=E(fe,oe);if(pe===u)return u;if(typeof Ee=="boolean")return pe;if(Ee){const ve=Ee.when;if(typeof ve=="string"){const se=(Te,Me,Q,W)=>{if(!W||!pe(Te,Me))return null;const ie=ve.replace("$(basename)",()=>Q),_e=W(ie);return(0,k.isThenable)(_e)?_e.then(de=>de?fe:null):_e?fe:null};return se.requiresSiblings=!0,se}}return pe}function Y(fe,Ee){const oe=fe.filter(Me=>!!Me.basenames);if(oe.length<2)return fe;const pe=oe.reduce((Me,Q)=>{const W=Q.basenames;return W?Me.concat(W):Me},[]);let ve;if(Ee){ve=[];for(let Me=0,Q=pe.length;Me<Q;Me++)ve.push(Ee)}else ve=oe.reduce((Me,Q)=>{const W=Q.patterns;return W?Me.concat(W):Me},[]);const se=function(Me,Q){if(typeof Me!="string")return null;if(!Q){let ie;for(ie=Me.length;ie>0;ie--){const _e=Me.charCodeAt(ie-1);if(_e===P.CharCode.Slash||_e===P.CharCode.Backslash)break}Q=Me.substr(ie)}const W=pe.indexOf(Q);return W!==-1?ve[W]:null};se.basenames=pe,se.patterns=ve,se.allBasenames=pe;const Te=fe.filter(Me=>!Me.basenames);return Te.push(se),Te}function re(fe,Ee){return(0,y.equals)(fe,Ee,(oe,pe)=>typeof oe=="string"&&typeof pe=="string"?oe===pe:typeof oe!="string"&&typeof pe!="string"?oe.base===pe.base&&oe.pattern===pe.pattern:!1)}}),define(De[59],Ie([1,0,14,98,24,13,2]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=l,e.isMarkdownString=T,e.markdownStringEqual=b,e.escapeMarkdownSyntaxTokens=c,e.appendEscapedMarkdownCodeBlockFence=C,e.escapeDoubleQuotes=h,e.removeMarkdownEscapes=r,e.parseHrefAndDimensions=o;var R;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class v{constructor(d="",t=!1){if(this.value=d,typeof this.value!="string")throw(0,y.illegalArgument)("value");typeof t=="boolean"?(this.isTrusted=t,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=t.isTrusted??void 0,this.supportThemeIcons=t.supportThemeIcons??!1,this.supportHtml=t.supportHtml??!1)}appendText(d,t=R.Paragraph){return this.value+=c(this.supportThemeIcons?(0,k.escapeIcons)(d):d).replace(/([ \t]+)/g,(s,n)=>"&nbsp;".repeat(n.length)).replace(/\>/gm,"\\>").replace(/\n/g,t===R.Break?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,t){return this.value+=`
${C(t,d)}
`,this}appendLink(d,t,s){return this.value+="[",this.value+=this._escape(t,"]"),this.value+="](",this.value+=this._escape(String(d),")"),s&&(this.value+=` "${this._escape(this._escape(s,'"'),")")}"`),this.value+=")",this}_escape(d,t){const s=new RegExp((0,O.escapeRegExpCharacters)(t),"g");return d.replace(s,(n,i)=>d.charAt(i-1)!=="\\"?`\\${n}`:n)}}e.MarkdownString=v;function l(a){return T(a)?!a.value:Array.isArray(a)?a.every(l):!0}function T(a){return a instanceof v?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function b(a,d){return a===d?!0:!a||!d?!1:a.value===d.value&&a.isTrusted===d.isTrusted&&a.supportThemeIcons===d.supportThemeIcons&&a.supportHtml===d.supportHtml&&(a.baseUri===d.baseUri||!!a.baseUri&&!!d.baseUri&&(0,P.isEqual)(A.URI.from(a.baseUri),A.URI.from(d.baseUri)))}function c(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function C(a,d){const t=a.match(/^`+/gm)?.reduce((n,i)=>n.length>i.length?n:i).length??0,s=t>=3?t+1:3;return[`${"`".repeat(s)}${d}`,a,`${"`".repeat(s)}`].join(`
`)}function h(a){return a.replace(/"/g,"&quot;")}function r(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(a){const d=[],t=a.split("|").map(n=>n.trim());a=t[0];const s=t[1];if(s){const n=/height=(\d+)/.exec(s),i=/width=(\d+)/.exec(s),g=n?n[1]:"",f=i?i[1]:"",u=isFinite(parseInt(f)),E=isFinite(parseInt(g));u&&d.push(`width="${f}"`),E&&d.push(`height="${g}"`)}return{href:a,dimensions:d}}}),define(De[102],Ie([1,0,18,53,20,21,24,13]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=v,e.normalizeDriveLetter=T,e.tildify=c,e.untildify=C,e.shorten=a,e.template=t,e.mnemonicMenuLabel=s,e.mnemonicButtonLabel=n,e.unmnemonicLabel=i,e.splitRecentLabel=g;function v(u,E){const{os:I,tildify:_,relative:w}=E;if(w){const m=l(u,w,I);if(typeof m=="string")return m}let p=u.fsPath;if(I===O.OperatingSystem.Windows&&!O.isWindows?p=p.replace(/\//g,"\\"):I!==O.OperatingSystem.Windows&&O.isWindows&&(p=p.replace(/\\/g,"/")),I!==O.OperatingSystem.Windows&&_?.userHome){const m=_.userHome.fsPath;let S;u.scheme!==_.userHome.scheme&&u.path[0]===P.posix.sep&&u.path[1]!==P.posix.sep?S=_.userHome.with({path:u.path}).fsPath:S=p,p=c(S,m,I)}return(I===O.OperatingSystem.Windows?P.win32:P.posix).normalize(T(p,I===O.OperatingSystem.Windows))}function l(u,E,I){const _=I===O.OperatingSystem.Windows?P.win32:P.posix,w=I===O.OperatingSystem.Linux?A.extUri:A.extUriIgnorePathCase,p=E.getWorkspace(),D=(0,y.firstOrDefault)(p.folders);if(!D)return;u.scheme!==D.uri.scheme&&u.path[0]===P.posix.sep&&u.path[1]!==P.posix.sep&&(u=D.uri.with({path:u.path}));const m=E.getWorkspaceFolder(u);if(!m)return;let S;if(w.isEqual(m.uri,u)?S="":S=w.relativePath(m.uri,u)??"",S&&(S=_.normalize(S)),p.folders.length>1&&!E.noPrefix){const M=m.name?m.name:w.basenameOrAuthority(m.uri);S=S?`${M} \u2022 ${S}`:M}return S}function T(u,E=O.isWindows){return(0,k.hasDriveLetter)(u,E)?u.charAt(0).toUpperCase()+u.slice(1):u}let b=Object.create(null);function c(u,E,I=O.OS){if(I===O.OperatingSystem.Windows||!u||!E)return u;let _=b.original===E?b.normalized:void 0;_||(_=E,O.isWindows&&(_=(0,k.toSlashes)(_)),_=`${(0,R.rtrim)(_,P.posix.sep)}${P.posix.sep}`,b={original:E,normalized:_});let w=u;return O.isWindows&&(w=(0,k.toSlashes)(w)),(I===O.OperatingSystem.Linux?w.startsWith(_):(0,R.startsWithIgnoreCase)(w,_))?`~/${w.substr(_.length)}`:u}function C(u,E){return u.replace(/^~($|\/|\\)/,`${E}$1`)}const h="\u2026",r="\\\\",o="~";function a(u,E=P.sep){const I=new Array(u.length);let _=!1;for(let w=0;w<u.length;w++){const p=u[w];if(p===""){I[w]=`.${E}`;continue}if(!p){I[w]=p;continue}_=!0;let D="",m=p;m.indexOf(r)===0?(D=m.substr(0,m.indexOf(r)+r.length),m=m.substr(m.indexOf(r)+r.length)):m.indexOf(E)===0?(D=m.substr(0,m.indexOf(E)+E.length),m=m.substr(m.indexOf(E)+E.length)):m.indexOf(o)===0&&(D=m.substr(0,m.indexOf(o)+o.length),m=m.substr(m.indexOf(o)+o.length));const S=m.split(E);for(let M=1;_&&M<=S.length;M++)for(let L=S.length-M;_&&L>=0;L--){_=!1;let H=S.slice(L,L+M).join(E);for(let V=0;!_&&V<u.length;V++)if(V!==w&&u[V]&&u[V].indexOf(H)>-1){const $=L+M===S.length,N=L>0&&u[V].indexOf(E)>-1?E+H:H,F=u[V].endsWith(N);_=!$||F}if(!_){let V="";(S[0].endsWith(":")||D!=="")&&(L===1&&(L=0,M++,H=S[0]+E+H),L>0&&(V=S[0]+E),V=D+V),L>0&&(V=V+h+E),V=V+H,L+M<S.length&&(V=V+E+h),I[w]=V}}_&&(I[w]=p)}return I}var d;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function t(u,E=Object.create(null)){const I=[];let _=!1,w="";for(const p of u)if(p==="$"||_&&p==="{")w&&I.push({value:w,type:d.TEXT}),w="",_=!0;else if(p==="}"&&_){const D=E[w];if(typeof D=="string")D.length&&I.push({value:D,type:d.VARIABLE});else if(D){const m=I[I.length-1];(!m||m.type!==d.SEPARATOR)&&I.push({value:D.label,type:d.SEPARATOR})}w="",_=!1}else w+=p;return w&&!_&&I.push({value:w,type:d.TEXT}),I.filter((p,D)=>{if(p.type===d.SEPARATOR){const m=I[D-1],S=I[D+1];return[m,S].every(M=>M&&(M.type===d.VARIABLE||M.type===d.TEXT)&&M.value.length>0)}return!0}).map(p=>p.value).join("")}function s(u,E){return O.isMacintosh||E?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):u.replace(/&&|&/g,I=>I==="&"?"&&":"&")}function n(u,E){return O.isMacintosh||E?u.replace(/\(&&\w\)|&&/g,""):O.isWindows?u.replace(/&&|&/g,I=>I==="&"?"&&":"&"):u.replace(/&&/g,"_")}function i(u){return u.replace(/&/g,"&&")}function g(u){if(u.endsWith("]")){const E=u.lastIndexOf(" [",u.length-2);if(E!==-1){const I=f(u.substring(0,E)),_=u.substring(E);return{name:I.name+_,parentPath:I.parentPath}}}return f(u)}function f(u){const E=u.indexOf("/")!==-1?P.posix:P.win32,I=E.basename(u),_=E.dirname(u);return I.length?{name:I,parentPath:_}:{name:_,parentPath:""}}}),define(De[159],Ie([1,0,23,37,2]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=v,e.transformIncomingURIs=T,e.transformAndReviveIncomingURIs=b;function O(c){return c.toJSON()}class A{constructor(C){this._uriTransformer=C}transformIncoming(C){const h=this._uriTransformer.transformIncoming(C);return h===C?C:O(P.URI.from(h))}transformOutgoing(C){const h=this._uriTransformer.transformOutgoing(C);return h===C?C:O(P.URI.from(h))}transformOutgoingURI(C){const h=this._uriTransformer.transformOutgoing(C);return h===C?C:P.URI.from(h)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(c){return c}transformOutgoing(c){return c}transformOutgoingURI(c){return c}transformOutgoingScheme(c){return c}};function R(c,C,h){if(!c||h>200)return null;if(typeof c=="object"){if(c instanceof P.URI)return C.transformOutgoing(c);for(const r in c)if(Object.hasOwnProperty.call(c,r)){const o=R(c[r],C,h+1);o!==null&&(c[r]=o)}}return null}function v(c,C){const h=R(c,C,0);return h===null?c:h}function l(c,C,h,r){if(!c||r>200)return null;if(typeof c=="object"){if(c.$mid===k.MarshalledId.Uri)return h?P.URI.revive(C.transformIncoming(c)):C.transformIncoming(c);if(c instanceof y.VSBuffer)return null;for(const o in c)if(Object.hasOwnProperty.call(c,o)){const a=l(c[o],C,h,r+1);a!==null&&(c[o]=a)}}return null}function T(c,C){const h=l(c,C,!1,0);return h===null?c:h}function b(c,C){const h=l(c,C,!0,0);return h===null?c:h}}),define(De[160],Ie([1,0,11,4,6,49,15]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=v;var R;(function(c){c[c.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",c[c.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function v(c){const C=c;return C?.changed instanceof Map||C?.deleted instanceof Set}var l;(function(c){c[c.None=0]="None",c[c.Initialized=1]="Initialized",c[c.Closed=2]="Closed"})(l||(e.StorageState=l={}));class T extends P.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(C,h=Object.create(null)){super(),this.database=C,this.options=h,this._onDidChangeStorage=this._register(new k.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new y.ThrottledDelayer(T.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(C=>this.onDidChangeItemsExternal(C)))}onDidChangeItemsExternal(C){this._onDidChangeStorage.pause();try{C.changed?.forEach((h,r)=>this.acceptExternal(r,h)),C.deleted?.forEach(h=>this.acceptExternal(h,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(C,h){if(this.state===l.Closed)return;let r=!1;(0,A.isUndefinedOrNull)(h)?r=this.cache.delete(C):this.cache.get(C)!==h&&(this.cache.set(C,h),r=!0),r&&this._onDidChangeStorage.fire({key:C,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(C,h){const r=this.cache.get(C);return(0,A.isUndefinedOrNull)(r)?h:r}getBoolean(C,h){const r=this.get(C);return(0,A.isUndefinedOrNull)(r)?h:r==="true"}getNumber(C,h){const r=this.get(C);return(0,A.isUndefinedOrNull)(r)?h:parseInt(r,10)}getObject(C,h){const r=this.get(C);return(0,A.isUndefinedOrNull)(r)?h:(0,O.parse)(r)}async set(C,h,r=!1){if(this.state===l.Closed)return;if((0,A.isUndefinedOrNull)(h))return this.delete(C,r);const o=(0,A.isObject)(h)||Array.isArray(h)?(0,O.stringify)(h):String(h);if(this.cache.get(C)!==o)return this.cache.set(C,o),this.pendingInserts.set(C,o),this.pendingDeletes.delete(C),this._onDidChangeStorage.fire({key:C,external:r}),this.doFlush()}async delete(C,h=!1){if(!(this.state===l.Closed||!this.cache.delete(C)))return this.pendingDeletes.has(C)||this.pendingDeletes.add(C),this.pendingInserts.delete(C),this._onDidChangeStorage.fire({key:C,external:h}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const C={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(C).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(C){if(!(this.state===l.Closed||this.pendingClose))return this.doFlush(C)}async doFlush(C){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),C)}async whenFlushed(){if(this.hasPending)return new Promise(C=>this.whenFlushedCallbacks.push(C))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=T;class b{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(C){C.insert?.forEach((h,r)=>this.items.set(r,h)),C.delete?.forEach(h=>this.items.delete(h))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=b}),define(De[161],Ie([1,0,13,21,23]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=T,e.decodeUTF16LE=b;let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let R;function v(){return R||(R=new TextDecoder("UTF-16BE")),R}let l;function T(){return l||(l=k.isLittleEndian()?A():v()),l}function b(h,r,o){const a=new Uint16Array(h.buffer,r,o);return o>0&&(a[0]===65279||a[0]===65534)?c(h,r,o):A().decode(a)}function c(h,r,o){const a=[];let d=0;for(let t=0;t<o;t++){const s=P.readUInt16LE(h,r);r+=2,a[d++]=String.fromCharCode(s)}return a.join("")}class C{constructor(r){this._capacity=r|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const r=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return T().decode(r)}_flushBuffer(){const r=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[r]:this._completedStrings[this._completedStrings.length]=r}appendCharCode(r){const o=this._capacity-this._bufferLength;o<=1&&(o===0||y.isHighSurrogate(r))&&this._flushBuffer(),this._buffer[this._bufferLength++]=r}appendASCIICharCode(r){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=r}appendString(r){const o=r.length;if(this._bufferLength+o>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=r;return}for(let a=0;a<o;a++)this._buffer[this._bufferLength++]=r.charCodeAt(a)}}e.StringBuilder=C}),define(De[162],Ie([1,0,23,161]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=A;function P(v){return v.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(l,T,b,c){this.oldPosition=l,this.oldText=T,this.newPosition=b,this.newText=c}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static _writeStringSize(l){return 4+2*l.length}static _writeString(l,T,b){const c=T.length;y.writeUInt32BE(l,c,b),b+=4;for(let C=0;C<c;C++)y.writeUInt16LE(l,T.charCodeAt(C),b),b+=2;return b}static _readString(l,T){const b=y.readUInt32BE(l,T);return T+=4,(0,k.decodeUTF16LE)(l,T,b)}writeSize(){return 8+O._writeStringSize(this.oldText)+O._writeStringSize(this.newText)}write(l,T){return y.writeUInt32BE(l,this.oldPosition,T),T+=4,y.writeUInt32BE(l,this.newPosition,T),T+=4,T=O._writeString(l,this.oldText,T),T=O._writeString(l,this.newText,T),T}static read(l,T,b){const c=y.readUInt32BE(l,T);T+=4;const C=y.readUInt32BE(l,T);T+=4;const h=O._readString(l,T);T+=O._writeStringSize(h);const r=O._readString(l,T);return T+=O._writeStringSize(r),b.push(new O(c,h,C,r)),T}}e.TextChange=O;function A(v,l){return v===null||v.length===0?l:new R(v,l).compress()}class R{constructor(l,T){this._prevEdits=l,this._currEdits=T,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let l=0,T=0,b=this._getPrev(l),c=this._getCurr(T);for(;l<this._prevLen||T<this._currLen;){if(b===null){this._acceptCurr(c),c=this._getCurr(++T);continue}if(c===null){this._acceptPrev(b),b=this._getPrev(++l);continue}if(c.oldEnd<=b.newPosition){this._acceptCurr(c),c=this._getCurr(++T);continue}if(b.newEnd<=c.oldPosition){this._acceptPrev(b),b=this._getPrev(++l);continue}if(c.oldPosition<b.newPosition){const[a,d]=R._splitCurr(c,b.newPosition-c.oldPosition);this._acceptCurr(a),c=d;continue}if(b.newPosition<c.oldPosition){const[a,d]=R._splitPrev(b,c.oldPosition-b.newPosition);this._acceptPrev(a),b=d;continue}let r,o;if(c.oldEnd===b.newEnd)r=b,o=c,b=this._getPrev(++l),c=this._getCurr(++T);else if(c.oldEnd<b.newEnd){const[a,d]=R._splitPrev(b,c.oldLength);r=a,o=c,b=d,c=this._getCurr(++T)}else{const[a,d]=R._splitCurr(c,b.newLength);r=b,o=a,b=this._getPrev(++l),c=d}this._result[this._resultLen++]=new O(r.oldPosition,r.oldText,o.newPosition,o.newText),this._prevDeltaOffset+=r.newLength-r.oldLength,this._currDeltaOffset+=o.newLength-o.oldLength}const C=R._merge(this._result);return R._removeNoOps(C)}_acceptCurr(l){this._result[this._resultLen++]=R._rebaseCurr(this._prevDeltaOffset,l),this._currDeltaOffset+=l.newLength-l.oldLength}_getCurr(l){return l<this._currLen?this._currEdits[l]:null}_acceptPrev(l){this._result[this._resultLen++]=R._rebasePrev(this._currDeltaOffset,l),this._prevDeltaOffset+=l.newLength-l.oldLength}_getPrev(l){return l<this._prevLen?this._prevEdits[l]:null}static _rebaseCurr(l,T){return new O(T.oldPosition-l,T.oldText,T.newPosition,T.newText)}static _rebasePrev(l,T){return new O(T.oldPosition,T.oldText,T.newPosition+l,T.newText)}static _splitPrev(l,T){const b=l.newText.substr(0,T),c=l.newText.substr(T);return[new O(l.oldPosition,l.oldText,l.newPosition,b),new O(l.oldEnd,"",l.newPosition+T,c)]}static _splitCurr(l,T){const b=l.oldText.substr(0,T),c=l.oldText.substr(T);return[new O(l.oldPosition,b,l.newPosition,l.newText),new O(l.oldPosition+T,c,l.newEnd,"")]}static _merge(l){if(l.length===0)return l;const T=[];let b=0,c=l[0];for(let C=1;C<l.length;C++){const h=l[C];c.oldEnd===h.oldPosition?c=new O(c.oldPosition,c.oldText+h.oldText,c.newPosition,c.newText+h.newText):(T[b++]=c,c=h)}return T[b++]=c,T}static _removeNoOps(l){if(l.length===0)return l;const T=[];let b=0;for(let c=0;c<l.length;c++){const C=l[c];C.oldText!==C.newText&&(T[b++]=C)}return T}}}),define(De[163],Ie([1,0,41,20]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=P,e.targetsNotebooks=O;function P(A,R,v,l,T,b){if(Array.isArray(A)){let c=0;for(const C of A){const h=P(C,R,v,l,T,b);if(h===10)return h;h>c&&(c=h)}return c}else{if(typeof A=="string")return l?A==="*"?5:A===v?10:0:0;if(A){const{language:c,pattern:C,scheme:h,hasAccessToAllModels:r,notebookType:o}=A;if(!l&&!r)return 0;o&&T&&(R=T);let a=0;if(h)if(h===R.scheme)a=10;else if(h==="*")a=5;else return 0;if(c)if(c===v)a=10;else if(c==="*")a=Math.max(a,5);else return 0;if(o)if(o===b)a=10;else if(o==="*"&&b!==void 0)a=Math.max(a,5);else return 0;if(C){let d;if(typeof C=="string"?d=C:d={...C,base:(0,k.normalize)(C.base)},d===R.fsPath||(0,y.match)(d,R.fsPath))a=10;else return 0}return a}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(De[164],Ie([1,0,4,13,33,52,99,147,162,6]),function(he,e,y,k,P,O,A,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class T extends l.Disposable{constructor(c,C,h,r,o,a,d){super(),this._onDidChangeContent=this._register(new y.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=C,this._mightContainNonBasicASCII=!a,this._mightContainRTL=r,this._mightContainUnusualLineTerminators=o,this._pieceTree=new A.PieceTreeBase(c,h,d)}equals(c){return!(c instanceof T)||this._BOM!==c._BOM||this.getEOL()!==c.getEOL()?!1:this._pieceTree.equal(c._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(c){return this._pieceTree.createSnapshot(c?this._BOM:"")}getOffsetAt(c,C){return this._pieceTree.getOffsetAt(c,C)}getPositionAt(c){return this._pieceTree.getPositionAt(c)}getRangeAt(c,C){const h=c+C,r=this.getPositionAt(c),o=this.getPositionAt(h);return new P.Range(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(c,C=O.EndOfLinePreference.TextDefined){if(c.isEmpty())return"";const h=this._getEndOfLine(C);return this._pieceTree.getValueInRange(c,h)}getValueLengthInRange(c,C=O.EndOfLinePreference.TextDefined){if(c.isEmpty())return 0;if(c.startLineNumber===c.endLineNumber)return c.endColumn-c.startColumn;const h=this.getOffsetAt(c.startLineNumber,c.startColumn),r=this.getOffsetAt(c.endLineNumber,c.endColumn);let o=0;const a=this._getEndOfLine(C),d=this.getEOL();if(a.length!==d.length){const t=a.length-d.length,s=c.endLineNumber-c.startLineNumber;o=t*s}return r-h+o}getCharacterCountInRange(c,C=O.EndOfLinePreference.TextDefined){if(this._mightContainNonBasicASCII){let h=0;const r=c.startLineNumber,o=c.endLineNumber;for(let a=r;a<=o;a++){const d=this.getLineContent(a),t=a===r?c.startColumn-1:0,s=a===o?c.endColumn-1:d.length;for(let n=t;n<s;n++)k.isHighSurrogate(d.charCodeAt(n))?(h=h+1,n=n+1):h=h+1}return h+=this._getEndOfLine(C).length*(o-r),h}return this.getValueLengthInRange(c,C)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(c){return this._pieceTree.getLineContent(c)}getLineCharCode(c,C){return this._pieceTree.getLineCharCode(c,C)}getCharCode(c){return this._pieceTree.getCharCode(c)}getLineLength(c){return this._pieceTree.getLineLength(c)}getLineMinColumn(c){return 1}getLineMaxColumn(c){return this.getLineLength(c)+1}getLineFirstNonWhitespaceColumn(c){const C=k.firstNonWhitespaceIndex(this.getLineContent(c));return C===-1?0:C+1}getLineLastNonWhitespaceColumn(c){const C=k.lastNonWhitespaceIndex(this.getLineContent(c));return C===-1?0:C+2}_getEndOfLine(c){switch(c){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(c){this._pieceTree.setEOL(c)}applyEdits(c,C,h){let r=this._mightContainRTL,o=this._mightContainUnusualLineTerminators,a=this._mightContainNonBasicASCII,d=!0,t=[];for(let E=0;E<c.length;E++){const I=c[E];d&&I._isTracked&&(d=!1);const _=I.range;if(I.text){let S=!0;a||(S=!k.isBasicASCII(I.text),a=S),!r&&S&&(r=k.containsRTL(I.text)),!o&&S&&(o=k.containsUnusualLineTerminators(I.text))}let w="",p=0,D=0,m=0;if(I.text){let S;[p,D,m,S]=(0,R.countEOL)(I.text);const M=this.getEOL(),L=M===`\r
`?R.StringEOL.CRLF:R.StringEOL.LF;S===R.StringEOL.Unknown||S===L?w=I.text:w=I.text.replace(/\r\n|\r|\n/g,M)}t[E]={sortIndex:E,identifier:I.identifier||null,range:_,rangeOffset:this.getOffsetAt(_.startLineNumber,_.startColumn),rangeLength:this.getValueLengthInRange(_),text:w,eolCount:p,firstLineLength:D,lastLineLength:m,forceMoveMarkers:!!I.forceMoveMarkers,isAutoWhitespaceEdit:I.isAutoWhitespaceEdit||!1}}t.sort(T._sortOpsAscending);let s=!1;for(let E=0,I=t.length-1;E<I;E++){const _=t[E].range.getEndPosition(),w=t[E+1].range.getStartPosition();if(w.isBeforeOrEqual(_)){if(w.isBefore(_))throw new Error("Overlapping ranges are not allowed!");s=!0}}d&&(t=this._reduceOperations(t));const n=h||C?T._getInverseEditRanges(t):[],i=[];if(C)for(let E=0;E<t.length;E++){const I=t[E],_=n[E];if(I.isAutoWhitespaceEdit&&I.range.isEmpty())for(let w=_.startLineNumber;w<=_.endLineNumber;w++){let p="";w===_.startLineNumber&&(p=this.getLineContent(I.range.startLineNumber),k.firstNonWhitespaceIndex(p)!==-1)||i.push({lineNumber:w,oldContent:p})}}let g=null;if(h){let E=0;g=[];for(let I=0;I<t.length;I++){const _=t[I],w=n[I],p=this.getValueInRange(_.range),D=_.rangeOffset+E;E+=_.text.length-p.length,g[I]={sortIndex:_.sortIndex,identifier:_.identifier,range:w,text:p,textChange:new v.TextChange(_.rangeOffset,p,D,_.text)}}s||g.sort((I,_)=>I.sortIndex-_.sortIndex)}this._mightContainRTL=r,this._mightContainUnusualLineTerminators=o,this._mightContainNonBasicASCII=a;const f=this._doApplyEdits(t);let u=null;if(C&&i.length>0){i.sort((E,I)=>I.lineNumber-E.lineNumber),u=[];for(let E=0,I=i.length;E<I;E++){const _=i[E].lineNumber;if(E>0&&i[E-1].lineNumber===_)continue;const w=i[E].oldContent,p=this.getLineContent(_);p.length===0||p===w||k.firstNonWhitespaceIndex(p)!==-1||u.push(_)}}return this._onDidChangeContent.fire(),new O.ApplyEditsResult(g,f,u)}_reduceOperations(c){return c.length<1e3?c:[this._toSingleEditOperation(c)]}_toSingleEditOperation(c){let C=!1;const h=c[0].range,r=c[c.length-1].range,o=new P.Range(h.startLineNumber,h.startColumn,r.endLineNumber,r.endColumn);let a=h.startLineNumber,d=h.startColumn;const t=[];for(let f=0,u=c.length;f<u;f++){const E=c[f],I=E.range;C=C||E.forceMoveMarkers,t.push(this.getValueInRange(new P.Range(a,d,I.startLineNumber,I.startColumn))),E.text.length>0&&t.push(E.text),a=I.endLineNumber,d=I.endColumn}const s=t.join(""),[n,i,g]=(0,R.countEOL)(s);return{sortIndex:0,identifier:c[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,O.EndOfLinePreference.TextDefined),text:s,eolCount:n,firstLineLength:i,lastLineLength:g,forceMoveMarkers:C,isAutoWhitespaceEdit:!1}}_doApplyEdits(c){c.sort(T._sortOpsDescending);const C=[];for(let h=0;h<c.length;h++){const r=c[h],o=r.range.startLineNumber,a=r.range.startColumn,d=r.range.endLineNumber,t=r.range.endColumn;if(o===d&&a===t&&r.text.length===0)continue;r.text?(this._pieceTree.delete(r.rangeOffset,r.rangeLength),this._pieceTree.insert(r.rangeOffset,r.text,!0)):this._pieceTree.delete(r.rangeOffset,r.rangeLength);const s=new P.Range(o,a,d,t);C.push({range:s,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return C}findMatchesLineByLine(c,C,h,r){return this._pieceTree.findMatchesLineByLine(c,C,h,r)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(c,C){const h=c.startLineNumber,r=c.startColumn,[o,a,d]=(0,R.countEOL)(C);let t;if(C.length>0){const s=o+1;s===1?t=new P.Range(h,r,h,r+a):t=new P.Range(h,r,h+s-1,d+1)}else t=new P.Range(h,r,h,r);return t}static _getInverseEditRanges(c){const C=[];let h=0,r=0,o=null;for(let a=0,d=c.length;a<d;a++){const t=c[a];let s,n;o?o.range.endLineNumber===t.range.startLineNumber?(s=h,n=r+(t.range.startColumn-o.range.endColumn)):(s=h+(t.range.startLineNumber-o.range.endLineNumber),n=t.range.startColumn):(s=t.range.startLineNumber,n=t.range.startColumn);let i;if(t.text.length>0){const g=t.eolCount+1;g===1?i=new P.Range(s,n,s,n+t.firstLineLength):i=new P.Range(s,n,s+g-1,t.lastLineLength+1)}else i=new P.Range(s,n,s,n);h=i.endLineNumber,r=i.endColumn,C.push(i),o=t}return C}static _sortOpsAscending(c,C){const h=P.Range.compareRangesUsingEnds(c.range,C.range);return h===0?c.sortIndex-C.sortIndex:h}static _sortOpsDescending(c,C){const h=P.Range.compareRangesUsingEnds(c.range,C.range);return h===0?C.sortIndex-c.sortIndex:-h}}e.PieceTreeTextBuffer=T}),define(De[165],Ie([1,0,28,13,52,99,164]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class R{constructor(T,b,c,C,h,r,o,a,d){this._chunks=T,this._bom=b,this._cr=c,this._lf=C,this._crlf=h,this._containsRTL=r,this._containsUnusualLineTerminators=o,this._isBasicASCII=a,this._normalizeEOL=d}_getEOL(T){const b=this._cr+this._lf+this._crlf,c=this._cr+this._crlf;return b===0?T===P.DefaultEndOfLine.LF?`
`:`\r
`:c>b/2?`\r
`:`
`}create(T){const b=this._getEOL(T),c=this._chunks;if(this._normalizeEOL&&(b===`\r
`&&(this._cr>0||this._lf>0)||b===`
`&&(this._cr>0||this._crlf>0)))for(let h=0,r=c.length;h<r;h++){const o=c[h].buffer.replace(/\r\n|\r|\n/g,b),a=(0,O.createLineStartsFast)(o);c[h]=new O.StringBuffer(o,a)}const C=new A.PieceTreeTextBuffer(c,this._bom,b,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:C,disposable:C}}getFirstLineText(T){return this._chunks[0].buffer.substr(0,T).split(/\r\n|\r|\n/)[0]}}class v{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(T){if(T.length===0)return;this.chunks.length===0&&k.startsWithUTF8BOM(T)&&(this.BOM=k.UTF8_BOM_CHARACTER,T=T.substr(1));const b=T.charCodeAt(T.length-1);b===y.CharCode.CarriageReturn||b>=55296&&b<=56319?(this._acceptChunk1(T.substr(0,T.length-1),!1),this._hasPreviousChar=!0,this._previousChar=b):(this._acceptChunk1(T,!1),this._hasPreviousChar=!1,this._previousChar=b)}_acceptChunk1(T,b){!b&&T.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+T):this._acceptChunk2(T))}_acceptChunk2(T){const b=(0,O.createLineStarts)(this._tmpLineStarts,T);this.chunks.push(new O.StringBuffer(T,b.lineStarts)),this.cr+=b.cr,this.lf+=b.lf,this.crlf+=b.crlf,b.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=k.containsRTL(T)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=k.containsUnusualLineTerminators(T)))}finish(T=!0){return this._finish(),new R(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,T)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const T=this.chunks[this.chunks.length-1];T.buffer+=String.fromCharCode(this._previousChar);const b=(0,O.createLineStartsFast)(T.buffer);T.lineStarts=b,this._previousChar===y.CharCode.CarriageReturn&&this.cr++}}}e.PieceTreeTextBufferBuilder=v}),define(De[103],Ie([1,0,23,21]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=v,e.decodeSemanticTokensDto=T;var P;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(P||(P={}));function O(b){for(let c=0,C=b.length;c<C;c+=4){const h=b[c+0],r=b[c+1],o=b[c+2],a=b[c+3];b[c+0]=a,b[c+1]=o,b[c+2]=r,b[c+3]=h}}function A(b){const c=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return k.isLittleEndian()||O(c),y.VSBuffer.wrap(c)}function R(b){const c=b.buffer;if(k.isLittleEndian()||O(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const C=new Uint8Array(c.byteLength);return C.set(c),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function v(b){const c=new Uint32Array(l(b));let C=0;if(c[C++]=b.id,b.type==="full")c[C++]=P.Full,c[C++]=b.data.length,c.set(b.data,C),C+=b.data.length;else{c[C++]=P.Delta,c[C++]=b.deltas.length;for(const h of b.deltas)c[C++]=h.start,c[C++]=h.deleteCount,h.data?(c[C++]=h.data.length,c.set(h.data,C),C+=h.data.length):c[C++]=0}return A(c)}function l(b){let c=0;if(c+=2,b.type==="full")c+=1+b.data.length;else{c+=1,c+=3*b.deltas.length;for(const C of b.deltas)C.data&&(c+=C.data.length)}return c}function T(b){const c=R(b);let C=0;const h=c[C++];if(c[C++]===P.Full){const d=c[C++],t=c.subarray(C,C+d);return C+=d,{id:h,type:"full",data:t}}const o=c[C++],a=[];for(let d=0;d<o;d++){const t=c[C++],s=c[C++],n=c[C++];let i;n>0&&(i=c.subarray(C,C+n),C+=n),a[d]={start:t,deleteCount:s,data:i}}return{id:h,type:"delta",deltas:a}}}),define(De[166],Ie([8,9]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(De[167],Ie([8,9]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[168],Ie([8,9]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(De[169],Ie([8,9]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(De[170],Ie([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[171],Ie([8,9]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[172],Ie([8,9]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(De[173],Ie([8,9]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(De[174],Ie([8,9]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(De[175],Ie([8,9]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(De[176],Ie([8,9]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(De[177],Ie([8,9]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[178],Ie([8,9]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(De[179],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[180],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[181],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[182],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(De[183],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(De[184],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[185],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[186],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[187],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[188],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[189],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[190],Ie([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[191],Ie([8,9]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(De[192],Ie([8,9]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(De[193],Ie([8,9]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(De[194],Ie([8,9]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(De[195],Ie([8,9]),function(he,e){return he.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(De[196],Ie([8,9]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[197],Ie([8,9]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[198],Ie([8,9]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[199],Ie([8,9]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[200],Ie([8,9]),function(he,e){return he.create("vs/workbench/contrib/testing/common/constants",e)}),define(De[201],Ie([8,9]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[202],Ie([8,9]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(De[203],Ie([8,9]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[204],Ie([8,9]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[205],Ie([1,0,28,14,169]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var O;(function(T){T[T.LParen=0]="LParen",T[T.RParen=1]="RParen",T[T.Neg=2]="Neg",T[T.Eq=3]="Eq",T[T.NotEq=4]="NotEq",T[T.Lt=5]="Lt",T[T.LtEq=6]="LtEq",T[T.Gt=7]="Gt",T[T.GtEq=8]="GtEq",T[T.RegexOp=9]="RegexOp",T[T.RegexStr=10]="RegexStr",T[T.True=11]="True",T[T.False=12]="False",T[T.In=13]="In",T[T.Not=14]="Not",T[T.And=15]="And",T[T.Or=16]="Or",T[T.Str=17]="Str",T[T.QuotedStr=18]="QuotedStr",T[T.Error=19]="Error",T[T.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...T){switch(T.length){case 1:return(0,P.localize)(0,null,T[0]);case 2:return(0,P.localize)(1,null,T[0],T[1]);case 3:return(0,P.localize)(2,null,T[0],T[1],T[2]);default:return}}const R=(0,P.localize)(3,null),v=(0,P.localize)(4,null);class l{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return b.isTripleEq?"===":"==";case O.NotEq:return b.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return b.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return b.lexeme;case O.QuotedStr:return b.lexeme;case O.Error:return b.lexeme;case O.EOF:return"EOF";default:throw(0,k.illegalState)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this._keywords=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this._errors}reset(b){return this._input=b,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case y.CharCode.OpenParen:this._addToken(O.LParen);break;case y.CharCode.CloseParen:this._addToken(O.RParen);break;case y.CharCode.ExclamationMark:if(this._match(y.CharCode.Equals)){const c=this._match(y.CharCode.Equals);this._tokens.push({type:O.NotEq,offset:this._start,isTripleEq:c})}else this._addToken(O.Neg);break;case y.CharCode.SingleQuote:this._quotedString();break;case y.CharCode.Slash:this._regex();break;case y.CharCode.Equals:if(this._match(y.CharCode.Equals)){const c=this._match(y.CharCode.Equals);this._tokens.push({type:O.Eq,offset:this._start,isTripleEq:c})}else this._match(y.CharCode.Tilde)?this._addToken(O.RegexOp):this._error(A("==","=~"));break;case y.CharCode.LessThan:this._addToken(this._match(y.CharCode.Equals)?O.LtEq:O.Lt);break;case y.CharCode.GreaterThan:this._addToken(this._match(y.CharCode.Equals)?O.GtEq:O.Gt);break;case y.CharCode.Ampersand:this._match(y.CharCode.Ampersand)?this._addToken(O.And):this._error(A("&&"));break;case y.CharCode.Pipe:this._match(y.CharCode.Pipe)?this._addToken(O.Or):this._error(A("||"));break;case y.CharCode.Space:case y.CharCode.CarriageReturn:case y.CharCode.Tab:case y.CharCode.LineFeed:case y.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(O.EOF),Array.from(this._tokens)}_match(b){return this._isAtEnd()||this._input.charCodeAt(this._current)!==b?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?y.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(b){this._tokens.push({type:b,offset:this._start})}_error(b){const c=this._start,C=this._input.substring(this._start,this._current),h={type:O.Error,offset:this._start,lexeme:C};this._errors.push({offset:c,lexeme:C,additionalInfo:b}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const b=this.stringRe.exec(this._input);if(b){this._current=this._start+b[0].length;const c=this._input.substring(this._start,this._current),C=l._keywords.get(c);C?this._addToken(C):this._tokens.push({type:O.Str,lexeme:c,offset:this._start})}}_quotedString(){for(;this._peek()!==y.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:O.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let b=this._current,c=!1,C=!1;for(;;){if(b>=this._input.length){this._current=b,this._error(v);return}const r=this._input.charCodeAt(b);if(c)c=!1;else if(r===y.CharCode.Slash&&!C){b++;break}else r===y.CharCode.OpenSquareBracket?C=!0:r===y.CharCode.Backslash?c=!0:r===y.CharCode.CloseSquareBracket&&(C=!1);b++}for(;b<this._input.length&&l._regexFlags.has(this._input.charCodeAt(b));)b++;this._current=b;const h=this._input.substring(this._start,this._current);this._tokens.push({type:O.RegexStr,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=l}),define(De[206],Ie([1,0,24,35,171,321]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=v,e.parseVersion=l,e.normalizeVersion=T,e.isValidVersion=b,e.validateExtensionManifest=c,e.isValidExtensionVersion=C,e.isEngineValid=h;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function v(a){return a=a.trim(),a==="*"||A.test(a)}function l(a){if(!v(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=a.match(A);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}function T(a){if(!a)return null;const d=a.majorBase,t=a.majorMustEqual,s=a.minorBase;let n=a.minorMustEqual;const i=a.patchBase;let g=a.patchMustEqual;a.hasCaret&&(d===0||(n=!1),g=!1);let f=0;if(a.preRelease){const u=R.exec(a.preRelease);if(u){const[,E,I,_]=u;f=Date.UTC(Number(E),Number(I)-1,Number(_))}}return{majorBase:d,majorMustEqual:t,minorBase:s,minorMustEqual:n,patchBase:i,patchMustEqual:g,isMinimum:a.hasGreaterEquals,notBefore:f}}function b(a,d,t){let s;typeof a=="string"?s=T(l(a)):s=a;let n;d instanceof Date?n=d.getTime():typeof d=="string"&&(n=new Date(d).getTime());let i;if(typeof t=="string"?i=T(l(t)):i=t,!s||!i)return!1;const g=s.majorBase,f=s.minorBase,u=s.patchBase;let E=i.majorBase,I=i.minorBase,_=i.patchBase;const w=i.notBefore;let p=i.majorMustEqual,D=i.minorMustEqual,m=i.patchMustEqual;return i.isMinimum?g>E?!0:g<E?!1:f>I?!0:f<I||n&&n<w?!1:u>=_:(g===1&&E===0&&(!p||!D||!m)&&(E=1,I=0,_=0,p=!0,D=!1,m=!1),g<E?!1:g>E?!p:f<I?!1:f>I?!D:u<_?!1:u>_?!m:!(n&&n<w))}function c(a,d,t,s,n){const i=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return i.push([k.default.Error,P.localize(0,null)]),i;if(typeof s.name!="string")return i.push([k.default.Error,P.localize(1,null,"name")]),i;if(typeof s.version!="string")return i.push([k.default.Error,P.localize(2,null,"version")]),i;if(!s.engines)return i.push([k.default.Error,P.localize(3,null,"engines")]),i;if(typeof s.engines.vscode!="string")return i.push([k.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof s.extensionDependencies<"u"&&!o(s.extensionDependencies))return i.push([k.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof s.activationEvents<"u"){if(!o(s.activationEvents))return i.push([k.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof s.main>"u"&&typeof s.browser>"u")return i.push([k.default.Error,P.localize(7,null,"activationEvents","main","browser")]),i}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&i.push([k.default.Warning,P.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return i.push([k.default.Error,P.localize(9,null,"main")]),i;{const u=(0,y.joinPath)(t,s.main);(0,y.isEqualOrParent)(u,t)||i.push([k.default.Warning,P.localize(10,null,u.path,t.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return i.push([k.default.Error,P.localize(11,null,"browser")]),i;{const u=(0,y.joinPath)(t,s.browser);(0,y.isEqualOrParent)(u,t)||i.push([k.default.Warning,P.localize(12,null,u.path,t.path)])}}if(!O.valid(s.version))return i.push([k.default.Error,P.localize(13,null)]),i;const g=[];if(!C(a,d,s,n,g))for(const u of g)i.push([k.default.Error,u]);return i}function C(a,d,t,s,n){return s||typeof t.main>"u"&&typeof t.browser>"u"?!0:r(a,d,t.engines.vscode,n)}function h(a,d,t){return a==="*"||r(d,t,a)}function r(a,d,t,s=[]){const n=T(l(t));if(!n)return s.push(P.localize(14,null,t)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return s.push(P.localize(15,null,t)),!1}else if(!n.majorMustEqual)return s.push(P.localize(16,null,t)),!1;return b(a,d,n)?!0:(s.push(P.localize(17,null,a,t)),!1)}function o(a){if(!Array.isArray(a))return!1;for(let d=0,t=a.length;d<t;d++)if(typeof a[d]!="string")return!1;return!0}}),define(De[74],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class y{constructor(P,O=[],A=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=y}),define(De[60],Ie([1,0,74]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=O,e.getSingletonServiceDescriptors=A;const k=[];var P;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(R,v,l){v instanceof y.SyncDescriptor||(v=new y.SyncDescriptor(v,[],!!l)),k.push([R,v])}function A(){return k}}),define(De[207],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=y;class k{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const A of this._nodes.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const R=this.lookupOrInsertNode(O),v=this.lookupOrInsertNode(A);R.outgoing.set(v.key,v),v.incoming.set(R.key,R)}removeNode(O){const A=this._hashFn(O);this._nodes.delete(A);for(const R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(O){const A=this._hashFn(O);let R=this._nodes.get(A);return R||(R=new y(A,O),this._nodes.set(A,R)),R}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[A,R]of this._nodes)O.push(`${A}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this._nodes){const R=new Set([O]),v=this._findCycle(A,R);if(v)return v}}_findCycle(O,A){for(const[R,v]of O.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const l=this._findCycle(v,A);if(l)return l;A.delete(R)}}}e.Graph=k}),define(De[3],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=P,e.refineServiceDecorator=O;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(v){return v[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(y||(e._util=y={})),e.IInstantiationService=P("instantiationService");function k(A,R,v){R[y.DI_TARGET]===R?R[y.DI_DEPENDENCIES].push({id:A,index:v}):(R[y.DI_DEPENDENCIES]=[{id:A,index:v}],R[y.DI_TARGET]=R)}function P(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const R=function(v,l,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(R,v,T)};return R.toString=()=>A,y.serviceIds.set(A,R),R}function O(A){return A}}),define(De[42],Ie([1,0,15,2,3]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=O,e.isConfigurationUpdateOverrides=A,e.ConfigurationTargetToString=v,e.isConfigured=l,e.toValuesTree=T,e.addToValueTree=b,e.removeFromValueTree=c,e.getConfigurationValue=h,e.merge=r,e.getLanguageTagSettingPlainKey=o,e.IConfigurationService=(0,P.createDecorator)("configurationService");function O(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof k.URI)}function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof k.URI)}var R;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function v(a){switch(a){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function l(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function T(a,d){const t=Object.create(null);for(const s in a)b(t,s,a[s],d);return t}function b(a,d,t,s){const n=d.split("."),i=n.pop();let g=a;for(let f=0;f<n.length;f++){const u=n[f];let E=g[u];switch(typeof E){case"undefined":E=g[u]=Object.create(null);break;case"object":if(E===null){s(`Ignoring ${d} as ${n.slice(0,f+1).join(".")} is null`);return}break;default:s(`Ignoring ${d} as ${n.slice(0,f+1).join(".")} is ${JSON.stringify(E)}`);return}g=E}if(typeof g=="object"&&g!==null)try{g[i]=t}catch{s(`Ignoring ${d} as ${n.join(".")} is ${JSON.stringify(g)}`)}else s(`Ignoring ${d} as ${n.join(".")} is ${JSON.stringify(g)}`)}function c(a,d){const t=d.split(".");C(a,t)}function C(a,d){const t=d.shift();if(d.length===0){delete a[t];return}if(Object.keys(a).indexOf(t)!==-1){const s=a[t];typeof s=="object"&&!Array.isArray(s)&&(C(s,d),Object.keys(s).length===0&&delete a[t])}}function h(a,d,t){function s(g,f){let u=g;for(const E of f){if(typeof u!="object"||u===null)return;u=u[E]}return u}const n=d.split("."),i=s(a,n);return typeof i>"u"?t:i}function r(a,d,t){Object.keys(d).forEach(s=>{s!=="__proto__"&&(s in a?y.isObject(a[s])&&y.isObject(d[s])?r(a[s],d[s],t):t&&(a[s]=d[s]):a[s]=d[s])})}function o(a){return a.replace(/[\[\]]/g,"")}}),define(De[32],Ie([1,0,28,21,13,205,3,168,14]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=T,e.validateWhenClauses=f,e.expressionsAreEqualWithConstantSubstitution=u,e.implies=se;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",k.isMacintosh),l.set("isLinux",k.isLinux),l.set("isWindows",k.isWindows),l.set("isWeb",k.isWeb),l.set("isMacNative",k.isMacintosh&&!k.isWeb),l.set("isEdge",k.isEdge),l.set("isFirefox",k.isFirefox),l.set("isChrome",k.isChrome),l.set("isSafari",k.isSafari);function T(Q,W){if(l.get(Q)!==void 0)throw(0,v.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(Q,W)}const b=Object.prototype.hasOwnProperty;var c;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(c||(e.ContextKeyExprType=c={}));const C={regexParsingWithErrorRecovery:!0},h=(0,R.localize)(0,null),r=(0,R.localize)(1,null),o=(0,R.localize)(2,null),a=(0,R.localize)(3,null),d=(0,R.localize)(4,null),t=(0,R.localize)(5,null),s=(0,R.localize)(6,null),n=(0,R.localize)(7,null);class i{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(W=C){this._config=W,this._scanner=new O.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(W){if(W===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:r});return}this._tokens=this._scanner.reset(W).scan(),this._current=0,this._parsingErrors=[];try{const ie=this._expr();if(!this._isAtEnd()){const _e=this._peek(),de=_e.type===O.TokenType.Str?t:void 0;throw this._parsingErrors.push({message:d,offset:_e.offset,lexeme:O.Scanner.getLexeme(_e),additionalInfo:de}),i._parseError}return ie}catch(ie){if(ie!==i._parseError)throw ie;return}}_expr(){return this._or()}_or(){const W=[this._and()];for(;this._matchOne(O.TokenType.Or);){const ie=this._and();W.push(ie)}return W.length===1?W[0]:g.or(...W)}_and(){const W=[this._term()];for(;this._matchOne(O.TokenType.And);){const ie=this._term();W.push(ie)}return W.length===1?W[0]:g.and(...W)}_term(){if(this._matchOne(O.TokenType.Neg)){const W=this._peek();switch(W.type){case O.TokenType.True:return this._advance(),I.INSTANCE;case O.TokenType.False:return this._advance(),_.INSTANCE;case O.TokenType.LParen:{this._advance();const ie=this._expr();return this._consume(O.TokenType.RParen,a),ie?.negate()}case O.TokenType.Str:return this._advance(),M.create(W.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",W)}}return this._primary()}_primary(){const W=this._peek();switch(W.type){case O.TokenType.True:return this._advance(),g.true();case O.TokenType.False:return this._advance(),g.false();case O.TokenType.LParen:{this._advance();const ie=this._expr();return this._consume(O.TokenType.RParen,a),ie}case O.TokenType.Str:{const ie=W.lexeme;if(this._advance(),this._matchOne(O.TokenType.RegexOp)){const de=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),de.type!==O.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",de);const Se=de.lexeme,ae=Se.lastIndexOf("/"),X=ae===Se.length-1?void 0:this._removeFlagsGY(Se.substring(ae+1));let J;try{J=new RegExp(Se.substring(1,ae),X)}catch{throw this._errExpectedButGot("REGEX",de)}return F.create(ie,J)}switch(de.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const Se=[de.lexeme];this._advance();let ae=this._peek(),X=0;for(let ze=0;ze<de.lexeme.length;ze++)de.lexeme.charCodeAt(ze)===y.CharCode.OpenParen?X++:de.lexeme.charCodeAt(ze)===y.CharCode.CloseParen&&X--;for(;!this._isAtEnd()&&ae.type!==O.TokenType.And&&ae.type!==O.TokenType.Or;){switch(ae.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let ze=0;ze<ae.lexeme.length;ze++)ae.lexeme.charCodeAt(ze)===y.CharCode.OpenParen?X++:de.lexeme.charCodeAt(ze)===y.CharCode.CloseParen&&X--}if(X<0)break;Se.push(O.Scanner.getLexeme(ae)),this._advance(),ae=this._peek()}const J=Se.join(""),me=J.lastIndexOf("/"),ge=me===J.length-1?void 0:this._removeFlagsGY(J.substring(me+1));let Le;try{Le=new RegExp(J.substring(1,me),ge)}catch{throw this._errExpectedButGot("REGEX",de)}return g.regex(ie,Le)}case O.TokenType.QuotedStr:{const Se=de.lexeme;this._advance();let ae=null;if(!(0,P.isFalsyOrWhitespace)(Se)){const X=Se.indexOf("/"),J=Se.lastIndexOf("/");if(X!==J&&X>=0){const me=Se.slice(X+1,J),ge=Se[J+1]==="i"?"i":"";try{ae=new RegExp(me,ge)}catch{throw this._errExpectedButGot("REGEX",de)}}}if(ae===null)throw this._errExpectedButGot("REGEX",de);return F.create(ie,ae)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(O.TokenType.Not)){this._consume(O.TokenType.In,o);const de=this._value();return g.notIn(ie,de)}switch(this._peek().type){case O.TokenType.Eq:{this._advance();const de=this._value();if(this._previous().type===O.TokenType.QuotedStr)return g.equals(ie,de);switch(de){case"true":return g.has(ie);case"false":return g.not(ie);default:return g.equals(ie,de)}}case O.TokenType.NotEq:{this._advance();const de=this._value();if(this._previous().type===O.TokenType.QuotedStr)return g.notEquals(ie,de);switch(de){case"true":return g.not(ie);case"false":return g.has(ie);default:return g.notEquals(ie,de)}}case O.TokenType.Lt:return this._advance(),$.create(ie,this._value());case O.TokenType.LtEq:return this._advance(),N.create(ie,this._value());case O.TokenType.Gt:return this._advance(),H.create(ie,this._value());case O.TokenType.GtEq:return this._advance(),V.create(ie,this._value());case O.TokenType.In:return this._advance(),g.in(ie,this._value());default:return g.has(ie)}}case O.TokenType.EOF:throw this._parsingErrors.push({message:s,offset:W.offset,lexeme:"",additionalInfo:n}),i._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const W=this._peek();switch(W.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this._advance(),W.lexeme;case O.TokenType.True:return this._advance(),"true";case O.TokenType.False:return this._advance(),"false";case O.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(W){return W.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(W){return this._check(W)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(W,ie){if(this._check(W))return this._advance();throw this._errExpectedButGot(ie,this._peek())}_errExpectedButGot(W,ie,_e){const de=(0,R.localize)(8,null,W,O.Scanner.getLexeme(ie)),Se=ie.offset,ae=O.Scanner.getLexeme(ie);return this._parsingErrors.push({message:de,offset:Se,lexeme:ae,additionalInfo:_e}),i._parseError}_check(W){return this._peek().type===W}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===O.TokenType.EOF}}e.Parser=i;class g{static false(){return I.INSTANCE}static true(){return _.INSTANCE}static has(W){return w.create(W)}static equals(W,ie){return p.create(W,ie)}static notEquals(W,ie){return S.create(W,ie)}static regex(W,ie){return F.create(W,ie)}static in(W,ie){return D.create(W,ie)}static notIn(W,ie){return m.create(W,ie)}static not(W){return M.create(W)}static and(...W){return fe.create(W,null,!0)}static or(...W){return Ee.create(W,null,!0)}static greater(W,ie){return H.create(W,ie)}static greaterEquals(W,ie){return V.create(W,ie)}static smaller(W,ie){return $.create(W,ie)}static smallerEquals(W,ie){return N.create(W,ie)}static{this._parser=new i({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this._parser.parse(W)}}e.ContextKeyExpr=g;function f(Q){const W=new i({regexParsingWithErrorRecovery:!1});return Q.map(ie=>(W.parse(ie),W.lexingErrors.length>0?W.lexingErrors.map(_e=>({errorMessage:_e.additionalInfo?(0,R.localize)(9,null,_e.additionalInfo):(0,R.localize)(10,null),offset:_e.offset,length:_e.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(_e=>({errorMessage:_e.additionalInfo?`${_e.message}. ${_e.additionalInfo}`:_e.message,offset:_e.offset,length:_e.lexeme.length})):[]))}function u(Q,W){const ie=Q?Q.substituteConstants():void 0,_e=W?W.substituteConstants():void 0;return!ie&&!_e?!0:!ie||!_e?!1:ie.equals(_e)}function E(Q,W){return Q.cmp(W)}class I{static{this.INSTANCE=new I}constructor(){this.type=c.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return _.INSTANCE}}e.ContextKeyFalseExpr=I;class _{static{this.INSTANCE=new _}constructor(){this.type=c.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=_;class w{static create(W,ie=null){const _e=l.get(W);return typeof _e=="boolean"?_e?_.INSTANCE:I.INSTANCE:new w(W,ie)}constructor(W,ie){this.key=W,this.negated=ie,this.type=c.Defined}cmp(W){return W.type!==this.type?this.type-W.type:pe(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=l.get(this.key);return typeof W=="boolean"?W?_.INSTANCE:I.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.negated||(this.negated=M.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class p{static create(W,ie,_e=null){if(typeof ie=="boolean")return ie?w.create(W,_e):M.create(W,_e);const de=l.get(W);return typeof de=="boolean"?ie===(de?"true":"false")?_.INSTANCE:I.INSTANCE:new p(W,ie,_e)}constructor(W,ie,_e){this.key=W,this.value=ie,this.negated=_e,this.type=c.Equals}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=l.get(this.key);if(typeof W=="boolean"){const ie=W?"true":"false";return this.value===ie?_.INSTANCE:I.INSTANCE}return this}evaluate(W){return W.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(W){return W.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class D{static create(W,ie){return new D(W,ie)}constructor(W,ie){this.key=W,this.valueKey=ie,this.type=c.In,this.negated=null}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.key,this.valueKey,W.key,W.valueKey)}equals(W){return W.type===this.type?this.key===W.key&&this.valueKey===W.valueKey:!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.valueKey),_e=W.getValue(this.key);return Array.isArray(ie)?ie.includes(_e):typeof _e=="string"&&typeof ie=="object"&&ie!==null?b.call(ie,_e):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(W){return W.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=D;class m{static create(W,ie){return new m(W,ie)}constructor(W,ie){this.key=W,this.valueKey=ie,this.type=c.NotIn,this._negated=D.create(W,ie)}cmp(W){return W.type!==this.type?this.type-W.type:this._negated.cmp(W._negated)}equals(W){return W.type===this.type?this._negated.equals(W._negated):!1}substituteConstants(){return this}evaluate(W){return!this._negated.evaluate(W)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(W){return W.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=m;class S{static create(W,ie,_e=null){if(typeof ie=="boolean")return ie?M.create(W,_e):w.create(W,_e);const de=l.get(W);return typeof de=="boolean"?ie===(de?"true":"false")?I.INSTANCE:_.INSTANCE:new S(W,ie,_e)}constructor(W,ie,_e){this.key=W,this.value=ie,this.negated=_e,this.type=c.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=l.get(this.key);if(typeof W=="boolean"){const ie=W?"true":"false";return this.value===ie?I.INSTANCE:_.INSTANCE}return this}evaluate(W){return W.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(W){return W.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class M{static create(W,ie=null){const _e=l.get(W);return typeof _e=="boolean"?_e?I.INSTANCE:_.INSTANCE:new M(W,ie)}constructor(W,ie){this.key=W,this.negated=ie,this.type=c.Not}cmp(W){return W.type!==this.type?this.type-W.type:pe(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=l.get(this.key);return typeof W=="boolean"?W?I.INSTANCE:_.INSTANCE:this}evaluate(W){return!W.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(W){return W.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=M;function L(Q,W){if(typeof Q=="string"){const ie=parseFloat(Q);isNaN(ie)||(Q=ie)}return typeof Q=="string"||typeof Q=="number"?W(Q):I.INSTANCE}class H{static create(W,ie,_e=null){return L(ie,de=>new H(W,de,_e))}constructor(W,ie,_e){this.key=W,this.value=ie,this.negated=_e,this.type=c.Greater}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=H;class V{static create(W,ie,_e=null){return L(ie,de=>new V(W,de,_e))}constructor(W,ie,_e){this.key=W,this.value=ie,this.negated=_e,this.type=c.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=V;class ${static create(W,ie,_e=null){return L(ie,de=>new $(W,de,_e))}constructor(W,ie,_e){this.key=W,this.value=ie,this.negated=_e,this.type=c.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=V.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=$;class N{static create(W,ie,_e=null){return L(ie,de=>new N(W,de,_e))}constructor(W,ie,_e){this.key=W,this.value=ie,this.negated=_e,this.type=c.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=N;class F{static create(W,ie){return new F(W,ie)}constructor(W,ie){this.key=W,this.regexp=ie,this.type=c.Regex,this.negated=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.key<W.key)return-1;if(this.key>W.key)return 1;const ie=this.regexp?this.regexp.source:"",_e=W.regexp?W.regexp.source:"";return ie<_e?-1:ie>_e?1:0}equals(W){if(W.type===this.type){const ie=this.regexp?this.regexp.source:"",_e=W.regexp?W.regexp.source:"";return this.key===W.key&&ie===_e}return!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.key);return this.regexp?this.regexp.test(ie):!1}serialize(){const W=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${W}`}keys(){return[this.key]}map(W){return W.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=Y.create(this)),this.negated}}e.ContextKeyRegexExpr=F;class Y{static create(W){return new Y(W)}constructor(W){this._actual=W,this.type=c.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this._actual.cmp(W._actual)}equals(W){return W.type===this.type?this._actual.equals(W._actual):!1}substituteConstants(){return this}evaluate(W){return!this._actual.evaluate(W)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(W){return new Y(this._actual.map(W))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=Y;function re(Q){let W=null;for(let ie=0,_e=Q.length;ie<_e;ie++){const de=Q[ie].substituteConstants();if(Q[ie]!==de&&W===null){W=[];for(let Se=0;Se<ie;Se++)W[Se]=Q[Se]}W!==null&&(W[ie]=de)}return W===null?Q:W}class fe{static create(W,ie,_e){return fe._normalizeArr(W,ie,_e)}constructor(W,ie){this.expr=W,this.negated=ie,this.type=c.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,_e=this.expr.length;ie<_e;ie++){const de=E(this.expr[ie],W.expr[ie]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,_e=this.expr.length;ie<_e;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:fe.create(W,this.negated,!1)}evaluate(W){for(let ie=0,_e=this.expr.length;ie<_e;ie++)if(!this.expr[ie].evaluate(W))return!1;return!0}static _normalizeArr(W,ie,_e){const de=[];let Se=!1;for(const ae of W)if(ae){if(ae.type===c.True){Se=!0;continue}if(ae.type===c.False)return I.INSTANCE;if(ae.type===c.And){de.push(...ae.expr);continue}de.push(ae)}if(de.length===0&&Se)return _.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort(E);for(let ae=1;ae<de.length;ae++)de[ae-1].equals(de[ae])&&(de.splice(ae,1),ae--);if(de.length===1)return de[0];for(;de.length>1;){const ae=de[de.length-1];if(ae.type!==c.Or)break;de.pop();const X=de.pop(),J=de.length===0,me=Ee.create(ae.expr.map(ge=>fe.create([ge,X],null,_e)),null,J);me&&(de.push(me),de.sort(E))}if(de.length===1)return de[0];if(_e){for(let ae=0;ae<de.length;ae++)for(let X=ae+1;X<de.length;X++)if(de[ae].negate().equals(de[X]))return I.INSTANCE;if(de.length===1)return de[0]}return new fe(de,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new fe(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.negated){const W=[];for(const ie of this.expr)W.push(ie.negate());this.negated=Ee.create(W,this,!0)}return this.negated}}e.ContextKeyAndExpr=fe;class Ee{static create(W,ie,_e){return Ee._normalizeArr(W,ie,_e)}constructor(W,ie){this.expr=W,this.negated=ie,this.type=c.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,_e=this.expr.length;ie<_e;ie++){const de=E(this.expr[ie],W.expr[ie]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,_e=this.expr.length;ie<_e;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:Ee.create(W,this.negated,!1)}evaluate(W){for(let ie=0,_e=this.expr.length;ie<_e;ie++)if(this.expr[ie].evaluate(W))return!0;return!1}static _normalizeArr(W,ie,_e){let de=[],Se=!1;if(W){for(let ae=0,X=W.length;ae<X;ae++){const J=W[ae];if(J){if(J.type===c.False){Se=!0;continue}if(J.type===c.True)return _.INSTANCE;if(J.type===c.Or){de=de.concat(J.expr);continue}de.push(J)}}if(de.length===0&&Se)return I.INSTANCE;de.sort(E)}if(de.length!==0){if(de.length===1)return de[0];for(let ae=1;ae<de.length;ae++)de[ae-1].equals(de[ae])&&(de.splice(ae,1),ae--);if(de.length===1)return de[0];if(_e){for(let ae=0;ae<de.length;ae++)for(let X=ae+1;X<de.length;X++)if(de[ae].negate().equals(de[X]))return _.INSTANCE;if(de.length===1)return de[0]}return new Ee(de,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new Ee(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.negated){const W=[];for(const ie of this.expr)W.push(ie.negate());for(;W.length>1;){const ie=W.shift(),_e=W.shift(),de=[];for(const Se of Me(ie))for(const ae of Me(_e))de.push(fe.create([Se,ae],null,!1));W.unshift(Ee.create(de,null,!1))}this.negated=Ee.create(W,this,!0)}return this.negated}}e.ContextKeyOrExpr=Ee;class oe extends w{static{this._info=[]}static all(){return oe._info.values()}constructor(W,ie,_e){super(W,null),this._defaultValue=ie,typeof _e=="object"?oe._info.push({..._e,key:W}):_e!==!0&&oe._info.push({key:W,description:_e,type:ie!=null?typeof ie:void 0})}bindTo(W){return W.createKey(this.key,this._defaultValue)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return p.create(this.key,W)}notEqualsTo(W){return S.create(this.key,W)}}e.RawContextKey=oe,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function pe(Q,W){return Q<W?-1:Q>W?1:0}function ve(Q,W,ie,_e){return Q<ie?-1:Q>ie?1:W<_e?-1:W>_e?1:0}function se(Q,W){if(Q.type===c.False||W.type===c.True)return!0;if(Q.type===c.Or)return W.type===c.Or?Te(Q.expr,W.expr):!1;if(W.type===c.Or){for(const ie of W.expr)if(se(Q,ie))return!0;return!1}if(Q.type===c.And){if(W.type===c.And)return Te(W.expr,Q.expr);for(const ie of Q.expr)if(se(ie,W))return!0;return!1}return Q.equals(W)}function Te(Q,W){let ie=0,_e=0;for(;ie<Q.length&&_e<W.length;){const de=Q[ie].cmp(W[_e]);if(de<0)return!1;de===0&&ie++,_e++}return ie===Q.length}function Me(Q){return Q.type===c.Or?Q.expr:[Q]}}),define(De[208],Ie([1,0,32,3]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX=e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=e.AccessibilitySupport=e.IAccessibilityService=void 0,e.isAccessibilityInformation=O,e.IAccessibilityService=(0,k.createDecorator)("accessibilityService");var P;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=new y.RawContextKey("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX="ACCESSIBLE_VIEW_SHOWN_"}),define(De[104],Ie([1,0,18,26,21,142,322,148,209,166,208]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=t,e.clampedInt=n,e.clampedFloat=g,e.stringSet=E,e.cursorStyleToString=L,e.filterValidationDecorations=ye;var b;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(b||(e.EditorAutoIndentStrategy=b={})),e.MINIMAP_GUTTER_WIDTH=8;class c{constructor(j){this._values=j}hasChanged(j){return this._values[j]}}e.ConfigurationChangedEvent=c;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class h{constructor(j,we,qe,Je){this.id=j,this.name=we,this.defaultValue=qe,this.schema=Je}applyUpdate(j,we){return o(j,we)}compute(j,we,qe){return qe}}class r{constructor(j,we){this.newValue=j,this.didChange=we}}e.ApplyUpdateResult=r;function o(Z,j){if(typeof Z!="object"||typeof j!="object"||!Z||!j)return new r(j,Z!==j);if(Array.isArray(Z)||Array.isArray(j)){const qe=Array.isArray(Z)&&Array.isArray(j)&&y.equals(Z,j);return new r(j,!qe)}let we=!1;for(const qe in j)if(j.hasOwnProperty(qe)){const Je=o(Z[qe],j[qe]);Je.didChange&&(Z[qe]=Je.newValue,we=!0)}return new r(Z,we)}class a{constructor(j){this.schema=void 0,this.id=j,this.name="_never_",this.defaultValue=void 0}applyUpdate(j,we){return o(j,we)}validate(j){return this.defaultValue}}class d{constructor(j,we,qe,Je){this.id=j,this.name=we,this.defaultValue=qe,this.schema=Je}applyUpdate(j,we){return o(j,we)}validate(j){return typeof j>"u"?this.defaultValue:j}compute(j,we,qe){return qe}}function t(Z,j){return typeof Z>"u"?j:Z==="false"?!1:!!Z}class s extends d{constructor(j,we,qe,Je=void 0){typeof Je<"u"&&(Je.type="boolean",Je.default=qe),super(j,we,qe,Je)}validate(j){return t(j,this.defaultValue)}}function n(Z,j,we,qe){if(typeof Z>"u")return j;let Je=parseInt(Z,10);return isNaN(Je)?j:(Je=Math.max(we,Je),Je=Math.min(qe,Je),Je|0)}class i extends d{static clampedInt(j,we,qe,Je){return n(j,we,qe,Je)}constructor(j,we,qe,Je,lt,gt=void 0){typeof gt<"u"&&(gt.type="integer",gt.default=qe,gt.minimum=Je,gt.maximum=lt),super(j,we,qe,gt),this.minimum=Je,this.maximum=lt}validate(j){return i.clampedInt(j,this.defaultValue,this.minimum,this.maximum)}}function g(Z,j,we,qe){if(typeof Z>"u")return j;const Je=f.float(Z,j);return f.clamp(Je,we,qe)}class f extends d{static clamp(j,we,qe){return j<we?we:j>qe?qe:j}static float(j,we){if(typeof j=="number")return j;if(typeof j>"u")return we;const qe=parseFloat(j);return isNaN(qe)?we:qe}constructor(j,we,qe,Je,lt){typeof lt<"u"&&(lt.type="number",lt.default=qe),super(j,we,qe,lt),this.validationFn=Je}validate(j){return this.validationFn(f.float(j,this.defaultValue))}}class u extends d{static string(j,we){return typeof j!="string"?we:j}constructor(j,we,qe,Je=void 0){typeof Je<"u"&&(Je.type="string",Je.default=qe),super(j,we,qe,Je)}validate(j){return u.string(j,this.defaultValue)}}function E(Z,j,we,qe){return typeof Z!="string"?j:qe&&Z in qe?qe[Z]:we.indexOf(Z)===-1?j:Z}class I extends d{constructor(j,we,qe,Je,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=Je,lt.default=qe),super(j,we,qe,lt),this._allowedValues=Je}validate(j){return E(j,this.defaultValue,this._allowedValues)}}class _ extends h{constructor(j,we,qe,Je,lt,gt,Rt=void 0){typeof Rt<"u"&&(Rt.type="string",Rt.enum=lt,Rt.default=Je),super(j,we,qe,Rt),this._allowedValues=lt,this._convert=gt}validate(j){return typeof j!="string"?this.defaultValue:this._allowedValues.indexOf(j)===-1?this.defaultValue:this._convert(j)}}function w(Z){switch(Z){case"none":return b.None;case"keep":return b.Keep;case"brackets":return b.Brackets;case"advanced":return b.Advanced;case"full":return b.Full}}class p extends h{constructor(){super(xe.accessibilitySupport,"accessibilitySupport",T.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(j){switch(j){case"auto":return T.AccessibilitySupport.Unknown;case"off":return T.AccessibilitySupport.Disabled;case"on":return T.AccessibilitySupport.Enabled}return this.defaultValue}compute(j,we,qe){return qe===T.AccessibilitySupport.Unknown?j.accessibilitySupport:qe}}class D extends h{constructor(){const j={insertSpace:!0,ignoreEmptyLines:!0};super(xe.comments,"comments",j,{"editor.comments.insertSpace":{type:"boolean",default:j.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:j.ignoreEmptyLines,description:l.localize(5,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{insertSpace:t(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var m;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(m||(e.TextEditorCursorBlinkingStyle=m={}));function S(Z){switch(Z){case"blink":return m.Blink;case"smooth":return m.Smooth;case"phase":return m.Phase;case"expand":return m.Expand;case"solid":return m.Solid}}var M;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function L(Z){switch(Z){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function H(Z){switch(Z){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class V extends a{constructor(){super(xe.editorClassName)}compute(j,we,qe){const Je=["monaco-editor"];return we.get(xe.extraEditorClassName)&&Je.push(we.get(xe.extraEditorClassName)),j.extraEditorClassName&&Je.push(j.extraEditorClassName),we.get(xe.mouseStyle)==="default"?Je.push("mouse-default"):we.get(xe.mouseStyle)==="copy"&&Je.push("mouse-copy"),we.get(xe.showUnused)&&Je.push("showUnused"),we.get(xe.showDeprecated)&&Je.push("showDeprecated"),Je.join(" ")}}class $ extends s{constructor(){super(xe.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(j,we,qe){return qe&&j.emptySelectionClipboard}}class N extends h{constructor(){const j={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(xe.find,"find",j,{"editor.find.cursorMoveOnType":{type:"boolean",default:j.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:j.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:j.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:j.globalFindClipboard,description:l.localize(16,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:j.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:j.loop,description:l.localize(18,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{cursorMoveOnType:t(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof j.seedSearchStringFromSelection=="boolean"?j.seedSearchStringFromSelection?"always":"never":E(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof j.autoFindInSelection=="boolean"?j.autoFindInSelection?"always":"never":E(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(we.loop,this.defaultValue.loop)}}}class F extends h{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(xe.fontLigatures,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(j){return typeof j>"u"?this.defaultValue:typeof j=="string"?j==="false"||j.length===0?F.OFF:j==="true"?F.ON:j:j?F.ON:F.OFF}}e.EditorFontLigatures=F;class Y extends h{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(xe.fontVariations,"fontVariations",Y.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(j){return typeof j>"u"?this.defaultValue:typeof j=="string"?j==="false"?Y.OFF:j==="true"?Y.TRANSLATE:j:j?Y.TRANSLATE:Y.OFF}compute(j,we,qe){return j.fontInfo.fontVariationSettings}}e.EditorFontVariations=Y;class re extends a{constructor(){super(xe.fontInfo)}compute(j,we,qe){return j.fontInfo}}class fe extends d{constructor(){super(xe.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(j){const we=f.float(j,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(we,6,100)}compute(j,we,qe){return j.fontInfo.fontSize}}class Ee extends h{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(xe.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Ee.MINIMUM_VALUE,maximum:Ee.MAXIMUM_VALUE,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Ee.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(j){return j==="normal"||j==="bold"?j:String(i.clampedInt(j,e.EDITOR_FONT_DEFAULTS.fontWeight,Ee.MINIMUM_VALUE,Ee.MAXIMUM_VALUE))}}class oe extends h{constructor(){const j={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:j.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(xe.gotoLocation,"gotoLocation",j,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...we},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...we},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...we},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...we},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...we},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:j.alternativeDefinitionCommand,enum:qe,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:j.alternativeTypeDefinitionCommand,enum:qe,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:j.alternativeDeclarationCommand,enum:qe,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:j.alternativeImplementationCommand,enum:qe,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:j.alternativeReferenceCommand,enum:qe,description:l.localize(41,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{multiple:E(we.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:we.multipleDefinitions??E(we.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:we.multipleTypeDefinitions??E(we.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:we.multipleDeclarations??E(we.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:we.multipleImplementations??E(we.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:we.multipleReferences??E(we.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(we.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(we.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(we.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(we.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(we.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class pe extends h{constructor(){const j={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(xe.hover,"hover",j,{"editor.hover.enabled":{type:"boolean",default:j.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:j.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:j.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:j.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:j.above,description:l.localize(46,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{enabled:t(we.enabled,this.defaultValue.enabled),delay:i.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:t(we.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(we.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(we.above,this.defaultValue.above)}}}var ve;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(ve||(e.RenderMinimap=ve={}));class se extends a{constructor(){super(xe.layoutInfo)}compute(j,we,qe){return se.computeLayout(we,{memory:j.memory,outerWidth:j.outerWidth,outerHeight:j.outerHeight,isDominatedByLongLines:j.isDominatedByLongLines,lineHeight:j.fontInfo.lineHeight,viewLineCount:j.viewLineCount,lineNumbersDigitCount:j.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:j.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:j.fontInfo.maxDigitWidth,pixelRatio:j.pixelRatio,glyphMarginDecorationLaneCount:j.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(j){const we=j.height/j.lineHeight,qe=Math.floor(j.paddingTop/j.lineHeight);let Je=Math.floor(j.paddingBottom/j.lineHeight);j.scrollBeyondLastLine&&(Je=Math.max(Je,we-1));const lt=(qe+j.viewLineCount+Je)/(j.pixelRatio*j.height),gt=Math.floor(j.viewLineCount/lt);return{typicalViewportLineCount:we,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Je,desiredRatio:lt,minimapLineCount:gt}}static _computeMinimapLayout(j,we){const qe=j.outerWidth,Je=j.outerHeight,lt=j.pixelRatio;if(!j.minimap.enabled)return{renderMinimap:ve.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(lt*Je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Je};const gt=we.stableMinimapLayoutInput,Rt=gt&&j.outerHeight===gt.outerHeight&&j.lineHeight===gt.lineHeight&&j.typicalHalfwidthCharacterWidth===gt.typicalHalfwidthCharacterWidth&&j.pixelRatio===gt.pixelRatio&&j.scrollBeyondLastLine===gt.scrollBeyondLastLine&&j.paddingTop===gt.paddingTop&&j.paddingBottom===gt.paddingBottom&&j.minimap.enabled===gt.minimap.enabled&&j.minimap.side===gt.minimap.side&&j.minimap.size===gt.minimap.size&&j.minimap.showSlider===gt.minimap.showSlider&&j.minimap.renderCharacters===gt.minimap.renderCharacters&&j.minimap.maxColumn===gt.minimap.maxColumn&&j.minimap.scale===gt.minimap.scale&&j.verticalScrollbarWidth===gt.verticalScrollbarWidth&&j.isViewportWrapping===gt.isViewportWrapping,Gt=j.lineHeight,Ut=j.typicalHalfwidthCharacterWidth,ui=j.scrollBeyondLastLine,Jt=j.minimap.renderCharacters;let Xe=lt>=2?Math.round(j.minimap.scale*2):j.minimap.scale;const Wt=j.minimap.maxColumn,xt=j.minimap.size,ft=j.minimap.side,pt=j.verticalScrollbarWidth,Zt=j.viewLineCount,Xt=j.remainingWidth,Bt=j.isViewportWrapping,Et=Jt?2:3;let Ot=Math.floor(lt*Je);const Ht=Ot/lt;let zt=!1,Ge=!1,ei=Et*Xe,ti=Xe/lt,li=1;if(xt==="fill"||xt==="fit"){const{typicalViewportLineCount:ri,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:Qt,desiredRatio:si,minimapLineCount:Tt}=se.computeContainedMinimapLineCount({viewLineCount:Zt,scrollBeyondLastLine:ui,paddingTop:j.paddingTop,paddingBottom:j.paddingBottom,height:Je,lineHeight:Gt,pixelRatio:lt});if(Zt/Tt>1)zt=!0,Ge=!0,Xe=1,ei=1,ti=Xe/lt;else{let vt=!1,Vt=Xe+1;if(xt==="fit"){const Ct=Math.ceil((Ft+Zt+Qt)*ei);Bt&&Rt&&Xt<=we.stableFitRemainingWidth?(vt=!0,Vt=we.stableFitMaxMinimapScale):vt=Ct>Ot}if(xt==="fill"||vt){zt=!0;const Ct=Xe;ei=Math.min(Gt*lt,Math.max(1,Math.floor(1/si))),Bt&&Rt&&Xt<=we.stableFitRemainingWidth&&(Vt=we.stableFitMaxMinimapScale),Xe=Math.min(Vt,Math.max(1,Math.floor(ei/Et))),Xe>Ct&&(li=Math.min(2,Xe/Ct)),ti=Xe/lt/li,Ot=Math.ceil(Math.max(ri,Ft+Zt+Qt)*ei),Bt?(we.stableMinimapLayoutInput=j,we.stableFitRemainingWidth=Xt,we.stableFitMaxMinimapScale=Xe):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0)}}}const _t=Math.floor(Wt*ti),Lt=Math.min(_t,Math.max(0,Math.floor((Xt-pt-2)*ti/(Ut+ti)))+e.MINIMAP_GUTTER_WIDTH);let Pt=Math.floor(lt*Lt);const Nt=Pt/lt;Pt=Math.floor(Pt*li);const ci=Jt?ve.Text:ve.Blocks,$t=ft==="left"?0:qe-Lt-pt;return{renderMinimap:ci,minimapLeft:$t,minimapWidth:Lt,minimapHeightIsEditorHeight:zt,minimapIsSampling:Ge,minimapScale:Xe,minimapLineHeight:ei,minimapCanvasInnerWidth:Pt,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:Ht}}static computeLayout(j,we){const qe=we.outerWidth|0,Je=we.outerHeight|0,lt=we.lineHeight|0,gt=we.lineNumbersDigitCount|0,Rt=we.typicalHalfwidthCharacterWidth,Gt=we.maxDigitWidth,Ut=we.pixelRatio,ui=we.viewLineCount,Jt=j.get(xe.wordWrapOverride2),Xe=Jt==="inherit"?j.get(xe.wordWrapOverride1):Jt,Wt=Xe==="inherit"?j.get(xe.wordWrap):Xe,xt=j.get(xe.wordWrapColumn),ft=we.isDominatedByLongLines,pt=j.get(xe.glyphMargin),Zt=j.get(xe.lineNumbers).renderType!==Le.Off,Xt=j.get(xe.lineNumbersMinChars),Bt=j.get(xe.scrollBeyondLastLine),Et=j.get(xe.padding),Ot=j.get(xe.minimap),Ht=j.get(xe.scrollbar),zt=Ht.verticalScrollbarSize,Ge=Ht.verticalHasArrows,ei=Ht.arrowSize,ti=Ht.horizontalScrollbarSize,li=j.get(xe.folding),_t=j.get(xe.showFoldingControls)!=="never";let Lt=j.get(xe.lineDecorationsWidth);li&&_t&&(Lt+=16);let Pt=0;if(Zt){const qt=Math.max(gt,Xt);Pt=Math.round(qt*Gt)}let Nt=0;pt&&(Nt=lt*we.glyphMarginDecorationLaneCount);let ci=0,$t=ci+Nt,ri=$t+Pt,Ft=ri+Lt;const Qt=qe-Nt-Pt-Lt;let si=!1,Tt=!1,St=-1;Xe==="inherit"&&ft?(si=!0,Tt=!0):Wt==="on"||Wt==="bounded"?Tt=!0:Wt==="wordWrapColumn"&&(St=xt);const vt=se._computeMinimapLayout({outerWidth:qe,outerHeight:Je,lineHeight:lt,typicalHalfwidthCharacterWidth:Rt,pixelRatio:Ut,scrollBeyondLastLine:Bt,paddingTop:Et.top,paddingBottom:Et.bottom,minimap:Ot,verticalScrollbarWidth:zt,viewLineCount:ui,remainingWidth:Qt,isViewportWrapping:Tt},we.memory||new C);vt.renderMinimap!==ve.None&&vt.minimapLeft===0&&(ci+=vt.minimapWidth,$t+=vt.minimapWidth,ri+=vt.minimapWidth,Ft+=vt.minimapWidth);const Vt=Qt-vt.minimapWidth,Ct=Math.max(1,Math.floor((Vt-zt-2)/Rt)),oi=Ge?ei:0;return Tt&&(St=Math.max(1,Ct),Wt==="bounded"&&(St=Math.min(St,xt))),{width:qe,height:Je,glyphMarginLeft:ci,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:we.glyphMarginDecorationLaneCount,lineNumbersLeft:$t,lineNumbersWidth:Pt,decorationsLeft:ri,decorationsWidth:Lt,contentLeft:Ft,contentWidth:Vt,minimap:vt,viewportColumn:Ct,isWordWrapMinified:si,isViewportWrapping:Tt,wrappingColumn:St,verticalScrollbarWidth:zt,horizontalScrollbarHeight:ti,overviewRuler:{top:oi,width:zt,height:Je-2*oi,right:0}}}}e.EditorLayoutInfoComputer=se;class Te extends h{constructor(){super(xe.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(j){return E(j,"simple",["simple","advanced"])}compute(j,we,qe){return we.get(xe.accessibilitySupport)===T.AccessibilitySupport.Enabled?"advanced":qe}}var Me;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(Me||(e.ShowLightbulbIconMode=Me={}));class Q extends h{constructor(){const j={enabled:Me.On};super(xe.lightbulb,"lightbulb",j,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Me.Off,Me.OnCode,Me.On],default:j.enabled,enumDescriptions:[l.localize(50,null),l.localize(51,null),l.localize(52,null)],description:l.localize(53,null)}})}validate(j){return!j||typeof j!="object"?this.defaultValue:{enabled:E(j.enabled,this.defaultValue.enabled,[Me.Off,Me.OnCode,Me.On])}}}class W extends h{constructor(){const j={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(xe.stickyScroll,"stickyScroll",j,{"editor.stickyScroll.enabled":{type:"boolean",default:j.enabled,description:l.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:j.maxLineCount,minimum:1,maximum:20,description:l.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:j.defaultModel,description:l.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:j.scrollWithEditor,description:l.localize(57,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{enabled:t(we.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(we.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:E(we.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(we.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ie extends h{constructor(){const j={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(xe.inlayHints,"inlayHints",j,{"editor.inlayHints.enabled":{type:"string",default:j.enabled,description:l.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(59,null),l.localize(60,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(61,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:j.fontSize,markdownDescription:l.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:j.fontFamily,markdownDescription:l.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:j.padding,description:l.localize(65,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return typeof we.enabled=="boolean"&&(we.enabled=we.enabled?"on":"off"),{enabled:E(we.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(we.fontFamily,this.defaultValue.fontFamily),padding:t(we.padding,this.defaultValue.padding)}}}class _e extends h{constructor(){super(xe.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(j){return typeof j=="string"&&/^\d+(\.\d+)?ch$/.test(j)?-parseFloat(j.substring(0,j.length-2)):i.clampedInt(j,this.defaultValue,0,1e3)}compute(j,we,qe){return qe<0?i.clampedInt(-qe*j.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class de extends f{constructor(){super(xe.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,j=>f.clamp(j,0,150),{markdownDescription:l.localize(66,null)})}compute(j,we,qe){return j.fontInfo.lineHeight}}class Se extends h{constructor(){const j={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(xe.minimap,"minimap",j,{"editor.minimap.enabled":{type:"boolean",default:j.enabled,description:l.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:j.autohide,description:l.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(69,null),l.localize(70,null),l.localize(71,null)],default:j.size,description:l.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:j.side,description:l.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:j.showSlider,description:l.localize(74,null)},"editor.minimap.scale":{type:"number",default:j.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:j.renderCharacters,description:l.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:j.maxColumn,description:l.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:j.showRegionSectionHeaders,description:l.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:j.showMarkSectionHeaders,description:l.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:j.sectionHeaderFontSize,description:l.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:j.sectionHeaderLetterSpacing,description:l.localize(81,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{enabled:t(we.enabled,this.defaultValue.enabled),autohide:t(we.autohide,this.defaultValue.autohide),size:E(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:E(we.side,this.defaultValue.side,["right","left"]),showSlider:E(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(we.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(we.scale,1,1,3),maxColumn:i.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:t(we.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:t(we.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(we.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(we.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ae(Z){return Z==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class X extends h{constructor(){super(xe.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(83,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{top:i.clampedInt(we.top,0,0,1e3),bottom:i.clampedInt(we.bottom,0,0,1e3)}}}class J extends h{constructor(){const j={enabled:!0,cycle:!0};super(xe.parameterHints,"parameterHints",j,{"editor.parameterHints.enabled":{type:"boolean",default:j.enabled,description:l.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:j.cycle,description:l.localize(85,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{enabled:t(we.enabled,this.defaultValue.enabled),cycle:t(we.cycle,this.defaultValue.cycle)}}}class me extends a{constructor(){super(xe.pixelRatio)}compute(j,we,qe){return j.pixelRatio}}class ge extends h{constructor(){const j={other:"on",comments:"off",strings:"off"},we=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null)]}];super(xe.quickSuggestions,"quickSuggestions",j,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:we,default:j.strings,description:l.localize(89,null)},comments:{anyOf:we,default:j.comments,description:l.localize(90,null)},other:{anyOf:we,default:j.other,description:l.localize(91,null)}},default:j,markdownDescription:l.localize(92,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=j}validate(j){if(typeof j=="boolean"){const Ut=j?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!j||typeof j!="object")return this.defaultValue;const{other:we,comments:qe,strings:Je}=j,lt=["on","inline","off"];let gt,Rt,Gt;return typeof we=="boolean"?gt=we?"on":"off":gt=E(we,this.defaultValue.other,lt),typeof qe=="boolean"?Rt=qe?"on":"off":Rt=E(qe,this.defaultValue.comments,lt),typeof Je=="boolean"?Gt=Je?"on":"off":Gt=E(Je,this.defaultValue.strings,lt),{other:gt,comments:Rt,strings:Gt}}}var Le;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Le||(e.RenderLineNumbersType=Le={}));class ze extends h{constructor(){super(xe.lineNumbers,"lineNumbers",{renderType:Le.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(93,null),l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"on",description:l.localize(97,null)})}validate(j){let we=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof j<"u"&&(typeof j=="function"?(we=Le.Custom,qe=j):j==="interval"?we=Le.Interval:j==="relative"?we=Le.Relative:j==="on"?we=Le.On:we=Le.Off),{renderType:we,renderFn:qe}}}function ye(Z){const j=Z.get(xe.renderValidationDecorations);return j==="editable"?Z.get(xe.readOnly):j!=="on"}class ke extends h{constructor(){const j=[],we={type:"number",description:l.localize(98,null)};super(xe.rulers,"rulers",j,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:l.localize(99,null),format:"color-hex"}}}]},default:j,description:l.localize(100,null)})}validate(j){if(Array.isArray(j)){const we=[];for(const qe of j)if(typeof qe=="number")we.push({column:i.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Je=qe;we.push({column:i.clampedInt(Je.column,0,0,1e4),color:Je.color})}return we.sort((qe,Je)=>qe.column-Je.column),we}return this.defaultValue}}class Oe extends h{constructor(){super(xe.readOnlyMessage,"readOnlyMessage",void 0)}validate(j){return!j||typeof j!="object"?this.defaultValue:j}}function B(Z,j){if(typeof Z!="string")return j;switch(Z){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class x extends h{constructor(){const j={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(xe.scrollbar,"scrollbar",j,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(101,null),l.localize(102,null),l.localize(103,null)],default:"auto",description:l.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(105,null),l.localize(106,null),l.localize(107,null)],default:"auto",description:l.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:j.verticalScrollbarSize,description:l.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:j.horizontalScrollbarSize,description:l.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:j.scrollByPage,description:l.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:j.ignoreHorizontalScrollbarInContentHeight,description:l.localize(112,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j,qe=i.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Je=i.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(we.vertical,this.defaultValue.vertical),horizontal:B(we.horizontal,this.defaultValue.horizontal),useShadows:t(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:i.clampedInt(we.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Je,verticalSliderSize:i.clampedInt(we.verticalSliderSize,Je,0,1e3),scrollByPage:t(we.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(we.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends h{constructor(){const j={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(xe.unicodeHighlighting,"unicodeHighlight",j,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:j.nonBasicASCII,description:l.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:j.invisibleCharacters,description:l.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:j.ambiguousCharacters,description:l.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:j.includeComments,description:l.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:j.includeStrings,description:l.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:j.allowedCharacters,description:l.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:j.allowedLocales,description:l.localize(119,null)}})}applyUpdate(j,we){let qe=!1;we.allowedCharacters&&j&&(k.equals(j.allowedCharacters,we.allowedCharacters)||(j={...j,allowedCharacters:we.allowedCharacters},qe=!0)),we.allowedLocales&&j&&(k.equals(j.allowedLocales,we.allowedLocales)||(j={...j,allowedLocales:we.allowedLocales},qe=!0));const Je=super.applyUpdate(j,we);return qe?new r(Je.newValue,!0):Je}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{nonBasicASCII:Be(we.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(we.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(we.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Be(we.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Be(we.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(j.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(j.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(j,we){if(typeof j!="object"||!j)return we;const qe={};for(const[Je,lt]of Object.entries(j))lt===!0&&(qe[Je]=!0);return qe}}class K extends h{constructor(){const j={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(xe.inlineSuggest,"inlineSuggest",j,{"editor.inlineSuggest.enabled":{type:"boolean",default:j.enabled,description:l.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:j.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(121,null),l.localize(122,null),l.localize(123,null)],description:l.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:j.suppressSuggestions,description:l.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:j.fontFamily,description:l.localize(126,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{enabled:t(we.enabled,this.defaultValue.enabled),mode:E(we.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:E(we.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:t(we.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(we.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:u.string(we.fontFamily,this.defaultValue.fontFamily)}}}class te extends h{constructor(){const j={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(xe.inlineEdit,"experimentalInlineEdit",j,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:j.enabled,description:l.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:j.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(128,null),l.localize(129,null),l.localize(130,null)],description:l.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:j.fontFamily,description:l.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:j.backgroundColoring,description:l.localize(133,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{enabled:t(we.enabled,this.defaultValue.enabled),showToolbar:E(we.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:u.string(we.fontFamily,this.defaultValue.fontFamily),keepOnBlur:t(we.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:t(we.backgroundColoring,this.defaultValue.backgroundColoring)}}}class ue extends h{constructor(){const j={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(xe.bracketPairColorization,"bracketPairColorization",j,{"editor.bracketPairColorization.enabled":{type:"boolean",default:j.enabled,markdownDescription:l.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:j.independentColorPoolPerBracketType,description:l.localize(135,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{enabled:t(we.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(we.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ae extends h{constructor(){const j={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(xe.guides,"guides",j,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(136,null),l.localize(137,null),l.localize(138,null)],default:j.bracketPairs,description:l.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:j.bracketPairsHorizontal,description:l.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:j.highlightActiveBracketPair,description:l.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:j.indentation,description:l.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(146,null),l.localize(147,null),l.localize(148,null)],default:j.highlightActiveIndentation,description:l.localize(149,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{bracketPairs:Be(we.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Be(we.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(we.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(we.indentation,this.defaultValue.indentation),highlightActiveIndentation:Be(we.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Be(Z,j,we){const qe=we.indexOf(Z);return qe===-1?j:we[qe]}class He extends h{constructor(){const j={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(xe.suggest,"suggest",j,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(150,null),l.localize(151,null)],default:j.insertMode,description:l.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:j.filterGraceful,description:l.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:j.localityBonus,description:l.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:j.shareSuggestSelections,markdownDescription:l.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(156,null),l.localize(157,null),l.localize(158,null),l.localize(159,null)],default:j.selectionMode,markdownDescription:l.localize(160,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:j.snippetsPreventQuickSuggestions,description:l.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:j.showIcons,description:l.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:j.showStatusBar,description:l.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:j.preview,description:l.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:j.showInlineDetails,description:l.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(197,null)}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{insertMode:E(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:E(we.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(we.showIcons,this.defaultValue.showIcons),showStatusBar:t(we.showStatusBar,this.defaultValue.showStatusBar),preview:t(we.preview,this.defaultValue.preview),previewMode:E(we.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(we.showMethods,this.defaultValue.showMethods),showFunctions:t(we.showFunctions,this.defaultValue.showFunctions),showConstructors:t(we.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(we.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(we.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(we.showFields,this.defaultValue.showFields),showVariables:t(we.showVariables,this.defaultValue.showVariables),showClasses:t(we.showClasses,this.defaultValue.showClasses),showStructs:t(we.showStructs,this.defaultValue.showStructs),showInterfaces:t(we.showInterfaces,this.defaultValue.showInterfaces),showModules:t(we.showModules,this.defaultValue.showModules),showProperties:t(we.showProperties,this.defaultValue.showProperties),showEvents:t(we.showEvents,this.defaultValue.showEvents),showOperators:t(we.showOperators,this.defaultValue.showOperators),showUnits:t(we.showUnits,this.defaultValue.showUnits),showValues:t(we.showValues,this.defaultValue.showValues),showConstants:t(we.showConstants,this.defaultValue.showConstants),showEnums:t(we.showEnums,this.defaultValue.showEnums),showEnumMembers:t(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(we.showKeywords,this.defaultValue.showKeywords),showWords:t(we.showWords,this.defaultValue.showWords),showColors:t(we.showColors,this.defaultValue.showColors),showFiles:t(we.showFiles,this.defaultValue.showFiles),showReferences:t(we.showReferences,this.defaultValue.showReferences),showFolders:t(we.showFolders,this.defaultValue.showFolders),showTypeParameters:t(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(we.showSnippets,this.defaultValue.showSnippets),showUsers:t(we.showUsers,this.defaultValue.showUsers),showIssues:t(we.showIssues,this.defaultValue.showIssues)}}}class Ye extends h{constructor(){super(xe.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(199,null),default:!0,type:"boolean"}})}validate(j){return!j||typeof j!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(j.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(j.selectSubwords,this.defaultValue.selectSubwords)}}}class tt extends h{constructor(){const j=[];super(xe.wordSegmenterLocales,"wordSegmenterLocales",j,{anyOf:[{description:l.localize(200,null),type:"string"},{description:l.localize(201,null),type:"array",items:{type:"string"}}]})}validate(j){if(typeof j=="string"&&(j=[j]),Array.isArray(j)){const we=[];for(const qe of j)if(typeof qe=="string")try{Intl.Segmenter.supportedLocalesOf(qe).length>0&&we.push(qe)}catch{}return we}return this.defaultValue}}var Ze;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Ze||(e.WrappingIndent=Ze={}));class it extends h{constructor(){super(xe.wrappingIndent,"wrappingIndent",Ze.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(202,null),l.localize(203,null),l.localize(204,null),l.localize(205,null)],description:l.localize(206,null),default:"same"}})}validate(j){switch(j){case"none":return Ze.None;case"same":return Ze.Same;case"indent":return Ze.Indent;case"deepIndent":return Ze.DeepIndent}return Ze.Same}compute(j,we,qe){return we.get(xe.accessibilitySupport)===T.AccessibilitySupport.Enabled?Ze.None:qe}}class nt extends a{constructor(){super(xe.wrappingInfo)}compute(j,we,qe){const Je=we.get(xe.layoutInfo);return{isDominatedByLongLines:j.isDominatedByLongLines,isWordWrapMinified:Je.isWordWrapMinified,isViewportWrapping:Je.isViewportWrapping,wrappingColumn:Je.wrappingColumn}}}class mt extends h{constructor(){const j={enabled:!0,showDropSelector:"afterDrop"};super(xe.dropIntoEditor,"dropIntoEditor",j,{"editor.dropIntoEditor.enabled":{type:"boolean",default:j.enabled,markdownDescription:l.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(209,null),l.localize(210,null)],default:"afterDrop"}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{enabled:t(we.enabled,this.defaultValue.enabled),showDropSelector:E(we.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ut extends h{constructor(){const j={enabled:!0,showPasteSelector:"afterPaste"};super(xe.pasteAs,"pasteAs",j,{"editor.pasteAs.enabled":{type:"boolean",default:j.enabled,markdownDescription:l.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(213,null),l.localize(214,null)],default:"afterPaste"}})}validate(j){if(!j||typeof j!="object")return this.defaultValue;const we=j;return{enabled:t(we.enabled,this.defaultValue.enabled),showPasteSelector:E(we.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?at:P.isLinux?ht:rt,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function We(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var xe;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(xe||(e.EditorOption=xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:We(new s(xe.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(215,null)})),acceptSuggestionOnEnter:We(new I(xe.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(216,null),""],markdownDescription:l.localize(217,null)})),accessibilitySupport:We(new p),accessibilityPageSize:We(new i(xe.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(218,null),tags:["accessibility"]})),ariaLabel:We(new u(xe.ariaLabel,"ariaLabel",l.localize(219,null))),ariaRequired:We(new s(xe.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:We(new s(xe.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:We(new I(xe.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(221,null),l.localize(222,null),""],description:l.localize(223,null)})),autoClosingComments:We(new I(xe.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(224,null),l.localize(225,null),""],description:l.localize(226,null)})),autoClosingDelete:We(new I(xe.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(227,null),""],description:l.localize(228,null)})),autoClosingOvertype:We(new I(xe.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(229,null),""],description:l.localize(230,null)})),autoClosingQuotes:We(new I(xe.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(231,null),l.localize(232,null),""],description:l.localize(233,null)})),autoIndent:We(new _(xe.autoIndent,"autoIndent",b.Full,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[l.localize(234,null),l.localize(235,null),l.localize(236,null),l.localize(237,null),l.localize(238,null)],description:l.localize(239,null)})),automaticLayout:We(new s(xe.automaticLayout,"automaticLayout",!1)),autoSurround:We(new I(xe.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(240,null),l.localize(241,null),l.localize(242,null),""],description:l.localize(243,null)})),bracketPairColorization:We(new ue),bracketPairGuides:We(new Ae),stickyTabStops:We(new s(xe.stickyTabStops,"stickyTabStops",!1,{description:l.localize(244,null)})),codeLens:We(new s(xe.codeLens,"codeLens",!0,{description:l.localize(245,null)})),codeLensFontFamily:We(new u(xe.codeLensFontFamily,"codeLensFontFamily","",{description:l.localize(246,null)})),codeLensFontSize:We(new i(xe.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(247,null)})),colorDecorators:We(new s(xe.colorDecorators,"colorDecorators",!0,{description:l.localize(248,null)})),colorDecoratorActivatedOn:We(new I(xe.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),colorDecoratorsLimit:We(new i(xe.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(253,null)})),columnSelection:We(new s(xe.columnSelection,"columnSelection",!1,{description:l.localize(254,null)})),comments:We(new D),contextmenu:We(new s(xe.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:We(new s(xe.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:l.localize(255,null)})),cursorBlinking:We(new _(xe.cursorBlinking,"cursorBlinking",m.Blink,"blink",["blink","smooth","phase","expand","solid"],S,{description:l.localize(256,null)})),cursorSmoothCaretAnimation:We(new I(xe.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),cursorStyle:We(new _(xe.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],H,{description:l.localize(261,null)})),cursorSurroundingLines:We(new i(xe.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(262,null)})),cursorSurroundingLinesStyle:We(new I(xe.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(263,null),l.localize(264,null)],markdownDescription:l.localize(265,null)})),cursorWidth:We(new i(xe.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(266,null)})),disableLayerHinting:We(new s(xe.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:We(new s(xe.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:We(new s(xe.domReadOnly,"domReadOnly",!1)),dragAndDrop:We(new s(xe.dragAndDrop,"dragAndDrop",!0,{description:l.localize(267,null)})),emptySelectionClipboard:We(new $),dropIntoEditor:We(new mt),stickyScroll:We(new W),experimentalWhitespaceRendering:We(new I(xe.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(268,null),l.localize(269,null),l.localize(270,null)],description:l.localize(271,null)})),extraEditorClassName:We(new u(xe.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:We(new f(xe.fastScrollSensitivity,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:l.localize(272,null)})),find:We(new N),fixedOverflowWidgets:We(new s(xe.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:We(new s(xe.folding,"folding",!0,{description:l.localize(273,null)})),foldingStrategy:We(new I(xe.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(274,null),l.localize(275,null)],description:l.localize(276,null)})),foldingHighlight:We(new s(xe.foldingHighlight,"foldingHighlight",!0,{description:l.localize(277,null)})),foldingImportsByDefault:We(new s(xe.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:l.localize(278,null)})),foldingMaximumRegions:We(new i(xe.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(279,null)})),unfoldOnClickAfterEndOfLine:We(new s(xe.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(280,null)})),fontFamily:We(new u(xe.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(281,null)})),fontInfo:We(new re),fontLigatures2:We(new F),fontSize:We(new fe),fontWeight:We(new Ee),fontVariations:We(new Y),formatOnPaste:We(new s(xe.formatOnPaste,"formatOnPaste",!1,{description:l.localize(282,null)})),formatOnType:We(new s(xe.formatOnType,"formatOnType",!1,{description:l.localize(283,null)})),glyphMargin:We(new s(xe.glyphMargin,"glyphMargin",!0,{description:l.localize(284,null)})),gotoLocation:We(new oe),hideCursorInOverviewRuler:We(new s(xe.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:l.localize(285,null)})),hover:We(new pe),inDiffEditor:We(new s(xe.inDiffEditor,"inDiffEditor",!1)),letterSpacing:We(new f(xe.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>f.clamp(Z,-5,20),{description:l.localize(286,null)})),lightbulb:We(new Q),lineDecorationsWidth:We(new _e),lineHeight:We(new de),lineNumbers:We(new ze),lineNumbersMinChars:We(new i(xe.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:We(new s(xe.linkedEditing,"linkedEditing",!1,{description:l.localize(287,null)})),links:We(new s(xe.links,"links",!0,{description:l.localize(288,null)})),matchBrackets:We(new I(xe.matchBrackets,"matchBrackets","always",["always","near","never"],{description:l.localize(289,null)})),minimap:We(new Se),mouseStyle:We(new I(xe.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:We(new f(xe.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:l.localize(290,null)})),mouseWheelZoom:We(new s(xe.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.isMacintosh?l.localize(291,null):l.localize(292,null)})),multiCursorMergeOverlapping:We(new s(xe.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:l.localize(293,null)})),multiCursorModifier:We(new _(xe.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ae,{markdownEnumDescriptions:[l.localize(294,null),l.localize(295,null)],markdownDescription:l.localize(296,null)})),multiCursorPaste:We(new I(xe.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(297,null),l.localize(298,null)],markdownDescription:l.localize(299,null)})),multiCursorLimit:We(new i(xe.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(300,null)})),occurrencesHighlight:We(new I(xe.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[l.localize(301,null),l.localize(302,null),l.localize(303,null)],markdownDescription:l.localize(304,null)})),overviewRulerBorder:We(new s(xe.overviewRulerBorder,"overviewRulerBorder",!0,{description:l.localize(305,null)})),overviewRulerLanes:We(new i(xe.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:We(new X),pasteAs:We(new ut),parameterHints:We(new J),peekWidgetDefaultFocus:We(new I(xe.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),definitionLinkOpensInPeek:We(new s(xe.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:l.localize(309,null)})),quickSuggestions:We(new ge),quickSuggestionsDelay:We(new i(xe.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(310,null)})),readOnly:We(new s(xe.readOnly,"readOnly",!1)),readOnlyMessage:We(new Oe),renameOnType:We(new s(xe.renameOnType,"renameOnType",!1,{description:l.localize(311,null),markdownDeprecationMessage:l.localize(312,null)})),renderControlCharacters:We(new s(xe.renderControlCharacters,"renderControlCharacters",!0,{description:l.localize(313,null),restricted:!0})),renderFinalNewline:We(new I(xe.renderFinalNewline,"renderFinalNewline",P.isLinux?"dimmed":"on",["off","on","dimmed"],{description:l.localize(314,null)})),renderLineHighlight:We(new I(xe.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(315,null)],description:l.localize(316,null)})),renderLineHighlightOnlyWhenFocus:We(new s(xe.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(317,null)})),renderValidationDecorations:We(new I(xe.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:We(new I(xe.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(318,null),l.localize(319,null),l.localize(320,null),""],description:l.localize(321,null)})),revealHorizontalRightPadding:We(new i(xe.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:We(new s(xe.roundedSelection,"roundedSelection",!0,{description:l.localize(322,null)})),rulers:We(new ke),scrollbar:We(new x),scrollBeyondLastColumn:We(new i(xe.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(323,null)})),scrollBeyondLastLine:We(new s(xe.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:l.localize(324,null)})),scrollPredominantAxis:We(new s(xe.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:l.localize(325,null)})),selectionClipboard:We(new s(xe.selectionClipboard,"selectionClipboard",!0,{description:l.localize(326,null),included:P.isLinux})),selectionHighlight:We(new s(xe.selectionHighlight,"selectionHighlight",!0,{description:l.localize(327,null)})),selectOnLineNumbers:We(new s(xe.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:We(new I(xe.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(328,null),l.localize(329,null),l.localize(330,null)],description:l.localize(331,null)})),showUnused:We(new s(xe.showUnused,"showUnused",!0,{description:l.localize(332,null)})),showDeprecated:We(new s(xe.showDeprecated,"showDeprecated",!0,{description:l.localize(333,null)})),inlayHints:We(new ie),snippetSuggestions:We(new I(xe.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(334,null),l.localize(335,null),l.localize(336,null),l.localize(337,null)],description:l.localize(338,null)})),smartSelect:We(new Ye),smoothScrolling:We(new s(xe.smoothScrolling,"smoothScrolling",!1,{description:l.localize(339,null)})),stopRenderingLineAfter:We(new i(xe.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:We(new He),inlineSuggest:We(new K),inlineEdit:We(new te),inlineCompletionsAccessibilityVerbose:We(new s(xe.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(340,null)})),suggestFontSize:We(new i(xe.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:We(new i(xe.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:We(new s(xe.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:l.localize(343,null)})),suggestSelection:We(new I(xe.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(344,null),l.localize(345,null),l.localize(346,null)],description:l.localize(347,null)})),tabCompletion:We(new I(xe.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(348,null),l.localize(349,null),l.localize(350,null)],description:l.localize(351,null)})),tabIndex:We(new i(xe.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:We(new q),unusualLineTerminators:We(new I(xe.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(352,null),l.localize(353,null),l.localize(354,null)],description:l.localize(355,null)})),useShadowDOM:We(new s(xe.useShadowDOM,"useShadowDOM",!0)),useTabStops:We(new s(xe.useTabStops,"useTabStops",!0,{description:l.localize(356,null)})),wordBreak:We(new I(xe.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(357,null),l.localize(358,null)],description:l.localize(359,null)})),wordSegmenterLocales:We(new tt),wordSeparators:We(new u(xe.wordSeparators,"wordSeparators",v.USUAL_WORD_SEPARATORS,{description:l.localize(360,null)})),wordWrap:We(new I(xe.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(361,null),l.localize(362,null),l.localize(363,null),l.localize(364,null)],description:l.localize(365,null)})),wordWrapBreakAfterCharacters:We(new u(xe.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:We(new u(xe.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:We(new i(xe.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(366,null)})),wordWrapOverride1:We(new I(xe.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:We(new I(xe.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:We(new V),defaultColorDecorators:We(new s(xe.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:l.localize(367,null)})),pixelRatio:We(new me),tabFocusMode:We(new s(xe.tabFocusMode,"tabFocusMode",!1,{markdownDescription:l.localize(368,null)})),layoutInfo:We(new se),wrappingInfo:We(new nt),wrappingIndent:We(new it),wrappingStrategy:We(new Te)}}),define(De[105],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,y.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,y.refineServiceDecorator)(e.IEnvironmentService)}),define(De[30],Ie([1,0,58,20,13,15,2,172,3,21,16,47]),function(he,e,y,k,P,O,A,R,v,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=c,e.isFileSystemWatcher=o,e.hasReadWriteCapability=d,e.hasFileFolderCopyCapability=t,e.hasFileCloneCapability=s,e.hasOpenReadWriteCloseCapability=n,e.hasFileReadStreamCapability=i,e.hasFileAtomicReadCapability=g,e.hasFileAtomicWriteCapability=f,e.hasFileAtomicDeleteCapability=u,e.hasReadonlyCapability=E,e.createFileSystemProviderError=w,e.ensureFileSystemProviderError=p,e.markAsFileSystemProviderError=D,e.toFileSystemProviderErrorCode=m,e.toFileOperationResult=S,e.isParent=$,e.etag=Ee,e.whenProviderRegistered=oe,e.getLargeFileConfirmationLimit=ve,e.IFileService=(0,v.createDecorator)("fileService");function c(se){return se.create===!0}var C;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(C||(e.FileType=C={}));var h;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var r;(function(se){se[se.UPDATED=2]="UPDATED",se[se.ADDED=4]="ADDED",se[se.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(se){const Te=se;return!!Te&&typeof Te.onDidChange=="function"}var a;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function d(se){return!!(se.capabilities&a.FileReadWrite)}function t(se){return!!(se.capabilities&a.FileFolderCopy)}function s(se){return!!(se.capabilities&a.FileClone)}function n(se){return!!(se.capabilities&a.FileOpenReadWriteClose)}function i(se){return!!(se.capabilities&a.FileReadStream)}function g(se){return d(se)?!!(se.capabilities&a.FileAtomicRead):!1}function f(se){return d(se)?!!(se.capabilities&a.FileAtomicWrite):!1}function u(se){return!!(se.capabilities&a.FileAtomicDelete)}function E(se){return!!(se.capabilities&a.Readonly)}var I;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(I||(e.FileSystemProviderErrorCode=I={}));class _ extends Error{static create(Te,Me){const Q=new _(Te.toString(),Me);return D(Q,Me),Q}constructor(Te,Me){super(Te),this.code=Me}}e.FileSystemProviderError=_;function w(se,Te){return _.create(se,Te)}function p(se){return se||w((0,R.localize)(0,null),I.Unknown)}function D(se,Te){return se.name=Te?`${Te} (FileSystemError)`:"FileSystemError",se}function m(se){if(!se)return I.Unknown;if(se instanceof _)return se.code;const Te=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!Te)return I.Unknown;switch(Te[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}function S(se){if(se instanceof N)return se.fileOperationResult;switch(m(se)){case I.FileNotFound:return re.FILE_NOT_FOUND;case I.FileIsADirectory:return re.FILE_IS_DIRECTORY;case I.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case I.FileWriteLocked:return re.FILE_WRITE_LOCKED;case I.NoPermissions:return re.FILE_PERMISSION_DENIED;case I.FileExists:return re.FILE_MOVE_CONFLICT;case I.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var M;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class L{constructor(Te,Me,Q){this.resource=Te,this.operation=Me,this.target=Q}isOperation(Te){return this.operation===Te}}e.FileOperationEvent=L;var H;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(H||(e.FileChangeType=H={}));class V{static{this.MIXED_CORRELATION=null}constructor(Te,Me){this.ignorePathCasing=Me,this.correlationId=void 0,this.added=new b.Lazy(()=>{const Q=y.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Q.fill(this.rawAdded.map(W=>[W,!0])),Q}),this.updated=new b.Lazy(()=>{const Q=y.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Q.fill(this.rawUpdated.map(W=>[W,!0])),Q}),this.deleted=new b.Lazy(()=>{const Q=y.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Q.fill(this.rawDeleted.map(W=>[W,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of Te){switch(Q.type){case H.ADDED:this.rawAdded.push(Q.resource);break;case H.UPDATED:this.rawUpdated.push(Q.resource);break;case H.DELETED:this.rawDeleted.push(Q.resource);break}this.correlationId!==V.MIXED_CORRELATION&&(typeof Q.cId=="number"?this.correlationId===void 0?this.correlationId=Q.cId:this.correlationId!==Q.cId&&(this.correlationId=V.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=V.MIXED_CORRELATION))}}contains(Te,...Me){return this.doContains(Te,{includeChildren:!1},...Me)}affects(Te,...Me){return this.doContains(Te,{includeChildren:!0},...Me)}doContains(Te,Me,...Q){if(!Te)return!1;const W=Q.length>0;return!!((!W||Q.includes(H.ADDED))&&(this.added.value.get(Te)||Me.includeChildren&&this.added.value.findSuperstr(Te))||(!W||Q.includes(H.UPDATED))&&(this.updated.value.get(Te)||Me.includeChildren&&this.updated.value.findSuperstr(Te))||(!W||Q.includes(H.DELETED))&&(this.deleted.value.findSubstr(Te)||Me.includeChildren&&this.deleted.value.findSuperstr(Te)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Te){return this.correlationId===Te}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=V;function $(se,Te,Me){return!se||!Te||se===Te||Te.length>se.length?!1:(Te.charAt(Te.length-1)!==k.sep&&(Te+=k.sep),Me?(0,P.startsWithIgnoreCase)(se,Te):se.indexOf(Te)===0)}class N extends Error{constructor(Te,Me,Q){super(Te),this.fileOperationResult=Me,this.options=Q}}e.FileOperationError=N;class F extends N{constructor(Te,Me,Q,W){super(Te,Me,W),this.fileOperationResult=Me,this.size=Q}}e.TooLargeFileOperationError=F;class Y extends N{constructor(Te,Me,Q){super(Te,re.FILE_NOT_MODIFIED_SINCE,Q),this.stat=Me}}e.NotModifiedSinceFileOperationError=Y;var re;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var fe;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.ETAG_DISABLED="";function Ee(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}async function oe(se,Te){if(!Te.hasProvider(A.URI.from({scheme:se.scheme})))return new Promise(Me=>{const Q=Te.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===se.scheme&&W.added&&(Q.dispose(),Me())})})}class pe{static{this.KB=1024}static{this.MB=pe.KB*pe.KB}static{this.GB=pe.MB*pe.KB}static{this.TB=pe.GB*pe.KB}static formatSize(Te){return(0,O.isNumber)(Te)||(Te=0),Te<pe.KB?(0,R.localize)(1,null,Te.toFixed(0)):Te<pe.MB?(0,R.localize)(2,null,(Te/pe.KB).toFixed(2)):Te<pe.GB?(0,R.localize)(3,null,(Te/pe.MB).toFixed(2)):Te<pe.TB?(0,R.localize)(4,null,(Te/pe.GB).toFixed(2)):(0,R.localize)(5,null,(Te/pe.TB).toFixed(2))}}e.ByteSize=pe;function ve(se){const Te=typeof se=="string"||se?.scheme===T.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===T.Schemas.file?1024*pe.MB:Te?10*pe.MB:l.isWeb?50*pe.MB:1024*pe.MB}}),define(De[75],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...P){this._entries=new Map;for(const[O,A]of P)this.set(O,A)}set(P,O){const A=this._entries.get(P);return this._entries.set(P,O),A}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=y}),define(De[210],Ie([1,0,11,14,6,74,207,3,75,211]),function(he,e,y,k,P,O,A,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class b extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class c{constructor(o=new v.ServiceCollection,a=!1,d,t=T){this._services=o,this._strict=a,this._parent=d,this._enableTracing=t,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=t?d?._globalGraph??new A.Graph(s=>s):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,P.dispose)(this._children),this._children.clear();for(const o of this._servicesToMaybeDispose)(0,P.isDisposable)(o)&&o.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(o,a){this._throwIfDisposed();const d=this,t=new class extends c{dispose(){d._children.delete(t),super.dispose()}}(o,this._strict,this,this._enableTracing);return this._children.add(t),a?.add(t),t}invokeFunction(o,...a){this._throwIfDisposed();const d=h.traceInvocation(this._enableTracing,o);let t=!1;try{return o({get:n=>{if(t)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(n,d);if(!i)throw new Error(`[invokeFunction] unknown service '${n}'`);return i}},...a)}finally{t=!0,d.stop()}}createInstance(o,...a){this._throwIfDisposed();let d,t;return o instanceof O.SyncDescriptor?(d=h.traceCreation(this._enableTracing,o.ctor),t=this._createInstance(o.ctor,o.staticArguments.concat(a),d)):(d=h.traceCreation(this._enableTracing,o),t=this._createInstance(o,a,d)),d.stop(),t}_createInstance(o,a=[],d){const t=R._util.getServiceDependencies(o).sort((i,g)=>i.index-g.index),s=[];for(const i of t){const g=this._getOrCreateServiceInstance(i.id,d);g||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),s.push(g)}const n=t.length>0?t[0].index:a.length;if(a.length!==n){console.trace(`[createInstance] First service dependency of ${o.name} at position ${n+1} conflicts with ${a.length} static arguments`);const i=n-a.length;i>0?a=a.concat(new Array(i)):a=a.slice(0,n)}return Reflect.construct(o,a.concat(s))}_setCreatedServiceInstance(o,a){if(this._services.get(o)instanceof O.SyncDescriptor)this._services.set(o,a);else if(this._parent)this._parent._setCreatedServiceInstance(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const a=this._services.get(o);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):a}_getOrCreateServiceInstance(o,a){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const d=this._getServiceInstanceOrDescriptor(o);return d instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,d,a.branch(o,!0)):(a.branch(o,!1),d)}_safeCreateAndCacheServiceInstance(o,a,d){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,a,d)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,a,d){const t=new A.Graph(i=>i.id.toString());let s=0;const n=[{id:o,desc:a,_trace:d}];for(;n.length;){const i=n.pop();if(t.lookupOrInsertNode(i),s++>1e3)throw new b(t);for(const g of R._util.getServiceDependencies(i.desc.ctor)){const f=this._getServiceInstanceOrDescriptor(g.id);if(f||this._throwIfStrict(`[createInstance] ${o} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(g.id)),f instanceof O.SyncDescriptor){const u={id:g.id,desc:f,_trace:i._trace.branch(g.id,!0)};t.insertEdge(i,u),n.push(u)}}}for(;;){const i=t.roots();if(i.length===0){if(!t.isEmpty())throw new b(t);break}for(const{data:g}of i){if(this._getServiceInstanceOrDescriptor(g.id)instanceof O.SyncDescriptor){const u=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setCreatedServiceInstance(g.id,u)}t.removeNode(g)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,a,d=[],t,s){if(this._services.get(o)instanceof O.SyncDescriptor)return this._createServiceInstance(o,a,d,t,s,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,a,d,t,s);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(o,a,d=[],t,s,n){if(t){const i=new c(void 0,this._strict,this,this._enableTracing);i._globalGraphImplicitDependency=String(o);const g=new Map,f=new y.GlobalIdleValue(()=>{const u=i._createInstance(a,d,s);for(const[E,I]of g){const _=u[E];if(typeof _=="function")for(const w of I)w.disposable=_.apply(u,w.listener)}return g.clear(),n.add(u),u});return new Proxy(Object.create(null),{get(u,E){if(!f.isInitialized&&typeof E=="string"&&(E.startsWith("onDid")||E.startsWith("onWill"))){let w=g.get(E);return w||(w=new l.LinkedList,g.set(E,w)),(D,m,S)=>{if(f.isInitialized)return f.value[E](D,m,S);{const M={listener:[D,m,S],disposable:void 0},L=w.push(M);return(0,P.toDisposable)(()=>{L(),M.disposable?.dispose()})}}}if(E in u)return u[E];const I=f.value;let _=I[E];return typeof _!="function"||(_=_.bind(I),u[E]=_),_},set(u,E,I){return f.value[E]=I,!0},getPrototypeOf(u){return a.prototype}})}else{const i=this._createInstance(a,d,s);return n.add(i),i}}_throwIfStrict(o,a){if(a&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=c;var C;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(C||(C={}));class h{static{this.all=new Set}static{this._None=new class extends h{constructor(){super(C.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,a){return o?new h(C.Invocation,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h._None}static traceCreation(o,a){return o?new h(C.Creation,a.name):h._None}static{this._totals=0}constructor(o,a){this.type=o,this.name=a,this._start=Date.now(),this._dep=[]}branch(o,a){const d=new h(C.Branch,o.toString());return this._dep.push([o,a,d]),d}stop(){const o=Date.now()-this._start;h._totals+=o;let a=!1;function d(s,n){const i=[],g=new Array(s+1).join("	");for(const[f,u,E]of n._dep)if(u&&E){a=!0,i.push(`${g}CREATES -> ${f}`);const I=d(s+1,E);I&&i.push(I)}else i.push(`${g}uses -> ${f}`);return i.join(`
`)}const t=[`${this.type===C.Creation?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(o>2||a)&&h.all.add(t.join(`
`))}}e.Trace=h}),define(De[12],Ie([1,0,173,48,4,76,6,29,21,24,15,2,32,3]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=r,e.log=a,e.getLogLevel=_,e.LogLevelToString=w,e.LogLevelToLocalizedString=p,e.parseLogLevel=D,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function h(){return new Date().toISOString()}function r(m){return(0,T.isNumber)(m)}var o;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(o||(e.LogLevel=o={})),e.DEFAULT_LOG_LEVEL=o.Info;function a(m,S,M){switch(S){case o.Trace:m.trace(M);break;case o.Debug:m.debug(M);break;case o.Info:m.info(M);break;case o.Warning:m.warn(M);break;case o.Error:m.error(M);break;case o.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function d(m,S=!1){let M="";for(let L=0;L<m.length;L++){let H=m[L];if(H instanceof Error&&(H=(0,k.toErrorMessage)(H,S)),typeof H=="object")try{H=JSON.stringify(H)}catch{}M+=(L>0?" ":"")+H}return M}class t extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(S){this.level!==S&&(this.level=S,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(S){return this.level!==o.Off&&this.level<=S}}e.AbstractLogger=t;class s extends t{constructor(S){super(),this.logAlways=S}checkLogLevel(S){return this.logAlways||super.checkLogLevel(S)}trace(S,...M){this.checkLogLevel(o.Trace)&&this.log(o.Trace,d([S,...M],!0))}debug(S,...M){this.checkLogLevel(o.Debug)&&this.log(o.Debug,d([S,...M]))}info(S,...M){this.checkLogLevel(o.Info)&&this.log(o.Info,d([S,...M]))}warn(S,...M){this.checkLogLevel(o.Warning)&&this.log(o.Warning,d([S,...M]))}error(S,...M){if(this.checkLogLevel(o.Error))if(S instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=S.stack,this.log(o.Error,d(L))}else this.log(o.Error,d([S,...M]))}flush(){}}e.AbstractMessageLogger=s;class n extends t{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S),this.useColors=!v.isWindows}trace(S,...M){this.checkLogLevel(o.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...M):console.log(`[main ${h()}]`,S,...M))}debug(S,...M){this.checkLogLevel(o.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...M):console.log(`[main ${h()}]`,S,...M))}info(S,...M){this.checkLogLevel(o.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...M):console.log(`[main ${h()}]`,S,...M))}warn(S,...M){this.checkLogLevel(o.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,S,...M):console.warn(`[main ${h()}]`,S,...M))}error(S,...M){this.checkLogLevel(o.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,S,...M):console.error(`[main ${h()}]`,S,...M))}flush(){}}e.ConsoleMainLogger=n;class i extends t{constructor(S=e.DEFAULT_LOG_LEVEL,M=!0){super(),this.useColors=M,this.setLevel(S)}trace(S,...M){this.checkLogLevel(o.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",S,...M):console.log(S,...M))}debug(S,...M){this.checkLogLevel(o.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",S,...M):console.log(S,...M))}info(S,...M){this.checkLogLevel(o.Info)&&(this.useColors?console.log("%c INFO","color: #33f",S,...M):console.log(S,...M))}warn(S,...M){this.checkLogLevel(o.Warning)&&(this.useColors?console.log("%c WARN","color: #993",S,...M):console.log(S,...M))}error(S,...M){this.checkLogLevel(o.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",S,...M):console.error(S,...M))}flush(){}}e.ConsoleLogger=i;class g extends t{constructor(S,M=e.DEFAULT_LOG_LEVEL){super(),this.adapter=S,this.setLevel(M)}trace(S,...M){this.checkLogLevel(o.Trace)&&this.adapter.log(o.Trace,[this.extractMessage(S),...M])}debug(S,...M){this.checkLogLevel(o.Debug)&&this.adapter.log(o.Debug,[this.extractMessage(S),...M])}info(S,...M){this.checkLogLevel(o.Info)&&this.adapter.log(o.Info,[this.extractMessage(S),...M])}warn(S,...M){this.checkLogLevel(o.Warning)&&this.adapter.log(o.Warning,[this.extractMessage(S),...M])}error(S,...M){this.checkLogLevel(o.Error)&&this.adapter.log(o.Error,[this.extractMessage(S),...M])}extractMessage(S){return typeof S=="string"?S:(0,k.toErrorMessage)(S,this.checkLogLevel(o.Trace))}flush(){}}e.AdapterLogger=g;class f extends t{constructor(S){super(),this.loggers=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const M of this.loggers)M.setLevel(S);super.setLevel(S)}trace(S,...M){for(const L of this.loggers)L.trace(S,...M)}debug(S,...M){for(const L of this.loggers)L.debug(S,...M)}info(S,...M){for(const L of this.loggers)L.info(S,...M)}warn(S,...M){for(const L of this.loggers)L.warn(S,...M)}error(S,...M){for(const L of this.loggers)L.error(S,...M)}flush(){for(const S of this.loggers)S.flush()}dispose(){for(const S of this.loggers)S.dispose();super.dispose()}}e.MultiplexLogger=f;class u extends A.Disposable{constructor(S,M,L){if(super(),this.logLevel=S,this.logsHome=M,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new P.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,L)for(const H of L)this._loggers.set(H.resource,{logger:void 0,info:H})}getLoggerEntry(S){return(0,T.isString)(S)?[...this._loggers.values()].find(M=>M.info.id===S):this._loggers.get(S)}getLogger(S){return this.getLoggerEntry(S)?.logger}createLogger(S,M){const L=this.toResource(S),H=(0,T.isString)(S)?S:M?.id??(0,O.hash)(L.toString()).toString(16);let V=this._loggers.get(L)?.logger;const $=M?.logLevel==="always"?o.Trace:M?.logLevel;V||(V=this.doCreateLogger(L,$??this.getLogLevel(L)??this.logLevel,{...M,id:H}));const N={logger:V,info:{resource:L,id:H,logLevel:$,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(N.info),this._loggers.set(L,N),V}toResource(S){return(0,T.isString)(S)?(0,l.joinPath)(this.logsHome,`${S}.log`):S}setLogLevel(S,M){if(b.URI.isUri(S)){const L=S,H=M,V=this._loggers.get(L);V&&H!==V.info.logLevel&&(V.info.logLevel=H===this.logLevel?void 0:H,V.logger?.setLevel(H),this._loggers.set(V.info.resource,V),this._onDidChangeLogLevel.fire([L,H]))}else{this.logLevel=S;for(const[L,H]of this._loggers.entries())this._loggers.get(L)?.info.logLevel===void 0&&H.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(S,M){const L=this.getLoggerEntry(S);L&&M!==!L.info.hidden&&(L.info.hidden=!M,this._loggers.set(L.info.resource,L),this._onDidChangeVisibility.fire([L.info.resource,M]))}getLogLevel(S){let M;return S&&(M=this._loggers.get(S)?.info.logLevel),M??this.logLevel}registerLogger(S){const M=this._loggers.get(S.resource);M?M.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this._loggers.set(S.resource,{info:S,logger:void 0}),this._onDidChangeLoggers.fire({added:[S],removed:[]}))}deregisterLogger(S){const M=this._loggers.get(S);M&&(M.logger&&M.logger.dispose(),this._loggers.delete(S),this._onDidChangeLoggers.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const S of this._loggers.values())yield S.info}getRegisteredLogger(S){return this._loggers.get(S)?.info}dispose(){this._loggers.forEach(S=>S.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=u;class E{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(S){}getLevel(){return o.Info}trace(S,...M){}debug(S,...M){}info(S,...M){}warn(S,...M){}error(S,...M){}critical(S,...M){}dispose(){}flush(){}}e.NullLogger=E;class I extends E{}e.NullLogService=I;function _(m){if(m.verbose)return o.Trace;if(typeof m.logLevel=="string"){const S=D(m.logLevel.toLowerCase());if(S!==void 0)return S}return e.DEFAULT_LOG_LEVEL}function w(m){switch(m){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function p(m){switch(m){case o.Trace:return{original:"Trace",value:y.localize(0,null)};case o.Debug:return{original:"Debug",value:y.localize(1,null)};case o.Info:return{original:"Info",value:y.localize(2,null)};case o.Warning:return{original:"Warning",value:y.localize(3,null)};case o.Error:return{original:"Error",value:y.localize(4,null)};case o.Off:return{original:"Off",value:y.localize(5,null)}}}function D(m){switch(m){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.CONTEXT_LOG_LEVEL=new c.RawContextKey("logLevel",w(o.Info))}),define(De[212],Ie([1,0,6,12]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class P extends y.Disposable{constructor(A,R=[]){super(),this.logger=new k.MultiplexLogger([A,...R]),this._register(A.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}flush(){this.logger.flush()}}e.LogService=P}),define(De[106],Ie([1,0,35,174,3]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(v){function l(h,r){return r-h}v.compare=l;const T=Object.create(null);T[v.Error]=(0,k.localize)(0,null),T[v.Warning]=(0,k.localize)(1,null),T[v.Info]=(0,k.localize)(2,null);function b(h){return T[h]||""}v.toString=b;function c(h){switch(h){case y.default.Error:return v.Error;case y.default.Warning:return v.Warning;case y.default.Info:return v.Info;case y.default.Ignore:return v.Hint}}v.fromSeverity=c;function C(h){switch(h){case v.Error:return y.default.Error;case v.Warning:return y.default.Warning;case v.Info:return y.default.Info;case v.Hint:return y.default.Ignore}}v.toSeverity=C}(A||(e.MarkerSeverity=A={}));var R;(function(v){const l="";function T(c){return b(c,!0)}v.makeKey=T;function b(c,C){const h=[l];return c.source?h.push(c.source.replace("\xA6","\\\xA6")):h.push(l),c.code?typeof c.code=="string"?h.push(c.code.replace("\xA6","\\\xA6")):h.push(c.code.value.replace("\xA6","\\\xA6")):h.push(l),c.severity!==void 0&&c.severity!==null?h.push(A.toString(c.severity)):h.push(l),c.message&&C?h.push(c.message.replace("\xA6","\\\xA6")):h.push(l),c.startLineNumber!==void 0&&c.startLineNumber!==null?h.push(c.startLineNumber.toString()):h.push(l),c.startColumn!==void 0&&c.startColumn!==null?h.push(c.startColumn.toString()):h.push(l),c.endLineNumber!==void 0&&c.endLineNumber!==null?h.push(c.endLineNumber.toString()):h.push(l),c.endColumn!==void 0&&c.endColumn!==null?h.push(c.endColumn.toString()):h.push(l),h.push(l),h.join("\xA6")}v.makeKeyOptionalMessage=b})(R||(e.IMarkerData=R={})),e.IMarkerService=(0,P.createDecorator)("markerService")}),define(De[213],Ie([1,0,4,35,3]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=R,e.Severity=k.default,e.INotificationService=(0,P.createDecorator)("notificationService");var O;(function(b){b[b.DEFAULT=0]="DEFAULT",b[b.SILENT=1]="SILENT",b[b.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(b){b[b.WORKSPACE=0]="WORKSPACE",b[b.PROFILE=1]="PROFILE",b[b.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function R(b){if(b){const c=b;return typeof c.id=="string"&&typeof c.label=="string"}return!1}var v;(function(b){b[b.OFF=0]="OFF",b[b.ERROR=1]="ERROR"})(v||(e.NotificationsFilter=v={}));class l{constructor(){this.progress=new T,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(c){}updateMessage(c){}updateActions(c){}close(){}}e.NoOpNotification=l;class T{infinite(){}done(){}total(c){}worked(c){}}e.NoOpProgress=T}),define(De[107],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,y.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var je=this&&this.__decorate||function(he,e,y,k){var P=arguments.length,O=P<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,y):k,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(he,e,y,k);else for(var R=he.length-1;R>=0;R--)(A=he[R])&&(O=(P<3?A(O):P>3?A(e,y,O):A(e,y))||O);return P>3&&O&&Object.defineProperty(e,y,O),O},$e=this&&this.__param||function(he,e){return function(y,k){e(y,k,he)}};define(De[77],Ie([1,0,11,22,6,3]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,O.createDecorator)("progressService");var A;(function(b){b[b.Explorer=1]="Explorer",b[b.Scm=3]="Scm",b[b.Extensions=5]="Extensions",b[b.Window=10]="Window",b[b.Notification=15]="Notification",b[b.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(c){this.callback=c}report(c){this._value=c,this.callback(this._value)}}e.Progress=R;class v{get value(){return this._value}constructor(c){this.callback=c}report(c){this._asyncQueue?this._asyncQueue.push(c):this._asyncQueue=[c],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const c=this._asyncQueue.shift();this._value=c,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const c=this._drainListener;this._drainListener=void 0,c?.()}}drain(){return this._processingAsyncQueue?new Promise(c=>{const C=this._drainListener;this._drainListener=()=>{C?.(),c()}}):Promise.resolve()}}e.AsyncProgress=v;let l=class extends P.Disposable{constructor(c,C){super(),this.deferred=new y.DeferredPromise,C.withProgress(c,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,P.toDisposable)(()=>this.deferred.complete()))}report(c){this.reporter?this.reporter.report(c):this.lastStep=c}};e.UnmanagedProgress=l,e.UnmanagedProgress=l=je([$e(1,e.IProgressService)],l);class T extends P.Disposable{constructor(c){super(),this.progressIndicator=c,this.currentOperationId=0,this.currentOperationDisposables=this._register(new P.DisposableStore)}start(c){this.stop();const C=++this.currentOperationId,h=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{C===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},c),this.currentOperationDisposables.add((0,P.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,P.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,P.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:C,token:h.token,stop:()=>this.doStop(C),isCurrent:()=>this.currentOperationId===C}}stop(){this.doStop(this.currentOperationId)}doStop(c){this.currentOperationId===c&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,O.createDecorator)("editorProgressService")}),define(De[31],Ie([1,0,61,15]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(A,R){y.ok(k.isString(A)),y.ok(k.isObject(R)),y.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new P}),define(De[78],Ie([1,0,4,31]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class O{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,l){this.schemasById[P(v)]=l,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new O;k.Registry.add(e.Extensions.JSONContribution,A)}),define(De[54],Ie([1,0,18,4,15,167,42,78,31]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=r,e.keyFromOverrideIdentifiers=o,e.getDefaultValue=a,e.validateProperty=t,e.getScopes=s;var l;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=v.Registry.as(R.Extensions.JSONContribution);class c{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,g=!0){this.registerConfigurations([i],g)}registerConfigurations(i,g=!0){const f=new Set;this.doRegisterConfigurations(i,g,f),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f})}deregisterConfigurations(i){const g=new Set;this.doDeregisterConfigurations(i,g),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g})}updateConfigurations({add:i,remove:g}){const f=new Set;this.doDeregisterConfigurations(g,f),this.doRegisterConfigurations(i,!1,f),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f})}registerDefaultConfigurations(i){const g=new Set;this.doRegisterDefaultConfigurations(i,g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,g){const f=[];for(const{overrides:u,source:E}of i)for(const I in u)if(g.add(I),e.OVERRIDE_PROPERTY_REGEX.test(I)){const _=this.configurationDefaultsOverrides.get(I),w=_?.valuesSources??new Map;if(E)for(const S of Object.keys(u[I]))w.set(S,E);const p={..._?.value||{},...u[I]};this.configurationDefaultsOverrides.set(I,{source:E,value:p,valuesSources:w});const D=(0,A.getLanguageTagSettingPlainKey)(I),m={type:"object",default:p,description:O.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:P.isString(E)?void 0:E,defaultValueSource:E};f.push(...r(I)),this.configurationProperties[I]=m,this.defaultLanguageConfigurationOverridesNode.properties[I]=m}else{this.configurationDefaultsOverrides.set(I,{value:u[I],source:E});const _=this.configurationProperties[I];_&&(this.updatePropertyDefaultValue(I,_),this.updateSchema(I,_))}this.doRegisterOverrideIdentifiers(f)}deregisterDefaultConfigurations(i){const g=new Set;this.doDeregisterDefaultConfigurations(i,g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,g){for(const{overrides:f,source:u}of i)for(const E in f){const I=this.configurationDefaultsOverrides.get(E),_=P.isString(u)?u:u?.id,w=P.isString(I?.source)?I?.source:I?.source?.id;if(_===w)if(g.add(E),this.configurationDefaultsOverrides.delete(E),e.OVERRIDE_PROPERTY_REGEX.test(E))delete this.configurationProperties[E],delete this.defaultLanguageConfigurationOverridesNode.properties[E];else{const p=this.configurationProperties[E];p&&(this.updatePropertyDefaultValue(E,p),this.updateSchema(E,p))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let g=!1;const f=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,f),g=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,f),g=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,f),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const g of i)this.overrideIdentifiers.add(g);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,g,f){i.forEach(u=>{this.validateAndRegisterProperties(u,g,u.extensionInfo,u.restrictedProperties,void 0,f),this.configurationContributors.push(u),this.registerJSONConfiguration(u)})}doDeregisterConfigurations(i,g){const f=u=>{if(u.properties)for(const E in u.properties){g.add(E);const I=this.configurationProperties[E];I?.policy?.name&&this.policyConfigurations.delete(I.policy.name),delete this.configurationProperties[E],this.removeFromSchema(E,u.properties[E])}u.allOf?.forEach(E=>f(E))};for(const u of i){f(u);const E=this.configurationContributors.indexOf(u);E!==-1&&this.configurationContributors.splice(E,1)}}validateAndRegisterProperties(i,g=!0,f,u,E=T.WINDOW,I){E=P.isUndefinedOrNull(i.scope)?E:i.scope;const _=i.properties;if(_)for(const p in _){const D=_[p];if(g&&t(p,D)){delete _[p];continue}if(D.source=f,D.defaultDefaultValue=_[p].default,this.updatePropertyDefaultValue(p,D),e.OVERRIDE_PROPERTY_REGEX.test(p)?D.scope=void 0:(D.scope=P.isUndefinedOrNull(D.scope)?E:D.scope,D.restricted=P.isUndefinedOrNull(D.restricted)?!!u?.includes(p):D.restricted),_[p].hasOwnProperty("included")&&!_[p].included){this.excludedConfigurationProperties[p]=_[p],delete _[p];continue}else this.configurationProperties[p]=_[p],_[p].policy?.name&&this.policyConfigurations.set(_[p].policy.name,p);!_[p].deprecationMessage&&_[p].markdownDeprecationMessage&&(_[p].deprecationMessage=_[p].markdownDeprecationMessage),I.add(p)}const w=i.allOf;if(w)for(const p of w)this.validateAndRegisterProperties(p,g,f,u,E,I)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const g=f=>{const u=f.properties;if(u)for(const I in u)this.updateSchema(I,u[I]);f.allOf?.forEach(g)};g(i)}updateSchema(i,g){switch(e.allSettings.properties[i]=g,g.scope){case T.APPLICATION:e.applicationSettings.properties[i]=g;break;case T.MACHINE:e.machineSettings.properties[i]=g;break;case T.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[i]=g;break;case T.WINDOW:e.windowSettings.properties[i]=g;break;case T.RESOURCE:e.resourceSettings.properties[i]=g;break;case T.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[i]=g,this.resourceLanguageSettingsSchema.properties[i]=g;break}}removeFromSchema(i,g){switch(delete e.allSettings.properties[i],g.scope){case T.APPLICATION:delete e.applicationSettings.properties[i];break;case T.MACHINE:delete e.machineSettings.properties[i];break;case T.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[i];break;case T.WINDOW:delete e.windowSettings.properties[i];break;case T.RESOURCE:case T.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const g=`[${i}]`,f={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(g,f),e.allSettings.properties[g]=f,e.applicationSettings.properties[g]=f,e.machineSettings.properties[g]=f,e.machineOverridableSettings.properties[g]=f,e.windowSettings.properties[g]=f,e.resourceSettings.properties[g]=f}}registerOverridePropertyPatternKey(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,g){const f=this.configurationDefaultsOverrides.get(i);let u=f?.value,E=f?.source;P.isUndefined(u)&&(u=g.defaultDefaultValue,E=void 0),P.isUndefined(u)&&(u=a(g.type)),g.default=u,g.defaultValueSource=E}}const C="\\[([^\\]]+)\\]",h=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function r(n){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(n)){let g=h.exec(n);for(;g?.length;){const f=g[1].trim();f&&i.push(f),g=h.exec(n)}}return(0,y.distinct)(i)}function o(n){return n.reduce((i,g)=>`${i}[${g}]`,"")}function a(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new c;v.Registry.add(e.Extensions.Configuration,d);function t(n,i){return n.trim()?e.OVERRIDE_PROPERTY_REGEX.test(n)?O.localize(7,null,n):d.getConfigurationProperties()[n]!==void 0?O.localize(8,null,n):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,n,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}function s(){const n=[],i=d.getConfigurationProperties();for(const g of Object.keys(i))n.push([g,i[g].scope]);return n.push(["launch",T.RESOURCE]),n.push(["task",T.RESOURCE]),n}}),define(De[214],Ie([1,0,18,4,134,6,29,26,15,2,42,54,30,31]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=s;function h(f){return Object.isFrozen(f)?f:R.deepFreeze(f)}class r{static createEmptyModel(u){return new r({},[],[],void 0,u)}constructor(u,E,I,_,w){this._contents=u,this._keys=E,this._overrides=I,this.raw=_,this.logService=w,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const u=this.raw.map(E=>{if(E instanceof r)return E;const I=new o("",this.logService);return I.parseRaw(E),I.configurationModel});this._rawConfiguration=u.reduce((E,I)=>I===E?I:E.merge(I),u[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(u){return u?(0,T.getConfigurationValue)(this.contents,u):this.contents}inspect(u,E){const I=this;return{get value(){return h(I.rawConfiguration.getValue(u))},get override(){return E?h(I.rawConfiguration.getOverrideValue(u,E)):void 0},get merged(){return h(E?I.rawConfiguration.override(E).getValue(u):I.rawConfiguration.getValue(u))},get overrides(){const _=[];for(const{contents:w,identifiers:p,keys:D}of I.rawConfiguration.overrides){const m=new r(w,D,[],void 0,I.logService).getValue(u);m!==void 0&&_.push({identifiers:p,value:m})}return _.length?h(_):void 0}}}getOverrideValue(u,E){const I=this.getContentsForOverrideIdentifer(E);return I?u?(0,T.getConfigurationValue)(I,u):I:void 0}getKeysForOverrideIdentifier(u){const E=[];for(const I of this.overrides)I.identifiers.includes(u)&&E.push(...I.keys);return y.distinct(E)}getAllOverrideIdentifiers(){const u=[];for(const E of this.overrides)u.push(...E.identifiers);return y.distinct(u)}override(u){let E=this.overrideConfigurations.get(u);return E||(E=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,E)),E}merge(...u){const E=R.deepClone(this.contents),I=R.deepClone(this.overrides),_=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const p of u)if(w.push(...p.raw?.length?p.raw:[p]),!p.isEmpty()){this.mergeContents(E,p.contents);for(const D of p.overrides){const[m]=I.filter(S=>y.equals(S.identifiers,D.identifiers));m?(this.mergeContents(m.contents,D.contents),m.keys.push(...D.keys),m.keys=y.distinct(m.keys)):I.push(R.deepClone(D))}for(const D of p.keys)_.indexOf(D)===-1&&_.push(D)}return new r(E,_,I,w.every(p=>p instanceof r)?void 0:w,this.logService)}createOverrideConfigurationModel(u){const E=this.getContentsForOverrideIdentifer(u);if(!E||typeof E!="object"||!Object.keys(E).length)return this;const I={};for(const _ of y.distinct([...Object.keys(this.contents),...Object.keys(E)])){let w=this.contents[_];const p=E[_];p&&(typeof w=="object"&&typeof p=="object"?(w=R.deepClone(w),this.mergeContents(w,p)):w=p),I[_]=w}return new r(I,this.keys,this.overrides,void 0,this.logService)}mergeContents(u,E){for(const I of Object.keys(E)){if(I in u&&v.isObject(u[I])&&v.isObject(E[I])){this.mergeContents(u[I],E[I]);continue}u[I]=R.deepClone(E[I])}}getContentsForOverrideIdentifer(u){let E=null,I=null;const _=w=>{w&&(I?this.mergeContents(I,w):I=R.deepClone(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===u?E=w.contents:w.identifiers.includes(u)&&_(w.contents);return _(E),I}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,E){this.updateValue(u,E,!0)}setValue(u,E){this.updateValue(u,E,!1)}removeValue(u){const E=this.keys.indexOf(u);E!==-1&&(this.keys.splice(E,1),(0,T.removeFromValueTree)(this.contents,u),b.OVERRIDE_PROPERTY_REGEX.test(u)&&this.overrides.splice(this.overrides.findIndex(I=>y.equals(I.identifiers,(0,b.overrideIdentifiersFromKey)(u))),1))}updateValue(u,E,I){(0,T.addToValueTree)(this.contents,u,E,_=>this.logService.error(_)),I=I||this.keys.indexOf(u)===-1,I&&this.keys.push(u),b.OVERRIDE_PROPERTY_REGEX.test(u)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(u),keys:Object.keys(this.contents[u]),contents:(0,T.toValuesTree)(this.contents[u],_=>this.logService.error(_))})}}e.ConfigurationModel=r;class o{constructor(u,E){this._name=u,this.logService=E,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||r.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,E){if(!v.isUndefinedOrNull(u)){const I=this.doParseContent(u);this.parseRaw(I,E)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,E){this._raw=u;const{contents:I,keys:_,overrides:w,restricted:p,hasExcludedProperties:D}=this.doParseRaw(u,E);this._configurationModel=new r(I,_,w,D?[u]:void 0,this.logService),this._restrictedConfigurations=p||[]}doParseContent(u){let E={},I=null,_=[];const w=[],p=[];function D(S){Array.isArray(_)?_.push(S):I!==null&&(_[I]=S)}const m={onObjectBegin:()=>{const S={};D(S),w.push(_),_=S,I=null},onObjectProperty:S=>{I=S},onObjectEnd:()=>{_=w.pop()},onArrayBegin:()=>{const S=[];D(S),w.push(_),_=S,I=null},onArrayEnd:()=>{_=w.pop()},onLiteralValue:D,onError:(S,M,L)=>{p.push({error:S,offset:M,length:L})}};if(u)try{P.visit(u,m),E=_[0]||{}}catch(S){this.logService.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return E}doParseRaw(u,E){const I=C.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),_=this.filter(u,I,!0,E);u=_.raw;const w=(0,T.toValuesTree)(u,m=>this.logService.error(`Conflict in settings file ${this._name}: ${m}`)),p=Object.keys(u),D=this.toOverrides(u,m=>this.logService.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:w,keys:p,overrides:D,restricted:_.restricted,hasExcludedProperties:_.hasExcludedProperties}}filter(u,E,I,_){let w=!1;if(!_?.scopes&&!_?.skipRestricted&&!_?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:w};const p={},D=[];for(const m in u)if(b.OVERRIDE_PROPERTY_REGEX.test(m)&&I){const S=this.filter(u[m],E,!1,_);p[m]=S.raw,w=w||S.hasExcludedProperties,D.push(...S.restricted)}else{const S=E[m],M=S?typeof S.scope<"u"?S.scope:b.ConfigurationScope.WINDOW:void 0;S?.restricted&&D.push(m),!_.exclude?.includes(m)&&(_.include?.includes(m)||(M===void 0||_.scopes===void 0||_.scopes.includes(M))&&!(_.skipRestricted&&S?.restricted))?p[m]=u[m]:w=!0}return{raw:p,restricted:D,hasExcludedProperties:w}}toOverrides(u,E){const I=[];for(const _ of Object.keys(u))if(b.OVERRIDE_PROPERTY_REGEX.test(_)){const w={};for(const p in u[_])w[p]=u[_][p];I.push({identifiers:(0,b.overrideIdentifiersFromKey)(_),keys:Object.keys(w),contents:(0,T.toValuesTree)(w,E)})}return I}}e.ConfigurationModelParser=o;class a extends O.Disposable{constructor(u,E,I,_,w){super(),this.userSettingsResource=u,this.parseOptions=E,this.fileService=_,this.logService=w,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new o(this.userSettingsResource.toString(),w),this._register(this.fileService.watch(I.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.any(k.Event.filter(this.fileService.onDidFilesChange,p=>p.contains(this.userSettingsResource)),k.Event.filter(this.fileService.onDidRunOperation,p=>(p.isOperation(c.FileOperation.CREATE)||p.isOperation(c.FileOperation.COPY)||p.isOperation(c.FileOperation.DELETE)||p.isOperation(c.FileOperation.WRITE))&&I.isEqual(p.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return r.createEmptyModel(this.logService)}}reparse(u){return u&&(this.parseOptions=u),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=a;class d{constructor(u,E,I,_,w,p,D,m,S,M,L,H,V){this.key=u,this.overrides=E,this._value=I,this.overrideIdentifiers=_,this.defaultConfiguration=w,this.policyConfiguration=p,this.applicationConfiguration=D,this.userConfiguration=m,this.localUserConfiguration=S,this.remoteUserConfiguration=M,this.workspaceConfiguration=L,this.folderConfigurationModel=H,this.memoryConfigurationModel=V}get value(){return h(this._value)}toInspectValue(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class t{constructor(u,E,I,_,w,p,D,m,S,M){this._defaultConfiguration=u,this._policyConfiguration=E,this._applicationConfiguration=I,this._localUserConfiguration=_,this._remoteUserConfiguration=w,this._workspaceConfiguration=p,this._folderConfigurations=D,this._memoryConfiguration=m,this._memoryConfigurationByResource=S,this.logService=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(u,E,I){return this.getConsolidatedConfigurationModel(u,E,I).getValue(u)}updateValue(u,E,I={}){let _;I.resource?(_=this._memoryConfigurationByResource.get(I.resource),_||(_=r.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(I.resource,_))):_=this._memoryConfiguration,E===void 0?_.removeValue(u):_.setValue(u,E),I.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,E,I){const _=this.getConsolidatedConfigurationModel(u,E,I),w=this.getFolderConfigurationModelForResource(E.resource,I),p=E.resource?this._memoryConfigurationByResource.get(E.resource)||this._memoryConfiguration:this._memoryConfiguration,D=new Set;for(const m of _.overrides)for(const S of m.identifiers)_.getOverrideValue(u,S)!==void 0&&D.add(S);return new d(u,E,_.getValue(u),D.size?[...D]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,I?this._workspaceConfiguration:void 0,w||void 0,p)}keys(u){const E=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:E?E.keys.slice(0):[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(u){this._policyConfiguration=u}updateApplicationConfiguration(u){this._applicationConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,E){this._folderConfigurations.set(u,E),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,E){const I=[];if(!E){const{added:_,updated:w,removed:p}=i(this._defaultConfiguration,u);E=[..._,...w,...p]}for(const _ of E)for(const w of(0,b.overrideIdentifiersFromKey)(_)){const p=this._defaultConfiguration.getKeysForOverrideIdentifier(w),D=u.getKeysForOverrideIdentifier(w),m=[...D.filter(S=>p.indexOf(S)===-1),...p.filter(S=>D.indexOf(S)===-1),...p.filter(S=>!R.equals(this._defaultConfiguration.override(w).getValue(S),u.override(w).getValue(S)))];I.push([w,m])}return this.updateDefaultConfiguration(u),{keys:E,overrides:I}}compareAndUpdatePolicyConfiguration(u){const{added:E,updated:I,removed:_}=i(this._policyConfiguration,u),w=[...E,...I,..._];return w.length&&this.updatePolicyConfiguration(u),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:E,updated:I,removed:_,overrides:w}=i(this.applicationConfiguration,u),p=[...E,...I,..._];return p.length&&this.updateApplicationConfiguration(u),{keys:p,overrides:w}}compareAndUpdateLocalUserConfiguration(u){const{added:E,updated:I,removed:_,overrides:w}=i(this.localUserConfiguration,u),p=[...E,...I,..._];return p.length&&this.updateLocalUserConfiguration(u),{keys:p,overrides:w}}compareAndUpdateRemoteUserConfiguration(u){const{added:E,updated:I,removed:_,overrides:w}=i(this.remoteUserConfiguration,u),p=[...E,...I,..._];return p.length&&this.updateRemoteUserConfiguration(u),{keys:p,overrides:w}}compareAndUpdateWorkspaceConfiguration(u){const{added:E,updated:I,removed:_,overrides:w}=i(this.workspaceConfiguration,u),p=[...E,...I,..._];return p.length&&this.updateWorkspaceConfiguration(u),{keys:p,overrides:w}}compareAndUpdateFolderConfiguration(u,E){const I=this.folderConfigurations.get(u),{added:_,updated:w,removed:p,overrides:D}=i(I,E),m=[..._,...w,...p];return(m.length||!I)&&this.updateFolderConfiguration(u,E),{keys:m,overrides:D}}compareAndDeleteFolderConfiguration(u){const E=this.folderConfigurations.get(u);if(!E)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:I,updated:_,removed:w,overrides:p}=i(E,void 0);return{keys:[...I,..._,...w],overrides:p}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(u,E,I){let _=this.getConsolidatedConfigurationModelForResource(E,I);return E.overrideIdentifier&&(_=_.override(E.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(u)!==void 0&&(_=_.merge(this._policyConfiguration)),_}getConsolidatedConfigurationModelForResource({resource:u},E){let I=this.getWorkspaceConsolidatedConfiguration();if(E&&u){const _=E.getFolder(u);_&&(I=this.getFolderConsolidatedConfiguration(_.uri)||I);const w=this._memoryConfigurationByResource.get(u);w&&(I=I.merge(w))}return I}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let E=this._foldersConsolidatedConfigurations.get(u);if(!E){const I=this.getWorkspaceConsolidatedConfiguration(),_=this._folderConfigurations.get(u);_?(E=I.merge(_),this._foldersConsolidatedConfigurations.set(u,E)):E=I}return E}getFolderConfigurationModelForResource(u,E){if(E&&u){const I=E.getFolder(u);if(I)return this._folderConfigurations.get(I.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,E)=>{const{contents:I,overrides:_,keys:w}=this._folderConfigurations.get(E);return u.push([E,{contents:I,overrides:_,keys:w}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.keys.forEach(E=>u.add(E)),this.userConfiguration.keys.forEach(E=>u.add(E)),this._workspaceConfiguration.keys.forEach(E=>u.add(E)),this._folderConfigurations.forEach(E=>E.keys.forEach(I=>u.add(I))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(E=>u.add(E)),this.userConfiguration.getAllOverrideIdentifiers().forEach(E=>u.add(E)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(E=>u.add(E)),this._folderConfigurations.forEach(E=>E.getAllOverrideIdentifiers().forEach(I=>u.add(I))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const E=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(I=>E.add(I)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(I=>E.add(I)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(I=>E.add(I)),this._folderConfigurations.forEach(I=>I.getKeysForOverrideIdentifier(u).forEach(_=>E.add(_))),[...E.values()]}static parse(u,E){const I=this.parseConfigurationModel(u.defaults,E),_=this.parseConfigurationModel(u.policy,E),w=this.parseConfigurationModel(u.application,E),p=this.parseConfigurationModel(u.user,E),D=this.parseConfigurationModel(u.workspace,E),m=u.folders.reduce((S,M)=>(S.set(l.URI.revive(M[0]),this.parseConfigurationModel(M[1],E)),S),new A.ResourceMap);return new t(I,_,w,p,r.createEmptyModel(E),D,m,r.createEmptyModel(E),new A.ResourceMap,E)}static parseConfigurationModel(u,E){return new r(u.contents,u.keys,u.overrides,void 0,E)}}e.Configuration=t;function s(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const u=new Set,E=new Map;for(const _ of f)_.keys.forEach(w=>u.add(w)),_.overrides.forEach(([w,p])=>{const D=(0,A.getOrSet)(E,w,new Set);p.forEach(m=>D.add(m))});const I=[];return E.forEach((_,w)=>I.push([w,[..._.values()]])),{keys:[...u.values()],overrides:I}}class n{constructor(u,E,I,_,w){this.change=u,this.previous=E,this.currentConfiguraiton=I,this.currentWorkspace=_,this.logService=w,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const p of u.keys)this.affectedKeys.add(p);for(const[,p]of u.overrides)for(const D of p)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const p of this.affectedKeys)this._affectsConfigStr+=p+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=t.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(u,E){const I=this._marker+u,_=this._affectsConfigStr.indexOf(I);if(_<0)return!1;const w=_+I.length;if(w>=this._affectsConfigStr.length)return!1;const p=this._affectsConfigStr.charCodeAt(w);if(p!==this._markerCode1&&p!==this._markerCode2)return!1;if(E){const D=this.previousConfiguration?this.previousConfiguration.getValue(u,E,this.previous?.workspace):void 0,m=this.currentConfiguraiton.getValue(u,E,this.currentWorkspace);return!R.equals(D,m)}return!0}}e.ConfigurationChangeEvent=n;function i(f,u){const{added:E,removed:I,updated:_}=g(u?.rawConfiguration,f?.rawConfiguration),w=[],p=f?.getAllOverrideIdentifiers()||[],D=u?.getAllOverrideIdentifiers()||[];if(u){const m=D.filter(S=>!p.includes(S));for(const S of m)w.push([S,u.getKeysForOverrideIdentifier(S)])}if(f){const m=p.filter(S=>!D.includes(S));for(const S of m)w.push([S,f.getKeysForOverrideIdentifier(S)])}if(u&&f){for(const m of p)if(D.includes(m)){const S=g({contents:f.getOverrideValue(void 0,m)||{},keys:f.getKeysForOverrideIdentifier(m)},{contents:u.getOverrideValue(void 0,m)||{},keys:u.getKeysForOverrideIdentifier(m)});w.push([m,[...S.added,...S.removed,...S.updated]])}}return{added:E,removed:I,updated:_,overrides:w}}function g(f,u){const E=f?u?f.keys.filter(w=>u.keys.indexOf(w)===-1):[...f.keys]:[],I=u?f?u.keys.filter(w=>f.keys.indexOf(w)===-1):[...u.keys]:[],_=[];if(f&&u){for(const w of u.keys)if(f.keys.indexOf(w)!==-1){const p=(0,T.getConfigurationValue)(u.contents,w),D=(0,T.getConfigurationValue)(f.contents,w);R.equals(p,D)||_.push(w)}}return{added:E,removed:I,updated:_}}}),define(De[108],Ie([1,0,14,3]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=l,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var P;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(b){this.id=b,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class A{constructor(b,c){this.host=b,this.port=c,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=A;var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class v extends y.ErrorNoTelemetry{static isNotAvailable(b){return b instanceof v&&b._code===R.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof v&&b._code===R.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof v&&b._code===R.NoResolverFound}static isInvalidAuthority(b){return b instanceof v&&b._code===R.InvalidAuthority}static isHandled(b){return b instanceof v&&b.isHandled}constructor(b,c=R.Unknown,C){super(b),this._message=b,this._code=c,this._detail=C,this.isHandled=c===R.NotAvailable&&C===!0,Object.setPrototypeOf(this,v.prototype)}}e.RemoteAuthorityResolverError=v;function l(T){const b=T.indexOf("+");return b===-1?T:T.substring(0,b)}}),define(De[62],Ie([1,0,16]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=k,e.getRemoteName=P,e.parseAuthorityWithPort=O,e.parseAuthorityWithOptionalPort=A;function k(v){return v.scheme===y.Schemas.vscodeRemote?v.authority:void 0}function P(v){if(!v)return;const l=v.indexOf("+");return l<0?v:v.substr(0,l)}function O(v){const{host:l,port:T}=R(v);if(typeof T>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:T}}function A(v,l){let{host:T,port:b}=R(v);return typeof b>"u"&&(b=l),{host:T,port:b}}function R(v){const l=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const T=v.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const b=v.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:v,port:void 0}}}),define(De[19],Ie([1,0,13,3,62]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=O,e.isApplicationScopedExtension=b,e.isLanguagePackExtension=c,e.isAuthenticationProviderExtension=C,e.isResolverExtension=h,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var R;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.LINUX_PPC64LE="linux-ppc64le",r.LINUX_RISCV64="linux-riscv64",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class v{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,a){if(typeof o>"u"||o===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof o=="string"||typeof a=="string"){const d=typeof o=="string"?o:o.value,t=typeof a=="string"?a:a.value;return y.equalsIgnoreCase(d,t)}return o._lower===a._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.ExtensionIdentifier=v;class l{get size(){return this._set.size}constructor(o){if(this._set=new Set,o)for(const a of o)this.add(a)}add(o){this._set.add(v.toKey(o))}delete(o){return this._set.delete(v.toKey(o))}has(o){return this._set.has(v.toKey(o))}}e.ExtensionIdentifierSet=l;class T{constructor(){this._map=new Map}clear(){this._map.clear()}delete(o){this._map.delete(v.toKey(o))}get(o){return this._map.get(v.toKey(o))}has(o){return this._map.has(v.toKey(o))}set(o,a){this._map.set(v.toKey(o),a)}values(){return this._map.values()}forEach(o){this._map.forEach(o)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=T;function b(r){return c(r)}function c(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function C(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function h(r,o){if(o){const a=`onResolveRemoteAuthority:${(0,P.getRemoteName)(o)}`;return!!r.activationEvents?.includes(a)}return!1}e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[109],Ie([1,0,21,170,19,3]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=R,e.toTargetPlatform=v,e.getTargetPlatform=l,e.isNotWebExtensionInWebTargetPlatform=T,e.isTargetPlatformCompatible=b,e.isIExtensionIdentifier=c,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var A;(function(n){n.COMMAND="command",n.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function R(n){switch(n){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case P.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function v(n){switch(n){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.LINUX_PPC64LE:return P.TargetPlatform.LINUX_PPC64LE;case P.TargetPlatform.LINUX_RISCV64:return P.TargetPlatform.LINUX_RISCV64;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function l(n,i){switch(n){case y.Platform.Windows:return i==="x64"?P.TargetPlatform.WIN32_X64:i==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case y.Platform.Linux:return i==="x64"?P.TargetPlatform.LINUX_X64:i==="arm64"?P.TargetPlatform.LINUX_ARM64:i==="arm"?P.TargetPlatform.LINUX_ARMHF:i==="ppc64le"?P.TargetPlatform.LINUX_PPC64LE:i==="riscv64"?P.TargetPlatform.LINUX_RISCV64:P.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?P.TargetPlatform.ALPINE_X64:i==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case y.Platform.Mac:return i==="x64"?P.TargetPlatform.DARWIN_X64:i==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case y.Platform.Web:return P.TargetPlatform.WEB}}function T(n,i){return i===P.TargetPlatform.WEB&&!n.includes(P.TargetPlatform.WEB)}function b(n,i,g){return T(i,g)?!1:n===P.TargetPlatform.UNDEFINED||n===P.TargetPlatform.UNIVERSAL?!0:n===P.TargetPlatform.UNKNOWN?!1:n===g}function c(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var C;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var h;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var r;(function(n){n.Install="install",n.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var o;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var a;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed",n.DownloadFailedWriting="DownloadFailedWriting"})(a||(e.ExtensionGalleryErrorCode=a={}));class d extends Error{constructor(i,g){super(i),this.code=g,this.name=g}}e.ExtensionGalleryError=d;var t;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.DownloadFailedWriting="DownloadFailedWriting",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.ScanningExtension="ScanningExtension",n.ReadUninstalled="ReadUninstalled",n.UnsetUninstalled="UnsetUninstalled",n.Delete="Delete",n.Rename="Rename",n.IntializeDefaultProfile="IntializeDefaultProfile",n.AddToProfile="AddToProfile",n.InstalledExtensionNotFound="InstalledExtensionNotFound",n.PostInstall="PostInstall",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(t||(e.ExtensionManagementErrorCode=t={}));class s extends Error{constructor(i,g){super(i),this.code=g,this.name=g}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,k.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,k.localize2)(1,"Preferences")}),define(De[110],Ie([1,0,14,19]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class P{constructor(){this._generators=new Map,this._cache=new WeakMap}register(A,R){this._generators.set(A,R)}readActivationEvents(A){return this._cache.has(A)||this._cache.set(A,this._readActivationEvents(A)),this._cache.get(A)}createActivationEventsMap(A){const R=Object.create(null);for(const v of A){const l=this.readActivationEvents(v);l.length>0&&(R[k.ExtensionIdentifier.toKey(v.identifier)]=l)}return R}_readActivationEvents(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const R=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let v=0;v<R.length;v++)R[v]==="onUri"&&(R[v]=`onUri:${k.ExtensionIdentifier.toKey(A.identifier)}`);if(!A.contributes)return R;for(const v in A.contributes){const l=this._generators.get(v);if(!l)continue;const T=A.contributes[v],b=Array.isArray(T)?T:[T];try{l(b,R)}catch(c){(0,y.onUnexpectedError)(c)}}return R}}e.ImplicitActivationEventsImpl=P,e.ImplicitActivationEvents=new P}),define(De[215],Ie([1,0,23,14,6,175,54,3,12,31]),function(he,e,y,k,P,O,A,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=c,e.hasNoContent=C,e.asText=h,e.asTextOrError=r,e.asJson=o,e.updateProxyConfigurationsScope=a,e.IRequestService=(0,R.createDecorator)("requestService");class T{constructor(n){this.original=n}toJSON(){if(!this.headers){const n=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?n[i]="*****":n[i]=this.original[i];this.headers=n}return this.headers}}class b extends P.Disposable{constructor(n){super(),this.counter=0,this.logger=n.createLogger("network",{name:(0,O.localize)(0,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async logAndRequest(n,i,g){const f=`${n} #${++this.counter}: ${i.url}`;this.logger.trace(`${f} - begin`,i.type,new T(i.headers??{}));try{const u=await g();return this.logger.trace(`${f} - end`,i.type,u.res.statusCode,u.res.headers),u}catch(u){throw this.logger.error(`${f} - error`,i.type,(0,k.getErrorMessage)(u)),u}}}e.AbstractRequestService=b;function c(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function C(s){return s.res.statusCode===204}async function h(s){return C(s)?null:(await(0,y.streamToBuffer)(s.stream)).toString()}async function r(s){if(!c(s))throw new Error("Server returned "+s.res.statusCode);return h(s)}async function o(s){if(!c(s))throw new Error("Server returned "+s.res.statusCode);if(C(s))return null;const i=(await(0,y.streamToBuffer)(s.stream)).toString();try{return JSON.parse(i)}catch(g){throw g.message+=`:
`+i,g}}function a(s){t(s)}let d;function t(s){const n=l.Registry.as(A.Extensions.Configuration),i=d;d={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},n.updateConfigurations({add:[d],remove:i?[i]:[]})}t(A.ConfigurationScope.APPLICATION)}),define(De[216],Ie([1,0,21,79,36]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=A,e.verifyMicrosoftInternalDomain=R;function O(v){if(y.platform===y.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function A(v,l,T,b,c,C,h,r,o,a){const d=Object.create(null);d["common.machineId"]=C,d["common.sqmId"]=h,d["common.devDeviceId"]=r,d.sessionID=(0,P.generateUuid)()+Date.now(),d.commitHash=b,d.version=c,d["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,y.PlatformToString)(y.platform),d["common.nodePlatform"]=k.platform,d["common.nodeArch"]=T,d["common.product"]=a||"desktop",o&&(d["common.msftInternal"]=o);let t=0;const s=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>t++,enumerable:!0}}),y.isLinuxSnap&&(d["common.snap"]="true");const n=O(l);return n&&(d["common.platformDetail"]=n),d}function R(v){const l=k.env.USERDNSDOMAIN;if(!l)return!1;const T=l.toLowerCase();return v.some(b=>T===b)}}),define(De[111],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,y.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,y.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(k||(e.TelemetryLevel=k={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(De[63],Ie([1,0,26,15,62,216,111]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=T,e.isLoggingOnly=b,e.getTelemetryLevel=c,e.validateTelemetryData=C,e.cleanRemoteAuthority=r,e.isInternalTelemetry=a,e.getPiiPathsFromEnvironment=d,e.cleanData=n;class R{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class v{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=v,e.NullTelemetryService=new v;class l{async publicLog(g,f,u){}async publicLogError(g,f,u){}}e.NullEndpointTelemetryService=l,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function T(i,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!i.enableTelemetry)}function b(i,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function c(i){const g=i.getValue(A.TELEMETRY_SETTING_ID),f=i.getValue(A.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return A.TelemetryLevel.NONE;switch(g??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function C(i){const g={},f={},u={};o(i,u);for(let E in u){E=E.length>150?E.substr(E.length-149):E;const I=u[E];typeof I=="number"?f[E]=I:typeof I=="boolean"?f[E]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${I.length}`),g[E]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(g[E]=I)}return{properties:g,measurements:f}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(i){if(!i)return"none";const g=(0,P.getRemoteName)(i);return h.has(g)?g:"other"}function o(i,g,f=0,u){if(i)for(const E of Object.getOwnPropertyNames(i)){const I=i[E],_=u?u+E:E;Array.isArray(I)?g[_]=(0,y.safeStringify)(I):I instanceof Date?g[_]=I.toISOString():(0,k.isObject)(I)?f<2?o(I,g,f+1,_+"."):g[_]=(0,y.safeStringify)(I):g[_]=I}}function a(i,g){const f=i.msftInternalDomains||[],u=g.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(f)||u}function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function t(i,g){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let f=i;const u=[];for(const w of g)for(;;){const p=w.exec(i);if(!p)break;u.push([p.index,w.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let _=0;for(f="";;){const w=I.exec(i);if(!w)break;const p=u.some(([D,m])=>w.index<m&&D<I.lastIndex);!E.test(w[0])&&!p&&(f+=i.substring(_,w.index)+"<REDACTED: user-file-path>",_=I.lastIndex)}return _<i.length&&(f+=i.substr(_)),f}function s(i){if(!i)return i;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of g)if(f.regex.test(i))return`<REDACTED: ${f.label}>`;return i}function n(i,g){return(0,y.cloneAndChange)(i,f=>{if(f instanceof R||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let u=f.replaceAll("%20"," ");u=t(u,g);for(const E of g)u=u.replace(E,"");return u=s(u),u}})}}),define(De[217],Ie([1,0,13,109,19,21,2,14,79,63]),function(he,e,y,k,P,O,A,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=T,e.getIdAndVersion=h,e.getExtensionId=r,e.adoptToGalleryExtensionId=o,e.getGalleryExtensionId=a,e.groupByExtension=d,e.getLocalExtensionTelemetryData=t,e.getGalleryExtensionTelemetryData=s,e.getExtensionDependencies=n,e.computeTargetPlatform=g;function T(f,u){return f.uuid&&u.uuid?f.uuid===u.uuid:f.id===u.id?!0:(0,y.compareIgnoreCase)(f.id,u.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(u){const E=u.manifest?u.manifest.version:u.version,I=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new c(u.identifier,E,I)}static parse(u){const E=b.exec(u);return E&&E[1]&&E[2]?new c({id:E[1]},E[2],E[4]||void 0):null}constructor(u,E,I=P.TargetPlatform.UNDEFINED){this.identifier=u,this.version=E,this.targetPlatform=I,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof c?T(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.ExtensionKey=c;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(f){const u=C.exec(f);return u&&u[1]?[o(u[1]),u[2]]:[o(f),void 0]}function r(f,u){return`${f}.${u}`}function o(f){return f.toLowerCase()}function a(f,u){return o(r(f??P.UNDEFINED_PUBLISHER,u))}function d(f,u){const E=[],I=_=>{for(const w of E)if(w.some(p=>T(u(p),u(_))))return w;return null};for(const _ of f){const w=I(_);w?w.push(_):E.push([_])}return E}function t(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function s(f){return{id:new l.TelemetryTrustedValue(f.identifier.id),name:new l.TelemetryTrustedValue(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function n(f,u){const E=[],I=u.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const _=I.shift();if(_&&E.every(w=>!T(w.identifier,{id:_}))){const w=f.filter(p=>T(p.identifier,{id:_}));w.length===1&&(E.push(w[0]),I.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}async function i(f,u){if(!O.isLinux)return!1;let E;try{E=(await f.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{E=(await f.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(_){u.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(_))}}return!!E&&(E.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(f,u){const E=await i(f,u),I=(0,k.getTargetPlatform)(E?"alpine":O.platform,v.arch);return u.debug("ComputeTargetPlatform:",I),I}}),define(De[218],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=y,e.serializeEnvironmentDescriptionMap=k,e.deserializeEnvironmentVariableCollection=P,e.deserializeEnvironmentDescriptionMap=O,e.serializeEnvironmentVariableCollections=A,e.deserializeEnvironmentVariableCollections=R;function y(v){return[...v.entries()]}function k(v){return v?[...v.entries()]:[]}function P(v){return new Map(v)}function O(v){return new Map(v??[])}function A(v){return Array.from(v.entries()).map(l=>[l[0],y(l[1].map),k(l[1].descriptionMap)])}function R(v){return new Map(v.map(l=>[l[0],{map:P(l[1]),descriptionMap:O(l[2])}]))}}),define(De[219],Ie([1,0,3,32,31]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new k.RawContextKey("terminalTabFocusMode",!1,!0);var O;(function(n){n.AutomationProfile="terminal.integrated.automationProfile.",n.DefaultProfile="terminal.integrated.defaultProfile.",n.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(n){n.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",n.AutomationProfileLinux="terminal.integrated.automationProfile.linux",n.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",n.AutomationProfileWindows="terminal.integrated.automationProfile.windows",n.ProfilesWindows="terminal.integrated.profiles.windows",n.ProfilesMacOs="terminal.integrated.profiles.osx",n.ProfilesLinux="terminal.integrated.profiles.linux",n.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",n.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",n.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",n.UseWslProfiles="terminal.integrated.useWslProfiles",n.TabsDefaultColor="terminal.integrated.tabs.defaultColor",n.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",n.TabsEnabled="terminal.integrated.tabs.enabled",n.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",n.TabsHideCondition="terminal.integrated.tabs.hideCondition",n.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",n.TabsShowActions="terminal.integrated.tabs.showActions",n.TabsLocation="terminal.integrated.tabs.location",n.TabsFocusMode="terminal.integrated.tabs.focusMode",n.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",n.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",n.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",n.CopyOnSelection="terminal.integrated.copyOnSelection",n.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",n.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",n.FontFamily="terminal.integrated.fontFamily",n.FontSize="terminal.integrated.fontSize",n.LetterSpacing="terminal.integrated.letterSpacing",n.LineHeight="terminal.integrated.lineHeight",n.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",n.TabStopWidth="terminal.integrated.tabStopWidth",n.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",n.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",n.BellDuration="terminal.integrated.bellDuration",n.FontWeight="terminal.integrated.fontWeight",n.FontWeightBold="terminal.integrated.fontWeightBold",n.CursorBlinking="terminal.integrated.cursorBlinking",n.CursorStyle="terminal.integrated.cursorStyle",n.CursorStyleInactive="terminal.integrated.cursorStyleInactive",n.CursorWidth="terminal.integrated.cursorWidth",n.Scrollback="terminal.integrated.scrollback",n.DetectLocale="terminal.integrated.detectLocale",n.DefaultLocation="terminal.integrated.defaultLocation",n.GpuAcceleration="terminal.integrated.gpuAcceleration",n.TerminalTitleSeparator="terminal.integrated.tabs.separator",n.TerminalTitle="terminal.integrated.tabs.title",n.TerminalDescription="terminal.integrated.tabs.description",n.RightClickBehavior="terminal.integrated.rightClickBehavior",n.MiddleClickBehavior="terminal.integrated.middleClickBehavior",n.Cwd="terminal.integrated.cwd",n.ConfirmOnExit="terminal.integrated.confirmOnExit",n.ConfirmOnKill="terminal.integrated.confirmOnKill",n.EnableBell="terminal.integrated.enableBell",n.EnableVisualBell="terminal.integrated.enableVisualBell",n.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",n.AllowChords="terminal.integrated.allowChords",n.AllowMnemonics="terminal.integrated.allowMnemonics",n.TabFocusMode="terminal.integrated.tabFocusMode",n.EnvMacOs="terminal.integrated.env.osx",n.EnvLinux="terminal.integrated.env.linux",n.EnvWindows="terminal.integrated.env.windows",n.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",n.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",n.ShowExitAlert="terminal.integrated.showExitAlert",n.SplitCwd="terminal.integrated.splitCwd",n.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",n.WordSeparators="terminal.integrated.wordSeparators",n.EnableFileLinks="terminal.integrated.enableFileLinks",n.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",n.UnicodeVersion="terminal.integrated.unicodeVersion",n.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",n.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",n.HideOnStartup="terminal.integrated.hideOnStartup",n.CustomGlyphs="terminal.integrated.customGlyphs",n.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",n.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",n.InheritEnv="terminal.integrated.inheritEnv",n.ShowLinkHover="terminal.integrated.showLinkHover",n.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",n.AutoReplies="terminal.integrated.autoReplies",n.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",n.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",n.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",n.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",n.EnableImages="terminal.integrated.enableImages",n.SmoothScrolling="terminal.integrated.smoothScrolling",n.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",n.FocusAfterRun="terminal.integrated.focusAfterRun",n.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",n.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",n.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var R;(function(n){n.PowerShell="pwsh",n.Bash="bash",n.Fish="fish",n.Sh="sh",n.Csh="csh",n.Ksh="ksh",n.Zsh="zsh",n.Python="python"})(R||(e.PosixShellType=R={}));var v;(function(n){n.CommandPrompt="cmd",n.PowerShell="pwsh",n.Wsl="wsl",n.GitBash="gitbash",n.Python="python"})(v||(e.WindowsShellType=v={}));var l;(function(n){n[n.Api=0]="Api",n[n.Process=1]="Process",n[n.Sequence=2]="Sequence",n[n.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var T;(function(n){n.LocalPty="localPty",n.PtyHost="ptyHost",n.PtyHostWindow="ptyHostWindow",n.Logger="logger",n.Heartbeat="heartbeat"})(T||(e.TerminalIpcChannels=T={}));var b;(function(n){n.Cwd="cwd",n.InitialCwd="initialCwd",n.FixedDimensions="fixedDimensions",n.Title="title",n.ShellType="shellType",n.HasChildProcesses="hasChildProcesses",n.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",n.OverrideDimensions="overrideDimensions",n.FailedShellIntegrationActivation="failedShellIntegrationActivation",n.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.IPtyService=(0,y.createDecorator)("ptyService");var c;(function(n){n[n.BeatInterval=5e3]="BeatInterval",n[n.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",n[n.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",n[n.SecondWaitMultiplier=1]="SecondWaitMultiplier",n[n.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(c||(e.HeartbeatConstants=c={}));var C;(function(n){n[n.Panel=1]="Panel",n[n.Editor=2]="Editor"})(C||(e.TerminalLocation=C={}));var h;(function(n){n.TerminalView="view",n.Editor="editor"})(h||(e.TerminalLocationString=h={}));var r;(function(n){n[n.GraceTime=6e4]="GraceTime",n[n.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var o;(function(n){n[n.HighWatermarkChars=1e5]="HighWatermarkChars",n[n.LowWatermarkChars=5e3]="LowWatermarkChars",n[n.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var a;(function(n){n.GitBash="Git Bash",n.Pwsh="PowerShell"})(a||(e.ProfileSource=a={}));var d;(function(n){n[n.Off=0]="Off",n[n.FinalTerm=1]="FinalTerm",n[n.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var t;(function(n){n[n.Unknown=0]="Unknown",n[n.Shutdown=1]="Shutdown",n[n.Process=2]="Process",n[n.User=3]="User",n[n.Extension=4]="Extension"})(t||(e.TerminalExitReason=t={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(i){const g=this._sanitizeRemoteAuthority(i.remoteAuthority);if(this._backends.has(g))throw new Error(`A terminal backend with remote authority '${g}' was already registered.`);this._backends.set(g,i)}getTerminalBackend(i){return this._backends.get(this._sanitizeRemoteAuthority(i))}_sanitizeRemoteAuthority(i){return i?.toLowerCase()??""}}P.Registry.add(e.TerminalExtensions.Backend,new s),e.ILocalPtyService=(0,y.createDecorator)("localPtyService"),e.ITerminalLogService=(0,y.createDecorator)("terminalLogService")}),define(De[220],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class y{constructor(P){this._callback=P,this._terminalBufferMap=new Map}dispose(){for(const P of this._terminalBufferMap.values())P.dispose()}startBuffering(P,O,A=5){const R=O(v=>{const l=typeof v=="string"?v:v.data;let T=this._terminalBufferMap.get(P);if(T){T.data.push(l);return}const b=setTimeout(()=>this.flushBuffer(P),A);T={data:[l],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(P),R.dispose()}},this._terminalBufferMap.set(P,T)});return R}stopBuffering(P){this._terminalBufferMap.get(P)?.dispose()}flushBuffer(P){const O=this._terminalBufferMap.get(P);O&&(this._terminalBufferMap.delete(P),this._callback(P,O.data.join("")))}}e.TerminalDataBufferer=y}),define(De[221],Ie([1,0,11,97,323,34,4,15,2,176,78,31]),function(he,e,y,k,P,O,A,R,v,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=o,e.getIconRegistry=a,e.Extensions={IconContribution:"base.contributions.icons"};var c;(function(n){function i(g,f){let u=g.defaults;for(;O.ThemeIcon.isThemeIcon(u);){const E=r.getIcon(u.id);if(!E)return;u=E.defaults}return u}n.getDefinition=i})(c||(e.IconContribution=c={}));var C;(function(n){function i(f){return{weight:f.weight,style:f.style,src:f.src.map(u=>({format:u.format,location:u.location.toString()}))}}n.toJSONObject=i;function g(f){const u=E=>(0,R.isString)(E)?E:void 0;if(f&&Array.isArray(f.src)&&f.src.every(E=>(0,R.isString)(E.format)&&(0,R.isString)(E.location)))return{weight:u(f.weight),style:u(f.style),src:f.src.map(E=>({format:E.format,location:v.URI.parse(E.location)}))}}n.fromJSONObject=g})(C||(e.IconFontDefinition=C={}));class h{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,l.localize)(0,null)},fontCharacter:{type:"string",description:(0,l.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(i,g,f,u){const E=this.iconsById[i];if(E){if(f&&!E.description){E.description=f,this.iconSchema.properties[i].markdownDescription=`${f} $(${i})`;const w=this.iconReferenceSchema.enum.indexOf(i);w!==-1&&(this.iconReferenceSchema.enumDescriptions[w]=f),this._onDidChange.fire()}return E}const I={id:i,description:f,defaults:g,deprecationMessage:u};this.iconsById[i]=I;const _={$ref:"#/definitions/icons"};return u&&(_.deprecationMessage=u),f&&(_.markdownDescription=`${f}: $(${i})`),this.iconSchema.properties[i]=_,this.iconReferenceSchema.enum.push(i),this.iconReferenceSchema.enumDescriptions.push(f||""),this._onDidChange.fire(),{id:i}}deregisterIcon(i){delete this.iconsById[i],delete this.iconSchema.properties[i];const g=this.iconReferenceSchema.enum.indexOf(i);g!==-1&&(this.iconReferenceSchema.enum.splice(g,1),this.iconReferenceSchema.enumDescriptions.splice(g,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(i=>this.iconsById[i])}getIcon(i){return this.iconsById[i]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(i,g){const f=this.iconFontsById[i];return f||(this.iconFontsById[i]=g,this._onDidChange.fire(),g)}deregisterIconFont(i){delete this.iconFontsById[i]}getIconFont(i){return this.iconFontsById[i]}toString(){const i=(E,I)=>E.id.localeCompare(I.id),g=E=>{for(;O.ThemeIcon.isThemeIcon(E.defaults);)E=this.iconsById[E.defaults.id];return`codicon codicon-${E?E.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(E=>this.iconsById[E]);for(const E of u.filter(I=>!!I.description).sort(i))f.push(`|<i class="${g(E)}"></i>|${E.id}|${O.ThemeIcon.isThemeIcon(E.defaults)?E.defaults.id:E.id}|${E.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const E of u.filter(I=>!O.ThemeIcon.isThemeIcon(I.defaults)).sort(i))f.push(`|<i class="${g(E)}"></i>|${E.id}|`);return f.join(`
`)}}const r=new h;b.Registry.add(e.Extensions.IconContribution,r);function o(n,i,g,f){return r.registerIcon(n,i,g,f)}function a(){return r}function d(){const n=(0,P.getCodiconFontCharacters)();for(const i in n){const g="\\"+n[i].toString(16);r.registerIcon(i,{fontCharacter:g})}}d(),e.iconsSchemaId="vscode://schemas/icons";const t=b.Registry.as(T.Extensions.JSONContribution);t.registerSchema(e.iconsSchemaId,r.getIconSchema());const s=new y.RunOnceScheduler(()=>t.notifySchemaChanged(e.iconsSchemaId),200);r.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.widgetClose=o("widget-close",k.Codicon.close,(0,l.localize)(2,null)),e.gotoPreviousLocation=o("goto-previous-location",k.Codicon.arrowUp,(0,l.localize)(3,null)),e.gotoNextLocation=o("goto-next-location",k.Codicon.arrowDown,(0,l.localize)(4,null)),e.syncing=O.ThemeIcon.modify(k.Codicon.sync,"spin"),e.spinningLoading=O.ThemeIcon.modify(k.Codicon.loading,"spin")}),define(De[222],Ie([1,0,4,21,2,42,3,12]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=T,e.extractLocalHostUriMetaDataForPortMapping=c,e.extractQueryLocalHostUriMetaDataForPortMapping=C,e.isLocalhost=h,e.isAllInterfaces=r,e.isPortPrivileged=o,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var v;(function(t){t.Http="http",t.Https="https"})(v||(e.TunnelProtocol=v={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function T(t){return!!t.forwardPort}var b;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function c(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(s)return{address:s[1],port:+s[2]}}function C(t){if(t.scheme!=="http"&&t.scheme!=="https"||!t.query)return;const s=t.query.split("&");for(const n of s){const i=n.split("=")[1];if(/^https?:/.exec(i)){const g=c(P.URI.parse(i));if(g)return g}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function h(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function r(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}function o(t,s,n,i){if(n===k.OperatingSystem.Windows)return!1;if(n===k.OperatingSystem.Macintosh&&r(s)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(g?.length===4&&parseInt(g[1])>=18)return!1}return t<1024}class a{constructor(s,n,i){this.remoteAddress=s,this.localAddress=n,this._dispose=i,this._onDispose=new y.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=a;let d=class{constructor(s,n){this.logService=s,this.configurationService=n,this._onTunnelOpened=new y.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new y.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new y.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const s=this.configurationService.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this._tunnelProvider=s,s?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this._canElevate=s.elevation,this._privacyOptions=s.privacyOptions,this._canChangeProtocol=s.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const s=[],n=Array.from(this._tunnels.values());for(const i of n){const g=Array.from(i.values());for(const f of g){const u=await f.value;u&&typeof u!="string"&&s.push(u)}}return s}async dispose(){for(const s of this._tunnels.values()){for(const{value:n}of s.values())await n.then(i=>typeof i!="string"?i?.dispose():void 0);s.clear()}this._tunnels.clear()}setEnvironmentTunnel(s,n,i,g,f){this.addTunnelToMap(s,n,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:n,localAddress:i,privacy:g,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,n){(r(s)||h(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const i=this.getTunnelFromMap(s,n);if(i)return++i.refcount,i.value}openTunnel(s,n,i,g,f,u=!1,E,I){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${i} on local port ${f}.`);const _=this._tunnelProvider??s;if(!_)return;if(n||(n="localhost"),g||(g=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(i)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.retainOrCreateTunnel(_,n,i,g,f,u,E,I);return w?w.then(p=>{if(p){if(typeof p=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(n,i),p}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(n,i);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.makeTunnel(p);return(p.tunnelRemoteHost!==n||p.tunnelRemotePort!==i)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&p.privacy!==E&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(D),D}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}makeTunnel(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const n=this._tunnels.get(s.tunnelRemoteHost);if(n){const i=n.get(s.tunnelRemotePort);i&&(i.refcount--,await this.tryDisposeTunnel(s.tunnelRemoteHost,s.tunnelRemotePort,i))}}}}async tryDisposeTunnel(s,n,i){if(i.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${n}.`);const g=i.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(s)&&this._tunnels.get(s).delete(n),g}}async closeTunnel(s,n){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${n} `);const i=this._tunnels.get(s);if(i&&i.has(n)){const g=i.get(n);g.refcount=0,await this.tryDisposeTunnel(s,n,g)}}addTunnelToMap(s,n,i){this._tunnels.has(s)||this._tunnels.set(s,new Map),this._tunnels.get(s).set(n,{refcount:1,value:i})}async removeEmptyOrErrorTunnelFromMap(s,n){const i=this._tunnels.get(s);if(i){const g=i.get(n),f=g?await g.value:void 0;(!f||typeof f=="string")&&i.delete(n),i.size===0&&this._tunnels.delete(s)}}getTunnelFromMap(s,n){const i=[s];h(s)?(i.push(...e.LOCALHOST_ADDRESSES),i.push(...e.ALL_INTERFACES_ADDRESSES)):r(s)&&i.push(...e.ALL_INTERFACES_ADDRESSES);const g=i.map(f=>this._tunnels.get(f));for(const f of g){const u=f?.get(n);if(u)return u}}canTunnel(s){return!!c(s)}createWithProvider(s,n,i,g,f,u,E){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${i} on local port ${g}.`);const I=i;this._factoryInProgress.add(I);const _=g===void 0?i:g,w={elevationRequired:f?this.isPortPrivileged(_):!1},p={remoteAddress:{host:n,port:i},localAddressPort:g,privacy:u,public:u?u!==l.Private:void 0,protocol:E},D=s.forwardPort(p,w);return D?(this.addTunnelToMap(n,i,D),D.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(I)})):this._factoryInProgress.delete(I),D}};e.AbstractTunnelService=d,e.AbstractTunnelService=d=je([$e(0,R.ILogService),$e(1,O.IConfigurationService)],d)}),define(De[223],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,y.createDecorator)("IUriIdentityService")}),define(De[224],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,y.createDecorator)("editSessionIdentityService");var k;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(k||(e.EditSessionIdentityMatch=k={}))}),define(De[225],Ie([1,0,16]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=k,e.getVirtualWorkspaceLocation=P,e.getVirtualWorkspaceScheme=O,e.getVirtualWorkspaceAuthority=A,e.isVirtualWorkspace=R;function k(v){return v.scheme!==y.Schemas.file&&v.scheme!==y.Schemas.vscodeRemote}function P(v){if(v.folders.length)return v.folders.every(l=>k(l.uri))?v.folders[0].uri:void 0;if(v.configuration&&k(v.configuration))return v.configuration}function O(v){return P(v)?.scheme}function A(v){return P(v)?.authority}function R(v){return P(v)!==void 0}}),define(De[50],Ie([1,0,178,20,58,24,2,3,16]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=l,e.isEmptyWorkspaceIdentifier=T,e.toWorkspaceIdentifier=b,e.isWorkspaceIdentifier=c,e.reviveIdentifier=C,e.isWorkspace=r,e.isWorkspaceFolder=o,e.toWorkspaceFolder=t,e.isUntitledWorkspace=s,e.isTemporaryWorkspace=n,e.isStandaloneEditorWorkspace=i,e.isSavedWorkspace=g,e.hasWorkspaceFileExtension=f,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function l(u){const E=u;return typeof E?.id=="string"&&A.URI.isUri(E.uri)}function T(u){return typeof u?.id=="string"&&!l(u)&&!c(u)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(u,E){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,k.basename)(u)}:E?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const I=u;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}function c(u){const E=u;return typeof E?.id=="string"&&A.URI.isUri(E.configPath)}function C(u){const E=u;if(E?.uri)return{id:E.id,uri:A.URI.revive(E.uri)};const I=u;if(I?.configPath)return{id:I.id,configPath:A.URI.revive(I.configPath)};if(u?.id)return{id:u.id}}var h;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function r(u){const E=u;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}function o(u){const E=u;return!!(E&&typeof E=="object"&&A.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}class a{constructor(E,I,_,w,p){this._id=E,this._transient=_,this._configuration=w,this._ignorePathCasing=p,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=I}update(E){this._id=E.id,this._configuration=E.configuration,this._transient=E.transient,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E)||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=a;class d{constructor(E,I){this.raw=I,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,O.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function t(u){return new d({uri:u,index:0,name:(0,O.basenameOrAuthority)(u)},{uri:u.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function s(u,E){return O.extUriBiasedIgnorePathCase.isEqualOrParent(u,E.untitledWorkspacesHome)}function n(u){let E;return A.URI.isUri(u)?E=u:E=u.configuration,E?.scheme===v.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(u){return u.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function g(u,E){return!s(u,E)&&!n(u)}function f(u){return(typeof u=="string"?(0,k.extname)(u):(0,O.extname)(u))===e.WORKSPACE_SUFFIX}}),define(De[112],Ie([1,0,76,4,6,24,2,177,105,30,3,12,50,29,223,11,36,13,15]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=s,e.reviveProfile=n,e.toUserDataProfile=i;var t;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(t||(e.ProfileResourceType=t={}));function s(u){const E=u;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&typeof E.isDefault=="boolean"&&typeof E.name=="string"&&A.URI.isUri(E.location)&&A.URI.isUri(E.globalStorageHome)&&A.URI.isUri(E.settingsResource)&&A.URI.isUri(E.keybindingsResource)&&A.URI.isUri(E.tasksResource)&&A.URI.isUri(E.snippetsHome)&&A.URI.isUri(E.extensionsResource))}e.IUserDataProfilesService=(0,T.createDecorator)("IUserDataProfilesService");function n(u,E){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:A.URI.revive(u.location).with({scheme:E}),globalStorageHome:A.URI.revive(u.globalStorageHome).with({scheme:E}),settingsResource:A.URI.revive(u.settingsResource).with({scheme:E}),keybindingsResource:A.URI.revive(u.keybindingsResource).with({scheme:E}),tasksResource:A.URI.revive(u.tasksResource).with({scheme:E}),snippetsHome:A.URI.revive(u.snippetsHome).with({scheme:E}),extensionsResource:A.URI.revive(u.extensionsResource).with({scheme:E}),cacheHome:A.URI.revive(u.cacheHome).with({scheme:E}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}function i(u,E,I,_,w,p){return{id:u,name:E,location:I,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:p&&w?.useDefaultFlags?.globalState?p.globalStorageHome:(0,O.joinPath)(I,"globalStorage"),settingsResource:p&&w?.useDefaultFlags?.settings?p.settingsResource:(0,O.joinPath)(I,"settings.json"),keybindingsResource:p&&w?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,O.joinPath)(I,"keybindings.json"),tasksResource:p&&w?.useDefaultFlags?.tasks?p.tasksResource:(0,O.joinPath)(I,"tasks.json"),snippetsHome:p&&w?.useDefaultFlags?.snippets?p.snippetsHome:(0,O.joinPath)(I,"snippets"),extensionsResource:p&&w?.useDefaultFlags?.extensions?p.extensionsResource:(0,O.joinPath)(I,"extensions.json"),cacheHome:(0,O.joinPath)(_,u),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let g=class extends P.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(E,I,_,w){super(),this.environmentService=E,this.fileService=I,this.uriIdentityService=_,this.logService=w,this.enabled=!0,this._onDidChangeProfiles=this._register(new k.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new k.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new k.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new k.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new C.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,O.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(E){this.enabled!==E&&(this._profilesObject=void 0,this.enabled=E)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const E=this.createDefaultProfile(),I=[E];if(this.enabled)try{for(const p of this.getStoredProfiles()){if(!p.name||!(0,d.isString)(p.name)||!p.location){this.logService.warn("Skipping the invalid stored profile",p.location||p.name);continue}I.push(i((0,O.basename)(p.location),p.name,p.location,this.profilesCacheHome,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},E))}}catch(p){this.logService.error(p)}const _=new C.ResourceMap,w=new Map;if(I.length)try{const p=this.getStoredProfileAssociations();if(p.workspaces)for(const[D,m]of Object.entries(p.workspaces)){const S=A.URI.parse(D),M=I.find(L=>L.id===m);M&&_.set(S,M)}if(p.emptyWindows)for(const[D,m]of Object.entries(p.emptyWindows)){const S=I.find(M=>M.id===m);S&&w.set(D,S)}}catch(p){this.logService.error(p)}this._profilesObject={profiles:I,workspaces:_,emptyWindows:w}}return this._profilesObject}createDefaultProfile(){const E=i("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...E,extensionsResource:this.getDefaultProfileExtensionsLocation()??E.extensionsResource,isDefault:!0}}async createTransientProfile(E){const I="Temp",_=new RegExp(`${(0,a.escapeRegExpCharacters)(I)}\\s(\\d+)`);let w=0;for(const D of this.profiles){const m=_.exec(D.name),S=m?parseInt(m[1]):0;w=S>w?S:w}const p=`${I} ${w+1}`;return this.createProfile((0,y.hash)((0,o.generateUuid)()).toString(16),p,{transient:!0},E)}async createNamedProfile(E,I,_){return this.createProfile((0,y.hash)((0,o.generateUuid)()).toString(16),E,I,_)}async createProfile(E,I,_,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const p=await this.doCreateProfile(E,I,_);return w&&await this.setProfileForWorkspace(w,p),p}async doCreateProfile(E,I,_){if(!(0,d.isString)(I)||!I)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.profileCreationPromises.get(I);return w||(w=(async()=>{try{if(this.profiles.find(S=>S.name===I||S.id===E))throw new Error(`Profile with ${I} name already exists`);const D=i(E,I,(0,O.joinPath)(this.profilesHome,E),this.profilesCacheHome,_,this.defaultProfile);await this.fileService.createFolder(D.location);const m=[];return this._onWillCreateProfile.fire({profile:D,join(S){m.push(S)}}),await r.Promises.settled(m),this.updateProfiles([D],[],[]),D}finally{this.profileCreationPromises.delete(I)}})(),this.profileCreationPromises.set(I,w)),w}async updateProfile(E,I){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let _=this.profiles.find(w=>w.id===E.id);if(!_)throw new Error(`Profile '${E.name}' does not exist`);return _=i(_.id,I.name??_.name,_.location,this.profilesCacheHome,{shortName:I.shortName??_.shortName,icon:I.icon===null?void 0:I.icon??_.icon,transient:I.transient??_.isTransient,useDefaultFlags:I.useDefaultFlags??_.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[_]),_}async removeProfile(E){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(E.isDefault)throw new Error("Cannot remove default profile");const I=this.profiles.find(w=>w.id===E.id);if(!I)throw new Error(`Profile '${E.name}' does not exist`);const _=[];this._onWillRemoveProfile.fire({profile:I,join(w){_.push(w)}});try{await Promise.allSettled(_)}catch(w){this.logService.error(w)}for(const w of[...this.profilesObject.emptyWindows.keys()])I.id===this.profilesObject.emptyWindows.get(w)?.id&&this.profilesObject.emptyWindows.delete(w);for(const w of[...this.profilesObject.workspaces.keys()])I.id===this.profilesObject.workspaces.get(w)?.id&&this.profilesObject.workspaces.delete(w);this.updateStoredProfileAssociations(),this.updateProfiles([],[I],[]);try{await this.fileService.del(I.cacheHome,{recursive:!0})}catch(w){(0,l.toFileOperationResult)(w)!==l.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(w)}}async setProfileForWorkspace(E,I){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const _=this.profiles.find(w=>w.id===I.id);if(!_)throw new Error(`Profile '${I.name}' does not exist`);this.updateWorkspaceAssociation(E,_)}unsetWorkspace(E,I){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(E,void 0,I)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const E=await this.fileService.resolve(this.profilesHome);await Promise.all((E.children||[]).filter(I=>I.isDirectory&&this.profiles.every(_=>!this.uriIdentityService.extUri.isEqual(_.location,I.resource))).map(I=>this.fileService.del(I.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const E=this.transientProfilesObject.profiles.filter(I=>!this.isProfileAssociatedToWorkspace(I));await Promise.allSettled(E.map(I=>this.removeProfile(I)))}getProfileForWorkspace(E){const I=this.getWorkspace(E);return A.URI.isUri(I)?this.transientProfilesObject.workspaces.get(I)??this.profilesObject.workspaces.get(I):this.transientProfilesObject.emptyWindows.get(I)??this.profilesObject.emptyWindows.get(I)}getWorkspace(E){return(0,c.isSingleFolderWorkspaceIdentifier)(E)?E.uri:(0,c.isWorkspaceIdentifier)(E)?E.configPath:E.id}isProfileAssociatedToWorkspace(E){return!!([...this.transientProfilesObject.emptyWindows.values()].some(I=>this.uriIdentityService.extUri.isEqual(I.location,E.location))||[...this.transientProfilesObject.workspaces.values()].some(I=>this.uriIdentityService.extUri.isEqual(I.location,E.location))||[...this.profilesObject.emptyWindows.values()].some(I=>this.uriIdentityService.extUri.isEqual(I.location,E.location))||[...this.profilesObject.workspaces.values()].some(I=>this.uriIdentityService.extUri.isEqual(I.location,E.location)))}updateProfiles(E,I,_){const w=[...this.profiles,...E],p=[];this.transientProfilesObject.profiles=[];for(let D of w)D.isDefault||I.some(m=>D.id===m.id)||(D=_.find(m=>D.id===m.id)??D,D.isTransient?this.transientProfilesObject.profiles.push(D):p.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags}));this.saveStoredProfiles(p),this._profilesObject=void 0,this.triggerProfilesChanges(E,I,_)}triggerProfilesChanges(E,I,_){this._onDidChangeProfiles.fire({added:E,removed:I,updated:_,all:this.profiles})}updateWorkspaceAssociation(E,I,_){_=I?.isTransient?!0:_,_||this.updateWorkspaceAssociation(E,void 0,!0);const w=this.getWorkspace(E),p=_?this.transientProfilesObject:this.profilesObject;A.URI.isUri(w)?(p.workspaces.delete(w),I&&p.workspaces.set(w,I)):(p.emptyWindows.delete(w),I&&p.emptyWindows.set(w,I)),_||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const E={};for(const[_,w]of this.profilesObject.workspaces.entries())E[_.toString()]=w.id;const I={};for(const[_,w]of this.profilesObject.emptyWindows.entries())I[_.toString()]=w.id;this.saveStoredProfileAssociations({workspaces:E,emptyWindows:I}),this._profilesObject=void 0}migrateStoredProfileAssociations(E){const I={},_=this.createDefaultProfile();if(E.workspaces)for(const[p,D]of Object.entries(E.workspaces)){const m=A.URI.parse(D);I[p]=this.uriIdentityService.extUri.isEqual(m,_.location)?_.id:this.uriIdentityService.extUri.basename(m)}const w={};if(E.emptyWindows)for(const[p,D]of Object.entries(E.emptyWindows)){const m=A.URI.parse(D);w[p]=this.uriIdentityService.extUri.isEqual(m,_.location)?_.id:this.uriIdentityService.extUri.basename(m)}return{workspaces:I,emptyWindows:w}}getStoredProfiles(){return[]}saveStoredProfiles(E){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(E){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=g,e.UserDataProfilesService=g=je([$e(0,v.IEnvironmentService),$e(1,l.IFileService),$e(2,h.IUriIdentityService),$e(3,b.ILogService)],g);class f extends g{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(E){this.storedProfiles=E}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(E){this.storedProfileAssociations=E}}e.InMemoryUserDataProfilesService=f}),define(De[226],Ie([1,0,11,4,6,64,15,160,3,112]),function(he,e,y,k,P,O,A,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=C,e.isProfileUsingDefaultStorage=r,e.logStorage=a,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var T;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var c;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(c||(e.StorageTarget=c={}));function C(d){const t=d.get(e.TARGET_KEY);if(t)try{return JSON.parse(t)}catch{}return Object.create(null)}class h extends P.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(t={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=t,this._onDidChangeValue=this._register(new k.PauseableEmitter),this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new y.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(t,s,n){return k.Event.filter(this._onDidChangeValue.event,i=>i.scope===t&&(s===void 0||i.key===s),n)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,y.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(t,s){const{key:n,external:i}=s;if(n===e.TARGET_KEY){switch(t){case b.APPLICATION:this._applicationKeyTargets=void 0;break;case b.PROFILE:this._profileKeyTargets=void 0;break;case b.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:t})}else this._onDidChangeValue.fire({scope:t,key:n,target:this.getKeyTargets(t)[n],external:i})}emitWillSaveState(t){this._onWillSaveState.fire({reason:t})}get(t,s,n){return this.getStorage(s)?.get(t,n)}getBoolean(t,s,n){return this.getStorage(s)?.getBoolean(t,n)}getNumber(t,s,n){return this.getStorage(s)?.getNumber(t,n)}getObject(t,s,n){return this.getStorage(s)?.getObject(t,n)}storeAll(t,s){this.withPausedEmitters(()=>{for(const n of t)this.store(n.key,n.value,n.scope,n.target,s)})}store(t,s,n,i,g=!1){if((0,A.isUndefinedOrNull)(s)){this.remove(t,n,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(t,n,i),this.getStorage(n)?.set(t,s,g)})}remove(t,s,n=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(t,s,void 0),this.getStorage(s)?.delete(t,n)})}withPausedEmitters(t){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{t()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(t,s){const n=[],i=this.getKeyTargets(t);for(const g of Object.keys(i))i[g]===s&&n.push(g);return n}updateKeyTarget(t,s,n,i=!1){const g=this.getKeyTargets(s);typeof n=="number"?g[t]!==n&&(g[t]=n,this.getStorage(s)?.set(e.TARGET_KEY,JSON.stringify(g),i)):typeof g[t]=="number"&&(delete g[t],this.getStorage(s)?.set(e.TARGET_KEY,JSON.stringify(g),i))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(b.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(b.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(b.APPLICATION)),this._applicationKeyTargets}getKeyTargets(t){switch(t){case b.APPLICATION:return this.applicationKeyTargets;case b.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(t){const s=this.getStorage(t);return s?C(s):Object.create(null)}isNew(t){return this.getBoolean(e.IS_NEW_KEY,t)===!0}async flush(t=T.NONE){this._onWillSaveState.fire({reason:t});const s=this.getStorage(b.APPLICATION),n=this.getStorage(b.PROFILE),i=this.getStorage(b.WORKSPACE);switch(t){case T.NONE:await y.Promises.settled([s?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await y.Promises.settled([s?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const t=this.getStorage(b.APPLICATION)?.items??new Map,s=this.getStorage(b.PROFILE)?.items??new Map,n=this.getStorage(b.WORKSPACE)?.items??new Map;return a(t,s,n,this.getLogDetails(b.APPLICATION)??"",this.getLogDetails(b.PROFILE)??"",this.getLogDetails(b.WORKSPACE)??"")}async optimize(t){return await this.flush(),this.getStorage(t)?.optimize()}async switch(t,s){return this.emitWillSaveState(T.NONE),(0,l.isUserDataProfile)(t)?this.switchToProfile(t,s):this.switchToWorkspace(t,s)}canSwitchProfile(t,s){return!(t.id===s.id||r(s)&&r(t))}switchData(t,s,n){this.withPausedEmitters(()=>{const i=new Set;for(const[g,f]of t)i.add(g),s.get(g)!==f&&this.emitDidChangeValue(n,{key:g,external:!0});for(const[g]of s.items)i.has(g)||this.emitDidChangeValue(n,{key:g,external:!0})})}}e.AbstractStorageService=h;function r(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class o extends h{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(t=>this.emitDidChangeValue(b.WORKSPACE,t))),this._register(this.profileStorage.onDidChangeStorage(t=>this.emitDidChangeValue(b.PROFILE,t))),this._register(this.applicationStorage.onDidChangeStorage(t=>this.emitDidChangeValue(b.APPLICATION,t)))}getStorage(t){switch(t){case b.APPLICATION:return this.applicationStorage;case b.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(t){switch(t){case b.APPLICATION:return"inMemory (application)";case b.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(t){return!1}}e.InMemoryStorageService=o;async function a(d,t,s,n,i,g){const f=S=>{try{return JSON.parse(S)}catch{return S}},u=new Map,E=new Map;d.forEach((S,M)=>{u.set(M,S),E.set(M,f(S))});const I=new Map,_=new Map;t.forEach((S,M)=>{I.set(M,S),_.set(M,f(S))});const w=new Map,p=new Map;s.forEach((S,M)=>{w.set(M,S),p.set(M,f(S))}),console.group(n!==i?`Storage: Application (path: ${n})`:`Storage: Application & Profile (path: ${n}, default profile)`);const D=[];if(u.forEach((S,M)=>{D.push({key:M,value:S})}),console.table(D),console.groupEnd(),console.log(E),n!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const S=[];I.forEach((M,L)=>{S.push({key:L,value:M})}),console.table(S),console.groupEnd(),console.log(_)}console.group(`Storage: Workspace (path: ${g})`);const m=[];w.forEach((S,M)=>{m.push({key:M,value:S})}),console.table(m),console.groupEnd(),console.log(p)}}),define(De[80],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class y{static{this.enableDebugLogging=!1}constructor(P){this.id=P,this._data=new Map,this._idPool=1}add(P){const O=this._idPool++;return this._data.set(O,P),this.logDebugInfo(),O}get(P,O){return this._data.has(P)?this._data.get(P)[O]:void 0}delete(P){this._data.delete(P),this.logDebugInfo()}logDebugInfo(){y.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=y}),define(De[51],Ie([1,0,16,24,30,3]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(y.Schemas)),this._providerInfo=new Map,this.extUri=new k.ExtUri(v=>{const l=this._providerInfo.get(v.scheme);return!(l===void 0||l&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(v,l){l===null?this._providerInfo.delete(v.scheme):this._providerInfo.set(v.scheme,l)}isFreeScheme(v){return!this._providerInfo.has(v)&&!this._systemSchemes.has(v)}getCapabilities(v){return this._providerInfo.get(v)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,O.createDecorator)("IExtHostFileSystemInfo")}),define(De[27],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,y.createDecorator)("IExtHostInitDataService")}),define(De[227],Ie([1,0,183,12,212,27]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends P.LogService{constructor(v,l,T){const b=T.remote.isRemote?"remoteexthost":v?"workerexthost":"exthost",c=T.remote.isRemote?(0,y.localize)(0,null):v?(0,y.localize)(1,null):(0,y.localize)(2,null);super(l.createLogger(b,{name:c}))}};e.ExtHostLogService=A,e.ExtHostLogService=A=je([$e(1,k.ILoggerService),$e(2,O.IExtHostInitDataService)],A)}),define(De[228],Ie([1,0,11]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(A,R,v){this._deferredPromises=new Map,this._id=A,this._shared=R,this._storage=v,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(l=>(this._value=l,this)),this._storageListener=this._storage.onDidChangeStorage(l=>{l.shared===this._shared&&l.key===this._id&&(this._value=l.value)}),this._scheduler=new y.RunOnceScheduler(()=>{const l=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const T of l.values())T.complete()}catch(T){for(const b of l.values())b.error(T)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,R){let v=this._value[A];return typeof v>"u"&&(v=R),v}update(A,R){this._value[A]=R;const v=this._deferredPromises.get(A);if(v!==void 0)return v.p;const l=new y.DeferredPromise;return this._deferredPromises.set(A,l),this._scheduler.isScheduled()||this._scheduler.schedule(),l.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=k;class P extends k{setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}constructor(A,R){super(A.identifier.value,!0,R),this._extension=A}}e.ExtensionGlobalMemento=P}),define(De[229],Ie([1,0,4,2]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class P{constructor(A){this._notebooksAndEditors=A,this._onDidSaveNotebookDocument=new y.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new y.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,R,v,l){const b=this._notebooksAndEditors.getNotebookDocument(k.URI.revive(A)).acceptModelChanged(R.value,v,l);this._onDidChangeNotebookDocument.fire(b)}$acceptDirtyStateChanged(A,R){this._notebooksAndEditors.getNotebookDocument(k.URI.revive(A)).acceptDirty(R)}$acceptModelSaved(A){const R=this._notebooksAndEditors.getNotebookDocument(k.URI.revive(A));this._onDidSaveNotebookDocument.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=P}),define(De[17],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,y.createDecorator)("IExtHostRpcService");class k{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.ExtHostRpcService=k}),define(De[230],Ie([1,0,19,4]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{#e;constructor(A,R){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=y.ExtensionIdentifier.toKey(A.identifier),this.#e=R,this.#e.onDidChangePassword(v=>{v.extensionId===this._id&&this._onDidChange.fire({key:v.key})})}get(A){return this.#e.get(this._id,A)}store(A,R){return this.#e.store(this._id,A,R)}delete(A){return this.#e.delete(this._id,A)}}e.ExtensionSecrets=P}),define(De[65],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,y.createDecorator)("IURITransformerService");class k{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=k}),define(De[113],Ie([1,0,192,15,2,6,3,31,30,16,48,154,35]),function(he,e,y,k,P,O,A,R,v,l,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=r,e.isEditorPaneWithScrolling=o,e.findViewStateForEditor=a,e.isResourceEditorInput=d,e.isResourceDiffEditorInput=t,e.isResourceMultiDiffEditorInput=s,e.isResourceSideBySideEditorInput=n,e.isUntitledResourceEditorInput=i,e.isResourceMergeEditorInput=g,e.isEditorInput=w,e.isSideBySideEditorInput=D,e.isDiffEditorInput=m,e.createTooLargeFileError=S,e.isEditorInputWithOptions=M,e.isEditorInputWithOptionsAndGroup=L,e.isEditorIdentifier=H,e.isEditorCommandsContext=V,e.preventEditorClose=fe,e.pathsToEditors=pe,e.isTextEditorViewState=se,e.isEditorOpenError=Te,e.createEditorOpenError=Me,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var C;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(C||(e.EditorPaneSelectionChangeReason=C={}));var h;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(h||(e.EditorPaneSelectionCompareResult=h={}));function r(Q){const W=Q;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function o(Q){const W=Q;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function a(Q,W,ie){for(const _e of ie.visibleEditorPanes)if(_e.group.id===W&&Q.matches(_e.input))return _e.getViewState()}function d(Q){if(w(Q))return!1;const W=Q;return P.URI.isUri(W?.resource)}function t(Q){if(w(Q))return!1;const W=Q;return W?.original!==void 0&&W.modified!==void 0}function s(Q){if(w(Q))return!1;const W=Q;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function n(Q){if(w(Q)||t(Q))return!1;const W=Q;return W?.primary!==void 0&&W.secondary!==void 0}function i(Q){if(w(Q))return!1;const W=Q;return W?W.resource===void 0||W.resource.scheme===l.Schemas.untitled||W.forceUntitled===!0:!1}function g(Q){if(w(Q))return!1;const W=Q;return P.URI.isUri(W?.base?.resource)&&P.URI.isUri(W?.input1?.resource)&&P.URI.isUri(W?.input2?.resource)&&P.URI.isUri(W?.result?.resource)}var f;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var u;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class E{constructor(){this.mapIdToSaveSource=new Map}registerSource(W,ie){let _e=this.mapIdToSaveSource.get(W);return _e||(_e={source:W,label:ie},this.mapIdToSaveSource.set(W,_e)),_e.source}getSourceLabel(W){return this.mapIdToSaveSource.get(W)?.label??W}}e.SaveSourceRegistry=new E;var I;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription",Q[Q.CanDropIntoEditor=128]="CanDropIntoEditor",Q[Q.MultipleEditors=256]="MultipleEditors",Q[Q.Scratchpad=512]="Scratchpad"})(I||(e.EditorInputCapabilities=I={}));class _ extends O.Disposable{}e.AbstractEditorInput=_;function w(Q){return Q instanceof _}function p(Q){const W=Q;return P.URI.isUri(W?.preferredResource)}function D(Q){const W=Q;return w(W?.primary)&&w(W?.secondary)}function m(Q){const W=Q;return w(W?.modified)&&w(W?.original)}function S(Q,W,ie,_e,de){return Me(_e,[(0,b.toAction)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const Se={...ie,limits:{size:Number.MAX_VALUE}};Q.openEditor(W,Se)}}),(0,b.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>de.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}function M(Q){return w(Q?.editor)}function L(Q){const W=Q;return M(Q)&&W?.group!==void 0}function H(Q){const W=Q;return typeof W?.groupId=="number"&&w(W.editor)}function V(Q){return typeof Q?.groupId=="number"}var $;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})($||(e.EditorCloseContext=$={}));var N;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LABEL=2]="GROUP_LABEL",Q[Q.GROUP_LOCKED=3]="GROUP_LOCKED",Q[Q.EDITORS_SELECTION=4]="EDITORS_SELECTION",Q[Q.EDITOR_OPEN=5]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=6]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=7]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=9]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=11]="EDITOR_PIN",Q[Q.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Q[Q.EDITOR_STICKY=13]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=14]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var F;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class Y{getOriginalUri(W,ie){if(!W)return;if(g(W))return e.EditorResourceAccessor.getOriginalUri(W.result,ie);if(ie?.supportSideBySide){const{primary:de,secondary:Se}=this.getSideEditors(W);if(de&&Se){if(ie?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(Se,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===F.ANY)return this.getOriginalUri(de,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(Se,{filterByScheme:ie.filterByScheme});W=ie.supportSideBySide===F.PRIMARY?de:Se}}if(t(W)||s(W)||n(W)||g(W))return;const _e=p(W)?W.preferredResource:W.resource;return!_e||!ie||!ie.filterByScheme?_e:this.filterUri(_e,ie.filterByScheme)}getSideEditors(W){return D(W)||n(W)?{primary:W.primary,secondary:W.secondary}:m(W)||t(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,ie){if(!W)return;if(g(W))return e.EditorResourceAccessor.getCanonicalUri(W.result,ie);if(ie?.supportSideBySide){const{primary:de,secondary:Se}=this.getSideEditors(W);if(de&&Se){if(ie?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(Se,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===F.ANY)return this.getCanonicalUri(de,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(Se,{filterByScheme:ie.filterByScheme});W=ie.supportSideBySide===F.PRIMARY?de:Se}}if(t(W)||s(W)||n(W)||g(W))return;const _e=W.resource;return!_e||!ie||!ie.filterByScheme?_e:this.filterUri(_e,ie.filterByScheme)}filterUri(W,ie){if(Array.isArray(ie)){if(ie.some(_e=>W.scheme===_e))return W}else if(ie===W.scheme)return W}}var re;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.KEYBOARD=1]="KEYBOARD",Q[Q.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function fe(Q,W,ie,_e){if(!Q.isSticky(W))return!1;switch(_e.preventPinnedEditorClose){case"keyboardAndMouse":return ie===re.MOUSE||ie===re.KEYBOARD;case"mouse":return ie===re.MOUSE;case"keyboard":return ie===re.KEYBOARD}return!1}e.EditorResourceAccessor=new Y;var Ee;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(Ee||(e.CloseDirection=Ee={}));class oe{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(W){const ie=this.instantiationService=W.get(A.IInstantiationService);for(const[_e,de]of this.editorSerializerConstructors)this.createEditorSerializer(_e,de,ie);this.editorSerializerConstructors.clear()}createEditorSerializer(W,ie,_e){const de=_e.createInstance(ie);this.editorSerializerInstances.set(W,de)}registerFileEditorFactory(W){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=W}getFileEditorFactory(){return(0,k.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(W,ie){if(this.editorSerializerConstructors.has(W)||this.editorSerializerInstances.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.instantiationService?this.createEditorSerializer(W,ie,this.instantiationService):this.editorSerializerConstructors.set(W,ie),(0,O.toDisposable)(()=>{this.editorSerializerConstructors.delete(W),this.editorSerializerInstances.delete(W)})}getEditorSerializer(W){return this.editorSerializerInstances.get(typeof W=="string"?W:W.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new oe);async function pe(Q,W,ie){return!Q||!Q.length?[]:await Promise.all(Q.map(async _e=>{const de=P.URI.revive(_e.fileUri);if(!de){ie.info("Cannot resolve the path because it is not valid.",_e);return}if(!await W.canHandleResource(de)){ie.info("Cannot resolve the path because it cannot be handled",_e);return}let ae=_e.exists,X=_e.type;if(typeof ae!="boolean"||typeof X!="number")try{X=(await W.stat(de)).isDirectory?v.FileType.Directory:v.FileType.Unknown,ae=!0}catch(me){ie.error(me),ae=!1}if(!ae&&_e.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",_e);return}if(X===v.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",_e);return}const J={..._e.options,pinned:!0};return ae?{resource:de,options:J}:{resource:de,options:J,forceUntitled:!0}}))}var ve;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(ve||(e.EditorsOrder=ve={}));function se(Q){const W=Q;if(!W)return!1;const ie=W;if(ie.modified)return se(ie.modified);const _e=W;return!!(_e.contributionsState&&_e.viewState&&Array.isArray(_e.cursorState))}function Te(Q){return(0,T.isErrorWithActions)(Q)}function Me(Q,W,ie){const _e=(0,T.createErrorWithActions)(Q,W);return _e.forceMessage=ie?.forceMessage,_e.forceSeverity=ie?.forceSeverity,_e.allowDialog=ie?.allowDialog,_e}}),define(De[231],Ie([1,0,4,193,3,6,29,31,26,97,221]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=C,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,k.localize)(0,null),e.defaultViewIcon=(0,T.registerIcon)("default-view-icon",l.Codicon.window,(0,k.localize)(1,null));var b;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var c;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(c||(e.ViewContainerLocation=c={})),e.ViewContainerLocations=[c.Sidebar,c.Panel,c.AuxiliaryBar];function C(i){switch(i){case c.Sidebar:return"sidebar";case c.Panel:return"panel";case c.AuxiliaryBar:return"auxiliarybar"}}class h extends O.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new y.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new y.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return[...this.viewContainers.values()].flat()}registerViewContainer(g,f,u){const E=this.get(g.id);if(E)return E;const I=g;return I.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.getOrSet)(this.viewContainers,f,[]).push(I),u?.isDefault&&this.defaultViewContainers.push(I),this._onDidRegister.fire({viewContainer:I,viewContainerLocation:f}),I}deregisterViewContainer(g){for(const f of this.viewContainers.keys()){const u=this.viewContainers.get(f),E=u?.indexOf(g);if(E!==-1){u?.splice(E,1),u.length===0&&this.viewContainers.delete(f),this._onDidDeregister.fire({viewContainer:g,viewContainerLocation:f});return}}}get(g){return this.all.filter(f=>f.id===g)[0]}getViewContainers(g){return[...this.viewContainers.get(g)||[]]}getViewContainerLocation(g){return[...this.viewContainers.keys()].filter(f=>this.getViewContainers(f).filter(u=>u?.id===g.id).length>0)[0]}getDefaultViewContainer(g){return this.defaultViewContainers.find(f=>this.getViewContainerLocation(f)===g)}}R.Registry.add(b.ViewContainersRegistry,new h);var r;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(r||(e.ViewContentGroups=r={}));function o(i,g){const f=i.group??r.More,u=g.group??r.More;return f!==u?f.localeCompare(u):(i.order??5)-(g.order??5)}class a extends O.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new y.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new y.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new y.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new y.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(g,f){this.registerViews2([{views:g,viewContainer:f}])}registerViews2(g){g.forEach(({views:f,viewContainer:u})=>this.addViews(f,u)),this._onViewsRegistered.fire(g)}deregisterViews(g,f){const u=this.removeViews(g,f);u.length&&this._onViewsDeregistered.fire({views:u,viewContainer:f})}moveViews(g,f){for(const u of this._views.keys())if(u!==f){const E=this.removeViews(g,u);E.length&&(this.addViews(E,f),this._onDidChangeContainer.fire({views:E,from:u,to:f}))}}getViews(g){return this._views.get(g)||[]}getView(g){for(const f of this._viewContainers){const u=(this._views.get(f)||[]).filter(E=>E.id===g)[0];if(u)return u}return null}getViewContainer(g){for(const f of this._viewContainers)if((this._views.get(f)||[]).filter(E=>E.id===g)[0])return f;return null}registerViewWelcomeContent(g,f){return this._viewWelcomeContents.add(g,f),this._onDidChangeViewWelcomeContent.fire(g),(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(g,f),this._onDidChangeViewWelcomeContent.fire(g)})}registerViewWelcomeContent2(g,f){const u=new Map;for(const[E,I]of f)this._viewWelcomeContents.add(g,I),u.set(E,(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(g,I),this._onDidChangeViewWelcomeContent.fire(g)}));return this._onDidChangeViewWelcomeContent.fire(g),u}getViewWelcomeContent(g){const f=[];return this._viewWelcomeContents.forEach(g,u=>f.push(u)),f.sort(o)}addViews(g,f){let u=this._views.get(f);u||(u=[],this._views.set(f,u),this._viewContainers.push(f));for(const E of g){if(this.getView(E.id)!==null)throw new Error((0,k.localize)(2,null,E.id));u.push(E)}}removeViews(g,f){const u=this._views.get(f);if(!u)return[];const E=[],I=[];for(const _ of u)g.includes(_)?E.push(_):I.push(_);return E.length&&(I.length?this._views.set(f,I):(this._views.delete(f),this._viewContainers.splice(this._viewContainers.indexOf(f),1))),E}}R.Registry.add(b.ViewsRegistry,new a),e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var d;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(d||(e.ViewVisibilityState=d={}));var t;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(t||(e.TreeItemCollapsibleState=t={}));class s{constructor(g,f){this.resolved=!1,this._hasResolve=!1,(0,v.mixin)(this,g),this._hasResolve=!!f,this.resolve=async u=>{if(f&&!this.resolved){const E=await f(u);E&&(this.tooltip=this.tooltip??E.tooltip,this.command=this.command??E.command)}u.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s;class n extends Error{constructor(g){super((0,k.localize)(3,null,g)),this.name="NoTreeViewError"}static is(g){return g.name==="NoTreeViewError"}}e.NoTreeViewError=n}),define(De[232],Ie([1,0,194,32]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_IN_QUICK_CHAT=e.CONTEXT_CHAT_LOCATION=e.CONTEXT_CHAT_INPUT_HAS_AGENT=e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=e.CONTEXT_CHAT_ENABLED=e.CONTEXT_IN_CHAT_SESSION=e.CONTEXT_IN_CHAT_INPUT=e.CONTEXT_CHAT_INPUT_HAS_FOCUS=e.CONTEXT_CHAT_INPUT_HAS_TEXT=e.CONTEXT_CHAT_EDIT_APPLIED=e.CONTEXT_REQUEST=e.CONTEXT_RESPONSE=e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=e.CONTEXT_RESPONSE_FILTERED=e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=e.CONTEXT_RESPONSE_VOTE=void 0,e.CONTEXT_RESPONSE_VOTE=new k.RawContextKey("chatSessionResponseVote","",{type:"string",description:(0,y.localize)(0,null)}),e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=new k.RawContextKey("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,y.localize)(1,null)}),e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=new k.RawContextKey("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,y.localize)(2,null)}),e.CONTEXT_RESPONSE_FILTERED=new k.RawContextKey("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,y.localize)(3,null)}),e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=new k.RawContextKey("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,y.localize)(4,null)}),e.CONTEXT_RESPONSE=new k.RawContextKey("chatResponse",!1,{type:"boolean",description:(0,y.localize)(5,null)}),e.CONTEXT_REQUEST=new k.RawContextKey("chatRequest",!1,{type:"boolean",description:(0,y.localize)(6,null)}),e.CONTEXT_CHAT_EDIT_APPLIED=new k.RawContextKey("chatEditApplied",!1,{type:"boolean",description:(0,y.localize)(7,null)}),e.CONTEXT_CHAT_INPUT_HAS_TEXT=new k.RawContextKey("chatInputHasText",!1,{type:"boolean",description:(0,y.localize)(8,null)}),e.CONTEXT_CHAT_INPUT_HAS_FOCUS=new k.RawContextKey("chatInputHasFocus",!1,{type:"boolean",description:(0,y.localize)(9,null)}),e.CONTEXT_IN_CHAT_INPUT=new k.RawContextKey("inChatInput",!1,{type:"boolean",description:(0,y.localize)(10,null)}),e.CONTEXT_IN_CHAT_SESSION=new k.RawContextKey("inChat",!1,{type:"boolean",description:(0,y.localize)(11,null)}),e.CONTEXT_CHAT_ENABLED=new k.RawContextKey("chatIsEnabled",!1,{type:"boolean",description:(0,y.localize)(12,null)}),e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=new k.RawContextKey("chatCursorAtTop",!1),e.CONTEXT_CHAT_INPUT_HAS_AGENT=new k.RawContextKey("chatInputHasAgent",!1),e.CONTEXT_CHAT_LOCATION=new k.RawContextKey("chatLocation",void 0),e.CONTEXT_IN_QUICK_CHAT=new k.RawContextKey("quickChatHasFocus",!1,{type:"boolean",description:(0,y.localize)(13,null)})}),define(De[233],Ie([1,0,324,11,22,4,40,6,49,140,13,32,19,3,12,107,215,226,232]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ChatAgentNameService=e.IChatAgentNameService=e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0,e.getFullyQualifiedId=f,e.reviveSerializedAgent=u;var s;(function(E){E.Panel="panel",E.Terminal="terminal",E.Notebook="notebook",E.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(E){function I(_){switch(_){case"panel":return E.Panel;case"terminal":return E.Terminal;case"notebook":return E.Notebook;case"editor":return E.Editor}return E.Panel}E.fromRaw=I}(s||(e.ChatAgentLocation=s={})),e.IChatAgentService=(0,C.createDecorator)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(I){this.contextKeyService=I,this._agents=new Map,this._onDidChangeAgents=new O.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event,this._agentCompletionProviders=new Map,this._hasDefaultAgent=d.CONTEXT_CHAT_ENABLED.bindTo(this.contextKeyService)}registerAgent(I,_){if(this.getAgent(I))throw new Error(`Agent already registered: ${JSON.stringify(I)}`);const p=this,D=_.slashCommands;_={..._,get slashCommands(){return D.filter(S=>!S.when||p.contextKeyService.contextMatchesRules(b.ContextKeyExpr.deserialize(S.when)))}};const m={data:_};return this._agents.set(I,m),(0,R.toDisposable)(()=>{this._agents.delete(I),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(I,_){const w=this._agents.get(I);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(I)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(I)}`);return w.data.isDefault&&this._hasDefaultAgent.set(!0),w.impl=_,this._onDidChangeAgents.fire(new i(w.data,_)),(0,R.toDisposable)(()=>{w.impl=void 0,this._onDidChangeAgents.fire(void 0),w.data.isDefault&&this._hasDefaultAgent.set(!1)})}registerDynamicAgent(I,_){I.isDynamic=!0;const w={data:I,impl:_};return this._agents.set(I.id,w),this._onDidChangeAgents.fire(new i(I,_)),(0,R.toDisposable)(()=>{this._agents.delete(I.id),this._onDidChangeAgents.fire(void 0)})}registerAgentCompletionProvider(I,_){return this._agentCompletionProviders.set(I,_),{dispose:()=>{this._agentCompletionProviders.delete(I)}}}async getAgentCompletionItems(I,_,w){return await this._agentCompletionProviders.get(I)?.(_,w)??[]}updateAgent(I,_){const w=this._agents.get(I);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(I)} registered`);w.data.metadata={...w.data.metadata,..._},this._onDidChangeAgents.fire(new i(w.data,w.impl))}getDefaultAgent(I){return(0,y.findLast)(this.getActivatedAgents(),_=>!!_.isDefault&&_.locations.includes(I))}getContributedDefaultAgent(I){return this.getAgents().find(_=>!!_.isDefault&&_.locations.includes(I))}getSecondaryAgent(){return A.Iterable.find(this._agents.values(),I=>!!I.data.metadata.isSecondary)?.data}getAgent(I){if(this._agentIsEnabled(I))return this._agents.get(I)?.data}_agentIsEnabled(I){const _=this._agents.get(I);return!_?.data.when||this.contextKeyService.contextMatchesRules(b.ContextKeyExpr.deserialize(_.data.when))}getAgentByFullyQualifiedId(I){const _=A.Iterable.find(this._agents.values(),w=>f(w.data)===I)?.data;if(!(_&&!this._agentIsEnabled(_.id)))return _}getAgents(){return Array.from(this._agents.values()).map(I=>I.data).filter(I=>this._agentIsEnabled(I.id))}getActivatedAgents(){return Array.from(this._agents.values()).filter(I=>!!I.impl).filter(I=>this._agentIsEnabled(I.data.id)).map(I=>new i(I.data,I.impl))}getAgentsByName(I){return this.getAgents().filter(_=>_.name===I)}async invokeAgent(I,_,w,p,D){const m=this._agents.get(I);if(!m?.impl)throw new Error(`No activated agent with id "${I}"`);return await m.impl.invoke(_,w,p,D)}async getFollowups(I,_,w,p,D){const m=this._agents.get(I);if(!m?.impl)throw new Error(`No activated agent with id "${I}"`);return m.impl?.provideFollowups?m.impl.provideFollowups(_,w,p,D):[]}};e.ChatAgentService=n,e.ChatAgentService=n=je([$e(0,b.IContextKeyService)],n);class i{constructor(I,_){this.data=I,this.impl=_}get id(){return this.data.id}get name(){return this.data.name??""}get fullName(){return this.data.fullName??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get extensionPublisherId(){return this.data.extensionPublisherId}get extensionPublisherDisplayName(){return this.data.publisherDisplayName}get extensionDisplayName(){return this.data.extensionDisplayName}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get defaultImplicitVariables(){return this.data.defaultImplicitVariables}get locations(){return this.data.locations}async invoke(I,_,w,p){return this.impl.invoke(I,_,w,p)}async provideFollowups(I,_,w,p){return this.impl.provideFollowups?this.impl.provideFollowups(I,_,w,p):[]}provideWelcomeMessage(I,_){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(I,_)}provideSampleQuestions(I,_){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(I,_)}}e.MergedChatAgent=i,e.IChatAgentNameService=(0,C.createDecorator)("chatAgentNameService");let g=class{static{t=this}static{this.StorageKey="chat.participantNameRegistry"}constructor(I,_,w,p){if(this.requestService=_,this.logService=w,this.storageService=p,this.registry=(0,l.observableValue)(this,Object.create(null)),this.disposed=!1,!I.chatParticipantRegistry)return;this.url=I.chatParticipantRegistry;const D=p.get(t.StorageKey,a.StorageScope.APPLICATION);try{this.registry.set(JSON.parse(D??"{}"),void 0)}catch{p.remove(t.StorageKey,a.StorageScope.APPLICATION)}this.refresh()}refresh(){this.disposed||this.update().catch(I=>this.logService.warn("Failed to fetch chat participant registry",I)).then(()=>(0,k.timeout)(5*60*1e3)).then(()=>this.refresh())}async update(){const I=await this.requestService.request({type:"GET",url:this.url},P.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const _=await(0,o.asJson)(I);if(!_||_.version!==1)throw new Error("Unexpected chat participant registry response.");const w=_.restrictedChatParticipants;this.registry.set(w,void 0),this.storageService.store(t.StorageKey,JSON.stringify(w),a.StorageScope.APPLICATION,a.StorageTarget.MACHINE)}getAgentNameRestriction(I){const _=this.checkAgentNameRestriction(I.name,I).get(),w=!I.fullName||this.checkAgentNameRestriction(I.fullName.replace(/\s/g,""),I).get();return _&&w}checkAgentNameRestriction(I,_){return this.registry.map(p=>p[I.toLowerCase()]).map(p=>p?p.some(D=>(0,T.equalsIgnoreCase)(D,D.includes(".")?_.extensionId.value:_.extensionPublisherId)):!0)}dispose(){this.disposed=!0}};e.ChatAgentNameService=g,e.ChatAgentNameService=g=t=je([$e(0,r.IProductService),$e(1,o.IRequestService),$e(2,h.ILogService),$e(3,a.IStorageService)],g);function f(E){return`${E.extensionId.value}.${E.id}`}function u(E){const I="name"in E?E:{...E,name:E.id};return"extensionPublisherId"in I||(I.extensionPublisherId=I.extensionPublisher??""),"extensionDisplayName"in I||(I.extensionDisplayName=""),"extensionId"in I||(I.extensionId=new c.ExtensionIdentifier("")),(0,v.revive)(I)}}),define(De[234],Ie([1,0,2,33,3]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.isIDocumentContext=O,e.isIUsedContext=A;function O(l){return!!l&&typeof l=="object"&&"uri"in l&&l.uri instanceof y.URI&&"version"in l&&typeof l.version=="number"&&"ranges"in l&&Array.isArray(l.ranges)&&l.ranges.every(k.Range.isIRange)}function A(l){return!!l&&typeof l=="object"&&"documents"in l&&Array.isArray(l.documents)&&l.documents.every(O)}var R;(function(l){l[l.Down=0]="Down",l[l.Up=1]="Up"})(R||(e.ChatAgentVoteDirection=R={}));var v;(function(l){l[l.Action=1]="Action",l[l.Toolbar=2]="Toolbar"})(v||(e.ChatCopyKind=v={})),e.IChatService=(0,P.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(De[235],Ie([1,0,4,11,196]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class O{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new y.Emitter,this._onExit=new y.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(R){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=R}onEvent(R){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=R}onRequest(R){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=R}sendResponse(R){R.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.internalSend("response",R)}sendRequest(R,v,l,T){const b={command:R};if(v&&Object.keys(v).length>0&&(b.arguments=v),this.internalSend("request",b),typeof T=="number"){const c=setTimeout(()=>{clearTimeout(c);const C=this.pendingRequests.get(b.seq);if(C){this.pendingRequests.delete(b.seq);const h={type:"response",seq:0,request_seq:b.seq,success:!1,command:R,message:(0,P.localize)(0,null,T,R)};C(h)}},T)}return l&&this.pendingRequests.set(b.seq,l),b.seq}acceptMessage(R){this.messageCallback?this.messageCallback(R):(this.queue.push(R),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(R,v){return R.type!=="event"||v.type!=="event"}async processQueue(){let R;for(;this.queue.length;){if((!R||this.needsTaskBoundaryBetween(this.queue[0],R))&&await(0,k.timeout)(0),R=this.queue.shift(),!R)return;switch(R.type){case"event":this.eventCallback?.(R);break;case"request":this.requestCallback?.(R);break;case"response":{const v=R,l=this.pendingRequests.get(v.request_seq);l&&(this.pendingRequests.delete(v.request_seq),l(v));break}}}}internalSend(R,v){v.type=R,v.seq=this.sequence++,this.sendMessage(v)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const R=new Map;this.pendingRequests.forEach((v,l)=>R.set(l,v)),await(0,k.timeout)(500),R.forEach((v,l)=>{v({type:"response",seq:0,request_seq:l,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(l)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=O}),define(De[81],Ie([1,0,2,197,32,3]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=v,e.isFrameDeemphasized=T,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new P.RawContextKey("debugType",void 0,{type:"string",description:k.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new P.RawContextKey("debugConfigurationType",void 0,{type:"string",description:k.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new P.RawContextKey("debugState","inactive",{type:"string",description:k.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new P.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:k.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new P.RawContextKey("hasDebugged",!1,{type:"boolean",description:k.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new P.RawContextKey("inDebugMode",!1,{type:"boolean",description:k.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new P.RawContextKey("inDebugRepl",!1,{type:"boolean",description:k.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new P.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:k.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new P.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:k.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new P.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:k.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new P.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:k.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new P.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:k.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new P.RawContextKey("variablesFocused",!0,{type:"boolean",description:k.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new P.RawContextKey("expressionSelected",!1,{type:"boolean",description:k.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new P.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:k.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new P.RawContextKey("callStackItemType",void 0,{type:"string",description:k.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new P.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:k.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new P.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:k.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new P.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:k.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new P.RawContextKey("watchItemType",void 0,{type:"string",description:k.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new P.RawContextKey("canViewMemory",void 0,{type:"boolean",description:k.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new P.RawContextKey("breakpointItemType",void 0,{type:"string",description:k.localize(21,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new P.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:k.localize(22,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new P.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:k.localize(23,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new P.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:k.localize(24,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new P.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:k.localize(25,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new P.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:k.localize(26,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new P.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:k.localize(27,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new P.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:k.localize(28,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new P.RawContextKey("stepBackSupported",!1,{type:"boolean",description:k.localize(29,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new P.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:k.localize(30,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new P.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:k.localize(31,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new P.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:k.localize(32,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new P.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:k.localize(33,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new P.RawContextKey("breakpointsExist",!1,{type:"boolean",description:k.localize(34,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new P.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:k.localize(35,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new P.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:k.localize(36,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new P.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:k.localize(37,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new P.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:k.localize(38,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new P.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:k.localize(39,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new P.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:k.localize(40,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new P.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:k.localize(41,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new P.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:k.localize(42,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new P.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:k.localize(43,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new P.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:k.localize(44,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new P.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:k.localize(45,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new P.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:k.localize(46,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new P.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:k.localize(47,null)}),e.CONTEXT_VARIABLE_VALUE=new P.RawContextKey("variableValue",!1,{type:"string",description:k.localize(48,null)}),e.CONTEXT_VARIABLE_TYPE=new P.RawContextKey("variableType",!1,{type:"string",description:k.localize(49,null)}),e.CONTEXT_VARIABLE_INTERFACES=new P.RawContextKey("variableInterfaces",!1,{type:"array",description:k.localize(50,null)}),e.CONTEXT_VARIABLE_NAME=new P.RawContextKey("variableName",!1,{type:"string",description:k.localize(51,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new P.RawContextKey("variableLanguage",!1,{type:"string",description:k.localize(52,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new P.RawContextKey("variableExtensionId",!1,{type:"string",description:k.localize(53,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new P.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:k.localize(54,null)}),e.CONTEXT_MULTI_SESSION_REPL=new P.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:k.localize(55,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new P.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:k.localize(56,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new P.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:k.localize(57,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new P.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:k.localize(58,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new P.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:k.localize(59,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new P.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:k.localize(60,null)});const A=t=>k.localize(61,null,t);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:k.localize(62,null)};var R;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(R||(e.State=R={}));function v(t){switch(t){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var l;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(l||(e.MemoryRangeType=l={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";function T(t){return t.source.presentationHint==="deemphasize"||t.presentationHint==="deemphasize"||t.presentationHint==="subtle"}var b;(function(t){t[t.Variable=0]="Variable",t[t.Address=1]="Address"})(b||(e.DataBreakpointSetType=b={}));var c;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(c||(e.DebugConfigurationProviderTriggerKind=c={}));var C;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.IDebugService=(0,O.createDecorator)("debugService");var h;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(h||(e.BreakpointWidgetContext=h={}));var r;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var a;(function(t){t.deserialize=s=>s,t.serialize=s=>s})(a||(e.IDebugVisualizationTreeItem=a={}));var d;(function(t){t.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:y.URI.revive(s.iconPath.light),dark:y.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),t.serialize=s=>s})(d||(e.IDebugVisualization=d={}))}),define(De[236],Ie([1,0,13,2,20,26,16,33,22,18]),function(he,e,y,k,P,O,A,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=b,e.filterExceptionsFromTelemetry=c,e.isSessionAttach=C,e.getExtensionHostDebugSession=h,e.isDebuggerMainContribution=r,e.getExactExpressionStartAndEnd=o,e.getEvaluatableExpressionAtPosition=a,e.isUri=t,e.convertToDAPaths=i,e.convertToVSCPaths=g,e.getVisibleAndSorted=u,e.saveAllBeforeDebugStart=I;const T=/{([^}]+)}/g;function b(w,p,D){return w.replace(T,function(m,S){return p&&S.length>0&&S[0]!=="_"?m:D&&D.hasOwnProperty(S)?D[S]:m})}function c(w){const p={};for(const D of Object.keys(w))D.startsWith("!")||(p[D]=w[D]);return p}function C(w){return w.configuration.request==="attach"&&!h(w)&&(!w.parentSession||C(w.parentSession))}function h(w){let p=w.configuration.type;if(p)return p==="vslsShare"&&(p=w.configuration.adapterProxy.configuration.type),(0,y.equalsIgnoreCase)(p,"extensionhost")||(0,y.equalsIgnoreCase)(p,"pwa-extensionhost")?w:w.parentSession?h(w.parentSession):void 0}function r(w){return w.type&&(w.label||w.program||w.runtime)}function o(w,p,D){let m,S=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let L=null;for(;L=M.exec(w);){const H=L.index+1,V=H+L[0].length;if(H<=p&&V>=D){m=L[0],S=H;break}}if(m){const H=/\w+/g;let V=null;for(;(V=H.exec(m))&&!(V.index+1+S+V[0].length>=D););V&&(m=m.substring(0,H.lastIndex))}return m?{start:S,end:S+m.length-1}:{start:0,end:0}}async function a(w,p,D,m){if(w.evaluatableExpressionProvider.has(p)){const S=w.evaluatableExpressionProvider.ordered(p),M=(0,l.coalesce)(await Promise.all(S.map(async L=>{try{return await L.provideEvaluatableExpression(p,D,m??v.CancellationToken.None)}catch{return}})));if(M.length>0){let L=M[0].expression;const H=M[0].range;return L||(L=p.getLineContent(D.lineNumber).substring(H.startColumn-1,H.endColumn-1)),{range:H,matchingExpression:L}}}else{const S=p.getLineContent(D.lineNumber),{start:M,end:L}=o(S,D.column,D.column),H=S.substring(M-1,L);return{matchingExpression:H,range:new R.Range(D.lineNumber,M,D.lineNumber,M+H.length)}}return null}const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(w){return!!(w&&w.match(d))}function s(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(t(w.path))return k.URI.parse(w.path);if((0,P.isAbsolute)(w.path))return k.URI.file(w.path)}return w.path}function n(w){if(typeof w.path=="object"){const p=k.URI.revive(w.path);if(p)return p.scheme===A.Schemas.file?p.fsPath:p.toString()}return w.path}function i(w,p){const D=p?s:n,m=(0,O.deepClone)(w);return f(m,(S,M)=>{S&&M&&(M.path=D(M))}),m}function g(w,p){const D=p?s:n,m=(0,O.deepClone)(w);return f(m,(S,M)=>{!S&&M&&(M.path=D(M))}),m}function f(w,p){switch(w.type){case"event":{const D=w;switch(D.event){case"output":p(!1,D.body.source);break;case"loadedSource":p(!1,D.body.source);break;case"breakpoint":p(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=w;switch(D.command){case"setBreakpoints":p(!0,D.arguments.source);break;case"breakpointLocations":p(!0,D.arguments.source);break;case"source":p(!0,D.arguments.source);break;case"gotoTargets":p(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(m=>p(!1,m));break;default:break}break}case"response":{const D=w;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(m=>p(!1,m.source));break;case"loadedSources":D.body.sources.forEach(m=>p(!1,m));break;case"scopes":D.body.scopes.forEach(m=>p(!1,m.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(m=>p(!1,m.source));break;case"setBreakpoints":D.body.breakpoints.forEach(m=>p(!1,m.source));break;case"disassemble":D.body?.instructions.forEach(S=>p(!1,S.location));break;default:break}break}}}function u(w){return w.filter(p=>!p.presentation?.hidden).sort((p,D)=>p.presentation?D.presentation?p.presentation.group?D.presentation.group?p.presentation.group!==D.presentation.group?p.presentation.group.localeCompare(D.presentation.group):E(p.presentation.order,D.presentation.order):-1:D.presentation.group?1:E(p.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function E(w,p){return typeof w!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:w-p}async function I(w,p){const D=w.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(D!=="none"&&(await p.saveAll(),D==="allEditorsInActiveGroup")){const m=p.activeEditorPane;m&&m.input.resource?.scheme===A.Schemas.untitled&&await p.save({editor:m.input,groupId:m.group.id})}await w.reloadConfiguration()}const _=(w,p)=>!w||!p?w===p:w.name===p.name&&w.path===p.path&&w.sourceReference===p.sourceReference;e.sourcesEqual=_}),define(De[237],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(k||(e.CellExecutionUpdateType=k={})),e.INotebookExecutionService=(0,y.createDecorator)("INotebookExecutionService")}),define(De[238],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var k;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(k||(e.ProxyKernelState=k={})),e.INotebookKernelService=(0,y.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,y.createDecorator)("INotebookKernelHistoryService")}),define(De[239],Ie([1,0,6,33,52,165,101]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class R extends y.Disposable{constructor(l,T,b){super(),this._source=l,this._inputTextBuffer=T,this._outputs=b,this._outputTextBuffers=void 0}_getFullModelRange(l){const T=l.getLineCount();return new k.Range(1,1,T,this._getLineMaxColumn(l,T))}_getLineMaxColumn(l,T){if(T<1||T>l.getLineCount())throw new Error("Illegal value for lineNumber");return l.getLineLength(T)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const l=new O.PieceTreeTextBufferBuilder;l.acceptChunk(this._source);const T=l.finish(!0),{textBuffer:b,disposable:c}=T.create(P.DefaultEndOfLine.LF);this._inputTextBuffer=b,this._register(c)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(l=>{const T=new O.PieceTreeTextBufferBuilder;T.acceptChunk(l);const b=T.finish(!0),{textBuffer:c,disposable:C}=b.create(P.DefaultEndOfLine.LF);return this._register(C),c})),this._outputTextBuffers}findInInputs(l){const b=new A.SearchParams(l,!1,!1,null).parseSearchRequest();if(!b)return[];const c=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(c,b,!0,5e3)}findInOutputs(l){const b=new A.SearchParams(l,!1,!1,null).parseSearchRequest();return b?this.outputTextBuffers.map(c=>{const C=c.findMatchesLineByLine(this._getFullModelRange(c),b,!0,5e3);if(C.length!==0)return{textBuffer:c,matches:C}}).filter(c=>!!c):[]}}e.CellSearchModel=R}),define(De[55],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(O){O.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var k;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(k||(e.TestPosition=k={}));class P{static fromExtHostTestItem(A,R,v=A.parent){if(A._isRoot)return new P([R]);const l=[A.id];for(let T=v;T&&T.id!==R;T=T.parent)l.push(T.id);return l.push(R),new P(l.reverse())}static isRoot(A){return!A.includes(y.Delimiter)}static root(A){const R=A.indexOf(y.Delimiter);return R===-1?A:A.slice(0,R)}static fromString(A){return new P(A.split(y.Delimiter))}static join(A,R){return new P([...A.path,R])}static joinToString(A,R){return A.toString()+y.Delimiter+R}static parentId(A){const R=A.lastIndexOf(y.Delimiter);return R===-1?void 0:A.slice(0,R)}static localId(A){const R=A.lastIndexOf(y.Delimiter);return R===-1?A:A.slice(R+y.Delimiter.length)}static isChild(A,R){return R.startsWith(A)&&R[A.length]===y.Delimiter}static compare(A,R){return A===R?k.IsSame:P.isChild(A,R)?k.IsChild:P.isChild(R,A)?k.IsParent:k.Disconnected}static getLengthOfCommonPrefix(A,R){if(A===0)return 0;let v=0;for(;v<A-1;){for(let l=1;l<A;l++){const T=R(l-1),b=R(l);if(T.path[v]!==b.path[v])return v}v++}return v}constructor(A,R=A.length){if(this.path=A,this.viewEnd=R,A.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.viewEnd>1?new P(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.viewEnd;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let R=0;R<A.viewEnd&&R<this.viewEnd;R++)if(A.path[R]!==this.path[R])return k.Disconnected;return A.viewEnd>this.viewEnd?k.IsChild:A.viewEnd<this.viewEnd?k.IsParent:k.IsSame}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+=y.Delimiter,this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=P}),define(De[56],Ie([1,0,2,100,33,55]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var A;(function($){$[$.Unset=0]="Unset",$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.testResultStateToContextValues={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var R;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var v;(function($){$[$.Run=2]="Run",$[$.Debug=4]="Debug",$[$.Coverage=8]="Coverage",$[$.HasNonDefaultProfile=16]="HasNonDefaultProfile",$[$.HasConfigurable=32]="HasConfigurable",$[$.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.testRunProfileBitsetList=[v.Run,v.Debug,v.Coverage,v.HasNonDefaultProfile,v.HasConfigurable,v.SupportsContinuousRun];const l=$=>"runId"in $;e.isStartControllerTests=l;var T;(function($){$.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),$.deserialize=(N,F)=>({range:P.Range.lift(F.range),uri:N.asCanonicalUri(y.URI.revive(F.uri))})})(T||(e.IRichLocation=T={}));var b;(function($){$[$.Error=0]="Error",$[$.Output=1]="Output"})(b||(e.TestMessageType=b={}));var c;(function($){$.serialize=N=>({message:N.message,type:b.Error,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&T.serialize(N.location)}),$.deserialize=(N,F)=>({message:F.message,type:b.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&T.deserialize(N,F.location)})})(c||(e.ITestErrorMessage=c={}));const C=($,N)=>`${N?"s":"e"}${$}`;e.getMarkId=C;var h;(function($){$.serialize=N=>({message:N.message,type:b.Output,offset:N.offset,length:N.length,location:N.location&&T.serialize(N.location)}),$.deserialize=(N,F)=>({message:F.message,type:b.Output,offset:F.offset,length:F.length,location:F.location&&T.deserialize(N,F.location)})})(h||(e.ITestOutputMessage=h={}));var r;(function($){$.serialize=N=>N.type===b.Error?c.serialize(N):h.serialize(N),$.deserialize=(N,F)=>F.type===b.Error?c.deserialize(N,F):h.deserialize(N,F)})(r||(e.ITestMessage=r={}));var o;(function($){$.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),$.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(r.serialize)}),$.deserialize=(N,F)=>({state:F.state,duration:F.duration,messages:F.messages.map(Y=>r.deserialize(N,Y))})})(o||(e.ITestTaskState=o={}));const a="\0",d=($,N)=>$+a+N;e.namespaceTestTag=d;const t=$=>{const N=$.indexOf(a);return{ctrlId:$.slice(0,N),tagId:$.slice(N+1)}};e.denamespaceTestTag=t;var s;(function($){$.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),$.deserialize=(N,F)=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?N.asCanonicalUri(y.URI.revive(F.uri)):void 0,range:F.range?P.Range.lift(F.range):null,description:F.description,error:F.error,sortText:F.sortText})})(s||(e.ITestItem=s={}));var n;(function($){$[$.NotExpandable=0]="NotExpandable",$[$.Expandable=1]="Expandable",$[$.BusyExpanding=2]="BusyExpanding",$[$.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var i;(function($){$.serialize=N=>({expand:N.expand,item:s.serialize(N.item)}),$.deserialize=(N,F)=>({controllerId:O.TestId.root(F.item.extId),expand:F.expand,item:s.deserialize(N,F.item)})})(i||(e.InternalTestItem=i={}));var g;(function($){$.serialize=N=>{let F;return N.item&&(F={},N.item.label!==void 0&&(F.label=N.item.label),N.item.tags!==void 0&&(F.tags=N.item.tags),N.item.busy!==void 0&&(F.busy=N.item.busy),N.item.uri!==void 0&&(F.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(F.range=N.item.range?.toJSON()),N.item.description!==void 0&&(F.description=N.item.description),N.item.error!==void 0&&(F.error=N.item.error),N.item.sortText!==void 0&&(F.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:F}},$.deserialize=N=>{let F;return N.item&&(F={},N.item.label!==void 0&&(F.label=N.item.label),N.item.tags!==void 0&&(F.tags=N.item.tags),N.item.busy!==void 0&&(F.busy=N.item.busy),N.item.range!==void 0&&(F.range=N.item.range?P.Range.lift(N.item.range):null),N.item.description!==void 0&&(F.description=N.item.description),N.item.error!==void 0&&(F.error=N.item.error),N.item.sortText!==void 0&&(F.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:F}}})(g||(e.ITestItemUpdate=g={}));const f=($,N)=>{N.expand!==void 0&&($.expand=N.expand),N.item!==void 0&&($.item=$.item?Object.assign($.item,N.item):N.item)};e.applyTestItemUpdate=f;var u;(function($){$.serializeWithoutMessages=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(o.serializeWithoutMessages)}),$.serialize=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(o.serialize)}),$.deserialize=(N,F)=>({...i.deserialize(N,F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(Y=>o.deserialize(N,Y)),retired:!0})})(u||(e.TestResultItem=u={}));var E;(function($){$.empty=()=>({covered:0,total:0}),$.sum=(N,F)=>{N.covered+=F.covered,N.total+=F.total}})(E||(e.ICoverageCount=E={}));var I;(function($){$.serialize=N=>({id:N.id,statement:N.statement,branch:N.branch,declaration:N.declaration,testId:N.testId?.toString(),uri:N.uri.toJSON()}),$.deserialize=(N,F)=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testId:F.testId?O.TestId.fromString(F.testId):void 0,uri:N.asCanonicalUri(y.URI.revive(F.uri))}),$.empty=(N,F)=>({id:N,uri:F,testId:void 0,statement:E.empty()})})(I||(e.IFileCoverage=I={}));function _($){return{...$,location:$.location?.toJSON()}}function w($){return $.location=$.location?k.Position.isIPosition($.location)?k.Position.lift($.location):P.Range.lift($.location):void 0,$}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var p;(function($){$[$.Declaration=0]="Declaration",$[$.Statement=1]="Statement",$[$.Branch=2]="Branch"})(p||(e.DetailType=p={}));var D;(function($){$.serialize=N=>N.type===p.Declaration?S.serialize(N):M.serialize(N),$.deserialize=N=>N.type===p.Declaration?S.deserialize(N):M.deserialize(N)})(D||(e.CoverageDetails=D={}));var m;(function($){$.serialize=_,$.deserialize=w})(m||(e.IBranchCoverage=m={}));var S;(function($){$.serialize=_,$.deserialize=w})(S||(e.IDeclarationCoverage=S={}));var M;(function($){$.serialize=N=>({..._(N),branches:N.branches?.map(m.serialize)}),$.deserialize=N=>({...w(N),branches:N.branches?.map(m.deserialize)})})(M||(e.IStatementCoverage=M={}));var L;(function($){$[$.Add=0]="Add",$[$.Update=1]="Update",$[$.DocumentSynced=2]="DocumentSynced",$[$.Remove=3]="Remove",$[$.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",$[$.Retire=5]="Retire",$[$.AddTag=6]="AddTag",$[$.RemoveTag=7]="RemoveTag"})(L||(e.TestDiffOpType=L={}));var H;(function($){$.deserialize=(N,F)=>F.op===L.Add?{op:F.op,item:i.deserialize(N,F.item)}:F.op===L.Update?{op:F.op,item:g.deserialize(F.item)}:F.op===L.DocumentSynced?{op:F.op,uri:N.asCanonicalUri(y.URI.revive(F.uri)),docv:F.docv}:F,$.serialize=N=>N.op===L.Add?{op:N.op,item:i.serialize(N.item)}:N.op===L.Update?{op:N.op,item:g.serialize(N.item)}:N})(H||(e.TestsDiffOp=H={}));class V{constructor(N){this.uriIdentity=N,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(N){const F=this.createChangeCollector();for(const Y of N)switch(Y.op){case L.Add:this.add(i.deserialize(this.uriIdentity,Y.item),F);break;case L.Update:this.update(g.deserialize(Y.item),F);break;case L.Remove:this.remove(Y.itemId,F);break;case L.Retire:this.retireTest(Y.itemId);break;case L.IncrementPendingExtHosts:this.updatePendingRoots(Y.amount);break;case L.AddTag:this._tags.set(Y.tag.id,Y.tag);break;case L.RemoveTag:this._tags.delete(Y.id);break}F.complete?.()}add(N,F){const Y=O.TestId.parentId(N.item.extId)?.toString();let re;if(!Y)re=this.createItem(N),this.roots.add(re),this.items.set(N.item.extId,re);else if(this.items.has(Y)){const fe=this.items.get(Y);fe.children.add(N.item.extId),re=this.createItem(N,fe),this.items.set(N.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return F.add?.(re),N.expand===n.BusyExpanding&&this.busyControllerCount++,re}update(N,F){const Y=this.items.get(N.extId);if(Y)return N.expand!==void 0&&(Y.expand===n.BusyExpanding&&this.busyControllerCount--,N.expand===n.BusyExpanding&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(Y,N),F.update?.(Y),Y}remove(N,F){const Y=this.items.get(N);if(!Y)return;const re=O.TestId.parentId(Y.item.extId)?.toString();re?this.items.get(re).children.delete(Y.item.extId):this.roots.delete(Y);const fe=[[N]];for(;fe.length;)for(const Ee of fe.pop()){const oe=this.items.get(Ee);oe&&(fe.push(oe.children),this.items.delete(Ee),F.remove?.(oe,oe!==Y),oe.expand===n.BusyExpanding&&this.busyControllerCount--)}}retireTest(N){}updatePendingRoots(N){this.pendingRootCount+=N}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=V}),define(De[240],Ie([1,0,98,200,56]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.testConfigurationGroupNames=e.labelForTestInState=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(b){b.ViewletId="workbench.view.extension.test",b.ExplorerViewId="workbench.view.testing",b.OutputPeekContributionId="editor.contrib.testingOutputPeek",b.DecorationsContributionId="editor.contrib.testingDecorations",b.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",b.CoverageViewId="workbench.view.testCoverage",b.ResultsPanelId="workbench.panel.testResults",b.ResultsViewId="workbench.panel.testResults.view",b.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(b){b.List="list",b.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var R;(function(b){b.ByLocation="location",b.ByStatus="status",b.ByDuration="duration"})(R||(e.TestExplorerViewSorting=R={}));const v={[P.TestResultState.Errored]:(0,k.localize)(0,null),[P.TestResultState.Failed]:(0,k.localize)(1,null),[P.TestResultState.Passed]:(0,k.localize)(2,null),[P.TestResultState.Queued]:(0,k.localize)(3,null),[P.TestResultState.Running]:(0,k.localize)(4,null),[P.TestResultState.Skipped]:(0,k.localize)(5,null),[P.TestResultState.Unset]:(0,k.localize)(6,null)},l=(b,c)=>(0,k.localize)(7,null,(0,y.stripIcons)(b),v[c]);e.labelForTestInState=l,e.testConfigurationGroupNames={[P.TestRunProfileBitset.Debug]:(0,k.localize)(8,null),[P.TestRunProfileBitset.Run]:(0,k.localize)(9,null),[P.TestRunProfileBitset.Coverage]:(0,k.localize)(10,null)};var T;(function(b){b.CancelTestRefreshAction="testing.cancelTestRefresh",b.CancelTestRunAction="testing.cancelRun",b.ClearTestResultsAction="testing.clearTestResults",b.CollapseAllAction="testing.collapseAll",b.ConfigureTestProfilesAction="testing.configureProfile",b.ContinousRunUsingForTest="testing.continuousRunUsingForTest",b.CoverageAtCursor="testing.coverageAtCursor",b.CoverageByUri="testing.coverage.uri",b.CoverageClear="testing.coverage.close",b.CoverageCurrentFile="testing.coverageCurrentFile",b.CoverageFilterToTest="testing.coverageFilterToTest",b.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",b.CoverageLastRun="testing.coverageLastRun",b.CoverageSelectedAction="testing.coverageSelected",b.CoverageToggleToolbar="testing.coverageToggleToolbar",b.CoverageViewChangeSorting="testing.coverageViewChangeSorting",b.DebugAction="testing.debug",b.DebugAllAction="testing.debugAll",b.DebugAtCursor="testing.debugAtCursor",b.DebugByUri="testing.debug.uri",b.DebugCurrentFile="testing.debugCurrentFile",b.DebugFailedTests="testing.debugFailTests",b.DebugLastRun="testing.debugLastRun",b.DebugSelectedAction="testing.debugSelected",b.FilterAction="workbench.actions.treeView.testExplorer.filter",b.GetExplorerSelection="_testing.getExplorerSelection",b.GetSelectedProfiles="testing.getSelectedProfiles",b.GoToTest="testing.editFocusedTest",b.HideTestAction="testing.hideTest",b.OpenCoverage="testing.openCoverage",b.OpenOutputPeek="testing.openOutputPeek",b.RefreshTestsAction="testing.refreshTests",b.ReRunFailedTests="testing.reRunFailTests",b.ReRunLastRun="testing.reRunLastRun",b.RunAction="testing.run",b.RunAllAction="testing.runAll",b.RunAllWithCoverageAction="testing.coverageAll",b.RunAtCursor="testing.runAtCursor",b.RunByUri="testing.run.uri",b.RunCurrentFile="testing.runCurrentFile",b.RunSelectedAction="testing.runSelected",b.RunUsingProfileAction="testing.runUsing",b.RunWithCoverageAction="testing.coverage",b.SearchForTestExtension="testing.searchForTestExtension",b.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",b.ShowMostRecentOutputAction="testing.showMostRecentOutput",b.StartContinousRun="testing.startContinuousRun",b.StopContinousRun="testing.stopContinuousRun",b.TestingSortByDurationAction="testing.sortByDuration",b.TestingSortByLocationAction="testing.sortByLocation",b.TestingSortByStatusAction="testing.sortByStatus",b.TestingViewAsListAction="testing.viewAsList",b.TestingViewAsTreeAction="testing.viewAsTree",b.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",b.ToggleInlineTestOutput="testing.toggleInlineTestOutput",b.UnhideAllTestsAction="testing.unhideAllTests",b.UnhideTestAction="testing.unhideTest"})(T||(e.TestCommandId=T={}))}),define(De[82],Ie([1,0,11,4,6,61,56,55]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const l=(d,t)=>d===t,b=Object.entries({range:(d,t)=>d===t?!0:!d||!t?!1:d.equalsRange(t),busy:l,label:l,description:l,error:l,sortText:l,tags:(d,t)=>!(d.length!==t.length||d.some(s=>!t.includes(s)))}),c=(d,t)=>{let s;for(const[n,i]of b)i(d[n],t[n])||(s?s[n]=t[n]:s={[n]:t[n]});return s};class C extends P.Disposable{get root(){return this.options.root}constructor(t){super(),this.options=t,this.debounceSendDiff=this._register(new y.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new k.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(t){this._resolveHandler=t;for(const s of this.tree.values())this.updateExpandability(s)}get resolveHandler(){return this._resolveHandler}collectDiff(){const t=this.diff;return this.diff=[],t}pushDiff(t){switch(t.op){case A.TestDiffOpType.DocumentSynced:{for(const s of this.diff)if(s.op===A.TestDiffOpType.DocumentSynced&&s.uri===t.uri){s.docv=t.docv;return}break}case A.TestDiffOpType.Update:{const s=this.diff[this.diff.length-1];if(s){if(s.op===A.TestDiffOpType.Update&&s.item.extId===t.item.extId){(0,A.applyTestItemUpdate)(s.item,t.item);return}if(s.op===A.TestDiffOpType.Add&&s.item.item.extId===t.item.extId){(0,A.applyTestItemUpdate)(s.item,t.item);return}}break}}this.diff.push(t),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(t,s){const n=this.tree.get(t);if(n){if((n.expandLevels===void 0||s>n.expandLevels)&&(n.expandLevels=s),n.expand===A.TestItemExpandState.Expandable){const i=this.resolveChildren(n);return i.isOpen()?this.expandChildren(n,s-1):i.wait().then(()=>this.expandChildren(n,s-1))}else if(n.expand===A.TestItemExpandState.Expanded)return n.resolveBarrier?.isOpen()===!1?n.resolveBarrier.wait().then(()=>this.expandChildren(n,s-1)):this.expandChildren(n,s-1)}}dispose(){for(const t of this.tree.values())this.options.getApiFor(t.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(t,s){switch(s.op){case v.RemoveChild:this.removeItem(R.TestId.joinToString(t.fullId,s.id));break;case v.Upsert:this.upsertItem(s.item,t);break;case v.Bulk:for(const n of s.ops)this.onTestItemEvent(t,n);break;case v.SetTags:this.diffTagRefs(s.new,s.old,t.fullId.toString());break;case v.UpdateCanResolveChildren:this.updateExpandability(t);break;case v.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),item:s.update}});break;case v.DocumentSynced:this.documentSynced(t.actual.uri);break;default:(0,O.assertNever)(s)}}documentSynced(t){t&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:t,docv:this.options.getDocumentVersion(t)})}upsertItem(t,s){const n=R.TestId.fromExtHostTestItem(t,this.root.id,s?.actual),i=this.options.getApiFor(t);i.parent&&i.parent!==s?.actual&&this.options.getChildren(i.parent).delete(t.id);let g=this.tree.get(n.toString());if(!g){g={fullId:n,actual:t,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},t.tags.forEach(this.incrementTagRefs,this),this.tree.set(g.fullId.toString(),g),this.setItemParent(t,s),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.options.controllerId,expand:g.expand,item:this.options.toITestItem(t)}}),this.connectItemAndChildren(t,g,s);return}if(g.actual===t){this.connectItem(t,g,s);return}if(g.actual.uri?.toString()!==t.uri?.toString())return this.removeItem(n.toString()),this.upsertItem(t,s);const f=this.options.getChildren(g.actual),u=g.actual,E=c(this.options.toITestItem(u),this.options.toITestItem(t));this.options.getApiFor(u).listener=void 0,g.actual=t,g.resolveBarrier=void 0,g.expand=A.TestItemExpandState.NotExpandable,E&&(E.hasOwnProperty("tags")&&(this.diffTagRefs(t.tags,u.tags,n.toString()),delete E.tags),this.onTestItemEvent(g,{op:v.SetProp,update:E})),this.connectItemAndChildren(t,g,s);for(const[_,w]of f)this.options.getChildren(t).get(w.id)||this.removeItem(R.TestId.joinToString(n,w.id));const I=g.expandLevels;I!==void 0&&queueMicrotask(()=>{g.expand===A.TestItemExpandState.Expandable&&(g.expandLevels=void 0,this.expand(n.toString(),I))}),this.documentSynced(g.actual.uri)}diffTagRefs(t,s,n){const i=new Set(s.map(g=>g.id));for(const g of t)i.delete(g.id)||this.incrementTagRefs(g);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:n,item:{tags:t.map(g=>(0,A.namespaceTestTag)(this.options.controllerId,g.id))}}}),i.forEach(this.decrementTagRefs,this)}incrementTagRefs(t){const s=this.tags.get(t.id);s?s.refCount++:(this.tags.set(t.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.namespaceTestTag)(this.options.controllerId,t.id)}}))}decrementTagRefs(t){const s=this.tags.get(t);s&&!--s.refCount&&(this.tags.delete(t),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.namespaceTestTag)(this.options.controllerId,t)}))}setItemParent(t,s){this.options.getApiFor(t).parent=s&&s.actual!==this.root?s.actual:void 0}connectItem(t,s,n){this.setItemParent(t,n);const i=this.options.getApiFor(t);i.parent=n?.actual,i.listener=g=>this.onTestItemEvent(s,g),this.updateExpandability(s)}connectItemAndChildren(t,s,n){this.connectItem(t,s,n);for(const[i,g]of this.options.getChildren(t))this.upsertItem(g,s)}updateExpandability(t){let s;this._resolveHandler?t.resolveBarrier?s=t.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:s=t.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:s=A.TestItemExpandState.NotExpandable,s!==t.expand&&(t.expand=s,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),expand:s}}),s===A.TestItemExpandState.Expandable&&t.expandLevels!==void 0&&this.resolveChildren(t))}expandChildren(t,s){if(s<0)return;const n=[];for(const[i,g]of this.options.getChildren(t.actual)){const f=this.expand(R.TestId.joinToString(t.fullId,g.id),s);(0,y.isThenable)(f)&&n.push(f)}if(n.length)return Promise.all(n).then(()=>{})}resolveChildren(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this._resolveHandler){const g=new y.Barrier;return g.open(),g}t.expand=A.TestItemExpandState.BusyExpanding,this.pushExpandStateUpdate(t);const s=t.resolveBarrier=new y.Barrier,n=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,g)};let i;try{i=this._resolveHandler(t.actual===this.root?void 0:t.actual)}catch(g){n(g)}return(0,y.isThenable)(i)?i.catch(n).then(()=>{s.open(),this.updateExpandability(t)}):(s.open(),this.updateExpandability(t)),t.resolveBarrier}pushExpandStateUpdate(t){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),expand:t.expand}})}removeItem(t){const s=this.tree.get(t);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:t});const n=[s];for(;n.length;){const i=n.pop();if(i){this.options.getApiFor(i.actual).listener=void 0;for(const g of i.actual.tags)this.decrementTagRefs(g.id);this.tree.delete(i.fullId.toString());for(const[g,f]of this.options.getChildren(i.actual))n.push(this.tree.get(R.TestId.joinToString(i.fullId,f.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.diffOpEmitter.fire(t)}}e.TestItemCollection=C;class h extends Error{constructor(t){super(`Attempted to insert a duplicate test item ID ${t}`)}}e.DuplicateTestItemError=h;class r extends Error{constructor(t){super(`TestItem with ID "${t}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=r;class o extends Error{constructor(t,s,n){super(`TestItem with ID "${t}" is from controller "${s}" and cannot be added as a child of an item from controller "${n}".`)}}e.MixedTestItemController=o;const a=(d,t,s)=>{let n=new Map;return{get size(){return n.size},forEach(i,g){for(const f of n.values())i.call(g,f,this)},[Symbol.iterator](){return n.entries()},replace(i){const g=new Map,f=new Set(n.keys()),u={op:v.Bulk,ops:[]};for(const E of i){if(!(E instanceof s))throw new r(E.id);const I=t(E).controllerId;if(I!==d.controllerId)throw new o(E.id,I,d.controllerId);if(g.has(E.id))throw new h(E.id);g.set(E.id,E),f.delete(E.id),u.ops.push({op:v.Upsert,item:E})}for(const E of f.keys())u.ops.push({op:v.RemoveChild,id:E});d.listener?.(u),n=g},add(i){if(!(i instanceof s))throw new r(i.id);n.set(i.id,i),d.listener?.({op:v.Upsert,item:i})},delete(i){n.delete(i)&&d.listener?.({op:v.RemoveChild,id:i})},get(i){return n.get(i)},toJSON(){return Array.from(n.values())}}};e.createTestItemChildren=a}),define(De[114],Ie([1,0,82]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const k=new WeakMap,P=(A,R)=>{const v={controllerId:R};return k.set(A,v),v};e.createPrivateApiFor=P;const O=A=>{const R=k.get(A);if(!R)throw new y.InvalidTestItemError(A?.id||"<unknown>");return R};e.getPrivateApiFor=O}),define(De[83],Ie([1,0,28,16,2]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=O,e.decodeAuthority=R,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function O(v,l){return v.scheme===k.Schemas.http||v.scheme===k.Schemas.https?v:(l&&l.authority&&l.isRemote&&v.scheme===k.Schemas.file&&(v=P.URI.from({scheme:k.Schemas.vscodeRemote,authority:l.authority,path:v.path})),P.URI.from({scheme:k.Schemas.https,authority:`${v.scheme}+${A(v.authority)}.${e.webviewRootResourceAuthority}`,path:v.path,fragment:v.fragment,query:v.query}))}function A(v){return v.replace(/./g,l=>{const T=l.charCodeAt(0);return T>=y.CharCode.a&&T<=y.CharCode.z||T>=y.CharCode.A&&T<=y.CharCode.Z||T>=y.CharCode.Digit0&&T<=y.CharCode.Digit9?l:"-"+T.toString(16).padStart(4,"0")})}function R(v){return v.replace(/-([0-9a-f]{4})/g,(l,T)=>String.fromCharCode(parseInt(T,16)))}}),define(De[241],Ie([1,0,4,6,83]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class O{constructor(R,v,l){this._proxy=R,this._editors=v,this._remoteInfo=l,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(v.onDidChangeVisibleTextEditors(()=>{const T=v.getVisibleTextEditors();for(const b of this._insets.values())T.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(R=>R.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(R,v,l,T,b){let c;for(const t of this._editors.getVisibleTextEditors(!0))if(t.value===R){c=t;break}if(!c)throw new Error("not a visible editor");const C=this,h=this._handlePool++,r=new y.Emitter,o=new y.Emitter,a=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(t){return(0,P.asWebviewUri)(t,C._remoteInfo)}get cspSource(){return P.webviewGenericCspSource}set options(t){this._options=t,C._proxy.$setOptions(h,t)}get options(){return this._options}set html(t){this._html=t,C._proxy.$setHtml(h,t)}get html(){return this._html}get onDidReceiveMessage(){return r.event}postMessage(t){return C._proxy.$postMessage(h,t)}},d=new class{constructor(){this.editor=R,this.line=v,this.height=l,this.webview=a,this.onDidDispose=o.event}dispose(){C._insets.has(h)&&(C._insets.delete(h),C._proxy.$disposeEditorInset(h),o.fire(),o.dispose(),r.dispose())}};return this._proxy.$createEditorInset(h,c.id,c.value.document.uri,v+1,l,T||{},b.identifier,b.extensionLocation),this._insets.set(h,{editor:R,inset:d,onDidReceiveMessage:r}),d}$onDidDispose(R){const v=this._insets.get(R);v&&v.inset.dispose()}$onDidReceiveMessage(R,v){this._insets.get(R)?.onDidReceiveMessage.fire(v)}}e.ExtHostEditorInsets=O}),define(De[115],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,y.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,y.createDecorator)("IAuthenticationExtensionsService")}),define(De[242],Ie([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,y.createDecorator)("configurationResolverService");var k;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(k||(e.VariableKind=k={}));class P extends Error{constructor(A,R){super(R),this.variable=A}}e.VariableError=P}),define(De[243],Ie([1,0,20,79,15,26,21,102,201,242,13]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class b{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(C,h,r,o){this._contributedVariables=new Map,this._context=C,this._labelService=h,this._userHomePromise=r,o&&(this._envVariablesPromise=o.then(a=>this.prepareEnv(a)))}prepareEnv(C){if(A.isWindows){const h=Object.create(null);return Object.keys(C).forEach(r=>{h[r.toLowerCase()]=C[r]}),h}return C}resolveWithEnvironment(C,h,r){return this.recursiveResolve({env:this.prepareEnv(C),userHome:void 0},h?h.uri:void 0,r)}async resolveAsync(C,h){const r={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(r,C?C.uri:void 0,h)}async resolveAnyBase(C,h,r,o){const a=O.deepClone(h);A.isWindows&&a.windows?Object.keys(a.windows).forEach(t=>a[t]=a.windows[t]):A.isMacintosh&&a.osx?Object.keys(a.osx).forEach(t=>a[t]=a.osx[t]):A.isLinux&&a.linux&&Object.keys(a.linux).forEach(t=>a[t]=a.linux[t]),delete a.windows,delete a.osx,delete a.linux;const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,C?C.uri:void 0,a,r,o)}async resolveAnyAsync(C,h,r){return this.resolveAnyBase(C,h,r)}async resolveAnyMap(C,h,r){const o=new Map;return{newConfig:await this.resolveAnyBase(C,h,r,o),resolvedVariables:o}}resolveWithInteractionReplace(C,h,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,h,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,h){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,h)}async recursiveResolve(C,h,r,o,a){if(P.isString(r))return this.resolveString(C,h,r,o,a);if(Array.isArray(r))return Promise.all(r.map(d=>this.recursiveResolve(C,h,d,o,a)));if(P.isObject(r)){const d=Object.create(null),t=await Promise.all(Object.keys(r).map(async s=>[await this.resolveString(C,h,s,o,a),await this.recursiveResolve(C,h,r[s],o,a)]));for(const[s,n]of t)d[s]=n;return d}return r}resolveString(C,h,r,o,a){return(0,T.replaceAsync)(r,b.VARIABLE_REGEXP,async(d,t)=>{if(t.includes(b.VARIABLE_LHS))return d;let s=await this.evaluateSingleVariable(C,d,t,h,o);return a?.set(t,s),s!==d&&P.isString(s)&&s.match(b.VARIABLE_REGEXP)&&(s=await this.resolveString(C,h,s,o,a)),s})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}async evaluateSingleVariable(C,h,r,o,a){let d;const t=r.split(":");t.length>1&&(r=t[0],d=t[1]);const s=g=>{const f=this._context.getFilePath();if(f)return(0,R.normalizeDriveLetter)(f);throw new l.VariableError(g,(0,v.localize)(0,null,h))},n=g=>{const f=s(g);if(this._context.getWorkspaceFolderPathForFile){const u=this._context.getWorkspaceFolderPathForFile();if(u)return(0,R.normalizeDriveLetter)(u)}throw new l.VariableError(g,(0,v.localize)(1,null,h,y.basename(f)))},i=g=>{if(d){const f=this._context.getFolderUri(d);if(f)return f;throw new l.VariableError(g,(0,v.localize)(2,null,h,d))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new l.VariableError(g,(0,v.localize)(3,null,h)):new l.VariableError(g,(0,v.localize)(4,null,h))};switch(r){case"env":if(d){if(C.env){const g=C.env[A.isWindows?d.toLowerCase():d];if(P.isString(g))return g}return""}throw new l.VariableError(l.VariableKind.Env,(0,v.localize)(5,null,h));case"config":if(d){const g=this._context.getConfigurationValue(o,d);if(P.isUndefinedOrNull(g))throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(6,null,h,d));if(P.isObject(g))throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(7,null,h,d));return g}throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(8,null,h));case"command":return this.resolveFromMap(l.VariableKind.Command,h,d,a,"command");case"input":return this.resolveFromMap(l.VariableKind.Input,h,d,a,"input");case"extensionInstallFolder":if(d){const g=await this._context.getExtension(d);if(!g)throw new l.VariableError(l.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,h,d));return this.fsPath(g.extensionLocation)}throw new l.VariableError(l.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,h));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.fsPath(i(l.VariableKind.WorkspaceFolder)));case"cwd":return o||d?(0,R.normalizeDriveLetter)(this.fsPath(i(l.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(y.basename(this.fsPath(i(l.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new l.VariableError(l.VariableKind.UserHome,(0,v.localize)(11,null,h))}case"lineNumber":{const g=this._context.getLineNumber();if(g)return g;throw new l.VariableError(l.VariableKind.LineNumber,(0,v.localize)(12,null,h))}case"selectedText":{const g=this._context.getSelectedText();if(g)return g;throw new l.VariableError(l.VariableKind.SelectedText,(0,v.localize)(13,null,h))}case"file":return s(l.VariableKind.File);case"fileWorkspaceFolder":return n(l.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.basename(n(l.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||d?y.relative(this.fsPath(i(l.VariableKind.RelativeFile)),s(l.VariableKind.RelativeFile)):s(l.VariableKind.RelativeFile);case"relativeFileDirname":{const g=y.dirname(s(l.VariableKind.RelativeFileDirname));if(o||d){const f=y.relative(this.fsPath(i(l.VariableKind.RelativeFileDirname)),g);return f.length===0?".":f}return g}case"fileDirname":return y.dirname(s(l.VariableKind.FileDirname));case"fileExtname":return y.extname(s(l.VariableKind.FileExtname));case"fileBasename":return y.basename(s(l.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=y.basename(s(l.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-y.extname(g).length)}case"fileDirnameBasename":return y.basename(y.dirname(s(l.VariableKind.FileDirnameBasename)));case"execPath":{const g=this._context.getExecPath();return g||h}case"execInstallFolder":{const g=this._context.getAppRoot();return g||h}case"pathSeparator":case"/":return y.sep;default:try{const g=d?`${r}:${d}`:r;return this.resolveFromMap(l.VariableKind.Unknown,h,g,a,void 0)}catch{return h}}}}resolveFromMap(C,h,r,o,a){if(r&&o){const d=a===void 0?o[r]:o[a+":"+r];if(typeof d=="string")return d;throw new l.VariableError(C,(0,v.localize)(14,null,h))}return h}}e.AbstractVariableResolverService=b}),define(De[116],Ie([1,0,3,113]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=l,e.isEditorGroup=c,e.preferredSideBySideGroupDirection=C,e.IEditorGroupsService=(0,y.createDecorator)("editorGroupsService");var P;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var R;(function(h){h[h.MAXIMIZE=0]="MAXIMIZE",h[h.EXPAND=1]="EXPAND",h[h.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var v;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function l(h){const r=h;return(0,k.isEditorInput)(r?.editor)&&(0,k.isEditorInput)(r?.replacement)}var T;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var b;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(b||(e.OpenEditorContext=b={}));function c(h){const r=h;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function C(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(De[244],Ie([1,0,3,116]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=P,e.IEditorService=(0,y.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function P(O){const A=O;return typeof O=="number"||(0,k.isEditorGroup)(A)}}),define(De[245],Ie([1,0,3,105]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,y.refineServiceDecorator)(k.IEnvironmentService)}),define(De[117],Ie([1,0,19,4,20,6,11]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(d,t){this.versionId=d,this.removedDueToLooping=t}}e.DeltaExtensionsResult=R;class v{static isHostExtension(d,t,s){if(t.getExtensionDescription(d))return!1;const n=s.getExtensionDescription(d);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(d,t){this._activationEventsReader=d,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(r),this._extensionsMap=new y.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const d of this._extensionDescriptions){if(this._extensionsMap.has(d.identifier)){console.error("Extension `"+d.identifier.value+"` is already registered");continue}this._extensionsMap.set(d.identifier,d),this._extensionsArr.push(d);const t=this._activationEventsReader.readActivationEvents(d);for(const s of t)this._activationMap.has(s)||this._activationMap.set(s,[]),this._activationMap.get(s).push(d)}}set(d){return this._extensionDescriptions=d,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(d,t){this._extensionDescriptions=o(this._extensionDescriptions,t),this._extensionDescriptions=this._extensionDescriptions.concat(d);const s=v._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=o(this._extensionDescriptions,s.map(n=>n.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new R(this._versionId,s)}static _findLoopingExtensions(d){const t=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,u){this.addNode(f),this.addNode(u),this._arcs.has(f)?this._arcs.get(f).push(u):this._arcs.set(f,[u])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,u){const E=t.getArcs(f);for(let I=0;I<E.length;I++)if(!u.has(E[I]))return!1;return!0}getNodes(){return this._nodesArr}},s=new y.ExtensionIdentifierMap;for(const f of d)if(s.set(f.identifier,f),f.extensionDependencies)for(const u of f.extensionDependencies)t.addArc(y.ExtensionIdentifier.toKey(f.identifier),y.ExtensionIdentifier.toKey(u));const n=new Set;t.getNodes().filter(f=>t.getArcs(f).length===0).forEach(f=>n.add(f));const i=t.getNodes().filter(f=>!n.has(f));let g;do{g=!1;for(let f=0;f<i.length;f++){const u=i[f];t.hasOnlyGoodArcs(u,n)&&(i.splice(f,1),f--,n.add(u),g=!0)}}while(g);return i.map(f=>s.get(f))}containsActivationEvent(d){return this._activationMap.has(d)}containsExtension(d){return this._extensionsMap.has(d)}getExtensionDescriptionsForActivationEvent(d){const t=this._activationMap.get(d);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new l(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(d){const t=this._extensionsMap.get(d);return t||void 0}getExtensionDescriptionByUUID(d){for(const t of this._extensionsArr)if(t.uuid===d)return t}getExtensionDescriptionByIdOrUUID(d,t){return this.getExtensionDescription(d)??(t?this.getExtensionDescriptionByUUID(t):void 0)}}e.ExtensionDescriptionRegistry=v;class l{constructor(d,t){this.versionId=d,this.extensions=t}}e.ExtensionDescriptionRegistrySnapshot=l;class T{constructor(d){this._lock=new C,this._actual=new v(d,[])}async acquireLock(d){const t=await this._lock.acquire(d);return new b(this,t)}deltaExtensions(d,t,s){if(!d.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(t,s)}containsActivationEvent(d){return this._actual.containsActivationEvent(d)}containsExtension(d){return this._actual.containsExtension(d)}getExtensionDescriptionsForActivationEvent(d){return this._actual.getExtensionDescriptionsForActivationEvent(d)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(d){return this._actual.getExtensionDescription(d)}getExtensionDescriptionByUUID(d){return this._actual.getExtensionDescriptionByUUID(d)}getExtensionDescriptionByIdOrUUID(d,t){return this._actual.getExtensionDescriptionByIdOrUUID(d,t)}}e.LockableExtensionDescriptionRegistry=T;class b extends O.Disposable{constructor(d,t){super(),this._registry=d,this._isDisposed=!1,this._register(t)}isAcquiredFor(d){return!this._isDisposed&&this._registry===d}}e.ExtensionDescriptionRegistryLock=b;class c{constructor(d){this.name=d;const t=(0,A.promiseWithResolvers)();this.promise=t.promise,this._resolve=t.resolve}resolve(d){this._resolve(d)}}class C{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(d){const t=new c(d);return this._pendingCustomers.push(t),this._advance(),t.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const d=this._pendingCustomers.shift();this._isLocked=!0;let t=!0;const s=setTimeout(()=>{t&&console.warn(`The customer named ${d.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{t&&(clearTimeout(s),t=!1,this._isLocked=!1,this._advance())};d.resolve((0,O.toDisposable)(n))}}var h;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(h||(h={}));function r(a,d){const t=a.isBuiltin?h.Builtin:a.isUnderDevelopment?h.Dev:h.User,s=d.isBuiltin?h.Builtin:d.isUnderDevelopment?h.Dev:h.User;if(t!==s)return t-s;const n=P.posix.basename(a.extensionLocation.path),i=P.posix.basename(d.extensionLocation.path);return n<i?-1:n>i?1:0}function o(a,d){const t=new y.ExtensionIdentifierSet(d);return a.filter(s=>!t.has(s.identifier))}}),define(De[84],Ie([1,0,23]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=A,e.isMessageOfType=R;var k;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(k||(e.UIKind=k={}));var P;(function(l){l[l.VersionMismatch=55]="VersionMismatch",l[l.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(l){l[l.Initialized=0]="Initialized",l[l.Ready=1]="Ready",l[l.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(l){const T=y.VSBuffer.alloc(1);switch(l){case O.Initialized:T.writeUInt8(1,0);break;case O.Ready:T.writeUInt8(2,0);break;case O.Terminate:T.writeUInt8(3,0);break}return T}function R(l,T){if(l.byteLength!==1)return!1;switch(l.readUInt8(0)){case 1:return T===O.Initialized;case 2:return T===O.Ready;case 3:return T===O.Terminate;default:return!1}}var v;(function(l){l.Start="START_NATIVE_LOG",l.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(De[66],Ie([1,0,3,4,111,12,27,84,62,63,26,2,6,186]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=o;let h=class extends c.Disposable{constructor(d,t){super(),this.initData=d,this.loggerService=t,this._onDidChangeTelemetryEnabled=this._register(new k.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new k.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=P.TelemetryLevel.NONE,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=b.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=t.createLogger(this.extHostTelemetryLogFile,{id:l.extensionTelemetryLogChannelId,name:(0,C.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(t.onDidChangeLogLevel(s=>{(0,O.isLogLevel)(s)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this._level>=P.TelemetryLevel.CRASH,isErrorsEnabled:this._productConfig.error?this._level>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this._productConfig.usage?this._level>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(d,t,s){const n=this.getTelemetryDetails(),i=new r(t,s,d,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(d),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),g=this._telemetryLoggers.get(d.identifier.value)??[];return this._telemetryLoggers.set(d.identifier.value,[...g,i]),i.apiTelemetryLogger}$initializeTelemetryLevel(d,t,s){this._level=d,this._telemetryIsSupported=t,this._productConfig=s??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(d){const t=Object.create(null);switch(t["common.extname"]=`${d.publisher}.${d.name}`,t["common.extversion"]=d.version,t["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,t["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,t["common.sqmid"]=this.initData.telemetryInfo.sqmId,t["common.devDeviceId"]=this.initData.telemetryInfo.devDeviceId,t["common.vscodeversion"]=this.initData.version,t["common.isnewappinstall"]=o(this.initData.telemetryInfo.firstSessionDate),t["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:t["common.uikind"]="web";break;case R.UIKind.Desktop:t["common.uikind"]="desktop";break;default:t["common.uikind"]="unknown"}return t["common.remotename"]=(0,v.getRemoteName)((0,l.cleanRemoteAuthority)(this.initData.remote.authority)),t}$onDidChangeTelemetryLevel(d){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=d;const t=this.getTelemetryDetails();this._telemetryLoggers.forEach((s,n)=>{const i=s.filter(g=>!g.isDisposed);i.length===0?this._telemetryLoggers.delete(n):this._telemetryLoggers.set(n,i)}),this._telemetryLoggers.forEach(s=>{for(const n of s)n.updateTelemetryEnablements(t.isUsageEnabled,t.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(d,t){const n=this._telemetryLoggers.get(d.value)?.filter(g=>!g.isDisposed);if(!n)return this._telemetryLoggers.delete(d.value),!1;let i=!1;for(const g of n)g.ignoreUnhandledExtHostErrors||(g.logError(t),i=!0);return i}};e.ExtHostTelemetry=h,e.ExtHostTelemetry=h=je([$e(0,A.IExtHostInitDataService),$e(1,O.ILoggerService)],h);class r{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,t,s,n,i,g,f){this._extension=s,this._logger=n,this._inLoggingOnlyMode=i,this._commonProperties=g,this._onDidChangeEnableStates=new k.Emitter,this.ignoreUnhandledExtHostErrors=t?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=t?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=t?.additionalCommonProperties,this._sender=d,this._telemetryEnablements={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(d,t){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:d,isErrorsEnabled:t},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(d){let t="properties"in d?d.properties??{}:d;return t=(0,l.cleanData)(t,[]),this._additionalCommonProperties&&(t=(0,T.mixin)(t,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(t=(0,T.mixin)(t,this._commonProperties)),"properties"in d?d.properties=t:d=t,d}logEvent(d,t){this._sender&&(this._extension.publisher==="vscode"?d=this._extension.name+"/"+d:d=this._extension.identifier.value+"/"+d,t=this.mixInCommonPropsAndCleanData(t||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(d,t),this._logger.trace(d,t))}logUsage(d,t){this._telemetryEnablements.isUsageEnabled&&this.logEvent(d,t)}logError(d,t){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof d=="string")this.logEvent(d,t);else{const s={name:d.name,message:d.message,stack:d.stack,cause:d.cause},n=(0,l.cleanData)(s,[]),i=new Error(n.message,{cause:n.cause});i.stack=n.stack,i.name=n.name,t=this.mixInCommonPropsAndCleanData(t||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(i,t),this._logger.trace("exception",t)}}get apiTelemetryLogger(){if(!this._apiObject){const d=this,t={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return d._telemetryEnablements.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d._onDidChangeEnableStates.event.bind(d)};this._apiObject=Object.freeze(t)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let d=this._sender;this._sender=void 0,Promise.resolve(d.flush()).then(d=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=r;function o(a){const d=Date.now()-new Date(a).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.IExtHostTelemetry=(0,y.createDecorator)("IExtHostTelemetry")}),define(De[25],Ie([1,0,4,2,217,110,19,3]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=c,e.checkProposedApiEnabled=C,e.toExtension=a,e.toExtensionDescription=d,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class v{constructor(n){this.dependency=n}}e.MissingExtensionDependency=v;var l;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(l||(e.ExtensionHostStartup=l={}));class T{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(n,i,g){this._versionId=n,this._allExtensions=i.slice(0),this._myExtensions=g.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:O.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(n,i,g){if(this._versionId>n)throw new Error(`ExtensionHostExtensions: invalid versionId ${n} (current: ${this._versionId})`);const f=[],u=[],E=[],I=[],_=b(this._allExtensions),w=b(i),p=(L,H)=>L.extensionLocation.toString()===H.extensionLocation.toString()||L.isBuiltin===H.isBuiltin||L.isUserBuiltin===H.isUserBuiltin||L.isUnderDevelopment===H.isUnderDevelopment;for(const L of this._allExtensions){const H=w.get(L.identifier);if(!H){f.push(L.identifier),_.delete(L.identifier);continue}if(!p(L,H)){f.push(L.identifier),_.delete(L.identifier);continue}}for(const L of i){const H=_.get(L.identifier);if(!H){u.push(L);continue}if(!p(H,L)){f.push(H.identifier),_.delete(H.identifier);continue}}const D=new A.ExtensionIdentifierSet(this._myExtensions),m=new A.ExtensionIdentifierSet(g);for(const L of this._myExtensions)m.has(L)||E.push(L);for(const L of g)D.has(L)||I.push(L);const S=O.ImplicitActivationEvents.createActivationEventsMap(u),M={versionId:n,toRemove:f,toAdd:u,addActivationEvents:S,myToRemove:E,myToAdd:I};return this.delta(M),M}delta(n){if(this._versionId>=n.versionId)return null;const{toRemove:i,toAdd:g,myToRemove:f,myToAdd:u}=n,E=new A.ExtensionIdentifierSet(i),I=new A.ExtensionIdentifierSet(f);for(let _=0;_<this._allExtensions.length;_++)E.has(this._allExtensions[_].identifier)&&(this._allExtensions.splice(_,1),_--);for(let _=0;_<this._myExtensions.length;_++)I.has(this._myExtensions[_])&&(this._myExtensions.splice(_,1),_--);for(const _ of g)this._allExtensions.push(_);for(const _ of u)this._myExtensions.push(_);return this._myActivationEvents=null,n}containsExtension(n){for(const i of this._myExtensions)if(A.ExtensionIdentifier.equals(i,n))return!0;return!1}containsActivationEvent(n){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(n)}_readMyActivationEvents(){const n=new Set;for(const i of this._allExtensions){if(!this.containsExtension(i.identifier))continue;const g=O.ImplicitActivationEvents.readActivationEvents(i);for(const f of g)n.add(f)}return n}}e.ExtensionHostExtensions=T;function b(s){const n=new A.ExtensionIdentifierMap;for(const i of s)n.set(i.identifier,i);return n}function c(s,n){return s.enabledApiProposals?s.enabledApiProposals.includes(n):!1}function C(s,n){if(!c(s,n))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${n}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${n}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class h{constructor(n,i,g,f){this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=g,this.activationReason=f}}e.ActivationTimes=h;class r{constructor(n,i){this.description=n,this.value=i}}e.ExtensionPointContribution=r;var o;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function a(s){return{type:s.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function d(s,n){return{identifier:new A.ExtensionIdentifier((0,P.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===A.ExtensionType.System,isUserBuiltin:s.type===A.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!n,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName}}class t{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(n){return Promise.resolve(void 0)}activateById(n,i){return Promise.resolve(void 0)}activationEventIsDone(n){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(n){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(n,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(n){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=t}),define(De[246],Ie([1,0,14,117,19,25,12,11]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class v{static{this.NONE=new v(!1,-1,-1,-1)}constructor(a,d,t,s){this.startup=a,this.codeLoadingTime=d,this.activateCallTime=t,this.activateResolvedTime=s}}e.ExtensionActivationTimes=v;class l{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,d){return a===-1||d===-1?-1:d-a}build(){return new v(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=l;class T{constructor(a,d,t,s,n,i){this.activationFailed=a,this.activationFailedError=d,this.activationTimes=t,this.module=s,this.exports=n,this.subscriptions=i}}e.ActivatedExtension=T;class b extends T{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=b;class c extends T{constructor(){super(!1,null,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=c;class C extends T{constructor(a){super(!0,a,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let h=class{constructor(a,d,t,s){this._logService=s,this._registry=a,this._globalRegistry=d,this._host=t,this._operations=new P.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[a,d]of this._operations)d.dispose()}async waitForActivatingExtensions(){const a=[];for(const[d,t]of this._operations)a.push(t.wait());await Promise.all(a)}isActivated(a){const d=this._operations.get(a);return!!(d&&d.value)}getActivatedExtension(a){const d=this._operations.get(a);if(!d||!d.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return d.value}async activateByEvent(a,d){if(this._alreadyActivatedEvents[a])return;const t=this._registry.getExtensionDescriptionsForActivationEvent(a);await this._activateExtensions(t.map(s=>({id:s.identifier,reason:{startup:d,extensionId:s.identifier,activationEvent:a}}))),this._alreadyActivatedEvents[a]=!0}activateById(a,d){const t=this._registry.getExtensionDescription(a);if(!t)throw new Error(`Extension '${a.value}' is not known`);return this._activateExtensions([{id:t.identifier,reason:d}])}async _activateExtensions(a){const d=a.filter(t=>!this.isActivated(t.id)).map(t=>this._handleActivationRequest(t));await Promise.all(d.map(t=>t.wait()))}_handleActivationRequest(a){if(this._operations.has(a.id))return this._operations.get(a.id);if(this._isHostExtension(a.id))return this._createAndSaveOperation(a,null,[],null);const d=this._registry.getExtensionDescription(a.id);if(!d){const n=new Error(`Cannot activate unknown extension '${a.id.value}'`),i=this._createAndSaveOperation(a,null,[],new C(n));return this._host.onExtensionActivationError(a.id,n,new O.MissingExtensionDependency(a.id.value)),i}const t=[],s=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const n of s){if(this._isResolvedExtension(n))continue;const i=this._operations.get(n);if(i){t.push(i);continue}if(this._isHostExtension(n)){t.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(n).identifier,reason:a.reason}));continue}const g=this._registry.getExtensionDescription(n);if(g){if(!g.main&&!g.browser)continue;t.push(this._handleActivationRequest({id:g.identifier,reason:a.reason}));continue}const f=d.displayName||d.identifier.value,u=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${n}'`),E=this._createAndSaveOperation(a,d.displayName,[],new C(u));return this._host.onExtensionActivationError(d.identifier,u,new O.MissingExtensionDependency(n)),E}return this._createAndSaveOperation(a,d.displayName,t,null)}_createAndSaveOperation(a,d,t,s){const n=new r(a.id,d,a.reason,t,s,this._host,this._logService);return this._operations.set(a.id,n),n}_isHostExtension(a){return k.ExtensionDescriptionRegistry.isHostExtension(a,this._registry,this._globalRegistry)}_isResolvedExtension(a){const d=this._globalRegistry.getExtensionDescription(a);return d?!d.main&&!d.browser:!1}};e.ExtensionsActivator=h,e.ExtensionsActivator=h=je([$e(3,A.ILogService)],h);let r=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(a,d,t,s,n,i,g){this._id=a,this._displayName=d,this._reason=t,this._deps=s,this._value=n,this._host=i,this._logService=g,this._barrier=new R.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let a=0;a<this._deps.length;a++){const d=this._deps[a];if(d.value&&!d.value.activationFailed){this._deps.splice(a,1),a--;continue}if(d.value&&d.value.activationFailed){const t=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);t.detail=d.value.activationFailedError,this._value=new C(t),this._host.onExtensionActivationError(this._id,t,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(a=>a.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(a){const d=new Error;if(a&&a.name&&(d.name=a.name),a&&a.message?d.message=`Activating extension '${this._id.value}' failed: ${a.message}.`:d.message=`Activating extension '${this._id.value}' failed: ${a}.`,a&&a.stack&&(d.stack=a.stack),this._value=new C(d),this._isDisposed&&y.isCancellationError(a))return;this._host.onExtensionActivationError(this._id,d,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(a)}}};r=je([$e(6,A.ILogService)],r)}),define(De[247],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[118],Ie([1,0,203,14,35,109,78,31,19,247,107,110]),function(he,e,y,k,P,O,A,R,v,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const c=R.Registry.as(A.Extensions.JSONContribution);class C{constructor(n,i,g){this._messageHandler=n,this._extension=i,this._extensionPointId=g}_msg(n,i){this._messageHandler({type:n,message:i,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(n){this._msg(P.default.Error,n)}warn(n){this._msg(P.default.Warning,n)}info(n){this._msg(P.default.Info,n)}}e.ExtensionMessageCollector=C;class h{static _toSet(n){const i=new v.ExtensionIdentifierSet;for(let g=0,f=n.length;g<f;g++)i.add(n[g].description.identifier);return i}static compute(n,i){if(!n||!n.length)return new h(i,[]);if(!i||!i.length)return new h([],n);const g=this._toSet(n),f=this._toSet(i),u=i.filter(I=>!g.has(I.description.identifier)),E=n.filter(I=>!f.has(I.description.identifier));return new h(u,E)}constructor(n,i){this.added=n,this.removed=i}}e.ExtensionPointUserDelta=h;class r{constructor(n,i){this.name=n,this.defaultExtensionKind=i,this._handler=null,this._users=null,this._delta=null}setHandler(n){if(this._handler!==null)throw new Error("Handler already set!");return this._handler=n,this._handle(),{dispose:()=>{this._handler=null}}}acceptUsers(n){this._delta=h.compute(this._users,n),this._users=n,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(n){(0,k.onUnexpectedError)(n)}}}e.ExtensionPoint=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(42,null)},{label:"*",description:y.localize(43,null),body:"*"}]}},badges:{type:"array",description:y.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(45,null)},href:{type:"string",description:y.localize(46,null)},description:{type:"string",description:y.localize(47,null)}}}},markdown:{type:"string",description:y.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:y.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:y.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(53,null)},{body:["workspace"],description:y.localize(54,null)},{body:["ui","workspace"],description:y.localize(55,null)},{body:["workspace","ui"],description:y.localize(56,null)},{body:[],description:y.localize(57,null)}]},capabilities:{description:y.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(61,null),y.localize(62,null),y.localize(63,null)]},description:{type:"string",markdownDescription:y.localize(64,null)}}},untrustedWorkspaces:{description:y.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(67,null),y.localize(68,null),y.localize(69,null)]},restrictedConfigurations:{description:y.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(71,null)}}}}},sponsor:{description:y.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(74,null),type:"string"},"vscode:uninstall":{description:y.localize(75,null),type:"string"}}},icon:{type:"string",description:y.localize(76,null)},l10n:{type:"string",description:y.localize(77,null)},pricing:{type:"string",markdownDescription:y.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class d{constructor(){this._extensionPoints=new Map}registerExtensionPoint(n){if(this._extensionPoints.has(n.extensionPoint))throw new Error("Duplicate extension point: "+n.extensionPoint);const i=new r(n.extensionPoint,n.defaultExtensionKind);return this._extensionPoints.set(n.extensionPoint,i),n.activationEventsGenerator&&b.ImplicitActivationEvents.register(n.extensionPoint,n.activationEventsGenerator),e.schema.properties.contributes.properties[n.extensionPoint]=n.jsonSchema,c.registerSchema(a,e.schema),i}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=d;const t={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(t.ExtensionsRegistry,new d),e.ExtensionsRegistry=R.Registry.as(t.ExtensionsRegistry),c.registerSchema(a,e.schema),c.registerSchema(T.productSchemaId,{properties:{extensionEnabledApiProposals:{description:y.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}}]}}}})}),define(De[248],Ie([1,0,4,40,6,13,195,19,3,12,25,118]),function(he,e,y,k,P,O,A,R,v,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelsService=e.languageModelExtensionPoint=e.ILanguageModelsService=e.ChatMessageRole=void 0;var c;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(c||(e.ChatMessageRole=c={})),e.ILanguageModelsService=(0,v.createDecorator)("ILanguageModelsService");const C={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.languageModelExtensionPoint=b.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[C,{type:"array",items:C}]},activationEventsGenerator:(r,o)=>{for(const a of r)o.push(`onLanguageModelChat:${a.vendor}`)}});let h=class{constructor(o,a){this._extensionService=o,this._logService=a,this._store=new P.DisposableStore,this._providers=new Map,this._vendors=new Set,this._onDidChangeProviders=this._store.add(new y.Emitter),this.onDidChangeLanguageModels=this._onDidChangeProviders.event,this._store.add(e.languageModelExtensionPoint.setHandler(d=>{this._vendors.clear();for(const s of d){if(!(0,T.isProposedApiEnabled)(s.description,"chatProvider")){s.collector.error((0,A.localize)(2,null));continue}for(const n of k.Iterable.wrap(s.value)){if(this._vendors.has(n.vendor)){s.collector.error((0,A.localize)(3,null,n.vendor));continue}if((0,O.isFalsyOrWhitespace)(n.vendor)){s.collector.error((0,A.localize)(4,null));continue}if(n.vendor.trim()!==n.vendor){s.collector.error((0,A.localize)(5,null));continue}this._vendors.add(n.vendor)}}const t=[];for(const[s,n]of this._providers)this._vendors.has(n.metadata.vendor)||(this._providers.delete(s),t.push(s));t.length>0&&this._onDidChangeProviders.fire({removed:t})}))}dispose(){this._store.dispose(),this._providers.clear()}getLanguageModelIds(){return Array.from(this._providers.keys())}lookupLanguageModel(o){return this._providers.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this._extensionService.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const d=Array.from(this._vendors).map(t=>this._extensionService.activateByEvent(`onLanguageModelChat:${t}`));await Promise.all(d)}const a=[];for(const[d,t]of this._providers)(o.vendor===void 0||t.metadata.vendor===o.vendor)&&(o.family===void 0||t.metadata.family===o.family)&&(o.version===void 0||t.metadata.version===o.version)&&(o.identifier===void 0||t.metadata.id===o.identifier)&&(!t.metadata.targetExtensions||t.metadata.targetExtensions.some(s=>R.ExtensionIdentifier.equals(s,o.extension)))&&a.push(d);return this._logService.trace("[LM] selected language models",o,a),a}registerLanguageModelChat(o,a){if(this._logService.trace("[LM] registering language model chat",o,a.metadata),!this._vendors.has(a.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${a.metadata.vendor}.`);if(this._providers.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this._providers.set(o,a),this._onDidChangeProviders.fire({added:[{identifier:o,metadata:a.metadata}]}),(0,P.toDisposable)(()=>{this._providers.delete(o)&&(this._onDidChangeProviders.fire({removed:[o]}),this._logService.trace("[LM] UNregistered language model chat",o,a.metadata))})}makeLanguageModelChatRequest(o,a,d,t,s,n){const i=this._providers.get(o);if(!i)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return i.provideChatResponse(d,a,t,s,n)}computeTokenLength(o,a,d){const t=this._providers.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.provideTokenCount(a,d)}};e.LanguageModelsService=h,e.LanguageModelsService=h=je([$e(0,T.IExtensionService),$e(1,l.ILogService)],h)}),define(De[249],Ie([1,0,198,15,26,118,32,4]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const v={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var l;(function(c){function C(h,r,o){if(!h)return;const a=k.isString(h.type)?h.type:void 0;if(!a||a.length===0){o.error(y.localize(3,null));return}const d=[];if(Array.isArray(h.required))for(const t of h.required)k.isString(t)&&d.push(t);return{extensionId:r.value,taskType:a,required:d,properties:h.properties?P.deepClone(h.properties):{},when:h.when?A.ContextKeyExpr.deserialize(h.when):void 0}}c.from=C})(l||(l={}));const T=O.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,C)=>{for(const h of c)h.type&&C.push(`onTaskType:${h.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:v}});class b{constructor(){this._onDefinitionsChanged=new R.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((C,h)=>{T.setHandler((r,o)=>{this._schema=void 0;try{for(const a of o.removed){const d=a.value;for(const t of d)this.taskTypes&&t.type&&this.taskTypes[t.type]&&delete this.taskTypes[t.type]}for(const a of o.added){const d=a.value;for(const t of d){const s=l.from(t,a.description.identifier,a.collector);s&&(this.taskTypes[s.taskType]=s)}}(o.removed.length>0||o.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}C(void 0)})})}onReady(){return this.readyPromise}get(C){return this.taskTypes[C]}all(){return Object.keys(this.taskTypes).map(C=>this.taskTypes[C])}getJsonSchema(){if(this._schema===void 0){const C=[];for(const h of this.all()){const r={type:"object",additionalProperties:!1};h.required.length>0&&(r.required=h.required.slice(0)),h.properties!==void 0?r.properties=P.deepClone(h.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[h.taskType]},C.push(r)}this._schema={oneOf:C}}return this._schema}}e.TaskDefinitionRegistry=new b}),define(De[250],Ie([1,0,199,15,24,26,32,249,42]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,y.localize(0,null)),e.TASKS_CATEGORY=y.localize2(2,"Tasks");var l;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(l||(e.ShellQuoting=l={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function F(Y){if(!Y)return N.Strong;switch(Y.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=F}(l||(e.ShellQuoting=l={}));var T;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(T||(e.CommandOptions=T={}));var b;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(b||(e.RevealKind=b={})),function(N){function F(Y){switch(Y.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=F}(b||(e.RevealKind=b={}));var c;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(c||(e.RevealProblemKind=c={})),function(N){function F(Y){switch(Y.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=F}(c||(e.RevealProblemKind=c={}));var C;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(C||(e.PanelKind=C={})),function(N){function F(Y){switch(Y.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=F}(C||(e.PanelKind=C={}));var h;(function(N){N.defaults={echo:!0,reveal:b.Always,revealProblems:c.Never,focus:!1,panel:C.Shared,showReuseMessage:!0,clear:!1}})(h||(e.PresentationOptions=h={}));var r;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(N){function F(re){switch(re.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=F;function Y(re){switch(re){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=Y}(r||(e.RuntimeType=r={}));var o;(function(N){function F(Y){return k.isString(Y)?Y:Y.value}N.value=F})(o||(e.CommandString=o={}));var a;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function F(re){return re===N.Clean._id||re===N.Build._id||re===N.Rebuild._id||re===N.Test._id}N.is=F;function Y(re){if(re!==void 0)return k.isString(re)?F(re)?{_id:re,isDefault:!1}:void 0:re}N.from=Y})(a||(e.TaskGroup=a={}));var d;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(d||(e.TaskScope=d={}));var t;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function F(Y){switch(Y){case N.User:return v.ConfigurationTarget.USER;case N.WorkspaceFile:return v.ConfigurationTarget.WORKSPACE;default:return v.ConfigurationTarget.WORKSPACE_FOLDER}}N.toConfigurationTarget=F})(t||(e.TaskSourceKind=t={}));var s;(function(N){N.parallel="parallel",N.sequence="sequence"})(s||(e.DependsOrder=s={}));var n;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var i;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(i||(e.RunOptions=i={}));class g{constructor(F,Y,re,fe,Ee,oe){this._label="",this._id=F,Y&&(this._label=Y),re&&(this.type=re),this.runOptions=fe,this.configurationProperties=Ee,this._source=oe}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.getFolderId(),id:this._id};return JSON.stringify(F)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,Y=!1){if(F===void 0)return!1;if(k.isString(F))return F===this._label||F===this.configurationProperties.identifier||Y&&F===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),F&&(this._taskLoadMessages=this._taskLoadMessages.concat(F))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=g;class f extends g{constructor(F,Y,re,fe,Ee,oe,pe,ve){super(F,re,void 0,pe,ve,Y),this.command={},this._source=Y,this.hasDefinedMatchers=oe,Ee&&(this.command=Ee)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let Y;switch(this.command?this.command.runtime:void 0){case r.Shell:Y="shell";break;case r.Process:Y="process";break;case r.CustomExecution:Y="customExecution";break;case void 0:Y="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Y,_key:this._id,id:this._id}}}static is(F){return F instanceof f}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===t.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.getFolderId();if(!F)return;let Y=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(Y+=this._source.kind);const re={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:Y};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(F){return new f(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.CustomTask=f;class u extends g{constructor(F,Y,re,fe,Ee,oe,pe){super(F,re,fe,oe,pe,Y),this._source=Y,this.configures=Ee}static is(F){return F instanceof u}fromObject(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===t.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.getFolderId();if(!F)return;let Y=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(Y+=this._source.kind);const re={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:Y};return JSON.stringify(re)}}e.ConfiguringTask=u;class E extends g{constructor(F,Y,re,fe,Ee,oe,pe,ve,se){super(F,re,fe,ve,se,Y),this.defines=Ee,this.hasDefinedMatchers=pe,this.command=oe,this.icon=se.icon,this.hide=se.hide}clone(){return new E(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof E}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===d.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.getFolderId(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(F){return new E(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.ContributedTask=E;class I extends g{constructor(F,Y,re,fe,Ee,oe){super(F,re,fe,Ee,oe,Y),this._source=Y}clone(){return new I(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof I}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(F){return new I(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.InMemoryTask=I;var _;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(_||(e.ExecutionEngine=_={})),function(N){N._default=N.Terminal}(_||(e.ExecutionEngine=_={}));var w;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class p{constructor(F){this._order=new Map;for(let Y=0;Y<F.length;Y++)this._order.set(F[Y].uri.toString(),Y)}compare(F,Y){const re=F.getWorkspaceFolder(),fe=Y.getWorkspaceFolder();if(re&&fe){let Ee=this._order.get(re.uri.toString());Ee=Ee===void 0?0:Ee+1;let oe=this._order.get(fe.uri.toString());return oe=oe===void 0?0:oe+1,Ee===oe?F._label.localeCompare(Y._label):Ee-oe}else return!re&&fe?-1:re&&!fe?1:0}}e.TaskSorter=p;var D;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(D||(e.TaskEventKind=D={}));var m;(function(N){N.SingleRun="singleRun",N.Background="background"})(m||(e.TaskRunType=m={}));var S;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var M;(function(N){function F(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?m.Background:m.SingleRun,group:ve.configurationProperties.group,__task:ve}}function Y(ve,se,Te){return{...F(ve),kind:D.Start,terminalId:se,resolvedVariables:Te}}N.start=Y;function re(ve,se,Te){return{...F(ve),kind:D.ProcessStarted,terminalId:se,processId:Te}}N.processStarted=re;function fe(ve,se,Te){return{...F(ve),kind:D.ProcessEnded,terminalId:se,exitCode:Te}}N.processEnded=fe;function Ee(ve,se,Te){return{...F(ve),kind:D.Terminated,exitReason:Te,terminalId:se}}N.terminated=Ee;function oe(ve,se,Te){return{...F(se),kind:ve,terminalId:Te}}N.general=oe;function pe(){return{kind:D.Changed}}N.changed=pe})(M||(e.TaskEvent=M={}));var L;(function(N){function F(re){const fe=Object.keys(re).sort();let Ee="";for(const oe of fe){let pe=re[oe];pe instanceof Object?pe=F(pe):typeof pe=="string"&&(pe=pe.replace(/,/g,",,")),Ee+=oe+","+pe+","}return Ee}function Y(re){const Ee={_key:F(re),type:re.taskType};return Object.assign(Ee,re),Ee}N.create=Y})(L||(e.KeyedTaskIdentifier=L={}));var H;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(H||(e.TaskSettingId=H={}));var V;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var $;(function(N){function F(Y,re){const fe=R.TaskDefinitionRegistry.get(Y.type);if(fe===void 0){const ve=O.deepClone(Y);return delete ve._key,L.create(ve)}const Ee=Object.create(null);Ee.type=fe.taskType;const oe=new Set;fe.required.forEach(ve=>oe.add(ve));const pe=fe.properties;for(const ve of Object.keys(pe)){const se=Y[ve];if(se!=null)Ee[ve]=se;else if(oe.has(ve)){const Te=pe[ve];if(Te.default!==void 0)Ee[ve]=O.deepClone(Te.default);else switch(Te.type){case"boolean":Ee[ve]=!1;break;case"number":case"integer":Ee[ve]=0;break;case"string":Ee[ve]="";break;default:re.error(y.localize(1,null,JSON.stringify(Y,void 0,0),ve));return}}}return L.create(Ee)}N.createTaskIdentifier=F})($||(e.TaskDefinition=$={}))}),define(De[251],Ie([1,0,14]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,R)=>{this._actualOk=A,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,y.onUnexpectedError)(A))}then(A,R){return this._ensureActual().then(A,R)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=k;class P extends k{constructor(){super(),this._hasErr=!0,this._err=new y.CancellationError}}e.CanceledLazyPromise=P}),define(De[38],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=P,e.getStringIdentifierForProxy=O;class y{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++y.count}}e.ProxyIdentifier=y;const k=[];function P(R){const v=new y(R);return k[v.nid]=v,v}function O(R){return k[R].sid}class A{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=A}),define(De[5],Ie([1,0,38]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(k||(e.TextEditorRevealType=k={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var R;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var v;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var l;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(l||(e.NotebookEditorRevealType=l={}));var T;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(T||(e.CandidatePortSource=T={}));class b{static{this._n=0}static mixin(o){return o._id=b._n++,o}}e.IdObject=b;var c;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var C;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(C||(e.ISuggestResultDtoField=C={}));var h;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(h||(e.ExtHostTestingResource=h={})),e.MainContext={MainThreadAuthentication:(0,y.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,y.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,y.createProxyIdentifier)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,y.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,y.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,y.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,y.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,y.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,y.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,y.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,y.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,y.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.createProxyIdentifier)("MainThreadAiEmbeddingVector")},e.ExtHostContext={ExtHostCommands:(0,y.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,y.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,y.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,y.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,y.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,y.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.createProxyIdentifier)("ExtHostInteractive"),ExtHostChatAgents2:(0,y.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,y.createProxyIdentifier)("ExtHostSpeech"),ExtHostEmbeddings:(0,y.createProxyIdentifier)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,y.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,y.createProxyIdentifier)("ExtHostLocalization")}}),define(De[85],Ie([1,0,3,12,5,17]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,y.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(v,l){this._extHostLogService=l,this._reportedUsages=new Set,this._telemetryShape=v.getProxy(P.MainContext.MainThreadTelemetry)}report(v,l,T){const b=this.getUsageKey(v,l);this._reportedUsages.has(b)||(this._reportedUsages.add(b),l.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${v}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:l.identifier.value,apiId:v}))}getUsageKey(v,l){return`${v}-${l.identifier.value}`}};e.ExtHostApiDeprecationService=A,e.ExtHostApiDeprecationService=A=je([$e(0,O.IExtHostRpcService),$e(1,k.ILogService)],A),e.NullApiDeprecationService=Object.freeze(new class{report(R,v,l){}})}),define(De[252],Ie([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(O){const A=O.getProxy(y.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(R){return A.$writeText(R)}})}}e.ExtHostClipboard=k}),define(De[253],Ie([1,0,26,5,27,17]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=class{constructor(T,b){this._mainThreadConsole=T.getProxy(k.MainContext.MainThreadConsole),this._includeStack=b.consoleForward.includeStack,this._logNative=b.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(T,b){const c=this,C=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){c._handleConsoleCall(T,b,C,arguments)}})}_handleConsoleCall(T,b,c,C){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:b,arguments:v(C,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(T,c,C)}};e.AbstractExtHostConsoleForwarder=A,e.AbstractExtHostConsoleForwarder=A=je([$e(0,O.IExtHostRpcService),$e(1,P.IExtHostInitDataService)],A);const R=1e5;function v(l,T){const b=[];if(l.length)for(let c=0;c<l.length;c++){let C=l[c];if(typeof C>"u")C="undefined";else if(C instanceof Error){const h=C;h.stack?C=h.stack:C=h.toString()}b.push(C)}if(T){const c=new Error().stack;c&&b.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,y.safeStringify)(b);return c.length>R?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(De[254],Ie([1,0,2,5,25]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class O{constructor(R){this._proxy=R.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(R,v){return v?.allowUIResources&&(0,P.checkProposedApiEnabled)(R,"showLocal"),this._proxy.$showOpenDialog(v).then(l=>l?l.map(T=>y.URI.revive(T)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(v=>v?y.URI.revive(v):void 0)}}e.ExtHostDialogs=O}),define(De[255],Ie([1,0,22,4,6,5]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEmbeddings=void 0;class A{constructor(v){this._provider=new Map,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._allKnownModels=new Set,this._handlePool=0,this._proxy=v.getProxy(O.MainContext.MainThreadEmbeddings)}registerEmbeddingsProvider(v,l,T){if(this._allKnownModels.has(l))throw new Error("An embeddings provider for this model is already registered");const b=this._handlePool++;return this._proxy.$registerEmbeddingProvider(b,l),this._provider.set(b,{id:l,provider:T}),(0,P.toDisposable)(()=>{this._proxy.$unregisterEmbeddingProvider(b),this._provider.delete(b)})}async computeEmbeddings(v,l,T){T??=y.CancellationToken.None;let b=!1;typeof l=="string"&&(l=[l],b=!0);const c=await this._proxy.$computeEmbeddings(v,l,T);if(c.length!==l.length)throw new Error;if(b){if(c.length!==1)throw new Error;return c[0]}return c}async $provideEmbeddings(v,l,T){const b=this._provider.get(v);if(!b)return[];const c=await b.provider.provideEmbeddings(l,T);return c||[]}get embeddingsModels(){return Array.from(this._allKnownModels)}$acceptEmbeddingModels(v){this._allKnownModels=new Set(v),this._onDidChange.fire()}}e.ExtHostEmbeddings=A}),define(De[256],Ie([1,0,6,5]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class P{constructor(A){this._handlePool=0,this._proxy=A.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const R=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(R,A),(0,y.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=P}),define(De[86],Ie([1,0,21,13,2,3,12,5,27,17]),function(he,e,y,k,P,O,A,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let T=class{constructor(c,C,h){this.logService=h,this.bundleCache=new Map,this._proxy=C.getProxy(R.MainContext.MainThreadLocalization),this.currentLanguage=c.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===y.LANGUAGE_DEFAULT}getMessage(c,C){const{message:h,args:r,comment:o}=C;if(this.isDefaultLanguage)return(0,k.format2)(h,r??{});let a=h;o&&o.length>0&&(a+=`/${Array.isArray(o)?o.join(""):o}`);const d=this.bundleCache.get(c)?.contents[a];return d||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,k.format2)(d??h,r??{})}getBundle(c){return this.bundleCache.get(c)?.contents}getBundleUri(c){return this.bundleCache.get(c)?.uri}async initializeLocalizedMessages(c){if(this.isDefaultLanguage||!c.l10n&&!c.isBuiltin||this.bundleCache.has(c.identifier.value))return;let C;const h=await this.getBundleLocation(c);if(!h){this.logService.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const r=await this._proxy.$fetchBundleContents(h),o=JSON.parse(r);C=c.isBuiltin?o.contents?.bundle:o}catch(r){this.logService.error(`Failed to load translations for ${c.identifier.value} from ${h}: ${r.message}`);return}C&&this.bundleCache.set(c.identifier.value,{contents:C,uri:h})}async getBundleLocation(c){if(c.isBuiltin){const C=await this._proxy.$fetchBuiltInBundleUri(c.identifier.value,this.currentLanguage);return P.URI.revive(C)}return c.l10n?P.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=T,e.ExtHostLocalizationService=T=je([$e(0,v.IExtHostInitDataService),$e(1,l.IExtHostRpcService),$e(2,A.ILogService)],T),e.IExtHostLocalizationService=(0,O.createDecorator)("IExtHostLocalizationService")}),define(De[257],Ie([1,0,12,5,27,17,2,49]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let v=class extends y.AbstractLoggerService{constructor(b,c){super(c.logLevel,c.logsLocation,c.loggers.map(C=>(0,R.revive)(C))),this._proxy=b.getProxy(k.MainContext.MainThreadLogger)}$setLogLevel(b,c){c?this.setLogLevel(A.URI.revive(c),b):this.setLogLevel(b)}setVisibility(b,c){super.setVisibility(b,c),this._proxy.$setVisibility(b,c)}doCreateLogger(b,c,C){return new l(this._proxy,b,c,C)}};e.ExtHostLoggerService=v,e.ExtHostLoggerService=v=je([$e(0,O.IExtHostRpcService),$e(1,P.IExtHostInitDataService)],v);class l extends y.AbstractMessageLogger{constructor(b,c,C,h){super(h?.logLevel==="always"),this.proxy=b,this.file=c,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(C),this.proxy.$createLogger(c,h).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,c){const C=[[b,c]];this.isLoggerCreated?this.doLog(C):this.buffer.push(...C)}doLog(b){this.proxy.$log(this.file,b)}flush(){this.proxy.$flush(this.file)}}}),define(De[87],Ie([1,0,5,3,6,17,23]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,k.createDecorator)("IExtHostManagedSockets");let R=class{constructor(b){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=b.getProxy(y.MainContext.MainThreadManagedSockets)}setFactory(b,c){for(const C of this._managedRemoteSockets.values())C.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new v(b,c),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(b){if(!this._factory||this._factory.socketFactoryId!==b)throw new Error(`No socket factory with id ${b}`);const c=++this._remoteSocketIdCounter,C=await this._factory.makeConnection(),h=new P.DisposableStore;return this._managedRemoteSockets.set(c,new l(c,C,h)),h.add((0,P.toDisposable)(()=>this._managedRemoteSockets.delete(c))),h.add(C.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(c),h.dispose()})),h.add(C.onDidClose(r=>{this._proxy.$onDidManagedSocketClose(c,r?.stack??r?.message),h.dispose()})),h.add(C.onDidReceiveMessage(r=>this._proxy.$onDidManagedSocketHaveData(c,A.VSBuffer.wrap(r)))),c}$remoteSocketWrite(b,c){this._managedRemoteSockets.get(b)?.actual.send(c.buffer)}$remoteSocketEnd(b){const c=this._managedRemoteSockets.get(b);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(b){await this._managedRemoteSockets.get(b)?.actual.drain?.()}};e.ExtHostManagedSockets=R,e.ExtHostManagedSockets=R=je([$e(0,O.IExtHostRpcService)],R);class v{constructor(b,c){this.socketFactoryId=b,this.makeConnection=c}}class l extends P.Disposable{constructor(b,c,C){super(),this.socketId=b,this.actual=c,this._register(C)}}}),define(De[258],Ie([1,0,5,12,25]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function O(R){return R&&R.title}let A=class{constructor(v,l){this._logService=l,this._proxy=v.getProxy(y.MainContext.MainThreadMessageService)}showMessage(v,l,T,b,c){const C={source:{identifier:v.identifier,label:v.displayName||v.name}};let h;typeof b=="string"||O(b)?h=[b,...c]:(C.modal=b?.modal,C.useCustom=b?.useCustom,C.detail=b?.detail,h=c),C.useCustom&&(0,P.checkProposedApiEnabled)(v,"resolvers");const r=[];let o=!1;for(let a=0;a<h.length;a++){const d=h[a];if(typeof d=="string")r.push({title:d,handle:a,isCloseAffordance:!1});else if(typeof d=="object"){const{title:t,isCloseAffordance:s}=d;r.push({title:t,isCloseAffordance:!!s,handle:a}),s&&(o?this._logService.warn(`[${v.identifier}] Only one message item can have 'isCloseAffordance':`,d):o=!0)}else this._logService.warn(`[${v.identifier}] Invalid message item:`,d)}return this._proxy.$showMessage(l,T,C,r).then(a=>{if(typeof a=="number")return h[a]})}};e.ExtHostMessageService=A,e.ExtHostMessageService=A=je([$e(1,k.ILogService)],A)}),define(De[259],Ie([1,0,6,15,2,25,5]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(l){this.handlers=new Map,this.proxy=l.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(l,T,b){if((0,O.checkProposedApiEnabled)(l,"profileContentHandlers"),this.handlers.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.handlers.set(T,b),this.proxy.$registerProfileContentHandler(T,b.name,b.description,l.identifier.value),(0,y.toDisposable)(()=>{this.handlers.delete(T),this.proxy.$unregisterProfileContentHandler(T)})}async $saveProfile(l,T,b,c){const C=this.handlers.get(l);if(!C)throw new Error(`Unknown handler with id: ${l}`);return C.saveProfile(T,b,c)}async $readProfile(l,T,b){const c=this.handlers.get(l);if(!c)throw new Error(`Unknown handler with id: ${l}`);return c.readProfile((0,k.isString)(T)?T:P.URI.revive(T),b)}}e.ExtHostProfileContentHandlers=R}),define(De[88],Ie([1,0,5,4,3]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class O{constructor(R){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=R.getProxy(y.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this._onDidChangePassword.fire(R)}get(R,v){return this._proxy.$getPassword(R,v)}store(R,v,l){return this._proxy.$setPassword(R,v,l)}delete(R,v){return this._proxy.$deletePassword(R,v)}}e.ExtHostSecretState=O,e.IExtHostSecretState=(0,P.createDecorator)("IExtHostSecretState")}),define(De[260],Ie([1,0,22,6,5]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class O{static{this.ID_POOL=1}constructor(R){this.providers=new Map,this.sessions=new Map,this.synthesizers=new Map,this.proxy=R.getProxy(P.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(R,v,l){const T=this.providers.get(R);if(!T)return;const b=new k.DisposableStore,c=new y.CancellationTokenSource;this.sessions.set(v,c);const C=await T.provideSpeechToTextSession(c.token,l?{language:l}:void 0);C&&(b.add(C.onDidChange(h=>{c.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(v,h)})),b.add(c.token.onCancellationRequested(()=>b.dispose())))}async $cancelSpeechToTextSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}async $createTextToSpeechSession(R,v,l){const T=this.providers.get(R);if(!T)return;const b=new k.DisposableStore,c=new y.CancellationTokenSource;this.sessions.set(v,c);const C=await T.provideTextToSpeechSession(c.token,l?{language:l}:void 0);C&&(this.synthesizers.set(v,C),b.add(C.onDidChange(h=>{c.token.isCancellationRequested||this.proxy.$emitTextToSpeechEvent(v,h)})),b.add(c.token.onCancellationRequested(()=>b.dispose())))}async $synthesizeSpeech(R,v){this.synthesizers.get(R)?.synthesize(v)}async $cancelTextToSpeechSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R),this.synthesizers.delete(R)}async $createKeywordRecognitionSession(R,v){const l=this.providers.get(R);if(!l)return;const T=new k.DisposableStore,b=new y.CancellationTokenSource;this.sessions.set(v,b);const c=await l.provideKeywordRecognitionSession(b.token);c&&(T.add(c.onDidChange(C=>{b.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(v,C)})),T.add(b.token.onCancellationRequested(()=>T.dispose())))}async $cancelKeywordRecognitionSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}registerProvider(R,v,l){const T=O.ID_POOL++;return this.providers.set(T,l),this.proxy.$registerProvider(T,v,{extension:R,displayName:R.value}),(0,k.toDisposable)(()=>{this.proxy.$unregisterProvider(T),this.providers.delete(T)})}}e.ExtHostSpeech=O}),define(De[89],Ie([1,0,5,4,3]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class O{constructor(R,v){this._logService=v,this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=R.getProxy(y.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,v){this._proxy.$registerExtensionStorageKeysToSync(R,v)}async initializeExtensionStorage(R,v,l){const T=await this._proxy.$initializeExtensionStorage(R,v);let b;return T&&(b=this.safeParseValue(R,v,T)),b||l}setValue(R,v,l){return this._proxy.$setValue(R,v,l)}$acceptValue(R,v,l){const T=this.safeParseValue(R,v,l);T&&this._onDidChangeStorage.fire({shared:R,key:v,value:T})}safeParseValue(R,v,l){try{return JSON.parse(l)}catch(T){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${R}): ${T}`)}}}e.ExtHostStorage=O,e.IExtHostStorage=(0,P.createDecorator)("IExtHostStorage")}),define(De[261],Ie([1,0,6,16,2,5]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{static{this.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}constructor(v){this._openers=new Map,this._proxy=v.getProxy(O.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(v,l,T,b){if(this._openers.has(l))throw new Error(`Opener with id '${l}' already registered`);const c=b.schemes.find(C=>!A.supportedSchemes.has(C));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(l,T),this._proxy.$registerUriOpener(l,b.schemes,v,b.label),(0,y.toDisposable)(()=>{this._openers.delete(l),this._proxy.$unregisterUriOpener(l)})}async $canOpenUri(v,l,T){const b=this._openers.get(v);if(!b)throw new Error(`Unknown opener with id: ${v}`);const c=P.URI.revive(l);return b.canOpenExternalUri(c,T)}async $openUri(v,l,T){const b=this._openers.get(v);if(!b)throw new Error(`Unknown opener id: '${v}'`);return b.openExternalUri(P.URI.revive(l.resolvedUri),{sourceUri:P.URI.revive(l.sourceUri)},T)}}e.ExtHostUriOpeners=A}),define(De[262],Ie([1,0,5,2,6,14,19]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{static{this.HandlePool=0}constructor(l){this.handles=new A.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=l.getProxy(y.MainContext.MainThreadUrls)}registerUriHandler(l,T){const b=l.identifier;if(this.handles.has(b))throw new Error(`Protocol handler already registered for extension ${b}`);const c=R.HandlePool++;return this.handles.add(b),this.handlers.set(c,T),this._proxy.$registerUriHandler(c,b,l.displayName||l.name),(0,P.toDisposable)(()=>{this.handles.delete(b),this.handlers.delete(c),this._proxy.$unregisterUriHandler(c)})}$handleExternalUri(l,T){const b=this.handlers.get(l);if(!b)return Promise.resolve(void 0);try{b.handleUri(k.URI.revive(T))}catch(c){(0,O.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(l){return k.URI.revive(await this._proxy.$createAppUri(l))}}e.ExtHostUrls=R}),define(De[263],Ie([1,0,23,5]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=O,e.deserializeWebviewMessage=R;class P{constructor(){this.buffers=[]}add(l){let T=this.buffers.indexOf(l);return T<0&&(T=this.buffers.length,this.buffers.push(l)),T}}function O(v,l){if(l.serializeBuffersForPostMessage){const T=new P,c=JSON.stringify(v,(h,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:T.add(r)};if(ArrayBuffer.isView(r)){const o=A(r);if(o)return{$$vscode_array_buffer_reference$$:!0,index:T.add(r.buffer),view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),C=T.buffers.map(h=>{const r=new Uint8Array(h);return y.VSBuffer.wrap(r)});return{message:c,buffers:C}}else return{message:JSON.stringify(v),buffers:[]}}function A(v){switch(v.constructor.name){case"Int8Array":return k.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return k.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return k.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return k.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return k.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return k.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return k.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return k.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return k.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return k.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return k.WebviewMessageArrayBufferViewType.BigUint64Array}}function R(v,l){const T=l.map(C=>{const h=new ArrayBuffer(C.byteLength);return new Uint8Array(h).set(C.buffer),h}),b=l.length?(C,h)=>{if(h&&typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const r=h,{index:o}=r,a=T[o];if(r.view)switch(r.view.type){case k.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(a,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(a,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(a,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(a,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(a,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(a,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(a,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(a,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(a,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(a,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(a,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return h}:void 0;return{message:JSON.parse(v,b),arrayBuffers:T}}}),define(De[67],Ie([1,0,4,6,16,26,2,206,263,83,5]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=c,e.toExtensionData=r,e.serializeWebviewOptions=o;class b{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;constructor(s,n,i,g,f,u,E){this.#a="",this.#l=!1,this.#c=!1,this._onMessageEmitter=new y.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new y.Emitter,this._onDidDispose=this.#d.event,this.#e=s,this.#t=n,this.#o=i,this.#n=g,this.#s=f,this.#r=u,this.#u=c(u),this.#h=C(u),this.#i=E}#d;dispose(){this.#l=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#c=!0,(0,l.asWebviewUri)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===P.Schemas.https||s.scheme===P.Schemas.http){let n=s.toString();return n.endsWith("/")||(n+="/"),n+" "+l.webviewGenericCspSource}return l.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(s){this.assertNotDisposed(),this.#a!==s&&(this.#a=s,this.#h&&!this.#c&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#c=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(s)))}get options(){return this.assertNotDisposed(),this.#o}set options(s){this.assertNotDisposed(),O.equals(this.#o,s)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#l)return!1;const n=(0,v.serializeWebviewMessage)(s,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,n.message,...n.buffers)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(s){if(!this.#h)return s;const n=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,f,u,E,I,_)=>{const w=A.URI.from({scheme:E||"file",path:decodeURIComponent(I)}),p=(0,l.asWebviewUri)(w,{isRemote:n,authority:i}).toString();return`${f}${p}${_}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,f,u,E,I,_)=>{const w=A.URI.from({scheme:E||"file",path:decodeURIComponent(I)}),p=(0,l.asWebviewUri)(w,{isRemote:n,authority:i}).toString();return`${f}${p}${_}`})}}e.ExtHostWebview=b;function c(t){try{const s=(0,R.normalizeVersion)((0,R.parseVersion)(t.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function C(t){try{const s=(0,R.normalizeVersion)((0,R.parseVersion)(t.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class h extends k.Disposable{constructor(s,n,i,g,f){super(),this.remoteInfo=n,this.workspace=i,this._logService=g,this._deprecationService=f,this._webviews=new Map,this._webviewProxy=s.getProxy(T.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const s of this._webviews.values())s.dispose();this._webviews.clear()}$onMessage(s,n,i){const g=this.getWebview(s);if(g){const{message:f}=(0,v.deserializeWebviewMessage)(n,i.value);g._onMessageEmitter.fire(f)}}$onMissingCsp(s,n){this._logService.warn(`${n} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,n,i){const g=new b(s,this._webviewProxy,a(n),this.remoteInfo,this.workspace,i,this._deprecationService);this._webviews.set(s,g);const f=g._onDidDispose(()=>{f.dispose(),this.deleteWebview(s)});return g}deleteWebview(s){this._webviews.delete(s)}getWebview(s){return this._webviews.get(s)}}e.ExtHostWebviews=h;function r(t){return{id:t.identifier,location:t.extensionLocation}}function o(t,s,n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots||d(t,s)}}function a(t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots?.map(s=>A.URI.from(s))}}function d(t,s){return[...(s?.getWorkspaceFolders()||[]).map(n=>n.uri),t.extensionLocation]}}),define(De[119],Ie([1,0,4,16,13,2,3,17,5]),function(he,e,y,k,P,O,A,R,v){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class{static{l=this}static{this.InitialState={focused:!0,active:!0}}getState(){const c=this._state;return{get focused(){return c.focused},get active(){return c.active}}}constructor(c){this._onDidChangeWindowState=new y.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=l.InitialState,this._proxy=c.getProxy(v.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:C,isActive:h})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",h)})}$onDidChangeWindowFocus(c){this.onDidChangeWindowProperty("focused",c)}$onDidChangeWindowActive(c){this.onDidChangeWindowProperty("active",c)}onDidChangeWindowProperty(c,C){C!==this._state[c]&&(this._state={...this._state,[c]:C},this._onDidChangeWindowState.fire(this._state))}openUri(c,C){let h;if(typeof c=="string"){h=c;try{c=O.URI.parse(c)}catch{return Promise.reject(`Invalid uri - '${c}'`)}}return(0,P.isFalsyOrWhitespace)(c.scheme)?Promise.reject("Invalid scheme - cannot be empty"):c.scheme===k.Schemas.command?Promise.reject(`Invalid scheme '${c.scheme}'`):this._proxy.$openUri(c,h,C)}async asExternalUri(c,C){if((0,P.isFalsyOrWhitespace)(c.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(c,C);return O.URI.from(h)}};e.ExtHostWindow=T,e.ExtHostWindow=T=l=je([$e(0,R.IExtHostRpcService)],T),e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(De[264],Ie([1,0,253,27,17]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let O=class extends y.AbstractExtHostConsoleForwarder{constructor(R,v){super(R,v)}_nativeConsoleLogMessage(R,v,l){v.apply(console,l)}};e.ExtHostConsoleForwarder=O,e.ExtHostConsoleForwarder=O=je([$e(0,P.IExtHostRpcService),$e(1,k.IExtHostInitDataService)],O)}),define(De[265],Ie([1,0,11,23,22,28,14,4,6,37,159,251,38]),function(he,e,y,k,P,O,A,R,v,l,T,b,c){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=d,e.parseJsonAndRestoreBufferRefs=t;function h(M,L){try{return JSON.stringify(M,L)}catch{return"null"}}const r="$$ref$$",o={[r]:-1};class a{constructor(L,H){this.jsonString=L,this.referencedBuffers=H}}function d(M,L=null,H=!1){const V=[];return{jsonString:(H?h:JSON.stringify)(M,(N,F)=>{if(typeof F>"u")return o;if(typeof F=="object"){if(F instanceof k.VSBuffer){const Y=V.push(F)-1;return{[r]:Y}}if(L)return L(N,F)}return F}),referencedBuffers:V}}function t(M,L,H){return JSON.parse(M,(V,$)=>{if($){const N=$[r];if(typeof N=="number")return L[N];if(H&&$.$mid===l.MarshalledId.Uri)return H.transformIncoming($)}return $})}function s(M,L){return JSON.stringify(M,L)}function n(M){return M?(L,H)=>H&&H.$mid===l.MarshalledId.Uri?M.transformOutgoing(H):H:null}var i;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(i||(e.RequestInitiator=i={}));var g;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(g||(e.ResponsiveState=g={}));const f=()=>{},u=Symbol.for("rpcProtocol"),E=Symbol.for("rpcProxy");class I extends v.Disposable{static{C=u}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(L,H=null,V=null){super(),this[C]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=H,this._uriTransformer=V,this._uriReplacer=n(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let $=0,N=c.ProxyIdentifier.count;$<N;$++)this._locals[$]=null,this._proxies[$]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=g.Responsive,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new y.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage($=>this._receiveOneMessage($))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{const H=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],H.resolveErr(A.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+I.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+I.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(g.Responsive)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(g.Unresponsive):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,T.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:H,sid:V}=L;return this._proxies[H]||(this._proxies[H]=this._createProxy(H,V)),this._proxies[H]}_createProxy(L,H){const V={get:($,N)=>(typeof N=="string"&&!$[N]&&N.charCodeAt(0)===O.CharCode.DollarSign&&($[N]=(...F)=>this._remoteCall(L,N,F)),N===E?H:$[N])};return new Proxy(Object.create(null),V)}set(L,H){return this._locals[L.nid]=H,H}assertRegistered(L){for(let H=0,V=L.length;H<V;H++){const $=L[H];if(!this._locals[$.nid])throw new Error(`Missing proxy instance ${$.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const H=L.byteLength,V=w.read(L,0),$=V.readUInt8(),N=V.readUInt32();switch($){case m.RequestJSONArgs:case m.RequestJSONArgsWithCancellation:{let{rpcId:F,method:Y,args:re}=D.deserializeRequestJSONArgs(V);this._uriTransformer&&(re=(0,T.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(H,N,F,Y,re,$===m.RequestJSONArgsWithCancellation);break}case m.RequestMixedArgs:case m.RequestMixedArgsWithCancellation:{let{rpcId:F,method:Y,args:re}=D.deserializeRequestMixedArgs(V);this._uriTransformer&&(re=(0,T.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(H,N,F,Y,re,$===m.RequestMixedArgsWithCancellation);break}case m.Acknowledged:{this._logger?.logIncoming(H,N,i.LocalSide,"ack"),this._onDidReceiveAcknowledge(N);break}case m.Cancel:{this._receiveCancel(H,N);break}case m.ReplyOKEmpty:{this._receiveReply(H,N,void 0);break}case m.ReplyOKJSON:{let F=D.deserializeReplyOKJSON(V);this._uriTransformer&&(F=(0,T.transformIncomingURIs)(F,this._uriTransformer)),this._receiveReply(H,N,F);break}case m.ReplyOKJSONWithBuffers:{const F=D.deserializeReplyOKJSONWithBuffers(V,this._uriTransformer);this._receiveReply(H,N,F);break}case m.ReplyOKVSBuffer:{const F=D.deserializeReplyOKVSBuffer(V);this._receiveReply(H,N,F);break}case m.ReplyErrError:{let F=D.deserializeReplyErrError(V);this._uriTransformer&&(F=(0,T.transformIncomingURIs)(F,this._uriTransformer)),this._receiveReplyErr(H,N,F);break}case m.ReplyErrEmpty:{this._receiveReplyErr(H,N,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,H,V,$,N,F){this._logger?.logIncoming(L,H,i.OtherSide,`receiveRequest ${(0,c.getStringIdentifierForProxy)(V)}.${$}(`,N);const Y=String(H);let re,fe;if(F){const oe=new P.CancellationTokenSource;N.push(oe.token),re=this._invokeHandler(V,$,N),fe=()=>oe.cancel()}else re=this._invokeHandler(V,$,N),fe=f;this._cancelInvokedHandlers[Y]=fe;const Ee=D.serializeAcknowledged(H);this._logger?.logOutgoing(Ee.byteLength,H,i.OtherSide,"ack"),this._protocol.send(Ee),re.then(oe=>{delete this._cancelInvokedHandlers[Y];const pe=D.serializeReplyOK(H,oe,this._uriReplacer);this._logger?.logOutgoing(pe.byteLength,H,i.OtherSide,"reply:",oe),this._protocol.send(pe)},oe=>{delete this._cancelInvokedHandlers[Y];const pe=D.serializeReplyErr(H,oe);this._logger?.logOutgoing(pe.byteLength,H,i.OtherSide,"replyErr:",oe),this._protocol.send(pe)})}_receiveCancel(L,H){this._logger?.logIncoming(L,H,i.OtherSide,"receiveCancel");const V=String(H);this._cancelInvokedHandlers[V]?.()}_receiveReply(L,H,V){this._logger?.logIncoming(L,H,i.LocalSide,"receiveReply:",V);const $=String(H);if(!this._pendingRPCReplies.hasOwnProperty($))return;const N=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$],N.resolveOk(V)}_receiveReplyErr(L,H,V){this._logger?.logIncoming(L,H,i.LocalSide,"receiveReplyErr:",V);const $=String(H);if(!this._pendingRPCReplies.hasOwnProperty($))return;const N=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$];let F;V&&(V.$isError?(F=new Error,F.name=V.name,F.message=V.message,F.stack=V.stack):F=V),N.resolveErr(F)}_invokeHandler(L,H,V){try{return Promise.resolve(this._doInvokeHandler(L,H,V))}catch($){return Promise.reject($)}}_doInvokeHandler(L,H,V){const $=this._locals[L];if(!$)throw new Error("Unknown actor "+(0,c.getStringIdentifierForProxy)(L));const N=$[H];if(typeof N!="function")throw new Error("Unknown method "+H+" on actor "+(0,c.getStringIdentifierForProxy)(L));return N.apply($,V)}_remoteCall(L,H,V){if(this._isDisposed)return new b.CanceledLazyPromise;let $=null;if(V.length>0&&P.CancellationToken.isCancellationToken(V[V.length-1])&&($=V.pop()),$&&$.isCancellationRequested)return Promise.reject(A.canceled());const N=D.serializeRequestArguments(V,this._uriReplacer),F=++this._lastMessageId,Y=String(F),re=new b.LazyPromise,fe=new v.DisposableStore;$&&fe.add($.onCancellationRequested(()=>{const oe=D.serializeCancel(F);this._logger?.logOutgoing(oe.byteLength,F,i.LocalSide,"cancel"),this._protocol.send(D.serializeCancel(F))})),this._pendingRPCReplies[Y]=new _(re,fe),this._onWillSendRequest(F);const Ee=D.serializeRequest(F,L,H,N,!!$);return this._logger?.logOutgoing(Ee.byteLength,F,i.LocalSide,`request: ${(0,c.getStringIdentifierForProxy)(L)}.${H}(`,V),this._protocol.send(Ee),re}}e.RPCProtocol=I;class _{constructor(L,H){this._promise=L,this._disposable=H}resolveOk(L){this._promise.resolveOk(L),this._disposable.dispose()}resolveErr(L){this._promise.resolveErr(L),this._disposable.dispose()}}class w{static alloc(L,H,V){const $=new w(k.VSBuffer.alloc(V+1+4),0);return $.writeUInt8(L),$.writeUInt32(H),$}static read(L,H){return new w(L,H)}get buffer(){return this._buff}constructor(L,H){this._buff=L,this._offset=H}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const V=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,V}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,V}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const H=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,H}static sizeMixedArray(L){let H=0;H+=1;for(let V=0,$=L.length;V<$;V++){const N=L[V];switch(H+=1,N.type){case S.String:H+=this.sizeLongString(N.value);break;case S.VSBuffer:H+=this.sizeVSBuffer(N.value);break;case S.SerializedObjectWithBuffers:H+=this.sizeUInt32,H+=this.sizeLongString(N.value);for(let F=0;F<N.buffers.length;++F)H+=this.sizeVSBuffer(N.buffers[F]);break;case S.Undefined:break}}return H}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let H=0,V=L.length;H<V;H++){const $=L[H];switch($.type){case S.String:this.writeUInt8(S.String),this.writeLongString($.value);break;case S.VSBuffer:this.writeUInt8(S.VSBuffer),this.writeVSBuffer($.value);break;case S.SerializedObjectWithBuffers:this.writeUInt8(S.SerializedObjectWithBuffers),this.writeUInt32($.buffers.length),this.writeLongString($.value);for(let N=0;N<$.buffers.length;++N)this.writeBuffer($.buffers[N]);break;case S.Undefined:this.writeUInt8(S.Undefined);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const H=new Array(L);for(let V=0;V<L;V++)switch(this.readUInt8()){case S.String:H[V]=this.readLongString();break;case S.VSBuffer:H[V]=this.readVSBuffer();break;case S.SerializedObjectWithBuffers:{const N=this.readUInt32(),F=this.readLongString(),Y=[];for(let re=0;re<N;++re)Y.push(this.readVSBuffer());H[V]=new c.SerializableObjectWithBuffers(t(F,Y,null));break}case S.Undefined:H[V]=void 0;break}return H}}var p;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(p||(p={}));class D{static _useMixedArgSerialization(L){for(let H=0,V=L.length;H<V;H++)if(L[H]instanceof k.VSBuffer||L[H]instanceof c.SerializableObjectWithBuffers||typeof L[H]>"u")return!0;return!1}static serializeRequestArguments(L,H){if(this._useMixedArgSerialization(L)){const V=[];for(let $=0,N=L.length;$<N;$++){const F=L[$];if(F instanceof k.VSBuffer)V[$]={type:S.VSBuffer,value:F};else if(typeof F>"u")V[$]={type:S.Undefined};else if(F instanceof c.SerializableObjectWithBuffers){const{jsonString:Y,referencedBuffers:re}=d(F.value,H);V[$]={type:S.SerializedObjectWithBuffers,value:k.VSBuffer.fromString(Y),buffers:re}}else V[$]={type:S.String,value:k.VSBuffer.fromString(s(F,H))}}return{type:p.Mixed,args:V}}return{type:p.Simple,args:s(L,H)}}static serializeRequest(L,H,V,$,N){switch($.type){case p.Simple:return this._requestJSONArgs(L,H,V,$.args,N);case p.Mixed:return this._requestMixedArgs(L,H,V,$.args,N)}}static _requestJSONArgs(L,H,V,$,N){const F=k.VSBuffer.fromString(V),Y=k.VSBuffer.fromString($);let re=0;re+=w.sizeUInt8(),re+=w.sizeShortString(F),re+=w.sizeLongString(Y);const fe=w.alloc(N?m.RequestJSONArgsWithCancellation:m.RequestJSONArgs,L,re);return fe.writeUInt8(H),fe.writeShortString(F),fe.writeLongString(Y),fe.buffer}static deserializeRequestJSONArgs(L){const H=L.readUInt8(),V=L.readShortString(),$=L.readLongString();return{rpcId:H,method:V,args:JSON.parse($)}}static _requestMixedArgs(L,H,V,$,N){const F=k.VSBuffer.fromString(V);let Y=0;Y+=w.sizeUInt8(),Y+=w.sizeShortString(F),Y+=w.sizeMixedArray($);const re=w.alloc(N?m.RequestMixedArgsWithCancellation:m.RequestMixedArgs,L,Y);return re.writeUInt8(H),re.writeShortString(F),re.writeMixedArray($),re.buffer}static deserializeRequestMixedArgs(L){const H=L.readUInt8(),V=L.readShortString(),$=L.readMixedArray(),N=new Array($.length);for(let F=0,Y=$.length;F<Y;F++){const re=$[F];typeof re=="string"?N[F]=JSON.parse(re):N[F]=re}return{rpcId:H,method:V,args:N}}static serializeAcknowledged(L){return w.alloc(m.Acknowledged,L,0).buffer}static serializeCancel(L){return w.alloc(m.Cancel,L,0).buffer}static serializeReplyOK(L,H,V){if(typeof H>"u")return this._serializeReplyOKEmpty(L);if(H instanceof k.VSBuffer)return this._serializeReplyOKVSBuffer(L,H);if(H instanceof c.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:N}=d(H.value,V,!0);return this._serializeReplyOKJSONWithBuffers(L,$,N)}else return this._serializeReplyOKJSON(L,h(H,V))}static _serializeReplyOKEmpty(L){return w.alloc(m.ReplyOKEmpty,L,0).buffer}static _serializeReplyOKVSBuffer(L,H){let V=0;V+=w.sizeVSBuffer(H);const $=w.alloc(m.ReplyOKVSBuffer,L,V);return $.writeVSBuffer(H),$.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,H){const V=k.VSBuffer.fromString(H);let $=0;$+=w.sizeLongString(V);const N=w.alloc(m.ReplyOKJSON,L,$);return N.writeLongString(V),N.buffer}static _serializeReplyOKJSONWithBuffers(L,H,V){const $=k.VSBuffer.fromString(H);let N=0;N+=w.sizeUInt32,N+=w.sizeLongString($);for(const Y of V)N+=w.sizeVSBuffer(Y);const F=w.alloc(m.ReplyOKJSONWithBuffers,L,N);F.writeUInt32(V.length),F.writeLongString($);for(const Y of V)F.writeBuffer(Y);return F.buffer}static deserializeReplyOKJSON(L){const H=L.readLongString();return JSON.parse(H)}static deserializeReplyOKJSONWithBuffers(L,H){const V=L.readUInt32(),$=L.readLongString(),N=[];for(let F=0;F<V;++F)N.push(L.readVSBuffer());return new c.SerializableObjectWithBuffers(t($,N,H))}static serializeReplyErr(L,H){const V=H?h(A.transformErrorForSerialization(H),null):void 0;if(typeof V!="string")return this._serializeReplyErrEmpty(L);const $=k.VSBuffer.fromString(V);let N=0;N+=w.sizeLongString($);const F=w.alloc(m.ReplyErrError,L,N);return F.writeLongString($),F.buffer}static deserializeReplyErrError(L){const H=L.readLongString();return JSON.parse(H)}static _serializeReplyErrEmpty(L){return w.alloc(m.ReplyErrEmpty,L,0).buffer}}var m;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var S;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(S||(S={}))}),define(De[266],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const y=function(O){const A=R=>{globalThis.removeEventListener("message",A);const v=R.data;Object.defineProperties(globalThis,{postMessage:{value(l,T){v.postMessage(l,T)}},onmessage:{get(){return v.onmessage},set(l){v.onmessage=l}}}),v.addEventListener("message",l=>{globalThis.dispatchEvent(new MessageEvent("message",{data:l.data,ports:l.ports?[...l.ports]:void 0}))}),v.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class k extends EventTarget{constructor(O,A,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const v=`((${y})('${A}'))`,l=new Blob([v],{type:"application/javascript"}),T=URL.createObjectURL(l),b=new MessageChannel,c=T,C={type:"_newWorker",id:c,port:b.port2,url:T,options:R};O(C,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{O({type:"_terminateWorker",id:c}),URL.revokeObjectURL(T),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(h){b.port1.onmessage=h}},onmessageerror:{get(){return b.port1.onmessageerror},set(h){b.port1.onmessageerror=h}}}),b.port1.addEventListener("messageerror",h=>{const r=new MessageEvent("messageerror",{data:h.data});this.dispatchEvent(r)}),b.port1.addEventListener("message",h=>{const r=new MessageEvent("message",{data:h.data});this.dispatchEvent(r)}),b.port1.start()}}e.NestedWorker=k}),define(De[267],Ie([1,0,23,29,16,60,3]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=T,e.generate=b,e.INotebookDocumentService=(0,A.createDecorator)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${R.join("")}]+`),l=7;function T(C){if(C.scheme!==P.Schemas.vscodeNotebookCell)return;const h=C.fragment.indexOf("s");if(h<0)return;const r=parseInt(C.fragment.substring(0,h).replace(v,""),l),o=(0,y.decodeBase64)(C.fragment.substring(h+1)).toString();if(!isNaN(r))return{handle:r,notebook:C.with({scheme:o,fragment:null})}}function b(C,h){const r=h.toString(l),a=`${r.length<R.length?R[r.length-1]:"z"}${r}s${(0,y.encodeBase64)(y.VSBuffer.fromString(C.scheme),!0,!0)}`;return C.with({scheme:P.Schemas.vscodeNotebookCell,fragment:a})}class c{constructor(){this._documents=new k.ResourceMap}getNotebook(h){if(h.scheme===P.Schemas.vscodeNotebookCell){const r=T(h);if(r){const o=this._documents.get(r.notebook);if(o)return o}}return this._documents.get(h)}addNotebookDocument(h){this._documents.set(h.uri,h)}removeNotebookDocument(h){this._documents.delete(h.uri)}}e.NotebookDocumentWorkbenchService=c,(0,O.registerSingleton)(e.INotebookDocumentService,c,O.InstantiationType.Delayed)}),define(De[90],Ie([1,0,23,41,40,73,16,20,21,32,267]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=g,e.isDocumentExcludePattern=u,e.notebookDocumentFilterMatch=E,e.isTextStreamMime=w,e.compressOutputItemStreams=D,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var b;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(b||(e.CellKind=b={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",O.Mimes.latex,O.Mimes.markdown,"image/png","image/jpeg",O.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[O.Mimes.latex,O.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var c;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(c||(e.NotebookRunState=c={}));var C;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(C||(e.NotebookCellExecutionState=C={}));var h;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(h||(e.NotebookExecutionState=h={}));var r;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var a;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var d;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(d||(e.SelectionStateType=d={}));var t;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(t||(e.CellEditType=t={}));var s;(function(F){F.scheme=A.Schemas.vscodeNotebookCell;function Y(ve,se){return(0,T.generate)(ve,se)}F.generate=Y;function re(ve){return(0,T.parse)(ve)}F.parse=re;function fe(ve,se){return ve.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${se??""},${ve.scheme!==A.Schemas.file?ve.scheme:""}`})}F.generateCellOutputUri=fe;function Ee(ve){if(ve.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ve.fragment);if(!se)return;const Te=se[1]&&se[1]!==""?se[1]:void 0,Me=se[2];return{outputId:Te,notebook:ve.with({scheme:Me||A.Schemas.file,fragment:null})}}F.parseCellOutputUri=Ee;function oe(ve,se,Te){return F.generate(ve,se).with({scheme:Te})}F.generateCellPropertyUri=oe;function pe(ve,se){if(ve.scheme===se)return F.parse(ve.with({scheme:F.scheme}))}F.parseCellPropertyUri=pe})(s||(e.CellUri=s={}));const n=F=>v.isWindows?F.replace(/\//g,"\\"):F;class i{constructor(Y=[],re=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=re,this.order=[...new Set(Y)].map(fe=>({pattern:fe,matches:k.parse(n(fe))}))}sort(Y){const re=new Map(P.Iterable.map(Y,Ee=>[Ee,n(Ee)]));let fe=[];for(const{matches:Ee}of this.order)for(const[oe,pe]of re)if(Ee(pe)){fe.push(oe),re.delete(oe);break}return re.size&&(fe=fe.concat([...re.keys()].sort((Ee,oe)=>this.defaultOrder.indexOf(Ee)-this.defaultOrder.indexOf(oe)))),fe}prioritize(Y,re){const fe=this.findIndex(Y);if(fe===-1){this.order.unshift({pattern:Y,matches:k.parse(n(Y))});return}const Ee=new Set(re.map(pe=>this.findIndex(pe,fe)));Ee.delete(-1);const oe=Array.from(Ee).sort();this.order.splice(fe+1,0,...oe.map(pe=>this.order[pe]));for(let pe=oe.length-1;pe>=0;pe--)this.order.splice(oe[pe],1)}toArray(){return this.order.map(Y=>Y.pattern)}findIndex(Y,re=this.order.length){const fe=n(Y);for(let Ee=0;Ee<re;Ee++)if(this.order[Ee].matches(fe))return Ee;return-1}}e.MimeTypeDisplayOrder=i;function g(F,Y,re,fe=(Ee,oe)=>Ee===oe){const Ee=[];function oe(se,Te,Me){if(Te===0&&Me.length===0)return;const Q=Ee[Ee.length-1];Q&&Q.start+Q.deleteCount===se?(Q.deleteCount+=Te,Q.toInsert.push(...Me)):Ee.push({start:se,deleteCount:Te,toInsert:Me})}let pe=0,ve=0;for(;;){if(pe===F.length){oe(pe,0,Y.slice(ve));break}if(ve===Y.length){oe(pe,F.length-pe,[]);break}const se=F[pe],Te=Y[ve];if(fe(se,Te)){pe+=1,ve+=1;continue}re(Te)?(oe(pe,1,[]),pe+=1):(oe(pe,0,[Te]),ve+=1)}return Ee}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new l.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new l.RawContextKey("notebookEditorCursorAtLineBoundary","none");var f;(function(F){F.default="default",F.option="option"})(f||(e.NotebookEditorPriority=f={}));function u(F){const Y=F;return!!((typeof Y.include=="string"||k.isRelativePattern(Y.include))&&(typeof Y.exclude=="string"||k.isRelativePattern(Y.exclude)))}function E(F,Y,re){if(Array.isArray(F.viewType)&&F.viewType.indexOf(Y)>=0||F.viewType===Y)return!0;if(F.filenamePattern){const fe=u(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,Ee=u(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(k.match(fe,(0,R.basename)(re.fsPath).toLowerCase()))return!(Ee&&k.match(Ee,(0,R.basename)(re.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var I;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(I||(e.CellStatusbarAlignment=I={}));class _{static{this._prefix="notebook/"}static create(Y){return`${_._prefix}${Y}`}static parse(Y){if(Y.startsWith(_._prefix))return Y.substring(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_;function w(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}const p=new TextDecoder;function D(F){const Y=[];let re=!1;for(const pe of F)(Y.length===0||re)&&(Y.push(pe),re=!0);let fe=M(Y);const Ee=y.VSBuffer.concat(Y.map(pe=>y.VSBuffer.wrap(pe))),oe=N(Ee);return fe=fe||oe.byteLength!==Ee.byteLength,{data:oe,didCompression:fe}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const m=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(F=>F.charCodeAt(0)),S=10;function M(F){let Y=!1;return F.forEach((re,fe)=>{if(fe===0||re.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const Ee=F[fe-1],oe=re.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(oe[0]===m[0]&&oe[1]===m[1]&&oe[2]===m[2]){const pe=Ee.lastIndexOf(S);if(pe===-1)return;Y=!0,F[fe-1]=Ee.subarray(0,pe),F[fe]=re.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),Y}function L(F){let Y=F;do F=Y,Y=F.replace(/[^\n]\x08/gm,"");while(Y.length<F.length);return F}function H(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const Y=F.match(/^(.*)\r+/m)[1];let re=F.match(/\r+(.*)$/m)[1];re=re+Y.slice(re.length,Y.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,re)}return F}const V=8,$=13;function N(F){return!F.buffer.includes(V)&&!F.buffer.includes($)?F:y.VSBuffer.fromString(H(L(p.decode(F.buffer))))}}),define(De[7],Ie([1,0,18,14,59,29,73,13,15,2,36,19,30,108,90]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h){"use strict";var r,o,a,d,t,s,n,i,g,f,u,E,I,_,w,p,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseTextEditPart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart2=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugThread=e.DebugStackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropOrPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.HoverVerbosityAction=e.VerboseHover=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.asStatusBarItemIdentifier=lt,e.setBreakpointId=ki,e.validateTestCoverageCount=yn;function m(z){return Object.assign(z,{apply:function(...ne){if(ne.length===0)return Reflect.construct(z,[]);{const Ce=ne.length===1?[]:ne[1];return Reflect.construct(z,Ce,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(z,[]);{const[Ce,...Ke]=ne;return Reflect.construct(z,Ke,Ce.constructor)}}})}var S;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(S||(e.TerminalOutputAnchor=S={}));var M;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let L=r=class{static from(...U){let ne=U;return new r(function(){if(ne){for(const Ce of ne)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();ne=void 0}})}#e;constructor(U){this.#e=U}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=L,e.Disposable=L=r=je([m],L);let H=o=class{static Min(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let Ce=1;Ce<U.length;Ce++){const Ke=U[Ce];Ke.isBefore(ne)&&(ne=Ke)}return ne}static Max(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let Ce=1;Ce<U.length;Ce++){const Ke=U[Ce];Ke.isAfter(ne)&&(ne=Ke)}return ne}static isPosition(U){if(!U)return!1;if(U instanceof o)return!0;const{line:ne,character:Ce}=U;return typeof ne=="number"&&typeof Ce=="number"}static of(U){if(U instanceof o)return U;if(this.isPosition(U))return new o(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(U,ne){if(U<0)throw(0,k.illegalArgument)("line must be non-negative");if(ne<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=U,this._character=ne}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,ne=0){if(U===null||ne===null)throw(0,k.illegalArgument)();let Ce;return typeof U>"u"?Ce=0:typeof U=="number"?Ce=U:(Ce=typeof U.lineDelta=="number"?U.lineDelta:0,ne=typeof U.characterDelta=="number"?U.characterDelta:0),Ce===0&&ne===0?this:new o(this.line+Ce,this.character+ne)}with(U,ne=this.character){if(U===null||ne===null)throw(0,k.illegalArgument)();let Ce;return typeof U>"u"?Ce=this.line:typeof U=="number"?Ce=U:(Ce=typeof U.line=="number"?U.line:this.line,ne=typeof U.character=="number"?U.character:this.character),Ce===this.line&&ne===this.character?this:new o(Ce,ne)}toJSON(){return{line:this.line,character:this.character}}};e.Position=H,e.Position=H=o=je([m],H);let V=a=class{static isRange(U){return U instanceof a?!0:U?H.isPosition(U.start)&&H.isPosition(U.end):!1}static of(U){if(U instanceof a)return U;if(this.isRange(U))return new a(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(U,ne,Ce,Ke){let et,dt;if(typeof U=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(et=new H(U,ne),dt=new H(Ce,Ke)):H.isPosition(U)&&H.isPosition(ne)&&(et=H.of(U),dt=H.of(ne)),!et||!dt)throw new Error("Invalid arguments");et.isBefore(dt)?(this._start=et,this._end=dt):(this._start=dt,this._end=et)}contains(U){return a.isRange(U)?this.contains(U.start)&&this.contains(U.end):H.isPosition(U)?!(H.of(U).isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const ne=H.Max(U.start,this._start),Ce=H.Min(U.end,this._end);if(!ne.isAfter(Ce))return new a(ne,Ce)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ne=H.Min(U.start,this._start),Ce=H.Max(U.end,this.end);return new a(ne,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,ne=this.end){if(U===null||ne===null)throw(0,k.illegalArgument)();let Ce;return U?H.isPosition(U)?Ce=U:(Ce=U.start||this.start,ne=U.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&ne.isEqual(this.end)?this:new a(Ce,ne)}toJSON(){return[this.start,this.end]}};e.Range=V,e.Range=V=a=je([m],V);let $=d=class extends V{static isSelection(U){return U instanceof d?!0:U?V.isRange(U)&&H.isPosition(U.anchor)&&H.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(U,ne,Ce,Ke){let et,dt;if(typeof U=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(et=new H(U,ne),dt=new H(Ce,Ke)):H.isPosition(U)&&H.isPosition(ne)&&(et=H.of(U),dt=H.of(ne)),!et||!dt)throw new Error("Invalid arguments");super(et,dt),this._anchor=et,this._active=dt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=$,e.Selection=$=d=je([m],$);const N=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,k.illegalArgument)("connectionToken")};class F{static isResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.host=="string"&&typeof U.port=="number"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,ne,Ce){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,k.illegalArgument)("port");typeof Ce<"u"&&N(Ce),this.host=U,this.port=Math.round(ne),this.connectionToken=Ce}}e.ResolvedAuthority=F;class Y{static isManagedResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.makeConnection=="function"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,ne){this.makeConnection=U,this.connectionToken=ne,typeof ne<"u"&&N(ne)}}e.ManagedResolvedAuthority=Y;class re extends Error{static NotAvailable(U,ne){return new re(U,C.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(U){return new re(U,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ne=C.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(U),this._message=U,this._code=ne,this._detail=Ce,Object.setPrototypeOf(this,re.prototype)}}e.RemoteAuthorityResolverError=re;var fe;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(fe||(e.EndOfLine=fe={}));var Ee;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(Ee||(e.EnvironmentVariableMutatorType=Ee={}));let oe=t=class{static isTextEdit(U){return U instanceof t?!0:U?V.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ne){return new t(U,ne)}static insert(U,ne){return t.replace(new V(U,U),ne)}static delete(U){return t.replace(U,"")}static setEndOfLine(U){const ne=new t(new V(new H(0,0),new H(0,0)),"");return ne.newEol=U,ne}get range(){return this._range}set range(U){if(U&&!V.isRange(U))throw(0,k.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,k.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,k.illegalArgument)("newEol");this._newEol=U}constructor(U,ne){this._range=U,this._newText=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=oe,e.TextEdit=oe=t=je([m],oe);let pe=s=class{static isNotebookCellEdit(U){return U instanceof s?!0:U?Ei.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ne){return new s(U,ne)}static insertCells(U,ne){return new s(new Ei(U,U),ne)}static deleteCells(U){return new s(U,[])}static updateCellMetadata(U,ne){const Ce=new s(new Ei(U,U),[]);return Ce.newCellMetadata=ne,Ce}static updateNotebookMetadata(U){const ne=new s(new Ei(0,0),[]);return ne.newNotebookMetadata=U,ne}constructor(U,ne){this.range=U,this.newCells=ne}};e.NotebookEdit=pe,e.NotebookEdit=pe=s=je([m],pe);class ve{static isSnippetTextEdit(U){return U instanceof ve?!0:U?V.isRange(U.range)&&Me.isSnippetString(U.snippet):!1}static replace(U,ne){return new ve(U,ne)}static insert(U,ne){return ve.replace(new V(U,U),ne)}constructor(U,ne){this.range=U,this.snippet=ne}}e.SnippetTextEdit=ve;var se;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Te=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,ne,Ce,Ke){this._edits.push({_type:se.File,from:U,to:ne,options:Ce,metadata:Ke})}createFile(U,ne,Ce){this._edits.push({_type:se.File,from:void 0,to:U,options:ne,metadata:Ce})}deleteFile(U,ne,Ce){this._edits.push({_type:se.File,from:U,to:void 0,options:ne,metadata:Ce})}replaceNotebookMetadata(U,ne,Ce){this._edits.push({_type:se.Cell,metadata:Ce,uri:U,edit:{editType:h.CellEditType.DocumentMetadata,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(U,ne,Ce,Ke){const et=ne.start,dt=ne.end;(et!==dt||Ce.length>0)&&this._edits.push({_type:se.CellReplace,uri:U,index:et,count:dt-et,cells:Ce,metadata:Ke})}replaceNotebookCellMetadata(U,ne,Ce,Ke){this._edits.push({_type:se.Cell,metadata:Ke,uri:U,edit:{editType:h.CellEditType.Metadata,index:ne,metadata:Ce}})}replace(U,ne,Ce,Ke){this._edits.push({_type:se.Text,uri:U,edit:new oe(ne,Ce),metadata:Ke})}insert(U,ne,Ce,Ke){this.replace(U,new V(ne,ne),Ce,Ke)}delete(U,ne,Ce){this.replace(U,ne,"",Ce)}has(U){return this._edits.some(ne=>ne._type===se.Text&&ne.uri.toString()===U.toString())}set(U,ne){if(ne)for(const Ce of ne){if(!Ce)continue;let Ke,et;Array.isArray(Ce)?(Ke=Ce[0],et=Ce[1]):Ke=Ce,pe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata(U,Ke.range.start,Ke.newCellMetadata,et):Ke.newNotebookMetadata?this.replaceNotebookMetadata(U,Ke.newNotebookMetadata,et):this.replaceNotebookCells(U,Ke.range,Ke.newCells,et):ve.isSnippetTextEdit(Ke)?this._edits.push({_type:se.Snippet,uri:U,range:Ke.range,edit:Ke.snippet,metadata:et}):this._edits.push({_type:se.Text,uri:U,edit:Ke,metadata:et})}else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ke=this._edits[Ce];switch(Ke._type){case se.Text:case se.Snippet:case se.Cell:case se.CellReplace:Ke.uri.toString()===U.toString()&&(this._edits[Ce]=void 0);break}}(0,y.coalesceInPlace)(this._edits)}}get(U){const ne=[];for(const Ce of this._edits)Ce._type===se.Text&&Ce.uri.toString()===U.toString()&&ne.push(Ce.edit);return ne}entries(){const U=new O.ResourceMap;for(const ne of this._edits)if(ne._type===se.Text){let Ce=U.get(ne.uri);Ce||(Ce=[ne.uri,[]],U.set(ne.uri,Ce)),Ce[1].push(ne.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Te,e.WorkspaceEdit=Te=je([m],Te);let Me=n=class{static isSnippetString(U){return U instanceof n?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this._tabstop=1,this.value=U||""}appendText(U){return this.value+=n._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ne=this._tabstop++){if(typeof U=="function"){const Ce=new n;Ce._tabstop=this._tabstop,U(Ce),this._tabstop=Ce._tabstop,U=Ce.value}else U=n._escape(U);return this.value+="${",this.value+=ne,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ne=this._tabstop++){const Ce=U.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(U,ne){if(typeof ne=="function"){const Ce=new n;Ce._tabstop=this._tabstop,ne(Ce),this._tabstop=Ce._tabstop,ne=Ce.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.SnippetString=Me,e.SnippetString=Me=n=je([m],Me);var Q;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Q||(e.DiagnosticTag=Q={}));var W;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let ie=i=class{static isLocation(U){return U instanceof i?!0:U?V.isRange(U.range)&&l.URI.isUri(U.uri):!1}constructor(U,ne){if(this.uri=U,ne)if(V.isRange(ne))this.range=V.of(ne);else if(H.isPosition(ne))this.range=new V(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=ie,e.Location=ie=i=je([m],ie);let _e=class{static is(U){return U?typeof U.message=="string"&&U.location&&V.isRange(U.location.range)&&l.URI.isUri(U.location.uri):!1}constructor(U,ne){this.location=U,this.message=ne}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.location.range.isEqual(ne.location.range)&&U.location.uri.toString()===ne.location.uri.toString()}};e.DiagnosticRelatedInformation=_e,e.DiagnosticRelatedInformation=_e=je([m],_e);let de=class{constructor(U,ne,Ce=W.Error){if(!V.isRange(U))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=U,this.message=ne,this.severity=Ce}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.severity===ne.severity&&U.code===ne.code&&U.severity===ne.severity&&U.source===ne.source&&U.range.isEqual(ne.range)&&(0,y.equals)(U.tags,ne.tags)&&(0,y.equals)(U.relatedInformation,ne.relatedInformation,_e.isEqual)}};e.Diagnostic=de,e.Diagnostic=de=je([m],de);let Se=class{constructor(U,ne){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ne}};e.Hover=Se,e.Hover=Se=je([m],Se);let ae=class extends Se{constructor(U,ne,Ce,Ke){super(U,ne),this.canIncreaseHover=Ce,this.canDecreaseHover=Ke}};e.VerboseHover=ae,e.VerboseHover=ae=je([m],ae);var X;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})(X||(e.HoverVerbosityAction=X={}));var J;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(J||(e.DocumentHighlightKind=J={}));let me=class{constructor(U,ne=J.Text){this.range=U,this.kind=ne}toJSON(){return{range:this.range,kind:J[this.kind]}}};e.DocumentHighlight=me,e.DocumentHighlight=me=je([m],me);let ge=class{constructor(U,ne){this.uri=U,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(U=>U.toJSON())}}};e.MultiDocumentHighlight=ge,e.MultiDocumentHighlight=ge=je([m],ge);var Le;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Le||(e.SymbolKind=Le={}));var ze;(function(z){z[z.Deprecated=1]="Deprecated"})(ze||(e.SymbolTag=ze={}));let ye=g=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ne,Ce,Ke,et){this.name=U,this.kind=ne,this.containerName=et,typeof Ce=="string"&&(this.containerName=Ce),Ke instanceof ie?this.location=Ke:Ce instanceof V&&(this.location=new ie(Ke,Ce)),g.validate(this)}toJSON(){return{name:this.name,kind:Le[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=ye,e.SymbolInformation=ye=g=je([m],ye);let ke=f=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(f.validate)}constructor(U,ne,Ce,Ke,et){this.name=U,this.detail=ne,this.kind=Ce,this.range=Ke,this.selectionRange=et,this.children=[],f.validate(this)}};e.DocumentSymbol=ke,e.DocumentSymbol=ke=f=je([m],ke);var Oe;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let B=class{constructor(U,ne){this.title=U,this.kind=ne}};e.CodeAction=B,e.CodeAction=B=je([m],B);let x=class{static{u=this}static{this.sep="."}constructor(U){this.value=U}append(U){return new u(this.value?this.value+u.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+u.sep)}};e.CodeActionKind=x,e.CodeActionKind=x=u=je([m],x),x.Empty=new x(""),x.QuickFix=x.Empty.append("quickfix"),x.Refactor=x.Empty.append("refactor"),x.RefactorExtract=x.Refactor.append("extract"),x.RefactorInline=x.Refactor.append("inline"),x.RefactorMove=x.Refactor.append("move"),x.RefactorRewrite=x.Refactor.append("rewrite"),x.Source=x.Empty.append("source"),x.SourceOrganizeImports=x.Source.append("organizeImports"),x.SourceFixAll=x.Source.append("fixAll"),x.Notebook=x.Empty.append("notebook");let q=class{constructor(U,ne){if(this.range=U,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=q,e.SelectionRange=q=je([m],q);class K{constructor(U,ne,Ce,Ke,et,dt){this.kind=U,this.name=ne,this.detail=Ce,this.uri=Ke,this.range=et,this.selectionRange=dt}}e.CallHierarchyItem=K;class te{constructor(U,ne){this.fromRanges=ne,this.from=U}}e.CallHierarchyIncomingCall=te;class ue{constructor(U,ne){this.fromRanges=ne,this.to=U}}e.CallHierarchyOutgoingCall=ue;var Ae;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let Be=class{constructor(U,ne){this.range=U,this.command=ne}get isResolved(){return!!this.command}};e.CodeLens=Be,e.CodeLens=Be=je([m],Be);let He=E=class{#e;static isMarkdownString(U){return U instanceof E?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ne=!1){this.#e=new P.MarkdownString(U,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(U){this.#e.value=U}get isTrusted(){return this.#e.isTrusted}set isTrusted(U){this.#e.isTrusted=U}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(U){this.#e.supportThemeIcons=U}get supportHtml(){return this.#e.supportHtml}set supportHtml(U){this.#e.supportHtml=U}get baseUri(){return this.#e.baseUri}set baseUri(U){this.#e.baseUri=U}appendText(U){return this.#e.appendText(U),this}appendMarkdown(U){return this.#e.appendMarkdown(U),this}appendCodeblock(U,ne){return this.#e.appendCodeblock(ne??"",U),this}};e.MarkdownString=He,e.MarkdownString=He=E=je([m],He);let Ye=class{constructor(U,ne){this.label=U,this.documentation=ne}};e.ParameterInformation=Ye,e.ParameterInformation=Ye=je([m],Ye);let tt=class{constructor(U,ne){this.label=U,this.documentation=ne,this.parameters=[]}};e.SignatureInformation=tt,e.SignatureInformation=tt=je([m],tt);let Ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Ze,e.SignatureHelp=Ze=je([m],Ze);var it;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var nt;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(nt||(e.InlayHintKind=nt={}));let mt=class{constructor(U){this.value=U}};e.InlayHintLabelPart=mt,e.InlayHintLabelPart=mt=je([m],mt);let ut=class{constructor(U,ne,Ce){this.position=U,this.label=ne,this.kind=Ce}};e.InlayHint=ut,e.InlayHint=ut=je([m],ut);var rt;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(rt||(e.CompletionTriggerKind=rt={}));var at;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(at||(e.CompletionItemKind=at={}));var ht;(function(z){z[z.Deprecated=1]="Deprecated"})(ht||(e.CompletionItemTag=ht={}));let We=class{constructor(U,ne){this.label=U,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=We,e.CompletionItem=We=je([m],We);let xe=class{constructor(U=[],ne=!1){this.items=U,this.isIncomplete=ne}};e.CompletionList=xe,e.CompletionList=xe=je([m],xe);let Z=class{constructor(U,ne,Ce){this.insertText=U,this.range=ne,this.command=Ce}};e.InlineSuggestion=Z,e.InlineSuggestion=Z=je([m],Z);let j=class{constructor(U){this.commands=void 0,this.suppressSuggestions=void 0,this.items=U}};e.InlineSuggestionList=j,e.InlineSuggestionList=j=je([m],j);var we;(function(z){z[z.Unknown=0]="Unknown",z[z.Word=1]="Word",z[z.Line=2]="Line",z[z.Suggest=3]="Suggest"})(we||(e.PartialAcceptTriggerKind=we={}));var qe;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(qe||(e.ViewColumn=qe={}));var Je;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Je||(e.StatusBarAlignment=Je={}));function lt(z,U){return`${b.ExtensionIdentifier.toKey(z)}.${U}`}var gt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(gt||(e.TextEditorLineNumbersStyle=gt={}));var Rt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Rt||(e.TextDocumentSaveReason=Rt={}));var Gt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var Ut;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var ui;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ui||(e.TextDocumentChangeReason=ui={}));var Jt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Jt||(e.DecorationRangeBehavior=Jt={})),function(z){function U(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var Xe;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(Xe||(e.SyntaxTokenType=Xe={})),function(z){function U(ne){switch(ne){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=U}(Xe||(e.SyntaxTokenType=Xe={}));let Wt=class{constructor(U,ne){if(ne&&!l.URI.isUri(ne))throw(0,k.illegalArgument)("target");if(!V.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.target=ne}};e.DocumentLink=Wt,e.DocumentLink=Wt=je([m],Wt);let xt=class{constructor(U,ne,Ce,Ke){this.red=U,this.green=ne,this.blue=Ce,this.alpha=Ke}};e.Color=xt,e.Color=xt=je([m],xt);let ft=class{constructor(U,ne){if(ne&&!(ne instanceof xt))throw(0,k.illegalArgument)("color");if(!V.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.color=ne}};e.ColorInformation=ft,e.ColorInformation=ft=je([m],ft);let pt=class{constructor(U){if(!U||typeof U!="string")throw(0,k.illegalArgument)("label");this.label=U}};e.ColorPresentation=pt,e.ColorPresentation=pt=je([m],pt);var Zt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Zt||(e.ColorFormat=Zt={}));var Xt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Xt||(e.SourceControlInputBoxValidationType=Xt={}));var Bt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(Bt||(e.TerminalExitReason=Bt={}));var Et;(function(z){z[z.Low=0]="Low",z[z.Medium=1]="Medium",z[z.High=2]="High"})(Et||(e.TerminalShellExecutionCommandLineConfidence=Et={}));class Ot{constructor(U,ne,Ce){if(this.startIndex=U,this.length=ne,this.tooltip=Ce,typeof U!="number"||U<0)throw(0,k.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,k.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=Ot;class Ht{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Ht;class zt{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=zt;var Ge;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(Ge||(e.TerminalLocation=Ge={}));class ei{constructor(U){if(this.options=U,typeof U!="object")throw(0,k.illegalArgument)("options")}}e.TerminalProfile=ei;var ti;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(ti||(e.TaskRevealKind=ti={}));var li;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(li||(e.TaskPanelKind=li={}));let _t=class{static{I=this}static{this.Clean=new I("clean","Clean")}static{this.Build=new I("build","Build")}static{this.Rebuild=new I("rebuild","Rebuild")}static{this.Test=new I("test","Test")}static from(U){switch(U){case"clean":return I.Clean;case"build":return I.Build;case"rebuild":return I.Rebuild;case"test":return I.Test;default:return}}constructor(U,ne){if(this.label=ne,typeof U!="string"||typeof ne!="string")throw(0,k.illegalArgument)("name");this._id=U}get id(){return this._id}};e.TaskGroup=_t,e.TaskGroup=_t=I=je([m],_t);function Lt(z){let U="";for(let ne=0;ne<z.length;ne++)U+=z[ne].replace(/,/g,",,")+",";return U}let Pt=class{constructor(U,ne,Ce){if(typeof U!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=U,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Ce):this._options=ne)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,k.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(const ne of this._args)U.push(ne);return Lt(U)}};e.ProcessExecution=Pt,e.ProcessExecution=Pt=je([m],Pt);let Nt=class{constructor(U,ne,Ce){if(this._args=[],Array.isArray(ne)){if(!U)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this._command=U,this._args=ne,this._options=Ce}else{if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=U,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ne of this._args)U.push(typeof ne=="string"?ne:ne.value);return Lt(U)}};e.ShellExecution=Nt,e.ShellExecution=Nt=je([m],Nt);var ci;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ci||(e.ShellQuoting=ci={}));var $t;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})($t||(e.TaskScope=$t={}));class ri{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=ri;let Ft=class{static{_=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(U,ne,Ce,Ke,et,dt){this.__deprecated=!1,this._definition=this.definition=U;let bt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Ce,this.execution=Ke,bt=et,this.__deprecated=!0):ne===$t.Global||ne===$t.Workspace?(this.target=ne,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=et,bt=dt):(this.target=ne,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=et,bt=dt),typeof bt=="string"?(this._problemMatchers=[bt],this._hasDefinedMatchers=!0):Array.isArray(bt)?(this._problemMatchers=bt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Pt?this._definition={type:_.ProcessType,id:this._execution.computeId()}:this._execution instanceof Nt?this._definition={type:_.ShellType,id:this._execution.computeId()}:this._execution instanceof ri?this._definition={type:_.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:_.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const ne=this._definition.type;(_.EmptyType===ne||_.ProcessType===ne||_.ShellType===ne||_.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};e.Task=Ft,e.Task=Ft=_=je([m],Ft);var Qt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Qt||(e.ProgressLocation=Qt={}));var si;(function(z){function U(ne){const Ce=ne;return(0,v.isNumber)(Ce.value)?Ce.tooltip&&!(0,v.isString)(Ce.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ce.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ce.value),!1)}z.isViewBadge=U})(si||(e.ViewBadge=si={}));let Tt=w=class{static isTreeItem(U,ne){const Ce=U;if(Ce.checkboxState!==void 0){const Ke=(0,v.isNumber)(Ce.checkboxState)?Ce.checkboxState:(0,v.isObject)(Ce.checkboxState)&&(0,v.isNumber)(Ce.checkboxState.state)?Ce.checkboxState.state:void 0,et=!(0,v.isNumber)(Ce.checkboxState)&&(0,v.isObject)(Ce.checkboxState)?Ce.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==vt.Checked&&Ke!==vt.Unchecked||et!==void 0&&!(0,v.isString)(et))return console.log("INVALID tree item, invalid checkboxState",Ce.checkboxState),!1}if(U instanceof w)return!0;if(Ce.label!==void 0&&!(0,v.isString)(Ce.label)&&!Ce.label?.label)return console.log("INVALID tree item, invalid label",Ce.label),!1;if(Ce.id!==void 0&&!(0,v.isString)(Ce.id))return console.log("INVALID tree item, invalid id",Ce.id),!1;if(Ce.iconPath!==void 0&&!(0,v.isString)(Ce.iconPath)&&!l.URI.isUri(Ce.iconPath)&&(!Ce.iconPath||!(0,v.isString)(Ce.iconPath.id))){const Ke=Ce.iconPath;if(!Ke||!(0,v.isString)(Ke.light)&&!l.URI.isUri(Ke.light)&&!(0,v.isString)(Ke.dark)&&!l.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ce.iconPath),!1}return Ce.description!==void 0&&!(0,v.isString)(Ce.description)&&typeof Ce.description!="boolean"?(console.log("INVALID tree item, invalid description",Ce.description),!1):Ce.resourceUri!==void 0&&!l.URI.isUri(Ce.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ce.resourceUri),!1):Ce.tooltip!==void 0&&!(0,v.isString)(Ce.tooltip)&&!(Ce.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Ce.tooltip),!1):Ce.command!==void 0&&!Ce.command.command?(console.log("INVALID tree item, invalid command",Ce.command),!1):Ce.collapsibleState!==void 0&&Ce.collapsibleState<St.None&&Ce.collapsibleState>St.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ce.collapsibleState),!1):Ce.contextValue!==void 0&&!(0,v.isString)(Ce.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ce.contextValue),!1):Ce.accessibilityInformation!==void 0&&!Ce.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ce.accessibilityInformation),!1):!0}constructor(U,ne=St.None){this.collapsibleState=ne,l.URI.isUri(U)?this.resourceUri=U:this.label=U}};e.TreeItem=Tt,e.TreeItem=Tt=w=je([m],Tt);var St;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(St||(e.TreeItemCollapsibleState=St={}));var vt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(vt||(e.TreeItemCheckboxState=vt={}));let Vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U){this.value=U}};e.DataTransferItem=Vt,e.DataTransferItem=Vt=je([m],Vt);class Ct extends Vt{}e.InternalDataTransferItem=Ct;class oi extends Ct{#e;constructor(U){super(""),this.#e=U}asFile(){return this.#e}}e.InternalFileDataTransferItem=oi;class qt{constructor(U,ne,Ce,Ke){this.name=U,this.uri=ne,this._itemId=Ce,this._getData=Ke}data(){return this._getData()}}e.DataTransferFile=qt;let pi=class{#e=new Map;constructor(U){for(const[ne,Ce]of U??[]){const Ke=this.#e.get(this.#t(ne));Ke?Ke.push(Ce):this.#e.set(this.#t(ne),[Ce])}}get(U){return this.#e.get(this.#t(U))?.[0]}set(U,ne){this.#e.set(this.#t(U),[ne])}forEach(U,ne){for(const[Ce,Ke]of this.#e)for(const et of Ke)U.call(ne,et,Ce,this)}*[Symbol.iterator](){for(const[U,ne]of this.#e)for(const Ce of ne)yield[U,Ce]}#t(U){return U.toLowerCase()}};e.DataTransfer=pi,e.DataTransfer=pi=je([m],pi);let hi=class{constructor(U,ne,Ce){this.insertText=U,this.title=ne,this.kind=Ce}};e.DocumentDropEdit=hi,e.DocumentDropEdit=hi=je([m],hi);var Di;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(Di||(e.DocumentPasteTriggerKind=Di={}));class kt{static{this.sep="."}constructor(U){this.value=U}append(...U){return new kt((this.value?[this.value,...U]:U).join(kt.sep))}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+kt.sep)}}e.DocumentDropOrPasteEditKind=kt,kt.Empty=new kt("");class Pi{constructor(U,ne,Ce){this.title=ne,this.insertText=U,this.kind=Ce}}e.DocumentPasteEdit=Pi;let ai=class{constructor(U,ne){this.id=U,this.color=ne}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};e.ThemeIcon=ai,e.ThemeIcon=ai=je([m],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let It=class{constructor(U){this.id=U}};e.ThemeColor=It,e.ThemeColor=It=je([m],It);var Ii;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ii||(e.ConfigurationTarget=Ii={}));let Si=class{get base(){return this._base}set base(U){this._base=U,this._baseUri=l.URI.file(U)}get baseUri(){return this._baseUri}set baseUri(U){this._baseUri=U,this._base=U.fsPath}constructor(U,ne){if(typeof U!="string"&&(!U||!l.URI.isUri(U)&&!l.URI.isUri(U.uri)))throw(0,k.illegalArgument)("base");if(typeof ne!="string")throw(0,k.illegalArgument)("pattern");typeof U=="string"?this.baseUri=l.URI.file(U):l.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Si,e.RelativePattern=Si=je([m],Si);const vi=new WeakMap;function ki(z,U){vi.set(z,U)}let fi=class{constructor(U,ne,Ce,Ke,et){this.enabled=typeof U=="boolean"?U:!0,typeof ne=="string"&&(this.condition=ne),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ke=="string"&&(this.logMessage=Ke),typeof et=="string"&&(this.mode=et)}get id(){return this._id||(this._id=vi.get(this)??(0,T.generateUuid)()),this._id}};e.Breakpoint=fi,e.Breakpoint=fi=je([m],fi);let be=class extends fi{constructor(U,ne,Ce,Ke,et,dt){if(super(ne,Ce,Ke,et,dt),U===null)throw(0,k.illegalArgument)("location");this.location=U}};e.SourceBreakpoint=be,e.SourceBreakpoint=be=je([m],be);let Re=class extends fi{constructor(U,ne,Ce,Ke,et,dt){super(ne,Ce,Ke,et,dt),this.functionName=U}};e.FunctionBreakpoint=Re,e.FunctionBreakpoint=Re=je([m],Re);let ce=class extends fi{constructor(U,ne,Ce,Ke,et,dt,bt,Kt){if(super(Ke,et,dt,bt,Kt),!ne)throw(0,k.illegalArgument)("dataId");this.label=U,this.dataId=ne,this.canPersist=Ce}};e.DataBreakpoint=ce,e.DataBreakpoint=ce=je([m],ce);let G=class{constructor(U,ne,Ce){this.command=U,this.args=ne||[],this.options=Ce}};e.DebugAdapterExecutable=G,e.DebugAdapterExecutable=G=je([m],G);let Pe=class{constructor(U,ne){this.port=U,this.host=ne}};e.DebugAdapterServer=Pe,e.DebugAdapterServer=Pe=je([m],Pe);let Ue=class{constructor(U){this.path=U}};e.DebugAdapterNamedPipeServer=Ue,e.DebugAdapterNamedPipeServer=Ue=je([m],Ue);let Qe=class{constructor(U){this.implementation=U}};e.DebugAdapterInlineImplementation=Qe,e.DebugAdapterInlineImplementation=Qe=je([m],Qe);class Ve{constructor(U,ne,Ce){this.session=U,this.threadId=ne,this.frameId=Ce}}e.DebugStackFrame=Ve;class ct{constructor(U,ne){this.session=U,this.threadId=ne}}e.DebugThread=ct;let Dt=class{constructor(U,ne){this.range=U,this.expression=ne}};e.EvaluatableExpression=Dt,e.EvaluatableExpression=Dt=je([m],Dt);var Yt;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Yt||(e.InlineCompletionTriggerKind=Yt={}));let ii=class{constructor(U,ne){this.range=U,this.text=ne}};e.InlineValueText=ii,e.InlineValueText=ii=je([m],ii);let Mt=class{constructor(U,ne,Ce=!0){this.range=U,this.variableName=ne,this.caseSensitiveLookup=Ce}};e.InlineValueVariableLookup=Mt,e.InlineValueVariableLookup=Mt=je([m],Mt);let jt=class{constructor(U,ne){this.range=U,this.expression=ne}};e.InlineValueEvaluatableExpression=jt,e.InlineValueEvaluatableExpression=jt=je([m],jt);let Fi=class{constructor(U,ne){this.frameId=U,this.stoppedLocation=ne}};e.InlineValueContext=Fi,e.InlineValueContext=Fi=je([m],Fi);var Ui;(function(z){z[z.AIGenerated=1]="AIGenerated"})(Ui||(e.NewSymbolNameTag=Ui={}));var Qi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Qi||(e.NewSymbolNameTriggerKind=Qi={}));class xi{constructor(U,ne){this.newSymbolName=U,this.tags=ne}}e.NewSymbolName=xi;var Ri;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Bi=p=class extends Error{static FileExists(U){return new p(U,c.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(U){return new p(U,c.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(U){return new p(U,c.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(U){return new p(U,c.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(U){return new p(U,c.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(U){return new p(U,c.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(U,ne=c.FileSystemProviderErrorCode.Unknown,Ce){super(l.URI.isUri(U)?U.toString(!0):U),this.code=Ce?.name??"Unknown",(0,c.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}};e.FileSystemError=Bi,e.FileSystemError=Bi=p=je([m],Bi);let zi=class{constructor(U,ne,Ce){this.start=U,this.end=ne,this.kind=Ce}};e.FoldingRange=zi,e.FoldingRange=zi=je([m],zi);var wi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(wi||(e.FoldingRangeKind=wi={}));var Yi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Yi||(e.CommentThreadCollapsibleState=Yi={}));var Ji;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Ji||(e.CommentMode=Ji={}));var Li;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(Li||(e.CommentState=Li={}));var Wi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Wi||(e.CommentThreadState=Wi={}));var $i;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})($i||(e.CommentThreadApplicability=$i={}));class gn{constructor(U,ne=[]){this.tokenTypes=U,this.tokenModifiers=ne}}e.SemanticTokensLegend=gn;function Zi(z){return typeof z>"u"||(0,v.isStringArray)(z)}class Vi{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let ne=0,Ce=U.tokenTypes.length;ne<Ce;ne++)this._tokenTypeStrToInt.set(U.tokenTypes[ne],ne);for(let ne=0,Ce=U.tokenModifiers.length;ne<Ce;ne++)this._tokenModifierStrToInt.set(U.tokenModifiers[ne],ne)}}push(U,ne,Ce,Ke,et){if(typeof U=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this._pushEncoded(U,ne,Ce,Ke,et);if(V.isRange(U)&&typeof ne=="string"&&Zi(Ce))return this._push(U,ne,Ce);throw(0,k.illegalArgument)()}_push(U,ne,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,et=U.start.character,dt=U.end.character-U.start.character,bt=this._tokenTypeStrToInt.get(ne);let Kt=0;if(Ce)for(const di of Ce){if(!this._tokenModifierStrToInt.has(di))throw new Error("`tokenModifier` is not in the provided legend");const mi=this._tokenModifierStrToInt.get(di);Kt|=1<<mi>>>0}this._pushEncoded(Ke,et,dt,bt,Kt)}_pushEncoded(U,ne,Ce,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Kt=this._data.length/5|0;let di=0,mi=0;for(let bi=0;bi<Kt;bi++){let _i=this._data[5*bi],Gi=this._data[5*bi+1];_i===0?(_i=di,Gi+=mi):_i+=di,this._data[5*bi]=_i,this._data[5*bi+1]=Gi,di=_i,mi=Gi}}let dt=U,bt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(bt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=bt,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=U,this._prevChar=ne}static _sortAndDeltaEncode(U){const ne=[],Ce=U.length/5|0;for(let bt=0;bt<Ce;bt++)ne[bt]=bt;ne.sort((bt,Kt)=>{const di=U[5*bt],mi=U[5*Kt];if(di===mi){const bi=U[5*bt+1],_i=U[5*Kt+1];return bi-_i}return di-mi});const Ke=new Uint32Array(U.length);let et=0,dt=0;for(let bt=0;bt<Ce;bt++){const Kt=5*ne[bt],di=U[Kt+0],mi=U[Kt+1],bi=U[Kt+2],_i=U[Kt+3],Gi=U[Kt+4],Un=di-et,Er=Un===0?mi-dt:mi,Xi=5*bt;Ke[Xi+0]=Un,Ke[Xi+1]=Er,Ke[Xi+2]=bi,Ke[Xi+3]=_i,Ke[Xi+4]=Gi,et=di,dt=mi}return Ke}build(U){return this._dataIsSortedAndDeltaEncoded?new yi(new Uint32Array(this._data),U):new yi(Vi._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=Vi;class yi{constructor(U,ne){this.resultId=ne,this.data=U}}e.SemanticTokens=yi;class mn{constructor(U,ne,Ce){this.start=U,this.deleteCount=ne,this.data=Ce}}e.SemanticTokensEdit=mn;class pn{constructor(U,ne){this.resultId=ne,this.edits=U}}e.SemanticTokensEdits=pn;var en;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));class Hi{constructor(U){this.name=U}}e.DebugVisualization=Hi;let Oi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.QuickInputButtons=Oi,e.QuickInputButtons=Oi=je([m],Oi);var Fe;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Fe||(e.QuickPickItemKind=Fe={}));var gi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var qi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(qi||(e.ExtensionKind=qi={}));class st{static validate(U){if(typeof U.badge=="string"){let ne=(0,R.nextCharLength)(U.badge,0);if(ne<U.badge.length&&(ne+=(0,R.nextCharLength)(U.badge,ne)),U.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!ai.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ne,Ce){this.badge=U,this.tooltip=ne,this.color=Ce}}e.FileDecoration=st;let wt=class{constructor(U){this.kind=U}};e.ColorTheme=wt,e.ColorTheme=wt=je([m],wt);var tn;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(tn||(e.ColorThemeKind=tn={}));class Ei{static isNotebookRange(U){return U instanceof Ei?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(U,ne){if(U<0)throw(0,k.illegalArgument)("start must be positive");if(ne<0)throw(0,k.illegalArgument)("end must be positive");U<=ne?(this._start=U,this._end=ne):(this._start=ne,this._end=U)}with(U){let ne=this._start,Ce=this._end;return U.start!==void 0&&(ne=U.start),U.end!==void 0&&(Ce=U.end),ne===this._start&&Ce===this._end?this:new Ei(ne,Ce)}}e.NotebookRange=Ei;class Ai{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ne=>Ai.isNotebookCellData(ne))}static isNotebookCellData(U){return!0}constructor(U,ne,Ce,Ke,et,dt,bt){this.kind=U,this.value=ne,this.languageId=Ce,this.mime=Ke,this.outputs=et??[],this.metadata=dt,this.executionSummary=bt,Ai.validate(this)}}e.NotebookCellData=Ai;class vn{constructor(U){this.cells=U}}e.NotebookData=vn;class ni{static isNotebookCellOutputItem(U){return U instanceof ni?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ne={name:U.name,message:U.message,stack:U.stack};return ni.json(ne,"application/vnd.code.notebook.error")}static stdout(U){return ni.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return ni.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ne="application/octet-stream"){return new ni(U,ne)}static#e=new TextEncoder;static text(U,ne=A.Mimes.text){const Ce=ni.#e.encode(String(U));return new ni(Ce,ne)}static json(U,ne="text/x-json"){const Ce=JSON.stringify(U,void 0,"	");return ni.text(Ce,ne)}constructor(U,ne){this.data=U,this.mime=ne;const Ce=(0,A.normalizeMimeType)(ne,!0);if(!Ce)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}}e.NotebookCellOutputItem=ni;class Ni{static isNotebookCellOutput(U){return U instanceof Ni?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ne=!1){const Ce=new Set,Ke=new Set;for(let et=0;et<U.length;et++){const dt=U[et],bt=(0,A.normalizeMimeType)(dt.mime);if(!Ce.has(bt)||(0,h.isTextStreamMime)(bt)){Ce.add(bt);continue}Ke.add(et),ne&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ke.size===0?U:U.filter((et,dt)=>!Ke.has(dt))}constructor(U,ne,Ce){this.items=Ni.ensureUniqueMimeTypes(U,!0),typeof ne=="string"?(this.id=ne,this.metadata=Ce):(this.id=(0,T.generateUuid)(),this.metadata=ne??Ce)}}e.NotebookCellOutput=Ni;var nn;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(nn||(e.NotebookCellKind=nn={}));var rn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(rn||(e.NotebookCellExecutionState=rn={}));var ji;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ji||(e.NotebookCellStatusBarAlignment=ji={}));var sn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class En{constructor(U,ne){this.text=U,this.alignment=ne}}e.NotebookCellStatusBarItem=En;var on;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(on||(e.NotebookControllerAffinity=on={}));var an;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(an||(e.NotebookControllerAffinity2=an={}));class bn{constructor(U,ne=[]){this.uri=U,this.provides=(0,y.asArray)(ne)}}e.NotebookRendererScript=bn;class Sn{constructor(U){this.label=U}}e.NotebookKernelSourceAction=Sn;var ln;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(ln||(e.NotebookVariablesRequestKind=ln={}));let Ki=class{constructor(U,ne){this.label=U,this.timestamp=ne}};e.TimelineItem=Ki,e.TimelineItem=Ki=je([m],Ki);var cn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var dn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(dn||(e.StandardTokenType=dn={}));class ee{constructor(U,ne){this.ranges=U,this.wordPattern=ne}}e.LinkedEditingRanges=ee;class le{constructor(U){this._autoForwardAction=U}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=le;var Ne;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Ne||(e.TestResultState=Ne={}));var ot;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(ot||(e.TestRunProfileKind=ot={}));let yt=class{constructor(U=void 0,ne=void 0,Ce=void 0,Ke=!1,et=!0){this.include=U,this.exclude=ne,this.profile=Ce,this.continuous=Ke,this.preserveFocus=et}};e.TestRunRequest=yt,e.TestRunRequest=yt=je([m],yt);let At=D=class{static diff(U,ne,Ce){const Ke=new D(U);return Ke.expectedOutput=ne,Ke.actualOutput=Ce,Ke}constructor(U){this.message=U}};e.TestMessage=At,e.TestMessage=At=D=je([m],At);let Ci=class{constructor(U){this.id=U}};e.TestTag=Ci,e.TestTag=Ci=je([m],Ci);class Mi{constructor(U,ne){this.covered=U,this.total=ne,yn(this)}}e.TestCoverageCount=Mi;function yn(z){if(z){if(z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`);if(z.total<0)throw new Error(`The number of covered items (${z.total}) cannot be negative`)}}class wn{static fromDetails(U,ne){const Ce=new Mi(0,0),Ke=new Mi(0,0),et=new Mi(0,0);for(const bt of ne)if("branches"in bt){Ce.total+=1,Ce.covered+=bt.executed?1:0;for(const Kt of bt.branches)Ke.total+=1,Ke.covered+=Kt.executed?1:0}else et.total+=1,et.covered+=bt.executed?1:0;const dt=new wn(U,Ce,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return dt.detailedCoverage=ne,dt}constructor(U,ne,Ce,Ke,et){this.uri=U,this.statementCoverage=ne,this.branchCoverage=Ce,this.declarationCoverage=Ke,this.testItem=et}}e.FileCoverage=wn;class xn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,ne,Ce=[]){this.executed=U,this.location=ne,this.branches=Ce}}e.StatementCoverage=xn;class Bn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,ne,Ce){this.executed=U,this.location=ne,this.label=Ce}}e.BranchCoverage=Bn;class zn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,ne,Ce){this.name=U,this.executed=ne,this.location=Ce}}e.DeclarationCoverage=zn;var Cn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Cn||(e.ExternalUriOpenerPriority=Cn={}));var _n;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(_n||(e.WorkspaceTrustState=_n={}));var Dn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Dn||(e.PortAutoForwardAction=Dn={}));class Wn{constructor(U,ne,Ce,Ke,et,dt){this.kind=U,this.name=ne,this.detail=Ce,this.uri=Ke,this.range=et,this.selectionRange=dt}}e.TypeHierarchyItem=Wn;class $n{constructor(U){this.uri=U}}e.TextTabInput=$n;class Vn{constructor(U,ne){this.original=U,this.modified=ne}}e.TextDiffTabInput=Vn;class Hn{constructor(U,ne,Ce,Ke){this.base=U,this.input1=ne,this.input2=Ce,this.result=Ke}}e.TextMergeTabInput=Hn;class qn{constructor(U,ne){this.uri=U,this.viewType=ne}}e.CustomEditorTabInput=qn;class jn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=jn;class Kn{constructor(U,ne){this.uri=U,this.notebookType=ne}}e.NotebookEditorTabInput=Kn;class Gn{constructor(U,ne,Ce){this.original=U,this.modified=ne,this.notebookType=Ce}}e.NotebookDiffEditorTabInput=Gn;class Xn{constructor(){}}e.TerminalEditorTabInput=Xn;class Qn{constructor(U,ne){this.uri=U,this.inputBoxUri=ne}}e.InteractiveWindowInput=Qn;class Yn{constructor(){}}e.ChatEditorTabInput=Yn;class Jn{constructor(U){this.textDiffs=U}}e.TextMultiDiffTabInput=Jn;var In;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(In||(e.InteractiveSessionVoteDirection=In={}));var Tn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Tn||(e.ChatCopyKind=Tn={}));var Pn;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(Pn||(e.ChatVariableLevel=Pn={}));class Zn{constructor(U,ne,Ce){this.id=U,this.label=ne,this.values=Ce}}e.ChatCompletionItem=Zn;var kn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(kn||(e.InteractiveEditorResponseFeedbackKind=kn={}));var An;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(An||(e.ChatResultFeedbackKind=An={}));class er{constructor(U){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new He(U):U}}e.ChatResponseMarkdownPart=er;class tr{constructor(U,ne){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new He(U):U,this.vulnerabilities=ne}}e.ChatResponseMarkdownWithVulnerabilitiesPart=tr;class ir{constructor(U,ne){this.participant=U,this.command=ne}}e.ChatResponseDetectedParticipantPart=ir;class nr{constructor(U,ne,Ce){this.title=U,this.message=ne,this.data=Ce}}e.ChatResponseConfirmationPart=nr;class rr{constructor(U,ne){this.value=U,this.baseUri=ne}}e.ChatResponseFileTreePart=rr;class sr{constructor(U,ne){this.value=U,this.title=ne}}e.ChatResponseAnchorPart=sr;class or{constructor(U){this.value=U}}e.ChatResponseProgressPart=or;class ar{constructor(U,ne){this.value=U,this.task=ne}}e.ChatResponseProgressPart2=ar;class lr{constructor(U){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new He(U):U}}e.ChatResponseWarningPart=lr;class cr{constructor(U){this.value=U}}e.ChatResponseCommandButtonPart=cr;class ur{constructor(U,ne){this.value=U,this.iconPath=ne}}e.ChatResponseReferencePart=ur;class dr{constructor(U,ne){this.uri=U,this.edits=Array.isArray(ne)?ne:[ne]}}e.ChatResponseTextEditPart=dr;class hr{constructor(U,ne,Ce,Ke){this.prompt=U,this.command=ne,this.references=Ce,this.participant=Ke}}e.ChatRequestTurn=hr;class fr{constructor(U,ne,Ce,Ke){this.response=U,this.result=ne,this.participant=Ce,this.command=Ke}}e.ChatResponseTurn=fr;var Rn;(function(z){z[z.Panel=1]="Panel",z[z.Terminal=2]="Terminal",z[z.Notebook=3]="Notebook",z[z.Editor=4]="Editor"})(Rn||(e.ChatLocation=Rn={}));var hn;(function(z){z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.System=3]="System"})(hn||(e.LanguageModelChatMessageRole=hn={}));class fn{static User(U,ne){return new fn(hn.User,U,ne)}static Assistant(U,ne){return new fn(hn.Assistant,U,ne)}constructor(U,ne,Ce){this.role=U,this.content=ne,this.name=Ce}}e.LanguageModelChatMessage=fn;class gr{constructor(U){this.content=U}}e.LanguageModelChatSystemMessage=gr;class mr{constructor(U,ne){this.content=U,this.name=ne}}e.LanguageModelChatUserMessage=mr;class pr{constructor(U,ne){this.content=U,this.name=ne}}e.LanguageModelChatAssistantMessage=pr;class Ti extends Error{static NotFound(U){return new Ti(U,Ti.NotFound.name)}static NoPermissions(U){return new Ti(U,Ti.NoPermissions.name)}static Blocked(U){return new Ti(U,Ti.Blocked.name)}constructor(U,ne,Ce){super(U,{cause:Ce}),this.name="LanguageModelError",this.code=ne??""}}e.LanguageModelError=Ti;var Ln;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(Ln||(e.RelatedInformationType=Ln={}));var On;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped",z[z.Error=5]="Error"})(On||(e.SpeechToTextStatus=On={}));var Nn;(function(z){z[z.Started=1]="Started",z[z.Stopped=2]="Stopped",z[z.Error=3]="Error"})(Nn||(e.TextToSpeechStatus=Nn={}));var Mn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(Mn||(e.KeywordRecognitionStatus=Mn={}));class vr{constructor(U,ne){this.text=U,this.range=ne}}e.InlineEdit=vr;var Fn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Fn||(e.InlineEditTriggerKind=Fn={}))}),define(De[268],Ie([1,0,5,7]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class P{constructor(A){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(y.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,R,v){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const l=this._relatedInformationProviders.get(A);if(!l)throw new Error("related information provider not found");return await l.provideRelatedInformation(R,v)??[]}getRelatedInformation(A,R,v){return this._proxy.$getAiRelatedInformation(R,v)}registerRelatedInformationProvider(A,R,v){const l=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(l,v),this._proxy.$registerAiRelatedInformationProvider(l,R),new k.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(l),this._relatedInformationProviders.delete(l)})}}e.ExtHostRelatedInformation=P}),define(De[91],Ie([1,0,4,5,7,19,115,3,17]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,R.createDecorator)("IExtHostAuthentication");let l=class{constructor(c){this._authenticationProviders=new Map,this._onDidChangeSessions=new y.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new T,this._getSessionsTaskSingler=new T,this._proxy=c.getProxy(k.MainContext.MainThreadAuthentication)}async getSession(c,C,h,r={}){const o=O.ExtensionIdentifier.toKey(c.identifier),a=[...h].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${o} ${C} ${a}`,async()=>{await this._proxy.$ensureProvider(C);const d=c.displayName||c.name;return this._proxy.$getSession(C,h,o,d,r)})}async getSessions(c,C,h){const r=O.ExtensionIdentifier.toKey(c.identifier),o=[...h].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${r} ${o}`,async()=>{await this._proxy.$ensureProvider(C);const a=c.displayName||c.name;return this._proxy.$getSessions(C,h,r,a)})}async removeSession(c,C){const h=this._authenticationProviders.get(c);return h?h.provider.removeSession(C):this._proxy.$removeSession(c,C)}registerAuthenticationProvider(c,C,h,r){if(this._authenticationProviders.get(c))throw new Error(`An authentication provider with id '${c}' is already registered.`);this._authenticationProviders.set(c,{label:C,provider:h,options:r??{supportsMultipleAccounts:!1}});const o=h.onDidChangeSessions(a=>this._proxy.$sendDidChangeSessions(c,a));return this._proxy.$registerAuthenticationProvider(c,C,r?.supportsMultipleAccounts??!1),new P.Disposable(()=>{o.dispose(),this._authenticationProviders.delete(c),this._proxy.$unregisterAuthenticationProvider(c)})}async $createSession(c,C,h){const r=this._authenticationProviders.get(c);if(r)return await r.provider.createSession(C,h);throw new Error(`Unable to find authentication provider with handle: ${c}`)}async $removeSession(c,C){const h=this._authenticationProviders.get(c);if(h)return await h.provider.removeSession(C);throw new Error(`Unable to find authentication provider with handle: ${c}`)}async $getSessions(c,C){const h=this._authenticationProviders.get(c);if(h)return await h.provider.getSessions(C);throw new Error(`Unable to find authentication provider with handle: ${c}`)}$onDidChangeAuthenticationSessions(c,C){return c.startsWith(A.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:c,label:C}}),Promise.resolve()}};e.ExtHostAuthentication=l,e.ExtHostAuthentication=l=je([$e(0,v.IExtHostRpcService)],l);class T{constructor(){this._inFlightPromises=new Map}getOrCreate(c,C){const h=this._inFlightPromises.get(c);if(h)return h;const r=C().finally(()=>this._inFlightPromises.delete(c));return this._inFlightPromises.set(c,r),r}}}),define(De[120],Ie([1,0,2,5,7,3,17,12,18,13,20,25]),function(he,e,y,k,P,O,A,R,v,l,T,b){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class{static{c=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(r,o){this._logService=o,this._provider=new Map,this._proxy=r.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(r,o){const a=c._handlePool++;this._provider.set(a,{provider:r,extensionDescription:o}),this._proxy.$registerDecorationProvider(a,o.identifier.value);const d=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(t=>{if(!t){this._proxy.$onDidChange(a,null);return}const s=(0,v.asArray)(t);if(s.length<=c._maxEventSize){this._proxy.$onDidChange(a,s);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,s.length);const n=s.map(f=>({uri:f,rank:(0,l.count)(f.path,"/")})),i=(0,v.groupBy)(n,(f,u)=>f.rank-u.rank||(0,l.compare)(f.uri.path,u.uri.path)),g=[];e:for(const f of i){let u;for(const E of f){const I=(0,T.dirname)(E.uri.path);if(u!==I&&(u=I,g.push(E.uri)>=c._maxEventSize))break e}}this._proxy.$onDidChange(a,g)});return new P.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(r,o,a){if(!this._provider.has(r))return Object.create(null);const d=Object.create(null),{provider:t,extensionDescription:s}=this._provider.get(r);return await Promise.all(o.map(async n=>{try{const{uri:i,id:g}=n,f=await Promise.resolve(t.provideFileDecoration(y.URI.revive(i),a));if(!f)return;try{P.FileDecoration.validate(f),f.badge&&typeof f.badge!="string"&&(0,b.checkProposedApiEnabled)(s,"codiconDecoration"),d[g]=[f.propagate,f.tooltip,f.badge,f.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${s.identifier.value}': ${u}`)}}catch(i){this._logService.error(i)}})),d}};e.ExtHostDecorations=C,e.ExtHostDecorations=C=c=je([$e(0,A.IExtHostRpcService),$e(1,R.ILogService)],C),e.IExtHostDecorations=(0,O.createDecorator)("IExtHostDecorations")}),define(De[269],Ie([1,0,14,2,7,5,16,22,13]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class l{static{this._handlePool=0}constructor(b,c,C){this._documentsAndEditors=c,this._logService=C,this._documentContentProviders=new Map,this._proxy=b.getProxy(O.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,c){if(Object.keys(A.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const C=l._handlePool++;this._documentContentProviders.set(C,c),this._proxy.$registerTextContentProvider(C,b);let h;if(typeof c.onDidChange=="function"){let r;h=c.onDidChange(async o=>{if(o.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(o))return;r&&await r;const a=this.$provideTextDocumentContent(C,o).then(async d=>{if(!d&&typeof d!="string")return;const t=this._documentsAndEditors.getDocument(o);if(!t)return;const s=(0,v.splitLines)(d);if(!t.equalLines(s))return this._proxy.$onVirtualDocumentChange(o,d)}).catch(y.onUnexpectedError).finally(()=>{r===a&&(r=void 0)});r=a})}return new P.Disposable(()=>{this._documentContentProviders.delete(C)&&this._proxy.$unregisterTextContentProvider(C),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(b,c){const C=this._documentContentProviders.get(b);return C?Promise.resolve(C.provideTextDocumentContent(k.URI.revive(c),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=l}),define(De[121],Ie([1,0,61,16,13,325,209,7,18]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=T;const l=new Map;function T(h,r){r?l.set(h,r):l.delete(h)}function b(h){return l.get(h)}class c extends O.MirrorTextModel{constructor(r,o,a,d,t,s,n){super(o,a,d,t),this._proxy=r,this._languageId=s,this._isDirty=n,this._isDisposed=!1}dispose(){(0,y.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(r){return(0,v.equals)(this._lines,r)}get document(){if(!this._document){const r=this;this._document={get uri(){return r._uri},get fileName(){return r._uri.fsPath},get isUntitled(){return r._uri.scheme===k.Schemas.untitled},get languageId(){return r._languageId},get version(){return r._versionId},get isClosed(){return r._isDisposed},get isDirty(){return r._isDirty},save(){return r._save()},getText(o){return o?r._getTextInRange(o):r.getText()},get eol(){return r._eol===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return r._lines.length},lineAt(o){return r._lineAt(o)},offsetAt(o){return r._offsetAt(o)},positionAt(o){return r._positionAt(o)},validateRange(o){return r._validateRange(o)},validatePosition(o){return r._validatePosition(o)},getWordRangeAtPosition(o,a){return r._getWordRangeAtPosition(o,a)}}}return Object.freeze(this._document)}_acceptLanguageId(r){(0,y.ok)(!this._isDisposed),this._languageId=r}_acceptIsDirty(r){(0,y.ok)(!this._isDisposed),this._isDirty=r}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(r){const o=this._validateRange(r);if(o.isEmpty)return"";if(o.isSingleLine)return this._lines[o.start.line].substring(o.start.character,o.end.character);const a=this._eol,d=o.start.line,t=o.end.line,s=[];s.push(this._lines[d].substring(o.start.character));for(let n=d+1;n<t;n++)s.push(this._lines[n]);return s.push(this._lines[t].substring(0,o.end.character)),s.join(a)}_lineAt(r){let o;if(r instanceof R.Position?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this._lines.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new C(o,this._lines[o],o===this._lines.length-1)}_offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.line-1)+r.character}_positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(r),a=this._lines[o.index].length;return new R.Position(o.index,Math.min(o.remainder,a))}_validateRange(r){if(!(r instanceof R.Range))throw new Error("Invalid argument");const o=this._validatePosition(r.start),a=this._validatePosition(r.end);return o===r.start&&a===r.end?r:new R.Range(o.line,o.character,a.line,a.character)}_validatePosition(r){if(!(r instanceof R.Position))throw new Error("Invalid argument");if(this._lines.length===0)return r.with(0,0);let{line:o,character:a}=r,d=!1;if(o<0)o=0,a=0,d=!0;else if(o>=this._lines.length)o=this._lines.length-1,a=this._lines[o].length,d=!0;else{const t=this._lines[o].length;a<0?(a=0,d=!0):a>t&&(a=t,d=!0)}return d?new R.Position(o,a):r}_getWordRangeAtPosition(r,o){const a=this._validatePosition(r);if(!o)o=b(this._languageId);else if((0,P.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const d=(0,A.getWordAtText)(a.character+1,(0,A.ensureValidWordDefinition)(o),this._lines[a.line],0);if(d)return new R.Range(a.line,d.startColumn-1,a.line,d.endColumn-1)}}e.ExtHostDocumentData=c;class C{constructor(r,o,a){this._line=r,this._text=o,this._isLastLine=a}get lineNumber(){return this._line}get text(){return this._text}get range(){return new R.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new R.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=C}),define(De[270],Ie([1,0,5,7]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class P{constructor(A){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(y.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,R,v){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const l=this._AiEmbeddingVectorProviders.get(A);if(!l)throw new Error("Embedding vector provider not found");const T=await l.provideEmbeddingVector(R,v);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(A,R,v){const l=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(l,v),this._proxy.$registerAiEmbeddingVectorProvider(R,l),new k.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(l),this._AiEmbeddingVectorProviders.delete(l)})}}e.ExtHostAiEmbeddingVector=P}),define(De[68],Ie([1,0,5,30,7,23,3,17,51,6,11,24,16]),function(he,e,y,k,P,O,A,R,v,l,T,b,c){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let h=C=class{constructor(o,a){this._fileSystemProvider=new Map,this._writeQueue=new T.ResourceQueue,this._proxy=o.getProxy(y.MainContext.MainThreadFileSystem);const d=this;this.value=Object.freeze({async stat(t){try{let s;const n=d._fileSystemProvider.get(t.scheme);return n?(await d._proxy.$ensureActivation(t.scheme),s=await n.impl.stat(t)):s=await d._proxy.$stat(t),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===k.FilePermission.Readonly?1:void 0}}catch(s){C._handleError(s)}},async readDirectory(t){try{const s=d._fileSystemProvider.get(t.scheme);return s?(await d._proxy.$ensureActivation(t.scheme),(await s.impl.readDirectory(t)).slice()):await d._proxy.$readdir(t)}catch(s){return C._handleError(s)}},async createDirectory(t){try{const s=d._fileSystemProvider.get(t.scheme);return s&&!s.isReadonly?(await d._proxy.$ensureActivation(t.scheme),await d.mkdirp(s.impl,s.extUri,t)):await d._proxy.$mkdir(t)}catch(s){return C._handleError(s)}},async readFile(t){try{const s=d._fileSystemProvider.get(t.scheme);return s?(await d._proxy.$ensureActivation(t.scheme),(await s.impl.readFile(t)).slice()):(await d._proxy.$readFile(t)).buffer}catch(s){return C._handleError(s)}},async writeFile(t,s){try{const n=d._fileSystemProvider.get(t.scheme);return n&&!n.isReadonly?(await d._proxy.$ensureActivation(t.scheme),await d.mkdirp(n.impl,n.extUri,n.extUri.dirname(t)),await d._writeQueue.queueFor(t,()=>Promise.resolve(n.impl.writeFile(t,s,{create:!0,overwrite:!0})))):await d._proxy.$writeFile(t,O.VSBuffer.wrap(s))}catch(n){return C._handleError(n)}},async delete(t,s){try{const n=d._fileSystemProvider.get(t.scheme);return n&&!n.isReadonly&&!s?.useTrash?(await d._proxy.$ensureActivation(t.scheme),await n.impl.delete(t,{recursive:!1,...s})):await d._proxy.$delete(t,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(n){return C._handleError(n)}},async rename(t,s,n){try{return await d._proxy.$rename(t,s,{overwrite:!1,...n})}catch(i){return C._handleError(i)}},async copy(t,s,n){try{return await d._proxy.$copy(t,s,{overwrite:!1,...n})}catch(i){return C._handleError(i)}},isWritableFileSystem(t){const s=a.getCapabilities(t);if(typeof s=="number")return!(s&k.FileSystemProviderCapabilities.Readonly)}})}async mkdirp(o,a,d){const t=[];for(;!a.isEqual(d,a.dirname(d));)try{if(!((await o.stat(d)).type&k.FileType.Directory))throw P.FileSystemError.FileExists(`Unable to create folder '${d.scheme===c.Schemas.file?d.fsPath:d.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(k.toFileSystemProviderErrorCode(s)!==k.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(a.basename(d)),d=a.dirname(d)}for(let s=t.length-1;s>=0;s--){d=a.joinPath(d,t[s]);try{await o.createDirectory(d)}catch(n){if(k.toFileSystemProviderErrorCode(n)!==k.FileSystemProviderErrorCode.FileExists)throw n}}}static _handleError(o){if(o instanceof P.FileSystemError)throw o;if(o instanceof k.FileSystemProviderError)switch(o.code){case k.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(o.message);case k.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(o.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(o.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(o.message);case k.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(o.message);case k.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(o.message);default:throw new P.FileSystemError(o.message,o.name)}if(!(o instanceof Error))throw new P.FileSystemError(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw P.FileSystemError.Unavailable(o.message);switch(o.name){case k.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(o.message);case k.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(o.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(o.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(o.message);case k.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(o.message);case k.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(o.message);default:throw new P.FileSystemError(o.message,o.name)}}addFileSystemProvider(o,a,d){return this._fileSystemProvider.set(o,{impl:a,extUri:d?.isCaseSensitive?b.extUri:b.extUriIgnorePathCase,isReadonly:!!d?.isReadonly}),(0,l.toDisposable)(()=>this._fileSystemProvider.delete(o))}getFileSystemProviderExtUri(o){return this._fileSystemProvider.get(o)?.extUri??b.extUri}};e.ExtHostConsumerFileSystem=h,e.ExtHostConsumerFileSystem=h=C=je([$e(0,R.IExtHostRpcService),$e(1,v.IExtHostFileSystemInfo)],h),e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(De[92],Ie([1,0,3,27,12,68,2]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,y.createDecorator)("IExtensionStoragePaths");let R=class{constructor(l,T,b){this._logService=T,this._extHostFileSystem=b,this._workspace=l.workspace??void 0,this._environment=l.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(l){return A.URI.joinPath(this._environment.workspaceStorageHome,l)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const l=this._workspace.id,T=await this._getWorkspaceStorageURI(l);try{return await this._extHostFileSystem.value.stat(T),this._logService.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",T),await this._extHostFileSystem.value.createDirectory(T),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),T}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(l){if(this._value)return A.URI.joinPath(this._value,l.identifier.value)}globalValue(l){return A.URI.joinPath(this._environment.globalStorageHome,l.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=R,e.ExtensionStoragePaths=R=je([$e(0,k.IExtHostInitDataService),$e(1,P.ILogService),$e(2,O.IExtHostConsumerFileSystem)],R)}),define(De[271],Ie([1,0,7,17,4]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let O=class{constructor(R){this._actual=new y.ColorTheme(y.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new P.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(R){let v;switch(R){case"light":v=y.ColorThemeKind.Light;break;case"hcDark":v=y.ColorThemeKind.HighContrast;break;case"hcLight":v=y.ColorThemeKind.HighContrastLight;break;default:v=y.ColorThemeKind.Dark}this._actual=new y.ColorTheme(v),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=O,e.ExtHostTheming=O=je([$e(0,k.IExtHostRpcService)],O)}),define(De[93],Ie([1,0,22,4,6,189,3,12,222,5,27,17,7]),function(he,e,y,k,P,O,A,R,v,l,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class C extends v.DisposableTunnel{}var h;(function(o){function a(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,privacy:t.privacy??(t.public?v.TunnelPrivacyId.Public:v.TunnelPrivacyId.Private),protocol:t.protocol}}o.fromApiTunnel=a;function d(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.privacy!==v.TunnelPrivacyId.ConstantPrivate&&t.privacy!==v.TunnelPrivacyId.ConstantPrivate,privacy:t.privacy,protocol:t.protocol}}o.fromServiceTunnel=d})(h||(e.TunnelDtoConverter=h={})),e.IExtHostTunnelService=(0,A.createDecorator)("IExtHostTunnelService");let r=class extends P.Disposable{constructor(a,d,t){super(),this.logService=t,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new k.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=a.getProxy(l.MainContext.MainThreadTunnelService)}async openTunnel(a,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const t=await this._proxy.$openTunnel(d,a.displayName);if(t){const s=new C(t.remoteAddress,t.localAddress,()=>this._proxy.$closeTunnel(t.remoteAddress));return this._register(s),s}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(a,d){a.portRange===void 0&&a.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const t=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(t,{selector:a,provider:d}),this._proxy.$registerPortsAttributesProvider(a,t),new c.Disposable(()=>{this._portAttributesProviders.delete(t),this._proxy.$unregisterPortsAttributesProvider(t)})}async $providePortAttributes(a,d,t,s,n){const i=[];for(const f of a){const u=this._portAttributesProviders.get(f);if(!u)return[];i.push(...await Promise.all(d.map(async E=>{let I;try{I=await u.provider.providePortAttributes({port:E,pid:t,commandLine:s},n)}catch{I=await u.provider.providePortAttributes(E,t,s,n)}return{providedAttributes:I,port:E}})))}const g=i.filter(f=>!!f.providedAttributes);return g.length>0?g.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,d){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(s,n)=>await a.provideTunnel(s,n,y.CancellationToken.None)??void 0;const t=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,privacyOptions:d.tunnelFeatures?.privacyOptions,protocol:d.tunnelFeatures.protocol===void 0?!0:d.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(t),Promise.resolve((0,P.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,d){if(a){a.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this._showCandidatePort=a.showCandidatePort,this._proxy.$setCandidateFilter());const t=a.tunnelFactory??(d?this.makeManagedTunnelFactory(d):void 0);if(t){this._forwardPortProvider=t;let s=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const n=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this._proxy.$setTunnelProvider(n)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(a){}async $closeTunnel(a,d){if(this._extensionTunnels.has(a.host)){const t=this._extensionTunnels.get(a.host);t.has(a.port)&&(d&&t.get(a.port).disposeListener.dispose(),await t.get(a.port).tunnel.dispose(),t.delete(a.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(a,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const t=this._forwardPortProvider(a,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),t!==void 0){const s=await t;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(a.remoteAddress.host)||this._extensionTunnels.set(a.remoteAddress.host,new Map);const n=this._register(s.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(s.remoteAddress))));return this._extensionTunnels.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:s,disposeListener:n}),h.fromApiTunnel(s)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(t){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),t instanceof Error)return t.message}}async $applyCandidateFilter(a){const d=await Promise.all(a.map(s=>this._showCandidatePort(s.host,s.port,s.detail??""))),t=a.filter((s,n)=>d[n]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(s=>s.port).join(", ")} to ${t.map(s=>s.port).join(", ")}`),t}};e.ExtHostTunnelService=r,e.ExtHostTunnelService=r=je([$e(0,b.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,R.ILogService)],r)}),define(De[10],Ie([1,0,18,23,146,272,59,29,135,49,73,26,141,24,34,15,2,104,33,150,94,52,106,77,114,113,233,248,81,90,55,56,244,7]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s,n,i,g,f,u,E,I,_,w,p,D,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=pe,e.fromRangeOrRangeWithMessage=se,e.pathOrURIToURI=Te;var M;(function(be){function Re(G){const{selectionStartLineNumber:Pe,selectionStartColumn:Ue,positionLineNumber:Qe,positionColumn:Ve}=G,ct=new S.Position(Pe-1,Ue-1),Dt=new S.Position(Qe-1,Ve-1);return new S.Selection(ct,Dt)}be.to=Re;function ce(G){const{anchor:Pe,active:Ue}=G;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}be.from=ce})(M||(e.Selection=M={}));var L;(function(be){function Re(G){if(!G)return;const{start:Pe,end:Ue}=G;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}be.from=Re;function ce(G){if(!G)return;const{startLineNumber:Pe,startColumn:Ue,endLineNumber:Qe,endColumn:Ve}=G;return new S.Range(Pe-1,Ue-1,Qe-1,Ve-1)}be.to=ce})(L||(e.Range=L={}));var H;(function(be){function Re(G){return{uri:G.uri,range:L.from(G.range)}}be.from=Re;function ce(G){return new S.Location(o.URI.revive(G.uri),L.to(G.range))}be.to=ce})(H||(e.Location=H={}));var V;(function(be){function Re(ce){switch(ce){case t.StandardTokenType.Comment:return S.StandardTokenType.Comment;case t.StandardTokenType.Other:return S.StandardTokenType.Other;case t.StandardTokenType.RegEx:return S.StandardTokenType.RegEx;case t.StandardTokenType.String:return S.StandardTokenType.String}}be.to=Re})(V||(e.TokenType=V={}));var $;(function(be){function Re(G){return new S.Position(G.lineNumber-1,G.column-1)}be.to=Re;function ce(G){return{lineNumber:G.line+1,column:G.character+1}}be.from=ce})($||(e.Position=$={}));var N;(function(be){function Re(Pe,Ue,Qe){return(0,y.coalesce)((0,y.asArray)(Pe).map(Ve=>ce(Ve,Ue,Qe)))}be.from=Re;function ce(Pe,Ue,Qe){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Qe?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:G(Pe.scheme,Ue),pattern:lt.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Qe?.isBuiltin}}function G(Pe,Ue){return Ue&&typeof Pe=="string"?Ue.transformOutgoingScheme(Pe):Pe}})(N||(e.DocumentSelector=N={}));var F;(function(be){function Re(G){switch(G){case S.DiagnosticTag.Unnecessary:return i.MarkerTag.Unnecessary;case S.DiagnosticTag.Deprecated:return i.MarkerTag.Deprecated}}be.from=Re;function ce(G){switch(G){case i.MarkerTag.Unnecessary:return S.DiagnosticTag.Unnecessary;case i.MarkerTag.Deprecated:return S.DiagnosticTag.Deprecated;default:return}}be.to=ce})(F||(e.DiagnosticTag=F={}));var Y;(function(be){function Re(G){let Pe;return G.code&&((0,r.isString)(G.code)||(0,r.isNumber)(G.code)?Pe=String(G.code):Pe={value:String(G.code.value),target:G.code.target}),{...L.from(G.range),message:G.message,source:G.source,code:Pe,severity:fe.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(re.from),tags:Array.isArray(G.tags)?(0,y.coalesce)(G.tags.map(F.from)):void 0}}be.from=Re;function ce(G){const Pe=new S.Diagnostic(L.to(G),G.message,fe.to(G.severity));return Pe.source=G.source,Pe.code=(0,r.isString)(G.code)?G.code:G.code?.value,Pe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(re.to),Pe.tags=G.tags&&(0,y.coalesce)(G.tags.map(F.to)),Pe}be.to=ce})(Y||(e.Diagnostic=Y={}));var re;(function(be){function Re(G){return{...L.from(G.location.range),message:G.message,resource:G.location.uri}}be.from=Re;function ce(G){return new S.DiagnosticRelatedInformation(new S.Location(G.resource,L.to(G)),G.message)}be.to=ce})(re||(e.DiagnosticRelatedInformation=re={}));var fe;(function(be){function Re(G){switch(G){case S.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}be.from=Re;function ce(G){switch(G){case i.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}be.to=ce})(fe||(e.DiagnosticSeverity=fe={}));var Ee;(function(be){function Re(G){return typeof G=="number"&&G>=S.ViewColumn.One?G-1:G===S.ViewColumn.Beside?m.SIDE_GROUP:m.ACTIVE_GROUP}be.from=Re;function ce(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ce})(Ee||(e.ViewColumn=Ee={}));function oe(be){return typeof be.range<"u"}function pe(be){return be.length===0?!0:!!oe(be[0])}var ve;(function(be){function Re(Ve){return Ve.map(be.from)}be.fromMany=Re;function ce(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function G(Ve){let ct;if(ce(Ve)){const{language:Mt,value:jt}=Ve;ct={value:"```"+Mt+`
`+jt+"\n```\n"}}else S.MarkdownString.isMarkdownString(Ve)?ct={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?ct={value:Ve}:ct={value:""};const Dt=Object.create(null);ct.uris=Dt;const Yt=Mt=>{try{let jt=o.URI.parse(Mt,!0);jt=jt.with({query:Pe(jt.query,Dt)}),Dt[Mt]=jt}catch{}return""},ii=new v.marked.Renderer;return ii.link=Yt,ii.image=Mt=>typeof Mt=="string"?Yt(A.parseHrefAndDimensions(Mt).href):"",(0,v.marked)(ct.value,{renderer:ii}),ct}be.from=G;function Pe(Ve,ct){if(!Ve)return Ve;let Dt;try{Dt=(0,l.parse)(Ve)}catch{}if(!Dt)return Ve;let Yt=!1;return Dt=(0,b.cloneAndChange)(Dt,ii=>{if(o.URI.isUri(ii)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Mt]=ii,Yt=!0,Mt}else return}),Yt?JSON.stringify(Dt):Ve}function Ue(Ve){const ct=new S.MarkdownString(Ve.value,Ve.supportThemeIcons);return ct.isTrusted=Ve.isTrusted,ct.supportHtml=Ve.supportHtml,ct.baseUri=Ve.baseUri?o.URI.from(Ve.baseUri):void 0,ct}be.to=Ue;function Qe(Ve){if(Ve)return typeof Ve=="string"?Ve:be.from(Ve)}be.fromStrict=Qe})(ve||(e.MarkdownString=ve={}));function se(be){return pe(be)?be.map(Re=>({range:L.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?ve.fromMany(Re.hoverMessage):Re.hoverMessage?ve.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):be.map(Re=>({range:L.from(Re)}))}function Te(be){return typeof be>"u"?be:typeof be=="string"?o.URI.file(be):be}var Me;(function(be){function Re(ce){return typeof ce>"u"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?Te(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}be.from=Re})(Me||(e.ThemableDecorationAttachmentRenderOptions=Me={}));var Q;(function(be){function Re(ce){return typeof ce>"u"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?Te(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?Me.from(ce.before):void 0,after:ce.after?Me.from(ce.after):void 0}}be.from=Re})(Q||(e.ThemableDecorationRenderOptions=Q={}));var W;(function(be){function Re(ce){if(typeof ce>"u")return ce;switch(ce){case S.DecorationRangeBehavior.OpenOpen:return n.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case S.DecorationRangeBehavior.ClosedClosed:return n.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case S.DecorationRangeBehavior.OpenClosed:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case S.DecorationRangeBehavior.ClosedOpen:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}be.from=Re})(W||(e.DecorationRangeBehavior=W={}));var ie;(function(be){function Re(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?W.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?Q.from(ce.light):void 0,dark:ce.dark?Q.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?Te(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?Me.from(ce.before):void 0,after:ce.after?Me.from(ce.after):void 0}}be.from=Re})(ie||(e.DecorationRenderOptions=ie={}));var _e;(function(be){function Re(G){return{text:G.newText,eol:G.newEol&&Z.from(G.newEol),range:L.from(G.range)}}be.from=Re;function ce(G){const Pe=new S.TextEdit(L.to(G.range),G.text);return Pe.newEol=typeof G.eol>"u"?void 0:Z.to(G.eol),Pe}be.to=ce})(_e||(e.TextEdit=_e={}));var de;(function(be){function Re(G,Pe){const Ue={edits:[]};if(G instanceof S.WorkspaceEdit){const Qe=new R.ResourceSet;for(const Ve of G._allEntries())Ve._type===S.FileEditType.File&&o.URI.isUri(Ve.to)&&Ve.from===void 0&&Qe.add(Ve.to);for(const Ve of G._allEntries())if(Ve._type===S.FileEditType.File){let ct;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?ct={type:"base64",value:(0,k.encodeBase64)(k.VSBuffer.wrap(Ve.options.contents))}:ct={type:"dataTransferItem",id:Ve.options.contents._itemId}),Ue.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:ct},metadata:Ve.metadata})}else Ve._type===S.FileEditType.Text?Ue.edits.push({resource:Ve.uri,textEdit:_e.from(Ve.edit),versionId:Qe.has(Ve.uri)?void 0:Pe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===S.FileEditType.Snippet?Ue.edits.push({resource:Ve.uri,textEdit:{range:L.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ve.uri)?void 0:Pe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===S.FileEditType.Cell?Ue.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===S.FileEditType.CellReplace&&Ue.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:w.CellEditType.Replace,index:Ve.index,count:Ve.count,cells:Ve.cells.map(Wt.from)}})}return Ue}be.from=Re;function ce(G){const Pe=new S.WorkspaceEdit,Ue=new R.ResourceMap;for(const Qe of G.edits)if(Qe.textEdit){const Ve=Qe,ct=o.URI.revive(Ve.resource),Dt=L.to(Ve.textEdit.range),Yt=Ve.textEdit.text,ii=Ve.textEdit.insertAsSnippet;let Mt;ii?Mt=S.SnippetTextEdit.replace(Dt,new S.SnippetString(Yt)):Mt=S.TextEdit.replace(Dt,Yt);const jt=Ue.get(ct);jt?jt.push(Mt):Ue.set(ct,[Mt])}else Pe.renameFile(o.URI.revive(Qe.oldResource),o.URI.revive(Qe.newResource),Qe.options);for(const[Qe,Ve]of Ue)Pe.set(Qe,Ve);return Pe}be.to=ce})(de||(e.WorkspaceEdit=de={}));var Se;(function(be){const Re=Object.create(null);Re[S.SymbolKind.File]=s.SymbolKind.File,Re[S.SymbolKind.Module]=s.SymbolKind.Module,Re[S.SymbolKind.Namespace]=s.SymbolKind.Namespace,Re[S.SymbolKind.Package]=s.SymbolKind.Package,Re[S.SymbolKind.Class]=s.SymbolKind.Class,Re[S.SymbolKind.Method]=s.SymbolKind.Method,Re[S.SymbolKind.Property]=s.SymbolKind.Property,Re[S.SymbolKind.Field]=s.SymbolKind.Field,Re[S.SymbolKind.Constructor]=s.SymbolKind.Constructor,Re[S.SymbolKind.Enum]=s.SymbolKind.Enum,Re[S.SymbolKind.Interface]=s.SymbolKind.Interface,Re[S.SymbolKind.Function]=s.SymbolKind.Function,Re[S.SymbolKind.Variable]=s.SymbolKind.Variable,Re[S.SymbolKind.Constant]=s.SymbolKind.Constant,Re[S.SymbolKind.String]=s.SymbolKind.String,Re[S.SymbolKind.Number]=s.SymbolKind.Number,Re[S.SymbolKind.Boolean]=s.SymbolKind.Boolean,Re[S.SymbolKind.Array]=s.SymbolKind.Array,Re[S.SymbolKind.Object]=s.SymbolKind.Object,Re[S.SymbolKind.Key]=s.SymbolKind.Key,Re[S.SymbolKind.Null]=s.SymbolKind.Null,Re[S.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Re[S.SymbolKind.Struct]=s.SymbolKind.Struct,Re[S.SymbolKind.Event]=s.SymbolKind.Event,Re[S.SymbolKind.Operator]=s.SymbolKind.Operator,Re[S.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function ce(Pe){return typeof Re[Pe]=="number"?Re[Pe]:s.SymbolKind.Property}be.from=ce;function G(Pe){for(const Ue in Re)if(Re[Ue]===Pe)return Number(Ue);return S.SymbolKind.Property}be.to=G})(Se||(e.SymbolKind=Se={}));var ae;(function(be){function Re(G){switch(G){case S.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}be.from=Re;function ce(G){switch(G){case s.SymbolTag.Deprecated:return S.SymbolTag.Deprecated}}be.to=ce})(ae||(e.SymbolTag=ae={}));var X;(function(be){function Re(G){return{name:G.name,kind:Se.from(G.kind),tags:G.tags&&G.tags.map(ae.from),containerName:G.containerName,location:ze.from(G.location)}}be.from=Re;function ce(G){const Pe=new S.SymbolInformation(G.name,Se.to(G.kind),G.containerName,ze.to(G.location));return Pe.tags=G.tags&&G.tags.map(ae.to),Pe}be.to=ce})(X||(e.WorkspaceSymbol=X={}));var J;(function(be){function Re(G){const Pe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:L.from(G.range),selectionRange:L.from(G.selectionRange),kind:Se.from(G.kind),tags:G.tags?.map(ae.from)??[]};return G.children&&(Pe.children=G.children.map(Re)),Pe}be.from=Re;function ce(G){const Pe=new S.DocumentSymbol(G.name,G.detail,Se.to(G.kind),L.to(G.range),L.to(G.selectionRange));return(0,y.isNonEmptyArray)(G.tags)&&(Pe.tags=G.tags.map(ae.to)),G.children&&(Pe.children=G.children.map(ce)),Pe}be.to=ce})(J||(e.DocumentSymbol=J={}));var me;(function(be){function Re(G){const Pe=new S.CallHierarchyItem(Se.to(G.kind),G.name,G.detail||"",o.URI.revive(G.uri),L.to(G.range),L.to(G.selectionRange));return Pe._sessionId=G._sessionId,Pe._itemId=G._itemId,Pe}be.to=Re;function ce(G,Pe,Ue){if(Pe=Pe??G._sessionId,Ue=Ue??G._itemId,Pe===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ue,name:G.name,detail:G.detail,kind:Se.from(G.kind),uri:G.uri,range:L.from(G.range),selectionRange:L.from(G.selectionRange),tags:G.tags?.map(ae.from)}}be.from=ce})(me||(e.CallHierarchyItem=me={}));var ge;(function(be){function Re(ce){return new S.CallHierarchyIncomingCall(me.to(ce.from),ce.fromRanges.map(G=>L.to(G)))}be.to=Re})(ge||(e.CallHierarchyIncomingCall=ge={}));var Le;(function(be){function Re(ce){return new S.CallHierarchyOutgoingCall(me.to(ce.to),ce.fromRanges.map(G=>L.to(G)))}be.to=Re})(Le||(e.CallHierarchyOutgoingCall=Le={}));var ze;(function(be){function Re(G){return{range:G.range&&L.from(G.range),uri:G.uri}}be.from=Re;function ce(G){return new S.Location(o.URI.revive(G.uri),L.to(G.range))}be.to=ce})(ze||(e.location=ze={}));var ye;(function(be){function Re(G){const Pe=G,Ue=G;return{originSelectionRange:Pe.originSelectionRange?L.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ue.uri,range:L.from(Pe.targetRange?Pe.targetRange:Ue.range),targetSelectionRange:Pe.targetSelectionRange?L.from(Pe.targetSelectionRange):void 0}}be.from=Re;function ce(G){return{targetUri:o.URI.revive(G.uri),targetRange:L.to(G.range),targetSelectionRange:G.targetSelectionRange?L.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?L.to(G.originSelectionRange):void 0}}be.to=ce})(ye||(e.DefinitionLink=ye={}));var ke;(function(be){function Re(G){return{range:L.from(G.range),contents:ve.fromMany(G.contents),canIncreaseVerbosity:G.canIncreaseVerbosity,canDecreaseVerbosity:G.canDecreaseVerbosity}}be.from=Re;function ce(G){const Pe=G.contents.map(ve.to),Ue=L.to(G.range),Qe=G.canIncreaseVerbosity,Ve=G.canDecreaseVerbosity;return new S.VerboseHover(Pe,Ue,Qe,Ve)}be.to=ce})(ke||(e.Hover=ke={}));var Oe;(function(be){function Re(G){return{range:L.from(G.range),expression:G.expression}}be.from=Re;function ce(G){return new S.EvaluatableExpression(L.to(G.range),G.expression)}be.to=ce})(Oe||(e.EvaluatableExpression=Oe={}));var B;(function(be){function Re(G){if(G instanceof S.InlineValueText)return{type:"text",range:L.from(G.range),text:G.text};if(G instanceof S.InlineValueVariableLookup)return{type:"variable",range:L.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:L.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Re;function ce(G){switch(G.type){case"text":return{range:L.to(G.range),text:G.text};case"variable":return{range:L.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:L.to(G.range),expression:G.expression}}}be.to=ce})(B||(e.InlineValue=B={}));var x;(function(be){function Re(G){return{frameId:G.frameId,stoppedLocation:L.from(G.stoppedLocation)}}be.from=Re;function ce(G){return new S.InlineValueContext(G.frameId,L.to(G.stoppedLocation))}be.to=ce})(x||(e.InlineValueContext=x={}));var q;(function(be){function Re(G){return{range:L.from(G.range),kind:G.kind}}be.from=Re;function ce(G){return new S.DocumentHighlight(L.to(G.range),G.kind)}be.to=ce})(q||(e.DocumentHighlight=q={}));var K;(function(be){function Re(G){return{uri:G.uri,highlights:G.highlights.map(q.from)}}be.from=Re;function ce(G){return new S.MultiDocumentHighlight(o.URI.revive(G.uri),G.highlights.map(q.to))}be.to=ce})(K||(e.MultiDocumentHighlight=K={}));var te;(function(be){function Re(ce){switch(ce){case s.CompletionTriggerKind.TriggerCharacter:return S.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return S.CompletionTriggerKind.Invoke}}be.to=Re})(te||(e.CompletionTriggerKind=te={}));var ue;(function(be){function Re(ce){return{triggerKind:te.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}be.to=Re})(ue||(e.CompletionContext=ue={}));var Ae;(function(be){function Re(G){switch(G){case S.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}be.from=Re;function ce(G){switch(G){case s.CompletionItemTag.Deprecated:return S.CompletionItemTag.Deprecated}}be.to=ce})(Ae||(e.CompletionItemTag=Ae={}));var Be;(function(be){const Re=new Map([[S.CompletionItemKind.Method,s.CompletionItemKind.Method],[S.CompletionItemKind.Function,s.CompletionItemKind.Function],[S.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[S.CompletionItemKind.Field,s.CompletionItemKind.Field],[S.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[S.CompletionItemKind.Class,s.CompletionItemKind.Class],[S.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[S.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[S.CompletionItemKind.Module,s.CompletionItemKind.Module],[S.CompletionItemKind.Property,s.CompletionItemKind.Property],[S.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[S.CompletionItemKind.Value,s.CompletionItemKind.Value],[S.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[S.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[S.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[S.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[S.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[S.CompletionItemKind.Text,s.CompletionItemKind.Text],[S.CompletionItemKind.Color,s.CompletionItemKind.Color],[S.CompletionItemKind.File,s.CompletionItemKind.File],[S.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[S.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[S.CompletionItemKind.Event,s.CompletionItemKind.Event],[S.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[S.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[S.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[S.CompletionItemKind.User,s.CompletionItemKind.User]]);function ce(Ue){return Re.get(Ue)??s.CompletionItemKind.Property}be.from=ce;const G=new Map([[s.CompletionItemKind.Method,S.CompletionItemKind.Method],[s.CompletionItemKind.Function,S.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,S.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,S.CompletionItemKind.Field],[s.CompletionItemKind.Variable,S.CompletionItemKind.Variable],[s.CompletionItemKind.Class,S.CompletionItemKind.Class],[s.CompletionItemKind.Interface,S.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,S.CompletionItemKind.Struct],[s.CompletionItemKind.Module,S.CompletionItemKind.Module],[s.CompletionItemKind.Property,S.CompletionItemKind.Property],[s.CompletionItemKind.Unit,S.CompletionItemKind.Unit],[s.CompletionItemKind.Value,S.CompletionItemKind.Value],[s.CompletionItemKind.Constant,S.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,S.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,S.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,S.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,S.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,S.CompletionItemKind.Text],[s.CompletionItemKind.Color,S.CompletionItemKind.Color],[s.CompletionItemKind.File,S.CompletionItemKind.File],[s.CompletionItemKind.Reference,S.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,S.CompletionItemKind.Folder],[s.CompletionItemKind.Event,S.CompletionItemKind.Event],[s.CompletionItemKind.Operator,S.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,S.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,S.CompletionItemKind.User],[s.CompletionItemKind.Issue,S.CompletionItemKind.Issue]]);function Pe(Ue){return G.get(Ue)??S.CompletionItemKind.Property}be.to=Pe})(Be||(e.CompletionItemKind=Be={}));var He;(function(be){function Re(ce,G){const Pe=new S.CompletionItem(ce.label);return Pe.insertText=ce.insertText,Pe.kind=Be.to(ce.kind),Pe.tags=ce.tags?.map(Ae.to),Pe.detail=ce.detail,Pe.documentation=A.isMarkdownString(ce.documentation)?ve.to(ce.documentation):ce.documentation,Pe.sortText=ce.sortText,Pe.filterText=ce.filterText,Pe.preselect=ce.preselect,Pe.commitCharacters=ce.commitCharacters,d.Range.isIRange(ce.range)?Pe.range=L.to(ce.range):typeof ce.range=="object"&&(Pe.range={inserting:L.to(ce.range.insert),replacing:L.to(ce.range.replace)}),Pe.keepWhitespace=typeof ce.insertTextRules>"u"?!1:!!(ce.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof ce.insertTextRules<"u"&&ce.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Pe.insertText=new S.SnippetString(ce.insertText):(Pe.insertText=ce.insertText,Pe.textEdit=Pe.range instanceof S.Range?new S.TextEdit(Pe.range,Pe.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Pe.additionalTextEdits=ce.additionalTextEdits.map(Ue=>_e.to(Ue))),Pe.command=G&&ce.command?G.fromInternal(ce.command):void 0,Pe}be.to=Re})(He||(e.CompletionItem=He={}));var Ye;(function(be){function Re(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:ve.fromStrict(G.documentation)}}be.from=Re;function ce(G){return{label:G.label,documentation:A.isMarkdownString(G.documentation)?ve.to(G.documentation):G.documentation}}be.to=ce})(Ye||(e.ParameterInformation=Ye={}));var tt;(function(be){function Re(G){return{label:G.label,documentation:ve.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(Ye.from):[],activeParameter:G.activeParameter}}be.from=Re;function ce(G){return{label:G.label,documentation:A.isMarkdownString(G.documentation)?ve.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(Ye.to):[],activeParameter:G.activeParameter}}be.to=ce})(tt||(e.SignatureInformation=tt={}));var Ze;(function(be){function Re(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(tt.from):[]}}be.from=Re;function ce(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(tt.to):[]}}be.to=ce})(Ze||(e.SignatureHelp=Ze={}));var it;(function(be){function Re(ce,G){const Pe=new S.InlayHint($.to(G.position),typeof G.label=="string"?G.label:G.label.map(nt.to.bind(void 0,ce)),G.kind&&mt.to(G.kind));return Pe.textEdits=G.textEdits&&G.textEdits.map(_e.to),Pe.tooltip=A.isMarkdownString(G.tooltip)?ve.to(G.tooltip):G.tooltip,Pe.paddingLeft=G.paddingLeft,Pe.paddingRight=G.paddingRight,Pe}be.to=Re})(it||(e.InlayHint=it={}));var nt;(function(be){function Re(ce,G){const Pe=new S.InlayHintLabelPart(G.label);return Pe.tooltip=A.isMarkdownString(G.tooltip)?ve.to(G.tooltip):G.tooltip,s.Command.is(G.command)&&(Pe.command=ce.fromInternal(G.command)),G.location&&(Pe.location=ze.to(G.location)),Pe}be.to=Re})(nt||(e.InlayHintLabelPart=nt={}));var mt;(function(be){function Re(G){return G}be.from=Re;function ce(G){return G}be.to=ce})(mt||(e.InlayHintKind=mt={}));var ut;(function(be){function Re(G){return{range:L.from(G.range),url:G.target,tooltip:G.tooltip}}be.from=Re;function ce(G){let Pe;if(G.url)try{Pe=typeof G.url=="string"?o.URI.parse(G.url,!0):o.URI.revive(G.url)}catch{}return new S.DocumentLink(L.to(G.range),Pe)}be.to=ce})(ut||(e.DocumentLink=ut={}));var rt;(function(be){function Re(G){const Pe=new S.ColorPresentation(G.label);return G.textEdit&&(Pe.textEdit=_e.to(G.textEdit)),G.additionalTextEdits&&(Pe.additionalTextEdits=G.additionalTextEdits.map(Ue=>_e.to(Ue))),Pe}be.to=Re;function ce(G){return{label:G.label,textEdit:G.textEdit?_e.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Pe=>_e.from(Pe)):void 0}}be.from=ce})(rt||(e.ColorPresentation=rt={}));var at;(function(be){function Re(G){return new S.Color(G[0],G[1],G[2],G[3])}be.to=Re;function ce(G){return[G.red,G.green,G.blue,G.alpha]}be.from=ce})(at||(e.Color=at={}));var ht;(function(be){function Re(G){return{range:L.from(G.range)}}be.from=Re;function ce(G){return new S.SelectionRange(L.to(G.range))}be.to=ce})(ht||(e.SelectionRange=ht={}));var We;(function(be){function Re(ce){switch(ce){case u.SaveReason.AUTO:return S.TextDocumentSaveReason.AfterDelay;case u.SaveReason.EXPLICIT:return S.TextDocumentSaveReason.Manual;case u.SaveReason.FOCUS_CHANGE:case u.SaveReason.WINDOW_CHANGE:return S.TextDocumentSaveReason.FocusOut}}be.to=Re})(We||(e.TextDocumentSaveReason=We={}));var xe;(function(be){function Re(G){switch(G){case S.TextEditorLineNumbersStyle.Off:return a.RenderLineNumbersType.Off;case S.TextEditorLineNumbersStyle.Relative:return a.RenderLineNumbersType.Relative;case S.TextEditorLineNumbersStyle.Interval:return a.RenderLineNumbersType.Interval;case S.TextEditorLineNumbersStyle.On:default:return a.RenderLineNumbersType.On}}be.from=Re;function ce(G){switch(G){case a.RenderLineNumbersType.Off:return S.TextEditorLineNumbersStyle.Off;case a.RenderLineNumbersType.Relative:return S.TextEditorLineNumbersStyle.Relative;case a.RenderLineNumbersType.Interval:return S.TextEditorLineNumbersStyle.Interval;case a.RenderLineNumbersType.On:default:return S.TextEditorLineNumbersStyle.On}}be.to=ce})(xe||(e.TextEditorLineNumbersStyle=xe={}));var Z;(function(be){function Re(G){if(G===S.EndOfLine.CRLF)return n.EndOfLineSequence.CRLF;if(G===S.EndOfLine.LF)return n.EndOfLineSequence.LF}be.from=Re;function ce(G){if(G===n.EndOfLineSequence.CRLF)return S.EndOfLine.CRLF;if(G===n.EndOfLineSequence.LF)return S.EndOfLine.LF}be.to=ce})(Z||(e.EndOfLine=Z={}));var j;(function(be){function Re(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case S.ProgressLocation.SourceControl:return g.ProgressLocation.Scm;case S.ProgressLocation.Window:return g.ProgressLocation.Window;case S.ProgressLocation.Notification:return g.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}be.from=Re})(j||(e.ProgressLocation=j={}));var we;(function(be){function Re(G){const Pe={start:G.start+1,end:G.end+1};return G.kind&&(Pe.kind=qe.from(G.kind)),Pe}be.from=Re;function ce(G){const Pe={start:G.start-1,end:G.end-1};return G.kind&&(Pe.kind=qe.to(G.kind)),Pe}be.to=ce})(we||(e.FoldingRange=we={}));var qe;(function(be){function Re(G){if(G)switch(G){case S.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}be.from=Re;function ce(G){if(G)switch(G.value){case s.FoldingRangeKind.Comment.value:return S.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports.value:return S.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region.value:return S.FoldingRangeKind.Region}}be.to=ce})(qe||(e.FoldingRangeKind=qe={}));var Je;(function(be){function Re(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?L.from(ce.selection):void 0,override:typeof ce.override=="boolean"?u.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}be.from=Re})(Je||(e.TextEditorOpenOptions=Je={}));var lt;(function(be){function Re(Ue){return Ue instanceof S.RelativePattern?Ue.toJSON():typeof Ue=="string"?Ue:ce(Ue)||G(Ue)?new S.RelativePattern(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}be.from=Re;function ce(Ue){const Qe=Ue;return Qe?o.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function G(Ue){const Qe=Ue;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Pe(Ue){return typeof Ue=="string"?Ue:new S.RelativePattern(o.URI.revive(Ue.baseUri),Ue.pattern)}be.to=Pe})(lt||(e.GlobPattern=lt={}));var gt;(function(be){function Re(ce){if(ce){if(Array.isArray(ce))return ce.map(Re);if(typeof ce=="string")return ce;{const G=ce;return{language:G.language,scheme:G.scheme,pattern:lt.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}be.from=Re})(gt||(e.LanguageSelector=gt={}));var Rt;(function(be){function Re(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&o.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Qe=>Qe instanceof S.Range)))}be.is=Re;function ce(G){return{documents:G.documents.map(Pe=>Pe.map(Ue=>({uri:o.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Qe=>L.from(Qe))})))}}be.from=ce})(Rt||(e.MappedEditsContext=Rt={}));var Gt;(function(be){function Re(G){return{start:G.start,end:G.end}}be.from=Re;function ce(G){return new S.NotebookRange(G.start,G.end)}be.to=ce})(Gt||(e.NotebookRange=Gt={}));var Ut;(function(be){function Re(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}be.to=Re;function ce(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}be.from=ce})(Ut||(e.NotebookCellExecutionSummary=Ut={}));var ui;(function(be){function Re(ce){if(ce===w.NotebookCellExecutionState.Unconfirmed)return S.NotebookCellExecutionState.Pending;if(ce===w.NotebookCellExecutionState.Pending)return;if(ce===w.NotebookCellExecutionState.Executing)return S.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ce}`)}be.to=Re})(ui||(e.NotebookCellExecutionState=ui={}));var Jt;(function(be){function Re(G){switch(G){case S.NotebookCellKind.Markup:return w.CellKind.Markup;case S.NotebookCellKind.Code:default:return w.CellKind.Code}}be.from=Re;function ce(G){switch(G){case w.CellKind.Markup:return S.NotebookCellKind.Markup;case w.CellKind.Code:default:return S.NotebookCellKind.Code}}be.to=ce})(Jt||(e.NotebookCellKind=Jt={}));var Xe;(function(be){function Re(G){const Pe={metadata:G.metadata??Object.create(null),cells:[]};for(const Ue of G.cells)S.NotebookCellData.validate(Ue),Pe.cells.push(Wt.from(Ue));return Pe}be.from=Re;function ce(G){const Pe=new S.NotebookData(G.cells.map(Wt.to));return(0,r.isEmptyObject)(G.metadata)||(Pe.metadata=G.metadata),Pe}be.to=ce})(Xe||(e.NotebookData=Xe={}));var Wt;(function(be){function Re(G){return{cellKind:Jt.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Ut.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(ft.from):[]}}be.from=Re;function ce(G){return new S.NotebookCellData(Jt.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(ft.to):void 0,G.metadata,G.internalMetadata?Ut.to(G.internalMetadata):void 0)}be.to=ce})(Wt||(e.NotebookCellData=Wt={}));var xt;(function(be){function Re(G){return{mime:G.mime,valueBytes:k.VSBuffer.wrap(G.data)}}be.from=Re;function ce(G){return new S.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}be.to=ce})(xt||(e.NotebookCellOutputItem=xt={}));var ft;(function(be){function Re(G){return{outputId:G.id,items:G.items.map(xt.from),metadata:G.metadata}}be.from=Re;function ce(G){const Pe=G.items.map(xt.to);return new S.NotebookCellOutput(Pe,G.outputId,G.metadata)}be.to=ce})(ft||(e.NotebookCellOutput=ft={}));var pt;(function(be){function Re(Pe){return G(Pe)?{include:lt.from(Pe.include)??void 0,exclude:lt.from(Pe.exclude)??void 0}:lt.from(Pe)??void 0}be.from=Re;function ce(Pe){return G(Pe)?{include:lt.to(Pe.include),exclude:lt.to(Pe.exclude)}:lt.to(Pe)}be.to=ce;function G(Pe){const Ue=Pe;return Ue?!(0,r.isUndefinedOrNull)(Ue.include)&&!(0,r.isUndefinedOrNull)(Ue.exclude):!1}})(pt||(e.NotebookExclusiveDocumentPattern=pt={}));var Zt;(function(be){function Re(ce,G,Pe){const Ue=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===S.NotebookCellStatusBarAlignment.Left?w.CellStatusbarAlignment.Left:w.CellStatusbarAlignment.Right,command:G.toInternal(Ue,Pe),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}be.from=Re})(Zt||(e.NotebookStatusBarItem=Zt={}));var Xt;(function(be){function Re(ce,G,Pe){const Ue=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{command:G.toInternal(Ue,Pe),label:ce.label,description:ce.description,detail:ce.detail,documentation:ce.documentation}}be.from=Re})(Xt||(e.NotebookKernelSourceAction=Xt={}));var Bt;(function(be){function Re(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{},cellContentMetadata:ce?.cellContentMetadata??{}}}be.from=Re})(Bt||(e.NotebookDocumentContentOptions=Bt={}));var Et;(function(be){function Re(G){return{uri:G.uri,provides:G.provides}}be.from=Re;function ce(G){return new S.NotebookRendererScript(o.URI.revive(G.uri),G.provides)}be.to=ce})(Et||(e.NotebookRendererScript=Et={}));var Ot;(function(be){function Re(G){return{message:ve.fromStrict(G.message)||"",type:D.TestMessageType.Error,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:L.from(G.location.range),uri:G.location.uri}}}be.from=Re;function ce(G){const Pe=new S.TestMessage(typeof G.message=="string"?G.message:ve.to(G.message));return Pe.actualOutput=G.actual,Pe.expectedOutput=G.expected,Pe.contextValue=G.contextValue,Pe.location=G.location?ze.to(G.location):void 0,Pe}be.to=ce})(Ot||(e.TestMessage=Ot={}));var Ht;(function(be){be.namespace=D.namespaceTestTag,be.denamespace=D.denamespaceTestTag})(Ht||(e.TestTag=Ht={}));var zt;(function(be){function Re(G){const Pe=(0,f.getPrivateApiFor)(G).controllerId;return{extId:p.TestId.fromExtHostTestItem(G,Pe).toString(),label:G.label,uri:o.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Ue=>Ht.namespace(Pe,Ue.id)),range:d.Range.lift(L.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&ve.fromStrict(G.error)||null}}be.from=Re;function ce(G){return{parent:void 0,error:void 0,id:p.TestId.fromString(G.extId).localId,label:G.label,uri:o.URI.revive(G.uri),tags:(G.tags||[]).map(Pe=>{const{tagId:Ue}=Ht.denamespace(Pe);return new S.TestTag(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:L.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}be.toPlain=ce})(zt||(e.TestItem=zt={})),function(be){function Re(G){return{id:G.id}}be.from=Re;function ce(G){return new S.TestTag(G.id)}be.to=ce}(Ht||(e.TestTag=Ht={}));var Ge;(function(be){const Re=(G,Pe)=>{const Ue=G.value;if(!Ue)return;const Qe={...zt.toPlain(Ue.item),parent:Pe,taskStates:Ue.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(ct=>ct.type===D.TestMessageType.Error).map(Ot.to)})),children:[]};if(G.children)for(const Ve of G.children.values()){const ct=Re(Ve,Qe);ct&&Qe.children.push(ct)}return Qe};function ce(G){const Pe=new c.WellDefinedPrefixTree;for(const Ve of G.items)Pe.insert(p.TestId.fromString(Ve.item.extId).path,Ve);const Ue=[Pe.nodes],Qe=[];for(;Ue.length;)for(const Ve of Ue.pop())Ve.value?Qe.push(Ve):Ve.children&&Ue.push(Ve.children.values());return{completedAt:G.completedAt,results:Qe.map(Ve=>Re(Ve)).filter(r.isDefined)}}be.to=ce})(Ge||(e.TestResults=Ge={}));var ei;(function(be){function Re(Ue){return{covered:Ue.covered,total:Ue.total}}function ce(Ue){return"line"in Ue?$.from(Ue):L.from(Ue)}function G(Ue){if(typeof Ue.executed=="number"&&Ue.executed<0)throw new Error(`Invalid coverage count ${Ue.executed}`);return"branches"in Ue?{count:Ue.executed,location:ce(Ue.location),type:D.DetailType.Statement,branches:Ue.branches.length?Ue.branches.map(Qe=>({count:Qe.executed,location:Qe.location&&ce(Qe.location),label:Qe.label})):void 0}:{type:D.DetailType.Declaration,name:Ue.name,count:Ue.executed,location:ce(Ue.location)}}be.fromDetails=G;function Pe(Ue,Qe,Ve){return S.validateTestCoverageCount(Ve.statementCoverage),S.validateTestCoverageCount(Ve.branchCoverage),S.validateTestCoverageCount(Ve.declarationCoverage),{id:Qe,uri:Ve.uri,statement:Re(Ve.statementCoverage),branch:Ve.branchCoverage&&Re(Ve.branchCoverage),declaration:Ve.declarationCoverage&&Re(Ve.declarationCoverage),testId:Ve instanceof S.FileCoverage&&Ve.testItem?p.TestId.fromExtHostTestItem(Ve.testItem,Ue).toString():void 0}}be.fromFile=Pe})(ei||(e.TestCoverage=ei={}));var ti;(function(be){function Re(ce){switch(ce){case s.CodeActionTriggerType.Invoke:return S.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return S.CodeActionTriggerKind.Automatic}}be.to=Re})(ti||(e.CodeActionTriggerKind=ti={}));var li;(function(be){function Re(G){const Pe=new S.TypeHierarchyItem(Se.to(G.kind),G.name,G.detail||"",o.URI.revive(G.uri),L.to(G.range),L.to(G.selectionRange));return Pe._sessionId=G._sessionId,Pe._itemId=G._itemId,Pe}be.to=Re;function ce(G,Pe,Ue){if(Pe=Pe??G._sessionId,Ue=Ue??G._itemId,Pe===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ue,kind:Se.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:L.from(G.range),selectionRange:L.from(G.selectionRange),tags:G.tags?.map(ae.from)}}be.from=ce})(li||(e.TypeHierarchyItem=li={}));var _t;(function(be){function Re(ce){if(ce)return{value:ce.value,tooltip:ce.tooltip}}be.from=Re})(_t||(e.ViewBadge=_t={}));var Lt;(function(be){function Re(Ue,Qe,Ve){const ct=Qe.fileData;return ct?new S.InternalFileDataTransferItem(new S.DataTransferFile(ct.name,o.URI.revive(ct.uri),ct.id,(0,O.createSingleCallFunction)(()=>Ve(ct.id)))):Ue===T.Mimes.uriList&&Qe.uriListData?new S.InternalDataTransferItem(Pe(Qe.uriListData)):new S.InternalDataTransferItem(Qe.asString)}be.to=Re;async function ce(Ue,Qe){const Ve=await Qe.asString();if(Ue===T.Mimes.uriList)return{asString:Ve,fileData:void 0,uriListData:G(Ve)};const ct=Qe.asFile();return{asString:Ve,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}be.from=ce;function G(Ue){return P.UriList.split(Ue).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return o.URI.parse(Qe)}catch{}return Qe})}function Pe(Ue){return P.UriList.create(Ue.map(Qe=>typeof Qe=="string"?Qe:o.URI.revive(Qe)))}})(Lt||(e.DataTransferItem=Lt={}));var Pt;(function(be){function Re(G,Pe){const Ue=G.items.map(([Qe,Ve])=>[Qe,Lt.to(Qe,Ve,Pe)]);return new S.DataTransfer(Ue)}be.toDataTransfer=Re;async function ce(G){const Pe={items:[]},Ue=[];for(const[Qe,Ve]of G)Ue.push((async()=>{Pe.items.push([Qe,await Lt.from(Qe,Ve)])})());return await Promise.all(Ue),Pe}be.from=ce})(Pt||(e.DataTransfer=Pt={}));var Nt;(function(be){function Re(G,Pe){return{kind:"reply",agentId:G.participant??Pe?.agentId??"",subCommand:G.command??Pe?.command,message:G.prompt,title:G.label}}be.from=Re;function ce(G){return{prompt:G.message,label:G.title,participant:G.agentId,command:G.subCommand}}be.to=ce})(Nt||(e.ChatFollowup=Nt={}));var ci;(function(be){function Re(G){switch(G.role){case I.ChatMessageRole.System:return new S.LanguageModelChatMessage(S.LanguageModelChatMessageRole.System,G.content);case I.ChatMessageRole.User:return new S.LanguageModelChatMessage(S.LanguageModelChatMessageRole.User,G.content);case I.ChatMessageRole.Assistant:return new S.LanguageModelChatMessage(S.LanguageModelChatMessageRole.Assistant,G.content)}}be.to=Re;function ce(G){switch(G.role){case S.LanguageModelChatMessageRole.System:return{role:I.ChatMessageRole.System,content:G.content};case S.LanguageModelChatMessageRole.User:return{role:I.ChatMessageRole.User,content:G.content};case S.LanguageModelChatMessageRole.Assistant:return{role:I.ChatMessageRole.Assistant,content:G.content}}}be.from=ce})(ci||(e.LanguageModelChatMessage=ci={}));var $t;(function(be){function Re(G){return{kind:"markdownContent",content:ve.from(G.value)}}be.from=Re;function ce(G){return new S.ChatResponseMarkdownPart(ve.to(G.content))}be.to=ce})($t||(e.ChatResponseMarkdownPart=$t={}));var ri;(function(be){function Re(G){return{kind:"markdownVuln",content:ve.from(G.value),vulnerabilities:G.vulnerabilities}}be.from=Re;function ce(G){return new S.ChatResponseMarkdownWithVulnerabilitiesPart(ve.to(G.content),G.vulnerabilities)}be.to=ce})(ri||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ri={}));var Ft;(function(be){function Re(G){return{kind:"agentDetection",agentId:G.participant,command:G.command}}be.from=Re;function ce(G){return new S.ChatResponseDetectedParticipantPart(G.agentId,G.command)}be.to=ce})(Ft||(e.ChatResponseDetectedParticipantPart=Ft={}));var Qt;(function(be){function Re(ce){return{kind:"confirmation",title:ce.title,message:ce.message,data:ce.data}}be.from=Re})(Qt||(e.ChatResponseConfirmationPart=Qt={}));var si;(function(be){function Re(G){const{value:Pe,baseUri:Ue}=G;function Qe(Ve,ct){return Ve.map(Dt=>{const Yt=o.URI.joinPath(ct,Dt.name);return{label:Dt.name,uri:Yt,children:Dt.children&&Qe(Dt.children,Yt)}})}return{kind:"treeData",treeData:{label:(0,C.basename)(Ue),uri:Ue,children:Qe(Pe,Ue)}}}be.from=Re;function ce(G){const Pe=(0,l.revive)(G.treeData);function Ue(ct){return ct.map(Dt=>({name:Dt.label,children:Dt.children&&Ue(Dt.children)}))}const Qe=Pe.uri,Ve=Pe.children?Ue(Pe.children):[];return new S.ChatResponseFileTreePart(Ve,Qe)}be.to=ce})(si||(e.ChatResponseFilesPart=si={}));var Tt;(function(be){function Re(G){const Pe=Ue=>o.URI.isUri(Ue);return{kind:"inlineReference",name:G.title,inlineReference:Pe(G.value)?G.value:H.from(G.value)}}be.from=Re;function ce(G){const Pe=(0,l.revive)(G);return new S.ChatResponseAnchorPart(o.URI.isUri(Pe.inlineReference)?Pe.inlineReference:H.to(Pe.inlineReference),G.name)}be.to=ce})(Tt||(e.ChatResponseAnchorPart=Tt={}));var St;(function(be){function Re(G){return{kind:"progressMessage",content:ve.from(G.value)}}be.from=Re;function ce(G){return new S.ChatResponseProgressPart(G.content.value)}be.to=ce})(St||(e.ChatResponseProgressPart=St={}));var vt;(function(be){function Re(G){return{kind:"warning",content:ve.from(G.value)}}be.from=Re;function ce(G){return new S.ChatResponseWarningPart(G.content.value)}be.to=ce})(vt||(e.ChatResponseWarningPart=vt={}));var Vt;(function(be){function Re(ce){return{kind:"progressTask",content:ve.from(ce.value)}}be.from=Re})(Vt||(e.ChatTask=Vt={}));var Ct;(function(be){function Re(ce){return{kind:"progressTaskResult",content:typeof ce=="string"?ve.from(ce):void 0}}be.from=Re})(Ct||(e.ChatTaskResult=Ct={}));var oi;(function(be){function Re(G,Pe,Ue){return{kind:"command",command:Pe.toInternal(G.value,Ue)??{command:G.value.command,title:G.value.title}}}be.from=Re;function ce(G,Pe){return new S.ChatResponseCommandButtonPart(Pe.fromInternal(G.command)??{command:G.command.id,title:G.command.title})}be.to=ce})(oi||(e.ChatResponseCommandButtonPart=oi={}));var qt;(function(be){function Re(G){return{kind:"textEdit",uri:G.uri,edits:G.edits.map(Pe=>_e.from(Pe))}}be.from=Re;function ce(G){return new S.ChatResponseTextEditPart(o.URI.revive(G.uri),G.edits.map(Pe=>_e.to(Pe)))}be.to=ce})(qt||(e.ChatResponseTextEditPart=qt={}));var pi;(function(be){function Re(G){const Pe=h.ThemeIcon.isThemeIcon(G.iconPath)?G.iconPath:o.URI.isUri(G.iconPath)?{light:o.URI.revive(G.iconPath)}:G.iconPath&&"light"in G.iconPath&&"dark"in G.iconPath&&o.URI.isUri(G.iconPath.light)&&o.URI.isUri(G.iconPath.dark)?{light:o.URI.revive(G.iconPath.light),dark:o.URI.revive(G.iconPath.dark)}:void 0;return"variableName"in G.value?{kind:"reference",reference:{variableName:G.value.variableName,value:o.URI.isUri(G.value.value)||!G.value.value?G.value.value:H.from(G.value.value)},iconPath:Pe}:{kind:"reference",reference:o.URI.isUri(G.value)?G.value:H.from(G.value),iconPath:Pe}}be.from=Re;function ce(G){const Pe=(0,l.revive)(G),Ue=Qe=>o.URI.isUri(Qe)?Qe:H.to(Qe);return new S.ChatResponseReferencePart("variableName"in Pe.reference?{variableName:Pe.reference.variableName,value:Pe.reference.value&&Ue(Pe.reference.value)}:Ue(Pe.reference))}be.to=ce})(pi||(e.ChatResponseReferencePart=pi={}));var hi;(function(be){function Re(Pe,Ue,Qe){return Pe instanceof S.ChatResponseMarkdownPart?$t.from(Pe):Pe instanceof S.ChatResponseAnchorPart?Tt.from(Pe):Pe instanceof S.ChatResponseReferencePart?pi.from(Pe):Pe instanceof S.ChatResponseProgressPart?St.from(Pe):Pe instanceof S.ChatResponseFileTreePart?si.from(Pe):Pe instanceof S.ChatResponseCommandButtonPart?oi.from(Pe,Ue,Qe):Pe instanceof S.ChatResponseTextEditPart?qt.from(Pe):Pe instanceof S.ChatResponseMarkdownWithVulnerabilitiesPart?ri.from(Pe):Pe instanceof S.ChatResponseDetectedParticipantPart?Ft.from(Pe):Pe instanceof S.ChatResponseWarningPart?vt.from(Pe):{kind:"markdownContent",content:ve.from("")}}be.from=Re;function ce(Pe,Ue){switch(Pe.kind){case"reference":return pi.to(Pe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return G(Pe,Ue)}}be.to=ce;function G(Pe,Ue){switch(Pe.kind){case"markdownContent":return $t.to(Pe);case"inlineReference":return Tt.to(Pe);case"progressMessage":return;case"treeData":return si.to(Pe);case"command":return oi.to(Pe,Ue)}}be.toContent=G})(hi||(e.ChatResponsePart=hi={}));var Di;(function(be){function Re(ce){return{prompt:ce.message,command:ce.command,attempt:ce.attempt??0,enableCommandDetection:ce.enableCommandDetection??!0,references:ce.variables.variables.map(Pi.to),location:kt.to(ce.location),acceptedConfirmationData:ce.acceptedConfirmationData,rejectedConfirmationData:ce.rejectedConfirmationData}}be.to=Re})(Di||(e.ChatAgentRequest=Di={}));var kt;(function(be){function Re(G){switch(G){case E.ChatAgentLocation.Notebook:return S.ChatLocation.Notebook;case E.ChatAgentLocation.Terminal:return S.ChatLocation.Terminal;case E.ChatAgentLocation.Panel:return S.ChatLocation.Panel;case E.ChatAgentLocation.Editor:return S.ChatLocation.Editor}}be.to=Re;function ce(G){switch(G){case S.ChatLocation.Notebook:return E.ChatAgentLocation.Notebook;case S.ChatLocation.Terminal:return E.ChatAgentLocation.Terminal;case S.ChatLocation.Panel:return E.ChatAgentLocation.Panel;case S.ChatLocation.Editor:return E.ChatAgentLocation.Editor}}be.from=ce})(kt||(e.ChatLocation=kt={}));var Pi;(function(be){function Re(ce){const G=ce.value;if(!G)throw new Error("Invalid value reference");return{id:ce.id,name:ce.name,range:ce.range&&[ce.range.start,ce.range.endExclusive],value:(0,o.isUriComponents)(G)?o.URI.revive(G):G&&typeof G=="object"&&"uri"in G&&"range"in G&&(0,o.isUriComponents)(G.uri)?H.to((0,l.revive)(G)):G,modelDescription:ce.modelDescription}}be.to=Re})(Pi||(e.ChatAgentValueReference=Pi={}));var ai;(function(be){function Re(ce,G,Pe){return{id:ce.id,label:ce.label,fullName:ce.fullName,icon:ce.icon?.id,value:ce.values[0].value,insertText:ce.insertText,detail:ce.detail,documentation:ce.documentation,command:G.toInternal(ce.command,Pe)}}be.from=Re})(ai||(e.ChatAgentCompletionItem=ai={}));var It;(function(be){function Re(ce){return{errorDetails:ce.errorDetails,metadata:ce.metadata}}be.to=Re})(It||(e.ChatAgentResult=It={}));var Ii;(function(be){function Re(ce,G,Pe){if(G.action.kind==="vote")return;const Ue=It.to(ce);if(G.action.kind==="command"){const Qe=G.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Pe.fromInternal(Qe)??{command:Qe.id,title:Qe.title}}},result:Ue}}else return G.action.kind==="followUp"?{action:{kind:"followUp",followup:Nt.to(G.action.followup)},result:Ue}:G.action.kind==="inlineChat"?{action:{kind:"editor",accepted:G.action.action==="accepted"},result:Ue}:{action:G.action,result:Ue}}be.to=Re})(Ii||(e.ChatAgentUserActionEvent=Ii={}));var Si;(function(be){function Re(ce,G,Pe){return"terminalCommand"in ce?{terminalCommand:ce.terminalCommand,shouldExecute:ce.shouldExecute}:"uri"in ce?{uri:ce.uri}:G.toInternal(ce,Pe)}be.from=Re})(Si||(e.TerminalQuickFix=Si={}));var vi;(function(be){function Re(ce){return{kind:ki.to(ce.kind)}}be.to=Re})(vi||(e.PartialAcceptInfo=vi={}));var ki;(function(be){function Re(ce){switch(ce){case s.PartialAcceptTriggerKind.Word:return S.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return S.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return S.PartialAcceptTriggerKind.Suggest;default:return S.PartialAcceptTriggerKind.Unknown}}be.to=Re})(ki||(e.PartialAcceptTriggerKind=ki={}));var fi;(function(be){function Re(ce,G){return{id:G,label:ce.label,description:ce.description,canEdit:ce.canEdit,collapsibleState:ce.collapsibleState||_.DebugTreeItemCollapsibleState.None,contextValue:ce.contextValue}}be.from=Re})(fi||(e.DebugTreeItem=fi={}))}),define(De[273],Ie([1,0,5,17,10,38]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(v,l){this._proxy=v.getProxy(y.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:T=>l.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,l,T){const b=new O.SerializableObjectWithBuffers(P.WorkspaceEdit.from(v,this._versionInformationProvider));return this._proxy.$tryApplyWorkspaceEdit(b,void 0,T?.isRefactoring??!1)}};e.ExtHostBulkEdits=A,e.ExtHostBulkEdits=A=je([$e(0,k.IExtHostRpcService)],A)}),define(De[274],Ie([1,0,18,11,48,4,40,6,69,15,2,19,5,10,7,234,25]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class a{constructor(n,i,g,f,u){this._extension=n,this._request=i,this._proxy=g,this._commandsConverter=f,this._sessionDisposables=u,this._stopWatch=v.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let i=function(f){if(n._isClosed){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,f),u}};const n=this;this._stopWatch.reset();const g=(f,u)=>{if(typeof this._firstProgress>"u"&&"content"in f&&(this._firstProgress=this._stopWatch.elapsed()),u){const E=this._proxy.$handleProgressChunk(this._request.requestId,f),I={report:_=>{E?.then(w=>{w&&(h.MarkdownString.isMarkdownString(_.value)?this._proxy.$handleProgressChunk(this._request.requestId,C.ChatResponseWarningPart.from(_),w):this._proxy.$handleProgressChunk(this._request.requestId,C.ChatResponseReferencePart.from(_),w))})}};Promise.all([E,u?.(I)]).then(([_,w])=>{_!==void 0&&w!==void 0&&this._proxy.$handleProgressChunk(this._request.requestId,C.ChatTaskResult.from(w),_)})}else this._proxy.$handleProgressChunk(this._request.requestId,f)};this._apiObject={markdown(f){i(this.markdown);const u=new h.ChatResponseMarkdownPart(f),E=C.ChatResponseMarkdownPart.from(u);return g(E),this},markdownWithVulnerabilities(f,u){i(this.markdown),u&&(0,o.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions");const E=new h.ChatResponseMarkdownWithVulnerabilitiesPart(f,u),I=C.ChatResponseMarkdownWithVulnerabilitiesPart.from(E);return g(I),this},filetree(f,u){i(this.filetree);const E=new h.ChatResponseFileTreePart(f,u),I=C.ChatResponseFilesPart.from(E);return g(I),this},anchor(f,u){i(this.anchor);const E=new h.ChatResponseAnchorPart(f,u),I=C.ChatResponseAnchorPart.from(E);return g(I),this},button(f){i(this.anchor);const u=new h.ChatResponseCommandButtonPart(f),E=C.ChatResponseCommandButtonPart.from(u,n._commandsConverter,n._sessionDisposables);return g(E),this},progress(f,u){i(this.progress);const E=new h.ChatResponseProgressPart2(f,u),I=u?C.ChatTask.from(E):C.ChatResponseProgressPart.from(E);return g(I,u),this},warning(f){i(this.progress),(0,o.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions");const u=new h.ChatResponseWarningPart(f),E=C.ChatResponseWarningPart.from(u);return g(E),this},reference(f,u){if(i(this.reference),"variableName"in f&&(0,o.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions"),"variableName"in f&&!f.value){const E=n._request.variables.variables.find(I=>I.name===f.variableName);if(E){let I;if(E.references?.length)I=E.references.map(_=>({kind:"reference",reference:{variableName:f.variableName,value:_.reference}}));else{const _=new h.ChatResponseReferencePart(f,u);I=[C.ChatResponseReferencePart.from(_)]}return I.forEach(_=>g(_)),this}}else{const E=new h.ChatResponseReferencePart(f,u),I=C.ChatResponseReferencePart.from(E);g(I)}return this},textEdit(f,u){i(this.textEdit),(0,o.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions");const E=new h.ChatResponseTextEditPart(f,u),I=C.ChatResponseTextEditPart.from(E);return g(I),this},detectedParticipant(f,u){i(this.detectedParticipant),(0,o.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions");const E=new h.ChatResponseDetectedParticipantPart(f,u),I=C.ChatResponseDetectedParticipantPart.from(E);return g(I),this},confirmation(f,u,E){i(this.confirmation),(0,o.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions");const I=new h.ChatResponseConfirmationPart(f,u,E),_=C.ChatResponseConfirmationPart.from(I);return g(_),this},push(f){if(i(this.push),(f instanceof h.ChatResponseTextEditPart||f instanceof h.ChatResponseMarkdownWithVulnerabilitiesPart||f instanceof h.ChatResponseDetectedParticipantPart||f instanceof h.ChatResponseWarningPart||f instanceof h.ChatResponseConfirmationPart)&&(0,o.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions"),f instanceof h.ChatResponseReferencePart)this.reference(f.value,f.iconPath);else{const u=C.ChatResponsePart.from(f,n._commandsConverter,n._sessionDisposables);g(u)}return this}}}return this._apiObject}}class d extends R.Disposable{static{this._idPool=0}constructor(n,i,g,f){super(),this._logService=i,this.commands=g,this.quality=f,this._agents=new Map,this._sessionDisposables=this._register(new R.DisposableMap),this._completionDisposables=this._register(new R.DisposableMap),this._proxy=n.getProxy(c.MainContext.MainThreadChatAgents2)}transferActiveChat(n){this._proxy.$transferActiveChatSession(n)}createChatAgent(n,i,g){const f=d._idPool++,u=new t(n,this.quality,i,this._proxy,f,g);return this._agents.set(f,u),u.isAgentEnabled()&&this._proxy.$registerAgent(f,n.identifier,i,{},void 0),u.apiAgent}createDynamicChatAgent(n,i,g,f){const u=d._idPool++,E=new t(n,this.quality,i,this._proxy,u,f);return this._agents.set(u,E),this._proxy.$registerAgent(u,n.identifier,i,{isSticky:!0},g),E.apiAgent}async $invokeAgent(n,i,g,f){const u=this._agents.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let E=this._sessionDisposables.get(i.sessionId);E||(E=new R.DisposableStore,this._sessionDisposables.set(i.sessionId,E));const I=new a(u.extension,i,this._proxy,this.commands.converter,E);try{const _=await this.prepareHistoryTurns(i.agentId,g),w=u.invoke(C.ChatAgentRequest.to(i),{history:_},I.apiObject,f);return await(0,k.raceCancellation)(Promise.resolve(w).then(p=>{if(p?.metadata)try{JSON.stringify(p.metadata)}catch(m){const S=`result.metadata MUST be JSON.stringify-able. Got error: ${m.message}`;return this._logService.error(`[${u.extension.identifier.value}] [@${u.id}] ${S}`,u.extension),{errorDetails:{message:S},timings:I.timings}}let D;return p?.errorDetails&&(D={...p.errorDetails,responseIsIncomplete:!0}),D?.responseIsRedacted&&(0,o.checkProposedApiEnabled)(u.extension,"chatParticipantPrivate"),{errorDetails:D,timings:I.timings,metadata:p?.metadata}}),f)}catch(_){return this._logService.error(_,u.extension),_ instanceof h.LanguageModelError&&_.cause&&(_=_.cause),{errorDetails:{message:(0,P.toErrorMessage)(_),responseIsIncomplete:!0}}}finally{I.close()}}async prepareHistoryTurns(n,i){const g=[];for(const f of i.history){const u=C.ChatAgentResult.to(f.result),E=n===f.request.agentId?u:{...u,metadata:void 0};g.push(new h.ChatRequestTurn(f.request.message,f.request.command,f.request.variables.variables.map(C.ChatAgentValueReference.to),f.request.agentId));const I=(0,y.coalesce)(f.response.map(_=>C.ChatResponsePart.toContent(_,this.commands.converter)));g.push(new h.ChatResponseTurn(I,E,f.request.agentId,f.request.command))}return g}$releaseSession(n){this._sessionDisposables.deleteAndDispose(n)}async $provideFollowups(n,i,g,f,u){const E=this._agents.get(i);if(!E)return Promise.resolve([]);const I=await this.prepareHistoryTurns(E.id,f),_=C.ChatAgentResult.to(g);return(await E.provideFollowups(_,{history:I},u)).filter(w=>{const p=!w.participant||A.Iterable.some(this._agents.values(),D=>D.id===w.participant&&b.ExtensionIdentifier.equals(D.extension.identifier,E.extension.identifier));return p||this._logService.warn(`[@${E.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),p}).map(w=>C.ChatFollowup.from(w,n))}$acceptFeedback(n,i,g,f){const u=this._agents.get(n);if(!u)return;const E=C.ChatAgentResult.to(i);let I;switch(g){case r.ChatAgentVoteDirection.Down:I=h.ChatResultFeedbackKind.Unhelpful;break;case r.ChatAgentVoteDirection.Up:I=h.ChatResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(f?{result:E,kind:I,reportIssue:f}:{result:E,kind:I}))}$acceptAction(n,i,g){const f=this._agents.get(n);if(!f||g.action.kind==="vote")return;const u=C.ChatAgentUserActionEvent.to(i,g,this.commands.converter);u&&f.acceptAction(Object.freeze(u))}async $invokeCompletionProvider(n,i,g){const f=this._agents.get(n);if(!f)return[];let u=this._completionDisposables.get(n);return u?u.clear():(u=new R.DisposableStore,this._completionDisposables.set(n,u)),(await f.invokeCompletionProvider(i,g)).map(I=>C.ChatAgentCompletionItem.from(I,this.commands.converter,u))}async $provideWelcomeMessage(n,i,g){const f=this._agents.get(n);if(f)return await f.provideWelcomeMessage(C.ChatLocation.to(i),g)}async $provideSampleQuestions(n,i,g){const f=this._agents.get(n);if(f)return(await f.provideSampleQuestions(C.ChatLocation.to(i),g)).map(u=>C.ChatFollowup.from(u,void 0))}}e.ExtHostChatAgents2=d;class t{constructor(n,i,g,f,u,E){this.extension=n,this.quality=i,this.id=g,this._proxy=f,this._handle=u,this._requestHandler=E,this._onDidReceiveFeedback=new O.Emitter,this._onDidPerformAction=new O.Emitter}acceptFeedback(n){this._onDidReceiveFeedback.fire(n)}acceptAction(n){this._onDidPerformAction.fire(n)}async invokeCompletionProvider(n,i){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(n,i)??[]:[]}isAgentEnabled(){return!(this.quality==="stable"&&!(0,o.isProposedApiEnabled)(this.extension,"chatParticipantPrivate"))}async provideFollowups(n,i,g){if(!this._followupProvider)return[];const f=await this._followupProvider.provideFollowups(n,i,g);return f?f.filter(u=>!(u&&"commandId"in u)).filter(u=>!(u&&"message"in u)):[]}async provideWelcomeMessage(n,i){if(!this._welcomeMessageProvider)return[];const g=await this._welcomeMessageProvider.provideWelcomeMessage(n,i);return g?g.map(f=>typeof f=="string"?f:C.MarkdownString.from(f)):[]}async provideSampleQuestions(n,i){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const g=await this._welcomeMessageProvider.provideSampleQuestions(n,i);return g||[]}get apiAgent(){let n=!1,i=!1;const g=()=>{n||i||(i=!0,queueMicrotask(()=>{f.isAgentEnabled()&&(this._proxy.$updateAgent(this._handle,{icon:this._iconPath?this._iconPath instanceof T.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof h.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:C.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:C.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:C.MarkdownString.from(this._helpTextPostfix),supportIssueReporting:this._supportIssueReporting,requester:this._requester,supportsSlowVariables:this._supportsSlowReferences}),i=!1)}))},f=this;return{get id(){return f.id},get iconPath(){return f._iconPath},set iconPath(u){f._iconPath=u,g()},get requestHandler(){return f._requestHandler},set requestHandler(u){(0,l.assertType)(typeof u=="function","Invalid request handler"),f._requestHandler=u},get followupProvider(){return f._followupProvider},set followupProvider(u){f._followupProvider=u,g()},get isDefault(){return(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._isDefault},set isDefault(u){(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._isDefault=u,g()},get helpTextPrefix(){return(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextPrefix},set helpTextPrefix(u){(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextPrefix=u,g()},get helpTextVariablesPrefix(){return(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextVariablesPrefix},set helpTextVariablesPrefix(u){(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextVariablesPrefix=u,g()},get helpTextPostfix(){return(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextPostfix},set helpTextPostfix(u){(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextPostfix=u,g()},get isSecondary(){return(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._isSecondary},set isSecondary(u){(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._isSecondary=u,g()},get supportIssueReporting(){return(0,o.checkProposedApiEnabled)(f.extension,"chatParticipantPrivate"),f._supportIssueReporting},set supportIssueReporting(u){(0,o.checkProposedApiEnabled)(f.extension,"chatParticipantPrivate"),f._supportIssueReporting=u,g()},get onDidReceiveFeedback(){return f._onDidReceiveFeedback.event},set participantVariableProvider(u){if((0,o.checkProposedApiEnabled)(f.extension,"chatParticipantAdditions"),f._agentVariableProvider=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");f._proxy.$registerAgentCompletionsProvider(f._handle,f.id,u.triggerCharacters)}else f._proxy.$unregisterAgentCompletionsProvider(f._handle,f.id)},get participantVariableProvider(){return(0,o.checkProposedApiEnabled)(f.extension,"chatParticipantAdditions"),f._agentVariableProvider},set welcomeMessageProvider(u){(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._welcomeMessageProvider=u,g()},get welcomeMessageProvider(){return(0,o.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._welcomeMessageProvider},onDidPerformAction:(0,o.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(u){f._requester=u,g()},get requester(){return f._requester},set supportsSlowReferences(u){(0,o.checkProposedApiEnabled)(f.extension,"chatParticipantPrivate"),f._supportsSlowReferences=u,g()},get supportsSlowReferences(){return(0,o.checkProposedApiEnabled)(f.extension,"chatParticipantPrivate"),f._supportsSlowReferences},dispose(){n=!0,f._followupProvider=void 0,f._onDidReceiveFeedback.dispose(),f._proxy.$unregisterAgent(f._handle)}}}invoke(n,i,g,f){return this._requestHandler(n,i,g,f)}}}),define(De[275],Ie([1,0,14,6,34,5,10,7,25]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class l{static{this._idPool=0}constructor(c){this._resolver=new Map,this._proxy=c.getProxy(O.MainContext.MainThreadChatVariables)}async $resolveVariable(c,C,h,r){const o=this._resolver.get(c);if(o)try{if(o.resolver.resolve2){(0,v.checkProposedApiEnabled)(o.extension,"chatParticipantAdditions");const a=new T(C,this._proxy),d=await o.resolver.resolve2(o.data.name,{prompt:h},a.apiObject,r);if(d&&d[0])return d[0].value}else{const a=await o.resolver.resolve(o.data.name,{prompt:h},r);if(a&&a[0])return a[0].value}}catch(a){(0,y.onUnexpectedExternalError)(a)}}registerVariableResolver(c,C,h,r,o,a,d,t,s){const n=l._idPool++,i=s?P.ThemeIcon.fromId(s):void 0;return this._resolver.set(n,{extension:c,data:{id:C,name:h,description:r,modelDescription:o,icon:i},resolver:d}),this._proxy.$registerVariable(n,{id:C,name:h,description:r,modelDescription:o,isSlow:a,fullName:t,icon:i}),(0,k.toDisposable)(()=>{this._resolver.delete(n),this._proxy.$unregisterVariable(n)})}attachContext(c,C,h){this._proxy.$attachContext(c,R.Location.isLocation(C)?A.Location.from(C):C,A.ChatLocation.from(h))}}e.ExtHostChatVariables=l;class T{constructor(c,C){this._requestId=c,this._proxy=C,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let C=function(r){if(c._isClosed){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,r),o}};const c=this,h=r=>{this._proxy.$handleProgressChunk(this._requestId,r)};this._apiObject={progress(r){C(this.progress);const o=new R.ChatResponseProgressPart(r),a=A.ChatResponseProgressPart.from(o);return h(a),this},reference(r){C(this.reference);const o=new R.ChatResponseReferencePart(r),a=A.ChatResponseReferencePart.from(o);return h(a),this},push(r){return C(this.push),r instanceof R.ChatResponseReferencePart?h(A.ChatResponseReferencePart.from(r)):r instanceof R.ChatResponseProgressPart&&h(A.ChatResponseProgressPart.from(r)),this}}}return this._apiObject}}}),define(De[276],Ie([1,0,11,72,4,6,37,2,94,19,10,7,5,25]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=h;function h(r,o,a){const d=r.getProxy(c.MainContext.MainThreadComments);class t{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new l.ExtensionIdentifierMap,o.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===A.MarshalledId.CommentController){const p=this._commentControllers.get(w.handle);return p?p.value:w}else if(w&&w.$mid===A.MarshalledId.CommentThread){const p=w,D=this._commentControllers.get(p.commentControlHandle);if(!D)return p;const m=D.getCommentThread(p.commentThreadHandle);return m?m.value:p}else if(w&&(w.$mid===A.MarshalledId.CommentThreadReply||w.$mid===A.MarshalledId.CommentThreadInstance)){const p=this._commentControllers.get(w.thread.commentControlHandle);if(!p)return w;const D=p.getCommentThread(w.thread.commentThreadHandle);return D?w.$mid===A.MarshalledId.CommentThreadInstance?D.value:{thread:D.value,text:w.text}:w}else if(w&&w.$mid===A.MarshalledId.CommentNode){const p=this._commentControllers.get(w.thread.commentControlHandle);if(!p)return w;const D=p.getCommentThread(w.thread.commentThreadHandle);if(!D)return w;const m=w.commentUniqueId,S=D.getCommentByUniqueId(m);return S||w}else if(w&&w.$mid===A.MarshalledId.CommentThreadNode){const p=this._commentControllers.get(w.thread.commentControlHandle);if(!p)return w;const D=p.getCommentThread(w.thread.commentThreadHandle);if(!D)return w;const m=w.text,S=w.commentUniqueId,M=D.getCommentByUniqueId(S);return M?(typeof M.body=="string"?M.body=m:M.body=new b.MarkdownString(m),M):w}return w}})}createCommentController(w,p,D){const m=t.handlePool++,S=new n(w,m,p,D);this._commentControllers.set(S.handle,S);const M=this._commentControllersByExtension.get(w.identifier)||[];return M.push(S),this._commentControllersByExtension.set(w.identifier,M),S.value}async $createCommentThreadTemplate(w,p,D,m){const S=this._commentControllers.get(w);S&&S.$createCommentThreadTemplate(p,D,m)}async $setActiveComment(w,p){const D=this._commentControllers.get(w);D&&D.$setActiveComment(p??void 0)}async $updateCommentThreadTemplate(w,p,D){const m=this._commentControllers.get(w);m&&m.$updateCommentThreadTemplate(p,D)}$deleteCommentThread(w,p){this._commentControllers.get(w)?.$deleteCommentThread(p)}async $provideCommentingRanges(w,p,D){const m=this._commentControllers.get(w);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const S=await a.ensureDocumentData(R.URI.revive(p));return(0,y.asPromise)(async()=>{const M=await m.commentingRangeProvider.provideCommentingRanges(S.document,D);let L;return Array.isArray(M)?L={ranges:M,fileComments:!1}:M?L={ranges:M.ranges||[],fileComments:M.fileComments||!1}:L=M??void 0,L}).then(M=>{let L;return M&&(L={ranges:M.ranges.map(H=>T.Range.from(H)),fileComments:M.fileComments}),L})}$toggleReaction(w,p,D,m,S){const M=this._commentControllers.get(w);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,y.asPromise)(()=>{const L=M.getCommentThread(p);if(L){const H=L.getCommentByUniqueId(m.uniqueIdInThread);if(M!==void 0&&H&&M.reactionHandler)return M.reactionHandler(H,f(S))}return Promise.resolve(void 0)})}}class s{static{this._handlePool=0}set threadId(w){this._id=w}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(w){(w===void 0!=(this._range===void 0)||!w||!this._range||!w.isEqual(this._range))&&(this._range=w,this.modifications.range=w,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(w){this._canReply!==w&&(this._canReply=w,this.modifications.canReply=w,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(w){this._label=w,this.modifications.label=w,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(w){this._contextValue=w,this.modifications.contextValue=w,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(w){this._comments=w,this.modifications.comments=w,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(w){this._collapseState=w,this.modifications.collapsibleState=w,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(w){this._state=w,typeof w=="object"?((0,C.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=w.resolved,this.modifications.applicability=w.applicability):this.modifications.state=w,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(w,p,D,m,S,M,L,H,V){this._commentControllerHandle=p,this._id=D,this._uri=m,this._range=S,this._comments=M,this.extensionDescription=L,this._isTemplate=H,this.handle=s._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new P.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputDisposables.value=new O.DisposableStore,this._id===void 0&&(this._id=`${w}.${this.handle}`),d.$createCommentThread(p,this.handle,this._id,this._uri,T.Range.from(this._range),L.identifier,this._isTemplate,V),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=M,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(p,this.handle)}});const $=this;this.value={get uri(){return $.uri},get range(){return $.range},set range(N){$.range=N},get comments(){return $.comments},set comments(N){$.comments=N},get collapsibleState(){return $.collapsibleState},set collapsibleState(N){$.collapsibleState=N},get canReply(){return $.canReply},set canReply(N){$.canReply=N},get contextValue(){return $.contextValue},set contextValue(N){$.contextValue=N},get label(){return $.label},set label(N){$.label=N},get state(){return $.state},set state(N){$.state=N},dispose:()=>{$.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new O.DisposableStore);const w=D=>Object.prototype.hasOwnProperty.call(this.modifications,D),p={};w("range")&&(p.range=T.Range.from(this._range)),w("label")&&(p.label=this.label),w("contextValue")&&(p.contextValue=this.contextValue??null),w("comments")&&(p.comments=this._comments.map(D=>i(this,D,this._commentsMap,this.extensionDescription))),w("collapsibleState")&&(p.collapseState=u(this._collapseState)),w("canReply")&&(p.canReply=this.canReply),w("state")&&(p.state=E(this._state)),w("applicability")&&(p.applicability=I(this._state)),w("isTemplate")&&(p.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,p)}getCommentByUniqueId(w){for(const p of this._commentsMap){const D=p[0],m=p[1];if(w===m)return D}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(w=>w.dispose())}}je([(0,k.debounce)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(w){this._commentingRangeProvider=w,w?.resourceHints&&(0,C.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),d.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(w){this._reactionHandler=w,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this._options}set options(w){this._options=w,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,C.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,C.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(w,p,D,m){this._extension=w,this._handle=p,this._id=D,this._label=m,this._threads=new Map,d.$registerCommentController(this.handle,D,m,this._extension.identifier.value);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(M){S.options=M},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(M){S.commentingRangeProvider=M},get reactionHandler(){return S.reactionHandler},set reactionHandler(M){S.reactionHandler=M},get activeCommentThread(){return S.activeCommentThread},createCommentThread(M,L,H){return S.createCommentThread(M,L,H).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(w,p,D){p===void 0&&(0,C.checkProposedApiEnabled)(this._extension,"fileComments");const m=new s(this.id,this.handle,void 0,w,p,D,this._extension,!1);return this._threads.set(m.handle,m),m}$setActiveComment(w){if(!w){this._activeComment=void 0,this._activeThread=void 0;return}const p=this._threads.get(w.commentThreadHandle);p&&(this._activeComment=w.uniqueIdInThread?p.getCommentByUniqueId(w.uniqueIdInThread):void 0,this._activeThread=p)}$createCommentThreadTemplate(w,p,D){const m=new s(this.id,this.handle,void 0,R.URI.revive(w),T.Range.to(p),[],this._extension,!0,D);return m.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(w,p){const D=this._threads.get(w);D&&(D.range=T.Range.to(p))}$deleteCommentThread(w){this._threads.get(w)?.dispose(),this._threads.delete(w)}getCommentThread(w){return this._threads.get(w)}dispose(){this._threads.forEach(w=>{w.dispose()}),this._localDisposables.forEach(w=>w.dispose())}}function i(_,w,p,D){let m=p.get(w);return m||(m=++_.commentHandle,p.set(w,m)),w.state!==void 0&&(0,C.checkProposedApiEnabled)(D,"commentsDraftState"),w.reactions?.some(S=>S.reactors!==void 0)&&(0,C.checkProposedApiEnabled)(D,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:m,body:typeof w.body=="string"?w.body:T.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(S=>g(S)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function g(_){return{label:_.label,iconPath:_.iconPath?T.pathOrURIToURI(_.iconPath):void 0,count:_.count,hasReacted:_.authorHasReacted,reactors:_.reactors&&_.reactors.length>0&&typeof _.reactors[0]!="string"?_.reactors.map(w=>w.name):_.reactors}}function f(_){return{label:_.label||"",count:_.count||0,iconPath:_.iconPath?R.URI.revive(_.iconPath):"",authorHasReacted:_.hasReacted||!1,reactors:_.reactors?.map(w=>({name:w}))}}function u(_){if(_!==void 0)switch(_){case b.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case b.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function E(_){let w;if(typeof _=="object"?w=_.resolved:w=_,w!==void 0)switch(w){case b.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case b.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}function I(_){let w;if(typeof _=="object"&&(w=_.applicability),w!==void 0)switch(w){case b.CommentThreadApplicability.Current:return v.CommentThreadApplicability.Current;case b.CommentThreadApplicability.Outdated:return v.CommentThreadApplicability.Outdated}return v.CommentThreadApplicability.Current}return new t}}),define(De[277],Ie([1,0,22,76,6,16,24,2,10,67,80,5,7]),function(he,e,y,k,P,O,A,R,v,l,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class C{constructor(g,f){this.document=g,this._storagePath=f,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(g){return this._edits.add([g])}async undo(g,f){await this.getEdit(g).undo(),f||this.disposeBackup()}async redo(g,f){await this.getEdit(g).redo(),f||this.disposeBackup()}disposeEdits(g){for(const f of g)this._edits.delete(f)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const g=n(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,g)}updateBackup(g){this._backup?.delete(),this._backup=g}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(g){const f=this._edits.get(g,0);if(!f)throw new Error("No edit found");return f}}class h{constructor(){this._documents=new Map}get(g,f){return this._documents.get(this.key(g,f))}add(g,f,u){const E=this.key(g,f.uri);if(this._documents.has(E))throw new Error(`Document already exists for viewType:${g} resource:${f.uri}`);const I=new C(f,u);return this._documents.set(E,I),I}delete(g,f){const u=this.key(g,f.uri);this._documents.delete(u)}key(g,f){return`${g}@@@${f}`}}var r;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this._providers=new Map}addTextProvider(g,f,u){return this.add(g,{type:r.Text,extension:f,provider:u})}addCustomProvider(g,f,u){return this.add(g,{type:r.Custom,extension:f,provider:u})}get(g){return this._providers.get(g)}add(g,f){if(this._providers.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this._providers.set(g,f),new c.Disposable(()=>this._providers.delete(g))}}class a{constructor(g,f,u,E,I){this._extHostDocuments=f,this._extensionStoragePaths=u,this._extHostWebview=E,this._extHostWebviewPanels=I,this._editorProviders=new o,this._documents=new h,this._proxy=g.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(g,f,u,E){const I=new P.DisposableStore;return t(u)?(I.add(this._editorProviders.addTextProvider(f,g,u)),this._proxy.$registerTextEditorProvider((0,l.toExtensionData)(g),f,E.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,l.shouldSerializeBuffersForPostMessage)(g))):(I.add(this._editorProviders.addCustomProvider(f,g,u)),d(u)&&I.add(u.onDidChangeCustomDocument(_=>{const w=this.getCustomDocumentEntry(f,_.document.uri);if(s(_)){const p=w.addEdit(_);this._proxy.$onDidEdit(_.document.uri,f,p,_.label)}else this._proxy.$onContentChange(_.document.uri,f)})),this._proxy.$registerCustomEditorProvider((0,l.toExtensionData)(g),f,E.webviewOptions||{},!!E.supportsMultipleEditorsPerDocument,(0,l.shouldSerializeBuffersForPostMessage)(g))),c.Disposable.from(I,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(f)}))}async $createCustomDocument(g,f,u,E,I){const _=this._editorProviders.get(f);if(!_)throw new Error(`No provider found for '${f}'`);if(_.type!==r.Custom)throw new Error(`Invalid provide type for '${f}'`);const w=R.URI.revive(g),p=await _.provider.openCustomDocument(w,{backupId:u,untitledDocumentData:E?.buffer},I);let D;return d(_.provider)&&this._extensionStoragePaths&&(D=this._extensionStoragePaths.workspaceValue(_.extension)??this._extensionStoragePaths.globalValue(_.extension)),this._documents.add(f,p,D),{editable:d(_.provider)}}async $disposeCustomDocument(g,f){const u=this._editorProviders.get(f);if(!u)throw new Error(`No provider found for '${f}'`);if(u.type!==r.Custom)throw new Error(`Invalid provider type for '${f}'`);const E=R.URI.revive(g),{document:I}=this.getCustomDocumentEntry(f,E);this._documents.delete(f,I),I.dispose()}async $resolveCustomEditor(g,f,u,E,I,_){const w=this._editorProviders.get(u);if(!w)throw new Error(`No provider found for '${u}'`);const p=v.ViewColumn.to(I),D=this._extHostWebview.createNewWebview(f,E.contentOptions,w.extension),m=this._extHostWebviewPanels.createNewWebviewPanel(f,u,E.title,p,E.options,D,E.active),S=R.URI.revive(g);switch(w.type){case r.Custom:{const{document:M}=this.getCustomDocumentEntry(u,S);return w.provider.resolveCustomEditor(M,m,_)}case r.Text:{const M=this._extHostDocuments.getDocument(S);return w.provider.resolveCustomTextEditor(M,m,_)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,f,u){this.getCustomDocumentEntry(f,g).disposeEdits(u)}async $onMoveCustomEditor(g,f,u){const E=this._editorProviders.get(u);if(!E)throw new Error(`No provider found for '${u}'`);if(!E.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const I=this._extHostWebviewPanels.getWebviewPanel(g);if(!I)throw new Error("No webview found");const _=R.URI.revive(f),w=this._extHostDocuments.getDocument(_);await E.provider.moveCustomTextEditor(w,I,y.CancellationToken.None)}async $undo(g,f,u,E){return this.getCustomDocumentEntry(f,g).undo(u,E)}async $redo(g,f,u,E){return this.getCustomDocumentEntry(f,g).redo(u,E)}async $revert(g,f,u){const E=this.getCustomDocumentEntry(f,g);await this.getCustomEditorProvider(f).revertCustomDocument(E.document,u),E.disposeBackup()}async $onSave(g,f,u){const E=this.getCustomDocumentEntry(f,g);await this.getCustomEditorProvider(f).saveCustomDocument(E.document,u),E.disposeBackup()}async $onSaveAs(g,f,u,E){const I=this.getCustomDocumentEntry(f,g);return this.getCustomEditorProvider(f).saveCustomDocumentAs(I.document,R.URI.revive(u),E)}async $backup(g,f,u){const E=this.getCustomDocumentEntry(f,g),_=await this.getCustomEditorProvider(f).backupCustomDocument(E.document,{destination:E.getNewBackupUri()},u);return E.updateBackup(_),_.id}getCustomDocumentEntry(g,f){const u=this._documents.get(g,R.URI.revive(f));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(g){const u=this._editorProviders.get(g)?.provider;if(!u||!d(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=a;function d(i){return!!i.onDidChangeCustomDocument}function t(i){return typeof i.resolveCustomTextEditor=="function"}function s(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function n(i){const g=i.scheme===O.Schemas.file||i.scheme===O.Schemas.untitled?i.fsPath:i.toString();return(0,k.hash)(g)+""}}),define(De[278],Ie([1,0,179,106,2,5,7,10,4,12,29,51]),function(he,e,y,k,P,O,A,R,v,l,T,b){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{#e;#t;#i;constructor(o,a,d,t,s,n,i,g){this._name=o,this._owner=a,this._maxDiagnosticsTotal=d,this._maxDiagnosticsPerFile=t,this._modelVersionIdProvider=s,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(t,d),this.#i=new T.ResourceMap(f=>n.getComparisonKey(f)),this.#e=i,this.#t=g}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,a){if(!o){this.clear();return}this._checkDisposed();let d=[];if(P.URI.isUri(o)){if(!a){this.delete(o);return}this.#i.set(o,a.slice()),d=[o]}else if(Array.isArray(o)){d=[];let n;o=[...o].sort(C._compareIndexedTuplesByUri);for(const i of o){const[g,f]=i;if((!n||g.toString()!==n.toString())&&(n&&this.#i.get(n).length===0&&this.#i.delete(n),n=g,d.push(g),this.#i.set(g,[])),f)this.#i.get(g)?.push(...f);else{const u=this.#i.get(g);u&&(u.length=0)}}}if(this.#t.fire(d),!this.#e)return;const t=[];let s=0;for(const n of d){let i=[];const g=this.#i.get(n);if(g)if(g.length>this._maxDiagnosticsPerFile){i=[];const f=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const E of g)if(E.severity===f[u]&&i.push({...R.Diagnostic.from(E),modelVersionId:this._modelVersionIdProvider(n)})===this._maxDiagnosticsPerFile)break e;i.push({severity:k.MarkerSeverity.Info,message:(0,y.localize)(0,null,g.length-this._maxDiagnosticsPerFile),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=g.map(f=>({...R.Diagnostic.from(f),modelVersionId:this._modelVersionIdProvider(n)}));if(t.push([n,i]),s+=i.length,s>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,t)}delete(o){this._checkDisposed(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(o,a){this._checkDisposed();for(const[d,t]of this)o.call(a,d,t,this)}*[Symbol.iterator](){this._checkDisposed();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this._checkDisposed();const a=this.#i.get(o);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this.#i.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,a){return o[0].toString()<a[0].toString()?-1:o[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=C;let h=class{static{c=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*c._maxDiagnosticsPerFile}static _mapper(o){const a=new T.ResourceMap;for(const d of o)a.set(d,d);return{uris:Object.freeze(Array.from(a.values()))}}constructor(o,a,d,t){this._logService=a,this._fileSystemInfoService=d,this._extHostDocumentsAndEditors=t,this._collections=new Map,this._onDidChangeDiagnostics=new v.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=v.Event.map(this._onDidChangeDiagnostics.event,c._mapper),this._proxy=o.getProxy(O.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(o,a){const{_collections:d,_proxy:t,_onDidChangeDiagnostics:s,_logService:n,_fileSystemInfoService:i,_extHostDocumentsAndEditors:g}=this,f=new class{$changeMany(I,_){t.$changeMany(I,_),n.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,I,_.length===0?"CLEARING":_)}$clear(I){t.$clear(I),n.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,I)}dispose(){t.dispose()}};let u;if(!a)a="_generated_diagnostic_collection_name_#"+c._idPool++,u=a;else if(!d.has(a))u=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do u=a+c._idPool++;while(d.has(u))}return new class extends C{constructor(){super(a,u,c._maxDiagnosticsTotal,c._maxDiagnosticsPerFile,I=>g.getDocument(I)?.version,i.extUri,f,s),d.set(u,this)}dispose(){super.dispose(),d.delete(u)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const a=new Map,d=[];for(const t of this._collections.values())t.forEach((s,n)=>{let i=a.get(s.toString());typeof i>"u"&&(i=d.length,a.set(s.toString(),i),d.push([s,[]])),d[i][1]=d[i][1].concat(...n)});return d}}_getDiagnostics(o){let a=[];for(const d of this._collections.values())d.has(o)&&(a=a.concat(d.get(o)));return a}$acceptMarkersChange(o){if(!this._mirrorCollection){const a="_generated_mirror",d=new C(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,d),this._mirrorCollection=d}for(const[a,d]of o)this._mirrorCollection.set(P.URI.revive(a),d.map(R.Diagnostic.to))}};e.ExtHostDiagnostics=h,e.ExtHostDiagnostics=h=c=je([$e(1,l.ILogService),$e(2,b.IExtHostFileSystemInfo)],h)}),define(De[279],Ie([1,0,2,14,7,10,211,38]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class v{constructor(T,b,c,C={timeout:1500,errors:3}){this._logService=T,this._documents=b,this._mainThreadBulkEdits=c,this._thresholds=C,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(b,c,C)=>{const r={dispose:this._callbacks.push([b,c,T])};return Array.isArray(C)&&C.push(r),r}}async $participateInSave(T,b){const c=y.URI.revive(T);let C=!1;const h=setTimeout(()=>C=!0,this._thresholds.timeout),r=[];try{for(const o of[...this._callbacks]){if(C)break;const a=this._documents.getDocument(c),d=await this._deliverEventAsyncAndBlameBadListeners(o,{document:a,reason:O.TextDocumentSaveReason.to(b)});r.push(d)}}finally{clearTimeout(h)}return r}_deliverEventAsyncAndBlameBadListeners([T,b,c],C){const h=this._badListeners.get(T);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(c,T,b,C).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${c.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this._badListeners.get(T);this._badListeners.set(T,o?o+1:1),typeof o=="number"&&o>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${c.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,b,c,C){const h=[],r=Date.now(),{document:o,reason:a}=C,{version:d}=o,t=Object.freeze({document:o,reason:a,waitUntil(s){if(Object.isFrozen(h))throw(0,k.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(s))}});try{b.apply(c,[t])}catch(s){return Promise.reject(s)}return Object.freeze(h),new Promise((s,n)=>{const i=setTimeout(()=>n(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(g=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(i),s(g)}).catch(g=>{clearTimeout(i),n(g)})}).then(s=>{const n={edits:[]};for(const i of s)if(Array.isArray(i)&&i.every(g=>g instanceof P.TextEdit))for(const{newText:g,newEol:f,range:u}of i)n.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:u&&O.Range.from(u),text:g,eol:f&&O.EndOfLine.from(f)}});if(n.edits.length!==0)return d===o.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new R.SerializableObjectWithBuffers(n)):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=v}),define(De[280],Ie([1,0,4,6,2,5,121,10,15,26,7]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(C,h){this._onDidAddDocument=new y.Emitter,this._onDidRemoveDocument=new y.Emitter,this._onDidChangeDocument=new y.Emitter,this._onDidSaveDocument=new y.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=C.getProxy(O.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const o of r)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const o of r)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(C){if(!C)return;const h=this._documentsAndEditors.getDocument(C);if(h)return h}getDocument(C){const h=this.getDocumentData(C);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return h.document}ensureDocumentData(C){const h=this._documentsAndEditors.getDocument(C);if(h)return Promise.resolve(h);let r=this._documentLoader.get(C.toString());return r||(r=this._proxy.$tryOpenDocument(C).then(o=>{this._documentLoader.delete(C.toString());const a=P.URI.revive(o);return(0,v.assertIsDefined)(this._documentsAndEditors.getDocument(a))},o=>(this._documentLoader.delete(C.toString()),Promise.reject(o))),this._documentLoader.set(C.toString(),r)),r}createDocumentData(C){return this._proxy.$tryCreateDocument(C).then(h=>P.URI.revive(h))}$acceptModelLanguageChanged(C,h){const r=P.URI.revive(C),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(h),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(C){const h=P.URI.revive(C),r=this._documentsAndEditors.getDocument(h);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(C,h){const r=P.URI.revive(C),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),this._onDidChangeDocument.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,h,r){const o=P.URI.revive(C),a=this._documentsAndEditors.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(r),a.onEvents(h);let d;h.isUndoing?d=T.TextDocumentChangeReason.Undo:h.isRedoing&&(d=T.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,l.deepFreeze)({document:a.document,contentChanges:h.changes.map(t=>({range:R.Range.to(t.range),rangeOffset:t.rangeOffset,rangeLength:t.rangeLength,text:t.text})),reason:d}))}setWordDefinitionFor(C,h){(0,A.setWordDefinitionFor)(C,h)}}e.ExtHostDocuments=b}),define(De[70],Ie([1,0,281,4,15,2,3,5,17,10,7]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class b{constructor(o,a,d){this._activeTabIdGetter=d,this._parentGroup=a,this.acceptDtoUpdate(o)}get apiObject(){if(!this._apiObject){const o=this,a={get isActive(){return o._dto.id===o._activeTabIdGetter()},get label(){return o._dto.label},get input(){return o._input},get isDirty(){return o._dto.isDirty},get isPinned(){return o._dto.isPinned},get isPreview(){return o._dto.isPreview},get group(){return o._parentGroup.apiObject}};this._apiObject=Object.freeze(a)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(o){this._dto=o,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case R.TabInputKind.TextInput:return new T.TextTabInput(O.URI.revive(this._dto.input.uri));case R.TabInputKind.TextDiffInput:return new T.TextDiffTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified));case R.TabInputKind.TextMergeInput:return new T.TextMergeTabInput(O.URI.revive(this._dto.input.base),O.URI.revive(this._dto.input.input1),O.URI.revive(this._dto.input.input2),O.URI.revive(this._dto.input.result));case R.TabInputKind.CustomEditorInput:return new T.CustomEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.viewType);case R.TabInputKind.WebviewEditorInput:return new T.WebviewEditorTabInput(this._dto.input.viewType);case R.TabInputKind.NotebookInput:return new T.NotebookEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case R.TabInputKind.NotebookDiffInput:return new T.NotebookDiffEditorTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case R.TabInputKind.TerminalEditorInput:return new T.TerminalEditorTabInput;case R.TabInputKind.InteractiveEditorInput:return new T.InteractiveWindowInput(O.URI.revive(this._dto.input.uri),O.URI.revive(this._dto.input.inputBoxUri));case R.TabInputKind.ChatEditorInput:return new T.ChatEditorTabInput;case R.TabInputKind.MultiDiffEditorInput:return new T.TextMultiDiffTabInput(this._dto.input.diffEditors.map(o=>new T.TextDiffTabInput(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class c{constructor(o,a){this._tabs=[],this._activeTabId="",this._dto=o,this._activeGroupIdGetter=a;for(const d of o.tabs)d.isActive&&(this._activeTabId=d.id),this._tabs.push(new b(d,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const o=this,a={get isActive(){return o._dto.groupId===o._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(o._dto.viewColumn)},get activeTab(){return o._tabs.find(d=>d.tabId===o._activeTabId)?.apiObject},get tabs(){return Object.freeze(o._tabs.map(d=>d.apiObject))}};this._apiObject=Object.freeze(a)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(o){this._dto=o}acceptTabOperation(o){if(o.kind===R.TabModelOperationKind.TAB_OPEN){const d=new b(o.tabDto,this,()=>this.activeTabId());return this._tabs.splice(o.index,0,d),o.tabDto.isActive&&(this._activeTabId=d.tabId),d}else if(o.kind===R.TabModelOperationKind.TAB_CLOSE){const d=this._tabs.splice(o.index,1)[0];if(!d)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return d.tabId===this._activeTabId&&(this._activeTabId=""),d}else if(o.kind===R.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const d=this._tabs.splice(o.oldIndex,1)[0];if(!d)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this._tabs.splice(o.index,0,d),d}const a=this._tabs.find(d=>d.tabId===o.tabDto.id);if(!a)throw new Error("INVALID tab");return o.tabDto.isActive?this._activeTabId=o.tabDto.id:this._activeTabId===o.tabDto.id&&!o.tabDto.isActive&&(this._activeTabId=""),a.acceptDtoUpdate(o.tabDto),a}activeTabId(){return this._activeTabId}}let C=class{constructor(o){this._onDidChangeTabs=new k.Emitter,this._onDidChangeTabGroups=new k.Emitter,this._extHostTabGroups=[],this._proxy=o.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const o=this,a={onDidChangeTabGroups:o._onDidChangeTabGroups.event,onDidChangeTabs:o._onDidChangeTabs.event,get all(){return Object.freeze(o._extHostTabGroups.map(d=>d.apiObject))},get activeTabGroup(){const d=o._activeGroupId;return(0,P.assertIsDefined)(o._extHostTabGroups.find(s=>s.groupId===d)?.apiObject)},close:async(d,t)=>{const s=Array.isArray(d)?d:[d];return s.length?h(s[0])?this._closeGroups(s,t):this._closeTabs(s,t):!0}};this._apiObject=Object.freeze(a)}return this._apiObject}$acceptEditorTabModel(o){const a=new Set(this._extHostTabGroups.map(f=>f.groupId)),d=new Set(o.map(f=>f.groupId)),t=(0,y.diffSets)(a,d),s=this._extHostTabGroups.filter(f=>t.removed.includes(f.groupId)).map(f=>f.apiObject),n=[],i=[];this._extHostTabGroups=o.map(f=>{const u=new c(f,()=>this._activeGroupId);return t.added.includes(u.groupId)?n.push(u.apiObject):i.push(u.apiObject),u});const g=(0,P.assertIsDefined)(o.find(f=>f.isActive===!0)?.groupId);g!==void 0&&this._activeGroupId!==g&&(this._activeGroupId=g),this._onDidChangeTabGroups.fire(Object.freeze({opened:n,closed:s,changed:i}))}$acceptTabGroupUpdate(o){const a=this._extHostTabGroups.find(d=>d.groupId===o.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(o),o.isActive&&(this._activeGroupId=o.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const a=this._extHostTabGroups.find(t=>t.groupId===o.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const d=a.acceptTabOperation(o);switch(o.kind){case R.TabModelOperationKind.TAB_OPEN:this._onDidChangeTabs.fire(Object.freeze({opened:[d.apiObject],closed:[],changed:[]}));return;case R.TabModelOperationKind.TAB_CLOSE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[d.apiObject],changed:[]}));return;case R.TabModelOperationKind.TAB_MOVE:case R.TabModelOperationKind.TAB_UPDATE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[d.apiObject]}));return}}_findExtHostTabFromApi(o){for(const a of this._extHostTabGroups)for(const d of a.tabs)if(d.apiObject===o)return d}_findExtHostTabGroupFromApi(o){return this._extHostTabGroups.find(a=>a.apiObject===o)}async _closeTabs(o,a){const d=[];for(const t of o){const s=this._findExtHostTabFromApi(t);if(!s)throw new Error("Tab close: Invalid tab not found!");d.push(s.tabId)}return this._proxy.$closeTab(d,a)}async _closeGroups(o,a){const d=[];for(const t of o){const s=this._findExtHostTabGroupFromApi(t);if(!s)throw new Error("Group close: Invalid group not found!");d.push(s.groupId)}return this._proxy.$closeGroup(d,a)}};e.ExtHostEditorTabs=C,e.ExtHostEditorTabs=C=je([$e(0,v.IExtHostRpcService)],C);function h(r){return r.tabs!==void 0}}),define(De[282],Ie([1,0,2,5,30,6,7,10,326,13,28,23,25,59]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class h{constructor(){this._schemes=[]}add(a){this._stateMachine=void 0,this._schemes.push(a)}delete(a){const d=this._schemes.indexOf(a);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const a=this._schemes.sort(),d=[];let t,s,n=v.State.LastKnownState,i=v.State.LastKnownState;for(const g of a){let f=t?(0,l.commonPrefixLength)(t,g):0;for(f===0?s=v.State.Start:s=i;f<g.length;f++)f+1===g.length?(n=i,i=v.State.BeforeColon):i+=1,d.push([s,g.toUpperCase().charCodeAt(f),i]),d.push([s,g.toLowerCase().charCodeAt(f),i]),s=i;t=g,i=n}d.push([v.State.BeforeColon,T.CharCode.Colon,v.State.AfterColon]),d.push([v.State.AfterColon,T.CharCode.Slash,v.State.End]),this._stateMachine=new v.StateMachine(d)}}provideDocumentLinks(a){this._initStateMachine();const d=[],t=v.LinkComputer.computeLinks({getLineContent(s){return a.lineAt(s-1).text},getLineCount(){return a.lineCount}},this._stateMachine);for(const s of t){const n=R.DocumentLink.to(s);n.target&&d.push(n)}return d}}class r{constructor(a,d){this._extHostLanguageFeatures=d,this._linkProvider=new h,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=a.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(a,d,t,s={}){if(r._validateFileSystemProvider(t),this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(a,"*",this._linkProvider));const n=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(n,t);let i=P.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(i+=P.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(i+=P.FileSystemProviderCapabilities.Readonly),typeof t.copy=="function"&&(i+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,c.checkProposedApiEnabled)(a,"fsChunks"),i+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let g;s.isReadonly&&(0,C.isMarkdownString)(s.isReadonly)&&s.isReadonly.value!==""&&(g={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this._proxy.$registerFileSystemProvider(n,d,i,g).catch(u=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${d}`),console.error(u)});const f=t.onDidChangeFile(u=>{const E=[];for(const I of u){const{uri:_,type:w}=I;if(_.scheme!==d)continue;let p;switch(w){case A.FileChangeType.Changed:p=P.FileChangeType.UPDATED;break;case A.FileChangeType.Created:p=P.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:p=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}E.push({resource:_,type:p})}this._proxy.$onFileSystemChange(n,E)});return(0,O.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(n),this._proxy.$unregisterProvider(n)})}static _validateFileSystemProvider(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(a){const{type:d,ctime:t,mtime:s,size:n,permissions:i}=a;return{type:d,ctime:t,mtime:s,size:n,permissions:i}}$stat(a,d){return Promise.resolve(this._getFsProvider(a).stat(y.URI.revive(d))).then(t=>r._asIStat(t))}$readdir(a,d){return Promise.resolve(this._getFsProvider(a).readDirectory(y.URI.revive(d)))}$readFile(a,d){return Promise.resolve(this._getFsProvider(a).readFile(y.URI.revive(d))).then(t=>b.VSBuffer.wrap(t))}$writeFile(a,d,t,s){return Promise.resolve(this._getFsProvider(a).writeFile(y.URI.revive(d),t.buffer,s))}$delete(a,d,t){return Promise.resolve(this._getFsProvider(a).delete(y.URI.revive(d),t))}$rename(a,d,t,s){return Promise.resolve(this._getFsProvider(a).rename(y.URI.revive(d),y.URI.revive(t),s))}$copy(a,d,t,s){const n=this._getFsProvider(a);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(y.URI.revive(d),y.URI.revive(t),s))}$mkdir(a,d){return Promise.resolve(this._getFsProvider(a).createDirectory(y.URI.revive(d)))}$watch(a,d,t,s){const n=this._getFsProvider(a).watch(y.URI.revive(t),s);this._watches.set(d,n)}$unwatch(a,d){const t=this._watches.get(d);t&&(t.dispose(),this._watches.delete(d))}$open(a,d,t){const s=this._getFsProvider(a);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(y.URI.revive(d),t))}$close(a,d){const t=this._getFsProvider(a);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(d))}$read(a,d,t,s){const n=this._getFsProvider(a);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const i=b.VSBuffer.alloc(s);return Promise.resolve(n.read(d,t,i.buffer,0,s)).then(g=>i.slice(0,g))}$write(a,d,t,s){const n=this._getFsProvider(a);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(d,t,s.buffer,0,s.byteLength))}_getFsProvider(a){const d=this._fsProvider.get(a);if(!d){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return d}}e.ExtHostFileSystem=r}),define(De[283],Ie([1,0,4,41,2,5,10,7,30,47]),function(he,e,y,k,P,O,A,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class T{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(h,r,o,a,d,t){this.session=Math.random(),this._onDidCreate=new y.Emitter,this._onDidChange=new y.Emitter,this._onDidDelete=new y.Emitter,this._config=0,t?.ignoreCreateEvents&&(this._config+=1),t?.ignoreChangeEvents&&(this._config+=2),t?.ignoreDeleteEvents&&(this._config+=4);const s=(0,k.parse)(d),n=typeof d=="string",i=t?.correlate,g=a(f=>{if(!(typeof f.session=="number"&&f.session!==this.session)&&!(i&&typeof f.session>"u")){if(!t?.ignoreCreateEvents)for(const u of f.created){const E=P.URI.revive(u);s(E.fsPath)&&(!n||r.getWorkspaceFolder(E))&&this._onDidCreate.fire(E)}if(!t?.ignoreChangeEvents)for(const u of f.changed){const E=P.URI.revive(u);s(E.fsPath)&&(!n||r.getWorkspaceFolder(E))&&this._onDidChange.fire(E)}if(!t?.ignoreDeleteEvents)for(const u of f.deleted){const E=P.URI.revive(u);s(E.fsPath)&&(!n||r.getWorkspaceFolder(E))&&this._onDidDelete.fire(E)}}});this._disposable=R.Disposable.from(this.ensureWatching(h,o,d,t,t?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,g)}ensureWatching(h,r,o,a,d){const t=R.Disposable.from();if(typeof o=="string"||a?.ignoreChangeEvents&&a?.ignoreCreateEvents&&a?.ignoreDeleteEvents)return t;const s=h.getProxy(O.MainContext.MainThreadFileSystemEventService);let n=!1;(o.pattern.includes(k.GLOBSTAR)||o.pattern.includes(k.GLOB_SPLIT))&&(n=!0);let i;return d&&(a?.ignoreChangeEvents||a?.ignoreCreateEvents||a?.ignoreDeleteEvents)&&(i=v.FileChangeFilter.UPDATED|v.FileChangeFilter.ADDED|v.FileChangeFilter.DELETED,a?.ignoreChangeEvents&&(i&=~v.FileChangeFilter.UPDATED),a?.ignoreCreateEvents&&(i&=~v.FileChangeFilter.ADDED),a?.ignoreDeleteEvents&&(i&=~v.FileChangeFilter.DELETED)),s.$watch(r.identifier.value,this.session,o.baseUri,{recursive:n,excludes:a?.excludes??[],filter:i},!!d),R.Disposable.from({dispose:()=>s.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class b{constructor(h){this._events=h,this.session=this._events.session,this._created=new l.Lazy(()=>this._events.created.map(P.URI.revive)),this._changed=new l.Lazy(()=>this._events.changed.map(P.URI.revive)),this._deleted=new l.Lazy(()=>this._events.deleted.map(P.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class c{constructor(h,r,o){this._mainContext=h,this._logService=r,this._extHostDocumentsAndEditors=o,this._onFileSystemEvent=new y.Emitter,this._onDidRenameFile=new y.Emitter,this._onDidCreateFile=new y.Emitter,this._onDidDeleteFile=new y.Emitter,this._onWillRenameFile=new y.AsyncEmitter,this._onWillCreateFile=new y.AsyncEmitter,this._onWillDeleteFile=new y.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(h,r,o,a){return new T(this._mainContext,h,r,this._onFileSystemEvent.event,A.GlobPattern.from(o),a)}$onFileEvent(h){this._onFileSystemEvent.fire(new b(h))}$onDidRunFileOperation(h,r){switch(h){case v.FileOperation.MOVE:this._onDidRenameFile.fire(Object.freeze({files:r.map(o=>({oldUri:P.URI.revive(o.source),newUri:P.URI.revive(o.target)}))}));break;case v.FileOperation.DELETE:this._onDidDeleteFile.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;case v.FileOperation.CREATE:case v.FileOperation.COPY:this._onDidCreateFile.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(h){return this._createWillExecuteEvent(h,this._onWillRenameFile)}getOnWillCreateFileEvent(h){return this._createWillExecuteEvent(h,this._onWillCreateFile)}getOnWillDeleteFileEvent(h){return this._createWillExecuteEvent(h,this._onWillDeleteFile)}_createWillExecuteEvent(h,r){return(o,a,d)=>{const t=function(n){o.call(a,n)};return t.extension=h,r.event(t,void 0,d)}}async $onWillRunFileOperation(h,r,o,a){switch(h){case v.FileOperation.MOVE:return await this._fireWillEvent(this._onWillRenameFile,{files:r.map(d=>({oldUri:P.URI.revive(d.source),newUri:P.URI.revive(d.target)}))},o,a);case v.FileOperation.DELETE:return await this._fireWillEvent(this._onWillDeleteFile,{files:r.map(d=>P.URI.revive(d.target))},o,a);case v.FileOperation.CREATE:case v.FileOperation.COPY:return await this._fireWillEvent(this._onWillCreateFile,{files:r.map(d=>P.URI.revive(d.target))},o,a)}}async _fireWillEvent(h,r,o,a){const d=new Set,t=[];if(await h.fireAsync(r,a,async(n,i)=>{const g=Date.now(),f=await Promise.resolve(n);f instanceof R.WorkspaceEdit&&(t.push([i.extension,f]),d.add(i.extension.displayName??i.extension.identifier.value)),Date.now()-g>o&&this._logService.warn("SLOW file-participant",i.extension.identifier)}),a.isCancellationRequested||t.length===0)return;const s={edits:[]};for(const[,n]of t){const{edits:i}=A.WorkspaceEdit.from(n,{getTextDocumentVersion:g=>this._extHostDocumentsAndEditors.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(i)}return{edit:s,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=c}),define(De[284],Ie([1,0,18,11,22,14,96,6,26,69,13,15,2,33,327,94,103,181,19,10,7,25,80,5]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s,n,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class f{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentSymbols(B,x){const q=this._documents.getDocument(B),K=await this._provider.provideDocumentSymbols(q,x);if(!(0,y.isFalsyOrEmpty)(K))return K[0]instanceof s.DocumentSymbol?K.map(t.DocumentSymbol.from):f._asDocumentSymbolTree(K)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((K,te)=>{let ue=K.location.range.start.compareTo(te.location.range.start);return ue===0&&(ue=te.location.range.end.compareTo(K.location.range.end)),ue});const x=[],q=[];for(const K of B){const te={name:K.name||"!!MISSING: name!!",kind:t.SymbolKind.from(K.kind),tags:K.tags?.map(t.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:t.Range.from(K.location.range),selectionRange:t.Range.from(K.location.range),children:[]};for(;;){if(q.length===0){q.push(te),x.push(te);break}const ue=q[q.length-1];if(C.Range.containsRange(ue.range,te.range)&&!C.Range.equalsRange(ue.range,te.range)){ue.children?.push(te),q.push(te);break}q.pop()}}return x}}class u{constructor(B,x,q,K,te,ue){this._documents=B,this._commands=x,this._provider=q,this._extension=K,this._extTelemetry=te,this._logService=ue,this._cache=new i.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,x){const q=this._documents.getDocument(B),K=await this._provider.provideCodeLenses(q,x);if(!K||x.isCancellationRequested)return;const te=this._cache.add(K),ue=new R.DisposableStore;this._disposables.set(te,ue);const Ae={cacheId:te,lenses:[]};for(let Be=0;Be<K.length;Be++)Ae.lenses.push({cacheId:[te,Be],range:t.Range.from(K[Be].range),command:this._commands.toInternal(K[Be].command,ue)});return Ae}async resolveCodeLens(B,x){const q=B.cacheId&&this._cache.get(...B.cacheId);if(!q)return;let K;if(typeof this._provider.resolveCodeLens!="function"||q.isResolved?K=q:K=await this._provider.resolveCodeLens(q,x),K||(K=q),x.isCancellationRequested)return;const te=B.cacheId&&this._disposables.get(B.cacheId[0]);if(te){if(!K.command){const ue=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,ue),this._logService.error(ue);return}return B.command=this._commands.toInternal(K.command,te),B}}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}function E(Oe){return Array.isArray(Oe)?Oe.map(t.DefinitionLink.from):Oe?[t.DefinitionLink.from(Oe)]:[]}class I{constructor(B,x){this._documents=B,this._provider=x}async provideDefinition(B,x,q){const K=this._documents.getDocument(B),te=t.Position.to(x),ue=await this._provider.provideDefinition(K,te,q);return E(ue)}}class _{constructor(B,x){this._documents=B,this._provider=x}async provideDeclaration(B,x,q){const K=this._documents.getDocument(B),te=t.Position.to(x),ue=await this._provider.provideDeclaration(K,te,q);return E(ue)}}class w{constructor(B,x){this._documents=B,this._provider=x}async provideImplementation(B,x,q){const K=this._documents.getDocument(B),te=t.Position.to(x),ue=await this._provider.provideImplementation(K,te,q);return E(ue)}}class p{constructor(B,x){this._documents=B,this._provider=x}async provideTypeDefinition(B,x,q){const K=this._documents.getDocument(B),te=t.Position.to(x),ue=await this._provider.provideTypeDefinition(K,te,q);return E(ue)}}class D{static{this.HOVER_MAP_MAX_SIZE=10}constructor(B,x){this._documents=B,this._provider=x,this._hoverCounter=0,this._hoverMap=new Map}async provideHover(B,x,q,K){const te=this._documents.getDocument(B),ue=t.Position.to(x);let Ae;if(q&&q.verbosityRequest){const tt=q.verbosityRequest.previousHover.id,Ze=this._hoverMap.get(tt);if(!Ze)throw new Error(`Hover with id ${tt} not found`);const it={verbosityDelta:q.verbosityRequest.verbosityDelta,previousHover:Ze};Ae=await this._provider.provideHover(te,ue,K,it)}else Ae=await this._provider.provideHover(te,ue,K);if(!Ae||(0,y.isFalsyOrEmpty)(Ae.contents))return;Ae.range||(Ae.range=te.getWordRangeAtPosition(ue)),Ae.range||(Ae.range=new s.Range(ue,ue));const Be=t.Hover.from(Ae),He=this._hoverCounter;if(this._hoverMap.size===D.HOVER_MAP_MAX_SIZE){const tt=Math.min(...this._hoverMap.keys());this._hoverMap.delete(tt)}return this._hoverMap.set(He,Ae),this._hoverCounter+=1,{...Be,id:He}}releaseHover(B){this._hoverMap.delete(B)}}class m{constructor(B,x){this._documents=B,this._provider=x}async provideEvaluatableExpression(B,x,q){const K=this._documents.getDocument(B),te=t.Position.to(x),ue=await this._provider.provideEvaluatableExpression(K,te,q);if(ue)return t.EvaluatableExpression.from(ue)}}class S{constructor(B,x){this._documents=B,this._provider=x}async provideInlineValues(B,x,q,K){const te=this._documents.getDocument(B),ue=await this._provider.provideInlineValues(te,t.Range.to(x),t.InlineValueContext.to(q),K);if(Array.isArray(ue))return ue.map(Ae=>t.InlineValue.from(Ae))}}class M{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentHighlights(B,x,q){const K=this._documents.getDocument(B),te=t.Position.to(x),ue=await this._provider.provideDocumentHighlights(K,te,q);if(Array.isArray(ue))return ue.map(t.DocumentHighlight.from)}}class L{constructor(B,x){this._documents=B,this._provider=x}async provideMultiDocumentHighlights(B,x,q,K){const te=this._documents.getDocument(B),ue=q.map(He=>this._documents.getDocument(He)),Ae=t.Position.to(x),Be=await this._provider.provideMultiDocumentHighlights(te,Ae,ue,K);if(Array.isArray(Be))return Be.map(t.MultiDocumentHighlight.from)}}class H{constructor(B,x){this._documents=B,this._provider=x}async provideLinkedEditingRanges(B,x,q){const K=this._documents.getDocument(B),te=t.Position.to(x),ue=await this._provider.provideLinkedEditingRanges(K,te,q);if(ue&&Array.isArray(ue.ranges))return{ranges:(0,y.coalesce)(ue.ranges.map(t.Range.from)),wordPattern:ue.wordPattern}}}class V{constructor(B,x){this._documents=B,this._provider=x}async provideReferences(B,x,q,K){const te=this._documents.getDocument(B),ue=t.Position.to(x),Ae=await this._provider.provideReferences(te,ue,q,K);if(Array.isArray(Ae))return Ae.map(t.location.from)}}class ${static{this._maxCodeActionsPerFile=1e3}constructor(B,x,q,K,te,ue,Ae){this._documents=B,this._commands=x,this._diagnostics=q,this._provider=K,this._logService=te,this._extension=ue,this._apiDeprecation=Ae,this._cache=new i.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(B,x,q,K){const te=this._documents.getDocument(B),ue=h.Selection.isISelection(x)?t.Selection.to(x):t.Range.to(x),Ae=[];for(const it of this._diagnostics.getDiagnostics(B))if(ue.intersection(it.range)&&Ae.push(it)>$._maxCodeActionsPerFile)break;const Be={diagnostics:Ae,only:q.only?new s.CodeActionKind(q.only):void 0,triggerKind:t.CodeActionTriggerKind.to(q.trigger)},He=await this._provider.provideCodeActions(te,ue,Be,K);if(!(0,y.isNonEmptyArray)(He)||K.isCancellationRequested)return;const Ye=this._cache.add(He),tt=new R.DisposableStore;this._disposables.set(Ye,tt);const Ze=[];for(let it=0;it<He.length;it++){const nt=He[it];if(nt)if($._isCommand(nt))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:nt.title,command:this._commands.toInternal(nt,tt)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=nt.ranges??[];Ze.push({cacheId:[Ye,it],title:nt.title,command:nt.command&&this._commands.toInternal(nt.command,tt),diagnostics:nt.diagnostics&&nt.diagnostics.map(t.Diagnostic.from),edit:nt.edit&&t.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,n.isProposedApiEnabled)(this._extension,"codeActionAI")?nt.isAI:!1,ranges:(0,n.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,y.coalesce)(mt.map(t.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:Ye,actions:Ze}}async resolveCodeAction(B,x){const[q,K]=B,te=this._cache.get(q,K);if(!te||$._isCommand(te))return{};if(!this._provider.resolveCodeAction)return{};const ue=await this._provider.resolveCodeAction(te,x)??te;let Ae;ue.edit&&(Ae=t.WorkspaceEdit.from(ue.edit,void 0));let Be;if(ue.command){const He=this._disposables.get(q);He&&(Be=this._commands.toInternal(ue.command,He))}return{edit:Ae,command:Be}}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}class N{constructor(B,x,q,K,te){this._proxy=B,this._documents=x,this._provider=q,this._handle=K,this._extension=te,this._cache=new i.Cache("DocumentPasteEdit")}async prepareDocumentPaste(B,x,q,K){if(!this._provider.prepareDocumentPaste)return;const te=this._documents.getDocument(B),ue=x.map(He=>t.Range.to(He)),Ae=t.DataTransfer.toDataTransfer(q,()=>{throw new O.NotImplementedError});if(await this._provider.prepareDocumentPaste(te,ue,Ae,K),K.isCancellationRequested)return;const Be=Array.from(Ae).filter(([,He])=>!(He instanceof s.InternalDataTransferItem));return t.DataTransfer.from(Be)}async providePasteEdits(B,x,q,K,te,ue){if(!this._provider.provideDocumentPasteEdits)return[];const Ae=this._documents.getDocument(x),Be=q.map(Ze=>t.Range.to(Ze)),He=t.DataTransfer.toDataTransfer(K,async Ze=>(await this._proxy.$resolvePasteFileData(this._handle,B,Ze)).buffer),Ye=await this._provider.provideDocumentPasteEdits(Ae,Be,He,{only:te.only?new s.DocumentDropOrPasteEditKind(te.only):void 0,triggerKind:te.triggerKind},ue);if(!Ye||ue.isCancellationRequested)return[];const tt=this._cache.add(Ye);return Ye.map((Ze,it)=>({_cacheId:[tt,it],title:Ze.title??(0,a.localize)(0,null,this._extension.displayName||this._extension.name),kind:Ze.kind,yieldTo:Ze.yieldTo?.map(nt=>nt.value),insertText:typeof Ze.insertText=="string"?Ze.insertText:{snippet:Ze.insertText.value},additionalEdit:Ze.additionalEdit?t.WorkspaceEdit.from(Ze.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,x){const[q,K]=B,te=this._cache.get(q,K);if(!te||!this._provider.resolveDocumentPasteEdit)return{};const ue=await this._provider.resolveDocumentPasteEdit(te,x)??te;return{additionalEdit:ue.additionalEdit?t.WorkspaceEdit.from(ue.additionalEdit,void 0):void 0}}releasePasteEdits(B){this._cache.delete(B)}}class F{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentFormattingEdits(B,x,q){const K=this._documents.getDocument(B),te=await this._provider.provideDocumentFormattingEdits(K,x,q);if(Array.isArray(te))return te.map(t.TextEdit.from)}}class Y{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentRangeFormattingEdits(B,x,q,K){const te=this._documents.getDocument(B),ue=t.Range.to(x),Ae=await this._provider.provideDocumentRangeFormattingEdits(te,ue,q,K);if(Array.isArray(Ae))return Ae.map(t.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,x,q,K){(0,b.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const te=this._documents.getDocument(B),ue=x.map(t.Range.to),Ae=await this._provider.provideDocumentRangesFormattingEdits(te,ue,q,K);if(Array.isArray(Ae))return Ae.map(t.TextEdit.from)}}class re{constructor(B,x){this._documents=B,this._provider=x,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,x,q,K,te){const ue=this._documents.getDocument(B),Ae=t.Position.to(x),Be=await this._provider.provideOnTypeFormattingEdits(ue,Ae,q,K,te);if(Array.isArray(Be))return Be.map(t.TextEdit.from)}}class fe{constructor(B,x){this._provider=B,this._logService=x,this._cache=new i.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(B,x){const q=await this._provider.provideWorkspaceSymbols(B,x);if(!(0,y.isNonEmptyArray)(q))return{symbols:[]};const K=this._cache.add(q),te={cacheId:K,symbols:[]};for(let ue=0;ue<q.length;ue++){const Ae=q[ue];if(!Ae||!Ae.name){this._logService.warn("INVALID SymbolInformation",Ae);continue}te.symbols.push({...t.WorkspaceSymbol.from(Ae),cacheId:[K,ue]})}return te}async resolveWorkspaceSymbol(B,x){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const q=this._cache.get(...B.cacheId);if(q){const K=await this._provider.resolveWorkspaceSymbol(q,x);return K&&(0,v.mixin)(B,t.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(B){this._cache.delete(B)}}class Ee{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,x,q){this._documents=B,this._provider=x,this._logService=q}async provideRenameEdits(B,x,q,K){const te=this._documents.getDocument(B),ue=t.Position.to(x);try{const Ae=await this._provider.provideRenameEdits(te,ue,q,K);return Ae?t.WorkspaceEdit.from(Ae):void 0}catch(Ae){const Be=Ee._asMessage(Ae);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(B,x,q){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const K=this._documents.getDocument(B),te=t.Position.to(x);try{const ue=await this._provider.prepareRename(K,te,q);let Ae,Be;if(s.Range.isRange(ue)?(Ae=ue,Be=K.getText(ue)):(0,b.isObject)(ue)&&(Ae=ue.range,Be=ue.placeholder),!Ae||!Be)return;if(Ae.start.line>te.line||Ae.end.line<te.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:t.Range.from(Ae),text:Be}}catch(ue){const Ae=Ee._asMessage(ue);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(ue)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class oe{static{this.languageTriggerKindToVSCodeTriggerKind={[r.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(B,x,q){this._documents=B,this._provider=x,this._logService=q}async supportsAutomaticNewSymbolNamesTriggerKind(){return this._provider.supportsAutomaticTriggerKind}async provideNewSymbolNames(B,x,q,K){const te=this._documents.getDocument(B),ue=t.Range.to(x);try{const Ae=oe.languageTriggerKindToVSCodeTriggerKind[q],Be=await this._provider.provideNewSymbolNames(te,ue,Ae,K);return Be?Be.map(He=>typeof He=="string"?{newSymbolName:He}:{newSymbolName:He.newSymbolName,tags:He.tags}):void 0}catch(Ae){this._logService.error(oe._asMessage(Ae)??JSON.stringify(Ae,null,"	"));return}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class pe{constructor(B,x){this.resultId=B,this.tokens=x}}class ve{constructor(B,x){this._documents=B,this._provider=x,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,x,q){const K=this._documents.getDocument(B),te=x!==0?this._previousResults.get(x):null;let ue=typeof te?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(K,te.resultId,q):await this._provider.provideDocumentSemanticTokens(K,q);return te&&this._previousResults.delete(x),ue?(ue=ve._fixProvidedSemanticTokens(ue),this._send(ve._convertToEdits(te,ue),ue)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return ve._isSemanticTokens(B)?ve._isCorrectSemanticTokens(B)?B:new s.SemanticTokens(new Uint32Array(B.data),B.resultId):ve._isSemanticTokensEdits(B)?ve._isCorrectSemanticTokensEdits(B)?B:new s.SemanticTokensEdits(B.edits.map(x=>new s.SemanticTokensEdit(x.start,x.deleteCount,x.data?new Uint32Array(x.data):x.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const x of B.edits)if(!(x.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,x){if(!ve._isSemanticTokens(x)||!B||!B.tokens)return x;const q=B.tokens,K=q.length,te=x.data,ue=te.length;let Ae=0;const Be=Math.min(K,ue);for(;Ae<Be&&q[Ae]===te[Ae];)Ae++;if(Ae===K&&Ae===ue)return new s.SemanticTokensEdits([],x.resultId);let He=0;const Ye=Be-Ae;for(;He<Ye&&q[K-He-1]===te[ue-He-1];)He++;return new s.SemanticTokensEdits([{start:Ae,deleteCount:K-Ae-He,data:te.subarray(Ae,ue-He)}],x.resultId)}_send(B,x){if(ve._isSemanticTokens(B)){const q=this._nextResultId++;return this._previousResults.set(q,new pe(B.resultId,B.data)),(0,o.encodeSemanticTokensDto)({id:q,type:"full",data:B.data})}if(ve._isSemanticTokensEdits(B)){const q=this._nextResultId++;return ve._isSemanticTokens(x)?this._previousResults.set(q,new pe(x.resultId,x.data)):this._previousResults.set(q,new pe(B.resultId)),(0,o.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(B.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class se{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentRangeSemanticTokens(B,x,q){const K=this._documents.getDocument(B),te=await this._provider.provideDocumentRangeSemanticTokens(K,t.Range.to(x),q);return te?this._send(te):null}_send(B){return(0,o.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}class Te{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,x,q,K,te){this._documents=B,this._commands=x,this._provider=q,this._apiDeprecation=K,this._extension=te,this._cache=new i.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(B,x,q,K){const te=this._documents.getDocument(B),ue=t.Position.to(x),Ae=te.getWordRangeAtPosition(ue)||new s.Range(ue,ue),Be=Ae.with({end:ue}),He=new l.StopWatch,Ye=await this._provider.provideCompletionItems(te,ue,K,t.CompletionContext.to(q));if(!Ye||K.isCancellationRequested)return;const tt=Array.isArray(Ye)?new s.CompletionList(Ye):Ye,Ze=Te.supportsResolving(this._provider)?this._cache.add(tt.items):this._cache.add([]),it=new R.DisposableStore;this._disposables.set(Ze,it);const nt=[],mt={x:Ze,[g.ISuggestResultDtoField.completions]:nt,[g.ISuggestResultDtoField.defaultRanges]:{replace:t.Range.from(Ae),insert:t.Range.from(Be)},[g.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[g.ISuggestResultDtoField.duration]:He.elapsed()};for(let ut=0;ut<tt.items.length;ut++){const rt=tt.items[ut],at=this._convertCompletionItem(rt,[Ze,ut],Be,Ae);nt.push(at)}return mt}async resolveCompletionItem(B,x){if(typeof this._provider.resolveCompletionItem!="function")return;const q=this._cache.get(...B);if(!q)return;const K=this._convertCompletionItem(q,B),te=await this._provider.resolveCompletionItem(q,x);if(!te)return;const ue=this._convertCompletionItem(te,B);return(K[g.ISuggestDataDtoField.insertText]!==ue[g.ISuggestDataDtoField.insertText]||K[g.ISuggestDataDtoField.insertTextRules]!==ue[g.ISuggestDataDtoField.insertTextRules])&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K[g.ISuggestDataDtoField.commandIdent]!==ue[g.ISuggestDataDtoField.commandIdent]||K[g.ISuggestDataDtoField.commandId]!==ue[g.ISuggestDataDtoField.commandId]||!(0,v.equals)(K[g.ISuggestDataDtoField.commandArguments],ue[g.ISuggestDataDtoField.commandArguments]))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,[g.ISuggestDataDtoField.documentation]:ue[g.ISuggestDataDtoField.documentation],[g.ISuggestDataDtoField.detail]:ue[g.ISuggestDataDtoField.detail],[g.ISuggestDataDtoField.additionalTextEdits]:ue[g.ISuggestDataDtoField.additionalTextEdits],[g.ISuggestDataDtoField.insertText]:ue[g.ISuggestDataDtoField.insertText],[g.ISuggestDataDtoField.insertTextRules]:ue[g.ISuggestDataDtoField.insertTextRules],[g.ISuggestDataDtoField.commandIdent]:ue[g.ISuggestDataDtoField.commandIdent],[g.ISuggestDataDtoField.commandId]:ue[g.ISuggestDataDtoField.commandId],[g.ISuggestDataDtoField.commandArguments]:ue[g.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,x,q,K){const te=this._disposables.get(x[0]);if(!te)throw Error("DisposableStore is missing...");const ue=this._commands.toInternal(B.command,te),Ae={x,[g.ISuggestDataDtoField.label]:B.label,[g.ISuggestDataDtoField.kind]:B.kind!==void 0?t.CompletionItemKind.from(B.kind):void 0,[g.ISuggestDataDtoField.kindModifier]:B.tags&&B.tags.map(t.CompletionItemTag.from),[g.ISuggestDataDtoField.detail]:B.detail,[g.ISuggestDataDtoField.documentation]:typeof B.documentation>"u"?void 0:t.MarkdownString.fromStrict(B.documentation),[g.ISuggestDataDtoField.sortText]:B.sortText!==B.label?B.sortText:void 0,[g.ISuggestDataDtoField.filterText]:B.filterText!==B.label?B.filterText:void 0,[g.ISuggestDataDtoField.preselect]:B.preselect||void 0,[g.ISuggestDataDtoField.insertTextRules]:B.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[g.ISuggestDataDtoField.commitCharacters]:B.commitCharacters?.join(""),[g.ISuggestDataDtoField.additionalTextEdits]:B.additionalTextEdits&&B.additionalTextEdits.map(t.TextEdit.from),[g.ISuggestDataDtoField.commandIdent]:ue?.$ident,[g.ISuggestDataDtoField.commandId]:ue?.id,[g.ISuggestDataDtoField.commandArguments]:ue?.$ident?void 0:ue?.arguments};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae[g.ISuggestDataDtoField.insertText]=B.textEdit.newText):typeof B.insertText=="string"?Ae[g.ISuggestDataDtoField.insertText]=B.insertText:B.insertText instanceof s.SnippetString&&(Ae[g.ISuggestDataDtoField.insertText]=B.insertText.value,Ae[g.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let Be;return B.textEdit?Be=B.textEdit.range:B.range&&(Be=B.range),s.Range.isRange(Be)?Ae[g.ISuggestDataDtoField.range]=t.Range.from(Be):Be&&(!q?.isEqual(Be.inserting)||!K?.isEqual(Be.replacing))&&(Ae[g.ISuggestDataDtoField.range]={insert:t.Range.from(Be.inserting),replace:t.Range.from(Be.replacing)}),Ae}}class Me{async provideInlineCompletions(B,x,q,K){}disposeCompletions(B){}handleDidShowCompletionItem(B,x,q){}handlePartialAccept(B,x,q,K){}}class Q extends Me{constructor(B,x,q,K){super(),this._extension=B,this._documents=x,this._provider=q,this._commands=K,this._references=new ie,this._isAdditionsProposedApiEnabled=(0,n.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[r.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,x,q,K){const te=this._documents.getDocument(B),ue=t.Position.to(x),Ae=await this._provider.provideInlineCompletionItems(te,ue,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:t.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},K);if(!Ae||K.isCancellationRequested)return;const Be=Array.isArray(Ae)?Ae:Ae.items,He=this._isAdditionsProposedApiEnabled?Array.isArray(Ae)?[]:Ae.commands||[]:[],Ye=this._isAdditionsProposedApiEnabled&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let tt;return{pid:this._references.createReferenceId({dispose(){tt?.dispose()},items:Be}),items:Be.map((it,nt)=>{let mt;it.command&&(tt||(tt=new R.DisposableStore),mt=this._commands.toInternal(it.command,tt));const ut=it.insertText;return{insertText:typeof ut=="string"?ut:{snippet:ut.value},filterText:it.filterText,range:it.range?t.Range.from(it.range):void 0,command:mt,idx:nt,completeBracketPairs:this._isAdditionsProposedApiEnabled?it.completeBracketPairs:!1}}),commands:He.map(it=>(tt||(tt=new R.DisposableStore),this._commands.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(B){this._references.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,x,q){const K=this._references.get(B)?.items[x];K&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(K,q)}handlePartialAccept(B,x,q,K){const te=this._references.get(B)?.items[x];te&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(te,q),this._provider.handleDidPartiallyAcceptCompletionItem(te,t.PartialAcceptInfo.to(K)))}}class W{async provideInlineEdits(B,x,q){const K=this._documents.getDocument(B),te=await this._provider.provideInlineEdit(K,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[x.triggerKind]},q);if(!te||q.isCancellationRequested)return;let ue;const Ae=this._references.createReferenceId({dispose(){ue?.dispose()},item:te});let Be;te.accepted&&(ue||(ue=new R.DisposableStore),Be=this._commands.toInternal(te.accepted,ue));let He;return te.rejected&&(ue||(ue=new R.DisposableStore),He=this._commands.toInternal(te.rejected,ue)),{pid:Ae,text:te.text,range:t.Range.from(te.range),accepted:Be,rejected:He}}disposeEdit(B){this._references.disposeReferenceId(B)?.dispose()}constructor(B,x,q,K){this._documents=x,this._provider=q,this._commands=K,this._references=new ie,this.languageTriggerKindToVSCodeTriggerKind={[r.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class ie{constructor(){this._references=new Map,this._idPool=1}createReferenceId(B){const x=this._idPool++;return this._references.set(x,B),x}disposeReferenceId(B){const x=this._references.get(B);return this._references.delete(B),x}get(B){return this._references.get(B)}}class _e{constructor(B,x){this._documents=B,this._provider=x,this._cache=new i.Cache("SignatureHelp")}async provideSignatureHelp(B,x,q,K){const te=this._documents.getDocument(B),ue=t.Position.to(x),Ae=this.reviveContext(q),Be=await this._provider.provideSignatureHelp(te,ue,K,Ae);if(Be){const He=this._cache.add([Be]);return{...t.SignatureHelp.from(Be),id:He}}}reviveContext(B){let x;if(B.activeSignatureHelp){const q=t.SignatureHelp.to(B.activeSignatureHelp),K=this._cache.get(B.activeSignatureHelp.id,0);K?(x=K,x.activeSignature=q.activeSignature,x.activeParameter=q.activeParameter):x=q}return{...B,activeSignatureHelp:x}}releaseSignatureHelp(B){this._cache.delete(B)}}class de{constructor(B,x,q,K,te){this._documents=B,this._commands=x,this._provider=q,this._logService=K,this._extension=te,this._cache=new i.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(B,x,q){const K=this._documents.getDocument(B),te=t.Range.to(x),ue=await this._provider.provideInlayHints(K,te,q);if(!Array.isArray(ue)||ue.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(x)}`);return}if(q.isCancellationRequested)return;const Ae=this._cache.add(ue);this._disposables.set(Ae,new R.DisposableStore);const Be={hints:[],cacheId:Ae};for(let He=0;He<ue.length;He++)this._isValidInlayHint(ue[He],te)&&Be.hints.push(this._convertInlayHint(ue[He],[Ae,He]));return this._logService.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(x)}`),Be}async resolveInlayHint(B,x){if(typeof this._provider.resolveInlayHint!="function")return;const q=this._cache.get(...B);if(!q)return;const K=await this._provider.resolveInlayHint(q,x);if(K&&this._isValidInlayHint(K))return this._convertInlayHint(K,B)}releaseHints(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_isValidInlayHint(B,x){return B.label.length===0||Array.isArray(B.label)&&B.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(x&&!x.contains(B.position))}_convertInlayHint(B,x){const q=this._disposables.get(x[0]);if(!q)throw Error("DisposableStore is missing...");const K={label:"",cacheId:x,tooltip:t.MarkdownString.fromStrict(B.tooltip),position:t.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(t.TextEdit.from),kind:B.kind&&t.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")K.label=B.label;else{const te=[];K.label=te;for(const ue of B.label){if(!ue.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Ae={label:ue.value,tooltip:t.MarkdownString.fromStrict(ue.tooltip)};s.Location.isLocation(ue.location)&&(Ae.location=t.location.from(ue.location)),ue.command&&(Ae.command=this._commands.toInternal(ue.command,q)),te.push(Ae)}}return K}}class Se{constructor(B,x){this._documents=B,this._provider=x,this._cache=new i.Cache("DocumentLink")}async provideLinks(B,x){const q=this._documents.getDocument(B),K=await this._provider.provideDocumentLinks(q,x);if(!(!Array.isArray(K)||K.length===0)&&!x.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:K.filter(Se._validateLink).map(t.DocumentLink.from)};{const te=this._cache.add(K),ue={links:[],cacheId:te};for(let Ae=0;Ae<K.length;Ae++){if(!Se._validateLink(K[Ae]))continue;const Be=t.DocumentLink.from(K[Ae]);Be.cacheId=[te,Ae],ue.links.push(Be)}return ue}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,x){if(typeof this._provider.resolveDocumentLink!="function")return;const q=this._cache.get(...B);if(!q)return;const K=await this._provider.resolveDocumentLink(q,x);if(!(!K||!Se._validateLink(K)))return t.DocumentLink.from(K)}releaseLinks(B){this._cache.delete(B)}}class ae{constructor(B,x){this._documents=B,this._provider=x}async provideColors(B,x){const q=this._documents.getDocument(B),K=await this._provider.provideDocumentColors(q,x);return Array.isArray(K)?K.map(ue=>({color:t.Color.from(ue.color),range:t.Range.from(ue.range)})):[]}async provideColorPresentations(B,x,q){const K=this._documents.getDocument(B),te=t.Range.to(x.range),ue=t.Color.to(x.color),Ae=await this._provider.provideColorPresentations(ue,{document:K,range:te},q);if(Array.isArray(Ae))return Ae.map(t.ColorPresentation.from)}}class X{constructor(B,x){this._documents=B,this._provider=x}async provideFoldingRanges(B,x,q){const K=this._documents.getDocument(B),te=await this._provider.provideFoldingRanges(K,x,q);if(Array.isArray(te))return te.map(t.FoldingRange.from)}}class J{constructor(B,x,q){this._documents=B,this._provider=x,this._logService=q}async provideSelectionRanges(B,x,q){const K=this._documents.getDocument(B),te=x.map(t.Position.to),ue=await this._provider.provideSelectionRanges(K,te,q);if(!(0,y.isNonEmptyArray)(ue))return[];if(ue.length!==te.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let Be=0;Be<te.length;Be++){const He=[];Ae.push(He);let Ye=te[Be],tt=ue[Be];for(;;){if(!tt.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(He.push(t.SelectionRange.from(tt)),!tt.parent)break;Ye=tt.range,tt=tt.parent}}return Ae}}class me{constructor(B,x){this._documents=B,this._provider=x,this._idPool=new A.IdGenerator(""),this._cache=new Map}async prepareSession(B,x,q){const K=this._documents.getDocument(B),te=t.Position.to(x),ue=await this._provider.prepareCallHierarchy(K,te,q);if(!ue)return;const Ae=this._idPool.nextId();return this._cache.set(Ae,new Map),Array.isArray(ue)?ue.map(Be=>this._cacheAndConvertItem(Ae,Be)):[this._cacheAndConvertItem(Ae,ue)]}async provideCallsTo(B,x,q){const K=this._itemFromCache(B,x);if(!K)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyIncomingCalls(K,q);if(te)return te.map(ue=>({from:this._cacheAndConvertItem(B,ue.from),fromRanges:ue.fromRanges.map(Ae=>t.Range.from(Ae))}))}async provideCallsFrom(B,x,q){const K=this._itemFromCache(B,x);if(!K)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyOutgoingCalls(K,q);if(te)return te.map(ue=>({to:this._cacheAndConvertItem(B,ue.to),fromRanges:ue.fromRanges.map(Ae=>t.Range.from(Ae))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,x){const q=this._cache.get(B),K=t.CallHierarchyItem.from(x,B,q.size.toString(36));return q.set(K._itemId,x),K}_itemFromCache(B,x){return this._cache.get(B)?.get(x)}}class ge{constructor(B,x){this._documents=B,this._provider=x,this._idPool=new A.IdGenerator(""),this._cache=new Map}async prepareSession(B,x,q){const K=this._documents.getDocument(B),te=t.Position.to(x),ue=await this._provider.prepareTypeHierarchy(K,te,q);if(!ue)return;const Ae=this._idPool.nextId();return this._cache.set(Ae,new Map),Array.isArray(ue)?ue.map(Be=>this._cacheAndConvertItem(Ae,Be)):[this._cacheAndConvertItem(Ae,ue)]}async provideSupertypes(B,x,q){const K=this._itemFromCache(B,x);if(!K)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySupertypes(K,q);if(te)return te.map(ue=>this._cacheAndConvertItem(B,ue))}async provideSubtypes(B,x,q){const K=this._itemFromCache(B,x);if(!K)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySubtypes(K,q);if(te)return te.map(ue=>this._cacheAndConvertItem(B,ue))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,x){const q=this._cache.get(B),K=t.TypeHierarchyItem.from(x,B,q.size.toString(36));return q.set(K._itemId,x),K}_itemFromCache(B,x){return this._cache.get(B)?.get(x)}}class Le{constructor(B,x,q,K,te){this._proxy=B,this._documents=x,this._provider=q,this._handle=K,this._extension=te,this._cache=new i.Cache("DocumentDropEdit")}async provideDocumentOnDropEdits(B,x,q,K,te){const ue=this._documents.getDocument(x),Ae=t.Position.to(q),Be=t.DataTransfer.toDataTransfer(K,async Ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,B,Ze)).buffer),He=await this._provider.provideDocumentDropEdits(ue,Ae,Be,te);if(!He)return;const Ye=(0,y.asArray)(He),tt=this._cache.add(Ye);return Ye.map((Ze,it)=>({_cacheId:[tt,it],title:Ze.title??(0,a.localize)(1,null,this._extension.displayName||this._extension.name),kind:Ze.kind?.value,yieldTo:Ze.yieldTo?.map(nt=>nt.value),insertText:typeof Ze.insertText=="string"?Ze.insertText:{snippet:Ze.insertText.value},additionalEdit:Ze.additionalEdit?t.WorkspaceEdit.from(Ze.additionalEdit,void 0):void 0}))}async resolveDropEdit(B,x){const[q,K]=B,te=this._cache.get(q,K);if(!te||!this._provider.resolveDocumentDropEdit)return{};const ue=await this._provider.resolveDocumentDropEdit(te,x)??te;return{additionalEdit:ue.additionalEdit?t.WorkspaceEdit.from(ue.additionalEdit,void 0):void 0}}releaseDropEdits(B){this._cache.delete(B)}}class ze{constructor(B,x){this._documents=B,this._provider=x}async provideMappedEdits(B,x,q,K){const te=c.URI.revive(B),ue=this._documents.getDocument(te),Ae=q.documents.map(Ye=>Ye.map(tt=>({uri:c.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(Ze=>t.Range.to(Ze))}))),Be={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},He=await this._provider.provideMappedEdits(ue,x,Be,K);return He?t.WorkspaceEdit.from(He):null}}class ye{constructor(B,x){this.adapter=B,this.extension=x}}class ke{static{this._handlePool=0}constructor(B,x,q,K,te,ue,Ae,Be){this._uriTransformer=x,this._documents=q,this._commands=K,this._diagnostics=te,this._logService=ue,this._apiDeprecation=Ae,this._extensionTelemetry=Be,this._adapter=new Map,this._proxy=B.getProxy(g.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(B,x){return t.DocumentSelector.from(B,this._uriTransformer,x)}_createDisposable(B){return new s.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return ke._handlePool++}async _withAdapter(B,x,q,K,te,ue=!1){const Ae=this._adapter.get(B);if(!Ae||!(Ae.adapter instanceof x))return K;const Be=Date.now();ue||this._logService.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const He=q(Ae.adapter,Ae.extension);return Promise.resolve(He).catch(Ye=>{(0,O.isCancellationError)(Ye)||(this._logService.error(`[${Ae.extension.identifier.value}] provider FAILED`),this._logService.error(Ye),this._extensionTelemetry.onExtensionError(Ae.extension.identifier,Ye))}).finally(()=>{ue||this._logService.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),P.CancellationToken.isCancellationToken(te)?(0,k.raceCancellationError)(He,te):He}_addNewAdapter(B,x){const q=this._nextHandle();return this._adapter.set(q,new ye(B,x)),q}static _extLabel(B){return B.displayName||B.name}static _extId(B){return B.identifier.value}registerDocumentSymbolProvider(B,x,q,K){const te=this._addNewAdapter(new f(this._documents,q),B),ue=K&&K.label||ke._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(te,this._transformDocumentSelector(x,B),ue),this._createDisposable(te)}$provideDocumentSymbols(B,x,q){return this._withAdapter(B,f,K=>K.provideDocumentSymbols(c.URI.revive(x),q),void 0,q)}registerCodeLensProvider(B,x,q){const K=this._nextHandle(),te=typeof q.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(K,new ye(new u(this._documents,this._commands.converter,q,B,this._extensionTelemetry,this._logService),B)),this._proxy.$registerCodeLensSupport(K,this._transformDocumentSelector(x,B),te);let ue=this._createDisposable(K);if(te!==void 0){const Ae=q.onDidChangeCodeLenses(Be=>this._proxy.$emitCodeLensEvent(te));ue=s.Disposable.from(ue,Ae)}return ue}$provideCodeLenses(B,x,q){return this._withAdapter(B,u,K=>K.provideCodeLenses(c.URI.revive(x),q),void 0,q)}$resolveCodeLens(B,x,q){return this._withAdapter(B,u,K=>K.resolveCodeLens(x,q),void 0,void 0)}$releaseCodeLenses(B,x){this._withAdapter(B,u,q=>Promise.resolve(q.releaseCodeLenses(x)),void 0,void 0)}registerDefinitionProvider(B,x,q){const K=this._addNewAdapter(new I(this._documents,q),B);return this._proxy.$registerDefinitionSupport(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$provideDefinition(B,x,q,K){return this._withAdapter(B,I,te=>te.provideDefinition(c.URI.revive(x),q,K),[],K)}registerDeclarationProvider(B,x,q){const K=this._addNewAdapter(new _(this._documents,q),B);return this._proxy.$registerDeclarationSupport(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$provideDeclaration(B,x,q,K){return this._withAdapter(B,_,te=>te.provideDeclaration(c.URI.revive(x),q,K),[],K)}registerImplementationProvider(B,x,q){const K=this._addNewAdapter(new w(this._documents,q),B);return this._proxy.$registerImplementationSupport(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$provideImplementation(B,x,q,K){return this._withAdapter(B,w,te=>te.provideImplementation(c.URI.revive(x),q,K),[],K)}registerTypeDefinitionProvider(B,x,q){const K=this._addNewAdapter(new p(this._documents,q),B);return this._proxy.$registerTypeDefinitionSupport(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$provideTypeDefinition(B,x,q,K){return this._withAdapter(B,p,te=>te.provideTypeDefinition(c.URI.revive(x),q,K),[],K)}registerHoverProvider(B,x,q,K){const te=this._addNewAdapter(new D(this._documents,q),B);return this._proxy.$registerHoverProvider(te,this._transformDocumentSelector(x,B)),this._createDisposable(te)}$provideHover(B,x,q,K,te){return this._withAdapter(B,D,ue=>ue.provideHover(c.URI.revive(x),q,K,te),void 0,te)}$releaseHover(B,x){this._withAdapter(B,D,q=>Promise.resolve(q.releaseHover(x)),void 0,void 0)}registerEvaluatableExpressionProvider(B,x,q,K){const te=this._addNewAdapter(new m(this._documents,q),B);return this._proxy.$registerEvaluatableExpressionProvider(te,this._transformDocumentSelector(x,B)),this._createDisposable(te)}$provideEvaluatableExpression(B,x,q,K){return this._withAdapter(B,m,te=>te.provideEvaluatableExpression(c.URI.revive(x),q,K),void 0,K)}registerInlineValuesProvider(B,x,q,K){const te=typeof q.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ue=this._addNewAdapter(new S(this._documents,q),B);this._proxy.$registerInlineValuesProvider(ue,this._transformDocumentSelector(x,B),te);let Ae=this._createDisposable(ue);if(te!==void 0){const Be=q.onDidChangeInlineValues(He=>this._proxy.$emitInlineValuesEvent(te));Ae=s.Disposable.from(Ae,Be)}return Ae}$provideInlineValues(B,x,q,K,te){return this._withAdapter(B,S,ue=>ue.provideInlineValues(c.URI.revive(x),q,K,te),void 0,te)}registerDocumentHighlightProvider(B,x,q){const K=this._addNewAdapter(new M(this._documents,q),B);return this._proxy.$registerDocumentHighlightProvider(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}registerMultiDocumentHighlightProvider(B,x,q){const K=this._addNewAdapter(new L(this._documents,q),B);return this._proxy.$registerMultiDocumentHighlightProvider(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$provideDocumentHighlights(B,x,q,K){return this._withAdapter(B,M,te=>te.provideDocumentHighlights(c.URI.revive(x),q,K),void 0,K)}$provideMultiDocumentHighlights(B,x,q,K,te){return this._withAdapter(B,L,ue=>ue.provideMultiDocumentHighlights(c.URI.revive(x),q,K.map(Ae=>c.URI.revive(Ae)),te),void 0,te)}registerLinkedEditingRangeProvider(B,x,q){const K=this._addNewAdapter(new H(this._documents,q),B);return this._proxy.$registerLinkedEditingRangeProvider(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$provideLinkedEditingRanges(B,x,q,K){return this._withAdapter(B,H,async te=>{const ue=await te.provideLinkedEditingRanges(c.URI.revive(x),q,K);if(ue)return{ranges:ue.ranges,wordPattern:ue.wordPattern?ke._serializeRegExp(ue.wordPattern):void 0}},void 0,K)}registerReferenceProvider(B,x,q){const K=this._addNewAdapter(new V(this._documents,q),B);return this._proxy.$registerReferenceSupport(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$provideReferences(B,x,q,K,te){return this._withAdapter(B,V,ue=>ue.provideReferences(c.URI.revive(x),q,K,te),void 0,te)}registerCodeActionProvider(B,x,q,K){const te=new R.DisposableStore,ue=this._addNewAdapter(new $(this._documents,this._commands.converter,this._diagnostics,q,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerCodeActionSupport(ue,this._transformDocumentSelector(x,B),{providedKinds:K?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:K?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this._commands.converter.toInternal(Ae.command,te)}))},ke._extLabel(B),ke._extId(B),!!q.resolveCodeAction),te.add(this._createDisposable(ue)),te}$provideCodeActions(B,x,q,K,te){return this._withAdapter(B,$,ue=>ue.provideCodeActions(c.URI.revive(x),q,K,te),void 0,te)}$resolveCodeAction(B,x,q){return this._withAdapter(B,$,K=>K.resolveCodeAction(x,q),{},void 0)}$releaseCodeActions(B,x){this._withAdapter(B,$,q=>Promise.resolve(q.releaseCodeActions(x)),void 0,void 0)}registerDocumentFormattingEditProvider(B,x,q){const K=this._addNewAdapter(new F(this._documents,q),B);return this._proxy.$registerDocumentFormattingSupport(K,this._transformDocumentSelector(x,B),B.identifier,B.displayName||B.name),this._createDisposable(K)}$provideDocumentFormattingEdits(B,x,q,K){return this._withAdapter(B,F,te=>te.provideDocumentFormattingEdits(c.URI.revive(x),q,K),void 0,K)}registerDocumentRangeFormattingEditProvider(B,x,q){const K=typeof q.provideDocumentRangesFormattingEdits=="function",te=this._addNewAdapter(new Y(this._documents,q),B);return this._proxy.$registerRangeFormattingSupport(te,this._transformDocumentSelector(x,B),B.identifier,B.displayName||B.name,K),this._createDisposable(te)}$provideDocumentRangeFormattingEdits(B,x,q,K,te){return this._withAdapter(B,Y,ue=>ue.provideDocumentRangeFormattingEdits(c.URI.revive(x),q,K,te),void 0,te)}$provideDocumentRangesFormattingEdits(B,x,q,K,te){return this._withAdapter(B,Y,ue=>ue.provideDocumentRangesFormattingEdits(c.URI.revive(x),q,K,te),void 0,te)}registerOnTypeFormattingEditProvider(B,x,q,K){const te=this._addNewAdapter(new re(this._documents,q),B);return this._proxy.$registerOnTypeFormattingSupport(te,this._transformDocumentSelector(x,B),K,B.identifier),this._createDisposable(te)}$provideOnTypeFormattingEdits(B,x,q,K,te,ue){return this._withAdapter(B,re,Ae=>Ae.provideOnTypeFormattingEdits(c.URI.revive(x),q,K,te,ue),void 0,ue)}registerWorkspaceSymbolProvider(B,x){const q=this._addNewAdapter(new fe(x,this._logService),B);return this._proxy.$registerNavigateTypeSupport(q,typeof x.resolveWorkspaceSymbol=="function"),this._createDisposable(q)}$provideWorkspaceSymbols(B,x,q){return this._withAdapter(B,fe,K=>K.provideWorkspaceSymbols(x,q),{symbols:[]},q)}$resolveWorkspaceSymbol(B,x,q){return this._withAdapter(B,fe,K=>K.resolveWorkspaceSymbol(x,q),void 0,void 0)}$releaseWorkspaceSymbols(B,x){this._withAdapter(B,fe,q=>q.releaseWorkspaceSymbols(x),void 0,void 0)}registerRenameProvider(B,x,q){const K=this._addNewAdapter(new Ee(this._documents,q,this._logService),B);return this._proxy.$registerRenameSupport(K,this._transformDocumentSelector(x,B),Ee.supportsResolving(q)),this._createDisposable(K)}$provideRenameEdits(B,x,q,K,te){return this._withAdapter(B,Ee,ue=>ue.provideRenameEdits(c.URI.revive(x),q,K,te),void 0,te)}$resolveRenameLocation(B,x,q,K){return this._withAdapter(B,Ee,te=>te.resolveRenameLocation(c.URI.revive(x),q,K),void 0,K)}registerNewSymbolNamesProvider(B,x,q){const K=this._addNewAdapter(new oe(this._documents,q,this._logService),B);return this._proxy.$registerNewSymbolNamesProvider(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$supportsAutomaticNewSymbolNamesTriggerKind(B){return this._withAdapter(B,oe,x=>x.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(B,x,q,K,te){return this._withAdapter(B,oe,ue=>ue.provideNewSymbolNames(c.URI.revive(x),q,K,te),void 0,te)}registerDocumentSemanticTokensProvider(B,x,q,K){const te=this._addNewAdapter(new ve(this._documents,q),B),ue=typeof q.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(te,this._transformDocumentSelector(x,B),K,ue);let Ae=this._createDisposable(te);if(ue){const Be=q.onDidChangeSemanticTokens(He=>this._proxy.$emitDocumentSemanticTokensEvent(ue));Ae=s.Disposable.from(Ae,Be)}return Ae}$provideDocumentSemanticTokens(B,x,q,K){return this._withAdapter(B,ve,te=>te.provideDocumentSemanticTokens(c.URI.revive(x),q,K),null,K)}$releaseDocumentSemanticTokens(B,x){this._withAdapter(B,ve,q=>q.releaseDocumentSemanticColoring(x),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,x,q,K){const te=this._addNewAdapter(new se(this._documents,q),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(te,this._transformDocumentSelector(x,B),K),this._createDisposable(te)}$provideDocumentRangeSemanticTokens(B,x,q,K){return this._withAdapter(B,se,te=>te.provideDocumentRangeSemanticTokens(c.URI.revive(x),q,K),null,K)}registerCompletionItemProvider(B,x,q,K){const te=this._addNewAdapter(new Te(this._documents,this._commands.converter,q,this._apiDeprecation,B),B);return this._proxy.$registerCompletionsProvider(te,this._transformDocumentSelector(x,B),K,Te.supportsResolving(q),B.identifier),this._createDisposable(te)}$provideCompletionItems(B,x,q,K,te){return this._withAdapter(B,Te,ue=>ue.provideCompletionItems(c.URI.revive(x),q,K,te),void 0,te)}$resolveCompletionItem(B,x,q){return this._withAdapter(B,Te,K=>K.resolveCompletionItem(x,q),void 0,q)}$releaseCompletionItems(B,x){this._withAdapter(B,Te,q=>q.releaseCompletionItems(x),void 0,void 0)}registerInlineCompletionsProvider(B,x,q,K){const te=new Q(B,this._documents,q,this._commands.converter),ue=this._addNewAdapter(te,B);return this._proxy.$registerInlineCompletionsSupport(ue,this._transformDocumentSelector(x,B),te.supportsHandleEvents,d.ExtensionIdentifier.toKey(B.identifier.value),K?.yieldTo?.map(Ae=>d.ExtensionIdentifier.toKey(Ae))||[]),this._createDisposable(ue)}$provideInlineCompletions(B,x,q,K,te){return this._withAdapter(B,Me,ue=>ue.provideInlineCompletions(c.URI.revive(x),q,K,te),void 0,te)}$handleInlineCompletionDidShow(B,x,q,K){this._withAdapter(B,Me,async te=>{te.handleDidShowCompletionItem(x,q,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,x,q,K,te){this._withAdapter(B,Me,async ue=>{ue.handlePartialAccept(x,q,K,te)},void 0,void 0)}$freeInlineCompletionsList(B,x){this._withAdapter(B,Me,async q=>{q.disposeCompletions(x)},void 0,void 0)}registerInlineEditProvider(B,x,q){const K=new W(B,this._documents,q,this._commands.converter),te=this._addNewAdapter(K,B);return this._proxy.$registerInlineEditProvider(te,this._transformDocumentSelector(x,B),B.identifier),this._createDisposable(te)}$provideInlineEdit(B,x,q,K){return this._withAdapter(B,W,te=>te.provideInlineEdits(c.URI.revive(x),q,K),void 0,K)}$freeInlineEdit(B,x){this._withAdapter(B,W,async q=>{q.disposeEdit(x)},void 0,void 0)}registerSignatureHelpProvider(B,x,q,K){const te=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,ue=this._addNewAdapter(new _e(this._documents,q),B);return this._proxy.$registerSignatureHelpProvider(ue,this._transformDocumentSelector(x,B),te),this._createDisposable(ue)}$provideSignatureHelp(B,x,q,K,te){return this._withAdapter(B,_e,ue=>ue.provideSignatureHelp(c.URI.revive(x),q,K,te),void 0,te)}$releaseSignatureHelp(B,x){this._withAdapter(B,_e,q=>q.releaseSignatureHelp(x),void 0,void 0)}registerInlayHintsProvider(B,x,q){const K=typeof q.onDidChangeInlayHints=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new de(this._documents,this._commands.converter,q,this._logService,B),B);this._proxy.$registerInlayHintsProvider(te,this._transformDocumentSelector(x,B),typeof q.resolveInlayHint=="function",K,ke._extLabel(B));let ue=this._createDisposable(te);if(K!==void 0){const Ae=q.onDidChangeInlayHints(Be=>this._proxy.$emitInlayHintsEvent(K));ue=s.Disposable.from(ue,Ae)}return ue}$provideInlayHints(B,x,q,K){return this._withAdapter(B,de,te=>te.provideInlayHints(c.URI.revive(x),q,K),void 0,K)}$resolveInlayHint(B,x,q){return this._withAdapter(B,de,K=>K.resolveInlayHint(x,q),void 0,q)}$releaseInlayHints(B,x){this._withAdapter(B,de,q=>q.releaseHints(x),void 0,void 0)}registerDocumentLinkProvider(B,x,q){const K=this._addNewAdapter(new Se(this._documents,q),B);return this._proxy.$registerDocumentLinkProvider(K,this._transformDocumentSelector(x,B),typeof q.resolveDocumentLink=="function"),this._createDisposable(K)}$provideDocumentLinks(B,x,q){return this._withAdapter(B,Se,K=>K.provideLinks(c.URI.revive(x),q),void 0,q,x.scheme==="output")}$resolveDocumentLink(B,x,q){return this._withAdapter(B,Se,K=>K.resolveLink(x,q),void 0,void 0,!0)}$releaseDocumentLinks(B,x){this._withAdapter(B,Se,q=>q.releaseLinks(x),void 0,void 0,!0)}registerColorProvider(B,x,q){const K=this._addNewAdapter(new ae(this._documents,q),B);return this._proxy.$registerDocumentColorProvider(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$provideDocumentColors(B,x,q){return this._withAdapter(B,ae,K=>K.provideColors(c.URI.revive(x),q),[],q)}$provideColorPresentations(B,x,q,K){return this._withAdapter(B,ae,te=>te.provideColorPresentations(c.URI.revive(x),q,K),void 0,K)}registerFoldingRangeProvider(B,x,q){const K=this._nextHandle(),te=typeof q.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(K,new ye(new X(this._documents,q),B)),this._proxy.$registerFoldingRangeProvider(K,this._transformDocumentSelector(x,B),B.identifier,te);let ue=this._createDisposable(K);if(te!==void 0){const Ae=q.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(te));ue=s.Disposable.from(ue,Ae)}return ue}$provideFoldingRanges(B,x,q,K){return this._withAdapter(B,X,te=>te.provideFoldingRanges(c.URI.revive(x),q,K),void 0,K)}registerSelectionRangeProvider(B,x,q){const K=this._addNewAdapter(new J(this._documents,q,this._logService),B);return this._proxy.$registerSelectionRangeProvider(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$provideSelectionRanges(B,x,q,K){return this._withAdapter(B,J,te=>te.provideSelectionRanges(c.URI.revive(x),q,K),[],K)}registerCallHierarchyProvider(B,x,q){const K=this._addNewAdapter(new me(this._documents,q),B);return this._proxy.$registerCallHierarchyProvider(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$prepareCallHierarchy(B,x,q,K){return this._withAdapter(B,me,te=>Promise.resolve(te.prepareSession(c.URI.revive(x),q,K)),void 0,K)}$provideCallHierarchyIncomingCalls(B,x,q,K){return this._withAdapter(B,me,te=>te.provideCallsTo(x,q,K),void 0,K)}$provideCallHierarchyOutgoingCalls(B,x,q,K){return this._withAdapter(B,me,te=>te.provideCallsFrom(x,q,K),void 0,K)}$releaseCallHierarchy(B,x){this._withAdapter(B,me,q=>Promise.resolve(q.releaseSession(x)),void 0,void 0)}registerTypeHierarchyProvider(B,x,q){const K=this._addNewAdapter(new ge(this._documents,q),B);return this._proxy.$registerTypeHierarchyProvider(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$prepareTypeHierarchy(B,x,q,K){return this._withAdapter(B,ge,te=>Promise.resolve(te.prepareSession(c.URI.revive(x),q,K)),void 0,K)}$provideTypeHierarchySupertypes(B,x,q,K){return this._withAdapter(B,ge,te=>te.provideSupertypes(x,q,K),void 0,K)}$provideTypeHierarchySubtypes(B,x,q,K){return this._withAdapter(B,ge,te=>te.provideSubtypes(x,q,K),void 0,K)}$releaseTypeHierarchy(B,x){this._withAdapter(B,ge,q=>Promise.resolve(q.releaseSession(x)),void 0,void 0)}registerDocumentOnDropEditProvider(B,x,q,K){const te=this._nextHandle();return this._adapter.set(te,new ye(new Le(this._proxy,this._documents,q,te,B),B)),this._proxy.$registerDocumentOnDropEditProvider(te,this._transformDocumentSelector(x,B),(0,n.isProposedApiEnabled)(B,"documentPaste")&&K?{supportsResolve:!!q.resolveDocumentDropEdit,dropMimeTypes:K.dropMimeTypes}:void 0),this._createDisposable(te)}$provideDocumentOnDropEdits(B,x,q,K,te,ue){return this._withAdapter(B,Le,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(x,c.URI.revive(q),K,te,ue)),void 0,void 0)}$resolveDropEdit(B,x,q){return this._withAdapter(B,Le,K=>K.resolveDropEdit(x,q),{},void 0)}$releaseDropEdits(B,x){this._withAdapter(B,Le,q=>Promise.resolve(q.releaseDropEdits(x)),void 0,void 0)}registerMappedEditsProvider(B,x,q){const K=this._addNewAdapter(new ze(this._documents,q),B);return this._proxy.$registerMappedEditsProvider(K,this._transformDocumentSelector(x,B)),this._createDisposable(K)}$provideMappedEdits(B,x,q,K,te){return this._withAdapter(B,ze,ue=>Promise.resolve(ue.provideMappedEdits(x,q,K,te)),null,te)}registerDocumentPasteEditProvider(B,x,q,K){const te=this._nextHandle();return this._adapter.set(te,new ye(new N(this._proxy,this._documents,q,te,B),B)),this._proxy.$registerPasteEditProvider(te,this._transformDocumentSelector(x,B),{supportsCopy:!!q.prepareDocumentPaste,supportsPaste:!!q.provideDocumentPasteEdits,supportsResolve:!!q.resolveDocumentPasteEdit,providedPasteEditKinds:K.providedPasteEditKinds?.map(ue=>ue.value),copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this._createDisposable(te)}$prepareDocumentPaste(B,x,q,K,te){return this._withAdapter(B,N,ue=>ue.prepareDocumentPaste(c.URI.revive(x),q,K,te),void 0,te)}$providePasteEdits(B,x,q,K,te,ue,Ae){return this._withAdapter(B,N,Be=>Be.providePasteEdits(x,c.URI.revive(q),K,te,ue,Ae),void 0,Ae)}$resolvePasteEdit(B,x,q){return this._withAdapter(B,N,K=>K.resolvePasteEdit(x,q),{},void 0)}$releasePasteEdits(B,x){this._withAdapter(B,N,q=>Promise.resolve(q.releasePasteEdits(x)),void 0,void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:B.flags}}static _serializeIndentationRule(B){return{decreaseIndentPattern:ke._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:ke._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?ke._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?ke._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:ke._serializeRegExp(B.beforeText),afterText:B.afterText?ke._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?ke._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(ke._serializeOnEnterRule)}static _serializeAutoClosingPair(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(x=>s.SyntaxTokenType.toString(x)):void 0}}static _serializeAutoClosingPairs(B){return B.map(ke._serializeAutoClosingPair)}setLanguageConfiguration(B,x,q){const{wordPattern:K}=q;if(K&&(0,T.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this._documents.setWordDefinitionFor(x,K):this._documents.setWordDefinitionFor(x,void 0),q.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),q.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const te=this._nextHandle(),ue={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?ke._serializeRegExp(q.wordPattern):void 0,indentationRules:q.indentationRules?ke._serializeIndentationRule(q.indentationRules):void 0,onEnterRules:q.onEnterRules?ke._serializeOnEnterRules(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport,autoClosingPairs:q.autoClosingPairs?ke._serializeAutoClosingPairs(q.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(te,x,ue),this._createDisposable(te)}$setWordDefinitions(B){for(const x of B)this._documents.setWordDefinitionFor(x.languageId,new RegExp(x.regexSource,x.regexFlags))}}e.ExtHostLanguageFeatures=ke}),define(De[95],Ie([1,0,11,22,14,4,40,6,182,19,3,12,77,5,91,17,10,7,115,25]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,e.IExtHostLanguageModels=(0,T.createDecorator)("IExtHostLanguageModels");class n{constructor(u,E){this.option=u,this.stream=new y.AsyncIterableSource,this.stream=E??new y.AsyncIterableSource}}class i{constructor(){this._responseStreams=new Map,this._defaultStream=new y.AsyncIterableSource,this._isDone=!1,this._isStreaming=!1;const u=this;this.apiObject={text:u._defaultStream.asyncIterable}}*_streams(){if(this._responseStreams.size>0)for(const[,u]of this._responseStreams)yield u.stream;else yield this._defaultStream}handleFragment(u){if(this._isDone)return;this._isStreaming=!0;let E=this._responseStreams.get(u.index);E||(this._responseStreams.size===0?E=new n(u.index,this._defaultStream):E=new n(u.index),this._responseStreams.set(u.index,E)),E.stream.emitOne(u.part)}get isStreaming(){return this._isStreaming}reject(u){this._isDone=!0;for(const E of this._streams())E.reject(u)}resolve(){this._isDone=!0;for(const u of this._streams())u.resolve()}}let g=class{static{s=this}static{this._idPool=1}constructor(u,E,I){this._logService=E,this._extHostAuthentication=I,this._onDidChangeModelAccess=new O.Emitter,this._onDidChangeProviders=new O.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new l.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=u.getProxy(C.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(u,E,I,_){const w=s._idPool++;this._languageModels.set(w,{extension:u.identifier,provider:I,languageModelId:E});let p;_.auth&&(p={providerLabel:u.displayName||u.name,accountLabel:typeof _.auth=="object"?_.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(w,`${l.ExtensionIdentifier.toKey(u.identifier)}/${w}/${E}`,{extension:u.identifier,id:E,vendor:_.vendor??l.ExtensionIdentifier.toKey(u.identifier),name:_.name??"",family:_.family??"",version:_.version,maxInputTokens:_.maxInputTokens,maxOutputTokens:_.maxOutputTokens,auth:p,targetExtensions:_.extensions});const D=I.onDidReceiveLanguageModelResponse2?.(({extensionId:m,participant:S,tokenCount:M})=>{this._proxy.$whenLanguageModelChatRequestMade(E,new l.ExtensionIdentifier(m),S,M)});return(0,R.toDisposable)(()=>{this._languageModels.delete(w),this._proxy.$unregisterProvider(w),D?.dispose()})}async $provideLanguageModelResponse(u,E,I,_,w,p){const D=this._languageModels.get(u);if(!D)return;const m=new c.Progress(async S=>{if(p.isCancellationRequested){this._logService.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(E,{index:S.index,part:S.part})});return D.provider.provideLanguageModelResponse(_.map(o.LanguageModelChatMessage.to),w,l.ExtensionIdentifier.toKey(I),m,p)}$provideTokenLength(u,E,I){const _=this._languageModels.get(u);return _?Promise.resolve(_.provider.provideTokenCount(E,I)):Promise.resolve(0)}$acceptChatModelMetadata(u){if(u.added)for(const{identifier:E,metadata:I}of u.added)this._allLanguageModelData.set(E,{metadata:I,apiObjects:new l.ExtensionIdentifierMap});if(u.removed)for(const E of u.removed){this._allLanguageModelData.delete(E);for(const[I,_]of this._pendingRequest)_.languageModelId===E&&(_.res.reject(new P.CancellationError),this._pendingRequest.delete(I))}u.added?.forEach(E=>this._fakeAuthPopulate(E.metadata)),this._onDidChangeProviders.fire(void 0)}async selectLanguageModels(u,E){const I=await this._proxy.$selectChatModels({...E,extension:u.identifier}),_=[],w=this;for(const p of I){const D=this._allLanguageModelData.get(p);if(!D)continue;this._isUsingAuth(u.identifier,D.metadata)&&await this._fakeAuthPopulate(D.metadata);let m=D.apiObjects.get(u.identifier);m||(m={id:p,vendor:D.metadata.vendor,family:D.metadata.family,version:D.metadata.version,name:D.metadata.name,maxInputTokens:D.metadata.maxInputTokens,countTokens(S,M){if(!w._allLanguageModelData.has(p))throw a.LanguageModelError.NotFound(p);return w._computeTokenLength(p,S,M??k.CancellationToken.None)},sendRequest(S,M,L){if(!w._allLanguageModelData.has(p))throw a.LanguageModelError.NotFound(p);return w._sendChatRequest(u,p,S,M??{},L??k.CancellationToken.None)}},Object.freeze(m),D.apiObjects.set(u.identifier,m)),_.push(m)}return _}async _sendChatRequest(u,E,I,_,w){const p=this._convertMessages(u,I),D=u.identifier,m=this._allLanguageModelData.get(E)?.metadata;if(!m||!this._allLanguageModelData.has(E))throw a.LanguageModelError.NotFound(`Language model '${E}' is unknown.`);if(this._isUsingAuth(D,m)&&(!await this._getAuthAccess(u,{identifier:m.extension,displayName:m.auth.providerLabel},_.justification,!1)||!this._modelAccessList.get(D)?.has(m.extension)))throw a.LanguageModelError.NoPermissions(`Language model '${E}' cannot be used by '${D.value}'.`);const S=Math.random()*1e6|0,M=this._proxy.$fetchResponse(D,E,S,p,_.modelOptions??{},w),L=new y.Barrier,H=new i;this._pendingRequest.set(S,{languageModelId:E,res:H});let V;if(M.catch($=>{L.isOpen()?H.reject($):V=$}).finally(()=>{this._pendingRequest.delete(S),H.resolve(),L.open()}),await L.wait(),V)throw V.name===a.LanguageModelError.name?V:new a.LanguageModelError(`Language model '${E}' errored, check cause for more details`,"Unknown",V);return H.apiObject}_convertMessages(u,E){const I=[];for(const _ of E)_.role===a.LanguageModelChatMessageRole.System&&(0,t.checkProposedApiEnabled)(u,"languageModelSystem"),I.push(o.LanguageModelChatMessage.from(_));return I}async $handleResponseFragment(u,E){const I=this._pendingRequest.get(u);I&&I.res.handleFragment(E)}async _getAuthAccess(u,E,I,_){const w=d.INTERNAL_AUTH_PROVIDER_PREFIX+E.identifier.value;if(await this._extHostAuthentication.getSession(u,w,[],{silent:!0}))return this.$updateModelAccesslist([{from:u.identifier,to:E.identifier,enabled:!0}]),!0;if(_)return!1;try{const D=I?(0,v.localize)(0,null,E.displayName,I):void 0;return await this._extHostAuthentication.getSession(u,w,[],{forceNewSession:{detail:D}}),this.$updateModelAccesslist([{from:u.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(u,E){return!!E.auth&&!l.ExtensionIdentifier.equals(E.extension,u)}async _fakeAuthPopulate(u){if(u.auth)for(const E of this._languageAccessInformationExtensions)try{await this._getAuthAccess(E,{identifier:u.extension,displayName:""},void 0,!0)}catch(I){this._logService.error("Fake Auth request failed"),this._logService.error(I)}}async _computeTokenLength(u,E,I){if(!this._allLanguageModelData.get(u))throw a.LanguageModelError.NotFound(`Language model '${u}' is unknown.`);const w=A.Iterable.find(this._languageModels.values(),p=>p.languageModelId===u);return w?w.provider.provideTokenCount(E,I):this._proxy.$countTokens(u,typeof E=="string"?E:o.LanguageModelChatMessage.from(E),I)}$updateModelAccesslist(u){const E=new Array;for(const{from:I,to:_,enabled:w}of u){const p=this._modelAccessList.get(I)??new l.ExtensionIdentifierSet;if(p.has(_)!==w){w?p.add(_):p.delete(_),this._modelAccessList.set(I,p);const m={from:I,to:_};E.push(m),this._onDidChangeModelAccess.fire(m)}}}createLanguageModelAccessInformation(u){this._languageAccessInformationExtensions.add(u);const E=this,I=O.Event.signal(O.Event.filter(this._onDidChangeModelAccess.event,w=>l.ExtensionIdentifier.equals(w.from,u.identifier))),_=O.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return O.Event.any(I,_)},canSendRequest(w){let p;e:for(const[m,S]of E._allLanguageModelData)for(const M of S.apiObjects.values())if(M===w){p=S.metadata;break e}if(!p)return;if(!E._isUsingAuth(u.identifier,p))return!0;const D=E._modelAccessList.get(u.identifier);if(D)return D.has(p.extension)}}}};e.ExtHostLanguageModels=g,e.ExtHostLanguageModels=g=s=je([$e(0,r.IExtHostRpcService),$e(1,b.ILogService),$e(2,h.IExtHostAuthentication)],g)}),define(De[285],Ie([1,0,5,10,7,35,11,6,25]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class l{constructor(b,c,C,h){this._documents=c,this._commands=C,this._uriTransformer=h,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=b.getProxy(y.MainContext.MainThreadLanguages)}$acceptLanguageIds(b){this._languageIds=b}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(b,c){await this._proxy.$changeLanguage(b,c);const C=this._documents.getDocumentData(b);if(!C)throw new Error(`document '${b.toString()}' NOT found`);return C.document}async tokenAtPosition(b,c){const C=b.version,h=k.Position.from(c),r=await this._proxy.$tokensAtPosition(b.uri,h),o={type:P.StandardTokenType.Other,range:b.getWordRangeAtPosition(c)??new P.Range(c.line,c.character,c.line,c.character)};if(!r)return o;const a={range:k.Range.to(r.range),type:k.TokenType.to(r.type)};return!a.range.contains(c)||C!==b.version?o:a}createLanguageStatusItem(b,c,C){const h=this._handlePool++,r=this._proxy,o=this._ids,a=`${b.identifier.value}/${c}`;if(o.has(a))throw new Error(`LanguageStatusItem with id '${c}' ALREADY exists`);o.add(a);const d={selector:C,id:c,name:b.displayName??b.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let t;const s=new R.DisposableStore,n=()=>{if(t?.dispose(),!o.has(a)){console.warn(`LanguageStatusItem (${c}) from ${b.identifier.value} has been disposed and CANNOT be updated anymore`);return}t=(0,A.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(h,{id:a,name:d.name??b.displayName??b.name,source:b.displayName??b.name,selector:k.DocumentSelector.from(d.selector,this._uriTransformer),label:d.text,detail:d.detail??"",severity:d.severity===P.LanguageStatusSeverity.Error?O.default.Error:d.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:d.command&&this._commands.toInternal(d.command,s),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},i={dispose(){s.dispose(),t?.dispose(),r.$removeLanguageStatus(h),o.delete(a)},get id(){return d.id},get name(){return d.name},set name(g){d.name=g,n()},get selector(){return d.selector},set selector(g){d.selector=g,n()},get text(){return d.text},set text(g){d.text=g,n()},set text2(g){(0,v.checkProposedApiEnabled)(b,"languageStatusText"),d.text=g,n()},get text2(){return(0,v.checkProposedApiEnabled)(b,"languageStatusText"),d.text},get detail(){return d.detail},set detail(g){d.detail=g,n()},get severity(){return d.severity},set severity(g){d.severity=g,n()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(g){d.accessibilityInformation=g,n()},get command(){return d.command},set command(g){d.command=g,n()},get busy(){return d.busy},set busy(g){d.busy=g,n()}};return n(),i}}e.ExtHostLanguages=l}),define(De[286],Ie([1,0,16,2,10,7,90]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(b,c,C,h){this.start=b,this.deletedCount=c,this.deletedItems=C,this.items=h}asApiEvent(){return{range:new O.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}}class v{static asModelAddData(b){return{EOL:b.eol,lines:b.source,languageId:b.language,uri:b.uri,isDirty:!1,versionId:1}}constructor(b,c,C){this.notebook=b,this._extHostDocument=c,this._cellData=C,this.handle=C.handle,this.uri=k.URI.revive(C.uri),this.cellKind=C.cellKind,this._outputs=C.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=C.internalMetadata??{},this._metadata=Object.freeze(C.metadata??{}),this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:c.document,get mime(){return b._mime},set mime(h){b._mime=h},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}};this._apiCell=Object.freeze(C)}return this._apiCell}setOutputs(b){this._outputs=b.map(P.NotebookCellOutput.to)}setOutputItems(b,c,C){const h=C.map(P.NotebookCellOutputItem.to),r=this._outputs.find(o=>o.id===b);if(r&&(c||(r.items.length=0),r.items.push(...h),r.items.length>1&&r.items.every(o=>A.isTextStreamMime(o.mime)))){const o=new Map,a=[];r.items.forEach(d=>{let t;o.has(d.mime)?t=o.get(d.mime):(t=[],o.set(d.mime,t),a.push(d.mime)),t.push(d.data)}),r.items.length=0,a.forEach(d=>{const t=A.compressOutputItemStreams(o.get(d));r.items.push({mime:d,data:t.data.buffer})})}}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=v;class l{static{this._handlePool=0}constructor(b,c,C,h,r){this._proxy=b,this._textDocumentsAndEditors=c,this._textDocuments=C,this.uri=h,this.handle=l._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=r.viewType,this._metadata=Object.freeze(r.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,r.cells]],!0,void 0),this._versionId=r.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const b=this,c={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===y.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(C){return C=b._validateIndex(C),b._cells[C].apiCell},getCells(C){return(C?b._getCells(C):b._cells).map(r=>r.apiCell)},save(){return b._save()}};this._notebook=Object.freeze(c)}return this._notebook}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,c,C){this._versionId=b.versionId,this._isDirty=c,this.acceptDocumentPropertiesChanged({metadata:C});const h={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},r=[];for(const a of b.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1,h.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this._moveCells(a.index,a.length,a.newIdx,h.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(a.index,a.outputs),r.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems),r.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(a.index,a.language),r.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(a.index,a.metadata),r.push({cell:this._cells[a.index].apiCell,metadata:this._cells[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(a.index,a.internalMetadata),r.push({cell:this._cells[a.index].apiCell,executionSummary:this._cells[a.index].apiCell.executionSummary}));const o=new Map;for(let a=0;a<r.length;a++){const d=r[a],t=o.get(d.cell);if(t===void 0){const s=h.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...d});o.set(d.cell,s-1)}else h.cellChanges[t]={...h.cellChanges[t],...d}}return Object.freeze(h),Object.freeze(h.cellChanges),Object.freeze(h.contentChanges),h}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let c=b.start|0,C=b.end|0;return c<0&&(c=0),C>this._cells.length&&(C=this._cells.length),b.with({start:c,end:C})}_getCells(b){b=this._validateRange(b);const c=[];for(let C=b.start;C<b.end;C++)c.push(this._cells[C]);return c}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,c,C){if(this._disposed)return;const h=[],r=[],o=[];if(b.reverse().forEach(a=>{const t=a[2].map(i=>{const g=new v(this,this._textDocumentsAndEditors,i);return c||r.push(v.asModelAddData(i)),g}),s=new R(a[0],a[1],[],t),n=this._cells.splice(a[0],a[1],...t);for(const i of n)o.push(i.uri),s.deletedItems.push(i.apiCell);h.push(s)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),C)for(const a of h)C.push(a.asApiEvent())}_moveCells(b,c,C,h){const r=this._cells.splice(b,c);this._cells.splice(C,0,...r);const o=[new R(b,c,r.map(a=>a.apiCell),[]),new R(C,0,[],r)];for(const a of o)h.push(a.asApiEvent())}_setCellOutputs(b,c){this._cells[b].setOutputs(c)}_setCellOutputItems(b,c,C,h){this._cells[b].setOutputItems(c,C,h)}_changeCellLanguage(b,c){const C=this._cells[b];C.apiCell.document.languageId!==c&&this._textDocuments.$acceptModelLanguageChanged(C.uri,c)}_changeCellMime(b,c){const C=this._cells[b];C.apiCell.mime=c}_changeCellMetadata(b,c){this._cells[b].setMetadata(c)}_changeCellInternalMetadata(b,c){this._cells[b].setInternalMetadata(c)}getCellFromApiCell(b){return this._cells.find(c=>c.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(c=>c.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=l}),define(De[287],Ie([1,0,4,2,10,7,38]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(l,T,b,c={timeout:1500,errors:3}){this._logService=l,this._notebooksAndEditors=T,this._mainThreadBulkEdits=b,this._thresholds=c,this._onWillSaveNotebookDocumentEvent=new y.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(l){return(T,b,c)=>{const C=function(r){T.call(b,r)};return C.extension=l,this._onWillSaveNotebookDocumentEvent.event(C,void 0,c)}}async $participateInSave(l,T,b){const c=k.URI.revive(l),C=this._notebooksAndEditors.getNotebookDocument(c);if(!C)throw new Error("Unable to resolve notebook document");const h=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:C.apiNotebook,reason:P.TextDocumentSaveReason.to(T)},b,async(o,a)=>{const d=Date.now(),t=await await Promise.resolve(o);Date.now()-d>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!b.isCancellationRequested&&t&&(t instanceof O.WorkspaceEdit?h.push(t):this._logService.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),b.isCancellationRequested)return!1;if(h.length===0)return!0;const r={edits:[]};for(const o of h){const{edits:a}=P.WorkspaceEdit.from(o);r.edits=r.edits.concat(a)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new A.SerializableObjectWithBuffers(r))}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(De[122],Ie([1,0,14,10,7]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(R,v,l,T,b,c){this.id=R,this._proxy=v,this.notebookData=l,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=b,this._visibleRanges=T,this._viewColumn=c}get apiEditor(){if(!this._editor){const R=this;this._editor={get notebook(){return R.notebookData.apiNotebook},get selection(){return R._selections[0]},set selection(v){this.selections=[v]},get selections(){return R._selections},set selections(v){if(!Array.isArray(v)||!v.every(P.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");R._selections=v,R._trySetSelections(v)},get visibleRanges(){return R._visibleRanges},revealRange(v,l){R._proxy.$tryRevealRange(R.id,k.NotebookRange.from(v),l??P.NotebookEditorRevealType.Default)},get viewColumn(){return R._viewColumn}},O.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(R){this._visible=R}_acceptVisibleRanges(R){this._visibleRanges=R}_acceptSelections(R){this._selections=R}_trySetSelections(R){this._proxy.$trySetSelections(this.id,R.map(k.NotebookRange.from))}_acceptViewColumn(R){this._viewColumn=R}}e.ExtHostNotebookEditor=O}),define(De[288],Ie([1,0,4,12,10]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let O=class{constructor(R,v){this._logService=R,this._notebooksAndEditors=v,this._onDidChangeNotebookEditorSelection=new y.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new y.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(R,v){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,v);const l=this._notebooksAndEditors.getEditorById(R);v.visibleRanges&&l._acceptVisibleRanges(v.visibleRanges.ranges.map(P.NotebookRange.to)),v.selections&&l._acceptSelections(v.selections.selections.map(P.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:l.apiEditor,visibleRanges:l.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:l.apiEditor,selections:l.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const v in R)this._notebooksAndEditors.getEditorById(v)._acceptViewColumn(P.ViewColumn.to(R[v]))}};e.ExtHostNotebookEditors=O,e.ExtHostNotebookEditors=O=je([$e(0,k.ILogService)],O)}),define(De[289],Ie([1,0,4,5,122]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class O{constructor(R,v){this._extHostNotebook=v,this._rendererMessageEmitters=new Map,this.proxy=R.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,v,l){const T=this._extHostNotebook.getEditorById(R);this._rendererMessageEmitters.get(v)?.fire({editor:T.apiEditor,message:l})}createRendererMessaging(R,v){if(!R.contributes?.notebookRenderer?.some(T=>T.id===v))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${v})`);return{onDidReceiveMessage:(T,b,c)=>this.getOrCreateEmitterFor(v).event(T,b,c),postMessage:(T,b)=>{P.ExtHostNotebookEditor.apiEditorsToExtHost.has(T)&&([T,b]=[b,T]);const c=b&&P.ExtHostNotebookEditor.apiEditorsToExtHost.get(b);return this.proxy.$postMessage(c?.id,v,T)}}}getOrCreateEmitterFor(R){let v=this._rendererMessageEmitters.get(R);return v||(v=new y.Emitter({onDidRemoveLastListener:()=>{v?.dispose(),this._rendererMessageEmitters.delete(R)}}),this._rendererMessageEmitters.set(R,v),v)}}e.ExtHostNotebookRenderers=O}),define(De[290],Ie([1,0,10,77,22,72,14]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class R{constructor(b){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=b}async withProgress(b,c,C){const h=this._handles++,{title:r,location:o,cancellable:a}=c,d={label:b.displayName||b.name,id:b.identifier.value};return this._proxy.$startProgress(h,{location:y.ProgressLocation.from(o),title:r,source:d,cancellable:a},b.isUnderDevelopment?void 0:b.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(h,C,!!a)}_withProgress(b,c,C){let h;C&&(h=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(b,h));const r=a=>{this._proxy.$progressEnd(a),this._mapHandleToCancellationSource.delete(a),h?.dispose()};let o;try{o=c(new l(this._proxy,b),C&&h?h.token:P.CancellationToken.None)}catch(a){throw r(b),a}return o.then(a=>r(b),a=>r(b)),o}$acceptProgressCanceled(b){const c=this._mapHandleToCancellationSource.get(b);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(b))}}e.ExtHostProgress=R;function v(T,b){return T.message=b.message,typeof b.increment=="number"&&(typeof T.increment=="number"?T.increment+=b.increment:T.increment=b.increment),T}class l extends k.Progress{constructor(b,c){super(C=>this.throttledReport(C)),this._proxy=b,this._handle=c}throttledReport(b){this._proxy.$progressReport(this._handle,b)}}je([(0,O.throttle)(100,(T,b)=>v(T,b),()=>Object.create(null))],l.prototype,"throttledReport",null)}),define(De[291],Ie([1,0,2,5,11,10]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{static{this.handlePool=0}constructor(v,l){this.uriTransformer=l,this.providers=new Map,this.proxy=v.getProxy(k.MainContext.MainThreadQuickDiff)}$provideOriginalResource(v,l,T){const b=y.URI.revive(l),c=this.providers.get(v);return c?(0,P.asPromise)(()=>c.provideOriginalResource(b,T)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider(v,l,T,b){const c=A.handlePool++;return this.providers.set(c,l),this.proxy.$registerQuickDiffProvider(c,O.DocumentSelector.from(v,this.uriTransformer),T,b),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(c),this.providers.delete(c)}}}}e.ExtHostQuickDiff=A}),define(De[292],Ie([1,0,22,4,6,5,2,7,14,18,35,34,25,10]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=h;function h(r,o,a){const d=r.getProxy(O.MainContext.MainThreadQuickOpen);class t{constructor(_,w){this._sessions=new Map,this._instances=0,this._workspace=_,this._commands=w}showQuickPick(_,w,p,D=y.CancellationToken.None){this._onDidSelectItem=void 0;const m=Promise.resolve(w),S=++this._instances,M=d.$show(S,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},D),L={},H=M.then(()=>L);return Promise.race([H,m]).then(V=>{if(V===L)return;const $=(0,c.isProposedApiEnabled)(_,"quickPickItemTooltip");return m.then(N=>{const F=[];for(let Y=0;Y<N.length;Y++){const re=N[Y];if(typeof re=="string")F.push({label:re,handle:Y});else if(re.kind===R.QuickPickItemKind.Separator)F.push({type:"separator",label:re.label});else{re.tooltip&&!$&&console.warn(`Extension '${_.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${_.identifier.value}`);const fe=re.iconPath?f(re.iconPath):void 0;F.push({label:re.label,iconPath:fe?.iconPath,iconClass:fe?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:$?C.MarkdownString.fromStrict(re.tooltip):void 0,handle:Y})}}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=Y=>{p.onDidSelectItem(N[Y])}),d.$setItems(S,F),M.then(Y=>{if(typeof Y=="number")return N[Y];if(Array.isArray(Y))return Y.map(re=>N[re])})})}).then(void 0,V=>{if(!(0,v.isCancellationError)(V))return d.$setError(S,V),Promise.reject(V)})}$onItemSelected(_){this._onDidSelectItem?.(_)}showInput(_,w=y.CancellationToken.None){return this._validateInput=_?.validateInput,d.$input(_,typeof this._validateInput=="function",w).then(void 0,p=>{if(!(0,v.isCancellationError)(p))return Promise.reject(p)})}async $validateInput(_){if(!this._validateInput)return;const w=await this._validateInput(_);if(!w||typeof w=="string")return w;let p;switch(w.severity){case R.InputBoxValidationSeverity.Info:p=T.default.Info;break;case R.InputBoxValidationSeverity.Warning:p=T.default.Warning;break;case R.InputBoxValidationSeverity.Error:p=T.default.Error;break;default:p=w.message?T.default.Error:T.default.Ignore;break}return{content:w.message,severity:p}}async showWorkspaceFolderPick(_,w=y.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[_]);if(!p)return;const D=await this._workspace.getWorkspaceFolders2();if(D)return D.find(m=>m.uri.toString()===p.uri.toString())}createQuickPick(_){const w=new u(_,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(_){const w=new E(_,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}$onDidChangeValue(_,w){this._sessions.get(_)?._fireDidChangeValue(w)}$onDidAccept(_){this._sessions.get(_)?._fireDidAccept()}$onDidChangeActive(_,w){const p=this._sessions.get(_);p instanceof u&&p._fireDidChangeActive(w)}$onDidChangeSelection(_,w){const p=this._sessions.get(_);p instanceof u&&p._fireDidChangeSelection(w)}$onDidTriggerButton(_,w){this._sessions.get(_)?._fireDidTriggerButton(w)}$onDidTriggerItemButton(_,w,p){const D=this._sessions.get(_);D instanceof u&&D._fireDidTriggerItemButton(w,p)}$onDidHide(_){this._sessions.get(_)?._fireDidHide()}}class s{static{this._nextId=1}constructor(_,w){this._extensionId=_,this._onDidDispose=w,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(_){this._title=_,this.update({title:_})}get step(){return this._steps}set step(_){this._steps=_,this.update({step:_})}get totalSteps(){return this._totalSteps}set totalSteps(_){this._totalSteps=_,this.update({totalSteps:_})}get enabled(){return this._enabled}set enabled(_){this._enabled=_,this.update({enabled:_})}get busy(){return this._busy}set busy(_){this._busy=_,this.update({busy:_})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(_){this._ignoreFocusOut=_,this.update({ignoreFocusOut:_})}get value(){return this._value}set value(_){this._value=_,this.update({value:_})}get placeholder(){return this._placeholder}set placeholder(_){this._placeholder=_,this.update({placeholder:_})}get buttons(){return this._buttons}set buttons(_){this._buttons=_.slice(),this._handlesToButtons.clear(),_.forEach((w,p)=>{const D=w===R.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(D,w)}),this.update({buttons:_.map((w,p)=>({...f(w.iconPath),tooltip:w.tooltip,handle:w===R.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(_){this._value=_,this._onDidChangeValueEmitter.fire(_)}_fireDidTriggerButton(_){const w=this._handlesToButtons.get(_);w&&this._onDidTriggerButtonEmitter.fire(w)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(_){if(!this._disposed){for(const w of Object.keys(_)){const p=_[w];this._pendingUpdate[w]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function n(I){if(I instanceof R.ThemeIcon)return{id:I.id};const _=g(I),w=i(I);return{dark:typeof _=="string"?A.URI.file(_):_,light:typeof w=="string"?A.URI.file(w):w}}function i(I){return typeof I=="object"&&"light"in I?I.light:I}function g(I){return typeof I=="object"&&"dark"in I?I.dark:I}function f(I){const _=n(I);let w,p;return"id"in _?p=b.ThemeIcon.asClassName(_):w=_,{iconPath:w,iconClass:p}}class u extends s{constructor(_,w){super(_.identifier,w),this.extension=_,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(_){this._items=_.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),_.forEach((D,m)=>{this._handlesToItems.set(m,D),this._itemsToHandles.set(D,m)});const w=(0,c.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),p=[];for(let D=0;D<_.length;D++){const m=_[D];if(m.kind===R.QuickPickItemKind.Separator)p.push({type:"separator",label:m.label});else{m.tooltip&&!w&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const S=m.iconPath?f(m.iconPath):void 0;p.push({handle:D,label:m.label,iconPath:S?.iconPath,iconClass:S?.iconClass,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,tooltip:w?C.MarkdownString.fromStrict(m.tooltip):void 0,buttons:m.buttons?.map((M,L)=>({...f(M.iconPath),tooltip:M.tooltip,handle:L}))})}}this.update({items:p})}get canSelectMany(){return this._canSelectMany}set canSelectMany(_){this._canSelectMany=_,this.update({canSelectMany:_})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(_){this._matchOnDescription=_,this.update({matchOnDescription:_})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(_){this._matchOnDetail=_,this.update({matchOnDetail:_})}get sortByLabel(){return this._sortByLabel}set sortByLabel(_){this._sortByLabel=_,this.update({sortByLabel:_})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(_){this._keepScrollPosition=_,this.update({keepScrollPosition:_})}get activeItems(){return this._activeItems}set activeItems(_){this._activeItems=_.filter(w=>this._itemsToHandles.has(w)),this.update({activeItems:this._activeItems.map(w=>this._itemsToHandles.get(w))})}get selectedItems(){return this._selectedItems}set selectedItems(_){this._selectedItems=_.filter(w=>this._itemsToHandles.has(w)),this.update({selectedItems:this._selectedItems.map(w=>this._itemsToHandles.get(w))})}_fireDidChangeActive(_){const w=(0,l.coalesce)(_.map(p=>this._handlesToItems.get(p)));this._activeItems=w,this._onDidChangeActiveEmitter.fire(w)}_fireDidChangeSelection(_){const w=(0,l.coalesce)(_.map(p=>this._handlesToItems.get(p)));this._selectedItems=w,this._onDidChangeSelectionEmitter.fire(w)}_fireDidTriggerItemButton(_,w){const p=this._handlesToItems.get(_);if(!p||!p.buttons||!p.buttons.length)return;const D=p.buttons[w];D&&this._onDidTriggerItemButtonEmitter.fire({button:D,item:p})}}class E extends s{constructor(_,w){super(_.identifier,w),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(_){this._password=_,this.update({password:_})}get prompt(){return this._prompt}set prompt(_){this._prompt=_,this.update({prompt:_})}get valueSelection(){return this._valueSelection}set valueSelection(_){this._valueSelection=_,this.update({valueSelection:_})}get validationMessage(){return this._validationMessage}set validationMessage(_){this._validationMessage=_,_?typeof _=="string"?this.update({validationMessage:_,severity:T.default.Error}):this.update({validationMessage:_.message,severity:_.severity??T.default.Error}):this.update({validationMessage:void 0,severity:T.default.Ignore})}}return new t(o,a)}}),define(De[293],Ie([1,0,2,4,72,6,11,5,18,158,12,19,37,34,10,25,16,21]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function t(M){return M instanceof y.URI}function s(M,L){return M.scheme===o.Schemas.file&&L.scheme===o.Schemas.file&&a.isLinux?M.toString()===L.toString():M.toString().toLowerCase()===L.toString().toLowerCase()}function n(M){if(M)return typeof M.iconPath=="string"?y.URI.file(M.iconPath):y.URI.isUri(M.iconPath)||C.ThemeIcon.isThemeIcon(M.iconPath)?M.iconPath:void 0}function i(M){if(M.icon){if(y.URI.isUri(M.icon))return M.icon;if(C.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const L=M.icon;return{light:L.light,dark:L.dark}}}else return}function g(M,L){if(!M.iconPath&&!L.iconPath)return 0;if(M.iconPath){if(!L.iconPath)return 1}else return-1;const H=typeof M.iconPath=="string"?M.iconPath:y.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id,V=typeof L.iconPath=="string"?L.iconPath:y.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,l.comparePaths)(H,V)}function f(M,L){let H=0;if(M.strikeThrough!==L.strikeThrough)return M.strikeThrough?1:-1;if(M.faded!==L.faded)return M.faded?1:-1;if(M.tooltip!==L.tooltip)return(M.tooltip||"").localeCompare(L.tooltip||"");if(H=g(M,L),H!==0)return H;if(M.light&&L.light)H=g(M.light,L.light);else{if(M.light)return 1;if(L.light)return-1}if(H!==0)return H;if(M.dark&&L.dark)H=g(M.dark,L.dark);else{if(M.dark)return 1;if(L.dark)return-1}return H}function u(M,L){if(M.command!==L.command)return M.command<L.command?-1:1;if(M.title!==L.title)return M.title<L.title?-1:1;if(M.tooltip!==L.tooltip){if(M.tooltip!==void 0&&L.tooltip!==void 0)return M.tooltip<L.tooltip?-1:1;if(M.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(M.arguments===L.arguments)return 0;if(M.arguments)if(L.arguments){if(M.arguments.length!==L.arguments.length)return M.arguments.length-L.arguments.length}else return 1;else return-1;for(let H=0;H<M.arguments.length;H++){const V=M.arguments[H],$=L.arguments[H];if(V!==$&&!(t(V)&&t($)&&s(V,$)))return V<$?-1:1}return 0}function E(M,L){let H=(0,l.comparePaths)(M.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(H!==0)return H;if(M.command&&L.command)H=u(M.command,L.command);else{if(M.command)return 1;if(L.command)return-1}if(H!==0)return H;if(M.decorations&&L.decorations)H=f(M.decorations,L.decorations);else{if(M.decorations)return 1;if(L.decorations)return-1}if(M.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)H=(0,l.comparePaths)(M.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(M.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(M.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)H=(0,l.comparePaths)(M.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(M.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return H}function I(M,L){for(let H=0;H<M.length;H++)if(M[H]!==L[H])return!1;return!0}function _(M,L){return M.command===L.command&&M.title===L.title&&M.tooltip===L.tooltip&&(M.arguments&&L.arguments?I(M.arguments,L.arguments):M.arguments===L.arguments)}function w(M,L){return(0,v.equals)(M,L,_)}class p{#e;#t;get value(){return this._value}set value(L){L=L??"",this._sequencer.queue(async()=>this.#e.$setInputBoxValue(this._sourceControlHandle,L)),this.updateValue(L)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(L){this._sequencer.queue(async()=>this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,L)),this._placeholder=L}get validateInput(){return(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(L){if((0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=L,this._sequencer.queue(async()=>this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!L))}get enabled(){return this._enabled}set enabled(L){L=!!L,this._enabled!==L&&(this._enabled=L,this._sequencer.queue(async()=>this.#e.$setInputBoxEnablement(this._sourceControlHandle,L)))}get visible(){return this._visible}set visible(L){L=!!L,this._visible!==L&&(this._visible=L,this._sequencer.queue(async()=>this.#e.$setInputBoxVisibility(this._sourceControlHandle,L)))}get document(){return(0,r.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(L,H,V,$,N,F){this._extension=L,this._sequencer=$,this._sourceControlHandle=N,this._documentUri=F,this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=H,this.#e=V}showValidationMessage(L,H){(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),this._sequencer.queue(async()=>this.#e.$showValidationMessage(this._sourceControlHandle,L,H))}$onInputBoxValueChange(L){this.updateValue(L)}updateValue(L){this._value=L,this._onDidChange.fire(L)}}e.ExtHostSCMInputBox=p;class D{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(L){this._label=L,this._sequencer.queue(async()=>this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,L))}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(L){this._hideWhenEmpty=L,this._sequencer.queue(async()=>this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features))}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(L){this._resourceStates=[...L],this._onDidUpdateResourceStates.fire()}constructor(L,H,V,$,N,F,Y,re){this._proxy=L,this._commands=H,this._sequencer=V,this._sourceControlHandle=$,this._id=N,this._label=F,this.multiDiffEditorEnableViewChanges=Y,this._extension=re,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=D._handlePool++}getResourceState(L){return this._resourceStatesMap.get(L)}$executeResourceCommand(L,H){const V=this._resourceStatesCommandsMap.get(L);return V?(0,A.asPromise)(()=>this._commands.executeCommand(V.command,...V.arguments||[],H)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this._resourceStates].sort(E),V=(0,v.sortedDiff)(this._resourceSnapshot,L,E).map(F=>{const Y=F.toInsert.map(re=>{const fe=this._resourceHandlePool++;this._resourceStatesMap.set(fe,re);const Ee=re.resourceUri;let oe;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const X=new O.DisposableStore;oe=this._commands.converter.toInternal(re.command,X),this._resourceStatesDisposablesMap.set(fe,X)}else this._resourceStatesCommandsMap.set(fe,re.command);const pe=(0,r.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),ve=pe?re.multiDiffEditorOriginalUri:void 0,se=pe?re.multiFileDiffEditorModifiedUri:void 0,Te=n(re.decorations),Me=re.decorations&&n(re.decorations.light)||Te,Q=re.decorations&&n(re.decorations.dark)||Te,W=[Me,Q],ie=re.decorations&&re.decorations.tooltip||"",_e=re.decorations&&!!re.decorations.strikeThrough,de=re.decorations&&!!re.decorations.faded,Se=re.contextValue||"";return{rawResource:[fe,Ee,W,ie,_e,de,Se,oe,ve,se],handle:fe}});return{start:F.start,deleteCount:F.deleteCount,toInsert:Y}}),$=V.map(({start:F,deleteCount:Y,toInsert:re})=>[F,Y,re.map(fe=>fe.rawResource)]),N=V.reverse();for(const{start:F,deleteCount:Y,toInsert:re}of N){const fe=re.map(oe=>oe.handle),Ee=this._handlesSnapshot.splice(F,Y,...fe);for(const oe of Ee)this._resourceStatesMap.delete(oe),this._resourceStatesCommandsMap.delete(oe),this._resourceStatesDisposablesMap.get(oe)?.dispose(),this._resourceStatesDisposablesMap.delete(oe)}return this._resourceSnapshot=L,$}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class m{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(L){this._count!==L&&(this._count=L,this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{count:L})))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(L){this._quickDiffProvider=L;let H;(0,r.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(H=L?.label),this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!L,quickDiffLabel:H}))}get historyProvider(){return(0,r.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(L){(0,r.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=L,this._historyProviderDisposable.value=new O.DisposableStore,this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!L})),L&&this._historyProviderDisposable.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=L?.currentHistoryItemGroup,this._sequencer.queue(async()=>this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup))}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(L){L!==this._commitTemplate&&(this._commitTemplate=L,this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{commitTemplate:L})))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(L){this._acceptInputDisposables.value=new O.DisposableStore,this._acceptInputCommand=L;const H=this._commands.converter.toInternal(L,this._acceptInputDisposables.value);this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{acceptInputCommand:H}))}get actionButton(){return(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(L){(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new O.DisposableStore,this._actionButton=L;const H=L!==void 0?{command:this._commands.converter.toInternal(L.command,this._actionButtonDisposables.value),secondaryCommands:L.secondaryCommands?.map(V=>V.map($=>this._commands.converter.toInternal($,this._actionButtonDisposables.value))),description:L.description,enabled:L.enabled}:void 0;this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{actionButton:H??null}))}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(L){if(this._statusBarCommands&&L&&w(this._statusBarCommands,L))return;this._statusBarDisposables.value=new O.DisposableStore,this._statusBarCommands=L;const H=(L||[]).map(V=>this._commands.converter.toInternal(V,this._statusBarDisposables.value));this._sequencer.queue(async()=>this.#e.$updateSourceControl(this.handle,{statusBarCommands:H}))}get selected(){return this._selected}constructor(L,H,V,$,N,F,Y){this._extension=L,this._commands=$,this._id=N,this._label=F,this._rootUri=Y,this._sequencer=new A.Sequencer,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new O.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new O.MutableDisposable,this._statusBarDisposables=new O.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=m._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=V;const re=y.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${N}/scm${this.handle}/input`,query:Y?`rootUri=${encodeURIComponent(Y.toString())}`:void 0});this._sequencer.queue(()=>this.#e.$registerSourceControl(this.handle,N,F,Y,re)),this._inputBox=new p(L,H,this.#e,this._sequencer,this.handle,re)}createResourceGroup(L,H,V){const $=(0,r.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,N=new D(this.#e,this._commands,this._sequencer,this.handle,L,H,$,this._extension),F=k.Event.once(N.onDidDispose)(()=>this.createdResourceGroups.delete(N));return this.createdResourceGroups.set(N,F),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const L=[],H=[];for(const[V,$]of this.createdResourceGroups){$.dispose();const N=V.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(V),this.eventuallyUpdateResourceStates()});k.Event.once(V.onDidDispose)(()=>{this.updatedResourceGroups.delete(V),N.dispose(),this._groups.delete(V.handle),this._sequencer.queue(async()=>this.#e.$unregisterGroup(this.handle,V.handle))}),L.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const F=V._takeResourceStateSnapshot();F.length>0&&H.push([V.handle,F]),this._groups.set(V.handle,V)}this._sequencer.queue(async()=>this.#e.$registerGroups(this.handle,L,H)),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const L=[];this.updatedResourceGroups.forEach(H=>{const V=H._takeResourceStateSnapshot();V.length!==0&&L.push([H.handle,V])}),L.length>0&&this._sequencer.queue(async()=>this.#e.$spliceResourceStates(this.handle,L)),this.updatedResourceGroups.clear()}getResourceGroup(L){return this._groups.get(L)}setSelectionState(L){this._selected=L,this._onDidChangeSelection.fire(L)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(L=>L.dispose()),this._sequencer.queue(async()=>this.#e.$unregisterSourceControl(this.handle))}}je([(0,P.debounce)(100)],m.prototype,"eventuallyAddResourceGroups",null),je([(0,P.debounce)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let S=class{static{d=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(L,H,V,$){this._commands=H,this._extHostDocuments=V,this.logService=$,this._sourceControls=new Map,this._sourceControlsByExtension=new b.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=L.getProxy(R.MainContext.MainThreadSCM),this._telemetry=L.getProxy(R.MainContext.MainThreadTelemetry),H.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===c.MarshalledId.ScmResource){const F=this._sourceControls.get(N.sourceControlHandle);if(!F)return N;const Y=F.getResourceGroup(N.groupHandle);return Y?Y.getResourceState(N.handle):N}else if(N&&N.$mid===c.MarshalledId.ScmResourceGroup){const F=this._sourceControls.get(N.sourceControlHandle);return F?F.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===c.MarshalledId.ScmProvider){const F=this._sourceControls.get(N.handle);return F||N}return N}})}createSourceControl(L,H,V,$){this.logService.trace("ExtHostSCM#createSourceControl",L.identifier.value,H,V,$),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const N=d._handlePool++,F=new m(L,this._extHostDocuments,this._proxy,this._commands,H,V,$);this._sourceControls.set(N,F);const Y=this._sourceControlsByExtension.get(L.identifier)||[];return Y.push(F),this._sourceControlsByExtension.set(L.identifier,Y),F}getLastInputBox(L){this.logService.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const H=this._sourceControlsByExtension.get(L.identifier),V=H&&H[H.length-1];return V&&V.inputBox}$provideOriginalResource(L,H,V){const $=y.URI.revive(H);this.logService.trace("ExtHostSCM#$provideOriginalResource",L,$.toString());const N=this._sourceControls.get(L);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>N.quickDiffProvider.provideOriginalResource($,V)).then(F=>F||null)}$onInputBoxValueChange(L,H){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",L);const V=this._sourceControls.get(L);return V&&V.inputBox.$onInputBoxValueChange(H),Promise.resolve(void 0)}$executeResourceCommand(L,H,V,$){this.logService.trace("ExtHostSCM#$executeResourceCommand",L,H,V);const N=this._sourceControls.get(L);if(!N)return Promise.resolve(void 0);const F=N.getResourceGroup(H);return F?F.$executeResourceCommand(V,$):Promise.resolve(void 0)}$validateInput(L,H,V){this.logService.trace("ExtHostSCM#$validateInput",L);const $=this._sourceControls.get(L);return!$||!$.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>$.inputBox.validateInput(H,V)).then(N=>{if(!N)return Promise.resolve(void 0);const F=h.MarkdownString.fromStrict(N.message);return F?Promise.resolve([F,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this._sourceControls.get(L)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,H,V,$){return await this._sourceControls.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(H,V,$)??void 0}async $provideHistoryItems(L,H,V,$){return(await this._sourceControls.get(L)?.historyProvider?.provideHistoryItems(H,V,$))?.map(Y=>({...Y,icon:i(Y)}))??void 0}async $provideHistoryItemSummary(L,H,V,$){const N=this._sourceControls.get(L)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const F=await N.provideHistoryItemSummary(H,V,$);return F?{...F,icon:i(F)}:void 0}async $provideHistoryItemChanges(L,H,V,$){return await this._sourceControls.get(L)?.historyProvider?.provideHistoryItemChanges(H,V,$)??void 0}};e.ExtHostSCM=S,e.ExtHostSCM=S=d=je([$e(3,T.ILogService)],S)}),define(De[294],Ie([1,0,5,10,2]),function(he,e,y,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class O{static{this.handlePool=0}constructor(R,v){this.uriTransformer=v,this.providers=new Map,this.proxy=R.getProxy(y.MainContext.MainThreadShare)}async $provideShare(R,v,l){return await this.providers.get(R)?.provideShare({selection:k.Range.to(v.selection),resourceUri:P.URI.revive(v.resourceUri)},l)??void 0}registerShareProvider(R,v){const l=O.handlePool++;return this.providers.set(l,v),this.proxy.$registerShareProvider(l,k.DocumentSelector.from(R,this.uriTransformer),v.id,v.label,v.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(l),this.providers.delete(l)}}}}e.ExtHostShare=O}),define(De[295],Ie([1,0,7,5,185,6,10,15]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class v{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new y.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(c,C,h,r,o,a=y.StatusBarAlignment.Left,d){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new O.DisposableStore,this.#e=c,this.#t=C,o&&r){this._entryId=(0,y.asStatusBarItemIdentifier)(r.identifier,o);const t=h.get(this._entryId);t&&(a=t.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,d=t.priority,this._visible=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this._entryId=String(v.ID_GEN++);this._extension=r,this._id=o,this._alignment=a,this._priority=this.validatePriority(d)}validatePriority(c){if((0,R.isNumber)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(c){this._text=c,this.update()}set name(c){this._name=c,this.update()}set tooltip(c){this._tooltip=c,this.update()}set color(c){this._color=c,this.update()}set backgroundColor(c){c&&!v.ALLOWED_BACKGROUND_COLORS.has(c.id)&&(c=void 0),this._backgroundColor=c,this.update()}set command(c){this._command?.fromApi!==c&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new O.DisposableStore,typeof c=="string"?this._command={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this._latestCommandRegistration)}:c?this._command={fromApi:c,internal:this.#t.toInternal(c,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(c){this._accessibilityInformation=c,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let C;this._name?C=this._name:C=(0,P.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=v.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const r=A.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,c,this._extension?.identifier.value,C,this._text,r,this._command?.internal,h,this._backgroundColor,this._alignment===y.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=v;class l{constructor(c){this._messages=[],this._item=c.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,P.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(c){const C={message:c};return this._messages.unshift(C),this._update(),new y.Disposable(()=>{const h=this._messages.indexOf(C);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(c,C){this._existingItems=new Map,this._proxy=c.getProxy(k.MainContext.MainThreadStatusBar),this._commands=C,this._statusMessage=new l(this)}$acceptStaticEntries(c){for(const C of c)this._existingItems.set(C.entryId,C)}createStatusBarEntry(c,C,h,r){return new v(this._proxy,this._commands,this._existingItems,c,C,h,r)}setStatusBarMessage(c,C){const h=this._statusMessage.setMessage(c);let r;return typeof C=="number"?r=setTimeout(()=>h.dispose(),C):typeof C<"u"&&C.then(()=>h.dispose(),()=>h.dispose()),new y.Disposable(()=>{h.dispose(),clearTimeout(r)})}}e.ExtHostStatusBar=T}),define(De[123],Ie([1,0,33,114,55,82,56,10,2]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const l=(t,s,n,i)=>{let g=s;return{enumerable:!0,configurable:!1,get(){return g},set(f){if(!n(g,f)){const u=g;g=f,t.listener?.(i(f,u))}}}},T=(t,s)=>t===s,b={range:(t,s)=>t===s?!0:!t||!s?!1:t.isEqual(s),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(t,s)=>!(t.length!==s.length||t.some(n=>!s.find(i=>n.id===i.id)))},c=t=>s=>({op:O.TestItemEventOp.SetProp,update:t(s)}),C=(t,s)=>({range:(()=>{let n;const i=c(g=>({range:y.Range.lift(R.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return n},set(g){t.listener?.({op:O.TestItemEventOp.DocumentSynced}),b.range(n,g)||(n=g,t.listener?.(i(g)))}}})(),label:l(t,s,b.label,c(n=>({label:n}))),description:l(t,void 0,b.description,c(n=>({description:n}))),sortText:l(t,void 0,b.sortText,c(n=>({sortText:n}))),canResolveChildren:l(t,!1,b.canResolveChildren,n=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:n})),busy:l(t,!1,b.busy,c(n=>({busy:n}))),error:l(t,void 0,b.error,c(n=>({error:R.MarkdownString.fromStrict(n)||null}))),tags:l(t,[],b.tags,(n,i)=>({op:O.TestItemEventOp.SetTags,new:n.map(R.TestTag.from),old:i.map(R.TestTag.from)}))}),h=t=>{const s=P.TestId.fromString(t.extId),n=new o(s.controllerId,s.localId,t.label,v.URI.revive(t.uri)||void 0);return n.range=R.Range.to(t.range||void 0),n.description=t.description||void 0,n.sortText=t.sortText||void 0,n.tags=t.tags.map(i=>R.TestTag.to({id:(0,A.denamespaceTestTag)(i).tagId})),n},r=t=>{let s;for(const n of t.tests){const i=h(n.item);(0,k.getPrivateApiFor)(i).parent=s,s=i}return s};e.toItemFromContext=r;class o{constructor(s,n,i,g){if(n.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(n)} symbol`);const f=(0,k.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:n,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof a?void 0:f.parent}},children:{value:(0,O.createTestItemChildren)(f,k.getPrivateApiFor,o),enumerable:!0,writable:!1},...C(f,i)})}}e.TestItemImpl=o;class a extends o{constructor(s,n){super(s,s,n,void 0),this._isRoot=!0}}e.TestItemRootImpl=a;class d extends O.TestItemCollection{constructor(s,n,i){super({controllerId:s,getDocumentVersion:g=>g&&i.getDocument(g)?.version,getApiFor:k.getPrivateApiFor,getChildren:g=>g.children,root:new a(s,n),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=d}),define(De[39],Ie([1,0,15,7,10,26,5,18,12,49,33,100,2,6,3,17,123,23,38,48,69,63,66,36]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s,n,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{#e;#t;#i;constructor(p,D,m){this._commands=new Map,this._apiCommands=new Map,this.#e=p.getProxy(A.MainContext.MainThreadCommands),this._logService=D,this.#i=m,this.#t=p.getProxy(A.MainContext.MainThreadTelemetry),this.converter=new u(this,S=>{const M=this._apiCommands.get(S);return M?.result===I.Void?M:void 0},D),this._argumentProcessors=[{processArgument(S){return(0,l.revive)(S)}},{processArgument(S){return(0,O.cloneAndChange)(S,function(M){if(T.Range.isIRange(M))return P.Range.to(M);if(b.Position.isIPosition(M))return P.Position.to(M);if(T.Range.isIRange(M.range)&&c.URI.isUri(M.uri))return P.location.to(M);if(M instanceof a.VSBuffer)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(p){this._argumentProcessors.push(p)}registerApiCommand(p){const D=this.registerCommand(!1,p.id,async(...m)=>{const S=p.args.map((L,H)=>{if(!L.validate(m[H]))throw new Error(`Invalid argument '${L.name}' when running '${p.id}', received: ${typeof m[H]=="object"?JSON.stringify(m[H],null,"	"):m[H]} `);return L.convert(m[H])}),M=await this.executeCommand(p.internalId,...S);return p.result.convert(M,m,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this._apiCommands.set(p.id,p),new k.Disposable(()=>{D.dispose(),this._apiCommands.delete(p.id)})}registerCommand(p,D,m,S,M,L){if(this._logService.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this._commands.has(D))throw new Error(`command '${D}' already exists`);return this._commands.set(D,{callback:m,thisArg:S,metadata:M,extension:L}),p&&this.#e.$registerCommand(D),new k.Disposable(()=>{this._commands.delete(D)&&p&&this.#e.$unregisterCommand(D)})}executeCommand(p,...D){return this._logService.trace("ExtHostCommands#executeCommand",p),this._doExecuteCommand(p,D,!0)}async _doExecuteCommand(p,D,m){if(this._commands.has(p))return this.#e.$fireCommandActivationEvent(p),this._executeContributedCommand(p,D,!1);{let S=!1;const M=(0,O.cloneAndChange)(D,function(L){if(L instanceof k.Position)return P.Position.from(L);if(L instanceof k.Range)return P.Range.from(L);if(L instanceof k.Location)return P.location.from(L);if(k.NotebookRange.isNotebookRange(L))return P.NotebookRange.from(L);if(L instanceof ArrayBuffer)return S=!0,a.VSBuffer.wrap(new Uint8Array(L));if(L instanceof Uint8Array)return S=!0,a.VSBuffer.wrap(L);if(L instanceof a.VSBuffer)return S=!0,L;if(!Array.isArray(L))return L});try{const L=await this.#e.$executeCommand(p,S?new d.SerializableObjectWithBuffers(M):M,m);return(0,l.revive)(L)}catch(L){if(L instanceof Error&&L.message==="$executeCommand:retry")return this._doExecuteCommand(p,D,!1);throw L}}}async _executeContributedCommand(p,D,m){const S=this._commands.get(p);if(!S)throw new Error("Unknown command");const{callback:M,thisArg:L,metadata:H}=S;if(H?.args)for(let $=0;$<H.args.length;$++)try{(0,y.validateConstraint)(D[$],H.args[$].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${H.args[$].name}' - ${H.args[$].description}`)}const V=s.StopWatch.create();try{return await M.apply(L,D)}catch($){if(p===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...D);N&&(p=N.command)}if(this._logService.error($,p,S.extension?.identifier),!m)throw $;if(S.extension?.identifier){const N=this.#i.onExtensionError(S.extension.identifier,$);this._logService.trace("forwarded error to extension?",N,S.extension?.identifier)}throw new class extends Error{constructor(){super((0,t.toErrorMessage)($)),this.id=p,this.source=S.extension?.displayName??S.extension?.name}}}finally{this._reportTelemetry(S,p,V.elapsed())}}_reportTelemetry(p,D,m){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new n.TelemetryTrustedValue(D),duration:m})}$executeContributedCommand(p,...D){this._logService.trace("ExtHostCommands#$executeContributedCommand",p);const m=this._commands.get(p);return m?(D=D.map(S=>this._argumentProcessors.reduce((M,L)=>L.processArgument(M,m.extension?.identifier),S)),this._executeContributedCommand(p,D,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this._logService.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(D=>(p&&(D=D.filter(m=>m[0]!=="_")),D))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[D,m]of this._commands){const{metadata:S}=m;S&&(p[D]=S)}return Promise.resolve(p)}};e.ExtHostCommands=f,e.ExtHostCommands=f=je([$e(0,r.IExtHostRpcService),$e(1,v.ILogService),$e(2,i.IExtHostTelemetry)],f),e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class u{constructor(p,D,m){this._commands=p,this._lookupApiCommand=D,this._logService=m,this.delegatingCommandId=`__vsc${(0,g.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(p,D){if(!p)return;const m={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return m;const S=this._lookupApiCommand(p.command);if(S)m.id=S.internalId,m.arguments=S.args.map((M,L)=>M.convert(p.arguments&&p.arguments[L]));else if((0,R.isNonEmptyArray)(p.arguments)){const M=`${p.command} /${++this._cachIdPool}`;this._cache.set(M,p),D.add((0,C.toDisposable)(()=>{this._cache.delete(M),this._logService.trace("CommandsConverter#DISPOSE",M)})),m.$ident=M,m.id=this.delegatingCommandId,m.arguments=[M],this._logService.trace("CommandsConverter#CREATE",p.command,M)}return m}fromInternal(p){return typeof p.$ident=="string"?this._cache.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this._cache.get(p[0])}_executeConvertedCommand(...p){const D=this.getActualCommand(...p);return this._logService.trace("CommandsConverter#EXECUTE",p[0],D?D.command:"MISSING"),D?this._commands.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.CommandsConverter=u;class E{static{this.Uri=new E("uri","Uri of a text document",p=>c.URI.isUri(p),p=>p)}static{this.Position=new E("position","A position in a text document",p=>k.Position.isPosition(p),P.Position.from)}static{this.Range=new E("range","A range in a text document",p=>k.Range.isRange(p),P.Range.from)}static{this.Selection=new E("selection","A selection in a text document",p=>k.Selection.isSelection(p),P.Selection.from)}static{this.Number=new E("number","",p=>typeof p=="number",p=>p)}static{this.String=new E("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=E.Arr(E.String)}static Arr(p){return new E(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,D=>Array.isArray(D)&&D.every(m=>p.validate(m)),D=>D.map(m=>p.convert(m)))}static{this.CallHierarchyItem=new E("item","A call hierarchy item",p=>p instanceof k.CallHierarchyItem,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new E("item","A type hierarchy item",p=>p instanceof k.TypeHierarchyItem,P.TypeHierarchyItem.from)}static{this.TestItem=new E("testItem","A VSCodium TestItem",p=>p instanceof o.TestItemImpl,P.TestItem.from)}constructor(p,D,m,S){this.name=p,this.description=D,this.validate=m,this.convert=S}optional(){return new E(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,D){return new E(p??this.name,D??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E;class I{static{this.Void=new I("no result",p=>p)}constructor(p,D){this.description=p,this.convert=D}}e.ApiCommandResult=I;class _{constructor(p,D,m,S,M){this.id=p,this.internalId=D,this.description=m,this.args=S,this.result=M}}e.ApiCommand=_}),define(De[296],Ie([1,0,18,16,2,94,103,32,39,10,7]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new v.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(l.DocumentHighlight.to))),new v.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,y.isFalsyOrEmpty)(r))return;class a extends T.SymbolInformation{static to(t){const s=new a(t.name,l.SymbolKind.to(t.kind),t.containerName||"",new T.Location(o[0],l.Range.to(t.range)));return s.detail=t.detail,s.range=s.location.range,s.selectionRange=l.Range.to(t.selectionRange),s.children=t.children?t.children.map(a.to):[],s}}return r.map(a.to)})),new v.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(l.TextEdit.to))),new v.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(l.TextEdit.to))),new v.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,new v.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new v.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(l.TextEdit.to))),new v.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new v.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new v.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new v.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new v.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(l.location.to))),new v.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(l.Hover.to))),new v.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>T.Position.isPosition(o)),r=>r.map(l.Position.from))],new v.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(o=>{let a;for(const d of o.reverse())a=new T.SelectionRange(l.Range.to(d),a);return a}))),new v.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.ApiCommandArgument.String.with("query","Search string")],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(l.WorkspaceSymbol.to))),new v.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(l.CallHierarchyItem.to))),new v.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(l.CallHierarchyIncomingCall.to))),new v.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(l.CallHierarchyOutgoingCall.to))),new v.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:l.Range.to(r.range),placeholder:r.text}})),new v.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("newName","The new symbol name")],new v.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return l.WorkspaceEdit.to(r)}})),new v.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(l.DocumentLink.to))),new v.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.decodeSemanticTokensDto)(r);if(o.type==="full")return new T.SemanticTokens(o.data,void 0)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range.optional()],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.decodeSemanticTokensDto)(r);if(o.type==="full")return new T.SemanticTokens(o.data,void 0)})),new v.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,o,a)=>{if(!r)return new T.CompletionList([]);const d=r.suggestions.map(t=>l.CompletionItem.to(t,a));return new T.CompletionList(d,r.incomplete)})),new v.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return l.SignatureHelp.to(r)})),new v.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,o,a)=>C(d=>new T.CodeLens(l.Range.to(d.range),d.command&&a.fromInternal(d.command)))(r))),new v.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>T.Range.isRange(r),r=>T.Selection.isSelection(r)?l.Selection.from(r):l.Range.from(r)),v.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,o,a)=>C(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(d.command)}else{const t=new T.CodeAction(d.title,d.kind?new T.CodeActionKind(d.kind):void 0);return d.edit&&(t.edit=l.WorkspaceEdit.to(d.edit)),d.command&&(t.command=a.fromInternal(d.command)),t.isPreferred=d.isPreferred,t}})(r))),new v.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new T.ColorInformation(l.Range.to(o.range),l.Color.to(o.color))):[])),new v.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.ApiCommandArgument("color","The color to show and insert",r=>r instanceof T.Color,l.Color.from),new v.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:l.Range.from(r.range)}))],new v.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(l.ColorPresentation.to):[])),new v.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of Inlay objects",(r,o,a)=>r.map(l.InlayHint.to.bind(void 0,a)))),new v.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(l.FoldingRange.to)})),new v.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>l.NotebookExclusiveDocumentPattern.to(o))})))),new v.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof T.Range,r=>l.InlineValueContext.from(r))],new v.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(l.InlineValue.to))),new v.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,k.matchesSomeScheme)(r,k.Schemas.http,k.Schemas.https),r=>r),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[l.ViewColumn.from(r),void 0]:[l.ViewColumn.from(r.viewColumn),l.TextEditorOpenOptions.from(r)])).optional(),v.ApiCommandArgument.String.with("label","").optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.ApiCommandArgument.Uri.with("resource","Resource to open"),v.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[l.ViewColumn.from(r),void 0]:[l.ViewColumn.from(r.viewColumn),l.TextEditorOpenOptions.from(r)])).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),v.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),v.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[l.ViewColumn.from(r.viewColumn),l.TextEditorOpenOptions.from(r)]).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[v.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new v.ApiCommandArgument("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[a,d,t]=o;if(!P.URI.isUri(a)||!P.URI.isUri(d)&&d!==void 0&&d!==null||!P.URI.isUri(t)&&t!==void 0&&t!==null)return!1}return!0},r=>r)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.ApiCommandArgument.TestItem],v.ApiCommandResult.Void),new v.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.ApiCommandResult.Void),new v.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.ApiCommandArgument.String.with("name","The context key name"),new v.ApiCommandArgument("value","The context key value",()=>!0,r=>r)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.StringArray,new v.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",r=>l.MappedEditsContext.is(r),r=>l.MappedEditsContext.from(r))],new v.ApiCommandResult("A promise that resolves to a workspace edit or null",r=>r?l.WorkspaceEdit.to(r):null)),new v.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new v.ApiCommandArgument("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?l.Range.from(r.initialRange):void 0,initialSelection:T.Selection.isSelection(r.initialSelection)?l.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?l.Position.from(r.position):void 0}})],v.ApiCommandResult.Void)];class c{static register(o){b.forEach(o.registerApiCommand,o),this._registerValidateWhenClausesCommand(o)}static _registerValidateWhenClausesCommand(o){o.registerCommand(!1,"_validateWhenClauses",R.validateWhenClauses)}}e.ExtHostApiCommands=c;function C(r){return o=>{if(Array.isArray(o))return o.map(r)}}function h(r){if(!Array.isArray(r))return;const o=[];for(const a of r)O.isLocationLink(a)?o.push(l.DefinitionLink.to(a)):o.push(l.location.to(a));return o}}),define(De[297],Ie([1,0,2,39]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class P{constructor(A,R,v,l,T){this._extHostNotebooks=R,this._textDocumentsAndEditors=v,this._commands=l;const b=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",c=>!0,c=>c),new k.ApiCommandArgument("resource","Interactive resource Uri",c=>!0,c=>c),new k.ApiCommandArgument("controllerId","Notebook controller Id",c=>!0,c=>c),new k.ApiCommandArgument("title","Interactive editor title",c=>!0,c=>c)],new k.ApiCommandResult("Notebook and input URI",c=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const C=this._extHostNotebooks.getEditorById(c.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:y.URI.revive(c.notebookUri),inputUri:y.URI.revive(c.inputUri),notebookEditor:C.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:y.URI.revive(c.notebookUri),inputUri:y.URI.revive(c.inputUri)}}));this._commands.registerApiCommand(b)}$willAddInteractiveDocument(A,R,v,l){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:v,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=P}),define(De[298],Ie([1,0,18,11,22,4,6,29,2,19,12,5,39,10,7,83,237,25,38,238]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=E;let s=class{constructor(_,w,p,D,m){this._initData=w,this._extHostNotebook=p,this._commands=D,this._logService=m,this._activeExecutions=new R.ResourceMap,this._activeNotebookExecutions=new R.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new O.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=_.getProxy(b.MainContext.MainThreadNotebookKernels);const S=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const H=this._extHostNotebook.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:H}}else if(L&&"notebookEditor"in L){const H=this._extHostNotebook.getIdByEditor(L.notebookEditor);if(H===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:H}}return L})],c.ApiCommandResult.Void),M=new c.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[c.ApiCommandArgument.Uri],new c.ApiCommandResult("A promise that resolves to an array of variables",(L,H)=>L.map(V=>({variable:{name:V.name,value:V.value,expression:V.expression,type:V.type,language:V.language},hasNamedChildren:V.hasNamedChildren,indexedChildrenCount:V.indexedChildrenCount}))));this._commands.registerApiCommand(S),this._commands.registerApiCommand(M)}createNotebookController(_,w,p,D,m,S){for(const se of this._kernelData.values())if(se.controller.id===w&&l.ExtensionIdentifier.equals(_.identifier,se.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const M=this._handlePool++,L=this;this._logService.trace(`NotebookController[${M}], CREATED by ${_.identifier.value}, ${w}`);const H=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${_.identifier}'`);let V=!1;const $=new O.Emitter,N=new O.Emitter,F={id:E(_.identifier,w),notebookType:p,extensionId:_.identifier,extensionLocation:_.extensionLocation,label:D||_.identifier.value,preloads:S?S.map(C.NotebookRendererScript.from):[]};let Y=m??H,re,fe;this._proxy.$addKernel(M,F).catch(se=>{console.log(se),V=!0});let Ee=0;const oe=()=>{if(V)return;const se=++Ee;Promise.resolve().then(()=>{se===Ee&&this._proxy.$updateKernel(M,F)})},pe=new R.ResourceMap,ve={get id(){return w},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return F.label},set label(se){F.label=se??_.displayName??_.name,oe()},get detail(){return F.detail??""},set detail(se){F.detail=se,oe()},get description(){return F.description??""},set description(se){F.description=se,oe()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(se){F.supportedLanguages=se,oe()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(se){F.supportsExecutionOrder=se,oe()},get rendererScripts(){return F.preloads?F.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(se){Y=se??H},get interruptHandler(){return re},set interruptHandler(se){re=se,F.supportsInterrupt=!!se,oe()},set variableProvider(se){(0,a.checkProposedApiEnabled)(_,"notebookVariableProvider"),fe=se,F.hasVariableProvider=!!se,se?.onDidChangeVariables(Te=>L._proxy.$variablesUpdated(Te.uri)),oe()},get variableProvider(){return fe},createNotebookCellExecution(se){if(V)throw new Error("notebook controller is DISPOSED");if(!pe.has(se.notebook.uri))throw L._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Te=>Te.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return L._createNotebookCellExecution(se,E(_.identifier,this.id))},createNotebookExecution(se){if((0,a.checkProposedApiEnabled)(_,"notebookExecution"),V)throw new Error("notebook controller is DISPOSED");if(!pe.has(se.uri))throw L._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Te=>Te.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return L._createNotebookExecution(se,E(_.identifier,this.id))},dispose:()=>{V||(this._logService.trace(`NotebookController[${M}], DISPOSED`),V=!0,this._kernelData.delete(M),$.dispose(),N.dispose(),this._proxy.$removeKernel(M))},updateNotebookAffinity(se,Te){Te===h.NotebookControllerAffinity2.Hidden&&(0,a.checkProposedApiEnabled)(_,"notebookControllerAffinityHidden"),L._proxy.$updateNotebookPriority(M,se.uri,Te)},onDidReceiveMessage:N.event,postMessage(se,Te){return(0,a.checkProposedApiEnabled)(_,"notebookMessaging"),L._proxy.$postMessage(M,Te&&L._extHostNotebook.getIdByEditor(Te),se)},asWebviewUri(se){return(0,a.checkProposedApiEnabled)(_,"notebookMessaging"),(0,r.asWebviewUri)(se,L._initData.remote)}};return this._kernelData.set(M,{extensionId:_.identifier,controller:ve,onDidReceiveMessage:N,onDidChangeSelection:$,associatedNotebooks:pe}),ve}getIdByController(_){for(const[w,p]of this._kernelData)if(p.controller===_)return E(p.extensionId,_.id);return null}createNotebookControllerDetectionTask(_,w){const p=this._kernelDetectionTaskHandlePool++,D=this;this._logService.trace(`NotebookControllerDetectionTask[${p}], CREATED by ${_.identifier.value}`),this._proxy.$addKernelDetectionTask(p,w);const m={dispose:()=>{this._kernelDetectionTask.delete(p),D._proxy.$removeKernelDetectionTask(p)}};return this._kernelDetectionTask.set(p,m),m}registerKernelSourceActionProvider(_,w,p){const D=this._kernelSourceActionProviderHandlePool++,m=typeof p.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,S=this;this._kernelSourceActionProviders.set(D,p),this._logService.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${_.identifier.value}`),this._proxy.$addKernelSourceActionProvider(D,D,w);let M;return m!==void 0&&(M=p.onDidChangeNotebookKernelSourceActions(L=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this._kernelSourceActionProviders.delete(D),S._proxy.$removeKernelSourceActionProvider(D,D),M?.dispose()}}}async $provideKernelSourceActions(_,w){const p=this._kernelSourceActionProviders.get(_);if(p){const D=new A.DisposableStore;return(await p.provideNotebookKernelSourceActions(w)??[]).map(S=>C.NotebookKernelSourceAction.from(S,this._commands.converter,D))}return[]}$acceptNotebookAssociation(_,w,p){const D=this._kernelData.get(_);if(D){const m=this._extHostNotebook.getNotebookDocument(v.URI.revive(w));p?D.associatedNotebooks.set(m.uri,!0):D.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${_}] ASSOCIATE notebook`,m.uri.toString(),p),D.onDidChangeSelection.fire({selected:p,notebook:m.apiNotebook})}}async $executeCells(_,w,p){const D=this._kernelData.get(_);if(!D)return;const m=this._extHostNotebook.getNotebookDocument(v.URI.revive(w)),S=[];for(const M of p){const L=m.getCell(M);L&&S.push(L.apiCell)}try{this._logService.trace(`NotebookController[${_}] EXECUTE cells`,m.uri.toString(),S.length),await D.controller.executeHandler.call(D.controller,S,m.apiNotebook,D.controller)}catch(M){this._logService.error(`NotebookController[${_}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(_,w,p){const D=this._kernelData.get(_);if(!D)return;const m=this._extHostNotebook.getNotebookDocument(v.URI.revive(w));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,m.apiNotebook);else for(const S of p){const M=m.getCell(S);M&&this._activeExecutions.get(M.uri)?.cancel()}if(D.controller.interruptHandler){const S=this._activeNotebookExecutions.get(m.uri);this._activeNotebookExecutions.delete(m.uri),p.length&&Array.isArray(S)&&S.length&&S.forEach(M=>M.dispose())}}async $provideVariables(_,w,p,D,m,S,M){const L=this._kernelData.get(_);if(!L)return;const H=this._extHostNotebook.getNotebookDocument(v.URI.revive(p)),V=L.controller.variableProvider;if(!V)return;let $;if(D!==void 0){if($=this.variableStore[D],!$)return}else this.variableStore={};const N=m==="named"?h.NotebookVariablesRequestKind.Named:h.NotebookVariablesRequestKind.Indexed,F=V.provideVariables(H.apiNotebook,$,N,S,M);let Y=0;for await(const re of F){if(M.isCancellationRequested)return;const fe={id:this.id++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:L.extensionId.value};if(this.variableStore[fe.id]=re.variable,this._proxy.$receiveVariable(w,fe),Y++>=t.variablePageSize)return}}$acceptKernelMessageFromRenderer(_,w,p){const D=this._kernelData.get(_);if(!D)return;const m=this._extHostNotebook.getEditorById(w);D.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:p}))}$cellExecutionChanged(_,w,p){const m=this._extHostNotebook.getNotebookDocument(v.URI.revive(_)).getCell(w);if(m){const S=p?C.NotebookCellExecutionState.to(p):h.NotebookCellExecutionState.Idle;S!==void 0&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:S})}}_createNotebookCellExecution(_,w){if(_.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this._extHostNotebook.getNotebookDocument(_.notebook.uri).getCellFromApiCell(_);if(!D)throw new Error("invalid cell");if(this._activeExecutions.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const m=new i(w,D,this._proxy);this._activeExecutions.set(D.uri,m);const S=m.onDidChangeState(()=>{m.state===n.Resolved&&(m.dispose(),S.dispose(),this._activeExecutions.delete(D.uri))});return m.asApiObject()}_createNotebookExecution(_,w){const p=this._extHostNotebook.getNotebookDocument(_.uri),D=_.getCells().find(M=>{const L=p.getCellFromApiCell(M);return L&&this._activeExecutions.has(L.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this._activeNotebookExecutions.has(p.uri))throw new Error(`duplicate notebook execution for ${p.uri}`);const m=new f(w,p,this._proxy),S=m.onDidChangeState(()=>{m.state===g.Resolved&&(m.dispose(),S.dispose(),this._activeNotebookExecutions.delete(p.uri))});return this._activeNotebookExecutions.set(p.uri,[m,S]),m.asApiObject()}};e.ExtHostNotebookKernels=s,e.ExtHostNotebookKernels=s=je([$e(4,T.ILogService)],s);var n;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(n||(n={}));class i extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(_,w,p){super(),this._cell=w,this._proxy=p,this._handle=i.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=n.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._collector=new u(10,D=>this.update(D)),this._executionOrder=w.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,_,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(_){await this._collector.addItem(_)}async update(_){const w=Array.isArray(_)?_:[_];return this._proxy.$updateExecution(this._handle,new d.SerializableObjectWithBuffers(w))}verifyStateForOutput(){if(this._state===n.Init)throw new Error("Must call start before modifying cell output");if(this._state===n.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(_){let w=this._cell;if(_&&(w=this._cell.notebook.getCellFromApiCell(_)),!w)throw new Error("INVALID cell");return w.handle}validateAndConvertOutputs(_){return _.map(w=>{const p=h.NotebookCellOutput.ensureUniqueMimeTypes(w.items,!0);return p===w.items?C.NotebookCellOutput.from(w):C.NotebookCellOutput.from({items:p,id:w.id,metadata:w.metadata})})}async updateOutputs(_,w,p){const D=this.cellIndexToHandle(w),m=this.validateAndConvertOutputs((0,y.asArray)(_));return this.updateSoon({editType:o.CellExecutionUpdateType.Output,cellHandle:D,append:p,outputs:m})}async updateOutputItems(_,w,p){return _=h.NotebookCellOutput.ensureUniqueMimeTypes((0,y.asArray)(_),!0),this.updateSoon({editType:o.CellExecutionUpdateType.OutputItems,items:_.map(C.NotebookCellOutputItem.from),outputId:w.id,append:p})}asApiObject(){const _=this;return Object.freeze({get token(){return _._tokenSource.token},get cell(){return _._cell.apiCell},get executionOrder(){return _._executionOrder},set executionOrder(p){_._executionOrder=p,_.update([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:_._executionOrder}])},start(p){if(_._state===n.Resolved||_._state===n.Started)throw new Error("Cannot call start again");_._state=n.Started,_._onDidChangeState.fire(),_.update({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:p})},end(p,D,m){if(_._state===n.Resolved)throw new Error("Cannot call resolve twice");_._state=n.Resolved,_._onDidChangeState.fire(),_._collector.flush();const S=m?{message:m.message,stack:m.stack,location:m?.location?{startLineNumber:m.location.start.line,startColumn:m.location.start.character,endLineNumber:m.location.end.line,endColumn:m.location.end.character}:void 0,uri:m.uri}:void 0;_._proxy.$completeExecution(_._handle,new d.SerializableObjectWithBuffers({runEndTime:D,lastRunSuccess:p,error:S}))},clearOutput(p){return _.verifyStateForOutput(),_.updateOutputs([],p,!1)},appendOutput(p,D){return _.verifyStateForOutput(),_.updateOutputs(p,D,!0)},replaceOutput(p,D){return _.verifyStateForOutput(),_.updateOutputs(p,D,!1)},appendOutputItems(p,D){return _.verifyStateForOutput(),_.updateOutputItems(p,D,!0)},replaceOutputItems(p,D){return _.verifyStateForOutput(),_.updateOutputItems(p,D,!1)}})}}var g;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(g||(g={}));class f extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(_,w,p){super(),this._notebook=w,this._proxy=p,this._handle=f.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=g.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,_,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===g.Resolved||this._state===g.Started)throw new Error("Cannot call start again");this._state=g.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===g.Resolved)throw new Error("Cannot call resolve twice");this._state=g.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class u{constructor(_,w){this.delay=_,this.callback=w,this.batch=[],this.startedTimer=Date.now()}addItem(_){return this.batch.push(_),this.currentDeferred||(this.currentDeferred=new k.DeferredPromise,this.startedTimer=Date.now(),(0,k.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const _=this.currentDeferred;this.currentDeferred=void 0;const w=this.batch;return this.batch=[],this.callback(w).finally(()=>_.complete())}}function E(I,_){return`${I.value}/${_}`}}),define(De[57],Ie([1,0,4,5,3,2,17,6,7,187,14,218,22,36,219,220,34,11,10,39,37]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,P.createDecorator)("IExtHostTerminalService");class n extends R.Disposable{constructor(m,S,M,L){super(),this._proxy=m,this._id=S,this._creationOptions=M,this._name=L,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new y.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(V=>this._pidPromiseComplete=V);const H=this;this.value={get name(){return H._name||""},get processId(){return H._pidPromise},get creationOptions(){return H._creationOptions},get exitStatus(){return H._exitStatus},get state(){return H._state},get selection(){return H._selection},get shellIntegration(){return H.shellIntegration},sendText(V,$=!0){H._checkDisposed(),H._proxy.$sendText(H._id,V,$)},show(V){H._checkDisposed(),H._proxy.$show(H._id,V)},hide(){H._checkDisposed(),H._proxy.$hide(H._id)},dispose(){H._disposed||(H._disposed=!0,H._proxy.$dispose(H._id))},get dimensions(){if(!(H._cols===void 0||H._rows===void 0))return{columns:H._cols,rows:H._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(m,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??S?.cwd??void 0,env:m.env??void 0,icon:_(m.iconPath)??void 0,color:o.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this._serializeParentTerminal(m.location,S?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,S,M,L,H){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:L,color:o.ThemeColor.isThemeColor(H)?H.id:void 0,location:S?.location||this._serializeParentTerminal(m,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(m,S){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in m?{viewColumn:d.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(m){this._name=m}setExitStatus(m,S){this._exitStatus=Object.freeze({code:m,reason:S})}setDimensions(m,S){return m===this._cols&&S===this._rows||m===0||S===0?!1:(this._cols=m,this._rows=S,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(m){this._selection=m}_setProcessId(m){this._pidPromiseComplete?(this._pidPromiseComplete(m),this._pidPromiseComplete=void 0):this._pidPromise.then(S=>{S!==m&&(this._pidPromise=Promise.resolve(m))})}}e.ExtHostTerminal=n;class i{get onProcessReady(){return this._onProcessReady.event}constructor(m){this._pty=m,this.id=0,this.shouldPersist=!1,this._onProcessData=new y.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new y.Emitter,this._onDidChangeProperty=new y.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new y.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${S}`)}async start(){}shutdown(){this._pty.close()}input(m){this._pty.handleInput?.(m)}resize(m,S){this._pty.setDimensions?.({columns:m,rows:S})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this._pty.onDidWrite(S=>this._onProcessData.fire(S)),this._pty.onDidClose?.((S=void 0)=>{this._onProcessExit.fire(S===void 0?void 0:S)}),this._pty.onDidOverrideDimensions?.(S=>{S&&this._onDidChangeProperty.fire({type:h.ProcessPropertyType.OverrideDimensions,value:{cols:S.columns,rows:S.rows}})}),this._pty.onDidChangeName?.(S=>{this._onDidChangeProperty.fire({type:h.ProcessPropertyType.Title,value:S})}),this._pty.open(m||void 0),m&&this._pty.setDimensions?.(m),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let g=1,f=class extends R.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(m=>m.value)}constructor(m,S,M){super(),this._extHostCommands=S,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new R.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new y.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new y.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new y.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new y.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new y.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new y.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new y.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new y.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=M.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(m),this._extHostCommands.registerArgumentProcessor({processArgument:L=>{const H=V=>{const $=V;return this.getTerminalById($.instanceId)?.value};switch(L?.$mid){case s.MarshalledId.TerminalContext:return H(L);default:{if(Array.isArray(L))for(let V=0;V<L.length&&L[V].$mid===s.MarshalledId.TerminalContext;V++)L[V]=H(L[V]);return L}}}}),this._register({dispose:()=>{for(const[L,H]of this._terminalProcesses)H.shutdown(!0)}})}getDefaultShell(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(m,S){const M=new n(this._proxy,(0,C.generateUuid)(),m,m.name),L=new i(m.pty);return M.createExtensionTerminal(m.location,S,this._serializeParentTerminal(m,S).resolvedExtHostIdentifier,_(m.iconPath),w(m.color)).then(H=>{const V=this._setupExtHostProcessListeners(H,L);this._terminalProcessDisposables[H]=V}),this._terminals.push(M),M.value}_serializeParentTerminal(m,S){if(S=S||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const M=m.location.parentTerminal;if(M){const L=this._terminals.find(H=>H.value===M);L&&(S.resolvedExtHostIdentifier=L._id)}}else m.location&&typeof m.location!="object"?S.location=m.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(m,S){if(!this.getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const L=new i(S),H=this._setupExtHostProcessListeners(m,L);this._terminalProcessDisposables[m]=H}async $acceptActiveTerminalChanged(m){const S=this._activeTerminal;if(m===null){this._activeTerminal=void 0,S!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const M=this.getTerminalById(m);M&&(this._activeTerminal=M,S!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(m,S){const M=this.getTerminalById(m);M&&this._onDidWriteTerminalData.fire({terminal:M.value,data:S})}async $acceptTerminalDimensions(m,S,M){const L=this.getTerminalById(m);L&&L.setDimensions(S,M)&&this._onDidChangeTerminalDimensions.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(m,S){const M=this.getTerminalById(m);M&&this._onDidExecuteCommand.fire({terminal:M.value,...S})}async $acceptTerminalMaximumDimensions(m,S,M){this._terminalProcesses.get(m)?.resize(S,M)}async $acceptTerminalTitleChange(m,S){const M=this.getTerminalById(m);M&&(M.name=S)}async $acceptTerminalClosed(m,S,M){const L=this._getTerminalObjectIndexById(this._terminals,m);if(L!==null){const H=this._terminals.splice(L,1)[0];H.setExitStatus(S,M),this._onDidCloseTerminal.fire(H.value)}}$acceptTerminalOpened(m,S,M,L){if(S){const $=this._getTerminalObjectIndexById(this._terminals,S);if($!==null){this._terminals[$]._id=m,this._onDidOpenTerminal.fire(this.terminals[$]),this._terminals[$].isOpen=!0;return}}const H={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:O.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},V=new n(this._proxy,m,H,M);this._terminals.push(V),this._onDidOpenTerminal.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(m,S){this.getTerminalById(m)?._setProcessId(S)}async $startExtensionTerminal(m,S){const M=this.getTerminalById(m);if(!M)return{message:(0,l.localize)(0,null,m)};M.isOpen||await new Promise(H=>{const V=this.onDidOpenTerminal(async $=>{$===M.value&&(V.dispose(),H())})});const L=this._terminalProcesses.get(m);L?L.startSendingEvents(S):this._extensionTerminalAwaitingStart[m]={initialDimensions:S}}_setupExtHostProcessListeners(m,S){const M=new R.DisposableStore;M.add(S.onProcessReady(H=>this._proxy.$sendProcessReady(m,H.pid,H.cwd,H.windowsPty))),M.add(S.onDidChangeProperty(H=>this._proxy.$sendProcessProperty(m,H))),this._bufferer.startBuffering(m,S.onProcessData),M.add(S.onProcessExit(H=>this._onProcessExit(m,H))),this._terminalProcesses.set(m,S);const L=this._extensionTerminalAwaitingStart[m];return L&&S instanceof i&&(S.startSendingEvents(L.initialDimensions),delete this._extensionTerminalAwaitingStart[m]),M}$acceptProcessAckDataEvent(m,S){this._terminalProcesses.get(m)?.acknowledgeDataEvent(S)}$acceptProcessInput(m,S){this._terminalProcesses.get(m)?.input(S)}$acceptTerminalInteraction(m){const S=this.getTerminalById(m);S?.setInteractedWith()&&this._onDidChangeTerminalState.fire(S.value)}$acceptTerminalSelection(m,S){this.getTerminalById(m)?.setSelection(S)}$acceptProcessResize(m,S,M){try{this._terminalProcesses.get(m)?.resize(S,M)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(m,S){this._terminalProcesses.get(m)?.shutdown(S)}$acceptProcessRequestInitialCwd(m){this._terminalProcesses.get(m)?.getInitialCwd().then(S=>this._proxy.$sendProcessProperty(m,{type:h.ProcessPropertyType.InitialCwd,value:S}))}$acceptProcessRequestCwd(m){this._terminalProcesses.get(m)?.getCwd().then(S=>this._proxy.$sendProcessProperty(m,{type:h.ProcessPropertyType.Cwd,value:S}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this._linkProviders.add(m),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new v.Disposable(()=>{this._linkProviders.delete(m),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(m,S,M){if(this._profileProviders.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this._profileProviders.set(S,M),this._proxy.$registerProfileProvider(S,m.identifier.value),new v.Disposable(()=>{this._profileProviders.delete(S),this._proxy.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(m,S,M){if(this._quickFixProviders.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this._quickFixProviders.set(m,M),this._proxy.$registerQuickFixProvider(m,S),new v.Disposable(()=>{this._quickFixProviders.delete(m),this._proxy.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,S){const M=new c.CancellationTokenSource().token;if(M.isCancellationRequested)return;const L=this._quickFixProviders.get(m);if(!L)return;const H=await L.provideTerminalQuickFixes(S,M);if(H===null||Array.isArray(H)&&H.length===0)return;const V=new R.DisposableStore;if(this._lastQuickFixCommands.value=V,!Array.isArray(H))return H?d.TerminalQuickFix.from(H,this._extHostCommands.converter,V):void 0;const $=[];for(const N of H){const F=d.TerminalQuickFix.from(N,this._extHostCommands.converter,V);F&&$.push(F)}return $}async $createContributedProfileTerminal(m,S){const M=new c.CancellationTokenSource().token;let L=await this._profileProviders.get(m)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,S);return}this.createTerminalFromOptions(L.options,S)}}async $provideLinks(m,S){const M=this.getTerminalById(m);if(!M)return[];this._terminalLinkCache.delete(m),this._terminalLinkCancellationSource.get(m)?.dispose(!0);const H=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(m,H);const V=[],$={terminal:M.value,line:S},N=[];for(const re of this._linkProviders)N.push(a.Promises.withAsyncBody(async fe=>{H.token.onCancellationRequested(()=>fe({provider:re,links:[]}));const Ee=await re.provideTerminalLinks($,H.token)||[];H.token.isCancellationRequested||fe({provider:re,links:Ee})}));const F=await Promise.all(N);if(H.token.isCancellationRequested)return[];const Y=new Map;for(const re of F)re&&re.links.length>0&&V.push(...re.links.map(fe=>{const Ee={id:g++,startIndex:fe.startIndex,length:fe.length,label:fe.tooltip};return Y.set(Ee.id,{provider:re.provider,link:fe}),Ee}));return this._terminalLinkCache.set(m,Y),V}$activateLink(m,S){const M=this._terminalLinkCache.get(m)?.get(S);M&&M.provider.handleTerminalLink(M.link)}_onProcessExit(m,S){this._bufferer.stopBuffering(m),this._terminalProcesses.delete(m),delete this._extensionTerminalAwaitingStart[m];const M=this._terminalProcessDisposables[m];M&&(M.dispose(),delete this._terminalProcessDisposables[m]),this._proxy.$sendProcessExit(m,S)}getTerminalById(m){return this._getTerminalObjectById(this._terminals,m)}getTerminalIdByApiObject(m){const S=this._terminals.findIndex(M=>M.value===m);return S>=0?S:null}_getTerminalObjectById(m,S){const M=this._getTerminalObjectIndexById(m,S);return M!==null?m[M]:null}_getTerminalObjectIndexById(m,S){const M=m.findIndex(L=>L._id===S);return M>=0?M:null}getEnvironmentVariableCollection(m){let S=this._environmentVariableCollections.get(m.identifier.value);return S||(S=new u,this._setEnvironmentVariableCollection(m.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(m,S){const M=(0,b.serializeEnvironmentVariableCollection)(S.map),L=(0,b.serializeEnvironmentDescriptionMap)(S.descriptionMap);this._proxy.$setEnvironmentVariableCollection(m,S.persistent,M.length===0?void 0:M,L)}$initEnvironmentVariableCollections(m){m.forEach(S=>{const M=S[0],L=new u(S[1]);this._setEnvironmentVariableCollection(M,L)})}$acceptDefaultProfile(m,S){const M=this._defaultProfile;this._defaultProfile=m,this._defaultAutomationProfile=S,M?.path!==m.path&&this._onDidChangeShell.fire(m.path)}_setEnvironmentVariableCollection(m,S){this._environmentVariableCollections.set(m,S),S.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(m,S)})}};e.BaseExtHostTerminalService=f,e.BaseExtHostTerminalService=f=je([$e(1,t.IExtHostCommands),$e(2,A.IExtHostRpcService)],f);class u{get persistent(){return this._persistent}set persistent(m){this._persistent=m,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(m){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new y.Emitter,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const S=this.getScopeKey(m);let M=this.scopedCollections.get(S);return M||(M=new E(this,m),this.scopedCollections.set(S,M),M.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),M}replace(m,S,M,L){this._setIfDiffers(m,{value:S,type:v.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:L})}append(m,S,M,L){this._setIfDiffers(m,{value:S,type:v.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:L})}prepend(m,S,M,L){this._setIfDiffers(m,{value:S,type:v.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:L})}_setIfDiffers(m,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.getKey(m,S.scope),L=this.map.get(M),H=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==S.value||L.type!==S.type||L.options?.applyAtProcessCreation!==H.applyAtProcessCreation||L.options?.applyAtShellIntegration!==H.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const V=this.getKey(m,S.scope),$={variable:m,...S,options:H};this.map.set(V,$),this._onDidChangeCollection.fire()}}get(m,S){const M=this.getKey(m,S),L=this.map.get(M);return L?p(L):void 0}getKey(m,S){const M=this.getScopeKey(S);return M.length?`${m}:::${M}`:m}getScopeKey(m){return this.getWorkspaceKey(m?.workspaceFolder)??""}getWorkspaceKey(m){return m?m.uri.toString():void 0}getVariableMap(m){const S=new Map;for(const[M,L]of this.map)this.getScopeKey(L.scope)===this.getScopeKey(m)&&S.set(L.variable,p(L));return S}delete(m,S){const M=this.getKey(m,S);this.map.delete(M),this._onDidChangeCollection.fire()}clear(m){if(m?.workspaceFolder){for(const[S,M]of this.map)M.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(S);this.clearDescription(m)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(m,S){const M=this.getScopeKey(S),L=this.descriptionMap.get(M);if(!L||L.description!==m){let H;typeof m=="string"?H=m:H=m?.value.split(`

`)[0];const V={description:H,scope:S};this.descriptionMap.set(M,V),this._onDidChangeCollection.fire()}}getDescription(m){const S=this.getScopeKey(m);return this.descriptionMap.get(S)?.description}clearDescription(m){const S=this.getScopeKey(m);this.descriptionMap.delete(S)}}class E{get persistent(){return this.collection.persistent}set persistent(m){this.collection.persistent=m}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(m,S){this.collection=m,this.scope=S,this._onDidChangeCollection=new y.Emitter}getScoped(m){return this.collection.getScopedEnvironmentVariableCollection(m)}replace(m,S,M){this.collection.replace(m,S,M,this.scope)}append(m,S,M){this.collection.append(m,S,M,this.scope)}prepend(m,S,M){this.collection.prepend(m,S,M,this.scope)}get(m){return this.collection.get(m,this.scope)}forEach(m,S){this.collection.getVariableMap(this.scope).forEach((M,L)=>m.call(S,L,M,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(m){this.collection.delete(m,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(m){this.collection.setDescription(m,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let I=class extends f{constructor(m,S){super(!1,m,S)}createTerminal(m,S,M){throw new T.NotSupportedError}createTerminalFromOptions(m,S){throw new T.NotSupportedError}};e.WorkerExtHostTerminalService=I,e.WorkerExtHostTerminalService=I=je([$e(0,t.IExtHostCommands),$e(1,A.IExtHostRpcService)],I);function _(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function w(D){return o.ThemeColor.isThemeColor(D)?D:void 0}function p(D){const m={...D};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(De[124],Ie([1,0,7,6,3,5,17,57,4,2,11]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,P.createDecorator)("IExtHostTerminalShellIntegration");let b=class extends k.Disposable{constructor(o,a){super(),this._extHostTerminalService=a,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new v.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new v.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new v.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=o.getProxy(O.MainContext.MainThreadTerminalShellIntegration),this._register((0,k.toDisposable)(()=>{for(const[d,t]of this._activeShellIntegrations)t.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(o){const a=this._extHostTerminalService.getTerminalById(o);if(!a)return;const d=a.value;let t=this._activeShellIntegrations.get(o);t||(t=new c(a.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(o,t),t.store.add(a.onWillDispose(()=>this._activeShellIntegrations.get(o)?.dispose())),t.store.add(t.onDidRequestShellExecution(s=>this._proxy.$executeCommand(o,s))),t.store.add(t.onDidRequestEndExecution(s=>this._onDidEndTerminalShellExecution.fire(s))),t.store.add(t.onDidRequestChangeShellIntegration(s=>this._onDidChangeTerminalShellIntegration.fire(s))),a.shellIntegration=t.value),this._onDidChangeTerminalShellIntegration.fire({terminal:d,shellIntegration:t.value})}$shellExecutionStart(o,a,d,t,s){this._activeShellIntegrations.has(o)||this.$shellIntegrationChange(o);const n={value:a,confidence:d,isTrusted:t};this._activeShellIntegrations.get(o)?.startShellExecution(n,s)}$shellExecutionEnd(o,a,d,t,s){const n={value:a,confidence:d,isTrusted:t};this._activeShellIntegrations.get(o)?.endShellExecution(n,s)}$shellExecutionData(o,a){this._activeShellIntegrations.get(o)?.emitData(a)}$cwdChange(o,a){this._activeShellIntegrations.get(o)?.setCwd((0,l.isUriComponents)(a)?l.URI.revive(a):a)}$closeTerminal(o){this._activeShellIntegrations.get(o)?.dispose(),this._activeShellIntegrations.delete(o)}};e.ExtHostTerminalShellIntegration=b,e.ExtHostTerminalShellIntegration=b=je([$e(0,A.IExtHostRpcService),$e(1,R.IExtHostTerminalService)],b);class c extends k.Disposable{get currentExecution(){return this._currentExecution}constructor(o,a){super(),this._terminal=o,this._onDidStartTerminalShellExecution=a,this._ignoreNextExecution=!1,this.store=this._register(new k.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new v.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new v.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new v.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const d=this;this.value={get cwd(){return d._cwd},executeCommand(t,s){let n=t;s&&(n+=` "${s.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),d._onDidRequestShellExecution.fire(n);const i={value:n,confidence:y.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},g=d.startShellExecution(i,d._cwd,!0).value;return d._ignoreNextExecution=!0,g}}}startShellExecution(o,a,d){if(this._ignoreNextExecution&&this._currentExecution)this._ignoreNextExecution=!1;else{this._currentExecution&&(this._currentExecution.endExecution(void 0),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:void 0}));const t=this._currentExecution=new C(o,a);d?queueMicrotask(()=>this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:t.value})):this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value})}return this._currentExecution}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,a){this._currentExecution&&(this._currentExecution.endExecution(o),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:a}),this._currentExecution=void 0)}setCwd(o){let a=!1;l.URI.isUri(this._cwd)?a=!l.URI.isUri(o)||this._cwd.toString()!==o.toString():this._cwd!==o&&(a=!0),a&&(this._cwd=o,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class C{constructor(o,a){this._commandLine=o,this.cwd=a,this._ended=!1;const d=this;this.value={get commandLine(){return d._commandLine},get cwd(){return d.cwd},read(){return d._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._ended)return T.AsyncIterableObject.EMPTY;this._dataStream=new h}return this._dataStream.createIterable()}emitData(o){this._dataStream?.emitData(o)}endExecution(o){o&&(this._commandLine=o),this._dataStream?.endExecution(),this._dataStream=void 0,this._ended=!0}}class h extends k.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){this._barrier||(this._barrier=new T.Barrier);const o=this._barrier;return new T.AsyncIterableObject(async d=>{this._emitters.push(d),await o.wait()})}emitData(o){for(const a of this._emitters)a.emitOne(o)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(De[299],Ie([1,0,11,23,22,4,272,76,6,37,15,36,12,5,17,123,10,7,240,55,82,56,25]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=0;const f=new WeakMap;let u=class extends v.Disposable{constructor(F,Y,re,fe){super(),this.logService=Y,this.commands=re,this.editors=fe,this.resultsChangedEmitter=this._register(new O.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new O.Emitter),this.followupProviders=new Set,this.testFollowups=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(C.MainContext.MainThreadTesting),this.observer=new M(this.proxy),this.runTracker=new w(this.proxy,Y),re.registerArgumentProcessor({processArgument:Ee=>{switch(Ee?.$mid){case l.MarshalledId.TestItemContext:{const oe=Ee,pe=oe.tests[oe.tests.length-1].item.extId;return this.controllers.get(t.TestId.root(pe))?.collection.tree.get(pe)?.actual??(0,r.toItemFromContext)(Ee)}case l.MarshalledId.TestMessageMenuArgs:{const{test:oe,message:pe}=Ee,ve=oe.item.extId;return{test:this.controllers.get(t.TestId.root(ve))?.collection.tree.get(ve)?.actual??(0,r.toItemFromContext)({$mid:l.MarshalledId.TestItemContext,tests:[oe]}),message:o.TestMessage.to(pe)}}default:return Ee}}}),re.registerCommand(!1,"testing.getExplorerSelection",async()=>{const Ee=await re.executeCommand(d.TestCommandId.GetExplorerSelection),oe=pe=>{const ve=this.controllers.get(t.TestId.root(pe));if(ve)return t.TestId.isRoot(pe)?ve.controller:ve.collection.tree.get(pe)?.actual};return{include:Ee?.include.map(oe).filter(T.isDefined)||[],exclude:Ee?.exclude.map(oe).filter(T.isDefined)||[]}})}createTestController(F,Y,re,fe){if(this.controllers.has(Y))throw new Error(`Attempt to insert a duplicate controller with ID "${Y}"`);const Ee=new v.DisposableStore,oe=Ee.add(new r.ExtHostTestItemCollection(Y,re,this.editors));oe.root.label=re;const pe=new Map,ve=new Set,se=this.proxy,Te={items:oe.root.children,get label(){return re},set label(Q){re=Q,oe.root.label=Q,se.$updateController(Y,{label:re})},get refreshHandler(){return fe},set refreshHandler(Q){fe=Q,se.$updateController(Y,{canRefresh:!!Q})},get id(){return Y},createRunProfile:(Q,W,ie,_e,de,Se)=>{let ae=(0,R.hash)(Q);for(;pe.has(ae);)ae++;return new H(this.proxy,pe,ve,this.defaultProfilesChangedEmitter.event,Y,ae,Q,W,ie,_e,de,Se)},createTestItem(Q,W,ie){return new r.TestItemImpl(Y,Q,W,ie)},createTestRun:(Q,W,ie=!0)=>this.runTracker.createTestRun(F,Y,oe,Q,W,ie),invalidateTestResults:Q=>{if(Q===void 0)this.proxy.$markTestRetired(void 0);else{const W=Q instanceof Array?Q:[Q];this.proxy.$markTestRetired(W.map(ie=>t.TestId.fromExtHostTestItem(ie,Y).toString()))}},set resolveHandler(Q){oe.resolveHandler=Q},get resolveHandler(){return oe.resolveHandler},dispose:()=>{Ee.dispose()}};se.$registerTestController(Y,re,!!fe),Ee.add((0,v.toDisposable)(()=>se.$unregisterTestController(Y)));const Me={controller:Te,collection:oe,profiles:pe,extension:F,activeProfiles:ve};return this.controllers.set(Y,Me),Ee.add((0,v.toDisposable)(()=>this.controllers.delete(Y))),Ee.add(oe.onDidGenerateDiff(Q=>se.$publishDiff(Y,Q.map(n.TestsDiffOp.serialize)))),Te}createTestObserver(){return this.observer.checkout()}async runTests(F,Y=P.CancellationToken.None){const re=p(F);if(!re)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const fe=this.controllers.get(re.controllerId);if(!fe)throw new Error("Controller not found");await this.proxy.$runTests({preserveFocus:F.preserveFocus??!0,targets:[{testIds:F.include?.map(Ee=>t.TestId.fromExtHostTestItem(Ee,fe.collection.root.id).toString())??[fe.collection.root.id],profileGroup:V[re.kind],profileId:re.profileId,controllerId:re.controllerId}],exclude:F.exclude?.map(Ee=>Ee.id)},Y)}registerTestFollowupProvider(F){return this.followupProviders.add(F),{dispose:()=>{this.followupProviders.delete(F)}}}$syncTests(){for(const{collection:F}of this.controllers.values())F.flushDiff();return Promise.resolve()}async $getCoverageDetails(F,Y){return(await this.runTracker.getCoverageDetails(F,Y))?.map(o.TestCoverage.fromDetails)}async $disposeRun(F){this.runTracker.disposeTestRun(F)}$configureRunProfile(F,Y){this.controllers.get(F)?.profiles.get(Y)?.configureHandler?.()}$setDefaultRunProfiles(F){const Y=new Map;for(const[re,fe]of Object.entries(F)){const Ee=this.controllers.get(re);if(!Ee)continue;const oe=new Map,pe=fe.filter(se=>!Ee.activeProfiles.has(se)),ve=[...Ee.activeProfiles].filter(se=>!fe.includes(se));for(const se of pe)oe.set(se,!0),Ee.activeProfiles.add(se);for(const se of ve)oe.set(se,!1),Ee.activeProfiles.delete(se);oe.size&&Y.set(re,oe)}this.defaultProfilesChangedEmitter.fire(Y)}async $refreshTests(F,Y){await this.controllers.get(F)?.controller.refreshHandler?.(Y)}$publishTestResults(F){this.results=Object.freeze(F.map(Y=>{const re=o.TestResults.to(Y);return f.set(re,Y.id),re}).concat(this.results).sort((Y,re)=>re.completedAt-Y.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(F,Y){const re=this.controllers.get(t.TestId.fromString(F).controllerId)?.collection;re&&(await re.expand(F,Y<0?1/0:Y),re.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F.map(Y=>n.TestsDiffOp.deserialize({asCanonicalUri:re=>re},Y)))}async $runControllerTests(F,Y){return Promise.all(F.map(re=>this.runControllerTestRequest(re,!1,Y)))}async $startContinuousRun(F,Y){const re=new P.CancellationTokenSource(Y),fe=await Promise.all(F.map(Ee=>this.runControllerTestRequest(Ee,!0,re.token)));return!Y.isCancellationRequested&&!fe.some(Ee=>Ee.error)&&await new Promise(Ee=>Y.onCancellationRequested(Ee)),re.dispose(!0),fe}async $provideTestFollowups(F,Y){const re=this.results.find(oe=>f.get(oe)===F.resultId),fe=re&&$(t.TestId.fromString(F.extId),re?.results);if(!fe)return[];let Ee=[];return await Promise.all([...this.followupProviders].map(async oe=>{try{const pe=await oe.provideFollowup(re,fe,F.taskIndex,F.messageIndex,Y);pe&&(Ee=Ee.concat(pe))}catch(pe){this.logService.error("Error thrown while providing followup for test message",pe)}})),Y.isCancellationRequested?[]:Ee.map(oe=>{const pe=g++;return this.testFollowups.set(pe,oe),{title:oe.title,id:pe}})}$disposeTestFollowups(F){for(const Y of F)this.testFollowups.delete(Y)}$executeTestFollowup(F){const Y=this.testFollowups.get(F);return Y?this.commands.executeCommand(Y.command,...Y.arguments||[]):Promise.resolve()}async runControllerTestRequest(F,Y,re){const fe=this.controllers.get(F.controllerId);if(!fe)return{};const{collection:Ee,profiles:oe,extension:pe}=fe,ve=oe.get(F.profileId);if(!ve)return{};const se=F.testIds.map(W=>Ee.tree.get(W)).filter(T.isDefined),Te=F.excludeExtIds.map(W=>fe.collection.tree.get(W)).filter(T.isDefined).filter(W=>se.some(ie=>ie.fullId.compare(W.fullId)===t.TestPosition.IsChild));if(!se.length)return{};const Me=new a.TestRunRequest(se.some(W=>W.actual instanceof r.TestItemRootImpl)?void 0:se.map(W=>W.actual),Te.map(W=>W.actual),ve,Y),Q=(0,n.isStartControllerTests)(F)&&this.runTracker.prepareForMainThreadTestRun(pe,Me,D.fromInternal(F,fe.collection),ve,re);try{return await ve.runHandler(Me,re),{}}catch(W){return{error:String(W)}}finally{Q&&Q.hasRunningTasks&&!re.isCancellationRequested&&await O.Event.toPromise(Q.onEnd)}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};e.ExtHostTesting=u,e.ExtHostTesting=u=je([$e(0,h.IExtHostRpcService),$e(1,c.ILogService)],u);const E=1e4;var I;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(I||(I={}));class _ extends v.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor(F,Y,re,fe,Ee,oe){super(),this.dto=F,this.proxy=Y,this.logService=re,this.profile=fe,this.extension=Ee,this.state=I.Running,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new O.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new P.CancellationTokenSource(oe));const pe=this._register(new y.RunOnceScheduler(()=>this.forciblyEndTasks(),E));this._register(this.cts.token.onCancellationRequested(()=>pe.schedule()));const ve=new O.Emitter;this.onDidDispose=ve.event,this._register((0,v.toDisposable)(()=>{ve.fire(),ve.dispose()}))}cancel(){this.state===I.Running?(this.cts.cancel(),this.state=I.Cancelling):this.state===I.Cancelling&&this.forciblyEndTasks()}getCoverageDetails(F,Y){const[,re]=t.TestId.fromString(F).path,fe=this.publishedCoverage.get(F);if(!fe)return[];const Ee=this.tasks.get(re);if(!Ee)throw new Error("unreachable: run task was not found");return this.profile?.loadDetailedCoverage?.(Ee.run,fe,Y)??[]}createRun(F){const Y=this.dto.id,re=this.dto.controllerId,fe=(0,b.generateUuid)(),Ee=Te=>(Me,...Q)=>{if(pe){this.logService.warn(`Setting the state of test "${Me.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(Me)&&(this.ensureTestIsKnown(Me),Te(Me,...Q))},oe=(Te,Me)=>{const Q=Me instanceof Array?Me.map(o.TestMessage.from):[o.TestMessage.from(Me)];if(Te.uri&&Te.range){const W={range:o.Range.from(Te.range),uri:Te.uri};for(const ie of Q)ie.location=ie.location||W}this.proxy.$appendTestMessagesInRun(Y,fe,t.TestId.fromExtHostTestItem(Te,re).toString(),Q)};let pe=!1;const ve=new Map,se={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,onDidDispose:this.onDidDispose,addCoverage:Te=>{if(pe)return;const Me=Te instanceof a.FileCoverage?Te.testItem:void 0;let Q;if(Me){if((0,i.checkProposedApiEnabled)(this.extension,"attributableCoverage"),!this.dto.isIncluded(Me))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.ensureTestIsKnown(Me),Q=ve.get(Me),Q===void 0&&(Q=ve.size,ve.set(Me,Q))}const W=Te.uri.toString(),ie=new t.TestId(Q!==void 0?[Y,fe,W,String(Q)]:[Y,fe,W]).toString();this.publishedCoverage.set(ie,Te),this.proxy.$appendCoverage(Y,fe,o.TestCoverage.fromFile(re,ie,Te))},enqueued:Ee(Te=>{this.proxy.$updateTestStateInRun(Y,fe,t.TestId.fromExtHostTestItem(Te,re).toString(),n.TestResultState.Queued)}),skipped:Ee(Te=>{this.proxy.$updateTestStateInRun(Y,fe,t.TestId.fromExtHostTestItem(Te,re).toString(),n.TestResultState.Skipped)}),started:Ee(Te=>{this.proxy.$updateTestStateInRun(Y,fe,t.TestId.fromExtHostTestItem(Te,re).toString(),n.TestResultState.Running)}),errored:Ee((Te,Me,Q)=>{oe(Te,Me),this.proxy.$updateTestStateInRun(Y,fe,t.TestId.fromExtHostTestItem(Te,re).toString(),n.TestResultState.Errored,Q)}),failed:Ee((Te,Me,Q)=>{oe(Te,Me),this.proxy.$updateTestStateInRun(Y,fe,t.TestId.fromExtHostTestItem(Te,re).toString(),n.TestResultState.Failed,Q)}),passed:Ee((Te,Me)=>{this.proxy.$updateTestStateInRun(Y,fe,t.TestId.fromExtHostTestItem(Te,this.dto.controllerId).toString(),n.TestResultState.Passed,Me)}),appendOutput:(Te,Me,Q)=>{pe||(Q&&(this.dto.isIncluded(Q)?this.ensureTestIsKnown(Q):Q=void 0),this.proxy.$appendOutputToRun(Y,fe,k.VSBuffer.fromString(Te),Me&&o.location.from(Me),Q&&t.TestId.fromExtHostTestItem(Q,re).toString()))},end:()=>{pe||(pe=!0,ve.clear(),this.proxy.$finishedTestRunTask(Y,fe),--this.running||this.markEnded())}};return this.running++,this.tasks.set(fe,{run:se}),this.proxy.$startedTestRunTask(Y,{id:fe,name:F,running:!0}),se}forciblyEndTasks(){for(const{run:F}of this.tasks.values())F.end()}markEnded(){this.state!==I.Ended&&(this.state=I.Ended,this.endEmitter.fire())}ensureTestIsKnown(F){if(!(F instanceof r.TestItemImpl))throw new s.InvalidTestItemError(F.id);if(this.sharedTestIds.has(t.TestId.fromExtHostTestItem(F,this.dto.controllerId).toString()))return;const Y=[],re=this.dto.colllection.root;for(;;){const fe=o.TestItem.from(F);if(Y.unshift(fe),this.sharedTestIds.has(fe.extId)||(this.sharedTestIds.add(fe.extId),F===re))break;F=F.parent||re}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,Y)}dispose(){this.markEnded(),super.dispose()}}class w{get trackers(){return this.tracked.values()}constructor(F,Y){this.proxy=F,this.logService=Y,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails(F,Y){const re=t.TestId.root(F);return this.trackedById.get(re)?.getCoverageDetails(F,Y)||[]}disposeTestRun(F){this.trackedById.get(F)?.dispose(),this.trackedById.delete(F);for(const[Y,{id:re}]of this.tracked)re===F&&this.tracked.delete(Y)}prepareForMainThreadTestRun(F,Y,re,fe,Ee){return this.getTracker(Y,re,fe,F,Ee)}cancelRunById(F){this.trackedById.get(F)?.cancel()}cancelAllRuns(){for(const F of this.tracked.values())F.cancel()}createTestRun(F,Y,re,fe,Ee,oe){const pe=this.tracked.get(fe);if(pe)return pe.createRun(Ee);const ve=D.fromPublic(Y,re,fe,oe),se=p(fe);this.proxy.$startedExtensionTestRun({controllerId:Y,continuous:!!fe.continuous,profile:se&&{group:V[se.kind],id:se.profileId},exclude:fe.exclude?.map(Me=>t.TestId.fromExtHostTestItem(Me,re.root.id).toString())??[],id:ve.id,include:fe.include?.map(Me=>t.TestId.fromExtHostTestItem(Me,re.root.id).toString())??[re.root.id],preserveFocus:fe.preserveFocus??!0,persist:oe});const Te=this.getTracker(fe,ve,fe.profile,F);return O.Event.once(Te.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(ve.id)}),Te.createRun(Ee)}getTracker(F,Y,re,fe,Ee){const oe=new _(Y,this.proxy,this.logService,re,fe,Ee);return this.tracked.set(F,oe),this.trackedById.set(oe.id,oe),oe}}e.TestRunCoordinator=w;const p=N=>{if(N.profile){if(!(N.profile instanceof H))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class D{static fromPublic(F,Y,re,fe){return new D(F,(0,b.generateUuid)(),re.include?.map(Ee=>t.TestId.fromExtHostTestItem(Ee,F).toString())??[F],re.exclude?.map(Ee=>t.TestId.fromExtHostTestItem(Ee,F).toString())??[],fe,Y)}static fromInternal(F,Y){return new D(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,Y)}constructor(F,Y,re,fe,Ee,oe){this.controllerId=F,this.id=Y,this.isPersisted=Ee,this.colllection=oe,this.includePrefix=re.map(pe=>pe+t.TestIdPathParts.Delimiter),this.excludePrefix=fe.map(pe=>pe+t.TestIdPathParts.Delimiter)}isIncluded(F){const Y=t.TestId.fromExtHostTestItem(F,this.controllerId).toString()+t.TestIdPathParts.Delimiter;for(const re of this.excludePrefix)if(Y===re||Y.startsWith(re))return!1;for(const re of this.includePrefix)if(Y===re||Y.startsWith(re))return!0;return!1}}e.TestRunDto=D;class m{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(F){this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(F){this.added.add(F)}update(F){Object.assign(F.revived,o.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}this.updated.delete(F);const Y=t.TestId.parentId(F.item.extId);if(Y&&this.alreadyRemoved.has(Y.toString())){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:Y,removed:re}=this;return{get added(){return[...F].map(fe=>fe.revived)},get updated(){return[...Y].map(fe=>fe.revived)},get removed(){return[...re].map(fe=>fe.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class S extends n.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new O.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,Y){return{...F,revived:o.TestItem.toPlain(F.item),depth:Y?Y.depth+1:0,children:new Set}}createChangeCollector(){return new m(this.changeEmitter)}}class M{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(Y=>Y.revived)},dispose:(0,A.createSingleCallFunction)(()=>{--F.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new S({asCanonicalUri:Y=>Y});return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}const L=(N,F,Y,re)=>{Y?Object.assign(Y,re):F.$updateTestRunConfig(N.controllerId,N.profileId,re)};class H{#e;#t;#i;#n;#s;get label(){return this._label}set label(F){F!==this._label&&(this._label=F,L(this,this.#e,this.#n,{label:F}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(F){F!==this._supportsContinuousRun&&(this._supportsContinuousRun=F,L(this,this.#e,this.#n,{supportsContinuousRun:F}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?this.#t.add(this.profileId):this.#t.delete(this.profileId),L(this,this.#e,this.#n,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,L(this,this.#e,this.#n,{tag:F?o.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,L(this,this.#e,this.#n,{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return O.Event.chain(this.#i,F=>F.map(Y=>Y.get(this.controllerId)?.get(this.profileId)).filter(T.isDefined))}constructor(F,Y,re,fe,Ee,oe,pe,ve,se,Te=!1,Me=void 0,Q=!1){this.controllerId=Ee,this.profileId=oe,this._label=pe,this.kind=ve,this.runHandler=se,this._tag=Me,this._supportsContinuousRun=Q,this.#e=F,this.#s=Y,this.#t=re,this.#i=fe,Y.set(oe,this);const W=V[ve];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${ve}`);Te&&re.add(oe),this.#n={profileId:oe,controllerId:Ee,tag:Me?o.TestTag.namespace(this.controllerId,Me.id):null,label:pe,group:W,isDefault:Te,hasConfigurationHandler:!1,supportsContinuousRun:Q},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=H;const V={[a.TestRunProfileKind.Coverage]:n.TestRunProfileBitset.Coverage,[a.TestRunProfileKind.Debug]:n.TestRunProfileBitset.Debug,[a.TestRunProfileKind.Run]:n.TestRunProfileBitset.Run};function $(N,F){for(let Y=0;Y<N.path.length;Y++){const re=F.find(fe=>fe.id===N.path[Y]);if(!re)return;if(Y===N.path.length-1)return re;F=re.children}}}),define(De[125],Ie([1,0,61,14,96,10,7]),function(he,e,y,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{static{this._Keys=new P.IdGenerator("TextEditorDecorationType")}constructor(c,C,h){const r=R._Keys.nextId();c.$registerTextEditorDecorationType(C.identifier,r,O.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:r,dispose(){c.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=R;class v{constructor(c,C){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=C.undoStopBefore,this._undoStopAfter=C.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,C){this._throwIfFinalized();let h=null;if(c instanceof A.Position)h=new A.Range(c,c);else if(c instanceof A.Range)h=c;else throw new Error("Unrecognized location");this._pushEdit(h,C,!1)}insert(c,C){this._throwIfFinalized(),this._pushEdit(new A.Range(c,c),C,!0)}delete(c){this._throwIfFinalized();let C=null;if(c instanceof A.Range)C=c;else throw new Error("Unrecognized location");this._pushEdit(C,null,!0)}_pushEdit(c,C,h){const r=this._document.validateRange(c);this._collectedEdits.push({range:r,text:C,forceMoveMarkers:h})}setEndOfLine(c){if(this._throwIfFinalized(),c!==A.EndOfLine.LF&&c!==A.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=c}}class l{constructor(c,C,h,r){this._proxy=c,this._id=C,this._accept(h),this._logService=r;const o=this;this.value={get tabSize(){return o._tabSize},set tabSize(a){o._setTabSize(a)},get indentSize(){return o._indentSize},set indentSize(a){o._setIndentSize(a)},get insertSpaces(){return o._insertSpaces},set insertSpaces(a){o._setInsertSpaces(a)},get cursorStyle(){return o._cursorStyle},set cursorStyle(a){o._setCursorStyle(a)},get lineNumbers(){return o._lineNumbers},set lineNumbers(a){o._setLineNumbers(a)}}}_accept(c){this._tabSize=c.tabSize,this._indentSize=c.indentSize,this._originalIndentSize=c.originalIndentSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=O.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const C=Math.floor(c);return C>0?C:null}if(typeof c=="string"){const C=parseInt(c,10);return isNaN(C)?null:C>0?C:null}return null}_setTabSize(c){const C=this._validateTabSize(c);if(C!==null){if(typeof C=="number"){if(this._tabSize===C)return;this._tabSize=C}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:C}))}}_validateIndentSize(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const C=Math.floor(c);return C>0?C:null}if(typeof c=="string"){const C=parseInt(c,10);return isNaN(C)?null:C>0?C:null}return null}_setIndentSize(c){const C=this._validateIndentSize(c);if(C!==null){if(typeof C=="number"){if(this._originalIndentSize===C)return;this._indentSize=C,this._originalIndentSize=C}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:C}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:!!c}_setInsertSpaces(c){const C=this._validateInsertSpaces(c);if(typeof C=="boolean"){if(this._insertSpaces===C)return;this._insertSpaces=C}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:C}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:O.TextEditorLineNumbersStyle.from(c)})))}assign(c){const C={};let h=!1;if(typeof c.tabSize<"u"){const r=this._validateTabSize(c.tabSize);r==="auto"?(h=!0,C.tabSize=r):typeof r=="number"&&this._tabSize!==r&&(this._tabSize=r,h=!0,C.tabSize=r)}if(typeof c.indentSize<"u"){const r=this._validateIndentSize(c.indentSize);r==="tabSize"?(h=!0,C.indentSize=r):typeof r=="number"&&this._originalIndentSize!==r&&(this._indentSize=r,this._originalIndentSize=r,h=!0,C.indentSize=r)}if(typeof c.insertSpaces<"u"){const r=this._validateInsertSpaces(c.insertSpaces);r==="auto"?(h=!0,C.insertSpaces=r):this._insertSpaces!==r&&(this._insertSpaces=r,h=!0,C.insertSpaces=r)}typeof c.cursorStyle<"u"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,h=!0,C.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,h=!0,C.lineNumbers=O.TextEditorLineNumbersStyle.from(c.lineNumbers)),h&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,C))}_warnOnError(c,C){C.catch(h=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(h)})}}e.ExtHostTextEditorOptions=l;class T{constructor(c,C,h,r,o,a,d,t){this.id=c,this._proxy=C,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._options=new l(this._proxy,this.id,a,h),this._visibleRanges=d,this._viewColumn=t;const s=this;this.value=Object.freeze({get document(){return r.value},set document(n){throw new k.ReadonlyError("document")},get selection(){return s._selections&&s._selections[0]},set selection(n){if(!(n instanceof A.Selection))throw(0,k.illegalArgument)("selection");s._selections=[n],s._trySetSelection()},get selections(){return s._selections},set selections(n){if(!Array.isArray(n)||n.some(i=>!(i instanceof A.Selection)))throw(0,k.illegalArgument)("selections");s._selections=n,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(n){throw new k.ReadonlyError("visibleRanges")},get options(){return s._options.value},set options(n){s._disposed||s._options.assign(n)},get viewColumn(){return s._viewColumn},set viewColumn(n){throw new k.ReadonlyError("viewColumn")},edit(n,i={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new v(r.value,i);return n(g),s._applyEdit(g)},insertSnippet(n,i,g={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!i||Array.isArray(i)&&i.length===0)f=s._selections.map(u=>O.Range.from(u));else if(i instanceof A.Position){const{lineNumber:u,column:E}=O.Position.from(i);f=[{startLineNumber:u,startColumn:E,endLineNumber:u,endColumn:E}]}else if(i instanceof A.Range)f=[O.Range.from(i)];else{f=[];for(const u of i)if(u instanceof A.Range)f.push(O.Range.from(u));else{const{lineNumber:E,column:I}=O.Position.from(u);f.push({startLineNumber:E,startColumn:I,endLineNumber:E,endColumn:I})}}return C.$tryInsertSnippet(c,r.value.version,n.value,f,g)},setDecorations(n,i){const g=i.length===0;g&&!s._hasDecorationsForKey.has(n.key)||(g?s._hasDecorationsForKey.delete(n.key):s._hasDecorationsForKey.add(n.key),s._runOnProxy(()=>{if(O.isDecorationOptionsArr(i))return C.$trySetDecorations(c,n.key,O.fromRangeOrRangeWithMessage(i));{const f=new Array(4*i.length);for(let u=0,E=i.length;u<E;u++){const I=i[u];f[4*u]=I.start.line+1,f[4*u+1]=I.start.character+1,f[4*u+2]=I.end.line+1,f[4*u+3]=I.end.character+1}return C.$trySetDecorationsFast(c,n.key,f)}}))},revealRange(n,i){s._runOnProxy(()=>C.$tryRevealRange(c,O.Range.from(n),i||A.TextEditorRevealType.Default))},show(n){C.$tryShowEditor(c,O.ViewColumn.from(n))},hide(){C.$tryHideEditor(c)}})}dispose(){(0,y.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,y.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,y.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,y.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,y.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(O.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const C=c.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const h=C.edits.map(o=>o.range);h.sort((o,a)=>o.end.line===a.end.line?o.end.character===a.end.character?o.start.line===a.start.line?o.start.character-a.start.character:o.start.line-a.start.line:o.end.character-a.end.character:o.end.line-a.end.line);for(let o=0,a=h.length-1;o<a;o++){const d=h[o].end;if(h[o+1].start.isBefore(d))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=C.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,r,{setEndOfLine:typeof C.setEndOfLine=="number"?O.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this._logService.warn(C),null))}}e.ExtHostTextEditor=T}),define(De[71],Ie([1,0,61,4,6,2,3,5,121,17,125,10,12,29,16,40,47]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let d=class{constructor(s,n){this._extHostRpc=s,this._logService=n,this._activeEditorId=null,this._editors=new Map,this._documents=new C.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const n=[],i=[],g=[];if(s.removedDocuments)for(const f of s.removedDocuments){const u=O.URI.revive(f),E=this._documents.get(u);E?.unref()&&(this._documents.delete(u),n.push(E.value))}if(s.addedDocuments)for(const f of s.addedDocuments){const u=O.URI.revive(f.uri);let E=this._documents.get(u);if(E&&u.scheme!==h.Schemas.vscodeNotebookCell&&u.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);E||(E=new a(new v.ExtHostDocumentData(this._extHostRpc.getProxy(R.MainContext.MainThreadDocuments),u,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this._documents.set(u,E),i.push(E.value)),E.ref()}if(s.removedEditors)for(const f of s.removedEditors){const u=this._editors.get(f);this._editors.delete(f),u&&g.push(u)}if(s.addedEditors)for(const f of s.addedEditors){const u=O.URI.revive(f.documentUri);y.ok(this._documents.has(u),`document '${u}' does not exist`),y.ok(!this._editors.has(f.id),`editor '${f.id}' already exists!`);const E=this._documents.get(u).value,I=new T.ExtHostTextEditor(f.id,this._extHostRpc.getProxy(R.MainContext.MainThreadTextEditors),this._logService,new o.Lazy(()=>E.document),f.selections.map(b.Selection.to),f.options,f.visibleRanges.map(_=>b.Range.to(_)),typeof f.editorPosition=="number"?b.ViewColumn.to(f.editorPosition):void 0);this._editors.set(f.id,I)}s.newActiveEditor!==void 0&&(y.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,P.dispose)(n),(0,P.dispose)(g),s.removedDocuments&&this._onDidRemoveDocuments.fire(n),s.addedDocuments&&this._onDidAddDocuments.fire(i),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(f=>f.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return r.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const n=this._editors.get(this._activeEditorId);return s?n:n?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=d,e.ExtHostDocumentsAndEditors=d=je([$e(0,l.IExtHostRpcService),$e(1,c.ILogService)],d),e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[300],Ie([1,0,18,4,5,125,10,7]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class v{constructor(T,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new k.Emitter,this._onDidChangeTextEditorOptions=new k.Emitter,this._onDidChangeTextEditorVisibleRanges=new k.Emitter,this._onDidChangeTextEditorViewColumn=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(P.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const b=this._extHostDocumentsAndEditors.allEditors();return T?b:b.map(c=>c.value)}async showTextDocument(T,b,c){let C;typeof b=="number"?C={position:A.ViewColumn.from(b),preserveFocus:c}:typeof b=="object"?C={position:A.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?A.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:C={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(T.uri,C),r=h&&this._extHostDocumentsAndEditors.getEditor(h);if(r)return r.value;throw h?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,b){return new O.TextEditorDecorationType(this._proxy,T,b).value}$acceptEditorPropertiesChanged(T,b){const c=this._extHostDocumentsAndEditors.getEditor(T);if(!c)throw new Error("unknown text editor");if(b.options&&c._acceptOptions(b.options),b.selections){const C=b.selections.selections.map(A.Selection.to);c._acceptSelections(C)}if(b.visibleRanges){const C=y.coalesce(b.visibleRanges.map(A.Range.to));c._acceptVisibleRanges(C)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...b.options,lineNumbers:A.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const C=R.TextEditorSelectionChangeKind.fromValue(b.selections.source),h=b.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:h,kind:C})}if(b.visibleRanges){const C=y.coalesce(b.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:C})}}$acceptEditorPositionData(T){for(const b in T){const c=this._extHostDocumentsAndEditors.getEditor(b);if(!c)throw new Error("Unknown text editor");const C=A.ViewColumn.to(T[b]);c.value.viewColumn!==C&&(c._acceptViewColumn(C),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:C}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=v}),define(De[301],Ie([1,0,2,3,5,6,7,10,19,37,15]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class b{constructor(h,r){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=h.getProxy(P.MainContext.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(o,a)=>{if(o&&o.$mid===l.MarshalledId.TimelineActionContext)if(this._providers.get(o.source)&&v.ExtensionIdentifier.equals(a,this._providers.get(o.source)?.extension)){const d=o.uri===void 0?void 0:y.URI.revive(o.uri);return this._itemsBySourceAndUriMap.get(o.source)?.get(c(d))?.get(o.handle)}else return;return o}})}async $getTimeline(h,r,o,a){return this._providers.get(h)?.provider.provideTimeline(y.URI.revive(r),o,a)}registerTimelineProvider(h,r,o,a){const d=new O.DisposableStore,t=this.convertTimelineItem(r.id,a,d).bind(this);let s;r.onDidChange&&(s=r.onDidChange(i=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...i,id:r.id}),this));const n=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...r,scheme:h,onDidChange:void 0,async provideTimeline(i,g,f){g?.resetCache&&(d.clear(),n.get(r.id)?.clear());const u=await r.provideTimeline(i,g,f);if(u==null)return;const E=t(i,g);return{...u,source:r.id,items:u.items.map(E)}},dispose(){for(const i of n.values())i.get(r.id)?.clear();s?.dispose(),d.dispose()}},o)}convertTimelineItem(h,r,o){return(a,d)=>{let t;if(d?.cacheResults){let s=this._itemsBySourceAndUriMap.get(h);s===void 0&&(s=new Map,this._itemsBySourceAndUriMap.set(h,s));const n=c(a);t=s.get(n),t===void 0&&(t=new Map,s.set(n,t))}return s=>{const{iconPath:n,...i}=s,g=`${h}|${s.id??s.timestamp}`;t?.set(g,s);let f,u,E;s.iconPath&&(n instanceof A.ThemeIcon?E={id:n.id,color:n.color}:y.URI.isUri(n)?(f=n,u=n):{light:f,dark:u}=n);let I;return A.MarkdownString.isMarkdownString(i.tooltip)?I=R.MarkdownString.from(i.tooltip):(0,T.isString)(i.tooltip)?I=i.tooltip:A.MarkdownString.isMarkdownString(i.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=R.MarkdownString.from(i.detail)):(0,T.isString)(i.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=i.detail),{...i,id:i.id??void 0,handle:g,source:h,command:s.command?r.toInternal(s.command,o):void 0,icon:f,iconDark:u,themeIcon:E,tooltip:I,accessibilityInformation:s.accessibilityInformation}}}}registerTimelineProviderCore(h,r){if(this._providers.get(h.id))throw new Error(`Timeline Provider ${h.id} already exists.`);return this._proxy.$registerTimelineProvider({id:h.id,label:h.label,scheme:h.scheme}),this._providers.set(h.id,{provider:h,extension:r}),(0,O.toDisposable)(()=>{for(const a of this._itemsBySourceAndUriMap.values())a.get(h.id)?.clear();this._providers.delete(h.id),this._proxy.$unregisterTimelineProvider(h.id),h.dispose()})}}e.ExtHostTimeline=b;function c(C){return C?.toString()}}),define(De[302],Ie([1,0,188,24,2,4,6,231,11,7,15,18,10,59,22,152,25]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(s,n){if((0,T.isString)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let i;return Array.isArray(s.highlights)&&(i=s.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),i=i.length?i:void 0),{label:s.label,highlights:i}}}class d extends A.Disposable{constructor(n,i,g){super(),this._proxy=n,this.commands=i,this.logService=g,this.treeViews=new Map,this.treeDragAndDropService=new r.TreeViewsDnDService;function f(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:u=>f(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(E=>f(E)?this.convertArgument(E):E):u})}registerTreeDataProvider(n,i,g){const f=this.createTreeView(n,{treeDataProvider:i},g);return{dispose:()=>f.dispose()}}createTreeView(n,i,g){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=i.dragAndDropController?.dropMimeTypes??[],u=i.dragAndDropController?.dragMimeTypes??[],E=!!i.dragAndDropController?.handleDrag,I=!!i.dragAndDropController?.handleDrop,_=this.createExtHostTreeView(n,i,g),w={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:f,dragMimeTypes:u,hasHandleDrag:E,hasHandleDrop:I,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},p=this._proxy.$registerTreeViewDataProvider(n,w),D={get onDidCollapseElement(){return _.onDidCollapseElement},get onDidExpandElement(){return _.onDidExpandElement},get selection(){return _.selectedElements},get onDidChangeSelection(){return _.onDidChangeSelection},get activeItem(){return(0,o.checkProposedApiEnabled)(g,"treeViewActiveItem"),_.focusedElement},get onDidChangeActiveItem(){return(0,o.checkProposedApiEnabled)(g,"treeViewActiveItem"),_.onDidChangeActiveItem},get visible(){return _.visible},get onDidChangeVisibility(){return _.onDidChangeVisibility},get onDidChangeCheckboxState(){return _.onDidChangeCheckboxState},get message(){return _.message},set message(m){(0,C.isMarkdownString)(m)&&(0,o.checkProposedApiEnabled)(g,"treeViewMarkdownMessage"),_.message=m},get title(){return _.title},set title(m){_.title=m},get description(){return _.description},set description(m){_.description=m},get badge(){return _.badge},set badge(m){m!==void 0&&l.ViewBadge.isViewBadge(m)?_.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(_.badge=void 0)},reveal:(m,S)=>_.reveal(m,S),dispose:async()=>{await p,this.treeViews.delete(n),_.dispose()}};return this._register(D),D}$getChildren(n,i){const g=this.treeViews.get(n);return g?g.getChildren(i):Promise.reject(new R.NoTreeViewError(n))}async $handleDrop(n,i,g,f,u,E,I,_){const w=this.treeViews.get(n);if(!w)return Promise.reject(new R.NoTreeViewError(n));const p=c.DataTransfer.toDataTransfer(g,async D=>(await this._proxy.$resolveDropFileData(n,i,D)).buffer);return I===n&&_&&await this.addAdditionalTransferItems(p,w,_,u,E),w.onDrop(p,f,u)}async addAdditionalTransferItems(n,i,g,f,u){const E=this.treeDragAndDropService.removeDragOperationTransfer(u);if(E)(await E)?.forEach((I,_)=>{I&&n.set(_,I)});else if(u&&i.handleDrag){const I=i.handleDrag(g,n,f);this.treeDragAndDropService.addDragOperationTransfer(u,I),await I}return n}async $handleDrag(n,i,g,f){const u=this.treeViews.get(n);if(!u)return Promise.reject(new R.NoTreeViewError(n));const E=await this.addAdditionalTransferItems(new l.DataTransfer,u,i,f,g);if(!(!E||f.isCancellationRequested))return c.DataTransfer.from(E)}async $hasResolve(n){const i=this.treeViews.get(n);if(!i)throw new R.NoTreeViewError(n);return i.hasResolve}$resolve(n,i,g){const f=this.treeViews.get(n);if(!f)throw new R.NoTreeViewError(n);return f.resolveTreeItem(i,g)}$setExpanded(n,i,g){const f=this.treeViews.get(n);if(!f)throw new R.NoTreeViewError(n);f.setExpanded(i,g)}$setSelectionAndFocus(n,i,g){const f=this.treeViews.get(n);if(!f)throw new R.NoTreeViewError(n);f.setSelectionAndFocus(i,g)}$setVisible(n,i){const g=this.treeViews.get(n);if(!g){if(!i)return;throw new R.NoTreeViewError(n)}g.setVisible(i)}$changeCheckboxState(n,i){const g=this.treeViews.get(n);if(!g)throw new R.NoTreeViewError(n);g.setCheckboxState(i)}createExtHostTreeView(n,i,g){const f=this._register(new t(n,i,this._proxy,this.commands.converter,this.logService,g));return this.treeViews.set(n,f),f}convertArgument(n){const i=this.treeViews.get(n.$treeViewId);return i&&"$treeItemHandle"in n?i.getExtensionElement(n.$treeItemHandle):i&&"$focusedTreeItem"in n&&n.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=d;class t extends A.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(n=>this.getExtensionElement(n)).filter(n=>!(0,T.isUndefinedOrNull)(n))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(n,i,g,f,u,E){if(super(),this.viewId=n,this.proxy=g,this.commands=f,this.logService=u,this.extension=E,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new O.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new O.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new O.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new O.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new O.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new O.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,E.contributes&&E.contributes.views)for(const p in E.contributes.views)for(const D of E.contributes.views[p])D.id===n&&(this._title=D.name);this.dataProvider=i.treeDataProvider,this.dndController=i.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(p=>{Array.isArray(p)&&p.length===0||this._onDidChangeData.fire({message:!1,element:p})}));let I,_;const w=O.Event.debounce(this._onDidChangeData.event,(p,D)=>(p||(p={message:!1,elements:[]}),D.element!==!1&&(I||(I=new Promise(m=>_=m),this.refreshPromise=this.refreshPromise.then(()=>I)),Array.isArray(D.element)?p.elements.push(...D.element):p.elements.push(D.element)),D.message&&(p.message=!0),p),200,!0);this._register(w(({message:p,elements:D})=>{D.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=_;return I=null,this.refresh(D).then(()=>m())})),p&&this.proxy.$setMessage(this.viewId,c.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(n){const i=n?this.getExtensionElement(n):void 0;if(n&&!i)return this.logService.error(`No tree item with id '${n}' found.`),Promise.resolve([]);let g=this.getChildrenNodes(n);return g||(g=await this.fetchChildrenNodes(i)),g?g.map(f=>f.item):void 0}getExtensionElement(n){return this.elements.get(n)}reveal(n,i){i=i||{select:!0,focus:!1};const g=(0,T.isUndefinedOrNull)(i.select)?!0:i.select,f=(0,T.isUndefinedOrNull)(i.focus)?!1:i.focus,u=(0,T.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):n?this.refreshPromise.then(()=>this.resolveUnknownParentChain(n)).then(E=>this.resolveTreeNode(n,E[E.length-1]).then(I=>this.proxy.$reveal(this.viewId,{item:I.item,parentChain:E.map(_=>_.item)},{select:g,focus:f,expand:u})),E=>this.logService.error(E)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:f,expand:u})}get message(){return this._message}set message(n){this._message=n,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(n){this._title=n,this.proxy.$setTitle(this.viewId,n,this._description)}get description(){return this._description}set description(n){this._description=n,this.proxy.$setTitle(this.viewId,this._title,n)}get badge(){return this._badge}set badge(n){this._badge?.value===n?.value&&this._badge?.tooltip===n?.tooltip||(this._badge=c.ViewBadge.from(n),this.proxy.$setBadge(this.viewId,n))}setExpanded(n,i){const g=this.getExtensionElement(n);g&&(i?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelectionAndFocus(n,i){const g=!(0,b.equals)(this._selectedHandles,n);this._selectedHandles=n;const f=this._focusedHandle!==i;this._focusedHandle=i,g&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),f&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(n){n!==this._visible&&(this._visible=n,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(n){const i=(await Promise.all(n.map(async g=>{const f=this.getExtensionElement(g.treeItemHandle);return f?{extensionItem:f,treeItem:await this.dataProvider.getTreeItem(f),newState:g.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);i.forEach(g=>{g.treeItem.checkboxState=g.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:i.map(g=>[g.extensionItem,g.newState])})}async handleDrag(n,i,g){const f=[];for(const u of n){const E=this.getExtensionElement(u);E&&f.push(E)}if(!(!this.dndController?.handleDrag||f.length===0))return await this.dndController.handleDrag(f,i,g),i}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(n,i,g){const f=i?this.getExtensionElement(i):void 0;if(!(!f&&i||!this.dndController?.handleDrop))return(0,v.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(f,n,g):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(n,i){if(!this.dataProvider.resolveTreeItem)return;const g=this.elements.get(n);if(g){const f=this.nodes.get(g);if(f){const u=await this.dataProvider.resolveTreeItem(f.extensionItem,g,i)??f.extensionItem;return this.validateTreeItem(u),f.item.tooltip=this.getTooltip(u.tooltip),f.item.command=this.getCommand(f.disposableStore,u.command),f.item}}}resolveUnknownParentChain(n){return this.resolveParent(n).then(i=>i?this.resolveUnknownParentChain(i).then(g=>this.resolveTreeNode(i,g[g.length-1]).then(f=>(g.push(f),g))):Promise.resolve([]))}resolveParent(n){const i=this.nodes.get(n);return i?Promise.resolve(i.parent?this.elements.get(i.parent.item.handle):void 0):(0,v.asPromise)(()=>this.dataProvider.getParent(n))}resolveTreeNode(n,i){const g=this.nodes.get(n);return g?Promise.resolve(g):(0,v.asPromise)(()=>this.dataProvider.getTreeItem(n)).then(f=>this.createHandle(n,f,i,!0)).then(f=>this.getChildren(i?i.item.handle:void 0).then(()=>{const u=this.getExtensionElement(f);if(u){const E=this.nodes.get(u);if(E)return Promise.resolve(E)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(n){if(n){let i;if(typeof n=="string"){const g=this.getExtensionElement(n);i=g?this.nodes.get(g):void 0}else i=n;return i&&i.children||void 0}return this.roots}async fetchChildrenNodes(n){this.clearChildren(n);const i=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=n?this.nodes.get(n):void 0,f=await this.dataProvider.getChildren(n);if(i.token.isCancellationRequested)return;const u=(0,b.coalesce)(f||[]),E=await Promise.all((0,b.coalesce)(u).map(_=>this.dataProvider.getTreeItem(_)));if(i.token.isCancellationRequested)return;const I=E.map((_,w)=>_?this.createAndRegisterTreeNode(u[w],_,g):null);return(0,b.coalesce)(I)}finally{i.dispose()}}refresh(n){if(n.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(n);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(n){const i=new Set,g=n.map(u=>this.nodes.get(u));for(const u of g)if(u&&!i.has(u.item.handle)){let E=u;for(;E&&E.parent&&g.findIndex(I=>E&&E.parent&&I&&I.item.handle===E.parent.item.handle)===-1;){const I=this.elements.get(E.parent.item.handle);E=I?this.nodes.get(I):void 0}E&&!E.parent&&i.add(u.item.handle)}const f=[];return i.forEach(u=>{const E=this.elements.get(u);if(E){const I=this.nodes.get(E);I&&(!I.parent||!i.has(I.parent.item.handle))&&f.push(u)}}),f}refreshHandles(n){const i={};return Promise.all(n.map(g=>this.refreshNode(g).then(f=>{f&&(i[g]=f.item)}))).then(()=>Object.keys(i).length?this.proxy.$refresh(this.viewId,i):void 0)}refreshNode(n){const i=this.getExtensionElement(n);if(i){const g=this.nodes.get(i);if(g)return this.clearChildren(i),(0,v.asPromise)(()=>this.dataProvider.getTreeItem(i)).then(f=>{if(f){const u=this.createTreeNode(i,f,g.parent);return this.updateNodeCache(i,u,g,g.parent),g.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(n,i,g){const f=this.createTreeNode(n,i,g);if(i.id&&this.elements.has(f.item.handle))throw new Error((0,y.localize)(0,null,i.id));return this.addNodeToCache(n,f),this.addNodeToParentCache(f,g),f}getTooltip(n){return l.MarkdownString.isMarkdownString(n)?c.MarkdownString.from(n):n}getCommand(n,i){return i?{...this.commands.toInternal(i,n),originalId:i.command}:void 0}getCheckbox(n){if(n.checkboxState===void 0)return;let i,g,f;return typeof n.checkboxState=="number"?i=n.checkboxState:(i=n.checkboxState.state,g=n.checkboxState.tooltip,f=n.checkboxState.accessibilityInformation),{isChecked:i===l.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:f}}validateTreeItem(n){if(!l.TreeItem.isTreeItem(n,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(n,i,g){this.validateTreeItem(i);const f=this._register(new A.DisposableStore),u=this.createHandle(n,i,g),E=this.getLightIconPath(i);return{item:{handle:u,parentHandle:g?g.item.handle:void 0,label:a(i.label,this.extension),description:i.description,resourceUri:i.resourceUri,tooltip:this.getTooltip(i.tooltip),command:this.getCommand(f,i.command),contextValue:i.contextValue,icon:E,iconDark:this.getDarkIconPath(i)||E,themeIcon:this.getThemeIcon(i),collapsibleState:(0,T.isUndefinedOrNull)(i.collapsibleState)?l.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.getCheckbox(i)},extensionItem:i,parent:g,children:void 0,disposableStore:f,dispose(){f.dispose()}}}getThemeIcon(n){return n.iconPath instanceof l.ThemeIcon?n.iconPath:void 0}createHandle(n,{id:i,label:g,resourceUri:f},u,E){if(i)return`${t.ID_HANDLE_PREFIX}/${i}`;const I=a(g,this.extension),_=u?u.item.handle:t.LABEL_HANDLE_PREFIX;let w=I?I.label:f?(0,k.basename)(f):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const p=this.nodes.has(n)?this.nodes.get(n).item.handle:void 0,D=this.getChildrenNodes(u)||[];let m,S=0;do{if(m=`${_}/${S}:${w}`,E||!this.elements.has(m)||p===m)break;S++}while(S<=D.length);return m}getLightIconPath(n){if(n.iconPath&&!(n.iconPath instanceof l.ThemeIcon))return typeof n.iconPath=="string"||P.URI.isUri(n.iconPath)?this.getIconPath(n.iconPath):this.getIconPath(n.iconPath.light)}getDarkIconPath(n){if(n.iconPath&&!(n.iconPath instanceof l.ThemeIcon)&&n.iconPath.dark)return this.getIconPath(n.iconPath.dark)}getIconPath(n){return P.URI.isUri(n)?n:P.URI.file(n)}addNodeToCache(n,i){this.elements.set(i.item.handle,n),this.nodes.set(n,i)}updateNodeCache(n,i,g,f){this.elements.delete(i.item.handle),this.nodes.delete(n),i.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(n,i);const u=this.getChildrenNodes(f)||[],E=u.filter(I=>I.item.handle===g.item.handle)[0];E&&u.splice(u.indexOf(E),1,i)}addNodeToParentCache(n,i){i?(i.children||(i.children=[]),i.children.push(n)):(this.roots||(this.roots=[]),this.roots.push(n))}clearChildren(n){if(n){const i=this.nodes.get(n);if(i){if(i.children)for(const g of i.children){const f=this.elements.get(g.item.handle);f&&this.clear(f)}i.children=void 0}}else this.clearAll()}clear(n){const i=this.nodes.get(n);if(i){if(i.children)for(const g of i.children){const f=this.elements.get(g.item.handle);f&&this.clear(f)}this.nodes.delete(n),this.elements.delete(i.item.handle),i.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(n=>n.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(De[303],Ie([1,0,4,6,2,36,10,67,5,7]),function(he,e,y,k,P,O,A,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class T extends k.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;#d;constructor(h,r,o,a){super(),this.#o=void 0,this.#l=!0,this.#u=!1,this.#h=this._register(new y.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new y.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=h,this.#t=r,this.#n=o,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#c=a.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(h){this.assertNotDisposed(),this.#r!==h&&(this.#r=h,this.#t.$setTitle(this.#e,h))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(h){this.assertNotDisposed(),this.#a!==h&&(this.#a=h,this.#t.$setIconPath(this.#e,P.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#c}get visible(){return this.assertNotDisposed(),this.#l}_updateViewState(h){this.#u||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(this.#c=h.active,this.#l=h.visible,this.#o=h.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(h,r){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof h>"u"?void 0:A.ViewColumn.from(h),preserveFocus:!!r})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class b extends k.Disposable{static newHandle(){return(0,O.generateUuid)()}constructor(h,r,o){super(),this.webviews=r,this.workspace=o,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(v.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(h=>h.dispose()),this._webviewPanels.clear()}createWebviewPanel(h,r,o,a,d={}){const t=typeof a=="object"?a.viewColumn:a,s={viewColumn:A.ViewColumn.from(t),preserveFocus:typeof a=="object"&&!!a.preserveFocus},n=(0,R.shouldSerializeBuffersForPostMessage)(h),i=b.newHandle();this._proxy.$createWebviewPanel((0,R.toExtensionData)(h),i,r,{title:o,panelOptions:c(d),webviewOptions:(0,R.serializeWebviewOptions)(h,this.workspace,d),serializeBuffersForPostMessage:n},s);const g=this.webviews.createNewWebview(i,d,h);return this.createNewWebviewPanel(i,r,o,t,d,g,!0)}$onDidChangeWebviewPanelViewStates(h){const r=Object.keys(h);r.sort((o,a)=>{const d=h[o],t=h[a];return d.active?1:t.active?-1:+d.visible-+t.visible});for(const o of r){const a=this.getWebviewPanel(o);if(!a)continue;const d=h[o];a._updateViewState({active:d.active,visible:d.visible,viewColumn:A.ViewColumn.to(d.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,r,o){if(this._serializers.has(r))throw new Error(`Serializer for '${r}' already registered`);return this._serializers.set(r,{serializer:o,extension:h}),this._proxy.$registerSerializer(r,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(h)}),new l.Disposable(()=>{this._serializers.delete(r),this._proxy.$unregisterSerializer(r)})}async $deserializeWebviewPanel(h,r,o,a){const d=this._serializers.get(r);if(!d)throw new Error(`No serializer found for '${r}'`);const{serializer:t,extension:s}=d,n=this.webviews.createNewWebview(h,o.webviewOptions,s),i=this.createNewWebviewPanel(h,r,o.title,a,o.panelOptions,n,o.active);await t.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(h,r,o,a,d,t,s){const n=new T(h,this._proxy,t,{viewType:r,title:o,viewColumn:a,panelOptions:d,active:s});return this._webviewPanels.set(h,n),n}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=b;function c(C){return{enableFindWidget:C.enableFindWidget,retainContextWhenHidden:C.retainContextWhenHidden}}}),define(De[304],Ie([1,0,4,6,67,10,5,7]),function(he,e,y,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends k.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;constructor(b,c,C,h,r,o){super(),this.#s=!1,this.#c=this._register(new y.Emitter),this.onDidChangeVisibility=this.#c.event,this.#u=this._register(new y.Emitter),this.onDidDispose=this.#u.event,this.#i=C,this.#a=h,this.#e=b,this.#t=c,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#c;#u;get title(){return this.assertNotDisposed(),this.#a}set title(b){this.assertNotDisposed(),this.#a!==b&&(this.#a=b,this.#t.$setWebviewViewTitle(this.#e,b))}get description(){return this.assertNotDisposed(),this.#o}set description(b){this.assertNotDisposed(),this.#o!==b&&(this.#o=b,this.#t.$setWebviewViewDescription(this.#e,b))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(b){b===this.#r||this.#s||(this.#r=b,this.#c.fire())}get badge(){return this.assertNotDisposed(),this.#l}set badge(b){this.assertNotDisposed(),!(b?.value===this.#l?.value&&b?.tooltip===this.#l?.tooltip)&&(this.#l=O.ViewBadge.from(b),this.#t.$setWebviewViewBadge(this.#e,b))}show(b){this.assertNotDisposed(),this.#t.$show(this.#e,!!b)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class l{constructor(b,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=b.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(b,c,C,h){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:C,extension:b}),this._proxy.$registerWebviewViewProvider((0,P.toExtensionData)(b),c,{retainContextWhenHidden:h?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(b)}),new R.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(b,c,C,h,r){const o=this._viewProviders.get(c);if(!o)throw new Error(`No view provider found for '${c}'`);const{provider:a,extension:d}=o,t=this._extHostWebview.createNewWebview(b,{},d),s=new v(b,this._proxy,c,C,t,!0);this._webviewViews.set(b,s),await a.resolveWebviewView(s,{state:h},r)}async $onDidChangeWebviewViewVisibility(b,c){this.getWebviewView(b)._setVisible(c)}async $disposeWebviewView(b){const c=this.getWebviewView(b);this._webviewViews.delete(b),c.dispose(),this._extHostWebview.deleteWebview(b)}getWebviewView(b){const c=this._webviewViews.get(b);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=l}),define(De[305],Ie([1,0,4,31,32,3]),function(he,e,y,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new P.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new P.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new P.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new P.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new P.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new P.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,O.createDecorator)("outputService");var A;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new y.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new y.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(l){this.channels.has(l.id)||(this.channels.set(l.id,l),this._onDidRegisterChannel.fire(l.id))}getChannels(){const l=[];return this.channels.forEach(T=>l.push(T)),l}getChannel(l){return this.channels.get(l)}removeChannel(l){this.channels.delete(l),this._onDidRemoveChannel.fire(l)}}k.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new P.RawContextKey("activeOutputChannel","")}),define(De[126],Ie([1,0,5,3,17,19,12,305,68,27,51,156,23,15,30,4,6]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class a extends A.AbstractMessageLogger{get disposed(){return this._disposed}constructor(n,i,g,f,u){super(),this.id=n,this.name=i,this.logger=g,this.proxy=f,this.extension=u,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(g.getLevel()),this._register(g.onDidChangeLogLevel(E=>this.setLevel(E)))}get logLevel(){return this.getLevel()}appendLine(n){this.append(n+`
`)}append(n){this.info(n)}clear(){const n=this.offset;this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Clear,n)}replace(n){const i=this.offset;this.info(n),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Replace,i),this.visible&&this.logger.flush()}show(n,i){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof n=="boolean"?n:i))}hide(){this.proxy.$close(this.id)}log(n,i){this.offset+=c.VSBuffer.fromString(i).byteLength,(0,A.log)(this.logger,n,i),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class d extends a{appendLine(n){this.append(n)}}let t=class{constructor(n,i,g,f,u,E){this.initData=i,this.extHostFileSystem=g,this.extHostFileSystemInfo=f,this.loggerService=u,this.logService=E,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=n.getProxy(y.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(i.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(n){this.visibleChannelId=n;for(const[i,g]of this.channels)g.visible=i===this.visibleChannelId}createOutputChannel(n,i,g){if(n=n.trim(),!n)throw new Error("illegal argument `name`. must not be falsy");const f=typeof i=="object"&&i.log,u=(0,C.isString)(i)?i:void 0;if((0,C.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let E;const I=this.initData.environment.extensionLogLevel?.find(([w])=>O.ExtensionIdentifier.equals(g.identifier,w))?.[1];I&&(E=(0,A.parseLogLevel)(I));const _=f?this.doCreateLogOutputChannel(n,E,g):this.doCreateOutputChannel(n,u,g);return _.then(w=>{this.channels.set(w.id,w),w.visible=w.id===this.visibleChannelId}),f?this.createExtHostLogOutputChannel(n,E??this.logService.getLevel(),_):this.createExtHostOutputChannel(n,_)}async doCreateOutputChannel(n,i,g){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const f=await this.outputDirectoryPromise,u=this.extHostFileSystemInfo.extUri.joinPath(f,`${this.namePool++}-${n.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),E=this.loggerService.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.proxy.$register(n,u,i,g.identifier.value);return new a(I,n,E,this.proxy,g)}async doCreateLogOutputChannel(n,i,g){const f=await this.createExtensionLogDirectory(g),u=n.replace(/[\\/:\*\?"<>\|]/g,""),E=this.extHostFileSystemInfo.extUri.joinPath(f,`${u}.log`),I=`${g.identifier.value}.${u}`,_=this.loggerService.createLogger(E,{id:I,name:n,logLevel:i,extensionId:g.identifier.value});return new d(I,n,_,this.proxy,g)}createExtensionLogDirectory(n){let i=this.extensionLogDirectoryPromise.get(n.identifier.value);if(!i){const g=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,n.identifier.value);this.extensionLogDirectoryPromise.set(n.identifier.value,i=(async()=>{try{await this.extHostFileSystem.value.createDirectory(g)}catch(f){if((0,h.toFileSystemProviderErrorCode)(f)!==h.FileSystemProviderErrorCode.FileExists)throw f}return g})())}return i}createExtHostOutputChannel(n,i){let g=!1;const f=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return n},append(u){f(),i.then(E=>E.append(u))},appendLine(u){f(),i.then(E=>E.appendLine(u))},clear(){f(),i.then(u=>u.clear())},replace(u){f(),i.then(E=>E.replace(u))},show(u,E){f(),i.then(I=>I.show(u,E))},hide(){f(),i.then(u=>u.hide())},dispose(){g=!0,i.then(u=>u.dispose())}}}createExtHostLogOutputChannel(n,i,g){const f=new o.DisposableStore,u=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},E=f.add(new r.Emitter);function I(_){i=_,E.fire(_)}return g.then(_=>{f.add(_),_.logLevel!==i&&I(_.logLevel),f.add(_.onDidChangeLogLevel(w=>I(w)))}),{...this.createExtHostOutputChannel(n,g),get logLevel(){return i},onDidChangeLogLevel:E.event,trace(_,...w){u(),g.then(p=>p.trace(_,...w))},debug(_,...w){u(),g.then(p=>p.debug(_,...w))},info(_,...w){u(),g.then(p=>p.info(_,...w))},warn(_,...w){u(),g.then(p=>p.warn(_,...w))},error(_,...w){u(),g.then(p=>p.error(_,...w))},dispose(){f.dispose()}}}};e.ExtHostOutputService=t,e.ExtHostOutputService=t=je([$e(0,P.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,v.IExtHostConsumerFileSystem),$e(3,T.IExtHostFileSystemInfo),$e(4,A.ILoggerService),$e(5,A.ILogService)],t),e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(De[127],Ie([1,0,3,11]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,y.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let R=0;R<this.maxSampleCount;R++){const v=await P.getRoundTripTime();if(v===void 0)return;O=Math.min(O,v/2),await(0,k.timeout)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((R,v)=>R+v,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((R,v)=>R+v,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(De[306],Ie([1,0,191,54,31,50,42,6,4,127,21,26,11,112]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWindowConfiguration=e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.windowConfigurationNodeBase=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,y.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:k.ConfigurationScope.APPLICATION,title:(0,y.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,y.localize)(3,null),type:"object",order:101}),e.windowConfigurationNodeBase=Object.freeze({id:"window",order:8,title:(0,y.localize)(4,null),type:"object"}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class h{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new v.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new h;P.Registry.add(e.Extensions.ConfigurationMigration,r);let o=class extends R.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.configurationService=n,this.workspaceService=i,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async g=>{for(const f of g.added)await this.migrateConfigurationsForFolder(f,r.migrations)})),this.migrateConfigurations(r.migrations),this._register(r.onDidRegisterConfigurationMigration(g=>this.migrateConfigurations(g)))}async migrateConfigurations(n){await this.migrateConfigurationsForFolder(void 0,n);for(const i of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(i,n)}async migrateConfigurationsForFolder(n,i){await Promise.all([i.map(g=>this.migrateConfigurationsForFolderAndOverride(g,n?.uri))])}async migrateConfigurationsForFolderAndOverride(n,i){const g=this.configurationService.inspect(n.key,{resource:i}),f=this.workspaceService.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[u,E]of f){const I=g[u];if(!I)continue;const _=[];if(I.value!==void 0){const w=await this.runMigration(n,u,I.value,i,void 0);for(const p of w??[])_.push([p,[]])}for(const{identifiers:w,value:p}of I.overrides??[])if(p!==void 0){const D=await this.runMigration(n,u,p,i,w);for(const m of D??[])_.push([m,w])}_.length&&await Promise.allSettled(_.map(async([[w,p],D])=>this.configurationService.updateValue(w,p.value,{resource:i,overrideIdentifiers:D},E)))}}async runMigration(n,i,g,f,u){const E=_=>{const p=this.configurationService.inspect(_,{resource:f})[i];if(p)return u?p.overrides?.find(({identifiers:D})=>(0,b.equals)(D,u))?.value:p.value},I=await n.migrateFn(g,E);return Array.isArray(I)?I:[[n.key,I]]}};e.ConfigurationMigrationWorkbenchContribution=o,e.ConfigurationMigrationWorkbenchContribution=o=je([$e(0,A.IConfigurationService),$e(1,O.IWorkspaceContextService)],o);let a=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.remoteAgentService=n,this._ready=new c.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!T.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==T.OperatingSystem.Windows)return;P.Registry.as(k.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(5,null)},default:[],markdownDescription:(0,y.localize)(6,null),scope:k.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(7,null),scope:k.ConfigurationScope.MACHINE}}})}};e.DynamicWorkbenchSecurityConfiguration=a,e.DynamicWorkbenchSecurityConfiguration=a=je([$e(0,l.IRemoteAgentService)],a);const d="window.newWindowProfile";let t=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,i){super(),this.userDataProfilesService=n,this.configurationService=i,this.registerNewWindowProfileConfiguration(),this._register(this.userDataProfilesService.onDidChangeProfiles(g=>this.registerNewWindowProfileConfiguration())),this.setNewWindowProfile(),this.checkAndResetNewWindowProfileConfig(),this._register(i.onDidChangeConfiguration(g=>{g.source!==A.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(d)&&this.setNewWindowProfile()})),this._register(this.userDataProfilesService.onDidChangeProfiles(()=>this.checkAndResetNewWindowProfileConfig()))}registerNewWindowProfileConfiguration(){const n=P.Registry.as(k.Extensions.Configuration),i={...e.windowConfigurationNodeBase,properties:{[d]:{type:["string","null"],default:null,enum:[...this.userDataProfilesService.profiles.map(g=>g.name),null],enumItemLabels:[...this.userDataProfilesService.profiles.map(g=>""),(0,y.localize)(8,null)],description:(0,y.localize)(9,null),scope:k.ConfigurationScope.APPLICATION}}};this.configurationNode?n.updateConfigurations({add:[i],remove:[this.configurationNode]}):n.registerConfiguration(i),this.configurationNode=i}setNewWindowProfile(){const n=this.configurationService.getValue(d);this.newWindowProfile=n?this.userDataProfilesService.profiles.find(i=>i.name===n):void 0}checkAndResetNewWindowProfileConfig(){const n=this.configurationService.getValue(d);if(!n)return;const i=this.newWindowProfile?this.userDataProfilesService.profiles.find(g=>g.id===this.newWindowProfile.id):void 0;n!==i?.name&&this.configurationService.updateValue(d,i?.name)}};e.DynamicWindowConfiguration=t,e.DynamicWindowConfiguration=t=je([$e(0,C.IUserDataProfilesService),$e(1,A.IConfigurationService)],t)}),define(De[307],Ie([1,0,41,16,20,24,202,306,54,3,31]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=r,e.globMatchesResource=o,e.IEditorResolverService=(0,l.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const b=T.Registry.as(v.Extensions.Configuration),c={...R.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};b.registerConfiguration(c);var C;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(C||(e.RegisteredEditorPriority=C={}));var h;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(h||(e.ResolvedStatus=h={}));function r(a){switch(a){case C.exclusive:return 5;case C.default:return 4;case C.builtin:return 3;case C.option:default:return 1}}function o(a,d){if(new Set([k.Schemas.extension,k.Schemas.webviewPanel,k.Schemas.vscodeWorkspaceTrust,k.Schemas.vscodeSettings]).has(d.scheme))return!1;const n=typeof a=="string"&&a.indexOf(P.posix.sep)>=0?`${d.scheme}:${d.path}`:(0,O.basename)(d);return y.match(typeof a=="string"?a.toLowerCase():a,n.toLowerCase())}}),define(De[308],Ie([1,0,53,16,20,21,24,2,3,225,50,245,127]),function(he,e,y,k,P,O,A,R,v,l,T,b,c){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,v.createDecorator)("pathService");let h=C=class{constructor(o,a,d,t){this.localUserHome=o,this.remoteAgentService=a,this.environmentService=d,this.contextService=t,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||O.OS)(),this.resolveUserHome=(async()=>{const s=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=s?.userHome??o})()}hasValidBasename(o,a,d){return typeof a=="string"||typeof a>"u"?this.resolveOS.then(t=>this.doHasValidBasename(o,t,a)):this.doHasValidBasename(o,a,d)}doHasValidBasename(o,a,d){return o.scheme===k.Schemas.file||o.scheme===k.Schemas.vscodeRemote?(0,y.isValidBasename)(d??(0,A.basename)(o),a===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return C.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(o,a){if(o.remoteAuthority)return k.Schemas.vscodeRemote;const d=(0,l.getVirtualWorkspaceScheme)(a.getWorkspace());if(d)return d;const t=a.getWorkspace().folders[0];if(t)return t.uri.scheme;const s=a.getWorkspace().configuration;return s?s.scheme:k.Schemas.file}userHome(o){return o?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(o=>o===O.OperatingSystem.Windows?P.win32:P.posix)}async fileURI(o){let a="";if(await this.resolveOS===O.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const t=o.indexOf("/",2);t===-1?(a=o.substring(2),o="/"):(a=o.substring(2,t),o=o.substring(t)||"/")}return R.URI.from({scheme:k.Schemas.file,authority:a,path:o,query:"",fragment:""})}};e.AbstractPathService=h,e.AbstractPathService=h=C=je([$e(1,c.IRemoteAgentService),$e(2,b.IWorkbenchEnvironmentService),$e(3,T.IWorkspaceContextService)],h)}),define(De[128],Ie([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class y{constructor(A,R){this.line=A,this.character=R}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,R){return new y(0,0)}with(A){return new y(0,0)}}e.Position=y;class k{constructor(A,R,v,l){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,R),this.end=new y(v,l)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new k(0,0,0,0)}with(A){return new k(0,0,0,0)}}e.Range=k;var P;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(De[43],Ie([1,0,18,41,26,53,13,3,20,14,128,11]),function(he,e,y,k,P,O,A,R,v,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=a,e.isFileMatch=d,e.isProgressMessage=t,e.getExcludes=_,e.pathIncludedInQuery=w,e.deserializeSearchError=m,e.serializeSearchError=S,e.isSerializedSearchComplete=M,e.isSerializedSearchSuccess=L,e.isSerializedFileMatch=H,e.isFilePatternMatch=V,e.resolvePatternsForProvider=N,e.hasSiblingPromiseFn=re,e.hasSiblingFn=fe,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",C=" characters skipped \u27EB",h=(c.length+C.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var r;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text",oe[oe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text",oe[oe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function a(oe){return!!oe.preview}function d(oe){return!!oe.resource}function t(oe){return!!oe.message}var s;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class n{constructor(pe){this.resource=pe,this.results=[]}}e.FileMatch=n;class i{constructor(pe,ve,se,Te){this.ranges=ve,this.webviewIndex=Te;const Me=Array.isArray(ve)?ve:[ve];if(se&&se.matchLines===1&&g(Me)){pe=(0,A.getNLines)(pe,se.matchLines);let Q="",W=0,ie=0;const _e=Math.floor(se.charsPerLine/5),de=[];for(const Se of Me){const ae=Math.max(Se.startColumn-_e,0),X=Se.startColumn+se.charsPerLine;if(ae>ie+_e+h){const J=c+(ae-ie)+C;Q+=J+pe.slice(ae,X),W+=ae-(ie+J.length)}else Q+=pe.slice(ie,X);de.push(new u(0,Se.startColumn-W,Se.endColumn-W)),ie=X}this.preview={text:Q,matches:Array.isArray(this.ranges)?de:de[0]}}else{const Q=Array.isArray(ve)?ve[0].startLineNumber:ve.startLineNumber;this.preview={text:pe,matches:(0,y.mapArrayOrNot)(ve,W=>new f(W.startLineNumber-Q,W.startColumn,W.endLineNumber-Q,W.endColumn))}}}}e.TextSearchMatch=i;function g(oe){const pe=oe[0].startLineNumber;for(const ve of oe)if(ve.startLineNumber!==pe||ve.endLineNumber!==pe)return!1;return!0}class f{constructor(pe,ve,se,Te){this.startLineNumber=pe,this.startColumn=ve,this.endLineNumber=se,this.endColumn=Te}}e.SearchRange=f;class u extends f{constructor(pe,ve,se){super(pe,ve,pe,se)}}e.OneLineRange=u;var E;(function(oe){oe.List="list",oe.Tree="tree"})(E||(e.ViewMode=E={}));var I;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function _(oe,pe=!0){const ve=oe&&oe.files&&oe.files.exclude,se=pe&&oe&&oe.search&&oe.search.exclude;if(!ve&&!se)return;if(!ve||!se)return ve||se;let Te=Object.create(null);return Te=P.mixin(Te,P.deepClone(ve)),Te=P.mixin(Te,P.deepClone(se),!0),Te}function w(oe,pe){return oe.excludePattern&&k.match(oe.excludePattern,pe)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&k.match(oe.includePattern,pe)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ve=>{const se=ve.folder.fsPath;if(O.isEqualOrParent(pe,se)){const Te=v.relative(se,pe);return!ve.includePattern||!!k.match(ve.includePattern,Te)}else return!1}):!1:!0}var p;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class D extends Error{constructor(pe,ve){super(pe),this.code=ve}}e.SearchError=D;function m(oe){const pe=oe.message;if((0,l.isCancellationError)(oe))return new D(pe,p.canceled);try{const ve=JSON.parse(pe);return new D(ve.message,ve.code)}catch{return new D(pe,p.other)}}function S(oe){const pe={message:oe.message,code:oe.code};return new Error(JSON.stringify(pe))}function M(oe){return oe.type==="error"?!0:oe.type==="success"}function L(oe){return oe.type==="success"}function H(oe){return!!oe.path}function V(oe,pe,ve=!0){const se=oe.searchPath?oe.searchPath:oe.relativePath;return ve?(0,A.fuzzyContains)(se,pe):k.match(pe,se)}class ${constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function N(oe,pe){const ve={...oe||{},...pe||{}};return Object.keys(ve).filter(se=>{const Te=ve[se];return typeof Te=="boolean"&&Te})}class F{constructor(pe,ve){this._parsedIncludeExpression=null,this._excludeExpression={...pe.excludePattern||{},...ve.excludePattern||{}},this._parsedExcludeExpression=k.parse(this._excludeExpression);let se=pe.includePattern;ve.includePattern&&(se?se={...se,...ve.includePattern}:se=ve.includePattern),se&&(this._parsedIncludeExpression=k.parse(se))}matchesExcludesSync(pe,ve,se){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,ve,se))}includedInQuerySync(pe,ve,se){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,ve,se)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(pe,ve,se))}includedInQuery(pe,ve,se){const Te=this._parsedExcludeExpression(pe,ve,se),Me=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(pe,ve,se):!0;return(0,b.isThenable)(Te)?Te.then(Q=>Q?!1:Me()):Me()}hasSiblingExcludeClauses(){return Y(this._excludeExpression)}}e.QueryGlobTester=F;function Y(oe){for(const pe in oe)if(typeof oe[pe]!="boolean")return!0;return!1}function re(oe){if(!oe)return;let pe;return ve=>(pe||(pe=(oe()||Promise.resolve([])).then(se=>se?Ee(se):{})),pe.then(se=>!!se[ve]))}function fe(oe){if(!oe)return;let pe;return ve=>{if(!pe){const se=oe();pe=se?Ee(se):{}}return!!pe[ve]}}function Ee(oe){const pe={};for(const ve of oe)pe[ve]=!0;return pe}}),define(De[44],Ie([1,0,18,11,22,4,6,58,16,137,24,13,2,190,30,3,12,213,50,51,27,17,10,7,65,43,5,49]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s,n,i,g,f,u,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function _(H,V,$){return new T.ExtUri(N=>m(N,$)).isEqual(H,V)}function w(H,V,$){return _(H.uri,V.uri,$)?0:(0,b.compare)(H.uri.toString(),V.uri.toString())}function p(H,V,$){return H.index!==V.index?H.index<V.index?-1:1:_(H.uri,V.uri,$)?(0,b.compare)(H.name,V.name):(0,b.compare)(H.uri.toString(),V.uri.toString())}function D(H,V,$,N){const F=H.slice(0).sort((re,fe)=>$(re,fe,N)),Y=V.slice(0).sort((re,fe)=>$(re,fe,N));return(0,y.delta)(F,Y,(re,fe)=>$(re,fe,N))}function m(H,V){const $=V.getCapabilities(H.scheme);return!($&&$&h.FileSystemProviderCapabilities.PathCaseSensitive)}class S extends d.Workspace{static toExtHostWorkspace(V,$,N,F){if(!V)return{workspace:null,added:[],removed:[]};const{id:Y,name:re,folders:fe,configuration:Ee,transient:oe,isUntitled:pe}=V,ve=[],se=$;$?fe.forEach((W,ie)=>{const _e=c.URI.revive(W.uri),de=S._findFolder(N||$,_e,F);de?(de.name=W.name,de.index=W.index,ve.push(de)):ve.push({uri:_e,name:W.name,index:ie})}):ve.push(...fe.map(({uri:W,name:ie,index:_e})=>({uri:c.URI.revive(W),name:ie,index:_e}))),ve.sort((W,ie)=>W.index<ie.index?-1:1);const Te=new S(Y,re,ve,!!oe,Ee?c.URI.revive(Ee):null,!!pe,W=>m(W,F)),{added:Me,removed:Q}=D(se?se.workspaceFolders:[],Te.workspaceFolders,w,F);return{workspace:Te,added:Me,removed:Q}}static _findFolder(V,$,N){for(let F=0;F<V.folders.length;F++){const Y=V.workspaceFolders[F];if(_(Y.uri,$,N))return Y}}constructor(V,$,N,F,Y,re,fe){super(V,N.map(Ee=>new d.WorkspaceFolder(Ee)),F,Y,fe),this._name=$,this._isUntitled=re,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(fe),N.forEach(Ee=>{this._workspaceFolders.push(Ee),this._structure.set(Ee.uri,Ee)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(V,$){return $&&this._structure.get(V)&&(V=(0,T.dirname)(V)),this._structure.findSubstr(V)}resolveWorkspaceFolder(V){return this._structure.get(V)}}let M=class{constructor(V,$,N,F,Y){this._onDidChangeWorkspace=new O.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new O.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new O.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=F,this._extHostFileSystemInfo=N,this._uriTransformerService=Y,this._requestIdProvider=new l.Counter,this._barrier=new k.Barrier,this._proxy=V.getProxy(E.MainContext.MainThreadWorkspace),this._messageService=V.getProxy(E.MainContext.MainThreadMessageService);const re=$.workspace;this._confirmedWorkspace=re?new S(re.id,re.name,[],!!re.transient,re.configuration?c.URI.revive(re.configuration):null,!!re.isUntitled,fe=>m(fe,N)):void 0}$initializeWorkspace(V,$){this._trusted=$,this.$acceptWorkspaceData(V),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:v.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(V,$,N,...F){const Y=[];if(Array.isArray(F)&&F.forEach(pe=>{c.URI.isUri(pe.uri)&&!Y.some(ve=>_(ve.uri,pe.uri,this._extHostFileSystemInfo))&&Y.push({uri:pe.uri,name:pe.name||(0,T.basenameOrAuthority)(pe.uri)})}),this._unconfirmedWorkspace||[$,N].some(pe=>typeof pe!="number"||pe<0)||N===0&&Y.length===0)return!1;const re=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+N>re.length)return!1;const fe=re.slice(0);fe.splice($,N,...Y.map(pe=>({uri:pe.uri,name:pe.name||(0,T.basenameOrAuthority)(pe.uri),index:void 0})));for(let pe=0;pe<fe.length;pe++){const ve=fe[pe];if(fe.some((se,Te)=>Te!==pe&&_(ve.uri,se.uri,this._extHostFileSystemInfo)))return!1}fe.forEach((pe,ve)=>pe.index=ve);const{added:Ee,removed:oe}=D(re,fe,p,this._extHostFileSystemInfo);if(Ee.length===0&&oe.length===0)return!1;if(this._proxy){const pe=V.displayName||V.name;this._proxy.$updateWorkspaceFolders(pe,$,N,Y).then(void 0,ve=>{this._unconfirmedWorkspace=void 0;const se={source:{identifier:V.identifier,label:V.displayName||V.name}};this._messageService.$showMessage(a.Severity.Error,(0,C.localize)(0,null,pe,ve.toString()),se,[])})}return this.trySetWorkspaceFolders(fe),!0}getWorkspaceFolder(V,$){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(V,$)}async getWorkspaceFolder2(V,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(V,$)}async resolveWorkspaceFolder(V){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(V)}getPath(){if(!this._actualWorkspace)return;const{folders:V}=this._actualWorkspace;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,$){let N,F="";if(typeof V=="string"?(N=c.URI.file(V),F=V):typeof V<"u"&&(N=V,F=V.fsPath),!N)return F;const Y=this.getWorkspaceFolder(N,!0);if(!Y)return F;typeof $>"u"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let re=(0,T.relativePath)(Y.uri,N);return $&&Y.name&&(re=`${Y.name}/${re}`),re}trySetWorkspaceFolders(V){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:V,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:$,added:N,removed:F}=S.toExtHostWorkspace(V,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:F}))}findFiles(V,$,N,F,Y=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let re="",fe=!0;return $===null?fe=!1:$!==void 0&&(typeof $=="string"?re=$:re=$.pattern),this._findFilesImpl(V,void 0,{exclude:re,maxResults:N,useDefaultExcludes:fe,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Y)}findFiles2(V,$={},N,F=P.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,V,$,F)}async _findFilesImpl(V,$,N,F=P.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const Y=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,re={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:Y,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let fe;if(V){const{includePattern:Ee,folder:oe}=L(i.GlobPattern.from(V));fe=oe,re.includePattern=Ee}else{const{includePattern:Ee,folder:oe}=L(i.GlobPattern.from($));fe=oe,re.filePattern=Ee}return this._proxy.$startFileSearch(fe??null,re,F).then(Ee=>Array.isArray(Ee)?Ee.map(oe=>c.URI.revive(oe)):[])}async findTextInFiles(V,$,N,F,Y=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const re=this._requestIdProvider.getNext(),fe=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:Ee,folder:oe}=L(i.GlobPattern.from($.include)),pe=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,ve={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:fe,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:Ee,excludePattern:pe},se=!1;if(this._activeSearchCallbacks[re]=Te=>{if(se)return;const Me=c.URI.revive(Te.resource);Te.results.forEach(Q=>{const W=(0,I.revive)(Q);(0,u.resultIsMatch)(W)?N({uri:Me,preview:{text:W.preview.text,matches:(0,y.mapArrayOrNot)(W.preview.matches,ie=>new g.Range(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,y.mapArrayOrNot)(W.ranges,ie=>new g.Range(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):N({uri:Me,text:W.text,lineNumber:W.lineNumber})})},Y.isCancellationRequested)return{};try{const Te=await this._proxy.$startTextSearch(V,oe??null,ve,re,Y);return delete this._activeSearchCallbacks[re],Te||{}}catch(Te){throw delete this._activeSearchCallbacks[re],Te}}$handleTextSearchResult(V,$){this._activeSearchCallbacks[$]?.(V)}async save(V){const $=await this._proxy.$save(V,{saveAs:!1});return c.URI.revive($)}async saveAs(V){const $=await this._proxy.$save(V,{saveAs:!0});return c.URI.revive($)}saveAll(V){return this._proxy.$saveAll(V)}resolveProxy(V){return this._proxy.$resolveProxy(V)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(V){return this._proxy.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(V,$){if(this._editSessionIdentityProviders.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this._editSessionIdentityProviders.set(V,$);const N=this._uriTransformerService.transformOutgoingScheme(V),F=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(F,N),(0,A.toDisposable)(()=>{this._editSessionIdentityProviders.delete(V),this._proxy.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(V,$){this._logService.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(c.URI.revive(V));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const F=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!F),!F)return;const Y=await F.provideEditSessionIdentity(N,$);if(this._logService.info("Provider returned edit session identifier: ",Y),!!Y)return Y}async $provideEditSessionIdentityMatch(V,$,N,F){this._logService.info("Getting edit session identifier for workspaceFolder",V);const Y=await this.resolveWorkspaceFolder(c.URI.revive(V));if(!Y){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",Y);const re=this._editSessionIdentityProviders.get(Y.uri.scheme);if(this._logService.info(`Provider for scheme ${Y.uri.scheme} is defined: `,!!re),!re)return;const fe=await re.provideEditSessionIdentityMatch?.($,N,F);if(this._logService.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(V){return($,N,F)=>{const Y=function(fe){$.call(N,fe)};return Y.extension=V,this._onWillCreateEditSessionIdentityEvent.event(Y,void 0,F)}}async $onWillCreateEditSessionIdentity(V,$,N){const F=await this.resolveWorkspaceFolder(c.URI.revive(V));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:F},$,async(Y,re)=>{const fe=Date.now();await Promise.resolve(Y),Date.now()-fe>N&&this._logService.warn("SLOW edit session create-participant",re.extension.identifier)}),$.isCancellationRequested}registerCanonicalUriProvider(V,$){if(this._canonicalUriProviders.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this._canonicalUriProviders.set(V,$);const N=this._uriTransformerService.transformOutgoingScheme(V),F=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(F,N),(0,A.toDisposable)(()=>{this._canonicalUriProviders.delete(V),this._proxy.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(V,$,N){const F=this._canonicalUriProviders.get(V.scheme);if(!F)return;const Y=await F.provideCanonicalUri?.(c.URI.revive(V),$,N);if(Y)return Y}async $provideCanonicalUri(V,$,N){return this.provideCanonicalUri(c.URI.revive(V),{targetScheme:$},N)}};e.ExtHostWorkspace=M,e.ExtHostWorkspace=M=je([$e(0,n.IExtHostRpcService),$e(1,s.IExtHostInitDataService),$e(2,t.IExtHostFileSystemInfo),$e(3,o.ILogService),$e(4,f.IURITransformerService)],M),e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function L(H){let V,$;return H&&(typeof H=="string"?V=H:(V=H.pattern,$=c.URI.revive(H.baseUri))),{includePattern:V,folder:$}}}),define(De[45],Ie([1,0,26,4,44,5,7,42,214,54,15,11,3,17,12,2]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(f,u){if(u){const E=u.split(".");let I=f;for(let _=0;I&&_<E.length;_++)I=I[E[_]];return I}}function a(f){return f instanceof r.URI}function d(f){return f&&f.uri instanceof r.URI&&f.languageId&&typeof f.languageId=="string"}function t(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function s(f){return f&&f.uri instanceof r.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function n(f){if(a(f))return{resource:f};if(d(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(t(f))return{overrideIdentifier:f.languageId};if(s(f))return{resource:f.uri};if(f===null)return{resource:null}}let i=class{constructor(u,E,I){this._proxy=u.getProxy(O.MainContext.MainThreadConfiguration),this._extHostWorkspace=E,this._logService=I,this._barrier=new b.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new g(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,E){this.getConfigProvider().then(I=>I.$acceptConfigurationChanged(u,E))}};e.ExtHostConfiguration=i,e.ExtHostConfiguration=i=je([$e(0,C.IExtHostRpcService),$e(1,P.IExtHostWorkspace),$e(2,h.ILogService)],i);class g{constructor(u,E,I,_){this._onDidChangeConfiguration=new k.Emitter,this._proxy=u,this._logService=_,this._extHostWorkspace=E,this._configuration=v.Configuration.parse(I,_),this._configurationScopes=this._toMap(I.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,E){const I={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=v.Configuration.parse(u,this._logService),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(E,I))}getConfiguration(u,E,I){const _=n(E)||{},w=this._toReadonlyValue(u?o(this._configuration.getValue(void 0,_,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,_,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,_,I?.identifier);function p(m){if(m==null)return null;if(typeof m=="boolean")return m?R.ConfigurationTarget.USER:R.ConfigurationTarget.WORKSPACE;switch(m){case A.ConfigurationTarget.Global:return R.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return R.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return R.ConfigurationTarget.WORKSPACE_FOLDER}}const D={has(m){return typeof o(w,m)<"u"},get:(m,S)=>{this._validateConfigurationAccess(u?`${u}.${m}`:m,_,I?.identifier);let M=o(w,m);if(typeof M>"u")M=S;else{let L;const H=(V,$)=>{if((0,T.isObject)(V)){let N;const F=()=>{L=L||(0,y.deepClone)(w),N=N||o(L,$)};return new Proxy(V,{get:(Y,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return F(),()=>N;if(L)return N=N||o(L,$),N[re];const fe=Y[re];return typeof re=="string"?H(fe,`${$}.${re}`):fe},set:(Y,re,fe)=>(F(),N&&(N[re]=fe),!0),deleteProperty:(Y,re)=>(F(),N&&delete N[re],!0),defineProperty:(Y,re,fe)=>(F(),N&&Object.defineProperty(N,re,fe),!0)})}return Array.isArray(V)?(0,y.deepClone)(V):V};M=H(M,m)}return M},update:(m,S,M,L)=>{m=u?`${u}.${m}`:m;const H=p(M);return S!==void 0?this._proxy.$updateConfigurationOption(H,m,S,_,L):this._proxy.$removeConfigurationOption(H,m,_,L)},inspect:m=>{m=u?`${u}.${m}`:m;const S=this._configuration.inspect(m,_,this._extHostWorkspace.workspace);if(S)return{key:m,defaultValue:(0,y.deepClone)(S.policy?.value??S.default?.value),globalValue:(0,y.deepClone)(S.user?.value??S.application?.value),workspaceValue:(0,y.deepClone)(S.workspace?.value),workspaceFolderValue:(0,y.deepClone)(S.workspaceFolder?.value),defaultLanguageValue:(0,y.deepClone)(S.default?.override),globalLanguageValue:(0,y.deepClone)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,y.deepClone)(S.workspace?.override),workspaceFolderLanguageValue:(0,y.deepClone)(S.workspaceFolder?.override),languageIds:(0,y.deepClone)(S.overrideIdentifiers)}}};return typeof w=="object"&&(0,y.mixin)(D,w,!1),Object.freeze(D)}_toReadonlyValue(u){const E=I=>(0,T.isObject)(I)?new Proxy(I,{get:(_,w)=>E(_[w]),set:(_,w,p)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(_,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(_,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:_=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):I;return E(u)}_validateConfigurationAccess(u,E,I){const _=l.OVERRIDE_PROPERTY_REGEX.test(u)?l.ConfigurationScope.RESOURCE:this._configurationScopes.get(u),w=I?`[${I.value}] `:"";if(l.ConfigurationScope.RESOURCE===_){typeof E?.resource>"u"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(l.ConfigurationScope.WINDOW===_){E?.resource&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,E){const I=new v.ConfigurationChangeEvent(u,E,this._configuration,this._extHostWorkspace.workspace,this._logService);return Object.freeze({affectsConfiguration:(_,w)=>I.affectsConfiguration(_,n(w))})}_toMap(u){return u.reduce((E,I)=>(E.set(I[0],I[1]),E),new Map)}}e.ExtHostConfigProvider=g,e.IExtHostConfiguration=(0,c.createDecorator)("IExtHostConfiguration")}),define(De[129],Ie([1,0,2,11,4,5,7,44,71,45,22,57,17,27,3,16,21,12,85,250,14]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(L){function H($){if($!=null)return $}L.from=H;function V($){if($!=null)return $}L.to=V})(n||(n={}));var i;(function(L){function H($){if($!=null)return $}L.from=H;function V($){if($!=null)return $}L.to=V})(i||(i={}));var g;(function(L){function H($){if($!=null)return $}L.from=H;function V($){if($!=null)return $}L.to=V})(g||(g={}));var f;(function(L){function H(N){if(N){const F=N;return F&&!!F.process}else return!1}L.is=H;function V(N){if(N==null)return;const F={process:N.process,args:N.args};return N.options&&(F.options=g.from(N.options)),F}L.from=V;function $(N){if(N!=null)return new A.ProcessExecution(N.process,N.args,N.options)}L.to=$})(f||(f={}));var u;(function(L){function H($){if($!=null)return $}L.from=H;function V($){if($!=null)return $}L.to=V})(u||(u={}));var E;(function(L){function H(N){if(N){const F=N;return F&&(!!F.commandLine||!!F.command)}else return!1}L.is=H;function V(N){if(N==null)return;const F={};return N.commandLine!==void 0?F.commandLine=N.commandLine:(F.command=N.command,F.args=N.args),N.options&&(F.options=u.from(N.options)),F}L.from=V;function $(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.ShellExecution(N.commandLine,N.options):new A.ShellExecution(N.command,N.args?N.args:[],N.options)}L.to=$})(E||(E={}));var I;(function(L){function H(N){if(N){const F=N;return F&&F.customExecution==="customExecution"}else return!1}L.is=H;function V(N){return{customExecution:"customExecution"}}L.from=V;function $(N,F){return F.get(N)}L.to=$})(I||(e.CustomExecutionDTO=I={}));var _;(function(L){function H(V,$){let N;return V.scope!==void 0&&typeof V.scope!="number"?N=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===A.TaskScope.Workspace&&$&&$.workspaceFile?N=$.workspaceFile:N=t.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:N}}L.from=H})(_||(e.TaskHandleDTO=_={}));var w;(function(L){function H(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}L.from=H})(w||(w={}));var p;(function(L){function H(N,F){if(N==null)return[];const Y=[];for(const re of N){const fe=V(re,F);fe&&Y.push(fe)}return Y}L.fromMany=H;function V(N,F){if(N==null)return;let Y;N.execution instanceof A.ProcessExecution?Y=f.from(N.execution):N.execution instanceof A.ShellExecution?Y=E.from(N.execution):N.execution&&N.execution instanceof A.CustomExecution&&(Y=I.from(N.execution));const re=n.from(N.definition);let fe;return N.scope?typeof N.scope=="number"?fe=N.scope:fe=N.scope.uri:fe=A.TaskScope.Workspace,!re||!fe?void 0:{_id:N._id,definition:re,name:N.name,source:{extensionId:F.identifier.value,label:N.source,scope:fe},execution:Y,isBackground:N.isBackground,group:w.from(N.group),presentationOptions:i.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}L.from=V;async function $(N,F,Y){if(N==null)return;let re;f.is(N.execution)?re=f.to(N.execution):E.is(N.execution)?re=E.to(N.execution):I.is(N.execution)&&(re=I.to(N._id,Y));const fe=n.to(N.definition);let Ee;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Ee=N.source.scope:Ee=await F.resolveWorkspaceFolder(y.URI.revive(N.source.scope)):Ee=A.TaskScope.Workspace),!fe||!Ee)return;const oe=new A.Task(fe,Ee,N.name,N.source.label,re,N.problemMatchers);return N.isBackground!==void 0&&(oe.isBackground=N.isBackground),N.group!==void 0&&(oe.group=A.TaskGroup.from(N.group._id),oe.group&&N.group.isDefault&&(oe.group=new A.TaskGroup(oe.group.id,oe.group.label),N.group.isDefault===!0&&(oe.group.isDefault=N.group.isDefault))),N.presentationOptions&&(oe.presentationOptions=i.to(N.presentationOptions)),N._id&&(oe._id=N._id),N.detail&&(oe.detail=N.detail),oe}L.to=$})(p||(e.TaskDTO=p={}));var D;(function(L){function H($){return $}L.from=H;function V($){if($)return Object.assign(Object.create(null),$)}L.to=V})(D||(D={}));class m{#e;constructor(H,V,$){this._id=V,this._task=$,this.#e=H}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}let S=class{constructor(H,V,$,N,F,Y,re,fe){this._onDidExecuteTask=new P.Emitter,this._onDidTerminateTask=new P.Emitter,this._onDidTaskProcessStarted=new P.Emitter,this._onDidTaskProcessEnded=new P.Emitter,this._proxy=H.getProxy(O.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=N,this._configurationService=F,this._terminalService=Y,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=re,this._deprecationService=fe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,V,$){if(!$)return new A.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:V,provider:$,extension:H}),this._proxy.$registerTaskProvider(N,V),new A.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(H,V){this._proxy.$registerTaskSystem(H,V)}fetchTasks(H){return this._proxy.$fetchTasks(D.from(H)).then(async V=>{const $=[];for(const N of V){const F=await p.to(N,this._workspaceProvider,this._providedCustomExecutions2);F&&$.push(F)}return $})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(V=>H.push(V)),H}terminateTask(H){if(!(H instanceof m))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,V,$){const N=this._providedCustomExecutions2.get(H.id);N&&(this._activeCustomExecutions2.set(H.id,N),this._terminalService.attachPtyToTerminal(V,await N.callback($))),this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){if(!this._taskExecutionPromises.has(H.id))return;const V=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const V=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:V,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const V=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:H.exitCode})}$provideTasks(H,V){const $=this._handlers.get(H);if(!$)return Promise.reject(new Error("no handler found"));const N=[],F=(0,k.asPromise)(()=>$.provider.provideTasks(T.CancellationToken.None)).then(Y=>this.provideTasksInternal(V,N,$,Y));return new Promise(Y=>{F.then(re=>{Promise.all(N).then(()=>{Y(re)})})})}async $resolveTask(H,V){const $=this._handlers.get(H);if(!$)return Promise.reject(new Error("no handler found"));if(V.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${$.type}].`);const N=await p.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const F=await $.provider.resolveTask(N,T.CancellationToken.None);if(!F)return;this.checkDeprecation(F,$);const Y=p.from(F,$.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(F.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return I.is(Y.execution)&&await this.addCustomExecution(Y,F,!0),await this.resolveTaskInternal(Y)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,V,$){const N=await this._proxy.$createTaskId(H);!$&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,V.execution)),this._providedCustomExecutions2.set(N,V.execution)}async getTaskExecution(H,V){if(typeof H=="string"){const F=this._taskExecutionPromises.get(H);if(!F)throw new s.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return F}const $=this._taskExecutionPromises.get(H.id);if($)return $;let N;return V?N=Promise.resolve(new m(this,H.id,V)):N=p.to(H.task,this._workspaceProvider,this._providedCustomExecutions2).then(F=>{if(!F)throw new s.ErrorNoTelemetry("Unexpected: Task does not exist.");return new m(this,H.id,F)}),this._taskExecutionPromises.set(H.id,N),N.then(F=>(this._taskExecutions.set(H.id,F),F))}checkDeprecation(H,V){H._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));const $=this._notProvidedCustomExecutions.values();let N=$.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=$.next()}};e.ExtHostTaskBase=S,e.ExtHostTaskBase=S=je([$e(0,c.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,R.IExtHostWorkspace),$e(3,v.IExtHostDocumentsAndEditors),$e(4,l.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,a.ILogService),$e(7,d.IExtHostApiDeprecationService)],S);let M=class extends S{constructor(H,V,$,N,F,Y,re,fe){super(H,V,$,N,F,Y,re,fe),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(o.Platform.Web)})}async executeTask(H,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const $=p.from(V,H);if($===void 0)throw new Error("Task is not valid");if(I.is($.execution))await this.addCustomExecution($,V,!1);else throw new s.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution($),V);return this._proxy.$executeTask($).catch(F=>{throw new Error(F)}),N}provideTasksInternal(H,V,$,N){const F=[];if(N)for(const Y of N){if(this.checkDeprecation(Y,$),!Y.definition||!H[Y.definition.type]){const fe=Y.source?Y.source:"No task source";this._logService.warn(`The task [${fe}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const re=p.from(Y,$.extension);re&&I.is(re.execution)?(F.push(re),V.push(this.addCustomExecution(re,Y,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:F,extension:$.extension}}async resolveTaskInternal(H){if(I.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,V,$){}};e.WorkerExtHostTask=M,e.WorkerExtHostTask=M=je([$e(0,c.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,R.IExtHostWorkspace),$e(3,v.IExtHostDocumentsAndEditors),$e(4,l.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,a.ILogService),$e(7,d.IExtHostApiDeprecationService)],M),e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(De[309],Ie([1,0,43,33]),function(he,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=P,e.genericCellMatchesToTextSearchMatches=O;function P(A){return"cellResults"in A}e.rawCellPrefix="rawCell#";function O(A,R){let v=-1;const l=[];let T=[];return A.forEach(c=>{c.range.startLineNumber!==v&&T.length>0&&(l.push([...T]),T=[]),T.push(c),v=c.range.endLineNumber}),T.length>0&&l.push([...T]),l.map(c=>{const C=[],h=c[0].range.startLineNumber,r=c[c.length-1].range.endLineNumber;for(let o=h;o<=r;o++)C.push(R.getLineContent(o));return new y.TextSearchMatch(C.join(`
`)+`
`,c.map(o=>new k.Range(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(De[310],Ie([1,0,184,23,4,6,29,37,13,15,2,30,80,5,39,10,7,38,286,122,26,16,43,239,309,307]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s,n,i,g,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class E{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(_=>_.apiEditor)}constructor(_,w,p,D,m,S,M){this._textDocumentsAndEditors=p,this._textDocuments=D,this._extHostFileSystem=m,this._extHostSearch=S,this._logService=M,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new P.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new P.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new P.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new P.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new c.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=_.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=_.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=_.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===R.MarshalledId.NotebookCellActionContext){const H=L.notebookEditor?.notebookUri,V=L.cell.handle,N=this._documents.get(H)?.getCell(V);if(N)return N.apiCell}if(L&&L.$mid===R.MarshalledId.NotebookActionContext){const H=L.uri,V=this._documents.get(H);if(V)return V.apiNotebook}return L}}),E._registerApiCommands(w)}getEditorById(_){const w=this._editors.get(_);if(!w)throw new Error(`unknown text editor: ${_}. known editors: ${[...this._editors.keys()]} `);return w}getIdByEditor(_){for(const[w,p]of this._editors)if(p.apiEditor===_)return w}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(_,w){const p=this._documents.get(_);if(!p&&!w)throw new Error(`NO notebook document for '${_}'`);return p}static _convertNotebookRegistrationData(_,w){if(!w)return;const p=w.filenamePattern.map(D=>r.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(w.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:_.identifier,providerDisplayName:_.displayName||_.name,displayName:w.displayName,filenamePattern:p,exclusive:w.exclusive||!1}}registerNotebookCellStatusBarItemProvider(_,w,p){const D=E._notebookStatusBarItemProviderHandlePool++,m=typeof p.onDidChangeCellStatusBarItems=="function"?E._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(D,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(D,m,w);let S;return m!==void 0&&(S=p.onDidChangeCellStatusBarItems(M=>this._notebookProxy.$emitCellStatusBarEvent(m))),new o.Disposable(()=>{this._notebookStatusBarItemProviders.delete(D),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(D,m),S?.dispose()})}async createNotebookDocument(_){const w=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:_.viewType,content:_.content&&r.NotebookData.from(_.content)});return T.URI.revive(w)}async openNotebookDocument(_){const w=this._documents.get(_);if(w)return w.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(_),D=this._documents.get(T.URI.revive(p));return(0,l.assertIsDefined)(D?.apiNotebook)}async showNotebookDocument(_,w){T.URI.isUri(_)&&(_=await this.openNotebookDocument(_));let p;typeof w=="object"?p={position:r.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(r.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:p={preserveFocus:!1};const D=await this._notebookEditorsProxy.$tryShowNotebookDocument(_.uri,_.notebookType,p),m=D&&this._editors.get(D)?.apiEditor;if(m)return m;throw D?new Error(`Could NOT open editor for "${_.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${_.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(_,w,p,D){const m=this._notebookStatusBarItemProviders.get(_),S=T.URI.revive(w),M=this._documents.get(S);if(!M||!m)return;const L=M.getCellFromIndex(p);if(!L)return;const H=await m.provideCellStatusBarItems(L.apiCell,D);if(!H)return;const V=new O.DisposableStore,$=this._statusBarCache.add([V]),F=(Array.isArray(H)?H:[H]).map(Y=>r.NotebookStatusBarItem.from(Y,this._commandsConverter,V));return{cacheId:$,items:F}}$releaseNotebookCellStatusBarItems(_){this._statusBarCache.delete(_)}registerNotebookSerializer(_,w,p,D,m){if((0,v.isFalsyOrWhitespace)(w))throw new Error("viewType cannot be empty or just whitespace");const S=this._handlePool++;return this._notebookSerializer.set(S,{viewType:w,serializer:p,options:D}),this._notebookProxy.$registerNotebookSerializer(S,{id:_.identifier,location:_.extensionLocation},w,r.NotebookDocumentContentOptions.from(D),E._convertNotebookRegistrationData(_,m)),(0,O.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(S)})}async $dataToNotebook(_,w,p){const D=this._notebookSerializer.get(_);if(!D)throw new Error("NO serializer found");const m=await D.serializer.deserializeNotebook(w.buffer,p);return new a.SerializableObjectWithBuffers(r.NotebookData.from(m))}async $notebookToData(_,w,p){const D=this._notebookSerializer.get(_);if(!D)throw new Error("NO serializer found");const m=await D.serializer.serializeNotebook(r.NotebookData.to(w.value),p);return k.VSBuffer.wrap(m)}async $saveNotebook(_,w,p,D,m){const S=T.URI.revive(w),M=this._notebookSerializer.get(_);if(this.trace(`enter saveNotebook(versionId: ${p}, ${S.toString()})`),!M)throw new Error("NO serializer found");const L=this._documents.get(S);if(!L)throw new Error("Document NOT found");if(L.versionId!==p)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(S.scheme))throw new b.FileOperationError((0,y.localize)(0,null,this._resourceForError(S)),b.FileOperationResult.FILE_PERMISSION_DENIED);const H={metadata:(0,s.filter)(L.apiNotebook.metadata,Y=>!(M.options?.transientDocumentMetadata??{})[Y]),cells:[]};for(const Y of L.apiNotebook.getCells()){const re=new o.NotebookCellData(Y.kind,Y.document.getText(),Y.document.languageId,Y.mime,M.options?.transientOutputs?[]:[...Y.outputs],Y.metadata,Y.executionSummary);re.metadata=(0,s.filter)(Y.metadata,fe=>!(M.options?.transientCellMetadata??{})[fe]),H.cells.push(re)}if(await this._validateWriteFile(S,D),m.isCancellationRequested)throw new Error("canceled");const V=await M.serializer.serializeNotebook(H,m);if(m.isCancellationRequested)throw new Error("canceled");this.trace(`serialized versionId: ${p} ${S.toString()}`),await this._extHostFileSystem.value.writeFile(S,V),this.trace(`Finished write versionId: ${p} ${S.toString()}`);const $=this._extHostFileSystem.getFileSystemProviderExtUri(S.scheme),N=await this._extHostFileSystem.value.stat(S),F={name:$.basename(S),isFile:(N.type&b.FileType.File)!==0,isDirectory:(N.type&b.FileType.Directory)!==0,isSymbolicLink:(N.type&b.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&b.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(S.scheme),locked:!!((N.permissions??0)&b.FilePermission.Locked),etag:b.etag({mtime:N.mtime,size:N.size}),children:void 0};return this.trace(`exit saveNotebook(versionId: ${p}, ${S.toString()})`),F}async $searchInNotebooks(_,w,p,D,m){const S=this._notebookSerializer.get(_)?.serializer;if(!S)return{limitHit:!1,results:[]};const M=new A.ResourceSet;await(async(N,F,Y)=>{await Promise.all(N.map(async re=>await Promise.all(re.filenamePatterns.map(fe=>{const Ee={_reason:Y._reason,folderQueries:Y.folderQueries,includePattern:Y.includePattern,excludePattern:Y.excludePattern,maxResults:Y.maxResults,type:i.QueryType.File,filePattern:fe};return this._extHostSearch.doInternalFileSearchWithCustomCallback(Ee,F,oe=>{oe.forEach(pe=>{M.has(pe)||D.some(se=>re.isFromSettings&&!se.isFromSettings?!1:se.filenamePatterns.some(Te=>(0,u.globMatchesResource)(Te,pe)))||M.add(pe)})}).catch(oe=>{if(oe.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw oe})}))))})(p,m,w);const H=new A.ResourceMap;let V=!1;const $=Array.from(M).map(async N=>{const F=[];try{if(m.isCancellationRequested)return;if(w.maxResults&&[...H.values()].reduce((Ee,oe)=>Ee+oe.cellResults.length,0)>w.maxResults){V=!0;return}const Y=[],re=this._documents.get(N);if(re)re.apiNotebook.getCells().forEach(oe=>Y.push({input:oe.document.getText(),outputs:oe.outputs.flatMap(pe=>pe.items.map(ve=>ve.data.toString()))}));else{const Ee=await this._extHostFileSystem.value.readFile(N),oe=k.VSBuffer.fromString(Ee.toString()),pe=await S.deserializeNotebook(oe.buffer,m);if(m.isCancellationRequested)return;r.NotebookData.from(pe).cells.forEach(se=>Y.push({input:se.source,outputs:se.outputs.flatMap(Te=>Te.items.map(Me=>Me.valueBytes.toString()))}))}if(m.isCancellationRequested)return;Y.forEach((Ee,oe)=>{const pe=w.contentPattern.pattern,ve=new g.CellSearchModel(Ee.input,void 0,Ee.outputs),se=ve.findInInputs(pe),Te=ve.findInOutputs(pe),Me=Te.flatMap(Q=>(0,f.genericCellMatchesToTextSearchMatches)(Q.matches,Q.textBuffer)).map((Q,W)=>(Q.webviewIndex=W,Q));if(se.length>0||Te.length>0){const Q={index:oe,contentResults:(0,f.genericCellMatchesToTextSearchMatches)(se,ve.inputTextBuffer),webviewResults:Me};F.push(Q)}});const fe={resource:N,cellResults:F};H.set(N,fe);return}catch{return}});return await Promise.all($),{limitHit:V,results:[...H.values()]}}async _validateWriteFile(_,w){const p=await this._extHostFileSystem.value.stat(_);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==b.ETAG_DISABLED&&typeof p.mtime=="number"&&typeof p.size=="number"&&w.mtime<p.mtime&&w.etag!==b.etag({mtime:w.mtime,size:p.size}))throw new b.FileOperationError((0,y.localize)(1,null),b.FileOperationResult.FILE_MODIFIED_SINCE,w)}_resourceForError(_){return _.scheme===n.Schemas.file?_.fsPath:_.toString()}_createExtHostEditor(_,w,p){if(this._editors.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const D=new t.ExtHostNotebookEditor(w,this._notebookEditorsProxy,_,p.visibleRanges.map(r.NotebookRange.to),p.selections.map(r.NotebookRange.to),typeof p.viewColumn=="number"?r.ViewColumn.to(p.viewColumn):void 0);this._editors.set(w,D)}$acceptDocumentAndEditorsDelta(_){if(_.value.removedDocuments)for(const p of _.value.removedDocuments){const D=T.URI.revive(p),m=this._documents.get(D);m&&(m.dispose(),this._documents.delete(D),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(S=>S.document.uri)}),this._onDidCloseNotebookDocument.fire(m.apiNotebook));for(const S of this._editors.values())S.notebookData.uri.toString()===D.toString()&&this._editors.delete(S.id)}if(_.value.addedDocuments){const p=[];for(const D of _.value.addedDocuments){const m=T.URI.revive(D.uri);if(this._documents.has(m))throw new Error(`adding EXISTING notebook ${m} `);const S=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,m,D);p.push(...D.cells.map(M=>d.ExtHostCell.asModelAddData(M))),this._documents.get(m)?.dispose(),this._documents.set(m,S),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(S.apiNotebook)}}if(_.value.addedEditors)for(const p of _.value.addedEditors){if(this._editors.has(p.id))return;const D=T.URI.revive(p.documentUri),m=this._documents.get(D);m&&this._createExtHostEditor(m,p.id,p)}const w=[];if(_.value.removedEditors)for(const p of _.value.removedEditors){const D=this._editors.get(p);D&&(this._editors.delete(p),this._activeNotebookEditor?.id===D.id&&(this._activeNotebookEditor=void 0),w.push(D))}if(_.value.visibleEditors){this._visibleNotebookEditors=_.value.visibleEditors.map(D=>this._editors.get(D)).filter(D=>!!D);const p=new Set;this._visibleNotebookEditors.forEach(D=>p.add(D.id));for(const D of this._editors.values()){const m=p.has(D.id);D._acceptVisibility(m)}this._visibleNotebookEditors=[...this._editors.values()].map(D=>D).filter(D=>D.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}_.value.newActiveEditor===null?this._activeNotebookEditor=void 0:_.value.newActiveEditor&&(this._editors.get(_.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${_.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(_.value.newActiveEditor)),_.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(_){const w=h.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new h.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new h.ApiCommandArgument("data","Bytes to convert to data",m=>m instanceof Uint8Array,m=>k.VSBuffer.wrap(m))],new h.ApiCommandResult("Notebook Data",m=>r.NotebookData.to(m.value))),D=new h.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new h.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",m=>!0,m=>new a.SerializableObjectWithBuffers(r.NotebookData.from(m)))],new h.ApiCommandResult("Bytes",m=>m.buffer));_.registerApiCommand(p),_.registerApiCommand(D)}trace(_){this._logService.trace(`[Extension Host Notebook] ${_}`)}}e.ExtHostNotebookController=E}),define(De[311],Ie([1,0,20,22,48,41,24,69,43]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class l{constructor(c,C,h){this.config=c,this.provider=C,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&O.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&O.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const C=this.config.folderQueries||[];return new Promise((h,r)=>{const o=a=>{this.resultCount++,c(a)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(a=>{const d=a.toString(),t=y.basename(d);this.globalExcludePattern&&this.globalExcludePattern(d,t)||this.matchFile(o,{base:a,basename:t})}),Promise.all(C.map(a=>this.searchInFolder(a,o))).then(a=>{h({limitHit:this.isLimitHit,stats:a[0]||void 0})},a=>{r(new Error((0,P.toErrorMessage)(a)))})})}async searchInFolder(c,C){const h=new k.CancellationTokenSource,r=this.getSearchOptionsForFolder(c),o=this.initDirectoryTree(),a=new v.QueryGlobTester(this.config,c),d=!a.hasSiblingExcludeClauses();let t;try{this.activeCancellationTokens.add(h),t=R.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},r,h.token),n=t.elapsed(),i=R.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(g=>{const f=y.posix.relative(c.folder.path,g.path);if(d){const u=y.basename(g.path);this.matchFile(C,{base:c.folder,relativePath:f,basename:u});return}this.addDirectoryEntries(o,c.folder,f,C)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(o,a,C),{providerTime:n,postProcessTime:i.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(c){const C=(0,v.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),h=(0,v.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:h,includes:C,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},C,h,r){if(h===this.filePattern){const a=y.basename(this.filePattern);this.matchFile(r,{base:C,relativePath:this.filePattern,basename:a})}function o(a){const d=y.basename(a),t=y.dirname(a);let s=c[t];s||(s=c[t]=[],o(t)),s.push({base:C,relativePath:a,basename:d})}o(h)}matchDirectoryTree({rootEntries:c,pathToEntries:C},h,r){const o=this,a=this.filePattern;function d(t){const s=(0,v.hasSiblingFn)(()=>t.map(n=>n.basename));for(let n=0,i=t.length;n<i;n++){const g=t[n],{relativePath:f,basename:u}=g;if(h.matchesExcludesSync(f,u,a!==u?s:void 0))continue;const E=C[f];if(E)d(E);else{if(f===a)continue;o.matchFile(r,g)}if(o.isLimitHit)break}}d(c)}matchFile(c,C){(!this.includePattern||C.relativePath&&this.includePattern(C.relativePath,C.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(C))}}class T{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(c,C,h,r){const o=this.getSessionTokenSource(c.cacheKey),a=new l(c,C,o&&o.token);let d=0;const t=s=>{d+=s.length,h(s.map(n=>this.rawMatchToSearchItem(n)))};return this.doSearch(a,T.BATCH_SIZE,t,r).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:s.stats}:void 0,messages:[]}))}clearCache(c){this.getSessionTokenSource(c)?.cancel()}getSessionTokenSource(c){if(c)return this.sessions.has(c)||this.sessions.set(c,new k.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:A.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,C,h,r){const o=r.onCancellationRequested(()=>{c.cancel()}),a=t=>{t&&(d.push(t),C>0&&d.length>=C&&(h(d),d=[]))};let d=[];return c.search(a).then(t=>(d.length&&h(d),o.dispose(),t),t=>(d.length&&h(d),o.dispose(),Promise.reject(t)))}}e.FileSearchManager=T}),define(De[312],Ie([1,0,18,281,41,102,29,16,20,24,13,15,2,101,204,42,12,50,116,308,43]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.resolveResourcesForSearchIncludes=w;let n=class{constructor(D,m,S,M,L){this.configurationService=D,this.workspaceContextService=m,this.editorGroupsService=S,this.logService=M,this.pathService=L}text(D,m,S={}){D=this.getContentPattern(D,S);const M=this.configurationService.getValue(),L=m&&m.some(V=>!this.configurationService.getValue({resource:V}).search.useRipgrep);return{...this.commonQuery(m?.map(a.toWorkspaceFolder),S),type:s.QueryType.Text,contentPattern:D,previewOptions:S.previewOptions,maxFileSize:S.maxFileSize,usePCRE2:M.search.usePCRE2||L||!1,beforeContext:S.beforeContext,afterContext:S.afterContext,userDisabledExcludesAndIgnoreFiles:S.disregardExcludeSettings&&S.disregardIgnoreFiles}}getContentPattern(D,m){const S=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const M={...D,wordSeparators:S.editor.wordSeparators};return this.isCaseSensitive(D,m)&&(M.isCaseSensitive=!0),this.isMultiline(D)&&(M.isMultiline=!0),m.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=m.notebookSearchConfig.includeMarkupInput),m.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=m.notebookSearchConfig.includeMarkupPreview),m.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=m.notebookSearchConfig.includeCodeInput),m.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=m.notebookSearchConfig.includeOutput),M}file(D,m={}){return{...this.commonQuery(D,m),type:s.QueryType.File,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey,shouldGlobMatchFilePattern:m.shouldGlobSearch}}handleIncludeExclude(D,m){return D?(D=Array.isArray(D)?D.map(E):E(D),m?this.parseSearchPaths(D):{pattern:g(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],m={}){const S=this.handleIncludeExclude(m.includePattern,m.expandPatterns),M=this.handleIncludeExclude(m.excludePattern,m.expandPatterns),L=D.length>1,H=(S.searchPaths&&S.searchPaths.length?S.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,m,M)):D.map(N=>this.getFolderQueryForRoot(N,m,M,L))).filter(N=>!!N),V={_reason:m._reason,folderQueries:H,usingSearchPaths:!!(S.searchPaths&&S.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:M.pattern,includePattern:S.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const N=y.coalesce(this.editorGroupsService.groups.flatMap(re=>re.editors.map(fe=>fe.resource)));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const F=N.filter(re=>(0,s.pathIncludedInQuery)(V,re.fsPath)),Y=this.commonQueryFromFileList(F);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...V,...Y}}const $=m.extraFileResources&&m.extraFileResources.filter(N=>(0,s.pathIncludedInQuery)(V,N.fsPath));return V.extraFileResources=$&&$.length?$:void 0,V}commonQueryFromFileList(D){const m=[],S=new A.ResourceMap,M={};let L=!1;return D.forEach(H=>{if(H.scheme===R.Schemas.walkThrough)return;if((0,l.isAbsolutePath)(H)){const $=this.workspaceContextService.getWorkspaceFolder(H)?.uri??H.with({path:v.dirname(H.fsPath)});let N=S.get($);N||(L=!0,N={folder:$,includePattern:{}},m.push(N),S.set($,N));const F=v.relative($.fsPath,H.fsPath);(0,b.assertIsDefined)(N.includePattern)[F.replace(/\\/g,"/")]=!0}else H.fsPath&&(L=!0,M[H.fsPath]=!0)}),{folderQueries:m,includePattern:M,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(D,m){if(m.isSmartCase){if(D.isRegExp){if(T.containsUppercaseCharacter(D.pattern,!0))return!0}else if(T.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,C.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const m=Y=>v.isAbsolute(Y)||/^\.\.?([\/\\]|$)/.test(Y),M=(Array.isArray(D)?D:f(D)).map(Y=>{const re=this.pathService.resolvedUserHome;return re?(0,O.untildify)(Y,re.scheme===R.Schemas.file?re.fsPath:re.path):Y}),L=k.groupBy(M,Y=>m(Y)?"searchPaths":"exprSegments"),H=(L.exprSegments||[]).map(Y=>T.rtrim(Y,"/")).map(Y=>T.rtrim(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),u(Y))),V={},$=this.expandSearchPathPatterns(L.searchPaths||[]);$&&$.length&&(V.searchPaths=$);const N=H.flat(),F=g(...N);return F&&(V.pattern=F),V}getExcludesForFolder(D,m){return m.disregardExcludeSettings?void 0:(0,s.getExcludes)(D,!m.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const m=D.flatMap(M=>{let{pathPortion:L,globPortion:H}=i(M);return H&&(H=I(H)),this.expandOneSearchPath(L).flatMap($=>this.resolveOneSearchPathPattern($,H))}),S=new Map;return m.forEach(M=>{const L=M.searchPath.toString(),H=S.get(L);H?M.pattern&&(H.pattern=H.pattern||{},H.pattern[M.pattern]=!0):S.set(L,{searchPath:M.searchPath,pattern:M.pattern?g(M.pattern):void 0})}),Array.from(S.values())}expandOneSearchPath(D){if(v.isAbsolute(D)){const m=this.workspaceContextService.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==R.Schemas.file?[{searchPath:m[0].uri.with({path:D})}]:[{searchPath:c.URI.file(v.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===a.WorkbenchState.FOLDER){const m=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=E(D),D.startsWith("../")||D===".."){const M=v.posix.resolve(m.path,D);return[{searchPath:m.with({path:M})}]}const S=I(D);return[{searchPath:m,pattern:S}]}else{if(D==="./"||D===".\\")return[];{const m=D.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(L=>{const H=m.match(new RegExp(`^${T.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return H?{match:H,folder:L}:null}).filter(b.isDefined);if(M.length)return M.map(L=>{const H=L.match[1];return{searchPath:L.folder.uri,pattern:H&&I(H)}});{const L=D.match(/\.[\/\\](.+)[\/\\]?/),H=L?L[1]:D,V=h.localize(0,null,H);throw new Error(V)}}}}resolveOneSearchPathPattern(D,m){const S=D.pattern&&m?`${D.pattern}/${m}`:D.pattern||m,M=[{searchPath:D.searchPath,pattern:S}];return S&&!S.endsWith("**")&&M.push({searchPath:D.searchPath,pattern:S+"/**"}),M}getFolderQueryForSearchPath(D,m,S){const M=this.getFolderQueryForRoot((0,a.toWorkspaceFolder)(D.searchPath),m,S,!1);return M?{...M,includePattern:D.pattern}:null}getFolderQueryForRoot(D,m,S,M){let L;const H=c.URI.isUri(D)?D:D.uri;if(S.searchPaths){const Y=S.searchPaths.filter(re=>(0,l.isEqual)(re.searchPath,H))[0];if(Y&&!Y.pattern)return null;Y&&(L=Y.pattern)}const V=this.configurationService.getValue({resource:H}),N={...this.getExcludesForFolder(V,m)||{},...L||{}},F=c.URI.isUri(D)?(0,l.basename)(D):D.name;return{folder:H,folderName:M?F:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!V.search.followSymlinks}}};e.QueryBuilder=n,e.QueryBuilder=n=je([$e(0,r.IConfigurationService),$e(1,a.IWorkspaceContextService),$e(2,d.IEditorGroupsService),$e(3,o.ILogService),$e(4,t.IPathService)],n);function i(p){const D=p.match(/[\*\{\}\(\)\[\]\?]/);if(D){const m=D.index,S=p.substr(0,m).match(/[/|\\][^/\\]*$/);if(S){let M=p.substr(0,S.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:p.substr((S.index||0)+1)}}}return{pathPortion:p}}function g(...p){return p.length?p.reduce((D,m)=>(D[m]=!0,D),Object.create(null)):void 0}function f(p){return P.splitGlobAware(p,",").map(D=>D.trim()).filter(D=>!!D.length)}function u(p){return[`**/${p}/**`,`**/${p}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function E(p){return p.replace(/\\/g,"/")}function I(p){return E(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function _(p){return p.replace(/([?*[\]])/g,"[$1]")}function w(p,D){p=y.distinct(p,M=>M.toString());const m=[],S=D.getWorkspace();return p&&p.forEach(M=>{let L;if(D.getWorkbenchState()===a.WorkbenchState.FOLDER)L=(0,l.relativePath)(S.folders[0].uri,M),L&&L!=="."&&(L="./"+L);else{const H=D.getWorkspaceFolder(M);if(H){const V=H.name;if(S.folders.filter(N=>N.name===V).length===1){const N=(0,l.relativePath)(H.uri,M);N===""?L=`./${H.name}`:L=`./${H.name}/${N}`}else L=M.fsPath}}L&&m.push(_(L))}),m}}),define(De[313],Ie([1,0,24,2,22,14,3,312,43,50,11]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=c,e.checkGlobFileExists=r;const b=7e3;function c(o,a){const d=a.activationEvents;if(!d)return Promise.resolve(void 0);const t=[],s=[];for(const E of d)if(/^workspaceContains:/.test(E)){const I=E.substr(18);I.indexOf("*")>=0||I.indexOf("?")>=0||o.forceUsingSearch?s.push(I):t.push(I)}if(t.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:n,resolve:i}=(0,T.promiseWithResolvers)(),g=E=>i({activationEvent:E}),f=Promise.all(t.map(E=>C(o,E,g))).then(()=>{}),u=h(o,a.identifier,s,g);return Promise.all([f,u]).then(()=>{i(void 0)}),n}async function C(o,a,d){for(const t of o.folders)if(await o.exists(y.joinPath(k.URI.revive(t),a))){d(`workspaceContains:${a}`);return}}async function h(o,a,d,t){if(d.length===0)return Promise.resolve(void 0);const s=new P.CancellationTokenSource,n=o.checkExists(o.folders,d,s.token),i=setTimeout(async()=>{s.cancel(),o.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},b);let g=!1;try{g=await n}catch(f){O.isCancellationError(f)||O.onUnexpectedError(f)}s.dispose(),clearTimeout(i),g&&t(`workspaceContains:${d.join(",")}`)}function r(o,a,d,t){const s=o.get(A.IInstantiationService),n=o.get(v.ISearchService),g=s.createInstance(R.QueryBuilder).file(a.map(f=>(0,l.toWorkspaceFolder)(k.URI.revive(f))),{_reason:"checkExists",includePattern:d,exists:!0});return n.fileSearch(g,t).then(f=>!!f.limitHit,f=>O.isCancellationError(f)?!1:Promise.reject(f))}}),define(De[46],Ie([1,0,180,20,64,24,11,6,58,2,12,5,45,246,89,44,25,117,14,19,23,228,7,108,3,27,92,17,75,93,57,95,4,313,88,230,16,86,69,21,87]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s,n,i,g,f,u,E,I,_,w,p,D,m,S,M,L,H,V,$,N,F){"use strict";var Y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,f.createDecorator)("IHostUtils");let re=Y=class extends R.Disposable{constructor(Q,W,ie,_e,de,Se,ae,X,J,me,ge,Le,ze){super(),this._extHostManagedSockets=Le,this._extHostLanguageModels=ze,this._onDidChangeRemoteConnectionData=this._register(new m.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=W,this._extHostContext=ie,this._initData=ae,this._extHostWorkspace=_e,this._extHostConfiguration=de,this._logService=Se,this._extHostTunnelService=J,this._extHostTerminalService=me,this._extHostLocalizationService=ge,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._activationEventsReader=new Te(this._initData.extensions.activationEvents),this._globalRegistry=new a.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const ye=new t.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new a.ExtensionDescriptionRegistry(this._activationEventsReader,ve(this._globalRegistry,ye)),N.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${oe(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${oe(this._myRegistry)}`)),this._storage=new h.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=X,this._instaService=Q.createChild(new _.ServiceCollection([h.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState])),this._activator=this._register(new C.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(ke,Oe,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ke,d.transformErrorForSerialization(Oe),B)},actualActivateExtension:async(ke,Oe)=>{if(a.ExtensionDescriptionRegistry.isHostExtension(ke,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(ke,Oe),new C.HostExtension;const B=this._myRegistry.getExtensionDescription(ke);return this._activateExtension(B,Oe)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),P.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Q){d.onUnexpectedError(Q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Q=[];try{Q=this._myRegistry.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this._deactivate(de))}catch{}await Promise.all(Q)}terminate(Q,W=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),d.setUnexpectedErrorHandler(_e=>{this._logService.error(_e)}),this._extHostContext.dispose();const ie=this._deactivateAll();Promise.race([(0,A.timeout)(5e3),ie]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${W}`):this._logService.info(`Extension host exiting with code ${W}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(W)})}isActivated(Q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Q):!1}async getExtension(Q){const W=await this._mainThreadExtensionsProxy.$getExtension(Q);return W&&{...W,identifier:new t.ExtensionIdentifier(W.identifier.value),extensionLocation:l.URI.revive(W.extensionLocation)}}_activateByEvent(Q,W){return this._activator.activateByEvent(Q,W)}_activateById(Q,W){return this._activator.activateById(Q,W)}activateByIdWithErrors(Q,W){return this._activateById(Q,W).then(()=>{const ie=this._activator.getActivatedExtension(Q);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Q=>this._myRegistry)}getExtensionExports(Q){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(Q).exports;try{return this._activator.getActivatedExtension(Q).exports}catch{return null}}async _realPathExtensionUri(Q){if(Q.scheme===H.Schemas.file&&this._hostUtils.fsRealpath){const W=Q.fsPath;this._realPathCache.has(W)||this._realPathCache.set(W,this._hostUtils.fsRealpath(W));const ie=await this._realPathCache.get(W);return l.URI.file(ie)}return Q}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Q=>new se(Q))),this._extensionPathIndex}async _createExtensionPathIndex(Q){const W=v.TernarySearchTree.forUris(ie=>O.extUriBiasedIgnorePathCase.ignorePathCasing(ie));return await Promise.all(Q.map(async ie=>{if(this._getEntryPoint(ie)){const _e=await this._realPathExtensionUri(ie.extensionLocation);W.set(_e,ie)}})),W}_deactivate(Q){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Q))return W;const ie=this._activator.getActivatedExtension(Q);if(!ie)return W;try{typeof ie.module.deactivate=="function"&&(W=Promise.resolve(ie.module.deactivate()).then(void 0,_e=>(this._logService.error(_e),Promise.resolve(void 0))))}catch(_e){this._logService.error(`An error occurred when deactivating the extension '${Q.value}':`),this._logService.error(_e)}try{(0,R.dispose)(ie.subscriptions)}catch(_e){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this._logService.error(_e)}return W}async _activateExtension(Q,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier),this._doActivateExtension(Q,W).then(ie=>{const _e=ie.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Q.identifier,_e.codeLoadingTime,_e.activateCallTime,_e.activateResolvedTime,W),this._logExtensionActivationTimes(Q,W,"success",_e),ie},ie=>{throw this._logExtensionActivationTimes(Q,W,"failure"),ie})}_logExtensionActivationTimes(Q,W,ie,_e){const de=Ee(Q,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...de,..._e||{},outcome:ie})}_doActivateExtension(Q,W){const ie=Ee(Q,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ie);const _e=this._getEntryPoint(Q);if(!_e)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${Q.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this._logService.flush();const de=new C.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(Q,(0,O.joinPath)(Q.extensionLocation,_e),de),this._loadExtensionContext(Q)]).then(Se=>(P.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),Y._callActivate(this._logService,Q.identifier,Se[0],Se[1],de))).then(Se=>(P.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),Se))}_loadExtensionContext(Q){const W=this._extHostLanguageModels.createLanguageModelAccessInformation(Q),ie=new n.ExtensionGlobalMemento(Q,this._storage),_e=new n.ExtensionMemento(Q.identifier.value,!1,this._storage),de=new L.ExtensionSecrets(Q,this._secretState),Se=Q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ae=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([ie.whenReady,_e.whenReady,this._storagePath.whenReady]).then(()=>{const X=this;let J,me;const ge=(0,o.isProposedApiEnabled)(Q,"ipc")?this._initData.messagePorts?.get(t.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:ie,workspaceState:_e,secrets:de,subscriptions:[],get languageModelAccessInformation(){return W},get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(Le){return k.join(Q.extensionLocation.fsPath,Le)},get storagePath(){return X._storagePath.workspaceValue(Q)?.fsPath},get globalStoragePath(){return X._storagePath.globalValue(Q).fsPath},get logPath(){return k.join(X._initData.logsLocation.fsPath,Q.identifier.value)},get logUri(){return l.URI.joinPath(X._initData.logsLocation,Q.identifier.value)},get storageUri(){return X._storagePath.workspaceValue(Q)},get globalStorageUri(){return X._storagePath.globalValue(Q)},get extensionMode(){return Se},get extension(){return J===void 0&&(J=new pe(X,Q.identifier,Q,ae,!1)),J},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(Q,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X._extHostTerminalService.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!me){if(!ge)return;const Le=m.Event.buffer(m.Event.fromDOMEventEmitter(ge,"message",ze=>ze.data));ge.start(),me={onDidReceiveMessage:Le,postMessage:ge.postMessage.bind(ge)}}return me}})})}static _callActivate(Q,W,ie,_e,de){return ie=ie||{activate:void 0,deactivate:void 0},this._callActivateOptional(Q,W,ie,_e,de).then(Se=>new C.ActivatedExtension(!1,null,de.build(),ie,Se,_e.subscriptions))}static _callActivateOptional(Q,W,ie,_e,de){if(typeof ie.activate=="function")try{de.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${W.value}`);const Se=typeof global=="object"?global:self,ae=ie.activate.apply(Se,[_e]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(ae).then(X=>(de.activateResolveStop(),X))}catch(Se){return Promise.reject(Se)}else return Promise.resolve(ie)}_activateOneStartupFinished(Q,W){this._activateById(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:W}).then(void 0,ie=>{this._logService.error(ie)})}_activateAllStartupFinishedDeferred(Q,W=0){const _e=Date.now();(0,N.setTimeout0)(()=>{for(let de=W;de<Q.length;de+=1){const Se=Q[de];for(const ae of Se.activationEvents??[])if(ae==="onStartupFinished")if(Date.now()-_e>50){this._activateAllStartupFinishedDeferred(Q,de);break}else this._activateOneStartupFinished(Se,ae)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(P.getMarks()),this._extHostConfiguration.getConfigProvider().then(Q=>{const W=Q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this._myRegistry.getAllExtensionDescriptions();if(W)this._activateAllStartupFinishedDeferred(ie);else for(const _e of ie)if(_e.activationEvents)for(const de of _e.activationEvents)de==="onStartupFinished"&&this._activateOneStartupFinished(_e,de)})}_handleEagerExtensions(){const Q=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ie=this._handleWorkspaceContainsEagerExtensions(W),_e=this._handleRemoteResolverEagerExtensions(),de=Promise.all([_e,Q,ie]).then(()=>{});return Promise.race([de,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),de}_handleWorkspaceContainsEagerExtensions(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(Q,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Q,W){if(this.isActivated(W.identifier))return;const ie=!this._initData.remote.isRemote&&!!this._initData.remote.authority,_e={logService:this._logService,folders:Q.map(Se=>Se.uri),forceUsingSearch:ie||!this._hostUtils.fsExists,exists:Se=>this._hostUtils.fsExists(Se.fsPath),checkExists:(Se,ae,X)=>this._mainThreadWorkspaceProxy.$checkExists(Se,ae,X)},de=await(0,S.checkActivateWorkspaceContainsExtension)(_e,W);if(de)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:de.activationEvent}).then(void 0,Se=>this._logService.error(Se))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Q){throw console.error(Q),Q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:W}=this._initData.environment;if(!Q||!W)throw new Error(y.localize(0,null));const ie=await this._loadCommonJSModule(null,W,new C.ExtensionActivationTimesBuilder(!1));if(!ie||typeof ie.run!="function")throw new Error(y.localize(1,null,W.toString()));return new Promise((_e,de)=>{const Se=(J,me)=>{J?(N.isCI&&this._logService.error("Test runner called back with error",J),de(J)):(N.isCI&&(me?this._logService.info(`Test runner called back with ${me} failures.`):this._logService.info("Test runner called back with successful outcome.")),_e(typeof me=="number"&&me>0?1:0))},ae=(0,O.originalFSPath)(W),X=ie.run(ae,Se);X&&X.then&&X.then(()=>{N.isCI&&this._logService.info("Test runner finished successfully."),_e(0)}).catch(J=>{N.isCI&&this._logService.error("Test runner finished with error",J),de(J instanceof Error&&J.stack?J.stack:String(J))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,W){return this._resolvers[Q]=W,(0,R.toDisposable)(()=>{delete this._resolvers[Q]})}async getRemoteExecServer(Q){const{resolver:W}=await this._activateAndGetResolver(Q);return W?.resolveExecServer?.(Q,{resolveAttempt:0})}async _activateAndGetResolver(Q){const W=Q.indexOf("+");if(W===-1)throw new i.RemoteAuthorityResolverError("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=Q.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this._resolvers[ie]}}async $resolveAuthority(Q,W){const ie=$.StopWatch.create(!1),_e=()=>`[resolveAuthority(${(0,g.getRemoteAuthorityPrefix)(Q)},${W})][${ie.elapsed()}ms] `,de=x=>this._logService.info(`${_e()}${x}`),Se=x=>this._logService.warn(`${_e()}${x}`),ae=(x,q=void 0)=>this._logService.error(`${_e()}${x}`,q),X=x=>{if(x instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:x._code,message:x._message,detail:x._detail}};throw x},J=async x=>{de(`activating resolver for ${x}...`);const{resolver:q,authorityPrefix:K}=await this._activateAndGetResolver(x);if(!q)throw ae(`no resolver for ${K}`),new i.RemoteAuthorityResolverError(`No remote extension installed to resolve ${K}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:K,remoteAuthority:x}},me=Q.split(/@|%40/g).reverse();de(`activating remote resolvers ${me.join(" -> ")}`);let ge;try{ge=await Promise.all(me.map(J)).catch(async x=>{if(!(x instanceof i.RemoteAuthorityResolverError)||x._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw x;return Se(`resolving nested authorities failed: ${x.message}`),[await J(Q)]})}catch(x){return X(x)}const Le=new A.IntervalTimer;Le.cancelAndSet(()=>de("waiting..."),1e3);let ze,ye;for(const[x,{authorityPrefix:q,resolver:K,remoteAuthority:te}]of ge.entries())try{if(x===ge.length-1)de("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${q}`),ze=await K.resolve(te,{resolveAttempt:W,execServer:ye}),P.mark(`code/extHost/didResolveAuthorityOK/${q}`),de("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(K,i.ManagedResolvedAuthority.isManagedResolvedAuthority(ze)?ze:void 0));else{if(de(`invoking resolveExecServer() for ${te}`),P.mark(`code/extHost/willResolveExecServer/${q}`),ye=await K.resolveExecServer?.(te,{resolveAttempt:W,execServer:ye}),!ye)throw new i.RemoteAuthorityResolverError(`Exec server was not available for ${te}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(ue){return P.mark(`code/extHost/didResolveAuthorityError/${q}`),ae("returned an error",ue),Le.dispose(),X(ue)}Le.dispose();const ke={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${i.ManagedResolvedAuthority.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let B;if(i.ManagedResolvedAuthority.isManagedResolvedAuthority(ze)){const x=W;this._extHostManagedSockets.setFactory(x,ze.makeConnection),B={authority:Q,connectTo:new g.ManagedRemoteConnection(x),connectionToken:ze.connectionToken}}else B={authority:Q,connectTo:new g.WebSocketRemoteConnection(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:B,options:Oe,tunnelInformation:ke}}}async $getCanonicalURI(Q,W){this._logService.info(`$getCanonicalURI invoked for authority (${(0,g.getRemoteAuthorityPrefix)(Q)})`);const{resolver:ie}=await this._activateAndGetResolver(Q);if(!ie)return null;const _e=l.URI.revive(W);if(typeof ie.getCanonicalURI>"u")return _e;const de=await(0,A.asPromise)(()=>ie.getCanonicalURI(_e));return de||_e}async $startExtensionHost(Q){Q.toAdd.forEach(Se=>Se.extensionLocation=l.URI.revive(Se.extensionLocation));const{globalRegistry:W,myExtensions:ie}=fe(this._activationEventsReader,this._globalRegistry,this._myRegistry,Q),_e=await this._createExtensionPathIndex(ie);return(await this.getExtensionPathIndex()).setSearchTree(_e),this._globalRegistry.set(W.getAllExtensionDescriptions()),this._myRegistry.set(ie),N.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${oe(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${oe(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(Q,W){return W===o.ActivationKind.Immediate?this._almostReadyToRunExtensions.wait().then(ie=>this._activateByEvent(Q,!1)):this._readyToRunExtensions.wait().then(ie=>this._activateByEvent(Q,!1))}async $activate(Q,W){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Q)?(await this._activateById(Q,W),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(Se=>Se.extensionLocation=l.URI.revive(Se.extensionLocation));const{globalRegistry:W,myExtensions:ie}=fe(this._activationEventsReader,this._globalRegistry,this._myRegistry,Q),_e=await this._createExtensionPathIndex(ie);return(await this.getExtensionPathIndex()).setSearchTree(_e),this._globalRegistry.set(W.getAllExtensionDescriptions()),this._myRegistry.set(ie),N.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${oe(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${oe(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const W=s.VSBuffer.alloc(Q),ie=Math.random()%256;for(let _e=0;_e<Q;_e++)W.writeUInt8(ie,_e);return W}async $updateRemoteConnectionData(Q){this._remoteConnectionData=Q,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=re,e.AbstractExtHostExtensionService=re=Y=je([$e(0,f.IInstantiationService),$e(1,e.IHostUtils),$e(2,I.IExtHostRpcService),$e(3,r.IExtHostWorkspace),$e(4,c.IExtHostConfiguration),$e(5,T.ILogService),$e(6,u.IExtHostInitDataService),$e(7,E.IExtensionStoragePaths),$e(8,w.IExtHostTunnelService),$e(9,p.IExtHostTerminalService),$e(10,V.IExtHostLocalizationService),$e(11,F.IExtHostManagedSockets),$e(12,D.IExtHostLanguageModels)],re);function fe(Me,Q,W,ie){Me.addActivationEvents(ie.addActivationEvents);const _e=new a.ExtensionDescriptionRegistry(Me,Q.getAllExtensionDescriptions());_e.deltaExtensions(ie.toAdd,ie.toRemove);const de=new t.ExtensionIdentifierSet(W.getAllExtensionDescriptions().map(ae=>ae.identifier));for(const ae of ie.myToRemove)de.delete(ae);for(const ae of ie.myToAdd)de.add(ae);const Se=ve(_e,de);return{globalRegistry:_e,myExtensions:Se}}function Ee(Me,Q){return{id:Me.identifier.value,name:Me.name,extensionVersion:Me.version,publisherDisplayName:Me.publisher,activationEvents:Me.activationEvents?Me.activationEvents.join(","):null,isBuiltin:Me.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}function oe(Me){return Me.getAllExtensionDescriptions().map(Q=>Q.identifier.value).join(",")}e.IExtHostExtensionService=(0,f.createDecorator)("IExtHostExtensionService");class pe{#e;#t;#i;constructor(Q,W,ie,_e,de){this.#e=Q,this.#t=W,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=k.normalize((0,O.originalFSPath)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=_e,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=pe;function ve(Me,Q){return Me.getAllExtensionDescriptions().filter(W=>Q.has(W.identifier))}class se{constructor(Q){this._searchTree=Q}setSearchTree(Q){this._searchTree=Q}findSubstr(Q){return this._searchTree.findSubstr(Q)}forEach(Q){return this._searchTree.forEach(Q)}}e.ExtensionPaths=se;class Te{constructor(Q){this._map=new t.ExtensionIdentifierMap,this.addActivationEvents(Q)}readActivationEvents(Q){return this._map.get(Q.identifier)??[]}addActivationEvents(Q){for(const W of Object.keys(Q))this._map.set(W,Q[W])}}}),define(De[314],Ie([1,0,64,2,5,45,25,19,17,27,3,46,12,13]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(s,n,i,g,f,u,E){this._apiFactory=s,this._extensionRegistry=n,this._instaService=i,this._extHostConfiguration=g,this._extHostExtensionService=f,this._initData=u,this._logService=E,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),y.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,n,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(d,n,this._initData.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const n of s.nodeModuleName)this._factories.set(n,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(n=>s.alternativeModuleName(n))}};e.RequireInterceptor=r,e.RequireInterceptor=r=je([$e(2,T.IInstantiationService),$e(3,O.IExtHostConfiguration),$e(4,b.IExtHostExtensionService),$e(5,l.IExtHostInitDataService),$e(6,c.ILogService)],r);let o=class{static{h=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&h.aliased.size){const n=(0,C.escapeRegExpCharacters)(this.forceForwardSlashes(s.environment.appRoot.fsPath)),i="[a-z0-9_.-]",g=`@${i}+\\/${i}+|${i}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${f}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(s){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(s));if(!n)return;const[,i,g,f]=n,u=h.aliased.get(g);if(u!==void 0)return console.warn(`${g} as been renamed to ${u}, please update your imports`),i+u+f}forceForwardSlashes(s){return s.replace(/\\/g,"/")}};o=h=je([$e(0,l.IExtHostInitDataService)],o);class a{constructor(s,n,i,g,f){this._apiFactory=s,this._extensionPaths=n,this._extensionRegistry=i,this._configProvider=g,this._logService=f,this.nodeModuleName="vscode",this._extApiImpl=new R.ExtensionIdentifierMap}load(s,n){const i=this._extensionPaths.findSubstr(n);if(i){let g=this._extApiImpl.get(i.identifier);return g||(g=this._apiFactory(i,this._extensionRegistry,this._configProvider),this._extApiImpl.set(i.identifier,g)),g}if(!this._defaultApiImpl){let g="";this._extensionPaths.forEach((f,u)=>g+=`	${u} -> ${f.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${g}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let d=class{constructor(s,n,i){this._extensionPaths=s,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=i.getProxy(P.MainContext.MainThreadTelemetry);const g=i.getProxy(P.MainContext.MainThreadWindow);this._impl=(f,u)=>{const E=k.URI.parse(f);return u?this.callOriginal(f,u):E.scheme==="http"||E.scheme==="https"?g.$openUri(E,f,{allowTunneling:!0}):E.scheme==="mailto"||E.scheme===this._appUriScheme?g.$openUri(E,f,{}):this.callOriginal(f,u)}}load(s,n,i){const g=this._extensionPaths.findSubstr(n);return g&&(this._extensionId=g.identifier.value,this.sendShimmingTelemetry()),this._original=i(s),this._impl}callOriginal(s,n){return this.sendNoForwardTelemetry(),this._original(s,n)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};d=je([$e(2,v.IExtHostRpcService)],d)}),define(De[130],Ie([1,0,47,6,20,79,3,71,70,46,7,44,243,45]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class h extends c.AbstractVariableResolverService{constructor(a,d,t,s,n,i,g){function f(){if(t){const u=t.activeEditor();if(u)return u.document.uri;const E=s.tabGroups.all.find(I=>I.isActive)?.activeTab;if(E!==void 0){if(E.input instanceof T.TextDiffTabInput||E.input instanceof T.NotebookDiffEditorTabInput)return E.input.modified;if(E.input instanceof T.TextTabInput||E.input instanceof T.NotebookEditorTabInput||E.input instanceof T.CustomEditorTabInput)return E.input.uri}}}super({getFolderUri:u=>{const E=i.folders.filter(I=>I.name===u);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(u,E)=>n.getConfiguration(void 0,u).get(E),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=f();if(u)return P.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(d){const u=f();if(u){const E=d.getWorkspaceFolder(u);if(E)return P.normalize(E.uri.fsPath)}}},getSelectedText:()=>{if(t){const u=t.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(t){const u=t.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>a.getExtension(u)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(O.env))}}let r=class extends k.Disposable{constructor(a,d,t,s,n){super(),this.extensionService=a,this.workspaceService=d,this.editorService=t,this.configurationService=s,this.editorTabs=n,this._resolver=new y.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),f={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async u=>{f.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new h(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,f,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=r,e.ExtHostVariableResolverProviderService=r=je([$e(0,l.IExtHostExtensionService),$e(1,b.IExtHostWorkspace),$e(2,R.IExtHostDocumentsAndEditors),$e(3,C.IExtHostConfiguration),$e(4,v.IExtHostEditorTabs)],r)}),define(De[131],Ie([1,0,11,4,2,19,3,5,70,46,17,7,44,235,81,236,45,130,6,34,39,10,18]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,A.createDecorator)("IExtHostDebugService");let g=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(p,D,m,S,M,L,H){this._workspaceService=D,this._extensionService=m,this._configurationService=S,this._editorTabs=M,this._variableResolver=L,this._commands=H,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=p.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter,this._onDidChangeActiveStackItem=new k.Emitter,this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(V=>{V.onDidChange($=>{this.registerAllDebugTypes(V)}),this.registerAllDebugTypes(V)})}async $getVisualizerTreeItem(p,D){const m=this.hydrateVisualizationContext(D);if(!m)return;const S=await this._debugVisualizationTrees.get(p)?.getTreeItem?.(m);return S?this.convertVisualizerTreeItem(p,S):void 0}registerDebugVisualizationTree(p,D,m){const S=O.ExtensionIdentifier.toKey(p.identifier),M=this.extensionVisKey(S,D);if(this._debugVisualizationProviders.has(M))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this._debugVisualizationTrees.set(M,m),this._debugServiceProxy.$registerDebugVisualizerTree(M,!!m.editItem),(0,d.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(M),this._debugVisualizationTrees.delete(D)})}async $getVisualizerTreeItemChildren(p,D){const m=this._debugVisualizationElements.get(D)?.item;return m?(await this._debugVisualizationTrees.get(p)?.getChildren?.(m))?.map(M=>this.convertVisualizerTreeItem(p,M))||[]:[]}async $editVisualizerTreeItem(p,D){const m=this._debugVisualizationElements.get(p);if(!m)return;const S=await this._debugVisualizationTrees.get(m.provider)?.editItem?.(m.item,D);return this.convertVisualizerTreeItem(m.provider,S||m.item)}$disposeVisualizedTree(p){const D=this._debugVisualizationElements.get(p);if(!D)return;const m=[D.children];for(const S of m)if(S)for(const M of S)m.push(this._debugVisualizationElements.get(M)?.children),this._debugVisualizationElements.delete(M)}convertVisualizerTreeItem(p,D){let m=this._debugVisualizationTreeItemIds.get(D);return m||(m=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(D,m),this._debugVisualizationElements.set(m,{provider:p,item:D})),n.DebugTreeItem.from(D,m)}asDebugSourceUri(p,D){const m=p;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let S=`debug:${encodeURIComponent(m.path||"")}`,M="?";return D&&(S+=`${M}session=${encodeURIComponent(D.id)}`,M="&"),S+=`${M}ref=${m.sourceReference}`,P.URI.parse(S)}else{if(m.path)return P.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const D=[];for(const m of p.getAllExtensionDescriptions())if(m.contributes){const S=m.contributes.debuggers;if(S&&S.length>0)for(const M of S)(0,r.isDebuggerMainContribution)(M)&&D.push(M.type)}this._debugServiceProxy.$registerDebugTypes(D)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const p=[];return this._breakpoints.forEach(D=>p.push(D)),p}async $resolveDebugVisualizer(p,D){const m=this._visualizers.get(p);if(!m)throw new Error(`No debug visualizer found with id '${p}'`);let{v:S,provider:M,extensionId:L}=m;if(S.visualization||(S=await M.resolveDebugVisualization?.(S,D)||S,m.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${M}'`);return this.serializeVisualization(L,S.visualization)}async $executeDebugVisualizerCommand(p){const D=this._visualizers.get(p);if(!D)throw new Error(`No debug visualizer found with id '${p}'`);const m=D.v.visualization;m&&"command"in m&&this._commands.executeCommand(m.command,...m.arguments||[])}hydrateVisualizationContext(p){const D=this._debugSessions.get(p.sessionId);return D&&{session:D.api,variable:p.variable,containerId:p.containerId,frameId:p.frameId,threadId:p.threadId}}async $provideDebugVisualizers(p,D,m,S){const M=this.hydrateVisualizationContext(m),L=this.extensionVisKey(p,D),H=this._debugVisualizationProviders.get(L);if(!M||!H)return[];const V=await H.provideDebugVisualization(M,S);return V?V.map($=>{const N=++this._visualizerIdCounter;this._visualizers.set(N,{v:$,provider:H,extensionId:p});const F=$.iconPath?this.getIconPathOrClass($.iconPath):void 0;return{id:N,name:$.name,iconClass:F?.iconClass,iconPath:F?.iconPath,visualization:this.serializeVisualization(p,$.visualization)}}):[]}$disposeDebugVisualizers(p){for(const D of p)this._visualizers.delete(D)}registerDebugVisualizationProvider(p,D,m){if(!p.contributes?.debugVisualizers?.some(L=>L.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const S=O.ExtensionIdentifier.toKey(p.identifier),M=this.extensionVisKey(S,D);if(this._debugVisualizationProviders.has(M))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this._debugVisualizationProviders.set(M,m),this._debugServiceProxy.$registerDebugVisualizer(S,D),(0,d.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(S,D),this._debugVisualizationProviders.delete(D)})}addBreakpoints(p){const D=p.filter(M=>{const L=M.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,M),!0)});this.fireBreakpointChanges(D,[],[]);const m=[],S=new Map;for(const M of D)if(M instanceof b.SourceBreakpoint){let L=S.get(M.location.uri.toString());L||(L={type:"sourceMulti",uri:M.location.uri,lines:[]},S.set(M.location.uri.toString(),L),m.push(L)),L.lines.push({id:M.id,enabled:M.enabled,condition:M.condition,hitCondition:M.hitCondition,logMessage:M.logMessage,line:M.location.range.start.line,character:M.location.range.start.character,mode:M.mode})}else M instanceof b.FunctionBreakpoint&&m.push({type:"function",id:M.id,enabled:M.enabled,hitCondition:M.hitCondition,logMessage:M.logMessage,condition:M.condition,functionName:M.functionName,mode:M.mode});return this._debugServiceProxy.$registerBreakpoints(m)}removeBreakpoints(p){const D=p.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],D,[]);const m=D.filter(L=>L instanceof b.SourceBreakpoint).map(L=>L.id),S=D.filter(L=>L instanceof b.FunctionBreakpoint).map(L=>L.id),M=D.filter(L=>L instanceof b.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(m,S,M)}startDebugging(p,D,m){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,D,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===b.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,suppressSaveBeforeStart:m.suppressSaveBeforeStart,suppressDebugStatusbar:m.suppressDebugStatusbar??m.debugUI?.simple,suppressDebugToolbar:m.suppressDebugToolbar??m.debugUI?.simple,suppressDebugView:m.suppressDebugView??m.debugUI?.simple})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,D,m){if(!D)return new b.Disposable(()=>{});const S=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:S,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,m,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,S),new b.Disposable(()=>{this._configProviders=this._configProviders.filter(M=>M.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(p,D,m){if(!m)return new b.Disposable(()=>{});if(!this.definesDebugType(p,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:S,factory:m}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,S),new b.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(M=>M.factory!==m),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(p,D){if(!D)return new b.Disposable(()=>{});const m=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:m,factory:D}),new b.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(S=>S.factory!==D)})}async $runInTerminal(p,D){return Promise.resolve(void 0)}async $substituteVariables(p,D){let m;const S=await this.getFolder(p);return S&&(m={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(m,D)}createDebugAdapter(p,D){if(p.type==="implementation")return new I(p.implementation)}createSignService(){}async $startDASession(p,D){const m=this,S=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(S.type),S).then(M=>{if(!M)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const L=this.convertToDto(M),H=this.createDebugAdapter(L,S);if(!H)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const V=H;return this._debugAdapters.set(p,V),this.getDebugAdapterTrackers(S).then($=>($&&this._debugAdaptersTrackers.set(p,$),V.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const F=N,Y={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const re=await this._signService.sign(F.arguments.value);Y.body={signature:re},V.sendResponse(Y)}else throw new Error("no signer")}catch(re){Y.success=!1,Y.message=re.message,V.sendResponse(Y)}}else $&&$.onDidSendMessage&&$.onDidSendMessage(N),N=(0,r.convertToVSCPaths)(N,!0),m._debugServiceProxy.$acceptDAMessage(p,N)}),V.onError(N=>{$&&$.onError&&$.onError(N),this._debugServiceProxy.$acceptDAError(p,N.name,N.message,N.stack)}),V.onExit(N=>{$&&$.onExit&&$.onExit(N??void 0,void 0),this._debugServiceProxy.$acceptDAExit(p,N??void 0,void 0)}),$&&$.onWillStartSession&&$.onWillStartSession(),V.startSession()))})}$sendDAMessage(p,D){D=(0,r.convertToDAPaths)(D,!1);const m=this._debugAdaptersTrackers.get(p);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(D),this._debugAdapters.get(p)?.sendMessage(D)}$stopDASession(p){const D=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),D&&D.onWillStopSession&&D.onWillStopSession();const m=this._debugAdapters.get(p);return this._debugAdapters.delete(p),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const D=[],m=[],S=[];if(p.added)for(const M of p.added){const L=M.id;if(L&&!this._breakpoints.has(L)){let H;if(M.type==="function")H=new b.FunctionBreakpoint(M.functionName,M.enabled,M.condition,M.hitCondition,M.logMessage,M.mode);else if(M.type==="data")H=new b.DataBreakpoint(M.label,M.dataId,M.canPersist,M.enabled,M.hitCondition,M.condition,M.logMessage,M.mode);else{const V=P.URI.revive(M.uri);H=new b.SourceBreakpoint(new b.Location(V,new b.Position(M.line,M.character)),M.enabled,M.condition,M.hitCondition,M.logMessage,M.mode)}(0,b.setBreakpointId)(H,L),this._breakpoints.set(L,H),D.push(H)}}if(p.removed)for(const M of p.removed){const L=this._breakpoints.get(M);L&&(this._breakpoints.delete(M),m.push(L))}if(p.changed){for(const M of p.changed)if(M.id){const L=this._breakpoints.get(M.id);if(L){if(L instanceof b.FunctionBreakpoint&&M.type==="function"){const H=L;H.enabled=M.enabled,H.condition=M.condition,H.hitCondition=M.hitCondition,H.logMessage=M.logMessage,H.functionName=M.functionName}else if(L instanceof b.SourceBreakpoint&&M.type==="source"){const H=L;H.enabled=M.enabled,H.condition=M.condition,H.hitCondition=M.hitCondition,H.logMessage=M.logMessage,H.location=new b.Location(P.URI.revive(M.uri),new b.Position(M.line,M.character))}S.push(L)}}}this.fireBreakpointChanges(D,m,S)}async $acceptStackFrameFocus(p){let D;if(p){const m=await this.getSession(p.sessionId);p.kind==="thread"?D=new b.DebugThread(m.api,p.threadId):D=new b.DebugStackFrame(m.api,p.threadId,p.frameId)}this._activeStackItem=D,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(p,D,m){return(0,y.asPromise)(async()=>{const S=this.getConfigProviderByHandle(p);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const M=await this.getFolder(D);return S.provideDebugConfigurations(M,m)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(p,D,m,S){return(0,y.asPromise)(async()=>{const M=this.getConfigProviderByHandle(p);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(D);return M.resolveDebugConfiguration(L,m,S)})}$resolveDebugConfigurationWithSubstitutedVariables(p,D,m,S){return(0,y.asPromise)(async()=>{const M=this.getConfigProviderByHandle(p);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(D);return M.resolveDebugConfigurationWithSubstitutedVariables(L,m,S)})}async $provideDebugAdapter(p,D){const m=this.getAdapterDescriptorFactoryByHandle(p);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.getSession(D);return this.getAdapterDescriptor(m,S).then(M=>{if(!M)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.convertToDto(M)})}async $acceptDebugSessionStarted(p){const D=await this.getSession(p);this._onDidStartDebugSession.fire(D.api)}async $acceptDebugSessionTerminated(p){const D=await this.getSession(p);D&&(this._onDidTerminateDebugSession.fire(D.api),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(p,D){(await this.getSession(p))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(p,D){const S={session:(await this.getSession(p)).api,event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(S)}convertToDto(p){if(p instanceof b.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof b.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof b.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof b.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const D=this._adapterFactories.filter(m=>m.type===p);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(p){const D=this._adapterFactories.filter(m=>m.handle===p);if(D.length>0)return D[0].factory}getConfigProviderByHandle(p){const D=this._configProviders.filter(m=>m.handle===p);if(D.length>0)return D[0].provider}definesDebugType(p,D){if(p.contributes){const m=p.contributes.debuggers;if(m&&m.length>0){for(const S of m)if(S.label&&S.type&&S.type===D)return!0}}return!1}getDebugAdapterTrackers(p){const m=p.configuration.type,S=this._trackerFactories.filter(M=>M.type===m||M.type==="*").map(M=>(0,y.asPromise)(()=>M.factory.createDebugAdapterTracker(p.api)).then(L=>L,L=>null));return Promise.race([Promise.all(S).then(M=>{const L=(0,i.coalesce)(M);if(L.length>0)return new E(L)}),new Promise(M=>setTimeout(()=>M(void 0),1e3))]).catch(M=>{})}async getAdapterDescriptor(p,D){const m=D.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new b.DebugAdapterServer(m));if(p){const M=await this._extensionService.getExtensionRegistry();return(0,y.asPromise)(()=>p.createDebugAdapterDescriptor(D.api,this.daExecutableFromPackage(D,M))).then(L=>{if(L)return L})}const S=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,S))}daExecutableFromPackage(p,D){}fireBreakpointChanges(p,D,m){(p.length>0||D.length>0||m.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:D,changed:m}))}async getSession(p){if(p)if(typeof p=="string"){const D=this._debugSessions.get(p);if(D)return D}else{let D=this._debugSessions.get(p.id);if(!D){const m=await this.getFolder(p.folderUri),S=p.parent?this._debugSessions.get(p.parent):void 0;D=new f(this._debugServiceProxy,p.id,p.type,p.name,m,p.configuration,S?.api),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(p){if(p){const D=P.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}extensionVisKey(p,D){return`${p}\0${D}`}serializeVisualization(p,D){if(D){if("title"in D&&"command"in D)return{type:h.DebugVisualizationType.Command};if("treeId"in D)return{type:h.DebugVisualizationType.Tree,id:`${p}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(p){const D=this.getIconUris(p);let m,S;return"id"in D?S=t.ThemeIcon.asClassName(D):m=D,{iconPath:m,iconClass:S}}getIconUris(p){if(p instanceof b.ThemeIcon)return{id:p.id};const D=typeof p=="object"&&"dark"in p?p.dark:p,m=typeof p=="object"&&"light"in p?p.light:p;return{dark:typeof D=="string"?P.URI.file(D):D,light:typeof m=="string"?P.URI.file(m):m}}};e.ExtHostDebugServiceBase=g,e.ExtHostDebugServiceBase=g=je([$e(0,T.IExtHostRpcService),$e(1,c.IExtHostWorkspace),$e(2,l.IExtHostExtensionService),$e(3,o.IExtHostConfiguration),$e(4,v.IExtHostEditorTabs),$e(5,a.IExtHostVariableResolverProvider),$e(6,s.IExtHostCommands)],g);class f{constructor(p,D,m,S,M,L,H){this._debugServiceProxy=p,this._id=D,this._type=m,this._name=S,this._workspaceFolder=M,this._configuration=L,this._parentSession=H}get api(){const p=this;return this.apiSession??=Object.freeze({id:p._id,type:p._type,get name(){return p._name},set name(D){p._name=D,p._debugServiceProxy.$setDebugSessionName(p._id,D)},parentSession:p._parentSession,workspaceFolder:p._workspaceFolder,configuration:p._configuration,customRequest(D,m){return p._debugServiceProxy.$customDebugAdapterRequest(p._id,D,m)},getDebugProtocolBreakpoint(D){return p._debugServiceProxy.$getDebugProtocolBreakpoint(p._id,D.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(p){this._name=p}get configuration(){return this._configuration}}e.ExtHostDebugSession=f;class u{constructor(p){this.value=Object.freeze({append(D){p.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=u;class E{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(D=>D.onError?D.onError(p):void 0)}onExit(p,D){this.trackers.forEach(m=>m.onExit?m.onExit(p,D):void 0)}}class I extends C.AbstractDebugAdapter{constructor(p){super(),this.implementation=p,p.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let _=class extends g{constructor(p,D,m,S,M,L,H){super(p,D,m,S,M,L,H)}};e.WorkerExtHostDebugService=_,e.WorkerExtHostDebugService=_=je([$e(0,T.IExtHostRpcService),$e(1,c.IExtHostWorkspace),$e(2,l.IExtHostExtensionService),$e(3,o.IExtHostConfiguration),$e(4,v.IExtHostEditorTabs),$e(5,a.IExtHostVariableResolverProvider),$e(6,s.IExtHostCommands)],_)}),define(De[315],Ie([1,0,14,64,2,5,265,12,60,75,27,210,17,65,46,66]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class o{static async installEarlyHandler(t){Error.stackTraceLimit=100;const s=t.get(R.ILogService),i=t.get(c.IExtHostRpcService).getProxy(O.MainContext.MainThreadErrors);y.setUnexpectedErrorHandler(g=>{s.error(g);const f=y.transformErrorForSerialization(g);i.$onUnexpectedError(f)})}static async installFullHandler(t){const s=t.get(R.ILogService),n=t.get(c.IExtHostRpcService),i=t.get(h.IExtHostExtensionService),g=t.get(r.IExtHostTelemetry),f=n.getProxy(O.MainContext.MainThreadExtensionService),u=n.getProxy(O.MainContext.MainThreadErrors),E=await i.getExtensionPathIndex(),I=new WeakMap;function _(D,m){if(I.has(D))return I.get(D).stack;let S="",M,L;for(const V of m)S+=`
	at ${V.toString()}`,L=V.getFileName(),!M&&L&&(M=E.findSubstr(P.URI.file(L)));const H=`${D.name||"Error"}: ${D.message||""}${S}`;return I.set(D,{extensionIdentifier:M?.identifier,stack:H}),H}const w=Symbol("prepareStackTrace wrapped");let p=_;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(D){if(D===_||!D||D[w]){p=D||_;return}p=function(m,S){return _(m,S),D.call(Error,m,S)},Object.assign(p,{[w]:!0})}}),y.setUnexpectedErrorHandler(D=>{s.error(D);const m=y.transformErrorForSerialization(D),S=I.get(D);if(!S?.extensionIdentifier){u.$onUnexpectedError(m);return}f.$onExtensionRuntimeError(S.extensionIdentifier,m);const M=g.onExtensionError(S.extensionIdentifier,D);s.trace("forwarded error to extension?",M,S)})}}e.ErrorHandler=o;class a{constructor(t,s,n,i,g){this._hostUtils=n,this._rpcProtocol=new A.RPCProtocol(t,null,i),s=a._transform(s,this._rpcProtocol);const f=new l.ServiceCollection(...(0,v.getSingletonServiceDescriptors)());f.set(T.IExtHostInitDataService,{_serviceBrand:void 0,...s,messagePorts:g}),f.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),f.set(C.IURITransformerService,new C.URITransformerService(i)),f.set(h.IHostUtils,n);const u=new b.InstantiationService(f,!0);u.invokeFunction(o.installEarlyHandler),this._logService=u.invokeFunction(E=>E.get(R.ILogService)),k.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",s),this._extensionService=u.invokeFunction(E=>E.get(h.IExtHostExtensionService)),this._extensionService.initialize(),u.invokeFunction(o.installFullHandler)}async asBrowserUri(t){const s=this._rpcProtocol.getProxy(O.MainContext.MainThreadExtensionService);return P.URI.revive(await s.$asBrowserUri(t))}terminate(t){this._extensionService.terminate(t)}static _transform(t,s){t.extensions.allExtensions.forEach(i=>{i.extensionLocation=P.URI.revive(s.transformIncomingURIs(i.extensionLocation))}),t.environment.appRoot=P.URI.revive(s.transformIncomingURIs(t.environment.appRoot));const n=t.environment.extensionDevelopmentLocationURI;return n&&(t.environment.extensionDevelopmentLocationURI=n.map(i=>P.URI.revive(s.transformIncomingURIs(i)))),t.environment.extensionTestsLocationURI=P.URI.revive(s.transformIncomingURIs(t.environment.extensionTestsLocationURI)),t.environment.globalStorageHome=P.URI.revive(s.transformIncomingURIs(t.environment.globalStorageHome)),t.environment.workspaceStorageHome=P.URI.revive(s.transformIncomingURIs(t.environment.workspaceStorageHome)),t.environment.extensionTelemetryLogResource=P.URI.revive(s.transformIncomingURIs(t.environment.extensionTelemetryLogResource)),t.nlsBaseUrl=P.URI.revive(s.transformIncomingURIs(t.nlsBaseUrl)),t.logsLocation=P.URI.revive(s.transformIncomingURIs(t.logsLocation)),t.workspace=s.transformIncomingURIs(t.workspace),t}}e.ExtensionHostMain=a}),define(De[316],Ie([1,0,18,11,22,48,16,20,24,2,43]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,e.extensionResultIsMatch=r;class b{constructor(d,t,s){this.queryProviderPair=d,this.fileUtils=t,this.processType=s,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(d,t){const s=this.query.folderQueries||[],n=new P.CancellationTokenSource(t);return new Promise((i,g)=>{this.collector=new C(d);let f=!1;const u=(E,I)=>{if(!f&&!this.isLimitHit){const _=this.resultSize(E);r(E)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,f=!0,n.cancel(),E=this.trimResultToSize(E,this.query.maxResults-this.resultCount));const w=this.resultSize(E);this.resultCount+=w,(w>0||!r(E))&&this.collector.add(E,I)}};Promise.all(s.map((E,I)=>this.searchInFolder(E,_=>u(_,I),n.token))).then(E=>{n.dispose(),this.collector.flush();const I=E.some(_=>!!_&&!!_.limitHit);i({limitHit:this.isLimitHit||I,messages:E.flatMap(_=>_?.message?Array.isArray(_.message)?_.message:[_.message]:[]),stats:{type:this.processType}})},E=>{n.dispose();const I=(0,O.toErrorMessage)(E);g(new Error(I))})})}resultSize(d){return r(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,t){const s=Array.isArray(d.ranges)?d.ranges:[d.ranges],n=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:s.slice(0,t),preview:{matches:n.slice(0,t),text:d.preview.text},uri:d.uri}}async searchInFolder(d,t,s){const n=new T.QueryGlobTester(this.query,d),i=[],g={report:E=>{if(!this.validateProviderResult(E))return;const I=d.folder.scheme===A.Schemas.file?(0,T.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(v.dirname(E.uri))):void 0,_=v.relativePath(d.folder,E.uri);if(_){const w=n.includedInQuery(_,R.basename(_),I);(0,k.isThenable)(w)?i.push(w.then(p=>{p&&t(E)})):w&&t(E)}}},f=this.getSearchOptionsForFolder(d);let u;return this.queryProviderPair.query.type===T.QueryType.aiText?u=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,f,g,s):u=await this.queryProviderPair.provider.provideTextSearchResults(c(this.queryProviderPair.query.contentPattern),f,g,s),i.length&&await Promise.all(i),u}validateProviderResult(d){if(r(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const t=(0,T.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),s=(0,T.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),n={folder:l.URI.from(d.folder),excludes:s,includes:t,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return"usePCRE2"in this.query&&(n.usePCRE2=this.query.usePCRE2),n}}e.TextSearchManager=b;function c(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class C{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new o(512,t=>this.sendItems(t))}add(d,t){this._currentFileMatch&&(this._currentFolderIdx!==t||!v.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=t,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(h(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=C;function h(a){return r(a)?{preview:{matches:(0,y.mapArrayOrNot)(a.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:a.preview.text},ranges:(0,y.mapArrayOrNot)(a.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function r(a){return!!a.preview}class o{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(d,t){this.maxBatchSize=d,this.cb=t,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,t){d&&this.addItemToBatch(d,t)}addItems(d,t){d&&this.addItemsToBatch(d,t)}addItemToBatch(d,t){this.batch.push(d),this.batchSize+=t,this.onUpdate()}addItemsToBatch(d,t){this.batch=this.batch.concat(d),this.batchSize+=t,this.onUpdate()}onUpdate(){this.totalNumberCompleted<o.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},o.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=o}),define(De[132],Ie([1,0,6,5,3,311,17,65,12,2,316]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=c,e.IExtHostSearch=(0,P.createDecorator)("IExtHostSearch");let b=class{constructor(r,o,a){this.extHostRpc=r,this._uriTransformer=o,this._logService=a,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new O.FileSearchManager}_transformScheme(r){return this._uriTransformer.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this._textSearchUsedSchemes.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this._textSearchUsedSchemes.add(r);const a=this._handlePool++;return this._textSearchProvider.set(a,o),this._proxy.$registerTextSearchProvider(a,this._transformScheme(r)),(0,y.toDisposable)(()=>{this._textSearchUsedSchemes.delete(r),this._textSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}registerAITextSearchProvider(r,o){if(this._aiTextSearchUsedSchemes.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this._aiTextSearchUsedSchemes.add(r);const a=this._handlePool++;return this._aiTextSearchProvider.set(a,o),this._proxy.$registerAITextSearchProvider(a,this._transformScheme(r)),(0,y.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(r),this._aiTextSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}registerFileSearchProvider(r,o){if(this._fileSearchUsedSchemes.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this._fileSearchUsedSchemes.add(r);const a=this._handlePool++;return this._fileSearchProvider.set(a,o),this._proxy.$registerFileSearchProvider(a,this._transformScheme(r)),(0,y.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(r),this._fileSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(r,o,a,d){const t=c(a),s=this._fileSearchProvider.get(r);if(s)return this._fileSearchManager.fileSearch(t,s,n=>{this._proxy.$handleFileMatch(r,o,n.map(i=>i.resource))},d);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,a){return{messages:[]}}$clearCache(r){return this._fileSearchManager.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,a,d){const t=this._textSearchProvider.get(r);if(!t||!t.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const s=c(a);return this.createTextSearchManager(s,t).search(i=>this._proxy.$handleTextMatch(r,o,i),d)}$provideAITextSearchResults(r,o,a,d){const t=this._aiTextSearchProvider.get(r);if(!t||!t.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const s=c(a);return this.createAITextSearchManager(s,t).search(i=>this._proxy.$handleTextMatch(r,o,i),d)}$enableExtensionHostSearch(){}createTextSearchManager(r,o){return new T.TextSearchManager({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}createAITextSearchManager(r,o){return new T.TextSearchManager({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.ExtHostSearch=b,e.ExtHostSearch=b=je([$e(0,A.IExtHostRpcService),$e(1,R.IURITransformerService),$e(2,v.ILogService)],b);function c(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(C),extraFileResources:h.extraFileResources&&h.extraFileResources.map(r=>l.URI.revive(r))}}function C(h){return{...h,folder:l.URI.revive(h.folder)}}}),define(De[317],Ie([1,0,22,14,4,6,16,35,2,104,163,149,52,19,30,12,62,63,224,5,268,296,85,91,273,274,275,252,241,39,276,45,277,131,120,278,254,269,279,280,71,70,255,270,46,282,68,283,51,27,297,256,284,95,285,86,87,258,310,287,229,288,298,289,126,259,290,291,292,17,293,132,88,294,260,295,89,92,129,66,57,124,299,300,271,301,302,93,10,7,261,65,262,67,303,304,119,44,81,84,25,128]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s,n,i,g,f,u,E,I,_,w,p,D,m,S,M,L,H,V,$,N,F,Y,re,fe,Ee,oe,pe,ve,se,Te,Me,Q,W,ie,_e,de,Se,ae,X,J,me,ge,Le,ze,ye,ke,Oe,B,x,q,K,te,ue,Ae,Be,He,Ye,tt,Ze,it,nt,mt,ut,rt,at,ht,We,xe,Z,j,we,qe,Je,lt,gt,Rt,Gt,Ut,ui,Jt,Xe,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=xt;function xt(ft){const pt=ft.get(Te.IExtHostInitDataService),Zt=ft.get(se.IExtHostFileSystemInfo),Xt=ft.get(pe.IExtHostConsumerFileSystem),Bt=ft.get(Ee.IExtHostExtensionService),Et=ft.get(Ut.IExtHostWorkspace),Ot=ft.get(it.IExtHostTelemetry),Ht=ft.get(D.IExtHostConfiguration),zt=ft.get(qe.IURITransformerService),Ge=ft.get(q.IExtHostRpcService),ei=ft.get(Ye.IExtHostStorage),ti=ft.get(tt.IExtensionStoragePaths),li=ft.get(r.ILoggerService),_t=ft.get(r.ILogService),Lt=ft.get(xe.IExtHostTunnelService),Pt=ft.get(i.IExtHostApiDeprecationService),Nt=ft.get(Gt.IExtHostWindow),ci=ft.get(ue.IExtHostSecretState),$t=ft.get(Y.IExtHostEditorTabs),ri=ft.get(Se.IExtHostManagedSockets),Ft=ft.get(g.IExtHostAuthentication),Qt=ft.get(ie.IExtHostLanguageModels);Ge.set(t.ExtHostContext.ExtHostFileSystemInfo,Zt),Ge.set(t.ExtHostContext.ExtHostLogLevelServiceShape,li),Ge.set(t.ExtHostContext.ExtHostWorkspace,Et),Ge.set(t.ExtHostContext.ExtHostConfiguration,Ht),Ge.set(t.ExtHostContext.ExtHostExtensionService,Bt),Ge.set(t.ExtHostContext.ExtHostStorage,ei),Ge.set(t.ExtHostContext.ExtHostTunnelService,Lt),Ge.set(t.ExtHostContext.ExtHostWindow,Nt),Ge.set(t.ExtHostContext.ExtHostSecretState,ci),Ge.set(t.ExtHostContext.ExtHostTelemetry,Ot),Ge.set(t.ExtHostContext.ExtHostEditorTabs,$t),Ge.set(t.ExtHostContext.ExtHostManagedSockets,ri),Ge.set(t.ExtHostContext.ExtHostAuthentication,Ft),Ge.set(t.ExtHostContext.ExtHostChatProvider,Qt);const si=Ge.set(t.ExtHostContext.ExtHostDecorations,ft.get(M.IExtHostDecorations)),Tt=Ge.set(t.ExtHostContext.ExtHostDocumentsAndEditors,ft.get(F.IExtHostDocumentsAndEditors)),St=Ge.set(t.ExtHostContext.ExtHostCommands,ft.get(w.IExtHostCommands)),vt=Ge.set(t.ExtHostContext.ExtHostTerminalService,ft.get(nt.IExtHostTerminalService)),Vt=Ge.set(t.ExtHostContext.ExtHostTerminalShellIntegration,ft.get(mt.IExtHostTerminalShellIntegration)),Ct=Ge.set(t.ExtHostContext.ExtHostDebugService,ft.get(S.IExtHostDebugService)),oi=Ge.set(t.ExtHostContext.ExtHostSearch,ft.get(te.IExtHostSearch)),qt=Ge.set(t.ExtHostContext.ExtHostTask,ft.get(Ze.IExtHostTask)),pi=Ge.set(t.ExtHostContext.ExtHostOutputService,ft.get(ye.IExtHostOutputService)),hi=Ge.set(t.ExtHostContext.ExtHostLocalization,ft.get(de.IExtHostLocalizationService)),Di=Ge.set(t.ExtHostContext.ExtHostUrls,new Je.ExtHostUrls(Ge)),kt=Ge.set(t.ExtHostContext.ExtHostDocuments,new N.ExtHostDocuments(Ge,Tt)),Pi=Ge.set(t.ExtHostContext.ExtHostDocumentContentProviders,new V.ExtHostDocumentContentProvider(Ge,Tt,_t)),ai=Ge.set(t.ExtHostContext.ExtHostDocumentSaveParticipant,new $.ExtHostDocumentSaveParticipant(_t,kt,Ge.getProxy(t.MainContext.MainThreadBulkEdits))),It=Ge.set(t.ExtHostContext.ExtHostNotebook,new X.ExtHostNotebookController(Ge,St,Tt,kt,Xt,oi,_t)),Ii=Ge.set(t.ExtHostContext.ExtHostNotebookDocuments,new me.ExtHostNotebookDocuments(It)),Si=Ge.set(t.ExtHostContext.ExtHostNotebookEditors,new ge.ExtHostNotebookEditors(_t,It)),vi=Ge.set(t.ExtHostContext.ExtHostNotebookKernels,new Le.ExtHostNotebookKernels(Ge,pt,It,St,_t)),ki=Ge.set(t.ExtHostContext.ExtHostNotebookRenderers,new ze.ExtHostNotebookRenderers(Ge,It)),fi=Ge.set(t.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new J.ExtHostNotebookDocumentSaveParticipant(_t,It,Ge.getProxy(t.MainContext.MainThreadBulkEdits))),be=Ge.set(t.ExtHostContext.ExtHostEditors,new rt.ExtHostEditors(Ge,Tt)),Re=Ge.set(t.ExtHostContext.ExtHostTreeViews,new We.ExtHostTreeViews(Ge.getProxy(t.MainContext.MainThreadTreeViews),St,_t)),ce=Ge.set(t.ExtHostContext.ExtHostEditorInsets,new _.ExtHostEditorInsets(Ge.getProxy(t.MainContext.MainThreadEditorInsets),be,pt.remote)),G=Ge.set(t.ExtHostContext.ExtHostDiagnostics,new L.ExtHostDiagnostics(Ge,_t,Zt,Tt)),Pe=Ge.set(t.ExtHostContext.ExtHostLanguages,new _e.ExtHostLanguages(Ge,kt,St.converter,zt)),Ue=Ge.set(t.ExtHostContext.ExtHostLanguageFeatures,new W.ExtHostLanguageFeatures(Ge,zt,kt,St,G,_t,Pt,Ot)),Qe=Ge.set(t.ExtHostContext.ExtHostFileSystem,new oe.ExtHostFileSystem(Ge,Ue)),Ve=Ge.set(t.ExtHostContext.ExtHostFileSystemEventService,new ve.ExtHostFileSystemEventService(Ge,_t,Tt)),ct=Ge.set(t.ExtHostContext.ExtHostQuickOpen,(0,x.createExtHostQuickOpen)(Ge,Et,St)),Dt=Ge.set(t.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(Ge,St,kt,_t)),Yt=Ge.set(t.ExtHostContext.ExtHostQuickDiff,new B.ExtHostQuickDiff(Ge,zt)),ii=Ge.set(t.ExtHostContext.ExtHostShare,new Ae.ExtHostShare(Ge,zt)),Mt=Ge.set(t.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(Ge,St,kt)),jt=Ge.set(t.ExtHostContext.ExtHostProgress,new Oe.ExtHostProgress(Ge.getProxy(t.MainContext.MainThreadProgress))),Fi=Ge.set(t.ExtHostContext.ExtHostLabelService,new Q.ExtHostLabelService(Ge)),Ui=Ge.set(t.ExtHostContext.ExtHostTheming,new at.ExtHostTheming(Ge)),Qi=Ge.set(t.ExtHostContext.ExtHostTimeline,new ht.ExtHostTimeline(Ge,St)),xi=Ge.set(t.ExtHostContext.ExtHostWebviews,new lt.ExtHostWebviews(Ge,pt.remote,Et,_t,Pt)),Ri=Ge.set(t.ExtHostContext.ExtHostWebviewPanels,new gt.ExtHostWebviewPanels(Ge,xi,Et)),Bi=Ge.set(t.ExtHostContext.ExtHostCustomEditors,new m.ExtHostCustomEditors(Ge,kt,ti,xi,Ri)),zi=Ge.set(t.ExtHostContext.ExtHostWebviewViews,new Rt.ExtHostWebviewViews(Ge,xi)),wi=Ge.set(t.ExtHostContext.ExtHostTesting,new ut.ExtHostTesting(Ge,_t,St,Tt)),Yi=Ge.set(t.ExtHostContext.ExtHostUriOpeners,new we.ExtHostUriOpeners(Ge)),Ji=Ge.set(t.ExtHostContext.ExtHostProfileContentHandlers,new ke.ExtHostProfileContentHandlers(Ge));Ge.set(t.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,It,Tt,St,_t));const Li=Ge.set(t.ExtHostContext.ExtHostChatAgents2,new u.ExtHostChatAgents2(Ge,_t,St,pt.quality)),Wi=Ge.set(t.ExtHostContext.ExtHostChatVariables,new E.ExtHostChatVariables(Ge)),$i=Ge.set(t.ExtHostContext.ExtHostAiRelatedInformation,new s.ExtHostRelatedInformation(Ge)),gn=Ge.set(t.ExtHostContext.ExtHostAiEmbeddingVector,new fe.ExtHostAiEmbeddingVector(Ge)),Zi=Ge.set(t.ExtHostContext.ExtHostStatusBar,new He.ExtHostStatusBar(Ge,St.converter)),Vi=Ge.set(t.ExtHostContext.ExtHostSpeech,new Be.ExtHostSpeech(Ge)),yi=Ge.set(t.ExtHostContext.ExtHostEmbeddings,new re.ExtHostEmbeddings(Ge)),mn=Object.values(t.ExtHostContext);Ge.assertRegistered(mn);const pn=new f.ExtHostBulkEdits(Ge,Tt),en=new I.ExtHostClipboard(Ge),Hi=new ae.ExtHostMessageService(Ge,_t),Oi=new H.ExtHostDialogs(Ge);return n.ExtHostApiCommands.register(St),function(Fe,gi,qi){function st(ee){return(le,Ne,ot)=>{const yt=ee(At=>{try{le.call(Ne,At)}catch(Ci){k.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${Ci.toString()}`,{cause:Ci})),Ot.onExtensionError(Fe.identifier,Ci)}});return ot?.push(yt),yt}}const wt=function(){let ee=!Fe.isUnderDevelopment;function le(){ee||(_t.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Ne(ot){if(Array.isArray(ot))ot.forEach(Ne);else if(typeof ot=="string")le();else{const yt=ot;typeof yt.scheme>"u"&&le(),typeof yt.exclusive=="boolean"&&(0,Xe.checkProposedApiEnabled)(Fe,"documentFiltersExclusive")}return ot}}(),tn={getSession(ee,le,Ne){return typeof Ne?.forceNewSession=="object"&&Ne.forceNewSession.learnMore&&(0,Xe.checkProposedApiEnabled)(Fe,"authLearnMore"),Ft.getSession(Fe,ee,le,Ne)},getSessions(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"authGetSessions"),Ft.getSessions(Fe,ee,le)},async hasSession(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"authSession"),!!await Ft.getSession(Fe,ee,le,{silent:!0})},get onDidChangeSessions(){return st(Ft.onDidChangeSessions)},registerAuthenticationProvider(ee,le,Ne,ot){return Ft.registerAuthenticationProvider(ee,le,Ne,ot)}},Ei={registerCommand(ee,le,Ne){return St.registerCommand(!0,ee,le,Ne,void 0,Fe)},registerTextEditorCommand(ee,le,Ne){return St.registerCommand(!0,ee,(...ot)=>{const yt=be.getActiveTextEditor();if(!yt){_t.warn("Cannot execute "+ee+" because there is no active text editor.");return}return yt.edit(At=>{le.apply(Ne,[yt,At,...ot])}).then(At=>{At||_t.warn("Edits from command "+ee+" were not applied.")},At=>{_t.warn("An error occurred while running command "+ee,At)})},void 0,void 0,Fe)},registerDiffInformationCommand:(ee,le,Ne)=>((0,Xe.checkProposedApiEnabled)(Fe,"diffCommand"),St.registerCommand(!0,ee,async(...ot)=>{const yt=Tt.activeEditor(!0);if(!yt){_t.warn("Cannot execute "+ee+" because there is no active text editor.");return}const At=await be.getDiffInformation(yt.id);le.apply(Ne,[At,...ot])},void 0,void 0,Fe)),executeCommand(ee,...le){return St.executeCommand(ee,...le)},getCommands(ee=!1){return St.getCommands(ee)}},Ai={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return en.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return st(vt.onDidChangeShell)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return st(Ot.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(Fe,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(Fe,"telemetry"),st(Ot.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,le){return it.ExtHostTelemetryLogger.validateSender(ee),Ot.instantiateLogger(Fe,ee,le)},openExternal(ee,le){return Nt.openUri(ee,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===pt.environment.appUriScheme)return Di.createAppUri(ee);try{return await Nt.asExternalUri(ee,{allowTunneling:!!pt.remote.authority})}catch(le){if((0,A.matchesScheme)(ee,A.Schemas.http)||(0,A.matchesScheme)(ee,A.Schemas.https))return ee;throw le}},get remoteName(){return(0,o.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,Xe.checkProposedApiEnabled)(Fe,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return _t.getLevel()},get onDidChangeLogLevel(){return st(_t.onDidChangeLogLevel)},get appQuality(){return(0,Xe.checkProposedApiEnabled)(Fe,"resolvers"),pt.quality},get appCommit(){return(0,Xe.checkProposedApiEnabled)(Fe,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Ai);const vn={createTestController(ee,le,Ne){return wi.createTestController(Fe,ee,le,Ne)},createTestObserver(){return(0,Xe.checkProposedApiEnabled)(Fe,"testObserver"),wi.createTestObserver()},runTests(ee){return(0,Xe.checkProposedApiEnabled)(Fe,"testObserver"),wi.runTests(ee)},registerTestFollowupProvider(ee){return(0,Xe.checkProposedApiEnabled)(Fe,"testObserver"),wi.registerTestFollowupProvider(ee)},get onDidChangeTestResults(){return(0,Xe.checkProposedApiEnabled)(Fe,"testObserver"),st(wi.onResultsChanged)},get testResults(){return(0,Xe.checkProposedApiEnabled)(Fe,"testObserver"),wi.results}},ni=pt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Ni={getExtension(ee,le){(0,Xe.isProposedApiEnabled)(Fe,"extensionsAny")||(le=!1);const Ne=gi.mine.getExtensionDescription(ee);if(Ne)return new Ee.Extension(Bt,Fe.identifier,Ne,ni,!1);if(le){const ot=gi.all.getExtensionDescription(ee);if(ot)return new Ee.Extension(Bt,Fe.identifier,ot,ni,!0)}},get all(){const ee=[];for(const le of gi.mine.getAllExtensionDescriptions())ee.push(new Ee.Extension(Bt,Fe.identifier,le,ni,!1));return ee},get allAcrossExtensionHosts(){(0,Xe.checkProposedApiEnabled)(Fe,"extensionsAny");const ee=new C.ExtensionIdentifierSet(gi.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),le=[];for(const Ne of gi.all.getAllExtensionDescriptions()){const ot=!ee.has(Ne.identifier);le.push(new Ee.Extension(Bt,Fe.identifier,Ne,ni,ot))}return le},get onDidChange(){return(0,Xe.isProposedApiEnabled)(Fe,"extensionsAny")?st(P.Event.any(gi.mine.onDidChange,gi.all.onDidChange)):st(gi.mine.onDidChange)}},nn={createDiagnosticCollection(ee){return G.createDiagnosticCollection(Fe.identifier,ee)},get onDidChangeDiagnostics(){return st(G.onDidChangeDiagnostics)},getDiagnostics:ee=>G.getDiagnostics(ee),getLanguages(){return Pe.getLanguages()},setTextDocumentLanguage(ee,le){return Pe.changeLanguage(ee.uri,le)},match(ee,le){const Ne=Z.LanguageSelector.from(ee);let ot;return(0,T.targetsNotebooks)(Ne)&&(ot=It.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(At=>At.document===le))?.apiNotebook),(0,T.score)(Ne,le.uri,le.languageId,!0,ot?.uri,ot?.notebookType)},registerCodeActionsProvider(ee,le,Ne){return Ue.registerCodeActionProvider(Fe,wt(ee),le,Ne)},registerDocumentPasteEditProvider(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"documentPaste"),Ue.registerDocumentPasteEditProvider(Fe,wt(ee),le,Ne)},registerCodeLensProvider(ee,le){return Ue.registerCodeLensProvider(Fe,wt(ee),le)},registerDefinitionProvider(ee,le){return Ue.registerDefinitionProvider(Fe,wt(ee),le)},registerDeclarationProvider(ee,le){return Ue.registerDeclarationProvider(Fe,wt(ee),le)},registerImplementationProvider(ee,le){return Ue.registerImplementationProvider(Fe,wt(ee),le)},registerTypeDefinitionProvider(ee,le){return Ue.registerTypeDefinitionProvider(Fe,wt(ee),le)},registerHoverProvider(ee,le){return Ue.registerHoverProvider(Fe,wt(ee),le,Fe.identifier)},registerEvaluatableExpressionProvider(ee,le){return Ue.registerEvaluatableExpressionProvider(Fe,wt(ee),le,Fe.identifier)},registerInlineValuesProvider(ee,le){return Ue.registerInlineValuesProvider(Fe,wt(ee),le,Fe.identifier)},registerDocumentHighlightProvider(ee,le){return Ue.registerDocumentHighlightProvider(Fe,wt(ee),le)},registerMultiDocumentHighlightProvider(ee,le){return Ue.registerMultiDocumentHighlightProvider(Fe,wt(ee),le)},registerLinkedEditingRangeProvider(ee,le){return Ue.registerLinkedEditingRangeProvider(Fe,wt(ee),le)},registerReferenceProvider(ee,le){return Ue.registerReferenceProvider(Fe,wt(ee),le)},registerRenameProvider(ee,le){return Ue.registerRenameProvider(Fe,wt(ee),le)},registerNewSymbolNamesProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"newSymbolNamesProvider"),Ue.registerNewSymbolNamesProvider(Fe,wt(ee),le)},registerDocumentSymbolProvider(ee,le,Ne){return Ue.registerDocumentSymbolProvider(Fe,wt(ee),le,Ne)},registerWorkspaceSymbolProvider(ee){return Ue.registerWorkspaceSymbolProvider(Fe,ee)},registerDocumentFormattingEditProvider(ee,le){return Ue.registerDocumentFormattingEditProvider(Fe,wt(ee),le)},registerDocumentRangeFormattingEditProvider(ee,le){return Ue.registerDocumentRangeFormattingEditProvider(Fe,wt(ee),le)},registerOnTypeFormattingEditProvider(ee,le,Ne,...ot){return Ue.registerOnTypeFormattingEditProvider(Fe,wt(ee),le,[Ne].concat(ot))},registerDocumentSemanticTokensProvider(ee,le,Ne){return Ue.registerDocumentSemanticTokensProvider(Fe,wt(ee),le,Ne)},registerDocumentRangeSemanticTokensProvider(ee,le,Ne){return Ue.registerDocumentRangeSemanticTokensProvider(Fe,wt(ee),le,Ne)},registerSignatureHelpProvider(ee,le,Ne,...ot){return typeof Ne=="object"?Ue.registerSignatureHelpProvider(Fe,wt(ee),le,Ne):Ue.registerSignatureHelpProvider(Fe,wt(ee),le,typeof Ne>"u"?[]:[Ne,...ot])},registerCompletionItemProvider(ee,le,...Ne){return Ue.registerCompletionItemProvider(Fe,wt(ee),le,Ne)},registerInlineCompletionItemProvider(ee,le,Ne){return le.handleDidShowCompletionItem&&(0,Xe.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),le.handleDidPartiallyAcceptCompletionItem&&(0,Xe.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),Ne&&(0,Xe.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),Ue.registerInlineCompletionsProvider(Fe,wt(ee),le,Ne)},registerInlineEditProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"inlineEdit"),Ue.registerInlineEditProvider(Fe,wt(ee),le)},registerDocumentLinkProvider(ee,le){return Ue.registerDocumentLinkProvider(Fe,wt(ee),le)},registerColorProvider(ee,le){return Ue.registerColorProvider(Fe,wt(ee),le)},registerFoldingRangeProvider(ee,le){return Ue.registerFoldingRangeProvider(Fe,wt(ee),le)},registerSelectionRangeProvider(ee,le){return Ue.registerSelectionRangeProvider(Fe,ee,le)},registerCallHierarchyProvider(ee,le){return Ue.registerCallHierarchyProvider(Fe,ee,le)},registerTypeHierarchyProvider(ee,le){return Ue.registerTypeHierarchyProvider(Fe,ee,le)},setLanguageConfiguration:(ee,le)=>Ue.setLanguageConfiguration(Fe,ee,le),getTokenInformationAtPosition(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"tokenInformation"),Pe.tokenAtPosition(ee,le)},registerInlayHintsProvider(ee,le){return Ue.registerInlayHintsProvider(Fe,ee,le)},createLanguageStatusItem(ee,le){return Pe.createLanguageStatusItem(Fe,ee,le)},registerDocumentDropEditProvider(ee,le,Ne){return Ue.registerDocumentOnDropEditProvider(Fe,ee,le,(0,Xe.isProposedApiEnabled)(Fe,"documentPaste")?Ne:void 0)}},rn={get activeTextEditor(){return be.getActiveTextEditor()},get visibleTextEditors(){return be.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(ee,le,Ne){v.URI.isUri(ee)&&ee.scheme===A.Schemas.vscodeRemote&&!ee.authority&&Pt.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await(v.URI.isUri(ee)?Promise.resolve(ji.openTextDocument(ee)):Promise.resolve(ee));return be.showTextDocument(ot,le,Ne)},createTextEditorDecorationType(ee){return be.createTextEditorDecorationType(Fe,ee)},onDidChangeActiveTextEditor(ee,le,Ne){return st(be.onDidChangeActiveTextEditor)(ee,le,Ne)},onDidChangeVisibleTextEditors(ee,le,Ne){return st(be.onDidChangeVisibleTextEditors)(ee,le,Ne)},onDidChangeTextEditorSelection(ee,le,Ne){return st(be.onDidChangeTextEditorSelection)(ee,le,Ne)},onDidChangeTextEditorOptions(ee,le,Ne){return st(be.onDidChangeTextEditorOptions)(ee,le,Ne)},onDidChangeTextEditorVisibleRanges(ee,le,Ne){return st(be.onDidChangeTextEditorVisibleRanges)(ee,le,Ne)},onDidChangeTextEditorViewColumn(ee,le,Ne){return st(be.onDidChangeTextEditorViewColumn)(ee,le,Ne)},onDidCloseTerminal(ee,le,Ne){return st(vt.onDidCloseTerminal)(ee,le,Ne)},onDidOpenTerminal(ee,le,Ne){return st(vt.onDidOpenTerminal)(ee,le,Ne)},onDidChangeActiveTerminal(ee,le,Ne){return st(vt.onDidChangeActiveTerminal)(ee,le,Ne)},onDidChangeTerminalDimensions(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"terminalDimensions"),st(vt.onDidChangeTerminalDimensions)(ee,le,Ne)},onDidChangeTerminalState(ee,le,Ne){return st(vt.onDidChangeTerminalState)(ee,le,Ne)},onDidWriteTerminalData(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"terminalDataWriteEvent"),st(vt.onDidWriteTerminalData)(ee,le,Ne)},onDidExecuteTerminalCommand(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"terminalExecuteCommandEvent"),st(vt.onDidExecuteTerminalCommand)(ee,le,Ne)},onDidChangeTerminalShellIntegration(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),st(Vt.onDidChangeTerminalShellIntegration)(ee,le,Ne)},onDidStartTerminalShellExecution(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),st(Vt.onDidStartTerminalShellExecution)(ee,le,Ne)},onDidEndTerminalShellExecution(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),st(Vt.onDidEndTerminalShellExecution)(ee,le,Ne)},get state(){return Nt.getState()},onDidChangeWindowState(ee,le,Ne){return st(Nt.onDidChangeWindowState)(ee,le,Ne)},showInformationMessage(ee,...le){return Hi.showMessage(Fe,R.default.Info,ee,le[0],le.slice(1))},showWarningMessage(ee,...le){return Hi.showMessage(Fe,R.default.Warning,ee,le[0],le.slice(1))},showErrorMessage(ee,...le){return Hi.showMessage(Fe,R.default.Error,ee,le[0],le.slice(1))},showQuickPick(ee,le,Ne){return ct.showQuickPick(Fe,ee,le,Ne)},showWorkspaceFolderPick(ee){return ct.showWorkspaceFolderPick(ee)},showInputBox(ee,le){return ct.showInput(ee,le)},showOpenDialog(ee){return Oi.showOpenDialog(Fe,ee)},showSaveDialog(ee){return Oi.showSaveDialog(ee)},createStatusBarItem(ee,le,Ne){let ot,yt,At;return typeof ee=="string"?(ot=ee,yt=le,At=Ne):(yt=ee,At=le),Zi.createStatusBarEntry(Fe,ot,yt,At)},setStatusBarMessage(ee,le){return Zi.setStatusBarMessage(ee,le)},withScmProgress(ee){return Pt.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),jt.withProgress(Fe,{location:j.ProgressLocation.SourceControl},(le,Ne)=>ee({report(ot){}}))},withProgress(ee,le){return jt.withProgress(Fe,ee,le)},createOutputChannel(ee,le){return pi.createOutputChannel(ee,le,Fe)},createWebviewPanel(ee,le,Ne,ot){return Ri.createWebviewPanel(Fe,ee,le,Ne,ot)},createWebviewTextEditorInset(ee,le,Ne,ot){return(0,Xe.checkProposedApiEnabled)(Fe,"editorInsets"),ce.createWebviewEditorInset(ee,le,Ne,ot,Fe)},createTerminal(ee,le,Ne){return typeof ee=="object"?"pty"in ee?vt.createExtensionTerminal(ee):vt.createTerminalFromOptions(ee):vt.createTerminal(ee,le,Ne)},registerTerminalLinkProvider(ee){return vt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,le){return vt.registerProfileProvider(Fe,ee,le)},registerTerminalQuickFixProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(ee,Fe.identifier.value,le)},registerTreeDataProvider(ee,le){return Re.registerTreeDataProvider(ee,le,Fe)},createTreeView(ee,le){return Re.createTreeView(ee,le,Fe)},registerWebviewPanelSerializer:(ee,le)=>Ri.registerWebviewPanelSerializer(Fe,ee,le),registerCustomEditorProvider:(ee,le,Ne={})=>Bi.registerCustomEditorProvider(Fe,ee,le,Ne),registerFileDecorationProvider(ee){return si.registerFileDecorationProvider(ee,Fe)},registerUriHandler(ee){return Di.registerUriHandler(Fe,ee)},createQuickPick(){return ct.createQuickPick(Fe)},createInputBox(){return ct.createInputBox(Fe)},get activeColorTheme(){return Ui.activeColorTheme},onDidChangeActiveColorTheme(ee,le,Ne){return st(Ui.onDidChangeActiveColorTheme)(ee,le,Ne)},registerWebviewViewProvider(ee,le,Ne){return zi.registerWebviewViewProvider(Fe,ee,le,Ne?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,le,Ne){return st(It.onDidChangeActiveNotebookEditor)(ee,le,Ne)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return st(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,le,Ne){return st(Si.onDidChangeNotebookEditorSelection)(ee,le,Ne)},onDidChangeNotebookEditorVisibleRanges(ee,le,Ne){return st(Si.onDidChangeNotebookEditorVisibleRanges)(ee,le,Ne)},showNotebookDocument(ee,le){return It.showNotebookDocument(ee,le)},registerExternalUriOpener(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"externalUriOpener"),Yi.registerExternalUriOpener(Fe.identifier,ee,le,Ne)},registerProfileContentHandler(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"profileContentHandlers"),Ji.registerProfileContentHandler(Fe,ee,le)},registerQuickDiffProvider(ee,le,Ne,ot){return(0,Xe.checkProposedApiEnabled)(Fe,"quickDiffProvider"),Yt.registerQuickDiffProvider(wt(ee),le,Ne,ot)},get tabGroups(){return $t.tabGroups},registerShareProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"shareProvider"),ii.registerShareProvider(wt(ee),le)}},ji={get rootPath(){return Pt.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Et.getPath()},set rootPath(ee){throw new k.ReadonlyError("rootPath")},getWorkspaceFolder(ee){return Et.getWorkspaceFolder(ee)},get workspaceFolders(){return Et.getWorkspaceFolders()},get name(){return Et.name},set name(ee){throw new k.ReadonlyError("name")},get workspaceFile(){return Et.workspaceFile},set workspaceFile(ee){throw new k.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(ee,le,...Ne)=>Et.updateWorkspaceFolders(Fe,ee,le||0,...Ne),onDidChangeWorkspaceFolders:function(ee,le,Ne){return st(Et.onDidChangeWorkspace)(ee,le,Ne)},asRelativePath:(ee,le)=>Et.getRelativePath(ee,le),findFiles:(ee,le,Ne,ot)=>Et.findFiles(ee,le,Ne,Fe.identifier,ot),findFiles2:(ee,le,Ne)=>((0,Xe.checkProposedApiEnabled)(Fe,"findFiles2"),Et.findFiles2(ee,le,Fe.identifier,Ne)),findTextInFiles:(ee,le,Ne,ot)=>{(0,Xe.checkProposedApiEnabled)(Fe,"findTextInFiles");let yt,At;return typeof le=="object"?(yt=le,At=Ne):(yt={},At=le,ot=Ne),Et.findTextInFiles(ee,yt||{},At,Fe.identifier,ot)},save:ee=>Et.save(ee),saveAs:ee=>Et.saveAs(ee),saveAll:ee=>Et.saveAll(ee),applyEdit(ee,le){return pn.applyWorkspaceEdit(ee,Fe,le)},createFileSystemWatcher:(ee,le,Ne,ot)=>{let yt;return typeof le=="boolean"?yt={ignoreCreateEvents:!!le,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!ot,correlate:!1}:le&&((0,Xe.checkProposedApiEnabled)(Fe,"createFileSystemWatcher"),yt={...le,correlate:!0}),Ve.createFileSystemWatcher(Et,Fe,ee,yt)},get textDocuments(){return kt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new k.ReadonlyError("textDocuments")},openTextDocument(ee){let le;const Ne=ee;if(typeof ee=="string")le=Promise.resolve(v.URI.file(ee));else if(v.URI.isUri(ee))le=Promise.resolve(ee);else if(!Ne||typeof Ne=="object")le=kt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ot=>(ot.scheme===A.Schemas.vscodeRemote&&!ot.authority&&Pt.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),kt.ensureDocumentData(ot).then(yt=>yt.document)))},onDidOpenTextDocument:(ee,le,Ne)=>st(kt.onDidAddDocument)(ee,le,Ne),onDidCloseTextDocument:(ee,le,Ne)=>st(kt.onDidRemoveDocument)(ee,le,Ne),onDidChangeTextDocument:(ee,le,Ne)=>st(kt.onDidChangeDocument)(ee,le,Ne),onDidSaveTextDocument:(ee,le,Ne)=>st(kt.onDidSaveDocument)(ee,le,Ne),onWillSaveTextDocument:(ee,le,Ne)=>st(ai.getOnWillSaveTextDocumentEvent(Fe))(ee,le,Ne),get notebookDocuments(){return It.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,le){let Ne;if(v.URI.isUri(ee))Ne=ee,await It.openNotebookDocument(ee);else if(typeof ee=="string")Ne=v.URI.revive(await It.createNotebookDocument({viewType:ee,content:le}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ee,le,Ne){return st(Ii.onDidSaveNotebookDocument)(ee,le,Ne)},onDidChangeNotebookDocument(ee,le,Ne){return st(Ii.onDidChangeNotebookDocument)(ee,le,Ne)},onWillSaveNotebookDocument(ee,le,Ne){return st(fi.getOnWillSaveNotebookDocumentEvent(Fe))(ee,le,Ne)},get onDidOpenNotebookDocument(){return st(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return st(It.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,le,Ne,ot){return It.registerNotebookSerializer(Fe,ee,le,Ne,(0,Xe.isProposedApiEnabled)(Fe,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ee,le,Ne)=>st(qi.onDidChangeConfiguration)(ee,le,Ne),getConfiguration(ee,le){return le=arguments.length===1?void 0:le,qi.getConfiguration(ee,le,Fe)},registerTextDocumentContentProvider(ee,le){return Pi.registerTextDocumentContentProvider(ee,le)},registerTaskProvider:(ee,le)=>(Pt.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(Fe,ee,le)),registerFileSystemProvider(ee,le,Ne){return(0,O.combinedDisposable)(Qe.registerFileSystemProvider(Fe,ee,le,Ne),Xt.addFileSystemProvider(ee,le,Ne))},get fs(){return Xt.value},registerFileSearchProvider:(ee,le)=>((0,Xe.checkProposedApiEnabled)(Fe,"fileSearchProvider"),oi.registerFileSearchProvider(ee,le)),registerTextSearchProvider:(ee,le)=>((0,Xe.checkProposedApiEnabled)(Fe,"textSearchProvider"),oi.registerTextSearchProvider(ee,le)),registerAITextSearchProvider:(ee,le)=>((0,Xe.checkProposedApiEnabled)(Fe,"aiTextSearchProvider"),(0,Xe.checkProposedApiEnabled)(Fe,"textSearchProvider"),oi.registerAITextSearchProvider(ee,le)),registerRemoteAuthorityResolver:(ee,le)=>((0,Xe.checkProposedApiEnabled)(Fe,"resolvers"),Bt.registerRemoteAuthorityResolver(ee,le)),registerResourceLabelFormatter:ee=>((0,Xe.checkProposedApiEnabled)(Fe,"resolvers"),Fi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Xe.checkProposedApiEnabled)(Fe,"resolvers"),Bt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,le,Ne)=>st(Ve.onDidCreateFile)(ee,le,Ne),onDidDeleteFiles:(ee,le,Ne)=>st(Ve.onDidDeleteFile)(ee,le,Ne),onDidRenameFiles:(ee,le,Ne)=>st(Ve.onDidRenameFile)(ee,le,Ne),onWillCreateFiles:(ee,le,Ne)=>st(Ve.getOnWillCreateFileEvent(Fe))(ee,le,Ne),onWillDeleteFiles:(ee,le,Ne)=>st(Ve.getOnWillDeleteFileEvent(Fe))(ee,le,Ne),onWillRenameFiles:(ee,le,Ne)=>st(Ve.getOnWillRenameFileEvent(Fe))(ee,le,Ne),openTunnel:ee=>((0,Xe.checkProposedApiEnabled)(Fe,"tunnels"),Lt.openTunnel(Fe,ee).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,Xe.checkProposedApiEnabled)(Fe,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(ee,le,Ne)=>((0,Xe.checkProposedApiEnabled)(Fe,"tunnels"),st(Lt.onDidChangeTunnels)(ee,le,Ne)),registerPortAttributesProvider:(ee,le)=>((0,Xe.checkProposedApiEnabled)(Fe,"portsAttributes"),Lt.registerPortsAttributesProvider(ee,le)),registerTunnelProvider:(ee,le)=>((0,Xe.checkProposedApiEnabled)(Fe,"tunnelFactory"),Lt.registerTunnelProvider(ee,le)),registerTimelineProvider:(ee,le)=>((0,Xe.checkProposedApiEnabled)(Fe,"timeline"),Qi.registerTimelineProvider(ee,le,Fe.identifier,St.converter)),get isTrusted(){return Et.trusted},requestWorkspaceTrust:ee=>((0,Xe.checkProposedApiEnabled)(Fe,"workspaceTrust"),Et.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,le,Ne)=>st(Et.onDidGrantWorkspaceTrust)(ee,le,Ne),registerEditSessionIdentityProvider:(ee,le)=>((0,Xe.checkProposedApiEnabled)(Fe,"editSessionIdentityProvider"),Et.registerEditSessionIdentityProvider(ee,le)),onWillCreateEditSessionIdentity:(ee,le,Ne)=>((0,Xe.checkProposedApiEnabled)(Fe,"editSessionIdentityProvider"),st(Et.getOnWillCreateEditSessionIdentityEvent(Fe))(ee,le,Ne)),registerCanonicalUriProvider:(ee,le)=>((0,Xe.checkProposedApiEnabled)(Fe,"canonicalUriProvider"),Et.registerCanonicalUriProvider(ee,le)),getCanonicalUri:(ee,le,Ne)=>((0,Xe.checkProposedApiEnabled)(Fe,"canonicalUriProvider"),Et.provideCanonicalUri(ee,le,Ne))},sn={get inputBox(){return Pt.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Dt.getLastInputBox(Fe)},createSourceControl(ee,le,Ne){return Dt.createSourceControl(Fe,ee,le,Ne)}},En={createCommentController(ee,le){return Mt.createCommentController(Fe,ee,le)}},on={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get activeStackItem(){return Ct.activeStackItem},registerDebugVisualizationProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"debugVisualization"),Ct.registerDebugVisualizationProvider(Fe,ee,le)},registerDebugVisualizationTreeProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"debugVisualization"),Ct.registerDebugVisualizationTree(Fe,ee,le)},onDidStartDebugSession(ee,le,Ne){return st(Ct.onDidStartDebugSession)(ee,le,Ne)},onDidTerminateDebugSession(ee,le,Ne){return st(Ct.onDidTerminateDebugSession)(ee,le,Ne)},onDidChangeActiveDebugSession(ee,le,Ne){return st(Ct.onDidChangeActiveDebugSession)(ee,le,Ne)},onDidReceiveDebugSessionCustomEvent(ee,le,Ne){return st(Ct.onDidReceiveDebugSessionCustomEvent)(ee,le,Ne)},onDidChangeBreakpoints(ee,le,Ne){return st(Ct.onDidChangeBreakpoints)(ee,le,Ne)},onDidChangeActiveStackItem(ee,le,Ne){return st(Ct.onDidChangeActiveStackItem)(ee,le,Ne)},registerDebugConfigurationProvider(ee,le,Ne){return Ct.registerDebugConfigurationProvider(ee,le,Ne||ui.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,le){return Ct.registerDebugAdapterDescriptorFactory(Fe,ee,le)},registerDebugAdapterTrackerFactory(ee,le){return Ct.registerDebugAdapterTrackerFactory(ee,le)},startDebugging(ee,le,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?Ct.startDebugging(ee,le,{parentSession:Ne}):Ct.startDebugging(ee,le,Ne||{})},stopDebugging(ee){return Ct.stopDebugging(ee)},addBreakpoints(ee){return Ct.addBreakpoints(ee)},removeBreakpoints(ee){return Ct.removeBreakpoints(ee)},asDebugSourceUri(ee,le){return Ct.asDebugSourceUri(ee,le)}},an={registerTaskProvider:(ee,le)=>qt.registerTaskProvider(Fe,ee,le),fetchTasks:ee=>qt.fetchTasks(ee),executeTask:ee=>qt.executeTask(Fe,ee),get taskExecutions(){return qt.taskExecutions},onDidStartTask:(ee,le,Ne)=>st(qt.onDidStartTask)(ee,le,Ne),onDidEndTask:(ee,le,Ne)=>st(qt.onDidEndTask)(ee,le,Ne),onDidStartTaskProcess:(ee,le,Ne)=>st(qt.onDidStartTaskProcess)(ee,le,Ne),onDidEndTaskProcess:(ee,le,Ne)=>st(qt.onDidEndTaskProcess)(ee,le,Ne)},bn={createNotebookController(ee,le,Ne,ot,yt){return vi.createNotebookController(Fe,ee,le,Ne,ot,(0,Xe.isProposedApiEnabled)(Fe,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,le)=>It.registerNotebookCellStatusBarItemProvider(Fe,ee,le),createRendererMessaging(ee){return ki.createRendererMessaging(Fe,ee)},createNotebookControllerDetectionTask(ee){return(0,Xe.checkProposedApiEnabled)(Fe,"notebookKernelSource"),vi.createNotebookControllerDetectionTask(Fe,ee)},registerKernelSourceActionProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"notebookKernelSource"),vi.registerKernelSourceActionProvider(Fe,ee,le)},onDidChangeNotebookCellExecutionState(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"notebookCellExecutionState"),st(vi.onDidChangeNotebookCellExecutionState)(ee,le,Ne)}},Sn={t(...ee){if(typeof ee[0]=="string"){const le=ee.shift(),Ne=!ee||typeof ee[0]!="object"?ee:ee[0];return hi.getMessage(Fe.identifier.value,{message:le,args:Ne})}return hi.getMessage(Fe.identifier.value,ee[0])},get bundle(){return hi.getBundle(Fe.identifier.value)},get uri(){return hi.getBundleUri(Fe.identifier.value)}},ln={_version:1,transferActiveChat(ee){return(0,Xe.checkProposedApiEnabled)(Fe,"interactive"),Li.transferActiveChat(ee)}},Ki={getRelatedInformation(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),$i.getRelatedInformation(Fe,ee,le)},registerRelatedInformationProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),$i.registerRelatedInformationProvider(Fe,ee,le)},registerEmbeddingVectorProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),gn.registerEmbeddingVectorProvider(Fe,ee,le)}},cn={_version:1,registerChatResponseProvider(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"chatProvider"),Qt.registerLanguageModel(Fe,ee,le,Ne)},registerChatVariableResolver(ee,le,Ne,ot,yt,At,Ci,Mi){return(0,Xe.checkProposedApiEnabled)(Fe,"chatVariableResolver"),Wi.registerVariableResolver(Fe,ee,le,Ne,ot,yt,At,Ci,Mi?.id)},registerMappedEditsProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"mappedEditsProvider"),Ue.registerMappedEditsProvider(Fe,ee,le)},createChatParticipant(ee,le){return Li.createChatAgent(Fe,ee,le)},createDynamicChatParticipant(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"chatParticipantPrivate"),Li.createDynamicChatAgent(Fe,ee,le,Ne)},attachContext(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"chatVariableResolver"),Wi.attachContext(ee,le,Ne)}},un={selectChatModels:ee=>pt.quality==="stable"?(console.warn(`[${C.ExtensionIdentifier.toKey(Fe.identifier)}] This API is disabled in '${pt.environment.appName}'-stable.`),Promise.resolve([])):Qt.selectLanguageModels(Fe,ee??{}),onDidChangeChatModels:(ee,le,Ne)=>pt.quality==="stable"?(console.warn(`[${C.ExtensionIdentifier.toKey(Fe.identifier)}] This API is disabled in '${pt.environment.appName}'-stable.`),P.Event.None(ee,le,Ne)):Qt.onDidChangeProviders(ee,le,Ne),get embeddingModels(){return(0,Xe.checkProposedApiEnabled)(Fe,"embeddings"),yi.embeddingsModels},onDidChangeEmbeddingModels:(ee,le,Ne)=>((0,Xe.checkProposedApiEnabled)(Fe,"embeddings"),yi.onDidChange(ee,le,Ne)),registerEmbeddingsProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"embeddings"),yi.registerEmbeddingsProvider(Fe,ee,le)},async computeEmbeddings(ee,le,Ne){return(0,Xe.checkProposedApiEnabled)(Fe,"embeddings"),yi.computeEmbeddings(ee,le,Ne)}},dn={registerSpeechProvider(ee,le){return(0,Xe.checkProposedApiEnabled)(Fe,"speech"),Vi.registerProvider(Fe.identifier,ee,le)}};return{version:pt.version,ai:Ki,authentication:tn,commands:Ei,comments:En,chat:cn,debug:on,env:Ai,extensions:Ni,interactive:ln,l10n:Sn,languages:nn,lm:un,notebooks:bn,scm:sn,speech:dn,tasks:an,tests:vn,window:rn,workspace:ji,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,ChatResultFeedbackKind:j.ChatResultFeedbackKind,ChatVariableLevel:j.ChatVariableLevel,ChatCompletionItem:j.ChatCompletionItem,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:k.CancellationError,CancellationTokenSource:y.CancellationTokenSource,CandidatePortSource:t.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentState:j.CommentState,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CommentThreadApplicability:j.CommentThreadApplicability,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:ui.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DebugVisualization:j.DebugVisualization,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,MultiDocumentHighlight:j.MultiDocumentHighlight,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:P.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:h.FileType,FilePermission:h.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,VerboseHover:j.VerboseHover,HoverVerbosityAction:j.HoverVerbosityAction,IndentAction:b.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:c.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixTerminalCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:j.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,SyntaxTokenType:j.SyntaxTokenType,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:Jt.UIKind,Uri:v.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentPasteTriggerKind:j.DocumentPasteTriggerKind,DocumentDropEdit:j.DocumentDropEdit,DocumentDropOrPasteEditKind:j.DocumentDropOrPasteEditKind,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,ManagedResolvedAuthority:j.ManagedResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,NotebookVariablesRequestKind:j.NotebookVariablesRequestKind,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:Wt.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,TestCoverageCount:j.TestCoverageCount,FileCoverage:j.FileCoverage,FileCoverage2:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,DeclarationCoverage:j.DeclarationCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TabInputChat:j.ChatEditorTabInput,TabInputTextMultiDiff:j.TextMultiDiffTabInput,TelemetryTrustedValue:a.TelemetryTrustedValue,LogLevel:r.LogLevel,EditSessionIdentityMatch:d.EditSessionIdentityMatch,InteractiveSessionVoteDirection:j.InteractiveSessionVoteDirection,ChatCopyKind:j.ChatCopyKind,InteractiveEditorResponseFeedbackKind:j.InteractiveEditorResponseFeedbackKind,DebugStackFrame:j.DebugStackFrame,DebugThread:j.DebugThread,RelatedInformationType:j.RelatedInformationType,SpeechToTextStatus:j.SpeechToTextStatus,TextToSpeechStatus:j.TextToSpeechStatus,PartialAcceptTriggerKind:j.PartialAcceptTriggerKind,KeywordRecognitionStatus:j.KeywordRecognitionStatus,ChatResponseMarkdownPart:j.ChatResponseMarkdownPart,ChatResponseFileTreePart:j.ChatResponseFileTreePart,ChatResponseAnchorPart:j.ChatResponseAnchorPart,ChatResponseProgressPart:j.ChatResponseProgressPart,ChatResponseProgressPart2:j.ChatResponseProgressPart2,ChatResponseReferencePart:j.ChatResponseReferencePart,ChatResponseWarningPart:j.ChatResponseWarningPart,ChatResponseTextEditPart:j.ChatResponseTextEditPart,ChatResponseMarkdownWithVulnerabilitiesPart:j.ChatResponseMarkdownWithVulnerabilitiesPart,ChatResponseCommandButtonPart:j.ChatResponseCommandButtonPart,ChatResponseDetectedParticipantPart:j.ChatResponseDetectedParticipantPart,ChatResponseConfirmationPart:j.ChatResponseConfirmationPart,ChatRequestTurn:j.ChatRequestTurn,ChatResponseTurn:j.ChatResponseTurn,ChatLocation:j.ChatLocation,LanguageModelChatMessageRole:j.LanguageModelChatMessageRole,LanguageModelChatMessage:j.LanguageModelChatMessage,LanguageModelChatMessage2:j.LanguageModelChatMessage,LanguageModelChatSystemMessage:j.LanguageModelChatSystemMessage,LanguageModelChatUserMessage:j.LanguageModelChatUserMessage,LanguageModelChatAssistantMessage:j.LanguageModelChatAssistantMessage,LanguageModelError:j.LanguageModelError,NewSymbolName:j.NewSymbolName,NewSymbolNameTag:j.NewSymbolNameTag,NewSymbolNameTriggerKind:j.NewSymbolNameTriggerKind,InlineEdit:j.InlineEdit,InlineEditTriggerKind:j.InlineEditTriggerKind}}}}),define(De[318],Ie([1,0,60,126,44,120,45,39,71,57,129,131,132,89,93,85,119,68,51,88,66,70,257,12,130,86,87,91,95,124]),function(he,e,y,k,P,O,A,R,v,l,T,b,c,C,h,r,o,a,d,t,s,n,i,g,f,u,E,I,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.registerSingleton)(u.IExtHostLocalizationService,u.ExtHostLocalizationService,y.InstantiationType.Delayed),(0,y.registerSingleton)(g.ILoggerService,i.ExtHostLoggerService,y.InstantiationType.Delayed),(0,y.registerSingleton)(r.IExtHostApiDeprecationService,r.ExtHostApiDeprecationService,y.InstantiationType.Delayed),(0,y.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,y.InstantiationType.Eager),(0,y.registerSingleton)(I.IExtHostAuthentication,I.ExtHostAuthentication,y.InstantiationType.Eager),(0,y.registerSingleton)(_.IExtHostLanguageModels,_.ExtHostLanguageModels,y.InstantiationType.Eager),(0,y.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,y.InstantiationType.Eager),(0,y.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem,y.InstantiationType.Eager),(0,y.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService,y.InstantiationType.Eager),(0,y.registerSingleton)(O.IExtHostDecorations,O.ExtHostDecorations,y.InstantiationType.Eager),(0,y.registerSingleton)(v.IExtHostDocumentsAndEditors,v.ExtHostDocumentsAndEditors,y.InstantiationType.Eager),(0,y.registerSingleton)(E.IExtHostManagedSockets,E.ExtHostManagedSockets,y.InstantiationType.Eager),(0,y.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo,y.InstantiationType.Eager),(0,y.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService,y.InstantiationType.Delayed),(0,y.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch,y.InstantiationType.Eager),(0,y.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,y.InstantiationType.Eager),(0,y.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask,y.InstantiationType.Eager),(0,y.registerSingleton)(l.IExtHostTerminalService,l.WorkerExtHostTerminalService,y.InstantiationType.Eager),(0,y.registerSingleton)(w.IExtHostTerminalShellIntegration,w.ExtHostTerminalShellIntegration,y.InstantiationType.Eager),(0,y.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService,y.InstantiationType.Eager),(0,y.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,y.InstantiationType.Eager),(0,y.registerSingleton)(P.IExtHostWorkspace,P.ExtHostWorkspace,y.InstantiationType.Eager),(0,y.registerSingleton)(t.IExtHostSecretState,t.ExtHostSecretState,y.InstantiationType.Eager),(0,y.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry,y.InstantiationType.Eager),(0,y.registerSingleton)(n.IExtHostEditorTabs,n.ExtHostEditorTabs,y.InstantiationType.Eager),(0,y.registerSingleton)(f.IExtHostVariableResolverProvider,f.ExtHostVariableResolverProviderService,y.InstantiationType.Eager)}),define(De[319],Ie([1,0,317,46,2,314,7,11,264]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends O.RequireInterceptor{_installInterceptor(){}getModule(C,h){for(const r of this._alternatives){const o=r(C);if(o){C=o;break}}if(this._factories.has(C))return this._factories.get(C).load(C,h,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(v.ExtHostConsoleForwarder);const C=this._instaService.invokeFunction(y.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(l,C,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(C){return C.browser}async _loadCommonJSModule(C,h,r){h=h.with({path:b(h.path,".js")});const o=C?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const a=P.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(h)),d=await fetch(a.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),d.status!==200)throw new Error(d.statusText);const t=await d.text(),s=`${h.toString(!0)}#vscode-extension`,n=`${t}
//# sourceURL=${s}`;let i;try{i=new Function("module","exports","require",n)}catch(E){throw console.error(o?`Loading code for extension ${o} failed: ${E.message}`:`Loading code failed: ${E.message}`),console.error(`${h.toString(!0)}${typeof E.line=="number"?` line ${E.line}`:""}${typeof E.column=="number"?` column ${E.column}`:""}`),console.error(E),E}C&&await this._extHostLocalizationService.initializeLocalizedMessages(C);const g={},f={exports:g},u=E=>{const I=this._fakeModules.getModule(E,h);if(I===void 0)throw new Error(`Cannot load module '${E}'`);return I};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(f,g,u),f.exports!==g?f.exports:g}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(C){}async _waitForDebuggerAttachment(C=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const h=Date.now()+C;for(;Date.now()<h&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=T;function b(c,C){return c.endsWith(C)?c:c+C}}),define(De[320],Ie([1,0,74,60,12,46,227,92,319]),function(he,e,y,k,P,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,k.registerSingleton)(P.ILogService,new y.SyncDescriptor(A.ExtHostLogService,[!0],!0)),(0,k.registerSingleton)(O.IExtHostExtensionService,v.ExtHostExtensionService,k.InstantiationType.Eager),(0,k.registerSingleton)(R.IExtensionStoragePaths,R.ExtensionStoragePaths,k.InstantiationType.Eager)}),define(De[328],Ie([1,0,23,4,84,315,266,20,64,16,2,318,320]),function(he,e,y,k,P,O,A,R,v,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=n;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function C(i){return/^(file|vscode-remote):/i.test(i)}const h=fetch.bind(self);function r(i){self.fetch=async function(g,f){return g instanceof Request||C(String(g))&&(g=(await i(T.URI.parse(String(g)))).toString(!0)),h(g,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(g,f,u,E,I){(async()=>(C(f.toString())&&(f=(await i(T.URI.parse(f.toString()))).toString(!0)),super.open(g,f,u??!0,E,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(g,f){if(/^file:/i.test(g.toString()))g=l.FileAccess.uriToBrowserUri(T.URI.parse(g.toString())).toString(!0);else if(/^vscode-remote:/i.test(g.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const E=`(${function(p){function D(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const m=fetch.bind(self);self.fetch=function(M,L){return M instanceof Request?m(M,L):m(D(M),L)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,L,H,V,$){return super.open(M,D(L),H??!0,V,$)}};const S=importScripts.bind(self);self.importScripts=(...M)=>{S(...M.map(D))},S(p)}.toString()}('${g}'))`;f=f||{},f.name=`${name} -> ${f.name||R.basename(g.toString())}`;const I=new Blob([E],{type:"application/javascript"}),_=URL.createObjectURL(I);return new i(_,f)}}else self.Worker=class extends A.NestedWorker{constructor(i,g){super(c,i,{name:R.basename(i.toString()),...g})}};const o=new class{constructor(){this.pid=void 0}exit(i){b()}};class a{constructor(){const g=new MessageChannel,f=new k.Emitter;let u=!1;c(g.port2,[g.port2]),g.port1.onmessage=E=>{const{data:I}=E;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const _=y.VSBuffer.wrap(new Uint8Array(I,0,I.byteLength));if((0,P.isMessageOfType)(_,P.MessageType.Terminate)){u=!0,t("received terminate message from renderer");return}f.fire(_)},this.protocol={onMessage:f.event,send:E=>{if(!u){const I=E.buffer.buffer.slice(E.buffer.byteOffset,E.buffer.byteOffset+E.buffer.byteLength);g.port1.postMessage(I,[I])}}}}}function d(i){return new Promise(g=>{const f=i.onMessage(u=>{f.dispose();const E=JSON.parse(u.toString());i.send((0,P.createMessageOfType)(P.MessageType.Initialized)),g({protocol:i,initData:E})});i.send((0,P.createMessageOfType)(P.MessageType.Ready))})}let t=i=>b();function s(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function n(){v.mark("code/extHost/willConnectToRenderer");const i=new a;return{onmessage(g){s(g)&&d(i.protocol).then(f=>{v.mark("code/extHost/didWaitForInitData");const u=new O.ExtensionHostMain(f.protocol,f.initData,o,null,g.data);r(E=>u.asBrowserUri(E)),t=E=>u.terminate(E)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d98c6de73fb939f1eb4b8a500c569b858b2d297/core/vs/workbench/api/worker/extensionHostWorker.js.map
